import { ParserBase } from "@awayjs/core";
import { LoaderInfo } from "./LoaderInfo";
import { LoaderContext } from "../system/LoaderContext";
import { DisplayObjectContainer } from "./DisplayObjectContainer";
import { DisplayObject } from "./DisplayObject";
import { URLRequest } from "../net/URLRequest";
import { UncaughtErrorEvents } from '../events/UncaughtErrorEvents';
import { ByteArray } from '../../avm2/natives/byteArray';
export declare class Loader extends DisplayObjectContainer {
    private _factory;
    private _loader;
    private _isImage;
    private _parser;
    private _uncaughtErrorEvents;
    private _loaderContext;
    _content: DisplayObject;
    get content(): DisplayObject;
    get uncaughtErrorEvents(): UncaughtErrorEvents;
    constructor(parser: ParserBase);
    private _onLoaderProgressDelegate;
    private onLoaderProgress;
    private _onLoaderCompleteDelegate;
    private onLoaderComplete;
    private _onAssetCompleteDelegate;
    private onAssetComplete;
    addChild(child: DisplayObject): DisplayObject;
    addChildAt(child: DisplayObject, index: number): DisplayObject;
    removeChild(child: DisplayObject): DisplayObject;
    removeChildAt(index: number): DisplayObject;
    setChildIndex(child: DisplayObject, index: number): void;
    load(url: URLRequest, context?: LoaderContext): void;
    loadData(buffer: Uint8Array, context?: LoaderContext): void;
    loadBytes(data: ByteArray, context?: LoaderContext): void;
    close(): void;
    _unload(stopExecution: boolean, gc: boolean): void;
    unload(): void;
    unloadAndStop(gc: boolean): void;
    get contentLoaderInfo(): LoaderInfo;
    set contentLoaderInfo(value: LoaderInfo);
}
