import { ASObject } from "../../avm2/nat/ASObject";
import { MapObject } from "../../base/utilities";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class Event extends ASObject {
    static axClass: typeof Event;
    static _instances: MapObject<Event>;
    static classInitializer: any;
    static getInstance(type: string, bubbles?: boolean, cancelable?: boolean): Event;
    static getBroadcastInstance(type: string, bubbles?: boolean, cancelable?: boolean): Event;
    /**
     * http://stackoverflow.com/questions/16900176/as3enterframe-event-propagation-understanding-issue
     */
    static isBroadcastEventType(type: string): boolean;
    constructor(type: string, bubbles?: boolean, cancelable?: boolean);
    static ACTIVATE: string;
    static ADDED: string;
    static ADDED_TO_STAGE: string;
    static CANCEL: string;
    static CHANGE: string;
    static CLEAR: string;
    static CLOSE: string;
    static COMPLETE: string;
    static CONNECT: string;
    static COPY: string;
    static CUT: string;
    static DEACTIVATE: string;
    static ENTER_FRAME: string;
    static FRAME_CONSTRUCTED: string;
    static EXIT_FRAME: string;
    static FRAME_LABEL: string;
    static ID3: string;
    static INIT: string;
    static MOUSE_LEAVE: string;
    static OPEN: string;
    static PASTE: string;
    static REMOVED: string;
    static REMOVED_FROM_STAGE: string;
    static RENDER: string;
    static RESIZE: string;
    static SCROLL: string;
    static TEXT_INTERACTION_MODE_CHANGE: string;
    static SELECT: string;
    static SELECT_ALL: string;
    static SOUND_COMPLETE: string;
    static TAB_CHILDREN_CHANGE: string;
    static TAB_ENABLED_CHANGE: string;
    static TAB_INDEX_CHANGE: string;
    static UNLOAD: string;
    static FULLSCREEN: string;
    static CONTEXT3D_CREATE: string;
    static TEXTURE_READY: string;
    static VIDEO_FRAME: string;
    static SUSPEND: string;
    static AVM1_INIT: string;
    static AVM1_CONSTRUCT: string;
    static AVM1_LOAD: string;
    _type: string;
    _bubbles: boolean;
    _cancelable: boolean;
    _target: Object;
    _currentTarget: Object;
    _eventPhase: number;
    _stopPropagation: boolean;
    _stopImmediatePropagation: boolean;
    _isDefaultPrevented: boolean;
    /**
     * Some events don't participate in the normal capturing and bubbling phase.
     */
    private _isBroadcastEvent;
    get type(): string;
    get bubbles(): boolean;
    get cancelable(): boolean;
    get target(): Object;
    set target(value: Object);
    get currentTarget(): Object;
    set currentTarget(value: Object);
    get eventPhase(): number;
    stopPropagation(): void;
    stopImmediatePropagation(): void;
    preventDefault(): void;
    isDefaultPrevented(): boolean;
    isBroadcastEvent(): boolean;
    clone(): Event;
    toString(): string;
    formatToString(className: string, ...args: string[]): string;
}
