import { ASObject } from "../../avm2/nat/ASObject";
import { ColorTransform as AwayColorTransform } from '@awayjs/core';
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class ColorTransform extends ASObject {
    private _adaptee;
    static axClass: typeof ColorTransform;
    static classInitializer(): void;
    static classSymbols: string[];
    static instanceSymbols: string[];
    get adaptee(): AwayColorTransform;
    constructor(redMultiplierAdaptee?: number | AwayColorTransform, greenMultiplier?: number, blueMultiplier?: number, alphaMultiplier?: number, redOffset?: number, greenOffset?: number, blueOffset?: number, alphaOffset?: number);
    static FROZEN_IDENTITY_COLOR_TRANSFORM: ColorTransform;
    static TEMP_COLOR_TRANSFORM: ColorTransform;
    /**
     * A decimal value that is multiplied with the alpha transparency channel
     * value.
     *
     * <p>If you set the alpha transparency value of a display object directly by
     * using the <code>alpha</code> property of the DisplayObject instance, it
     * affects the value of the <code>alphaMultiplier</code> property of that
     * display object's <code>transform.colorTransform</code> property.</p>
     */
    get alphaMultiplier(): number;
    set alphaMultiplier(value: number);
    /**
     * A number from -255 to 255 that is added to the alpha transparency channel
     * value after it has been multiplied by the <code>alphaMultiplier</code>
     * value.
     */
    get alphaOffset(): number;
    set alphaOffset(value: number);
    /**
     * A decimal value that is multiplied with the blue channel value.
     */
    get blueMultiplier(): number;
    set blueMultiplier(value: number);
    /**
     * A number from -255 to 255 that is added to the blue channel value after it
     * has been multiplied by the <code>blueMultiplier</code> value.
     */
    get blueOffset(): number;
    set blueOffset(value: number);
    /**
     * A decimal value that is multiplied with the green channel value.
     */
    get greenMultiplier(): number;
    set greenMultiplier(value: number);
    /**
     * A number from -255 to 255 that is added to the green channel value after
     * it has been multiplied by the <code>greenMultiplier</code> value.
     */
    get greenOffset(): number;
    set greenOffset(value: number);
    /**
     * A decimal value that is multiplied with the red channel value.
     */
    get redMultiplier(): number;
    set redMultiplier(value: number);
    /**
     * A number from -255 to 255 that is added to the red channel value after it
     * has been multiplied by the <code>redMultiplier</code> value.
     */
    get redOffset(): number;
    set redOffset(value: number);
    get color(): number;
    set color(value: number);
    concat(second: ColorTransform): void;
    preMultiply(second: ColorTransform): void;
    copyFrom(sourceColorTransform: ColorTransform): void;
    setTo(redMultiplier: number, greenMultiplier: number, blueMultiplier: number, alphaMultiplier: number, redOffset: number, greenOffset: number, blueOffset: number, alphaOffset: number): void;
    clone(): ColorTransform;
    convertToFixedPoint(): ColorTransform;
    dispose(): void;
    equals(other: ColorTransform): boolean;
    toString(): string;
}
