import { Float64Vector } from "../../avm2/natives/float64Vector";
import { Vector3D } from "./Vector3D";
import { Matrix3D } from "./Matrix3D";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class Utils3D extends ASObject {
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    constructor();
    static projectVector(m: Matrix3D, v: Vector3D): Vector3D;
    static projectVectors(m: Matrix3D, verts: Float64Vector, projectedVerts: Float64Vector, uvts: Float64Vector): void;
    static pointTowards(percent: number, mat: Matrix3D, pos: Vector3D, at?: Vector3D, up?: Vector3D): Matrix3D;
}
