import { __extends } from "tslib";
import { release, notImplemented } from "../../base/utilities/Debug";
import { Matrix3D } from "./Matrix3D";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: Utils3D
var Utils3D = /** @class */ (function (_super) {
    __extends(Utils3D, _super);
    function Utils3D() {
        return _super.call(this) || this;
    }
    // AS -> JS Bindings
    Utils3D.projectVector = function (m, v) {
        Matrix3D;
        m = m;
        v = v;
        release || notImplemented("public flash.geom.Utils3D::static projectVector");
        return;
    };
    Utils3D.projectVectors = function (m, verts, projectedVerts, uvts) {
        m = m;
        verts = verts;
        projectedVerts = projectedVerts;
        uvts = uvts;
        release || notImplemented("public flash.geom.Utils3D::static projectVectors");
        return;
    };
    Utils3D.pointTowards = function (percent, mat, pos, at, up) {
        if (at === void 0) { at = null; }
        if (up === void 0) { up = null; }
        percent = +percent;
        mat = mat;
        pos = pos;
        at = at;
        up = up;
        release || notImplemented("public flash.geom.Utils3D::static pointTowards");
        return;
    };
    // Called whenever the class is initialized.
    Utils3D.classInitializer = null;
    // List of static symbols to link.
    Utils3D.classSymbols = null; // [];
    // List of instance symbols to link.
    Utils3D.instanceSymbols = null; // [];
    return Utils3D;
}(ASObject));
export { Utils3D };
