import { TextFormat as AwaytextFormat } from "@awayjs/scene";
import { ASObject } from '../../avm2/nat/ASObject';
import { AXClass } from '../../avm2/run/AXClass';
import { ASArray } from '../../avm2/nat/ASArray';
export declare class TextFormat extends ASObject {
    static axClass: typeof TextFormat & AXClass;
    adaptee: AwaytextFormat;
    get target(): string;
    set target(value: string);
    get tabStops(): ASArray;
    set tabStops(value: ASArray);
    get display(): string;
    set display(value: string);
    get bullet(): any;
    set bullet(value: any);
    get url(): string;
    set url(value: string);
    get align(): string;
    set align(value: string);
    get blockIndent(): number;
    set blockIndent(value: number);
    /**
     * The left margin of the paragraph, in pixels. The default value is
     * <code>null</code>, which indicates that the left margin is 0 pixels.
     */
    private _leftMargin;
    get leftMargin(): number;
    set leftMargin(value: number);
    get rightMargin(): number;
    set rightMargin(value: number);
    get indent(): number;
    set indent(value: number);
    get color(): number;
    set color(value: number);
    get kerning(): boolean;
    set kerning(value: boolean);
    get leading(): number;
    set leading(value: number);
    get letterSpacing(): number;
    set letterSpacing(value: number);
    get size(): number;
    set size(value: number);
    get bold(): boolean;
    set bold(value: boolean);
    get italic(): boolean;
    set italic(value: boolean);
    get underline(): boolean;
    set underline(value: boolean);
    get font_name(): string;
    set font_name(value: string);
    get style_name(): any;
    set style_name(value: any);
    get font(): any;
    set font(value: any);
    /**
     * Indicates the target window where the hyperlink is displayed. If the
     * target window is an empty string, the text is displayed in the default
     * target window <code>_self</code>. You can choose a custom name or one of
     * the following four names: <code>_self</code> specifies the current frame
     * in the current window, <code>_blank</code> specifies a new window,
     * <code>_parent</code> specifies the parent of the current frame, and
     * <code>_top</code> specifies the top-level frame in the current window. If
     * the <code>TextFormat.url</code> property is an empty string or
     * <code>null</code>, you can get or set this property, but the property will
     * have no effect.
     */
    link_target: string;
    constructor(font?: string, size?: number, color?: number, bold?: boolean, italic?: boolean, underline?: boolean, url?: string, link_target?: string, align?: string, leftMargin?: number, rightMargin?: number, indent?: number, leading?: number);
    clone(): TextFormat;
}
