import { Image2D } from "@awayjs/stage";
import { Timeline, MovieClip, Sprite, DisplayObjectContainer, Billboard, ISceneGraphFactory, TextField, PrefabBase, DefaultSceneGraphFactory } from "@awayjs/scene";
import { MaterialBase } from "@awayjs/materials";
import { AVM1Context } from "./context";
export interface FrameScript {
    (any?: any): any;
    precedence?: number[];
    context?: MovieClip;
}
export declare class AVM1SceneGraphFactory extends DefaultSceneGraphFactory implements ISceneGraphFactory {
    static _instance: AVM1SceneGraphFactory;
    static get instance(): AVM1SceneGraphFactory;
    imageStore: Object;
    avm1Context: AVM1Context;
    constructor(avm1Context: AVM1Context);
    createSprite(prefab?: PrefabBase): Sprite;
    createDisplayObjectContainer(): DisplayObjectContainer;
    createMovieClip(timeline?: Timeline, symbol?: any): MovieClip;
    createTextField(): TextField;
    createBillboard(material: MaterialBase): Billboard;
    createImage2D(width: number, height: number, transparent?: boolean, fillColor?: number, powerOfTwo?: boolean): Image2D;
}
