import { __extends } from "tslib";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { DisplayObject as AwayDisplayObject } from "@awayjs/scene";
//import {BitmapImage2D as BitmapData} from "@awayjs/stage"
import { XMLDocumentAway } from "./customAway/xml/XMLDocumentAway";
import { EventDispatcher } from '../as3webFlash/events/EventDispatcher';
import { DisplayObject } from '../as3webFlash/display/DisplayObject';
import { DisplayObjectContainer } from '../as3webFlash/display/DisplayObjectContainer';
import { Loader } from '../as3webFlash/display/Loader';
import { LoaderInfo } from '../as3webFlash/display/LoaderInfo';
import { MovieClip } from '../as3webFlash/display/MovieClip';
import { Graphics } from '../as3webFlash/display/Graphics';
import { Bitmap } from '../as3webFlash/display/Bitmap';
import { BitmapData } from '../as3webFlash/display/BitmapData';
import { SimpleButton } from '../as3webFlash/display/SimpleButton';
import { TextField } from '../as3webFlash/text/TextField';
import { Point } from '../as3webFlash/geom/Point';
import { Event } from '../as3webFlash/events/Event';
import { KeyboardEvent } from '../as3webFlash/events/KeyboardEvent';
import { MouseEvent } from '../as3webFlash/events/MouseEvent';
import { ProgressEvent } from '../as3webFlash/events/ProgressEvent';
import { Rectangle } from '../as3webFlash/geom/Rectangle';
import { Matrix } from '../as3webFlash/geom/Matrix';
import { ColorTransform } from '../as3webFlash/geom/ColorTransform';
import { Transform } from '../as3webFlash/geom/Transform';
import { URLRequest } from '../as3webFlash/net/URLRequest';
import { URLLoader } from '../as3webFlash/net/URLLoader';
import { URLVariables } from '../as3webFlash/net/URLVariables';
import { SharedObject } from '../as3webFlash/net/SharedObject';
import { LoaderContext } from '../as3webFlash/system/LoaderContext';
import { ByteArray } from '../avm2/natives/byteArray';
import { Sound } from '../as3webFlash/media/Sound';
import { XMLNode } from '../avm2/natives/xml-document';
import { TextFormat } from '../flash/text/TextFormat';
import { AVMAwayStage } from './AVMAwayStage';
var AVM1Movie = /** @class */ (function (_super) {
    __extends(AVM1Movie, _super);
    function AVM1Movie() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AVM1Movie.prototype._getLevelForRoot = function (root) { return 0; };
    ;
    AVM1Movie.prototype._getRootForLevel = function (level) { return null; };
    ;
    AVM1Movie.prototype._addRoot = function (level, root) { };
    ;
    AVM1Movie.prototype._removeRoot = function (level) { };
    ;
    return AVM1Movie;
}(AwayDisplayObject));
export { AVM1Movie };
var ContextMenu = /** @class */ (function () {
    function ContextMenu() {
    }
    return ContextMenu;
}());
export { ContextMenu };
var ContextMenuItem = /** @class */ (function () {
    function ContextMenuItem() {
    }
    return ContextMenuItem;
}());
export { ContextMenuItem };
var fscommand = /** @class */ (function () {
    function fscommand() {
    }
    return fscommand;
}());
export { fscommand };
var Security = /** @class */ (function () {
    function Security() {
    }
    return Security;
}());
export { Security };
var Capabilities = /** @class */ (function () {
    function Capabilities() {
    }
    return Capabilities;
}());
export { Capabilities };
var ExternalInterface = /** @class */ (function () {
    function ExternalInterface() {
    }
    return ExternalInterface;
}());
export { ExternalInterface };
var Mouse = /** @class */ (function () {
    function Mouse() {
    }
    return Mouse;
}());
export { Mouse };
var SoundChannel = /** @class */ (function () {
    function SoundChannel() {
    }
    return SoundChannel;
}());
export { SoundChannel };
var SoundTransform = /** @class */ (function () {
    function SoundTransform() {
    }
    return SoundTransform;
}());
export { SoundTransform };
var SoundMixer = /** @class */ (function () {
    function SoundMixer() {
    }
    return SoundMixer;
}());
export { SoundMixer };
var SecurityDomain = /** @class */ (function () {
    function SecurityDomain() {
        this.flash = {
            display: {
                EventDispatcher: EventDispatcher,
                DisplayObject: DisplayObject,
                DisplayObjectContainer: DisplayObjectContainer,
                AVM1Movie: AVM1Movie,
                Stage: AVMAwayStage,
                Loader: Loader,
                LoaderInfo: LoaderInfo,
                MovieClip: MovieClip,
                Graphics: Graphics,
                Bitmap: Bitmap,
                BitmapData: BitmapData,
                SimpleButton: SimpleButton
            },
            events: {
                EventDispatcher: EventDispatcher,
                Event: Event,
                KeyboardEvent: KeyboardEvent,
                MouseEvent: MouseEvent,
                ProgressEvent: ProgressEvent
            },
            external: {
                ExternalInterface: ExternalInterface
            },
            filters: {},
            text: {
                TextField: TextField,
                TextFormat: TextFormat
            },
            geom: {
                Point: Point,
                Rectangle: Rectangle,
                Matrix: Matrix,
                ColorTransform: ColorTransform,
                Transform: Transform
            },
            net: {
                URLRequest: URLRequest,
                URLLoader: URLLoader,
                URLVariables: URLVariables,
                SharedObject: SharedObject
            },
            system: {
                Capabilities: Capabilities,
                LoaderContext: LoaderContext,
                Security: Security,
                fscommand: fscommand
            },
            ui: {
                ContextMenu: ContextMenu,
                ContextMenuItem: ContextMenuItem,
                Mouse: Mouse
            },
            utils: {
                ByteArray: ByteArray
            },
            media: {
                Sound: Sound,
                SoundChannel: SoundChannel,
                SoundTransform: SoundTransform,
                SoundMixer: SoundMixer
            },
            xml: {
                XMLDocument: XMLDocumentAway,
                XMLNode: XMLNode
            }
        };
        this.player = {}; //80pro Shumway.Player.Player;
    }
    return SecurityDomain;
}());
export { SecurityDomain };
