import { ActionsDataParser, ParsedAction } from "./parser";
export interface ActionCodeBlock {
    label: number;
    items: ActionCodeBlockItem[];
    jump: number;
}
export interface ActionCodeBlockItem {
    action: ParsedAction;
    next: number;
    conditionalJumpTo: number;
}
export interface AnalyzerResults {
    /** Sparsed array with compiled actions, index is an original location
     *  in the binary actions data */
    actions: ActionCodeBlockItem[];
    blocks: ActionCodeBlock[];
    dataId: string;
    singleConstantPool: any[];
    registersLimit: number;
}
export declare class ActionsDataAnalyzer {
    parentResults: AnalyzerResults;
    registersLimit: number;
    constructor();
    analyze(parser: ActionsDataParser): AnalyzerResults;
}
