/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Context, AVM1ActionsData } from "../context";
import { MovieClip } from "@awayjs/scene";
import { AVM1Object } from "../runtime/AVM1Object";
import { AVM1EventHandler } from "./AVM1EventHandler";
import { AVM1MovieClip } from './AVM1MovieClip';
declare class AVM1ButtonAction {
    keyCode: number;
    stateTransitionFlags: number;
    actionsData: Uint8Array;
    actionsBlock: AVM1ActionsData;
}
export interface IFrameScript {
    (any?: any): any;
    precedence?: number[];
    context?: MovieClip;
}
export declare class AVM1Button extends AVM1MovieClip {
    private _requiredListeners;
    protected _actions: AVM1ButtonAction[];
    static createAVM1Class(context: AVM1Context): AVM1Object;
    _updateMouseEnabled(event: AVM1EventHandler, enabled: boolean): void;
    initAVM1SymbolInstance(context: AVM1Context, awayObject: MovieClip): void;
    initAdapter(): void;
    stop(): void;
    getEnabled(): boolean;
    setEnabled(value: any): void;
    getTrackAsMenu(): boolean;
    setTrackAsMenu(value: boolean): void;
    _addListeners(): void;
    _removeListeners(): void;
    private _keyDownHandler;
    protected _mouseEventHandler(type: number): void;
    protected _runAction(action: AVM1ButtonAction): void;
    protected _initEventsHandlers(): void;
}
export {};
