/**
 * Copyright 2015 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Context } from "../context";
import { ColorTransform } from "@awayjs/core";
import { AVM1Object } from "../runtime/AVM1Object";
import { AVM1Function } from "../runtime/AVM1Function";
export declare function fromAVM1Object(v: AVM1Object): AVM1ColorTransform;
export declare function toAwayColorTransform(v: AVM1ColorTransform): ColorTransform;
export declare function copyAS3ColorTransform(t: ColorTransform, v: AVM1ColorTransform): void;
export declare class AVM1ColorTransform extends AVM1Object {
    _rawData: number[];
    constructor(context: AVM1Context, redMultiplier?: number, greenMultiplier?: number, blueMultiplier?: number, alphaMultiplier?: number, redOffset?: number, greenOffset?: number, blueOffset?: number, alphaOffset?: number);
    getRedMultiplier(): number;
    setRedMultiplier(value: number): void;
    getGreenMultiplier(): number;
    setGreenMultiplier(value: number): void;
    getBlueMultiplier(): number;
    setBlueMultiplier(value: number): void;
    getAlphaMultiplier(): number;
    setAlphaMultiplier(value: number): void;
    getRedOffset(): number;
    setRedOffset(value: number): void;
    getGreenOffset(): number;
    setGreenOffset(value: number): void;
    getBlueOffset(): number;
    setBlueOffset(value: number): void;
    getAlphaOffset(): number;
    setAlphaOffset(value: number): void;
    getRM(): number;
    setRM(value: number): void;
    getGM(): number;
    setGM(value: number): void;
    getBM(): number;
    setBM(value: number): void;
    getAM(): number;
    setAM(value: number): void;
    getRO(): number;
    setRO(value: number): void;
    getGO(): number;
    setGO(value: number): void;
    getBO(): number;
    setBO(value: number): void;
    getAO(): number;
    setAO(value: number): void;
    getRgb(): number;
    setRgb(rgb: number): void;
    concat(second: AVM1ColorTransform): void;
    _toString(): string;
    static fromAwayColorTransform(context: AVM1Context, t: ColorTransform): AVM1ColorTransform;
}
export declare class AVM1ColorTransformFunction extends AVM1Function {
    constructor(context: AVM1Context);
    alConstruct(args?: any[]): AVM1Object;
}
export declare class AVM1ColorTransformPrototype extends AVM1Object {
    constructor(context: AVM1Context, fn: AVM1Function);
}
