import { MouseEvent, KeyboardEvent, FocusEvent, TextfieldEvent } from "@awayjs/scene";
var AVM1EventHandler = /** @class */ (function () {
    function AVM1EventHandler(propertyName, eventName, stageEvent, allowDisable, isMouse, isButton) {
        this.propertyName = propertyName;
        this.eventName = eventName;
        this.stageEvent = stageEvent;
        this.allowDisable = allowDisable;
        this.isMouse = isMouse;
        this.isButton = isButton;
    }
    return AVM1EventHandler;
}());
export { AVM1EventHandler };
var AVM1EventProps = /** @class */ (function () {
    function AVM1EventProps() {
    }
    return AVM1EventProps;
}());
export { AVM1EventProps };
/**
 * Key codes below 32 aren't interpreted as char codes, but are mapped to specific buttons instead.
 * This array uses the key code as the index and KeyboardEvent.keyCode values matching the
 * specific keys as the value.
 * @type {number[]}
 */
export var AVM1KeyCodeMap = [-1, 37, 39, 36, 35, 45, 46, -1, 8, -1, -1, -1, -1, 13, 38, 40, 33, 34, 9, 27];
export var ClipEventMappings = Object.create(null);
ClipEventMappings[262144 /* Construct */] = true;
ClipEventMappings[512 /* Initialize */] = true;
ClipEventMappings[131072 /* KeyPress */] = new AVM1EventHandler('onKey', KeyboardEvent.KEYDOWN, true, true, false, false);
ClipEventMappings[1 /* Load */] = new AVM1EventHandler('onLoad', 'load', false, false, false, false);
ClipEventMappings[4 /* Unload */] = new AVM1EventHandler('onUnload', 'unload', false, false, false, false),
    ClipEventMappings[256 /* Data */] = new AVM1EventHandler('onData', 'data', false, false, false, false),
    ClipEventMappings[2 /* EnterFrame */] = new AVM1EventHandler('onEnterFrame', 'enterFrame', false, false, false, false),
    ClipEventMappings[64 /* KeyDown */] = new AVM1EventHandler('onKeyDown', KeyboardEvent.KEYDOWN, true, true, false, false);
ClipEventMappings[128 /* KeyUp */] = new AVM1EventHandler('onKeyUp', KeyboardEvent.KEYUP, true, true, false, false);
ClipEventMappings[8 /* MouseMove */] = new AVM1EventHandler('onMouseMove', MouseEvent.MOUSE_MOVE, true, true, true, false);
ClipEventMappings[16 /* MouseDown */] = new AVM1EventHandler('onMouseDown', MouseEvent.MOUSE_DOWN, true, true, true, false);
ClipEventMappings[32 /* MouseUp */] = new AVM1EventHandler('onMouseUp', MouseEvent.MOUSE_UP, true, true, true, false);
ClipEventMappings[1024 /* Press */] = new AVM1EventHandler('onPress', MouseEvent.MOUSE_DOWN, false, true, true, true);
ClipEventMappings[2048 /* Release */] = new AVM1EventHandler('onRelease', MouseEvent.MOUSE_UP, false, true, true, true);
ClipEventMappings[4096 /* ReleaseOutside */] = new AVM1EventHandler('onReleaseOutside', MouseEvent.MOUSE_UP_OUTSIDE, false, true, true, true);
ClipEventMappings[8192 /* RollOver */] = new AVM1EventHandler('onRollOver', MouseEvent.MOUSE_OVER, false, true, true, true);
ClipEventMappings[16384 /* RollOut */] = new AVM1EventHandler('onRollOut', MouseEvent.MOUSE_OUT, false, true, true, true);
ClipEventMappings[32768 /* DragOver */] = new AVM1EventHandler('onDragOver', MouseEvent.DRAG_OVER, false, true, true, true);
ClipEventMappings[65536 /* DragOut */] = new AVM1EventHandler('onDragOut', MouseEvent.DRAG_OUT, false, true, true, true);
var setFocusEventMapping = new AVM1EventHandler('onSetFocus', FocusEvent.FOCUS_IN, false, true, false, false);
var unFocusEventMapping = new AVM1EventHandler('onKillFocus', FocusEvent.FOCUS_OUT, false, true, false, false);
var onChangedEventMapping = new AVM1EventHandler('onChanged', TextfieldEvent.CHANGED, false, true, false, false);
export var EventsListForMC = [
    ClipEventMappings[1 /* Load */],
    ClipEventMappings[4 /* Unload */],
    ClipEventMappings[256 /* Data */],
    ClipEventMappings[2 /* EnterFrame */],
    ClipEventMappings[64 /* KeyDown */],
    ClipEventMappings[128 /* KeyUp */],
    ClipEventMappings[8 /* MouseMove */],
    ClipEventMappings[16 /* MouseDown */],
    ClipEventMappings[32 /* MouseUp */],
    ClipEventMappings[1024 /* Press */],
    ClipEventMappings[2048 /* Release */],
    ClipEventMappings[4096 /* ReleaseOutside */],
    ClipEventMappings[8192 /* RollOver */],
    ClipEventMappings[16384 /* RollOut */],
    ClipEventMappings[32768 /* DragOver */],
    ClipEventMappings[65536 /* DragOut */],
    ClipEventMappings[131072 /* KeyPress */],
    setFocusEventMapping,
    unFocusEventMapping,
    onChangedEventMapping
];
export var EventsListForButton = [
    ClipEventMappings[1 /* Load */],
    ClipEventMappings[4 /* Unload */],
    ClipEventMappings[256 /* Data */],
    ClipEventMappings[2 /* EnterFrame */],
    ClipEventMappings[64 /* KeyDown */],
    ClipEventMappings[128 /* KeyUp */],
    ClipEventMappings[1024 /* Press */],
    ClipEventMappings[2048 /* Release */],
    ClipEventMappings[4096 /* ReleaseOutside */],
    ClipEventMappings[8192 /* RollOver */],
    ClipEventMappings[16384 /* RollOut */],
    ClipEventMappings[32768 /* DragOver */],
    ClipEventMappings[65536 /* DragOut */],
    ClipEventMappings[131072 /* KeyPress */],
    setFocusEventMapping,
    unFocusEventMapping,
    onChangedEventMapping
];
