/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Context } from "../context";
import { AVMAwayStage } from "../AVMAwayStage";
import { AVM1Object } from "../runtime/AVM1Object";
export declare class AVM1Key extends AVM1Object {
    static BACKSPACE: number;
    static CAPSLOCK: number;
    static CONTROL: number;
    static DELETEKEY: number;
    static DOWN: number;
    static END: number;
    static ENTER: number;
    static ESCAPE: number;
    static HOME: number;
    static INSERT: number;
    static LEFT: number;
    static PGDN: number;
    static PGUP: number;
    static RIGHT: number;
    static SHIFT: number;
    static SPACE: number;
    static TAB: number;
    static UP: number;
    static _keyStates: any[];
    static _lastKeyCode: number;
    static createAVM1Class(context: AVM1Context): AVM1Object;
    static alInitStatic(context: AVM1Context): void;
    static keyDownDelegate: any;
    static keyUpDelegate: any;
    static bindStage(context: AVM1Context, cls: AVM1Object, stage: AVMAwayStage, htmlElement: HTMLElement): void;
    static isDown(context: AVM1Context, code: any): boolean;
    static getCode(context: AVM1Context): number;
}
