/**
 * Copyright 2015 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Context } from "../context";
import { URLLoader } from "@awayjs/core";
import { AVM1Object } from "../runtime/AVM1Object";
import { AVM1Function } from "../runtime/AVM1Function";
export interface IAVM1DataObject {
    isAVM1DataObject: boolean;
    _as3Loader: URLLoader;
    getBytesLoaded(): number;
    getBytesTotal(): number;
}
export declare function loadAVM1DataObject(context: AVM1Context, url: string, method: string, contentType: string, data: any, target: IAVM1DataObject): void;
export declare class AVM1LoadVarsFunction extends AVM1Function {
    constructor(context: AVM1Context);
    alConstruct(args?: any[]): AVM1Object;
    alCall(thisArg: any, args?: any[]): any;
}
export declare class AVM1LoadVarsPrototype extends AVM1Object implements IAVM1DataObject {
    constructor(context: AVM1Context, fn: AVM1LoadVarsFunction);
    isAVM1DataObject: boolean;
    _as3Loader: URLLoader;
    getBytesLoaded(): number;
    getBytesTotal(): number;
    load(url: string): boolean;
    defaultOnData(src: string): void;
    decode(queryString: string): void;
    _toString(): string;
    send(url: string, target: string, method?: string): boolean;
    sendAndLoad(url: string, target: AVM1Object, method?: string): boolean;
}
