/**
 * Copyright 2015 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Point } from "./AVM1Point";
import { AVM1Context } from "../context";
import { Matrix } from "@awayjs/core";
import { AVM1Object } from "../runtime/AVM1Object";
import { AVM1Function } from "../runtime/AVM1Function";
export declare function toAS3Matrix(v: AVM1Object): Matrix;
export declare function copyAS3MatrixTo(m: Matrix, v: AVM1Object): void;
export declare class AVM1Matrix extends AVM1Object {
    constructor(context: AVM1Context, a?: number, b?: number, c?: number, d?: number, tx?: number, ty?: number);
    static fromAS3Matrix(context: AVM1Context, m: Matrix): AVM1Matrix;
}
export declare class AVM1MatrixFunction extends AVM1Function {
    constructor(context: AVM1Context);
    alConstruct(args?: any[]): AVM1Object;
}
export declare class AVM1MatrixPrototype extends AVM1Object {
    constructor(context: AVM1Context, fn: AVM1Function);
    clone(): AVM1Matrix;
    concat(other: AVM1Matrix): void;
    createBox(scaleX: number, scaleY: number, rotation?: number, tx?: number, ty?: number): void;
    createGradientBox(width: number, height: number, rotation?: number, tx?: number, ty?: number): void;
    deltaTransformPoint(pt: AVM1Point): AVM1Point;
    identity(): void;
    invert(): void;
    rotate(angle: number): void;
    scale(sx: number, sy: number): void;
    _toString(): string;
    transformPoint(pt: AVM1Point): AVM1Point;
    translate(tx: number, ty: number): void;
}
