/**
 * Copyright 2015 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Context } from "../context";
import { Point } from "@awayjs/core";
import { AVM1Object } from "../runtime/AVM1Object";
import { AVM1Function } from "../runtime/AVM1Function";
export declare function toAS3Point(v: AVM1Object): Point;
export declare function copyAS3PointTo(p: Point, v: AVM1Object): void;
export declare class AVM1Point extends AVM1Object {
    constructor(context: AVM1Context, x?: number, y?: number);
    static fromAS3Point(context: AVM1Context, p: Point): AVM1Point;
}
export declare class AVM1PointFunction extends AVM1Function {
    constructor(context: AVM1Context);
    alConstruct(args?: any[]): AVM1Object;
    distance(pt1: AVM1Point, pt2: AVM1Point): number;
    interpolate(pt1: AVM1Point, pt2: AVM1Point, f: number): AVM1Point;
    polar(len: number, angle: number): AVM1Point;
}
export declare class AVM1PointPrototype extends AVM1Object {
    constructor(context: AVM1Context, fn: AVM1Function);
    getLength(): number;
    add(v: AVM1Point): AVM1Point;
    clone(): AVM1Point;
    equals(toCompare: AVM1Point): boolean;
    normalize(length: number): void;
    offset(dx: number, dy: number): void;
    subtract(v: AVM1Point): AVM1Point;
    _toString(): string;
}
