/**
 * Copyright 2015 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Point } from "./AVM1Point";
import { AVM1Context } from "../context";
import { Rectangle } from "@awayjs/core";
import { AVM1Object } from "../runtime/AVM1Object";
import { AVM1Function } from "../runtime/AVM1Function";
export declare function toAS3Rectangle(v: AVM1Object): Rectangle;
export declare function copyAS3RectangleTo(r: Rectangle, v: AVM1Object): void;
export declare class AVM1Rectangle extends AVM1Object {
    constructor(context: AVM1Context, x?: number, y?: number, width?: number, height?: number);
    static fromAS3Rectangle(context: AVM1Context, r: Rectangle): AVM1Point;
}
export declare class AVM1RectangleFunction extends AVM1Function {
    constructor(context: AVM1Context);
    alConstruct(args?: any[]): AVM1Object;
}
export declare class AVM1RectanglePrototype extends AVM1Object {
    constructor(context: AVM1Context, fn: AVM1Function);
    getBottom(): number;
    setBottom(value: number): void;
    getBottomRight(): AVM1Point;
    setBottomRight(pt: AVM1Point): void;
    getLeft(): number;
    setLeft(value: number): void;
    getSize(): AVM1Point;
    setSize(pt: AVM1Point): void;
    getRight(): number;
    setRight(value: number): void;
    getTop(): number;
    setTop(value: number): void;
    getTopLeft(): AVM1Point;
    setTopLeft(pt: AVM1Point): void;
    clone(): AVM1Rectangle;
    contains(x: number, y: number): boolean;
    containsPoint(pt: AVM1Point): boolean;
    containsRectangle(rect: AVM1Rectangle): boolean;
    equals(toCompare: AVM1Rectangle): boolean;
    inflate(dx: number, dy: number): void;
    inflatePoint(pt: AVM1Point): void;
    intersection(toIntersect: AVM1Rectangle): AVM1Rectangle;
    intersects(toIntersect: AVM1Rectangle): boolean;
    isEmpty(): boolean;
    offset(dx: number, dy: number): void;
    offsetPoint(pt: AVM1Point): void;
    setEmpty(): void;
    _toString(): string;
    union(toUnion: AVM1Rectangle): AVM1Rectangle;
}
