/**
 * Copyright 2015 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Context } from "../context";
import { AVM1Object } from "../runtime/AVM1Object";
export declare class AVM1SharedObject extends AVM1Object {
    static createAVM1Class(context: AVM1Context): AVM1Object;
    private _data;
    private _storage_name;
    constructor(context: AVM1Context);
    setName(name: string): any;
    static getLocal(context: AVM1Context, name: string, localPath?: string, secure?: boolean): AVM1SharedObject;
    getData(): any;
    clear(): void;
    private getAVM1Value;
    private getJSValue;
    flush(minDiskSpace?: number): any;
}
