/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Object } from "../runtime/AVM1Object";
import { AVM1Context } from "../context";
export declare class AVM1Sound extends AVM1Object {
    static createAVM1Class(context: AVM1Context): AVM1Object;
    private _target;
    private _sound;
    private _channel;
    private _linkageID;
    private _assetNameSpace;
    private _onCompleteCallback;
    avm1Constructor(target_mc: any): void;
    alPut(p: any, v: any): void;
    alDeleteProperty(p: any): boolean;
    attachSound(id: string): void;
    private loopsToPlay;
    private soundCompleteInternal;
    onSoundComplete(callback?: any): void;
    loadSound(url: string, isStreaming: boolean): void;
    getBytesLoaded(): number;
    getBytesTotal(): number;
    getDuration(): number;
    getPan(): number;
    setPan(value: number): void;
    getTransform(): any;
    setTransform(transformObject: any): void;
    getVolume(): number;
    setVolume(value: number): void;
    start(secondOffset?: number, loops?: number): void;
    stop(linkageID?: string): void;
}
