/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Object } from "../runtime/AVM1Object";
import { AVM1Context } from "../context";
import { AVMAwayStage } from "../AVMAwayStage";
import { Rectangle } from '@awayjs/core';
export declare class AVM1Stage extends AVM1Object {
    static stage: AVMAwayStage;
    static createAVM1Class(context: AVM1Context): AVM1Object;
    static bindStage(context: AVM1Context, cls: AVM1Object, stage: AVMAwayStage, htmlElement: HTMLElement): void;
    _awayAVMStage: AVMAwayStage;
    getAlign(): any;
    setAlign(value: any): void;
    getDisplayState(): string;
    setDisplayState(value: any): void;
    getFullScreenSourceRect(): Rectangle;
    setFullScreenSourceRect(value: Rectangle): void;
    getHeight(): number;
    getScaleMode(): any;
    setScaleMode(value: any): void;
    getShowMenu(): boolean;
    setShowMenu(value: any): void;
    getWidth(): number;
}
