import { IAVM1SymbolBase } from "./AVM1Utils";
import { AVM1Context, IAVM1EventPropertyObserver } from "../context";
import { MapObject } from "../../base/utilities";
import { DisplayObjectContainer } from "@awayjs/scene";
import { AVM1MovieClip } from "./AVM1MovieClip";
import { AVM1Rectangle } from "./AVM1Rectangle";
import { AVM1Object } from "../runtime/AVM1Object";
import { AVM1EventHandler } from "./AVM1EventHandler";
export declare class AVM1SymbolBase<T extends DisplayObjectContainer> extends AVM1Object implements IAVM1SymbolBase, IAVM1EventPropertyObserver {
    adaptee: T;
    _as3ObjectTemplate: any;
    hasSwappedDepth: boolean;
    dynamicallyCreated: boolean;
    initAVM1SymbolInstance(context: AVM1Context, awayObject: T): void;
    protected _mouseListenerCount: number;
    private _eventsMap;
    private _events;
    protected _eventsListeners: MapObject<Function>;
    protected _onClipEventsListeners: any[];
    protected _eventHandlers: MapObject<AVM1EventHandler>;
    protected enabled: boolean;
    private avmColor;
    bindEvents(events: AVM1EventHandler[], autoUnbind?: boolean): void;
    unbindEvents(): void;
    updateEventByPropName(eventName: any): void;
    updateAllEvents(): void;
    private _updateEvent;
    _addOnClipEventListener(event: AVM1EventHandler, callback?: () => void, eventProps?: any): void;
    _addEventListener(event: AVM1EventHandler, callback?: Function): void;
    addEventListenerOnAdapter(event: AVM1EventHandler, callback: () => void, eventProps?: any): void;
    removeEventListenerOnAdapter(event: AVM1EventHandler, callback: () => void): void;
    _updateMouseEnabled(event: AVM1EventHandler, enabled: boolean): void;
    freeFromScript(): void;
    private _removeEventListener;
    onEventPropertyModified(propertyName: string): void;
    getEnabled(): boolean;
    setEnabled(value: any): void;
    setEnabledListener(value: any): void;
    get_alpha(): number;
    set_alpha(value: number): void;
    getBlendMode(): string;
    setBlendMode(value: string): void;
    getCacheAsBitmap(): boolean;
    setCacheAsBitmap(value: boolean): void;
    getFilters(): AVM1Object;
    setFilters(value: any): void;
    get_focusrect(): boolean;
    set_focusrect(value: boolean): void;
    get_height(): number;
    set_height(value: number): void;
    get_highquality(): number;
    set_highquality(value: number): void;
    getMenu(): void;
    setMenu(value: any): void;
    get_name(): string;
    set_name(value: string): void;
    get_parent(): AVM1MovieClip;
    set_parent(value: AVM1MovieClip): void;
    getOpaqueBackground(): number;
    setOpaqueBackground(value: number): void;
    get_quality(): string;
    set_quality(value: any): void;
    set_root(value: any): void;
    get_root(): AVM1MovieClip;
    get_rotation(): number;
    set_rotation(value: number): void;
    getScale9Grid(): AVM1Rectangle;
    setScale9Grid(value: AVM1Rectangle): void;
    getScrollRect(): AVM1Rectangle;
    setScrollRect(value: AVM1Rectangle): void;
    get_soundbuftime(): number;
    set_soundbuftime(value: number): void;
    getTabEnabled(): boolean;
    setTabEnabled(value: boolean): void;
    getTabIndex(): number;
    setTabIndex(value: number): void;
    get_target(): string;
    removeMovieClip(): void;
    get_visible(): boolean;
    set_visible(value: boolean): void;
    get_url(): string;
    get_width(): number;
    set_width(value: number): void;
    get_x(): number;
    set_x(value: number): void;
    get_xmouse(): number;
    get_xscale(): number;
    set_xscale(value: number): void;
    get_y(): number;
    set_y(value: number): void;
    get_ymouse(): number;
    get_yscale(): number;
    set_yscale(value: number): void;
    getDepth(): number;
    toString(): string;
}
