/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Context } from "../context";
import { TextField } from "@awayjs/scene";
import { AVM1SymbolBase } from "./AVM1SymbolBase";
import { AVM1Object } from "../runtime/AVM1Object";
export declare class AVM1TextField extends AVM1SymbolBase<TextField> {
    static createAVM1Class(context: AVM1Context): AVM1Object;
    private _variable;
    private _exitFrameHandler;
    dispatchKeyEvent(keyCode: any, isShift: any, isCTRL: any, isAlt: any): void;
    static allTextfields: any;
    static syncAllTextfields(): void;
    static textFieldVars: AVM1TextField[];
    static syncQueedTextfields(): void;
    getAwayJSID(): number;
    selectTextField(fromMouseDown?: boolean): void;
    removeTextField(): void;
    alPut(p: any, v: any): void;
    initAdapter(): void;
    initAVM1SymbolInstance(context: AVM1Context, awayObject: TextField): void;
    clone(): any;
    getAntiAliasType(): string;
    setAntiAliasType(value: string): void;
    get_width(): number;
    get_height(): number;
    set_width(value: number): void;
    set_height(value: number): void;
    get_x(): number;
    get_y(): number;
    set_x(value: number): void;
    set_y(value: number): void;
    getAutoSize(): string;
    setAutoSize(value: any): void;
    getBackground(): boolean;
    setBackground(value: boolean): void;
    getBackgroundColor(): number;
    setBackgroundColor(value: any): void;
    getBorder(): boolean;
    setBorder(value: boolean): void;
    getBorderColor(): number;
    setBorderColor(value: number): void;
    getBottomScroll(): number;
    getCondenseWhite(): boolean;
    setCondenseWhite(value: boolean): void;
    getEmbedFonts(): boolean;
    setEmbedFonts(value: any): void;
    getNewTextFormat(): AVM1Object;
    getTextFormat(beginIndex?: number, endIndex?: number): AVM1Object;
    getGridFitType(): string;
    setGridFitType(value: string): void;
    getHscroll(): number;
    setHscroll(value: number): void;
    getHtml(): boolean;
    setHtml(value: any): void;
    getHtmlText(): string;
    setHtmlText(value: string): void;
    getLength(): number;
    getMaxChars(): number;
    setMaxChars(value: any): void;
    getRestrict(): string;
    setRestrict(value: any): void;
    getMaxhscroll(): number;
    getMaxscroll(): number;
    getMultiline(): boolean;
    setMultiline(value: boolean): void;
    getPassword(): boolean;
    setPassword(value: boolean): void;
    getScroll(): number;
    setScroll(value: number): void;
    getSelectable(): boolean;
    setSelectable(value: any): void;
    replaceSel(value: string): void;
    /**
     * for html text this will get ignored
     */
    setNewTextFormat(value: any): void;
    /**
     * This should only have effect on text that is currently existent on the Textfield.
     * for new text we must use setNewTextFormat
     */
    setTextFormat(): void;
    getText(): string;
    setText(value: string): void;
    getTextColor(): number;
    setTextColor(value: number): void;
    getTextHeight(): number;
    setTextHeight(value: number): void;
    getTextWidth(): number;
    setTextWidth(value: any): void;
    getType(): string;
    setType(value: string): void;
    getVariable(): string;
    private _prevTextVarContent;
    private _textVarHolder;
    private _textVarPropName;
    setVariable(name: string): void;
    private _onAS3ObjectExitFrame;
    syncTextFieldValue(): void;
    updateVarFromText(): void;
    private _syncTextFieldValue;
    getWordWrap(): boolean;
    setWordWrap(value: boolean): void;
    private _initEventsHandlers;
}
