/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Context } from "../context";
import { IHasAS3ObjectReference } from "./AVM1Utils";
import { TextFormat } from "@awayjs/scene";
import { AVM1Object } from "../runtime/AVM1Object";
export declare class AVM1TextFormat extends AVM1Object implements IHasAS3ObjectReference {
    static createAVM1Class(context: AVM1Context): AVM1Object;
    static createFromNative(context: AVM1Context, awayObject: TextFormat): AVM1Object;
    alPut(p: any, v: any): void;
    adaptee: any;
    avm1Constructor(font?: string, size?: number, color?: number, bold?: boolean, italic?: boolean, underline?: boolean, url?: string, target?: string, align?: string, leftMargin?: number, rightMargin?: number, indent?: number, leading?: number): void;
    private static _measureTextField;
    static alInitStatic(context: AVM1Context): void;
    getAdaptee(): any;
    setAdaptee(value: any): void;
    getAlign(): string;
    setAlign(value: string): void;
    getBlockIndent(): any;
    setBlockIndent(value: any): void;
    getBold(): any;
    setBold(value: any): void;
    getBullet(): any;
    setBullet(value: any): void;
    getColor(): any;
    setColor(value: any): void;
    getFont(): string;
    setFont(value: string): void;
    getIndent(): any;
    setIndent(value: any): void;
    getItalic(): any;
    setItalic(value: any): void;
    getKerning(): any;
    setKerning(value: any): void;
    getLeading(): any;
    setLeading(value: any): void;
    getLeftMargin(): any;
    setLeftMargin(value: any): void;
    getLetterSpacing(): any;
    setLetterSpacing(value: any): void;
    getRightMargin(): any;
    setRightMargin(value: any): void;
    getSize(): any;
    setSize(value: any): void;
    getTabStops(): any;
    setTabStops(value: any): void;
    getTarget(): string;
    setTarget(value: string): void;
    getTextExtent(text: string, width?: number): AVM1Object;
    getUnderline(): any;
    setUnderline(value: any): void;
    getUrl(): string;
    setUrl(value: string): void;
}
