/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { AVM1Object } from "../runtime/AVM1Object";
import { AVM1Context } from "../context";
import { AVM1Matrix } from "./AVM1Matrix";
import { AVM1ColorTransform } from "./AVM1ColorTransform";
import { AVM1Rectangle } from "./AVM1Rectangle";
import { Transform } from "@awayjs/core";
export declare class AVM1Transform extends AVM1Object {
    static createAVM1Class(context: AVM1Context): AVM1Object;
    private _target;
    private _targetAwayObject;
    get as3Transform(): Transform;
    avm1Constructor(target_mc: any): void;
    getMatrix(): AVM1Object;
    setMatrix(value: AVM1Matrix): void;
    getConcatenatedMatrix(): AVM1Matrix;
    getColorTransform(): AVM1ColorTransform;
    setColorTransform(value: AVM1ColorTransform): void;
    getPixelBounds(): AVM1Rectangle;
}
