import { AVM1Object } from "./AVM1Object";
import { IAVM1Context, IAVM1Callable } from "../runtime";
/**
 * Base class for ActionsScript functions.
 */
export declare class AVM1Function extends AVM1Object implements IAVM1Callable {
    isOnEnter: boolean;
    constructor(context: IAVM1Context);
    alConstruct(args?: any[]): AVM1Object;
    alCall(thisArg: any, args?: any[]): any;
    /**
     * Wraps the function to the callable JavaScript function.
     * @returns {Function} a JavaScript function.
     */
    toJSFunction(thisArg?: AVM1Object): Function;
}
