import { IDisplayObjectAdapter } from "@awayjs/scene";
import { IAVM1Context, IAVM1Callable, AVM1DefaultValueHint } from "../runtime";
import { IAsset } from "@awayjs/core";
import { AVM1Context } from "../context";
import { AVM1PropertyDescriptor } from "./AVM1PropertyDescriptor";
/**
 * Base class for object instances we prefer to not inherit Object.prototype properties.
 */
export declare class NullPrototypeObject {
}
/**
 * Base class for the ActionScript AVM1 object.
 */
export declare class AVM1Object extends NullPrototypeObject implements IDisplayObjectAdapter {
    _ownProperties: any;
    _prototype: AVM1Object;
    _avm1Context: IAVM1Context;
    adaptee: IAsset;
    avmType: string;
    protected initialDepth: number;
    protected scriptRefsToChilds: any;
    _eventObserver: AVM1Object;
    _blockedByScript: boolean;
    _ctBlockedByScript: boolean;
    protoTypeChanged: boolean;
    protected _visibilityByScript: boolean;
    get eventObserver(): AVM1Object;
    set eventObserver(value: AVM1Object);
    dispose(): any;
    isBlockedByScript(): boolean;
    isColorTransformByScript(): boolean;
    isVisibilityByScript(): boolean;
    initAdapter(): void;
    freeFromScript(): void;
    clone(): AVM1Object;
    get context(): AVM1Context;
    constructor(avm1Context: IAVM1Context);
    get alPrototype(): AVM1Object;
    set alPrototype(v: AVM1Object);
    alGetPrototypeProperty(): AVM1Object;
    alSetOwnPrototypeProperty(v: any): void;
    alGetConstructorProperty(): AVM1Object;
    alSetOwnConstructorProperty(v: any): void;
    _debugEscapeProperty(p: any): string;
    alGetOwnProperty(name: any): AVM1PropertyDescriptor;
    alSetOwnProperty(p: any, desc: AVM1PropertyDescriptor): void;
    alHasOwnProperty(p: any): boolean;
    alDeleteOwnProperty(p: any): void;
    deleteOwnProperties(): void;
    alGetOwnPropertiesKeys(): string[];
    alGetProperty(p: any): AVM1PropertyDescriptor;
    alGet(p: any): any;
    alCanPut(p: any): boolean;
    alPut(p: any, v: any): void;
    alHasProperty(p: any): boolean;
    alDeleteProperty(p: any): boolean;
    alAddPropertyWatcher(p: any, callback: IAVM1Callable, userData: any): boolean;
    alRemotePropertyWatcher(p: any): boolean;
    alDefaultValue(hint?: AVM1DefaultValueHint): any;
    alGetKeys(): string[];
}
