import { Info } from "./Info";
import { ClassTraitInfo } from "./ClassTraitInfo";
import { RuntimeTraits } from "./RuntimeTraits";
import { ABCFile } from "./ABCFile";
import { InstanceInfo } from "./InstanceInfo";
import { MethodInfo } from "./MethodInfo";
import { Traits } from "./Traits";
import { MetadataInfo } from "./MetadataInfo";
import { IndentingWriter } from "../../../base/utilities";
export declare class ClassInfo extends Info {
    abc: ABCFile;
    instanceInfo: InstanceInfo;
    initializer: MethodInfo | number;
    traits: Traits;
    trait: ClassTraitInfo;
    runtimeTraits: RuntimeTraits;
    constructor(abc: ABCFile, instanceInfo: InstanceInfo, initializer: MethodInfo | number, traits: Traits);
    getNativeMetadata(): MetadataInfo;
    getInitializer(): MethodInfo;
    toString(): string;
    trace(writer: IndentingWriter): void;
}
