import { Info } from "./Info";
import { ClassInfo } from "./ClassInfo";
import { RuntimeTraits } from "./RuntimeTraits";
import { AXClass } from "../../run/AXClass";
import { ABCFile } from "./ABCFile";
import { Multiname } from "./Multiname";
import { MethodInfo } from "./MethodInfo";
import { Traits } from "./Traits";
import { IndentingWriter } from "../../../base/utilities";
export declare class InstanceInfo extends Info {
    abc: ABCFile;
    name: Multiname | number;
    superName: Multiname | number;
    flags: number;
    protectedNs: number;
    interfaceNameIndices: number[];
    initializer: MethodInfo | number;
    traits: Traits;
    classInfo: ClassInfo;
    runtimeTraits: RuntimeTraits;
    private _interfaces;
    constructor(abc: ABCFile, name: Multiname | number, superName: Multiname | number, flags: number, protectedNs: number, interfaceNameIndices: number[], initializer: MethodInfo | number, traits: Traits);
    getInitializer(): MethodInfo;
    getName(): Multiname;
    getClassName(): string;
    getSuperName(): Multiname;
    getInterfaces(ownerClass: AXClass): Set<AXClass>;
    toString(): string;
    toFlashlogString(): string;
    trace(writer: IndentingWriter): void;
    isInterface(): boolean;
    isSealed(): boolean;
    isFinal(): boolean;
}
