import { MethodTraitInfo } from "./MethodTraitInfo";
import { MethodBodyInfo } from "./MethodBodyInfo";
import { AXClass } from "../../run/AXClass";
import { ABCFile } from "./ABCFile";
import { ParameterInfo } from "./ParameterInfo";
import { MetadataInfo } from "./MetadataInfo";
import { Multiname } from './Multiname';
export declare class MethodInfo {
    abc: ABCFile;
    private _index;
    name: number;
    returnTypeNameIndex: number;
    parameters: ParameterInfo[];
    optionalCount: number;
    flags: number;
    trait: MethodTraitInfo;
    minArgs: number;
    private _body;
    private _returnType;
    compiled: Function;
    names: Multiname[];
    error: string;
    constructor(abc: ABCFile, _index: number, name: number, returnTypeNameIndex: number, parameters: ParameterInfo[], optionalCount: number, flags: number);
    getNativeMetadata(): MetadataInfo;
    getBody(): MethodBodyInfo;
    index(): number;
    getType(): AXClass;
    getName(): string;
    toString(): string;
    toFlashlogString(): string;
    isNative(): boolean;
    needsRest(): boolean;
    needsArguments(): boolean;
}
