export declare class AbcStream {
    private static _resultBuffer;
    private _bytes;
    private _view;
    private _position;
    constructor(bytes: Uint8Array);
    private static _getResultBuffer;
    get position(): number;
    remaining(): number;
    seek(position: number): void;
    advance(length: number): void;
    readU8(): number;
    readU8s(count: number): Uint8Array;
    viewU8s(count: number): Uint8Array;
    readS8(): number;
    readU32(): number;
    readU30(): number;
    readU30Unsafe(): number;
    readS16(): number;
    /**
     * Read a variable-length encoded 32-bit signed integer. The value may use one to five bytes (little endian),
     * each contributing 7 bits. The most significant bit of each byte indicates that the next byte is part of
     * the value. The spec indicates that the most significant bit of the last byte to be read is sign extended
     * but this turns out not to be the case in the real implementation, for instance 0x7f should technically be
     * -1, but instead it's 127. Moreover, what happens to the remaining 4 high bits of the fifth byte that is
     * read? Who knows, here we'll just stay true to the Tamarin implementation.
     */
    readS32(): number;
    readWord(): number;
    readS24(): number;
    readDouble(): number;
    readUTFString(length: any): string;
}
