export interface ErrorInfo {
    code: number;
    message: string;
}
export declare var Errors: {
    /**
     * AVM2 Error Codes
     */
    NotImplementedError: {
        code: number;
        message: string;
    };
    InvalidPrecisionError: {
        code: number;
        message: string;
    };
    InvalidRadixError: {
        code: number;
        message: string;
    };
    InvokeOnIncompatibleObjectError: {
        code: number;
        message: string;
    };
    ArrayIndexNotIntegerError: {
        code: number;
        message: string;
    };
    CallOfNonFunctionError: {
        code: number;
        message: string;
    };
    ConstructOfNonFunctionError: {
        code: number;
        message: string;
    };
    ConvertNullToObjectError: {
        code: number;
        message: string;
    };
    ConvertUndefinedToObjectError: {
        code: number;
        message: string;
    };
    ClassNotFoundError: {
        code: number;
        message: string;
    };
    DescendentsError: {
        code: number;
        message: string;
    };
    StackOverflowError: {
        code: number;
        message: string;
    };
    CpoolIndexRangeError: {
        code: number;
        message: string;
    };
    CpoolEntryWrongTypeError: {
        code: number;
        message: string;
    };
    CheckTypeFailedError: {
        code: number;
        message: string;
    };
    CannotAssignToMethodError: {
        code: number;
        message: string;
    };
    CantUseInstanceofOnNonObjectError: {
        code: number;
        message: string;
    };
    IsTypeMustBeClassError: {
        code: number;
        message: string;
    };
    InvalidMagicError: {
        code: number;
        message: string;
    };
    UnsupportedTraitsKindError: {
        code: number;
        message: string;
    };
    PrototypeTypeError: {
        code: number;
        message: string;
    };
    ConvertToPrimitiveError: {
        code: number;
        message: string;
    };
    InvalidURIError: {
        code: number;
        message: string;
    };
    WriteSealedError: {
        code: number;
        message: string;
    };
    WrongArgumentCountError: {
        code: number;
        message: string;
    };
    UndefinedVarError: {
        code: number;
        message: string;
    };
    ReadSealedError: {
        code: number;
        message: string;
    };
    ConstWriteError: {
        code: number;
        message: string;
    };
    XMLPrefixNotBound: {
        code: number;
        message: string;
    };
    XMLUnterminatedElementTag: {
        code: number;
        message: string;
    };
    XMLOnlyWorksWithOneItemLists: {
        code: number;
        message: string;
    };
    XMLAssignmentToIndexedXMLNotAllowed: {
        code: number;
        message: string;
    };
    XMLMarkupMustBeWellFormed: {
        code: number;
        message: string;
    };
    XMLAssigmentOneItemLists: {
        code: number;
        message: string;
    };
    XMLMalformedElement: {
        code: number;
        message: string;
    };
    XMLUnterminatedCData: {
        code: number;
        message: string;
    };
    XMLUnterminatedXMLDecl: {
        code: number;
        message: string;
    };
    XMLUnterminatedDocTypeDecl: {
        code: number;
        message: string;
    };
    XMLUnterminatedComment: {
        code: number;
        message: string;
    };
    XMLUnterminatedElement: {
        code: number;
        message: string;
    };
    XMLNamespaceWithPrefixAndNoURI: {
        code: number;
        message: string;
    };
    RegExpFlagsArgumentError: {
        code: number;
        message: string;
    };
    InvalidBaseClassError: {
        code: number;
        message: string;
    };
    XMLInvalidName: {
        code: number;
        message: string;
    };
    XMLIllegalCyclicalLoop: {
        code: number;
        message: string;
    };
    FilterError: {
        code: number;
        message: string;
    };
    OutOfRangeError: {
        code: number;
        message: string;
    };
    VectorFixedError: {
        code: number;
        message: string;
    };
    TypeAppOfNonParamType: {
        code: number;
        message: string;
    };
    WrongTypeArgCountError: {
        code: number;
        message: string;
    };
    JSONCyclicStructure: {
        code: number;
        message: string;
    };
    JSONInvalidReplacer: {
        code: number;
        message: string;
    };
    JSONInvalidParseInput: {
        code: number;
        message: string;
    };
    InvalidRangeError: {
        code: number;
        message: string;
    };
    NullArgumentError: {
        code: number;
        message: string;
    };
    InvalidArgumentError: {
        code: number;
        message: string;
    };
    ArrayFilterNonNullObjectError: {
        code: number;
        message: string;
    };
    InvalidParamError: {
        code: number;
        message: string;
    };
    ParamRangeError: {
        code: number;
        message: string;
    };
    NullPointerError: {
        code: number;
        message: string;
    };
    InvalidEnumError: {
        code: number;
        message: string;
    };
    CantInstantiateError: {
        code: number;
        message: string;
    };
    InvalidBitmapData: {
        code: number;
        message: string;
    };
    EOFError: {
        code: number;
        message: string;
        fqn: string;
    };
    CompressedDataError: {
        code: number;
        message: string;
        fqn: string;
    };
    EmptyStringError: {
        code: number;
        message: string;
    };
    ProxyGetPropertyError: {
        code: number;
        message: string;
    };
    ProxySetPropertyError: {
        code: number;
        message: string;
    };
    ProxyCallPropertyError: {
        code: number;
        message: string;
    };
    ProxyHasPropertyError: {
        code: number;
        message: string;
    };
    ProxyDeletePropertyError: {
        code: number;
        message: string;
    };
    ProxyGetDescendantsError: {
        code: number;
        message: string;
    };
    ProxyNextNameIndexError: {
        code: number;
        message: string;
    };
    ProxyNextNameError: {
        code: number;
        message: string;
    };
    ProxyNextValueError: {
        code: number;
        message: string;
    };
    /**
     * Player Error Codes
     */
    TooFewArgumentsError: {
        code: number;
        message: string;
    };
    ParamTypeError: {
        code: number;
        message: string;
    };
    SocketConnectError: {
        code: number;
        message: string;
    };
    CantAddSelfError: {
        code: number;
        message: string;
    };
    NotAChildError: {
        code: number;
        message: string;
    };
    UnhandledError: {
        code: number;
        message: string;
    };
    AllowDomainArgumentError: {
        code: number;
        message: string;
    };
    DelayRangeError: {
        code: number;
        message: string;
    };
    ExternalInterfaceNotAvailableError: {
        code: number;
        message: string;
    };
    InvalidLoaderMethodError: {
        code: number;
        message: string;
    };
    InvalidStageMethodError: {
        code: number;
        message: string;
    };
    TimelineObjectNameSealedError: {
        code: number;
        message: string;
    };
    AlreadyConnectedError: {
        code: number;
        message: string;
    };
    CloseNotConnectedError: {
        code: number;
        message: string;
    };
    ArgumentSizeError: {
        code: number;
        message: string;
    };
    AsyncError: {
        code: number;
        message: string;
    };
    LoadingObjectNotSWFError: {
        code: number;
        message: string;
    };
    LoadingObjectNotInitializedError: {
        code: number;
        message: string;
    };
    DecodeParamError: {
        code: number;
        message: string;
    };
    SceneNotFoundError: {
        code: number;
        message: string;
    };
    FrameLabelNotFoundError: {
        code: number;
        message: string;
    };
    InvalidLoaderInfoMethodError: {
        code: number;
        message: string;
    };
    SecuritySwfNotAllowedError: {
        code: number;
        message: string;
    };
    UnknownFileTypeError: {
        code: number;
        message: string;
    };
    CantAddParentError: {
        code: number;
        message: string;
    };
    Matrix3DRefCannontBeShared: {
        code: number;
        message: string;
    };
    ObjectWithStringsParamError: {
        code: number;
        message: string;
    };
    AllowCodeImportError: {
        code: number;
        message: string;
    };
    PermissionDenied: {
        code: number;
        message: string;
    };
    InternalErrorIV: {
        code: number;
        message: string;
    };
};
export declare function getErrorMessage(index: number): string;
export declare function getErrorInfo(index: number): ErrorInfo;
export declare function formatErrorMessage(error: any, ...args: any[]): string;
export declare function translateErrorMessage(error: any): any;
