import { Scope } from "./run/Scope";
import { Multiname } from "./abc/lazy/Multiname";
import { MethodInfo } from "./abc/lazy/MethodInfo";
import { AXClass } from "./run/AXClass";
export declare enum Bytecode {
    BKPT = 1,
    NOP = 2,
    THROW = 3,
    GETSUPER = 4,
    GETSUPER_DYN = 260,
    SETSUPER = 5,
    SETSUPER_DYN = 261,
    DXNS = 6,
    DXNSLATE = 7,
    KILL = 8,
    LABEL = 9,
    LF32X4 = 10,
    SF32X4 = 11,
    IFNLT = 12,
    IFNLE = 13,
    IFNGT = 14,
    IFNGE = 15,
    JUMP = 16,
    IFTRUE = 17,
    IFFALSE = 18,
    IFEQ = 19,
    IFNE = 20,
    IFLT = 21,
    IFLE = 22,
    IFGT = 23,
    IFGE = 24,
    IFSTRICTEQ = 25,
    IFSTRICTNE = 26,
    LOOKUPSWITCH = 27,
    PUSHWITH = 28,
    POPSCOPE = 29,
    NEXTNAME = 30,
    HASNEXT = 31,
    PUSHNULL = 32,
    PUSHUNDEFINED = 33,
    PUSHFLOAT = 34,
    NEXTVALUE = 35,
    PUSHBYTE = 36,
    PUSHSHORT = 37,
    PUSHTRUE = 38,
    PUSHFALSE = 39,
    PUSHNAN = 40,
    POP = 41,
    DUP = 42,
    SWAP = 43,
    PUSHSTRING = 44,
    PUSHINT = 45,
    PUSHUINT = 46,
    PUSHDOUBLE = 47,
    PUSHSCOPE = 48,
    PUSHNAMESPACE = 49,
    HASNEXT2 = 50,
    LI8 = 53,
    LI16 = 54,
    LI32 = 55,
    LF32 = 56,
    LF64 = 57,
    SI8 = 58,
    SI16 = 59,
    SI32 = 60,
    SF32 = 61,
    SF64 = 62,
    NEWFUNCTION = 64,
    CALL = 65,
    CONSTRUCT = 66,
    CALLMETHOD = 67,
    CALLSTATIC = 68,
    CALLSUPER = 69,
    CALLSUPER_DYN = 69,
    CALLPROPERTY = 70,
    CALLPROPERTY_DYN = 326,
    RETURNVOID = 71,
    RETURNVALUE = 72,
    CONSTRUCTSUPER = 73,
    CONSTRUCTSUPER_DYN = 329,
    CONSTRUCTPROP = 74,
    CONSTRUCTPROP_DYN = 330,
    CALLSUPERID = 75,
    CALLPROPLEX = 76,
    CALLPROPLEX_DYN = 332,
    CALLINTERFACE = 77,
    CALLSUPERVOID = 78,
    CALLSUPERVOID_DYN = 334,
    CALLPROPVOID = 79,
    SXI1 = 80,
    SXI8 = 81,
    SXI16 = 82,
    APPLYTYPE = 83,
    PUSHFLOAT4 = 84,
    NEWOBJECT = 85,
    NEWARRAY = 86,
    NEWACTIVATION = 87,
    NEWCLASS = 88,
    GETDESCENDANTS = 89,
    NEWCATCH = 90,
    FINDPROPSTRICT = 93,
    FINDPROPSTRICT_DYN = 349,
    FINDPROPERTY = 94,
    FINDPROPERTY_DYN = 350,
    FINDDEF = 95,
    GETLEX = 96,
    GETLEX_DYN = 352,
    SETPROPERTY = 97,
    SETPROPERTY_DYN = 353,
    GETLOCAL = 98,
    SETLOCAL = 99,
    GETGLOBALSCOPE = 100,
    GETSCOPEOBJECT = 101,
    GETPROPERTY = 102,
    GETPROPERTY_DYN = 358,
    GETOUTERSCOPE = 103,
    INITPROPERTY = 104,
    UNUSED_69 = 105,
    DELETEPROPERTY = 106,
    DELETEPROPERTY_DYN = 362,
    UNUSED_6B = 107,
    GETSLOT = 108,
    SETSLOT = 109,
    GETGLOBALSLOT = 110,
    SETGLOBALSLOT = 111,
    CONVERT_S = 112,
    ESC_XELEM = 113,
    ESC_XATTR = 114,
    CONVERT_I = 115,
    CONVERT_U = 116,
    CONVERT_D = 117,
    CONVERT_B = 118,
    CONVERT_O = 119,
    CHECKFILTER = 120,
    CONVERT_F = 121,
    UNPLUS = 122,
    CONVERT_F4 = 123,
    BC_7C = 124,
    BC_7D = 125,
    BC_7E = 126,
    BC_7F = 127,
    COERCE = 128,
    COERCE_DYN = 384,
    COERCE_B = 129,
    COERCE_A = 130,
    COERCE_I = 131,
    COERCE_D = 132,
    COERCE_S = 133,
    ASTYPE = 134,
    ASTYPELATE = 135,
    COERCE_U = 136,
    COERCE_O = 137,
    NEGATE = 144,
    INCREMENT = 145,
    INCLOCAL = 146,
    DECREMENT = 147,
    DECLOCAL = 148,
    TYPEOF = 149,
    NOT = 150,
    BITNOT = 151,
    UNUSED_98 = 152,
    UNUSED_99 = 153,
    UNUSED_9A = 154,
    UNUSED_9B = 155,
    UNUSED_9C = 156,
    UNUSED_9D = 157,
    UNUSED_9E = 158,
    UNUSED_9F = 159,
    ADD = 160,
    SUBTRACT = 161,
    MULTIPLY = 162,
    DIVIDE = 163,
    MODULO = 164,
    LSHIFT = 165,
    RSHIFT = 166,
    URSHIFT = 167,
    BITAND = 168,
    BITOR = 169,
    BITXOR = 170,
    EQUALS = 171,
    STRICTEQUALS = 172,
    LESSTHAN = 173,
    LESSEQUALS = 174,
    GREATERTHAN = 175,
    GREATEREQUALS = 176,
    INSTANCEOF = 177,
    ISTYPE = 178,
    ISTYPELATE = 179,
    IN = 180,
    UNUSED_B5 = 181,
    UNUSED_B6 = 182,
    UNUSED_B7 = 183,
    UNUSED_B8 = 184,
    UNUSED_B9 = 185,
    UNUSED_BA = 186,
    UNUSED_BB = 187,
    UNUSED_BC = 188,
    UNUSED_BD = 189,
    UNUSED_BE = 190,
    UNUSED_BF = 191,
    INCREMENT_I = 192,
    DECREMENT_I = 193,
    INCLOCAL_I = 194,
    DECLOCAL_I = 195,
    NEGATE_I = 196,
    ADD_I = 197,
    SUBTRACT_I = 198,
    MULTIPLY_I = 199,
    UNUSED_C8 = 200,
    UNUSED_C9 = 201,
    UNUSED_CA = 202,
    UNUSED_CB = 203,
    UNUSED_CC = 204,
    UNUSED_CD = 205,
    UNUSED_CE = 206,
    UNUSED_CF = 207,
    GETLOCAL0 = 208,
    GETLOCAL1 = 209,
    GETLOCAL2 = 210,
    GETLOCAL3 = 211,
    SETLOCAL0 = 212,
    SETLOCAL1 = 213,
    SETLOCAL2 = 214,
    SETLOCAL3 = 215,
    UNUSED_D8 = 216,
    UNUSED_D9 = 217,
    UNUSED_DA = 218,
    UNUSED_DB = 219,
    UNUSED_DC = 220,
    UNUSED_DD = 221,
    UNUSED_DE = 222,
    UNUSED_DF = 223,
    UNUSED_E0 = 224,
    UNUSED_E1 = 225,
    UNUSED_E2 = 226,
    UNUSED_E3 = 227,
    UNUSED_E4 = 228,
    UNUSED_E5 = 229,
    UNUSED_E6 = 230,
    UNUSED_E7 = 231,
    UNUSED_E8 = 232,
    UNUSED_E9 = 233,
    UNUSED_EA = 234,
    UNUSED_EB = 235,
    UNUSED_EC = 236,
    UNUSED_ED = 237,
    UNUSED_EE = 238,
    INVALID = 237,
    DEBUG = 239,
    DEBUGLINE = 240,
    DEBUGFILE = 241,
    BKPTLINE = 242,
    TIMESTAMP = 243,
    RESTARGC = 244,
    RESTARG = 245,
    UNUSED_F6 = 246,
    UNUSED_F7 = 247,
    UNUSED_F8 = 248,
    UNUSED_F9 = 249,
    UNUSED_FA = 250,
    UNUSED_FB = 251,
    UNUSED_FC = 252,
    UNUSED_FD = 253,
    UNUSED_FE = 254,
    END = 255
}
export declare let BytecodeName: typeof Bytecode;
export declare function compile(methodInfo: MethodInfo): string | {
    names: Multiname[];
    compiled: any;
};
export declare class Context {
    private readonly mi;
    private readonly savedScope;
    private readonly sec;
    private readonly abc;
    private readonly names;
    private readonly jsGlobal;
    private readonly axCoerceString;
    constructor(mi: MethodInfo, savedScope: Scope, names: Multiname[]);
    call(value: any, obj: any, pp: any): any;
    getdefinitionbyname(scope: any, obj: any, pp: any): AXClass;
    getproperty(mn: any, obj: any): any;
    getpropertydyn(mn: any, obj: any): any;
    setproperty(mn: any, value: any, obj: any): any;
    deleteproperty(name: any, obj: any): any;
    construct(obj: any, pp: any): any;
    constructprop(mn: any, obj: any, pp: any): any;
    pushwith(scope: any, obj: any): any;
    hasnext2(obj: any, name: any): (number | import("./run/AXObject").AXObject)[];
    runtimename(name: any, index: any): number | Multiname;
}
