import { AXSecurityDomain } from "../run/AXSecurityDomain";
import { AXClass } from '../run/AXClass';
/**
 * Other natives can live in this module
 */
export declare var Natives: {
    print: (sec: AXSecurityDomain, expression: any, arg1?: any, arg2?: any, arg3?: any, arg4?: any) => void;
    debugBreak: (v: any) => void;
    bugzilla: (_: AXSecurityDomain, n: any) => boolean;
    decodeURI: (sec: AXSecurityDomain, encodedURI: string) => string;
    decodeURIComponent: (sec: AXSecurityDomain, encodedURI: string) => string;
    encodeURI: (sec: AXSecurityDomain, uri: string) => string;
    encodeURIComponent: (sec: AXSecurityDomain, uri: string) => string;
    isNaN: (sec: any, ...args: any[]) => any;
    isFinite: (sec: any, ...args: any[]) => any;
    parseInt: (sec: any, ...args: any[]) => any;
    parseFloat: (sec: any, ...args: any[]) => any;
    escape: (sec: any, ...args: any[]) => any;
    unescape: (sec: any, ...args: any[]) => any;
    isXMLName: () => boolean;
    notImplemented: (sec: any, ...args: any[]) => any;
    /**
     * Returns the fully qualified class name of an object.
     */
    getQualifiedClassName(_: AXSecurityDomain, value: any): string;
    /**
     * Returns the fully qualified class name of the base class of the object specified by the
     * |value| parameter.
     */
    getQualifiedSuperclassName(sec: AXSecurityDomain, value: any): any;
    /**
     * Returns the class with the specified name, or |null| if no such class exists.
     */
    getDefinitionByName(sec: AXSecurityDomain, name: string): AXClass;
    describeType(sec: AXSecurityDomain, value: any, flags: number): any;
    describeTypeJSON(sec: AXSecurityDomain, value: any, flags: number): any;
    getArgv(): any[];
};
