import { ASXML } from "./xml";
import { ASObject } from "../nat/ASObject";
export declare class IME extends ASObject {
    constructor();
    static get enabled(): boolean;
    static set enabled(enabled: boolean);
    static get conversionMode(): string;
    static set conversionMode(mode: string);
    static setCompositionString(composition: string): void;
    static doConversion(): void;
    static compositionSelectionChanged(start: number, end: number): void;
    static compositionAbandoned(): void;
    static get isSupported(): boolean;
}
export declare class System extends ASObject {
    private static _useCodePage;
    static classInitializer(): void;
    static get ime(): IME;
    static setClipboard(string: string): void;
    static get totalMemoryNumber(): number;
    static get freeMemory(): number;
    static get privateMemory(): number;
    static get useCodePage(): boolean;
    static set useCodePage(value: boolean);
    static get vmVersion(): string;
    static pause(): void;
    static resume(): void;
    static exit(code: number): void;
    static gc(): void;
    static pauseForGCIfCollectionImminent(imminence?: number): void;
    static disposeXML(node: ASXML): void;
    static get swfVersion(): number;
    static get apiVersion(): number;
    static getArgv(): any[];
    static getRunmode(): string;
}
export declare var OriginalSystem: typeof System;
export declare function initSystem(): void;
