import { ISecurityDomain } from "../nat/ISecurityDomain";
import { ABCFile } from "../abc/lazy/ABCFile";
import { ScriptInfo } from "../abc/lazy/ScriptInfo";
import { Multiname } from "../abc/lazy/Multiname";
import { AXSecurityDomain } from "./AXSecurityDomain";
import { AXGlobal } from "./AXGlobal";
import { AXClass } from "./AXClass";
import { AXObject } from "./AXObject";
/**
 * All code lives within an application domain.
 */
export declare class AXApplicationDomain {
    /**
     * All application domains have a reference to the root, or system application domain.
     */
    system: AXApplicationDomain;
    /**
     * Parent application domain.
     */
    parent: AXApplicationDomain;
    sec: ISecurityDomain;
    private _abcs;
    private _binarySymbols;
    constructor(sec: AXSecurityDomain, parent: AXApplicationDomain);
    addBinarySymbol(symbol: any): void;
    getBinarySymbol(className: string): any;
    loadABC(abc: ABCFile): void;
    loadAndExecuteABC(abc: ABCFile): void;
    executeABC(abc: ABCFile): void;
    findClassInfo(name: string): any;
    executeScript(scriptInfo: ScriptInfo): void;
    findProperty(mn: Multiname, strict: boolean, execute: boolean): AXGlobal;
    getClass(mn: Multiname): AXClass;
    getProperty(mn: Multiname, strict: boolean, execute: boolean): AXObject;
    findDefiningScript(mn: Multiname, execute: boolean): ScriptInfo;
    private _findDefiningScriptInABC;
}
