/*
 * Copyright 2013 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License"),
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { release } from "./utilities/Debug";
var SwfTagCodeNames = ["CODE_END", "CODE_SHOW_FRAME", "CODE_DEFINE_SHAPE", "CODE_FREE_CHARACTER", "CODE_PLACE_OBJECT", "CODE_REMOVE_OBJECT", "CODE_DEFINE_BITS", "CODE_DEFINE_BUTTON", "CODE_JPEG_TABLES", "CODE_SET_BACKGROUND_COLOR", "CODE_DEFINE_FONT", "CODE_DEFINE_TEXT", "CODE_DO_ACTION", "CODE_DEFINE_FONT_INFO", "CODE_DEFINE_SOUND", "CODE_START_SOUND", "CODE_STOP_SOUND", "CODE_DEFINE_BUTTON_SOUND", "CODE_SOUND_STREAM_HEAD", "CODE_SOUND_STREAM_BLOCK", "CODE_DEFINE_BITS_LOSSLESS", "CODE_DEFINE_BITS_JPEG2", "CODE_DEFINE_SHAPE2", "CODE_DEFINE_BUTTON_CXFORM", "CODE_PROTECT", "CODE_PATHS_ARE_POSTSCRIPT", "CODE_PLACE_OBJECT2", "INVALID", "CODE_REMOVE_OBJECT2", "CODE_SYNC_FRAME", "INVALID", "CODE_FREE_ALL", "CODE_DEFINE_SHAPE3", "CODE_DEFINE_TEXT2", "CODE_DEFINE_BUTTON2", "CODE_DEFINE_BITS_JPEG3", "CODE_DEFINE_BITS_LOSSLESS2", "CODE_DEFINE_EDIT_TEXT", "CODE_DEFINE_VIDEO", "CODE_DEFINE_SPRITE", "CODE_NAME_CHARACTER", "CODE_PRODUCT_INFO", "CODE_DEFINE_TEXT_FORMAT", "CODE_FRAME_LABEL", "CODE_DEFINE_BEHAVIOUR", "CODE_SOUND_STREAM_HEAD2", "CODE_DEFINE_MORPH_SHAPE", "CODE_GENERATE_FRAME", "CODE_DEFINE_FONT2", "CODE_GEN_COMMAND", "CODE_DEFINE_COMMAND_OBJECT", "CODE_CHARACTER_SET", "CODE_EXTERNAL_FONT", "CODE_DEFINE_FUNCTION", "CODE_PLACE_FUNCTION", "CODE_GEN_TAG_OBJECTS", "CODE_EXPORT_ASSETS", "CODE_IMPORT_ASSETS", "CODE_ENABLE_DEBUGGER", "CODE_DO_INIT_ACTION", "CODE_DEFINE_VIDEO_STREAM", "CODE_VIDEO_FRAME", "CODE_DEFINE_FONT_INFO2", "CODE_DEBUG_ID", "CODE_ENABLE_DEBUGGER2", "CODE_SCRIPT_LIMITS", "CODE_SET_TAB_INDEX", "CODE_DEFINE_SHAPE4", "INVALID", "CODE_FILE_ATTRIBUTES", "CODE_PLACE_OBJECT3", "CODE_IMPORT_ASSETS2", "CODE_DO_ABC_DEFINE", "CODE_DEFINE_FONT_ALIGN_ZONES", "CODE_CSM_TEXT_SETTINGS", "CODE_DEFINE_FONT3", "CODE_SYMBOL_CLASS", "CODE_METADATA", "CODE_DEFINE_SCALING_GRID", "INVALID", "INVALID", "INVALID", "CODE_DO_ABC", "CODE_DEFINE_SHAPE4", "CODE_DEFINE_MORPH_SHAPE2", "INVALID", "CODE_DEFINE_SCENE_AND_FRAME_LABEL_DATA", "CODE_DEFINE_BINARY_DATA", "CODE_DEFINE_FONT_NAME", "CODE_START_SOUND2", "CODE_DEFINE_BITS_JPEG4", "CODE_DEFINE_FONT4", "CODE_TELEMETRY"];
export function getSwfTagCodeName(tagCode) {
    return release ? "SwfTagCode: " + tagCode : SwfTagCodeNames[tagCode];
}
export var DefinitionTags;
(function (DefinitionTags) {
    DefinitionTags[DefinitionTags["CODE_DEFINE_SHAPE"] = 2] = "CODE_DEFINE_SHAPE";
    DefinitionTags[DefinitionTags["CODE_DEFINE_BITS"] = 6] = "CODE_DEFINE_BITS";
    DefinitionTags[DefinitionTags["CODE_DEFINE_BUTTON"] = 7] = "CODE_DEFINE_BUTTON";
    DefinitionTags[DefinitionTags["CODE_DEFINE_FONT"] = 10] = "CODE_DEFINE_FONT";
    DefinitionTags[DefinitionTags["CODE_DEFINE_TEXT"] = 11] = "CODE_DEFINE_TEXT";
    DefinitionTags[DefinitionTags["CODE_DEFINE_SOUND"] = 14] = "CODE_DEFINE_SOUND";
    DefinitionTags[DefinitionTags["CODE_DEFINE_BITS_LOSSLESS"] = 20] = "CODE_DEFINE_BITS_LOSSLESS";
    DefinitionTags[DefinitionTags["CODE_DEFINE_BITS_JPEG2"] = 21] = "CODE_DEFINE_BITS_JPEG2";
    DefinitionTags[DefinitionTags["CODE_DEFINE_SHAPE2"] = 22] = "CODE_DEFINE_SHAPE2";
    DefinitionTags[DefinitionTags["CODE_DEFINE_SHAPE3"] = 32] = "CODE_DEFINE_SHAPE3";
    DefinitionTags[DefinitionTags["CODE_DEFINE_TEXT2"] = 33] = "CODE_DEFINE_TEXT2";
    DefinitionTags[DefinitionTags["CODE_DEFINE_BUTTON2"] = 34] = "CODE_DEFINE_BUTTON2";
    DefinitionTags[DefinitionTags["CODE_DEFINE_BITS_JPEG3"] = 35] = "CODE_DEFINE_BITS_JPEG3";
    DefinitionTags[DefinitionTags["CODE_DEFINE_BITS_LOSSLESS2"] = 36] = "CODE_DEFINE_BITS_LOSSLESS2";
    DefinitionTags[DefinitionTags["CODE_DEFINE_EDIT_TEXT"] = 37] = "CODE_DEFINE_EDIT_TEXT";
    DefinitionTags[DefinitionTags["CODE_DEFINE_SPRITE"] = 39] = "CODE_DEFINE_SPRITE";
    DefinitionTags[DefinitionTags["CODE_DEFINE_MORPH_SHAPE"] = 46] = "CODE_DEFINE_MORPH_SHAPE";
    DefinitionTags[DefinitionTags["CODE_DEFINE_FONT2"] = 48] = "CODE_DEFINE_FONT2";
    DefinitionTags[DefinitionTags["CODE_DEFINE_VIDEO_STREAM"] = 60] = "CODE_DEFINE_VIDEO_STREAM";
    DefinitionTags[DefinitionTags["CODE_DEFINE_FONT3"] = 75] = "CODE_DEFINE_FONT3";
    DefinitionTags[DefinitionTags["CODE_DEFINE_SHAPE4"] = 83] = "CODE_DEFINE_SHAPE4";
    DefinitionTags[DefinitionTags["CODE_DEFINE_MORPH_SHAPE2"] = 84] = "CODE_DEFINE_MORPH_SHAPE2";
    DefinitionTags[DefinitionTags["CODE_DEFINE_BINARY_DATA"] = 87] = "CODE_DEFINE_BINARY_DATA";
    DefinitionTags[DefinitionTags["CODE_DEFINE_BITS_JPEG4"] = 90] = "CODE_DEFINE_BITS_JPEG4";
    DefinitionTags[DefinitionTags["CODE_DEFINE_FONT4"] = 91] = "CODE_DEFINE_FONT4";
})(DefinitionTags || (DefinitionTags = {}));
export var ImageDefinitionTags;
(function (ImageDefinitionTags) {
    ImageDefinitionTags[ImageDefinitionTags["CODE_DEFINE_BITS"] = 6] = "CODE_DEFINE_BITS";
    ImageDefinitionTags[ImageDefinitionTags["CODE_DEFINE_BITS_JPEG2"] = 21] = "CODE_DEFINE_BITS_JPEG2";
    ImageDefinitionTags[ImageDefinitionTags["CODE_DEFINE_BITS_JPEG3"] = 35] = "CODE_DEFINE_BITS_JPEG3";
    ImageDefinitionTags[ImageDefinitionTags["CODE_DEFINE_BITS_JPEG4"] = 90] = "CODE_DEFINE_BITS_JPEG4";
})(ImageDefinitionTags || (ImageDefinitionTags = {}));
export var FontDefinitionTags;
(function (FontDefinitionTags) {
    FontDefinitionTags[FontDefinitionTags["CODE_DEFINE_FONT"] = 10] = "CODE_DEFINE_FONT";
    FontDefinitionTags[FontDefinitionTags["CODE_DEFINE_FONT2"] = 48] = "CODE_DEFINE_FONT2";
    FontDefinitionTags[FontDefinitionTags["CODE_DEFINE_FONT3"] = 75] = "CODE_DEFINE_FONT3";
    FontDefinitionTags[FontDefinitionTags["CODE_DEFINE_FONT4"] = 91] = "CODE_DEFINE_FONT4";
})(FontDefinitionTags || (FontDefinitionTags = {}));
export var ControlTags;
(function (ControlTags) {
    ControlTags[ControlTags["CODE_PLACE_OBJECT"] = 4] = "CODE_PLACE_OBJECT";
    ControlTags[ControlTags["CODE_PLACE_OBJECT2"] = 26] = "CODE_PLACE_OBJECT2";
    ControlTags[ControlTags["CODE_PLACE_OBJECT3"] = 70] = "CODE_PLACE_OBJECT3";
    ControlTags[ControlTags["CODE_REMOVE_OBJECT"] = 5] = "CODE_REMOVE_OBJECT";
    ControlTags[ControlTags["CODE_REMOVE_OBJECT2"] = 28] = "CODE_REMOVE_OBJECT2";
    ControlTags[ControlTags["CODE_START_SOUND"] = 15] = "CODE_START_SOUND";
    ControlTags[ControlTags["CODE_START_SOUND2"] = 89] = "CODE_START_SOUND2";
    ControlTags[ControlTags["CODE_VIDEO_FRAME"] = 61] = "CODE_VIDEO_FRAME";
})(ControlTags || (ControlTags = {}));
