import { Cache } from "./Cache";
import { ImageType } from "../utilities";
export declare function RGBAToARGB(rgba: number): number;
export declare function ARGBToRGBA(argb: number): number;
export declare function rgbaToCSSStyle(rgba: number): string;
export declare function cssStyleToRGBA(style: string): any;
export declare function hexToRGB(color: string): number;
export declare function rgbToHex(color: number): string;
export declare function isValidHexColor(value: any): boolean;
export declare function clampByte(value: number): number;
/**
 * Unpremultiplies the given |pARGB| color value.
 */
export declare function unpremultiplyARGB(pARGB: number): number;
/**
 * Premultiplies the given |pARGB| color value.
 */
export declare function premultiplyARGB(uARGB: number): number;
/**
 * Make sure to call this before using the |unpremultiplyARGBUsingTableLookup| or
 * |premultiplyARGBUsingTableLookup| functions. We want to execute this lazily so
 * we don't incur any startup overhead.
 */
export declare function ensureUnpremultiplyTable(): void;
export declare function getUnpremultiplyTable(): Uint8Array;
export declare function tableLookupUnpremultiplyARGB(pARGB: any): number;
export declare function blendPremultipliedBGRA(tpBGRA: number, spBGRA: number): number;
export declare function convertImage(sourceFormat: ImageType, targetFormat: ImageType, source: Int32Array, target: Int32Array): void;
export declare let ColorUtilitites: {
    RGBAToARGB: typeof RGBAToARGB;
    ARGBToRGBA: typeof ARGBToRGBA;
    cssStyleToRGBACache: Cache;
    rgbaToCSSStyle: typeof rgbaToCSSStyle;
    cssStyleToRGBA: typeof cssStyleToRGBA;
    hexToRGB: typeof hexToRGB;
    rgbToHex: typeof rgbToHex;
    isValidHexColor: typeof isValidHexColor;
    clampByte: typeof clampByte;
    unpremultiplyARGB: typeof unpremultiplyARGB;
    premultiplyARGB: typeof premultiplyARGB;
    premultiplyTable: Uint8Array;
    unpremultiplyTable: Uint8Array;
    ensureUnpremultiplyTable: typeof ensureUnpremultiplyTable;
    getUnpremultiplyTable: typeof getUnpremultiplyTable;
    tableLookupUnpremultiplyARGB: typeof tableLookupUnpremultiplyARGB;
    blendPremultipliedBGRA: typeof blendPremultipliedBGRA;
    convertImage: typeof convertImage;
};
