export declare var i8: Int8Array;
export declare var u8: Uint8Array;
export declare var i32: Int32Array;
export declare var f32: Float32Array;
export declare var f64: Float64Array;
export declare var nativeLittleEndian: boolean;
declare global {
    interface Math {
        clz32(value: number): number;
        imul(value1: number, value2: number): number;
    }
}
/**
 * Convert a float into 32 bits.
 */
export declare function floatToInt32(v: number): number;
/**
 * Convert 32 bits into a float.
 */
export declare function int32ToFloat(i: number): number;
/**
 * Swap the bytes of a 16 bit number.
 */
export declare function swap16(i: number): number;
/**
 * Swap the bytes of a 32 bit number.
 */
export declare function swap32(i: number): number;
/**
 * Converts a number to s8.u8 fixed point representation.
 */
export declare function toS8U8(v: number): number;
/**
 * Converts a number from s8.u8 fixed point representation.
 */
export declare function fromS8U8(i: number): number;
/**
 * Round trips a number through s8.u8 conversion.
 */
export declare function clampS8U8(v: number): number;
/**
 * Converts a number to signed 16 bits.
 */
export declare function toS16(v: number): number;
export declare function bitCount(i: number): number;
export declare function ones(i: number): number;
export declare function trailingZeros(i: number): number;
export declare function getFlags(i: number, flags: string[]): string;
export declare function isPowerOfTwo(x: number): boolean;
export declare function roundToMultipleOfFour(x: number): number;
export declare function nearestPowerOfTwo(x: number): number;
export declare function roundToMultipleOfPowerOfTwo(i: number, powerOfTwo: number): number;
export declare function toHEX(i: number): string;
export declare let IntegerUtilities: {
    i8: Int8Array;
    u8: Uint8Array;
    i32: Int32Array;
    f32: Float32Array;
    f64: Float64Array;
    nativeLittleEndian: boolean;
    floatToInt32: typeof floatToInt32;
    int32ToFloat: typeof int32ToFloat;
    swap16: typeof swap16;
    swap32: typeof swap32;
    toS8U8: typeof toS8U8;
    fromS8U8: typeof fromS8U8;
    clampS8U8: typeof clampS8U8;
    toS16: typeof toS16;
    bitCount: typeof bitCount;
    ones: typeof ones;
    trailingZeros: typeof trailingZeros;
    getFlags: typeof getFlags;
    isPowerOfTwo: typeof isPowerOfTwo;
    roundToMultipleOfFour: typeof roundToMultipleOfFour;
    nearestPowerOfTwo: typeof nearestPowerOfTwo;
    roundToMultipleOfPowerOfTwo: typeof roundToMultipleOfPowerOfTwo;
    toHEX: typeof toHEX;
};
