export declare function pow2(exponent: number): number;
export declare function clamp(value: number, min: number, max: number): number;
/**
 * Rounds *.5 to the nearest even number.
 * See https://en.wikipedia.org/wiki/Rounding#Round_half_to_even for details.
 */
export declare function roundHalfEven(value: number): number;
/**
 * Rounds *.5 up on even occurrences, down on odd occurrences.
 * See https://en.wikipedia.org/wiki/Rounding#Alternating_tie-breaking for details.
 */
export declare function altTieBreakRound(value: number, even: boolean): number;
export declare function epsilonEquals(value: number, other: number): boolean;
export declare let NumberUtilities: {
    pow2: typeof pow2;
    clamp: typeof clamp;
    roundHalfEven: typeof roundHalfEven;
    altTieBreakRound: typeof altTieBreakRound;
    epsilonEquals: typeof epsilonEquals;
};
