import { MapObject } from "../utilities";
export declare function boxValue(value: any): any;
export declare function toKeyValueArray(object: Object): any[];
export declare function isPrototypeWriteable(object: Object): boolean;
export declare function hasOwnProperty(object: Object, name: string): boolean;
export declare function propertyIsEnumerable(object: Object, name: string): boolean;
/**
 * Returns a property descriptor for the own or inherited property with the given name, or
 * null if one doesn't exist.
 */
export declare function getPropertyDescriptor(object: Object, name: string): PropertyDescriptor;
export declare function hasOwnGetter(object: Object, name: string): boolean;
export declare function getOwnGetter(object: Object, name: string): () => any;
export declare function hasOwnSetter(object: Object, name: string): boolean;
export declare function createMap<T>(): MapObject<T>;
export declare function createArrayMap<T>(): MapObject<T>;
export declare function defineReadOnlyProperty(object: Object, name: string, value: any): void;
export declare function copyProperties(object: Object, template: Object): void;
export declare function copyOwnProperties(object: Object, template: Object): void;
export declare function copyOwnPropertyDescriptors(object: Object, template: Object, filter?: (name: string) => boolean, overwrite?: boolean, makeWritable?: boolean): void;
export declare function copyPropertiesByList(object: Object, template: Object, propertyList: string[]): void;
export declare function defineNonEnumerableGetter(obj: any, name: any, getter: any): void;
export declare function defineNonEnumerableProperty(obj: any, name: any, value: any): void;
export declare let ObjectUtilities: {
    boxValue: typeof boxValue;
    toKeyValueArray: typeof toKeyValueArray;
    isPrototypeWriteable: typeof isPrototypeWriteable;
    hasOwnProperty: typeof hasOwnProperty;
    propertyIsEnumerable: typeof propertyIsEnumerable;
    getPropertyDescriptor: typeof getPropertyDescriptor;
    hasOwnGetter: typeof hasOwnGetter;
    getOwnGetter: typeof getOwnGetter;
    hasOwnSetter: typeof hasOwnSetter;
    createArrayMap: typeof createArrayMap;
    createMap: typeof createMap;
    defineReadOnlyProperty: typeof defineReadOnlyProperty;
    copyProperties: typeof copyProperties;
    copyOwnProperties: typeof copyOwnProperties;
    copyOwnPropertyDescriptors: typeof copyOwnPropertyDescriptors;
    copyPropertiesByList: typeof copyPropertiesByList;
    defineNonEnumerableGetter: typeof defineNonEnumerableGetter;
    defineNonEnumerableProperty: typeof defineNonEnumerableProperty;
};
