export declare function repeatString(c: string, n: number): string;
export declare function memorySizeToString(value: number): string;
/**
 * Returns a reasonably sized description of the |value|, to be used for debugging purposes.
 */
export declare function toSafeString(value: any): string;
export declare function toSafeArrayString(array: any): string;
export declare function utf8decode(str: string): Uint8Array;
export declare function utf8encode(bytes: Uint8Array): string;
export declare function base64EncodeBytes(bytes: Uint8Array): string;
/**
 * Decodes the result of encoding with base64EncodeBytes, but not necessarily any other
 * base64-encoded data. Note that this also doesn't do any error checking.
 */
export declare function decodeRestrictedBase64ToBytes(encoded: string): Uint8Array;
export declare function escapeString(str: string): string;
/**
 * Workaround for max stack size limit.
 */
export declare function fromCharCodeArray(buffer: Uint32Array): string;
declare global {
    interface Math {
        clz32(value: number): number;
    }
}
export declare function variableLengthEncodeInt32(n: any): string;
export declare function toEncoding(n: any): string;
export declare function fromEncoding(c: any): any;
export declare function variableLengthDecodeInt32(s: any): number;
export declare function trimMiddle(s: string, maxLength: number): string;
export declare function multiple(s: string, count: number): string;
export declare function indexOfAny(s: string, chars: string[], position: number): number;
/**
 * The concatN() functions concatenate multiple strings in a way that
 * avoids creating intermediate strings, unlike String.prototype.concat().
 *
 * Note that these functions don't have identical behaviour to using '+',
 * because they will ignore any arguments that are |undefined| or |null|.
 * This usually doesn't matter.
 */
export declare function concat3(s0: any, s1: any, s2: any): string;
export declare function concat4(s0: any, s1: any, s2: any, s3: any): string;
export declare function concat9(s0: any, s1: any, s2: any, s3: any, s4: any, s5: any, s6: any, s7: any, s8: any): string;
export declare let StringUtilities: {
    repeatString: typeof repeatString;
    memorySizeToString: typeof memorySizeToString;
    toSafeString: typeof toSafeString;
    toSafeArrayString: typeof toSafeArrayString;
    utf8decode: typeof utf8decode;
    utf8encode: typeof utf8encode;
    base64EncodeBytes: typeof base64EncodeBytes;
    base64DecodeMap: number[];
    base64DecodeMapOffset: number;
    base64EOF: number;
    decodeRestrictedBase64ToBytes: typeof decodeRestrictedBase64ToBytes;
    escapeString: typeof escapeString;
    fromCharCodeArray: typeof fromCharCodeArray;
    variableLengthEncodeInt32: typeof variableLengthEncodeInt32;
    toEncoding: typeof toEncoding;
    fromEncoding: typeof fromEncoding;
    variableLengthDecodeInt32: typeof variableLengthDecodeInt32;
    trimMiddle: typeof trimMiddle;
    multiple: typeof multiple;
    indexOfAny: typeof indexOfAny;
    _concat3array: any[];
    _concat4array: any[];
    _concat9array: any[];
    concat3: typeof concat3;
    concat4: typeof concat4;
    concat9: typeof concat9;
};
