import { DisplayObject } from "./DisplayObject";
import { Bounds } from "@awayjs/graphics";
import { BitmapSymbol, BitmapData } from './BitmapData';
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class Bitmap extends DisplayObject {
    static classInitializer: any;
    _symbol: BitmapSymbol;
    applySymbol(): void;
    static classSymbols: string[];
    static instanceSymbols: string[];
    constructor(bitmapData?: BitmapData, pixelSnapping?: string, smoothing?: boolean);
    _pixelSnapping: string;
    _smoothing: boolean;
    _bitmapData: BitmapData;
    get pixelSnapping(): string;
    set pixelSnapping(value: string);
    get smoothing(): boolean;
    set smoothing(value: boolean);
    get bitmapData(): BitmapData;
    set bitmapData(value: BitmapData);
    _getContentBounds(includeStrokes?: boolean): Bounds;
    _containsPointDirectly(localX: number, localY: number, globalX: number, globalY: number): boolean;
}
