import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: ColorCorrectionSupport
var ColorCorrectionSupport = /** @class */ (function (_super) {
    __extends(ColorCorrectionSupport, _super);
    function ColorCorrectionSupport() {
        return _super.call(this) || this;
    }
    // AS -> JS Bindings
    ColorCorrectionSupport.fromNumber = function (n) {
        switch (n) {
            case 0:
                return ColorCorrectionSupport.UNSUPPORTED;
            case 1:
                return ColorCorrectionSupport.DEFAULT_ON;
            case 2:
                return ColorCorrectionSupport.DEFAULT_OFF;
            default:
                return null;
        }
    };
    ColorCorrectionSupport.toNumber = function (value) {
        switch (value) {
            case ColorCorrectionSupport.UNSUPPORTED:
                return 0;
            case ColorCorrectionSupport.DEFAULT_ON:
                return 1;
            case ColorCorrectionSupport.DEFAULT_OFF:
                return 2;
            default:
                return -1;
        }
    };
    // Called whenever the class is initialized.
    ColorCorrectionSupport.classInitializer = null;
    // List of static symbols to link.
    ColorCorrectionSupport.classSymbols = null; // [];
    // List of instance symbols to link.
    ColorCorrectionSupport.instanceSymbols = null; // [];
    // JS -> AS Bindings
    ColorCorrectionSupport.UNSUPPORTED = "unsupported";
    ColorCorrectionSupport.DEFAULT_ON = "defaultOn";
    ColorCorrectionSupport.DEFAULT_OFF = "defaultOff";
    return ColorCorrectionSupport;
}(ASObject));
export { ColorCorrectionSupport };
