import { Rectangle } from "../geom/Rectangle";
import { DisplayObject } from "./DisplayObject";
import { AccessibilityImplementation } from "../accessibility/AccessibilityImplementation";
import { ContextMenu } from "../ui/ContextMenu";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class InteractiveObject extends DisplayObject {
    static classInitializer: any;
    constructor();
    protected _initializeFields(): void;
    _tabEnabled: boolean;
    _tabIndex: number;
    _focusRect: any;
    _mouseEnabled: boolean;
    _doubleClickEnabled: boolean;
    _accessibilityImplementation: AccessibilityImplementation;
    _softKeyboardInputAreaOfInterest: Rectangle;
    _needsSoftKeyboard: boolean;
    _contextMenu: ContextMenu;
    get tabEnabled(): boolean;
    set tabEnabled(enabled: boolean);
    get tabIndex(): number;
    set tabIndex(index: number);
    get focusRect(): any;
    /**
     * The given |focusRect| can be one of: |true|, |false| or |null|.
     */
    set focusRect(focusRect: any);
    get mouseEnabled(): boolean;
    set mouseEnabled(enabled: boolean);
    get doubleClickEnabled(): boolean;
    set doubleClickEnabled(enabled: boolean);
    get accessibilityImplementation(): AccessibilityImplementation;
    set accessibilityImplementation(value: AccessibilityImplementation);
    get softKeyboardInputAreaOfInterest(): Rectangle;
    set softKeyboardInputAreaOfInterest(value: Rectangle);
    get needsSoftKeyboard(): boolean;
    set needsSoftKeyboard(value: boolean);
    get contextMenu(): ContextMenu;
    set contextMenu(cm: ContextMenu);
    requestSoftKeyboard(): boolean;
}
