import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: InterpolationMethod
var InterpolationMethod = /** @class */ (function (_super) {
    __extends(InterpolationMethod, _super);
    function InterpolationMethod() {
        return _super.call(this) || this;
    }
    // AS -> JS Bindings
    InterpolationMethod.fromNumber = function (n) {
        switch (n) {
            case 0 /* RGB */:
                return InterpolationMethod.RGB;
            case 1 /* LinearRGB */:
                return InterpolationMethod.LINEAR_RGB;
            default:
                return null;
        }
    };
    InterpolationMethod.toNumber = function (value) {
        switch (value) {
            case InterpolationMethod.RGB:
                return 0 /* RGB */;
            case InterpolationMethod.LINEAR_RGB:
                return 1 /* LinearRGB */;
            default:
                return -1;
        }
    };
    InterpolationMethod.classInitializer = null;
    InterpolationMethod.classSymbols = null; // [];
    InterpolationMethod.instanceSymbols = null; // [];
    // JS -> AS Bindings
    InterpolationMethod.RGB = "rgb";
    InterpolationMethod.LINEAR_RGB = "linearRGB";
    return InterpolationMethod;
}(ASObject));
export { InterpolationMethod };
