import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: JointStyle
var JointStyle = /** @class */ (function (_super) {
    __extends(JointStyle, _super);
    function JointStyle() {
        return _super.call(this) || this;
    }
    // AS -> JS Bindings
    JointStyle.fromNumber = function (n) {
        switch (n) {
            case 0:
                return JointStyle.ROUND;
            case 1:
                return JointStyle.BEVEL;
            case 2:
                return JointStyle.MITER;
            default:
                return null;
        }
    };
    JointStyle.toNumber = function (value) {
        switch (value) {
            case JointStyle.ROUND:
                return 0;
            case JointStyle.BEVEL:
                return 1;
            case JointStyle.MITER:
                return 2;
            default:
                return -1;
        }
    };
    // Called whenever the class is initialized.
    JointStyle.classInitializer = null;
    // List of static symbols to link.
    JointStyle.classSymbols = null; // [];
    // List of instance symbols to link.
    JointStyle.instanceSymbols = null; // [];
    // JS -> AS Bindings
    JointStyle.ROUND = "round";
    JointStyle.BEVEL = "bevel";
    JointStyle.MITER = "miter";
    return JointStyle;
}(ASObject));
export { JointStyle };
