import { EventDispatcher } from "../events/EventDispatcher";
import { Loader } from "./Loader";
import { DisplayObject } from "./DisplayObject";
import { ByteArray } from "../../avm2/natives/byteArray";
import { UncaughtErrorEvents } from "../events/UncaughtErrorEvents";
import { AXClass } from "../../avm2/run/AXClass";
import { ApplicationDomain } from "../system/ApplicationDomain";
import { Symbol } from "../symbol";
import { SpriteSymbol } from "./Sprite";
import { AVM1Context } from '../../avm1/context';
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class LoaderInfo extends EventDispatcher {
    static classInitializer: any;
    static axClass: typeof LoaderInfo & AXClass;
    static CtorToken: {};
    constructor(token: Object);
    reset(): void;
    setFile(file: any): void;
    static getLoaderInfoByDefinition(object: Object): LoaderInfo;
    _url: string;
    _loaderUrl: string;
    _file: any;
    _bytesLoaded: number;
    _bytesTotal: number;
    _applicationDomain: ApplicationDomain;
    _parameters: Object;
    _allowCodeImport: boolean;
    _checkPolicyFile: boolean;
    _width: number;
    _height: number;
    _sharedEvents: EventDispatcher;
    _parentSandboxBridge: Object;
    _childSandboxBridge: Object;
    _loader: Loader;
    _content: DisplayObject;
    _bytes: ByteArray;
    _abcBlocksLoaded: number;
    _mappedSymbolsLoaded: number;
    _fontsLoaded: number;
    _uncaughtErrorEvents: UncaughtErrorEvents;
    /**
     * Use this to ignore any user code.
     */
    _allowCodeExecution: boolean;
    _dictionary: Symbol[];
    _avm1Context: AVM1Context;
    get loaderURL(): string;
    get url(): string;
    get isURLInaccessible(): boolean;
    get bytesLoaded(): number;
    get bytesTotal(): number;
    get applicationDomain(): ApplicationDomain;
    get app(): any;
    get swfVersion(): number;
    get actionScriptVersion(): number;
    get frameRate(): number;
    get width(): number;
    get height(): number;
    get contentType(): string;
    get sharedEvents(): EventDispatcher;
    get parentSandboxBridge(): Object;
    set parentSandboxBridge(door: Object);
    get childSandboxBridge(): Object;
    set childSandboxBridge(door: Object);
    get sameDomain(): boolean;
    get childAllowsParent(): boolean;
    get parentAllowsChild(): boolean;
    get loader(): Loader;
    get content(): DisplayObject;
    get bytes(): ByteArray;
    get parameters(): Object;
    get uncaughtErrorEvents(): UncaughtErrorEvents;
    getSymbolResolver(classDefinition: AXClass, symbolId: number): () => any;
    getSymbolById(id: number): Symbol;
    getRootSymbol(): SpriteSymbol;
    private _syncAVM1Attributes;
    getFrame(sprite: {
        frames: any[];
    }, index: number): any;
    private resolveClassSymbol;
}
export interface IRootElementService {
    pageUrl: string;
    swfUrl: string;
    loaderUrl: string;
}
