import { Graphics } from "./Graphics";
import { SymbolData } from "../symbol";
import { ISecurityDomain } from "../../avm2/nat/ISecurityDomain";
import { Bounds } from "../../base/utilities";
import { ShapeSymbol } from "./Shape";
import { LoaderInfo } from "./LoaderInfo";
import { DisplayObject } from "./DisplayObject";
import { AXClass } from '../../avm2/run/AXClass';
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class MorphShape extends DisplayObject {
    static classSymbols: string[];
    static instanceSymbols: string[];
    static axClass: typeof MorphShape & AXClass;
    static classInitializer: any;
    _symbol: MorphShapeSymbol;
    applySymbol(): void;
    constructor();
    _canHaveGraphics(): boolean;
    _getGraphics(): Graphics;
    get graphics(): Graphics;
    _containsPointDirectly(localX: number, localY: number, globalX: number, globalY: number): boolean;
}
export declare class MorphShapeSymbol extends ShapeSymbol {
    morphFillBounds: Bounds;
    morphLineBounds: Bounds;
    constructor(data: SymbolData, sec: ISecurityDomain);
    static FromData(data: any, loaderInfo: LoaderInfo): MorphShapeSymbol;
}
