import { DisplayObject } from "./DisplayObject";
import { Graphics } from "./Graphics";
import { DisplaySymbol, SymbolData } from "../symbol";
import { LoaderInfo } from "./LoaderInfo";
import { AXClass } from '../../avm2/run/AXClass';
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class Shape extends DisplayObject {
    static axClass: typeof Shape & AXClass;
    static classInitializer: any;
    _symbol: ShapeSymbol;
    applySymbol(): void;
    constructor();
    protected _initializeFields(): void;
    _canHaveGraphics(): boolean;
    _getGraphics(): Graphics;
    get graphics(): Graphics;
    _containsPointDirectly(localX: number, localY: number, globalX: number, globalY: number): boolean;
}
export declare class ShapeSymbol extends DisplaySymbol {
    graphics: Graphics;
    constructor(data: SymbolData, symbolClass: AXClass);
    static FromData(data: SymbolData, loaderInfo: LoaderInfo): ShapeSymbol;
    processRequires(dependencies: any[], loaderInfo: LoaderInfo): void;
}
