import { DisplayObjectContainer } from "./DisplayObjectContainer";
import { LoaderInfo } from "./LoaderInfo";
import { DisplaySymbol, SymbolData } from "../symbol";
import { FrameLabel } from "./FrameLabel";
import { HitTestingResult, HitTestingType, DisplayObject } from "./DisplayObject";
import { Rectangle } from "../geom/Rectangle";
import { Point } from "../geom/Point";
import { SoundTransform } from "../media/SoundTransform";
import { Graphics } from "./Graphics";
import { SWFFrame } from '../../../parsers/SWFFrame';
export declare class Sprite extends DisplayObjectContainer {
    static classInitializer: any;
    _symbol: SpriteSymbol;
    applySymbol(): void;
    static classSymbols: string[];
    static instanceSymbols: string[];
    constructor();
    protected _initializeFields(): void;
    private _buttonMode;
    private _dropTarget;
    private _hitArea;
    private _useHandCursor;
    private _dragMode;
    private _dragDeltaX;
    private _dragDeltaY;
    private _dragBounds;
    _hitTarget: Sprite;
    _addFrame(frame: SWFFrame): void;
    _initializeChildren(frame: SWFFrame): void;
    _processControlTags(tags: any[], backwards: boolean): void;
    _removeAnimatedChild(child: DisplayObject): void;
    _canHaveGraphics(): boolean;
    _getGraphics(): Graphics;
    get graphics(): Graphics;
    get buttonMode(): boolean;
    set buttonMode(value: boolean);
    get dropTarget(): DisplayObject;
    get hitArea(): Sprite;
    set hitArea(value: Sprite);
    get useHandCursor(): boolean;
    set useHandCursor(value: boolean);
    get soundTransform(): SoundTransform;
    set soundTransform(sndTransform: SoundTransform);
    /**
     * Returns the current mouse position relative to this object.
     */
    _getDragMousePosition(): Point;
    startDrag(lockCenter?: boolean, bounds?: Rectangle): void;
    stopDrag(): void;
    _updateDragState(dropTarget?: DisplayObject): void;
    startTouchDrag(touchPointID: number, lockCenter?: boolean, bounds?: Rectangle): void;
    stopTouchDrag(touchPointID: number): void;
    _containsPoint(globalX: number, globalY: number, localX: number, localY: number, testingType: HitTestingType, objects: DisplayObject[]): HitTestingResult;
    _containsPointDirectly(localX: number, localY: number, globalX: number, globalY: number): boolean;
}
export declare class SpriteSymbol extends DisplaySymbol {
    numFrames: number;
    frames: any[];
    labels: FrameLabel[];
    isRoot: boolean;
    avm1Name: string;
    loaderInfo: LoaderInfo;
    constructor(data: SymbolData, loaderInfo: LoaderInfo);
    static FromData(data: any, loaderInfo: LoaderInfo): SpriteSymbol;
}
