import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: StageAlign
var StageAlign = /** @class */ (function (_super) {
    __extends(StageAlign, _super);
    function StageAlign() {
        return _super.call(this) || this;
    }
    StageAlign.fromNumber = function (n) {
        if (n === 0) {
            return "";
        }
        var s = "";
        if (n & 1 /* Top */) {
            s += "T";
        }
        if (n & 2 /* Bottom */) {
            s += "B";
        }
        if (n & 4 /* Left */) {
            s += "L";
        }
        if (n & 8 /* Right */) {
            s += "R";
        }
        return s;
    };
    /**
     * Looks like the Flash player just searches for the "T", "B", "L", "R" characters and
     * maintains an internal bit field for alignment, for instance it's possible to set the
     * alignment value "TBLR" even though there is no enum for it.
     */
    StageAlign.toNumber = function (value) {
        var n = 0;
        value = value.toUpperCase();
        if (value.indexOf("T") >= 0) {
            n |= 1 /* Top */;
        }
        if (value.indexOf("B") >= 0) {
            n |= 2 /* Bottom */;
        }
        if (value.indexOf("L") >= 0) {
            n |= 4 /* Left */;
        }
        if (value.indexOf("R") >= 0) {
            n |= 8 /* Right */;
        }
        return n;
    };
    StageAlign.classInitializer = null;
    StageAlign.classSymbols = null; // [];
    StageAlign.instanceSymbols = null; // [];
    // JS -> AS Bindings
    StageAlign.TOP = "T";
    StageAlign.LEFT = "L";
    StageAlign.BOTTOM = "B";
    StageAlign.RIGHT = "R";
    StageAlign.TOP_LEFT = "TL";
    StageAlign.TOP_RIGHT = "TR";
    StageAlign.BOTTOM_LEFT = "BL";
    StageAlign.BOTTOM_RIGHT = "BR";
    return StageAlign;
}(ASObject));
export { StageAlign };
