import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: StageDisplayState
var StageDisplayState = /** @class */ (function (_super) {
    __extends(StageDisplayState, _super);
    function StageDisplayState() {
        return _super.call(this) || this;
    }
    // AS -> JS Bindings
    StageDisplayState.fromNumber = function (n) {
        switch (n) {
            case 0:
                return StageDisplayState.FULL_SCREEN;
            case 1:
                return StageDisplayState.FULL_SCREEN_INTERACTIVE;
            case 2:
                return StageDisplayState.NORMAL;
            default:
                return null;
        }
    };
    StageDisplayState.toNumber = function (value) {
        switch (value) {
            case StageDisplayState.FULL_SCREEN:
                return 0;
            case StageDisplayState.FULL_SCREEN_INTERACTIVE:
                return 1;
            case StageDisplayState.NORMAL:
                return 2;
            default:
                return -1;
        }
    };
    // Called whenever the class is initialized.
    StageDisplayState.classInitializer = null;
    // List of static symbols to link.
    StageDisplayState.classSymbols = null; // [];
    // List of instance symbols to link.
    StageDisplayState.instanceSymbols = null; // [];
    // JS -> AS Bindings
    StageDisplayState.FULL_SCREEN = "fullScreen";
    StageDisplayState.FULL_SCREEN_INTERACTIVE = "fullScreenInteractive";
    StageDisplayState.NORMAL = "normal";
    return StageDisplayState;
}(ASObject));
export { StageDisplayState };
