import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: StageQuality
var StageQuality = /** @class */ (function (_super) {
    __extends(StageQuality, _super);
    function StageQuality() {
        return _super.call(this) || this;
    }
    // AS -> JS Bindings
    StageQuality.fromNumber = function (n) {
        switch (n) {
            case 0:
                return StageQuality.LOW;
            case 1:
                return StageQuality.MEDIUM;
            case 2:
                return StageQuality.HIGH;
            case 3:
                return StageQuality.BEST;
            case 4:
                return StageQuality.HIGH_8X8;
            case 5:
                return StageQuality.HIGH_8X8_LINEAR;
            case 6:
                return StageQuality.HIGH_16X16;
            case 7:
                return StageQuality.HIGH_16X16_LINEAR;
            default:
                return null;
        }
    };
    StageQuality.toNumber = function (value) {
        switch (value) {
            case StageQuality.LOW:
                return 0;
            case StageQuality.MEDIUM:
                return 1;
            case StageQuality.HIGH:
                return 2;
            case StageQuality.BEST:
                return 3;
            case StageQuality.HIGH_8X8:
                return 4;
            case StageQuality.HIGH_8X8_LINEAR:
                return 5;
            case StageQuality.HIGH_16X16:
                return 6;
            case StageQuality.HIGH_16X16_LINEAR:
                return 7;
            default:
                return -1;
        }
    };
    // Called whenever the class is initialized.
    StageQuality.classInitializer = null;
    // List of static symbols to link.
    StageQuality.classSymbols = null; // [];
    // List of instance symbols to link.
    StageQuality.instanceSymbols = null; // [];
    // JS -> AS Bindings
    StageQuality.LOW = "low";
    StageQuality.MEDIUM = "medium";
    StageQuality.HIGH = "high";
    StageQuality.BEST = "best";
    StageQuality.HIGH_8X8 = "8x8";
    StageQuality.HIGH_8X8_LINEAR = "8x8linear";
    StageQuality.HIGH_16X16 = "16x16";
    StageQuality.HIGH_16X16_LINEAR = "16x16linear";
    return StageQuality;
}(ASObject));
export { StageQuality };
