import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: StageScaleMode
var StageScaleMode = /** @class */ (function (_super) {
    __extends(StageScaleMode, _super);
    function StageScaleMode() {
        return _super.call(this) || this;
    }
    // AS -> JS Bindings
    StageScaleMode.fromNumber = function (n) {
        switch (n) {
            case 0 /* ShowAll */:
                return StageScaleMode.SHOW_ALL;
            case 1 /* ExactFit */:
                return StageScaleMode.EXACT_FIT;
            case 2 /* NoBorder */:
                return StageScaleMode.NO_BORDER;
            case 4 /* NoScale */:
                return StageScaleMode.NO_SCALE;
            default:
                return null;
        }
    };
    StageScaleMode.toNumber = function (value) {
        switch (value.toLowerCase()) {
            case StageScaleMode.SHOW_ALL_LOWERCASE:
                return 0 /* ShowAll */;
            case StageScaleMode.EXACT_FIT_LOWERCASE:
                return 1 /* ExactFit */;
            case StageScaleMode.NO_BORDER_LOWERCASE:
                return 2 /* NoBorder */;
            case StageScaleMode.NO_SCALE_LOWERCASE:
                return 4 /* NoScale */;
            default:
                return -1;
        }
    };
    // Called whenever the class is initialized.
    StageScaleMode.classInitializer = null;
    // List of static symbols to link.
    StageScaleMode.classSymbols = null; // [];
    // List of instance symbols to link.
    StageScaleMode.instanceSymbols = null; // [];
    // JS -> AS Bindings
    StageScaleMode.SHOW_ALL = "showAll";
    StageScaleMode.EXACT_FIT = "exactFit";
    StageScaleMode.NO_BORDER = "noBorder";
    StageScaleMode.NO_SCALE = "noScale";
    StageScaleMode.SHOW_ALL_LOWERCASE = "showall";
    StageScaleMode.EXACT_FIT_LOWERCASE = "exactfit";
    StageScaleMode.NO_BORDER_LOWERCASE = "noborder";
    StageScaleMode.NO_SCALE_LOWERCASE = "noscale";
    return StageScaleMode;
}(ASObject));
export { StageScaleMode };
