import { __extends } from "tslib";
import { Event } from "./Event";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: HTTPStatusEvent
var HTTPStatusEvent = /** @class */ (function (_super) {
    __extends(HTTPStatusEvent, _super);
    function HTTPStatusEvent(type, bubbles, cancelable, status) {
        if (bubbles === void 0) { bubbles = false; }
        if (cancelable === void 0) { cancelable = false; }
        if (status === void 0) { status = 0; }
        var _this = _super.call(this, type, bubbles, cancelable) || this;
        _this._status = status | 0;
        return _this;
    }
    HTTPStatusEvent.prototype._setStatus = function (value) {
        this._status = value;
    };
    Object.defineProperty(HTTPStatusEvent.prototype, "status", {
        get: function () {
            return this._status;
        },
        enumerable: true,
        configurable: true
    });
    HTTPStatusEvent.prototype.clone = function () {
        return new HTTPStatusEvent(this.type, this.bubbles, this.cancelable, this.status);
    };
    HTTPStatusEvent.prototype.toString = function () {
        return this.formatToString('HTTPStatusEvent', 'type', 'bubbles', 'cancelable', 'eventPhase', 'status');
    };
    HTTPStatusEvent.classInitializer = null;
    HTTPStatusEvent.HTTP_STATUS = "httpStatus";
    HTTPStatusEvent.HTTP_RESPONSE_STATUS = "httpResponseStatus";
    return HTTPStatusEvent;
}(Event));
export { HTTPStatusEvent };
