import { Event } from "./Event";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class KeyboardEvent extends Event {
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    constructor(type: string, bubbles?: boolean, cancelable?: boolean, charCodeValue?: number, keyCodeValue?: number, keyLocationValue?: number, ctrlKeyValue?: boolean, altKeyValue?: boolean, shiftKeyValue?: boolean);
    static KEY_DOWN: string;
    static KEY_UP: string;
    private _charCode;
    private _keyCode;
    private _keyLocation;
    private _ctrlKey;
    private _altKey;
    private _shiftKey;
    get charCode(): number;
    set charCode(value: number);
    get keyCode(): number;
    set keyCode(value: number);
    get keyLocation(): number;
    set keyLocation(value: number);
    get ctrlKey(): boolean;
    set ctrlKey(value: boolean);
    get altKey(): boolean;
    set altKey(value: boolean);
    get shiftKey(): boolean;
    set shiftKey(value: boolean);
    clone(): Event;
    toString(): string;
    updateAfterEvent(): void;
}
