import { MouseEvent as MouseEventAway } from "@awayjs/scene";
import { Event } from "./Event";
import { InteractiveObject } from "../display/InteractiveObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class MouseEvent extends Event {
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    constructor(type: string, bubbles?: boolean, cancelable?: boolean, localX?: number, localY?: number, relatedObject?: InteractiveObject, ctrlKey?: boolean, altKey?: boolean, shiftKey?: boolean, buttonDown?: boolean, delta?: number);
    static CLICK: string;
    static DOUBLE_CLICK: string;
    static MOUSE_DOWN: string;
    static MOUSE_MOVE: string;
    static MOUSE_OUT: string;
    static MOUSE_OVER: string;
    static MOUSE_UP: string;
    static RELEASE_OUTSIDE: string;
    static MOUSE_WHEEL: string;
    static ROLL_OUT: string;
    static ROLL_OVER: string;
    static MIDDLE_CLICK: string;
    static MIDDLE_MOUSE_DOWN: string;
    static MIDDLE_MOUSE_UP: string;
    static RIGHT_CLICK: string;
    static RIGHT_MOUSE_DOWN: string;
    static RIGHT_MOUSE_UP: string;
    static CONTEXT_MENU: string;
    /**
     * AS3 mouse event names don't match DOM even names, so map them here.
     */
    static typeFromDOMType(name: string): string;
    fillFromAway(awayEvent: MouseEventAway): void;
    private _localX;
    private _localY;
    private _movementX;
    private _movementY;
    private _delta;
    private _position;
    private _ctrlKey;
    private _altKey;
    private _shiftKey;
    private _buttonDown;
    private _relatedObject;
    private _isRelatedObjectInaccessible;
    get localX(): number;
    set localX(value: number);
    get localY(): number;
    set localY(value: number);
    get stageX(): Number;
    get stageY(): Number;
    get movementX(): number;
    set movementX(value: number);
    get movementY(): number;
    set movementY(value: number);
    get delta(): number;
    set delta(value: number);
    get ctrlKey(): boolean;
    set ctrlKey(value: boolean);
    get altKey(): boolean;
    set altKey(value: boolean);
    get shiftKey(): boolean;
    set shiftKey(value: boolean);
    get buttonDown(): boolean;
    set buttonDown(value: boolean);
    get relatedObject(): InteractiveObject;
    set relatedObject(value: InteractiveObject);
    get isRelatedObjectInaccessible(): boolean;
    set isRelatedObjectInaccessible(value: boolean);
    updateAfterEvent(): void;
    private _getGlobalPoint;
    clone(): Event;
    toString(): string;
}
