import { BitmapFilter } from "./BitmapFilter";
import { Rectangle } from "../geom/Rectangle";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class BevelFilter extends BitmapFilter {
    static axClass: typeof BevelFilter;
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    static FromUntyped(obj: any): BevelFilter;
    constructor(distance?: number, angle?: number, highlightColor?: number, highlightAlpha?: number, shadowColor?: number, shadowAlpha?: number, blurX?: number, blurY?: number, strength?: number, quality?: number, type?: string, knockout?: boolean);
    _updateFilterBounds(bounds: Rectangle): void;
    private _distance;
    private _angle;
    private _highlightColor;
    private _highlightAlpha;
    private _shadowColor;
    private _shadowAlpha;
    private _blurX;
    private _blurY;
    private _knockout;
    private _quality;
    private _strength;
    private _type;
    get distance(): number;
    set distance(value: number);
    get angle(): number;
    set angle(value: number);
    get highlightColor(): number;
    set highlightColor(value: number);
    get highlightAlpha(): number;
    set highlightAlpha(value: number);
    get shadowColor(): number;
    set shadowColor(value: number);
    get shadowAlpha(): number;
    set shadowAlpha(value: number);
    get blurX(): number;
    set blurX(value: number);
    get blurY(): number;
    set blurY(value: number);
    get knockout(): boolean;
    set knockout(value: boolean);
    get quality(): number;
    set quality(value: number);
    get strength(): number;
    set strength(value: number);
    get type(): string;
    set type(value: string);
    clone(): BitmapFilter;
}
