import { Rectangle } from "../geom/Rectangle";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class BitmapFilter extends ASObject {
    static axClass: typeof BitmapFilter;
    static classInitializer: any;
    private static EPS;
    private static blurFilterStepWidths;
    static _updateBlurBounds(bounds: Rectangle, blurX: number, blurY: number, quality: number, isBlurFilter?: boolean): void;
    constructor();
    _updateFilterBounds(bounds: Rectangle): void;
    _serialize(message: any): void;
    clone(): BitmapFilter;
}
export declare class GradientArrays {
    static colors: any[];
    static alphas: any[];
    static ratios: any[];
    static sanitize(colors: any[], alphas: any[], ratios: any[]): void;
    static sanitizeColors(colors: number[], maxLen?: number): number[];
    static sanitizeAlphas(alphas: number[], maxLen?: number, minLen?: number, value?: number): number[];
    static sanitizeRatios(ratios: number[], maxLen?: number, minLen?: number, value?: number): number[];
    static initArray(len: number, value?: number): number[];
}
