import { BitmapFilter } from "./BitmapFilter";
import { Rectangle } from "../geom/Rectangle";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class BlurFilter extends BitmapFilter {
    static axClass: typeof BlurFilter;
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    static FromUntyped(obj: any): BlurFilter;
    constructor(blurX?: number, blurY?: number, quality?: number);
    _updateFilterBounds(bounds: Rectangle): void;
    _serialize(message: any): void;
    private _blurX;
    private _blurY;
    private _quality;
    get blurX(): number;
    set blurX(value: number);
    get blurY(): number;
    set blurY(value: number);
    get quality(): number;
    set quality(value: number);
    clone(): BitmapFilter;
}
