import { BitmapFilter } from "./BitmapFilter";
import { ASArray } from "../../avm2/nat/ASArray";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class ConvolutionFilter extends BitmapFilter {
    static axClass: typeof ConvolutionFilter;
    static classInitializer: any;
    static FromUntyped(obj: any): ConvolutionFilter;
    constructor(matrixX?: number, matrixY?: number, matrix?: ASArray, divisor?: number, bias?: number, preserveAlpha?: boolean, clamp?: boolean, color?: number, alpha?: number);
    private _expandArray;
    private _matrix;
    private _matrixX;
    private _matrixY;
    private _divisor;
    private _bias;
    private _preserveAlpha;
    private _clamp;
    private _color;
    private _alpha;
    get matrix(): ASArray;
    set matrix(value_: ASArray);
    get matrixX(): number;
    set matrixX(value: number);
    get matrixY(): number;
    set matrixY(value: number);
    get divisor(): number;
    set divisor(value: number);
    get bias(): number;
    set bias(value: number);
    get preserveAlpha(): boolean;
    set preserveAlpha(value: boolean);
    get clamp(): boolean;
    set clamp(value: boolean);
    get color(): number;
    set color(value: number);
    get alpha(): number;
    set alpha(value: number);
    clone(): BitmapFilter;
}
