import { BitmapFilter } from "./BitmapFilter";
import { Point } from "../geom/Point";
import { BitmapData } from "../display/BitmapData";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class DisplacementMapFilter extends BitmapFilter {
    static axClass: typeof DisplacementMapFilter;
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    static FromUntyped(obj: any): DisplacementMapFilter;
    constructor(mapBitmap?: BitmapData, mapPoint?: Point, componentX?: number, componentY?: number, scaleX?: number, scaleY?: number, mode?: string, color?: number, alpha?: number);
    private _mapBitmap;
    private _mapPoint;
    private _componentX;
    private _componentY;
    private _scaleX;
    private _scaleY;
    private _mode;
    private _color;
    private _alpha;
    get mapBitmap(): BitmapData;
    set mapBitmap(value: BitmapData);
    get mapPoint(): Point;
    set mapPoint(value: Point);
    get componentX(): number;
    set componentX(value: number);
    get componentY(): number;
    set componentY(value: number);
    get scaleX(): number;
    set scaleX(value: number);
    get scaleY(): number;
    set scaleY(value: number);
    get mode(): string;
    set mode(value: string);
    get color(): number;
    set color(value: number);
    get alpha(): number;
    set alpha(value: number);
    clone(): BitmapFilter;
}
