import { BitmapFilter } from "./BitmapFilter";
import { Rectangle } from "../geom/Rectangle";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class DropShadowFilter extends BitmapFilter {
    static axClass: typeof DropShadowFilter;
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    static FromUntyped(obj: any): DropShadowFilter;
    constructor(distance?: number, angle?: number, color?: number, alpha?: number, blurX?: number, blurY?: number, strength?: number, quality?: number, inner?: boolean, knockout?: boolean, hideObject?: boolean);
    _updateFilterBounds(bounds: Rectangle): void;
    private _distance;
    private _angle;
    private _color;
    private _alpha;
    private _blurX;
    private _blurY;
    private _hideObject;
    private _inner;
    private _knockout;
    private _quality;
    private _strength;
    get distance(): number;
    set distance(value: number);
    get angle(): number;
    set angle(value: number);
    get color(): number;
    set color(value: number);
    get alpha(): number;
    set alpha(value: number);
    get blurX(): number;
    set blurX(value: number);
    get blurY(): number;
    set blurY(value: number);
    get hideObject(): boolean;
    set hideObject(value: boolean);
    get inner(): boolean;
    set inner(value: boolean);
    get knockout(): boolean;
    set knockout(value: boolean);
    get quality(): number;
    set quality(value: number);
    get strength(): number;
    set strength(value: number);
    clone(): BitmapFilter;
}
