import { BitmapFilter } from "./BitmapFilter";
import { ASArray } from "../../avm2/nat/ASArray";
import { Rectangle } from "../geom/Rectangle";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class GradientGlowFilter extends BitmapFilter {
    static axClass: typeof GradientGlowFilter;
    static classInitializer: any;
    static FromUntyped(obj: any): GradientGlowFilter;
    constructor(distance?: number, angle?: number, colors?: ASArray, alphas?: ASArray, ratios?: ASArray, blurX?: number, blurY?: number, strength?: number, quality?: number, type?: string, knockout?: boolean);
    _updateFilterBounds(bounds: Rectangle): void;
    private _distance;
    private _angle;
    private _colors;
    private _alphas;
    private _ratios;
    private _blurX;
    private _blurY;
    private _knockout;
    private _quality;
    private _strength;
    private _type;
    get distance(): number;
    set distance(value: number);
    get angle(): number;
    set angle(value: number);
    get colors(): ASArray;
    set colors(value: ASArray);
    get alphas(): ASArray;
    set alphas(value: ASArray);
    get ratios(): ASArray;
    set ratios(value_: ASArray);
    get blurX(): number;
    set blurX(value: number);
    get blurY(): number;
    set blurY(value: number);
    get knockout(): boolean;
    set knockout(value: boolean);
    get quality(): number;
    set quality(value: number);
    get strength(): number;
    set strength(value: number);
    get type(): string;
    set type(value: string);
    clone(): BitmapFilter;
}
