import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class ColorTransform extends ASObject {
    static axClass: typeof ColorTransform;
    static classInitializer(): void;
    static classSymbols: string[];
    static instanceSymbols: string[];
    constructor(redMultiplier?: number, greenMultiplier?: number, blueMultiplier?: number, alphaMultiplier?: number, redOffset?: number, greenOffset?: number, blueOffset?: number, alphaOffset?: number);
    static FROZEN_IDENTITY_COLOR_TRANSFORM: ColorTransform;
    static TEMP_COLOR_TRANSFORM: ColorTransform;
    redMultiplier: number;
    greenMultiplier: number;
    blueMultiplier: number;
    alphaMultiplier: number;
    redOffset: number;
    greenOffset: number;
    blueOffset: number;
    alphaOffset: number;
    set native_redMultiplier(redMultiplier: number);
    get native_redMultiplier(): number;
    set native_greenMultiplier(greenMultiplier: number);
    get native_greenMultiplier(): number;
    set native_blueMultiplier(blueMultiplier: number);
    get native_blueMultiplier(): number;
    set native_alphaMultiplier(alphaMultiplier: number);
    get native_alphaMultiplier(): number;
    set native_redOffset(redOffset: number);
    get native_redOffset(): number;
    set native_greenOffset(greenOffset: number);
    get native_greenOffset(): number;
    set native_blueOffset(blueOffset: number);
    get native_blueOffset(): number;
    set native_alphaOffset(alphaOffset: number);
    get native_alphaOffset(): number;
    ColorTransform(redMultiplier?: number, greenMultiplier?: number, blueMultiplier?: number, alphaMultiplier?: number, redOffset?: number, greenOffset?: number, blueOffset?: number, alphaOffset?: number): void;
    get color(): number;
    set color(newColor: number);
    concat(second: ColorTransform): void;
    preMultiply(second: ColorTransform): void;
    copyFrom(sourceColorTransform: ColorTransform): void;
    copyFromUntyped(object: any): void;
    setTo(redMultiplier: number, greenMultiplier: number, blueMultiplier: number, alphaMultiplier: number, redOffset: number, greenOffset: number, blueOffset: number, alphaOffset: number): void;
    clone(): ColorTransform;
    convertToFixedPoint(): ColorTransform;
    equals(other: ColorTransform): boolean;
    toString(): string;
}
