import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
import { clampS8U8, toS16 } from "../../base/utilities/IntegerUtilities";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: ColorTransform
var ColorTransform = /** @class */ (function (_super) {
    __extends(ColorTransform, _super);
    // "blueMultiplier", "alphaMultiplier", "redOffset",
    // "greenOffset", "blueOffset", "alphaOffset",
    // "color", "color", "concat", "toString"];
    function ColorTransform(redMultiplier, greenMultiplier, blueMultiplier, alphaMultiplier, redOffset, greenOffset, blueOffset, alphaOffset) {
        if (redMultiplier === void 0) { redMultiplier = 1; }
        if (greenMultiplier === void 0) { greenMultiplier = 1; }
        if (blueMultiplier === void 0) { blueMultiplier = 1; }
        if (alphaMultiplier === void 0) { alphaMultiplier = 1; }
        if (redOffset === void 0) { redOffset = 0; }
        if (greenOffset === void 0) { greenOffset = 0; }
        if (blueOffset === void 0) { blueOffset = 0; }
        if (alphaOffset === void 0) { alphaOffset = 0; }
        var _this = _super.call(this) || this;
        _this.redMultiplier = +redMultiplier;
        _this.greenMultiplier = +greenMultiplier;
        _this.blueMultiplier = +blueMultiplier;
        _this.alphaMultiplier = +alphaMultiplier;
        _this.redOffset = +redOffset;
        _this.greenOffset = +greenOffset;
        _this.blueOffset = +blueOffset;
        _this.alphaOffset = +alphaOffset;
        return _this;
    }
    ColorTransform.classInitializer = function () {
        this.FROZEN_IDENTITY_COLOR_TRANSFORM = Object.freeze(this.axConstruct([]));
        this.TEMP_COLOR_TRANSFORM = this.axConstruct([]);
    };
    Object.defineProperty(ColorTransform.prototype, "native_redMultiplier", {
        get: function () {
            return this.redMultiplier;
        },
        set: function (redMultiplier) {
            this.redMultiplier = +redMultiplier;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorTransform.prototype, "native_greenMultiplier", {
        get: function () {
            return this.greenMultiplier;
        },
        set: function (greenMultiplier) {
            this.greenMultiplier = +greenMultiplier;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorTransform.prototype, "native_blueMultiplier", {
        get: function () {
            return this.blueMultiplier;
        },
        set: function (blueMultiplier) {
            this.blueMultiplier = +blueMultiplier;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorTransform.prototype, "native_alphaMultiplier", {
        get: function () {
            return this.alphaMultiplier;
        },
        set: function (alphaMultiplier) {
            this.alphaMultiplier = +alphaMultiplier;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorTransform.prototype, "native_redOffset", {
        get: function () {
            return this.redOffset;
        },
        set: function (redOffset) {
            this.redOffset = +redOffset;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorTransform.prototype, "native_greenOffset", {
        get: function () {
            return this.greenOffset;
        },
        set: function (greenOffset) {
            this.greenOffset = +greenOffset;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorTransform.prototype, "native_blueOffset", {
        get: function () {
            return this.blueOffset;
        },
        set: function (blueOffset) {
            this.blueOffset = +blueOffset;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ColorTransform.prototype, "native_alphaOffset", {
        get: function () {
            return this.alphaOffset;
        },
        set: function (alphaOffset) {
            this.alphaOffset = +alphaOffset;
        },
        enumerable: true,
        configurable: true
    });
    ColorTransform.prototype.ColorTransform = function (redMultiplier, greenMultiplier, blueMultiplier, alphaMultiplier, redOffset, greenOffset, blueOffset, alphaOffset) {
        if (redMultiplier === void 0) { redMultiplier = 1; }
        if (greenMultiplier === void 0) { greenMultiplier = 1; }
        if (blueMultiplier === void 0) { blueMultiplier = 1; }
        if (alphaMultiplier === void 0) { alphaMultiplier = 1; }
        if (redOffset === void 0) { redOffset = 0; }
        if (greenOffset === void 0) { greenOffset = 0; }
        if (blueOffset === void 0) { blueOffset = 0; }
        if (alphaOffset === void 0) { alphaOffset = 0; }
        this.redMultiplier = redMultiplier;
        this.greenMultiplier = greenMultiplier;
        this.blueMultiplier = blueMultiplier;
        this.alphaMultiplier = alphaMultiplier;
        this.redOffset = redOffset;
        this.greenOffset = greenOffset;
        this.blueOffset = blueOffset;
        this.alphaOffset = alphaOffset;
    };
    Object.defineProperty(ColorTransform.prototype, "color", {
        get: function () {
            return (this.redOffset << 16) | (this.greenOffset << 8) | this.blueOffset;
        },
        set: function (newColor) {
            this.redOffset = (newColor >> 16) & 0xff;
            this.greenOffset = (newColor >> 8) & 0xff;
            this.blueOffset = newColor & 0xff;
            this.redMultiplier = this.greenMultiplier = this.blueMultiplier = 1;
        },
        enumerable: true,
        configurable: true
    });
    ColorTransform.prototype.concat = function (second) {
        this.redMultiplier *= second.redMultiplier;
        this.greenMultiplier *= second.greenMultiplier;
        this.blueMultiplier *= second.blueMultiplier;
        this.alphaMultiplier *= second.alphaMultiplier;
        this.redOffset += second.redOffset;
        this.greenOffset += second.greenOffset;
        this.blueOffset += second.blueOffset;
        this.alphaOffset += second.alphaOffset;
    };
    ColorTransform.prototype.preMultiply = function (second) {
        this.redOffset += second.redOffset * this.redMultiplier;
        this.greenOffset += second.greenOffset * this.greenMultiplier;
        this.blueOffset += second.blueOffset * this.blueMultiplier;
        this.alphaOffset += second.alphaOffset * this.alphaMultiplier;
        this.redMultiplier *= second.redMultiplier;
        this.greenMultiplier *= second.greenMultiplier;
        this.blueMultiplier *= second.blueMultiplier;
        this.alphaMultiplier *= second.alphaMultiplier;
    };
    ColorTransform.prototype.copyFrom = function (sourceColorTransform) {
        this.redMultiplier = sourceColorTransform.redMultiplier;
        this.greenMultiplier = sourceColorTransform.greenMultiplier;
        this.blueMultiplier = sourceColorTransform.blueMultiplier;
        this.alphaMultiplier = sourceColorTransform.alphaMultiplier;
        this.redOffset = sourceColorTransform.redOffset;
        this.greenOffset = sourceColorTransform.greenOffset;
        this.blueOffset = sourceColorTransform.blueOffset;
        this.alphaOffset = sourceColorTransform.alphaOffset;
    };
    ColorTransform.prototype.copyFromUntyped = function (object) {
        this.redMultiplier = object.redMultiplier / 256;
        this.greenMultiplier = object.greenMultiplier / 256;
        this.blueMultiplier = object.blueMultiplier / 256;
        this.alphaMultiplier = object.alphaMultiplier / 256;
        this.redOffset = object.redOffset;
        this.greenOffset = object.greenOffset;
        this.blueOffset = object.blueOffset;
        this.alphaOffset = object.alphaOffset;
    };
    ColorTransform.prototype.setTo = function (redMultiplier, greenMultiplier, blueMultiplier, alphaMultiplier, redOffset, greenOffset, blueOffset, alphaOffset) {
        this.redMultiplier = redMultiplier;
        this.greenMultiplier = greenMultiplier;
        this.blueMultiplier = blueMultiplier;
        this.alphaMultiplier = alphaMultiplier;
        this.redOffset = redOffset;
        this.greenOffset = greenOffset;
        this.blueOffset = blueOffset;
        this.alphaOffset = alphaOffset;
    };
    ColorTransform.prototype.clone = function () {
        return new ColorTransform(this.redMultiplier, this.greenMultiplier, this.blueMultiplier, this.alphaMultiplier, this.redOffset, this.greenOffset, this.blueOffset, this.alphaOffset);
    };
    ColorTransform.prototype.convertToFixedPoint = function () {
        this.redMultiplier = clampS8U8(this.redMultiplier);
        this.greenMultiplier = clampS8U8(this.greenMultiplier);
        this.blueMultiplier = clampS8U8(this.blueMultiplier);
        this.alphaMultiplier = clampS8U8(this.alphaMultiplier);
        this.redOffset = toS16(this.redOffset);
        this.greenOffset = toS16(this.greenOffset);
        this.blueOffset = toS16(this.blueOffset);
        this.alphaOffset = toS16(this.alphaOffset);
        return this;
    };
    ColorTransform.prototype.equals = function (other) {
        if (this === other) {
            return true;
        }
        return this.redMultiplier === other.redMultiplier &&
            this.greenMultiplier === other.greenMultiplier &&
            this.blueMultiplier === other.blueMultiplier &&
            this.alphaMultiplier === other.alphaMultiplier &&
            this.redOffset === other.redOffset &&
            this.greenOffset === other.greenOffset &&
            this.blueOffset === other.blueOffset &&
            this.alphaOffset === other.alphaOffset;
    };
    ColorTransform.prototype.toString = function () {
        return "(redMultiplier=" + this.redMultiplier +
            ", greenMultiplier=" + this.greenMultiplier +
            ", blueMultiplier=" + this.blueMultiplier +
            ", alphaMultiplier=" + this.alphaMultiplier +
            ", redOffset=" + this.redOffset +
            ", greenOffset=" + this.greenOffset +
            ", blueOffset=" + this.blueOffset +
            ", alphaOffset=" + this.alphaOffset +
            ")";
    };
    ColorTransform.classSymbols = null; // [];
    ColorTransform.instanceSymbols = null; // ["redMultiplier", "greenMultiplier",
    return ColorTransform;
}(ASObject));
export { ColorTransform };
