import { ASObject } from "../../avm2/nat/ASObject";
import { Point } from "./Point";
import { Matrix3D } from "./Matrix3D";
import { DisplayObject } from '../display/DisplayObject';
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Initial values for the projection as used in Flash. Only for `root` will a different center
 * be used: constructing an instance manually will get 250,250.
 */
export declare const enum DefaultPerspectiveProjection {
    FOV = 55,
    CenterX = 250,
    CenterY = 250
}
export declare class PerspectiveProjection extends ASObject {
    static axClass: typeof PerspectiveProjection;
    static classInitializer: any;
    constructor();
    static FromDisplayObject(displayObject: DisplayObject): PerspectiveProjection;
    private _displayObject;
    _fieldOfView: number;
    _centerX: number;
    _centerY: number;
    get fieldOfView(): number;
    set fieldOfView(fieldOfViewAngleInDegrees: number);
    get projectionCenter(): Point;
    set projectionCenter(p: Point);
    get focalLength(): number;
    set focalLength(value: number);
    toMatrix3D(): Matrix3D;
    clone(): PerspectiveProjection;
}
