import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
import { release, somewhatImplemented } from "../../base/utilities/Debug";
import { assert } from "@awayjs/graphics";
import { Point } from "./Point";
import { Matrix3D } from "./Matrix3D";
var PerspectiveProjection = /** @class */ (function (_super) {
    __extends(PerspectiveProjection, _super);
    function PerspectiveProjection() {
        var _this = _super.call(this) || this;
        _this._fieldOfView = 55 /* FOV */;
        _this._centerX = 250 /* CenterX */;
        _this._centerY = 250 /* CenterY */;
        return _this;
    }
    PerspectiveProjection.FromDisplayObject = function (displayObject) {
        release || assert(displayObject);
        var projection = this.axConstruct();
        projection._displayObject = displayObject;
        return projection;
    };
    Object.defineProperty(PerspectiveProjection.prototype, "fieldOfView", {
        get: function () {
            release || somewhatImplemented("public flash.geom.PerspectiveProjection::get fieldOfView");
            return this._displayObject ?
                this._displayObject._perspectiveProjectionFOV :
                this._fieldOfView;
        },
        set: function (fieldOfViewAngleInDegrees) {
            fieldOfViewAngleInDegrees = +fieldOfViewAngleInDegrees;
            release || somewhatImplemented("public flash.geom.PerspectiveProjection::set fieldOfView");
            if (this._displayObject) {
                this._displayObject._perspectiveProjectionFOV = fieldOfViewAngleInDegrees;
            }
            else {
                this._fieldOfView = fieldOfViewAngleInDegrees;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PerspectiveProjection.prototype, "projectionCenter", {
        get: function () {
            release || somewhatImplemented("public flash.geom.PerspectiveProjection::get projectionCenter");
            var centerX;
            var centerY;
            if (this._displayObject) {
                centerX = this._displayObject._perspectiveProjectionCenterX;
                centerY = this._displayObject._perspectiveProjectionCenterY;
            }
            else {
                centerX = this._centerX;
                centerY = this._centerY;
            }
            return new Point(centerX, centerY);
        },
        set: function (p) {
            release || somewhatImplemented("public flash.geom.PerspectiveProjection::set projectionCenter");
            if (this._displayObject) {
                this._displayObject._perspectiveProjectionCenterX = +p.x;
                this._displayObject._perspectiveProjectionCenterY = +p.y;
            }
            else {
                this._centerX = +p.x;
                this._centerY = +p.y;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(PerspectiveProjection.prototype, "focalLength", {
        get: function () {
            release || somewhatImplemented("public flash.geom.PerspectiveProjection::get focalLength");
            var fov;
            var centerX;
            if (this._displayObject) {
                fov = this._displayObject._perspectiveProjectionFOV;
                centerX = this._displayObject._perspectiveProjectionCenterX;
            }
            else {
                fov = this._fieldOfView;
                centerX = this._centerX;
            }
            return 1 / Math.tan(fov * Math.PI / 180 / 2) * centerX;
        },
        set: function (value) {
            value = +value;
            release || somewhatImplemented("public flash.geom.PerspectiveProjection::set focalLength");
            var centerX = this._displayObject ?
                this._displayObject._perspectiveProjectionCenterX :
                this._centerX;
            var fov = 2 * Math.atan(centerX / value);
            if (this._displayObject) {
                this._displayObject._perspectiveProjectionFOV = fov;
            }
            else {
                this._fieldOfView = fov;
            }
        },
        enumerable: true,
        configurable: true
    });
    PerspectiveProjection.prototype.toMatrix3D = function () {
        release || somewhatImplemented("public flash.geom.PerspectiveProjection::toMatrix3D");
        return new Matrix3D();
    };
    PerspectiveProjection.prototype.clone = function () {
        var clone = Object.create(this.axClass.tPrototype);
        clone._fieldOfView = this._fieldOfView;
        clone._centerX = this._centerX;
        clone._centerY = this._centerY;
        clone._displayObject = this._displayObject;
        return clone;
    };
    PerspectiveProjection.classInitializer = null;
    return PerspectiveProjection;
}(ASObject));
export { PerspectiveProjection };
