import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class Point extends ASObject {
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    constructor(x?: number, y?: number);
    x: number;
    y: number;
    set native_x(x: number);
    get native_x(): number;
    set native_y(y: number);
    get native_y(): number;
    Point(x?: number, y?: number): void;
    get length(): number;
    static interpolate(p1: Point, p2: Point, f: number): Point;
    static distance(p1: Point, p2: Point): number;
    static polar(length: number, angle: number): Point;
    clone(): Point;
    offset(dx: number, dy: number): void;
    equals(toCompare: Point): Boolean;
    subtract(v: Point): Point;
    add(v: Point): Point;
    normalize(thickness: number): void;
    copyFrom(sourcePoint: Point): void;
    setTo(x: number, y: number): void;
    toTwips(): Point;
    toPixels(): Point;
    round(): Point;
    toString(): string;
}
