import { ASObject } from "../../avm2/nat/ASObject";
import { Bounds } from "../../base/utilities";
import { Point } from "./Point";
import { IDataInput, IDataOutput } from "../../avm2/natives/byteArray";
import { IExternalizable } from "../utils/IExternalizable";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class Rectangle extends ASObject implements IExternalizable {
    static axClass: typeof Rectangle;
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    x: number;
    y: number;
    width: number;
    height: number;
    constructor(x?: number, y?: number, width?: number, height?: number);
    static FromBounds(bounds: Bounds): Rectangle;
    set native_x(x: number);
    get native_x(): number;
    set native_y(y: number);
    get native_y(): number;
    set native_width(width: number);
    get native_width(): number;
    set native_height(height: number);
    get native_height(): number;
    get left(): number;
    set left(value: number);
    get right(): number;
    set right(value: number);
    get top(): number;
    set top(value: number);
    get bottom(): number;
    set bottom(value: number);
    get topLeft(): Point;
    set topLeft(value: Point);
    get bottomRight(): Point;
    set bottomRight(value: Point);
    get size(): Point;
    set size(value: Point);
    get area(): number;
    clone(): Rectangle;
    isEmpty(): boolean;
    setEmpty(): Rectangle;
    inflate(dx: number, dy: number): void;
    inflatePoint(point: Point): void;
    offset(dx: number, dy: number): void;
    offsetPoint(point: Point): void;
    contains(x: number, y: number): boolean;
    containsPoint(point: Point): boolean;
    containsRect(rect: Rectangle): boolean;
    intersection(toIntersect: Rectangle): Rectangle;
    intersects(toIntersect: Rectangle): boolean;
    intersectInPlace(clipRect: Rectangle): Rectangle;
    intersectInPlaceInt32(clipRect: Rectangle): Rectangle;
    union(toUnion: Rectangle): Rectangle;
    unionInPlace(toUnion: Rectangle): Rectangle;
    equals(toCompare: Rectangle): boolean;
    copyFrom(sourceRect: Rectangle): void;
    setTo(x: number, y: number, width: number, height: number): void;
    toTwips(): Rectangle;
    getBaseWidth(angle: number): number;
    getBaseHeight(angle: number): number;
    toPixels(): Rectangle;
    snapInPlace(): Rectangle;
    roundInPlace(): Rectangle;
    toString(): string;
    hashCode(): number;
    writeExternal(output: IDataOutput): void;
    readExternal(input: IDataInput): void;
}
