import { ASObject } from "../../avm2/nat/ASObject";
import { Matrix } from "./Matrix";
import { ColorTransform } from "./ColorTransform";
import { Rectangle } from "./Rectangle";
import { Matrix3D } from "./Matrix3D";
import { PerspectiveProjection } from "./PerspectiveProjection";
import { DisplayObject } from '../display/DisplayObject';
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class Transform extends ASObject {
    static classInitializer: any;
    private _displayObject;
    constructor(displayObject: DisplayObject);
    get matrix(): Matrix;
    set matrix(value: Matrix);
    get colorTransform(): ColorTransform;
    set colorTransform(value: ColorTransform);
    get concatenatedMatrix(): Matrix;
    get concatenatedColorTransform(): ColorTransform;
    get pixelBounds(): Rectangle;
    get matrix3D(): Matrix3D;
    set matrix3D(m: Matrix3D);
    getRelativeMatrix3D(relativeTo: DisplayObject): Matrix3D;
    get perspectiveProjection(): PerspectiveProjection;
    set perspectiveProjection(projection: PerspectiveProjection);
}
