import { Rectangle } from "../geom/Rectangle";
import { Float64Vector } from "../../avm2/natives/float64Vector";
import { ByteArray } from "../../avm2/natives/byteArray";
import { BitmapData } from "../display/BitmapData";
import { ASArray } from "../../avm2/nat/ASArray";
import { EventDispatcher } from "../events/EventDispatcher";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class Camera extends EventDispatcher {
    static classInitializer: any;
    constructor();
    static get names(): ASArray;
    static get isSupported(): boolean;
    static getCamera(name?: string): Camera;
    static _scanHardware(): void;
    get activityLevel(): number;
    get bandwidth(): number;
    get currentFPS(): number;
    get fps(): number;
    get height(): number;
    get index(): number;
    get keyFrameInterval(): number;
    get loopback(): boolean;
    get motionLevel(): number;
    get motionTimeout(): number;
    get muted(): boolean;
    get name(): string;
    get quality(): number;
    get width(): number;
    setCursor(value: boolean): void;
    setKeyFrameInterval(keyFrameInterval: number): void;
    setLoopback(compress?: boolean): void;
    setMode(width: number, height: number, fps: number, favorArea?: boolean): void;
    setMotionLevel(motionLevel: number, timeout?: number): void;
    setQuality(bandwidth: number, quality: number): void;
    drawToBitmapData(destination: BitmapData): void;
    copyToByteArray(rect: Rectangle, destination: ByteArray): void;
    copyToVector(rect: Rectangle, destination: Float64Vector): void;
}
