import { __extends } from "tslib";
import { release, somewhatImplemented } from "../../base/utilities/Debug";
import { axCoerceString } from "../../avm2/run/axCoerceString";
import { EventDispatcher } from "../events/EventDispatcher";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: Camera
var Camera = /** @class */ (function (_super) {
    __extends(Camera, _super);
    function Camera() {
        return _super.call(this) || this;
    }
    Object.defineProperty(Camera, "names", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get names");
            return this.sec.createArrayUnsafe([]);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera, "isSupported", {
        get: function () {
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Camera.getCamera = function (name) {
        if (name === void 0) { name = null; }
        name = axCoerceString(name);
        release || somewhatImplemented("public flash.media.Camera::static getCamera");
        return null;
    };
    Camera._scanHardware = function () {
        release || somewhatImplemented("public flash.media.Camera::static _scanHardware");
    };
    Object.defineProperty(Camera.prototype, "activityLevel", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get activityLevel");
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "bandwidth", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get bandwidth");
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "currentFPS", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get currentFPS");
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "fps", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get fps");
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "height", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get height");
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "index", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get index");
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "keyFrameInterval", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get keyFrameInterval");
            return 1;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "loopback", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get loopback");
            return false;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "motionLevel", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get motionLevel");
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "motionTimeout", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get motionTimeout");
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "muted", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get muted");
            return true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "name", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get name");
            return '';
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "quality", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get quality");
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Camera.prototype, "width", {
        get: function () {
            release || somewhatImplemented("public flash.media.Camera::get width");
            return 0;
        },
        enumerable: true,
        configurable: true
    });
    Camera.prototype.setCursor = function (value) {
        value = !!value;
        release || somewhatImplemented("public flash.media.Camera::setCursor");
    };
    Camera.prototype.setKeyFrameInterval = function (keyFrameInterval /*int*/) {
        keyFrameInterval = keyFrameInterval | 0;
        release || somewhatImplemented("public flash.media.Camera::setKeyFrameInterval");
    };
    Camera.prototype.setLoopback = function (compress) {
        if (compress === void 0) { compress = false; }
        compress = !!compress;
        release || somewhatImplemented("public flash.media.Camera::setLoopback");
    };
    Camera.prototype.setMode = function (width /*int*/, height /*int*/, fps, favorArea) {
        if (favorArea === void 0) { favorArea = true; }
        width = width | 0;
        height = height | 0;
        fps = +fps;
        favorArea = !!favorArea;
        release || somewhatImplemented("public flash.media.Camera::setMode");
    };
    Camera.prototype.setMotionLevel = function (motionLevel /*int*/, timeout) {
        if (timeout === void 0) { timeout = 2000; }
        motionLevel = motionLevel | 0;
        timeout = timeout | 0;
        release || somewhatImplemented("public flash.media.Camera::setMotionLevel");
    };
    Camera.prototype.setQuality = function (bandwidth /*int*/, quality /*int*/) {
        bandwidth = bandwidth | 0;
        quality = quality | 0;
        release || somewhatImplemented("public flash.media.Camera::setQuality");
    };
    Camera.prototype.drawToBitmapData = function (destination) {
        destination = destination;
        release || somewhatImplemented("public flash.media.Camera::drawToBitmapData");
    };
    Camera.prototype.copyToByteArray = function (rect, destination) {
        rect = rect;
        destination = destination;
        release || somewhatImplemented("public flash.media.Camera::copyToByteArray");
    };
    Camera.prototype.copyToVector = function (rect, destination) {
        rect = rect;
        destination = destination;
        release || somewhatImplemented("public flash.media.Camera::copyToVector");
    };
    Camera.classInitializer = null;
    return Camera;
}(EventDispatcher));
export { Camera };
