import { SoundTransform } from "./SoundTransform";
import { EventDispatcher } from "../events/EventDispatcher";
import { ASArray } from "../../avm2/nat/ASArray";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class Microphone extends EventDispatcher {
    static classInitializer: any;
    constructor();
    static get names(): ASArray;
    static get isSupported(): boolean;
    static getMicrophone(index?: number): Microphone;
    static getEnhancedMicrophone(index?: number): Microphone;
    get rate(): number;
    set rate(rate: number);
    get codec(): string;
    set codec(codec: string);
    get framesPerPacket(): number;
    set framesPerPacket(frames: number);
    get encodeQuality(): number;
    set encodeQuality(quality: number);
    get noiseSuppressionLevel(): number;
    set noiseSuppressionLevel(level: number);
    get enableVAD(): boolean;
    set enableVAD(enable: boolean);
    get activityLevel(): number;
    get gain(): number;
    set gain(gain: number);
    get index(): number;
    get muted(): boolean;
    get name(): string;
    get silenceLevel(): number;
    get silenceTimeout(): number;
    get useEchoSuppression(): boolean;
    get soundTransform(): SoundTransform;
    set soundTransform(sndTransform: SoundTransform);
    get enhancedOptions(): any;
    set enhancedOptions(options: any);
    setSilenceLevel(silenceLevel: number, timeout?: number): void;
    setUseEchoSuppression(useEchoSuppression: boolean): void;
    setLoopBack(state?: boolean): void;
}
