import { __extends } from "tslib";
import { release, notImplemented, somewhatImplemented } from "../../base/utilities/Debug";
import { axCoerceString } from "../../avm2/run/axCoerceString";
import { EventDispatcher } from "../events/EventDispatcher";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: Microphone
var Microphone = /** @class */ (function (_super) {
    __extends(Microphone, _super);
    function Microphone() {
        return _super.call(this) || this;
    }
    Object.defineProperty(Microphone, "names", {
        get: function () {
            release || somewhatImplemented("public flash.media.Microphone::get names");
            return this.sec.createArrayUnsafe([]);
            // return this._names;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone, "isSupported", {
        get: function () {
            release || somewhatImplemented("public flash.media.Microphone::get isSupported");
            return false;
            // return this._isSupported;
        },
        enumerable: true,
        configurable: true
    });
    Microphone.getMicrophone = function (index) {
        if (index === void 0) { index = -1; }
        index = index | 0;
        release || notImplemented("public flash.media.Microphone::static getMicrophone");
        return;
    };
    Microphone.getEnhancedMicrophone = function (index) {
        if (index === void 0) { index = -1; }
        index = index | 0;
        release || notImplemented("public flash.media.Microphone::static getEnhancedMicrophone");
        return;
    };
    Object.defineProperty(Microphone.prototype, "rate", {
        // _rate: number /*int*/;
        // _codec: string;
        // _framesPerPacket: number /*int*/;
        // _encodeQuality: number /*int*/;
        // _noiseSuppressionLevel: number /*int*/;
        // _enableVAD: boolean;
        // _activityLevel: number;
        // _gain: number;
        // _index: number /*int*/;
        // _muted: boolean;
        // _name: string;
        // _silenceLevel: number;
        // _silenceTimeout: number /*int*/;
        // _useEchoSuppression: boolean;
        // _soundTransform: flash.media.SoundTransform;
        // _enhancedOptions: flash.media.MicrophoneEnhancedOptions;
        get: function () {
            release || notImplemented("public flash.media.Microphone::get rate");
            return;
            // return this._rate;
        },
        set: function (rate /*int*/) {
            rate = rate | 0;
            release || notImplemented("public flash.media.Microphone::set rate");
            return;
            // this._rate = rate;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "codec", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get codec");
            return;
            // return this._codec;
        },
        set: function (codec) {
            codec = axCoerceString(codec);
            release || notImplemented("public flash.media.Microphone::set codec");
            return;
            // this._codec = codec;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "framesPerPacket", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get framesPerPacket");
            return;
            // return this._framesPerPacket;
        },
        set: function (frames /*int*/) {
            frames = frames | 0;
            release || notImplemented("public flash.media.Microphone::set framesPerPacket");
            return;
            // this._framesPerPacket = frames;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "encodeQuality", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get encodeQuality");
            return;
            // return this._encodeQuality;
        },
        set: function (quality /*int*/) {
            quality = quality | 0;
            release || notImplemented("public flash.media.Microphone::set encodeQuality");
            return;
            // this._encodeQuality = quality;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "noiseSuppressionLevel", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get noiseSuppressionLevel");
            return;
            // return this._noiseSuppressionLevel;
        },
        set: function (level /*int*/) {
            level = level | 0;
            release || notImplemented("public flash.media.Microphone::set noiseSuppressionLevel");
            return;
            // this._noiseSuppressionLevel = level;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "enableVAD", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get enableVAD");
            return;
            // return this._enableVAD;
        },
        set: function (enable) {
            enable = !!enable;
            release || notImplemented("public flash.media.Microphone::set enableVAD");
            return;
            // this._enableVAD = enable;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "activityLevel", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get activityLevel");
            return;
            // return this._activityLevel;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "gain", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get gain");
            return;
            // return this._gain;
        },
        set: function (gain) {
            gain = +gain;
            release || notImplemented("public flash.media.Microphone::set gain");
            return;
            // this._gain = gain;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "index", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get index");
            return;
            // return this._index;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "muted", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get muted");
            return;
            // return this._muted;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "name", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get name");
            return;
            // return this._name;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "silenceLevel", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get silenceLevel");
            return;
            // return this._silenceLevel;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "silenceTimeout", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get silenceTimeout");
            return;
            // return this._silenceTimeout;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "useEchoSuppression", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get useEchoSuppression");
            return;
            // return this._useEchoSuppression;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "soundTransform", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get soundTransform");
            return;
            // return this._soundTransform;
        },
        set: function (sndTransform) {
            sndTransform = sndTransform;
            release || notImplemented("public flash.media.Microphone::set soundTransform");
            return;
            // this._soundTransform = sndTransform;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Microphone.prototype, "enhancedOptions", {
        get: function () {
            release || notImplemented("public flash.media.Microphone::get enhancedOptions");
            return;
            // return this._enhancedOptions;
        },
        set: function (options /* flash.media.MicrophoneEnhancedOptions */) {
            options = options;
            release || notImplemented("public flash.media.Microphone::set enhancedOptions");
            return;
            // this._enhancedOptions = options;
        },
        enumerable: true,
        configurable: true
    });
    Microphone.prototype.setSilenceLevel = function (silenceLevel, timeout) {
        if (timeout === void 0) { timeout = -1; }
        silenceLevel = +silenceLevel;
        timeout = timeout | 0;
        release || notImplemented("public flash.media.Microphone::setSilenceLevel");
        return;
    };
    Microphone.prototype.setUseEchoSuppression = function (useEchoSuppression) {
        useEchoSuppression = !!useEchoSuppression;
        release || notImplemented("public flash.media.Microphone::setUseEchoSuppression");
        return;
    };
    Microphone.prototype.setLoopBack = function (state) {
        if (state === void 0) { state = true; }
        state = !!state;
        release || notImplemented("public flash.media.Microphone::setLoopBack");
        return;
    };
    Microphone.classInitializer = null;
    return Microphone;
}(EventDispatcher));
export { Microphone };
