import { EventDispatcher } from "../events/EventDispatcher";
import { ISoundSource } from "./SoundMixer";
import { SoundTransform } from "./SoundTransform";
import { ISecurityDomain } from "../../avm2/nat/ISecurityDomain";
import { Sound } from "./Sound";
export declare class SoundChannel extends EventDispatcher implements ISoundSource {
    static classInitializer: any;
    _symbol: SoundChannel;
    constructor();
    static initializeFromAudioElement(sec: ISecurityDomain, element: HTMLAudioElement): SoundChannel;
    _element: any;
    _sound: Sound;
    private _audioChannel;
    private _pcmData;
    private _playing;
    private _position;
    _soundTransform: SoundTransform;
    private _leftPeak;
    private _rightPeak;
    get position(): number;
    get soundTransform(): SoundTransform;
    set soundTransform(sndTransform: SoundTransform);
    get leftPeak(): number;
    get rightPeak(): number;
    get playing(): boolean;
    stop(): void;
    _playSoundDataViaAudio(soundData: any, startTime: any, loops: any): void;
    _playSoundDataViaChannel(soundData: any, startTime: any, loops: any): void;
    stopSound(): void;
    updateSoundLevels(volume: number): void;
}
