import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: SoundLoaderContext
var SoundLoaderContext = /** @class */ (function (_super) {
    __extends(SoundLoaderContext, _super);
    function SoundLoaderContext(bufferTime, checkPolicyFile) {
        if (bufferTime === void 0) { bufferTime = 1000; }
        if (checkPolicyFile === void 0) { checkPolicyFile = false; }
        var _this = _super.call(this) || this;
        _this.bufferTime = +bufferTime;
        _this.checkPolicyFile = !!checkPolicyFile;
        return _this;
    }
    // Called whenever the class is initialized.
    SoundLoaderContext.classInitializer = null;
    // List of static symbols to link.
    SoundLoaderContext.classSymbols = null; // [];
    // List of instance symbols to link.
    SoundLoaderContext.instanceSymbols = null; // ["bufferTime", "checkPolicyFile"];
    return SoundLoaderContext;
}(ASObject));
export { SoundLoaderContext };
