import { DisplayObject } from "../display/DisplayObject";
import { NetStreamAppendBytesAction } from "../net/NetStreamAppendBytesAction";
import { DisplaySymbol, SymbolData } from "../symbol";
import { ISecurityDomain } from "../../avm2/nat/ISecurityDomain";
import { LoaderInfo } from "../display/LoaderInfo";
import { Camera } from "./Camera";
import { NetStream } from "../net/NetStream";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class Video extends DisplayObject {
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    _symbol: VideoSymbol;
    applySymbol(): void;
    protected _initializeFields(): void;
    constructor(width?: number, height?: number);
    _deblocking: number;
    _smoothing: boolean;
    _videoWidth: number;
    _videoHeight: number;
    _netStream: NetStream;
    _camera: Camera;
    get deblocking(): number;
    set deblocking(value: number);
    get smoothing(): boolean;
    set smoothing(value: boolean);
    get videoWidth(): number;
    get videoHeight(): number;
    _containsPointDirectly(localX: number, localY: number, globalX: number, globalY: number): boolean;
    clear(): void;
    attachNetStream(netStream: NetStreamAppendBytesAction): void;
    attachCamera(camera: Camera): void;
}
export declare class VideoSymbol extends DisplaySymbol {
    width: number;
    height: number;
    deblocking: number;
    smoothing: boolean;
    codec: number;
    constructor(data: SymbolData, sec: ISecurityDomain);
    static FromData(data: any, loaderInfo: LoaderInfo): VideoSymbol;
}
