import { EventDispatcher } from "../events/EventDispatcher";
import { ASArray } from "../../avm2/nat/ASArray";
import { Responder } from "./Responder";
import { ASObject } from '../../avm2/nat/ASObject';
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class NetConnection extends EventDispatcher {
    static classInitializer: any;
    constructor();
    close(): void;
    addHeader(operation: string, mustUnderstand?: Boolean, param?: Object): void;
    call(command: string, responder: Responder): void;
    static _defaultObjectEncoding: number;
    static get defaultObjectEncoding(): number;
    static set defaultObjectEncoding(version: number);
    private _connected;
    private _uri;
    private _client;
    private _objectEncoding;
    private _proxyType;
    private _usingTLS;
    private _protocol;
    private _rtmpConnection;
    private _rtmpCreateStreamCallbacks;
    get connected(): boolean;
    get uri(): string;
    connect(command: string): void;
    _createRtmpStream(callback: any): void;
    get client(): ASObject;
    set client(object: ASObject);
    get objectEncoding(): number;
    set objectEncoding(version: number);
    get proxyType(): string;
    set proxyType(ptype: string);
    get connectedProxyType(): string;
    get usingTLS(): boolean;
    get protocol(): string;
    get maxPeerConnections(): number;
    set maxPeerConnections(maxPeers: number);
    get nearID(): string;
    get farID(): string;
    get nearNonce(): string;
    get farNonce(): string;
    get unconnectedPeerStreams(): ASArray;
    invoke(index: number): any;
    private _invoke;
}
