import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
import { axCoerceString } from "../../avm2/run/axCoerceString";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: NetStreamInfo
var NetStreamInfo = /** @class */ (function (_super) {
    __extends(NetStreamInfo, _super);
    function NetStreamInfo(curBPS, byteCount, maxBPS, audioBPS, audioByteCount, videoBPS, videoByteCount, dataBPS, dataByteCount, playbackBPS, droppedFrames, audioBufferByteLength, videoBufferByteLength, dataBufferByteLength, audioBufferLength, videoBufferLength, dataBufferLength, srtt, audioLossRate, videoLossRate, metaData, xmpData, uri, resourceName, isLive) {
        if (metaData === void 0) { metaData = null; }
        if (xmpData === void 0) { xmpData = null; }
        if (uri === void 0) { uri = null; }
        if (resourceName === void 0) { resourceName = null; }
        if (isLive === void 0) { isLive = true; }
        var _this = _super.call(this) || this;
        _this.currentBytesPerSecond = +curBPS;
        _this.byteCount = +byteCount;
        _this.maxBytesPerSecond = +maxBPS;
        _this.audioBytesPerSecond = +audioBPS;
        _this.audioByteCount = +audioByteCount;
        _this.videoBytesPerSecond = +videoBPS;
        _this.videoByteCount = +videoByteCount;
        _this.dataBytesPerSecond = +dataBPS;
        _this.dataByteCount = +dataByteCount;
        _this.playbackBytesPerSecond = +playbackBPS;
        _this.droppedFrames = +droppedFrames;
        _this.audioBufferByteLength = +audioBufferByteLength;
        _this.videoBufferByteLength = +videoBufferByteLength;
        _this.dataBufferByteLength = +dataBufferByteLength;
        _this.audioBufferLength = +audioBufferLength;
        _this.videoBufferLength = +videoBufferLength;
        _this.dataBufferLength = +dataBufferLength;
        _this._srtt = +srtt;
        _this.audioLossRate = +audioLossRate;
        _this.videoLossRate = +videoLossRate;
        _this.metaData = metaData;
        _this.xmpData = xmpData;
        _this.uri = axCoerceString(uri);
        _this.resourceName = axCoerceString(resourceName);
        _this.isLive = !!isLive;
        return _this;
    }
    // Called whenever the class is initialized.
    NetStreamInfo.classInitializer = null;
    // List of static symbols to link.
    NetStreamInfo.classSymbols = null; // [];
    // List of instance symbols to link.
    NetStreamInfo.instanceSymbols = null;
    return NetStreamInfo;
}(ASObject));
export { NetStreamInfo };
