import { ByteArray, IDataInput } from "../../avm2/natives/byteArray";
import { EventDispatcher } from "../events/EventDispatcher";
import { URLRequest } from "./URLRequest";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class URLStream extends EventDispatcher implements IDataInput {
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    constructor();
    private _buffer;
    private _writePosition;
    private _session;
    private _connected;
    get connected(): boolean;
    get bytesAvailable(): number;
    get objectEncoding(): number;
    set objectEncoding(version: number);
    get endian(): string;
    set endian(type: string);
    get diskCacheEnabled(): boolean;
    get position(): number;
    set position(offset: number);
    get length(): number;
    load(request: URLRequest): void;
    readBytes(bytes: ByteArray, offset?: number, length?: number): void;
    readBoolean(): boolean;
    readByte(): number;
    readUnsignedByte(): number;
    readShort(): number;
    readUnsignedShort(): number;
    readUnsignedInt(): number;
    readInt(): number;
    readFloat(): number;
    readDouble(): number;
    readMultiByte(length: number, charSet: string): string;
    readUTF(): string;
    readUTFBytes(length: number): string;
    close(): void;
    readObject(): any;
    stop(): void;
}
