import { __extends } from "tslib";
import { isInteger, Bounds } from "../base/utilities";
import { release, warning, assert } from "../base/utilities/Debug";
import { Multiname } from "../avm2/abc/lazy/Multiname";
import { ByteArray } from "../avm2/natives/byteArray";
/**
 * TODO document
 */
var Symbol = /** @class */ (function () {
    function Symbol(data, symbolDefaultClass) {
        release || assert(isInteger(data.id));
        this.data = data;
        if (data.className) {
            var app = data.env.app;
            try {
                var symbolClass = app.getClass(Multiname.FromFQNString(data.className, 0 /* Public */));
                this.symbolClass = symbolClass;
                // The symbolClass should have received a lazy symbol resolver in Loader#_applyLoadUpdate.
                release || assert(symbolClass.tPrototype.hasOwnProperty('_symbol'));
                // Replace it by this symbol without triggering the resolver and causing an infinite
                // recursion.
                Object.defineProperty(symbolClass.tPrototype, '_symbol', { value: this });
            }
            catch (e) {
                warning("Symbol " + data.id + " bound to non-existing class " + data.className);
                this.symbolClass = symbolDefaultClass;
            }
        }
        else {
            this.symbolClass = symbolDefaultClass;
        }
        this.isAVM1Object = false;
    }
    Object.defineProperty(Symbol.prototype, "id", {
        get: function () {
            return this.data.id;
        },
        enumerable: true,
        configurable: true
    });
    return Symbol;
}());
export { Symbol };
var DisplaySymbol = /** @class */ (function (_super) {
    __extends(DisplaySymbol, _super);
    function DisplaySymbol(data, symbolClass, dynamic) {
        var _this = _super.call(this, data, symbolClass) || this;
        _this.dynamic = dynamic;
        return _this;
    }
    DisplaySymbol.prototype._setBoundsFromData = function (data) {
        this.fillBounds = data.fillBounds ? Bounds.FromUntyped(data.fillBounds) : null;
        this.lineBounds = data.lineBounds ? Bounds.FromUntyped(data.lineBounds) : null;
        if (!this.lineBounds && this.fillBounds) {
            this.lineBounds = this.fillBounds.clone();
        }
    };
    return DisplaySymbol;
}(Symbol));
export { DisplaySymbol };
var BinarySymbol = /** @class */ (function (_super) {
    __extends(BinarySymbol, _super);
    function BinarySymbol(data, sec) {
        return _super.call(this, data, ByteArray.axClass) || this;
    }
    BinarySymbol.FromData = function (data, loaderInfo) {
        var symbol = new BinarySymbol(data, loaderInfo.app.sec);
        symbol.buffer = data.data;
        symbol.byteLength = data.data.byteLength;
        return symbol;
    };
    return BinarySymbol;
}(Symbol));
export { BinarySymbol };
var SoundStart = /** @class */ (function () {
    function SoundStart(soundId, soundInfo) {
        this.soundId = soundId;
        this.soundInfo = soundInfo;
    }
    return SoundStart;
}());
export { SoundStart };
