import { ASObject } from "../../avm2/nat/ASObject";
import { AXApplicationDomain } from "../../avm2/run/AXApplicationDomain";
import { ByteArray } from "../../avm2/natives/byteArray";
import { GenericVector } from "../../avm2/natives/GenericVector";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class ApplicationDomain extends ASObject {
    axDomain: AXApplicationDomain;
    constructor(parentDomainOrAXDomain?: any);
    static get currentDomain(): ApplicationDomain;
    static get MIN_DOMAIN_MEMORY_LENGTH(): number;
    get parentDomain(): ApplicationDomain;
    get domainMemory(): ByteArray;
    set domainMemory(mem: ByteArray);
    getDefinition(name: string): Object;
    hasDefinition(name: string): boolean;
    private getDefinitionImpl;
    getQualifiedDefinitionNames(): GenericVector;
}
