import { ASObject } from "../../avm2/nat/ASObject";
import { ApplicationDomain } from "./ApplicationDomain";
import { SecurityDomain } from "./SecurityDomain";
import { DisplayObjectContainer } from "../display/DisplayObjectContainer";
import { AVM1Context } from '../../avm1/context';
/**
 * Copyright 2015 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class LoaderContext extends ASObject {
    static classInitializer: any;
    static instanceSymbols: string[];
    private $BgcheckPolicyFile;
    private $BgapplicationDomain;
    private $BgsecurityDomain;
    private $BgallowCodeImport;
    private $BgrequestedContentParent;
    private $Bgparameters;
    private $BgimageDecodingPolicy;
    _avm1Context: AVM1Context;
    constructor(checkPolicyFile?: boolean, applicationDomain?: ApplicationDomain, securityDomain?: SecurityDomain);
    get imageDecodingPolicy(): string;
    get parameters(): ASObject;
    get requestedContentParent(): DisplayObjectContainer;
    get allowCodeImport(): boolean;
    get securityDomain(): SecurityDomain;
    get applicationDomain(): ApplicationDomain;
    get checkPolicyFile(): boolean;
}
