import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
import { ImageDecodingPolicy } from "./ImageDecodingPolicy";
/**
 * Copyright 2015 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: LoaderContext
var LoaderContext = /** @class */ (function (_super) {
    __extends(LoaderContext, _super);
    function LoaderContext(checkPolicyFile, applicationDomain, securityDomain) {
        if (checkPolicyFile === void 0) { checkPolicyFile = false; }
        if (applicationDomain === void 0) { applicationDomain = null; }
        if (securityDomain === void 0) { securityDomain = null; }
        var _this = _super.call(this) || this;
        _this.$BgcheckPolicyFile = !!checkPolicyFile;
        _this.$BgapplicationDomain = applicationDomain;
        _this.$BgsecurityDomain = securityDomain;
        _this.$BgimageDecodingPolicy = ImageDecodingPolicy.ON_DEMAND;
        _this._avm1Context = null;
        return _this;
    }
    Object.defineProperty(LoaderContext.prototype, "imageDecodingPolicy", {
        get: function () {
            return this.$BgimageDecodingPolicy;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoaderContext.prototype, "parameters", {
        get: function () {
            return this.$Bgparameters;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoaderContext.prototype, "requestedContentParent", {
        get: function () {
            return this.$BgrequestedContentParent;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoaderContext.prototype, "allowCodeImport", {
        get: function () {
            return this.$BgallowCodeImport;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoaderContext.prototype, "securityDomain", {
        get: function () {
            return this.$BgsecurityDomain;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoaderContext.prototype, "applicationDomain", {
        get: function () {
            return this.$BgapplicationDomain;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LoaderContext.prototype, "checkPolicyFile", {
        get: function () {
            return this.$BgcheckPolicyFile;
        },
        enumerable: true,
        configurable: true
    });
    LoaderContext.classInitializer = null;
    LoaderContext.instanceSymbols = ["checkPolicyFile!", "applicationDomain!", "sec!",
        "allowCodeImport!", "requestedContentParent!",
        "parameters!", "imageDecodingPolicy!"];
    return LoaderContext;
}(ASObject));
export { LoaderContext };
