import { ASArray } from "../../avm2/nat/ASArray";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class Security extends ASObject {
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    constructor();
    static REMOTE: string;
    static LOCAL_WITH_FILE: string;
    static LOCAL_WITH_NETWORK: string;
    static LOCAL_TRUSTED: string;
    static APPLICATION: string;
    private static _exactSettings;
    private static _sandboxType;
    static get exactSettings(): boolean;
    static set exactSettings(value: boolean);
    static get disableAVM1Loading(): boolean;
    static set disableAVM1Loading(value: boolean);
    static get sandboxType(): string;
    static get pageDomain(): string;
    static allowDomain(): void;
    static allowInsecureDomain(): void;
    static loadPolicyFile(url: string): void;
    static showSettings(panel?: string): void;
    static duplicateSandboxBridgeInputArguments(toplevel: ASObject, args: ASArray): ASArray;
    static duplicateSandboxBridgeOutputArgument(toplevel: ASObject, arg: any): any;
}
export declare const enum CrossDomainSWFLoadingWhitelistResult {
    /**
     * The requested domain belongs to the same domain as SWF's.
     */
    OwnDomain = 0,
    /**
     * The requested domain belongs to the other domain than SWF's.
     */
    Remote = 1,
    /**
     * The requested domain is not whitelisted.
     */
    Failed = 2
}
export interface ICrossDomainSWFLoadingWhitelist {
    addToSWFLoadingWhitelist(domain: string, insecure: boolean, ownDomain: boolean): any;
    checkDomainForSWFLoading(domain: string): CrossDomainSWFLoadingWhitelistResult;
}
