import { ASObject } from "../../avm2/nat/ASObject";
import { ASArray } from "../../avm2/nat/ASArray";
import { EventDispatcher } from "../events/EventDispatcher";
import { TextFormat } from "./TextFormat";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export interface Style {
    color?: string;
    display?: string;
    fontFamily?: string;
    fontSize?: any;
    fontStyle?: string;
    fontWeight?: string;
    kerning?: any;
    leading?: any;
    letterSpacing?: any;
    marginLeft?: any;
    marginRight?: any;
    textAlign?: string;
    textDecoration?: string;
    textIndent?: any;
}
export declare class StyleSheet extends EventDispatcher {
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    constructor();
    private _rules;
    get styleNames(): ASArray;
    getStyle(styleName: string): Style;
    applyStyle(textFormat: TextFormat, styleName: string): TextFormat;
    setStyle(styleName: string, styleObject: Style): void;
    hasStyle(styleName: string): boolean;
    clear(): void;
    transform(formatObject: ASObject): TextFormat;
    parseCSS(css: string): void;
}
