import { Style } from "./StyleSheet";
import { ASObject } from "../../avm2/nat/ASObject";
import { ASArray } from "../../avm2/nat/ASArray";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
export declare class TextFormat extends ASObject {
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    constructor(font?: string, size?: Object, color?: Object, bold?: Object, italic?: Object, underline?: Object, url?: string, target?: string, align?: string, leftMargin?: Object, rightMargin?: Object, indent?: Object, leading?: Object);
    private static measureTextField;
    private _align;
    private _blockIndent;
    private _bold;
    private _bullet;
    private _color;
    private _display;
    private _font;
    private _indent;
    private _italic;
    private _kerning;
    private _leading;
    private _leftMargin;
    private _letterSpacing;
    private _rightMargin;
    private _size;
    private _tabStops;
    private _target;
    private _underline;
    private _url;
    get align(): string;
    set align(value: string);
    get blockIndent(): Object;
    set blockIndent(value: Object);
    get bold(): Object;
    set bold(value: Object);
    get bullet(): Object;
    set bullet(value: Object);
    get color(): Object;
    set color(value: Object);
    get display(): string;
    set display(value: string);
    get font(): string;
    set font(value: string);
    get style(): string;
    get indent(): Object;
    set indent(value: Object);
    get italic(): Object;
    set italic(value: Object);
    get kerning(): Object;
    set kerning(value: Object);
    get leading(): Object;
    set leading(value: Object);
    get leftMargin(): Object;
    set leftMargin(value: Object);
    get letterSpacing(): Object;
    set letterSpacing(value: Object);
    get rightMargin(): Object;
    set rightMargin(value: Object);
    get size(): Object;
    set size(value: Object);
    get tabStops(): ASArray;
    set tabStops(value: ASArray);
    get target(): string;
    set target(value: string);
    get underline(): Object;
    set underline(value: Object);
    get url(): string;
    set url(value: string);
    /**
     * All integer values on TextFormat are typed as Object and coerced to ints using the following
     * "algorithm":
     * - if the supplied value is null or undefined, the field is set to null
     * - else if coercing to number results in NaN or the value is greater than MAX_INT, set to
     *   -0x80000000
     * - else, round the coerced value using half-even rounding
     */
    private static coerceNumber;
    /**
     * Boolean values are only stored as bools if they're not undefined or null. In that case,
     * they're stored as null.
     */
    private static coerceBoolean;
    clone(): TextFormat;
    equals(other: TextFormat): boolean;
    merge(other: TextFormat): void;
    intersect(other: TextFormat): void;
    transform(formatObject: Style): this;
}
