import { ASObject } from "../../avm2/nat/ASObject";
import { EventDispatcher } from "../events/EventDispatcher";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/**
 * Dispatches AS3 keyboard events to the focus event dispatcher.
 */
export declare class KeyboardEventDispatcher {
    private _lastKeyCode;
    private _captureKeyPress;
    private _charCodeMap;
    target: EventDispatcher;
    /**
     * Converts DOM keyboard event data into AS3 keyboard events.
     */
    dispatchKeyboardEvent(event: KeyboardEventData): void;
}
export interface KeyboardEventData {
    type: string;
    keyCode: number;
    charCode: number;
    location: number;
    ctrlKey: boolean;
    altKey: boolean;
    shiftKey: boolean;
}
export declare class Keyboard extends ASObject {
    static classInitializer: any;
    static classSymbols: string[];
    static instanceSymbols: string[];
    constructor();
    static get capsLock(): boolean;
    static get numLock(): boolean;
    static get hasVirtualKeyboard(): boolean;
    static get physicalKeyboardType(): string;
    static isAccessible(): boolean;
}
