import { __extends } from "tslib";
import { ASObject } from "../../avm2/nat/ASObject";
/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: MouseCursor
var MouseCursor = /** @class */ (function (_super) {
    __extends(MouseCursor, _super);
    function MouseCursor() {
        return _super.call(this) || this;
    }
    MouseCursor.fromNumber = function (n) {
        switch (n) {
            case 0:
                return MouseCursor.AUTO;
            case 1:
                return MouseCursor.ARROW;
            case 2:
                return MouseCursor.BUTTON;
            case 3:
                return MouseCursor.HAND;
            case 4:
                return MouseCursor.IBEAM;
            default:
                return null;
        }
    };
    MouseCursor.toNumber = function (value) {
        switch (value) {
            case MouseCursor.AUTO:
                return 0;
            case MouseCursor.ARROW:
                return 1;
            case MouseCursor.BUTTON:
                return 2;
            case MouseCursor.HAND:
                return 3;
            case MouseCursor.IBEAM:
                return 4;
            default:
                return -1;
        }
    };
    // Called whenever the class is initialized.
    MouseCursor.classInitializer = null;
    // List of static symbols to link.
    MouseCursor.classSymbols = null; // [];
    // List of instance symbols to link.
    MouseCursor.instanceSymbols = null; // [];
    // JS -> AS Bindings
    MouseCursor.AUTO = "auto";
    MouseCursor.ARROW = "arrow";
    MouseCursor.BUTTON = "button";
    MouseCursor.HAND = "hand";
    MouseCursor.IBEAM = "ibeam";
    return MouseCursor;
}(ASObject));
export { MouseCursor };
