var BrowserSystemResourcesLoadingService = /** @class */ (function () {
    function BrowserSystemResourcesLoadingService() {
    }
    BrowserSystemResourcesLoadingService.getInstance = function () {
        if (BrowserSystemResourcesLoadingService._instance)
            return BrowserSystemResourcesLoadingService._instance;
        return (BrowserSystemResourcesLoadingService._instance = new BrowserSystemResourcesLoadingService());
    };
    BrowserSystemResourcesLoadingService.prototype.load = function (url, type) {
        return this._promiseFile(url, type);
    };
    BrowserSystemResourcesLoadingService.prototype._promiseFile = function (path, responseType) {
        return new Promise(function (resolve, reject) {
            //SWF.enterTimeline('Load file', path);
            var xhr = new XMLHttpRequest();
            xhr.open("GET", path);
            xhr.responseType = responseType;
            xhr.onload = function () {
                var response = xhr.response;
                if (response) {
                    if (responseType === "json" && xhr.responseType !== "json") {
                        // some browsers (e.g. Safari) have no idea what json is
                        response = JSON.parse(response);
                    }
                    resolve(response);
                }
                else {
                    reject("Unable to load " + path + ": " + xhr.statusText);
                }
            };
            xhr.onerror = function () {
                reject("Unable to load: xhr error");
            };
            xhr.send();
        });
    };
    return BrowserSystemResourcesLoadingService;
}());
export { BrowserSystemResourcesLoadingService };
