import { SwfTag, DefinitionTag, Bbox, ShapeRecord, FillStyle } from "@awayjs/graphics";
export declare const enum SwfTagCode {
    CODE_END = 0,
    CODE_SHOW_FRAME = 1,
    CODE_DEFINE_SHAPE = 2,
    CODE_FREE_CHARACTER = 3,
    CODE_PLACE_OBJECT = 4,
    CODE_REMOVE_OBJECT = 5,
    CODE_DEFINE_BITS = 6,
    CODE_DEFINE_BUTTON = 7,
    CODE_JPEG_TABLES = 8,
    CODE_SET_BACKGROUND_COLOR = 9,
    CODE_DEFINE_FONT = 10,
    CODE_DEFINE_TEXT = 11,
    CODE_DO_ACTION = 12,
    CODE_DEFINE_FONT_INFO = 13,
    CODE_DEFINE_SOUND = 14,
    CODE_START_SOUND = 15,
    CODE_STOP_SOUND = 16,
    CODE_DEFINE_BUTTON_SOUND = 17,
    CODE_SOUND_STREAM_HEAD = 18,
    CODE_SOUND_STREAM_BLOCK = 19,
    CODE_DEFINE_BITS_LOSSLESS = 20,
    CODE_DEFINE_BITS_JPEG2 = 21,
    CODE_DEFINE_SHAPE2 = 22,
    CODE_DEFINE_BUTTON_CXFORM = 23,
    CODE_PROTECT = 24,
    CODE_PATHS_ARE_POSTSCRIPT = 25,
    CODE_PLACE_OBJECT2 = 26,
    CODE_REMOVE_OBJECT2 = 28,
    CODE_SYNC_FRAME = 29,
    CODE_FREE_ALL = 31,
    CODE_DEFINE_SHAPE3 = 32,
    CODE_DEFINE_TEXT2 = 33,
    CODE_DEFINE_BUTTON2 = 34,
    CODE_DEFINE_BITS_JPEG3 = 35,
    CODE_DEFINE_BITS_LOSSLESS2 = 36,
    CODE_DEFINE_EDIT_TEXT = 37,
    CODE_DEFINE_VIDEO = 38,
    CODE_DEFINE_SPRITE = 39,
    CODE_NAME_CHARACTER = 40,
    CODE_PRODUCT_INFO = 41,
    CODE_DEFINE_TEXT_FORMAT = 42,
    CODE_FRAME_LABEL = 43,
    CODE_DEFINE_BEHAVIOUR = 44,
    CODE_SOUND_STREAM_HEAD2 = 45,
    CODE_DEFINE_MORPH_SHAPE = 46,
    CODE_GENERATE_FRAME = 47,
    CODE_DEFINE_FONT2 = 48,
    CODE_GEN_COMMAND = 49,
    CODE_DEFINE_COMMAND_OBJECT = 50,
    CODE_CHARACTER_SET = 51,
    CODE_EXTERNAL_FONT = 52,
    CODE_DEFINE_FUNCTION = 53,
    CODE_PLACE_FUNCTION = 54,
    CODE_GEN_TAG_OBJECTS = 55,
    CODE_EXPORT_ASSETS = 56,
    CODE_IMPORT_ASSETS = 57,
    CODE_ENABLE_DEBUGGER = 58,
    CODE_DO_INIT_ACTION = 59,
    CODE_DEFINE_VIDEO_STREAM = 60,
    CODE_VIDEO_FRAME = 61,
    CODE_DEFINE_FONT_INFO2 = 62,
    CODE_DEBUG_ID = 63,
    CODE_ENABLE_DEBUGGER2 = 64,
    CODE_SCRIPT_LIMITS = 65,
    CODE_SET_TAB_INDEX = 66,
    CODE_FILE_ATTRIBUTES = 69,
    CODE_PLACE_OBJECT3 = 70,
    CODE_IMPORT_ASSETS2 = 71,
    CODE_DO_ABC_DEFINE = 72,
    CODE_DEFINE_FONT_ALIGN_ZONES = 73,
    CODE_CSM_TEXT_SETTINGS = 74,
    CODE_DEFINE_FONT3 = 75,
    CODE_SYMBOL_CLASS = 76,
    CODE_METADATA = 77,
    CODE_DEFINE_SCALING_GRID = 78,
    CODE_DO_ABC = 82,
    CODE_DEFINE_SHAPE4 = 83,
    CODE_DEFINE_MORPH_SHAPE2 = 84,
    CODE_DEFINE_SCENE_AND_FRAME_LABEL_DATA = 86,
    CODE_DEFINE_BINARY_DATA = 87,
    CODE_DEFINE_FONT_NAME = 88,
    CODE_START_SOUND2 = 89,
    CODE_DEFINE_BITS_JPEG4 = 90,
    CODE_DEFINE_FONT4 = 91,
    CODE_TELEMETRY = 93
}
export declare function getSwfTagCodeName(tagCode: SwfTagCode): string;
export declare enum DefinitionTags {
    CODE_DEFINE_SHAPE = 2,
    CODE_DEFINE_BITS = 6,
    CODE_DEFINE_BUTTON = 7,
    CODE_DEFINE_FONT = 10,
    CODE_DEFINE_TEXT = 11,
    CODE_DEFINE_SOUND = 14,
    CODE_DEFINE_BITS_LOSSLESS = 20,
    CODE_DEFINE_BITS_JPEG2 = 21,
    CODE_DEFINE_SHAPE2 = 22,
    CODE_DEFINE_SHAPE3 = 32,
    CODE_DEFINE_TEXT2 = 33,
    CODE_DEFINE_BUTTON2 = 34,
    CODE_DEFINE_BITS_JPEG3 = 35,
    CODE_DEFINE_BITS_LOSSLESS2 = 36,
    CODE_DEFINE_EDIT_TEXT = 37,
    CODE_DEFINE_SPRITE = 39,
    CODE_DEFINE_MORPH_SHAPE = 46,
    CODE_DEFINE_FONT2 = 48,
    CODE_DEFINE_VIDEO_STREAM = 60,
    CODE_DEFINE_FONT3 = 75,
    CODE_DEFINE_SHAPE4 = 83,
    CODE_DEFINE_MORPH_SHAPE2 = 84,
    CODE_DEFINE_BINARY_DATA = 87,
    CODE_DEFINE_BITS_JPEG4 = 90,
    CODE_DEFINE_FONT4 = 91
}
export declare enum ImageDefinitionTags {
    CODE_DEFINE_BITS = 6,
    CODE_DEFINE_BITS_JPEG2 = 21,
    CODE_DEFINE_BITS_JPEG3 = 35,
    CODE_DEFINE_BITS_JPEG4 = 90
}
export declare enum FontDefinitionTags {
    CODE_DEFINE_FONT = 10,
    CODE_DEFINE_FONT2 = 48,
    CODE_DEFINE_FONT3 = 75,
    CODE_DEFINE_FONT4 = 91
}
export declare enum ControlTags {
    CODE_PLACE_OBJECT = 4,
    CODE_PLACE_OBJECT2 = 26,
    CODE_PLACE_OBJECT3 = 70,
    CODE_REMOVE_OBJECT = 5,
    CODE_REMOVE_OBJECT2 = 28,
    CODE_START_SOUND = 15,
    CODE_START_SOUND2 = 89,
    CODE_VIDEO_FRAME = 61
}
export interface Matrix {
    a: number;
    b: number;
    c: number;
    d: number;
    tx: number;
    ty: number;
}
export interface ColorTransform {
    redMultiplier: number;
    greenMultiplier: number;
    blueMultiplier: number;
    alphaMultiplier: number;
    redOffset: number;
    greenOffset: number;
    blueOffset: number;
    alphaOffset: number;
}
export interface DisplayListTag extends SwfTag {
    depth: number;
}
export interface PlaceObjectTag extends DisplayListTag {
    actionBlocksPrecedence?: number;
    symbolId?: number;
    flags: number;
    matrix?: Matrix;
    cxform?: ColorTransform;
    className?: string;
    ratio?: number;
    name?: string;
    clipDepth?: number;
    filters?: any[];
    blendMode?: number;
    bmpCache?: number;
    visibility?: boolean;
    backgroundColor?: number;
    events?: ClipEvents[];
}
export declare const enum PlaceObjectFlags {
    Move = 1,
    HasCharacter = 2,
    HasMatrix = 4,
    HasColorTransform = 8,
    HasRatio = 16,
    HasName = 32,
    HasClipDepth = 64,
    HasClipActions = 128,
    HasFilterList = 256,
    HasBlendMode = 512,
    HasCacheAsBitmap = 1024,
    HasClassName = 2048,
    HasImage = 4096,
    HasVisible = 8192,
    OpaqueBackground = 16384,
    Reserved = 32768
}
export declare const enum AVM1ClipEvents {
    Load = 1,
    EnterFrame = 2,
    Unload = 4,
    MouseMove = 8,
    MouseDown = 16,
    MouseUp = 32,
    KeyDown = 64,
    KeyUp = 128,
    Data = 256,
    Initialize = 512,
    Press = 1024,
    Release = 2048,
    ReleaseOutside = 4096,
    RollOver = 8192,
    RollOut = 16384,
    DragOver = 32768,
    DragOut = 65536,
    KeyPress = 131072,
    Construct = 262144
}
export interface ClipEvents {
    flags: number;
    keyCode?: number;
    actionsBlock: Uint8Array;
}
export interface Filter {
    type: number;
}
export interface GlowFilter extends Filter {
    colors: number[];
    ratios?: number[];
    blurX: number;
    blurY: number;
    angle?: number;
    distance?: number;
    strength: number;
    inner: boolean;
    knockout: boolean;
    compositeSource: boolean;
    onTop?: boolean;
    quality: number;
}
export interface BlurFilter extends Filter {
    blurX: number;
    blurY: number;
    quality: number;
}
export interface ConvolutionFilter extends Filter {
    matrixX: number;
    matrixY: number;
    divisor: number;
    bias: number;
    matrix: number[];
    color: number;
    clamp: boolean;
    preserveAlpha: boolean;
}
export interface ColorMatrixFilter extends Filter {
    matrix: number[];
}
export interface RemoveObjectTag extends DisplayListTag {
    depth: number;
    symbolId?: number;
}
export interface ImageTag extends DefinitionTag {
    deblock?: number;
    imgData: Uint8Array;
    alphaData?: Uint8Array;
    mimeType: string;
    jpegTables?: {
        data: Uint8Array;
    };
}
export interface ButtonTag extends DefinitionTag {
    characters?: ButtonCharacter[];
    actionsData?: Uint8Array;
    trackAsMenu?: boolean;
    buttonActions?: ButtonCondAction[];
}
export interface ButtonCharacter {
    flags: number;
    symbolId?: number;
    depth?: number;
    matrix?: Matrix;
    cxform?: ColorTransform;
    filters?: Filter[];
    blendMode?: number;
    buttonActions?: ButtonCondAction[];
}
export declare const enum ButtonCharacterFlags {
    StateUp = 1,
    StateOver = 2,
    StateDown = 4,
    StateHitTest = 8,
    HasFilterList = 16,
    HasBlendMode = 32
}
export interface ButtonCondAction {
    keyCode: number;
    stateTransitionFlags: number;
    actionsData: Uint8Array;
}
export interface BinaryDataTag extends DefinitionTag {
    data: Uint8Array;
}
export interface FontTag extends DefinitionTag {
    flags: number;
    language?: number;
    name?: string;
    copyright?: string;
    resolution?: number;
    offsets?: number[];
    mapOffset?: number;
    glyphs?: Glyph[];
    codes?: number[];
    ascent?: number;
    descent?: number;
    leading?: number;
    advance?: number[];
    bbox?: Bbox[];
    kerning?: Kerning[];
    data?: Uint8Array;
    fileURL?: string;
}
export declare const enum FontFlags {
    Bold = 1,
    Italic = 2,
    WideOrHasFontData = 4,
    WideOffset = 8,
    Ansi = 16,
    SmallText = 32,
    ShiftJis = 64,
    HasLayout = 128
}
export declare type Glyph = ShapeRecord[];
export interface StaticTextTag extends DefinitionTag {
    bbox: Bbox;
    matrix: Matrix;
    records: TextRecord[];
}
export interface TextRecord {
    flags: number;
    fontId?: number;
    color?: number;
    moveX?: number;
    moveY?: number;
    fontHeight?: number;
    glyphCount?: number;
    entries?: TextEntry[];
}
export declare const enum TextRecordFlags {
    HasMoveX = 1,
    HasMoveY = 2,
    HasColor = 4,
    HasFont = 8
}
export interface TextEntry {
    glyphIndex: number;
    advance: number;
}
export interface SoundTag extends DefinitionTag {
    soundFormat: number;
    soundRate: number;
    soundSize: number;
    soundType: number;
    samplesCount: number;
    soundData: Uint8Array;
}
export interface StartSoundTag extends SwfTag {
    soundId?: number;
    soundClassName?: string;
    soundInfo: SoundInfo;
}
export interface SoundInfo {
    flags: number;
    inPoint?: number;
    outPoint?: number;
    loopCount?: number;
    envelopes?: SoundEnvelope[];
}
export declare const enum SoundInfoFlags {
    HasInPoint = 1,
    HasOutPoint = 2,
    HasLoops = 4,
    HasEnvelope = 8,
    NoMultiple = 16,
    Stop = 32
}
export interface SoundEnvelope {
    pos44: number;
    volumeLeft: number;
    volumeRight: number;
}
export interface SoundStreamHeadTag {
    playbackRate: number;
    playbackSize: number;
    playbackType: number;
    streamCompression: number;
    streamRate: number;
    streamSize: number;
    streamType: number;
    samplesCount: number;
    latencySeek?: number;
}
export interface BitmapTag extends DefinitionTag {
    format: number;
    width: number;
    height: number;
    hasAlpha: boolean;
    colorTableSize?: number;
    bmpData: Uint8Array;
}
export interface TextTag extends DefinitionTag {
    bbox: Bbox;
    flags: number;
    fontId?: number;
    fontClass?: string;
    fontHeight?: number;
    color?: number;
    maxLength?: number;
    align?: number;
    leftMargin?: number;
    rightMargin?: number;
    indent?: number;
    leading?: number;
    variableName: string;
    initialText?: string;
}
export declare const enum TextFlags {
    HasFont = 1,
    HasMaxLength = 2,
    HasColor = 4,
    ReadOnly = 8,
    Password = 16,
    Multiline = 32,
    WordWrap = 64,
    HasText = 128,
    UseOutlines = 256,
    Html = 512,
    WasStatic = 1024,
    Border = 2048,
    NoSelect = 4096,
    HasLayout = 8192,
    AutoSize = 16384,
    HasFontClass = 32768
}
export interface Kerning {
    code1: number;
    code2: number;
    adjustment: number;
}
export interface ScalingGridTag extends SwfTag {
    symbolId: number;
    splitter: Bbox;
}
export interface SceneTag extends SwfTag {
    scenes: Scene[];
    labels: Label[];
}
export interface Scene {
    offset: number;
    name: string;
}
export interface Label {
    frame: number;
    name: string;
}
export declare const enum ShapeFlags {
    UsesScalingStrokes = 1,
    UsesNonScalingStrokes = 2,
    UsesFillWindingRule = 4,
    IsMorph = 8
}
export interface SolidFill extends FillStyle {
    color: number;
    colorMorph?: number;
}
export interface GradientFill extends FillStyle {
    matrix: Matrix;
    matrixMorph?: Matrix;
    spreadMode?: number;
    interpolationMode?: number;
    records: GradientRecord[];
    focalPoint?: number;
    focalPointMorph?: number;
}
export interface GradientRecord {
    ratio: number;
    color: number;
    ratioMorph?: number;
    colorMorph?: number;
}
export interface BitmapFill extends FillStyle {
    bitmapId: number;
    condition: boolean;
    matrix: Matrix;
    matrixMorph?: Matrix;
}
export interface VideoStreamTag extends DefinitionTag {
    numFrames: number;
    width: number;
    height: number;
    deblocking: number;
    smoothing: boolean;
    codecId: number;
}
export interface VideoFrameTag extends SwfTag {
    streamId: number;
    frameNum: number;
    videoData: Uint8Array;
}
