/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { ImageDefinition } from "./image";
import { BitmapTag } from "../SWFTags";
export declare const enum BitmapFormat {
    /**
     * 8-bit color mapped image.
     */
    FORMAT_COLORMAPPED = 3,
    /**
     * 15-bit RGB image.
     */
    FORMAT_15BPP = 4,
    /**
     * 24-bit RGB image, however stored as 4 byte value 0x00RRGGBB.
     */
    FORMAT_24BPP = 5
}
export declare function defineBitmap(tag: BitmapTag): {
    definition: ImageDefinition;
    type: string;
};
