import { ImageType } from "@awayjs/graphics";
import { ImageTag } from "../SWFTags";
/**
 * Parses JPEG chunks and reads image width and height information. JPEG data
 * in SWFs is encoded in chunks and not directly decodable by the JPEG parser.
 */
export declare function parseJpegChunks(bytes: Uint8Array, chunks: Uint8Array[]): void;
/**
 * Extracts PNG width and height information.
 */
export declare function parsePngHeaders(image: any, bytes: Uint8Array): void;
export interface ImageDefinition {
    type: string;
    id: number;
    width: number;
    height: number;
    mimeType: string;
    data: Uint8ClampedArray;
    dataType?: ImageType;
    image: any;
}
export interface JPEGTablesState {
    data: Uint8Array;
    parsedChunks?: Uint8Array[];
}
export declare function defineImage(tag: ImageTag): ImageDefinition;
