/**
 * Copyright 2014 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
import { SoundTag } from "../SWFTags";
export declare function packageWave(data: any, sampleRate: any, channels: any, size: any, swapBytes: any): {
    data: Uint8Array;
    mimeType: string;
};
export declare function defineSound(tag: SoundTag): {
    type: string;
    id: number;
    sampleRate: number;
    channels: number;
    pcm: any;
    packaged: any;
};
export interface DecodedSound {
    streamId: number;
    samplesCount: number;
    pcm?: Float32Array;
    data?: Uint8Array;
    seek?: number;
}
export declare class SoundStream {
    streamId: number;
    samplesCount: number;
    sampleRate: number;
    channels: number;
    streamSize: number;
    format: any;
    currentSample: number;
    allChunks: Uint8Array[];
    decode: (block: Uint8Array) => DecodedSound;
    constructor(samplesCount: any, sampleRate: any, channels: any, streamSize: any);
    static FromTag(tag: any): SoundStream;
}
