import { AXSecurityDomain } from "./run/AXSecurityDomain";


// export interface Function {
//   axApply(thisArg: any, argArray?: any[]): any;
//   axCall(thisArg: any): any;
// }

var $: AXSecurityDomain = null;

/*
  *     +--------------------------+
  *     |      Base Prototype      |
  *     +--------------------------+
  *     |- axHasPropertyInternal   |
  *     |- axHasProperty           |            +-------------------+
  *     |- axSetProperty           |     +-----#|  objectPrototype  |
  *     |- axGetProperty           |     |      +-------------------+
  *     |- axSetPublicProperty     |     |      | - sec             |
  *     |- axGetSlot               |<----+      +-------------------+
  *     |- axSetSlot               |     |
  *     |  …                       |     |
  *     |                          |     |      +-------------------+
  *     |                          |     +-----#|  objectPrototype  |
  *     |                          |            +-------------------+
  *     +--------------------------+            | - sec             |
  *                                             +-------------------+
  *                                                       ^
  *                                                       |
  *                                                       |
  *                                                       #
  *     +-----------------+                        +------------+
  *  +-#|  Class Object   |----------------------->| tPrototype |<-----------------<--------------------+
  *  |  +-----------------+                        +------------+                  |                    |
  *  |                                                    ^                        |                    |
  *  |                                                    |                        |                    |
  *  |                                                    |--------+               |                    |
  *  |                                                    |        |               #                    #
  *  |                         +------------+             |        |      +-----------------+  +-----------------+
  *  |                         | - traits   |             #        |      |     Number      |  |      Uint       |
  *  |  +-----------------+    +------------+      +------------+  |      +-----------------+  +-----------------+
  *  +-#|   Class Class   |--->| tPrototype |#---->| dPrototype |  |      | - value         |  | - value         |
  *  |  +-----------------+    +------------+      +------------+  |      +-----------------+  +-----------------+
  *  |                                ^                            |
  *  |                                |                            |      +-----------------+  +-----------------+
  *  +--------------------------------+----------------------------+-----#|     Boolean     |  |      Array      |
  *  |                                                             |      +-----------------+  +-----------------+
  *  |                                                             |      | - value         |  | - value         |
  *  |  +-----------------+    +------------+      +------------+  |      +-----------------+  +-----------------+
  *  +-#|     Class A     |--->| tPrototype |#---->| dPrototype |#-+
  *  |  +-----------------+    +------------+      +------------+         +-----------------+  +-----------------+
  *  |                         | - traits   |--+          ^               |       Int       |  |    Function     |
  *  |                         +------------+  |          |               +-----------------+  +-----------------+
  *  |                                ^        |          |               | - value         |  | - value         |
  *  |                                |        |          +--------+      +-----------------+  +-----------------+
  *  |                                #        |                   |
  *  |                         +------------+  |   +------------+  |      +-----------------+
  *  |                         |  Object A  |  +-->|   Traits   |  |      |     String      |
  *  |                         +------------+      +------------+  |      +-----------------+
  *  |                                                             |      | - value         |
  *  |                                                             |      +-----------------+
  *  |                                                             |
  *  |                                                             |
  *  |                                                             |
  *  |                                                             |
  *  |                                                             |
  *  | +-----------------+     +------------+      +------------+  |
  *  +#|Class B extends A|---->| tPrototype |#---->| dPrototype |#-+
  *    +-----------------+     +------------+      +------------+
  *                            | - traits   |
  *                            +------------+
  *
  */















