/**
 * Copyright 2014 Mozilla Foundation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: NationalDigitsType
module Shumway.AVMX.AS.flash.globalization {
  import notImplemented = Shumway.Debug.notImplemented;
  import axCoerceString = Shumway.AVMX.axCoerceString;
  export class NationalDigitsType extends ASObject {
    
    // Called whenever the class is initialized.
    static classInitializer: any = null;

    // List of static symbols to link.
    static classSymbols: string [] = null; // [];
    
    // List of instance symbols to link.
    static instanceSymbols: string [] = null; // [];
    
    constructor () {
      super();
    }
    
    // JS -> AS Bindings
    static EUROPEAN: number /*uint*/ = 48;
    static ARABIC_INDIC: number /*uint*/ = 1632;
    static EXTENDED_ARABIC_INDIC: number /*uint*/ = 1776;
    static NKO: number /*uint*/ = 1984;
    static DEVANAGARI: number /*uint*/ = 2406;
    static BENGALI: number /*uint*/ = 2534;
    static GURMUKHI: number /*uint*/ = 2662;
    static GUJARATI: number /*uint*/ = 2790;
    static ORIYA: number /*uint*/ = 2918;
    static TAMIL: number /*uint*/ = 3046;
    static TELUGU: number /*uint*/ = 3174;
    static KANNADA: number /*uint*/ = 3302;
    static MALAYALAM: number /*uint*/ = 3430;
    static THAI: number /*uint*/ = 3664;
    static LAO: number /*uint*/ = 3792;
    static TIBETAN: number /*uint*/ = 3872;
    static MYANMAR: number /*uint*/ = 4160;
    static MYANMAR_SHAN: number /*uint*/ = 4240;
    static KHMER: number /*uint*/ = 6112;
    static MONGOLIAN: number /*uint*/ = 6160;
    static LIMBU: number /*uint*/ = 6470;
    static NEW_TAI_LUE: number /*uint*/ = 6608;
    static BALINESE: number /*uint*/ = 6992;
    static SUNDANESE: number /*uint*/ = 7088;
    static LEPCHA: number /*uint*/ = 7232;
    static OL_CHIKI: number /*uint*/ = 7248;
    static VAI: number /*uint*/ = 42528;
    static SAURASHTRA: number /*uint*/ = 43216;
    static KAYAH_LI: number /*uint*/ = 43264;
    static CHAM: number /*uint*/ = 43600;
    static FULL_WIDTH: number /*uint*/ = 65296;
    static OSMANYA: number /*uint*/ = 66720;
    
    
    // AS -> JS Bindings
    
  }
}
