import { ASObject } from "../../avm2/nat";

/**
 * Copyright 2014 Mozilla Foundation
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Class: CertificateStatus
export class CertificateStatus extends ASObject {
  
  // Called whenever the class is initialized.
  static classInitializer: any = null;

  // List of static symbols to link.
  static classSymbols: string [] = null; // [];
  
  // List of instance symbols to link.
  static instanceSymbols: string [] = null; // [];
  
  constructor () {
    super();
  }
  
  // JS -> AS Bindings
  static TRUSTED: string = "trusted";
  static UNKNOWN: string = "unknown";
  static INVALID: string = "invalid";
  static EXPIRED: string = "expired";
  static NOT_YET_VALID: string = "notYetValid";
  static PRINCIPAL_MISMATCH: string = "principalMismatch";
  static UNTRUSTED_SIGNERS: string = "untrustedSigners";
  static REVOKED: string = "revoked";
  static INVALID_CHAIN: string = "invalidChain";
}