(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
    typeof define === 'function' && define.amd ? define(['exports'], factory) :
    (factory((global.AwayjsSwfViewer = {})));
}(this, (function (exports) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics$1 = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    function __extends$1(d, b) {
        extendStatics$1(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var StreamingAudioChannel = /** @class */ (function () {
        function StreamingAudioChannel(groupID, groupVolume, groupPan) {
            var _this = this;
            if (groupID === void 0) { groupID = 0; }
            if (groupVolume === void 0) { groupVolume = 1; }
            if (groupPan === void 0) { groupPan = 1; }
            this._isPlaying = false;
            this._isLooping = false;
            this._groupID = 0;
            this._groupVolume = 1;
            this._groupPan = 0;
            this._startTime = 0;
            this._groupID = groupID;
            this._groupVolume = groupVolume;
            this._groupPan = groupPan;
            this._sourceOpenDelegate = function (event) { return _this._sourceOpen(event); };
            this._updateEndDelegate = function (event) { return _this._updateEnd(event); };
            this._audio = new Audio();
            this._audio.ontimeupdate = function (event) { return _this._onTimeUpdate(event); };
            this._updateSource();
        }
        StreamingAudioChannel.stopAllSounds = function (channelGroup) {
            if (channelGroup === void 0) { channelGroup = -1; }
            var len = StreamingAudioChannel._channels.length;
            if (channelGroup < 0) {
                for (var j = 0; j < len; j++) {
                    StreamingAudioChannel._channels[j].stop();
                }
                StreamingAudioChannel._channels.length = 0;
                return;
            }
            var aliveChannels = [];
            for (var j = 0; j < len; j++) {
                if (StreamingAudioChannel._channels[j].groupID == channelGroup) {
                    StreamingAudioChannel._channels[j].stop();
                }
                else {
                    aliveChannels[aliveChannels.length] = StreamingAudioChannel._channels[j];
                }
            }
            StreamingAudioChannel._channels = aliveChannels;
        };
        StreamingAudioChannel.setChannelGroupVolume = function (value, channelGroup) {
            if (channelGroup === void 0) { channelGroup = -1; }
            var len = StreamingAudioChannel._channels.length;
            if (channelGroup < 0) {
                for (var j = 0; j < len; j++) {
                    StreamingAudioChannel._channels[j].groupVolume = value;
                }
                return;
            }
            for (var j = 0; j < len; j++) {
                if (StreamingAudioChannel._channels[j].groupID == channelGroup) {
                    StreamingAudioChannel._channels[j].groupVolume = value;
                }
            }
        };
        Object.defineProperty(StreamingAudioChannel.prototype, "duration", {
            get: function () {
                return this._duration;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(StreamingAudioChannel.prototype, "currentTime", {
            get: function () {
                return this._audio.currentTime - this._startTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(StreamingAudioChannel.prototype, "groupID", {
            get: function () {
                return this._groupID;
            },
            set: function (value) {
                this._groupID = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(StreamingAudioChannel.prototype, "groupVolume", {
            get: function () {
                return this._groupVolume;
            },
            set: function (value) {
                if (this._groupVolume == value)
                    return;
                this._groupVolume = value;
                this._audio.volume = this._groupVolume * this._volume;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(StreamingAudioChannel.prototype, "groupPan", {
            get: function () {
                return this._groupPan;
            },
            set: function (value) {
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(StreamingAudioChannel.prototype, "volume", {
            get: function () {
                return this._volume;
            },
            set: function (value) {
                if (this._volume == value)
                    return;
                this._volume = value;
                this._audio.volume = this._volume;
            },
            enumerable: true,
            configurable: true
        });
        StreamingAudioChannel.prototype.isPlaying = function () {
            return this._isPlaying;
        };
        StreamingAudioChannel.prototype.isLooping = function () {
            return this._isLooping;
        };
        StreamingAudioChannel.prototype.isDecoding = function () {
            return false;
        };
        Object.defineProperty(StreamingAudioChannel.prototype, "pan", {
            get: function () {
                //todo
                return 0;
            },
            set: function (value) {
                //todo
            },
            enumerable: true,
            configurable: true
        });
        StreamingAudioChannel.prototype.play = function (buffer, offset, loop) {
            if (offset === void 0) { offset = 0; }
            if (loop === void 0) { loop = false; }
            this._isPlaying = true;
            if (this._isLooping || this._isLooping != loop) {
                this._isLooping = loop;
                this._sourceDirty = true;
            }
            if (this._sourceDirty)
                this._updateSource();
            this._buffer = buffer;
            this._offset = offset;
            this._audio.volume = this._groupVolume * this._volume;
            if (!this._isQueuing && !this._isOpening)
                this._queueBuffer();
        };
        StreamingAudioChannel.prototype.stop = function () {
            this._audio.pause();
            this._isPlaying = false;
            this._isLooping = false;
        };
        StreamingAudioChannel.prototype._sourceOpen = function (event) {
            this._isOpening = false;
            //TODO: find out how in the name of all that is holy how this can be executed more than once on a MediaSource object
            if (this._mediaSource.activeSourceBuffers.length) {
                console.log("ERR: double sourceopen event called");
                return;
            }
            this._sourceBuffer = this._mediaSource.addSourceBuffer('audio/mpeg');
            this._sourceBuffer.addEventListener("updateend", this._updateEndDelegate);
            if (this._isPlaying)
                this._queueBuffer();
        };
        StreamingAudioChannel.prototype._queueBuffer = function () {
            this._isQueuing = true;
            this._startTime = this._sourceBuffer.timestampOffset;
            this._sourceBuffer.appendBuffer(this._buffer);
        };
        StreamingAudioChannel.prototype._updateEnd = function (event) {
            this._isQueuing = false;
            if (this._isLooping)
                this._mediaSource.endOfStream();
            this._duration = this._sourceBuffer.timestampOffset - this._startTime;
            this._audio.currentTime = this._startTime + this._offset;
            this._audio.play();
        };
        StreamingAudioChannel.prototype._onTimeUpdate = function (event) {
            //TODO: more accurate end detection
            if (!this._isLooping && this._duration < this._audio.currentTime - this._startTime + 0.1)
                this.stop();
        };
        StreamingAudioChannel.prototype._updateSource = function () {
            if (this._mediaSource)
                this._disposeSource();
            this._isQueuing = false;
            this._isOpening = true;
            this._mediaSource = new MediaSource();
            this._mediaSource.addEventListener("sourceopen", this._sourceOpenDelegate);
            this._urlString = URL.createObjectURL(this._mediaSource);
            this._audio.src = this._urlString;
            this._audio.loop = this._isLooping;
            this._sourceDirty = false;
        };
        StreamingAudioChannel.prototype._disposeSource = function () {
            if (!this._isOpening) {
                if (this._sourceBuffer.timestampOffset)
                    this._sourceBuffer.remove(0, this._sourceBuffer.timestampOffset);
                this._sourceBuffer.removeEventListener("updateend", this._updateEndDelegate);
                this._mediaSource.removeSourceBuffer(this._sourceBuffer);
                delete this._sourceBuffer;
                this._sourceBuffer = null;
            }
            this._mediaSource.removeEventListener("sourceopen", this._sourceOpenDelegate);
            URL.revokeObjectURL(this._urlString);
            delete this._mediaSource;
            this._mediaSource = null;
        };
        StreamingAudioChannel.maxChannels = 4;
        StreamingAudioChannel._channels = new Array();
        return StreamingAudioChannel;
    }());

    var WebAudioChannel = /** @class */ (function () {
        function WebAudioChannel(groupID, groupVolume, groupPan) {
            var _this = this;
            if (groupID === void 0) { groupID = 0; }
            if (groupVolume === void 0) { groupVolume = 1; }
            if (groupPan === void 0) { groupPan = 1; }
            this._isPlaying = false;
            this._isLooping = false;
            this._isDecoding = false;
            this._volume = 1;
            this._pan = 0;
            this._groupID = 0;
            this._groupVolume = 1;
            this._groupPan = 0;
            this._startTime = 0;
            this._groupID = groupID;
            this._groupVolume = groupVolume;
            this._groupPan = groupPan;
            this._audioCtx = WebAudioChannel.getAudioContext();
            this._usingNativePanner = typeof this._audioCtx.createStereoPanner === 'function';
            this._gainNode = this._audioCtx.createGain();
            this._gainNode.gain.value = this._groupVolume * this._volume;
            this._pannerNode = this._usingNativePanner ? this._audioCtx.createStereoPanner() : this._audioCtx.createPanner();
            if (this._usingNativePanner)
                this._pannerNode.pan.value = this._pan;
            else
                this._pannerNode.setPosition(Math.sin(this._pan * (Math.PI / 2)), 0, Math.cos(this._pan * (Math.PI / 2)));
            this._gainNode.connect(this._pannerNode);
            this._pannerNode.connect(this._audioCtx.destination);
            this._onEndedDelegate = function (event) { return _this._onEnded(event); };
        }
        WebAudioChannel.getAudioContext = function () {
            if (!WebAudioChannel._audioCtx && (window["AudioContext"] || window["webkitAudioContext"]))
                WebAudioChannel._audioCtx = new (window["AudioContext"] || window["webkitAudioContext"])();
            if (WebAudioChannel._audioCtx && WebAudioChannel._audioCtx.state == "suspended")
                WebAudioChannel._audioCtx.resume();
            return WebAudioChannel._audioCtx;
        };
        WebAudioChannel.stopAllSounds = function (channelGroup) {
            if (channelGroup === void 0) { channelGroup = -1; }
            var len = WebAudioChannel._channels.length;
            if (channelGroup < 0) {
                for (var j = 0; j < len; j++) {
                    WebAudioChannel._channels[j].stop();
                }
                WebAudioChannel._channels.length = 0;
                return;
            }
            var aliveChannels = [];
            for (var j = 0; j < len; j++) {
                if (WebAudioChannel._channels[j].groupID == channelGroup) {
                    WebAudioChannel._channels[j].stop();
                }
                else {
                    aliveChannels[aliveChannels.length] = WebAudioChannel._channels[j];
                }
            }
            WebAudioChannel._channels = aliveChannels;
        };
        WebAudioChannel.setChannelGroupVolume = function (value, channelGroup) {
            if (channelGroup === void 0) { channelGroup = -1; }
            var len = WebAudioChannel._channels.length;
            if (channelGroup < 0) {
                for (var j = 0; j < len; j++) {
                    WebAudioChannel._channels[j].groupVolume = value;
                }
                return;
            }
            for (var j = 0; j < len; j++) {
                if (WebAudioChannel._channels[j].groupID == channelGroup) {
                    WebAudioChannel._channels[j].groupVolume = value;
                }
            }
        };
        Object.defineProperty(WebAudioChannel.prototype, "duration", {
            get: function () {
                return this._duration;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioChannel.prototype, "currentTime", {
            get: function () {
                if (this._isDecoding) {
                    return this._currentTime;
                }
                return this._audioCtx.currentTime - this._startTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioChannel.prototype, "groupID", {
            get: function () {
                return this._groupID;
            },
            set: function (value) {
                this._groupID = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioChannel.prototype, "groupVolume", {
            get: function () {
                return this._groupVolume;
            },
            set: function (value) {
                if (this._groupVolume == value)
                    return;
                this._groupVolume = value;
                this._gainNode.gain.value = this._groupVolume * this._volume;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioChannel.prototype, "groupPan", {
            get: function () {
                return this._groupPan;
            },
            set: function (value) {
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioChannel.prototype, "volume", {
            get: function () {
                return this._volume;
            },
            set: function (value) {
                if (this._volume == value)
                    return;
                this._volume = value;
                this._gainNode.gain.value = this._groupVolume * this._volume;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioChannel.prototype, "pan", {
            get: function () {
                return this._pan;
            },
            set: function (value) {
                if (this._pan == value)
                    return;
                this._pan = value;
                if (this._usingNativePanner)
                    this._pannerNode.pan.value = this._pan;
                else
                    this._pannerNode.setPosition(Math.sin(this._pan * (Math.PI / 2)), 0, Math.cos(this._pan * (Math.PI / 2)));
            },
            enumerable: true,
            configurable: true
        });
        WebAudioChannel.prototype.isPlaying = function () {
            return this._isPlaying;
        };
        WebAudioChannel.prototype.isLooping = function () {
            return this._isLooping;
        };
        WebAudioChannel.prototype.isDecoding = function () {
            return this._isDecoding;
        };
        WebAudioChannel.prototype.play = function (buffer, offset, loop, id) {
            var _this = this;
            if (offset === void 0) { offset = 0; }
            if (loop === void 0) { loop = false; }
            if (id === void 0) { id = 0; }
            this._isPlaying = true;
            this._isLooping = loop;
            this._currentTime = offset;
            //console.log("play with offset time", offset)
            this._id = id;
            this._isDecoding = true;
            buffer = buffer.slice(0);
            //fast path for short sounds
            if (WebAudioChannel._decodeCache[id])
                this._onDecodeComplete(WebAudioChannel._decodeCache[id]);
            else if (!WebAudioChannel._errorCache[id])
                this._audioCtx.decodeAudioData(buffer, function (buffer) { return _this._onDecodeComplete(buffer); }, function (event) { return _this._onError(event); });
            else
                this.stop();
        };
        WebAudioChannel.prototype.stop = function () {
            // for AVM1 it is a bug to stop a audio thats currently decoding.
            // when we call stopAllASounds() during audio-decode, this audio should still play
            //if(this._isDecoding){
            //	return;
            //}
            if (!this._isPlaying)
                return;
            this._isPlaying = false;
            this._isLooping = false;
            this._isDecoding = false;
            if (this._source)
                this._disposeSource();
        };
        WebAudioChannel.prototype._onDecodeComplete = function (buffer) {
            if (!this._isPlaying)
                return;
            this._isDecoding = false;
            //if (buffer.duration < 2) //cache all buffers?
            WebAudioChannel._decodeCache[this._id] = buffer;
            if (this._source)
                this._disposeSource();
            this._source = this._audioCtx.createBufferSource();
            this._source.loop = this._isLooping;
            this._source.connect(this._gainNode);
            this._source.buffer = buffer;
            this._duration = buffer.duration;
            this._pan = 0;
            this._startTime = this._audioCtx.currentTime - this._currentTime;
            //console.log("play with offset time decode complete", this._audioCtx.currentTime, this._currentTime, this._startTime)
            this._source.onended = this._onEndedDelegate;
            try {
                this._gainNode.gain.value = this._groupVolume * this._volume;
                if (this._usingNativePanner)
                    this._pannerNode.pan.value = this._pan;
                else
                    this._pannerNode.setPosition(Math.sin(this._pan * (Math.PI / 2)), 0, Math.cos(this._pan * (Math.PI / 2)));
                // TODO: offset / startTime make problem in dino-run game:
                this._source.start(this._audioCtx.currentTime, this._currentTime);
            }
            catch (error) {
                console.log("Error starting audio: " + error);
                this._disposeSource();
            }
        };
        WebAudioChannel.prototype._onError = function (event) {
            console.log("Error with decoding audio data");
            WebAudioChannel._errorCache[this._id] = true;
            this.stop();
        };
        WebAudioChannel.prototype._onEnded = function (event) {
            if (this.onSoundComplete) {
                this.onSoundComplete();
            }
            this.stop();
        };
        WebAudioChannel.prototype._disposeSource = function () {
            //clean up
            this._source.onended = null;
            this._source.stop(this._audioCtx.currentTime);
            this._source.disconnect();
            // delete this._source.buffer;
            // delete this._source;
            this._source = null;
        };
        WebAudioChannel.maxChannels = 64; // for icycle: 128;
        WebAudioChannel._channels = new Array();
        WebAudioChannel._decodeCache = new Object();
        WebAudioChannel._errorCache = new Object();
        return WebAudioChannel;
    }());
    var audioCtx = WebAudioChannel.getAudioContext();
    // context state at this time is `undefined` in iOS8 Safari
    if (audioCtx && audioCtx.state === 'suspended') {
        var resume = function () {
            audioCtx.resume();
            //create empty buffer
            var buffer = audioCtx.createBuffer(1, 1, 22050);
            var source = audioCtx.createBufferSource();
            source.buffer = buffer;
            source.connect(audioCtx.destination);
            source.start();
            setTimeout(function () {
                if (audioCtx.state === 'running') {
                    document.removeEventListener('mousedown', resume, false);
                }
            }, 0);
        };
        document.addEventListener('mousedown', resume, false);
    }

    var ErrorBase = /** @class */ (function () {
        function ErrorBase(message, id, _name) {
            if (message === void 0) { message = ''; }
            if (id === void 0) { id = 0; }
            if (_name === void 0) { _name = ''; }
            this._errorID = 0; //Contains the reference number associated with the specific error message.
            this._messsage = ''; //Contains the message associated with the Error object.
            this._name = ''; // Contains the name of the Error object.
            this._messsage = message;
            this._name = name;
            this._errorID = id;
        }
        Object.defineProperty(ErrorBase.prototype, "message", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return this._messsage;
            },
            /**
             *
             * @param value
             */
            set: function (value) {
                this._messsage = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ErrorBase.prototype, "name", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return this._name;
            },
            /**
             *
             * @param value
             */
            set: function (value) {
                this._name = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ErrorBase.prototype, "errorID", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                return this._errorID;
            },
            enumerable: true,
            configurable: true
        });
        return ErrorBase;
    }());

    /**
     * AbstractMethodError is thrown when an abstract method is called. The method in question should be overridden
     * by a concrete subclass.
     */
    var AbstractMethodError = /** @class */ (function (_super) {
        __extends$1(AbstractMethodError, _super);
        /**
         * Create a new AbstractMethodError.
         * @param message An optional message to override the default error message.
         * @param id The id of the error.
         */
        function AbstractMethodError(message, id) {
            if (message === void 0) { message = null; }
            if (id === void 0) { id = 0; }
            return _super.call(this, message || "An abstract method was called! Either an instance of an abstract export class was created, or an abstract method was not overridden by the subclass.", id) || this;
        }
        return AbstractMethodError;
    }(ErrorBase));

    var ByteArrayBase = /** @class */ (function () {
        function ByteArrayBase() {
            this.position = 0;
            this.length = 0;
            this._mode = "";
        }
        ByteArrayBase.prototype.writeByte = function (b) {
            throw "Virtual method";
        };
        ByteArrayBase.prototype.readByte = function () {
            throw "Virtual method";
        };
        ByteArrayBase.prototype.writeUnsignedByte = function (b) {
            throw "Virtual method";
        };
        ByteArrayBase.prototype.readUnsignedByte = function () {
            throw "Virtual method";
        };
        ByteArrayBase.prototype.writeUnsignedShort = function (b) {
            throw "Virtual method";
        };
        ByteArrayBase.prototype.readUnsignedShort = function () {
            throw "Virtual method";
        };
        ByteArrayBase.prototype.writeUnsignedInt = function (b) {
            throw "Virtual method";
        };
        ByteArrayBase.prototype.readUnsignedInt = function () {
            throw "Virtual method";
        };
        ByteArrayBase.prototype.writeFloat = function (b) {
            throw "Virtual method";
        };
        ByteArrayBase.prototype.toFloatBits = function (x) {
            throw "Virtual method";
        };
        ByteArrayBase.prototype.readFloat = function (b) {
            throw "Virtual method";
        };
        ByteArrayBase.prototype.fromFloatBits = function (x) {
            throw "Virtual method";
        };
        ByteArrayBase.prototype.getBytesAvailable = function () {
            throw new AbstractMethodError('ByteArrayBase, getBytesAvailable() not implemented ');
        };
        ByteArrayBase.prototype.toString = function () {
            return "[ByteArray] ( " + this._mode + " ) position=" + this.position + " length=" + this.length;
        };
        ByteArrayBase.prototype.compareEqual = function (other, count) {
            if (count == undefined || count > this.length - this.position)
                count = this.length - this.position;
            if (count > other.length - other.position)
                count = other.length - other.position;
            var r = true;
            while (r && count >= 4) {
                count -= 4;
                if (this.readUnsignedInt() != other.readUnsignedInt())
                    r = false;
            }
            while (r && count >= 1) {
                count--;
                if (this.readUnsignedByte() != other.readUnsignedByte())
                    r = false;
            }
            var c0;
            this.position -= (c0 - count);
            other.position -= (c0 - count);
            return r;
        };
        ByteArrayBase.prototype.writeBase64String = function (s) {
            for (var i = 0; i < s.length; i++) {
                var v = s.charAt(i);
            }
        };
        ByteArrayBase.prototype.dumpToConsole = function () {
            var oldpos = this.position;
            this.position = 0;
            var nstep = 8;
            function asHexString(x, digits) {
                var lut = ["0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f"];
                var sh = "";
                for (var d = 0; d < digits; d++) {
                    sh = lut[(x >> (d << 2)) & 0xf] + sh;
                }
                return sh;
            }
            for (var i = 0; i < this.length; i += nstep) {
                var s = asHexString(i, 4) + ":";
                for (var j = 0; j < nstep && i + j < this.length; j++) {
                    s += " " + asHexString(this.readUnsignedByte(), 2);
                }
                console.log(s);
            }
            this.position = oldpos;
        };
        ByteArrayBase.prototype.readBase64String = function (count) {
            if (count == undefined || count > this.length - this.position)
                count = this.length - this.position;
            if (!(count > 0))
                return "";
            return ByteArrayBase.internalGetBase64String(count, this.readUnsignedByte, this);
        };
        ByteArrayBase.internalGetBase64String = function (count, getUnsignedByteFunc, self) {
            var r = "";
            var b0, b1, b2, enc1, enc2, enc3, enc4;
            var base64Key = ByteArrayBase.Base64Key;
            while (count >= 3) {
                b0 = getUnsignedByteFunc.apply(self);
                b1 = getUnsignedByteFunc.apply(self);
                b2 = getUnsignedByteFunc.apply(self);
                enc1 = b0 >> 2;
                enc2 = ((b0 & 3) << 4) | (b1 >> 4);
                enc3 = ((b1 & 15) << 2) | (b2 >> 6);
                enc4 = b2 & 63;
                r += base64Key.charAt(enc1) + base64Key.charAt(enc2) + base64Key.charAt(enc3) + base64Key.charAt(enc4);
                count -= 3;
            }
            // pad
            if (count == 2) {
                b0 = getUnsignedByteFunc.apply(self);
                b1 = getUnsignedByteFunc.apply(self);
                enc1 = b0 >> 2;
                enc2 = ((b0 & 3) << 4) | (b1 >> 4);
                enc3 = ((b1 & 15) << 2);
                r += base64Key.charAt(enc1) + base64Key.charAt(enc2) + base64Key.charAt(enc3) + "=";
            }
            else if (count == 1) {
                b0 = getUnsignedByteFunc.apply(self);
                enc1 = b0 >> 2;
                enc2 = ((b0 & 3) << 4);
                r += base64Key.charAt(enc1) + base64Key.charAt(enc2) + "==";
            }
            return r;
        };
        ByteArrayBase.Base64Key = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
        return ByteArrayBase;
    }());

    var ByteArray = /** @class */ (function (_super) {
        __extends$1(ByteArray, _super);
        function ByteArray(maxlength) {
            if (maxlength === void 0) { maxlength = 4; }
            var _this = _super.call(this) || this;
            _this._mode = "Typed array";
            _this.maxlength = Math.max((maxlength + 255) & (~255), 4);
            _this.arraybytes = new ArrayBuffer(_this.maxlength);
            _this.unalignedarraybytestemp = new ArrayBuffer(16);
            return _this;
        }
        ByteArray.prototype.ensureWriteableSpace = function (n) {
            this.ensureSpace(n + this.position);
        };
        ByteArray.prototype.setArrayBuffer = function (aBuffer) {
            this.ensureSpace(aBuffer.byteLength);
            this.length = aBuffer.byteLength;
            var inInt8AView = new Int8Array(aBuffer);
            var localInt8View = new Int8Array(this.arraybytes, 0, this.length);
            localInt8View.set(inInt8AView);
            this.position = 0;
        };
        ByteArray.prototype.writeArrayBuffer = function (aBuffer) {
            this.ensureWriteableSpace(aBuffer.byteLength);
            var inInt8AView = new Int8Array(aBuffer);
            var localInt8View = new Int8Array(this.arraybytes, this.length, aBuffer.byteLength);
            localInt8View.set(inInt8AView);
            this.length += aBuffer.byteLength;
            this.position = this.length;
        };
        ByteArray.prototype.writeByteArray = function (ba) {
            this.ensureWriteableSpace(ba.length);
            var inInt8AView = new Int8Array(ba.arraybytes, 0, ba.length);
            var localInt8View = new Int8Array(this.arraybytes, this.length, ba.length);
            localInt8View.set(inInt8AView);
            this.length += ba.length;
            this.position = this.length;
        };
        ByteArray.prototype.getBytesAvailable = function () {
            return (this.length) - (this.position);
        };
        ByteArray.prototype.ensureSpace = function (n) {
            if (n > this.maxlength) {
                var newmaxlength = (n + 255) & (~255);
                var newarraybuffer = new ArrayBuffer(newmaxlength);
                var view = new Uint8Array(this.arraybytes, 0, this.length);
                var newview = new Uint8Array(newarraybuffer, 0, this.length);
                newview.set(view); // memcpy
                this.arraybytes = newarraybuffer;
                this.maxlength = newmaxlength;
            }
        };
        ByteArray.prototype.writeObject = function (object) {
            console.log("writeObject not implemented yet in core/ByteArray");
        };
        ByteArray.prototype.readObject = function () {
            console.log("readObject not implemented yet in core/ByteArray");
            return {};
        };
        ByteArray.prototype.writeByte = function (b) {
            this.ensureWriteableSpace(1);
            var view = new Int8Array(this.arraybytes);
            view[this.position++] = (~~b); // ~~ is cast to int in js...
            if (this.position > this.length) {
                this.length = this.position;
            }
        };
        ByteArray.prototype.readByte = function () {
            if (this.position >= this.length)
                throw "ByteArray out of bounds read. Positon=" + this.position + ", Length=" + this.length;
            var view = new Int8Array(this.arraybytes);
            return view[this.position++];
        };
        ByteArray.prototype.readBytes = function (bytes, offset, length) {
            if (offset === void 0) { offset = 0; }
            if (length === void 0) { length = 0; }
            if (length == null)
                length = bytes.length;
            bytes.ensureWriteableSpace(offset + length);
            var byteView = new Int8Array(bytes.arraybytes);
            var localByteView = new Int8Array(this.arraybytes);
            byteView.set(localByteView.subarray(this.position, this.position + length), offset);
            this.position += length;
            if (length + offset > bytes.length)
                bytes.length += (length + offset) - bytes.length;
        };
        ByteArray.prototype.writeUnsignedByte = function (b) {
            this.ensureWriteableSpace(1);
            var view = new Uint8Array(this.arraybytes);
            view[this.position++] = (~~b) & 0xff; // ~~ is cast to int in js...
            if (this.position > this.length)
                this.length = this.position;
        };
        ByteArray.prototype.readUnsignedByte = function () {
            if (this.position >= this.length)
                throw "ByteArray out of bounds read. Positon=" + this.position + ", Length=" + this.length;
            var view = new Uint8Array(this.arraybytes);
            return view[this.position++];
        };
        ByteArray.prototype.writeUnsignedShort = function (b) {
            this.ensureWriteableSpace(2);
            if ((this.position & 1) == 0) {
                var view = new Uint16Array(this.arraybytes);
                view[this.position >> 1] = (~~b) & 0xffff; // ~~ is cast to int in js...
            }
            else {
                var view = new Uint16Array(this.unalignedarraybytestemp, 0, 1);
                view[0] = (~~b) & 0xffff;
                var view2 = new Uint8Array(this.arraybytes, this.position, 2);
                var view3 = new Uint8Array(this.unalignedarraybytestemp, 0, 2);
                view2.set(view3);
            }
            this.position += 2;
            if (this.position > this.length)
                this.length = this.position;
        };
        ByteArray.prototype.readUTFBytes = function (len) {
            var value = "";
            var max = this.position + len;
            var data = new DataView(this.arraybytes);
            // utf8-encode
            while (this.position < max) {
                var c = data.getUint8(this.position++);
                if (c < 0x80) {
                    if (c == 0)
                        break;
                    value += String.fromCharCode(c);
                }
                else if (c < 0xE0) {
                    value += String.fromCharCode(((c & 0x3F) << 6) | (data.getUint8(this.position++) & 0x7F));
                }
                else if (c < 0xF0) {
                    var c2 = data.getUint8(this.position++);
                    value += String.fromCharCode(((c & 0x1F) << 12) | ((c2 & 0x7F) << 6) | (data.getUint8(this.position++) & 0x7F));
                }
                else {
                    var c2 = data.getUint8(this.position++);
                    var c3 = data.getUint8(this.position++);
                    value += String.fromCharCode(((c & 0x0F) << 18) | ((c2 & 0x7F) << 12) | ((c3 << 6) & 0x7F) | (data.getUint8(this.position++) & 0x7F));
                }
            }
            return value;
        };
        ByteArray.prototype.writeUTFBytes = function (s) {
            var escstr = encodeURIComponent(s);
            var binstr = escstr.replace(/%([0-9A-F]{2})/g, function (match, p1) {
                return String.fromCharCode(parseInt('0x' + p1));
            });
            this.ensureWriteableSpace(4 + binstr.length);
            this.writeInt(binstr.length);
            for (var i = 0; i < binstr.length; i++) {
                this.writeUnsignedByte(binstr.charCodeAt(i)); //todo: there are probably faster ways to do this
            }
            if (binstr.length % 4) {
                var paddingbytes = binstr.length % 4;
                for (var i = 0; i < paddingbytes; i++) {
                    this.writeUnsignedByte(0);
                }
            }
            return binstr.length;
        };
        ByteArray.prototype.readInt = function () {
            var data = new DataView(this.arraybytes);
            var int = data.getInt32(this.position, true);
            this.position += 4;
            return int;
        };
        ByteArray.prototype.readShort = function () {
            var data = new DataView(this.arraybytes);
            var short = data.getInt16(this.position, true);
            this.position += 2;
            return short;
        };
        ByteArray.prototype.readDouble = function () {
            var data = new DataView(this.arraybytes);
            var double = data.getFloat64(this.position, true);
            this.position += 8;
            return double;
        };
        ByteArray.prototype.readUnsignedShort = function () {
            if (this.position > this.length + 2)
                throw "ByteArray out of bounds read. Position=" + this.position + ", Length=" + this.length;
            if ((this.position & 1) == 0) {
                var view = new Uint16Array(this.arraybytes);
                var pa = this.position >> 1;
                this.position += 2;
                return view[pa];
            }
            else {
                var view = new Uint16Array(this.unalignedarraybytestemp, 0, 1);
                var view2 = new Uint8Array(this.arraybytes, this.position, 2);
                var view3 = new Uint8Array(this.unalignedarraybytestemp, 0, 2);
                view3.set(view2);
                this.position += 2;
                return view[0];
            }
        };
        ByteArray.prototype.writeUnsignedInt = function (b) {
            this.ensureWriteableSpace(4);
            if ((this.position & 3) == 0) {
                var view = new Uint32Array(this.arraybytes);
                view[this.position >> 2] = (~~b) & 0xffffffff; // ~~ is cast to int in js...
            }
            else {
                var view = new Uint32Array(this.unalignedarraybytestemp, 0, 1);
                view[0] = (~~b) & 0xffffffff;
                var view2 = new Uint8Array(this.arraybytes, this.position, 4);
                var view3 = new Uint8Array(this.unalignedarraybytestemp, 0, 4);
                view2.set(view3);
            }
            this.position += 4;
            if (this.position > this.length)
                this.length = this.position;
        };
        ByteArray.prototype.writeInt = function (b) {
            this.ensureWriteableSpace(4);
            if ((this.position & 3) == 0) {
                var view = new Int32Array(this.arraybytes);
                view[this.position >> 2] = (~~b); // ~~ is cast to int in js...
            }
            else {
                var view = new Int32Array(this.unalignedarraybytestemp, 0, 1);
                view[0] = (~~b);
                var view2 = new Uint8Array(this.arraybytes, this.position, 4);
                var view3 = new Uint8Array(this.unalignedarraybytestemp, 0, 4);
                view2.set(view3);
            }
            this.position += 4;
            if (this.position > this.length)
                this.length = this.position;
        };
        ByteArray.prototype.readUnsignedInt = function () {
            if (this.position > this.length + 4)
                throw "ByteArray out of bounds read. Position=" + this.position + ", Length=" + this.length;
            if ((this.position & 3) == 0) {
                var view = new Uint32Array(this.arraybytes);
                var pa = this.position >> 2;
                this.position += 4;
                return view[pa];
            }
            else {
                var view = new Uint32Array(this.unalignedarraybytestemp, 0, 1);
                var view2 = new Uint8Array(this.arraybytes, this.position, 4);
                var view3 = new Uint8Array(this.unalignedarraybytestemp, 0, 4);
                view3.set(view2);
                this.position += 4;
                return view[0];
            }
        };
        ByteArray.prototype.writeFloat = function (b) {
            this.ensureWriteableSpace(4);
            if ((this.position & 3) == 0) {
                var view = new Float32Array(this.arraybytes);
                view[this.position >> 2] = b;
            }
            else {
                var view = new Float32Array(this.unalignedarraybytestemp, 0, 1);
                view[0] = b;
                var view2 = new Uint8Array(this.arraybytes, this.position, 4);
                var view3 = new Uint8Array(this.unalignedarraybytestemp, 0, 4);
                view2.set(view3);
            }
            this.position += 4;
            if (this.position > this.length)
                this.length = this.position;
        };
        ByteArray.prototype.readFloat = function () {
            if (this.position > this.length + 4)
                throw "ByteArray out of bounds read. Positon=" + this.position + ", Length=" + this.length;
            if ((this.position & 3) == 0) {
                var view = new Float32Array(this.arraybytes);
                var pa = this.position >> 2;
                this.position += 4;
                return view[pa];
            }
            else {
                var view = new Float32Array(this.unalignedarraybytestemp, 0, 1);
                var view2 = new Uint8Array(this.arraybytes, this.position, 4);
                var view3 = new Uint8Array(this.unalignedarraybytestemp, 0, 4);
                view3.set(view2);
                this.position += 4;
                return view[0];
            }
        };
        return ByteArray;
    }(ByteArrayBase));

    var ParserUtils = /** @class */ (function () {
        function ParserUtils() {
        }
        ParserUtils.arrayBufferToBase64 = function (data, mimeType) {
            var byteStr = '';
            var bytes = new Uint8Array(data);
            var len = bytes.byteLength;
            for (var i = 0; i < len; i++)
                byteStr += String.fromCharCode(bytes[i]);
            var base64Image = window.btoa(byteStr);
            return 'data:' + mimeType + ';base64,' + base64Image;
        };
        ParserUtils.arrayBufferToAudio = function (data, fileType) {
            var str = ParserUtils.arrayBufferToBase64(data, 'audio/' + fileType);
            var audio = new Audio();
            audio.src = str;
            return audio;
        };
        /**
         * Converts an ArrayBuffer to a base64 string
         *
         * @param image data as a ByteArray
         *
         * @return HTMLImageElement
         *
         */
        ParserUtils.arrayBufferToImage = function (data) {
            var str = ParserUtils.arrayBufferToBase64(data, 'image/png');
            var img = new Image();
            img.src = str;
            return img;
        };
        /**
         * Converts an ByteArray to an Image - returns an HTMLImageElement
         *
         * @param image data as a ByteArray
         *
         * @return HTMLImageElement
         *
         */
        ParserUtils.byteArrayToImage = function (data) {
            var str = ParserUtils.arrayBufferToBase64(data.arraybytes, 'image/png');
            var img = new Image();
            img.src = str;
            return img;
        };
        ParserUtils.byteArrayToAudio = function (data, filetype) {
            var str = ParserUtils.arrayBufferToBase64(data.arraybytes, 'audio/' + filetype);
            var audio = new Audio();
            audio.src = str;
            return audio;
        };
        /**
         * Converts an Blob to an Image - returns an HTMLImageElement
         *
         * @param image data as a Blob
         *
         * @return HTMLImageElement
         *
         */
        ParserUtils.blobToImage = function (data) {
            var URLObj = window['URL'] || window['webkitURL'];
            var src = URLObj.createObjectURL(data);
            var img = new Image();
            img.src = src;
            return img;
        };
        /**
         * Converts an Blob to audio - returns an HTMLAudioElement
         *
         * @param audio data as a Blob
         *
         * @return HTMLAudioElement
         *
         */
        ParserUtils.blobToAudio = function (data) {
            var URLObj = window['URL'] || window['webkitURL'];
            var src = URLObj.createObjectURL(data);
            var img = new Audio();
            img.src = src;
            return img;
        };
        /**
         * Returns a object as ByteArray, if possible.
         *
         * @param data The object to return as ByteArray
         *
         * @return The ByteArray or null
         *
         */
        ParserUtils.toByteArray = function (data) {
            var b = new ByteArray();
            b.setArrayBuffer(data);
            return b;
        };
        /**
         * Returns a object as String, if possible.
         *
         * @param data The object to return as String
         * @param length The length of the returned String
         *
         * @return The String or null
         *
         */
        ParserUtils.toString = function (data, length) {
            if (length === void 0) { length = 0; }
            if (typeof data === 'string') {
                var s = data;
                if (s['substr'] != null)
                    return s.substr(0, s.length);
            }
            if (data instanceof ByteArray) {
                var ba = data;
                ba.position = 0;
                return ba.readUTFBytes(Math.min(ba.getBytesAvailable(), length));
            }
            return null;
            /*
             var ba:ByteArray;

             length ||= uint.MAX_VALUE;

             if (data is String)
             return String(data).substr(0, length);

             ba = toByteArray(data);
             if (ba) {
             ba.position = 0;
             return ba.readUTFBytes(Math.min(ba.bytesAvailable, length));
             }

             return null;

             */
        };
        return ParserUtils;
    }());

    var EventAudioChannel = /** @class */ (function () {
        function EventAudioChannel(groupID, groupVolume, groupPan) {
            var _this = this;
            if (groupID === void 0) { groupID = 0; }
            if (groupVolume === void 0) { groupVolume = 1; }
            if (groupPan === void 0) { groupPan = 1; }
            this._isPlaying = false;
            this._isLooping = false;
            this._groupID = 0;
            this._groupVolume = 1;
            this._groupPan = 0;
            this._startTime = 0;
            this._groupID = groupID;
            this._groupVolume = groupVolume;
            this._groupPan = groupPan;
            this._audio = new Audio();
            this._audio.ontimeupdate = function (event) { return _this._onTimeUpdate(event); };
        }
        EventAudioChannel.stopAllSounds = function (channelGroup) {
            if (channelGroup === void 0) { channelGroup = -1; }
            var len = EventAudioChannel._channels.length;
            if (channelGroup < 0) {
                for (var j = 0; j < len; j++) {
                    EventAudioChannel._channels[j].stop();
                }
                EventAudioChannel._channels.length = 0;
                return;
            }
            var aliveChannels = [];
            for (var j = 0; j < len; j++) {
                if (EventAudioChannel._channels[j].groupID == channelGroup) {
                    EventAudioChannel._channels[j].stop();
                }
                else {
                    aliveChannels[aliveChannels.length] = EventAudioChannel._channels[j];
                }
            }
            EventAudioChannel._channels = aliveChannels;
        };
        EventAudioChannel.setChannelGroupVolume = function (value, channelGroup) {
            if (channelGroup === void 0) { channelGroup = -1; }
            var len = EventAudioChannel._channels.length;
            if (channelGroup < 0) {
                for (var j = 0; j < len; j++) {
                    EventAudioChannel._channels[j].groupVolume = value;
                }
                return;
            }
            for (var j = 0; j < len; j++) {
                if (EventAudioChannel._channels[j].groupID == channelGroup) {
                    EventAudioChannel._channels[j].groupVolume = value;
                }
            }
        };
        Object.defineProperty(EventAudioChannel.prototype, "duration", {
            get: function () {
                return this._duration;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EventAudioChannel.prototype, "currentTime", {
            get: function () {
                return this._audio.currentTime - this._startTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EventAudioChannel.prototype, "pan", {
            get: function () {
                //todo
                return 0;
            },
            set: function (value) {
                //todo
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EventAudioChannel.prototype, "groupID", {
            get: function () {
                return this._groupID;
            },
            set: function (value) {
                this._groupID = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EventAudioChannel.prototype, "groupVolume", {
            get: function () {
                return this._groupVolume;
            },
            set: function (value) {
                if (this._groupVolume == value)
                    return;
                this._groupVolume = value;
                this._audio.volume = this._groupVolume * this._volume;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EventAudioChannel.prototype, "groupPan", {
            get: function () {
                return this._groupPan;
            },
            set: function (value) {
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EventAudioChannel.prototype, "volume", {
            get: function () {
                return this._volume;
            },
            set: function (value) {
                if (this._volume == value)
                    return;
                this._volume = value;
                this._audio.volume = this._volume;
            },
            enumerable: true,
            configurable: true
        });
        EventAudioChannel.prototype.isPlaying = function () {
            return this._isPlaying;
        };
        EventAudioChannel.prototype.isLooping = function () {
            return this._isLooping;
        };
        EventAudioChannel.prototype.isDecoding = function () {
            return false;
        };
        EventAudioChannel.prototype.play = function (buffer, offset, loop, id) {
            if (offset === void 0) { offset = 0; }
            if (loop === void 0) { loop = false; }
            if (id === void 0) { id = 0; }
            this._isPlaying = true;
            this._isLooping = loop;
            this._audio.src = EventAudioChannel._base64Cache[id] || (EventAudioChannel._base64Cache[id] = ParserUtils.arrayBufferToBase64(buffer, "audio/mp3"));
            this._audio.loop = this._isLooping;
            var thisAudio = this._audio;
            this._audio.addEventListener('loadedmetadata', function () {
                thisAudio.currentTime = offset;
                thisAudio.play();
            }, false);
            this._audio.addEventListener('error', function (err) {
                console.log("error in audio", err);
            }, false);
            this._audio.addEventListener('error', function (err) {
                console.log("error in audio", err);
            }, false);
            this._audio.addEventListener('canplay', function (err) {
                console.log("canplay in audio", err);
            }, false);
            this._audio.addEventListener('canplaythrough', function (err) {
                console.log("canplaythrough in audio", err);
            }, false);
            this._audio.addEventListener('abort', function (err) {
                console.log("abort in audio", err);
            }, false);
            this._audio.addEventListener('loadstart', function (err) {
                console.log("loadstart in audio", err);
            }, false);
            this._audio.addEventListener('suspend', function (err) {
                console.log("suspend in audio", err);
            }, false);
        };
        EventAudioChannel.prototype.stop = function () {
            this._audio.pause();
            this._isPlaying = false;
            this._isLooping = false;
        };
        EventAudioChannel.prototype._onTimeUpdate = function (event) {
            //TODO: more accurate end detection
            if (!this._isLooping && this._audio.duration < this._audio.currentTime - this._startTime + 0.1) {
                if (this.onSoundComplete) {
                    this.onSoundComplete();
                }
                this.stop();
            }
        };
        EventAudioChannel.maxChannels = 4;
        EventAudioChannel._channels = new Array();
        EventAudioChannel._base64Cache = new Object();
        return EventAudioChannel;
    }());

    var AudioManager = /** @class */ (function () {
        function AudioManager() {
        }
        AudioManager.setVolume = function (value, channelGroup) {
            if (channelGroup === void 0) { channelGroup = -1; }
            if (channelGroup < 0) {
                var len = AudioManager._channelGroupVolumes.length;
                for (var j = 0; j < len; j++) {
                    AudioManager._channelGroupVolumes[j] = value;
                }
            }
            else {
                AudioManager._channelGroupVolumes[channelGroup] = value;
            }
            WebAudioChannel.setChannelGroupVolume(value, channelGroup);
            StreamingAudioChannel.setChannelGroupVolume(value, channelGroup);
            EventAudioChannel.setChannelGroupVolume(value, channelGroup);
        };
        AudioManager.getVolume = function (channelGroup) {
            if (channelGroup === void 0) { channelGroup = 0; }
            return AudioManager._channelGroupVolumes[channelGroup];
        };
        AudioManager.setExternalSoundInterface = function (new_obj) {
            if (new_obj.startSound == null) {
                console.log("Could not set the externalSoundInterface, because it does not provide a 'startSound' function");
                return;
            }
            if (new_obj.stopSound == null) {
                console.log("Could not set the externalSoundInterface, because it does not provide a 'stopSound' function");
                return;
            }
            AudioManager._externalSoundInterface = new_obj;
        };
        AudioManager.getExternalSoundInterface = function () {
            return AudioManager._externalSoundInterface;
        };
        AudioManager.stopAllSounds = function () {
            WebAudioChannel.stopAllSounds();
            StreamingAudioChannel.stopAllSounds();
            EventAudioChannel.stopAllSounds();
            //AudioChannel.stopAllSounds();
        };
        AudioManager.getChannel = function (byteLength, channelGroup) {
            if (channelGroup === void 0) { channelGroup = 0; }
            //choose best audio channel by bytelength
            //todo: StreamingAudioChannel doesnt seem to be working. no error, but also no sound is playing
            var channelClass = (byteLength > 50000000) ? StreamingAudioChannel : WebAudioChannel;
            if (AudioManager.isIE) {
                channelClass = EventAudioChannel;
            }
            //var channelClass:IAudioChannelClass = WebAudioChannel;
            var i = 0;
            while (channelClass._channels[i] && channelClass._channels[i].isPlaying())
                i++;
            if (i == channelClass.maxChannels) {
                //pick the oldest channel to reuse, ignoring looping channels
                var channel;
                var len = channelClass._channels.length;
                for (var j = 0; j < len; j++) {
                    channel = channelClass._channels[j];
                    if (!channel.isLooping() && !channel.isDecoding()) {
                        channel.groupID = channelGroup;
                        channel.groupVolume = AudioManager._channelGroupVolumes[channelGroup];
                        channel.groupPan = AudioManager._channelGroupPanning[channelGroup];
                        channelClass._channels.push(channelClass._channels.splice(j, 1)[0]);
                        channel.stop();
                        return channel;
                    }
                }
                //do not return channel until one is freed up
                return null;
            }
            return (channelClass._channels[i] = new channelClass(channelGroup, AudioManager._channelGroupVolumes[channelGroup], AudioManager._channelGroupPanning[channelGroup]));
        };
        AudioManager.isIE = !!navigator.userAgent.match(/Trident/g) || !!navigator.userAgent.match(/MSIE/g);
        //todo: make AudioPlaybackManager keep track of active sounds + implement global playback control
        AudioManager._externalSoundInterface = null;
        AudioManager._channelGroupVolumes = [1];
        AudioManager._channelGroupPanning = [0.5];
        return AudioManager;
    }());

    var EventBase = /** @class */ (function () {
        function EventBase(type) {
            /**
             * Type of event
             * @property type
             * @type String
             */
            this.type = undefined;
            /**
             * Reference to target object
             * @property target
             * @type Object
             */
            this.target = undefined;
            this.type = type;
        }
        /**
         * Clones the current event.
         * @return An exact duplicate of the current event.
         */
        EventBase.prototype.clone = function () {
            return new EventBase(this.type);
        };
        return EventBase;
    }());

    /**
     * @export class away.events.AssetEvent
     */
    var AssetEvent = /** @class */ (function (_super) {
        __extends$1(AssetEvent, _super);
        /**
         *
         */
        function AssetEvent(type, asset, prevName) {
            if (prevName === void 0) { prevName = null; }
            var _this = _super.call(this, type) || this;
            _this._asset = asset;
            _this._prevName = prevName || _this._asset.name;
            return _this;
        }
        Object.defineProperty(AssetEvent.prototype, "asset", {
            /**
             *
             */
            get: function () {
                return this._asset;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AssetEvent.prototype, "prevName", {
            /**
             *
             */
            get: function () {
                return this._prevName;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        AssetEvent.prototype.clone = function () {
            return new AssetEvent(this.type, this._asset, this._prevName);
        };
        /**
         * Dispatched when the content of an asset is invalidated
         */
        AssetEvent.INVALIDATE = "invalidate";
        /**
         * Dispatched when an asset is cleared
         */
        AssetEvent.CLEAR = "clear";
        /**
         *
         */
        AssetEvent.RENAME = 'rename';
        /**
         *
         */
        AssetEvent.ENTER_FRAME = 'enterFrame';
        /**
         *
         */
        AssetEvent.EXIT_FRAME = 'exitFrame';
        /**
         *
         */
        AssetEvent.ASSET_CONFLICT_RESOLVED = 'assetConflictResolved';
        /**
         * Dispatched when the loading of an asset and all of its dependencies is complete.
         */
        AssetEvent.ASSET_COMPLETE = "assetComplete";
        /**
         *
         */
        AssetEvent.TEXTURE_SIZE_ERROR = 'textureSizeError';
        return AssetEvent;
    }(EventBase));

    /**
     * Base export class for dispatching events
    *
    * @export class away.events.EventDispatcher
    *
    */
    var EventDispatcher = /** @class */ (function () {
        function EventDispatcher(target) {
            if (target === void 0) { target = null; }
            this._listenerObjects = new Array();
            this._t = target || this;
        }
        /**
         * Add an event listener
         * @method addEventListener
         * @param {String} Name of event to add a listener for
         * @param {Function} Callback function
         */
        EventDispatcher.prototype.addEventListener = function (type, listener) {
            var l = this._listenerObjects[type];
            if (l === undefined)
                l = this._listenerObjects[type] = new ListenerObject();
            l.addEventListener(listener);
        };
        /**
         * Remove an event listener
         * @method removeEventListener
         * @param {String} Name of event to remove a listener for
         * @param {Function} Callback function
         */
        EventDispatcher.prototype.removeEventListener = function (type, listener) {
            var l = this._listenerObjects[type];
            if (l) {
                l.removeEventListener(listener);
                if (l.numListeners == 0)
                    delete this._listenerObjects[type];
            }
        };
        /**
         * Dispatch an event
         * @method dispatchEvent
         * @param {Event} Event to dispatch
         */
        EventDispatcher.prototype.dispatchEvent = function (event) {
            var l = this._listenerObjects[event.type];
            if (l) {
                event.target = this._t;
                l.dispatchEvent(event);
            }
        };
        /**
         * check if an object has an event listener assigned to it
         * @method hasListener
         * @param {String} Name of event to remove a listener for
         * @param {Function} Callback function
         */
        EventDispatcher.prototype.hasEventListener = function (type, listener) {
            if (this._listenerObjects[type] === undefined)
                return false;
            if (listener != null)
                return this._listenerObjects[type].getEventListenerIndex(listener) !== -1;
            return this._listenerObjects[type].numListeners > 0;
        };
        return EventDispatcher;
    }());
    var ListenerObject = /** @class */ (function () {
        function ListenerObject() {
            this._index = 0;
            this._listeners = new Array();
            this.numListeners = 0;
        }
        ListenerObject.prototype.addEventListener = function (listener) {
            //check if listener already added
            if (this.getEventListenerIndex(listener) !== -1)
                return;
            this._listeners.push(listener);
            this.numListeners++;
        };
        ListenerObject.prototype.removeEventListener = function (listener) {
            //check if listener exists
            var index = this.getEventListenerIndex(listener);
            if (index === -1)
                return;
            this._listeners.splice(index, 1);
            //deals with removing a listener mid-way through dispatching listeners
            if (index <= this._index)
                this._index--;
            this.numListeners--;
        };
        ListenerObject.prototype.dispatchEvent = function (event) {
            var len = this.numListeners;
            for (this._index = 0; this._index < len && this._index < this.numListeners; this._index++)
                this._listeners[this._index](event);
        };
        /**
         * get Event Listener Index in array. Returns -1 if no listener is added
         * @method getEventListenerIndex
         * @param {String} Name of event to remove a listener for
         * @param {Function} Callback function
         */
        ListenerObject.prototype.getEventListenerIndex = function (listener) {
            for (var index = 0; index < this.numListeners; index++)
                if (listener == this._listeners[index])
                    return index;
            return -1;
        };
        return ListenerObject;
    }());

    var AssetBase = /** @class */ (function (_super) {
        __extends$1(AssetBase, _super);
        function AssetBase(name) {
            if (name === void 0) { name = null; }
            var _this = _super.call(this) || this;
            _this._id = AssetBase.ID_COUNT++;
            if (name == null)
                name = 'null';
            _this._name = name;
            _this._originalName = name;
            _this.updateFullPath();
            return _this;
        }
        Object.defineProperty(AssetBase.prototype, "adaptee", {
            get: function () {
                return this;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AssetBase.prototype, "adapter", {
            /**
             * adapter is used to provide MovieClip to scripts taken from different platforms
             * setter typically managed by factory. getter defaults to AwayJS class
             */
            get: function () {
                return this._adapter || this;
            },
            set: function (value) {
                this._adapter = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AssetBase.prototype, "assetType", {
            /**
             *
             */
            get: function () {
                throw new AbstractMethodError();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AssetBase.prototype, "originalName", {
            /**
             * The original name used for this asset in the resource (e.g. file) in which
             * it was found. This may not be the same as <code>name</code>, which may
             * have changed due to of a name conflict.
             */
            get: function () {
                return this._originalName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AssetBase.prototype, "id", {
            /**
             * A unique id for the asset, used to identify assets in an associative array
             */
            get: function () {
                return this._id;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AssetBase.prototype, "name", {
            get: function () {
                return this._name;
            },
            set: function (val) {
                var prev;
                prev = this._name;
                this._name = val;
                if (this._name == null)
                    this._name = 'null';
                this.updateFullPath();
                this.dispatchEvent(new AssetEvent(AssetEvent.RENAME, this, prev));
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        AssetBase.prototype.invalidate = function () {
            this.dispatchEvent(new AssetEvent(AssetEvent.INVALIDATE, this));
        };
        /**
         * @inheritDoc
         */
        AssetBase.prototype.dispose = function () {
            throw new AbstractMethodError();
        };
        AssetBase.prototype.clone = function () {
            throw new AbstractMethodError();
        };
        AssetBase.prototype.clear = function () {
            this.dispatchEvent(new AssetEvent(AssetEvent.CLEAR, this));
        };
        Object.defineProperty(AssetBase.prototype, "assetNamespace", {
            get: function () {
                return this._namespace;
            },
            set: function (value) {
                this._namespace = value ? value : AssetBase.DEFAULT_NAMESPACE;
                this.updateFullPath();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AssetBase.prototype, "assetFullPath", {
            get: function () {
                return this._full_path;
            },
            enumerable: true,
            configurable: true
        });
        AssetBase.prototype.assetPathEquals = function (name, ns) {
            return (this._name == name && (!ns || this._namespace == ns));
        };
        AssetBase.prototype.isAsset = function (assetClass) {
            return this.assetType == assetClass.assetType;
        };
        AssetBase.prototype.resetAssetPath = function (name, ns, overrideOriginal) {
            if (ns === void 0) { ns = null; }
            if (overrideOriginal === void 0) { overrideOriginal = true; }
            this._name = name ? name : 'null';
            this._namespace = ns ? ns : AssetBase.DEFAULT_NAMESPACE;
            if (overrideOriginal)
                this._originalName = this._name;
            this.updateFullPath();
        };
        AssetBase.prototype.updateFullPath = function () {
            this._full_path = [this._namespace, this._name];
        };
        AssetBase.ID_COUNT = 0;
        AssetBase.DEFAULT_NAMESPACE = 'default';
        return AssetBase;
    }(EventDispatcher));

    // TODO: Audio should probably be an interface containing play/stop/seek functionality
    var WaveAudio = /** @class */ (function (_super) {
        __extends$1(WaveAudio, _super);
        /**
         *
         */
        function WaveAudio(data, channelGroup) {
            if (channelGroup === void 0) { channelGroup = 0; }
            var _this = _super.call(this) || this;
            _this._volume = 1;
            _this._pan = 0;
            _this._audioChannels = [];
            _this._loopsToPlay = 0;
            _this._isPlaying = false;
            _this._channelsPlaying = 0;
            _this._data = data;
            _this._channelGroup = channelGroup;
            return _this;
        }
        Object.defineProperty(WaveAudio.prototype, "isPlaying", {
            get: function () {
                return this._isPlaying;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WaveAudio.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return WaveAudio.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WaveAudio.prototype, "loopsToPlay", {
            get: function () {
                return this._loopsToPlay;
            },
            set: function (value) {
                var _this = this;
                if (this._loopsToPlay == value)
                    return;
                this._loopsToPlay = value;
                if (this._audioChannel)
                    this._audioChannel.onSoundComplete = function () { return _this._soundCompleteInternal(); };
            },
            enumerable: true,
            configurable: true
        });
        WaveAudio.prototype._soundCompleteInternal = function () {
            this._loopsToPlay--;
            if (this._loopsToPlay > 0) {
                this.stop();
                this.play(0, false);
            }
            else {
                if (this._channelsPlaying > 0)
                    this._channelsPlaying--;
                if (this._channelsPlaying == 0)
                    this._isPlaying = false;
                if (this._onSoundComplete)
                    this._onSoundComplete();
            }
        };
        Object.defineProperty(WaveAudio.prototype, "pan", {
            get: function () {
                return this._pan;
            },
            set: function (value) {
                if (this._pan == value)
                    return;
                this._pan = value;
                if (this._audioChannel)
                    this._audioChannel.pan = this._pan;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WaveAudio.prototype, "channelGroup", {
            get: function () {
                return this._channelGroup;
            },
            set: function (value) {
                if (this._channelGroup == value)
                    return;
                this._channelGroup = value;
                var groupVolume = AudioManager.getVolume(value);
                for (var i = 0; i < this._audioChannels.length; i++)
                    this._audioChannels[i].groupVolume = groupVolume;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WaveAudio.prototype, "volume", {
            get: function () {
                return this._volume;
            },
            set: function (value) {
                if (this._volume == value)
                    return;
                this._volume = value;
                if (this._audioChannel)
                    this._audioChannel.volume = this._volume;
                for (var i = 0; i < this._audioChannels.length; i++)
                    this._audioChannels[i].volume = this._volume;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WaveAudio.prototype, "currentTime", {
            get: function () {
                if (this._audioChannel)
                    return this._audioChannel.currentTime;
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WaveAudio.prototype, "duration", {
            get: function () {
                if (this._audioChannel)
                    return this._audioChannel.duration;
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        WaveAudio.prototype.dispose = function () {
            this._isPlaying = false;
            this.stop();
        };
        WaveAudio.prototype.play = function (offset, loop) {
            var _this = this;
            if (loop === void 0) { loop = false; }
            this._isPlaying = true;
            this._audioChannel = AudioManager.getChannel(this._data.size, this.channelGroup);
            if (this._audioChannel) {
                this._channelsPlaying++;
                this._audioChannels.push(this._audioChannel);
                this._audioChannel.volume = this._volume;
                this._audioChannel.onSoundComplete = function () { return _this._soundCompleteInternal(); };
                this._data.play(this._audioChannel, offset, loop, this.id);
            }
        };
        Object.defineProperty(WaveAudio.prototype, "onSoundComplete", {
            set: function (value) {
                var _this = this;
                this._onSoundComplete = value;
                if (this._audioChannel)
                    this._audioChannel.onSoundComplete = function () { return _this._soundCompleteInternal(); };
            },
            enumerable: true,
            configurable: true
        });
        WaveAudio.prototype.stop = function () {
            this._isPlaying = false;
            for (var i = 0; i < this._audioChannels.length; i++) {
                this._audioChannels[i].stop();
                delete this._audioChannels[i];
            }
            this._channelsPlaying = 0;
            this._audioChannels.length = 0;
            this._audioChannel = null;
        };
        WaveAudio.prototype.clone = function () {
            var newInstance = new WaveAudio(this._data);
            newInstance.name = this.name;
            return newInstance;
        };
        WaveAudio.assetType = "[asset WaveAudio]";
        return WaveAudio;
    }(AssetBase));
    var WaveAudioData = /** @class */ (function () {
        function WaveAudioData(data) {
            if (data instanceof Blob) {
                this._blob = data;
            }
            else {
                this._buffer = (data instanceof ByteArray) ? data.arraybytes : data;
            }
        }
        Object.defineProperty(WaveAudioData.prototype, "size", {
            get: function () {
                if (this._buffer)
                    return this._buffer.byteLength;
                return this._blob.size;
            },
            enumerable: true,
            configurable: true
        });
        WaveAudioData.prototype.play = function (audioChannel, offset, loop, id) {
            var _this = this;
            if (this._buffer) {
                audioChannel.play(this._buffer, offset, loop, id);
            }
            else if (!this._loading) {
                this._loading = true;
                var fileReader = new FileReader();
                fileReader.onload = function (event) { return _this._blobConverted(event, audioChannel, offset, loop, id); };
                fileReader.readAsArrayBuffer(this._blob);
            }
        };
        WaveAudioData.prototype._blobConverted = function (event, audioChannel, offset, loop, id) {
            this._buffer = event.target.result;
            audioChannel.play(this._buffer, offset, loop, id);
        };
        return WaveAudioData;
    }());

    /**
     *
     */
    var ColorUtils = /** @class */ (function () {
        function ColorUtils() {
        }
        ColorUtils.float32ColorToARGB = function (float32Color) {
            var a = (float32Color & 0xff000000) >>> 24;
            var r = (float32Color & 0xff0000) >>> 16;
            var g = (float32Color & 0xff00) >>> 8;
            var b = float32Color & 0xff;
            var result = [a, r, g, b];
            return result;
        };
        ColorUtils.f32_RGBA_To_f32_ARGB = function (float32Color) {
            var r = (float32Color & 0xff000000) >>> 24;
            var g = (float32Color & 0xff0000) >>> 16;
            var b = (float32Color & 0xff00) >>> 8;
            var a = float32Color & 0xff;
            return (a << 24) | (r << 16) | (g << 8) | b;
        };
        ColorUtils.f32_RGB_To_f32_ARGB = function (float32Color) {
            var r = (float32Color & 0xff000000) >>> 24;
            var g = (float32Color & 0xff0000) >>> 16;
            var b = (float32Color & 0xff00) >>> 8;
            var a = float32Color & 0xff;
            return (a << 24) | (r << 16) | (g << 8) | b;
        };
        ColorUtils.prototype.getAlphaFromF32RGBA = function (float32Color) {
            return float32Color & 0xff;
        };
        ColorUtils.ARGBtoFloat32 = function (a, r, g, b) {
            return ((a << 24) | (r << 16) | (g << 8) | b);
        };
        ColorUtils.componentToHex = function (c) {
            var hex = c.toString(16);
            return hex.length == 1 ? "0" + hex : hex;
        };
        ColorUtils.RGBToHexString = function (argb) {
            return "#" + ColorUtils.componentToHex(argb[1]) + ColorUtils.componentToHex(argb[2]) + ColorUtils.componentToHex(argb[3]);
        };
        ColorUtils.ARGBToHexString = function (argb) {
            return "#" + ColorUtils.componentToHex(argb[0]) + ColorUtils.componentToHex(argb[1]) + ColorUtils.componentToHex(argb[2]) + ColorUtils.componentToHex(argb[3]);
        };
        return ColorUtils;
    }());

    /**
     * The ColorTransform export class lets you adjust the color values in a display
     * object. The color adjustment or <i>color transformation</i> can be applied
     * to all four channels: red, green, blue, and alpha transparency.
     *
     * <p>When a ColorTransform object is applied to a display object, a new value
     * for each color channel is calculated like this:</p>
     *
     * <ul>
     *   <li>New red value = (old red value * <code>redMultiplier</code>) +
     * <code>redOffset</code></li>
     *   <li>New green value = (old green value * <code>greenMultiplier</code>) +
     * <code>greenOffset</code></li>
     *   <li>New blue value = (old blue value * <code>blueMultiplier</code>) +
     * <code>blueOffset</code></li>
     *   <li>New alpha value = (old alpha value * <code>alphaMultiplier</code>) +
     * <code>alphaOffset</code></li>
     * </ul>
     *
     * <p>If any of the color channel values is greater than 255 after the
     * calculation, it is set to 255. If it is less than 0, it is set to 0.</p>
     *
     * <p>You can use ColorTransform objects in the following ways:</p>
     *
     * <ul>
     *   <li>In the <code>colorTransform</code> parameter of the
     * <code>colorTransform()</code> method of the BitmapData class</li>
     *   <li>As the <code>colorTransform</code> property of a Transform object
     * (which can be used as the <code>transform</code> property of a display
     * object)</li>
     * </ul>
     *
     * <p>You must use the <code>new ColorTransform()</code> constructor to create
     * a ColorTransform object before you can call the methods of the
     * ColorTransform object.</p>
     *
     * <p>Color transformations do not apply to the background color of a movie
     * clip(such as a loaded SWF object). They apply only to graphics and symbols
     * that are attached to the movie clip.</p>
     */
    var ColorTransform = /** @class */ (function () {
        function ColorTransform(redMultiplier, greenMultiplier, blueMultiplier, alphaMultiplier, redOffset, greenOffset, blueOffset, alphaOffset) {
            if (redMultiplier === void 0) { redMultiplier = 1; }
            if (greenMultiplier === void 0) { greenMultiplier = 1; }
            if (blueMultiplier === void 0) { blueMultiplier = 1; }
            if (alphaMultiplier === void 0) { alphaMultiplier = 1; }
            if (redOffset === void 0) { redOffset = 0; }
            if (greenOffset === void 0) { greenOffset = 0; }
            if (blueOffset === void 0) { blueOffset = 0; }
            if (alphaOffset === void 0) { alphaOffset = 0; }
            if (redMultiplier instanceof Float32Array) {
                this._rawData = redMultiplier;
            }
            else {
                this._rawData = new Float32Array(8);
                this.redMultiplier = Number(redMultiplier);
                this.greenMultiplier = greenMultiplier;
                this.blueMultiplier = blueMultiplier;
                this.alphaMultiplier = alphaMultiplier;
                this.redOffset = redOffset;
                this.greenOffset = greenOffset;
                this.blueOffset = blueOffset;
                this.alphaOffset = alphaOffset;
            }
        }
        ColorTransform.prototype.concat = function (second) {
            this._rawData[0] *= second._rawData[0];
            this._rawData[1] *= second._rawData[1];
            this._rawData[2] *= second._rawData[2];
            this._rawData[3] *= second._rawData[3];
            this._rawData[4] += second._rawData[4];
            this._rawData[5] += second._rawData[5];
            this._rawData[6] += second._rawData[6];
            this._rawData[7] += second._rawData[7];
        };
        Object.defineProperty(ColorTransform.prototype, "alphaMultiplier", {
            /**
             * A decimal value that is multiplied with the alpha transparency channel
             * value.
             *
             * <p>If you set the alpha transparency value of a display object directly by
             * using the <code>alpha</code> property of the DisplayObject instance, it
             * affects the value of the <code>alphaMultiplier</code> property of that
             * display object's <code>transform.colorTransform</code> property.</p>
             */
            get: function () {
                return this._rawData[3];
            },
            set: function (value) {
                this._rawData[3] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform.prototype, "alphaOffset", {
            /**
             * A number from -255 to 255 that is added to the alpha transparency channel
             * value after it has been multiplied by the <code>alphaMultiplier</code>
             * value.
             */
            get: function () {
                return this._rawData[7];
            },
            set: function (value) {
                this._rawData[7] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform.prototype, "blueMultiplier", {
            /**
             * A decimal value that is multiplied with the blue channel value.
             */
            get: function () {
                return this._rawData[2];
            },
            set: function (value) {
                this._rawData[2] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform.prototype, "blueOffset", {
            /**
             * A number from -255 to 255 that is added to the blue channel value after it
             * has been multiplied by the <code>blueMultiplier</code> value.
             */
            get: function () {
                return this._rawData[6];
            },
            set: function (value) {
                this._rawData[6] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform.prototype, "greenMultiplier", {
            /**
             * A decimal value that is multiplied with the green channel value.
             */
            get: function () {
                return this._rawData[1];
            },
            set: function (value) {
                this._rawData[1] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform.prototype, "greenOffset", {
            /**
             * A number from -255 to 255 that is added to the green channel value after
             * it has been multiplied by the <code>greenMultiplier</code> value.
             */
            get: function () {
                return this._rawData[5];
            },
            set: function (value) {
                this._rawData[5] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform.prototype, "redMultiplier", {
            /**
             * A decimal value that is multiplied with the red channel value.
             */
            get: function () {
                return this._rawData[0];
            },
            set: function (value) {
                this._rawData[0] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform.prototype, "redOffset", {
            /**
             * A number from -255 to 255 that is added to the red channel value after it
             * has been multiplied by the <code>redMultiplier</code> value.
             */
            get: function () {
                return this._rawData[4];
            },
            set: function (value) {
                this._rawData[4] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform.prototype, "color", {
            /**
             * The RGB color value for a ColorTransform object.
             *
             * <p>When you set this property, it changes the three color offset values
             * (<code>redOffset</code>, <code>greenOffset</code>, and
             * <code>blueOffset</code>) accordingly, and it sets the three color
             * multiplier values(<code>redMultiplier</code>,
             * <code>greenMultiplier</code>, and <code>blueMultiplier</code>) to 0. The
             * alpha transparency multiplier and offset values do not change.</p>
             *
             * <p>When you pass a value for this property, use the format
             * 0x<i>RRGGBB</i>. <i>RR</i>, <i>GG</i>, and <i>BB</i> each consist of two
             * hexadecimal digits that specify the offset of each color component. The 0x
             * tells the ActionScript compiler that the number is a hexadecimal
             * value.</p>
             */
            get: function () {
                return ((this._rawData[4] << 16) | (this._rawData[5] << 8) | this._rawData[6]);
            },
            set: function (value) {
                var argb = ColorUtils.float32ColorToARGB(value);
                this._rawData[4] = argb[1]; //(value >> 16) & 0xFF;
                this._rawData[5] = argb[2]; //(value >> 8) & 0xFF;
                this._rawData[6] = argb[3]; //value & 0xFF;
                this._rawData[0] = 1;
                this._rawData[1] = 1;
                this._rawData[2] = 1;
            },
            enumerable: true,
            configurable: true
        });
        ColorTransform.prototype.copyRawDataFrom = function (sourceData) {
            var targetData = this._rawData;
            targetData[0] = sourceData[0];
            targetData[1] = sourceData[1];
            targetData[2] = sourceData[2];
            targetData[3] = sourceData[3];
            targetData[4] = sourceData[4];
            targetData[5] = sourceData[5];
            targetData[6] = sourceData[6];
            targetData[7] = sourceData[7];
        };
        ColorTransform.prototype.clear = function () {
            this._rawData[0] = 1;
            this._rawData[1] = 1;
            this._rawData[2] = 1;
            this._rawData[3] = 1;
            this._rawData[4] = 0;
            this._rawData[5] = 0;
            this._rawData[6] = 0;
            this._rawData[7] = 0;
        };
        ColorTransform.prototype.clone = function () {
            var colorTransform = new ColorTransform();
            colorTransform.copyFrom(this);
            return colorTransform;
        };
        ColorTransform.prototype.copyFrom = function (source) {
            var sourceData = source._rawData, targetData = this._rawData;
            targetData[0] = sourceData[0];
            targetData[1] = sourceData[1];
            targetData[2] = sourceData[2];
            targetData[3] = sourceData[3];
            targetData[4] = sourceData[4];
            targetData[5] = sourceData[5];
            targetData[6] = sourceData[6];
            targetData[7] = sourceData[7];
        };
        ColorTransform.prototype.copyTo = function (target) {
            target.copyFrom(this);
        };
        ColorTransform.prototype.prepend = function (ct) {
            this._rawData[4] += ct._rawData[4] * this._rawData[0];
            this._rawData[5] += ct._rawData[5] * this._rawData[1];
            this._rawData[6] += ct._rawData[6] * this._rawData[2];
            this._rawData[7] += ct._rawData[7] * this._rawData[3];
            this.redMultiplier *= ct.redMultiplier;
            this.greenMultiplier *= ct.greenMultiplier;
            this.blueMultiplier *= ct.blueMultiplier;
            this.alphaMultiplier *= ct.alphaMultiplier;
        };
        ColorTransform.prototype._isRenderable = function () {
            return this._rawData[3] != 0 || this._rawData[7] > 0;
        };
        return ColorTransform;
    }());

    /**
     * The Point object represents a location in a two-dimensional coordinate
     * system, where <i>x</i> represents the horizontal axis and <i>y</i>
     * represents the vertical axis.
     *
     * <p>The following code creates a point at(0,0):</p>
     *
     * <p>Methods and properties of the following classes use Point objects:</p>
     *
     * <ul>
     *   <li>BitmapData</li>
     *   <li>DisplayObject</li>
     *   <li>DisplayObjectContainer</li>
     *   <li>DisplacementMapFilter</li>
     *   <li>NativeWindow</li>
     *   <li>Matrix</li>
     *   <li>Rectangle</li>
     * </ul>
     *
     * <p>You can use the <code>new Point()</code> constructor to create a Point
     * object.</p>
     */
    var Point = /** @class */ (function () {
        /**
         * Creates a new point. If you pass no parameters to this method, a point is
         * created at(0,0).
         *
         * @param x The horizontal coordinate.
         * @param y The vertical coordinate.
         */
        function Point(x, y) {
            if (x === void 0) { x = 0; }
            if (y === void 0) { y = 0; }
            this._rawData = new Float32Array(2);
            this._rawData[0] = x;
            this._rawData[1] = y;
        }
        Object.defineProperty(Point.prototype, "x", {
            /**
             * The horizontal coordinate of the point. The default value is 0.
             */
            get: function () {
                return this._rawData[0];
            },
            set: function (value) {
                this._rawData[0] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Point.prototype, "y", {
            /**
             * The vertical coordinate of the point. The default value is 0.
             */
            get: function () {
                return this._rawData[1];
            },
            set: function (value) {
                this._rawData[1] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Point.prototype, "length", {
            /**
             * The length of the line segment from(0,0) to this point.
             */
            get: function () {
                return Math.sqrt(this._rawData[0] * this._rawData[0] + this._rawData[1] * this._rawData[1]);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Adds the coordinates of another point to the coordinates of this point to
         * create a new point.
         *
         * @param v The point to be added.
         * @return The new point.
         */
        Point.prototype.add = function (v) {
            return new Point(this._rawData[0] + v._rawData[0], this._rawData[1] + v._rawData[1]);
        };
        /**
         * Creates a copy of this Point object.
         *
         * @return The new Point object.
         */
        Point.prototype.clone = function () {
            return new Point(this.x, this.y);
        };
        Point.prototype.copyFrom = function (sourcePoint) {
            this._rawData[0] = sourcePoint._rawData[0];
            this._rawData[1] = sourcePoint._rawData[1];
        };
        /**
         * Determines whether two points are equal. Two points are equal if they have
         * the same <i>x</i> and <i>y</i> values.
         *
         * @param toCompare The point to be compared.
         * @return A value of <code>true</code> if the object is equal to this Point
         *         object; <code>false</code> if it is not equal.
         */
        Point.prototype.equals = function (toCompare) {
            return (this._rawData[0] === toCompare._rawData[0] && this._rawData[1] == toCompare._rawData[1]);
        };
        /**
         * Scales the line segment between(0,0) and the current point to a set
         * length.
         *
         * @param thickness The scaling value. For example, if the current point is
         *                 (0,5), and you normalize it to 1, the point returned is
         *                  at(0,1).
         */
        Point.prototype.normalize = function (thickness) {
            if (thickness === void 0) { thickness = 1; }
            var len = this.length;
            if ((this.x !== 0 || this.y !== 0) && len) {
                var relativeThickness = thickness / len;
                this._rawData[0] *= relativeThickness;
                this._rawData[1] *= relativeThickness;
            }
        };
        /**
         * Offsets the Point object by the specified amount. The value of
         * <code>dx</code> is added to the original value of <i>x</i> to create the
         * new <i>x</i> value. The value of <code>dy</code> is added to the original
         * value of <i>y</i> to create the new <i>y</i> value.
         *
         * @param dx The amount by which to offset the horizontal coordinate,
         *           <i>x</i>.
         * @param dy The amount by which to offset the vertical coordinate, <i>y</i>.
         */
        Point.prototype.offset = function (dx, dy) {
            this._rawData[0] += dx;
            this._rawData[1] += dy;
        };
        Point.prototype.setTo = function (xa, ya) {
            this._rawData[0] = xa;
            this._rawData[1] = ya;
        };
        /**
         * Subtracts the coordinates of another point from the coordinates of this
         * point to create a new point.
         *
         * @param v The point to be subtracted.
         * @return The new point.
         */
        Point.prototype.subtract = function (v) {
            return new Point(this.x - v.x, this.y - v.y);
        };
        /**
         * Returns a string that contains the values of the <i>x</i> and <i>y</i>
         * coordinates. The string has the form <code>"(x=<i>x</i>,
         * y=<i>y</i>)"</code>, so calling the <code>toString()</code> method for a
         * point at 23,17 would return <code>"(x=23, y=17)"</code>.
         *
         * @return The string representation of the coordinates.
         */
        Point.prototype.toString = function () {
            return "[Point] (x=" + this.x + ", y=" + this.y + ")";
        };
        /**
         * Returns the distance between <code>pt1</code> and <code>pt2</code>.
         *
         * @param pt1 The first point.
         * @param pt2 The second point.
         * @return The distance between the first and second points.
         */
        Point.distance = function (pt1, pt2) {
            var dx = pt2.x - pt1.x;
            var dy = pt2.y - pt1.y;
            return (dx === 0) ? Math.abs(dy) : (dy === 0) ? Math.abs(dx) : Math.sqrt(dx * dx + dy * dy);
        };
        /**
         * Determines a point between two specified points. The parameter
         * <code>f</code> determines where the new interpolated point is located
         * relative to the two end points specified by parameters <code>pt1</code>
         * and <code>pt2</code>. The closer the value of the parameter <code>f</code>
         * is to <code>1.0</code>, the closer the interpolated point is to the first
         * point(parameter <code>pt1</code>). The closer the value of the parameter
         * <code>f</code> is to 0, the closer the interpolated point is to the second
         * point(parameter <code>pt2</code>).
         *
         * @param pt1 The first point.
         * @param pt2 The second point.
         * @param f   The level of interpolation between the two points. Indicates
         *            where the new point will be, along the line between
         *            <code>pt1</code> and <code>pt2</code>. If <code>f</code>=1,
         *            <code>pt1</code> is returned; if <code>f</code>=0,
         *            <code>pt2</code> is returned.
         * @return The new, interpolated point.
         */
        Point.interpolate = function (pt1, pt2, f) {
            var f1 = 1 - f;
            var raw1 = pt1._rawData;
            var raw2 = pt2._rawData;
            return new Point(raw1[0] * f + raw2[0] * f1, raw1[1] * f + raw2[1] * f1);
        };
        /**
         * Converts a pair of polar coordinates to a Cartesian point coordinate.
         *
         * @param len   The length coordinate of the polar pair.
         * @param angle The angle, in radians, of the polar pair.
         * @return The Cartesian point.
         */
        Point.polar = function (len, angle) {
            return new Point(len * Math.cos(angle), len * Math.sin(angle));
        };
        return Point;
    }());

    /**
     * AbstractMethodError is thrown when an abstract method is called. The method in question should be overridden
     * by a concrete subclass.
     */
    var ArgumentError = /** @class */ (function (_super) {
        __extends$1(ArgumentError, _super);
        /**
         * Create a new ArgumentError.
         *
         * @param message An optional message to override the default error message.
         * @param id The id of the error.
         */
        function ArgumentError(message, id) {
            if (message === void 0) { message = null; }
            if (id === void 0) { id = 0; }
            return _super.call(this, message || "ArgumentError", id) || this;
        }
        return ArgumentError;
    }(ErrorBase));

    /**
     * The Matrix export class represents a transformation matrix that determines how to
     * map points from one coordinate space to another. You can perform various
     * graphical transformations on a display object by setting the properties of
     * a Matrix object, applying that Matrix object to the <code>matrix</code>
     * property of a Transform object, and then applying that Transform object as
     * the <code>transform</code> property of the display object. These
     * transformation functions include translation(<i>x</i> and <i>y</i>
     * repositioning), rotation, scaling, and skewing.
     *
     * <p>Together these types of transformations are known as <i>affine
     * transformations</i>. Affine transformations preserve the straightness of
     * lines while transforming, so that parallel lines stay parallel.</p>
     *
     * <p>To apply a transformation matrix to a display object, you create a
     * Transform object, set its <code>matrix</code> property to the
     * transformation matrix, and then set the <code>transform</code> property of
     * the display object to the Transform object. Matrix objects are also used as
     * parameters of some methods, such as the following:</p>
     *
     * <ul>
     *   <li>The <code>draw()</code> method of a BitmapData object</li>
     *   <li>The <code>beginBitmapFill()</code> method,
     * <code>beginGradientFill()</code> method, or
     * <code>lineGradientStyle()</code> method of a Graphics object</li>
     * </ul>
     *
     * <p>A transformation matrix object is a 3 x 3 matrix with the following
     * contents:</p>
     *
     * <p>In traditional transformation matrixes, the <code>u</code>,
     * <code>v</code>, and <code>w</code> properties provide extra capabilities.
     * The Matrix export class can only operate in two-dimensional space, so it always
     * assumes that the property values <code>u</code> and <code>v</code> are 0.0,
     * and that the property value <code>w</code> is 1.0. The effective values of
     * the matrix are as follows:</p>
     *
     * <p>You can get and set the values of all six of the other properties in a
     * Matrix object: <code>a</code>, <code>b</code>, <code>c</code>,
     * <code>d</code>, <code>tx</code>, and <code>ty</code>.</p>
     *
     * <p>The Matrix export class supports the four major types of transformations:
     * translation, scaling, rotation, and skewing. You can set three of these
     * transformations by using specialized methods, as described in the following
     * table: </p>
     *
     * <p>Each transformation function alters the current matrix properties so
     * that you can effectively combine multiple transformations. To do this, you
     * call more than one transformation function before applying the matrix to
     * its display object target(by using the <code>transform</code> property of
     * that display object).</p>
     *
     * <p>Use the <code>new Matrix()</code> constructor to create a Matrix object
     * before you can call the methods of the Matrix object.</p>
     */
    var Matrix = /** @class */ (function () {
        function Matrix(a, b, c, d, tx, ty) {
            if (a === void 0) { a = 1; }
            if (b === void 0) { b = 0; }
            if (c === void 0) { c = 0; }
            if (d === void 0) { d = 1; }
            if (tx === void 0) { tx = 0; }
            if (ty === void 0) { ty = 0; }
            this.rawData = new Float32Array(6);
            if (a instanceof Float32Array) {
                this.copyRawDataFrom(a);
            }
            else {
                var raw = this.rawData;
                raw[0] = Number(a);
                raw[1] = b;
                raw[2] = c;
                raw[3] = d;
                raw[4] = tx;
                raw[5] = ty;
            }
        }
        Object.defineProperty(Matrix.prototype, "a", {
            /**
             * The value that affects the positioning of pixels along the <i>x</i> axis
             * when scaling or rotating an image.
             */
            get: function () {
                return this.rawData[0];
            },
            set: function (value) {
                this.rawData[0] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix.prototype, "b", {
            /**
             * The value that affects the positioning of pixels along the <i>y</i> axis
             * when rotating or skewing an image.
             */
            get: function () {
                return this.rawData[1];
            },
            set: function (value) {
                this.rawData[1] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix.prototype, "c", {
            /**
             * The value that affects the positioning of pixels along the <i>x</i> axis
             * when rotating or skewing an image.
             */
            get: function () {
                return this.rawData[2];
            },
            set: function (value) {
                this.rawData[2] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix.prototype, "d", {
            /**
             * The value that affects the positioning of pixels along the <i>y</i> axis
             * when scaling or rotating an image.
             */
            get: function () {
                return this.rawData[3];
            },
            set: function (value) {
                this.rawData[3] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix.prototype, "tx", {
            /**
             * The distance by which to translate each point along the <i>x</i> axis.
             */
            get: function () {
                return this.rawData[4];
            },
            set: function (value) {
                this.rawData[4] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix.prototype, "ty", {
            /**
             * The distance by which to translate each point along the <i>y</i> axis.
             */
            get: function () {
                return this.rawData[5];
            },
            set: function (value) {
                this.rawData[5] = value;
            },
            enumerable: true,
            configurable: true
        });
        Matrix.prototype.copyRawDataFrom = function (vector, index) {
            if (index === void 0) { index = 0; }
            var raw = this.rawData;
            raw[0] = vector[0];
            raw[1] = vector[1];
            raw[2] = vector[2];
            raw[3] = vector[3];
            raw[4] = vector[4];
            raw[5] = vector[5];
        };
        /**
         * Returns a new Matrix object that is a clone of this matrix, with an exact
         * copy of the contained object.
         *
         * @return A Matrix object.
         */
        Matrix.prototype.clone = function () {
            var raw = this.rawData;
            return new Matrix(raw[0], raw[1], raw[2], raw[3], raw[4], raw[5]);
        };
        /**
         * Concatenates a matrix with the current matrix, effectively combining the
         * geometric effects of the two. In mathematical terms, concatenating two
         * matrixes is the same as combining them using matrix multiplication.
         *
         * <p>For example, if matrix <code>m1</code> scales an object by a factor of
         * four, and matrix <code>m2</code> rotates an object by 1.5707963267949
         * radians(<code>Math.PI/2</code>), then <code>m1.concat(m2)</code>
         * transforms <code>m1</code> into a matrix that scales an object by a factor
         * of four and rotates the object by <code>Math.PI/2</code> radians. </p>
         *
         * <p>This method replaces the source matrix with the concatenated matrix. If
         * you want to concatenate two matrixes without altering either of the two
         * source matrixes, first copy the source matrix by using the
         * <code>clone()</code> method, as shown in the Class Examples section.</p>
         *
         * @param matrix The matrix to be concatenated to the source matrix.
         */
        Matrix.prototype.concat = function (matrix) {
            var m = this.rawData;
            var n = matrix.rawData;
            var a = m[0] * n[0];
            var b = 0.0;
            var c = 0.0;
            var d = m[3] * n[3];
            var tx = m[4] * n[0] + n[4];
            var ty = m[5] * n[3] + n[5];
            if (m[1] !== 0.0 || m[2] !== 0.0 || n[1] !== 0.0 || n[2] !== 0.0) {
                a += m[1] * n[2];
                d += m[2] * n[1];
                b += m[0] * n[1] + m[1] * n[3];
                c += m[2] * n[0] + m[3] * n[2];
                tx += m[5] * n[2];
                ty += m[4] * n[1];
            }
            m[0] = a;
            m[1] = b;
            m[2] = c;
            m[3] = d;
            m[4] = tx;
            m[5] = ty;
        };
        /**
         * Copies a Vector3D object into specific column of the calling Matrix3D
         * object.
         *
         * @param column   The column from which to copy the data from.
         * @param vector3D The Vector3D object from which to copy the data.
         */
        Matrix.prototype.copyColumnFrom = function (column, vector3D) {
            var raw = this.rawData;
            var rawVector3D = vector3D._rawData;
            if (column > 2) {
                throw "Column " + column + " out of bounds (2)";
            }
            else if (column == 0) {
                raw[0] = rawVector3D[0];
                raw[1] = rawVector3D[1];
            }
            else if (column == 1) {
                raw[2] = rawVector3D[0];
                raw[3] = rawVector3D[1];
            }
            else {
                raw[4] = rawVector3D[0];
                raw[5] = rawVector3D[1];
            }
        };
        /**
         * Copies specific column of the calling Matrix object into the Vector3D
         * object. The w element of the Vector3D object will not be changed.
         *
         * @param column   The column from which to copy the data from.
         * @param vector3D The Vector3D object from which to copy the data.
         */
        Matrix.prototype.copyColumnTo = function (column, vector3D) {
            var raw = this.rawData;
            var rawVector3D = vector3D._rawData;
            if (column > 2) {
                throw new ArgumentError("ArgumentError, Column " + column + " out of bounds [0, ..., 2]");
            }
            else if (column == 0) {
                rawVector3D[0] = raw[0];
                rawVector3D[1] = raw[1];
                rawVector3D[2] = 0;
            }
            else if (column == 1) {
                rawVector3D[0] = raw[2];
                rawVector3D[1] = raw[3];
                rawVector3D[2] = 0;
            }
            else {
                rawVector3D[0] = raw[4];
                rawVector3D[1] = raw[5];
                rawVector3D[2] = 1;
            }
        };
        /**
         * Copies all of the matrix data from the source Point object into the
         * calling Matrix object.
         *
         * @param sourceMatrix The Matrix object from which to copy the data.
         */
        Matrix.prototype.copyFrom = function (sourceMatrix) {
            var raw = this.rawData;
            var sourceRaw = sourceMatrix.rawData;
            raw[0] = sourceRaw[0];
            raw[1] = sourceRaw[1];
            raw[2] = sourceRaw[2];
            raw[3] = sourceRaw[3];
            raw[4] = sourceRaw[4];
            raw[5] = sourceRaw[5];
        };
        /**
         * Copies a Vector3D object into specific row of the calling Matrix object.
         *
         * @param row      The row from which to copy the data from.
         * @param vector3D The Vector3D object from which to copy the data.
         */
        Matrix.prototype.copyRowFrom = function (row, vector3D) {
            var raw = this.rawData;
            var rawVector3D = vector3D._rawData;
            if (row > 2) {
                throw new ArgumentError("ArgumentError, Row " + row + " out of bounds [0, ..., 2]");
            }
            else if (row == 0) {
                raw[0] = rawVector3D[0];
                raw[2] = rawVector3D[1];
                raw[4] = rawVector3D[2];
            }
            else {
                raw[1] = rawVector3D[0];
                raw[3] = rawVector3D[1];
                raw[5] = rawVector3D[2];
            }
        };
        /**
         * Copies specific row of the calling Matrix object into the Vector3D object.
         * The w element of the Vector3D object will not be changed.
         *
         * @param row      The row from which to copy the data from.
         * @param vector3D The Vector3D object from which to copy the data.
         */
        Matrix.prototype.copyRowTo = function (row, vector3D) {
            var raw = this.rawData;
            var rawVector3D = vector3D._rawData;
            if (row > 2) {
                throw new ArgumentError("ArgumentError, Row " + row + " out of bounds [0, ..., 2]");
            }
            else if (row == 0) {
                rawVector3D[0] = raw[0];
                rawVector3D[1] = raw[2];
                rawVector3D[2] = raw[4];
            }
            else if (row == 1) {
                rawVector3D[0] = raw[1];
                rawVector3D[1] = raw[3];
                rawVector3D[2] = raw[5];
            }
            else {
                rawVector3D[0] = 0;
                rawVector3D[1] = 0;
                rawVector3D[2] = 1;
            }
        };
        /**
         * Includes parameters for scaling, rotation, and translation. When applied
         * to a matrix it sets the matrix's values based on those parameters.
         *
         * <p>Using the <code>createBox()</code> method lets you obtain the same
         * matrix as you would if you applied the <code>identity()</code>,
         * <code>rotate()</code>, <code>scale()</code>, and <code>translate()</code>
         * methods in succession. For example, <code>mat1.createBox(2,2,Math.PI/4,
         * 100, 100)</code> has the same effect as the following:</p>
         *
         * @param scaleX   The factor by which to scale horizontally.
         * @param scaleY   The factor by which scale vertically.
         * @param rotation The amount to rotate, in radians.
         * @param tx       The number of pixels to translate(move) to the right
         *                 along the <i>x</i> axis.
         * @param ty       The number of pixels to translate(move) down along the
         *                 <i>y</i> axis.
         */
        Matrix.prototype.createBox = function (scaleX, scaleY, rotation, tx, ty) {
            if (rotation === void 0) { rotation = 0; }
            if (tx === void 0) { tx = 0; }
            if (ty === void 0) { ty = 0; }
            var raw = this.rawData;
            if (rotation !== 0) {
                var u = Math.cos(rotation);
                var v = Math.sin(rotation);
                raw[0] = u * scaleX;
                raw[1] = v * scaleY;
                raw[2] = -v * scaleX;
                raw[3] = u * scaleY;
            }
            else {
                raw[0] = scaleX;
                raw[1] = 0;
                raw[2] = 0;
                raw[3] = scaleY;
            }
            raw[4] = tx;
            raw[5] = ty;
        };
        /**
         * Creates the specific style of matrix expected by the
         * <code>beginGradientFill()</code> and <code>lineGradientStyle()</code>
         * methods of the Graphics class. Width and height are scaled to a
         * <code>scaleX</code>/<code>scaleY</code> pair and the
         * <code>tx</code>/<code>ty</code> values are offset by half the width and
         * height.
         *
         * <p>For example, consider a gradient with the following
         * characteristics:</p>
         *
         * <ul>
         *   <li><code>GradientType.LINEAR</code></li>
         *   <li>Two colors, green and blue, with the ratios array set to <code>[0,
         * 255]</code></li>
         *   <li><code>SpreadMethod.PAD</code></li>
         *   <li><code>InterpolationMethod.LINEAR_RGB</code></li>
         * </ul>
         *
         * <p>The following illustrations show gradients in which the matrix was
         * defined using the <code>createGradientBox()</code> method with different
         * parameter settings:</p>
         *
         * @param width    The width of the gradient box.
         * @param height   The height of the gradient box.
         * @param rotation The amount to rotate, in radians.
         * @param tx       The distance, in pixels, to translate to the right along
         *                 the <i>x</i> axis. This value is offset by half of the
         *                 <code>width</code> parameter.
         * @param ty       The distance, in pixels, to translate down along the
         *                 <i>y</i> axis. This value is offset by half of the
         *                 <code>height</code> parameter.
         */
        Matrix.prototype.createGradientBox = function (width, height, rotation, tx, ty) {
            if (rotation === void 0) { rotation = 0; }
            if (tx === void 0) { tx = 0; }
            if (ty === void 0) { ty = 0; }
            this.createBox(width / 1638.4, height / 1638.4, rotation, tx + width / 2, ty + height / 2);
        };
        /**
         * Given a point in the pretransform coordinate space, returns the
         * coordinates of that point after the transformation occurs. Unlike the
         * standard transformation applied using the <code>transformPoint()</code>
         * method, the <code>deltaTransformPoint()</code> method's transformation
         * does not consider the translation parameters <code>tx</code> and
         * <code>ty</code>.
         *
         * @param point The point for which you want to get the result of the matrix
         *              transformation.
         * @return The point resulting from applying the matrix transformation.
         */
        Matrix.prototype.deltaTransformPoint = function (point) {
            var raw = this.rawData;
            return new Point(point.x * raw[0] + point.y * raw[2], point.x * raw[1] + point.y * raw[3]);
        };
        /**
         * Sets each matrix property to a value that causes a null transformation. An
         * object transformed by applying an identity matrix will be identical to the
         * original.
         *
         * <p>After calling the <code>identity()</code> method, the resulting matrix
         * has the following properties: <code>a</code>=1, <code>b</code>=0,
         * <code>c</code>=0, <code>d</code>=1, <code>tx</code>=0,
         * <code>ty</code>=0.</p>
         *
         * <p>In matrix notation, the identity matrix looks like this:</p>
         *
         */
        Matrix.prototype.identity = function () {
            var raw = this.rawData;
            raw[0] = 1;
            raw[1] = 0;
            raw[2] = 0;
            raw[3] = 1;
            raw[4] = 0;
            raw[5] = 0;
        };
        /**
         * Performs the opposite transformation of the original matrix. You can apply
         * an inverted matrix to an object to undo the transformation performed when
         * applying the original matrix.
         */
        Matrix.prototype.invert = function () {
            var raw = this.rawData;
            var b = raw[1];
            var c = raw[2];
            var tx = raw[4];
            var ty = raw[5];
            if (b === 0 && c === 0) {
                var a = raw[0] = 1 / raw[0];
                var d = raw[3] = 1 / raw[3];
                raw[1] = raw[2] = 0;
                raw[4] = -a * tx;
                raw[5] = -d * ty;
                return;
            }
            var a = raw[0];
            var d = raw[3];
            var determinant = a * d - b * c;
            if (determinant === 0) {
                this.identity();
                return;
            }
            /**
             * Multiplying by reciprocal of the |determinant| is only accurate if the reciprocal is
             * representable without loss of precision. This is usually only the case for powers of
             * two: 1/2, 1/4 ...
             */
            determinant = 1 / determinant;
            var k = 0;
            k = raw[0] = d * determinant;
            b = raw[1] = -b * determinant;
            c = raw[2] = -c * determinant;
            d = raw[3] = a * determinant;
            raw[4] = -(k * tx + c * ty);
            raw[5] = -(b * tx + d * ty);
        };
        /**
         * Returns a new Matrix object that is a clone of this matrix, with an exact
         * copy of the contained object.
         *
         * @param matrix The matrix for which you want to get the result of the matrix
         *               transformation.
         * @return A Matrix object.
         */
        Matrix.prototype.multiply = function (matrix) {
            var result = new Matrix();
            result.a = this.a * matrix.a + this.b * matrix.c;
            result.b = this.a * matrix.b + this.b * matrix.d;
            result.c = this.c * matrix.a + this.d * matrix.c;
            result.d = this.c * matrix.b + this.d * matrix.d;
            result.tx = this.tx * matrix.a + this.ty * matrix.c + matrix.tx;
            result.ty = this.tx * matrix.b + this.ty * matrix.d + matrix.ty;
            return result;
        };
        /**
         * Applies a rotation transformation to the Matrix object.
         *
         * <p>The <code>rotate()</code> method alters the <code>a</code>,
         * <code>b</code>, <code>c</code>, and <code>d</code> properties of the
         * Matrix object. In matrix notation, this is the same as concatenating the
         * current matrix with the following:</p>
         *
         * @param angle The rotation angle in radians.
         */
        Matrix.prototype.rotate = function (angle) {
            if (angle !== 0) {
                var raw = this.rawData;
                var u = Math.cos(angle);
                var v = Math.sin(angle);
                var ta = raw[0];
                var tb = raw[1];
                var tc = raw[2];
                var td = raw[3];
                var ttx = raw[4];
                var tty = raw[5];
                raw[0] = ta * u - tb * v;
                raw[1] = ta * v + tb * u;
                raw[2] = tc * u - td * v;
                raw[3] = tc * v + td * u;
                raw[4] = ttx * u - tty * v;
                raw[5] = ttx * v + tty * u;
            }
        };
        /**
         * Applies a scaling transformation to the matrix. The <i>x</i> axis is
         * multiplied by <code>sx</code>, and the <i>y</i> axis it is multiplied by
         * <code>sy</code>.
         *
         * <p>The <code>scale()</code> method alters the <code>a</code> and
         * <code>d</code> properties of the Matrix object. In matrix notation, this
         * is the same as concatenating the current matrix with the following
         * matrix:</p>
         *
         * @param sx A multiplier used to scale the object along the <i>x</i> axis.
         * @param sy A multiplier used to scale the object along the <i>y</i> axis.
         */
        Matrix.prototype.scale = function (sx, sy) {
            var raw = this.rawData;
            if (sx !== 1) {
                raw[0] *= sx;
                raw[1] *= sx;
                raw[4] *= sx;
            }
            if (sy !== 1) {
                raw[2] *= sy;
                raw[3] *= sy;
                raw[5] *= sy;
            }
        };
        /**
         * Sets the members of Matrix to the specified values.
         *
         * @param a  The value that affects the positioning of pixels along the
         *           <i>x</i> axis when scaling or rotating an image.
         * @param b  The value that affects the positioning of pixels along the
         *           <i>y</i> axis when rotating or skewing an image.
         * @param c  The value that affects the positioning of pixels along the
         *           <i>x</i> axis when rotating or skewing an image.
         * @param d  The value that affects the positioning of pixels along the
         *           <i>y</i> axis when scaling or rotating an image..
         * @param tx The distance by which to translate each point along the <i>x</i>
         *           axis.
         * @param ty The distance by which to translate each point along the <i>y</i>
         *           axis.
         */
        Matrix.prototype.setTo = function (a, b, c, d, tx, ty) {
            var raw = this.rawData;
            raw[0] = a;
            raw[2] = b;
            raw[1] = c;
            raw[3] = d;
            raw[4] = tx;
            raw[5] = ty;
        };
        /**
         * Returns a text value listing the properties of the Matrix object.
         *
         * @return A string containing the values of the properties of the Matrix
         *         object: <code>a</code>, <code>b</code>, <code>c</code>,
         *         <code>d</code>, <code>tx</code>, and <code>ty</code>.
         */
        Matrix.prototype.toString = function () {
            return "[Matrix] (a=" + this.a + ", b=" + this.b + ", c=" + this.c + ", d=" + this.d + ", tx=" + this.tx + ", ty=" + this.ty + ")";
        };
        /**
         * Returns the result of applying the geometric transformation represented by
         * the Matrix object to the specified point.
         *
         * @param point The point for which you want to get the result of the Matrix
         *              transformation.
         * @return The point resulting from applying the Matrix transformation.
         */
        Matrix.prototype.transformPoint = function (point) {
            var raw = this.rawData;
            return new Point(point.x * raw[0] + point.y * raw[2] + raw[4], point.x * raw[1] + point.y * raw[3] + raw[5]);
        };
        /**
         * Translates the matrix along the <i>x</i> and <i>y</i> axes, as specified
         * by the <code>dx</code> and <code>dy</code> parameters.
         *
         * @param dx The amount of movement along the <i>x</i> axis to the right, in
         *           pixels.
         * @param dy The amount of movement down along the <i>y</i> axis, in pixels.
         */
        Matrix.prototype.translate = function (dx, dy) {
            this.rawData[4] += dx;
            this.rawData[5] += dy;
        };
        return Matrix;
    }());

    /**
     * The Vector3D export class represents a point or a location in the three-dimensional
     * space using the Cartesian coordinates x, y, and z. As in a two-dimensional
     * space, the x property represents the horizontal axis and the y property
     * represents the vertical axis. In three-dimensional space, the z property
     * represents depth. The value of the x property increases as the object moves
     * to the right. The value of the y property increases as the object moves
     * down. The z property increases as the object moves farther from the point
     * of view. Using perspective projection and scaling, the object is seen to be
     * bigger when near and smaller when farther away from the screen. As in a
     * right-handed three-dimensional coordinate system, the positive z-axis points
     * away from the viewer and the value of the z property increases as the object
     * moves away from the viewer's eye. The origin point (0,0,0) of the global
     * space is the upper-left corner of the stage.
     *
     * <p>The Vector3D export class can also represent a direction, an arrow pointing from
     * the origin of the coordinates, such as (0,0,0), to an endpoint; or a
     * floating-point component of an RGB (Red, Green, Blue) color model.</p>
     *
     * <p>Quaternion notation introduces a fourth element, the w property, which
     * provides additional orientation information. For example, the w property can
     * define an angle of rotation of a Vector3D object. The combination of the
     * angle of rotation and the coordinates x, y, and z can determine the display
     * object's orientation. Here is a representation of Vector3D elements in
     * matrix notation:</p>
     */
    var Vector3D = /** @class */ (function () {
        /**
         * Creates an instance of a Vector3D object. If you do not specify a
         * parameter for the constructor, a Vector3D object is created with
         * the elements (0,0,0,0).
         *
         * @param x The first element, such as the x coordinate.
         * @param y The second element, such as the y coordinate.
         * @param z The third element, such as the z coordinate.
         * @param w An optional element for additional data such as the angle
         *          of rotation.
         */
        function Vector3D(x, y, z, w) {
            if (x === void 0) { x = 0; }
            if (y === void 0) { y = 0; }
            if (z === void 0) { z = 0; }
            if (w === void 0) { w = 1; }
            this._rawData = new Float32Array(4);
            var raw = this._rawData;
            raw[0] = x;
            raw[1] = y;
            raw[2] = z;
            raw[3] = w;
        }
        Object.defineProperty(Vector3D.prototype, "x", {
            /**
             * The first element of a Vector3D object, such as the x coordinate of
             * a point in the three-dimensional space. The default value is 0.
             */
            get: function () {
                return this._rawData[0];
            },
            set: function (value) {
                this._rawData[0] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Vector3D.prototype, "y", {
            /*
             *The second element of a Vector3D object, such as the y coordinate of
             * a point in the three-dimensional space. The default value is 0.
             */
            get: function () {
                return this._rawData[1];
            },
            set: function (value) {
                this._rawData[1] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Vector3D.prototype, "z", {
            /**
             * The third element of a Vector3D object, such as the z coordinate of
             * a point in the three-dimensional space. The default value is 0.
             */
            get: function () {
                return this._rawData[2];
            },
            set: function (value) {
                this._rawData[2] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Vector3D.prototype, "w", {
            /**
             * The fourth element of a Vector3D object (in addition to the x, y,
             * and z properties) can hold data such as the angle of rotation. The
             * default value is 0.
             *
             * <p>Quaternion notation employs an angle as the fourth element in
             * its calculation of three-dimensional rotation. The w property can
             * be used to define the angle of rotation about the Vector3D object.
             * The combination of the rotation angle and the coordinates (x,y,z)
             * determines the display object's orientation.</p>
             *
             * <p>In addition, the w property can be used as a perspective warp
             * factor for a projected three-dimensional position or as a projection
             * transform value in representing a three-dimensional coordinate
             * projected into the two-dimensional space. For example, you can
             * create a projection matrix using the <code>Matrix3D.rawData</code>
             * property, that, when applied to a Vector3D object, produces a
             * transform value in the Vector3D object's fourth element (the w
             * property). Dividing the Vector3D object's other elements by the
             * transform value then produces a projected Vector3D object. You can
             * use the <code>Vector3D.project()</code> method to divide the first
             * three elements of a Vector3D object by its fourth element.</p>
             */
            get: function () {
                return this._rawData[3];
            },
            set: function (value) {
                this._rawData[3] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Vector3D.prototype, "length", {
            /**
             * The length, magnitude, of the current Vector3D object from the
             * origin (0,0,0) to the object's x, y, and z coordinates. The w
             * property is ignored. A unit vector has a length or magnitude of
             * one.
             */
            get: function () {
                return Math.sqrt(this.lengthSquared);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Vector3D.prototype, "lengthSquared", {
            /**
             * The square of the length of the current Vector3D object, calculated
             * using the x, y, and z properties. The w property is ignored. Use the
             * <code>lengthSquared()</code> method whenever possible instead of the
             * slower <code>Math.sqrt()</code> method call of the
             * <code>Vector3D.length()</code> method.
             */
            get: function () {
                var raw = this._rawData;
                return raw[0] * raw[0] + raw[1] * raw[1] + raw[2] * raw[2];
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Adds the value of the x, y, and z elements of the current Vector3D
         * object to the values of the x, y, and z elements of another Vector3D
         * object. The <code>add()</code> method does not change the current
         * Vector3D object. Instead, it returns a new Vector3D object with
         * the new values.
         *
         * <p>The result of adding two vectors together is a resultant vector.
         * One way to visualize the result is by drawing a vector from the
         * origin or tail of the first vector to the end or head of the second
         * vector. The resultant vector is the distance between the origin
         * point of the first vector and the end point of the second vector.
         * </p>
         */
        Vector3D.prototype.add = function (a) {
            var raw = this._rawData;
            var rawA = a._rawData;
            return new Vector3D(raw[0] + rawA[0], raw[1] + rawA[1], raw[2] + rawA[2]);
        };
        /**
         * Returns the angle in radians between two vectors. The returned angle
         * is the smallest radian the first Vector3D object rotates until it
         * aligns with the second Vector3D object.
         *
         * <p>The <code>angleBetween()</code> method is a static method. You
         * can use it directly as a method of the Vector3D class.</p>
         *
         * <p>To convert a degree to a radian, you can use the following
         * formula:</p>
         *
         * <p><code>radian = Math.PI/180 * degree</code></p>
         *
         * @param a The first Vector3D object.
         * @param b The second Vector3D object.
         * @returns The angle between two Vector3D objects.
         */
        Vector3D.angleBetween = function (a, b) {
            return Math.acos(a.dotProduct(b) / (a.length * b.length));
        };
        /**
         * Returns a new Vector3D object that is an exact copy of the current
         * Vector3D object.
         *
         * @returns A new Vector3D object that is a copy of the current
         * Vector3D object.
         */
        Vector3D.prototype.clone = function () {
            var raw = this._rawData;
            return new Vector3D(raw[0], raw[1], raw[2], raw[3]);
        };
        Vector3D.combine = function (a, b, ascl, bscl) {
            var rawA = a._rawData;
            var rawB = b._rawData;
            return new Vector3D(rawA[0] * ascl + rawB[0] * bscl, rawA[1] * ascl + rawB[1] * bscl, rawA[2] * ascl + rawB[2] * bscl);
        };
        /**
         * Copies all of vector data from the source Vector3D object into the
         * calling Vector3D object.
         *
         * @param src The Vector3D object from which to copy the data.
         */
        Vector3D.prototype.copyFrom = function (src) {
            var raw = this._rawData;
            var rawSrc = src._rawData;
            raw[0] = rawSrc[0];
            raw[1] = rawSrc[1];
            raw[2] = rawSrc[2];
            raw[3] = rawSrc[3];
        };
        /**
         * Returns a new Vector3D object that is perpendicular (at a right
         * angle) to the current Vector3D and another Vector3D object. If the
         * returned Vector3D object's coordinates are (0,0,0), then the two
         * Vector3D objects are parallel to each other.
         *
         * <p>You can use the normalized cross product of two vertices of a
         * polygon surface with the normalized vector of the camera or eye
         * viewpoint to get a dot product. The value of the dot product can
         * identify whether a surface of a three-dimensional object is hidden
         * from the viewpoint.</p>
         *
         * @param a A second Vector3D object.
         * @returns A new Vector3D object that is perpendicular to the current
         *          Vector3D object and the Vector3D object specified as the
         *          parameter.
         */
        Vector3D.prototype.crossProduct = function (a, t) {
            if (t === void 0) { t = null; }
            if (t == null)
                t = new Vector3D();
            var raw = this._rawData;
            var rawA = a._rawData;
            var rawT = t._rawData;
            rawT[0] = raw[1] * rawA[2] - raw[2] * rawA[1];
            rawT[1] = raw[2] * rawA[0] - raw[0] * rawA[2];
            rawT[2] = raw[0] * rawA[1] - raw[1] * rawA[0];
            return t;
        };
        /**
         * Decrements the value of the x, y, and z elements of the current
         * Vector3D object by the values of the x, y, and z elements of
         * specified Vector3D object. Unlike the
         * <code>Vector3D.subtract()</code> method, the
         * <code>decrementBy()</code> method changes the current Vector3D
         * object and does not return a new Vector3D object.
         *
         * @param a The Vector3D object containing the values to subtract from
         *          the current Vector3D object.
         */
        Vector3D.prototype.decrementBy = function (a) {
            var raw = this._rawData;
            var rawA = a._rawData;
            raw[0] -= rawA[0];
            raw[1] -= rawA[1];
            raw[2] -= rawA[2];
        };
        /**
         * Returns the distance between two Vector3D objects. The
         * <code>distance()</code> method is a static method. You can use it
         * directly as a method of the Vector3D export class to get the Euclidean
         * distance between two three-dimensional points.
         *
         * @param pt1 A Vector3D object as the first three-dimensional point.
         * @param pt2 A Vector3D object as the second three-dimensional point.
         * @returns The distance between two Vector3D objects.
         */
        Vector3D.distance = function (pt1, pt2) {
            var rawPt1 = pt1._rawData;
            var rawPt2 = pt2._rawData;
            var x = rawPt1[0] - rawPt2[0];
            var y = rawPt1[1] - rawPt2[1];
            var z = rawPt1[2] - rawPt2[2];
            return Math.sqrt(x * x + y * y + z * z);
        };
        /**
         * If the current Vector3D object and the one specified as the
         * parameter are unit vertices, this method returns the cosine of the
         * angle between the two vertices. Unit vertices are vertices that
         * point to the same direction but their length is one. They remove the
         * length of the vector as a factor in the result. You can use the
         * <code>normalize()</code> method to convert a vector to a unit
         * vector.
         *
         * <p>The <code>dotProduct()</code> method finds the angle between two
         * vertices. It is also used in backface culling or lighting
         * calculations. Backface culling is a procedure for determining which
         * surfaces are hidden from the viewpoint. You can use the normalized
         * vertices from the camera, or eye, viewpoint and the cross product of
         * the vertices of a polygon surface to get the dot product. If the dot
         * product is less than zero, then the surface is facing the camera or
         * the viewer. If the two unit vertices are perpendicular to each
         * other, they are orthogonal and the dot product is zero. If the two
         * vertices are parallel to each other, the dot product is one.</p>
         *
         * @param a The second Vector3D object.
         * @returns A scalar which is the dot product of the current Vector3D
         *          object and the specified Vector3D object.
         *
         * @see away.geom.Vector3D#crossProduct()
         * @see away.geom.Vector3D#normalize()
         */
        Vector3D.prototype.dotProduct = function (a) {
            var raw = this._rawData;
            var rawA = a._rawData;
            return raw[0] * rawA[0] + raw[1] * rawA[1] + raw[2] * rawA[2];
        };
        /**
         * Determines whether two Vector3D objects are equal by comparing the
         * x, y, and z elements of the current Vector3D object with a
         * specified Vector3D object. If the values of these elements are the
         * same, the two Vector3D objects are equal. If the second optional
         * parameter is set to true, all four elements of the Vector3D objects,
         * including the w property, are compared.
         *
         * @param toCompare The Vector3D object to be compared with the current
         *                  Vector3D object.
         * @param allFour   An optional parameter that specifies whether the w
         *                  property of the Vector3D objects is used in the
         *                  comparison.
         * @returns A value of true if the specified Vector3D object is equal
         *          to the current Vector3D object; false if it is not equal.
         */
        Vector3D.prototype.equals = function (toCompare, allFour) {
            if (allFour === void 0) { allFour = false; }
            var raw = this._rawData;
            var rawToCompare = toCompare._rawData;
            return (raw[0] == rawToCompare[0] && raw[1] == rawToCompare[1] && raw[2] == rawToCompare[2] && (!allFour || raw[3] == rawToCompare[3]));
        };
        /**
         * Converts the current vector to an identity or unit vector.
         */
        Vector3D.prototype.identity = function () {
            var raw = this._rawData;
            raw[0] = 0;
            raw[1] = 0;
            raw[2] = 0;
            raw[3] = 1;
        };
        /**
         * Increments the value of the x, y, and z elements of the current
         * Vector3D object by the values of the x, y, and z elements of a
         * specified Vector3D object. Unlike the <code>Vector3D.add()</code>
         * method, the <code>incrementBy()</code> method changes the current
         * Vector3D object and does not return a new Vector3D object.
         *
         * @param a The Vector3D object to be added to the current Vector3D
         *          object.
         */
        Vector3D.prototype.incrementBy = function (a) {
            var raw = this._rawData;
            var rawA = a._rawData;
            raw[0] += rawA[0];
            raw[1] += rawA[1];
            raw[2] += rawA[2];
        };
        /**
         * Compares the elements of the current Vector3D object with the
         * elements of a specified Vector3D object to determine whether they
         * are nearly equal. The two Vector3D objects are nearly equal if the
         * value of all the elements of the two vertices are equal, or the
         * result of the comparison is within the tolerance range. The
         * difference between two elements must be less than the number
         * specified as the tolerance parameter. If the third optional
         * parameter is set to <code>true</code>, all four elements of the
         * Vector3D objects, including the <code>w</code> property, are
         * compared. Otherwise, only the x, y, and z elements are included in
         * the comparison.
         *
         * @param toCompare The Vector3D object to be compared with the current
         *                  Vector3D object.
         * @param tolerance A number determining the tolerance factor. If the
         *                  difference between the values of the Vector3D
         *                  element specified in the toCompare parameter and
         *                  the current Vector3D element is less than the
         *                  tolerance number, the two values are considered
         *                  nearly equal.
         * @param allFour   An optional parameter that specifies whether the w
         *                  property of the Vector3D objects is used in the
         *                  comparison.
         * @returns A value of true if the specified Vector3D object is nearly
         *          equal to the current Vector3D object; false if it is not
         *          equal.
         *
         * @see away.geom.Vector3D#equals()
         */
        Vector3D.prototype.nearEquals = function (toCompare, tolerance, allFour) {
            if (allFour === void 0) { allFour = true; }
            var raw = this._rawData;
            var rawToCompare = toCompare._rawData;
            return ((Math.abs(raw[0] - rawToCompare[0]) < tolerance)
                && (Math.abs(raw[1] - rawToCompare[1]) < tolerance)
                && (Math.abs(raw[2] - rawToCompare[2]) < tolerance)
                && (!allFour || Math.abs(raw[3] - rawToCompare[3]) < tolerance));
        };
        /**
         * Sets the current Vector3D object to its inverse. The inverse object
         * is also considered the opposite of the original object. The value of
         * the x, y, and z properties of the current Vector3D object is changed
         * to -x, -y, and -z.
         */
        Vector3D.prototype.negate = function () {
            var raw = this._rawData;
            raw[0] = -raw[0];
            raw[1] = -raw[1];
            raw[2] = -raw[2];
        };
        /**
         * Scales the Vector3D object between(0,0,0) and the current point to a set
         * length.
         *
         * @param thickness The scaling value. For example, if the current
         *                  Vector3D object is (0,3,4), and you normalize it to
         *                  1, the point returned is at(0,0.6,0.8).
         */
        Vector3D.prototype.normalize = function (thickness) {
            if (thickness === void 0) { thickness = 1; }
            var len = this.length;
            if (len) {
                var raw = this._rawData;
                var invLength = thickness / len;
                raw[0] *= invLength;
                raw[1] *= invLength;
                raw[2] *= invLength;
            }
            return len;
        };
        /**
         * Divides the value of the <code>x</code>, <code>y</code>, and
         * <code>z</code> properties of the current Vector3D object by the
         * value of its <code>w</code> property.
         *
         * <p>If the current Vector3D object is the result of multiplying a
         * Vector3D object by a projection Matrix3D object, the w property can
         * hold the transform value. The <code>project()</code> method then can
         * complete the projection by dividing the elements by the
         * <code>w</code> property. Use the <code>Matrix3D.rawData</code>
         * property to create a projection Matrix3D object.</p>
         */
        Vector3D.prototype.project = function () {
            var raw = this._rawData;
            raw[0] /= raw[3];
            raw[1] /= raw[3];
            raw[2] /= raw[3];
        };
        /**
         * Scales the current Vector3D object by a scalar, a magnitude. The
         * Vector3D object's x, y, and z elements are multiplied by the scalar
         * number specified in the parameter. For example, if the vector is
         * scaled by ten, the result is a vector that is ten times longer. The
         * scalar can also change the direction of the vector. Multiplying the
         * vector by a negative number reverses its direction.
         *
         * @param s A multiplier (scalar) used to scale a Vector3D object.
         */
        Vector3D.prototype.scaleBy = function (s) {
            var raw = this._rawData;
            raw[0] *= s;
            raw[1] *= s;
            raw[2] *= s;
        };
        /**
         * Sets the members of Vector3D to the specified values
         *
         * @param xa The first element, such as the x coordinate.
         * @param ya The second element, such as the y coordinate.
         * @param za The third element, such as the z coordinate.
         */
        Vector3D.prototype.setTo = function (xa, ya, za, wa) {
            if (wa === void 0) { wa = 1; }
            var raw = this._rawData;
            raw[0] = xa;
            raw[1] = ya;
            raw[2] = za;
            raw[3] = wa;
        };
        /**
         * Subtracts the value of the x, y, and z elements of the current
         * Vector3D object from the values of the x, y, and z elements of
         * another Vector3D object. The <code>subtract()</code> method does not
         * change the current Vector3D object. Instead, this method returns a
         * new Vector3D object with the new values.
         *
         * @param a The Vector3D object to be subtracted from the current
         *          Vector3D object.
         * @returns A new Vector3D object that is the difference between the
         *          current Vector3D and the specified Vector3D object.
         *
         * @see away.geom.Vector3D#decrementBy()
         */
        Vector3D.prototype.subtract = function (a) {
            var raw = this._rawData;
            var rawA = a._rawData;
            return new Vector3D(raw[0] - rawA[0], raw[1] - rawA[1], raw[2] - rawA[2]);
        };
        /**
         * Returns a string representation of the current Vector3D object. The
         * string contains the values of the x, y, and z properties.
         */
        Vector3D.prototype.toString = function () {
            var raw = this._rawData;
            return "[Vector3D] (x:" + raw[0] + " ,y:" + raw[1] + ", z" + raw[2] + ", w:" + raw[3] + ")";
        };
        /**
         * The x axis defined as a Vector3D object with coordinates (1,0,0).
         */
        Vector3D.X_AXIS = new Vector3D(1, 0, 0);
        /**
         * The y axis defined as a Vector3D object with coordinates (0,1,0).
         */
        Vector3D.Y_AXIS = new Vector3D(0, 1, 0);
        /**
         * The z axis defined as a Vector3D object with coordinates (0,0,1).
         */
        Vector3D.Z_AXIS = new Vector3D(0, 0, 1);
        return Vector3D;
    }());

    /**
     * A Box object is an area defined by its position, as indicated by its
     * top-left-front corner point(<i>x</i>, <i>y</i>, <i>z</i>) and by its width,
     * height and depth.
     *
     *
     * <p>The <code>x</code>, <code>y</code>, <code>z</code>, <code>width</code>,
     * <code>height</code> <code>depth</code> properties of the Box export class are
     * independent of each other; changing the value of one property has no effect
     * on the others. However, the <code>right</code>, <code>bottom</code> and
     * <code>back</code> properties are integrally related to those six
     * properties. For example, if you change the value of the <code>right</code>
     * property, the value of the <code>width</code> property changes; if you
     * change the <code>bottom</code> property, the value of the
     * <code>height</code> property changes. </p>
     *
     * <p>The following methods and properties use Box objects:</p>
     *
     * <ul>
     *   <li>The <code>bounds</code> property of the DisplayObject class</li>
     * </ul>
     *
     * <p>You can use the <code>new Box()</code> constructor to create a
     * Box object.</p>
     *
     * <p><b>Note:</b> The Box export class does not define a cubic Shape
     * display object.
     */
    var Box = /** @class */ (function () {
        /**
         * Creates a new Box object with the top-left-front corner specified by the
         * <code>x</code>, <code>y</code> and <code>z</code> parameters and with the
         * specified <code>width</code>, <code>height</code> and <code>depth</code>
         * parameters. If you call this public without parameters, a box with
         * <code>x</code>, <code>y</code>, <code>z</code>, <code>width</code>,
         * <code>height</code> and <code>depth</code> properties set to 0 is created.
         *
         * @param x      The <i>x</i> coordinate of the top-left-front corner of the
         *               box.
         * @param y      The <i>y</i> coordinate of the top-left-front corner of the
         *               box.
         * @param z      The <i>z</i> coordinate of the top-left-front corner of the
         *               box.
         * @param width  The width of the box, in pixels.
         * @param height The height of the box, in pixels.
         * @param depth The depth of the box, in pixels.
         */
        function Box(x, y, z, width, height, depth) {
            if (x === void 0) { x = 0; }
            if (y === void 0) { y = 0; }
            if (z === void 0) { z = 0; }
            if (width === void 0) { width = 0; }
            if (height === void 0) { height = 0; }
            if (depth === void 0) { depth = 0; }
            this.x = x;
            this.y = y;
            this.z = z;
            this.width = width;
            this.height = height;
            this.depth = depth;
        }
        Object.defineProperty(Box.prototype, "back", {
            /**
             * The sum of the <code>z</code> and <code>height</code> properties.
             */
            get: function () {
                return this.z + this.depth;
            },
            set: function (val) {
                this.depth = val - this.z;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Box.prototype, "bottom", {
            /**
             * The sum of the <code>y</code> and <code>height</code> properties.
             */
            get: function () {
                return this.y + this.height;
            },
            set: function (val) {
                this.height = val - this.y;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Box.prototype, "bottomRightBack", {
            /**
             * The location of the Box object's bottom-right corner, determined by the
             * values of the <code>right</code> and <code>bottom</code> properties.
             */
            get: function () {
                if (this._bottomRightBack == null)
                    this._bottomRightBack = new Vector3D();
                this._bottomRightBack.x = this.x + this.width;
                this._bottomRightBack.y = this.y + this.height;
                this._bottomRightBack.z = this.z + this.depth;
                return this._bottomRightBack;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Box.prototype, "front", {
            /**
             * The <i>z</i> coordinate of the top-left-front corner of the box. Changing
             * the <code>front</code> property of a Box object has no effect on the
             * <code>x</code>, <code>y</code>, <code>width</code> and <code>height</code>
             * properties. However it does affect the <code>depth</code> property,
             * whereas changing the <code>z</code> value does <i>not</i> affect the
             * <code>depth</code> property.
             *
             * <p>The value of the <code>left</code> property is equal to the value of
             * the <code>x</code> property.</p>
             */
            get: function () {
                return this.z;
            },
            set: function (val) {
                this.depth += this.z - val;
                this.z = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Box.prototype, "left", {
            /**
             * The <i>x</i> coordinate of the top-left corner of the box. Changing the
             * <code>left</code> property of a Box object has no effect on the
             * <code>y</code> and <code>height</code> properties. However it does affect
             * the <code>width</code> property, whereas changing the <code>x</code> value
             * does <i>not</i> affect the <code>width</code> property.
             *
             * <p>The value of the <code>left</code> property is equal to the value of
             * the <code>x</code> property.</p>
             */
            get: function () {
                return this.x;
            },
            set: function (val) {
                this.width += this.x - val;
                this.x = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Box.prototype, "right", {
            /**
             * The sum of the <code>x</code> and <code>width</code> properties.
             */
            get: function () {
                return this.x + this.width;
            },
            set: function (val) {
                this.width = val - this.x;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Box.prototype, "size", {
            /**
             * The size of the Box object, expressed as a Vector3D object with the
             * values of the <code>width</code>, <code>height</code> and
             * <code>depth</code> properties.
             */
            get: function () {
                if (this._size == null)
                    this._size = new Vector3D();
                this._size.x = this.width;
                this._size.y = this.height;
                this._size.z = this.depth;
                return this._size;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Box.prototype, "top", {
            /**
             * The <i>y</i> coordinate of the top-left-front corner of the box. Changing
             * the <code>top</code> property of a Box object has no effect on the
             * <code>x</code> and <code>width</code> properties. However it does affect
             * the <code>height</code> property, whereas changing the <code>y</code>
             * value does <i>not</i> affect the <code>height</code> property.
             *
             * <p>The value of the <code>top</code> property is equal to the value of the
             * <code>y</code> property.</p>
             */
            get: function () {
                return this.y;
            },
            set: function (val) {
                this.height += (this.y - val);
                this.y = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Box.prototype, "topLeftFront", {
            /**
             * The location of the Box object's top-left-front corner, determined by the
             * <i>x</i>, <i>y</i> and <i>z</i> coordinates of the point.
             */
            get: function () {
                if (this._topLeftFront == null)
                    this._topLeftFront = new Vector3D();
                this._topLeftFront.x = this.x;
                this._topLeftFront.y = this.y;
                this._topLeftFront.z = this.z;
                return this._topLeftFront;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns a new Box object with the same values for the <code>x</code>,
         * <code>y</code>, <code>z</code>, <code>width</code>, <code>height</code>
         * and <code>depth</code> properties as the original Box object.
         *
         * @return A new Box object with the same values for the <code>x</code>,
         *         <code>y</code>, <code>z</code>, <code>width</code>,
         *         <code>height</code> and <code>depth</code> properties as the
         *         original Box object.
         */
        Box.prototype.clone = function () {
            return new Box(this.x, this.y, this.z, this.width, this.height, this.depth);
        };
        /**
         * Determines whether the specified position is contained within the cubic
         * region defined by this Box object.
         *
         * @param x The <i>x</i> coordinate(horizontal component) of the position.
         * @param y The <i>y</i> coordinate(vertical component) of the position.
         * @param z The <i>z</i> coordinate(longitudinal component) of the position.
         * @return A value of <code>true</code> if the Box object contains the
         *         specified position; otherwise <code>false</code>.
         */
        Box.prototype.contains = function (x, y, z) {
            return (this.x <= x && this.x + this.width >= x && this.y <= y && this.y + this.height >= y && this.z <= z && this.z + this.depth >= z);
        };
        /**
         * Determines whether the specified position is contained within the cubic
         * region defined by this Box object. This method is similar to the
         * <code>Box.contains()</code> method, except that it takes a Vector3D
         * object as a parameter.
         *
         * @param position The position, as represented by its <i>x</i>, <i>y</i> and
         *                 <i>z</i> coordinates.
         * @return A value of <code>true</code> if the Box object contains the
         *         specified position; otherwise <code>false</code>.
         */
        Box.prototype.containsPoint = function (position) {
            return (this.x <= position.x && this.x + this.width >= position.x && this.y <= position.y && this.y + this.height >= position.y && this.z <= position.z && this.z + this.depth >= position.z);
        };
        /**
         * Determines whether the Box object specified by the <code>box</code>
         * parameter is contained within this Box object. A Box object is said to
         * contain another if the second Box object falls entirely within the
         * boundaries of the first.
         *
         * @param box The Box object being checked.
         * @return A value of <code>true</code> if the Box object that you specify
         *         is contained by this Box object; otherwise <code>false</code>.
         */
        Box.prototype.containsBox = function (box) {
            return (this.x <= box.x && this.x + this.width >= box.x + box.width && this.y <= box.y && this.y + this.height >= box.y + box.height && this.z <= box.z && this.z + this.depth >= box.z + box.depth);
        };
        /**
         * Copies all of box data from the source Box object into the calling
         * Box object.
         *
         * @param sourceBox The Box object from which to copy the data.
         */
        Box.prototype.copyFrom = function (sourceBox) {
            this.x = sourceBox.x;
            this.y = sourceBox.y;
            this.z = sourceBox.z;
            this.width = sourceBox.width;
            this.height = sourceBox.height;
            this.depth = sourceBox.depth;
        };
        /**
         * Determines whether the object specified in the <code>toCompare</code>
         * parameter is equal to this Box object. This method compares the
         * <code>x</code>, <code>y</code>, <code>z</code>, <code>width</code>,
         * <code>height</code> and <code>depth</code> properties of an object against
         * the same properties of this Box object.
         *
         * @param toCompare The box to compare to this Box object.
         * @return A value of <code>true</code> if the object has exactly the same
         *         values for the <code>x</code>, <code>y</code>, <code>z</code>,
         *         <code>width</code>, <code>height</code> and <code>depth</code>
         *         properties as this Box object; otherwise <code>false</code>.
         */
        Box.prototype.equals = function (toCompare) {
            return (this.x == toCompare.x && this.y == toCompare.y && this.z == toCompare.z && this.width == toCompare.width && this.height == toCompare.height && this.depth == toCompare.depth);
        };
        /**
         * Increases the size of the Box object by the specified amounts, in
         * pixels. The center point of the Box object stays the same, and its
         * size increases to the left and right by the <code>dx</code> value, to
         * the top and the bottom by the <code>dy</code> value, and to
         * the front and the back by the <code>dz</code> value.
         *
         * @param dx The value to be added to the left and the right of the Box
         *           object. The following equation is used to calculate the new
         *           width and position of the box:
         * @param dy The value to be added to the top and the bottom of the Box
         *           object. The following equation is used to calculate the new
         *           height and position of the box:
         * @param dz The value to be added to the front and the back of the Box
         *           object. The following equation is used to calculate the new
         *           depth and position of the box:
         */
        Box.prototype.inflate = function (dx, dy, dz) {
            this.x -= dx / 2;
            this.y -= dy / 2;
            this.z -= dz / 2;
            this.width += dx / 2;
            this.height += dy / 2;
            this.depth += dz / 2;
        };
        /**
         * Increases the size of the Box object. This method is similar to the
         * <code>Box.inflate()</code> method except it takes a Vector3D object as
         * a parameter.
         *
         * <p>The following two code examples give the same result:</p>
         *
         * @param delta The <code>x</code> property of this Vector3D object is used to
         *              increase the horizontal dimension of the Box object.
         *              The <code>y</code> property is used to increase the vertical
         *              dimension of the Box object.
         *              The <code>z</code> property is used to increase the
         *              longitudinal dimension of the Box object.
         */
        Box.prototype.inflatePoint = function (delta) {
            this.x -= delta.x / 2;
            this.y -= delta.y / 2;
            this.z -= delta.z / 2;
            this.width += delta.x / 2;
            this.height += delta.y / 2;
            this.depth += delta.z / 2;
        };
        /**
         * If the Box object specified in the <code>toIntersect</code> parameter
         * intersects with this Box object, returns the area of intersection
         * as a Box object. If the boxes do not intersect, this method returns an
         * empty Box object with its properties set to 0.
         *
         * @param toIntersect The Box object to compare against to see if it
         *                    intersects with this Box object.
         * @return A Box object that equals the area of intersection. If the
         *         boxes do not intersect, this method returns an empty Box
         *         object; that is, a box with its <code>x</code>, <code>y</code>,
         *         <code>z</code>, <code>width</code>,  <code>height</code>, and
         *         <code>depth</code> properties set to 0.
         */
        Box.prototype.intersection = function (toIntersect) {
            if (this.intersects(toIntersect)) {
                var i = new Box();
                if (this.x > toIntersect.x) {
                    i.x = this.x;
                    i.width = toIntersect.x - this.x + toIntersect.width;
                    if (i.width > this.width)
                        i.width = this.width;
                }
                else {
                    i.x = toIntersect.x;
                    i.width = this.x - toIntersect.x + this.width;
                    if (i.width > toIntersect.width)
                        i.width = toIntersect.width;
                }
                if (this.y > toIntersect.y) {
                    i.y = this.y;
                    i.height = toIntersect.y - this.y + toIntersect.height;
                    if (i.height > this.height)
                        i.height = this.height;
                }
                else {
                    i.y = toIntersect.y;
                    i.height = this.y - toIntersect.y + this.height;
                    if (i.height > toIntersect.height)
                        i.height = toIntersect.height;
                }
                if (this.z > toIntersect.z) {
                    i.z = this.z;
                    i.depth = toIntersect.z - this.z + toIntersect.depth;
                    if (i.depth > this.depth)
                        i.depth = this.depth;
                }
                else {
                    i.z = toIntersect.z;
                    i.depth = this.z - toIntersect.z + this.depth;
                    if (i.depth > toIntersect.depth)
                        i.depth = toIntersect.depth;
                }
                return i;
            }
            return new Box();
        };
        /**
         * Determines whether the object specified in the <code>toIntersect</code>
         * parameter intersects with this Box object. This method checks the
         * <code>x</code>, <code>y</code>, <code>z</code>, <code>width</code>,
         * <code>height</code>, and <code>depth</code> properties of the specified
         * Box object to see if it intersects with this Box object.
         *
         * @param toIntersect The Box object to compare against this Box object.
         * @return A value of <code>true</code> if the specified object intersects
         *         with this Box object; otherwise <code>false</code>.
         */
        Box.prototype.intersects = function (toIntersect) {
            return (this.x + this.width >= toIntersect.x && this.x <= toIntersect.x + toIntersect.width && this.y + this.height >= toIntersect.y && this.y <= toIntersect.y + toIntersect.height && this.z + this.depth >= toIntersect.z && this.z <= toIntersect.z + toIntersect.depth);
        };
        Box.prototype.rayIntersection = function (position, direction, targetNormal) {
            if (targetNormal === void 0) { targetNormal = null; }
            if (this.containsPoint(position))
                return 0;
            var halfExtentsX = this.width / 2;
            var halfExtentsY = this.height / 2;
            var halfExtentsZ = this.depth / 2;
            var centerX = this.x + halfExtentsX;
            var centerY = this.y + halfExtentsY;
            var centerZ = this.z + halfExtentsZ;
            var px = position.x - centerX;
            var py = position.y - centerY;
            var pz = position.z - centerZ;
            var vx = direction.x;
            var vy = direction.y;
            var vz = direction.z;
            var ix;
            var iy;
            var iz;
            var rayEntryDistance;
            // ray-plane tests
            var intersects;
            if (vx < 0) {
                rayEntryDistance = (halfExtentsX - px) / vx;
                if (rayEntryDistance > 0) {
                    iy = py + rayEntryDistance * vy;
                    iz = pz + rayEntryDistance * vz;
                    if (iy > -halfExtentsY && iy < halfExtentsY && iz > -halfExtentsZ && iz < halfExtentsZ) {
                        if (targetNormal) {
                            targetNormal.x = 1;
                            targetNormal.y = 0;
                            targetNormal.z = 0;
                        }
                        intersects = true;
                    }
                }
            }
            if (!intersects && vx > 0) {
                rayEntryDistance = (-halfExtentsX - px) / vx;
                if (rayEntryDistance > 0) {
                    iy = py + rayEntryDistance * vy;
                    iz = pz + rayEntryDistance * vz;
                    if (iy > -halfExtentsY && iy < halfExtentsY && iz > -halfExtentsZ && iz < halfExtentsZ) {
                        if (targetNormal) {
                            targetNormal.x = -1;
                            targetNormal.y = 0;
                            targetNormal.z = 0;
                        }
                        intersects = true;
                    }
                }
            }
            if (!intersects && vy < 0) {
                rayEntryDistance = (halfExtentsY - py) / vy;
                if (rayEntryDistance > 0) {
                    ix = px + rayEntryDistance * vx;
                    iz = pz + rayEntryDistance * vz;
                    if (ix > -halfExtentsX && ix < halfExtentsX && iz > -halfExtentsZ && iz < halfExtentsZ) {
                        if (targetNormal) {
                            targetNormal.x = 0;
                            targetNormal.y = 1;
                            targetNormal.z = 0;
                        }
                        intersects = true;
                    }
                }
            }
            if (!intersects && vy > 0) {
                rayEntryDistance = (-halfExtentsY - py) / vy;
                if (rayEntryDistance > 0) {
                    ix = px + rayEntryDistance * vx;
                    iz = pz + rayEntryDistance * vz;
                    if (ix > -halfExtentsX && ix < halfExtentsX && iz > -halfExtentsZ && iz < halfExtentsZ) {
                        if (targetNormal) {
                            targetNormal.x = 0;
                            targetNormal.y = -1;
                            targetNormal.z = 0;
                        }
                        intersects = true;
                    }
                }
            }
            if (!intersects && vz < 0) {
                rayEntryDistance = (halfExtentsZ - pz) / vz;
                if (rayEntryDistance > 0) {
                    ix = px + rayEntryDistance * vx;
                    iy = py + rayEntryDistance * vy;
                    if (iy > -halfExtentsY && iy < halfExtentsY && ix > -halfExtentsX && ix < halfExtentsX) {
                        if (targetNormal) {
                            targetNormal.x = 0;
                            targetNormal.y = 0;
                            targetNormal.z = 1;
                        }
                        intersects = true;
                    }
                }
            }
            if (!intersects && vz > 0) {
                rayEntryDistance = (-halfExtentsZ - pz) / vz;
                if (rayEntryDistance > 0) {
                    ix = px + rayEntryDistance * vx;
                    iy = py + rayEntryDistance * vy;
                    if (iy > -halfExtentsY && iy < halfExtentsY && ix > -halfExtentsX && ix < halfExtentsX) {
                        if (targetNormal) {
                            targetNormal.x = 0;
                            targetNormal.y = 0;
                            targetNormal.z = -1;
                        }
                        intersects = true;
                    }
                }
            }
            return intersects ? rayEntryDistance : -1;
        };
        /**
         * Finds the closest point on the Box to another given point. This can be used for maximum error calculations for content within a given Box.
         *
         * @param point The point for which to find the closest point on the Box
         * @param target An optional Vector3D to store the result to prevent creating a new object.
         * @return
         */
        Box.prototype.closestPointToPoint = function (point, target) {
            if (target === void 0) { target = null; }
            var p;
            if (target == null)
                target = new Vector3D();
            p = point.x;
            if (p < this.x)
                p = this.x;
            if (p > this.x + this.width)
                p = this.x + this.width;
            target.x = p;
            p = point.y;
            if (p < this.y + this.height)
                p = this.y + this.height;
            if (p > this.y)
                p = this.y;
            target.y = p;
            p = point.z;
            if (p < this.z)
                p = this.z;
            if (p > this.z + this.depth)
                p = this.z + this.depth;
            target.z = p;
            return target;
        };
        /**
         * Adjusts the location of the Box object, as determined by its
         * top-left-front corner, by the specified amounts.
         *
         * @param dx Moves the <i>x</i> value of the Box object by this amount.
         * @param dy Moves the <i>y</i> value of the Box object by this amount.
         * @param dz Moves the <i>z</i> value of the Box object by this amount.
         */
        Box.prototype.offset = function (dx, dy, dz) {
            this.x += dx;
            this.y += dy;
            this.z += dz;
        };
        /**
         * Adjusts the location of the Box object using a Vector3D object as a
         * parameter. This method is similar to the <code>Box.offset()</code>
         * method, except that it takes a Vector3D object as a parameter.
         *
         * @param position A Vector3D object to use to offset this Box object.
         */
        Box.prototype.offsetPosition = function (position) {
            this.x += position.x;
            this.y += position.y;
            this.z += position.z;
        };
        /**
         * Sets all of the Box object's properties to 0. A Box object is empty if its
         * width, height or depth is less than or equal to 0.
         *
         * <p> This method sets the values of the <code>x</code>, <code>y</code>,
         * <code>z</code>, <code>width</code>, <code>height</code>, and
         * <code>depth</code> properties to 0.</p>
         *
         */
        Box.prototype.identity = function () {
            this.x = 0;
            this.y = 0;
            this.z = 0;
            this.width = 0;
            this.height = 0;
            this.depth = 0;
        };
        /**
         * Sets the members of Box to the specified values
         *
         * @param xa      The <i>x</i> coordinate of the top-left-front corner of the
         *                box.
         * @param ya      The <i>y</i> coordinate of the top-left-front corner of the
         *                box.
         * @param yz      The <i>z</i> coordinate of the top-left-front corner of the
         *                box.
         * @param widtha  The width of the box, in pixels.
         * @param heighta The height of the box, in pixels.
         * @param deptha  The depth of the box, in pixels.
         */
        Box.prototype.setTo = function (xa, ya, za, widtha, heighta, deptha) {
            this.x = xa;
            this.y = ya;
            this.z = za;
            this.width = widtha;
            this.height = heighta;
            this.depth = deptha;
        };
        /**
         * Builds and returns a string that lists the horizontal, vertical and
         * longitudinal positions and the width, height and depth of the Box object.
         *
         * @return A string listing the value of each of the following properties of
         *         the Box object: <code>x</code>, <code>y</code>, <code>z</code>,
         *         <code>width</code>, <code>height</code>, and <code>depth</code>.
         */
        Box.prototype.toString = function () {
            return "[Box] (x=" + this.x + ", y=" + this.y + ", z=" + this.z + ", width=" + this.width + ", height=" + this.height + ", depth=" + this.depth + ")";
        };
        /**
         * Adds two boxes together to create a new Box object, by filling
         * in the horizontal, vertical and longitudinal space between the two boxes.
         *
         * @param toUnion A Box object to add to this Box object.
         * @return A new Box object that is the union of the two boxes.
         */
        Box.prototype.union = function (toUnion, target) {
            if (target === void 0) { target = null; }
            var width;
            var height;
            var depth;
            if (target == null)
                target = new Box();
            if (toUnion == null) {
                target.copyFrom(this);
                return target;
            }
            if (this.x < toUnion.x) {
                width = toUnion.x - this.x + toUnion.width;
                target.x = this.x;
                target.width = (width < this.width) ? this.width : width;
            }
            else {
                width = this.x - toUnion.x + this.width;
                target.x = toUnion.x;
                target.width = (width < toUnion.width) ? toUnion.width : width;
            }
            if (this.y < toUnion.y) {
                height = toUnion.y - this.y + toUnion.height;
                target.y = this.y;
                target.height = (height < this.height) ? this.height : height;
            }
            else {
                height = this.y - toUnion.y + this.height;
                target.y = toUnion.y;
                target.height = (height < toUnion.height) ? toUnion.height : height;
            }
            if (this.z < toUnion.z) {
                depth = toUnion.z - this.z + toUnion.depth;
                target.z = this.z;
                target.depth = (depth < this.depth) ? this.depth : depth;
            }
            else {
                depth = this.z - toUnion.z + this.depth;
                target.z = toUnion.z;
                target.depth = (depth < toUnion.depth) ? toUnion.depth : depth;
            }
            return target;
        };
        return Box;
    }());

    /**
    * MathConsts provides some commonly used mathematical constants
    */
    var MathConsts = /** @class */ (function () {
        function MathConsts() {
        }
        /**
         * The amount to multiply with when converting radians to degrees.
         */
        MathConsts.RADIANS_TO_DEGREES = 180 / Math.PI;
        /**
         * The amount to multiply with when converting degrees to radians.
         */
        MathConsts.DEGREES_TO_RADIANS = Math.PI / 180;
        return MathConsts;
    }());

    /**
     * A Quaternion object which can be used to represent rotations.
     */
    var Orientation3D = /** @class */ (function () {
        function Orientation3D() {
        }
        /**
         * The axis angle orientation uses a combination of an axis and an angle to determine the orientation.
         * @type {string}
         */
        Orientation3D.AXIS_ANGLE = "axisAngle";
        /**
         * The default orientation for decompose() and recompose() methods, defines the orientation with three separate angles of rotation for each axis.
         * @type {string}
         */
        Orientation3D.EULER_ANGLES = "eulerAngles";
        /**
         * The quaternion orientation uses complex numbers.
         * @type {string}
         */
        Orientation3D.QUATERNION = "quaternion";
        return Orientation3D;
    }());

    var Sphere = /** @class */ (function () {
        /**
         * Create a Sphere with ABCD coefficients
         */
        function Sphere(x, y, z, radius) {
            if (x === void 0) { x = 0; }
            if (y === void 0) { y = 0; }
            if (z === void 0) { z = 0; }
            if (radius === void 0) { radius = 0; }
            this.x = x;
            this.y = y;
            this.z = z;
            this.radius = radius;
        }
        Sphere.prototype.rayIntersection = function (position, direction, targetNormal) {
            if (this.containsPoint(position))
                return 0;
            var px = position.x - this.x, py = position.y - this.y, pz = position.z - this.z;
            var vx = direction.x, vy = direction.y, vz = direction.z;
            var rayEntryDistance;
            var a = vx * vx + vy * vy + vz * vz;
            var b = 2 * (px * vx + py * vy + pz * vz);
            var c = px * px + py * py + pz * pz - this.radius * this.radius;
            var det = b * b - 4 * a * c;
            if (det >= 0) { // ray goes through sphere
                var sqrtDet = Math.sqrt(det);
                rayEntryDistance = (-b - sqrtDet) / (2 * a);
                if (rayEntryDistance >= 0) {
                    targetNormal.x = px + rayEntryDistance * vx;
                    targetNormal.y = py + rayEntryDistance * vy;
                    targetNormal.z = pz + rayEntryDistance * vz;
                    targetNormal.normalize();
                    return rayEntryDistance;
                }
            }
            // ray misses sphere
            return -1;
        };
        Sphere.prototype.containsPoint = function (position) {
            var px = position.x - this.x;
            var py = position.y - this.y;
            var pz = position.z - this.z;
            var distance = Math.sqrt(px * px + py * py + pz * pz);
            return distance <= this.radius;
        };
        /**
         * Copies all of sphere data from the source Sphere object into the calling
         * Sphere object.
         *
         * @param sourceSphere The Sphere object from which to copy the data.
         */
        Sphere.prototype.copyFrom = function (sourceSphere) {
            this.x = sourceSphere.x;
            this.y = sourceSphere.y;
            this.z = sourceSphere.z;
            this.radius = sourceSphere.radius;
        };
        /**
     * Adds two spheres together to create a new Sphere object, by filling
     * in the horizontal, vertical and longitudinal space between the two spheres.
     *
     * <p><b>Note:</b> The <code>union()</code> method ignores spheres with
     * <code>0</code> as the height, width or depth value, such as: <code>var
     * box2:Sphere = new Sphere(300,300,300,50,50,0);</code></p>
     *
     * @param toUnion A Sphere object to add to this Sphere object.
     * @return A new Sphere object that is the union of the two spheres.
     */
        Sphere.prototype.union = function (toUnion, target) {
            if (target === void 0) { target = null; }
            if (target == null)
                target = new Sphere();
            if (toUnion == null) {
                target.copyFrom(this);
                return target;
            }
            var xDiff = toUnion.x - this.x;
            var yDiff = toUnion.y - this.y;
            var zDiff = toUnion.z - this.z;
            target.radius = (Math.sqrt(xDiff * xDiff + yDiff * yDiff + zDiff * zDiff) + toUnion.radius + this.radius) / 2;
            target.x = this.x + xDiff / 2;
            target.y = this.y + yDiff / 2;
            target.z = this.z + zDiff / 2;
            return target;
        };
        Sphere.prototype.toString = function () {
            return "Sphere [x:" + this.x + ", y:" + this.y + ", z:" + this.z + ", radius:" + this.radius + "]";
        };
        return Sphere;
    }());

    var Matrix3D = /** @class */ (function () {
        /**
         * Creates a Matrix3D object.
         */
        function Matrix3D(rawData) {
            if (rawData === void 0) { rawData = null; }
            this._position = new Vector3D();
            this._positionDirty = true;
            if (rawData != null) {
                this._rawData = rawData;
            }
            else {
                this._rawData = new Float32Array(16);
                this.identity();
            }
        }
        Matrix3D.getAxisRotationMatrix = function (x, y, z, degrees, target) {
            if (target === void 0) { target = null; }
            if (target == null)
                target = new Matrix3D();
            var targetData = target._rawData;
            var rad = degrees * MathConsts.DEGREES_TO_RADIANS;
            var c = Math.cos(rad);
            var s = Math.sin(rad);
            var t = 1 - c;
            var tmp1, tmp2;
            targetData[0] = c + x * x * t;
            targetData[5] = c + y * y * t;
            targetData[10] = c + z * z * t;
            tmp1 = x * y * t;
            tmp2 = z * s;
            targetData[1] = tmp1 + tmp2;
            targetData[4] = tmp1 - tmp2;
            tmp1 = x * z * t;
            tmp2 = y * s;
            targetData[8] = tmp1 + tmp2;
            targetData[2] = tmp1 - tmp2;
            tmp1 = y * z * t;
            tmp2 = x * s;
            targetData[9] = tmp1 - tmp2;
            targetData[6] = tmp1 + tmp2;
            targetData[3] = 0;
            targetData[7] = 0;
            targetData[11] = 0;
            targetData[12] = 0;
            targetData[13] = 0;
            targetData[14] = 0;
            targetData[15] = 1;
            target.invalidatePosition();
            return target;
        };
        Matrix3D.getPointAtMatrix = function (pos, dir, up, target) {
            if (target === void 0) { target = null; }
            var dirN;
            var upN;
            var lftN;
            if (target == null)
                target = new Matrix3D();
            var targetData = target._rawData;
            dirN = dir.clone();
            dirN.normalize();
            upN = up.clone();
            upN.normalize();
            lftN = upN.crossProduct(dirN);
            lftN.normalize();
            if (lftN.length < 0.05) {
                lftN.x = upN.y;
                lftN.y = upN.x;
                lftN.z = 0;
                lftN.normalize();
            }
            upN = dirN.crossProduct(lftN);
            targetData[0] = lftN.x;
            targetData[1] = lftN.y;
            targetData[2] = lftN.z;
            targetData[3] = 0;
            targetData[4] = upN.x;
            targetData[5] = upN.y;
            targetData[6] = upN.z;
            targetData[7] = 0;
            targetData[8] = dirN.x;
            targetData[9] = dirN.y;
            targetData[10] = dirN.z;
            targetData[11] = 0;
            targetData[12] = lftN.dotProduct(pos);
            targetData[13] = upN.dotProduct(pos);
            targetData[14] = dirN.dotProduct(pos);
            targetData[15] = 1;
            target.invalidatePosition();
            return target;
        };
        /**
         * Fills the 3d matrix with values representing the transformation made by the given quaternion.
         *
         * @param    quarternion    The quarterion object to convert.
         */
        Matrix3D.getQuaternionMatrix = function (quarternion, target) {
            if (target === void 0) { target = null; }
            if (target == null)
                target = new Matrix3D();
            var targetData = target._rawData;
            var x = quarternion.x;
            var y = quarternion.y;
            var z = quarternion.z;
            var w = quarternion.w;
            var xx = x * x;
            var xy = x * y;
            var xz = x * z;
            var xw = x * w;
            var yy = y * y;
            var yz = y * z;
            var yw = y * w;
            var zz = z * z;
            var zw = z * w;
            targetData[0] = 1 - 2 * (yy + zz);
            targetData[1] = 2 * (xy + zw);
            targetData[2] = 2 * (xz - yw);
            targetData[4] = 2 * (xy - zw);
            targetData[5] = 1 - 2 * (xx + zz);
            targetData[6] = 2 * (yz + xw);
            targetData[8] = 2 * (xz + yw);
            targetData[9] = 2 * (yz - xw);
            targetData[10] = 1 - 2 * (xx + yy);
            targetData[3] = 0;
            targetData[7] = 0;
            targetData[11] = 0;
            targetData[12] = 0;
            targetData[13] = 0;
            targetData[14] = 0;
            targetData[15] = 1;
            target.invalidatePosition();
            return target;
        };
        /**
         * Returns a boolean value representing whether there is any difference between the two given 3d matrices.
         */
        Matrix3D.compare = function (m1, m2) {
            var r1 = m1._rawData;
            var r2 = m2._rawData;
            for (var i = 0; i < 16; ++i)
                if (r1[i] != r2[i])
                    return false;
            return true;
        };
        Object.defineProperty(Matrix3D.prototype, "determinant", {
            /**
             * [read-only] A number that determines whether a matrix is invertible.
             */
            get: function () {
                var raw = this._rawData;
                return ((raw[0] * raw[5] - raw[4] * raw[1]) * (raw[10] * raw[15] - raw[14] * raw[11])
                    - (raw[0] * raw[9] - raw[8] * raw[1]) * (raw[6] * raw[15] - raw[14] * raw[7])
                    + (raw[0] * raw[13] - raw[12] * raw[1]) * (raw[6] * raw[11] - raw[10] * raw[7])
                    + (raw[4] * raw[9] - raw[8] * raw[5]) * (raw[2] * raw[15] - raw[14] * raw[3])
                    - (raw[4] * raw[13] - raw[12] * raw[5]) * (raw[2] * raw[11] - raw[10] * raw[3])
                    + (raw[8] * raw[13] - raw[12] * raw[9]) * (raw[2] * raw[7] - raw[6] * raw[3]));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix3D.prototype, "position", {
            /**
             * A Vector3D object that holds the position, the 3D coordinate (x,y,z) of a display object within the
             * transformation's frame of reference.
             */
            get: function () {
                if (this._positionDirty) {
                    this._positionDirty = false;
                    this._position.x = this._rawData[12];
                    this._position.y = this._rawData[13];
                    this._position.z = this._rawData[14];
                }
                return this._position;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Appends the matrix by multiplying another Matrix3D object by the current Matrix3D object.
         */
        Matrix3D.prototype.append = function (lhs) {
            var raw = this._rawData;
            var rawLhs = lhs._rawData;
            var m111 = raw[0];
            var m112 = raw[1];
            var m113 = raw[2];
            var m114 = raw[3];
            var m121 = raw[4];
            var m122 = raw[5];
            var m123 = raw[6];
            var m124 = raw[7];
            var m131 = raw[8];
            var m132 = raw[9];
            var m133 = raw[10];
            var m134 = raw[11];
            var m141 = raw[12];
            var m142 = raw[13];
            var m143 = raw[14];
            var m144 = raw[15];
            var m211 = rawLhs[0];
            var m212 = rawLhs[1];
            var m213 = rawLhs[2];
            var m214 = rawLhs[3];
            var m221 = rawLhs[4];
            var m222 = rawLhs[5];
            var m223 = rawLhs[6];
            var m224 = rawLhs[7];
            var m231 = rawLhs[8];
            var m232 = rawLhs[9];
            var m233 = rawLhs[10];
            var m234 = rawLhs[11];
            var m241 = rawLhs[12];
            var m242 = rawLhs[13];
            var m243 = rawLhs[14];
            var m244 = rawLhs[15];
            raw[0] = m111 * m211 + m112 * m221 + m113 * m231 + m114 * m241;
            raw[1] = m111 * m212 + m112 * m222 + m113 * m232 + m114 * m242;
            raw[2] = m111 * m213 + m112 * m223 + m113 * m233 + m114 * m243;
            raw[3] = m111 * m214 + m112 * m224 + m113 * m234 + m114 * m244;
            raw[4] = m121 * m211 + m122 * m221 + m123 * m231 + m124 * m241;
            raw[5] = m121 * m212 + m122 * m222 + m123 * m232 + m124 * m242;
            raw[6] = m121 * m213 + m122 * m223 + m123 * m233 + m124 * m243;
            raw[7] = m121 * m214 + m122 * m224 + m123 * m234 + m124 * m244;
            raw[8] = m131 * m211 + m132 * m221 + m133 * m231 + m134 * m241;
            raw[9] = m131 * m212 + m132 * m222 + m133 * m232 + m134 * m242;
            raw[10] = m131 * m213 + m132 * m223 + m133 * m233 + m134 * m243;
            raw[11] = m131 * m214 + m132 * m224 + m133 * m234 + m134 * m244;
            raw[12] = m141 * m211 + m142 * m221 + m143 * m231 + m144 * m241;
            raw[13] = m141 * m212 + m142 * m222 + m143 * m232 + m144 * m242;
            raw[14] = m141 * m213 + m142 * m223 + m143 * m233 + m144 * m243;
            raw[15] = m141 * m214 + m142 * m224 + m143 * m234 + m144 * m244;
            this._positionDirty = true;
        };
        /**
         * Appends an incremental rotation to a Matrix3D object.
         */
        Matrix3D.prototype.appendRotation = function (degrees, axis) {
            this.append(Matrix3D.getAxisRotationMatrix(axis.x, axis.y, axis.z, degrees, Matrix3D._tempMatrix));
        };
        /**
         * Appends an incremental skew change along the x, y, and z axes to a Matrix3D object.
         */
        Matrix3D.prototype.appendSkew = function (xSkew, ySkew, zSkew) {
            if (xSkew == 0 && ySkew == 0 && zSkew == 0)
                return;
            var rawData = Matrix3D._tempMatrix._rawData;
            rawData[0] = 1;
            rawData[1] = 0;
            rawData[2] = 0;
            rawData[3] = 0;
            rawData[4] = xSkew;
            rawData[5] = 1;
            rawData[6] = 0;
            rawData[7] = 0;
            rawData[8] = ySkew;
            rawData[9] = zSkew;
            rawData[10] = 1;
            rawData[11] = 0;
            rawData[12] = 0;
            rawData[13] = 0;
            rawData[14] = 0;
            rawData[15] = 1;
            this.append(Matrix3D._tempMatrix);
        };
        /**
         * Appends an incremental scale change along the x, y, and z axes to a Matrix3D object.
         */
        Matrix3D.prototype.appendScale = function (xScale, yScale, zScale) {
            if (xScale == 1 && yScale == 1 && zScale == 1)
                return;
            var rawData = Matrix3D._tempMatrix._rawData;
            rawData[0] = xScale;
            rawData[1] = 0;
            rawData[2] = 0;
            rawData[3] = 0;
            rawData[4] = 0;
            rawData[5] = yScale;
            rawData[6] = 0;
            rawData[7] = 0;
            rawData[8] = 0;
            rawData[9] = 0;
            rawData[10] = zScale;
            rawData[11] = 0;
            rawData[12] = 0;
            rawData[13] = 0;
            rawData[14] = 0;
            rawData[15] = 1;
            this.append(Matrix3D._tempMatrix);
        };
        /**
        *Appends an incremental translation, a repositioning along the x, y, and z axes, to a Matrix3D object.
         */
        Matrix3D.prototype.appendTranslation = function (x, y, z) {
            var raw = this._rawData;
            var m41 = raw[3], m42 = raw[7], m43 = raw[11], m44 = raw[15];
            raw[0] += x * m41;
            raw[1] += y * m41;
            raw[2] += z * m41;
            raw[4] += x * m42;
            raw[5] += y * m42;
            raw[6] += z * m42;
            raw[8] += x * m43;
            raw[9] += y * m43;
            raw[10] += z * m43;
            raw[12] += x * m44;
            raw[13] += y * m44;
            raw[14] += z * m44;
            this._positionDirty = true;
        };
        /**
         * Returns a new Matrix3D object that is an exact copy of the current Matrix3D object.
         */
        Matrix3D.prototype.clone = function () {
            var matrix3D = new Matrix3D();
            matrix3D.copyFrom(this);
            return matrix3D;
        };
        /**
         * Copies a Vector3D object into specific column of the calling Matrix3D object.
         */
        Matrix3D.prototype.copyColumnFrom = function (column, vector3D) {
            if (column < 0 || column > 3)
                throw new ArgumentError("ArgumentError, Column " + column + " out of bounds [0, ..., 3]");
            var targetData = this._rawData;
            var vectorData = vector3D._rawData;
            column *= 4;
            targetData[column] = vectorData[0];
            targetData[column + 1] = vectorData[1];
            targetData[column + 2] = vectorData[2];
            targetData[column + 3] = vectorData[3];
            this._positionDirty = true;
        };
        /**
         * Copies specific column of the calling Matrix3D object into the Vector3D object.
         */
        Matrix3D.prototype.copyColumnTo = function (column, vector3D, negate) {
            if (negate === void 0) { negate = false; }
            if (column < 0 || column > 3)
                throw new ArgumentError("ArgumentError, Column " + column + " out of bounds [0, ..., 3]");
            column *= 4;
            var sourceData = this._rawData;
            var vectorData = vector3D._rawData;
            if (negate) {
                vectorData[0] = -sourceData[column];
                vectorData[1] = -sourceData[column + 1];
                vectorData[2] = -sourceData[column + 2];
                vectorData[3] = -sourceData[column + 3];
            }
            else {
                vectorData[0] = sourceData[column];
                vectorData[1] = sourceData[column + 1];
                vectorData[2] = sourceData[column + 2];
                vectorData[3] = sourceData[column + 3];
            }
        };
        /**
         * Copies all of the matrix data from the source Matrix3D object into the calling Matrix3D object.
         */
        Matrix3D.prototype.copyFrom = function (source, transpose) {
            if (transpose === void 0) { transpose = false; }
            var sourceData = source._rawData, targetData = this._rawData;
            targetData[0] = sourceData[0];
            targetData[5] = sourceData[5];
            targetData[10] = sourceData[10];
            targetData[15] = sourceData[15];
            if (transpose) {
                targetData[1] = sourceData[4];
                targetData[2] = sourceData[8];
                targetData[3] = sourceData[12];
                targetData[4] = sourceData[1];
                targetData[6] = sourceData[9];
                targetData[7] = sourceData[13];
                targetData[8] = sourceData[2];
                targetData[9] = sourceData[6];
                targetData[11] = sourceData[14];
                targetData[12] = sourceData[3];
                targetData[13] = sourceData[7];
                targetData[14] = sourceData[11];
            }
            else {
                targetData[1] = sourceData[1];
                targetData[2] = sourceData[2];
                targetData[3] = sourceData[3];
                targetData[4] = sourceData[4];
                targetData[6] = sourceData[6];
                targetData[7] = sourceData[7];
                targetData[8] = sourceData[8];
                targetData[9] = sourceData[9];
                targetData[11] = sourceData[11];
                targetData[12] = sourceData[12];
                targetData[13] = sourceData[13];
                targetData[14] = sourceData[14];
            }
            this._positionDirty = true;
        };
        /**
         * Copies this Matrix3D object into a destination Matrix3D object.
         */
        Matrix3D.prototype.copyTo = function (target, transpose) {
            if (transpose === void 0) { transpose = false; }
            target.copyFrom(this, transpose);
        };
        Matrix3D.prototype.copyRawDataFrom = function (sourceData, offset, transpose) {
            if (offset === void 0) { offset = 0; }
            if (transpose === void 0) { transpose = false; }
            var targetData = this._rawData;
            targetData[0] = sourceData[offset + 0];
            targetData[5] = sourceData[offset + 5];
            targetData[10] = sourceData[offset + 10];
            targetData[15] = sourceData[offset + 15];
            if (transpose) {
                targetData[offset + 1] = sourceData[4];
                targetData[offset + 2] = sourceData[8];
                targetData[offset + 3] = sourceData[12];
                targetData[offset + 4] = sourceData[1];
                targetData[offset + 6] = sourceData[9];
                targetData[offset + 7] = sourceData[13];
                targetData[offset + 8] = sourceData[2];
                targetData[offset + 9] = sourceData[6];
                targetData[offset + 11] = sourceData[14];
                targetData[offset + 12] = sourceData[3];
                targetData[offset + 13] = sourceData[7];
                targetData[offset + 14] = sourceData[11];
            }
            else {
                targetData[1] = sourceData[offset + 1];
                targetData[2] = sourceData[offset + 2];
                targetData[3] = sourceData[offset + 3];
                targetData[4] = sourceData[offset + 4];
                targetData[6] = sourceData[offset + 6];
                targetData[7] = sourceData[offset + 7];
                targetData[8] = sourceData[offset + 8];
                targetData[9] = sourceData[offset + 9];
                targetData[11] = sourceData[offset + 11];
                targetData[12] = sourceData[offset + 12];
                targetData[13] = sourceData[offset + 13];
                targetData[14] = sourceData[offset + 14];
            }
            this._positionDirty = true;
        };
        Matrix3D.prototype.copyRawDataTo = function (targetData, offset, transpose) {
            if (offset === void 0) { offset = 0; }
            if (transpose === void 0) { transpose = false; }
            var sourceData = this._rawData;
            targetData[offset] = sourceData[0];
            targetData[offset + 5] = sourceData[5];
            targetData[offset + 10] = sourceData[10];
            targetData[offset + 15] = sourceData[15];
            if (transpose) {
                targetData[offset + 1] = sourceData[4];
                targetData[offset + 2] = sourceData[8];
                targetData[offset + 3] = sourceData[12];
                targetData[offset + 4] = sourceData[1];
                targetData[offset + 6] = sourceData[9];
                targetData[offset + 7] = sourceData[13];
                targetData[offset + 8] = sourceData[2];
                targetData[offset + 9] = sourceData[6];
                targetData[offset + 11] = sourceData[14];
                targetData[offset + 12] = sourceData[3];
                targetData[offset + 13] = sourceData[7];
                targetData[offset + 14] = sourceData[11];
            }
            else {
                targetData[offset + 1] = sourceData[1];
                targetData[offset + 2] = sourceData[2];
                targetData[offset + 3] = sourceData[3];
                targetData[offset + 4] = sourceData[4];
                targetData[offset + 6] = sourceData[6];
                targetData[offset + 7] = sourceData[7];
                targetData[offset + 8] = sourceData[8];
                targetData[offset + 9] = sourceData[9];
                targetData[offset + 11] = sourceData[11];
                targetData[offset + 12] = sourceData[12];
                targetData[offset + 13] = sourceData[13];
                targetData[offset + 14] = sourceData[14];
            }
        };
        /**
         * Copies a Vector3D object into specific row of the calling Matrix3D object.
         */
        Matrix3D.prototype.copyRowFrom = function (row, vector3D) {
            if (row < 0 || row > 3)
                throw new ArgumentError("ArgumentError, Row " + row + " out of bounds [0, ..., 3]");
            var targetData = this._rawData;
            var vectorData = vector3D._rawData;
            targetData[row] = vectorData[0];
            targetData[row + 4] = vectorData[1];
            targetData[row + 8] = vectorData[2];
            targetData[row + 12] = vectorData[3];
            this._positionDirty = true;
        };
        /**
         * Copies specific row of the calling Matrix3D object into the Vector3D object.
         */
        Matrix3D.prototype.copyRowTo = function (row, vector3D, negate) {
            if (negate === void 0) { negate = false; }
            if (row < 0 || row > 3)
                throw new ArgumentError("ArgumentError, Row " + row + " out of bounds [0, ..., 3]");
            var sourceData = this._rawData;
            var vectorData = vector3D._rawData;
            if (negate) {
                vectorData[0] = -sourceData[row];
                vectorData[1] = -sourceData[row + 4];
                vectorData[2] = -sourceData[row + 8];
                vectorData[3] = -sourceData[row + 12];
            }
            else {
                vectorData[0] = sourceData[row];
                vectorData[1] = sourceData[row + 4];
                vectorData[2] = sourceData[row + 8];
                vectorData[3] = sourceData[row + 12];
            }
        };
        /**
         * Returns the transformation matrix's translation, rotation, and scale settings as a Vector of three Vector3D objects.
         */
        Matrix3D.prototype.decompose = function (orientationStyle) {
            if (orientationStyle === void 0) { orientationStyle = "eulerAngles"; }
            if (this._components == null)
                this._components = [new Vector3D(), new Vector3D(), new Vector3D(), new Vector3D()];
            var colX = new Vector3D(this._rawData[0], this._rawData[1], this._rawData[2]);
            var colY = new Vector3D(this._rawData[4], this._rawData[5], this._rawData[6]);
            var colZ = new Vector3D(this._rawData[8], this._rawData[9], this._rawData[10]);
            var scale = this._components[3];
            var skew = this._components[2];
            //compute X scale factor and normalise colX
            scale.x = colX.length;
            colX.scaleBy(1 / scale.x);
            //compute XY shear factor and make colY orthogonal to colX
            skew.x = colX.dotProduct(colY);
            colY = Vector3D.combine(colY, colX, 1, -skew.x);
            //compute Y scale factor and normalise colY
            scale.y = colY.length;
            colY.scaleBy(1 / scale.y);
            skew.x /= scale.y;
            //compute XZ and YZ shears and make colZ orthogonal to colX and colY
            skew.y = colX.dotProduct(colZ);
            colZ = Vector3D.combine(colZ, colX, 1, -skew.y);
            skew.z = colY.dotProduct(colZ);
            colZ = Vector3D.combine(colZ, colY, 1, -skew.z);
            //compute Z scale and normalise colZ
            scale.z = colZ.length;
            colZ.scaleBy(1 / scale.z);
            skew.y /= scale.z;
            skew.z /= scale.z;
            //at this point, the matrix (in cols) is orthonormal
            //check for a coordinate system flip. If the determinant is -1, negate the z scaling factor
            if (colX.dotProduct(colY.crossProduct(colZ)) < 0) {
                scale.z = -scale.z;
                colZ.x = -colZ.x;
                colZ.y = -colZ.y;
                colZ.z = -colZ.z;
            }
            var rot = this._components[1];
            switch (orientationStyle) {
                case Orientation3D.AXIS_ANGLE:
                    rot.w = Math.acos((colX.x + colY.y + colZ.z - 1) / 2);
                    var len = Math.sqrt((colY.z - colZ.y) * (colY.z - colZ.y) + (colZ.x - colX.z) * (colZ.x - colX.z) + (colX.y - colY.x) * (colX.y - colY.x));
                    rot.x = (colY.z - colZ.y) / len;
                    rot.y = (colZ.x - colX.z) / len;
                    rot.z = (colX.y - colY.x) / len;
                    break;
                case Orientation3D.QUATERNION:
                    var tr = colX.x + colY.y + colZ.z;
                    if (tr > 0) {
                        rot.w = Math.sqrt(1 + tr) / 2;
                        rot.x = (colY.z - colZ.y) / (4 * rot.w);
                        rot.y = (colZ.x - colX.z) / (4 * rot.w);
                        rot.z = (colX.y - colY.x) / (4 * rot.w);
                    }
                    else if ((colX.x > colY.y) && (colX.x > colZ.z)) {
                        rot.x = Math.sqrt(1 + colX.x - colY.y - colZ.z) / 2;
                        rot.w = (colY.z - colZ.y) / (4 * rot.x);
                        rot.y = (colX.y + colY.x) / (4 * rot.x);
                        rot.z = (colZ.x + colX.z) / (4 * rot.x);
                    }
                    else if (colY.y > colZ.z) {
                        rot.y = Math.sqrt(1 + colY.y - colX.x - colZ.z) / 2;
                        rot.x = (colX.y + colY.x) / (4 * rot.y);
                        rot.w = (colZ.x - colX.z) / (4 * rot.y);
                        rot.z = (colY.z + colZ.y) / (4 * rot.y);
                    }
                    else {
                        rot.z = Math.sqrt(1 + colZ.z - colX.x - colY.y) / 2;
                        rot.x = (colZ.x + colX.z) / (4 * rot.z);
                        rot.y = (colY.z + colZ.y) / (4 * rot.z);
                        rot.w = (colX.y - colY.x) / (4 * rot.z);
                    }
                    break;
                case Orientation3D.EULER_ANGLES:
                    rot.y = Math.asin(-colX.z);
                    //var cos:number = Math.cos(rot.y);
                    if (colX.z != 1 && colX.z != -1) {
                        rot.x = Math.atan2(colY.z, colZ.z);
                        rot.z = Math.atan2(colX.y, colX.x);
                    }
                    else {
                        rot.z = 0;
                        rot.x = Math.atan2(colY.x, colY.y);
                    }
                    break;
            }
            this._components[0].copyFrom(this.position);
            return this._components;
        };
        /**
         * Uses the transformation matrix without its translation elements to transform a Vector3D object from one space
         * coordinate to another.
         */
        Matrix3D.prototype.deltaTransformVector = function (v, t) {
            if (t === void 0) { t = null; }
            var x = v.x;
            var y = v.y;
            var z = v.z;
            if (!t)
                t = new Vector3D();
            var raw = this._rawData;
            var rawT = t._rawData;
            rawT[0] = x * raw[0] + y * raw[4] + z * raw[8];
            rawT[1] = x * raw[1] + y * raw[5] + z * raw[9];
            rawT[2] = x * raw[2] + y * raw[6] + z * raw[10];
            rawT[3] = x * raw[3] + y * raw[7] + z * raw[11];
            return t;
        };
        Matrix3D.prototype.deltaTransformVectors = function (vin, vout) {
            var raw = this._rawData;
            var a = raw[0];
            var e = raw[1];
            var i = raw[2];
            var m = raw[3];
            var b = raw[4];
            var f = raw[5];
            var j = raw[6];
            var n = raw[7];
            var c = raw[8];
            var g = raw[9];
            var k = raw[10];
            var o = raw[11];
            var outIndex = 0;
            var length = vin.length;
            for (var index = 0; index < length; index += 3) {
                var x = vin[index];
                var y = vin[index + 1];
                var z = vin[index + 2];
                vout[outIndex++] = a * x + b * y + c * z;
                vout[outIndex++] = e * x + f * y + g * z;
                vout[outIndex++] = i * x + j * y + k * z;
            }
        };
        /**
         * Converts the current matrix to an identity or unit matrix.
         */
        Matrix3D.prototype.identity = function () {
            var raw = this._rawData;
            raw[0] = 1;
            raw[1] = 0;
            raw[2] = 0;
            raw[3] = 0;
            raw[4] = 0;
            raw[5] = 1;
            raw[6] = 0;
            raw[7] = 0;
            raw[8] = 0;
            raw[9] = 0;
            raw[10] = 1;
            raw[11] = 0;
            raw[12] = 0;
            raw[13] = 0;
            raw[14] = 0;
            raw[15] = 1;
            this._positionDirty = true;
        };
        /**
         * Inverts the current matrix.
         */
        Matrix3D.prototype.invert = function () {
            var d = this.determinant;
            var invertable = Math.abs(d) > 0.00000000001;
            var raw = this._rawData;
            if (invertable) {
                d = 1 / d;
                var m11 = raw[0];
                var m12 = raw[1];
                var m13 = raw[2];
                var m14 = raw[3];
                var m21 = raw[4];
                var m22 = raw[5];
                var m23 = raw[6];
                var m24 = raw[7];
                var m31 = raw[8];
                var m32 = raw[9];
                var m33 = raw[10];
                var m34 = raw[11];
                var m41 = raw[12];
                var m42 = raw[13];
                var m43 = raw[14];
                var m44 = raw[15];
                raw[0] = d * (m22 * (m33 * m44 - m43 * m34) - m32 * (m23 * m44 - m43 * m24) + m42 * (m23 * m34 - m33 * m24));
                raw[1] = -d * (m12 * (m33 * m44 - m43 * m34) - m32 * (m13 * m44 - m43 * m14) + m42 * (m13 * m34 - m33 * m14));
                raw[2] = d * (m12 * (m23 * m44 - m43 * m24) - m22 * (m13 * m44 - m43 * m14) + m42 * (m13 * m24 - m23 * m14));
                raw[3] = -d * (m12 * (m23 * m34 - m33 * m24) - m22 * (m13 * m34 - m33 * m14) + m32 * (m13 * m24 - m23 * m14));
                raw[4] = -d * (m21 * (m33 * m44 - m43 * m34) - m31 * (m23 * m44 - m43 * m24) + m41 * (m23 * m34 - m33 * m24));
                raw[5] = d * (m11 * (m33 * m44 - m43 * m34) - m31 * (m13 * m44 - m43 * m14) + m41 * (m13 * m34 - m33 * m14));
                raw[6] = -d * (m11 * (m23 * m44 - m43 * m24) - m21 * (m13 * m44 - m43 * m14) + m41 * (m13 * m24 - m23 * m14));
                raw[7] = d * (m11 * (m23 * m34 - m33 * m24) - m21 * (m13 * m34 - m33 * m14) + m31 * (m13 * m24 - m23 * m14));
                raw[8] = d * (m21 * (m32 * m44 - m42 * m34) - m31 * (m22 * m44 - m42 * m24) + m41 * (m22 * m34 - m32 * m24));
                raw[9] = -d * (m11 * (m32 * m44 - m42 * m34) - m31 * (m12 * m44 - m42 * m14) + m41 * (m12 * m34 - m32 * m14));
                raw[10] = d * (m11 * (m22 * m44 - m42 * m24) - m21 * (m12 * m44 - m42 * m14) + m41 * (m12 * m24 - m22 * m14));
                raw[11] = -d * (m11 * (m22 * m34 - m32 * m24) - m21 * (m12 * m34 - m32 * m14) + m31 * (m12 * m24 - m22 * m14));
                raw[12] = -d * (m21 * (m32 * m43 - m42 * m33) - m31 * (m22 * m43 - m42 * m23) + m41 * (m22 * m33 - m32 * m23));
                raw[13] = d * (m11 * (m32 * m43 - m42 * m33) - m31 * (m12 * m43 - m42 * m13) + m41 * (m12 * m33 - m32 * m13));
                raw[14] = -d * (m11 * (m22 * m43 - m42 * m23) - m21 * (m12 * m43 - m42 * m13) + m41 * (m12 * m23 - m22 * m13));
                raw[15] = d * (m11 * (m22 * m33 - m32 * m23) - m21 * (m12 * m33 - m32 * m13) + m31 * (m12 * m23 - m22 * m13));
            }
            this._positionDirty = true;
            return invertable;
        };
        Matrix3D.prototype.isIdentity = function () {
            var raw = this._rawData;
            if (raw[0] == 1 &&
                raw[1] == 0 &&
                raw[2] == 0 &&
                raw[3] == 0 &&
                raw[4] == 0 &&
                raw[5] == 1 &&
                raw[6] == 0 &&
                raw[7] == 0 &&
                raw[8] == 0 &&
                raw[9] == 0 &&
                raw[10] == 1 &&
                raw[11] == 0 &&
                raw[12] == 0 &&
                raw[13] == 0 &&
                raw[14] == 0 &&
                raw[15] == 1)
                return true;
            return false;
        };
        /**
         * Prepends a matrix by multiplying the current Matrix3D object by another Matrix3D object.
         */
        Matrix3D.prototype.prepend = function (rhs) {
            var raw = this._rawData;
            var rawRhs = rhs._rawData;
            var m111 = rawRhs[0];
            var m112 = rawRhs[1];
            var m113 = rawRhs[2];
            var m114 = rawRhs[3];
            var m121 = rawRhs[4];
            var m122 = rawRhs[5];
            var m123 = rawRhs[6];
            var m124 = rawRhs[7];
            var m131 = rawRhs[8];
            var m132 = rawRhs[9];
            var m133 = rawRhs[10];
            var m134 = rawRhs[11];
            var m141 = rawRhs[12];
            var m142 = rawRhs[13];
            var m143 = rawRhs[14];
            var m144 = rawRhs[15];
            var m211 = raw[0];
            var m212 = raw[1];
            var m213 = raw[2];
            var m214 = raw[3];
            var m221 = raw[4];
            var m222 = raw[5];
            var m223 = raw[6];
            var m224 = raw[7];
            var m231 = raw[8];
            var m232 = raw[9];
            var m233 = raw[10];
            var m234 = raw[11];
            var m241 = raw[12];
            var m242 = raw[13];
            var m243 = raw[14];
            var m244 = raw[15];
            raw[0] = m111 * m211 + m112 * m221 + m113 * m231 + m114 * m241;
            raw[1] = m111 * m212 + m112 * m222 + m113 * m232 + m114 * m242;
            raw[2] = m111 * m213 + m112 * m223 + m113 * m233 + m114 * m243;
            raw[3] = m111 * m214 + m112 * m224 + m113 * m234 + m114 * m244;
            raw[4] = m121 * m211 + m122 * m221 + m123 * m231 + m124 * m241;
            raw[5] = m121 * m212 + m122 * m222 + m123 * m232 + m124 * m242;
            raw[6] = m121 * m213 + m122 * m223 + m123 * m233 + m124 * m243;
            raw[7] = m121 * m214 + m122 * m224 + m123 * m234 + m124 * m244;
            raw[8] = m131 * m211 + m132 * m221 + m133 * m231 + m134 * m241;
            raw[9] = m131 * m212 + m132 * m222 + m133 * m232 + m134 * m242;
            raw[10] = m131 * m213 + m132 * m223 + m133 * m233 + m134 * m243;
            raw[11] = m131 * m214 + m132 * m224 + m133 * m234 + m134 * m244;
            raw[12] = m141 * m211 + m142 * m221 + m143 * m231 + m144 * m241;
            raw[13] = m141 * m212 + m142 * m222 + m143 * m232 + m144 * m242;
            raw[14] = m141 * m213 + m142 * m223 + m143 * m233 + m144 * m243;
            raw[15] = m141 * m214 + m142 * m224 + m143 * m234 + m144 * m244;
            this._positionDirty = true;
        };
        /**
         * Prepends an incremental rotation to a Matrix3D object.
         */
        Matrix3D.prototype.prependRotation = function (degrees, axis) {
            this.prepend(Matrix3D.getAxisRotationMatrix(axis.x, axis.y, axis.z, degrees, Matrix3D._tempMatrix));
        };
        /**
         * Prepends an incremental scale change along the x, y, and z axes to a Matrix3D object.
         */
        Matrix3D.prototype.prependScale = function (xScale, yScale, zScale) {
            if (xScale == 1 && yScale == 1 && zScale == 1)
                return;
            var rawData = Matrix3D._tempMatrix._rawData;
            rawData[0] = xScale;
            rawData[1] = 0;
            rawData[2] = 0;
            rawData[3] = 0;
            rawData[4] = 0;
            rawData[5] = yScale;
            rawData[6] = 0;
            rawData[7] = 0;
            rawData[8] = 0;
            rawData[9] = 0;
            rawData[10] = zScale;
            rawData[11] = 0;
            rawData[12] = 0;
            rawData[13] = 0;
            rawData[14] = 0;
            rawData[15] = 1;
            this.prepend(Matrix3D._tempMatrix);
        };
        /**
         * Prepends an incremental translation, a repositioning along the x, y, and z axes, to a Matrix3D object.
         */
        Matrix3D.prototype.prependTranslation = function (x, y, z) {
            var rawData = Matrix3D._tempMatrix._rawData;
            rawData[0] = 1;
            rawData[1] = 0;
            rawData[2] = 0;
            rawData[3] = 0;
            rawData[4] = 0;
            rawData[5] = 1;
            rawData[6] = 0;
            rawData[7] = 0;
            rawData[8] = 0;
            rawData[9] = 0;
            rawData[10] = 1;
            rawData[11] = 0;
            rawData[12] = x;
            rawData[13] = y;
            rawData[14] = z;
            rawData[15] = 1;
            this.prepend(Matrix3D._tempMatrix);
        };
        // TODO orientationStyle
        /**
         * Sets the transformation matrix's translation, rotation, and scale settings.
         */
        Matrix3D.prototype.recompose = function (components) {
            var pos = components[0] || this.position;
            this.identity();
            var scale = components[3];
            if (scale && (scale.x != 1 || scale.y != 1 || scale.z != 1))
                this.appendScale(scale.x, scale.y, scale.z);
            var skew = components[2];
            if (skew && (skew.x != 0 || skew.y != 0 || skew.z != 0))
                this.appendSkew(skew.x, skew.y, skew.z);
            var sin;
            var cos;
            var rawData = Matrix3D._tempMatrix._rawData;
            rawData[12] = 0;
            rawData[13] = 0;
            rawData[14] = 0;
            rawData[15] = 0;
            var rotation = components[1];
            if (rotation) {
                var angle = -rotation.x;
                if (angle != 0) {
                    sin = Math.sin(angle);
                    cos = Math.cos(angle);
                    rawData[0] = 1;
                    rawData[1] = 0;
                    rawData[2] = 0;
                    rawData[3] = 0;
                    rawData[4] = 0;
                    rawData[5] = cos;
                    rawData[6] = -sin;
                    rawData[7] = 0;
                    rawData[8] = 0;
                    rawData[9] = sin;
                    rawData[10] = cos;
                    rawData[11] = 0;
                    this.append(Matrix3D._tempMatrix);
                }
                angle = -rotation.y;
                if (angle != 0) {
                    sin = Math.sin(angle);
                    cos = Math.cos(angle);
                    rawData[0] = cos;
                    rawData[1] = 0;
                    rawData[2] = sin;
                    rawData[3] = 0;
                    rawData[4] = 0;
                    rawData[5] = 1;
                    rawData[6] = 0;
                    rawData[7] = 0;
                    rawData[8] = -sin;
                    rawData[9] = 0;
                    rawData[10] = cos;
                    rawData[11] = 0;
                    this.append(Matrix3D._tempMatrix);
                }
                angle = -rotation.z;
                if (angle != 0) {
                    sin = Math.sin(angle);
                    cos = Math.cos(angle);
                    rawData[0] = cos;
                    rawData[1] = -sin;
                    rawData[2] = 0;
                    rawData[3] = 0;
                    rawData[4] = sin;
                    rawData[5] = cos;
                    rawData[6] = 0;
                    rawData[7] = 0;
                    rawData[8] = 0;
                    rawData[9] = 0;
                    rawData[10] = 1;
                    rawData[11] = 0;
                    this.append(Matrix3D._tempMatrix);
                }
            }
            this._rawData[12] = pos.x;
            this._rawData[13] = pos.y;
            this._rawData[14] = pos.z;
            if (components[0])
                this._positionDirty = true;
            this._rawData[15] = 1;
            return true;
        };
        Matrix3D.prototype.reflect = function (plane) {
            var a = plane.a, b = plane.b, c = plane.c, d = plane.d;
            var ab2 = -2 * a * b;
            var ac2 = -2 * a * c;
            var bc2 = -2 * b * c;
            // reflection matrix
            var rawData = this._rawData;
            rawData[0] = 1 - 2 * a * a;
            rawData[4] = ab2;
            rawData[8] = ac2;
            rawData[12] = -2 * a * d;
            rawData[1] = ab2;
            rawData[5] = 1 - 2 * b * b;
            rawData[9] = bc2;
            rawData[13] = -2 * b * d;
            rawData[2] = ac2;
            rawData[6] = bc2;
            rawData[10] = 1 - 2 * c * c;
            rawData[14] = -2 * c * d;
            rawData[3] = 0;
            rawData[7] = 0;
            rawData[11] = 0;
            rawData[15] = 1;
            this._positionDirty = true;
        };
        Matrix3D.prototype.transformBox = function (box, target) {
            if (target === void 0) { target = null; }
            if (box == null)
                throw new ArgumentError("ArgumentError, box cannot be null");
            var minX, minY, minZ;
            var maxX, maxY, maxZ;
            maxX = box.width + (minX = box.x);
            maxY = box.height + (minY = box.y);
            maxZ = box.depth + (minZ = box.z);
            if (!target)
                target = new Box();
            var hx = box.width / 2;
            var hy = box.height / 2;
            var hz = box.depth / 2;
            var cx = box.x + hx;
            var cy = box.y + hy;
            var cz = box.z + hz;
            var m11 = this._rawData[0], m12 = this._rawData[4], m13 = this._rawData[8], m14 = this._rawData[12];
            var m21 = this._rawData[1], m22 = this._rawData[5], m23 = this._rawData[9], m24 = this._rawData[13];
            var m31 = this._rawData[2], m32 = this._rawData[6], m33 = this._rawData[10], m34 = this._rawData[14];
            var centerX = cx * m11 + cy * m12 + cz * m13 + m14;
            var centerY = cx * m21 + cy * m22 + cz * m23 + m24;
            var centerZ = cx * m31 + cy * m32 + cz * m33 + m34;
            var halfExtentsX = Math.max(Math.abs(hx * m11 + hy * m12 + hz * m13), Math.abs(-hx * m11 + hy * m12 + hz * m13), Math.abs(hx * m11 - hy * m12 + hz * m13), Math.abs(hx * m11 + hy * m12 - hz * m13));
            var halfExtentsY = Math.max(Math.abs(hx * m21 + hy * m22 + hz * m23), Math.abs(-hx * m21 + hy * m22 + hz * m23), Math.abs(hx * m21 - hy * m22 + hz * m23), Math.abs(hx * m21 + hy * m22 - hz * m23));
            var halfExtentsZ = Math.max(Math.abs(hx * m31 + hy * m32 + hz * m33), Math.abs(-hx * m31 + hy * m32 + hz * m33), Math.abs(hx * m31 - hy * m32 + hz * m33), Math.abs(hx * m31 + hy * m32 - hz * m33));
            target.width = halfExtentsX * 2;
            target.height = halfExtentsY * 2;
            target.depth = halfExtentsZ * 2;
            target.x = centerX - halfExtentsX;
            target.y = centerY - halfExtentsY;
            target.z = centerZ - halfExtentsZ;
            return target;
        };
        Matrix3D.prototype.transformSphere = function (sphere, target) {
            if (target === void 0) { target = null; }
            //TODO: use a better solution than this
            if (sphere == null)
                throw new ArgumentError("ArgumentError, sphere cannot be null");
            var box = new Box(sphere.x - sphere.radius, sphere.y - sphere.radius, sphere.z - sphere.radius, sphere.radius * 2, sphere.radius * 2, sphere.radius * 2);
            this.transformBox(box, box);
            if (!target)
                target = new Sphere();
            target.x = box.x + box.width / 2;
            target.y = box.y + box.height / 2;
            target.z = box.z + box.depth / 2;
            target.radius = Math.max(box.width, box.height, box.depth);
            return target;
        };
        Matrix3D.prototype.transformVector = function (vector, target) {
            if (target === void 0) { target = null; }
            if (vector == null)
                throw new ArgumentError("ArgumentError, vector cannot be null");
            var x = vector.x;
            var y = vector.y;
            var z = vector.z;
            var w = vector.w;
            if (!target)
                target = new Vector3D();
            var raw = this._rawData;
            var rawTarget = target._rawData;
            rawTarget[0] = x * raw[0] + y * raw[4] + z * raw[8] + w * raw[12];
            rawTarget[1] = x * raw[1] + y * raw[5] + z * raw[9] + w * raw[13];
            rawTarget[2] = x * raw[2] + y * raw[6] + z * raw[10] + w * raw[14];
            rawTarget[3] = x * raw[3] + y * raw[7] + z * raw[11] + w * raw[15];
            return target;
        };
        /**
         * Uses the transformation matrix to transform a Vector of Numbers from one coordinate space to another.
         */
        Matrix3D.prototype.transformVectors = function (vin, vout) {
            var i = 0;
            var x = 0, y = 0, z = 0;
            var raw = this._rawData;
            while (i + 3 <= vin.length) {
                x = vin[i];
                y = vin[i + 1];
                z = vin[i + 2];
                vout[i] = x * raw[0] + y * raw[4] + z * raw[8] + raw[12];
                vout[i + 1] = x * raw[1] + y * raw[5] + z * raw[9] + raw[13];
                vout[i + 2] = x * raw[2] + y * raw[6] + z * raw[10] + raw[14];
                i += 3;
            }
        };
        /**
         * Converts the current Matrix3D object to a matrix where the rows and columns are swapped.
         */
        Matrix3D.prototype.transpose = function () {
            var raw = this._rawData;
            var rawTemp = Matrix3D._tempMatrix._rawData;
            this.copyRawDataTo(rawTemp, 0, true);
            raw[1] = rawTemp[1];
            raw[2] = rawTemp[2];
            raw[3] = rawTemp[3];
            raw[4] = rawTemp[4];
            raw[6] = rawTemp[6];
            raw[7] = rawTemp[7];
            raw[8] = rawTemp[8];
            raw[9] = rawTemp[9];
            raw[11] = rawTemp[11];
            raw[12] = rawTemp[12];
            raw[13] = rawTemp[13];
            raw[14] = rawTemp[14];
            this._positionDirty = true;
        };
        Matrix3D.prototype.invalidatePosition = function () {
            this._positionDirty = true;
        };
        Matrix3D.prototype.toFixed = function (decimalPlace) {
            var magnitude = Math.pow(10, decimalPlace);
            return "matrix3d(" + Math.round(this._rawData[0] * magnitude) / magnitude + "," + Math.round(this._rawData[1] * magnitude) / magnitude + "," + Math.round(this._rawData[2] * magnitude) / magnitude + "," + Math.round(this._rawData[3] * magnitude) / magnitude + "," + Math.round(this._rawData[4] * magnitude) / magnitude + "," + Math.round(this._rawData[5] * magnitude) / magnitude + "," + Math.round(this._rawData[6] * magnitude) / magnitude + "," + Math.round(this._rawData[7] * magnitude) / magnitude + "," + Math.round(this._rawData[8] * magnitude) / magnitude + "," + Math.round(this._rawData[9] * magnitude) / magnitude + "," + Math.round(this._rawData[10] * magnitude) / magnitude + "," + Math.round(this._rawData[11] * magnitude) / magnitude + "," + Math.round(this._rawData[12] * magnitude) / magnitude + "," + Math.round(this._rawData[13] * magnitude) / magnitude + "," + Math.round(this._rawData[14] * magnitude) / magnitude + "," + Math.round(this._rawData[15] * magnitude) / magnitude + ")";
        };
        Matrix3D.prototype.toString = function () {
            return "matrix3d(" + Math.round(this._rawData[0] * 1000) / 1000 + "," + Math.round(this._rawData[1] * 1000) / 1000 + "," + Math.round(this._rawData[2] * 1000) / 1000 + "," + Math.round(this._rawData[3] * 1000) / 1000 + "," + Math.round(this._rawData[4] * 1000) / 1000 + "," + Math.round(this._rawData[5] * 1000) / 1000 + "," + Math.round(this._rawData[6] * 1000) / 1000 + "," + Math.round(this._rawData[7] * 1000) / 1000 + "," + Math.round(this._rawData[8] * 1000) / 1000 + "," + Math.round(this._rawData[9] * 1000) / 1000 + "," + Math.round(this._rawData[10] * 1000) / 1000 + "," + Math.round(this._rawData[11] * 1000) / 1000 + "," + Math.round(this._rawData[12] * 1000) / 1000 + "," + Math.round(this._rawData[13] * 1000) / 1000 + "," + Math.round(this._rawData[14] * 1000) / 1000 + "," + Math.round(this._rawData[15] * 1000) / 1000 + ")";
        };
        /**
         * A reference to a Matrix3D to be used as a temporary data container, preventing object creation.
         */
        Matrix3D.CALCULATION_MATRIX = new Matrix3D();
        Matrix3D._tempMatrix = new Matrix3D();
        return Matrix3D;
    }());

    var TransformEvent = /** @class */ (function (_super) {
        __extends$1(TransformEvent, _super);
        function TransformEvent(type, transform) {
            var _this = _super.call(this, type) || this;
            _this._transform = transform;
            return _this;
        }
        Object.defineProperty(TransformEvent.prototype, "transform", {
            /**
             *
             * @returns {Transform}
             */
            get: function () {
                return this._transform;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the event.
         * @return An exact duplicate of the current object.
         */
        TransformEvent.prototype.clone = function () {
            return new TransformEvent(this.type, this._transform);
        };
        /**
         *
         */
        TransformEvent.INVALIDATE_MATRIX3D = "invalidateMatrix3D";
        /**
         *
         */
        TransformEvent.INVALIDATE_CONCATENATED_MATRIX3D = "invalidateConcatenatedMatrix3D";
        /**
         *
         */
        TransformEvent.UPDATE_CONCATENATED_MATRIX3D = "updateConcatenatedMatrix3D";
        /**
         *
         */
        TransformEvent.INVALIDATE_COLOR_TRANSFORM = "invalidateColorTransform";
        return TransformEvent;
    }(EventBase));

    /**
     * The Transform class provides access to color adjustment properties and two-
     * or three-dimensional transformation objects that can be applied to a
     * display object. During the transformation, the color or the orientation and
     * position of a display object is adjusted(offset) from the current values
     * or coordinates to new values or coordinates. The Transform class also
     * collects data about color and two-dimensional matrix transformations that
     * are applied to a display object and all of its parent objects. You can
     * access these combined transformations through the
     * <code>concatenatedColorTransform</code> and <code>concatenatedMatrix</code>
     * properties.
     *
     * <p>To apply color transformations: create a ColorTransform object, set the
     * color adjustments using the object's methods and properties, and then
     * assign the <code>colorTransformation</code> property of the
     * <code>transform</code> property of the display object to the new
     * ColorTransformation object.</p>
     *
     * <p>To apply two-dimensional transformations: create a Matrix object, set
     * the matrix's two-dimensional transformation, and then assign the
     * <code>transform.matrix</code> property of the display object to the new
     * Matrix object.</p>
     *
     * <p>To apply three-dimensional transformations: start with a
     * three-dimensional display object. A three-dimensional display object has a
     * <code>z</code> property value other than zero. You do not need to create
     * the Matrix3D object. For all three-dimensional objects, a Matrix3D object
     * is created automatically when you assign a <code>z</code> value to a
     * display object. You can access the display object's Matrix3D object through
     * the display object's <code>transform</code> property. Using the methods of
     * the Matrix3D class, you can add to or modify the existing transformation
     * settings. Also, you can create a custom Matrix3D object, set the custom
     * Matrix3D object's transformation elements, and then assign the new Matrix3D
     * object to the display object using the <code>transform.matrix</code>
     * property.</p>
     *
     * <p>To modify a perspective projection of the stage or root object: use the
     * <code>transform.matrix</code> property of the root display object to gain
     * access to the PerspectiveProjection object. Or, apply different perspective
     * projection properties to a display object by setting the perspective
     * projection properties of the display object's parent. The child display
     * object inherits the new properties. Specifically, create a
     * PerspectiveProjection object and set its properties, then assign the
     * PerspectiveProjection object to the <code>perspectiveProjection</code>
     * property of the parent display object's <code>transform</code> property.
     * The specified projection transformation then applies to all the display
     * object's three-dimensional children.</p>
     *
     * <p>Since both PerspectiveProjection and Matrix3D objects perform
     * perspective transformations, do not assign both to a display object at the
     * same time. Use the PerspectiveProjection object for focal length and
     * projection center changes. For more control over the perspective
     * transformation, create a perspective projection Matrix3D object.</p>
     */
    var Transform = /** @class */ (function (_super) {
        __extends$1(Transform, _super);
        function Transform(rawData, concatenatedMatrix3D) {
            if (rawData === void 0) { rawData = null; }
            if (concatenatedMatrix3D === void 0) { concatenatedMatrix3D = null; }
            var _this = _super.call(this) || this;
            //temp vector used in global to local
            _this._tempVector3D = new Vector3D();
            _this._inverseConcatenatedMatrix3D = new Matrix3D();
            _this._rotation = new Vector3D();
            _this._skew = new Vector3D();
            _this._scale = new Vector3D(1, 1, 1);
            _this._matrix = null;
            _this._rawData = rawData || new Float32Array(24);
            //create the view for matrix3D
            _this._matrix3D = new Matrix3D(new Float32Array(_this._rawData.buffer, 0, 16));
            //create the view for colorTransform
            _this._colorTransform = new ColorTransform(new Float32Array(_this._rawData.buffer, 64, 8));
            //create the concatenatedMatrix3D if required
            _this._concatenatedMatrix3D = concatenatedMatrix3D || _this._matrix3D;
            if (rawData == null) {
                _this._matrix3D.identity();
                _this._colorTransform.clear();
            }
            // Cached vector of transformation components used when
            // recomposing the transform matrix in updateTransform()
            _this._components = new Array(4);
            _this._components[1] = _this._rotation;
            _this._components[2] = _this._skew;
            _this._components[3] = _this._scale;
            _this.invalidateComponents();
            return _this;
        }
        Object.defineProperty(Transform.prototype, "backVector", {
            /**
             *
             */
            get: function () {
                if (!this._backVector)
                    this._backVector = new Vector3D();
                this._matrix3D.copyColumnTo(2, this._backVector, true);
                return this._backVector;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform.prototype, "colorTransform", {
            /**
             * A ColorTransform object containing values that universally adjust the
             * colors in the display object.
             *
             * @throws TypeError The colorTransform is null when being set
             */
            get: function () {
                return this._colorTransform;
            },
            set: function (val) {
                if (val) {
                    var sourceData = val._rawData, targetData = this._colorTransform._rawData;
                    targetData[0] = sourceData[0];
                    targetData[1] = sourceData[1];
                    targetData[2] = sourceData[2];
                    targetData[3] = sourceData[3];
                    targetData[4] = sourceData[4];
                    targetData[5] = sourceData[5];
                    targetData[6] = sourceData[6];
                    targetData[7] = sourceData[7];
                }
                else {
                    this._colorTransform.clear();
                }
                this.invalidateColorTransform();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform.prototype, "concatenatedMatrix", {
            //for AVM!:
            get: function () {
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform.prototype, "concatenatedMatrix3D", {
            /**
             * A Matrix object representing the combined transformation matrixes of the
             * display object and all of its parent objects, back to the root level. If
             * different transformation matrixes have been applied at different levels,
             * all of those matrixes are concatenated into one matrix for this property.
             * Also, for resizeable SWF content running in the browser, this property
             * factors in the difference between stage coordinates and window coordinates
             * due to window resizing. Thus, the property converts local coordinates to
             * window coordinates, which may not be the same coordinate space as that of
             * the Scene.
             */
            get: function () {
                if (this._concatenatedMatrix3DDirty) {
                    this._concatenatedMatrix3DDirty = false;
                    if (this._concatenatedMatrix3D == this._matrix3D && this._matrix3DDirty) //in cases where concatenated matrix has not been supplied
                        this.updateMatrix3D();
                    this.dispatchEvent(this._updateConcatenatedMatrix3D || (this._updateConcatenatedMatrix3D = new TransformEvent(TransformEvent.UPDATE_CONCATENATED_MATRIX3D, this)));
                }
                return this._concatenatedMatrix3D;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform.prototype, "inverseConcatenatedMatrix3D", {
            /**
             *
             */
            get: function () {
                if (this._inverseConcatenatedMatrix3DDirty) {
                    this._inverseConcatenatedMatrix3DDirty = false;
                    this._inverseConcatenatedMatrix3D.copyFrom(this.concatenatedMatrix3D);
                    this._inverseConcatenatedMatrix3D.invert();
                }
                return this._inverseConcatenatedMatrix3D;
            },
            enumerable: true,
            configurable: true
        });
        Transform.prototype.append = function (value) {
            console.log("append not implemented yet in core/Transform");
        };
        Object.defineProperty(Transform.prototype, "downVector", {
            /**
             *
             */
            get: function () {
                if (!this._downVector)
                    this._downVector = new Vector3D();
                this._matrix3D.copyColumnTo(1, this._downVector, true);
                return this._downVector;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform.prototype, "forwardVector", {
            /**
             *
             */
            get: function () {
                if (!this._forwardVector)
                    this._forwardVector = new Vector3D();
                this._matrix3D.copyColumnTo(2, this._forwardVector);
                return this._forwardVector;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform.prototype, "leftVector", {
            /**
             *
             */
            get: function () {
                if (!this._leftVector)
                    this._leftVector = new Vector3D();
                this._matrix3D.copyColumnTo(0, this._backVector, true);
                return this._leftVector;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform.prototype, "matrix", {
            /**
             * A Matrix object containing values that alter the scaling, rotation, and
             * translation of the display object.
             *
             * <p>If the <code>matrix</code> property is set to a value(not
             * <code>null</code>), the <code>matrix3D</code> property is
             * <code>null</code>. And if the <code>matrix3D</code> property is set to a
             * value(not <code>null</code>), the <code>matrix</code> property is
             * <code>null</code>.</p>
             *
             * @throws TypeError The matrix is null when being set
             */
            get: function () {
                if (!this._matrix)
                    this._matrix = new Matrix(this.matrix3D._rawData[0], this.matrix3D._rawData[1], this.matrix3D._rawData[4], this.matrix3D._rawData[5], this.matrix3D._rawData[12], this.matrix3D._rawData[13]);
                this._matrix.a = this.matrix3D._rawData[0];
                this._matrix.b = this.matrix3D._rawData[1];
                this._matrix.c = this.matrix3D._rawData[4];
                this._matrix.d = this.matrix3D._rawData[5];
                this._matrix.tx = this.matrix3D._rawData[12];
                this._matrix.ty = this.matrix3D._rawData[13];
                return this._matrix;
            },
            set: function (value) {
                this._matrix = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform.prototype, "matrix3D", {
            /**
             * Provides access to the Matrix3D object of a three-dimensional display
             * object. The Matrix3D object represents a transformation matrix that
             * determines the display object's position and orientation. A Matrix3D
             * object can also perform perspective projection.
             *
             * <p>If the <code>matrix</code> property is set to a value(not
             * <code>null</code>), the <code>matrix3D</code> property is
             * <code>null</code>. And if the <code>matrix3D</code> property is set to a
             * value(not <code>null</code>), the <code>matrix</code> property is
             * <code>null</code>.</p>
             */
            get: function () {
                if (this._matrix3DDirty)
                    this.updateMatrix3D();
                return this._matrix3D;
            },
            set: function (val) {
                var sourceData = val._rawData, targetData = this._matrix3D._rawData;
                targetData[0] = sourceData[0];
                targetData[1] = sourceData[1];
                targetData[2] = sourceData[2];
                targetData[3] = sourceData[3];
                targetData[4] = sourceData[4];
                targetData[5] = sourceData[5];
                targetData[6] = sourceData[6];
                targetData[7] = sourceData[7];
                targetData[8] = sourceData[8];
                targetData[9] = sourceData[9];
                targetData[10] = sourceData[10];
                targetData[11] = sourceData[11];
                targetData[12] = sourceData[12];
                targetData[13] = sourceData[13];
                targetData[14] = sourceData[14];
                targetData[15] = sourceData[15];
                this.invalidateComponents();
                this.invalidateConcatenatedMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform.prototype, "pixelBounds", {
            /**
             * A Rectangle object that defines the bounding rectangle of the display
             * object on the stage.
             */
            get: function () {
                return this._pixelBounds;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform.prototype, "position", {
            /**
             * Defines the position of the 3d object, relative to the local coordinates of the parent <code>ObjectContainer3D</code>.
             */
            get: function () {
                return this._matrix3D.position;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform.prototype, "rightVector", {
            /**
             *
             */
            get: function () {
                if (!this._rightVector)
                    this._rightVector = new Vector3D();
                this._matrix3D.copyColumnTo(0, this._rightVector);
                return this._rightVector;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform.prototype, "rotation", {
            /**
             * Defines the rotation of the 3d object, relative to the local coordinates of the parent <code>ObjectContainer3D</code>.
             */
            get: function () {
                if (this._componentsDirty)
                    this._updateComponents();
                return this._rotation;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Rotates the 3d object directly to a euler angle
         *
         * @param    ax        The angle in degrees of the rotation around the x axis.
         * @param    ay        The angle in degrees of the rotation around the y axis.
         * @param    az        The angle in degrees of the rotation around the z axis.
         */
        Transform.prototype.rotateTo = function (ax, ay, az) {
            if (this._componentsDirty)
                this._updateComponents();
            this._rotation.x = ax;
            this._rotation.y = ay;
            this._rotation.z = az;
            this.invalidateMatrix3D();
        };
        Object.defineProperty(Transform.prototype, "scale", {
            /**
             * Defines the scale of the 3d object, relative to the local coordinates of the parent <code>ObjectContainer3D</code>.
             */
            get: function () {
                if (this._componentsDirty)
                    this._updateComponents();
                return this._scale;
            },
            enumerable: true,
            configurable: true
        });
        Transform.prototype.scaleTo = function (sx, sy, sz) {
            if (this._componentsDirty)
                this._updateComponents();
            this._scale.x = sx;
            this._scale.y = sy;
            this._scale.z = sz;
            this.invalidateMatrix3D();
        };
        Object.defineProperty(Transform.prototype, "skew", {
            /**
             * Defines the scale of the 3d object, relative to the local coordinates of the parent <code>ObjectContainer3D</code>.
             */
            get: function () {
                if (this._componentsDirty)
                    this._updateComponents();
                return this._skew;
            },
            enumerable: true,
            configurable: true
        });
        Transform.prototype.skewTo = function (sx, sy, sz) {
            if (this._componentsDirty)
                this._updateComponents();
            this._skew.x = sx;
            this._skew.y = sy;
            this._skew.z = sz;
            this.invalidateMatrix3D();
        };
        Object.defineProperty(Transform.prototype, "upVector", {
            /**
             *
             */
            get: function () {
                if (!this._upVector)
                    this._upVector = new Vector3D();
                this._matrix3D.copyColumnTo(1, this._upVector);
                return this._upVector;
            },
            enumerable: true,
            configurable: true
        });
        Transform.prototype.copyRawDataTo = function (transform) {
            if (this._matrix3DDirty)
                this.updateMatrix3D();
            var targetData = transform._rawData;
            var sourceData = this._rawData;
            //Matrix3D data
            targetData[0] = sourceData[0];
            targetData[1] = sourceData[1];
            targetData[2] = sourceData[2];
            targetData[3] = sourceData[3];
            targetData[4] = sourceData[4];
            targetData[5] = sourceData[5];
            targetData[6] = sourceData[6];
            targetData[7] = sourceData[7];
            targetData[8] = sourceData[8];
            targetData[9] = sourceData[9];
            targetData[10] = sourceData[10];
            targetData[11] = sourceData[11];
            targetData[12] = sourceData[12];
            targetData[13] = sourceData[13];
            targetData[14] = sourceData[14];
            targetData[15] = sourceData[15];
            //ColorTransform data
            targetData[16] = sourceData[16];
            targetData[17] = sourceData[17];
            targetData[18] = sourceData[18];
            targetData[19] = sourceData[19];
            targetData[20] = sourceData[20];
            targetData[21] = sourceData[21];
            targetData[22] = sourceData[22];
            targetData[23] = sourceData[23];
            this.invalidateComponents();
            this.invalidateColorTransform();
        };
        Transform.prototype.clone = function () {
            var transform = new Transform();
            this.copyRawDataTo(transform);
            return transform;
        };
        Transform.prototype.dispose = function () {
        };
        /**
         * Converts the <code>point</code> object from the Scene(global) coordinates
         * to the display object's(local) coordinates.
         *
         * <p>To use this method, first create an instance of the Point class. The
         * <i>x</i> and <i>y</i> values that you assign represent global coordinates
         * because they relate to the origin(0,0) of the main display area. Then
         * pass the Point instance as the parameter to the
         * <code>globalToLocal()</code> method. The method returns a new Point object
         * with <i>x</i> and <i>y</i> values that relate to the origin of the display
         * object instead of the origin of the Scene.</p>
         *
         * @param point An object created with the Point class. The Point object
         *              specifies the <i>x</i> and <i>y</i> coordinates as
         *              properties.
         * @return A Point object with coordinates relative to the display object.
         */
        Transform.prototype.globalToLocal = function (point, target) {
            if (target === void 0) { target = null; }
            this._tempVector3D.setTo(point.x, point.y, 0);
            //console.log("this._tempVector3D", this._tempVector3D);
            //console.log("this._transform.inverseConcatenatedMatrix3D", this._transform.inverseConcatenatedMatrix3D);
            var pos = this.inverseConcatenatedMatrix3D.transformVector(this._tempVector3D, this._tempVector3D);
            //console.log("pos", pos);
            if (!target)
                target = new Point();
            target.x = pos.x;
            target.y = pos.y;
            return target;
        };
        /**
         * Converts a two-dimensional point from the Scene(global) coordinates to a
         * three-dimensional display object's(local) coordinates.
         *
         * <p>To use this method, first create an instance of the Vector3D class. The x,
         * y and z values that you assign to the Vector3D object represent global
         * coordinates because they are relative to the origin(0,0,0) of the scene. Then
         * pass the Vector3D object to the <code>globalToLocal3D()</code> method as the
         * <code>position</code> parameter.
         * The method returns three-dimensional coordinates as a Vector3D object
         * containing <code>x</code>, <code>y</code>, and <code>z</code> values that
         * are relative to the origin of the three-dimensional display object.</p>
         *
         * @param point A Vector3D object representing global x, y and z coordinates in
         *              the scene.
         * @return A Vector3D object with coordinates relative to the three-dimensional
         *         display object.
         */
        Transform.prototype.globalToLocal3D = function (position) {
            return this.inverseConcatenatedMatrix3D.transformVector(position);
        };
        /**
         * Converts the <code>point</code> object from the display object's(local)
         * coordinates to the Scene(global) coordinates.
         *
         * <p>This method allows you to convert any given <i>x</i> and <i>y</i>
         * coordinates from values that are relative to the origin(0,0) of a
         * specific display object(local coordinates) to values that are relative to
         * the origin of the Scene(global coordinates).</p>
         *
         * <p>To use this method, first create an instance of the Point class. The
         * <i>x</i> and <i>y</i> values that you assign represent local coordinates
         * because they relate to the origin of the display object.</p>
         *
         * <p>You then pass the Point instance that you created as the parameter to
         * the <code>localToGlobal()</code> method. The method returns a new Point
         * object with <i>x</i> and <i>y</i> values that relate to the origin of the
         * Scene instead of the origin of the display object.</p>
         *
         * @param point The name or identifier of a point created with the Point
         *              class, specifying the <i>x</i> and <i>y</i> coordinates as
         *              properties.
         * @return A Point object with coordinates relative to the Scene.
         */
        Transform.prototype.localToGlobal = function (point, target) {
            if (target === void 0) { target = null; }
            this._tempVector3D.setTo(point.x, point.y, 0);
            var pos = this.concatenatedMatrix3D.transformVector(this._tempVector3D, this._tempVector3D);
            if (!target)
                target = new Point();
            target.x = pos.x;
            target.y = pos.y;
            return target;
        };
        /**
         * Rotates the 3d object around to face a point defined relative to the local coordinates of the parent <code>ObjectContainer3D</code>.
         *
         * @param    target        The vector defining the point to be looked at
         * @param    upAxis        An optional vector used to define the desired up orientation of the 3d object after rotation has occurred
         */
        Transform.prototype.lookAt = function (position, upAxis) {
            if (upAxis === void 0) { upAxis = null; }
            if (upAxis == null)
                upAxis = Vector3D.Y_AXIS;
            var vec = Matrix3D.getPointAtMatrix(new Vector3D(), position.subtract(this._matrix3D.position), upAxis, Matrix3D.CALCULATION_MATRIX).decompose()[1];
            this.rotateTo(vec.x, vec.y, vec.z);
        };
        /**
         * Moves the 3d object forwards along it's local z axis
         *
         * @param    distance    The length of the movement
         */
        Transform.prototype.moveForward = function (distance) {
            this.translateLocal(Vector3D.Z_AXIS, distance);
        };
        /**
         * Moves the 3d object backwards along it's local z axis
         *
         * @param    distance    The length of the movement
         */
        Transform.prototype.moveBackward = function (distance) {
            this.translateLocal(Vector3D.Z_AXIS, -distance);
        };
        /**
         * Moves the 3d object backwards along it's local x axis
         *
         * @param    distance    The length of the movement
         */
        Transform.prototype.moveLeft = function (distance) {
            this.translateLocal(Vector3D.X_AXIS, -distance);
        };
        /**
         * Moves the 3d object forwards along it's local x axis
         *
         * @param    distance    The length of the movement
         */
        Transform.prototype.moveRight = function (distance) {
            this.translateLocal(Vector3D.X_AXIS, distance);
        };
        /**
         * Moves the 3d object forwards along it's local y axis
         *
         * @param    distance    The length of the movement
         */
        Transform.prototype.moveUp = function (distance) {
            this.translateLocal(Vector3D.Y_AXIS, distance);
        };
        /**
         * Moves the 3d object backwards along it's local y axis
         *
         * @param    distance    The length of the movement
         */
        Transform.prototype.moveDown = function (distance) {
            this.translateLocal(Vector3D.Y_AXIS, -distance);
        };
        /**
         * Moves the 3d object directly to a point in space
         *
         * @param    dx        The amount of movement along the local x axis.
         * @param    dy        The amount of movement along the local y axis.
         * @param    dz        The amount of movement along the local z axis.
         */
        Transform.prototype.moveTo = function (dx, dy, dz) {
            this._matrix3D._rawData[12] = dx;
            this._matrix3D._rawData[13] = dy;
            this._matrix3D._rawData[14] = dz;
            this.invalidatePosition();
        };
        /**
         * Rotates the 3d object around it's local x-axis
         *
         * @param    angle        The amount of rotation in degrees
         */
        Transform.prototype.pitch = function (angle) {
            this.rotate(Vector3D.X_AXIS, angle);
        };
        /**
         * Rotates the 3d object around it's local z-axis
         *
         * @param    angle        The amount of rotation in degrees
         */
        Transform.prototype.roll = function (angle) {
            this.rotate(Vector3D.Z_AXIS, angle);
        };
        /**
         * Rotates the 3d object around it's local y-axis
         *
         * @param    angle        The amount of rotation in degrees
         */
        Transform.prototype.yaw = function (angle) {
            this.rotate(Vector3D.Y_AXIS, angle);
        };
        /**
         * Rotates the 3d object around an axis by a defined angle
         *
         * @param    axis        The vector defining the axis of rotation
         * @param    angle        The amount of rotation in degrees
         */
        Transform.prototype.rotate = function (axis, angle) {
            this.matrix3D.prependRotation(angle, axis);
            this.invalidateComponents();
        };
        /**
         * Moves the 3d object along a vector by a defined length
         *
         * @param    axis        The vector defining the axis of movement
         * @param    distance    The length of the movement
         */
        Transform.prototype.translate = function (axis, distance) {
            var x = axis.x, y = axis.y, z = axis.z;
            var len = distance / Math.sqrt(x * x + y * y + z * z);
            this.matrix3D.appendTranslation(x * len, y * len, z * len);
            this.invalidatePosition();
        };
        /**
         * Moves the 3d object along a vector by a defined length
         *
         * @param    axis        The vector defining the axis of movement
         * @param    distance    The length of the movement
         */
        Transform.prototype.translateLocal = function (axis, distance) {
            var x = axis.x, y = axis.y, z = axis.z;
            var len = distance / Math.sqrt(x * x + y * y + z * z);
            this.matrix3D.prependTranslation(x * len, y * len, z * len);
            this.invalidatePosition();
        };
        Transform.prototype.clearMatrix3D = function () {
            this._matrix3D.identity();
            this.invalidateComponents();
        };
        Transform.prototype.clearColorTransform = function () {
            if (!this._colorTransform)
                return;
            this._colorTransform.clear();
            this.invalidateColorTransform();
        };
        /**
         * Invalidates the 3D transformation matrix, causing it to be updated upon the next request
         *
         * @private
         */
        Transform.prototype.invalidateMatrix3D = function () {
            if (this._concatenatedMatrix3D == this._matrix3D)
                this.invalidateConcatenatedMatrix3D();
            if (this._matrix3DDirty)
                return;
            this._matrix3DDirty = true;
            this.dispatchEvent(this._invalidateMatrix3D || (this._invalidateMatrix3D = new TransformEvent(TransformEvent.INVALIDATE_MATRIX3D, this)));
        };
        Transform.prototype.invalidateComponents = function () {
            this.invalidatePosition();
            this._componentsDirty = true;
        };
        Transform.prototype.invalidateConcatenatedMatrix3D = function () {
            if (this._concatenatedMatrix3DDirty)
                return;
            this._concatenatedMatrix3DDirty = true;
            this._inverseConcatenatedMatrix3DDirty = true;
            this.dispatchEvent(this._invalidateConcatenatedMatrix3D || (this._invalidateConcatenatedMatrix3D = new TransformEvent(TransformEvent.INVALIDATE_CONCATENATED_MATRIX3D, this)));
        };
        /**
         *
         */
        Transform.prototype.invalidatePosition = function () {
            if (this._concatenatedMatrix3D == this._matrix3D)
                this.invalidateConcatenatedMatrix3D();
            this._matrix3D.invalidatePosition();
            this.dispatchEvent(this._invalidateMatrix3D || (this._invalidateMatrix3D = new TransformEvent(TransformEvent.INVALIDATE_MATRIX3D, this))); //stricty speaking, this should be UPDATE_MATRIX3D
        };
        Transform.prototype.invalidateColorTransform = function () {
            this.dispatchEvent(this._invalidateColorTransform || (this._invalidateColorTransform = new TransformEvent(TransformEvent.INVALIDATE_COLOR_TRANSFORM, this)));
        };
        /**
         *
         */
        Transform.prototype.updateMatrix3D = function () {
            this._matrix3D.recompose(this._components);
            this._matrix3DDirty = false;
        };
        Transform.prototype._updateComponents = function () {
            var elements = this._matrix3D.decompose();
            var vec;
            vec = elements[1];
            this._rotation.x = vec.x;
            this._rotation.y = vec.y;
            this._rotation.z = vec.z;
            vec = elements[2];
            this._skew.x = vec.x;
            this._skew.y = vec.y;
            this._skew.z = vec.z;
            vec = elements[3];
            this._scale.x = vec.x;
            this._scale.y = vec.y;
            this._scale.z = vec.z;
            this._componentsDirty = false;
        };
        return Transform;
    }(EventDispatcher));

    var DocumentError = /** @class */ (function (_super) {
        __extends$1(DocumentError, _super);
        function DocumentError(message, id) {
            if (message === void 0) { message = "DocumentError"; }
            if (id === void 0) { id = 0; }
            return _super.call(this, message, id) || this;
        }
        DocumentError.DOCUMENT_DOES_NOT_EXIST = "documentDoesNotExist";
        return DocumentError;
    }(ErrorBase));

    /**
     * AbstractMethodError is thrown when an abstract method is called. The method in question should be overridden
     * by a concrete subclass.
     */
    var PartialImplementationError = /** @class */ (function (_super) {
        __extends$1(PartialImplementationError, _super);
        /**
         * Create a new AbstractMethodError.
         * @param message An optional message to override the default error message.
         * @param id The id of the error.
         */
        function PartialImplementationError(dependency, id) {
            if (dependency === void 0) { dependency = ''; }
            if (id === void 0) { id = 0; }
            return _super.call(this, "PartialImplementationError - this function is in development. Required Dependency: " + dependency, id) || this;
        }
        return PartialImplementationError;
    }(ErrorBase));

    /**
     * RangeError is thrown when an index is accessed out of range of the number of
     * available indices on an Array.
     */
    var RangeError$1 = /** @class */ (function (_super) {
        __extends$1(RangeError, _super);
        /**
         * Create a new RangeError.
         *
         * @param message An optional message to override the default error message.
         * @param id The id of the error.
         */
        function RangeError(message, id) {
            if (message === void 0) { message = null; }
            if (id === void 0) { id = 0; }
            return _super.call(this, message || "RangeError", id) || this;
        }
        return RangeError;
    }(ErrorBase));

    var LoaderEvent = /** @class */ (function (_super) {
        __extends$1(LoaderEvent, _super);
        /**
         * Create a new LoaderEvent object.
         *
         * @param type The event type.
         * @param url The url of the loaded resource.
         * @param assets The assets of the loaded resource.
         */
        function LoaderEvent(type, url, content, assets) {
            if (url === void 0) { url = null; }
            if (content === void 0) { content = null; }
            if (assets === void 0) { assets = null; }
            var _this = _super.call(this, type) || this;
            _this._url = url;
            _this._content = content;
            _this._assets = assets;
            return _this;
        }
        Object.defineProperty(LoaderEvent.prototype, "content", {
            /**
             * The content returned if the resource has been loaded inside a <code>Loader</code> object.
             */
            get: function () {
                return this._content;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderEvent.prototype, "url", {
            /**
             * The url of the loaded resource.
             */
            get: function () {
                return this._url;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderEvent.prototype, "assets", {
            /**
             * The error string on loadError.
             */
            get: function () {
                return this._assets;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the current event.
         * @return An exact duplicate of the current event.
         */
        LoaderEvent.prototype.clone = function () {
            return new LoaderEvent(this.type, this._url, this._content, this._assets);
        };
        /**
         * Dispatched when the loading of a session and all of its dependencies is complete.
         */
        LoaderEvent.LOAD_COMPLETE = "loadComplete";
        return LoaderEvent;
    }(EventBase));

    var ParserEvent = /** @class */ (function (_super) {
        __extends$1(ParserEvent, _super);
        function ParserEvent(type, message) {
            if (message === void 0) { message = ''; }
            var _this = _super.call(this, type) || this;
            _this._message = message;
            return _this;
        }
        Object.defineProperty(ParserEvent.prototype, "message", {
            /**
             * Additional human-readable message. Usually supplied for ParserEvent.PARSE_ERROR events.
             */
            get: function () {
                return this._message;
            },
            enumerable: true,
            configurable: true
        });
        ParserEvent.prototype.clone = function () {
            return new ParserEvent(this.type, this._message);
        };
        /**
         * Dispatched when parsing of an asset completed.
         */
        ParserEvent.PARSE_COMPLETE = 'parseComplete';
        /**
         * Dispatched when an error occurs while parsing the data (e.g. because it's
         * incorrectly formatted.)
         */
        ParserEvent.PARSE_ERROR = 'parseError';
        /**
         * Dispatched when a parser is ready to have dependencies retrieved and resolved.
         * This is an internal event that should rarely (if ever) be listened for by
         * external classes.
         */
        ParserEvent.READY_FOR_DEPENDENCIES = 'readyForDependencies';
        return ParserEvent;
    }(EventBase));

    var ProjectionEvent = /** @class */ (function (_super) {
        __extends$1(ProjectionEvent, _super);
        function ProjectionEvent(type, projection) {
            var _this = _super.call(this, type) || this;
            _this._projection = projection;
            return _this;
        }
        Object.defineProperty(ProjectionEvent.prototype, "projection", {
            get: function () {
                return this._projection;
            },
            enumerable: true,
            configurable: true
        });
        ProjectionEvent.INVALIDATE_FRUSTUM_MATRIX3D = "invalidateFrustumMatrix3D";
        ProjectionEvent.INVALIDATE_VIEW_MATRIX3D = "invalidateViewMatrix3D";
        return ProjectionEvent;
    }(EventBase));

    var TimerEvent = /** @class */ (function (_super) {
        __extends$1(TimerEvent, _super);
        function TimerEvent(type) {
            return _super.call(this, type) || this;
        }
        /**
         *
         */
        TimerEvent.TIMER = "timer";
        /**
         *
         */
        TimerEvent.TIMER_COMPLETE = "timerComplete";
        return TimerEvent;
    }(EventBase));

    var URLLoaderEvent = /** @class */ (function (_super) {
        __extends$1(URLLoaderEvent, _super);
        function URLLoaderEvent(type, urlLoader) {
            var _this = _super.call(this, type) || this;
            _this._urlLoader = urlLoader;
            return _this;
        }
        Object.defineProperty(URLLoaderEvent.prototype, "urlLoader", {
            /**
             *
             */
            get: function () {
                return this._urlLoader;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        URLLoaderEvent.prototype.clone = function () {
            return new URLLoaderEvent(this.type, this._urlLoader);
        };
        URLLoaderEvent.HTTP_STATUS = "httpStatus";
        URLLoaderEvent.LOAD_ERROR = "loadError";
        URLLoaderEvent.LOAD_PROGRESS = "loadProgress";
        URLLoaderEvent.LOAD_START = "loadStart";
        URLLoaderEvent.LOAD_COMPLETE = "loadComplete";
        return URLLoaderEvent;
    }(EventBase));

    var PlaneClassification = /** @class */ (function () {
        function PlaneClassification() {
        }
        // "back" is synonymous with "in", but used for planes (back of plane is "inside" a solid volume walled by a plane)
        PlaneClassification.BACK = 0;
        PlaneClassification.FRONT = 1;
        PlaneClassification.IN = 0;
        PlaneClassification.OUT = 1;
        PlaneClassification.INTERSECT = 2;
        return PlaneClassification;
    }());

    var Plane3D = /** @class */ (function () {
        /**
         * Create a Plane3D with ABCD coefficients
         */
        function Plane3D(a, b, c, d) {
            if (a === void 0) { a = 0; }
            if (b === void 0) { b = 0; }
            if (c === void 0) { c = 0; }
            if (d === void 0) { d = 0; }
            this.a = a;
            this.b = b;
            this.c = c;
            this.d = d;
            if (a == 0 && b == 0) {
                this._iAlignment = Plane3D.ALIGN_XY_AXIS;
            }
            else if (b == 0 && c == 0) {
                this._iAlignment = Plane3D.ALIGN_YZ_AXIS;
            }
            else if (a == 0 && c == 0) {
                this._iAlignment = Plane3D.ALIGN_XZ_AXIS;
            }
            else {
                this._iAlignment = Plane3D.ALIGN_ANY;
            }
        }
        /**
         * Fills this Plane3D with the coefficients from 3 points in 3d space.
         * @param p0 Vector3D
         * @param p1 Vector3D
         * @param p2 Vector3D
         */
        Plane3D.prototype.fromPoints = function (p0, p1, p2) {
            var d1x = p1.x - p0.x;
            var d1y = p1.y - p0.y;
            var d1z = p1.z - p0.z;
            var d2x = p2.x - p0.x;
            var d2y = p2.y - p0.y;
            var d2z = p2.z - p0.z;
            this.a = d1y * d2z - d1z * d2y;
            this.b = d1z * d2x - d1x * d2z;
            this.c = d1x * d2y - d1y * d2x;
            this.d = this.a * p0.x + this.b * p0.y + this.c * p0.z;
            // not using epsilon, since a plane is infinite and a small incorrection can grow very large
            if (this.a == 0 && this.b == 0) {
                this._iAlignment = Plane3D.ALIGN_XY_AXIS;
            }
            else if (this.b == 0 && this.c == 0) {
                this._iAlignment = Plane3D.ALIGN_YZ_AXIS;
            }
            else if (this.a == 0 && this.c == 0) {
                this._iAlignment = Plane3D.ALIGN_XZ_AXIS;
            }
            else {
                this._iAlignment = Plane3D.ALIGN_ANY;
            }
        };
        /**
         * Fills this Plane3D with the coefficients from the plane's normal and a point in 3d space.
         * @param normal Vector3D
         * @param point  Vector3D
         */
        Plane3D.prototype.fromNormalAndPoint = function (normal, point) {
            this.a = normal.x;
            this.b = normal.y;
            this.c = normal.z;
            this.d = this.a * point.x + this.b * point.y + this.c * point.z;
            if (this.a == 0 && this.b == 0) {
                this._iAlignment = Plane3D.ALIGN_XY_AXIS;
            }
            else if (this.b == 0 && this.c == 0) {
                this._iAlignment = Plane3D.ALIGN_YZ_AXIS;
            }
            else if (this.a == 0 && this.c == 0) {
                this._iAlignment = Plane3D.ALIGN_XZ_AXIS;
            }
            else {
                this._iAlignment = Plane3D.ALIGN_ANY;
            }
        };
        /**
         * Normalize this Plane3D
         * @return Plane3D This Plane3D.
         */
        Plane3D.prototype.normalize = function () {
            var len = 1 / Math.sqrt(this.a * this.a + this.b * this.b + this.c * this.c);
            this.a *= len;
            this.b *= len;
            this.c *= len;
            this.d *= len;
            return this;
        };
        /**
         * Returns the signed distance between this Plane3D and the point p.
         * @param p Vector3D
         * @returns Number
         */
        Plane3D.prototype.distance = function (p) {
            if (this._iAlignment == Plane3D.ALIGN_YZ_AXIS) {
                return this.a * p.x - this.d;
            }
            else if (this._iAlignment == Plane3D.ALIGN_XZ_AXIS) {
                return this.b * p.y - this.d;
            }
            else if (this._iAlignment == Plane3D.ALIGN_XY_AXIS) {
                return this.c * p.z - this.d;
            }
            else {
                return this.a * p.x + this.b * p.y + this.c * p.z - this.d;
            }
        };
        /**
         * Classify a point against this Plane3D. (in front, back or intersecting)
         * @param p Vector3D
         * @return int Plane3.FRONT or Plane3D.BACK or Plane3D.INTERSECT
         */
        Plane3D.prototype.classifyPoint = function (p, epsilon) {
            if (epsilon === void 0) { epsilon = 0.01; }
            // check NaN
            if (this.d != this.d)
                return PlaneClassification.FRONT;
            var len;
            if (this._iAlignment == Plane3D.ALIGN_YZ_AXIS)
                len = this.a * p.x - this.d;
            else if (this._iAlignment == Plane3D.ALIGN_XZ_AXIS)
                len = this.b * p.y - this.d;
            else if (this._iAlignment == Plane3D.ALIGN_XY_AXIS)
                len = this.c * p.z - this.d;
            else
                len = this.a * p.x + this.b * p.y + this.c * p.z - this.d;
            if (len < -epsilon)
                return PlaneClassification.BACK;
            else if (len > epsilon)
                return PlaneClassification.FRONT;
            else
                return PlaneClassification.INTERSECT;
        };
        Plane3D.prototype.toString = function () {
            return "Plane3D [a:" + this.a + ", b:" + this.b + ", c:" + this.c + ", d:" + this.d + "]";
        };
        // indicates the alignment of the plane
        Plane3D.ALIGN_ANY = 0;
        Plane3D.ALIGN_XY_AXIS = 1;
        Plane3D.ALIGN_YZ_AXIS = 2;
        Plane3D.ALIGN_XZ_AXIS = 3;
        return Plane3D;
    }());

    var PoissonLookup = /** @class */ (function () {
        function PoissonLookup() {
        }
        PoissonLookup.initDistributions = function () {
            // precalculated for best control
            this._distributions = new Array();
            this._distributions[0] = new Array(0.3082841, 0.4320919);
            this._distributions[1] = new Array(0.3082841, 0.4320919, -0.2274942, -0.6640266);
            this._distributions[2] = new Array(0.8742689, 0.0009265686, -0.6864116, -0.5536607, -0.2325206, 0.7678371);
            this._distributions[3] = new Array(0.3913446, -0.7084417, -0.7511101, -0.5935929, -0.2323436, 0.5320091, 0.8435315, 0.5035911);
            this._distributions[4] = new Array(0.2122471, -0.5771395, -0.8543506, -0.1763534, 0.5189021, 0.8323698, -0.3616908, 0.5865368, 0.9523004, -0.04948437);
            this._distributions[5] = new Array(0.5791035, 0.3496495, 0.2959551, -0.6006749, -0.2419119, -0.06879545, -0.7403072, 0.6110353, -0.04555973, 0.8059174, -0.5275017, -0.737129);
            this._distributions[6] = new Array(0.06941478, 0.8519508, -0.7441907, 0.2426432, 0.6439992, -0.2405252, -0.1007523, -0.2327587, -0.6427067, -0.7248485, 0.8050759, 0.5492936, 0.3573822, -0.8824506);
            this._distributions[7] = new Array(0.8509863, 0.4452587, -0.09507271, 0.2073005, 0.1706571, -0.6434793, 0.8029777, -0.2718274, -0.4401725, 0.8196304, 0.2715359, 0.8598521, -0.8121575, -0.006447683, -0.6486837, -0.7237598);
            this._distributions[8] = new Array(0.6951686, -0.2680728, -0.04933243, 0.3710589, 0.6592212, 0.3661054, -0.01579228, -0.6909603, -0.3275101, -0.1756866, 0.3811549, 0.9218544, -0.216032, 0.9755028, -0.7065172, 0.3355389, -0.6579109, -0.6798355);
            this._distributions[9] = new Array(0.6181276, -0.09790418, -0.2537868, -0.5570995, -0.1964931, 0.3459414, 0.3474613, -0.8885581, 0.5135743, 0.5753114, -0.9549091, 0.1480672, -0.8711916, -0.4293123, -0.6928071, 0.6190156, -0.13369, 0.8892705, 0.0548224, -0.1246777);
            this._distributions[10] = new Array(0.4853027, -0.5080479, -0.1331675, -0.506597, 0.139575, 0.01316885, 0.803486, -0.07568797, 0.5240274, 0.4883182, -0.4334005, 0.1207938, -0.7794577, -0.3985141, 0.1576432, -0.9861221, -0.3712867, 0.6959021, 0.1517378, 0.9847429, -0.9762396, 0.1661073);
            this._distributions[11] = new Array(-0.2790166, -0.01252619, 0.3389016, 0.3921154, 0.2408341, -0.313211, -0.8151779, -0.3898362, -0.6347761, 0.3486495, 0.09471484, -0.7722448, -0.1385674, 0.6364574, 0.2456331, 0.9295807, -0.3864306, -0.8247881, 0.6111673, -0.7164014, 0.8287669, 0.05466961, 0.837706, 0.5415626);
            this._distributions[12] = new Array(0.056417, 0.3185693, -0.8245888, 0.1882799, 0.8575996, 0.1136829, 0.1070375, 0.875332, 0.4076743, -0.06000621, -0.4311306, 0.7239349, 0.2677574, -0.538472, -0.08486642, -0.2083647, -0.888989, -0.3906443, -0.4768958, -0.6664082, 0.09334993, -0.9861541, 0.808736, -0.455949, 0.5889823, 0.7660807);
            this._distributions[13] = new Array(-0.2681346, -0.3955857, -0.1315102, -0.8852947, -0.5143692, 0.09551838, 0.4344836, -0.546945, -0.8620899, -0.3813288, 0.1650431, 0.02034803, -0.1543657, 0.3842218, -0.828457, 0.5376903, -0.6145, -0.7818927, -0.2639062, 0.8784655, 0.1912684, 0.9720125, 0.3135219, 0.5224229, 0.7850655, 0.4592297, 0.7465045, -0.1368916);
            this._distributions[14] = new Array(0.4241029, 0.695281, 0.150511, -0.02304107, -0.2482675, 0.9120338, 0.8057325, 0.2622084, -0.2445909, 0.2765962, 0.8588713, -0.1772072, 0.3117845, -0.4385471, -0.3923851, -0.3298936, -0.1751254, -0.7405846, 0.6926506, -0.684163, -0.9304563, -0.3254691, -0.8533293, 0.1523024, 0.2510415, -0.917345, -0.6239773, -0.7105472, -0.6104624, 0.6041355);
            this._distributions[15] = new Array(0.5844554, 0.06651045, 0.1343258, 0.6756578, 0.3799674, -0.6301104, 0.5590436, 0.7940555, 0.09574714, 0.02262517, 0.8697868, 0.393301, 0.003945862, -0.421735, 0.9043913, -0.2432393, -0.4844007, 0.7190998, -0.3201078, 0.2972371, -0.3852352, -0.6341155, -0.5413069, -0.09223081, -0.8468984, -0.5126905, 0.004156174, -0.8633173, -0.9681889, -0.03305046, -0.846509, 0.4414353);
            this._distributions[16] = new Array(0.4506488, 0.657668, 0.4621297, 0.07441051, -0.2782125, 0.6201044, 0.9750003, 0.09110117, 0.1019436, 0.2986514, 0.03457398, 0.9631706, 0.542098, -0.5505635, 0.8675668, 0.4938077, -0.5414361, 0.2655292, -0.7941836, 0.6003053, -0.09847672, -0.1001604, -0.9316511, -0.08572888, 0.07286467, -0.611899, -0.5232627, -0.4082253, -0.5481608, -0.827938, -0.1551939, -0.9621193, 0.9220031, -0.3315949);
            this._distributions[17] = new Array(0.197908, -0.4697656, -0.4474689, -0.3428435, 0.8529873, -0.2228634, 0.6022478, -0.5469642, 0.2545276, -0.931133, -0.1507547, -0.7855865, -0.07606658, 0.1011628, 0.3046715, 0.2785755, 0.4698432, -0.1064076, 0.6831254, 0.4152522, 0.1374381, 0.8363233, -0.2166121, 0.6682042, 0.5511393, 0.7996449, -0.4278994, 0.28836, -0.8875198, 0.2181732, -0.8772842, -0.2818254, -0.7000262, 0.5762185, -0.6062385, -0.7439126);
            this._distributions[18] = new Array(0.6645703, -0.05678739, 0.5720971, 0.4533803, -0.07660709, 0.08802763, 0.5163431, -0.4426552, 0.1163455, -0.3404382, -0.4004807, -0.5046007, 0.2932099, -0.8201418, -0.5322125, 0.03834766, -0.1490209, -0.8817304, -0.8000439, -0.3509448, 0.5260983, 0.8421043, 0.1197811, 0.6963812, 0.9498612, 0.3122156, -0.9285746, 0.02120355, -0.6670724, 0.7217396, 0.9155889, -0.3510147, -0.271941, 0.4727852, 0.318879, 0.1634057, -0.2686755, 0.9253026);
            this._distributions[19] = new Array(0.5064292, 0.422527, 0.8935515, -0.06610427, 0.1199719, 0.175568, 0.403388, -0.2003276, 0.1657927, 0.8154403, 0.9301245, 0.2929218, -0.1644068, 0.6201534, 0.7113559, -0.6589743, -0.3364046, -0.1799502, 0.02109996, -0.392765, -0.382213, 0.3219992, -0.9201946, 0.1207967, -0.726185, 0.4291916, -0.7443482, -0.2480059, -0.5147594, 0.7418784, 0.1935272, -0.7406143, -0.3643523, -0.5559214, -0.7147766, -0.6326278, -0.2524151, -0.9096627, 0.5161405, 0.7908453);
            this._distributions[20] = new Array(0.7921003, -0.3032096, 0.5992879, -0.009052323, 0.2538549, -0.1872749, 0.7053444, 0.3677175, 0.5417761, -0.8170255, 0.9749611, 0.1210478, 0.1969143, -0.6117041, -0.1824499, -0.4634196, -0.1181338, -0.8668742, -0.3050112, -0.1352596, -0.4409327, -0.7082354, -0.03225285, 0.1171548, 0.3113096, 0.3250439, -0.8166144, -0.463995, -0.01014475, 0.4715334, -0.6868284, 0.05091889, -0.4011163, 0.2717285, -0.06756835, 0.8307694, -0.7938535, 0.4352129, -0.4663842, 0.7165329, 0.559729, 0.8093995);
            this._distributions[21] = new Array(0.07832243, 0.426151, -0.3856795, 0.5799953, 0.01970797, 0.06706189, 0.4822682, 0.3014512, -0.1532982, 0.87485, -0.4959527, 0.07888043, 0.260601, -0.2304784, 0.4996209, 0.7167382, 0.585986, -0.04265174, -0.7679967, 0.5509416, -0.9041753, 0.1802134, -0.8407655, -0.4442826, -0.2058258, -0.2636995, -0.4984115, -0.5928579, 0.2926032, -0.7886473, -0.06933882, -0.621177, 0.578115, -0.4813387, 0.8981777, -0.3291056, 0.1942733, 0.9255584, 0.8084362, 0.5066984, 0.9920095, 0.03103104, -0.2403206, -0.9389018);
            this._distributions[22] = new Array(-0.5691095, 0.1014316, -0.7788262, 0.384012, -0.8253665, -0.1645582, -0.1830993, 0.002997211, -0.2555013, -0.4177977, -0.6640869, -0.4794711, -0.2351242, 0.5850121, 0.02436554, 0.2825883, 0.006061143, -0.8200245, 0.1618791, -0.3063331, -0.3765897, -0.7249815, 0.6092919, -0.6769328, -0.5956934, 0.6957655, 0.5383642, 0.4522677, -0.1489165, 0.9125596, 0.4167473, 0.1335986, 0.1898309, 0.5874342, 0.2288171, 0.9624356, 0.7540846, -0.07672304, 0.8986252, 0.2788797, 0.3555991, -0.9262139, 0.8454325, -0.4027667, 0.4945236, -0.2935512);
            this._distributions[23] = new Array(-0.4481403, -0.3758374, -0.8877251, 0.08739938, 0.05015831, -0.1339983, -0.4070427, -0.8534173, 0.1019274, -0.5503222, -0.445998, 0.1997541, -0.8686263, -0.2788867, -0.7695944, -0.6033704, -0.05515742, -0.885711, -0.7714347, 0.5790485, 0.3466263, -0.8799297, 0.4487582, -0.5321087, -0.2461368, 0.6053771, -0.05568117, 0.2457351, -0.4668669, 0.8523816, 0.8103387, -0.4255538, 0.4054182, -0.175663, -0.2802011, -0.08920153, 0.2665959, 0.382935, 0.555679, 0.1621837, 0.105246, 0.8420411, 0.6921161, 0.6902903, 0.880946, 0.2483067, 0.9699264, -0.1021767);
            this._distributions[24] = new Array(-0.1703323, -0.3119385, 0.2916039, -0.2988263, -0.008472982, -0.9277695, -0.7730271, -0.3277904, 0.3440474, -0.6815342, -0.2910278, 0.03461745, -0.6764899, -0.657078, -0.3505501, -0.7311988, -0.03478927, 0.3258755, -0.6048835, 0.159423, 0.2035525, 0.02212214, 0.5116573, 0.2226856, 0.6664805, -0.2500189, 0.7147882, -0.6609634, 0.03030632, -0.5763278, -0.2516585, 0.6116219, -0.9434413, -0.0116792, 0.9061816, 0.2491155, 0.182867, 0.6076167, 0.286593, 0.9485695, -0.5992439, 0.6970096, -0.2082874, 0.9416641, 0.9880044, -0.1541709, -0.9122881, 0.331555, 0.7324886, 0.6725098);
            this._distributions[25] = new Array(0.3869598, -0.04974834, 0.7168844, -0.0693711, -0.07166742, 0.1725325, 0.4599592, 0.3232779, 0.5872094, -0.4198674, 0.2442266, -0.625667, 0.1254557, 0.4500048, -0.2290154, -0.1803567, 0.890583, 0.3373493, 0.1256081, 0.7853789, -0.2676466, 0.5305805, -0.7063224, 0.252168, -0.3989835, 0.1189921, 0.09617215, -0.2451447, 0.6302541, 0.6085876, 0.9380925, -0.3234899, 0.5086241, -0.8573482, 0.03576187, -0.9876697, -0.0876712, -0.6365195, -0.5276513, 0.823456, -0.6935764, -0.2240411, -0.5212318, -0.5383121, -0.2116208, 0.9639363, -0.9840096, 0.02743555, -0.3991577, -0.8994547, -0.7830126, 0.614068);
            this._distributions[26] = new Array(-0.8366601, 0.4464895, -0.5917366, -0.02073906, -0.9845258, 0.1635625, -0.3097973, 0.4379579, -0.5478154, 0.7173221, -0.1685888, 0.9261969, 0.01503595, 0.6046097, 0.4452421, 0.5449086, 0.0315687, 0.1944619, 0.3753404, 0.8688548, 0.4143643, 0.1396648, 0.8711032, 0.4304703, 0.7328773, 0.1461501, 0.6374492, -0.3521495, 0.145613, -0.1341466, 0.9040975, -0.135123, -0.7839059, -0.5450199, -0.516019, -0.3320859, -0.206158, -0.4431106, -0.9703014, -0.2368356, -0.2473119, -0.0864351, 0.2130725, -0.4604077, -0.003726701, -0.7122303, -0.4072131, -0.6833169, 0.1632999, -0.9776646, 0.4686888, -0.680495, -0.2293511, -0.9509777);
            this._distributions[27] = new Array(0.107311, -0.1311369, -0.4194764, -0.3148777, 0.6171439, -0.2745973, 0.2796618, 0.1937153, -0.09106886, 0.4180236, 0.6044006, 0.05577846, 0.02927299, -0.6738263, -0.2580845, 0.1179939, -0.09023564, -0.3830024, 0.3570953, -0.5000587, 0.81591, -0.5518309, 0.9300217, -0.1257987, 0.4904627, -0.8381903, -0.3163182, -0.8632009, 0.1137595, -0.9875998, 0.8390043, 0.3538185, 0.2149114, 0.4993694, 0.5191584, 0.3833552, 0.5002763, 0.7061465, -0.2567276, 0.9068756, -0.5197366, 0.3467845, 0.03668867, 0.9734009, -0.5347553, 0.66747, -0.9028882, 0.1023768, -0.8967977, 0.412834, -0.5821944, 0.0426479, -0.8032165, -0.2397038, -0.5597343, -0.6358021);
            this._distributions[28] = new Array(-0.6562496, -0.1781036, -0.9301494, 0.1185208, -0.3861143, -0.4153562, -0.1560799, -0.1099607, -0.5587025, 0.395218, -0.5322112, -0.699701, -0.5008639, 0.08726846, -0.970524, -0.1963461, -0.813577, -0.5185111, -0.1644458, 0.298, -0.3216791, 0.639982, 0.3315373, 0.3339162, 0.2383235, -0.00105722, 0.1137828, 0.5450742, -0.01899921, 0.8798413, 0.2849685, 0.8255596, 0.6974412, 0.2123175, 0.7588523, 0.5470437, 0.5102502, -0.1687844, 0.5853448, 0.8033476, 0.2590716, -0.5262504, 0.5607718, -0.6342825, 0.8666443, -0.1491841, 0.8341052, -0.4935003, -0.1568441, -0.6634066, 0.2512113, -0.8769391, -0.2559827, -0.9572457, -0.01928852, -0.3966542, -0.750667, 0.6409678);
            this._distributions[29] = new Array(0.3454786, -0.04837726, 0.2649553, 0.2406852, 0.5599093, -0.3839145, -0.1111814, -0.05502108, 0.7586042, -0.05818377, 0.2519488, -0.4665135, -0.1264972, 0.2602723, -0.08766216, -0.3671907, 0.6428129, 0.3999204, -0.6105871, -0.1246869, -0.4589451, -0.7646643, -0.03021116, -0.7899352, -0.6036922, -0.4293956, -0.2481938, 0.6534185, 0.102798, 0.6784465, -0.6392644, 0.4821358, -0.6789002, 0.1779133, -0.9140783, -0.1989647, -0.9262617, 0.3381507, 0.4794891, -0.8093274, 0.3959447, 0.668478, 0.9602883, 0.2272305, -0.123672, 0.9210883, 0.2375148, 0.9523395, -0.52898, 0.7973378, -0.382433, 0.1228794, 0.695015, 0.6948439, 0.7530277, -0.6458191, 0.8777987, -0.3272956, 0.2318525, -0.962768);
            this._distributions[30] = new Array(0.4518921, -0.1146195, 0.4720805, -0.4238748, 0.3655423, 0.1806341, 0.1589939, -0.23568, 0.7673324, -0.5149941, 0.01163658, 0.09045836, 0.7010971, 0.1245747, 0.7518286, -0.1855433, 0.4960719, 0.4601022, 0.2566979, -0.6308268, -0.0654714, -0.5126389, -0.1823319, -0.1343282, -0.1464312, 0.4883236, -0.3858738, 0.203523, 0.1484799, 0.4432284, -0.477109, -0.116241, 0.2719092, 0.7208626, 0.9104174, 0.3578536, -0.5956199, 0.7662588, -0.6996251, 0.3678654, -0.2514512, 0.9251933, 0.1275825, -0.9478135, -0.204608, -0.8611552, 0.4264838, -0.877443, 0.9854161, 0.05521112, 0.5912951, 0.7997434, 0.1140349, 0.982093, -0.9324368, -0.2094094, -0.42436, -0.6441524, -0.6722705, -0.3554261, -0.7844236, 0.08587621);
            this._distributions[31] = new Array(-0.4206714, -0.5613642, -0.8733016, -0.3373051, -0.1046226, -0.2902999, -0.1318562, -0.8434365, 0.1145093, -0.5962623, -0.4965627, -0.1873259, -0.5011808, -0.8546229, -0.7165636, -0.5743566, 0.1090901, 0.2017643, 0.3404809, -0.220455, -0.1989015, 0.2372122, -0.4538706, 0.0979171, 0.4514146, -0.572846, 0.2314168, -0.8514503, -0.4247236, 0.5650803, -0.943347, 0.04514639, -0.1309718, 0.5221877, -0.7004157, 0.4561877, 0.6306441, 0.04448673, 0.4301621, 0.5766876, 0.1078042, 0.7245752, 0.3875354, 0.2794483, 0.702876, -0.2924213, 0.7360667, -0.6210318, 0.7486517, 0.6531103, 0.4898235, 0.8591025, 0.6549174, 0.3854057, -0.2596106, 0.7916998, 0.9251194, -0.05296265, -0.5620695, 0.820877, -0.01228026, 0.9937211, 0.9612103, 0.2628758);
        };
        PoissonLookup.getDistribution = function (n /*int*/) {
            if (!this._distributions)
                this.initDistributions();
            if (n < 1 || n > 32)
                return null;
            return this._distributions[n - 1];
        };
        return PoissonLookup;
    }());

    /**
     * A Quaternion object which can be used to represent rotations.
     */
    var Quaternion = /** @class */ (function () {
        /**
         * Creates a new Quaternion object.
         * @param x The x value of the quaternion.
         * @param y The y value of the quaternion.
         * @param z The z value of the quaternion.
         * @param w The w value of the quaternion.
         */
        function Quaternion(x, y, z, w) {
            if (x === void 0) { x = 0; }
            if (y === void 0) { y = 0; }
            if (z === void 0) { z = 0; }
            if (w === void 0) { w = 1; }
            /**
             * The x value of the quaternion.
             */
            this.x = 0;
            /**
             * The y value of the quaternion.
             */
            this.y = 0;
            /**
             * The z value of the quaternion.
             */
            this.z = 0;
            /**
             * The w value of the quaternion.
             */
            this.w = 1;
            this.x = x;
            this.y = y;
            this.z = z;
            this.w = w;
        }
        Object.defineProperty(Quaternion.prototype, "magnitude", {
            /**
             * Returns the magnitude of the quaternion object.
             */
            get: function () {
                return Math.sqrt(this.w * this.w + this.x * this.x + this.y * this.y + this.z * this.z);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Fills the quaternion object with the result from a multiplication of two quaternion objects.
         *
         * @param    qa    The first quaternion in the multiplication.
         * @param    qb    The second quaternion in the multiplication.
         */
        Quaternion.prototype.multiply = function (qa, qb) {
            var w1 = qa.w, x1 = qa.x, y1 = qa.y, z1 = qa.z;
            var w2 = qb.w, x2 = qb.x, y2 = qb.y, z2 = qb.z;
            this.w = w1 * w2 - x1 * x2 - y1 * y2 - z1 * z2;
            this.x = w1 * x2 + x1 * w2 + y1 * z2 - z1 * y2;
            this.y = w1 * y2 - x1 * z2 + y1 * w2 + z1 * x2;
            this.z = w1 * z2 + x1 * y2 - y1 * x2 + z1 * w2;
        };
        Quaternion.prototype.multiplyVector = function (vector, target) {
            if (target === void 0) { target = null; }
            //target ||= new Quaternion();
            if (target === null) {
                target = new Quaternion();
            }
            var x2 = vector.x;
            var y2 = vector.y;
            var z2 = vector.z;
            target.w = -this.x * x2 - this.y * y2 - this.z * z2;
            target.x = this.w * x2 + this.y * z2 - this.z * y2;
            target.y = this.w * y2 - this.x * z2 + this.z * x2;
            target.z = this.w * z2 + this.x * y2 - this.y * x2;
            return target;
        };
        /**
         * Fills the quaternion object with values representing the given rotation around a vector.
         *
         * @param    axis    The axis around which to rotate
         * @param    angle    The angle in radians of the rotation.
         */
        Quaternion.prototype.fromAxisAngle = function (axis, angle) {
            var sin_a = Math.sin(angle / 2);
            var cos_a = Math.cos(angle / 2);
            this.x = axis.x * sin_a;
            this.y = axis.y * sin_a;
            this.z = axis.z * sin_a;
            this.w = cos_a;
            this.normalize();
        };
        /**
         * Spherically interpolates between two quaternions, providing an interpolation between rotations with constant angle change rate.
         * @param qa The first quaternion to interpolate.
         * @param qb The second quaternion to interpolate.
         * @param t The interpolation weight, a value between 0 and 1.
         */
        Quaternion.prototype.slerp = function (qa, qb, t) {
            var w1 = qa.w, x1 = qa.x, y1 = qa.y, z1 = qa.z;
            var w2 = qb.w, x2 = qb.x, y2 = qb.y, z2 = qb.z;
            var dot = w1 * w2 + x1 * x2 + y1 * y2 + z1 * z2;
            // shortest direction
            if (dot < 0) {
                dot = -dot;
                w2 = -w2;
                x2 = -x2;
                y2 = -y2;
                z2 = -z2;
            }
            if (dot < 0.95) {
                // interpolate angle linearly
                var angle = Math.acos(dot);
                var s = 1 / Math.sin(angle);
                var s1 = Math.sin(angle * (1 - t)) * s;
                var s2 = Math.sin(angle * t) * s;
                this.w = w1 * s1 + w2 * s2;
                this.x = x1 * s1 + x2 * s2;
                this.y = y1 * s1 + y2 * s2;
                this.z = z1 * s1 + z2 * s2;
            }
            else {
                // nearly identical angle, interpolate linearly
                this.w = w1 + t * (w2 - w1);
                this.x = x1 + t * (x2 - x1);
                this.y = y1 + t * (y2 - y1);
                this.z = z1 + t * (z2 - z1);
                var len = 1.0 / Math.sqrt(this.w * this.w + this.x * this.x + this.y * this.y + this.z * this.z);
                this.w *= len;
                this.x *= len;
                this.y *= len;
                this.z *= len;
            }
        };
        /**
         * Linearly interpolates between two quaternions.
         * @param qa The first quaternion to interpolate.
         * @param qb The second quaternion to interpolate.
         * @param t The interpolation weight, a value between 0 and 1.
         */
        Quaternion.prototype.lerp = function (qa, qb, t) {
            var w1 = qa.w, x1 = qa.x, y1 = qa.y, z1 = qa.z;
            var w2 = qb.w, x2 = qb.x, y2 = qb.y, z2 = qb.z;
            var len;
            // shortest direction
            if (w1 * w2 + x1 * x2 + y1 * y2 + z1 * z2 < 0) {
                w2 = -w2;
                x2 = -x2;
                y2 = -y2;
                z2 = -z2;
            }
            this.w = w1 + t * (w2 - w1);
            this.x = x1 + t * (x2 - x1);
            this.y = y1 + t * (y2 - y1);
            this.z = z1 + t * (z2 - z1);
            len = 1.0 / Math.sqrt(this.w * this.w + this.x * this.x + this.y * this.y + this.z * this.z);
            this.w *= len;
            this.x *= len;
            this.y *= len;
            this.z *= len;
        };
        /**
         * Fills the quaternion object with values representing the given euler rotation.
         *
         * @param    ax        The angle in radians of the rotation around the ax axis.
         * @param    ay        The angle in radians of the rotation around the ay axis.
         * @param    az        The angle in radians of the rotation around the az axis.
         */
        Quaternion.prototype.fromEulerAngles = function (ax, ay, az) {
            var halfX = ax * .5, halfY = ay * .5, halfZ = az * .5;
            var cosX = Math.cos(halfX), sinX = Math.sin(halfX);
            var cosY = Math.cos(halfY), sinY = Math.sin(halfY);
            var cosZ = Math.cos(halfZ), sinZ = Math.sin(halfZ);
            this.w = cosX * cosY * cosZ + sinX * sinY * sinZ;
            this.x = sinX * cosY * cosZ - cosX * sinY * sinZ;
            this.y = cosX * sinY * cosZ + sinX * cosY * sinZ;
            this.z = cosX * cosY * sinZ - sinX * sinY * cosZ;
        };
        /**
         * Fills a target Vector3D object with the Euler angles that form the rotation represented by this quaternion.
         * @param target An optional Vector3D object to contain the Euler angles. If not provided, a new object is created.
         * @return The Vector3D containing the Euler angles.
         */
        Quaternion.prototype.toEulerAngles = function (target) {
            if (target === void 0) { target = null; }
            //target ||= new Vector3D();
            if (target === null) {
                target = new Vector3D();
            }
            target.x = Math.atan2(2 * (this.w * this.x + this.y * this.z), 1 - 2 * (this.x * this.x + this.y * this.y));
            target.y = Math.asin(2 * (this.w * this.y - this.z * this.x));
            target.z = Math.atan2(2 * (this.w * this.z + this.x * this.y), 1 - 2 * (this.y * this.y + this.z * this.z));
            return target;
        };
        /**
         * Normalises the quaternion object.
         */
        Quaternion.prototype.normalize = function (val) {
            if (val === void 0) { val = 1; }
            var mag = val / Math.sqrt(this.x * this.x + this.y * this.y + this.z * this.z + this.w * this.w);
            this.x *= mag;
            this.y *= mag;
            this.z *= mag;
            this.w *= mag;
        };
        /**
         * Used to trace the values of a quaternion.
         *
         * @return A string representation of the quaternion object.
         */
        Quaternion.prototype.toString = function () {
            return "{x:" + this.x + " y:" + this.y + " z:" + this.z + " w:" + this.w + "}";
        };
        /**
         * Converts the quaternion to a Matrix3D object representing an equivalent rotation.
         * @param target An optional Matrix3D container to store the transformation in. If not provided, a new object is created.
         * @return A Matrix3D object representing an equivalent rotation.
         */
        Quaternion.prototype.toMatrix3D = function (target) {
            if (target === void 0) { target = null; }
            var xy2 = 2.0 * this.x * this.y, xz2 = 2.0 * this.x * this.z, xw2 = 2.0 * this.x * this.w;
            var yz2 = 2.0 * this.y * this.z, yw2 = 2.0 * this.y * this.w, zw2 = 2.0 * this.z * this.w;
            var xx = this.x * this.x, yy = this.y * this.y, zz = this.z * this.z, ww = this.w * this.w;
            if (!target)
                target = new Matrix3D();
            var rawData = target._rawData;
            rawData[0] = xx - yy - zz + ww;
            rawData[4] = xy2 - zw2;
            rawData[8] = xz2 + yw2;
            rawData[12] = 0;
            rawData[1] = xy2 + zw2;
            rawData[5] = -xx + yy - zz + ww;
            rawData[9] = yz2 - xw2;
            rawData[13] = 0;
            rawData[2] = xz2 - yw2;
            rawData[6] = yz2 + xw2;
            rawData[10] = -xx - yy + zz + ww;
            rawData[14] = 0;
            rawData[3] = 0.0;
            rawData[7] = 0.0;
            rawData[11] = 0;
            rawData[15] = 1;
            return target;
        };
        /**
         * Extracts a quaternion rotation matrix out of a given Matrix3D object.
         * @param matrix The Matrix3D out of which the rotation will be extracted.
         */
        Quaternion.prototype.fromMatrix = function (matrix) {
            var v = matrix.decompose(Orientation3D.QUATERNION)[1];
            this.x = v.x;
            this.y = v.y;
            this.z = v.z;
            this.w = v.w;
        };
        /**
         * Converts the quaternion to a Vector.&lt;Number&gt; matrix representation of a rotation equivalent to this quaternion.
         * @param target The Vector.&lt;Number&gt; to contain the raw matrix data.
         * @param exclude4thRow If true, the last row will be omitted, and a 4x3 matrix will be generated instead of a 4x4.
         */
        Quaternion.prototype.toRawData = function (target, exclude4thRow) {
            if (exclude4thRow === void 0) { exclude4thRow = false; }
            var xy2 = 2.0 * this.x * this.y, xz2 = 2.0 * this.x * this.z, xw2 = 2.0 * this.x * this.w;
            var yz2 = 2.0 * this.y * this.z, yw2 = 2.0 * this.y * this.w, zw2 = 2.0 * this.z * this.w;
            var xx = this.x * this.x, yy = this.y * this.y, zz = this.z * this.z, ww = this.w * this.w;
            target[0] = xx - yy - zz + ww;
            target[1] = xy2 - zw2;
            target[2] = xz2 + yw2;
            target[4] = xy2 + zw2;
            target[5] = -xx + yy - zz + ww;
            target[6] = yz2 - xw2;
            target[8] = xz2 - yw2;
            target[9] = yz2 + xw2;
            target[10] = -xx - yy + zz + ww;
            target[3] = target[7] = target[11] = 0;
            if (!exclude4thRow) {
                target[12] = target[13] = target[14] = 0;
                target[15] = 1;
            }
        };
        /**
         * Clones the quaternion.
         * @return An exact duplicate of the current Quaternion.
         */
        Quaternion.prototype.clone = function () {
            return new Quaternion(this.x, this.y, this.z, this.w);
        };
        /**
         * Rotates a point.
         * @param vector The Vector3D object to be rotated.
         * @param target An optional Vector3D object that will contain the rotated coordinates. If not provided, a new object will be created.
         * @return A Vector3D object containing the rotated point.
         */
        Quaternion.prototype.rotatePoint = function (vector, target) {
            if (target === void 0) { target = null; }
            var x1, y1, z1, w1;
            var x2 = vector.x, y2 = vector.y, z2 = vector.z;
            //target ||= new Vector3D();
            if (target === null) {
                target = new Vector3D();
            }
            // p*q'
            w1 = -this.x * x2 - this.y * y2 - this.z * z2;
            x1 = this.w * x2 + this.y * z2 - this.z * y2;
            y1 = this.w * y2 - this.x * z2 + this.z * x2;
            z1 = this.w * z2 + this.x * y2 - this.y * x2;
            target.x = -w1 * this.x + x1 * this.w - y1 * this.z + z1 * this.y;
            target.y = -w1 * this.y + x1 * this.z + y1 * this.w - z1 * this.x;
            target.z = -w1 * this.z - x1 * this.y + y1 * this.x + z1 * this.w;
            return target;
        };
        /**
         * Copies the data from a quaternion into this instance.
         * @param q The quaternion to copy from.
         */
        Quaternion.prototype.copyFrom = function (q) {
            this.x = q.x;
            this.y = q.y;
            this.z = q.z;
            this.w = q.w;
        };
        return Quaternion;
    }());

    /**
     * A Rectangle object is an area defined by its position, as indicated by its
     * top-left corner point(<i>x</i>, <i>y</i>) and by its width and its height.
     *
     *
     * <p>The <code>x</code>, <code>y</code>, <code>width</code>, and
     * <code>height</code> properties of the Rectangle export class are independent of
     * each other; changing the value of one property has no effect on the others.
     * However, the <code>right</code> and <code>bottom</code> properties are
     * integrally related to those four properties. For example, if you change the
     * value of the <code>right</code> property, the value of the
     * <code>width</code> property changes; if you change the <code>bottom</code>
     * property, the value of the <code>height</code> property changes. </p>
     *
     * <p>The following methods and properties use Rectangle objects:</p>
     *
     * <ul>
     *   <li>The <code>applyFilter()</code>, <code>colorTransform()</code>,
     * <code>copyChannel()</code>, <code>copyPixels()</code>, <code>draw()</code>,
     * <code>fillRect()</code>, <code>generateFilterRect()</code>,
     * <code>getColorBoundsRect()</code>, <code>getPixels()</code>,
     * <code>merge()</code>, <code>paletteMap()</code>,
     * <code>pixelDisolve()</code>, <code>setPixels()</code>, and
     * <code>threshold()</code> methods, and the <code>rect</code> property of the
     * BitmapData class</li>
     *   <li>The <code>getBounds()</code> and <code>getRect()</code> methods, and
     * the <code>scrollRect</code> and <code>scale9Grid</code> properties of the
     * DisplayObject class</li>
     *   <li>The <code>getCharBoundaries()</code> method of the TextField
     * class</li>
     *   <li>The <code>pixelBounds</code> property of the Transform class</li>
     *   <li>The <code>bounds</code> parameter for the <code>startDrag()</code>
     * method of the Sprite class</li>
     *   <li>The <code>printArea</code> parameter of the <code>addPage()</code>
     * method of the PrintJob class</li>
     * </ul>
     *
     * <p>You can use the <code>new Rectangle()</code> constructor to create a
     * Rectangle object.</p>
     *
     * <p><b>Note:</b> The Rectangle export class does not define a rectangular Shape
     * display object. To draw a rectangular Shape object onscreen, use the
     * <code>drawRect()</code> method of the Graphics class.</p>
     */
    var Rectangle = /** @class */ (function () {
        /**
         * Creates a new Rectangle object with the top-left corner specified by the
         * <code>x</code> and <code>y</code> parameters and with the specified
         * <code>width</code> and <code>height</code> parameters. If you call this
         * public without parameters, a rectangle with <code>x</code>,
         * <code>y</code>, <code>width</code>, and <code>height</code> properties set
         * to 0 is created.
         *
         * @param x      The <i>x</i> coordinate of the top-left corner of the
         *               rectangle.
         * @param y      The <i>y</i> coordinate of the top-left corner of the
         *               rectangle.
         * @param width  The width of the rectangle, in pixels.
         * @param height The height of the rectangle, in pixels.
         */
        function Rectangle(x, y, width, height) {
            if (x === void 0) { x = 0; }
            if (y === void 0) { y = 0; }
            if (width === void 0) { width = 0; }
            if (height === void 0) { height = 0; }
            this._rawData = new Float32Array(4);
            var raw = this._rawData;
            raw[0] = x;
            raw[1] = y;
            raw[2] = width;
            raw[3] = height;
        }
        //for AVM1:
        // for AVM1:
        Rectangle.prototype.axCallPublicProperty = function (value1, value2) {
            return null;
        };
        Rectangle.prototype.axGetPublicProperty = function (value) {
            return null;
        };
        Rectangle.prototype.axSetPublicProperty = function (value) {
            return null;
        };
        Object.defineProperty(Rectangle.prototype, "height", {
            /**
             * The height of the rectangle, in pixels. Changing the <code>height</code>
             * value of a Rectangle object has no effect on the <code>x</code>,
             * <code>y</code>, and <code>width</code> properties.
             */
            get: function () {
                return this._rawData[3];
            },
            set: function (value) {
                this._rawData[3] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle.prototype, "width", {
            /**
             * The width of the rectangle, in pixels. Changing the <code>width</code>
             * value of a Rectangle object has no effect on the <code>x</code>,
             * <code>y</code>, and <code>height</code> properties.
             */
            get: function () {
                return this._rawData[2];
            },
            set: function (value) {
                this._rawData[2] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle.prototype, "x", {
            /**
             * The <i>x</i> coordinate of the top-left corner of the rectangle. Changing
             * the value of the <code>x</code> property of a Rectangle object has no
             * effect on the <code>y</code>, <code>width</code>, and <code>height</code>
             * properties.
             *
             * <p>The value of the <code>x</code> property is equal to the value of the
             * <code>left</code> property.</p>
             */
            get: function () {
                return this._rawData[0];
            },
            set: function (value) {
                this._rawData[0] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle.prototype, "y", {
            /**
             * The <i>y</i> coordinate of the top-left corner of the rectangle. Changing
             * the value of the <code>y</code> property of a Rectangle object has no
             * effect on the <code>x</code>, <code>width</code>, and <code>height</code>
             * properties.
             *
             * <p>The value of the <code>y</code> property is equal to the value of the
             * <code>top</code> property.</p>
             */
            get: function () {
                return this._rawData[1];
            },
            set: function (value) {
                this._rawData[1] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle.prototype, "bottom", {
            /**
             * The sum of the <code>y</code> and <code>height</code> properties.
             */
            get: function () {
                return this._rawData[1] + this._rawData[3];
            },
            set: function (val) {
                this._rawData[3] = val - this._rawData[1];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle.prototype, "bottomRight", {
            /**
             * The location of the Rectangle object's bottom-right corner, determined by
             * the values of the <code>right</code> and <code>bottom</code> properties.
             */
            get: function () {
                if (this._bottomRight == null)
                    this._bottomRight = new Point();
                this._bottomRight._rawData[0] = this._rawData[0] + this._rawData[2];
                this._bottomRight._rawData[1] = this._rawData[1] + this._rawData[3];
                return this._bottomRight;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle.prototype, "left", {
            /**
             * The <i>x</i> coordinate of the top-left corner of the rectangle. Changing
             * the <code>left</code> property of a Rectangle object has no effect on the
             * <code>y</code> and <code>height</code> properties. However it does affect
             * the <code>width</code> property, whereas changing the <code>x</code> value
             * does <i>not</i> affect the <code>width</code> property.
             *
             * <p>The value of the <code>left</code> property is equal to the value of
             * the <code>x</code> property.</p>
             */
            get: function () {
                return this._rawData[0];
            },
            set: function (val) {
                this._rawData[2] += this._rawData[0] - val;
                this._rawData[0] = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle.prototype, "right", {
            /**
             * The sum of the <code>x</code> and <code>width</code> properties.
             */
            get: function () {
                return this._rawData[0] + this._rawData[2];
            },
            set: function (val) {
                this._rawData[2] = val - this._rawData[0];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle.prototype, "size", {
            /**
             * The size of the Rectangle object, expressed as a Point object with the
             * values of the <code>width</code> and <code>height</code> properties.
             */
            get: function () {
                if (this._size == null)
                    this._size = new Point();
                this._size._rawData[0] = this._rawData[2];
                this._size._rawData[1] = this._rawData[3];
                return this._size;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle.prototype, "top", {
            /**
             * The <i>y</i> coordinate of the top-left corner of the rectangle. Changing
             * the <code>top</code> property of a Rectangle object has no effect on the
             * <code>x</code> and <code>width</code> properties. However it does affect
             * the <code>height</code> property, whereas changing the <code>y</code>
             * value does <i>not</i> affect the <code>height</code> property.
             *
             * <p>The value of the <code>top</code> property is equal to the value of the
             * <code>y</code> property.</p>
             */
            get: function () {
                return this._rawData[1];
            },
            set: function (val) {
                this._rawData[3] += (this._rawData[1] - val);
                this._rawData[1] = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle.prototype, "topLeft", {
            /**
             * The location of the Rectangle object's top-left corner, determined by the
             * <i>x</i> and <i>y</i> coordinates of the point.
             */
            get: function () {
                if (this._topLeft == null)
                    this._topLeft = new Point();
                this._topLeft._rawData[0] = this._rawData[0];
                this._topLeft._rawData[1] = this._rawData[1];
                return this._topLeft;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns a new Rectangle object with the same values for the
         * <code>x</code>, <code>y</code>, <code>width</code>, and
         * <code>height</code> properties as the original Rectangle object.
         *
         * @return A new Rectangle object with the same values for the
         *         <code>x</code>, <code>y</code>, <code>width</code>, and
         *         <code>height</code> properties as the original Rectangle object.
         */
        Rectangle.prototype.clone = function () {
            var raw = this._rawData;
            return new Rectangle(raw[0], raw[1], raw[2], raw[3]);
        };
        /**
         * Determines whether the specified point is contained within the rectangular
         * region defined by this Rectangle object.
         *
         * @param x The <i>x</i> coordinate(horizontal position) of the point.
         * @param y The <i>y</i> coordinate(vertical position) of the point.
         * @return A value of <code>true</code> if the Rectangle object contains the
         *         specified point; otherwise <code>false</code>.
         */
        Rectangle.prototype.contains = function (x, y) {
            var raw = this._rawData;
            return (raw[0] <= x && raw[0] + raw[2] >= x && raw[1] <= y && raw[1] + raw[3] >= y);
        };
        /**
         * Determines whether the specified point is contained within the rectangular
         * region defined by this Rectangle object. This method is similar to the
         * <code>Rectangle.contains()</code> method, except that it takes a Point
         * object as a parameter.
         *
         * @param point The point, as represented by its <i>x</i> and <i>y</i>
         *              coordinates.
         * @return A value of <code>true</code> if the Rectangle object contains the
         *         specified point; otherwise <code>false</code>.
         */
        Rectangle.prototype.containsPoint = function (point) {
            var raw = this._rawData;
            var rawPoint = point._rawData;
            return (raw[0] <= rawPoint[0] && raw[0] + raw[2] >= rawPoint[0] && raw[1] <= rawPoint[1] && raw[1] + raw[3] >= rawPoint[1]);
        };
        /**
         * Determines whether the Rectangle object specified by the <code>rect</code>
         * parameter is contained within this Rectangle object. A Rectangle object is
         * said to contain another if the second Rectangle object falls entirely
         * within the boundaries of the first.
         *
         * @param rect The Rectangle object being checked.
         * @return A value of <code>true</code> if the Rectangle object that you
         *         specify is contained by this Rectangle object; otherwise
         *         <code>false</code>.
         */
        Rectangle.prototype.containsRect = function (rect) {
            var raw = this._rawData;
            var rawRect = rect._rawData;
            return (raw[0] <= rawRect[0] && raw[0] + raw[2] >= rawRect[0] + rawRect[2] && raw[1] <= rawRect[1] && raw[1] + raw[3] >= rawRect[1] + rawRect[3]);
        };
        /**
         * Copies all of rectangle data from the source Rectangle object into the
         * calling Rectangle object.
         *
         * @param sourceRect The Rectangle object from which to copy the data.
         */
        Rectangle.prototype.copyFrom = function (sourceRect) {
            var raw = this._rawData;
            var rawSource = sourceRect._rawData;
            raw[0] = rawSource[0];
            raw[1] = rawSource[1];
            raw[2] = rawSource[2];
            raw[3] = rawSource[3];
        };
        /**
         * Determines whether the object specified in the <code>toCompare</code>
         * parameter is equal to this Rectangle object. This method compares the
         * <code>x</code>, <code>y</code>, <code>width</code>, and
         * <code>height</code> properties of an object against the same properties of
         * this Rectangle object.
         *
         * @param toCompare The rectangle to compare to this Rectangle object.
         * @return A value of <code>true</code> if the object has exactly the same
         *         values for the <code>x</code>, <code>y</code>, <code>width</code>,
         *         and <code>height</code> properties as this Rectangle object;
         *         otherwise <code>false</code>.
         */
        Rectangle.prototype.equals = function (toCompare) {
            var raw = this._rawData;
            var rawCompare = toCompare._rawData;
            return (raw[0] == rawCompare[0] && raw[1] == rawCompare[1] && raw[2] == rawCompare[2] && raw[3] == rawCompare[3]);
        };
        /**
         * Increases the size of the Rectangle object by the specified amounts, in
         * pixels. The center point of the Rectangle object stays the same, and its
         * size increases to the left and right by the <code>dx</code> value, and to
         * the top and the bottom by the <code>dy</code> value.
         *
         * @param dx The value to be added to the left and the right of the Rectangle
         *           object. The following equation is used to calculate the new
         *           width and position of the rectangle:
         * @param dy The value to be added to the top and the bottom of the
         *           Rectangle. The following equation is used to calculate the new
         *           height and position of the rectangle:
         */
        Rectangle.prototype.inflate = function (dx, dy) {
            var raw = this._rawData;
            raw[0] -= dx / 2;
            raw[1] -= dy / 2;
            raw[2] += dx / 2;
            raw[3] += dy / 2;
        };
        /**
         * Increases the size of the Rectangle object. This method is similar to the
         * <code>Rectangle.inflate()</code> method except it takes a Point object as
         * a parameter.
         *
         * <p>The following two code examples give the same result:</p>
         *
         * @param point The <code>x</code> property of this Point object is used to
         *              increase the horizontal dimension of the Rectangle object.
         *              The <code>y</code> property is used to increase the vertical
         *              dimension of the Rectangle object.
         */
        Rectangle.prototype.inflatePoint = function (point) {
            var raw = this._rawData;
            raw[0] -= point.x / 2;
            raw[1] -= point.y / 2;
            raw[2] += point.x / 2;
            raw[3] += point.y / 2;
        };
        /**
         * If the Rectangle object specified in the <code>toIntersect</code>
         * parameter intersects with this Rectangle object, returns the area of
         * intersection as a Rectangle object. If the rectangles do not intersect,
         * this method returns an empty Rectangle object with its properties set to
         * 0.
         *
         * @param toIntersect The Rectangle object to compare against to see if it
         *                    intersects with this Rectangle object.
         * @return A Rectangle object that equals the area of intersection. If the
         *         rectangles do not intersect, this method returns an empty
         *         Rectangle object; that is, a rectangle with its <code>x</code>,
         *         <code>y</code>, <code>width</code>, and <code>height</code>
         *         properties set to 0.
         */
        Rectangle.prototype.intersection = function (toIntersect) {
            var raw = this._rawData;
            var rawIntersect = toIntersect._rawData;
            if (this.intersects(toIntersect)) {
                var result = new Rectangle();
                var rawResult = result._rawData;
                if (raw[0] > rawIntersect[0]) {
                    rawResult[0] = raw[0];
                    rawResult[2] = rawIntersect[0] - raw[0] + rawIntersect[2];
                    if (rawResult[2] > raw[2])
                        rawResult[2] = raw[2];
                }
                else {
                    rawResult[0] = rawIntersect[0];
                    rawResult[2] = raw[0] - rawIntersect[0] + raw[2];
                    if (rawResult[2] > rawIntersect[2])
                        rawResult[2] = rawIntersect[2];
                }
                if (raw[1] > rawIntersect[1]) {
                    rawResult[1] = raw[1];
                    rawResult[3] = rawIntersect[1] - raw[1] + rawIntersect[3];
                    if (rawResult[3] > raw[3])
                        rawResult[3] = raw[3];
                }
                else {
                    rawResult[1] = rawIntersect[1];
                    rawResult[3] = raw[1] - rawIntersect[1] + raw[3];
                    if (rawResult[3] > rawIntersect[3])
                        rawResult[3] = rawIntersect[3];
                }
                return result;
            }
            return new Rectangle();
        };
        /**
         * Determines whether the object specified in the <code>toIntersect</code>
         * parameter intersects with this Rectangle object. This method checks the
         * <code>x</code>, <code>y</code>, <code>width</code>, and
         * <code>height</code> properties of the specified Rectangle object to see if
         * it intersects with this Rectangle object.
         *
         * @param toIntersect The Rectangle object to compare against this Rectangle
         *                    object.
         * @return A value of <code>true</code> if the specified object intersects
         *         with this Rectangle object; otherwise <code>false</code>.
         */
        Rectangle.prototype.intersects = function (toIntersect) {
            var raw = this._rawData;
            var rawIntersect = toIntersect._rawData;
            return (raw[0] + raw[2] > rawIntersect[0] && raw[0] < rawIntersect[0] + rawIntersect[2] && raw[1] + raw[3] > rawIntersect[1] && raw[1] < rawIntersect[1] + rawIntersect[3]);
        };
        /**
         * Determines whether or not this Rectangle object is empty.
         *
         * @return A value of <code>true</code> if the Rectangle object's width or
         *         height is less than or equal to 0; otherwise <code>false</code>.
         */
        Rectangle.prototype.isEmpty = function () {
            var raw = this._rawData;
            return (raw[0] == 0 && raw[1] == 0 && raw[2] == 0 && raw[3] == 0);
        };
        /**
         * Adjusts the location of the Rectangle object, as determined by its
         * top-left corner, by the specified amounts.
         *
         * @param dx Moves the <i>x</i> value of the Rectangle object by this amount.
         * @param dy Moves the <i>y</i> value of the Rectangle object by this amount.
         */
        Rectangle.prototype.offset = function (dx, dy) {
            this._rawData[0] += dx;
            this._rawData[1] += dy;
        };
        /**
         * Adjusts the location of the Rectangle object using a Point object as a
         * parameter. This method is similar to the <code>Rectangle.offset()</code>
         * method, except that it takes a Point object as a parameter.
         *
         * @param point A Point object to use to offset this Rectangle object.
         */
        Rectangle.prototype.offsetPoint = function (point) {
            this._rawData[0] += point.x;
            this._rawData[1] += point.y;
        };
        /**
         * Sets all of the Rectangle object's properties to 0. A Rectangle object is
         * empty if its width or height is less than or equal to 0.
         *
         * <p> This method sets the values of the <code>x</code>, <code>y</code>,
         * <code>width</code>, and <code>height</code> properties to 0.</p>
         *
         */
        Rectangle.prototype.setEmpty = function () {
            var raw = this._rawData;
            raw[0] = 0;
            raw[1] = 0;
            raw[2] = 0;
            raw[3] = 0;
        };
        /**
         * Sets the members of Rectangle to the specified values
         *
         * @param xa      The <i>x</i> coordinate of the top-left corner of the
         *                rectangle.
         * @param ya      The <i>y</i> coordinate of the top-left corner of the
         *                rectangle.
         * @param widtha  The width of the rectangle, in pixels.
         * @param heighta The height of the rectangle, in pixels.
         */
        Rectangle.prototype.setTo = function (xa, ya, widtha, heighta) {
            var raw = this._rawData;
            raw[0] = xa;
            raw[1] = ya;
            raw[2] = widtha;
            raw[3] = heighta;
        };
        /**
         * Builds and returns a string that lists the horizontal and vertical
         * positions and the width and height of the Rectangle object.
         *
         * @return A string listing the value of each of the following properties of
         *         the Rectangle object: <code>x</code>, <code>y</code>,
         *         <code>width</code>, and <code>height</code>.
         */
        Rectangle.prototype.toString = function () {
            return "[Rectangle] (x=" + this.x + ", y=" + this.y + ", width=" + this.width + ", height=" + this.height + ")";
        };
        /**
         * Adds two rectangles together to create a new Rectangle object, by filling
         * in the horizontal and vertical space between the two rectangles.
         *
         * <p><b>Note:</b> The <code>union()</code> method ignores rectangles with
         * <code>0</code> as the height or width value, such as: <code>var
         * rect2:Rectangle = new Rectangle(300,300,50,0);</code></p>
         *
         * @param toUnion A Rectangle object to add to this Rectangle object.
         * @return A new Rectangle object that is the union of the two rectangles.
         */
        Rectangle.prototype.union = function (toUnion) {
            var raw = this._rawData;
            var rawUnion = toUnion._rawData;
            var target = new Rectangle();
            var rawTarget = target._rawData;
            if (raw[0] < rawUnion[0]) {
                rawTarget[0] = raw[0];
                rawTarget[2] = rawUnion[0] - raw[0] + rawUnion[2];
                if (rawTarget[2] < raw[2])
                    rawTarget[2] = raw[2];
            }
            else {
                rawTarget[0] = rawUnion[0];
                rawTarget[2] = raw[0] - rawUnion[0] + raw[2];
                if (rawTarget[2] < rawUnion[2])
                    rawTarget[2] = rawUnion[2];
            }
            if (raw[1] < rawUnion[1]) {
                rawTarget[1] = raw[1];
                rawTarget[3] = rawUnion[1] - raw[1] + rawUnion[3];
                if (rawTarget[3] < raw[3])
                    rawTarget[3] = raw[3];
            }
            else {
                rawTarget[1] = rawUnion[1];
                rawTarget[3] = raw[1] - rawUnion[1] + raw[3];
                if (rawTarget[3] < rawUnion[3])
                    rawTarget[3] = rawUnion[3];
            }
            return target;
        };
        return Rectangle;
    }());

    /**
     *
     * @export class away.pool.AbstractionBase
     */
    var AbstractionBase = /** @class */ (function (_super) {
        __extends$1(AbstractionBase, _super);
        function AbstractionBase(asset, pool) {
            var _this = _super.call(this) || this;
            _this._invalid = true;
            _this._asset = asset;
            _this._pool = pool;
            _this._onClearDelegate = function (event) { return _this.onClear(event); };
            _this._onInvalidateDelegate = function (event) { return _this.onInvalidate(event); };
            if (_this._asset) {
                _this._asset.addEventListener(AssetEvent.CLEAR, _this._onClearDelegate);
                _this._asset.addEventListener(AssetEvent.INVALIDATE, _this._onInvalidateDelegate);
            }
            return _this;
        }
        /**
         *
         */
        AbstractionBase.prototype.onClear = function (event) {
            if (this._asset) {
                this._asset.removeEventListener(AssetEvent.CLEAR, this._onClearDelegate);
                this._asset.removeEventListener(AssetEvent.INVALIDATE, this._onInvalidateDelegate);
            }
            this._pool.clearAbstraction(this._asset);
            this._pool = null;
            this._asset = null;
        };
        /**
         *
         */
        AbstractionBase.prototype.onInvalidate = function (event) {
            this._invalid = true;
        };
        return AbstractionBase;
    }(EventDispatcher));

    var AssetLibraryIterator = /** @class */ (function () {
        function AssetLibraryIterator(assets, assetTypeFilter, namespaceFilter, filterFunc) {
            this._assets = assets;
            this.filter(assetTypeFilter, namespaceFilter, filterFunc);
        }
        Object.defineProperty(AssetLibraryIterator.prototype, "currentAsset", {
            get: function () {
                // Return current, or null if no current
                return (this._idx < this._filtered.length) ? this._filtered[this._idx] : null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AssetLibraryIterator.prototype, "numAssets", {
            get: function () {
                return this._filtered.length;
            },
            enumerable: true,
            configurable: true
        });
        AssetLibraryIterator.prototype.next = function () {
            var next = null;
            if (this._idx < this._filtered.length)
                next = this._filtered[this._idx];
            this._idx++;
            return next;
        };
        AssetLibraryIterator.prototype.reset = function () {
            this._idx = 0;
        };
        AssetLibraryIterator.prototype.setIndex = function (index) {
            this._idx = index;
        };
        AssetLibraryIterator.prototype.filter = function (assetTypeFilter, namespaceFilter, filterFunc) {
            if (assetTypeFilter || namespaceFilter) {
                var idx;
                var asset;
                idx = 0;
                this._filtered = new Array(); //new Vector.<IAsset>;
                var l = this._assets.length;
                for (var c = 0; c < l; c++) {
                    asset = this._assets[c];
                    // Skip this assets if filtering on type and this is wrong type
                    if (assetTypeFilter && asset.adaptee.assetType != assetTypeFilter)
                        continue;
                    // Skip this asset if filtering on namespace and this is wrong namespace
                    if (namespaceFilter && asset.adaptee.assetNamespace != namespaceFilter)
                        continue;
                    // Skip this asset if a filter func has been provided and it returns false
                    if (filterFunc != null && !filterFunc(asset))
                        continue;
                    this._filtered[idx++] = asset;
                }
                /*
                 for each (asset in _assets) {
                 // Skip this assets if filtering on type and this is wrong type
                 if (assetTypeFilter && asset.assetType != assetTypeFilter)
                 continue;

                 // Skip this asset if filtering on namespace and this is wrong namespace
                 if (namespaceFilter && asset.assetNamespace != namespaceFilter)
                 continue;

                 // Skip this asset if a filter func has been provided and it returns false
                 if (filterFunc != null && !filterFunc(asset))
                 continue;

                 _filtered[idx++] = asset;
                 }
                 */
            }
            else {
                this._filtered = this._assets;
            }
        };
        return AssetLibraryIterator;
    }());

    var LoaderContext = /** @class */ (function () {
        /**
         * LoaderContext provides configuration for the Loader load() and parse() operations.
         * Use it to configure how (and if) dependencies are loaded, or to map dependency URLs to
         * embedded data.
         *
         * @see away.loading.Loader
         */
        function LoaderContext(includeDependencies, dependencyBaseUrl) {
            if (includeDependencies === void 0) { includeDependencies = true; }
            if (dependencyBaseUrl === void 0) { dependencyBaseUrl = null; }
            this._includeDependencies = includeDependencies;
            this._dependencyBaseUrl = dependencyBaseUrl || '';
            this._embeddedDataByUrl = {};
            this._remappedUrls = {};
            this._materialMode = LoaderContext.UNDEFINED;
            this._externalAssetMode = LoaderContext.PRELOADED;
        }
        Object.defineProperty(LoaderContext.prototype, "includeDependencies", {
            /**
             * Defines whether dependencies (all files except the one at the URL given to the load() or
             * parseData() operations) should be automatically loaded. Defaults to true.
             */
            get: function () {
                return this._includeDependencies;
            },
            set: function (val) {
                this._includeDependencies = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderContext.prototype, "materialMode", {
            /**
             * MaterialMode defines, if the Parser should create SinglePass or MultiPass Materials
             * Options:
             * 0 (Default / undefined) - All Parsers will create SinglePassMaterials, but the AWD2.1parser will create Materials as they are defined in the file
             * 1 (Force SinglePass) - All Parsers create SinglePassMaterials
             * 2 (Force MultiPass) - All Parsers will create MultiPassMaterials
             *
             */
            get: function () {
                return this._materialMode;
            },
            set: function (value) {
                this._materialMode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderContext.prototype, "externalAssetMode", {
            get: function () {
                return this._externalAssetMode;
            },
            set: function (value) {
                this._externalAssetMode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderContext.prototype, "dependencyBaseUrl", {
            /**
             * A base URL that will be prepended to all relative dependency URLs found in a loaded resource.
             * Absolute paths will not be affected by the value of this property.
             */
            get: function () {
                return this._dependencyBaseUrl;
            },
            set: function (val) {
                this._dependencyBaseUrl = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderContext.prototype, "overrideAbsolutePaths", {
            /**
             * Defines whether absolute paths (defined as paths that begin with a "/") should be overridden
             * with the dependencyBaseUrl defined in this context. If this is true, and the base path is
             * "base", /path/to/asset.jpg will be resolved as base/path/to/asset.jpg.
             */
            get: function () {
                return this._overrideAbsPath;
            },
            set: function (val) {
                this._overrideAbsPath = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderContext.prototype, "overrideFullURLs", {
            /**
             * Defines whether "full" URLs (defined as a URL that includes a scheme, e.g. http://) should be
             * overridden with the dependencyBaseUrl defined in this context. If this is true, and the base
             * path is "base", http://example.com/path/to/asset.jpg will be resolved as base/path/to/asset.jpg.
             */
            get: function () {
                return this._overrideFullUrls;
            },
            set: function (val) {
                this._overrideFullUrls = val;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Map a URL to another URL, so that files that are referred to by the original URL will instead
         * be loaded from the new URL. Use this when your file structure does not match the one that is
         * expected by the loaded file.
         *
         * @param originalUrl The original URL which is referenced in the loaded resource.
         * @param newUrl The URL from which away.should load the resource instead.
         *
         * @see mapUrlToData()
         */
        LoaderContext.prototype.mapUrl = function (originalUrl, newUrl) {
            this._remappedUrls[originalUrl] = newUrl;
        };
        /**
         * Map a URL to embedded data, so that instead of trying to load a dependency from the URL at
         * which it's referenced, the dependency data will be retrieved straight from the memory instead.
         *
         * @param originalUrl The original URL which is referenced in the loaded resource.
         * @param data The embedded data. Can be ByteArray or a export class which can be used to create a bytearray.
         */
        LoaderContext.prototype.mapUrlToData = function (originalUrl, data) {
            this._embeddedDataByUrl[originalUrl] = data;
        };
        /**
         * @private
         * Defines whether embedded data has been mapped to a particular URL.
         */
        LoaderContext.prototype._iHasDataForUrl = function (url) {
            return this._embeddedDataByUrl.hasOwnProperty(url);
        };
        /**
         * @private
         * Returns embedded data for a particular URL.
         */
        LoaderContext.prototype._iGetDataForUrl = function (url) {
            return this._embeddedDataByUrl[url];
        };
        /**
         * @private
         * Defines whether a replacement URL has been mapped to a particular URL.
         */
        LoaderContext.prototype._iHasMappingForUrl = function (url) {
            return this._remappedUrls.hasOwnProperty(url);
        };
        /**
         * @private
         * Returns new (replacement) URL for a particular original URL.
         */
        LoaderContext.prototype._iGetRemappedUrl = function (originalUrl) {
            return this._remappedUrls[originalUrl];
        };
        LoaderContext.UNDEFINED = 0;
        LoaderContext.SINGLEPASS_MATERIALS = 1;
        LoaderContext.MULTIPASS_MATERIALS = 2;
        LoaderContext.ON_DEMAND = "onDemand";
        LoaderContext.PRELOADED = "preloaded";
        return LoaderContext;
    }());

    var URLLoaderDataFormat = /** @class */ (function () {
        function URLLoaderDataFormat() {
        }
        /**
         * TEXT
         * @type {string}
         */
        URLLoaderDataFormat.TEXT = "text";
        /**
         * Variables / Value Pairs
         * @type {string}
         */
        URLLoaderDataFormat.VARIABLES = "variables";
        /**
         *
         * @type {string}
         */
        URLLoaderDataFormat.BLOB = "blob";
        /**
         *
         * @type {string}
         */
        URLLoaderDataFormat.ARRAY_BUFFER = "arraybuffer";
        /**
         *
         * @type {string}
         */
        URLLoaderDataFormat.BINARY = "binary";
        return URLLoaderDataFormat;
    }());

    var URLRequestMethod = /** @class */ (function () {
        function URLRequestMethod() {
        }
        /**
         *
         * @type {string}
         */
        URLRequestMethod.POST = 'POST';
        /**
         *
         * @type {string}
         */
        URLRequestMethod.GET = 'GET';
        return URLRequestMethod;
    }());

    var URLVariables = /** @class */ (function () {
        /**
         *
         * @param source
         */
        function URLVariables(source) {
            if (source === void 0) { source = null; }
            this._variables = new Object();
            if (source !== null)
                this.decode(source);
        }
        /**
         *
         * @param source
         */
        URLVariables.prototype.decode = function (source) {
            source = source.split("+").join(" ");
            var tokens, re = /[?&]?([^=]+)=([^&]*)/g;
            while (tokens = re.exec(source))
                this._variables[decodeURIComponent(tokens[1])] = decodeURIComponent(tokens[2]);
        };
        /**
         *
         * @returns {string}
         */
        URLVariables.prototype.toString = function () {
            return '';
        };
        Object.defineProperty(URLVariables.prototype, "variables", {
            /**
             *
             * @returns {Object}
             */
            get: function () {
                return this._variables;
            },
            /**
             *
             * @returns {Object}
             */
            set: function (obj) {
                this._variables = obj;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(URLVariables.prototype, "formData", {
            /**
             *
             * @returns {Object}
             */
            get: function () {
                var fd = new FormData();
                for (var s in this._variables)
                    fd.append(s, this._variables[s]);
                return fd;
            },
            enumerable: true,
            configurable: true
        });
        return URLVariables;
    }());

    /**
     * The URLLoader is used to load a single file, as part of a resource.
     *
     * While URLLoader can be used directly, e.g. to create a third-party asset
     * management system, it's recommended to use any of the classes Loader3D, Loader
     * and AssetLibrary instead in most cases.
     *
     * @see Loader
     * @see away.library.AssetLibrary
     */
    var URLLoader = /** @class */ (function (_super) {
        __extends$1(URLLoader, _super);
        /**
         * Creates a new URLLoader object.
         */
        function URLLoader() {
            var _this = _super.call(this) || this;
            _this._bytesLoaded = 0;
            _this._bytesTotal = 0;
            _this._dataFormat = URLLoaderDataFormat.TEXT;
            _this._loadError = false;
            return _this;
        }
        Object.defineProperty(URLLoader.prototype, "url", {
            /**
             *
             */
            get: function () {
                return this._request ? this._request.url : '';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(URLLoader.prototype, "data", {
            /**
             *
             */
            get: function () {
                return this._data;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(URLLoader.prototype, "dataFormat", {
            get: function () {
                return this._dataFormat;
            },
            /**
             *
             * URLLoaderDataFormat.BINARY
             * URLLoaderDataFormat.TEXT
             * URLLoaderDataFormat.VARIABLES
             *
             * @param format
             */
            set: function (format) {
                this._dataFormat = format;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(URLLoader.prototype, "bytesLoaded", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                return this._bytesLoaded;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(URLLoader.prototype, "bytesTotal", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                return this._bytesTotal;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Load a resource from a file.
         *
         * @param request The URLRequest object containing the URL of the object to be loaded.
         */
        URLLoader.prototype.load = function (request) {
            this._request = request;
            this.initXHR();
            if (request.method === URLRequestMethod.POST)
                this.postRequest(request);
            else
                this.getRequest(request);
        };
        URLLoader.prototype.isSupported = function () {
            return window != null;
        };
        /**
         *
         */
        URLLoader.prototype.close = function () {
            this._XHR.abort();
            this.disposeXHR();
        };
        /**
         *
         */
        URLLoader.prototype.dispose = function () {
            if (this._XHR)
                this._XHR.abort();
            this.disposeXHR();
        };
        /**
         *
         * @param xhr
         * @param responseType
         */
        URLLoader.prototype.setResponseType = function (xhr, responseType) {
            switch (responseType) {
                case URLLoaderDataFormat.ARRAY_BUFFER:
                case URLLoaderDataFormat.BLOB:
                case URLLoaderDataFormat.TEXT:
                    xhr.responseType = responseType;
                    break;
                case URLLoaderDataFormat.VARIABLES:
                    xhr.responseType = URLLoaderDataFormat.TEXT;
                    break;
                case URLLoaderDataFormat.BINARY:
                    xhr.responseType = '';
                    break;
                default:
            }
        };
        /**
         *
         * @param request {URLRequest}
         */
        URLLoader.prototype.getRequest = function (request) {
            try {
                this._XHR.open(request.method, request.url, request.async);
                this.setResponseType(this._XHR, this._dataFormat);
                this._XHR.send(); // No data to send
            }
            catch (e /* <XMLHttpRequestException> */) {
                this.handleXmlHttpRequestException(e);
            }
        };
        /**
         *
         * @param request {URLRequest}
         */
        URLLoader.prototype.postRequest = function (request) {
            this._loadError = false;
            this._XHR.open(request.method, request.url, request.async);
            if (request.data != null) {
                if (request.data instanceof URLVariables) {
                    var urlVars = request.data;
                    try {
                        this._XHR.responseType = 'text';
                        this._XHR.send(urlVars.formData);
                    }
                    catch (e /* <XMLHttpRequestException> */) {
                        this.handleXmlHttpRequestException(e);
                    }
                }
                else {
                    this.setResponseType(this._XHR, this._dataFormat);
                    if (request.data)
                        this._XHR.send(request.data); // TODO: Test
                    else
                        this._XHR.send(); // no data to send
                }
            }
            else {
                this._XHR.send(); // No data to send
            }
        };
        /**
         *
         * @param error {XMLHttpRequestException}
         */
        URLLoader.prototype.handleXmlHttpRequestException = function (error /* <XMLHttpRequestException> */) {
            switch (error.code) {
                /******************************************************************************************************************************************************************************************************
                 *
                 *  XMLHttpRequestException { message: "NETWORK_ERR: XMLHttpRequest Exception 101", name: "NETWORK_ERR", code: 101, stack: "Error: A network error occurred in synchronous req…",NETWORK_ERR: 101… }
                 *  code: 101 , message: "NETWORK_ERR: XMLHttpRequest Exception 101" ,  name: "NETWORK_ERR"
                 *
                 ******************************************************************************************************************************************************************************************************/
                case 101:
                    // Note: onLoadError event throws IO_ERROR event - this case is already Covered
                    break;
            }
        };
        /**
         *
         */
        URLLoader.prototype.initXHR = function () {
            var _this = this;
            if (!this._XHR) {
                this._XHR = new XMLHttpRequest();
                this._XHR.onloadstart = function (event) { return _this.onLoadStart(event); }; // loadstart	        - When the request starts.
                this._XHR.onprogress = function (event) { return _this.onProgress(event); }; // progress	            - While loading and sending data.
                this._XHR.onabort = function (event) { return _this.onAbort(event); }; // abort	            - When the request has been aborted, either by invoking the abort() method or navigating away from the page.
                this._XHR.onerror = function (event) { return _this.onLoadError(event); }; // error	            - When the request has failed.
                this._XHR.onload = function (event) { return _this.onLoadComplete(event); }; // load	                - When the request has successfully completed.
                this._XHR.ontimeout = function (event) { return _this.onTimeOut(event); }; // timeout	            - When the author specified timeout has passed before the request could complete.
                this._XHR.onloadend = function (event) { return _this.onLoadEnd(event); }; // loadend	            - When the request has completed, regardless of whether or not it was successful.
                this._XHR.onreadystatechange = function (event) { return _this.onReadyStateChange(event); }; // onreadystatechange   - When XHR state changes
            }
        };
        /**
         *
         */
        URLLoader.prototype.disposeXHR = function () {
            if (this._XHR !== null) {
                this._XHR.onloadstart = null;
                this._XHR.onprogress = null;
                this._XHR.onabort = null;
                this._XHR.onerror = null;
                this._XHR.onload = null;
                this._XHR.ontimeout = null;
                this._XHR.onloadend = null;
                this._XHR = null;
            }
        };
        /**
         *
         * @param source
         */
        URLLoader.prototype.decodeURLVariables = function (source) {
            var result = new Object();
            source = source.split("+").join(" ");
            var tokens, re = /[?&]?([^=]+)=([^&]*)/g;
            while (tokens = re.exec(source))
                result[decodeURIComponent(tokens[1])] = decodeURIComponent(tokens[2]);
            return result;
        };
        // XMLHttpRequest - Event Handlers
        /**
         * When XHR state changes
         * @param event
         */
        URLLoader.prototype.onReadyStateChange = function (event) {
            if (this._XHR.readyState == 4) {
                this._status = this._XHR.status;
                if (this._status == 404) {
                    this._loadError = true;
                    this.dispatchEvent(this._loadErrorEvent || (this._loadErrorEvent = new URLLoaderEvent(URLLoaderEvent.LOAD_ERROR, this)));
                }
                this.dispatchEvent(this._statusEvent || (this._statusEvent = new URLLoaderEvent(URLLoaderEvent.HTTP_STATUS, this)));
            }
        };
        /**
         * When the request has completed, regardless of whether or not it was successful.
         * @param event
         */
        URLLoader.prototype.onLoadEnd = function (event) {
            if (this._loadError === true)
                return;
        };
        /**
         * When the author specified timeout has passed before the request could complete.
         * @param event
         */
        URLLoader.prototype.onTimeOut = function (event) {
            //TODO: Timeout not currently implemented ( also not part of AS3 API )
        };
        /**
         * When the request has been aborted, either by invoking the abort() method or navigating away from the page.
         * @param event
         */
        URLLoader.prototype.onAbort = function (event) {
            // TODO: investigate whether this needs to be an IOError
        };
        /**
         * While loading and sending data.
         * @param event
         */
        URLLoader.prototype.onProgress = function (event) {
            this._bytesTotal = event.total;
            this._bytesLoaded = event.loaded;
            this.dispatchEvent(this._progressEvent || (this._progressEvent = new URLLoaderEvent(URLLoaderEvent.LOAD_PROGRESS, this)));
        };
        /**
         * When the request starts.
         * @param event
         */
        URLLoader.prototype.onLoadStart = function (event) {
            this.dispatchEvent(this._loadStartEvent || (this._loadStartEvent = new URLLoaderEvent(URLLoaderEvent.LOAD_START, this)));
        };
        /**
         * When the request has successfully completed.
         * @param event
         */
        URLLoader.prototype.onLoadComplete = function (event) {
            if (this._loadError === true)
                return;
            switch (this._dataFormat) {
                case URLLoaderDataFormat.TEXT:
                    this._data = this._XHR.responseText;
                    break;
                case URLLoaderDataFormat.VARIABLES:
                    this._data = this.decodeURLVariables(this._XHR.responseText);
                    break;
                case URLLoaderDataFormat.BLOB:
                case URLLoaderDataFormat.ARRAY_BUFFER:
                case URLLoaderDataFormat.BINARY:
                    this._data = this._XHR.response;
                    break;
                default:
                    this._data = this._XHR.responseText;
                    break;
            }
            this.dispatchEvent(this._loadCompleteEvent || (this._loadCompleteEvent = new URLLoaderEvent(URLLoaderEvent.LOAD_COMPLETE, this)));
        };
        /**
         * When the request has failed. ( due to network issues ).
         * @param event
         */
        URLLoader.prototype.onLoadError = function (event) {
            this._loadError = true;
            this.dispatchEvent(this._loadErrorEvent || (this._loadErrorEvent = new URLLoaderEvent(URLLoaderEvent.LOAD_ERROR, this)));
        };
        return URLLoader;
    }(EventDispatcher));

    /**
     * ResourceDependency represents the data required to load, parse and resolve additional files ("dependencies")
     * required by a parser, used by ResourceLoadSession.
     *
     */
    var ResourceDependency = /** @class */ (function () {
        function ResourceDependency(id, request, data, parser, parentParser, retrieveAsRawData, suppressAssetEvents, sub_id) {
            if (retrieveAsRawData === void 0) { retrieveAsRawData = false; }
            if (suppressAssetEvents === void 0) { suppressAssetEvents = false; }
            if (sub_id === void 0) { sub_id = 0; }
            this._id = id;
            this._sub_id = sub_id;
            this._request = request;
            this._data = data;
            this._parser = parser;
            this._parentParser = parentParser;
            this._retrieveAsRawData = retrieveAsRawData;
            this._suppressAssetEvents = suppressAssetEvents;
            this._assets = new Array();
            this._dependencies = new Array();
        }
        Object.defineProperty(ResourceDependency.prototype, "id", {
            /**
             *
             */
            get: function () {
                return this._id;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResourceDependency.prototype, "sub_id", {
            get: function () {
                return this._sub_id;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResourceDependency.prototype, "request", {
            /**
             *
             */
            get: function () {
                return this._request;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResourceDependency.prototype, "data", {
            /**
             * The data containing the dependency to be parsed, if the resource was already loaded.
             */
            get: function () {
                return this._data;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResourceDependency.prototype, "parser", {
            /**
             *
             */
            get: function () {
                return this._parser;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResourceDependency.prototype, "parentParser", {
            /**
             * The parser which is dependent on this ResourceDependency object.
             */
            get: function () {
                return this._parentParser;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResourceDependency.prototype, "retrieveAsRawData", {
            /**
             *
             */
            get: function () {
                return this._retrieveAsRawData;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResourceDependency.prototype, "suppresAssetEvents", {
            /**
             *
             */
            get: function () {
                return this._suppressAssetEvents;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResourceDependency.prototype, "assets", {
            /**
             *
             */
            get: function () {
                return this._assets;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResourceDependency.prototype, "dependencies", {
            /**
             *
             */
            get: function () {
                return this._dependencies;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * Method to set data after having already created the dependency object, e.g. after load.
         */
        ResourceDependency.prototype._iSetData = function (data) {
            this._data = data;
        };
        /**
         * @private
         *
         */
        ResourceDependency.prototype._iSetParser = function (parser) {
            this._parser = parser;
        };
        /**
         * Resolve the dependency when it's loaded with the parent parser. For example, a dependency containing an
         * ImageResource would be assigned to a Mesh instance as a BitmapMaterial, a scene graph object would be added
         * to its intended parent. The dependency should be a member of the dependencies property.
         */
        ResourceDependency.prototype.resolve = function () {
            if (this._parentParser)
                this._parentParser._iResolveDependency(this);
        };
        /**
         * Resolve a dependency failure. For example, map loading failure from a 3d file
         */
        ResourceDependency.prototype.resolveFailure = function () {
            if (this._parentParser)
                this._parentParser._iResolveDependencyFailure(this);
        };
        /**
         * Resolve the dependencies name
         */
        ResourceDependency.prototype.resolveName = function (asset) {
            if (this._parentParser)
                return this._parentParser._iResolveDependencyName(this, asset);
            return asset.name;
        };
        return ResourceDependency;
    }());

    /**
     * Dispatched when any asset finishes parsing. Also see specific events for each
     * individual asset type (meshes, materials et c.)
     *
     * @eventType away.events.AssetEvent
     */
    //[Event(name="assetComplete", type="away3d.events.AssetEvent")]
    /**
     * Dispatched when a full resource (including dependencies) finishes loading.
     *
     * @eventType away.events.LoaderEvent
     */
    //[Event(name="resourceComplete", type="away3d.events.LoaderEvent")]
    /**
     * Dispatched when a single dependency (which may be the main file of a resource)
     * finishes loading.
     *
     * @eventType away.events.LoaderEvent
     */
    //[Event(name="dependencyComplete", type="away3d.events.LoaderEvent")]
    /**
     * Dispatched when an error occurs during loading. I
     *
     * @eventType away.events.LoaderEvent
     */
    //[Event(name="loadError", type="away3d.events.LoaderEvent")]
    /**
     * Dispatched when an error occurs during parsing.
     *
     * @eventType away.events.ParserEvent
     */
    //[Event(name="parseError", type="away3d.events.ParserEvent")]
    /**
     * Dispatched when an image asset dimensions are not a power of 2
     *
     * @eventType away.events.AssetEvent
     */
    //[Event(name="textureSizeError", type="away3d.events.AssetEvent")]
    /**
     * Loader can load any file format that away.supports (or for which a third-party parser
     * has been plugged in) and it's dependencies. Events are dispatched when assets are encountered
     * and for when the resource (or it's dependencies) have been loaded.
     *
     * The Loader will not make assets available in any other way than through the dispatched
     * events. To store assets and make them available at any point from any module in an application,
     * use the AssetLibrary to load and manage assets.
     *
     * @see away.library.AssetLibrary
     */
    var Loader = /** @class */ (function (_super) {
        __extends$1(Loader, _super);
        /**
         * Create a new ResourceLoadSession object.
         */
        function Loader(materialMode) {
            if (materialMode === void 0) { materialMode = 0; }
            var _this = _super.call(this) || this;
            _this._materialMode = materialMode;
            _this._stack = new Array();
            _this._errorHandlers = new Array();
            _this._parseErrorHandlers = new Array();
            _this._onReadyForDependenciesDelegate = function (event) { return _this.onReadyForDependencies(event); };
            _this._onParseCompleteDelegate = function (event) { return _this.onParseComplete(event); };
            _this._onParseErrorDelegate = function (event) { return _this.onParseError(event); };
            _this._onLoadProgressDelegate = function (event) { return _this.onLoadProgress(event); };
            _this._onLoadCompleteDelegate = function (event) { return _this.onLoadComplete(event); };
            _this._onLoadErrorDelegate = function (event) { return _this.onLoadError(event); };
            _this._onTextureSizeErrorDelegate = function (event) { return _this.onTextureSizeError(event); };
            _this._onAssetCompleteDelegate = function (event) { return _this.onAssetComplete(event); };
            return _this;
        }
        /**
         * Enables a specific parser.
         * When no specific parser is set for a loading/parsing opperation,
         * loader3d can autoselect the correct parser to use.
         * A parser must have been enabled, to be considered when autoselecting the parser.
         *
         * @param parser The parser export class to enable.
         *
         * @see away.parsers.Parsers
         */
        Loader.enableParser = function (parser) {
            if (Loader._parsers.indexOf(parser) < 0)
                Loader._parsers.push(parser);
        };
        /**
         * Enables a list of parsers.
         * When no specific parser is set for a loading/parsing opperation,
         * Loader can autoselect the correct parser to use.
         * A parser must have been enabled, to be considered when autoselecting the parser.
         *
         * @param parsers A Vector of parser classes to enable.
         * @see away.parsers.Parsers
         */
        Loader.enableParsers = function (parsers) {
            for (var c = 0; c < parsers.length; c++)
                Loader.enableParser(parsers[c]);
        };
        Object.defineProperty(Loader.prototype, "baseDependency", {
            /**
             * Returns the base dependency of the loader
             */
            get: function () {
                return this._baseDependency;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Loader.prototype, "loaderInfo", {
            /**
             * Returns a LoaderInfo object corresponding to the object being loaded.
             * LoaderInfo objects are shared between the Loader object and the loaded
             * content object. The LoaderInfo object supplies loading progress
             * information and statistics about the loaded file.
             *
             * <p>Events related to the load are dispatched by the LoaderInfo object
             * referenced by the <code>contentLoaderInfo</code> property of the Loader
             * object. The <code>contentLoaderInfo</code> property is set to a valid
             * LoaderInfo object, even before the content is loaded, so that you can add
             * event listeners to the object prior to the load.</p>
             *
             * <p>To detect uncaught errors that happen in a loaded SWF, use the
             * <code>Loader.uncaughtErrorEvents</code> property, not the
             * <code>Loader.contentLoaderInfo.uncaughtErrorEvents</code> property.</p>
             */
            get: function () {
                return this._loaderInfo;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Loads a file and (optionally) all of its dependencies.
         *
         * @param req The URLRequest object containing the URL of the file to be loaded.
         * @param context An optional context object providing additional parameters for loading
         * @param ns An optional namespace string under which the file is to be loaded, allowing the differentiation of two resources with identical assets
         * @param parser An optional parser object for translating the loaded data into a usable resource. If not provided, Loader will attempt to auto-detect the file type.
         */
        Loader.prototype.load = function (req, context, ns, parser) {
            if (context === void 0) { context = null; }
            if (ns === void 0) { ns = null; }
            if (parser === void 0) { parser = null; }
            this._uri = req.url = req.url.replace(/\\/g, "/");
            this._context = context;
            this._namespace = ns;
            this._baseDependency = new ResourceDependency('', req, null, parser, null);
            this.retrieveDependency(this._baseDependency);
        };
        /**
         * Loads a resource from already loaded data.
         *
         * @param data The data object containing all resource information.
         * @param context An optional context object providing additional parameters for loading
         * @param ns An optional namespace string under which the file is to be loaded, allowing the differentiation of two resources with identical assets
         * @param parser An optional parser object for translating the loaded data into a usable resource. If not provided, Loader will attempt to auto-detect the file type.
         */
        Loader.prototype.loadData = function (data, id, context, ns, parser) {
            if (context === void 0) { context = null; }
            if (ns === void 0) { ns = null; }
            if (parser === void 0) { parser = null; }
            this._uri = id;
            this._context = context;
            this._namespace = ns;
            this._baseDependency = new ResourceDependency(id, null, data, parser, null);
            this.retrieveDependency(this._baseDependency);
        };
        /**
         * Recursively retrieves the next to-be-loaded and parsed dependency on the stack, or pops the list off the
         * stack when complete and continues on the top set.
         * @param parser The parser that will translate the data into a usable resource.
         */
        Loader.prototype.retrieveNext = function (parser) {
            if (parser === void 0) { parser = null; }
            if (this._currentDependency.dependencies.length) {
                var next = this._currentDependency.dependencies.pop();
                this._stack.push(this._currentDependency);
                this.retrieveDependency(next);
            }
            else if (this._currentDependency.parser && this._currentDependency.parser.parsingPaused) {
                this._currentDependency.parser._iResumeParsing();
            }
            else if (this._stack && this._stack.length) {
                var prev = this._currentDependency;
                this._currentDependency = this._stack.pop();
                if (prev._iSuccess)
                    prev.resolve();
                this.retrieveNext(parser);
            }
            else {
                this.dispatchEvent(new LoaderEvent(LoaderEvent.LOAD_COMPLETE, this._uri, this._baseDependency.parser.content, this._baseDependency.assets));
            }
        };
        /**
         * Retrieves a single dependency.
         * @param parser The parser that will translate the data into a usable resource.
         */
        Loader.prototype.retrieveDependency = function (dependency) {
            var data;
            if (this._context && this._context.materialMode != 0)
                this._materialMode = this._context.materialMode;
            this._currentDependency = dependency;
            dependency._iLoader = new URLLoader();
            this.addEventListeners(dependency._iLoader);
            // Get already loaded (or mapped) data if available
            data = dependency.data;
            if (this._context && dependency.request) {
                if (this._context._iHasDataForUrl(dependency.request.url)) {
                    data = this._context._iGetDataForUrl(dependency.request.url);
                }
                else if (this._context.externalAssetMode == LoaderContext.ON_DEMAND && (this.getSuffix(dependency.request.url) == "jpg" || this.getSuffix(dependency.request.url) == "png")) {
                    data = dependency.request;
                    if (!dependency.parser)
                        dependency._iSetParser(this.getParserFromSuffix(dependency.request.url));
                }
            }
            if (data) {
                if (data.constructor === Function)
                    data = new data();
                dependency._iSetData(data);
                if (dependency.retrieveAsRawData) {
                    // No need to parse. The parent parser is expecting this
                    // to be raw data so it can be passed directly.
                    dependency.resolve();
                    // Move on to next dependency
                    this.retrieveNext();
                }
                else {
                    this.parseDependency(dependency);
                }
            }
            else {
                // Resolve URL and start loading
                dependency.request.url = this.resolveDependencyUrl(dependency);
                if (dependency.retrieveAsRawData) {
                    // Always use binary for raw data loading
                    dependency._iLoader.dataFormat = URLLoaderDataFormat.BINARY;
                }
                else {
                    if (!dependency.parser)
                        dependency._iSetParser(this.getParserFromSuffix(dependency.request.url));
                    if (dependency.parser) {
                        dependency._iLoader.dataFormat = dependency.parser.dataFormat;
                    }
                    else {
                        // Always use BINARY for unknown file formats. The thorough
                        // file type check will determine format after load, and if
                        // binary, a text load will have broken the file data.
                        dependency._iLoader.dataFormat = URLLoaderDataFormat.BINARY;
                    }
                }
                dependency._iLoader.load(dependency.request);
            }
        };
        Loader.prototype.joinUrl = function (base, end) {
            if (end.charAt(0) == '/' || end.charAt(0) == '\\')
                end = end.substr(1);
            if (end.charAt(0) == '.')
                end = end.substr(2);
            if (base.length == 0)
                return end;
            if (base.charAt(base.length - 1) == '/' || base.charAt(base.length - 1) == '\\')
                base = base.substr(0, base.length - 1);
            return base.concat('/', end);
        };
        Loader.prototype.resolveDependencyUrl = function (dependency) {
            var scheme_re;
            var base;
            var url = dependency.request.url;
            // Has the user re-mapped this URL?
            if (this._context && this._context._iHasMappingForUrl(url))
                return this._context._iGetRemappedUrl(url);
            // This is the "base" dependency, i.e. the actual requested asset.
            // We will not try to resolve this since the user can probably be
            // thrusted to know this URL better than our automatic resolver. :)
            if (url == this._uri)
                return url;
            // Absolute URL? Check if starts with slash or a URL
            // scheme definition (e.g. ftp://, http://, file://)
            scheme_re = new RegExp('/^[a-zA-Z]{3,4}:\/\//');
            if (url.charAt(0) == '/') {
                if (this._context && this._context.overrideAbsolutePaths)
                    return this.joinUrl(this._context.dependencyBaseUrl, url);
                else
                    return url;
            }
            else if (scheme_re.test(url)) {
                // If overriding full URLs, get rid of scheme (e.g. "http://")
                // and replace with the dependencyBaseUrl defined by user.
                if (this._context && this._context.overrideFullURLs) {
                    var noscheme_url = url.replace(scheme_re, ''); //url['replace'](scheme_re);
                    return this.joinUrl(this._context.dependencyBaseUrl, noscheme_url);
                }
            }
            // Since not absolute, just get rid of base file name to find it's
            // folder and then concatenate dynamic URL
            if (this._context && this._context.dependencyBaseUrl) {
                base = this._context.dependencyBaseUrl;
                return this.joinUrl(base, url);
            }
            else {
                base = this._uri.substring(0, this._uri.lastIndexOf('/') + 1);
                return this.joinUrl(base, url);
            }
        };
        Loader.prototype.retrieveParserDependencies = function () {
            if (!this._currentDependency)
                return;
            var parserDependancies = this._currentDependency.parser.dependencies;
            var i, len = parserDependancies.length;
            for (i = 0; i < len; i++)
                this._currentDependency.dependencies[i] = parserDependancies[i];
            // Since more dependencies might be added eventually, empty this
            // list so that the same dependency isn't retrieved more than once.
            parserDependancies.length = 0;
            this._stack.push(this._currentDependency);
            this.retrieveNext();
        };
        Loader.prototype.resolveParserDependencies = function () {
            this._currentDependency._iSuccess = true;
            // Retrieve any last dependencies remaining on this parser, or
            // if none exists, just move on.
            if (this._currentDependency.parser && this._currentDependency.parser.dependencies.length && (!this._context || this._context.includeDependencies)) //context may be null
                this.retrieveParserDependencies();
            else
                this.retrieveNext();
        };
        /**
         * Called when a single dependency loading failed, and pushes further dependencies onto the stack.
         * @param event
         */
        Loader.prototype.onLoadError = function (event) {
            var handled;
            var isDependency = (this._currentDependency != this._baseDependency);
            var loader = event.urlLoader;
            this.removeEventListeners(loader);
            if (this.hasEventListener(URLLoaderEvent.LOAD_ERROR)) {
                this.dispatchEvent(event);
                handled = true;
            }
            else {
                // TODO: Consider not doing this even when Loader does have it's own LOAD_ERROR listener
                var i, len = this._errorHandlers.length;
                for (i = 0; i < len; i++)
                    if (!handled)
                        handled = this._errorHandlers[i](event);
            }
            if (handled) {
                //if (isDependency && ! event.isDefaultPrevented()) {
                if (isDependency) { // TODO: JS / AS3 Change - we don't have isDefaultPrevented - so will this work
                    this._currentDependency.resolveFailure();
                    this.retrieveNext();
                }
                else {
                    // Either this was the base file (last left in the stack) or
                    // default behavior was prevented by the handlers, and hence
                    // there is nothing more to do than clean up and bail.
                    this.dispose();
                    return;
                }
            }
            else {
                // Error event was not handled by listeners directly on Loader or
                // on any of the subscribed loaders (in the list of error handlers.)
                throw new Error();
            }
        };
        /**
         * Called when a dependency parsing failed, and dispatches a <code>ParserEvent.PARSE_ERROR</code>
         * @param event
         */
        Loader.prototype.onParseError = function (event) {
            var handled;
            var isDependency = (this._currentDependency != this._baseDependency);
            var loader = event.target;
            this.removeEventListeners(loader);
            if (this.hasEventListener(ParserEvent.PARSE_ERROR)) {
                this.dispatchEvent(event);
                handled = true;
            }
            else {
                // TODO: Consider not doing this even when Loader does
                // have it's own LOAD_ERROR listener
                var i, len = this._parseErrorHandlers.length;
                for (i = 0; i < len; i++)
                    if (!handled)
                        handled = this._parseErrorHandlers[i](event);
            }
            if (handled) {
                this.retrieveNext();
            }
            else {
                // Error event was not handled by listeners directly on Loader or
                // on any of the subscribed loaders (in the list of error handlers.)
                throw new Error(event.message);
            }
        };
        Loader.prototype.onAssetComplete = function (event) {
            // Add loaded asset to list of assets retrieved as part
            // of the current dependency. This list will be inspected
            // by the parent parser when dependency is resolved
            if (this._currentDependency)
                this._currentDependency.assets.push(event.asset);
            event.asset.resetAssetPath(event.asset.name, this._namespace);
            if (!this._currentDependency.suppresAssetEvents)
                this.dispatchEvent(event);
        };
        Loader.prototype.onReadyForDependencies = function (event) {
            var parser = event.target;
            if (this._context && !this._context.includeDependencies)
                parser._iResumeParsing();
            else
                this.retrieveParserDependencies();
        };
        Loader.prototype.onLoadProgress = function (event) {
            this.dispatchEvent(event);
        };
        /**
         * Called when a single dependency was parsed, and pushes further dependencies onto the stack.
         * @param event
         */
        Loader.prototype.onLoadComplete = function (event) {
            var loader = event.urlLoader;
            this.removeEventListeners(loader);
            // Resolve this dependency
            this._currentDependency._iSetData(loader.data);
            if (this._currentDependency.retrieveAsRawData) {
                // No need to parse this data, which should be returned as is
                this.resolveParserDependencies();
            }
            else {
                this.parseDependency(this._currentDependency);
            }
        };
        /**
         * Called when parsing is complete.
         */
        Loader.prototype.onParseComplete = function (event) {
            var parser = event.target;
            parser.removeEventListener(ParserEvent.READY_FOR_DEPENDENCIES, this._onReadyForDependenciesDelegate);
            parser.removeEventListener(ParserEvent.PARSE_COMPLETE, this._onParseCompleteDelegate);
            parser.removeEventListener(ParserEvent.PARSE_ERROR, this._onParseErrorDelegate);
            parser.removeEventListener(AssetEvent.TEXTURE_SIZE_ERROR, this._onTextureSizeErrorDelegate);
            parser.removeEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            this.resolveParserDependencies();
        };
        /**
         * Called when an image is too large or it's dimensions are not a power of 2
         * @param event
         */
        Loader.prototype.onTextureSizeError = function (event) {
            event.asset.name = this._currentDependency.resolveName(event.asset);
            this.dispatchEvent(event);
        };
        Loader.prototype.addEventListeners = function (loader) {
            loader.addEventListener(URLLoaderEvent.LOAD_PROGRESS, this._onLoadProgressDelegate);
            loader.addEventListener(URLLoaderEvent.LOAD_COMPLETE, this._onLoadCompleteDelegate);
            loader.addEventListener(URLLoaderEvent.LOAD_ERROR, this._onLoadErrorDelegate);
        };
        Loader.prototype.removeEventListeners = function (loader) {
            loader.removeEventListener(URLLoaderEvent.LOAD_PROGRESS, this._onLoadProgressDelegate);
            loader.removeEventListener(URLLoaderEvent.LOAD_COMPLETE, this._onLoadCompleteDelegate);
            loader.removeEventListener(URLLoaderEvent.LOAD_ERROR, this._onLoadErrorDelegate);
        };
        Loader.prototype.stop = function () {
            this.dispose();
        };
        Loader.prototype.dispose = function () {
            this._errorHandlers = null;
            this._parseErrorHandlers = null;
            this._context = null;
            this._stack = null;
            if (this._currentDependency && this._currentDependency._iLoader)
                this.removeEventListeners(this._currentDependency._iLoader);
            this._currentDependency = null;
        };
        /**
         * @private
         * This method is used by other loader classes (e.g. Loader3D and AssetLibraryBundle) to
         * add error event listeners to the Loader instance. This system is used instead of
         * the regular EventDispatcher system so that the AssetLibrary error handler can be sure
         * that if hasEventListener() returns true, it's client code that's listening for the
         * event. Secondly, functions added as error handler through this custom method are
         * expected to return a boolean value indicating whether the event was handled (i.e.
         * whether they in turn had any client code listening for the event.) If no handlers
         * return true, the Loader knows that the event wasn't handled and will throw an RTE.
         */
        Loader.prototype._iAddParseErrorHandler = function (handler) {
            if (this._parseErrorHandlers.indexOf(handler) < 0)
                this._parseErrorHandlers.push(handler);
        };
        Loader.prototype._iAddErrorHandler = function (handler) {
            if (this._errorHandlers.indexOf(handler) < 0)
                this._errorHandlers.push(handler);
        };
        /**
         * Guesses the parser to be used based on the file contents.
         * @param data The data to be parsed.
         * @param uri The url or id of the object to be parsed.
         * @return An instance of the guessed parser.
         */
        Loader.prototype.getParserFromData = function (data) {
            var len = Loader._parsers.length;
            // go in reverse order to allow application override of default parser added in away.proper
            for (var i = len - 1; i >= 0; i--)
                if (Loader._parsers[i].supportsData(data))
                    return new Loader._parsers[i]();
            return null;
        };
        /**
         * Initiates parsing of the loaded dependency.
         *
         * @param The dependency to be parsed.
         */
        Loader.prototype.parseDependency = function (dependency) {
            var parser = dependency.parser;
            // If no parser has been defined, try to find one by letting
            // all plugged in parsers inspect the actual data.
            if (!parser)
                dependency._iSetParser(parser = this.getParserFromData(dependency.data));
            if (parser) {
                parser.addEventListener(ParserEvent.READY_FOR_DEPENDENCIES, this._onReadyForDependenciesDelegate);
                parser.addEventListener(ParserEvent.PARSE_COMPLETE, this._onParseCompleteDelegate);
                parser.addEventListener(ParserEvent.PARSE_ERROR, this._onParseErrorDelegate);
                parser.addEventListener(AssetEvent.TEXTURE_SIZE_ERROR, this._onTextureSizeErrorDelegate);
                parser.addEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
                if (dependency.request && dependency.request.url)
                    parser._iFileName = dependency.request.url;
                parser.materialMode = this._materialMode;
                parser.parseAsync(dependency.data);
            }
            else {
                var handled;
                var message = "No parser defined. To enable all parsers for auto-detection, use Parsers.enableAllBundled()";
                var event = new ParserEvent(ParserEvent.PARSE_ERROR, message);
                if (this.hasEventListener(ParserEvent.PARSE_ERROR)) {
                    this.dispatchEvent(event);
                    handled = true;
                }
                else {
                    // TODO: Consider not doing this even when Loader does
                    // have it's own LOAD_ERROR listener
                    var i, len = this._parseErrorHandlers.length;
                    for (i = 0; i < len; i++)
                        if (!handled)
                            handled = this._parseErrorHandlers[i](event);
                }
                if (handled) {
                    this.retrieveNext();
                }
                else {
                    // Error event was not handled by listeners directly on Loader or
                    // on any of the subscribed loaders (in the list of error handlers.)
                    throw new Error(message);
                }
            }
        };
        /**
         * Guesses the parser to be used based on the file extension.
         * @return An instance of the guessed parser.
         */
        Loader.prototype.getParserFromSuffix = function (url) {
            var fileExtension = this.getSuffix(url);
            var len = Loader._parsers.length;
            // go in reverse order to allow application override of default parser added in away.proper
            for (var i = len - 1; i >= 0; i--) {
                var parserClass = Loader._parsers[i];
                if (parserClass.supportsType(fileExtension))
                    return new parserClass();
            }
            return null;
        };
        Loader.prototype.getSuffix = function (url) {
            // Get rid of query string if any and extract extension
            var base = (url.indexOf('?') > 0) ? url.split('?')[0] : url;
            return base.substr(base.lastIndexOf('.') + 1).toLowerCase();
        };
        // Image parser only parser that is added by default, to save file size.
        Loader._parsers = new Array();
        return Loader;
    }(EventDispatcher));

    /**
     * Enumaration export class for precedence when resolving naming conflicts in the library.
     *
     * @see away.library.AssetLibrary.conflictPrecedence
     * @see away.library.AssetLibrary.conflictStrategy
     * @see away.library.naming.ConflictStrategy
     */
    var ConflictPrecedence = /** @class */ (function () {
        function ConflictPrecedence() {
        }
        /**
         * Signals that in a conflict, the previous owner of the conflicting name
         * should be favored (and keep it's name) and that the newly renamed asset
         * is reverted to a non-conflicting name.
         */
        ConflictPrecedence.FAVOR_OLD = 'favorOld';
        /**
         * Signales that in a conflict, the newly renamed asset is favored (and keeps
         * it's newly defined name) and that the previous owner of that name gets
         * renamed to a non-conflicting name.
         */
        ConflictPrecedence.FAVOR_NEW = 'favorNew';
        return ConflictPrecedence;
    }());

    /**
     * Abstract base export class for naming conflict resolution classes. Extend this to create a
     * strategy export class which the asset library can use to resolve asset naming conflicts, or
     * use one of the bundled concrete strategy classes:
     *
     * <ul>
     *   <li>IgnoreConflictStrategy (ConflictStrategy.IGNORE)</li>
     *   <li>ErrorConflictStrategy (ConflictStrategy.THROW_ERROR)</li>
     *   <li>NumSuffixConflictStrategy (ConflictStrategy.APPEND_NUM_SUFFIX)</li>
     * </ul>
     *
     * @see away.library.AssetLibrary.conflictStrategy
     * @see away.library.ConflictStrategy
     * @see away.library.IgnoreConflictStrategy
     * @see away.library.ErrorConflictStrategy
     * @see away.library.NumSuffixConflictStrategy
     */
    var ConflictStrategyBase = /** @class */ (function () {
        function ConflictStrategyBase() {
        }
        /**
         * Resolve a naming conflict between two assets. Must be implemented by concrete strategy
         * classes.
         */
        ConflictStrategyBase.prototype.resolveConflict = function (changedAsset, oldAsset, assetsDictionary, precedence) {
            throw new AbstractMethodError();
        };
        /**
         * Create instance of this conflict strategy. Used internally by the AssetLibrary to
         * make sure the same strategy instance is not used in all AssetLibrary instances, which
         * would break any state caching that happens inside the strategy class.
         */
        ConflictStrategyBase.prototype.create = function () {
            throw new AbstractMethodError();
        };
        /**
         * Provided as a convenience method for all conflict strategy classes, as a way to finalize
         * the conflict resolution by applying the new names and dispatching the correct events.
         */
        ConflictStrategyBase.prototype._pUpdateNames = function (ns, nonConflictingName, oldAsset, newAsset, assetsDictionary, precedence) {
            var loser_prev_name;
            var winner;
            var loser;
            winner = (precedence === ConflictPrecedence.FAVOR_NEW) ? newAsset : oldAsset;
            loser = (precedence === ConflictPrecedence.FAVOR_NEW) ? oldAsset : newAsset;
            loser_prev_name = loser.adaptee.name;
            assetsDictionary[winner.adaptee.name] = winner;
            assetsDictionary[nonConflictingName] = loser;
            loser.adaptee.resetAssetPath(nonConflictingName, ns, false);
            loser.adaptee.dispatchEvent(new AssetEvent(AssetEvent.ASSET_CONFLICT_RESOLVED, loser.adaptee, loser_prev_name));
        };
        return ConflictStrategyBase;
    }());

    var ErrorConflictStrategy = /** @class */ (function (_super) {
        __extends$1(ErrorConflictStrategy, _super);
        function ErrorConflictStrategy() {
            return _super.call(this) || this;
        }
        ErrorConflictStrategy.prototype.resolveConflict = function (changedAsset, oldAsset, assetsDictionary, precedence) {
            throw new ErrorBase('Asset name collision while AssetLibrary.namingStrategy set to AssetLibrary.THROW_ERROR. Asset path: ' + changedAsset.adaptee.assetFullPath);
        };
        ErrorConflictStrategy.prototype.create = function () {
            return new ErrorConflictStrategy();
        };
        return ErrorConflictStrategy;
    }(ConflictStrategyBase));

    var IgnoreConflictStrategy = /** @class */ (function (_super) {
        __extends$1(IgnoreConflictStrategy, _super);
        function IgnoreConflictStrategy() {
            return _super.call(this) || this;
        }
        IgnoreConflictStrategy.prototype.resolveConflict = function (changedAsset, oldAsset, assetsDictionary, precedence) {
            // Do nothing, ignore the fact that there is a conflict.
            return;
        };
        IgnoreConflictStrategy.prototype.create = function () {
            return new IgnoreConflictStrategy();
        };
        return IgnoreConflictStrategy;
    }(ConflictStrategyBase));

    var NumSuffixConflictStrategy = /** @class */ (function (_super) {
        __extends$1(NumSuffixConflictStrategy, _super);
        function NumSuffixConflictStrategy(separator) {
            if (separator === void 0) { separator = '.'; }
            var _this = _super.call(this) || this;
            _this._separator = separator;
            _this._next_suffix = {};
            return _this;
        }
        NumSuffixConflictStrategy.prototype.resolveConflict = function (changedAsset, oldAsset, assetsDictionary, precedence) {
            var orig;
            var new_name;
            var base;
            var suffix;
            orig = changedAsset.adaptee.name;
            if (orig.indexOf(this._separator) >= 0) {
                // Name has an ocurrence of the separator, so get base name and suffix,
                // unless suffix is non-numerical, in which case revert to zero and
                // use entire name as base
                base = orig.substring(0, orig.lastIndexOf(this._separator));
                suffix = parseInt(orig.substring(base.length - 1));
                if (isNaN(suffix)) {
                    base = orig;
                    suffix = 0;
                }
            }
            else {
                base = orig;
                suffix = 0;
            }
            if (suffix == 0 && this._next_suffix.hasOwnProperty(base)) {
                suffix = this._next_suffix[base];
            }
            // Find the first suffixed name that does
            // not collide with other names.
            do {
                suffix++;
                new_name = base.concat(this._separator, suffix.toString());
            } while (assetsDictionary.hasOwnProperty(new_name));
            this._next_suffix[base] = suffix;
            this._pUpdateNames(oldAsset.adaptee.assetNamespace, new_name, oldAsset, changedAsset, assetsDictionary, precedence);
        };
        NumSuffixConflictStrategy.prototype.create = function () {
            return new NumSuffixConflictStrategy(this._separator);
        };
        return NumSuffixConflictStrategy;
    }(ConflictStrategyBase));

    /**
     * Enumeration export class for bundled conflict strategies. Set one of these values (or an
     * instance of a self-defined sub-export class of ConflictStrategyBase) to the conflictStrategy
     * property on an AssetLibrary to define how that library resolves naming conflicts.
     *
     * The value of the <code>AssetLibrary.conflictPrecedence</code> property defines which
     * of the conflicting assets will get to keep it's name, and which is renamed (if any.)
     *
     * @see away.library.AssetLibrary.conflictStrategy
     * @see away.library.naming.ConflictStrategyBase
     */
    var ConflictStrategy = /** @class */ (function () {
        function ConflictStrategy(include) {
            //TODO: find out why typescript d.ts files do not include this class
        }
        /**
         * Specifies that in case of a naming conflict, one of the assets will be renamed and
         * a numeric suffix appended to the base name.
         */
        ConflictStrategy.APPEND_NUM_SUFFIX = new NumSuffixConflictStrategy();
        /**
         * Specifies that naming conflicts should be ignored. This is not recommended in most
         * cases, unless it can be 100% guaranteed that the application does not cause naming
         * conflicts in the library (i.e. when an app-level system is in place to prevent this.)
         */
        ConflictStrategy.IGNORE = new IgnoreConflictStrategy();
        /**
         * Specifies that an error should be thrown if a naming conflict is discovered. Use this
         * to be 100% sure that naming conflicts never occur unnoticed, and when it's undesirable
         * to have the library automatically rename assets to avoid such conflicts.
         */
        ConflictStrategy.THROW_ERROR = new ErrorConflictStrategy();
        return ConflictStrategy;
    }());

    /**
     * AssetLibraryBundle enforces a multiton pattern and is not intended to be instanced directly.
     * Its purpose is to create a container for 3D data management, both before and after parsing.
     * If you are interested in creating multiple library bundles, please use the <code>getInstance()</code> method.
     */
    var AssetLibraryBundle = /** @class */ (function (_super) {
        __extends$1(AssetLibraryBundle, _super);
        /**
         * Creates a new <code>AssetLibraryBundle</code> object.
         *
         * @param me A multiton enforcer for the AssetLibraryBundle ensuring it cannnot be instanced.
         */
        function AssetLibraryBundle() {
            var _this = _super.call(this) || this;
            _this._loaderSessionsGarbage = new Array();
            _this._assets = new Array(); //new Vector.<IAsset>;
            _this._assetDictionary = new Object();
            _this._loaderSessions = new Array();
            _this.conflictStrategy = ConflictStrategy.IGNORE.create();
            _this.conflictPrecedence = ConflictPrecedence.FAVOR_NEW;
            _this._onAssetRenameDelegate = function (event) { return _this.onAssetRename(event); };
            _this._onAssetConflictResolvedDelegate = function (event) { return _this.onAssetConflictResolved(event); };
            _this._onLoadCompleteDelegate = function (event) { return _this.onLoadComplete(event); };
            _this._onTextureSizeErrorDelegate = function (event) { return _this.onTextureSizeError(event); };
            _this._onAssetCompleteDelegate = function (event) { return _this.onAssetComplete(event); };
            _this._onLoadErrorDelegate = function (event) { return _this.onLoadError(event); };
            _this._onParseErrorDelegate = function (event) { return _this.onParseError(event); };
            return _this;
        }
        /**
         * Returns an AssetLibraryBundle instance. If no key is given, returns the default bundle instance (which is
         * similar to using the AssetLibraryBundle as a singleton.) To keep several separated library bundles,
         * pass a string key to this method to define which bundle should be returned. This is
         * referred to as using the AssetLibrary as a multiton.
         *
         * @param key Defines which multiton instance should be returned.
         * @return An instance of the asset library
         */
        AssetLibraryBundle.getInstance = function (key) {
            if (key === void 0) { key = 'default'; }
            if (!key)
                key = 'default';
            if (!AssetLibraryBundle._iInstances.hasOwnProperty(key))
                AssetLibraryBundle._iInstances[key] = new AssetLibraryBundle();
            return AssetLibraryBundle._iInstances[key];
        };
        /**
         *
         */
        AssetLibraryBundle.prototype.enableParser = function (parserClass) {
            Loader.enableParser(parserClass);
        };
        /**
         *
         */
        AssetLibraryBundle.prototype.enableParsers = function (parserClasses) {
            Loader.enableParsers(parserClasses);
        };
        Object.defineProperty(AssetLibraryBundle.prototype, "conflictStrategy", {
            /**
             * Defines which strategy should be used for resolving naming conflicts, when two library
             * assets are given the same name. By default, <code>ConflictStrategy.APPEND_NUM_SUFFIX</code>
             * is used which means that a numeric suffix is appended to one of the assets. The
             * <code>conflictPrecedence</code> property defines which of the two conflicting assets will
             * be renamed.
             *
             * @see naming.ConflictStrategy
             * @see AssetLibrary.conflictPrecedence
             */
            get: function () {
                return this._strategy;
            },
            set: function (val) {
                if (!val)
                    throw new ErrorBase('namingStrategy must not be null. To ignore naming, use AssetLibrary.IGNORE');
                this._strategy = val.create();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AssetLibraryBundle.prototype, "conflictPrecedence", {
            /**
             * Defines which asset should have precedence when resolving a naming conflict between
             * two assets of which one has just been renamed by the user or by a parser. By default
             * <code>ConflictPrecedence.FAVOR_NEW</code> is used, meaning that the newly renamed
             * asset will keep it's new name while the older asset gets renamed to not conflict.
             *
             * This property is ignored for conflict strategies that do not actually rename an
             * asset automatically, such as ConflictStrategy.IGNORE and ConflictStrategy.THROW_ERROR.
             *
             * @see away.library.ConflictPrecedence
             * @see away.library.ConflictStrategy
             */
            get: function () {
                return this._strategyPreference;
            },
            set: function (val) {
                this._strategyPreference = val;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Create an AssetLibraryIterator instance that can be used to iterate over the assets
         * in this asset library instance. The iterator can filter assets on asset type and/or
         * namespace. A "null" filter value means no filter of that type is used.
         *
         * @param assetTypeFilter Asset type to filter on (from the AssetType enum class.) Use
         * null to not filter on asset type.
         * @param namespaceFilter Namespace to filter on. Use null to not filter on namespace.
         * @param filterFunc Callback function to use when deciding whether an asset should be
         * included in the iteration or not. This needs to be a function that takes a single
         * parameter of type IAsset and returns a boolean where true means it should be included.
         *
         * @see away.library.AssetType
         */
        AssetLibraryBundle.prototype.createIterator = function (assetTypeFilter, namespaceFilter, filterFunc) {
            if (assetTypeFilter === void 0) { assetTypeFilter = null; }
            if (namespaceFilter === void 0) { namespaceFilter = null; }
            if (filterFunc === void 0) { filterFunc = null; }
            return new AssetLibraryIterator(this._assets, assetTypeFilter, namespaceFilter, filterFunc);
        };
        /**
         * Loads a file and (optionally) all of its dependencies.
         *
         * @param req The URLRequest object containing the URL of the file to be loaded.
         * @param context An optional context object providing additional parameters for loading
         * @param ns An optional namespace string under which the file is to be loaded, allowing the differentiation of two resources with identical assets
         * @param parser An optional parser object for translating the loaded data into a usable resource. If not provided, Loader will attempt to auto-detect the file type.
         * @return A handle to the retrieved resource.
         */
        AssetLibraryBundle.prototype.load = function (req, context, ns, parser) {
            if (context === void 0) { context = null; }
            if (ns === void 0) { ns = null; }
            if (parser === void 0) { parser = null; }
            this.getLoader().load(req, context, ns, parser);
        };
        /**
         * Loads a resource from existing data in memory.
         *
         * @param data The data object containing all resource information.
         * @param context An optional context object providing additional parameters for loading
         * @param ns An optional namespace string under which the file is to be loaded, allowing the differentiation of two resources with identical assets
         * @param parser An optional parser object for translating the loaded data into a usable resource. If not provided, Loader will attempt to auto-detect the file type.
         * @return A handle to the retrieved resource.
         */
        AssetLibraryBundle.prototype.loadData = function (data, context, ns, parser) {
            if (context === void 0) { context = null; }
            if (ns === void 0) { ns = null; }
            if (parser === void 0) { parser = null; }
            this.getLoader().loadData(data, '', context, ns, parser);
        };
        AssetLibraryBundle.prototype.getLoader = function () {
            var loader = new Loader();
            this._loaderSessions.push(loader);
            loader.addEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoadCompleteDelegate);
            loader.addEventListener(AssetEvent.TEXTURE_SIZE_ERROR, this._onTextureSizeErrorDelegate);
            loader.addEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            // Error are handled separately (see documentation for addErrorHandler)
            loader._iAddErrorHandler(this._onLoadErrorDelegate);
            loader._iAddParseErrorHandler(this._onParseErrorDelegate);
            return loader;
        };
        AssetLibraryBundle.prototype.disposeLoader = function (loader) {
            var index = this._loaderSessions.indexOf(loader);
            this._loaderSessions.splice(index, 1);
            this.killloaderSession(loader);
        };
        /**
         *
         */
        AssetLibraryBundle.prototype.getAsset = function (name, ns) {
            if (ns === void 0) { ns = null; }
            if (this._assetDictDirty)
                this.rehashAssetDict();
            if (ns == null)
                ns = AssetBase.DEFAULT_NAMESPACE;
            if (!this._assetDictionary.hasOwnProperty(ns))
                return null;
            return this._assetDictionary[ns][name.toString().toLowerCase()];
        };
        AssetLibraryBundle.prototype.getAllAssets = function () {
            return this._assets;
        };
        /**
         * Adds an asset to the asset library, first making sure that it's name is unique
         * using the method defined by the <code>conflictStrategy</code> and
         * <code>conflictPrecedence</code> properties.
         */
        AssetLibraryBundle.prototype.addAsset = function (asset) {
            var ns;
            var old;
            // Bail if asset has already been added.
            if (this._assets.indexOf(asset) >= 0)
                return;
            old = this.getAsset(asset.adaptee.name, asset.adaptee.assetNamespace);
            ns = asset.adaptee.assetNamespace || AssetBase.DEFAULT_NAMESPACE;
            if (old != null)
                this._strategy.resolveConflict(asset, old, this._assetDictionary[ns], this._strategyPreference);
            //create unique-id (for now this is used in AwayBuilder only
            //asset.id = IDUtil.createUID();
            // Add it
            this._assets.push(asset);
            if (!this._assetDictionary.hasOwnProperty(ns))
                this._assetDictionary[ns] = new Object();
            this._assetDictionary[ns][asset.adaptee.name.toString().toLowerCase()] = asset;
            asset.adaptee.addEventListener(AssetEvent.RENAME, this._onAssetRenameDelegate);
            asset.adaptee.addEventListener(AssetEvent.ASSET_CONFLICT_RESOLVED, this._onAssetConflictResolvedDelegate);
        };
        /**
         * Removes an asset from the library, and optionally disposes that asset by calling
         * it's disposeAsset() method (which for most assets is implemented as a default
         * version of that type's dispose() method.
         *
         * @param asset The asset which should be removed from this library.
         * @param dispose Defines whether the assets should also be disposed.
         */
        AssetLibraryBundle.prototype.removeAsset = function (asset, dispose) {
            if (dispose === void 0) { dispose = true; }
            var idx;
            this.removeAssetFromDict(asset);
            asset.adaptee.removeEventListener(AssetEvent.RENAME, this._onAssetRenameDelegate);
            asset.adaptee.removeEventListener(AssetEvent.ASSET_CONFLICT_RESOLVED, this._onAssetConflictResolvedDelegate);
            idx = this._assets.indexOf(asset);
            if (idx >= 0)
                this._assets.splice(idx, 1);
            if (dispose)
                asset.dispose();
        };
        /**
         * Removes an asset which is specified using name and namespace.
         *
         * @param name The name of the asset to be removed.
         * @param ns The namespace to which the desired asset belongs.
         * @param dispose Defines whether the assets should also be disposed.
         *
         * @see away.library.AssetLibrary.removeAsset()
         */
        AssetLibraryBundle.prototype.removeAssetByName = function (name, ns, dispose) {
            if (ns === void 0) { ns = null; }
            if (dispose === void 0) { dispose = true; }
            var asset = this.getAsset(name, ns);
            if (asset)
                this.removeAsset(asset, dispose);
            return asset;
        };
        /**
         * Removes all assets from the asset library, optionally disposing them as they
         * are removed.
         *
         * @param dispose Defines whether the assets should also be disposed.
         */
        AssetLibraryBundle.prototype.removeAllAssets = function (dispose) {
            if (dispose === void 0) { dispose = true; }
            if (dispose) {
                var asset;
                var len = this._assets.length;
                for (var c = 0; c < len; c++) {
                    asset = this._assets[c];
                    asset.dispose();
                }
            }
            this._assets.length = 0;
            this.rehashAssetDict();
        };
        /**
         * Removes all assets belonging to a particular namespace (null for default)
         * from the asset library, and optionall disposes them by calling their
         * disposeAsset() method.
         *
         * @param ns The namespace from which all assets should be removed.
         * @param dispose Defines whether the assets should also be disposed.
         *
         * @see away.library.AssetLibrary.removeAsset()
         */
        AssetLibraryBundle.prototype.removeNamespaceAssets = function (ns, dispose) {
            if (ns === void 0) { ns = null; }
            if (dispose === void 0) { dispose = true; }
            var idx = 0;
            var asset;
            var old_assets;
            // Empty the assets vector after having stored a copy of it.
            // The copy will be filled with all assets which weren't removed.
            old_assets = this._assets.concat();
            this._assets.length = 0;
            if (ns == null)
                ns = AssetBase.DEFAULT_NAMESPACE;
            var len = old_assets.length;
            for (var d = 0; d < len; d++) {
                asset = old_assets[d];
                // Remove from dict if in the supplied namespace. If not,
                // transfer over to the new vector.
                if (asset.adaptee.assetNamespace == ns) {
                    if (dispose)
                        asset.dispose();
                    // Remove asset from dictionary, but don't try to auto-remove
                    // the namespace, which will trigger an unnecessarily expensive
                    // test that is not needed since we know that the namespace
                    // will be empty when loop finishes.
                    this.removeAssetFromDict(asset, false);
                }
                else {
                    this._assets[idx++] = asset;
                }
            }
            /*
             for each (asset in old_assets) {
             // Remove from dict if in the supplied namespace. If not,
             // transfer over to the new vector.
             if (asset.assetNamespace == ns) {
             if (dispose)
             asset.dispose();

             // Remove asset from dictionary, but don't try to auto-remove
             // the namespace, which will trigger an unnecessarily expensive
             // test that is not needed since we know that the namespace
             // will be empty when loop finishes.
             removeAssetFromDict(asset, false);
             } else
             _assets[idx++] = asset;

             }
             */
            // Remove empty namespace
            if (this._assetDictionary.hasOwnProperty(ns))
                delete this._assetDictionary[ns];
        };
        AssetLibraryBundle.prototype.removeAssetFromDict = function (asset, autoRemoveEmptyNamespace) {
            if (autoRemoveEmptyNamespace === void 0) { autoRemoveEmptyNamespace = true; }
            if (this._assetDictDirty)
                this.rehashAssetDict();
            if (this._assetDictionary.hasOwnProperty(asset.adaptee.assetNamespace)) {
                if (this._assetDictionary[asset.adaptee.assetNamespace].hasOwnProperty(asset.adaptee.name.toString().toLowerCase()))
                    delete this._assetDictionary[asset.adaptee.assetNamespace][asset.adaptee.name.toString().toLowerCase()];
                if (autoRemoveEmptyNamespace) {
                    var key;
                    var empty = true;
                    for (key in this._assetDictionary[asset.adaptee.assetNamespace]) {
                        empty = false;
                        break;
                    }
                    if (empty)
                        delete this._assetDictionary[asset.adaptee.assetNamespace];
                }
            }
        };
        AssetLibraryBundle.prototype.stopAllLoaders = function () {
            var len = this._loaderSessions.length;
            for (var i = 0; i < len; i++)
                this.killloaderSession(this._loaderSessions[i]);
            this._loaderSessions = new Array();
        };
        AssetLibraryBundle.prototype.rehashAssetDict = function () {
            var asset;
            this._assetDictionary = {};
            var len = this._assets.length;
            for (var c = 0; c < len; c++) {
                asset = this._assets[c];
                if (!this._assetDictionary.hasOwnProperty(asset.adaptee.assetNamespace))
                    this._assetDictionary[asset.adaptee.assetNamespace] = {};
                this._assetDictionary[asset.adaptee.assetNamespace][asset.adaptee.name.toString().toLowerCase()] = asset;
            }
            this._assetDictDirty = false;
        };
        /**
         * Called when a an error occurs during loading.
         */
        AssetLibraryBundle.prototype.onLoadError = function (event) {
            if (this.hasEventListener(URLLoaderEvent.LOAD_ERROR)) {
                this.dispatchEvent(event);
                return true;
            }
            else {
                return false;
            }
        };
        /**
         * Called when a an error occurs during parsing.
         */
        AssetLibraryBundle.prototype.onParseError = function (event) {
            if (this.hasEventListener(ParserEvent.PARSE_ERROR)) {
                this.dispatchEvent(event);
                return true;
            }
            else {
                return false;
            }
        };
        AssetLibraryBundle.prototype.onAssetComplete = function (event) {
            // Only add asset to library the first time.
            if (event.type == AssetEvent.ASSET_COMPLETE)
                this.addAsset(event.asset.adapter);
            this.dispatchEvent(event);
        };
        AssetLibraryBundle.prototype.onTextureSizeError = function (event) {
            this.dispatchEvent(event);
        };
        /**
         * Called when the resource and all of its dependencies was retrieved.
         */
        AssetLibraryBundle.prototype.onLoadComplete = function (event) {
            var loader = event.target;
            this.dispatchEvent(event);
            this.disposeLoader(loader);
        };
        AssetLibraryBundle.prototype.killloaderSession = function (loader) {
            loader.removeEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoadCompleteDelegate);
            loader.removeEventListener(AssetEvent.TEXTURE_SIZE_ERROR, this._onTextureSizeErrorDelegate);
            loader.removeEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            loader.stop();
        };
        AssetLibraryBundle.prototype.onAssetRename = function (event) {
            var asset = event.target.adapter; // TODO: was ev.currentTarget - watch this var
            var old = this.getAsset(asset.adaptee.assetNamespace, asset.adaptee.name);
            if (old != null) {
                this._strategy.resolveConflict(asset, old, this._assetDictionary[asset.adaptee.assetNamespace], this._strategyPreference);
            }
            else {
                var dict = this._assetDictionary[event.asset.assetNamespace];
                if (dict == null)
                    return;
                dict[event.prevName] = null;
                dict[event.asset.name.toString().toLowerCase()] = event.asset;
            }
        };
        AssetLibraryBundle.prototype.onAssetConflictResolved = function (event) {
            this.dispatchEvent(event.clone());
        };
        AssetLibraryBundle._iInstances = new Object();
        return AssetLibraryBundle;
    }(EventDispatcher));

    /**
     * AssetLibrary enforces a singleton pattern and is not intended to be instanced.
     * It's purpose is to allow access to the default library bundle through a set of static shortcut methods.
     * If you are interested in creating multiple library bundles, please use the <code>getBundle()</code> method.
     */
    var AssetLibrary = /** @class */ (function () {
        /**
         * Creates a new <code>AssetLibrary</code> object.
         *
         */
        function AssetLibrary() {
        }
        //*/
        /**
         * Returns an AssetLibrary bundle instance. If no key is given, returns the default bundle (which is
         * similar to using the AssetLibraryBundle as a singleton). To keep several separated library bundles,
         * pass a string key to this method to define which bundle should be returned. This is
         * referred to as using the AssetLibraryBundle as a multiton.
         *
         * @param key Defines which multiton instance should be returned.
         * @return An instance of the asset library
         */
        AssetLibrary.getBundle = function (key) {
            if (key === void 0) { key = 'default'; }
            return AssetLibraryBundle.getInstance(key);
        };
        /**
         *
         */
        AssetLibrary.enableParser = function (parserClass) {
            Loader.enableParser(parserClass);
        };
        /**
         *
         */
        AssetLibrary.enableParsers = function (parserClasses) {
            Loader.enableParsers(parserClasses);
        };
        Object.defineProperty(AssetLibrary, "conflictStrategy", {
            /**
             * Short-hand for conflictStrategy property on default asset library bundle.
             *
             * @see AssetLibraryBundle.conflictStrategy
             */
            get: function () {
                return AssetLibrary.getBundle().conflictStrategy;
            },
            set: function (val) {
                AssetLibrary.getBundle().conflictStrategy = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AssetLibrary, "conflictPrecedence", {
            /**
             * Short-hand for conflictPrecedence property on default asset library bundle.
             *
             * @see AssetLibraryBundle.conflictPrecedence
             */
            get: function () {
                return AssetLibrary.getBundle().conflictPrecedence;
            },
            set: function (val) {
                AssetLibrary.getBundle().conflictPrecedence = val;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Short-hand for createIterator() method on default asset library bundle.
         *
         * @see AssetLibraryBundle.createIterator()
         */
        AssetLibrary.createIterator = function (assetTypeFilter, namespaceFilter, filterFunc) {
            if (assetTypeFilter === void 0) { assetTypeFilter = null; }
            if (namespaceFilter === void 0) { namespaceFilter = null; }
            if (filterFunc === void 0) { filterFunc = null; }
            return AssetLibrary.getBundle().createIterator(assetTypeFilter, namespaceFilter, filterFunc);
        };
        /**
         * Short-hand for load() method on default asset library bundle.
         *
         * @see AssetLibraryBundle.load()
         */
        AssetLibrary.load = function (req, context, ns, parser) {
            if (context === void 0) { context = null; }
            if (ns === void 0) { ns = null; }
            if (parser === void 0) { parser = null; }
            AssetLibrary.getBundle().load(req, context, ns, parser);
        };
        /**
         * Short-hand for loadData() method on default asset library bundle.
         *
         * @see AssetLibraryBundle.loadData()
         */
        AssetLibrary.loadData = function (data, context, ns, parser) {
            if (context === void 0) { context = null; }
            if (ns === void 0) { ns = null; }
            if (parser === void 0) { parser = null; }
            AssetLibrary.getBundle().loadData(data, context, ns, parser);
        };
        AssetLibrary.stopLoad = function () {
            AssetLibrary.getBundle().stopAllLoaders();
        };
        AssetLibrary.getLoader = function () {
            return AssetLibrary.getBundle().getLoader();
        };
        /**
         * Short-hand for getAsset() method on default asset library bundle.
         *
         * @see AssetLibraryBundle.getAsset()
         */
        AssetLibrary.getAsset = function (name, ns) {
            if (ns === void 0) { ns = null; }
            return AssetLibrary.getBundle().getAsset(name, ns);
        };
        /**
         * Short-hand for getAsset() method on default asset library bundle.
         *
         * @see AssetLibraryBundle.getAsset()
         */
        AssetLibrary.getAllAssets = function () {
            return AssetLibrary.getBundle().getAllAssets();
        };
        /**
         * Short-hand for addEventListener() method on default asset library bundle.
         */
        AssetLibrary.addEventListener = function (type, listener) {
            AssetLibrary.getBundle().addEventListener(type, listener);
        };
        /**
         * Short-hand for removeEventListener() method on default asset library bundle.
         */
        AssetLibrary.removeEventListener = function (type, listener) {
            AssetLibrary.getBundle().removeEventListener(type, listener);
        };
        /**
         * Short-hand for hasEventListener() method on default asset library bundle.

         public static hasEventListener(type:string):boolean
         {
            return AssetLibrary.getBundle().hasEventListener(type);
        }

         public static willTrigger(type:string):boolean
         {
            return getBundle().willTrigger(type);
        }
         */
        /**
         * Short-hand for addAsset() method on default asset library bundle.
         *
         * @see AssetLibraryBundle.addAsset()
         */
        AssetLibrary.addAsset = function (asset) {
            AssetLibrary.getBundle().addAsset(asset);
        };
        /**
         * Short-hand for removeAsset() method on default asset library bundle.
         *
         * @param asset The asset which should be removed from the library.
         * @param dispose Defines whether the assets should also be disposed.
         *
         * @see AssetLibraryBundle.removeAsset()
         */
        AssetLibrary.removeAsset = function (asset, dispose) {
            if (dispose === void 0) { dispose = true; }
            AssetLibrary.getBundle().removeAsset(asset, dispose);
        };
        /**
         * Short-hand for removeAssetByName() method on default asset library bundle.
         *
         * @param name The name of the asset to be removed.
         * @param ns The namespace to which the desired asset belongs.
         * @param dispose Defines whether the assets should also be disposed.
         *
         * @see AssetLibraryBundle.removeAssetByName()
         */
        AssetLibrary.removeAssetByName = function (name, ns, dispose) {
            if (ns === void 0) { ns = null; }
            if (dispose === void 0) { dispose = true; }
            return AssetLibrary.getBundle().removeAssetByName(name, ns, dispose);
        };
        /**
         * Short-hand for removeAllAssets() method on default asset library bundle.
         *
         * @param dispose Defines whether the assets should also be disposed.
         *
         * @see AssetLibraryBundle.removeAllAssets()
         */
        AssetLibrary.removeAllAssets = function (dispose) {
            if (dispose === void 0) { dispose = true; }
            AssetLibrary.getBundle().removeAllAssets(dispose);
        };
        /**
         * Short-hand for removeNamespaceAssets() method on default asset library bundle.
         *
         * @see AssetLibraryBundle.removeNamespaceAssets()
         */
        AssetLibrary.removeNamespaceAssets = function (ns, dispose) {
            if (ns === void 0) { ns = null; }
            if (dispose === void 0) { dispose = true; }
            AssetLibrary.getBundle().removeNamespaceAssets(ns, dispose);
        };
        return AssetLibrary;
    }());

    /**
     * The LoaderInfo export class provides information about a loaded SWF file or a
     * loaded image file(JPEG, GIF, or PNG). LoaderInfo objects are available for
     * any display object. The information provided includes load progress, the
     * URLs of the loader and loaded content, the number of bytes total for the
     * media, and the nominal height and width of the media.
     *
     * <p>You can access LoaderInfo objects in two ways: </p>
     *
     * <ul>
     *   <li>The <code>contentLoaderInfo</code> property of a flash.display.Loader
     * object -  The <code>contentLoaderInfo</code> property is always available
     * for any Loader object. For a Loader object that has not called the
     * <code>load()</code> or <code>loadBytes()</code> method, or that has not
     * sufficiently loaded, attempting to access many of the properties of the
     * <code>contentLoaderInfo</code> property throws an error.</li>
     *   <li>The <code>loaderInfo</code> property of a display object. </li>
     * </ul>
     *
     * <p>The <code>contentLoaderInfo</code> property of a Loader object provides
     * information about the content that the Loader object is loading, whereas
     * the <code>loaderInfo</code> property of a DisplayObject provides
     * information about the root SWF file for that display object. </p>
     *
     * <p>When you use a Loader object to load a display object(such as a SWF
     * file or a bitmap), the <code>loaderInfo</code> property of the display
     * object is the same as the <code>contentLoaderInfo</code> property of the
     * Loader object(<code>DisplayObject.loaderInfo =
     * Loader.contentLoaderInfo</code>). Because the instance of the main export class of
     * the SWF file has no Loader object, the <code>loaderInfo</code> property is
     * the only way to access the LoaderInfo for the instance of the main export class of
     * the SWF file.</p>
     *
     * <p>The following diagram shows the different uses of the LoaderInfo
     * object - for the instance of the main export class of the SWF file, for the
     * <code>contentLoaderInfo</code> property of a Loader object, and for the
     * <code>loaderInfo</code> property of a loaded object:</p>
     *
     * <p>When a loading operation is not complete, some properties of the
     * <code>contentLoaderInfo</code> property of a Loader object are not
     * available. You can obtain some properties, such as
     * <code>bytesLoaded</code>, <code>bytesTotal</code>, <code>url</code>,
     * <code>loaderURL</code>, and <code>applicationDomain</code>. When the
     * <code>loaderInfo</code> object dispatches the <code>init</code> event, you
     * can access all properties of the <code>loaderInfo</code> object and the
     * loaded image or SWF file.</p>
     *
     * <p><b>Note:</b> All properties of LoaderInfo objects are read-only.</p>
     *
     * <p>The <code>EventDispatcher.dispatchEvent()</code> method is not
     * applicable to LoaderInfo objects. If you call <code>dispatchEvent()</code>
     * on a LoaderInfo object, an IllegalOperationError exception is thrown.</p>
     *
     * @event complete   Dispatched when data has loaded successfully. In other
     *                   words, it is dispatched when all the content has been
     *                   downloaded and the loading has finished. The
     *                   <code>complete</code> event is always dispatched after
     *                   the <code>init</code> event. The <code>init</code> event
     *                   is dispatched when the object is ready to access, though
     *                   the content may still be downloading.
     * @event httpStatus Dispatched when a network request is made over HTTP and
     *                   an HTTP status code can be detected.
     * @event init       Dispatched when the properties and methods of a loaded
     *                   SWF file are accessible and ready for use. The content,
     *                   however, can still be downloading. A LoaderInfo object
     *                   dispatches the <code>init</code> event when the following
     *                   conditions exist:
     *                   <ul>
     *                     <li>All properties and methods associated with the
     *                   loaded object and those associated with the LoaderInfo
     *                   object are accessible.</li>
     *                     <li>The constructors for all child objects have
     *                   completed.</li>
     *                     <li>All ActionScript code in the first frame of the
     *                   loaded SWF's main timeline has been executed.</li>
     *                   </ul>
     *
     *                   <p>For example, an <code>Event.INIT</code> is dispatched
     *                   when the first frame of a movie or animation is loaded.
     *                   The movie is then accessible and can be added to the
     *                   display list. The complete movie, however, can take
     *                   longer to download. The <code>Event.COMPLETE</code> is
     *                   only dispatched once the full movie is loaded.</p>
     *
     *                   <p>The <code>init</code> event always precedes the
     *                   <code>complete</code> event.</p>
     * @event ioError    Dispatched when an input or output error occurs that
     *                   causes a load operation to fail.
     * @event open       Dispatched when a load operation starts.
     * @event progress   Dispatched when data is received as the download
     *                   operation progresses.
     * @event unload     Dispatched by a LoaderInfo object whenever a loaded
     *                   object is removed by using the <code>unload()</code>
     *                   method of the Loader object, or when a second load is
     *                   performed by the same Loader object and the original
     *                   content is removed prior to the load beginning.
     */
    var LoaderInfo = /** @class */ (function (_super) {
        __extends$1(LoaderInfo, _super);
        function LoaderInfo() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(LoaderInfo.prototype, "bytes", {
            /**
             * The bytes associated with a LoaderInfo object.
             *
             * @throws SecurityError If the object accessing this API is prevented from
             *                       accessing the loaded object due to security
             *                       restrictions. This situation can occur, for
             *                       instance, when a Loader object attempts to access
             *                       the <code>contentLoaderInfo.content</code> property
             *                       and it is not granted security permission to access
             *                       the loaded content.
             *
             *                       <p>For more information related to security, see the
             *                       Flash Player Developer Center Topic: <a
             *                       href="http://www.adobe.com/go/devnet_security_en"
             *                       scope="external">Security</a>.</p>
             */
            get: function () {
                return this._bytes;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo.prototype, "bytesLoaded", {
            /**
             * The number of bytes that are loaded for the media. When this number equals
             * the value of <code>bytesTotal</code>, all of the bytes are loaded.
             */
            get: function () {
                return this._bytesLoaded;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo.prototype, "bytesTotal", {
            /**
             * The number of compressed bytes in the entire media file.
             *
             * <p>Before the first <code>progress</code> event is dispatched by this
             * LoaderInfo object's corresponding Loader object, <code>bytesTotal</code>
             * is 0. After the first <code>progress</code> event from the Loader object,
             * <code>bytesTotal</code> reflects the actual number of bytes to be
             * downloaded.</p>
             */
            get: function () {
                return this._bytesTotal;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo.prototype, "content", {
            /**
             * The loaded object associated with this LoaderInfo object.
             *
             * @throws SecurityError If the object accessing this API is prevented from
             *                       accessing the loaded object due to security
             *                       restrictions. This situation can occur, for
             *                       instance, when a Loader object attempts to access
             *                       the <code>contentLoaderInfo.content</code> property
             *                       and it is not granted security permission to access
             *                       the loaded content.
             *
             *                       <p>For more information related to security, see the
             *                       Flash Player Developer Center Topic: <a
             *                       href="http://www.adobe.com/go/devnet_security_en"
             *                       scope="external">Security</a>.</p>
             */
            get: function () {
                return this._content;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo.prototype, "contentType", {
            /**
             * The MIME type of the loaded file. The value is <code>null</code> if not
             * enough of the file has loaded in order to determine the type. The
             * following list gives the possible values:
             * <ul>
             *   <li><code>"application/x-shockwave-flash"</code></li>
             *   <li><code>"image/jpeg"</code></li>
             *   <li><code>"image/gif"</code></li>
             *   <li><code>"image/png"</code></li>
             * </ul>
             */
            get: function () {
                return this._contentType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo.prototype, "loader", {
            /**
             * The Loader object associated with this LoaderInfo object. If this
             * LoaderInfo object is the <code>loaderInfo</code> property of the instance
             * of the main export class of the SWF file, no Loader object is associated.
             *
             * @throws SecurityError If the object accessing this API is prevented from
             *                       accessing the Loader object because of security
             *                       restrictions. This can occur, for instance, when a
             *                       loaded SWF file attempts to access its
             *                       <code>loaderInfo.loader</code> property and it is
             *                       not granted security permission to access the
             *                       loading SWF file.
             *
             *                       <p>For more information related to security, see the
             *                       Flash Player Developer Center Topic: <a
             *                       href="http://www.adobe.com/go/devnet_security_en"
             *                       scope="external">Security</a>.</p>
             */
            get: function () {
                return this._loader;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo.prototype, "url", {
            /**
             * The URL of the media being loaded.
             *
             * <p>Before the first <code>progress</code> event is dispatched by this
             * LoaderInfo object's corresponding Loader object, the value of the
             * <code>url</code> property might reflect only the initial URL specified in
             * the call to the <code>load()</code> method of the Loader object. After the
             * first <code>progress</code> event, the <code>url</code> property reflects
             * the media's final URL, after any redirects and relative URLs are
             * resolved.</p>
             *
             * <p>In some cases, the value of the <code>url</code> property is truncated;
             * see the <code>isURLInaccessible</code> property for details.</p>
             */
            get: function () {
                return this._url;
            },
            enumerable: true,
            configurable: true
        });
        return LoaderInfo;
    }(EventDispatcher));

    var URLRequest = /** @class */ (function () {
        /**

         * @param url
         */
        function URLRequest(url) {
            if (url === void 0) { url = null; }
            /**
             *
             * away.net.URLRequestMethod.GET
             * away.net.URLRequestMethod.POST
             *
             * @type {string}
             */
            this.method = URLRequestMethod.GET;
            /**
             * Use asynchronous XMLHttpRequest
             * @type {boolean}
             */
            this.async = true;
            this._url = url;
        }
        Object.defineProperty(URLRequest.prototype, "url", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return this._url;
            },
            /**
             *
             * @param value
             */
            set: function (value) {
                this._url = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * dispose
         */
        URLRequest.prototype.dispose = function () {
            this.data = null;
            this._url = null;
        };
        return URLRequest;
    }());

    var Timer = /** @class */ (function (_super) {
        __extends$1(Timer, _super);
        function Timer(delay, repeatCount) {
            if (repeatCount === void 0) { repeatCount = 0; }
            var _this = _super.call(this) || this;
            _this._repeatCount = 0;
            _this._currentCount = 0;
            _this._running = false;
            _this._delay = delay;
            _this._repeatCount = repeatCount;
            if (isNaN(delay) || delay < 0)
                throw new ErrorBase("Delay is negative or not a number");
            return _this;
        }
        Object.defineProperty(Timer.prototype, "currentCount", {
            get: function () {
                return this._currentCount;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Timer.prototype, "delay", {
            get: function () {
                return this._delay;
            },
            set: function (value) {
                this._delay = value;
                if (this._running) {
                    this.stop();
                    this.start();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Timer.prototype, "repeatCount", {
            get: function () {
                return this._repeatCount;
            },
            set: function (value) {
                this._repeatCount = value;
            },
            enumerable: true,
            configurable: true
        });
        Timer.prototype.reset = function () {
            if (this._running)
                this.stop();
            this._currentCount = 0;
        };
        Object.defineProperty(Timer.prototype, "running", {
            get: function () {
                return this._running;
            },
            enumerable: true,
            configurable: true
        });
        Timer.prototype.start = function () {
            var _this = this;
            this._running = true;
            clearInterval(this._iid);
            this._iid = setInterval(function () { return _this.tick(); }, this._delay);
        };
        Timer.prototype.stop = function () {
            this._running = false;
            clearInterval(this._iid);
        };
        Timer.prototype.tick = function () {
            this._currentCount++;
            if ((this._repeatCount > 0) && this._currentCount >= this._repeatCount) {
                this.stop();
                this.dispatchEvent(new TimerEvent(TimerEvent.TIMER));
                this.dispatchEvent(new TimerEvent(TimerEvent.TIMER_COMPLETE));
            }
            else {
                this.dispatchEvent(new TimerEvent(TimerEvent.TIMER));
            }
        };
        return Timer;
    }(EventDispatcher));

    /**
     *
     *
     * @returns {number}
     */
    function getTimer() {
        // number milliseconds of 1970/01/01
        // this different to AS3 implementation which gets the number of milliseconds
        // since instance of Flash player was initialised
        return Date.now();
    }

    /**
     * <code>ParserBase</code> provides an abstract base export class for objects that convert blocks of data to data structures
     * supported by away.
     *
     * If used by <code>Loader</code> to automatically determine the parser type, two public static methods should
     * be implemented, with the following signatures:
     *
     * <code>public static supportsType(extension : string) : boolean</code>
     * Indicates whether or not a given file extension is supported by the parser.
     *
     * <code>public static supportsData(data : *) : boolean</code>
     * Tests whether a data block can be parsed by the parser.
     *
     * Furthermore, for any concrete subtype, the method <code>initHandle</code> should be overridden to immediately
     * create the object that will contain the parsed data. This allows <code>ResourceManager</code> to return an object
     * handle regardless of whether the object was loaded or not.
     *
     * @see Loader
     */
    var ParserBase = /** @class */ (function (_super) {
        __extends$1(ParserBase, _super);
        /**
         * Creates a new ParserBase object
         * @param format The data format of the file data to be parsed. Can be either <code>ParserDataFormat.BINARY</code> or <code>ParserDataFormat.PLAIN_TEXT</code>, and should be provided by the concrete subtype.
         *
         * @see away.loading.parsers.ParserDataFormat
         */
        function ParserBase(format) {
            var _this = _super.call(this) || this;
            _this._materialMode = 0;
            _this._dataFormat = format;
            _this._dependencies = new Array();
            _this._pOnIntervalDelegate = function (event) { return _this._pOnInterval(event); };
            return _this;
        }
        //----------------------------------------------------------------------------------------------------------------------------------------------------------------
        // TODO: add error checking for the following ( could cause a problem if this function is not implemented )
        //----------------------------------------------------------------------------------------------------------------------------------------------------------------
        // Needs to be implemented in all Parsers (
        //<code>public static supportsType(extension : string) : boolean</code>
        //* Indicates whether or not a given file extension is supported by the parser.
        //----------------------------------------------------------------------------------------------------------------------------------------------------------------
        ParserBase.supportsType = function (extension) {
            throw new AbstractMethodError();
        };
        Object.defineProperty(ParserBase.prototype, "content", {
            /* Protected */
            get: function () {
                return this._pContent;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParserBase.prototype, "parsingFailure", {
            get: function () {
                return this._parsingFailure;
            },
            set: function (b) {
                this._parsingFailure = b;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParserBase.prototype, "parsingPaused", {
            get: function () {
                return this._parsingPaused;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParserBase.prototype, "parsingComplete", {
            get: function () {
                return this._parsingComplete;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParserBase.prototype, "materialMode", {
            get: function () {
                return this._materialMode;
            },
            set: function (newMaterialMode) {
                this._materialMode = newMaterialMode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParserBase.prototype, "data", {
            get: function () {
                return this._data;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParserBase.prototype, "dataFormat", {
            /**
             * The data format of the file data to be parsed. Options are <code>URLLoaderDataFormat.BINARY</code>, <code>URLLoaderDataFormat.ARRAY_BUFFER</code>, <code>URLLoaderDataFormat.BLOB</code>, <code>URLLoaderDataFormat.VARIABLES</code> or <code>URLLoaderDataFormat.TEXT</code>.
             */
            get: function () {
                return this._dataFormat;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Parse data (possibly containing bytearry, plain text or BitmapAsset) asynchronously, meaning that
         * the parser will periodically stop parsing so that the AVM may proceed to the
         * next frame.
         *
         * @param data The untyped data object in which the loaded data resides.
         * @param frameLimit number of milliseconds of parsing allowed per frame. The
         * actual time spent on a frame can exceed this number since time-checks can
         * only be performed between logical sections of the parsing procedure.
         */
        ParserBase.prototype.parseAsync = function (data, frameLimit) {
            if (frameLimit === void 0) { frameLimit = 30; }
            this._data = data;
            this._pStartParsing(frameLimit);
        };
        ParserBase.prototype.parseSync = function (data) {
            this._data = data;
            var state = ParserBase.MORE_TO_PARSE;
            while (state == ParserBase.MORE_TO_PARSE) {
                state = this._pProceedParsing();
            }
            return this._pContent;
        };
        Object.defineProperty(ParserBase.prototype, "dependencies", {
            /**
             * A list of dependencies that need to be loaded and resolved for the object being parsed.
             */
            get: function () {
                return this._dependencies;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Resolve a dependency when it's loaded. For example, a dependency containing an ImageResource would be assigned
         * to a Mesh instance as a BitmapMaterial, a scene graph object would be added to its intended parent. The
         * dependency should be a member of the dependencies property.
         *
         * @param resourceDependency The dependency to be resolved.
         */
        ParserBase.prototype._iResolveDependency = function (resourceDependency) {
            throw new AbstractMethodError();
        };
        /**
         * Resolve a dependency loading failure. Used by parser to eventually provide a default map
         *
         * @param resourceDependency The dependency to be resolved.
         */
        ParserBase.prototype._iResolveDependencyFailure = function (resourceDependency) {
            throw new AbstractMethodError();
        };
        /**
         * Resolve a dependency name
         *
         * @param resourceDependency The dependency to be resolved.
         */
        ParserBase.prototype._iResolveDependencyName = function (resourceDependency, asset) {
            return asset.name;
        };
        ParserBase.prototype._iResumeParsing = function () {
            this._parsingPaused = false;
            if (this._timer)
                this._timer.start();
            //get started!
            if (!this._isParsing)
                this._pOnInterval();
        };
        ParserBase.prototype._pFinalizeAsset = function (asset, name) {
            if (name === void 0) { name = null; }
            if (name != null)
                asset.name = name;
            // If the asset has no name, give it
            // a per-type default name.
            if (!asset.name)
                asset.name = asset.assetType;
            this.dispatchEvent(new AssetEvent(AssetEvent.ASSET_COMPLETE, asset));
        };
        /**
         * Parse the next block of data.
         * @return Whether or not more data needs to be parsed. Can be <code>ParserBase.ParserBase.PARSING_DONE</code> or
         * <code>ParserBase.ParserBase.MORE_TO_PARSE</code>.
         */
        ParserBase.prototype._pProceedParsing = function () {
            throw new AbstractMethodError();
        };
        ParserBase.prototype._pDieWithError = function (message) {
            if (message === void 0) { message = 'Unknown parsing error'; }
            if (this._timer) {
                this._timer.removeEventListener(TimerEvent.TIMER, this._pOnIntervalDelegate);
                this._timer.stop();
                this._timer = null;
            }
            this.dispatchEvent(new ParserEvent(ParserEvent.PARSE_ERROR, message));
        };
        ParserBase.prototype._pAddDependency = function (id, req, parser, data, retrieveAsRawData, suppressErrorEvents, sub_id) {
            if (parser === void 0) { parser = null; }
            if (data === void 0) { data = null; }
            if (retrieveAsRawData === void 0) { retrieveAsRawData = false; }
            if (suppressErrorEvents === void 0) { suppressErrorEvents = false; }
            if (sub_id === void 0) { sub_id = 0; }
            var dependency = new ResourceDependency(id, req, data, parser, this, retrieveAsRawData, suppressErrorEvents, sub_id);
            this._dependencies.push(dependency);
            return dependency;
        };
        ParserBase.prototype._pPauseAndRetrieveDependencies = function () {
            this._pPauseParsing();
            this.dispatchEvent(new ParserEvent(ParserEvent.READY_FOR_DEPENDENCIES));
        };
        ParserBase.prototype._pPauseParsing = function () {
            if (this._timer)
                this._timer.stop();
            this._parsingPaused = true;
        };
        /**
         * Tests whether or not there is still time left for parsing within the maximum allowed time frame per session.
         * @return True if there is still time left, false if the maximum allotted time was exceeded and parsing should be interrupted.
         */
        ParserBase.prototype._pHasTime = function () {
            return ((getTimer() - this._lastFrameTime) < this._frameLimit);
        };
        /**
         * Called when the parsing pause interval has passed and parsing can proceed.
         */
        ParserBase.prototype._pOnInterval = function (event) {
            if (event === void 0) { event = null; }
            this._lastFrameTime = getTimer();
            this._isParsing = true;
            if (this._pProceedParsing() && !this._parsingFailure)
                this._pFinishParsing();
            this._isParsing = false;
        };
        /**
         * Initializes the parsing of data.
         * @param frameLimit The maximum duration of a parsing session.
         */
        ParserBase.prototype._pStartParsing = function (frameLimit) {
            this._frameLimit = frameLimit;
            this._timer = new Timer(this._frameLimit, 0);
            this._timer.addEventListener(TimerEvent.TIMER, this._pOnIntervalDelegate);
            this._timer.start();
            //get started!
            this._pOnInterval();
        };
        /**
         * Finish parsing the data.
         */
        ParserBase.prototype._pFinishParsing = function () {
            if (this._timer) {
                this._timer.removeEventListener(TimerEvent.TIMER, this._pOnIntervalDelegate);
                this._timer.stop();
            }
            this._timer = null;
            this._parsingComplete = true;
            this._isParsing = false;
            this.dispatchEvent(new ParserEvent(ParserEvent.PARSE_COMPLETE));
        };
        /**
         *
         * @returns {string}
         * @private
         */
        ParserBase.prototype._pGetTextData = function () {
            return ParserUtils.toString(this._data);
        };
        /**
         *
         * @returns {ByteArray}
         * @private
         */
        ParserBase.prototype._pGetByteData = function () {
            return ParserUtils.toByteArray(this._data);
        };
        /**
         *
         * @returns {any}
         * @private
         */
        ParserBase.prototype._pGetData = function () {
            return this._data;
        };
        /**
         * Returned by <code>proceedParsing</code> to indicate no more parsing is needed.
         */
        ParserBase.PARSING_DONE = true;
        /* Protected */
        /**
         * Returned by <code>proceedParsing</code> to indicate more parsing is needed, allowing asynchronous parsing.
         */
        ParserBase.MORE_TO_PARSE = false;
        return ParserBase;
    }(EventDispatcher));

    /**
     * An enumeration providing values to describe the data format of parsed data.
     */

    var WaveAudioParser = /** @class */ (function (_super) {
        __extends$1(WaveAudioParser, _super);
        function WaveAudioParser() {
            return _super.call(this, URLLoaderDataFormat.BLOB) || this;
        }
        WaveAudioParser.supportsType = function (extension) {
            extension = extension.toLowerCase();
            return extension == "wav" || extension == "mp3" || extension == "ogg";
        };
        WaveAudioParser.supportsData = function (data) {
            if (!(data instanceof ByteArray))
                return false;
            var ba = data;
            var filetype = WaveAudioParser.parseFileType(ba);
            return filetype ? true : false;
        };
        WaveAudioParser.prototype._pStartParsing = function (frameLimit) {
            //clear content
            delete this._pContent;
            this._pContent = null;
            _super.prototype._pStartParsing.call(this, frameLimit);
        };
        WaveAudioParser.prototype._pProceedParsing = function () {
            this._pContent = new WaveAudio(new WaveAudioData(this.data));
            this._pFinalizeAsset(this._pContent, this._iFileName);
            return ParserBase.PARSING_DONE;
        };
        WaveAudioParser.parseFileType = function (ba) {
            //old mp3 detections
            // This does not seem to work for all my mp3 files (i tested different mp3 encoders)
            // I leave it in, because it might work for mp3 data that i do not have here to test
            ba.position = 0;
            if ((ba.readUnsignedShort() & 0xFFE0) == 0xFFE0) {
                return 'mp3'; // test for MP3 syncword
            }
            // new mp3 detection
            // this from is-mp3 npm module,
            // but still i have mp3 files that are not detected by this
            // i added the hack: (byte_1 === 255 && byte_2 === 243 && byte_3 === 130) 	to catch those mp3s
            // todo: find a more foolproof way to detect al mp3 (my hack might collide with detection for other filetypes)
            ba.position = 0;
            var byte_1 = ba.readUnsignedByte();
            var byte_2 = ba.readUnsignedByte();
            var byte_3 = ba.readUnsignedByte();
            if ((byte_1 === 73 && byte_2 === 68 && byte_3 === 51)
                || (byte_1 === 255 && byte_2 === 251)
                || (byte_1 === 255 && byte_2 === 243 && byte_3 === 130)) {
                return 'mp3';
            }
            ba.position = 0;
            if (ba.readUTFBytes(4) == 'RIFF')
                return 'wav';
            ba.position = 0;
            if (ba.readUTFBytes(4) == 'OggS')
                return 'ogg';
            ba.position = 0;
            return null;
        };
        /*
            this static property can be set with a function that that will be called on each filename before adding it to the library
        */
        WaveAudioParser.processFilename = function (filename) {
            return filename;
        };
        return WaveAudioParser;
    }(ParserBase));

    /**
     * Provides constant values for camera lens projection options use the the <code>coordinateSystem</code> property
     *
     * @see away.projections.PerspectiveLens#coordinateSystem
     */
    var CoordinateSystem;
    (function (CoordinateSystem) {
        /**
         * Default option, projects to a left-handed coordinate system
         */
        CoordinateSystem[CoordinateSystem["LEFT_HANDED"] = 0] = "LEFT_HANDED";
        /**
         * Projects to a right-handed coordinate system
         */
        CoordinateSystem[CoordinateSystem["RIGHT_HANDED"] = 1] = "RIGHT_HANDED";
    })(CoordinateSystem || (CoordinateSystem = {}));

    var ProjectionBase = /** @class */ (function (_super) {
        __extends$1(ProjectionBase, _super);
        function ProjectionBase(coordinateSystem) {
            if (coordinateSystem === void 0) { coordinateSystem = CoordinateSystem.LEFT_HANDED; }
            var _this = _super.call(this) || this;
            _this._viewMatrix3D = new Matrix3D();
            _this._inverseViewMatrix3D = new Matrix3D();
            _this._frustumMatrix3D = new Matrix3D();
            _this._near = 20;
            _this._far = 3000;
            _this._scale = 1;
            _this._ratio = 1;
            _this._originX = 0;
            _this._originY = 0;
            _this._frustumRect = new Rectangle();
            _this._viewFrustumCorners = [];
            _this._viewMatrix3DDirty = true;
            _this._inverseViewMatrix3DDirty = true;
            _this._frustumMatrix3DDirty = true;
            _this._viewFrustumCornersDirty = true;
            _this._viewFrustumPlanesDirty = true;
            _this._coordinateSystem = coordinateSystem;
            _this._onInvalidateConcatenatedMatrix3DDelegate = function (event) { return _this._onInvalidateConcatenatedMatrix3D(event); };
            return _this;
        }
        Object.defineProperty(ProjectionBase.prototype, "transform", {
            get: function () {
                return this._transform;
            },
            set: function (value) {
                if (this._transform == value)
                    return;
                if (this._transform)
                    this._transform.removeEventListener(TransformEvent.INVALIDATE_CONCATENATED_MATRIX3D, this._onInvalidateConcatenatedMatrix3DDelegate);
                this._transform = value;
                if (this._transform)
                    this._transform.addEventListener(TransformEvent.INVALIDATE_CONCATENATED_MATRIX3D, this._onInvalidateConcatenatedMatrix3DDelegate);
                this._invalidateViewMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectionBase.prototype, "coordinateSystem", {
            /**
             * The handedness of the coordinate system projection. The default is LEFT_HANDED.
             */
            get: function () {
                return this._coordinateSystem;
            },
            set: function (value) {
                if (this._coordinateSystem == value)
                    return;
                this._coordinateSystem = value;
                this._invalidateFrustumMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectionBase.prototype, "scale", {
            /**
             *
             */
            get: function () {
                if (this._propertiesDirty)
                    this._updateProperties();
                return this._scale;
            },
            set: function (value) {
                if (this._scale == value)
                    return;
                this._scale = value;
                this._invalidateFrustumMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectionBase.prototype, "ratio", {
            /**
             *
             */
            get: function () {
                if (this._propertiesDirty)
                    this._updateProperties();
                return this._ratio;
            },
            set: function (value) {
                if (this._ratio == value)
                    return;
                this._ratio = value;
                this._invalidateFrustumMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectionBase.prototype, "frustumMatrix3D", {
            /**
             *
             * @returns {Matrix3D}
             */
            get: function () {
                if (this._frustumMatrix3DDirty)
                    this._updateFrustumMatrix3D();
                return this._frustumMatrix3D;
            },
            set: function (value) {
                this._frustumMatrix3D = value;
                this._invalidateViewMatrix3D();
                this._invalidateProperties();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectionBase.prototype, "viewFrustumCorners", {
            /**
             *
             * @returns {number[]}
             */
            get: function () {
                if (this._viewFrustumCornersDirty) {
                    this._viewFrustumCornersDirty = false;
                    if (this._frustumMatrix3DDirty)
                        this._updateFrustumMatrix3D();
                    var left = this._frustumRect.left;
                    var right = this._frustumRect.right;
                    var top = this._frustumRect.top;
                    var bottom = this._frustumRect.bottom;
                    if (this._propertiesDirty)
                        this._updateProperties();
                    var near = this._near;
                    var far = this._far;
                    this._viewFrustumCorners[0] = this._viewFrustumCorners[9] = near * left;
                    this._viewFrustumCorners[3] = this._viewFrustumCorners[6] = near * right;
                    this._viewFrustumCorners[1] = this._viewFrustumCorners[4] = near * top;
                    this._viewFrustumCorners[7] = this._viewFrustumCorners[10] = near * bottom;
                    this._viewFrustumCorners[12] = this._viewFrustumCorners[21] = far * left;
                    this._viewFrustumCorners[15] = this._viewFrustumCorners[18] = far * right;
                    this._viewFrustumCorners[13] = this._viewFrustumCorners[16] = far * top;
                    this._viewFrustumCorners[19] = this._viewFrustumCorners[22] = far * bottom;
                    this._viewFrustumCorners[2] = this._viewFrustumCorners[5] = this._viewFrustumCorners[8] = this._viewFrustumCorners[11] = near;
                    this._viewFrustumCorners[14] = this._viewFrustumCorners[17] = this._viewFrustumCorners[20] = this._viewFrustumCorners[23] = far;
                    this._transform.concatenatedMatrix3D.transformVectors(this._viewFrustumCorners, this._viewFrustumCorners);
                }
                return this._viewFrustumCorners;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectionBase.prototype, "viewFrustumPlanes", {
            /**
             *
             */
            get: function () {
                if (this._viewFrustumPlanesDirty) {
                    this._viewFrustumPlanesDirty = false;
                    if (!this._viewFrustumPlanes) {
                        this._viewFrustumPlanes = [];
                        for (var i = 0; i < 6; ++i)
                            this._viewFrustumPlanes[i] = new Plane3D();
                    }
                    var raw = this.viewMatrix3D._rawData;
                    var invLen;
                    var c11 = raw[0], c12 = raw[4], c13 = raw[8], c14 = raw[12];
                    var c21 = raw[1], c22 = raw[5], c23 = raw[9], c24 = raw[13];
                    var c31 = raw[2], c32 = raw[6], c33 = raw[10], c34 = raw[14];
                    var c41 = raw[3], c42 = raw[7], c43 = raw[11], c44 = raw[15];
                    var a, b, c, p;
                    // left plane
                    p = this._viewFrustumPlanes[0];
                    a = c41 + c11;
                    b = c42 + c12;
                    c = c43 + c13;
                    invLen = 1 / Math.sqrt(a * a + b * b + c * c);
                    p.a = a * invLen;
                    p.b = b * invLen;
                    p.c = c * invLen;
                    p.d = -(c44 + c14) * invLen;
                    // right plane
                    p = this._viewFrustumPlanes[1];
                    a = c41 - c11;
                    b = c42 - c12;
                    c = c43 - c13;
                    invLen = 1 / Math.sqrt(a * a + b * b + c * c);
                    p.a = a * invLen;
                    p.b = b * invLen;
                    p.c = c * invLen;
                    p.d = (c14 - c44) * invLen;
                    // bottom
                    p = this._viewFrustumPlanes[2];
                    a = c41 + c21;
                    b = c42 + c22;
                    c = c43 + c23;
                    invLen = 1 / Math.sqrt(a * a + b * b + c * c);
                    p.a = a * invLen;
                    p.b = b * invLen;
                    p.c = c * invLen;
                    p.d = -(c44 + c24) * invLen;
                    // top
                    p = this._viewFrustumPlanes[3];
                    a = c41 - c21;
                    b = c42 - c22;
                    c = c43 - c23;
                    invLen = 1 / Math.sqrt(a * a + b * b + c * c);
                    p.a = a * invLen;
                    p.b = b * invLen;
                    p.c = c * invLen;
                    p.d = (c24 - c44) * invLen;
                    // near
                    p = this._viewFrustumPlanes[4];
                    a = c31;
                    b = c32;
                    c = c33;
                    invLen = 1 / Math.sqrt(a * a + b * b + c * c);
                    p.a = a * invLen;
                    p.b = b * invLen;
                    p.c = c * invLen;
                    p.d = -c34 * invLen;
                    // far
                    p = this._viewFrustumPlanes[5];
                    a = c41 - c31;
                    b = c42 - c32;
                    c = c43 - c33;
                    invLen = 1 / Math.sqrt(a * a + b * b + c * c);
                    p.a = a * invLen;
                    p.b = b * invLen;
                    p.c = c * invLen;
                    p.d = (c34 - c44) * invLen;
                }
                return this._viewFrustumPlanes;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectionBase.prototype, "near", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                if (this._propertiesDirty)
                    this._updateProperties();
                return this._near;
            },
            set: function (value) {
                if (value == this._near)
                    return;
                this._near = value;
                this._invalidateFrustumMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectionBase.prototype, "originX", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                if (this._propertiesDirty)
                    this._updateProperties();
                return this._originX;
            },
            set: function (value) {
                if (this._originX == value)
                    return;
                this._originX = value;
                this._invalidateFrustumMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectionBase.prototype, "originY", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                if (this._propertiesDirty)
                    this._updateProperties();
                return this._originY;
            },
            set: function (value) {
                if (this._originY == value)
                    return;
                this._originY = value;
                this._invalidateFrustumMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectionBase.prototype, "far", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                if (this._propertiesDirty)
                    this._updateProperties();
                return this._far;
            },
            set: function (value) {
                if (value == this._far)
                    return;
                this._far = value;
                this._invalidateFrustumMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectionBase.prototype, "frustumRect", {
            get: function () {
                if (this._frustumMatrix3DDirty)
                    this._updateFrustumMatrix3D();
                return this._frustumRect;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         * @param position
         * @param target
         */
        ProjectionBase.prototype.project = function (position, target) {
            if (target === void 0) { target = null; }
            throw new AbstractMethodError();
        };
        /**
         *
         * @param nX
         * @param nY
         * @param sZ
         * @param target
         */
        ProjectionBase.prototype.unproject = function (nX, nY, sZ, target) {
            if (target === void 0) { target = null; }
            throw new AbstractMethodError();
        };
        Object.defineProperty(ProjectionBase.prototype, "viewMatrix3D", {
            get: function () {
                if (this._viewMatrix3DDirty) {
                    this._viewMatrix3DDirty = false;
                    if (this._transform) {
                        this._viewMatrix3D.copyFrom(this._transform.inverseConcatenatedMatrix3D);
                        this._viewMatrix3D.append(this.frustumMatrix3D);
                    }
                    else {
                        this._viewMatrix3D.copyFrom(this.frustumMatrix3D);
                    }
                }
                return this._viewMatrix3D;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProjectionBase.prototype, "inverseViewMatrix3D", {
            get: function () {
                if (this._inverseViewMatrix3DDirty) {
                    this._inverseViewMatrix3DDirty = false;
                    this._inverseViewMatrix3D.copyFrom(this.viewMatrix3D);
                    this._inverseViewMatrix3D.invert();
                }
                return this._inverseViewMatrix3D;
            },
            enumerable: true,
            configurable: true
        });
        ProjectionBase.prototype.clone = function () {
            throw new AbstractMethodError();
        };
        ProjectionBase.prototype._invalidateProperties = function () {
            this._propertiesDirty = true;
        };
        ProjectionBase.prototype._invalidateViewMatrix3D = function () {
            this._viewMatrix3DDirty = true;
            this._inverseViewMatrix3DDirty = true;
            this._viewFrustumCornersDirty = true;
            this._viewFrustumPlanesDirty = true;
            this.dispatchEvent(new ProjectionEvent(ProjectionEvent.INVALIDATE_VIEW_MATRIX3D, this));
        };
        ProjectionBase.prototype._invalidateFrustumMatrix3D = function () {
            if (this._propertiesDirty)
                this._updateProperties();
            this._frustumMatrix3DDirty = true;
            this.dispatchEvent(new ProjectionEvent(ProjectionEvent.INVALIDATE_FRUSTUM_MATRIX3D, this));
            this._invalidateViewMatrix3D();
        };
        ProjectionBase.prototype._updateFrustumMatrix3D = function () {
            this._frustumMatrix3DDirty = false;
        };
        ProjectionBase.prototype._updateProperties = function () {
            this._propertiesDirty = false;
        };
        ProjectionBase.prototype._onInvalidateConcatenatedMatrix3D = function (event) {
            this._invalidateViewMatrix3D();
        };
        return ProjectionBase;
    }(EventDispatcher));

    var ObliqueNearPlaneProjection = /** @class */ (function (_super) {
        __extends$1(ObliqueNearPlaneProjection, _super);
        function ObliqueNearPlaneProjection(baseProjection, plane) {
            var _this = _super.call(this) || this;
            _this.baseProjection = baseProjection;
            _this.plane = plane;
            _this._onProjectionMatrixChangedDelegate = function (event) { return _this.onProjectionMatrixChanged(event); };
            return _this;
        }
        Object.defineProperty(ObliqueNearPlaneProjection.prototype, "near", {
            //@override
            get: function () {
                return this._baseProjection.near;
            },
            //@override
            set: function (value) {
                this._baseProjection.near = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObliqueNearPlaneProjection.prototype, "far", {
            //@override
            get: function () {
                return this._baseProjection.far;
            },
            //@override
            set: function (value) {
                this._baseProjection.far = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObliqueNearPlaneProjection.prototype, "plane", {
            get: function () {
                return this._plane;
            },
            set: function (value) {
                this._plane = value;
                this._invalidateFrustumMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ObliqueNearPlaneProjection.prototype, "baseProjection", {
            set: function (value) {
                if (this._baseProjection)
                    this._baseProjection.removeEventListener(ProjectionEvent.INVALIDATE_FRUSTUM_MATRIX3D, this._onProjectionMatrixChangedDelegate);
                this._baseProjection = value;
                if (this._baseProjection)
                    this._baseProjection.addEventListener(ProjectionEvent.INVALIDATE_FRUSTUM_MATRIX3D, this._onProjectionMatrixChangedDelegate);
                this._invalidateFrustumMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        ObliqueNearPlaneProjection.prototype.onProjectionMatrixChanged = function (event) {
            this._invalidateFrustumMatrix3D();
        };
        //@override
        ObliqueNearPlaneProjection.prototype._updateFrustumMatrix3D = function () {
            _super.prototype._updateFrustumMatrix3D.call(this);
            this._frustumMatrix3D.copyFrom(this._baseProjection.frustumMatrix3D);
            var cx = this._plane.a;
            var cy = this._plane.b;
            var cz = this._plane.c;
            var cw = -this._plane.d + .05;
            var signX = cx >= 0 ? 1 : -1;
            var signY = cy >= 0 ? 1 : -1;
            var p = new Vector3D(signX, signY, 1, 1);
            var inverse = this._frustumMatrix3D.clone();
            inverse.invert();
            var q = inverse.transformVector(p);
            this._frustumMatrix3D.copyRowTo(3, p);
            var a = (q.x * p.x + q.y * p.y + q.z * p.z + q.w * p.w) / (cx * q.x + cy * q.y + cz * q.z + cw * q.w);
            this._frustumMatrix3D.copyRowFrom(2, new Vector3D(cx * a, cy * a, cz * a, cw * a));
        };
        return ObliqueNearPlaneProjection;
    }(ProjectionBase));

    var OrthographicProjection = /** @class */ (function (_super) {
        __extends$1(OrthographicProjection, _super);
        function OrthographicProjection(scale, coordinateSystem) {
            if (scale === void 0) { scale = 1; }
            if (coordinateSystem === void 0) { coordinateSystem = CoordinateSystem.LEFT_HANDED; }
            var _this = _super.call(this, coordinateSystem) || this;
            _this.scale = scale;
            return _this;
        }
        /**
         *
         * @param position
         * @param target
         */
        OrthographicProjection.prototype.project = function (position, target) {
            if (target === void 0) { target = null; }
            var v = this.viewMatrix3D.transformVector(position, target);
            v.x = v.x;
            v.y = -v.y;
            v.z = (v.z * (this._far - this._near) + this._far + this._near) / 2;
            v.w = 1;
            return v;
        };
        /**
         *
         * @param nX
         * @param nY
         * @param sZ
         * @param target
         */
        OrthographicProjection.prototype.unproject = function (nX, nY, sZ, target) {
            if (target === void 0) { target = null; }
            if (target == null)
                target = new Vector3D();
            target.x = nX * sZ;
            target.y = -nY * sZ;
            target.z = (sZ * 2 - this._far - this._near) / (this._far - this._near);
            target.w = 1;
            this.inverseViewMatrix3D.transformVector(target, target);
            target.w = 1;
            return target;
        };
        //@override
        OrthographicProjection.prototype.clone = function () {
            var clone = new OrthographicProjection(this.scale, this._coordinateSystem);
            clone._near = this._near;
            clone._far = this._far;
            clone._coordinateSystem = this._coordinateSystem;
            return clone;
        };
        //@override
        OrthographicProjection.prototype._updateFrustumMatrix3D = function () {
            _super.prototype._updateFrustumMatrix3D.call(this);
            var raw = this._frustumMatrix3D._rawData;
            var scaleV = this._scale;
            var scaleH = this._scale / this._ratio;
            this._frustumRect.left = 0.5 * (this._originX - 1) / scaleH;
            this._frustumRect.top = 0.5 * (this._originY - 1) / scaleV;
            this._frustumRect.right = this._frustumRect.left + 1 / scaleH;
            this._frustumRect.bottom = this._frustumRect.top + 1 / scaleV;
            raw[0] = 2 * scaleH; //2/(right - left);
            raw[5] = 2 * scaleV; //2/(bottom - top);
            raw[12] = this._originX; //(right + left)/(right - left)
            raw[13] = this._originY; //(bottom + top)/(bottom - top);
            raw[10] = 2 / (this._far - this._near);
            raw[14] = -(this._far + this._near) / (this._far - this._near);
            raw[1] = raw[2] = raw[3] = raw[4] = raw[6] = raw[7] = raw[8] = raw[9] = raw[11] = 0;
            raw[15] = 1;
            this._frustumMatrix3D.invalidatePosition();
        };
        OrthographicProjection.prototype._updateProperties = function () {
            _super.prototype._updateProperties.call(this);
            var rawData = this._frustumMatrix3D._rawData;
            this._near = -(rawData[14] + 1) / rawData[10];
            this._far = -(rawData[14] - 1) / rawData[10];
            this._originX = rawData[8];
            this._originY = rawData[9];
            this._scale = rawData[5] / 2;
            this._ratio = 0.5 * this._scale / rawData[0];
        };
        return OrthographicProjection;
    }(ProjectionBase));

    var PerspectiveProjection = /** @class */ (function (_super) {
        __extends$1(PerspectiveProjection, _super);
        function PerspectiveProjection(fieldOfView, coordinateSystem) {
            if (fieldOfView === void 0) { fieldOfView = 60; }
            if (coordinateSystem === void 0) { coordinateSystem = CoordinateSystem.LEFT_HANDED; }
            var _this = _super.call(this, coordinateSystem) || this;
            _this.fieldOfView = fieldOfView;
            return _this;
        }
        Object.defineProperty(PerspectiveProjection.prototype, "fieldOfView", {
            /**
             *
             */
            get: function () {
                return Math.atan(0.5 / this.scale) * 360 / Math.PI;
            },
            set: function (value) {
                this.scale = 0.5 / Math.tan(value * Math.PI / 360);
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         * @param position
         * @param target
         */
        PerspectiveProjection.prototype.project = function (position, target) {
            if (target === void 0) { target = null; }
            var v = this.viewMatrix3D.transformVector(position, target);
            v.x = v.x / v.w;
            v.y = -v.y / v.w;
            //z is remapped to w
            v.z = v.w;
            v.w = 1;
            return v;
        };
        /**
         *
         * @param nX
         * @param nY
         * @param sZ
         * @param target
         */
        PerspectiveProjection.prototype.unproject = function (nX, nY, sZ, target) {
            if (target === void 0) { target = null; }
            if (target == null)
                target = new Vector3D();
            target.x = nX * sZ;
            target.y = -nY * sZ;
            target.z = (this._far + this._near) / (this._far - this._near) * sZ - 2 * this._far * this._near / (this._far - this._near);
            target.w = sZ;
            this.inverseViewMatrix3D.transformVector(target, target);
            target.w = 1;
            return target;
        };
        /**
         *
         * @returns {PerspectiveProjection}
         */
        PerspectiveProjection.prototype.clone = function () {
            var clone = new PerspectiveProjection(this.fieldOfView, this._coordinateSystem);
            clone._near = this._near;
            clone._far = this._far;
            clone._coordinateSystem = this._coordinateSystem;
            return clone;
        };
        /**
         *
         * @private
         */
        PerspectiveProjection.prototype._updateFrustumMatrix3D = function () {
            _super.prototype._updateFrustumMatrix3D.call(this);
            var raw = this._frustumMatrix3D._rawData;
            var scaleV = this._scale;
            var scaleH = this._scale / this._ratio;
            this._frustumRect.left = 0.5 * (this._originX - 1) / scaleH;
            this._frustumRect.top = 0.5 * (this._originY - 1) / scaleV;
            this._frustumRect.right = this._frustumRect.left + 1 / scaleH;
            this._frustumRect.bottom = this._frustumRect.top + 1 / scaleV;
            raw[0] = 2 * scaleH; //2/(right - left);
            raw[5] = 2 * scaleV; //2/(bottom - top);
            raw[8] = this._originX; //(right + left)/(right - left)
            raw[9] = this._originY; //(bottom + top)/(bottom - top);
            raw[10] = (this._far + this._near) / (this._far - this._near);
            raw[11] = 1;
            raw[1] = raw[2] = raw[3] = raw[4] = raw[6] = raw[7] = raw[12] = raw[13] = raw[15] = 0;
            raw[14] = -2 * this._far * this._near / (this._far - this._near);
            if (this._coordinateSystem == CoordinateSystem.RIGHT_HANDED)
                raw[5] = -raw[5];
            this._frustumMatrix3D.invalidatePosition();
        };
        PerspectiveProjection.prototype._updateProperties = function () {
            _super.prototype._updateProperties.call(this);
            var rawData = this._frustumMatrix3D._rawData;
            this._near = rawData[14] / (-1 - rawData[10]);
            this._far = rawData[14] / (1 - rawData[10]);
            this._scale = rawData[5] / 2;
            this._ratio = 0.5 * this._scale / rawData[0];
            this._originX = rawData[8];
            this._originY = rawData[9];
        };
        return PerspectiveProjection;
    }(ProjectionBase));

    // helper class for places that needs different behaviour based on if we are building for AVM1 or not
    // hopefully in future this will no longer be needed, but for now its the best we can do to make adjustments per project easier / clearer
    var BuildMode = /** @class */ (function () {
        function BuildMode() {
        }
        // used when building AwayJS to use with AVM1
        BuildMode.AVM1 = "avm1";
        // used when building AwayJS to use with AS2 Framescript that have been converted to js
        BuildMode.AS2_AS_JS = "as2asjs";
        // used when building standart AwayJS (not for AVM1)
        BuildMode.STANDART = "standart";
        BuildMode.mode = BuildMode.STANDART;
        return BuildMode;
    }());

    var Byte32Array = /** @class */ (function () {
        function Byte32Array(byteLength) {
            if (byteLength === void 0) { byteLength = 0; }
            this._maxLength = -1;
            this.bytePosition = 0;
            this.byteLength = -1;
            this._ensureSpace(byteLength);
        }
        Object.defineProperty(Byte32Array.prototype, "arrayBuffer", {
            get: function () {
                return this._arrayBuffer;
            },
            set: function (value) {
                //reset position
                this.bytePosition = 0;
                //clear length
                this.byteLength = -1;
                this._maxLength = -1;
                //calc new length
                this._ensureSpace(value.byteLength);
                //write new buffer
                this._int32Array.set(new Int32Array(value));
            },
            enumerable: true,
            configurable: true
        });
        Byte32Array.prototype.readByte32Array = function (byte32Array, byteLength) {
            if (byteLength === void 0) { byteLength = -1; }
            if (byteLength == -1)
                byteLength = byte32Array.byteLength - byte32Array.bytePosition;
            byte32Array.writeInt32Array(this._int32Array.subarray(this.bytePosition / 4, (this.bytePosition + byteLength) / 4));
            this.bytePosition += byteLength;
        };
        Byte32Array.prototype.writeByte32Array = function (byte32Array) {
            byte32Array.bytePosition = 0;
            byte32Array.readByte32Array(this, byte32Array.byteLength);
        };
        Byte32Array.prototype.writeFloat32Array = function (float32Array) {
            this._ensureSpace(this.bytePosition + float32Array.length * 4);
            this._float32Array.set(float32Array, this.bytePosition / 4);
            this.bytePosition += float32Array.length * 4;
        };
        Byte32Array.prototype.writeInt32Array = function (int32Array) {
            this._ensureSpace(this.bytePosition + int32Array.length * 4);
            this._uint32Array.set(int32Array, this.bytePosition / 4);
            this.bytePosition += int32Array.length * 4;
        };
        Byte32Array.prototype.writeUint32Array = function (uint32Array) {
            this._ensureSpace(this.bytePosition + uint32Array.length * 4);
            this._uint32Array.set(uint32Array, this.bytePosition / 4);
            this.bytePosition += uint32Array.length * 4;
        };
        Byte32Array.prototype.readFloat32Array = function (float32Array) {
            float32Array.set(this._float32Array.subarray(this.bytePosition / 4, this.bytePosition / 4 + float32Array.length));
        };
        Byte32Array.prototype.readInt32Array = function (int32Array) {
            int32Array.set(this._int32Array.subarray(this.bytePosition / 4, this.bytePosition / 4 + int32Array.length));
        };
        Byte32Array.prototype.readUint32Array = function (uint32Array) {
            uint32Array.set(this._uint32Array.subarray(this.bytePosition / 4, this.bytePosition / 4 + uint32Array.length));
        };
        Byte32Array.prototype.getBytesAvailable = function () {
            return this.byteLength - this.bytePosition;
        };
        Byte32Array.prototype.readUTFBytes = function (len) {
            var value = "";
            var max = this.bytePosition + len;
            var data = new DataView(this._arrayBuffer);
            // utf8-encode
            while (this.bytePosition < max) {
                var c = data.getUint8(this.bytePosition++);
                if (c < 0x80) {
                    if (c == 0)
                        break;
                    value += String.fromCharCode(c);
                }
                else if (c < 0xE0) {
                    value += String.fromCharCode(((c & 0x3F) << 6) | (data.getUint8(this.bytePosition++) & 0x7F));
                }
                else if (c < 0xF0) {
                    var c2 = data.getUint8(this.bytePosition++);
                    value += String.fromCharCode(((c & 0x1F) << 12) | ((c2 & 0x7F) << 6) | (data.getUint8(this.bytePosition++) & 0x7F));
                }
                else {
                    var c2 = data.getUint8(this.bytePosition++);
                    var c3 = data.getUint8(this.bytePosition++);
                    value += String.fromCharCode(((c & 0x0F) << 18) | ((c2 & 0x7F) << 12) | ((c3 << 6) & 0x7F) | (data.getUint8(this.bytePosition++) & 0x7F));
                }
            }
            return value;
        };
        Byte32Array.prototype.writeUTFBytes = function (s) {
            var escstr = encodeURIComponent(s);
            var binstr = escstr.replace(/%([0-9A-F]{2})/g, function (match, p1) {
                return String.fromCharCode(parseInt('0x' + p1));
            });
            if (binstr.length % 4) {
                var padding = 4 - (binstr.length % 4);
                for (var i = 0; i < padding; i++)
                    binstr += " ";
            }
            this._ensureSpace(this.bytePosition + 4 + binstr.length);
            this.writeInt(binstr.length);
            for (var i = 0; i < binstr.length; i += 4)
                this.writeUnsignedInt((binstr.charCodeAt(i + 3) << 24) | (binstr.charCodeAt(i + 2) << 16) | (binstr.charCodeAt(i + 1) << 8) | binstr.charCodeAt(i));
            return binstr.length;
        };
        Byte32Array.prototype.readInt = function () {
            if (this.bytePosition > this.byteLength + 4)
                throw "ByteArray out of bounds read. Position=" + this.bytePosition + ", Length=" + this.byteLength;
            var pa = this.bytePosition >> 2;
            this.bytePosition += 4;
            return this._int32Array[pa];
        };
        Byte32Array.prototype.writeUnsignedInt = function (b) {
            this._ensureSpace(this.bytePosition + 4);
            this._uint32Array[this.bytePosition >> 2] = (~~b) & 0xffffffff; // ~~ is cast to int in js...
            this.bytePosition += 4;
        };
        Byte32Array.prototype.writeInt = function (b) {
            this._ensureSpace(this.bytePosition + 4);
            this._int32Array[this.bytePosition >> 2] = (~~b); // ~~ is cast to int in js...
            this.bytePosition += 4;
        };
        Byte32Array.prototype.readUnsignedInt = function () {
            if (this.bytePosition > this.byteLength + 4)
                throw "ByteArray out of bounds read. Position=" + this.bytePosition + ", Length=" + this.byteLength;
            var pa = this.bytePosition >> 2;
            this.bytePosition += 4;
            return this._uint32Array[pa];
        };
        Byte32Array.prototype.writeFloat = function (b) {
            this._ensureSpace(this.bytePosition + 4);
            this._float32Array[this.bytePosition >> 2] = b;
            this.bytePosition += 4;
        };
        Byte32Array.prototype.readFloat = function () {
            if (this.bytePosition > this.byteLength + 4)
                throw "ByteArray out of bounds read. Positon=" + this.bytePosition + ", Length=" + this.byteLength;
            var pa = this.bytePosition >> 2;
            this.bytePosition += 4;
            return this._float32Array[pa];
        };
        Byte32Array.prototype._ensureSpace = function (length) {
            if (this.byteLength < length) {
                this.byteLength = length;
                if (this._maxLength < length) { //add additional length in minimum 255-byte increments
                    this._maxLength = Math.max((length + 255) & (~255), 4);
                    var newArrayBuffer = new ArrayBuffer(this._maxLength);
                    var newInt32Array = new Int32Array(newArrayBuffer);
                    if (this._int32Array)
                        newInt32Array.set(this._int32Array); // memcpy
                    this._uint32Array = new Uint32Array(newArrayBuffer);
                    this._float32Array = new Float32Array(newArrayBuffer);
                    this._int32Array = newInt32Array;
                    this._arrayBuffer = newArrayBuffer;
                }
            }
        };
        return Byte32Array;
    }());

    var ByteArrayBuffer = /** @class */ (function (_super) {
        __extends$1(ByteArrayBuffer, _super);
        function ByteArrayBuffer() {
            var _this = _super.call(this) || this;
            _this._bytes = [];
            _this._mode = "Array";
            return _this;
        }
        ByteArrayBuffer.prototype.writeByte = function (b) {
            var bi = ~~b;
            this._bytes[this.position++] = bi;
            if (this.position > this.length) {
                this.length = this.position;
            }
        };
        ByteArrayBuffer.prototype.readByte = function () {
            if (this.position >= this.length) {
                throw "ByteArray out of bounds read. Position=" + this.position + ", Length=" + this.length;
            }
            return this._bytes[this.position++];
        };
        ByteArrayBuffer.prototype.writeUnsignedByte = function (b) {
            var bi = ~~b;
            this._bytes[this.position++] = bi & 0xff;
            if (this.position > this.length) {
                this.length = this.position;
            }
        };
        ByteArrayBuffer.prototype.readUnsignedByte = function () {
            if (this.position >= this.length) {
                throw "ByteArray out of bounds read. Position=" + this.position + ", Length=" + this.length;
            }
            return this._bytes[this.position++];
        };
        ByteArrayBuffer.prototype.writeUnsignedShort = function (b) {
            var bi = ~~b;
            this._bytes[this.position++] = bi & 0xff;
            this._bytes[this.position++] = (bi >> 8) & 0xff;
            if (this.position > this.length) {
                this.length = this.position;
            }
        };
        ByteArrayBuffer.prototype.readUnsignedShort = function () {
            if (this.position + 2 > this.length)
                throw "ByteArray out of bounds read. Position=" + this.position + ", Length=" + this.length;
            var r = this._bytes[this.position] | (this._bytes[this.position + 1] << 8);
            this.position += 2;
            return r;
        };
        ByteArrayBuffer.prototype.writeUnsignedInt = function (b) {
            var bi = ~~b;
            this._bytes[this.position++] = bi & 0xff;
            this._bytes[this.position++] = (bi >>> 8) & 0xff;
            this._bytes[this.position++] = (bi >>> 16) & 0xff;
            this._bytes[this.position++] = (bi >>> 24) & 0xff;
            if (this.position > this.length) {
                this.length = this.position;
            }
        };
        ByteArrayBuffer.prototype.readUnsignedInt = function () {
            if (this.position + 4 > this.length) {
                throw "ByteArray out of bounds read. Position=" + this.position + ", Length=" + this.length;
            }
            var r = this._bytes[this.position] | (this._bytes[this.position + 1] << 8) | (this._bytes[this.position + 2] << 16) | (this._bytes[this.position + 3] << 24);
            this.position += 4;
            return r >>> 0;
        };
        ByteArrayBuffer.prototype.writeFloat = function (b) {
            // this is crazy slow and silly, but as a fallback...
            this.writeUnsignedInt(this.toFloatBits(Number(b)));
        };
        ByteArrayBuffer.prototype.toFloatBits = function (x) {
            // don't handle inf/nan yet
            // special case zero
            if (x == 0) {
                return 0;
            }
            // remove the sign, after this we only deal with positive numbers
            var sign = 0;
            if (x < 0) {
                x = -x;
                sign = 1;
            }
            else {
                sign = 0;
            }
            // a float value is now defined as: x = (1+(mantissa*2^-23))*(2^(exponent-127))
            var exponent = Math.log(x) / Math.log(2); // rough exponent
            exponent = Math.floor(exponent);
            x = x * Math.pow(2, 23 - exponent); // normalize to 24 bits
            var mantissa = Math.floor(x) - 0x800000;
            exponent = exponent + 127;
            return ((sign << 31) >>> 0) | (exponent << 23) | mantissa;
        };
        ByteArrayBuffer.prototype.readFloat = function (b) {
            return this.fromFloatBits(this.readUnsignedInt());
        };
        ByteArrayBuffer.prototype.fromFloatBits = function (x) {
            if (x == 0) {
                return 0;
            }
            var exponent = (x >>> 23) & 0xff;
            var mantissa = (x & 0x7fffff) | 0x800000;
            var y = Math.pow(2, (exponent - 127) - 23) * mantissa;
            if (x >>> 31 != 0) {
                y = -y;
            }
            return y;
        };
        return ByteArrayBuffer;
    }(ByteArrayBase));

    var CSS = /** @class */ (function () {
        function CSS() {
        }
        CSS.setElementSize = function (element, width, height) {
            if (!element)
                return;
            element.style.width = width + "px";
            element.style.height = height + "px";
            element["width"] = width;
            element["height"] = height;
        };
        CSS.setElementWidth = function (element, width) {
            if (!element)
                return;
            element.style.width = width + "px";
            element["width"] = width;
        };
        CSS.setElementHeight = function (element, height) {
            if (!element)
                return;
            element.style.height = height + "px";
            element["height"] = height;
        };
        CSS.setElementX = function (element, x) {
            if (!element)
                return;
            element.style.position = 'absolute';
            element.style.left = x + "px";
        };
        CSS.setElementY = function (element, y) {
            if (!element)
                return;
            element.style.position = 'absolute';
            element.style.top = y + "px";
        };
        CSS.getElementVisibility = function (element) {
            if (!element)
                return false;
            return element.style.visibility == 'visible';
        };
        CSS.setElementVisibility = function (element, visible) {
            if (!element)
                return;
            if (visible) {
                element.style.visibility = 'visible';
            }
            else {
                element.style.visibility = 'hidden';
            }
        };
        CSS.setElementAlpha = function (element, alpha) {
            if (element instanceof HTMLCanvasElement) {
                var context = element.getContext("2d");
                context.globalAlpha = alpha;
            }
        };
        CSS.setElementPosition = function (element, x, y, absolute) {
            if (absolute === void 0) { absolute = false; }
            if (!element)
                return;
            if (absolute) {
                element.style.position = "absolute";
            }
            else {
                element.style.position = "relative";
            }
            element.style.left = x + "px";
            element.style.top = y + "px";
        };
        return CSS;
    }());

    /**
     *
     */

    var RequestAnimationFrame = /** @class */ (function () {
        function RequestAnimationFrame(callback, callbackContext) {
            var _this = this;
            this._active = false;
            this._argsArray = new Array();
            this._getTimer = getTimer;
            this.setCallback(callback, callbackContext);
            this._rafUpdateFunction = function () {
                if (_this._active)
                    _this._tick();
            };
            this._argsArray.push(this._dt);
        }
        // Public
        /**
         *
         * @param callback
         * @param callbackContext
         */
        RequestAnimationFrame.prototype.setCallback = function (callback, callbackContext) {
            this._callback = callback;
            this._callbackContext = callbackContext;
        };
        /**
         *
         */
        RequestAnimationFrame.prototype.start = function () {
            this._prevTime = this._getTimer();
            this._active = true;
            if (window) {
                if (window.requestAnimationFrame) {
                    window.requestAnimationFrame(this._rafUpdateFunction);
                }
                else {
                    if (window['mozRequestAnimationFrame'])
                        window.requestAnimationFrame = window['mozRequestAnimationFrame'];
                    else if (window['webkitRequestAnimationFrame'])
                        window.requestAnimationFrame = window['webkitRequestAnimationFrame'];
                    else if (window['oRequestAnimationFrame'])
                        window.requestAnimationFrame = window['oRequestAnimationFrame'];
                }
            }
        };
        /**
         *
         */
        RequestAnimationFrame.prototype.stop = function () {
            this._active = false;
        };
        Object.defineProperty(RequestAnimationFrame.prototype, "active", {
            // Get / Set
            /**
             *
             * @returns {boolean}
             */
            get: function () {
                return this._active;
            },
            enumerable: true,
            configurable: true
        });
        // Private
        /**
         *
         * @private
         */
        RequestAnimationFrame.prototype._tick = function () {
            this._currentTime = this._getTimer();
            this._dt = this._currentTime - this._prevTime;
            this._argsArray[0] = this._dt;
            this._callback.apply(this._callbackContext, this._argsArray);
            window.requestAnimationFrame(this._rafUpdateFunction);
            this._prevTime = this._currentTime;
        };
        return RequestAnimationFrame;
    }());

    var XmlUtils = /** @class */ (function () {
        function XmlUtils() {
        }
        XmlUtils.getChildrenWithTag = function (node, tag) {
            var fragment = document.createDocumentFragment();
            if (node) {
                var num = node.childNodes.length;
                for (var i = 0; i < num; i++) {
                    var child = node.childNodes[i];
                    if (child != null) {
                        if (child.nodeName == tag) {
                            fragment.appendChild(child);
                        }
                    }
                }
            }
            return fragment.childNodes;
        };
        XmlUtils.filterListByParam = function (nodes, paramName, paramValue) {
            var fragment = document.createDocumentFragment();
            if (nodes) {
                var num = nodes.length;
                for (var i = 0; i < num; i++) {
                    var child = nodes[i];
                    if (child != null) {
                        if (child.attributes.getNamedItem(paramName).value == paramValue) {
                            fragment.appendChild(child);
                        }
                    }
                }
            }
            return fragment.childNodes;
        };
        XmlUtils.strToXml = function (str) {
            var parser = new DOMParser();
            var node = parser.parseFromString(str, "text/xml");
            return node;
        };
        XmlUtils.nodeToString = function (node) {
            if (!node)
                return "";
            var str = (new XMLSerializer()).serializeToString(node);
            return str;
        };
        XmlUtils.readAttributeValue = function (node, attrName) {
            var attrs = node.attributes;
            if (attrs == undefined) {
                return "";
            }
            var attribute = attrs.getNamedItem(attrName);
            if (!attribute) {
                //console.log("XmlUltils - readAttributeValue() - name: " + attrName + ", attribute does not exist.";
                return "";
            }
            //console.log("XmlUltils - readAttributeValue() - name: " + attrName + ", value: " + attribute.value);
            return attribute.value;
        };
        XmlUtils.writeAttributeValue = function (node, attrName, attrValue) {
            var attribute = document.createAttribute(attrName);
            attribute.value = attrValue;
            attribute = node.attributes.setNamedItem(attribute);
            console.log("XmlUltils - writeAttributeValue() - name: " + attribute.name + ", value: " + attribute.value);
        };
        XmlUtils.hasAttribute = function (node, attrName) {
            var attrs = node.attributes;
            if (attrs == undefined) {
                return false;
            }
            var attribute = attrs.getNamedItem(attrName);
            return attribute != null;
        };
        return XmlUtils;
    }());

    console.debug("AwayJS - Core - 0.8.14");
    Loader.enableParser(WaveAudioParser);

    var Flags = /** @class */ (function () {
        function Flags() {
        }
        return Flags;
    }());

    var FS = /** @class */ (function () {
        function FS() {
        }
        return FS;
    }());

    /**
     *
     */
    var Opcode = /** @class */ (function () {
        function Opcode(dest, aformat, asize, bformat, bsize, opcode, simple, horizontal, fragonly, matrix) {
            this.a = new FS();
            this.b = new FS();
            this.flags = new Flags();
            this.dest = dest;
            this.a.format = aformat;
            this.a.size = asize;
            this.b.format = bformat;
            this.b.size = bsize;
            this.opcode = opcode;
            this.flags.simple = simple;
            this.flags.horizontal = horizontal;
            this.flags.fragonly = fragonly;
            this.flags.matrix = matrix;
        }
        return Opcode;
    }());

    var OpcodeMap = /** @class */ (function () {
        function OpcodeMap() {
        }
        Object.defineProperty(OpcodeMap, "map", {
            get: function () {
                if (!OpcodeMap._map) {
                    OpcodeMap._map = new Array();
                    OpcodeMap._map['mov'] = new Opcode("vector", "vector", 4, "none", 0, 0x00, true, null, null, null); //0
                    OpcodeMap._map['add'] = new Opcode("vector", "vector", 4, "vector", 4, 0x01, true, null, null, null); //1
                    OpcodeMap._map['sub'] = new Opcode("vector", "vector", 4, "vector", 4, 0x02, true, null, null, null); //2
                    OpcodeMap._map['mul'] = new Opcode("vector", "vector", 4, "vector", 4, 0x03, true, null, null, null); //3
                    OpcodeMap._map['div'] = new Opcode("vector", "vector", 4, "vector", 4, 0x04, true, null, null, null); //4
                    OpcodeMap._map['rcp'] = new Opcode("vector", "vector", 4, "none", 0, 0x05, true, null, null, null); //5
                    OpcodeMap._map['min'] = new Opcode("vector", "vector", 4, "vector", 4, 0x06, true, null, null, null); //6
                    OpcodeMap._map['max'] = new Opcode("vector", "vector", 4, "vector", 4, 0x07, true, null, null, null); //7
                    OpcodeMap._map['frc'] = new Opcode("vector", "vector", 4, "none", 0, 0x08, true, null, null, null); //8
                    OpcodeMap._map['sqt'] = new Opcode("vector", "vector", 4, "none", 0, 0x09, true, null, null, null); //9
                    OpcodeMap._map['rsq'] = new Opcode("vector", "vector", 4, "none", 0, 0x0a, true, null, null, null); //10
                    OpcodeMap._map['pow'] = new Opcode("vector", "vector", 4, "vector", 4, 0x0b, true, null, null, null); //11
                    OpcodeMap._map['log'] = new Opcode("vector", "vector", 4, "none", 0, 0x0c, true, null, null, null); //12
                    OpcodeMap._map['exp'] = new Opcode("vector", "vector", 4, "none", 0, 0x0d, true, null, null, null); //13
                    OpcodeMap._map['nrm'] = new Opcode("vector", "vector", 4, "none", 0, 0x0e, true, null, null, null); //14
                    OpcodeMap._map['sin'] = new Opcode("vector", "vector", 4, "none", 0, 0x0f, true, null, null, null); //15
                    OpcodeMap._map['cos'] = new Opcode("vector", "vector", 4, "none", 0, 0x10, true, null, null, null); //16
                    OpcodeMap._map['crs'] = new Opcode("vector", "vector", 4, "vector", 4, 0x11, true, true, null, null); //17
                    OpcodeMap._map['dp3'] = new Opcode("vector", "vector", 4, "vector", 4, 0x12, true, true, null, null); //18
                    OpcodeMap._map['dp4'] = new Opcode("vector", "vector", 4, "vector", 4, 0x13, true, true, null, null); //19
                    OpcodeMap._map['abs'] = new Opcode("vector", "vector", 4, "none", 0, 0x14, true, null, null, null); //20
                    OpcodeMap._map['neg'] = new Opcode("vector", "vector", 4, "none", 0, 0x15, true, null, null, null); //21
                    OpcodeMap._map['sat'] = new Opcode("vector", "vector", 4, "none", 0, 0x16, true, null, null, null); //22
                    OpcodeMap._map['ted'] = new Opcode("vector", "vector", 4, "sampler", 1, 0x26, true, null, true, null); //38
                    OpcodeMap._map['kil'] = new Opcode("none", "scalar", 1, "none", 0, 0x27, true, null, true, null); //39
                    OpcodeMap._map['tex'] = new Opcode("vector", "vector", 4, "sampler", 1, 0x28, true, null, true, null); //40
                    OpcodeMap._map['m33'] = new Opcode("vector", "matrix", 3, "vector", 3, 0x17, true, null, null, true); //23
                    OpcodeMap._map['m44'] = new Opcode("vector", "matrix", 4, "vector", 4, 0x18, true, null, null, true); //24
                    OpcodeMap._map['m43'] = new Opcode("vector", "matrix", 3, "vector", 4, 0x19, true, null, null, true); //25
                    OpcodeMap._map['ddx'] = new Opcode("vector", "vector", 4, "none", 0, 0x1a, true, null, true, null); //26
                    OpcodeMap._map['ddy'] = new Opcode("vector", "vector", 4, "none", 0, 0x1b, true, null, true, null); //27
                    OpcodeMap._map['sge'] = new Opcode("vector", "vector", 4, "vector", 4, 0x29, true, null, null, null); //41
                    OpcodeMap._map['slt'] = new Opcode("vector", "vector", 4, "vector", 4, 0x2a, true, null, null, null); //42
                    OpcodeMap._map['sgn'] = new Opcode("vector", "vector", 4, "vector", 4, 0x2b, true, null, null, null); //43
                    OpcodeMap._map['seq'] = new Opcode("vector", "vector", 4, "vector", 4, 0x2c, true, null, null, null); //44
                    OpcodeMap._map['sne'] = new Opcode("vector", "vector", 4, "vector", 4, 0x2d, true, null, null, null); //45
                }
                return OpcodeMap._map;
            },
            enumerable: true,
            configurable: true
        });
        return OpcodeMap;
    }());

    var Part = /** @class */ (function () {
        function Part(name, version) {
            if (name === void 0) { name = null; }
            if (version === void 0) { version = null; }
            this.name = "";
            this.version = 0;
            this.name = name;
            this.version = version;
            this.data = new ByteArray();
        }
        return Part;
    }());

    var Reg = /** @class */ (function () {
        function Reg(code, desc) {
            this.code = code;
            this.desc = desc;
        }
        return Reg;
    }());
    var RegMap = /** @class */ (function () {
        /*
         public static va:Reg = new Reg( 0x00, "vertex attribute" );
         public static fc:Reg = new Reg( 0x01, "fragment constant" );
         public static vc:Reg = new Reg( 0x01, "vertex constant" );
         public static ft:Reg = new Reg( 0x02, "fragment temporary" );
         public static vt:Reg = new Reg( 0x02, "vertex temporary" );
         public static vo:Reg = new Reg( 0x03, "vertex output" );
         public static op:Reg = new Reg( 0x03, "vertex output" );
         public static fd:Reg = new Reg( 0x03, "fragment depth output" );
         public static fo:Reg = new Reg( 0x03, "fragment output" );
         public static oc:Reg = new Reg( 0x03, "fragment output" );
         public static v: Reg = new Reg( 0x04, "varying" );
         public static vi:Reg = new Reg( 0x04, "varying output" );
         public static fi:Reg = new Reg( 0x04, "varying input" );
         public static fs:Reg = new Reg( 0x05, "sampler" );
         */
        function RegMap() {
        }
        Object.defineProperty(RegMap, "map", {
            get: function () {
                if (!RegMap._map) {
                    RegMap._map = new Array();
                    RegMap._map['va'] = new Reg(0x00, "vertex attribute");
                    RegMap._map['fc'] = new Reg(0x01, "fragment constant");
                    RegMap._map['vc'] = new Reg(0x01, "vertex constant");
                    RegMap._map['ft'] = new Reg(0x02, "fragment temporary");
                    RegMap._map['vt'] = new Reg(0x02, "vertex temporary");
                    RegMap._map['vo'] = new Reg(0x03, "vertex output");
                    RegMap._map['op'] = new Reg(0x03, "vertex output");
                    RegMap._map['fd'] = new Reg(0x03, "fragment depth output");
                    RegMap._map['fo'] = new Reg(0x03, "fragment output");
                    RegMap._map['oc'] = new Reg(0x03, "fragment output");
                    RegMap._map['v'] = new Reg(0x04, "varying");
                    RegMap._map['vi'] = new Reg(0x04, "varying output");
                    RegMap._map['fi'] = new Reg(0x04, "varying input");
                    RegMap._map['fs'] = new Reg(0x05, "sampler");
                }
                return RegMap._map;
            },
            enumerable: true,
            configurable: true
        });
        return RegMap;
    }());

    var Sampler = /** @class */ (function () {
        function Sampler(shift, mask, value) {
            this.shift = shift;
            this.mask = mask;
            this.value = value;
        }
        return Sampler;
    }());

    var SamplerMap = /** @class */ (function () {
        /*
         public static map =     [ new Sampler( 8, 0xf, 0 ),
         new Sampler( 8, 0xf, 5 ),
         new Sampler( 8, 0xf, 4 ),
         new Sampler( 8, 0xf, 1 ),
         new Sampler( 8, 0xf, 2 ),
         new Sampler( 8, 0xf, 1 ),
         new Sampler( 8, 0xf, 2 ),

         // dimension
         new Sampler( 12, 0xf, 0 ),
         new Sampler( 12, 0xf, 1 ),
         new Sampler( 12, 0xf, 2 ),

         // special
         new Sampler( 16, 1, 1 ),
         new Sampler( 16, 4, 4 ),

         // repeat
         new Sampler( 20, 0xf, 0 ),
         new Sampler( 20, 0xf, 1 ),
         new Sampler( 20, 0xf, 1 ),

         // mip
         new Sampler( 24, 0xf, 0 ),
         new Sampler( 24, 0xf, 0 ),
         new Sampler( 24, 0xf, 1 ),
         new Sampler( 24, 0xf, 2 ),

         // filter
         new Sampler( 28, 0xf, 0 ),
         new Sampler( 28, 0xf, 1 ) ]
         */
        /*
         public static rgba: Sampler = new Sampler( 8, 0xf, 0 );
         public static rg: Sampler = new Sampler( 8, 0xf, 5 );
         public static r: Sampler = new Sampler( 8, 0xf, 4 );
         public static compressed: Sampler = new Sampler( 8, 0xf, 1 );
         public static compressed_alpha: Sampler = new Sampler( 8, 0xf, 2 );
         public static dxt1: Sampler = new Sampler( 8, 0xf, 1 );
         public static dxt5: Sampler = new Sampler( 8, 0xf, 2 );

         // dimension
         public static sampler2d: Sampler = new Sampler( 12, 0xf, 0 );
         public static cube: Sampler = new Sampler( 12, 0xf, 1 );
         public static sampler3d: Sampler = new Sampler( 12, 0xf, 2 );

         // special
         public static centroid: Sampler = new Sampler( 16, 1, 1 );
         public static ignoresampler: Sampler = new Sampler( 16, 4, 4 );

         // repeat
         public static clamp: Sampler = new Sampler( 20, 0xf, 0 );
         public static repeat: Sampler = new Sampler( 20, 0xf, 1 );
         public static wrap: Sampler = new Sampler( 20, 0xf, 1 );

         // mip
         public static nomip: Sampler = new Sampler( 24, 0xf, 0 );
         public static mipnone: Sampler = new Sampler( 24, 0xf, 0 );
         public static mipnearest: Sampler = new Sampler( 24, 0xf, 1 );
         public static miplinear: Sampler = new Sampler( 24, 0xf, 2 );

         // filter
         public static nearest: Sampler = new Sampler( 28, 0xf, 0 );
         public static linear: Sampler = new Sampler( 28, 0xf, 1 );
         */
        function SamplerMap() {
        }
        Object.defineProperty(SamplerMap, "map", {
            get: function () {
                if (!SamplerMap._map) {
                    SamplerMap._map = new Array();
                    SamplerMap._map['rgba'] = new Sampler(8, 0xf, 0);
                    SamplerMap._map['rg'] = new Sampler(8, 0xf, 5);
                    SamplerMap._map['r'] = new Sampler(8, 0xf, 4);
                    SamplerMap._map['compressed'] = new Sampler(8, 0xf, 1);
                    SamplerMap._map['compressed_alpha'] = new Sampler(8, 0xf, 2);
                    SamplerMap._map['dxt1'] = new Sampler(8, 0xf, 1);
                    SamplerMap._map['dxt5'] = new Sampler(8, 0xf, 2);
                    // dimension
                    SamplerMap._map['2d'] = new Sampler(12, 0xf, 0);
                    SamplerMap._map['cube'] = new Sampler(12, 0xf, 1);
                    SamplerMap._map['3d'] = new Sampler(12, 0xf, 2);
                    // special
                    SamplerMap._map['centroid'] = new Sampler(16, 1, 1);
                    SamplerMap._map['ignoresampler'] = new Sampler(16, 4, 4);
                    // repeat
                    SamplerMap._map['clamp'] = new Sampler(20, 0xf, 0);
                    SamplerMap._map['repeat'] = new Sampler(20, 0xf, 1);
                    SamplerMap._map['wrap'] = new Sampler(20, 0xf, 1);
                    // mip
                    SamplerMap._map['nomip'] = new Sampler(24, 0xf, 0);
                    SamplerMap._map['mipnone'] = new Sampler(24, 0xf, 0);
                    SamplerMap._map['mipnearest'] = new Sampler(24, 0xf, 1);
                    SamplerMap._map['miplinear'] = new Sampler(24, 0xf, 2);
                    // filter
                    SamplerMap._map['nearest'] = new Sampler(28, 0xf, 0);
                    SamplerMap._map['linear'] = new Sampler(28, 0xf, 1);
                }
                return SamplerMap._map;
            },
            enumerable: true,
            configurable: true
        });
        return SamplerMap;
    }());

    var AGALMiniAssembler = /** @class */ (function () {
        function AGALMiniAssembler() {
            this.r = {};
            this.cur = new Part();
        }
        AGALMiniAssembler.prototype.assemble = function (source, ext_part, ext_version) {
            if (ext_part === void 0) { ext_part = null; }
            if (ext_version === void 0) { ext_version = null; }
            if (!ext_version) {
                ext_version = 1;
            }
            if (ext_part) {
                this.addHeader(ext_part, ext_version);
            }
            var lines = source.replace(/[\f\n\r\v]+/g, "\n").split("\n"); // handle breaks, then split into lines
            for (var i in lines) {
                this.processLine(lines[i], i);
            }
            return this.r;
        };
        AGALMiniAssembler.prototype.processLine = function (line, linenr) {
            var startcomment = line.search("//"); // remove comments
            if (startcomment != -1) {
                line = line.slice(0, startcomment);
            }
            line = line.replace(/^\s+|\s+$/g, ""); // remove outer space
            if (!(line.length > 0)) {
                return;
            }
            var optsi = line.search(/<.*>/g); // split of options part <*> if there
            var opts = null;
            if (optsi != -1) {
                opts = line.slice(optsi).match(/([\w\.\-\+]+)/gi);
                line = line.slice(0, optsi);
            }
            // get opcode/command				            
            var tokens = line.match(/([\w\.\+\[\]]+)/gi); // get tokens in line
            if (!tokens || tokens.length < 1) {
                if (line.length >= 3) {
                    console.log("Warning: bad line " + linenr + ": " + line);
                }
                return;
            }
            //console.log ( linenr, line, cur, tokens ); 
            switch (tokens[0]) {
                case "part":
                    this.addHeader(tokens[1], Number(tokens[2]));
                    break;
                case "endpart":
                    if (!this.cur) {
                        throw "Unexpected endpart";
                    }
                    this.cur.data.position = 0;
                    this.cur = null;
                    return;
                default:
                    if (!this.cur) {
                        console.log("Warning: bad line " + linenr + ": " + line + " (Outside of any part definition)");
                        return;
                    }
                    if (this.cur.name == "comment") {
                        return;
                    }
                    var op = OpcodeMap.map[tokens[0]];
                    if (!op) {
                        throw "Bad opcode " + tokens[0] + " " + linenr + ": " + line;
                    }
                    // console.log( 'AGALMiniAssembler' , 'op' , op );
                    this.emitOpcode(this.cur, op.opcode);
                    var ti = 1;
                    if (op.dest && op.dest != "none") {
                        if (!this.emitDest(this.cur, tokens[ti++], op.dest)) {
                            throw "Bad destination register " + tokens[ti - 1] + " " + linenr + ": " + line;
                        }
                    }
                    else {
                        this.emitZeroDword(this.cur);
                    }
                    if (op.a && op.a.format != "none") {
                        if (!this.emitSource(this.cur, tokens[ti++], op.a))
                            throw "Bad source register " + tokens[ti - 1] + " " + linenr + ": " + line;
                    }
                    else {
                        this.emitZeroQword(this.cur);
                    }
                    if (op.b && op.b.format != "none") {
                        if (op.b.format == "sampler") {
                            if (!this.emitSampler(this.cur, tokens[ti++], op.b, opts)) {
                                throw "Bad sampler register " + tokens[ti - 1] + " " + linenr + ": " + line;
                            }
                        }
                        else {
                            if (!this.emitSource(this.cur, tokens[ti++], op.b)) {
                                throw "Bad source register " + tokens[ti - 1] + " " + linenr + ": " + line;
                            }
                        }
                    }
                    else {
                        this.emitZeroQword(this.cur);
                    }
                    break;
            }
        };
        AGALMiniAssembler.prototype.emitHeader = function (pr) {
            pr.data.writeUnsignedByte(0xa0); // tag version
            pr.data.writeUnsignedInt(pr.version);
            if (pr.version >= 0x10) {
                pr.data.writeUnsignedByte(0); // align, for higher versions
            }
            pr.data.writeUnsignedByte(0xa1); // tag program id
            switch (pr.name) {
                case "fragment":
                    pr.data.writeUnsignedByte(1);
                    break;
                case "vertex":
                    pr.data.writeUnsignedByte(0);
                    break;
                case "cpu":
                    pr.data.writeUnsignedByte(2);
                    break;
                default:
                    pr.data.writeUnsignedByte(0xff);
                    break; // unknown/comment
            }
        };
        AGALMiniAssembler.prototype.emitOpcode = function (pr, opcode) {
            pr.data.writeUnsignedInt(opcode);
            //console.log ( "Emit opcode: ", opcode ); 
        };
        AGALMiniAssembler.prototype.emitZeroDword = function (pr) {
            pr.data.writeUnsignedInt(0);
        };
        AGALMiniAssembler.prototype.emitZeroQword = function (pr) {
            pr.data.writeUnsignedInt(0);
            pr.data.writeUnsignedInt(0);
        };
        AGALMiniAssembler.prototype.emitDest = function (pr, token, opdest) {
            //console.log( 'AGALMiniAssembler' , 'emitDest' , 'RegMap.map' , RegMap.map);
            var reg = token.match(/([fov]?[tpocidavs])(\d*)(\.[xyzw]{1,4})?/i); // g1: regname, g2:regnum, g3:mask
            // console.log( 'AGALMiniAssembler' , 'emitDest' , 'reg' , reg , reg[1] , RegMap.map[reg[1]] );
            // console.log( 'AGALMiniAssembler' , 'emitDest' , 'RegMap.map[reg[1]]' , RegMap.map[reg[1]] , 'bool' , !RegMap.map[reg[1]] ) ;
            if (!RegMap.map[reg[1]])
                return false;
            var em = { num: reg[2] ? reg[2] : 0, code: RegMap.map[reg[1]].code, mask: this.stringToMask(reg[3]) };
            pr.data.writeUnsignedShort(em.num);
            pr.data.writeUnsignedByte(em.mask);
            pr.data.writeUnsignedByte(em.code);
            //console.log ( "  Emit dest: ", em );
            return true;
        };
        AGALMiniAssembler.prototype.stringToMask = function (s) {
            if (!s)
                return 0xf;
            var r = 0;
            if (s.indexOf("x") != -1)
                r |= 1;
            if (s.indexOf("y") != -1)
                r |= 2;
            if (s.indexOf("z") != -1)
                r |= 4;
            if (s.indexOf("w") != -1)
                r |= 8;
            return r;
        };
        AGALMiniAssembler.prototype.stringToSwizzle = function (s) {
            if (!s) {
                return 0xe4;
            }
            var chartoindex = { x: 0, y: 1, z: 2, w: 3 };
            var sw = 0;
            if (s.charAt(0) != ".") {
                throw "Missing . for swizzle";
            }
            if (s.length > 1) {
                sw |= chartoindex[s.charAt(1)];
            }
            if (s.length > 2) {
                sw |= chartoindex[s.charAt(2)] << 2;
            }
            else {
                sw |= (sw & 3) << 2;
            }
            if (s.length > 3) {
                sw |= chartoindex[s.charAt(3)] << 4;
            }
            else {
                sw |= (sw & (3 << 2)) << 2;
            }
            if (s.length > 4) {
                sw |= chartoindex[s.charAt(4)] << 6;
            }
            else {
                sw |= (sw & (3 << 4)) << 2;
            }
            return sw;
        };
        AGALMiniAssembler.prototype.emitSampler = function (pr, token, opsrc, opts) {
            var reg = token.match(/fs(\d*)/i); // g1:regnum
            if (!reg || !reg[1]) {
                return false;
            }
            pr.data.writeUnsignedShort(parseInt(reg[1]));
            pr.data.writeUnsignedByte(0); // bias
            pr.data.writeUnsignedByte(0);
            /*
             pr.data.writeUnsignedByte ( 0x5 );
             pr.data.writeUnsignedByte ( 0 );   // readmode, dim
             pr.data.writeUnsignedByte ( 0 );   // special, wrap
             pr.data.writeUnsignedByte ( 0 );   // mip, filter
             */
            var samplerbits = 0x5;
            var sampleroptset = 0;
            for (var i = 0; i < opts.length; i++) {
                var o = SamplerMap.map[opts[i].toLowerCase()];
                //console.log( 'AGALMiniAssembler' , 'emitSampler' , 'SampleMap opt:' , o , '<-------- WATCH FOR THIS');
                if (o) {
                    if (((sampleroptset >> o.shift) & o.mask) != 0) {
                        console.log("Warning, duplicate sampler option");
                    }
                    sampleroptset |= o.mask << o.shift;
                    samplerbits &= ~(o.mask << o.shift);
                    samplerbits |= o.value << o.shift;
                }
                else {
                    console.log("Warning, unknown sampler option: ", opts[i]);
                    // todo bias
                }
            }
            pr.data.writeUnsignedInt(samplerbits);
            return true;
        };
        AGALMiniAssembler.prototype.emitSource = function (pr, token, opsrc) {
            var indexed = token.match(/vc\[(v[tcai])(\d+)\.([xyzw])([\+\-]\d+)?\](\.[xyzw]{1,4})?/i); // g1: indexregname, g2:indexregnum, g3:select, [g4:offset], [g5:swizzle]
            var reg;
            if (indexed) {
                if (!RegMap.map[indexed[1]]) {
                    return false;
                }
                var selindex = { x: 0, y: 1, z: 2, w: 3 };
                var em = { num: indexed[2] | 0, code: RegMap.map[indexed[1]].code, swizzle: this.stringToSwizzle(indexed[5]), select: selindex[indexed[3]], offset: indexed[4] | 0 };
                pr.data.writeUnsignedShort(em.num);
                pr.data.writeByte(em.offset);
                pr.data.writeUnsignedByte(em.swizzle);
                pr.data.writeUnsignedByte(0x1); // constant reg
                pr.data.writeUnsignedByte(em.code);
                pr.data.writeUnsignedByte(em.select);
                pr.data.writeUnsignedByte(1 << 7);
            }
            else {
                reg = token.match(/([fov]?[tpocidavs])(\d*)(\.[xyzw]{1,4})?/i); // g1: regname, g2:regnum, g3:swizzle
                if (!RegMap.map[reg[1]]) {
                    return false;
                }
                var em = { num: reg[2] | 0, code: RegMap.map[reg[1]].code, swizzle: this.stringToSwizzle(reg[3]) };
                pr.data.writeUnsignedShort(em.num);
                pr.data.writeUnsignedByte(0);
                pr.data.writeUnsignedByte(em.swizzle);
                pr.data.writeUnsignedByte(em.code);
                pr.data.writeUnsignedByte(0);
                pr.data.writeUnsignedByte(0);
                pr.data.writeUnsignedByte(0);
                //console.log ( "  Emit source: ", em, pr.data.length );
            }
            return true;
        };
        AGALMiniAssembler.prototype.addHeader = function (partname, version) {
            if (!version) {
                version = 1;
            }
            if (this.r[partname] == undefined) {
                this.r[partname] = new Part(partname, version);
                this.emitHeader(this.r[partname]);
            }
            else if (this.r[partname].version != version) {
                throw "Multiple versions for part " + partname;
            }
            this.cur = this.r[partname];
        };
        return AGALMiniAssembler;
    }());

    var Header = /** @class */ (function () {
        function Header() {
            this.progid = 0;
            this.version = 0;
            this.type = "";
        }
        return Header;
    }());

    var Description = /** @class */ (function () {
        function Description() {
            this.regread = [
                [],
                [],
                [],
                [],
                [],
                [],
                []
            ];
            this.regwrite = [
                [],
                [],
                [],
                [],
                [],
                [],
                []
            ];
            this.hasindirect = false;
            this.writedepth = false;
            this.hasmatrix = false;
            this.samplers = [];
            // added due to dynamic assignment 3*0xFFFFFFuuuu
            this.tokens = [];
            this.header = new Header();
        }
        return Description;
    }());

    var OpLUT = /** @class */ (function () {
        function OpLUT(s, flags, dest, a, b, matrixwidth, matrixheight, ndwm, scaler, dm, lod) {
            this.s = s;
            this.flags = flags;
            this.dest = dest;
            this.a = a;
            this.b = b;
            this.matrixwidth = matrixwidth;
            this.matrixheight = matrixheight;
            this.ndwm = ndwm;
            this.scalar = scaler;
            this.dm = dm;
            this.lod = lod;
        }
        return OpLUT;
    }());

    var Mapping = /** @class */ (function () {
        //TODO: get rid of hack that fixes including definition file
        function Mapping(include) {
        }
        Mapping.agal2glsllut = [
            //         s 												flags   dest    a     b 	    mw 	  mh    ndwm  scale dm	  lod
            new OpLUT("%dest = %cast(%a);\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(%a + %b);\n", 0, true, true, true, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(%a - %b);\n", 0, true, true, true, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(%a * %b);\n", 0, true, true, true, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(%a / %b);\n", 0, true, true, true, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(1.0) / %a;\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(min(%a,%b));\n", 0, true, true, true, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(max(%a,%b));\n", 0, true, true, true, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(fract(%a));\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(sqrt(abs(%a)));\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(inversesqrt(abs(%a)));\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(pow(abs(%a),%b));\n", 0, true, true, true, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(log2(abs(%a)));\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(exp2(%a));\n", 0, true, true, false, null, null, null, null, null, null),
            //         s 												flags  	dest    a     b 	    mw 	  mh    ndwm  scale dm	  lod
            new OpLUT("%dest = %cast(normalize(vec3( %a ) ));\n", 0, true, true, false, null, null, true, null, null, null),
            new OpLUT("%dest = %cast(sin(%a));\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(cos(%a));\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(cross(vec3(%a),vec3(%b)));\n", 0, true, true, true, null, null, true, null, null, null),
            new OpLUT("%dest = %cast(dot(vec3(%a),vec3(%b)));\n", 0, true, true, true, null, null, true, null, null, null),
            new OpLUT("%dest = %cast(dot(vec4(%a),vec4(%b)));\n", 0, true, true, true, null, null, true, null, null, null),
            new OpLUT("%dest = %cast(abs(%a));\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(%a * -1.0);\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(clamp(%a,0.0,1.0));\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(dot(vec3(%a),vec3(%b)));\n", null, true, true, true, 3, 3, true, null, null, null),
            new OpLUT("%dest = %cast(dot(vec4(%a),vec4(%b)));\n", null, true, true, true, 4, 4, true, null, null, null),
            new OpLUT("%dest = %cast(dot(vec4(%a),vec4(%b)));\n", null, true, true, true, 4, 3, true, null, null, null),
            //s:string, flags:number, dest:boolean, a:boolean, b:boolean, matrixwidth:number, matrixheight:number, ndwm:boolean, scaler:boolean, dm:boolean, lod:boolean
            new OpLUT("%dest = %cast(dFdx(%a));\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("%dest = %cast(dFdy(%a));\n", 0, true, true, false, null, null, null, null, null, null),
            new OpLUT("if (float(%a)==float(%b)) {;\n", 0, false, true, true, null, null, null, true, null, null), new OpLUT("if (float(%a)!=float(%b)) {;\n", 0, false, true, true, null, null, null, true, null, null), new OpLUT("if (float(%a)>=float(%b)) {;\n", 0, false, true, true, null, null, null, true, null, null), new OpLUT("if (float(%a)<float(%b)) {;\n", 0, false, true, true, null, null, null, true, null, null), new OpLUT("} else {;\n", 0, false, false, false, null, null, null, null, null, null), new OpLUT("};\n", 0, false, false, false, null, null, null, null, null, null), new OpLUT(null, null, null, null, false, null, null, null, null, null, null), new OpLUT(null, null, null, null, false, null, null, null, null, null, null), new OpLUT(null, null, null, null, false, null, null, null, null, null, null), new OpLUT(null, null, null, null, false, null, null, null, null, null, null),
            //         s 															flags  	dest    a     b 	    mw 	  mh    ndwm  scale dm	  lod
            new OpLUT("%dest = %cast(texture%texdimLod(%b,%texsize(%a)).%dm);\n", null, true, true, true, null, null, null, null, true, null), new OpLUT("if ( float(%a)<0.0 ) discard;\n", null, false, true, false, null, null, null, true, null, null), new OpLUT("%dest = %cast(texture%texdim(%b,%texsize(%a)%lod).%dm);\n", null, true, true, true, null, null, true, null, true, true), new OpLUT("%dest = %cast(greaterThanEqual(%a,%b).%dm);\n", 0, true, true, true, null, null, true, null, true, null), new OpLUT("%dest = %cast(lessThan(%a,%b).%dm);\n", 0, true, true, true, null, null, true, null, true, null), new OpLUT("%dest = %cast(sign(%a));\n", 0, true, true, false, null, null, null, null, null, null), new OpLUT("%dest = %cast(equal(%a,%b).%dm);\n", 0, true, true, true, null, null, true, null, true, null), new OpLUT("%dest = %cast(notEqual(%a,%b).%dm);\n", 0, true, true, true, null, null, true, null, true, null)
        ];
        return Mapping;
    }());

    var Destination = /** @class */ (function () {
        function Destination() {
            this.mask = 0;
            this.regnum = 0;
            this.regtype = 0;
            this.dim = 0;
            this.indexoffset = 0;
            this.swizzle = 0;
            this.lodbiad = 0;
            this.readmode = 0;
            this.special = 0;
            this.wrap = 0;
            this.filter = 0;
            this.indexregtype = 0;
            this.indexselect = 0;
            this.indirectflag = 0;
        }
        return Destination;
    }());

    var Token = /** @class */ (function () {
        function Token() {
            this.dest = new Destination();
            this.opcode = 0;
            this.a = new Destination();
            this.b = new Destination();
        }
        return Token;
    }());

    var AGALTokenizer = /** @class */ (function () {
        function AGALTokenizer() {
        }
        AGALTokenizer.prototype.decribeAGALByteArray = function (bytes) {
            var header = new Header();
            if (bytes.readUnsignedByte() != 0xa0) {
                throw "Bad AGAL: Missing 0xa0 magic byte.";
            }
            header.version = bytes.readUnsignedInt();
            if (header.version >= 0x10) {
                bytes.readUnsignedByte();
                header.version >>= 1;
            }
            if (bytes.readUnsignedByte() != 0xa1) {
                throw "Bad AGAL: Missing 0xa1 magic byte.";
            }
            header.progid = bytes.readUnsignedByte();
            switch (header.progid) {
                case 1:
                    header.type = "fragment";
                    break;
                case 0:
                    header.type = "vertex";
                    break;
                case 2:
                    header.type = "cpu";
                    break;
                default:
                    header.type = "";
                    break;
            }
            var desc = new Description();
            var tokens = [];
            while (bytes.position < bytes.length) {
                var token = new Token();
                token.opcode = bytes.readUnsignedInt();
                var lutentry = Mapping.agal2glsllut[token.opcode];
                if (!lutentry) {
                    throw "Opcode not valid or not implemented yet: " + token.opcode;
                }
                if (lutentry.matrixheight) {
                    desc.hasmatrix = true;
                }
                if (lutentry.dest) {
                    token.dest.regnum = bytes.readUnsignedShort();
                    token.dest.mask = bytes.readUnsignedByte();
                    token.dest.regtype = bytes.readUnsignedByte();
                    desc.regwrite[token.dest.regtype][token.dest.regnum] |= token.dest.mask;
                }
                else {
                    token.dest = null;
                    bytes.readUnsignedInt();
                }
                if (lutentry.a) {
                    this.readReg(token.a, 1, desc, bytes);
                }
                else {
                    token.a = null;
                    bytes.readUnsignedInt();
                    bytes.readUnsignedInt();
                }
                if (lutentry.b) {
                    this.readReg(token.b, lutentry.matrixheight | 0, desc, bytes);
                }
                else {
                    token.b = null;
                    bytes.readUnsignedInt();
                    bytes.readUnsignedInt();
                }
                tokens.push(token);
            }
            desc.header = header;
            desc.tokens = tokens;
            return desc;
        };
        AGALTokenizer.prototype.readReg = function (s, mh, desc, bytes) {
            s.regnum = bytes.readUnsignedShort();
            s.indexoffset = bytes.readByte();
            s.swizzle = bytes.readUnsignedByte();
            s.regtype = bytes.readUnsignedByte();
            desc.regread[s.regtype][s.regnum] = 0xf; // sould be swizzle to mask? should be |=                                                 
            if (s.regtype == 0x5) {
                // sampler
                s.lodbiad = s.indexoffset;
                s.indexoffset = undefined;
                s.swizzle = undefined;
                // sampler 
                s.readmode = bytes.readUnsignedByte();
                s.dim = s.readmode >> 4;
                s.readmode &= 0xf;
                s.special = bytes.readUnsignedByte();
                s.wrap = s.special >> 4;
                s.special &= 0xf;
                s.mipmap = bytes.readUnsignedByte();
                s.filter = s.mipmap >> 4;
                s.mipmap &= 0xf;
                desc.samplers[s.regnum] = s;
            }
            else {
                s.indexregtype = bytes.readUnsignedByte();
                s.indexselect = bytes.readUnsignedByte();
                s.indirectflag = bytes.readUnsignedByte();
            }
            if (s.indirectflag) {
                desc.hasindirect = true;
            }
            if (!s.indirectflag && mh) {
                for (var mhi = 0; mhi < mh; mhi++) //TODO wrong, should be |=
                 {
                    desc.regread[s.regtype][s.regnum + mhi] = desc.regread[s.regtype][s.regnum];
                }
            }
        };
        return AGALTokenizer;
    }());

    var AGLSLParser = /** @class */ (function () {
        function AGLSLParser() {
        }
        AGLSLParser.prototype.parse = function (desc, precision) {
            var header = "";
            var body = "";
            header += "precision " + precision + " float;\n";
            var tag = desc.header.type[0]; //TODO
            // declare uniforms
            if (desc.header.type == "vertex") {
                header += "uniform float yflip;\n";
            }
            // if (!desc.hasindirect) {
            // 	for (var i:number = 0; i < desc.regread[0x1].length; i++) {
            // 		if (desc.regread[0x1][i]) {
            // 			header += "uniform vec4 " + tag + "c" + i + ";\n";
            // 		}
            // 	}
            // } else {
            // 	header += "uniform vec4 " + tag + "carrr[" + AGLSLParser.maxvertexconstants + "];\n";                // use max const count instead
            // }
            var constcount = desc.regread[0x1].length;
            if (constcount > 0)
                header += "uniform vec4 " + tag + "c[" + constcount + "];\n";
            // declare temps
            for (var i = 0; i < desc.regread[0x2].length || i < desc.regwrite[0x2].length; i++) {
                if (desc.regread[0x2][i] || desc.regwrite[0x2][i]) // duh, have to check write only also...
                 {
                    header += "vec4 " + tag + "t" + i + ";\n";
                }
            }
            // declare streams
            for (var i = 0; i < desc.regread[0x0].length; i++) {
                if (desc.regread[0x0][i]) {
                    header += "attribute vec4 va" + i + ";\n";
                }
            }
            // declare interpolated
            for (var i = 0; i < desc.regread[0x4].length || i < desc.regwrite[0x4].length; i++) {
                if (desc.regread[0x4][i] || desc.regwrite[0x4][i]) {
                    header += "varying vec4 vi" + i + ";\n";
                }
            }
            // declare samplers
            var samptype = ["2D", "Cube", "3D", ""];
            for (var i = 0; i < desc.samplers.length; i++) {
                if (desc.samplers[i]) {
                    header += "uniform sampler" + samptype[desc.samplers[i].dim & 3] + " fs" + i + ";\n";
                }
            }
            // extra gl fluff: setup position and depth adjust temps
            if (desc.header.type == "vertex") {
                header += "vec4 outpos;\n";
            }
            if (desc.writedepth) {
                header += "vec4 tmp_FragDepth;\n";
            }
            //if ( desc.hasmatrix ) 
            //    header += "vec4 tmp_matrix;\n";
            var derivatives = false;
            // start body of code
            body += "void main() {\n";
            for (var i = 0; i < desc.tokens.length; i++) {
                var lutentry = Mapping.agal2glsllut[desc.tokens[i].opcode];
                if (lutentry.s.indexOf("dFdx") != -1 || lutentry.s.indexOf("dFdy") != -1)
                    derivatives = true;
                if (!lutentry) {
                    throw "Opcode not valid or not implemented yet: ";
                    /*+token.opcode;*/
                }
                var sublines = lutentry.matrixheight || 1;
                for (var sl = 0; sl < sublines; sl++) {
                    var line = "  " + lutentry.s;
                    if (desc.tokens[i].dest) {
                        if (lutentry.matrixheight) {
                            if (((desc.tokens[i].dest.mask >> sl) & 1) != 1) {
                                continue;
                            }
                            var destregstring = this.regtostring(desc.tokens[i].dest.regtype, desc.tokens[i].dest.regnum, desc, tag);
                            var destcaststring = "float";
                            var destmaskstring = ["x", "y", "z", "w"][sl];
                            destregstring += "." + destmaskstring;
                        }
                        else {
                            var destregstring = this.regtostring(desc.tokens[i].dest.regtype, desc.tokens[i].dest.regnum, desc, tag);
                            var destcaststring;
                            var destmaskstring;
                            if (desc.tokens[i].dest.mask != 0xf) {
                                var ndest = 0;
                                destmaskstring = "";
                                if (desc.tokens[i].dest.mask & 1) {
                                    ndest++;
                                    destmaskstring += "x";
                                }
                                if (desc.tokens[i].dest.mask & 2) {
                                    ndest++;
                                    destmaskstring += "y";
                                }
                                if (desc.tokens[i].dest.mask & 4) {
                                    ndest++;
                                    destmaskstring += "z";
                                }
                                if (desc.tokens[i].dest.mask & 8) {
                                    ndest++;
                                    destmaskstring += "w";
                                }
                                destregstring += "." + destmaskstring;
                                switch (ndest) {
                                    case 1:
                                        destcaststring = "float";
                                        break;
                                    case 2:
                                        destcaststring = "vec2";
                                        break;
                                    case 3:
                                        destcaststring = "vec3";
                                        break;
                                    default:
                                        throw "Unexpected destination mask";
                                }
                            }
                            else {
                                destcaststring = "vec4";
                                destmaskstring = "xyzw";
                            }
                        }
                        line = line.replace("%dest", destregstring);
                        line = line.replace("%cast", destcaststring);
                        line = line.replace("%dm", destmaskstring);
                    }
                    var dwm = 0xf;
                    if (!lutentry.ndwm && lutentry.dest && desc.tokens[i].dest) {
                        dwm = desc.tokens[i].dest.mask;
                    }
                    if (desc.tokens[i].a) {
                        line = line.replace("%a", this.sourcetostring(desc.tokens[i].a, 0, dwm, lutentry.scalar, desc, tag));
                    }
                    if (desc.tokens[i].b) {
                        line = line.replace("%b", this.sourcetostring(desc.tokens[i].b, sl, dwm, lutentry.scalar, desc, tag));
                        if (desc.tokens[i].b.regtype == 0x5) {
                            // sampler dim
                            var texdim = ["2D", "Cube", "3D"][desc.tokens[i].b.dim];
                            var texsize = ["vec2", "vec3", "vec3"][desc.tokens[i].b.dim];
                            line = line.replace("%texdim", texdim);
                            line = line.replace("%texsize", texsize);
                            var texlod = "";
                            line = line.replace("%lod", texlod);
                        }
                    }
                    body += line;
                }
            }
            // adjust z from opengl range of -1..1 to 0..1 as in d3d, this also enforces a left handed coordinate system
            if (desc.header.type == "vertex") {
                body += "  gl_Position = vec4(outpos.x, outpos.y, outpos.z*2.0 - outpos.w, outpos.w);\n";
            }
            //flag based switch
            if (derivatives && desc.header.type == "fragment") {
                header = "#extension GL_OES_standard_derivatives : enable\n" + header;
            }
            // clamp fragment depth
            if (desc.writedepth) {
                body += "  gl_FragDepth = clamp(tmp_FragDepth,0.0,1.0);\n";
            }
            // close main
            body += "}\n";
            return header + body;
        };
        AGLSLParser.prototype.regtostring = function (regtype, regnum, desc, tag) {
            switch (regtype) {
                case 0x0:
                    return "va" + regnum;
                case 0x1:
                    return desc.header.type[0] + "c[" + regnum + "]";
                // case 0x1:
                // 	if (desc.hasindirect && desc.header.type == "vertex") {
                // 		return "vcarrr[" + regnum + "]";
                // 	} else {
                // 		return tag + "c" + regnum;
                // 	}
                case 0x2:
                    return tag + "t" + regnum;
                case 0x3:
                    return desc.header.type == "vertex" ? "outpos" : "gl_FragColor";
                case 0x4:
                    return "vi" + regnum;
                case 0x5:
                    return "fs" + regnum;
                case 0x6:
                    return "tmp_FragDepth";
                default:
                    throw "Unknown register type";
            }
        };
        AGLSLParser.prototype.sourcetostring = function (s, subline, dwm, isscalar, desc, tag) {
            var swiz = ["x", "y", "z", "w"];
            var r;
            if (s.indirectflag) {
                r = "vcarrr[int(" + this.regtostring(s.indexregtype, s.regnum, desc, tag) + "." + swiz[s.indexselect] + ")";
                var realofs = subline + s.indexoffset;
                if (realofs < 0)
                    r += realofs.toString();
                if (realofs > 0)
                    r += "+" + realofs.toString();
                r += "]";
            }
            else {
                r = this.regtostring(s.regtype, s.regnum + subline, desc, tag);
            }
            // samplers never add swizzle        
            if (s.regtype == 0x5) {
                return r;
            }
            // scalar, first component only
            if (isscalar) {
                return r + "." + swiz[(s.swizzle >> 0) & 3];
            }
            // identity
            if (s.swizzle == 0xe4 && dwm == 0xf) {
                return r;
            }
            // with destination write mask folded in
            r += ".";
            if (dwm & 1)
                r += swiz[(s.swizzle >> 0) & 3];
            if (dwm & 2)
                r += swiz[(s.swizzle >> 2) & 3];
            if (dwm & 4)
                r += swiz[(s.swizzle >> 4) & 3];
            if (dwm & 8)
                r += swiz[(s.swizzle >> 6) & 3];
            return r;
        };
        AGLSLParser.maxvertexconstants = 128;
        AGLSLParser.maxfragconstants = 28;
        AGLSLParser.maxtemp = 8;
        AGLSLParser.maxstreams = 8;
        AGLSLParser.maxtextures = 8;
        return AGLSLParser;
    }());

    var ContextGLBlendFactor;
    (function (ContextGLBlendFactor) {
        ContextGLBlendFactor[ContextGLBlendFactor["DESTINATION_ALPHA"] = 0] = "DESTINATION_ALPHA";
        ContextGLBlendFactor[ContextGLBlendFactor["DESTINATION_COLOR"] = 1] = "DESTINATION_COLOR";
        ContextGLBlendFactor[ContextGLBlendFactor["ONE"] = 2] = "ONE";
        ContextGLBlendFactor[ContextGLBlendFactor["ONE_MINUS_DESTINATION_ALPHA"] = 3] = "ONE_MINUS_DESTINATION_ALPHA";
        ContextGLBlendFactor[ContextGLBlendFactor["ONE_MINUS_DESTINATION_COLOR"] = 4] = "ONE_MINUS_DESTINATION_COLOR";
        ContextGLBlendFactor[ContextGLBlendFactor["ONE_MINUS_SOURCE_ALPHA"] = 5] = "ONE_MINUS_SOURCE_ALPHA";
        ContextGLBlendFactor[ContextGLBlendFactor["ONE_MINUS_SOURCE_COLOR"] = 6] = "ONE_MINUS_SOURCE_COLOR";
        ContextGLBlendFactor[ContextGLBlendFactor["SOURCE_ALPHA"] = 7] = "SOURCE_ALPHA";
        ContextGLBlendFactor[ContextGLBlendFactor["SOURCE_COLOR"] = 8] = "SOURCE_COLOR";
        ContextGLBlendFactor[ContextGLBlendFactor["ZERO"] = 9] = "ZERO";
    })(ContextGLBlendFactor || (ContextGLBlendFactor = {}));

    var ContextGLClearMask;
    (function (ContextGLClearMask) {
        ContextGLClearMask[ContextGLClearMask["COLOR"] = 1] = "COLOR";
        ContextGLClearMask[ContextGLClearMask["DEPTH"] = 2] = "DEPTH";
        ContextGLClearMask[ContextGLClearMask["STENCIL"] = 4] = "STENCIL";
        ContextGLClearMask[ContextGLClearMask["ALL"] = 7] = "ALL";
    })(ContextGLClearMask || (ContextGLClearMask = {}));

    var ContextGLCompareMode;
    (function (ContextGLCompareMode) {
        ContextGLCompareMode[ContextGLCompareMode["ALWAYS"] = 0] = "ALWAYS";
        ContextGLCompareMode[ContextGLCompareMode["EQUAL"] = 1] = "EQUAL";
        ContextGLCompareMode[ContextGLCompareMode["GREATER"] = 2] = "GREATER";
        ContextGLCompareMode[ContextGLCompareMode["GREATER_EQUAL"] = 3] = "GREATER_EQUAL";
        ContextGLCompareMode[ContextGLCompareMode["LESS"] = 4] = "LESS";
        ContextGLCompareMode[ContextGLCompareMode["LESS_EQUAL"] = 5] = "LESS_EQUAL";
        ContextGLCompareMode[ContextGLCompareMode["NEVER"] = 6] = "NEVER";
        ContextGLCompareMode[ContextGLCompareMode["NOT_EQUAL"] = 7] = "NOT_EQUAL";
    })(ContextGLCompareMode || (ContextGLCompareMode = {}));

    var ContextGLDrawMode;
    (function (ContextGLDrawMode) {
        ContextGLDrawMode[ContextGLDrawMode["TRIANGLES"] = 0] = "TRIANGLES";
        ContextGLDrawMode[ContextGLDrawMode["LINES"] = 1] = "LINES";
    })(ContextGLDrawMode || (ContextGLDrawMode = {}));

    var ContextGLMipFilter;
    (function (ContextGLMipFilter) {
        ContextGLMipFilter[ContextGLMipFilter["MIPLINEAR"] = 0] = "MIPLINEAR";
        ContextGLMipFilter[ContextGLMipFilter["MIPNEAREST"] = 1] = "MIPNEAREST";
        ContextGLMipFilter[ContextGLMipFilter["MIPNONE"] = 2] = "MIPNONE";
    })(ContextGLMipFilter || (ContextGLMipFilter = {}));

    var ContextGLProfile;
    (function (ContextGLProfile) {
        ContextGLProfile[ContextGLProfile["BASELINE"] = 0] = "BASELINE";
        ContextGLProfile[ContextGLProfile["BASELINE_CONSTRAINED"] = 1] = "BASELINE_CONSTRAINED";
        ContextGLProfile[ContextGLProfile["BASELINE_EXTENDED"] = 2] = "BASELINE_EXTENDED";
    })(ContextGLProfile || (ContextGLProfile = {}));

    var ContextGLProgramType;
    (function (ContextGLProgramType) {
        ContextGLProgramType[ContextGLProgramType["FRAGMENT"] = 0] = "FRAGMENT";
        ContextGLProgramType[ContextGLProgramType["SAMPLER"] = 1] = "SAMPLER";
        ContextGLProgramType[ContextGLProgramType["VERTEX"] = 2] = "VERTEX";
    })(ContextGLProgramType || (ContextGLProgramType = {}));

    var ContextGLStencilAction;
    (function (ContextGLStencilAction) {
        ContextGLStencilAction[ContextGLStencilAction["DECREMENT_SATURATE"] = 0] = "DECREMENT_SATURATE";
        ContextGLStencilAction[ContextGLStencilAction["DECREMENT_WRAP"] = 1] = "DECREMENT_WRAP";
        ContextGLStencilAction[ContextGLStencilAction["INCREMENT_SATURATE"] = 2] = "INCREMENT_SATURATE";
        ContextGLStencilAction[ContextGLStencilAction["INCREMENT_WRAP"] = 3] = "INCREMENT_WRAP";
        ContextGLStencilAction[ContextGLStencilAction["INVERT"] = 4] = "INVERT";
        ContextGLStencilAction[ContextGLStencilAction["KEEP"] = 5] = "KEEP";
        ContextGLStencilAction[ContextGLStencilAction["SET"] = 6] = "SET";
        ContextGLStencilAction[ContextGLStencilAction["ZERO"] = 7] = "ZERO";
    })(ContextGLStencilAction || (ContextGLStencilAction = {}));

    var ContextGLTextureFilter;
    (function (ContextGLTextureFilter) {
        ContextGLTextureFilter[ContextGLTextureFilter["LINEAR"] = 0] = "LINEAR";
        ContextGLTextureFilter[ContextGLTextureFilter["NEAREST"] = 1] = "NEAREST";
    })(ContextGLTextureFilter || (ContextGLTextureFilter = {}));

    var ContextGLTextureFormat;
    (function (ContextGLTextureFormat) {
        ContextGLTextureFormat[ContextGLTextureFormat["BGRA"] = 0] = "BGRA";
        ContextGLTextureFormat[ContextGLTextureFormat["BGRA_PACKED"] = 1] = "BGRA_PACKED";
        ContextGLTextureFormat[ContextGLTextureFormat["BGR_PACKED"] = 2] = "BGR_PACKED";
        ContextGLTextureFormat[ContextGLTextureFormat["COMPRESSED"] = 3] = "COMPRESSED";
        ContextGLTextureFormat[ContextGLTextureFormat["COMPRESSED_ALPHA"] = 4] = "COMPRESSED_ALPHA";
    })(ContextGLTextureFormat || (ContextGLTextureFormat = {}));

    var ContextGLTriangleFace;
    (function (ContextGLTriangleFace) {
        ContextGLTriangleFace[ContextGLTriangleFace["BACK"] = 0] = "BACK";
        ContextGLTriangleFace[ContextGLTriangleFace["FRONT"] = 1] = "FRONT";
        ContextGLTriangleFace[ContextGLTriangleFace["FRONT_AND_BACK"] = 2] = "FRONT_AND_BACK";
        ContextGLTriangleFace[ContextGLTriangleFace["NONE"] = 3] = "NONE";
    })(ContextGLTriangleFace || (ContextGLTriangleFace = {}));

    var ContextGLVertexBufferFormat;
    (function (ContextGLVertexBufferFormat) {
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["FLOAT_1"] = 0] = "FLOAT_1";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["FLOAT_2"] = 1] = "FLOAT_2";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["FLOAT_3"] = 2] = "FLOAT_3";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["FLOAT_4"] = 3] = "FLOAT_4";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["BYTE_1"] = 4] = "BYTE_1";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["BYTE_2"] = 5] = "BYTE_2";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["BYTE_3"] = 6] = "BYTE_3";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["BYTE_4"] = 7] = "BYTE_4";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["UNSIGNED_BYTE_1"] = 8] = "UNSIGNED_BYTE_1";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["UNSIGNED_BYTE_2"] = 9] = "UNSIGNED_BYTE_2";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["UNSIGNED_BYTE_3"] = 10] = "UNSIGNED_BYTE_3";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["UNSIGNED_BYTE_4"] = 11] = "UNSIGNED_BYTE_4";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["SHORT_1"] = 12] = "SHORT_1";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["SHORT_2"] = 13] = "SHORT_2";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["SHORT_3"] = 14] = "SHORT_3";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["SHORT_4"] = 15] = "SHORT_4";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["UNSIGNED_SHORT_1"] = 16] = "UNSIGNED_SHORT_1";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["UNSIGNED_SHORT_2"] = 17] = "UNSIGNED_SHORT_2";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["UNSIGNED_SHORT_3"] = 18] = "UNSIGNED_SHORT_3";
        ContextGLVertexBufferFormat[ContextGLVertexBufferFormat["UNSIGNED_SHORT_4"] = 19] = "UNSIGNED_SHORT_4";
    })(ContextGLVertexBufferFormat || (ContextGLVertexBufferFormat = {}));

    var ContextGLWrapMode;
    (function (ContextGLWrapMode) {
        ContextGLWrapMode[ContextGLWrapMode["CLAMP"] = 0] = "CLAMP";
        ContextGLWrapMode[ContextGLWrapMode["REPEAT"] = 1] = "REPEAT";
    })(ContextGLWrapMode || (ContextGLWrapMode = {}));

    var ContextMode;
    (function (ContextMode) {
        ContextMode[ContextMode["AUTO"] = 0] = "AUTO";
        ContextMode[ContextMode["WEBGL"] = 1] = "WEBGL";
        ContextMode[ContextMode["FLASH"] = 2] = "FLASH";
        ContextMode[ContextMode["GLES"] = 3] = "GLES";
        ContextMode[ContextMode["NATIVE"] = 4] = "NATIVE";
        ContextMode[ContextMode["SOFTWARE"] = 5] = "SOFTWARE";
    })(ContextMode || (ContextMode = {}));

    var SamplerState = /** @class */ (function () {
        function SamplerState() {
        }
        return SamplerState;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics$2 = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    function __extends$2(d, b) {
        extendStatics$2(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var ImageEvent = /** @class */ (function (_super) {
        __extends$2(ImageEvent, _super);
        /**
         * Create a new ImageEvent
         * @param type The event type.
         * @param image The instance of the image being updated.
         */
        function ImageEvent(type, image) {
            var _this = _super.call(this, type) || this;
            _this._image = image;
            return _this;
        }
        Object.defineProperty(ImageEvent.prototype, "image", {
            /**
             * The image of the material.
             */
            get: function () {
                return this._image;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        ImageEvent.INVALIDATE_MIPMAPS = "invalidateMipmaps";
        return ImageEvent;
    }(EventBase));

    var StageEvent = /** @class */ (function (_super) {
        __extends$2(StageEvent, _super);
        function StageEvent(type, stage) {
            var _this = _super.call(this, type) || this;
            _this._stage = stage;
            return _this;
        }
        Object.defineProperty(StageEvent.prototype, "stage", {
            /**
             *
             */
            get: function () {
                return this._stage;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        StageEvent.prototype.clone = function () {
            return new StageEvent(this.type, this._stage);
        };
        /**
         *
         */
        StageEvent.STAGE_ERROR = "stageError";
        /**
         *
         */
        StageEvent.CONTEXT_CREATED = "contextCreated";
        /**
         *
         */
        StageEvent.CONTEXT_DISPOSED = "contextDisposed";
        /**
         *
         */
        StageEvent.CONTEXT_RECREATED = "contextRecreated";
        /**
         *
         */
        StageEvent.INVALIDATE_SIZE = "invalidateSize";
        return StageEvent;
    }(EventBase));

    var RTTEvent = /** @class */ (function (_super) {
        __extends$2(RTTEvent, _super);
        function RTTEvent(type, rttManager) {
            var _this = _super.call(this, type) || this;
            _this._rttManager = rttManager;
            return _this;
        }
        Object.defineProperty(RTTEvent.prototype, "rttManager", {
            /**
             *
             */
            get: function () {
                return this._rttManager;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        RTTEvent.prototype.clone = function () {
            return new RTTEvent(this.type, this._rttManager);
        };
        /**
         *
         */
        RTTEvent.RESIZE = "rttManagerResize";
        return RTTEvent;
    }(EventBase));

    var ImageBase = /** @class */ (function (_super) {
        __extends$2(ImageBase, _super);
        /**
         *
         */
        function ImageBase() {
            var _this = _super.call(this) || this;
            _this._pFormat = "bgra";
            return _this;
        }
        Object.defineProperty(ImageBase.prototype, "format", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return this._pFormat;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        ImageBase.prototype.invalidateMipmaps = function () {
            this.dispatchEvent(new ImageEvent(ImageEvent.INVALIDATE_MIPMAPS, this));
        };
        return ImageBase;
    }(AssetBase));
    /**
     *
     * @class away.pool.GL_ImageBase
     */
    var _Stage_ImageBase = /** @class */ (function (_super) {
        __extends$2(_Stage_ImageBase, _super);
        function _Stage_ImageBase(asset, stage) {
            var _this = _super.call(this, asset, stage) || this;
            _this.usages = 0;
            _this._invalidMipmaps = true;
            _this._invalidMapper = true;
            _this._stage = stage;
            _this._onInvalidateMipmapsDelegate = function (event) { return _this._onInvalidateMipmaps(event); };
            _this._asset.addEventListener(ImageEvent.INVALIDATE_MIPMAPS, _this._onInvalidateMipmapsDelegate);
            return _this;
        }
        _Stage_ImageBase.prototype.getTexture = function () {
            if (!this._texture) {
                this._createTexture();
                this._invalid = true;
            }
            return this._texture;
        };
        _Stage_ImageBase.prototype.getType = function () {
            throw new AbstractMethodError();
        };
        /**
         *
         */
        _Stage_ImageBase.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            if (this._texture) {
                this._texture.dispose();
                this._texture = null;
            }
        };
        _Stage_ImageBase.prototype.activate = function (index, sampler) {
            if (sampler === void 0) { sampler = null; }
            if (!sampler)
                sampler = ImageUtils.getDefaultSampler();
            var mipmap = (sampler.mipmap && !this._stage.globalDisableMipmap) ? sampler.mipmap : false;
            this._stage.setSamplerAt(index, sampler);
            this._stage.context.setTextureAt(index, this.getTexture());
            if (!this._mipmap && mipmap) {
                this._mipmap = true;
                this._invalidMipmaps = true;
            }
            if (this._invalidMipmaps) {
                this._invalidMipmaps = false;
                if (mipmap) //todo: allow for non-generated mipmaps
                    this._texture.generateMipmaps();
            }
        };
        _Stage_ImageBase.prototype._createTexture = function () {
            throw new AbstractMethodError();
        };
        /**
         *
         */
        _Stage_ImageBase.prototype._onInvalidateMipmaps = function (event) {
            this._invalidMipmaps = true;
        };
        return _Stage_ImageBase;
    }(AbstractionBase));

    var OpCodes = /** @class */ (function () {
        function OpCodes() {
        }
        OpCodes.trueValue = 32;
        OpCodes.falseValue = 33;
        OpCodes.intMask = 63;
        OpCodes.drawTriangles = 41;
        OpCodes.setProgramConstant = 42;
        OpCodes.setProgram = 43;
        OpCodes.present = 44;
        OpCodes.clear = 45;
        OpCodes.initProgram = 46;
        OpCodes.initVertexBuffer = 47;
        OpCodes.initIndexBuffer = 48;
        OpCodes.configureBackBuffer = 49;
        OpCodes.uploadArrayIndexBuffer = 50;
        OpCodes.uploadArrayVertexBuffer = 51;
        OpCodes.uploadAGALBytesProgram = 52;
        OpCodes.setVertexBufferAt = 53;
        OpCodes.uploadBytesIndexBuffer = 54;
        OpCodes.uploadBytesVertexBuffer = 55;
        OpCodes.setColorMask = 56;
        OpCodes.setDepthTest = 57;
        OpCodes.disposeProgram = 58;
        OpCodes.disposeContext = 59;
        // must skip 60 '<' as it will invalidate xml being passed over the bridge
        OpCodes.disposeVertexBuffer = 61;
        // must skip 62 '>' as it will invalidate xml being passed over the bridge
        OpCodes.disposeIndexBuffer = 63;
        OpCodes.initTexture = 64;
        OpCodes.setTextureAt = 65;
        OpCodes.uploadBytesTexture = 66;
        OpCodes.disposeTexture = 67;
        OpCodes.setCulling = 68;
        OpCodes.setScissorRect = 69;
        OpCodes.clearScissorRect = 70;
        OpCodes.setBlendFactors = 71;
        OpCodes.setRenderToTexture = 72;
        OpCodes.clearTextureAt = 73;
        OpCodes.clearVertexBufferAt = 74;
        OpCodes.setStencilActions = 75;
        OpCodes.setStencilReferenceValue = 76;
        OpCodes.initCubeTexture = 77;
        OpCodes.disposeCubeTexture = 78;
        OpCodes.uploadBytesCubeTexture = 79;
        OpCodes.clearRenderToTexture = 80;
        OpCodes.enableErrorChecking = 81;
        // added for gles context:
        OpCodes.drawVertices = 82;
        OpCodes.getFrameBufferForTexture = 83;
        OpCodes.uploadProgram = 84;
        OpCodes.disableCulling = 85;
        OpCodes.disableBlending = 86;
        OpCodes.setSamplerStateAt = 87;
        OpCodes.enableStencil = 88;
        OpCodes.disableStencil = 89;
        OpCodes.setStencilActionsMasks = 90;
        //public static passBitmapToCpp:number = 91; //reserved for java message
        OpCodes.uploadTextureFromURL = 92;
        OpCodes.startSound = 101;
        OpCodes.stopSound = 102;
        OpCodes.updateSound = 103;
        return OpCodes;
    }());

    var GLESAssetBase = /** @class */ (function () {
        function GLESAssetBase(context, id) {
            this._context = context;
            this._id = id;
        }
        Object.defineProperty(GLESAssetBase.prototype, "id", {
            get: function () {
                return this._id;
            },
            enumerable: true,
            configurable: true
        });
        return GLESAssetBase;
    }());

    var TextureBaseGLES = /** @class */ (function (_super) {
        __extends$2(TextureBaseGLES, _super);
        function TextureBaseGLES(context, gl, id) {
            var _this = _super.call(this, context, id) || this;
            _this.textureType = "";
            return _this;
            // this._gl = gl;
        }
        TextureBaseGLES.prototype.dispose = function () {
            //console.log("dispose texturedata "+this.id);
            ///this._context.addStream(String.fromCharCode(OpCodes.disposeTexture) + this.id.toString() + "#END");
            this._context._createBytes.writeInt(OpCodes.disposeTexture);
            this._context._createBytes.writeInt(this.id);
            //this._context.execute();
            //GLESConnector.gles.disposeTexture(this.id);
            // this._gl.deleteTexture(this._glTexture);
        };
        Object.defineProperty(TextureBaseGLES.prototype, "glTexture", {
            get: function () {
                return this._glTexture;
            },
            enumerable: true,
            configurable: true
        });
        TextureBaseGLES.prototype.generateMipmaps = function () {
            //GLESConnector.gles.generateMipmaps(this.id);
            // this._gl.bindTexture( this._gl.TEXTURE_2D, this._glTexture );
            // this._gl.generateMipmap(this._gl.TEXTURE_2D);
            // //this._gl.bindTexture( this._gl.TEXTURE_2D, null );
        };
        return TextureBaseGLES;
    }(GLESAssetBase));

    var CubeTextureGLES = /** @class */ (function (_super) {
        __extends$2(CubeTextureGLES, _super);
        function CubeTextureGLES(context, gl, size, id) {
            var _this = _super.call(this, context, gl, id) || this;
            _this._textureSelectorDictionary = new Array(6);
            _this.textureType = "textureCube";
            _this._size = size;
            return _this;
            //todo
            // this._glTexture = this._gl.createTexture();
            //
            // this._textureSelectorDictionary[0] = gl.TEXTURE_CUBE_MAP_POSITIVE_X;
            // this._textureSelectorDictionary[1] = gl.TEXTURE_CUBE_MAP_NEGATIVE_X;
            // this._textureSelectorDictionary[2] = gl.TEXTURE_CUBE_MAP_POSITIVE_Y;
            // this._textureSelectorDictionary[3] = gl.TEXTURE_CUBE_MAP_NEGATIVE_Y;
            // this._textureSelectorDictionary[4] = gl.TEXTURE_CUBE_MAP_POSITIVE_Z;
            // this._textureSelectorDictionary[5] = gl.TEXTURE_CUBE_MAP_NEGATIVE_Z;
        }
        CubeTextureGLES.prototype.uploadFromArray = function (array, side, miplevel) {
            if (miplevel === void 0) { miplevel = 0; }
            if (array.length != this._size * this._size * 4)
                throw new Error("Array is not the correct length for texture dimensions");
            if (array instanceof Array)
                array = new Uint8Array(array);
            //todo
            // this._gl.bindTexture(this._gl.TEXTURE_CUBE_MAP, this._glTexture);
            // this._gl.texImage2D(this._textureSelectorDictionary[side], miplevel, this._gl.RGBA, this._gl.RGBA, this._gl.UNSIGNED_BYTE, data);
            // this._gl.bindTexture(this._gl.TEXTURE_CUBE_MAP, null);
        };
        CubeTextureGLES.prototype.uploadCompressedTextureFromArray = function (array, offset /*uint*/, async) {
            //todo
            if (async === void 0) { async = false; }
        };
        Object.defineProperty(CubeTextureGLES.prototype, "size", {
            get: function () {
                return this._size;
            },
            enumerable: true,
            configurable: true
        });
        return CubeTextureGLES;
    }(TextureBaseGLES));

    var IndexBufferGLES = /** @class */ (function (_super) {
        __extends$2(IndexBufferGLES, _super);
        function IndexBufferGLES(context, gl, numIndices, id) {
            var _this = _super.call(this, context, id) || this;
            _this._gl = gl;
            // this._buffer = this._gl.createBuffer();
            _this._numIndices = numIndices;
            return _this;
        }
        IndexBufferGLES.prototype.uploadFromArray = function (array, startOffset, count) {
            //GLESConnector.gles.uploadIndexDataFromArray(this.id, data, startOffset, count);
            // this._gl.bindBuffer(this._gl.ELEMENT_ARRAY_BUFFER, this._buffer);
            //
            // if (startOffset)
            // 	this._gl.bufferSubData(this._gl.ELEMENT_ARRAY_BUFFER, startOffset*2, new Uint16Array(data));
            // else
            // 	this._gl.bufferData(this._gl.ELEMENT_ARRAY_BUFFER, new Uint16Array(data), this._gl.STATIC_DRAW);
        };
        IndexBufferGLES.prototype.uploadFromByteArray = function (data, startOffset, count) {
            //GLESConnector.gles.uploadIndexDataFromByteArray(this.id, data, startOffset, count);
            // this._gl.bindBuffer(this._gl.ELEMENT_ARRAY_BUFFER, this._buffer);
            //
            // if (startOffset)
            // 	this._gl.bufferSubData(this._gl.ELEMENT_ARRAY_BUFFER, startOffset*2, data);
            // else
            // 	this._gl.bufferData(this._gl.ELEMENT_ARRAY_BUFFER, data, this._gl.STATIC_DRAW);
        };
        IndexBufferGLES.prototype.dispose = function () {
            //GLESConnector.gles.disposeIndexBuffer(this.id);
            // this._gl.deleteBuffer(this._buffer);
        };
        Object.defineProperty(IndexBufferGLES.prototype, "numIndices", {
            get: function () {
                return this._numIndices;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(IndexBufferGLES.prototype, "glBuffer", {
            get: function () {
                return this._buffer;
            },
            enumerable: true,
            configurable: true
        });
        return IndexBufferGLES;
    }(GLESAssetBase));

    var GLESConnector = /** @class */ (function () {
        function GLESConnector() {
        }
        Object.defineProperty(GLESConnector, "gles", {
            get: function () {
                if (!GLESConnector._gles)
                    throw ("Error: Set GlesConnector.gles before calling methods on ContextGLES!");
                return GLESConnector._gles;
            },
            set: function (value) {
                GLESConnector._gles = value;
            },
            enumerable: true,
            configurable: true
        });
        GLESConnector._gles = null;
        return GLESConnector;
    }());

    var ProgramGLES = /** @class */ (function (_super) {
        __extends$2(ProgramGLES, _super);
        function ProgramGLES(context, gl, id) {
            var _this = _super.call(this, context, id) || this;
            _this._uniforms = [[], [], []];
            _this._attribs = [];
            return _this;
            //console.log("awayjs created program with id "+ id);
            // this._gl = gl;
            // this._program = this._gl.createProgram();
        }
        ProgramGLES.prototype.upload = function (vertexProgram, fragmentProgram) {
            //detect whether highp can be used
            var vertexPrecision = (this._gl.getShaderPrecisionFormat(this._gl.VERTEX_SHADER, this._gl.HIGH_FLOAT).precision != 0) ? "highp" : "mediump";
            var fragmentPrecision = (this._gl.getShaderPrecisionFormat(this._gl.FRAGMENT_SHADER, this._gl.HIGH_FLOAT).precision != 0) ? "highp" : "mediump";
            var vertexString = ProgramGLES._aglslParser.parse(ProgramGLES._tokenizer.decribeAGALByteArray(vertexProgram), vertexPrecision);
            var fragmentString = ProgramGLES._aglslParser.parse(ProgramGLES._tokenizer.decribeAGALByteArray(fragmentProgram), fragmentPrecision);
            //(String.fromCharCode(OpCodes.uploadProgram)+""+this.id + "###"+vertexString +  "###" + fragmentString + "#END");
            var newSendbytes = new Byte32Array();
            newSendbytes.writeInt(1); //tells cpp that this is a create-bytes chunk
            newSendbytes.writeInt(OpCodes.uploadProgram);
            newSendbytes.writeInt(this.id);
            newSendbytes.writeUTFBytes(vertexString);
            newSendbytes.writeUTFBytes(fragmentString);
            newSendbytes.bytePosition = 0;
            var localInt32View = new Int32Array(newSendbytes.byteLength / 4);
            newSendbytes.readInt32Array(localInt32View);
            GLESConnector.gles.sendGLESCommands(localInt32View.buffer);
        };
        ProgramGLES.prototype.getUniformLocation = function (programType, index) {
            if (index === void 0) { index = -1; }
            // if (this._uniforms[programType][index + 1] != null)
            // 	return this._uniforms[programType][index + 1];
            //
            // var name:string =  (index == -1)? ProgramGLES._uniformLocationNameDictionary[programType] : ProgramGLES._uniformLocationNameDictionary[programType] + index;
            // return (this._uniforms[programType][index + 1] = this._gl.getUniformLocation(this._program, name));
            return null;
        };
        //
        // public getUniformLocation(programType:number, index:number):WebGLUniformLocation
        // {
        // 	if (this._uniforms[programType][index] != null)
        // 		return this._uniforms[programType][index];
        //
        // 	return (this._uniforms[programType][index] = this._gl.getUniformLocation(this._program, ProgramGLES._uniformLocationNameDictionary[programType] + index));
        // }
        ProgramGLES.prototype.getAttribLocation = function (index) {
            // if (this._attribs[index] != null)
            // 	return this._attribs[index];
            //
            // return (this._attribs[index] = this._gl.getAttribLocation(this._program, "va" + index));
            return 0;
        };
        ProgramGLES.prototype.dispose = function () {
            //this._context.addStream(String.fromCharCode(OpCodes.disposeProgram)+""+ this.id);
            this._context._createBytes.writeInt(OpCodes.disposeProgram);
            this._context._createBytes.writeInt(this.id);
            //GLESConnector.gles.disposeProgram(this.id);
            // this._gl.deleteProgram(this._program);
        };
        ProgramGLES.prototype.focusProgram = function () {
            //GLESConnector.gles.focusProgram(this.id);
            // this._gl.useProgram(this._program);
        };
        Object.defineProperty(ProgramGLES.prototype, "glProgram", {
            get: function () {
                return this._program;
            },
            enumerable: true,
            configurable: true
        });
        ProgramGLES._tokenizer = new AGALTokenizer();
        ProgramGLES._aglslParser = new AGLSLParser();
        ProgramGLES._uniformLocationNameDictionary = ["fc", "fs", "vc"];
        return ProgramGLES;
    }(GLESAssetBase));

    var TextureGLES = /** @class */ (function (_super) {
        __extends$2(TextureGLES, _super);
        function TextureGLES(context, gl, width, height, id) {
            var _this = _super.call(this, context, gl, id) || this;
            _this.textureType = "texture2d";
            _this._width = width;
            _this._height = height;
            return _this;
            //
            // this._glTexture = this._gl.createTexture();
        }
        Object.defineProperty(TextureGLES.prototype, "width", {
            get: function () {
                return this._width;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextureGLES.prototype, "height", {
            get: function () {
                return this._height;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextureGLES.prototype, "frameBuffer", {
            get: function () {
                //this._context.addStream(String.fromCharCode(OpCodes.getFrameBufferForTexture) + this.id.toString() + "#END");
                /*
                        this._context._createBytes.ensureSpace(2);//the space for the text is ensured during writeUTFBytes
                        this._context._createBytes.writeUnsignedByte(OpCodes.disposeVertexBuffer);
                        this._context._createBytes.writeByte(this.id);
                        */
                //this._context.execute();
                // if (!this._frameBuffer) {
                // 	this._frameBuffer = this._gl.createFramebuffer();
                // 	this._gl.bindFramebuffer(this._gl.FRAMEBUFFER, this._frameBuffer);
                // 	this._gl.bindTexture(this._gl.TEXTURE_2D, this._glTexture);
                // 	this._gl.texImage2D(this._gl.TEXTURE_2D, 0, this._gl.RGBA, this._width, this._height, 0, this._gl.RGBA, this._gl.UNSIGNED_BYTE, null);
                //
                // 	var renderBuffer:GLESRenderbuffer = this._gl.createRenderbuffer();
                // 	this._gl.bindRenderbuffer(this._gl.RENDERBUFFER, renderBuffer);
                // 	this._gl.renderbufferStorage(this._gl.RENDERBUFFER, this._gl.DEPTH_STENCIL, this._width, this._height);
                //
                // 	this._gl.framebufferTexture2D(this._gl.FRAMEBUFFER, this._gl.COLOR_ATTACHMENT0, this._gl.TEXTURE_2D, this._glTexture, 0);
                // 	this._gl.framebufferRenderbuffer(this._gl.FRAMEBUFFER, this._gl.DEPTH_STENCIL_ATTACHMENT, this._gl.RENDERBUFFER, renderBuffer);
                //
                // 	this._gl.bindTexture(this._gl.TEXTURE_2D, null);
                // 	this._gl.bindRenderbuffer(this._gl.RENDERBUFFER, null);
                // 	this._gl.bindFramebuffer(this._gl.FRAMEBUFFER, null);
                // }
                return this._frameBuffer;
            },
            enumerable: true,
            configurable: true
        });
        TextureGLES.prototype.uploadFromArray = function (array, miplevel) {
            if (miplevel === void 0) { miplevel = 0; }
            if (array.length != this._width * this._height * 4)
                throw new Error("Array is not the correct length for texture dimensions");
            if (array instanceof Array)
                array = new Uint8Array(array);
            var newSendbytes = new Byte32Array();
            newSendbytes.writeInt(1); //tells cpp that this is a create-bytes chunk
            newSendbytes.writeInt(OpCodes.uploadBytesTexture | miplevel << 8);
            newSendbytes.writeInt(this.id);
            newSendbytes.writeFloat(this._width);
            newSendbytes.writeFloat(this._height);
            newSendbytes.writeInt(array.buffer.byteLength);
            newSendbytes.writeInt32Array(new Int32Array(array.buffer));
            newSendbytes.bytePosition = 0;
            var localInt32View = new Int32Array(newSendbytes.byteLength / 4);
            newSendbytes.readInt32Array(localInt32View);
            GLESConnector.gles.sendGLESCommands(localInt32View.buffer);
        };
        TextureGLES.prototype.uploadFromURL = function (urlRequest, miplevel) {
            if (miplevel === void 0) { miplevel = 0; }
            var newSendbytes = new Byte32Array();
            newSendbytes.writeInt(1); //tells cpp that this is a create-bytes chunk
            newSendbytes.writeInt(OpCodes.uploadTextureFromURL | miplevel << 8);
            newSendbytes.writeInt(this.id);
            var myURLString = urlRequest.url.replace(/[^a-zA-Z0-9]/g, '');
            console.log("urlRequest.url " + myURLString);
            newSendbytes.writeUTFBytes(myURLString);
            newSendbytes.bytePosition = 0;
            var localInt32View = new Int32Array(newSendbytes.byteLength / 4);
            newSendbytes.readInt32Array(localInt32View);
            GLESConnector.gles.sendGLESCommands(localInt32View.buffer);
        };
        TextureGLES.prototype.uploadCompressedTextureFromArray = function (array, offset /*uint*/, async) {
            if (async === void 0) { async = false; }
            //GLESConnector.gles.uploadCompressedTextureFromByteArray(this.id, data, offset, async);
            // var ext:Object = this._gl.getExtension("WEBKIT_WEBGL_compressed_texture_s3tc");
            // //this._gl.compressedTexImage2D(this._gl.TEXTURE_2D, 0, this)
        };
        return TextureGLES;
    }(TextureBaseGLES));

    var VertexBufferGLES = /** @class */ (function (_super) {
        __extends$2(VertexBufferGLES, _super);
        function VertexBufferGLES(context, gl, numVertices, dataPerVertex, id) {
            var _this = _super.call(this, context, id) || this;
            // this._gl = gl;
            // this._buffer = this._gl.createBuffer();
            _this._numVertices = numVertices;
            _this._dataPerVertex = dataPerVertex;
            return _this;
        }
        VertexBufferGLES.prototype.uploadFromArray = function (array, startVertex, numVertices) {
            //GLESConnector.gles.uploadVertexDataFromArray(this.id, vertices, startVertex, numVertices);
            // this._gl.bindBuffer(this._gl.ARRAY_BUFFER, this._buffer);
            //
            // if (startVertex)
            // 	this._gl.bufferSubData(this._gl.ARRAY_BUFFER, startVertex*this._dataPerVertex, new Float32Array(vertices));
            // else
            // 	this._gl.bufferData(this._gl.ARRAY_BUFFER, new Float32Array(vertices), this._gl.STATIC_DRAW);
        };
        VertexBufferGLES.prototype.uploadFromByteArray = function (data, startVertex, numVertices) {
            var newSendbytes = new Byte32Array();
            newSendbytes.writeInt(1); //send create bytes
            newSendbytes.writeInt(OpCodes.uploadArrayVertexBuffer);
            newSendbytes.writeInt(this.id);
            newSendbytes.writeInt(startVertex);
            newSendbytes.writeInt(data.byteLength);
            newSendbytes.writeInt32Array(new Int32Array(data)); //TODO: cache the view on the attributebuffer
            newSendbytes.bytePosition = 0;
            var localInt32View = new Int32Array(newSendbytes.byteLength / 4);
            newSendbytes.readInt32Array(localInt32View);
            GLESConnector.gles.sendGLESCommands(localInt32View.buffer);
        };
        Object.defineProperty(VertexBufferGLES.prototype, "numVertices", {
            get: function () {
                return this._numVertices;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(VertexBufferGLES.prototype, "dataPerVertex", {
            get: function () {
                return this._dataPerVertex;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(VertexBufferGLES.prototype, "glBuffer", {
            get: function () {
                return this._buffer;
            },
            enumerable: true,
            configurable: true
        });
        VertexBufferGLES.prototype.dispose = function () {
            //console.log("dispose vertexdata "+this.id);
            //this._context.addCreateStream(String.fromCharCode(OpCodes.disposeVertexBuffer) + this.id+"#END");
            this._context._createBytes.writeInt(OpCodes.disposeVertexBuffer);
            this._context._createBytes.writeInt(this.id);
        };
        return VertexBufferGLES;
    }(GLESAssetBase));

    var ContextGLES = /** @class */ (function () {
        function ContextGLES(canvas) {
            this._blendFactorDictionary = new Object();
            this._drawModeDictionary = new Object();
            this._compareModeDictionary = new Object();
            this.stencilTriangleFace = new Object();
            this._stencilActionDictionary = new Object();
            this._textureIndexDictionary = new Array(8);
            this._textureTypeDictionary = new Object();
            this._wrapDictionary = new Object();
            this._filterDictionary = new Object();
            this._mipmapFilterDictionary = new Object();
            this._vertexBufferPropertiesDictionary = [];
            this._samplerStates = new Array(8);
            this._stencilReferenceValue = 0;
            this._stencilReadMask = 0xff;
            this._separateStencil = false;
            this._textureCnt = 0;
            this._programCnt = 0;
            this._cubeTextureCnt = 0;
            this._indexBufferCnt = 0;
            this._vertexBufferCnt = 0;
            this._container = canvas;
            this._cmdBytes = new Byte32Array();
            this._createBytes = new Byte32Array();
            ContextGLES._soundBytes = new Byte32Array();
            ContextGLES._soundBytes.writeUnsignedInt(100); //id for sending sound data
            this._cmdBytes.writeUnsignedInt(0); //id for sending cmd data
            this._createBytes.writeUnsignedInt(1); //id for sending create data
            this._blendFactorDictionary[ContextGLBlendFactor.ONE] = 0;
            this._blendFactorDictionary[ContextGLBlendFactor.DESTINATION_ALPHA] = 1;
            this._blendFactorDictionary[ContextGLBlendFactor.DESTINATION_COLOR] = 2;
            this._blendFactorDictionary[ContextGLBlendFactor.ONE_MINUS_DESTINATION_ALPHA] = 3;
            this._blendFactorDictionary[ContextGLBlendFactor.ONE_MINUS_DESTINATION_COLOR] = 4;
            this._blendFactorDictionary[ContextGLBlendFactor.ONE_MINUS_SOURCE_ALPHA] = 5;
            this._blendFactorDictionary[ContextGLBlendFactor.ONE_MINUS_SOURCE_COLOR] = 6;
            this._blendFactorDictionary[ContextGLBlendFactor.SOURCE_ALPHA] = 7;
            this._blendFactorDictionary[ContextGLBlendFactor.SOURCE_COLOR] = 8;
            this._blendFactorDictionary[ContextGLBlendFactor.ZERO] = 9;
            this._drawModeDictionary[ContextGLDrawMode.LINES] = 0;
            this._drawModeDictionary[ContextGLDrawMode.TRIANGLES] = 1;
            this._compareModeDictionary[ContextGLCompareMode.ALWAYS] = 0;
            this._compareModeDictionary[ContextGLCompareMode.EQUAL] = 1;
            this._compareModeDictionary[ContextGLCompareMode.GREATER] = 2;
            this._compareModeDictionary[ContextGLCompareMode.GREATER_EQUAL] = 3;
            this._compareModeDictionary[ContextGLCompareMode.LESS] = 4;
            this._compareModeDictionary[ContextGLCompareMode.LESS_EQUAL] = 5;
            this._compareModeDictionary[ContextGLCompareMode.NEVER] = 6;
            this._compareModeDictionary[ContextGLCompareMode.NOT_EQUAL] = 7;
            this.stencilTriangleFace[ContextGLTriangleFace.BACK] = 2;
            this.stencilTriangleFace[ContextGLTriangleFace.FRONT] = 1;
            this.stencilTriangleFace[ContextGLTriangleFace.FRONT_AND_BACK] = 0;
            //
            this._stencilActionDictionary[ContextGLStencilAction.DECREMENT_SATURATE] = 0;
            this._stencilActionDictionary[ContextGLStencilAction.DECREMENT_WRAP] = 1;
            this._stencilActionDictionary[ContextGLStencilAction.INCREMENT_SATURATE] = 2;
            this._stencilActionDictionary[ContextGLStencilAction.INCREMENT_WRAP] = 3;
            this._stencilActionDictionary[ContextGLStencilAction.INVERT] = 4;
            this._stencilActionDictionary[ContextGLStencilAction.KEEP] = 5;
            this._stencilActionDictionary[ContextGLStencilAction.SET] = 6;
            this._stencilActionDictionary[ContextGLStencilAction.ZERO] = 7;
            this._textureTypeDictionary["texture2d"] = 0;
            this._textureTypeDictionary["textureCube"] = 1;
            this._wrapDictionary[ContextGLWrapMode.REPEAT] = 0;
            this._wrapDictionary[ContextGLWrapMode.CLAMP] = 1;
            this._filterDictionary[ContextGLTextureFilter.LINEAR] = 0;
            this._filterDictionary[ContextGLTextureFilter.NEAREST] = 1;
            this._mipmapFilterDictionary[ContextGLTextureFilter.LINEAR] = new Object();
            this._mipmapFilterDictionary[ContextGLTextureFilter.LINEAR][ContextGLMipFilter.MIPNEAREST] = 2;
            this._mipmapFilterDictionary[ContextGLTextureFilter.LINEAR][ContextGLMipFilter.MIPLINEAR] = 3;
            this._mipmapFilterDictionary[ContextGLTextureFilter.LINEAR][ContextGLMipFilter.MIPNONE] = 0;
            this._mipmapFilterDictionary[ContextGLTextureFilter.NEAREST] = new Object();
            this._mipmapFilterDictionary[ContextGLTextureFilter.NEAREST][ContextGLMipFilter.MIPNEAREST] = 4;
            this._mipmapFilterDictionary[ContextGLTextureFilter.NEAREST][ContextGLMipFilter.MIPLINEAR] = 5;
            this._mipmapFilterDictionary[ContextGLTextureFilter.NEAREST][ContextGLMipFilter.MIPNONE] = 1;
        }
        // soundcommands are excuted on @away/player/AS2SoundAdapter, and stored here as binary data
        // when context is executed, they get send to java along woth the oother data
        ContextGLES.startSound = function (name, id, volume, loop) {
            ContextGLES._soundBytes.writeInt(OpCodes.startSound | ((loop ? 1 : 0) << 8));
            ContextGLES._soundBytes.writeFloat(volume);
            ContextGLES._soundBytes.writeInt(id);
            ContextGLES._soundBytes.writeUTFBytes(name);
        };
        ContextGLES.stopSound = function (id) {
            ContextGLES._soundBytes.writeInt(OpCodes.stopSound);
            ContextGLES._soundBytes.writeInt(id);
        };
        ContextGLES.updateSound = function (id, volume, loop) {
            ContextGLES._soundBytes.writeInt(OpCodes.updateSound | ((loop ? 1 : 0) << 8));
            ContextGLES._soundBytes.writeFloat(volume);
            ContextGLES._soundBytes.writeInt(id);
        };
        Object.defineProperty(ContextGLES.prototype, "container", {
            get: function () {
                return this._container;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContextGLES.prototype, "standardDerivatives", {
            get: function () {
                return this._standardDerivatives;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContextGLES.prototype, "glVersion", {
            get: function () {
                return 1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContextGLES.prototype, "pixelRatio", {
            get: function () {
                return 1;
            },
            enumerable: true,
            configurable: true
        });
        ContextGLES.prototype.enableStencil = function () {
            this._cmdBytes.writeInt(OpCodes.enableStencil);
        };
        ContextGLES.prototype.disableStencil = function () {
            this._cmdBytes.writeInt(OpCodes.disableStencil);
        };
        ContextGLES.prototype.gl = function () {
            return this._gl;
        };
        ContextGLES.prototype.clear = function (red, green, blue, alpha, depth, stencil, mask) {
            if (red === void 0) { red = 0; }
            if (green === void 0) { green = 0; }
            if (blue === void 0) { blue = 0; }
            if (alpha === void 0) { alpha = 1; }
            if (depth === void 0) { depth = 1; }
            if (stencil === void 0) { stencil = 0; }
            if (mask === void 0) { mask = ContextGLClearMask.ALL; }
            this._cmdBytes.writeInt(OpCodes.clear);
            this._cmdBytes.writeFloat(red);
            this._cmdBytes.writeFloat(green);
            this._cmdBytes.writeFloat(blue);
            this._cmdBytes.writeFloat(alpha);
            this._cmdBytes.writeInt(depth);
            this._cmdBytes.writeInt(stencil);
            this._cmdBytes.writeInt(mask);
        };
        ContextGLES.prototype.configureBackBuffer = function (width, height, antiAlias, enableDepthAndStencil) {
            if (enableDepthAndStencil === void 0) { enableDepthAndStencil = true; }
            this._width = width;
            this._height = height;
            this._cmdBytes.writeInt(OpCodes.configureBackBuffer | (enableDepthAndStencil ? 1 : 0) << 8);
            this._cmdBytes.writeFloat(width);
            this._cmdBytes.writeFloat(height);
        };
        ContextGLES.prototype.createCubeTexture = function (size, format, optimizeForRenderToTexture, streamingLevels) {
            if (streamingLevels === void 0) { streamingLevels = 0; }
            // todo: cubetextures not finished / tested for opengl yet
            return new CubeTextureGLES(this, this._gl, size, this._cubeTextureCnt++);
        };
        ContextGLES.prototype.createIndexBuffer = function (numIndices) {
            // todo: indexBuffer not finished / tested for opengl yet
            return new IndexBufferGLES(this, this._gl, numIndices, this._indexBufferCnt++);
        };
        ContextGLES.prototype.createProgram = function () {
            return new ProgramGLES(this, this._gl, this._programCnt++);
        };
        ContextGLES.prototype.createTexture = function (width, height, format, optimizeForRenderToTexture, streamingLevels) {
            if (streamingLevels === void 0) { streamingLevels = 0; }
            //TODO streaming
            return new TextureGLES(this, this._gl, width, height, this._textureCnt++);
        };
        ContextGLES.prototype.createVertexBuffer = function (numVertices, dataPerVertex) {
            return new VertexBufferGLES(this, this._gl, numVertices, dataPerVertex, this._vertexBufferCnt++);
        };
        ContextGLES.prototype.dispose = function () {
            this._cmdBytes.writeInt(OpCodes.disposeContext);
            this.execute();
        };
        ContextGLES.prototype.drawToBitmapImage2D = function (destination) {
            //todo (not needed for icycle (?) )
            // var pixels:Uint8ClampedArray = new Uint8ClampedArray(destination.width*destination.height*4);
            //
            // this._gl.readPixels(0, 0, destination.width, destination.height, this._gl.RGBA, this._gl.UNSIGNED_BYTE, pixels);
            //
            // destination.setPixels(new Rectangle(0, 0, destination.width, destination.height), pixels);
        };
        ContextGLES.prototype.drawIndices = function (mode, indexBuffer, firstIndex, numIndices) {
            if (firstIndex === void 0) { firstIndex = 0; }
            if (numIndices === void 0) { numIndices = -1; }
            //todo (not needed for icycle)
            //GLESConnector.gles.drawIndices(mode, indexBuffer.id, firstIndex, numIndices);
            // if (!this._drawing)
            // 	throw "Need to clear before drawing if the buffer has not been cleared since the last present() call.";
            //
            //
            // this._gl.bindBuffer(this._gl.ELEMENT_ARRAY_BUFFER, indexBuffer.glBuffer);
            // this._gl.drawElements(this._drawModeDictionary[mode], (numIndices == -1)? indexBuffer.numIndices : numIndices, this._gl.UNSIGNED_SHORT, firstIndex*2);
        };
        ContextGLES.prototype.drawVertices = function (mode, firstVertex, numVertices) {
            if (firstVertex === void 0) { firstVertex = 0; }
            if (numVertices === void 0) { numVertices = -1; }
            // if (!this._drawing)
            // 	throw "Need to clear before drawing if the buffer has not been cleared since the last present() call.";
            this._cmdBytes.writeInt(OpCodes.drawVertices | (this._drawModeDictionary[mode] << 8));
            this._cmdBytes.writeInt(firstVertex);
            this._cmdBytes.writeInt(numVertices);
        };
        ContextGLES.prototype.present = function () {
            this.execute();
        };
        ContextGLES.prototype.setBlendFactors = function (sourceFactor, destinationFactor) {
            this._blendEnabled = true;
            this._blendSourceFactor = this._blendFactorDictionary[sourceFactor];
            this._blendDestinationFactor = this._blendFactorDictionary[destinationFactor];
            this.updateBlendStatus();
        };
        ContextGLES.prototype.setColorMask = function (red, green, blue, alpha) {
            this._cmdBytes.writeInt(OpCodes.setColorMask);
            this._cmdBytes.writeInt((red ? 1 : 0) | (green ? 1 : 0) << 8 | (blue ? 1 : 0) << 16 | (alpha ? 1 : 0) << 24);
        };
        ContextGLES.prototype.setCulling = function (triangleFaceToCull, coordinateSystem) {
            if (coordinateSystem === void 0) { coordinateSystem = CoordinateSystem.LEFT_HANDED; }
            if (triangleFaceToCull == ContextGLTriangleFace.NONE) {
                //this.addStream(String.fromCharCode(OpCodes.disableCulling) + "#END");
                this._cmdBytes.writeInt(OpCodes.disableCulling);
                return;
            }
            var faceCulling = this.translateTriangleFace(triangleFaceToCull, coordinateSystem);
            this._cmdBytes.writeInt(OpCodes.setCulling | faceCulling << 8);
        };
        ContextGLES.prototype.setDepthTest = function (depthMask, passCompareMode) {
            this._cmdBytes.writeInt(OpCodes.setDepthTest | (depthMask ? 1 : 0) << 8 | this._compareModeDictionary[passCompareMode] << 16);
        };
        ContextGLES.prototype.setStencilActionsMasks = function (compareMode, referenceValue, writeMask, actionOnBothPass, actionOnDepthFail, actionOnDepthPassStencilFail, coordinateSystem) {
            if (actionOnBothPass === void 0) { actionOnBothPass = "keep"; }
            if (actionOnDepthFail === void 0) { actionOnDepthFail = "keep"; }
            if (actionOnDepthPassStencilFail === void 0) { actionOnDepthPassStencilFail = "keep"; }
            if (coordinateSystem === void 0) { coordinateSystem = "leftHanded"; }
            var compareModeGL = this._compareModeDictionary[compareMode];
            var fail = this._stencilActionDictionary[actionOnDepthPassStencilFail];
            var zFail = this._stencilActionDictionary[actionOnDepthFail];
            var pass = this._stencilActionDictionary[actionOnBothPass];
            this._cmdBytes.writeInt(OpCodes.setStencilActionsMasks | (compareModeGL << 8));
            this._cmdBytes.writeInt(referenceValue);
            this._cmdBytes.writeInt(writeMask | fail << 8 | zFail << 16 | pass << 24);
        };
        ContextGLES.prototype.setStencilActions = function (triangleFace, compareMode, actionOnBothPass, actionOnDepthFail, actionOnDepthPassStencilFail, coordinateSystem) {
            if (triangleFace === void 0) { triangleFace = ContextGLTriangleFace.FRONT_AND_BACK; }
            if (compareMode === void 0) { compareMode = ContextGLCompareMode.ALWAYS; }
            if (actionOnBothPass === void 0) { actionOnBothPass = ContextGLStencilAction.KEEP; }
            if (actionOnDepthFail === void 0) { actionOnDepthFail = ContextGLStencilAction.KEEP; }
            if (actionOnDepthPassStencilFail === void 0) { actionOnDepthPassStencilFail = ContextGLStencilAction.KEEP; }
            if (coordinateSystem === void 0) { coordinateSystem = CoordinateSystem.LEFT_HANDED; }
            var compareModeGL = this._compareModeDictionary[compareMode];
            var triangleFaceGL = this.stencilTriangleFace[triangleFace];
            var fail = this._stencilActionDictionary[actionOnDepthPassStencilFail];
            var zFail = this._stencilActionDictionary[actionOnDepthFail];
            var pass = this._stencilActionDictionary[actionOnBothPass];
            this._cmdBytes.writeInt(OpCodes.setStencilActions | triangleFaceGL << 8);
            this._cmdBytes.writeInt(compareModeGL | fail << 8 | zFail << 16 | pass << 24);
        };
        ContextGLES.prototype.setStencilReferenceValue = function (referenceValue, readMask, writeMask) {
            if (readMask === void 0) { readMask = 0xFF; }
            if (writeMask === void 0) { writeMask = 0xFF; }
            this._cmdBytes.writeInt(OpCodes.setStencilReferenceValue);
            this._cmdBytes.writeInt(referenceValue);
            this._cmdBytes.writeInt(readMask);
            this._cmdBytes.writeInt(writeMask);
        };
        ContextGLES.prototype.setProgram = function (program) {
            this._cmdBytes.writeInt(OpCodes.setProgram);
            this._cmdBytes.writeInt(program.id);
        };
        ContextGLES.prototype.setProgramConstantsFromArray = function (programType, data) {
            this._cmdBytes.writeInt(OpCodes.setProgramConstant | programType << 8);
            this._cmdBytes.writeInt(data.length);
            this._cmdBytes.writeFloat32Array(data);
        };
        ContextGLES.prototype.setScissorRectangle = function (rectangle) {
            if (rectangle) {
                this._cmdBytes.writeInt(OpCodes.setScissorRect);
                this._cmdBytes.writeFloat(rectangle.x);
                this._cmdBytes.writeFloat(rectangle.y);
                this._cmdBytes.writeFloat(rectangle.width);
                this._cmdBytes.writeFloat(rectangle.height);
            }
            else {
                this._cmdBytes.writeInt(OpCodes.clearScissorRect);
            }
        };
        ContextGLES.prototype.setTextureAt = function (sampler, texture) {
            if (texture) {
                this._cmdBytes.writeInt(OpCodes.setTextureAt | sampler << 8);
                this._cmdBytes.writeInt(texture.id);
            }
            else {
                this._cmdBytes.writeInt(OpCodes.clearTextureAt | sampler << 8);
            }
        };
        ContextGLES.prototype.setSamplerStateAt = function (sampler, wrap, filter, mipfilter) {
            this._cmdBytes.writeInt(OpCodes.setSamplerStateAt | sampler << 8);
            this._cmdBytes.writeInt(this._wrapDictionary[wrap] | this._filterDictionary[filter] << 8 | this._mipmapFilterDictionary[filter][mipfilter] << 16);
        };
        ContextGLES.prototype.setVertexBufferAt = function (index, buffer, bufferOffset, format) {
            if (bufferOffset === void 0) { bufferOffset = 0; }
            if (format === void 0) { format = 4; }
            if (buffer) {
                this._cmdBytes.writeInt(OpCodes.setVertexBufferAt | index << 8 | format << 16 | buffer.dataPerVertex << 24);
                this._cmdBytes.writeInt(buffer.id);
                this._cmdBytes.writeInt(bufferOffset);
            }
            else {
                this._cmdBytes.writeInt(OpCodes.clearVertexBufferAt | index << 8);
            }
        };
        ContextGLES.prototype.setRenderToTexture = function (target, enableDepthAndStencil, antiAlias, surfaceSelector, mipmapSelector) {
            if (enableDepthAndStencil === void 0) { enableDepthAndStencil = false; }
            if (antiAlias === void 0) { antiAlias = 0; }
            if (surfaceSelector === void 0) { surfaceSelector = 0; }
            if (mipmapSelector === void 0) { mipmapSelector = 0; }
            if (target === null || target === undefined) {
                this._cmdBytes.writeInt(OpCodes.clearRenderToTexture);
            }
            else {
                this._cmdBytes.writeInt(OpCodes.setRenderToTexture | (enableDepthAndStencil ? 1 : 0) << 8);
                this._cmdBytes.writeInt(target.id);
            }
            // var texture:TextureGLES = <TextureGLES> target;
            // var frameBuffer:WebGLFramebuffer = texture.frameBuffer;
            // this._gl.bindFramebuffer(this._gl.FRAMEBUFFER, frameBuffer);
            //
            // if (enableDepthAndStencil) {
            // 	this._gl.enable(this._gl.STENCIL_TEST);
            // 	this._gl.enable(this._gl.DEPTH_TEST);
            // }
            //
            // this._gl.viewport(0, 0, texture.width, texture.height );
        };
        ContextGLES.prototype.setRenderToBackBuffer = function () {
            this._cmdBytes.writeInt(OpCodes.clearRenderToTexture);
            //todo
            // this._gl.bindFramebuffer(this._gl.FRAMEBUFFER, null);
        };
        ContextGLES.prototype.copyToTexture = function (target, rect, destPoint) {
        };
        ContextGLES.prototype.updateBlendStatus = function () {
            if (this._blendEnabled) {
                this._cmdBytes.writeInt(OpCodes.setBlendFactors | this._blendSourceFactor << 8 | this._blendDestinationFactor << 16);
            }
            else {
                this._cmdBytes.writeUnsignedInt(OpCodes.disableBlending);
            }
        };
        ContextGLES.prototype.translateTriangleFace = function (triangleFace, coordinateSystem) {
            switch (triangleFace) {
                case ContextGLTriangleFace.BACK:
                    return (coordinateSystem == CoordinateSystem.LEFT_HANDED) ? 2 : 1;
                case ContextGLTriangleFace.FRONT:
                    return (coordinateSystem == CoordinateSystem.LEFT_HANDED) ? 1 : 2;
                case ContextGLTriangleFace.FRONT_AND_BACK:
                    return 0;
                default:
                    throw "Unknown ContextGLTriangleFace type."; // TODO error
            }
        };
        ContextGLES.prototype.execute = function () {
            if (this._createBytes.bytePosition > 4) {
                this._createBytes.bytePosition = 0;
                var localInt32View1 = new Int32Array(this._createBytes.byteLength / 4);
                this._createBytes.readInt32Array(localInt32View1);
                GLESConnector.gles.sendGLESCommands(localInt32View1.buffer);
                this._createBytes.byteLength = 0;
                this._createBytes.bytePosition = 0;
                this._createBytes.writeUnsignedInt(1); // make sure first int in bytearray is the id (1 for create bytes)
            }
            if (this._cmdBytes.bytePosition > 4) {
                this._cmdBytes.bytePosition = 0;
                var localInt32View = new Int32Array(this._cmdBytes.byteLength / 4);
                this._cmdBytes.readInt32Array(localInt32View);
                GLESConnector.gles.sendGLESCommands(localInt32View.buffer);
                this._cmdBytes.byteLength = 0;
                this._cmdBytes.bytePosition = 0;
                this._cmdBytes.writeUnsignedInt(0); // make sure first int in bytearray is the id (0 for cmd bytes)
            }
            if (ContextGLES._soundBytes.bytePosition > 4) {
                ContextGLES._soundBytes.bytePosition = 0;
                var localInt32View2 = new Int32Array(ContextGLES._soundBytes.byteLength / 4);
                ContextGLES._soundBytes.readInt32Array(localInt32View2);
                GLESConnector.gles.sendGLESCommands(localInt32View2.buffer);
                ContextGLES._soundBytes.byteLength = 0;
                ContextGLES._soundBytes.bytePosition = 0;
                ContextGLES._soundBytes.writeUnsignedInt(100); // make sure first int in bytearray is the id (100 for cmd soundbytes)
            }
        };
        ContextGLES._uniformLocationNameDictionary = ["fc", "fs", "vc"];
        ContextGLES.MAX_SAMPLERS = 8;
        ContextGLES.modulo = 0;
        return ContextGLES;
    }());

    /**
     *
     */
    var ImageSampler = /** @class */ (function (_super) {
        __extends$2(ImageSampler, _super);
        /**
         *
         */
        function ImageSampler(repeat, smooth, mipmap) {
            if (repeat === void 0) { repeat = false; }
            if (smooth === void 0) { smooth = false; }
            if (mipmap === void 0) { mipmap = false; }
            var _this = _super.call(this) || this;
            _this._repeat = repeat;
            _this._smooth = smooth;
            _this._mipmap = mipmap;
            return _this;
        }
        Object.defineProperty(ImageSampler.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return ImageSampler.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ImageSampler.prototype, "repeat", {
            /**
             *
             */
            get: function () {
                return this._repeat;
            },
            set: function (value) {
                if (this._repeat == value)
                    return;
                this._repeat = value;
                //TODO: update dependencies
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ImageSampler.prototype, "smooth", {
            /**
             *
             */
            get: function () {
                return this._smooth;
            },
            set: function (value) {
                if (this._smooth == value)
                    return;
                this._smooth = value;
                //TODO: update dependencies
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ImageSampler.prototype, "mipmap", {
            /**
             *
             */
            get: function () {
                return this._mipmap;
            },
            set: function (value) {
                if (this._mipmap == value)
                    return;
                this._mipmap = value;
                //TODO: update dependencies
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ImageSampler.prototype, "imageRect", {
            /**
             *
             */
            get: function () {
                return this._imageRect;
            },
            set: function (value) {
                if (this._imageRect == value)
                    return;
                this._imageRect = value;
                this._updateRect();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ImageSampler.prototype, "frameRect", {
            /**
             *
             */
            get: function () {
                return this._frameRect;
            },
            set: function (value) {
                if (this._frameRect == value)
                    return;
                this._frameRect = value;
                this._updateRect();
            },
            enumerable: true,
            configurable: true
        });
        ImageSampler.prototype._updateRect = function () {
        };
        ImageSampler.assetType = "[asset Sampler]";
        return ImageSampler;
    }(AssetBase));

    /**
     *
     * @class away.pool.ProgramDataBase
     */
    var ProgramData = /** @class */ (function () {
        function ProgramData(pool, context, vertexString, fragmentString) {
            this.usages = 0;
            this._pool = pool;
            this.stage = context;
            this.vertexString = vertexString;
            this.fragmentString = fragmentString;
            this.stage.registerProgram(this);
        }
        /**
         *
         */
        ProgramData.prototype.dispose = function () {
            this.usages--;
            if (!this.usages) {
                this._pool.disposeItem(this.vertexString + this.fragmentString);
                this.stage.unRegisterProgram(this);
                if (this.program) {
                    this.program.dispose();
                    this.program = null;
                }
            }
        };
        ProgramData.PROGRAMDATA_ID_COUNT = 0;
        return ProgramData;
    }());

    /**
     * @class away.pool.ProgramDataPool
     */
    var ProgramDataPool = /** @class */ (function () {
        /**
         * //TODO
         *
         * @param textureDataClass
         */
        function ProgramDataPool(stage) {
            this._pool = new Object();
            this._stage = stage;
        }
        /**
         * //TODO
         *
         * @param materialOwner
         * @returns ITexture
         */
        ProgramDataPool.prototype.getItem = function (vertexString, fragmentString) {
            var key = vertexString + fragmentString;
            return this._pool[key] || (this._pool[key] = new ProgramData(this, this._stage, vertexString, fragmentString));
        };
        /**
         * //TODO
         *
         * @param materialOwner
         */
        ProgramDataPool.prototype.disposeItem = function (key) {
            this._pool[key] = null;
        };
        return ProgramDataPool;
    }());

    var IndexBufferSoftware = /** @class */ (function () {
        function IndexBufferSoftware(numIndices) {
            this._numIndices = numIndices;
        }
        IndexBufferSoftware.prototype.uploadFromArray = function (array, startOffset, count) {
            this._startOffset = startOffset * 2;
            this._data = array;
        };
        IndexBufferSoftware.prototype.uploadFromByteArray = function (data, startOffset, count) {
            this._startOffset = startOffset * 2;
            this._data = new Uint16Array(data);
        };
        IndexBufferSoftware.prototype.dispose = function () {
            this._data = null;
        };
        Object.defineProperty(IndexBufferSoftware.prototype, "numIndices", {
            get: function () {
                return this._numIndices;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(IndexBufferSoftware.prototype, "data", {
            get: function () {
                return this._data;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(IndexBufferSoftware.prototype, "startOffset", {
            get: function () {
                return this._startOffset;
            },
            enumerable: true,
            configurable: true
        });
        return IndexBufferSoftware;
    }());

    var VertexBufferSoftware = /** @class */ (function () {
        //private _dataOffset:number;
        function VertexBufferSoftware(numVertices, dataPerVertex) {
            this._numVertices = numVertices;
            this._dataPerVertex = dataPerVertex;
        }
        VertexBufferSoftware.prototype.uploadFromArray = function (array, startVertex, numVertices) {
            //this._dataOffset = startVertex * this._dataPerVertex;
            this._floatData = array;
        };
        VertexBufferSoftware.prototype.uploadFromByteArray = function (data, startVertex, numVertices) {
            //this._dataOffset = startVertex * this._dataPerVertex;
            this._floatData = new Float32Array(data, startVertex * this._dataPerVertex, numVertices * this._dataPerVertex / 4);
            this._uintData = new Uint8Array(data);
        };
        Object.defineProperty(VertexBufferSoftware.prototype, "numVertices", {
            get: function () {
                return this._numVertices;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(VertexBufferSoftware.prototype, "dataPerVertex", {
            get: function () {
                return this._dataPerVertex;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(VertexBufferSoftware.prototype, "attributesPerVertex", {
            get: function () {
                return this._dataPerVertex / 4;
            },
            enumerable: true,
            configurable: true
        });
        VertexBufferSoftware.prototype.dispose = function () {
            this._floatData = null;
        };
        Object.defineProperty(VertexBufferSoftware.prototype, "data", {
            get: function () {
                return this._floatData;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(VertexBufferSoftware.prototype, "uintData", {
            get: function () {
                return this._uintData;
            },
            enumerable: true,
            configurable: true
        });
        return VertexBufferSoftware;
    }());

    var TextureSoftware = /** @class */ (function () {
        function TextureSoftware(width, height) {
            this._mipLevels = [];
            this._width = width;
            this._height = height;
        }
        Object.defineProperty(TextureSoftware.prototype, "textureType", {
            get: function () {
                return TextureSoftware.textureType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextureSoftware.prototype, "width", {
            get: function () {
                return this._width;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextureSoftware.prototype, "height", {
            get: function () {
                return this._height;
            },
            enumerable: true,
            configurable: true
        });
        TextureSoftware.prototype.dispose = function () {
            this._mipLevels = null;
        };
        TextureSoftware.prototype.isTexture = function (textureClass) {
            return this.textureType == textureClass.textureType;
        };
        TextureSoftware.prototype.uploadFromArray = function (array, miplevel) {
            if (miplevel === void 0) { miplevel = 0; }
            this._mipLevels[miplevel] = (array instanceof Array) ? new Uint8Array(array) : array;
        };
        TextureSoftware.prototype.uploadFromURL = function (urlRequest, miplevel) {
            if (miplevel === void 0) { miplevel = 0; }
        };
        TextureSoftware.prototype.getData = function (miplevel) {
            return this._mipLevels[miplevel];
        };
        TextureSoftware.prototype.getMipLevelsCount = function () {
            return this._mipLevels.length;
        };
        TextureSoftware.prototype.generateMipmaps = function () {
            //TODO
        };
        TextureSoftware.textureType = "texture2d";
        return TextureSoftware;
    }());

    var CubeTextureSoftware = /** @class */ (function () {
        function CubeTextureSoftware(size) {
            this._textureSelectorDictionary = [[], [], [], [], [], []];
            this._size = size;
        }
        Object.defineProperty(CubeTextureSoftware.prototype, "textureType", {
            get: function () {
                return CubeTextureSoftware.textureType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CubeTextureSoftware.prototype, "size", {
            get: function () {
                return this._size;
            },
            enumerable: true,
            configurable: true
        });
        CubeTextureSoftware.prototype.dispose = function () {
            this._textureSelectorDictionary = null;
        };
        CubeTextureSoftware.prototype.isTexture = function (textureClass) {
            return this.textureType == textureClass.textureType;
        };
        CubeTextureSoftware.prototype.uploadFromArray = function (array, side, miplevel) {
            if (miplevel === void 0) { miplevel = 0; }
            this._textureSelectorDictionary[side][miplevel] = (array instanceof Array) ? new Uint8Array(array) : array;
        };
        CubeTextureSoftware.prototype.getData = function (side, miplevel) {
            if (miplevel === void 0) { miplevel = 0; }
            return this._textureSelectorDictionary[side][miplevel];
        };
        CubeTextureSoftware.prototype.getMipLevelsCount = function () {
            return 1;
        };
        CubeTextureSoftware.prototype.generateMipmaps = function () {
            //TODO
        };
        CubeTextureSoftware.prototype.uploadCompressedTextureFromArray = function (array, offset, async) {
            // TODO
        };
        CubeTextureSoftware.textureType = "textureCube";
        return CubeTextureSoftware;
    }());

    var ProgramVOSoftware = /** @class */ (function () {
        function ProgramVOSoftware() {
            this.outputColor = new Float32Array([0, 0, 0, 1]);
            this.discard = false;
        }
        return ProgramVOSoftware;
    }());

    /**
     * The same as SamplerState, but with strings
     * TODO: replace two similar classes with one
     */
    var SoftwareSamplerState = /** @class */ (function () {
        function SoftwareSamplerState() {
            this.wrap = ContextGLWrapMode.REPEAT;
            this.filter = ContextGLTextureFilter.LINEAR;
            this.mipfilter = ContextGLMipFilter.MIPLINEAR;
        }
        return SoftwareSamplerState;
    }());

    var ProgramSoftware = /** @class */ (function () {
        function ProgramSoftware() {
            this._numVarying = 0;
        }
        Object.defineProperty(ProgramSoftware.prototype, "numVarying", {
            get: function () {
                return this._numVarying;
            },
            enumerable: true,
            configurable: true
        });
        ProgramSoftware.prototype.upload = function (vertexProgram, fragmentProgram) {
            this._vertexDescr = ProgramSoftware._tokenizer.decribeAGALByteArray(vertexProgram);
            this._vertexVO = new ProgramVOSoftware();
            this._vertexVO.temp = new Float32Array(this._vertexDescr.regwrite[0x2].length * 4);
            this._vertexVO.attributes = new Float32Array(this._vertexDescr.regread[0x0].length * 4);
            this._numVarying = this._vertexDescr.regwrite[0x4].length;
            this._fragmentDescr = ProgramSoftware._tokenizer.decribeAGALByteArray(fragmentProgram);
            this._fragmentVO = new ProgramVOSoftware();
            this._fragmentVO.temp = new Float32Array(this._fragmentDescr.regwrite[0x2].length * 4);
            this._fragmentVO.varying = new Float32Array(this._fragmentDescr.regread[0x4].length * 4);
            this._fragmentVO.derivativeX = new Float32Array(this._fragmentVO.varying.length);
            this._fragmentVO.derivativeY = new Float32Array(this._fragmentVO.varying.length);
        };
        ProgramSoftware.prototype.dispose = function () {
            this._vertexDescr = null;
            this._fragmentDescr = null;
        };
        ProgramSoftware.prototype.vertex = function (context, vertexIndex, position, varying) {
            //set attributes
            var i;
            var j = 0;
            var numAttributes = this._vertexDescr.regread[0x0].length;
            var attributes = this._vertexVO.attributes;
            for (i = 0; i < numAttributes; i++) {
                var buffer = context._vertexBuffers[i];
                if (!buffer)
                    continue;
                var index = context._vertexBufferOffsets[i] / 4 + vertexIndex * buffer.attributesPerVertex;
                if (context._vertexBufferFormats[i] == ContextGLVertexBufferFormat.UNSIGNED_BYTE_4) {
                    attributes[j++] = buffer.uintData[index * 4];
                    attributes[j++] = buffer.uintData[index * 4 + 1];
                    attributes[j++] = buffer.uintData[index * 4 + 2];
                    attributes[j++] = buffer.uintData[index * 4 + 3];
                }
                else if (context._vertexBufferFormats[i] == ContextGLVertexBufferFormat.FLOAT_4) {
                    attributes[j++] = buffer.data[index];
                    attributes[j++] = buffer.data[index + 1];
                    attributes[j++] = buffer.data[index + 2];
                    attributes[j++] = buffer.data[index + 3];
                }
                else if (context._vertexBufferFormats[i] == ContextGLVertexBufferFormat.FLOAT_3) {
                    attributes[j++] = buffer.data[index];
                    attributes[j++] = buffer.data[index + 1];
                    attributes[j++] = buffer.data[index + 2];
                    attributes[j++] = 1;
                }
                else if (context._vertexBufferFormats[i] == ContextGLVertexBufferFormat.FLOAT_2) {
                    attributes[j++] = buffer.data[index];
                    attributes[j++] = buffer.data[index + 1];
                    attributes[j++] = 0;
                    attributes[j++] = 1;
                }
                else if (context._vertexBufferFormats[i] == ContextGLVertexBufferFormat.FLOAT_1) {
                    attributes[j++] = buffer.data[index];
                    attributes[j++] = 0;
                    attributes[j++] = 0;
                    attributes[j++] = 1;
                }
            }
            //clear temps
            var temp = this._vertexVO.temp;
            var numTemp = temp.length;
            for (var i = 0; i < numTemp; i += 4) {
                temp[i] = 0;
                temp[i + 1] = 0;
                temp[i + 2] = 0;
                temp[i + 3] = 1;
            }
            this._vertexVO.outputPosition = position;
            this._vertexVO.varying = varying;
            var len = this._vertexDescr.tokens.length;
            for (var i = 0; i < len; i++) {
                var token = this._vertexDescr.tokens[i];
                ProgramSoftware._opCodeFunc[token.opcode](this._vertexVO, this._vertexDescr, token.dest, token.a, token.b, context);
            }
        };
        ProgramSoftware.prototype.fragment = function (context, clip, clipRight, clipBottom, varying0, varying1, varying2, fragDepth) {
            this._fragmentVO.outputDepth = fragDepth;
            this._fragmentVO.discard = false;
            //clear temps
            var temp = this._fragmentVO.temp;
            var numTemp = temp.length;
            for (var i = 0; i < numTemp; i += 4) {
                temp[i] = 0;
                temp[i + 1] = 0;
                temp[i + 2] = 0;
                temp[i + 3] = 1;
            }
            //check for requirement of derivatives
            var varyingDerivatives = [];
            var len = this._fragmentDescr.tokens.length;
            for (var i = 0; i < len; i++) {
                var token = this._fragmentDescr.tokens[i];
                if (token.opcode == 0x28 && context._samplerStates[token.b.regnum] && context._samplerStates[token.b.regnum].mipfilter == ContextGLMipFilter.MIPLINEAR && context._textures[token.b.regnum].getMipLevelsCount() > 1)
                    varyingDerivatives.push(token.a.regnum);
            }
            var derivativeX = this._fragmentVO.derivativeX;
            var derivativeY = this._fragmentVO.derivativeY;
            var varying = this._fragmentVO.varying;
            var numVarying = varying.length;
            for (var i = 0; i < numVarying; i += 4) {
                // if (!varying0 || !varying1 || !varying2) continue;
                varying[i] = clip.x * varying0[i] + clip.y * varying1[i] + clip.z * varying2[i];
                varying[i + 1] = clip.x * varying0[i + 1] + clip.y * varying1[i + 1] + clip.z * varying2[i + 1];
                varying[i + 2] = clip.x * varying0[i + 2] + clip.y * varying1[i + 2] + clip.z * varying2[i + 2];
                varying[i + 3] = clip.x * varying0[i + 3] + clip.y * varying1[i + 3] + clip.z * varying2[i + 3];
                if (varyingDerivatives.indexOf(i) == -1)
                    continue;
                derivativeX[i] = clipRight.x * varying0[i] + clipRight.y * varying1[i] + clipRight.z * varying2[i];
                derivativeX[i + 1] = clipRight.x * varying0[i + 1] + clipRight.y * varying1[i + 1] + clipRight.z * varying2[i + 1];
                derivativeX[i + 2] = clipRight.x * varying0[i + 2] + clipRight.y * varying1[i + 2] + clipRight.z * varying2[i + 2];
                derivativeX[i + 3] = clipRight.x * varying0[i + 3] + clipRight.y * varying1[i + 3] + clipRight.z * varying2[i + 3];
                derivativeX[i] -= varying[i];
                derivativeX[i + 1] -= varying[i + 1];
                derivativeX[i + 2] -= varying[i + 2];
                derivativeX[i + 3] -= varying[i + 3];
                derivativeY[i] = clipBottom.x * varying0[i] + clipBottom.y * varying1[i] + clipBottom.z * varying2[i];
                derivativeY[i + 1] = clipBottom.x * varying0[i + 1] + clipBottom.y * varying1[i + 1] + clipBottom.z * varying2[i + 1];
                derivativeY[i + 2] = clipBottom.x * varying0[i + 2] + clipBottom.y * varying1[i + 2] + clipBottom.z * varying2[i + 2];
                derivativeY[i + 3] = clipBottom.x * varying0[i + 3] + clipBottom.y * varying1[i + 3] + clipBottom.z * varying2[i + 3];
                derivativeY[i] -= varying[i];
                derivativeY[i + 1] -= varying[i + 1];
                derivativeY[i + 2] -= varying[i + 2];
                derivativeY[i + 3] -= varying[i + 3];
            }
            for (var i = 0; i < len; i++) {
                var token = this._fragmentDescr.tokens[i];
                ProgramSoftware._opCodeFunc[token.opcode](this._fragmentVO, this._fragmentDescr, token.dest, token.a, token.b, context);
            }
            return this._fragmentVO;
        };
        ProgramSoftware.getDestTarget = function (vo, desc, dest) {
            var target;
            if (dest.regtype == 0x2) {
                target = vo.temp;
            }
            else if (dest.regtype == 0x3) {
                if (desc.header.type == "vertex") {
                    target = vo.outputPosition;
                }
                else {
                    target = vo.outputColor;
                }
            }
            else if (dest.regtype == 0x4) {
                target = vo.varying;
            }
            return target;
        };
        ProgramSoftware.getSourceTarget = function (vo, desc, dest, context) {
            var target;
            if (dest.regtype == 0x0) {
                target = vo.attributes;
            }
            else if (dest.regtype == 0x1) {
                if (desc.header.type == "vertex") {
                    target = context._vertexConstants;
                }
                else {
                    target = context._fragmentConstants;
                }
            }
            else if (dest.regtype == 0x2) {
                target = vo.temp;
            }
            else if (dest.regtype == 0x4) {
                target = vo.varying;
            }
            return target;
        };
        ProgramSoftware.mov = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            if (mask & 1)
                target[targetReg] = source1Target[source1Reg + ((source1.swizzle >> 0) & 3)];
            if (mask & 2)
                target[targetReg + 1] = source1Target[source1Reg + ((source1.swizzle >> 2) & 3)];
            if (mask & 4)
                target[targetReg + 2] = source1Target[source1Reg + ((source1.swizzle >> 4) & 3)];
            if (mask & 8)
                target[targetReg + 3] = source1Target[source1Reg + ((source1.swizzle >> 6) & 3)];
        };
        ProgramSoftware.m44 = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var mask = dest.mask;
            if (mask & 1)
                target[targetReg] = source1Target[source1Reg] * source2Target[source2Reg] + source1Target[source1Reg + 1] * source2Target[source2Reg + 1] + source1Target[source1Reg + 2] * source2Target[source2Reg + 2] + source2Target[source2Reg + 3];
            if (mask & 2)
                target[targetReg + 1] = source1Target[source1Reg] * source2Target[source2Reg + 4] + source1Target[source1Reg + 1] * source2Target[source2Reg + 5] + source1Target[source1Reg + 2] * source2Target[source2Reg + 6] + source2Target[source2Reg + 7];
            if (mask & 4)
                target[targetReg + 2] = source1Target[source1Reg] * source2Target[source2Reg + 8] + source1Target[source1Reg + 1] * source2Target[source2Reg + 9] + source1Target[source1Reg + 2] * source2Target[source2Reg + 10] + source2Target[source2Reg + 11];
            if (mask & 8)
                target[targetReg + 3] = source1Target[source1Reg] * source2Target[source2Reg + 12] + source1Target[source1Reg + 1] * source2Target[source2Reg + 13] + source1Target[source1Reg + 2] * source2Target[source2Reg + 14] + source2Target[source2Reg + 15];
        };
        ProgramSoftware.sample = function (vo, desc, context, source1, textureIndex) {
            var texture = context._textures[textureIndex];
            if (texture.isTexture(TextureSoftware))
                return ProgramSoftware.sampleSimpleTexture(vo, desc, context, source1, textureIndex);
            if (texture.isTexture(CubeTextureSoftware))
                return ProgramSoftware.sampleCubeTexture(vo, desc, context, source1, textureIndex);
            throw new ArgumentError("Cannot sample provided texture type");
        };
        ProgramSoftware.sampleCubeTexture = function (vo, desc, context, source1, textureIndex) {
            var source1Reg = 4 * source1.regnum;
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            // Get the direction vector.
            var x = source1Target[source1Reg + ((source1.swizzle >> 0) & 3)];
            var y = source1Target[source1Reg + ((source1.swizzle >> 2) & 3)];
            var z = source1Target[source1Reg + ((source1.swizzle >> 4) & 3)];
            // Determine which of the 6 cube sides to sample,
            // depending on the largest abs value of the direction vector.
            // Once determined, translate to uv within this side.
            var side = 0;
            var u = 0;
            var v = 0;
            var absx = Math.abs(x);
            var absy = Math.abs(y);
            var absz = Math.abs(z);
            var absmax = Math.max(absx, absy, absz);
            if (absmax == absx) {
                if (x >= 0) {
                    side = 0;
                    u = 0.5 - 0.5 * (z / x);
                    v = 0.5 - 0.5 * (y / x);
                }
                else {
                    side = 1;
                    u = 0.5 - 0.5 * (z / x);
                    v = 0.5 + 0.5 * (y / x);
                }
            }
            else if (absmax == absy) {
                if (y >= 0) {
                    side = 2;
                    u = 0.5 + 0.5 * (x / y);
                    v = 0.5 + 0.5 * (z / y);
                }
                else {
                    side = 3;
                    u = 0.5 - 0.5 * (x / y);
                    v = 0.5 + 0.5 * (z / y);
                }
            }
            else if (absmax == absz) {
                if (z >= 0) {
                    side = 4;
                    u = 0.5 + 0.5 * (x / z);
                    v = 0.5 - 0.5 * (y / z);
                }
                else {
                    side = 5;
                    u = 0.5 + 0.5 * (x / z);
                    v = 0.5 + 0.5 * (y / z);
                }
            }
            var texture = context._textures[textureIndex];
            var state = context._samplerStates[textureIndex] || this._defaultSamplerState;
            var repeat = state.wrap == ContextGLWrapMode.REPEAT;
            var mipmap = state.mipfilter == ContextGLMipFilter.MIPLINEAR;
            // TODO: implement mip mapping?
            if (state.filter == ContextGLTextureFilter.LINEAR)
                return ProgramSoftware.sampleBilinear(u, v, texture.getData(side), texture.size, texture.size, repeat, ProgramSoftware._colorValue0);
            return ProgramSoftware.sampleNearest(u, v, texture.getData(side), texture.size, texture.size, repeat, ProgramSoftware._colorValue0);
        };
        ProgramSoftware.sampleSimpleTexture = function (vo, desc, context, source1, textureIndex) {
            var source1Reg = 4 * source1.regnum;
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var u = source1Target[source1Reg + ((source1.swizzle >> 0) & 3)];
            var v = source1Target[source1Reg + ((source1.swizzle >> 2) & 3)];
            if (textureIndex >= context._textures.length || context._textures[textureIndex] == null)
                throw new ArgumentError("textureIndex contains no texture");
            var texture = context._textures[textureIndex];
            var state = context._samplerStates[textureIndex] || this._defaultSamplerState;
            var repeat = state.wrap == ContextGLWrapMode.REPEAT;
            var mipmap = state.mipfilter == ContextGLMipFilter.MIPLINEAR;
            if (mipmap && texture.getMipLevelsCount() > 1) {
                var dux = Math.abs(vo.derivativeX[source1Reg + ((source1.swizzle >> 0) & 3)]);
                var dvx = Math.abs(vo.derivativeX[source1Reg + ((source1.swizzle >> 2) & 3)]);
                var duy = Math.abs(vo.derivativeY[source1Reg + ((source1.swizzle >> 0) & 3)]);
                var dvy = Math.abs(vo.derivativeY[source1Reg + ((source1.swizzle >> 2) & 3)]);
                var lambda = Math.log(Math.max(texture.width * Math.sqrt(dux * dux + dvx * dvx), texture.height * Math.sqrt(duy * duy + dvy * dvy))) / Math.LN2;
                if (lambda > 0) {
                    var miplevelLow = Math.floor(lambda);
                    var miplevelHigh = Math.ceil(lambda);
                    var maxmiplevel = Math.log(Math.min(texture.width, texture.height)) / Math.LN2;
                    if (miplevelHigh > maxmiplevel)
                        miplevelHigh = maxmiplevel;
                    if (miplevelLow > maxmiplevel)
                        miplevelLow = maxmiplevel;
                    var mipblend = lambda - Math.floor(lambda);
                    var dataLow = texture.getData(miplevelLow);
                    var dataLowWidth = texture.width / Math.pow(2, miplevelLow);
                    var dataLowHeight = texture.height / Math.pow(2, miplevelLow);
                    var dataHigh = texture.getData(miplevelHigh);
                    var dataHighWidth = texture.width / Math.pow(2, miplevelHigh);
                    var dataHighHeight = texture.height / Math.pow(2, miplevelHigh);
                    if (state.filter == ContextGLTextureFilter.LINEAR) {
                        ProgramSoftware.sampleBilinear(u, v, dataLow, dataLowWidth, dataLowHeight, repeat, ProgramSoftware._colorValue0);
                        ProgramSoftware.sampleBilinear(u, v, dataHigh, dataHighWidth, dataHighHeight, repeat, ProgramSoftware._colorValue1);
                    }
                    else {
                        ProgramSoftware.sampleNearest(u, v, dataLow, dataLowWidth, dataLowHeight, repeat, ProgramSoftware._colorValue0);
                        ProgramSoftware.sampleNearest(u, v, dataHigh, dataHighWidth, dataHighHeight, repeat, ProgramSoftware._colorValue1);
                    }
                    return ProgramSoftware.interpolateColor(ProgramSoftware._colorValue0, ProgramSoftware._colorValue1, mipblend, ProgramSoftware._colorValue0);
                }
            }
            if (state.filter == ContextGLTextureFilter.LINEAR)
                return ProgramSoftware.sampleBilinear(u, v, texture.getData(0), texture.width, texture.height, repeat, ProgramSoftware._colorValue0);
            return ProgramSoftware.sampleNearest(u, v, texture.getData(0), texture.width, texture.height, repeat, ProgramSoftware._colorValue0);
        };
        ProgramSoftware.sampleNearest = function (u, v, textureData, textureWidth, textureHeight, repeat, output) {
            u *= textureWidth;
            v *= textureHeight;
            if (repeat) {
                u = Math.abs(u % textureWidth);
                v = Math.abs(v % textureHeight);
            }
            else {
                if (u < 0)
                    u = 0;
                else if (u > textureWidth - 1)
                    u = textureWidth - 1;
                if (v < 0)
                    v = 0;
                else if (v > textureHeight - 1)
                    v = textureHeight - 1;
            }
            u = Math.floor(u);
            v = Math.floor(v);
            var pos = (u + v * textureWidth) * 4;
            output[0] = textureData[pos] / 255;
            output[1] = textureData[pos + 1] / 255;
            output[2] = textureData[pos + 2] / 255;
            output[3] = textureData[pos + 3] / 255;
            return output;
        };
        ProgramSoftware.sampleBilinear = function (u, v, textureData, textureWidth, textureHeight, repeat, output) {
            var texelSizeX = 1 / textureWidth;
            var texelSizeY = 1 / textureHeight;
            u -= texelSizeX / 2;
            v -= texelSizeY / 2;
            var a = u * textureWidth;
            a = a - Math.floor(a);
            var b = v * textureHeight;
            b = b - Math.floor(b);
            return ProgramSoftware.interpolateColor(ProgramSoftware.interpolateColor(ProgramSoftware.sampleNearest(u, v, textureData, textureWidth, textureHeight, repeat, ProgramSoftware._colorInterpolated0), ProgramSoftware.sampleNearest(u + texelSizeX, v, textureData, textureWidth, textureHeight, repeat, ProgramSoftware._colorValue0), a, ProgramSoftware._colorInterpolated0), ProgramSoftware.interpolateColor(ProgramSoftware.sampleNearest(u, v + texelSizeY, textureData, textureWidth, textureHeight, repeat, ProgramSoftware._colorInterpolated1), ProgramSoftware.sampleNearest(u + texelSizeX, v + texelSizeY, textureData, textureWidth, textureHeight, repeat, ProgramSoftware._colorValue0), a, ProgramSoftware._colorInterpolated1), b, output);
        };
        ProgramSoftware.interpolateColor = function (source, target, a, output) {
            output[0] = source[0] + (target[0] - source[0]) * a;
            output[1] = source[1] + (target[1] - source[1]) * a;
            output[2] = source[2] + (target[2] - source[2]) * a;
            output[3] = source[3] + (target[3] - source[3]) * a;
            return output;
        };
        ProgramSoftware.tex = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var color = ProgramSoftware.sample(vo, desc, context, source1, source2.regnum);
            var mask = dest.mask;
            if (mask & 1)
                target[targetReg] = color[0];
            if (mask & 2)
                target[targetReg + 1] = color[1];
            if (mask & 4)
                target[targetReg + 2] = color[2];
            if (mask & 8)
                target[targetReg + 3] = color[3];
        };
        ProgramSoftware.add = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            if (mask & 1)
                target[targetReg] = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)] + source2Target[source2Reg + ((source2Swizzle >> 0) & 3)];
            if (mask & 2)
                target[targetReg + 1] = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)] + source2Target[source2Reg + ((source2Swizzle >> 2) & 3)];
            if (mask & 4)
                target[targetReg + 2] = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)] + source2Target[source2Reg + ((source2Swizzle >> 4) & 3)];
            if (mask & 8)
                target[targetReg + 3] = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)] + source2Target[source2Reg + ((source2Swizzle >> 6) & 3)];
        };
        ProgramSoftware.sub = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            if (mask & 1)
                target[targetReg] = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)] - source2Target[source2Reg + ((source2Swizzle >> 0) & 3)];
            if (mask & 2)
                target[targetReg + 1] = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)] - source2Target[source2Reg + ((source2Swizzle >> 2) & 3)];
            if (mask & 4)
                target[targetReg + 2] = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)] - source2Target[source2Reg + ((source2Swizzle >> 4) & 3)];
            if (mask & 8)
                target[targetReg + 3] = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)] - source2Target[source2Reg + ((source2Swizzle >> 6) & 3)];
        };
        ProgramSoftware.mul = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            if (mask & 1)
                target[targetReg] = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)] * source2Target[source2Reg + ((source2Swizzle >> 0) & 3)];
            if (mask & 2)
                target[targetReg + 1] = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)] * source2Target[source2Reg + ((source2Swizzle >> 2) & 3)];
            if (mask & 4)
                target[targetReg + 2] = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)] * source2Target[source2Reg + ((source2Swizzle >> 4) & 3)];
            if (mask & 8)
                target[targetReg + 3] = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)] * source2Target[source2Reg + ((source2Swizzle >> 6) & 3)];
        };
        ProgramSoftware.div = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            if (mask & 1)
                target[targetReg] = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)] / source2Target[source2Reg + ((source2Swizzle >> 0) & 3)];
            if (mask & 2)
                target[targetReg + 1] = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)] / source2Target[source2Reg + ((source2Swizzle >> 2) & 3)];
            if (mask & 4)
                target[targetReg + 2] = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)] / source2Target[source2Reg + ((source2Swizzle >> 4) & 3)];
            if (mask & 8)
                target[targetReg + 3] = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)] / source2Target[source2Reg + ((source2Swizzle >> 6) & 3)];
        };
        ProgramSoftware.rcp = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = 1 / source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            if (mask & 2)
                target[targetReg + 1] = 1 / source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            if (mask & 4)
                target[targetReg + 2] = 1 / source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            if (mask & 8)
                target[targetReg + 3] = 1 / source1Target[source1Reg + ((source1Swizzle >> 6) & 3)];
        };
        ProgramSoftware.min = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            if (mask & 1)
                target[targetReg] = Math.min(source1Target[source1Reg + ((source1Swizzle >> 0) & 3)], source2Target[source2Reg + ((source2Swizzle >> 0) & 3)]);
            if (mask & 2)
                target[targetReg + 1] = Math.min(source1Target[source1Reg + ((source1Swizzle >> 2) & 3)], source2Target[source2Reg + ((source2Swizzle >> 2) & 3)]);
            if (mask & 4)
                target[targetReg + 2] = Math.min(source1Target[source1Reg + ((source1Swizzle >> 4) & 3)], source2Target[source2Reg + ((source2Swizzle >> 4) & 3)]);
            if (mask & 8)
                target[targetReg + 3] = Math.min(source1Target[source1Reg + ((source1Swizzle >> 6) & 3)], source2Target[source2Reg + ((source2Swizzle >> 6) & 3)]);
        };
        ProgramSoftware.max = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            if (mask & 1)
                target[targetReg] = Math.max(source1Target[source1Reg + ((source1Swizzle >> 0) & 3)], source2Target[source2Reg + ((source2Swizzle >> 0) & 3)]);
            if (mask & 2)
                target[targetReg + 1] = Math.max(source1Target[source1Reg + ((source1Swizzle >> 2) & 3)], source2Target[source2Reg + ((source2Swizzle >> 2) & 3)]);
            if (mask & 4)
                target[targetReg + 2] = Math.max(source1Target[source1Reg + ((source1Swizzle >> 4) & 3)], source2Target[source2Reg + ((source2Swizzle >> 4) & 3)]);
            if (mask & 8)
                target[targetReg + 3] = Math.max(source1Target[source1Reg + ((source1Swizzle >> 6) & 3)], source2Target[source2Reg + ((source2Swizzle >> 6) & 3)]);
        };
        ProgramSoftware.frc = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)] - Math.floor(source1Target[source1Reg + ((source1Swizzle >> 0) & 3)]);
            if (mask & 2)
                target[targetReg + 1] = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)] - Math.floor(source1Target[source1Reg + ((source1Swizzle >> 2) & 3)]);
            if (mask & 4)
                target[targetReg + 2] = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)] - Math.floor(source1Target[source1Reg + ((source1Swizzle >> 4) & 3)]);
            if (mask & 8)
                target[targetReg + 3] = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)] - Math.floor(source1Target[source1Reg + ((source1Swizzle >> 6) & 3)]);
        };
        ProgramSoftware.sqt = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = Math.sqrt(source1Target[source1Reg + ((source1Swizzle >> 0) & 3)]);
            if (mask & 2)
                target[targetReg + 1] = Math.sqrt(source1Target[source1Reg + ((source1Swizzle >> 2) & 3)]);
            if (mask & 4)
                target[targetReg + 2] = Math.sqrt(source1Target[source1Reg + ((source1Swizzle >> 4) & 3)]);
            if (mask & 8)
                target[targetReg + 3] = Math.sqrt(source1Target[source1Reg + ((source1Swizzle >> 6) & 3)]);
        };
        ProgramSoftware.rsq = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = 1 / Math.sqrt(source1Target[source1Reg + ((source1Swizzle >> 0) & 3)]);
            if (mask & 2)
                target[targetReg + 1] = 1 / Math.sqrt(source1Target[source1Reg + ((source1Swizzle >> 2) & 3)]);
            if (mask & 4)
                target[targetReg + 2] = 1 / Math.sqrt(source1Target[source1Reg + ((source1Swizzle >> 4) & 3)]);
            if (mask & 8)
                target[targetReg + 3] = 1 / Math.sqrt(source1Target[source1Reg + ((source1Swizzle >> 6) & 3)]);
        };
        ProgramSoftware.pow = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            if (mask & 1)
                target[targetReg] = Math.pow(source1Target[source1Reg + ((source1Swizzle >> 0) & 3)], source2Target[source2Reg + ((source2Swizzle >> 0) & 3)]);
            if (mask & 2)
                target[targetReg + 1] = Math.pow(source1Target[source1Reg + ((source1Swizzle >> 2) & 3)], source2Target[source2Reg + ((source2Swizzle >> 2) & 3)]);
            if (mask & 4)
                target[targetReg + 2] = Math.pow(source1Target[source1Reg + ((source1Swizzle >> 4) & 3)], source2Target[source2Reg + ((source2Swizzle >> 4) & 3)]);
            if (mask & 8)
                target[targetReg + 3] = Math.pow(source1Target[source1Reg + ((source1Swizzle >> 6) & 3)], source2Target[source2Reg + ((source2Swizzle >> 6) & 3)]);
        };
        ProgramSoftware.log = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = Math.log(source1Target[source1Reg + ((source1Swizzle >> 0) & 3)]) / Math.LN2;
            if (mask & 2)
                target[targetReg + 1] = Math.log(source1Target[source1Reg + ((source1Swizzle >> 2) & 3)]) / Math.LN2;
            if (mask & 4)
                target[targetReg + 2] = Math.log(source1Target[source1Reg + ((source1Swizzle >> 4) & 3)]) / Math.LN2;
            if (mask & 8)
                target[targetReg + 3] = Math.log(source1Target[source1Reg + ((source1Swizzle >> 6) & 3)]) / Math.LN2;
        };
        ProgramSoftware.exp = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = Math.exp(source1Target[source1Reg + ((source1Swizzle >> 0) & 3)]);
            if (mask & 2)
                target[targetReg + 1] = Math.exp(source1Target[source1Reg + ((source1Swizzle >> 2) & 3)]);
            if (mask & 4)
                target[targetReg + 2] = Math.exp(source1Target[source1Reg + ((source1Swizzle >> 4) & 3)]);
            if (mask & 8)
                target[targetReg + 3] = Math.exp(source1Target[source1Reg + ((source1Swizzle >> 6) & 3)]);
        };
        ProgramSoftware.nrm = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var x = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            var y = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            var z = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            var len = Math.sqrt(x * x + y * y + z * z);
            x /= len;
            y /= len;
            z /= len;
            if (mask & 1)
                target[targetReg] = x;
            if (mask & 2)
                target[targetReg + 1] = y;
            if (mask & 4)
                target[targetReg + 2] = z;
        };
        ProgramSoftware.sin = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = Math.sin(source1Target[source1Reg + ((source1Swizzle >> 0) & 3)]);
            if (mask & 2)
                target[targetReg + 1] = Math.sin(source1Target[source1Reg + ((source1Swizzle >> 2) & 3)]);
            if (mask & 4)
                target[targetReg + 2] = Math.sin(source1Target[source1Reg + ((source1Swizzle >> 4) & 3)]);
            if (mask & 8)
                target[targetReg + 3] = Math.sin(source1Target[source1Reg + ((source1Swizzle >> 6) & 3)]);
        };
        ProgramSoftware.cos = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = Math.cos(source1Target[source1Reg + ((source1Swizzle >> 0) & 3)]);
            if (mask & 2)
                target[targetReg + 1] = Math.cos(source1Target[source1Reg + ((source1Swizzle >> 2) & 3)]);
            if (mask & 4)
                target[targetReg + 2] = Math.cos(source1Target[source1Reg + ((source1Swizzle >> 4) & 3)]);
            if (mask & 8)
                target[targetReg + 3] = Math.cos(source1Target[source1Reg + ((source1Swizzle >> 6) & 3)]);
        };
        ProgramSoftware.crs = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source1TargetX = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            var source1TargetY = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            var source1TargetZ = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var source2TargetX = source2Target[source2Reg + ((source2Swizzle >> 0) & 3)];
            var source2TargetY = source2Target[source2Reg + ((source2Swizzle >> 2) & 3)];
            var source2TargetZ = source2Target[source2Reg + ((source2Swizzle >> 4) & 3)];
            if (mask & 1)
                target[targetReg] = source1TargetY * source2TargetZ - source1TargetZ * source2TargetY;
            if (mask & 2)
                target[targetReg + 1] = source1TargetZ * source2TargetX - source1TargetX * source2TargetZ;
            if (mask & 4)
                target[targetReg + 2] = source1TargetX * source2TargetY - source1TargetY * source2TargetX;
        };
        ProgramSoftware.dp3 = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source1TargetX = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            var source1TargetY = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            var source1TargetZ = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var source2TargetX = source2Target[source2Reg + ((source2Swizzle >> 0) & 3)];
            var source2TargetY = source2Target[source2Reg + ((source2Swizzle >> 2) & 3)];
            var source2TargetZ = source2Target[source2Reg + ((source2Swizzle >> 4) & 3)];
            if (mask & 1)
                target[targetReg] = source1TargetX * source2TargetX + source1TargetY * source2TargetY + source1TargetZ * source2TargetZ;
            if (mask & 2)
                target[targetReg + 1] = source1TargetX * source2TargetX + source1TargetY * source2TargetY + source1TargetZ * source2TargetZ;
            if (mask & 4)
                target[targetReg + 2] = source1TargetX * source2TargetX + source1TargetY * source2TargetY + source1TargetZ * source2TargetZ;
            if (mask & 8)
                target[targetReg + 3] = source1TargetX * source2TargetX + source1TargetY * source2TargetY + source1TargetZ * source2TargetZ;
        };
        ProgramSoftware.dp4 = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source1TargetX = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            var source1TargetY = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            var source1TargetZ = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            var source1TargetW = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)];
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var source2TargetX = source2Target[source2Reg + ((source2Swizzle >> 0) & 3)];
            var source2TargetY = source2Target[source2Reg + ((source2Swizzle >> 2) & 3)];
            var source2TargetZ = source2Target[source2Reg + ((source2Swizzle >> 4) & 3)];
            var source2TargetW = source2Target[source2Reg + ((source2Swizzle >> 6) & 3)];
            if (mask & 1)
                target[targetReg] = source1TargetX * source2TargetX + source1TargetY * source2TargetY + source1TargetZ * source2TargetZ + source1TargetW * source2TargetW;
            if (mask & 2)
                target[targetReg + 1] = source1TargetX * source2TargetX + source1TargetY * source2TargetY + source1TargetZ * source2TargetZ + source1TargetW * source2TargetW;
            if (mask & 4)
                target[targetReg + 2] = source1TargetX * source2TargetX + source1TargetY * source2TargetY + source1TargetZ * source2TargetZ + source1TargetW * source2TargetW;
            if (mask & 8)
                target[targetReg + 3] = source1TargetX * source2TargetX + source1TargetY * source2TargetY + source1TargetZ * source2TargetZ + source1TargetW * source2TargetW;
        };
        ProgramSoftware.abs = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = Math.abs(source1Target[source1Reg + ((source1Swizzle >> 0) & 3)]);
            if (mask & 2)
                target[targetReg + 1] = Math.abs(source1Target[source1Reg + ((source1Swizzle >> 2) & 3)]);
            if (mask & 4)
                target[targetReg + 2] = Math.abs(source1Target[source1Reg + ((source1Swizzle >> 4) & 3)]);
            if (mask & 8)
                target[targetReg + 3] = Math.abs(source1Target[source1Reg + ((source1Swizzle >> 6) & 3)]);
        };
        ProgramSoftware.neg = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = -source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            if (mask & 2)
                target[targetReg + 1] = -source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            if (mask & 4)
                target[targetReg + 2] = -source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            if (mask & 8)
                target[targetReg + 3] = -source1Target[source1Reg + ((source1Swizzle >> 6) & 3)];
        };
        ProgramSoftware.sat = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = Math.max(0, Math.min(1, source1Target[source1Reg + ((source1Swizzle >> 0) & 3)]));
            if (mask & 2)
                target[targetReg + 1] = Math.max(0, Math.min(1, source1Target[source1Reg + ((source1Swizzle >> 2) & 3)]));
            if (mask & 4)
                target[targetReg + 2] = Math.max(0, Math.min(1, source1Target[source1Reg + ((source1Swizzle >> 4) & 3)]));
            if (mask & 8)
                target[targetReg + 3] = Math.max(0, Math.min(1, source1Target[source1Reg + ((source1Swizzle >> 6) & 3)]));
        };
        ProgramSoftware.m33 = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var mask = dest.mask;
            if (mask & 1)
                target[targetReg] = source1Target[source1Reg] * source2Target[source2Reg] + source1Target[source1Reg + 1] * source2Target[source2Reg + 1] + source1Target[source1Reg + 2] * source2Target[source2Reg + 2];
            if (mask & 2)
                target[targetReg + 1] = source1Target[source1Reg] * source2Target[source2Reg + 4] + source1Target[source1Reg + 1] * source2Target[source2Reg + 5] + source1Target[source1Reg + 2] * source2Target[source2Reg + 6];
            if (mask & 4)
                target[targetReg + 2] = source1Target[source1Reg] * source2Target[source2Reg + 8] + source1Target[source1Reg + 1] * source2Target[source2Reg + 9] + source1Target[source1Reg + 2] * source2Target[source2Reg + 10];
        };
        ProgramSoftware.m34 = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var mask = dest.mask;
            if (mask & 1)
                target[targetReg] = source1Target[source1Reg] * source2Target[source2Reg] + source1Target[source1Reg + 1] * source2Target[source2Reg + 1] + source1Target[source1Reg + 2] * source2Target[source2Reg + 2] + source2Target[source2Reg + 3];
            if (mask & 2)
                target[targetReg + 1] = source1Target[source1Reg] * source2Target[source2Reg + 4] + source1Target[source1Reg + 1] * source2Target[source2Reg + 5] + source1Target[source1Reg + 2] * source2Target[source2Reg + 6] + source2Target[source2Reg + 7];
            if (mask & 4)
                target[targetReg + 2] = source1Target[source1Reg] * source2Target[source2Reg + 8] + source1Target[source1Reg + 1] * source2Target[source2Reg + 9] + source1Target[source1Reg + 2] * source2Target[source2Reg + 10] + source2Target[source2Reg + 11];
        };
        ProgramSoftware.ddx = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = vo.derivativeX;
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            if (mask & 2)
                target[targetReg + 1] = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            if (mask & 4)
                target[targetReg + 2] = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            if (mask & 8)
                target[targetReg + 3] = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)];
        };
        ProgramSoftware.ddy = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var source1Target = vo.derivativeY;
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            if (mask & 1)
                target[targetReg] = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            if (mask & 2)
                target[targetReg + 1] = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            if (mask & 4)
                target[targetReg + 2] = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            if (mask & 8)
                target[targetReg + 3] = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)];
        };
        ProgramSoftware.sge = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source1TargetX = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            var source1TargetY = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            var source1TargetZ = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            var source1TargetW = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)];
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var source2TargetX = source2Target[source2Reg + ((source2Swizzle >> 0) & 3)];
            var source2TargetY = source2Target[source2Reg + ((source2Swizzle >> 2) & 3)];
            var source2TargetZ = source2Target[source2Reg + ((source2Swizzle >> 4) & 3)];
            var source2TargetW = source2Target[source2Reg + ((source2Swizzle >> 6) & 3)];
            if (mask & 1)
                target[targetReg] = source1TargetX >= source2TargetX ? 1 : 0;
            if (mask & 2)
                target[targetReg + 1] = source1TargetY >= source2TargetY ? 1 : 0;
            if (mask & 4)
                target[targetReg + 2] = source1TargetZ >= source2TargetZ ? 1 : 0;
            if (mask & 8)
                target[targetReg + 3] = source1TargetW >= source2TargetW ? 1 : 0;
        };
        ProgramSoftware.slt = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source2.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source1TargetX = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            var source1TargetY = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            var source1TargetZ = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            var source1TargetW = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)];
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var source2TargetX = source2Target[source2Reg + ((source2Swizzle >> 0) & 3)];
            var source2TargetY = source2Target[source2Reg + ((source2Swizzle >> 2) & 3)];
            var source2TargetZ = source2Target[source2Reg + ((source2Swizzle >> 4) & 3)];
            var source2TargetW = source2Target[source2Reg + ((source2Swizzle >> 6) & 3)];
            if (mask & 1)
                target[targetReg] = source1TargetX < source2TargetX ? 1 : 0;
            if (mask & 2)
                target[targetReg + 1] = source1TargetY < source2TargetY ? 1 : 0;
            if (mask & 4)
                target[targetReg + 2] = source1TargetZ < source2TargetZ ? 1 : 0;
            if (mask & 8)
                target[targetReg + 3] = source1TargetW < source2TargetW ? 1 : 0;
        };
        ProgramSoftware.seq = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source1TargetX = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            var source1TargetY = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            var source1TargetZ = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            var source1TargetW = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)];
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var source2TargetX = source2Target[source2Reg + ((source2Swizzle >> 0) & 3)];
            var source2TargetY = source2Target[source2Reg + ((source2Swizzle >> 2) & 3)];
            var source2TargetZ = source2Target[source2Reg + ((source2Swizzle >> 4) & 3)];
            var source2TargetW = source2Target[source2Reg + ((source2Swizzle >> 6) & 3)];
            if (mask & 1)
                target[targetReg] = source1TargetX == source2TargetX ? 1 : 0;
            if (mask & 2)
                target[targetReg + 1] = source1TargetY == source2TargetY ? 1 : 0;
            if (mask & 4)
                target[targetReg + 2] = source1TargetZ == source2TargetZ ? 1 : 0;
            if (mask & 8)
                target[targetReg + 3] = source1TargetW == source2TargetW ? 1 : 0;
        };
        ProgramSoftware.sne = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var source2Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source2Swizzle = source2.swizzle;
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source1TargetX = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            var source1TargetY = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            var source1TargetZ = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            var source1TargetW = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)];
            var source2Target = ProgramSoftware.getSourceTarget(vo, desc, source2, context);
            var source2TargetX = source2Target[source2Reg + ((source2Swizzle >> 0) & 3)];
            var source2TargetY = source2Target[source2Reg + ((source2Swizzle >> 2) & 3)];
            var source2TargetZ = source2Target[source2Reg + ((source2Swizzle >> 4) & 3)];
            var source2TargetW = source2Target[source2Reg + ((source2Swizzle >> 6) & 3)];
            if (mask & 1)
                target[targetReg] = source1TargetX != source2TargetX ? 1 : 0;
            if (mask & 2)
                target[targetReg + 1] = source1TargetY != source2TargetY ? 1 : 0;
            if (mask & 4)
                target[targetReg + 2] = source1TargetZ != source2TargetZ ? 1 : 0;
            if (mask & 8)
                target[targetReg + 3] = source1TargetW != source2TargetW ? 1 : 0;
        };
        ProgramSoftware.sgn = function (vo, desc, dest, source1, source2, context) {
            var targetReg = 4 * dest.regnum;
            var source1Reg = 4 * source1.regnum;
            var target = ProgramSoftware.getDestTarget(vo, desc, dest);
            var mask = dest.mask;
            var source1Swizzle = source1.swizzle;
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source1TargetX = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            var source1TargetY = source1Target[source1Reg + ((source1Swizzle >> 2) & 3)];
            var source1TargetZ = source1Target[source1Reg + ((source1Swizzle >> 4) & 3)];
            var source1TargetW = source1Target[source1Reg + ((source1Swizzle >> 6) & 3)];
            if (mask & 1)
                target[targetReg] = (source1TargetX < 0) ? -1 : (source1TargetX > 0) ? 1 : 0;
            if (mask & 2)
                target[targetReg + 1] = (source1TargetY < 0) ? -1 : (source1TargetY > 0) ? 1 : 0;
            if (mask & 4)
                target[targetReg + 2] = (source1TargetZ < 0) ? -1 : (source1TargetZ > 0) ? 1 : 0;
            if (mask & 8)
                target[targetReg + 3] = (source1TargetW < 0) ? -1 : (source1TargetW > 0) ? 1 : 0;
        };
        ProgramSoftware.kil = function (vo, desc, dest, source1, source2, context) {
            var source1Reg = 4 * source1.regnum;
            var source1Swizzle = source1.swizzle;
            var source1Target = ProgramSoftware.getSourceTarget(vo, desc, source1, context);
            var source1TargetX = source1Target[source1Reg + ((source1Swizzle >> 0) & 3)];
            if (source1TargetX < 0)
                vo.discard = true;
        };
        ProgramSoftware._defaultSamplerState = new SoftwareSamplerState();
        ProgramSoftware._tokenizer = new AGALTokenizer();
        ProgramSoftware._opCodeFunc = [
            ProgramSoftware.mov,
            ProgramSoftware.add,
            ProgramSoftware.sub,
            ProgramSoftware.mul,
            ProgramSoftware.div,
            ProgramSoftware.rcp,
            ProgramSoftware.min,
            ProgramSoftware.max,
            ProgramSoftware.frc,
            ProgramSoftware.sqt,
            ProgramSoftware.rsq,
            ProgramSoftware.pow,
            ProgramSoftware.log,
            ProgramSoftware.exp,
            ProgramSoftware.nrm,
            ProgramSoftware.sin,
            ProgramSoftware.cos,
            ProgramSoftware.crs,
            ProgramSoftware.dp3,
            ProgramSoftware.dp4,
            ProgramSoftware.abs,
            ProgramSoftware.neg,
            ProgramSoftware.sat,
            ProgramSoftware.m33,
            ProgramSoftware.m44,
            ProgramSoftware.m34,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            null,
            ProgramSoftware.kil,
            ProgramSoftware.tex,
            ProgramSoftware.sge,
            ProgramSoftware.slt,
            ProgramSoftware.sgn,
            ProgramSoftware.seq,
            ProgramSoftware.sne
        ];
        ProgramSoftware._colorValue0 = new Float32Array(4);
        ProgramSoftware._colorValue1 = new Float32Array(4);
        ProgramSoftware._colorInterpolated0 = new Float32Array(4);
        ProgramSoftware._colorInterpolated1 = new Float32Array(4);
        return ProgramSoftware;
    }());

    var BlendModeSoftware = /** @class */ (function () {
        function BlendModeSoftware() {
        }
        BlendModeSoftware.destinationAlpha = function (result, target, dest, source) {
            result[0] = target[0] * dest[3] / 0xFF;
            result[1] = target[1] * dest[3] / 0xFF;
            result[2] = target[2] * dest[3] / 0xFF;
            result[3] = target[3] * dest[3] / 0xFF;
        };
        BlendModeSoftware.destinationColor = function (result, target, dest, source) {
            result[0] = target[0] * dest[0] / 0xFF;
            result[1] = target[1] * dest[1] / 0xFF;
            result[2] = target[2] * dest[2] / 0xFF;
            result[3] = target[3] * dest[3] / 0xFF;
        };
        BlendModeSoftware.one = function (result, target, dest, source) {
            result[0] = target[0];
            result[1] = target[1];
            result[2] = target[2];
            result[3] = target[3];
        };
        BlendModeSoftware.oneMinusDestinationAlpha = function (result, target, dest, source) {
            result[0] = target[0] * (1 - dest[3] / 0xFF);
            result[1] = target[1] * (1 - dest[3] / 0xFF);
            result[2] = target[2] * (1 - dest[3] / 0xFF);
            result[3] = target[3] * (1 - dest[3] / 0xFF);
        };
        BlendModeSoftware.oneMinusDestinationColor = function (result, target, dest, source) {
            result[0] = target[0] * (1 - dest[0] / 0xFF);
            result[1] = target[1] * (1 - dest[1] / 0xFF);
            result[2] = target[2] * (1 - dest[2] / 0xFF);
            result[3] = target[3] * (1 - dest[3] / 0xFF);
        };
        BlendModeSoftware.oneMinusSourceAlpha = function (result, target, dest, source) {
            result[0] = target[0] * (1 - source[3] / 0xFF);
            result[1] = target[1] * (1 - source[3] / 0xFF);
            result[2] = target[2] * (1 - source[3] / 0xFF);
            result[3] = target[3] * (1 - source[3] / 0xFF);
        };
        BlendModeSoftware.oneMinusSourceColor = function (result, target, dest, source) {
            result[0] = target[0] * (1 - source[0] / 0xFF);
            result[1] = target[1] * (1 - source[1] / 0xFF);
            result[2] = target[2] * (1 - source[2] / 0xFF);
            result[3] = target[3] * (1 - source[3] / 0xFF);
        };
        BlendModeSoftware.sourceAlpha = function (result, target, dest, source) {
            result[0] = target[0] * source[3] / 0xFF;
            result[1] = target[1] * source[3] / 0xFF;
            result[2] = target[2] * source[3] / 0xFF;
            result[3] = target[3] * source[3] / 0xFF;
        };
        BlendModeSoftware.sourceColor = function (result, target, dest, source) {
            result[0] = target[0] * source[0] / 0xFF;
            result[1] = target[1] * source[1] / 0xFF;
            result[2] = target[2] * source[2] / 0xFF;
            result[3] = target[3] * source[3] / 0xFF;
        };
        BlendModeSoftware.zero = function (result, target, dest, source) {
        };
        return BlendModeSoftware;
    }());

    var DepthCompareModeSoftware = /** @class */ (function () {
        function DepthCompareModeSoftware() {
        }
        DepthCompareModeSoftware.always = function (fragDepth, currentDepth) {
            return true;
        };
        DepthCompareModeSoftware.equal = function (fragDepth, currentDepth) {
            return fragDepth == currentDepth;
        };
        DepthCompareModeSoftware.greater = function (fragDepth, currentDepth) {
            return fragDepth > currentDepth;
        };
        DepthCompareModeSoftware.greaterEqual = function (fragDepth, currentDepth) {
            return fragDepth >= currentDepth;
        };
        DepthCompareModeSoftware.less = function (fragDepth, currentDepth) {
            return fragDepth < currentDepth;
        };
        DepthCompareModeSoftware.lessEqual = function (fragDepth, currentDepth) {
            return fragDepth <= currentDepth;
        };
        DepthCompareModeSoftware.never = function (fragDepth, currentDepth) {
            return false;
        };
        DepthCompareModeSoftware.notEqual = function (fragDepth, currentDepth) {
            return fragDepth != currentDepth;
        };
        return DepthCompareModeSoftware;
    }());

    var ContextSoftware = /** @class */ (function () {
        function ContextSoftware(canvas) {
            this._backBufferRect = new Rectangle();
            this._cullingMode = ContextGLTriangleFace.BACK;
            this._blendSource = ContextGLBlendFactor.ONE;
            this._blendDestination = ContextGLBlendFactor.ZERO;
            this._colorMaskR = true;
            this._colorMaskG = true;
            this._colorMaskB = true;
            this._colorMaskA = true;
            this._writeDepth = true;
            this._depthCompareMode = ContextGLCompareMode.LESS;
            this._depthCompareModeSoftware = function (fragDepth, currentDepth) { return void []; };
            this._blendModeSoftware = function (result, dest, source) { return void []; };
            this._screenMatrix = new Matrix3D();
            this._frontBufferMatrix = new Matrix();
            this._bboxMin = new Point();
            this._bboxMax = new Point();
            this._clamp = new Point();
            this._samplerStates = [];
            this._textures = [];
            this.textureBuffersColor = [];
            this.textureBuffersZ = [];
            this.textureBuffersZClear = [];
            this._vertexBuffers = [];
            this._vertexBufferOffsets = [];
            this._vertexBufferFormats = [];
            this._rgba = new Uint8ClampedArray(4);
            this._source = new Uint8ClampedArray(4);
            this._dest = new Uint8ClampedArray(4);
            this._destComp = new Uint8ClampedArray(4);
            this._sourceComp = new Uint8ClampedArray(4);
            //public static _drawCallback:Function = null;
            this._antialias = 0;
            this._p0 = new Vector3D();
            this._p1 = new Vector3D();
            this._p2 = new Vector3D();
            this._project = new Vector3D();
            this._barycentric = new Vector3D();
            this._barycentricRight = new Vector3D();
            this._barycentricBottom = new Vector3D();
            this._canvas = canvas;
            this._backBufferColor = new BitmapImage2D(100, 100, false, 0, false);
            this._frontBuffer = new BitmapImage2D(100, 100, false, 0, false);
            this._activeBufferColor = this._backBufferColor;
            var len = 100 * 100;
            var zbufferBytes = new ArrayBuffer(len * 8);
            this._backBufferZ = new Float32Array(zbufferBytes, 0, len);
            this._backBufferZClear = new Float32Array(zbufferBytes, len * 4, len);
            for (var i = 0; i < len; i++)
                this._backBufferZClear[i] = 10000000;
            this._activeBufferZ = this._backBufferZ;
            if (document && document.body) {
                this._frontCanvas = document.createElement("canvas");
                this._frontBufferContext = this._frontCanvas.getContext("2d");
                this._frontBufferImageData = this._frontBufferContext.getImageData(0, 0, 100, 100);
                // TODO: remove software renderToTexture
                this._frontCanvas.style.position = "absolute";
                document.body.appendChild(this._frontCanvas);
            }
            this._depthCompareModeSoftware[ContextGLCompareMode.ALWAYS] = DepthCompareModeSoftware.always;
            this._depthCompareModeSoftware[ContextGLCompareMode.EQUAL] = DepthCompareModeSoftware.equal;
            this._depthCompareModeSoftware[ContextGLCompareMode.GREATER] = DepthCompareModeSoftware.greaterEqual;
            this._depthCompareModeSoftware[ContextGLCompareMode.GREATER_EQUAL] = DepthCompareModeSoftware.greater;
            this._depthCompareModeSoftware[ContextGLCompareMode.LESS] = DepthCompareModeSoftware.less;
            this._depthCompareModeSoftware[ContextGLCompareMode.LESS_EQUAL] = DepthCompareModeSoftware.lessEqual;
            this._depthCompareModeSoftware[ContextGLCompareMode.NEVER] = DepthCompareModeSoftware.never;
            this._depthCompareModeSoftware[ContextGLCompareMode.NOT_EQUAL] = DepthCompareModeSoftware.notEqual;
            this._blendModeSoftware[ContextGLBlendFactor.DESTINATION_ALPHA] = BlendModeSoftware.destinationAlpha;
            this._blendModeSoftware[ContextGLBlendFactor.DESTINATION_COLOR] = BlendModeSoftware.destinationColor;
            this._blendModeSoftware[ContextGLBlendFactor.ONE] = BlendModeSoftware.one;
            this._blendModeSoftware[ContextGLBlendFactor.ONE_MINUS_DESTINATION_ALPHA] = BlendModeSoftware.oneMinusDestinationAlpha;
            this._blendModeSoftware[ContextGLBlendFactor.ONE_MINUS_DESTINATION_COLOR] = BlendModeSoftware.oneMinusDestinationColor;
            this._blendModeSoftware[ContextGLBlendFactor.ONE_MINUS_SOURCE_ALPHA] = BlendModeSoftware.oneMinusSourceAlpha;
            this._blendModeSoftware[ContextGLBlendFactor.ONE_MINUS_SOURCE_COLOR] = BlendModeSoftware.oneMinusSourceColor;
            this._blendModeSoftware[ContextGLBlendFactor.SOURCE_ALPHA] = BlendModeSoftware.sourceAlpha;
            this._blendModeSoftware[ContextGLBlendFactor.SOURCE_COLOR] = BlendModeSoftware.sourceColor;
            this._blendModeSoftware[ContextGLBlendFactor.ZERO] = BlendModeSoftware.zero;
        }
        Object.defineProperty(ContextSoftware.prototype, "glVersion", {
            get: function () {
                return 1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContextSoftware.prototype, "pixelRatio", {
            get: function () {
                return 1;
            },
            enumerable: true,
            configurable: true
        });
        ContextSoftware.prototype.configureBackBuffer = function (width, height, antiAlias, enableDepthAndStencil) {
            this._antialias = antiAlias;
            if (this._antialias % 2 != 0)
                this._antialias = Math.floor(this._antialias - 0.5);
            if (this._antialias == 0)
                this._antialias = 1;
            this._frontBuffer._setSize(width, height);
            this._frontCanvas.width = width;
            this._frontCanvas.height = height;
            this._frontBufferImageData = this._frontBufferContext.getImageData(0, 0, width, height);
            var backBufferWidth = width * this._antialias;
            var backBufferHeight = height * this._antialias;
            //double buffer for fast clearing
            var len = backBufferWidth * backBufferHeight;
            var zbufferBytes = new ArrayBuffer(len * 8);
            this._backBufferZ = new Float32Array(zbufferBytes, 0, len);
            this._backBufferZClear = new Float32Array(zbufferBytes, len * 4, len);
            for (var i = 0; i < len; i++)
                this._backBufferZClear[i] = 10000000;
            if (this._activeBufferColor == this._backBufferColor)
                this._activeBufferZ = this._backBufferZ;
            this._backBufferRect.width = backBufferWidth;
            this._backBufferRect.height = backBufferHeight;
            this._backBufferColor._setSize(backBufferWidth, backBufferHeight);
            this.activateScreenMatrix(this._backBufferRect.width, this._backBufferRect.height, true);
            this._frontBufferMatrix = new Matrix();
            this._frontBufferMatrix.scale(1 / this._antialias, 1 / this._antialias);
        };
        ContextSoftware.prototype.activateScreenMatrix = function (width, height, yflip) {
            var raw = this._screenMatrix._rawData;
            raw[0] = width / 2;
            raw[1] = 0;
            raw[2] = 0;
            raw[3] = 0;
            raw[4] = 0;
            raw[5] = yflip ? -height / 2 : height / 2;
            raw[6] = 0;
            raw[7] = 0;
            raw[8] = 0;
            raw[9] = 0;
            raw[10] = 1;
            raw[11] = 0;
            raw[12] = width / 2;
            raw[13] = height / 2;
            raw[14] = 0;
            raw[15] = 0;
            this._yflip = yflip;
        };
        ContextSoftware.prototype.setRenderToTexture = function (target, enableDepthAndStencil, antiAlias, surfaceSelector, mipmapSelector) {
            // Create texture buffer and screen matrix if needed.
            var textureBufferColor = this.textureBuffersColor[surfaceSelector];
            if (textureBufferColor == null) {
                // TODO: consider transparency prop
                // TODO: consider fill color prop
                // TODO: consider powerOfTwo prop
                textureBufferColor = this.textureBuffersColor[surfaceSelector] = new BitmapImage2D(target.width, target.height, false, 0xFFFFFF, true);
                // TODO: transfer the initial image2D data from the texture to the BitmapImage2D object.
                target.uploadFromArray(textureBufferColor.data);
            }
            else {
                textureBufferColor.fillRect(textureBufferColor.rect, 0xFFFFFF);
            }
            this._activeBufferColor = textureBufferColor;
            this._activeBufferColor.lock();
            var textureBufferZ = this.textureBuffersZ[surfaceSelector];
            var textureBufferZClear = this.textureBuffersZClear[surfaceSelector];
            if (textureBufferZ == null) {
                //double buffer for fast clearing
                var len = target.width * target.height;
                var zbufferBytes = new ArrayBuffer(len * 8);
                textureBufferZ = this.textureBuffersZ[surfaceSelector] = new Float32Array(zbufferBytes, 0, len);
                textureBufferZClear = this.textureBuffersZClear[surfaceSelector] = new Float32Array(zbufferBytes, len * 4, len);
                for (var i = 0; i < len; i++)
                    textureBufferZClear[i] = 10000000;
            }
            textureBufferZ.set(textureBufferZClear); //fast memcpy
            this._activeBufferZ = textureBufferZ;
            this.activateScreenMatrix(target.width, target.height, false);
            this._activeTexture = target;
        };
        ContextSoftware.prototype.setRenderToBackBuffer = function () {
            this._activeBufferColor = this._backBufferColor;
            this._activeBufferZ = this._backBufferZ;
            this.activateScreenMatrix(this._backBufferColor.width, this._backBufferColor.height, true);
        };
        ContextSoftware.prototype.copyToTexture = function (target, rect, destPoint) {
        };
        ContextSoftware.prototype.drawIndices = function (mode, indexBuffer, firstIndex, numIndices) {
            if (!this._program)
                return;
            // These are place holders for vertex transformation operations.
            // Additional placeholders are for potentially interpolated values generated by near clipping
            // used to avoid trying to draw behind the camera
            var position0 = new Float32Array(4);
            var position1 = new Float32Array(4);
            var position2 = new Float32Array(4);
            var position3 = new Float32Array(4); // potentially interpolated
            var position4 = new Float32Array(4); // potentially interpolated
            var varying0 = new Float32Array(this._program.numVarying * 4);
            var varying1 = new Float32Array(this._program.numVarying * 4);
            var varying2 = new Float32Array(this._program.numVarying * 4);
            var varying3 = new Float32Array(this._program.numVarying * 4); // potentially interpolated
            var varying4 = new Float32Array(this._program.numVarying * 4); // potentially interpolated
            var incomingVertices = new Array(5);
            var outgoingVertices = new Array(4);
            incomingVertices[0] = position1;
            incomingVertices[1] = position2;
            incomingVertices[2] = position0; // notice position0 in index 2
            incomingVertices[3] = position3;
            incomingVertices[4] = position4;
            var incomingVaryings = new Array(5);
            var outgoingVaryings = new Array(4);
            incomingVaryings[0] = varying1;
            incomingVaryings[1] = varying2;
            incomingVaryings[2] = varying0;
            incomingVaryings[3] = varying3;
            incomingVaryings[4] = varying4;
            // Sweep triangles according to culling mode and process thru vertex shader.
            if (this._yflip && this._cullingMode == ContextGLTriangleFace.BACK || !this._yflip && this._cullingMode == ContextGLTriangleFace.FRONT) {
                for (var i = firstIndex; i < numIndices; i += 3) {
                    this._program.vertex(this, indexBuffer.data[indexBuffer.startOffset + i], position0, varying0);
                    this._program.vertex(this, indexBuffer.data[indexBuffer.startOffset + i + 1], position1, varying1);
                    this._program.vertex(this, indexBuffer.data[indexBuffer.startOffset + i + 2], position2, varying2);
                    this._triangle(incomingVertices, outgoingVertices, incomingVaryings, outgoingVaryings);
                }
            }
            else if (this._yflip && this._cullingMode == ContextGLTriangleFace.FRONT || !this._yflip && this._cullingMode == ContextGLTriangleFace.BACK) {
                for (var i = firstIndex; i < numIndices; i += 3) {
                    this._program.vertex(this, indexBuffer.data[indexBuffer.startOffset + i + 2], position0, varying0);
                    this._program.vertex(this, indexBuffer.data[indexBuffer.startOffset + i + 1], position1, varying1);
                    this._program.vertex(this, indexBuffer.data[indexBuffer.startOffset + i], position2, varying2);
                    this._triangle(incomingVertices, outgoingVertices, incomingVaryings, outgoingVaryings);
                }
            }
            else if (this._cullingMode == ContextGLTriangleFace.FRONT_AND_BACK || this._cullingMode == ContextGLTriangleFace.NONE) {
                for (var i = firstIndex; i < numIndices; i += 3) {
                    this._program.vertex(this, indexBuffer.data[indexBuffer.startOffset + i + 2], position0, varying0);
                    this._program.vertex(this, indexBuffer.data[indexBuffer.startOffset + i + 1], position1, varying1);
                    this._program.vertex(this, indexBuffer.data[indexBuffer.startOffset + i], position2, varying2);
                    this._triangle(incomingVertices, outgoingVertices, incomingVaryings, outgoingVaryings);
                    this._program.vertex(this, indexBuffer.data[indexBuffer.startOffset + i], position0, varying0);
                    this._program.vertex(this, indexBuffer.data[indexBuffer.startOffset + i + 1], position1, varying1);
                    this._program.vertex(this, indexBuffer.data[indexBuffer.startOffset + i + 2], position2, varying2);
                    this._triangle(incomingVertices, outgoingVertices, incomingVaryings, outgoingVaryings);
                }
            }
            // Transfer buffer data to texture.
            if (this._activeBufferColor != this._backBufferColor) {
                this._activeBufferColor.unlock();
                this._activeTexture.uploadFromArray(this._activeBufferColor.data);
            }
        };
        ContextSoftware.prototype._triangle = function (incomingVertices, outgoingVertices, incomingVaryings, outgoingVaryings) {
            var numOriginalVerticesInside = 0;
            var numInterpolations = 0;
            var numOutgoingVertices = 0;
            // Check if the vertices are behind the near plane and interpolate
            // new vertices whenever one vertex in a side is in front of the camera AND the other is behind it.
            // Start by considering p0 as the previous vertex.
            var previousVertex = incomingVertices[2]; // p0
            var previousVarying = incomingVaryings[2]; // v0
            var previousVertexIsInside = previousVertex[2] > 0; // z > 0
            if (previousVertexIsInside) { // add the original vertex if its inside
                outgoingVertices[0] = previousVertex;
                outgoingVaryings[0] = previousVarying;
                numOutgoingVertices++;
                numOriginalVerticesInside++;
            }
            for (var i = 0; i < 3; i++) {
                var currentVertex = incomingVertices[i];
                var currentVarying = incomingVaryings[i];
                // Need interpolation?
                var currentVertexIsInside = currentVertex[2] > 0; // z > 0
                if (currentVertexIsInside != previousVertexIsInside) { // if one and only one is true
                    // Interpolate vertex pair and create a new vertex.
                    // z factor
                    var dz_current = Math.abs(currentVertex[2]);
                    var dz_previous = Math.abs(previousVertex[2]);
                    var factorZ = dz_previous / (dz_previous + dz_current);
                    this._interpolateVertexPair(factorZ, currentVertex, previousVertex, incomingVertices[3 + numInterpolations]);
                    outgoingVertices[numOutgoingVertices] = incomingVertices[3 + numInterpolations];
                    this._interpolateVertexPair(factorZ, currentVarying, previousVarying, incomingVaryings[3 + numInterpolations]);
                    outgoingVaryings[numOutgoingVertices] = incomingVaryings[3 + numInterpolations];
                    numOutgoingVertices++;
                    numInterpolations++;
                }
                if (currentVertexIsInside && i != 2) { // add the original vertex if its inside
                    outgoingVertices[numOutgoingVertices] = currentVertex;
                    outgoingVaryings[numOutgoingVertices] = currentVarying;
                    numOutgoingVertices++;
                    numOriginalVerticesInside++;
                }
                previousVertex = currentVertex;
                previousVarying = currentVarying;
                previousVertexIsInside = currentVertexIsInside;
            }
            // Project the resulting vertices as triangles.
            if (numOriginalVerticesInside == 3) { // no clipping
                this._projectTriangle(incomingVertices[0], incomingVertices[1], incomingVertices[2], incomingVaryings[0], incomingVaryings[1], incomingVaryings[2]);
            }
            else if (numOriginalVerticesInside == 2) { // quad clip (triangle is converted into a quad)
                this._projectTriangle(outgoingVertices[0], outgoingVertices[1], outgoingVertices[2], outgoingVaryings[0], outgoingVaryings[1], outgoingVaryings[2]);
                this._projectTriangle(outgoingVertices[0], outgoingVertices[2], outgoingVertices[3], outgoingVaryings[0], outgoingVaryings[2], outgoingVaryings[3]);
            }
            else if (numOriginalVerticesInside == 1) { // simple clip (triangle is reduced in size)
                this._projectTriangle(outgoingVertices[0], outgoingVertices[1], outgoingVertices[2], outgoingVaryings[0], outgoingVaryings[1], outgoingVaryings[2]);
            }
            // else if (numOriginalVerticesInside == 0) { // full clipping (do nothing)
            // }
        };
        ContextSoftware.prototype._projectTriangle = function (position0, position1, position2, varying0, varying1, varying2) {
            // Wrap the vertex transformed positions in Vector3D objects.
            this._p0.x = position0[0];
            this._p0.y = position0[1];
            this._p0.z = position0[2];
            this._p0.w = position0[3];
            this._p1.x = position1[0];
            this._p1.y = position1[1];
            this._p1.z = position1[2];
            this._p1.w = position1[3];
            this._p2.x = position2[0];
            this._p2.y = position2[1];
            this._p2.z = position2[2];
            this._p2.w = position2[3];
            // Reject any invalid vertices.
            if (this._p0.w == 0 || this._p1.w == 0 || this._p2.w == 0) {
                return;
            } // w = 0 represent direction vectors and we want positions
            if (isNaN(this._p0.x) || isNaN(this._p0.y) || isNaN(this._p0.z) || isNaN(this._p0.w)) {
                return;
            }
            if (isNaN(this._p1.x) || isNaN(this._p1.y) || isNaN(this._p1.z) || isNaN(this._p1.w)) {
                return;
            }
            if (isNaN(this._p2.x) || isNaN(this._p2.y) || isNaN(this._p2.z) || isNaN(this._p2.w)) {
                return;
            }
            // Clip space.
            this._p0.z = this._p0.z * 2 - this._p0.w;
            this._p1.z = this._p1.z * 2 - this._p1.w;
            this._p2.z = this._p2.z * 2 - this._p2.w;
            // Perspective divide.
            this._p0.project();
            this._p1.project();
            this._p2.project();
            // Transform into screen space.
            this._project.x = this._p0.w;
            this._project.y = this._p1.w;
            this._project.z = this._p2.w;
            this._p0.w = 1;
            this._p1.w = 1;
            this._p2.w = 1;
            this._p0 = this._screenMatrix.transformVector(this._p0, this._p0);
            this._p1 = this._screenMatrix.transformVector(this._p1, this._p1);
            this._p2 = this._screenMatrix.transformVector(this._p2, this._p2);
            // Prepare rasterization bounds.
            this._bboxMin.x = 1000000;
            this._bboxMin.y = 1000000;
            this._bboxMax.x = -1000000;
            this._bboxMax.y = -1000000;
            this._clamp.x = this._activeBufferColor.width - 1;
            this._clamp.y = this._activeBufferColor.height - 1;
            this._bboxMin.x = Math.max(0, Math.min(this._bboxMin.x, this._p0.x));
            this._bboxMin.y = Math.max(0, Math.min(this._bboxMin.y, this._p0.y));
            this._bboxMin.x = Math.max(0, Math.min(this._bboxMin.x, this._p1.x));
            this._bboxMin.y = Math.max(0, Math.min(this._bboxMin.y, this._p1.y));
            this._bboxMin.x = Math.max(0, Math.min(this._bboxMin.x, this._p2.x));
            this._bboxMin.y = Math.max(0, Math.min(this._bboxMin.y, this._p2.y));
            this._bboxMax.x = Math.min(this._clamp.x, Math.max(this._bboxMax.x, this._p0.x));
            this._bboxMax.y = Math.min(this._clamp.y, Math.max(this._bboxMax.y, this._p0.y));
            this._bboxMax.x = Math.min(this._clamp.x, Math.max(this._bboxMax.x, this._p1.x));
            this._bboxMax.y = Math.min(this._clamp.y, Math.max(this._bboxMax.y, this._p1.y));
            this._bboxMax.x = Math.min(this._clamp.x, Math.max(this._bboxMax.x, this._p2.x));
            this._bboxMax.y = Math.min(this._clamp.y, Math.max(this._bboxMax.y, this._p2.y));
            this._bboxMin.x = Math.floor(this._bboxMin.x);
            this._bboxMin.y = Math.floor(this._bboxMin.y);
            this._bboxMax.x = Math.floor(this._bboxMax.x);
            this._bboxMax.y = Math.floor(this._bboxMax.y);
            /*
                NOTE:
                'simplified cross' product calculations below are inlined cross product calculations that ignore the z value and just use the output z value.
             */
            // Skip invalid bounds.
            var w = this._bboxMax.x - this._bboxMin.x;
            var h = this._bboxMax.y - this._bboxMin.y;
            if (w <= 0 || h <= 0) {
                return;
            }
            // Calculate the area division for all barycentric coordinates.
            var area = (this._p1.x - this._p0.x) * (this._p2.y - this._p0.y) - (this._p1.y - this._p0.y) * (this._p2.x - this._p0.x); // simplified cross
            if (area < 0) {
                return;
            } // skip null areas.
            // Pre-calculate barycentric x and y derivatives (steps).
            var w0_dx = -(this._p2.y - this._p1.y) / area;
            var w1_dx = -(this._p0.y - this._p2.y) / area;
            var w2_dx = -(this._p1.y - this._p0.y) / area;
            var w0_dy = (this._p2.x - this._p1.x) / area;
            var w1_dy = (this._p0.x - this._p2.x) / area;
            var w2_dy = (this._p1.x - this._p0.x) / area;
            // Calculate top left barycentric coordinate.
            var w0 = ((this._p2.x - this._p1.x) * (this._bboxMin.y - this._p1.y) - (this._p2.y - this._p1.y) * (this._bboxMin.x - this._p1.x)) / area; // simplified cross
            var w1 = ((this._p0.x - this._p2.x) * (this._bboxMin.y - this._p2.y) - (this._p0.y - this._p2.y) * (this._bboxMin.x - this._p2.x)) / area; // simplified cross
            var w2 = ((this._p1.x - this._p0.x) * (this._bboxMin.y - this._p0.y) - (this._p1.y - this._p0.y) * (this._bboxMin.x - this._p0.x)) / area; // simplified cross
            // Rasterize.
            var cx = 0;
            var cy = 0;
            for (var x = this._bboxMin.x; x <= this._bboxMax.x; x++) {
                for (var y = this._bboxMin.y; y <= this._bboxMax.y; y++) {
                    // Calculate the barycentric weights of the pixel.
                    this._barycentric.x = w0 + w0_dx * cx + w0_dy * cy;
                    this._barycentric.y = w1 + w1_dx * cx + w1_dy * cy;
                    this._barycentric.z = w2 + w2_dx * cx + w2_dy * cy;
                    // Step y.
                    cy += 1;
                    // Skip pixel if its not inside the triangle.
                    if (this._barycentric.x < 0 || this._barycentric.y < 0 || this._barycentric.z < 0)
                        continue;
                    // Calculate derivative (neighbor) weights.
                    if (x != this._bboxMax.x) {
                        this._barycentricRight.x = this._barycentric.x + w0_dx;
                        this._barycentricRight.y = this._barycentric.y + w1_dx;
                        this._barycentricRight.z = this._barycentric.z + w2_dx;
                        this._barycentricRight.x /= this._project.x;
                        this._barycentricRight.y /= this._project.y;
                        this._barycentricRight.z /= this._project.z;
                        this._barycentricRight.scaleBy(1 / (this._barycentricRight.x + this._barycentricRight.y + this._barycentricRight.z));
                    }
                    if (y != this._bboxMax.y) {
                        this._barycentricBottom.x = this._barycentric.x + w0_dy;
                        this._barycentricBottom.y = this._barycentric.y + w1_dy;
                        this._barycentricBottom.z = this._barycentric.z + w2_dy;
                        this._barycentricBottom.x /= this._project.x;
                        this._barycentricBottom.y /= this._project.y;
                        this._barycentricBottom.z /= this._project.z;
                        this._barycentricBottom.scaleBy(1 / (this._barycentricBottom.x + this._barycentricBottom.y + this._barycentricBottom.z));
                    }
                    // Interpolate frag depth.
                    var index = (x % this._activeBufferColor.width) + y * this._activeBufferColor.width;
                    var fragDepth = (this._barycentric.x * this._p0.z + this._barycentric.y * this._p1.z + this._barycentric.z * this._p2.z) / (this._barycentric.x + this._barycentric.y + this._barycentric.z);
                    this._barycentric.x /= this._project.x;
                    this._barycentric.y /= this._project.y;
                    this._barycentric.z /= this._project.z;
                    this._barycentric.scaleBy(1 / (this._barycentric.x + this._barycentric.y + this._barycentric.z));
                    // Depth test.
                    if (!this._depthCompareModeSoftware[this._depthCompareMode](fragDepth, this._activeBufferZ[index]))
                        continue;
                    // Process fragment shader.
                    var fragmentVO = this._program.fragment(this, this._barycentric, this._barycentricRight, this._barycentricBottom, varying0, varying1, varying2, fragDepth);
                    if (fragmentVO.discard)
                        continue;
                    // Write z buffer.
                    if (this._writeDepth)
                        this._activeBufferZ[index] = fragDepth; // TODO: fragmentVO.outputDepth?
                    // Write to source and transform color space.
                    this._source[0] = fragmentVO.outputColor[0] * 0xFF;
                    this._source[1] = fragmentVO.outputColor[1] * 0xFF;
                    this._source[2] = fragmentVO.outputColor[2] * 0xFF;
                    this._source[3] = fragmentVO.outputColor[3] * 0xFF;
                    // Read dest.
                    this._activeBufferColor.getPixelData(x, y, this._dest);
                    // Write to color buffer.
                    this._putPixel(x, y);
                }
                // Step x.
                cy = 0;
                cx += 1;
            }
        };
        ContextSoftware.prototype._putPixel = function (x, y) {
            this._blendModeSoftware[this._blendDestination](this._destComp, this._dest, this._dest, this._source);
            this._blendModeSoftware[this._blendSource](this._sourceComp, this._source, this._dest, this._source);
            this._rgba[0] = this._sourceComp[0] + this._destComp[0];
            this._rgba[1] = this._sourceComp[1] + this._destComp[1];
            this._rgba[2] = this._sourceComp[2] + this._destComp[2];
            this._rgba[3] = this._sourceComp[3] + this._destComp[3];
            this._activeBufferColor.setPixelData(x, y, this._rgba);
        };
        ContextSoftware.prototype.createCubeTexture = function (size, format, optimizeForRenderToTexture, streamingLevels) {
            return new CubeTextureSoftware(size);
        };
        ContextSoftware.prototype.createIndexBuffer = function (numIndices) {
            return new IndexBufferSoftware(numIndices);
        };
        ContextSoftware.prototype.createProgram = function () {
            return new ProgramSoftware();
        };
        ContextSoftware.prototype.createTexture = function (width, height, format, optimizeForRenderToTexture, streamingLevels) {
            return new TextureSoftware(width, height);
        };
        ContextSoftware.prototype.createVertexBuffer = function (numVertices, dataPerVertex) {
            return new VertexBufferSoftware(numVertices, dataPerVertex);
        };
        ContextSoftware.prototype.dispose = function () {
        };
        ContextSoftware.prototype.setBlendFactors = function (sourceFactor, destinationFactor) {
            this._blendSource = sourceFactor;
            this._blendDestination = destinationFactor;
        };
        ContextSoftware.prototype.setColorMask = function (red, green, blue, alpha) {
            this._colorMaskR = red;
            this._colorMaskG = green;
            this._colorMaskB = blue;
            this._colorMaskA = alpha;
        };
        ContextSoftware.prototype.setStencilActions = function (triangleFace, compareMode, actionOnBothPass, actionOnDepthFail, actionOnDepthPassStencilFail, coordinateSystem) {
            if (triangleFace === void 0) { triangleFace = ContextGLTriangleFace.FRONT_AND_BACK; }
            if (compareMode === void 0) { compareMode = ContextGLCompareMode.ALWAYS; }
            if (actionOnBothPass === void 0) { actionOnBothPass = ContextGLStencilAction.KEEP; }
            if (actionOnDepthFail === void 0) { actionOnDepthFail = ContextGLStencilAction.KEEP; }
            if (actionOnDepthPassStencilFail === void 0) { actionOnDepthPassStencilFail = ContextGLStencilAction.KEEP; }
            if (coordinateSystem === void 0) { coordinateSystem = CoordinateSystem.LEFT_HANDED; }
            //TODO:
        };
        ContextSoftware.prototype.setStencilReferenceValue = function (referenceValue, readMask, writeMask) {
            //TODO:
        };
        ContextSoftware.prototype.setCulling = function (triangleFaceToCull, coordinateSystem) {
            //TODO: CoordinateSystem.RIGHT_HAND
            this._cullingMode = triangleFaceToCull;
        };
        ContextSoftware.prototype.setDepthTest = function (depthMask, passCompareMode) {
            this._writeDepth = depthMask;
            this._depthCompareMode = passCompareMode;
        };
        ContextSoftware.prototype.setProgram = function (program) {
            this._program = program;
        };
        ContextSoftware.prototype.setProgramConstantsFromArray = function (programType, data) {
            var target;
            if (programType == ContextGLProgramType.VERTEX)
                target = this._vertexConstants = new Float32Array(data.length);
            else if (programType == ContextGLProgramType.FRAGMENT)
                target = this._fragmentConstants = new Float32Array(data.length);
            target.set(data);
        };
        ContextSoftware.prototype.setTextureAt = function (sampler, texture) {
            this._textures[sampler] = texture;
        };
        ContextSoftware.prototype.setVertexBufferAt = function (index, buffer, bufferOffset, format) {
            this._vertexBuffers[index] = buffer;
            this._vertexBufferOffsets[index] = bufferOffset;
            this._vertexBufferFormats[index] = format;
        };
        ContextSoftware.prototype.present = function () {
            this._backBufferColor.unlock();
            this._frontBuffer.fillRect(this._frontBuffer.rect, 0);
            this._frontBuffer.drawBitmap(this._backBufferColor.data, 0, 0, this._backBufferColor.width, this._backBufferColor.height, this._frontBufferMatrix);
            if (document && document.body) {
                this._frontBufferImageData.data.set(this._frontBuffer.data);
                this._frontBufferContext.putImageData(this._frontBufferImageData, 0, 0);
            }
        };
        ContextSoftware.prototype.drawToBitmapImage2D = function (destination) {
            destination.setPixels(this._activeBufferColor.rect, this._activeBufferColor.data);
        };
        ContextSoftware.prototype._interpolateVertexPair = function (factor, v0, v1, result) {
            for (var i = 0; i < v0.length; i++) {
                var delta = v0[i] - v1[i];
                result[i] = v1[i] + delta * factor;
            }
        };
        ContextSoftware.prototype.clamp = function (value, min, max) {
            if (min === void 0) { min = 0; }
            if (max === void 0) { max = 1; }
            return Math.max(min, Math.min(value, max));
        };
        ContextSoftware.prototype.interpolate = function (min, max, gradient) {
            return min + (max - min) * this.clamp(gradient);
        };
        ContextSoftware.prototype.drawVertices = function (mode, firstVertex, numVertices) {
            //TODO:
        };
        ContextSoftware.prototype.setScissorRectangle = function (rectangle) {
            //TODO:
        };
        ContextSoftware.prototype.setSamplerStateAt = function (sampler, wrap, filter, mipfilter) {
            var state = this._samplerStates[sampler];
            if (!state)
                state = this._samplerStates[sampler] = new SoftwareSamplerState();
            state.wrap = wrap;
            state.filter = filter;
            state.mipfilter = mipfilter;
        };
        ContextSoftware.prototype.enableStencil = function () {
        };
        ContextSoftware.prototype.disableStencil = function () {
        };
        Object.defineProperty(ContextSoftware.prototype, "frontBuffer", {
            get: function () {
                return this._frontBuffer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContextSoftware.prototype, "container", {
            get: function () {
                return this._canvas;
            },
            enumerable: true,
            configurable: true
        });
        ContextSoftware.prototype.clear = function (red, green, blue, alpha, depth, stencil, mask) {
            if (red === void 0) { red = 0; }
            if (green === void 0) { green = 0; }
            if (blue === void 0) { blue = 0; }
            if (alpha === void 0) { alpha = 1; }
            if (depth === void 0) { depth = 1; }
            if (stencil === void 0) { stencil = 0; }
            if (mask === void 0) { mask = ContextGLClearMask.ALL; }
            this._backBufferColor.lock();
            if (mask & ContextGLClearMask.COLOR)
                this._backBufferColor.fillRect(this._backBufferRect, ColorUtils.ARGBtoFloat32(alpha * 0xFF, red * 0xFF, green * 0xFF, blue * 0xFF));
            //TODO: mask & ContextGLClearMask.STENCIL
            if (mask & ContextGLClearMask.DEPTH)
                this._backBufferZ.set(this._backBufferZClear); //fast memcpy
        };
        ContextSoftware.MAX_SAMPLERS = 8;
        return ContextSoftware;
    }());

    var TextureBaseWebGL = /** @class */ (function () {
        function TextureBaseWebGL(gl) {
            this.textureType = "";
            this._gl = gl;
        }
        TextureBaseWebGL.prototype.dispose = function () {
            this._gl.deleteTexture(this._glTexture);
        };
        Object.defineProperty(TextureBaseWebGL.prototype, "glTexture", {
            get: function () {
                return this._glTexture;
            },
            enumerable: true,
            configurable: true
        });
        TextureBaseWebGL.prototype.generateMipmaps = function () {
            throw new AbstractMethodError();
        };
        return TextureBaseWebGL;
    }());

    var CubeTextureWebGL = /** @class */ (function (_super) {
        __extends$2(CubeTextureWebGL, _super);
        function CubeTextureWebGL(gl, size) {
            var _this = _super.call(this, gl) || this;
            _this._textureSelectorDictionary = new Array(6);
            _this.textureType = "textureCube";
            _this._size = size;
            _this._glTexture = _this._gl.createTexture();
            _this._textureSelectorDictionary[0] = gl.TEXTURE_CUBE_MAP_POSITIVE_X;
            _this._textureSelectorDictionary[1] = gl.TEXTURE_CUBE_MAP_NEGATIVE_X;
            _this._textureSelectorDictionary[2] = gl.TEXTURE_CUBE_MAP_POSITIVE_Y;
            _this._textureSelectorDictionary[3] = gl.TEXTURE_CUBE_MAP_NEGATIVE_Y;
            _this._textureSelectorDictionary[4] = gl.TEXTURE_CUBE_MAP_POSITIVE_Z;
            _this._textureSelectorDictionary[5] = gl.TEXTURE_CUBE_MAP_NEGATIVE_Z;
            return _this;
        }
        CubeTextureWebGL.prototype.uploadFromArray = function (array, side, miplevel) {
            if (miplevel === void 0) { miplevel = 0; }
            if (array.length != this._size * this._size * 4)
                throw new Error("Array is not the correct length for texture dimensions");
            if (array instanceof Array)
                array = new Uint8Array(array);
            this._gl.bindTexture(this._gl.TEXTURE_CUBE_MAP, this._glTexture);
            this._gl.texImage2D(this._textureSelectorDictionary[side], miplevel, this._gl.RGBA, this._size, this._size, 0, this._gl.RGBA, this._gl.UNSIGNED_BYTE, array);
            this._gl.bindTexture(this._gl.TEXTURE_CUBE_MAP, null);
        };
        CubeTextureWebGL.prototype.uploadCompressedTextureFromArray = function (array, offset /*uint*/, async) {
            if (async === void 0) { async = false; }
        };
        Object.defineProperty(CubeTextureWebGL.prototype, "size", {
            get: function () {
                return this._size;
            },
            enumerable: true,
            configurable: true
        });
        CubeTextureWebGL.prototype.generateMipmaps = function () {
            this._gl.bindTexture(this._gl.TEXTURE_CUBE_MAP, this._glTexture);
            this._gl.generateMipmap(this._gl.TEXTURE_CUBE_MAP);
            //this._gl.bindTexture( this._gl.TEXTURE_CUBE_MAP, null );
        };
        return CubeTextureWebGL;
    }(TextureBaseWebGL));

    var IndexBufferWebGL = /** @class */ (function () {
        function IndexBufferWebGL(gl, numIndices) {
            this._gl = gl;
            this._buffer = this._gl.createBuffer();
            this._numIndices = numIndices;
        }
        IndexBufferWebGL.prototype.uploadFromArray = function (array, startOffset, count) {
            this._gl.bindBuffer(this._gl.ELEMENT_ARRAY_BUFFER, this._buffer);
            if (startOffset)
                this._gl.bufferSubData(this._gl.ELEMENT_ARRAY_BUFFER, startOffset * 2, array);
            else
                this._gl.bufferData(this._gl.ELEMENT_ARRAY_BUFFER, array, this._gl.STATIC_DRAW);
        };
        IndexBufferWebGL.prototype.uploadFromByteArray = function (data, startOffset, count) {
            this._gl.bindBuffer(this._gl.ELEMENT_ARRAY_BUFFER, this._buffer);
            if (startOffset)
                this._gl.bufferSubData(this._gl.ELEMENT_ARRAY_BUFFER, startOffset * 2, data);
            else
                this._gl.bufferData(this._gl.ELEMENT_ARRAY_BUFFER, data, this._gl.STATIC_DRAW);
        };
        IndexBufferWebGL.prototype.dispose = function () {
            this._gl.deleteBuffer(this._buffer);
        };
        Object.defineProperty(IndexBufferWebGL.prototype, "numIndices", {
            get: function () {
                return this._numIndices;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(IndexBufferWebGL.prototype, "glBuffer", {
            get: function () {
                return this._buffer;
            },
            enumerable: true,
            configurable: true
        });
        return IndexBufferWebGL;
    }());

    var ProgramWebGL = /** @class */ (function () {
        function ProgramWebGL(gl) {
            this._uniforms = [[], [], []];
            this._attribs = [];
            this._gl = gl;
            this._program = this._gl.createProgram();
        }
        ProgramWebGL.prototype.upload = function (vertexProgram, fragmentProgram) {
            //detect whether highp can be used
            var vertexPrecision = (this._gl.getShaderPrecisionFormat(this._gl.VERTEX_SHADER, this._gl.HIGH_FLOAT).precision != 0) ? "highp" : "mediump";
            var fragmentPrecision = (this._gl.getShaderPrecisionFormat(this._gl.FRAGMENT_SHADER, this._gl.HIGH_FLOAT).precision != 0) ? "highp" : "mediump";
            var vertexString = ProgramWebGL._aglslParser.parse(ProgramWebGL._tokenizer.decribeAGALByteArray(vertexProgram), vertexPrecision);
            var fragmentString = ProgramWebGL._aglslParser.parse(ProgramWebGL._tokenizer.decribeAGALByteArray(fragmentProgram), fragmentPrecision);
            this._vertexShader = this._gl.createShader(this._gl.VERTEX_SHADER);
            this._fragmentShader = this._gl.createShader(this._gl.FRAGMENT_SHADER);
            this._gl.shaderSource(this._vertexShader, vertexString);
            this._gl.compileShader(this._vertexShader);
            if (!this._gl.getShaderParameter(this._vertexShader, this._gl.COMPILE_STATUS))
                throw new Error(this._gl.getShaderInfoLog(this._vertexShader));
            this._gl.shaderSource(this._fragmentShader, fragmentString);
            this._gl.compileShader(this._fragmentShader);
            if (!this._gl.getShaderParameter(this._fragmentShader, this._gl.COMPILE_STATUS))
                throw new Error(this._gl.getShaderInfoLog(this._fragmentShader));
            this._gl.attachShader(this._program, this._vertexShader);
            this._gl.attachShader(this._program, this._fragmentShader);
            this._gl.linkProgram(this._program);
            if (!this._gl.getProgramParameter(this._program, this._gl.LINK_STATUS))
                throw new Error(this._gl.getProgramInfoLog(this._program));
            this._uniforms[0].length = 0;
            this._uniforms[1].length = 0;
            this._uniforms[2].length = 0;
            this._attribs.length = 0;
        };
        ProgramWebGL.prototype.getUniformLocation = function (programType, index) {
            if (index === void 0) { index = -1; }
            if (this._uniforms[programType][index + 1] != null)
                return this._uniforms[programType][index + 1];
            var name = (index == -1) ? ProgramWebGL._uniformLocationNameDictionary[programType] : ProgramWebGL._uniformLocationNameDictionary[programType] + index;
            return (this._uniforms[programType][index + 1] = this._gl.getUniformLocation(this._program, name));
        };
        //
        // public getUniformLocation(programType:number, index:number):WebGLUniformLocation
        // {
        // 	if (this._uniforms[programType][index] != null)
        // 		return this._uniforms[programType][index];
        //
        // 	return (this._uniforms[programType][index] = this._gl.getUniformLocation(this._program, ProgramWebGL._uniformLocationNameDictionary[programType] + index));
        // }
        ProgramWebGL.prototype.getAttribLocation = function (index) {
            if (this._attribs[index] != null)
                return this._attribs[index];
            return (this._attribs[index] = this._gl.getAttribLocation(this._program, "va" + index));
        };
        ProgramWebGL.prototype.dispose = function () {
            this._gl.deleteProgram(this._program);
        };
        ProgramWebGL.prototype.focusProgram = function () {
            this._gl.useProgram(this._program);
        };
        Object.defineProperty(ProgramWebGL.prototype, "glProgram", {
            get: function () {
                return this._program;
            },
            enumerable: true,
            configurable: true
        });
        ProgramWebGL._tokenizer = new AGALTokenizer();
        ProgramWebGL._aglslParser = new AGLSLParser();
        ProgramWebGL._uniformLocationNameDictionary = ["fc", "fs", "vc"];
        return ProgramWebGL;
    }());

    var TextureWebGL = /** @class */ (function (_super) {
        __extends$2(TextureWebGL, _super);
        function TextureWebGL(gl, width, height) {
            var _this = _super.call(this, gl) || this;
            _this.textureType = "texture2d";
            _this._frameBuffer = [];
            _this._frameBufferDraw = [];
            _this._renderBuffer = [];
            _this._renderBufferDepth = [];
            _this._width = width;
            _this._height = height;
            _this._glTexture = _this._gl.createTexture();
            return _this;
        }
        Object.defineProperty(TextureWebGL.prototype, "width", {
            get: function () {
                return this._width;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextureWebGL.prototype, "height", {
            get: function () {
                return this._height;
            },
            enumerable: true,
            configurable: true
        });
        TextureWebGL.prototype.setFrameBuffer = function (enableDepthAndStencil, antiAlias, surfaceSelector, mipmapSelector) {
            if (enableDepthAndStencil === void 0) { enableDepthAndStencil = false; }
            if (antiAlias === void 0) { antiAlias = 0; }
            if (surfaceSelector === void 0) { surfaceSelector = 0; }
            if (mipmapSelector === void 0) { mipmapSelector = 0; }
            //only top level mipmap is allowed for WebGL1
            if (this._gl instanceof WebGLRenderingContext)
                mipmapSelector = 0;
            var width = this._width >>> mipmapSelector;
            var height = this._height >>> mipmapSelector;
            this._mipmapSelector = mipmapSelector;
            if (!this._frameBuffer[mipmapSelector]) {
                //create framebuffer
                var frameBuffer = this._frameBuffer[mipmapSelector] = this._gl.createFramebuffer();
                this._gl.bindFramebuffer(this._gl.FRAMEBUFFER, frameBuffer);
                //create renderbufferdepth
                var renderBufferDepth = this._renderBufferDepth[mipmapSelector] = this._gl.createRenderbuffer();
                this._gl.bindRenderbuffer(this._gl.RENDERBUFFER, renderBufferDepth);
                //no Multisample buffers with WebGL1
                if (this._gl instanceof WebGLRenderingContext) {
                    this._gl.bindTexture(this._gl.TEXTURE_2D, this._glTexture);
                    this._gl.texImage2D(this._gl.TEXTURE_2D, 0, this._gl.RGBA, width, height, 0, this._gl.RGBA, this._gl.UNSIGNED_BYTE, null);
                    this._gl.bindRenderbuffer(this._gl.RENDERBUFFER, renderBufferDepth);
                    this._gl.renderbufferStorage(this._gl.RENDERBUFFER, this._gl.DEPTH_STENCIL, this._width, this._height);
                    this._gl.framebufferTexture2D(this._gl.FRAMEBUFFER, this._gl.COLOR_ATTACHMENT0, this._gl.TEXTURE_2D, this._glTexture, 0);
                    this._gl.framebufferRenderbuffer(this._gl.FRAMEBUFFER, this._gl.DEPTH_STENCIL_ATTACHMENT, this._gl.RENDERBUFFER, renderBufferDepth);
                    this._gl.bindTexture(this._gl.TEXTURE_2D, null);
                }
                else {
                    this._gl.renderbufferStorageMultisample(this._gl.RENDERBUFFER, antiAlias, this._gl.DEPTH24_STENCIL8, width, height);
                    this._gl.framebufferRenderbuffer(this._gl.FRAMEBUFFER, this._gl.DEPTH_STENCIL_ATTACHMENT, this._gl.RENDERBUFFER, renderBufferDepth);
                    //get renderbuffer
                    var renderBuffer = this._renderBuffer[mipmapSelector] = this._gl.createRenderbuffer();
                    this._gl.bindRenderbuffer(this._gl.RENDERBUFFER, renderBuffer);
                    this._gl.renderbufferStorageMultisample(this._gl.RENDERBUFFER, antiAlias, this._gl.RGBA8, width, height);
                    this._gl.framebufferRenderbuffer(this._gl.FRAMEBUFFER, this._gl.COLOR_ATTACHMENT0, this._gl.RENDERBUFFER, renderBuffer);
                }
                this._gl.bindRenderbuffer(this._gl.RENDERBUFFER, null);
            }
            else {
                this._gl.bindFramebuffer(this._gl.FRAMEBUFFER, this._frameBuffer[mipmapSelector]);
            }
            if (enableDepthAndStencil) {
                this._gl.enable(this._gl.STENCIL_TEST);
                this._gl.enable(this._gl.DEPTH_TEST);
            }
            else {
                this._gl.disable(this._gl.STENCIL_TEST);
                this._gl.disable(this._gl.DEPTH_TEST);
            }
            this._gl.viewport(0, 0, width, height);
        };
        TextureWebGL.prototype.presentFrameBuffer = function () {
            //no Multisample buffers with WebGL1
            if (this._gl instanceof WebGLRenderingContext)
                return;
            var width = this._width >>> this._mipmapSelector;
            var height = this._height >>> this._mipmapSelector;
            //init framebuffer
            if (!this._frameBufferDraw[this._mipmapSelector])
                this._frameBufferDraw[this._mipmapSelector] = this._gl.createFramebuffer();
            this._gl.bindFramebuffer(this._gl.FRAMEBUFFER, this._frameBufferDraw[this._mipmapSelector]);
            //init texture
            this._gl.bindTexture(this._gl.TEXTURE_2D, this._glTexture);
            if (!this._texStorageFlag) {
                //texStorage2D creates an immutable texture for all levels
                this._gl.texStorage2D(this._gl.TEXTURE_2D, Math.log(Math.min(this._width, this._height)) / Math.LN2 + 1, this._gl.RGBA8, width, height);
                this._texStorageFlag = true;
            }
            //this._gl.texImage2D(this._gl.TEXTURE_2D, mipmapSelector, this._gl.RGBA, width, height, 0, this._gl.RGBA, this._gl.UNSIGNED_BYTE, null);
            this._gl.framebufferTexture2D(this._gl.FRAMEBUFFER, this._gl.COLOR_ATTACHMENT0, this._gl.TEXTURE_2D, this._glTexture, this._mipmapSelector);
            this._gl.bindTexture(this._gl.TEXTURE_2D, null);
            //write frameBuffer to frameBufferDraw
            this._gl.bindFramebuffer(this._gl.READ_FRAMEBUFFER, this._frameBuffer[this._mipmapSelector]);
            this._gl.bindFramebuffer(this._gl.DRAW_FRAMEBUFFER, this._frameBufferDraw[this._mipmapSelector]);
            this._gl.clearBufferfv(this._gl.COLOR, 0, [0.0, 0.0, 0.0, 0.0]);
            this._gl.blitFramebuffer(0, 0, width, height, 0, 0, width, height, this._gl.COLOR_BUFFER_BIT, this._gl.NEAREST);
        };
        TextureWebGL.prototype.uploadFromArray = function (array, miplevel) {
            if (miplevel === void 0) { miplevel = 0; }
            var width = this._width;
            var height = this._height;
            for (var i = 0; i < miplevel; i++) {
                width = width * 0.5;
                height = height * 0.5;
            }
            if (array.length != Math.floor(width) * Math.floor(height) * 4)
                throw new Error("Array is not the correct length for texture dimensions");
            if (array instanceof Array)
                array = new Uint8Array(array);
            this._gl.bindTexture(this._gl.TEXTURE_2D, this._glTexture);
            this._gl.texImage2D(this._gl.TEXTURE_2D, miplevel, this._gl.RGBA, width, height, 0, this._gl.RGBA, this._gl.UNSIGNED_BYTE, array);
            this._gl.bindTexture(this._gl.TEXTURE_2D, null);
        };
        TextureWebGL.prototype.uploadFromURL = function (urlRequest, miplevel) {
            if (miplevel === void 0) { miplevel = 0; }
            //dummy code for testing
            this._gl.bindTexture(this._gl.TEXTURE_2D, this._glTexture);
            this._gl.texImage2D(this._gl.TEXTURE_2D, 0, this._gl.RGBA, this._width, this._height, 0, this._gl.RGBA, this._gl.UNSIGNED_BYTE, null);
            this._gl.bindTexture(this._gl.TEXTURE_2D, null);
        };
        TextureWebGL.prototype.uploadCompressedTextureFromArray = function (array, offset, async) {
            if (async === void 0) { async = false; }
            var ext = this._gl.getExtension("WEBKIT_WEBGL_compressed_texture_s3tc");
            //this._gl.compressedTexImage2D(this._gl.TEXTURE_2D, 0, this)
        };
        TextureWebGL.prototype.generateMipmaps = function () {
            this._gl.bindTexture(this._gl.TEXTURE_2D, this._glTexture);
            this._gl.generateMipmap(this._gl.TEXTURE_2D);
            //this._gl.bindTexture( this._gl.TEXTURE_2D, null );
        };
        return TextureWebGL;
    }(TextureBaseWebGL));

    var VertexBufferWebGL = /** @class */ (function () {
        function VertexBufferWebGL(gl, numVertices, dataPerVertex) {
            this._gl = gl;
            this._buffer = this._gl.createBuffer();
            this._numVertices = numVertices;
            this._dataPerVertex = dataPerVertex;
        }
        VertexBufferWebGL.prototype.uploadFromArray = function (array, startVertex, numVertices) {
            this._gl.bindBuffer(this._gl.ARRAY_BUFFER, this._buffer);
            if (startVertex)
                this._gl.bufferSubData(this._gl.ARRAY_BUFFER, startVertex * this._dataPerVertex, array);
            else
                this._gl.bufferData(this._gl.ARRAY_BUFFER, array, this._gl.STATIC_DRAW);
        };
        VertexBufferWebGL.prototype.uploadFromByteArray = function (data, startVertex, numVertices) {
            this._gl.bindBuffer(this._gl.ARRAY_BUFFER, this._buffer);
            if (startVertex)
                this._gl.bufferSubData(this._gl.ARRAY_BUFFER, startVertex * this._dataPerVertex, data);
            else
                this._gl.bufferData(this._gl.ARRAY_BUFFER, data, this._gl.STATIC_DRAW);
        };
        Object.defineProperty(VertexBufferWebGL.prototype, "numVertices", {
            get: function () {
                return this._numVertices;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(VertexBufferWebGL.prototype, "dataPerVertex", {
            get: function () {
                return this._dataPerVertex;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(VertexBufferWebGL.prototype, "glBuffer", {
            get: function () {
                return this._buffer;
            },
            enumerable: true,
            configurable: true
        });
        VertexBufferWebGL.prototype.dispose = function () {
            this._gl.deleteBuffer(this._buffer);
        };
        return VertexBufferWebGL;
    }());

    var ContextWebGL = /** @class */ (function () {
        function ContextWebGL(canvas, alpha) {
            if (alpha === void 0) { alpha = false; }
            this._blendFactorDictionary = new Object();
            this._drawModeDictionary = new Object();
            this._compareModeDictionary = new Object();
            this._stencilActionDictionary = new Object();
            this._textureIndexDictionary = new Array(8);
            this._textureTypeDictionary = new Object();
            this._wrapDictionary = new Object();
            this._filterDictionary = new Object();
            this._mipmapFilterDictionary = new Object();
            this._vertexBufferPropertiesDictionary = [];
            this._drawing = true;
            this._samplerStates = new Array(8);
            this._stencilReferenceValue = 0;
            this._stencilReadMask = 0xff;
            this._separateStencil = false;
            this._container = canvas;
            this.initWebGL(alpha);
        }
        Object.defineProperty(ContextWebGL.prototype, "glVersion", {
            get: function () {
                return this._glVersion;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContextWebGL.prototype, "pixelRatio", {
            get: function () {
                return this._pixelRatio;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContextWebGL.prototype, "container", {
            get: function () {
                return this._container;
            },
            set: function (value) {
                this._container = value;
                this.initWebGL();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContextWebGL.prototype, "standardDerivatives", {
            get: function () {
                return this._standardDerivatives;
            },
            enumerable: true,
            configurable: true
        });
        ContextWebGL.prototype.initWebGL = function (alpha) {
            if (alpha === void 0) { alpha = false; }
            var props = {
                alpha: alpha,
                //antialias: (/\bCrOS\b/.test(navigator.userAgent))? false : true,
                stencil: true
            };
            try {
                this._gl = this._container.getContext("webgl2", props);
                if (!this._gl) {
                    this._gl = (this._container.getContext("webgl", props) || this._container.getContext("experimental-webgl", props));
                    this._glVersion = 1;
                }
                else {
                    this._glVersion = 2;
                }
            }
            catch (e) {
                //this.dispatchEvent( new away.events.AwayEvent( away.events.AwayEvent.INITIALIZE_FAILED, e ) );
            }
            if (this._gl) {
                //this.dispatchEvent( new away.events.AwayEvent( away.events.AwayEvent.INITIALIZE_SUCCESS ) );
                if (this._gl.getExtension("OES_standard_derivatives")) {
                    this._standardDerivatives = true;
                }
                else {
                    this._standardDerivatives = false;
                }
                //setup shortcut dictionaries
                this._blendFactorDictionary[ContextGLBlendFactor.ONE] = this._gl.ONE;
                this._blendFactorDictionary[ContextGLBlendFactor.DESTINATION_ALPHA] = this._gl.DST_ALPHA;
                this._blendFactorDictionary[ContextGLBlendFactor.DESTINATION_COLOR] = this._gl.DST_COLOR;
                this._blendFactorDictionary[ContextGLBlendFactor.ONE] = this._gl.ONE;
                this._blendFactorDictionary[ContextGLBlendFactor.ONE_MINUS_DESTINATION_ALPHA] = this._gl.ONE_MINUS_DST_ALPHA;
                this._blendFactorDictionary[ContextGLBlendFactor.ONE_MINUS_DESTINATION_COLOR] = this._gl.ONE_MINUS_DST_COLOR;
                this._blendFactorDictionary[ContextGLBlendFactor.ONE_MINUS_SOURCE_ALPHA] = this._gl.ONE_MINUS_SRC_ALPHA;
                this._blendFactorDictionary[ContextGLBlendFactor.ONE_MINUS_SOURCE_COLOR] = this._gl.ONE_MINUS_SRC_COLOR;
                this._blendFactorDictionary[ContextGLBlendFactor.SOURCE_ALPHA] = this._gl.SRC_ALPHA;
                this._blendFactorDictionary[ContextGLBlendFactor.SOURCE_COLOR] = this._gl.SRC_COLOR;
                this._blendFactorDictionary[ContextGLBlendFactor.ZERO] = this._gl.ZERO;
                this._drawModeDictionary[ContextGLDrawMode.LINES] = this._gl.LINES;
                this._drawModeDictionary[ContextGLDrawMode.TRIANGLES] = this._gl.TRIANGLES;
                this._compareModeDictionary[ContextGLCompareMode.ALWAYS] = this._gl.ALWAYS;
                this._compareModeDictionary[ContextGLCompareMode.EQUAL] = this._gl.EQUAL;
                this._compareModeDictionary[ContextGLCompareMode.GREATER] = this._gl.GREATER;
                this._compareModeDictionary[ContextGLCompareMode.GREATER_EQUAL] = this._gl.GEQUAL;
                this._compareModeDictionary[ContextGLCompareMode.LESS] = this._gl.LESS;
                this._compareModeDictionary[ContextGLCompareMode.LESS_EQUAL] = this._gl.LEQUAL;
                this._compareModeDictionary[ContextGLCompareMode.NEVER] = this._gl.NEVER;
                this._compareModeDictionary[ContextGLCompareMode.NOT_EQUAL] = this._gl.NOTEQUAL;
                this._stencilActionDictionary[ContextGLStencilAction.DECREMENT_SATURATE] = this._gl.DECR;
                this._stencilActionDictionary[ContextGLStencilAction.DECREMENT_WRAP] = this._gl.DECR_WRAP;
                this._stencilActionDictionary[ContextGLStencilAction.INCREMENT_SATURATE] = this._gl.INCR;
                this._stencilActionDictionary[ContextGLStencilAction.INCREMENT_WRAP] = this._gl.INCR_WRAP;
                this._stencilActionDictionary[ContextGLStencilAction.INVERT] = this._gl.INVERT;
                this._stencilActionDictionary[ContextGLStencilAction.KEEP] = this._gl.KEEP;
                this._stencilActionDictionary[ContextGLStencilAction.SET] = this._gl.REPLACE;
                this._stencilActionDictionary[ContextGLStencilAction.ZERO] = this._gl.ZERO;
                this._textureIndexDictionary[0] = this._gl.TEXTURE0;
                this._textureIndexDictionary[1] = this._gl.TEXTURE1;
                this._textureIndexDictionary[2] = this._gl.TEXTURE2;
                this._textureIndexDictionary[3] = this._gl.TEXTURE3;
                this._textureIndexDictionary[4] = this._gl.TEXTURE4;
                this._textureIndexDictionary[5] = this._gl.TEXTURE5;
                this._textureIndexDictionary[6] = this._gl.TEXTURE6;
                this._textureIndexDictionary[7] = this._gl.TEXTURE7;
                this._textureTypeDictionary["texture2d"] = this._gl.TEXTURE_2D;
                this._textureTypeDictionary["textureCube"] = this._gl.TEXTURE_CUBE_MAP;
                this._wrapDictionary[ContextGLWrapMode.REPEAT] = this._gl.REPEAT;
                this._wrapDictionary[ContextGLWrapMode.CLAMP] = this._gl.CLAMP_TO_EDGE;
                this._filterDictionary[ContextGLTextureFilter.LINEAR] = this._gl.LINEAR;
                this._filterDictionary[ContextGLTextureFilter.NEAREST] = this._gl.NEAREST;
                this._mipmapFilterDictionary[ContextGLTextureFilter.LINEAR] = new Object();
                this._mipmapFilterDictionary[ContextGLTextureFilter.LINEAR][ContextGLMipFilter.MIPNEAREST] = this._gl.LINEAR_MIPMAP_NEAREST;
                this._mipmapFilterDictionary[ContextGLTextureFilter.LINEAR][ContextGLMipFilter.MIPLINEAR] = this._gl.LINEAR_MIPMAP_LINEAR;
                this._mipmapFilterDictionary[ContextGLTextureFilter.LINEAR][ContextGLMipFilter.MIPNONE] = this._gl.LINEAR;
                this._mipmapFilterDictionary[ContextGLTextureFilter.NEAREST] = new Object();
                this._mipmapFilterDictionary[ContextGLTextureFilter.NEAREST][ContextGLMipFilter.MIPNEAREST] = this._gl.NEAREST_MIPMAP_NEAREST;
                this._mipmapFilterDictionary[ContextGLTextureFilter.NEAREST][ContextGLMipFilter.MIPLINEAR] = this._gl.NEAREST_MIPMAP_LINEAR;
                this._mipmapFilterDictionary[ContextGLTextureFilter.NEAREST][ContextGLMipFilter.MIPNONE] = this._gl.NEAREST;
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.FLOAT_1] = new VertexBufferProperties$1(1, this._gl.FLOAT, false);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.FLOAT_2] = new VertexBufferProperties$1(2, this._gl.FLOAT, false);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.FLOAT_3] = new VertexBufferProperties$1(3, this._gl.FLOAT, false);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.FLOAT_4] = new VertexBufferProperties$1(4, this._gl.FLOAT, false);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.BYTE_1] = new VertexBufferProperties$1(1, this._gl.BYTE, true);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.BYTE_2] = new VertexBufferProperties$1(2, this._gl.BYTE, true);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.BYTE_3] = new VertexBufferProperties$1(3, this._gl.BYTE, true);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.BYTE_4] = new VertexBufferProperties$1(4, this._gl.BYTE, true);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.UNSIGNED_BYTE_1] = new VertexBufferProperties$1(1, this._gl.UNSIGNED_BYTE, true);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.UNSIGNED_BYTE_2] = new VertexBufferProperties$1(2, this._gl.UNSIGNED_BYTE, true);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.UNSIGNED_BYTE_3] = new VertexBufferProperties$1(3, this._gl.UNSIGNED_BYTE, true);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.UNSIGNED_BYTE_4] = new VertexBufferProperties$1(4, this._gl.UNSIGNED_BYTE, true);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.SHORT_1] = new VertexBufferProperties$1(1, this._gl.SHORT, false);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.SHORT_2] = new VertexBufferProperties$1(2, this._gl.SHORT, false);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.SHORT_3] = new VertexBufferProperties$1(3, this._gl.SHORT, false);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.SHORT_4] = new VertexBufferProperties$1(4, this._gl.SHORT, false);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.UNSIGNED_SHORT_1] = new VertexBufferProperties$1(1, this._gl.UNSIGNED_SHORT, false);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.UNSIGNED_SHORT_2] = new VertexBufferProperties$1(2, this._gl.UNSIGNED_SHORT, false);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.UNSIGNED_SHORT_3] = new VertexBufferProperties$1(3, this._gl.UNSIGNED_SHORT, false);
                this._vertexBufferPropertiesDictionary[ContextGLVertexBufferFormat.UNSIGNED_SHORT_4] = new VertexBufferProperties$1(4, this._gl.UNSIGNED_SHORT, false);
                this._stencilCompareMode = this._gl.ALWAYS;
                this._stencilCompareModeBack = this._gl.ALWAYS;
                this._stencilCompareModeFront = this._gl.ALWAYS;
                var dpr = window.devicePixelRatio || 1;
                var bsr = this._gl["webkitBackingStorePixelRatio"] ||
                    this._gl["mozBackingStorePixelRatio"] ||
                    this._gl["msBackingStorePixelRatio"] ||
                    this._gl["oBackingStorePixelRatio"] ||
                    this._gl["backingStorePixelRatio"] || 1;
                //this._gl["backingStorePixelRatio"] || (/\bCrOS\b/.test(navigator.userAgent))? 0.5 : 1;
                this._pixelRatio = dpr / bsr;
            }
            else {
                //this.dispatchEvent( new away.events.AwayEvent( away.events.AwayEvent.INITIALIZE_FAILED, e ) );
                alert("WebGL is not available.");
            }
            //defaults
            for (var i = 0; i < ContextWebGL.MAX_SAMPLERS; ++i) {
                this._samplerStates[i] = new SamplerState();
                this._samplerStates[i].wrap = this._gl.REPEAT;
                this._samplerStates[i].filter = this._gl.LINEAR;
                this._samplerStates[i].mipfilter = this._gl.LINEAR;
            }
        };
        ContextWebGL.prototype.gl = function () {
            return this._gl;
        };
        ContextWebGL.prototype.clear = function (red, green, blue, alpha, depth, stencil, mask) {
            if (red === void 0) { red = 0; }
            if (green === void 0) { green = 0; }
            if (blue === void 0) { blue = 0; }
            if (alpha === void 0) { alpha = 1; }
            if (depth === void 0) { depth = 1; }
            if (stencil === void 0) { stencil = 0; }
            if (mask === void 0) { mask = ContextGLClearMask.ALL; }
            if (!this._drawing) {
                this.updateBlendStatus();
                this._drawing = true;
            }
            var glmask = 0;
            if (mask & ContextGLClearMask.COLOR)
                glmask |= this._gl.COLOR_BUFFER_BIT;
            if (mask & ContextGLClearMask.STENCIL)
                glmask |= this._gl.STENCIL_BUFFER_BIT;
            if (mask & ContextGLClearMask.DEPTH)
                glmask |= this._gl.DEPTH_BUFFER_BIT;
            this._gl.clearColor(red, green, blue, alpha);
            this._gl.clearDepth(depth);
            this._gl.clearStencil(stencil);
            this._gl.clear(glmask);
        };
        ContextWebGL.prototype.configureBackBuffer = function (width, height, antiAlias, enableDepthAndStencil) {
            if (enableDepthAndStencil === void 0) { enableDepthAndStencil = true; }
            this._width = width * this._pixelRatio;
            this._height = height * this._pixelRatio;
            if (enableDepthAndStencil) {
                this._gl.enable(this._gl.STENCIL_TEST);
                this._gl.enable(this._gl.DEPTH_TEST);
            }
            else {
                this._gl.disable(this._gl.STENCIL_TEST);
                this._gl.disable(this._gl.DEPTH_TEST);
            }
            this._gl.viewport(0, 0, this._width, this._height);
        };
        ContextWebGL.prototype.createCubeTexture = function (size, format, optimizeForRenderToTexture, streamingLevels) {
            if (streamingLevels === void 0) { streamingLevels = 0; }
            return new CubeTextureWebGL(this._gl, size);
        };
        ContextWebGL.prototype.createIndexBuffer = function (numIndices) {
            return new IndexBufferWebGL(this._gl, numIndices);
        };
        ContextWebGL.prototype.createProgram = function () {
            return new ProgramWebGL(this._gl);
        };
        ContextWebGL.prototype.createTexture = function (width, height, format, optimizeForRenderToTexture, streamingLevels) {
            if (streamingLevels === void 0) { streamingLevels = 0; }
            //TODO streaming
            return new TextureWebGL(this._gl, width, height);
        };
        ContextWebGL.prototype.createVertexBuffer = function (numVertices, dataPerVertex) {
            return new VertexBufferWebGL(this._gl, numVertices, dataPerVertex);
        };
        ContextWebGL.prototype.dispose = function () {
            for (var i = 0; i < this._samplerStates.length; ++i)
                this._samplerStates[i] = null;
        };
        ContextWebGL.prototype.drawToBitmapImage2D = function (destination) {
            var pixels = new Uint8Array(destination.width * destination.height * 4);
            this._gl.readPixels(0, 0, destination.width, destination.height, this._gl.RGBA, this._gl.UNSIGNED_BYTE, pixels);
            destination.setPixels(new Rectangle(0, 0, destination.width, destination.height), new Uint8ClampedArray(pixels.buffer));
        };
        ContextWebGL.prototype.drawIndices = function (mode, indexBuffer, firstIndex, numIndices) {
            if (firstIndex === void 0) { firstIndex = 0; }
            if (numIndices === void 0) { numIndices = -1; }
            if (!this._drawing)
                throw "Need to clear before drawing if the buffer has not been cleared since the last present() call.";
            this._gl.bindBuffer(this._gl.ELEMENT_ARRAY_BUFFER, indexBuffer.glBuffer);
            // Note: The 2 code options below are for #1 production and #2 debugging. Pick one and comment the other.
            // #1
            if (!window["awayDebugDrawing"]) {
                this._gl.drawElements(this._drawModeDictionary[mode], (numIndices == -1) ? indexBuffer.numIndices : numIndices, this._gl.UNSIGNED_SHORT, firstIndex * 2);
            } // #2
            else {
                for (var i = 0; i < numIndices; i += 3) {
                    this._gl.drawElements(this._gl.LINE_LOOP, 3, this._gl.UNSIGNED_SHORT, (firstIndex + i) * 2);
                }
            }
        };
        ContextWebGL.prototype.drawVertices = function (mode, firstVertex, numVertices) {
            if (firstVertex === void 0) { firstVertex = 0; }
            if (numVertices === void 0) { numVertices = -1; }
            if (!this._drawing)
                throw "Need to clear before drawing if the buffer has not been cleared since the last present() call.";
            if (numVertices == 0)
                return;
            //DEBUG: draws triangle outlines
            if (window["awayDebugDrawing"]) {
                for (var i = 0; i < numVertices; i += 3) {
                    this._gl.drawArrays(this._gl.LINE_LOOP, firstVertex + i, 3);
                }
            }
            else {
                try {
                    this._gl.drawArrays(this._drawModeDictionary[mode], firstVertex, numVertices);
                }
                catch (e) {
                    console.log(e);
                }
            }
            // todo: this check should not be needed.
            // for now it is here to prevent ugly gpu warnings when trying to render numVertices=0
            if (numVertices == 0)
                return;
        };
        ContextWebGL.prototype.present = function () {
            //this._drawing = false;
        };
        ContextWebGL.prototype.setBlendFactors = function (sourceFactor, destinationFactor) {
            this._blendEnabled = true;
            this._blendSourceFactor = this._blendFactorDictionary[sourceFactor];
            this._blendDestinationFactor = this._blendFactorDictionary[destinationFactor];
            this.updateBlendStatus();
        };
        ContextWebGL.prototype.setColorMask = function (red, green, blue, alpha) {
            this._gl.colorMask(red, green, blue, alpha);
        };
        ContextWebGL.prototype.setCulling = function (triangleFaceToCull, coordinateSystem) {
            if (coordinateSystem === void 0) { coordinateSystem = CoordinateSystem.LEFT_HANDED; }
            if (triangleFaceToCull == ContextGLTriangleFace.NONE) {
                this._gl.disable(this._gl.CULL_FACE);
            }
            else {
                this._gl.enable(this._gl.CULL_FACE);
                this._gl.cullFace(this.translateTriangleFace(triangleFaceToCull, coordinateSystem));
            }
        };
        // TODO ContextGLCompareMode
        ContextWebGL.prototype.setDepthTest = function (depthMask, passCompareMode) {
            this._gl.depthFunc(this._compareModeDictionary[passCompareMode]);
            this._gl.depthMask(depthMask);
        };
        ContextWebGL.prototype.enableStencil = function () {
            this._gl.enable(this._gl.STENCIL_TEST);
        };
        ContextWebGL.prototype.disableStencil = function () {
            this._gl.disable(this._gl.STENCIL_TEST);
        };
        ContextWebGL.prototype.setStencilActions = function (triangleFace, compareMode, actionOnBothPass, actionOnDepthFail, actionOnDepthPassStencilFail, coordinateSystem) {
            if (triangleFace === void 0) { triangleFace = ContextGLTriangleFace.FRONT_AND_BACK; }
            if (compareMode === void 0) { compareMode = ContextGLCompareMode.ALWAYS; }
            if (actionOnBothPass === void 0) { actionOnBothPass = ContextGLStencilAction.KEEP; }
            if (actionOnDepthFail === void 0) { actionOnDepthFail = ContextGLStencilAction.KEEP; }
            if (actionOnDepthPassStencilFail === void 0) { actionOnDepthPassStencilFail = ContextGLStencilAction.KEEP; }
            if (coordinateSystem === void 0) { coordinateSystem = CoordinateSystem.LEFT_HANDED; }
            this._separateStencil = triangleFace != ContextGLTriangleFace.FRONT_AND_BACK;
            var compareModeGL = this._compareModeDictionary[compareMode];
            var fail = this._stencilActionDictionary[actionOnDepthPassStencilFail];
            var zFail = this._stencilActionDictionary[actionOnDepthFail];
            var pass = this._stencilActionDictionary[actionOnBothPass];
            if (!this._separateStencil) {
                this._stencilCompareMode = compareModeGL;
                this._gl.stencilFunc(compareModeGL, this._stencilReferenceValue, this._stencilReadMask);
                this._gl.stencilOp(fail, zFail, pass);
            }
            else if (triangleFace == ContextGLTriangleFace.BACK) {
                this._stencilCompareModeBack = compareModeGL;
                this._gl.stencilFuncSeparate(this._gl.BACK, compareModeGL, this._stencilReferenceValue, this._stencilReadMask);
                this._gl.stencilOpSeparate(this._gl.BACK, fail, zFail, pass);
            }
            else if (triangleFace == ContextGLTriangleFace.FRONT) {
                this._stencilCompareModeFront = compareModeGL;
                this._gl.stencilFuncSeparate(this._gl.FRONT, compareModeGL, this._stencilReferenceValue, this._stencilReadMask);
                this._gl.stencilOpSeparate(this._gl.FRONT, fail, zFail, pass);
            }
        };
        ContextWebGL.prototype.setStencilReferenceValue = function (referenceValue, readMask, writeMask) {
            if (readMask === void 0) { readMask = 0xFF; }
            if (writeMask === void 0) { writeMask = 0xFF; }
            this._stencilReferenceValue = referenceValue;
            this._stencilReadMask = readMask;
            if (this._separateStencil) {
                this._gl.stencilFuncSeparate(this._gl.FRONT, this._stencilCompareModeFront, referenceValue, readMask);
                this._gl.stencilFuncSeparate(this._gl.BACK, this._stencilCompareModeBack, referenceValue, readMask);
            }
            else {
                this._gl.stencilFunc(this._stencilCompareMode, referenceValue, readMask);
            }
            this._gl.stencilMask(writeMask);
        };
        ContextWebGL.prototype.setProgram = function (program) {
            //TODO decide on construction/reference resposibilities
            this._currentProgram = program;
            program.focusProgram();
        };
        ContextWebGL.prototype.setProgramConstantsFromArray = function (programType, data) {
            if (data.length)
                this._gl.uniform4fv(this._currentProgram.getUniformLocation(programType), data);
        };
        ContextWebGL.prototype.setScissorRectangle = function (rectangle) {
            if (!rectangle) {
                this._gl.disable(this._gl.SCISSOR_TEST);
                return;
            }
            this._gl.enable(this._gl.SCISSOR_TEST);
            this._gl.scissor(rectangle.x * this._pixelRatio, this._height - (rectangle.y + rectangle.height) * this._pixelRatio, rectangle.width * this._pixelRatio, rectangle.height * this._pixelRatio);
        };
        ContextWebGL.prototype.setTextureAt = function (sampler, texture) {
            var samplerState = this._samplerStates[sampler];
            if (this._activeTexture != sampler && (texture || samplerState.type)) {
                this._activeTexture = sampler;
                this._gl.activeTexture(this._textureIndexDictionary[sampler]);
            }
            if (!texture) {
                if (samplerState.type) {
                    this._gl.bindTexture(samplerState.type, null);
                    samplerState.type = null;
                }
                return;
            }
            var textureType = this._textureTypeDictionary[texture.textureType];
            samplerState.type = textureType;
            this._gl.bindTexture(textureType, texture.glTexture);
            this._gl.uniform1i(this._currentProgram.getUniformLocation(ContextGLProgramType.SAMPLER, sampler), sampler);
            this._gl.texParameteri(textureType, this._gl.TEXTURE_WRAP_S, samplerState.wrap);
            this._gl.texParameteri(textureType, this._gl.TEXTURE_WRAP_T, samplerState.wrap);
            this._gl.texParameteri(textureType, this._gl.TEXTURE_MAG_FILTER, samplerState.filter);
            this._gl.texParameteri(textureType, this._gl.TEXTURE_MIN_FILTER, samplerState.mipfilter);
        };
        ContextWebGL.prototype.setSamplerStateAt = function (sampler, wrap, filter, mipfilter) {
            if (0 <= sampler && sampler < ContextWebGL.MAX_SAMPLERS) {
                this._samplerStates[sampler].wrap = this._wrapDictionary[wrap];
                this._samplerStates[sampler].filter = this._filterDictionary[filter];
                this._samplerStates[sampler].mipfilter = this._mipmapFilterDictionary[filter][mipfilter];
            }
            else {
                throw "Sampler is out of bounds.";
            }
        };
        ContextWebGL.prototype.setVertexBufferAt = function (index, buffer, bufferOffset, format) {
            if (bufferOffset === void 0) { bufferOffset = 0; }
            if (format === void 0) { format = 4; }
            var location = this._currentProgram ? this._currentProgram.getAttribLocation(index) : -1;
            if (!buffer) {
                if (location > -1)
                    this._gl.disableVertexAttribArray(location);
                return;
            }
            //buffer may not have changed if concatenated buffers are being used
            if (this._currentArrayBuffer != buffer) {
                this._currentArrayBuffer = buffer;
                this._gl.bindBuffer(this._gl.ARRAY_BUFFER, buffer ? buffer.glBuffer : null);
            }
            var properties = this._vertexBufferPropertiesDictionary[format];
            this._gl.enableVertexAttribArray(location);
            this._gl.vertexAttribPointer(location, properties.size, properties.type, properties.normalized, buffer.dataPerVertex, bufferOffset);
        };
        ContextWebGL.prototype.setRenderToTexture = function (target, enableDepthAndStencil, antiAlias, surfaceSelector, mipmapSelector) {
            if (enableDepthAndStencil === void 0) { enableDepthAndStencil = false; }
            if (antiAlias === void 0) { antiAlias = 0; }
            if (surfaceSelector === void 0) { surfaceSelector = 0; }
            if (mipmapSelector === void 0) { mipmapSelector = 0; }
            if (this._renderTarget)
                this._renderTarget.presentFrameBuffer();
            this._renderTarget = target;
            this._renderTarget.setFrameBuffer(enableDepthAndStencil, antiAlias, surfaceSelector, mipmapSelector);
        };
        ContextWebGL.prototype.setRenderToBackBuffer = function () {
            if (this._renderTarget) {
                this._renderTarget.presentFrameBuffer();
                this._renderTarget = null;
            }
            this._gl.bindFramebuffer(this._gl.FRAMEBUFFER, null);
        };
        ContextWebGL.prototype.copyToTexture = function (target, rect, destPoint) {
            this._gl.bindTexture(this._gl.TEXTURE_2D, target.glTexture);
            this._gl.copyTexSubImage2D(this._gl.TEXTURE_2D, 0, destPoint.x, destPoint.y, rect.x, rect.y, rect.width, rect.height);
        };
        ContextWebGL.prototype.updateBlendStatus = function () {
            if (this._blendEnabled) {
                this._gl.enable(this._gl.BLEND);
                this._gl.blendEquation(this._gl.FUNC_ADD);
                this._gl.blendFunc(this._blendSourceFactor, this._blendDestinationFactor);
            }
            else {
                this._gl.disable(this._gl.BLEND);
            }
        };
        ContextWebGL.prototype.translateTriangleFace = function (triangleFace, coordinateSystem) {
            switch (triangleFace) {
                case ContextGLTriangleFace.BACK:
                    return (coordinateSystem == CoordinateSystem.LEFT_HANDED) ? this._gl.FRONT : this._gl.BACK;
                case ContextGLTriangleFace.FRONT:
                    return (coordinateSystem == CoordinateSystem.LEFT_HANDED) ? this._gl.BACK : this._gl.FRONT;
                case ContextGLTriangleFace.FRONT_AND_BACK:
                    return this._gl.FRONT_AND_BACK;
                default:
                    throw "Unknown ContextGLTriangleFace type."; // TODO error
            }
        };
        ContextWebGL.MAX_SAMPLERS = 8;
        ContextWebGL.modulo = 0;
        return ContextWebGL;
    }());
    var VertexBufferProperties$1 = /** @class */ (function () {
        function VertexBufferProperties(size, type, normalized) {
            this.size = size;
            this.type = type;
            this.normalized = normalized;
        }
        return VertexBufferProperties;
    }());

    /**
     * A single register element (an entire register or a single register's component) used by the RegisterPool.
     */
    var ShaderRegisterElement = /** @class */ (function () {
        /**
         * Creates a new ShaderRegisterElement object.
         *
         * @param regName The name of the register.
         * @param index The index of the register.
         * @param component The register's component, if not the entire register is represented.
         */
        function ShaderRegisterElement(regName, index, component) {
            if (component === void 0) { component = -1; }
            this._component = component;
            this._regName = regName;
            this._index = index;
            this._toStr = this._regName;
            if (this._index >= 0)
                this._toStr += this._index;
            if (component > -1)
                this._toStr += "." + ShaderRegisterElement.COMPONENTS[component];
        }
        /**
         * Converts the register or the components AGAL string representation.
         */
        ShaderRegisterElement.prototype.toString = function () {
            return this._toStr;
        };
        Object.defineProperty(ShaderRegisterElement.prototype, "regName", {
            /**
             * The register's name.
             */
            get: function () {
                return this._regName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderRegisterElement.prototype, "index", {
            /**
             * The register's index.
             */
            get: function () {
                return this._index;
            },
            enumerable: true,
            configurable: true
        });
        ShaderRegisterElement.COMPONENTS = ["x", "y", "z", "w"];
        return ShaderRegisterElement;
    }());

    /**
     * RegisterPool is used by the shader compilers process to keep track of which registers of a certain type are
     * currently used and should not be allowed to be written to. Either entire registers can be requested and locked,
     * or single components (x, y, z, w) of a single register.
     * It is used by ShaderRegisterCache to track usages of individual register types.
     *
     * @see away.materials.ShaderRegisterCache
     */
    var RegisterPool = /** @class */ (function () {
        /**
         * Creates a new RegisterPool object.
         * @param regName The base name of the register type ("ft" for fragment temporaries, "vc" for vertex constants, etc)
         * @param regCount The amount of available registers of this type.
         * @param persistent Whether or not registers, once reserved, can be freed again. For example, temporaries are not persistent, but constants are.
         */
        function RegisterPool(regName, regCount, persistent) {
            if (persistent === void 0) { persistent = true; }
            this._regName = regName;
            this._regCount = regCount;
            this._persistent = persistent;
            this.initRegisters(regName, regCount);
        }
        /**
         * Retrieve an entire vector register that's still available.
         */
        RegisterPool.prototype.requestFreeVectorReg = function () {
            for (var i = 0; i < this._regCount; ++i) {
                if (!this.isRegisterUsed(i)) {
                    if (this._persistent)
                        this._usedVectorCount[i]++;
                    return this._vectorRegisters[i];
                }
            }
            throw new Error("Register overflow!");
        };
        /**
         * Retrieve a single vector component that's still available.
         */
        RegisterPool.prototype.requestFreeRegComponent = function () {
            for (var i = 0; i < this._regCount; ++i) {
                if (this._usedVectorCount[i] > 0)
                    continue;
                for (var j = 0; j < 4; ++j) {
                    if (this._usedSingleCount[j][i] == 0) {
                        if (this._persistent)
                            this._usedSingleCount[j][i]++;
                        return this._registerComponents[j][i];
                    }
                }
            }
            throw new Error("Register overflow!");
        };
        /**
         * Marks a register as used, so it cannot be retrieved. The register won't be able to be used until removeUsage
         * has been called usageCount times again.
         * @param register The register to mark as used.
         * @param usageCount The amount of usages to add.
         */
        RegisterPool.prototype.addUsage = function (register, usageCount) {
            if (register._component > -1)
                this._usedSingleCount[register._component][register.index] += usageCount;
            else
                this._usedVectorCount[register.index] += usageCount;
        };
        /**
         * Removes a usage from a register. When usages reach 0, the register is freed again.
         * @param register The register for which to remove a usage.
         */
        RegisterPool.prototype.removeUsage = function (register) {
            if (register._component > -1) {
                if (--this._usedSingleCount[register._component][register.index] < 0)
                    throw new Error("More usages removed than exist!");
            }
            else {
                if (--this._usedVectorCount[register.index] < 0)
                    throw new Error("More usages removed than exist!");
            }
        };
        /**
         * Disposes any resources used by the current RegisterPool object.
         */
        RegisterPool.prototype.dispose = function () {
            this._vectorRegisters = null;
            this._registerComponents = null;
            this._usedSingleCount = null;
            this._usedVectorCount = null;
        };
        /**
         * Indicates whether or not any registers are in use.
         */
        RegisterPool.prototype.hasRegisteredRegs = function () {
            for (var i = 0; i < this._regCount; ++i)
                if (this.isRegisterUsed(i))
                    return true;
            return false;
        };
        /**
         * Initializes all registers.
         */
        RegisterPool.prototype.initRegisters = function (regName, regCount) {
            var hash = RegisterPool._initPool(regName, regCount);
            this._vectorRegisters = RegisterPool._regPool[hash];
            this._registerComponents = RegisterPool._regCompsPool[hash];
            this._usedVectorCount = this._initArray(Array(regCount), 0);
            this._usedSingleCount = new Array(4);
            this._usedSingleCount[0] = this._initArray(new Array(regCount), 0);
            this._usedSingleCount[1] = this._initArray(new Array(regCount), 0);
            this._usedSingleCount[2] = this._initArray(new Array(regCount), 0);
            this._usedSingleCount[3] = this._initArray(new Array(regCount), 0);
        };
        RegisterPool._initPool = function (regName, regCount) {
            var hash = regName + regCount;
            if (RegisterPool._regPool[hash] != undefined)
                return hash;
            var vectorRegisters = new Array(regCount);
            RegisterPool._regPool[hash] = vectorRegisters;
            var registerComponents = [
                [],
                [],
                [],
                []
            ];
            RegisterPool._regCompsPool[hash] = registerComponents;
            for (var i = 0; i < regCount; ++i) {
                vectorRegisters[i] = new ShaderRegisterElement(regName, i);
                for (var j = 0; j < 4; ++j)
                    registerComponents[j][i] = new ShaderRegisterElement(regName, i, j);
            }
            return hash;
        };
        /**
         * Check if the temp register is either used for single or vector use
         */
        RegisterPool.prototype.isRegisterUsed = function (index) {
            if (this._usedVectorCount[index] > 0)
                return true;
            for (var i = 0; i < 4; ++i)
                if (this._usedSingleCount[i][index] > 0)
                    return true;
            return false;
        };
        RegisterPool.prototype._initArray = function (a, val) {
            var l = a.length;
            for (var c = 0; c < l; c++)
                a[c] = val;
            return a;
        };
        RegisterPool._regPool = new Object();
        RegisterPool._regCompsPool = new Object();
        return RegisterPool;
    }());

    /**
     * ShaderRegister Cache provides the usage management system for all registers during shading compilers.
     */
    var ShaderRegisterCache = /** @class */ (function () {
        /**
         * Create a new ShaderRegisterCache object.
         *
         * @param profile The compatibility profile used by the renderer.
         */
        function ShaderRegisterCache(profile) {
            this._numUsedVertexConstants = 0;
            this._numUsedFragmentConstants = 0;
            this._numUsedStreams = 0;
            this._numUsedTextures = 0;
            this._numUsedVaryings = 0;
            this._profile = profile;
            this.reset();
        }
        /**
         * Resets all registers.
         */
        ShaderRegisterCache.prototype.reset = function () {
            this._fragmentTempCache = new RegisterPool("ft", 8, false);
            this._vertexTempCache = new RegisterPool("vt", 8, false);
            this._varyingCache = new RegisterPool("v", 8);
            this._textureCache = new RegisterPool("fs", 8);
            this._vertexAttributesCache = new RegisterPool("va", 8);
            this._fragmentConstantsCache = new RegisterPool("fc", 28);
            this._vertexConstantsCache = new RegisterPool("vc", 128);
            this._fragmentOutputRegister = new ShaderRegisterElement("oc", -1);
            this._vertexOutputRegister = new ShaderRegisterElement("op", -1);
            this._numUsedVertexConstants = 0;
            this._numUsedStreams = 0;
            this._numUsedTextures = 0;
            this._numUsedVaryings = 0;
            this._numUsedFragmentConstants = 0;
        };
        /**
         * Disposes all resources used.
         */
        ShaderRegisterCache.prototype.dispose = function () {
            this._fragmentTempCache.dispose();
            this._vertexTempCache.dispose();
            this._varyingCache.dispose();
            this._fragmentConstantsCache.dispose();
            this._vertexAttributesCache.dispose();
            this._fragmentTempCache = null;
            this._vertexTempCache = null;
            this._varyingCache = null;
            this._fragmentConstantsCache = null;
            this._vertexAttributesCache = null;
            this._fragmentOutputRegister = null;
            this._vertexOutputRegister = null;
        };
        /**
         * Marks a fragment temporary register as used, so it cannot be retrieved. The register won't be able to be used until removeUsage
         * has been called usageCount times again.
         * @param register The register to mark as used.
         * @param usageCount The amount of usages to add.
         */
        ShaderRegisterCache.prototype.addFragmentTempUsages = function (register, usageCount) {
            this._fragmentTempCache.addUsage(register, usageCount);
        };
        /**
         * Removes a usage from a fragment temporary register. When usages reach 0, the register is freed again.
         * @param register The register for which to remove a usage.
         */
        ShaderRegisterCache.prototype.removeFragmentTempUsage = function (register) {
            this._fragmentTempCache.removeUsage(register);
        };
        /**
         * Marks a vertex temporary register as used, so it cannot be retrieved. The register won't be able to be used
         * until removeUsage has been called usageCount times again.
         * @param register The register to mark as used.
         * @param usageCount The amount of usages to add.
         */
        ShaderRegisterCache.prototype.addVertexTempUsages = function (register, usageCount) {
            this._vertexTempCache.addUsage(register, usageCount);
        };
        /**
         * Removes a usage from a vertex temporary register. When usages reach 0, the register is freed again.
         * @param register The register for which to remove a usage.
         */
        ShaderRegisterCache.prototype.removeVertexTempUsage = function (register) {
            this._vertexTempCache.removeUsage(register);
        };
        /**
         * Retrieve an entire fragment temporary register that's still available. The register won't be able to be used until removeUsage
         * has been called usageCount times again.
         */
        ShaderRegisterCache.prototype.getFreeFragmentVectorTemp = function () {
            return this._fragmentTempCache.requestFreeVectorReg();
        };
        /**
         * Retrieve a single component from a fragment temporary register that's still available.
         */
        ShaderRegisterCache.prototype.getFreeFragmentSingleTemp = function () {
            return this._fragmentTempCache.requestFreeRegComponent();
        };
        /**
         * Retrieve an available varying register
         */
        ShaderRegisterCache.prototype.getFreeVarying = function () {
            ++this._numUsedVaryings;
            return this._varyingCache.requestFreeVectorReg();
        };
        /**
         * Retrieve an available fragment constant register
         */
        ShaderRegisterCache.prototype.getFreeFragmentConstant = function () {
            ++this._numUsedFragmentConstants;
            return this._fragmentConstantsCache.requestFreeVectorReg();
        };
        /**
         * Retrieve an available vertex constant register
         */
        ShaderRegisterCache.prototype.getFreeVertexConstant = function () {
            ++this._numUsedVertexConstants;
            return this._vertexConstantsCache.requestFreeVectorReg();
        };
        /**
         * Retrieve an entire vertex temporary register that's still available.
         */
        ShaderRegisterCache.prototype.getFreeVertexVectorTemp = function () {
            return this._vertexTempCache.requestFreeVectorReg();
        };
        /**
         * Retrieve a single component from a vertex temporary register that's still available.
         */
        ShaderRegisterCache.prototype.getFreeVertexSingleTemp = function () {
            return this._vertexTempCache.requestFreeRegComponent();
        };
        /**
         * Retrieve an available vertex attribute register
         */
        ShaderRegisterCache.prototype.getFreeVertexAttribute = function () {
            ++this._numUsedStreams;
            return this._vertexAttributesCache.requestFreeVectorReg();
        };
        /**
         * Retrieve an available texture register
         */
        ShaderRegisterCache.prototype.getFreeTextureReg = function () {
            ++this._numUsedTextures;
            return this._textureCache.requestFreeVectorReg();
        };
        Object.defineProperty(ShaderRegisterCache.prototype, "fragmentOutputRegister", {
            /**
             * The fragment output register.
             */
            get: function () {
                return this._fragmentOutputRegister;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderRegisterCache.prototype, "numUsedVertexConstants", {
            /**
             * The amount of used vertex constant registers.
             */
            get: function () {
                return this._numUsedVertexConstants;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderRegisterCache.prototype, "numUsedFragmentConstants", {
            /**
             * The amount of used fragment constant registers.
             */
            get: function () {
                return this._numUsedFragmentConstants;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderRegisterCache.prototype, "numUsedStreams", {
            /**
             * The amount of used vertex streams.
             */
            get: function () {
                return this._numUsedStreams;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderRegisterCache.prototype, "numUsedTextures", {
            /**
             * The amount of used texture slots.
             */
            get: function () {
                return this._numUsedTextures;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderRegisterCache.prototype, "numUsedVaryings", {
            /**
             * The amount of used varying registers.
             */
            get: function () {
                return this._numUsedVaryings;
            },
            enumerable: true,
            configurable: true
        });
        return ShaderRegisterCache;
    }());

    var Filter3DTaskBase = /** @class */ (function () {
        function Filter3DTaskBase(requireDepthRender) {
            if (requireDepthRender === void 0) { requireDepthRender = false; }
            this._scaledTextureWidth = -1;
            this._scaledTextureHeight = -1;
            this._textureWidth = -1;
            this._textureHeight = -1;
            this._textureDimensionsInvalid = true;
            this._program3DInvalid = true;
            this._textureScale = 1;
            this._requireDepthRender = requireDepthRender;
            this._registerCache = new ShaderRegisterCache(ContextGLProfile.BASELINE);
        }
        Object.defineProperty(Filter3DTaskBase.prototype, "textureScale", {
            /**
             * The texture scale for the input of this texture. This will define the output of the previous entry in the chain
             */
            get: function () {
                return this._textureScale;
            },
            set: function (value) {
                if (this._textureScale == value)
                    return;
                this._textureScale = value;
                this._scaledTextureWidth = this._textureWidth / this._textureScale;
                this._scaledTextureHeight = this._textureHeight / this._textureScale;
                this._textureDimensionsInvalid = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DTaskBase.prototype, "target", {
            get: function () {
                return this._target;
            },
            set: function (value) {
                this._target = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DTaskBase.prototype, "rttManager", {
            get: function () {
                return this._rttManager;
            },
            set: function (value) {
                if (this._rttManager == value)
                    return;
                this._rttManager = value;
                this._textureDimensionsInvalid = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DTaskBase.prototype, "textureWidth", {
            get: function () {
                return this._textureWidth;
            },
            set: function (value) {
                if (this._textureWidth == value)
                    return;
                this._textureWidth = value;
                this._scaledTextureWidth = this._textureWidth / this._textureScale;
                this._textureDimensionsInvalid = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DTaskBase.prototype, "textureHeight", {
            get: function () {
                return this._textureHeight;
            },
            set: function (value) {
                if (this._textureHeight == value)
                    return;
                this._textureHeight = value;
                this._scaledTextureHeight = this._textureHeight / this._textureScale;
                this._textureDimensionsInvalid = true;
            },
            enumerable: true,
            configurable: true
        });
        Filter3DTaskBase.prototype.getMainInputTexture = function (stage) {
            if (this._textureDimensionsInvalid)
                this.updateTextures(stage);
            return this._mainInputTexture;
        };
        Filter3DTaskBase.prototype.dispose = function () {
            if (this._mainInputTexture)
                this._mainInputTexture.dispose();
            if (this._program3D)
                this._program3D.dispose();
        };
        Filter3DTaskBase.prototype.invalidateProgram = function () {
            this._program3DInvalid = true;
        };
        Filter3DTaskBase.prototype.updateProgram = function (stage) {
            if (this._program3D)
                this._program3D.dispose();
            this._program3D = stage.context.createProgram();
            this._registerCache.reset();
            var vertexByteCode = (new AGALMiniAssembler().assemble("part vertex 1\n" + this.getVertexCode() + "endpart"))['vertex'].data;
            var fragmentByteCode = (new AGALMiniAssembler().assemble("part fragment 1\n" + this.getFragmentCode() + "endpart"))['fragment'].data;
            this._program3D.upload(vertexByteCode, fragmentByteCode);
            this._program3DInvalid = false;
        };
        Filter3DTaskBase.prototype.getVertexCode = function () {
            var position = this._registerCache.getFreeVertexAttribute();
            this._positionIndex = position.index;
            var uv = this._registerCache.getFreeVertexAttribute();
            this._uvIndex = uv.index;
            this._uvVarying = this._registerCache.getFreeVarying();
            var code;
            code = "mov op, " + position + "\n" +
                "mov " + this._uvVarying + ", " + uv + "\n";
            return code;
        };
        Filter3DTaskBase.prototype.getFragmentCode = function () {
            throw new AbstractMethodError();
        };
        Filter3DTaskBase.prototype.updateTextures = function (stage) {
            if (this._mainInputTexture)
                this._mainInputTexture.dispose();
            this._mainInputTexture = new Image2D(this._scaledTextureWidth, this._scaledTextureHeight);
            this._textureDimensionsInvalid = false;
        };
        Filter3DTaskBase.prototype.getProgram = function (stage) {
            if (this._program3DInvalid)
                this.updateProgram(stage);
            return this._program3D;
        };
        Filter3DTaskBase.prototype.activate = function (stage, projection, depthTexture) {
        };
        Filter3DTaskBase.prototype.deactivate = function (stage) {
        };
        Object.defineProperty(Filter3DTaskBase.prototype, "requireDepthRender", {
            get: function () {
                return this._requireDepthRender;
            },
            enumerable: true,
            configurable: true
        });
        return Filter3DTaskBase;
    }());

    var Filter3DCopyPixelTask = /** @class */ (function (_super) {
        __extends$2(Filter3DCopyPixelTask, _super);
        function Filter3DCopyPixelTask() {
            var _this = _super.call(this) || this;
            _this.rect = new Rectangle();
            _this.destPoint = new Point();
            _this._vertexConstantData = new Float32Array([0.0, 0.0, 0.0, 0.0]);
            _this._fragmentConstantData = new Float32Array([0.0, 0.0, 0.0, 0.0]);
            return _this;
        }
        Object.defineProperty(Filter3DCopyPixelTask.prototype, "sourceTexture", {
            get: function () {
                return this._mainInputTexture;
            },
            set: function (value) {
                this._mainInputTexture = value;
            },
            enumerable: true,
            configurable: true
        });
        Filter3DCopyPixelTask.prototype.getVertexCode = function () {
            var temp1 = this._registerCache.getFreeVertexVectorTemp();
            var rect = this._registerCache.getFreeVertexConstant();
            var position = this._registerCache.getFreeVertexAttribute();
            this._positionIndex = position.index;
            var uv = this._registerCache.getFreeVertexAttribute();
            this._uvIndex = uv.index;
            this._uvVarying = this._registerCache.getFreeVarying();
            var code;
            code = "mul " + temp1 + ".xy, " + position + ", " + rect + ".zw\n" +
                "add " + temp1 + ".xy, " + temp1 + ", " + rect + ".xy\n" +
                "mov " + temp1 + ".w, " + position + ".w\n" +
                "mov op, " + temp1 + "\n" +
                "mov " + this._uvVarying + ", " + uv + "\n";
            return code;
        };
        Filter3DCopyPixelTask.prototype.getFragmentCode = function () {
            var temp1 = this._registerCache.getFreeFragmentVectorTemp();
            var inputTexture = this._registerCache.getFreeTextureReg();
            this._inputTextureIndex = inputTexture.index;
            var offset = this._registerCache.getFreeFragmentConstant();
            var code;
            code = "add " + temp1 + ", " + this._uvVarying + ", " + offset + ".xy\n" +
                "tex " + temp1 + ", " + this._uvVarying + ", " + inputTexture + " <2d,linear,clamp>\n" +
                "mov oc, " + temp1 + "\n";
            return code;
        };
        Filter3DCopyPixelTask.prototype.getMainInputTexture = function (stage) {
            return this._mainInputTexture;
        };
        Filter3DCopyPixelTask.prototype.activate = function (stage, projection, depthTexture) {
            this._vertexConstantData[0] = (2 * this.destPoint.x + this.rect.width) / this._target.width - 1;
            this._vertexConstantData[1] = (2 * this.destPoint.y + this.rect.height) / this._target.height - 1;
            this._vertexConstantData[2] = this.rect.width / this._target.width;
            this._vertexConstantData[3] = this.rect.height / this._target.height;
            this._fragmentConstantData[0] = this.rect.x / this._mainInputTexture.width;
            this._fragmentConstantData[1] = this.rect.y / this._mainInputTexture.height;
            var context = stage.context;
            context.setProgramConstantsFromArray(ContextGLProgramType.VERTEX, this._vertexConstantData);
            context.setProgramConstantsFromArray(ContextGLProgramType.FRAGMENT, this._fragmentConstantData);
        };
        Filter3DCopyPixelTask.prototype.deactivate = function (stage) {
        };
        return Filter3DCopyPixelTask;
    }(Filter3DTaskBase));

    var Filter3DBase = /** @class */ (function () {
        function Filter3DBase() {
            this._textureScale = 1;
            this._tasks = new Array();
        }
        Object.defineProperty(Filter3DBase.prototype, "requireDepthRender", {
            get: function () {
                return this._requireDepthRender;
            },
            enumerable: true,
            configurable: true
        });
        Filter3DBase.prototype.addTask = function (filter) {
            this._tasks.push(filter);
            if (this._requireDepthRender == null)
                this._requireDepthRender = filter.requireDepthRender;
        };
        Object.defineProperty(Filter3DBase.prototype, "tasks", {
            get: function () {
                return this._tasks;
            },
            enumerable: true,
            configurable: true
        });
        Filter3DBase.prototype.getMainInputTexture = function (stage) {
            return this._tasks[0].getMainInputTexture(stage);
        };
        Object.defineProperty(Filter3DBase.prototype, "textureWidth", {
            get: function () {
                return this._textureWidth;
            },
            set: function (value) {
                this._textureWidth = value;
                for (var i = 0; i < this._tasks.length; ++i)
                    this._tasks[i].textureWidth = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DBase.prototype, "rttManager", {
            get: function () {
                return this._rttManager;
            },
            set: function (value) {
                this._rttManager = value;
                for (var i = 0; i < this._tasks.length; ++i)
                    this._tasks[i].rttManager = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DBase.prototype, "textureHeight", {
            get: function () {
                return this._textureHeight;
            },
            set: function (value) {
                this._textureHeight = value;
                for (var i = 0; i < this._tasks.length; ++i)
                    this._tasks[i].textureHeight = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DBase.prototype, "textureScale", {
            get: function () {
                return this._textureScale;
            },
            set: function (value) {
                this._textureScale = value;
                for (var i = 0; i < this._tasks.length; ++i)
                    this._tasks[i].textureScale = value;
            },
            enumerable: true,
            configurable: true
        });
        // link up the filters correctly with the next filter
        Filter3DBase.prototype.setRenderTargets = function (mainTarget, stage) {
            this._tasks[this._tasks.length - 1].target = mainTarget;
        };
        Filter3DBase.prototype.dispose = function () {
            for (var i = 0; i < this._tasks.length; ++i)
                this._tasks[i].dispose();
        };
        Filter3DBase.prototype.update = function (stage, projection) {
        };
        return Filter3DBase;
    }());

    var CopyPixelFilter3D = /** @class */ (function (_super) {
        __extends$2(CopyPixelFilter3D, _super);
        /**
         * Creates a new CopyPixelFilter3D object
         * @param blurX The amount of horizontal blur to apply
         * @param blurY The amount of vertical blur to apply
         * @param stepSize The distance between samples. Set to -1 to autodetect with acceptable quality.
         */
        function CopyPixelFilter3D() {
            var _this = _super.call(this) || this;
            _this._copyPixelTask = new Filter3DCopyPixelTask();
            _this.addTask(_this._copyPixelTask);
            return _this;
        }
        Object.defineProperty(CopyPixelFilter3D.prototype, "rect", {
            get: function () {
                return this._copyPixelTask.rect;
            },
            set: function (value) {
                this._copyPixelTask.rect = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CopyPixelFilter3D.prototype, "destPoint", {
            get: function () {
                return this._copyPixelTask.destPoint;
            },
            set: function (value) {
                this._copyPixelTask.destPoint = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CopyPixelFilter3D.prototype, "sourceTexture", {
            get: function () {
                return this._copyPixelTask.sourceTexture;
            },
            set: function (value) {
                this._copyPixelTask.sourceTexture = value;
            },
            enumerable: true,
            configurable: true
        });
        return CopyPixelFilter3D;
    }(Filter3DBase));

    /**
     * Stage provides a proxy class to handle the creation and attachment of the Context
     * (and in turn the back buffer) it uses. Stage should never be created directly,
     * but requested through StageManager.
     *
     * @see away.managers.StageManager
     *
     */
    var Stage = /** @class */ (function (_super) {
        __extends$2(Stage, _super);
        function Stage(container, stageIndex, stageManager, forceSoftware, profile) {
            if (forceSoftware === void 0) { forceSoftware = false; }
            if (profile === void 0) { profile = ContextGLProfile.BASELINE; }
            var _this = _super.call(this) || this;
            _this._abstractionPool = new Object();
            _this._programData = new Array();
            _this._x = 0;
            _this._y = 0;
            //private static _frameEventDriver:Shape = new Shape(); // TODO: add frame driver/request animation frame
            _this._stageIndex = -1;
            _this._antiAlias = 4;
            //private var _activeVertexBuffers : Vector.<VertexBuffer> = new Vector.<VertexBuffer>(8, true);
            //private var _activeTextures : Vector.<TextureBase> = new Vector.<TextureBase>(8, true);
            _this._renderTarget = null;
            _this._renderSurfaceSelector = 0;
            _this._renderMipmapSelector = 0;
            //private _mouse3DManager:away.managers.Mouse3DManager;
            //private _touch3DManager:Touch3DManager; //TODO: imeplement dependency Touch3DManager
            _this._initialised = false;
            _this._bufferFormatDictionary = new Array(5);
            _this.globalDisableMipmap = false;
            _this.globalDisableSmooth = false;
            _this._programDataPool = new ProgramDataPool(_this);
            _this._container = container;
            if (_this._container) {
                _this._container.addEventListener("webglcontextlost", function (event) { return _this.onContextLost(event); });
                _this._container.addEventListener("webglcontextrestored", function (event) { return _this.onContextRestored(event); });
            }
            _this._stageIndex = stageIndex;
            _this._stageManager = stageManager;
            _this._enableDepthAndStencil = true;
            CSS.setElementX(_this._container, 0);
            CSS.setElementY(_this._container, 0);
            _this._bufferFormatDictionary[1] = new Array(5);
            _this._bufferFormatDictionary[1][1] = ContextGLVertexBufferFormat.BYTE_1;
            _this._bufferFormatDictionary[1][2] = ContextGLVertexBufferFormat.BYTE_2;
            _this._bufferFormatDictionary[1][3] = ContextGLVertexBufferFormat.BYTE_3;
            _this._bufferFormatDictionary[1][4] = ContextGLVertexBufferFormat.BYTE_4;
            _this._bufferFormatDictionary[2] = new Array(5);
            _this._bufferFormatDictionary[2][1] = ContextGLVertexBufferFormat.SHORT_1;
            _this._bufferFormatDictionary[2][2] = ContextGLVertexBufferFormat.SHORT_2;
            _this._bufferFormatDictionary[2][3] = ContextGLVertexBufferFormat.SHORT_3;
            _this._bufferFormatDictionary[2][4] = ContextGLVertexBufferFormat.SHORT_4;
            _this._bufferFormatDictionary[4] = new Array(5);
            _this._bufferFormatDictionary[4][1] = ContextGLVertexBufferFormat.FLOAT_1;
            _this._bufferFormatDictionary[4][2] = ContextGLVertexBufferFormat.FLOAT_2;
            _this._bufferFormatDictionary[4][3] = ContextGLVertexBufferFormat.FLOAT_3;
            _this._bufferFormatDictionary[4][4] = ContextGLVertexBufferFormat.FLOAT_4;
            _this._bufferFormatDictionary[5] = new Array(5);
            _this._bufferFormatDictionary[5][1] = ContextGLVertexBufferFormat.UNSIGNED_BYTE_1;
            _this._bufferFormatDictionary[5][2] = ContextGLVertexBufferFormat.UNSIGNED_BYTE_2;
            _this._bufferFormatDictionary[5][3] = ContextGLVertexBufferFormat.UNSIGNED_BYTE_3;
            _this._bufferFormatDictionary[5][4] = ContextGLVertexBufferFormat.UNSIGNED_BYTE_4;
            _this._bufferFormatDictionary[6] = new Array(5);
            _this._bufferFormatDictionary[6][1] = ContextGLVertexBufferFormat.UNSIGNED_SHORT_1;
            _this._bufferFormatDictionary[6][2] = ContextGLVertexBufferFormat.UNSIGNED_SHORT_2;
            _this._bufferFormatDictionary[6][3] = ContextGLVertexBufferFormat.UNSIGNED_SHORT_3;
            _this._bufferFormatDictionary[6][4] = ContextGLVertexBufferFormat.UNSIGNED_SHORT_4;
            _this.visible = true;
            return _this;
        }
        Object.defineProperty(Stage.prototype, "glVersion", {
            get: function () {
                return this._context.glVersion;
            },
            enumerable: true,
            configurable: true
        });
        Stage.prototype.getProgramData = function (vertexString, fragmentString) {
            return this._programDataPool.getItem(vertexString, fragmentString);
        };
        Stage.prototype.setRenderTarget = function (target, enableDepthAndStencil, surfaceSelector, mipmapSelector) {
            if (enableDepthAndStencil === void 0) { enableDepthAndStencil = false; }
            if (surfaceSelector === void 0) { surfaceSelector = 0; }
            if (mipmapSelector === void 0) { mipmapSelector = 0; }
            if (this._renderTarget === target && surfaceSelector == this._renderSurfaceSelector && mipmapSelector == this._renderMipmapSelector && this._enableDepthAndStencil == enableDepthAndStencil)
                return;
            this._renderTarget = target;
            this._renderSurfaceSelector = surfaceSelector;
            this._renderMipmapSelector = mipmapSelector;
            this._enableDepthAndStencil = enableDepthAndStencil;
            if (target) {
                var targetStage = this.getAbstraction(target);
                this._context.setRenderToTexture(targetStage.getTexture(), enableDepthAndStencil, this._antiAlias, surfaceSelector, mipmapSelector);
                if (mipmapSelector != 0 && this._context.glVersion != 1) { //hack to stop auto generated mipmaps
                    targetStage._invalidMipmaps = false;
                    targetStage._mipmap = true;
                }
            }
            else {
                this._context.setRenderToBackBuffer();
                this.configureBackBuffer(this._width, this._height, this._antiAlias, this._enableDepthAndStencil);
            }
        };
        Stage.prototype.copyPixels = function (source, target, rect, destPoint, alphaBitmapData, alphaPoint, mergeAlpha) {
            if (alphaBitmapData === void 0) { alphaBitmapData = null; }
            if (alphaPoint === void 0) { alphaPoint = null; }
            if (mergeAlpha === void 0) { mergeAlpha = false; }
            //early out for values that won't produce any visual update
            if (destPoint.x < -rect.width || destPoint.x > target.width || destPoint.y < -rect.height || destPoint.y > target.height)
                return;
            if (mergeAlpha) {
                if (!this._renderToTextureVertexBuffer) {
                    this._renderToTextureVertexBuffer = this._context.createVertexBuffer(4, 20);
                    this._renderToTextureVertexBuffer.uploadFromArray(new Float32Array([-1, -1, 0, 0, 0, 1, -1, 1, 0, 1, 1, 1, 1, 1, 2, -1, 1, 0, 1, 3]), 0, 4);
                }
                if (!this._indexBuffer) {
                    this._indexBuffer = this._context.createIndexBuffer(6);
                    this._indexBuffer.uploadFromArray(new Uint16Array([2, 1, 0, 3, 2, 0]), 0, 6);
                }
                if (!this._copyPixelFilter) {
                    this._copyPixelFilter = new CopyPixelFilter3D();
                    this._copyPixelSampler = new ImageSampler(false, false, false);
                }
                this._copyPixelFilter.sourceTexture = source;
                this._copyPixelFilter.rect = rect;
                this._copyPixelFilter.destPoint = destPoint;
                this._copyPixelFilter.setRenderTargets(target, this);
                //render
                var indexBuffer = this._indexBuffer;
                var vertexBuffer = this._renderToTextureVertexBuffer;
                var tasks = this._copyPixelFilter.tasks;
                var len = tasks.length;
                if (len > 1 || tasks[0].target) {
                    this._context.setProgram(tasks[0].getProgram(this));
                    this._context.setVertexBufferAt(tasks[0]._positionIndex, vertexBuffer, 0, ContextGLVertexBufferFormat.FLOAT_2);
                    this._context.setVertexBufferAt(tasks[0]._uvIndex, vertexBuffer, 8, ContextGLVertexBufferFormat.FLOAT_2);
                }
                for (var i = 0; i < len; ++i) {
                    var task = tasks[i];
                    this.setRenderTarget(task.target, false);
                    this.setScissor(null);
                    this._context.setProgram(task.getProgram(this));
                    this._context.setDepthTest(false, ContextGLCompareMode.LESS_EQUAL);
                    this.getAbstraction(task.getMainInputTexture(this)).activate(task._inputTextureIndex, this._copyPixelSampler);
                    if (!task.target) {
                        vertexBuffer = this._renderToTextureVertexBuffer;
                        this._context.setVertexBufferAt(task._positionIndex, vertexBuffer, 0, ContextGLVertexBufferFormat.FLOAT_2);
                        this._context.setVertexBufferAt(task._uvIndex, vertexBuffer, 8, ContextGLVertexBufferFormat.FLOAT_2);
                    }
                    task.activate(this, null, null);
                    this._context.drawIndices(ContextGLDrawMode.TRIANGLES, indexBuffer, 0, 6);
                    task.deactivate(this);
                }
                this._context.setDepthTest(true, ContextGLCompareMode.LESS_EQUAL);
                this._context.setTextureAt(0, null);
                this._context.setVertexBufferAt(0, null);
                this._context.setVertexBufferAt(1, null);
            }
            else {
                var rect = rect.clone();
                var destPoint = destPoint.clone();
                if (destPoint.x < 0) {
                    rect.x -= destPoint.x;
                    rect.width += destPoint.x;
                    destPoint.x = 0;
                }
                if (destPoint.y < 0) {
                    rect.y -= destPoint.y;
                    rect.height += destPoint.y;
                    destPoint.y = 0;
                }
                if (rect.width > target.width - destPoint.x)
                    rect.width = target.width - destPoint.x;
                if (rect.height > target.height - destPoint.y)
                    rect.height = target.height - destPoint.y;
                this.setRenderTarget(source, false);
                this.setScissor(null);
                var targetStage = this.getAbstraction(target);
                this._context.copyToTexture(targetStage.getTexture(), rect, destPoint);
            }
        };
        Stage.prototype.getAbstraction = function (asset) {
            return (this._abstractionPool[asset.id] || (this._abstractionPool[asset.id] = new Stage._abstractionClassPool[asset.assetType](asset, this)));
        };
        /**
         *
         * @param image
         */
        Stage.prototype.clearAbstraction = function (asset) {
            delete this._abstractionPool[asset.id];
        };
        /**
         *
         * @param imageObjectClass
         */
        Stage.registerAbstraction = function (abstractionClass, assetClass) {
            Stage._abstractionClassPool[assetClass.assetType] = abstractionClass;
        };
        /**
         * Requests a Context object to attach to the managed gl canvas.
         */
        Stage.prototype.requestContext = function (forceSoftware, profile, mode, alpha) {
            // If forcing software, we can be certain that the
            // returned Context will be running software mode.
            // If not, we can't be sure and should stick to the
            // old value (will likely be same if re-requesting.)
            if (forceSoftware === void 0) { forceSoftware = false; }
            if (profile === void 0) { profile = ContextGLProfile.BASELINE; }
            if (mode === void 0) { mode = ContextMode.AUTO; }
            if (alpha === void 0) { alpha = false; }
            if (this._usesSoftwareRendering != null)
                this._usesSoftwareRendering = forceSoftware;
            this._profile = profile;
            try {
                if (mode == ContextMode.SOFTWARE)
                    this._context = new ContextSoftware(this._container);
                else if (mode == ContextMode.GLES)
                    this._context = new ContextGLES(this._container);
                else
                    this._context = new ContextWebGL(this._container, alpha);
            }
            catch (e) {
                this.dispatchEvent(new StageEvent(StageEvent.STAGE_ERROR, this));
            }
            if (this._context)
                this._callback(this._context);
        };
        Object.defineProperty(Stage.prototype, "width", {
            /**
             * The width of the gl canvas
             */
            get: function () {
                this._sizeDirty = false;
                return this._width;
            },
            set: function (val) {
                if (this._width == val)
                    return;
                this._container.style.width = val + "px";
                this._container.width = val * this._context.pixelRatio;
                this._width = val;
                this._backBufferDirty = true;
                this._invalidateSize();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "height", {
            /**
             * The height of the gl canvas
             */
            get: function () {
                this._sizeDirty = false;
                return this._height;
            },
            set: function (val) {
                if (this._height == val)
                    return;
                this._container.style.height = val + "px";
                this._container.height = val * this._context.pixelRatio;
                this._height = val;
                this._backBufferDirty = true;
                this._invalidateSize();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "x", {
            /**
             * The x position of the gl canvas
             */
            get: function () {
                return this._x;
            },
            set: function (val) {
                if (this._x == val)
                    return;
                CSS.setElementX(this._container, val);
                this._x = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "y", {
            /**
             * The y position of the gl canvas
             */
            get: function () {
                return this._y;
            },
            set: function (val) {
                if (this._y == val)
                    return;
                CSS.setElementY(this._container, val);
                this._y = val;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "visible", {
            get: function () {
                return CSS.getElementVisibility(this._container);
            },
            set: function (val) {
                CSS.setElementVisibility(this._container, val);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "container", {
            get: function () {
                return this._container;
            },
            set: function (value) {
                this._container = value;
                if (this._context) {
                    this._context.container = this._container;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "context", {
            /**
             * The Context object associated with the given stage object.
             */
            get: function () {
                return this._context;
            },
            enumerable: true,
            configurable: true
        });
        Stage.prototype._invalidateSize = function () {
            if (this._sizeDirty)
                return;
            this._sizeDirty = true;
            this.dispatchEvent(new StageEvent(StageEvent.INVALIDATE_SIZE, this));
        };
        Object.defineProperty(Stage.prototype, "profile", {
            get: function () {
                return this._profile;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Disposes the Stage object, freeing the Context attached to the Stage.
         */
        Stage.prototype.dispose = function () {
            for (var id in this._abstractionPool) {
                if (this._abstractionPool[id].clear)
                    this._abstractionPool[id].clear();
            }
            this._abstractionPool = {};
            this._stageManager.iRemoveStage(this);
            this.freeContext();
            this._stageManager = null;
            this._stageIndex = -1;
        };
        /**
         * Configures the back buffer associated with the Stage object.
         * @param backBufferWidth The width of the backbuffer.
         * @param backBufferHeight The height of the backbuffer.
         * @param antiAlias The amount of anti-aliasing to use.
         * @param enableDepthAndStencil Indicates whether the back buffer contains a depth and stencil buffer.
         */
        Stage.prototype.configureBackBuffer = function (backBufferWidth, backBufferHeight, antiAlias, enableDepthAndStencil) {
            this.width = backBufferWidth;
            this.height = backBufferHeight;
            this._antiAlias = antiAlias;
            this._enableDepthAndStencil = enableDepthAndStencil;
            if (this._context)
                this._context.configureBackBuffer(backBufferWidth, backBufferHeight, antiAlias, enableDepthAndStencil);
        };
        Object.defineProperty(Stage.prototype, "enableDepthAndStencil", {
            /*
             * Indicates whether the depth and stencil buffer is used
             */
            get: function () {
                return this._enableDepthAndStencil;
            },
            set: function (enableDepthAndStencil) {
                if (this._enableDepthAndStencil == enableDepthAndStencil)
                    return;
                this._enableDepthAndStencil = enableDepthAndStencil;
                this._backBufferDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "renderSurfaceSelector", {
            get: function () {
                return this._renderSurfaceSelector;
            },
            enumerable: true,
            configurable: true
        });
        /*
         * Clear and reset the back buffer when using a shared context
         */
        Stage.prototype.clear = function (red, green, blue, alpha, depth, stencil, mask) {
            if (red === void 0) { red = 0; }
            if (green === void 0) { green = 0; }
            if (blue === void 0) { blue = 0; }
            if (alpha === void 0) { alpha = 1; }
            if (depth === void 0) { depth = 1; }
            if (stencil === void 0) { stencil = 0; }
            if (mask === void 0) { mask = ContextGLClearMask.ALL; }
            if (!this._context)
                return;
            if (this._backBufferDirty && this._renderTarget == null) {
                this._backBufferDirty = false;
                this.configureBackBuffer(this._width, this._height, this._antiAlias, this._enableDepthAndStencil);
            }
            this._context.clear(red, green, blue, alpha, depth, stencil, mask);
            this._bufferClear = true;
        };
        Object.defineProperty(Stage.prototype, "stageIndex", {
            /**
             * The index of the Stage which is managed by this instance of StageProxy.
             */
            get: function () {
                return this._stageIndex;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "usesSoftwareRendering", {
            /**
             * Indicates whether the Stage managed by this proxy is running in software mode.
             * Remember to wait for the CONTEXT_CREATED event before checking this property,
             * as only then will it be guaranteed to be accurate.
             */
            get: function () {
                return this._usesSoftwareRendering;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "antiAlias", {
            /**
             * The antiAliasing of the Stage.
             */
            get: function () {
                return this._antiAlias;
            },
            set: function (antiAlias) {
                if (this._antiAlias == antiAlias)
                    return;
                this._antiAlias = antiAlias;
                this._backBufferDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "color", {
            /**
             * The background color of the Stage.
             */
            get: function () {
                return this._color;
            },
            set: function (color) {
                this._color = color;
            },
            enumerable: true,
            configurable: true
        });
        Stage.prototype.registerProgram = function (programData) {
            var i = 0;
            while (this._programData[i] != null)
                i++;
            this._programData[i] = programData;
            programData.id = i;
        };
        Stage.prototype.unRegisterProgram = function (programData) {
            this._programData[programData.id] = null;
            programData.id = -1;
        };
        /**
         * Frees the Context associated with this StageProxy.
         */
        Stage.prototype.freeContext = function () {
            if (this._context) {
                this._context.dispose();
                this.dispatchEvent(new StageEvent(StageEvent.CONTEXT_DISPOSED, this));
            }
            this._context = null;
            this._initialised = false;
        };
        Stage.prototype.onContextLost = function (event) {
        };
        Stage.prototype.onContextRestored = function (event) {
        };
        Stage.prototype.recoverFromDisposal = function () {
            if (!this._context)
                return false;
            //away.Debug.throwPIR( 'StageProxy' , 'recoverFromDisposal' , '' );
            /*
             if (this._iContext.driverInfo == "Disposed")
             {
             this._iContext = null;
             this.dispatchEvent(new StageEvent(StageEvent.CONTEXT_DISPOSED));
             return false;

             }
             */
            return true;
        };
        Stage.prototype._callback = function (context) {
            this._context = context;
            this._container = this._context.container;
            // Only configure back buffer if width and height have been set,
            // which they may not have been if View.render() has yet to be
            // invoked for the first time.
            if (this._width && this._height)
                this._context.configureBackBuffer(this._width, this._height, this._antiAlias, this._enableDepthAndStencil);
            // Dispatch the appropriate event depending on whether context was
            // created for the first time or recreated after a device loss.
            this.dispatchEvent(new StageEvent(this._initialised ? StageEvent.CONTEXT_RECREATED : StageEvent.CONTEXT_CREATED, this));
            this._initialised = true;
        };
        Stage.prototype.setVertexBuffer = function (index, buffer, size, dimensions, offset, unsigned) {
            if (unsigned === void 0) { unsigned = false; }
            this._context.setVertexBufferAt(index, buffer, offset, this._bufferFormatDictionary[unsigned ? size + 4 : size][dimensions]);
        };
        Stage.prototype.setScissor = function (rectangle) {
            if (this._backBufferDirty && this._renderTarget == null) {
                this._backBufferDirty = false;
                this.configureBackBuffer(this._width, this._height, this._antiAlias, this._enableDepthAndStencil);
            }
            this._context.setScissorRectangle(rectangle);
        };
        Stage.prototype.setSamplerAt = function (index, sampler) {
            var wrap = sampler.repeat ? ContextGLWrapMode.REPEAT : ContextGLWrapMode.CLAMP;
            var filter = (sampler.smooth && !this.globalDisableSmooth) ? ContextGLTextureFilter.LINEAR : ContextGLTextureFilter.NEAREST;
            var mipfilter = (sampler.mipmap && !this.globalDisableMipmap) ? ContextGLMipFilter.MIPLINEAR : ContextGLMipFilter.MIPNONE;
            this._context.setSamplerStateAt(index, wrap, filter, mipfilter);
        };
        Stage._abstractionClassPool = new Object();
        return Stage;
    }(EventDispatcher));

    var ImageCube = /** @class */ (function (_super) {
        __extends$2(ImageCube, _super);
        /**
         *
         */
        function ImageCube(size) {
            var _this = _super.call(this) || this;
            _this._size = size;
            _this._testDimensions();
            return _this;
        }
        Object.defineProperty(ImageCube.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return ImageCube.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ImageCube.prototype, "size", {
            /**
             * The size of the cube bitmap in pixels.
             */
            get: function () {
                return this._size;
            },
            set: function (value) {
                if (this._size == value)
                    return;
                this._setSize(this._size);
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         * @param width
         * @param height
         * @private
         */
        ImageCube.prototype._setSize = function (size) {
            if (this._size != size)
                this.clear();
            this._size = size;
            this._testDimensions();
        };
        /**
         *
         * @private
         */
        ImageCube.prototype._testDimensions = function () {
            if (!ImageUtils.isDimensionValid(this._size))
                throw new Error("Invalid dimension: Width and height must be power of 2 and cannot exceed 2048");
        };
        ImageCube.assetType = "[image ImageCube]";
        return ImageCube;
    }(ImageBase));
    /**
     *
     * @class away.pool.GL_ImageCubeBase
     */
    var _Stage_ImageCube = /** @class */ (function (_super) {
        __extends$2(_Stage_ImageCube, _super);
        function _Stage_ImageCube() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        _Stage_ImageCube.prototype.getType = function () {
            return "cube";
        };
        /**
         *
         * @param context
         * @returns {ITexture}
         */
        _Stage_ImageCube.prototype._createTexture = function () {
            this._texture = this._stage.context.createCubeTexture(this._asset.size, ContextGLTextureFormat.BGRA, false);
        };
        return _Stage_ImageCube;
    }(_Stage_ImageBase));
    Stage.registerAbstraction(_Stage_ImageCube, ImageCube);

    var BitmapImageUtils = /** @class */ (function () {
        function BitmapImageUtils() {
        }
        BitmapImageUtils.drawBitmap = function (source, offsetX, offsetY, width, height, canvas, canvasOffsetX, canvasOffsetY, canvasImageWidth, canvasImageHeight, matrix) {
            if (matrix === void 0) { matrix = null; }
            if (matrix || (canvasImageWidth != width || canvasImageHeight != height)) {
                if (!matrix) {
                    matrix = new Matrix();
                    matrix.scale(canvasImageWidth / width, canvasImageHeight / height);
                }
                var scaleX = Math.sqrt(matrix.a * matrix.a + matrix.b * matrix.b);
                var scaleY = Math.sqrt(matrix.c * matrix.c + matrix.d * matrix.d);
                var canvasWidth = width * scaleX;
                var canvasHeight = height * scaleY;
                matrix.tx += canvasOffsetX;
                matrix.ty += canvasOffsetY;
                var canvasOffsetX = Math.floor(matrix.tx);
                var canvasOffsetY = Math.floor(matrix.ty);
                matrix.invert();
                if (scaleX >= 1 || scaleY >= 1) {
                    var p = new Point();
                    for (var i = canvasOffsetX; i < canvasOffsetX + canvasWidth; i++) {
                        for (var j = canvasOffsetY; j < canvasOffsetY + canvasHeight; j++) {
                            p.x = i;
                            p.y = j;
                            p = matrix.transformPoint(p);
                            var color = BitmapImageUtils.sampleBilinear(p.x, p.y, source, width, height);
                            BitmapImageUtils.applyPixel32(canvas, canvasImageWidth, canvasImageHeight, i, j, color);
                        }
                    }
                }
                else {
                    //decimate
                    var p1 = new Point();
                    var p2 = new Point();
                    for (var i = canvasOffsetX; i < canvasOffsetX + canvasWidth; i++) {
                        for (var j = canvasOffsetY; j < canvasOffsetY + canvasHeight; j++) {
                            p1.x = i;
                            p1.y = j;
                            p1 = matrix.transformPoint(p1);
                            p2.x = i + 1;
                            p2.y = j + 1;
                            p2 = matrix.transformPoint(p2);
                            var color = BitmapImageUtils.sampleBox(p1.x + offsetX, p1.y + offsetY, p2.x + offsetX, p2.y + offsetY, source, width, height);
                            BitmapImageUtils.applyPixel32(canvas, canvasImageWidth, canvasImageHeight, i, j, color);
                        }
                    }
                }
                matrix.invert();
            }
            else {
                for (var i = canvasOffsetX; i < canvasOffsetX + canvasWidth; i++) {
                    for (var j = canvasOffsetY; j < canvasOffsetY + canvasHeight; j++) {
                        var color = BitmapImageUtils.sample(i - canvasOffsetX + offsetX, j - canvasOffsetY + offsetY, source, width, height);
                        BitmapImageUtils.applyPixel32(canvas, canvasImageWidth, canvasImageHeight, i, j, color);
                    }
                }
            }
        };
        BitmapImageUtils.applyPixel32 = function (data, width, height, x, y, color) {
            //todo: blending support
            x = Math.floor(x);
            y = Math.floor(y);
            if (x < 0 || x >= width || y >= height || y < 0)
                return;
            var index = (x + y * width) * 4;
            //var alpha:number = color[3] / 255;
            // target.data[index] += color[0];
            // target.data[index + 1] += color[1];
            // target.data[index + 2] += color[2];
            // target.data[index + 3] += color[3];
            data[index] = color[0];
            data[index + 1] = color[1];
            data[index + 2] = color[2];
            data[index + 3] = color[3];
            data[index] = data[index] & 0xFF;
            data[index + 1] = data[index + 1] & 0xFF;
            data[index + 2] = data[index + 2] & 0xFF;
            data[index + 3] = data[index + 3] & 0xFF;
        };
        BitmapImageUtils.sampleBilinear = function (u, v, data, width, height, texelSizeX, texelSizeY) {
            if (texelSizeX === void 0) { texelSizeX = 1; }
            if (texelSizeY === void 0) { texelSizeY = 1; }
            var color00 = BitmapImageUtils.sample(u, v, data, width, height);
            var color10 = BitmapImageUtils.sample(u + texelSizeX, v, data, width, height);
            var color01 = BitmapImageUtils.sample(u, v + texelSizeY, data, width, height);
            var color11 = BitmapImageUtils.sample(u + texelSizeX, v + texelSizeY, data, width, height);
            var a = u;
            a = a - Math.floor(a);
            var interColor0 = BitmapImageUtils.interpolateColor(color00, color10, a);
            var interColor1 = BitmapImageUtils.interpolateColor(color01, color11, a);
            var b = v;
            b = b - Math.floor(b);
            return BitmapImageUtils.interpolateColor(interColor0, interColor1, b);
        };
        BitmapImageUtils.sample = function (u, v, data, width, height) {
            u = Math.floor(u);
            v = Math.floor(v);
            var result = [0, 0, 0, 0];
            if (u < 0 || u >= width || v < 0 || v >= height) {
                return result;
            }
            var index = (u + v * width) * 4;
            result[0] = data[index];
            result[1] = data[index + 1];
            result[2] = data[index + 2];
            result[3] = data[index + 3];
            return result;
        };
        BitmapImageUtils.sampleBox = function (x0, y0, x1, y1, data, width, height) {
            var area = 0; // -- total area accumulated in pixels
            var result = [0, 0, 0, 0];
            var x;
            var y;
            var xsize;
            var ysize;
            var fromY = Math.floor(y0);
            var toY = Math.ceil(y1);
            fromY = Math.max(Math.min(fromY, height - 1), 0);
            toY = Math.max(Math.min(toY, height - 1), 0);
            for (y = fromY; y < toY; y++) {
                ysize = 1;
                if (y < y0) {
                    ysize = ysize * (1.0 - (y0 - y));
                }
                if (y > y1) {
                    ysize = ysize * (1.0 - (y - y1));
                }
                var fromX = Math.floor(x0);
                var toX = Math.ceil(x1);
                fromX = Math.max(Math.min(fromX, width - 1), 0);
                toX = Math.max(Math.min(toX, width - 1), 0);
                for (x = fromX; x < toX; x++) {
                    xsize = ysize;
                    var color = BitmapImageUtils.sample(x, y, data, width, height);
                    if (x < x0) {
                        xsize = xsize * (1.0 - (x0 - x));
                    }
                    if (x > x1) {
                        xsize = xsize * (1.0 - (x - x1));
                    }
                    result[0] += color[0] * xsize;
                    result[1] += color[1] * xsize;
                    result[2] += color[2] * xsize;
                    result[3] += color[3] * xsize;
                    area = area + xsize;
                }
            }
            result[0] /= area;
            result[1] /= area;
            result[2] /= area;
            result[3] /= area;
            result[0] = result[0] & 0xFF;
            result[1] = result[1] & 0xFF;
            result[2] = result[2] & 0xFF;
            result[3] = result[3] & 0xFF;
            return result;
        };
        BitmapImageUtils.interpolateColor = function (source, target, a) {
            var result = [];
            result[0] = source[0] + (target[0] - source[0]) * a;
            result[1] = source[1] + (target[1] - source[1]) * a;
            result[2] = source[2] + (target[2] - source[2]) * a;
            result[3] = source[3] + (target[3] - source[3]) * a;
            return result;
        };
        return BitmapImageUtils;
    }());

    /**
     * The BitmapImage2D export class lets you work with the data(pixels) of a Bitmap
     * object. You can use the methods of the BitmapImage2D export class to create
     * arbitrarily sized transparent or opaque bitmap images and manipulate them
     * in various ways at runtime. You can also access the BitmapImage2D for a bitmap
     * image that you load with the <code>flash.Assets</code> or
     * <code>flash.display.Loader</code> classes.
     *
     * <p>This export class lets you separate bitmap rendering operations from the
     * internal display updating routines of flash. By manipulating a
     * BitmapImage2D object directly, you can create complex images without incurring
     * the per-frame overhead of constantly redrawing the content from vector
     * data.</p>
     *
     * <p>The methods of the BitmapImage2D export class support effects that are not
     * available through the filters available to non-bitmap display objects.</p>
     *
     * <p>A BitmapImage2D object contains an array of pixel data. This data can
     * represent either a fully opaque bitmap or a transparent bitmap that
     * contains alpha channel data. Either type of BitmapImage2D object is stored as
     * a buffer of 32-bit integers. Each 32-bit integer determines the properties
     * of a single pixel in the bitmap.</p>
     *
     * <p>Each 32-bit integer is a combination of four 8-bit channel values(from
     * 0 to 255) that describe the alpha transparency and the red, green, and blue
     * (ARGB) values of the pixel.(For ARGB values, the most significant byte
     * represents the alpha channel value, followed by red, green, and blue.)</p>
     *
     * <p>The four channels(alpha, red, green, and blue) are represented as
     * numbers when you use them with the <code>BitmapImage2D.copyChannel()</code>
     * method or the <code>DisplacementMapFilter.componentX</code> and
     * <code>DisplacementMapFilter.componentY</code> properties, and these numbers
     * are represented by the following constants in the BitmapImage2DChannel
     * class:</p>
     *
     * <ul>
     *   <li><code>BitmapImage2DChannel.ALPHA</code></li>
     *   <li><code>BitmapImage2DChannel.RED</code></li>
     *   <li><code>BitmapImage2DChannel.GREEN</code></li>
     *   <li><code>BitmapImage2DChannel.BLUE</code></li>
     * </ul>
     *
     * <p>You can attach BitmapImage2D objects to a Bitmap object by using the
     * <code>bitmapData</code> property of the Bitmap object.</p>
     *
     * <p>You can use a BitmapImage2D object to fill a Graphics object by using the
     * <code>Graphics.beginBitmapFill()</code> method.</p>
     *
     * <p>You can also use a BitmapImage2D object to perform batch tile rendering
     * using the <code>flash.display.Tilesheet</code> class.</p>
     *
     * <p>In Flash Player 10, the maximum size for a BitmapImage2D object
     * is 8,191 pixels in width or height, and the total number of pixels cannot
     * exceed 16,777,215 pixels.(So, if a BitmapImage2D object is 8,191 pixels wide,
     * it can only be 2,048 pixels high.) In Flash Player 9 and earlier, the limitation
     * is 2,880 pixels in height and 2,880 in width.</p>
     */
    var BitmapImageCube = /** @class */ (function (_super) {
        __extends$2(BitmapImageCube, _super);
        /**
         * Creates a BitmapImage2D object with a specified width and height. If you
         * specify a value for the <code>fillColor</code> parameter, every pixel in
         * the bitmap is set to that color.
         *
         * <p>By default, the bitmap is created as transparent, unless you pass
         * the value <code>false</code> for the transparent parameter. After you
         * create an opaque bitmap, you cannot change it to a transparent bitmap.
         * Every pixel in an opaque bitmap uses only 24 bits of color channel
         * information. If you define the bitmap as transparent, every pixel uses 32
         * bits of color channel information, including an alpha transparency
         * channel.</p>
         *
         * @param width       The width of the bitmap image in pixels.
         * @param height      The height of the bitmap image in pixels.
         * @param transparent Specifies whether the bitmap image supports per-pixel
         *                    transparency. The default value is <code>true</code>
         *                    (transparent). To create a fully transparent bitmap,
         *                    set the value of the <code>transparent</code>
         *                    parameter to <code>true</code> and the value of the
         *                    <code>fillColor</code> parameter to 0x00000000(or to
         *                    0). Setting the <code>transparent</code> property to
         *                    <code>false</code> can result in minor improvements
         *                    in rendering performance.
         * @param fillColor   A 32-bit ARGB color value that you use to fill the
         *                    bitmap image area. The default value is
         *                    0xFFFFFFFF(solid white).
         */
        function BitmapImageCube(size, transparent, fillColor) {
            if (transparent === void 0) { transparent = true; }
            if (fillColor === void 0) { fillColor = null; }
            var _this = _super.call(this, size) || this;
            _this._data = new Array(6);
            _this._locked = false;
            _this._transparent = transparent;
            for (var i = 0; i < 6; i++) {
                _this._data[i] = new Uint8ClampedArray(4 * _this._size * _this._size);
                if (fillColor != null)
                    _this.fillRect(i, new Rectangle(0, 0, size, size), fillColor);
            }
            return _this;
        }
        Object.defineProperty(BitmapImageCube.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return BitmapImageCube.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BitmapImageCube.prototype, "transparent", {
            /**
             * Defines whether the bitmap image supports per-pixel transparency. You can
             * set this value only when you construct a BitmapImage2D object by passing in
             * <code>true</code> for the <code>transparent</code> parameter of the
             * constructor. Then, after you create a BitmapImage2D object, you can check
             * whether it supports per-pixel transparency by determining if the value of
             * the <code>transparent</code> property is <code>true</code>.
             */
            get: function () {
                return this._transparent;
            },
            set: function (value) {
                this._transparent = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns a new BitmapImage2D object that is a clone of the original instance
         * with an exact copy of the contained bitmap.
         *
         * @return A new BitmapImage2D object that is identical to the original.
         */
        BitmapImageCube.prototype.clone = function () {
            var t = new BitmapImageCube(this._size, this.transparent);
            for (var i = 0; i < 6; i++) {
                t.setPixels(i, new Rectangle(0, 0, this._size, this._size), this.data[i]);
            }
            return t;
        };
        /**
         * Adjusts the color values in a specified area of a bitmap image by using a
         * <code>ColorTransform</code> object. If the rectangle matches the
         * boundaries of the bitmap image, this method transforms the color values of
         * the entire image.
         *
         * @param rect           A Rectangle object that defines the area of the
         *                       image in which the ColorTransform object is applied.
         * @param colorTransform A ColorTransform object that describes the color
         *                       transformation values to apply.
         */
        BitmapImageCube.prototype.colorTransform = function (side, rect, colorTransform) {
            var i, j, index, data = this.data[side];
            for (i = 0; i < rect.width; ++i) {
                for (j = 0; j < rect.height; ++j) {
                    index = (i + rect.x + (j + rect.y) * this._size) * 4;
                    data[index] = data[index] * colorTransform.redMultiplier + colorTransform.redOffset;
                    data[index + 1] = data[index + 1] * colorTransform.greenMultiplier + colorTransform.greenOffset;
                    data[index + 2] = data[index + 2] * colorTransform.blueMultiplier + colorTransform.blueOffset;
                    data[index + 3] = data[index + 3] * colorTransform.alphaMultiplier + colorTransform.alphaOffset;
                }
            }
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Transfers data from one channel of another BitmapImage2D object or the
         * current BitmapImage2D object into a channel of the current BitmapImage2D object.
         * All of the data in the other channels in the destination BitmapImage2D object
         * are preserved.
         *
         * <p>The source channel value and destination channel value can be one of
         * following values: </p>
         *
         * <ul>
         *   <li><code>BitmapImage2DChannel.RED</code></li>
         *   <li><code>BitmapImage2DChannel.GREEN</code></li>
         *   <li><code>BitmapImage2DChannel.BLUE</code></li>
         *   <li><code>BitmapImage2DChannel.ALPHA</code></li>
         * </ul>
         *
         * @param sourceBitmapImage2D The input bitmap image to use. The source image
         *                         can be a different BitmapImage2D object or it can
         *                         refer to the current BitmapImage2D object.
         * @param sourceRect       The source Rectangle object. To copy only channel
         *                         data from a smaller area within the bitmap,
         *                         specify a source rectangle that is smaller than
         *                         the overall size of the BitmapImage2D object.
         * @param destPoint        The destination Point object that represents the
         *                         upper-left corner of the rectangular area where
         *                         the new channel data is placed. To copy only
         *                         channel data from one area to a different area in
         *                         the destination image, specify a point other than
         *                        (0,0).
         * @param sourceChannel    The source channel. Use a value from the
         *                         BitmapImage2DChannel class
         *                        (<code>BitmapImage2DChannel.RED</code>,
         *                         <code>BitmapImage2DChannel.BLUE</code>,
         *                         <code>BitmapImage2DChannel.GREEN</code>,
         *                         <code>BitmapImage2DChannel.ALPHA</code>).
         * @param destChannel      The destination channel. Use a value from the
         *                         BitmapImage2DChannel class
         *                        (<code>BitmapImage2DChannel.RED</code>,
         *                         <code>BitmapImage2DChannel.BLUE</code>,
         *                         <code>BitmapImage2DChannel.GREEN</code>,
         *                         <code>BitmapImage2DChannel.ALPHA</code>).
         * @throws TypeError The sourceBitmapImage2D, sourceRect or destPoint are null.
         */
        BitmapImageCube.prototype.copyChannel = function (side, sourceBitmap, sourceRect, destPoint, sourceChannel, destChannel) {
            var sourceData = sourceBitmap.data;
            var destData = this._data[side];
            var sourceOffset = Math.round(Math.log(sourceChannel) / Math.log(2));
            var destOffset = Math.round(Math.log(destChannel) / Math.log(2));
            var sourceX = Math.round(sourceRect.x);
            var sourceY = Math.round(sourceRect.y);
            var destX = Math.round(destPoint.x);
            var destY = Math.round(destPoint.y);
            var i, j, sourceIndex, destIndex;
            for (i = 0; i < sourceRect.width; ++i) {
                for (j = 0; j < sourceRect.height; ++j) {
                    sourceIndex = (i + sourceX + (j + sourceY) * sourceBitmap.width) * 4;
                    destIndex = (i + destX + (j + destY) * this._size) * 4;
                    destData[destIndex + destOffset] = sourceData[sourceIndex + sourceOffset];
                }
            }
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Frees memory that is used to store the BitmapImage2D object.
         *
         * <p>When the <code>dispose()</code> method is called on an image, the width
         * and height of the image are set to 0. All subsequent calls to methods or
         * properties of this BitmapImage2D instance fail, and an exception is thrown.
         * </p>
         *
         * <p><code>BitmapImage2D.dispose()</code> releases the memory occupied by the
         * actual bitmap data, immediately(a bitmap can consume up to 64 MB of
         * memory). After using <code>BitmapImage2D.dispose()</code>, the BitmapImage2D
         * object is no longer usable and an exception may be thrown if
         * you call functions on the BitmapImage2D object. However,
         * <code>BitmapImage2D.dispose()</code> does not garbage collect the BitmapImage2D
         * object(approximately 128 bytes); the memory occupied by the actual
         * BitmapImage2D object is released at the time the BitmapImage2D object is
         * collected by the garbage collector.</p>
         *
         */
        BitmapImageCube.prototype.dispose = function () {
            _super.prototype.dispose.call(this);
            for (var i = 0; i < 6; i++)
                this._data[i] = null;
            this._transparent = null;
            this._locked = null;
        };
        /**
         * Draws the <code>source</code> display object onto the bitmap image, using
         * the NME software renderer. You can specify <code>matrix</code>,
         * <code>colorTransform</code>, <code>blendMode</code>, and a destination
         * <code>clipRect</code> parameter to control how the rendering performs.
         * Optionally, you can specify whether the bitmap should be smoothed when
         * scaled(this works only if the source object is a BitmapImage2D object).
         *
         * <p>The source display object does not use any of its applied
         * transformations for this call. It is treated as it exists in the library
         * or file, with no matrix transform, no color transform, and no blend mode.
         * To draw a display object(such as a movie clip) by using its own transform
         * properties, you can copy its <code>transform</code> property object to the
         * <code>transform</code> property of the Bitmap object that uses the
         * BitmapImage2D object.</p>
         *
         * @param source         The display object or BitmapImage2D object to draw to
         *                       the BitmapImage2D object.(The DisplayObject and
         *                       BitmapImage2D classes implement the IBitmapDrawable
         *                       interface.)
         * @param matrix         A Matrix object used to scale, rotate, or translate
         *                       the coordinates of the bitmap. If you do not want to
         *                       apply a matrix transformation to the image, set this
         *                       parameter to an identity matrix, created with the
         *                       default <code>new Matrix()</code> constructor, or
         *                       pass a <code>null</code> value.
         * @param colorTransform A ColorTransform object that you use to adjust the
         *                       color values of the bitmap. If no object is
         *                       supplied, the bitmap image's colors are not
         *                       transformed. If you must pass this parameter but you
         *                       do not want to transform the image, set this
         *                       parameter to a ColorTransform object created with
         *                       the default <code>new ColorTransform()</code>
         *                       constructor.
         * @param blendMode      A string value, from the flash.display.BlendMode
         *                       class, specifying the blend mode to be applied to
         *                       the resulting bitmap.
         * @param clipRect       A Rectangle object that defines the area of the
         *                       source object to draw. If you do not supply this
         *                       value, no clipping occurs and the entire source
         *                       object is drawn.
         * @param smoothing      A Boolean value that determines whether a BitmapImage2D
         *                       object is smoothed when scaled or rotated, due to a
         *                       scaling or rotation in the <code>matrix</code>
         *                       parameter. The <code>smoothing</code> parameter only
         *                       applies if the <code>source</code> parameter is a
         *                       BitmapImage2D object. With <code>smoothing</code> set
         *                       to <code>false</code>, the rotated or scaled
         *                       BitmapImage2D image can appear pixelated or jagged. For
         *                       example, the following two images use the same
         *                       BitmapImage2D object for the <code>source</code>
         *                       parameter, but the <code>smoothing</code> parameter
         *                       is set to <code>true</code> on the left and
         *                       <code>false</code> on the right:
         *
         *                       <p>Drawing a bitmap with <code>smoothing</code> set
         *                       to <code>true</code> takes longer than doing so with
         *                       <code>smoothing</code> set to
         *                       <code>false</code>.</p>
         * @throws ArgumentError The <code>source</code> parameter is not a
         *                       BitmapImage2D or DisplayObject object.
         * @throws ArgumentError The source is null or not a valid IBitmapDrawable
         *                       object.
         * @throws SecurityError The <code>source</code> object and(in the case of a
         *                       Sprite or MovieClip object) all of its child objects
         *                       do not come from the same domain as the caller, or
         *                       are not in a content that is accessible to the
         *                       caller by having called the
         *                       <code>Security.allowDomain()</code> method. This
         *                       restriction does not apply to AIR content in the
         *                       application security sandbox.
         */
        BitmapImageCube.prototype.drawBitmap = function (side, source, offsetX, offsetY, width, height, matrix) {
            if (matrix === void 0) { matrix = null; }
            BitmapImageUtils.drawBitmap(source, offsetX, offsetY, width, height, this.data[side], 0, 0, this._size, this._size, matrix);
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Fills a rectangular area of pixels with a specified ARGB color.
         *
         * @param rect  The rectangular area to fill.
         * @param color The ARGB color value that fills the area. ARGB colors are
         *              often specified in hexadecimal format; for example,
         *              0xFF336699.
         * @throws TypeError The rect is null.
         */
        BitmapImageCube.prototype.fillRect = function (side, rect, color) {
            var data = new Uint32Array(this._data[side].buffer);
            var x = ~~rect.x, y = ~~rect.y, width = ~~rect.width, height = ~~rect.height;
            var argb = this._transparent ? (color & 0xFFFFFFFF) : (color & 0xFFFFFF) + 0xFF000000;
            //fast path for complete fill
            if (x == 0 && y == 0 && width == this._size && height == this._size) {
                data.fill(argb);
            }
            else {
                var j;
                var index;
                for (j = 0; j < height; ++j) {
                    index = x + (j + y) * this._size;
                    data.fill(argb, index, index + width);
                }
            }
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Returns an integer that represents an RGB pixel value from a BitmapImage2D
         * object at a specific point(<i>x</i>, <i>y</i>). The
         * <code>getPixel()</code> method returns an unmultiplied pixel value. No
         * alpha information is returned.
         *
         * <p>All pixels in a BitmapImage2D object are stored as premultiplied color
         * values. A premultiplied image pixel has the red, green, and blue color
         * channel values already multiplied by the alpha data. For example, if the
         * alpha value is 0, the values for the RGB channels are also 0, independent
         * of their unmultiplied values. This loss of data can cause some problems
         * when you perform operations. All BitmapImage2D methods take and return
         * unmultiplied values. The internal pixel representation is converted from
         * premultiplied to unmultiplied before it is returned as a value. During a
         * set operation, the pixel value is premultiplied before the raw image pixel
         * is set.</p>
         *
         * @param x The <i>x</i> position of the pixel.
         * @param y The <i>y</i> position of the pixel.
         * @return A number that represents an RGB pixel value. If the(<i>x</i>,
         *         <i>y</i>) coordinates are outside the bounds of the image, the
         *         method returns 0.
         */
        BitmapImageCube.prototype.getPixel = function (side, x, y) {
            var r;
            var g;
            var b;
            var a;
            var index = (~~x + ~~y * this._size) * 4, data = this.data[side];
            r = data[index + 0];
            g = data[index + 1];
            b = data[index + 2];
            a = data[index + 3];
            //returns black if fully transparent
            if (!a)
                return 0x0;
            return (r * 0xFF / a << 16) | (g * 0xFF / a << 8) | b * 0xFF / a;
        };
        /**
         * Returns an ARGB color value that contains alpha channel data and RGB data.
         * This method is similar to the <code>getPixel()</code> method, which
         * returns an RGB color without alpha channel data.
         *
         * <p>All pixels in a BitmapImage2D object are stored as premultiplied color
         * values. A premultiplied image pixel has the red, green, and blue color
         * channel values already multiplied by the alpha data. For example, if the
         * alpha value is 0, the values for the RGB channels are also 0, independent
         * of their unmultiplied values. This loss of data can cause some problems
         * when you perform operations. All BitmapImage2D methods take and return
         * unmultiplied values. The internal pixel representation is converted from
         * premultiplied to unmultiplied before it is returned as a value. During a
         * set operation, the pixel value is premultiplied before the raw image pixel
         * is set.</p>
         *
         * @param x The <i>x</i> position of the pixel.
         * @param y The <i>y</i> position of the pixel.
         * @return A number representing an ARGB pixel value. If the(<i>x</i>,
         *         <i>y</i>) coordinates are outside the bounds of the image, 0 is
         *         returned.
         */
        BitmapImageCube.prototype.getPixel32 = function (side, x, y) {
            var r;
            var g;
            var b;
            var a;
            var index = (~~x + ~~y * this._size) * 4;
            var data = this.data[side];
            r = data[index++];
            g = data[index++];
            b = data[index++];
            a = data[index];
            if (!a)
                return 0x0;
            return (a << 24) | (r * 0xFF / a << 16) | (g * 0xFF / a << 8) | b * 0xFF / a;
        };
        /**
         * Locks an image so that any objects that reference the BitmapImage2D object,
         * such as Bitmap objects, are not updated when this BitmapImage2D object
         * changes. To improve performance, use this method along with the
         * <code>unlock()</code> method before and after numerous calls to the
         * <code>setPixel()</code> or <code>setPixel32()</code> method.
         *
         */
        BitmapImageCube.prototype.lock = function () {
            if (this._locked)
                return;
            this._locked = true;
        };
        /**
         * Converts an Array into a rectangular region of pixel data. For each pixel,
         * an Array element is read and written into the BitmapImage2D pixel. The data
         * in the Array is expected to be 32-bit ARGB pixel values.
         *
         * @param rect        Specifies the rectangular region of the BitmapImage2D
         *                    object.
         * @param inputArray  An Array that consists of 32-bit unmultiplied pixel
         *                    values to be used in the rectangular region.
         * @throws RangeError The vector array is not large enough to read all the
         *                    pixel data.
         */
        BitmapImageCube.prototype.setArray = function (side, rect, inputArray) {
            var i, j, index, argb, data = this.data[side];
            for (i = 0; i < rect.width; ++i) {
                for (j = 0; j < rect.height; ++j) {
                    argb = ColorUtils.float32ColorToARGB(inputArray[i + j * rect.width]);
                    index = (i + rect.x + (j + rect.y) * this._size) * 4;
                    data[index + 0] = argb[1];
                    data[index + 1] = argb[2];
                    data[index + 2] = argb[3];
                    data[index + 3] = this._transparent ? argb[0] : 0xFF;
                }
            }
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Sets a single pixel of a BitmapImage2D object. The current alpha channel
         * value of the image pixel is preserved during this operation. The value of
         * the RGB color parameter is treated as an unmultiplied color value.
         *
         * <p><b>Note:</b> To increase performance, when you use the
         * <code>setPixel()</code> or <code>setPixel32()</code> method repeatedly,
         * call the <code>lock()</code> method before you call the
         * <code>setPixel()</code> or <code>setPixel32()</code> method, and then call
         * the <code>unlock()</code> method when you have made all pixel changes.
         * This process prevents objects that reference this BitmapImage2D instance from
         * updating until you finish making the pixel changes.</p>
         *
         * @param x     The <i>x</i> position of the pixel whose value changes.
         * @param y     The <i>y</i> position of the pixel whose value changes.
         * @param color The resulting RGB color for the pixel.
         */
        BitmapImageCube.prototype.setPixel = function (side, x, y, color) {
            var index = (~~x + ~~y * this._size) * 4, argb = ColorUtils.float32ColorToARGB(color), data = this.data[side];
            data[index + 0] = argb[1];
            data[index + 1] = argb[2];
            data[index + 2] = argb[3];
            data[index + 3] = 0xff;
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Sets the color and alpha transparency values of a single pixel of a
         * BitmapImage2D object. This method is similar to the <code>setPixel()</code>
         * method; the main difference is that the <code>setPixel32()</code> method
         * takes an ARGB color value that contains alpha channel information.
         *
         * <p>All pixels in a BitmapImage2D object are stored as premultiplied color
         * values. A premultiplied image pixel has the red, green, and blue color
         * channel values already multiplied by the alpha data. For example, if the
         * alpha value is 0, the values for the RGB channels are also 0, independent
         * of their unmultiplied values. This loss of data can cause some problems
         * when you perform operations. All BitmapImage2D methods take and return
         * unmultiplied values. The internal pixel representation is converted from
         * premultiplied to unmultiplied before it is returned as a value. During a
         * set operation, the pixel value is premultiplied before the raw image pixel
         * is set.</p>
         *
         * <p><b>Note:</b> To increase performance, when you use the
         * <code>setPixel()</code> or <code>setPixel32()</code> method repeatedly,
         * call the <code>lock()</code> method before you call the
         * <code>setPixel()</code> or <code>setPixel32()</code> method, and then call
         * the <code>unlock()</code> method when you have made all pixel changes.
         * This process prevents objects that reference this BitmapImage2D instance from
         * updating until you finish making the pixel changes.</p>
         *
         * @param x     The <i>x</i> position of the pixel whose value changes.
         * @param y     The <i>y</i> position of the pixel whose value changes.
         * @param color The resulting ARGB color for the pixel. If the bitmap is
         *              opaque(not transparent), the alpha transparency portion of
         *              this color value is ignored.
         */
        BitmapImageCube.prototype.setPixel32 = function (side, x, y, color) {
            var index = (~~x + ~~y * this._size) * 4, argb = ColorUtils.float32ColorToARGB(color), data = this.data[side];
            data[index + 0] = argb[1];
            data[index + 1] = argb[2];
            data[index + 2] = argb[3];
            data[index + 3] = this._transparent ? argb[0] : 0xFF;
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Converts a byte array into a rectangular region of pixel data. For each
         * pixel, the <code>ByteArray.readUnsignedInt()</code> method is called and
         * the return value is written into the pixel. If the byte array ends before
         * the full rectangle is written, the function returns. The data in the byte
         * array is expected to be 32-bit ARGB pixel values. No seeking is performed
         * on the byte array before or after the pixels are read.
         *
         * @param rect           Specifies the rectangular region of the BitmapImage2D
         *                       object.
         * @param inputByteArray A ByteArray object that consists of 32-bit
         *                       unmultiplied pixel values to be used in the
         *                       rectangular region.
         * @throws EOFError  The <code>inputByteArray</code> object does not include
         *                   enough data to fill the area of the <code>rect</code>
         *                   rectangle. The method fills as many pixels as possible
         *                   before throwing the exception.
         * @throws TypeError The rect or inputByteArray are null.
         */
        BitmapImageCube.prototype.setPixels = function (side, rect, input) {
            //fast path for full imageData
            if (rect.x == 0 && rect.y == 0 && rect.width == this._size && rect.height == this._size) {
                this._data[side].set(input);
            }
            else {
                var i, imageSize = this._size, inputWidth = rect.width, data = this._data[side];
                for (i = 0; i < rect.height; ++i)
                    data.set(input.subarray(i * inputWidth * 4, (i + 1) * inputWidth * 4), (rect.x + (i + rect.y) * imageSize) * 4);
            }
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Unlocks an image so that any objects that reference the BitmapImage2D object,
         * such as Bitmap objects, are updated when this BitmapImage2D object changes.
         * To improve performance, use this method along with the <code>lock()</code>
         * method before and after numerous calls to the <code>setPixel()</code> or
         * <code>setPixel32()</code> method.
         *
         * @param changeRect The area of the BitmapImage2D object that has changed. If
         *                   you do not specify a value for this parameter, the
         *                   entire area of the BitmapImage2D object is considered
         *                   changed.
         */
        BitmapImageCube.prototype.unlock = function () {
            if (!this._locked)
                return;
            this._locked = false;
            this.invalidate();
        };
        Object.defineProperty(BitmapImageCube.prototype, "data", {
            /**
             *
             * @returns {ImageData}
             */
            get: function () {
                return this._data;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         * @param width
         * @param height
         * @private
         */
        BitmapImageCube.prototype._setSize = function (size) {
            for (var i = 0; i < 6; i++) {
                var data = this.data[i];
                this._data[i] = new Uint8ClampedArray(4 * size * size);
                var inputSize = (this._size < size) ? this._size : size;
                for (var j = 0; j < inputSize; ++i)
                    this._data[i].set(data.subarray(j * inputSize * 4, (j + 1) * inputSize * 4), j * size * 4);
            }
            _super.prototype._setSize.call(this, size);
        };
        BitmapImageCube.assetType = "[image BitmapImageCube]";
        BitmapImageCube.posX = 0;
        BitmapImageCube.negX = 1;
        BitmapImageCube.posY = 2;
        BitmapImageCube.negY = 3;
        BitmapImageCube.posZ = 4;
        BitmapImageCube.negZ = 5;
        return BitmapImageCube;
    }(ImageCube));
    /**
     *
     * @class away.pool.ImageObjectBase
     */
    var _Stage_BitmapImageCube = /** @class */ (function (_super) {
        __extends$2(_Stage_BitmapImageCube, _super);
        function _Stage_BitmapImageCube() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        _Stage_BitmapImageCube.prototype.getTexture = function () {
            _super.prototype.getTexture.call(this);
            if (this._invalid) {
                this._invalid = false;
                for (var i = 0; i < 6; ++i)
                    this._texture.uploadFromArray(new Uint8Array(this._asset.data[i].buffer), i, 0);
                this._invalidMipmaps = true;
            }
            return this._texture;
        };
        return _Stage_BitmapImageCube;
    }(_Stage_ImageCube));
    Stage.registerAbstraction(_Stage_BitmapImageCube, BitmapImageCube);

    var DefaultGraphicsFactory = /** @class */ (function () {
        function DefaultGraphicsFactory() {
        }
        DefaultGraphicsFactory.prototype.createImage2D = function (width, height, transparent, fillColor, powerOfTwo) {
            if (transparent === void 0) { transparent = true; }
            if (fillColor === void 0) { fillColor = null; }
            if (powerOfTwo === void 0) { powerOfTwo = true; }
            return new BitmapImage2D(width, height, transparent, fillColor, powerOfTwo);
        };
        return DefaultGraphicsFactory;
    }());

    var ImageUtils = /** @class */ (function () {
        function ImageUtils() {
        }
        /**
         *
         */
        ImageUtils.imageToBitmapImage2D = function (img, powerOfTwo, factory) {
            if (powerOfTwo === void 0) { powerOfTwo = true; }
            if (factory === void 0) { factory = null; }
            if (!factory)
                factory = new DefaultGraphicsFactory();
            var image2D = factory.createImage2D(img.naturalWidth, img.naturalHeight, true, null, powerOfTwo);
            var canvas = document.createElement("canvas");
            canvas.width = img.naturalWidth;
            canvas.height = img.naturalHeight;
            var context = canvas.getContext("2d");
            context.drawImage(img, 0, 0);
            image2D.setPixels(image2D.rect, context.getImageData(0, 0, img.naturalWidth, img.naturalHeight).data);
            return image2D;
        };
        ImageUtils.isImage2DValid = function (image2D) {
            if (image2D == null)
                return true;
            return this.isDimensionValid(image2D.width, image2D.powerOfTwo) && this.isDimensionValid(image2D.height, image2D.powerOfTwo);
        };
        ImageUtils.isHTMLImageElementValid = function (image) {
            if (image == null)
                return true;
            return this.isDimensionValid(image.width) && this.isDimensionValid(image.height);
        };
        ImageUtils.isDimensionValid = function (d, powerOfTwo) {
            if (powerOfTwo === void 0) { powerOfTwo = true; }
            return d >= 1 && d <= this.MAX_SIZE && (!powerOfTwo || this.isPowerOfTwo(d));
        };
        ImageUtils.isPowerOfTwo = function (value) {
            return value ? ((value & -value) == value) : false;
        };
        ImageUtils.getBestPowerOf2 = function (value) {
            var p = 1;
            while (p < value)
                p <<= 1;
            if (p > this.MAX_SIZE)
                p = this.MAX_SIZE;
            return p;
        };
        ImageUtils.getDefaultImage2D = function () {
            if (!this._defaultBitmapImage2D)
                this.createDefaultImage2D();
            return this._defaultBitmapImage2D;
        };
        ImageUtils.getDefaultImageCube = function () {
            if (!this._defaultBitmapImageCube)
                this.createDefaultImageCube();
            return this._defaultBitmapImageCube;
        };
        ImageUtils.getDefaultSampler = function () {
            if (!this._defaultSampler)
                this.createDefaultSampler();
            return this._defaultSampler;
        };
        ImageUtils.createDefaultImageCube = function () {
            if (!this._defaultBitmapImage2D)
                this.createDefaultImage2D();
            var b = new BitmapImageCube(this._defaultBitmapImage2D.width);
            for (var i = 0; i < 6; i++)
                b.drawBitmap(i, this._defaultBitmapImage2D.data, 0, 0, this._defaultBitmapImage2D.width, this._defaultBitmapImage2D.height);
            this._defaultBitmapImageCube = b;
        };
        ImageUtils.createDefaultImage2D = function () {
            var b = new BitmapImage2D(8, 8, false, 0x000000);
            //create chekerboard
            var i, j;
            for (i = 0; i < 8; i++)
                for (j = 0; j < 8; j++)
                    if ((j & 1) ^ (i & 1))
                        b.setPixel(i, j, 0XFFFFFF);
            this._defaultBitmapImage2D = b;
        };
        ImageUtils.createDefaultSampler = function () {
            this._defaultSampler = new ImageSampler();
        };
        ImageUtils.MAX_SIZE = 8192;
        return ImageUtils;
    }());

    var Image2D = /** @class */ (function (_super) {
        __extends$2(Image2D, _super);
        /**
         *
         */
        function Image2D(width, height, powerOfTwo) {
            if (powerOfTwo === void 0) { powerOfTwo = true; }
            var _this = _super.call(this) || this;
            _this._powerOfTwo = true;
            _this._rect = new Rectangle(0, 0, Math.round(width), Math.round(height));
            _this._powerOfTwo = powerOfTwo;
            _this._testDimensions();
            return _this;
        }
        Object.defineProperty(Image2D.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return Image2D.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Image2D.prototype, "height", {
            /**
             * The height of the image in pixels.
             */
            get: function () {
                return this._rect.height;
            },
            set: function (value) {
                this._setSize(this._rect.width, value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Image2D.prototype, "alphaChannel", {
            get: function () {
                return this._alphaChannel;
            },
            set: function (value) {
                this._alphaChannel = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Image2D.prototype, "rect", {
            /**
             * The rectangle that defines the size and location of the bitmap image. The
             * top and left of the rectangle are 0; the width and height are equal to the
             * width and height in pixels of the BitmapData object.
             */
            get: function () {
                return this._rect;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Image2D.prototype, "width", {
            /**
             * The width of the bitmap image in pixels.
             */
            get: function () {
                return this._rect.width;
            },
            set: function (value) {
                this._setSize(value, this._rect.height);
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         * @param width
         * @param height
         * @private
         */
        Image2D.prototype._setSize = function (width, height) {
            width = Math.round(width);
            height = Math.round(height);
            if (this._rect.width == width && this._rect.height == height)
                return;
            this.clear();
            this._rect.width = width;
            this._rect.height = height;
            this._testDimensions();
        };
        /**
         *
         * @private
         */
        Image2D.prototype._testDimensions = function () {
            if (this._powerOfTwo && (!ImageUtils.isDimensionValid(this._rect.width) || !ImageUtils.isDimensionValid(this._rect.height)))
                throw new Error("Invalid dimension: Width and height must be power of 2 and cannot exceed 2048");
        };
        Object.defineProperty(Image2D.prototype, "powerOfTwo", {
            /**
             * Enable POT texture size validation
             * @returns {boolean}
             */
            get: function () {
                return this._powerOfTwo;
            },
            set: function (value) {
                if (this._powerOfTwo == value)
                    return;
                this._powerOfTwo = value;
                this._testDimensions();
            },
            enumerable: true,
            configurable: true
        });
        Image2D.assetType = "[image Image2D]";
        return Image2D;
    }(ImageBase));
    /**
     *
     * @class away.pool.ImageStateBase
     */
    var _Stage_Image2D = /** @class */ (function (_super) {
        __extends$2(_Stage_Image2D, _super);
        function _Stage_Image2D() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        _Stage_Image2D.prototype.getType = function () {
            return "2d";
        };
        /**
         *
         * @param context
         * @returns {ITexture}
         */
        _Stage_Image2D.prototype._createTexture = function () {
            this._texture = this._stage.context.createTexture(this._asset.width, this._asset.height, ContextGLTextureFormat.BGRA, true);
        };
        return _Stage_Image2D;
    }(_Stage_ImageBase));
    Stage.registerAbstraction(_Stage_Image2D, Image2D);

    /**
     * The BitmapImage2D export class lets you work with the data(pixels) of a Bitmap
     * object. You can use the methods of the BitmapImage2D export class to create
     * arbitrarily sized transparent or opaque bitmap images and manipulate them
     * in various ways at runtime. You can also access the BitmapImage2D for a bitmap
     * image that you load with the <code>flash.Assets</code> or
     * <code>flash.display.Loader</code> classes.
     *
     * <p>This export class lets you separate bitmap rendering operations from the
     * internal display updating routines of flash. By manipulating a
     * BitmapImage2D object directly, you can create complex images without incurring
     * the per-frame overhead of constantly redrawing the content from vector
     * data.</p>
     *
     * <p>The methods of the BitmapImage2D export class support effects that are not
     * available through the filters available to non-bitmap display objects.</p>
     *
     * <p>A BitmapImage2D object contains an array of pixel data. This data can
     * represent either a fully opaque bitmap or a transparent bitmap that
     * contains alpha channel data. Either type of BitmapImage2D object is stored as
     * a buffer of 32-bit integers. Each 32-bit integer determines the properties
     * of a single pixel in the bitmap.</p>
     *
     * <p>Each 32-bit integer is a combination of four 8-bit channel values(from
     * 0 to 255) that describe the alpha transparency and the red, green, and blue
     * (ARGB) values of the pixel.(For ARGB values, the most significant byte
     * represents the alpha channel value, followed by red, green, and blue.)</p>
     *
     * <p>The four channels(alpha, red, green, and blue) are represented as
     * numbers when you use them with the <code>BitmapImage2D.copyChannel()</code>
     * method or the <code>DisplacementMapFilter.componentX</code> and
     * <code>DisplacementMapFilter.componentY</code> properties, and these numbers
     * are represented by the following constants in the BitmapImage2DChannel
     * class:</p>
     *
     * <ul>
     *   <li><code>BitmapImage2DChannel.ALPHA</code></li>
     *   <li><code>BitmapImage2DChannel.RED</code></li>
     *   <li><code>BitmapImage2DChannel.GREEN</code></li>
     *   <li><code>BitmapImage2DChannel.BLUE</code></li>
     * </ul>
     *
     * <p>You can attach BitmapImage2D objects to a Bitmap object by using the
     * <code>bitmapData</code> property of the Bitmap object.</p>
     *
     * <p>You can use a BitmapImage2D object to fill a Graphics object by using the
     * <code>Graphics.beginBitmapFill()</code> method.</p>
     *
     * <p>You can also use a BitmapImage2D object to perform batch tile rendering
     * using the <code>flash.display.Tilesheet</code> class.</p>
     *
     * <p>In Flash Player 10, the maximum size for a BitmapImage2D object
     * is 8,191 pixels in width or height, and the total number of pixels cannot
     * exceed 16,777,215 pixels.(So, if a BitmapImage2D object is 8,191 pixels wide,
     * it can only be 2,048 pixels high.) In Flash Player 9 and earlier, the limitation
     * is 2,880 pixels in height and 2,880 in width.</p>
     */
    var BitmapImage2D = /** @class */ (function (_super) {
        __extends$2(BitmapImage2D, _super);
        /**
         * Creates a BitmapImage2D object with a specified width and height. If you
         * specify a value for the <code>fillColor</code> parameter, every pixel in
         * the bitmap is set to that color.
         *
         * <p>By default, the bitmap is created as transparent, unless you pass
         * the value <code>false</code> for the transparent parameter. After you
         * create an opaque bitmap, you cannot change it to a transparent bitmap.
         * Every pixel in an opaque bitmap uses only 24 bits of color channel
         * information. If you define the bitmap as transparent, every pixel uses 32
         * bits of color channel information, including an alpha transparency
         * channel.</p>
         *
         * @param width       The width of the bitmap image in pixels.
         * @param height      The height of the bitmap image in pixels.
         * @param transparent Specifies whether the bitmap image supports per-pixel
         *                    transparency. The default value is <code>true</code>
         *                    (transparent). To create a fully transparent bitmap,
         *                    set the value of the <code>transparent</code>
         *                    parameter to <code>true</code> and the value of the
         *                    <code>fillColor</code> parameter to 0x00000000(or to
         *                    0). Setting the <code>transparent</code> property to
         *                    <code>false</code> can result in minor improvements
         *                    in rendering performance.
         * @param fillColor   A 32-bit ARGB color value that you use to fill the
         *                    bitmap image area. The default value is
         *                    0xFFFFFFFF(solid white).
         */
        function BitmapImage2D(width, height, transparent, fillColor, powerOfTwo, stage) {
            if (transparent === void 0) { transparent = true; }
            if (fillColor === void 0) { fillColor = null; }
            if (powerOfTwo === void 0) { powerOfTwo = true; }
            if (stage === void 0) { stage = null; }
            var _this = _super.call(this, width, height, powerOfTwo) || this;
            _this._locked = false;
            _this._data = new Uint8ClampedArray(4 * _this._rect.width * _this._rect.height);
            _this._transparent = transparent;
            _this._stage = stage;
            if (fillColor != null && fillColor != 0x0)
                _this.fillRect(_this._rect, fillColor);
            return _this;
        }
        BitmapImage2D.prototype.addMipLevel = function (newLevel) {
            if (!this._customMipLevels)
                this._customMipLevels = [];
            this._customMipLevels.push(newLevel);
        };
        Object.defineProperty(BitmapImage2D.prototype, "mipLevels", {
            get: function () {
                return this._customMipLevels;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BitmapImage2D.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return BitmapImage2D.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BitmapImage2D.prototype, "transparent", {
            /**
             * Defines whether the bitmap image supports per-pixel transparency. You can
             * set this value only when you construct a BitmapImage2D object by passing in
             * <code>true</code> for the <code>transparent</code> parameter of the
             * constructor. Then, after you create a BitmapImage2D object, you can check
             * whether it supports per-pixel transparency by determining if the value of
             * the <code>transparent</code> property is <code>true</code>.
             */
            get: function () {
                return this._transparent;
            },
            set: function (value) {
                this._transparent = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns a new BitmapImage2D object that is a clone of the original instance
         * with an exact copy of the contained bitmap.
         *
         * @return A new BitmapImage2D object that is identical to the original.
         */
        BitmapImage2D.prototype.clone = function () {
            var t = new BitmapImage2D(this._rect.width, this._rect.height, this._transparent, null, this._powerOfTwo);
            t.setPixels(this._rect, this.data);
            return t;
        };
        /**
         * Adjusts the color values in a specified area of a bitmap image by using a
         * <code>ColorTransform</code> object. If the rectangle matches the
         * boundaries of the bitmap image, this method transforms the color values of
         * the entire image.
         *
         * @param rect           A Rectangle object that defines the area of the
         *                       image in which the ColorTransform object is applied.
         * @param colorTransform A ColorTransform object that describes the color
         *                       transformation values to apply.
         */
        BitmapImage2D.prototype.colorTransform = function (rect, colorTransform) {
            var i, j, index, data = this.data;
            for (i = 0; i < rect.width; ++i) {
                for (j = 0; j < rect.height; ++j) {
                    index = (i + rect.x + (j + rect.y) * this._rect.width) * 4;
                    data[index] = data[index] * colorTransform.redMultiplier + colorTransform.redOffset;
                    data[index + 1] = data[index + 1] * colorTransform.greenMultiplier + colorTransform.greenOffset;
                    data[index + 2] = data[index + 2] * colorTransform.blueMultiplier + colorTransform.blueOffset;
                    data[index + 3] = data[index + 3] * colorTransform.alphaMultiplier + colorTransform.alphaOffset;
                }
            }
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Transfers data from one channel of another BitmapImage2D object or the
         * current BitmapImage2D object into a channel of the current BitmapImage2D object.
         * All of the data in the other channels in the destination BitmapImage2D object
         * are preserved.
         *
         * <p>The source channel value and destination channel value can be one of
         * following values: </p>
         *
         * <ul>
         *   <li><code>BitmapImage2DChannel.RED</code></li>
         *   <li><code>BitmapImage2DChannel.GREEN</code></li>
         *   <li><code>BitmapImage2DChannel.BLUE</code></li>
         *   <li><code>BitmapImage2DChannel.ALPHA</code></li>
         * </ul>
         *
         * @param sourceBitmapImage2D The input bitmap image to use. The source image
         *                         can be a different BitmapImage2D object or it can
         *                         refer to the current BitmapImage2D object.
         * @param sourceRect       The source Rectangle object. To copy only channel
         *                         data from a smaller area within the bitmap,
         *                         specify a source rectangle that is smaller than
         *                         the overall size of the BitmapImage2D object.
         * @param destPoint        The destination Point object that represents the
         *                         upper-left corner of the rectangular area where
         *                         the new channel data is placed. To copy only
         *                         channel data from one area to a different area in
         *                         the destination image, specify a point other than
         *                        (0,0).
         * @param sourceChannel    The source channel. Use a value from the
         *                         BitmapImage2DChannel class
         *                        (<code>BitmapImage2DChannel.RED</code>,
         *                         <code>BitmapImage2DChannel.BLUE</code>,
         *                         <code>BitmapImage2DChannel.GREEN</code>,
         *                         <code>BitmapImage2DChannel.ALPHA</code>).
         * @param destChannel      The destination channel. Use a value from the
         *                         BitmapImage2DChannel class
         *                        (<code>BitmapImage2DChannel.RED</code>,
         *                         <code>BitmapImage2DChannel.BLUE</code>,
         *                         <code>BitmapImage2DChannel.GREEN</code>,
         *                         <code>BitmapImage2DChannel.ALPHA</code>).
         * @throws TypeError The sourceBitmapImage2D, sourceRect or destPoint are null.
         */
        BitmapImage2D.prototype.copyChannel = function (sourceBitmap, sourceRect, destPoint, sourceChannel, destChannel) {
            var sourceData = sourceBitmap.data;
            var destData = this.data;
            var sourceOffset = Math.round(Math.log(sourceChannel) / Math.log(2));
            var destOffset = Math.round(Math.log(destChannel) / Math.log(2));
            var sourceX = Math.round(sourceRect.x);
            var sourceY = Math.round(sourceRect.y);
            var destX = Math.round(destPoint.x);
            var destY = Math.round(destPoint.y);
            var i, j, sourceIndex, destIndex;
            for (i = 0; i < sourceRect.width; ++i) {
                for (j = 0; j < sourceRect.height; ++j) {
                    sourceIndex = (i + sourceX + (j + sourceY) * sourceBitmap.width) * 4;
                    destIndex = (i + destX + (j + destY) * this._rect.width) * 4;
                    destData[destIndex + destOffset] = sourceData[sourceIndex + sourceOffset];
                }
            }
            if (!this._locked)
                this.invalidate();
        };
        // public copyPixels(source:BitmapImage2D, sourceRect:Rectangle, destPoint:Point)
        // {
        // 	if (!this._imageData)
        // 		this._imageData = this._context.getImageData(0, 0, this._rect.width, this._rect.height);
        // 	var targetWidth:number = this._rect.width;
        // 	var targetHeight:number = this._rect.height;
        // 	var x:number = (destPoint.x > targetWidth)? targetWidth : ~~destPoint.x;
        // 	var y:number = (destPoint.y > targetHeight)? targetHeight : ~~destPoint.y;
        // 	var sourceData:Uint8ClampedArray = source.getImageData().data;
        // 	var targetData:Uint8ClampedArray = this._imageData.data;
        // 	//fast path for full imageData
        // 	if (sourceRect.equals(this._rect) && !x && !y) {
        // 		targetData.set(sourceData);
        // 	} else {
        // 		var inputWidth:number = source.width;
        // 		var sourceX:number = Math.round(sourceRect.x);
        // 		var sourceY:number = Math.round(sourceRect.y);
        // 		var sourceWidth:number = (sourceRect.width > targetWidth - x)? targetWidth - x : (sourceRect.width > source.rect.width - sourceX)? source.rect.width - sourceX : Math.round(sourceRect.width);
        // 		var sourceHeight:number = (sourceRect.height > targetHeight - y)? targetHeight - y : (sourceRect.height > source.rect.height - sourceY)? source.rect.height - sourceY : Math.round(sourceRect.height);
        // 		if (x < 0) {
        // 			sourceX -= x;
        // 			sourceWidth += x;
        // 			x = 0;
        // 		}
        // 		if (y < 0) {
        // 			sourceY -= y;
        // 			sourceHeight += y;
        // 			y = 0;
        // 		}
        // 		if (sourceX < 0) {
        // 			x -= sourceX;
        // 			sourceWidth += sourceX;
        // 			sourceX = 0;
        // 		}
        // 		if (sourceY < 0) {
        // 			y -= sourceY;
        // 			sourceHeight += sourceY;
        // 			sourceY = 0;
        // 		}
        // 		for (var i:number = 0; i < sourceHeight; ++i)
        // 			targetData.set(sourceData.subarray((sourceX + (i + sourceY)*inputWidth)*4, (sourceX + (i + sourceY)*inputWidth + sourceWidth)*4), (x + (i + y)*targetWidth)*4);
        // 	}
        // 	if (!this._locked)
        // 		this.invalidate();
        // }
        BitmapImage2D.prototype.merge = function (source, sourceRect, destPoint, redMultiplier, greenMultiplier, blueMultiplier, alphaMultiplier) {
            var dest = this.data;
            var src = source.data;
            redMultiplier = ~~redMultiplier;
            greenMultiplier = ~~greenMultiplier;
            blueMultiplier = ~~blueMultiplier;
            alphaMultiplier = ~~alphaMultiplier;
            var i, j, index;
            for (i = 0; i < sourceRect.width; ++i) {
                for (j = 0; j < sourceRect.height; ++j) {
                    index = (i + sourceRect.x + (j + sourceRect.y) * this.width) * 4;
                    dest[index] = ~~((src[index] * redMultiplier + dest[index] * (0x100 - redMultiplier)) / 0x100);
                    dest[index + 1] = ~~((src[index + 1] * greenMultiplier + dest[index + 1] * (0x100 - greenMultiplier)) / 0x100);
                    dest[index + 2] = ~~((src[index + 2] * blueMultiplier + dest[index + 2] * (0x100 - blueMultiplier)) / 0x100);
                    dest[index + 3] = ~~((src[index + 3] * alphaMultiplier + dest[index + 3] * (0x100 - alphaMultiplier)) / 0x100);
                }
            }
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Frees memory that is used to store the BitmapImage2D object.
         *
         * <p>When the <code>dispose()</code> method is called on an image, the width
         * and height of the image are set to 0. All subsequent calls to methods or
         * properties of this BitmapImage2D instance fail, and an exception is thrown.
         * </p>
         *
         * <p><code>BitmapImage2D.dispose()</code> releases the memory occupied by the
         * actual bitmap data, immediately(a bitmap can consume up to 64 MB of
         * memory). After using <code>BitmapImage2D.dispose()</code>, the BitmapImage2D
         * object is no longer usable and an exception may be thrown if
         * you call functions on the BitmapImage2D object. However,
         * <code>BitmapImage2D.dispose()</code> does not garbage collect the BitmapImage2D
         * object(approximately 128 bytes); the memory occupied by the actual
         * BitmapImage2D object is released at the time the BitmapImage2D object is
         * collected by the garbage collector.</p>
         *
         */
        BitmapImage2D.prototype.dispose = function () {
            this.clear();
            this._data = null;
            this._rect = null;
            this._transparent = null;
            this._locked = null;
        };
        BitmapImage2D.prototype.drawBitmap = function (source, offsetX, offsetY, width, height, matrix) {
            if (matrix === void 0) { matrix = null; }
            BitmapImageUtils.drawBitmap(source, offsetX, offsetY, width, height, this.data, 0, 0, this._rect.width, this._rect.height, matrix);
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Fills a rectangular area of pixels with a specified ARGB color.
         *
         * @param rect  The rectangular area to fill.
         * @param color The ARGB color value that fills the area. ARGB colors are
         *              often specified in hexadecimal format; for example,
         *              0xFF336699.
         * @throws TypeError The rect is null.
         */
        BitmapImage2D.prototype.fillRect = function (rect, color) {
            var data = new Uint32Array(this._data.buffer);
            var x = ~~rect.x, y = ~~rect.y, width = ~~rect.width, height = ~~rect.height;
            var argb = this._transparent ? (color & 0xFFFFFFFF) : (color & 0xFFFFFF) + 0xFF000000;
            //fast path for complete fill
            if (x == 0 && y == 0 && width == this._rect.width && height == this._rect.height) {
                data.fill(argb);
            }
            else {
                var j;
                var index;
                for (j = 0; j < height; ++j) {
                    index = x + (j + y) * this._rect.width;
                    data.fill(argb, index, index + width);
                }
            }
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Returns an integer that represents an RGB pixel value from a BitmapImage2D
         * object at a specific point(<i>x</i>, <i>y</i>). The
         * <code>getPixel()</code> method returns an unmultiplied pixel value. No
         * alpha information is returned.
         *
         * <p>All pixels in a BitmapImage2D object are stored as premultiplied color
         * values. A premultiplied image pixel has the red, green, and blue color
         * channel values already multiplied by the alpha data. For example, if the
         * alpha value is 0, the values for the RGB channels are also 0, independent
         * of their unmultiplied values. This loss of data can cause some problems
         * when you perform operations. All BitmapImage2D methods take and return
         * unmultiplied values. The internal pixel representation is converted from
         * premultiplied to unmultiplied before it is returned as a value. During a
         * set operation, the pixel value is premultiplied before the raw image pixel
         * is set.</p>
         *
         * @param x The <i>x</i> position of the pixel.
         * @param y The <i>y</i> position of the pixel.
         * @return A number that represents an RGB pixel value. If the(<i>x</i>,
         *         <i>y</i>) coordinates are outside the bounds of the image, the
         *         method returns 0.
         */
        BitmapImage2D.prototype.getPixel = function (x, y) {
            var r;
            var g;
            var b;
            var a;
            var index = (~~x + ~~y * this._rect.width) * 4, data = this.data;
            r = data[index + 0];
            g = data[index + 1];
            b = data[index + 2];
            a = data[index + 3];
            //returns black if fully transparent
            if (!a)
                return 0x0;
            return (r * 0xFF / a << 16) | (g * 0xFF / a << 8) | b * 0xFF / a;
        };
        /**
         * Returns an ARGB color value that contains alpha channel data and RGB data.
         * This method is similar to the <code>getPixel()</code> method, which
         * returns an RGB color without alpha channel data.
         *
         * <p>All pixels in a BitmapImage2D object are stored as premultiplied color
         * values. A premultiplied image pixel has the red, green, and blue color
         * channel values already multiplied by the alpha data. For example, if the
         * alpha value is 0, the values for the RGB channels are also 0, independent
         * of their unmultiplied values. This loss of data can cause some problems
         * when you perform operations. All BitmapImage2D methods take and return
         * unmultiplied values. The internal pixel representation is converted from
         * premultiplied to unmultiplied before it is returned as a value. During a
         * set operation, the pixel value is premultiplied before the raw image pixel
         * is set.</p>
         *
         * @param x The <i>x</i> position of the pixel.
         * @param y The <i>y</i> position of the pixel.
         * @return A number representing an ARGB pixel value. If the(<i>x</i>,
         *         <i>y</i>) coordinates are outside the bounds of the image, 0 is
         *         returned.
         */
        BitmapImage2D.prototype.getPixel32 = function (x, y) {
            var r;
            var g;
            var b;
            var a;
            var index = (~~x + ~~y * this._rect.width) * 4;
            var data = this.data;
            r = data[index++];
            g = data[index++];
            b = data[index++];
            a = data[index];
            if (!a)
                return 0x0;
            return (a << 24) | (r * 0xFF / a << 16) | (g * 0xFF / a << 8) | b * 0xFF / a;
        };
        BitmapImage2D.prototype.getPixelData = function (x, y, imagePixel) {
            var index = (x + y * this._rect.width) * 4;
            var data = this.data;
            imagePixel[0] = data[index++];
            imagePixel[1] = data[index++];
            imagePixel[2] = data[index++];
            imagePixel[3] = data[index];
        };
        BitmapImage2D.prototype.setPixelData = function (x, y, imagePixel) {
            var index = (x + y * this._rect.width) * 4;
            var data = this.data;
            data[index + 0] = imagePixel[0];
            data[index + 1] = imagePixel[1];
            data[index + 2] = imagePixel[2];
            data[index + 3] = this._transparent ? imagePixel[3] : 0xFF;
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Locks an image so that any objects that reference the BitmapImage2D object,
         * such as Bitmap objects, are not updated when this BitmapImage2D object
         * changes. To improve performance, use this method along with the
         * <code>unlock()</code> method before and after numerous calls to the
         * <code>setPixel()</code> or <code>setPixel32()</code> method.
         *
         */
        BitmapImage2D.prototype.lock = function () {
            if (this._locked)
                return;
            this._locked = true;
        };
        /**
         * Converts an Array into a rectangular region of pixel data. For each pixel,
         * an Array element is read and written into the BitmapImage2D pixel. The data
         * in the Array is expected to be 32-bit ARGB pixel values.
         *
         * @param rect        Specifies the rectangular region of the BitmapImage2D
         *                    object.
         * @param inputArray  An Array that consists of 32-bit unmultiplied pixel
         *                    values to be used in the rectangular region.
         * @throws RangeError The vector array is not large enough to read all the
         *                    pixel data.
         */
        BitmapImage2D.prototype.setArray = function (rect, inputArray) {
            var i, j, index, argb, data = this.data;
            for (i = 0; i < rect.width; ++i) {
                for (j = 0; j < rect.height; ++j) {
                    argb = ColorUtils.float32ColorToARGB(inputArray[i + j * rect.width]);
                    index = (i + rect.x + (j + rect.y) * this._rect.width) * 4;
                    data[index + 0] = argb[1];
                    data[index + 1] = argb[2];
                    data[index + 2] = argb[3];
                    data[index + 3] = this._transparent ? argb[0] : 0xFF;
                }
            }
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Sets a single pixel of a BitmapImage2D object. The current alpha channel
         * value of the image pixel is preserved during this operation. The value of
         * the RGB color parameter is treated as an unmultiplied color value.
         *
         * <p><b>Note:</b> To increase performance, when you use the
         * <code>setPixel()</code> or <code>setPixel32()</code> method repeatedly,
         * call the <code>lock()</code> method before you call the
         * <code>setPixel()</code> or <code>setPixel32()</code> method, and then call
         * the <code>unlock()</code> method when you have made all pixel changes.
         * This process prevents objects that reference this BitmapImage2D instance from
         * updating until you finish making the pixel changes.</p>
         *
         * @param x     The <i>x</i> position of the pixel whose value changes.
         * @param y     The <i>y</i> position of the pixel whose value changes.
         * @param color The resulting RGB color for the pixel.
         */
        BitmapImage2D.prototype.setPixel = function (x, y, color) {
            var index = (~~x + ~~y * this._rect.width) * 4, argb = ColorUtils.float32ColorToARGB(color), data = this.data;
            data[index + 0] = argb[1];
            data[index + 1] = argb[2];
            data[index + 2] = argb[3];
            data[index + 3] = 0xff;
            if (!this._locked)
                this.invalidate();
        };
        BitmapImage2D.prototype.setPixelFromArray = function (x, y, colors) {
            var index = (x + y * this._rect.width) * 4, data = this.data;
            data[index + 0] = colors[1];
            data[index + 1] = colors[2];
            data[index + 2] = colors[3];
            data[index + 3] = colors[0] * 0xff;
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Sets the color and alpha transparency values of a single pixel of a
         * BitmapImage2D object. This method is similar to the <code>setPixel()</code>
         * method; the main difference is that the <code>setPixel32()</code> method
         * takes an ARGB color value that contains alpha channel information.
         *
         * <p>All pixels in a BitmapImage2D object are stored as premultiplied color
         * values. A premultiplied image pixel has the red, green, and blue color
         * channel values already multiplied by the alpha data. For example, if the
         * alpha value is 0, the values for the RGB channels are also 0, independent
         * of their unmultiplied values. This loss of data can cause some problems
         * when you perform operations. All BitmapImage2D methods take and return
         * unmultiplied values. The internal pixel representation is converted from
         * premultiplied to unmultiplied before it is returned as a value. During a
         * set operation, the pixel value is premultiplied before the raw image pixel
         * is set.</p>
         *
         * <p><b>Note:</b> To increase performance, when you use the
         * <code>setPixel()</code> or <code>setPixel32()</code> method repeatedly,
         * call the <code>lock()</code> method before you call the
         * <code>setPixel()</code> or <code>setPixel32()</code> method, and then call
         * the <code>unlock()</code> method when you have made all pixel changes.
         * This process prevents objects that reference this BitmapImage2D instance from
         * updating until you finish making the pixel changes.</p>
         *
         * @param x     The <i>x</i> position of the pixel whose value changes.
         * @param y     The <i>y</i> position of the pixel whose value changes.
         * @param color The resulting ARGB color for the pixel. If the bitmap is
         *              opaque(not transparent), the alpha transparency portion of
         *              this color value is ignored.
         */
        BitmapImage2D.prototype.setPixel32 = function (x, y, color) {
            var index = (~~x + ~~y * this._rect.width) * 4, argb = ColorUtils.float32ColorToARGB(color), data = this.data;
            data[index + 0] = argb[1];
            data[index + 1] = argb[2];
            data[index + 2] = argb[3];
            data[index + 3] = this._transparent ? argb[0] : 0xFF;
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Converts a byte array into a rectangular region of pixel data. For each
         * pixel, the <code>ByteArray.readUnsignedInt()</code> method is called and
         * the return value is written into the pixel. If the byte array ends before
         * the full rectangle is written, the function returns. The data in the byte
         * array is expected to be 32-bit ARGB pixel values. No seeking is performed
         * on the byte array before or after the pixels are read.
         *
         * @param rect           Specifies the rectangular region of the BitmapImage2D
         *                       object.
         * @param inputByteArray A ByteArray object that consists of 32-bit
         *                       unmultiplied pixel values to be used in the
         *                       rectangular region.
         * @throws EOFError  The <code>inputByteArray</code> object does not include
         *                   enough data to fill the area of the <code>rect</code>
         *                   rectangle. The method fills as many pixels as possible
         *                   before throwing the exception.
         * @throws TypeError The rect or inputByteArray are null.
         */
        BitmapImage2D.prototype.setPixels = function (rect, input) {
            //fast path for full imageData
            if (rect.equals(this._rect)) {
                this._data.set(input);
            }
            else {
                var i, imageWidth = this._rect.width, inputWidth = rect.width, data = this._data;
                for (i = 0; i < rect.height; ++i)
                    data.set(input.subarray(i * inputWidth * 4, (i + 1) * inputWidth * 4), (rect.x + (i + rect.y) * imageWidth) * 4);
            }
            if (!this._locked)
                this.invalidate();
        };
        /**
         * Unlocks an image so that any objects that reference the BitmapImage2D object,
         * such as Bitmap objects, are updated when this BitmapImage2D object changes.
         * To improve performance, use this method along with the <code>lock()</code>
         * method before and after numerous calls to the <code>setPixel()</code> or
         * <code>setPixel32()</code> method.
         *
         * @param changeRect The area of the BitmapImage2D object that has changed. If
         *                   you do not specify a value for this parameter, the
         *                   entire area of the BitmapImage2D object is considered
         *                   changed.
         */
        BitmapImage2D.prototype.unlock = function () {
            if (!this._locked)
                return;
            this._locked = false;
            this.invalidate();
        };
        Object.defineProperty(BitmapImage2D.prototype, "data", {
            /**
             *
             * @returns {ImageData}
             */
            get: function () {
                if (this._alphaChannel) {
                    if (this._data.length != this._alphaChannel.length * 4)
                        throw ("error when trying to merge the alpha channel into the image. the length of the alpha channel should be 1/4 of the length of the imageData");
                    for (var i = 0; i < this._alphaChannel.length; i++)
                        this._data[i * 4 + 3] = this._alphaChannel[i];
                    //remove alpha data once applied
                    this._alphaChannel = null;
                }
                return this._data;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         * @param width
         * @param height
         * @private
         */
        BitmapImage2D.prototype._setSize = function (width, height) {
            var data = this.data;
            this._data = new Uint8ClampedArray(4 * width * height);
            var i;
            var inputWidth = (this._rect.width < width) ? this._rect.width : width;
            var inputHeight = (this._rect.height < height) ? this._rect.height : height;
            for (i = 0; i < inputHeight; ++i)
                this._data.set(data.subarray(i * inputWidth * 4, (i + 1) * inputWidth * 4), i * width * 4);
            _super.prototype._setSize.call(this, width, height);
        };
        BitmapImage2D.assetType = "[image BitmapImage2D]";
        return BitmapImage2D;
    }(Image2D));
    /**
     *
     * @class away.pool.ImageObjectBase
     */
    var _Stage_BitmapImage2D = /** @class */ (function (_super) {
        __extends$2(_Stage_BitmapImage2D, _super);
        function _Stage_BitmapImage2D() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        _Stage_BitmapImage2D.prototype.getTexture = function () {
            _super.prototype.getTexture.call(this);
            if (this._invalid) {
                this._invalid = false;
                this._texture.uploadFromArray(new Uint8Array(this._asset.data.buffer), 0);
                var mipLevels = this._asset.mipLevels;
                if (mipLevels && mipLevels.length > 0) {
                    for (var i = 0; i < mipLevels.length; i++) {
                        this._texture.uploadFromArray(new Uint8Array(mipLevels[i].data.buffer), i + 1);
                    }
                    this._mipmap = true;
                    this._invalidMipmaps = false;
                }
                else {
                    this._invalidMipmaps = true;
                }
            }
            return this._texture;
        };
        return _Stage_BitmapImage2D;
    }(_Stage_Image2D));
    Stage.registerAbstraction(_Stage_BitmapImage2D, BitmapImage2D);

    var BitmapImageChannel = /** @class */ (function () {
        function BitmapImageChannel() {
        }
        BitmapImageChannel.ALPHA = 8;
        BitmapImageChannel.BLUE = 4;
        BitmapImageChannel.GREEN = 2;
        BitmapImageChannel.RED = 1;
        return BitmapImageChannel;
    }());

    /**
     * A export class that provides constant values for visual blend mode effects. These
     * constants are used in the following:
     * <ul>
     *   <li> The <code>blendMode</code> property of the
     * flash.display.DisplayObject class.</li>
     *   <li> The <code>blendMode</code> parameter of the <code>draw()</code>
     * method of the flash.display.BitmapData class</li>
     * </ul>
     */
    var BlendMode = /** @class */ (function () {
        function BlendMode() {
        }
        /**
         * Adds the values of the constituent colors of the display object to the
         * colors of its background, applying a ceiling of 0xFF. This setting is
         * commonly used for animating a lightening dissolve between two objects.
         *
         * <p>For example, if the display object has a pixel with an RGB value of
         * 0xAAA633, and the background pixel has an RGB value of 0xDD2200, the
         * resulting RGB value for the displayed pixel is 0xFFC833(because 0xAA +
         * 0xDD > 0xFF, 0xA6 + 0x22 = 0xC8, and 0x33 + 0x00 = 0x33).</p>
         */
        BlendMode.ADD = "add";
        /**
         * Applies the alpha value of each pixel of the display object to the
         * background. This requires the <code>blendMode</code> property of the
         * parent display object be set to
         * <code>away.base.BlendMode.LAYER</code>.
         *
         * <p>Not supported under GPU rendering.</p>
         */
        BlendMode.ALPHA = "alpha";
        /**
         * Selects the darker of the constituent colors of the display object and the
         * colors of the background(the colors with the smaller values). This
         * setting is commonly used for superimposing type.
         *
         * <p>For example, if the display object has a pixel with an RGB value of
         * 0xFFCC33, and the background pixel has an RGB value of 0xDDF800, the
         * resulting RGB value for the displayed pixel is 0xDDCC00(because 0xFF >
         * 0xDD, 0xCC < 0xF8, and 0x33 > 0x00 = 33).</p>
         *
         * <p>Not supported under GPU rendering.</p>
         */
        BlendMode.DARKEN = "darken";
        /**
         * Compares the constituent colors of the display object with the colors of
         * its background, and subtracts the darker of the values of the two
         * constituent colors from the lighter value. This setting is commonly used
         * for more vibrant colors.
         *
         * <p>For example, if the display object has a pixel with an RGB value of
         * 0xFFCC33, and the background pixel has an RGB value of 0xDDF800, the
         * resulting RGB value for the displayed pixel is 0x222C33(because 0xFF -
         * 0xDD = 0x22, 0xF8 - 0xCC = 0x2C, and 0x33 - 0x00 = 0x33).</p>
         */
        BlendMode.DIFFERENCE = "difference";
        /**
         * Erases the background based on the alpha value of the display object. This
         * process requires that the <code>blendMode</code> property of the parent
         * display object be set to <code>flash.display.BlendMode.LAYER</code>.
         *
         * <p>Not supported under GPU rendering.</p>
         */
        BlendMode.ERASE = "erase";
        /**
         * Adjusts the color of each pixel based on the darkness of the display
         * object. If the display object is lighter than 50% gray, the display object
         * and background colors are screened, which results in a lighter color. If
         * the display object is darker than 50% gray, the colors are multiplied,
         * which results in a darker color. This setting is commonly used for shading
         * effects.
         *
         * <p>Not supported under GPU rendering.</p>
         */
        BlendMode.HARDLIGHT = "hardlight";
        /**
         * Inverts the background.
         */
        BlendMode.INVERT = "invert";
        /**
         * Forces the creation of a transparency group for the display object. This
         * means that the display object is precomposed in a temporary buffer before
         * it is processed further. The precomposition is done automatically if the
         * display object is precached by means of bitmap caching or if the display
         * object is a display object container that has at least one child object
         * with a <code>blendMode</code> setting other than <code>"normal"</code>.
         *
         * <p>Not supported under GPU rendering.</p>
         */
        BlendMode.LAYER = "layer";
        /**
         * Selects the lighter of the constituent colors of the display object and
         * the colors of the background(the colors with the larger values). This
         * setting is commonly used for superimposing type.
         *
         * <p>For example, if the display object has a pixel with an RGB value of
         * 0xFFCC33, and the background pixel has an RGB value of 0xDDF800, the
         * resulting RGB value for the displayed pixel is 0xFFF833(because 0xFF >
         * 0xDD, 0xCC < 0xF8, and 0x33 > 0x00 = 33).</p>
         *
         * <p>Not supported under GPU rendering.</p>
         */
        BlendMode.LIGHTEN = "lighten";
        /**
         * Multiplies the values of the display object constituent colors by the
         * constituent colors of the background color, and normalizes by dividing by
         * 0xFF, resulting in darker colors. This setting is commonly used for
         * shadows and depth effects.
         *
         * <p>For example, if a constituent color(such as red) of one pixel in the
         * display object and the corresponding color of the pixel in the background
         * both have the value 0x88, the multiplied result is 0x4840. Dividing by
         * 0xFF yields a value of 0x48 for that constituent color, which is a darker
         * shade than the color of the display object or the color of the
         * background.</p>
         */
        BlendMode.MULTIPLY = "multiply";
        /**
         * The display object appears in front of the background. Pixel values of the
         * display object override the pixel values of the background. Where the
         * display object is transparent, the background is visible.
         */
        BlendMode.NORMAL = "normal";
        /**
         * Adjusts the color of each pixel based on the darkness of the background.
         * If the background is lighter than 50% gray, the display object and
         * background colors are screened, which results in a lighter color. If the
         * background is darker than 50% gray, the colors are multiplied, which
         * results in a darker color. This setting is commonly used for shading
         * effects.
         *
         * <p>Not supported under GPU rendering.</p>
         */
        BlendMode.OVERLAY = "overlay";
        /**
         * Multiplies the complement(inverse) of the display object color by the
         * complement of the background color, resulting in a bleaching effect. This
         * setting is commonly used for highlights or to remove black areas of the
         * display object.
         */
        BlendMode.SCREEN = "screen";
        /**
         * Uses a shader to define the blend between objects.
         *
         * <p>Setting the <code>blendShader</code> property to a Shader instance
         * automatically sets the display object's <code>blendMode</code> property to
         * <code>BlendMode.SHADER</code>. If the <code>blendMode</code> property is
         * set to <code>BlendMode.SHADER</code> without first setting the
         * <code>blendShader</code> property, the <code>blendMode</code> property is
         * set to <code>BlendMode.NORMAL</code> instead. If the
         * <code>blendShader</code> property is set(which sets the
         * <code>blendMode</code> property to <code>BlendMode.SHADER</code>), then
         * later the value of the <code>blendMode</code> property is changed, the
         * blend mode can be reset to use the blend shader simply by setting the
         * <code>blendMode</code> property to <code>BlendMode.SHADER</code>. The
         * <code>blendShader</code> property does not need to be set again except to
         * change the shader that's used to define the blend mode.</p>
         *
         * <p>Not supported under GPU rendering.</p>
         */
        BlendMode.SHADER = "shader";
        /**
         * Subtracts the values of the constituent colors in the display object from
         * the values of the background color, applying a floor of 0. This setting is
         * commonly used for animating a darkening dissolve between two objects.
         *
         * <p>For example, if the display object has a pixel with an RGB value of
         * 0xAA2233, and the background pixel has an RGB value of 0xDDA600, the
         * resulting RGB value for the displayed pixel is 0x338400(because 0xDD -
         * 0xAA = 0x33, 0xA6 - 0x22 = 0x84, and 0x00 - 0x33 < 0x00).</p>
         */
        BlendMode.SUBTRACT = "subtract";
        return BlendMode;
    }());

    /**

     */
    var ExternalImage2D = /** @class */ (function (_super) {
        __extends$2(ExternalImage2D, _super);
        /**
         *
         */
        function ExternalImage2D(urlRequest) {
            var _this = _super.call(this, 8, 8, true) || this;
            _this._urlRequest = urlRequest;
            return _this;
        }
        Object.defineProperty(ExternalImage2D.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return ExternalImage2D.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExternalImage2D.prototype, "urlRequest", {
            get: function () {
                return this._urlRequest;
            },
            set: function (value) {
                this._urlRequest = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns a new ExternalImage2D object that is a clone of the original instance
         * with an exact copy of the contained bitmap.
         *
         * @return A new ExternalImage2D object that is identical to the original.
         */
        ExternalImage2D.prototype.clone = function () {
            var t = new ExternalImage2D(this._urlRequest);
            return t;
        };
        ExternalImage2D.assetType = "[image ExternalImage2D]";
        return ExternalImage2D;
    }(Image2D));
    /**
     *
     * @class away.pool.ImageObjectBase
     */
    var _Stage_ExternalImage2D = /** @class */ (function (_super) {
        __extends$2(_Stage_ExternalImage2D, _super);
        function _Stage_ExternalImage2D() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        _Stage_ExternalImage2D.prototype.getTexture = function () {
            _super.prototype.getTexture.call(this);
            if (this._invalid) {
                this._invalid = false;
                this._texture.uploadFromURL(this._asset.urlRequest, 0);
                this._invalidMipmaps = true;
            }
            return this._texture;
        };
        return _Stage_ExternalImage2D;
    }(_Stage_Image2D));
    Stage.registerAbstraction(_Stage_ExternalImage2D, ExternalImage2D);

    /**
     *
     */
    var SpecularImage2D = /** @class */ (function (_super) {
        __extends$2(SpecularImage2D, _super);
        /**
         *
         */
        function SpecularImage2D(specularSource, glossSource) {
            if (specularSource === void 0) { specularSource = null; }
            if (glossSource === void 0) { glossSource = null; }
            var _this = _super.call(this, 1, 1) || this;
            _this._specularSource = specularSource;
            _this._glossSource = glossSource;
            _this._output = new BitmapImage2D(1, 1, false, 0xffffff);
            _this._testSize();
            return _this;
        }
        Object.defineProperty(SpecularImage2D.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return SpecularImage2D.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularImage2D.prototype, "specularSource", {
            get: function () {
                return this._specularSource;
            },
            set: function (value) {
                if (this._specularSource == value)
                    return;
                this._specularSource = value;
                this.invalidate();
                this._testSize();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularImage2D.prototype, "glossSource", {
            get: function () {
                return this._glossSource;
            },
            set: function (value) {
                if (this._glossSource == value)
                    return;
                this._glossSource = value;
                this.invalidate();
                this._testSize();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns a new SpecularImage2D object that is a clone of the original instance
         * with an exact copy of the contained bitmap.
         *
         * @return A new SpecularImage2D object that is identical to the original.
         */
        SpecularImage2D.prototype.clone = function () {
            return new SpecularImage2D(this._specularSource, this._glossSource);
        };
        /**
         * Frees memory that is used to store the SpecularImage2D object.
         *
         * <p>When the <code>dispose()</code> method is called on an image, the width
         * and height of the image are set to 0. All subsequent calls to methods or
         * properties of this SpecularImage2D instance fail, and an exception is thrown.
         * </p>
         *
         * <p><code>SpecularImage2D.dispose()</code> releases the memory occupied by the
         * actual bitmap data, immediately(a bitmap can consume up to 64 MB of
         * memory). After using <code>SpecularImage2D.dispose()</code>, the SpecularImage2D
         * object is no longer usable and an exception may be thrown if
         * you call functions on the SpecularImage2D object. However,
         * <code>SpecularImage2D.dispose()</code> does not garbage collect the SpecularImage2D
         * object(approximately 128 bytes); the memory occupied by the actual
         * SpecularImage2D object is released at the time the SpecularImage2D object is
         * collected by the garbage collector.</p>
         *
         */
        SpecularImage2D.prototype.dispose = function () {
            _super.prototype.dispose.call(this);
            this._rect = null;
            this._output.dispose();
        };
        Object.defineProperty(SpecularImage2D.prototype, "data", {
            /**
             *
             * @returns {ImageData}
             */
            get: function () {
                var origin = new Point();
                this._output.fillRect(this._rect, 0xffffff);
                if (this._glossSource)
                    this._output.copyChannel(this._glossSource, this._rect, origin, BitmapImageChannel.GREEN, BitmapImageChannel.GREEN);
                if (this._specularSource)
                    this._output.copyChannel(this._specularSource, this._rect, origin, BitmapImageChannel.RED, BitmapImageChannel.RED);
                return this._output.data;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         * @param width
         * @param height
         * @private
         */
        SpecularImage2D.prototype._setSize = function (width, height) {
            _super.prototype._setSize.call(this, width, height);
            this._output._setSize(width, height);
        };
        SpecularImage2D.prototype._testSize = function () {
            var w, h;
            if (this._specularSource) {
                w = this._specularSource.width;
                h = this._specularSource.height;
            }
            else if (this._glossSource) {
                w = this._glossSource.width;
                h = this._glossSource.height;
            }
            else {
                w = 1;
                h = 1;
            }
            if (w != this._output.width && h != this._output.height) {
                this._output.dispose();
                this._output = new BitmapImage2D(w, h, false, 0xffffff);
            }
            this._setSize(w, h);
        };
        SpecularImage2D.assetType = "[asset SpecularImage2D]";
        return SpecularImage2D;
    }(Image2D));
    Stage.registerAbstraction(_Stage_BitmapImage2D, SpecularImage2D);

    var Filter3DCompositeTask = /** @class */ (function (_super) {
        __extends$2(Filter3DCompositeTask, _super);
        function Filter3DCompositeTask(blendMode, exposure) {
            if (exposure === void 0) { exposure = 1; }
            var _this = _super.call(this) || this;
            _this._data = new Float32Array([exposure, 0.5, 2.0, -1, 0.0, 0.0, 0.0, 0.0]);
            _this._blendMode = blendMode;
            return _this;
        }
        Object.defineProperty(Filter3DCompositeTask.prototype, "overlayTexture", {
            get: function () {
                return this._overlayTexture;
            },
            set: function (value) {
                this._overlayTexture = value;
                this._overlayWidth = this._overlayTexture.width;
                this._overlayHeight = this._overlayTexture.height;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DCompositeTask.prototype, "exposure", {
            get: function () {
                return this._data[0];
            },
            set: function (value) {
                this._data[0] = value;
            },
            enumerable: true,
            configurable: true
        });
        Filter3DCompositeTask.prototype.getFragmentCode = function () {
            var temp1 = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(temp1, 1);
            var temp2 = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(temp2, 1);
            var temp3 = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(temp3, 1);
            var temp4 = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(temp4, 1);
            var inputTexture = this._registerCache.getFreeTextureReg();
            this._inputTextureIndex = inputTexture.index;
            var overlayTexture = this._registerCache.getFreeTextureReg();
            this._overlayTextureIndex = overlayTexture.index;
            var exposure = this._registerCache.getFreeFragmentConstant();
            this._exposureIndex = exposure.index * 4;
            var scaling = this._registerCache.getFreeFragmentConstant();
            this._scalingIndex = scaling.index * 4;
            var code;
            code = "tex " + temp1 + ", " + this._uvVarying + ", " + inputTexture + " <2d,linear,clamp>\n" +
                "mul " + temp2 + ", " + this._uvVarying + ", " + scaling + ".zw\n" +
                "add " + temp2 + ", " + temp2 + ", " + scaling + ".xy\n" +
                "tex " + temp2 + ", " + temp2 + ", " + overlayTexture + " <2d,linear,clamp>\n" +
                "mul " + temp2 + ", " + temp2 + ", " + exposure + ".xxx\n" +
                "add " + temp2 + ", " + temp2 + ", " + exposure + ".xxx\n";
            switch (this._blendMode) {
                case "multiply":
                    code += "mul oc, " + temp1 + ", " + temp2 + "\n";
                    break;
                case "add":
                    code += "add oc, " + temp1 + ", " + temp2 + "\n";
                    break;
                case "subtract":
                    code += "sub oc, " + temp1 + ", " + temp2 + "\n";
                    break;
                case "overlay":
                    code += "sge " + temp3 + ", " + temp1 + ", " + exposure + ".yyy\n"; // t2 = (blend >= 0.5)? 1 : 0
                    code += "sub " + temp1 + ", " + temp3 + ", " + temp1 + "\n"; // base = (1 : 0 - base)
                    code += "sub " + temp2 + ", " + temp2 + ", " + temp3 + "\n"; // blend = (blend - 1 : 0)
                    code += "mul " + temp2 + ", " + temp2 + ", " + temp1 + "\n"; // blend = blend * base
                    code += "sub " + temp4 + ", " + temp3 + ", " + exposure + ".yyy\n"; // t3 = (blend >= 0.5)? 0.5 : -0.5
                    code += "div " + temp2 + ", " + temp2 + ", " + temp4 + "\n"; // blend = blend / ( 0.5 : -0.5)
                    code += "add oc, " + temp2 + ", " + temp3 + "\n";
                    break;
                case "normal":
                    // for debugging purposes
                    code += "mov oc, " + temp1 + "\n";
                    break;
                default:
                    throw new Error("Unknown blend mode");
            }
            return code;
        };
        Filter3DCompositeTask.prototype.activate = function (stage, projection, depthTexture) {
            this._data[4] = -0.5 * (this._textureWidth - this._overlayWidth) / this._overlayWidth;
            this._data[5] = -0.5 * (this._textureHeight - this._overlayHeight) / this._overlayHeight;
            this._data[6] = this._textureWidth / this._overlayWidth;
            this._data[7] = this._textureHeight / this._overlayHeight;
            var context = stage.context;
            context.setProgramConstantsFromArray(ContextGLProgramType.FRAGMENT, this._data);
            stage.getAbstraction(this._overlayTexture).activate(this._overlayTextureIndex);
        };
        Filter3DCompositeTask.prototype.deactivate = function (stage) {
            stage.context.setTextureAt(1, null);
        };
        return Filter3DCompositeTask;
    }(Filter3DTaskBase));

    var Filter3DFXAATask = /** @class */ (function (_super) {
        __extends$2(Filter3DFXAATask, _super);
        /**
         *
         * @param amount
         * @param stepSize The distance between samples. Set to -1 to autodetect with acceptable quality.
         */
        function Filter3DFXAATask(amount, stepSize) {
            if (amount === void 0) { amount = 1; }
            if (stepSize === void 0) { stepSize = -1; }
            var _this = _super.call(this) || this;
            _this._stepSize = 1;
            _this._data = new Float32Array(20);
            //luma
            _this._data.set([0.299, 0.587, 0.114, 0], 0); //0.212, 0.716, 0.072
            //helpers
            _this._data.set([0.25, 0.5, 0.75, 1], 4);
            //settings (screen x, screen y, ...)
            _this._data.set([1 / 1024, 1 / 1024, -1, 1], 8);
            //deltas
            _this._data.set([1 / 128, 1 / 8, 8, 0], 12);
            //deltas
            _this._data.set([1.0 / 3.0 - 0.5, 2.0 / 3.0 - 0.5, 0.0 / 3.0 - 0.5, 3.0 / 3.0 - 0.5], 16);
            _this.amount = amount;
            _this.stepSize = stepSize;
            return _this;
        }
        Object.defineProperty(Filter3DFXAATask.prototype, "amount", {
            get: function () {
                return this._amount;
            },
            set: function (value) {
                if (this._amount == value)
                    return;
                this._amount = value;
                this.invalidateProgram();
                this.updateBlurData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DFXAATask.prototype, "stepSize", {
            get: function () {
                return this._stepSize;
            },
            set: function (value) {
                if (this._stepSize == value)
                    return;
                this._stepSize = value;
                this.calculateStepSize();
                this.invalidateProgram();
                this.updateBlurData();
            },
            enumerable: true,
            configurable: true
        });
        Filter3DFXAATask.prototype.getFragmentCode = function () {
            var lum = "fc0"; //	0.299, 0.587, 0.114
            var _025 = "fc1.x";
            var _05 = "fc1.y";
            var _1 = "fc1.w";
            var pix = "fc2.xy";
            var dx = "fc2.x"; // 1/1024
            var dy = "fc2.y"; // 1/1024
            var fxaaReduceMin = "fc3.x"; //1/128
            var fxaaReduceMul = "fc3.y"; //1/8
            var fxaaSpanMax = "fc3.z"; //8
            var delta1 = "fc4.x"; //1.0/3.0 - 0.5
            var delta2 = "fc4.y"; //2.0/3.0 - 0.5
            var delta3 = "fc4.z"; //0.0/3.0 - 0.5
            var delta4 = "fc4.w"; //3.0/3.0 - 0.5
            var uv_in = "v0";
            var uv = "ft0.xy";
            var uvx = "ft0.x";
            var uvy = "ft0.y";
            var TL = "ft2.x";
            var TR = "ft2.y";
            var BL = "ft2.z";
            var BR = "ft2.w";
            var M = "ft3.x";
            var tempf1 = "ft3.y";
            var tempf2 = "ft3.z";
            var tempf3 = "ft3.w";
            var tex = "ft1";
            var dirx = "ft4.x";
            var diry = "ft4.y";
            var dirxy = "ft4.xy";
            var dirReduce = "ft5.x";
            var inverseDirAdjustment = "ft5.y";
            var result1 = "ft6";
            var result2 = "ft7";
            var lumaMin = "ft5.x";
            var lumaMax = "ft5.y";
            var sample = "fs0";
            var temp = tex;
            var tempxy = temp + ".xy";
            var code = new Array();
            //lumas
            code.push("tex", tex, uv_in, sample, "<2d wrap linear>", "\n");
            code.push("dp3", M, tex, lum, "\n");
            code.push("mov", uv, uv_in, "\n");
            code.push("sub", uv, uv, pix, "\n");
            code.push("tex", tex, uv, sample, "<2d wrap linear>", "\n");
            code.push("dp3", TL, tex, lum, "\n");
            code.push("mov", uv, uv_in, "\n");
            code.push("add", uv, uv, pix, "\n");
            code.push("tex", tex, uv, sample, "<2d wrap linear>", "\n");
            code.push("dp3", BR, tex, lum, "\n");
            code.push("mov", uv, uv_in, "\n");
            code.push("sub", uvy, uvy, dy, "\n");
            code.push("add", uvx, uvx, dx, "\n");
            code.push("tex", tex, uv, sample, "<2d wrap linear>", "\n");
            code.push("dp3", TR, tex, lum, "\n");
            code.push("mov", uv, uv_in, "\n");
            code.push("add", uvy, uvy, dy, "\n");
            code.push("sub", uvx, uvx, dx, "\n");
            code.push("tex", tex, uv, sample, "<2d wrap linear>", "\n");
            code.push("dp3", BL, tex, lum, "\n");
            //dir
            code.push("add", tempf1, TL, TR, "\n");
            code.push("add", tempf2, BL, BR, "\n");
            code.push("sub", dirx, tempf1, tempf2, "\n");
            code.push("neg", dirx, dirx, "\n");
            code.push("add", tempf1, TL, BL, "\n");
            code.push("add", tempf2, TR, BR, "\n");
            code.push("sub", diry, tempf1, tempf2, "\n");
            code.push("add", tempf1, tempf1, tempf2, "\n");
            code.push("mul", tempf1, tempf1, fxaaReduceMul, "\n");
            code.push("mul", tempf1, tempf1, _025, "\n");
            code.push("max", dirReduce, tempf1, fxaaReduceMin, "\n");
            code.push("abs", tempf1, dirx, "\n");
            code.push("abs", tempf2, diry, "\n");
            code.push("min", tempf1, tempf1, tempf2, "\n");
            code.push("add", tempf1, tempf1, dirReduce, "\n");
            code.push("rcp", inverseDirAdjustment, tempf1, "\n");
            code.push("mul", tempf1, dirx, inverseDirAdjustment, "\n");
            code.push("mov", tempf2, fxaaSpanMax, "\n");
            code.push("neg", tempf2, tempf2, "\n");
            code.push("max", tempf1, tempf1, tempf2, "\n");
            code.push("min", tempf1, fxaaSpanMax, tempf1, "\n");
            code.push("mul", dirx, tempf1, dx, "\n");
            code.push("mul", tempf1, diry, inverseDirAdjustment, "\n");
            code.push("mov", tempf2, fxaaSpanMax, "\n");
            code.push("neg", tempf2, tempf2, "\n");
            code.push("max", tempf1, tempf1, tempf2, "\n");
            code.push("min", tempf1, fxaaSpanMax, tempf1, "\n");
            code.push("mul", diry, tempf1, dy, "\n");
            code.push("mul", tempxy, dirxy, delta1, "\n");
            code.push("add", uv, uv_in, tempxy, "\n");
            code.push("tex", result1, uv, sample, "<2d wrap linear>", "\n");
            code.push("mul", tempxy, dirxy, delta2, "\n");
            code.push("add", uv, uv_in, tempxy, "\n");
            code.push("tex", tex, uv, sample, "<2d wrap linear>", "\n");
            code.push("add", result1, result1, tex, "\n");
            code.push("mul", result1, result1, _05, "\n");
            code.push("mul", tempxy, dirxy, delta3, "\n");
            code.push("add", uv, uv_in, tempxy, "\n");
            code.push("tex", result2, uv, sample, "<2d wrap linear>", "\n");
            code.push("mul", tempxy, dirxy, delta4, "\n");
            code.push("add", uv, uv_in, tempxy, "\n");
            code.push("tex", tex, uv, sample, "<2d wrap linear>", "\n");
            code.push("add", result2, result2, tex, "\n");
            code.push("mul", result2, result2, _025, "\n");
            code.push("mul", tex, result1, _05, "\n");
            code.push("add", result2, result2, tex, "\n");
            code.push("min", tempf1, BL, BR, "\n");
            code.push("min", tempf2, TL, TR, "\n");
            code.push("min", tempf1, tempf1, tempf2, "\n");
            code.push("min", lumaMin, tempf1, M, "\n");
            code.push("max", tempf1, BL, BR, "\n");
            code.push("max", tempf2, TL, TR, "\n");
            code.push("max", tempf1, tempf1, tempf2, "\n");
            code.push("max", lumaMax, tempf1, M, "\n");
            code.push("dp3", tempf1, lum, result2, "\n");
            code.push("slt", tempf2, tempf1, lumaMin, "\n");
            code.push("sge", tempf3, tempf1, lumaMax, "\n");
            code.push("mul", tempf2, tempf2, tempf3, "\n");
            code.push("mul", result1, result1, tempf2, "\n");
            code.push("sub", tempf2, _1, tempf2, "\n");
            code.push("mul", result2, result2, tempf2, "\n");
            code.push("add", "oc", result1, result2, "\n");
            //this._data[2] = 1/numSamples;
            return code.join(" ");
        };
        Filter3DFXAATask.prototype.activate = function (stage, projection, depthTexture) {
            stage.context.setProgramConstantsFromArray(ContextGLProgramType.FRAGMENT, this._data);
        };
        Filter3DFXAATask.prototype.updateTextures = function (stage) {
            _super.prototype.updateTextures.call(this, stage);
            this.updateBlurData();
        };
        Filter3DFXAATask.prototype.updateBlurData = function () {
            // todo: must be normalized using view size ratio instead of texture
            if (this._rttManager) {
                this._data[8] = 1 / this._textureWidth;
                this._data[9] = 1 / this._textureHeight;
                //this._data[8] = 1/this._rttManager.viewWidth;
                //this._data[9] = 1/this._rttManager.viewHeight;
            }
        };
        Filter3DFXAATask.prototype.calculateStepSize = function () {
            this._realStepSize = 1; //this._stepSize > 0? this._stepSize : this._amount > Filter3DVBlurTask.MAX_AUTO_SAMPLES? this._amount/Filter3DVBlurTask.MAX_AUTO_SAMPLES : 1;
        };
        //TODO - remove blur variables and create setters/getters for FXAA
        Filter3DFXAATask.MAX_AUTO_SAMPLES = 15;
        return Filter3DFXAATask;
    }(Filter3DTaskBase));

    var Filter3DHBlurTask = /** @class */ (function (_super) {
        __extends$2(Filter3DHBlurTask, _super);
        /**
         * Creates a new Filter3DHDepthOfFFieldTask
         * @param amount The maximum amount of blur to apply in pixels at the most out-of-focus areas
         * @param stepSize The distance between samples. Set to -1 to autodetect with acceptable quality.
         */
        function Filter3DHBlurTask(amount, stepSize) {
            if (stepSize === void 0) { stepSize = -1; }
            var _this = _super.call(this) || this;
            _this._stepSize = 1;
            _this._amount = amount;
            _this._data = new Float32Array([0, 0, 0, 1]);
            _this.stepSize = stepSize;
            return _this;
        }
        Object.defineProperty(Filter3DHBlurTask.prototype, "amount", {
            get: function () {
                return this._amount;
            },
            set: function (value) {
                if (this._amount == value)
                    return;
                this._amount = value;
                this.invalidateProgram();
                this.updateBlurData();
                this.calculateStepSize();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DHBlurTask.prototype, "stepSize", {
            get: function () {
                return this._stepSize;
            },
            set: function (value) {
                if (this._stepSize == value)
                    return;
                this._stepSize = value;
                this.calculateStepSize();
                this.invalidateProgram();
                this.updateBlurData();
            },
            enumerable: true,
            configurable: true
        });
        Filter3DHBlurTask.prototype.getFragmentCode = function () {
            var temp1 = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(temp1, 1);
            var temp2 = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(temp2, 1);
            var temp3 = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(temp3, 1);
            var inputTexture = this._registerCache.getFreeTextureReg();
            this._inputTextureIndex = inputTexture.index;
            var blur = this._registerCache.getFreeFragmentConstant();
            this._blurIndex = blur.index * 4;
            var code;
            var numSamples = 1;
            code = "mov " + temp1 + ", " + this._uvVarying + "\n" +
                "sub " + temp1 + ".x, " + this._uvVarying + ".x, " + blur + ".x\n";
            code += "tex " + temp2 + ", " + temp1 + ", " + inputTexture + " <2d,linear,clamp>\n";
            for (var x = this._realStepSize; x <= this._amount; x += this._realStepSize) {
                code += "add " + temp1 + ".x, " + temp1 + ".x, " + blur + ".y\n" +
                    "tex " + temp3 + ", " + temp1 + ", " + inputTexture + " <2d,linear,clamp>\n" +
                    "add " + temp2 + ", " + temp2 + ", " + temp3 + "\n";
                ++numSamples;
            }
            code += "mul oc, " + temp2 + ", " + blur + ".z\n";
            this._data[2] = 1 / numSamples;
            return code;
        };
        Filter3DHBlurTask.prototype.activate = function (stage, projection, depthTexture) {
            stage.context.setProgramConstantsFromArray(ContextGLProgramType.FRAGMENT, this._data);
        };
        Filter3DHBlurTask.prototype.updateTextures = function (stage) {
            _super.prototype.updateTextures.call(this, stage);
            this.updateBlurData();
        };
        Filter3DHBlurTask.prototype.updateBlurData = function () {
            // todo: must be normalized using view size ratio instead of texture
            var invW = 1 / this._textureWidth;
            this._data[0] = this._amount * .5 * invW;
            this._data[1] = this._realStepSize * invW;
        };
        Filter3DHBlurTask.prototype.calculateStepSize = function () {
            this._realStepSize = this._stepSize > 0 ? this._stepSize : this._amount > Filter3DHBlurTask.MAX_AUTO_SAMPLES ? this._amount / Filter3DHBlurTask.MAX_AUTO_SAMPLES : 1;
        };
        Filter3DHBlurTask.MAX_AUTO_SAMPLES = 15;
        return Filter3DHBlurTask;
    }(Filter3DTaskBase));

    var Filter3DVBlurTask = /** @class */ (function (_super) {
        __extends$2(Filter3DVBlurTask, _super);
        /**
         *
         * @param amount
         * @param stepSize The distance between samples. Set to -1 to autodetect with acceptable quality.
         */
        function Filter3DVBlurTask(amount, stepSize) {
            if (stepSize === void 0) { stepSize = -1; }
            var _this = _super.call(this) || this;
            _this._stepSize = 1;
            _this._amount = amount;
            _this._data = new Float32Array([0, 0, 0, 1]);
            _this.stepSize = stepSize;
            return _this;
        }
        Object.defineProperty(Filter3DVBlurTask.prototype, "amount", {
            get: function () {
                return this._amount;
            },
            set: function (value) {
                if (this._amount == value)
                    return;
                this._amount = value;
                this.invalidateProgram();
                this.updateBlurData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DVBlurTask.prototype, "stepSize", {
            get: function () {
                return this._stepSize;
            },
            set: function (value) {
                if (this._stepSize == value)
                    return;
                this._stepSize = value;
                this.calculateStepSize();
                this.invalidateProgram();
                this.updateBlurData();
            },
            enumerable: true,
            configurable: true
        });
        Filter3DVBlurTask.prototype.getFragmentCode = function () {
            var temp1 = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(temp1, 1);
            var temp2 = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(temp2, 1);
            var temp3 = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(temp3, 1);
            var inputTexture = this._registerCache.getFreeTextureReg();
            this._inputTextureIndex = inputTexture.index;
            var blur = this._registerCache.getFreeFragmentConstant();
            this._blurIndex = blur.index * 4;
            var code;
            var numSamples = 1;
            code = "mov " + temp1 + ", " + this._uvVarying + "\n" +
                "sub " + temp1 + ".y, " + this._uvVarying + ".y, " + blur + ".x\n";
            code += "tex " + temp2 + ", " + temp1 + ", " + inputTexture + " <2d,linear,clamp>\n";
            for (var x = this._realStepSize; x <= this._amount; x += this._realStepSize) {
                code += "add " + temp1 + ".y, " + temp1 + ".y, " + blur + ".y\n";
                code += "tex " + temp3 + ", " + temp1 + ", " + inputTexture + " <2d,linear,clamp>\n" +
                    "add " + temp2 + ", " + temp2 + ", " + temp3 + "\n";
                ++numSamples;
            }
            code += "mul oc, " + temp2 + ", " + blur + ".z\n";
            this._data[2] = 1 / numSamples;
            return code;
        };
        Filter3DVBlurTask.prototype.activate = function (stage, projection, depthTexture) {
            stage.context.setProgramConstantsFromArray(ContextGLProgramType.FRAGMENT, this._data);
        };
        Filter3DVBlurTask.prototype.updateTextures = function (stage) {
            _super.prototype.updateTextures.call(this, stage);
            this.updateBlurData();
        };
        Filter3DVBlurTask.prototype.updateBlurData = function () {
            // todo: must be normalized using view size ratio instead of texture
            var invH = 1 / this._textureHeight;
            this._data[0] = this._amount * .5 * invH;
            this._data[1] = this._realStepSize * invH;
        };
        Filter3DVBlurTask.prototype.calculateStepSize = function () {
            this._realStepSize = this._stepSize > 0 ? this._stepSize : this._amount > Filter3DVBlurTask.MAX_AUTO_SAMPLES ? this._amount / Filter3DVBlurTask.MAX_AUTO_SAMPLES : 1;
        };
        Filter3DVBlurTask.MAX_AUTO_SAMPLES = 15;
        return Filter3DVBlurTask;
    }(Filter3DTaskBase));

    var BlurFilter3D = /** @class */ (function (_super) {
        __extends$2(BlurFilter3D, _super);
        /**
         * Creates a new BlurFilter3D object
         * @param blurX The amount of horizontal blur to apply
         * @param blurY The amount of vertical blur to apply
         * @param stepSize The distance between samples. Set to -1 to autodetect with acceptable quality.
         */
        function BlurFilter3D(blurX, blurY, stepSize) {
            if (blurX === void 0) { blurX = 3; }
            if (blurY === void 0) { blurY = 3; }
            if (stepSize === void 0) { stepSize = -1; }
            var _this = _super.call(this) || this;
            _this._hBlurTask = new Filter3DHBlurTask(blurX, stepSize);
            _this._vBlurTask = new Filter3DVBlurTask(blurY, stepSize);
            _this.addTask(_this._hBlurTask);
            _this.addTask(_this._vBlurTask);
            return _this;
        }
        Object.defineProperty(BlurFilter3D.prototype, "blurX", {
            get: function () {
                return this._hBlurTask.amount;
            },
            set: function (value) {
                this._hBlurTask.amount = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BlurFilter3D.prototype, "blurY", {
            get: function () {
                return this._vBlurTask.amount;
            },
            set: function (value) {
                this._vBlurTask.amount = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BlurFilter3D.prototype, "stepSize", {
            /**
             * The distance between two blur samples. Set to -1 to autodetect with acceptable quality (default value).
             * Higher values provide better performance at the cost of reduces quality.
             */
            get: function () {
                return this._hBlurTask.stepSize;
            },
            set: function (value) {
                this._hBlurTask.stepSize = value;
                this._vBlurTask.stepSize = value;
            },
            enumerable: true,
            configurable: true
        });
        BlurFilter3D.prototype.setRenderTargets = function (mainTarget, stage) {
            this._hBlurTask.target = this._vBlurTask.getMainInputTexture(stage);
            _super.prototype.setRenderTargets.call(this, mainTarget, stage);
        };
        return BlurFilter3D;
    }(Filter3DBase));

    var CompositeFilter3D = /** @class */ (function (_super) {
        __extends$2(CompositeFilter3D, _super);
        /**
         * Creates a new CompositeFilter3D object
         * @param blurX The amount of horizontal blur to apply
         * @param blurY The amount of vertical blur to apply
         * @param stepSize The distance between samples. Set to -1 to autodetect with acceptable quality.
         */
        function CompositeFilter3D(blendMode, exposure) {
            if (exposure === void 0) { exposure = 1; }
            var _this = _super.call(this) || this;
            _this._compositeTask = new Filter3DCompositeTask(blendMode, exposure);
            _this.addTask(_this._compositeTask);
            return _this;
        }
        Object.defineProperty(CompositeFilter3D.prototype, "exposure", {
            get: function () {
                return this._compositeTask.exposure;
            },
            set: function (value) {
                this._compositeTask.exposure = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(CompositeFilter3D.prototype, "overlayTexture", {
            get: function () {
                return this._compositeTask.overlayTexture;
            },
            set: function (value) {
                this._compositeTask.overlayTexture = value;
            },
            enumerable: true,
            configurable: true
        });
        return CompositeFilter3D;
    }(Filter3DBase));

    var FXAAFilter3D = /** @class */ (function (_super) {
        __extends$2(FXAAFilter3D, _super);
        /**
         * Creates a new FXAAFilter3D object
         * @param amount
         * @param stepSize The distance between samples. Set to -1 to autodetect with acceptable quality.
         */
        function FXAAFilter3D(amount, stepSize) {
            if (stepSize === void 0) { stepSize = -1; }
            var _this = _super.call(this) || this;
            _this._fxaaTask = new Filter3DFXAATask(amount, stepSize);
            _this.addTask(_this._fxaaTask);
            return _this;
        }
        Object.defineProperty(FXAAFilter3D.prototype, "amount", {
            get: function () {
                return this._fxaaTask.amount;
            },
            set: function (value) {
                this._fxaaTask.amount = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FXAAFilter3D.prototype, "stepSize", {
            get: function () {
                return this._fxaaTask.stepSize;
            },
            set: function (value) {
                this._fxaaTask.stepSize = value;
            },
            enumerable: true,
            configurable: true
        });
        return FXAAFilter3D;
    }(Filter3DBase));

    /**
     * The StageManager class provides a multiton object that handles management for Stage objects.
     *
     * @see away.base.Stage
     */
    var StageManager = /** @class */ (function (_super) {
        __extends$2(StageManager, _super);
        /**
         * Creates a new StageManager class.
         * @param stage The Stage object that contains the Stage objects to be managed.
         * @private
         */
        function StageManager() {
            var _this = _super.call(this) || this;
            _this._stages = new Array(StageManager.STAGE_MAX_QUANTITY);
            _this._onContextCreatedDelegate = function (event) { return _this.onContextCreated(event); };
            return _this;
        }
        /**
         * Gets a StageManager instance for the given Stage object.
         * @param stage The Stage object that contains the Stage objects to be managed.
         * @return The StageManager instance for the given Stage object.
         */
        StageManager.getInstance = function () {
            if (this._instance == null)
                this._instance = new StageManager();
            return this._instance;
        };
        /**
         * Requests the Stage for the given index.
         *
         * @param index The index of the requested Stage.
         * @param forceSoftware Whether to force software mode even if hardware acceleration is available.
         * @param profile The compatibility profile, an enumeration of ContextProfile
         * @return The Stage for the given index.
         */
        StageManager.prototype.getStageAt = function (index, forceSoftware, profile, mode, alpha) {
            if (forceSoftware === void 0) { forceSoftware = false; }
            if (profile === void 0) { profile = ContextGLProfile.BASELINE; }
            if (mode === void 0) { mode = ContextMode.AUTO; }
            if (alpha === void 0) { alpha = false; }
            if (index < 0 || index >= StageManager.STAGE_MAX_QUANTITY)
                throw new ArgumentError("Index is out of bounds [0.." + StageManager.STAGE_MAX_QUANTITY + "]");
            if (!this._stages[index]) {
                StageManager._numStages++;
                if (document && StageManager.htmlCanvas == null) {
                    var canvas = document.createElement("canvas");
                    canvas.id = "stage" + index;
                    document.body.appendChild(canvas);
                }
                else if (StageManager.htmlCanvas) {
                    var canvas = StageManager.htmlCanvas;
                }
                var stage = this._stages[index] = new Stage(canvas, index, this, forceSoftware, profile);
                stage.addEventListener(StageEvent.CONTEXT_CREATED, this._onContextCreatedDelegate);
                stage.requestContext(forceSoftware, profile, mode, alpha);
            }
            return this._stages[index];
        };
        /**
         * Removes a Stage from the manager.
         * @param stage
         * @private
         */
        StageManager.prototype.iRemoveStage = function (stage) {
            StageManager._numStages--;
            stage.removeEventListener(StageEvent.CONTEXT_CREATED, this._onContextCreatedDelegate);
            this._stages[stage.stageIndex] = null;
        };
        /**
         * Get the next available stage. An error is thrown if there are no StageProxies available
         * @param forceSoftware Whether to force software mode even if hardware acceleration is available.
         * @param profile The compatibility profile, an enumeration of ContextProfile
         * @return The allocated stage
         */
        StageManager.prototype.getFreeStage = function (forceSoftware, profile, mode, alpha) {
            if (forceSoftware === void 0) { forceSoftware = false; }
            if (profile === void 0) { profile = ContextGLProfile.BASELINE; }
            if (mode === void 0) { mode = ContextMode.AUTO; }
            if (alpha === void 0) { alpha = false; }
            var i = 0;
            var len = this._stages.length;
            while (i < len) {
                if (!this._stages[i])
                    return this.getStageAt(i, forceSoftware, profile, mode, alpha);
                ++i;
            }
            return null;
        };
        Object.defineProperty(StageManager.prototype, "hasFreeStage", {
            /**
             * Checks if a new stage can be created and managed by the class.
             * @return true if there is one slot free for a new stage
             */
            get: function () {
                return StageManager._numStages < StageManager.STAGE_MAX_QUANTITY ? true : false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(StageManager.prototype, "numSlotsFree", {
            /**
             * Returns the amount of stage objects that can be created and managed by the class
             * @return the amount of free slots
             */
            get: function () {
                return StageManager.STAGE_MAX_QUANTITY - StageManager._numStages;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(StageManager.prototype, "numSlotsUsed", {
            /**
             * Returns the amount of Stage objects currently managed by the class.
             * @return the amount of slots used
             */
            get: function () {
                return StageManager._numStages;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(StageManager.prototype, "numSlotsTotal", {
            /**
             * The maximum amount of Stage objects that can be managed by the class
             */
            get: function () {
                return this._stages.length;
            },
            enumerable: true,
            configurable: true
        });
        StageManager.prototype.onContextCreated = function (event) {
            //var stage:Stage = <Stage> e.target;
            //document.body.appendChild(stage.canvas)
        };
        StageManager.STAGE_MAX_QUANTITY = 8;
        StageManager.htmlCanvas = null;
        StageManager._numStages = 0;
        return StageManager;
    }(EventDispatcher));

    var RTTBufferManager = /** @class */ (function (_super) {
        __extends$2(RTTBufferManager, _super);
        function RTTBufferManager(stage, powerOfTwo) {
            if (powerOfTwo === void 0) { powerOfTwo = true; }
            var _this = _super.call(this) || this;
            _this._viewOffsetX = 0;
            _this._viewOffsetY = 0;
            _this._viewWidth = -1;
            _this._viewHeight = -1;
            _this._textureWidth = -1;
            _this._textureHeight = -1;
            _this._buffersInvalid = true;
            _this._renderToTextureRect = new Rectangle();
            _this._stage = stage;
            _this._powerOfTwo = powerOfTwo;
            return _this;
        }
        RTTBufferManager.getInstance = function (stage) {
            if (!stage)
                throw new Error("stage key cannot be null!");
            if (RTTBufferManager._instances == null)
                RTTBufferManager._instances = new Array();
            var rttBufferManager = RTTBufferManager.getRTTBufferManagerFromStage(stage);
            if (rttBufferManager == null) {
                rttBufferManager = new RTTBufferManager(stage);
                var vo = new RTTBufferManagerVO();
                vo.stage3d = stage;
                vo.rttbfm = rttBufferManager;
                RTTBufferManager._instances.push(vo);
            }
            return rttBufferManager;
        };
        RTTBufferManager.getRTTBufferManagerFromStage = function (stage) {
            var l = RTTBufferManager._instances.length;
            var r;
            for (var c = 0; c < l; c++) {
                r = RTTBufferManager._instances[c];
                if (r.stage3d === stage)
                    return r.rttbfm;
            }
            return null;
        };
        RTTBufferManager.deleteRTTBufferManager = function (stage) {
            var l = RTTBufferManager._instances.length;
            var r;
            for (var c = 0; c < l; c++) {
                r = RTTBufferManager._instances[c];
                if (r.stage3d === stage) {
                    RTTBufferManager._instances.splice(c, 1);
                    return;
                }
            }
        };
        Object.defineProperty(RTTBufferManager.prototype, "textureRatioX", {
            get: function () {
                if (this._buffersInvalid)
                    this.updateRTTBuffers();
                return this._textureRatioX;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RTTBufferManager.prototype, "textureRatioY", {
            get: function () {
                if (this._buffersInvalid)
                    this.updateRTTBuffers();
                return this._textureRatioY;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RTTBufferManager.prototype, "viewOffsetX", {
            get: function () {
                return this._viewOffsetX;
            },
            set: function (value) {
                this._viewOffsetX = value;
                this._buffersInvalid = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RTTBufferManager.prototype, "viewOffsetY", {
            get: function () {
                return this._viewOffsetY;
            },
            set: function (value) {
                this._viewOffsetY = value;
                this._buffersInvalid = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RTTBufferManager.prototype, "viewWidth", {
            get: function () {
                return this._viewWidth;
            },
            set: function (value) {
                if (value == this._viewWidth)
                    return;
                this._viewWidth = value;
                this._buffersInvalid = true;
                this._textureWidth = this._powerOfTwo ? ImageUtils.getBestPowerOf2(this._viewWidth) : this._viewWidth;
                if (this._textureWidth > this._viewWidth) {
                    this._renderToTextureRect.x = Math.floor((this._textureWidth - this._viewWidth) * .5);
                    this._renderToTextureRect.width = this._viewWidth;
                }
                else {
                    this._renderToTextureRect.x = 0;
                    this._renderToTextureRect.width = this._textureWidth;
                }
                this.dispatchEvent(new RTTEvent(RTTEvent.RESIZE, this));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RTTBufferManager.prototype, "viewHeight", {
            get: function () {
                return this._viewHeight;
            },
            set: function (value) {
                if (value == this._viewHeight)
                    return;
                this._viewHeight = value;
                this._buffersInvalid = true;
                this._textureHeight = this._powerOfTwo ? ImageUtils.getBestPowerOf2(this._viewHeight) : this._viewHeight;
                if (this._textureHeight > this._viewHeight) {
                    this._renderToTextureRect.y = Math.floor((this._textureHeight - this._viewHeight) * .5);
                    this._renderToTextureRect.height = this._viewHeight;
                }
                else {
                    this._renderToTextureRect.y = 0;
                    this._renderToTextureRect.height = this._textureHeight;
                }
                this.dispatchEvent(new RTTEvent(RTTEvent.RESIZE, this));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RTTBufferManager.prototype, "renderToTextureVertexBuffer", {
            get: function () {
                if (this._buffersInvalid)
                    this.updateRTTBuffers();
                return this._renderToTextureVertexBuffer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RTTBufferManager.prototype, "renderToScreenVertexBuffer", {
            get: function () {
                if (this._buffersInvalid)
                    this.updateRTTBuffers();
                return this._renderToScreenVertexBuffer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RTTBufferManager.prototype, "indexBuffer", {
            get: function () {
                if (this._buffersInvalid)
                    this.updateRTTBuffers();
                return this._indexBuffer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RTTBufferManager.prototype, "renderToTextureRect", {
            get: function () {
                if (this._buffersInvalid)
                    this.updateRTTBuffers();
                return this._renderToTextureRect;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RTTBufferManager.prototype, "textureWidth", {
            get: function () {
                return this._textureWidth;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RTTBufferManager.prototype, "textureHeight", {
            get: function () {
                return this._textureHeight;
            },
            enumerable: true,
            configurable: true
        });
        RTTBufferManager.prototype.dispose = function () {
            RTTBufferManager.deleteRTTBufferManager(this._stage);
            if (this._indexBuffer) {
                this._indexBuffer.dispose();
                this._renderToScreenVertexBuffer.dispose();
                this._renderToTextureVertexBuffer.dispose();
                this._renderToScreenVertexBuffer = null;
                this._renderToTextureVertexBuffer = null;
                this._indexBuffer = null;
            }
        };
        // todo: place all this in a separate model, since it's used all over the place
        // maybe it even has a place in the core (together with screenRect etc)?
        // needs to be stored per view of course
        RTTBufferManager.prototype.updateRTTBuffers = function () {
            var context = this._stage.context;
            var textureVerts;
            var screenVerts;
            var x;
            var y;
            if (this._renderToTextureVertexBuffer == null)
                this._renderToTextureVertexBuffer = context.createVertexBuffer(4, 20);
            if (this._renderToScreenVertexBuffer == null)
                this._renderToScreenVertexBuffer = context.createVertexBuffer(4, 20);
            if (!this._indexBuffer) {
                this._indexBuffer = context.createIndexBuffer(6);
                this._indexBuffer.uploadFromArray(new Uint16Array([2, 1, 0, 3, 2, 0]), 0, 6);
            }
            this._textureRatioX = x = Math.min(this._viewWidth / this._textureWidth, 1);
            this._textureRatioY = y = Math.min(this._viewHeight / this._textureHeight, 1);
            var u1 = (1 - x) * .5;
            var u2 = (x + 1) * .5;
            var v1 = (1 - y) * .5;
            var v2 = (y + 1) * .5;
            // last element contains indices for data per vertex that can be passed to the vertex shader if necessary (ie: frustum corners for deferred rendering)
            textureVerts = new Float32Array([-x, -y, u1, v1, 0, x, -y, u2, v1, 1, x, y, u2, v2, 2, -x, y, u1, v2, 3]);
            screenVerts = new Float32Array([-1, -1, u1, v1, 0, 1, -1, u2, v1, 1, 1, 1, u2, v2, 2, -1, 1, u1, v2, 3]);
            this._renderToTextureVertexBuffer.uploadFromArray(textureVerts, 0, 4);
            this._renderToScreenVertexBuffer.uploadFromArray(screenVerts, 0, 4);
            this._buffersInvalid = false;
        };
        return RTTBufferManager;
    }(EventDispatcher));
    var RTTBufferManagerVO = /** @class */ (function () {
        function RTTBufferManagerVO() {
        }
        return RTTBufferManagerVO;
    }());

    /**
     * Image2DParser provides a "parser" for natively supported image types (jpg, png). While it simply loads bytes into
     * a loader object, it wraps it in a BitmapDataResource so resource management can happen consistently without
     * exception cases.
     */
    var Image2DParser = /** @class */ (function (_super) {
        __extends$2(Image2DParser, _super);
        /**
         * Creates a new Image2DParser object.
         * @param uri The url or id of the data or file to be parsed.
         * @param extra The holder for extra contextual data that the parser might need.
         */
        function Image2DParser(factory, alphaChannel) {
            if (factory === void 0) { factory = null; }
            if (alphaChannel === void 0) { alphaChannel = null; }
            var _this = _super.call(this, URLLoaderDataFormat.BLOB) || this;
            _this._factory = factory || new DefaultGraphicsFactory();
            _this._alphaChannel = alphaChannel;
            return _this;
        }
        /**
         * Indicates whether or not a given file extension is supported by the parser.
         * @param extension The file extension of a potential file to be parsed.
         * @return Whether or not the given file type is supported.
         */
        Image2DParser.supportsType = function (extension) {
            extension = extension.toLowerCase();
            return extension == "jpg" || extension == "jpeg" || extension == "png" || extension == "gif"; //|| extension == "bmp";//|| extension == "atf";
        };
        /**
         * Tests whether a data block can be parsed by the parser.
         * @param data The data block to potentially be parsed.
         * @return Whether or not the given data is supported.
         */
        Image2DParser.supportsData = function (data) {
            if (data instanceof HTMLImageElement)
                return true;
            if (!(data instanceof ByteArray))
                return false;
            var ba = data;
            ba.position = 0;
            if (ba.readUnsignedShort() == 0xd8ff)
                return true; // JPEG, maybe check for "JFIF" as well?
            ba.position = 0;
            if (ba.readShort() == 0x424D)
                return true; // BMP
            ba.position = 1;
            if (ba.readUTFBytes(3) == 'PNG')
                return true;
            ba.position = 0;
            if (ba.readUTFBytes(3) == 'GIF' && ba.readShort() == 0x3839 && ba.readByte() == 0x61)
                return true;
            ba.position = 0;
            if (ba.readUTFBytes(3) == 'ATF')
                return true;
            return false;
        };
        Image2DParser.prototype._pFinalizeAsset = function (asset, fileName) {
            if (this._alphaChannel)
                asset.alphaChannel = this._alphaChannel;
            _super.prototype._pFinalizeAsset.call(this, asset, fileName);
        };
        /**
         * @inheritDoc
         */
        Image2DParser.prototype._pProceedParsing = function () {
            var _this = this;
            var asset;
            if (this._loadingImage) {
                return ParserBase.MORE_TO_PARSE;
            }
            else if (this._htmlImageElement) {
                //if (ImageUtils.isHTMLImageElementValid(this._htmlImageElement)) {
                asset = ImageUtils.imageToBitmapImage2D(this._htmlImageElement, false, this._factory);
                this._pFinalizeAsset(asset, this._iFileName);
                //}
            }
            else if (this.data instanceof HTMLImageElement) { // Parse HTMLImageElement
                var htmlImageElement = this.data;
                //if (ImageUtils.isHTMLImageElementValid(htmlImageElement)) {
                asset = ImageUtils.imageToBitmapImage2D(htmlImageElement, false, this._factory);
                this._pFinalizeAsset(asset, this._iFileName);
                //} else {
                //	sizeError = true;
                //}
            }
            else if (this.data instanceof ByteArray) { // Parse a ByteArray
                var ba = this.data;
                ba.position = 0;
                this._htmlImageElement = ParserUtils.byteArrayToImage(this.data);
                if (!this._htmlImageElement.naturalWidth) {
                    this._htmlImageElement.onload = function (event) { return _this.onLoadComplete(event); };
                    this._loadingImage = true;
                    return ParserBase.MORE_TO_PARSE;
                }
                //if (ImageUtils.isHTMLImageElementValid(this._htmlImageElement)) {
                asset = ImageUtils.imageToBitmapImage2D(this._htmlImageElement, false, this._factory);
                this._pFinalizeAsset(asset, this._iFileName);
                //} else {
                //	sizeError = true;
                //
                //}
            }
            else if (this.data instanceof ArrayBuffer) { // Parse an ArrayBuffer
                this._htmlImageElement = ParserUtils.arrayBufferToImage(this.data);
                asset = ImageUtils.imageToBitmapImage2D(this._htmlImageElement, false, this._factory);
                this._pFinalizeAsset(asset, this._iFileName);
            }
            else if (this.data instanceof Blob) { // Parse a Blob
                this._htmlImageElement = ParserUtils.blobToImage(this.data);
                this._htmlImageElement.onload = function (event) { return _this.onLoadComplete(event); };
                this._loadingImage = true;
                return ParserBase.MORE_TO_PARSE;
            }
            else if (this.data instanceof URLRequest) { // Parse a URLRequest
                asset = new ExternalImage2D(this.data);
                this._pFinalizeAsset(asset, this._iFileName);
            }
            this._pContent = asset;
            return ParserBase.PARSING_DONE;
        };
        Image2DParser.prototype.onLoadComplete = function (event) {
            this._loadingImage = false;
        };
        return Image2DParser;
    }(ParserBase));

    /**
     * ImageCubeParser provides a "parser" for natively supported image types (jpg, png). While it simply loads bytes into
     * a loader object, it wraps it in a BitmapImage2DResource so resource management can happen consistently without
     * exception cases.
     */
    var ImageCubeParser = /** @class */ (function (_super) {
        __extends$2(ImageCubeParser, _super);
        /**
         * Creates a new ImageCubeParser object.
         * @param uri The url or id of the data or file to be parsed.
         * @param extra The holder for extra contextual data that the parser might need.
         */
        function ImageCubeParser() {
            return _super.call(this, URLLoaderDataFormat.TEXT) || this;
        }
        /**
         * Indicates whether or not a given file extension is supported by the parser.
         * @param extension The file extension of a potential file to be parsed.
         * @return Whether or not the given file type is supported.
         */
        ImageCubeParser.supportsType = function (extension) {
            extension = extension.toLowerCase();
            return extension == "cube";
        };
        /**
         * Tests whether a data block can be parsed by the parser.
         * @param data The data block to potentially be parsed.
         * @return Whether or not the given data is supported.
         */
        ImageCubeParser.supportsData = function (data) {
            try {
                var obj = JSON.parse(data);
                if (obj)
                    return true;
                return false;
            }
            catch (e) {
                return false;
            }
        };
        /**
         * @inheritDoc
         */
        ImageCubeParser.prototype._iResolveDependency = function (resourceDependency) {
        };
        /**
         * @inheritDoc
         */
        ImageCubeParser.prototype._iResolveDependencyFailure = function (resourceDependency) {
        };
        /**
         * @inheritDoc
         */
        ImageCubeParser.prototype._pProceedParsing = function () {
            if (this._imgDependencyDictionary != null) { //all images loaded
                var asset = new BitmapImageCube(this._getBitmapImage2D(ImageCubeParser.posX).width);
                var rect = new Rectangle(0, 0, asset.size, asset.size);
                asset.setPixels(BitmapImageCube.posX, rect, this._getBitmapImage2D(ImageCubeParser.posX).data);
                asset.setPixels(BitmapImageCube.negX, rect, this._getBitmapImage2D(ImageCubeParser.negX).data);
                asset.setPixels(BitmapImageCube.posY, rect, this._getBitmapImage2D(ImageCubeParser.posY).data);
                asset.setPixels(BitmapImageCube.negY, rect, this._getBitmapImage2D(ImageCubeParser.negY).data);
                asset.setPixels(BitmapImageCube.posZ, rect, this._getBitmapImage2D(ImageCubeParser.posZ).data);
                asset.setPixels(BitmapImageCube.negZ, rect, this._getBitmapImage2D(ImageCubeParser.negZ).data);
                //clear dictionary
                this._imgDependencyDictionary = null;
                asset.name = this._iFileName;
                this._pFinalizeAsset(asset, this._iFileName);
                return ParserBase.PARSING_DONE;
            }
            try {
                var json = JSON.parse(this.data);
                var data = json.data;
                var rec;
                if (data.length != 6)
                    this._pDieWithError('ImageCubeParser: Error - cube texture should have exactly 6 images');
                if (json) {
                    this._imgDependencyDictionary = new Object();
                    for (var c = 0; c < data.length; c++) {
                        rec = data[c];
                        this._imgDependencyDictionary[rec.id] = this._pAddDependency(rec.id, new URLRequest(rec.image.toString()));
                    }
                    if (!this._validateCubeData()) {
                        this._pDieWithError("ImageCubeParser: JSON data error - cubes require id of:   \n" + ImageCubeParser.posX + ', ' + ImageCubeParser.negX + ',  \n' + ImageCubeParser.posY + ', ' + ImageCubeParser.negY + ',  \n' + ImageCubeParser.posZ + ', ' + ImageCubeParser.negZ);
                        return ParserBase.PARSING_DONE;
                    }
                    this._pPauseAndRetrieveDependencies();
                    return ParserBase.MORE_TO_PARSE;
                }
            }
            catch (e) {
                this._pDieWithError('CubeTexturePaser Error parsing JSON');
            }
            return ParserBase.PARSING_DONE;
        };
        ImageCubeParser.prototype._validateCubeData = function () {
            return (this._imgDependencyDictionary[ImageCubeParser.posX] != null && this._imgDependencyDictionary[ImageCubeParser.negX] != null && this._imgDependencyDictionary[ImageCubeParser.posY] != null && this._imgDependencyDictionary[ImageCubeParser.negY] != null && this._imgDependencyDictionary[ImageCubeParser.posZ] != null && this._imgDependencyDictionary[ImageCubeParser.negZ] != null);
        };
        ImageCubeParser.prototype._getBitmapImage2D = function (name) {
            var dependency = this._imgDependencyDictionary[name];
            if (dependency)
                return dependency.assets[0];
            return null;
        };
        ImageCubeParser.posX = 'posX';
        ImageCubeParser.negX = 'negX';
        ImageCubeParser.posY = 'posY';
        ImageCubeParser.negY = 'negY';
        ImageCubeParser.posZ = 'posZ';
        ImageCubeParser.negZ = 'negZ';
        return ImageCubeParser;
    }(ParserBase));

    /**
     * TextureAtlasParser provides a "parser" for natively supported image types (jpg, png). While it simply loads bytes into
     * a loader object, it wraps it in a BitmapImage2DResource so resource management can happen consistently without
     * exception cases.
     */
    var TextureAtlasParser = /** @class */ (function (_super) {
        __extends$2(TextureAtlasParser, _super);
        /**
         * Creates a new TextureAtlasParser object.
         * @param uri The url or id of the data or file to be parsed.
         * @param extra The holder for extra contextual data that the parser might need.
         */
        function TextureAtlasParser() {
            var _this = _super.call(this, URLLoaderDataFormat.TEXT) || this;
            _this._parseState = 0;
            return _this;
        }
        /**
         * Indicates whether or not a given file extension is supported by the parser.
         * @param extension The file extension of a potential file to be parsed.
         * @return Whether or not the given file type is supported.
         */
        TextureAtlasParser.supportsType = function (extension) {
            extension = extension.toLowerCase();
            return extension == "xml";
        };
        /**
         * Tests whether a data block can be parsed by the parser.
         * @param data The data block to potentially be parsed.
         * @return Whether or not the given data is supported.
         */
        TextureAtlasParser.supportsData = function (data) {
            try {
                var content = ParserUtils.toString(data);
                if (content.indexOf("TextureAtlas") != -1 || content.indexOf("textureatlas") != -1)
                    return true;
                return false;
            }
            catch (e) {
                return false;
            }
        };
        /**
         * @inheritDoc
         */
        TextureAtlasParser.prototype._iResolveDependency = function (resourceDependency) {
            if (resourceDependency.assets.length) {
                this._imageData = resourceDependency.assets[0];
                this._pFinalizeAsset(this._imageData);
                this._parseState = TextureAtlasParserState.PARSE_SUBTEXTURES;
            }
            else {
                this._parseState = TextureAtlasParserState.PARSE_COMPLETE;
            }
        };
        /**
         * @inheritDoc
         */
        TextureAtlasParser.prototype._iResolveDependencyFailure = function (resourceDependency) {
            this._parseState = TextureAtlasParserState.PARSE_COMPLETE;
        };
        /**
         * @inheritDoc
         */
        TextureAtlasParser.prototype._pProceedParsing = function () {
            switch (this._parseState) {
                case TextureAtlasParserState.PARSE_XML:
                    try {
                        this._doc = XmlUtils.getChildrenWithTag(XmlUtils.strToXml(this._pGetTextData()), "TextureAtlas")[0];
                        this._imagePath = XmlUtils.readAttributeValue(this._doc, "imagePath");
                        this._subTextureNodes = XmlUtils.getChildrenWithTag(this._doc, "SubTexture");
                        this._parseState = TextureAtlasParserState.PARSE_IMAGE;
                    }
                    catch (Error) {
                        return ParserBase.PARSING_DONE;
                    }
                    break;
                case TextureAtlasParserState.PARSE_IMAGE:
                    if (this._imagePath) {
                        this._pAddDependency(this._imagePath, new URLRequest(this._imagePath));
                        this._pPauseAndRetrieveDependencies();
                    }
                    else {
                        return ParserBase.PARSING_DONE;
                    }
                    break;
                case TextureAtlasParserState.PARSE_SUBTEXTURES:
                    var sampler;
                    var element;
                    var x;
                    var y;
                    var width;
                    var height;
                    var len = this._subTextureNodes.length;
                    for (var i = 0; i < len; i++) {
                        element = this._subTextureNodes[i];
                        sampler = new ImageSampler();
                        //setup subtexture rect
                        x = XmlUtils.readAttributeValue(element, "x");
                        y = XmlUtils.readAttributeValue(element, "y");
                        width = XmlUtils.readAttributeValue(element, "width");
                        height = XmlUtils.readAttributeValue(element, "height");
                        if (x || y || width || height)
                            sampler.imageRect = new Rectangle(parseInt(x) / this._imageData.width, parseInt(y) / this._imageData.height, parseInt(width) / this._imageData.width, parseInt(height) / this._imageData.height);
                        //setup frame rect
                        x = XmlUtils.readAttributeValue(element, "frameX");
                        y = XmlUtils.readAttributeValue(element, "frameY");
                        width = XmlUtils.readAttributeValue(element, "frameWidth");
                        height = XmlUtils.readAttributeValue(element, "frameHeight");
                        if (x || y || width || height)
                            sampler.frameRect = new Rectangle(parseInt(x), parseInt(y), parseInt(width), parseInt(height));
                        this._pFinalizeAsset(sampler, XmlUtils.readAttributeValue(element, "name"));
                    }
                    this._parseState = TextureAtlasParserState.PARSE_COMPLETE;
                    break;
                case TextureAtlasParserState.PARSE_COMPLETE:
                    return ParserBase.PARSING_DONE;
            }
            return ParserBase.MORE_TO_PARSE;
        };
        return TextureAtlasParser;
    }(ParserBase));
    var TextureAtlasParserState = /** @class */ (function () {
        function TextureAtlasParserState() {
        }
        TextureAtlasParserState.PARSE_XML = 0;
        TextureAtlasParserState.PARSE_IMAGE = 1;
        TextureAtlasParserState.PARSE_SUBTEXTURES = 2;
        TextureAtlasParserState.PARSE_COMPLETE = 3;
        return TextureAtlasParserState;
    }());

    /**
     * ShaderRegisterData contains the "named" registers, generated by the compiler and to be passed on to the methods.
     */
    var ShaderRegisterData = /** @class */ (function () {
        function ShaderRegisterData() {
            this.textures = new Array();
            this.animatableAttributes = new Array();
            this.animationTargetRegisters = new Array();
        }
        return ShaderRegisterData;
    }());

    var AttributesBuffer = /** @class */ (function (_super) {
        __extends$2(AttributesBuffer, _super);
        /**
         *
         */
        function AttributesBuffer(stride, count) {
            if (stride === void 0) { stride = 0; }
            if (count === void 0) { count = 0; }
            var _this = _super.call(this) || this;
            _this._count = 0;
            _this._newCount = 0;
            _this._stride = 0;
            _this._newStride = 0;
            _this._viewVOs = new Array();
            _this._stride = _this._newStride = stride;
            _this._count = _this._newCount = count;
            _this._buffer = new ArrayBuffer(_this._stride * _this._count);
            _this._bufferView = new Uint8Array(_this._buffer, 0, _this._buffer.byteLength);
            return _this;
        }
        Object.defineProperty(AttributesBuffer.prototype, "assetType", {
            /**
             * @returns {string}
             */
            get: function () {
                return AttributesBuffer.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesBuffer.prototype, "stride", {
            get: function () {
                if (this._lengthDirty)
                    this._updateLength();
                return this._stride;
            },
            set: function (value) {
                if (this._newStride == value)
                    return;
                this._newStride = value;
                this.resize();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesBuffer.prototype, "count", {
            get: function () {
                return this._newCount;
            },
            set: function (value) {
                if (this._newCount == value)
                    return;
                this._newCount = value;
                this.resize();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesBuffer.prototype, "buffer", {
            get: function () {
                if (this._lengthDirty)
                    this._updateLength();
                this._contentDirty = false;
                return this._buffer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesBuffer.prototype, "bufferView", {
            get: function () {
                if (this._lengthDirty)
                    this._updateLength();
                this._contentDirty = false;
                return this._bufferView;
            },
            set: function (value) {
                this._bufferView = value;
                this._buffer = this._bufferView.buffer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesBuffer.prototype, "length", {
            get: function () {
                return this._count * this.stride;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        AttributesBuffer.prototype.invalidate = function () {
            if (this._contentDirty)
                return;
            _super.prototype.invalidate.call(this);
            this._contentDirty = true;
        };
        /**
         *
         * @private
         */
        AttributesBuffer.prototype.resize = function () {
            if (this._lengthDirty)
                return;
            this.clear();
            this._lengthDirty = true;
            //dispose buffer if stride is 0
            if (!this._newStride) {
                this._buffer = null;
                this._bufferView = null;
            }
        };
        AttributesBuffer.prototype.cloneBufferView = function () {
            var attributesBuffer = new AttributesBuffer(this._stride, this._count);
            attributesBuffer.bufferView.set(this.bufferView);
            return attributesBuffer;
        };
        AttributesBuffer.prototype.clone = function () {
            var attributesBuffer = new AttributesBuffer(this._stride, this._count);
            attributesBuffer.bufferView.set(this.bufferView);
            var len = this._viewVOs.length;
            for (var i = 0; i < len; i++)
                this._viewVOs[i].view._internalClone(attributesBuffer);
            return attributesBuffer;
        };
        AttributesBuffer.prototype.getView = function (index) {
            if (index < this._viewVOs.length)
                return this._viewVOs[index].view;
            return null;
        };
        AttributesBuffer.prototype._setAttributes = function (viewIndex, arrayBufferView, offset) {
            if (offset === void 0) { offset = 0; }
            var array = (arrayBufferView instanceof Uint8Array) ? arrayBufferView : new Uint8Array(arrayBufferView.buffer);
            var viewVO = this._viewVOs[viewIndex];
            var vLength = viewVO.length;
            var vOffset = viewVO.offset;
            var vCount = array.length / vLength;
            //make sure there is enough space in the buffer
            if (this.count < vCount + offset)
                this.count = vCount + offset;
            if (this._lengthDirty)
                this._updateLength();
            //fast path for separate buffers
            if (this._viewVOs.length == 1) {
                this._bufferView.set(array);
            }
            else {
                for (var i = 0; i < vCount; i++)
                    this._bufferView.set(array.subarray(i * vLength, (i + 1) * vLength), (i + offset) * this._stride + vOffset);
            }
            this.invalidate();
        };
        AttributesBuffer.prototype._addView = function (view) {
            var viewVO = new ViewVO(view);
            var len = this._viewVOs.length;
            viewVO.offset = len ? this._viewVOs[len - 1].offset + this._viewVOs[len - 1].length : 0;
            this._viewVOs.push(viewVO);
            if (this._newStride < viewVO.offset + viewVO.length) {
                this._newStride = viewVO.offset + viewVO.length;
                this.resize();
            }
            view._index = len;
        };
        AttributesBuffer.prototype._removeView = function (view) {
            var viewIndex = view._index;
            var viewVO = this._viewVOs.splice(viewIndex, 1)[0];
            var len = this._viewVOs.length;
            viewVO.dispose();
            for (var i = viewIndex; i < len; i++) {
                viewVO = this._viewVOs[i];
                viewVO.offset = i ? this._viewVOs[i - 1].offset + this._viewVOs[i - 1].length : 0;
                viewVO.view._index = i;
            }
            this._newStride = len ? this._viewVOs[len - 1].offset + this._viewVOs[len - 1].length : 0;
            this.resize();
        };
        AttributesBuffer.prototype._getOffset = function (viewIndex) {
            return this._viewVOs[viewIndex].offset;
        };
        AttributesBuffer.prototype._updateLength = function () {
            this._lengthDirty = false;
            var i;
            var j;
            var len = this._viewVOs.length;
            var newLength = this._newStride * this._newCount;
            if (!this._buffer || this._buffer.byteLength != newLength) {
                var newBuffer = new ArrayBuffer(newLength);
                var newView = new Uint8Array(newBuffer, 0, newBuffer.byteLength);
                var viewVO;
                var vLength;
                var vOffset;
                var vOldOffset;
                if (this._buffer) {
                    if (this._stride != this._newStride) {
                        for (i = 0; i < len; i++) {
                            viewVO = this._viewVOs[i];
                            vLength = viewVO.length;
                            vOffset = viewVO.offset;
                            vOldOffset = viewVO.oldOffset;
                            for (j = 0; j < this._count; j++)
                                if (vOldOffset != null)
                                    newView.set(new Uint8Array(this._buffer, j * this._stride + vOldOffset, vLength), j * this._newStride + vOffset);
                            viewVO.oldOffset = viewVO.offset;
                        }
                        this._stride = this._newStride;
                    }
                    else {
                        newView.set(new Uint8Array(this._buffer, 0, Math.min(newLength, this._buffer.byteLength))); //TODO: bypass quantisation of bytearray on instantiation
                    }
                }
                this._buffer = newBuffer;
                this._bufferView = newView;
            }
            this._count = this._newCount;
        };
        AttributesBuffer.assetType = "[assets AttributesBuffer]";
        return AttributesBuffer;
    }(AssetBase));
    var ViewVO = /** @class */ (function () {
        function ViewVO(view) {
            this.view = view;
            this.length = view.size * view.dimensions;
        }
        ViewVO.prototype.dispose = function () {
            this.view = null;
        };
        ViewVO.prototype.clone = function () {
            return new ViewVO(this.view);
        };
        return ViewVO;
    }());
    /**
     *
     * @class away.pool._Stage_AttributesBuffer
     */
    var _Stage_AttributesBuffer = /** @class */ (function (_super) {
        __extends$2(_Stage_AttributesBuffer, _super);
        function _Stage_AttributesBuffer(attributesBuffer, stage) {
            var _this = _super.call(this, attributesBuffer, stage) || this;
            _this._stage = stage;
            _this._attributesBuffer = attributesBuffer;
            return _this;
        }
        /**
         *
         */
        _Stage_AttributesBuffer.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            this._attributesBuffer = null;
            if (this._indexBuffer) {
                this._indexBuffer.dispose();
                this._indexBuffer = null;
            }
            if (this._vertexBuffer) {
                this._vertexBuffer.dispose();
                this._vertexBuffer = null;
            }
        };
        _Stage_AttributesBuffer.prototype.activate = function (index, size, dimensions, offset, unsigned) {
            if (unsigned === void 0) { unsigned = false; }
            this._stage.setVertexBuffer(index, this._getVertexBuffer(), size, dimensions, offset, unsigned);
        };
        _Stage_AttributesBuffer.prototype.draw = function (mode, firstIndex, numIndices) {
            this._stage.context.drawIndices(mode, this._getIndexBuffer(), firstIndex, numIndices);
        };
        _Stage_AttributesBuffer.prototype._getIndexBuffer = function () {
            if (!this._indexBuffer) {
                this._invalid = true;
                this._indexBuffer = this._stage.context.createIndexBuffer(this._attributesBuffer.count * this._attributesBuffer.stride / 2); //hardcoded assuming UintArray
            }
            if (this._invalid) {
                this._invalid = false;
                this._indexBuffer.uploadFromByteArray(this._attributesBuffer.buffer, 0, this._attributesBuffer.length);
            }
            return this._indexBuffer;
        };
        _Stage_AttributesBuffer.prototype._getVertexBuffer = function () {
            if (!this._vertexBuffer) {
                this._invalid = true;
                this._vertexBuffer = this._stage.context.createVertexBuffer(this._attributesBuffer.count, this._attributesBuffer.stride);
            }
            if (this._invalid) {
                this._invalid = false;
                this._vertexBuffer.uploadFromByteArray(this._attributesBuffer.buffer, 0, this._attributesBuffer.count);
            }
            return this._vertexBuffer;
        };
        return _Stage_AttributesBuffer;
    }(AbstractionBase));
    Stage.registerAbstraction(_Stage_AttributesBuffer, AttributesBuffer);

    var AttributesView = /** @class */ (function (_super) {
        __extends$2(AttributesView, _super);
        function AttributesView(arrayClass, dimensions, attributesBufferCount, unsigned) {
            if (attributesBufferCount === void 0) { attributesBufferCount = 0; }
            if (unsigned === void 0) { unsigned = false; }
            var _this = _super.call(this) || this;
            _this._arrayClass = arrayClass;
            _this._size = arrayClass.BYTES_PER_ELEMENT;
            _this._dimensions = dimensions;
            _this._attributesBuffer = (attributesBufferCount instanceof AttributesBuffer) ? attributesBufferCount : new AttributesBuffer(_this._dimensions * _this._size, attributesBufferCount);
            _this._attributesBuffer._addView(_this);
            _this._unsigned = unsigned;
            return _this;
        }
        Object.defineProperty(AttributesView.prototype, "assetType", {
            /**
             *
             *
             */
            get: function () {
                return AttributesView.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesView.prototype, "attributesBuffer", {
            get: function () {
                return this._attributesBuffer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesView.prototype, "size", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                return this._size;
            },
            set: function (value) {
                if (this._size == value)
                    return;
                this._size = value;
                this._attributesBuffer._removeView(this);
                this._attributesBuffer._addView(this);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesView.prototype, "dimensions", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                return this._dimensions;
            },
            set: function (value) {
                if (this._dimensions == value)
                    return;
                this._dimensions = value;
                //reset view
                this._attributesBuffer._removeView(this);
                this._attributesBuffer._addView(this);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesView.prototype, "unsigned", {
            get: function () {
                return this._unsigned;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesView.prototype, "count", {
            get: function () {
                return this._attributesBuffer.count;
            },
            set: function (value) {
                this._attributesBuffer.count = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesView.prototype, "offset", {
            get: function () {
                return this._attributesBuffer._getOffset(this._index);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesView.prototype, "length", {
            get: function () {
                return this._attributesBuffer.count * this._dimensions;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AttributesView.prototype, "stride", {
            get: function () {
                return this._attributesBuffer.stride / this._size;
            },
            enumerable: true,
            configurable: true
        });
        AttributesView.prototype.set = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            this._attributesBuffer._setAttributes(this._index, (values instanceof Array) ? new (this._arrayClass)(values) : values, offset);
        };
        AttributesView.prototype.get = function (count, offset) {
            if (offset === void 0) { offset = 0; }
            return new (this._arrayClass)(this._attributesBuffer.buffer, offset * this._attributesBuffer.stride + this.offset, count * this.stride - this.offset / this.size);
        };
        AttributesView.prototype._internalClone = function (attributesBuffer) {
            return (this._cloneCache = new AttributesView(this._arrayClass, this._dimensions, attributesBuffer, this._unsigned));
        };
        AttributesView.prototype.clone = function (attributesBuffer) {
            if (attributesBuffer === void 0) { attributesBuffer = null; }
            if (attributesBuffer)
                this._internalClone(attributesBuffer);
            if (!this._cloneCache)
                this._attributesBuffer.clone();
            var cloneCache = this._cloneCache;
            this._cloneCache = null;
            return cloneCache;
        };
        AttributesView.prototype.invalidate = function () {
            _super.prototype.invalidate.call(this);
            this._attributesBuffer.invalidate();
        };
        /**
         * @inheritDoc
         */
        AttributesView.prototype.dispose = function () {
            if (!this._attributesBuffer)
                return;
            this._attributesBuffer._removeView(this);
            this._attributesBuffer = null;
        };
        AttributesView.assetType = "[attributes AttributesView]";
        return AttributesView;
    }(AssetBase));

    var Byte4Attributes = /** @class */ (function (_super) {
        __extends$2(Byte4Attributes, _super);
        function Byte4Attributes(attributesBufferLength, unsigned) {
            if (unsigned === void 0) { unsigned = true; }
            return _super.call(this, unsigned ? Uint8Array : Int8Array, 4, attributesBufferLength, unsigned) || this;
        }
        Object.defineProperty(Byte4Attributes.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return Byte4Attributes.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Byte4Attributes.prototype.set = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            _super.prototype.set.call(this, values, offset);
        };
        Byte4Attributes.prototype.get = function (count, offset) {
            if (offset === void 0) { offset = 0; }
            return _super.prototype.get.call(this, count, offset);
        };
        Byte4Attributes.prototype._internalClone = function (attributesBuffer) {
            return (this._cloneCache = new Byte4Attributes(attributesBuffer, this._arrayClass == Uint8Array));
        };
        Byte4Attributes.prototype.clone = function (attributesBuffer) {
            if (attributesBuffer === void 0) { attributesBuffer = null; }
            return _super.prototype.clone.call(this, attributesBuffer);
        };
        Byte4Attributes.assetType = "[attributes Byte4Attributes]";
        return Byte4Attributes;
    }(AttributesView));

    var Float1Attributes = /** @class */ (function (_super) {
        __extends$2(Float1Attributes, _super);
        function Float1Attributes(attributesBufferLength) {
            return _super.call(this, Float32Array, 1, attributesBufferLength) || this;
        }
        Object.defineProperty(Float1Attributes.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return Float1Attributes.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Float1Attributes.prototype.set = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            _super.prototype.set.call(this, values, offset);
        };
        Float1Attributes.prototype.get = function (count, offset) {
            if (offset === void 0) { offset = 0; }
            return _super.prototype.get.call(this, count, offset);
        };
        Float1Attributes.prototype._internalClone = function (attributesBuffer) {
            return (this._cloneCache = new Float1Attributes(attributesBuffer));
        };
        Float1Attributes.prototype.clone = function (attributesBuffer) {
            if (attributesBuffer === void 0) { attributesBuffer = null; }
            return _super.prototype.clone.call(this, attributesBuffer);
        };
        Float1Attributes.assetType = "[attributes Float1Attributes]";
        return Float1Attributes;
    }(AttributesView));

    var Float2Attributes = /** @class */ (function (_super) {
        __extends$2(Float2Attributes, _super);
        function Float2Attributes(attributesBufferLength) {
            return _super.call(this, Float32Array, 2, attributesBufferLength) || this;
        }
        Object.defineProperty(Float2Attributes.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return Float2Attributes.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Float2Attributes.prototype.set = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            _super.prototype.set.call(this, values, offset);
        };
        Float2Attributes.prototype.get = function (count, offset) {
            if (offset === void 0) { offset = 0; }
            return _super.prototype.get.call(this, count, offset);
        };
        Float2Attributes.prototype._internalClone = function (attributesBuffer) {
            return (this._cloneCache = new Float2Attributes(attributesBuffer));
        };
        Float2Attributes.prototype.clone = function (attributesBuffer) {
            if (attributesBuffer === void 0) { attributesBuffer = null; }
            return _super.prototype.clone.call(this, attributesBuffer);
        };
        Float2Attributes.assetType = "[attributes Float2Attributes]";
        return Float2Attributes;
    }(AttributesView));

    var Float3Attributes = /** @class */ (function (_super) {
        __extends$2(Float3Attributes, _super);
        function Float3Attributes(attributesBufferLength) {
            return _super.call(this, Float32Array, 3, attributesBufferLength) || this;
        }
        Object.defineProperty(Float3Attributes.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return Float3Attributes.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Float3Attributes.prototype.set = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            _super.prototype.set.call(this, values, offset);
        };
        Float3Attributes.prototype.get = function (count, offset) {
            if (offset === void 0) { offset = 0; }
            return _super.prototype.get.call(this, count, offset);
        };
        Float3Attributes.prototype._internalClone = function (attributesBuffer) {
            return (this._cloneCache = new Float3Attributes(attributesBuffer));
        };
        Float3Attributes.prototype.clone = function (attributesBuffer) {
            if (attributesBuffer === void 0) { attributesBuffer = null; }
            return _super.prototype.clone.call(this, attributesBuffer);
        };
        Float3Attributes.assetType = "[attributes Float3Attributes]";
        return Float3Attributes;
    }(AttributesView));

    var Float4Attributes = /** @class */ (function (_super) {
        __extends$2(Float4Attributes, _super);
        function Float4Attributes(attributesBufferLength) {
            return _super.call(this, Float32Array, 4, attributesBufferLength) || this;
        }
        Object.defineProperty(Float4Attributes.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return Float4Attributes.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Float4Attributes.prototype.set = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            _super.prototype.set.call(this, values, offset);
        };
        Float4Attributes.prototype.get = function (count, offset) {
            if (offset === void 0) { offset = 0; }
            return _super.prototype.get.call(this, count, offset);
        };
        Float4Attributes.prototype._internalClone = function (attributesBuffer) {
            return (this._cloneCache = new Float4Attributes(attributesBuffer));
        };
        Float4Attributes.prototype.clone = function (attributesBuffer) {
            if (attributesBuffer === void 0) { attributesBuffer = null; }
            return _super.prototype.clone.call(this, attributesBuffer);
        };
        Float4Attributes.assetType = "[attributes Float4Attributes]";
        return Float4Attributes;
    }(AttributesView));

    var Short2Attributes = /** @class */ (function (_super) {
        __extends$2(Short2Attributes, _super);
        function Short2Attributes(attributesBufferLength, unsigned) {
            if (unsigned === void 0) { unsigned = true; }
            return _super.call(this, unsigned ? Uint16Array : Int16Array, 2, attributesBufferLength, unsigned) || this;
        }
        Object.defineProperty(Short2Attributes.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return Short2Attributes.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Short2Attributes.prototype.set = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            _super.prototype.set.call(this, values, offset);
        };
        Short2Attributes.prototype.get = function (count, offset) {
            if (offset === void 0) { offset = 0; }
            return _super.prototype.get.call(this, count, offset);
        };
        Short2Attributes.prototype._internalClone = function (attributesBuffer) {
            return (this._cloneCache = new Short2Attributes(attributesBuffer, this._arrayClass == Uint16Array));
        };
        Short2Attributes.prototype.clone = function (attributesBuffer) {
            if (attributesBuffer === void 0) { attributesBuffer = null; }
            return _super.prototype.clone.call(this, attributesBuffer);
        };
        Short2Attributes.assetType = "[attributes Short2Attributes]";
        return Short2Attributes;
    }(AttributesView));

    var Short3Attributes = /** @class */ (function (_super) {
        __extends$2(Short3Attributes, _super);
        function Short3Attributes(attributesBufferLength, unsigned) {
            if (unsigned === void 0) { unsigned = true; }
            return _super.call(this, unsigned ? Uint16Array : Int16Array, 3, attributesBufferLength, unsigned) || this;
        }
        Object.defineProperty(Short3Attributes.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return Short3Attributes.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Short3Attributes.prototype.set = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            _super.prototype.set.call(this, values, offset);
        };
        Short3Attributes.prototype.get = function (count, offset) {
            if (offset === void 0) { offset = 0; }
            return _super.prototype.get.call(this, count, offset);
        };
        Short3Attributes.prototype._internalClone = function (attributesBuffer) {
            return (this._cloneCache = new Short3Attributes(attributesBuffer, this._arrayClass == Uint16Array));
        };
        Short3Attributes.prototype.clone = function (attributesBuffer) {
            if (attributesBuffer === void 0) { attributesBuffer = null; }
            return _super.prototype.clone.call(this, attributesBuffer);
        };
        Short3Attributes.assetType = "[attributes Short3Attributes]";
        return Short3Attributes;
    }(AttributesView));

    console.debug("AwayJS - Stage - 0.10.20");
    Loader.enableParser(Image2DParser);
    Loader.enableParser(ImageCubeParser);
    Loader.enableParser(TextureAtlasParser);

    /**
     *
     */
    var AlignmentMode = /** @class */ (function () {
        function AlignmentMode() {
        }
        /**
         *
         */
        AlignmentMode.REGISTRATION_POINT = "registrationPoint";
        /**
         *
         */
        AlignmentMode.TRANSFORM_POINT = "transformPoint";
        return AlignmentMode;
    }());

    /**
     *
     */
    var HierarchicalProperties = /** @class */ (function () {
        function HierarchicalProperties() {
        }
        /**
         *
         */
        HierarchicalProperties.MOUSE_ENABLED = 1;
        /**
         *
         */
        HierarchicalProperties.VISIBLE = 2;
        /**
         *
         */
        HierarchicalProperties.MASK_ID = 4;
        /**
         *
         */
        HierarchicalProperties.MASKS = 8;
        /**
         *
         */
        HierarchicalProperties.COLOR_TRANSFORM = 16;
        /**
         *
         */
        HierarchicalProperties.SCENE_TRANSFORM = 32;
        /**
         *
         */
        HierarchicalProperties.ALL = 63;
        return HierarchicalProperties;
    }());

    var OrientationMode = /** @class */ (function () {
        function OrientationMode() {
        }
        /**
         *
         */
        OrientationMode.DEFAULT = "default";
        /**
         *
         */
        OrientationMode.CAMERA_PLANE = "cameraPlane";
        /**
         *
         */
        OrientationMode.CAMERA_POSITION = "cameraPosition";
        return OrientationMode;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics$3 = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    function __extends$3(d, b) {
        extendStatics$3(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics$4 = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    function __extends$4(d, b) {
        extendStatics$4(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * Value object ___ for a picking collision returned by a picking collider. Created as unique objects on display objects
     *
     * @see away.base.DisplayObject#pickingCollision
     *
     * @class away.pick.PickingCollision
     */
    var PickingCollision = /** @class */ (function () {
        /**
         * Creates a new <code>PickingCollision</code> object.
         *
         * @param entity The entity to which this collision object belongs.
         */
        function PickingCollision(entity) {
            this.entity = entity;
        }
        return PickingCollision;
    }());

    /**
     *
     */
    var BoundingVolumeType;
    (function (BoundingVolumeType) {
        /**
         *
         */
        BoundingVolumeType[BoundingVolumeType["SPHERE"] = 0] = "SPHERE";
        /**
     *
     */
        BoundingVolumeType[BoundingVolumeType["SPHERE_FAST"] = 1] = "SPHERE_FAST";
        /**
         *
         */
        BoundingVolumeType[BoundingVolumeType["SPHERE_BOUNDS"] = 2] = "SPHERE_BOUNDS";
        /**
         *
         */
        BoundingVolumeType[BoundingVolumeType["SPHERE_BOUNDS_FAST"] = 3] = "SPHERE_BOUNDS_FAST";
        /**
         *
         */
        BoundingVolumeType[BoundingVolumeType["BOX"] = 4] = "BOX";
        /**
         *
         */
        BoundingVolumeType[BoundingVolumeType["BOX_FAST"] = 5] = "BOX_FAST";
        /**
         *
         */
        BoundingVolumeType[BoundingVolumeType["BOX_BOUNDS"] = 6] = "BOX_BOUNDS";
        /**
         *
         */
        BoundingVolumeType[BoundingVolumeType["BOX_BOUNDS_FAST"] = 7] = "BOX_BOUNDS_FAST";
        /**
         *
         */
        BoundingVolumeType[BoundingVolumeType["NULL"] = 8] = "NULL";
    })(BoundingVolumeType || (BoundingVolumeType = {}));

    var BoundsPickerEvent = /** @class */ (function (_super) {
        __extends$4(BoundsPickerEvent, _super);
        function BoundsPickerEvent(type, boundsPicker) {
            var _this = _super.call(this, type) || this;
            _this._boundsPicker = boundsPicker;
            return _this;
        }
        Object.defineProperty(BoundsPickerEvent.prototype, "boundsPicker", {
            get: function () {
                return this._boundsPicker;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the event.
         * @return An exact duplicate of the current object.
         */
        BoundsPickerEvent.prototype.clone = function () {
            return new BoundsPickerEvent(this.type, this._boundsPicker);
        };
        /**
         *
         */
        BoundsPickerEvent.INVALIDATE_BOUNDS = "invalidateBounds";
        return BoundsPickerEvent;
    }(EventBase));

    var BoundingVolumeBase = /** @class */ (function (_super) {
        __extends$4(BoundingVolumeBase, _super);
        //protected _boundsPrimitive:Sprite;
        function BoundingVolumeBase(asset, pool) {
            var _this = _super.call(this, asset, pool) || this;
            _this._targetCoordinateSpace = asset;
            _this._picker = pool.picker;
            _this._strokeFlag = pool.strokeFlag;
            _this._fastFlag = pool.fastFlag;
            _this._onInvalidateBoundsDelegate = function (event) { return _this._onInvalidateBounds(event); };
            _this._onInvalidateMatrix3DDelegate = function (event) { return _this._onInvalidateMatrix3D(event); };
            _this._picker.addEventListener(BoundsPickerEvent.INVALIDATE_BOUNDS, _this._onInvalidateBoundsDelegate);
            if (_this._targetCoordinateSpace) {
                var targetEntity = _this._picker.entity;
                while (targetEntity && targetEntity != _this._targetCoordinateSpace.parent) {
                    targetEntity.transform.addEventListener(TransformEvent.INVALIDATE_MATRIX3D, _this._onInvalidateMatrix3DDelegate);
                    targetEntity = targetEntity.parent;
                }
                if (!targetEntity) //case when targetCoordinateSpace is not part of the same displaylist ancestry
                    _this._targetCoordinateSpace.transform.addEventListener(TransformEvent.INVALIDATE_CONCATENATED_MATRIX3D, _this._onInvalidateMatrix3DDelegate);
            }
            return _this;
        }
        BoundingVolumeBase.prototype._onInvalidateBounds = function (event) {
            this._invalid = true;
        };
        BoundingVolumeBase.prototype._onInvalidateMatrix3D = function (event) {
            this._invalid = true;
        };
        BoundingVolumeBase.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            this._picker.addEventListener(BoundsPickerEvent.INVALIDATE_BOUNDS, this._onInvalidateBoundsDelegate);
            if (this._targetCoordinateSpace) {
                var targetEntity = this._picker.entity;
                while (targetEntity && targetEntity != this._targetCoordinateSpace.parent) {
                    targetEntity.transform.removeEventListener(TransformEvent.INVALIDATE_MATRIX3D, this._onInvalidateMatrix3DDelegate);
                    targetEntity = targetEntity.parent;
                }
                if (!targetEntity) //case when targetCoordinateSpace is not part of the same displaylist ancestry
                    this._targetCoordinateSpace.transform.removeEventListener(TransformEvent.INVALIDATE_CONCATENATED_MATRIX3D, this._onInvalidateMatrix3DDelegate);
            }
            this._targetCoordinateSpace = null;
            this._picker = null;
            //this._boundsPrimitive = null;
        };
        // public get boundsPrimitive():DisplayObject
        // {
        // 	if (this._boundsPrimitive == null) {
        // 		this._boundsPrimitive = this._createBoundsPrimitive();
        // 		this._invalid = true;
        // 	}
        // 	if(this._invalid)
        // 		this._update();
        // 	this._boundsPrimitive.transform.matrix3D = this._boundingEntity.transform.concatenatedMatrix3D;
        // 	return this._boundsPrimitive;
        // }
        BoundingVolumeBase.prototype.nullify = function () {
            throw new AbstractMethodError();
        };
        BoundingVolumeBase.prototype.isInFrustum = function (planes, numPlanes) {
            throw new AbstractMethodError();
        };
        BoundingVolumeBase.prototype.clone = function () {
            throw new AbstractMethodError();
        };
        BoundingVolumeBase.prototype.rayIntersection = function (position, direction, targetNormal) {
            return -1;
        };
        BoundingVolumeBase.prototype.classifyToPlane = function (plane) {
            throw new AbstractMethodError();
        };
        BoundingVolumeBase.prototype._update = function () {
            this._invalid = false;
        };
        return BoundingVolumeBase;
    }(AbstractionBase));

    /**
     * BoundingBox represents a bounding box volume that has its planes aligned to the local coordinate axes of the bounded object.
     * This is useful for most sprites.
     */
    var BoundingBox = /** @class */ (function (_super) {
        __extends$4(BoundingBox, _super);
        function BoundingBox() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._x = 0;
            _this._y = 0;
            _this._z = 0;
            _this._width = 0;
            _this._height = 0;
            _this._depth = 0;
            _this._centerX = 0;
            _this._centerY = 0;
            _this._centerZ = 0;
            _this._halfExtentsX = 0;
            _this._halfExtentsY = 0;
            _this._halfExtentsZ = 0;
            return _this;
            // public _createBoundsPrimitive():Sprite
            // {
            // 	this._prefab = new PrimitiveCubePrefab(null, ElementsType.LINE);
            // 	return <Sprite> this._prefab.getNewObject();
            // }
        }
        /**
         * @inheritDoc
         */
        BoundingBox.prototype.nullify = function () {
            this._x = this._y = this._z = 0;
            this._width = this._height = this._depth = 0;
            this._centerX = this._centerY = this._centerZ = 0;
            this._halfExtentsX = this._halfExtentsY = this._halfExtentsZ = 0;
        };
        /**
         * @inheritDoc
         */
        BoundingBox.prototype.isInFrustum = function (planes, numPlanes) {
            if (this._invalid)
                this._update();
            if (this._box == null)
                return;
            for (var i = 0; i < numPlanes; ++i) {
                var plane = planes[i];
                var a = plane.a;
                var b = plane.b;
                var c = plane.c;
                var flippedExtentX = a < 0 ? -this._halfExtentsX : this._halfExtentsX;
                var flippedExtentY = b < 0 ? -this._halfExtentsY : this._halfExtentsY;
                var flippedExtentZ = c < 0 ? -this._halfExtentsZ : this._halfExtentsZ;
                var projDist = a * (this._centerX + flippedExtentX) + b * (this._centerY + flippedExtentY) + c * (this._centerZ + flippedExtentZ) - plane.d;
                if (projDist < 0)
                    return false;
            }
            return true;
        };
        BoundingBox.prototype.rayIntersection = function (position, direction, targetNormal) {
            if (this._invalid)
                this._update();
            if (this._box == null)
                return -1;
            return this._box.rayIntersection(position, direction, targetNormal);
        };
        BoundingBox.prototype.getBox = function () {
            if (this._invalid)
                this._update();
            return this._box;
        };
        BoundingBox.prototype.classifyToPlane = function (plane) {
            var a = plane.a;
            var b = plane.b;
            var c = plane.c;
            var centerDistance = a * this._centerX + b * this._centerY + c * this._centerZ - plane.d;
            if (a < 0)
                a = -a;
            if (b < 0)
                b = -b;
            if (c < 0)
                c = -c;
            var boundOffset = a * this._halfExtentsX + b * this._halfExtentsY + c * this._halfExtentsZ;
            return centerDistance > boundOffset ? PlaneClassification.FRONT : centerDistance < -boundOffset ? PlaneClassification.BACK : PlaneClassification.INTERSECT;
        };
        BoundingBox.prototype._update = function () {
            _super.prototype._update.call(this);
            var matrix3D;
            if (this._targetCoordinateSpace) {
                if (this._targetCoordinateSpace == this._picker.entity) {
                    matrix3D = this._picker.entity.transform.matrix3D;
                }
                else {
                    matrix3D = this._picker.entity.transform.concatenatedMatrix3D.clone();
                    if (this._targetCoordinateSpace.parent)
                        matrix3D.append(this._targetCoordinateSpace.parent.transform.inverseConcatenatedMatrix3D);
                }
            }
            this._box = this._picker._getBoxBoundsInternal(matrix3D, this._strokeFlag, this._fastFlag, this._box);
            if (this._box == null)
                return;
            //TODO: Warning - isInFrustum will be inactive until below commented code is resolved
            //---------------------------------------------------------------------------------
            // var matrix:Matrix3D = this._boundingEntity.transform.concatenatedMatrix3D;
            var hx = this._box.width / 2;
            var hy = this._box.height / 2;
            var hz = this._box.depth / 2;
            var cx = this._box.x + hx;
            var cy = this._box.y + hy;
            var cz = this._box.z + hz;
            // var raw:Float32Array = matrix._rawData;
            // var m11:number = raw[0], m12:number = raw[4], m13:number = raw[8], m14:number = raw[12];
            // var m21:number = raw[1], m22:number = raw[5], m23:number = raw[9], m24:number = raw[13];
            // var m31:number = raw[2], m32:number = raw[6], m33:number = raw[10], m34:number = raw[14];
            // this._centerX = cx*m11 + cy*m12 + cz*m13 + m14;
            // this._centerY = cx*m21 + cy*m22 + cz*m23 + m24;
            // this._centerZ = cx*m31 + cy*m32 + cz*m33 + m34;
            // this._halfExtentsX = Math.abs(hx*m11 + hy*m12 + hz*m13);
            // this._halfExtentsY = Math.abs(hx*m21 + hy*m22 + hz*m23);
            // this._halfExtentsZ = Math.abs(hx*m31 + hy*m32 + hz*m33);
            // if (this._prefab) {
            // 	this._prefab.width = this._box.width;
            // 	this._prefab.height = this._box.height;
            // 	this._prefab.depth = this._box.depth;
            // 	// this._boundsPrimitive.transform.matrix3D = matrix;
            // 	this._boundsPrimitive.registrationPoint = new Vector3D(-cx*this._boundsPrimitive.transform.scale.x, -cy*this._boundsPrimitive.transform.scale.y, -cz*this._boundsPrimitive.transform.scale.z);
            // }
            // this._width = this._halfExtentsX*2;
            // this._height = this._halfExtentsY*2;
            // this._depth = this._halfExtentsZ*2;
            // this._x = this._centerX - this._halfExtentsX;
            // this._y = this._centerY - this._halfExtentsY;
            // this._z = this._centerZ - this._halfExtentsZ;
        };
        return BoundingBox;
    }(BoundingVolumeBase));

    var BoundingSphere = /** @class */ (function (_super) {
        __extends$4(BoundingSphere, _super);
        function BoundingSphere() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._radius = 0;
            _this._centerX = 0;
            _this._centerY = 0;
            _this._centerZ = 0;
            return _this;
            // public _pCreateBoundsPrimitive():Sprite
            // {
            // 	this._prefab = new PrimitiveSpherePrefab(null, ElementsType.LINE);
            // 	return <Sprite> this._prefab.getNewObject();
            // }
        }
        //private _prefab:PrimitiveSpherePrefab;
        BoundingSphere.prototype.nullify = function () {
            this._centerX = this._centerY = this._centerZ = 0;
            this._radius = 0;
        };
        BoundingSphere.prototype.isInFrustum = function (planes, numPlanes) {
            if (this._invalid)
                this._update();
            for (var i = 0; i < numPlanes; ++i) {
                var plane = planes[i];
                var flippedExtentX = plane.a < 0 ? -this._radius : this._radius;
                var flippedExtentY = plane.b < 0 ? -this._radius : this._radius;
                var flippedExtentZ = plane.c < 0 ? -this._radius : this._radius;
                var projDist = plane.a * (this._centerX + flippedExtentX) + plane.b * (this._centerY + flippedExtentY) + plane.c * (this._centerZ + flippedExtentZ) - plane.d;
                if (projDist < 0) {
                    return false;
                }
            }
            return true;
        };
        BoundingSphere.prototype.rayIntersection = function (position, direction, targetNormal) {
            if (this._invalid)
                this._update();
            return this._sphere.rayIntersection(position, direction, targetNormal);
        };
        BoundingSphere.prototype.getSphere = function () {
            if (this._invalid)
                this._update();
            return this._sphere;
        };
        //@override
        BoundingSphere.prototype.classifyToPlane = function (plane) {
            var a = plane.a;
            var b = plane.b;
            var c = plane.c;
            var dd = a * this._centerX + b * this._centerY + c * this._centerZ - plane.d;
            if (a < 0)
                a = -a;
            if (b < 0)
                b = -b;
            if (c < 0)
                c = -c;
            var rr = (a + b + c) * this._radius;
            return dd > rr ? PlaneClassification.FRONT : dd < -rr ? PlaneClassification.BACK : PlaneClassification.INTERSECT;
        };
        BoundingSphere.prototype._update = function () {
            _super.prototype._update.call(this);
            var matrix3D;
            if (this._targetCoordinateSpace) {
                if (this._targetCoordinateSpace == this._picker.entity) {
                    matrix3D = this._picker.entity.transform.matrix3D;
                }
                else {
                    matrix3D = this._picker.entity.transform.concatenatedMatrix3D.clone();
                    if (this._targetCoordinateSpace.parent)
                        matrix3D.append(this._targetCoordinateSpace.parent.transform.inverseConcatenatedMatrix3D);
                }
            }
            this._sphere = this._picker._getSphereBoundsInternal(null, matrix3D, this._strokeFlag, this._fastFlag, this._sphere);
            var matrix = this._picker.entity.transform.concatenatedMatrix3D;
            var cx = this._sphere.x;
            var cy = this._sphere.y;
            var cz = this._sphere.z;
            var r = this._sphere.radius;
            var raw = matrix._rawData;
            var m11 = raw[0], m12 = raw[4], m13 = raw[8], m14 = raw[12];
            var m21 = raw[1], m22 = raw[5], m23 = raw[9], m24 = raw[13];
            var m31 = raw[2], m32 = raw[6], m33 = raw[10], m34 = raw[14];
            this._centerX = cx * m11 + cy * m12 + cz * m13 + m14;
            this._centerY = cx * m21 + cy * m22 + cz * m23 + m24;
            this._centerZ = cx * m31 + cy * m32 + cz * m33 + m34;
            var rx = m11 + m12 + m13;
            var ry = m21 + m22 + m23;
            var rz = m31 + m32 + m33;
            this._radius = r * Math.sqrt((rx * rx + ry * ry + rz * rz) / 3);
            // if (this._prefab) {
            // 	this._prefab.radius = r;
            // 	this._boundsPrimitive.x = cx;
            // 	this._boundsPrimitive.y = cy;
            // 	this._boundsPrimitive.z = cz;
            // 	this._boundsPrimitive.transform.matrix3D = matrix;
            // }
        };
        return BoundingSphere;
    }(BoundingVolumeBase));

    var NullBounds = /** @class */ (function (_super) {
        __extends$4(NullBounds, _super);
        function NullBounds() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        //@override
        NullBounds.prototype.isInFrustum = function (planes, numPlanes) {
            return true;
        };
        NullBounds.prototype.classifyToPlane = function (plane) {
            return PlaneClassification.INTERSECT;
        };
        return NullBounds;
    }(BoundingVolumeBase));

    var _a, _b, _c;
    var BoundingVolumePool = /** @class */ (function () {
        function BoundingVolumePool(picker, boundingVolumeType) {
            this._boundingVolumePool = new Object();
            this._picker = picker;
            this._strokeFlag = BoundingVolumePool._strokeDict[boundingVolumeType];
            this._fastFlag = BoundingVolumePool._fastDict[boundingVolumeType];
            this._boundingVolumeClass = BoundingVolumePool._boundsDict[boundingVolumeType];
        }
        Object.defineProperty(BoundingVolumePool.prototype, "picker", {
            get: function () {
                return this._picker;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BoundingVolumePool.prototype, "strokeFlag", {
            get: function () {
                return this._strokeFlag;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BoundingVolumePool.prototype, "fastFlag", {
            get: function () {
                return this._fastFlag;
            },
            enumerable: true,
            configurable: true
        });
        BoundingVolumePool.prototype.getAbstraction = function (entity) {
            var id = entity ? entity.id : -1;
            return (this._boundingVolumePool[id] || (this._boundingVolumePool[id] = new this._boundingVolumeClass(entity, this)));
        };
        BoundingVolumePool.prototype.clearAbstraction = function (entity) {
            delete this._boundingVolumePool[entity ? entity.id : -1];
        };
        BoundingVolumePool.prototype.dispose = function () {
            for (var key in this._boundingVolumePool)
                this._boundingVolumePool[key].onClear(null);
        };
        BoundingVolumePool._strokeDict = (_a = {}, _a[BoundingVolumeType.BOX] = false, _a[BoundingVolumeType.BOX_FAST] = false, _a[BoundingVolumeType.BOX_BOUNDS] = true, _a[BoundingVolumeType.BOX_BOUNDS_FAST] = true, _a[BoundingVolumeType.SPHERE] = false, _a[BoundingVolumeType.SPHERE_FAST] = false, _a[BoundingVolumeType.SPHERE_BOUNDS] = true, _a[BoundingVolumeType.SPHERE_FAST] = true, _a[BoundingVolumeType.NULL] = false, _a);
        BoundingVolumePool._fastDict = (_b = {}, _b[BoundingVolumeType.BOX] = false, _b[BoundingVolumeType.BOX_FAST] = true, _b[BoundingVolumeType.BOX_BOUNDS] = false, _b[BoundingVolumeType.BOX_BOUNDS_FAST] = true, _b[BoundingVolumeType.SPHERE] = false, _b[BoundingVolumeType.SPHERE_FAST] = true, _b[BoundingVolumeType.SPHERE_BOUNDS] = false, _b[BoundingVolumeType.SPHERE_FAST] = true, _b[BoundingVolumeType.NULL] = false, _b);
        BoundingVolumePool._boundsDict = (_c = {}, _c[BoundingVolumeType.BOX] = BoundingBox, _c[BoundingVolumeType.BOX_FAST] = BoundingBox, _c[BoundingVolumeType.BOX_BOUNDS] = BoundingBox, _c[BoundingVolumeType.BOX_BOUNDS_FAST] = BoundingBox, _c[BoundingVolumeType.SPHERE] = BoundingSphere, _c[BoundingVolumeType.SPHERE_FAST] = BoundingSphere, _c[BoundingVolumeType.SPHERE_BOUNDS] = BoundingSphere, _c[BoundingVolumeType.SPHERE_FAST] = BoundingSphere, _c[BoundingVolumeType.NULL] = NullBounds, _c);
        return BoundingVolumePool;
    }());

    /**
     * @class away.pool.PickEntity
     */
    var PickEntity = /** @class */ (function (_super) {
        __extends$4(PickEntity, _super);
        /**
         * //TODO
         *
         * @param materialClassGL
         */
        function PickEntity(view, entity, pickGroup) {
            var _this = _super.call(this, entity, pickGroup) || this;
            _this._boundingVolumePools = new Object();
            _this._orientedBoxBounds = [];
            _this._orientedBoxBoundsDirty = [true, true];
            _this._orientedSphereBounds = [];
            _this._orientedSphereBoundsDirty = [true, true];
            _this._pickablePool = new Object();
            _this._pickables = [];
            _this.shapeFlag = false;
            _this._view = view;
            _this._entity = entity;
            _this._pickGroup = pickGroup;
            _this._pickingCollision = new PickingCollision(_this._entity);
            return _this;
        }
        Object.defineProperty(PickEntity.prototype, "pickingCollision", {
            get: function () {
                return this._pickingCollision;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PickEntity.prototype, "view", {
            /**
             *
             * @returns {IPickingEntity}
             */
            get: function () {
                return this._view;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PickEntity.prototype, "entity", {
            /**
             *
             * @returns {IPickingEntity}
             */
            get: function () {
                return this._entity;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PickEntity.prototype, "pickGroup", {
            /**
             *
             * @returns {IPickingEntity}
             */
            get: function () {
                return this._pickGroup;
            },
            enumerable: true,
            configurable: true
        });
        PickEntity.prototype.getBoundingVolume = function (targetCoordinateSpace, boundingVolumeType) {
            if (targetCoordinateSpace === void 0) { targetCoordinateSpace = null; }
            if (boundingVolumeType === void 0) { boundingVolumeType = null; }
            if (boundingVolumeType == null)
                boundingVolumeType = this._entity.defaultBoundingVolume;
            var pool = (this._boundingVolumePools[boundingVolumeType] || (this._boundingVolumePools[boundingVolumeType] = new BoundingVolumePool(this, boundingVolumeType)));
            return pool.getAbstraction(targetCoordinateSpace);
        };
        /**
         * Evaluates the display object to see if it overlaps or intersects with the
         * point specified by the <code>x</code> and <code>y</code> parameters. The
         * <code>x</code> and <code>y</code> parameters specify a point in the
         * coordinate space of the Scene, not the display object container that
         * contains the display object(unless that display object container is the
         * Scene).
         *
         * @param x         The <i>x</i> coordinate to test against this object.
         * @param y         The <i>y</i> coordinate to test against this object.
         * @param shapeFlag Whether to check against the actual pixels of the object
         *                 (<code>true</code>) or the bounding box
         *                 (<code>false</code>).
         * @param maskFlag Whether to check against the object when it is used as mask
         *                 (<code>false</code>).
         * @return <code>true</code> if the display object overlaps or intersects
         *         with the specified point; <code>false</code> otherwise.
         */
        PickEntity.prototype.hitTestPoint = function (x, y, shapeFlag) {
            if (shapeFlag === void 0) { shapeFlag = false; }
            return this._hitTestPointInternal(this._entity, x, y, shapeFlag, false);
        };
        PickEntity.prototype._hitTestPointInternal = function (rootEntity, x, y, shapeFlag, maskFlag) {
            if (shapeFlag === void 0) { shapeFlag = false; }
            if (maskFlag === void 0) { maskFlag = false; }
            if (this._entity.maskId != -1 && (!maskFlag || !shapeFlag)) //allow masks for bounds hit tests
                return false;
            if (this._invalid)
                this._update();
            //set local tempPoint for later reference
            var tempPoint = new Point(x, y);
            this._entity.transform.globalToLocal(tempPoint, tempPoint);
            //early out for box test
            var box = this._getBoxBoundsInternal(null, false, true);
            if (box == null || !box.contains(tempPoint.x, tempPoint.y, 0))
                return false;
            //early out for non-shape tests
            if (!shapeFlag || this._entity.assetType == "[asset TextField]" || this._entity.assetType == "[asset Billboard]")
                return true;
            var len = this._pickables.length;
            var shapeHit = false;
            for (var i = 0; i < len; i++) {
                if (this._pickables[i].hitTestPoint(tempPoint.x, tempPoint.y, 0)) {
                    shapeHit = true;
                    break;
                }
            }
            if (!shapeHit)
                return false;
            //do the mask thang
            var maskOwners = this._entity.maskOwners;
            if (maskOwners) {
                var numOwners = maskOwners.length;
                var entity;
                var masks;
                var numMasks;
                var maskHit;
                for (var i = 0; i < numOwners; i++) {
                    entity = maskOwners[i];
                    if (!entity.isDescendant(rootEntity))
                        continue;
                    masks = entity.masks;
                    numMasks = masks.length;
                    maskHit = false;
                    for (var j = 0; j < numMasks; j++) {
                        entity = masks[j];
                        if (!entity.isDescendant(rootEntity))
                            continue;
                        // todo: figure out why a mask can be null here!
                        if (entity && this._pickGroup.getBoundsPicker(entity.partition)._hitTestPointInternal(rootEntity, x, y, shapeFlag, true)) {
                            maskHit = true;
                            break;
                        }
                    }
                    if (!maskHit)
                        return false;
                }
            }
            return true;
        };
        /**
         * @inheritDoc
         */
        PickEntity.prototype.isIntersectingRay = function (globalRayPosition, globalRayDirection) {
            return this._isIntersectingRayInternal(this._entity, globalRayPosition, globalRayDirection);
        };
        /**
         * @inheritDoc
         */
        PickEntity.prototype._isIntersectingRayInternal = function (rootEntity, globalRayPosition, globalRayDirection) {
            this._pickingCollision.rayPosition = this._entity.transform.inverseConcatenatedMatrix3D.transformVector(globalRayPosition, this._pickingCollision.rayPosition);
            this._pickingCollision.rayDirection = this._entity.transform.inverseConcatenatedMatrix3D.deltaTransformVector(globalRayDirection, this._pickingCollision.rayDirection);
            this._pickingCollision.normal = this._pickingCollision.normal || new Vector3D();
            //early out for bounds test
            var rayEntryDistance = this.getBoundingVolume().rayIntersection(this._pickingCollision.rayPosition, this._pickingCollision.rayDirection, this._pickingCollision.normal);
            //check masks
            if (rayEntryDistance < 0 || !this._isIntersectingMasks(rootEntity, globalRayPosition, globalRayDirection))
                return false;
            this._pickingCollision.rayEntryDistance = rayEntryDistance;
            this._pickingCollision.globalRayPosition = globalRayPosition;
            this._pickingCollision.globalRayDirection = globalRayDirection;
            this._pickingCollision.rayOriginIsInsideBounds = rayEntryDistance == 0;
            return true;
        };
        PickEntity.prototype.isIntersectingShape = function (findClosestCollision) {
            var shapeHit = false;
            for (var i = 0; i < this._pickables.length; i++) {
                if (this._pickables[i].testCollision(this._pickingCollision, findClosestCollision)) {
                    if (!findClosestCollision)
                        return true;
                    else
                        shapeHit = true;
                }
            }
            return shapeHit;
        };
        PickEntity.prototype.getBoxBounds = function (targetCoordinateSpace, strokeFlag, fastFlag) {
            if (targetCoordinateSpace === void 0) { targetCoordinateSpace = null; }
            if (strokeFlag === void 0) { strokeFlag = false; }
            if (fastFlag === void 0) { fastFlag = false; }
            return this._getBoxBoundsInternal(targetCoordinateSpace ? targetCoordinateSpace.transform.matrix3D : null, strokeFlag, fastFlag);
        };
        PickEntity.prototype._getBoxBoundsInternal = function (matrix3D, strokeFlag, fastFlag, cache, target) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (fastFlag === void 0) { fastFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (this._invalid)
                this._update();
            var numPickables = this._pickables.length;
            if (numPickables) {
                if (fastFlag) {
                    var obb;
                    var strokeIndex = strokeFlag ? 1 : 0;
                    if (this._orientedBoxBoundsDirty[strokeIndex]) {
                        this._orientedBoxBoundsDirty[strokeIndex] = false;
                        for (var i = 0; i < numPickables; i++)
                            obb = this._pickables[i].getBoxBounds(null, strokeFlag, this._orientedBoxBounds[strokeIndex], obb);
                        this._orientedBoxBounds[strokeIndex] = obb;
                    }
                    else {
                        obb = this._orientedBoxBounds[strokeIndex];
                    }
                    if (obb != null)
                        target = (matrix3D) ? matrix3D.transformBox(obb).union(target, target || cache) : obb.union(target, target || cache);
                }
                else {
                    for (var i = 0; i < numPickables; i++)
                        target = this._pickables[i].getBoxBounds(matrix3D, strokeFlag, cache, target);
                }
            }
            return target;
        };
        PickEntity.prototype.getSphereBounds = function (targetCoordinateSpace, strokeFlag, fastFlag) {
            if (targetCoordinateSpace === void 0) { targetCoordinateSpace = null; }
            if (strokeFlag === void 0) { strokeFlag = false; }
            if (fastFlag === void 0) { fastFlag = false; }
            return this._getSphereBoundsInternal(null, targetCoordinateSpace ? targetCoordinateSpace.transform.matrix3D : null, strokeFlag, fastFlag);
        };
        PickEntity.prototype._getSphereBoundsInternal = function (center, matrix3D, strokeFlag, fastFlag, cache, target) {
            if (center === void 0) { center = null; }
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (fastFlag === void 0) { fastFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (this._invalid)
                this._update();
            var box = this._getBoxBoundsInternal(matrix3D, strokeFlag);
            if (box == null)
                return;
            if (!center) {
                center = new Vector3D();
                center.x = box.x + box.width / 2;
                center.y = box.y + box.height / 2;
                center.z = box.z + box.depth / 2;
            }
            var numPickables = this._pickables.length;
            if (numPickables) {
                if (fastFlag) {
                    var osb;
                    var strokeIndex = strokeFlag ? 1 : 0;
                    if (this._orientedSphereBoundsDirty[strokeIndex]) {
                        this._orientedSphereBoundsDirty[strokeIndex] = false;
                        for (var i = 0; i < numPickables; i++)
                            osb = this._pickables[i].getSphereBounds(center, null, strokeFlag, this._orientedSphereBounds[strokeIndex], osb);
                        this._orientedSphereBounds[strokeIndex] = osb;
                    }
                    else {
                        osb = this._orientedSphereBounds[strokeIndex];
                    }
                    if (osb != null)
                        target = (matrix3D) ? matrix3D.transformSphere(osb).union(target, target || cache) : osb.union(target, target || cache);
                }
                else {
                    for (var i = 0; i < numPickables; i++)
                        target = this._pickables[i].getSphereBounds(center, matrix3D, strokeFlag, cache, target);
                }
            }
            return target;
        };
        PickEntity.prototype.applyTraversable = function (pickable) {
            //is the pickable a mask?
            this._pickables.push(this.getAbstraction(pickable));
        };
        PickEntity.prototype.onInvalidate = function (event) {
            _super.prototype.onInvalidate.call(this, event);
            this._pickables = [];
            this._orientedBoxBoundsDirty[0] = true;
            this._orientedBoxBoundsDirty[1] = true;
            this._orientedSphereBoundsDirty[0] = true;
            this._orientedSphereBoundsDirty[1] = true;
            this.dispatchEvent(new BoundsPickerEvent(BoundsPickerEvent.INVALIDATE_BOUNDS, this));
        };
        PickEntity.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            for (var key in this._boundingVolumePools) {
                this._boundingVolumePools[key].dispose();
                delete this._boundingVolumePools[key];
            }
        };
        /**
         * //TODO
         *
         * @param renderable
         * @returns IRenderState
         */
        PickEntity.prototype.getAbstraction = function (pickable) {
            return this._pickablePool[pickable.id] || (this._pickablePool[pickable.id] = new PickEntity._pickPickableClassPool[pickable.assetType](pickable, this));
        };
        /**
         *
         * @param renderable
         */
        PickEntity.prototype.clearAbstraction = function (pickable) {
            delete this._pickablePool[pickable.id];
            this.onInvalidate(null);
        };
        /**
         *
         * @param imageObjectClass
         */
        PickEntity.registerPickable = function (pickClass, assetClass) {
            PickEntity._pickPickableClassPool[assetClass.assetType] = pickClass;
        };
        PickEntity.prototype._update = function () {
            this._invalid = false;
            this._entity._acceptTraverser(this);
        };
        PickEntity.prototype._isIntersectingMasks = function (rootEntity, globalRayPosition, globalRayDirection) {
            //horrible hack for 2d masks
            //do the mask thang
            var maskOwners = this._entity.maskOwners;
            if (maskOwners) {
                var numOwners = maskOwners.length;
                var entity;
                var masks;
                var numMasks;
                var maskHit;
                for (var i = 0; i < numOwners; i++) {
                    entity = maskOwners[i];
                    if (!entity.isDescendant(rootEntity))
                        continue;
                    masks = entity.masks;
                    numMasks = masks.length;
                    maskHit = false;
                    for (var j = 0; j < numMasks; j++) {
                        entity = masks[j];
                        if (!entity.isDescendant(rootEntity))
                            continue;
                        // todo: figure out why a mask can be null here!
                        if (entity && this._pickGroup.getRaycastPicker(entity.partition)._getCollisionInternal(globalRayPosition, globalRayDirection, true, true)) {
                            maskHit = true;
                            break;
                        }
                    }
                    if (!maskHit)
                        return false;
                }
            }
            return true;
        };
        PickEntity._pickPickableClassPool = new Object();
        return PickEntity;
    }(AbstractionBase));

    /**
     * @class RenderableListItem
     */
    var _Pick_PickableBase = /** @class */ (function (_super) {
        __extends$4(_Pick_PickableBase, _super);
        /**
         *
         * @param renderable
         * @param sourceEntity
         * @param surface
         * @param renderer
         */
        function _Pick_PickableBase(pickable, pickEntity) {
            var _this = _super.call(this, pickable, pickEntity) || this;
            //store references
            _this.sourceEntity = pickEntity.entity;
            _this._view = pickEntity.view;
            _this._pickGroup = pickEntity.pickGroup;
            _this.pickable = pickable;
            return _this;
        }
        _Pick_PickableBase.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            //this.sourceEntity = null;
            this._view = null;
            this.pickable = null;
        };
        _Pick_PickableBase.prototype.hitTestPoint = function (x, y, z) {
            throw new AbstractMethodError();
        };
        _Pick_PickableBase.prototype.getBoxBounds = function (matrix3D, strokeFlag, cache, target) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            return target;
        };
        _Pick_PickableBase.prototype.getSphereBounds = function (center, matrix3D, strokeFlag, cache, target) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            return target;
        };
        _Pick_PickableBase.prototype.testCollision = function (collision, closestFlag) {
            throw new AbstractMethodError();
        };
        return _Pick_PickableBase;
    }(AbstractionBase));

    var ViewEvent = /** @class */ (function (_super) {
        __extends$4(ViewEvent, _super);
        function ViewEvent(type, view) {
            var _this = _super.call(this, type) || this;
            _this._view = view;
            return _this;
        }
        Object.defineProperty(ViewEvent.prototype, "view", {
            get: function () {
                return this._view;
            },
            enumerable: true,
            configurable: true
        });
        ViewEvent.INVALIDATE_VIEW_MATRIX3D = "invalidateViewMatrix3D";
        ViewEvent.INVALIDATE_SIZE = "invalidateSize";
        return ViewEvent;
    }(EventBase));

    /**
     * @class away.partition.NodeBase
     */
    var NodeBase = /** @class */ (function () {
        function NodeBase(entity, partition) {
            this._childNodes = new Array();
            this._numChildNodes = 0;
            this._entity = entity;
            this._partition = partition;
        }
        Object.defineProperty(NodeBase.prototype, "entity", {
            get: function () {
                return this._entity;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NodeBase.prototype, "pickObject", {
            get: function () {
                return this._entity.pickObject;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NodeBase.prototype, "boundsVisible", {
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NodeBase.prototype, "maskId", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                return this._entity.maskId;
            },
            enumerable: true,
            configurable: true
        });
        NodeBase.prototype.getBoundsPrimitive = function (pickGroup) {
            throw new AbstractMethodError();
        };
        /**
         *
         * @param planes
         * @param numPlanes
         * @returns {boolean}
         * @internal
         */
        NodeBase.prototype.isInFrustum = function (planes, numPlanes) {
            return true;
        };
        NodeBase.prototype.isVisible = function () {
            return this._entity._iIsVisible();
        };
        /**
         *
         * @param rayPosition
         * @param rayDirection
         * @returns {boolean}
         */
        NodeBase.prototype.isIntersectingRay = function (rootEntity, rayPosition, rayDirection, pickGroup) {
            return true;
        };
        /**
         *
         * @returns {boolean}
         */
        NodeBase.prototype.isRenderable = function () {
            return true;
        };
        /**
         *
         * @returns {boolean}
         */
        NodeBase.prototype.isCastingShadow = function () {
            return true;
        };
        NodeBase.prototype.dispose = function () {
            this.parent = null;
            this._childNodes = null;
        };
        /**
         *
         * @param traverser
         */
        NodeBase.prototype.acceptTraverser = function (traverser) {
            if (this._partition.root == this._entity)
                this._partition.updateEntities();
            //get the sub-traverser for the partition, if different, terminate this traversal
            if (traverser.partition != this._partition && traverser != traverser.getTraverser(this._partition))
                return;
            if (traverser.enterNode(this)) {
                for (var i = 0; i < this._numChildNodes; i++)
                    this._childNodes[i].acceptTraverser(traverser);
            }
        };
        /**
         *
         * @param node
         * @internal
         */
        NodeBase.prototype.iAddNode = function (node) {
            node.parent = this;
            this._childNodes[this._numChildNodes++] = node;
        };
        /**
         *
         * @param node
         * @internal
         */
        NodeBase.prototype.iRemoveNode = function (node) {
            var index = this._childNodes.indexOf(node);
            this._childNodes[index] = this._childNodes[--this._numChildNodes];
            this._childNodes.pop();
        };
        return NodeBase;
    }());

    /**
     * @class away.partition.Partition
     */
    var PartitionBase = /** @class */ (function (_super) {
        __extends$4(PartitionBase, _super);
        function PartitionBase(root, isScene) {
            if (isScene === void 0) { isScene = false; }
            var _this = _super.call(this) || this;
            _this._children = new Array();
            _this._abstractionPool = new Object();
            _this._updateQueue = {};
            _this._root = root;
            _this._root.addEventListener(AssetEvent.CLEAR, function (event) { return _this._onRootClear(event); });
            if (isScene)
                _this._scene = root;
            return _this;
        }
        Object.defineProperty(PartitionBase.prototype, "parent", {
            get: function () {
                return this._parent;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartitionBase.prototype, "root", {
            get: function () {
                return this._root;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PartitionBase.prototype, "scene", {
            get: function () {
                return this._scene;
            },
            enumerable: true,
            configurable: true
        });
        PartitionBase.prototype.addChild = function (child) {
            if (child && child.parent)
                child.parent.removeChildInternal(child);
            this._children.push(child);
            child._setParent(this);
            return child;
        };
        PartitionBase.prototype.removeChild = function (child) {
            this.removeChildInternal(child);
            child._setParent(null);
            return child;
        };
        PartitionBase.prototype.removeChildInternal = function (child) {
            return this._children.splice(this._children.indexOf(child), 1)[0];
        };
        PartitionBase.prototype.getAbstraction = function (entity) {
            return (this._abstractionPool[entity.id] || (this._abstractionPool[entity.id] = new PartitionBase._abstractionClassPool[entity.assetType](entity, this)));
        };
        PartitionBase.prototype.getPartition = function (entity) {
            return null;
        };
        /**
         *
         * @param image
         */
        PartitionBase.prototype.clearAbstraction = function (entity) {
            delete this._abstractionPool[entity.id];
        };
        PartitionBase.prototype.traverse = function (traverser) {
            this._invalid = false;
            this._rootNode.acceptTraverser(traverser);
        };
        PartitionBase.prototype.invalidateEntity = function (entity) {
            if (!this._invalid)
                this.invalidate();
            this._updateQueue[entity.id] = entity;
        };
        PartitionBase.prototype.updateEntity = function (entity) {
            //TODO: remove reliance on view
            //required for controllers with autoUpdate set to true and queued events
            entity._iInternalUpdate();
            this.updateNode(this.getAbstraction(entity));
        };
        PartitionBase.prototype.updateNode = function (node) {
            var targetNode = this.findParentForNode(node);
            if (targetNode && node.parent != targetNode) {
                if (node.parent)
                    node.parent.iRemoveNode(node);
                targetNode.iAddNode(node);
            }
        };
        PartitionBase.prototype.clearEntity = function (entity) {
            if (!this._invalid)
                this.invalidate();
            delete this._updateQueue[entity.id];
            this.clearNode(this.getAbstraction(entity));
        };
        PartitionBase.prototype.clearNode = function (node) {
            if (node.parent) {
                node.parent.iRemoveNode(node);
                node.parent = null;
            }
        };
        /**
         *
         * @param entity
         * @returns {away.partition.NodeBase}
         */
        PartitionBase.prototype.findParentForNode = function (node) {
            return this._rootNode;
        };
        PartitionBase.prototype.updateEntities = function () {
            for (var key in this._updateQueue)
                this.updateEntity(this._updateQueue[key]);
            //clear updateQueue
            this._updateQueue = {};
        };
        PartitionBase.prototype.invalidate = function () {
            this._invalid = true;
            _super.prototype.invalidate.call(this);
            if (this._parent)
                this._parent.invalidate();
        };
        PartitionBase.prototype.dispose = function () {
            for (var key in this._abstractionPool)
                this._abstractionPool[key].onClear(null);
        };
        PartitionBase.prototype._setParent = function (parent) {
            if (this._parent) {
                this._parent.clearNode(this._rootNode);
                this._parent.invalidate();
            }
            this._parent = parent;
            if (parent) {
                parent.updateNode(this._rootNode);
                parent.invalidate();
            }
            this._setScene(parent ? parent.scene : null);
        };
        PartitionBase.prototype._setScene = function (scene) {
            if (this._scene == scene)
                return;
            this._scene = scene;
            var len = this._children.length;
            for (var i = 0; i < len; ++i)
                this._children[i]._setScene(scene);
        };
        PartitionBase.prototype._onRootClear = function (event) {
            this.clear();
            this._abstractionPool;
        };
        /**
         *
         * @param imageObjectClass
         */
        PartitionBase.registerAbstraction = function (entityNodeClass, assetClass) {
            PartitionBase._abstractionClassPool[assetClass.assetType] = entityNodeClass;
        };
        PartitionBase._abstractionClassPool = new Object();
        return PartitionBase;
    }(AssetBase));

    /**
     * @class away.partition.Partition
     */
    var BasicPartition = /** @class */ (function (_super) {
        __extends$4(BasicPartition, _super);
        function BasicPartition(root) {
            var _this = _super.call(this, root) || this;
            _this._rootNode = new NodeBase(root, _this);
            return _this;
        }
        return BasicPartition;
    }(PartitionBase));

    /**
     * @class away.partition.EntityNode
     */
    var EntityNode = /** @class */ (function (_super) {
        __extends$4(EntityNode, _super);
        function EntityNode(entity, partition) {
            return _super.call(this, entity, partition) || this;
        }
        Object.defineProperty(EntityNode.prototype, "entity", {
            get: function () {
                return this._asset;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EntityNode.prototype, "pickObject", {
            get: function () {
                return this._asset.pickObject;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EntityNode.prototype, "boundsVisible", {
            get: function () {
                return this._asset.boundsVisible;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EntityNode.prototype, "maskId", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                return this._asset.maskId;
            },
            enumerable: true,
            configurable: true
        });
        EntityNode.prototype.getBoundsPrimitive = function (pickGroup) {
            return this._asset.getBoundsPrimitive(pickGroup);
        };
        /**
         *
         * @returns {boolean}
         */
        EntityNode.prototype.isCastingShadow = function () {
            return this._asset.castsShadows;
        };
        EntityNode.prototype.onClear = function (event) {
            this._pool.clearEntity(this._asset);
            _super.prototype.onClear.call(this, event);
        };
        /**
         *
         * @param planes
         * @param numPlanes
         * @returns {boolean}
         */
        /**
         *
         * @param planes
         * @param numPlanes
         * @returns {boolean}
         */
        EntityNode.prototype.isInFrustum = function (planes, numPlanes) {
            if (!this._asset._iIsVisible())
                return false;
            return true; // todo: hack for 2d. attention. might break stuff in 3d.
            //return this._bounds.isInFrustum(planes, numPlanes);
        };
        EntityNode.prototype.isVisible = function () {
            return this._asset._iIsVisible();
        };
        /**
         * @inheritDoc
         */
        EntityNode.prototype.isIntersectingRay = function (rootEntity, globalRayPosition, globalRayDirection, pickGroup) {
            return pickGroup.getAbstraction(this._asset)._isIntersectingRayInternal(rootEntity, globalRayPosition, globalRayDirection);
            // if (!this._entity._iIsVisible() || !this.isIntersectingMasks(globalRayPosition, globalRayDirection, this._entity._iAssignedMasks()))
            // 	return false;
            // var pickingCollision:PickingCollision = this._entity._iPickingCollision;
            // pickingCollision.rayPosition = this._entity.transform.inverseConcatenatedMatrix3D.transformVector(globalRayPosition);
            // pickingCollision.rayDirection = this._entity.transform.inverseConcatenatedMatrix3D.deltaTransformVector(globalRayDirection);
            // if (!pickingCollision.normal)
            // 	pickingCollision.normal = new Vector3D();
            // var rayEntryDistance:number = pickGroup.getAbstraction(this._entity).getBoundingVolume(null, this._entity.defaultBoundingVolume).rayIntersection(pickingCollision.rayPosition, pickingCollision.rayDirection, pickingCollision.normal);
            // if (rayEntryDistance < 0)
            // 	return false;
            // pickingCollision.rayEntryDistance = rayEntryDistance;
            // pickingCollision.globalRayPosition = globalRayPosition;
            // pickingCollision.globalRayDirection = globalRayDirection;
            // pickingCollision.rayOriginIsInsideBounds = rayEntryDistance == 0;
            // return true;
        };
        /**
         *
         * @returns {boolean}
         */
        EntityNode.prototype.isRenderable = function () {
            return this._asset._iAssignedColorTransform()._isRenderable();
        };
        /**
         * @inheritDoc
         */
        EntityNode.prototype.acceptTraverser = function (traverser) {
            if (traverser.enterNode(this))
                traverser.applyEntity(this._asset);
        };
        return EntityNode;
    }(AbstractionBase));

    /**
     * Picks a 3d object from a view or scene by 3D raycast calculations.
     * Performs an initial coarse boundary calculation to return a subset of entities whose bounding volumes intersect with the specified ray,
     * then triggers an optional picking collider on individual renderable objects to further determine the precise values of the picking ray collision.
     *
     * @class away.pick.RaycastPicker
     */
    var RaycastPicker = /** @class */ (function (_super) {
        __extends$4(RaycastPicker, _super);
        /**
         * Creates a new <code>RaycastPicker</code> object.
         *
         * @param findClosestCollision Determines whether the picker searches for the closest bounds collision along the ray,
         * or simply returns the first collision encountered. Defaults to false.
         */
        function RaycastPicker(pickGroup, partition, pool) {
            var _this = _super.call(this, partition, pool) || this;
            _this.shapeFlag = false;
            _this.findClosestCollision = false;
            _this._entities = [];
            _this._pickers = [];
            _this._collectedEntities = [];
            _this._pickGroup = pickGroup;
            _this._partition = partition;
            _this._entity = partition.root;
            return _this;
        }
        Object.defineProperty(RaycastPicker.prototype, "partition", {
            get: function () {
                return this._partition;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RaycastPicker.prototype, "entity", {
            /**
             *
             * @returns {IPickingEntity}
             */
            get: function () {
                return this._entity;
            },
            enumerable: true,
            configurable: true
        });
        RaycastPicker.prototype.traverse = function () {
            this._entities.length = 0;
            this._pickers.length = 0;
            this._partition.traverse(this);
        };
        RaycastPicker.prototype.getTraverser = function (partition) {
            if (partition.root._iIsMouseEnabled() || partition.root.isDragEntity()) {
                var traverser = this._pickGroup.getRaycastPicker(partition);
                if (traverser._isIntersectingRayInternal(this._rootEntity, this._globalRayPosition, this._globalRayDirection, this._shapeFlag))
                    this._pickers.push(traverser);
                return traverser;
            }
            return this;
        };
        Object.defineProperty(RaycastPicker.prototype, "dragEntity", {
            get: function () {
                return this._dragEntity;
            },
            set: function (entity) {
                if (this._dragEntity == entity)
                    return;
                if (this._dragEntity)
                    this._dragEntity._stopDrag();
                this._dragEntity = entity;
                if (this._dragEntity)
                    this._dragEntity._startDrag();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns true if the current node is at least partly in the frustum. If so, the partition node knows to pass on the traverser to its children.
         *
         * @param node The Partition3DNode object to frustum-test.
         */
        RaycastPicker.prototype.enterNode = function (node) {
            if (!node.isVisible() || node.maskId != this._rootEntity.maskId)
                return false;
            if (node.pickObject) {
                node.pickObject.partition.traverse(this);
                return false;
            }
            return node.isIntersectingRay(this._rootEntity, this._globalRayPosition, this._globalRayDirection, this._pickGroup);
        };
        /**
     *
     * @param planes
     * @param numPlanes
     * @returns {boolean}
     */
        RaycastPicker.prototype.isInFrustum = function (planes, numPlanes) {
            if (!this._entity._iIsVisible())
                return false;
            return true; // todo: hack for 2d. attention. might break stuff in 3d.
            //return this._bounds.isInFrustum(planes, numPlanes);
        };
        /**
         * @inheritDoc
         */
        RaycastPicker.prototype.isIntersectingRay = function (globalRayPosition, globalRayDirection, shapeFlag) {
            if (shapeFlag === void 0) { shapeFlag = false; }
            return this._isIntersectingRayInternal(this._entity, globalRayPosition, globalRayDirection, shapeFlag);
        };
        /**
         * @inheritDoc
         */
        RaycastPicker.prototype._isIntersectingRayInternal = function (rootEntity, globalRayPosition, globalRayDirection, shapeFlag) {
            this._rootEntity = rootEntity;
            this._globalRayPosition = globalRayPosition;
            this._globalRayDirection = globalRayDirection;
            this._shapeFlag = this.shapeFlag || shapeFlag;
            this.traverse();
            if (!this._entities.length && !this._pickers.length)
                return false;
            // this._pickingCollision.rayPosition = this._entity.transform.inverseConcatenatedMatrix3D.transformVector(globalRayPosition, this._pickingCollision.rayPosition);
            // this._pickingCollision.rayDirection = this._entity.transform.inverseConcatenatedMatrix3D.deltaTransformVector(globalRayDirection, this._pickingCollision.rayDirection);
            // this._pickingCollision.normal = this._pickingCollision.normal || new Vector3D();
            // var rayEntryDistance:number = this._pickGroup.getBoundsPicker(this._partition).getBoundingVolume().rayIntersection(this._pickingCollision.rayPosition, this._pickingCollision.rayDirection, this._pickingCollision.normal);
            // if (rayEntryDistance < 0)
            // 	return false;
            // this._pickingCollision.rayEntryDistance = rayEntryDistance;
            // this._pickingCollision.rayOriginIsInsideBounds = rayEntryDistance == 0;
            return true;
        };
        // public isIntersectingShape(findClosestCollision:boolean):boolean
        // {
        // 	//recalculates the rayEntryDistance and normal for shapes
        // 	var rayEntryDistance:number = Number.MAX_VALUE;
        // 	for (var i:number = 0; i < this._entities.length; ++i) {
        // 		if (this._entities[i].isIntersectingShape(findClosestCollision) && rayEntryDistance > this._entities[i].pickingCollision.rayEntryDistance) {
        // 			rayEntryDistance = this._entities[i].pickingCollision.rayEntryDistance;
        // 			this._pickingCollision.normal = this._entities[i].pickingCollision.normal;
        // 		}
        // 	}
        // 	if (rayEntryDistance == Number.MAX_VALUE) {
        // 		this._pickingCollision.rayEntryDistance = -1;
        // 		return false;
        // 	}
        // 	this._pickingCollision.rayEntryDistance = rayEntryDistance;
        // 	return true;
        // }
        /**
         * @inheritDoc
         */
        RaycastPicker.prototype.getCollision = function (rayPosition, rayDirection, shapeFlag) {
            if (shapeFlag === void 0) { shapeFlag = false; }
            return this._getCollisionInternal(rayPosition, rayDirection, shapeFlag, false);
        };
        RaycastPicker.prototype._getCollisionInternal = function (rayPosition, rayDirection, shapeFlag, maskFlag) {
            //early out if no collisions detected
            if (!this._isIntersectingRayInternal(this._entity, rayPosition, rayDirection, shapeFlag))
                return null;
            //collect pickers
            this._collectEntities(this._collectedEntities, this._dragEntity);
            //console.log("entities: ", this._entities)
            var collision = this._getPickingCollision();
            //discard collected pickers
            this._collectedEntities.length = 0;
            return collision;
        };
        RaycastPicker.prototype._collectEntities = function (collectedEntities, dragEntity) {
            var len = this._pickers.length;
            var picker;
            for (var i = 0; i < len; i++)
                if ((picker = this._pickers[i]).entity != dragEntity)
                    picker._collectEntities(collectedEntities, dragEntity);
            //ensures that raycastPicker entities are always added last, for correct 2D picking
            var entity;
            for (var i = 0; i < this._entities.length; ++i) {
                (entity = this._entities[i]).pickingCollision.pickerEntity = this._entity;
                collectedEntities.push(entity);
            }
            // //need to re-calculate the rayEntryDistance for only those entities inside the picker
            // this._pickingCollision.rayEntryDistance = Number.MAX_VALUE;
            // for (var i:number = 0; i < this._entities.length; ++i) {
            // 	if (this._pickingCollision.rayEntryDistance > this._entities[i].pickingCollision.rayEntryDistance) {
            // 		this._pickingCollision.rayEntryDistance = this._entities[i].pickingCollision.rayEntryDistance;
            // 		this._pickingCollision.normal = this._entities[i].pickingCollision.normal;
            // 	}
            // }
            // this._pickingCollision.rayOriginIsInsideBounds = this._pickingCollision.rayEntryDistance == 0;
        };
        //		public getEntityCollision(position:Vector3D, direction:Vector3D, entities:Array<IPickingEntity>):PickingCollision
        //		{
        //			this._numRenderables = 0;
        //
        //			var renderable:IPickingEntity;
        //			var l:number = entities.length;
        //
        //			for (var c:number = 0; c < l; c++) {
        //				renderable = entities[c];
        //
        //				if (renderable.isIntersectingRay(position, direction))
        //					this._renderables[this._numRenderables++] = renderable;
        //			}
        //
        //			return this.getPickingCollision(this._raycastCollector);
        //		}
        RaycastPicker.prototype.setIgnoreList = function (entities) {
            this._ignoredEntities = entities;
        };
        // public getCollider(entity:IPickingEntity):IPickingCollider
        // {
        // 	return this.getPartition(entity).getAbstraction(entity).pickingCollider;
        // }
        // public setCollider(entity:IPickingEntity, collider:IPickingCollider)
        // {
        // 	this.getPartition(entity).getAbstraction(entity).pickingCollider = collider;
        // }
        RaycastPicker.prototype.isIgnored = function (entity) {
            if (this._ignoredEntities) {
                var len = this._ignoredEntities.length;
                for (var i = 0; i < len; i++)
                    if (this._ignoredEntities[i] == entity)
                        return true;
            }
            return false;
        };
        RaycastPicker.prototype.sortOnNearT = function (entity1, entity2) {
            //return entity1._iPickingCollision.rayEntryDistance > entity2._iPickingCollision.rayEntryDistance? 1 : -1;// use this for Icycle;
            return entity1.pickingCollision.rayEntryDistance > entity2.pickingCollision.rayEntryDistance ? 1 : entity1.pickingCollision.rayEntryDistance < entity2.pickingCollision.rayEntryDistance ? -1 : 0;
        };
        RaycastPicker.prototype._getPickingCollision = function () {
            // Sort pickers from closest to furthest to reduce tests.
            this._collectedEntities = this._collectedEntities.sort(this.sortOnNearT); // TODO - test sort filter in JS
            // ---------------------------------------------------------------------
            // Evaluate triangle collisions when needed.
            // Replaces collision data provided by bounds collider with more precise data.
            // ---------------------------------------------------------------------
            var entity;
            var testCollision;
            var bestCollision;
            var len = this._collectedEntities.length;
            for (var i = 0; i < len; i++) {
                entity = this._collectedEntities[i];
                testCollision = entity.pickingCollision;
                if (bestCollision == null || testCollision.rayEntryDistance < bestCollision.rayEntryDistance) {
                    if ((this._shapeFlag || entity.shapeFlag)) {
                        testCollision.rayEntryDistance = Number.MAX_VALUE;
                        // If a collision exists, update the collision data and stop all checks.
                        if (entity.isIntersectingShape(this.findClosestCollision))
                            bestCollision = testCollision;
                    }
                    else if (!testCollision.rayOriginIsInsideBounds) {
                        // A bounds collision with no picking collider stops all checks.
                        // Note: a bounds collision with a ray origin inside its bounds is ONLY ever used
                        // to enable the detection of a corresponsding triangle collision.
                        // Therefore, bounds collisions with a ray origin inside its bounds can be ignored
                        // if it has been established that there is NO triangle collider to test
                        bestCollision = testCollision;
                        break;
                    }
                }
                else {
                    //if the next rayEntryDistance of testCollision is greater than bestCollision,
                    //there won't be a better collision available
                    break;
                }
            }
            if (bestCollision)
                this.updatePosition(bestCollision);
            if (this._dragEntity) {
                if (this._dragEntity.assetType == "[asset MovieClip]" && this._dragEntity.adapter) {
                    this._dragEntity.adapter.setDropTarget(bestCollision ? bestCollision.entity : null);
                }
            }
            return bestCollision;
        };
        RaycastPicker.prototype.updatePosition = function (pickingCollision) {
            var collisionPos = pickingCollision.position || (pickingCollision.position = new Vector3D());
            var rayDir = pickingCollision.rayDirection;
            var rayPos = pickingCollision.rayPosition;
            var t = pickingCollision.rayEntryDistance;
            collisionPos.x = rayPos.x + t * rayDir.x;
            collisionPos.y = rayPos.y + t * rayDir.y;
            collisionPos.z = rayPos.z + t * rayDir.z;
        };
        RaycastPicker.prototype.dispose = function () {
            //TODO
        };
        /**
         *
         * @param entity
         */
        RaycastPicker.prototype.applyEntity = function (entity) {
            if (!this.isIgnored(entity)) {
                var pickEntity = this._pickGroup.getAbstraction(entity);
                this._entities.push(pickEntity);
            }
        };
        return RaycastPicker;
    }(AbstractionBase));

    /**
     * Picks a 3d object from a view or scene by 3D raycast calculations.
     * Performs an initial coarse boundary calculation to return a subset of entities whose bounding volumes intersect with the specified ray,
     * then triggers an optional picking collider on individual renderable objects to further determine the precise values of the picking ray collision.
     *
     * @class away.pick.RaycastPicker
     */
    var BoundsPicker = /** @class */ (function (_super) {
        __extends$4(BoundsPicker, _super);
        /**
         * Creates a new <code>RaycastPicker</code> object.
         *
         * @param findClosestCollision Determines whether the picker searches for the closest bounds collision along the ray,
         * or simply returns the first collision encountered. Defaults to false.
         */
        function BoundsPicker(pickGroup, partition, pool) {
            var _this = _super.call(this, partition, pool) || this;
            _this._boundingVolumePools = new Object();
            _this._boundsPickers = [];
            _this._pickGroup = pickGroup;
            _this._partition = partition;
            _this._entity = partition.root;
            return _this;
        }
        Object.defineProperty(BoundsPicker.prototype, "partition", {
            get: function () {
                return this._partition;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BoundsPicker.prototype, "entity", {
            /**
             *
             * @returns {IPartitionEntity}
             */
            get: function () {
                return this._entity;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BoundsPicker.prototype, "width", {
            /**
             * Indicates the width of the display object, in pixels. The width is
             * calculated based on the bounds of the content of the display object. When
             * you set the <code>width</code> property, the <code>scaleX</code> property
             * is adjusted accordingly, as shown in the following code:
             *
             * <p>Except for TextField and Video objects, a display object with no
             * content(such as an empty sprite) has a width of 0, even if you try to set
             * <code>width</code> to a different value.</p>
             */
            get: function () {
                var box = this.getBoxBounds();
                if (box == null)
                    return 0;
                // if (this._entity._registrationMatrix3D)
                // 	return box.width*this._entity.scaleX*this._entity._registrationMatrix3D._rawData[0];
                return box.width * this._entity.transform.scale.x;
            },
            set: function (val) {
                var box = this.getBoxBounds();
                //return if box is empty ie setting width for no content is impossible
                if (box == null || box.width == 0)
                    return;
                //this._updateAbsoluteDimension();
                this._entity.transform.scaleTo(val / box.width, this._entity.transform.scale.y, this._entity.transform.scale.z);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BoundsPicker.prototype, "height", {
            /**
             * Indicates the height of the display object, in pixels. The height is
             * calculated based on the bounds of the content of the display object. When
             * you set the <code>height</code> property, the <code>scaleY</code> property
             * is adjusted accordingly, as shown in the following code:
             *
             * <p>Except for TextField and Video objects, a display object with no
             * content (such as an empty sprite) has a height of 0, even if you try to
             * set <code>height</code> to a different value.</p>
             */
            get: function () {
                var box = this.getBoxBounds();
                if (box == null)
                    return 0;
                // if (this._entity._registrationMatrix3D)
                // 	return box.height*this._entity.scaleY*this._entity._registrationMatrix3D._rawData[5];
                return box.height * this._entity.transform.scale.y;
            },
            set: function (val) {
                var box = this.getBoxBounds();
                //return if box is empty ie setting height for no content is impossible
                if (box == null || box.height == 0)
                    return;
                //this._updateAbsoluteDimension();
                this._entity.transform.scaleTo(this._entity.transform.scale.x, val / box.height, this._entity.transform.scale.z);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BoundsPicker.prototype, "depth", {
            /**
             * Indicates the depth of the display object, in pixels. The depth is
             * calculated based on the bounds of the content of the display object. When
             * you set the <code>depth</code> property, the <code>scaleZ</code> property
             * is adjusted accordingly, as shown in the following code:
             *
             * <p>Except for TextField and Video objects, a display object with no
             * content (such as an empty sprite) has a depth of 0, even if you try to
             * set <code>depth</code> to a different value.</p>
             */
            get: function () {
                var box = this.getBoxBounds();
                if (box == null)
                    return 0;
                // if (this._entity._registrationMatrix3D)
                // 	return  box.depth*this._entity.scaleZ*this._entity._registrationMatrix3D._rawData[10];
                return box.depth * this._entity.transform.scale.z;
            },
            set: function (val) {
                var box = this.getBoxBounds();
                //return if box is empty ie setting depth for no content is impossible
                if (box == null || box.depth == 0)
                    return;
                //this._updateAbsoluteDimension();
                this._entity.transform.scaleTo(this._entity.transform.scale.x, this._entity.transform.scale.y, val / box.depth);
            },
            enumerable: true,
            configurable: true
        });
        BoundsPicker.prototype.onInvalidate = function (event) {
            _super.prototype.onInvalidate.call(this, event);
            this.dispatchEvent(new BoundsPickerEvent(BoundsPickerEvent.INVALIDATE_BOUNDS, this));
        };
        BoundsPicker.prototype.traverse = function () {
            this._boundsPickers.length = 0;
            this._partition.traverse(this);
            this._invalid = false;
        };
        BoundsPicker.prototype.getTraverser = function (partition) {
            var traverser = this._pickGroup.getBoundsPicker(partition);
            if (this._invalid)
                this._boundsPickers.push(traverser);
            return traverser;
        };
        /**
         * Returns true if the current node is at least partly in the frustum. If so, the partition node knows to pass on the traverser to its children.
         *
         * @param node The Partition3DNode object to frustum-test.
         */
        BoundsPicker.prototype.enterNode = function (node) {
            return true;
        };
        BoundsPicker.prototype.getBoundingVolume = function (targetCoordinateSpace, boundingVolumeType) {
            if (targetCoordinateSpace === void 0) { targetCoordinateSpace = null; }
            if (boundingVolumeType === void 0) { boundingVolumeType = null; }
            if (boundingVolumeType == null)
                boundingVolumeType = this._entity.defaultBoundingVolume;
            var pool = (this._boundingVolumePools[boundingVolumeType] || (this._boundingVolumePools[boundingVolumeType] = new BoundingVolumePool(this, boundingVolumeType)));
            return pool.getAbstraction(targetCoordinateSpace);
        };
        BoundsPicker.prototype.getBoxBounds = function (targetCoordinateSpace, strokeFlag, fastFlag) {
            if (targetCoordinateSpace === void 0) { targetCoordinateSpace = null; }
            if (strokeFlag === void 0) { strokeFlag = false; }
            if (fastFlag === void 0) { fastFlag = false; }
            return this.getBoundingVolume(targetCoordinateSpace, strokeFlag ? (fastFlag ? BoundingVolumeType.BOX_BOUNDS_FAST : BoundingVolumeType.BOX_BOUNDS) : (fastFlag ? BoundingVolumeType.BOX_FAST : BoundingVolumeType.BOX)).getBox();
        };
        BoundsPicker.prototype.getSphereBounds = function (targetCoordinateSpace, strokeFlag, fastFlag) {
            if (targetCoordinateSpace === void 0) { targetCoordinateSpace = null; }
            if (strokeFlag === void 0) { strokeFlag = false; }
            if (fastFlag === void 0) { fastFlag = false; }
            return this.getBoundingVolume(targetCoordinateSpace, strokeFlag ? (fastFlag ? BoundingVolumeType.SPHERE_BOUNDS_FAST : BoundingVolumeType.SPHERE_BOUNDS) : (fastFlag ? BoundingVolumeType.SPHERE_FAST : BoundingVolumeType.SPHERE)).getSphere();
        };
        BoundsPicker.prototype.hitTestPoint = function (x, y, shapeFlag) {
            if (shapeFlag === void 0) { shapeFlag = false; }
            return this._hitTestPointInternal(this._entity, x, y, shapeFlag, false);
        };
        BoundsPicker.prototype._hitTestPointInternal = function (rootEntity, x, y, shapeFlag, maskFlag) {
            if (shapeFlag === void 0) { shapeFlag = false; }
            if (maskFlag === void 0) { maskFlag = false; }
            if (this._entity.maskId != -1 && (!maskFlag || !shapeFlag)) //allow masks for bounds hit tests
                return false;
            if (this._invalid)
                this.traverse();
            //set local tempPoint for later reference
            var tempPoint = new Point(x, y);
            this._entity.transform.globalToLocal(tempPoint, tempPoint);
            //early out for box test
            var box = this.getBoxBounds(null, false, true);
            if (box == null || !box.contains(tempPoint.x, tempPoint.y, 0))
                return false;
            //early out for non-shape tests
            if (!shapeFlag || this._entity.assetType == "[asset TextField]" || this._entity.assetType == "[asset Billboard]")
                return true;
            var numPickers = this._boundsPickers.length;
            if (numPickers)
                for (var i = 0; i < numPickers; ++i)
                    if (this._boundsPickers[i]._hitTestPointInternal(rootEntity, x, y, shapeFlag, maskFlag))
                        return true;
        };
        /**
         * Evaluates the bounding box of the display object to see if it overlaps or
         * intersects with the bounding box of the <code>obj</code> display object.
         *
         * @param obj The display object to test against.
         * @return <code>true</code> if the bounding boxes of the display objects
         *         intersect; <code>false</code> if not.
         */
        BoundsPicker.prototype.hitTestObject = function (obj) {
            //TODO: getBoxBounds should be using the root partition root
            var objBox = obj.getBoxBounds(this._entity, true);
            if (objBox == null)
                return false;
            var box = this.getBoxBounds(this._entity, true);
            if (box == null)
                return false;
            if (objBox.intersects(box))
                return true;
            return false;
        };
        BoundsPicker.prototype._getBoxBoundsInternal = function (matrix3D, strokeFlag, fastFlag, cache, target) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (fastFlag === void 0) { fastFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (this._invalid)
                this.traverse();
            var numPickers = this._boundsPickers.length;
            if (numPickers > 0) {
                var m = new Matrix3D();
                for (var i = 0; i < numPickers; ++i) {
                    if (this._boundsPickers[i].entity != this._entity) {
                        if (matrix3D)
                            m.copyFrom(matrix3D);
                        else
                            m.identity();
                        m.prepend(this._boundsPickers[i].entity.transform.matrix3D);
                        if (this._boundsPickers[i].entity._registrationMatrix3D)
                            m.prepend(this._boundsPickers[i].entity._registrationMatrix3D);
                        target = this._boundsPickers[i]._getBoxBoundsInternal(m, strokeFlag, fastFlag, cache, target);
                    }
                    else {
                        target = this._boundsPickers[i]._getBoxBoundsInternal(matrix3D, strokeFlag, fastFlag, cache, target);
                    }
                }
            }
            return target;
        };
        BoundsPicker.prototype._getSphereBoundsInternal = function (center, matrix3D, strokeFlag, fastFlag, cache, target) {
            if (center === void 0) { center = null; }
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (fastFlag === void 0) { fastFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (this._invalid)
                this.traverse();
            var box = this._getBoxBoundsInternal(matrix3D, strokeFlag, fastFlag);
            if (box == null)
                return;
            if (!center) {
                center = new Vector3D();
                center.x = box.x + box.width / 2;
                center.y = box.y + box.height / 2;
                center.z = box.z + box.depth / 2;
            }
            var numPickers = this._boundsPickers.length;
            if (numPickers > 0) {
                var m = new Matrix3D();
                for (var i = 0; i < numPickers; ++i) {
                    if (this._boundsPickers[i].entity != this._entity) {
                        if (matrix3D)
                            m.copyFrom(matrix3D);
                        else
                            m.identity();
                        m.prepend(this._boundsPickers[i].entity.transform.matrix3D);
                        if (this._boundsPickers[i].entity._registrationMatrix3D)
                            m.prepend(this._boundsPickers[i].entity._registrationMatrix3D);
                        target = this._boundsPickers[i]._getSphereBoundsInternal(center, m, strokeFlag, fastFlag, cache, target);
                    }
                    else {
                        target = this._boundsPickers[i]._getSphereBoundsInternal(center, matrix3D, strokeFlag, fastFlag, cache, target);
                    }
                }
            }
            return target;
        };
        /**
     *
     * @param planes
     * @param numPlanes
     * @returns {boolean}
     */
        BoundsPicker.prototype.isInFrustum = function (planes, numPlanes) {
            if (!this._entity._iIsVisible())
                return false;
            return true; // todo: hack for 2d. attention. might break stuff in 3d.
            //return this._bounds.isInFrustum(planes, numPlanes);
        };
        BoundsPicker.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            for (var key in this._boundingVolumePools) {
                this._boundingVolumePools[key].dispose();
                delete this._boundingVolumePools[key];
            }
        };
        BoundsPicker.prototype.dispose = function () {
            //TODO
        };
        /**
         *
         * @param entity
         */
        BoundsPicker.prototype.applyEntity = function (entity) {
            this._boundsPickers.push(this._pickGroup.getAbstraction(entity));
        };
        return BoundsPicker;
    }(AbstractionBase));

    /**
     * Picks a 3d object from a view or scene by 3D raycast calculations.
     * Performs an initial coarse boundary calculation to return a subset of entities whose bounding volumes intersect with the specified ray,
     * then triggers an optional picking collider on individual renderable objects to further determine the precise values of the picking ray collision.
     *
     * @class away.pick.RaycastPicker
     */
    var TabPicker = /** @class */ (function (_super) {
        __extends$4(TabPicker, _super);
        /**
         * Creates a new <code>RaycastPicker</code> object.
         *
         * @param findClosestCollision Determines whether the picker searches for the closest bounds collision along the ray,
         * or simply returns the first collision encountered. Defaults to false.
         */
        function TabPicker(partition, pool) {
            var _this = _super.call(this, partition, pool) || this;
            _this._tabEntities = [];
            _this._customTabEntities = [];
            _this._customTabEntitiesSorted = [];
            _this._partition = partition;
            _this._entity = partition.root;
            return _this;
        }
        Object.defineProperty(TabPicker.prototype, "partition", {
            get: function () {
                return this._partition;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TabPicker.prototype, "entity", {
            /**
             *
             * @returns {IPartitionEntity}
             */
            get: function () {
                return this._entity;
            },
            enumerable: true,
            configurable: true
        });
        TabPicker.prototype.sortTabEnabledEntities = function () {
            if (this._customTabEntities.length <= 0 && this._tabEntities.length <= 0)
                return;
            var snapGridY = 10;
            var len = 0;
            var orderedOnY = [];
            var i = 0;
            var e = 0;
            if (this._customTabEntities.length > 0) {
                while (i < this._customTabEntities.length) {
                    if (this._customTabEntities[i]) {
                        this._customTabEntities[i] = this._customTabEntities[i].reverse();
                    }
                    i++;
                }
                return;
            }
            //  first sort into rows based on global y-position, snapping y-positions to a grid 
            //  than sort the rows by global x-position
            len = this._tabEntities.length;
            for (i = 0; i < len; i++) {
                var enabledEntity = this._tabEntities[i];
                var scenePosition = enabledEntity.transform.concatenatedMatrix3D.position;
                //console.log("enabledEntity.scenePosition.y", scenePosition.y);
                var ySnappedToGrid = Math.floor(scenePosition.y / snapGridY);
                if (orderedOnY.length <= ySnappedToGrid) {
                    orderedOnY.length = ySnappedToGrid + 1;
                }
                if (!orderedOnY[ySnappedToGrid])
                    orderedOnY[ySnappedToGrid] = [];
                orderedOnY[ySnappedToGrid].push(enabledEntity);
            }
            this._tabEntities.length = 0;
            for (i = 0; i < orderedOnY.length; i++) {
                var entityRow = orderedOnY[i];
                if (entityRow) {
                    //console.log("entityRow", entityRow.length);
                    entityRow = entityRow.sort(function (a, b) {
                        return a.transform.concatenatedMatrix3D.position.x > b.transform.concatenatedMatrix3D.position.x ? 1 : -1;
                    });
                    for (e = 0; e < entityRow.length; e++) {
                        //console.log("2enabledEntity.scenePosition.y", entityRow[e].transform.concatenatedMatrix3D.position.y);
                        //console.log("2enabledEntity.scenePosition.x", entityRow[e].transform.concatenatedMatrix3D.position.x);
                        this._tabEntities[this._tabEntities.length] = entityRow[e];
                    }
                }
            }
        };
        TabPicker.prototype.traverse = function () {
            this._tabEntities.length = 0;
            this._customTabEntities.length = 0;
            this._customTabEntitiesSorted.length = 0;
            this._partition.traverse(this);
            this.sortTabEnabledEntities();
            this._invalid = false;
        };
        TabPicker.prototype.getTraverser = function (partition) {
            return this;
        };
        TabPicker.prototype.getNextTabEntity = function (currentFocus) {
            if (this._invalid)
                this.traverse();
            if (this._customTabEntities.length <= 0 && this._tabEntities.length <= 0)
                return currentFocus;
            if (this._customTabEntities.length > 0) {
                var i = 0;
                var i2 = 0;
                var t = 0;
                var t2 = 0;
                if (currentFocus) {
                    while (i < this._customTabEntities.length) {
                        if (this._customTabEntities[i]) {
                            for (t = 0; t < this._customTabEntities[i].length; t++) {
                                if (this._customTabEntities[i][t] == currentFocus) {
                                    t2 = t + 1;
                                    while (t2 < this._customTabEntities[i].length) {
                                        if (this._customTabEntities[i][t2])
                                            return this._customTabEntities[i][t2];
                                        t2++;
                                    }
                                    i2 = i + 1;
                                    while (i2 < this._customTabEntities.length) {
                                        if (this._customTabEntities[i2]) {
                                            for (t2 = 0; t2 < this._customTabEntities[i2].length; t2++) {
                                                if (this._customTabEntities[i2][t2])
                                                    return this._customTabEntities[i2][t2];
                                            }
                                        }
                                        i2++;
                                    }
                                    i2 = 0;
                                    while (i2 < this._customTabEntities.length) {
                                        if (this._customTabEntities[i2]) {
                                            for (t2 = 0; t2 < this._customTabEntities[i2].length; t2++) {
                                                if (this._customTabEntities[i2][t2])
                                                    return this._customTabEntities[i2][t2];
                                            }
                                        }
                                        i2++;
                                    }
                                }
                            }
                        }
                        i++;
                    }
                }
                i2 = 0;
                while (i2 < this._customTabEntities.length) {
                    if (this._customTabEntities[i2]) {
                        for (t2 = 0; t2 < this._customTabEntities[i2].length; t2++) {
                            if (this._customTabEntities[i2][t2])
                                return this._customTabEntities[i2][t2];
                        }
                    }
                    i2++;
                }
                return currentFocus;
            }
            var len = this._tabEntities.length;
            for (var i = 0; i < len; i++) {
                if (this._tabEntities[i] == currentFocus) {
                    if (i == len - 1) {
                        return this._tabEntities[0];
                    }
                    return this._tabEntities[i + 1];
                }
            }
            // this point we would already have exit out if tabEntities.length was 0
            return this._tabEntities[0];
        };
        TabPicker.prototype.getPrevTabEntity = function (currentFocus) {
            if (this._invalid)
                this.traverse();
            if (this._customTabEntities.length <= 0 && this._tabEntities.length <= 0)
                return currentFocus;
            if (this._customTabEntities.length > 0) {
                var i = this._customTabEntities.length;
                var i2 = 0;
                var t = 0;
                var t2 = 0;
                if (currentFocus) {
                    while (i > 0) {
                        i--;
                        if (this._customTabEntities[i]) {
                            for (t = this._customTabEntities[i].length - 1; t >= 0; t--) {
                                if (this._customTabEntities[i][t] == currentFocus) {
                                    t2 = t - 1;
                                    while (t2 > 0) {
                                        t2--;
                                        if (this._customTabEntities[i][t2])
                                            return this._customTabEntities[i][t2];
                                    }
                                    i2 = i - 1;
                                    while (i2 > 0) {
                                        i2--;
                                        if (this._customTabEntities[i2]) {
                                            for (t2 = this._customTabEntities[i2].length - 1; t2 >= 0; t2--) {
                                                if (this._customTabEntities[i2][t2])
                                                    return this._customTabEntities[i2][t2];
                                            }
                                        }
                                    }
                                    i2 = this._customTabEntities.length;
                                    while (i2 > 0) {
                                        i2--;
                                        if (this._customTabEntities[i2]) {
                                            for (t2 = this._customTabEntities[i2].length - 1; t2 >= 0; t2--) {
                                                if (this._customTabEntities[i2][t2])
                                                    return this._customTabEntities[i2][t2];
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
                i2 = this._customTabEntities.length - 1;
                while (i2 > 0) {
                    i2--;
                    if (this._customTabEntities[i2]) {
                        for (t2 = this._customTabEntities[i2].length - 1; t2 >= 0; t2--) {
                            if (this._customTabEntities[i2][t2])
                                return this._customTabEntities[i2][t2];
                        }
                    }
                }
                return currentFocus;
            }
            if (currentFocus) {
                var len = this._tabEntities.length;
                for (var i = len - 1; i >= 0; i--) {
                    if (this._tabEntities[i] == currentFocus) {
                        if (i == 0) {
                            return this._tabEntities[this._tabEntities.length - 1];
                        }
                        return this._tabEntities[i - 1];
                    }
                }
            }
            // this point we would already have exit out if tabEntities.length was 0
            return this._tabEntities[0];
        };
        /**
         * Returns true if the current node is at least partly in the frustum. If so, the partition node knows to pass on the traverser to its children.
         *
         * @param node The Partition3DNode object to frustum-test.
         */
        TabPicker.prototype.enterNode = function (node) {
            if (!node.isVisible())
                return false;
            return true;
        };
        TabPicker.prototype.dispose = function () {
            //TODO
        };
        /**
         *
         * @param entity
         */
        TabPicker.prototype.applyEntity = function (entity) {
            if (entity.tabEnabled) {
                if (entity.assetType != "[asset TextField]" || entity.type == "input") {
                    // add the entity to the correct tab list.
                    if (entity.tabIndex >= 0) {
                        if (this._customTabEntities.length < entity.tabIndex)
                            this._customTabEntities.length = entity.tabIndex;
                        if (!this._customTabEntities[entity.tabIndex]) {
                            this._customTabEntities[entity.tabIndex] = [];
                        }
                        this._customTabEntities[entity.tabIndex].push(entity);
                    }
                    else {
                        this._tabEntities[this._tabEntities.length] = entity;
                    }
                }
            }
        };
        return TabPicker;
    }(AbstractionBase));

    /**
     * @class away.pool.PickGroup
     */
    var PickGroup = /** @class */ (function () {
        /**
         * //TODO
         *
         * @param materialClassGL
         */
        function PickGroup(view) {
            this._entityPool = new Object();
            this._view = view;
            this._raycastPickerPool = new RaycastPickerPool(this);
            this._boundsPickerPool = new BoundsPickerPool(this);
            this._tabPickerPool = PickGroup._tabPickerPool || (PickGroup._tabPickerPool = new TabPickerPool());
        }
        Object.defineProperty(PickGroup, "instancePool", {
            get: function () { return PickGroup._instancePool; },
            enumerable: true,
            configurable: true
        });
        PickGroup.clearAllInstances = function () {
            for (var key in this._instancePool) {
                var inst = this._instancePool[key];
                if (inst) {
                    for (var key2 in inst._entityPool) {
                        if (inst._entityPool[key2] && inst._entityPool[key2].entity) {
                            if (!inst._entityPool[key2].entity.isStage)
                                inst._entityPool[key2].entity.dispose();
                        }
                        if (inst._entityPool[key2])
                            delete inst._entityPool[key2];
                    }
                    inst._entityPool = null;
                }
                delete this._instancePool[key];
            }
        };
        PickGroup.getInstance = function (view) {
            return this._instancePool[view.id] || (this._instancePool[view.id] = new PickGroup(view));
        };
        PickGroup.prototype.getAbstraction = function (entity) {
            return this._entityPool[entity.id] || (this._entityPool[entity.id] = new PickEntity(this._view, entity, this));
        };
        /**
         *
         * @param entity
         */
        PickGroup.prototype.clearAbstraction = function (entity) {
            delete this._entityPool[entity.id];
        };
        PickGroup.prototype.getRaycastPicker = function (partition) {
            return this._raycastPickerPool.getAbstraction(partition);
        };
        PickGroup.prototype.getBoundsPicker = function (partition) {
            return this._boundsPickerPool.getAbstraction(partition);
        };
        PickGroup.prototype.getTabPicker = function (partition) {
            return this._tabPickerPool.getAbstraction(partition);
        };
        PickGroup._instancePool = new Object();
        return PickGroup;
    }());
    var RaycastPickerPool = /** @class */ (function () {
        function RaycastPickerPool(pickGroup) {
            this._abstractionPool = new Object();
            this._pickGroup = pickGroup;
        }
        /**
         * //TODO
         *
         * @param entity
         * @returns EntityNode
         */
        RaycastPickerPool.prototype.getAbstraction = function (partition) {
            return (this._abstractionPool[partition.id] || (this._abstractionPool[partition.id] = new RaycastPicker(this._pickGroup, partition, this)));
        };
        /**
         *
         * @param entity
         */
        RaycastPickerPool.prototype.clearAbstraction = function (partition) {
            delete this._abstractionPool[partition.id];
        };
        return RaycastPickerPool;
    }());
    var BoundsPickerPool = /** @class */ (function () {
        function BoundsPickerPool(pickGroup) {
            this._abstractionPool = new Object();
            this._pickGroup = pickGroup;
        }
        /**
         * //TODO
         *
         * @param entity
         * @returns EntityNode
         */
        BoundsPickerPool.prototype.getAbstraction = function (partition) {
            return (this._abstractionPool[partition.id] || (this._abstractionPool[partition.id] = new BoundsPicker(this._pickGroup, partition, this)));
        };
        /**
         *
         * @param entity
         */
        BoundsPickerPool.prototype.clearAbstraction = function (partition) {
            delete this._abstractionPool[partition.id];
        };
        return BoundsPickerPool;
    }());
    var TabPickerPool = /** @class */ (function () {
        function TabPickerPool() {
            this._abstractionPool = new Object();
        }
        /**
         * //TODO
         *
         * @param entity
         * @returns EntityNode
         */
        TabPickerPool.prototype.getAbstraction = function (partition) {
            return (this._abstractionPool[partition.id] || (this._abstractionPool[partition.id] = new TabPicker(partition, this)));
        };
        /**
         *
         * @param entity
         */
        TabPickerPool.prototype.clearAbstraction = function (partition) {
            delete this._abstractionPool[partition.id];
        };
        return TabPickerPool;
    }());

    var View = /** @class */ (function (_super) {
        __extends$4(View, _super);
        function View(projection, stage, forceSoftware, profile, mode, alpha) {
            if (projection === void 0) { projection = null; }
            if (stage === void 0) { stage = null; }
            if (forceSoftware === void 0) { forceSoftware = false; }
            if (profile === void 0) { profile = ContextGLProfile.BASELINE; }
            if (mode === void 0) { mode = ContextMode.AUTO; }
            if (alpha === void 0) { alpha = false; }
            var _this = _super.call(this) || this;
            _this._rect = new Rectangle();
            _this._backgroundRed = 0;
            _this._backgroundGreen = 0;
            _this._backgroundBlue = 0;
            _this._focalLength = 1000;
            _this._pixelRatio = 1;
            _this._frustumMatrix3D = new Matrix3D();
            _this._viewMatrix3D = new Matrix3D();
            _this._inverseViewMatrix3D = new Matrix3D();
            _this._components = new Array(4);
            _this._offset = new Vector3D();
            _this._scale = new Vector3D(1, 1, 1);
            _this._frustumMatrix3DDirty = true;
            _this._viewMatrix3DDirty = true;
            _this._inverseViewMatrix3DDirty = true;
            /**
             *
             */
            _this.backgroundAlpha = 1;
            /**
             *
             */
            _this.backgroundDepth = 1;
            /**
             *
             */
            _this.backgroundStencil = 0;
            /**
             *
             */
            _this.preservePixelRatio = true;
            /**
             *
             */
            _this.preserveFocalLength = false;
            /**
             *
             */
            _this.preserveDimensions = false;
            _this._components[0] = _this._offset;
            _this._components[3] = _this._scale;
            _this._onInvalidateSizeDelegate = function (event) { return _this._onInvalidateSize(event); };
            _this._onInvalidateViewMatrix3DDelegate = function (event) { return _this._onInvalidateViewMatrix3D(event); };
            _this._projection = projection || new PerspectiveProjection();
            _this._projection.addEventListener(ProjectionEvent.INVALIDATE_VIEW_MATRIX3D, _this._onInvalidateViewMatrix3DDelegate);
            if (stage)
                _this._shareContext = true;
            _this._stage = stage || StageManager.getInstance().getFreeStage(forceSoftware, profile, mode, alpha);
            _this._stage.addEventListener(StageEvent.INVALIDATE_SIZE, _this._onInvalidateSizeDelegate);
            _this._targetWidth = _this._stage.width;
            _this._targetHeight = _this._stage.height;
            _this._updateFocalLength();
            _this._updatePixelRatio();
            return _this;
        }
        Object.defineProperty(View.prototype, "shareContext", {
            /**
             *
             */
            get: function () {
                return this._shareContext;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "x", {
            /**
             *
             */
            get: function () {
                if (this._shareContext || this._target)
                    return this._rect.x;
                return this._stage.x;
            },
            set: function (value) {
                if (this._shareContext || this._target) {
                    if (this._rect.x == value)
                        return;
                    this._offset.x = (this._rect.x = value) / this._targetWidth;
                    this._invalidateViewMatrix3D();
                }
                else {
                    this._stage.x = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "y", {
            /**
             *
             */
            get: function () {
                if (this._shareContext || this._target)
                    return this._rect.y;
                return this._stage.y;
            },
            set: function (value) {
                if (this._shareContext || this._target) {
                    if (this._rect.y == value)
                        return;
                    this._offset.y = (this._rect.y = value) / this._targetHeight;
                    this._invalidateViewMatrix3D();
                }
                else {
                    this._stage.y = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "width", {
            /**
             *
             */
            get: function () {
                return this._rect.width;
            },
            set: function (value) {
                if (this._rect.width == value)
                    return;
                this._rect.width = value;
                if (this._shareContext || this._target) {
                    this._scale.x = value / this._targetWidth;
                    this._updatePixelRatio();
                    this._invalidateViewMatrix3D();
                }
                else {
                    this._stage.width = value;
                }
                this._invalidateSize();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "height", {
            /**
             *
             */
            get: function () {
                return this._scale.y * this._targetHeight;
            },
            set: function (value) {
                if (this._rect.height == value)
                    return;
                this._rect.height = value;
                if (this._shareContext || this._target) {
                    this._scale.y = value / this._targetHeight;
                    this._updateFocalLength();
                    this._updatePixelRatio();
                    this._invalidateViewMatrix3D();
                }
                else {
                    this._stage.height = value;
                }
                this._invalidateSize();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "backgroundColor", {
            /**
             *
             */
            get: function () {
                return this._backgroundColor;
            },
            set: function (value) {
                if (this._backgroundColor == value)
                    return;
                this._backgroundColor = value;
                this._backgroundRed = ((value >> 16) & 0xff) / 0xff;
                this._backgroundGreen = ((value >> 8) & 0xff) / 0xff;
                this._backgroundBlue = (value & 0xff) / 0xff;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "focalLength", {
            /**
             *
             */
            get: function () {
                return this._focalLength;
            },
            set: function (value) {
                if (this._focalLength == value)
                    return;
                this._focalLength = value;
                this._updateFocalLength();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "pixelRatio", {
            /**
             *
             */
            get: function () {
                return this._pixelRatio;
            },
            set: function (value) {
                if (this._pixelRatio == value)
                    return;
                this._pixelRatio = value;
                this._updatePixelRatio();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "projection", {
            get: function () {
                return this._projection;
            },
            set: function (value) {
                if (value == null)
                    throw new ErrorBase("projection cannot be null");
                if (this._projection == value)
                    return;
                this._projection.removeEventListener(ProjectionEvent.INVALIDATE_VIEW_MATRIX3D, this._onInvalidateViewMatrix3DDelegate);
                this._projection = value;
                this._projection.addEventListener(ProjectionEvent.INVALIDATE_VIEW_MATRIX3D, this._onInvalidateViewMatrix3DDelegate);
                this._invalidateViewMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "target", {
            get: function () {
                return this._target;
            },
            set: function (value) {
                if (this._target == value)
                    return;
                this._updateTarget(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "stage", {
            get: function () {
                return this._stage;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "frustumMatrix3D", {
            get: function () {
                if (this._frustumMatrix3DDirty) {
                    this._frustumMatrix3DDirty = false;
                    this._frustumMatrix3D.recompose(this._components);
                    this._frustumMatrix3D.prepend(this._projection.frustumMatrix3D);
                }
                return this._frustumMatrix3D;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "viewMatrix3D", {
            get: function () {
                if (this._viewMatrix3DDirty) {
                    this._viewMatrix3DDirty = false;
                    this._viewMatrix3D.recompose(this._components);
                    this._viewMatrix3D.prepend(this._projection.viewMatrix3D);
                }
                return this._viewMatrix3D;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(View.prototype, "inverseViewMatrix3D", {
            get: function () {
                if (this._inverseViewMatrix3DDirty) {
                    this._inverseViewMatrix3DDirty = false;
                    this._inverseViewMatrix3D.copyFrom(this.viewMatrix3D);
                    this._inverseViewMatrix3D.invert();
                }
                return this._inverseViewMatrix3D;
            },
            enumerable: true,
            configurable: true
        });
        View.prototype.clear = function (enableClear, enableDepthAndStencil, surfaceSelector, mipmapSelector, clearMaskSelector) {
            if (enableClear === void 0) { enableClear = true; }
            if (enableDepthAndStencil === void 0) { enableDepthAndStencil = true; }
            if (surfaceSelector === void 0) { surfaceSelector = 0; }
            if (mipmapSelector === void 0) { mipmapSelector = 0; }
            if (clearMaskSelector === void 0) { clearMaskSelector = ContextGLClearMask.ALL; }
            this._stage.setRenderTarget(this._target, enableDepthAndStencil, surfaceSelector, mipmapSelector);
            //TODO: make scissor compatible with image targets
            this._stage.setScissor((this._target == null) ? this._rect : null);
            if (enableClear)
                this._stage.clear(this._backgroundRed, this._backgroundGreen, this._backgroundBlue, this.backgroundAlpha, this.backgroundDepth, this.backgroundStencil, clearMaskSelector);
        };
        View.prototype.present = function () {
            if (!this._shareContext && this._target == null)
                this._stage.context.present();
        };
        /*
        
         */
        View.prototype.project = function (position, target) {
            if (target === void 0) { target = null; }
            target = this._projection.project(position, target);
            target.x = (target.x + 1) * this.width / 2;
            target.y = (target.y + 1) * this.height / 2;
            return target;
        };
        View.prototype.unproject = function (sX, sY, sZ, target) {
            if (target === void 0) { target = null; }
            return this._projection.unproject(2 * sX / this.width - 1, 2 * sY / this.height - 1, sZ, target);
        };
        View.prototype.dispose = function () {
            if (this._target) {
                this._target.removeEventListener(AssetEvent.INVALIDATE, this._onInvalidateSizeDelegate);
                this._target = null;
            }
            else {
                this._stage.removeEventListener(StageEvent.INVALIDATE_SIZE, this._onInvalidateSizeDelegate);
                if (!this._shareContext && this._target == null)
                    this._stage.dispose();
                this._stage = null;
            }
            if (this._projection) {
                this._projection.removeEventListener(ProjectionEvent.INVALIDATE_VIEW_MATRIX3D, this._onInvalidateViewMatrix3DDelegate);
                this._projection = null;
            }
        };
        View.prototype._onInvalidateSize = function (event) {
            this._updateDimensions();
            this._updateFocalLength();
            this._updatePixelRatio();
        };
        View.prototype._onInvalidateViewMatrix3D = function (event) {
            this._invalidateViewMatrix3D();
        };
        View.prototype._updateTarget = function (value) {
            if (this._target)
                this._target.removeEventListener(AssetEvent.INVALIDATE, this._onInvalidateSizeDelegate);
            else
                this._stage.removeEventListener(StageEvent.INVALIDATE_SIZE, this._onInvalidateSizeDelegate);
            this._target = value;
            if (this._target)
                this._target.addEventListener(AssetEvent.INVALIDATE, this._onInvalidateSizeDelegate);
            else
                this._stage.addEventListener(StageEvent.INVALIDATE_SIZE, this._onInvalidateSizeDelegate);
            this._updateDimensions();
            this._updateFocalLength();
            this._updatePixelRatio();
        };
        View.prototype._updateDimensions = function () {
            if (this._target) {
                if (this._target instanceof Image2D) {
                    this._targetWidth = this._target.width;
                    this._targetHeight = this._target.height;
                }
                else if (this._target instanceof ImageCube) {
                    this._targetWidth = this._target.size;
                    this._targetHeight = this._target.size;
                }
            }
            else {
                this._targetWidth = this._stage.width;
                this._targetHeight = this._stage.height;
            }
            if (this.preserveDimensions && (this._shareContext || this._target)) {
                this._offset.x = this._rect.x / this._targetWidth;
                this._offset.y = this._rect.y / this._targetHeight;
                this._scale.x = this._rect.width / this._targetWidth;
                this._scale.y = this._rect.height / this._targetHeight;
            }
            else {
                this._rect.x = this._offset.x * this._targetWidth;
                this._rect.y = this._offset.y * this._targetHeight;
                this._rect.width = this._scale.x * this._targetWidth;
                this._rect.height = this._scale.y * this._targetHeight;
                this._invalidateSize();
            }
        };
        View.prototype._updateFocalLength = function () {
            if (this.preserveFocalLength)
                this.projection.scale = this._focalLength / this._rect.height;
            else
                this._focalLength = this._projection.scale * this._rect.height;
        };
        View.prototype._updatePixelRatio = function () {
            if (this.preservePixelRatio)
                this._projection.ratio = this._pixelRatio * this._rect.width / this._rect.height;
            else
                this._pixelRatio = this._projection.ratio * this._rect.height / this._rect.width;
        };
        View.prototype._invalidateViewMatrix3D = function () {
            this._frustumMatrix3DDirty = true;
            this._viewMatrix3DDirty = true;
            this._inverseViewMatrix3DDirty = true;
            this.dispatchEvent(new ViewEvent(ViewEvent.INVALIDATE_VIEW_MATRIX3D, this));
        };
        View.prototype._invalidateSize = function () {
            this.dispatchEvent(new ViewEvent(ViewEvent.INVALIDATE_SIZE, this));
        };
        return View;
    }(AssetBase));

    console.debug("AwayJS - View - 0.5.11");

    /**
     * ...
     */
    var AnimationElements = /** @class */ (function () {
        function AnimationElements() {
            this._pVertexBuffer = new Array(8);
            this._pBufferContext = new Array(8);
            this._pBufferDirty = new Array(8);
            this.numProcessedVertices = 0;
            this.previousTime = Number.NEGATIVE_INFINITY;
            this.animationParticles = new Array();
            for (var i = 0; i < 8; i++)
                this._pBufferDirty[i] = true;
            this._iUniqueId = AnimationElements.SUBGEOM_ID_COUNT++;
        }
        AnimationElements.prototype.createVertexData = function (numVertices, totalLenOfOneVertex) {
            this._numVertices = numVertices;
            this._totalLenOfOneVertex = totalLenOfOneVertex;
            this._pVertexData = new Float32Array(numVertices * totalLenOfOneVertex);
        };
        AnimationElements.prototype.activateVertexBuffer = function (index, bufferOffset, stage, format) {
            var contextIndex = stage.stageIndex;
            var context = stage.context;
            var buffer = this._pVertexBuffer[contextIndex];
            if (!buffer || this._pBufferContext[contextIndex] != context) {
                buffer = this._pVertexBuffer[contextIndex] = context.createVertexBuffer(this._numVertices, this._totalLenOfOneVertex * 4);
                this._pBufferContext[contextIndex] = context;
                this._pBufferDirty[contextIndex] = true;
            }
            if (this._pBufferDirty[contextIndex]) {
                buffer.uploadFromArray(this._pVertexData, 0, this._numVertices);
                this._pBufferDirty[contextIndex] = false;
            }
            context.setVertexBufferAt(index, buffer, bufferOffset * 4, format);
        };
        AnimationElements.prototype.dispose = function () {
            while (this._pVertexBuffer.length) {
                var vertexBuffer = this._pVertexBuffer.pop();
                if (vertexBuffer)
                    vertexBuffer.dispose();
            }
        };
        AnimationElements.prototype.invalidateBuffer = function () {
            for (var i = 0; i < 8; i++)
                this._pBufferDirty[i] = true;
        };
        Object.defineProperty(AnimationElements.prototype, "vertexData", {
            get: function () {
                return this._pVertexData;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationElements.prototype, "numVertices", {
            get: function () {
                return this._numVertices;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationElements.prototype, "totalLenOfOneVertex", {
            get: function () {
                return this._totalLenOfOneVertex;
            },
            enumerable: true,
            configurable: true
        });
        AnimationElements.SUBGEOM_ID_COUNT = 0;
        return AnimationElements;
    }());

    var ColorSegmentPoint = /** @class */ (function () {
        function ColorSegmentPoint(life, color) {
            //0<life<1
            if (life <= 0 || life >= 1)
                throw (new Error("life exceeds range (0,1)"));
            this._life = life;
            this._color = color;
        }
        Object.defineProperty(ColorSegmentPoint.prototype, "color", {
            get: function () {
                return this._color;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorSegmentPoint.prototype, "life", {
            get: function () {
                return this._life;
            },
            enumerable: true,
            configurable: true
        });
        return ColorSegmentPoint;
    }());

    /**
     * Contains transformation data for a skeleton joint, used for skeleton animation.
     *
     * @see away.animation.Skeleton
     * @see away.animation.SkeletonJoint
     *
     * todo: support (uniform) scale
     */
    var JointPose = /** @class */ (function () {
        function JointPose() {
            /**
             * The rotation of the pose stored as a quaternion
             */
            this.orientation = new Quaternion();
            /**
             * The translation of the pose
             */
            this.translation = new Vector3D();
        }
        /**
         * Converts the transformation to a Matrix3D representation.
         *
         * @param target An optional target matrix to store the transformation. If not provided, it will create a new instance.
         * @return The transformation matrix of the pose.
         */
        JointPose.prototype.toMatrix3D = function (target) {
            if (target === void 0) { target = null; }
            if (target == null)
                target = new Matrix3D();
            this.orientation.toMatrix3D(target);
            target.appendTranslation(this.translation.x, this.translation.y, this.translation.z);
            return target;
        };
        /**
         * Copies the transformation data from a source pose object into the existing pose object.
         *
         * @param pose The source pose to copy from.
         */
        JointPose.prototype.copyFrom = function (pose) {
            var or = pose.orientation;
            var tr = pose.translation;
            this.orientation.x = or.x;
            this.orientation.y = or.y;
            this.orientation.z = or.z;
            this.orientation.w = or.w;
            this.translation.x = tr.x;
            this.translation.y = tr.y;
            this.translation.z = tr.z;
        };
        return JointPose;
    }());

    /**
     * ...
     */
    var ParticleAnimationData = /** @class */ (function () {
        function ParticleAnimationData(index, startTime, duration, delay, particle) {
            this.index = index;
            this.startTime = startTime;
            this.totalTime = duration + delay;
            this.duration = duration;
            this.delay = delay;
            this.startVertexIndex = particle.startVertexIndex;
            this.numVertices = particle.numVertices;
        }
        return ParticleAnimationData;
    }());

    /**
     * Dynamic class for holding the local properties of a particle, used for processing the static properties
     * of particles in the particle animation set before beginning upload to the GPU.
     */
    var ParticleProperties = /** @class */ (function () {
        function ParticleProperties() {
        }
        return ParticleProperties;
    }());

    /**
     * Options for setting the properties mode of a particle animation node.
     */
    var ParticlePropertiesMode = /** @class */ (function () {
        function ParticlePropertiesMode() {
        }
        /**
         * Mode that defines the particle node as acting on global properties (ie. the properties set in the node constructor or the corresponding animation state).
         */
        ParticlePropertiesMode.GLOBAL = 0;
        /**
         * Mode that defines the particle node as acting on local static properties (ie. the properties of particles set in the initialising on the animation set).
         */
        ParticlePropertiesMode.LOCAL_STATIC = 1;
        /**
         * Mode that defines the particle node as acting on local dynamic properties (ie. the properties of the particles set in the corresponding animation state).
         */
        ParticlePropertiesMode.LOCAL_DYNAMIC = 2;
        return ParticlePropertiesMode;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics$5 = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    function __extends$5(d, b) {
        extendStatics$5(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * A Skeleton object is a hierarchical grouping of joint objects that can be used for skeletal animation.
     *
     * @see away.animators.SkeletonJoint
     */
    var Skeleton = /** @class */ (function (_super) {
        __extends$5(Skeleton, _super);
        /**
         * Creates a new <code>Skeleton</code> object
         */
        function Skeleton() {
            var _this = _super.call(this) || this;
            // in the long run, it might be a better idea to not store Joint objects, but keep all data in Vectors, that we can upload easily?
            _this.joints = new Array();
            return _this;
        }
        Object.defineProperty(Skeleton.prototype, "numJoints", {
            /**
             * The total number of joints in the skeleton.
             */
            get: function () {
                return this.joints.length;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns the joint object in the skeleton with the given name, otherwise returns a null object.
         *
         * @param jointName The name of the joint object to be found.
         * @return The joint object with the given name.
         *
         * @see #joints
         */
        Skeleton.prototype.jointFromName = function (jointName) {
            var jointIndex = this.jointIndexFromName(jointName);
            if (jointIndex != -1)
                return this.joints[jointIndex];
            else
                return null;
        };
        /**
         * Returns the joint index, given the joint name. -1 is returned if the joint name is not found.
         *
         * @param jointName The name of the joint object to be found.
         * @return The index of the joint object in the joints Array
         *
         * @see #joints
         */
        Skeleton.prototype.jointIndexFromName = function (jointName) {
            // this is implemented as a linear search, rather than a possibly
            // more optimal method (Dictionary lookup, for example) because:
            // a) it is assumed that it will be called once for each joint
            // b) it is assumed that it will be called only during load, and not during main loop
            // c) maintaining a dictionary (for safety) would dictate an interface to access SkeletonJoints,
            //    rather than direct array access.  this would be sub-optimal.
            var jointIndex;
            var joint;
            for (var i; i < this.joints.length; i++) {
                joint = this.joints[i];
                if (joint.name == jointName)
                    return jointIndex;
                jointIndex++;
            }
            return -1;
        };
        /**
         * @inheritDoc
         */
        Skeleton.prototype.dispose = function () {
            this.joints.length = 0;
        };
        Object.defineProperty(Skeleton.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return Skeleton.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Skeleton.assetType = "[asset Skeleton]";
        return Skeleton;
    }(AssetBase));

    /**
     * A value obect representing a single joint in a skeleton object.
     *
     * @see away.animators.Skeleton
     */

    /**
     * A collection of pose objects, determining the pose for an entire skeleton.
     * The <code>jointPoses</code> vector object corresponds to a skeleton's <code>joints</code> vector object, however, there is no
     * reference to a skeleton's instance, since several skeletons can be influenced by the same pose (eg: animation
     * clips are added to any animator with a valid skeleton)
     *
     * @see away.animators.Skeleton
     * @see away.animators.JointPose
     */
    var SkeletonPose = /** @class */ (function (_super) {
        __extends$5(SkeletonPose, _super);
        /**
         * Creates a new <code>SkeletonPose</code> object.
         */
        function SkeletonPose() {
            var _this = _super.call(this) || this;
            _this.jointPoses = new Array();
            return _this;
        }
        Object.defineProperty(SkeletonPose.prototype, "numJointPoses", {
            /**
             * The total number of joint poses in the skeleton pose.
             */
            get: function () {
                return this.jointPoses.length;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SkeletonPose.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return SkeletonPose.assetType;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns the joint pose object with the given joint name, otherwise returns a null object.
         *
         * @param jointName The name of the joint object whose pose is to be found.
         * @return The pose object with the given joint name.
         */
        SkeletonPose.prototype.jointPoseFromName = function (jointName) {
            var jointPoseIndex = this.jointPoseIndexFromName(jointName);
            if (jointPoseIndex != -1)
                return this.jointPoses[jointPoseIndex];
            else
                return null;
        };
        /**
         * Returns the pose index, given the joint name. -1 is returned if the joint name is not found in the pose.
         *
         * @param The name of the joint object whose pose is to be found.
         * @return The index of the pose object in the jointPoses Array
         *
         * @see #jointPoses
         */
        SkeletonPose.prototype.jointPoseIndexFromName = function (jointName) {
            // this is implemented as a linear search, rather than a possibly
            // more optimal method (Dictionary lookup, for example) because:
            // a) it is assumed that it will be called once for each joint
            // b) it is assumed that it will be called only during load, and not during main loop
            // c) maintaining a dictionary (for safety) would dictate an interface to access JointPoses,
            //    rather than direct array access.  this would be sub-optimal.
            var jointPoseIndex;
            var jointPose;
            for (var i; i < this.jointPoses.length; i++) {
                jointPose = this.jointPoses[i];
                if (jointPose.name == jointName)
                    return jointPoseIndex;
                jointPoseIndex++;
            }
            return -1;
        };
        /**
         * Creates a copy of the <code>SkeletonPose</code> object, with a dulpicate of its component joint poses.
         *
         * @return SkeletonPose
         */
        SkeletonPose.prototype.clone = function () {
            var clone = new SkeletonPose();
            var numJointPoses = this.jointPoses.length;
            for (var i = 0; i < numJointPoses; i++) {
                var cloneJointPose = new JointPose();
                var thisJointPose = this.jointPoses[i];
                cloneJointPose.name = thisJointPose.name;
                cloneJointPose.copyFrom(thisJointPose);
                clone.jointPoses[i] = cloneJointPose;
            }
            return clone;
        };
        /**
         * @inheritDoc
         */
        SkeletonPose.prototype.dispose = function () {
            this.jointPoses.length = 0;
        };
        SkeletonPose.assetType = "[asset SkeletonPose]";
        return SkeletonPose;
    }(AssetBase));

    /**
     * Options for setting the animation mode of a vertex animator object.
     *
     * @see away.animators.VertexAnimator
     */
    var VertexAnimationMode = /** @class */ (function () {
        function VertexAnimationMode() {
        }
        /**
         * Animation mode that adds all outputs from active vertex animation state to form the current vertex animation pose.
         */
        VertexAnimationMode.ADDITIVE = "additive";
        /**
         * Animation mode that picks the output from a single vertex animation state to form the current vertex animation pose.
         */
        VertexAnimationMode.ABSOLUTE = "absolute";
        return VertexAnimationMode;
    }());

    /**
     * ShaderBase keeps track of the number of dependencies for "named registers" used across a pass.
     * Named registers are that are not necessarily limited to a single method. They are created by the compiler and
     * passed on to methods. The compiler uses the results to reserve usages through RegisterPool, which can be removed
     * each time a method has been compiled into the shader.
     *
     * @see RegisterPool.addUsage
     */
    var ShaderBase = /** @class */ (function () {
        /**
         * Creates a new MethodCompilerVO object.
         */
        function ShaderBase(renderElements, renderMaterial, pass, stage) {
            this._abstractionPool = new Object();
            this._blendFactorSource = ContextGLBlendFactor.ONE;
            this._blendFactorDest = ContextGLBlendFactor.ZERO;
            this._invalidProgram = true;
            this._animationVertexCode = "";
            this._animationFragmentCode = "";
            this._vertexCode = "";
            this._fragmentCode = "";
            this._postAnimationFragmentCode = "";
            this.usesBlending = false;
            this.useImageRect = false;
            this.usesCurves = false;
            /**
             * The depth compare mode used to render the renderables using this material.
             *
             * @see away.stagegl.ContextGLCompareMode
             */
            this.depthCompareMode = ContextGLCompareMode.LESS_EQUAL;
            /**
             * Indicate whether the shader should write to the depth buffer or not. Ignored when blending is enabled.
             */
            this.writeDepth = true;
            this._defaultCulling = ContextGLTriangleFace.BACK;
            this._pInverseSceneMatrix = new Float32Array(16);
            //set ambient values to default
            this.ambientR = 0xFF;
            this.ambientG = 0xFF;
            this.ambientB = 0xFF;
            /**
             * Indicates whether there are any dependencies on the world-space position vector.
             */
            this.usesGlobalPosFragment = false;
            /**
             * Indicates whether there are any dependencies on the local position vector.
             */
            this.usesPositionFragment = false;
            /**
             *
             */
            this.imageIndices = new Array();
            this._renderElements = renderElements;
            this._renderMaterial = renderMaterial;
            this._pass = pass;
            this._stage = stage;
            this.profile = this._stage.profile;
        }
        Object.defineProperty(ShaderBase.prototype, "pass", {
            get: function () {
                return this._pass;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderBase.prototype, "renderMaterial", {
            get: function () {
                return this._renderMaterial;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderBase.prototype, "programData", {
            get: function () {
                if (this._invalidProgram)
                    this._updateProgram();
                return this._programData;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderBase.prototype, "usesAnimation", {
            get: function () {
                return this._usesAnimation;
            },
            set: function (value) {
                if (this._usesAnimation == value)
                    return;
                this._usesAnimation = value;
                this.invalidateProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderBase.prototype, "numUsedVertexConstants", {
            get: function () {
                if (this._invalidProgram)
                    this._updateProgram();
                return this._numUsedVertexConstants;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderBase.prototype, "numUsedFragmentConstants", {
            get: function () {
                if (this._invalidProgram)
                    this._updateProgram();
                return this._numUsedFragmentConstants;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderBase.prototype, "numUsedStreams", {
            /**
             * The amount of used vertex streams in the vertex code. Used by the animation code generation to know from which index on streams are available.
             */
            get: function () {
                if (this._invalidProgram)
                    this._updateProgram();
                return this._numUsedStreams;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShaderBase.prototype, "numUsedTextures", {
            /**
             *
             */
            get: function () {
                if (this._invalidProgram)
                    this._updateProgram();
                return this._numUsedTextures;
            },
            enumerable: true,
            configurable: true
        });
        ShaderBase.prototype.getAbstraction = function (asset) {
            return (this._abstractionPool[asset.id] || (this._abstractionPool[asset.id] = new ShaderBase._abstractionClassPool[asset.assetType](asset, this)));
        };
        /**
         *
         * @param image
         */
        ShaderBase.prototype.clearAbstraction = function (asset) {
            delete this._abstractionPool[asset.id];
        };
        /**
         *
         * @param imageObjectClass
         */
        ShaderBase.registerAbstraction = function (abstractionClass, assetClass) {
            ShaderBase._abstractionClassPool[assetClass.assetType] = abstractionClass;
        };
        ShaderBase.prototype._includeDependencies = function () {
            this._renderMaterial.renderElements._includeDependencies(this);
            this._pass._includeDependencies(this);
            //this.usesCommonData = this.usesCurves || this.usesCommonData;
        };
        /**
         * Clears dependency counts for all registers. Called when recompiling a pass.
         */
        ShaderBase.prototype.reset = function () {
            this.projectionDependencies = 0;
            this.normalDependencies = 0;
            this.colorDependencies = 0;
            this.viewDirDependencies = 0;
            this.uvDependencies = 0;
            this.secondaryUVDependencies = 0;
            this.globalPosDependencies = 0;
            this.tangentDependencies = 0;
            this.usesCommonData = false;
            this.usesGlobalPosFragment = false;
            this.usesPositionFragment = false;
            this.usesFragmentAnimation = false;
            this.usesTangentSpace = false;
            this.outputsNormals = false;
            this.outputsTangentNormals = false;
        };
        /**
         * The blend mode to use when drawing this renderable. The following blend modes are supported:
         * <ul>
         * <li>BlendMode.NORMAL: No blending, unless the material inherently needs it</li>
         * <li>BlendMode.LAYER: Force blending. This will draw the object the same as NORMAL, but without writing depth writes.</li>
         * <li>BlendMode.MULTIPLY</li>
         * <li>BlendMode.ADD</li>
         * <li>BlendMode.ALPHA</li>
         * </ul>
         */
        ShaderBase.prototype.setBlendMode = function (value) {
            switch (value) {
                case BlendMode.NORMAL:
                    this._blendFactorSource = ContextGLBlendFactor.ONE;
                    this._blendFactorDest = ContextGLBlendFactor.ZERO;
                    this.usesBlending = false;
                    break;
                case BlendMode.LAYER:
                    this._blendFactorSource = ContextGLBlendFactor.SOURCE_ALPHA;
                    this._blendFactorDest = ContextGLBlendFactor.ONE_MINUS_SOURCE_ALPHA;
                    this.usesBlending = true;
                    break;
                case BlendMode.MULTIPLY:
                    this._blendFactorSource = ContextGLBlendFactor.ZERO;
                    this._blendFactorDest = ContextGLBlendFactor.SOURCE_COLOR;
                    this.usesBlending = true;
                    break;
                case BlendMode.ADD:
                    this._blendFactorSource = ContextGLBlendFactor.SOURCE_ALPHA;
                    this._blendFactorDest = ContextGLBlendFactor.ONE;
                    this.usesBlending = true;
                    break;
                case BlendMode.ALPHA:
                    this._blendFactorSource = ContextGLBlendFactor.ZERO;
                    this._blendFactorDest = ContextGLBlendFactor.SOURCE_ALPHA;
                    this.usesBlending = true;
                    break;
                default:
                    throw new ArgumentError("Unsupported blend mode!");
            }
        };
        /**
         * @inheritDoc
         */
        ShaderBase.prototype._activate = function (projection) {
            if (!this.programData.program) {
                this.programData.program = this._stage.context.createProgram();
                var vertexByteCode = (new AGALMiniAssembler().assemble("part vertex 1\n" + this.programData.vertexString + "endpart"))['vertex'].data;
                var fragmentByteCode = (new AGALMiniAssembler().assemble("part fragment 1\n" + this.programData.fragmentString + "endpart"))['fragment'].data;
                this.programData.program.upload(vertexByteCode, fragmentByteCode);
            }
            //set program data
            this._stage.context.setProgram(this.programData.program);
            this._stage.context.setCulling(this.useBothSides ? ContextGLTriangleFace.NONE : this._defaultCulling, projection.coordinateSystem);
            if (!this.usesTangentSpace && this.cameraPositionIndex >= 0) {
                var pos = projection.transform.concatenatedMatrix3D.position;
                this.vertexConstantData[this.cameraPositionIndex] = pos.x;
                this.vertexConstantData[this.cameraPositionIndex + 1] = pos.y;
                this.vertexConstantData[this.cameraPositionIndex + 2] = pos.z;
            }
            this._stage.context.setDepthTest((this.writeDepth && !this.usesBlending), this.depthCompareMode);
            if (this.usesBlending)
                this._stage.context.setBlendFactors(this._blendFactorSource, this._blendFactorDest);
            this.activeElements = null;
        };
        /**
         * @inheritDoc
         */
        ShaderBase.prototype._deactivate = function () {
            //For the love of god don't remove this if you want your multi-material shadows to not flicker like shit
            this._stage.context.setDepthTest(true, ContextGLCompareMode.LESS_EQUAL);
            this.activeElements = null;
        };
        /**
         *
         *
         * @param renderable
         * @param stage
         * @param camera
         */
        ShaderBase.prototype._setRenderState = function (renderState, projection) {
            if (renderState.sourceEntity.animator)
                renderState.sourceEntity.animator.setRenderState(this, renderState, this._stage, projection);
            var rawData;
            if (this.usesUVTransform) {
                var uvMatrix = renderState.uvMatrix;
                if (uvMatrix) {
                    //transpose
                    rawData = uvMatrix.rawData;
                    this.vertexConstantData[this.uvMatrixIndex] = rawData[0];
                    this.vertexConstantData[this.uvMatrixIndex + 1] = rawData[2];
                    this.vertexConstantData[this.uvMatrixIndex + 3] = rawData[4];
                    this.vertexConstantData[this.uvMatrixIndex + 4] = rawData[1];
                    this.vertexConstantData[this.uvMatrixIndex + 5] = rawData[3];
                    this.vertexConstantData[this.uvMatrixIndex + 7] = rawData[5];
                }
                else {
                    this.vertexConstantData[this.uvMatrixIndex] = 1;
                    this.vertexConstantData[this.uvMatrixIndex + 1] = 0;
                    this.vertexConstantData[this.uvMatrixIndex + 3] = 0;
                    this.vertexConstantData[this.uvMatrixIndex + 4] = 0;
                    this.vertexConstantData[this.uvMatrixIndex + 5] = 1;
                    this.vertexConstantData[this.uvMatrixIndex + 7] = 0;
                }
            }
            if (this.usesColorTransform) {
                var colorTransform = renderState.sourceEntity._iAssignedColorTransform();
                if (colorTransform) {
                    //TODO: AWDParser to write normalised color offsets
                    rawData = colorTransform._rawData;
                    this.fragmentConstantData[this.colorTransformIndex] = rawData[0];
                    this.fragmentConstantData[this.colorTransformIndex + 1] = rawData[1];
                    this.fragmentConstantData[this.colorTransformIndex + 2] = rawData[2];
                    this.fragmentConstantData[this.colorTransformIndex + 3] = rawData[3];
                    this.fragmentConstantData[this.colorTransformIndex + 4] = rawData[4] / 255;
                    this.fragmentConstantData[this.colorTransformIndex + 5] = rawData[5] / 255;
                    this.fragmentConstantData[this.colorTransformIndex + 6] = rawData[6] / 255;
                    this.fragmentConstantData[this.colorTransformIndex + 7] = rawData[7] / 255;
                }
                else {
                    this.fragmentConstantData[this.colorTransformIndex] = 1;
                    this.fragmentConstantData[this.colorTransformIndex + 1] = 1;
                    this.fragmentConstantData[this.colorTransformIndex + 2] = 1;
                    this.fragmentConstantData[this.colorTransformIndex + 3] = 1;
                    this.fragmentConstantData[this.colorTransformIndex + 4] = 0;
                    this.fragmentConstantData[this.colorTransformIndex + 5] = 0;
                    this.fragmentConstantData[this.colorTransformIndex + 6] = 0;
                    this.fragmentConstantData[this.colorTransformIndex + 7] = 0;
                }
            }
            if (this.sceneNormalMatrixIndex >= 0) {
                this.sceneNormalMatrix.copyFrom(renderState.sourceEntity.transform.inverseConcatenatedMatrix3D);
            }
            if (this.usesTangentSpace && this.cameraPositionIndex >= 0) {
                renderState.sourceEntity.transform.inverseConcatenatedMatrix3D.copyRawDataTo(this._pInverseSceneMatrix);
                var pos = projection.transform.concatenatedMatrix3D.position;
                var x = pos.x;
                var y = pos.y;
                var z = pos.z;
                this.vertexConstantData[this.cameraPositionIndex] = this._pInverseSceneMatrix[0] * x + this._pInverseSceneMatrix[4] * y + this._pInverseSceneMatrix[8] * z + this._pInverseSceneMatrix[12];
                this.vertexConstantData[this.cameraPositionIndex + 1] = this._pInverseSceneMatrix[1] * x + this._pInverseSceneMatrix[5] * y + this._pInverseSceneMatrix[9] * z + this._pInverseSceneMatrix[13];
                this.vertexConstantData[this.cameraPositionIndex + 2] = this._pInverseSceneMatrix[2] * x + this._pInverseSceneMatrix[6] * y + this._pInverseSceneMatrix[10] * z + this._pInverseSceneMatrix[14];
            }
        };
        ShaderBase.prototype.invalidateProgram = function () {
            this._invalidProgram = true;
        };
        ShaderBase.prototype.dispose = function () {
            this._programData.dispose();
            this._programData = null;
            this._registerCache.dispose();
            this._registerCache = null;
            this._sharedRegisters = null;
        };
        ShaderBase.prototype._updateProgram = function () {
            this._invalidProgram = false;
            this._sharedRegisters = new ShaderRegisterData();
            this._registerCache = new ShaderRegisterCache(this.profile);
            this.reset();
            this._includeDependencies();
            this._initRegisterIndices();
            this._compileDependencies();
            //compile custom vertex & fragment codes from pass
            this._vertexCode += this._pass._getVertexCode(this._registerCache, this._sharedRegisters);
            this._fragmentCode += this._pass._getFragmentCode(this._registerCache, this._sharedRegisters);
            this._postAnimationFragmentCode += this._pass._getPostAnimationFragmentCode(this._registerCache, this._sharedRegisters);
            //assign the final output color to the output register
            this._postAnimationFragmentCode += "mov " + this._registerCache.fragmentOutputRegister + ", " + this._sharedRegisters.shadedTarget + "\n";
            this._registerCache.removeFragmentTempUsage(this._sharedRegisters.shadedTarget);
            this._compileAnimationCode();
            //initialise the required shader constants
            this._initConstantData();
            var programData = this._stage.getProgramData(this._animationVertexCode + this._vertexCode, this._fragmentCode + this._animationFragmentCode + this._postAnimationFragmentCode);
            //check program data hasn't changed, keep count of program usages
            if (this._programData != programData) {
                if (this._programData)
                    this._programData.dispose();
                this._programData = programData;
                programData.usages++;
            }
        };
        /**
         * Reset all the indices to "unused".
         */
        ShaderBase.prototype._initRegisterIndices = function () {
            this.commonsDataIndex = -1;
            this.cameraPositionIndex = -1;
            this.curvesIndex = -1;
            this.uvIndex = -1;
            this.uvMatrixIndex = -1;
            this.colorTransformIndex = -1;
            this.secondaryUVIndex = -1;
            this.normalIndex = -1;
            this.colorBufferIndex = -1;
            this.tangentIndex = -1;
            this.sceneMatrixIndex = -1;
            this.sceneNormalMatrixIndex = -1;
            this.jointIndexIndex = -1;
            this.jointWeightIndex = -1;
            this.imageIndices.length = 0;
            this._sharedRegisters.animatedPosition = this._registerCache.getFreeVertexVectorTemp();
            this._registerCache.addVertexTempUsages(this._sharedRegisters.animatedPosition, 1);
            this._sharedRegisters.animatableAttributes.push(this._registerCache.getFreeVertexAttribute());
            this._sharedRegisters.animationTargetRegisters.push(this._sharedRegisters.animatedPosition);
            this._vertexCode = "";
            this._fragmentCode = "";
            this._postAnimationFragmentCode = "";
            //create commonly shared constant registers
            if (this.usesCommonData || this.normalDependencies > 0) {
                this._sharedRegisters.commons = this._registerCache.getFreeFragmentConstant();
                this.commonsDataIndex = this._sharedRegisters.commons.index * 4;
            }
            //Creates the registers to contain the tangent data.
            //Needs to be created FIRST and in this order (for when using tangent space)
            if (this.tangentDependencies > 0 || this.outputsNormals) {
                this._sharedRegisters.tangentInput = this._registerCache.getFreeVertexAttribute();
                this.tangentIndex = this._sharedRegisters.tangentInput.index;
                this._sharedRegisters.animatedTangent = this._registerCache.getFreeVertexVectorTemp();
                this._registerCache.addVertexTempUsages(this._sharedRegisters.animatedTangent, 1);
                if (this.usesTangentSpace) {
                    this._sharedRegisters.bitangent = this._registerCache.getFreeVertexVectorTemp();
                    this._registerCache.addVertexTempUsages(this._sharedRegisters.bitangent, 1);
                }
                this._sharedRegisters.animatableAttributes.push(this._sharedRegisters.tangentInput);
                this._sharedRegisters.animationTargetRegisters.push(this._sharedRegisters.animatedTangent);
            }
            if (this.normalDependencies > 0) {
                this._sharedRegisters.normalInput = this._registerCache.getFreeVertexAttribute();
                this.normalIndex = this._sharedRegisters.normalInput.index;
                this._sharedRegisters.animatedNormal = this._registerCache.getFreeVertexVectorTemp();
                this._registerCache.addVertexTempUsages(this._sharedRegisters.animatedNormal, 1);
                this._sharedRegisters.animatableAttributes.push(this._sharedRegisters.normalInput);
                this._sharedRegisters.animationTargetRegisters.push(this._sharedRegisters.animatedNormal);
            }
            if (this.uvDependencies > 0) {
                this._sharedRegisters.uvInput = this._registerCache.getFreeVertexAttribute();
                this.uvIndex = this._sharedRegisters.uvInput.index;
                if (!this.usesUVTransform) {
                    this._sharedRegisters.animatedUV = this._registerCache.getFreeVertexVectorTemp();
                    this._registerCache.addVertexTempUsages(this._sharedRegisters.animatedUV, 1);
                }
            }
            this._sharedRegisters.shadedTarget = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(this._sharedRegisters.shadedTarget, 1);
        };
        /**
         * Compile the code for the methods.
         */
        ShaderBase.prototype._compileDependencies = function () {
            if (this.colorDependencies > 0)
                this._compileColorCode();
            //compile the world-space position if required
            if (this.globalPosDependencies > 0)
                this._compileGlobalPositionCode();
            //compile the local-space position if required
            if (this.usesPositionFragment)
                this._compilePositionCode();
            if (this.usesCurves)
                this._compileCurvesCode();
            if (this.usesColorTransform)
                this._compileColorTransformCode();
            //Calculate the (possibly animated) UV coordinates.
            if (this.uvDependencies > 0)
                this._compileUVCode();
            if (this.secondaryUVDependencies > 0)
                this._compileSecondaryUVCode();
            if (this.normalDependencies > 0)
                this._compileNormalCode();
            if (this.viewDirDependencies > 0)
                this._compileViewDirCode();
            //collect code from elements
            this._vertexCode += this._renderElements._getVertexCode(this, this._registerCache, this._sharedRegisters);
            this._fragmentCode += this._renderElements._getFragmentCode(this, this._registerCache, this._sharedRegisters);
        };
        /**
         * Initializes the unchanging constant data for this shader object.
         */
        ShaderBase.prototype._initConstantData = function () {
            //Updates the amount of used register indices.
            this._numUsedVertexConstants = this._registerCache.numUsedVertexConstants;
            this._numUsedFragmentConstants = this._registerCache.numUsedFragmentConstants;
            this._numUsedStreams = this._registerCache.numUsedStreams;
            this._numUsedTextures = this._registerCache.numUsedTextures;
            this.vertexConstantData = new Float32Array(this._registerCache.numUsedVertexConstants * 4);
            this.fragmentConstantData = new Float32Array(this._registerCache.numUsedFragmentConstants * 4);
            //Initialies viewMatrix
            if (this.viewMatrixIndex >= 0) {
                this.viewMatrix = new Matrix3D(new Float32Array(this.vertexConstantData.buffer, this.viewMatrixIndex * 4, 16));
            }
            else if (this.viewMatrix) {
                this.viewMatrix = null;
            }
            //Initialies sceneMatrix
            if (this.sceneMatrixIndex >= 0) {
                this.sceneMatrix = new Matrix3D(new Float32Array(this.vertexConstantData.buffer, this.sceneMatrixIndex * 4, 16));
            }
            else if (this.sceneMatrix) {
                this.sceneMatrix = null;
            }
            //Initializes commonly required constant values.
            if (this.commonsDataIndex >= 0) {
                this.fragmentConstantData[this.commonsDataIndex] = .5;
                this.fragmentConstantData[this.commonsDataIndex + 1] = 0;
                this.fragmentConstantData[this.commonsDataIndex + 2] = 1 / 255;
                this.fragmentConstantData[this.commonsDataIndex + 3] = 1;
            }
            //Initializes the default UV transformation matrix.
            if (this.uvMatrixIndex >= 0) {
                this.vertexConstantData[this.uvMatrixIndex] = 1;
                this.vertexConstantData[this.uvMatrixIndex + 1] = 0;
                this.vertexConstantData[this.uvMatrixIndex + 2] = 0;
                this.vertexConstantData[this.uvMatrixIndex + 3] = 0;
                this.vertexConstantData[this.uvMatrixIndex + 4] = 0;
                this.vertexConstantData[this.uvMatrixIndex + 5] = 1;
                this.vertexConstantData[this.uvMatrixIndex + 6] = 0;
                this.vertexConstantData[this.uvMatrixIndex + 7] = 0;
            }
            //Initializes the default colorTransform.
            if (this.colorTransformIndex >= 0) {
                this.fragmentConstantData[this.colorTransformIndex] = 1;
                this.fragmentConstantData[this.colorTransformIndex + 1] = 1;
                this.fragmentConstantData[this.colorTransformIndex + 2] = 1;
                this.fragmentConstantData[this.colorTransformIndex + 3] = 1;
                this.fragmentConstantData[this.colorTransformIndex + 4] = 0;
                this.fragmentConstantData[this.colorTransformIndex + 5] = 0;
                this.fragmentConstantData[this.colorTransformIndex + 6] = 0;
                this.fragmentConstantData[this.colorTransformIndex + 7] = 0;
            }
            if (this.sceneNormalMatrixIndex >= 0) {
                this.sceneNormalMatrix = new Matrix3D(new Float32Array(this.vertexConstantData.buffer, this.sceneNormalMatrixIndex * 4, 16));
            }
            else if (this.sceneNormalMatrix) {
                this.sceneNormalMatrix = null;
            }
            if (this.cameraPositionIndex >= 0)
                this.vertexConstantData[this.cameraPositionIndex + 3] = 1;
            // init constant data in pass
            this._pass._initConstantData();
            //init constant data in animation
            if (this._usesAnimation)
                this._renderMaterial.animationSet.doneAGALCode(this);
        };
        ShaderBase.prototype._compileColorCode = function () {
            this._sharedRegisters.colorInput = this._registerCache.getFreeVertexAttribute();
            this.colorBufferIndex = this._sharedRegisters.colorInput.index;
            this._sharedRegisters.colorVarying = this._registerCache.getFreeVarying();
            this._vertexCode += "mov " + this._sharedRegisters.colorVarying + ", " + this._sharedRegisters.colorInput + "\n";
        };
        ShaderBase.prototype._compileGlobalPositionCode = function () {
            this._registerCache.addVertexTempUsages(this._sharedRegisters.globalPositionVertex = this._registerCache.getFreeVertexVectorTemp(), this.globalPosDependencies);
            var sceneMatrixReg = this._registerCache.getFreeVertexConstant();
            this._registerCache.getFreeVertexConstant();
            this._registerCache.getFreeVertexConstant();
            this._registerCache.getFreeVertexConstant();
            this.sceneMatrixIndex = sceneMatrixReg.index * 4;
            this._vertexCode += "m44 " + this._sharedRegisters.globalPositionVertex + ", " + this._sharedRegisters.animatedPosition + ", " + sceneMatrixReg + "\n";
            if (this.usesGlobalPosFragment) {
                this._sharedRegisters.globalPositionVarying = this._registerCache.getFreeVarying();
                this._vertexCode += "mov " + this._sharedRegisters.globalPositionVarying + ", " + this._sharedRegisters.globalPositionVertex + "\n";
            }
        };
        ShaderBase.prototype._compilePositionCode = function () {
            this._sharedRegisters.positionVarying = this._registerCache.getFreeVarying();
            this._vertexCode += "mov " + this._sharedRegisters.positionVarying + ", " + this._sharedRegisters.animatedPosition + "\n";
        };
        ShaderBase.prototype._compileCurvesCode = function () {
            this._sharedRegisters.curvesInput = this._registerCache.getFreeVertexAttribute();
            this.curvesIndex = this._sharedRegisters.curvesInput.index;
            this._sharedRegisters.curvesVarying = this._registerCache.getFreeVarying();
            this._vertexCode += "mov " + this._sharedRegisters.curvesVarying + ", " + this._sharedRegisters.curvesInput + "\n";
            var temp = this._registerCache.getFreeFragmentSingleTemp();
            this._fragmentCode += "mul " + temp + ", " + this._sharedRegisters.curvesVarying + ".y, " + this._sharedRegisters.curvesVarying + ".y\n" +
                "sub " + temp + ", " + temp + ", " + this._sharedRegisters.curvesVarying + ".z\n" +
                "mul " + temp + ", " + temp + ", " + this._sharedRegisters.curvesVarying + ".x\n" +
                "kil " + temp + "\n";
            // var temp:ShaderRegisterElement = this._registerCache.getFreeFragmentVectorTemp();
            //
            // this._postAnimationFragmentCode += "mul " + temp + ".x, " + this._sharedRegisters.curvesVarying + ".y, " + this._sharedRegisters.curvesVarying + ".y\n" +
            // 					"sub " + temp + ".x, " + temp + ".x, " + this._sharedRegisters.curvesVarying + ".z\n" +
            // 					"mul " + temp + ".x, " + temp + ".x, " + this._sharedRegisters.curvesVarying + ".x\n" +
            // 					"ddx " + temp + ".y," + temp + ".x\n" +
            // 					"ddy " + temp + ".z," + temp + ".x\n" +
            // 					"mul " + temp + ".y, " + temp + ".y, " + temp + ".y\n" +
            // 					"mul " + temp + ".z, " + temp + ".z, " + temp + ".z\n" +
            // 					"add " + this._sharedRegisters.shadedTarget + ".w, " + temp + ".y, " + temp + ".z\n" +
            // 					"sqt " + this._sharedRegisters.shadedTarget + ".w, " + this._sharedRegisters.shadedTarget + ".w\n" +
            // 					"div " + this._sharedRegisters.shadedTarget + ".w, " + temp + ".x, " + this._sharedRegisters.shadedTarget + ".w\n" +
            // 					"max " + this._sharedRegisters.shadedTarget + ".w, " + this._sharedRegisters.shadedTarget + ".w, " + this._sharedRegisters.commons + ".y\n" +
            // 					"min " + this._sharedRegisters.shadedTarget + ".w, " + this._sharedRegisters.shadedTarget + ".w, " + this._sharedRegisters.commons + ".w\n";
        };
        /**
         * Calculate the transformed colours
         */
        ShaderBase.prototype._compileColorTransformCode = function () {
            // rm, gm, bm, am - multiplier
            // ro, go, bo, ao - offset
            var ct1 = this._registerCache.getFreeFragmentConstant();
            var ct2 = this._registerCache.getFreeFragmentConstant();
            this.colorTransformIndex = ct1.index * 4;
            this._postAnimationFragmentCode += "mul " + this._sharedRegisters.shadedTarget + ", " + this._sharedRegisters.shadedTarget + ", " + ct1 + "\n";
            this._postAnimationFragmentCode += "add " + this._sharedRegisters.shadedTarget + ", " + this._sharedRegisters.shadedTarget + ", " + ct2 + "\n";
        };
        /**
         * Calculate the (possibly animated) UV coordinates.
         */
        ShaderBase.prototype._compileUVCode = function () {
            this._sharedRegisters.uvVarying = this._registerCache.getFreeVarying();
            if (this.usesUVTransform) {
                // a, b, 0, tx
                // c, d, 0, ty
                var uvTransform1 = this._registerCache.getFreeVertexConstant();
                var uvTransform2 = this._registerCache.getFreeVertexConstant();
                this.uvMatrixIndex = uvTransform1.index * 4;
                this._vertexCode += "dp4 " + this._sharedRegisters.uvVarying + ".x, " + this._sharedRegisters.uvInput + ", " + uvTransform1 + "\n" +
                    "dp4 " + this._sharedRegisters.uvVarying + ".y, " + this._sharedRegisters.uvInput + ", " + uvTransform2 + "\n" +
                    "mov " + this._sharedRegisters.uvVarying + ".zw, " + this._sharedRegisters.uvInput + ".zw \n";
            }
            else {
                this._vertexCode += "mov " + this._sharedRegisters.uvVarying + ", " + this._sharedRegisters.animatedUV + "\n";
            }
        };
        /**
         * Provide the secondary UV coordinates.
         */
        ShaderBase.prototype._compileSecondaryUVCode = function () {
            var uvAttributeReg = this._registerCache.getFreeVertexAttribute();
            this.secondaryUVIndex = uvAttributeReg.index;
            this._sharedRegisters.secondaryUVVarying = this._registerCache.getFreeVarying();
            this._vertexCode += "mov " + this._sharedRegisters.secondaryUVVarying + ", " + uvAttributeReg + "\n";
        };
        /**
         * Calculate the view direction.
         */
        ShaderBase.prototype._compileViewDirCode = function () {
            var cameraPositionReg = this._registerCache.getFreeVertexConstant();
            this._sharedRegisters.viewDirVarying = this._registerCache.getFreeVarying();
            this._sharedRegisters.viewDirFragment = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(this._sharedRegisters.viewDirFragment, this.viewDirDependencies);
            this.cameraPositionIndex = cameraPositionReg.index * 4;
            if (this.usesTangentSpace) {
                var temp = this._registerCache.getFreeVertexVectorTemp();
                this._vertexCode += "sub " + temp + ", " + cameraPositionReg + ", " + this._sharedRegisters.animatedPosition + "\n" +
                    "m33 " + this._sharedRegisters.viewDirVarying + ".xyz, " + temp + ", " + this._sharedRegisters.animatedTangent + "\n" +
                    "mov " + this._sharedRegisters.viewDirVarying + ".w, " + this._sharedRegisters.animatedPosition + ".w\n";
            }
            else {
                this._vertexCode += "sub " + this._sharedRegisters.viewDirVarying + ", " + cameraPositionReg + ", " + this._sharedRegisters.globalPositionVertex + "\n";
                this._registerCache.removeVertexTempUsage(this._sharedRegisters.globalPositionVertex);
            }
            //TODO is this required in all cases? (re: distancemappass)
            this._fragmentCode += "nrm " + this._sharedRegisters.viewDirFragment + ".xyz, " + this._sharedRegisters.viewDirVarying + "\n" +
                "mov " + this._sharedRegisters.viewDirFragment + ".w,   " + this._sharedRegisters.viewDirVarying + ".w\n";
        };
        /**
         * Calculate the normal.
         */
        ShaderBase.prototype._compileNormalCode = function () {
            this._sharedRegisters.normalFragment = this._registerCache.getFreeFragmentVectorTemp();
            this._registerCache.addFragmentTempUsages(this._sharedRegisters.normalFragment, this.normalDependencies);
            //simple normal aquisition if no tangent space is being used
            if (this.outputsNormals && !this.outputsTangentNormals) {
                this._vertexCode += this._pass._getNormalVertexCode(this._registerCache, this._sharedRegisters);
                this._fragmentCode += this._pass._getNormalFragmentCode(this._registerCache, this._sharedRegisters);
                return;
            }
            var normalMatrix;
            if (!this.outputsNormals || !this.usesTangentSpace) {
                normalMatrix = new Array(3);
                normalMatrix[0] = this._registerCache.getFreeVertexConstant();
                normalMatrix[1] = this._registerCache.getFreeVertexConstant();
                normalMatrix[2] = this._registerCache.getFreeVertexConstant();
                this._registerCache.getFreeVertexConstant();
                this.sceneNormalMatrixIndex = normalMatrix[0].index * 4;
                this._sharedRegisters.normalVarying = this._registerCache.getFreeVarying();
            }
            if (this.outputsNormals) {
                if (this.usesTangentSpace) {
                    // normalize normal + tangent vector and generate (approximated) bitangent used in m33 operation for view
                    this._vertexCode += "nrm " + this._sharedRegisters.animatedNormal + ".xyz, " + this._sharedRegisters.animatedNormal + "\n" +
                        "nrm " + this._sharedRegisters.animatedTangent + ".xyz, " + this._sharedRegisters.animatedTangent + "\n" +
                        "crs " + this._sharedRegisters.bitangent + ".xyz, " + this._sharedRegisters.animatedNormal + ", " + this._sharedRegisters.animatedTangent + "\n";
                    this._fragmentCode += this._pass._getNormalFragmentCode(this._registerCache, this._sharedRegisters);
                }
                else {
                    //Compiles the vertex shader code for tangent-space normal maps.
                    this._sharedRegisters.tangentVarying = this._registerCache.getFreeVarying();
                    this._sharedRegisters.bitangentVarying = this._registerCache.getFreeVarying();
                    var temp = this._registerCache.getFreeVertexVectorTemp();
                    this._vertexCode += "m33 " + temp + ".xyz, " + this._sharedRegisters.animatedNormal + ", " + normalMatrix[0] + "\n" +
                        "nrm " + this._sharedRegisters.animatedNormal + ".xyz, " + temp + "\n" +
                        "m33 " + temp + ".xyz, " + this._sharedRegisters.animatedTangent + ", " + normalMatrix[0] + "\n" +
                        "nrm " + this._sharedRegisters.animatedTangent + ".xyz, " + temp + "\n" +
                        "mov " + this._sharedRegisters.tangentVarying + ".x, " + this._sharedRegisters.animatedTangent + ".x  \n" +
                        "mov " + this._sharedRegisters.tangentVarying + ".z, " + this._sharedRegisters.animatedNormal + ".x  \n" +
                        "mov " + this._sharedRegisters.tangentVarying + ".w, " + this._sharedRegisters.normalInput + ".w  \n" +
                        "mov " + this._sharedRegisters.bitangentVarying + ".x, " + this._sharedRegisters.animatedTangent + ".y  \n" +
                        "mov " + this._sharedRegisters.bitangentVarying + ".z, " + this._sharedRegisters.animatedNormal + ".y  \n" +
                        "mov " + this._sharedRegisters.bitangentVarying + ".w, " + this._sharedRegisters.normalInput + ".w  \n" +
                        "mov " + this._sharedRegisters.normalVarying + ".x, " + this._sharedRegisters.animatedTangent + ".z  \n" +
                        "mov " + this._sharedRegisters.normalVarying + ".z, " + this._sharedRegisters.animatedNormal + ".z  \n" +
                        "mov " + this._sharedRegisters.normalVarying + ".w, " + this._sharedRegisters.normalInput + ".w  \n" +
                        "crs " + temp + ".xyz, " + this._sharedRegisters.animatedNormal + ", " + this._sharedRegisters.animatedTangent + "\n" +
                        "mov " + this._sharedRegisters.tangentVarying + ".y, " + temp + ".x    \n" +
                        "mov " + this._sharedRegisters.bitangentVarying + ".y, " + temp + ".y  \n" +
                        "mov " + this._sharedRegisters.normalVarying + ".y, " + temp + ".z    \n";
                    this._registerCache.removeVertexTempUsage(this._sharedRegisters.animatedTangent);
                    //Compiles the fragment shader code for tangent-space normal maps.
                    var t;
                    var b;
                    var n;
                    t = this._registerCache.getFreeFragmentVectorTemp();
                    this._registerCache.addFragmentTempUsages(t, 1);
                    b = this._registerCache.getFreeFragmentVectorTemp();
                    this._registerCache.addFragmentTempUsages(b, 1);
                    n = this._registerCache.getFreeFragmentVectorTemp();
                    this._registerCache.addFragmentTempUsages(n, 1);
                    this._fragmentCode += "nrm " + t + ".xyz, " + this._sharedRegisters.tangentVarying + "\n" +
                        "mov " + t + ".w, " + this._sharedRegisters.tangentVarying + ".w	\n" +
                        "nrm " + b + ".xyz, " + this._sharedRegisters.bitangentVarying + "\n" +
                        "nrm " + n + ".xyz, " + this._sharedRegisters.normalVarying + "\n";
                    //compile custom fragment code for normal calcs
                    this._fragmentCode += this._pass._getNormalFragmentCode(this._registerCache, this._sharedRegisters) +
                        "m33 " + this._sharedRegisters.normalFragment + ".xyz, " + this._sharedRegisters.normalFragment + ", " + t + "\n" +
                        "mov " + this._sharedRegisters.normalFragment + ".w, " + this._sharedRegisters.normalVarying + ".w\n";
                    this._registerCache.removeFragmentTempUsage(b);
                    this._registerCache.removeFragmentTempUsage(t);
                    this._registerCache.removeFragmentTempUsage(n);
                }
            }
            else {
                // no output, world space is enough
                this._vertexCode += "m33 " + this._sharedRegisters.normalVarying + ".xyz, " + this._sharedRegisters.animatedNormal + ", " + normalMatrix[0] + "\n" +
                    "mov " + this._sharedRegisters.normalVarying + ".w, " + this._sharedRegisters.animatedNormal + ".w\n";
                this._fragmentCode += "nrm " + this._sharedRegisters.normalFragment + ".xyz, " + this._sharedRegisters.normalVarying + "\n" +
                    "mov " + this._sharedRegisters.normalFragment + ".w, " + this._sharedRegisters.normalVarying + ".w\n";
                if (this.tangentDependencies > 0) {
                    this._sharedRegisters.tangentVarying = this._registerCache.getFreeVarying();
                    this._vertexCode += "m33 " + this._sharedRegisters.tangentVarying + ".xyz, " + this._sharedRegisters.animatedTangent + ", " + normalMatrix[0] + "\n" +
                        "mov " + this._sharedRegisters.tangentVarying + ".w, " + this._sharedRegisters.animatedTangent + ".w\n";
                }
            }
            if (!this.usesTangentSpace)
                this._registerCache.removeVertexTempUsage(this._sharedRegisters.animatedNormal);
        };
        ShaderBase.prototype._compileAnimationCode = function () {
            //reset code
            this._animationVertexCode = "";
            this._animationFragmentCode = "";
            //check to see if GPU animation is used
            if (this._usesAnimation) {
                var animationSet = this._renderMaterial.animationSet;
                this._animationVertexCode += animationSet.getAGALVertexCode(this, this._registerCache, this._sharedRegisters);
                if (this.uvDependencies > 0 && !this.usesUVTransform)
                    this._animationVertexCode += animationSet.getAGALUVCode(this, this._registerCache, this._sharedRegisters);
                if (this.usesFragmentAnimation)
                    this._animationFragmentCode += animationSet.getAGALFragmentCode(this, this._registerCache, this._sharedRegisters.shadedTarget);
            }
            else {
                // simply write attributes to targets, do not animate them
                // projection will pick up on targets[0] to do the projection
                var len = this._sharedRegisters.animatableAttributes.length;
                for (var i = 0; i < len; ++i)
                    this._animationVertexCode += "mov " + this._sharedRegisters.animationTargetRegisters[i] + ", " + this._sharedRegisters.animatableAttributes[i] + "\n";
                if (this.uvDependencies > 0 && !this.usesUVTransform)
                    this._animationVertexCode += "mov " + this._sharedRegisters.animatedUV + "," + this._sharedRegisters.uvInput + "\n";
            }
        };
        ShaderBase.prototype.setVertexConst = function (index, x, y, z, w) {
            if (x === void 0) { x = 0; }
            if (y === void 0) { y = 0; }
            if (z === void 0) { z = 0; }
            if (w === void 0) { w = 0; }
            index *= 4;
            this.vertexConstantData[index++] = x;
            this.vertexConstantData[index++] = y;
            this.vertexConstantData[index++] = z;
            this.vertexConstantData[index] = w;
        };
        ShaderBase.prototype.setVertexConstFromArray = function (index, data) {
            index *= 4;
            for (var i = 0; i < data.length; i++)
                this.vertexConstantData[index++] = data[i];
        };
        ShaderBase.prototype.setVertexConstFromMatrix = function (index, matrix) {
            index *= 4;
            var rawData = matrix._rawData;
            this.vertexConstantData[index++] = rawData[0];
            this.vertexConstantData[index++] = rawData[4];
            this.vertexConstantData[index++] = rawData[8];
            this.vertexConstantData[index++] = rawData[12];
            this.vertexConstantData[index++] = rawData[1];
            this.vertexConstantData[index++] = rawData[5];
            this.vertexConstantData[index++] = rawData[9];
            this.vertexConstantData[index++] = rawData[13];
            this.vertexConstantData[index++] = rawData[2];
            this.vertexConstantData[index++] = rawData[6];
            this.vertexConstantData[index++] = rawData[10];
            this.vertexConstantData[index++] = rawData[14];
            this.vertexConstantData[index++] = rawData[3];
            this.vertexConstantData[index++] = rawData[7];
            this.vertexConstantData[index++] = rawData[11];
            this.vertexConstantData[index] = rawData[15];
        };
        ShaderBase.prototype.setFragmentConst = function (index, x, y, z, w) {
            if (x === void 0) { x = 0; }
            if (y === void 0) { y = 0; }
            if (z === void 0) { z = 0; }
            if (w === void 0) { w = 0; }
            index *= 4;
            this.fragmentConstantData[index++] = x;
            this.fragmentConstantData[index++] = y;
            this.fragmentConstantData[index++] = z;
            this.fragmentConstantData[index] = w;
        };
        ShaderBase._abstractionClassPool = new Object();
        return ShaderBase;
    }());

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics$6 = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    function __extends$6(d, b) {
        extendStatics$6(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var PassEvent = /** @class */ (function (_super) {
        __extends$6(PassEvent, _super);
        function PassEvent(type, pass) {
            var _this = _super.call(this, type) || this;
            _this._pass = pass;
            return _this;
        }
        Object.defineProperty(PassEvent.prototype, "pass", {
            /**
             *
             */
            get: function () {
                return this._pass;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        PassEvent.prototype.clone = function () {
            return new PassEvent(this.type, this._pass);
        };
        /**
         *
         */
        PassEvent.INVALIDATE = "invalidatePass";
        return PassEvent;
    }(EventBase));

    var MaterialEvent = /** @class */ (function (_super) {
        __extends$6(MaterialEvent, _super);
        /**
         * Create a new GraphicsEvent
         * @param type The event type.
         * @param dataType An optional data type of the vertex data being updated.
         */
        function MaterialEvent(type, material) {
            var _this = _super.call(this, type) || this;
            _this._material = material;
            return _this;
        }
        Object.defineProperty(MaterialEvent.prototype, "material", {
            /**
             * The material of the renderable.
             */
            get: function () {
                return this._material;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the event.
         *
         * @return An exact duplicate of the current object.
         */
        MaterialEvent.prototype.clone = function () {
            return new MaterialEvent(this.type, this._material);
        };
        MaterialEvent.INVALIDATE_TEXTURES = "invalidateTextures";
        MaterialEvent.INVALIDATE_PASSES = "invalidatePasses";
        return MaterialEvent;
    }(EventBase));

    /**
     *
     * @class away.pool.Passes
     */
    var _Render_MaterialBase = /** @class */ (function (_super) {
        __extends$6(_Render_MaterialBase, _super);
        function _Render_MaterialBase(material, renderElements) {
            var _this = _super.call(this, material, renderElements) || this;
            /**
             * A list of material owners, renderables or custom Entities.
             */
            _this._owners = new Array();
            _this._passes = new Array();
            _this._invalidAnimation = true;
            _this._invalidRender = true;
            _this._invalidImages = true;
            _this._imageIndices = new Object();
            _this._usesAnimation = false;
            _this.images = new Array();
            _this.samplers = new Array();
            /**
             * Indicates whether or not the renderable requires alpha blending during rendering.
             */
            _this.requiresBlending = false;
            _this.materialID = material.id;
            _this._material = material;
            _this._renderElements = renderElements;
            _this._stage = renderElements.stage;
            _this._renderGroup = renderElements.renderGroup;
            _this._onInvalidateTexturesDelegate = function (event) { return _this.onInvalidateTextures(event); };
            _this._onInvalidatePassesDelegate = function (event) { return _this.onInvalidatePasses(event); };
            _this._material.addEventListener(MaterialEvent.INVALIDATE_TEXTURES, _this._onInvalidateTexturesDelegate);
            _this._material.addEventListener(MaterialEvent.INVALIDATE_PASSES, _this._onInvalidatePassesDelegate);
            _this._onPassInvalidateDelegate = function (event) { return _this.onPassInvalidate(event); };
            return _this;
        }
        Object.defineProperty(_Render_MaterialBase.prototype, "animationSet", {
            get: function () {
                return this._animationSet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MaterialBase.prototype, "material", {
            get: function () {
                return this._material;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MaterialBase.prototype, "numImages", {
            get: function () {
                if (this._invalidImages)
                    this._updateImages();
                return this._numImages;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MaterialBase.prototype, "renderOrderId", {
            get: function () {
                if (this._invalidAnimation)
                    this._updateAnimation();
                return this._renderOrderId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MaterialBase.prototype, "passes", {
            get: function () {
                if (this._invalidAnimation)
                    this._updateAnimation();
                return this._passes;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MaterialBase.prototype, "style", {
            get: function () {
                return this._material.style;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MaterialBase.prototype, "renderGroup", {
            get: function () {
                return this._renderGroup;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MaterialBase.prototype, "renderElements", {
            get: function () {
                return this._renderElements;
            },
            enumerable: true,
            configurable: true
        });
        //
        // MATERIAL MANAGEMENT
        //
        /**
         * Mark an IEntity as owner of this material.
         * Assures we're not using the same material across renderables with different animations, since the
         * Programs depend on animation. This method needs to be called when a material is assigned.
         *
         * @param owner The IEntity that had this material assigned
         *
         * @internal
         */
        _Render_MaterialBase.prototype.addOwner = function (owner) {
            this._owners.push(owner);
            var animationSet;
            var animator = owner.sourceEntity.animator;
            if (animator)
                animationSet = animator.animationSet;
            if (owner.sourceEntity.animator) {
                if (this._animationSet && animationSet != this._animationSet) {
                    throw new Error("A Material instance cannot be shared across material owners with different animation sets");
                }
                else {
                    if (this._animationSet != animationSet) {
                        this._animationSet = animationSet;
                        this._invalidAnimation = true;
                    }
                }
            }
        };
        /**
         * Removes an IEntity as owner.
         * @param owner
         *
         * @internal
         */
        _Render_MaterialBase.prototype.removeOwner = function (owner) {
            this._owners.splice(this._owners.indexOf(owner), 1);
            if (!this._owners.length)
                this.onClear(null);
        };
        _Render_MaterialBase.prototype.getImageIndex = function (texture, index) {
            if (index === void 0) { index = 0; }
            if (this._invalidImages)
                this._updateImages();
            return this._imageIndices[texture.id][index];
        };
        /**
         *
         */
        _Render_MaterialBase.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            var len = this._passes.length;
            for (var i = 0; i < len; i++) {
                this._passes[i].removeEventListener(PassEvent.INVALIDATE, this._onPassInvalidateDelegate);
                this._passes[i].dispose();
            }
            this._passes = null;
            this._material.removeEventListener(MaterialEvent.INVALIDATE_TEXTURES, this._onInvalidateTexturesDelegate);
            this._material.removeEventListener(MaterialEvent.INVALIDATE_PASSES, this._onInvalidatePassesDelegate);
            this._animationSet = null;
            this._material = null;
            this._renderElements = null;
            this._stage = null;
            this._owners = null;
        };
        /**
         *
         */
        _Render_MaterialBase.prototype.onInvalidatePasses = function (event) {
            var len = this._passes.length;
            for (var i = 0; i < len; i++)
                this._passes[i].invalidate();
            this._invalidAnimation = true;
            this._invalidImages = true;
        };
        /**
         * Listener for when a pass's shader code changes. It recalculates the render order id.
         */
        _Render_MaterialBase.prototype.onPassInvalidate = function (event) {
            this._invalidAnimation = true;
        };
        /**
         *
         */
        _Render_MaterialBase.prototype.onInvalidateTextures = function (event) {
            var renderables = this._owners;
            var numOwners = renderables.length;
            for (var j = 0; j < numOwners; j++)
                renderables[j]._onInvalidateStyle();
        };
        /**
         *
         */
        _Render_MaterialBase.prototype.onInvalidate = function (event) {
            _super.prototype.onInvalidate.call(this, event);
            this._invalidRender = true;
            this._invalidAnimation = true;
        };
        /**
         * Removes all passes from the surface
         */
        _Render_MaterialBase.prototype._pClearPasses = function () {
            var len = this._passes.length;
            for (var i = 0; i < len; ++i)
                this._passes[i].removeEventListener(PassEvent.INVALIDATE, this._onPassInvalidateDelegate);
            this._passes.length = 0;
        };
        /**
         * Adds a pass to the surface
         * @param pass
         */
        _Render_MaterialBase.prototype._pAddPass = function (pass) {
            this._passes.push(pass);
            pass.addEventListener(PassEvent.INVALIDATE, this._onPassInvalidateDelegate);
        };
        /**
         * Removes a pass from the surface.
         * @param pass The pass to be removed.
         */
        _Render_MaterialBase.prototype._pRemovePass = function (pass) {
            pass.removeEventListener(PassEvent.INVALIDATE, this._onPassInvalidateDelegate);
            this._passes.splice(this._passes.indexOf(pass), 1);
        };
        /**
         * Performs any processing that needs to occur before any of its passes are used.
         *
         * @private
         */
        _Render_MaterialBase.prototype._pUpdateRender = function () {
            this._invalidRender = false;
        };
        /**
         *
         * @param surface
         */
        _Render_MaterialBase.prototype._updateAnimation = function () {
            if (this._invalidRender)
                this._pUpdateRender();
            this._invalidAnimation = false;
            var usesAnimation = this._getEnabledGPUAnimation();
            var renderOrderId = 0;
            var mult = 1;
            var shader;
            var len = this._passes.length;
            for (var i = 0; i < len; i++) {
                shader = this._passes[i].shader;
                shader.usesAnimation = usesAnimation;
                renderOrderId += shader.programData.id * mult;
                mult *= 1000;
            }
            if (this._usesAnimation != usesAnimation) {
                this._usesAnimation = usesAnimation;
                var renderables = this._owners;
                var numOwners = renderables.length;
                for (var j = 0; j < numOwners; j++)
                    renderables[j]._onInvalidateElements();
            }
            this._renderOrderId = renderOrderId;
        };
        _Render_MaterialBase.prototype._updateImages = function () {
            this._invalidImages = false;
            var style = this._material.style;
            var numTextures = this._material.getNumTextures();
            var texture;
            var numImages;
            var images;
            var index = 0;
            for (var i = 0; i < numTextures; i++) {
                texture = this._material.getTextureAt(i);
                numImages = texture.getNumImages();
                images = this._imageIndices[texture.id] = new Array();
                for (var j = 0; j < numImages; j++) {
                    this.images[index] = this._stage.getAbstraction(texture.getImageAt(j) || (style ? style.getImageAt(texture, j) : null) || ImageUtils.getDefaultImage2D());
                    this.samplers[index] = texture.getSamplerAt(j) || (style ? style.getSamplerAt(texture, j) : null) || ImageUtils.getDefaultSampler();
                    images[j] = index++;
                }
            }
            this._numImages = index;
        };
        /**
         * test if animation will be able to run on gpu BEFORE compiling materials
         * test if the shader objects supports animating the animation set in the vertex shader
         * if any object using this material fails to support accelerated animations for any of the shader objects,
         * we should do everything on cpu (otherwise we have the cost of both gpu + cpu animations)
         */
        _Render_MaterialBase.prototype._getEnabledGPUAnimation = function () {
            if (this._animationSet) {
                this._animationSet.resetGPUCompatibility();
                var entities = this._owners;
                var numOwners = entities.length;
                var len = this._passes.length;
                var shader;
                for (var i = 0; i < len; i++) {
                    shader = this._passes[i].shader;
                    shader.usesAnimation = false;
                    for (var j = 0; j < numOwners; j++)
                        if (entities[j].sourceEntity.animator)
                            entities[j].sourceEntity.animator.testGPUCompatibility(shader);
                }
                return !this._animationSet.usesCPU;
            }
            return false;
        };
        return _Render_MaterialBase;
    }(AbstractionBase));

    /**
     * @class away.pool.MaterialPoolBase
     */
    var _Render_ElementsBase = /** @class */ (function () {
        /**
         * //TODO
         *
         * @param materialClassGL
         */
        function _Render_ElementsBase(stage, renderMaterialClassPool, renderGroup) {
            this._abstractionPool = new Object();
            this._stage = stage;
            this._renderMaterialClassPool = renderMaterialClassPool;
            this._renderGroup = renderGroup;
        }
        Object.defineProperty(_Render_ElementsBase.prototype, "stage", {
            get: function () {
                return this._stage;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_ElementsBase.prototype, "renderGroup", {
            /**
             *
             * @returns {IRenderEntity}
             */
            get: function () {
                return this._renderGroup;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * //TODO
         *
         * @param elementsOwner
         * @returns IElements
         */
        _Render_ElementsBase.prototype.getAbstraction = function (material) {
            return (this._abstractionPool[material.id] || (this._abstractionPool[material.id] = new this._renderMaterialClassPool[material.assetType](material, this)));
        };
        /**
         * //TODO
         *
         * @param elementsOwner
         */
        _Render_ElementsBase.prototype.clearAbstraction = function (material) {
            delete this._abstractionPool[material.id];
        };
        _Render_ElementsBase.prototype._includeDependencies = function (shader) {
        };
        _Render_ElementsBase.prototype._getVertexCode = function (shader, registerCache, sharedRegisters) {
            return "";
        };
        _Render_ElementsBase.prototype._getFragmentCode = function (shader, registerCache, sharedRegisters) {
            return "";
        };
        return _Render_ElementsBase;
    }());

    /**
     * Dispatched to notify changes in a sub geometry object's state.
     *
     * @class away.events.RenderableEvent
     * @see away.core.base.Graphics
     */
    var RenderableEvent = /** @class */ (function (_super) {
        __extends$6(RenderableEvent, _super);
        /**
         * Create a new GraphicsEvent
         * @param type The event type.
         * @param dataType An optional data type of the vertex data being updated.
         */
        function RenderableEvent(type, renderable) {
            var _this = _super.call(this, type) || this;
            _this._renderable = renderable;
            return _this;
        }
        Object.defineProperty(RenderableEvent.prototype, "renderable", {
            /**
             * The renderobject owner of the renderable owner.
             */
            get: function () {
                return this._renderable;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the event.
         *
         * @return An exact duplicate of the current object.
         */
        RenderableEvent.prototype.clone = function () {
            return new RenderableEvent(this.type, this._renderable);
        };
        /**
         * Dispatched when a Renderable has been updated.
         */
        RenderableEvent.INVALIDATE_MATERIAL = "invalidateMaterial";
        /**
         *
         */
        RenderableEvent.INVALIDATE_ELEMENTS = "invalidateElements";
        /**
         *
         */
        RenderableEvent.INVALIDATE_STYLE = "invalidateStyle";
        return RenderableEvent;
    }(EventBase));

    var MaterialUtils = /** @class */ (function () {
        function MaterialUtils() {
        }
        MaterialUtils.getDefaultTextureMaterial = function () {
            if (!this._defaultTextureMaterial)
                this.createDefaultTextureMaterial();
            return this._defaultTextureMaterial;
        };
        MaterialUtils.getDefaultCubeTextureMaterial = function () {
            if (!this._defaultCubeTextureMaterial)
                this.createDefaultCubeTextureMaterial();
            return this._defaultCubeTextureMaterial;
        };
        MaterialUtils.getDefaultColorMaterial = function () {
            if (!MaterialUtils._defaultColorMaterial)
                MaterialUtils.createDefaultColorMaterial();
            return MaterialUtils._defaultColorMaterial;
        };
        MaterialUtils.createDefaultTextureMaterial = function () {
            this._defaultTextureMaterial = new this._defaultMaterialClass(ImageUtils.getDefaultImage2D());
            this._defaultTextureMaterial.name = "defaultTextureMaterial";
        };
        MaterialUtils.createDefaultCubeTextureMaterial = function () {
            this._defaultCubeTextureMaterial = new this._defaultMaterialClass(ImageUtils.getDefaultImageCube());
            this._defaultCubeTextureMaterial.name = "defaultCubeTextureMaterial";
        };
        MaterialUtils.createDefaultColorMaterial = function () {
            this._defaultColorMaterial = new this._defaultMaterialClass(0xFFFFFF);
            this._defaultColorMaterial.name = "defaultColorMaterial";
        };
        MaterialUtils.setDefaultMaterialClass = function (materialClass) {
            this._defaultMaterialClass = materialClass;
        };
        return MaterialUtils;
    }());

    /**
     * @class RenderableListItem
     */
    var _Render_RenderableBase = /** @class */ (function (_super) {
        __extends$6(_Render_RenderableBase, _super);
        /**
         *
         * @param renderable
         * @param sourceEntity
         * @param surface
         * @param renderer
         */
        function _Render_RenderableBase(renderable, renderEntity) {
            var _this = _super.call(this, renderable, renderEntity) || this;
            _this._materialDirty = true;
            _this._elementsDirty = true;
            _this._styleDirty = true;
            _this._images = new Array();
            _this._samplers = new Array();
            _this._count = 0;
            _this._offset = 0;
            _this._onInvalidateElementsDelegate = function (event) { return _this._onInvalidateElements(event); };
            _this._onInvalidateMaterialDelegate = function (event) { return _this._onInvalidateMaterial(event); };
            _this._onInvalidateStyleDelegate = function (event) { return _this._onInvalidateStyle(event); };
            //store references
            _this.sourceEntity = renderEntity.entity;
            _this._stage = renderEntity.stage;
            _this.renderGroup = renderEntity.renderGroup;
            _this._asset.addEventListener(RenderableEvent.INVALIDATE_ELEMENTS, _this._onInvalidateElementsDelegate);
            _this._asset.addEventListener(RenderableEvent.INVALIDATE_MATERIAL, _this._onInvalidateMaterialDelegate);
            _this._asset.addEventListener(RenderableEvent.INVALIDATE_STYLE, _this._onInvalidateStyleDelegate);
            return _this;
        }
        Object.defineProperty(_Render_RenderableBase.prototype, "images", {
            /**
             *
             */
            get: function () {
                if (this._styleDirty)
                    this._updateStyle();
                return this._images;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_RenderableBase.prototype, "samplers", {
            /**
             *
             */
            get: function () {
                if (this._styleDirty)
                    this._updateStyle();
                return this._samplers;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_RenderableBase.prototype, "uvMatrix", {
            /**
             *
             */
            get: function () {
                if (this._styleDirty)
                    this._updateStyle();
                return this._uvMatrix;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_RenderableBase.prototype, "stageElements", {
            /**
             *
             * @returns {_Stage_ElementsBase}
             */
            get: function () {
                if (this._elementsDirty)
                    this._updateElements();
                return this._stageElements;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_RenderableBase.prototype, "renderMaterial", {
            /**
             *
             * @returns {_Render_MaterialBase}
             */
            get: function () {
                if (this._materialDirty)
                    this._updateMaterial();
                return this._renderMaterial;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Renders an object to the current render target.
         *
         * @private
         */
        _Render_RenderableBase.prototype._iRender = function (pass, view) {
            pass._setRenderState(this, view);
            var elements = this.stageElements;
            if (pass.shader.activeElements != elements) {
                pass.shader.activeElements = elements;
                elements._setRenderState(this, pass.shader, view);
            }
            this._stageElements.draw(this, pass.shader, view, this._count, this._offset);
        };
        _Render_RenderableBase.prototype.onClear = function (event) {
            this._asset.removeEventListener(RenderableEvent.INVALIDATE_ELEMENTS, this._onInvalidateElementsDelegate);
            this._asset.removeEventListener(RenderableEvent.INVALIDATE_MATERIAL, this._onInvalidateMaterialDelegate);
            this._asset.removeEventListener(RenderableEvent.INVALIDATE_STYLE, this._onInvalidateStyleDelegate);
            _super.prototype.onClear.call(this, event);
            this.renderSceneTransform = null;
            //this.sourceEntity = null;
            this._stage = null;
            this.next = null;
            this.maskOwners = null;
            this._renderMaterial.removeOwner(this);
            this._renderMaterial = null;
            this._stageElements = null;
        };
        _Render_RenderableBase.prototype._onInvalidateElements = function (event) {
            if (event === void 0) { event = null; }
            this._elementsDirty = true;
        };
        _Render_RenderableBase.prototype._onInvalidateMaterial = function (event) {
            if (event === void 0) { event = null; }
            this._materialDirty = true;
            this._styleDirty = true;
        };
        _Render_RenderableBase.prototype._onInvalidateStyle = function (event) {
            if (event === void 0) { event = null; }
            this._styleDirty = true;
        };
        _Render_RenderableBase.prototype._getStageElements = function () {
            throw new AbstractMethodError();
        };
        _Render_RenderableBase.prototype._getRenderMaterial = function () {
            throw new AbstractMethodError();
        };
        _Render_RenderableBase.prototype._getStyle = function () {
            throw new AbstractMethodError();
        };
        /**
         * //TODO
         *
         * @private
         */
        _Render_RenderableBase.prototype._updateElements = function () {
            this._stageElements = this._getStageElements();
            this._elementsDirty = false;
        };
        _Render_RenderableBase.prototype._updateMaterial = function () {
            var renderMaterial = this._getRenderMaterial();
            if (this._renderMaterial != renderMaterial) {
                if (this._renderMaterial)
                    this._renderMaterial.removeOwner(this);
                this._renderMaterial = renderMaterial;
                this._renderMaterial.addOwner(this);
            }
            this._materialDirty = false;
        };
        _Render_RenderableBase.prototype._updateStyle = function () {
            var style = this._getStyle();
            if (this._materialDirty)
                this._updateMaterial();
            //create a cache of image & sampler objects for the renderable
            var numImages = this._renderMaterial.numImages;
            var material = this._renderMaterial.material;
            this._images.length = numImages;
            this._samplers.length = numImages;
            this._uvMatrix = style ? style.uvMatrix : material.style ? material.style.uvMatrix : null;
            var numTextures = this._renderMaterial.material.getNumTextures();
            var texture;
            var numImages;
            var image;
            var index;
            for (var i = 0; i < numTextures; i++) {
                texture = material.getTextureAt(i);
                numImages = texture.getNumImages();
                for (var j = 0; j < numImages; j++) {
                    index = this._renderMaterial.getImageIndex(texture, j);
                    image = style ? style.getImageAt(texture, j) : null;
                    this._images[index] = image ? this._stage.getAbstraction(image) : null;
                    this._samplers[index] = style ? style.getSamplerAt(texture, j) : null;
                }
            }
            this._styleDirty = false;
        };
        _Render_RenderableBase.prototype.getDefaultMaterial = function () {
            return MaterialUtils.getDefaultTextureMaterial();
        };
        return _Render_RenderableBase;
    }(AbstractionBase));

    /**
     * @class away.pool.RenderEntity
     */
    var RenderEntity = /** @class */ (function (_super) {
        __extends$6(RenderEntity, _super);
        /**
         * //TODO
         *
         * @param materialClassGL
         */
        function RenderEntity(stage, entity, renderGroup) {
            var _this = _super.call(this, entity, renderGroup) || this;
            _this._abstractionPool = new Object();
            _this._stage = stage;
            _this._renderGroup = renderGroup;
            _this._onInvalidateElementsDelegate = function (event) { return _this._onInvalidateElements(event); };
            _this._onInvalidateMaterialDelegate = function (event) { return _this._onInvalidateMaterial(event); };
            _this._onInvalidateStyleDelegate = function (event) { return _this._onInvalidateStyle(event); };
            _this._asset.addEventListener(RenderableEvent.INVALIDATE_ELEMENTS, _this._onInvalidateElementsDelegate);
            _this._asset.addEventListener(RenderableEvent.INVALIDATE_MATERIAL, _this._onInvalidateMaterialDelegate);
            _this._asset.addEventListener(RenderableEvent.INVALIDATE_STYLE, _this._onInvalidateStyleDelegate);
            return _this;
        }
        Object.defineProperty(RenderEntity.prototype, "stage", {
            /**
             *
             * @returns {RenderGroup}
             */
            get: function () {
                return this._stage;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RenderEntity.prototype, "entity", {
            /**
             *
             * @returns {IRenderEntity}
             */
            get: function () {
                return this._asset;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RenderEntity.prototype, "renderGroup", {
            /**
             *
             * @returns {IRenderEntity}
             */
            get: function () {
                return this._renderGroup;
            },
            enumerable: true,
            configurable: true
        });
        RenderEntity.prototype.onClear = function (event) {
            this._asset.removeEventListener(RenderableEvent.INVALIDATE_ELEMENTS, this._onInvalidateElementsDelegate);
            this._asset.removeEventListener(RenderableEvent.INVALIDATE_MATERIAL, this._onInvalidateMaterialDelegate);
            this._asset.removeEventListener(RenderableEvent.INVALIDATE_STYLE, this._onInvalidateStyleDelegate);
            //clear all renderables associated with this render entity
            for (var key in this._abstractionPool)
                this._abstractionPool[key].onClear(null);
            _super.prototype.onClear.call(this, event);
        };
        RenderEntity.prototype._onInvalidateElements = function (event) {
            for (var key in this._abstractionPool)
                this._abstractionPool[key]._onInvalidateElements();
        };
        RenderEntity.prototype._onInvalidateMaterial = function (event) {
            for (var key in this._abstractionPool)
                this._abstractionPool[key]._onInvalidateMaterial();
        };
        RenderEntity.prototype._onInvalidateStyle = function (event) {
            for (var key in this._abstractionPool)
                this._abstractionPool[key]._onInvalidateStyle();
        };
        /**
         * //TODO
         *
         * @param renderable
         * @returns IRenderState
         */
        RenderEntity.prototype.getAbstraction = function (renderable) {
            return this._abstractionPool[renderable.id] || (this._abstractionPool[renderable.id] = new RenderEntity._renderRenderableClassPool[renderable.assetType](renderable, this));
        };
        /**
         *
         * @param renderable
         */
        RenderEntity.prototype.clearAbstraction = function (renderable) {
            delete this._abstractionPool[renderable.id];
        };
        /**
         *
         * @param imageObjectClass
         */
        RenderEntity.registerRenderable = function (renderStateClass, assetClass) {
            RenderEntity._renderRenderableClassPool[assetClass.assetType] = renderStateClass;
        };
        RenderEntity._renderRenderableClassPool = new Object();
        return RenderEntity;
    }(AbstractionBase));

    var StyleEvent = /** @class */ (function (_super) {
        __extends$6(StyleEvent, _super);
        function StyleEvent(type, style) {
            var _this = _super.call(this, type) || this;
            _this._style = style;
            return _this;
        }
        Object.defineProperty(StyleEvent.prototype, "style", {
            get: function () {
                return this._style;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the event.
         * @return An exact duplicate of the current object.
         */
        StyleEvent.prototype.clone = function () {
            return new StyleEvent(this.type, this._style);
        };
        /**
         *
         */
        StyleEvent.INVALIDATE_PROPERTIES = "invalidateProperties";
        return StyleEvent;
    }(EventBase));

    /**
     *
     */
    var Style = /** @class */ (function (_super) {
        __extends$6(Style, _super);
        function Style() {
            var _this = _super.call(this) || this;
            _this._samplers = new Object();
            _this._images = new Object();
            _this._color = 0xFFFFFF;
            return _this;
        }
        Object.defineProperty(Style.prototype, "sampler", {
            get: function () {
                return this._sampler;
            },
            set: function (value) {
                if (this._sampler == value)
                    return;
                this._sampler = value;
                this._invalidateProperties();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Style.prototype, "image", {
            get: function () {
                return this._image;
            },
            set: function (value) {
                if (this._image == value)
                    return;
                this._image = value;
                this._invalidateProperties();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Style.prototype, "uvMatrix", {
            get: function () {
                return this._uvMatrix;
            },
            set: function (value) {
                if (this._uvMatrix == value)
                    return;
                this._uvMatrix = value;
                this._invalidateProperties();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Style.prototype, "color", {
            /**
             * The diffuse reflectivity color of the surface.
             */
            get: function () {
                return this._color;
            },
            set: function (value) {
                if (this._color == value)
                    return;
                this._color = value;
                this._invalidateProperties();
            },
            enumerable: true,
            configurable: true
        });
        Style.prototype.getImageAt = function (texture, index) {
            if (index === void 0) { index = 0; }
            return (this._images[texture.id] ? this._images[texture.id][index] : null) || this._image;
        };
        Style.prototype.getSamplerAt = function (texture, index) {
            if (index === void 0) { index = 0; }
            return (this._samplers[texture.id] ? this._samplers[texture.id][index] : null) || this._sampler;
        };
        Style.prototype.addImageAt = function (image, texture, index) {
            if (index === void 0) { index = 0; }
            if (!this._images[texture.id])
                this._images[texture.id] = new Array();
            this._images[texture.id][index] = image;
        };
        Style.prototype.addSamplerAt = function (sampler, texture, index) {
            if (index === void 0) { index = 0; }
            if (!this._samplers[texture.id])
                this._samplers[texture.id] = new Array();
            this._samplers[texture.id][index] = sampler;
            this._invalidateProperties();
        };
        Style.prototype.removeImageAt = function (texture, index) {
            if (index === void 0) { index = 0; }
            if (!this._images[texture.id])
                return;
            this._images[texture.id][index] = null;
            this._invalidateProperties();
        };
        Style.prototype.removeSamplerAt = function (texture, index) {
            if (index === void 0) { index = 0; }
            if (!this._samplers[texture.id])
                return;
            this._samplers[texture.id][index] = null;
            this._invalidateProperties();
        };
        Style.prototype._invalidateProperties = function () {
            this.dispatchEvent(new StyleEvent(StyleEvent.INVALIDATE_PROPERTIES, this));
        };
        return Style;
    }(EventDispatcher));

    /**
     *
     * @class away.pool._Shader_TextureBaseBase
     */
    var _Shader_TextureBase = /** @class */ (function (_super) {
        __extends$6(_Shader_TextureBase, _super);
        function _Shader_TextureBase(texture, shader) {
            var _this = _super.call(this, texture, shader) || this;
            _this._texture = texture;
            _this._shader = shader;
            _this._stage = shader._stage;
            return _this;
        }
        /**
         *
         */
        _Shader_TextureBase.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            this._texture = null;
            this._shader = null;
            this._stage = null;
        };
        /**
         * Initializes the properties for a MethodVO, including register and texture indices.
         *
         * @param methodVO The MethodVO object linking this method with the pass currently being compiled.
         *
         * @internal
         */
        _Shader_TextureBase.prototype._initVO = function (chunkVO) {
        };
        /**
         * Initializes unchanging shader constants using the data from a MethodVO.
         *
         * @param methodVO The MethodVO object linking this method with the pass currently being compiled.
         *
         * @internal
         */
        _Shader_TextureBase.prototype._initConstants = function () {
        };
        _Shader_TextureBase.prototype._getFragmentCode = function (targetReg, regCache, sharedReg, inputReg) {
            if (inputReg === void 0) { inputReg = null; }
            throw new AbstractMethodError();
        };
        _Shader_TextureBase.prototype._setRenderState = function (renderState) {
            //overidden for state logic
        };
        _Shader_TextureBase.prototype.activate = function () {
            //overridden for activation logic
        };
        _Shader_TextureBase.prototype.getTextureReg = function (imageIndex, regCache, sharedReg) {
            var index = this._shader.imageIndices.indexOf(imageIndex); //todo: collapse the index based on duplicate image objects to save registrations
            if (index == -1) {
                var textureReg = regCache.getFreeTextureReg();
                sharedReg.textures.push(textureReg);
                this._shader.imageIndices.push(imageIndex);
                return textureReg;
            }
            return sharedReg.textures[index];
        };
        return _Shader_TextureBase;
    }(AbstractionBase));

    /**
     * ...
     */
    var AnimationRegisterData = /** @class */ (function () {
        function AnimationRegisterData() {
            this.indexDictionary = new Object();
        }
        AnimationRegisterData.prototype.reset = function (registerCache, sharedRegisters, needVelocity) {
            this.rotationRegisters = new Array();
            this.positionAttribute = sharedRegisters.animatableAttributes[0];
            this.scaleAndRotateTarget = sharedRegisters.animationTargetRegisters[0];
            for (var i = 1; i < sharedRegisters.animationTargetRegisters.length; i++)
                this.rotationRegisters.push(sharedRegisters.animationTargetRegisters[i]);
            //allot const register
            this.vertexZeroConst = registerCache.getFreeVertexConstant();
            this.vertexZeroConst = new ShaderRegisterElement(this.vertexZeroConst.regName, this.vertexZeroConst.index, 0);
            this.vertexOneConst = new ShaderRegisterElement(this.vertexZeroConst.regName, this.vertexZeroConst.index, 1);
            this.vertexTwoConst = new ShaderRegisterElement(this.vertexZeroConst.regName, this.vertexZeroConst.index, 2);
            //allot temp register
            this.positionTarget = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(this.positionTarget, 1);
            this.positionTarget = new ShaderRegisterElement(this.positionTarget.regName, this.positionTarget.index);
            if (needVelocity) {
                this.velocityTarget = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(this.velocityTarget, 1);
                this.velocityTarget = new ShaderRegisterElement(this.velocityTarget.regName, this.velocityTarget.index);
                this.vertexTime = new ShaderRegisterElement(this.velocityTarget.regName, this.velocityTarget.index, 3);
                this.vertexLife = new ShaderRegisterElement(this.positionTarget.regName, this.positionTarget.index, 3);
            }
            else {
                var tempTime = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(tempTime, 1);
                this.vertexTime = new ShaderRegisterElement(tempTime.regName, tempTime.index, 0);
                this.vertexLife = new ShaderRegisterElement(tempTime.regName, tempTime.index, 1);
            }
        };
        AnimationRegisterData.prototype.setUVSourceAndTarget = function (sharedRegisters) {
            this.uvVar = sharedRegisters.animatedUV;
            this.uvAttribute = sharedRegisters.uvInput;
            //uv action is processed after normal actions,so use offsetTarget as uvTarget
            this.uvTarget = new ShaderRegisterElement(this.positionTarget.regName, this.positionTarget.index);
        };
        AnimationRegisterData.prototype.setRegisterIndex = function (node, parameterIndex, registerIndex) {
            //8 should be enough for any node.
            var t = this.indexDictionary[node.id];
            if (t == null)
                t = this.indexDictionary[node.id] = new Array(8);
            t[parameterIndex] = registerIndex;
        };
        AnimationRegisterData.prototype.getRegisterIndex = function (node, parameterIndex) {
            return this.indexDictionary[node.id][parameterIndex];
        };
        return AnimationRegisterData;
    }());

    /**
     * Provides an abstract base class for nodes in an animation blend tree.
     */
    var AnimationNodeBase = /** @class */ (function (_super) {
        __extends$6(AnimationNodeBase, _super);
        /**
         * Creates a new <code>AnimationNodeBase</code> object.
         */
        function AnimationNodeBase() {
            return _super.call(this) || this;
        }
        Object.defineProperty(AnimationNodeBase.prototype, "stateClass", {
            get: function () {
                return this._pStateClass;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        AnimationNodeBase.prototype.dispose = function () {
        };
        Object.defineProperty(AnimationNodeBase.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return AnimationNodeBase.assetType;
            },
            enumerable: true,
            configurable: true
        });
        AnimationNodeBase.assetType = "[asset AnimationNodeBase]";
        return AnimationNodeBase;
    }(AssetBase));

    /**
     * Dispatched to notify changes in a sub geometry object's state.
     *
     * @class away.events.ElementsEvent
     * @see away.core.base.Graphics
     */
    var ElementsEvent = /** @class */ (function (_super) {
        __extends$6(ElementsEvent, _super);
        /**
         * Create a new GraphicsEvent
         * @param type The event type.
         * @param attributesView An optional data type of the vertex data being updated.
         */
        function ElementsEvent(type, attributesView) {
            var _this = _super.call(this, type) || this;
            _this._attributesView = attributesView;
            return _this;
        }
        Object.defineProperty(ElementsEvent.prototype, "attributesView", {
            /**
             * The attributes view of the vertex data.
             */
            get: function () {
                return this._attributesView;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the event.
         *
         * @return An exact duplicate of the current object.
         */
        ElementsEvent.prototype.clone = function () {
            return new ElementsEvent(this.type, this._attributesView);
        };
        /**
         * Dispatched when a Elements's index data has been updated.
         */
        ElementsEvent.INVALIDATE_INDICES = "invalidateIndices";
        /**
         * Dispatched when a Elements's index data has been disposed.
         */
        ElementsEvent.CLEAR_INDICES = "clearIndices";
        /**
         * Dispatched when a Elements's vertex data has been updated.
         */
        ElementsEvent.INVALIDATE_VERTICES = "invalidateVertices";
        /**
         * Dispatched when a Elements's vertex data has been disposed.
         */
        ElementsEvent.CLEAR_VERTICES = "clearVertices";
        return ElementsEvent;
    }(EventBase));

    var ElementsUtils = /** @class */ (function () {
        function ElementsUtils() {
        }
        ElementsUtils.generateFaceNormals = function (indexAttributes, positionAttributes, faceNormalAttributes, count, offset) {
            if (offset === void 0) { offset = 0; }
            var indices = indexAttributes.get(count, offset);
            var positions = positionAttributes.get(positionAttributes.count);
            if (faceNormalAttributes == null)
                faceNormalAttributes = new Float4Attributes(count + offset);
            else if (faceNormalAttributes.count < count + offset)
                faceNormalAttributes.count = count + offset;
            var indexDim = indexAttributes.stride;
            var posDim = positionAttributes.dimensions;
            var posStride = positionAttributes.stride;
            var faceNormals = faceNormalAttributes.get(count, offset);
            var len = count * indexDim;
            var i = 0;
            var j = 0;
            var index;
            var x1, x2, x3;
            var y1, y2, y3;
            var z1, z2, z3;
            var dx1, dy1, dz1;
            var dx2, dy2, dz2;
            var cx, cy, cz;
            var d;
            if (posDim == 3) {
                for (i = 0; i < len; i += indexDim) {
                    index = indices[i] * posStride;
                    x1 = positions[index];
                    y1 = positions[index + 1];
                    z1 = positions[index + 2];
                    index = indices[i + 1] * posStride;
                    x2 = positions[index];
                    y2 = positions[index + 1];
                    z2 = positions[index + 2];
                    index = indices[i + 2] * posStride;
                    x3 = positions[index];
                    y3 = positions[index + 1];
                    z3 = positions[index + 2];
                    dx1 = x3 - x1;
                    dy1 = y3 - y1;
                    dz1 = z3 - z1;
                    dx2 = x2 - x1;
                    dy2 = y2 - y1;
                    dz2 = z2 - z1;
                    cx = dz1 * dy2 - dy1 * dz2;
                    cy = dx1 * dz2 - dz1 * dx2;
                    cz = dy1 * dx2 - dx1 * dy2;
                    d = Math.sqrt(cx * cx + cy * cy + cz * cz);
                    // length of cross product = 2*triangle area
                    faceNormals[j++] = cx;
                    faceNormals[j++] = cy;
                    faceNormals[j++] = cz;
                    faceNormals[j++] = d;
                }
            }
            else if (posDim == 2) {
                for (i = 0; i < len; i += indexDim) {
                    faceNormals[j++] = 0;
                    faceNormals[j++] = 0;
                    faceNormals[j++] = 1;
                    faceNormals[j++] = 1;
                }
            }
            return faceNormalAttributes;
        };
        ElementsUtils.generateNormals = function (indexAttributes, faceNormalAttributes, normalAttributes, concatenatedBuffer) {
            var indices = indexAttributes.get(indexAttributes.count);
            var faceNormals = faceNormalAttributes.get(faceNormalAttributes.count);
            if (normalAttributes == null)
                normalAttributes = new Float3Attributes(concatenatedBuffer);
            var indexDim = indexAttributes.dimensions;
            var normalStride = normalAttributes.stride;
            var normals = normalAttributes.get(normalAttributes.count);
            var i;
            var len = normalAttributes.count * normalStride;
            //clear normal values
            for (i = 0; i < len; i += normalStride) {
                normals[i] = 0;
                normals[i + 1] = 0;
                normals[i + 2] = 0;
            }
            len = indexAttributes.count * indexDim;
            var index;
            var f1 = 0;
            var f2 = 1;
            var f3 = 2;
            //collect face normals
            for (i = 0; i < len; i += indexDim) {
                index = indices[i] * normalStride;
                normals[index] += faceNormals[f1];
                normals[index + 1] += faceNormals[f2];
                normals[index + 2] += faceNormals[f3];
                index = indices[i + 1] * normalStride;
                normals[index] += faceNormals[f1];
                normals[index + 1] += faceNormals[f2];
                normals[index + 2] += faceNormals[f3];
                index = indices[i + 2] * normalStride;
                normals[index] += faceNormals[f1];
                normals[index + 1] += faceNormals[f2];
                normals[index + 2] += faceNormals[f3];
                f1 += 4;
                f2 += 4;
                f3 += 4;
            }
            len = normalAttributes.count * normalStride;
            var vx;
            var vy;
            var vz;
            var d;
            //normalise normals collections
            for (i = 0; i < len; i += normalStride) {
                vx = normals[i];
                vy = normals[i + 1];
                vz = normals[i + 2];
                d = 1.0 / Math.sqrt(vx * vx + vy * vy + vz * vz);
                normals[i] = vx * d;
                normals[i + 1] = vy * d;
                normals[i + 2] = vz * d;
            }
            return normalAttributes;
        };
        ElementsUtils.generateFaceTangents = function (indexAttributes, positionAttributes, uvAttributes, faceTangentAttributes, count, offset, useFaceWeights) {
            if (offset === void 0) { offset = 0; }
            if (useFaceWeights === void 0) { useFaceWeights = false; }
            var indices = indexAttributes.get(count, offset);
            var positions = positionAttributes.get(positionAttributes.count);
            var uvs = uvAttributes.get(uvAttributes.count);
            if (faceTangentAttributes == null)
                faceTangentAttributes = new Float4Attributes(count + offset);
            else if (faceTangentAttributes.count < count + offset)
                faceTangentAttributes.count = count + offset;
            var indexDim = indexAttributes.dimensions;
            var posDim = positionAttributes.dimensions;
            var posStride = positionAttributes.stride;
            var uvStride = uvAttributes.stride;
            var faceTangents = faceTangentAttributes.get(count, offset);
            var i = 0;
            var index1;
            var index2;
            var index3;
            var v0;
            var v1;
            var v2;
            var dv1;
            var dv2;
            var denom;
            var x0, y0, z0;
            var dx1, dy1, dz1;
            var dx2, dy2, dz2;
            var cx, cy, cz;
            //multiply by dimension to get index length
            var len = count * indexDim;
            for (i = 0; i < len; i += indexDim) {
                index1 = indices[i];
                index2 = indices[i + 1];
                index3 = indices[i + 2];
                v0 = uvs[index1 * uvStride + 1];
                dv1 = uvs[index2 * uvStride + 1] - v0;
                dv2 = uvs[index3 * uvStride + 1] - v0;
                v0 = index1 * posStride;
                v1 = index2 * posStride;
                v2 = index3 * posStride;
                x0 = positions[v0];
                dx1 = positions[v1] - x0;
                dx2 = positions[v2] - x0;
                cx = dv2 * dx1 - dv1 * dx2;
                y0 = positions[v0 + 1];
                dy1 = positions[v1 + 1] - y0;
                dy2 = positions[v2 + 1] - y0;
                cy = dv2 * dy1 - dv1 * dy2;
                if (posDim == 3) {
                    z0 = positions[v0 + 2];
                    dz1 = positions[v1 + 2] - z0;
                    dz2 = positions[v2 + 2] - z0;
                    cz = dv2 * dz1 - dv1 * dz2;
                }
                else {
                    cz = 0;
                }
                denom = 1 / Math.sqrt(cx * cx + cy * cy + cz * cz);
                faceTangents[i] = denom * cx;
                faceTangents[i + 1] = denom * cy;
                faceTangents[i + 2] = denom * cz;
            }
            return faceTangentAttributes;
        };
        ElementsUtils.generateTangents = function (indexAttributes, faceTangentAttributes, faceNormalAttributes, tangentAttributes, concatenatedBuffer) {
            var indices = indexAttributes.get(indexAttributes.count);
            var faceTangents = faceTangentAttributes.get(faceTangentAttributes.count);
            var faceNormals = faceNormalAttributes.get(faceNormalAttributes.count);
            if (tangentAttributes == null)
                tangentAttributes = new Float3Attributes(concatenatedBuffer);
            var indexDim = indexAttributes.dimensions;
            var tangentStride = tangentAttributes.stride;
            var tangents = tangentAttributes.get(tangentAttributes.count);
            var i;
            var len = tangentAttributes.count * tangentStride;
            //clear tangent values
            for (i = 0; i < len; i += tangentStride) {
                tangents[i] = 0;
                tangents[i + 1] = 0;
                tangents[i + 2] = 0;
            }
            var weight;
            var index;
            var f1 = 0;
            var f2 = 1;
            var f3 = 2;
            var f4 = 3;
            len = indexAttributes.count * indexDim;
            //collect face tangents
            for (i = 0; i < len; i += indexDim) {
                weight = faceNormals[f4];
                index = indices[i] * tangentStride;
                tangents[index++] += faceTangents[f1] * weight;
                tangents[index++] += faceTangents[f2] * weight;
                tangents[index] += faceTangents[f3] * weight;
                index = indices[i + 1] * tangentStride;
                tangents[index++] += faceTangents[f1] * weight;
                tangents[index++] += faceTangents[f2] * weight;
                tangents[index] += faceTangents[f3] * weight;
                index = indices[i + 2] * tangentStride;
                tangents[index++] += faceTangents[f1] * weight;
                tangents[index++] += faceTangents[f2] * weight;
                tangents[index] += faceTangents[f3] * weight;
                f1 += 3;
                f2 += 3;
                f3 += 3;
                f4 += 4;
            }
            var vx;
            var vy;
            var vz;
            var d;
            //normalise tangents collections
            for (i = 0; i < len; i += tangentStride) {
                vx = tangents[i];
                vy = tangents[i + 1];
                vz = tangents[i + 2];
                d = 1.0 / Math.sqrt(vx * vx + vy * vy + vz * vz);
                tangents[i] = vx * d;
                tangents[i + 1] = vy * d;
                tangents[i + 2] = vz * d;
            }
            return tangentAttributes;
        };
        ElementsUtils.generateColors = function (indexAttributes, colorAttributes, concatenatedBuffer, count, offset) {
            if (offset === void 0) { offset = 0; }
            if (colorAttributes == null)
                colorAttributes = new Byte4Attributes(concatenatedBuffer);
            if (colorAttributes.count < count + offset)
                colorAttributes.count = count + offset;
            var colors = colorAttributes.get(count, offset);
            var colorStride = colorAttributes.stride;
            var len = colorAttributes.count * colorStride;
            for (var i = 0; i < len; i += colorStride) {
                colors[i] = 0xFF;
                colors[i + 1] = 0xFF;
                colors[i + 2] = 0xFF;
                colors[i + 3] = 0xFF;
            }
            return colorAttributes;
        };
        ElementsUtils.scale = function (scaleA, scaleB, scaleC, output, count, offset) {
            if (offset === void 0) { offset = 0; }
            if (output.count < count + offset)
                output.count = count + offset;
            var scaleArray = new Float32Array([scaleA, scaleB, scaleC]);
            var values = output.get(count, offset);
            var outputStride = output.stride;
            var outputDim = output.dimensions;
            var i;
            var j;
            var len = count * outputStride;
            for (i = 0; i < len; i += outputStride)
                for (j = 0; j < outputDim; j++)
                    values[i + j] *= scaleArray[j];
            output.invalidate();
        };
        ElementsUtils.applyTransformation = function (transform, positionAttributes, normalAttributes, tangentAttributes, count, offset) {
            if (offset === void 0) { offset = 0; }
            //todo: make this compatible with 2-dimensional positions
            var positions = positionAttributes.get(count, offset);
            var positionStride = positionAttributes.stride;
            var normals;
            var normalStride;
            if (normalAttributes) {
                normals = normalAttributes.get(count, offset);
                normalStride = normalAttributes.stride;
            }
            var tangents;
            var tangentStride;
            if (tangentAttributes) {
                tangents = tangentAttributes.get(count, offset);
                tangentStride = tangentAttributes.stride;
            }
            var i;
            var i1;
            var i2;
            var vector = new Vector3D();
            var invTranspose;
            if (normalAttributes || tangentAttributes) {
                invTranspose = transform.clone();
                invTranspose.invert();
                invTranspose.transpose();
            }
            var vi0 = 0;
            var ni0 = 0;
            var ti0 = 0;
            for (i = 0; i < count; ++i) {
                // bake position
                i1 = vi0 + 1;
                i2 = vi0 + 2;
                vector.x = positions[vi0];
                vector.y = positions[i1];
                vector.z = positions[i2];
                vector = transform.transformVector(vector);
                positions[vi0] = vector.x;
                positions[i1] = vector.y;
                positions[i2] = vector.z;
                vi0 += positionStride;
                if (normals) {
                    // bake normal
                    i1 = ni0 + 1;
                    i2 = ni0 + 2;
                    vector.x = normals[ni0];
                    vector.y = normals[i1];
                    vector.z = normals[i2];
                    vector = invTranspose.deltaTransformVector(vector);
                    vector.normalize();
                    normals[ni0] = vector.x;
                    normals[i1] = vector.y;
                    normals[i2] = vector.z;
                    ni0 += normalStride;
                }
                if (tangents) {
                    // bake tangent
                    i1 = ti0 + 1;
                    i2 = ti0 + 2;
                    vector.x = tangents[ti0];
                    vector.y = tangents[i1];
                    vector.z = tangents[i2];
                    vector = invTranspose.deltaTransformVector(vector);
                    vector.normalize();
                    tangents[ti0] = vector.x;
                    tangents[i1] = vector.y;
                    tangents[i2] = vector.z;
                    ti0 += tangentStride;
                }
            }
            positionAttributes.invalidate();
            if (normalAttributes)
                normalAttributes.invalidate();
            if (tangentAttributes)
                tangentAttributes.invalidate();
        };
        ElementsUtils.getSubIndices = function (indexAttributes, numVertices, indexMappings, indexOffset) {
            if (indexOffset === void 0) { indexOffset = 0; }
            var buffer = indexAttributes.attributesBuffer;
            var numIndices = indexAttributes.length;
            //reset mappings
            indexMappings.length = 0;
            //shortcut for those buffers that fit into the maximum buffer sizes
            if (numIndices < ElementsUtils.LIMIT_INDICES && numVertices < ElementsUtils.LIMIT_VERTS)
                return buffer;
            var i;
            var indices = indexAttributes.get(indexAttributes.count, indexOffset);
            var splitIndices = new Array();
            var indexSwap = ElementsUtils._indexSwap;
            indexSwap.length = numIndices;
            for (i = 0; i < numIndices; i++)
                indexSwap[i] = -1;
            var originalIndex;
            var splitIndex;
            var index = 0;
            var offsetLength = indexOffset * indexAttributes.dimensions;
            // Loop over all triangles
            i = 0;
            while (i < numIndices + offsetLength && i + 1 < ElementsUtils.LIMIT_INDICES && index + 1 < ElementsUtils.LIMIT_VERTS) {
                originalIndex = indices[i];
                if (indexSwap[originalIndex] >= 0) {
                    splitIndex = indexSwap[originalIndex];
                }
                else {
                    // This vertex does not yet exist in the split list and
                    // needs to be copied from the long list.
                    splitIndex = index++;
                    indexSwap[originalIndex] = splitIndex;
                    indexMappings[splitIndex] = originalIndex;
                }
                // Store new index, which may have come from the swap look-up,
                // or from copying a new set of vertex data from the original vector
                splitIndices[i++] = splitIndex;
            }
            buffer = new AttributesBuffer(indexAttributes.size * indexAttributes.dimensions, splitIndices.length / indexAttributes.dimensions);
            indexAttributes = indexAttributes.clone(buffer);
            indexAttributes.set(splitIndices);
            return buffer;
        };
        ElementsUtils.getSubVertices = function (vertexBuffer, indexMappings) {
            if (!indexMappings.length)
                return vertexBuffer;
            var stride = vertexBuffer.stride;
            var vertices = vertexBuffer.bufferView;
            var splitVerts = new Uint8Array(indexMappings.length * stride);
            var splitIndex;
            var originalIndex;
            var i = 0;
            var j = 0;
            var len = indexMappings.length;
            for (i = 0; i < len; i++) {
                splitIndex = i * stride;
                originalIndex = indexMappings[i] * stride;
                for (j = 0; j < stride; j++)
                    splitVerts[splitIndex + j] = vertices[originalIndex + j];
            }
            vertexBuffer = new AttributesBuffer(stride, len);
            vertexBuffer.bufferView = splitVerts;
            return vertexBuffer;
        };
        ElementsUtils.tempFloat32x4 = new Float32Array(4);
        ElementsUtils.LIMIT_VERTS = 0xffff;
        ElementsUtils.LIMIT_INDICES = 0xffffff;
        ElementsUtils._indexSwap = new Array();
        return ElementsUtils;
    }());

    /**
     *
     * @class away.pool._Stage_ElementsBaseBase
     */
    var _Stage_ElementsBase = /** @class */ (function (_super) {
        __extends$6(_Stage_ElementsBase, _super);
        function _Stage_ElementsBase(elements, stage) {
            var _this = _super.call(this, elements, stage) || this;
            _this.usages = 0;
            _this._vertices = new Object();
            _this._verticesUpdated = new Object();
            _this._indexMappings = Array();
            _this._numIndices = 0;
            _this._elements = elements;
            _this._stage = stage;
            _this._onInvalidateIndicesDelegate = function (event) { return _this._onInvalidateIndices(event); };
            _this._onClearIndicesDelegate = function (event) { return _this._onClearIndices(event); };
            _this._onInvalidateVerticesDelegate = function (event) { return _this._onInvalidateVertices(event); };
            _this._onClearVerticesDelegate = function (event) { return _this._onClearVertices(event); };
            _this._elements.addEventListener(ElementsEvent.CLEAR_INDICES, _this._onClearIndicesDelegate);
            _this._elements.addEventListener(ElementsEvent.INVALIDATE_INDICES, _this._onInvalidateIndicesDelegate);
            _this._elements.addEventListener(ElementsEvent.CLEAR_VERTICES, _this._onClearVerticesDelegate);
            _this._elements.addEventListener(ElementsEvent.INVALIDATE_VERTICES, _this._onInvalidateVerticesDelegate);
            return _this;
        }
        Object.defineProperty(_Stage_ElementsBase.prototype, "elements", {
            get: function () {
                return this._elements;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Stage_ElementsBase.prototype, "numIndices", {
            /**
             *
             */
            get: function () {
                return this._numIndices;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Stage_ElementsBase.prototype, "numVertices", {
            /**
             *
             */
            get: function () {
                return this._numVertices;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        _Stage_ElementsBase.prototype.getIndexMappings = function () {
            if (!this._indicesUpdated)
                this._updateIndices();
            return this._indexMappings;
        };
        /**
         *
         */
        _Stage_ElementsBase.prototype.getIndexBufferGL = function () {
            if (!this._indicesUpdated)
                this._updateIndices();
            return this._indices;
        };
        /**
         *
         */
        _Stage_ElementsBase.prototype.getVertexBufferGL = function (attributesView) {
            //first check if indices need updating which may affect vertices
            if (!this._indicesUpdated)
                this._updateIndices();
            var bufferId = attributesView.attributesBuffer.id;
            if (!this._verticesUpdated[bufferId])
                this._updateVertices(attributesView);
            return this._vertices[bufferId];
        };
        /**
         *
         */
        _Stage_ElementsBase.prototype.activateVertexBufferVO = function (index, attributesView, dimensions, offset) {
            if (dimensions === void 0) { dimensions = 0; }
            if (offset === void 0) { offset = 0; }
            this.getVertexBufferGL(attributesView).activate(index, attributesView.size, dimensions || attributesView.dimensions, attributesView.offset + offset, attributesView.unsigned);
        };
        /**
         *
         */
        _Stage_ElementsBase.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            this._elements.removeEventListener(ElementsEvent.CLEAR_INDICES, this._onClearIndicesDelegate);
            this._elements.removeEventListener(ElementsEvent.INVALIDATE_INDICES, this._onInvalidateIndicesDelegate);
            this._elements.removeEventListener(ElementsEvent.CLEAR_VERTICES, this._onClearVerticesDelegate);
            this._elements.removeEventListener(ElementsEvent.INVALIDATE_VERTICES, this._onInvalidateVerticesDelegate);
            this._elements = null;
            if (this._overflow) {
                this._overflow.onClear(event);
                this._overflow = null;
            }
        };
        _Stage_ElementsBase.prototype._setRenderState = function (renderable, shader, view) {
            if (!this._verticesUpdated)
                this._updateIndices();
            //TODO replace overflow system with something sensible
            //this._render(renderable, camera, viewProjection);
            //
            // if (this._overflow)
            // 	this._overflow._iRender(renderable, camera, viewProjection);
        };
        _Stage_ElementsBase.prototype.draw = function (renderable, shader, view, count, offset) {
            throw new AbstractMethodError();
        };
        /**
         * //TODO
         *
         * @private
         */
        _Stage_ElementsBase.prototype._updateIndices = function (indexOffset) {
            if (indexOffset === void 0) { indexOffset = 0; }
            var indices = this._elements.indices;
            if (indices) {
                this._indices = this._stage.getAbstraction(ElementsUtils.getSubIndices(indices, this._elements.numVertices, this._indexMappings, indexOffset));
                this._numIndices = this._indices._attributesBuffer.count * indices.dimensions;
            }
            else {
                this._indices = null;
                this._numIndices = 0;
                this._indexMappings = Array();
            }
            indexOffset += this._numIndices;
            //check if there is more to split
            if (indices && indexOffset < indices.count * this._elements.indices.dimensions) {
                if (!this._overflow)
                    this._overflow = this._pGetOverflowElements();
                this._overflow._updateIndices(indexOffset);
            }
            else if (this._overflow) {
                this._overflow.onClear(new AssetEvent(AssetEvent.CLEAR, this._elements));
                this._overflow = null;
            }
            this._indicesUpdated = true;
            //invalidate vertices if index mappings exist
            if (this._indexMappings.length)
                for (var key in this._verticesUpdated)
                    this._verticesUpdated[key] = false;
        };
        /**
         * //TODO
         *
         * @param attributesView
         * @private
         */
        _Stage_ElementsBase.prototype._updateVertices = function (attributesView) {
            this._numVertices = this._elements.numVertices;
            var bufferId = attributesView.attributesBuffer.id;
            this._vertices[bufferId] = this._stage.getAbstraction(ElementsUtils.getSubVertices(attributesView.attributesBuffer, this._indexMappings));
            this._verticesUpdated[bufferId] = true;
        };
        /**
         * //TODO
         *
         * @param event
         * @private
         */
        _Stage_ElementsBase.prototype._onInvalidateIndices = function (event) {
            if (!event.attributesView)
                return;
            this._indicesUpdated = false;
        };
        /**
         * //TODO
         *
         * @param event
         * @private
         */
        _Stage_ElementsBase.prototype._onClearIndices = function (event) {
            if (!event.attributesView)
                return;
            this._indices.onClear(new AssetEvent(AssetEvent.CLEAR, event.attributesView));
            this._indices = null;
        };
        /**
         * //TODO
         *
         * @param event
         * @private
         */
        _Stage_ElementsBase.prototype._onInvalidateVertices = function (event) {
            if (!event.attributesView)
                return;
            var bufferId = event.attributesView.attributesBuffer.id;
            this._verticesUpdated[bufferId] = false;
        };
        /**
         * //TODO
         *
         * @param event
         * @private
         */
        _Stage_ElementsBase.prototype._onClearVertices = function (event) {
            if (!event.attributesView)
                return;
            var bufferId = event.attributesView.attributesBuffer.id;
            if (this._vertices[bufferId]) {
                this._vertices[bufferId].onClear(new AssetEvent(AssetEvent.CLEAR, event.attributesView));
                delete this._vertices[bufferId];
                delete this._verticesUpdated[bufferId];
            }
        };
        /**
         * //TODO
         *
         * @param pool
         * @param renderable
         * @param level
         * @param indexOffset
         * @returns {away.pool.GL_ShapeRenderable}
         * @protected
         */
        _Stage_ElementsBase.prototype._pGetOverflowElements = function () {
            throw new AbstractMethodError();
        };
        return _Stage_ElementsBase;
    }(AbstractionBase));

    /**
     * MethodVO contains data for a given shader object for the use within a single material.
     * This allows shader methods to be shared across materials while their non-public state differs.
     */
    var ChunkVO = /** @class */ (function () {
        function ChunkVO() {
        }
        return ChunkVO;
    }());

    /**
     *
     */
    var MappingMode;
    (function (MappingMode) {
        /**
         *
         */
        MappingMode[MappingMode["LINEAR"] = 0] = "LINEAR";
        /**
         *
         */
        MappingMode[MappingMode["RADIAL"] = 1] = "RADIAL";
    })(MappingMode || (MappingMode = {}));

    /**
     * @class away.render.Filter3DRenderer
     */
    var Filter3DRenderer = /** @class */ (function () {
        function Filter3DRenderer(stage) {
            var _this = this;
            this._filterSizesInvalid = true;
            this._onRTTResizeDelegate = function (event) { return _this.onRTTResize(event); };
            this._stage = stage;
            this._rttManager = RTTBufferManager.getInstance(stage);
            this._rttManager.addEventListener(RTTEvent.RESIZE, this._onRTTResizeDelegate);
            this._sampler = new ImageSampler(false, false, false);
            this._renderToTextureRect = new Rectangle();
        }
        Filter3DRenderer.prototype.onRTTResize = function (event) {
            this._filterSizesInvalid = true;
        };
        Object.defineProperty(Filter3DRenderer.prototype, "requireDepthRender", {
            get: function () {
                return this._requireDepthRender;
            },
            enumerable: true,
            configurable: true
        });
        Filter3DRenderer.prototype.getMainInputTexture = function (stage) {
            if (this._filterTasksInvalid)
                this.updateFilterTasks(stage);
            return this._mainInputTexture;
        };
        Object.defineProperty(Filter3DRenderer.prototype, "filters", {
            get: function () {
                return this._filters;
            },
            set: function (value) {
                this._filters = value;
                this._filterTasksInvalid = true;
                this._requireDepthRender = false;
                if (!this._filters)
                    return;
                for (var i = 0; i < this._filters.length; ++i)
                    if (this._filters[i].requireDepthRender)
                        this._requireDepthRender = true;
                this._filterSizesInvalid = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DRenderer.prototype, "sampler", {
            get: function () {
                return this._sampler;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Filter3DRenderer.prototype, "renderToTextureRect", {
            get: function () {
                if (this._filterSizesInvalid)
                    this.updateFilterSizes();
                return this._renderToTextureRect;
            },
            enumerable: true,
            configurable: true
        });
        Filter3DRenderer.prototype.updateFilterTasks = function (stage) {
            var len;
            if (this._filterSizesInvalid)
                this.updateFilterSizes();
            if (!this._filters) {
                this._tasks = null;
                return;
            }
            this._tasks = new Array();
            len = this._filters.length - 1;
            var filter;
            for (var i = 0; i <= len; ++i) {
                // make sure all internal tasks are linked together
                filter = this._filters[i];
                filter.setRenderTargets(i == len ? null : this._filters[i + 1].getMainInputTexture(stage), stage);
                this._tasks = this._tasks.concat(filter.tasks);
            }
            this._mainInputTexture = this._filters[0].getMainInputTexture(stage);
        };
        Filter3DRenderer.prototype.render = function (stage, projection, depthTexture) {
            var len;
            var i;
            var task;
            var context = stage.context;
            var indexBuffer = this._rttManager.indexBuffer;
            var vertexBuffer = this._rttManager.renderToTextureVertexBuffer;
            if (!this._filters)
                return;
            if (this._filterSizesInvalid)
                this.updateFilterSizes();
            if (this._filterTasksInvalid)
                this.updateFilterTasks(stage);
            len = this._filters.length;
            for (i = 0; i < len; ++i)
                this._filters[i].update(stage, projection);
            len = this._tasks.length;
            if (len > 1) {
                context.setProgram(this._tasks[0].getProgram(stage));
                context.setVertexBufferAt(this._tasks[0]._positionIndex, vertexBuffer, 0, ContextGLVertexBufferFormat.FLOAT_2);
                context.setVertexBufferAt(this._tasks[0]._uvIndex, vertexBuffer, 8, ContextGLVertexBufferFormat.FLOAT_2);
            }
            for (i = 0; i < len; ++i) {
                task = this._tasks[i];
                stage.setRenderTarget(task.target);
                context.setProgram(task.getProgram(stage));
                stage.getAbstraction(task.getMainInputTexture(stage)).activate(task._inputTextureIndex, this._sampler);
                if (!task.target) {
                    vertexBuffer = this._rttManager.renderToScreenVertexBuffer;
                    context.setVertexBufferAt(task._positionIndex, vertexBuffer, 0, ContextGLVertexBufferFormat.FLOAT_2);
                    context.setVertexBufferAt(task._uvIndex, vertexBuffer, 8, ContextGLVertexBufferFormat.FLOAT_2);
                }
                context.clear(0.0, 0.0, 0.0, 0.0);
                task.activate(stage, projection, depthTexture);
                context.setBlendFactors(ContextGLBlendFactor.ONE, ContextGLBlendFactor.ZERO);
                context.drawIndices(ContextGLDrawMode.TRIANGLES, indexBuffer, 0, 6);
                task.deactivate(stage);
            }
            context.setTextureAt(0, null);
            context.setVertexBufferAt(0, null);
            context.setVertexBufferAt(1, null);
        };
        Filter3DRenderer.prototype.updateFilterSizes = function () {
            for (var i = 0; i < this._filters.length; ++i) {
                this._filters[i].textureWidth = this._rttManager.textureWidth;
                this._filters[i].textureHeight = this._rttManager.textureHeight;
                this._filters[i].rttManager = this._rttManager;
            }
            var scale = this._filters[0].textureScale;
            this._renderToTextureRect.x = this._rttManager.renderToTextureRect.x / scale;
            this._renderToTextureRect.y = this._rttManager.renderToTextureRect.y / scale;
            this._renderToTextureRect.width = this._rttManager.renderToTextureRect.width / scale;
            this._renderToTextureRect.height = this._rttManager.renderToTextureRect.height / scale;
            this._filterSizesInvalid = false;
        };
        Filter3DRenderer.prototype.dispose = function () {
            this._rttManager.removeEventListener(RTTEvent.RESIZE, this._onRTTResizeDelegate);
            this._rttManager = null;
            this._stage = null;
        };
        return Filter3DRenderer;
    }());

    /**
     * @class away.sort.RenderableMergeSort
     */
    var RenderableMergeSort = /** @class */ (function () {
        function RenderableMergeSort() {
        }
        RenderableMergeSort.prototype.sortBlendedRenderables = function (head) {
            var headB;
            var fast;
            var slow;
            if (!head || !head.next) {
                return head;
            }
            // split in two sublists
            slow = head;
            fast = head.next;
            while (fast) {
                fast = fast.next;
                if (fast) {
                    slow = slow.next;
                    fast = fast.next;
                }
            }
            headB = slow.next;
            slow.next = null;
            // recurse
            head = this.sortBlendedRenderables(head);
            headB = this.sortBlendedRenderables(headB);
            // merge sublists while respecting order
            var result;
            var curr;
            var l;
            if (!head)
                return headB;
            if (!headB)
                return head;
            while (head && headB) {
                if (head.zIndex < headB.zIndex) {
                    l = head;
                    head = head.next;
                }
                else {
                    l = headB;
                    headB = headB.next;
                }
                if (!result)
                    result = l;
                else
                    curr.next = l;
                curr = l;
            }
            if (head)
                curr.next = head;
            else if (headB)
                curr.next = headB;
            return result;
        };
        RenderableMergeSort.prototype.sortOpaqueRenderables = function (head) {
            var headB;
            var fast, slow;
            if (!head || !head.next) {
                return head;
            }
            // split in two sublists
            slow = head;
            fast = head.next;
            while (fast) {
                fast = fast.next;
                if (fast) {
                    slow = slow.next;
                    fast = fast.next;
                }
            }
            headB = slow.next;
            slow.next = null;
            // recurse
            head = this.sortOpaqueRenderables(head);
            headB = this.sortOpaqueRenderables(headB);
            // merge sublists while respecting order
            var result;
            var curr;
            var l;
            var cmp = 0;
            if (!head)
                return headB;
            if (!headB)
                return head;
            while (head && headB && head != null && headB != null) {
                // first sort per render order id (reduces program3D switches),
                // then on render object id (reduces setting props),
                // then on zIndex (reduces overdraw)
                var aid = head.renderOrderId;
                var bid = headB.renderOrderId;
                if (aid == bid) {
                    var ma = head.materialID;
                    var mb = headB.materialID;
                    if (ma == mb) {
                        if (head.zIndex < headB.zIndex)
                            cmp = 1;
                        else
                            cmp = -1;
                    }
                    else if (ma > mb) {
                        cmp = 1;
                    }
                    else {
                        cmp = -1;
                    }
                }
                else if (aid > bid) {
                    cmp = 1;
                }
                else {
                    cmp = -1;
                }
                if (cmp < 0) {
                    l = head;
                    head = head.next;
                }
                else {
                    l = headB;
                    headB = headB.next;
                }
                if (!result) {
                    result = l;
                    curr = l;
                }
                else {
                    curr.next = l;
                    curr = l;
                }
            }
            if (head)
                curr.next = head;
            else if (headB)
                curr.next = headB;
            return result;
        };
        return RenderableMergeSort;
    }());

    /**
     * RendererBase forms an abstract base class for classes that are used in the rendering pipeline to render the
     * contents of a partition
     *
     * @class away.render.RendererBase
     */
    var RendererBase = /** @class */ (function (_super) {
        __extends$6(RendererBase, _super);
        /**
         * Creates a new RendererBase object.
         */
        function RendererBase(renderGroup, partition, pool) {
            var _this = _super.call(this, partition, pool) || this;
            _this._numUsedStreams = 0;
            _this._numUsedTextures = 0;
            _this._cameraForward = new Vector3D();
            _this._depthTextureDirty = true;
            _this._depthPrepass = false;
            _this._pNumElements = 0;
            _this._disableColor = false;
            _this._disableClear = false;
            _this._renderBlended = true;
            _this._numCullPlanes = 0;
            _this._partition = partition;
            _this._maskId = partition.root.maskId;
            _this._onSizeInvalidateDelegate = function (event) { return _this.onSizeInvalidate(event); };
            _this._onContextUpdateDelegate = function (event) { return _this.onContextUpdate(event); };
            //default sorting algorithm
            _this.renderableSorter = new RenderableMergeSort();
            _this._renderGroup = renderGroup;
            _this._renderGroup.addEventListener(StageEvent.CONTEXT_CREATED, _this._onContextUpdateDelegate);
            _this._renderGroup.addEventListener(StageEvent.CONTEXT_RECREATED, _this._onContextUpdateDelegate);
            _this._renderGroup.addEventListener(ViewEvent.INVALIDATE_SIZE, _this._onSizeInvalidateDelegate);
            _this._view = _this._renderGroup.view;
            _this._stage = _this._renderGroup.stage;
            if (_this._stage.context)
                _this._context = _this._stage.context;
            return _this;
        }
        Object.defineProperty(RendererBase.prototype, "partition", {
            get: function () {
                return this._partition;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RendererBase.prototype, "renderGroup", {
            get: function () {
                return this._renderGroup;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RendererBase.prototype, "cullPlanes", {
            /**
             *
             */
            get: function () {
                return this._customCullPlanes;
            },
            set: function (value) {
                this._customCullPlanes = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RendererBase.prototype, "renderBlended", {
            get: function () {
                return this._renderBlended;
            },
            set: function (value) {
                this._renderBlended = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RendererBase.prototype, "disableColor", {
            get: function () {
                return this._disableColor;
            },
            set: function (value) {
                if (this._disableColor == value)
                    return;
                this._disableColor = value;
                this._invalid = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RendererBase.prototype, "disableClear", {
            get: function () {
                return this._disableClear;
            },
            set: function (value) {
                if (this._disableClear == value)
                    return;
                this._disableClear = value;
                this._invalid = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RendererBase.prototype, "numElements", {
            /**
             *
             */
            get: function () {
                return this._pNumElements;
            },
            enumerable: true,
            configurable: true
        });
        RendererBase.prototype.activatePass = function (pass) {
            //clear unused vertex streams
            var i;
            for (i = pass.shader.numUsedStreams; i < this._numUsedStreams; i++)
                this._context.setVertexBufferAt(i, null);
            //clear unused texture streams
            for (i = pass.shader.numUsedTextures; i < this._numUsedTextures; i++)
                this._context.setTextureAt(i, null);
            //activate shader object through pass
            pass._activate(this._view);
        };
        RendererBase.prototype.deactivatePass = function (pass) {
            //deactivate shader object through pass
            pass._deactivate();
            this._numUsedStreams = pass.shader.numUsedStreams;
            this._numUsedTextures = pass.shader.numUsedTextures;
        };
        Object.defineProperty(RendererBase.prototype, "context", {
            get: function () {
                return this._context;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RendererBase.prototype, "stage", {
            /**
             * The Stage that will provide the ContextGL used for rendering.
             */
            get: function () {
                return this._stage;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RendererBase.prototype, "view", {
            get: function () {
                return this._view;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Disposes the resources used by the RendererBase.
         */
        RendererBase.prototype.dispose = function () {
            this._renderGroup.removeEventListener(StageEvent.CONTEXT_CREATED, this._onContextUpdateDelegate);
            this._renderGroup.removeEventListener(StageEvent.CONTEXT_RECREATED, this._onContextUpdateDelegate);
            this._renderGroup.removeEventListener(ViewEvent.INVALIDATE_SIZE, this._onSizeInvalidateDelegate);
            this._onContextUpdateDelegate = null;
            this._onSizeInvalidateDelegate = null;
            this._view = null;
            this._stage = null;
            this._context = null;
            /*
             if (_backgroundImageRenderer) {
             _backgroundImageRenderer.dispose();
             _backgroundImageRenderer = null;
             }
             */
        };
        /**
         * Renders the potentially visible geometry to the back buffer or texture.
         * @param target An option target texture to render to.
         * @param surfaceSelector The index of a CubeTexture's face to render to.
         * @param additionalClearMask Additional clear mask information, in case extra clear channels are to be omitted.
         */
        RendererBase.prototype.render = function (enableDepthAndStencil, surfaceSelector, mipmapSelector, maskConfig) {
            //TODO refactor setTarget so that rendertextures are created before this check
            // if (!this._stage || !this._context)
            // 	return;
            if (enableDepthAndStencil === void 0) { enableDepthAndStencil = true; }
            if (surfaceSelector === void 0) { surfaceSelector = 0; }
            if (mipmapSelector === void 0) { mipmapSelector = 0; }
            if (maskConfig === void 0) { maskConfig = 0; }
            this._maskConfig = maskConfig;
            //check for mask rendering
            if (this._maskConfig) {
                this._disableClear = true;
                this._disableColor = true;
            }
            this._renderGroup.update(this._partition);
            //reset head values
            this._pBlendedRenderableHead = null;
            this._pOpaqueRenderableHead = null;
            this._pNumElements = 0;
            this._activeMaskOwners = null;
            this._cameraTransform = this._view.projection.transform.concatenatedMatrix3D;
            this._cameraForward = this._view.projection.transform.forwardVector;
            this._cullPlanes = this._customCullPlanes ? this._customCullPlanes : this._view.projection.viewFrustumPlanes;
            this._numCullPlanes = this._cullPlanes ? this._cullPlanes.length : 0;
            RendererBase._collectionMark++;
            this._partition.traverse(this);
            //sort the resulting renderables
            if (this.renderableSorter) {
                this._pOpaqueRenderableHead = this.renderableSorter.sortOpaqueRenderables(this._pOpaqueRenderableHead);
                this._pBlendedRenderableHead = this.renderableSorter.sortBlendedRenderables(this._pBlendedRenderableHead);
            }
            // invalidate mipmaps (if target exists) to regenerate if required
            if (this._view.target)
                this._view.target.invalidateMipmaps();
            // this._pRttViewProjectionMatrix.copyFrom(projection.viewMatrix3D);
            // this._pRttViewProjectionMatrix.appendScale(this.textureRatioX, this.textureRatioY, 1);
            this._executeRender(enableDepthAndStencil, surfaceSelector, mipmapSelector);
            // clear buffers
            for (var i = 0; i < 8; ++i) {
                this._context.setVertexBufferAt(i, null);
                this._context.setTextureAt(i, null);
            }
        };
        RendererBase.prototype._iRenderCascades = function (projection, node, enableDepthAndStencil, surfaceSelector) {
            // this._stage.setRenderTarget(target, true, 0);
            // this._context.clear(1, 1, 1, 1, 1, 0);
            if (enableDepthAndStencil === void 0) { enableDepthAndStencil = true; }
            if (surfaceSelector === void 0) { surfaceSelector = 0; }
            // this._context.setBlendFactors(ContextGLBlendFactor.ONE, ContextGLBlendFactor.ZERO);
            // this._context.setDepthTest(true, ContextGLCompareMode.LESS);
            // var head:_Render_RenderableBase = this._pOpaqueRenderableHead;
            // var first:boolean = true;
            // //TODO cascades must have separate collectors, rather than separate draw commands
            // for (var i:number = numCascades - 1; i >= 0; --i) {
            // 	//this._stage.scissorRect = scissorRects[i];
            // 	//this.drawCascadeRenderables(head, cameras[i], first? null : cameras[i].frustumPlanes);
            // 	first = false;
            // }
            // //line required for correct rendering when using away3d with starling. DO NOT REMOVE UNLESS STARLING INTEGRATION IS RETESTED!
            // this._context.setDepthTest(false, ContextGLCompareMode.LESS_EQUAL);
        };
        /**
         * Renders the potentially visible geometry to the back buffer or texture. Only executed if everything is set up.
         *
         * @param target An option target texture to render to.
         * @param surfaceSelector The index of a CubeTexture's face to render to.
         * @param additionalClearMask Additional clear mask information, in case extra clear channels are to be omitted.
         */
        RendererBase.prototype._executeRender = function (enableDepthAndStencil, surfaceSelector, mipmapSelector) {
            if (enableDepthAndStencil === void 0) { enableDepthAndStencil = true; }
            if (surfaceSelector === void 0) { surfaceSelector = 0; }
            if (mipmapSelector === void 0) { mipmapSelector = 0; }
            //TODO: allow sharedContexts for image targets
            this._view.clear(!this._depthPrepass && !this._disableClear, enableDepthAndStencil, surfaceSelector, mipmapSelector, (!this._view.shareContext || this._view.target) ? ContextGLClearMask.ALL : ContextGLClearMask.DEPTH);
            /*
             if (_backgroundImageRenderer)
             _backgroundImageRenderer.render();
             */
            //initialise blend mode
            this._context.setBlendFactors(ContextGLBlendFactor.ONE, ContextGLBlendFactor.ZERO);
            //initialise depth test
            this._context.setDepthTest(true, ContextGLCompareMode.LESS_EQUAL);
            //initialise color mask
            if (this._disableColor)
                this._context.setColorMask(false, false, false, false);
            else
                this._context.setColorMask(true, true, true, true);
            //initialise stencil
            if (this._maskConfig)
                this._context.enableStencil();
            else
                this._context.disableStencil();
            this.drawRenderables(this._pOpaqueRenderableHead);
            if (this._renderBlended)
                this.drawRenderables(this._pBlendedRenderableHead);
            //line required for correct rendering when using away3d with starling. DO NOT REMOVE UNLESS STARLING INTEGRATION IS RETESTED!
            //this._context.setDepthTest(false, ContextGLCompareMode.LESS_EQUAL); //oopsie
            if (!this._view.shareContext || this._view.target) {
                if (this._snapshotRequired && this._snapshotBitmapImage2D) {
                    this._context.drawToBitmapImage2D(this._snapshotBitmapImage2D);
                    this._snapshotRequired = false;
                }
            }
        };
        RendererBase.prototype.onInvalidate = function (event) {
            _super.prototype.onInvalidate.call(this, event);
            this._renderGroup.invalidate();
        };
        /*
         * Will draw the renderer's output on next render to the provided bitmap data.
         * */
        RendererBase.prototype.queueSnapshot = function (bmd) {
            this._snapshotRequired = true;
            this._snapshotBitmapImage2D = bmd;
        };
        //private drawCascadeRenderables(renderRenderable:_Render_RenderableBase, camera:Camera, cullPlanes:Array<Plane3D>)
        //{
        //	var renderRenderable2:_Render_RenderableBase;
        //	var render:_Render_MaterialBase;
        //	var pass:IPass;
        //
        //	while (renderRenderable) {
        //		renderRenderable2 = renderRenderable;
        //		render = renderRenderable.render;
        //		pass = render.passes[0] //assuming only one pass per material
        //
        //		this.activatePass(renderRenderable, pass, camera);
        //
        //		do {
        //			// if completely in front, it will fall in a different cascade
        //			// do not use near and far planes
        //			if (!cullPlanes || renderRenderable2.sourceEntity.worldBounds.isInFrustum(cullPlanes, 4)) {
        //				renderRenderable2._iRender(pass, camera, this._pRttViewProjectionMatrix);
        //			} else {
        //				renderRenderable2.cascaded = true;
        //			}
        //
        //			renderRenderable2 = renderRenderable2.next;
        //
        //		} while (renderRenderable2 && renderRenderable2.render == render && !renderRenderable2.cascaded);
        //
        //		this.deactivatePass(renderRenderable, pass);
        //
        //		renderRenderable = renderRenderable2;
        //	}
        //}
        /**
         * Draw a list of renderables.
         *
         * @param renderables The renderables to draw.
         */
        RendererBase.prototype.drawRenderables = function (renderRenderable) {
            var i;
            var len;
            var renderRenderable2;
            var renderMaterial;
            var passes;
            var pass;
            while (renderRenderable) {
                renderMaterial = renderRenderable.renderMaterial;
                passes = renderMaterial.passes;
                // otherwise this would result in depth rendered anyway because fragment shader kil is ignored
                // if (this._disableColor && renderMaterial.material.alphaThreshold != 0) {
                // 	renderRenderable2 = renderRenderable;
                // 	// fast forward
                // 	do {
                // 		renderRenderable2 = renderRenderable2.next;
                //
                // 	} while (renderRenderable2 && renderRenderable2.renderMaterial == renderMaterial);
                // } else {
                if (this._activeMasksDirty || this._checkMaskOwners(renderRenderable.maskOwners)) {
                    if (!(this._activeMaskOwners = renderRenderable.maskOwners)) {
                        //re-establish stencil settings (if not inside another mask)
                        if (!this._maskConfig)
                            this._context.disableStencil();
                    }
                    else {
                        this._renderMasks(this._activeMaskOwners);
                    }
                    this._activeMasksDirty = false;
                }
                //iterate through each shader object
                len = passes.length;
                for (i = 0; i < len; i++) {
                    renderRenderable2 = renderRenderable;
                    pass = passes[i];
                    this.activatePass(pass);
                    do {
                        ///console.log("maskOwners", renderRenderable2.maskOwners);
                        renderRenderable2._iRender(pass, this._view);
                        renderRenderable2 = renderRenderable2.next;
                    } while (renderRenderable2 && renderRenderable2.renderMaterial == renderMaterial && !(this._activeMasksDirty = this._checkMaskOwners(renderRenderable2.maskOwners)));
                    this.deactivatePass(pass);
                }
                // }
                renderRenderable = renderRenderable2;
            }
        };
        /**
         * Assign the context once retrieved
         */
        RendererBase.prototype.onContextUpdate = function (event) {
            this._context = this._stage.context;
        };
        /*
         public get iBackground():Texture2DBase
         {
         return this._background;
         }
         */
        /*
         public set iBackground(value:Texture2DBase)
         {
         if (this._backgroundImageRenderer && !value) {
         this._backgroundImageRenderer.dispose();
         this._backgroundImageRenderer = null;
         }

         if (!this._backgroundImageRenderer && value)
         {

         this._backgroundImageRenderer = new BackgroundImageRenderer(this._stage);

         }


         this._background = value;

         if (this._backgroundImageRenderer)
         this._backgroundImageRenderer.texture = value;
         }
         */
        /*
         public get backgroundImageRenderer():BackgroundImageRenderer
         {
         return _backgroundImageRenderer;
         }
         */
        /**
         *
         */
        RendererBase.prototype.onSizeInvalidate = function (event) {
            if (this._pRttBufferManager) {
                this._pRttBufferManager.viewWidth = this._view.width;
                this._pRttBufferManager.viewHeight = this._view.height;
            }
            this._depthTextureDirty = true;
        };
        /**
         *
         * @param node
         * @returns {boolean}
         */
        RendererBase.prototype.enterNode = function (node) {
            var enter = node._collectionMark != RendererBase._collectionMark && node.isRenderable() && node.isInFrustum(this._cullPlanes, this._numCullPlanes) && node.maskId == this._maskId;
            node._collectionMark = RendererBase._collectionMark;
            return enter;
        };
        RendererBase.prototype.getTraverser = function (partition) {
            return this;
        };
        RendererBase.prototype.applyEntity = function (entity) {
            this._sourceEntity = entity;
            this._renderEntity = this._renderGroup.getAbstraction(entity);
            // project onto camera's z-axis
            this._zIndex = entity.zOffset + this._cameraTransform.position.subtract(entity.scenePosition).dotProduct(this._cameraForward);
            //save sceneTransform
            this._renderSceneTransform = entity.getRenderSceneTransform(this._cameraTransform);
            //collect renderables
            entity._acceptTraverser(this);
        };
        RendererBase.prototype.applyTraversable = function (renderable) {
            var renderRenderable = this._renderEntity.getAbstraction(renderable);
            //set local vars for faster referencing
            renderRenderable.cascaded = false;
            renderRenderable.zIndex = this._zIndex;
            renderRenderable.maskId = this._sourceEntity.maskId;
            renderRenderable.maskOwners = this._sourceEntity.maskOwners;
            var renderMaterial = renderRenderable.renderMaterial;
            renderRenderable.materialID = renderMaterial.materialID;
            renderRenderable.renderOrderId = renderMaterial.renderOrderId;
            //store reference to scene transform
            renderRenderable.renderSceneTransform = this._renderSceneTransform;
            if (renderMaterial.requiresBlending) {
                renderRenderable.next = this._pBlendedRenderableHead;
                this._pBlendedRenderableHead = renderRenderable;
            }
            else {
                renderRenderable.next = this._pOpaqueRenderableHead;
                this._pOpaqueRenderableHead = renderRenderable;
            }
            this._pNumElements += renderRenderable.stageElements.elements.numElements; //need to re-trigger stageElements getter in case animator has changed
        };
        RendererBase.prototype._renderMasks = function (maskOwners) {
            //calculate the bit index of maskConfig devided by two
            var halfBitIndex = Math.log2(this._maskConfig) >> 1;
            //create a new base and config value for the mask to be rendered
            var newMaskBase = this._maskConfig ? Math.pow(2, (halfBitIndex + 1) << 1) : 1; //maskBase set to next odd significant bit
            var newMaskConfig = newMaskBase;
            this._context.enableStencil();
            this._context.setStencilActions(ContextGLTriangleFace.FRONT_AND_BACK, ContextGLCompareMode.ALWAYS, ContextGLStencilAction.SET, ContextGLStencilAction.SET, ContextGLStencilAction.SET);
            var numLayers = maskOwners.length;
            var children;
            var numChildren;
            var mask;
            for (var i = 0; i < numLayers; ++i) {
                if (i != 0)
                    this._context.setStencilActions(ContextGLTriangleFace.FRONT_AND_BACK, ContextGLCompareMode.EQUAL, ContextGLStencilAction.SET, ContextGLStencilAction.SET, ContextGLStencilAction.KEEP);
                this._context.setStencilReferenceValue(0xFF, newMaskConfig, newMaskConfig = (newMaskConfig & newMaskBase) + newMaskBase); //flips between read odd write even to read even write odd
                this._context.clear(0, 0, 0, 0, 0, 0, ContextGLClearMask.STENCIL); //clears write mask to zero
                children = maskOwners[i].masks;
                numChildren = children.length;
                for (var j = 0; j < numChildren; ++j) {
                    mask = children[j];
                    //todo: figure out why masks can be null here
                    if (mask)
                        this._renderGroup.getRenderer(mask.partition).render(true, 0, 0, newMaskConfig);
                }
            }
            this._context.setStencilActions(ContextGLTriangleFace.FRONT_AND_BACK, ContextGLCompareMode.EQUAL, ContextGLStencilAction.SET, ContextGLStencilAction.SET, ContextGLStencilAction.KEEP);
            this._context.setStencilReferenceValue(0xFF, newMaskConfig, this._maskConfig); //reads from mask output, writes to previous mask state
            if (!this._disableColor) //re-establish color mask settings (if not inside another mask)
                this._context.setColorMask(true, true, true, true);
        };
        RendererBase.prototype._checkMaskOwners = function (maskOwners) {
            if (this._activeMaskOwners == null || maskOwners == null)
                return Boolean(this._activeMaskOwners != maskOwners);
            if (this._activeMaskOwners.length != maskOwners.length)
                return true;
            var numLayers = maskOwners.length;
            var numMasks;
            var masks;
            var activeNumMasks;
            var activeMasks;
            for (var i = 0; i < numLayers; i++) {
                masks = maskOwners[i].masks;
                numMasks = masks.length;
                activeMasks = this._activeMaskOwners[i].masks;
                activeNumMasks = activeMasks.length;
                if (activeNumMasks != numMasks)
                    return true;
                for (var j = 0; j < numMasks; j++) {
                    if (activeMasks[j] != masks[j])
                        return true;
                }
            }
            return false;
        };
        RendererBase._collectionMark = 0;
        return RendererBase;
    }(AbstractionBase));

    /**
     * The DefaultRenderer class provides the default rendering method. It renders the scene graph objects using the
     * materials assigned to them.
     *
     * @class away.render.DefaultRenderer
     */
    var DefaultRenderer = /** @class */ (function (_super) {
        __extends$6(DefaultRenderer, _super);
        /**
         * Creates a new DefaultRenderer object.
         *
         * @param antiAlias The amount of anti-aliasing to use.
         * @param renderMode The render mode to use.
         */
        function DefaultRenderer(renderGroup, partition, pool) {
            var _this = _super.call(this, renderGroup, partition, pool) || this;
            _this._pRttBufferManager = RTTBufferManager.getInstance(_this._stage);
            _this._depthRenderer = renderGroup.depthRenderGroup.getRenderer(partition);
            _this._distanceRenderer = renderGroup.distanceRenderGroup.getRenderer(partition);
            return _this;
        }
        Object.defineProperty(DefaultRenderer.prototype, "antiAlias", {
            get: function () {
                return this._stage.antiAlias;
            },
            set: function (value) {
                this._stage.antiAlias = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DefaultRenderer.prototype, "depthPrepass", {
            /**
             *
             */
            get: function () {
                return this._depthPrepass;
            },
            set: function (value) {
                this._depthPrepass = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DefaultRenderer.prototype, "filters3d", {
            /**
             *
             * @returns {*}
             */
            get: function () {
                return this._filter3DRenderer ? this._filter3DRenderer.filters : null;
            },
            set: function (value) {
                if (value && value.length == 0)
                    value = null;
                if (this._filter3DRenderer && !value) {
                    this._filter3DRenderer.dispose();
                    this._filter3DRenderer = null;
                }
                else if (!this._filter3DRenderer && value) {
                    this._filter3DRenderer = new Filter3DRenderer(this._stage);
                    this._filter3DRenderer.filters = value;
                }
                if (this._filter3DRenderer) {
                    this._filter3DRenderer.filters = value;
                    this._requireDepthRender = this._filter3DRenderer.requireDepthRender;
                }
                else {
                    this._requireDepthRender = false;
                    if (this._depthRender) {
                        this._depthRender.dispose();
                        this._depthRender = null;
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        DefaultRenderer.prototype.enterNode = function (node) {
            var enter = _super.prototype.enterNode.call(this, node);
            if (enter && node.boundsVisible)
                this.applyEntity(node.getBoundsPrimitive(this._renderGroup.pickGroup));
            return enter;
        };
        DefaultRenderer.prototype.render = function (enableDepthAndStencil, surfaceSelector, mipmapSelector, maskConfig) {
            if (enableDepthAndStencil === void 0) { enableDepthAndStencil = true; }
            if (surfaceSelector === void 0) { surfaceSelector = 0; }
            if (mipmapSelector === void 0) { mipmapSelector = 0; }
            if (maskConfig === void 0) { maskConfig = 0; }
            if (!this._stage.recoverFromDisposal()) { //if context has Disposed by the OS,don't render at this frame
                return;
            }
            if (this._requireDepthRender)
                this._renderSceneDepthToTexture();
            if (this._depthPrepass)
                this._renderDepthPrepass();
            if (this._filter3DRenderer) { //TODO
                this._view.target = this._filter3DRenderer.getMainInputTexture(this._stage);
                _super.prototype.render.call(this, enableDepthAndStencil, surfaceSelector, mipmapSelector);
                this._filter3DRenderer.render(this._stage, this._view.projection, this._depthRender);
            }
            else {
                //this._view.target = null;
                _super.prototype.render.call(this, enableDepthAndStencil, surfaceSelector, mipmapSelector, maskConfig);
            }
            if (!maskConfig)
                this._view.present();
        };
        DefaultRenderer.prototype.dispose = function () {
            this._view.dispose();
            this._pRttBufferManager.dispose();
            this._pRttBufferManager = null;
            this._depthRenderer.dispose();
            this._distanceRenderer.dispose();
            this._depthRenderer = null;
            this._distanceRenderer = null;
            this._depthRender = null;
            _super.prototype.dispose.call(this);
        };
        /**
         *
         */
        DefaultRenderer.prototype._renderDepthPrepass = function () {
            this._depthRenderer.disableColor = true;
            this._depthRenderer.view.projection = this._view.projection;
            if (this._filter3DRenderer) {
                this._depthRenderer.view.target = this._filter3DRenderer.getMainInputTexture(this._stage);
                this._depthRenderer.render();
            }
            else {
                this._depthRenderer.view.target = null;
                this._depthRenderer.render();
            }
            this._depthRenderer.disableColor = false;
        };
        /**
         *
         */
        DefaultRenderer.prototype._renderSceneDepthToTexture = function () {
            if (this._depthTextureDirty || !this._depthRender)
                this.initDepthTexture(this._stage.context);
            this._depthRenderer.render();
        };
        /**
         *
         */
        DefaultRenderer.prototype.initDepthTexture = function (context) {
            this._depthTextureDirty = false;
            if (this._depthRender)
                this._depthRender.dispose();
            this._depthRender = new BitmapImage2D(this._pRttBufferManager.textureWidth, this._pRttBufferManager.textureHeight);
            this._depthRenderer.view.target = this._depthRender;
            this._depthRenderer.view.projection = this._view.projection;
        };
        return DefaultRenderer;
    }(RendererBase));

    /**
     * The DepthRenderer class renders 32-bit depth information encoded as RGBA
     *
     * @class away.render.DepthRenderer
     */
    var DepthRenderer = /** @class */ (function (_super) {
        __extends$6(DepthRenderer, _super);
        /**
         * Creates a new DepthRenderer object.
         * @param renderBlended Indicates whether semi-transparent objects should be rendered.
         * @param distanceBased Indicates whether the written depth value is distance-based or projected depth-based
         */
        function DepthRenderer(renderGroup, partition, pool) {
            return _super.call(this, renderGroup, partition, pool) || this;
        }
        /**
         *
         */
        DepthRenderer.prototype.enterNode = function (node) {
            var enter = node._collectionMark != RendererBase._collectionMark && node.isCastingShadow();
            if (!enter) {
                node._collectionMark = RendererBase._collectionMark;
                return false;
            }
            return _super.prototype.enterNode.call(this, node);
        };
        return DepthRenderer;
    }(RendererBase));

    /**
     * The DistanceRenderer class renders 32-bit depth information encoded as RGBA
     *
     * @class away.render.DistanceRenderer
     */
    var DistanceRenderer = /** @class */ (function (_super) {
        __extends$6(DistanceRenderer, _super);
        /**
         * Creates a new DistanceRenderer object.
         * @param renderBlended Indicates whether semi-transparent objects should be rendered.
         * @param distanceBased Indicates whether the written depth value is distance-based or projected depth-based
         */
        function DistanceRenderer(renderGroup, partition, pool) {
            return _super.call(this, renderGroup, partition, pool) || this;
        }
        /**
         *
         */
        DistanceRenderer.prototype.enterNode = function (node) {
            var enter = node._collectionMark != RendererBase._collectionMark && node.isCastingShadow();
            if (!enter) {
                node._collectionMark = RendererBase._collectionMark;
                return false;
            }
            return _super.prototype.enterNode.call(this, node);
        };
        return DistanceRenderer;
    }(RendererBase));

    var _a$1, _b$1;
    var DefaultRendererPool = /** @class */ (function () {
        function DefaultRendererPool(renderGroup) {
            this._abstractionPool = new Object();
            this._renderGroup = renderGroup;
        }
        Object.defineProperty(DefaultRendererPool.prototype, "materialClassPool", {
            get: function () {
                return DefaultRendererPool._materialClassPool;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * //TODO
         *
         * @param entity
         * @returns EntityNode
         */
        DefaultRendererPool.prototype.getAbstraction = function (partition) {
            return (this._abstractionPool[partition.id] || (this._abstractionPool[partition.id] = new DefaultRenderer(this._renderGroup, partition, this)));
        };
        /**
         *
         * @param entity
         */
        DefaultRendererPool.prototype.clearAbstraction = function (partition) {
            delete this._abstractionPool[partition.id];
        };
        /**
         *
         * @param imageObjectClass
         */
        DefaultRendererPool.registerMaterial = function (renderMaterialClass, materialClass) {
            DefaultRendererPool._materialClassPool[materialClass.assetType] = renderMaterialClass;
        };
        DefaultRendererPool._materialClassPool = new Object();
        return DefaultRendererPool;
    }());
    var DepthRendererPool = /** @class */ (function () {
        function DepthRendererPool(renderGroup) {
            this._abstractionPool = new Object();
            this._renderGroup = renderGroup;
        }
        Object.defineProperty(DepthRendererPool.prototype, "materialClassPool", {
            get: function () {
                return DepthRendererPool._materialClassPool;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * //TODO
         *
         * @param entity
         * @returns EntityNode
         */
        DepthRendererPool.prototype.getAbstraction = function (partition) {
            return (this._abstractionPool[partition.id] || (this._abstractionPool[partition.id] = new DepthRenderer(this._renderGroup, partition, this)));
        };
        /**
         *
         * @param entity
         */
        DepthRendererPool.prototype.clearAbstraction = function (partition) {
            delete this._abstractionPool[partition.id];
        };
        /**
         *
         * @param imageObjectClass
         */
        DepthRendererPool.registerMaterial = function (renderMaterialClass, materialClass) {
            DepthRendererPool._materialClassPool[materialClass.assetType] = renderMaterialClass;
        };
        DepthRendererPool._materialClassPool = new Object();
        return DepthRendererPool;
    }());
    var DistanceRendererPool = /** @class */ (function () {
        function DistanceRendererPool(renderGroup) {
            this._abstractionPool = new Object();
            this._renderGroup = renderGroup;
        }
        Object.defineProperty(DistanceRendererPool.prototype, "materialClassPool", {
            get: function () {
                return DistanceRendererPool._materialClassPool;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * //TODO
         *
         * @param entity
         * @returns EntityNode
         */
        DistanceRendererPool.prototype.getAbstraction = function (partition) {
            return (this._abstractionPool[partition.id] || (this._abstractionPool[partition.id] = new DistanceRenderer(this._renderGroup, partition, this)));
        };
        /**
         *
         * @param entity
         */
        DistanceRendererPool.prototype.clearAbstraction = function (partition) {
            delete this._abstractionPool[partition.id];
        };
        /**
         *
         * @param imageObjectClass
         */
        DistanceRendererPool.registerMaterial = function (renderMaterialClass, materialClass) {
            DistanceRendererPool._materialClassPool[materialClass.assetType] = renderMaterialClass;
        };
        DistanceRendererPool._materialClassPool = new Object();
        return DistanceRendererPool;
    }());
    var RendererType;
    (function (RendererType) {
        RendererType[RendererType["DEFAULT"] = 0] = "DEFAULT";
        RendererType[RendererType["DEPTH"] = 1] = "DEPTH";
        RendererType[RendererType["DISTANCE"] = 2] = "DISTANCE";
    })(RendererType || (RendererType = {}));
    /**
     * @class away.pool.RenderGroup
     */
    var RenderGroup = /** @class */ (function (_super) {
        __extends$6(RenderGroup, _super);
        /**
         * //TODO
         *
         * @param materialClassGL
         */
        function RenderGroup(view, rendererType) {
            var _this = _super.call(this) || this;
            _this._mappers = new Array();
            _this._materialPools = new Object();
            _this._entityPool = new Object();
            _this._view = view;
            _this._stage = view.stage;
            _this._pickGroup = PickGroup.getInstance(view);
            _this._rendererPool = new RenderGroup._rendererClass[rendererType](_this);
            _this._materialClassPool = _this._rendererPool.materialClassPool;
            if (rendererType != RendererType.DEFAULT) //set shadow renderer backgrounds to white
                _this._view.backgroundColor = 0xFFFFFF;
            _this._onSizeInvalidateDelegate = function (event) { return _this.onSizeInvalidate(event); };
            _this._onContextUpdateDelegate = function (event) { return _this.onContextUpdate(event); };
            _this._stage.addEventListener(StageEvent.CONTEXT_CREATED, _this._onContextUpdateDelegate);
            _this._stage.addEventListener(StageEvent.CONTEXT_RECREATED, _this._onContextUpdateDelegate);
            _this._view.addEventListener(ViewEvent.INVALIDATE_SIZE, _this._onSizeInvalidateDelegate);
            return _this;
        }
        RenderGroup.getInstance = function (view, rendererType) {
            return this._instancePool[rendererType][view.id] || (this._instancePool[rendererType][view.id] = new RenderGroup(view, rendererType));
        };
        Object.defineProperty(RenderGroup.prototype, "view", {
            get: function () {
                return this._view;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RenderGroup.prototype, "depthRenderGroup", {
            get: function () {
                if (this._depthRenderGroup == null)
                    this._depthRenderGroup = RenderGroup.getInstance(new View(null, this._stage), RendererType.DEPTH);
                return this._depthRenderGroup;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RenderGroup.prototype, "distanceRenderGroup", {
            get: function () {
                if (this._distanceRenderGroup == null)
                    this._distanceRenderGroup = RenderGroup.getInstance(new View(null, this._stage), RendererType.DISTANCE);
                return this._distanceRenderGroup;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RenderGroup.prototype, "stage", {
            get: function () {
                return this._stage;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(RenderGroup.prototype, "pickGroup", {
            get: function () {
                return this._pickGroup;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Disposes the resources used by the RendererBase.
         */
        RenderGroup.prototype.dispose = function () {
            this._stage.removeEventListener(StageEvent.CONTEXT_CREATED, this._onContextUpdateDelegate);
            this._stage.removeEventListener(StageEvent.CONTEXT_RECREATED, this._onContextUpdateDelegate);
            this._view.removeEventListener(ViewEvent.INVALIDATE_SIZE, this._onSizeInvalidateDelegate);
            this._view = null;
            this._stage = null;
        };
        RenderGroup.prototype.update = function (partition) {
            //update mappers
            var len = this._mappers.length;
            for (var i = 0; i < len; i++)
                this._mappers[i].update(partition, this);
        };
        RenderGroup.prototype.invalidate = function () {
            this._invalid = true;
        };
        RenderGroup.prototype._addMapper = function (mapper) {
            if (this._mappers.indexOf(mapper) != -1)
                return;
            this._mappers.push(mapper);
        };
        RenderGroup.prototype._removeMapper = function (mapper) {
            var index = this._mappers.indexOf(mapper);
            if (index != -1)
                this._mappers.splice(index, 1);
        };
        /**
         *
         */
        RenderGroup.prototype.onSizeInvalidate = function (event) {
            this.dispatchEvent(event);
        };
        /**
         * Assign the context once retrieved
         */
        RenderGroup.prototype.onContextUpdate = function (event) {
            this.dispatchEvent(event);
        };
        RenderGroup.prototype.getRenderElements = function (elements) {
            return this._materialPools[elements.assetType] || (this._materialPools[elements.assetType] = new RenderGroup._renderElementsClassPool[elements.assetType](this._stage, this._materialClassPool, this));
        };
        RenderGroup.prototype.getAbstraction = function (entity) {
            return this._entityPool[entity.id] || (this._entityPool[entity.id] = new RenderEntity(this._stage, entity, this));
        };
        RenderGroup.prototype.getRenderer = function (partition) {
            return this._rendererPool.getAbstraction(partition);
        };
        /**
         *
         * @param entity
         */
        RenderGroup.prototype.clearAbstraction = function (entity) {
            delete this._entityPool[entity.id];
        };
        /**
         *
         * @param imageObjectClass
         */
        RenderGroup.registerElements = function (renderElementsClass, elementsClass) {
            RenderGroup._renderElementsClassPool[elementsClass.assetType] = renderElementsClass;
        };
        RenderGroup.registerDefaultMaterial = function (renderMaterialClass, materialClass) {
            DefaultRendererPool.registerMaterial(renderMaterialClass, materialClass);
        };
        RenderGroup.registerDepthMaterial = function (renderMaterialClass, materialClass) {
            DepthRendererPool.registerMaterial(renderMaterialClass, materialClass);
        };
        RenderGroup.registerDistanceMaterial = function (renderMaterialClass, materialClass) {
            DistanceRendererPool.registerMaterial(renderMaterialClass, materialClass);
        };
        RenderGroup._rendererClass = (_a$1 = {}, _a$1[RendererType.DEFAULT] = DefaultRendererPool, _a$1[RendererType.DEPTH] = DepthRendererPool, _a$1[RendererType.DISTANCE] = DistanceRendererPool, _a$1);
        RenderGroup._defaultInstancePool = new Object();
        RenderGroup._depthInstancePool = new Object();
        RenderGroup._distanceInstancePool = new Object();
        RenderGroup._instancePool = (_b$1 = {}, _b$1[RendererType.DEFAULT] = RenderGroup._defaultInstancePool, _b$1[RendererType.DEPTH] = RenderGroup._depthInstancePool, _b$1[RendererType.DISTANCE] = RenderGroup._distanceInstancePool, _b$1);
        RenderGroup._renderElementsClassPool = new Object();
        return RenderGroup;
    }(EventDispatcher));

    /**
     * @class away.sort.NullSort
     */

    console.debug("AwayJS - Renderer - 0.10.9");

    /**
     * Provides an abstract base class for nodes with time-based animation data in an animation blend tree.
     */
    var AnimationClipNodeBase = /** @class */ (function (_super) {
        __extends$5(AnimationClipNodeBase, _super);
        /**
         * Creates a new <code>AnimationClipNodeBase</code> object.
         */
        function AnimationClipNodeBase() {
            var _this = _super.call(this) || this;
            _this._pLooping = true;
            _this._pTotalDuration = 0;
            _this._pStitchDirty = true;
            _this._pStitchFinalFrame = false;
            _this._pNumFrames = 0;
            _this._pDurations = new Array();
            /*uint*/
            _this._pTotalDelta = new Vector3D();
            _this.fixedFrameRate = true;
            return _this;
        }
        Object.defineProperty(AnimationClipNodeBase.prototype, "looping", {
            /**
             * Determines whether the contents of the animation node have looping characteristics enabled.
             */
            get: function () {
                return this._pLooping;
            },
            set: function (value) {
                if (this._pLooping == value)
                    return;
                this._pLooping = value;
                this._pStitchDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationClipNodeBase.prototype, "stitchFinalFrame", {
            /**
             * Defines if looping content blends the final frame of animation data with the first (true) or works on the
             * assumption that both first and last frames are identical (false). Defaults to false.
             */
            get: function () {
                return this._pStitchFinalFrame;
            },
            set: function (value) {
                if (this._pStitchFinalFrame == value)
                    return;
                this._pStitchFinalFrame = value;
                this._pStitchDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationClipNodeBase.prototype, "totalDuration", {
            get: function () {
                if (this._pStitchDirty)
                    this._pUpdateStitch();
                return this._pTotalDuration;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationClipNodeBase.prototype, "totalDelta", {
            get: function () {
                if (this._pStitchDirty)
                    this._pUpdateStitch();
                return this._pTotalDelta;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationClipNodeBase.prototype, "lastFrame", {
            get: function () {
                if (this._pStitchDirty)
                    this._pUpdateStitch();
                return this._pLastFrame;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationClipNodeBase.prototype, "durations", {
            /**
             * Returns a vector of time values representing the duration (in milliseconds) of each animation frame in the clip.
             */
            get: function () {
                return this._pDurations;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Updates the node's final frame stitch state.
         *
         * @see #stitchFinalFrame
         */
        AnimationClipNodeBase.prototype._pUpdateStitch = function () {
            this._pStitchDirty = false;
            this._pLastFrame = (this._pStitchFinalFrame) ? this._pNumFrames : this._pNumFrames - 1;
            this._pTotalDuration = 0;
            this._pTotalDelta.x = 0;
            this._pTotalDelta.y = 0;
            this._pTotalDelta.z = 0;
        };
        return AnimationClipNodeBase;
    }(AnimationNodeBase));

    /**
     *
     */
    var AnimationStateBase = /** @class */ (function () {
        function AnimationStateBase(animator, animationNode) {
            this._pRootDelta = new Vector3D();
            this._pPositionDeltaDirty = true;
            this._pStartTime = 0;
            this._pAnimator = animator;
            this._pAnimationNode = animationNode;
        }
        Object.defineProperty(AnimationStateBase.prototype, "positionDelta", {
            /**
             * Returns a 3d vector representing the translation delta of the animating entity for the current timestep of animation
             */
            get: function () {
                if (this._pPositionDeltaDirty) {
                    this._pUpdatePositionDelta();
                }
                return this._pRootDelta;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Resets the start time of the node to a  new value.
         *
         * @param startTime The absolute start time (in milliseconds) of the node's starting time.
         */
        AnimationStateBase.prototype.offset = function (startTime) {
            this._pStartTime = startTime;
            this._pPositionDeltaDirty = true;
        };
        /**
         * Updates the configuration of the node to its current state.
         *
         * @param time The absolute time (in milliseconds) of the animator's play head position.
         *
         * @see AnimatorBase#update()
         */
        AnimationStateBase.prototype.update = function (time) {
            if (this._pTime == time - this._pStartTime) {
                return;
            }
            this._pUpdateTime(time);
        };
        /**
         * Sets the animation phase of the node.
         *
         * @param value The phase value to use. 0 represents the beginning of an animation clip, 1 represents the end.
         */
        AnimationStateBase.prototype.phase = function (value) {
        };
        /**
         * Updates the node's internal playhead position.
         *
         * @param time The local time (in milliseconds) of the node's playhead position.
         */
        AnimationStateBase.prototype._pUpdateTime = function (time) {
            this._pTime = time - this._pStartTime;
            this._pPositionDeltaDirty = true;
        };
        /**
         * Updates the node's root delta position
         */
        AnimationStateBase.prototype._pUpdatePositionDelta = function () {
        };
        return AnimationStateBase;
    }());

    /**
     * ...
     */
    var ParticleStateBase = /** @class */ (function (_super) {
        __extends$5(ParticleStateBase, _super);
        function ParticleStateBase(animator, particleNode, needUpdateTime) {
            if (needUpdateTime === void 0) { needUpdateTime = false; }
            var _this = _super.call(this, animator, particleNode) || this;
            _this._pDynamicProperties = new Array();
            _this._pDynamicPropertiesDirty = new Object();
            _this._pParticleAnimator = animator;
            _this._particleNode = particleNode;
            _this._pNeedUpdateTime = needUpdateTime;
            return _this;
        }
        Object.defineProperty(ParticleStateBase.prototype, "needUpdateTime", {
            get: function () {
                return this._pNeedUpdateTime;
            },
            enumerable: true,
            configurable: true
        });
        ParticleStateBase.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
        };
        ParticleStateBase.prototype._pUpdateDynamicProperties = function (animationElements) {
            this._pDynamicPropertiesDirty[animationElements._iUniqueId] = true;
            var animationParticles = animationElements.animationParticles;
            var vertexData = animationElements.vertexData;
            var totalLenOfOneVertex = animationElements.totalLenOfOneVertex;
            var dataLength = this._particleNode.dataLength;
            var dataOffset = this._particleNode._iDataOffset;
            var vertexLength;
            //			var particleOffset:number;
            var startingOffset;
            var vertexOffset;
            var data;
            var animationParticle;
            //			var numParticles:number = _positions.length/dataLength;
            var numParticles = this._pDynamicProperties.length;
            var i = 0;
            var j = 0;
            var k = 0;
            //loop through all particles
            while (i < numParticles) {
                //loop through each particle data for the current particle
                while (j < numParticles && (animationParticle = animationParticles[j]).index == i) {
                    data = this._pDynamicProperties[i];
                    vertexLength = animationParticle.numVertices * totalLenOfOneVertex;
                    startingOffset = animationParticle.startVertexIndex * totalLenOfOneVertex + dataOffset;
                    //loop through each vertex in the particle data
                    for (k = 0; k < vertexLength; k += totalLenOfOneVertex) {
                        vertexOffset = startingOffset + k;
                        //						particleOffset = i * dataLength;
                        //loop through all vertex data for the current particle data
                        for (k = 0; k < vertexLength; k += totalLenOfOneVertex) {
                            vertexOffset = startingOffset + k;
                            vertexData[vertexOffset++] = data.x;
                            vertexData[vertexOffset++] = data.y;
                            vertexData[vertexOffset++] = data.z;
                            if (dataLength == 4)
                                vertexData[vertexOffset++] = data.w;
                        }
                        //loop through each value in the particle vertex
                        //						switch(dataLength) {
                        //							case 4:
                        //								vertexData[vertexOffset++] = _positions[particleOffset++];
                        //							case 3:
                        //								vertexData[vertexOffset++] = _positions[particleOffset++];
                        //							case 2:
                        //								vertexData[vertexOffset++] = _positions[particleOffset++];
                        //							case 1:
                        //								vertexData[vertexOffset++] = _positions[particleOffset++];
                        //						}
                    }
                    j++;
                }
                i++;
            }
            animationElements.invalidateBuffer();
        };
        return ParticleStateBase;
    }(AnimationStateBase));

    /**
     * ...
     */
    var ParticleAccelerationState = /** @class */ (function (_super) {
        __extends$5(ParticleAccelerationState, _super);
        function ParticleAccelerationState(animator, particleAccelerationNode) {
            var _this = _super.call(this, animator, particleAccelerationNode) || this;
            _this._particleAccelerationNode = particleAccelerationNode;
            _this._acceleration = _this._particleAccelerationNode._acceleration;
            _this.updateAccelerationData();
            return _this;
        }
        Object.defineProperty(ParticleAccelerationState.prototype, "acceleration", {
            /**
             * Defines the acceleration vector of the state, used when in global mode.
             */
            get: function () {
                return this._acceleration;
            },
            set: function (value) {
                this._acceleration.x = value.x;
                this._acceleration.y = value.y;
                this._acceleration.z = value.z;
                this.updateAccelerationData();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        ParticleAccelerationState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            var index = animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleAccelerationState.ACCELERATION_INDEX);
            if (this._particleAccelerationNode.mode == ParticlePropertiesMode.LOCAL_STATIC)
                animationElements.activateVertexBuffer(index, this._particleAccelerationNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_3);
            else
                shader.setVertexConst(index, this._halfAcceleration.x, this._halfAcceleration.y, this._halfAcceleration.z);
        };
        ParticleAccelerationState.prototype.updateAccelerationData = function () {
            if (this._particleAccelerationNode.mode == ParticlePropertiesMode.GLOBAL)
                this._halfAcceleration = new Vector3D(this._acceleration.x / 2, this._acceleration.y / 2, this._acceleration.z / 2);
        };
        /** @private */
        ParticleAccelerationState.ACCELERATION_INDEX = 0;
        return ParticleAccelerationState;
    }(ParticleStateBase));

    /**
     * Provides an abstract base class for particle animation nodes.
     */
    var ParticleNodeBase = /** @class */ (function (_super) {
        __extends$5(ParticleNodeBase, _super);
        /**
         * Creates a new <code>ParticleNodeBase</code> object.
         *
         * @param               name            Defines the generic name of the particle animation node.
         * @param               mode            Defines whether the mode of operation acts on local properties of a particle or global properties of the node.
         * @param               dataLength      Defines the length of the data used by the node when in <code>LOCAL_STATIC</code> mode.
         * @param    [optional] priority        the priority of the particle animation node, used to order the agal generated in a particle animation set. Defaults to 1.
         */
        function ParticleNodeBase(name, mode, dataLength, priority) {
            if (priority === void 0) { priority = 1; }
            var _this = _super.call(this) || this;
            _this._pDataLength = 3;
            name = name + ParticleNodeBase.MODES[mode];
            _this.name = name;
            _this._pMode = mode;
            _this._priority = priority;
            _this._pDataLength = dataLength;
            _this._pOneData = new Array(_this._pDataLength);
            return _this;
        }
        Object.defineProperty(ParticleNodeBase.prototype, "mode", {
            /**
             * Returns the property mode of the particle animation node. Typically set in the node constructor
             *
             * @see away.animators.ParticlePropertiesMode
             */
            get: function () {
                return this._pMode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleNodeBase.prototype, "priority", {
            /**
             * Returns the priority of the particle animation node, used to order the agal generated in a particle animation set. Set automatically on instantiation.
             *
             * @see away.animators.ParticleAnimationSet
             * @see #getAGALVertexCode
             */
            get: function () {
                return this._priority;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleNodeBase.prototype, "dataLength", {
            /**
             * Returns the length of the data used by the node when in <code>LOCAL_STATIC</code> mode. Used to generate the local static data of the particle animation set.
             *
             * @see away.animators.ParticleAnimationSet
             * @see #getAGALVertexCode
             */
            get: function () {
                return this._pDataLength;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleNodeBase.prototype, "oneData", {
            /**
             * Returns the generated data vector of the node after one particle pass during the generation of all local static data of the particle animation set.
             *
             * @see away.animators.ParticleAnimationSet
             * @see #generatePropertyOfOneParticle
             */
            get: function () {
                return this._pOneData;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns the AGAL code of the particle animation node for use in the vertex shader.
         */
        ParticleNodeBase.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            return "";
        };
        /**
         * Returns the AGAL code of the particle animation node for use in the fragment shader.
         */
        ParticleNodeBase.prototype.getAGALFragmentCode = function (shader, animationSet, registerCache, animationRegisterData) {
            return "";
        };
        /**
         * Returns the AGAL code of the particle animation node for use in the fragment shader when UV coordinates are required.
         */
        ParticleNodeBase.prototype.getAGALUVCode = function (shader, animationSet, registerCache, animationRegisterData) {
            return "";
        };
        /**
         * Called internally by the particle animation set when assigning the set of static properties originally defined by the initParticleFunc of the set.
         *
         * @see away.animators.ParticleAnimationSet#initParticleFunc
         */
        ParticleNodeBase.prototype._iGeneratePropertyOfOneParticle = function (param) {
        };
        /**
         * Called internally by the particle animation set when determining the requirements of the particle animation node AGAL.
         */
        ParticleNodeBase.prototype._iProcessAnimationSetting = function (particleAnimationSet) {
        };
        //modes alias
        ParticleNodeBase.GLOBAL = 'Global';
        ParticleNodeBase.LOCAL_STATIC = 'LocalStatic';
        ParticleNodeBase.LOCAL_DYNAMIC = 'LocalDynamic';
        //modes list
        ParticleNodeBase.MODES = {
            0: ParticleNodeBase.GLOBAL,
            1: ParticleNodeBase.LOCAL_STATIC,
            2: ParticleNodeBase.LOCAL_DYNAMIC
        };
        return ParticleNodeBase;
    }(AnimationNodeBase));

    /**
     * A particle animation node used to apply a constant acceleration vector to the motion of a particle.
     */
    var ParticleAccelerationNode = /** @class */ (function (_super) {
        __extends$5(ParticleAccelerationNode, _super);
        /**
         * Creates a new <code>ParticleAccelerationNode</code>
         *
         * @param               mode            Defines whether the mode of operation acts on local properties of a particle or global properties of the node.
         * @param    [optional] acceleration    Defines the default acceleration vector of the node, used when in global mode.
         */
        function ParticleAccelerationNode(mode, acceleration) {
            if (acceleration === void 0) { acceleration = null; }
            var _this = _super.call(this, "ParticleAcceleration", mode, 3) || this;
            _this._pStateClass = ParticleAccelerationState;
            _this._acceleration = acceleration || new Vector3D();
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleAccelerationNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var accelerationValue = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
            animationRegisterData.setRegisterIndex(this, ParticleAccelerationState.ACCELERATION_INDEX, accelerationValue.index);
            var temp = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(temp, 1);
            var code = "mul " + temp + "," + animationRegisterData.vertexTime + "," + accelerationValue + "\n";
            if (animationSet.needVelocity) {
                var temp2 = registerCache.getFreeVertexVectorTemp();
                code += "mul " + temp2 + "," + temp + "," + animationRegisterData.vertexTwoConst + "\n";
                code += "add " + animationRegisterData.velocityTarget + ".xyz," + temp2 + ".xyz," + animationRegisterData.velocityTarget + ".xyz\n";
            }
            registerCache.removeVertexTempUsage(temp);
            code += "mul " + temp + "," + temp + "," + animationRegisterData.vertexTime + "\n";
            code += "add " + animationRegisterData.positionTarget + ".xyz," + temp + "," + animationRegisterData.positionTarget + ".xyz\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleAccelerationNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleAccelerationNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            var tempAcceleration = param[ParticleAccelerationNode.ACCELERATION_VECTOR3D];
            if (!tempAcceleration)
                throw new Error("there is no " + ParticleAccelerationNode.ACCELERATION_VECTOR3D + " in param!");
            this._pOneData[0] = tempAcceleration.x / 2;
            this._pOneData[1] = tempAcceleration.y / 2;
            this._pOneData[2] = tempAcceleration.z / 2;
        };
        /**
         * Reference for acceleration node properties on a single particle (when in local property mode).
         * Expects a <code>Vector3D</code> object representing the direction of acceleration on the particle.
         */
        ParticleAccelerationNode.ACCELERATION_VECTOR3D = "AccelerationVector3D";
        return ParticleAccelerationNode;
    }(ParticleNodeBase));

    /**
     * ...
     */
    var ParticleBezierCurveState = /** @class */ (function (_super) {
        __extends$5(ParticleBezierCurveState, _super);
        function ParticleBezierCurveState(animator, particleBezierCurveNode) {
            var _this = _super.call(this, animator, particleBezierCurveNode) || this;
            _this._particleBezierCurveNode = particleBezierCurveNode;
            _this._controlPoint = _this._particleBezierCurveNode._iControlPoint;
            _this._endPoint = _this._particleBezierCurveNode._iEndPoint;
            return _this;
        }
        Object.defineProperty(ParticleBezierCurveState.prototype, "controlPoint", {
            /**
             * Defines the default control point of the node, used when in global mode.
             */
            get: function () {
                return this._controlPoint;
            },
            set: function (value) {
                this._controlPoint = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleBezierCurveState.prototype, "endPoint", {
            /**
             * Defines the default end point of the node, used when in global mode.
             */
            get: function () {
                return this._endPoint;
            },
            set: function (value) {
                this._endPoint = value;
            },
            enumerable: true,
            configurable: true
        });
        ParticleBezierCurveState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            var controlIndex = animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleBezierCurveState.BEZIER_CONTROL_INDEX);
            var endIndex = animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleBezierCurveState.BEZIER_END_INDEX);
            if (this._particleBezierCurveNode.mode == ParticlePropertiesMode.LOCAL_STATIC) {
                animationElements.activateVertexBuffer(controlIndex, this._particleBezierCurveNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_3);
                animationElements.activateVertexBuffer(endIndex, this._particleBezierCurveNode._iDataOffset + 3, stage, ContextGLVertexBufferFormat.FLOAT_3);
            }
            else {
                shader.setVertexConst(controlIndex, this._controlPoint.x, this._controlPoint.y, this._controlPoint.z);
                shader.setVertexConst(endIndex, this._endPoint.x, this._endPoint.y, this._endPoint.z);
            }
        };
        /** @private */
        ParticleBezierCurveState.BEZIER_CONTROL_INDEX = 0;
        /** @private */
        ParticleBezierCurveState.BEZIER_END_INDEX = 1;
        return ParticleBezierCurveState;
    }(ParticleStateBase));

    /**
     * A particle animation node used to control the position of a particle over time along a bezier curve.
     */
    var ParticleBezierCurveNode = /** @class */ (function (_super) {
        __extends$5(ParticleBezierCurveNode, _super);
        /**
         * Creates a new <code>ParticleBezierCurveNode</code>
         *
         * @param               mode            Defines whether the mode of operation acts on local properties of a particle or global properties of the node.
         * @param    [optional] controlPoint    Defines the default control point of the node, used when in global mode.
         * @param    [optional] endPoint        Defines the default end point of the node, used when in global mode.
         */
        function ParticleBezierCurveNode(mode, controlPoint, endPoint) {
            if (controlPoint === void 0) { controlPoint = null; }
            if (endPoint === void 0) { endPoint = null; }
            var _this = _super.call(this, "ParticleBezierCurve", mode, 6) || this;
            _this._pStateClass = ParticleBezierCurveState;
            _this._iControlPoint = controlPoint || new Vector3D();
            _this._iEndPoint = endPoint || new Vector3D();
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleBezierCurveNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var controlValue = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
            animationRegisterData.setRegisterIndex(this, ParticleBezierCurveState.BEZIER_CONTROL_INDEX, controlValue.index);
            var endValue = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
            animationRegisterData.setRegisterIndex(this, ParticleBezierCurveState.BEZIER_END_INDEX, endValue.index);
            var temp = registerCache.getFreeVertexVectorTemp();
            var rev_time = new ShaderRegisterElement(temp.regName, temp.index, 0);
            var time_2 = new ShaderRegisterElement(temp.regName, temp.index, 1);
            var time_temp = new ShaderRegisterElement(temp.regName, temp.index, 2);
            registerCache.addVertexTempUsages(temp, 1);
            var temp2 = registerCache.getFreeVertexVectorTemp();
            var distance = new ShaderRegisterElement(temp2.regName, temp2.index);
            registerCache.removeVertexTempUsage(temp);
            var code = "";
            code += "sub " + rev_time + "," + animationRegisterData.vertexOneConst + "," + animationRegisterData.vertexLife + "\n";
            code += "mul " + time_2 + "," + animationRegisterData.vertexLife + "," + animationRegisterData.vertexLife + "\n";
            code += "mul " + time_temp + "," + animationRegisterData.vertexLife + "," + rev_time + "\n";
            code += "mul " + time_temp + "," + time_temp + "," + animationRegisterData.vertexTwoConst + "\n";
            code += "mul " + distance + ".xyz," + time_temp + "," + controlValue + "\n";
            code += "add " + animationRegisterData.positionTarget + ".xyz," + distance + ".xyz," + animationRegisterData.positionTarget + ".xyz\n";
            code += "mul " + distance + ".xyz," + time_2 + "," + endValue + "\n";
            code += "add " + animationRegisterData.positionTarget + ".xyz," + distance + ".xyz," + animationRegisterData.positionTarget + ".xyz\n";
            if (animationSet.needVelocity) {
                code += "mul " + time_2 + "," + animationRegisterData.vertexLife + "," + animationRegisterData.vertexTwoConst + "\n";
                code += "sub " + time_temp + "," + animationRegisterData.vertexOneConst + "," + time_2 + "\n";
                code += "mul " + time_temp + "," + animationRegisterData.vertexTwoConst + "," + time_temp + "\n";
                code += "mul " + distance + ".xyz," + controlValue + "," + time_temp + "\n";
                code += "add " + animationRegisterData.velocityTarget + ".xyz," + distance + ".xyz," + animationRegisterData.velocityTarget + ".xyz\n";
                code += "mul " + distance + ".xyz," + endValue + "," + time_2 + "\n";
                code += "add " + animationRegisterData.velocityTarget + ".xyz," + distance + ".xyz," + animationRegisterData.velocityTarget + ".xyz\n";
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleBezierCurveNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleBezierCurveNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            var bezierControl = param[ParticleBezierCurveNode.BEZIER_CONTROL_VECTOR3D];
            if (!bezierControl)
                throw new Error("there is no " + ParticleBezierCurveNode.BEZIER_CONTROL_VECTOR3D + " in param!");
            var bezierEnd = param[ParticleBezierCurveNode.BEZIER_END_VECTOR3D];
            if (!bezierEnd)
                throw new Error("there is no " + ParticleBezierCurveNode.BEZIER_END_VECTOR3D + " in param!");
            this._pOneData[0] = bezierControl.x;
            this._pOneData[1] = bezierControl.y;
            this._pOneData[2] = bezierControl.z;
            this._pOneData[3] = bezierEnd.x;
            this._pOneData[4] = bezierEnd.y;
            this._pOneData[5] = bezierEnd.z;
        };
        /**
         * Reference for bezier curve node properties on a single particle (when in local property mode).
         * Expects a <code>Vector3D</code> object representing the control point position (0, 1, 2) of the curve.
         */
        ParticleBezierCurveNode.BEZIER_CONTROL_VECTOR3D = "BezierControlVector3D";
        /**
         * Reference for bezier curve node properties on a single particle (when in local property mode).
         * Expects a <code>Vector3D</code> object representing the end point position (0, 1, 2) of the curve.
         */
        ParticleBezierCurveNode.BEZIER_END_VECTOR3D = "BezierEndVector3D";
        return ParticleBezierCurveNode;
    }(ParticleNodeBase));

    /**
     * ...
     */
    var ParticleBillboardState = /** @class */ (function (_super) {
        __extends$5(ParticleBillboardState, _super);
        /**
         *
         */
        function ParticleBillboardState(animator, particleNode) {
            var _this = _super.call(this, animator, particleNode) || this;
            _this._matrix = new Matrix3D;
            _this._billboardAxis = particleNode._iBillboardAxis;
            return _this;
        }
        ParticleBillboardState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            var comps;
            if (this._billboardAxis) {
                var pos = renderable.sourceEntity.transform.concatenatedMatrix3D.position;
                var look = projection.transform.concatenatedMatrix3D.position.subtract(pos);
                var right = look.crossProduct(this._billboardAxis);
                right.normalize();
                look = this.billboardAxis.crossProduct(right);
                look.normalize();
                //create a quick inverse projection matrix
                this._matrix.copyFrom(renderable.sourceEntity.transform.concatenatedMatrix3D);
                comps = this._matrix.decompose(Orientation3D.AXIS_ANGLE);
                this._matrix.copyColumnFrom(0, right);
                this._matrix.copyColumnFrom(1, this.billboardAxis);
                this._matrix.copyColumnFrom(2, look);
                this._matrix.copyColumnFrom(3, pos);
                this._matrix.appendRotation(-comps[1].w * MathConsts.RADIANS_TO_DEGREES, comps[1]);
            }
            else {
                //create a quick inverse projection matrix
                this._matrix.copyFrom(renderable.sourceEntity.transform.concatenatedMatrix3D);
                this._matrix.append(projection.transform.inverseConcatenatedMatrix3D);
                //decompose using axis angle rotations
                comps = this._matrix.decompose(Orientation3D.AXIS_ANGLE);
                //recreate the matrix with just the rotation data
                this._matrix.identity();
                this._matrix.appendRotation(-comps[1].w * MathConsts.RADIANS_TO_DEGREES, comps[1]);
            }
            //set a new matrix transform constant
            shader.setVertexConstFromMatrix(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleBillboardState.MATRIX_INDEX), this._matrix);
        };
        Object.defineProperty(ParticleBillboardState.prototype, "billboardAxis", {
            /**
             * Defines the billboard axis.
             */
            get: function () {
                return this.billboardAxis;
            },
            set: function (value) {
                this.billboardAxis = value ? value.clone() : null;
                if (this.billboardAxis)
                    this.billboardAxis.normalize();
            },
            enumerable: true,
            configurable: true
        });
        /** @private */
        ParticleBillboardState.MATRIX_INDEX = 0;
        return ParticleBillboardState;
    }(ParticleStateBase));

    /**
     * A particle animation node that controls the rotation of a particle to always face the camera.
     */
    var ParticleBillboardNode = /** @class */ (function (_super) {
        __extends$5(ParticleBillboardNode, _super);
        /**
         * Creates a new <code>ParticleBillboardNode</code>
         */
        function ParticleBillboardNode(billboardAxis) {
            if (billboardAxis === void 0) { billboardAxis = null; }
            var _this = _super.call(this, "ParticleBillboard", ParticlePropertiesMode.GLOBAL, 0, 4) || this;
            _this._pStateClass = ParticleBillboardState;
            _this._iBillboardAxis = billboardAxis;
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleBillboardNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var rotationMatrixRegister = registerCache.getFreeVertexConstant();
            animationRegisterData.setRegisterIndex(this, ParticleBillboardState.MATRIX_INDEX, rotationMatrixRegister.index);
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            var temp = registerCache.getFreeVertexVectorTemp();
            var code = "m33 " + temp + ".xyz," + animationRegisterData.scaleAndRotateTarget + "," + rotationMatrixRegister + "\n" +
                "mov " + animationRegisterData.scaleAndRotateTarget + ".xyz," + temp + "\n";
            var shaderRegisterElement;
            for (var i = 0; i < animationRegisterData.rotationRegisters.length; i++) {
                shaderRegisterElement = animationRegisterData.rotationRegisters[i];
                code += "m33 " + temp + ".xyz," + shaderRegisterElement + "," + rotationMatrixRegister + "\n" +
                    "mov " + shaderRegisterElement + ".xyz," + shaderRegisterElement + "\n";
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleBillboardNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleBillboardNode.prototype._iProcessAnimationSetting = function (particleAnimationSet) {
            particleAnimationSet.hasBillboard = true;
        };
        return ParticleBillboardNode;
    }(ParticleNodeBase));

    /**
     * ...
     * @author ...
     */
    var ParticleColorState = /** @class */ (function (_super) {
        __extends$5(ParticleColorState, _super);
        function ParticleColorState(animator, particleColorNode) {
            var _this = _super.call(this, animator, particleColorNode) || this;
            _this._particleColorNode = particleColorNode;
            _this._usesMultiplier = _this._particleColorNode._iUsesMultiplier;
            _this._usesOffset = _this._particleColorNode._iUsesOffset;
            _this._usesCycle = _this._particleColorNode._iUsesCycle;
            _this._usesPhase = _this._particleColorNode._iUsesPhase;
            _this._startColor = _this._particleColorNode._iStartColor;
            _this._endColor = _this._particleColorNode._iEndColor;
            _this._cycleDuration = _this._particleColorNode._iCycleDuration;
            _this._cyclePhase = _this._particleColorNode._iCyclePhase;
            _this.updateColorData();
            return _this;
        }
        Object.defineProperty(ParticleColorState.prototype, "startColor", {
            /**
             * Defines the start color transform of the state, when in global mode.
             */
            get: function () {
                return this._startColor;
            },
            set: function (value) {
                this._startColor = value;
                this.updateColorData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleColorState.prototype, "endColor", {
            /**
             * Defines the end color transform of the state, when in global mode.
             */
            get: function () {
                return this._endColor;
            },
            set: function (value) {
                this._endColor = value;
                this.updateColorData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleColorState.prototype, "cycleDuration", {
            /**
             * Defines the duration of the animation in seconds, used as a period independent of particle duration when in global mode. Defaults to 1.
             */
            get: function () {
                return this._cycleDuration;
            },
            set: function (value) {
                this._cycleDuration = value;
                this.updateColorData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleColorState.prototype, "cyclePhase", {
            /**
             * Defines the phase of the cycle in degrees, used as the starting offset of the cycle when in global mode. Defaults to 0.
             */
            get: function () {
                return this._cyclePhase;
            },
            set: function (value) {
                this._cyclePhase = value;
                this.updateColorData();
            },
            enumerable: true,
            configurable: true
        });
        ParticleColorState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            if (shader.usesFragmentAnimation) {
                var dataOffset = this._particleColorNode._iDataOffset;
                if (this._usesCycle)
                    shader.setVertexConst(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleColorState.CYCLE_INDEX), this._cycleData.x, this._cycleData.y, this._cycleData.z, this._cycleData.w);
                if (this._usesMultiplier) {
                    if (this._particleColorNode.mode == ParticlePropertiesMode.LOCAL_STATIC) {
                        animationElements.activateVertexBuffer(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleColorState.START_MULTIPLIER_INDEX), dataOffset, stage, ContextGLVertexBufferFormat.FLOAT_4);
                        dataOffset += 4;
                        animationElements.activateVertexBuffer(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleColorState.DELTA_MULTIPLIER_INDEX), dataOffset, stage, ContextGLVertexBufferFormat.FLOAT_4);
                        dataOffset += 4;
                    }
                    else {
                        shader.setVertexConst(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleColorState.START_MULTIPLIER_INDEX), this._startMultiplierData.x, this._startMultiplierData.y, this._startMultiplierData.z, this._startMultiplierData.w);
                        shader.setVertexConst(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleColorState.DELTA_MULTIPLIER_INDEX), this._deltaMultiplierData.x, this._deltaMultiplierData.y, this._deltaMultiplierData.z, this._deltaMultiplierData.w);
                    }
                }
                if (this._usesOffset) {
                    if (this._particleColorNode.mode == ParticlePropertiesMode.LOCAL_STATIC) {
                        animationElements.activateVertexBuffer(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleColorState.START_OFFSET_INDEX), dataOffset, stage, ContextGLVertexBufferFormat.FLOAT_4);
                        dataOffset += 4;
                        animationElements.activateVertexBuffer(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleColorState.DELTA_OFFSET_INDEX), dataOffset, stage, ContextGLVertexBufferFormat.FLOAT_4);
                    }
                    else {
                        shader.setVertexConst(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleColorState.START_OFFSET_INDEX), this._startOffsetData.x, this._startOffsetData.y, this._startOffsetData.z, this._startOffsetData.w);
                        shader.setVertexConst(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleColorState.DELTA_OFFSET_INDEX), this._deltaOffsetData.x, this._deltaOffsetData.y, this._deltaOffsetData.z, this._deltaOffsetData.w);
                    }
                }
            }
        };
        ParticleColorState.prototype.updateColorData = function () {
            if (this._usesCycle) {
                if (this._cycleDuration <= 0)
                    throw (new Error("the cycle duration must be greater than zero"));
                this._cycleData = new Vector3D(Math.PI * 2 / this._cycleDuration, this._cyclePhase * Math.PI / 180, 0, 0);
            }
            if (this._particleColorNode.mode == ParticlePropertiesMode.GLOBAL) {
                if (this._usesCycle) {
                    if (this._usesMultiplier) {
                        this._startMultiplierData = new Vector3D((this._startColor.redMultiplier + this._endColor.redMultiplier) / 2, (this._startColor.greenMultiplier + this._endColor.greenMultiplier) / 2, (this._startColor.blueMultiplier + this._endColor.blueMultiplier) / 2, (this._startColor.alphaMultiplier + this._endColor.alphaMultiplier) / 2);
                        this._deltaMultiplierData = new Vector3D((this._endColor.redMultiplier - this._startColor.redMultiplier) / 2, (this._endColor.greenMultiplier - this._startColor.greenMultiplier) / 2, (this._endColor.blueMultiplier - this._startColor.blueMultiplier) / 2, (this._endColor.alphaMultiplier - this._startColor.alphaMultiplier) / 2);
                    }
                    if (this._usesOffset) {
                        this._startOffsetData = new Vector3D((this._startColor.redOffset + this._endColor.redOffset) / (255 * 2), (this._startColor.greenOffset + this._endColor.greenOffset) / (255 * 2), (this._startColor.blueOffset + this._endColor.blueOffset) / (255 * 2), (this._startColor.alphaOffset + this._endColor.alphaOffset) / (255 * 2));
                        this._deltaOffsetData = new Vector3D((this._endColor.redOffset - this._startColor.redOffset) / (255 * 2), (this._endColor.greenOffset - this._startColor.greenOffset) / (255 * 2), (this._endColor.blueOffset - this._startColor.blueOffset) / (255 * 2), (this._endColor.alphaOffset - this._startColor.alphaOffset) / (255 * 2));
                    }
                }
                else {
                    if (this._usesMultiplier) {
                        this._startMultiplierData = new Vector3D(this._startColor.redMultiplier, this._startColor.greenMultiplier, this._startColor.blueMultiplier, this._startColor.alphaMultiplier);
                        this._deltaMultiplierData = new Vector3D((this._endColor.redMultiplier - this._startColor.redMultiplier), (this._endColor.greenMultiplier - this._startColor.greenMultiplier), (this._endColor.blueMultiplier - this._startColor.blueMultiplier), (this._endColor.alphaMultiplier - this._startColor.alphaMultiplier));
                    }
                    if (this._usesOffset) {
                        this._startOffsetData = new Vector3D(this._startColor.redOffset / 255, this._startColor.greenOffset / 255, this._startColor.blueOffset / 255, this._startColor.alphaOffset / 255);
                        this._deltaOffsetData = new Vector3D((this._endColor.redOffset - this._startColor.redOffset) / 255, (this._endColor.greenOffset - this._startColor.greenOffset) / 255, (this._endColor.blueOffset - this._startColor.blueOffset) / 255, (this._endColor.alphaOffset - this._startColor.alphaOffset) / 255);
                    }
                }
            }
        };
        /** @private */
        ParticleColorState.START_MULTIPLIER_INDEX = 0;
        /** @private */
        ParticleColorState.DELTA_MULTIPLIER_INDEX = 1;
        /** @private */
        ParticleColorState.START_OFFSET_INDEX = 2;
        /** @private */
        ParticleColorState.DELTA_OFFSET_INDEX = 3;
        /** @private */
        ParticleColorState.CYCLE_INDEX = 4;
        return ParticleColorState;
    }(ParticleStateBase));

    /**
     * ...
     */
    var ParticleTimeState = /** @class */ (function (_super) {
        __extends$5(ParticleTimeState, _super);
        function ParticleTimeState(animator, particleTimeNode) {
            var _this = _super.call(this, animator, particleTimeNode, true) || this;
            _this._particleTimeNode = particleTimeNode;
            return _this;
        }
        ParticleTimeState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            animationElements.activateVertexBuffer(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleTimeState.TIME_STREAM_INDEX), this._particleTimeNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_4);
            var particleTime = this._pTime / 1000;
            shader.setVertexConst(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleTimeState.TIME_CONSTANT_INDEX), particleTime, particleTime, particleTime, particleTime);
        };
        /** @private */
        ParticleTimeState.TIME_STREAM_INDEX = 0;
        /** @private */
        ParticleTimeState.TIME_CONSTANT_INDEX = 1;
        return ParticleTimeState;
    }(ParticleStateBase));

    /**
     * A particle animation node used as the base node for timekeeping inside a particle. Automatically added to a particle animation set on instatiation.
     */
    var ParticleTimeNode = /** @class */ (function (_super) {
        __extends$5(ParticleTimeNode, _super);
        /**
         * Creates a new <code>ParticleTimeNode</code>
         *
         * @param    [optional] usesDuration    Defines whether the node uses the <code>duration</code> data in the static properties to determine how long a particle is visible for. Defaults to false.
         * @param    [optional] usesDelay       Defines whether the node uses the <code>delay</code> data in the static properties to determine how long a particle is hidden for. Defaults to false. Requires <code>usesDuration</code> to be true.
         * @param    [optional] usesLooping     Defines whether the node creates a looping timeframe for each particle determined by the <code>startTime</code>, <code>duration</code> and <code>delay</code> data in the static properties function. Defaults to false. Requires <code>usesLooping</code> to be true.
         */
        function ParticleTimeNode(usesDuration, usesLooping, usesDelay) {
            if (usesDuration === void 0) { usesDuration = false; }
            if (usesLooping === void 0) { usesLooping = false; }
            if (usesDelay === void 0) { usesDelay = false; }
            var _this = _super.call(this, "ParticleTime", ParticlePropertiesMode.LOCAL_STATIC, 4, 0) || this;
            _this._pStateClass = ParticleTimeState;
            _this._iUsesDuration = usesDuration;
            _this._iUsesLooping = usesLooping;
            _this._iUsesDelay = usesDelay;
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleTimeNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var timeStreamRegister = registerCache.getFreeVertexAttribute(); //timeStreamRegister.x is start，timeStreamRegister.y is during time
            animationRegisterData.setRegisterIndex(this, ParticleTimeState.TIME_STREAM_INDEX, timeStreamRegister.index);
            var timeConst = registerCache.getFreeVertexConstant();
            animationRegisterData.setRegisterIndex(this, ParticleTimeState.TIME_CONSTANT_INDEX, timeConst.index);
            var code = "";
            code += "sub " + animationRegisterData.vertexTime + "," + timeConst + "," + timeStreamRegister + ".x\n";
            //if time=0,set the position to zero.
            var temp = registerCache.getFreeVertexSingleTemp();
            code += "sge " + temp + "," + animationRegisterData.vertexTime + "," + animationRegisterData.vertexZeroConst + "\n";
            code += "mul " + animationRegisterData.scaleAndRotateTarget + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz," + temp + "\n";
            if (this._iUsesDuration) {
                if (this._iUsesLooping) {
                    var div = registerCache.getFreeVertexSingleTemp();
                    if (this._iUsesDelay) {
                        code += "div " + div + "," + animationRegisterData.vertexTime + "," + timeStreamRegister + ".z\n";
                        code += "frc " + div + "," + div + "\n";
                        code += "mul " + animationRegisterData.vertexTime + "," + div + "," + timeStreamRegister + ".z\n";
                        code += "slt " + div + "," + animationRegisterData.vertexTime + "," + timeStreamRegister + ".y\n";
                        code += "mul " + animationRegisterData.scaleAndRotateTarget + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz," + div + "\n";
                    }
                    else {
                        code += "mul " + div + "," + animationRegisterData.vertexTime + "," + timeStreamRegister + ".w\n";
                        code += "frc " + div + "," + div + "\n";
                        code += "mul " + animationRegisterData.vertexTime + "," + div + "," + timeStreamRegister + ".y\n";
                    }
                }
                else {
                    var sge = registerCache.getFreeVertexSingleTemp();
                    code += "sge " + sge + "," + timeStreamRegister + ".y," + animationRegisterData.vertexTime + "\n";
                    code += "mul " + animationRegisterData.scaleAndRotateTarget + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz," + sge + "\n";
                }
            }
            code += "mul " + animationRegisterData.vertexLife + "," + animationRegisterData.vertexTime + "," + timeStreamRegister + ".w\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleTimeNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleTimeNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            this._pOneData[0] = param.startTime;
            this._pOneData[1] = param.duration;
            this._pOneData[2] = param.delay + param.duration;
            this._pOneData[3] = 1 / param.duration;
        };
        return ParticleTimeNode;
    }(ParticleNodeBase));

    var AnimationSetError = /** @class */ (function (_super) {
        __extends$5(AnimationSetError, _super);
        function AnimationSetError(message) {
            return _super.call(this, message) || this;
        }
        return AnimationSetError;
    }(ErrorBase));

    /**
     * Provides an abstract base class for data set classes that hold animation data for use in animator classes.
     *
     * @see away.animators.AnimatorBase
     */
    var AnimationSetBase = /** @class */ (function (_super) {
        __extends$5(AnimationSetBase, _super);
        function AnimationSetBase() {
            var _this = _super.call(this) || this;
            _this._animations = new Array();
            _this._animationNames = new Array();
            _this._animationDictionary = new Object();
            return _this;
        }
        /**
         * Retrieves a temporary GPU register that's still free.
         *
         * @param exclude An array of non-free temporary registers.
         * @param excludeAnother An additional register that's not free.
         * @return A temporary register that can be used.
         */
        AnimationSetBase.prototype._pFindTempReg = function (exclude, excludeAnother) {
            if (excludeAnother === void 0) { excludeAnother = null; }
            var i = 0;
            var reg;
            while (true) {
                reg = "vt" + i;
                if (exclude.indexOf(reg) == -1 && excludeAnother != reg)
                    return reg;
                ++i;
            }
        };
        Object.defineProperty(AnimationSetBase.prototype, "usesCPU", {
            /**
             * Indicates whether the properties of the animation data contained within the set combined with
             * the vertex registers already in use on shading materials allows the animation data to utilise
             * GPU calls.
             */
            get: function () {
                return this._usesCPU;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Called by the material to reset the GPU indicator before testing whether register space in the shader
         * is available for running GPU-based animation code.
         *
         * @private
         */
        AnimationSetBase.prototype.resetGPUCompatibility = function () {
            this._usesCPU = false;
        };
        AnimationSetBase.prototype.cancelGPUCompatibility = function () {
            this._usesCPU = true;
        };
        /**
         * @inheritDoc
         */
        AnimationSetBase.prototype.getAGALVertexCode = function (shader, registerCache, sharedRegisters) {
            throw new AbstractMethodError();
        };
        /**
         * @inheritDoc
         */
        AnimationSetBase.prototype.getAGALFragmentCode = function (shader, registerCache, shadedTarget) {
            throw new AbstractMethodError();
        };
        /**
         * @inheritDoc
         */
        AnimationSetBase.prototype.getAGALUVCode = function (shader, registerCache, sharedRegisters) {
            throw new AbstractMethodError();
        };
        /**
         * @inheritDoc
         */
        AnimationSetBase.prototype.doneAGALCode = function (shader) {
            throw new AbstractMethodError();
        };
        Object.defineProperty(AnimationSetBase.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return AnimationSetBase.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationSetBase.prototype, "animations", {
            /**
             * Returns a vector of animation state objects that make up the contents of the animation data set.
             */
            get: function () {
                return this._animations;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationSetBase.prototype, "animationNames", {
            /**
             * Returns a vector of animation state objects that make up the contents of the animation data set.
             */
            get: function () {
                return this._animationNames;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Check to determine whether a state is registered in the animation set under the given name.
         *
         * @param stateName The name of the animation state object to be checked.
         */
        AnimationSetBase.prototype.hasAnimation = function (name) {
            return this._animationDictionary[name] != null;
        };
        /**
         * Retrieves the animation state object registered in the animation data set under the given name.
         *
         * @param stateName The name of the animation state object to be retrieved.
         */
        AnimationSetBase.prototype.getAnimation = function (name) {
            return this._animationDictionary[name];
        };
        /**
         * Adds an animation state object to the aniamtion data set under the given name.
         *
         * @param stateName The name under which the animation state object will be stored.
         * @param animationState The animation state object to be staored in the set.
         */
        AnimationSetBase.prototype.addAnimation = function (node) {
            if (this._animationDictionary[node.name])
                throw new AnimationSetError("root node name '" + node.name + "' already exists in the set");
            this._animationDictionary[node.name] = node;
            this._animations.push(node);
            this._animationNames.push(node.name);
        };
        /**
         * Cleans up any resources used by the current object.
         */
        AnimationSetBase.prototype.dispose = function () {
        };
        AnimationSetBase.assetType = "[asset AnimationSet]";
        return AnimationSetBase;
    }(AssetBase));

    /**
     * The animation data set used by particle-based animators, containing particle animation data.
     *
     * @see away.animators.ParticleAnimator
     */
    var ParticleAnimationSet = /** @class */ (function (_super) {
        __extends$5(ParticleAnimationSet, _super);
        /**
         * Creates a new <code>ParticleAnimationSet</code>
         *
         * @param    [optional] usesDuration    Defines whether the animation set uses the <code>duration</code> data in its static properties to determine how long a particle is visible for. Defaults to false.
         * @param    [optional] usesLooping     Defines whether the animation set uses a looping timeframe for each particle determined by the <code>startTime</code>, <code>duration</code> and <code>delay</code> data in its static properties function. Defaults to false. Requires <code>usesDuration</code> to be true.
         * @param    [optional] usesDelay       Defines whether the animation set uses the <code>delay</code> data in its static properties to determine how long a particle is hidden for. Defaults to false. Requires <code>usesLooping</code> to be true.
         */
        function ParticleAnimationSet(usesDuration, usesLooping, usesDelay) {
            if (usesDuration === void 0) { usesDuration = false; }
            if (usesLooping === void 0) { usesLooping = false; }
            if (usesDelay === void 0) { usesDelay = false; }
            var _this = _super.call(this) || this;
            _this._animationElements = new Object();
            _this._particleNodes = new Array();
            _this._localDynamicNodes = new Array();
            _this._localStaticNodes = new Array();
            _this._totalLenOfOneVertex = 0;
            //automatically add a particle time node to the set
            _this.addAnimation(_this._timeNode = new ParticleTimeNode(usesDuration, usesLooping, usesDelay));
            return _this;
        }
        Object.defineProperty(ParticleAnimationSet.prototype, "particleNodes", {
            /**
             * Returns a vector of the particle animation nodes contained within the set.
             */
            get: function () {
                return this._particleNodes;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        ParticleAnimationSet.prototype.addAnimation = function (node) {
            var i;
            var n = node;
            n._iProcessAnimationSetting(this);
            if (n.mode == ParticlePropertiesMode.LOCAL_STATIC) {
                n._iDataOffset = this._totalLenOfOneVertex;
                this._totalLenOfOneVertex += n.dataLength;
                this._localStaticNodes.push(n);
            }
            else if (n.mode == ParticlePropertiesMode.LOCAL_DYNAMIC)
                this._localDynamicNodes.push(n);
            for (i = this._particleNodes.length - 1; i >= 0; i--) {
                if (this._particleNodes[i].priority <= n.priority)
                    break;
            }
            this._particleNodes.splice(i + 1, 0, n);
            _super.prototype.addAnimation.call(this, node);
        };
        /**
         * @inheritDoc
         */
        ParticleAnimationSet.prototype.getAGALVertexCode = function (shader, registerCache, sharedRegisters) {
            //grab animationRegisterData from the materialpassbase or create a new one if the first time
            this._iAnimationRegisterData = shader.animationRegisterData;
            if (this._iAnimationRegisterData == null)
                this._iAnimationRegisterData = shader.animationRegisterData = new AnimationRegisterData();
            //reset animationRegisterData
            this._iAnimationRegisterData.reset(registerCache, sharedRegisters, this.needVelocity);
            var code = "";
            var len = sharedRegisters.animatableAttributes.length;
            for (var i = 0; i < len; i++)
                code += "mov " + sharedRegisters.animationTargetRegisters[i] + "," + sharedRegisters.animatableAttributes[i] + "\n";
            code += "mov " + this._iAnimationRegisterData.positionTarget + ".xyz," + this._iAnimationRegisterData.vertexZeroConst + "\n";
            if (this.needVelocity)
                code += "mov " + this._iAnimationRegisterData.velocityTarget + ".xyz," + this._iAnimationRegisterData.vertexZeroConst + "\n";
            var node;
            var i;
            for (i = 0; i < this._particleNodes.length; i++) {
                node = this._particleNodes[i];
                if (node.priority < ParticleAnimationSet.POST_PRIORITY)
                    code += node.getAGALVertexCode(shader, this, registerCache, this._iAnimationRegisterData);
            }
            code += "add " + this._iAnimationRegisterData.scaleAndRotateTarget + ".xyz," + this._iAnimationRegisterData.scaleAndRotateTarget + ".xyz," + this._iAnimationRegisterData.positionTarget + ".xyz\n";
            for (i = 0; i < this._particleNodes.length; i++) {
                node = this._particleNodes[i];
                if (node.priority >= ParticleAnimationSet.POST_PRIORITY && node.priority < ParticleAnimationSet.COLOR_PRIORITY)
                    code += node.getAGALVertexCode(shader, this, registerCache, this._iAnimationRegisterData);
            }
            if (this.hasColorMulNode) {
                this._iAnimationRegisterData.colorMulTarget = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(this._iAnimationRegisterData.colorMulTarget, 1);
                this._iAnimationRegisterData.colorMulVary = registerCache.getFreeVarying();
                code += "mov " + this._iAnimationRegisterData.colorMulTarget + "," + this._iAnimationRegisterData.vertexOneConst + "\n";
            }
            if (this.hasColorAddNode) {
                this._iAnimationRegisterData.colorAddTarget = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(this._iAnimationRegisterData.colorAddTarget, 1);
                this._iAnimationRegisterData.colorAddVary = registerCache.getFreeVarying();
                code += "mov " + this._iAnimationRegisterData.colorAddTarget + "," + this._iAnimationRegisterData.vertexZeroConst + "\n";
            }
            for (i = 0; i < this._particleNodes.length; i++) {
                node = this._particleNodes[i];
                if (node.priority >= ParticleAnimationSet.COLOR_PRIORITY)
                    code += node.getAGALVertexCode(shader, this, registerCache, this._iAnimationRegisterData);
            }
            if (shader.usesFragmentAnimation && (this.hasColorAddNode || this.hasColorMulNode)) {
                if (this.hasColorMulNode)
                    code += "mov " + this._iAnimationRegisterData.colorMulVary + "," + this._iAnimationRegisterData.colorMulTarget + "\n";
                if (this.hasColorAddNode)
                    code += "mov " + this._iAnimationRegisterData.colorAddVary + "," + this._iAnimationRegisterData.colorAddTarget + "\n";
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleAnimationSet.prototype.getAGALUVCode = function (shader, registerCache, sharedRegisters) {
            var code = "";
            if (this.hasUVNode) {
                this._iAnimationRegisterData.setUVSourceAndTarget(sharedRegisters);
                code += "mov " + this._iAnimationRegisterData.uvTarget + ".xy," + this._iAnimationRegisterData.uvAttribute.toString() + "\n";
                var node;
                for (var i = 0; i < this._particleNodes.length; i++)
                    node = this._particleNodes[i];
                code += node.getAGALUVCode(shader, this, registerCache, this._iAnimationRegisterData);
                code += "mov " + this._iAnimationRegisterData.uvVar + "," + this._iAnimationRegisterData.uvTarget + ".xy\n";
            }
            else
                code += "mov " + sharedRegisters.animatedUV + "," + sharedRegisters.uvInput + "\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleAnimationSet.prototype.getAGALFragmentCode = function (shader, registerCache, shadedTarget) {
            var code = "";
            if (shader.usesFragmentAnimation && (this.hasColorAddNode || this.hasColorMulNode)) {
                if (this.hasColorMulNode)
                    code += "mul " + shadedTarget + "," + shadedTarget + "," + this._iAnimationRegisterData.colorMulVary + "\n";
                if (this.hasColorAddNode)
                    code += "add " + shadedTarget + "," + shadedTarget + "," + this._iAnimationRegisterData.colorAddVary + "\n";
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleAnimationSet.prototype.doneAGALCode = function (shader) {
            //set vertexZeroConst,vertexOneConst,vertexTwoConst
            shader.setVertexConst(this._iAnimationRegisterData.vertexZeroConst.index, 0, 1, 2, 0);
        };
        Object.defineProperty(ParticleAnimationSet.prototype, "usesCPU", {
            /**
             * @inheritDoc
             */
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        ParticleAnimationSet.prototype.cancelGPUCompatibility = function () {
        };
        ParticleAnimationSet.prototype.dispose = function () {
            for (var key in this._animationElements)
                this._animationElements[key].dispose();
            _super.prototype.dispose.call(this);
        };
        ParticleAnimationSet.prototype.getAnimationElements = function (particleCollection, elements) {
            var animationElements = this._animationElements[elements.id];
            if (animationElements)
                return animationElements;
            this._iGenerateAnimationElements(particleCollection);
            return this._animationElements[elements.id];
        };
        /** @private */
        ParticleAnimationSet.prototype._iGenerateAnimationElements = function (particleCollection) {
            if (this.initParticleFunc == null)
                throw (new Error("no initParticleFunc set"));
            var i, j, k;
            var animationElements;
            var newAnimationElements = false;
            var elements;
            var localNode;
            for (i = 0; i < particleCollection.numElements; i++) {
                elements = particleCollection.elements[i];
                if (this._animationElements[elements.id])
                    continue;
                animationElements = this._animationElements[elements.id] = new AnimationElements();
                //create the vertexData vector that will be used for local node data
                animationElements.createVertexData(elements.numVertices, this._totalLenOfOneVertex);
                newAnimationElements = true;
            }
            if (!newAnimationElements)
                return;
            var particles = particleCollection.particles;
            var particlesLength = particles.length;
            var numParticles = particleCollection.numParticles;
            var particleProperties = new ParticleProperties();
            var particle;
            var oneDataLen;
            var oneDataOffset;
            var counterForVertex;
            var counterForOneData;
            var oneData;
            var numVertices;
            var vertexData;
            var vertexLength;
            var startingOffset;
            var vertexOffset;
            //default values for particle param
            particleProperties.total = numParticles;
            particleProperties.startTime = 0;
            particleProperties.duration = 1000;
            particleProperties.delay = 0.1;
            i = 0;
            j = 0;
            while (i < numParticles) {
                particleProperties.index = i;
                //call the init on the particle parameters
                this.initParticleFunc.call(this.initParticleScope, particleProperties);
                //create the next set of node properties for the particle
                for (k = 0; k < this._localStaticNodes.length; k++)
                    this._localStaticNodes[k]._iGeneratePropertyOfOneParticle(particleProperties);
                //loop through all particle data for the curent particle
                while (j < particlesLength && (particle = particles[j]).particleIndex == i) {
                    //find the target animationElements
                    for (k = 0; k < particleCollection.numElements; k++) {
                        elements = particleCollection.elements[k];
                        if (elements == particle.elements) {
                            animationElements = this._animationElements[elements.id];
                            break;
                        }
                    }
                    numVertices = particle.numVertices;
                    vertexData = animationElements.vertexData;
                    vertexLength = numVertices * this._totalLenOfOneVertex;
                    startingOffset = animationElements.numProcessedVertices * this._totalLenOfOneVertex;
                    //loop through each static local node in the animation set
                    for (k = 0; k < this._localStaticNodes.length; k++) {
                        localNode = this._localStaticNodes[k];
                        oneData = localNode.oneData;
                        oneDataLen = localNode.dataLength;
                        oneDataOffset = startingOffset + localNode._iDataOffset;
                        //loop through each vertex set in the vertex data
                        for (counterForVertex = 0; counterForVertex < vertexLength; counterForVertex += this._totalLenOfOneVertex) {
                            vertexOffset = oneDataOffset + counterForVertex;
                            //add the data for the local node to the vertex data
                            for (counterForOneData = 0; counterForOneData < oneDataLen; counterForOneData++)
                                vertexData[vertexOffset + counterForOneData] = oneData[counterForOneData];
                        }
                    }
                    //store particle properties if they need to be retreived for dynamic local nodes
                    if (this._localDynamicNodes.length)
                        animationElements.animationParticles.push(new ParticleAnimationData(i, particleProperties.startTime, particleProperties.duration, particleProperties.delay, particle));
                    animationElements.numProcessedVertices += numVertices;
                    //next index
                    j++;
                }
                //next particle
                i++;
            }
        };
        /**
         * Property used by particle nodes that require compilers at the end of the shader
         */
        ParticleAnimationSet.POST_PRIORITY = 9;
        /**
         * Property used by particle nodes that require color compilers
         */
        ParticleAnimationSet.COLOR_PRIORITY = 18;
        return ParticleAnimationSet;
    }(AnimationSetBase));

    /**
     * A particle animation node used to control the color variation of a particle over time.
     */
    var ParticleColorNode = /** @class */ (function (_super) {
        __extends$5(ParticleColorNode, _super);
        /**
         * Creates a new <code>ParticleColorNode</code>
         *
         * @param               mode            Defines whether the mode of operation acts on local properties of a particle or global properties of the node.
         * @param    [optional] usesMultiplier  Defines whether the node uses multiplier data in the shader for its color transformations. Defaults to true.
         * @param    [optional] usesOffset      Defines whether the node uses offset data in the shader for its color transformations. Defaults to true.
         * @param    [optional] usesCycle       Defines whether the node uses the <code>cycleDuration</code> property in the shader to calculate the period of the animation independent of particle duration. Defaults to false.
         * @param    [optional] usesPhase       Defines whether the node uses the <code>cyclePhase</code> property in the shader to calculate a starting offset to the cycle rotation of the particle. Defaults to false.
         * @param    [optional] startColor      Defines the default start color transform of the node, when in global mode.
         * @param    [optional] endColor        Defines the default end color transform of the node, when in global mode.
         * @param    [optional] cycleDuration   Defines the duration of the animation in seconds, used as a period independent of particle duration when in global mode. Defaults to 1.
         * @param    [optional] cyclePhase      Defines the phase of the cycle in degrees, used as the starting offset of the cycle when in global mode. Defaults to 0.
         */
        function ParticleColorNode(mode, usesMultiplier, usesOffset, usesCycle, usesPhase, startColor, endColor, cycleDuration, cyclePhase) {
            if (usesMultiplier === void 0) { usesMultiplier = true; }
            if (usesOffset === void 0) { usesOffset = true; }
            if (usesCycle === void 0) { usesCycle = false; }
            if (usesPhase === void 0) { usesPhase = false; }
            if (startColor === void 0) { startColor = null; }
            if (endColor === void 0) { endColor = null; }
            if (cycleDuration === void 0) { cycleDuration = 1; }
            if (cyclePhase === void 0) { cyclePhase = 0; }
            var _this = _super.call(this, "ParticleColor", mode, (usesMultiplier && usesOffset) ? 16 : 8, ParticleAnimationSet.COLOR_PRIORITY) || this;
            _this._pStateClass = ParticleColorState;
            _this._iUsesMultiplier = usesMultiplier;
            _this._iUsesOffset = usesOffset;
            _this._iUsesCycle = usesCycle;
            _this._iUsesPhase = usesPhase;
            _this._iStartColor = startColor || new ColorTransform();
            _this._iEndColor = endColor || new ColorTransform();
            _this._iCycleDuration = cycleDuration;
            _this._iCyclePhase = cyclePhase;
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleColorNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var code = "";
            if (shader.usesFragmentAnimation) {
                var temp = registerCache.getFreeVertexVectorTemp();
                if (this._iUsesCycle) {
                    var cycleConst = registerCache.getFreeVertexConstant();
                    animationRegisterData.setRegisterIndex(this, ParticleColorState.CYCLE_INDEX, cycleConst.index);
                    registerCache.addVertexTempUsages(temp, 1);
                    var sin = registerCache.getFreeVertexSingleTemp();
                    registerCache.removeVertexTempUsage(temp);
                    code += "mul " + sin + "," + animationRegisterData.vertexTime + "," + cycleConst + ".x\n";
                    if (this._iUsesPhase)
                        code += "add " + sin + "," + sin + "," + cycleConst + ".y\n";
                    code += "sin " + sin + "," + sin + "\n";
                }
                if (this._iUsesMultiplier) {
                    var startMultiplierValue = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
                    var deltaMultiplierValue = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
                    animationRegisterData.setRegisterIndex(this, ParticleColorState.START_MULTIPLIER_INDEX, startMultiplierValue.index);
                    animationRegisterData.setRegisterIndex(this, ParticleColorState.DELTA_MULTIPLIER_INDEX, deltaMultiplierValue.index);
                    code += "mul " + temp + "," + deltaMultiplierValue + "," + (this._iUsesCycle ? sin : animationRegisterData.vertexLife) + "\n";
                    code += "add " + temp + "," + temp + "," + startMultiplierValue + "\n";
                    code += "mul " + animationRegisterData.colorMulTarget + "," + temp + "," + animationRegisterData.colorMulTarget + "\n";
                }
                if (this._iUsesOffset) {
                    var startOffsetValue = (this._pMode == ParticlePropertiesMode.LOCAL_STATIC) ? registerCache.getFreeVertexAttribute() : registerCache.getFreeVertexConstant();
                    var deltaOffsetValue = (this._pMode == ParticlePropertiesMode.LOCAL_STATIC) ? registerCache.getFreeVertexAttribute() : registerCache.getFreeVertexConstant();
                    animationRegisterData.setRegisterIndex(this, ParticleColorState.START_OFFSET_INDEX, startOffsetValue.index);
                    animationRegisterData.setRegisterIndex(this, ParticleColorState.DELTA_OFFSET_INDEX, deltaOffsetValue.index);
                    code += "mul " + temp + "," + deltaOffsetValue + "," + (this._iUsesCycle ? sin : animationRegisterData.vertexLife) + "\n";
                    code += "add " + temp + "," + temp + "," + startOffsetValue + "\n";
                    code += "add " + animationRegisterData.colorAddTarget + "," + temp + "," + animationRegisterData.colorAddTarget + "\n";
                }
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleColorNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleColorNode.prototype._iProcessAnimationSetting = function (particleAnimationSet) {
            if (this._iUsesMultiplier)
                particleAnimationSet.hasColorMulNode = true;
            if (this._iUsesOffset)
                particleAnimationSet.hasColorAddNode = true;
        };
        /**
         * @inheritDoc
         */
        ParticleColorNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            var startColor = param[ParticleColorNode.COLOR_START_COLORTRANSFORM];
            if (!startColor)
                throw (new Error("there is no " + ParticleColorNode.COLOR_START_COLORTRANSFORM + " in param!"));
            var endColor = param[ParticleColorNode.COLOR_END_COLORTRANSFORM];
            if (!endColor)
                throw (new Error("there is no " + ParticleColorNode.COLOR_END_COLORTRANSFORM + " in param!"));
            var i = 0;
            if (!this._iUsesCycle) {
                //multiplier
                if (this._iUsesMultiplier) {
                    this._pOneData[i++] = startColor.redMultiplier;
                    this._pOneData[i++] = startColor.greenMultiplier;
                    this._pOneData[i++] = startColor.blueMultiplier;
                    this._pOneData[i++] = startColor.alphaMultiplier;
                    this._pOneData[i++] = endColor.redMultiplier - startColor.redMultiplier;
                    this._pOneData[i++] = endColor.greenMultiplier - startColor.greenMultiplier;
                    this._pOneData[i++] = endColor.blueMultiplier - startColor.blueMultiplier;
                    this._pOneData[i++] = endColor.alphaMultiplier - startColor.alphaMultiplier;
                }
                //offset
                if (this._iUsesOffset) {
                    this._pOneData[i++] = startColor.redOffset / 255;
                    this._pOneData[i++] = startColor.greenOffset / 255;
                    this._pOneData[i++] = startColor.blueOffset / 255;
                    this._pOneData[i++] = startColor.alphaOffset / 255;
                    this._pOneData[i++] = (endColor.redOffset - startColor.redOffset) / 255;
                    this._pOneData[i++] = (endColor.greenOffset - startColor.greenOffset) / 255;
                    this._pOneData[i++] = (endColor.blueOffset - startColor.blueOffset) / 255;
                    this._pOneData[i++] = (endColor.alphaOffset - startColor.alphaOffset) / 255;
                }
            }
            else {
                //multiplier
                if (this._iUsesMultiplier) {
                    this._pOneData[i++] = (startColor.redMultiplier + endColor.redMultiplier) / 2;
                    this._pOneData[i++] = (startColor.greenMultiplier + endColor.greenMultiplier) / 2;
                    this._pOneData[i++] = (startColor.blueMultiplier + endColor.blueMultiplier) / 2;
                    this._pOneData[i++] = (startColor.alphaMultiplier + endColor.alphaMultiplier) / 2;
                    this._pOneData[i++] = (startColor.redMultiplier - endColor.redMultiplier) / 2;
                    this._pOneData[i++] = (startColor.greenMultiplier - endColor.greenMultiplier) / 2;
                    this._pOneData[i++] = (startColor.blueMultiplier - endColor.blueMultiplier) / 2;
                    this._pOneData[i++] = (startColor.alphaMultiplier - endColor.alphaMultiplier) / 2;
                }
                //offset
                if (this._iUsesOffset) {
                    this._pOneData[i++] = (startColor.redOffset + endColor.redOffset) / (255 * 2);
                    this._pOneData[i++] = (startColor.greenOffset + endColor.greenOffset) / (255 * 2);
                    this._pOneData[i++] = (startColor.blueOffset + endColor.blueOffset) / (255 * 2);
                    this._pOneData[i++] = (startColor.alphaOffset + endColor.alphaOffset) / (255 * 2);
                    this._pOneData[i++] = (startColor.redOffset - endColor.redOffset) / (255 * 2);
                    this._pOneData[i++] = (startColor.greenOffset - endColor.greenOffset) / (255 * 2);
                    this._pOneData[i++] = (startColor.blueOffset - endColor.blueOffset) / (255 * 2);
                    this._pOneData[i++] = (startColor.alphaOffset - endColor.alphaOffset) / (255 * 2);
                }
            }
        };
        /**
         * Reference for color node properties on a single particle (when in local property mode).
         * Expects a <code>ColorTransform</code> object representing the start color transform applied to the particle.
         */
        ParticleColorNode.COLOR_START_COLORTRANSFORM = "ColorStartColorTransform";
        /**
         * Reference for color node properties on a single particle (when in local property mode).
         * Expects a <code>ColorTransform</code> object representing the end color transform applied to the particle.
         */
        ParticleColorNode.COLOR_END_COLORTRANSFORM = "ColorEndColorTransform";
        return ParticleColorNode;
    }(ParticleNodeBase));

    /**
     * ...
     */
    var ParticleFollowState = /** @class */ (function (_super) {
        __extends$5(ParticleFollowState, _super);
        function ParticleFollowState(animator, particleFollowNode) {
            var _this = _super.call(this, animator, particleFollowNode, true) || this;
            _this._targetPos = new Vector3D();
            _this._targetEuler = new Vector3D();
            //temporary vector3D for calculation
            _this._temp = new Vector3D();
            _this._particleFollowNode = particleFollowNode;
            _this._smooth = particleFollowNode._iSmooth;
            return _this;
        }
        Object.defineProperty(ParticleFollowState.prototype, "followTarget", {
            get: function () {
                return this._followTarget;
            },
            set: function (value) {
                this._followTarget = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleFollowState.prototype, "smooth", {
            get: function () {
                return this._smooth;
            },
            set: function (value) {
                this._smooth = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        ParticleFollowState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            if (this._followTarget) {
                if (this._particleFollowNode._iUsesPosition) {
                    this._targetPos.x = this._followTarget.transform.position.x / renderable.sourceEntity.transform.scale.x;
                    this._targetPos.y = this._followTarget.transform.position.y / renderable.sourceEntity.transform.scale.y;
                    this._targetPos.z = this._followTarget.transform.position.z / renderable.sourceEntity.transform.scale.z;
                }
                if (this._particleFollowNode._iUsesRotation) {
                    this._targetEuler.x = this._followTarget.transform.rotation.x;
                    this._targetEuler.y = this._followTarget.transform.rotation.y;
                    this._targetEuler.z = this._followTarget.transform.rotation.z;
                }
            }
            //initialization
            if (!this._prePos)
                this._prePos = this._targetPos.clone();
            if (!this._preEuler)
                this._preEuler = this._targetEuler.clone();
            var currentTime = this._pTime / 1000;
            var previousTime = animationElements.previousTime;
            var deltaTime = currentTime - previousTime;
            var needProcess = previousTime != currentTime;
            if (this._particleFollowNode._iUsesPosition && this._particleFollowNode._iUsesRotation) {
                if (needProcess)
                    this.processPositionAndRotation(currentTime, deltaTime, animationElements);
                animationElements.activateVertexBuffer(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleFollowState.FOLLOW_POSITION_INDEX), this._particleFollowNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_3);
                animationElements.activateVertexBuffer(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleFollowState.FOLLOW_ROTATION_INDEX), this._particleFollowNode._iDataOffset + 3, stage, ContextGLVertexBufferFormat.FLOAT_3);
            }
            else if (this._particleFollowNode._iUsesPosition) {
                if (needProcess)
                    this.processPosition(currentTime, deltaTime, animationElements);
                animationElements.activateVertexBuffer(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleFollowState.FOLLOW_POSITION_INDEX), this._particleFollowNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_3);
            }
            else if (this._particleFollowNode._iUsesRotation) {
                if (needProcess)
                    this.precessRotation(currentTime, deltaTime, animationElements);
                animationElements.activateVertexBuffer(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleFollowState.FOLLOW_ROTATION_INDEX), this._particleFollowNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_3);
            }
            this._prePos.copyFrom(this._targetPos);
            this._targetEuler.copyFrom(this._targetEuler);
            animationElements.previousTime = currentTime;
        };
        ParticleFollowState.prototype.processPosition = function (currentTime, deltaTime, animationElements) {
            var data = animationElements.animationParticles;
            var vertexData = animationElements.vertexData;
            var changed = false;
            var len = data.length;
            var interpolatedPos;
            var posVelocity;
            if (this._smooth) {
                posVelocity = this._prePos.subtract(this._targetPos);
                posVelocity.scaleBy(1 / deltaTime);
            }
            else
                interpolatedPos = this._targetPos;
            for (var i = 0; i < len; i++) {
                var k = (currentTime - data[i].startTime) / data[i].totalTime;
                var t = (k - Math.floor(k)) * data[i].totalTime;
                if (t - deltaTime <= 0) {
                    var inc = data[i].startVertexIndex * animationElements.totalLenOfOneVertex + this._particleFollowNode._iDataOffset;
                    if (this._smooth) {
                        this._temp.copyFrom(posVelocity);
                        this._temp.scaleBy(t);
                        interpolatedPos = this._targetPos.add(this._temp);
                    }
                    if (vertexData[inc] != interpolatedPos.x || vertexData[inc + 1] != interpolatedPos.y || vertexData[inc + 2] != interpolatedPos.z) {
                        changed = true;
                        for (var j = 0; j < data[i].numVertices; j++) {
                            vertexData[inc++] = interpolatedPos.x;
                            vertexData[inc++] = interpolatedPos.y;
                            vertexData[inc++] = interpolatedPos.z;
                        }
                    }
                }
            }
            if (changed)
                animationElements.invalidateBuffer();
        };
        ParticleFollowState.prototype.precessRotation = function (currentTime, deltaTime, animationElements) {
            var data = animationElements.animationParticles;
            var vertexData = animationElements.vertexData;
            var changed = false;
            var len = data.length;
            var interpolatedRotation;
            var rotationVelocity;
            if (this._smooth) {
                rotationVelocity = this._preEuler.subtract(this._targetEuler);
                rotationVelocity.scaleBy(1 / deltaTime);
            }
            else
                interpolatedRotation = this._targetEuler;
            for (var i = 0; i < len; i++) {
                var k = (currentTime - data[i].startTime) / data[i].totalTime;
                var t = (k - Math.floor(k)) * data[i].totalTime;
                if (t - deltaTime <= 0) {
                    var inc = data[i].startVertexIndex * animationElements.totalLenOfOneVertex + this._particleFollowNode._iDataOffset;
                    if (this._smooth) {
                        this._temp.copyFrom(rotationVelocity);
                        this._temp.scaleBy(t);
                        interpolatedRotation = this._targetEuler.add(this._temp);
                    }
                    if (vertexData[inc] != interpolatedRotation.x || vertexData[inc + 1] != interpolatedRotation.y || vertexData[inc + 2] != interpolatedRotation.z) {
                        changed = true;
                        for (var j = 0; j < data[i].numVertices; j++) {
                            vertexData[inc++] = interpolatedRotation.x;
                            vertexData[inc++] = interpolatedRotation.y;
                            vertexData[inc++] = interpolatedRotation.z;
                        }
                    }
                }
            }
            if (changed)
                animationElements.invalidateBuffer();
        };
        ParticleFollowState.prototype.processPositionAndRotation = function (currentTime, deltaTime, animationElements) {
            var data = animationElements.animationParticles;
            var vertexData = animationElements.vertexData;
            var changed = false;
            var len = data.length;
            var interpolatedPos;
            var interpolatedRotation;
            var posVelocity;
            var rotationVelocity;
            if (this._smooth) {
                posVelocity = this._prePos.subtract(this._targetPos);
                posVelocity.scaleBy(1 / deltaTime);
                rotationVelocity = this._preEuler.subtract(this._targetEuler);
                rotationVelocity.scaleBy(1 / deltaTime);
            }
            else {
                interpolatedPos = this._targetPos;
                interpolatedRotation = this._targetEuler;
            }
            for (var i = 0; i < len; i++) {
                var k = (currentTime - data[i].startTime) / data[i].totalTime;
                var t = (k - Math.floor(k)) * data[i].totalTime;
                if (t - deltaTime <= 0) {
                    var inc = data[i].startVertexIndex * animationElements.totalLenOfOneVertex + this._particleFollowNode._iDataOffset;
                    if (this._smooth) {
                        this._temp.copyFrom(posVelocity);
                        this._temp.scaleBy(t);
                        interpolatedPos = this._targetPos.add(this._temp);
                        this._temp.copyFrom(rotationVelocity);
                        this._temp.scaleBy(t);
                        interpolatedRotation = this._targetEuler.add(this._temp);
                    }
                    if (vertexData[inc] != interpolatedPos.x || vertexData[inc + 1] != interpolatedPos.y || vertexData[inc + 2] != interpolatedPos.z || vertexData[inc + 3] != interpolatedRotation.x || vertexData[inc + 4] != interpolatedRotation.y || vertexData[inc + 5] != interpolatedRotation.z) {
                        changed = true;
                        for (var j = 0; j < data[i].numVertices; j++) {
                            vertexData[inc++] = interpolatedPos.x;
                            vertexData[inc++] = interpolatedPos.y;
                            vertexData[inc++] = interpolatedPos.z;
                            vertexData[inc++] = interpolatedRotation.x;
                            vertexData[inc++] = interpolatedRotation.y;
                            vertexData[inc++] = interpolatedRotation.z;
                        }
                    }
                }
            }
            if (changed)
                animationElements.invalidateBuffer();
        };
        /** @private */
        ParticleFollowState.FOLLOW_POSITION_INDEX = 0;
        /** @private */
        ParticleFollowState.FOLLOW_ROTATION_INDEX = 1;
        return ParticleFollowState;
    }(ParticleStateBase));

    /**
     * A particle animation node used to create a follow behaviour on a particle system.
     */
    var ParticleFollowNode = /** @class */ (function (_super) {
        __extends$5(ParticleFollowNode, _super);
        /**
         * Creates a new <code>ParticleFollowNode</code>
         *
         * @param    [optional] usesPosition     Defines wehether the individual particle reacts to the position of the target.
         * @param    [optional] usesRotation     Defines wehether the individual particle reacts to the rotation of the target.
         * @param    [optional] smooth     Defines wehether the state calculate the interpolated value.
         */
        function ParticleFollowNode(usesPosition, usesRotation, smooth) {
            if (usesPosition === void 0) { usesPosition = true; }
            if (usesRotation === void 0) { usesRotation = true; }
            if (smooth === void 0) { smooth = false; }
            var _this = _super.call(this, "ParticleFollow", ParticlePropertiesMode.LOCAL_DYNAMIC, (usesPosition && usesRotation) ? 6 : 3, ParticleAnimationSet.POST_PRIORITY) || this;
            _this._pStateClass = ParticleFollowState;
            _this._iUsesPosition = usesPosition;
            _this._iUsesRotation = usesRotation;
            _this._iSmooth = smooth;
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleFollowNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            //TODO: use Quaternion to implement this function
            var code = "";
            if (this._iUsesRotation) {
                var rotationAttribute = registerCache.getFreeVertexAttribute();
                animationRegisterData.setRegisterIndex(this, ParticleFollowState.FOLLOW_ROTATION_INDEX, rotationAttribute.index);
                var temp1 = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(temp1, 1);
                var temp2 = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(temp2, 1);
                var temp3 = registerCache.getFreeVertexVectorTemp();
                var temp4;
                if (animationSet.hasBillboard) {
                    registerCache.addVertexTempUsages(temp3, 1);
                    temp4 = registerCache.getFreeVertexVectorTemp();
                }
                registerCache.removeVertexTempUsage(temp1);
                registerCache.removeVertexTempUsage(temp2);
                if (animationSet.hasBillboard)
                    registerCache.removeVertexTempUsage(temp3);
                var len = animationRegisterData.rotationRegisters.length;
                var i;
                //x axis
                code += "mov " + temp1 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp1 + ".x," + animationRegisterData.vertexOneConst + "\n";
                code += "mov " + temp3 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "sin " + temp3 + ".y," + rotationAttribute + ".x\n";
                code += "cos " + temp3 + ".z," + rotationAttribute + ".x\n";
                code += "mov " + temp2 + ".x," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp2 + ".y," + temp3 + ".z\n";
                code += "neg " + temp2 + ".z," + temp3 + ".y\n";
                if (animationSet.hasBillboard)
                    code += "m33 " + temp4 + ".xyz," + animationRegisterData.positionTarget + ".xyz," + temp1 + "\n";
                else {
                    code += "m33 " + animationRegisterData.scaleAndRotateTarget + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz," + temp1 + "\n";
                    for (i = 0; i < len; i++)
                        code += "m33 " + animationRegisterData.rotationRegisters[i] + ".xyz," + animationRegisterData.rotationRegisters[i] + "," + temp1 + "\n";
                }
                //y axis
                code += "mov " + temp1 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "cos " + temp1 + ".x," + rotationAttribute + ".y\n";
                code += "sin " + temp1 + ".z," + rotationAttribute + ".y\n";
                code += "mov " + temp2 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp2 + ".y," + animationRegisterData.vertexOneConst + "\n";
                code += "mov " + temp3 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "neg " + temp3 + ".x," + temp1 + ".z\n";
                code += "mov " + temp3 + ".z," + temp1 + ".x\n";
                if (animationSet.hasBillboard)
                    code += "m33 " + temp4 + ".xyz," + temp4 + ".xyz," + temp1 + "\n";
                else {
                    code += "m33 " + animationRegisterData.scaleAndRotateTarget + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz," + temp1 + "\n";
                    for (i = 0; i < len; i++)
                        code += "m33 " + animationRegisterData.rotationRegisters[i] + ".xyz," + animationRegisterData.rotationRegisters[i] + "," + temp1 + "\n";
                }
                //z axis
                code += "mov " + temp2 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "sin " + temp2 + ".x," + rotationAttribute + ".z\n";
                code += "cos " + temp2 + ".y," + rotationAttribute + ".z\n";
                code += "mov " + temp1 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp1 + ".x," + temp2 + ".y\n";
                code += "neg " + temp1 + ".y," + temp2 + ".x\n";
                code += "mov " + temp3 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp3 + ".z," + animationRegisterData.vertexOneConst + "\n";
                if (animationSet.hasBillboard) {
                    code += "m33 " + temp4 + ".xyz," + temp4 + ".xyz," + temp1 + "\n";
                    code += "sub " + temp4 + ".xyz," + temp4 + ".xyz," + animationRegisterData.positionTarget + ".xyz\n";
                    code += "add " + animationRegisterData.scaleAndRotateTarget + ".xyz," + temp4 + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz\n";
                }
                else {
                    code += "m33 " + animationRegisterData.scaleAndRotateTarget + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz," + temp1 + "\n";
                    for (i = 0; i < len; i++)
                        code += "m33 " + animationRegisterData.rotationRegisters[i] + ".xyz," + animationRegisterData.rotationRegisters[i] + "," + temp1 + "\n";
                }
            }
            if (this._iUsesPosition) {
                var positionAttribute = registerCache.getFreeVertexAttribute();
                animationRegisterData.setRegisterIndex(this, ParticleFollowState.FOLLOW_POSITION_INDEX, positionAttribute.index);
                code += "add " + animationRegisterData.scaleAndRotateTarget + ".xyz," + positionAttribute + "," + animationRegisterData.scaleAndRotateTarget + ".xyz\n";
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleFollowNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        return ParticleFollowNode;
    }(ParticleNodeBase));

    /**
    *
    */
    var ParticleInitialColorState = /** @class */ (function (_super) {
        __extends$5(ParticleInitialColorState, _super);
        function ParticleInitialColorState(animator, particleInitialColorNode) {
            var _this = _super.call(this, animator, particleInitialColorNode) || this;
            _this._particleInitialColorNode = particleInitialColorNode;
            _this._usesMultiplier = particleInitialColorNode._iUsesMultiplier;
            _this._usesOffset = particleInitialColorNode._iUsesOffset;
            _this._initialColor = particleInitialColorNode._iInitialColor;
            _this.updateColorData();
            return _this;
        }
        Object.defineProperty(ParticleInitialColorState.prototype, "initialColor", {
            /**
             * Defines the initial color transform of the state, when in global mode.
             */
            get: function () {
                return this._initialColor;
            },
            set: function (value) {
                this._initialColor = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        ParticleInitialColorState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            if (shader.usesFragmentAnimation) {
                if (this._particleInitialColorNode.mode == ParticlePropertiesMode.LOCAL_STATIC) {
                    var dataOffset = this._particleInitialColorNode._iDataOffset;
                    if (this._usesMultiplier) {
                        animationElements.activateVertexBuffer(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleInitialColorState.MULTIPLIER_INDEX), dataOffset, stage, ContextGLVertexBufferFormat.FLOAT_4);
                        dataOffset += 4;
                    }
                    if (this._usesOffset)
                        animationElements.activateVertexBuffer(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleInitialColorState.OFFSET_INDEX), dataOffset, stage, ContextGLVertexBufferFormat.FLOAT_4);
                }
                else {
                    if (this._usesMultiplier)
                        shader.setVertexConst(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleInitialColorState.MULTIPLIER_INDEX), this._multiplierData.x, this._multiplierData.y, this._multiplierData.z, this._multiplierData.w);
                    if (this._usesOffset)
                        shader.setVertexConst(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleInitialColorState.OFFSET_INDEX), this._offsetData.x, this._offsetData.y, this._offsetData.z, this._offsetData.w);
                }
            }
        };
        ParticleInitialColorState.prototype.updateColorData = function () {
            if (this._particleInitialColorNode.mode == ParticlePropertiesMode.GLOBAL) {
                if (this._usesMultiplier)
                    this._multiplierData = new Vector3D(this._initialColor.redMultiplier, this._initialColor.greenMultiplier, this._initialColor.blueMultiplier, this._initialColor.alphaMultiplier);
                if (this._usesOffset)
                    this._offsetData = new Vector3D(this._initialColor.redOffset / 255, this._initialColor.greenOffset / 255, this._initialColor.blueOffset / 255, this._initialColor.alphaOffset / 255);
            }
        };
        /** @private */
        ParticleInitialColorState.MULTIPLIER_INDEX = 0;
        /** @private */
        ParticleInitialColorState.OFFSET_INDEX = 1;
        return ParticleInitialColorState;
    }(ParticleStateBase));

    /**
     *
     */
    var ParticleInitialColorNode = /** @class */ (function (_super) {
        __extends$5(ParticleInitialColorNode, _super);
        function ParticleInitialColorNode(mode, usesMultiplier, usesOffset, initialColor) {
            if (usesMultiplier === void 0) { usesMultiplier = true; }
            if (usesOffset === void 0) { usesOffset = false; }
            if (initialColor === void 0) { initialColor = null; }
            var _this = _super.call(this, "ParticleInitialColor", mode, (usesMultiplier && usesOffset) ? 8 : 4, ParticleAnimationSet.COLOR_PRIORITY) || this;
            _this._pStateClass = ParticleInitialColorState;
            _this._iUsesMultiplier = usesMultiplier;
            _this._iUsesOffset = usesOffset;
            _this._iInitialColor = initialColor || new ColorTransform();
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleInitialColorNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var code = "";
            if (shader.usesFragmentAnimation) {
                if (this._iUsesMultiplier) {
                    var multiplierValue = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
                    animationRegisterData.setRegisterIndex(this, ParticleInitialColorState.MULTIPLIER_INDEX, multiplierValue.index);
                    code += "mul " + animationRegisterData.colorMulTarget + "," + multiplierValue + "," + animationRegisterData.colorMulTarget + "\n";
                }
                if (this._iUsesOffset) {
                    var offsetValue = (this._pMode == ParticlePropertiesMode.LOCAL_STATIC) ? registerCache.getFreeVertexAttribute() : registerCache.getFreeVertexConstant();
                    animationRegisterData.setRegisterIndex(this, ParticleInitialColorState.OFFSET_INDEX, offsetValue.index);
                    code += "add " + animationRegisterData.colorAddTarget + "," + offsetValue + "," + animationRegisterData.colorAddTarget + "\n";
                }
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleInitialColorNode.prototype._iProcessAnimationSetting = function (particleAnimationSet) {
            if (this._iUsesMultiplier)
                particleAnimationSet.hasColorMulNode = true;
            if (this._iUsesOffset)
                particleAnimationSet.hasColorAddNode = true;
        };
        /**
         * @inheritDoc
         */
        ParticleInitialColorNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            var initialColor = param[ParticleInitialColorNode.COLOR_INITIAL_COLORTRANSFORM];
            if (!initialColor)
                throw (new Error("there is no " + ParticleInitialColorNode.COLOR_INITIAL_COLORTRANSFORM + " in param!"));
            var i = 0;
            //multiplier
            if (this._iUsesMultiplier) {
                this._pOneData[i++] = initialColor.redMultiplier;
                this._pOneData[i++] = initialColor.greenMultiplier;
                this._pOneData[i++] = initialColor.blueMultiplier;
                this._pOneData[i++] = initialColor.alphaMultiplier;
            }
            //offset
            if (this._iUsesOffset) {
                this._pOneData[i++] = initialColor.redOffset / 255;
                this._pOneData[i++] = initialColor.greenOffset / 255;
                this._pOneData[i++] = initialColor.blueOffset / 255;
                this._pOneData[i++] = initialColor.alphaOffset / 255;
            }
        };
        /**
         * Reference for color node properties on a single particle (when in local property mode).
         * Expects a <code>ColorTransform</code> object representing the color transform applied to the particle.
         */
        ParticleInitialColorNode.COLOR_INITIAL_COLORTRANSFORM = "ColorInitialColorTransform";
        return ParticleInitialColorNode;
    }(ParticleNodeBase));

    /**
     * ...
     */
    var ParticleOrbitState = /** @class */ (function (_super) {
        __extends$5(ParticleOrbitState, _super);
        function ParticleOrbitState(animator, particleOrbitNode) {
            var _this = _super.call(this, animator, particleOrbitNode) || this;
            _this._particleOrbitNode = particleOrbitNode;
            _this._usesEulers = _this._particleOrbitNode._iUsesEulers;
            _this._usesCycle = _this._particleOrbitNode._iUsesCycle;
            _this._usesPhase = _this._particleOrbitNode._iUsesPhase;
            _this._eulers = _this._particleOrbitNode._iEulers;
            _this._radius = _this._particleOrbitNode._iRadius;
            _this._cycleDuration = _this._particleOrbitNode._iCycleDuration;
            _this._cyclePhase = _this._particleOrbitNode._iCyclePhase;
            _this.updateOrbitData();
            return _this;
        }
        Object.defineProperty(ParticleOrbitState.prototype, "radius", {
            /**
             * Defines the radius of the orbit when in global mode. Defaults to 100.
             */
            get: function () {
                return this._radius;
            },
            set: function (value) {
                this._radius = value;
                this.updateOrbitData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleOrbitState.prototype, "cycleDuration", {
            /**
             * Defines the duration of the orbit in seconds, used as a period independent of particle duration when in global mode. Defaults to 1.
             */
            get: function () {
                return this._cycleDuration;
            },
            set: function (value) {
                this._cycleDuration = value;
                this.updateOrbitData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleOrbitState.prototype, "cyclePhase", {
            /**
             * Defines the phase of the orbit in degrees, used as the starting offset of the cycle when in global mode. Defaults to 0.
             */
            get: function () {
                return this._cyclePhase;
            },
            set: function (value) {
                this._cyclePhase = value;
                this.updateOrbitData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleOrbitState.prototype, "eulers", {
            /**
             * Defines the euler rotation in degrees, applied to the orientation of the orbit when in global mode.
             */
            get: function () {
                return this._eulers;
            },
            set: function (value) {
                this._eulers = value;
                this.updateOrbitData();
            },
            enumerable: true,
            configurable: true
        });
        ParticleOrbitState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            var index = animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleOrbitState.ORBIT_INDEX);
            if (this._particleOrbitNode.mode == ParticlePropertiesMode.LOCAL_STATIC) {
                if (this._usesPhase)
                    animationElements.activateVertexBuffer(index, this._particleOrbitNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_4);
                else
                    animationElements.activateVertexBuffer(index, this._particleOrbitNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_3);
            }
            else
                shader.setVertexConst(index, this._orbitData.x, this._orbitData.y, this._orbitData.z, this._orbitData.w);
            if (this._usesEulers)
                shader.setVertexConstFromMatrix(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleOrbitState.EULERS_INDEX), this._eulersMatrix);
        };
        ParticleOrbitState.prototype.updateOrbitData = function () {
            if (this._usesEulers) {
                this._eulersMatrix = new Matrix3D();
                this._eulersMatrix.appendRotation(this._eulers.x, Vector3D.X_AXIS);
                this._eulersMatrix.appendRotation(this._eulers.y, Vector3D.Y_AXIS);
                this._eulersMatrix.appendRotation(this._eulers.z, Vector3D.Z_AXIS);
            }
            if (this._particleOrbitNode.mode == ParticlePropertiesMode.GLOBAL) {
                this._orbitData = new Vector3D(this._radius, 0, this._radius * Math.PI * 2, this._cyclePhase * Math.PI / 180);
                if (this._usesCycle) {
                    if (this._cycleDuration <= 0)
                        throw (new Error("the cycle duration must be greater than zero"));
                    this._orbitData.y = Math.PI * 2 / this._cycleDuration;
                }
                else
                    this._orbitData.y = Math.PI * 2;
            }
        };
        /** @private */
        ParticleOrbitState.ORBIT_INDEX = 0;
        /** @private */
        ParticleOrbitState.EULERS_INDEX = 1;
        return ParticleOrbitState;
    }(ParticleStateBase));

    /**
     * A particle animation node used to control the position of a particle over time around a circular orbit.
     */
    var ParticleOrbitNode = /** @class */ (function (_super) {
        __extends$5(ParticleOrbitNode, _super);
        /**
         * Creates a new <code>ParticleOrbitNode</code> object.
         *
         * @param               mode            Defines whether the mode of operation acts on local properties of a particle or global properties of the node.
         * @param    [optional] usesEulers      Defines whether the node uses the <code>eulers</code> property in the shader to calculate a rotation on the orbit. Defaults to true.
         * @param    [optional] usesCycle       Defines whether the node uses the <code>cycleDuration</code> property in the shader to calculate the period of the orbit independent of particle duration. Defaults to false.
         * @param    [optional] usesPhase       Defines whether the node uses the <code>cyclePhase</code> property in the shader to calculate a starting offset to the cycle rotation of the particle. Defaults to false.
         * @param    [optional] radius          Defines the radius of the orbit when in global mode. Defaults to 100.
         * @param    [optional] cycleDuration   Defines the duration of the orbit in seconds, used as a period independent of particle duration when in global mode. Defaults to 1.
         * @param    [optional] cyclePhase      Defines the phase of the orbit in degrees, used as the starting offset of the cycle when in global mode. Defaults to 0.
         * @param    [optional] eulers          Defines the euler rotation in degrees, applied to the orientation of the orbit when in global mode.
         */
        function ParticleOrbitNode(mode, usesEulers, usesCycle, usesPhase, radius, cycleDuration, cyclePhase, eulers) {
            if (usesEulers === void 0) { usesEulers = true; }
            if (usesCycle === void 0) { usesCycle = false; }
            if (usesPhase === void 0) { usesPhase = false; }
            if (radius === void 0) { radius = 100; }
            if (cycleDuration === void 0) { cycleDuration = 1; }
            if (cyclePhase === void 0) { cyclePhase = 0; }
            if (eulers === void 0) { eulers = null; }
            var _this = this;
            var len = 3;
            if (usesPhase)
                len++;
            _this = _super.call(this, "ParticleOrbit", mode, len) || this;
            _this._pStateClass = ParticleOrbitState;
            _this._iUsesEulers = usesEulers;
            _this._iUsesCycle = usesCycle;
            _this._iUsesPhase = usesPhase;
            _this._iRadius = radius;
            _this._iCycleDuration = cycleDuration;
            _this._iCyclePhase = cyclePhase;
            _this._iEulers = eulers || new Vector3D();
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleOrbitNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var orbitRegister = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
            animationRegisterData.setRegisterIndex(this, ParticleOrbitState.ORBIT_INDEX, orbitRegister.index);
            var eulersMatrixRegister = registerCache.getFreeVertexConstant();
            animationRegisterData.setRegisterIndex(this, ParticleOrbitState.EULERS_INDEX, eulersMatrixRegister.index);
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            var temp1 = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(temp1, 1);
            var distance = new ShaderRegisterElement(temp1.regName, temp1.index);
            var temp2 = registerCache.getFreeVertexVectorTemp();
            var cos = new ShaderRegisterElement(temp2.regName, temp2.index, 0);
            var sin = new ShaderRegisterElement(temp2.regName, temp2.index, 1);
            var degree = new ShaderRegisterElement(temp2.regName, temp2.index, 2);
            registerCache.removeVertexTempUsage(temp1);
            var code = "";
            if (this._iUsesCycle) {
                code += "mul " + degree + "," + animationRegisterData.vertexTime + "," + orbitRegister + ".y\n";
                if (this._iUsesPhase)
                    code += "add " + degree + "," + degree + "," + orbitRegister + ".w\n";
            }
            else
                code += "mul " + degree + "," + animationRegisterData.vertexLife + "," + orbitRegister + ".y\n";
            code += "cos " + cos + "," + degree + "\n";
            code += "sin " + sin + "," + degree + "\n";
            code += "mul " + distance + ".x," + cos + "," + orbitRegister + ".x\n";
            code += "mul " + distance + ".y," + sin + "," + orbitRegister + ".x\n";
            code += "mov " + distance + ".wz" + animationRegisterData.vertexZeroConst + "\n";
            if (this._iUsesEulers)
                code += "m44 " + distance + "," + distance + "," + eulersMatrixRegister + "\n";
            code += "add " + animationRegisterData.positionTarget + ".xyz," + distance + ".xyz," + animationRegisterData.positionTarget + ".xyz\n";
            if (animationSet.needVelocity) {
                code += "neg " + distance + ".x," + sin + "\n";
                code += "mov " + distance + ".y," + cos + "\n";
                code += "mov " + distance + ".zw," + animationRegisterData.vertexZeroConst + "\n";
                if (this._iUsesEulers)
                    code += "m44 " + distance + "," + distance + "," + eulersMatrixRegister + "\n";
                code += "mul " + distance + "," + distance + "," + orbitRegister + ".z\n";
                code += "div " + distance + "," + distance + "," + orbitRegister + ".y\n";
                if (!this._iUsesCycle)
                    code += "div " + distance + "," + distance + "," + animationRegisterData.vertexLife + "\n";
                code += "add " + animationRegisterData.velocityTarget + ".xyz," + animationRegisterData.velocityTarget + ".xyz," + distance + ".xyz\n";
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleOrbitNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleOrbitNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            //Vector3D.x is radius, Vector3D.y is cycle duration, Vector3D.z is phase
            var orbit = param[ParticleOrbitNode.ORBIT_VECTOR3D];
            if (!orbit)
                throw new Error("there is no " + ParticleOrbitNode.ORBIT_VECTOR3D + " in param!");
            this._pOneData[0] = orbit.x;
            if (this._iUsesCycle && orbit.y <= 0)
                throw (new Error("the cycle duration must be greater than zero"));
            this._pOneData[1] = Math.PI * 2 / (!this._iUsesCycle ? 1 : orbit.y);
            this._pOneData[2] = orbit.x * Math.PI * 2;
            if (this._iUsesPhase)
                this._pOneData[3] = orbit.z * Math.PI / 180;
        };
        /**
         * Reference for orbit node properties on a single particle (when in local property mode).
         * Expects a <code>Vector3D</code> object representing the radius (x), cycle speed (y) and cycle phase (z) of the motion on the particle.
         */
        ParticleOrbitNode.ORBIT_VECTOR3D = "OrbitVector3D";
        return ParticleOrbitNode;
    }(ParticleNodeBase));

    /**
     * ...
     */
    var ParticleOscillatorState = /** @class */ (function (_super) {
        __extends$5(ParticleOscillatorState, _super);
        function ParticleOscillatorState(animator, particleOscillatorNode) {
            var _this = _super.call(this, animator, particleOscillatorNode) || this;
            _this._particleOscillatorNode = particleOscillatorNode;
            _this._oscillator = _this._particleOscillatorNode._iOscillator;
            _this.updateOscillatorData();
            return _this;
        }
        Object.defineProperty(ParticleOscillatorState.prototype, "oscillator", {
            /**
             * Defines the default oscillator axis (x, y, z) and cycleDuration (w) of the state, used when in global mode.
             */
            get: function () {
                return this._oscillator;
            },
            set: function (value) {
                this._oscillator = value;
                this.updateOscillatorData();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        ParticleOscillatorState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            var index = animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleOscillatorState.OSCILLATOR_INDEX);
            if (this._particleOscillatorNode.mode == ParticlePropertiesMode.LOCAL_STATIC)
                animationElements.activateVertexBuffer(index, this._particleOscillatorNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_4);
            else
                shader.setVertexConst(index, this._oscillatorData.x, this._oscillatorData.y, this._oscillatorData.z, this._oscillatorData.w);
        };
        ParticleOscillatorState.prototype.updateOscillatorData = function () {
            if (this._particleOscillatorNode.mode == ParticlePropertiesMode.GLOBAL) {
                if (this._oscillator.w <= 0)
                    throw (new Error("the cycle duration must greater than zero"));
                if (this._oscillatorData == null)
                    this._oscillatorData = new Vector3D();
                this._oscillatorData.x = this._oscillator.x;
                this._oscillatorData.y = this._oscillator.y;
                this._oscillatorData.z = this._oscillator.z;
                this._oscillatorData.w = Math.PI * 2 / this._oscillator.w;
            }
        };
        /** @private */
        ParticleOscillatorState.OSCILLATOR_INDEX = 0;
        return ParticleOscillatorState;
    }(ParticleStateBase));

    /**
     * A particle animation node used to control the position of a particle over time using simple harmonic motion.
     */
    var ParticleOscillatorNode = /** @class */ (function (_super) {
        __extends$5(ParticleOscillatorNode, _super);
        /**
         * Creates a new <code>ParticleOscillatorNode</code>
         *
         * @param               mode            Defines whether the mode of operation acts on local properties of a particle or global properties of the node.
         * @param    [optional] oscillator      Defines the default oscillator axis (x, y, z) and cycleDuration (w) of the node, used when in global mode.
         */
        function ParticleOscillatorNode(mode, oscillator) {
            if (oscillator === void 0) { oscillator = null; }
            var _this = _super.call(this, "ParticleOscillator", mode, 4) || this;
            _this._pStateClass = ParticleOscillatorState;
            _this._iOscillator = oscillator || new Vector3D();
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleOscillatorNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var oscillatorRegister = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
            animationRegisterData.setRegisterIndex(this, ParticleOscillatorState.OSCILLATOR_INDEX, oscillatorRegister.index);
            var temp = registerCache.getFreeVertexVectorTemp();
            var dgree = new ShaderRegisterElement(temp.regName, temp.index, 0);
            var sin = new ShaderRegisterElement(temp.regName, temp.index, 1);
            var cos = new ShaderRegisterElement(temp.regName, temp.index, 2);
            registerCache.addVertexTempUsages(temp, 1);
            var temp2 = registerCache.getFreeVertexVectorTemp();
            var distance = new ShaderRegisterElement(temp2.regName, temp2.index);
            registerCache.removeVertexTempUsage(temp);
            var code = "";
            code += "mul " + dgree + "," + animationRegisterData.vertexTime + "," + oscillatorRegister + ".w\n";
            code += "sin " + sin + "," + dgree + "\n";
            code += "mul " + distance + ".xyz," + sin + "," + oscillatorRegister + ".xyz\n";
            code += "add " + animationRegisterData.positionTarget + ".xyz," + distance + ".xyz," + animationRegisterData.positionTarget + ".xyz\n";
            if (animationSet.needVelocity) {
                code += "cos " + cos + "," + dgree + "\n";
                code += "mul " + distance + ".xyz," + cos + "," + oscillatorRegister + ".xyz\n";
                code += "add " + animationRegisterData.velocityTarget + ".xyz," + distance + ".xyz," + animationRegisterData.velocityTarget + ".xyz\n";
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleOscillatorNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleOscillatorNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            //(Vector3D.x,Vector3D.y,Vector3D.z) is oscillator axis, Vector3D.w is oscillator cycle duration
            var drift = param[ParticleOscillatorNode.OSCILLATOR_VECTOR3D];
            if (!drift)
                throw (new Error("there is no " + ParticleOscillatorNode.OSCILLATOR_VECTOR3D + " in param!"));
            this._pOneData[0] = drift.x;
            this._pOneData[1] = drift.y;
            this._pOneData[2] = drift.z;
            if (drift.w <= 0)
                throw (new Error("the cycle duration must greater than zero"));
            this._pOneData[3] = Math.PI * 2 / drift.w;
        };
        /**
         * Reference for ocsillator node properties on a single particle (when in local property mode).
         * Expects a <code>Vector3D</code> object representing the axis (x,y,z) and cycle speed (w) of the motion on the particle.
         */
        ParticleOscillatorNode.OSCILLATOR_VECTOR3D = "OscillatorVector3D";
        return ParticleOscillatorNode;
    }(ParticleNodeBase));

    /**
     * ...
     * @author ...
     */
    var ParticlePositionState = /** @class */ (function (_super) {
        __extends$5(ParticlePositionState, _super);
        function ParticlePositionState(animator, particlePositionNode) {
            var _this = _super.call(this, animator, particlePositionNode) || this;
            _this._particlePositionNode = particlePositionNode;
            _this._position = _this._particlePositionNode._iPosition;
            return _this;
        }
        Object.defineProperty(ParticlePositionState.prototype, "position", {
            /**
             * Defines the position of the particle when in global mode. Defaults to 0,0,0.
             */
            get: function () {
                return this._position;
            },
            set: function (value) {
                this._position = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        ParticlePositionState.prototype.getPositions = function () {
            return this._pDynamicProperties;
        };
        ParticlePositionState.prototype.setPositions = function (value) {
            this._pDynamicProperties = value;
            this._pDynamicPropertiesDirty = new Object();
        };
        /**
         * @inheritDoc
         */
        ParticlePositionState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            if (this._particlePositionNode.mode == ParticlePropertiesMode.LOCAL_DYNAMIC && !this._pDynamicPropertiesDirty[animationElements._iUniqueId])
                this._pUpdateDynamicProperties(animationElements);
            var index = animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticlePositionState.POSITION_INDEX);
            if (this._particlePositionNode.mode == ParticlePropertiesMode.GLOBAL)
                shader.setVertexConst(index, this._position.x, this._position.y, this._position.z);
            else
                animationElements.activateVertexBuffer(index, this._particlePositionNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_3);
        };
        /** @private */
        ParticlePositionState.POSITION_INDEX = 0;
        return ParticlePositionState;
    }(ParticleStateBase));

    /**
     * A particle animation node used to set the starting position of a particle.
     */
    var ParticlePositionNode = /** @class */ (function (_super) {
        __extends$5(ParticlePositionNode, _super);
        /**
         * Creates a new <code>ParticlePositionNode</code>
         *
         * @param               mode            Defines whether the mode of operation acts on local properties of a particle or global properties of the node.
         * @param    [optional] position        Defines the default position of the particle when in global mode. Defaults to 0,0,0.
         */
        function ParticlePositionNode(mode, position) {
            if (position === void 0) { position = null; }
            var _this = _super.call(this, "ParticlePosition", mode, 3) || this;
            _this._pStateClass = ParticlePositionState;
            _this._iPosition = position || new Vector3D();
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticlePositionNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var positionAttribute = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
            animationRegisterData.setRegisterIndex(this, ParticlePositionState.POSITION_INDEX, positionAttribute.index);
            return "add " + animationRegisterData.positionTarget + ".xyz," + positionAttribute + ".xyz," + animationRegisterData.positionTarget + ".xyz\n";
        };
        /**
         * @inheritDoc
         */
        ParticlePositionNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticlePositionNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            var offset = param[ParticlePositionNode.POSITION_VECTOR3D];
            if (!offset)
                throw (new Error("there is no " + ParticlePositionNode.POSITION_VECTOR3D + " in param!"));
            this._pOneData[0] = offset.x;
            this._pOneData[1] = offset.y;
            this._pOneData[2] = offset.z;
        };
        /**
         * Reference for position node properties on a single particle (when in local property mode).
         * Expects a <code>Vector3D</code> object representing position of the particle.
         */
        ParticlePositionNode.POSITION_VECTOR3D = "PositionVector3D";
        return ParticlePositionNode;
    }(ParticleNodeBase));

    /**
     * ...
     */
    var ParticleRotateToHeadingState = /** @class */ (function (_super) {
        __extends$5(ParticleRotateToHeadingState, _super);
        function ParticleRotateToHeadingState(animator, particleNode) {
            var _this = _super.call(this, animator, particleNode) || this;
            _this._matrix = new Matrix3D();
            return _this;
        }
        ParticleRotateToHeadingState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            if (this._pParticleAnimator.animationSet.hasBillboard) {
                this._matrix.copyFrom(renderable.sourceEntity.transform.concatenatedMatrix3D);
                this._matrix.append(projection.transform.inverseConcatenatedMatrix3D);
                shader.setVertexConstFromMatrix(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleRotateToHeadingState.MATRIX_INDEX), this._matrix);
            }
        };
        /** @private */
        ParticleRotateToHeadingState.MATRIX_INDEX = 0;
        return ParticleRotateToHeadingState;
    }(ParticleStateBase));

    /**
     * A particle animation node used to control the rotation of a particle to match its heading vector.
     */
    var ParticleRotateToHeadingNode = /** @class */ (function (_super) {
        __extends$5(ParticleRotateToHeadingNode, _super);
        /**
         * Creates a new <code>ParticleBillboardNode</code>
         */
        function ParticleRotateToHeadingNode() {
            var _this = _super.call(this, "ParticleRotateToHeading", ParticlePropertiesMode.GLOBAL, 0, 3) || this;
            _this._pStateClass = ParticleRotateToHeadingState;
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleRotateToHeadingNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var code = "";
            var len = animationRegisterData.rotationRegisters.length;
            var i;
            if (animationSet.hasBillboard) {
                var temp1 = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(temp1, 1);
                var temp2 = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(temp2, 1);
                var temp3 = registerCache.getFreeVertexVectorTemp();
                var rotationMatrixRegister = registerCache.getFreeVertexConstant();
                animationRegisterData.setRegisterIndex(this, ParticleRotateToHeadingState.MATRIX_INDEX, rotationMatrixRegister.index);
                registerCache.getFreeVertexConstant();
                registerCache.getFreeVertexConstant();
                registerCache.getFreeVertexConstant();
                registerCache.removeVertexTempUsage(temp1);
                registerCache.removeVertexTempUsage(temp2);
                //process the velocity
                code += "m33 " + temp1 + ".xyz," + animationRegisterData.velocityTarget + ".xyz," + rotationMatrixRegister + "\n";
                code += "mov " + temp3 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp3 + ".xy," + temp1 + ".xy\n";
                code += "nrm " + temp3 + ".xyz," + temp3 + ".xyz\n";
                //temp3.x=cos,temp3.y=sin
                //only process z axis
                code += "mov " + temp2 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp2 + ".x," + temp3 + ".y\n";
                code += "mov " + temp2 + ".y," + temp3 + ".x\n";
                code += "mov " + temp1 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp1 + ".x," + temp3 + ".x\n";
                code += "neg " + temp1 + ".y," + temp3 + ".y\n";
                code += "mov " + temp3 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp3 + ".z," + animationRegisterData.vertexOneConst + "\n";
                code += "m33 " + animationRegisterData.scaleAndRotateTarget + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz," + temp1 + "\n";
                for (i = 0; i < len; i++)
                    code += "m33 " + animationRegisterData.rotationRegisters[i] + ".xyz," + animationRegisterData.rotationRegisters[i] + "," + temp1 + "\n";
            }
            else {
                var nrmVel = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(nrmVel, 1);
                var xAxis = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(xAxis, 1);
                var R = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(R, 1);
                var R_rev = registerCache.getFreeVertexVectorTemp();
                var cos = new ShaderRegisterElement(R.regName, R.index, 3);
                var sin = new ShaderRegisterElement(R_rev.regName, R_rev.index, 3);
                var cos2 = new ShaderRegisterElement(nrmVel.regName, nrmVel.index, 3);
                var tempSingle = sin;
                registerCache.removeVertexTempUsage(nrmVel);
                registerCache.removeVertexTempUsage(xAxis);
                registerCache.removeVertexTempUsage(R);
                code += "mov " + xAxis + ".x," + animationRegisterData.vertexOneConst + "\n";
                code += "mov " + xAxis + ".yz," + animationRegisterData.vertexZeroConst + "\n";
                code += "nrm " + nrmVel + ".xyz," + animationRegisterData.velocityTarget + ".xyz\n";
                code += "dp3 " + cos2 + "," + nrmVel + ".xyz," + xAxis + ".xyz\n";
                code += "crs " + nrmVel + ".xyz," + xAxis + ".xyz," + nrmVel + ".xyz\n";
                code += "nrm " + nrmVel + ".xyz," + nrmVel + ".xyz\n";
                //use R as temp to judge if nrm is (0,0,0).
                //if nrm is (0,0,0) ,change it to (0,0,1).
                code += "dp3 " + R + ".x," + nrmVel + ".xyz," + nrmVel + ".xyz\n";
                code += "sge " + R + ".x," + animationRegisterData.vertexZeroConst + "," + R + ".x\n";
                code += "add " + nrmVel + ".z," + R + ".x," + nrmVel + ".z\n";
                code += "add " + tempSingle + "," + cos2 + "," + animationRegisterData.vertexOneConst + "\n";
                code += "div " + tempSingle + "," + tempSingle + "," + animationRegisterData.vertexTwoConst + "\n";
                code += "sqt " + cos + "," + tempSingle + "\n";
                code += "sub " + tempSingle + "," + animationRegisterData.vertexOneConst + "," + cos2 + "\n";
                code += "div " + tempSingle + "," + tempSingle + "," + animationRegisterData.vertexTwoConst + "\n";
                code += "sqt " + sin + "," + tempSingle + "\n";
                code += "mul " + R + ".xyz," + sin + "," + nrmVel + ".xyz\n";
                //use cos as R.w
                code += "mul " + R_rev + ".xyz," + sin + "," + nrmVel + ".xyz\n";
                code += "neg " + R_rev + ".xyz," + R_rev + ".xyz\n";
                //use cos as R_rev.w
                //nrmVel and xAxis are used as temp register
                code += "crs " + nrmVel + ".xyz," + R + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz\n";
                //use cos as R.w
                code += "mul " + xAxis + ".xyz," + cos + "," + animationRegisterData.scaleAndRotateTarget + ".xyz\n";
                code += "add " + nrmVel + ".xyz," + nrmVel + ".xyz," + xAxis + ".xyz\n";
                code += "dp3 " + xAxis + ".w," + R + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz\n";
                code += "neg " + nrmVel + ".w," + xAxis + ".w\n";
                code += "crs " + R + ".xyz," + nrmVel + ".xyz," + R_rev + ".xyz\n";
                //code += "mul " + xAxis + ".xyzw," + nrmVel + ".xyzw," +R_rev + ".w\n";
                code += "mul " + xAxis + ".xyzw," + nrmVel + ".xyzw," + cos + "\n";
                code += "add " + R + ".xyz," + R + ".xyz," + xAxis + ".xyz\n";
                code += "mul " + xAxis + ".xyz," + nrmVel + ".w," + R_rev + ".xyz\n";
                code += "add " + animationRegisterData.scaleAndRotateTarget + ".xyz," + R + ".xyz," + xAxis + ".xyz\n";
                for (i = 0; i < len; i++) {
                    //just repeat the calculate above
                    //because of the limited registers, no need to optimise
                    code += "mov " + xAxis + ".x," + animationRegisterData.vertexOneConst + "\n";
                    code += "mov " + xAxis + ".yz," + animationRegisterData.vertexZeroConst + "\n";
                    code += "nrm " + nrmVel + ".xyz," + animationRegisterData.velocityTarget + ".xyz\n";
                    code += "dp3 " + cos2 + "," + nrmVel + ".xyz," + xAxis + ".xyz\n";
                    code += "crs " + nrmVel + ".xyz," + xAxis + ".xyz," + nrmVel + ".xyz\n";
                    code += "nrm " + nrmVel + ".xyz," + nrmVel + ".xyz\n";
                    code += "dp3 " + R + ".x," + nrmVel + ".xyz," + nrmVel + ".xyz\n";
                    code += "sge " + R + ".x," + animationRegisterData.vertexZeroConst + "," + R + ".x\n";
                    code += "add " + nrmVel + ".z," + R + ".x," + nrmVel + ".z\n";
                    code += "add " + tempSingle + "," + cos2 + "," + animationRegisterData.vertexOneConst + "\n";
                    code += "div " + tempSingle + "," + tempSingle + "," + animationRegisterData.vertexTwoConst + "\n";
                    code += "sqt " + cos + "," + tempSingle + "\n";
                    code += "sub " + tempSingle + "," + animationRegisterData.vertexOneConst + "," + cos2 + "\n";
                    code += "div " + tempSingle + "," + tempSingle + "," + animationRegisterData.vertexTwoConst + "\n";
                    code += "sqt " + sin + "," + tempSingle + "\n";
                    code += "mul " + R + ".xyz," + sin + "," + nrmVel + ".xyz\n";
                    code += "mul " + R_rev + ".xyz," + sin + "," + nrmVel + ".xyz\n";
                    code += "neg " + R_rev + ".xyz," + R_rev + ".xyz\n";
                    code += "crs " + nrmVel + ".xyz," + R + ".xyz," + animationRegisterData.rotationRegisters[i] + ".xyz\n";
                    code += "mul " + xAxis + ".xyz," + cos + "," + animationRegisterData.rotationRegisters[i] + ".xyz\n";
                    code += "add " + nrmVel + ".xyz," + nrmVel + ".xyz," + xAxis + ".xyz\n";
                    code += "dp3 " + xAxis + ".w," + R + ".xyz," + animationRegisterData.rotationRegisters[i] + ".xyz\n";
                    code += "neg " + nrmVel + ".w," + xAxis + ".w\n";
                    code += "crs " + R + ".xyz," + nrmVel + ".xyz," + R_rev + ".xyz\n";
                    code += "mul " + xAxis + ".xyzw," + nrmVel + ".xyzw," + cos + "\n";
                    code += "add " + R + ".xyz," + R + ".xyz," + xAxis + ".xyz\n";
                    code += "mul " + xAxis + ".xyz," + nrmVel + ".w," + R_rev + ".xyz\n";
                    code += "add " + animationRegisterData.rotationRegisters[i] + ".xyz," + R + ".xyz," + xAxis + ".xyz\n";
                }
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleRotateToHeadingNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleRotateToHeadingNode.prototype._iProcessAnimationSetting = function (particleAnimationSet) {
            particleAnimationSet.needVelocity = true;
        };
        return ParticleRotateToHeadingNode;
    }(ParticleNodeBase));

    /**
     * ...
     */
    var ParticleRotateToPositionState = /** @class */ (function (_super) {
        __extends$5(ParticleRotateToPositionState, _super);
        function ParticleRotateToPositionState(animator, particleRotateToPositionNode) {
            var _this = _super.call(this, animator, particleRotateToPositionNode) || this;
            _this._matrix = new Matrix3D();
            _this._particleRotateToPositionNode = particleRotateToPositionNode;
            _this._position = _this._particleRotateToPositionNode._iPosition;
            return _this;
        }
        Object.defineProperty(ParticleRotateToPositionState.prototype, "position", {
            /**
             * Defines the position of the point the particle will rotate to face when in global mode. Defaults to 0,0,0.
             */
            get: function () {
                return this._position;
            },
            set: function (value) {
                this._position = value;
            },
            enumerable: true,
            configurable: true
        });
        ParticleRotateToPositionState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            var index = animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleRotateToPositionState.POSITION_INDEX);
            if (this._pParticleAnimator.animationSet.hasBillboard) {
                this._matrix.copyFrom(renderable.sourceEntity.transform.concatenatedMatrix3D);
                this._matrix.append(projection.transform.inverseConcatenatedMatrix3D);
                shader.setVertexConstFromMatrix(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleRotateToPositionState.MATRIX_INDEX), this._matrix);
            }
            if (this._particleRotateToPositionNode.mode == ParticlePropertiesMode.GLOBAL) {
                this._offset = renderable.sourceEntity.transform.inverseConcatenatedMatrix3D.transformVector(this._position);
                shader.setVertexConst(index, this._offset.x, this._offset.y, this._offset.z);
            }
            else
                animationElements.activateVertexBuffer(index, this._particleRotateToPositionNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_3);
        };
        /** @private */
        ParticleRotateToPositionState.MATRIX_INDEX = 0;
        /** @private */
        ParticleRotateToPositionState.POSITION_INDEX = 1;
        return ParticleRotateToPositionState;
    }(ParticleStateBase));

    /**
     * A particle animation node used to control the rotation of a particle to face to a position
     */
    var ParticleRotateToPositionNode = /** @class */ (function (_super) {
        __extends$5(ParticleRotateToPositionNode, _super);
        /**
         * Creates a new <code>ParticleRotateToPositionNode</code>
         */
        function ParticleRotateToPositionNode(mode, position) {
            if (position === void 0) { position = null; }
            var _this = _super.call(this, "ParticleRotateToPosition", mode, 3, 3) || this;
            _this._pStateClass = ParticleRotateToPositionState;
            _this._iPosition = position || new Vector3D();
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleRotateToPositionNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var positionAttribute = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
            animationRegisterData.setRegisterIndex(this, ParticleRotateToPositionState.POSITION_INDEX, positionAttribute.index);
            var code = "";
            var len = animationRegisterData.rotationRegisters.length;
            var i;
            if (animationSet.hasBillboard) {
                var temp1 = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(temp1, 1);
                var temp2 = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(temp2, 1);
                var temp3 = registerCache.getFreeVertexVectorTemp();
                var rotationMatrixRegister = registerCache.getFreeVertexConstant();
                animationRegisterData.setRegisterIndex(this, ParticleRotateToPositionState.MATRIX_INDEX, rotationMatrixRegister.index);
                registerCache.getFreeVertexConstant();
                registerCache.getFreeVertexConstant();
                registerCache.getFreeVertexConstant();
                registerCache.removeVertexTempUsage(temp1);
                registerCache.removeVertexTempUsage(temp2);
                //process the position
                code += "sub " + temp1 + ".xyz," + positionAttribute + ".xyz," + animationRegisterData.positionTarget + ".xyz\n";
                code += "m33 " + temp1 + ".xyz," + temp1 + ".xyz," + rotationMatrixRegister + "\n";
                code += "mov " + temp3 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp3 + ".xy," + temp1 + ".xy\n";
                code += "nrm " + temp3 + ".xyz," + temp3 + ".xyz\n";
                //temp3.x=cos,temp3.y=sin
                //only process z axis
                code += "mov " + temp2 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp2 + ".x," + temp3 + ".y\n";
                code += "mov " + temp2 + ".y," + temp3 + ".x\n";
                code += "mov " + temp1 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp1 + ".x," + temp3 + ".x\n";
                code += "neg " + temp1 + ".y," + temp3 + ".y\n";
                code += "mov " + temp3 + "," + animationRegisterData.vertexZeroConst + "\n";
                code += "mov " + temp3 + ".z," + animationRegisterData.vertexOneConst + "\n";
                code += "m33 " + animationRegisterData.scaleAndRotateTarget + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz," + temp1 + "\n";
                for (i = 0; i < len; i++)
                    code += "m33 " + animationRegisterData.rotationRegisters[i] + ".xyz," + animationRegisterData.rotationRegisters[i] + "," + temp1 + "\n";
            }
            else {
                var nrmDirection = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(nrmDirection, 1);
                var temp = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(temp, 1);
                var cos = new ShaderRegisterElement(temp.regName, temp.index, 0);
                var sin = new ShaderRegisterElement(temp.regName, temp.index, 1);
                var o_temp = new ShaderRegisterElement(temp.regName, temp.index, 2);
                var tempSingle = new ShaderRegisterElement(temp.regName, temp.index, 3);
                var R = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(R, 1);
                registerCache.removeVertexTempUsage(nrmDirection);
                registerCache.removeVertexTempUsage(temp);
                registerCache.removeVertexTempUsage(R);
                code += "sub " + nrmDirection + ".xyz," + positionAttribute + ".xyz," + animationRegisterData.positionTarget + ".xyz\n";
                code += "nrm " + nrmDirection + ".xyz," + nrmDirection + ".xyz\n";
                code += "mov " + sin + "," + nrmDirection + ".y\n";
                code += "mul " + cos + "," + sin + "," + sin + "\n";
                code += "sub " + cos + "," + animationRegisterData.vertexOneConst + "," + cos + "\n";
                code += "sqt " + cos + "," + cos + "\n";
                code += "mul " + R + ".x," + cos + "," + animationRegisterData.scaleAndRotateTarget + ".y\n";
                code += "mul " + R + ".y," + sin + "," + animationRegisterData.scaleAndRotateTarget + ".z\n";
                code += "mul " + R + ".z," + sin + "," + animationRegisterData.scaleAndRotateTarget + ".y\n";
                code += "mul " + R + ".w," + cos + "," + animationRegisterData.scaleAndRotateTarget + ".z\n";
                code += "sub " + animationRegisterData.scaleAndRotateTarget + ".y," + R + ".x," + R + ".y\n";
                code += "add " + animationRegisterData.scaleAndRotateTarget + ".z," + R + ".z," + R + ".w\n";
                code += "abs " + R + ".y," + nrmDirection + ".y\n";
                code += "sge " + R + ".z," + R + ".y," + animationRegisterData.vertexOneConst + "\n";
                code += "mul " + R + ".x," + R + ".y," + nrmDirection + ".y\n";
                //judgu if nrmDirection=(0,1,0);
                code += "mov " + nrmDirection + ".y," + animationRegisterData.vertexZeroConst + "\n";
                code += "dp3 " + sin + "," + nrmDirection + ".xyz," + nrmDirection + ".xyz\n";
                code += "sge " + tempSingle + "," + animationRegisterData.vertexZeroConst + "," + sin + "\n";
                code += "mov " + nrmDirection + ".y," + animationRegisterData.vertexZeroConst + "\n";
                code += "nrm " + nrmDirection + ".xyz," + nrmDirection + ".xyz\n";
                code += "sub " + sin + "," + animationRegisterData.vertexOneConst + "," + tempSingle + "\n";
                code += "mul " + sin + "," + sin + "," + nrmDirection + ".x\n";
                code += "mov " + cos + "," + nrmDirection + ".z\n";
                code += "neg " + cos + "," + cos + "\n";
                code += "sub " + o_temp + "," + animationRegisterData.vertexOneConst + "," + cos + "\n";
                code += "mul " + o_temp + "," + R + ".x," + tempSingle + "\n";
                code += "add " + cos + "," + cos + "," + o_temp + "\n";
                code += "mul " + R + ".x," + cos + "," + animationRegisterData.scaleAndRotateTarget + ".x\n";
                code += "mul " + R + ".y," + sin + "," + animationRegisterData.scaleAndRotateTarget + ".z\n";
                code += "mul " + R + ".z," + sin + "," + animationRegisterData.scaleAndRotateTarget + ".x\n";
                code += "mul " + R + ".w," + cos + "," + animationRegisterData.scaleAndRotateTarget + ".z\n";
                code += "sub " + animationRegisterData.scaleAndRotateTarget + ".x," + R + ".x," + R + ".y\n";
                code += "add " + animationRegisterData.scaleAndRotateTarget + ".z," + R + ".z," + R + ".w\n";
                for (i = 0; i < len; i++) {
                    //just repeat the calculate above
                    //because of the limited registers, no need to optimise
                    code += "sub " + nrmDirection + ".xyz," + positionAttribute + ".xyz," + animationRegisterData.positionTarget + ".xyz\n";
                    code += "nrm " + nrmDirection + ".xyz," + nrmDirection + ".xyz\n";
                    code += "mov " + sin + "," + nrmDirection + ".y\n";
                    code += "mul " + cos + "," + sin + "," + sin + "\n";
                    code += "sub " + cos + "," + animationRegisterData.vertexOneConst + "," + cos + "\n";
                    code += "sqt " + cos + "," + cos + "\n";
                    code += "mul " + R + ".x," + cos + "," + animationRegisterData.rotationRegisters[i] + ".y\n";
                    code += "mul " + R + ".y," + sin + "," + animationRegisterData.rotationRegisters[i] + ".z\n";
                    code += "mul " + R + ".z," + sin + "," + animationRegisterData.rotationRegisters[i] + ".y\n";
                    code += "mul " + R + ".w," + cos + "," + animationRegisterData.rotationRegisters[i] + ".z\n";
                    code += "sub " + animationRegisterData.rotationRegisters[i] + ".y," + R + ".x," + R + ".y\n";
                    code += "add " + animationRegisterData.rotationRegisters[i] + ".z," + R + ".z," + R + ".w\n";
                    code += "abs " + R + ".y," + nrmDirection + ".y\n";
                    code += "sge " + R + ".z," + R + ".y," + animationRegisterData.vertexOneConst + "\n";
                    code += "mul " + R + ".x," + R + ".y," + nrmDirection + ".y\n";
                    code += "mov " + nrmDirection + ".y," + animationRegisterData.vertexZeroConst + "\n";
                    code += "dp3 " + sin + "," + nrmDirection + ".xyz," + nrmDirection + ".xyz\n";
                    code += "sge " + tempSingle + "," + animationRegisterData.vertexZeroConst + "," + sin + "\n";
                    code += "mov " + nrmDirection + ".y," + animationRegisterData.vertexZeroConst + "\n";
                    code += "nrm " + nrmDirection + ".xyz," + nrmDirection + ".xyz\n";
                    code += "sub " + sin + "," + animationRegisterData.vertexOneConst + "," + tempSingle + "\n";
                    code += "mul " + sin + "," + sin + "," + nrmDirection + ".x\n";
                    code += "mov " + cos + "," + nrmDirection + ".z\n";
                    code += "neg " + cos + "," + cos + "\n";
                    code += "sub " + o_temp + "," + animationRegisterData.vertexOneConst + "," + cos + "\n";
                    code += "mul " + o_temp + "," + R + ".x," + tempSingle + "\n";
                    code += "add " + cos + "," + cos + "," + o_temp + "\n";
                    code += "mul " + R + ".x," + cos + "," + animationRegisterData.rotationRegisters[i] + ".x\n";
                    code += "mul " + R + ".y," + sin + "," + animationRegisterData.rotationRegisters[i] + ".z\n";
                    code += "mul " + R + ".z," + sin + "," + animationRegisterData.rotationRegisters[i] + ".x\n";
                    code += "mul " + R + ".w," + cos + "," + animationRegisterData.rotationRegisters[i] + ".z\n";
                    code += "sub " + animationRegisterData.rotationRegisters[i] + ".x," + R + ".x," + R + ".y\n";
                    code += "add " + animationRegisterData.rotationRegisters[i] + ".z," + R + ".z," + R + ".w\n";
                }
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleRotateToPositionNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleRotateToPositionNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            var offset = param[ParticleRotateToPositionNode.POSITION_VECTOR3D];
            if (!offset)
                throw (new Error("there is no " + ParticleRotateToPositionNode.POSITION_VECTOR3D + " in param!"));
            this._pOneData[0] = offset.x;
            this._pOneData[1] = offset.y;
            this._pOneData[2] = offset.z;
        };
        /**
         * Reference for the position the particle will rotate to face for a single particle (when in local property mode).
         * Expects a <code>Vector3D</code> object representing the position that the particle must face.
         */
        ParticleRotateToPositionNode.POSITION_VECTOR3D = "RotateToPositionVector3D";
        return ParticleRotateToPositionNode;
    }(ParticleNodeBase));

    /**
     * ...
     */
    var ParticleRotationalVelocityState = /** @class */ (function (_super) {
        __extends$5(ParticleRotationalVelocityState, _super);
        function ParticleRotationalVelocityState(animator, particleRotationNode) {
            var _this = _super.call(this, animator, particleRotationNode) || this;
            _this._particleRotationalVelocityNode = particleRotationNode;
            _this._rotationalVelocity = _this._particleRotationalVelocityNode._iRotationalVelocity;
            _this.updateRotationalVelocityData();
            return _this;
        }
        Object.defineProperty(ParticleRotationalVelocityState.prototype, "rotationalVelocity", {
            /**
             * Defines the default rotationalVelocity of the state, used when in global mode.
             */
            get: function () {
                return this._rotationalVelocity;
            },
            set: function (value) {
                this._rotationalVelocity = value;
                this.updateRotationalVelocityData();
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        ParticleRotationalVelocityState.prototype.getRotationalVelocities = function () {
            return this._pDynamicProperties;
        };
        ParticleRotationalVelocityState.prototype.setRotationalVelocities = function (value) {
            this._pDynamicProperties = value;
            this._pDynamicPropertiesDirty = new Object();
        };
        /**
         * @inheritDoc
         */
        ParticleRotationalVelocityState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            if (this._particleRotationalVelocityNode.mode == ParticlePropertiesMode.LOCAL_DYNAMIC && !this._pDynamicPropertiesDirty[animationElements._iUniqueId])
                this._pUpdateDynamicProperties(animationElements);
            var index = animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleRotationalVelocityState.ROTATIONALVELOCITY_INDEX);
            if (this._particleRotationalVelocityNode.mode == ParticlePropertiesMode.GLOBAL)
                shader.setVertexConst(index, this._rotationalVelocityData.x, this._rotationalVelocityData.y, this._rotationalVelocityData.z, this._rotationalVelocityData.w);
            else
                animationElements.activateVertexBuffer(index, this._particleRotationalVelocityNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_4);
        };
        ParticleRotationalVelocityState.prototype.updateRotationalVelocityData = function () {
            if (this._particleRotationalVelocityNode.mode == ParticlePropertiesMode.GLOBAL) {
                if (this._rotationalVelocity.w <= 0)
                    throw (new Error("the cycle duration must greater than zero"));
                var rotation = this._rotationalVelocity.clone();
                if (rotation.length <= 0)
                    rotation.z = 1; //set the default direction
                else
                    rotation.normalize();
                // w is used as angle/2 in agal
                this._rotationalVelocityData = new Vector3D(rotation.x, rotation.y, rotation.z, Math.PI / rotation.w);
            }
        };
        /** @private */
        ParticleRotationalVelocityState.ROTATIONALVELOCITY_INDEX = 0;
        return ParticleRotationalVelocityState;
    }(ParticleStateBase));

    /**
     * A particle animation node used to set the starting rotational velocity of a particle.
     */
    var ParticleRotationalVelocityNode = /** @class */ (function (_super) {
        __extends$5(ParticleRotationalVelocityNode, _super);
        /**
         * Creates a new <code>ParticleRotationalVelocityNode</code>
         *
         * @param               mode            Defines whether the mode of operation acts on local properties of a particle or global properties of the node.
         */
        function ParticleRotationalVelocityNode(mode, rotationalVelocity) {
            if (rotationalVelocity === void 0) { rotationalVelocity = null; }
            var _this = _super.call(this, "ParticleRotationalVelocity", mode, 4) || this;
            _this._pStateClass = ParticleRotationalVelocityState;
            _this._iRotationalVelocity = rotationalVelocity || new Vector3D();
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleRotationalVelocityNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var rotationRegister = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
            animationRegisterData.setRegisterIndex(this, ParticleRotationalVelocityState.ROTATIONALVELOCITY_INDEX, rotationRegister.index);
            var nrmVel = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(nrmVel, 1);
            var xAxis = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(xAxis, 1);
            var temp = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(temp, 1);
            var Rtemp = new ShaderRegisterElement(temp.regName, temp.index);
            var R_rev = registerCache.getFreeVertexVectorTemp();
            R_rev = new ShaderRegisterElement(R_rev.regName, R_rev.index);
            var cos = new ShaderRegisterElement(Rtemp.regName, Rtemp.index, 3);
            var sin = new ShaderRegisterElement(R_rev.regName, R_rev.index, 3);
            registerCache.removeVertexTempUsage(nrmVel);
            registerCache.removeVertexTempUsage(xAxis);
            registerCache.removeVertexTempUsage(temp);
            var code = "";
            code += "mov " + nrmVel + ".xyz," + rotationRegister + ".xyz\n";
            code += "mov " + nrmVel + ".w," + animationRegisterData.vertexZeroConst + "\n";
            code += "mul " + cos + "," + animationRegisterData.vertexTime + "," + rotationRegister + ".w\n";
            code += "sin " + sin + "," + cos + "\n";
            code += "cos " + cos + "," + cos + "\n";
            code += "mul " + Rtemp + ".xyz," + sin + "," + nrmVel + ".xyz\n";
            code += "mul " + R_rev + ".xyz," + sin + "," + nrmVel + ".xyz\n";
            code += "neg " + R_rev + ".xyz," + R_rev + ".xyz\n";
            //nrmVel and xAxis are used as temp register
            code += "crs " + nrmVel + ".xyz," + Rtemp + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz\n";
            code += "mul " + xAxis + ".xyz," + cos + "," + animationRegisterData.scaleAndRotateTarget + ".xyz\n";
            code += "add " + nrmVel + ".xyz," + nrmVel + ".xyz," + xAxis + ".xyz\n";
            code += "dp3 " + xAxis + ".w," + Rtemp + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz\n";
            code += "neg " + nrmVel + ".w," + xAxis + ".w\n";
            code += "crs " + Rtemp + ".xyz," + nrmVel + ".xyz," + R_rev + ".xyz\n";
            //use cos as R_rev.w
            code += "mul " + xAxis + ".xyzw," + nrmVel + ".xyzw," + cos + "\n";
            code += "add " + Rtemp + ".xyz," + Rtemp + ".xyz," + xAxis + ".xyz\n";
            code += "mul " + xAxis + ".xyz," + nrmVel + ".w," + R_rev + ".xyz\n";
            code += "add " + animationRegisterData.scaleAndRotateTarget + ".xyz," + Rtemp + ".xyz," + xAxis + ".xyz\n";
            var len = animationRegisterData.rotationRegisters.length;
            for (var i = 0; i < len; i++) {
                code += "mov " + nrmVel + ".xyz," + rotationRegister + ".xyz\n";
                code += "mov " + nrmVel + ".w," + animationRegisterData.vertexZeroConst + "\n";
                code += "mul " + cos + "," + animationRegisterData.vertexTime + "," + rotationRegister + ".w\n";
                code += "sin " + sin + "," + cos + "\n";
                code += "cos " + cos + "," + cos + "\n";
                code += "mul " + Rtemp + ".xyz," + sin + "," + nrmVel + ".xyz\n";
                code += "mul " + R_rev + ".xyz," + sin + "," + nrmVel + ".xyz\n";
                code += "neg " + R_rev + ".xyz," + R_rev + ".xyz\n";
                code += "crs " + nrmVel + ".xyz," + Rtemp + ".xyz," + animationRegisterData.rotationRegisters[i] + ".xyz\n";
                code += "mul " + xAxis + ".xyz," + cos + "," + animationRegisterData.rotationRegisters[i] + "\n";
                code += "add " + nrmVel + ".xyz," + nrmVel + ".xyz," + xAxis + ".xyz\n";
                code += "dp3 " + xAxis + ".w," + Rtemp + ".xyz," + animationRegisterData.rotationRegisters[i] + "\n";
                code += "neg " + nrmVel + ".w," + xAxis + ".w\n";
                code += "crs " + Rtemp + ".xyz," + nrmVel + ".xyz," + R_rev + ".xyz\n";
                code += "mul " + xAxis + ".xyzw," + nrmVel + ".xyzw," + cos + "\n";
                code += "add " + Rtemp + ".xyz," + Rtemp + ".xyz," + xAxis + ".xyz\n";
                code += "mul " + xAxis + ".xyz," + nrmVel + ".w," + R_rev + ".xyz\n";
                code += "add " + animationRegisterData.rotationRegisters[i] + "," + Rtemp + ".xyz," + xAxis + ".xyz\n";
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleRotationalVelocityNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleRotationalVelocityNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            //(Vector3d.x,Vector3d.y,Vector3d.z) is rotation axis,Vector3d.w is cycle duration
            var rotate = param[ParticleRotationalVelocityNode.ROTATIONALVELOCITY_VECTOR3D];
            if (!rotate)
                throw (new Error("there is no " + ParticleRotationalVelocityNode.ROTATIONALVELOCITY_VECTOR3D + " in param!"));
            if (rotate.length <= 0)
                rotate.z = 1; //set the default direction
            else
                rotate.normalize();
            this._pOneData[0] = rotate.x;
            this._pOneData[1] = rotate.y;
            this._pOneData[2] = rotate.z;
            if (rotate.w <= 0)
                throw (new Error("the cycle duration must greater than zero"));
            // it's used as angle/2 in agal
            this._pOneData[3] = Math.PI / rotate.w;
        };
        /**
         * Reference for rotational velocity node properties on a single particle (when in local property mode).
         * Expects a <code>Vector3D</code> object representing the rotational velocity around an axis of the particle.
         */
        ParticleRotationalVelocityNode.ROTATIONALVELOCITY_VECTOR3D = "RotationalVelocityVector3D";
        return ParticleRotationalVelocityNode;
    }(ParticleNodeBase));

    /**
     * ...
     */
    var ParticleScaleState = /** @class */ (function (_super) {
        __extends$5(ParticleScaleState, _super);
        function ParticleScaleState(animator, particleScaleNode) {
            var _this = _super.call(this, animator, particleScaleNode) || this;
            _this._particleScaleNode = particleScaleNode;
            _this._usesCycle = _this._particleScaleNode._iUsesCycle;
            _this._usesPhase = _this._particleScaleNode._iUsesPhase;
            _this._minScale = _this._particleScaleNode._iMinScale;
            _this._maxScale = _this._particleScaleNode._iMaxScale;
            _this._cycleDuration = _this._particleScaleNode._iCycleDuration;
            _this._cyclePhase = _this._particleScaleNode._iCyclePhase;
            _this.updateScaleData();
            return _this;
        }
        Object.defineProperty(ParticleScaleState.prototype, "minScale", {
            /**
             * Defines the end scale of the state, when in global mode. Defaults to 1.
             */
            get: function () {
                return this._minScale;
            },
            set: function (value) {
                this._minScale = value;
                this.updateScaleData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleScaleState.prototype, "maxScale", {
            /**
             * Defines the end scale of the state, when in global mode. Defaults to 1.
             */
            get: function () {
                return this._maxScale;
            },
            set: function (value) {
                this._maxScale = value;
                this.updateScaleData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleScaleState.prototype, "cycleDuration", {
            /**
             * Defines the duration of the animation in seconds, used as a period independent of particle duration when in global mode. Defaults to 1.
             */
            get: function () {
                return this._cycleDuration;
            },
            set: function (value) {
                this._cycleDuration = value;
                this.updateScaleData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleScaleState.prototype, "cyclePhase", {
            /**
             * Defines the phase of the cycle in degrees, used as the starting offset of the cycle when in global mode. Defaults to 0.
             */
            get: function () {
                return this._cyclePhase;
            },
            set: function (value) {
                this._cyclePhase = value;
                this.updateScaleData();
            },
            enumerable: true,
            configurable: true
        });
        ParticleScaleState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            var index = animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleScaleState.SCALE_INDEX);
            if (this._particleScaleNode.mode == ParticlePropertiesMode.LOCAL_STATIC) {
                if (this._usesCycle) {
                    if (this._usesPhase)
                        animationElements.activateVertexBuffer(index, this._particleScaleNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_4);
                    else
                        animationElements.activateVertexBuffer(index, this._particleScaleNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_3);
                }
                else
                    animationElements.activateVertexBuffer(index, this._particleScaleNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_2);
            }
            else
                shader.setVertexConst(index, this._scaleData.x, this._scaleData.y, this._scaleData.z, this._scaleData.w);
        };
        ParticleScaleState.prototype.updateScaleData = function () {
            if (this._particleScaleNode.mode == ParticlePropertiesMode.GLOBAL) {
                if (this._usesCycle) {
                    if (this._cycleDuration <= 0)
                        throw (new Error("the cycle duration must be greater than zero"));
                    this._scaleData = new Vector3D((this._minScale + this._maxScale) / 2, Math.abs(this._minScale - this._maxScale) / 2, Math.PI * 2 / this._cycleDuration, this._cyclePhase * Math.PI / 180);
                }
                else
                    this._scaleData = new Vector3D(this._minScale, this._maxScale - this._minScale, 0, 0);
            }
        };
        /** @private */
        ParticleScaleState.SCALE_INDEX = 0;
        return ParticleScaleState;
    }(ParticleStateBase));

    /**
     * A particle animation node used to control the scale variation of a particle over time.
     */
    var ParticleScaleNode = /** @class */ (function (_super) {
        __extends$5(ParticleScaleNode, _super);
        /**
         * Creates a new <code>ParticleScaleNode</code>
         *
         * @param               mode            Defines whether the mode of operation acts on local properties of a particle or global properties of the node.
         * @param    [optional] usesCycle       Defines whether the node uses the <code>cycleDuration</code> property in the shader to calculate the period of animation independent of particle duration. Defaults to false.
         * @param    [optional] usesPhase       Defines whether the node uses the <code>cyclePhase</code> property in the shader to calculate a starting offset to the animation cycle. Defaults to false.
         * @param    [optional] minScale        Defines the default min scale transform of the node, when in global mode. Defaults to 1.
         * @param    [optional] maxScale        Defines the default max color transform of the node, when in global mode. Defaults to 1.
         * @param    [optional] cycleDuration   Defines the default duration of the animation in seconds, used as a period independent of particle duration when in global mode. Defaults to 1.
         * @param    [optional] cyclePhase      Defines the default phase of the cycle in degrees, used as the starting offset of the cycle when in global mode. Defaults to 0.
         */
        function ParticleScaleNode(mode, usesCycle, usesPhase, minScale, maxScale, cycleDuration, cyclePhase) {
            if (minScale === void 0) { minScale = 1; }
            if (maxScale === void 0) { maxScale = 1; }
            if (cycleDuration === void 0) { cycleDuration = 1; }
            if (cyclePhase === void 0) { cyclePhase = 0; }
            var _this = _super.call(this, "ParticleScale", mode, (usesCycle && usesPhase) ? 4 : ((usesCycle || usesPhase) ? 3 : 2), 3) || this;
            _this._pStateClass = ParticleScaleState;
            _this._iUsesCycle = usesCycle;
            _this._iUsesPhase = usesPhase;
            _this._iMinScale = minScale;
            _this._iMaxScale = maxScale;
            _this._iCycleDuration = cycleDuration;
            _this._iCyclePhase = cyclePhase;
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleScaleNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var code = "";
            var temp = registerCache.getFreeVertexSingleTemp();
            var scaleRegister = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
            animationRegisterData.setRegisterIndex(this, ParticleScaleState.SCALE_INDEX, scaleRegister.index);
            if (this._iUsesCycle) {
                code += "mul " + temp + "," + animationRegisterData.vertexTime + "," + scaleRegister + ".z\n";
                if (this._iUsesPhase)
                    code += "add " + temp + "," + temp + "," + scaleRegister + ".w\n";
                code += "sin " + temp + "," + temp + "\n";
            }
            code += "mul " + temp + "," + scaleRegister + ".y," + ((this._iUsesCycle) ? temp : animationRegisterData.vertexLife) + "\n";
            code += "add " + temp + "," + scaleRegister + ".x," + temp + "\n";
            code += "mul " + animationRegisterData.scaleAndRotateTarget + ".xyz," + animationRegisterData.scaleAndRotateTarget + ".xyz," + temp + "\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleScaleNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleScaleNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            var scale = param[ParticleScaleNode.SCALE_VECTOR3D];
            if (!scale)
                throw (new Error("there is no " + ParticleScaleNode.SCALE_VECTOR3D + " in param!"));
            if (this._iUsesCycle) {
                this._pOneData[0] = (scale.x + scale.y) / 2;
                this._pOneData[1] = Math.abs(scale.x - scale.y) / 2;
                if (scale.z <= 0)
                    throw (new Error("the cycle duration must be greater than zero"));
                this._pOneData[2] = Math.PI * 2 / scale.z;
                if (this._iUsesPhase)
                    this._pOneData[3] = scale.w * Math.PI / 180;
            }
            else {
                this._pOneData[0] = scale.x;
                this._pOneData[1] = scale.y - scale.x;
            }
        };
        /**
         * Reference for scale node properties on a single particle (when in local property mode).
         * Expects a <code>Vector3D</code> representing the min scale (x), max scale(y), optional cycle speed (z) and phase offset (w) applied to the particle.
         */
        ParticleScaleNode.SCALE_VECTOR3D = "ScaleVector3D";
        return ParticleScaleNode;
    }(ParticleNodeBase));

    /**
     *
     */
    var ParticleSegmentedColorState = /** @class */ (function (_super) {
        __extends$5(ParticleSegmentedColorState, _super);
        function ParticleSegmentedColorState(animator, particleSegmentedColorNode) {
            var _this = _super.call(this, animator, particleSegmentedColorNode) || this;
            _this._usesMultiplier = particleSegmentedColorNode._iUsesMultiplier;
            _this._usesOffset = particleSegmentedColorNode._iUsesOffset;
            _this._startColor = particleSegmentedColorNode._iStartColor;
            _this._endColor = particleSegmentedColorNode._iEndColor;
            _this._segmentPoints = particleSegmentedColorNode._iSegmentPoints;
            _this._numSegmentPoint = particleSegmentedColorNode._iNumSegmentPoint;
            _this.updateColorData();
            return _this;
        }
        Object.defineProperty(ParticleSegmentedColorState.prototype, "startColor", {
            /**
             * Defines the start color transform of the state, when in global mode.
             */
            get: function () {
                return this._startColor;
            },
            set: function (value) {
                this._startColor = value;
                this.updateColorData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleSegmentedColorState.prototype, "endColor", {
            /**
             * Defines the end color transform of the state, when in global mode.
             */
            get: function () {
                return this._endColor;
            },
            set: function (value) {
                this._endColor = value;
                this.updateColorData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleSegmentedColorState.prototype, "numSegmentPoint", {
            /**
             * Defines the number of segments.
             */
            get: function () {
                return this._numSegmentPoint;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleSegmentedColorState.prototype, "segmentPoints", {
            /**
             * Defines the key points of color
             */
            get: function () {
                return this._segmentPoints;
            },
            set: function (value) {
                this._segmentPoints = value;
                this.updateColorData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleSegmentedColorState.prototype, "usesMultiplier", {
            get: function () {
                return this._usesMultiplier;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleSegmentedColorState.prototype, "usesOffset", {
            get: function () {
                return this._usesOffset;
            },
            enumerable: true,
            configurable: true
        });
        ParticleSegmentedColorState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            if (shader.usesFragmentAnimation) {
                if (this._numSegmentPoint > 0)
                    shader.setVertexConst(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleSegmentedColorState.TIME_DATA_INDEX), this._timeLifeData[0], this._timeLifeData[1], this._timeLifeData[2], this._timeLifeData[3]);
                if (this._usesMultiplier)
                    shader.setVertexConstFromArray(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleSegmentedColorState.START_MULTIPLIER_INDEX), this._multiplierData);
                if (this._usesOffset)
                    shader.setVertexConstFromArray(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleSegmentedColorState.START_OFFSET_INDEX), this._offsetData);
            }
        };
        ParticleSegmentedColorState.prototype.updateColorData = function () {
            this._timeLifeData = new Float32Array(4);
            this._multiplierData = new Float32Array(4 * (this._numSegmentPoint + 1));
            this._offsetData = new Float32Array(4 * (this._numSegmentPoint + 1));
            //cut off the time data
            var i;
            var j = 0;
            var count = this._numSegmentPoint > 3 ? 3 : this._numSegmentPoint;
            for (i = 0; i < count; i++) {
                if (i == 0)
                    this._timeLifeData[j++] = this._segmentPoints[i].life;
                else
                    this._timeLifeData[j++] = this._segmentPoints[i].life - this._segmentPoints[i - 1].life;
            }
            i = count;
            if (this._numSegmentPoint == 0)
                this._timeLifeData[j++] = 1;
            else
                this._timeLifeData[j++] = 1 - this._segmentPoints[i - 1].life;
            if (this._usesMultiplier) {
                j = 0;
                this._multiplierData[j++] = this._startColor.redMultiplier;
                this._multiplierData[j++] = this._startColor.greenMultiplier;
                this._multiplierData[j++] = this._startColor.blueMultiplier;
                this._multiplierData[j++] = this._startColor.alphaMultiplier;
                for (i = 0; i < this._numSegmentPoint; i++) {
                    if (i == 0) {
                        this._multiplierData[j++] = (this._segmentPoints[i].color.redMultiplier - this._startColor.redMultiplier) / this._timeLifeData[i];
                        this._multiplierData[j++] = (this._segmentPoints[i].color.greenMultiplier - this._startColor.greenMultiplier) / this._timeLifeData[i];
                        this._multiplierData[j++] = (this._segmentPoints[i].color.blueMultiplier - this._startColor.blueMultiplier) / this._timeLifeData[i];
                        this._multiplierData[j++] = (this._segmentPoints[i].color.alphaMultiplier - this._startColor.alphaMultiplier) / this._timeLifeData[i];
                    }
                    else {
                        this._multiplierData[j++] = (this._segmentPoints[i].color.redMultiplier - this._segmentPoints[i - 1].color.redMultiplier) / this._timeLifeData[i];
                        this._multiplierData[j++] = (this._segmentPoints[i].color.greenMultiplier - this._segmentPoints[i - 1].color.greenMultiplier) / this._timeLifeData[i];
                        this._multiplierData[j++] = (this._segmentPoints[i].color.blueMultiplier - this._segmentPoints[i - 1].color.blueMultiplier) / this._timeLifeData[i];
                        this._multiplierData[j++] = (this._segmentPoints[i].color.alphaMultiplier - this._segmentPoints[i - 1].color.alphaMultiplier) / this._timeLifeData[i];
                    }
                }
                i = this._numSegmentPoint;
                if (this._numSegmentPoint == 0) {
                    this._multiplierData[j++] = this._endColor.redMultiplier - this._startColor.redMultiplier;
                    this._multiplierData[j++] = this._endColor.greenMultiplier - this._startColor.greenMultiplier;
                    this._multiplierData[j++] = this._endColor.blueMultiplier - this._startColor.blueMultiplier;
                    this._multiplierData[j++] = this._endColor.alphaMultiplier - this._startColor.alphaMultiplier;
                }
                else {
                    this._multiplierData[j++] = (this._endColor.redMultiplier - this._segmentPoints[i - 1].color.redMultiplier) / this._timeLifeData[i];
                    this._multiplierData[j++] = (this._endColor.greenMultiplier - this._segmentPoints[i - 1].color.greenMultiplier) / this._timeLifeData[i];
                    this._multiplierData[j++] = (this._endColor.blueMultiplier - this._segmentPoints[i - 1].color.blueMultiplier) / this._timeLifeData[i];
                    this._multiplierData[j++] = (this._endColor.alphaMultiplier - this._segmentPoints[i - 1].color.alphaMultiplier) / this._timeLifeData[i];
                }
            }
            if (this._usesOffset) {
                j = 0;
                this._offsetData[j++] = this._startColor.redOffset / 255;
                this._offsetData[j++] = this._startColor.greenOffset / 255;
                this._offsetData[j++] = this._startColor.blueOffset / 255;
                this._offsetData[j++] = this._startColor.alphaOffset / 255;
                for (i = 0; i < this._numSegmentPoint; i++) {
                    if (i == 0) {
                        this._offsetData[j++] = (this._segmentPoints[i].color.redOffset - this._startColor.redOffset) / this._timeLifeData[i] / 255;
                        this._offsetData[j++] = (this._segmentPoints[i].color.greenOffset - this._startColor.greenOffset) / this._timeLifeData[i] / 255;
                        this._offsetData[j++] = (this._segmentPoints[i].color.blueOffset - this._startColor.blueOffset) / this._timeLifeData[i] / 255;
                        this._offsetData[j++] = (this._segmentPoints[i].color.alphaOffset - this._startColor.alphaOffset) / this._timeLifeData[i] / 255;
                    }
                    else {
                        this._offsetData[j++] = (this._segmentPoints[i].color.redOffset - this._segmentPoints[i - 1].color.redOffset) / this._timeLifeData[i] / 255;
                        this._offsetData[j++] = (this._segmentPoints[i].color.greenOffset - this._segmentPoints[i - 1].color.greenOffset) / this._timeLifeData[i] / 255;
                        this._offsetData[j++] = (this._segmentPoints[i].color.blueOffset - this._segmentPoints[i - 1].color.blueOffset) / this._timeLifeData[i] / 255;
                        this._offsetData[j++] = (this._segmentPoints[i].color.alphaOffset - this._segmentPoints[i - 1].color.alphaOffset) / this._timeLifeData[i] / 255;
                    }
                }
                i = this._numSegmentPoint;
                if (this._numSegmentPoint == 0) {
                    this._offsetData[j++] = (this._endColor.redOffset - this._startColor.redOffset) / 255;
                    this._offsetData[j++] = (this._endColor.greenOffset - this._startColor.greenOffset) / 255;
                    this._offsetData[j++] = (this._endColor.blueOffset - this._startColor.blueOffset) / 255;
                    this._offsetData[j++] = (this._endColor.alphaOffset - this._startColor.alphaOffset) / 255;
                }
                else {
                    this._offsetData[i] = (this._endColor.redOffset - this._segmentPoints[i - 1].color.redOffset) / this._timeLifeData[i] / 255;
                    this._offsetData[j++] = (this._endColor.greenOffset - this._segmentPoints[i - 1].color.greenOffset) / this._timeLifeData[i] / 255;
                    this._offsetData[j++] = (this._endColor.blueOffset - this._segmentPoints[i - 1].color.blueOffset) / this._timeLifeData[i] / 255;
                    this._offsetData[j++] = (this._endColor.alphaOffset - this._segmentPoints[i - 1].color.alphaOffset) / this._timeLifeData[i] / 255;
                }
            }
        };
        /** @private */
        ParticleSegmentedColorState.START_MULTIPLIER_INDEX = 0;
        /** @private */
        ParticleSegmentedColorState.START_OFFSET_INDEX = 1;
        /** @private */
        ParticleSegmentedColorState.TIME_DATA_INDEX = 2;
        return ParticleSegmentedColorState;
    }(ParticleStateBase));

    /**
     *
     */
    var ParticleSegmentedColorNode = /** @class */ (function (_super) {
        __extends$5(ParticleSegmentedColorNode, _super);
        function ParticleSegmentedColorNode(usesMultiplier, usesOffset, numSegmentPoint, startColor, endColor, segmentPoints) {
            var _this = 
            //because of the stage3d register limitation, it only support the global mode
            _super.call(this, "ParticleSegmentedColor", ParticlePropertiesMode.GLOBAL, 0, ParticleAnimationSet.COLOR_PRIORITY) || this;
            _this._pStateClass = ParticleSegmentedColorState;
            if (numSegmentPoint > 4)
                throw (new Error("the numSegmentPoint must be less or equal 4"));
            _this._iUsesMultiplier = usesMultiplier;
            _this._iUsesOffset = usesOffset;
            _this._iNumSegmentPoint = numSegmentPoint;
            _this._iStartColor = startColor;
            _this._iEndColor = endColor;
            _this._iSegmentPoints = segmentPoints;
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleSegmentedColorNode.prototype._iProcessAnimationSetting = function (particleAnimationSet) {
            if (this._iUsesMultiplier)
                particleAnimationSet.hasColorMulNode = true;
            if (this._iUsesOffset)
                particleAnimationSet.hasColorAddNode = true;
        };
        /**
         * @inheritDoc
         */
        ParticleSegmentedColorNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var code = "";
            if (shader.usesFragmentAnimation) {
                var accMultiplierColor;
                //var accOffsetColor:ShaderRegisterElement;
                if (this._iUsesMultiplier) {
                    accMultiplierColor = registerCache.getFreeVertexVectorTemp();
                    registerCache.addVertexTempUsages(accMultiplierColor, 1);
                }
                var tempColor = registerCache.getFreeVertexVectorTemp();
                registerCache.addVertexTempUsages(tempColor, 1);
                var temp = registerCache.getFreeVertexVectorTemp();
                var accTime = new ShaderRegisterElement(temp.regName, temp.index, 0);
                var tempTime = new ShaderRegisterElement(temp.regName, temp.index, 1);
                if (this._iUsesMultiplier)
                    registerCache.removeVertexTempUsage(accMultiplierColor);
                registerCache.removeVertexTempUsage(tempColor);
                //for saving all the life values (at most 4)
                var lifeTimeRegister = registerCache.getFreeVertexConstant();
                animationRegisterData.setRegisterIndex(this, ParticleSegmentedColorState.TIME_DATA_INDEX, lifeTimeRegister.index);
                var i;
                var startMulValue;
                var deltaMulValues;
                if (this._iUsesMultiplier) {
                    startMulValue = registerCache.getFreeVertexConstant();
                    animationRegisterData.setRegisterIndex(this, ParticleSegmentedColorState.START_MULTIPLIER_INDEX, startMulValue.index);
                    deltaMulValues = new Array();
                    for (i = 0; i < this._iNumSegmentPoint + 1; i++)
                        deltaMulValues.push(registerCache.getFreeVertexConstant());
                }
                var startOffsetValue;
                var deltaOffsetValues;
                if (this._iUsesOffset) {
                    startOffsetValue = registerCache.getFreeVertexConstant();
                    animationRegisterData.setRegisterIndex(this, ParticleSegmentedColorState.START_OFFSET_INDEX, startOffsetValue.index);
                    deltaOffsetValues = new Array();
                    for (i = 0; i < this._iNumSegmentPoint + 1; i++)
                        deltaOffsetValues.push(registerCache.getFreeVertexConstant());
                }
                if (this._iUsesMultiplier)
                    code += "mov " + accMultiplierColor + "," + startMulValue + "\n";
                if (this._iUsesOffset)
                    code += "add " + animationRegisterData.colorAddTarget + "," + animationRegisterData.colorAddTarget + "," + startOffsetValue + "\n";
                for (i = 0; i < this._iNumSegmentPoint; i++) {
                    switch (i) {
                        case 0:
                            code += "min " + tempTime + "," + animationRegisterData.vertexLife + "," + lifeTimeRegister + ".x\n";
                            break;
                        case 1:
                            code += "sub " + accTime + "," + animationRegisterData.vertexLife + "," + lifeTimeRegister + ".x\n";
                            code += "max " + tempTime + "," + accTime + "," + animationRegisterData.vertexZeroConst + "\n";
                            code += "min " + tempTime + "," + tempTime + "," + lifeTimeRegister + ".y\n";
                            break;
                        case 2:
                            code += "sub " + accTime + "," + accTime + "," + lifeTimeRegister + ".y\n";
                            code += "max " + tempTime + "," + accTime + "," + animationRegisterData.vertexZeroConst + "\n";
                            code += "min " + tempTime + "," + tempTime + "," + lifeTimeRegister + ".z\n";
                            break;
                        case 3:
                            code += "sub " + accTime + "," + accTime + "," + lifeTimeRegister + ".z\n";
                            code += "max " + tempTime + "," + accTime + "," + animationRegisterData.vertexZeroConst + "\n";
                            code += "min " + tempTime + "," + tempTime + "," + lifeTimeRegister + ".w\n";
                            break;
                    }
                    if (this._iUsesMultiplier) {
                        code += "mul " + tempColor + "," + tempTime + "," + deltaMulValues[i] + "\n";
                        code += "add " + accMultiplierColor + "," + accMultiplierColor + "," + tempColor + "\n";
                    }
                    if (this._iUsesOffset) {
                        code += "mul " + tempColor + "," + tempTime + "," + deltaOffsetValues[i] + "\n";
                        code += "add " + animationRegisterData.colorAddTarget + "," + animationRegisterData.colorAddTarget + "," + tempColor + "\n";
                    }
                }
                //for the last segment:
                if (this._iNumSegmentPoint == 0)
                    tempTime = animationRegisterData.vertexLife;
                else {
                    switch (this._iNumSegmentPoint) {
                        case 1:
                            code += "sub " + accTime + "," + animationRegisterData.vertexLife + "," + lifeTimeRegister + ".x\n";
                            break;
                        case 2:
                            code += "sub " + accTime + "," + accTime + "," + lifeTimeRegister + ".y\n";
                            break;
                        case 3:
                            code += "sub " + accTime + "," + accTime + "," + lifeTimeRegister + ".z\n";
                            break;
                        case 4:
                            code += "sub " + accTime + "," + accTime + "," + lifeTimeRegister + ".w\n";
                            break;
                    }
                    code += "max " + tempTime + "," + accTime + "," + animationRegisterData.vertexZeroConst + "\n";
                }
                if (this._iUsesMultiplier) {
                    code += "mul " + tempColor + "," + tempTime + "," + deltaMulValues[this._iNumSegmentPoint] + "\n";
                    code += "add " + accMultiplierColor + "," + accMultiplierColor + "," + tempColor + "\n";
                    code += "mul " + animationRegisterData.colorMulTarget + "," + animationRegisterData.colorMulTarget + "," + accMultiplierColor + "\n";
                }
                if (this._iUsesOffset) {
                    code += "mul " + tempColor + "," + tempTime + "," + deltaOffsetValues[this._iNumSegmentPoint] + "\n";
                    code += "add " + animationRegisterData.colorAddTarget + "," + animationRegisterData.colorAddTarget + "," + tempColor + "\n";
                }
            }
            return code;
        };
        return ParticleSegmentedColorNode;
    }(ParticleNodeBase));

    /**
     * ...
     */
    var ParticleSpriteSheetState = /** @class */ (function (_super) {
        __extends$5(ParticleSpriteSheetState, _super);
        function ParticleSpriteSheetState(animator, particleSpriteSheetNode) {
            var _this = _super.call(this, animator, particleSpriteSheetNode) || this;
            _this._particleSpriteSheetNode = particleSpriteSheetNode;
            _this._usesCycle = _this._particleSpriteSheetNode._iUsesCycle;
            _this._usesPhase = _this._particleSpriteSheetNode._iUsesCycle;
            _this._totalFrames = _this._particleSpriteSheetNode._iTotalFrames;
            _this._numColumns = _this._particleSpriteSheetNode._iNumColumns;
            _this._numRows = _this._particleSpriteSheetNode._iNumRows;
            _this._cycleDuration = _this._particleSpriteSheetNode._iCycleDuration;
            _this._cyclePhase = _this._particleSpriteSheetNode._iCyclePhase;
            _this.updateSpriteSheetData();
            return _this;
        }
        Object.defineProperty(ParticleSpriteSheetState.prototype, "cyclePhase", {
            /**
             * Defines the cycle phase, when in global mode. Defaults to zero.
             */
            get: function () {
                return this._cyclePhase;
            },
            set: function (value) {
                this._cyclePhase = value;
                this.updateSpriteSheetData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleSpriteSheetState.prototype, "cycleDuration", {
            /**
             * Defines the cycle duration in seconds, when in global mode. Defaults to 1.
             */
            get: function () {
                return this._cycleDuration;
            },
            set: function (value) {
                this._cycleDuration = value;
                this.updateSpriteSheetData();
            },
            enumerable: true,
            configurable: true
        });
        ParticleSpriteSheetState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            if (!shader.usesUVTransform) {
                shader.setVertexConst(animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleSpriteSheetState.UV_INDEX_0), this._spriteSheetData[0], this._spriteSheetData[1], this._spriteSheetData[2], this._spriteSheetData[3]);
                if (this._usesCycle) {
                    var index = animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleSpriteSheetState.UV_INDEX_1);
                    if (this._particleSpriteSheetNode.mode == ParticlePropertiesMode.LOCAL_STATIC) {
                        if (this._usesPhase)
                            animationElements.activateVertexBuffer(index, this._particleSpriteSheetNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_3);
                        else
                            animationElements.activateVertexBuffer(index, this._particleSpriteSheetNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_2);
                    }
                    else
                        shader.setVertexConst(index, this._spriteSheetData[4], this._spriteSheetData[5]);
                }
            }
        };
        ParticleSpriteSheetState.prototype.updateSpriteSheetData = function () {
            this._spriteSheetData = new Array(8);
            var uTotal = this._totalFrames / this._numColumns;
            this._spriteSheetData[0] = uTotal;
            this._spriteSheetData[1] = 1 / this._numColumns;
            this._spriteSheetData[2] = 1 / this._numRows;
            if (this._usesCycle) {
                if (this._cycleDuration <= 0)
                    throw (new Error("the cycle duration must be greater than zero"));
                this._spriteSheetData[4] = uTotal / this._cycleDuration;
                this._spriteSheetData[5] = this._cycleDuration;
                if (this._usesPhase)
                    this._spriteSheetData[6] = this._cyclePhase;
            }
        };
        /** @private */
        ParticleSpriteSheetState.UV_INDEX_0 = 0;
        /** @private */
        ParticleSpriteSheetState.UV_INDEX_1 = 1;
        return ParticleSpriteSheetState;
    }(ParticleStateBase));

    /**
     * A particle animation node used when a spritesheet texture is required to animate the particle.
     * NB: to enable use of this node, the <code>repeat</code> property on the material has to be set to true.
     */
    var ParticleSpriteSheetNode = /** @class */ (function (_super) {
        __extends$5(ParticleSpriteSheetNode, _super);
        /**
         * Creates a new <code>ParticleSpriteSheetNode</code>
         *
         * @param               mode            Defines whether the mode of operation acts on local properties of a particle or global properties of the node.
         * @param    [optional] numColumns      Defines the number of columns in the spritesheet, when in global mode. Defaults to 1.
         * @param    [optional] numRows         Defines the number of rows in the spritesheet, when in global mode. Defaults to 1.
         * @param    [optional] cycleDuration   Defines the default cycle duration in seconds, when in global mode. Defaults to 1.
         * @param    [optional] cyclePhase      Defines the default cycle phase, when in global mode. Defaults to 0.
         * @param    [optional] totalFrames     Defines the total number of frames used by the spritesheet, when in global mode. Defaults to the number defined by numColumns and numRows.
         * @param    [optional] looping         Defines whether the spritesheet animation is set to loop indefinitely. Defaults to true.
         */
        function ParticleSpriteSheetNode(mode, usesCycle, usesPhase, numColumns, numRows, cycleDuration, cyclePhase, totalFrames) {
            if (numColumns === void 0) { numColumns = 1; }
            if (numRows === void 0) { numRows = 1; }
            if (cycleDuration === void 0) { cycleDuration = 1; }
            if (cyclePhase === void 0) { cyclePhase = 0; }
            if (totalFrames === void 0) { totalFrames = Number.MAX_VALUE; }
            var _this = _super.call(this, "ParticleSpriteSheet", mode, usesCycle ? (usesPhase ? 3 : 2) : 1, ParticleAnimationSet.POST_PRIORITY + 1) || this;
            _this._pStateClass = ParticleSpriteSheetState;
            _this._iUsesCycle = usesCycle;
            _this._iUsesPhase = usesPhase;
            _this._iNumColumns = numColumns;
            _this._iNumRows = numRows;
            _this._iCyclePhase = cyclePhase;
            _this._iCycleDuration = cycleDuration;
            _this._iTotalFrames = Math.min(totalFrames, numColumns * numRows);
            return _this;
        }
        Object.defineProperty(ParticleSpriteSheetNode.prototype, "numColumns", {
            /**
             * Defines the number of columns in the spritesheet, when in global mode. Defaults to 1. Read only.
             */
            get: function () {
                return this._iNumColumns;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleSpriteSheetNode.prototype, "numRows", {
            /**
             * Defines the number of rows in the spritesheet, when in global mode. Defaults to 1. Read only.
             */
            get: function () {
                return this._iNumRows;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleSpriteSheetNode.prototype, "totalFrames", {
            /**
             * Defines the total number of frames used by the spritesheet, when in global mode. Defaults to the number defined by numColumns and numRows. Read only.
             */
            get: function () {
                return this._iTotalFrames;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        ParticleSpriteSheetNode.prototype.getAGALUVCode = function (shader, animationSet, registerCache, animationRegisterData) {
            //get 2 vc
            var uvParamConst1 = registerCache.getFreeVertexConstant();
            var uvParamConst2 = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
            animationRegisterData.setRegisterIndex(this, ParticleSpriteSheetState.UV_INDEX_0, uvParamConst1.index);
            animationRegisterData.setRegisterIndex(this, ParticleSpriteSheetState.UV_INDEX_1, uvParamConst2.index);
            var uTotal = new ShaderRegisterElement(uvParamConst1.regName, uvParamConst1.index, 0);
            var uStep = new ShaderRegisterElement(uvParamConst1.regName, uvParamConst1.index, 1);
            var vStep = new ShaderRegisterElement(uvParamConst1.regName, uvParamConst1.index, 2);
            var uSpeed = new ShaderRegisterElement(uvParamConst2.regName, uvParamConst2.index, 0);
            var cycle = new ShaderRegisterElement(uvParamConst2.regName, uvParamConst2.index, 1);
            var phaseTime = new ShaderRegisterElement(uvParamConst2.regName, uvParamConst2.index, 2);
            var temp = registerCache.getFreeVertexVectorTemp();
            var time = new ShaderRegisterElement(temp.regName, temp.index, 0);
            var vOffset = new ShaderRegisterElement(temp.regName, temp.index, 1);
            temp = new ShaderRegisterElement(temp.regName, temp.index, 2);
            var temp2 = new ShaderRegisterElement(temp.regName, temp.index, 3);
            var u = new ShaderRegisterElement(animationRegisterData.uvTarget.regName, animationRegisterData.uvTarget.index, 0);
            var v = new ShaderRegisterElement(animationRegisterData.uvTarget.regName, animationRegisterData.uvTarget.index, 1);
            var code = "";
            //scale uv
            code += "mul " + u + "," + u + "," + uStep + "\n";
            if (this._iNumRows > 1)
                code += "mul " + v + "," + v + "," + vStep + "\n";
            if (this._iUsesCycle) {
                if (this._iUsesPhase)
                    code += "add " + time + "," + animationRegisterData.vertexTime + "," + phaseTime + "\n";
                else
                    code += "mov " + time + "," + animationRegisterData.vertexTime + "\n";
                code += "div " + time + "," + time + "," + cycle + "\n";
                code += "frc " + time + "," + time + "\n";
                code += "mul " + time + "," + time + "," + cycle + "\n";
                code += "mul " + temp + "," + time + "," + uSpeed + "\n";
            }
            else
                code += "mul " + temp.toString() + "," + animationRegisterData.vertexLife + "," + uTotal + "\n";
            if (this._iNumRows > 1) {
                code += "frc " + temp2 + "," + temp + "\n";
                code += "sub " + vOffset + "," + temp + "," + temp2 + "\n";
                code += "mul " + vOffset + "," + vOffset + "," + vStep + "\n";
                code += "add " + v + "," + v + "," + vOffset + "\n";
            }
            code += "div " + temp2 + "," + temp + "," + uStep + "\n";
            code += "frc " + temp + "," + temp2 + "\n";
            code += "sub " + temp2 + "," + temp2 + "," + temp + "\n";
            code += "mul " + temp + "," + temp2 + "," + uStep + "\n";
            if (this._iNumRows > 1)
                code += "frc " + temp + "," + temp + "\n";
            code += "add " + u + "," + u + "," + temp + "\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleSpriteSheetNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleSpriteSheetNode.prototype._iProcessAnimationSetting = function (particleAnimationSet) {
            particleAnimationSet.hasUVNode = true;
        };
        /**
         * @inheritDoc
         */
        ParticleSpriteSheetNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            if (this._iUsesCycle) {
                var uvCycle = param[ParticleSpriteSheetNode.UV_VECTOR3D];
                if (!uvCycle)
                    throw (new Error("there is no " + ParticleSpriteSheetNode.UV_VECTOR3D + " in param!"));
                if (uvCycle.x <= 0)
                    throw (new Error("the cycle duration must be greater than zero"));
                var uTotal = this._iTotalFrames / this._iNumColumns;
                this._pOneData[0] = uTotal / uvCycle.x;
                this._pOneData[1] = uvCycle.x;
                if (this._iUsesPhase)
                    this._pOneData[2] = uvCycle.y;
            }
        };
        /**
         * Reference for spritesheet node properties on a single particle (when in local property mode).
         * Expects a <code>Vector3D</code> representing the cycleDuration (x), optional phaseTime (y).
         */
        ParticleSpriteSheetNode.UV_VECTOR3D = "UVVector3D";
        return ParticleSpriteSheetNode;
    }(ParticleNodeBase));

    /**
     * ...
     */
    var ParticleUVState = /** @class */ (function (_super) {
        __extends$5(ParticleUVState, _super);
        function ParticleUVState(animator, particleUVNode) {
            var _this = _super.call(this, animator, particleUVNode) || this;
            _this._particleUVNode = particleUVNode;
            return _this;
        }
        ParticleUVState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            if (!shader.usesUVTransform) {
                var index = animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleUVState.UV_INDEX);
                var data = this._particleUVNode._iUvData;
                shader.setVertexConst(index, data.x, data.y);
            }
        };
        /** @private */
        ParticleUVState.UV_INDEX = 0;
        return ParticleUVState;
    }(ParticleStateBase));

    /**
     * A particle animation node used to control the UV offset and scale of a particle over time.
     */
    var ParticleUVNode = /** @class */ (function (_super) {
        __extends$5(ParticleUVNode, _super);
        /**
         * Creates a new <code>ParticleTimeNode</code>
         *
         * @param               mode            Defines whether the mode of operation acts on local properties of a particle or global properties of the node.
         * @param    [optional] cycle           Defines whether the time track is in loop mode. Defaults to false.
         * @param    [optional] scale           Defines whether the time track is in loop mode. Defaults to false.
         * @param    [optional] axis            Defines whether the time track is in loop mode. Defaults to false.
         */
        function ParticleUVNode(mode, cycle, scale, axis) {
            if (cycle === void 0) { cycle = 1; }
            if (scale === void 0) { scale = 1; }
            if (axis === void 0) { axis = "x"; }
            var _this = 
            //because of the stage3d register limitation, it only support the global mode
            _super.call(this, "ParticleUV", ParticlePropertiesMode.GLOBAL, 4, ParticleAnimationSet.POST_PRIORITY + 1) || this;
            _this._pStateClass = ParticleUVState;
            _this._cycle = cycle;
            _this._scale = scale;
            _this._axis = axis;
            _this.updateUVData();
            return _this;
        }
        Object.defineProperty(ParticleUVNode.prototype, "cycle", {
            /**
             *
             */
            get: function () {
                return this._cycle;
            },
            set: function (value) {
                this._cycle = value;
                this.updateUVData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleUVNode.prototype, "scale", {
            /**
             *
             */
            get: function () {
                return this._scale;
            },
            set: function (value) {
                this._scale = value;
                this.updateUVData();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleUVNode.prototype, "axis", {
            /**
             *
             */
            get: function () {
                return this._axis;
            },
            set: function (value) {
                this._axis = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        ParticleUVNode.prototype.getAGALUVCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var code = "";
            var uvConst = registerCache.getFreeVertexConstant();
            animationRegisterData.setRegisterIndex(this, ParticleUVState.UV_INDEX, uvConst.index);
            var axisIndex = this._axis == "x" ? 0 : (this._axis == "y" ? 1 : 2);
            var target = new ShaderRegisterElement(animationRegisterData.uvTarget.regName, animationRegisterData.uvTarget.index, axisIndex);
            var sin = registerCache.getFreeVertexSingleTemp();
            if (this._scale != 1)
                code += "mul " + target + "," + target + "," + uvConst + ".y\n";
            code += "mul " + sin + "," + animationRegisterData.vertexTime + "," + uvConst + ".x\n";
            code += "sin " + sin + "," + sin + "\n";
            code += "add " + target + "," + target + "," + sin + "\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleUVNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        ParticleUVNode.prototype.updateUVData = function () {
            this._iUvData = new Vector3D(Math.PI * 2 / this._cycle, this._scale, 0, 0);
        };
        /**
         * @inheritDoc
         */
        ParticleUVNode.prototype._iProcessAnimationSetting = function (particleAnimationSet) {
            particleAnimationSet.hasUVNode = true;
        };
        /**
         *
         */
        ParticleUVNode.U_AXIS = "x";
        /**
         *
         */
        ParticleUVNode.V_AXIS = "y";
        return ParticleUVNode;
    }(ParticleNodeBase));

    /**
     * ...
     */
    var ParticleVelocityState = /** @class */ (function (_super) {
        __extends$5(ParticleVelocityState, _super);
        function ParticleVelocityState(animator, particleVelocityNode) {
            var _this = _super.call(this, animator, particleVelocityNode) || this;
            _this._particleVelocityNode = particleVelocityNode;
            _this._velocity = _this._particleVelocityNode._iVelocity;
            return _this;
        }
        Object.defineProperty(ParticleVelocityState.prototype, "velocity", {
            /**
             * Defines the default velocity vector of the state, used when in global mode.
             */
            get: function () {
                return this._velocity;
            },
            set: function (value) {
                this._velocity = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        ParticleVelocityState.prototype.getVelocities = function () {
            return this._pDynamicProperties;
        };
        ParticleVelocityState.prototype.setVelocities = function (value) {
            this._pDynamicProperties = value;
            this._pDynamicPropertiesDirty = new Object();
        };
        ParticleVelocityState.prototype.setRenderState = function (shader, renderable, animationElements, animationRegisterData, projection, stage) {
            if (this._particleVelocityNode.mode == ParticlePropertiesMode.LOCAL_DYNAMIC && !this._pDynamicPropertiesDirty[animationElements._iUniqueId])
                this._pUpdateDynamicProperties(animationElements);
            var index = animationRegisterData.getRegisterIndex(this._pAnimationNode, ParticleVelocityState.VELOCITY_INDEX);
            if (this._particleVelocityNode.mode == ParticlePropertiesMode.GLOBAL)
                shader.setVertexConst(index, this._velocity.x, this._velocity.y, this._velocity.z);
            else
                animationElements.activateVertexBuffer(index, this._particleVelocityNode._iDataOffset, stage, ContextGLVertexBufferFormat.FLOAT_3);
        };
        /** @private */
        ParticleVelocityState.VELOCITY_INDEX = 0;
        return ParticleVelocityState;
    }(ParticleStateBase));

    /**
     * A particle animation node used to set the starting velocity of a particle.
     */
    var ParticleVelocityNode = /** @class */ (function (_super) {
        __extends$5(ParticleVelocityNode, _super);
        /**
         * Creates a new <code>ParticleVelocityNode</code>
         *
         * @param               mode            Defines whether the mode of operation acts on local properties of a particle or global properties of the node.
         * @param    [optional] velocity        Defines the default velocity vector of the node, used when in global mode.
         */
        function ParticleVelocityNode(mode, velocity) {
            if (velocity === void 0) { velocity = null; }
            var _this = _super.call(this, "ParticleVelocity", mode, 3) || this;
            _this._pStateClass = ParticleVelocityState;
            _this._iVelocity = velocity || new Vector3D();
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleVelocityNode.prototype.getAGALVertexCode = function (shader, animationSet, registerCache, animationRegisterData) {
            var velocityValue = (this._pMode == ParticlePropertiesMode.GLOBAL) ? registerCache.getFreeVertexConstant() : registerCache.getFreeVertexAttribute();
            animationRegisterData.setRegisterIndex(this, ParticleVelocityState.VELOCITY_INDEX, velocityValue.index);
            var distance = registerCache.getFreeVertexVectorTemp();
            var code = "";
            code += "mul " + distance + "," + animationRegisterData.vertexTime + "," + velocityValue + "\n";
            code += "add " + animationRegisterData.positionTarget + ".xyz," + distance + "," + animationRegisterData.positionTarget + ".xyz\n";
            if (animationSet.needVelocity)
                code += "add " + animationRegisterData.velocityTarget + ".xyz," + velocityValue + ".xyz," + animationRegisterData.velocityTarget + ".xyz\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        ParticleVelocityNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        ParticleVelocityNode.prototype._iGeneratePropertyOfOneParticle = function (param) {
            var _tempVelocity = param[ParticleVelocityNode.VELOCITY_VECTOR3D];
            if (!_tempVelocity)
                throw new Error("there is no " + ParticleVelocityNode.VELOCITY_VECTOR3D + " in param!");
            this._pOneData[0] = _tempVelocity.x;
            this._pOneData[1] = _tempVelocity.y;
            this._pOneData[2] = _tempVelocity.z;
        };
        /**
         * Reference for velocity node properties on a single particle (when in local property mode).
         * Expects a <code>Vector3D</code> object representing the direction of movement on the particle.
         */
        ParticleVelocityNode.VELOCITY_VECTOR3D = "VelocityVector3D";
        return ParticleVelocityNode;
    }(ParticleNodeBase));

    /**
     *
     */
    var SkeletonBinaryLERPState = /** @class */ (function (_super) {
        __extends$5(SkeletonBinaryLERPState, _super);
        function SkeletonBinaryLERPState(animator, skeletonAnimationNode) {
            var _this = _super.call(this, animator, skeletonAnimationNode) || this;
            _this._blendWeight = 0;
            _this._skeletonPose = new SkeletonPose();
            _this._skeletonPoseDirty = true;
            _this._skeletonAnimationNode = skeletonAnimationNode;
            _this._inputA = animator.getAnimationState(_this._skeletonAnimationNode.inputA);
            _this._inputB = animator.getAnimationState(_this._skeletonAnimationNode.inputB);
            return _this;
        }
        Object.defineProperty(SkeletonBinaryLERPState.prototype, "blendWeight", {
            /**
             * Defines a fractional value between 0 and 1 representing the blending ratio between inputA (0) and inputB (1),
             * used to produce the skeleton pose output.
             *
             * @see inputA
             * @see inputB
             */
            get: function () {
                return this._blendWeight;
            },
            set: function (value) {
                this._blendWeight = value;
                this._pPositionDeltaDirty = true;
                this._skeletonPoseDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        SkeletonBinaryLERPState.prototype.phase = function (value) {
            this._skeletonPoseDirty = true;
            this._pPositionDeltaDirty = true;
            this._inputA.phase(value);
            this._inputB.phase(value);
        };
        /**
         * @inheritDoc
         */
        SkeletonBinaryLERPState.prototype._pUpdateTime = function (time) {
            this._skeletonPoseDirty = true;
            this._inputA.update(time);
            this._inputB.update(time);
            _super.prototype._pUpdateTime.call(this, time);
        };
        /**
         * Returns the current skeleton pose of the animation in the clip based on the internal playhead position.
         */
        SkeletonBinaryLERPState.prototype.getSkeletonPose = function (skeleton) {
            if (this._skeletonPoseDirty)
                this.updateSkeletonPose(skeleton);
            return this._skeletonPose;
        };
        /**
         * @inheritDoc
         */
        SkeletonBinaryLERPState.prototype._pUpdatePositionDelta = function () {
            this._pPositionDeltaDirty = false;
            var deltA = this._inputA.positionDelta;
            var deltB = this._inputB.positionDelta;
            this._pRootDelta.x = deltA.x + this._blendWeight * (deltB.x - deltA.x);
            this._pRootDelta.y = deltA.y + this._blendWeight * (deltB.y - deltA.y);
            this._pRootDelta.z = deltA.z + this._blendWeight * (deltB.z - deltA.z);
        };
        /**
         * Updates the output skeleton pose of the node based on the blendWeight value between input nodes.
         *
         * @param skeleton The skeleton used by the animator requesting the ouput pose.
         */
        SkeletonBinaryLERPState.prototype.updateSkeletonPose = function (skeleton) {
            this._skeletonPoseDirty = false;
            var endPose;
            var endPoses = this._skeletonPose.jointPoses;
            var poses1 = this._inputA.getSkeletonPose(skeleton).jointPoses;
            var poses2 = this._inputB.getSkeletonPose(skeleton).jointPoses;
            var pose1, pose2;
            var p1, p2;
            var tr;
            var numJoints = skeleton.numJoints;
            // :s
            if (endPoses.length != numJoints)
                endPoses.length = numJoints;
            for (var i = 0; i < numJoints; ++i) {
                endPose = endPoses[i];
                if (endPose == null)
                    endPose = endPoses[i] = new JointPose();
                pose1 = poses1[i];
                pose2 = poses2[i];
                p1 = pose1.translation;
                p2 = pose2.translation;
                endPose.orientation.lerp(pose1.orientation, pose2.orientation, this._blendWeight);
                tr = endPose.translation;
                tr.x = p1.x + this._blendWeight * (p2.x - p1.x);
                tr.y = p1.y + this._blendWeight * (p2.y - p1.y);
                tr.z = p1.z + this._blendWeight * (p2.z - p1.z);
            }
        };
        return SkeletonBinaryLERPState;
    }(AnimationStateBase));

    /**
     * A skeleton animation node that uses two animation node inputs to blend a lineraly interpolated output of a skeleton pose.
     */
    var SkeletonBinaryLERPNode = /** @class */ (function (_super) {
        __extends$5(SkeletonBinaryLERPNode, _super);
        /**
         * Creates a new <code>SkeletonBinaryLERPNode</code> object.
         */
        function SkeletonBinaryLERPNode() {
            var _this = _super.call(this) || this;
            _this._pStateClass = SkeletonBinaryLERPState;
            return _this;
        }
        /**
         * @inheritDoc
         */
        SkeletonBinaryLERPNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        return SkeletonBinaryLERPNode;
    }(AnimationNodeBase));

    /**
     * Dispatched to notify changes in an animation state's state.
     */
    var AnimationStateEvent = /** @class */ (function (_super) {
        __extends$5(AnimationStateEvent, _super);
        /**
         * Create a new <code>AnimatonStateEvent</code>
         *
         * @param type The event type.
         * @param animator The animation state object that is the subject of this event.
         * @param animationNode The animation node inside the animation state from which the event originated.
         */
        function AnimationStateEvent(type, animator, animationState, animationNode) {
            var _this = _super.call(this, type) || this;
            _this._animator = animator;
            _this._animationState = animationState;
            _this._animationNode = animationNode;
            return _this;
        }
        Object.defineProperty(AnimationStateEvent.prototype, "animator", {
            /**
             * The animator object that is the subject of this event.
             */
            get: function () {
                return this._animator;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationStateEvent.prototype, "animationState", {
            /**
             * The animation state object that is the subject of this event.
             */
            get: function () {
                return this._animationState;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationStateEvent.prototype, "animationNode", {
            /**
             * The animation node inside the animation state from which the event originated.
             */
            get: function () {
                return this._animationNode;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the event.
         *
         * @return An exact duplicate of the current object.
         */
        AnimationStateEvent.prototype.clone = function () {
            return new AnimationStateEvent(this.type, this._animator, this._animationState, this._animationNode);
        };
        /**
         * Dispatched when a non-looping clip node inside an animation state reaches the end of its timeline.
         */
        AnimationStateEvent.PLAYBACK_COMPLETE = "playbackComplete";
        AnimationStateEvent.TRANSITION_COMPLETE = "transitionComplete";
        return AnimationStateEvent;
    }(EventBase));

    /**
     *
     */
    var AnimationClipState = /** @class */ (function (_super) {
        __extends$5(AnimationClipState, _super);
        function AnimationClipState(animator, animationClipNode) {
            var _this = _super.call(this, animator, animationClipNode) || this;
            _this._pFramesDirty = true;
            _this._animationClipNode = animationClipNode;
            return _this;
        }
        Object.defineProperty(AnimationClipState.prototype, "blendWeight", {
            /**
             * Returns a fractional value between 0 and 1 representing the blending ratio of the current playhead position
             * between the current frame (0) and next frame (1) of the animation.
             *
             * @see #currentFrame
             * @see #nextFrame
             */
            get: function () {
                if (this._pFramesDirty)
                    this._pUpdateFrames();
                return this._pBlendWeight;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationClipState.prototype, "currentFrame", {
            /**
             * Returns the current frame of animation in the clip based on the internal playhead position.
             */
            get: function () {
                if (this._pFramesDirty)
                    this._pUpdateFrames();
                return this._pCurrentFrame;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimationClipState.prototype, "nextFrame", {
            /**
             * Returns the next frame of animation in the clip based on the internal playhead position.
             */
            get: function () {
                if (this._pFramesDirty)
                    this._pUpdateFrames();
                return this._pNextFrame;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        AnimationClipState.prototype.update = function (time) {
            if (!this._animationClipNode.looping) {
                if (time > this._pStartTime + this._animationClipNode.totalDuration)
                    time = this._pStartTime + this._animationClipNode.totalDuration;
                else if (time < this._pStartTime)
                    time = this._pStartTime;
            }
            if (this._pTime == time - this._pStartTime)
                return;
            this._pUpdateTime(time);
        };
        /**
         * @inheritDoc
         */
        AnimationClipState.prototype.phase = function (value) {
            var time = value * this._animationClipNode.totalDuration + this._pStartTime;
            if (this._pTime == time - this._pStartTime)
                return;
            this._pUpdateTime(time);
        };
        /**
         * @inheritDoc
         */
        AnimationClipState.prototype._pUpdateTime = function (time) {
            this._pFramesDirty = true;
            this._pTimeDir = (time - this._pStartTime > this._pTime) ? 1 : -1;
            _super.prototype._pUpdateTime.call(this, time);
        };
        /**
         * Updates the nodes internal playhead to determine the current and next animation frame, and the blendWeight between the two.
         *
         * @see #currentFrame
         * @see #nextFrame
         * @see #blendWeight
         */
        AnimationClipState.prototype._pUpdateFrames = function () {
            this._pFramesDirty = false;
            var looping = this._animationClipNode.looping;
            var totalDuration = this._animationClipNode.totalDuration;
            var lastFrame = this._animationClipNode.lastFrame;
            var time = this._pTime;
            //trace("time", time, totalDuration)
            if (looping && (time >= totalDuration || time < 0)) {
                time %= totalDuration;
                if (time < 0)
                    time += totalDuration;
            }
            if (!looping && time >= totalDuration) {
                this.notifyPlaybackComplete();
                this._pCurrentFrame = lastFrame;
                this._pNextFrame = lastFrame;
                this._pBlendWeight = 0;
            }
            else if (!looping && time <= 0) {
                this._pCurrentFrame = 0;
                this._pNextFrame = 0;
                this._pBlendWeight = 0;
            }
            else if (this._animationClipNode.fixedFrameRate) {
                var t = time / totalDuration * lastFrame;
                this._pCurrentFrame = Math.floor(t);
                this._pBlendWeight = t - this._pCurrentFrame;
                this._pNextFrame = this._pCurrentFrame + 1;
            }
            else {
                this._pCurrentFrame = 0;
                this._pNextFrame = 0;
                var dur = 0, frameTime;
                var durations = this._animationClipNode.durations;
                do {
                    frameTime = dur;
                    dur += durations[this._pNextFrame];
                    this._pCurrentFrame = this._pNextFrame++;
                } while (time > dur);
                if (this._pCurrentFrame == lastFrame) {
                    this._pCurrentFrame = 0;
                    this._pNextFrame = 1;
                }
                this._pBlendWeight = (time - frameTime) / durations[this._pCurrentFrame];
            }
        };
        AnimationClipState.prototype.notifyPlaybackComplete = function () {
            if (this._animationStatePlaybackComplete == null)
                this._animationStatePlaybackComplete = new AnimationStateEvent(AnimationStateEvent.PLAYBACK_COMPLETE, this._pAnimator, this, this._animationClipNode);
            this._animationClipNode.dispatchEvent(this._animationStatePlaybackComplete);
        };
        return AnimationClipState;
    }(AnimationStateBase));

    /**
     *
     */
    var SkeletonClipState = /** @class */ (function (_super) {
        __extends$5(SkeletonClipState, _super);
        function SkeletonClipState(animator, skeletonClipNode) {
            var _this = _super.call(this, animator, skeletonClipNode) || this;
            _this._rootPos = new Vector3D();
            _this._skeletonPose = new SkeletonPose();
            _this._skeletonPoseDirty = true;
            _this._skeletonClipNode = skeletonClipNode;
            _this._frames = _this._skeletonClipNode.frames;
            return _this;
        }
        Object.defineProperty(SkeletonClipState.prototype, "currentPose", {
            /**
             * Returns the current skeleton pose frame of animation in the clip based on the internal playhead position.
             */
            get: function () {
                if (this._pFramesDirty)
                    this._pUpdateFrames();
                return this._currentPose;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SkeletonClipState.prototype, "nextPose", {
            /**
             * Returns the next skeleton pose frame of animation in the clip based on the internal playhead position.
             */
            get: function () {
                if (this._pFramesDirty)
                    this._pUpdateFrames();
                return this._nextPose;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns the current skeleton pose of the animation in the clip based on the internal playhead position.
         */
        SkeletonClipState.prototype.getSkeletonPose = function (skeleton) {
            if (this._skeletonPoseDirty)
                this.updateSkeletonPose(skeleton);
            return this._skeletonPose;
        };
        /**
         * @inheritDoc
         */
        SkeletonClipState.prototype._pUpdateTime = function (time) {
            this._skeletonPoseDirty = true;
            _super.prototype._pUpdateTime.call(this, time);
        };
        /**
         * @inheritDoc
         */
        SkeletonClipState.prototype._pUpdateFrames = function () {
            _super.prototype._pUpdateFrames.call(this);
            this._currentPose = this._frames[this._pCurrentFrame];
            if (this._skeletonClipNode.looping && this._pNextFrame >= this._skeletonClipNode.lastFrame) {
                this._nextPose = this._frames[0];
                this._pAnimator.dispatchCycleEvent();
            }
            else
                this._nextPose = this._frames[this._pNextFrame];
        };
        /**
         * Updates the output skeleton pose of the node based on the internal playhead position.
         *
         * @param skeleton The skeleton used by the animator requesting the ouput pose.
         */
        SkeletonClipState.prototype.updateSkeletonPose = function (skeleton) {
            this._skeletonPoseDirty = false;
            if (!this._skeletonClipNode.totalDuration)
                return;
            if (this._pFramesDirty)
                this._pUpdateFrames();
            var currentPose = this._currentPose.jointPoses;
            var nextPose = this._nextPose.jointPoses;
            var numJoints = skeleton.numJoints;
            var p1, p2;
            var pose1, pose2;
            var endPoses = this._skeletonPose.jointPoses;
            var endPose;
            var tr;
            // :s
            if (endPoses.length != numJoints)
                endPoses.length = numJoints;
            if ((numJoints != currentPose.length) || (numJoints != nextPose.length))
                throw new Error("joint counts don't match!");
            for (var i = 0; i < numJoints; ++i) {
                endPose = endPoses[i];
                if (endPose == null)
                    endPose = endPoses[i] = new JointPose();
                pose1 = currentPose[i];
                pose2 = nextPose[i];
                p1 = pose1.translation;
                p2 = pose2.translation;
                if (this._skeletonClipNode.highQuality)
                    endPose.orientation.slerp(pose1.orientation, pose2.orientation, this._pBlendWeight);
                else
                    endPose.orientation.lerp(pose1.orientation, pose2.orientation, this._pBlendWeight);
                if (i > 0) {
                    tr = endPose.translation;
                    tr.x = p1.x + this._pBlendWeight * (p2.x - p1.x);
                    tr.y = p1.y + this._pBlendWeight * (p2.y - p1.y);
                    tr.z = p1.z + this._pBlendWeight * (p2.z - p1.z);
                }
            }
        };
        /**
         * @inheritDoc
         */
        SkeletonClipState.prototype._pUpdatePositionDelta = function () {
            this._pPositionDeltaDirty = false;
            if (this._pFramesDirty)
                this._pUpdateFrames();
            var p1, p2, p3;
            var totalDelta = this._skeletonClipNode.totalDelta;
            // jumping back, need to reset position
            if ((this._pTimeDir > 0 && this._pNextFrame < this._pOldFrame) || (this._pTimeDir < 0 && this._pNextFrame > this._pOldFrame)) {
                this._rootPos.x -= totalDelta.x * this._pTimeDir;
                this._rootPos.y -= totalDelta.y * this._pTimeDir;
                this._rootPos.z -= totalDelta.z * this._pTimeDir;
            }
            var dx = this._rootPos.x;
            var dy = this._rootPos.y;
            var dz = this._rootPos.z;
            if (this._skeletonClipNode.stitchFinalFrame && this._pNextFrame == this._skeletonClipNode.lastFrame) {
                p1 = this._frames[0].jointPoses[0].translation;
                p2 = this._frames[1].jointPoses[0].translation;
                p3 = this._currentPose.jointPoses[0].translation;
                this._rootPos.x = p3.x + p1.x + this._pBlendWeight * (p2.x - p1.x);
                this._rootPos.y = p3.y + p1.y + this._pBlendWeight * (p2.y - p1.y);
                this._rootPos.z = p3.z + p1.z + this._pBlendWeight * (p2.z - p1.z);
            }
            else {
                p1 = this._currentPose.jointPoses[0].translation;
                p2 = this._frames[this._pNextFrame].jointPoses[0].translation; //cover the instances where we wrap the pose but still want the final frame translation values
                this._rootPos.x = p1.x + this._pBlendWeight * (p2.x - p1.x);
                this._rootPos.y = p1.y + this._pBlendWeight * (p2.y - p1.y);
                this._rootPos.z = p1.z + this._pBlendWeight * (p2.z - p1.z);
            }
            this._pRootDelta.x = this._rootPos.x - dx;
            this._pRootDelta.y = this._rootPos.y - dy;
            this._pRootDelta.z = this._rootPos.z - dz;
            this._pOldFrame = this._pNextFrame;
        };
        return SkeletonClipState;
    }(AnimationClipState));

    /**
     * A skeleton animation node containing time-based animation data as individual skeleton poses.
     */
    var SkeletonClipNode = /** @class */ (function (_super) {
        __extends$5(SkeletonClipNode, _super);
        /**
         * Creates a new <code>SkeletonClipNode</code> object.
         */
        function SkeletonClipNode() {
            var _this = _super.call(this) || this;
            _this._frames = new Array();
            /**
             * Determines whether to use SLERP equations (true) or LERP equations (false) in the calculation
             * of the output skeleton pose. Defaults to false.
             */
            _this.highQuality = false;
            _this._pStateClass = SkeletonClipState;
            return _this;
        }
        Object.defineProperty(SkeletonClipNode.prototype, "frames", {
            /**
             * Returns a vector of skeleton poses representing the pose of each animation frame in the clip.
             */
            get: function () {
                return this._frames;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Adds a skeleton pose frame to the internal timeline of the animation node.
         *
         * @param skeletonPose The skeleton pose object to add to the timeline of the node.
         * @param duration The specified duration of the frame in milliseconds.
         */
        SkeletonClipNode.prototype.addFrame = function (skeletonPose, duration) {
            this._frames.push(skeletonPose);
            this._pDurations.push(duration);
            this._pNumFrames = this._pDurations.length;
            this._pStitchDirty = true;
        };
        /**
         * @inheritDoc
         */
        SkeletonClipNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        /**
         * @inheritDoc
         */
        SkeletonClipNode.prototype._pUpdateStitch = function () {
            _super.prototype._pUpdateStitch.call(this);
            var i = this._pNumFrames - 1;
            var p1, p2, delta;
            while (i--) {
                this._pTotalDuration += this._pDurations[i];
                p1 = this._frames[i].jointPoses[0].translation;
                p2 = this._frames[i + 1].jointPoses[0].translation;
                delta = p2.subtract(p1);
                this._pTotalDelta.x += delta.x;
                this._pTotalDelta.y += delta.y;
                this._pTotalDelta.z += delta.z;
            }
            if (this._pStitchFinalFrame || !this._pLooping) {
                this._pTotalDuration += this._pDurations[this._pNumFrames - 1];
                p1 = this._frames[0].jointPoses[0].translation;
                p2 = this._frames[1].jointPoses[0].translation;
                delta = p2.subtract(p1);
                this._pTotalDelta.x += delta.x;
                this._pTotalDelta.y += delta.y;
                this._pTotalDelta.z += delta.z;
            }
        };
        return SkeletonClipNode;
    }(AnimationClipNodeBase));

    /**
     *
     */
    var SkeletonDifferenceState = /** @class */ (function (_super) {
        __extends$5(SkeletonDifferenceState, _super);
        function SkeletonDifferenceState(animator, skeletonAnimationNode) {
            var _this = _super.call(this, animator, skeletonAnimationNode) || this;
            _this._blendWeight = 0;
            _this._skeletonPose = new SkeletonPose();
            _this._skeletonPoseDirty = true;
            _this._skeletonAnimationNode = skeletonAnimationNode;
            _this._baseInput = animator.getAnimationState(_this._skeletonAnimationNode.baseInput);
            _this._differenceInput = animator.getAnimationState(_this._skeletonAnimationNode.differenceInput);
            return _this;
        }
        Object.defineProperty(SkeletonDifferenceState.prototype, "blendWeight", {
            /**
             * Defines a fractional value between 0 and 1 representing the blending ratio between the base input (0) and difference input (1),
             * used to produce the skeleton pose output.
             *
             * @see #baseInput
             * @see #differenceInput
             */
            get: function () {
                return this._blendWeight;
            },
            set: function (value) {
                this._blendWeight = value;
                this._pPositionDeltaDirty = true;
                this._skeletonPoseDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        SkeletonDifferenceState.prototype.phase = function (value) {
            this._skeletonPoseDirty = true;
            this._pPositionDeltaDirty = true;
            this._baseInput.phase(value);
            this._baseInput.phase(value);
        };
        /**
         * @inheritDoc
         */
        SkeletonDifferenceState.prototype._pUpdateTime = function (time) {
            this._skeletonPoseDirty = true;
            this._baseInput.update(time);
            this._differenceInput.update(time);
            _super.prototype._pUpdateTime.call(this, time);
        };
        /**
         * Returns the current skeleton pose of the animation in the clip based on the internal playhead position.
         */
        SkeletonDifferenceState.prototype.getSkeletonPose = function (skeleton) {
            if (this._skeletonPoseDirty)
                this.updateSkeletonPose(skeleton);
            return this._skeletonPose;
        };
        /**
         * @inheritDoc
         */
        SkeletonDifferenceState.prototype._pUpdatePositionDelta = function () {
            this._pPositionDeltaDirty = false;
            var deltA = this._baseInput.positionDelta;
            var deltB = this._differenceInput.positionDelta;
            this.positionDelta.x = deltA.x + this._blendWeight * deltB.x;
            this.positionDelta.y = deltA.y + this._blendWeight * deltB.y;
            this.positionDelta.z = deltA.z + this._blendWeight * deltB.z;
        };
        /**
         * Updates the output skeleton pose of the node based on the blendWeight value between base input and difference input nodes.
         *
         * @param skeleton The skeleton used by the animator requesting the ouput pose.
         */
        SkeletonDifferenceState.prototype.updateSkeletonPose = function (skeleton) {
            this._skeletonPoseDirty = false;
            var endPose;
            var endPoses = this._skeletonPose.jointPoses;
            var basePoses = this._baseInput.getSkeletonPose(skeleton).jointPoses;
            var diffPoses = this._differenceInput.getSkeletonPose(skeleton).jointPoses;
            var base, diff;
            var basePos, diffPos;
            var tr;
            var numJoints = skeleton.numJoints;
            // :s
            if (endPoses.length != numJoints)
                endPoses.length = numJoints;
            for (var i = 0; i < numJoints; ++i) {
                endPose = endPoses[i];
                if (endPose == null)
                    endPose = endPoses[i] = new JointPose();
                base = basePoses[i];
                diff = diffPoses[i];
                basePos = base.translation;
                diffPos = diff.translation;
                SkeletonDifferenceState._tempQuat.multiply(diff.orientation, base.orientation);
                endPose.orientation.lerp(base.orientation, SkeletonDifferenceState._tempQuat, this._blendWeight);
                tr = endPose.translation;
                tr.x = basePos.x + this._blendWeight * diffPos.x;
                tr.y = basePos.y + this._blendWeight * diffPos.y;
                tr.z = basePos.z + this._blendWeight * diffPos.z;
            }
        };
        SkeletonDifferenceState._tempQuat = new Quaternion();
        return SkeletonDifferenceState;
    }(AnimationStateBase));

    /**
     * A skeleton animation node that uses a difference input pose with a base input pose to blend a linearly interpolated output of a skeleton pose.
     */
    var SkeletonDifferenceNode = /** @class */ (function (_super) {
        __extends$5(SkeletonDifferenceNode, _super);
        /**
         * Creates a new <code>SkeletonAdditiveNode</code> object.
         */
        function SkeletonDifferenceNode() {
            var _this = _super.call(this) || this;
            _this._pStateClass = SkeletonDifferenceState;
            return _this;
        }
        /**
         * @inheritDoc
         */
        SkeletonDifferenceNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        return SkeletonDifferenceNode;
    }(AnimationNodeBase));

    /**
     *
     */
    var SkeletonDirectionalState = /** @class */ (function (_super) {
        __extends$5(SkeletonDirectionalState, _super);
        function SkeletonDirectionalState(animator, skeletonAnimationNode) {
            var _this = _super.call(this, animator, skeletonAnimationNode) || this;
            _this._skeletonPose = new SkeletonPose();
            _this._skeletonPoseDirty = true;
            _this._blendWeight = 0;
            _this._direction = 0;
            _this._blendDirty = true;
            _this._skeletonAnimationNode = skeletonAnimationNode;
            _this._forward = animator.getAnimationState(_this._skeletonAnimationNode.forward);
            _this._backward = animator.getAnimationState(_this._skeletonAnimationNode.backward);
            _this._left = animator.getAnimationState(_this._skeletonAnimationNode.left);
            _this._right = animator.getAnimationState(_this._skeletonAnimationNode.right);
            return _this;
        }
        Object.defineProperty(SkeletonDirectionalState.prototype, "direction", {
            get: function () {
                return this._direction;
            },
            /**
             * Defines the direction in degrees of the aniamtion between the forwards (0), right(90) backwards (180) and left(270) input nodes,
             * used to produce the skeleton pose output.
             */
            set: function (value) {
                if (this._direction == value)
                    return;
                this._direction = value;
                this._blendDirty = true;
                this._skeletonPoseDirty = true;
                this._pPositionDeltaDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        SkeletonDirectionalState.prototype.phase = function (value) {
            if (this._blendDirty)
                this.updateBlend();
            this._skeletonPoseDirty = true;
            this._pPositionDeltaDirty = true;
            this._inputA.phase(value);
            this._inputB.phase(value);
        };
        /**
         * @inheritDoc
         */
        SkeletonDirectionalState.prototype._pUdateTime = function (time) {
            if (this._blendDirty)
                this.updateBlend();
            this._skeletonPoseDirty = true;
            this._inputA.update(time);
            this._inputB.update(time);
            _super.prototype._pUpdateTime.call(this, time);
        };
        /**
         * Returns the current skeleton pose of the animation in the clip based on the internal playhead position.
         */
        SkeletonDirectionalState.prototype.getSkeletonPose = function (skeleton) {
            if (this._skeletonPoseDirty)
                this.updateSkeletonPose(skeleton);
            return this._skeletonPose;
        };
        /**
         * @inheritDoc
         */
        SkeletonDirectionalState.prototype._pUpdatePositionDelta = function () {
            this._pPositionDeltaDirty = false;
            if (this._blendDirty)
                this.updateBlend();
            var deltA = this._inputA.positionDelta;
            var deltB = this._inputB.positionDelta;
            this.positionDelta.x = deltA.x + this._blendWeight * (deltB.x - deltA.x);
            this.positionDelta.y = deltA.y + this._blendWeight * (deltB.y - deltA.y);
            this.positionDelta.z = deltA.z + this._blendWeight * (deltB.z - deltA.z);
        };
        /**
         * Updates the output skeleton pose of the node based on the direction value between forward, backwards, left and right input nodes.
         *
         * @param skeleton The skeleton used by the animator requesting the ouput pose.
         */
        SkeletonDirectionalState.prototype.updateSkeletonPose = function (skeleton) {
            this._skeletonPoseDirty = false;
            if (this._blendDirty)
                this.updateBlend();
            var endPose;
            var endPoses = this._skeletonPose.jointPoses;
            var poses1 = this._inputA.getSkeletonPose(skeleton).jointPoses;
            var poses2 = this._inputB.getSkeletonPose(skeleton).jointPoses;
            var pose1, pose2;
            var p1, p2;
            var tr;
            var numJoints = skeleton.numJoints;
            // :s
            if (endPoses.length != numJoints)
                endPoses.length = numJoints;
            for (var i = 0; i < numJoints; ++i) {
                endPose = endPoses[i];
                if (endPose == null)
                    endPose = endPoses[i] = new JointPose();
                pose1 = poses1[i];
                pose2 = poses2[i];
                p1 = pose1.translation;
                p2 = pose2.translation;
                endPose.orientation.lerp(pose1.orientation, pose2.orientation, this._blendWeight);
                tr = endPose.translation;
                tr.x = p1.x + this._blendWeight * (p2.x - p1.x);
                tr.y = p1.y + this._blendWeight * (p2.y - p1.y);
                tr.z = p1.z + this._blendWeight * (p2.z - p1.z);
            }
        };
        /**
         * Updates the blend value for the animation output based on the direction value between forward, backwards, left and right input nodes.
         *
         * @private
         */
        SkeletonDirectionalState.prototype.updateBlend = function () {
            this._blendDirty = false;
            if (this._direction < 0 || this._direction > 360) {
                this._direction %= 360;
                if (this._direction < 0)
                    this._direction += 360;
            }
            if (this._direction < 90) {
                this._inputA = this._forward;
                this._inputB = this._right;
                this._blendWeight = this._direction / 90;
            }
            else if (this._direction < 180) {
                this._inputA = this._right;
                this._inputB = this._backward;
                this._blendWeight = (this._direction - 90) / 90;
            }
            else if (this._direction < 270) {
                this._inputA = this._backward;
                this._inputB = this._left;
                this._blendWeight = (this._direction - 180) / 90;
            }
            else {
                this._inputA = this._left;
                this._inputB = this._forward;
                this._blendWeight = (this._direction - 270) / 90;
            }
        };
        return SkeletonDirectionalState;
    }(AnimationStateBase));

    /**
     * A skeleton animation node that uses four directional input poses with an input direction to blend a linearly interpolated output of a skeleton pose.
     */
    var SkeletonDirectionalNode = /** @class */ (function (_super) {
        __extends$5(SkeletonDirectionalNode, _super);
        function SkeletonDirectionalNode() {
            var _this = _super.call(this) || this;
            _this._pStateClass = SkeletonDirectionalState;
            return _this;
        }
        /**
         * @inheritDoc
         */
        SkeletonDirectionalNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        return SkeletonDirectionalNode;
    }(AnimationNodeBase));

    /**
     *
     */
    var SkeletonNaryLERPState = /** @class */ (function (_super) {
        __extends$5(SkeletonNaryLERPState, _super);
        function SkeletonNaryLERPState(animator, skeletonAnimationNode) {
            var _this = _super.call(this, animator, skeletonAnimationNode) || this;
            _this._skeletonPose = new SkeletonPose();
            _this._skeletonPoseDirty = true;
            _this._blendWeights = new Array();
            _this._inputs = new Array();
            _this._skeletonAnimationNode = skeletonAnimationNode;
            var i = _this._skeletonAnimationNode.numInputs;
            while (i--)
                _this._inputs[i] = animator.getAnimationState(_this._skeletonAnimationNode._iInputs[i]);
            return _this;
        }
        /**
         * @inheritDoc
         */
        SkeletonNaryLERPState.prototype.phase = function (value) {
            this._skeletonPoseDirty = true;
            this._pPositionDeltaDirty = true;
            for (var j = 0; j < this._skeletonAnimationNode.numInputs; ++j) {
                if (this._blendWeights[j])
                    this._inputs[j].update(value);
            }
        };
        /**
         * @inheritDoc
         */
        SkeletonNaryLERPState.prototype._pUdateTime = function (time) {
            for (var j = 0; j < this._skeletonAnimationNode.numInputs; ++j) {
                if (this._blendWeights[j])
                    this._inputs[j].update(time);
            }
            _super.prototype._pUpdateTime.call(this, time);
        };
        /**
         * Returns the current skeleton pose of the animation in the clip based on the internal playhead position.
         */
        SkeletonNaryLERPState.prototype.getSkeletonPose = function (skeleton) {
            if (this._skeletonPoseDirty)
                this.updateSkeletonPose(skeleton);
            return this._skeletonPose;
        };
        /**
         * Returns the blend weight of the skeleton aniamtion node that resides at the given input index.
         *
         * @param index The input index for which the skeleton animation node blend weight is requested.
         */
        SkeletonNaryLERPState.prototype.getBlendWeightAt = function (index) {
            return this._blendWeights[index];
        };
        /**
         * Sets the blend weight of the skeleton aniamtion node that resides at the given input index.
         *
         * @param index The input index on which the skeleton animation node blend weight is to be set.
         * @param blendWeight The blend weight value to use for the given skeleton animation node index.
         */
        SkeletonNaryLERPState.prototype.setBlendWeightAt = function (index, blendWeight) {
            this._blendWeights[index] = blendWeight;
            this._pPositionDeltaDirty = true;
            this._skeletonPoseDirty = true;
        };
        /**
         * @inheritDoc
         */
        SkeletonNaryLERPState.prototype._pUpdatePositionDelta = function () {
            this._pPositionDeltaDirty = false;
            var delta;
            var weight;
            this.positionDelta.x = 0;
            this.positionDelta.y = 0;
            this.positionDelta.z = 0;
            for (var j = 0; j < this._skeletonAnimationNode.numInputs; ++j) {
                weight = this._blendWeights[j];
                if (weight) {
                    delta = this._inputs[j].positionDelta;
                    this.positionDelta.x += weight * delta.x;
                    this.positionDelta.y += weight * delta.y;
                    this.positionDelta.z += weight * delta.z;
                }
            }
        };
        /**
         * Updates the output skeleton pose of the node based on the blend weight values given to the input nodes.
         *
         * @param skeleton The skeleton used by the animator requesting the ouput pose.
         */
        SkeletonNaryLERPState.prototype.updateSkeletonPose = function (skeleton) {
            this._skeletonPoseDirty = false;
            var weight;
            var endPoses = this._skeletonPose.jointPoses;
            var poses;
            var endPose, pose;
            var endTr, tr;
            var endQuat, q;
            var firstPose;
            var i;
            var w0, x0, y0, z0;
            var w1, x1, y1, z1;
            var numJoints = skeleton.numJoints;
            // :s
            if (endPoses.length != numJoints)
                endPoses.length = numJoints;
            for (var j = 0; j < this._skeletonAnimationNode.numInputs; ++j) {
                weight = this._blendWeights[j];
                if (!weight)
                    continue;
                poses = this._inputs[j].getSkeletonPose(skeleton).jointPoses;
                if (!firstPose) {
                    firstPose = poses;
                    for (i = 0; i < numJoints; ++i) {
                        endPose = endPoses[i];
                        if (endPose == null)
                            endPose = endPoses[i] = new JointPose();
                        pose = poses[i];
                        q = pose.orientation;
                        tr = pose.translation;
                        endQuat = endPose.orientation;
                        endQuat.x = weight * q.x;
                        endQuat.y = weight * q.y;
                        endQuat.z = weight * q.z;
                        endQuat.w = weight * q.w;
                        endTr = endPose.translation;
                        endTr.x = weight * tr.x;
                        endTr.y = weight * tr.y;
                        endTr.z = weight * tr.z;
                    }
                }
                else {
                    for (i = 0; i < skeleton.numJoints; ++i) {
                        endPose = endPoses[i];
                        pose = poses[i];
                        q = firstPose[i].orientation;
                        x0 = q.x;
                        y0 = q.y;
                        z0 = q.z;
                        w0 = q.w;
                        q = pose.orientation;
                        tr = pose.translation;
                        x1 = q.x;
                        y1 = q.y;
                        z1 = q.z;
                        w1 = q.w;
                        // find shortest direction
                        if (x0 * x1 + y0 * y1 + z0 * z1 + w0 * w1 < 0) {
                            x1 = -x1;
                            y1 = -y1;
                            z1 = -z1;
                            w1 = -w1;
                        }
                        endQuat = endPose.orientation;
                        endQuat.x += weight * x1;
                        endQuat.y += weight * y1;
                        endQuat.z += weight * z1;
                        endQuat.w += weight * w1;
                        endTr = endPose.translation;
                        endTr.x += weight * tr.x;
                        endTr.y += weight * tr.y;
                        endTr.z += weight * tr.z;
                    }
                }
            }
            for (i = 0; i < skeleton.numJoints; ++i)
                endPoses[i].orientation.normalize();
        };
        return SkeletonNaryLERPState;
    }(AnimationStateBase));

    /**
     * A skeleton animation node that uses an n-dimensional array of animation node inputs to blend a lineraly interpolated output of a skeleton pose.
     */
    var SkeletonNaryLERPNode = /** @class */ (function (_super) {
        __extends$5(SkeletonNaryLERPNode, _super);
        /**
         * Creates a new <code>SkeletonNaryLERPNode</code> object.
         */
        function SkeletonNaryLERPNode() {
            var _this = _super.call(this) || this;
            _this._iInputs = new Array();
            _this._pStateClass = SkeletonNaryLERPState;
            return _this;
        }
        Object.defineProperty(SkeletonNaryLERPNode.prototype, "numInputs", {
            get: function () {
                return this._numInputs;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns an integer representing the input index of the given skeleton animation node.
         *
         * @param input The skeleton animation node for with the input index is requested.
         */
        SkeletonNaryLERPNode.prototype.getInputIndex = function (input) {
            return this._iInputs.indexOf(input);
        };
        /**
         * Returns the skeleton animation node object that resides at the given input index.
         *
         * @param index The input index for which the skeleton animation node is requested.
         */
        SkeletonNaryLERPNode.prototype.getInputAt = function (index) {
            return this._iInputs[index];
        };
        /**
         * Adds a new skeleton animation node input to the animation node.
         */
        SkeletonNaryLERPNode.prototype.addInput = function (input) {
            this._iInputs[this._numInputs++] = input;
        };
        /**
         * @inheritDoc
         */
        SkeletonNaryLERPNode.prototype.getAnimationState = function (animator) {
            return animator.getAnimationState(this);
        };
        return SkeletonNaryLERPNode;
    }(AnimationNodeBase));

    /**
     *
     */
    var VertexClipState = /** @class */ (function (_super) {
        __extends$5(VertexClipState, _super);
        function VertexClipState(animator, vertexClipNode) {
            var _this = _super.call(this, animator, vertexClipNode) || this;
            _this._vertexClipNode = vertexClipNode;
            _this._frames = _this._vertexClipNode.frames;
            return _this;
        }
        Object.defineProperty(VertexClipState.prototype, "currentElements", {
            /**
             * @inheritDoc
             */
            get: function () {
                if (this._pFramesDirty)
                    this._pUpdateFrames();
                return this._currentGraphics;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(VertexClipState.prototype, "nextElements", {
            /**
             * @inheritDoc
             */
            get: function () {
                if (this._pFramesDirty)
                    this._pUpdateFrames();
                return this._nextGraphics;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        VertexClipState.prototype._pUpdateFrames = function () {
            _super.prototype._pUpdateFrames.call(this);
            this._currentGraphics = this._frames[this._pCurrentFrame];
            if (this._vertexClipNode.looping && this._pNextFrame >= this._vertexClipNode.lastFrame) {
                this._nextGraphics = this._frames[0];
                this._pAnimator.dispatchCycleEvent();
            }
            else
                this._nextGraphics = this._frames[this._pNextFrame];
        };
        /**
         * @inheritDoc
         */
        VertexClipState.prototype._pUpdatePositionDelta = function () {
            //TODO:implement positiondelta functionality for vertex animations
        };
        return VertexClipState;
    }(AnimationClipState));

    /**
     * A vertex animation node containing time-based animation data as individual geometry obejcts.
     */
    var VertexClipNode = /** @class */ (function (_super) {
        __extends$5(VertexClipNode, _super);
        /**
         * Creates a new <code>VertexClipNode</code> object.
         */
        function VertexClipNode() {
            var _this = _super.call(this) || this;
            _this._frames = new Array();
            _this._translations = new Array();
            _this._pStateClass = VertexClipState;
            return _this;
        }
        Object.defineProperty(VertexClipNode.prototype, "frames", {
            /**
             * Returns a vector of geometry frames representing the vertex values of each animation frame in the clip.
             */
            get: function () {
                return this._frames;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Adds a geometry object to the internal timeline of the animation node.
         *
         * @param geometry The geometry object to add to the timeline of the node.
         * @param duration The specified duration of the frame in milliseconds.
         * @param translation The absolute translation of the frame, used in root delta calculations for sprite movement.
         */
        VertexClipNode.prototype.addFrame = function (elements, duration, translation) {
            if (translation === void 0) { translation = null; }
            this._frames.push(elements);
            this._pDurations.push(duration);
            this._translations.push(translation || new Vector3D());
            this._pNumFrames = this._pDurations.length;
            this._pStitchDirty = true;
        };
        /**
         * @inheritDoc
         */
        VertexClipNode.prototype._pUpdateStitch = function () {
            _super.prototype._pUpdateStitch.call(this);
            var i = this._pNumFrames - 1;
            var p1, p2, delta;
            while (i--) {
                this._pTotalDuration += this._pDurations[i];
                p1 = this._translations[i];
                p2 = this._translations[i + 1];
                delta = p2.subtract(p1);
                this._pTotalDelta.x += delta.x;
                this._pTotalDelta.y += delta.y;
                this._pTotalDelta.z += delta.z;
            }
            if (this._pNumFrames > 1 && (this._pStitchFinalFrame || !this._pLooping)) {
                this._pTotalDuration += this._pDurations[this._pNumFrames - 1];
                p1 = this._translations[0];
                p2 = this._translations[1];
                delta = p2.subtract(p1);
                this._pTotalDelta.x += delta.x;
                this._pTotalDelta.y += delta.y;
                this._pTotalDelta.z += delta.z;
            }
        };
        return VertexClipNode;
    }(AnimationClipNodeBase));

    /**
     *
     */
    var CrossfadeTransitionState = /** @class */ (function (_super) {
        __extends$5(CrossfadeTransitionState, _super);
        function CrossfadeTransitionState(animator, skeletonAnimationNode) {
            var _this = _super.call(this, animator, skeletonAnimationNode) || this;
            _this._crossfadeTransitionNode = skeletonAnimationNode;
            return _this;
        }
        /**
         * @inheritDoc
         */
        CrossfadeTransitionState.prototype._pUpdateTime = function (time) {
            this.blendWeight = Math.abs(time - this._crossfadeTransitionNode.startBlend) / (1000 * this._crossfadeTransitionNode.blendSpeed);
            if (this.blendWeight >= 1) {
                this.blendWeight = 1;
                if (this._animationStateTransitionComplete == null)
                    this._animationStateTransitionComplete = new AnimationStateEvent(AnimationStateEvent.TRANSITION_COMPLETE, this._pAnimator, this, this._crossfadeTransitionNode);
                this._crossfadeTransitionNode.dispatchEvent(this._animationStateTransitionComplete);
            }
            _super.prototype._pUpdateTime.call(this, time);
        };
        return CrossfadeTransitionState;
    }(SkeletonBinaryLERPState));

    /**
     * A skeleton animation node that uses two animation node inputs to blend a lineraly interpolated output of a skeleton pose.
     */
    var CrossfadeTransitionNode = /** @class */ (function (_super) {
        __extends$5(CrossfadeTransitionNode, _super);
        /**
         * Creates a new <code>CrossfadeTransitionNode</code> object.
         */
        function CrossfadeTransitionNode() {
            var _this = _super.call(this) || this;
            _this._pStateClass = CrossfadeTransitionState;
            return _this;
        }
        return CrossfadeTransitionNode;
    }(SkeletonBinaryLERPNode));

    /**
     * Dispatched to notify changes in an animator's state.
     */
    var AnimatorEvent = /** @class */ (function (_super) {
        __extends$5(AnimatorEvent, _super);
        /**
         * Create a new <code>AnimatorEvent</code> object.
         *
         * @param type The event type.
         * @param animator The animator object that is the subject of this event.
         */
        function AnimatorEvent(type, animator) {
            var _this = _super.call(this, type) || this;
            _this._animator = animator;
            return _this;
        }
        Object.defineProperty(AnimatorEvent.prototype, "animator", {
            get: function () {
                return this._animator;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the event.
         *
         * @return An exact duplicate of the current event object.
         */
        AnimatorEvent.prototype.clone = function () {
            return new AnimatorEvent(this.type, this._animator);
        };
        /**
         * Defines the value of the type property of a start event object.
         */
        AnimatorEvent.START = "animatorStart";
        /**
         * Defines the value of the type property of a stop event object.
         */
        AnimatorEvent.STOP = "animatorStop";
        /**
         * Defines the value of the type property of a cycle complete event object.
         */
        AnimatorEvent.CYCLE_COMPLETE = "animatorCycleComplete";
        return AnimatorEvent;
    }(EventBase));

    /**
     * Dispatched when playback of an animation inside the animator object starts.
     *
     * @eventType away3d.events.AnimatorEvent
     */
    //[Event(name="start", type="away3d.events.AnimatorEvent")]
    /**
     * Dispatched when playback of an animation inside the animator object stops.
     *
     * @eventType away3d.events.AnimatorEvent
     */
    //[Event(name="stop", type="away3d.events.AnimatorEvent")]
    /**
     * Dispatched when playback of an animation reaches the end of an animation.
     *
     * @eventType away3d.events.AnimatorEvent
     */
    //[Event(name="cycle_complete", type="away3d.events.AnimatorEvent")]
    /**
     * Provides an abstract base class for animator classes that control animation output from a data set subtype of <code>AnimationSetBase</code>.
     *
     * @see away.animators.AnimationSetBase
     */
    var AnimatorBase = /** @class */ (function (_super) {
        __extends$5(AnimatorBase, _super);
        /**
         * Creates a new <code>AnimatorBase</code> object.
         *
         * @param animationSet The animation data set to be used by the animator object.
         */
        function AnimatorBase(animationSet) {
            var _this = _super.call(this) || this;
            _this._autoUpdate = true;
            _this._time = 0;
            _this._playbackSpeed = 1;
            _this._pOwners = new Array();
            _this._pAbsoluteTime = 0;
            _this._animationStates = new Object();
            /**
             * Enables translation of the animated graphics from data returned per frame via the positionDelta property of the active animation node. Defaults to true.
             *
             * @see away.animators.IAnimationState#positionDelta
             */
            _this.updatePosition = true;
            _this._pAnimationSet = animationSet;
            _this._broadcaster = new RequestAnimationFrame(_this.onEnterFrame, _this);
            return _this;
        }
        AnimatorBase.prototype.getAnimationState = function (node) {
            var className = node.stateClass;
            var uID = node.id;
            if (this._animationStates[uID] == null)
                this._animationStates[uID] = new className(this, node);
            return this._animationStates[uID];
        };
        AnimatorBase.prototype.getAnimationStateByName = function (name) {
            return this.getAnimationState(this._pAnimationSet.getAnimation(name));
        };
        Object.defineProperty(AnimatorBase.prototype, "absoluteTime", {
            /**
             * Returns the internal absolute time of the animator, calculated by the current time and the playback speed.
             *
             * @see #time
             * @see #playbackSpeed
             */
            get: function () {
                return this._pAbsoluteTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimatorBase.prototype, "animationSet", {
            /**
             * Returns the animation data set in use by the animator.
             */
            get: function () {
                return this._pAnimationSet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimatorBase.prototype, "activeState", {
            /**
             * Returns the current active animation state.
             */
            get: function () {
                return this._pActiveState;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimatorBase.prototype, "activeAnimation", {
            /**
             * Returns the current active animation node.
             */
            get: function () {
                return this._pAnimationSet.getAnimation(this._pActiveAnimationName);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimatorBase.prototype, "activeAnimationName", {
            /**
             * Returns the current active animation node.
             */
            get: function () {
                return this._pActiveAnimationName;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimatorBase.prototype, "autoUpdate", {
            /**
             * Determines whether the animators internal update mechanisms are active. Used in cases
             * where manual updates are required either via the <code>time</code> property or <code>update()</code> method.
             * Defaults to true.
             *
             * @see #time
             * @see #update()
             */
            get: function () {
                return this._autoUpdate;
            },
            set: function (value) {
                if (this._autoUpdate == value)
                    return;
                this._autoUpdate = value;
                if (this._autoUpdate)
                    this.start();
                else
                    this.stop();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AnimatorBase.prototype, "time", {
            /**
             * Gets and sets the internal time clock of the animator.
             */
            get: function () {
                return this._time;
            },
            set: function (value) {
                if (this._time == value)
                    return;
                this.update(value);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Sets the animation phase of the current active state's animation clip(s).
         *
         * @param value The phase value to use. 0 represents the beginning of an animation clip, 1 represents the end.
         */
        AnimatorBase.prototype.phase = function (value) {
            this._pActiveState.phase(value);
        };
        Object.defineProperty(AnimatorBase.prototype, "playbackSpeed", {
            /**
             * The amount by which passed time should be scaled. Used to slow down or speed up animations. Defaults to 1.
             */
            get: function () {
                return this._playbackSpeed;
            },
            set: function (value) {
                this._playbackSpeed = value;
            },
            enumerable: true,
            configurable: true
        });
        AnimatorBase.prototype.setRenderState = function (shader, renderable, stage, projection) {
            throw new AbstractMethodError();
        };
        /**
         * Resumes the automatic playback clock controling the active state of the animator.
         */
        AnimatorBase.prototype.start = function () {
            if (this._isPlaying || !this._autoUpdate)
                return;
            this._time = this._pAbsoluteTime = getTimer();
            this._isPlaying = true;
            this._broadcaster.start();
            if (!this.hasEventListener(AnimatorEvent.START))
                return;
            if (this._startEvent == null)
                this._startEvent = new AnimatorEvent(AnimatorEvent.START, this);
            this.dispatchEvent(this._startEvent);
        };
        /**
         * Pauses the automatic playback clock of the animator, in case manual updates are required via the
         * <code>time</code> property or <code>update()</code> method.
         *
         * @see #time
         * @see #update()
         */
        AnimatorBase.prototype.stop = function () {
            if (!this._isPlaying)
                return;
            this._isPlaying = false;
            this._broadcaster.stop();
            if (!this.hasEventListener(AnimatorEvent.STOP))
                return;
            if (this._stopEvent == null)
                this._stopEvent = new AnimatorEvent(AnimatorEvent.STOP, this);
            this.dispatchEvent(this._stopEvent);
        };
        /**
         * Provides a way to manually update the active state of the animator when automatic
         * updates are disabled.
         *
         * @see #stop()
         * @see #autoUpdate
         */
        AnimatorBase.prototype.update = function (time) {
            var dt = (time - this._time) * this.playbackSpeed;
            this._pUpdateDeltaTime(dt);
            this._time = time;
        };
        AnimatorBase.prototype.reset = function (name, offset) {
            if (offset === void 0) { offset = 0; }
            this.getAnimationState(this._pAnimationSet.getAnimation(name)).offset(offset + this._pAbsoluteTime);
        };
        /**
         * Used by the graphics object to which the animator is applied, registers the owner for internal use.
         *
         * @private
         */
        AnimatorBase.prototype.addOwner = function (entity) {
            this._pOwners.push(entity);
        };
        /**
         * Used by the graphics object from which the animator is removed, unregisters the owner for internal use.
         *
         * @private
         */
        AnimatorBase.prototype.removeOwner = function (entity) {
            this._pOwners.splice(this._pOwners.indexOf(entity), 1);
        };
        /**
         * Internal abstract method called when the time delta property of the animator's contents requires updating.
         *
         * @private
         */
        AnimatorBase.prototype._pUpdateDeltaTime = function (dt) {
            this._pAbsoluteTime += dt;
            this._pActiveState.update(this._pAbsoluteTime);
            if (this.updatePosition)
                this.applyPositionDelta();
        };
        /**
         * Enter frame event handler for automatically updating the active state of the animator.
         */
        AnimatorBase.prototype.onEnterFrame = function (event) {
            if (event === void 0) { event = null; }
            this.update(getTimer());
        };
        AnimatorBase.prototype.applyPositionDelta = function () {
            var delta = this._pActiveState.positionDelta;
            var dist = delta.length;
            var len;
            if (dist > 0) {
                len = this._pOwners.length;
                for (var i = 0; i < len; ++i)
                    this._pOwners[i].transform.translateLocal(delta, dist);
            }
        };
        /**
         *  for internal use.
         *
         * @private
         */
        AnimatorBase.prototype.dispatchCycleEvent = function () {
            if (this.hasEventListener(AnimatorEvent.CYCLE_COMPLETE)) {
                if (this._cycleEvent == null)
                    this._cycleEvent = new AnimatorEvent(AnimatorEvent.CYCLE_COMPLETE, this);
                this.dispatchEvent(this._cycleEvent);
            }
        };
        /**
         * @inheritDoc
         */
        AnimatorBase.prototype.clone = function () {
            throw new AbstractMethodError();
        };
        /**
         * @inheritDoc
         */
        AnimatorBase.prototype.dispose = function () {
        };
        AnimatorBase.prototype.invalidateElements = function () {
            var entity;
            var len = this._pOwners.length;
            for (var i = 0; i < len; i++) {
                entity = this._pOwners[i];
                entity.invalidateElements();
            }
        };
        /**
         * @inheritDoc
         */
        AnimatorBase.prototype.testGPUCompatibility = function (shader) {
            throw new AbstractMethodError();
        };
        Object.defineProperty(AnimatorBase.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return AnimatorBase.assetType;
            },
            enumerable: true,
            configurable: true
        });
        AnimatorBase.prototype.getRenderableElements = function (renderable, sourceElements) {
            //nothing to do here
            return sourceElements;
        };
        AnimatorBase.assetType = "[asset Animator]";
        return AnimatorBase;
    }(AssetBase));

    /**
     * Provides an interface for assigning paricle-based animation data sets to sprite-based entity objects
     * and controlling the various available states of animation through an interative playhead that can be
     * automatically updated or manually triggered.
     *
     * Requires that the containing geometry of the parent sprite is particle geometry
     *
     * @see away.base.ParticleAnimator
     */
    var ParticleAnimator = /** @class */ (function (_super) {
        __extends$5(ParticleAnimator, _super);
        /**
         * Creates a new <code>ParticleAnimator</code> object.
         *
         * @param particleAnimationSet The animation data set containing the particle animations used by the animator.
         */
        function ParticleAnimator(particleAnimationSet) {
            var _this = _super.call(this, particleAnimationSet) || this;
            _this._animationParticleStates = new Array();
            _this._animatorParticleStates = new Array();
            _this._timeParticleStates = new Array();
            _this._totalLenOfOneVertex = 0;
            _this._animatorSubGeometries = new Object();
            _this._particleAnimationSet = particleAnimationSet;
            var state;
            var node;
            for (var i = 0; i < _this._particleAnimationSet.particleNodes.length; i++) {
                node = _this._particleAnimationSet.particleNodes[i];
                state = _this.getAnimationState(node);
                if (node.mode == ParticlePropertiesMode.LOCAL_DYNAMIC) {
                    _this._animatorParticleStates.push(state);
                    node._iDataOffset = _this._totalLenOfOneVertex;
                    _this._totalLenOfOneVertex += node.dataLength;
                }
                else {
                    _this._animationParticleStates.push(state);
                }
                if (state.needUpdateTime)
                    _this._timeParticleStates.push(state);
            }
            return _this;
        }
        /**
         * @inheritDoc
         */
        ParticleAnimator.prototype.clone = function () {
            return new ParticleAnimator(this._particleAnimationSet);
        };
        /**
         * @inheritDoc
         */
        ParticleAnimator.prototype.setRenderState = function (shader, renderable, stage, projection) {
            var animationRegisterData = this._particleAnimationSet._iAnimationRegisterData;
            var particleCollection = renderable.shape.particleCollection;
            var elements = renderable.shape.elements;
            //process animation sub geometries
            var animationElements = this._particleAnimationSet.getAnimationElements(particleCollection, elements);
            var i;
            for (i = 0; i < this._animationParticleStates.length; i++)
                this._animationParticleStates[i].setRenderState(shader, renderable, animationElements, animationRegisterData, projection, stage);
            //process animator subgeometries
            var animatorElements = this.getAnimatorElements(particleCollection, elements);
            for (i = 0; i < this._animatorParticleStates.length; i++)
                this._animatorParticleStates[i].setRenderState(shader, renderable, animatorElements, animationRegisterData, projection, stage);
        };
        /**
         * @inheritDoc
         */
        ParticleAnimator.prototype.testGPUCompatibility = function (shader) {
        };
        /**
         * @inheritDoc
         */
        ParticleAnimator.prototype.start = function () {
            _super.prototype.start.call(this);
            for (var i = 0; i < this._timeParticleStates.length; i++)
                this._timeParticleStates[i].offset(this._pAbsoluteTime);
        };
        /**
         * @inheritDoc
         */
        ParticleAnimator.prototype._pUpdateDeltaTime = function (dt) {
            this._pAbsoluteTime += dt;
            for (var i = 0; i < this._timeParticleStates.length; i++)
                this._timeParticleStates[i].update(this._pAbsoluteTime);
        };
        /**
         * @inheritDoc
         */
        ParticleAnimator.prototype.resetTime = function (offset) {
            if (offset === void 0) { offset = 0; }
            for (var i = 0; i < this._timeParticleStates.length; i++)
                this._timeParticleStates[i].offset(this._pAbsoluteTime + offset);
            this.update(this.time);
        };
        ParticleAnimator.prototype.dispose = function () {
            for (var key in this._animatorSubGeometries)
                this._animatorSubGeometries[key].dispose();
        };
        ParticleAnimator.prototype.getAnimatorElements = function (particleCollection, elements) {
            if (!this._animatorParticleStates.length)
                return;
            var animatorElements = this._animatorSubGeometries[elements.id] = new AnimationElements();
            //create the vertexData vector that will be used for local state data
            animatorElements.createVertexData(elements.numVertices, this._totalLenOfOneVertex);
            //pass the particles data to the animator elements
            animatorElements.animationParticles = this._particleAnimationSet.getAnimationElements(particleCollection, elements).animationParticles;
        };
        return ParticleAnimator;
    }(AnimatorBase));

    /**
     * The animation data set used by skeleton-based animators, containing skeleton animation data.
     *
     * @see away.animators.SkeletonAnimator
     */
    var SkeletonAnimationSet = /** @class */ (function (_super) {
        __extends$5(SkeletonAnimationSet, _super);
        /**
         * Creates a new <code>SkeletonAnimationSet</code> object.
         *
         * @param jointsPerVertex Sets the amount of skeleton joints that can be linked to a single vertex via skinned weight values. For GPU-base animation, the maximum allowed value is 4. Defaults to 4.
         */
        function SkeletonAnimationSet(jointsPerVertex) {
            if (jointsPerVertex === void 0) { jointsPerVertex = 4; }
            var _this = _super.call(this) || this;
            _this._jointsPerVertex = jointsPerVertex;
            return _this;
        }
        Object.defineProperty(SkeletonAnimationSet.prototype, "jointsPerVertex", {
            /**
             * Returns the amount of skeleton joints that can be linked to a single vertex via skinned weight values. For GPU-base animation, the
             * maximum allowed value is 4.
             */
            get: function () {
                return this._jointsPerVertex;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SkeletonAnimationSet.prototype, "matricesIndex", {
            get: function () {
                return this._matricesIndex;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        SkeletonAnimationSet.prototype.getAGALVertexCode = function (shader, registerCache, sharedRegisters) {
            this._matricesIndex = registerCache.numUsedVertexConstants;
            var indexOffset0 = this._matricesIndex;
            var indexOffset1 = this._matricesIndex + 1;
            var indexOffset2 = this._matricesIndex + 2;
            var indexStream = registerCache.getFreeVertexAttribute();
            shader.jointIndexIndex = indexStream.index;
            var weightStream = registerCache.getFreeVertexAttribute();
            shader.jointWeightIndex = weightStream.index;
            var indices = [indexStream + ".x", indexStream + ".y", indexStream + ".z", indexStream + ".w"];
            var weights = [weightStream + ".x", weightStream + ".y", weightStream + ".z", weightStream + ".w"];
            var temp1 = registerCache.getFreeVertexVectorTemp();
            var dot = "dp4";
            var code = "";
            var len = sharedRegisters.animatableAttributes.length;
            for (var i = 0; i < len; ++i) {
                var source = sharedRegisters.animatableAttributes[i];
                var target = sharedRegisters.animationTargetRegisters[i];
                for (var j = 0; j < this._jointsPerVertex; ++j) {
                    registerCache.getFreeVertexConstant();
                    registerCache.getFreeVertexConstant();
                    registerCache.getFreeVertexConstant();
                    code += dot + " " + temp1 + ".x, " + source + ", vc[" + indices[j] + "+" + indexOffset0 + "]\n" +
                        dot + " " + temp1 + ".y, " + source + ", vc[" + indices[j] + "+" + indexOffset1 + "]\n" +
                        dot + " " + temp1 + ".z, " + source + ", vc[" + indices[j] + "+" + indexOffset2 + "]\n" +
                        "mov " + temp1 + ".w, " + source + ".w\n" +
                        "mul " + temp1 + ", " + temp1 + ", " + weights[j] + "\n"; // apply weight
                    // add or mov to target. Need to write to a temp reg first, because an output can be a target
                    if (j == 0)
                        code += "mov " + target + ", " + temp1 + "\n";
                    else
                        code += "add " + target + ", " + target + ", " + temp1 + "\n";
                }
                // switch to dp3 once positions have been transformed, from now on, it should only be vectors instead of points
                dot = "dp3";
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        SkeletonAnimationSet.prototype.getAGALFragmentCode = function (shader, registerCache, shadedTarget) {
            return "";
        };
        /**
         * @inheritDoc
         */
        SkeletonAnimationSet.prototype.getAGALUVCode = function (shader, registerCache, sharedRegisters) {
            return "mov " + sharedRegisters.animatedUV + "," + sharedRegisters.uvInput + "\n";
        };
        /**
         * @inheritDoc
         */
        SkeletonAnimationSet.prototype.doneAGALCode = function (shader) {
        };
        return SkeletonAnimationSet;
    }(AnimationSetBase));

    /**
     * Provides an interface for assigning skeleton-based animation data sets to sprite-based entity objects
     * and controlling the various available states of animation through an interative playhead that can be
     * automatically updated or manually triggered.
     */
    var SkeletonAnimator = /** @class */ (function (_super) {
        __extends$5(SkeletonAnimator, _super);
        /**
         * Creates a new <code>SkeletonAnimator</code> object.
         *
         * @param skeletonAnimationSet The animation data set containing the skeleton animations used by the animator.
         * @param skeleton The skeleton object used for calculating the resulting global matrices for transforming skinned sprite data.
         * @param forceCPU Optional value that only allows the animator to perform calculation on the CPU. Defaults to false.
         */
        function SkeletonAnimator(animationSet, skeleton, forceCPU) {
            if (forceCPU === void 0) { forceCPU = false; }
            var _this = _super.call(this, animationSet) || this;
            _this._globalPose = new SkeletonPose();
            _this._morphedElements = new Object();
            _this._morphedElementsDirty = new Object();
            _this._skeletonAnimationSet = animationSet;
            _this._skeleton = skeleton;
            _this._forceCPU = forceCPU;
            _this._jointsPerVertex = animationSet.jointsPerVertex;
            _this._numJoints = _this._skeleton.numJoints;
            _this._globalMatrices = new Float32Array(_this._numJoints * 12);
            var j = 0;
            for (var i = 0; i < _this._numJoints; ++i) {
                _this._globalMatrices[j++] = 1;
                _this._globalMatrices[j++] = 0;
                _this._globalMatrices[j++] = 0;
                _this._globalMatrices[j++] = 0;
                _this._globalMatrices[j++] = 0;
                _this._globalMatrices[j++] = 1;
                _this._globalMatrices[j++] = 0;
                _this._globalMatrices[j++] = 0;
                _this._globalMatrices[j++] = 0;
                _this._globalMatrices[j++] = 0;
                _this._globalMatrices[j++] = 1;
                _this._globalMatrices[j++] = 0;
            }
            _this._onTransitionCompleteDelegate = function (event) { return _this.onTransitionComplete(event); };
            _this._onIndicesUpdateDelegate = function (event) { return _this.onIndicesUpdate(event); };
            _this._onVerticesUpdateDelegate = function (event) { return _this.onVerticesUpdate(event); };
            return _this;
        }
        Object.defineProperty(SkeletonAnimator.prototype, "globalMatrices", {
            /**
             * returns the calculated global matrices of the current skeleton pose.
             *
             * @see #globalPose
             */
            get: function () {
                if (this._globalPropertiesDirty)
                    this.updateGlobalProperties();
                return this._globalMatrices;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SkeletonAnimator.prototype, "globalPose", {
            /**
             * returns the current skeleton pose output from the animator.
             *
             * @see away.animators.data.SkeletonPose
             */
            get: function () {
                if (this._globalPropertiesDirty)
                    this.updateGlobalProperties();
                return this._globalPose;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SkeletonAnimator.prototype, "skeleton", {
            /**
             * Returns the skeleton object in use by the animator - this defines the number and heirarchy of joints used by the
             * skinned geoemtry to which skeleon animator is applied.
             */
            get: function () {
                return this._skeleton;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SkeletonAnimator.prototype, "forceCPU", {
            /**
             * Indicates whether the skeleton animator is disabled by default for GPU rendering, something that allows the animator to perform calculation on the GPU.
             * Defaults to false.
             */
            get: function () {
                return this._forceCPU;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SkeletonAnimator.prototype, "useCondensedIndices", {
            /**
             * Offers the option of enabling GPU accelerated animation on skeletons larger than 32 joints
             * by condensing the number of joint index values required per sprite. Only applicable to
             * skeleton animations that utilise more than one sprite object. Defaults to false.
             */
            get: function () {
                return this._useCondensedIndices;
            },
            set: function (value) {
                this._useCondensedIndices = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        SkeletonAnimator.prototype.clone = function () {
            return new SkeletonAnimator(this._skeletonAnimationSet, this._skeleton, this._forceCPU);
        };
        /**
         * Plays an animation state registered with the given name in the animation data set.
         *
         * @param name The data set name of the animation state to be played.
         * @param transition An optional transition object that determines how the animator will transition from the currently active animation state.
         * @param offset An option offset time (in milliseconds) that resets the state's internal clock to the absolute time of the animator plus the offset value. Required for non-looping animation states.
         */
        SkeletonAnimator.prototype.play = function (name, transition, offset) {
            if (transition === void 0) { transition = null; }
            if (offset === void 0) { offset = NaN; }
            if (this._pActiveAnimationName == name)
                return;
            this._pActiveAnimationName = name;
            if (!this._pAnimationSet.hasAnimation(name))
                throw new Error("Animation root node " + name + " not found!");
            if (transition && this._pActiveNode) {
                //setup the transition
                this._pActiveNode = transition.getAnimationNode(this, this._pActiveNode, this._pAnimationSet.getAnimation(name), this._pAbsoluteTime);
                this._pActiveNode.addEventListener(AnimationStateEvent.TRANSITION_COMPLETE, this._onTransitionCompleteDelegate);
            }
            else
                this._pActiveNode = this._pAnimationSet.getAnimation(name);
            this._pActiveState = this.getAnimationState(this._pActiveNode);
            if (this.updatePosition) {
                //update straight away to reset position deltas
                this._pActiveState.update(this._pAbsoluteTime);
                this._pActiveState.positionDelta;
            }
            this._activeSkeletonState = this._pActiveState;
            this.start();
            //apply a time offset if specified
            if (!isNaN(offset))
                this.reset(name, offset);
        };
        /**
         * @inheritDoc
         */
        SkeletonAnimator.prototype.setRenderState = function (shader, renderable, stage, projection) {
            // do on request of globalProperties
            if (this._globalPropertiesDirty)
                this.updateGlobalProperties();
            var elements = renderable.shape.elements;
            elements.useCondensedIndices = this._useCondensedIndices;
            if (this._useCondensedIndices) {
                // using a condensed data set
                this.updateCondensedMatrices(elements.condensedIndexLookUp);
                shader.setVertexConstFromArray(this._skeletonAnimationSet.matricesIndex, this._condensedMatrices);
            }
            else {
                if (this._pAnimationSet.usesCPU) {
                    if (this._morphedElementsDirty[elements.id])
                        this.morphElements(renderable, elements);
                    return;
                }
                shader.setVertexConstFromArray(this._skeletonAnimationSet.matricesIndex, this._globalMatrices);
            }
        };
        /**
         * @inheritDoc
         */
        SkeletonAnimator.prototype.testGPUCompatibility = function (shader) {
            if (!this._useCondensedIndices && (this._forceCPU || this._jointsPerVertex > 4 || shader.numUsedVertexConstants + this._numJoints * 3 > 128))
                this._pAnimationSet.cancelGPUCompatibility();
        };
        /**
         * Applies the calculated time delta to the active animation state node or state transition object.
         */
        SkeletonAnimator.prototype._pUpdateDeltaTime = function (dt) {
            _super.prototype._pUpdateDeltaTime.call(this, dt);
            //invalidate pose matrices
            this._globalPropertiesDirty = true;
            //trigger geometry invalidation if using CPU animation
            if (this._pAnimationSet.usesCPU)
                this.invalidateElements();
        };
        SkeletonAnimator.prototype.updateCondensedMatrices = function (condensedIndexLookUp) {
            var j = 0, k = 0;
            var len = condensedIndexLookUp.length;
            var srcIndex;
            this._condensedMatrices = new Float32Array(len * 12);
            for (var i = 0; i < len; i++) {
                srcIndex = condensedIndexLookUp[i] * 12; //12 required for the three 4-component vectors that store the matrix
                k = 12;
                // copy into condensed
                while (k--)
                    this._condensedMatrices[j++] = this._globalMatrices[srcIndex++];
            }
        };
        SkeletonAnimator.prototype.updateGlobalProperties = function () {
            this._globalPropertiesDirty = false;
            //get global pose
            this.localToGlobalPose(this._activeSkeletonState.getSkeletonPose(this._skeleton), this._globalPose, this._skeleton);
            // convert pose to matrix
            var mtxOffset = 0;
            var globalPoses = this._globalPose.jointPoses;
            var raw;
            var ox, oy, oz, ow;
            var xy2, xz2, xw2;
            var yz2, yw2, zw2;
            var n11, n12, n13;
            var n21, n22, n23;
            var n31, n32, n33;
            var m11, m12, m13, m14;
            var m21, m22, m23, m24;
            var m31, m32, m33, m34;
            var joints = this._skeleton.joints;
            var pose;
            var quat;
            var vec;
            var t;
            for (var i = 0; i < this._numJoints; ++i) {
                pose = globalPoses[i];
                quat = pose.orientation;
                vec = pose.translation;
                ox = quat.x;
                oy = quat.y;
                oz = quat.z;
                ow = quat.w;
                xy2 = (t = 2.0 * ox) * oy;
                xz2 = t * oz;
                xw2 = t * ow;
                yz2 = (t = 2.0 * oy) * oz;
                yw2 = t * ow;
                zw2 = 2.0 * oz * ow;
                yz2 = 2.0 * oy * oz;
                yw2 = 2.0 * oy * ow;
                zw2 = 2.0 * oz * ow;
                ox *= ox;
                oy *= oy;
                oz *= oz;
                ow *= ow;
                n11 = (t = ox - oy) - oz + ow;
                n12 = xy2 - zw2;
                n13 = xz2 + yw2;
                n21 = xy2 + zw2;
                n22 = -t - oz + ow;
                n23 = yz2 - xw2;
                n31 = xz2 - yw2;
                n32 = yz2 + xw2;
                n33 = -ox - oy + oz + ow;
                // prepend inverse bind pose
                raw = joints[i].inverseBindPose;
                m11 = raw[0];
                m12 = raw[4];
                m13 = raw[8];
                m14 = raw[12];
                m21 = raw[1];
                m22 = raw[5];
                m23 = raw[9];
                m24 = raw[13];
                m31 = raw[2];
                m32 = raw[6];
                m33 = raw[10];
                m34 = raw[14];
                this._globalMatrices[mtxOffset] = n11 * m11 + n12 * m21 + n13 * m31;
                this._globalMatrices[mtxOffset + 1] = n11 * m12 + n12 * m22 + n13 * m32;
                this._globalMatrices[mtxOffset + 2] = n11 * m13 + n12 * m23 + n13 * m33;
                this._globalMatrices[mtxOffset + 3] = n11 * m14 + n12 * m24 + n13 * m34 + vec.x;
                this._globalMatrices[mtxOffset + 4] = n21 * m11 + n22 * m21 + n23 * m31;
                this._globalMatrices[mtxOffset + 5] = n21 * m12 + n22 * m22 + n23 * m32;
                this._globalMatrices[mtxOffset + 6] = n21 * m13 + n22 * m23 + n23 * m33;
                this._globalMatrices[mtxOffset + 7] = n21 * m14 + n22 * m24 + n23 * m34 + vec.y;
                this._globalMatrices[mtxOffset + 8] = n31 * m11 + n32 * m21 + n33 * m31;
                this._globalMatrices[mtxOffset + 9] = n31 * m12 + n32 * m22 + n33 * m32;
                this._globalMatrices[mtxOffset + 10] = n31 * m13 + n32 * m23 + n33 * m33;
                this._globalMatrices[mtxOffset + 11] = n31 * m14 + n32 * m24 + n33 * m34 + vec.z;
                mtxOffset = mtxOffset + 12;
            }
        };
        SkeletonAnimator.prototype.getRenderableElements = function (renderable, sourceElements) {
            this._morphedElementsDirty[sourceElements.id] = true;
            //early out for GPU animations
            if (!this._pAnimationSet.usesCPU)
                return sourceElements;
            var targetElements;
            if (!(targetElements = this._morphedElements[sourceElements.id])) {
                //not yet stored
                sourceElements.normals;
                sourceElements.tangents;
                targetElements = (this._morphedElements[sourceElements.id] = sourceElements.clone());
                //turn off auto calculations on the morphed geometry
                targetElements.autoDeriveNormals = false;
                targetElements.autoDeriveTangents = false;
                //add event listeners for any changes in UV values on the source geometry
                sourceElements.addEventListener(ElementsEvent.INVALIDATE_INDICES, this._onIndicesUpdateDelegate);
                sourceElements.addEventListener(ElementsEvent.INVALIDATE_VERTICES, this._onVerticesUpdateDelegate);
            }
            return targetElements;
        };
        /**
         * If the animation can't be performed on GPU, transform vertices manually
         * @param subGeom The subgeometry containing the weights and joint index data per vertex.
         * @param pass The material pass for which we need to transform the vertices
         */
        SkeletonAnimator.prototype.morphElements = function (renderable, sourceElements) {
            this._morphedElementsDirty[sourceElements.id] = false;
            var numVertices = sourceElements.numVertices;
            var sourcePositions = sourceElements.positions.get(numVertices);
            var sourceNormals = sourceElements.normals.get(numVertices);
            var sourceTangents = sourceElements.tangents.get(numVertices);
            var posDim = sourceElements.positions.dimensions;
            var posStride = sourceElements.positions.stride;
            var normalStride = sourceElements.normals.stride;
            var tangentStride = sourceElements.tangents.stride;
            var jointIndices = sourceElements.jointIndices.get(numVertices);
            var jointWeights = sourceElements.jointWeights.get(numVertices);
            var jointStride = sourceElements.jointIndices.stride;
            var targetElements = this._morphedElements[sourceElements.id];
            var targetPositions = targetElements.positions.get(numVertices);
            var targetNormals = targetElements.normals.get(numVertices);
            var targetTangents = targetElements.tangents.get(numVertices);
            targetElements.positions.attributesBuffer.invalidate();
            targetElements.normals.attributesBuffer.invalidate();
            targetElements.tangents.attributesBuffer.invalidate();
            var index = 0;
            var i0 = 0;
            var i1 = 0;
            var i2 = 0;
            var i3 = 0;
            var k;
            var vx, vy, vz;
            var nx, ny, nz;
            var tx, ty, tz;
            var weight;
            var vertX, vertY, vertZ;
            var normX, normY, normZ;
            var tangX, tangY, tangZ;
            var m11, m12, m13, m14;
            var m21, m22, m23, m24;
            var m31, m32, m33, m34;
            while (index < numVertices) {
                i0 = index * posStride;
                vertX = sourcePositions[i0];
                vertY = sourcePositions[i0 + 1];
                vertZ = (posDim == 3) ? sourcePositions[i0 + 2] : 0;
                i1 = index * normalStride;
                normX = sourceNormals[i1];
                normY = sourceNormals[i1 + 1];
                normZ = sourceNormals[i1 + 2];
                i2 = index * tangentStride;
                tangX = sourceTangents[i2];
                tangY = sourceTangents[i2 + 1];
                tangZ = sourceTangents[i2 + 2];
                vx = 0;
                vy = 0;
                vz = 0;
                nx = 0;
                ny = 0;
                nz = 0;
                tx = 0;
                ty = 0;
                tz = 0;
                k = 0;
                i3 = index * jointStride;
                while (k < this._jointsPerVertex) {
                    weight = jointWeights[i3 + k];
                    if (weight > 0) {
                        // implicit /3*12 (/3 because indices are multiplied by 3 for gpu matrix access, *12 because it's the matrix size)
                        var mtxOffset = jointIndices[i3 + k] << 2;
                        m11 = this._globalMatrices[mtxOffset];
                        m12 = this._globalMatrices[mtxOffset + 1];
                        m13 = this._globalMatrices[mtxOffset + 2];
                        m14 = this._globalMatrices[mtxOffset + 3];
                        m21 = this._globalMatrices[mtxOffset + 4];
                        m22 = this._globalMatrices[mtxOffset + 5];
                        m23 = this._globalMatrices[mtxOffset + 6];
                        m24 = this._globalMatrices[mtxOffset + 7];
                        m31 = this._globalMatrices[mtxOffset + 8];
                        m32 = this._globalMatrices[mtxOffset + 9];
                        m33 = this._globalMatrices[mtxOffset + 10];
                        m34 = this._globalMatrices[mtxOffset + 11];
                        vx += weight * (m11 * vertX + m12 * vertY + m13 * vertZ + m14);
                        vy += weight * (m21 * vertX + m22 * vertY + m23 * vertZ + m24);
                        vz += weight * (m31 * vertX + m32 * vertY + m33 * vertZ + m34);
                        nx += weight * (m11 * normX + m12 * normY + m13 * normZ);
                        ny += weight * (m21 * normX + m22 * normY + m23 * normZ);
                        nz += weight * (m31 * normX + m32 * normY + m33 * normZ);
                        tx += weight * (m11 * tangX + m12 * tangY + m13 * tangZ);
                        ty += weight * (m21 * tangX + m22 * tangY + m23 * tangZ);
                        tz += weight * (m31 * tangX + m32 * tangY + m33 * tangZ);
                        k++;
                    }
                    else {
                        //if zero weight encountered, skip to the next vertex
                        k = this._jointsPerVertex;
                    }
                }
                targetPositions[i0] = vx;
                targetPositions[i0 + 1] = vy;
                if (posDim == 3)
                    targetPositions[i0 + 2] = vz;
                targetNormals[i1] = nx;
                targetNormals[i1 + 1] = ny;
                targetNormals[i1 + 2] = nz;
                targetTangents[i2] = tx;
                targetTangents[i2 + 1] = ty;
                targetTangents[i2 + 2] = tz;
                index++;
            }
        };
        /**
         * Converts a local hierarchical skeleton pose to a global pose
         * @param targetPose The SkeletonPose object that will contain the global pose.
         * @param skeleton The skeleton containing the joints, and as such, the hierarchical data to transform to global poses.
         */
        SkeletonAnimator.prototype.localToGlobalPose = function (sourcePose, targetPose, skeleton) {
            var globalPoses = targetPose.jointPoses;
            var globalJointPose;
            var joints = skeleton.joints;
            var len = sourcePose.numJointPoses;
            var jointPoses = sourcePose.jointPoses;
            var parentIndex;
            var joint;
            var parentPose;
            var pose;
            var or;
            var tr;
            var t;
            var q;
            var x1, y1, z1, w1;
            var x2, y2, z2, w2;
            var x3, y3, z3;
            // :s
            if (globalPoses.length != len)
                globalPoses.length = len;
            for (var i = 0; i < len; ++i) {
                globalJointPose = globalPoses[i];
                if (globalJointPose == null)
                    globalJointPose = globalPoses[i] = new JointPose();
                joint = joints[i];
                parentIndex = joint.parentIndex;
                pose = jointPoses[i];
                q = globalJointPose.orientation;
                t = globalJointPose.translation;
                if (parentIndex < 0) {
                    tr = pose.translation;
                    or = pose.orientation;
                    q.x = or.x;
                    q.y = or.y;
                    q.z = or.z;
                    q.w = or.w;
                    t.x = tr.x;
                    t.y = tr.y;
                    t.z = tr.z;
                }
                else {
                    // append parent pose
                    parentPose = globalPoses[parentIndex];
                    // rotate point
                    or = parentPose.orientation;
                    tr = pose.translation;
                    x2 = or.x;
                    y2 = or.y;
                    z2 = or.z;
                    w2 = or.w;
                    x3 = tr.x;
                    y3 = tr.y;
                    z3 = tr.z;
                    w1 = -x2 * x3 - y2 * y3 - z2 * z3;
                    x1 = w2 * x3 + y2 * z3 - z2 * y3;
                    y1 = w2 * y3 - x2 * z3 + z2 * x3;
                    z1 = w2 * z3 + x2 * y3 - y2 * x3;
                    // append parent translation
                    tr = parentPose.translation;
                    t.x = -w1 * x2 + x1 * w2 - y1 * z2 + z1 * y2 + tr.x;
                    t.y = -w1 * y2 + x1 * z2 + y1 * w2 - z1 * x2 + tr.y;
                    t.z = -w1 * z2 - x1 * y2 + y1 * x2 + z1 * w2 + tr.z;
                    // append parent orientation
                    x1 = or.x;
                    y1 = or.y;
                    z1 = or.z;
                    w1 = or.w;
                    or = pose.orientation;
                    x2 = or.x;
                    y2 = or.y;
                    z2 = or.z;
                    w2 = or.w;
                    q.w = w1 * w2 - x1 * x2 - y1 * y2 - z1 * z2;
                    q.x = w1 * x2 + x1 * w2 + y1 * z2 - z1 * y2;
                    q.y = w1 * y2 - x1 * z2 + y1 * w2 + z1 * x2;
                    q.z = w1 * z2 + x1 * y2 - y1 * x2 + z1 * w2;
                }
            }
        };
        SkeletonAnimator.prototype.onTransitionComplete = function (event) {
            if (event.type == AnimationStateEvent.TRANSITION_COMPLETE) {
                event.animationNode.removeEventListener(AnimationStateEvent.TRANSITION_COMPLETE, this._onTransitionCompleteDelegate);
                //if this is the current active state transition, revert control to the active node
                if (this._pActiveState == event.animationState) {
                    this._pActiveNode = this._pAnimationSet.getAnimation(this._pActiveAnimationName);
                    this._pActiveState = this.getAnimationState(this._pActiveNode);
                    this._activeSkeletonState = this._pActiveState;
                }
            }
        };
        SkeletonAnimator.prototype.onIndicesUpdate = function (event) {
            var elements = event.target;
            this._morphedElements[elements.id].setIndices(elements.indices);
        };
        SkeletonAnimator.prototype.onVerticesUpdate = function (event) {
            var elements = event.target;
            //only update uvs
            if (event.attributesView != elements.uvs && event.attributesView != elements.getCustomAtributes("secondaryUVs"))
                return;
            var morphElements = this._morphedElements[elements.id];
            var morphUVs = morphElements.uvs.get(elements.numVertices);
            morphElements.invalidateVertices(morphElements.uvs);
            var uvStride = morphElements.uvs.stride;
            var uvs = event.attributesView.get(elements.numVertices);
            var len = elements.numVertices * uvStride;
            for (var i = 0; i < len; i += uvStride) {
                morphUVs[i] = uvs[i];
                morphUVs[i + 1] = uvs[i + 1];
            }
        };
        return SkeletonAnimator;
    }(AnimatorBase));

    /**
     * The animation data set used by vertex-based animators, containing vertex animation state data.
     *
     * @see VertexAnimator
     */
    var VertexAnimationSet = /** @class */ (function (_super) {
        __extends$5(VertexAnimationSet, _super);
        /**
         * Returns whether or not normal data is used in last set GPU pass of the vertex shader.
         */
        //		public get useNormals():boolean
        //		{
        //			return this._uploadNormals;
        //		}
        /**
         * Creates a new <code>VertexAnimationSet</code> object.
         *
         * @param numPoses The number of poses made available at once to the GPU animation code.
         * @param blendMode Optional value for setting the animation mode of the vertex animator object.
         *
         * @see away3d.animators.data.VertexAnimationMode
         */
        function VertexAnimationSet(numPoses, blendMode) {
            if (numPoses === void 0) { numPoses = 2; }
            if (blendMode === void 0) { blendMode = "absolute"; }
            var _this = _super.call(this) || this;
            _this._numPoses = numPoses;
            _this._blendMode = blendMode;
            return _this;
        }
        Object.defineProperty(VertexAnimationSet.prototype, "numPoses", {
            /**
             * Returns the number of poses made available at once to the GPU animation code.
             */
            get: function () {
                return this._numPoses;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(VertexAnimationSet.prototype, "blendMode", {
            /**
             * Returns the active blend mode of the vertex animator object.
             */
            get: function () {
                return this._blendMode;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        VertexAnimationSet.prototype.getAGALVertexCode = function (shader, registerCache, sharedRegisters) {
            //grab animationRegisterData from the materialpassbase or create a new one if the first time
            this._iAnimationRegisterData = shader.animationRegisterData;
            if (this._iAnimationRegisterData == null)
                this._iAnimationRegisterData = shader.animationRegisterData = new AnimationRegisterData();
            if (this._blendMode == VertexAnimationMode.ABSOLUTE)
                return this.getAbsoluteAGALCode(shader, registerCache, sharedRegisters);
            else
                return this.getAdditiveAGALCode(shader, registerCache, sharedRegisters);
        };
        /**
         * @inheritDoc
         */
        VertexAnimationSet.prototype.getAGALFragmentCode = function (shader, registerCache, shadedTarget) {
            return "";
        };
        /**
         * @inheritDoc
         */
        VertexAnimationSet.prototype.getAGALUVCode = function (shader, registerCache, sharedRegisters) {
            return "mov " + sharedRegisters.animatedUV + "," + sharedRegisters.uvInput + "\n";
        };
        /**
         * @inheritDoc
         */
        VertexAnimationSet.prototype.doneAGALCode = function (shader) {
        };
        /**
         * Generates the vertex AGAL code for absolute blending.
         */
        VertexAnimationSet.prototype.getAbsoluteAGALCode = function (shader, registerCache, sharedRegisters) {
            var code = "";
            var temp1 = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(temp1, 1);
            var temp2 = registerCache.getFreeVertexVectorTemp();
            var regs = new Array(".x", ".y", ".z", ".w");
            var len = sharedRegisters.animatableAttributes.length;
            var constantReg = registerCache.getFreeVertexConstant();
            this._iAnimationRegisterData.weightsIndex = constantReg.index;
            this._iAnimationRegisterData.poseIndices = new Array(this._numPoses);
            var poseInput;
            var k = 0;
            if (len > 2)
                len = 2;
            for (var i = 0; i < len; ++i) {
                code += "mul " + temp1 + ", " + sharedRegisters.animatableAttributes[i] + ", " + constantReg + regs[0] + "\n";
                for (var j = 1; j < this._numPoses; ++j) {
                    poseInput = registerCache.getFreeVertexAttribute();
                    this._iAnimationRegisterData.poseIndices[k++] = poseInput.index;
                    code += "mul " + temp2 + ", " + poseInput + ", " + constantReg + regs[j] + "\n";
                    if (j < this._numPoses - 1) //TODO this is always the case, write better?
                        code += "add " + temp1 + ", " + temp1 + ", " + temp2 + "\n";
                }
                code += "add " + sharedRegisters.animationTargetRegisters[i] + ", " + temp1 + ", " + temp2 + "\n";
            }
            // add code for bitangents if tangents are used
            if (shader.tangentDependencies > 0 || shader.outputsNormals) {
                code += "dp3 " + temp1 + ".x, " + sharedRegisters.animatableAttributes[2] + ", " + sharedRegisters.animationTargetRegisters[1] + "\n" +
                    "mul " + temp1 + ", " + sharedRegisters.animationTargetRegisters[1] + ", " + temp1 + ".x\n" +
                    "sub " + sharedRegisters.animationTargetRegisters[2] + ", " + sharedRegisters.animationTargetRegisters[2] + ", " + temp1 + "\n";
            }
            //
            // // simply write attributes to targets, do not animate them
            // // projection will pick up on targets[0] to do the projection
            // var len:number = sharedRegisters.animatableAttributes.length;
            // for (var i:number = 0; i < len; ++i)
            // 	code += "mov " + sharedRegisters.animationTargetRegisters[i] + ", " + sharedRegisters.animatableAttributes[i] + "\n";
            return code;
        };
        /**
         * Generates the vertex AGAL code for additive blending.
         */
        VertexAnimationSet.prototype.getAdditiveAGALCode = function (shader, registerCache, sharedRegisters) {
            var code = "";
            var len = sharedRegisters.animatableAttributes.length;
            var regs = [".x", ".y", ".z", ".w"];
            var temp1 = registerCache.getFreeVertexVectorTemp();
            var constantReg = registerCache.getFreeVertexConstant();
            this._iAnimationRegisterData.weightsIndex = constantReg.index;
            this._iAnimationRegisterData.poseIndices = new Array(this._numPoses);
            var poseInput;
            var k = 0;
            if (len > 2)
                len = 2;
            code += "mov  " + sharedRegisters.animationTargetRegisters[0] + ", " + sharedRegisters.animatableAttributes[0] + "\n";
            if (shader.normalDependencies > 0)
                code += "mov " + sharedRegisters.animationTargetRegisters[1] + ", " + sharedRegisters.animatableAttributes[1] + "\n";
            for (var i = 0; i < len; ++i) {
                for (var j = 0; j < this._numPoses; ++j) {
                    poseInput = registerCache.getFreeVertexAttribute();
                    this._iAnimationRegisterData.poseIndices[k++] = poseInput.index;
                    code += "mul " + temp1 + ", " + poseInput + ", " + constantReg + regs[j] + "\n" +
                        "add " + sharedRegisters.animationTargetRegisters[i] + ", " + sharedRegisters.animationTargetRegisters[i] + ", " + temp1 + "\n";
                }
            }
            if (shader.tangentDependencies > 0 || shader.outputsNormals) {
                code += "dp3 " + temp1 + ".x, " + sharedRegisters.animatableAttributes[2] + ", " + sharedRegisters.animationTargetRegisters[1] + "\n" +
                    "mul " + temp1 + ", " + sharedRegisters.animationTargetRegisters[1] + ", " + temp1 + ".x\n" +
                    "sub " + sharedRegisters.animationTargetRegisters[2] + ", " + sharedRegisters.animatableAttributes[2] + ", " + temp1 + "\n";
            }
            return code;
        };
        return VertexAnimationSet;
    }(AnimationSetBase));

    /**
     * Provides an interface for assigning vertex-based animation data sets to entity-based entity objects
     * and controlling the various available states of animation through an interative playhead that can be
     * automatically updated or manually triggered.
     */
    var VertexAnimator = /** @class */ (function (_super) {
        __extends$5(VertexAnimator, _super);
        /**
         * Creates a new <code>VertexAnimator</code> object.
         *
         * @param vertexAnimationSet The animation data set containing the vertex animations used by the animator.
         */
        function VertexAnimator(vertexAnimationSet) {
            var _this = _super.call(this, vertexAnimationSet) || this;
            _this._poses = new Array();
            _this._weights = new Float32Array([1, 0, 0, 0]);
            _this._vertexAnimationSet = vertexAnimationSet;
            return _this;
        }
        /**
         * @inheritDoc
         */
        VertexAnimator.prototype.clone = function () {
            return new VertexAnimator(this._vertexAnimationSet);
        };
        /**
         * Plays a sequence with a given name. If the sequence is not found, it may not be loaded yet, and it will retry every frame.
         * @param sequenceName The name of the clip to be played.
         */
        VertexAnimator.prototype.play = function (name, transition, offset) {
            if (transition === void 0) { transition = null; }
            if (offset === void 0) { offset = NaN; }
            if (this._pActiveAnimationName == name)
                return;
            this._pActiveAnimationName = name;
            //TODO: implement transitions in vertex animator
            if (!this._pAnimationSet.hasAnimation(name))
                throw new Error("Animation root node " + name + " not found!");
            this._pActiveNode = this._pAnimationSet.getAnimation(name);
            this._pActiveState = this.getAnimationState(this._pActiveNode);
            if (this.updatePosition) {
                //update straight away to reset position deltas
                this._pActiveState.update(this._pAbsoluteTime);
                this._pActiveState.positionDelta;
            }
            this._activeVertexState = this._pActiveState;
            this.start();
            //apply a time offset if specified
            if (!isNaN(offset))
                this.reset(name, offset);
        };
        /**
         * @inheritDoc
         */
        VertexAnimator.prototype._pUpdateDeltaTime = function (dt) {
            _super.prototype._pUpdateDeltaTime.call(this, dt);
            var geometryFlag = false;
            if (this._poses[0] != this._activeVertexState.currentElements) {
                this._poses[0] = this._activeVertexState.currentElements;
                geometryFlag = true;
            }
            if (this._poses[1] != this._activeVertexState.nextElements)
                this._poses[1] = this._activeVertexState.nextElements;
            this._weights[0] = 1 - (this._weights[1] = this._activeVertexState.blendWeight);
            if (geometryFlag)
                this.invalidateElements();
        };
        /**
         * @inheritDoc
         */
        VertexAnimator.prototype.setRenderState = function (shader, renderable, stage, projection) {
            // todo: add code for when running on cpu
            // this type of animation can only be IRenderable
            var shape = renderable.shape;
            var elements = renderable.stageElements.elements;
            // if no poses defined, set temp data
            if (!this._poses.length) {
                this.setNullPose(shader, elements, stage);
                return;
            }
            var animationRegisterData = shader.animationRegisterData;
            var i;
            var len = this._vertexAnimationSet.numPoses;
            shader.setVertexConstFromArray(animationRegisterData.weightsIndex, this._weights);
            if (this._vertexAnimationSet.blendMode == VertexAnimationMode.ABSOLUTE)
                i = 1;
            else
                i = 0;
            var stageElements;
            var k = 0;
            for (; i < len; ++i) {
                elements = (this._poses[i] || shape.elements);
                stageElements = stage.getAbstraction(elements);
                stageElements._indexMappings = stage.getAbstraction(shape.elements).getIndexMappings();
                stageElements.activateVertexBufferVO(animationRegisterData.poseIndices[k++], elements.positions);
                if (shader.normalDependencies > 0)
                    stageElements.activateVertexBufferVO(animationRegisterData.poseIndices[k++], elements.normals);
            }
        };
        VertexAnimator.prototype.setNullPose = function (shader, elements, stage) {
            var animationRegisterData = shader.animationRegisterData;
            shader.setVertexConstFromArray(animationRegisterData.weightsIndex, this._weights);
            var stageElements = stage.getAbstraction(elements);
            var k = 0;
            if (this._vertexAnimationSet.blendMode == VertexAnimationMode.ABSOLUTE) {
                var len = this._vertexAnimationSet.numPoses;
                for (var i = 1; i < len; ++i) {
                    stageElements.activateVertexBufferVO(animationRegisterData.poseIndices[k++], elements.positions);
                    if (shader.normalDependencies > 0)
                        stageElements.activateVertexBufferVO(animationRegisterData.poseIndices[k++], elements.normals);
                }
            }
            // todo: set temp data for additive?
        };
        /**
         * Verifies if the animation will be used on cpu. Needs to be true for all passes for a material to be able to use it on gpu.
         * Needs to be called if gpu code is potentially required.
         */
        VertexAnimator.prototype.testGPUCompatibility = function (shader) {
        };
        VertexAnimator.prototype.getRenderableElements = function (renderState, sourceElements) {
            if (this._vertexAnimationSet.blendMode == VertexAnimationMode.ABSOLUTE && this._poses.length)
                return this._poses[0] || sourceElements;
            //nothing to do here
            return sourceElements;
        };
        return VertexAnimator;
    }(AnimatorBase));

    function assert(condition, message) {
        if (message === void 0) { message = "assertion failed"; }
        if (condition === "") { // avoid inadvertent false positive
            condition = true;
        }
        if (!condition) {
            if (typeof console !== 'undefined' && 'assert' in console) {
                console.assert(false, message);
                throw new Error(message);
            }
            else {
                //Debug.error(message.toString());
                throw new Error(message);
            }
        }
    }
    //export function memCopy<T extends TypedArray>(destination: T, source: T, doffset: number = 0,
    function memCopy(destination, source, doffset, soffset, length) {
        if (doffset === void 0) { doffset = 0; }
        if (soffset === void 0) { soffset = 0; }
        if (length === void 0) { length = 0; }
        if (soffset > 0 || (length > 0 && length < source.length)) {
            if (length <= 0) {
                length = source.length - soffset;
            }
            destination.set(source.subarray(soffset, soffset + length), doffset);
        }
        else {
            destination.set(source, doffset);
        }
    }
    /**
     * Faster release version of bounds.
     */
    var Bounds = /** @class */ (function () {
        function Bounds(xMin, yMin, xMax, yMax) {
            this.xMin = xMin | 0;
            this.yMin = yMin | 0;
            this.xMax = xMax | 0;
            this.yMax = yMax | 0;
        }
        //static FromUntyped(source:UntypedBounds):Bounds {
        Bounds.FromUntyped = function (source) {
            return new Bounds(source.xMin, source.yMin, source.xMax, source.yMax);
        };
        //static FromRectangle(source:ASRectangle):Bounds {
        Bounds.FromRectangle = function (source) {
            return new Bounds(source.x * 20 | 0, source.y * 20 | 0, (source.x + source.width) * 20 | 0, (source.y + source.height) * 20 | 0);
        };
        Bounds.prototype.setElements = function (xMin, yMin, xMax, yMax) {
            this.xMin = xMin;
            this.yMin = yMin;
            this.xMax = xMax;
            this.yMax = yMax;
        };
        Bounds.prototype.copyFrom = function (source) {
            this.setElements(source.xMin, source.yMin, source.xMax, source.yMax);
        };
        Bounds.prototype.contains = function (x, y) {
            return x < this.xMin !== x < this.xMax &&
                y < this.yMin !== y < this.yMax;
        };
        Bounds.prototype.unionInPlace = function (other) {
            if (other.isEmpty()) {
                return;
            }
            this.extendByPoint(other.xMin, other.yMin);
            this.extendByPoint(other.xMax, other.yMax);
        };
        Bounds.prototype.extendByPoint = function (x, y) {
            this.extendByX(x);
            this.extendByY(y);
        };
        Bounds.prototype.extendByX = function (x) {
            // Exclude default values.
            if (this.xMin === 0x8000000) {
                this.xMin = this.xMax = x;
                return;
            }
            this.xMin = Math.min(this.xMin, x);
            this.xMax = Math.max(this.xMax, x);
        };
        Bounds.prototype.extendByY = function (y) {
            // Exclude default values.
            if (this.yMin === 0x8000000) {
                this.yMin = this.yMax = y;
                return;
            }
            this.yMin = Math.min(this.yMin, y);
            this.yMax = Math.max(this.yMax, y);
        };
        Bounds.prototype.intersects = function (toIntersect) {
            return this.contains(toIntersect.xMin, toIntersect.yMin) ||
                this.contains(toIntersect.xMax, toIntersect.yMax);
        };
        Bounds.prototype.isEmpty = function () {
            return this.xMax <= this.xMin || this.yMax <= this.yMin;
        };
        Object.defineProperty(Bounds.prototype, "width", {
            get: function () {
                return this.xMax - this.xMin;
            },
            set: function (value) {
                this.xMax = this.xMin + value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Bounds.prototype, "height", {
            get: function () {
                return this.yMax - this.yMin;
            },
            set: function (value) {
                this.yMax = this.yMin + value;
            },
            enumerable: true,
            configurable: true
        });
        Bounds.prototype.getBaseWidth = function (angle) {
            var u = Math.abs(Math.cos(angle));
            var v = Math.abs(Math.sin(angle));
            return u * (this.xMax - this.xMin) + v * (this.yMax - this.yMin);
        };
        Bounds.prototype.getBaseHeight = function (angle) {
            var u = Math.abs(Math.cos(angle));
            var v = Math.abs(Math.sin(angle));
            return v * (this.xMax - this.xMin) + u * (this.yMax - this.yMin);
        };
        Bounds.prototype.setEmpty = function () {
            this.xMin = this.yMin = this.xMax = this.yMax = 0;
        };
        /**
         * Set all fields to the sentinel value 0x8000000.
         *
         * This is what Flash uses to indicate uninitialized bounds. Important for bounds calculation
         * in `Graphics` instances, which start out with empty bounds but must not just extend them
         * from an 0,0 origin.
         */
        Bounds.prototype.setToSentinels = function () {
            this.xMin = this.yMin = this.xMax = this.yMax = 0x8000000;
        };
        Bounds.prototype.clone = function () {
            return new Bounds(this.xMin, this.yMin, this.xMax, this.yMax);
        };
        Bounds.prototype.toString = function () {
            return "{ " +
                "xMin: " + this.xMin + ", " +
                "xMin: " + this.yMin + ", " +
                "xMax: " + this.xMax + ", " +
                "xMax: " + this.yMax +
                " }";
        };
        return Bounds;
    }());
    var ImageType;
    (function (ImageType) {
        ImageType[ImageType["None"] = 0] = "None";
        /**
         * Premultiplied ARGB (byte-order).
         */
        ImageType[ImageType["PremultipliedAlphaARGB"] = 1] = "PremultipliedAlphaARGB";
        /**
         * Unpremultiplied ARGB (byte-order).
         */
        ImageType[ImageType["StraightAlphaARGB"] = 2] = "StraightAlphaARGB";
        /**
         * Unpremultiplied RGBA (byte-order), this is what putImageData expects.
         */
        ImageType[ImageType["StraightAlphaRGBA"] = 3] = "StraightAlphaRGBA";
        ImageType[ImageType["JPEG"] = 4] = "JPEG";
        ImageType[ImageType["PNG"] = 5] = "PNG";
        ImageType[ImageType["GIF"] = 6] = "GIF";
    })(ImageType || (ImageType = {}));
    function clamp(value, min, max) {
        return Math.max(min, Math.min(max, value));
    }
    function roundToMultipleOfFour(x) {
        return (x + 3) & ~0x3;
    }
    function isNullOrUndefined(value) {
        return value == undefined;
    }
    function utf8decode(str) {
        var bytes = new Uint8Array(str.length * 4);
        var b = 0;
        for (var i = 0, j = str.length; i < j; i++) {
            var code = str.charCodeAt(i);
            if (code <= 0x7f) {
                bytes[b++] = code;
                continue;
            }
            if (0xD800 <= code && code <= 0xDBFF) {
                var codeLow = str.charCodeAt(i + 1);
                if (0xDC00 <= codeLow && codeLow <= 0xDFFF) {
                    // convert only when both high and low surrogates are present
                    code = ((code & 0x3FF) << 10) + (codeLow & 0x3FF) + 0x10000;
                    ++i;
                }
            }
            if ((code & 0xFFE00000) !== 0) {
                bytes[b++] = 0xF8 | ((code >>> 24) & 0x03);
                bytes[b++] = 0x80 | ((code >>> 18) & 0x3F);
                bytes[b++] = 0x80 | ((code >>> 12) & 0x3F);
                bytes[b++] = 0x80 | ((code >>> 6) & 0x3F);
                bytes[b++] = 0x80 | (code & 0x3F);
            }
            else if ((code & 0xFFFF0000) !== 0) {
                bytes[b++] = 0xF0 | ((code >>> 18) & 0x07);
                bytes[b++] = 0x80 | ((code >>> 12) & 0x3F);
                bytes[b++] = 0x80 | ((code >>> 6) & 0x3F);
                bytes[b++] = 0x80 | (code & 0x3F);
            }
            else if ((code & 0xFFFFF800) !== 0) {
                bytes[b++] = 0xE0 | ((code >>> 12) & 0x0F);
                bytes[b++] = 0x80 | ((code >>> 6) & 0x3F);
                bytes[b++] = 0x80 | (code & 0x3F);
            }
            else {
                bytes[b++] = 0xC0 | ((code >>> 6) & 0x1F);
                bytes[b++] = 0x80 | (code & 0x3F);
            }
        }
        return bytes.subarray(0, b);
    }
    function utf8encode(bytes) {
        var j = 0, str = "";
        while (j < bytes.length) {
            var b1 = bytes[j++] & 0xFF;
            if (b1 <= 0x7F) {
                str += String.fromCharCode(b1);
            }
            else {
                var currentPrefix = 0xC0;
                var validBits = 5;
                do {
                    var mask = (currentPrefix >> 1) | 0x80;
                    if ((b1 & mask) === currentPrefix)
                        break;
                    currentPrefix = (currentPrefix >> 1) | 0x80;
                    --validBits;
                } while (validBits >= 0);
                if (validBits <= 0) {
                    // Invalid UTF8 character -- copying as is
                    str += String.fromCharCode(b1);
                    continue;
                }
                var code = (b1 & ((1 << validBits) - 1));
                var invalid = false;
                for (var i = 5; i >= validBits; --i) {
                    var bi = bytes[j++];
                    if ((bi & 0xC0) != 0x80) {
                        // Invalid UTF8 character sequence
                        invalid = true;
                        break;
                    }
                    code = (code << 6) | (bi & 0x3F);
                }
                if (invalid) {
                    // Copying invalid sequence as is
                    for (var k = j - (7 - i); k < j; ++k) {
                        str += String.fromCharCode(bytes[k] & 255);
                    }
                    continue;
                }
                if (code >= 0x10000) {
                    str += String.fromCharCode((((code - 0x10000) >> 10) & 0x3FF) |
                        0xD800, (code & 0x3FF) | 0xDC00);
                }
                else {
                    str += String.fromCharCode(code);
                }
            }
        }
        return str;
    }
    /**
     * Simple pool allocator for ArrayBuffers. This reduces memory usage in data structures
     * that resize buffers.
     */
    var ArrayBufferPool = /** @class */ (function () {
        /**
         * Creates a pool that manages a pool of a |maxSize| number of array buffers.
         */
        function ArrayBufferPool(maxSize) {
            if (maxSize === void 0) { maxSize = 32; }
            this._list = [];
            this._maxSize = maxSize;
        }
        /**
         * Creates or reuses an existing array buffer that is at least the
         * specified |length|.
         */
        ArrayBufferPool.prototype.acquire = function (length) {
            if (ArrayBufferPool._enabled) {
                var list = this._list;
                for (var i = 0; i < list.length; i++) {
                    var buffer = list[i];
                    if (buffer.byteLength >= length) {
                        list.splice(i, 1);
                        return buffer;
                    }
                }
            }
            return new ArrayBuffer(length);
        };
        /**
         * Releases an array buffer that is no longer needed back to the pool.
         */
        ArrayBufferPool.prototype.release = function (buffer) {
            if (ArrayBufferPool._enabled) {
                var list = this._list;
                //release || Debug.assert(ArrayUtilities.indexOf(list, buffer) < 0);
                if (list.length === this._maxSize) {
                    list.shift();
                }
                list.push(buffer);
            }
        };
        /**
         * Resizes a Uint8Array to have the given length.
         */
        ArrayBufferPool.prototype.ensureUint8ArrayLength = function (array, length) {
            if (array.length >= length) {
                return array;
            }
            var newLength = Math.max(array.length + length, ((array.length * 3) >> 1) + 1);
            var newArray = new Uint8Array(this.acquire(newLength), 0, newLength);
            newArray.set(array);
            this.release(array.buffer);
            return newArray;
        };
        /**
         * Resizes a Float64Array to have the given length.
         */
        ArrayBufferPool.prototype.ensureFloat64ArrayLength = function (array, length) {
            if (array.length >= length) {
                return array;
            }
            var newLength = Math.max(array.length + length, ((array.length * 3) >> 1) + 1);
            var newArray = new Float64Array(this.acquire(newLength * Float64Array.BYTES_PER_ELEMENT), 0, newLength);
            newArray.set(array);
            this.release(array.buffer);
            return newArray;
        };
        ArrayBufferPool._enabled = true;
        return ArrayBufferPool;
    }());
    /**
     * Makes sure that a typed array has the requested capacity. If required, it creates a new
     * instance of the array's class with a power-of-two capacity at least as large as required.
     */
    //export function ensureTypedArrayCapacity<T extends TypedArray>(array: T, capacity: number): T {
    function ensureTypedArrayCapacity(array, capacity) {
        if (array.length < capacity) {
            var oldArray = array;
            array = new array.constructor(IntegerUtilities.nearestPowerOfTwo(capacity));
            array.set(oldArray, 0);
        }
        return array;
    }
    /*
    interface Math {
        imul(a: number, b: number): number;
        /**
         * Returns the number of leading zeros of a number.
         * @param x A numeric expression.
         */
    /*clz32(x: number): number;
    }*/
    var IntegerUtilities;
    (function (IntegerUtilities) {
        var sharedBuffer = new ArrayBuffer(8);
        IntegerUtilities.i8 = new Int8Array(sharedBuffer);
        IntegerUtilities.u8 = new Uint8Array(sharedBuffer);
        IntegerUtilities.i32 = new Int32Array(sharedBuffer);
        IntegerUtilities.f32 = new Float32Array(sharedBuffer);
        IntegerUtilities.f64 = new Float64Array(sharedBuffer);
        IntegerUtilities.nativeLittleEndian = new Int8Array(new Int32Array([1]).buffer)[0] === 1;
        /**
         * Convert a float into 32 bits.
         */
        function floatToInt32(v) {
            IntegerUtilities.f32[0] = v;
            return IntegerUtilities.i32[0];
        }
        IntegerUtilities.floatToInt32 = floatToInt32;
        /**
         * Convert 32 bits into a float.
         */
        function int32ToFloat(i) {
            IntegerUtilities.i32[0] = i;
            return IntegerUtilities.f32[0];
        }
        IntegerUtilities.int32ToFloat = int32ToFloat;
        /**
         * Swap the bytes of a 16 bit number.
         */
        function swap16(i) {
            return ((i & 0xFF) << 8) | ((i >> 8) & 0xFF);
        }
        IntegerUtilities.swap16 = swap16;
        /**
         * Swap the bytes of a 32 bit number.
         */
        function swap32(i) {
            return ((i & 0xFF) << 24) | ((i & 0xFF00) << 8) | ((i >> 8) & 0xFF00) | ((i >> 24) & 0xFF);
        }
        IntegerUtilities.swap32 = swap32;
        /**
         * Converts a number to s8.u8 fixed point representation.
         */
        function toS8U8(v) {
            return ((v * 256) << 16) >> 16;
        }
        IntegerUtilities.toS8U8 = toS8U8;
        /**
         * Converts a number from s8.u8 fixed point representation.
         */
        function fromS8U8(i) {
            return i / 256;
        }
        IntegerUtilities.fromS8U8 = fromS8U8;
        /**
         * Round trips a number through s8.u8 conversion.
         */
        function clampS8U8(v) {
            return fromS8U8(toS8U8(v));
        }
        IntegerUtilities.clampS8U8 = clampS8U8;
        /**
         * Converts a number to signed 16 bits.
         */
        function toS16(v) {
            return (v << 16) >> 16;
        }
        IntegerUtilities.toS16 = toS16;
        function bitCount(i) {
            i = i - ((i >> 1) & 0x55555555);
            i = (i & 0x33333333) + ((i >> 2) & 0x33333333);
            return (((i + (i >> 4)) & 0x0F0F0F0F) * 0x01010101) >> 24;
        }
        IntegerUtilities.bitCount = bitCount;
        function ones(i) {
            i = i - ((i >> 1) & 0x55555555);
            i = (i & 0x33333333) + ((i >> 2) & 0x33333333);
            return ((i + (i >> 4) & 0xF0F0F0F) * 0x1010101) >> 24;
        }
        IntegerUtilities.ones = ones;
        function trailingZeros(i) {
            return IntegerUtilities.ones((i & -i) - 1);
        }
        IntegerUtilities.trailingZeros = trailingZeros;
        function getFlags(i, flags) {
            var str = "";
            for (var i = 0; i < flags.length; i++) {
                if (i & (1 << i)) {
                    str += flags[i] + " ";
                }
            }
            if (str.length === 0) {
                return "";
            }
            return str.trim();
        }
        IntegerUtilities.getFlags = getFlags;
        function isPowerOfTwo(x) {
            return x && ((x & (x - 1)) === 0);
        }
        IntegerUtilities.isPowerOfTwo = isPowerOfTwo;
        function roundToMultipleOfFour(x) {
            return (x + 3) & ~0x3;
        }
        IntegerUtilities.roundToMultipleOfFour = roundToMultipleOfFour;
        function nearestPowerOfTwo(x) {
            x--;
            x |= x >> 1;
            x |= x >> 2;
            x |= x >> 4;
            x |= x >> 8;
            x |= x >> 16;
            x++;
            return x;
        }
        IntegerUtilities.nearestPowerOfTwo = nearestPowerOfTwo;
        function roundToMultipleOfPowerOfTwo(i, powerOfTwo) {
            var x = (1 << powerOfTwo) - 1;
            return (i + x) & ~x; // Round up to multiple of power of two.
        }
        IntegerUtilities.roundToMultipleOfPowerOfTwo = roundToMultipleOfPowerOfTwo;
        function toHEX(i) {
            var i = (i < 0 ? 0xFFFFFFFF + i + 1 : i);
            return "0x" + ("00000000" + i.toString(16)).substr(-8);
        }
        IntegerUtilities.toHEX = toHEX;
        /**
         * Polyfill imul.
         */
        /*
        if (!Math.imul) {
            Math.imul = function imul(a, b) {
                var ah  = (a >>> 16) & 0xffff;
                var al = a & 0xffff;
                var bh  = (b >>> 16) & 0xffff;
                var bl = b & 0xffff;
                // the shift by 0 fixes the sign on the high part
                // the final |0 converts the unsigned value into a signed value
                return ((al * bl) + (((ah * bl + al * bh) << 16) >>> 0) | 0);
            };
        }*/
        /**
         * Polyfill clz32.
         */
        /*if (!Math.clz32) {
            Math.clz32 = function clz32(i: number) {
                i |= (i >> 1);
                i |= (i >> 2);
                i |= (i >> 4);
                i |= (i >> 8);
                i |= (i >> 16);
                return 32 - IntegerUtilities.ones(i);
            };
        }*/
    })(IntegerUtilities || (IntegerUtilities = {}));
    var ABCBlock = /** @class */ (function () {
        function ABCBlock() {
        }
        return ABCBlock;
    }());
    var SymbolExport = /** @class */ (function () {
        function SymbolExport(symbolId, className) {
            this.symbolId = symbolId;
            this.className = className;
        }
        return SymbolExport;
    }());
    var UnparsedTag = /** @class */ (function () {
        function UnparsedTag(tagCode, byteOffset, byteLength) {
            this.tagCode = tagCode;
            this.byteOffset = byteOffset;
            this.byteLength = byteLength;
        }
        return UnparsedTag;
    }());
    var DictionaryEntry = /** @class */ (function (_super) {
        __extends$5(DictionaryEntry, _super);
        function DictionaryEntry(id, tagCode, byteOffset, byteLength) {
            var _this = _super.call(this, tagCode, byteOffset, byteLength) || this;
            _this.id = id;
            return _this;
        }
        return DictionaryEntry;
    }(UnparsedTag));
    var EagerlyParsedDictionaryEntry = /** @class */ (function (_super) {
        __extends$5(EagerlyParsedDictionaryEntry, _super);
        function EagerlyParsedDictionaryEntry(id, unparsed, type, definition) {
            var _this = _super.call(this, id, unparsed.tagCode, unparsed.byteOffset, unparsed.byteLength) || this;
            _this.type = type;
            _this.definition = definition;
            _this.ready = false;
            return _this;
        }
        return EagerlyParsedDictionaryEntry;
    }(DictionaryEntry));
    /**
     * Similar to |toString| but returns |null| for |null| or |undefined| instead
     * of "null" or "undefined".
     */
    function axCoerceString(x) {
        if (typeof x === "string") {
            return x;
        }
        else if (x == undefined) {
            return null;
        }
        return x + '';
    }
    var Errors = {
        /**
         * AVM2 Error Codes
         */
        //  OutOfMemoryError                     : {code: 1000, message: "The system is out of memory."},
        NotImplementedError: { code: 1001, message: "The method %1 is not implemented." },
        InvalidPrecisionError: { code: 1002, message: "Number.toPrecision has a range of 1 to 21. Number.toFixed and Number.toExponential have a range of 0 to 20. Specified value is not within expected range." },
        InvalidRadixError: { code: 1003, message: "The radix argument must be between 2 and 36; got %1." },
        InvokeOnIncompatibleObjectError: { code: 1004, message: "Method %1 was invoked on an incompatible object." },
        ArrayIndexNotIntegerError: { code: 1005, message: "Array index is not a positive integer (%1)." },
        CallOfNonFunctionError: { code: 1006, message: "%1 is not a function." },
        ConstructOfNonFunctionError: { code: 1007, message: "Instantiation attempted on a non-constructor." },
        //  AmbiguousBindingError                : {code: 1008, message: "%1 is ambiguous; Found more than one matching binding."},
        ConvertNullToObjectError: { code: 1009, message: "Cannot access a property or method of a null object reference." },
        ConvertUndefinedToObjectError: { code: 1010, message: "A term is undefined and has no properties." },
        //  IllegalOpcodeError                   : {code: 1011, message: "Method %1 contained illegal opcode %2 at offset %3."},
        //  LastInstExceedsCodeSizeError         : {code: 1012, message: "The last instruction exceeded code size."},
        //  FindVarWithNoScopeError              : {code: 1013, message: "Cannot call OP_findproperty when scopeDepth is 0."},
        ClassNotFoundError: { code: 1014, message: "Class %1 could not be found." },
        //  IllegalSetDxns                       : {code: 1015, message: "Method %1 cannot set default xml namespace"},
        DescendentsError: { code: 1016, message: "Descendants operator (..) not supported on type %1." },
        //  ScopeStackOverflowError              : {code: 1017, message: "Scope stack overflow occurred."},
        //  ScopeStackUnderflowError             : {code: 1018, message: "Scope stack underflow occurred."},
        //  GetScopeObjectBoundsError            : {code: 1019, message: "Getscopeobject %1 is out of bounds."},
        //  CannotFallOffMethodError             : {code: 1020, message: "Code cannot fall off the end of a method."},
        //  InvalidBranchTargetError             : {code: 1021, message: "At least one branch target was not on a valid instruction in the method."},
        //  IllegalVoidError                     : {code: 1022, message: "Type void may only be used as a function return type."},
        StackOverflowError: { code: 1023, message: "Stack overflow occurred." },
        //  StackUnderflowError                  : {code: 1024, message: "Stack underflow occurred."},
        //  InvalidRegisterError                 : {code: 1025, message: "An invalid register %1 was accessed."},
        //  SlotExceedsCountError                : {code: 1026, message: "Slot %1 exceeds slotCount=%2 of %3."},
        //  MethodInfoExceedsCountError          : {code: 1027, message: "Method_info %1 exceeds method_count=%2."},
        //  DispIdExceedsCountError              : {code: 1028, message: "Disp_id %1 exceeds max_disp_id=%2 of %3."},
        //  DispIdUndefinedError                 : {code: 1029, message: "Disp_id %1 is undefined on %2."},
        //  StackDepthUnbalancedError            : {code: 1030, message: "Stack depth is unbalanced. %1 != %2."},
        //  ScopeDepthUnbalancedError            : {code: 1031, message: "Scope depth is unbalanced. %1 != %2."},
        CpoolIndexRangeError: { code: 1032, message: "Cpool index %1 is out of range %2." },
        CpoolEntryWrongTypeError: { code: 1033, message: "Cpool entry %1 is wrong type." },
        CheckTypeFailedError: { code: 1034, message: "Type Coercion failed: cannot convert %1 to %2." },
        //  IllegalSuperCallError                : {code: 1035, message: "Illegal super expression found in method %1."},
        CannotAssignToMethodError: { code: 1037, message: "Cannot assign to a method %1 on %2." },
        //  RedefinedError                       : {code: 1038, message: "%1 is already defined."},
        //  CannotVerifyUntilReferencedError     : {code: 1039, message: "Cannot verify method until it is referenced."},
        CantUseInstanceofOnNonObjectError: { code: 1040, message: "The right-hand side of instanceof must be a class or function." },
        IsTypeMustBeClassError: { code: 1041, message: "The right-hand side of operator must be a class." },
        InvalidMagicError: { code: 1042, message: "Not an ABC file.  major_version=%1 minor_version=%2." },
        //  InvalidCodeLengthError               : {code: 1043, message: "Invalid code_length=%1."},
        //  InvalidMethodInfoFlagsError          : {code: 1044, message: "MethodInfo-%1 unsupported flags=%2."},
        UnsupportedTraitsKindError: { code: 1045, message: "Unsupported traits kind=%1." },
        //  MethodInfoOrderError                 : {code: 1046, message: "MethodInfo-%1 referenced before definition."},
        //  MissingEntryPointError               : {code: 1047, message: "No entry point was found."},
        PrototypeTypeError: { code: 1049, message: "Prototype objects must be vanilla Objects." },
        ConvertToPrimitiveError: { code: 1050, message: "Cannot convert %1 to primitive." },
        //  IllegalEarlyBindingError             : {code: 1051, message: "Illegal early binding access to %1."},
        InvalidURIError: { code: 1052, message: "Invalid URI passed to %1 function." },
        //  IllegalOverrideError                 : {code: 1053, message: "Illegal override of %1 in %2."},
        //  IllegalExceptionHandlerError         : {code: 1054, message: "Illegal range or target offsets in exception handler."},
        WriteSealedError: { code: 1056, message: "Cannot create property %1 on %2." },
        //  IllegalSlotError                     : {code: 1057, message: "%1 can only contain methods."},
        //  IllegalOperandTypeError              : {code: 1058, message: "Illegal operand type: %1 must be %2."},
        //  ClassInfoOrderError                  : {code: 1059, message: "ClassInfo-%1 is referenced before definition."},
        //  ClassInfoExceedsCountError           : {code: 1060, message: "ClassInfo %1 exceeds class_count=%2."},
        //  NumberOutOfRangeError                : {code: 1061, message: "The value %1 cannot be converted to %2 without losing precision."},
        WrongArgumentCountError: { code: 1063, message: "Argument count mismatch on %1. Expected %2, got %3." },
        //  CannotCallMethodAsConstructor        : {code: 1064, message: "Cannot call method %1 as constructor."},
        UndefinedVarError: { code: 1065, message: "Variable %1 is not defined." },
        //  FunctionConstructorError             : {code: 1066, message: "The form function('function body') is not supported."},
        //  IllegalNativeMethodBodyError         : {code: 1067, message: "Native method %1 has illegal method body."},
        //  CannotMergeTypesError                : {code: 1068, message: "%1 and %2 cannot be reconciled."},
        ReadSealedError: { code: 1069, message: "Property %1 not found on %2 and there is no default value." },
        //  CallNotFoundError                    : {code: 1070, message: "Method %1 not found on %2"},
        //  AlreadyBoundError                    : {code: 1071, message: "Function %1 has already been bound to %2."},
        //  ZeroDispIdError                      : {code: 1072, message: "Disp_id 0 is illegal."},
        //  DuplicateDispIdError                 : {code: 1073, message: "Non-override method %1 replaced because of duplicate disp_id %2."},
        ConstWriteError: { code: 1074, message: "Illegal write to read-only property %1 on %2." },
        //  MathNotFunctionError                 : {code: 1075, message: "Math is not a function."},
        //  MathNotConstructorError              : {code: 1076, message: "Math is not a constructor."},
        //  WriteOnlyError                       : {code: 1077, message: "Illegal read of write-only property %1 on %2."},
        //  IllegalOpMultinameError              : {code: 1078, message: "Illegal opcode/multiname combination: %1<%2>."},
        //  IllegalNativeMethodError             : {code: 1079, message: "Native methods are not allowed in loaded code."},
        //  IllegalNamespaceError                : {code: 1080, message: "Illegal value for namespace."},
        //  ReadSealedErrorNs                    : {code: 1081, message: "Property %1 not found on %2 and there is no default value."},
        //  NoDefaultNamespaceError              : {code: 1082, message: "No default namespace has been set."},
        XMLPrefixNotBound: { code: 1083, message: "The prefix \"%1\" for element \"%2\" is not bound." },
        //  XMLBadQName                          : {code: 1084, message: "Element or attribute (\"%1\") does not match QName production: QName::=(NCName':')?NCName."},
        XMLUnterminatedElementTag: { code: 1085, message: "The element type \"%1\" must be terminated by the matching end-tag \"</%2>\"." },
        XMLOnlyWorksWithOneItemLists: { code: 1086, message: "The %1 method only works on lists containing one item." },
        XMLAssignmentToIndexedXMLNotAllowed: { code: 1087, message: "Assignment to indexed XML is not allowed." },
        XMLMarkupMustBeWellFormed: { code: 1088, message: "The markup in the document following the root element must be well-formed." },
        XMLAssigmentOneItemLists: { code: 1089, message: "Assignment to lists with more than one item is not supported." },
        XMLMalformedElement: { code: 1090, message: "XML parser failure: element is malformed." },
        XMLUnterminatedCData: { code: 1091, message: "XML parser failure: Unterminated CDATA section." },
        XMLUnterminatedXMLDecl: { code: 1092, message: "XML parser failure: Unterminated XML declaration." },
        XMLUnterminatedDocTypeDecl: { code: 1093, message: "XML parser failure: Unterminated DOCTYPE declaration." },
        XMLUnterminatedComment: { code: 1094, message: "XML parser failure: Unterminated comment." },
        //  XMLUnterminatedAttribute             : {code: 1095, message: "XML parser failure: Unterminated attribute."},
        XMLUnterminatedElement: { code: 1096, message: "XML parser failure: Unterminated element." },
        //  XMLUnterminatedProcessingInstruction : {code: 1097, message: "XML parser failure: Unterminated processing instruction."},
        XMLNamespaceWithPrefixAndNoURI: { code: 1098, message: "Illegal prefix %1 for no namespace." },
        RegExpFlagsArgumentError: { code: 1100, message: "Cannot supply flags when constructing one RegExp from another." },
        //  NoScopeError                         : {code: 1101, message: "Cannot verify method %1 with unknown scope."},
        //  IllegalDefaultValue                  : {code: 1102, message: "Illegal default value for type %1."},
        //  CannotExtendFinalClass               : {code: 1103, message: "Class %1 cannot extend final base class."},
        //  XMLDuplicateAttribute                : {code: 1104, message: "Attribute \"%1\" was already specified for element \"%2\"."},
        //  CorruptABCError                      : {code: 1107, message: "The ABC data is corrupt, attempt to read out of bounds."},
        InvalidBaseClassError: { code: 1108, message: "The OP_newclass opcode was used with the incorrect base class." },
        //  DanglingFunctionError                : {code: 1109, message: "Attempt to directly call unbound function %1 from method %2."},
        //  CannotExtendError                    : {code: 1110, message: "%1 cannot extend %2."},
        //  CannotImplementError                 : {code: 1111, message: "%1 cannot implement %2."},
        //  CoerceArgumentCountError             : {code: 1112, message: "Argument count mismatch on class coercion.  Expected 1, got %1."},
        //  InvalidNewActivationError            : {code: 1113, message: "OP_newactivation used in method without NEED_ACTIVATION flag."},
        //  NoGlobalScopeError                   : {code: 1114, message: "OP_getglobalslot or OP_setglobalslot used with no global scope."},
        //  NotConstructorError                  : {code: 1115, message: "%1 is not a constructor."},
        //  ApplyError                           : {code: 1116, message: "second argument to Function.prototype.apply must be an array."},
        XMLInvalidName: { code: 1117, message: "Invalid XML name: %1." },
        XMLIllegalCyclicalLoop: { code: 1118, message: "Illegal cyclical loop between nodes." },
        //  DeleteTypeError                      : {code: 1119, message: "Delete operator is not supported with operand of type %1."},
        //  DeleteSealedError                    : {code: 1120, message: "Cannot delete property %1 on %2."},
        //  DuplicateMethodBodyError             : {code: 1121, message: "Method %1 has a duplicate method body."},
        //  IllegalInterfaceMethodBodyError      : {code: 1122, message: "Interface method %1 has illegal method body."},
        FilterError: { code: 1123, message: "Filter operator not supported on type %1." },
        //  InvalidHasNextError                  : {code: 1124, message: "OP_hasnext2 requires object and index to be distinct registers."},
        OutOfRangeError: { code: 1125, message: "The index %1 is out of range %2." },
        VectorFixedError: { code: 1126, message: "Cannot change the length of a fixed Vector." },
        TypeAppOfNonParamType: { code: 1127, message: "Type application attempted on a non-parameterized type." },
        WrongTypeArgCountError: { code: 1128, message: "Incorrect number of type parameters for %1. Expected %2, got %3." },
        JSONCyclicStructure: { code: 1129, message: "Cyclic structure cannot be converted to JSON string." },
        JSONInvalidReplacer: { code: 1131, message: "Replacer argument to JSON stringifier must be an array or a two parameter function." },
        JSONInvalidParseInput: { code: 1132, message: "Invalid JSON parse input." },
        //  FileOpenError                        : {code: 1500, message: "Error occurred opening file %1."},
        //  FileWriteError                       : {code: 1501, message: "Error occurred writing to file %1."},
        //  ScriptTimeoutError                   : {code: 1502, message: "A script has executed for longer than the default timeout period of 15 seconds."},
        //  ScriptTerminatedError                : {code: 1503, message: "A script failed to exit after 30 seconds and was terminated."},
        //  EndOfFileError                       : {code: 1504, message: "End of file."},
        //  StringIndexOutOfBoundsError          : {code: 1505, message: "The string index %1 is out of bounds; must be in range %2 to %3."},
        InvalidRangeError: { code: 1506, message: "The specified range is invalid." },
        NullArgumentError: { code: 1507, message: "Argument %1 cannot be null." },
        InvalidArgumentError: { code: 1508, message: "The value specified for argument %1 is invalid." },
        ArrayFilterNonNullObjectError: { code: 1510, message: "When the callback argument is a method of a class, the optional this argument must be null." },
        InvalidParamError: { code: 2004, message: "One of the parameters is invalid." },
        ParamRangeError: { code: 2006, message: "The supplied index is out of bounds." },
        NullPointerError: { code: 2007, message: "Parameter %1 must be non-null." },
        InvalidEnumError: { code: 2008, message: "Parameter %1 must be one of the accepted values." },
        CantInstantiateError: { code: 2012, message: "%1 class cannot be instantiated." },
        InvalidBitmapData: { code: 2015, message: "Invalid BitmapData." },
        EOFError: { code: 2030, message: "End of file was encountered.", fqn: 'flash.errors.EOFError' },
        CompressedDataError: { code: 2058, message: "There was an error decompressing the data.", fqn: 'flash.errors.IOError' },
        EmptyStringError: { code: 2085, message: "Parameter %1 must be non-empty string." },
        ProxyGetPropertyError: { code: 2088, message: "The Proxy class does not implement getProperty. It must be overridden by a subclass." },
        ProxySetPropertyError: { code: 2089, message: "The Proxy class does not implement setProperty. It must be overridden by a subclass." },
        ProxyCallPropertyError: { code: 2090, message: "The Proxy class does not implement callProperty. It must be overridden by a subclass." },
        ProxyHasPropertyError: { code: 2091, message: "The Proxy class does not implement hasProperty. It must be overridden by a subclass." },
        ProxyDeletePropertyError: { code: 2092, message: "The Proxy class does not implement deleteProperty. It must be overridden by a subclass." },
        ProxyGetDescendantsError: { code: 2093, message: "The Proxy class does not implement getDescendants. It must be overridden by a subclass." },
        ProxyNextNameIndexError: { code: 2105, message: "The Proxy class does not implement nextNameIndex. It must be overridden by a subclass." },
        ProxyNextNameError: { code: 2106, message: "The Proxy class does not implement nextName. It must be overridden by a subclass." },
        ProxyNextValueError: { code: 2107, message: "The Proxy class does not implement nextValue. It must be overridden by a subclass." },
        //  InvalidArrayLengthError              : {code: 2108, message: "The value %1 is not a valid Array length."},
        //  ReadExternalNotImplementedError      : {code: 2173, message: "Unable to read object in stream.  The class %1 does not implement flash.utils.IExternalizable but is aliased to an externalizable class."},
        /**
         * Player Error Codes
         */
        //  NoSecurityContextError                                    : { code: 2000, message: "No active security context."},
        TooFewArgumentsError: { code: 2001, message: "Too few arguments were specified; got %1, %2 expected." },
        //  InvalidSocketError                                        : { code: 2002, message: "Operation attempted on invalid socket."},
        //  InvalidSocketPortError                                    : { code: 2003, message: "Invalid socket port number specified."},
        ParamTypeError: { code: 2005, message: "Parameter %1 is of the incorrect type. Should be type %2." },
        //  HasStyleSheetError                                        : { code: 2009, message: "This method cannot be used on a text field with a style sheet."},
        //  SocketLocalFileSecurityError                              : { code: 2010, message: "Local-with-filesystem SWF files are not permitted to use sockets."},
        SocketConnectError: { code: 2011, message: "Socket connection failed to %1:%2." },
        //  AuthoringOnlyFeatureError                                 : { code: 2013, message: "Feature can only be used in Flash Authoring."},
        //  FeatureNotAvailableError                                  : { code: 2014, message: "Feature is not available at this time."},
        //  InvalidBitmapDataError                                    : { code: 2015, message: "Invalid BitmapData."},
        //  SystemExitSecurityError                                   : { code: 2017, message: "Only trusted local files may cause the Flash Player to exit."},
        //  SystemExitUnsupportedError                                : { code: 2018, message: "System.exit is only available in the standalone Flash Player."},
        //  InvalidDepthError                                         : { code: 2019, message: "Depth specified is invalid."},
        //  MovieClipSwapError                                        : { code: 2020, message: "MovieClips objects with different parents cannot be swapped."},
        //  ObjectCreationError                                       : { code: 2021, message: "Object creation failed."},
        //  NotDisplayObjectError                                     : { code: 2022, message: "Class %1 must inherit from DisplayObject to link to a symbol."},
        //  NotSpriteError                                            : { code: 2023, message: "Class %1 must inherit from Sprite to link to the root."},
        CantAddSelfError: { code: 2024, message: "An object cannot be added as a child of itself." },
        NotAChildError: { code: 2025, message: "The supplied DisplayObject must be a child of the caller." },
        //  NavigateURLError                                          : { code: 2026, message: "An error occurred navigating to the URL %1."},
        //  MustBeNonNegativeError                                    : { code: 2027, message: "Parameter %1 must be a non-negative number; got %2."},
        //  LocalSecurityError                                        : { code: 2028, message: "Local-with-filesystem SWF file %1 cannot access Internet URL %2."},
        //  InvalidStreamError                                        : { code: 2029, message: "This URLStream object does not have a stream opened."},
        //  SocketError                                               : { code: 2031, message: "Socket Error."},
        //  StreamError                                               : { code: 2032, message: "Stream Error."},
        //  KeyGenerationError                                        : { code: 2033, message: "Key Generation Failed."},
        //  InvalidKeyError                                           : { code: 2034, message: "An invalid digest was supplied."},
        //  URLNotFoundError                                          : { code: 2035, message: "URL Not Found."},
        //  LoadNeverCompletedError                                   : { code: 2036, message: "Load Never Completed."},
        //  InvalidCallError                                          : { code: 2037, message: "Functions called in incorrect sequence, or earlier call was unsuccessful."},
        //  FileIOError                                               : { code: 2038, message: "File I/O Error."},
        //  RemoteURLError                                            : { code: 2039, message: "Invalid remote URL protocol. The remote URL protocol must be HTTP or HTTPS."},
        //  BrowseInProgressError                                     : { code: 2041, message: "Only one file browsing session may be performed at a time."},
        //  DigestNotSupportedError                                   : { code: 2042, message: "The digest property is not supported by this load operation."},
        UnhandledError: { code: 2044, message: "Unhandled %1:." },
        //  FileVerificationError                                     : { code: 2046, message: "The loaded file did not have a valid signature."},
        //  DisplayListSecurityError                                  : { code: 2047, message: "Security sandbox violation: %1: %2 cannot access %3."},
        //  DownloadSecurityError                                     : { code: 2048, message: "Security sandbox violation: %1 cannot load data from %2."},
        //  UploadSecurityError                                       : { code: 2049, message: "Security sandbox violation: %1 cannot upload data to %2."},
        //  OutboundScriptingSecurityError                            : { code: 2051, message: "Security sandbox violation: %1 cannot evaluate scripting URLs within %2 (allowScriptAccess is %3). Attempted URL was %4."},
        AllowDomainArgumentError: { code: 2052, message: "Only String arguments are permitted for allowDomain and allowInsecureDomain." },
        //  IntervalSecurityError                                     : { code: 2053, message: "Security sandbox violation: %1 cannot clear an interval timer set by %2."},
        //  ExactSettingsError                                        : { code: 2054, message: "The value of Security.exactSettings cannot be changed after it has been used."},
        //  PrintJobStartError                                        : { code: 2055, message: "The print job could not be started."},
        //  PrintJobSendError                                         : { code: 2056, message: "The print job could not be sent to the printer."},
        //  PrintJobAddPageError                                      : { code: 2057, message: "The page could not be added to the print job."},
        //  ExternalCallbackSecurityError                             : { code: 2059, message: "Security sandbox violation: %1 cannot overwrite an ExternalInterface callback added by %2."},
        //  ExternalInterfaceSecurityError                            : { code: 2060, message: "Security sandbox violation: ExternalInterface caller %1 cannot access %2."},
        //  ExternalInterfaceNoCallbackError                          : { code: 2061, message: "No ExternalInterface callback %1 registered."},
        //  NoCloneMethodError                                        : { code: 2062, message: "Children of Event must override clone() {return new MyEventClass (...);}."},
        //  IMEError                                                  : { code: 2063, message: "Error attempting to execute IME command."},
        //  FocusNotSetError                                          : { code: 2065, message: "The focus cannot be set for this target."},
        DelayRangeError: { code: 2066, message: "The Timer delay specified is out of range." },
        ExternalInterfaceNotAvailableError: { code: 2067, message: "The ExternalInterface is not available in this container. ExternalInterface requires Internet Explorer ActiveX, Firefox, Mozilla 1.7.5 and greater, or other browsers that support NPRuntime." },
        //  InvalidSoundError                                         : { code: 2068, message: "Invalid sound."},
        InvalidLoaderMethodError: { code: 2069, message: "The Loader class does not implement this method." },
        //  StageOwnerSecurityError                                   : { code: 2070, message: "Security sandbox violation: caller %1 cannot access Stage owned by %2."},
        InvalidStageMethodError: { code: 2071, message: "The Stage class does not implement this property or method." },
        //  ProductManagerDiskError                                   : { code: 2073, message: "There was a problem saving the application to disk."},
        //  ProductManagerStageError                                  : { code: 2074, message: "The stage is too small to fit the download ui."},
        //  ProductManagerVerifyError                                 : { code: 2075, message: "The downloaded file is invalid."},
        //  FilterFailedError                                         : { code: 2077, message: "This filter operation cannot be performed with the specified input parameters."},
        TimelineObjectNameSealedError: { code: 2078, message: "The name property of a Timeline-placed object cannot be modified." },
        //  BitmapNotAssociatedWithBitsCharError                      : { code: 2079, message: "Classes derived from Bitmap can only be associated with defineBits characters (bitmaps)."},
        AlreadyConnectedError: { code: 2082, message: "Connect failed because the object is already connected." },
        CloseNotConnectedError: { code: 2083, message: "Close failed because the object is not connected." },
        ArgumentSizeError: { code: 2084, message: "The AMF encoding of the arguments cannot exceed 40K." },
        //  FileReferenceProhibitedError                              : { code: 2086, message: "A setting in the mms.cfg file prohibits this FileReference request."},
        //  DownloadFileNameProhibitedError                           : { code: 2087, message: "The FileReference.download() file name contains prohibited characters."},
        //  EventDispatchRecursionError                               : { code: 2094, message: "Event dispatch recursion overflow."},
        AsyncError: { code: 2095, message: "%1 was unable to invoke callback %2." },
        //  DisallowedHTTPHeaderError                                 : { code: 2096, message: "The HTTP request header %1 cannot be set via ActionScript."},
        //  FileFilterError                                           : { code: 2097, message: "The FileFilter Array is not in the correct format."},
        LoadingObjectNotSWFError: { code: 2098, message: "The loading object is not a .swf file, you cannot request SWF properties from it." },
        LoadingObjectNotInitializedError: { code: 2099, message: "The loading object is not sufficiently loaded to provide this information." },
        //  EmptyByteArrayError                                       : { code: 2100, message: "The ByteArray parameter in Loader.loadBytes() must have length greater than 0."},
        DecodeParamError: { code: 2101, message: "The String passed to URLVariables.decode() must be a URL-encoded query string containing name/value pairs." },
        //  NotAnXMLChildError                                        : { code: 2102, message: "The before XMLNode parameter must be a child of the caller."},
        //  XMLRecursionError                                         : { code: 2103, message: "XML recursion failure: new child would create infinite loop."},
        SceneNotFoundError: { code: 2108, message: "Scene %1 was not found." },
        FrameLabelNotFoundError: { code: 2109, message: "Frame label %1 not found in scene %2." },
        //  DisableAVM1LoadingError                                   : { code: 2110, message: "The value of Security.disableAVM1Loading cannot be set unless the caller can access the stage and is in an ActionScript 3.0 SWF file."},
        //  AVM1LoadingError                                          : { code: 2111, message: "Security.disableAVM1Loading is true so the current load of the ActionScript 1.0/2.0 SWF file has been blocked."},
        //  ApplicationDomainSecurityError                            : { code: 2112, message: "Provided parameter LoaderContext.ApplicationDomain is from a disallowed domain."},
        //  SecurityDomainSecurityError                               : { code: 2113, message: "Provided parameter LoaderContext.SecurityDomain is from a disallowed domain."},
        //  NonNullPointerError                                       : { code: 2114, message: "Parameter %1 must be null."},
        //  TrueParamError                                            : { code: 2115, message: "Parameter %1 must be false."},
        //  FalseParamError                                           : { code: 2116, message: "Parameter %1 must be true."},
        InvalidLoaderInfoMethodError: { code: 2118, message: "The LoaderInfo class does not implement this method." },
        //  LoaderInfoAppDomainSecurityError                          : { code: 2119, message: "Security sandbox violation: caller %1 cannot access LoaderInfo.applicationDomain owned by %2."},
        SecuritySwfNotAllowedError: { code: 2121, message: "Security sandbox violation: %1: %2 cannot access %3. This may be worked around by calling Security.allowDomain." },
        //  SecurityNonSwfIncompletePolicyFilesError                  : { code: 2122, message: "Security sandbox violation: %1: %2 cannot access %3. A policy file is required, but the checkPolicyFile flag was not set when this media was loaded."},
        //  SecurityNonSwfNotAllowedError                             : { code: 2123, message: "Security sandbox violation: %1: %2 cannot access %3. No policy files granted access."},
        UnknownFileTypeError: { code: 2124, message: "Loaded file is an unknown type." },
        //  SecurityCrossVMNotAllowedError                            : { code: 2125, message: "Security sandbox violation: %1 cannot use Runtime Shared Library %2 because crossing the boundary between ActionScript 3.0 and ActionScript 1.0/2.0 objects is not allowed."},
        //  NotConnectedError                                         : { code: 2126, message: "NetConnection object must be connected."},
        //  FileRefBadPostDataTypeError                               : { code: 2127, message: "FileReference POST data cannot be type ByteArray."},
        //  NetConnectionConnectError                                 : { code: 2129, message: "Connection to %1 failed."},
        //  SharedObjectFlushFailedError                              : { code: 2130, message: "Unable to flush SharedObject."},
        //  DefinitionNotFoundError                                   : { code: 2131, message: "Definition %1 cannot be found."},
        //  NetConnectionInvalidConnectFromNetStatusEventError        : { code: 2132, message: "NetConnection.connect cannot be called from a netStatus event handler."},
        //  CallbackNotRegisteredError                                : { code: 2133, message: "Callback %1 is not registered."},
        //  SharedObjectCreateError                                   : { code: 2134, message: "Cannot create SharedObject."},
        //  InvalidSWFError                                           : { code: 2136, message: "The SWF file %1 contains invalid data."},
        //  NavigationSecurityError                                   : { code: 2137, message: "Security sandbox violation: %1 cannot navigate window %2 within %3 (allowScriptAccess is %4). Attempted URL was %5."},
        //  NonParsableRichTextXMLError                               : { code: 2138, message: "Rich text XML could not be parsed."},
        //  SharedObjectConnectError                                  : { code: 2139, message: "SharedObject could not connect."},
        //  LocalSecurityLoadingError                                 : { code: 2140, message: "Security sandbox violation: %1 cannot load %2. Local-with-filesystem and local-with-networking SWF files cannot load each other."},
        //  MultiplePrintJobsError                                    : { code: 2141, message: "Only one PrintJob may be in use at a time."},
        //  LocalImportSecurityError                                  : { code: 2142, message: "Security sandbox violation: local SWF files cannot use the LoaderContext.sec property. %1 was attempting to load %2."},
        //  AccOverrideRole                                           : { code: 2143, message: "AccessibilityImplementation.get_accRole() must be overridden from its default."},
        //  AccOverrideState                                          : { code: 2144, message: "AccessibilityImplementation.get_accState() must be overridden from its default."},
        //  URLRequestHeaderInvalidLengthError                        : { code: 2145, message: "Cumulative length of requestHeaders must be less than 8192 characters."},
        //  AllowNetworkingSecurityError                              : { code: 2146, message: "Security sandbox violation: %1 cannot call %2 because the HTML/container parameter allowNetworking has the value %3."},
        //  ForbiddenProtocolError                                    : { code: 2147, message: "Forbidden protocol in URL %1."},
        //  RemoteToLocalSecurityError                                : { code: 2148, message: "SWF file %1 cannot access local resource %2. Only local-with-filesystem and trusted local SWF files may access local resources."},
        //  FsCommandSecurityError                                    : { code: 2149, message: "Security sandbox violation: %1 cannot make fscommand calls to %2 (allowScriptAccess is %3)."},
        CantAddParentError: { code: 2150, message: "An object cannot be added as a child to one of it's children (or children's children, etc.)." },
        //  FullScreenSecurityError                                   : { code: 2151, message: "You cannot enter full screen mode when the settings dialog is visible."},
        //  FullScreenNotAllowedError                                 : { code: 2152, message: "Full screen mode is not allowed."},
        //  URLRequestInvalidHeader                                   : { code: 2153, message: "The URLRequest.requestHeaders array must contain only non-NULL URLRequestHeader objects."},
        //  InvalidNetStreamObject                                    : { code: 2154, message: "The NetStream Object is invalid.  This may be due to a failed NetConnection."},
        //  InvalidFunctionName                                       : { code: 2155, message: "The ExternalInterface.call functionName parameter is invalid.  Only alphanumeric characters are supported."},
        //  ForbiddenPortForProtocolError                             : { code: 2156, message: "Port %1 may not be accessed using protocol %2. Calling SWF was %3."},
        //  NoAsfunctionErrror                                        : { code: 2157, message: "Rejecting URL %1 because the 'asfunction:' protocol may only be used for link targets, not for networking APIs."},
        //  InvalidNetConnectionObject                                : { code: 2158, message: "The NetConnection Object is invalid.  This may be due to a dropped NetConnection."},
        //  InvalidSharedObject                                       : { code: 2159, message: "The SharedObject Object is invalid."},
        //  InvalidTextLineError                                      : { code: 2160, message: "The TextLine is INVALID and cannot be used to access the current state of the TextBlock."},
        //  TextLayoutError                                           : { code: 2161, message: "An internal error occured while laying out the text."},
        //  FragmentOutputType                                        : { code: 2162, message: "The Shader output type is not compatible for this operation."},
        //  FragmentInputType                                         : { code: 2163, message: "The Shader input type %1 is not compatible for this operation."},
        //  FragmentInputMissing                                      : { code: 2164, message: "The Shader input %1 is missing or an unsupported type."},
        //  FragmentInputTooSmall                                     : { code: 2165, message: "The Shader input %1 does not have enough data."},
        //  FragmentInputNoDimension                                  : { code: 2166, message: "The Shader input %1 lacks valid dimensions."},
        //  FragmentNotEnoughInput                                    : { code: 2167, message: "The Shader does not have the required number of inputs for this operation."},
        //  StaticTextLineError                                       : { code: 2168, message: "Static text lines have no atoms and no reference to a text block."},
        //  SecurityQuestionableBrowserScriptingError                 : { code: 2169, message: "The method %1 may not be used for browser scripting.  The URL %2 requested by %3 is being ignored.  If you intend to call browser script, use navigateToURL instead."},
        //  HeaderSecurityError                                       : { code: 2170, message: "Security sandbox violation: %1 cannot send HTTP headers to %2."},
        //  FragmentMissing                                           : { code: 2171, message: "The Shader object contains no byte code to execute."},
        //  FragmentAlreadyRunning                                    : { code: 2172, message: "The ShaderJob is already running or finished."},
        //  FileReferenceBusyError                                    : { code: 2174, message: "Only one download, upload, load or save operation can be active at a time on each FileReference."},
        //  UnformattedElementError                                   : { code: 2175, message: "One or more elements of the content of the TextBlock has a null ElementFormat."},
        //  UserActionRequiredError                                   : { code: 2176, message: "Certain actions, such as those that display a pop-up window, may only be invoked upon user interaction, for example by a mouse click or button press."},
        //  FragmentInputTooLarge                                     : { code: 2177, message: "The Shader input %1 is too large."},
        //  ClipboardConstNotAllowed                                  : { code: 2178, message: "The Clipboard.generalClipboard object must be used instead of creating a new Clipboard."},
        //  ClipboardDisallowedRead                                   : { code: 2179, message: "The Clipboard.generalClipboard object may only be read while processing a flash.events.Event.PASTE event."},
        //  CantMoveAVM1ContentLoadedIntoAVM2                         : { code: 2180, message: "It is illegal to move AVM1 content (AS1 or AS2) to a different part of the displayList when it has been loaded into AVM2 (AS3) content."},
        //  InvalidTextLineMethodError                                : { code: 2181, message: "The TextLine class does not implement this property or method."},
        //  PerspectiveFieldOfViewValueInvalid                        : { code: 2182, message: "Invalid fieldOfView value.  The value must be greater than 0 and less than 180."},
        //  Invalid3DScale                                            : { code: 2183, message: "Scale values must not be zero."},
        //  LockedElementFormatError                                  : { code: 2184, message: "The ElementFormat object is locked and cannot be modified."},
        //  LockedFontDescriptionError                                : { code: 2185, message: "The FontDescription object is locked and cannot be modified."},
        //  PerspectiveFocalLengthInvalid                             : { code: 2186, message: "Invalid focalLength %1."},
        //  Matrix3DDecomposeTypeInvalid                              : { code: 2187, message: "Invalid orientation style %1.  Value must be one of 'Orientation3D.EULER_ANGLES', 'Orientation3D.AXIS_ANGLE', or 'Orientation3D.QUATERNION'."},
        //  MatrixNonInvertibleError                                  : { code: 2188, message: "Invalid raw matrix. Matrix must be invertible."},
        Matrix3DRefCannontBeShared: { code: 2189, message: "A Matrix3D can not be assigned to more than one DisplayObject." },
        //  ForceDownloadSecurityError                                : { code: 2190, message: "The attempted load of %1 failed as it had a Content-Disposition of attachment set."},
        //  ClipboardDisallowedWrite                                  : { code: 2191, message: "The Clipboard.generalClipboard object may only be written to as the result of user interaction, for example by a mouse click or button press."},
        //  MalformedUnicodeError                                     : { code: 2192, message: "An unpaired Unicode surrogate was encountered in the input."},
        //  SecurityContentAccessDeniedError                          : { code: 2193, message: "Security sandbox violation: %1: %2 cannot access %3."},
        //  LoaderParamError                                          : { code: 2194, message: "Parameter %1 cannot be a Loader."},
        //  LoaderAsyncError                                          : { code: 2195, message: "Error thrown as Loader called %1."},
        ObjectWithStringsParamError: { code: 2196, message: "Parameter %1 must be an Object with only String values." },
        //  SystemUpdaterPlayerNotSupportedError                      : { code: 2200, message: "The SystemUpdater class is not supported by this player."},
        //  SystemUpdaterOSNotSupportedError                          : { code: 2201, message: "The requested update type is not supported on this operating system."},
        //  SystemUpdaterBusy                                         : { code: 2202, message: "Only one SystemUpdater action is allowed at a time."},
        //  SystemUpdaterFailed                                       : { code: 2203, message: "The requested SystemUpdater action cannot be completed."},
        //  SystemUpdaterCannotCancel                                 : { code: 2204, message: "This operation cannot be canceled because it is waiting for user interaction."},
        //  SystemUpdaterUnknownTarget                                : { code: 2205, message: "Invalid update type %1."},
        //  SignedSWfLoadingError                                     : { code: 2500, message: "An error occurred decrypting the signed swf file. The swf will not be loaded."},
        //  NotScreenSharingError                                     : { code: 2501, message: "This property can only be accessed during screen sharing."},
        //  NotSharingMonitorError                                    : { code: 2502, message: "This property can only be accessed if sharing the entire screen."},
        //  FileBadPathName                                           : { code: 3000, message: "Illegal path name."},
        //  FileAccessDenied                                          : { code: 3001, message: "File or directory access denied."},
        //  FileExists                                                : { code: 3002, message: "File or directory exists."},
        //  FileDoesNotExist                                          : { code: 3003, message: "File or directory does not exist."},
        //  FileInsufficientSpace                                     : { code: 3004, message: "Insufficient file space."},
        //  FileSystemResources                                       : { code: 3005, message: "Insufficient system resources."},
        //  FileNotAFile                                              : { code: 3006, message: "Not a file."},
        //  FileNotADir                                               : { code: 3007, message: "Not a directory."},
        //  FileReadOnlyFileSys                                       : { code: 3008, message: "Read-only or write-protected media."},
        //  FileNotSameDevice                                         : { code: 3009, message: "Cannot move file or directory to a different device."},
        //  DirNotEmpty                                               : { code: 3010, message: "Directory is not empty."},
        //  FileDestinationExists                                     : { code: 3011, message: "Move or copy destination already exists."},
        //  FileCantDelete                                            : { code: 3012, message: "Cannot delete file or directory."},
        //  FileInUse                                                 : { code: 3013, message: "File or directory is in use."},
        //  FileCopyMoveAncestor                                      : { code: 3014, message: "Cannot copy or move a file or directory to overwrite a containing directory."},
        //  LoadBytesCodeExecutionSecurityError                       : { code: 3015, message: "Loader.loadBytes() is not permitted to load content with executable code."},
        //  FileApplicationNotFound                                   : { code: 3016, message: "No application was found that can open this file."},
        //  SQLConnectionCannotClose                                  : { code: 3100, message: "A SQLConnection cannot be closed while statements are still executing."},
        //  SQLConnectionAlreadyOpen                                  : { code: 3101, message: "Database connection is already open."},
        //  SQLConnectionInvalidName                                  : { code: 3102, message: "Name argument specified was invalid. It must not be null or empty."},
        //  SQLConnectionInTransaction                                : { code: 3103, message: "Operation cannot be performed while there is an open transaction on this connection."},
        //  SQLConnectionNotOpen                                      : { code: 3104, message: "A SQLConnection must be open to perform this operation."},
        //  SQLConnectionNoOpenTransaction                            : { code: 3105, message: "Operation is only allowed if a connection has an open transaction."},
        //  SQLStatementIsExecutingProperty                           : { code: 3106, message: "Property cannot be changed while SQLStatement.executing is true."},
        //  SQLStatementIvalidCall                                    : { code: 3107, message: "%1 may not be called unless SQLResult.complete is false."},
        //  SQLStatementInvalidText                                   : { code: 3108, message: "Operation is not permitted when the SQLStatement.text property is not set."},
        //  SQLStatementInvalidConnection                             : { code: 3109, message: "Operation is not permitted when the SQLStatement.sqlConnection property is not set."},
        //  SQLStatementIsExecutingCall                               : { code: 3110, message: "Operation cannot be performed while SQLStatement.executing is true."},
        //  SQLStatementInvalidSchemaType                             : { code: 3111, message: "An invalid schema type was specified."},
        //  SQLConnectionInvalidLockType                              : { code: 3112, message: "An invalid transaction lock type was specified."},
        //  SQLConnectionNotFileReference                             : { code: 3113, message: "Reference specified is not of type File."},
        //  SQLConnectionInvalidModeSpecified                         : { code: 3114, message: "An invalid open mode was specified."},
        //  SQLGeneralEngineError                                     : { code: 3115, message: "SQL Error."},
        //  SQLInternalEngineError                                    : { code: 3116, message: "An internal logic error occurred."},
        //  SQLPermissionError                                        : { code: 3117, message: "Access permission denied."},
        //  SQLOperationAbortedError                                  : { code: 3118, message: "Operation aborted."},
        //  SQLDatabaseLockedError                                    : { code: 3119, message: "Database file is currently locked."},
        //  SQLTableLockedError                                       : { code: 3120, message: "Table is locked."},
        //  SQLOutOfMemoryError                                       : { code: 3121, message: "Out of memory."},
        //  SQLDatabaseIsReadonlyError                                : { code: 3122, message: "Attempt to write a readonly database."},
        //  SQLDatabaseCorruptError                                   : { code: 3123, message: "Database disk image is malformed."},
        //  SQLDatabaseFullError                                      : { code: 3124, message: "Insertion failed because database is full."},
        //  SQLCannotOpenDatabaseError                                : { code: 3125, message: "Unable to open the database file."},
        //  SQLLockingProtocolError                                   : { code: 3126, message: "Database lock protocol error."},
        //  SQLDatabaseEmptyError                                     : { code: 3127, message: "Database is empty."},
        //  SQLDiskIOError                                            : { code: 3128, message: "Disk I/O error occurred."},
        //  SQLSchemaChangedError                                     : { code: 3129, message: "The database schema changed."},
        //  SQLTooMuchDataError                                       : { code: 3130, message: "Too much data for one row of a table."},
        //  SQLConstraintError                                        : { code: 3131, message: "Abort due to constraint violation."},
        //  SQLDataTypeMismatchError                                  : { code: 3132, message: "Data type mismatch."},
        //  SQLConcurrencyError                                       : { code: 3133, message: "An internal error occurred."},
        //  SQLNotSupportedOnOSError                                  : { code: 3134, message: "Feature not supported on this operating system."},
        //  SQLAuthorizationDeniedError                               : { code: 3135, message: "Authorization denied."},
        //  SQLAuxDatabaseFormatError                                 : { code: 3136, message: "Auxiliary database format error."},
        //  SQLBindingRangeError                                      : { code: 3137, message: "An index specified for a parameter was out of range."},
        //  SQLInvalidDatabaseFileError                               : { code: 3138, message: "File opened is not a database file."},
        //  SQLInvalidPageSizeError                                   : { code: 3139, message: "The page size specified was not valid for this operation."},
        //  SQLInvalidKeySizeError                                    : { code: 3140, message: "The encryption key size specified was not valid for this operation. Keys must be exactly 16 bytes in length"},
        //  SQLInvalidConfigurationError                              : { code: 3141, message: "The requested database configuration is not supported."},
        //  SQLCannotRekeyNonKeyedDatabase                            : { code: 3143, message: "Unencrypted databases may not be reencrypted."},
        //  NativeWindowClosedError                                   : { code: 3200, message: "Cannot perform operation on closed window."},
        //  PDFNoReaderInstalled                                      : { code: 3201, message: "Adobe Reader cannot be found."},
        //  PDFOldReaderInstalled                                     : { code: 3202, message: "Adobe Reader 8.1 or later cannot be found."},
        //  PDFOldDefaultText                                         : { code: 3203, message: "Default Adobe Reader must be version 8.1 or later."},
        //  PDFCannotLoadReader                                       : { code: 3204, message: "An error ocurred trying to load Adobe Reader."},
        //  ApplicationFeatureSecurityError                           : { code: 3205, message: "Only application-sandbox content can access this feature."},
        //  LoaderInfoDoorSecurityError                               : { code: 3206, message: "Caller %1 cannot set LoaderInfo property %2."},
        //  ApplicationNonFeatureSecurityError                        : { code: 3207, message: "Application-sandbox content cannot access this feature."},
        //  InvalidClipboardAccess                                    : { code: 3208, message: "Attempt to access invalid clipboard."},
        //  DeadClipboardAccess                                       : { code: 3209, message: "Attempt to access dead clipboard."},
        //  DeadJavaScriptObjectAccess                                : { code: 3210, message: "The application attempted to reference a JavaScript object in a HTML page that is no longer loaded."},
        //  FilePromiseIOError                                        : { code: 3211, message: "Drag and Drop File Promise error: %1"},
        //  NativeProcessNotRunning                                   : { code: 3212, message: "Cannot perform operation on a NativeProcess that is not running."},
        //  NativeProcessAlreadyRunning                               : { code: 3213, message: "Cannot perform operation on a NativeProcess that is already running."},
        //  NativeProcessBadExecutable                                : { code: 3214, message: "NativeProcessStartupInfo.executable does not specify a valid executable file."},
        //  NativeProcessBadWorkingDirectory                          : { code: 3215, message: "NativeProcessStartupInfo.workingDirectory does not specify a valid directory."},
        //  NativeProcessStdOutReadError                              : { code: 3216, message: "Error while reading data from NativeProcess.standardOutput."},
        //  NativeProcessStdErrReadError                              : { code: 3217, message: "Error while reading data from NativeProcess.standardError."},
        //  NativeProcessStdInWriteError                              : { code: 3218, message: "Error while writing data to NativeProcess.standardInput."},
        //  NativeProcessNotStarted                                   : { code: 3219, message: "The NativeProcess could not be started. '%1'"},
        //  ActionNotAllowedSecurityError                             : { code: 3220, message: "Action '%1' not allowed in current security context '%2'."},
        //  SWFNoPlayerInstalled                                      : { code: 3221, message: "Adobe Flash Player cannot be found."},
        //  SWFOldPlayerInstalled                                     : { code: 3222, message: "The installed version of Adobe Flash Player is too old."},
        //  DNSResolverLookupError                                    : { code: 3223, message: "DNS lookup error: platform error %1"},
        //  SocketMessageTooLongError                                 : { code: 3224, message: "Socket message too long"},
        //  SocketCannotSendDataToAddressAfterConnect                 : { code: 3225, message: "Cannot send data to a location when connected."},
        AllowCodeImportError: { code: 3226, message: "Cannot import a SWF file when LoaderContext.allowCodeImport is false." },
        //  BackgroundLaunchError                                     : { code: 3227, message: "Cannot launch another application from background."},
        //  StageWebViewLoadError                                     : { code: 3228, message: "StageWebView encountered an error during the load operation."},
        //  StageWebViewProtocolNotSupported                          : { code: 3229, message: "The protocol is not supported.:"},
        //  BrowseOperationUnsupported                                : { code: 3230, message: "The browse operation is unsupported."},
        //  InvalidVoucher                                            : { code: 3300, message: "Voucher is invalid."},
        //  AuthenticationFailed                                      : { code: 3301, message: "User authentication failed."},
        //  RequireSSLError                                           : { code: 3302, message: "Flash Access server does not support SSL."},
        //  ContentExpiredError                                       : { code: 3303, message: "Content expired."},
        //  AuthorizationFailed                                       : { code: 3304, message: "User authorization failed (for example, the user has not purchased the content)."},
        //  ServerConnectionFailed                                    : { code: 3305, message: "Can't connect to the server."},
        //  ClientUpdateRequired                                      : { code: 3306, message: "Client update required (Flash Access server requires new client)."},
        //  InternalError                                             : { code: 3307, message: "Generic internal Flash Access failure."},
        //  WrongVoucherKey                                           : { code: 3308, message: "Wrong voucher key."},
        //  CorruptedFLV                                              : { code: 3309, message: "Video content is corrupted."},
        //  AppIDMismatch                                             : { code: 3310, message: "The AIR application or Flash Player SWF does not match the one specified in the DRM policy."},
        //  AppVersionMismatch                                        : { code: 3311, message: "The version of the application does not match the one specified in the DRM policy."},
        //  VoucherIntegrityError                                     : { code: 3312, message: "Verification of voucher failed."},
        //  WriteFileSystemFailed                                     : { code: 3313, message: "Write to the file system failed."},
        //  FLVHeaderIntegrityFailed                                  : { code: 3314, message: "Verification of FLV/F4V header file failed."},
        PermissionDenied: { code: 3315, message: "The current security context does not allow this operation." },
        //  LocalConnectionUserScopedLocked                           : { code: 3316, message: "The value of LocalConnection.isPerUser cannot be changed because it has already been locked by a call to LocalConnection.connect, .send, or .close."},
        //  LoadAdobeCPFailed                                         : { code: 3317, message: "Failed to load Flash Access module."},
        //  IncompatibleAdobeCPVersion                                : { code: 3318, message: "Incompatible version of Flash Access module found."},
        //  MissingAdobeCPEntryPoint                                  : { code: 3319, message: "Missing Flash Access module API entry point."},
        //  InternalErrorHA                                           : { code: 3320, message: "Generic internal Flash Access failure."},
        //  IndividualizationFailed                                   : { code: 3321, message: "Individualization failed."},
        //  DeviceBindingFailed                                       : { code: 3322, message: "Device binding failed."},
        //  CorruptStore                                              : { code: 3323, message: "The internal stores are corrupted."},
        //  MachineTokenInvalid                                       : { code: 3324, message: "Reset license files and the client will fetch a new machine token."},
        //  CorruptServerStateStore                                   : { code: 3325, message: "Internal stores are corrupt."},
        //  TamperingDetected                                         : { code: 3326, message: "Call customer support."},
        //  ClockTamperingDetected                                    : { code: 3327, message: "Clock tampering detected."},
        //  ServerErrorTryAgain                                       : { code: 3328, message: "Server error; retry the request."},
        //  ApplicationSpecificError                                  : { code: 3329, message: "Error in application-specific namespace."},
        //  NeedAuthentication                                        : { code: 3330, message: "Need to authenticate the user and reacquire the voucher."},
        //  ContentNotYetValid                                        : { code: 3331, message: "Content is not yet valid."},
        //  CachedVoucherExpired                                      : { code: 3332, message: "Cached voucher has expired. Reacquire the voucher from the server."},
        //  PlaybackWindowExpired                                     : { code: 3333, message: "The playback window for this policy has expired."},
        //  InvalidDRMPlatform                                        : { code: 3334, message: "This platform is not allowed to play this content."},
        //  InvalidDRMVersion                                         : { code: 3335, message: "Invalid version of Flash Access module. Upgrade AIR or Flash Access module for the Flash Player."},
        //  InvalidRuntimePlatform                                    : { code: 3336, message: "This platform is not allowed to play this content."},
        //  InvalidRuntimeVersion                                     : { code: 3337, message: "Upgrade Flash Player or AIR  and retry playback."},
        //  UnknownConnectionType                                     : { code: 3338, message: "Unknown connection type."},
        //  NoAnalogPlaybackAllowed                                   : { code: 3339, message: "Can't play back on analog device. Connect to a digital device."},
        //  NoAnalogProtectionAvail                                   : { code: 3340, message: "Can't play back because connected analog device doesn't have the correct capabilities."},
        //  NoDigitalPlaybackAllowed                                  : { code: 3341, message: "Can't play back on digital device."},
        //  NoDigitalProtectionAvail                                  : { code: 3342, message: "The connected digital device doesn't have the correct capabilities."},
        InternalErrorIV: { code: 3343, message: "Internal Error." }
        //  MissingAdobeCPModule                                      : { code: 3344, message: "Missing Flash Access module."},
        //  DRMNoAccessError                                          : { code: 3345, message: "This operation is not permitted with content protected using Flash Access."},
        //  DRMDataMigrationFailed                                    : { code: 3346, message: "Failed migrating local DRM data, all locally cached DRM vouchers are lost."},
        //  DRMInsufficientDeviceCapabilites                          : { code: 3347, message: "The device does not meet the Flash Access server's playback device constraints."},
        //  DRMHardStopIntervalExpired                                : { code: 3348, message: "This protected content is expired."},
        //  DRMServerVersionTooHigh                                   : { code: 3349, message: "The Flash Access server is running at a version that's higher than the max supported by this runtime."},
        //  DRMServerVersionTooLow                                    : { code: 3350, message: "The Flash Access server is running at a version that's lower than the min supported by this runtime."},
        //  DRMDeviceGroupTokenInvalid                                : { code: 3351, message: "Device Group registration token is corrupted, please refresh the token by registering again to the DRMDeviceGroup."},
        //  DRMDeviceGroupTokenTooOld                                 : { code: 3352, message: "The server is using a newer version of the registration token for this Device Group. Please refresh the token by registering again to the DRMDeviceGroup."},
        //  DRMDeviceGroupTokenTooNew                                 : { code: 3353, message: "the server is using an older version of the registration token for this Device Group."},
        //  DRMDeviceGroupTokenExpired                                : { code: 3354, message: "Device Group registration is expired, please refresh the token by registering again to the DRMDeviceGroup."},
        //  JoinDRMDeviceGroupFailed                                  : { code: 3355, message: "The server denied this Device Group registration request."},
        //  DRMVoucherHasNoCorrespondingRoot                          : { code: 3356, message: "The root voucher for this content's DRMVoucher was not found."},
        //  NoValidEmbeddedDRMVoucher                                 : { code: 3357, message: "The DRMContentData provides no valid embedded voucher and no Flash Access server url to acquire the voucher from."},
        //  NoACPProtectionAvailable                                  : { code: 3358, message: "ACP protection is not available on the device but required to playback the content."},
        //  NoCGMSAProtectionAvailable                                : { code: 3359, message: "CGMSA protection is not available on the device but required to playback the content."},
        //  DRMDeviceGroupRegistrationRequired                        : { code: 3360, message: "Device Group registration is required before doing this operation."},
        //  DeviceIsNotRegisteredToDRMDeviceGroup                     : { code: 3361, message: "The device is not registered to this Device Group."},
        //  ScriptBridgeError                                         : { code: 3400, message: "An error occured while executing JavaScript code."},
        //  ScriptBridgeNameAccessSecurityError                       : { code: 3401, message: "Security sandbox violation: An object with this name has already been registered from another security domain."},
        //  ScriptBridgeBrowserAccessSecurityError                    : { code: 3402, message: "Security sandbox violation: Bridge caller %1 cannot access %2."},
        //  ExtensionContextNoSuchMethod                              : { code: 3500, message: "The extension context does not have a method with the name %1."},
        //  ExtensionContextAlreadyDisposed                           : { code: 3501, message: "The extension context has already been disposed."},
        //  ExtensionContextInvalidReturnValue                        : { code: 3502, message: "The extension returned an invalid value."},
        //  ExtensionContextInvalidState                              : { code: 3503, message: "The extension was left in an invalid state."},
        //  NoValidProgramSet                                         : { code: 3600, message: "No valid program set."},
        //  NoValidIndexBufferSet                                     : { code: 3601, message: "No valid index buffer set."},
        //  SanityCheckOnParametersFailed                             : { code: 3602, message: "Sanity check on parameters failed, %1 triangles and %2 index offset."},
        //  NotEnoughIndicesInThisBuffer                              : { code: 3603, message: "Not enough indices in this buffer. %1 triangles at offset %2, but there are only %3 indices in buffer."},
        //  SampleBindsTextureAlsoBoundToRender                       : { code: 3604, message: "Sampler %1 binds a texture that is also bound for render to texture."},
        //  SampleBindsInvalidTexture                                 : { code: 3605, message: "Sampler %1 binds an invalid texture."},
        //  SamplerFormatDoesNotMatchTextureFormat                    : { code: 3606, message: "Sampler %1 format does not match texture format."},
        //  StreamIsNotUsed                                           : { code: 3607, message: "Stream %1 is set but not used by the current vertex program."},
        //  StreamIsInvalid                                           : { code: 3608, message: "Stream %1 is invalid."},
        //  StreamDoesNotHaveEnoughVertices                           : { code: 3609, message: "Stream %1 does not have enough vertices."},
        //  StreamVertexOffsetOutOfBounds                             : { code: 3610, message: "Stream %1 vertex offset is out of bounds"},
        //  StreamReadButNotSet                                       : { code: 3611, message: "Stream %1 is read by the current vertex program but not set."},
        //  ProgramMustBeLittleEndian                                 : { code: 3612, message: "Programs must be in little endian format."},
        //  NativeShaderCompilationFailed                             : { code: 3613, message: "The native shader compilation failed."},
        //  NativeShaderCompilationFailedOpenGL                       : { code: 3614, message: "The native shader compilation failed.enGL specific: %1"},
        //  AgalProgramTooSmall                                       : { code: 3615, message: "AGAL validation failed: Program size below minimum length for %1 program."},
        //  NotAnAgalProgram                                          : { code: 3616, message: "AGAL validation failed: Not an AGAL program. Wrong magic byte for %1 program."},
        //  BadAgalVersion                                            : { code: 3617, message: "AGAL validation failed: Bad AGAL version for %1 program. Current version is %2."},
        //  BadAgalProgramType                                        : { code: 3618, message: "AGAL validation failed: Bad AGAL program type identifier for %1 program."},
        //  BadAgalShadertype                                         : { code: 3619, message: "AGAL validation failed: Shader type must be either fragment or vertex for %1 program."},
        //  InvalidAgalOpcodeOutOfRange                               : { code: 3620, message: "AGAL validation failed: Invalid opcode, value out of range: %2 at token %3 of %1 program."},
        //  InvalidAgalOpcodeNotImplemented                           : { code: 3621, message: "AGAL validation failed: Invalid opcode, %2 is not implemented in this version at token %3 of %1 program."},
        //  AgalOpcodeOnlyAllowedInFragmentProgram                    : { code: 3622, message: "AGAL validation failed: Opcode %2 only allowed in fragment programs at token %3 of %1 program."},
        //  OpenConditionNesting                                      : { code: 3623, message: "AGAL validation failed: Open condition nesting (close without open) at token %2 of %1 program."},
        //  ConditionNestingTooDeep                                   : { code: 3624, message: "AGAL validation failed: Condition nesting (%2) too deep at token %3 of %1 program."},
        //  BadAgalSourceOperands                                     : { code: 3625, message: "AGAL validation failed: Bad AGAL source operands. Both are constants (this must be precomputed) at token %2 of %1 program."},
        //  BothOperandsAreIndirectReads                              : { code: 3626, message: "AGAL validation failed: Opcode %2, both operands are indirect reads at token %3 of %1 program."},
        //  OpcodeDestinationMustBeAllZero                            : { code: 3627, message: "AGAL validation failed: Opcode %2 destination operand must be all zero at token %3 of %1 program."},
        //  OpcodeDestinationMustUseMask                              : { code: 3628, message: "AGAL validation failed: The destination operand for the %2 instruction must mask w (use .xyz or less) at token %3 of %1 program."},
        //  TooManyTokens                                             : { code: 3629, message: "AGAL validation failed: Too many tokens (%2) for %1 program."},
        //  FragmentShaderType                                        : { code: 3630, message: "Fragment shader type is not fragment."},
        //  VertexShaderType                                          : { code: 3631, message: "Vertex shader type is not vertex."},
        //  VaryingReadButNotWrittenTo                                : { code: 3632, message: "AGAL linkage: Varying %1 is read in the fragment shader but not written to by the vertex shader."},
        //  VaryingPartialWrite                                       : { code: 3633, message: "AGAL linkage: Varying %1 is only partially written to. Must write all four components."},
        //  FragmentWriteAllComponents                                : { code: 3634, message: "AGAL linkage: Fragment output needs to write to all components."},
        //  VertexWriteAllComponents                                  : { code: 3635, message: "AGAL linkage: Vertex output needs to write to all components."},
        //  UnusedOperand                                             : { code: 3636, message: "AGAL validation failed: Unused operand is not set to zero for %2 at token %3 of %1 program."},
        //  SamplerRegisterOnlyInFragment                             : { code: 3637, message: "AGAL validation failed: Sampler registers only allowed in fragment programs for %2 at token %3 of %1 program."},
        //  SamplerRegisterSecondOperand                              : { code: 3638, message: "AGAL validation failed: Sampler register only allowed as second operand in texture instructions for %2 at token %3 of %1 program."},
        //  IndirectOnlyAllowedInVertex                               : { code: 3639, message: "AGAL validation failed: Indirect addressing only allowed in vertex programs for %2 at token %3 of %1 program."},
        //  IndirectOnlyIntoConstantRegisters                         : { code: 3640, message: "AGAL validation failed: Indirect addressing only allowed into constant registers for %2 at token %3 of %1 program."},
        //  IndirectNotAllowed                                        : { code: 3641, message: "AGAL validation failed: Indirect addressing not allowed for this operand in this instruction for %2 at token %3 of %1 program."},
        //  IndirectSourceType                                        : { code: 3642, message: "AGAL validation failed: Indirect source type must be attribute, constant or temporary for %2 at token %3 of %1 program."},
        //  IndirectAddressingFieldsMustBeZero                        : { code: 3643, message: "AGAL validation failed: Indirect addressing fields must be zero for direct adressing for %2 at token %3 of %1 program."},
        //  VaryingRegistersOnlyReadInFragment                        : { code: 3644, message: "AGAL validation failed: Varying registers can only be read in fragment programs for %2 at token %3 of %1 program."},
        //  AttributeRegistersOnlyReadInVertex                        : { code: 3645, message: "AGAL validation failed: Attribute registers can only be read in vertex programs for %2 at token %3 of %1 program."},
        //  CanNotReadOutputRegister                                  : { code: 3646, message: "AGAL validation failed: Can not read from output register for %2 at token %3 of %1 program."},
        //  TempRegisterReadWithoutWrite                              : { code: 3647, message: "AGAL validation failed: Temporary register read without being written to for %2 at token %3 of %1 program."},
        //  TempRegisterComponentReadWithoutWrite                     : { code: 3648, message: "AGAL validation failed: Temporary register component read without being written to for %2 at token %3 of %1 program."},
        //  SamplerRegisterCannotBeWrittenTo                          : { code: 3649, message: "AGAL validation failed: Sampler registers can not be written to for %2 at token %3 of %1 program."},
        //  VaryingRegistersWrite                                     : { code: 3650, message: "AGAL validation failed: Varying registers can only be written in vertex programs for %2 at token %3 of %1 program."},
        //  AttributeRegisterCannotBeWrittenTo                        : { code: 3651, message: "AGAL validation failed: Attribute registers can not be written to for %2 at token %3 of %1 program."},
        //  ConstantRegisterCannotBeWrittenTo                         : { code: 3652, message: "AGAL validation failed: Constant registers can not be written to for %2 at token %3 of %1 program."},
        //  DestinationWritemaskIsZero                                : { code: 3653, message: "AGAL validation failed: Destination writemask is zero for %2 at token %3 of %1 program."},
        //  AGALReservedBitsShouldBeZero                              : { code: 3654, message: "AGAL validation failed: Reserve bits should be zero for %2 at token %3 of %1 program."},
        //  UnknownRegisterType                                       : { code: 3655, message: "AGAL validation failed: Unknown register type for %2 at token %3 of %1 program."},
        //  SamplerRegisterOutOfBounds                                : { code: 3656, message: "AGAL validation failed: Sampler register index out of bounds for %2 at token %3 of %1 program."},
        //  VaryingRegisterOutOfBounds                                : { code: 3657, message: "AGAL validation failed: Varying register index out of bounds for %2 at token %3 of %1 program."},
        //  AttributeRegisterOutOfBounds                              : { code: 3658, message: "AGAL validation failed: Attribute register index out of bounds for %2 at token %3 of %1 program."},
        //  ConstantRegisterOutOfBounds                               : { code: 3659, message: "AGAL validation failed: Constant register index out of bounds for %2 at token %3 of %1 program."},
        //  OutputRegisterOutOfBounds                                 : { code: 3660, message: "AGAL validation failed: Output register index out of bounds for %2 at token %3 of %1 program."},
        //  TemporaryRegisterOutOfBounds                              : { code: 3661, message: "AGAL validation failed: Temporary register index out of bounds for %2 at token %3 of %1 program."},
        //  CubeMapSamplerMustUseClamp                                : { code: 3662, message: "AGAL validation failed: Cube map samplers must set wrapping to clamp mode for %2 at token %3 of %1 program."},
        //  SampleBindsUndefinedTexture                               : { code: 3663, message: "Sampler %1 binds an undefined texture."},
        //  UnknownSamplerDimension                                   : { code: 3664, message: "AGAL validation failed: Unknown sampler dimension %4 for %2 at token %3 of %1 program."},
        //  UnknownFilterMode                                         : { code: 3665, message: "AGAL validation failed: Unknown filter mode in sampler: %4 for %2 at token %3 of %1 program."},
        //  UnknownMipmapMode                                         : { code: 3666, message: "AGAL validation failed: Unknown mipmap mode in sampler: %4 for %2 at token %3 of %1 program."},
        //  UnknownWrappingMode                                       : { code: 3667, message: "AGAL validation failed: Unknown wrapping mode in sampler: %4 for %2 at token %3 of %1 program."},
        //  UnknownSpecialFlag                                        : { code: 3668, message: "AGAL validation failed: Unknown special flag used in sampler: %4 for %2 at token %3 of %1 program."},
        //  BadInputSize                                              : { code: 3669, message: "Bad input size."},
        //  BufferTooBig                                              : { code: 3670, message: "Buffer too big."},
        //  BufferHasZeroSize                                         : { code: 3671, message: "Buffer has zero size."},
        //  BufferCreationFailed                                      : { code: 3672, message: "Buffer creation failed. Internal error."},
        //  InvalidCubeSide                                           : { code: 3673, message: "Cube side must be [0..5]."},
        //  MiplevelTooLarge                                          : { code: 3674, message: "Miplevel too large."},
        //  TextureFormatMismatch                                     : { code: 3675, message: "Texture format mismatch."},
        //  PlatformDoesNotSupportTextureFormat                       : { code: 3676, message: "Platform does not support desired texture format."},
        //  TextureDecodingFailed                                     : { code: 3677, message: "Texture decoding failed. Internal error."},
        //  TextureNeedsToBeSquare                                    : { code: 3678, message: "Texture needs to be square."},
        //  TextureSizeDoesNotMatch                                   : { code: 3679, message: "Texture size does not match."},
        //  DepthTextureNotImplemented                                : { code: 3680, message: "Depth texture not implemented yet."},
        //  TextureSizeIsZero                                         : { code: 3681, message: "Texture size is zero."},
        //  TextureNotPowerOfTwo                                      : { code: 3682, message: "Texture size not a power of two."},
        //  TextureTooBig                                             : { code: 3683, message: "Texture too big (max is 2048x2048)."},
        //  TextureCreationFailed                                     : { code: 3684, message: "Texture creation failed. Internal error."},
        //  CouldNotCreateRenderer                                    : { code: 3685, message: "Could not create renderer."},
        //  DisabledFormatNeedsNullVertexBuffer                       : { code: 3686, message: "'disabled' format only valid with a null vertex buffer."},
        //  NullVertexBufferNeedsDisabledFormat                       : { code: 3687, message: "Null vertex buffers require the 'disabled' format."},
        //  NeedListenerToRequestContext                              : { code: 3688, message: "You must add an event listener for the context3DCreate event before requesting a new Context3D."},
        //  CantSwizzle2ndSource                                      : { code: 3689, message: "You can not swizzle second operand for %2 at token %3 of %1 program."},
        //  TooManyDrawCalls                                          : { code: 3690, message: "Too many draw calls before calling present."},
        //  ResourceLimitExceeded                                     : { code: 3691, message: "Resource limit for this resource type exceeded."},
        //  NeedToClearBeforeDraw                                     : { code: 3692, message: "All buffers need to be cleared every frame before drawing."},
        //  SecondOperandMustBeSamplerRegister                        : { code: 3693, message: "AGAL validation failed: Sampler register must be used for second operand in texture instructions for %2 at token %3 of %1 program."},
        //  ObjectDisposed                                            : { code: 3694, message: "The object was disposed by an earlier call of dispose() on it."},
        //  SameTextureNeedsSameSamplerParams                         : { code: 3695, message: "A texture can only be bound to multiple samplers if the samplers also have the exact same properties. Mismatch at samplers %1 and %2."},
        //  SecondUseOfSamplerMustHaveSameParams                      : { code: 3696, message: "AGAL validation failed: Second use of sampler register needs to specify the exact same properties. At token %3 of %1 program."},
        //  TextureBoundButNotUsed                                    : { code: 3697, message: "A texture is bound on sampler %1 but not used by the fragment program."},
        //  BackBufferNotConfigured                                   : { code: 3698, message: "The back buffer is not configured."},
        //  OperationFailed                                           : { code: 3699, message: "Requested Operation failed to complete"},
        //  TextureMipchainIsNotComplete                              : { code: 3700, message: "A texture sampler binds an incomplete texture. Make sure to upload(). All miplevels are required when mipmapping is enabled."},
        //  OutputColorNotMaskable                                    : { code: 3701, message: "The output color register can not use a write mask. All components must be written."},
        //  Context3DNotAvailable                                     : { code: 3702, message: "Context3D not available."},
        //  SwizzleMustBeScalar                                       : { code: 3703, message: "AGAL validation failed: Source swizzle must be scalar (one of: xxxx, yyyy, zzzz, wwww) for %2 at token %3 of %1 program."},
        //  CubeMapSamplerMustUseMipmap                               : { code: 3704, message: "AGAL validation failed: Cube map samplers must enable mipmapping for %2 at token %3 of %1 program."}
    };

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var InflateState;
    (function (InflateState) {
        InflateState[InflateState["INIT"] = 0] = "INIT";
        InflateState[InflateState["BLOCK_0"] = 1] = "BLOCK_0";
        InflateState[InflateState["BLOCK_1"] = 2] = "BLOCK_1";
        InflateState[InflateState["BLOCK_2_PRE"] = 3] = "BLOCK_2_PRE";
        InflateState[InflateState["BLOCK_2"] = 4] = "BLOCK_2";
        InflateState[InflateState["DONE"] = 5] = "DONE";
        InflateState[InflateState["ERROR"] = 6] = "ERROR";
        InflateState[InflateState["VERIFY_HEADER"] = 7] = "VERIFY_HEADER";
    })(InflateState || (InflateState = {}));
    var WINDOW_SIZE = 32768;
    var WINDOW_SHIFT_POSITION = 65536;
    var MAX_WINDOW_SIZE = WINDOW_SHIFT_POSITION + 258; /* plus max copy len */
    var Inflate = /** @class */ (function () {
        function Inflate(verifyHeader) {
            //
        }
        Inflate.prototype.push = function (data) {
            //Debug.abstractMethod('Inflate.push');
        };
        Inflate.prototype.close = function () {
            //
        };
        Inflate.create = function (verifyHeader) {
            /* if (typeof ShumwayCom !== 'undefined' && ShumwayCom.createSpecialInflate) {
               return new SpecialInflateAdapter(verifyHeader, ShumwayCom.createSpecialInflate);
             }*/
            return new BasicInflate(verifyHeader);
        };
        Inflate.prototype._processZLibHeader = function (buffer, start, end) {
            /* returns -1 - bad header, 0 - not enough data, 1+ - number of bytes processed */
            var ZLIB_HEADER_SIZE = 2;
            if (start + ZLIB_HEADER_SIZE > end) {
                return 0;
            }
            var header = (buffer[start] << 8) | buffer[start + 1];
            var error = null;
            if ((header & 0x0f00) !== 0x0800) {
                error = 'inflate: unknown compression method';
            }
            else if ((header % 31) !== 0) {
                error = 'inflate: bad FCHECK';
            }
            else if ((header & 0x20) !== 0) {
                error = 'inflate: FDICT bit set';
            }
            if (error) {
                if (this.onError) {
                    this.onError(error);
                }
                return -1;
            }
            else {
                return ZLIB_HEADER_SIZE;
            }
        };
        Inflate.inflate = function (data, expectedLength, zlibHeader) {
            var output = new Uint8Array(expectedLength);
            var position = 0;
            var inflate = Inflate.create(zlibHeader);
            inflate.onData = function (data) {
                // Make sure we don't cause an exception here when trying to set out-of-bound data by clamping the number of
                // bytes to write to the remaining space in our output buffer. The Flash Player ignores data that goes over the
                // expected length, so should we.
                var length = Math.min(data.length, output.length - position);
                if (length) {
                    memCopy(output, data, position, 0, length);
                }
                position += length;
            };
            inflate.onError = function (error) {
                throw new Error(error);
            };
            inflate.push(data);
            inflate.close();
            return output;
        };
        return Inflate;
    }());
    var BasicInflate = /** @class */ (function (_super) {
        __extends$5(BasicInflate, _super);
        function BasicInflate(verifyHeader) {
            var _this = _super.call(this, verifyHeader) || this;
            _this._buffer = null;
            _this._bufferSize = 0;
            _this._bufferPosition = 0;
            _this._bitBuffer = 0;
            _this._bitLength = 0;
            _this._window = new Uint8Array(MAX_WINDOW_SIZE);
            _this._windowPosition = 0;
            _this._state = verifyHeader ? InflateState.VERIFY_HEADER : InflateState.INIT;
            _this._isFinalBlock = false;
            _this._literalTable = null;
            _this._distanceTable = null;
            _this._block0Read = 0;
            _this._block2State = null;
            _this._copyState = {
                state: 0,
                len: 0,
                lenBits: 0,
                dist: 0,
                distBits: 0
            };
            if (!areTablesInitialized) {
                initializeTables();
                areTablesInitialized = true;
            }
            return _this;
        }
        BasicInflate.prototype.push = function (data) {
            if (!this._buffer || this._buffer.length < this._bufferSize + data.length) {
                var newBuffer = new Uint8Array(this._bufferSize + data.length);
                if (this._buffer) {
                    newBuffer.set(this._buffer);
                }
                this._buffer = newBuffer;
            }
            this._buffer.set(data, this._bufferSize);
            this._bufferSize += data.length;
            this._bufferPosition = 0;
            var incomplete = false;
            do {
                var lastPosition = this._windowPosition;
                if (this._state === InflateState.INIT) {
                    incomplete = this._decodeInitState();
                    if (incomplete) {
                        break;
                    }
                }
                switch (this._state) {
                    case InflateState.BLOCK_0:
                        incomplete = this._decodeBlock0();
                        break;
                    case InflateState.BLOCK_2_PRE:
                        incomplete = this._decodeBlock2Pre();
                        if (incomplete) {
                            break;
                        }
                    /* fall through */
                    case InflateState.BLOCK_1:
                    case InflateState.BLOCK_2:
                        incomplete = this._decodeBlock();
                        break;
                    case InflateState.ERROR:
                    case InflateState.DONE:
                        // skipping all data
                        this._bufferPosition = this._bufferSize;
                        break;
                    case InflateState.VERIFY_HEADER:
                        var processed = this._processZLibHeader(this._buffer, this._bufferPosition, this._bufferSize);
                        if (processed > 0) {
                            this._bufferPosition += processed;
                            this._state = InflateState.INIT;
                        }
                        else if (processed === 0) {
                            incomplete = true;
                        }
                        else {
                            this._state = InflateState.ERROR;
                        }
                        break;
                }
                var decoded = this._windowPosition - lastPosition;
                if (decoded > 0) {
                    this.onData(this._window.subarray(lastPosition, this._windowPosition));
                }
                if (this._windowPosition >= WINDOW_SHIFT_POSITION) {
                    // shift window
                    if ('copyWithin' in this._buffer) {
                        this._window['copyWithin'](0, this._windowPosition - WINDOW_SIZE, this._windowPosition);
                    }
                    else {
                        this._window.set(this._window.subarray(this._windowPosition - WINDOW_SIZE, this._windowPosition));
                    }
                    this._windowPosition = WINDOW_SIZE;
                }
            } while (!incomplete && this._bufferPosition < this._bufferSize);
            if (this._bufferPosition < this._bufferSize) {
                // shift buffer
                if ('copyWithin' in this._buffer) {
                    this._buffer['copyWithin'](0, this._bufferPosition, this._bufferSize);
                }
                else {
                    this._buffer.set(this._buffer.subarray(this._bufferPosition, this._bufferSize));
                }
                this._bufferSize -= this._bufferPosition;
            }
            else {
                this._bufferSize = 0;
            }
        };
        BasicInflate.prototype._decodeInitState = function () {
            if (this._isFinalBlock) {
                this._state = InflateState.DONE;
                return false;
            }
            var buffer = this._buffer, bufferSize = this._bufferSize;
            var bitBuffer = this._bitBuffer, bitLength = this._bitLength;
            var state;
            var position = this._bufferPosition;
            if (((bufferSize - position) << 3) + bitLength < 3) {
                return true;
            }
            if (bitLength < 3) {
                bitBuffer |= buffer[position++] << bitLength;
                bitLength += 8;
            }
            var type = bitBuffer & 7;
            bitBuffer >>= 3;
            bitLength -= 3;
            switch (type >> 1) {
                case 0:
                    bitBuffer = 0;
                    bitLength = 0;
                    if (bufferSize - position < 4) {
                        return true;
                    }
                    var length = buffer[position] | (buffer[position + 1] << 8);
                    var length2 = buffer[position + 2] | (buffer[position + 3] << 8);
                    position += 4;
                    if ((length ^ length2) !== 0xFFFF) {
                        this._error('inflate: invalid block 0 length');
                        state = InflateState.ERROR;
                        break;
                    }
                    if (length === 0) {
                        state = InflateState.INIT;
                    }
                    else {
                        this._block0Read = length;
                        state = InflateState.BLOCK_0;
                    }
                    break;
                case 1:
                    state = InflateState.BLOCK_1;
                    this._literalTable = fixedLiteralTable;
                    this._distanceTable = fixedDistanceTable;
                    break;
                case 2:
                    if (((bufferSize - position) << 3) + bitLength < 14 + 3 * 4) {
                        return true;
                    }
                    while (bitLength < 14) {
                        bitBuffer |= buffer[position++] << bitLength;
                        bitLength += 8;
                    }
                    var numLengthCodes = ((bitBuffer >> 10) & 15) + 4;
                    if (((bufferSize - position) << 3) + bitLength < 14 + 3 * numLengthCodes) {
                        return true;
                    }
                    var block2State = {
                        numLiteralCodes: (bitBuffer & 31) + 257,
                        numDistanceCodes: ((bitBuffer >> 5) & 31) + 1,
                        codeLengthTable: undefined,
                        bitLengths: undefined,
                        codesRead: 0,
                        dupBits: 0
                    };
                    bitBuffer >>= 14;
                    bitLength -= 14;
                    var codeLengths = new Uint8Array(19);
                    for (var i = 0; i < numLengthCodes; ++i) {
                        if (bitLength < 3) {
                            bitBuffer |= buffer[position++] << bitLength;
                            bitLength += 8;
                        }
                        codeLengths[codeLengthOrder[i]] = bitBuffer & 7;
                        bitBuffer >>= 3;
                        bitLength -= 3;
                    }
                    for (; i < 19; i++) {
                        codeLengths[codeLengthOrder[i]] = 0;
                    }
                    block2State.bitLengths =
                        new Uint8Array(block2State.numLiteralCodes + block2State.numDistanceCodes);
                    block2State.codeLengthTable = makeHuffmanTable(codeLengths);
                    this._block2State = block2State;
                    state = InflateState.BLOCK_2_PRE;
                    break;
                default:
                    this._error('inflate: unsupported block type');
                    state = InflateState.ERROR;
                    return false;
            }
            this._isFinalBlock = !!(type & 1);
            this._state = state;
            this._bufferPosition = position;
            this._bitBuffer = bitBuffer;
            this._bitLength = bitLength;
            return false;
        };
        BasicInflate.prototype._error = function (e) {
            if (this.onError) {
                this.onError(e);
            }
        };
        BasicInflate.prototype._decodeBlock0 = function () {
            var position = this._bufferPosition;
            var windowPosition = this._windowPosition;
            var toRead = this._block0Read;
            var leftInWindow = MAX_WINDOW_SIZE - windowPosition;
            var leftInBuffer = this._bufferSize - position;
            var incomplete = leftInBuffer < toRead;
            var canFit = Math.min(leftInWindow, leftInBuffer, toRead);
            this._window.set(this._buffer.subarray(position, position + canFit), windowPosition);
            this._windowPosition = windowPosition + canFit;
            this._bufferPosition = position + canFit;
            this._block0Read = toRead - canFit;
            if (toRead === canFit) {
                this._state = InflateState.INIT;
                return false;
            }
            return incomplete && leftInWindow < leftInBuffer;
        };
        BasicInflate.prototype._readBits = function (size) {
            var bitBuffer = this._bitBuffer;
            var bitLength = this._bitLength;
            if (size > bitLength) {
                var pos = this._bufferPosition;
                var end = this._bufferSize;
                do {
                    if (pos >= end) {
                        this._bufferPosition = pos;
                        this._bitBuffer = bitBuffer;
                        this._bitLength = bitLength;
                        return -1;
                    }
                    bitBuffer |= this._buffer[pos++] << bitLength;
                    bitLength += 8;
                } while (size > bitLength);
                this._bufferPosition = pos;
            }
            this._bitBuffer = bitBuffer >> size;
            this._bitLength = bitLength - size;
            return bitBuffer & ((1 << size) - 1);
        };
        BasicInflate.prototype._readCode = function (codeTable) {
            var bitBuffer = this._bitBuffer;
            var bitLength = this._bitLength;
            var maxBits = codeTable.maxBits;
            if (maxBits > bitLength) {
                var pos = this._bufferPosition;
                var end = this._bufferSize;
                do {
                    if (pos >= end) {
                        this._bufferPosition = pos;
                        this._bitBuffer = bitBuffer;
                        this._bitLength = bitLength;
                        return -1;
                    }
                    bitBuffer |= this._buffer[pos++] << bitLength;
                    bitLength += 8;
                } while (maxBits > bitLength);
                this._bufferPosition = pos;
            }
            var code = codeTable.codes[bitBuffer & ((1 << maxBits) - 1)];
            var len = code >> 16;
            if ((code & 0x8000)) {
                this._error('inflate: invalid encoding');
                this._state = InflateState.ERROR;
                return -1;
            }
            this._bitBuffer = bitBuffer >> len;
            this._bitLength = bitLength - len;
            return code & 0xffff;
        };
        BasicInflate.prototype._decodeBlock2Pre = function () {
            var block2State = this._block2State;
            var numCodes = block2State.numLiteralCodes + block2State.numDistanceCodes;
            var bitLengths = block2State.bitLengths;
            var i = block2State.codesRead;
            var prev = i > 0 ? bitLengths[i - 1] : 0;
            var codeLengthTable = block2State.codeLengthTable;
            var j;
            if (block2State.dupBits > 0) {
                j = this._readBits(block2State.dupBits);
                if (j < 0) {
                    return true;
                }
                while (j--) {
                    bitLengths[i++] = prev;
                }
                block2State.dupBits = 0;
            }
            while (i < numCodes) {
                var sym = this._readCode(codeLengthTable);
                if (sym < 0) {
                    block2State.codesRead = i;
                    return true;
                }
                else if (sym < 16) {
                    bitLengths[i++] = (prev = sym);
                    continue;
                }
                var j, dupBits;
                switch (sym) {
                    case 16:
                        dupBits = 2;
                        j = 3;
                        sym = prev;
                        break;
                    case 17:
                        dupBits = 3;
                        j = 3;
                        sym = 0;
                        break;
                    case 18:
                        dupBits = 7;
                        j = 11;
                        sym = 0;
                        break;
                }
                while (j--) {
                    bitLengths[i++] = sym;
                }
                j = this._readBits(dupBits);
                if (j < 0) {
                    block2State.codesRead = i;
                    block2State.dupBits = dupBits;
                    return true;
                }
                while (j--) {
                    bitLengths[i++] = sym;
                }
                prev = sym;
            }
            this._literalTable = makeHuffmanTable(bitLengths.subarray(0, block2State.numLiteralCodes));
            this._distanceTable = makeHuffmanTable(bitLengths.subarray(block2State.numLiteralCodes));
            this._state = InflateState.BLOCK_2;
            this._block2State = null;
            return false;
        };
        BasicInflate.prototype._decodeBlock = function () {
            var literalTable = this._literalTable, distanceTable = this._distanceTable;
            var output = this._window, pos = this._windowPosition;
            var copyState = this._copyState;
            var i, j, sym;
            var len, lenBits, dist, distBits;
            if (copyState.state !== 0) {
                // continuing len/distance operation
                switch (copyState.state) {
                    case 1:
                        j = 0;
                        if ((j = this._readBits(copyState.lenBits)) < 0) {
                            return true;
                        }
                        copyState.len += j;
                        copyState.state = 2;
                    /* fall through */
                    case 2:
                        if ((sym = this._readCode(distanceTable)) < 0) {
                            return true;
                        }
                        copyState.distBits = distanceExtraBits[sym];
                        copyState.dist = distanceCodes[sym];
                        copyState.state = 3;
                    /* fall through */
                    case 3:
                        j = 0;
                        if (copyState.distBits > 0 && (j = this._readBits(copyState.distBits)) < 0) {
                            return true;
                        }
                        dist = copyState.dist + j;
                        len = copyState.len;
                        i = pos - dist;
                        while (len--) {
                            output[pos++] = output[i++];
                        }
                        copyState.state = 0;
                        if (pos >= WINDOW_SHIFT_POSITION) {
                            this._windowPosition = pos;
                            return false;
                        }
                        break;
                }
            }
            do {
                sym = this._readCode(literalTable);
                if (sym < 0) {
                    this._windowPosition = pos;
                    return true;
                }
                else if (sym < 256) {
                    output[pos++] = sym;
                }
                else if (sym > 256) {
                    this._windowPosition = pos;
                    sym -= 257;
                    lenBits = lengthExtraBits[sym];
                    len = lengthCodes[sym];
                    j = lenBits === 0 ? 0 : this._readBits(lenBits);
                    if (j < 0) {
                        copyState.state = 1;
                        copyState.len = len;
                        copyState.lenBits = lenBits;
                        return true;
                    }
                    len += j;
                    sym = this._readCode(distanceTable);
                    if (sym < 0) {
                        copyState.state = 2;
                        copyState.len = len;
                        return true;
                    }
                    distBits = distanceExtraBits[sym];
                    dist = distanceCodes[sym];
                    j = distBits === 0 ? 0 : this._readBits(distBits);
                    if (j < 0) {
                        copyState.state = 3;
                        copyState.len = len;
                        copyState.dist = dist;
                        copyState.distBits = distBits;
                        return true;
                    }
                    dist += j;
                    i = pos - dist;
                    while (len--) {
                        output[pos++] = output[i++];
                    }
                }
                else {
                    this._state = InflateState.INIT;
                    break; // end of block
                }
            } while (pos < WINDOW_SHIFT_POSITION);
            this._windowPosition = pos;
            return false;
        };
        return BasicInflate;
    }(Inflate));
    var codeLengthOrder;
    var distanceCodes;
    var distanceExtraBits;
    var fixedDistanceTable;
    var lengthCodes;
    var lengthExtraBits;
    var fixedLiteralTable;
    var areTablesInitialized = false;
    function initializeTables() {
        codeLengthOrder = new Uint8Array([16, 17, 18, 0, 8, 7, 9, 6, 10, 5, 11, 4, 12, 3, 13, 2, 14, 1, 15]);
        distanceCodes = new Uint16Array(30);
        distanceExtraBits = new Uint8Array(30);
        for (var i = 0, j = 0, code = 1; i < 30; ++i) {
            distanceCodes[i] = code;
            code += 1 << (distanceExtraBits[i] = ~~((j += (i > 2 ? 1 : 0)) / 2));
        }
        var bitLengths = new Uint8Array(288);
        for (var i = 0; i < 32; ++i) {
            bitLengths[i] = 5;
        }
        fixedDistanceTable = makeHuffmanTable(bitLengths.subarray(0, 32));
        lengthCodes = new Uint16Array(29);
        lengthExtraBits = new Uint8Array(29);
        for (var i = 0, j = 0, code = 3; i < 29; ++i) {
            lengthCodes[i] = code - (i == 28 ? 1 : 0);
            code += 1 << (lengthExtraBits[i] = ~~(((j += (i > 4 ? 1 : 0)) / 4) % 6));
        }
        for (var i = 0; i < 288; ++i) {
            bitLengths[i] = i < 144 || i > 279 ? 8 : (i < 256 ? 9 : 7);
        }
        fixedLiteralTable = makeHuffmanTable(bitLengths);
    }
    function makeHuffmanTable(bitLengths) {
        var maxBits = Math.max.apply(null, bitLengths);
        var numLengths = bitLengths.length;
        var size = 1 << maxBits;
        var codes = new Uint32Array(size);
        // avoiding len == 0: using max number of bits
        var dummyCode = (maxBits << 16) | 0xFFFF;
        for (var j = 0; j < size; j++) {
            codes[j] = dummyCode;
        }
        for (var code = 0, len = 1, skip = 2; len <= maxBits; code <<= 1, ++len, skip <<= 1) {
            for (var val = 0; val < numLengths; ++val) {
                if (bitLengths[val] === len) {
                    var lsb = 0;
                    for (var i = 0; i < len; ++i)
                        lsb = (lsb * 2) + ((code >> i) & 1);
                    for (var i = lsb; i < size; i += skip)
                        codes[i] = (len << 16) | val;
                    ++code;
                }
            }
        }
        return { codes: codes, maxBits: maxBits };
    }
    var SpecialInflateAdapter = /** @class */ (function (_super) {
        __extends$5(SpecialInflateAdapter, _super);
        function SpecialInflateAdapter(verifyHeader, createSpecialInflate) {
            var _this = _super.call(this, verifyHeader) || this;
            _this._verifyHeader = verifyHeader;
            _this._specialInflate = createSpecialInflate();
            _this._specialInflate.setDataCallback(function (data) {
                this.onData(data);
            }.bind(_this));
            return _this;
        }
        SpecialInflateAdapter.prototype.push = function (data) {
            if (this._verifyHeader) {
                var buffer;
                if (this._buffer) {
                    buffer = new Uint8Array(this._buffer.length + data.length);
                    buffer.set(this._buffer);
                    buffer.set(data, this._buffer.length);
                    this._buffer = null;
                }
                else {
                    buffer = new Uint8Array(data);
                }
                var processed = this._processZLibHeader(buffer, 0, buffer.length);
                if (processed === 0) {
                    this._buffer = buffer;
                    return;
                }
                this._verifyHeader = true;
                if (processed > 0) {
                    data = buffer.subarray(processed);
                }
            }
            this._specialInflate.push(data);
        };
        SpecialInflateAdapter.prototype.close = function () {
            if (this._specialInflate) {
                this._specialInflate.close();
                this._specialInflate = null;
            }
        };
        return SpecialInflateAdapter;
    }(Inflate));
    var DeflateState;
    (function (DeflateState) {
        DeflateState[DeflateState["WRITE"] = 0] = "WRITE";
        DeflateState[DeflateState["DONE"] = 1] = "DONE";
        DeflateState[DeflateState["ZLIB_HEADER"] = 2] = "ZLIB_HEADER";
    })(DeflateState || (DeflateState = {}));
    var Adler32 = /** @class */ (function () {
        function Adler32() {
            this.a = 1;
            this.b = 0;
        }
        Adler32.prototype.update = function (data, start, end) {
            var a = this.a;
            var b = this.b;
            for (var i = start; i < end; ++i) {
                a = (a + (data[i] & 0xff)) % 65521;
                b = (b + a) % 65521;
            }
            this.a = a;
            this.b = b;
        };
        Adler32.prototype.getChecksum = function () {
            return (this.b << 16) | this.a;
        };
        return Adler32;
    }());
    var Deflate = /** @class */ (function () {
        function Deflate(writeZlibHeader) {
            this._writeZlibHeader = writeZlibHeader;
            this._state = writeZlibHeader ? DeflateState.ZLIB_HEADER : DeflateState.WRITE;
            this._adler32 = writeZlibHeader ? new Adler32() : null;
        }
        Deflate.prototype.push = function (data) {
            if (this._state === DeflateState.ZLIB_HEADER) {
                this.onData(new Uint8Array([0x78, 0x9C]));
                this._state = DeflateState.WRITE;
            }
            // simple non-compressing algorithm for now
            var len = data.length;
            var outputSize = len + Math.ceil(len / 0xFFFF) * 5;
            var output = new Uint8Array(outputSize);
            var outputPos = 0;
            var pos = 0;
            while (len > 0xFFFF) {
                output.set(new Uint8Array([
                    0x00,
                    0xFF, 0xFF,
                    0x00, 0x00
                ]), outputPos);
                outputPos += 5;
                output.set(data.subarray(pos, pos + 0xFFFF), outputPos);
                pos += 0xFFFF;
                outputPos += 0xFFFF;
                len -= 0xFFFF;
            }
            output.set(new Uint8Array([
                0x00,
                (len & 0xff), ((len >> 8) & 0xff),
                ((~len) & 0xff), (((~len) >> 8) & 0xff)
            ]), outputPos);
            outputPos += 5;
            output.set(data.subarray(pos, len), outputPos);
            this.onData(output);
            if (this._adler32) {
                this._adler32.update(data, 0, len);
            }
        };
        Deflate.prototype.close = function () {
            this._state = DeflateState.DONE;
            this.onData(new Uint8Array([
                0x01,
                0x00, 0x00,
                0xFF, 0xFF
            ]));
            if (this._adler32) {
                var checksum = this._adler32.getChecksum();
                this.onData(new Uint8Array([
                    checksum & 0xff, (checksum >> 8) & 0xff,
                    (checksum >> 16) & 0xff, (checksum >>> 24) & 0xff
                ]));
            }
        };
        return Deflate;
    }());

    /*
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var InputStream = /** @class */ (function () {
        function InputStream() {
            this.available = 0;
            this.pos = 0;
            this.buffer = new Uint8Array(2000);
        }
        InputStream.prototype.append = function (data) {
            var length = this.pos + this.available;
            var needLength = length + data.length;
            if (needLength > this.buffer.length) {
                var newLength = this.buffer.length * 2;
                while (newLength < needLength) {
                    newLength *= 2;
                }
                var newBuffer = new Uint8Array(newLength);
                newBuffer.set(this.buffer);
                this.buffer = newBuffer;
            }
            this.buffer.set(data, length);
            this.available += data.length;
        };
        InputStream.prototype.compact = function () {
            if (this.available === 0) {
                return;
            }
            this.buffer.set(this.buffer.subarray(this.pos, this.pos + this.available), 0);
            this.pos = 0;
        };
        InputStream.prototype.readByte = function () {
            if (this.available <= 0) {
                throw new Error("Unexpected end of file");
            }
            this.available--;
            return this.buffer[this.pos++];
        };
        return InputStream;
    }());
    var OutputStream = /** @class */ (function () {
        function OutputStream(onData) {
            this.onData = onData;
            this.processed = 0;
        }
        OutputStream.prototype.writeBytes = function (data) {
            this.onData.call(null, data);
            this.processed += data.length;
        };
        return OutputStream;
    }());
    var OutWindow = /** @class */ (function () {
        function OutWindow(outStream) {
            this.outStream = outStream;
            this.buf = null;
            this.pos = 0;
            this.size = 0;
            this.isFull = false;
            this.writePos = 0;
            this.totalPos = 0;
        }
        OutWindow.prototype.create = function (dictSize) {
            this.buf = new Uint8Array(dictSize);
            this.pos = 0;
            this.size = dictSize;
            this.isFull = false;
            this.writePos = 0;
            this.totalPos = 0;
        };
        OutWindow.prototype.putByte = function (b) {
            this.totalPos++;
            this.buf[this.pos++] = b;
            if (this.pos === this.size) {
                this.flush();
                this.pos = 0;
                this.isFull = true;
            }
        };
        OutWindow.prototype.getByte = function (dist) {
            return this.buf[dist <= this.pos ? this.pos - dist : this.size - dist + this.pos];
        };
        OutWindow.prototype.flush = function () {
            if (this.writePos < this.pos) {
                this.outStream.writeBytes(this.buf.subarray(this.writePos, this.pos));
                this.writePos = this.pos === this.size ? 0 : this.pos;
            }
        };
        OutWindow.prototype.copyMatch = function (dist, len) {
            var pos = this.pos;
            var size = this.size;
            var buffer = this.buf;
            var getPos = dist <= pos ? pos - dist : size - dist + pos;
            var left = len;
            while (left > 0) {
                var chunk = Math.min(Math.min(left, size - pos), size - getPos);
                for (var i = 0; i < chunk; i++) {
                    var b = buffer[getPos++];
                    buffer[pos++] = b;
                }
                if (pos === size) {
                    this.pos = pos;
                    this.flush();
                    pos = 0;
                    this.isFull = true;
                }
                if (getPos === size) {
                    getPos = 0;
                }
                left -= chunk;
            }
            this.pos = pos;
            this.totalPos += len;
        };
        OutWindow.prototype.checkDistance = function (dist) {
            return dist <= this.pos || this.isFull;
        };
        OutWindow.prototype.isEmpty = function () {
            return this.pos === 0 && !this.isFull;
        };
        return OutWindow;
    }());
    var kNumBitModelTotalBits = 11;
    var kNumMoveBits = 5;
    var PROB_INIT_VAL = ((1 << kNumBitModelTotalBits) >> 1);
    function createProbsArray(length) {
        var p = new Uint16Array(length);
        for (var i = 0; i < length; i++) {
            p[i] = PROB_INIT_VAL;
        }
        return p;
    }
    var kTopValue = 1 << 24;
    var RangeDecoder = /** @class */ (function () {
        function RangeDecoder(inStream) {
            this.inStream = inStream;
            this.range = 0;
            this.code = 0;
            this.corrupted = false;
        }
        RangeDecoder.prototype.init = function () {
            if (this.inStream.readByte() !== 0) {
                this.corrupted = true;
            }
            this.range = 0xFFFFFFFF | 0;
            var code = 0;
            for (var i = 0; i < 4; i++) {
                code = (code << 8) | this.inStream.readByte();
            }
            if (code === this.range) {
                this.corrupted = true;
            }
            this.code = code;
        };
        RangeDecoder.prototype.isFinishedOK = function () {
            return this.code === 0;
        };
        RangeDecoder.prototype.decodeDirectBits = function (numBits) {
            var res = 0;
            var range = this.range;
            var code = this.code;
            do {
                range = (range >>> 1) | 0;
                code = (code - range) | 0;
                var t = code >> 31; // if high bit set -1, otherwise 0
                code = (code + (range & t)) | 0;
                if (code === range) {
                    this.corrupted = true;
                }
                if (range >= 0 && range < kTopValue) {
                    range = range << 8;
                    code = (code << 8) | this.inStream.readByte();
                }
                res = ((res << 1) + t + 1) | 0;
            } while (--numBits);
            this.range = range;
            this.code = code;
            return res;
        };
        RangeDecoder.prototype.decodeBit = function (prob, index) {
            var range = this.range;
            var code = this.code;
            var v = prob[index];
            var bound = (range >>> kNumBitModelTotalBits) * v; // keep unsigned
            var symbol;
            if ((code >>> 0) < bound) {
                v = (v + (((1 << kNumBitModelTotalBits) - v) >> kNumMoveBits)) | 0;
                range = bound | 0;
                symbol = 0;
            }
            else {
                v = (v - (v >> kNumMoveBits)) | 0;
                code = (code - bound) | 0;
                range = (range - bound) | 0;
                symbol = 1;
            }
            prob[index] = v & 0xFFFF;
            if (range >= 0 && range < kTopValue) {
                range = range << 8;
                code = (code << 8) | this.inStream.readByte();
            }
            this.range = range;
            this.code = code;
            return symbol;
        };
        return RangeDecoder;
    }());
    function bitTreeReverseDecode(probs, offset, numBits, rc) {
        var m = 1;
        var symbol = 0;
        for (var i = 0; i < numBits; i++) {
            var bit = rc.decodeBit(probs, m + offset);
            m = (m << 1) + bit;
            symbol |= bit << i;
        }
        return symbol;
    }
    var BitTreeDecoder = /** @class */ (function () {
        function BitTreeDecoder(numBits) {
            this.numBits = numBits;
            this.probs = createProbsArray(1 << numBits);
        }
        BitTreeDecoder.prototype.decode = function (rc) {
            var m = 1;
            for (var i = 0; i < this.numBits; i++) {
                m = (m << 1) + rc.decodeBit(this.probs, m);
            }
            return m - (1 << this.numBits);
        };
        BitTreeDecoder.prototype.reverseDecode = function (rc) {
            return bitTreeReverseDecode(this.probs, 0, this.numBits, rc);
        };
        return BitTreeDecoder;
    }());
    function createBitTreeDecoderArray(numBits, length) {
        var p = [];
        p.length = length;
        for (var i = 0; i < length; i++) {
            p[i] = new BitTreeDecoder(numBits);
        }
        return p;
    }
    var kNumPosBitsMax = 4;
    var kNumStates = 12;
    var kNumLenToPosStates = 4;
    var kNumAlignBits = 4;
    var kEndPosModelIndex = 14;
    var kNumFullDistances = 1 << (kEndPosModelIndex >> 1);
    var kMatchMinLen = 2;
    var LenDecoder = /** @class */ (function () {
        function LenDecoder() {
            this.choice = createProbsArray(2);
            this.lowCoder = createBitTreeDecoderArray(3, 1 << kNumPosBitsMax);
            this.midCoder = createBitTreeDecoderArray(3, 1 << kNumPosBitsMax);
            this.highCoder = new BitTreeDecoder(8);
        }
        LenDecoder.prototype.decode = function (rc, posState) {
            if (rc.decodeBit(this.choice, 0) === 0) {
                return this.lowCoder[posState].decode(rc);
            }
            if (rc.decodeBit(this.choice, 1) === 0) {
                return 8 + this.midCoder[posState].decode(rc);
            }
            return 16 + this.highCoder.decode(rc);
        };
        return LenDecoder;
    }());
    function updateState_Literal(state) {
        if (state < 4) {
            return 0;
        }
        else if (state < 10) {
            return state - 3;
        }
        else {
            return state - 6;
        }
    }
    function updateState_Match(state) {
        return state < 7 ? 7 : 10;
    }
    function updateState_Rep(state) {
        return state < 7 ? 8 : 11;
    }
    function updateState_ShortRep(state) {
        return state < 7 ? 9 : 11;
    }
    var LZMA_DIC_MIN = 1 << 12;
    var MAX_DECODE_BITS_CALLS = 48;
    var LzmaDecoderInternal = /** @class */ (function () {
        function LzmaDecoderInternal(inStream, outStream) {
            this.rangeDec = new RangeDecoder(inStream);
            this.outWindow = new OutWindow(outStream);
            this.markerIsMandatory = false;
            this.lc = 0;
            this.pb = 0;
            this.lp = 0;
            this.dictSize = 0;
            this.dictSizeInProperties = 0;
            this.unpackSize = undefined;
            this.leftToUnpack = undefined;
            this.reps = new Int32Array(4);
            this.state = 0;
        }
        LzmaDecoderInternal.prototype.decodeProperties = function (properties) {
            var d = properties[0];
            if (d >= (9 * 5 * 5)) {
                throw new Error("Incorrect LZMA properties");
            }
            this.lc = d % 9;
            d = (d / 9) | 0;
            this.pb = (d / 5) | 0;
            this.lp = d % 5;
            this.dictSizeInProperties = 0;
            for (var i = 0; i < 4; i++) {
                this.dictSizeInProperties |= properties[i + 1] << (8 * i);
            }
            this.dictSize = this.dictSizeInProperties;
            if (this.dictSize < LZMA_DIC_MIN) {
                this.dictSize = LZMA_DIC_MIN;
            }
        };
        LzmaDecoderInternal.prototype.create = function () {
            this.outWindow.create(this.dictSize);
            this.init();
            this.rangeDec.init();
            this.reps[0] = 0;
            this.reps[1] = 0;
            this.reps[2] = 0;
            this.reps[3] = 0;
            this.state = 0;
            this.leftToUnpack = this.unpackSize;
        };
        LzmaDecoderInternal.prototype.decodeLiteral = function (state, rep0) {
            var outWindow = this.outWindow;
            var rangeDec = this.rangeDec;
            var prevByte = 0;
            if (!outWindow.isEmpty()) {
                prevByte = outWindow.getByte(1);
            }
            var symbol = 1;
            var litState = ((outWindow.totalPos & ((1 << this.lp) - 1)) << this.lc) + (prevByte >> (8 - this.lc));
            var probsIndex = 0x300 * litState;
            if (state >= 7) {
                var matchByte = outWindow.getByte(rep0 + 1);
                do {
                    var matchBit = (matchByte >> 7) & 1;
                    matchByte <<= 1;
                    var bit = rangeDec.decodeBit(this.litProbs, probsIndex + (((1 + matchBit) << 8) + symbol));
                    symbol = (symbol << 1) | bit;
                    if (matchBit !== bit) {
                        break;
                    }
                } while (symbol < 0x100);
            }
            while (symbol < 0x100) {
                symbol =
                    (symbol << 1) | rangeDec.decodeBit(this.litProbs, probsIndex + symbol);
            }
            return (symbol - 0x100) & 0xFF;
        };
        LzmaDecoderInternal.prototype.decodeDistance = function (len) {
            var lenState = len;
            if (lenState > kNumLenToPosStates - 1) {
                lenState = kNumLenToPosStates - 1;
            }
            var rangeDec = this.rangeDec;
            var posSlot = this.posSlotDecoder[lenState].decode(rangeDec);
            if (posSlot < 4) {
                return posSlot;
            }
            var numDirectBits = (posSlot >> 1) - 1;
            var dist = (2 | (posSlot & 1)) << numDirectBits;
            if (posSlot < kEndPosModelIndex) {
                dist =
                    (dist + bitTreeReverseDecode(this.posDecoders, dist - posSlot, numDirectBits, rangeDec)) | 0;
            }
            else {
                dist =
                    (dist + (rangeDec.decodeDirectBits(numDirectBits - kNumAlignBits) << kNumAlignBits)) | 0;
                dist = (dist + this.alignDecoder.reverseDecode(rangeDec)) | 0;
            }
            return dist;
        };
        LzmaDecoderInternal.prototype.init = function () {
            this.litProbs = createProbsArray(0x300 << (this.lc + this.lp));
            this.posSlotDecoder = createBitTreeDecoderArray(6, kNumLenToPosStates);
            this.alignDecoder = new BitTreeDecoder(kNumAlignBits);
            this.posDecoders =
                createProbsArray(1 + kNumFullDistances - kEndPosModelIndex);
            this.isMatch = createProbsArray(kNumStates << kNumPosBitsMax);
            this.isRep = createProbsArray(kNumStates);
            this.isRepG0 = createProbsArray(kNumStates);
            this.isRepG1 = createProbsArray(kNumStates);
            this.isRepG2 = createProbsArray(kNumStates);
            this.isRep0Long = createProbsArray(kNumStates << kNumPosBitsMax);
            this.lenDecoder = new LenDecoder();
            this.repLenDecoder = new LenDecoder();
        };
        LzmaDecoderInternal.prototype.decode = function (notFinal) {
            var rangeDec = this.rangeDec;
            var outWindow = this.outWindow;
            var pb = this.pb;
            var dictSize = this.dictSize;
            var markerIsMandatory = this.markerIsMandatory;
            var leftToUnpack = this.leftToUnpack;
            var isMatch = this.isMatch;
            var isRep = this.isRep;
            var isRepG0 = this.isRepG0;
            var isRepG1 = this.isRepG1;
            var isRepG2 = this.isRepG2;
            var isRep0Long = this.isRep0Long;
            var lenDecoder = this.lenDecoder;
            var repLenDecoder = this.repLenDecoder;
            var rep0 = this.reps[0];
            var rep1 = this.reps[1];
            var rep2 = this.reps[2];
            var rep3 = this.reps[3];
            var state = this.state;
            while (true) {
                // Based on worse case scenario one byte consumed per decodeBit calls,
                // reserving keeping some amount of bytes in the input stream for
                // non-final data blocks.
                if (notFinal && rangeDec.inStream.available < MAX_DECODE_BITS_CALLS) {
                    this.outWindow.flush();
                    break;
                }
                if (leftToUnpack === 0 && !markerIsMandatory) {
                    this.outWindow.flush();
                    if (rangeDec.isFinishedOK()) {
                        return LZMA_RES_FINISHED_WITHOUT_MARKER;
                    }
                }
                var posState = outWindow.totalPos & ((1 << pb) - 1);
                if (rangeDec.decodeBit(isMatch, (state << kNumPosBitsMax) + posState) === 0) {
                    if (leftToUnpack === 0) {
                        return LZMA_RES_ERROR;
                    }
                    outWindow.putByte(this.decodeLiteral(state, rep0));
                    state = updateState_Literal(state);
                    leftToUnpack--;
                    continue;
                }
                var len;
                if (rangeDec.decodeBit(isRep, state) !== 0) {
                    if (leftToUnpack === 0) {
                        return LZMA_RES_ERROR;
                    }
                    if (outWindow.isEmpty()) {
                        return LZMA_RES_ERROR;
                    }
                    if (rangeDec.decodeBit(isRepG0, state) === 0) {
                        if (rangeDec.decodeBit(isRep0Long, (state << kNumPosBitsMax) + posState) === 0) {
                            state = updateState_ShortRep(state);
                            outWindow.putByte(outWindow.getByte(rep0 + 1));
                            leftToUnpack--;
                            continue;
                        }
                    }
                    else {
                        var dist;
                        if (rangeDec.decodeBit(isRepG1, state) === 0) {
                            dist = rep1;
                        }
                        else {
                            if (rangeDec.decodeBit(isRepG2, state) === 0) {
                                dist = rep2;
                            }
                            else {
                                dist = rep3;
                                rep3 = rep2;
                            }
                            rep2 = rep1;
                        }
                        rep1 = rep0;
                        rep0 = dist;
                    }
                    len = repLenDecoder.decode(rangeDec, posState);
                    state = updateState_Rep(state);
                }
                else {
                    rep3 = rep2;
                    rep2 = rep1;
                    rep1 = rep0;
                    len = lenDecoder.decode(rangeDec, posState);
                    state = updateState_Match(state);
                    rep0 = this.decodeDistance(len);
                    if (rep0 === -1) {
                        this.outWindow.flush();
                        return rangeDec.isFinishedOK() ?
                            LZMA_RES_FINISHED_WITH_MARKER :
                            LZMA_RES_ERROR;
                    }
                    if (leftToUnpack === 0) {
                        return LZMA_RES_ERROR;
                    }
                    if (rep0 >= dictSize || !outWindow.checkDistance(rep0)) {
                        return LZMA_RES_ERROR;
                    }
                }
                len += kMatchMinLen;
                var isError = false;
                if (leftToUnpack !== undefined && leftToUnpack < len) {
                    len = leftToUnpack;
                    isError = true;
                }
                outWindow.copyMatch(rep0 + 1, len);
                leftToUnpack -= len;
                if (isError) {
                    return LZMA_RES_ERROR;
                }
            }
            this.state = state;
            this.reps[0] = rep0;
            this.reps[1] = rep1;
            this.reps[2] = rep2;
            this.reps[3] = rep3;
            this.leftToUnpack = leftToUnpack;
            return LZMA_RES_NOT_COMPLETE;
        };
        LzmaDecoderInternal.prototype.flushOutput = function () {
            this.outWindow.flush();
        };
        return LzmaDecoderInternal;
    }());
    var LZMA_RES_ERROR = 0;
    var LZMA_RES_FINISHED_WITH_MARKER = 1;
    var LZMA_RES_FINISHED_WITHOUT_MARKER = 2;
    var LZMA_RES_NOT_COMPLETE = 3;
    var SWF_LZMA_HEADER_LENGTH = 17;
    var STANDARD_LZMA_HEADER_LENGTH = 13;
    var EXTRA_LZMA_BYTES_NEEDED = 5;
    var LzmaDecoderState;
    (function (LzmaDecoderState) {
        LzmaDecoderState[LzmaDecoderState["WAIT_FOR_LZMA_HEADER"] = 0] = "WAIT_FOR_LZMA_HEADER";
        LzmaDecoderState[LzmaDecoderState["WAIT_FOR_SWF_HEADER"] = 1] = "WAIT_FOR_SWF_HEADER";
        LzmaDecoderState[LzmaDecoderState["PROCESS_DATA"] = 2] = "PROCESS_DATA";
        LzmaDecoderState[LzmaDecoderState["CLOSED"] = 3] = "CLOSED";
        LzmaDecoderState[LzmaDecoderState["ERROR"] = 4] = "ERROR";
    })(LzmaDecoderState || (LzmaDecoderState = {}));
    var LzmaDecoder = /** @class */ (function () {
        function LzmaDecoder(swfHeader) {
            if (swfHeader === void 0) { swfHeader = false; }
            this._state = swfHeader ? LzmaDecoderState.WAIT_FOR_SWF_HEADER :
                LzmaDecoderState.WAIT_FOR_LZMA_HEADER;
            this.buffer = null;
        }
        LzmaDecoder.prototype.push = function (data) {
            if (this._state < LzmaDecoderState.PROCESS_DATA) {
                var buffered = this.buffer ? this.buffer.length : 0;
                var headerBytesExpected = (this._state === LzmaDecoderState.WAIT_FOR_SWF_HEADER ?
                    SWF_LZMA_HEADER_LENGTH : STANDARD_LZMA_HEADER_LENGTH) +
                    EXTRA_LZMA_BYTES_NEEDED;
                if (buffered + data.length < headerBytesExpected) {
                    var newBuffer = new Uint8Array(buffered + data.length);
                    if (buffered > 0) {
                        newBuffer.set(this.buffer);
                    }
                    newBuffer.set(data, buffered);
                    this.buffer = newBuffer;
                    return;
                }
                var header = new Uint8Array(headerBytesExpected);
                if (buffered > 0) {
                    header.set(this.buffer);
                }
                header.set(data.subarray(0, headerBytesExpected - buffered), buffered);
                this._inStream = new InputStream();
                this._inStream.append(header.subarray(headerBytesExpected - EXTRA_LZMA_BYTES_NEEDED));
                this._outStream = new OutputStream(function (data) {
                    this.onData.call(null, data);
                }.bind(this));
                this._decoder = new LzmaDecoderInternal(this._inStream, this._outStream);
                // See http://helpx.adobe.com/flash-player/kb/exception-thrown-you-decompress-lzma-compressed.html
                if (this._state === LzmaDecoderState.WAIT_FOR_SWF_HEADER) {
                    this._decoder.decodeProperties(header.subarray(12, 17));
                    this._decoder.markerIsMandatory = false;
                    this._decoder.unpackSize = ((header[4] | (header[5] << 8) |
                        (header[6] << 16) | (header[7] << 24)) >>> 0) - 8;
                }
                else {
                    this._decoder.decodeProperties(header.subarray(0, 5));
                    var unpackSize = 0;
                    var unpackSizeDefined = false;
                    for (var i = 0; i < 8; i++) {
                        var b = header[5 + i];
                        if (b !== 0xFF) {
                            unpackSizeDefined = true;
                        }
                        unpackSize |= b << (8 * i);
                    }
                    this._decoder.markerIsMandatory = !unpackSizeDefined;
                    this._decoder.unpackSize = unpackSizeDefined ? unpackSize : undefined;
                }
                this._decoder.create();
                data = data.subarray(headerBytesExpected);
                this._state = LzmaDecoderState.PROCESS_DATA;
            }
            else if (this._state !== LzmaDecoderState.PROCESS_DATA) {
                return;
            }
            try {
                this._inStream.append(data);
                var res = this._decoder.decode(true);
                this._inStream.compact();
                if (res !== LZMA_RES_NOT_COMPLETE) {
                    this._checkError(res);
                }
            }
            catch (e) {
                this._decoder.flushOutput();
                this._decoder = null;
                this._error(e);
            }
        };
        LzmaDecoder.prototype.close = function () {
            if (this._state !== LzmaDecoderState.PROCESS_DATA) {
                return;
            }
            this._state = LzmaDecoderState.CLOSED;
            try {
                var res = this._decoder.decode(false);
                this._checkError(res);
            }
            catch (e) {
                this._decoder.flushOutput();
                this._error(e);
            }
            this._decoder = null;
        };
        LzmaDecoder.prototype._error = function (error) {
            // Stopping processing any data if an error occurs.
            this._state = LzmaDecoderState.ERROR;
            if (this.onError) {
                this.onError(error);
            }
        };
        LzmaDecoder.prototype._checkError = function (res) {
            var error;
            if (res === LZMA_RES_ERROR) {
                error = "LZMA decoding error";
            }
            else if (res === LZMA_RES_NOT_COMPLETE) {
                error = "Decoding is not complete";
            }
            else if (res === LZMA_RES_FINISHED_WITH_MARKER) {
                if (this._decoder.unpackSize !== undefined &&
                    this._decoder.unpackSize !== this._outStream.processed) {
                    error = "Finished with end marker before than specified size";
                }
            }
            else {
                error = "Internal LZMA Error";
            }
            if (error) {
                this._error(error);
            }
        };
        return LzmaDecoder;
    }());

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function axCoerceString$1(x) {
        if (typeof x === "string") {
            return x;
        }
        else if (x == undefined) {
            return null;
        }
        return x + '';
    }
    var PlainObjectDataBuffer = /** @class */ (function () {
        function PlainObjectDataBuffer(buffer, length, littleEndian) {
            this.buffer = buffer;
            this.length = length;
            this.littleEndian = littleEndian;
        }
        return PlainObjectDataBuffer;
    }());
    var bitMasks = new Uint32Array(33);
    for (var i = 1, mask = 0; i <= 32; i++) {
        bitMasks[i] = mask = (mask << 1) | 1;
    }
    var TypedArrayViewFlags;
    (function (TypedArrayViewFlags) {
        TypedArrayViewFlags[TypedArrayViewFlags["U8"] = 1] = "U8";
        TypedArrayViewFlags[TypedArrayViewFlags["I32"] = 2] = "I32";
        TypedArrayViewFlags[TypedArrayViewFlags["F32"] = 4] = "F32";
    })(TypedArrayViewFlags || (TypedArrayViewFlags = {}));
    var DataBuffer = /** @class */ (function () {
        function DataBuffer(initialSize) {
            if (initialSize === void 0) { initialSize = DataBuffer.INITIAL_SIZE; }
            // If we're constructing a child class of DataBuffer (or ByteArray), buffer initialization
            // has already happened at this point.
            if (this._buffer) {
                return;
            }
            this._buffer = new ArrayBuffer(initialSize);
            this._length = 0;
            this._position = 0;
            this._resetViews();
            this._littleEndian = DataBuffer._nativeLittleEndian;
            this._bitBuffer = 0;
            this._bitLength = 0;
        }
        DataBuffer.FromArrayBuffer = function (buffer, length) {
            if (length === void 0) { length = -1; }
            var dataBuffer = Object.create(DataBuffer.prototype);
            dataBuffer._buffer = buffer;
            dataBuffer._length = length === -1 ? buffer.byteLength : length;
            dataBuffer._position = 0;
            dataBuffer._resetViews();
            dataBuffer._littleEndian = DataBuffer._nativeLittleEndian;
            dataBuffer._bitBuffer = 0;
            dataBuffer._bitLength = 0;
            return dataBuffer;
        };
        DataBuffer.FromPlainObject = function (source) {
            var dataBuffer = DataBuffer.FromArrayBuffer(source.buffer, source.length);
            dataBuffer._littleEndian = source.littleEndian;
            return dataBuffer;
        };
        DataBuffer.prototype.toPlainObject = function () {
            return new PlainObjectDataBuffer(this._buffer, this._length, this._littleEndian);
        };
        /**
         * Clone the DataBuffer in a way that guarantees the underlying ArrayBuffer to be copied
         * into an instance of the current global's ArrayBuffer.
         *
         * Important if the underlying buffer comes from a different global, in which case accessing
         * its elements is excruiciatingly slow.
         */
        DataBuffer.prototype.clone = function () {
            var clone = DataBuffer.FromArrayBuffer(new Uint8Array(this._u8).buffer, this._length);
            clone._position = this._position;
            clone._littleEndian = this._littleEndian;
            clone._bitBuffer = this._bitBuffer;
            clone._bitLength = this._bitLength;
            return clone;
        };
        /**
         * By default, we only have a byte view. All other views are |null|.
         */
        DataBuffer.prototype._resetViews = function () {
            this._u8 = new Uint8Array(this._buffer);
            this._i32 = null;
            this._f32 = null;
        };
        /**
         * We don't want to eagerly allocate views if we won't ever need them. You must call this method
         * before using a view of a certain type to make sure it's available. Once a view is allocated,
         * it is not re-allocated unless the view becomes |null| as a result of a call to |resetViews|.
         */
        DataBuffer.prototype._requestViews = function (flags) {
            if ((this._buffer.byteLength & 0x3) === 0) {
                if (this._i32 === null && flags & TypedArrayViewFlags.I32) {
                    this._i32 = new Int32Array(this._buffer);
                }
                if (this._f32 === null && flags & TypedArrayViewFlags.F32) {
                    this._f32 = new Float32Array(this._buffer);
                }
            }
        };
        DataBuffer.prototype.getBytes = function () {
            return new Uint8Array(this._buffer, 0, this._length);
        };
        DataBuffer.prototype._ensureCapacity = function (length) {
            var currentBuffer = this._buffer;
            if (currentBuffer.byteLength >= length) {
                return;
            }
            var newLength = Math.max(currentBuffer.byteLength, 1);
            while (newLength < length) {
                newLength *= 2;
            }
            if (newLength > 0xFFFFFFFF) {
                assert(this.sec);
                this.sec.throwError('RangeError', Errors.ParamRangeError);
            }
            var newBuffer = DataBuffer._arrayBufferPool.acquire(newLength);
            var curentView = this._u8;
            this._buffer = newBuffer;
            this._resetViews();
            this._u8.set(curentView);
            var u8 = this._u8;
            // Zero out the rest of the buffer, since the arrayBufferPool doesn't
            // always give us a empty buffer.
            for (var i = curentView.length; i < u8.length; i++) {
                u8[i] = 0;
            }
            DataBuffer._arrayBufferPool.release(currentBuffer);
        };
        DataBuffer.prototype.clear = function () {
            this._length = 0;
            this._position = 0;
        };
        DataBuffer.prototype.readBoolean = function () {
            return this.readUnsignedByte() !== 0;
        };
        DataBuffer.prototype.readByte = function () {
            return this.readUnsignedByte() << 24 >> 24;
        };
        DataBuffer.prototype.readUnsignedByte = function () {
            if (this._position + 1 > this._length) {
                assert(this.sec);
                this.sec.throwError('flash.errors.EOFError', Errors.EOFError);
            }
            return this._u8[this._position++];
        };
        DataBuffer.prototype.readBytes = function (bytes, offset /*uint*/, length /*uint*/) {
            var position = this._position;
            offset = offset >>> 0;
            length = length >>> 0;
            if (length === 0) {
                length = this._length - position;
            }
            if (position + length > this._length) {
                assert(this.sec);
                this.sec.throwError('flash.errors.EOFError', Errors.EOFError);
            }
            if (bytes.length < offset + length) {
                bytes._ensureCapacity(offset + length);
                bytes.length = offset + length;
            }
            bytes._u8.set(new Uint8Array(this._buffer, position, length), offset);
            this._position += length;
        };
        DataBuffer.prototype.readShort = function () {
            return this.readUnsignedShort() << 16 >> 16;
        };
        DataBuffer.prototype.readUnsignedShort = function () {
            var u8 = this._u8;
            var position = this._position;
            if (position + 2 > this._length) {
                assert(this.sec);
                this.sec.throwError('flash.errors.EOFError', Errors.EOFError);
            }
            var a = u8[position + 0];
            var b = u8[position + 1];
            this._position = position + 2;
            return this._littleEndian ? (b << 8) | a : (a << 8) | b;
        };
        DataBuffer.prototype.readInt = function () {
            var u8 = this._u8;
            var position = this._position;
            if (position + 4 > this._length) {
                assert(this.sec);
                this.sec.throwError('flash.errors.EOFError', Errors.EOFError);
            }
            var a = u8[position + 0];
            var b = u8[position + 1];
            var c = u8[position + 2];
            var d = u8[position + 3];
            this._position = position + 4;
            return this._littleEndian ?
                (d << 24) | (c << 16) | (b << 8) | a :
                (a << 24) | (b << 16) | (c << 8) | d;
        };
        DataBuffer.prototype.readUnsignedInt = function () {
            return this.readInt() >>> 0;
        };
        DataBuffer.prototype.readFloat = function () {
            var position = this._position;
            if (position + 4 > this._length) {
                assert(this.sec);
                this.sec.throwError('flash.errors.EOFError', Errors.EOFError);
            }
            this._position = position + 4;
            this._requestViews(TypedArrayViewFlags.F32);
            if (this._littleEndian && (position & 0x3) === 0 && this._f32) {
                return this._f32[position >> 2];
            }
            else {
                var u8 = this._u8;
                var t8 = IntegerUtilities.u8;
                if (this._littleEndian) {
                    t8[0] = u8[position + 0];
                    t8[1] = u8[position + 1];
                    t8[2] = u8[position + 2];
                    t8[3] = u8[position + 3];
                }
                else {
                    t8[3] = u8[position + 0];
                    t8[2] = u8[position + 1];
                    t8[1] = u8[position + 2];
                    t8[0] = u8[position + 3];
                }
                return IntegerUtilities.f32[0];
            }
        };
        DataBuffer.prototype.readDouble = function () {
            var u8 = this._u8;
            var position = this._position;
            if (position + 8 > this._length) {
                assert(this.sec);
                this.sec.throwError('flash.errors.EOFError', Errors.EOFError);
            }
            var t8 = IntegerUtilities.u8;
            if (this._littleEndian) {
                t8[0] = u8[position + 0];
                t8[1] = u8[position + 1];
                t8[2] = u8[position + 2];
                t8[3] = u8[position + 3];
                t8[4] = u8[position + 4];
                t8[5] = u8[position + 5];
                t8[6] = u8[position + 6];
                t8[7] = u8[position + 7];
            }
            else {
                t8[0] = u8[position + 7];
                t8[1] = u8[position + 6];
                t8[2] = u8[position + 5];
                t8[3] = u8[position + 4];
                t8[4] = u8[position + 3];
                t8[5] = u8[position + 2];
                t8[6] = u8[position + 1];
                t8[7] = u8[position + 0];
            }
            this._position = position + 8;
            return IntegerUtilities.f64[0];
        };
        DataBuffer.prototype.writeBoolean = function (value) {
            this.writeByte(!!value ? 1 : 0);
        };
        DataBuffer.prototype.writeByte = function (value /*int*/) {
            var length = this._position + 1;
            this._ensureCapacity(length);
            this._u8[this._position++] = value;
            if (length > this._length) {
                this._length = length;
            }
        };
        DataBuffer.prototype.writeUnsignedByte = function (value /*uint*/) {
            var length = this._position + 1;
            this._ensureCapacity(length);
            this._u8[this._position++] = value;
            if (length > this._length) {
                this._length = length;
            }
        };
        DataBuffer.prototype.writeRawBytes = function (bytes) {
            var length = this._position + bytes.length;
            this._ensureCapacity(length);
            this._u8.set(bytes, this._position);
            this._position = length;
            if (length > this._length) {
                this._length = length;
            }
        };
        DataBuffer.prototype.writeBytes = function (bytes, offset /*uint*/, length /*uint*/) {
            if (isNullOrUndefined(bytes)) {
                assert(this.sec);
                this.sec.throwError('TypeError', Errors.NullPointerError, 'bytes');
            }
            offset = offset >>> 0;
            length = length >>> 0;
            if (arguments.length < 2) {
                offset = 0;
            }
            if (arguments.length < 3) {
                length = 0;
            }
            if (offset !== clamp(offset, 0, bytes.length) ||
                offset + length !== clamp(offset + length, 0, bytes.length)) {
                assert(this.sec);
                this.sec.throwError('RangeError', Errors.ParamRangeError);
            }
            if (length === 0) {
                length = bytes.length - offset;
            }
            this.writeRawBytes(new Uint8Array(bytes._buffer, offset, length));
        };
        DataBuffer.prototype.writeShort = function (value /*int*/) {
            this.writeUnsignedShort(value);
        };
        DataBuffer.prototype.writeUnsignedShort = function (value /*uint*/) {
            var position = this._position;
            this._ensureCapacity(position + 2);
            var u8 = this._u8;
            if (this._littleEndian) {
                u8[position + 0] = value;
                u8[position + 1] = value >> 8;
            }
            else {
                u8[position + 0] = value >> 8;
                u8[position + 1] = value;
            }
            position += 2;
            this._position = position;
            if (position > this._length) {
                this._length = position;
            }
        };
        DataBuffer.prototype.writeInt = function (value /*int*/) {
            this.writeUnsignedInt(value);
        };
        DataBuffer.prototype.write2Ints = function (a, b) {
            this.write2UnsignedInts(a, b);
        };
        DataBuffer.prototype.write4Ints = function (a, b, c, d) {
            this.write4UnsignedInts(a, b, c, d);
        };
        DataBuffer.prototype.writeUnsignedInt = function (value /*uint*/) {
            var position = this._position;
            this._ensureCapacity(position + 4);
            this._requestViews(TypedArrayViewFlags.I32);
            if (this._littleEndian === DataBuffer._nativeLittleEndian && (position & 0x3) === 0 && this._i32) {
                this._i32[position >> 2] = value;
            }
            else {
                var u8 = this._u8;
                if (this._littleEndian) {
                    u8[position + 0] = value;
                    u8[position + 1] = value >> 8;
                    u8[position + 2] = value >> 16;
                    u8[position + 3] = value >> 24;
                }
                else {
                    u8[position + 0] = value >> 24;
                    u8[position + 1] = value >> 16;
                    u8[position + 2] = value >> 8;
                    u8[position + 3] = value;
                }
            }
            position += 4;
            this._position = position;
            if (position > this._length) {
                this._length = position;
            }
        };
        DataBuffer.prototype.write2UnsignedInts = function (a, b) {
            var position = this._position;
            this._ensureCapacity(position + 8);
            this._requestViews(TypedArrayViewFlags.I32);
            if (this._littleEndian === DataBuffer._nativeLittleEndian && (position & 0x3) === 0 && this._i32) {
                this._i32[(position >> 2) + 0] = a;
                this._i32[(position >> 2) + 1] = b;
                position += 8;
                this._position = position;
                if (position > this._length) {
                    this._length = position;
                }
            }
            else {
                this.writeUnsignedInt(a);
                this.writeUnsignedInt(b);
            }
        };
        DataBuffer.prototype.write4UnsignedInts = function (a, b, c, d) {
            var position = this._position;
            this._ensureCapacity(position + 16);
            this._requestViews(TypedArrayViewFlags.I32);
            if (this._littleEndian === DataBuffer._nativeLittleEndian && (position & 0x3) === 0 && this._i32) {
                this._i32[(position >> 2) + 0] = a;
                this._i32[(position >> 2) + 1] = b;
                this._i32[(position >> 2) + 2] = c;
                this._i32[(position >> 2) + 3] = d;
                position += 16;
                this._position = position;
                if (position > this._length) {
                    this._length = position;
                }
            }
            else {
                this.writeUnsignedInt(a);
                this.writeUnsignedInt(b);
                this.writeUnsignedInt(c);
                this.writeUnsignedInt(d);
            }
        };
        DataBuffer.prototype.writeFloat = function (value) {
            var position = this._position;
            this._ensureCapacity(position + 4);
            this._requestViews(TypedArrayViewFlags.F32);
            if (this._littleEndian === DataBuffer._nativeLittleEndian && (position & 0x3) === 0 && this._f32) {
                this._f32[position >> 2] = value;
            }
            else {
                var u8 = this._u8;
                IntegerUtilities.f32[0] = value;
                var t8 = IntegerUtilities.u8;
                if (this._littleEndian) {
                    u8[position + 0] = t8[0];
                    u8[position + 1] = t8[1];
                    u8[position + 2] = t8[2];
                    u8[position + 3] = t8[3];
                }
                else {
                    u8[position + 0] = t8[3];
                    u8[position + 1] = t8[2];
                    u8[position + 2] = t8[1];
                    u8[position + 3] = t8[0];
                }
            }
            position += 4;
            this._position = position;
            if (position > this._length) {
                this._length = position;
            }
        };
        DataBuffer.prototype.write2Floats = function (a, b) {
            var position = this._position;
            this._ensureCapacity(position + 8);
            this._requestViews(TypedArrayViewFlags.F32);
            if (this._littleEndian === DataBuffer._nativeLittleEndian && (position & 0x3) === 0 && this._f32) {
                this._f32[(position >> 2) + 0] = a;
                this._f32[(position >> 2) + 1] = b;
                position += 8;
                this._position = position;
                if (position > this._length) {
                    this._length = position;
                }
            }
            else {
                this.writeFloat(a);
                this.writeFloat(b);
            }
        };
        DataBuffer.prototype.write6Floats = function (a, b, c, d, e, f) {
            var position = this._position;
            this._ensureCapacity(position + 24);
            this._requestViews(TypedArrayViewFlags.F32);
            if (this._littleEndian === DataBuffer._nativeLittleEndian && (position & 0x3) === 0 && this._f32) {
                this._f32[(position >> 2) + 0] = a;
                this._f32[(position >> 2) + 1] = b;
                this._f32[(position >> 2) + 2] = c;
                this._f32[(position >> 2) + 3] = d;
                this._f32[(position >> 2) + 4] = e;
                this._f32[(position >> 2) + 5] = f;
                position += 24;
                this._position = position;
                if (position > this._length) {
                    this._length = position;
                }
            }
            else {
                this.writeFloat(a);
                this.writeFloat(b);
                this.writeFloat(c);
                this.writeFloat(d);
                this.writeFloat(e);
                this.writeFloat(f);
            }
        };
        DataBuffer.prototype.writeDouble = function (value) {
            var position = this._position;
            this._ensureCapacity(position + 8);
            var u8 = this._u8;
            IntegerUtilities.f64[0] = value;
            var t8 = IntegerUtilities.u8;
            if (this._littleEndian) {
                u8[position + 0] = t8[0];
                u8[position + 1] = t8[1];
                u8[position + 2] = t8[2];
                u8[position + 3] = t8[3];
                u8[position + 4] = t8[4];
                u8[position + 5] = t8[5];
                u8[position + 6] = t8[6];
                u8[position + 7] = t8[7];
            }
            else {
                u8[position + 0] = t8[7];
                u8[position + 1] = t8[6];
                u8[position + 2] = t8[5];
                u8[position + 3] = t8[4];
                u8[position + 4] = t8[3];
                u8[position + 5] = t8[2];
                u8[position + 6] = t8[1];
                u8[position + 7] = t8[0];
            }
            position += 8;
            this._position = position;
            if (position > this._length) {
                this._length = position;
            }
        };
        DataBuffer.prototype.readRawBytes = function () {
            return new Int8Array(this._buffer, 0, this._length);
        };
        DataBuffer.prototype.writeUTF = function (value) {
            value = axCoerceString$1(value);
            var bytes = utf8decode(value);
            this.writeShort(bytes.length);
            this.writeRawBytes(bytes);
        };
        DataBuffer.prototype.writeUTFBytes = function (value) {
            value = axCoerceString$1(value);
            var bytes = utf8decode(value);
            this.writeRawBytes(bytes);
        };
        DataBuffer.prototype.readUTF = function () {
            return this.readUTFBytes(this.readShort());
        };
        DataBuffer.prototype.readUTFBytes = function (length /*uint*/) {
            length = length >>> 0;
            var pos = this._position;
            if (pos + length > this._length) {
                assert(this.sec);
                this.sec.throwError('flash.errors.EOFError', Errors.EOFError);
            }
            this._position += length;
            return utf8encode(new Uint8Array(this._buffer, pos, length));
        };
        Object.defineProperty(DataBuffer.prototype, "length", {
            get: function () {
                return this._length;
            },
            set: function (value /*uint*/) {
                value = value >>> 0;
                var capacity = this._buffer.byteLength;
                /* XXX: Do we need to zero the difference if length <= cap? */
                if (value > capacity) {
                    this._ensureCapacity(value);
                }
                this._length = value;
                this._position = clamp(this._position, 0, this._length);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataBuffer.prototype, "bytesAvailable", {
            get: function () {
                return this._length - this._position;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataBuffer.prototype, "position", {
            get: function () {
                return this._position;
            },
            set: function (position /*uint*/) {
                this._position = position >>> 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataBuffer.prototype, "buffer", {
            get: function () {
                return this._buffer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataBuffer.prototype, "bytes", {
            get: function () {
                return this._u8;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataBuffer.prototype, "ints", {
            get: function () {
                this._requestViews(TypedArrayViewFlags.I32);
                return this._i32;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataBuffer.prototype, "objectEncoding", {
            get: function () {
                return this._objectEncoding;
            },
            set: function (version /*uint*/) {
                version = version >>> 0;
                this._objectEncoding = version;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DataBuffer.prototype, "endian", {
            get: function () {
                return this._littleEndian ? "littleEndian" : "bigEndian";
            },
            set: function (type) {
                type = axCoerceString$1(type);
                if (type === "auto") {
                    this._littleEndian = DataBuffer._nativeLittleEndian;
                }
                else {
                    this._littleEndian = type === "littleEndian";
                }
            },
            enumerable: true,
            configurable: true
        });
        DataBuffer.prototype.toString = function () {
            return utf8encode(new Uint8Array(this._buffer, 0, this._length));
        };
        DataBuffer.prototype.toBlob = function (type) {
            return new Blob([new Uint8Array(this._buffer, this._position, this._length)], { type: type });
        };
        DataBuffer.prototype.writeMultiByte = function (value, charSet) {
            value = axCoerceString$1(value);
            charSet = axCoerceString$1(charSet);
            console.log("packageInternal flash.utils.ObjectOutput::writeMultiByte");
            return;
        };
        DataBuffer.prototype.readMultiByte = function (length /*uint*/, charSet) {
            length = length >>> 0;
            charSet = axCoerceString$1(charSet);
            console.log("packageInternal flash.utils.ObjectInput::readMultiByte");
            return;
        };
        DataBuffer.prototype.getValue = function (name) {
            name = name | 0;
            if (name >= this._length) {
                return undefined;
            }
            return this._u8[name];
        };
        DataBuffer.prototype.setValue = function (name, value) {
            name = name | 0;
            var length = name + 1;
            this._ensureCapacity(length);
            this._u8[name] = value;
            if (length > this._length) {
                this._length = length;
            }
        };
        DataBuffer.prototype.readFixed = function () {
            return this.readInt() / 65536;
        };
        DataBuffer.prototype.readFixed8 = function () {
            return this.readShort() / 256;
        };
        DataBuffer.prototype.readFloat16 = function () {
            var uint16 = this.readUnsignedShort();
            var sign = uint16 >> 15 ? -1 : 1;
            var exponent = (uint16 & 0x7c00) >> 10;
            var fraction = uint16 & 0x03ff;
            if (!exponent) {
                return sign * Math.pow(2, -14) * (fraction / 1024);
            }
            if (exponent === 0x1f) {
                return fraction ? NaN : sign * Infinity;
            }
            return sign * Math.pow(2, exponent - 15) * (1 + (fraction / 1024));
        };
        DataBuffer.prototype.readEncodedU32 = function () {
            var value = this.readUnsignedByte();
            if (!(value & 0x080)) {
                return value;
            }
            value = (value & 0x7f) | this.readUnsignedByte() << 7;
            if (!(value & 0x4000)) {
                return value;
            }
            value = (value & 0x3fff) | this.readUnsignedByte() << 14;
            if (!(value & 0x200000)) {
                return value;
            }
            value = (value & 0x1FFFFF) | this.readUnsignedByte() << 21;
            if (!(value & 0x10000000)) {
                return value;
            }
            return (value & 0xFFFFFFF) | (this.readUnsignedByte() << 28);
        };
        DataBuffer.prototype.readBits = function (size) {
            return (this.readUnsignedBits(size) << (32 - size)) >> (32 - size);
        };
        DataBuffer.prototype.readUnsignedBits = function (size) {
            var buffer = this._bitBuffer;
            var length = this._bitLength;
            while (size > length) {
                buffer = (buffer << 8) | this.readUnsignedByte();
                length += 8;
            }
            length -= size;
            var value = (buffer >>> length) & bitMasks[size];
            this._bitBuffer = buffer;
            this._bitLength = length;
            return value;
        };
        DataBuffer.prototype.readFixedBits = function (size) {
            return this.readBits(size) / 65536;
        };
        DataBuffer.prototype.readString = function (length) {
            var position = this._position;
            if (length) {
                if (position + length > this._length) {
                    assert(this.sec);
                    this.sec.throwError('flash.errors.EOFError', Errors.EOFError);
                }
                this._position += length;
            }
            else {
                length = 0;
                for (var i = position; i < this._length && this._u8[i]; i++) {
                    length++;
                }
                this._position += length + 1;
            }
            return utf8encode(new Uint8Array(this._buffer, position, length));
        };
        DataBuffer.prototype.align = function () {
            this._bitBuffer = 0;
            this._bitLength = 0;
        };
        DataBuffer.prototype.deflate = function () {
            this.compress('deflate');
        };
        DataBuffer.prototype.inflate = function () {
            this.uncompress('deflate');
        };
        DataBuffer.prototype.compress = function (algorithm) {
            if (arguments.length === 0) {
                algorithm = 'zlib';
            }
            else {
                algorithm = axCoerceString$1(algorithm);
            }
            var deflate;
            switch (algorithm) {
                case 'zlib':
                    deflate = new Deflate(true);
                    break;
                case 'deflate':
                    deflate = new Deflate(false);
                    break;
                default:
                    return;
            }
            var output = new DataBuffer();
            deflate.onData = output.writeRawBytes.bind(output);
            deflate.push(this._u8.subarray(0, this._length));
            deflate.close();
            this._ensureCapacity(output._u8.length);
            this._u8.set(output._u8);
            this.length = output.length;
            this._position = 0;
        };
        DataBuffer.prototype.uncompress = function (algorithm) {
            if (arguments.length === 0) {
                algorithm = 'zlib';
            }
            else {
                algorithm = axCoerceString$1(algorithm);
            }
            var inflate;
            switch (algorithm) {
                case 'zlib':
                    inflate = Inflate.create(true);
                    break;
                case 'deflate':
                    inflate = Inflate.create(false);
                    break;
                case 'lzma':
                    inflate = new LzmaDecoder(false);
                    break;
                default:
                    return;
            }
            var output = new DataBuffer();
            var error;
            inflate.onData = output.writeRawBytes.bind(output);
            inflate.onError = function (e) { return error = e; };
            inflate.push(this._u8.subarray(0, this._length));
            if (error) {
                assert(this.sec);
                this.sec.throwError('IOError', Errors.CompressedDataError);
            }
            inflate.close();
            this._ensureCapacity(output._u8.length);
            this._u8.set(output._u8);
            this.length = output.length;
            this._position = 0;
        };
        DataBuffer._nativeLittleEndian = new Int8Array(new Int32Array([1]).buffer)[0] === 1;
        /* The initial size of the backing, in bytes. Doubled every OOM. */
        DataBuffer.INITIAL_SIZE = 128;
        DataBuffer._arrayBufferPool = new ArrayBufferPool();
        return DataBuffer;
    }());

    var FillType;
    (function (FillType) {
        FillType[FillType["Solid"] = 0] = "Solid";
        FillType[FillType["LinearGradient"] = 16] = "LinearGradient";
        FillType[FillType["RadialGradient"] = 18] = "RadialGradient";
        FillType[FillType["FocalRadialGradient"] = 19] = "FocalRadialGradient";
        FillType[FillType["RepeatingBitmap"] = 64] = "RepeatingBitmap";
        FillType[FillType["ClippedBitmap"] = 65] = "ClippedBitmap";
        FillType[FillType["NonsmoothedRepeatingBitmap"] = 66] = "NonsmoothedRepeatingBitmap";
        FillType[FillType["NonsmoothedClippedBitmap"] = 67] = "NonsmoothedClippedBitmap";
    })(FillType || (FillType = {}));

    var PathSegment = /** @class */ (function () {
        function PathSegment(commands, data, morphData, prev, next, isReversed) {
            this.commands = commands;
            this.data = data;
            this.morphData = morphData;
            this.prev = prev;
            this.next = next;
            this.isReversed = isReversed;
            this.isValidFill = true;
            this.id = PathSegment._counter++;
        }
        PathSegment.FromDefaults = function (isMorph) {
            var commands = new DataBuffer();
            var data = new DataBuffer();
            commands.endian = data.endian = 'auto';
            var morphData = null;
            if (isMorph) {
                morphData = new DataBuffer();
                morphData.endian = 'auto';
            }
            return new PathSegment(commands, data, morphData, null, null, false);
        };
        PathSegment.prototype.moveTo = function (x, y) {
            this.commands.writeUnsignedByte(9 /* MoveTo */);
            this.data.write2Ints(x, y);
        };
        PathSegment.prototype.morphMoveTo = function (x, y, mx, my) {
            this.moveTo(x, y);
            this.morphData.write2Ints(mx, my);
        };
        PathSegment.prototype.lineTo = function (x, y) {
            this.commands.writeUnsignedByte(10 /* LineTo */);
            this.data.write2Ints(x, y);
        };
        PathSegment.prototype.morphLineTo = function (x, y, mx, my) {
            this.lineTo(x, y);
            this.morphData.write2Ints(mx, my);
        };
        PathSegment.prototype.curveTo = function (cpx, cpy, x, y) {
            this.commands.writeUnsignedByte(11 /* CurveTo */);
            this.data.write4Ints(cpx, cpy, x, y);
        };
        PathSegment.prototype.morphCurveTo = function (cpx, cpy, x, y, mcpx, mcpy, mx, my) {
            this.curveTo(cpx, cpy, x, y);
            this.morphData.write4Ints(mcpx, mcpy, mx, my);
        };
        /**
         * Returns a shallow copy of the segment1 with the "isReversed" flag set.
         * Reversed segments play themselves back in reverse when they're merged into the final
         * non-segmented path1.
         * Note: Don't modify the original, or the reversed copy, after this operation!
         */
        PathSegment.prototype.toReversed = function () {
            assert(!this.isReversed);
            return new PathSegment(this.commands, this.data, this.morphData, null, null, true);
        };
        PathSegment.prototype.clone = function () {
            return new PathSegment(this.commands, this.data, this.morphData, null, null, this.isReversed);
        };
        PathSegment.prototype.storeStartAndEnd = function () {
            var data = this.data.ints;
            var endPoint1 = data[0] + ',' + data[1];
            var endPoint2Offset = (this.data.length >> 2) - 2;
            var endPoint2 = data[endPoint2Offset] + ',' + data[endPoint2Offset + 1];
            if (!this.isReversed) {
                this.startPoint = endPoint1;
                this.endPoint = endPoint2;
            }
            else {
                this.startPoint = endPoint2;
                this.endPoint = endPoint1;
            }
        };
        PathSegment.prototype.connectsTo = function (other) {
            //assert(other !== this);
            if (other === this)
                return false;
            assert(this.endPoint);
            assert(other.startPoint);
            return this.endPoint === other.startPoint;
        };
        PathSegment.prototype.startConnectsTo = function (other) {
            if (other === this)
                return false;
            //	assert(other !== this);
            return this.startPoint === other.startPoint;
        };
        PathSegment.prototype.flipDirection = function () {
            var tempPoint = "";
            tempPoint = this.startPoint;
            this.startPoint = this.endPoint;
            this.endPoint = tempPoint;
            this.isReversed = !this.isReversed;
        };
        PathSegment.prototype.serializeAJS = function (shape, morphShape, lastPosition) {
            //console.log("serializeAJS segment1");
            if (this.isReversed) {
                this._serializeReversedAJS(shape, morphShape, lastPosition);
                return;
            }
            var commands = this.commands.bytes;
            // Note: this *must* use `this.data.length`, because buffers will have padding.
            var dataLength = this.data.length >> 2;
            var morphData = this.morphData ? this.morphData.ints : null;
            var data = this.data.ints;
            assert(commands[0] === 9 /* MoveTo */);
            // If the segment1's first moveTo goes to the current coordinates, we have to skip it.
            var offset = 0;
            if (data[0] === lastPosition.x && data[1] === lastPosition.y) {
                offset++;
            }
            var commandsCount = this.commands.length;
            var dataPosition = offset * 2;
            for (var i = offset; i < commandsCount; i++) {
                switch (commands[i]) {
                    case 9 /* MoveTo */:
                        //console.log("moveTo",data[dataPosition]/20, data[dataPosition+1]/20);
                        shape.moveTo(data[dataPosition] / 20, data[dataPosition + 1] / 20);
                        if (morphShape) {
                            morphShape.moveTo(morphData[dataPosition] / 20, morphData[dataPosition + 1] / 20);
                        }
                        break;
                    case 10 /* LineTo */:
                        //console.log("lineTo",data[dataPosition]/20, data[dataPosition+1]/20);
                        shape.lineTo(data[dataPosition] / 20, data[dataPosition + 1] / 20);
                        if (morphShape) {
                            morphShape.lineTo(morphData[dataPosition] / 20, morphData[dataPosition + 1] / 20);
                        }
                        break;
                    case 11 /* CurveTo */:
                        //console.log("curveTo",data[dataPosition]/20, data[dataPosition+1]/20,data[dataPosition+2]/20, data[dataPosition+3]/20);
                        shape.curveTo(data[dataPosition] / 20, data[dataPosition + 1] / 20, data[dataPosition + 2] / 20, data[dataPosition + 3] / 20);
                        if (morphShape) {
                            morphShape.curveTo(morphData[dataPosition] / 20, morphData[dataPosition + 1] / 20, morphData[dataPosition + 2] / 20, morphData[dataPosition + 3] / 20);
                        }
                        //shape.curveTo(data[dataPosition]/20, data[dataPosition+1]/20, data[dataPosition+2]/20, data[dataPosition+3]/20 );
                        dataPosition += 2;
                        break;
                }
                dataPosition += 2;
            }
            //assert(dataPosition === dataLength);
            lastPosition.x = data[dataLength - 2];
            lastPosition.y = data[dataLength - 1];
        };
        PathSegment.prototype._serializeReversedAJS = function (shape, morphShape, lastPosition) {
            //console.log("_serializeReversedAJS segment1");
            // For reversing the fill0 segments, we rely on the fact that each segment1
            // starts with a moveTo. We first write a new moveTo with the final drawing command's
            // target coordinates (if we don't skip it, see below). For each of the following
            // commands, we take the coordinates of the command originally *preceding*
            // it as the new target coordinates. The final coordinates we target will be
            // the ones from the original first moveTo.
            // Note: these *must* use `this.{data,commands}.length`, because buffers will have padding.
            var commandsCount = this.commands.length;
            var dataPosition = (this.data.length >> 2) - 2;
            var commands = this.commands.bytes;
            assert(commands[0] === 9 /* MoveTo */);
            var data = this.data.ints;
            var morphData = this.morphData ? this.morphData.ints : null;
            // Only write the first moveTo if it doesn't go to the current coordinates.
            if (data[dataPosition] !== lastPosition.x || data[dataPosition + 1] !== lastPosition.y) {
                shape.moveTo(data[dataPosition] / 20, data[dataPosition + 1] / 20);
                if (morphShape) {
                    morphShape.moveTo(morphData[dataPosition] / 20, morphData[dataPosition + 1] / 20);
                }
            }
            if (commandsCount === 1) {
                lastPosition.x = data[0];
                lastPosition.y = data[1];
                return;
            }
            for (var i = commandsCount; i-- > 1;) {
                dataPosition -= 2;
                var command = commands[i];
                switch (commands[i]) {
                    case 9 /* MoveTo */:
                        //console.log("moveTo",data[dataPosition]/20, data[dataPosition+1]/20);
                        shape.moveTo(data[dataPosition] / 20, data[dataPosition + 1] / 20);
                        if (morphShape) {
                            morphShape.moveTo(morphData[dataPosition] / 20, morphData[dataPosition + 1] / 20);
                        }
                        break;
                    case 10 /* LineTo */:
                        //console.log("lineTo",data[dataPosition]/20, data[dataPosition+1]/20);
                        shape.lineTo(data[dataPosition] / 20, data[dataPosition + 1] / 20);
                        if (morphShape) {
                            morphShape.lineTo(morphData[dataPosition] / 20, morphData[dataPosition + 1] / 20);
                        }
                        break;
                    case 11 /* CurveTo */:
                        dataPosition -= 2;
                        //console.log("curveTo",data[dataPosition+2]/20, data[dataPosition+3]/20,data[dataPosition]/20, data[dataPosition+1]/20);
                        shape.curveTo(data[dataPosition + 2] / 20, data[dataPosition + 3] / 20, data[dataPosition] / 20, data[dataPosition + 1] / 20);
                        if (morphShape) {
                            morphShape.curveTo(morphData[dataPosition + 2] / 20, morphData[dataPosition + 3] / 20, morphData[dataPosition] / 20, morphData[dataPosition + 1] / 20);
                        }
                        break;
                }
            }
            //assert(dataPosition === 0);
            lastPosition.x = data[0];
            lastPosition.y = data[1];
        };
        PathSegment._counter = 0;
        return PathSegment;
    }());

    /**
     * The GradientType class provides values for the <code>type</code> parameter
     * in the <code>beginGradientFill()</code> and
     * <code>lineGradientStyle()</code> methods of the flash.display.Graphics
     * class.
     */
    var GradientType;
    (function (GradientType) {
        /**
         * Value used to specify a linear gradient fill.
         */
        GradientType[GradientType["LINEAR"] = 0] = "LINEAR";
        /**
         * Value used to specify a radial gradient fill.
         */
        GradientType[GradientType["RADIAL"] = 1] = "RADIAL";
    })(GradientType || (GradientType = {}));

    var GraphicsFillStyle = /** @class */ (function () {
        function GraphicsFillStyle(color, alpha) {
            if (color === void 0) { color = 0xffffff; }
            if (alpha === void 0) { alpha = 1; }
            this.color = color;
            this.alpha = alpha;
        }
        Object.defineProperty(GraphicsFillStyle.prototype, "data_type", {
            get: function () {
                return GraphicsFillStyle.data_type;
            },
            enumerable: true,
            configurable: true
        });
        GraphicsFillStyle.data_type = "[graphicsdata FillStyle]";
        return GraphicsFillStyle;
    }());

    var GradientFillStyle = /** @class */ (function (_super) {
        __extends$5(GradientFillStyle, _super);
        function GradientFillStyle(type, colors, alphas, ratios, matrix, spreadMethod, interpolationMethod, focalPointRatio) {
            var _this = _super.call(this) || this;
            if (colors.length != alphas.length || colors.length != ratios.length) {
                throw ("GradientFillStyle: Error - colors, alphas and ratios must be of same length");
            }
            _this.colors = colors;
            _this.colors_r = [];
            _this.colors_g = [];
            _this.colors_b = [];
            _this.colors_r.length = _this.colors_g.length = _this.colors_g.length = _this.colors.length;
            _this.alphas = alphas;
            _this.ratios = ratios;
            _this.matrix = matrix;
            _this.type = type;
            _this.uvRectangle = new Rectangle();
            _this.ratios.sort(function (a, b) { return a - b; });
            _this.ratio_min = _this.ratios[0];
            _this.ratio_max = _this.ratios[_this.ratios.length - 1];
            var r = _this.ratios.length;
            //  todo: in case the ratios.sort has changed the order of ratios, 
            //  do we need to sync the order of color too ?
            var c = colors.length;
            var argb;
            while (c > 0) {
                c--;
                argb = ColorUtils.float32ColorToARGB(colors[c]);
                _this.colors_r[c] = argb[1];
                _this.colors_g[c] = argb[2];
                _this.colors_b[c] = argb[3];
            }
            return _this;
        }
        GradientFillStyle.prototype.getUVMatrix = function () {
            if (!this.matrix) {
                this.matrix = new Matrix();
            }
            // console.log(this.uvRectangle);
            // console.log(this.matrix);
            // todo: this is ported from exporter-cpp code
            // probably a lot to optimize here
            var projection_width = 1638.4;
            var projection_height = 1638.4;
            var projection_width_half = projection_width * 0.5;
            var projection_height_half = projection_height * 0.5;
            //	Get and invert the uv transform:
            var a = this.matrix.a;
            var b = this.matrix.b;
            var c = this.matrix.c;
            var d = this.matrix.d;
            var tx = this.matrix.tx;
            var ty = this.matrix.ty;
            var a_inv = d / (a * d - b * c);
            var b_inv = -b / (a * d - b * c);
            var c_inv = -c / (a * d - b * c);
            var d_inv = a / (a * d - b * c);
            var tx_inv = (c * ty - d * tx) / (a * d - b * c);
            var ty_inv = -(a * ty - b * tx) / (a * d - b * c);
            var a_out = (a_inv / projection_width) * (1 - (1 / 256));
            var c_out = (c_inv / projection_width) * (1 - (1 / 256));
            var tx_out = (this.uvRectangle.x) + ((tx_inv + projection_width_half) / projection_width) * (1 - (1 / 256));
            var ty_out = (this.uvRectangle.y); //+((ty_inv + projection_height_half)/projection_width)*(1-(1/256));
            this.matrix = new Matrix(a_out, 0, c_out, 0, tx_out, ty_out);
            if (this.type == GradientType.RADIAL) {
                this.matrix = new Matrix(a_inv / projection_width_half, c_inv / projection_width_half, b_inv / projection_width_half, d_inv / projection_width_half, ((tx_inv + projection_width_half) / projection_width_half) - 1, ((ty_inv + projection_height_half) / projection_width_half) - 1);
            }
            return this.matrix;
        };
        GradientFillStyle.prototype.getColorAtPosition = function (value) {
            var r1 = -1;
            var r2 = -1;
            if (value <= this.ratio_min) {
                r1 = 0;
                r2 = 0;
            }
            else if (value >= this.ratio_max) {
                r1 = this.ratios.length - 1;
                r2 = this.ratios.length - 1;
            }
            else {
                var r = 0;
                for (var r = 0; r < this.ratios.length - 1; r++) {
                    if (value == this.ratios[r]) {
                        r1 = r;
                        r2 = r;
                        break;
                    }
                    else if (value == this.ratios[r + 1]) {
                        r1 = r + 1;
                        r2 = r + 1;
                        break;
                    }
                    else if (value >= this.ratios[r] && value <= this.ratios[r + 1]) {
                        r1 = r;
                        r2 = r + 1;
                        break;
                    }
                }
            }
            if (r1 == r2) {
                return [this.alphas[r1], this.colors_r[r1], this.colors_g[r1], this.colors_b[r1]];
            }
            var mix = (value - this.ratios[r1]) / (this.ratios[r2] - this.ratios[r1]);
            var mix_neg = 1 - mix;
            var color_a = this.alphas[r2] * mix + this.alphas[r1] * mix_neg;
            var color_r = this.colors_r[r2] * mix + this.colors_r[r1] * mix_neg;
            var color_g = this.colors_g[r2] * mix + this.colors_g[r1] * mix_neg;
            var color_b = this.colors_b[r2] * mix + this.colors_b[r1] * mix_neg;
            return [color_a, color_r, color_g, color_b];
        };
        GradientFillStyle.prototype.toString = function () {
            var str = "";
            var c = this.colors.length;
            while (c > 0) {
                c--;
                str += this.colors[c] + "#" + this.alphas[c] + "#" + this.ratios[c] + "#";
            }
            return str;
        };
        Object.defineProperty(GradientFillStyle.prototype, "data_type", {
            get: function () {
                return GradientFillStyle.data_type;
            },
            enumerable: true,
            configurable: true
        });
        GradientFillStyle.data_type = "[graphicsdata GradientFillStyle]";
        return GradientFillStyle;
    }(GraphicsFillStyle));

    var BitmapFillStyle = /** @class */ (function () {
        function BitmapFillStyle(material, matrix, repeat, smooth) {
            this.material = material;
            this.matrix = matrix;
            this.repeat = repeat;
        }
        Object.defineProperty(BitmapFillStyle.prototype, "data_type", {
            get: function () {
                return BitmapFillStyle.data_type;
            },
            enumerable: true,
            configurable: true
        });
        BitmapFillStyle.prototype.getUVMatrix = function () {
            if (!this.matrix) {
                this.matrix = new Matrix();
            }
            // console.log(this.uvRectangle);
            // console.log(this.matrix);
            // todo: this is ported from exporter-cpp code
            // probably a lot to optimize here
            var projection_width = this.material.ambientMethod.texture._images[0].width * 2;
            var projection_height = this.material.ambientMethod.texture._images[0].height * 2;
            var projection_width_half = projection_width * 0.5;
            var projection_height_half = projection_height * 0.5;
            //	Get and invert the uv transform:
            var a = this.matrix.a / 20;
            var b = this.matrix.b / 20;
            var c = this.matrix.c / 20;
            var d = this.matrix.d / 20;
            var tx = this.matrix.tx;
            var ty = this.matrix.ty;
            var a_inv = d / (a * d - b * c);
            var b_inv = -b / (a * d - b * c);
            var c_inv = -c / (a * d - b * c);
            var d_inv = a / (a * d - b * c);
            var tx_inv = (c * ty - d * tx) / (a * d - b * c);
            var ty_inv = -(a * ty - b * tx) / (a * d - b * c);
            this.matrix.a = a_inv / projection_width_half;
            this.matrix.b = b_inv / projection_height_half;
            this.matrix.c = c_inv / projection_width_half;
            this.matrix.d = d_inv / projection_height_half;
            this.matrix.tx = tx_inv / projection_width_half;
            this.matrix.ty = ty_inv / projection_height_half;
            return this.matrix;
        };
        BitmapFillStyle.data_type = "[graphicsdata BitmapFillStyle]";
        return BitmapFillStyle;
    }());

    /**
     * The LineScaleMode class provides values for the <code>scaleMode</code>
     * parameter in the <code>Graphics.lineStyle()</code> method.
     */
    var LineScaleMode;
    (function (LineScaleMode) {
        /**
         * With this setting used as the <code>scaleMode</code> parameter of the
         * <code>lineStyle()</code> method, the thickness of the line scales
         * <i>only</i> vertically. For example, consider the following circles, drawn
         * with a one-pixel line, and each with the <code>scaleMode</code> parameter
         * set to <code>LineScaleMode.VERTICAL</code>. The circle on the left is
         * scaled only vertically, and the circle on the right is scaled both
         * vertically and horizontally.
         */
        LineScaleMode[LineScaleMode["HORIZONTAL"] = 0] = "HORIZONTAL";
        /**
         * With this setting used as the <code>scaleMode</code> parameter of the
         * <code>lineStyle()</code> method, the thickness of the line never scales.
         */
        LineScaleMode[LineScaleMode["NONE"] = 1] = "NONE";
        /**
         * With this setting used as the <code>scaleMode</code> parameter of the
         * <code>lineStyle()</code> method, the thickness of the line always scales
         * when the object is scaled(the default).
         */
        LineScaleMode[LineScaleMode["NORMAL"] = 2] = "NORMAL";
        /**
         * With this setting used as the <code>scaleMode</code> parameter of the
         * <code>lineStyle()</code> method, the thickness of the line scales
         * <i>only</i> horizontally. For example, consider the following circles,
         * drawn with a one-pixel line, and each with the <code>scaleMode</code>
         * parameter set to <code>LineScaleMode.HORIZONTAL</code>. The circle on the
         * left is scaled only horizontally, and the circle on the right is scaled
         * both vertically and horizontally.
         */
        LineScaleMode[LineScaleMode["VERTICAL"] = 3] = "VERTICAL";
        /**
         *
         */
        LineScaleMode[LineScaleMode["HAIRLINE"] = 4] = "HAIRLINE";
    })(LineScaleMode || (LineScaleMode = {}));

    /**
     * The CapsStyle class is an enumeration of constant values that specify the
     * caps style to use in drawing lines. The constants are provided for use as
     * values in the <code>caps</code> parameter of the
     * <code>flash.display.Graphics.lineStyle()</code> method. You can specify the
     * following three types of caps:
     */
    var CapsStyle = /** @class */ (function () {
        function CapsStyle() {
        }
        /**
         * Used to specify round caps in the <code>caps</code> parameter of the
         * <code>flash.display.Graphics.lineStyle()</code> method.
         */
        CapsStyle.ROUND = 1;
        /**
         * Used to specify no caps in the <code>caps</code> parameter of the
         * <code>flash.display.Graphics.lineStyle()</code> method.
         */
        CapsStyle.NONE = 0;
        /**
         * Used to specify square caps in the <code>caps</code> parameter of the
         * <code>flash.display.Graphics.lineStyle()</code> method.
         */
        CapsStyle.SQUARE = 2;
        return CapsStyle;
    }());

    /**
     * The JointStyle class is an enumeration of constant values that specify the
     * joint style to use in drawing lines. These constants are provided for use
     * as values in the <code>joints</code> parameter of the
     * <code>flash.display.Graphics.lineStyle()</code> method. The method supports
     * three types of joints: miter, round, and bevel, as the following example
     * shows:
     */
    var JointStyle = /** @class */ (function () {
        function JointStyle() {
        }
        /**
         * Specifies beveled joints in the <code>joints</code> parameter of the
         * <code>flash.display.Graphics.lineStyle()</code> method.
         */
        JointStyle.BEVEL = 1; //2;
        /**
         * Specifies mitered joints in the <code>joints</code> parameter of the
         * <code>flash.display.Graphics.lineStyle()</code> method.
         */
        JointStyle.MITER = 2; //0;
        /**
         * Specifies round joints in the <code>joints</code> parameter of the
         * <code>flash.display.Graphics.lineStyle()</code> method.
         */
        JointStyle.ROUND = 0; //1;
        return JointStyle;
    }());

    var GraphicsStrokeStyle = /** @class */ (function () {
        function GraphicsStrokeStyle(color, alpha, thickness, jointstyle, capstyle, miter_limit, scaleMode) {
            if (color === void 0) { color = 0xffffff; }
            if (alpha === void 0) { alpha = 1; }
            if (thickness === void 0) { thickness = 10; }
            if (jointstyle === void 0) { jointstyle = JointStyle.ROUND; }
            if (capstyle === void 0) { capstyle = CapsStyle.SQUARE; }
            if (miter_limit === void 0) { miter_limit = 10; }
            if (scaleMode === void 0) { scaleMode = LineScaleMode.NORMAL; }
            this._color = color;
            this._alpha = alpha;
            this._thickness = thickness;
            this._jointstyle = jointstyle;
            this._capstyle = capstyle;
            this._miter_limit = miter_limit;
            this.scaleMode = scaleMode;
        }
        Object.defineProperty(GraphicsStrokeStyle.prototype, "data_type", {
            get: function () {
                return GraphicsStrokeStyle.data_type;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GraphicsStrokeStyle.prototype, "color", {
            get: function () {
                return this._color;
            },
            set: function (value) {
                this._color = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GraphicsStrokeStyle.prototype, "alpha", {
            get: function () {
                return this._alpha;
            },
            set: function (value) {
                this._alpha = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GraphicsStrokeStyle.prototype, "half_thickness", {
            get: function () {
                return this._thickness / 2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GraphicsStrokeStyle.prototype, "thickness", {
            get: function () {
                return this._thickness;
            },
            set: function (value) {
                this._thickness = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GraphicsStrokeStyle.prototype, "jointstyle", {
            get: function () {
                return this._jointstyle;
            },
            set: function (value) {
                this._jointstyle = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GraphicsStrokeStyle.prototype, "miter_limit", {
            get: function () {
                return this._miter_limit;
            },
            set: function (value) {
                this._miter_limit = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GraphicsStrokeStyle.prototype, "capstyle", {
            get: function () {
                return this._capstyle;
            },
            set: function (value) {
                this._capstyle = value;
            },
            enumerable: true,
            configurable: true
        });
        GraphicsStrokeStyle.data_type = "[graphicsdata StrokeStyle]";
        return GraphicsStrokeStyle;
    }());

    var SegmentedPath = /** @class */ (function () {
        function SegmentedPath(fillStyle, lineStyle) {
            this.fillStyle = fillStyle;
            this.lineStyle = lineStyle;
            this._head = null;
        }
        SegmentedPath.prototype.addSegment = function (segment1) {
            assert(segment1);
            assert(segment1.next === null);
            assert(segment1.prev === null);
            var currentHead = this._head;
            if (currentHead) {
                assert(segment1 !== currentHead);
                currentHead.next = segment1;
                segment1.prev = currentHead;
            }
            this._head = segment1;
        };
        // Does *not* reset the segment1's prev and next pointers!
        SegmentedPath.prototype.removeSegment = function (segment1) {
            if (segment1.prev) {
                segment1.prev.next = segment1.next;
            }
            if (segment1.next) {
                segment1.next.prev = segment1.prev;
            }
        };
        SegmentedPath.prototype.insertSegment = function (segment1, next) {
            var prev = next.prev;
            segment1.prev = prev;
            segment1.next = next;
            if (prev) {
                prev.next = segment1;
            }
            next.prev = segment1;
        };
        SegmentedPath.prototype.head = function () {
            return this._head;
        };
        SegmentedPath.prototype.rgbaToArgb = function (float32Color) {
            var r = (float32Color & 0xff000000) >>> 24;
            var g = (float32Color & 0xff0000) >>> 16;
            var b = (float32Color & 0xff00) >>> 8;
            var a = float32Color & 0xff;
            return (a << 24) | (r << 16) |
                (g << 8) | b;
        };
        SegmentedPath.prototype.getAlpha = function (float32Color) {
            //var r:number = ( float32Color & 0xff000000 ) >>> 24;
            //var g:number = ( float32Color & 0xff0000 ) >>> 16;
            //var b:number = ( float32Color & 0xff00 ) >>> 8;
            var a = float32Color & 0xff;
            return a;
        };
        SegmentedPath.prototype.rgbToArgb = function (float32Color) {
            var a = (float32Color & 0xff000000) >>> 24;
            var b = (float32Color & 0xff0000) >>> 16;
            var g = (float32Color & 0xff00) >>> 8;
            var r = float32Color & 0xff;
            return (a << 24) | (r << 16) |
                (g << 8) | b;
        };
        SegmentedPath.prototype.serializeAJS = function (shape, morphShape) {
            //console.log("serializeAJS");
            var segment1 = this.head();
            if (!segment1) {
                // Path is empty.
                return;
            }
            if (this.fillStyle) {
                var style = this.fillStyle;
                var morph = style.morph;
                switch (style.type) {
                    case FillType.Solid:
                        style.alpha = this.getAlpha(style.color) / 255;
                        style.color = this.rgbaToArgb(style.color);
                        shape.style = new GraphicsFillStyle(style.color, style.alpha);
                        //	style.color=ColorUtils.ARGBtoFloat32(255, r, g, b);
                        //	shape.style=new GraphicsStrokeStyle(style.color, 5, 1);
                        if (morph) {
                            morph.alpha = this.getAlpha(morph.color) / 255;
                            morph.color = this.rgbaToArgb(morph.color);
                            morphShape.style = new GraphicsFillStyle(morph.color, morph.alpha);
                        }
                        break;
                    case FillType.LinearGradient:
                    case FillType.RadialGradient:
                    case FillType.FocalRadialGradient:
                        var gradientType = style.type === FillType.LinearGradient ?
                            GradientType.LINEAR :
                            GradientType.RADIAL;
                        var alphas = [];
                        for (var i = 0; i < style.colors.length; i++) {
                            alphas[i] = this.getAlpha(style.colors[i]) / 255;
                            style.colors[i] = this.rgbaToArgb(style.colors[i]);
                        }
                        var awayMatrix = new Matrix(style.transform.a, style.transform.b, style.transform.c, style.transform.d, style.transform.tx, style.transform.ty);
                        shape.style = new GradientFillStyle(gradientType, style.colors, alphas, style.ratios, awayMatrix, style.spreadMethod, style.interpolationMode, style.focalPoint / 2 | 0);
                        //console.log("style.spreadMethod, style.interpolationMode", style.spreadMethod, style.interpolationMode);
                        if (morph) {
                            var gradientType = morph.type === FillType.LinearGradient ?
                                GradientType.LINEAR :
                                GradientType.RADIAL;
                            var alphas = [];
                            for (var i = 0; i < morph.colors.length; i++) {
                                alphas[i] = this.getAlpha(morph.colors[i]) / 255;
                                morph.colors[i] = this.rgbaToArgb(morph.colors[i]);
                            }
                            var awayMatrix = new Matrix(morph.transform.a, morph.transform.b, morph.transform.c, morph.transform.d, morph.transform.tx, morph.transform.ty);
                            morphShape.style = new GradientFillStyle(gradientType, morph.colors, alphas, morph.ratios, awayMatrix, morph.spreadMethod, morph.interpolationMode, morph.focalPoint / 2 | 0);
                            //console.log("writeMorphGradient not handled yet");
                            //writeMorphGradient(morph, shape);
                        }
                        break;
                    case FillType.ClippedBitmap:
                    case FillType.RepeatingBitmap:
                    case FillType.NonsmoothedClippedBitmap:
                    case FillType.NonsmoothedRepeatingBitmap:
                        //console.log("bitmapIndex", style.bitmapIndex, "transform", style.transform,  "repeat", style.repeat,  "smooth", style.smooth);
                        var awayMatrix = new Matrix(style.transform.a, style.transform.b, style.transform.c, style.transform.d, style.transform.tx, style.transform.ty);
                        shape.style = new BitmapFillStyle(style.material, awayMatrix, style.repeat, style.smooth);
                        //shape.beginBitmap(command, style.bitmapIndex, style.transform, style.repeat, style.smooth);
                        if (morph) {
                            console.log("writeMorphBitmap not handled yet");
                            //writeMorphBitmap(morph, shape);
                        }
                        break;
                    default:
                        console.log('Invalid fill style type: ' + style.type);
                }
            }
            else {
                var style = this.lineStyle;
                var morph = style.morph;
                assert(style);
                switch (style.type) {
                    case FillType.Solid:
                        var scaleMode = style.noHscale ?
                            (style.noVscale ? 0 : 2) :
                            style.noVscale ? 3 : 1;
                        // TODO: Figure out how to handle startCapsStyle
                        var thickness = (clamp(style.width, 0, 0xff * 20) | 0) / 20;
                        style.alpha = this.getAlpha(style.color) / 255;
                        style.color = this.rgbaToArgb(style.color);
                        var scaleModeAWJ = LineScaleMode.NORMAL;
                        //if(style.noVscale==null && style.noHscale==null){
                        //	scaleModeAWJ="HAIRLINE";
                        //}
                        if (thickness == 0.05) {
                            scaleModeAWJ = LineScaleMode.HAIRLINE;
                        }
                        if (style.startCapsStyle != style.endCapsStyle) {
                            console.log("Warning: different end vs start capstyöe");
                        }
                        style.startCapsStyle = CapsStyle.ROUND;
                        style.jointStyle = 0;
                        //console.log("style.startCapsStyle", style.startCapsStyle, style.endCapsStyle, style );
                        shape.style = new GraphicsStrokeStyle(style.color, style.alpha, thickness, style.jointStyle, style.startCapsStyle, style.miterLimit, scaleModeAWJ);
                        //console.log("scaleMode", scaleModeAWJ, style.noHscale, style.noVscale, scaleMode, thickness, style.jointStyle, style.startCapsStyle, style.endCapsStyle, style.miterLimit);
                        if (morph) {
                            var thickness = (clamp(morph.width, 0, 0xff * 20) | 0) / 20;
                            morph.alpha = this.getAlpha(morph.color) / 255;
                            morph.color = this.rgbaToArgb(morph.color);
                            morphShape.style = new GraphicsStrokeStyle(morph.color, morph.alpha, thickness, style.jointStyle, style.startCapsStyle, style.miterLimit, scaleModeAWJ);
                            //console.log("writeMorphLineStyle not handled yet");
                            //writeMorphLineStyle(morph, shape);
                        }
                        break;
                    case FillType.LinearGradient:
                    case FillType.RadialGradient:
                    case FillType.FocalRadialGradient:
                        var scaleMode = style.noHscale ?
                            (style.noVscale ? 0 : 2) :
                            style.noVscale ? 3 : 1;
                        // TODO: Figure out how to handle startCapsStyle
                        //console.log("style.startCapsStyle", style.startCapsStyle, style.endCapsStyle, style );
                        var thickness = (clamp(style.width, 0, 0xff * 20) | 0) / 20;
                        style.alpha = this.getAlpha(style.color) / 255;
                        style.color = this.rgbaToArgb(style.color);
                        shape.style = new GraphicsStrokeStyle(style.color, style.alpha, thickness, style.jointStyle, style.endCapsStyle, style.miterLimit);
                        var gradientType = style.type === FillType.LinearGradient ?
                            GradientType.LINEAR :
                            GradientType.RADIAL;
                        for (var i = 0; i < style.colors.length; i++) {
                            style.colors[i] = this.rgbaToArgb(style.colors[i]);
                            alphas[i] = 1;
                        }
                        for (var i = 0; i < style.colors.length; i++)
                            alphas[i] = 1;
                        shape.style = new GradientFillStyle(gradientType, style.colors, alphas, style.ratios, style.transform, style.spreadMethod, style.interpolationMode, style.focalPoint / 2 | 0);
                        break;
                    case FillType.ClippedBitmap:
                    case FillType.RepeatingBitmap:
                    case FillType.NonsmoothedClippedBitmap:
                    case FillType.NonsmoothedRepeatingBitmap:
                        var scaleMode = style.noHscale ?
                            (style.noVscale ? 0 : 2) :
                            style.noVscale ? 3 : 1;
                        // TODO: Figure out how to handle startCapsStyle
                        //console.log("style.startCapsStyle", style.startCapsStyle, style.endCapsStyle, style );
                        var thickness = clamp(style.width, 0, 0xff * 20) | 0;
                        shape.style = new GraphicsStrokeStyle(style.color, 1, thickness, style.jointStyle, style.endCapsStyle, style.miterLimit);
                        break;
                    default:
                    //console.error('Line style type not yet supported: ' + style.type);
                }
            }
            while (segment1) {
                segment1.storeStartAndEnd();
                segment1 = segment1.prev;
            }
            var start = this.head();
            var end = start;
            var finalRoot = null;
            var finalHead = null;
            // Path segments for one style can appear in arbitrary order in the tag's list
            // of edge records.
            // Before we linearize them, we have to identify all pairs of segments where
            // one ends at a coordinate the other starts at.
            // The following loop does that, by creating ever-growing runs of matching
            // segments. If no more segments are found that match the current run (either
            // at the beginning, or at the end), the current run is complete, and a new
            // one is started. Rinse, repeat, until no solitary segments remain.
            var current = start.prev;
            while (start) {
                while (current) {
                    // if this segment1 has the same startpoint as the start-startpoint it needs to be reversed.
                    if (current.startConnectsTo(start)) {
                        current.flipDirection();
                    }
                    // if this segment1 connects to another, we remove it and add it at the end.
                    if (current.connectsTo(start)) {
                        if (current.next !== start) {
                            this.removeSegment(current);
                            this.insertSegment(current, start);
                        }
                        start = current;
                        current = start.prev;
                        continue;
                    }
                    if (current.startConnectsTo(end)) {
                        current.flipDirection();
                    }
                    if (end.connectsTo(current)) {
                        this.removeSegment(current);
                        end.next = current;
                        current = current.prev;
                        end.next.prev = end;
                        end.next.next = null;
                        end = end.next;
                        continue;
                    }
                    current = current.prev;
                }
                // This run of segments is finished. Store and forget it (for this loop).
                current = start.prev;
                if (!finalRoot) {
                    finalRoot = start;
                    finalHead = end;
                }
                else {
                    finalHead.next = start;
                    start.prev = finalHead;
                    finalHead = end;
                    finalHead.next = null;
                }
                if (!current) {
                    break;
                }
                start = end = current;
                current = start.prev;
            }
            var lastPosition = { x: 0, y: 0 };
            current = finalRoot;
            while (current) {
                if (current.isValidFill) {
                    current.serializeAJS(shape, morphShape, lastPosition);
                }
                current = current.next;
            }
            /*
            if (this.fillStyle) {
                shape.endFill();
            } else {
                shape.endLine();
            }*/
            return shape;
        };
        return SegmentedPath;
    }());

    var PlainObjectShapeData = /** @class */ (function () {
        function PlainObjectShapeData(commands, commandsPosition, coordinates, morphCoordinates, coordinatesPosition, styles, stylesLength, morphStyles, morphStylesLength, hasFills, hasLines) {
            this.commands = commands;
            this.commandsPosition = commandsPosition;
            this.coordinates = coordinates;
            this.morphCoordinates = morphCoordinates;
            this.coordinatesPosition = coordinatesPosition;
            this.styles = styles;
            this.stylesLength = stylesLength;
            this.morphStyles = morphStyles;
            this.morphStylesLength = morphStylesLength;
            this.hasFills = hasFills;
            this.hasLines = hasLines;
        }
        return PlainObjectShapeData;
    }());
    var DefaultSize;
    (function (DefaultSize) {
        DefaultSize[DefaultSize["Commands"] = 32] = "Commands";
        DefaultSize[DefaultSize["Coordinates"] = 128] = "Coordinates";
        DefaultSize[DefaultSize["Styles"] = 16] = "Styles";
    })(DefaultSize || (DefaultSize = {}));
    var ShapeData = /** @class */ (function () {
        function ShapeData(initialize) {
            if (initialize === void 0) { initialize = true; }
            if (initialize) {
                this.clear();
            }
        }
        ShapeData.FromPlainObject = function (source) {
            var data = new ShapeData(false);
            data.commands = source.commands;
            data.coordinates = source.coordinates;
            data.morphCoordinates = source.morphCoordinates;
            data.commandsPosition = source.commandsPosition;
            data.coordinatesPosition = source.coordinatesPosition;
            data.styles = DataBuffer.FromArrayBuffer(source.styles, source.stylesLength);
            data.styles.endian = 'auto';
            if (source.morphStyles) {
                data.morphStyles = DataBuffer.FromArrayBuffer(source.morphStyles, source.morphStylesLength);
                data.morphStyles.endian = 'auto';
            }
            data.hasFills = source.hasFills;
            data.hasLines = source.hasLines;
            return data;
        };
        ShapeData.prototype.moveTo = function (x, y) {
            this.ensurePathCapacities(1, 2);
            this.commands[this.commandsPosition++] = 9 /* MoveTo */;
            this.coordinates[this.coordinatesPosition++] = x;
            this.coordinates[this.coordinatesPosition++] = y;
        };
        ShapeData.prototype.lineTo = function (x, y) {
            this.ensurePathCapacities(1, 2);
            this.commands[this.commandsPosition++] = 10 /* LineTo */;
            this.coordinates[this.coordinatesPosition++] = x;
            this.coordinates[this.coordinatesPosition++] = y;
        };
        ShapeData.prototype.curveTo = function (controlX, controlY, anchorX, anchorY) {
            this.ensurePathCapacities(1, 4);
            this.commands[this.commandsPosition++] = 11 /* CurveTo */;
            this.coordinates[this.coordinatesPosition++] = controlX;
            this.coordinates[this.coordinatesPosition++] = controlY;
            this.coordinates[this.coordinatesPosition++] = anchorX;
            this.coordinates[this.coordinatesPosition++] = anchorY;
        };
        ShapeData.prototype.cubicCurveTo = function (controlX1, controlY1, controlX2, controlY2, anchorX, anchorY) {
            this.ensurePathCapacities(1, 6);
            this.commands[this.commandsPosition++] = 12 /* CubicCurveTo */;
            this.coordinates[this.coordinatesPosition++] = controlX1;
            this.coordinates[this.coordinatesPosition++] = controlY1;
            this.coordinates[this.coordinatesPosition++] = controlX2;
            this.coordinates[this.coordinatesPosition++] = controlY2;
            this.coordinates[this.coordinatesPosition++] = anchorX;
            this.coordinates[this.coordinatesPosition++] = anchorY;
        };
        ShapeData.prototype.beginFill = function (color) {
            this.ensurePathCapacities(1, 0);
            this.commands[this.commandsPosition++] = 1 /* BeginSolidFill */;
            this.styles.writeUnsignedInt(color);
            this.hasFills = true;
        };
        ShapeData.prototype.writeMorphFill = function (color) {
            this.morphStyles.writeUnsignedInt(color);
        };
        ShapeData.prototype.endFill = function () {
            this.ensurePathCapacities(1, 0);
            this.commands[this.commandsPosition++] = 4 /* EndFill */;
        };
        ShapeData.prototype.endLine = function () {
            this.ensurePathCapacities(1, 0);
            this.commands[this.commandsPosition++] = 8 /* LineEnd */;
        };
        ShapeData.prototype.lineStyle = function (thickness, color, pixelHinting, scaleMode, caps, joints, miterLimit) {
            assert(thickness === (thickness | 0), thickness >= 0 && thickness <= 0xff * 20);
            this.ensurePathCapacities(2, 0);
            this.commands[this.commandsPosition++] = 5 /* LineStyleSolid */;
            this.coordinates[this.coordinatesPosition++] = thickness;
            var styles = this.styles;
            styles.writeUnsignedInt(color);
            styles.writeBoolean(pixelHinting);
            styles.writeUnsignedByte(scaleMode);
            styles.writeUnsignedByte(caps);
            styles.writeUnsignedByte(joints);
            styles.writeUnsignedByte(miterLimit);
            this.hasLines = true;
        };
        ShapeData.prototype.writeMorphLineStyle = function (thickness, color) {
            this.morphCoordinates[this.coordinatesPosition - 1] = thickness;
            this.morphStyles.writeUnsignedInt(color);
        };
        /**
         * Bitmaps are specified the same for fills and strokes, so we only need to serialize them
         * once. The Parameter `pathCommand` is treated as the actual command to serialize, and must
         * be one of BeginBitmapFill and LineStyleBitmap.
         */
        ShapeData.prototype.beginBitmap = function (pathCommand, bitmapId, matrix, repeat, smooth) {
            assert(pathCommand === 3 /* BeginBitmapFill */ ||
                pathCommand === 7 /* LineStyleBitmap */);
            this.ensurePathCapacities(1, 0);
            this.commands[this.commandsPosition++] = pathCommand;
            var styles = this.styles;
            styles.writeUnsignedInt(bitmapId);
            this._writeStyleMatrix(matrix, false);
            styles.writeBoolean(repeat);
            styles.writeBoolean(smooth);
            this.hasFills = true;
        };
        ShapeData.prototype.writeMorphBitmap = function (matrix) {
            this._writeStyleMatrix(matrix, true);
        };
        /**
         * Gradients are specified the same for fills and strokes, so we only need to serialize them
         * once. The Parameter `pathCommand` is treated as the actual command to serialize, and must
         * be one of BeginGradientFill and LineStyleGradient.
         */
        ShapeData.prototype.beginGradient = function (pathCommand, colors, ratios, gradientType, matrix, spread, interpolation, focalPointRatio) {
            assert(pathCommand === 2 /* BeginGradientFill */ ||
                pathCommand === 6 /* LineStyleGradient */);
            this.ensurePathCapacities(1, 0);
            this.commands[this.commandsPosition++] = pathCommand;
            var styles = this.styles;
            styles.writeUnsignedByte(gradientType);
            assert(focalPointRatio === (focalPointRatio | 0));
            styles.writeShort(focalPointRatio);
            this._writeStyleMatrix(matrix, false);
            var colorStops = colors.length;
            styles.writeByte(colorStops);
            for (var i = 0; i < colorStops; i++) {
                // Ratio must be valid, otherwise we'd have bailed above.
                styles.writeUnsignedByte(ratios[i]);
                // Colors are coerced to uint32, with the highest byte stripped.
                styles.writeUnsignedInt(colors[i]);
            }
            styles.writeUnsignedByte(spread);
            styles.writeUnsignedByte(interpolation);
            this.hasFills = true;
        };
        ShapeData.prototype.writeMorphGradient = function (colors, ratios, matrix) {
            this._writeStyleMatrix(matrix, true);
            var styles = this.morphStyles;
            for (var i = 0; i < colors.length; i++) {
                // Ratio must be valid, otherwise we'd have bailed above.
                styles.writeUnsignedByte(ratios[i]);
                // Colors are coerced to uint32, with the highest byte stripped.
                styles.writeUnsignedInt(colors[i]);
            }
        };
        ShapeData.prototype.writeCommandAndCoordinates = function (command, x, y) {
            this.ensurePathCapacities(1, 2);
            this.commands[this.commandsPosition++] = command;
            this.coordinates[this.coordinatesPosition++] = x;
            this.coordinates[this.coordinatesPosition++] = y;
        };
        ShapeData.prototype.writeCoordinates = function (x, y) {
            this.ensurePathCapacities(0, 2);
            this.coordinates[this.coordinatesPosition++] = x;
            this.coordinates[this.coordinatesPosition++] = y;
        };
        ShapeData.prototype.writeMorphCoordinates = function (x, y) {
            this.morphCoordinates = ensureTypedArrayCapacity(this.morphCoordinates, this.coordinatesPosition);
            this.morphCoordinates[this.coordinatesPosition - 2] = x;
            this.morphCoordinates[this.coordinatesPosition - 1] = y;
        };
        ShapeData.prototype.clear = function () {
            this.commandsPosition = this.coordinatesPosition = 0;
            this.commands = new Uint8Array(DefaultSize.Commands);
            this.coordinates = new Int32Array(DefaultSize.Coordinates);
            this.styles = new DataBuffer(DefaultSize.Styles);
            this.styles.endian = 'auto';
            this.hasFills = this.hasLines = false;
        };
        ShapeData.prototype.isEmpty = function () {
            return this.commandsPosition === 0;
        };
        ShapeData.prototype.clone = function () {
            var copy = new ShapeData(false);
            copy.commands = new Uint8Array(this.commands);
            copy.commandsPosition = this.commandsPosition;
            copy.coordinates = new Int32Array(this.coordinates);
            copy.coordinatesPosition = this.coordinatesPosition;
            copy.styles = new DataBuffer(this.styles.length);
            copy.styles.writeRawBytes(this.styles.bytes.subarray(0, this.styles.length));
            if (this.morphStyles) {
                copy.morphStyles = new DataBuffer(this.morphStyles.length);
                copy.morphStyles.writeRawBytes(this.morphStyles.bytes.subarray(0, this.morphStyles.length));
            }
            copy.hasFills = this.hasFills;
            copy.hasLines = this.hasLines;
            return copy;
        };
        ShapeData.prototype.toPlainObject = function () {
            return new PlainObjectShapeData(this.commands, this.commandsPosition, this.coordinates, this.morphCoordinates, this.coordinatesPosition, this.styles.buffer, this.styles.length, this.morphStyles && this.morphStyles.buffer, this.morphStyles ? this.morphStyles.length : 0, this.hasFills, this.hasLines);
        };
        Object.defineProperty(ShapeData.prototype, "buffers", {
            get: function () {
                var buffers = [this.commands.buffer, this.coordinates.buffer, this.styles.buffer];
                if (this.morphCoordinates) {
                    buffers.push(this.morphCoordinates.buffer);
                }
                if (this.morphStyles) {
                    buffers.push(this.morphStyles.buffer);
                }
                return buffers;
            },
            enumerable: true,
            configurable: true
        });
        ShapeData.prototype._writeStyleMatrix = function (matrix, isMorph) {
            var styles = isMorph ? this.morphStyles : this.styles;
            styles.write6Floats(matrix.a, matrix.b, matrix.c, matrix.d, matrix.tx, matrix.ty);
        };
        ShapeData.prototype.ensurePathCapacities = function (numCommands, numCoordinates) {
            // ensureTypedArrayCapacity will hopefully be inlined, in which case the field writes
            // will be optimized out.
            this.commands = ensureTypedArrayCapacity(this.commands, this.commandsPosition + numCommands);
            this.coordinates = ensureTypedArrayCapacity(this.coordinates, this.coordinatesPosition + numCoordinates);
        };
        return ShapeData;
    }());

    /**
     * DrawMode is an enumeration of constant values that specify the
     * DrawMode to use when drawing.
     */
    var DrawMode = /** @class */ (function () {
        function DrawMode() {
        }
        /**
         * Used to specify to draw both strokes and fills
         */
        DrawMode.BOTH = 1;
        /**
         * Used to specify to draw strokes only
         */
        DrawMode.STROKE = 0;
        /**
         * Used to specify to draw fills only
         */
        DrawMode.FILL = 2;
        return DrawMode;
    }());

    /**
     * @class away.base.HitTestCache
     */
    var HitTestCache = /** @class */ (function () {
        function HitTestCache() {
            /**
             *
             */
            this.cells = new Array();
            /**
             *
             */
            this.lastCollisionIndex = -1;
        }
        return HitTestCache;
    }());

    var TriangleElementsUtils = /** @class */ (function () {
        function TriangleElementsUtils() {
        }
        //TODO - generate this dyanamically based on num tris
        TriangleElementsUtils.hitTest = function (x, y, z, box, triangleElements, count, offset) {
            if (offset === void 0) { offset = 0; }
            var positionAttributes = triangleElements.positions;
            var curveAttributes = triangleElements.getCustomAtributes("curves");
            var posStride = positionAttributes.stride;
            var curveStride = curveAttributes ? curveAttributes.stride : null;
            var positions = positionAttributes.get(count, offset);
            var curves = curveAttributes ? curveAttributes.get(count, offset) : null;
            var indices;
            var len;
            if (triangleElements.indices) {
                indices = triangleElements.indices.get(count, offset);
                positions = positionAttributes.get(positionAttributes.count);
                curves = curveAttributes ? curveAttributes.get(curveAttributes.count) : null;
                len = count * triangleElements.indices.dimensions;
            }
            else {
                positions = positionAttributes.get(count, offset);
                curves = curveAttributes ? curveAttributes.get(count, offset) : null;
                len = count;
            }
            var id0;
            var id1;
            var id2;
            var ax;
            var ay;
            var bx;
            var by;
            var cx;
            var cy;
            var hitTestCache = triangleElements.hitTestCache[offset] || (triangleElements.hitTestCache[offset] = new HitTestCache());
            var index = hitTestCache.lastCollisionIndex;
            if (index != -1 && index < len) {
                precheck: {
                    if (indices) {
                        id0 = indices[index + 2];
                        id1 = indices[index + 1];
                        id2 = indices[index];
                    }
                    else {
                        id0 = index + 2;
                        id1 = index + 1;
                        id2 = index;
                    }
                    ax = positions[id0 * posStride];
                    ay = positions[id0 * posStride + 1];
                    bx = positions[id1 * posStride];
                    by = positions[id1 * posStride + 1];
                    cx = positions[id2 * posStride];
                    cy = positions[id2 * posStride + 1];
                    //from a to p
                    var dx = ax - x;
                    var dy = ay - y;
                    //edge normal (a-b)
                    var nx = by - ay;
                    var ny = -(bx - ax);
                    var dot = (dx * nx) + (dy * ny);
                    if (dot > 0)
                        break precheck;
                    dx = bx - x;
                    dy = by - y;
                    nx = cy - by;
                    ny = -(cx - bx);
                    dot = (dx * nx) + (dy * ny);
                    if (dot > 0)
                        break precheck;
                    dx = cx - x;
                    dy = cy - y;
                    nx = ay - cy;
                    ny = -(ax - cx);
                    dot = (dx * nx) + (dy * ny);
                    if (dot > 0)
                        break precheck;
                    if (curves) {
                        //check if not solid
                        if (curves[id0 * curveStride + 2] != -128) {
                            var v0x = bx - ax;
                            var v0y = by - ay;
                            var v1x = cx - ax;
                            var v1y = cy - ay;
                            var v2x = x - ax;
                            var v2y = y - ay;
                            var den = v0x * v1y - v1x * v0y;
                            var v = (v2x * v1y - v1x * v2y) / den;
                            var w = (v0x * v2y - v2x * v0y) / den;
                            //var u:number = 1 - v - w;	//commented out as inlined away
                            //here be dragons
                            var uu = 0.5 * v + w;
                            var vv = w;
                            var d = uu * uu - vv;
                            var az = curves[id0 * curveStride];
                            if (d > 0 && az == -128) {
                                break precheck;
                            }
                            else if (d < 0 && az == 127) {
                                break precheck;
                            }
                        }
                    }
                    return true;
                }
            }
            //hard coded min vertex count to bother using a grid for
            if (len > 150) {
                var cells = hitTestCache.cells;
                var divisions = cells.length ? hitTestCache.divisions : (hitTestCache.divisions = Math.min(Math.ceil(Math.sqrt(len)), 32));
                var conversionX = divisions / box.width;
                var conversionY = divisions / box.height;
                var minx = box.x;
                var miny = box.y;
                if (!cells.length) { //build grid
                    //now we have bounds start creating grid cells and filling
                    cells.length = divisions * divisions;
                    for (var k = 0; k < len; k += 3) {
                        if (indices) {
                            id0 = indices[k + 2];
                            id1 = indices[k + 1];
                            id2 = indices[k];
                        }
                        else {
                            id0 = k + 2;
                            id1 = k + 1;
                            id2 = k;
                        }
                        ax = positions[id0 * posStride];
                        ay = positions[id0 * posStride + 1];
                        bx = positions[id1 * posStride];
                        by = positions[id1 * posStride + 1];
                        cx = positions[id2 * posStride];
                        cy = positions[id2 * posStride + 1];
                        //subtractions to push into positive space
                        var min_index_x = Math.floor((Math.min(ax, bx, cx) - minx) * conversionX);
                        var min_index_y = Math.floor((Math.min(ay, by, cy) - miny) * conversionY);
                        var max_index_x = Math.floor((Math.max(ax, bx, cx) - minx) * conversionX);
                        var max_index_y = Math.floor((Math.max(ay, by, cy) - miny) * conversionY);
                        for (var i = min_index_x; i <= max_index_x; i++) {
                            for (var j = min_index_y; j <= max_index_y; j++) {
                                var c = i + j * divisions;
                                var nodes = cells[c] || (cells[c] = new Array());
                                //push in the triangle ids
                                nodes.push(k);
                            }
                        }
                    }
                }
                var index_x = Math.floor((x - minx) * conversionX);
                var index_y = Math.floor((y - miny) * conversionY);
                var nodes = cells[index_x + index_y * divisions];
                if (nodes == null) {
                    hitTestCache.lastCollisionIndex = -1;
                    return false;
                }
                var nodeCount = nodes.length;
                for (var n = 0; n < nodeCount; n++) {
                    var k = nodes[n];
                    if (indices) {
                        id2 = indices[k];
                    }
                    else {
                        id2 = k;
                    }
                    if (id2 == index)
                        continue;
                    if (indices) {
                        id0 = indices[k + 2];
                        id1 = indices[k + 1];
                    }
                    else {
                        id0 = k + 2;
                        id1 = k + 1;
                    }
                    ax = positions[id0 * posStride];
                    ay = positions[id0 * posStride + 1];
                    bx = positions[id1 * posStride];
                    by = positions[id1 * posStride + 1];
                    cx = positions[id2 * posStride];
                    cy = positions[id2 * posStride + 1];
                    //from a to p
                    var dx = ax - x;
                    var dy = ay - y;
                    //edge normal (a-b)
                    var nx = by - ay;
                    var ny = -(bx - ax);
                    var dot = (dx * nx) + (dy * ny);
                    if (dot > 0)
                        continue;
                    dx = bx - x;
                    dy = by - y;
                    nx = cy - by;
                    ny = -(cx - bx);
                    dot = (dx * nx) + (dy * ny);
                    if (dot > 0)
                        continue;
                    dx = cx - x;
                    dy = cy - y;
                    nx = ay - cy;
                    ny = -(ax - cx);
                    dot = (dx * nx) + (dy * ny);
                    if (dot > 0)
                        continue;
                    if (curves) {
                        //check if not solid
                        if (curves[id0 * curveStride + 2] != -128) {
                            var v0x = bx - ax;
                            var v0y = by - ay;
                            var v1x = cx - ax;
                            var v1y = cy - ay;
                            var v2x = x - ax;
                            var v2y = y - ay;
                            var den = v0x * v1y - v1x * v0y;
                            var v = (v2x * v1y - v1x * v2y) / den;
                            var w = (v0x * v2y - v2x * v0y) / den;
                            //var u:number = 1 - v - w;	//commented out as inlined away
                            //here be dragons
                            var uu = 0.5 * v + w;
                            var vv = w;
                            var d = uu * uu - vv;
                            var az = curves[id0 * curveStride];
                            if (d > 0 && az == -128) {
                                continue;
                            }
                            else if (d < 0 && az == 127) {
                                continue;
                            }
                        }
                    }
                    hitTestCache.lastCollisionIndex = k;
                    return true;
                }
                hitTestCache.lastCollisionIndex = -1;
                return false;
            }
            //brute force
            for (var k = 0; k < len; k += 3) {
                if (indices) {
                    id2 = indices[k];
                }
                else {
                    id2 = k;
                }
                if (id2 == index)
                    continue;
                if (indices) {
                    id0 = indices[k + 2];
                    id1 = indices[k + 1];
                }
                else {
                    id0 = k + 2;
                    id1 = k + 1;
                }
                ax = positions[id0 * posStride];
                ay = positions[id0 * posStride + 1];
                bx = positions[id1 * posStride];
                by = positions[id1 * posStride + 1];
                cx = positions[id2 * posStride];
                cy = positions[id2 * posStride + 1];
                //from a to p
                var dx = ax - x;
                var dy = ay - y;
                //edge normal (a-b)
                var nx = by - ay;
                var ny = -(bx - ax);
                var dot = (dx * nx) + (dy * ny);
                if (dot > 0)
                    continue;
                dx = bx - x;
                dy = by - y;
                nx = cy - by;
                ny = -(cx - bx);
                dot = (dx * nx) + (dy * ny);
                if (dot > 0)
                    continue;
                dx = cx - x;
                dy = cy - y;
                nx = ay - cy;
                ny = -(ax - cx);
                dot = (dx * nx) + (dy * ny);
                if (dot > 0)
                    continue;
                if (curves) {
                    //check if not solid
                    if (curves[id0 * curveStride + 2] != -128) {
                        var v0x = bx - ax;
                        var v0y = by - ay;
                        var v1x = cx - ax;
                        var v1y = cy - ay;
                        var v2x = x - ax;
                        var v2y = y - ay;
                        var den = v0x * v1y - v1x * v0y;
                        var v = (v2x * v1y - v1x * v2y) / den;
                        var w = (v0x * v2y - v2x * v0y) / den;
                        //var u:number = 1 - v - w;	//commented out as inlined away
                        //here be dragons
                        var uu = 0.5 * v + w;
                        var vv = w;
                        var d = uu * uu - vv;
                        var az = curves[id0 * curveStride];
                        if (d > 0 && az == -128) {
                            continue;
                        }
                        else if (d < 0 && az == 127) {
                            continue;
                        }
                    }
                }
                hitTestCache.lastCollisionIndex = k;
                return true;
            }
            hitTestCache.lastCollisionIndex = -1;
            return false;
        };
        TriangleElementsUtils.getBoxBounds = function (positionAttributes, indexAttributes, matrix3D, cache, target, count, offset) {
            if (offset === void 0) { offset = 0; }
            var positions;
            var posDim = positionAttributes.dimensions;
            var posStride = positionAttributes.stride;
            var minX = 0, minY = 0, minZ = 0;
            var maxX = 0, maxY = 0, maxZ = 0;
            var indices;
            var len;
            if (indexAttributes) {
                len = count * indexAttributes.dimensions;
                indices = indexAttributes.get(count, offset);
                positions = positionAttributes.get(positionAttributes.count);
            }
            else {
                len = count;
                positions = positionAttributes.get(count, offset);
            }
            if (len == 0)
                return target;
            var i = 0;
            var index;
            var pos1, pos2, pos3, rawData;
            if (matrix3D)
                rawData = matrix3D._rawData;
            if (target == null) {
                target = cache || new Box();
                index = (indices) ? indices[i] * posStride : i * posStride;
                if (matrix3D) {
                    if (posDim == 3) {
                        pos1 = positions[index] * rawData[0] + positions[index + 1] * rawData[4] + positions[index + 2] * rawData[8] + rawData[12];
                        pos2 = positions[index] * rawData[1] + positions[index + 1] * rawData[5] + positions[index + 2] * rawData[9] + rawData[13];
                        pos3 = positions[index] * rawData[2] + positions[index + 1] * rawData[6] + positions[index + 2] * rawData[10] + rawData[14];
                    }
                    else {
                        pos1 = positions[index] * rawData[0] + positions[index + 1] * rawData[4] + rawData[12];
                        pos2 = positions[index] * rawData[1] + positions[index + 1] * rawData[5] + rawData[13];
                    }
                }
                else {
                    pos1 = positions[index];
                    pos2 = positions[index + 1];
                    pos3 = (posDim == 3) ? positions[index + 2] : 0;
                }
                maxX = minX = pos1;
                maxY = minY = pos2;
                maxZ = minZ = (posDim == 3) ? pos3 : 0;
                i++;
            }
            else {
                maxX = (minX = target.x) + target.width;
                maxY = (minY = target.y) + target.height;
                maxZ = (minZ = target.z) + target.depth;
            }
            for (; i < len; i++) {
                index = (indices) ? indices[i] * posStride : i * posStride;
                if (matrix3D) {
                    if (posDim == 3) {
                        pos1 = positions[index] * rawData[0] + positions[index + 1] * rawData[4] + positions[index + 2] * rawData[8] + rawData[12];
                        pos2 = positions[index] * rawData[1] + positions[index + 1] * rawData[5] + positions[index + 2] * rawData[9] + rawData[13];
                        pos3 = positions[index] * rawData[2] + positions[index + 1] * rawData[6] + positions[index + 2] * rawData[10] + rawData[14];
                    }
                    else {
                        pos1 = positions[index] * rawData[0] + positions[index + 1] * rawData[4] + rawData[12];
                        pos2 = positions[index] * rawData[1] + positions[index + 1] * rawData[5] + rawData[13];
                    }
                }
                else {
                    pos1 = positions[index];
                    pos2 = positions[index + 1];
                    pos3 = (posDim == 3) ? positions[index + 2] : 0;
                }
                if (pos1 < minX)
                    minX = pos1;
                else if (pos1 > maxX)
                    maxX = pos1;
                if (pos2 < minY)
                    minY = pos2;
                else if (pos2 > maxY)
                    maxY = pos2;
                if (posDim == 3) {
                    if (pos3 < minZ)
                        minZ = pos3;
                    else if (pos3 > maxZ)
                        maxZ = pos3;
                }
            }
            target.width = maxX - (target.x = minX);
            target.height = maxY - (target.y = minY);
            target.depth = maxZ - (target.z = minZ);
            return target;
        };
        TriangleElementsUtils.getSphereBounds = function (positionAttributes, center, matrix3D, cache, output, count, offset) {
            if (offset === void 0) { offset = 0; }
            var positions = positionAttributes.get(count, offset);
            var posDim = positionAttributes.dimensions;
            var posStride = positionAttributes.stride;
            var maxRadiusSquared = 0;
            var radiusSquared;
            var len = count * posStride;
            var distanceX;
            var distanceY;
            var distanceZ;
            for (var i = 0; i < len; i += posStride) {
                distanceX = positions[i] - center.x;
                distanceY = positions[i + 1] - center.y;
                distanceZ = (posDim == 3) ? positions[i + 2] - center.z : -center.z;
                radiusSquared = distanceX * distanceX + distanceY * distanceY + distanceZ * distanceZ;
                if (maxRadiusSquared < radiusSquared)
                    maxRadiusSquared = radiusSquared;
            }
            if (output == null)
                output = new Sphere();
            output.x = center.x;
            output.y = center.y;
            output.z = center.z;
            output.radius = Math.sqrt(maxRadiusSquared);
            return output;
        };
        TriangleElementsUtils.updateTriangleGraphicsSlice9 = function (triangleElements, originalRect, scaleX, scaleY, init, copy) {
            // todo: for now this only works for Float2Attributes.
            if (init === void 0) { init = false; }
            if (copy === void 0) { copy = false; }
            if (triangleElements.slice9Indices.length != 9) {
                throw ("ElementUtils: Error - triangleElement does not provide valid slice9Indices!");
            }
            var s_len = triangleElements.slice9Indices.length;
            var innerWidth = originalRect.width - (triangleElements.slice9offsets.x + triangleElements.slice9offsets.width) / scaleX;
            var innerHeight = originalRect.height - (triangleElements.slice9offsets.y + triangleElements.slice9offsets.height) / scaleY;
            if (innerWidth < 0) {
                innerWidth = 0;
                scaleX = (triangleElements.slice9offsets.x + triangleElements.slice9offsets.width) / originalRect.width;
            }
            if (innerHeight < 0) {
                innerHeight = 0;
                scaleY = (triangleElements.slice9offsets.y + triangleElements.slice9offsets.height) / originalRect.height;
            }
            var newElem;
            var positions;
            if (copy) {
                var newverts = new Uint8Array(triangleElements.positions.count * 8);
                while (v < triangleElements.positions.count * 2) {
                    newverts[v] = positions[v++];
                    newverts[v] = positions[v++];
                }
                var vertexBuffer = new AttributesBuffer(8, triangleElements.positions.count);
                vertexBuffer.bufferView = newverts;
                var newElem = new TriangleElements(vertexBuffer);
                newElem.setPositions(new Float2Attributes(vertexBuffer));
                newElem.slice9offsets = triangleElements.slice9offsets;
                newElem.initialSlice9Positions = triangleElements.initialSlice9Positions;
                newElem.slice9Indices = triangleElements.slice9Indices;
                positions = newElem.positions.get(newElem.positions.count);
                v = 0;
            }
            else {
                positions = triangleElements.positions.get(triangleElements.positions.count);
            }
            // todo: i had trouble when just cloning the positions 
            //	for now i just create the initialSlice9Positions by iterating the positions
            var v = 0;
            var init_positions;
            if (init) {
                init_positions = [];
                init_positions.length = triangleElements.positions.count * 2;
                while (v < triangleElements.positions.count * 2) {
                    init_positions[v] = positions[v++];
                    init_positions[v] = positions[v++];
                }
                triangleElements.initialSlice9Positions = init_positions;
            }
            else {
                init_positions = triangleElements.initialSlice9Positions;
            }
            var slice9Indices = triangleElements.slice9Indices;
            var s = 0;
            v = 0;
            var slice9Offsets_x = [];
            slice9Offsets_x.length = 3;
            var slice9Offsets_y = [];
            slice9Offsets_y.length = 3;
            slice9Offsets_x[0] = originalRect.x;
            slice9Offsets_x[1] = originalRect.x + triangleElements.slice9offsets.x / scaleX;
            slice9Offsets_x[2] = originalRect.x + triangleElements.slice9offsets.x / scaleX + innerWidth;
            slice9Offsets_y[0] = originalRect.y;
            slice9Offsets_y[1] = originalRect.y + triangleElements.slice9offsets.y / scaleY;
            slice9Offsets_y[2] = originalRect.y + triangleElements.slice9offsets.y / scaleY + innerHeight;
            //console.log("slice9Offsets_x",slice9Offsets_x);
            //console.log("slice9Offsets_y",slice9Offsets_x);
            var row_cnt = -1;
            var col_cnt = 0;
            var scalex = 0;
            var scaley = 0;
            var offsetx = 0;
            var offsety = 0;
            // iterating over the 9 chunks - keep in mind that we are constructing a 3x3 grid:
            for (s = 0; s < s_len; s++) {
                // keep track of column and row index
                if (row_cnt == 2) {
                    col_cnt++;
                    row_cnt = -1;
                }
                row_cnt++;
                // only need to x-scale if this is the middle column
                // if the innerWidth<=0 we can skip this complete column
                if (col_cnt == 1) {
                    scalex = innerWidth;
                }
                else {
                    scalex = 1 / scaleX;
                }
                // only need to y-scale if this is the middle row
                // if the innerHeight<=0 we can skip this complete row
                if (row_cnt == 1) {
                    scaley = innerHeight;
                }
                else {
                    scaley = 1 / scaleY;
                }
                // offsetx is different for each column
                offsetx = slice9Offsets_x[col_cnt];
                // offsety is different for each row
                offsety = slice9Offsets_y[row_cnt];
                // iterate the verts and apply the translation / scale
                while (v < slice9Indices[s]) {
                    positions[v] = offsetx + (init_positions[v++] * scalex);
                    positions[v] = offsety + (init_positions[v++] * scaley);
                }
            }
            //console.log("positions",positions);
            if (copy) {
                newElem.positions.invalidate();
                return newElem;
            }
            triangleElements.positions.invalidate();
            return triangleElements;
        };
        return TriangleElementsUtils;
    }());

    /**
     * @class away.base.TriangleElements
     */
    var ElementsBase = /** @class */ (function (_super) {
        __extends$5(ElementsBase, _super);
        /**
         *
         */
        function ElementsBase(concatenatedBuffer) {
            if (concatenatedBuffer === void 0) { concatenatedBuffer = null; }
            var _this = _super.call(this) || this;
            _this._customAttributesNames = new Array();
            _this._customAttributes = new Object();
            _this._autoDeriveNormals = true;
            _this._autoDeriveTangents = true;
            _this._numElements = 0;
            _this._numVertices = 0;
            _this._verticesDirty = new Object();
            _this._invalidateVertices = new Object();
            _this.usages = 0;
            _this._concatenatedBuffer = concatenatedBuffer;
            return _this;
        }
        Object.defineProperty(ElementsBase.prototype, "concatenatedBuffer", {
            get: function () {
                return this._concatenatedBuffer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ElementsBase.prototype, "indices", {
            /**
             * The raw index data that define the faces.
             */
            get: function () {
                return this._indices;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        ElementsBase.prototype.getCustomAtributesNames = function () {
            return this._customAttributesNames;
        };
        /**
         *
         */
        ElementsBase.prototype.getCustomAtributes = function (name) {
            return this._customAttributes[name];
        };
        Object.defineProperty(ElementsBase.prototype, "numElements", {
            /**
             * The total amount of triangles in the TriangleElements.
             */
            get: function () {
                return this._numElements;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ElementsBase.prototype, "numVertices", {
            get: function () {
                return this._numVertices;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ElementsBase.prototype, "condensedIndexLookUp", {
            get: function () {
                return this._condensedIndexLookUp;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ElementsBase.prototype, "autoDeriveNormals", {
            /**
             * True if the vertex normals should be derived from the geometry, false if the vertex normals are set
             * explicitly.
             */
            get: function () {
                return this._autoDeriveNormals;
            },
            set: function (value) {
                if (this._autoDeriveNormals == value)
                    return;
                this._autoDeriveNormals = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ElementsBase.prototype, "autoDeriveTangents", {
            /**
             * True if the vertex tangents should be derived from the geometry, false if the vertex normals are set
             * explicitly.
             */
            get: function () {
                return this._autoDeriveTangents;
            },
            set: function (value) {
                if (this._autoDeriveTangents == value)
                    return;
                this._autoDeriveTangents = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ElementsBase.prototype, "useCondensedIndices", {
            /**
             * Offers the option of enabling GPU accelerated animation on skeletons larger than 32 joints
             * by condensing the number of joint index values required per sprite. Only applicable to
             * skeleton animations that utilise more than one sprite object. Defaults to false.
             */
            get: function () {
                return this._useCondensedIndices;
            },
            set: function (value) {
                if (this._useCondensedIndices == value)
                    return;
                this._useCondensedIndices = value;
            },
            enumerable: true,
            configurable: true
        });
        ElementsBase.prototype.copyTo = function (elements) {
            if (this.indices)
                elements.setIndices(this.indices.clone());
            for (var name in this._customAttributes)
                elements.setCustomAttributes(name, this.getCustomAtributes(name).clone());
        };
        /**
         *
         */
        ElementsBase.prototype.dispose = function () {
            this.clear();
            if (this._indices) {
                this._indices.dispose();
                this._indices = null;
            }
            for (var name in this._customAttributes) {
                this._customAttributes[name].dispose();
                delete this._customAttributes;
            }
        };
        ElementsBase.prototype.setIndices = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            if (values instanceof Short3Attributes) {
                if (this._indices)
                    this.clearIndices();
                this._indices = values;
            }
            else if (values) {
                if (!this._indices)
                    this._indices = new Short3Attributes();
                this._indices.set(values, offset);
            }
            else if (this._indices) {
                this._indices.dispose();
                this._indices = null;
                this.clearIndices();
            }
            if (this._indices) {
                this._numElements = this._indices.count;
                this.invalidateIndices();
            }
            else {
                this._numElements = 0;
            }
        };
        ElementsBase.prototype.setCustomAttributes = function (name, values, offset) {
            if (offset === void 0) { offset = 0; }
            if (values == this._customAttributes[name])
                return;
            if (values instanceof AttributesView) {
                this.clearVertices(this._customAttributes[name]);
                this._customAttributes[name] = values;
            }
            else if (values) {
                if (!this._customAttributes[name])
                    this._customAttributes[name] = new Float3Attributes(this._concatenatedBuffer); //default custom atrributes is Float3
                this._customAttributes[name].set(values, offset);
            }
            else if (this._customAttributes[name]) {
                this.clearVertices(this._customAttributes[name]);
                this._customAttributesNames.splice(this._customAttributesNames.indexOf(name), 1);
                delete this._customAttributes[name];
                return;
            }
            this.invalidateVertices(this._customAttributes[name]);
            this._verticesDirty[this._customAttributes[name].id] = false;
            if (this._customAttributesNames.indexOf(name) == -1)
                this._customAttributesNames.push(name);
        };
        /**
         * Clones the current object
         * @return An exact duplicate of the current object.
         */
        ElementsBase.prototype.clone = function () {
            throw new AbstractMethodError();
        };
        ElementsBase.prototype.applyTransformation = function (transform, count, offset) {
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            throw new AbstractMethodError();
        };
        /**
         * Scales the geometry.
         * @param scale The amount by which to scale.
         */
        ElementsBase.prototype.scale = function (scale, count, offset) {
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            throw new AbstractMethodError();
        };
        ElementsBase.prototype.scaleUV = function (scaleU, scaleV, count, offset) {
            if (scaleU === void 0) { scaleU = 1; }
            if (scaleV === void 0) { scaleV = 1; }
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            throw new AbstractMethodError();
        };
        ElementsBase.prototype.getBoxBounds = function (view, entity, strokeFlag, matrix3D, cache, target, count, offset) {
            if (entity === void 0) { entity = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (matrix3D === void 0) { matrix3D = null; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            throw new AbstractMethodError();
        };
        ElementsBase.prototype.getSphereBounds = function (view, center, matrix3D, strokeFlag, cache, target, count, offset) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            throw new AbstractMethodError();
        };
        ElementsBase.prototype.hitTestPoint = function (view, entity, x, y, z, box, count, offset) {
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            throw new AbstractMethodError();
        };
        ElementsBase.prototype.invalidateIndices = function () {
            if (!this._invalidateIndices)
                this._invalidateIndices = new ElementsEvent(ElementsEvent.INVALIDATE_INDICES, this._indices);
            this.dispatchEvent(this._invalidateIndices);
        };
        ElementsBase.prototype.clearIndices = function () {
            this.dispatchEvent(new ElementsEvent(ElementsEvent.CLEAR_INDICES, this._indices));
        };
        ElementsBase.prototype.invalidateVertices = function (attributesView) {
            if (!attributesView || this._verticesDirty[attributesView.id])
                return;
            this._verticesDirty[attributesView.id] = true;
            if (!this._invalidateVertices[attributesView.id])
                this._invalidateVertices[attributesView.id] = new ElementsEvent(ElementsEvent.INVALIDATE_VERTICES, attributesView);
            this.dispatchEvent(this._invalidateVertices[attributesView.id]);
        };
        ElementsBase.prototype.clearVertices = function (attributesView) {
            if (!attributesView)
                return;
            attributesView.dispose();
            this.dispatchEvent(new ElementsEvent(ElementsEvent.CLEAR_VERTICES, attributesView));
            this._verticesDirty[attributesView.id] = null;
            this._invalidateVertices[attributesView.id] = null;
        };
        ElementsBase.prototype.testCollision = function (view, collision, box, closestFlag, material, count, offset) {
            if (offset === void 0) { offset = 0; }
            throw new AbstractMethodError();
        };
        return ElementsBase;
    }(AssetBase));

    /**
     * @class away.base.TriangleElements
     */
    var TriangleElements = /** @class */ (function (_super) {
        __extends$5(TriangleElements, _super);
        function TriangleElements() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._faceNormalsDirty = true;
            _this._faceTangentsDirty = true;
            //used for hittesting geometry
            _this.hitTestCache = new Object();
            return _this;
        }
        TriangleElements.prototype.updateSlice9 = function (width, height) {
        };
        Object.defineProperty(TriangleElements.prototype, "assetType", {
            get: function () {
                return TriangleElements.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TriangleElements.prototype, "jointsPerVertex", {
            /**
             *
             */
            get: function () {
                return this._jointsPerVertex;
            },
            set: function (value) {
                if (this._jointsPerVertex == value)
                    return;
                this._jointsPerVertex = value;
                if (this._jointIndices)
                    this._jointIndices.dimensions = this._jointsPerVertex;
                if (this._jointWeights)
                    this._jointWeights.dimensions = this._jointsPerVertex;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TriangleElements.prototype, "positions", {
            /**
             *
             */
            get: function () {
                if (!this._positions)
                    this.setPositions(new Float3Attributes(this._concatenatedBuffer));
                return this._positions;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TriangleElements.prototype, "normals", {
            /**
             *
             */
            get: function () {
                if (!this._normals || this._verticesDirty[this._normals.id])
                    this.setNormals(this._normals);
                return this._normals;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TriangleElements.prototype, "tangents", {
            /**
             *
             */
            get: function () {
                if (!this._tangents || this._verticesDirty[this._tangents.id])
                    this.setTangents(this._tangents);
                return this._tangents;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TriangleElements.prototype, "faceNormals", {
            /**
             * The raw data of the face normals, in the same order as the faces are listed in the index list.
             */
            get: function () {
                if (this._faceNormalsDirty)
                    this.updateFaceNormals();
                return this._faceNormals;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TriangleElements.prototype, "faceTangents", {
            /**
             * The raw data of the face tangets, in the same order as the faces are listed in the index list.
             */
            get: function () {
                if (this._faceTangentsDirty)
                    this.updateFaceTangents();
                return this._faceTangents;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TriangleElements.prototype, "uvs", {
            /**
             *
             */
            get: function () {
                if (!this._uvs && TriangleElements.isIE) {
                    var attributesView2 = new AttributesView(Float32Array, 2);
                    attributesView2.set(this._positions.get(this._positions.count));
                    var attributesBuffer2 = attributesView2.attributesBuffer;
                    this._uvs = new Float2Attributes(attributesBuffer2);
                    attributesView2.dispose();
                }
                return this._uvs;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TriangleElements.prototype, "jointIndices", {
            /**
             *
             */
            get: function () {
                return this._jointIndices;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TriangleElements.prototype, "jointWeights", {
            /**
             *
             */
            get: function () {
                return this._jointWeights;
            },
            enumerable: true,
            configurable: true
        });
        TriangleElements.prototype.getBoxBounds = function (view, entity, strokeFlag, matrix3D, cache, target, count, offset) {
            if (entity === void 0) { entity = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (matrix3D === void 0) { matrix3D = null; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            return TriangleElementsUtils.getBoxBounds(this.positions, this.indices, matrix3D, cache, target, count || this._numElements || this._numVertices, offset);
        };
        TriangleElements.prototype.getSphereBounds = function (view, center, matrix3D, strokeFlag, cache, target, count, offset) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            return TriangleElementsUtils.getSphereBounds(this.positions, center, matrix3D, cache, target, count || this._numVertices, offset);
        };
        TriangleElements.prototype.hitTestPoint = function (view, entity, x, y, z, box, count, offset, idx_count, idx_offset) {
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            if (idx_count === void 0) { idx_count = 0; }
            if (idx_offset === void 0) { idx_offset = 0; }
            return TriangleElementsUtils.hitTest(x, y, 0, box, this, count || this._numElements || this._numVertices, offset);
        };
        TriangleElements.prototype.setPositions = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            if (values == this._positions)
                return;
            if (values instanceof AttributesView) {
                this.clearVertices(this._positions);
                this._positions = values;
            }
            else if (values) {
                if (!this._positions)
                    this._positions = new Float3Attributes(this._concatenatedBuffer);
                this._positions.set(values, offset);
            }
            else {
                this.clearVertices(this._positions);
                this._positions = new Float3Attributes(this._concatenatedBuffer); //positions cannot be null
            }
            this._numVertices = this._positions.count;
            if (this._autoDeriveNormals)
                this.invalidateVertices(this._normals);
            if (this._autoDeriveTangents)
                this.invalidateVertices(this._tangents);
            this.invalidateVertices(this._positions);
            this._verticesDirty[this._positions.id] = false;
        };
        TriangleElements.prototype.setNormals = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            if (!this._autoDeriveNormals) {
                if (values == this._normals)
                    return;
                if (values instanceof Float3Attributes) {
                    this.clearVertices(this._normals);
                    this._normals = values;
                }
                else if (values) {
                    if (!this._normals)
                        this._normals = new Float3Attributes(this._concatenatedBuffer);
                    this._normals.set(values, offset);
                }
                else if (this._normals) {
                    this.clearVertices(this._normals);
                    this._normals = null;
                    return;
                }
            }
            else {
                this._normals = ElementsUtils.generateNormals(this.indices, this.faceNormals, this._normals, this._concatenatedBuffer);
            }
            this.invalidateVertices(this._normals);
            this._verticesDirty[this._normals.id] = false;
        };
        TriangleElements.prototype.setTangents = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            if (!this._autoDeriveTangents) {
                if (values == this._tangents)
                    return;
                if (values instanceof Float3Attributes) {
                    this.clearVertices(this._tangents);
                    this._tangents = values;
                }
                else if (values) {
                    if (!this._tangents)
                        this._tangents = new Float3Attributes(this._concatenatedBuffer);
                    this._tangents.set(values, offset);
                }
                else if (this._tangents) {
                    this.clearVertices(this._tangents);
                    this._tangents = null;
                    return;
                }
            }
            else {
                this._tangents = ElementsUtils.generateTangents(this.indices, this.faceTangents, this.faceNormals, this._tangents, this._concatenatedBuffer);
            }
            this.invalidateVertices(this._tangents);
            this._verticesDirty[this._tangents.id] = false;
        };
        TriangleElements.prototype.setUVs = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            if (values == this._uvs)
                return;
            if (values instanceof AttributesView) {
                this.clearVertices(this._uvs);
                this._uvs = values;
            }
            else if (values) {
                if (!this._uvs)
                    this._uvs = new Float2Attributes(this._concatenatedBuffer);
                this._uvs.set(values, offset);
            }
            else if (this._uvs) {
                this.clearVertices(this._uvs);
                this._uvs = null;
                return;
            }
            this.invalidateVertices(this._uvs);
            this._verticesDirty[this._uvs.id] = false;
        };
        TriangleElements.prototype.setJointIndices = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            if (values == this._jointIndices)
                return;
            if (values instanceof AttributesView) {
                this.clearVertices(this._jointIndices);
                this._jointIndices = values;
            }
            else if (values) {
                if (!this._jointIndices)
                    this._jointIndices = new AttributesView(Float32Array, this._jointsPerVertex, this._concatenatedBuffer);
                if (this._useCondensedIndices) {
                    var i = 0;
                    var oldIndex;
                    var newIndex = 0;
                    var dic = new Object();
                    this._condensedIndexLookUp = new Array();
                    while (i < values.length) {
                        oldIndex = values[i];
                        // if we encounter a new index, assign it a new condensed index
                        if (dic[oldIndex] == undefined) {
                            dic[oldIndex] = newIndex;
                            this._condensedIndexLookUp[newIndex++] = oldIndex;
                        }
                        //reset value to dictionary lookup
                        values[i++] = dic[oldIndex];
                    }
                }
                this._jointIndices.set(values, offset);
            }
            else if (this._jointIndices) {
                this.clearVertices(this._jointIndices);
                this._jointIndices = null;
                return;
            }
            this.invalidateVertices(this._jointIndices);
            this._verticesDirty[this._jointIndices.id] = false;
        };
        TriangleElements.prototype.setJointWeights = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            if (values == this._jointWeights)
                return;
            if (values instanceof AttributesView) {
                this.clearVertices(this._jointWeights);
                this._jointWeights = values;
            }
            else if (values) {
                if (!this._jointWeights)
                    this._jointWeights = new AttributesView(Float32Array, this._jointsPerVertex, this._concatenatedBuffer);
                this._jointWeights.set(values, offset);
            }
            else if (this._jointWeights) {
                this.clearVertices(this._jointWeights);
                this._jointWeights = null;
                return;
            }
            this.invalidateVertices(this._jointWeights);
            this._verticesDirty[this._jointWeights.id] = false;
        };
        /**
         *
         */
        TriangleElements.prototype.dispose = function () {
            _super.prototype.dispose.call(this);
            if (this._positions) {
                this._positions.dispose();
                this._positions = null;
            }
            if (this._normals) {
                this._normals.dispose();
                this._normals = null;
            }
            if (this._tangents) {
                this._tangents.dispose();
                this._tangents = null;
            }
            if (this._uvs) {
                this._uvs.dispose();
                this._uvs = null;
            }
            if (this._jointIndices) {
                this._jointIndices.dispose();
                this._jointIndices = null;
            }
            if (this._jointWeights) {
                this._jointWeights.dispose();
                this._jointWeights = null;
            }
            if (this._faceNormals) {
                this._faceNormals.dispose();
                this._faceNormals = null;
            }
            if (this._faceTangents) {
                this._faceTangents.dispose();
                this._faceTangents = null;
            }
        };
        TriangleElements.prototype.setIndices = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            _super.prototype.setIndices.call(this, values, offset);
            this._faceNormalsDirty = true;
            this._faceTangentsDirty = true;
            if (this._autoDeriveNormals)
                this.invalidateVertices(this._normals);
            if (this._autoDeriveTangents)
                this.invalidateVertices(this._tangents);
        };
        TriangleElements.prototype.copyTo = function (elements) {
            _super.prototype.copyTo.call(this, elements);
            //temp disable auto derives
            var autoDeriveNormals = this._autoDeriveNormals;
            var autoDeriveTangents = this._autoDeriveTangents;
            elements.autoDeriveNormals = this._autoDeriveNormals = false;
            elements.autoDeriveTangents = this._autoDeriveTangents = false;
            elements.setPositions(this.positions.clone());
            if (this.normals)
                elements.setNormals(this.normals.clone());
            if (this.tangents)
                elements.setTangents(this.tangents.clone());
            if (this.uvs)
                elements.setUVs(this.uvs.clone());
            elements.jointsPerVertex = this._jointsPerVertex;
            if (this.jointIndices)
                elements.setJointIndices(this.jointIndices.clone());
            if (this.jointWeights)
                elements.setJointWeights(this.jointWeights.clone());
            //return auto derives to cloned values
            elements.autoDeriveNormals = this._autoDeriveNormals = autoDeriveNormals;
            elements.autoDeriveTangents = this._autoDeriveTangents = autoDeriveTangents;
            if (this.slice9Indices) {
                elements.originalSlice9Size = this.originalSlice9Size;
                elements.slice9offsets = this.slice9offsets;
                elements.slice9Indices = this.slice9Indices;
                elements.initialSlice9Positions = this.initialSlice9Positions;
            }
        };
        /**
         * Clones the current object
         * @return An exact duplicate of the current object.
         */
        TriangleElements.prototype.clone = function () {
            var clone = new TriangleElements(this._concatenatedBuffer ? this._concatenatedBuffer.clone() : null);
            this.copyTo(clone);
            return clone;
        };
        TriangleElements.prototype.scaleUV = function (scaleU, scaleV, count, offset) {
            if (scaleU === void 0) { scaleU = 1; }
            if (scaleV === void 0) { scaleV = 1; }
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            if (this.uvs) // only scale if uvs exist
                ElementsUtils.scale(scaleU, scaleV, 0, this.uvs, count || this._numVertices, offset);
        };
        /**
         * Scales the geometry.
         * @param scale The amount by which to scale.
         */
        TriangleElements.prototype.scale = function (scale, count, offset) {
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            ElementsUtils.scale(scale, scale, scale, this.positions, count || this._numVertices, offset);
        };
        TriangleElements.prototype.applyTransformation = function (transform, count, offset) {
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            ElementsUtils.applyTransformation(transform, this.positions, this.normals, this.tangents, count || this._numVertices, offset);
        };
        /**
         * Updates the tangents for each face.
         */
        TriangleElements.prototype.updateFaceTangents = function () {
            this._faceTangents = ElementsUtils.generateFaceTangents(this.indices, this.positions, this.uvs || this.positions, this._faceTangents, this.numElements);
            this._faceTangentsDirty = false;
        };
        /**
         * Updates the normals for each face.
         */
        TriangleElements.prototype.updateFaceNormals = function () {
            this._faceNormals = ElementsUtils.generateFaceNormals(this.indices, this.positions, this._faceNormals, this.numElements);
            this._faceNormalsDirty = false;
        };
        TriangleElements.prototype.testCollision = function (view, collision, box, closestFlag, material, count, offset) {
            if (offset === void 0) { offset = 0; }
            var rayPosition = collision.rayPosition;
            var rayDirection = collision.rayDirection;
            var t;
            var i0, i1, i2;
            var rx, ry, rz;
            var nx, ny, nz;
            var cx, cy, cz;
            var coeff, u, v, w;
            var p0x, p0y, p0z;
            var p1x, p1y, p1z;
            var p2x, p2y, p2z;
            var s0x, s0y, s0z;
            var s1x, s1y, s1z;
            var nl, nDotV, D, disToPlane;
            var Q1Q2, Q1Q1, Q2Q2, RQ1, RQ2;
            var collisionTriangleIndex = -1;
            var bothSides = material.bothSides;
            var positions = this.positions.get(count, offset);
            var posDim = this.positions.dimensions;
            var posStride = this.positions.stride;
            var indices;
            if (this.indices) {
                indices = this.indices.get(this.numElements);
                count = indices.length;
            }
            for (var index = 0; index < count; index += 3) { // sweep all triangles
                // evaluate triangle indices
                if (indices) {
                    i0 = indices[index] * posStride;
                    i1 = indices[index + 1] * posStride;
                    i2 = indices[index + 2] * posStride;
                }
                else {
                    i0 = index * posStride;
                    i1 = (index + 1) * posStride;
                    i2 = (index + 2) * posStride;
                }
                // evaluate triangle positions
                p0x = positions[i0];
                p1x = positions[i1];
                p2x = positions[i2];
                s0x = p1x - p0x; // s0 = p1 - p0
                s1x = p2x - p0x; // s1 = p2 - p0
                p0y = positions[i0 + 1];
                p1y = positions[i1 + 1];
                p2y = positions[i2 + 1];
                s0y = p1y - p0y;
                s1y = p2y - p0y;
                if (posDim == 3) {
                    p0z = positions[i0 + 2];
                    p1z = positions[i1 + 2];
                    p2z = positions[i2 + 2];
                    s0z = p1z - p0z;
                    s1z = p2z - p0z;
                    // evaluate sides and triangle normal
                    nx = s0y * s1z - s0z * s1y; // n = s0 x s1
                    ny = s0z * s1x - s0x * s1z;
                    nz = s0x * s1y - s0y * s1x;
                    nl = 1 / Math.sqrt(nx * nx + ny * ny + nz * nz); // normalize n
                    nx *= nl;
                    ny *= nl;
                    nz *= nl;
                }
                else { //2d hittest
                    p0z = 0;
                    p1z = 0;
                    s0z = 0;
                    s1z = 0;
                    nx = 0;
                    ny = 0;
                    nz = ((s0x * s1y - s0y * s1x) > 0) ? 1 : -1;
                }
                // -- plane intersection test --
                nDotV = nx * rayDirection.x + ny * +rayDirection.y + nz * rayDirection.z; // rayDirection . normal
                if ((!bothSides && nDotV < 0.0) || (bothSides && nDotV != 0.0)) { // an intersection must exist
                    // find collision t
                    D = -(nx * p0x + ny * p0y + nz * p0z);
                    disToPlane = -(nx * rayPosition.x + ny * rayPosition.y + nz * rayPosition.z + D);
                    t = disToPlane / nDotV;
                    // find collision point
                    cx = rayPosition.x + t * rayDirection.x;
                    cy = rayPosition.y + t * rayDirection.y;
                    cz = rayPosition.z + t * rayDirection.z;
                    // collision point inside triangle? ( using barycentric coordinates )
                    Q1Q2 = s0x * s1x + s0y * s1y + s0z * s1z;
                    Q1Q1 = s0x * s0x + s0y * s0y + s0z * s0z;
                    Q2Q2 = s1x * s1x + s1y * s1y + s1z * s1z;
                    rx = cx - p0x;
                    ry = cy - p0y;
                    rz = cz - p0z;
                    RQ1 = rx * s0x + ry * s0y + rz * s0z;
                    RQ2 = rx * s1x + ry * s1y + rz * s1z;
                    coeff = 1 / (Q1Q1 * Q2Q2 - Q1Q2 * Q1Q2);
                    if (!isFinite(coeff))
                        continue;
                    v = coeff * (Q2Q2 * RQ1 - Q1Q2 * RQ2);
                    w = coeff * (-Q1Q2 * RQ1 + Q1Q1 * RQ2);
                    if (v < 0)
                        continue;
                    if (w < 0)
                        continue;
                    u = 1 - v - w;
                    if (!(u < 0) && t > 0 && t < collision.rayEntryDistance) { // all tests passed
                        collisionTriangleIndex = index / 3;
                        collision.rayEntryDistance = t;
                        collision.position = new Vector3D(cx, cy, cz);
                        collision.normal = new Vector3D(nx, ny, nz);
                        if (this.uvs) { //uv calculations
                            var uvs = this.uvs.get(this.numVertices);
                            var uvStride = this.uvs.stride;
                            var uIndex = indices ? indices[index] * uvStride : index * uvStride;
                            var uv0 = new Vector3D(uvs[uIndex], uvs[uIndex + 1]);
                            uIndex = indices ? indices[index + 1] * uvStride : (index + 1) * uvStride;
                            var uv1 = new Vector3D(uvs[uIndex], uvs[uIndex + 1]);
                            uIndex = indices ? indices[index + 2] * uvStride : (index + 2) * uvStride;
                            var uv2 = new Vector3D(uvs[uIndex], uvs[uIndex + 1]);
                            collision.uv = new Point(u * uv0.x + v * uv1.x + w * uv2.x, u * uv0.y + v * uv1.y + w * uv2.y);
                        }
                        collision.elementIndex = collisionTriangleIndex;
                        // if not looking for best hit, first found will do...
                        if (!closestFlag)
                            return true;
                    }
                }
            }
            if (collisionTriangleIndex >= 0)
                return true;
            return false;
        };
        TriangleElements.isIE = !!navigator.userAgent.match(/Trident/g) || !!navigator.userAgent.match(/MSIE/g);
        TriangleElements.assetType = "[asset TriangleElements]";
        return TriangleElements;
    }(ElementsBase));
    /**
     *
     * @class away.pool._Stage_TriangleElements
     */
    var _Stage_TriangleElements = /** @class */ (function (_super) {
        __extends$5(_Stage_TriangleElements, _super);
        function _Stage_TriangleElements(triangleElements, stage) {
            var _this = _super.call(this, triangleElements, stage) || this;
            _this._triangleElements = triangleElements;
            return _this;
        }
        _Stage_TriangleElements.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            this._triangleElements = null;
        };
        _Stage_TriangleElements.prototype._setRenderState = function (renderRenderable, shader, view) {
            _super.prototype._setRenderState.call(this, renderRenderable, shader, view);
            //set buffers
            //TODO: find a better way to update a concatenated buffer when autoderiving
            if (shader.normalIndex >= 0 && this._triangleElements.autoDeriveNormals)
                this._triangleElements.normals;
            if (shader.tangentIndex >= 0 && this._triangleElements.autoDeriveTangents)
                this._triangleElements.tangents;
            if (shader.curvesIndex >= 0)
                this.activateVertexBufferVO(shader.curvesIndex, this._triangleElements.getCustomAtributes("curves"));
            if (shader.uvIndex >= 0)
                this.activateVertexBufferVO(shader.uvIndex, this._triangleElements.uvs || this._triangleElements.positions);
            if (shader.secondaryUVIndex >= 0)
                this.activateVertexBufferVO(shader.secondaryUVIndex, this._triangleElements.getCustomAtributes("secondaryUVs") || this._triangleElements.uvs || this._triangleElements.positions);
            if (shader.normalIndex >= 0)
                this.activateVertexBufferVO(shader.normalIndex, this._triangleElements.normals);
            if (shader.tangentIndex >= 0)
                this.activateVertexBufferVO(shader.tangentIndex, this._triangleElements.tangents);
            if (shader.jointIndexIndex >= 0)
                this.activateVertexBufferVO(shader.jointIndexIndex, this._triangleElements.jointIndices);
            if (shader.jointWeightIndex >= 0)
                this.activateVertexBufferVO(shader.jointIndexIndex, this._triangleElements.jointWeights);
            this.activateVertexBufferVO(0, this._triangleElements.positions);
        };
        _Stage_TriangleElements.prototype.draw = function (renderRenderable, shader, view, count, offset) {
            //set constants
            if (shader.sceneMatrixIndex >= 0) {
                shader.sceneMatrix.copyFrom(renderRenderable.renderSceneTransform, true);
                shader.viewMatrix.copyFrom(view.viewMatrix3D, true);
            }
            else {
                var matrix3D = Matrix3D.CALCULATION_MATRIX;
                matrix3D.copyFrom(renderRenderable.renderSceneTransform);
                matrix3D.append(view.viewMatrix3D);
                shader.viewMatrix.copyFrom(matrix3D, true);
            }
            var context = this._stage.context;
            context.setProgramConstantsFromArray(ContextGLProgramType.VERTEX, shader.vertexConstantData);
            context.setProgramConstantsFromArray(ContextGLProgramType.FRAGMENT, shader.fragmentConstantData);
            if (this._indices)
                this.getIndexBufferGL().draw(ContextGLDrawMode.TRIANGLES, offset * 3, count * 3 || this.numIndices);
            else
                this._stage.context.drawVertices(ContextGLDrawMode.TRIANGLES, offset, count || this.numVertices);
        };
        /**
         * //TODO
         *
         * @param pool
         * @param renderable
         * @param level
         * @param indexOffset
         * @returns {away.pool.GL_ShapeRenderable}
         * @protected
         */
        _Stage_TriangleElements.prototype._pGetOverflowElements = function () {
            return new _Stage_TriangleElements(this._triangleElements, this._stage);
        };
        return _Stage_TriangleElements;
    }(_Stage_ElementsBase));
    /**
     * @class away.pool.LineMaterialPool
     */
    var _Render_TriangleElements = /** @class */ (function (_super) {
        __extends$5(_Render_TriangleElements, _super);
        function _Render_TriangleElements() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        _Render_TriangleElements.prototype._includeDependencies = function (shader) {
        };
        _Render_TriangleElements.prototype._getVertexCode = function (shader, registerCache, sharedRegisters) {
            var code = "";
            //get the projection coordinates
            var position = (shader.globalPosDependencies > 0) ? sharedRegisters.globalPositionVertex : sharedRegisters.animatedPosition;
            //reserving vertex constants for projection matrix
            var viewMatrixReg = registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            shader.viewMatrixIndex = viewMatrixReg.index * 4;
            if (shader.projectionDependencies > 0) {
                sharedRegisters.projectionFragment = registerCache.getFreeVarying();
                var temp = registerCache.getFreeVertexVectorTemp();
                code += "m44 " + temp + ", " + position + ", " + viewMatrixReg + "\n" +
                    "mov " + sharedRegisters.projectionFragment + ", " + temp + "\n" +
                    "mov op, " + temp + "\n";
            }
            else {
                code += "m44 op, " + position + ", " + viewMatrixReg + "\n";
            }
            return code;
        };
        _Render_TriangleElements.prototype._getFragmentCode = function (shader, registerCache, sharedRegisters) {
            return "";
        };
        return _Render_TriangleElements;
    }(_Render_ElementsBase));
    RenderGroup.registerElements(_Render_TriangleElements, TriangleElements);
    Stage.registerAbstraction(_Stage_TriangleElements, TriangleElements);

    var LineElementsUtils = /** @class */ (function () {
        function LineElementsUtils() {
        }
        //TODO - generate this dyanamically based on num tris
        LineElementsUtils.hitTest = function (x, y, z, thickness, box, lineElements, count, offset) {
            if (offset === void 0) { offset = 0; }
            var positionAttributes = lineElements.positions;
            var posStride = positionAttributes.stride;
            var positions = positionAttributes.get(count, offset);
            var indices;
            var len;
            if (lineElements.indices) {
                indices = lineElements.indices.get(count, offset);
                positions = positionAttributes.get(positionAttributes.count);
                len = count * lineElements.indices.dimensions;
            }
            else {
                positions = positionAttributes.get(count, offset);
                len = count;
            }
            var id0;
            var id1;
            var ax;
            var ay;
            var bx;
            var by;
            var hitTestCache = lineElements.hitTestCache[offset] || (lineElements.hitTestCache[offset] = new HitTestCache());
            var index = hitTestCache.lastCollisionIndex;
            if (index != -1 && index < len) {
                precheck: {
                    if (indices) {
                        id0 = indices[index] * posStride;
                        id1 = indices[index + 1] * posStride;
                    }
                    else {
                        id0 = index * posStride;
                        id1 = (index + 1) * posStride;
                    }
                    ax = positions[id0];
                    ay = positions[id0 + 1];
                    bx = positions[id1];
                    by = positions[id1 + 1];
                    //from a to p
                    var dx = ax - x;
                    var dy = ay - y;
                    //edge normal (a-b)
                    var nx = by - ay;
                    var ny = -(bx - ax);
                    var D = Math.sqrt(nx * nx + ny * ny);
                    //TODO: should strictly speaking be an elliptical calculation, use circle to approx temp
                    if (Math.abs((dx * nx) + (dy * ny)) > thickness * D)
                        break precheck;
                    //edge vector
                    var dot = (dx * ny) - (dy * nx);
                    if (dot > D * D || dot < 0)
                        break precheck;
                    return true;
                }
            }
            //hard coded min vertex count to bother using a grid for
            if (len > 150) {
                var cells = hitTestCache.cells;
                var divisions = cells.length ? hitTestCache.divisions : (hitTestCache.divisions = Math.min(Math.ceil(Math.sqrt(len)), 32));
                var conversionX = divisions / box.width;
                var conversionY = divisions / box.height;
                var minx = box.x;
                var miny = box.y;
                if (!cells.length) { //build grid
                    //now we have bounds start creating grid cells and filling
                    cells.length = divisions * divisions;
                    for (var k = 0; k < len; k += 3) {
                        if (indices) {
                            id0 = indices[k] * posStride;
                            id1 = indices[k + 1] * posStride;
                        }
                        else {
                            id0 = k * posStride;
                            id1 = (k + 1) * posStride;
                        }
                        ax = positions[id0];
                        ay = positions[id0 + 1];
                        bx = positions[id1];
                        by = positions[id1 + 1];
                        //subtractions to push into positive space
                        var min_index_x = Math.floor((Math.min(ax, bx) - minx) * conversionX);
                        var min_index_y = Math.floor((Math.min(ay, by) - miny) * conversionY);
                        var max_index_x = Math.floor((Math.max(ax, bx) - minx) * conversionX);
                        var max_index_y = Math.floor((Math.max(ay, by) - miny) * conversionY);
                        for (var i = min_index_x; i <= max_index_x; i++) {
                            for (var j = min_index_y; j <= max_index_y; j++) {
                                var c = i + j * divisions;
                                var nodes = cells[c] || (cells[c] = new Array());
                                //push in the triangle ids
                                nodes.push(k);
                            }
                        }
                    }
                }
                var index_x = Math.floor((x - minx) * conversionX);
                var index_y = Math.floor((y - miny) * conversionY);
                var nodes = cells[index_x + index_y * divisions];
                if (nodes == null) {
                    hitTestCache.lastCollisionIndex = -1;
                    return false;
                }
                var nodeCount = nodes.length;
                for (var n = 0; n < nodeCount; n++) {
                    var k = nodes[n];
                    if (indices) {
                        id0 = indices[k] * posStride;
                        id1 = indices[k + 1] * posStride;
                    }
                    else {
                        id0 = k * posStride;
                        id1 = (k + 1) * posStride;
                    }
                    ax = positions[id0];
                    ay = positions[id0 + 1];
                    bx = positions[id1];
                    by = positions[id1 + 1];
                    //from a to p
                    var dx = ax - x;
                    var dy = ay - y;
                    //edge normal (a-b)
                    var nx = by - ay;
                    var ny = -(bx - ax);
                    var D = Math.sqrt(nx * nx + ny * ny);
                    //TODO: should strictly speaking be an elliptical calculation, use circle to approx temp
                    if (Math.abs((dx * nx) + (dy * ny)) > thickness * D)
                        continue;
                    //edge vector
                    var dot = (dx * ny) - (dy * nx);
                    if (dot > D * D || dot < 0)
                        continue;
                    hitTestCache.lastCollisionIndex = k;
                    return true;
                }
                hitTestCache.lastCollisionIndex = -1;
                return false;
            }
            //brute force
            for (var k = 0; k < len; k += 6) {
                if (indices) {
                    id0 = indices[k] * posStride;
                    id1 = indices[k + 1] * posStride;
                }
                else {
                    id0 = k * posStride;
                    id1 = (k + 1) * posStride;
                }
                ax = positions[id0];
                ay = positions[id0 + 1];
                bx = positions[id1];
                by = positions[id1 + 1];
                //from a to p
                var dx = ax - x;
                var dy = ay - y;
                //edge normal (a-b)
                var nx = by - ay;
                var ny = -(bx - ax);
                var D = Math.sqrt(nx * nx + ny * ny);
                //TODO: should strictly speaking be an elliptical calculation, use circle to approx temp
                if (Math.abs((dx * nx) + (dy * ny)) > thickness * D)
                    continue;
                //edge vector
                var dot = (dx * ny) - (dy * nx);
                if (dot > D * D || dot < 0)
                    continue;
                hitTestCache.lastCollisionIndex = k;
                return true;
            }
            hitTestCache.lastCollisionIndex = -1;
            return false;
        };
        LineElementsUtils.getBoxBounds = function (positionAttributes, indexAttributes, matrix3D, thicknessScale, cache, target, count, offset) {
            if (offset === void 0) { offset = 0; }
            var positions;
            var posDim = positionAttributes.dimensions;
            var posStride = positionAttributes.stride;
            var minX = 0, minY = 0;
            var maxX = 0, maxY = 0;
            var indices;
            var len;
            if (indexAttributes) {
                len = count * indexAttributes.dimensions;
                indices = indexAttributes.get(count, offset);
                positions = positionAttributes.get(positionAttributes.count);
            }
            else {
                len = count;
                positions = positionAttributes.get(count, offset);
            }
            if (len == 0)
                return target;
            var i = 0;
            var index;
            var pos1, pos2, pos3, rawData;
            if (matrix3D)
                rawData = matrix3D._rawData;
            for (var i = 0; i < len; i += 3) {
                index = (indices) ? indices[i] * posStride : i * posStride;
                if (matrix3D) {
                    if (posDim == 6) {
                        pos1 = positions[index] * rawData[0] + positions[index + 1] * rawData[4] + positions[index + 2] * rawData[8] + rawData[12];
                        pos2 = positions[index] * rawData[1] + positions[index + 1] * rawData[5] + positions[index + 2] * rawData[9] + rawData[13];
                        pos3 = positions[index] * rawData[2] + positions[index + 1] * rawData[6] + positions[index + 2] * rawData[10] + rawData[14];
                    }
                    else {
                        pos1 = positions[index] * rawData[0] + positions[index + 1] * rawData[4] + rawData[12];
                        pos2 = positions[index] * rawData[1] + positions[index + 1] * rawData[5] + rawData[13];
                    }
                }
                else {
                    pos1 = positions[index];
                    pos2 = positions[index + 1];
                    pos3 = (posDim == 6) ? positions[index + 2] : 0;
                }
                if (i == 0) {
                    maxX = minX = pos1;
                    maxY = minY = pos2;
                }
                else {
                    if (pos1 < minX)
                        minX = pos1;
                    else if (pos1 > maxX)
                        maxX = pos1;
                    if (pos2 < minY)
                        minY = pos2;
                    else if (pos2 > maxY)
                        maxY = pos2;
                }
            }
            var thicknessX = matrix3D ? thicknessScale.x * rawData[0] + thicknessScale.y * rawData[4] : thicknessScale.x;
            var thicknessY = matrix3D ? thicknessScale.x * rawData[1] + thicknessScale.y * rawData[5] : thicknessScale.y;
            var box = new Box(minX - thicknessX, minY - thicknessY);
            box.right = maxX + thicknessX;
            box.bottom = maxY + thicknessY;
            return box.union(target, target || cache);
        };
        LineElementsUtils.getSphereBounds = function (positionAttributes, center, matrix3D, cache, output, count, offset) {
            if (offset === void 0) { offset = 0; }
            var positions = positionAttributes.get(count, offset);
            var posDim = positionAttributes.dimensions;
            var posStride = positionAttributes.stride;
            var maxRadiusSquared = 0;
            var radiusSquared;
            var len = count * posStride;
            var distanceX;
            var distanceY;
            var distanceZ;
            for (var i = 0; i < len; i += posStride) {
                distanceX = positions[i] - center.x;
                distanceY = positions[i + 1] - center.y;
                distanceZ = (posDim == 6) ? positions[i + 2] - center.z : -center.z;
                radiusSquared = distanceX * distanceX + distanceY * distanceY + distanceZ * distanceZ;
                if (maxRadiusSquared < radiusSquared)
                    maxRadiusSquared = radiusSquared;
            }
            if (output == null)
                output = new Sphere();
            output.x = center.x;
            output.y = center.y;
            output.z = center.z;
            output.radius = Math.sqrt(maxRadiusSquared);
            return output;
        };
        return LineElementsUtils;
    }());

    /**
     * @class LineElements
     */
    var LineElements = /** @class */ (function (_super) {
        __extends$5(LineElements, _super);
        /**
         *
         */
        function LineElements(concatenatedBuffer) {
            if (concatenatedBuffer === void 0) { concatenatedBuffer = null; }
            var _this = _super.call(this, concatenatedBuffer) || this;
            _this._thicknessScale = new Vector3D();
            //used for hittesting geometry
            _this.hitTestCache = new Object();
            _this._positions = new AttributesView(Float32Array, 6, concatenatedBuffer);
            return _this;
        }
        LineElements.prototype.getThicknessScale = function (view, entity, strokeFlag) {
            if (!strokeFlag && this.stroke.scaleMode == LineScaleMode.HAIRLINE) {
                this._thicknessScale.identity();
            }
            else {
                if (entity)
                    this._thicknessScale.copyFrom(entity.transform.concatenatedMatrix3D.decompose()[3]);
                else
                    this._thicknessScale.identity();
                this._thicknessScale.x *= view.focalLength * view.pixelRatio / 1000;
                this._thicknessScale.y *= view.focalLength / 1000;
                if (this.stroke && this.stroke.scaleMode == LineScaleMode.NORMAL) {
                    this._thicknessScale.x = (!strokeFlag || this.stroke.half_thickness * this._thicknessScale.x > 0.5) ? this.stroke.half_thickness : 0.5 / this._thicknessScale.x;
                    this._thicknessScale.y = (!strokeFlag || this.stroke.half_thickness * this._thicknessScale.y > 0.5) ? this.stroke.half_thickness : 0.5 / this._thicknessScale.y;
                }
                else if (!this.stroke || this.stroke.scaleMode == LineScaleMode.HAIRLINE) {
                    this._thicknessScale.x = 0.5 / this._thicknessScale.x;
                    this._thicknessScale.y = 0.5 / this._thicknessScale.y;
                }
            }
            return this._thicknessScale;
        };
        Object.defineProperty(LineElements.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return LineElements.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineElements.prototype, "positions", {
            /**
             *
             */
            get: function () {
                return this._positions;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineElements.prototype, "thickness", {
            /**
             *
             */
            get: function () {
                return this._thickness;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineElements.prototype, "colors", {
            /**
             *
             */
            get: function () {
                if (!this._colors)
                    this.setColors(this._colors);
                return this._colors;
            },
            enumerable: true,
            configurable: true
        });
        LineElements.prototype.getBoxBounds = function (view, entity, strokeFlag, matrix3D, cache, target, count, offset) {
            if (entity === void 0) { entity = null; }
            if (strokeFlag === void 0) { strokeFlag = false; }
            if (matrix3D === void 0) { matrix3D = null; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            return LineElementsUtils.getBoxBounds(this.positions, this.indices, matrix3D, this.getThicknessScale(view, entity, strokeFlag), cache, target, count || this._numElements || this._numVertices, offset);
        };
        LineElements.prototype.getSphereBounds = function (view, center, matrix3D, strokeFlag, cache, target, count, offset) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = false; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            return LineElementsUtils.getSphereBounds(this.positions, center, matrix3D, cache, target, count || this._numVertices, offset);
        };
        LineElements.prototype.hitTestPoint = function (view, entity, x, y, z, box, count, offset, idx_count, idx_offset) {
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            if (idx_count === void 0) { idx_count = 0; }
            if (idx_offset === void 0) { idx_offset = 0; }
            var scale = this.getThicknessScale(view, entity, true);
            var thickness = (scale.x + scale.y) / 2; //approx hack for now
            return LineElementsUtils.hitTest(x, y, 0, thickness, box, this, count || this._numElements || this._numVertices, offset);
        };
        LineElements.prototype.setPositions = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            if (values instanceof AttributesView) {
                this.clearVertices(this._positions);
                this._positions = values;
            }
            else if (values) {
                var i = 0;
                var j = 0;
                var index = 0;
                var positions = new Float32Array(values.length * 4);
                var indices = new Uint16Array(values.length);
                //oders incoming startpos/endpos values to look like the following 6-dimensional attributes view:
                //startpos x, y, z endpos x, y, z
                //endpos x, y, z startpos x, y, z
                //startpos x, y, z endpos x, y, z
                //endpos x, y, z startpos x, y, z
                while (i < values.length) {
                    if (index / 6 & 1) { //if number is odd, reverse the order of startpos/endpos
                        positions[index] = values[i + 3];
                        positions[index + 1] = values[i + 4];
                        positions[index + 2] = values[i + 5];
                        positions[index + 3] = values[i];
                        positions[index + 4] = values[i + 1];
                        positions[index + 5] = values[i + 2];
                    }
                    else {
                        positions[index] = values[i];
                        positions[index + 1] = values[i + 1];
                        positions[index + 2] = values[i + 2];
                        positions[index + 3] = values[i + 3];
                        positions[index + 4] = values[i + 4];
                        positions[index + 5] = values[i + 5];
                    }
                    index += 6;
                    if (++j == 4) {
                        var o = index / 6 - 4;
                        indices.set([o, o + 1, o + 2, o + 3, o + 2, o + 1], i);
                        j = 0;
                        i += 6;
                    }
                }
                this._positions.set(positions, offset * 4);
                this.setIndices(indices, offset);
            }
            else {
                this.clearVertices(this._positions);
                this._positions = new AttributesView(Float32Array, 6, this._concatenatedBuffer);
            }
            this._numVertices = this._positions.count;
            this.invalidateVertices(this._positions);
            this._verticesDirty[this._positions.id] = false;
        };
        LineElements.prototype.setThickness = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            if (values instanceof Float1Attributes) {
                this._thickness = values;
            }
            else if (values) {
                if (!this._thickness)
                    this._thickness = new Float1Attributes(this._concatenatedBuffer);
                var i = 0;
                var j = 0;
                var index = 0;
                var thickness = new Float32Array(values.length * 4);
                //oders incoming thickness values to look like the following 1-dimensional attributes view:
                //thickness t
                //thickness -t
                //thickness -t
                //thickness t
                while (i < values.length) {
                    thickness[index] = (Math.floor(0.5 * index + 0.5) & 1) ? -values[i] : values[i];
                    if (++j == 4) {
                        j = 0;
                        i++;
                    }
                    index++;
                }
                this._thickness.set(thickness, offset * 4);
            }
            else if (this._thickness) {
                this._thickness.dispose();
                this._thickness = null;
            }
            this.invalidateVertices(this._thickness);
            this._verticesDirty[this._thickness.id] = false;
        };
        LineElements.prototype.setColors = function (values, offset) {
            if (offset === void 0) { offset = 0; }
            if (values) {
                if (values == this._colors)
                    return;
                if (values instanceof Byte4Attributes) {
                    this.clearVertices(this._colors);
                    this._colors = values;
                }
                else {
                    if (!this._colors)
                        this._colors = new Byte4Attributes(this._concatenatedBuffer);
                    var i = 0;
                    var j = 0;
                    var index = 0;
                    var colors = new Uint8Array(values.length * 4);
                    while (i < values.length) {
                        if (index / 4 & 1) {
                            colors[index] = values[i + 4];
                            colors[index + 1] = values[i + 5];
                            colors[index + 2] = values[i + 6];
                            colors[index + 3] = values[i + 7];
                        }
                        else {
                            colors[index] = values[i];
                            colors[index + 1] = values[i + 1];
                            colors[index + 2] = values[i + 2];
                            colors[index + 3] = values[i + 3];
                        }
                        if (++j == 4) {
                            j = 0;
                            i += 8;
                        }
                        index += 4;
                    }
                    this._colors.set(colors, offset * 4);
                }
            }
            else {
                //auto-derive colors
                this._colors = ElementsUtils.generateColors(this.indices, this._colors, this._concatenatedBuffer, this._numVertices);
            }
            this.invalidateVertices(this._colors);
            this._verticesDirty[this._colors.id] = false;
        };
        /**
         *
         */
        LineElements.prototype.dispose = function () {
            _super.prototype.dispose.call(this);
            this._positions.dispose();
            this._positions = null;
            if (this._thickness) {
                this._thickness.dispose();
                this._thickness = null;
            }
            if (this._colors) {
                this._colors.dispose();
                this._colors = null;
            }
        };
        /**
         * Clones the current object
         * @return An exact duplicate of the current object.
         */
        LineElements.prototype.clone = function () {
            var clone = new LineElements(this._concatenatedBuffer ? this._concatenatedBuffer.clone() : null);
            clone.setIndices(this.indices.clone());
            clone.setPositions(this._positions.clone());
            clone.setThickness(this._thickness.clone());
            clone.setColors(this._colors.clone());
            return clone;
        };
        LineElements.prototype.testCollision = function (view, collision, box, closestFlag, material, count, offset) {
            if (offset === void 0) { offset = 0; }
            //TODO: peform correct line collision calculations
            var scale = this.getThicknessScale(view, collision.entity, true);
            var thickness = (scale.x + scale.y) / 2; //approx hack for now
            var rayEntryDistance = -collision.rayPosition.z / collision.rayDirection.z;
            var position = new Vector3D(collision.rayPosition.x + rayEntryDistance * collision.rayDirection.x, collision.rayPosition.y + rayEntryDistance * collision.rayDirection.y);
            //TODO use proper 3d testCollision method
            if (LineElementsUtils.hitTest(position.x, position.y, 0, thickness, box, this, this._numElements, offset)) {
                collision.rayEntryDistance = rayEntryDistance;
                collision.position = position;
                collision.normal = new Vector3D(0, 0, 1);
                return true;
            }
            return false;
        };
        LineElements.assetType = "[asset LineElements]";
        return LineElements;
    }(ElementsBase));
    /**
     *
     * @class away.pool._Stage_LineElements
     */
    var _Stage_LineElements = /** @class */ (function (_super) {
        __extends$5(_Stage_LineElements, _super);
        function _Stage_LineElements(lineElements, stage) {
            var _this = _super.call(this, lineElements, stage) || this;
            _this._scale = new Vector3D();
            _this._thickness = 1;
            _this._lineElements = lineElements;
            return _this;
        }
        _Stage_LineElements.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            this._lineElements = null;
        };
        _Stage_LineElements.prototype._setRenderState = function (renderRenderable, shader, view) {
            _super.prototype._setRenderState.call(this, renderRenderable, shader, view);
            var renderElements = renderRenderable.renderGroup.getRenderElements(renderRenderable.stageElements.elements);
            if (shader.colorBufferIndex >= 0)
                this.activateVertexBufferVO(shader.colorBufferIndex, this._lineElements.colors);
            this.activateVertexBufferVO(0, this._lineElements.positions, 3);
            this.activateVertexBufferVO(renderElements.secondaryPositionIndex, this._lineElements.positions, 3, 12);
            this.activateVertexBufferVO(renderElements.thicknessIndex, this._lineElements.thickness);
            if (shader.uvIndex >= 0)
                this.activateVertexBufferVO(shader.uvIndex, this._lineElements.positions, 2);
            var index = renderElements._dataIndex;
            var data = shader.vertexConstantData;
            data[index + 4] = 1;
            data[index + 5] = 1;
            data[index + 6] = 1;
            data[index + 7] = 1;
            data[index + 10] = -1;
            this._scale.copyFrom(renderRenderable.sourceEntity.transform.concatenatedMatrix3D.decompose()[3]);
            var stroke = this._lineElements.stroke;
            if (stroke && stroke.scaleMode == LineScaleMode.NORMAL) {
                data[index + 12] = (stroke.half_thickness * this._scale.x * this._thickness / 1000 > 0.5 / (view.focalLength * view.pixelRatio)) ? this._scale.x * this._thickness / 1000 : 0.5 / (stroke.half_thickness * view.focalLength * view.pixelRatio);
                data[index + 13] = (stroke.half_thickness * this._scale.y * this._thickness / 1000 > 0.5 / view.focalLength) ? this._scale.y * this._thickness / 1000 : 0.5 / (stroke.half_thickness * view.focalLength);
            }
            else if (!stroke || stroke.scaleMode == LineScaleMode.HAIRLINE) {
                data[index + 12] = this._thickness / (view.focalLength * view.pixelRatio);
                data[index + 13] = this._thickness / view.focalLength;
            }
            else {
                data[index + 12] = this._thickness / Math.min(view.width, view.height);
                data[index + 13] = this._thickness / Math.min(view.width, view.height);
            }
            data[index + 14] = view.projection.near;
            var context = this._stage.context;
        };
        _Stage_LineElements.prototype.draw = function (renderRenderable, shader, view, count, offset) {
            var context = this._stage.context;
            // projection matrix
            shader.viewMatrix.copyFrom(view.frustumMatrix3D, true);
            var matrix3D = Matrix3D.CALCULATION_MATRIX;
            matrix3D.copyFrom(renderRenderable.sourceEntity.transform.concatenatedMatrix3D);
            matrix3D.append(view.projection.transform.inverseConcatenatedMatrix3D);
            shader.sceneMatrix.copyFrom(matrix3D, true);
            context.setProgramConstantsFromArray(ContextGLProgramType.VERTEX, shader.vertexConstantData);
            context.setProgramConstantsFromArray(ContextGLProgramType.FRAGMENT, shader.fragmentConstantData);
            if (this._indices)
                this.getIndexBufferGL().draw(ContextGLDrawMode.TRIANGLES, offset * 3, count * 3 || this.numIndices);
            else
                this._stage.context.drawVertices(ContextGLDrawMode.TRIANGLES, offset, count || this.numVertices);
        };
        /**
         * //TODO
         *
         * @param pool
         * @param renderRenderable
         * @param level
         * @param indexOffset
         * @returns {away.pool.LineSubSpriteRenderable}
         * @protected
         */
        _Stage_LineElements.prototype._pGetOverflowElements = function () {
            return new _Stage_LineElements(this._lineElements, this._stage);
        };
        return _Stage_LineElements;
    }(_Stage_ElementsBase));
    /**
     * @class away.pool._Render_LineElements
     */
    var _Render_LineElements = /** @class */ (function (_super) {
        __extends$5(_Render_LineElements, _super);
        function _Render_LineElements() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.secondaryPositionIndex = -1;
            _this.thicknessIndex = -1;
            return _this;
        }
        _Render_LineElements.prototype._includeDependencies = function (shader) {
            //shader.colorDependencies++;
        };
        _Render_LineElements.prototype._getVertexCode = function (shader, registerCache, sharedRegisters) {
            //get the projection coordinates
            var position0 = (shader.globalPosDependencies > 0) ? sharedRegisters.globalPositionVertex : sharedRegisters.animatedPosition;
            var position1 = registerCache.getFreeVertexAttribute();
            this.secondaryPositionIndex = position1.index;
            var thickness = registerCache.getFreeVertexAttribute();
            this.thicknessIndex = thickness.index;
            //reserving vertex constants for projection matrix
            var viewMatrixReg = registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            shader.viewMatrixIndex = viewMatrixReg.index * 4;
            var dataReg = registerCache.getFreeVertexConstant(); // not used
            this._dataIndex = dataReg.index * 4;
            var constOne = registerCache.getFreeVertexConstant();
            var constNegOne = registerCache.getFreeVertexConstant();
            var misc = registerCache.getFreeVertexConstant();
            var sceneMatrixReg = registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            shader.sceneMatrixIndex = sceneMatrixReg.index * 4;
            var q0 = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(q0, 1);
            var q1 = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(q1, 1);
            var l = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(l, 1);
            var behind = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(behind, 1);
            var qclipped = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(qclipped, 1);
            var offset = registerCache.getFreeVertexVectorTemp();
            registerCache.addVertexTempUsages(offset, 1);
            var code = "m44 " + q0 + ", " + position0 + ", " + sceneMatrixReg + "			\n" + // transform Q0 to eye space
                "m44 " + q1 + ", " + position1 + ", " + sceneMatrixReg + "			\n" + // transform Q1 to eye space
                "sub " + l + ", " + q1 + ", " + q0 + " 			\n" + // L = Q1 - Q0
                // test if behind camera near plane
                // if 0 - Q0.z < Camera.near then the point needs to be clipped
                "slt " + behind + ".x, " + q0 + ".z, " + misc + ".z			\n" + // behind = ( 0 - Q0.z < -Camera.near ) ? 1 : 0
                "sub " + behind + ".y, " + constOne + ".x, " + behind + ".x			\n" + // !behind = 1 - behind
                // p = point on the plane (0,0,-near)
                // n = plane normal (0,0,-1)
                // D = Q1 - Q0
                // t = ( dot( n, ( p - Q0 ) ) / ( dot( n, d )
                // solve for t where line crosses Camera.near
                "add " + offset + ".x, " + q0 + ".z, " + misc + ".z			\n" + // Q0.z + ( -Camera.near )
                "sub " + offset + ".y, " + q0 + ".z, " + q1 + ".z			\n" + // Q0.z - Q1.z
                // fix divide by zero for horizontal lines
                "seq " + offset + ".z, " + offset + ".y " + constNegOne + ".x			\n" + // offset = (Q0.z - Q1.z)==0 ? 1 : 0
                "add " + offset + ".y, " + offset + ".y, " + offset + ".z			\n" + // ( Q0.z - Q1.z ) + offset
                "div " + offset + ".z, " + offset + ".x, " + offset + ".y			\n" + // t = ( Q0.z - near ) / ( Q0.z - Q1.z )
                "mul " + offset + ".xyz, " + offset + ".zzz, " + l + ".xyz	\n" + // t(L)
                "add " + qclipped + ".xyz, " + q0 + ".xyz, " + offset + ".xyz	\n" + // Qclipped = Q0 + t(L)
                "mov " + qclipped + ".w, " + constOne + ".x			\n" + // Qclipped.w = 1
                // If necessary, replace Q0 with new Qclipped
                "mul " + q0 + ", " + q0 + ", " + behind + ".yyyy			\n" + // !behind * Q0
                "mul " + qclipped + ", " + qclipped + ", " + behind + ".xxxx			\n" + // behind * Qclipped
                "add " + q0 + ", " + q0 + ", " + qclipped + "				\n" + // newQ0 = Q0 + Qclipped
                // calculate side vector for line
                "nrm " + l + ".xyz, " + l + ".xyz			\n" + // normalize( L )
                "nrm " + behind + ".xyz, " + q0 + ".xyz			\n" + // D = normalize( Q1 )
                "mov " + behind + ".w, " + constOne + ".x				\n" + // D.w = 1
                "crs " + qclipped + ".xyz, " + l + ", " + behind + "			\n" + // S = L x D
                "nrm " + qclipped + ".xyz, " + qclipped + ".xyz			\n" + // normalize( S )
                // face the side vector properly for the given point
                "mul " + qclipped + ".xyz, " + qclipped + ".xyz, " + thickness + ".xxx	\n" + // S *= weight
                "mov " + qclipped + ".w, " + constOne + ".x			\n" + // S.w = 1
                // calculate the amount required to move at the point's distance to correspond to the line's pixel width
                // scale the side vector by that amount
                "dp3 " + offset + ".x, " + q0 + ", " + constNegOne + "			\n" + // distance = dot( view )
                "mul " + qclipped + ".xyz, " + qclipped + ".xyz, " + offset + ".xxx	\n" + // S.xyz *= pixelScaleFactor
                "mul " + qclipped + ".xyz, " + qclipped + ".xyz, " + misc + ".xy	\n" + // distance *= vpsod
                // add scaled side vector to Q0 and transform to clip space
                "add " + q0 + ".xyz, " + q0 + ".xyz, " + qclipped + ".xyz	\n" + // Q0 + S
                "m44 op, " + q0 + ", " + viewMatrixReg + "			\n"; // transform Q0 to clip space
            registerCache.removeVertexTempUsage(q0);
            registerCache.removeVertexTempUsage(q1);
            registerCache.removeVertexTempUsage(l);
            registerCache.removeVertexTempUsage(behind);
            registerCache.removeVertexTempUsage(qclipped);
            registerCache.removeVertexTempUsage(offset);
            return code;
        };
        _Render_LineElements.prototype._getFragmentCode = function (shader, registerCache, sharedRegisters) {
            return "";
        };
        return _Render_LineElements;
    }(_Render_ElementsBase));
    RenderGroup.registerElements(_Render_LineElements, LineElements);
    Stage.registerAbstraction(_Stage_LineElements, LineElements);

    /**
     * Graphic wraps a Elements as a scene graph instantiation. A Graphic is owned by a Sprite object.
     *
     *
     * @see away.base.ElementsBase
     * @see away.entities.Sprite
     *
     * @class away.base.Graphic
     */
    var Shape = /** @class */ (function (_super) {
        __extends$5(Shape, _super);
        /**
         * Creates a new Shape object
         */
        function Shape(elements, material, style, count, offset) {
            if (material === void 0) { material = null; }
            if (style === void 0) { style = null; }
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            var _this = _super.call(this) || this;
            _this.usages = 0;
            _this._onInvalidatePropertiesDelegate = function (event) { return _this._onInvalidateProperties(event); };
            _this._onInvalidateVerticesDelegate = function (event) { return _this._onInvalidateVertices(event); };
            _this._elements = elements;
            _this._material = material;
            _this._style = style;
            if (_this._style)
                _this._style.addEventListener(StyleEvent.INVALIDATE_PROPERTIES, _this._onInvalidatePropertiesDelegate);
            _this.count = count;
            _this.offset = offset;
            return _this;
        }
        Shape.getShape = function (elements, material, style, count, offset) {
            if (material === void 0) { material = null; }
            if (style === void 0) { style = null; }
            if (count === void 0) { count = 0; }
            if (offset === void 0) { offset = 0; }
            if (Shape._pool.length) {
                var shape = Shape._pool.pop();
                shape.elements = elements;
                shape.material = material;
                shape.style = style;
                shape.count = count;
                shape.offset = offset;
                return shape;
            }
            return new Shape(elements, material, style, count, offset);
        };
        Shape.clearPool = function () {
            Shape._pool = [];
        };
        Object.defineProperty(Shape.prototype, "elements", {
            /**
             * The Elements object which provides the geometry data for this Shape.
             */
            get: function () {
                return this._elements;
            },
            set: function (value) {
                if (this._elements == value)
                    return;
                if (this._elements) {
                    this._elements.removeEventListener(ElementsEvent.INVALIDATE_VERTICES, this._onInvalidateVerticesDelegate);
                    this._elements.usages--;
                    if (!this._elements.usages)
                        this._elements.dispose();
                }
                this._elements = value;
                if (this._elements) {
                    this._elements.addEventListener(ElementsEvent.INVALIDATE_VERTICES, this._onInvalidateVerticesDelegate);
                    this._elements.usages++;
                }
                this.invalidateElements();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Shape.prototype, "assetType", {
            /**
             *
             */
            get: function () {
                return Shape.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Shape.prototype, "material", {
            /**
             * The material used to render the current Shape. If set to null, the containing Graphics's material will be used instead.
             */
            get: function () {
                return this._material;
            },
            set: function (value) {
                if (this._material == value)
                    return;
                this._material = value;
                this.invalidateMaterial();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Shape.prototype, "style", {
            /**
             * The style used to render the current Shape. If set to null, its parent Sprite's style will be used instead.
             */
            get: function () {
                return this._style;
            },
            set: function (value) {
                if (this._style == value)
                    return;
                if (this._style)
                    this._style.removeEventListener(StyleEvent.INVALIDATE_PROPERTIES, this._onInvalidatePropertiesDelegate);
                this._style = value;
                if (this._style)
                    this._style.addEventListener(StyleEvent.INVALIDATE_PROPERTIES, this._onInvalidatePropertiesDelegate);
                this.invalidateStyle();
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        Shape.prototype.dispose = function () {
            _super.prototype.clear.call(this);
            this.usages = 0;
            this.elements = null;
            this.material = null;
            this.style = null;
            this.particleCollection = null;
            Shape._pool.push(this);
        };
        Shape.prototype.invalidateElements = function () {
            this.dispatchEvent(new RenderableEvent(RenderableEvent.INVALIDATE_ELEMENTS, this));
        };
        Shape.prototype.invalidateMaterial = function () {
            this.dispatchEvent(new RenderableEvent(RenderableEvent.INVALIDATE_MATERIAL, this));
        };
        Shape.prototype.invalidateStyle = function () {
            this.dispatchEvent(new RenderableEvent(RenderableEvent.INVALIDATE_STYLE, this));
        };
        Shape.prototype._onInvalidateProperties = function (event) {
            this.invalidateStyle();
        };
        Shape.prototype._onInvalidateVertices = function (event) {
            if (event.attributesView != event.target.positions)
                return;
            this.invalidate();
        };
        /**
         * //TODO
         *
         * @param shortestCollisionDistance
         * @param findClosest
         * @returns {boolean}
         *
         * @internal
         */
        Shape.prototype.applyTransformation = function (transform) {
            this._elements.applyTransformation(transform, this.count, this.offset);
        };
        Shape.prototype.scale = function (scale) {
            this._elements.scale(scale, this.count, this.offset);
        };
        Shape.prototype.scaleUV = function (scaleU, scaleV) {
            if (scaleU === void 0) { scaleU = 1; }
            if (scaleV === void 0) { scaleV = 1; }
            this._elements.scaleUV(scaleU, scaleV, this.count, this.offset);
        };
        Shape._pool = new Array();
        Shape.assetType = "[asset Shape]";
        return Shape;
    }(AssetBase));
    /**
     * @class away.pool._Render_Shape
     */
    var _Render_Shape = /** @class */ (function (_super) {
        __extends$5(_Render_Shape, _super);
        /**
         * //TODO
         *
         * @param renderEntity
         * @param shape
         * @param level
         * @param indexOffset
         */
        function _Render_Shape(shape, renderEntity) {
            var _this = _super.call(this, shape, renderEntity) || this;
            _this.shape = shape;
            return _this;
        }
        _Render_Shape.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            this.shape = null;
        };
        /**
         *
         * @returns {ElementsBase}
         * @protected
         */
        _Render_Shape.prototype._getStageElements = function () {
            this._offset = this.shape.offset;
            this._count = this.shape.count;
            return this._stage.getAbstraction((this.sourceEntity.animator) ? this.sourceEntity.animator.getRenderableElements(this, this.shape.elements) : this.shape.elements);
        };
        _Render_Shape.prototype._getRenderMaterial = function () {
            return this.renderGroup.getRenderElements(this.shape.elements).getAbstraction(this._asset.material || this.sourceEntity.material || this.getDefaultMaterial());
        };
        _Render_Shape.prototype._getStyle = function () {
            return this._asset.style || this.sourceEntity.style;
        };
        _Render_Shape.prototype.getDefaultMaterial = function () {
            return (this.stageElements.elements instanceof LineElements) ? MaterialUtils.getDefaultColorMaterial() : MaterialUtils.getDefaultTextureMaterial();
        };
        return _Render_Shape;
    }(_Render_RenderableBase));
    /**
     * @class away.pool._Render_Shape
     */
    var _Pick_Shape = /** @class */ (function (_super) {
        __extends$5(_Pick_Shape, _super);
        /**
         * //TODO
         *
         * @param renderEntity
         * @param shape
         * @param level
         * @param indexOffset
         */
        function _Pick_Shape(shape, pickEntity) {
            var _this = _super.call(this, shape, pickEntity) || this;
            _this._orientedBoxBoundsDirty = true;
            _this._orientedSphereBoundsDirty = true;
            _this._onInvalidateElementsDelegate = function (event) { return _this._onInvalidateElements(event); };
            _this._asset.addEventListener(RenderableEvent.INVALIDATE_ELEMENTS, _this._onInvalidateElementsDelegate);
            return _this;
        }
        _Pick_Shape.prototype.onInvalidate = function (event) {
            _super.prototype.onInvalidate.call(this, event);
            this._orientedBoxBoundsDirty = true;
            this._orientedSphereBoundsDirty = true;
        };
        _Pick_Shape.prototype._onInvalidateElements = function (event) {
            this._orientedBoxBoundsDirty = true;
            this._orientedSphereBoundsDirty = true;
        };
        _Pick_Shape.prototype.onClear = function (event) {
            this._asset.removeEventListener(RenderableEvent.INVALIDATE_ELEMENTS, this._onInvalidateElementsDelegate);
            _super.prototype.onClear.call(this, event);
        };
        _Pick_Shape.prototype.hitTestPoint = function (x, y, z) {
            var box = this.getBoxBounds();
            //early out for box test
            if (box == null || !box.contains(x, y, z))
                return false;
            return this._asset.elements.hitTestPoint(this._view, this.sourceEntity, x, y, z, box, this._asset.count, this._asset.offset);
        };
        _Pick_Shape.prototype.getBoxBounds = function (matrix3D, strokeFlag, cache, target) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (matrix3D)
                return this._asset.elements.getBoxBounds(this._view, this.sourceEntity, strokeFlag, matrix3D, cache, target, this._asset.count, this._asset.offset);
            if (this._orientedBoxBoundsDirty) {
                this._orientedBoxBoundsDirty = false;
                this._orientedBoxBounds = this._asset.elements.getBoxBounds(this._view, this.sourceEntity, strokeFlag, null, this._orientedBoxBounds, null, this._asset.count, this._asset.offset);
            }
            if (this._orientedBoxBounds != null)
                target = this._orientedBoxBounds.union(target, target || cache);
            return target;
        };
        _Pick_Shape.prototype.getSphereBounds = function (center, matrix3D, strokeFlag, cache, target) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (matrix3D)
                return this._asset.elements.getSphereBounds(this._view, center, matrix3D, strokeFlag, cache, target, this._asset.count, this._asset.offset);
            if (this._orientedSphereBoundsDirty) {
                this._orientedSphereBoundsDirty = false;
                this._orientedSphereBounds = this._asset.elements.getSphereBounds(this._view, center, null, strokeFlag, this._orientedSphereBounds, null, this._asset.count, this._asset.offset);
            }
            if (this._orientedSphereBounds != null)
                target = this._orientedSphereBounds.union(target, target || cache);
            return target;
        };
        _Pick_Shape.prototype.testCollision = function (collision, findClosestCollision) {
            var box = this.getBoxBounds();
            //early out for box test
            if (box == null || !box.rayIntersection(collision.rayPosition, collision.rayDirection))
                return false;
            return this._asset.elements.testCollision(this._view, collision, box, findClosestCollision, this._asset.material || collision.entity.material, this._asset.count || this._asset.elements.numVertices, this._asset.offset);
        };
        return _Pick_Shape;
    }(_Pick_PickableBase));
    RenderEntity.registerRenderable(_Render_Shape, Shape);
    PickEntity.registerPickable(_Pick_Shape, Shape);

    /**
     * The GraphicsPathWinding class provides values for the
     * <code>flash.display.GraphicsPath.winding</code> property and the
     * <code>flash.display.Graphics.drawPath()</code> method to determine the
     * direction to draw a path. A clockwise path is positively wound, and a
     * counter-clockwise path is negatively wound:
     *
     * <p> When paths intersect or overlap, the winding direction determines the
     * rules for filling the areas created by the intersection or overlap:</p>
     */
    var GraphicsPathWinding = /** @class */ (function () {
        function GraphicsPathWinding() {
        }
        GraphicsPathWinding.EVEN_ODD = "evenOdd";
        GraphicsPathWinding.NON_ZERO = "nonZero";
        return GraphicsPathWinding;
    }());

    /**
     * Defines the values to use for specifying path-drawing commands.
     * The values in this class are used by the Graphics.drawPath() method,
     *or stored in the commands vector of a GraphicsPath object.
     */
    var GraphicsPathCommand = /** @class */ (function () {
        function GraphicsPathCommand() {
        }
        /**
         * Represents the default "do nothing" command.
         */
        GraphicsPathCommand.NO_OP = 0;
        /**
         * Specifies a drawing command that moves the current drawing position
         * to the x- and y-coordinates specified in the data vector.
         */
        GraphicsPathCommand.MOVE_TO = 1;
        /**
         * Specifies a drawing command that draws a line from the current drawing position
         * to the x- and y-coordinates specified in the data vector.
         */
        GraphicsPathCommand.LINE_TO = 2;
        /**
         *  Specifies a drawing command that draws a curve from the current drawing position
         *  to the x- and y-coordinates specified in the data vector, using a control point.
         */
        GraphicsPathCommand.CURVE_TO = 3;
        /**
         *  Specifies a drawing command that draws a curve from the current drawing position
         *  to the x- and y-coordinates specified in the data vector, using a control point.
         */
        GraphicsPathCommand.BUILD_JOINT = 13;
        GraphicsPathCommand.BUILD_ROUND_JOINT = 14;
        /**
         * Specifies a "line to" drawing command,
         * but uses two sets of coordinates (four values) instead of one set.
         */
        GraphicsPathCommand.WIDE_LINE_TO = 4;
        /**
         *   Specifies a "move to" drawing command,
         *   but uses two sets of coordinates (four values) instead of one set.
         */
        GraphicsPathCommand.WIDE_MOVE_TO = 5;
        /**
         * Specifies a drawing command that draws a curve from the current drawing position
         * to the x- and y-coordinates specified in the data vector, using 2 control points.
         */
        GraphicsPathCommand.CUBIC_CURVE = 6;
        return GraphicsPathCommand;
    }());

    /**

     * Defines the values to use for specifying path-drawing commands.
     * The values in this class are used by the Graphics.drawPath() method,
     *or stored in the commands vector of a GraphicsPath object.
     */
    var GraphicsPath = /** @class */ (function () {
        function GraphicsPath(commands, data, winding_rule) {
            if (commands === void 0) { commands = null; }
            if (data === void 0) { data = null; }
            if (winding_rule === void 0) { winding_rule = GraphicsPathWinding.EVEN_ODD; }
            this._orientedBoxBoundsDirty = true;
            this._startMerge = -1;
            this._endMerge = -1;
            this._mergeSource = -1;
            this._mergetarget = -1;
            this._connectedIdx = [];
            this._positionOffset = [];
            this.forceClose = false;
            this._cache = {};
            this._cacheSharedSegments = {};
            this._data = [];
            this._commands = [];
            this._style = null;
            this.verts = [];
            this._positions = [];
            if (commands != null && data != null) {
                this._data[0] = data;
                this._commands[0] = commands;
            }
            else {
                this._data[0] = [];
                this._commands[0] = [];
            }
            this._startPoint = new Point();
            this._cur_point = new Point();
            this._winding_rule = winding_rule;
            this._winding_directions = [];
        }
        Object.defineProperty(GraphicsPath.prototype, "data_type", {
            get: function () {
                return GraphicsPath.data_type;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GraphicsPath.prototype, "style", {
            get: function () {
                return this._style;
            },
            set: function (value) {
                this._style = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GraphicsPath.prototype, "fill", {
            get: function () {
                if (this._style == null)
                    return null;
                if (this._style.data_type == GraphicsFillStyle.data_type)
                    return this._style;
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GraphicsPath.prototype, "stroke", {
            get: function () {
                if (this._style == null)
                    return null;
                if (this._style.data_type == GraphicsStrokeStyle.data_type)
                    return this._style;
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GraphicsPath.prototype, "commands", {
            get: function () {
                return this._commands;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GraphicsPath.prototype, "data", {
            get: function () {
                return this._data;
            },
            enumerable: true,
            configurable: true
        });
        GraphicsPath.prototype.cacheSegment = function (contourIdx, segmentIdx, type, startx, starty, endx, endy, ctrlx, ctrly) {
            if (ctrlx === void 0) { ctrlx = null; }
            if (ctrly === void 0) { ctrly = null; }
            var idStr = type.toString() + "#";
            idStr += (startx > endx) ? (startx.toString() + "#" + endx.toString()) : (endx.toString() + "#" + startx.toString());
            idStr += (starty > endy) ? (starty.toString() + "#" + endy.toString()) : (endy.toString() + "#" + starty.toString());
            if (ctrlx != null && ctrly != null)
                idStr += ctrlx.toString() + "#" + ctrly.toString();
            var curCacheItem = this._cache[idStr];
            if (curCacheItem == null) {
                this._cache[idStr] = curCacheItem = [];
            }
            curCacheItem.push(contourIdx);
            curCacheItem.push(segmentIdx);
            if (curCacheItem.length > 2) {
                this._cacheSharedSegments[idStr] = curCacheItem;
            }
        };
        GraphicsPath.prototype.curveTo = function (controlX, controlY, anchorX, anchorY) {
            // if controlpoint and anchor are same, we add lineTo command
            if ((controlX == anchorX) && (controlY == anchorY)) {
                this.lineTo(controlX, controlY);
                //this.moveTo(anchorX, anchorY);
                return;
            }
            // if anchor is current point, but controlpoint is different, we lineto controlpoint
            if (((this._cur_point.x == anchorX) && (this._cur_point.y == anchorY)) && ((this._cur_point.x != controlX) || (this._cur_point.y != controlY))) {
                this.lineTo(controlX, controlY);
                this.moveTo(anchorX, anchorY);
                return;
            }
            // if controlpoint is current point, but anchor is different, we lineto anchor
            if (((this._cur_point.x != anchorX) || (this._cur_point.y != anchorY)) && ((this._cur_point.x == controlX) && (this._cur_point.y == controlY))) {
                this.lineTo(anchorX, anchorY);
                return;
            }
            // if controlpoint and anchor are same as current point
            if (((this._cur_point.x == anchorX) && (this._cur_point.y == anchorY)) && ((this._cur_point.x == controlX) && (this._cur_point.y == controlY))) {
                //console.log("curveTo command not added because startpoint and endpoint are the same.");
                this.lineTo(anchorX, anchorY);
                return;
            }
            if (this._commands[this._commands.length - 1].length == 0) {
                // every contour must start with a moveTo command, so we make sure we have correct startpoint
                this._commands[this._commands.length - 1].push(GraphicsPathCommand.MOVE_TO);
                this._data[this._data.length - 1].push(this._cur_point.x);
                this._data[this._data.length - 1].push(this._cur_point.y);
            }
            this._commands[this._commands.length - 1].push(GraphicsPathCommand.CURVE_TO);
            this._data[this._data.length - 1].push(controlX);
            this._data[this._data.length - 1].push(controlY);
            this._data[this._data.length - 1].push(anchorX);
            this._data[this._data.length - 1].push(anchorY);
            this._cur_point.x = anchorX;
            this._cur_point.y = anchorY;
        };
        GraphicsPath.prototype.cubicCurveTo = function (controlX, controlY, control2X, control2Y, anchorX, anchorY) {
            console.log("cubicCurveTo not yet fully supported.");
            if ((this._cur_point.x == anchorX) && (this._cur_point.y == anchorY)) {
                //console.log("curveTo command not added because startpoint and endpoint are the same.");
                return;
            }
            if (this._commands[this._commands.length - 1].length == 0) {
                // every contour must start with a moveTo command, so we make sure we have correct startpoint
                this._commands[this._commands.length - 1].push(GraphicsPathCommand.MOVE_TO);
                this._data[this._data.length - 1].push(this._cur_point.x);
                this._data[this._data.length - 1].push(this._cur_point.y);
            }
            this._commands[this._commands.length - 1].push(GraphicsPathCommand.CURVE_TO);
            this._data[this._data.length - 1].push(controlX);
            this._data[this._data.length - 1].push(controlY);
            this._data[this._data.length - 1].push(anchorX);
            this._data[this._data.length - 1].push(anchorY);
            this._cur_point.x = anchorX;
            this._cur_point.y = anchorY;
        };
        GraphicsPath.prototype.lineTo = function (x, y) {
            if ((this._cur_point.x == x) && (this._cur_point.y == y)) {
                //console.log("lineTo command not added because startpoint and endpoint are the same.");
                return;
            }
            if (this._commands[this._commands.length - 1].length == 0) {
                // every contour must start with a moveTo command, so we make sure we have correct startpoint
                this._commands[this._commands.length - 1].push(GraphicsPathCommand.MOVE_TO);
                this._data[this._data.length - 1].push(this._cur_point.x);
                this._data[this._data.length - 1].push(this._cur_point.y);
            }
            this._commands[this._commands.length - 1].push(GraphicsPathCommand.LINE_TO);
            this._data[this._data.length - 1].push(x);
            this._data[this._data.length - 1].push(y);
            this._cur_point.x = x;
            this._cur_point.y = y;
        };
        GraphicsPath.prototype.moveTo = function (x, y) {
            if ((this._cur_point.x == x) && (this._cur_point.y == y)) {
                //console.log("moveTo command not added because startpoint and endpoint are the same.");
                return;
            }
            // whenever a moveTo command apears, we start a new contour
            if (this._commands[this._commands.length - 1].length > 0) {
                this._commands.push([GraphicsPathCommand.MOVE_TO]);
                this._data.push([x, y]);
            }
            this._startPoint.x = x;
            this._startPoint.y = y;
            this._cur_point.x = x;
            this._cur_point.y = y;
        };
        GraphicsPath.prototype.wideLineTo = function (x, y) {
        };
        GraphicsPath.prototype.wideMoveTo = function (x, y) {
        };
        /* merges 2 contours together that share segments. the shared segments get removed*/
        GraphicsPath.prototype.mergeContours = function () {
            //console.log("merge", this._mergeSource, this._mergetarget, this._startMerge, this._endMerge);
            //console.log("merge", this.data[this._mergetarget]);
            //console.log("merge", this.data[this._mergeSource]);
            var direction = -1;
            if (this._startMerge == this._endMerge) {
                // only 1 segment to process. 
                // we need to look at the points to know in what direction the second path must be added to the first path
                var mergeIdx = this._connectedIdx[this._mergetarget][this._startMerge];
                var startx = this.data[this._mergetarget][this._positionOffset[this._mergetarget][this._startMerge] - 2];
                var starty = this.data[this._mergetarget][this._positionOffset[this._mergetarget][this._startMerge] - 1];
                var endx = this.data[this._mergetarget][this._positionOffset[this._mergetarget][this._startMerge]];
                var endy = this.data[this._mergetarget][this._positionOffset[this._mergetarget][this._startMerge] + 1];
                var startx2 = this.data[this._mergeSource][this._positionOffset[this._mergeSource][mergeIdx]];
                var starty2 = this.data[this._mergeSource][this._positionOffset[this._mergeSource][mergeIdx] + 1];
                var endx2 = this.data[this._mergeSource][this._positionOffset[this._mergeSource][mergeIdx] + 2];
                var endy2 = this.data[this._mergeSource][this._positionOffset[this._mergeSource][mergeIdx] + 3];
                if (startx == startx2 && starty == starty2 && endx == endx2 && endy == endy2) {
                    direction = 1;
                }
            }
            var startMergeIdx = this._connectedIdx[this._mergetarget][this._startMerge];
            var endMergeIdx = this._connectedIdx[this._mergetarget][this._endMerge];
            var numConnectedSegments = Math.abs(this._startMerge - this._endMerge) + 1;
            var segmentsToProcess = this._commands[this._mergeSource].length - numConnectedSegments;
            var direction = -1;
            if (startMergeIdx > endMergeIdx) {
                direction = 1;
                //console.log("segment goes in opposite direction");
            }
            var cur = startMergeIdx;
            var end_x = 0;
            var end_y = 0;
            var prev_x = 0;
            var prev_y = 0;
            var ctrl_x = 0;
            var ctrl_y = 0;
            var curve_verts;
            var k = 0;
            var k_len = 0;
            var data_cnt = this._positionOffset[this._mergeSource][startMergeIdx];
            for (var i = 0; i < segmentsToProcess; i++) {
                cur += direction;
                if (cur >= this._commands[this._mergeSource].length) {
                    cur -= this._commands[this._mergeSource].length;
                }
                if (cur < 0) {
                    cur += this._commands[this._mergeSource].length;
                }
                switch (this._commands[this._mergeSource][cur]) {
                    case GraphicsPathCommand.LINE_TO:
                        end_x = this.data[this._mergeSource][this._positionOffset[this._mergeSource][cur]];
                        end_y = this.data[this._mergeSource][this._positionOffset[this._mergeSource][cur] + 1];
                        //console.log("LINE_TO ", i, end_x, end_y);
                        this._positions[this._mergetarget].push(end_x);
                        this._positions[this._mergetarget].push(end_y);
                        prev_x = end_x;
                        prev_y = end_y;
                        break;
                    case GraphicsPathCommand.CURVE_TO:
                        ctrl_x = this.data[this._mergeSource][this._positionOffset[this._mergeSource][cur]];
                        ctrl_y = this.data[this._mergeSource][this._positionOffset[this._mergeSource][cur] + 1];
                        end_x = this.data[this._mergeSource][this._positionOffset[this._mergeSource][cur] + 2];
                        end_y = this.data[this._mergeSource][this._positionOffset[this._mergeSource][cur] + 3];
                        //console.log("CURVE_TO ", i, ctrl_x, ctrl_y, end_x, end_y);
                        curve_verts = [];
                        GraphicsFactoryHelper.tesselateCurve(prev_x, prev_y, ctrl_x, ctrl_y, end_x, end_y, curve_verts);
                        k_len = curve_verts.length;
                        for (k = 0; k < k_len; k += 2) {
                            this._positions[this._mergetarget].push(curve_verts[k]);
                            this._positions[this._mergetarget].push(curve_verts[k + 1]);
                        }
                        prev_x = end_x;
                        prev_y = end_y;
                        break;
                }
            }
            this._startMerge = -1;
            this._endMerge = -1;
            this._mergetarget = -1;
            this._mergeSource = -1;
        };
        GraphicsPath.prototype.prepare = function () {
            var commands;
            var isValidCommand = [];
            var contour_merged = [];
            var data;
            var c, i, k, k_len = 0;
            var data_cnt = 0;
            var prev_x, prev_y, end_x, end_y, ctrl_x, ctrl_y = 0;
            var curve_verts;
            var cmd_len = this.commands.length;
            for (c = 0; c < cmd_len; c++) {
                commands = this.commands[c];
                contour_merged[c] = false;
                data = this.data[c];
                this._positions[c] = [];
                isValidCommand[c] = [];
                this._connectedIdx[c] = [];
                this._positionOffset[c] = [];
                if ((data[0] != data[data.length - 2]) || (data[1] != data[data.length - 1])) {
                    if (this.forceClose) {
                        commands[commands.length] = GraphicsPathCommand.LINE_TO;
                        data[data.length] = data[0];
                        data[data.length] = data[1];
                    }
                    else {
                    }
                }
            }
            var cmd_len = this.commands.length;
            for (c = 0; c < cmd_len; c++) {
                commands = this.commands[c];
                data = this.data[c];
                data_cnt = 0;
                prev_x = data[data_cnt++];
                prev_y = data[data_cnt++];
                end_x = 0;
                end_y = 0;
                ctrl_x = 0;
                ctrl_y = 0;
                this._positions[c].push(prev_x);
                this._positions[c].push(prev_y);
                // now we collect the final position data
                // a command list is no longer needed for this position data,
                // we resolve all curves to line segments here
                this._startMerge = -1;
                this._endMerge = -1;
                this._mergetarget = -1;
                this._mergeSource = -1;
                data_cnt = 0;
                prev_x = data[data_cnt++];
                prev_y = data[data_cnt++];
                for (i = 1; i < commands.length; i++) {
                    switch (commands[i]) {
                        case GraphicsPathCommand.MOVE_TO:
                            console.log("ERROR ! ONLY THE FIRST COMMAND FOR A CONTOUR IS ALLOWED TO BE A 'MOVE_TO' COMMAND");
                            break;
                        case GraphicsPathCommand.LINE_TO:
                            end_x = data[data_cnt++];
                            end_y = data[data_cnt++];
                            //console.log("LINE_TO ", i, end_x, end_y);
                            this._positions[c].push(end_x);
                            this._positions[c].push(end_y);
                            prev_x = end_x;
                            prev_y = end_y;
                            break;
                        case GraphicsPathCommand.CURVE_TO:
                            ctrl_x = data[data_cnt++];
                            ctrl_y = data[data_cnt++];
                            end_x = data[data_cnt++];
                            end_y = data[data_cnt++];
                            //console.log("CURVE_TO ", i, ctrl_x, ctrl_y, end_x, end_y);
                            curve_verts = [];
                            GraphicsFactoryHelper.tesselateCurve(prev_x, prev_y, ctrl_x, ctrl_y, end_x, end_y, curve_verts);
                            k_len = curve_verts.length;
                            for (k = 0; k < k_len; k += 2) {
                                this._positions[c].push(curve_verts[k]);
                                this._positions[c].push(curve_verts[k + 1]);
                            }
                            prev_x = end_x;
                            prev_y = end_y;
                            break;
                    }
                }
            }
        };
        GraphicsPath.prototype.invalidate = function () {
            this._orientedBoxBoundsDirty = true;
        };
        GraphicsPath.prototype.getBoxBounds = function (matrix3D, cache, target) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (matrix3D)
                return this._internalGetBoxBounds(matrix3D, cache, target);
            if (this._orientedBoxBoundsDirty) {
                this._orientedBoxBoundsDirty = false;
                this._orientedBoxBounds = this._internalGetBoxBounds(null, this._orientedBoxBounds, null);
            }
            if (this._orientedBoxBounds != null)
                target = this._orientedBoxBounds.union(target, target || cache);
            return target;
        };
        GraphicsPath.prototype._internalGetBoxBounds = function (matrix3D, cache, target) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            var minX = 0, minY = 0;
            var maxX = 0, maxY = 0;
            var len = this._positions.length;
            if (len == 0)
                return target;
            var i = 0;
            var index = 0;
            var positions = this._positions[index++];
            var pLen = positions.length;
            var pos1, pos2, rawData;
            if (matrix3D)
                rawData = matrix3D._rawData;
            if (target == null) {
                target = cache || new Box();
                if (matrix3D) {
                    pos1 = positions[i] * rawData[0] + positions[i + 1] * rawData[4] + rawData[12];
                    pos2 = positions[i] * rawData[1] + positions[i + 1] * rawData[5] + rawData[13];
                }
                else {
                    pos1 = positions[i];
                    pos2 = positions[i + 1];
                }
                maxX = minX = pos1;
                maxY = minY = pos2;
                i += 2;
            }
            else {
                maxX = (minX = target.x) + target.width;
                maxY = (minY = target.y) + target.height;
            }
            for (; i < pLen; i += 2) {
                if (matrix3D) {
                    pos1 = positions[i] * rawData[0] + positions[i + 1] * rawData[4] + rawData[12];
                    pos2 = positions[i] * rawData[1] + positions[i + 1] * rawData[5] + rawData[13];
                }
                else {
                    pos1 = positions[i];
                    pos2 = positions[i + 1];
                }
                if (pos1 < minX)
                    minX = pos1;
                else if (pos1 > maxX)
                    maxX = pos1;
                if (pos2 < minY)
                    minY = pos2;
                else if (pos2 > maxY)
                    maxY = pos2;
                if (i >= pLen - 2 && index < len) {
                    i = 0;
                    positions = this._positions[index++];
                    pLen = positions.length;
                }
            }
            target.width = maxX - (target.x = minX);
            target.height = maxY - (target.y = minY);
            target.depth = 0;
            return target;
        };
        GraphicsPath.data_type = "[graphicsdata path]";
        return GraphicsPath;
    }());

    /**
     * The Graphics class contains a set of methods that you can use to create a
     * vector shape. Display objects that support drawing include Sprite and Shape
     * objects. Each of these classes includes a <code>graphics</code> property
     * that is a Graphics object. The following are among those helper functions
     * provided for ease of use: <code>drawRect()</code>,
     * <code>drawRoundRect()</code>, <code>drawCircle()</code>, and
     * <code>drawEllipse()</code>.
     *
     * <p>You cannot create a Graphics object directly from ActionScript code. If
     * you call <code>new Graphics()</code>, an exception is thrown.</p>
     *
     * <p>The Graphics class is final; it cannot be subclassed.</p>
     */
    var GraphicsFactoryStrokes = /** @class */ (function () {
        function GraphicsFactoryStrokes() {
        }
        GraphicsFactoryStrokes.draw_pathes = function (targetGraphics) {
            //return;
            var len = targetGraphics.queued_stroke_pathes.length;
            var i = 0;
            for (i = 0; i < len; i++) {
                var strokePath = targetGraphics.queued_stroke_pathes[i];
                var strokeStyle = strokePath.style;
                var obj = Graphics.get_material_for_color(strokeStyle.color, strokeStyle.alpha);
                var material = obj.material;
                strokePath.prepare();
                var elements;
                // if (targetGraphics.scaleStrokes != null) { //use LineElements
                elements = GraphicsFactoryStrokes.getLineElements([strokePath], material.curves, strokePath.stroke.scaleMode);
                // } else { // use TriangleELements
                // 	elements = GraphicsFactoryStrokes.getTriangleElements([strokePath], material.curves);
                // }
                if (!elements)
                    continue;
                elements.stroke = strokePath.stroke;
                //	if(material.curves)
                //		elements.setCustomAttributes("curves", new Byte4Attributes(attributesBuffer, false));
                //	material.alpha=(<GraphicsStrokeStyle>this.queued_stroke_pathes[i].style).alpha;
                var shape = targetGraphics.addShape(Shape.getShape(elements, material));
                if (obj.colorPos) {
                    shape.style = new Style();
                    var sampler = new ImageSampler();
                    material.animateUVs = true;
                    shape.style.addSamplerAt(sampler, material.getTextureAt(0));
                    shape.style.uvMatrix = new Matrix(0, 0, 0, 0, obj.colorPos.x, obj.colorPos.y);
                }
            }
            targetGraphics.queued_stroke_pathes.length = 0;
        };
        // public static updateStrokesForShape(shape:Shape, scale:Vector3D, scaleMode:string ){
        // 	//return;
        // 	var elements:TriangleElements = <TriangleElements> shape.elements;
        // 	var final_vert_list:Array<number>=[];
        // 	GraphicsFactoryStrokes.draw_path([graphicsPath], final_vert_list, false, scale, scaleMode);
        // 	elements.concatenatedBuffer.count = final_vert_list.length/2;
        // 	elements.setPositions(final_vert_list);
        // 	elements.invalidate();
        // }
        GraphicsFactoryStrokes.getLineElements = function (graphic_pathes, curves, scaleMode) {
            if (scaleMode === void 0) { scaleMode = LineScaleMode.NORMAL; }
            var final_vert_list = [];
            var final_thickness_list = [];
            var len = graphic_pathes.length;
            var positions;
            var strokeStyle;
            var data;
            var i = 0;
            var k = 0;
            var end_x = 0;
            var end_y = 0;
            var prev_x = 0;
            var prev_y = 0;
            var pos_count = 0;
            var thickness_count = 0;
            var half_thickness = 0;
            var cp = 0;
            for (cp = 0; cp < len; cp++) {
                positions = graphic_pathes[cp]._positions;
                strokeStyle = graphic_pathes[cp].stroke;
                half_thickness = (scaleMode != LineScaleMode.HAIRLINE) ? strokeStyle.half_thickness : 0.5;
                for (k = 0; k < positions.length; k++) {
                    //commands = contour_commands[k];
                    data = positions[k];
                    prev_x = data[0];
                    prev_y = data[1];
                    for (i = 2; i < data.length; i += 2) {
                        end_x = data[i];
                        end_y = data[i + 1];
                        // if the points are the same, we dont need to do anything.
                        if ((end_x != prev_x) || (end_y != prev_y)) {
                            final_vert_list[pos_count++] = prev_x;
                            final_vert_list[pos_count++] = prev_y;
                            final_vert_list[pos_count++] = 0;
                            final_vert_list[pos_count++] = end_x;
                            final_vert_list[pos_count++] = end_y;
                            final_vert_list[pos_count++] = 0;
                            final_thickness_list[thickness_count++] = half_thickness;
                        }
                        prev_x = end_x;
                        prev_y = end_y;
                    }
                }
            }
            if (final_vert_list.length == 0)
                return;
            var elements = new LineElements(new AttributesBuffer());
            elements.setPositions(final_vert_list);
            elements.setThickness(final_thickness_list);
            return elements;
        };
        GraphicsFactoryStrokes.getTriangleElements = function (graphic_pathes, curves, scaleMode) {
            if (scaleMode === void 0) { scaleMode = LineScaleMode.NORMAL; }
            var final_vert_list = [];
            var len = graphic_pathes.length;
            var positions;
            var strokeStyle;
            var data;
            var i = 0;
            var k = 0;
            var tmp_dir_point = new Point();
            var last_dir_vec = new Point();
            var tmp_point = new Point();
            var tmp_point2 = new Point();
            var tmp_point3 = new Point();
            var end_x = 0;
            var end_y = 0;
            var prev_x = 0;
            var prev_y = 0;
            var prev_prev_x = 0;
            var prev_prev_y = 0;
            var right_point_x = 0;
            var right_point_y = 0;
            var left_point_x = 0;
            var left_point_y = 0;
            var right_point_merged_x = 0;
            var right_point_merged_y = 0;
            var left_point_merged_x = 0;
            var left_point_merged_y = 0;
            var left_point_contour_x = 0;
            var left_point_contour_y = 0;
            var left_point_contour_prev_x = 0;
            var left_point_contour_prev_y = 0;
            var right_point_contour_x = 0;
            var right_point_contour_y = 0;
            var right_point_contour_prev_x = 0;
            var right_point_contour_prev_y = 0;
            var start_right_x = 0;
            var start_right_y = 0;
            var start_left_x = 0;
            var start_left_y = 0;
            var end_right_x = 0;
            var end_right_y = 0;
            var end_left_x = 0;
            var end_left_y = 0;
            var prev_normal_x;
            var prev_normal_y;
            var addJoints = true;
            var add_segment = false;
            var closed = false;
            var new_dir = 0;
            var dir_delta = 0;
            var last_direction = 0;
            var distance_miter = 0;
            var half_angle = 0;
            var distanceX = 0;
            var distanceY = 0;
            var half_thicknessX = 0;
            var half_thicknessY = 0;
            var new_cmds = [];
            var new_pnts = [];
            var new_cmds_cnt = 0;
            var new_pnts_cnt = 0;
            //console.log("process stroke");
            var cp = 0;
            for (cp = 0; cp < len; cp++) {
                positions = graphic_pathes[cp]._positions;
                strokeStyle = graphic_pathes[cp].stroke;
                half_thicknessX = strokeStyle.half_thickness;
                half_thicknessY = strokeStyle.half_thickness;
                //console.log("process contour", positions);
                if (scaleMode == LineScaleMode.NORMAL) {
                    /*
                    if((half_thicknessX*scale.x)<=0.5)
                        half_thicknessX=0.5*(1/scale.x);
                    
                    if((half_thicknessY*scale.y)<=0.5)
                        half_thicknessY=0.5*(1/scale.y);
                        */
                }
                // else if(scaleMode==LineScaleMode.NONE){
                // 	half_thicknessX*=(1/scale.x);
                // 	half_thicknessY*=(1/scale.y);
                // }
                // if(strokeStyle.scaleMode==LineScaleMode.HAIRLINE){
                // 	half_thicknessX=0.5*(1/scale.x);
                // 	half_thicknessY=0.5*(1/scale.y);
                // }
                for (k = 0; k < positions.length; k++) {
                    //commands = contour_commands[k];
                    data = positions[k];
                    // check if the path is closed. if yes, than set the last_dir_vec from last segment
                    closed = true;
                    prev_prev_x = null;
                    prev_prev_y = null;
                    if ((data[0] != data[data.length - 2]) || (data[1] != data[data.length - 1]))
                        closed = false;
                    else {
                        last_dir_vec.x = data[data.length - 2] - data[data.length - 4];
                        last_dir_vec.y = data[data.length - 1] - data[data.length - 3];
                        last_dir_vec.normalize();
                        last_direction = Math.atan2(last_dir_vec.y, last_dir_vec.x) * MathConsts.RADIANS_TO_DEGREES;
                        prev_prev_x = data[data.length - 2];
                        prev_prev_y = data[data.length - 1];
                        //console.log("Path is closed, we set initial direction: "+last_direction);
                    }
                    prev_x = data[0];
                    prev_y = data[1];
                    new_cmds = [];
                    new_pnts = [];
                    new_cmds_cnt = 0;
                    new_pnts_cnt = 0;
                    prev_normal_x = -1 * last_dir_vec.y;
                    prev_normal_y = last_dir_vec.x;
                    for (i = 2; i < data.length; i += 2) {
                        end_x = data[i];
                        end_y = data[i + 1];
                        //half_thicknessX=bkphalf_thicknessX*(i/data.length);
                        //half_thicknessY=bkphalf_thicknessY*(i/data.length);
                        // if the points are the same, we dont need to do anything.
                        if ((end_x != prev_x) || (end_y != prev_y)) {
                            //get the directional vector and the direction for this segment
                            tmp_dir_point.x = end_x - prev_x;
                            tmp_dir_point.y = end_y - prev_y;
                            tmp_dir_point.normalize();
                            new_dir = Math.atan2(tmp_dir_point.y, tmp_dir_point.x) * MathConsts.RADIANS_TO_DEGREES;
                            // get the difference in angle to the last segment
                            dir_delta = new_dir - last_direction;
                            if (dir_delta > 180) {
                                dir_delta -= 360;
                            }
                            if (dir_delta < -180) {
                                dir_delta += 360;
                            }
                            last_direction = new_dir;
                            // rotate direction around 90 degree
                            tmp_point.x = -1 * tmp_dir_point.y;
                            tmp_point.y = tmp_dir_point.x;
                            // find the 2 points left and right of the segments end-point
                            right_point_x = prev_x + (tmp_point.x * half_thicknessX);
                            right_point_y = prev_y + (tmp_point.y * half_thicknessY);
                            left_point_x = prev_x - (tmp_point.x * half_thicknessX);
                            left_point_y = prev_y - (tmp_point.y * half_thicknessY);
                            add_segment = false;
                            // check if this is the first segment, and the path is not closed
                            // in this case, we can just set the points to the contour points
                            if ((i == 2) && (!closed)) {
                                //console.log("segment "+i+"Path is not closed, we can just add the first segment")
                                add_segment = true;
                            }
                            else {
                                // dir_delta delta is the difference in direction between the segments
                                // 2 segments forming a straight line  have a dir_delta of 0
                                // a segments that goes straight back would have a dir_delta of 180 or -180
                                // we want to convert this into a angle where 0 means going back and 180 means straight forward.
                                half_angle = (180 - (dir_delta));
                                if (dir_delta < 0) {
                                    half_angle = (-180 - (dir_delta));
                                }
                                if ((dir_delta == 0) || (Math.abs(dir_delta) == 180)) {
                                    // straight line (back or forth)
                                    // only add segment if this is the first
                                    add_segment = (i == 2);
                                }
                                else if (Math.abs(half_angle) < 5) {
                                    // line going back with very steep angle
                                    add_segment = true;
                                }
                                else {
                                    add_segment = true;
                                    //	half_angle is the angle need to rotate our segments direction with
                                    //  in order to have a direction vector that points from original point to the merged contour points							
                                    half_angle = half_angle * -0.5 * MathConsts.DEGREES_TO_RADIANS;
                                    // get the direction vector that splits the angle between the 2 segments in half. 
                                    tmp_point2.x = tmp_dir_point.x * Math.cos(half_angle) + tmp_dir_point.y * Math.sin(half_angle);
                                    tmp_point2.y = tmp_dir_point.y * Math.cos(half_angle) - tmp_dir_point.x * Math.sin(half_angle);
                                    tmp_point2.normalize();
                                    //  calculate the distance that we need to move original point with direction-vector calculated above
                                    // 	very steep angles result in impossible values for distance
                                    //	we need to catch those cases and set sensible fallback for distance
                                    if (Math.abs(dir_delta) <= 1 || Math.abs(dir_delta) >= 359
                                        || (Math.abs(dir_delta) >= 179 && Math.abs(dir_delta) <= 181)) {
                                        distanceX = (dir_delta < 0) ? half_thicknessX : -half_thicknessX;
                                        distanceY = (dir_delta < 0) ? half_thicknessY : -half_thicknessY;
                                    }
                                    else {
                                        distanceX = half_thicknessX / Math.sin(half_angle);
                                        distanceY = half_thicknessY / Math.sin(half_angle);
                                    }
                                    /*console.log("\ndir_delta", dir_delta);
                                    console.log("half_angle", half_angle);
                                    console.log("distance", distance);
                                    console.log("dist", dist);*/
                                    /*
                                    var distx:number=end_x-prev_x;
                                    var disty:number=end_y-prev_y;
                                    var dist:number=Math.sqrt(distx*distx + disty*disty);


                                    distx=prev_prev_x-prev_x;
                                    disty=prev_prev_y-prev_y;
                                    var dist2:number=Math.sqrt(distx*distx + disty*disty);
                                    if(dist2<dist){
                                        dist=dist2;
                                    }
                                    //console.log("dist", dist);

                                    if(Math.abs(distance)>dist){
                                        //distance=(distance>=0)?dist:-dist;
                                    }*/
                                    // 	get the merged points left and right 
                                    //	by moving from original point along the direction vector 
                                    right_point_merged_x = prev_x - (tmp_point2.x * distanceX);
                                    right_point_merged_y = prev_y - (tmp_point2.y * distanceY);
                                    left_point_merged_x = prev_x + (tmp_point2.x * distanceX);
                                    left_point_merged_y = prev_y + (tmp_point2.y * distanceY);
                                    // use different points dependent if dir_delta is positive or negative
                                    if (dir_delta > 0) {
                                        left_point_contour_x = prev_x - (tmp_point.x * half_thicknessX);
                                        left_point_contour_y = prev_y - (tmp_point.y * half_thicknessY);
                                        left_point_contour_prev_x = prev_x - (prev_normal_x * half_thicknessX);
                                        left_point_contour_prev_y = prev_y - (prev_normal_y * half_thicknessY);
                                        right_point_x = right_point_merged_x;
                                        right_point_y = right_point_merged_y;
                                        left_point_x = left_point_contour_x;
                                        left_point_y = left_point_contour_y;
                                    }
                                    else {
                                        right_point_contour_x = prev_x + (tmp_point.x * half_thicknessX);
                                        right_point_contour_y = prev_y + (tmp_point.y * half_thicknessY);
                                        right_point_contour_prev_x = prev_x + (prev_normal_x * half_thicknessX);
                                        right_point_contour_prev_y = prev_y + (prev_normal_y * half_thicknessY);
                                        left_point_x = left_point_merged_x;
                                        left_point_y = left_point_merged_y;
                                        right_point_x = right_point_contour_x;
                                        right_point_y = right_point_contour_y;
                                    }
                                    addJoints = true;
                                    // check if we need to add a joint
                                    if (strokeStyle.jointstyle == JointStyle.MITER) {
                                        // 	miter means that we have no bevel effect on the corners, 
                                        // 	as long as the mitter-value is within a given miter_limit
                                        distance_miter = Math.sqrt((distanceX * distanceX + distanceY * distanceY) / (half_thicknessX * half_thicknessX + half_thicknessY * half_thicknessY) - 1);
                                        if (distance_miter <= strokeStyle.miter_limit) {
                                            // if within miter_limit, miter is applied, and we only need to add the merged points for both sides
                                            addJoints = false;
                                            left_point_x = left_point_merged_x;
                                            left_point_y = left_point_merged_y;
                                            right_point_x = right_point_merged_x;
                                            right_point_y = right_point_merged_y;
                                        }
                                        else {
                                            if (dir_delta > 0) {
                                                // right side is merged, left side has 2 points
                                                left_point_contour_x = left_point_contour_x - (tmp_dir_point.x * (strokeStyle.miter_limit * half_thicknessX));
                                                left_point_contour_y = left_point_contour_y - (tmp_dir_point.y * (strokeStyle.miter_limit * half_thicknessY));
                                                tmp_point3.x = prev_normal_y * -1;
                                                tmp_point3.y = prev_normal_x;
                                                left_point_contour_prev_x = left_point_contour_prev_x - (tmp_point3.x * (strokeStyle.miter_limit * half_thicknessX));
                                                left_point_contour_prev_y = left_point_contour_prev_y - (tmp_point3.y * (strokeStyle.miter_limit * half_thicknessY));
                                            }
                                            else {
                                                // left side is merged, right side has 2 points
                                                right_point_contour_x = right_point_contour_x - (tmp_dir_point.x * (strokeStyle.miter_limit * half_thicknessX));
                                                right_point_contour_y = right_point_contour_y - (tmp_dir_point.y * (strokeStyle.miter_limit * half_thicknessY));
                                                tmp_point3.x = prev_normal_y * -1;
                                                tmp_point3.y = prev_normal_x;
                                                right_point_contour_prev_x = right_point_contour_prev_x - (tmp_point3.x * (strokeStyle.miter_limit * half_thicknessX));
                                                right_point_contour_prev_y = right_point_contour_prev_y - (tmp_point3.y * (strokeStyle.miter_limit * half_thicknessY));
                                            }
                                        }
                                    }
                                    if (addJoints) {
                                        new_cmds[new_cmds_cnt++] = (strokeStyle.jointstyle != JointStyle.ROUND) ? GraphicsPathCommand.BUILD_JOINT : GraphicsPathCommand.BUILD_ROUND_JOINT;
                                        if (dir_delta > 0) {
                                            // right side is merged, left side has 2 points
                                            new_pnts[new_pnts_cnt++] = right_point_merged_x;
                                            new_pnts[new_pnts_cnt++] = right_point_merged_y;
                                            new_pnts[new_pnts_cnt++] = left_point_contour_prev_x;
                                            new_pnts[new_pnts_cnt++] = left_point_contour_prev_y;
                                            new_pnts[new_pnts_cnt++] = left_point_contour_x;
                                            new_pnts[new_pnts_cnt++] = left_point_contour_y;
                                        }
                                        else {
                                            // left side is merged, right side has 2 points
                                            new_pnts[new_pnts_cnt++] = right_point_contour_prev_x;
                                            new_pnts[new_pnts_cnt++] = right_point_contour_prev_y;
                                            new_pnts[new_pnts_cnt++] = left_point_merged_x;
                                            new_pnts[new_pnts_cnt++] = left_point_merged_y;
                                            new_pnts[new_pnts_cnt++] = right_point_contour_x;
                                            new_pnts[new_pnts_cnt++] = right_point_contour_y;
                                        }
                                        if (strokeStyle.jointstyle == JointStyle.ROUND) {
                                            new_pnts[new_pnts_cnt++] = prev_x - (tmp_point2.x * Math.abs(half_thicknessX));
                                            new_pnts[new_pnts_cnt++] = prev_y - (tmp_point2.y * Math.abs(half_thicknessY));
                                            if (dir_delta > 0) {
                                                new_pnts[new_pnts_cnt++] = left_point_contour_prev_x;
                                                new_pnts[new_pnts_cnt++] = left_point_contour_prev_y;
                                                new_pnts[new_pnts_cnt++] = left_point_contour_x;
                                                new_pnts[new_pnts_cnt++] = left_point_contour_y;
                                            }
                                            else {
                                                new_pnts[new_pnts_cnt++] = right_point_contour_prev_x;
                                                new_pnts[new_pnts_cnt++] = right_point_contour_prev_y;
                                                new_pnts[new_pnts_cnt++] = right_point_contour_x;
                                                new_pnts[new_pnts_cnt++] = right_point_contour_y;
                                            }
                                        }
                                    }
                                }
                            }
                            prev_normal_x = tmp_point.x;
                            prev_normal_y = tmp_point.y;
                            if (add_segment) {
                                new_cmds[new_cmds_cnt++] = GraphicsPathCommand.LINE_TO;
                                new_pnts[new_pnts_cnt++] = right_point_x;
                                new_pnts[new_pnts_cnt++] = right_point_y;
                                new_pnts[new_pnts_cnt++] = left_point_x;
                                new_pnts[new_pnts_cnt++] = left_point_y;
                            }
                            prev_prev_x = prev_x;
                            prev_prev_y = prev_y;
                            prev_x = end_x;
                            prev_y = end_y;
                            if (i == data.length - 2) {
                                new_cmds[new_cmds_cnt++] = GraphicsPathCommand.NO_OP;
                                if (!closed) {
                                    new_pnts[new_pnts_cnt++] = prev_x + (tmp_point.x * half_thicknessX);
                                    new_pnts[new_pnts_cnt++] = prev_y + (tmp_point.y * half_thicknessY);
                                    new_pnts[new_pnts_cnt++] = prev_x - (tmp_point.x * half_thicknessX);
                                    new_pnts[new_pnts_cnt++] = prev_y - (tmp_point.y * half_thicknessY);
                                }
                                else {
                                    new_pnts[new_pnts_cnt++] = new_pnts[0];
                                    new_pnts[new_pnts_cnt++] = new_pnts[1];
                                    new_pnts[new_pnts_cnt++] = new_pnts[2];
                                    new_pnts[new_pnts_cnt++] = new_pnts[3];
                                }
                            }
                        }
                    }
                    new_cmds_cnt = 0;
                    new_pnts_cnt = 0;
                    for (i = 0; i < new_cmds.length; i++) {
                        if (new_cmds[i] == GraphicsPathCommand.LINE_TO) {
                            start_right_x = new_pnts[new_pnts_cnt++];
                            start_right_y = new_pnts[new_pnts_cnt++];
                            start_left_x = new_pnts[new_pnts_cnt++];
                            start_left_y = new_pnts[new_pnts_cnt++];
                            end_right_x = new_pnts[new_pnts_cnt];
                            end_right_y = new_pnts[new_pnts_cnt + 1];
                            end_left_x = new_pnts[new_pnts_cnt + 2];
                            end_left_y = new_pnts[new_pnts_cnt + 3];
                            //0GraphicsFactoryHelper.drawPoint(start_right.x,start_right.y, final_vert_list, false);
                            //GraphicsFactoryHelper.drawPoint(start_left.x,start_left.y, final_vert_list, false);
                            //GraphicsFactoryHelper.drawPoint(end_right.x,end_right.y, final_vert_list, false);
                            //GraphicsFactoryHelper.drawPoint(end_left_x,end_left_y, final_vert_list, false);
                            GraphicsFactoryHelper.addTriangle(start_right_x, start_right_y, end_right_x, end_right_y, start_left_x, start_left_y, 0, final_vert_list, curves);
                            GraphicsFactoryHelper.addTriangle(start_left_x, start_left_y, end_right_x, end_right_y, end_left_x, end_left_y, 0, final_vert_list, curves);
                        }
                        else if (new_cmds[i] >= GraphicsPathCommand.BUILD_JOINT) {
                            end_right_x = new_pnts[new_pnts_cnt++];
                            end_right_y = new_pnts[new_pnts_cnt++];
                            start_right_x = new_pnts[new_pnts_cnt++];
                            start_right_y = new_pnts[new_pnts_cnt++];
                            start_left_x = new_pnts[new_pnts_cnt++];
                            start_left_y = new_pnts[new_pnts_cnt++];
                            GraphicsFactoryHelper.addTriangle(start_right_x, start_right_y, start_left_x, start_left_y, end_right_x, end_right_y, 0, final_vert_list, curves);
                            if (new_cmds[i] == GraphicsPathCommand.BUILD_ROUND_JOINT) {
                                end_left_x = new_pnts[new_pnts_cnt++];
                                end_left_y = new_pnts[new_pnts_cnt++];
                                start_right_x = new_pnts[new_pnts_cnt++];
                                start_right_y = new_pnts[new_pnts_cnt++];
                                start_left_x = new_pnts[new_pnts_cnt++];
                                start_left_y = new_pnts[new_pnts_cnt++];
                                GraphicsFactoryHelper.tesselateCurve(start_right_x, start_right_y, end_left_x, end_left_y, start_left_x, start_left_y, final_vert_list, true);
                            }
                        }
                    }
                    if (!closed) {
                        last_dir_vec.x = data[2] - data[0];
                        last_dir_vec.y = data[3] - data[1];
                        last_dir_vec.normalize();
                        //console.log("createCap", data[0], data[1], new_pnts[0], new_pnts[1], new_pnts[2], new_pnts[3], last_dir_vec.x, last_dir_vec.y, strokeStyle.capstyle, -1, half_thickness, final_vert_list, curves, scale);
                        GraphicsFactoryHelper.createCap(data[0], data[1], new_pnts[0], new_pnts[1], new_pnts[2], new_pnts[3], last_dir_vec.x, last_dir_vec.y, strokeStyle.capstyle, -1, half_thicknessX, half_thicknessY, final_vert_list, curves);
                        last_dir_vec.x = data[data.length - 2] - data[data.length - 4];
                        last_dir_vec.y = data[data.length - 1] - data[data.length - 3];
                        last_dir_vec.normalize();
                        GraphicsFactoryHelper.createCap(data[data.length - 2], data[data.length - 1], new_pnts[new_pnts.length - 4], new_pnts[new_pnts.length - 3], new_pnts[new_pnts.length - 2], new_pnts[new_pnts.length - 1], last_dir_vec.x, last_dir_vec.y, strokeStyle.capstyle, 1, half_thicknessX, half_thicknessY, final_vert_list, curves);
                    }
                }
            }
            //targetGraphic.queued_stroke_pathes.length=0;
            if (final_vert_list.length == 0)
                return;
            var attributesView = new AttributesView(Float32Array, curves ? 3 : 2);
            attributesView.set(final_vert_list);
            var attributesBuffer = attributesView.attributesBuffer.cloneBufferView();
            attributesView.dispose();
            var elements = new TriangleElements(attributesBuffer);
            elements.setPositions(new Float2Attributes(attributesBuffer));
            return elements;
        };
        return GraphicsFactoryStrokes;
    }());

    /**
     *
     * Graphics is a collection of Shapes, each of which contain the actual geometrical data such as vertices,
     * normals, uvs, etc. It also contains a reference to an animation class, which defines how the geometry moves.
     * A Graphics object is assigned to a Sprite, a scene graph occurence of the geometry, which in turn assigns
     * the SubGeometries to its respective TriangleGraphic objects.
     *
     *
     *
     *
     * @class Graphics
     */
    var Graphics = /** @class */ (function (_super) {
        __extends$5(Graphics, _super);
        /**
         * Creates a new Graphics object.
         */
        function Graphics() {
            var _this = _super.call(this) || this;
            _this._queuedShapeTags = [];
            _this._shapes = [];
            _this._current_position = new Point();
            _this._scale = new Vector3D();
            _this._scaleX = 0;
            _this._scaleY = 0;
            _this._drawingDirty = false;
            _this.usages = 0;
            _this.push = Array.prototype.push;
            //store associated entity object, otherwise assign itself as entity
            _this._drawingDirty = false;
            _this._current_position = new Point();
            _this._queued_fill_pathes = [];
            _this._queued_stroke_pathes = [];
            _this._active_fill_path = null;
            _this._active_stroke_path = null;
            _this._fillStyle = null;
            _this._lineStyle = null;
            _this._onInvalidateDelegate = function (event) { return _this._onInvalidate(event); };
            return _this;
        }
        Graphics.getGraphics = function () {
            if (Graphics._pool.length)
                return Graphics._pool.pop();
            return new Graphics();
        };
        Graphics.clearPool = function () {
            Graphics._pool = [];
        };
        // public getSpriteScale(view:View = null):Vector3D
        // {
        // 	if(this._entity)
        // 		this._scale.copyFrom(this._entity.transform.concatenatedMatrix3D.decompose()[3]);
        // 	else
        // 		this._scale.identity();
        // 	if (view) {
        // 		this._scale.x *= view.focalLength*view.pixelRatio/1000;
        // 		this._scale.y *= view.focalLength/1000;
        // 	}
        // 	return this._scale;
        // }
        // public updateScale(view:View)
        // {
        // 	var prevScaleX:number = this._scale.x;
        // 	var prevScaleY:number = this._scale.y;
        // 	var scale:Vector3D = this.getSpriteScale(view);
        // 	if (scale.x == prevScaleX && scale.y == prevScaleY)
        // 	 	return;
        // 	var len:number = this._shapes.length;
        // 	for (var i:number = 0; i < len; i++)
        // 		if(this._shapes[i].isStroke && this._shapes[i].strokePath.stroke() && this._shapes[i].strokePath.stroke().scaleMode != LineScaleMode.NORMAL)
        // 			GraphicsFactoryStrokes.updateStrokesForShape(this._shapes[i], scale, this.scaleStrokes);
        // }
        Graphics.prototype.updateSlice9 = function (scaleX, scaleY) {
            if (this._scaleX == scaleX && this._scaleY == scaleY)
                return;
            this._scaleX = scaleX;
            this._scaleY = scaleY;
            var len = this._shapes.length;
            for (var i = 0; i < len; i++)
                TriangleElementsUtils.updateTriangleGraphicsSlice9(this._shapes[i].elements, this.originalSlice9Size, scaleX, scaleY);
            this.invalidate();
        };
        Object.defineProperty(Graphics.prototype, "assetType", {
            get: function () {
                return Graphics.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Graphics.prototype, "count", {
            get: function () {
                return (this._shapes.length + this._queued_stroke_pathes.length + this._queued_fill_pathes.length + this._queuedShapeTags.length);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Graphics.prototype, "queued_stroke_pathes", {
            get: function () {
                return this._queued_stroke_pathes;
            },
            set: function (value) {
                this._queued_stroke_pathes = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Graphics.prototype, "queued_fill_pathes", {
            get: function () {
                return this._queued_fill_pathes;
            },
            set: function (value) {
                this._queued_fill_pathes = value;
            },
            enumerable: true,
            configurable: true
        });
        Graphics.prototype.add_queued_path = function (value) {
            if (value.style) {
                if (value.style.data_type == GraphicsFillStyle.data_type || value.style.data_type == GradientFillStyle.data_type || value.style.data_type == BitmapFillStyle.data_type) {
                    this._drawingDirty = true;
                    this._queued_fill_pathes.push(value);
                }
                if (value.style.data_type == GraphicsStrokeStyle.data_type) {
                    this._queued_stroke_pathes.push(value);
                    this.endFill();
                }
            }
        };
        /**
         * Adds a GraphicBase wrapping a Elements.
         *
         * @param elements
         */
        Graphics.prototype.addShape = function (shape) {
            var shapeIndex = this.getShapeIndex(shape);
            if (shapeIndex != -1)
                this.removeShapeAt(shapeIndex);
            this._shapes.push(shape);
            shape.addEventListener(RenderableEvent.INVALIDATE_ELEMENTS, this._onInvalidateDelegate);
            shape.addEventListener(RenderableEvent.INVALIDATE_MATERIAL, this._onInvalidateDelegate);
            shape.addEventListener(RenderableEvent.INVALIDATE_STYLE, this._onInvalidateDelegate);
            shape.addEventListener(AssetEvent.INVALIDATE, this._onInvalidateDelegate);
            shape.usages++;
            this._scaleX = 0;
            this._scaleY = 0;
            this.invalidate();
            return shape;
        };
        Graphics.prototype.removeShape = function (shape) {
            var shapeIndex = this.getShapeIndex(shape);
            if (shapeIndex == -1)
                throw new ArgumentError("Shape parameter is not a shape of the caller");
            this.removeShapeAt(shapeIndex);
        };
        Graphics.prototype.removeShapeAt = function (index) {
            if (index < 0 || index >= this._shapes.length)
                throw new RangeError$1("Index is out of range");
            var shape = this._shapes.splice(index, 1)[0];
            shape.removeEventListener(RenderableEvent.INVALIDATE_ELEMENTS, this._onInvalidateDelegate);
            shape.removeEventListener(RenderableEvent.INVALIDATE_MATERIAL, this._onInvalidateDelegate);
            shape.removeEventListener(RenderableEvent.INVALIDATE_STYLE, this._onInvalidateDelegate);
            shape.removeEventListener(AssetEvent.INVALIDATE, this._onInvalidateDelegate);
            shape.usages--;
            if (!shape.usages)
                shape.dispose();
            this.invalidate();
        };
        Graphics.prototype.getShapeAt = function (index) {
            return this._shapes[index];
        };
        Graphics.prototype.getShapeIndex = function (shape) {
            return this._shapes.indexOf(shape);
        };
        Graphics.prototype.applyTransformation = function (transform) {
            var len = this._shapes.length;
            for (var i = 0; i < len; ++i) {
                this._shapes[i].applyTransformation(transform);
            }
        };
        Graphics.prototype.copyTo = function (graphics, cloneShapes) {
            if (cloneShapes === void 0) { cloneShapes = false; }
            if (this._drawingDirty)
                this.endFill();
            if (this.slice9Rectangle) {
                graphics.slice9Rectangle = new Rectangle();
                graphics.slice9Rectangle.copyFrom(this.slice9Rectangle);
                graphics.originalSlice9Size = new Rectangle();
                graphics.originalSlice9Size.copyFrom(this.originalSlice9Size);
                graphics.minSlice9Width = this.minSlice9Width;
                graphics.minSlice9Height = this.minSlice9Height;
            }
            graphics._addShapes(this._shapes, cloneShapes);
        };
        /**
         * Scales the geometry.
         * @param scale The amount by which to scale.
         */
        Graphics.prototype.scale = function (scale) {
            var len = this._shapes.length;
            for (var i = 0; i < len; ++i)
                this._shapes[i].scale(scale);
        };
        Graphics.prototype.clear = function () {
            var shape;
            var len = this._shapes.length;
            for (var i = 0; i < len; i++) {
                shape = this._shapes[i];
                shape.removeEventListener(RenderableEvent.INVALIDATE_ELEMENTS, this._onInvalidateDelegate);
                shape.removeEventListener(RenderableEvent.INVALIDATE_MATERIAL, this._onInvalidateDelegate);
                shape.removeEventListener(RenderableEvent.INVALIDATE_STYLE, this._onInvalidateDelegate);
                shape.removeEventListener(AssetEvent.INVALIDATE, this._onInvalidateDelegate);
                shape.usages--;
                if (!shape.usages)
                    shape.dispose();
            }
            this._shapes.length = 0;
            this.invalidate();
            this._active_fill_path = null;
            this._active_stroke_path = null;
            this._queued_fill_pathes.length = 0;
            this._queued_stroke_pathes.length = 0;
            this._drawingDirty = false;
            this._lineStyle = null;
            this._fillStyle = null;
            //this.invalidateElements();
        };
        /**
         * Clears all resources used by the Graphics object, including SubGeometries.
         */
        Graphics.prototype.dispose = function () {
            this.clear();
            Graphics._pool.push(this);
        };
        /**
         * Scales the uv coordinates (tiling)
         * @param scaleU The amount by which to scale on the u axis. Default is 1;
         * @param scaleV The amount by which to scale on the v axis. Default is 1;
         */
        Graphics.prototype.scaleUV = function (scaleU, scaleV) {
            if (scaleU === void 0) { scaleU = 1; }
            if (scaleV === void 0) { scaleV = 1; }
            var len = this._shapes.length;
            for (var i = 0; i < len; ++i)
                this._shapes[i].scaleUV(scaleU, scaleV);
        };
        // public invalidateMaterials():void
        // {
        // 	var len:number = this._shapes.length;
        // 	for (var i:number = 0; i < len; ++i)
        // 		this._shapes[i].invalidateMaterial();
        // }
        // public invalidateElements():void
        // {
        // 	var len:number = this._shapes.length;
        // 	for (var i:number = 0; i < len; ++i)
        // 		this._shapes[i].invalidateElements();
        // }
        Graphics.prototype._acceptTraverser = function (traverser) {
            if (this._drawingDirty)
                this.endFill();
            var len = this._shapes.length;
            for (var i = len - 1; i >= 0; i--)
                traverser.applyTraversable(this._shapes[i]);
        };
        Graphics.prototype._onInvalidate = function (event) {
            this.invalidate();
        };
        Graphics.prototype.draw_fills = function () {
            GraphicsFactoryFills.draw_pathes(this);
            this._active_fill_path = null;
        };
        Graphics.prototype.draw_strokes = function () {
            GraphicsFactoryStrokes.draw_pathes(this);
            this._active_stroke_path = null;
        };
        /**
         * Fills a drawing area with a bitmap image. The bitmap can be repeated or
         * tiled to fill the area. The fill remains in effect until you call the
         * <code>beginFill()</code>, <code>beginBitmapFill()</code>,
         * <code>beginGradientFill()</code>, or <code>beginShaderFill()</code>
         * method. Calling the <code>clear()</code> method clears the fill.
         *
         * <p>The application renders the fill whenever three or more points are
         * drawn, or when the <code>endFill()</code> method is called. </p>
         *
         * @param bitmap A transparent or opaque bitmap image that contains the bits
         *               to be displayed.
         * @param matrix A matrix object(of the flash.geom.Matrix class), which you
         *               can use to define transformations on the bitmap. For
         *               example, you can use the following matrix to rotate a bitmap
         *               by 45 degrees(pi/4 radians):
         * @param repeat If <code>true</code>, the bitmap image repeats in a tiled
         *               pattern. If <code>false</code>, the bitmap image does not
         *               repeat, and the edges of the bitmap are used for any fill
         *               area that extends beyond the bitmap.
         *
         *               <p>For example, consider the following bitmap(a 20 x
         *               20-pixel checkerboard pattern):</p>
         *
         *               <p>When <code>repeat</code> is set to <code>true</code>(as
         *               in the following example), the bitmap fill repeats the
         *               bitmap:</p>
         *
         *               <p>When <code>repeat</code> is set to <code>false</code>,
         *               the bitmap fill uses the edge pixels for the fill area
         *               outside the bitmap:</p>
         * @param smooth If <code>false</code>, upscaled bitmap images are rendered
         *               by using a nearest-neighbor algorithm and look pixelated. If
         *               <code>true</code>, upscaled bitmap images are rendered by
         *               using a bilinear algorithm. Rendering by using the nearest
         *               neighbor algorithm is faster.
         */
        Graphics.prototype.beginBitmapFill = function (bitmap, matrix, repeat, smooth) {
            if (matrix === void 0) { matrix = null; }
            if (repeat === void 0) { repeat = true; }
            if (smooth === void 0) { smooth = false; }
            this.draw_fills();
            this._drawingDirty = true;
            this._fillStyle = new GraphicsFillStyle(0xffffff, 1);
        };
        /**
         * Specifies a simple one-color fill that subsequent calls to other Graphics
         * methods(such as <code>lineTo()</code> or <code>drawCircle()</code>) use
         * when drawing. The fill remains in effect until you call the
         * <code>beginFill()</code>, <code>beginBitmapFill()</code>,
         * <code>beginGradientFill()</code>, or <code>beginShaderFill()</code>
         * method. Calling the <code>clear()</code> method clears the fill.
         *
         * <p>The application renders the fill whenever three or more points are
         * drawn, or when the <code>endFill()</code> method is called.</p>
         *
         * @param color The color of the fill(0xRRGGBB).
         * @param alpha The alpha value of the fill(0.0 to 1.0).
         */
        Graphics.prototype.beginFill = function (color /*int*/, alpha) {
            if (alpha === void 0) { alpha = 1; }
            if (color == 0) {
                color = 0x010101;
            }
            this.draw_fills();
            this._fillStyle = new GraphicsFillStyle(color, alpha);
        };
        /**
         * Specifies a gradient fill used by subsequent calls to other Graphics
         * methods(such as <code>lineTo()</code> or <code>drawCircle()</code>) for
         * the object. The fill remains in effect until you call the
         * <code>beginFill()</code>, <code>beginBitmapFill()</code>,
         * <code>beginGradientFill()</code>, or <code>beginShaderFill()</code>
         * method. Calling the <code>clear()</code> method clears the fill.
         *
         * <p>The application renders the fill whenever three or more points are
         * drawn, or when the <code>endFill()</code> method is called. </p>
         *
         * @param type                A value from the GradientType class that
         *                            specifies which gradient type to use:
         *                            <code>GradientType.LINEAR</code> or
         *                            <code>GradientType.RADIAL</code>.
         * @param colors              An array of RGB hexadecimal color values used
         *                            in the gradient; for example, red is 0xFF0000,
         *                            blue is 0x0000FF, and so on. You can specify
         *                            up to 15 colors. For each color, specify a
         *                            corresponding value in the alphas and ratios
         *                            parameters.
         * @param alphas              An array of alpha values for the corresponding
         *                            colors in the colors array; valid values are 0
         *                            to 1. If the value is less than 0, the default
         *                            is 0. If the value is greater than 1, the
         *                            default is 1.
         * @param ratios              An array of color distribution ratios; valid
         *                            values are 0-255. This value defines the
         *                            percentage of the width where the color is
         *                            sampled at 100%. The value 0 represents the
         *                            left position in the gradient box, and 255
         *                            represents the right position in the gradient
         *                            box.
         * @param matrix              A transformation matrix as defined by the
         *                            flash.geom.Matrix class. The flash.geom.Matrix
         *                            class includes a
         *                            <code>createGradientBox()</code> method, which
         *                            lets you conveniently set up the matrix for use
         *                            with the <code>beginGradientFill()</code>
         *                            method.
         * @param spreadMethod        A value from the SpreadMethod class that
         *                            specifies which spread method to use, either:
         *                            <code>SpreadMethod.PAD</code>,
         *                            <code>SpreadMethod.REFLECT</code>, or
         *                            <code>SpreadMethod.REPEAT</code>.
         *
         *                            <p>For example, consider a simple linear
         *                            gradient between two colors:</p>
         *
         *                            <p>This example uses
         *                            <code>SpreadMethod.PAD</code> for the spread
         *                            method, and the gradient fill looks like the
         *                            following:</p>
         *
         *                            <p>If you use <code>SpreadMethod.REFLECT</code>
         *                            for the spread method, the gradient fill looks
         *                            like the following:</p>
         *
         *                            <p>If you use <code>SpreadMethod.REPEAT</code>
         *                            for the spread method, the gradient fill looks
         *                            like the following:</p>
         * @param interpolationMethod A value from the InterpolationMethod class that
         *                            specifies which value to use:
         *                            <code>InterpolationMethod.LINEAR_RGB</code> or
         *                            <code>InterpolationMethod.RGB</code>
         *
         *                            <p>For example, consider a simple linear
         *                            gradient between two colors(with the
         *                            <code>spreadMethod</code> parameter set to
         *                            <code>SpreadMethod.REFLECT</code>). The
         *                            different interpolation methods affect the
         *                            appearance as follows: </p>
         * @param focalPointRatio     A number that controls the location of the
         *                            focal point of the gradient. 0 means that the
         *                            focal point is in the center. 1 means that the
         *                            focal point is at one border of the gradient
         *                            circle. -1 means that the focal point is at the
         *                            other border of the gradient circle. A value
         *                            less than -1 or greater than 1 is rounded to -1
         *                            or 1. For example, the following example shows
         *                            a <code>focalPointRatio</code> set to 0.75:
         * @throws ArgumentError If the <code>type</code> parameter is not valid.
         */
        Graphics.prototype.beginGradientFill = function (type, colors, alphas, ratios, matrix, spreadMethod, interpolationMethod, focalPointRatio) {
            if (matrix === void 0) { matrix = null; }
            if (spreadMethod === void 0) { spreadMethod = "pad"; }
            if (interpolationMethod === void 0) { interpolationMethod = "rgb"; }
            if (focalPointRatio === void 0) { focalPointRatio = 0; }
            this.draw_fills();
            // start a new fill path
            this._drawingDirty = true;
            this._fillStyle = new GradientFillStyle(type, colors, alphas, ratios, matrix, spreadMethod, interpolationMethod, focalPointRatio);
        };
        /**
         * Copies all of drawing commands from the source Graphics object into the
         * calling Graphics object.
         *
         * @param sourceGraphics The Graphics object from which to copy the drawing
         *                       commands.
         */
        Graphics.prototype.copyFrom = function (sourceGraphics) {
            sourceGraphics.copyTo(this);
        };
        /**
         * Draws a cubic Bezier curve from the current drawing position to the
         * specified anchor point. Cubic Bezier curves consist of two anchor points
         * and two control points. The curve interpolates the two anchor points and
         * curves toward the two control points.
         *
         * The four points you use to draw a cubic Bezier curve with the
         * <code>cubicCurveTo()</code> method are as follows:
         *
         * <ul>
         *   <li>The current drawing position is the first anchor point. </li>
         *   <li>The anchorX and anchorY parameters specify the second anchor point.
         *   </li>
         *   <li>The <code>controlX1</code> and <code>controlY1</code> parameters
         *   specify the first control point.</li>
         *   <li>The <code>controlX2</code> and <code>controlY2</code> parameters
         *   specify the second control point.</li>
         * </ul>
         *
         * If you call the <code>cubicCurveTo()</code> method before calling the
         * <code>moveTo()</code> method, your curve starts at position (0, 0).
         *
         * If the <code>cubicCurveTo()</code> method succeeds, the Flash runtime sets
         * the current drawing position to (<code>anchorX</code>,
         * <code>anchorY</code>). If the <code>cubicCurveTo()</code> method fails,
         * the current drawing position remains unchanged.
         *
         * If your movie clip contains content created with the Flash drawing tools,
         * the results of calls to the <code>cubicCurveTo()</code> method are drawn
         * underneath that content.
         *
         * @param controlX1 Specifies the horizontal position of the first control
         *                  point relative to the registration point of the parent
         *                  display object.
         * @param controlY1 Specifies the vertical position of the first control
         *                  point relative to the registration point of the parent
         *                  display object.
         * @param controlX2 Specifies the horizontal position of the second control
         *                  point relative to the registration point of the parent
         *                  display object.
         * @param controlY2 Specifies the vertical position of the second control
         *                  point relative to the registration point of the parent
         *                  display object.
         * @param anchorX   Specifies the horizontal position of the anchor point
         *                  relative to the registration point of the parent display
         *                  object.
         * @param anchorY   Specifies the vertical position of the anchor point
         *                  relative to the registration point of the parent display
         *                  object.
         */
        Graphics.prototype.cubicCurveTo = function (controlX1, controlY1, controlX2, controlY2, anchorX, anchorY) {
            throw new PartialImplementationError("cubicCurveTo");
            /*
             t = 0.5; // given example value
             x = (1 - t) * (1 - t) * p[0].x + 2 * (1 - t) * t * p[1].x + t * t * p[2].x;
             y = (1 - t) * (1 - t) * p[0].y + 2 * (1 - t) * t * p[1].y + t * t * p[2].y;

             this.queued_command_types.push(Graphics.CMD_BEZIER);
             this.queued_command_data.push(controlX1);
             this.queued_command_data.push(controlY1);
             this.queued_command_data.push(controlX2);
             this.queued_command_data.push(controlY2);
             this.queued_command_data.push(anchorX);
             this.queued_command_data.push(anchorY);

             // todo: somehow convert cubic bezier curve into 2 quadric curves...

             this.draw_direction+=0;
             */
        };
        /**
         * Draws a curve using the current line style from the current drawing
         * position to(anchorX, anchorY) and using the control point that
         * (<code>controlX</code>, <code>controlY</code>) specifies. The current
         * drawing position is then set to(<code>anchorX</code>,
         * <code>anchorY</code>). If the movie clip in which you are drawing contains
         * content created with the Flash drawing tools, calls to the
         * <code>curveTo()</code> method are drawn underneath this content. If you
         * call the <code>curveTo()</code> method before any calls to the
         * <code>moveTo()</code> method, the default of the current drawing position
         * is(0, 0). If any of the parameters are missing, this method fails and the
         * current drawing position is not changed.
         *
         * <p>The curve drawn is a quadratic Bezier curve. Quadratic Bezier curves
         * consist of two anchor points and one control point. The curve interpolates
         * the two anchor points and curves toward the control point. </p>
         *
         * @param controlX A number that specifies the horizontal position of the
         *                 control point relative to the registration point of the
         *                 parent display object.
         * @param controlY A number that specifies the vertical position of the
         *                 control point relative to the registration point of the
         *                 parent display object.
         * @param anchorX  A number that specifies the horizontal position of the
         *                 next anchor point relative to the registration point of
         *                 the parent display object.
         * @param anchorY  A number that specifies the vertical position of the next
         *                 anchor point relative to the registration point of the
         *                 parent display object.
         */
        Graphics.prototype.curveTo = function (controlX, controlY, anchorX, anchorY) {
            this._drawingDirty = true;
            this._createGraphicPathes();
            if (this._active_fill_path != null) {
                this._active_fill_path.curveTo(controlX, controlY, anchorX, anchorY);
            }
            if (this._active_stroke_path != null) {
                this._active_stroke_path.curveTo(controlX, controlY, anchorX, anchorY);
            }
            this._current_position.x = anchorX;
            this._current_position.y = anchorY;
            this.invalidate();
        };
        /**
         * Draws a circle. Set the line style, fill, or both before you call the
         * <code>drawCircle()</code> method, by calling the <code>linestyle()</code>,
         * <code>lineGradientStyle()</code>, <code>beginFill()</code>,
         * <code>beginGradientFill()</code>, or <code>beginBitmapFill()</code>
         * method.
         *
         * @param x      The <i>x</i> location of the center of the circle relative
         *               to the registration point of the parent display object(in
         *               pixels).
         * @param y      The <i>y</i> location of the center of the circle relative
         *               to the registration point of the parent display object(in
         *               pixels).
         * @param radius The radius of the circle(in pixels).
         */
        Graphics.prototype.drawCircle = function (x, y, radius) {
            this._drawingDirty = true;
            this._createGraphicPathes();
            //var radius2=radius*1.065;
            if (this._active_fill_path != null) {
                this._active_fill_path.moveTo(x, y);
                /*
                for(var i=8; i>=0;i--){

                    var degree = (i) *(360/8)*Math.PI/180;
                    var degree2 = degree + ((360/16)*Math.PI/180);
                    this._active_fill_path.curveTo(x-(Math.cos(degree2)*radius2), y+(Math.sin(degree2)*radius2),x-(Math.cos(degree)*radius), y+(Math.sin(degree)*radius));
                }*/
                var r = radius;
                if (this._active_stroke_path != null) {
                    r -= this._active_stroke_path.style.thickness / 2;
                }
                GraphicsFactoryHelper.drawElipse(x, y, r, r, this._active_fill_path.verts, 0, 360, 5, false);
            }
            if (this._active_stroke_path != null) {
                this._active_stroke_path.moveTo(x, y);
                /*
                            var radius2=radius*0.93;
                            this._active_stroke_path.curveTo(x-(radius2), y+(radius2), x-radius, y);
                            this._active_stroke_path.curveTo(x-(radius2), y-(radius2), x, y-radius);
                            this._active_stroke_path.curveTo(x+(radius2), y-(radius2), x+radius, y);
                            this._active_stroke_path.curveTo(x+(radius2), y+(radius2), x, y+radius);
                            */
                GraphicsFactoryHelper.drawElipseStrokes(x, y, radius, radius, this._active_stroke_path.verts, 0, 360, 5, this._active_stroke_path.style.thickness / 2, false);
            }
            this.invalidate();
        };
        /**
         * Draws an ellipse. Set the line style, fill, or both before you call the
         * <code>drawEllipse()</code> method, by calling the
         * <code>linestyle()</code>, <code>lineGradientStyle()</code>,
         * <code>beginFill()</code>, <code>beginGradientFill()</code>, or
         * <code>beginBitmapFill()</code> method.
         *
         * @param x      The <i>x</i> location of the top-left of the bounding-box of
         *               the ellipse relative to the registration point of the parent
         *               display object(in pixels).
         * @param y      The <i>y</i> location of the top left of the bounding-box of
         *               the ellipse relative to the registration point of the parent
         *               display object(in pixels).
         * @param width  The width of the ellipse(in pixels).
         * @param height The height of the ellipse(in pixels).
         */
        Graphics.prototype.drawEllipse = function (x, y, width, height) {
            this._drawingDirty = true;
            this._createGraphicPathes();
            //var radius2=radius*1.065;
            if (this._active_fill_path != null) {
                this._active_fill_path.moveTo(x, y);
                /*
                 for(var i=8; i>=0;i--){

                 var degree = (i) *(360/8)*Math.PI/180;
                 var degree2 = degree + ((360/16)*Math.PI/180);
                 this._active_fill_path.curveTo(x-(Math.cos(degree2)*radius2), y+(Math.sin(degree2)*radius2),x-(Math.cos(degree)*radius), y+(Math.sin(degree)*radius));
                 }*/
                var w = width;
                var h = height;
                if (this._active_stroke_path != null) {
                    w -= this._active_stroke_path.style.thickness / 2;
                    h -= this._active_stroke_path.style.thickness / 2;
                }
                GraphicsFactoryHelper.drawElipse(x, y, w, h, this._active_fill_path.verts, 0, 360, 5, false);
            }
            if (this._active_stroke_path != null) {
                this._active_stroke_path.moveTo(x, y);
                GraphicsFactoryHelper.drawElipseStrokes(x, y, width, height, this._active_stroke_path.verts, 0, 360, 5, this._active_stroke_path.style.thickness / 2, false);
                /*
                 var radius2=radius*0.93;
                 this._active_stroke_path.curveTo(x-(radius2), y+(radius2), x-radius, y);
                 this._active_stroke_path.curveTo(x-(radius2), y-(radius2), x, y-radius);
                 this._active_stroke_path.curveTo(x+(radius2), y-(radius2), x+radius, y);
                 this._active_stroke_path.curveTo(x+(radius2), y+(radius2), x, y+radius);
                 */
            }
            this.invalidate();
        };
        /**
         * Submits a series of IGraphicsData instances for drawing. This method
         * accepts a Vector containing objects including paths, fills, and strokes
         * that implement the IGraphicsData interface. A Vector of IGraphicsData
         * instances can refer to a part of a shape, or a complex fully defined set
         * of data for rendering a complete shape.
         *
         * <p> Graphics paths can contain other graphics paths. If the
         * <code>graphicsData</code> Vector includes a path, that path and all its
         * sub-paths are rendered during this operation. </p>
         *
         */
        Graphics.prototype.drawGraphicsData = function (graphicsData) {
            //this.draw_fills();
            /*
             for (var i:number=0; i<graphicsData.length; i++){
             //todo
             if(graphicsData[i].dataType=="beginFill"){

             }
             else if(graphicsData[i].dataType=="endFill"){

             }
             else if(graphicsData[i].dataType=="endFill"){

             }
             else if(graphicsData[i].dataType=="Path"){

             }

             }
             */
        };
        /**
         * Submits a series of commands for drawing. The <code>drawPath()</code>
         * method uses vector arrays to consolidate individual <code>moveTo()</code>,
         * <code>lineTo()</code>, and <code>curveTo()</code> drawing commands into a
         * single call. The <code>drawPath()</code> method parameters combine drawing
         * commands with x- and y-coordinate value pairs and a drawing direction. The
         * drawing commands are values from the GraphicsPathCommand class. The x- and
         * y-coordinate value pairs are Numbers in an array where each pair defines a
         * coordinate location. The drawing direction is a value from the
         * GraphicsPathWinding class.
         *
         * <p> Generally, drawings render faster with <code>drawPath()</code> than
         * with a series of individual <code>lineTo()</code> and
         * <code>curveTo()</code> methods. </p>
         *
         * <p> The <code>drawPath()</code> method uses a uses a floating computation
         * so rotation and scaling of shapes is more accurate and gives better
         * results. However, curves submitted using the <code>drawPath()</code>
         * method can have small sub-pixel alignment errors when used in conjunction
         * with the <code>lineTo()</code> and <code>curveTo()</code> methods. </p>
         *
         * <p> The <code>drawPath()</code> method also uses slightly different rules
         * for filling and drawing lines. They are: </p>
         *
         * <ul>
         *   <li>When a fill is applied to rendering a path:
         * <ul>
         *   <li>A sub-path of less than 3 points is not rendered.(But note that the
         * stroke rendering will still occur, consistent with the rules for strokes
         * below.)</li>
         *   <li>A sub-path that isn't closed(the end point is not equal to the
         * begin point) is implicitly closed.</li>
         * </ul>
         * </li>
         *   <li>When a stroke is applied to rendering a path:
         * <ul>
         *   <li>The sub-paths can be composed of any number of points.</li>
         *   <li>The sub-path is never implicitly closed.</li>
         * </ul>
         * </li>
         * </ul>
         *
         * @param winding Specifies the winding rule using a value defined in the
         *                GraphicsPathWinding class.
         */
        Graphics.prototype.drawPath = function (commands, data, winding) {
            //todo
            /*
             if(this._active_fill_path!=null){
             this._active_fill_path.curveTo(controlX, controlY, anchorX, anchorY);
             }
             if(this._active_stroke_path!=null){
             this._active_stroke_path.curveTo(controlX, controlY, anchorX, anchorY);
             }
             this._current_position.x=anchorX;
             this._current_position.y=anchorY;
             */
        };
        /**
         * Draws a rectangle. Set the line style, fill, or both before you call the
         * <code>drawRect()</code> method, by calling the <code>linestyle()</code>,
         * <code>lineGradientStyle()</code>, <code>beginFill()</code>,
         * <code>beginGradientFill()</code>, or <code>beginBitmapFill()</code>
         * method.
         *
         * @param x      A number indicating the horizontal position relative to the
         *               registration point of the parent display object(in pixels).
         * @param y      A number indicating the vertical position relative to the
         *               registration point of the parent display object(in pixels).
         * @param width  The width of the rectangle(in pixels).
         * @param height The height of the rectangle(in pixels).
         * @throws ArgumentError If the <code>width</code> or <code>height</code>
         *                       parameters are not a number
         *                      (<code>Number.NaN</code>).
         */
        Graphics.prototype.drawRect = function (x, y, width, height) {
            this._drawingDirty = true;
            this._createGraphicPathes();
            if (this._active_fill_path != null) {
                this._active_fill_path.moveTo(x, y);
                /*
                this._active_fill_path.lineTo(x+width, y);
                this._active_fill_path.lineTo(x+width, y+height);
                this._active_fill_path.lineTo(x, y+height);
                this._active_fill_path.lineTo(x, y);
                */
                var w = width;
                var h = height;
                var t = 0;
                if (this._active_stroke_path != null) {
                    t = this._active_stroke_path.style.thickness / 2;
                    w -= this._active_stroke_path.style.thickness;
                    h -= this._active_stroke_path.style.thickness;
                }
                GraphicsFactoryHelper.addTriangle(x + t, y + h + t, x + t, y + t, x + w + t, y + t, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + t, y + h + t, x + t + w, y + t, x + w + t, y + h + t, 0, this._active_fill_path.verts, false);
            }
            if (this._active_stroke_path != null) {
                this._active_stroke_path.moveTo(x, y);
                //var t:number=(<GraphicsStrokeStyle>this._active_stroke_path.style).thickness/2;
                // todo: respect Jointstyle here (?)
                /*
                GraphicsFactoryHelper.addTriangle(x-t, y+height+t, x-t, y-t, x+t, y+t, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x-t, y+height+t, x+t, y+height-t, x+t, y+t, 0, this._active_stroke_path.verts, false);

                GraphicsFactoryHelper.addTriangle(x-t, y-t, x+width+t, y-t, x+t, y+t, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x+t, y+t, x+width+t, y-t, x+width-t, y+t, 0, this._active_stroke_path.verts, false);

                GraphicsFactoryHelper.addTriangle(x+width-t, y+height-t, x+width-t, y+t, x+width+t, y+height+t, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x+width+t, y+height+t, x+width+t, y-t, x+width-t, y+t, 0, this._active_stroke_path.verts, false);

                GraphicsFactoryHelper.addTriangle(x-t, y+height+t, x+width+t, y+height+t, x+t, y+height-t, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x+t, y+height-t, x+width+t, y+height+t, x+width-t, y+height-t, 0, this._active_stroke_path.verts, false);
                */
                this._active_stroke_path.lineTo(x + width, y);
                this._active_stroke_path.lineTo(x + width, y + height);
                this._active_stroke_path.lineTo(x, y + height);
                this._active_stroke_path.lineTo(x, y);
            }
            this.invalidate();
        };
        /**
         * Draws a rounded rectangle. Set the line style, fill, or both before you
         * call the <code>drawRoundRect()</code> method, by calling the
         * <code>linestyle()</code>, <code>lineGradientStyle()</code>,
         * <code>beginFill()</code>, <code>beginGradientFill()</code>, or
         * <code>beginBitmapFill()</code> method.
         *
         * @param x             A number indicating the horizontal position relative
         *                      to the registration point of the parent display
         *                      object(in pixels).
         * @param y             A number indicating the vertical position relative to
         *                      the registration point of the parent display object
         *                     (in pixels).
         * @param width         The width of the round rectangle(in pixels).
         * @param height        The height of the round rectangle(in pixels).
         * @param ellipseWidth  The width of the ellipse used to draw the rounded
         *                      corners(in pixels).
         * @param ellipseHeight The height of the ellipse used to draw the rounded
         *                      corners(in pixels). Optional; if no value is
         *                      specified, the default value matches that provided
         *                      for the <code>ellipseWidth</code> parameter.
         * @throws ArgumentError If the <code>width</code>, <code>height</code>,
         *                       <code>ellipseWidth</code> or
         *                       <code>ellipseHeight</code> parameters are not a
         *                       number(<code>Number.NaN</code>).
         */
        Graphics.prototype.drawRoundRect = function (x, y, width, height, ellipseWidth, ellipseHeight) {
            if (ellipseHeight === void 0) { ellipseHeight = NaN; }
            this._drawingDirty = true;
            this._createGraphicPathes();
            if (isNaN(ellipseHeight)) {
                ellipseHeight = ellipseWidth;
            }
            var w = width;
            var h = height;
            var ew = ellipseWidth / 2;
            var eh = ellipseHeight / 2;
            var t = 0;
            if (this._active_fill_path != null) {
                this._active_fill_path.moveTo(x, y);
                if (this._active_stroke_path != null) {
                    t = this._active_stroke_path.style.thickness / 2;
                    w -= this._active_stroke_path.style.thickness;
                    h -= this._active_stroke_path.style.thickness;
                }
                GraphicsFactoryHelper.addTriangle(x + t, y + h - eh, x + t, y + eh, x + w - t, y + eh, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + t, y + h - eh, x + w - t, y + eh, x + w - t, y + h - eh, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + ew, y + t, x + w - ew, y + eh, x + ew, y + eh, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + ew, y + t, x + w - ew, y + t, x + w - ew, y + eh, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + ew, y + h - eh, x + w - ew, y + h - t, x + ew, y + h - t, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + ew, y + h - eh, x + w - ew, y + h - eh, x + w - ew, y + h - t, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.drawElipse(x + ew, y + eh, ew - t, eh - t, this._active_fill_path.verts, 180, 270, 5, false);
                GraphicsFactoryHelper.drawElipse(x + w - ew, y + eh, ew - t, eh - t, this._active_fill_path.verts, 270, 360, 5, false);
                GraphicsFactoryHelper.drawElipse(x + w - ew, y + h - eh, ew - t, eh - t, this._active_fill_path.verts, 0, 90, 5, false);
                GraphicsFactoryHelper.drawElipse(x + ew, y + h - eh, ew - t, eh - t, this._active_fill_path.verts, 90, 180, 5, false);
            }
            if (this._active_stroke_path != null) {
                this._active_stroke_path.moveTo(x, y);
                t = this._active_stroke_path.style.thickness / 2;
                GraphicsFactoryHelper.addTriangle(x - t, y + h - eh, x - t, y + eh, x + t, y + eh, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x - t, y + h - eh, x + t, y + h - eh, x + t, y + eh, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + ew, y - t, x + w - ew, y - t, x + ew, y + t, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + ew, y + t, x + w - ew, y - t, x + w - ew, y + t, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + w - t, y + h - eh, x + w - t, y + eh, x + w + t, y + h - eh, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + w + t, y + h - eh, x + w + t, y + eh, x + w - t, y + eh, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + ew, y + h + t, x + w - ew, y + h + t, x + ew, y + h - t, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + ew, y + h - t, x + w - ew, y + h + t, x + w - ew, y + h - t, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.drawElipseStrokes(x + ew, y + eh, ew, eh, this._active_stroke_path.verts, 180, 270, 5, t, false);
                GraphicsFactoryHelper.drawElipseStrokes(x + w - ew, y + eh, ew, eh, this._active_stroke_path.verts, 270, 360, 5, t, false);
                GraphicsFactoryHelper.drawElipseStrokes(x + w - ew, y + h - eh, ew, eh, this._active_stroke_path.verts, 0, 90, 5, t, false);
                GraphicsFactoryHelper.drawElipseStrokes(x + ew, y + h - eh, ew, eh, this._active_stroke_path.verts, 90, 180, 5, t, false);
            }
            this.invalidate();
        };
        Graphics.prototype.drawRoundRectComplex = function (x, y, width, height, topLeftRadius, topRightRadius, bottomLeftRadius, bottomRightRadius) {
            var w = width;
            var h = height;
            var tl = topLeftRadius;
            var tr = topRightRadius;
            var bl = bottomLeftRadius;
            var br = bottomRightRadius;
            this._drawingDirty = true;
            this._createGraphicPathes();
            var t = 0;
            if (this._active_fill_path != null) {
                this._active_fill_path.moveTo(x, y);
                if (this._active_stroke_path != null) {
                    t = this._active_stroke_path.style.thickness / 2;
                    w -= this._active_stroke_path.style.thickness;
                    h -= this._active_stroke_path.style.thickness;
                }
                GraphicsFactoryHelper.addTriangle(x + tl, y + tl, x + w - tr, y + tr, x + w - br, y + h - br, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + tl, y + tl, x + w - br, y + h - br, x + bl, y + h - bl, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + t, y + tl, x + tl, y + tl, x + t, y + h - bl, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + tl, y + tl, x + t, y + h - bl, x + bl, y + h - bl, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + tl, y + t, x + tl, y + tl, x + w - tr, y + t, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + tl, y + tl, x + w - tr, y + tr, x + w - tr, y + t, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + w - t, y + tr, x + w - tr, y + tr, x + w - t, y + h - br, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + w - tr, y + tr, x + w - br, y + h - br, x + w - t, y + h - br, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + bl, y + h - t, x + w - br, y + h - t, x + bl, y + h - bl, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + bl, y + h - bl, x + w - br, y + h - t, x + w - br, y + h - br, 0, this._active_fill_path.verts, false);
                GraphicsFactoryHelper.drawElipse(x + tl, y + tl, tl - t, tl - t, this._active_fill_path.verts, 180, 270, 5, false);
                GraphicsFactoryHelper.drawElipse(x + w - tr, y + tr, tr - t, tr - t, this._active_fill_path.verts, 270, 360, 5, false);
                GraphicsFactoryHelper.drawElipse(x + w - br, y + h - br, br - t, br - t, this._active_fill_path.verts, 0, 90, 5, false);
                GraphicsFactoryHelper.drawElipse(x + bl, y + h - bl, bl - t, bl - t, this._active_fill_path.verts, 90, 180, 5, false);
            }
            if (this._active_stroke_path != null) {
                this._active_stroke_path.moveTo(x, y);
                t = this._active_stroke_path.style.thickness / 2;
                GraphicsFactoryHelper.addTriangle(x - t, y + h - bl, x - t, y + tl, x + t, y + tl, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x - t, y + h - bl, x + t, y + h - bl, x + t, y + tl, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + tl, y - t, x + w - tr, y - t, x + tr, y + t, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + tl, y + t, x + w - tr, y - t, x + w - tr, y + t, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + w - t, y + h - br, x + w - t, y + tr, x + w + t, y + h - br, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + w + t, y + h - br, x + w + t, y + tr, x + w - t, y + tr, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + bl, y + h + t, x + w - br, y + h + t, x + bl, y + h - t, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.addTriangle(x + bl, y + h - t, x + w - br, y + h + t, x + w - br, y + h - t, 0, this._active_stroke_path.verts, false);
                GraphicsFactoryHelper.drawElipseStrokes(x + tl, y + tl, tl, tl, this._active_stroke_path.verts, 180, 270, 5, t, false);
                GraphicsFactoryHelper.drawElipseStrokes(x + w - tr, y + tr, tr, tr, this._active_stroke_path.verts, 270, 360, 5, t, false);
                GraphicsFactoryHelper.drawElipseStrokes(x + w - br, y + h - br, br, br, this._active_stroke_path.verts, 0, 90, 5, t, false);
                GraphicsFactoryHelper.drawElipseStrokes(x + bl, y + h - bl, bl, bl, this._active_stroke_path.verts, 90, 180, 5, t, false);
            }
            this.invalidate();
        };
        /**
         * Renders a set of triangles, typically to distort bitmaps and give them a
         * three-dimensional appearance. The <code>drawTriangles()</code> method maps
         * either the current fill, or a bitmap fill, to the triangle faces using a
         * set of(u,v) coordinates.
         *
         * <p> Any type of fill can be used, but if the fill has a transform matrix
         * that transform matrix is ignored. </p>
         *
         * <p> A <code>uvtData</code> parameter improves texture mapping when a
         * bitmap fill is used. </p>
         *
         * @param culling Specifies whether to render triangles that face in a
         *                specified direction. This parameter prevents the rendering
         *                of triangles that cannot be seen in the current view. This
         *                parameter can be set to any value defined by the
         *                TriangleCulling class.
         */
        Graphics.prototype.drawTriangles = function (vertices, indices, uvtData, culling) {
            if (indices === void 0) { indices = null; }
            if (uvtData === void 0) { uvtData = null; }
            if (culling === void 0) { culling = null; }
            this._drawingDirty = true;
            if (this._active_fill_path != null) {
                //todo
            }
            if (this._active_stroke_path != null) {
                //todo
            }
        };
        /**
         * Applies a fill to the lines and curves that were added since the last call
         * to the <code>beginFill()</code>, <code>beginGradientFill()</code>, or
         * <code>beginBitmapFill()</code> method. Flash uses the fill that was
         * specified in the previous call to the <code>beginFill()</code>,
         * <code>beginGradientFill()</code>, or <code>beginBitmapFill()</code>
         * method. If the current drawing position does not equal the previous
         * position specified in a <code>moveTo()</code> method and a fill is
         * defined, the path is closed with a line and then filled.
         *
         */
        Graphics.prototype.endFill = function () {
            //execute any queued shapetags
            if (this._queuedShapeTags.length) {
                var localQueue = this._queuedShapeTags;
                var len = localQueue.length;
                this._queuedShapeTags = [];
                for (var i = 0; i < len; i++)
                    this.convertRecordsToShapeData(localQueue[i]);
                localQueue.length = 0;
            }
            this._drawingDirty = false;
            //todo: this is a hack for getting stroke pathes closed if a fill_path exists. needs refactor to make this work correctly
            if (this._active_stroke_path && this._active_fill_path) {
                this._active_stroke_path.forceClose = true;
            }
            this.draw_fills();
            this.draw_strokes();
            this._active_fill_path = null;
            this._active_stroke_path = null;
            //this._lineStyle=null;
            this._fillStyle = null;
            //this.invalidate();
            //this.invalidateElements();
        };
        /**
         * Specifies a bitmap to use for the line stroke when drawing lines.
         *
         * <p>The bitmap line style is used for subsequent calls to Graphics methods
         * such as the <code>lineTo()</code> method or the <code>drawCircle()</code>
         * method. The line style remains in effect until you call the
         * <code>lineStyle()</code> or <code>lineGradientStyle()</code> methods, or
         * the <code>lineBitmapStyle()</code> method again with different parameters.
         * </p>
         *
         * <p>You can call the <code>lineBitmapStyle()</code> method in the middle of
         * drawing a path to specify different styles for different line segments
         * within a path. </p>
         *
         * <p>Call the <code>lineStyle()</code> method before you call the
         * <code>lineBitmapStyle()</code> method to enable a stroke, or else the
         * value of the line style is <code>undefined</code>.</p>
         *
         * <p>Calls to the <code>clear()</code> method set the line style back to
         * <code>undefined</code>. </p>
         *
         * @param bitmap The bitmap to use for the line stroke.
         * @param matrix An optional transformation matrix as defined by the
         *               flash.geom.Matrix class. The matrix can be used to scale or
         *               otherwise manipulate the bitmap before applying it to the
         *               line style.
         * @param repeat Whether to repeat the bitmap in a tiled fashion.
         * @param smooth Whether smoothing should be applied to the bitmap.
         */
        Graphics.prototype.lineBitmapStyle = function (bitmap, matrix, repeat, smooth) {
            if (matrix === void 0) { matrix = null; }
            if (repeat === void 0) { repeat = true; }
            if (smooth === void 0) { smooth = false; }
            //this._drawingDirty=true;
            //this._lineStyle=new  GraphicsStrokeStyle(colors[0], alphas[0], 1);
            // start a new stroke path
        };
        /**
         * Specifies a gradient to use for the stroke when drawing lines.
         *
         * <p>The gradient line style is used for subsequent calls to Graphics
         * methods such as the <code>lineTo()</code> methods or the
         * <code>drawCircle()</code> method. The line style remains in effect until
         * you call the <code>lineStyle()</code> or <code>lineBitmapStyle()</code>
         * methods, or the <code>lineGradientStyle()</code> method again with
         * different parameters. </p>
         *
         * <p>You can call the <code>lineGradientStyle()</code> method in the middle
         * of drawing a path to specify different styles for different line segments
         * within a path. </p>
         *
         * <p>Call the <code>lineStyle()</code> method before you call the
         * <code>lineGradientStyle()</code> method to enable a stroke, or else the
         * value of the line style is <code>undefined</code>.</p>
         *
         * <p>Calls to the <code>clear()</code> method set the line style back to
         * <code>undefined</code>. </p>
         *
         * @param type                A value from the GradientType class that
         *                            specifies which gradient type to use, either
         *                            GradientType.LINEAR or GradientType.RADIAL.
         * @param colors              An array of RGB hexadecimal color values used
         *                            in the gradient; for example, red is 0xFF0000,
         *                            blue is 0x0000FF, and so on. You can specify
         *                            up to 15 colors. For each color, specify a
         *                            corresponding value in the alphas and ratios
         *                            parameters.
         * @param alphas              An array of alpha values for the corresponding
         *                            colors in the colors array; valid values are 0
         *                            to 1. If the value is less than 0, the default
         *                            is 0. If the value is greater than 1, the
         *                            default is 1.
         * @param ratios              An array of color distribution ratios; valid
         *                            values are 0-255. This value defines the
         *                            percentage of the width where the color is
         *                            sampled at 100%. The value 0 represents the
         *                            left position in the gradient box, and 255
         *                            represents the right position in the gradient
         *                            box.
         * @param matrix              A transformation matrix as defined by the
         *                            flash.geom.Matrix class. The flash.geom.Matrix
         *                            class includes a
         *                            <code>createGradientBox()</code> method, which
         *                            lets you conveniently set up the matrix for use
         *                            with the <code>lineGradientStyle()</code>
         *                            method.
         * @param spreadMethod        A value from the SpreadMethod class that
         *                            specifies which spread method to use:
         * @param interpolationMethod A value from the InterpolationMethod class that
         *                            specifies which value to use. For example,
         *                            consider a simple linear gradient between two
         *                            colors(with the <code>spreadMethod</code>
         *                            parameter set to
         *                            <code>SpreadMethod.REFLECT</code>). The
         *                            different interpolation methods affect the
         *                            appearance as follows:
         * @param focalPointRatio     A number that controls the location of the
         *                            focal point of the gradient. The value 0 means
         *                            the focal point is in the center. The value 1
         *                            means the focal point is at one border of the
         *                            gradient circle. The value -1 means that the
         *                            focal point is at the other border of the
         *                            gradient circle. Values less than -1 or greater
         *                            than 1 are rounded to -1 or 1. The following
         *                            image shows a gradient with a
         *                            <code>focalPointRatio</code> of -0.75:
         */
        Graphics.prototype.lineGradientStyle = function (type, colors, alphas, ratios, matrix, spreadMethod, interpolationMethod, focalPointRatio) {
            if (matrix === void 0) { matrix = null; }
            if (spreadMethod === void 0) { spreadMethod = null; }
            if (interpolationMethod === void 0) { interpolationMethod = null; }
            if (focalPointRatio === void 0) { focalPointRatio = 0; }
            this._drawingDirty = true;
            this._lineStyle = new GraphicsStrokeStyle(colors[0], alphas[0], 1);
        };
        /**
         * Specifies a shader to use for the line stroke when drawing lines.
         *
         * <p>The shader line style is used for subsequent calls to Graphics methods
         * such as the <code>lineTo()</code> method or the <code>drawCircle()</code>
         * method. The line style remains in effect until you call the
         * <code>lineStyle()</code> or <code>lineGradientStyle()</code> methods, or
         * the <code>lineBitmapStyle()</code> method again with different parameters.
         * </p>
         *
         * <p>You can call the <code>lineShaderStyle()</code> method in the middle of
         * drawing a path to specify different styles for different line segments
         * within a path. </p>
         *
         * <p>Call the <code>lineStyle()</code> method before you call the
         * <code>lineShaderStyle()</code> method to enable a stroke, or else the
         * value of the line style is <code>undefined</code>.</p>
         *
         * <p>Calls to the <code>clear()</code> method set the line style back to
         * <code>undefined</code>. </p>
         *
         * @param shader The shader to use for the line stroke.
         * @param matrix An optional transformation matrix as defined by the
         *               flash.geom.Matrix class. The matrix can be used to scale or
         *               otherwise manipulate the bitmap before applying it to the
         *               line style.
         */
        //		public lineShaderStyle(shader:Shader, matrix:Matrix = null)
        //		{
        //
        //		}
        /**
         * Specifies a line style used for subsequent calls to Graphics methods such
         * as the <code>lineTo()</code> method or the <code>drawCircle()</code>
         * method. The line style remains in effect until you call the
         * <code>lineGradientStyle()</code> method, the
         * <code>lineBitmapStyle()</code> method, or the <code>lineStyle()</code>
         * method with different parameters.
         *
         * <p>You can call the <code>lineStyle()</code> method in the middle of
         * drawing a path to specify different styles for different line segments
         * within the path.</p>
         *
         * <p><b>Note: </b>Calls to the <code>clear()</code> method set the line
         * style back to <code>undefined</code>.</p>
         *
         * <p><b>Note: </b>Flash Lite 4 supports only the first three parameters
         * (<code>thickness</code>, <code>color</code>, and <code>alpha</code>).</p>
         *
         * @param thickness    An integer that indicates the thickness of the line in
         *                     points; valid values are 0-255. If a number is not
         *                     specified, or if the parameter is undefined, a line is
         *                     not drawn. If a value of less than 0 is passed, the
         *                     default is 0. The value 0 indicates hairline
         *                     thickness; the maximum thickness is 255. If a value
         *                     greater than 255 is passed, the default is 255.
         * @param color        A hexadecimal color value of the line; for example,
         *                     red is 0xFF0000, blue is 0x0000FF, and so on. If a
         *                     value is not indicated, the default is 0x000000
         *                    (black). Optional.
         * @param alpha        A number that indicates the alpha value of the color
         *                     of the line; valid values are 0 to 1. If a value is
         *                     not indicated, the default is 1(solid). If the value
         *                     is less than 0, the default is 0. If the value is
         *                     greater than 1, the default is 1.
         * @param pixelHinting(Not supported in Flash Lite 4) A Boolean value that
         *                     specifies whether to hint strokes to full pixels. This
         *                     affects both the position of anchors of a curve and
         *                     the line stroke size itself. With
         *                     <code>pixelHinting</code> set to <code>true</code>,
         *                     line widths are adjusted to full pixel widths. With
         *                     <code>pixelHinting</code> set to <code>false</code>,
         *                     disjoints can appear for curves and straight lines.
         *                     For example, the following illustrations show how
         *                     Flash Player or Adobe AIR renders two rounded
         *                     rectangles that are identical, except that the
         *                     <code>pixelHinting</code> parameter used in the
         *                     <code>lineStyle()</code> method is set differently
         *                    (the images are scaled by 200%, to emphasize the
         *                     difference):
         *
         *                     <p>If a value is not supplied, the line does not use
         *                     pixel hinting.</p>
         * @param scaleMode   (Not supported in Flash Lite 4) A value from the
         *                     LineScaleMode class that specifies which scale mode to
         *                     use:
         *                     <ul>
         *                       <li> <code>LineScaleMode.NORMAL</code> - Always
         *                     scale the line thickness when the object is scaled
         *                    (the default). </li>
         *                       <li> <code>LineScaleMode.NONE</code> - Never scale
         *                     the line thickness. </li>
         *                       <li> <code>LineScaleMode.VERTICAL</code> - Do not
         *                     scale the line thickness if the object is scaled
         *                     vertically <i>only</i>. For example, consider the
         *                     following circles, drawn with a one-pixel line, and
         *                     each with the <code>scaleMode</code> parameter set to
         *                     <code>LineScaleMode.VERTICAL</code>. The circle on the
         *                     left is scaled vertically only, and the circle on the
         *                     right is scaled both vertically and horizontally:
         *                     </li>
         *                       <li> <code>LineScaleMode.HORIZONTAL</code> - Do not
         *                     scale the line thickness if the object is scaled
         *                     horizontally <i>only</i>. For example, consider the
         *                     following circles, drawn with a one-pixel line, and
         *                     each with the <code>scaleMode</code> parameter set to
         *                     <code>LineScaleMode.HORIZONTAL</code>. The circle on
         *                     the left is scaled horizontally only, and the circle
         *                     on the right is scaled both vertically and
         *                     horizontally:   </li>
         *                     </ul>
         * @param caps        (Not supported in Flash Lite 4) A value from the
         *                     CapsStyle class that specifies the type of caps at the
         *                     end of lines. Valid values are:
         *                     <code>CapsStyle.NONE</code>,
         *                     <code>CapsStyle.ROUND</code>, and
         *                     <code>CapsStyle.SQUARE</code>. If a value is not
         *                     indicated, Flash uses round caps.
         *
         *                     <p>For example, the following illustrations show the
         *                     different <code>capsStyle</code> settings. For each
         *                     setting, the illustration shows a blue line with a
         *                     thickness of 30(for which the <code>capsStyle</code>
         *                     applies), and a superimposed black line with a
         *                     thickness of 1(for which no <code>capsStyle</code>
         *                     applies): </p>
         * @param joints      (Not supported in Flash Lite 4) A value from the
         *                     JointStyle class that specifies the type of joint
         *                     appearance used at angles. Valid values are:
         *                     <code>JointStyle.BEVEL</code>,
         *                     <code>JointStyle.MITER</code>, and
         *                     <code>JointStyle.ROUND</code>. If a value is not
         *                     indicated, Flash uses round joints.
         *
         *                     <p>For example, the following illustrations show the
         *                     different <code>joints</code> settings. For each
         *                     setting, the illustration shows an angled blue line
         *                     with a thickness of 30(for which the
         *                     <code>jointStyle</code> applies), and a superimposed
         *                     angled black line with a thickness of 1(for which no
         *                     <code>jointStyle</code> applies): </p>
         *
         *                     <p><b>Note:</b> For <code>joints</code> set to
         *                     <code>JointStyle.MITER</code>, you can use the
         *                     <code>miterLimit</code> parameter to limit the length
         *                     of the miter.</p>
         * @param miterLimit  (Not supported in Flash Lite 4) A number that
         *                     indicates the limit at which a miter is cut off. Valid
         *                     values range from 1 to 255(and values outside that
         *                     range are rounded to 1 or 255). This value is only
         *                     used if the <code>jointStyle</code> is set to
         *                     <code>"miter"</code>. The <code>miterLimit</code>
         *                     value represents the length that a miter can extend
         *                     beyond the point at which the lines meet to form a
         *                     joint. The value expresses a factor of the line
         *                     <code>thickness</code>. For example, with a
         *                     <code>miterLimit</code> factor of 2.5 and a
         *                     <code>thickness</code> of 10 pixels, the miter is cut
         *                     off at 25 pixels.
         *
         *                     <p>For example, consider the following angled lines,
         *                     each drawn with a <code>thickness</code> of 20, but
         *                     with <code>miterLimit</code> set to 1, 2, and 4.
         *                     Superimposed are black reference lines showing the
         *                     meeting points of the joints:</p>
         *
         *                     <p>Notice that a given <code>miterLimit</code> value
         *                     has a specific maximum angle for which the miter is
         *                     cut off. The following table lists some examples:</p>
         */
        Graphics.prototype.lineStyle = function (thickness, color, alpha, pixelHinting, scaleMode, capstyle, jointstyle, miterLimit) {
            if (thickness === void 0) { thickness = 0; }
            if (color === void 0) { color = 0; }
            if (alpha === void 0) { alpha = 1; }
            if (pixelHinting === void 0) { pixelHinting = false; }
            if (scaleMode === void 0) { scaleMode = null; }
            if (capstyle === void 0) { capstyle = CapsStyle.NONE; }
            if (jointstyle === void 0) { jointstyle = JointStyle.MITER; }
            if (miterLimit === void 0) { miterLimit = 100; }
            this._drawingDirty = true;
            this._lineStyle = new GraphicsStrokeStyle(color, alpha, thickness, jointstyle, capstyle, miterLimit);
        };
        /**
         * Draws a line using the current line style from the current drawing
         * position to(<code>x</code>, <code>y</code>); the current drawing position
         * is then set to(<code>x</code>, <code>y</code>). If the display object in
         * which you are drawing contains content that was created with the Flash
         * drawing tools, calls to the <code>lineTo()</code> method are drawn
         * underneath the content. If you call <code>lineTo()</code> before any calls
         * to the <code>moveTo()</code> method, the default position for the current
         * drawing is(<i>0, 0</i>). If any of the parameters are missing, this
         * method fails and the current drawing position is not changed.
         *
         * @param x A number that indicates the horizontal position relative to the
         *          registration point of the parent display object(in pixels).
         * @param y A number that indicates the vertical position relative to the
         *          registration point of the parent display object(in pixels).
         */
        Graphics.prototype.lineTo = function (x, y) {
            this._drawingDirty = true;
            this._createGraphicPathes();
            if (this._active_fill_path != null) {
                this._active_fill_path.lineTo(x, y);
            }
            if (this._active_stroke_path != null) {
                this._active_stroke_path.lineTo(x, y);
            }
            this._current_position.x = x;
            this._current_position.y = y;
            this.invalidate();
        };
        /**
         * Moves the current drawing position to(<code>x</code>, <code>y</code>). If
         * any of the parameters are missing, this method fails and the current
         * drawing position is not changed.
         *
         * @param x A number that indicates the horizontal position relative to the
         *          registration point of the parent display object(in pixels).
         * @param y A number that indicates the vertical position relative to the
         *          registration point of the parent display object(in pixels).
         */
        Graphics.prototype.moveTo = function (x, y) {
            this._drawingDirty = true;
            this._createGraphicPathes();
            if (this._active_fill_path != null) {
                this._active_fill_path.moveTo(x, y);
            }
            if (this._active_stroke_path != null) {
                this._active_stroke_path.moveTo(x, y);
            }
            this._current_position.x = x;
            this._current_position.y = y;
            this.invalidate();
        };
        Graphics.prototype.queueShapeTag = function (shapeTag) {
            this._queuedShapeTags.push(shapeTag);
            this._drawingDirty = true;
        };
        Graphics.prototype._createGraphicPathes = function () {
            if (this._fillStyle != null && (this._active_fill_path == null || this._active_fill_path.style != this._fillStyle)) {
                this._active_fill_path = new GraphicsPath();
                this._active_fill_path.style = this._fillStyle;
                if (this._current_position.x != 0 || this._current_position.y != 0)
                    this._active_fill_path.moveTo(this._current_position.x, this._current_position.y);
                this._queued_fill_pathes.push(this._active_fill_path);
            }
            if (this._lineStyle != null && (this._active_stroke_path == null || this._active_stroke_path.style != this._lineStyle)) {
                this._active_stroke_path = new GraphicsPath();
                this._active_stroke_path.style = this._lineStyle;
                if (this._current_position.x != 0 || this._current_position.y != 0)
                    this._active_stroke_path.moveTo(this._current_position.x, this._current_position.y);
                this._queued_stroke_pathes.push(this._active_stroke_path);
            }
        };
        Graphics.prototype._addShapes = function (shapes, cloneShapes) {
            if (cloneShapes === void 0) { cloneShapes = false; }
            var shape;
            var len = shapes.length;
            for (var i = 0; i < len; i++) {
                shape = shapes[i];
                if (this.slice9Rectangle) { // todo: this is a dirty workaround to get the slice9-shapes cloned:
                    shape = Shape.getShape(TriangleElementsUtils.updateTriangleGraphicsSlice9(shape.elements, this.originalSlice9Size, 1, 1, false, true), shape.material, shape.style);
                }
                else if (cloneShapes) {
                    shape = Shape.getShape(shape.elements, shape.material, shape.style, shape.count, shape.offset);
                }
                shape.particleCollection = shapes[i].particleCollection;
                shape.addEventListener(RenderableEvent.INVALIDATE_ELEMENTS, this._onInvalidateDelegate);
                shape.addEventListener(RenderableEvent.INVALIDATE_MATERIAL, this._onInvalidateDelegate);
                shape.addEventListener(RenderableEvent.INVALIDATE_STYLE, this._onInvalidateDelegate);
                shape.addEventListener(AssetEvent.INVALIDATE, this._onInvalidateDelegate);
                this._shapes.push(shape);
                shape.usages++;
            }
            this._scaleX = 0;
            this._scaleY = 0;
            this._scale.identity();
            this.invalidate();
        };
        Graphics.prototype._isShapeMaterial = function (material) {
            var len = this._shapes.length;
            for (var i = 0; i < len; i++)
                if (material == this._shapes[i].material)
                    return true;
            return false;
        };
        /*
        * Converts records from the space-optimized format they're stored in to a
        * format that's more amenable to fast rendering.
        *
        * See http://blogs.msdn.com/b/mswanson/archive/2006/02/27/539749.aspx and
        * http://wahlers.com.br/claus/blog/hacking-swf-1-shapes-in-flash/ for details.
        */
        Graphics.prototype.convertRecordsToShapeData = function (tag) {
            var records = tag.records;
            var fillStyles = tag.fillStyles;
            var lineStyles = tag.lineStyles;
            var recordsMorph = tag.recordsMorph || null;
            var parser = tag.parser;
            var fillPaths = createPathsList(fillStyles, false, !!recordsMorph, parser);
            var linePaths = createPathsList(lineStyles, true, !!recordsMorph, parser);
            var isMorph = recordsMorph !== null;
            var styles = { fill0: 0, fill1: 0, line: 0 };
            var segment1 = null;
            var segment2 = null;
            var segmentL = null;
            // Fill- and line styles can be added by style change records in the middle of
            // a shape records list. This also causes the previous paths to be treated as
            // a group, so the lines don't get moved on top of any following fills.
            // To support this, we just append all current fill and line paths to a list
            // when new styles are introduced.
            var allPaths;
            // If no style is set for a segment1 of a path1, a 1px transparent line is used.
            var defaultPath;
            var numRecords = records.length;
            var x = 0;
            var y = 0;
            var morphX = 0;
            var morphY = 0;
            var path1;
            var path2;
            var pathL;
            //console.log("numRecords", numRecords);
            for (var i = 0, j = 0; i < numRecords; i++) {
                var record = records[i];
                //console.log("record", i, record.type);
                var morphRecord;
                if (isMorph) {
                    morphRecord = recordsMorph[j++];
                }
                // type 0 is a StyleChange record
                if (record.type === 0) {
                    if (record.flags & 16 /* HasNewStyles */) {
                        if (!allPaths) {
                            allPaths = [];
                        }
                        this.push.apply(allPaths, fillPaths);
                        fillPaths = createPathsList(record.fillStyles, false, isMorph, parser);
                        this.push.apply(allPaths, linePaths);
                        linePaths = createPathsList(record.lineStyles, true, isMorph, parser);
                        if (defaultPath) {
                            allPaths.push(defaultPath);
                            defaultPath = null;
                        }
                        styles = { fill0: 0, fill1: 0, line: 0 };
                    }
                    if (record.flags & 2 /* HasFillStyle0 */) {
                        styles.fill0 = record.fillStyle0;
                    }
                    if (record.flags & 4 /* HasFillStyle1 */) {
                        styles.fill1 = record.fillStyle1;
                    }
                    if (record.flags & 8 /* HasLineStyle */) {
                        styles.line = record.lineStyle;
                    }
                    // reset all segments and pathes to null, and than reset them based on new styles
                    path1 = path2 = pathL = null;
                    segment1 = segment2 = segmentL = null;
                    if (styles.fill0) {
                        path1 = fillPaths[styles.fill0 - 1];
                    }
                    if (styles.fill1) {
                        path2 = fillPaths[styles.fill1 - 1];
                    }
                    if (styles.line) {
                        pathL = linePaths[styles.line - 1];
                    }
                    if (record.flags & 1 /* Move */) {
                        x = record.moveX | 0;
                        y = record.moveY | 0;
                        // When morphed, StyleChangeRecords/MoveTo might not have a
                        // corresponding record in the start or end shape --
                        // processing morphRecord below before converting type 1 records.
                    }
                    // if a segment1 has same fill on both sides, we want to ignore this segment1 for fills
                    if (styles.fill1 && styles.fill0 && styles.fill0 == styles.fill1) {
                        //console.log("IGNORED SEGMENT", styles);
                        segment1 = null; //80pro: ignore segments with same fill on both sides
                        segment2 = null; //80pro: ignore segments with same fill on both sides
                        path1 = null; //80pro: ignore segments with same fill on both sides
                        path2 = null; //80pro: ignore segments with same fill on both sides
                    }
                    if (path1) {
                        segment1 = PathSegment.FromDefaults(isMorph);
                        path1.addSegment(segment1);
                        //console.log("new segment1");
                        // Move or not, we want this path1 segment1 to start where the last one
                        // left off. Even if the last one belonged to a different style.
                        // "Huh," you say? Yup.
                        if (!isMorph) {
                            segment1.moveTo(x, y);
                            //console.log("segment1.moveTo" ,x/20, y/20);
                        }
                        else {
                            if (morphRecord.type === 0) {
                                morphX = morphRecord.moveX | 0;
                                morphY = morphRecord.moveY | 0;
                            }
                            else {
                                morphX = x;
                                morphY = y;
                                // Not all moveTos are reflected in morph data.
                                // In that case, decrease morph data index.
                                j--;
                            }
                            segment1.morphMoveTo(x, y, morphX, morphY);
                        }
                    }
                    if (path2) {
                        segment2 = PathSegment.FromDefaults(isMorph);
                        path2.addSegment(segment2);
                        if (!isMorph) {
                            segment2.moveTo(x, y);
                            //console.log("segment1.moveTo" ,x/20, y/20);
                        }
                        else {
                            if (morphRecord.type === 0) {
                                morphX = morphRecord.moveX | 0;
                                morphY = morphRecord.moveY | 0;
                            }
                            else {
                                morphX = x;
                                morphY = y;
                                // Not all moveTos are reflected in morph data.
                                // In that case, decrease morph data index.
                                j--;
                            }
                            segment2.morphMoveTo(x, y, morphX, morphY);
                        }
                    }
                    if (pathL) {
                        segmentL = PathSegment.FromDefaults(isMorph);
                        pathL.addSegment(segmentL);
                        if (!isMorph) {
                            segmentL.moveTo(x, y);
                            //console.log("segment1.moveTo" ,x/20, y/20);
                        }
                        else {
                            if (morphRecord.type === 0) {
                                morphX = morphRecord.moveX | 0;
                                morphY = morphRecord.moveY | 0;
                            }
                            else {
                                morphX = x;
                                morphY = y;
                                // Not all moveTos are reflected in morph data.
                                // In that case, decrease morph data index.
                                j--;
                            }
                            segmentL.morphMoveTo(x, y, morphX, morphY);
                        }
                    }
                    //segment1.isReversed=true;
                    //segment2.isReversed=true;
                    //if(styles.fill1 && styles.fill0 && styles.fill1 !== styles.fill0){
                    //console.log("IGNORED SEGMENT");
                    //}
                }
                // type 1 is a StraightEdge or CurvedEdge record
                else {
                    //console.log("record.type !== 0");
                    assert(record.type === 1);
                    if (isMorph) {
                        // An invalid SWF might contain a move in the EndEdges list where the
                        // StartEdges list contains an edge. The Flash Player seems to skip it,
                        // so we do, too.
                        while (morphRecord && morphRecord.type === 0) {
                            morphRecord = recordsMorph[j++];
                        }
                        // The EndEdges list might be shorter than the StartEdges list. Reuse
                        // start edges as end edges in that case.
                        if (!morphRecord) {
                            morphRecord = record;
                        }
                    }
                    if (record.flags & 32 /* IsStraight */ &&
                        (!isMorph || (morphRecord.flags & 32 /* IsStraight */))) {
                        x += record.deltaX | 0;
                        y += record.deltaY | 0;
                        if (segment1 && !isMorph) {
                            segment1.lineTo(x, y);
                            //console.log("segment1.lineTo" ,x/20, y/20);
                        }
                        else if (segment1) {
                            morphX += morphRecord.deltaX | 0;
                            morphY += morphRecord.deltaY | 0;
                            segment1.morphLineTo(x, y, morphX, morphY);
                        }
                        if (segment2 && !isMorph) {
                            segment2.lineTo(x, y);
                            //console.log("segment1.lineTo" ,x/20, y/20);
                        }
                        else if (segment2) {
                            morphX += morphRecord.deltaX | 0;
                            morphY += morphRecord.deltaY | 0;
                            segment2.morphLineTo(x, y, morphX, morphY);
                        }
                        if (segmentL && !isMorph) {
                            segmentL.lineTo(x, y);
                            //console.log("segment1.lineTo" ,x/20, y/20);
                        }
                        else if (segmentL) {
                            morphX += morphRecord.deltaX | 0;
                            morphY += morphRecord.deltaY | 0;
                            segmentL.morphLineTo(x, y, morphX, morphY);
                        }
                    }
                    else {
                        var cx, cy;
                        var deltaX, deltaY;
                        if (!(record.flags & 32 /* IsStraight */)) {
                            cx = x + record.controlDeltaX | 0;
                            cy = y + record.controlDeltaY | 0;
                            x = cx + record.anchorDeltaX | 0;
                            y = cy + record.anchorDeltaY | 0;
                        }
                        else {
                            deltaX = record.deltaX | 0;
                            deltaY = record.deltaY | 0;
                            cx = x + (deltaX >> 1);
                            cy = y + (deltaY >> 1);
                            x += deltaX;
                            y += deltaY;
                        }
                        if (segment1 && !isMorph) {
                            segment1.curveTo(cx, cy, x, y);
                            //console.log("segment1.curveTo",cx/20, cy/20, x/20, y/20);
                        }
                        else if (segment1) {
                            if (!(morphRecord.flags & 32 /* IsStraight */)) {
                                var morphCX = morphX + morphRecord.controlDeltaX | 0;
                                var morphCY = morphY + morphRecord.controlDeltaY | 0;
                                morphX = morphCX + morphRecord.anchorDeltaX | 0;
                                morphY = morphCY + morphRecord.anchorDeltaY | 0;
                            }
                            else {
                                deltaX = morphRecord.deltaX | 0;
                                deltaY = morphRecord.deltaY | 0;
                                var morphCX = morphX + (deltaX >> 1);
                                var morphCY = morphY + (deltaY >> 1);
                                morphX += deltaX;
                                morphY += deltaY;
                            }
                            segment1.morphCurveTo(cx, cy, x, y, morphCX, morphCY, morphX, morphY);
                        }
                        if (segment2 && !isMorph) {
                            segment2.curveTo(cx, cy, x, y);
                            //console.log("segment1.curveTo",cx/20, cy/20, x/20, y/20);
                        }
                        else if (segment2) {
                            if (!(morphRecord.flags & 32 /* IsStraight */)) {
                                var morphCX = morphX + morphRecord.controlDeltaX | 0;
                                var morphCY = morphY + morphRecord.controlDeltaY | 0;
                                morphX = morphCX + morphRecord.anchorDeltaX | 0;
                                morphY = morphCY + morphRecord.anchorDeltaY | 0;
                            }
                            else {
                                deltaX = morphRecord.deltaX | 0;
                                deltaY = morphRecord.deltaY | 0;
                                var morphCX = morphX + (deltaX >> 1);
                                var morphCY = morphY + (deltaY >> 1);
                                morphX += deltaX;
                                morphY += deltaY;
                            }
                            segment2.morphCurveTo(cx, cy, x, y, morphCX, morphCY, morphX, morphY);
                        }
                        if (segmentL && !isMorph) {
                            segmentL.curveTo(cx, cy, x, y);
                            //console.log("segment1.curveTo",cx/20, cy/20, x/20, y/20);
                        }
                        else if (segmentL) {
                            if (!(morphRecord.flags & 32 /* IsStraight */)) {
                                var morphCX = morphX + morphRecord.controlDeltaX | 0;
                                var morphCY = morphY + morphRecord.controlDeltaY | 0;
                                morphX = morphCX + morphRecord.anchorDeltaX | 0;
                                morphY = morphCY + morphRecord.anchorDeltaY | 0;
                            }
                            else {
                                deltaX = morphRecord.deltaX | 0;
                                deltaY = morphRecord.deltaY | 0;
                                var morphCX = morphX + (deltaX >> 1);
                                var morphCY = morphY + (deltaY >> 1);
                                morphX += deltaX;
                                morphY += deltaY;
                            }
                            segmentL.morphCurveTo(cx, cy, x, y, morphCX, morphCY, morphX, morphY);
                        }
                    }
                }
            }
            //	applySegmentToStyles(segment1, styles, linePaths, fillPaths);
            // All current paths get appended to the allPaths list at the end. First fill,
            // then line paths.
            if (allPaths) {
                this.push.apply(allPaths, fillPaths);
            }
            else {
                allPaths = fillPaths;
            }
            this.push.apply(allPaths, linePaths);
            if (defaultPath) {
                allPaths.push(defaultPath);
            }
            var shapeAJS;
            if (isMorph) {
                var morphShapeAJS;
                //shape.morphCoordinates = new Int32Array(shape.coordinates.length);
                //shape.morphStyles = new DataBuffer(16);
                this.start = [];
                this.end = [];
                for (i = 0; i < allPaths.length; i++) {
                    //allPaths[i].serialize(shape);
                    shapeAJS = new GraphicsPath();
                    morphShapeAJS = new GraphicsPath();
                    //shapeAJS.queuePath(allPaths[i], morphShapeAJS)
                    allPaths[i].serializeAJS(shapeAJS, morphShapeAJS);
                    this.start.push(shapeAJS);
                    this.end.push(morphShapeAJS);
                }
            }
            else {
                for (i = 0; i < allPaths.length; i++) {
                    //console.log("allPaths", i, allPaths[i]);
                    //allPaths[i].serialize(shape);
                    shapeAJS = new GraphicsPath();
                    //shapeAJS.queuePath(allPaths[i], null);
                    allPaths[i].serializeAJS(shapeAJS, null);
                    //console.log("shapeAJS", shapeAJS);
                    this.add_queued_path(shapeAJS);
                }
            }
        };
        Graphics._pool = new Array();
        Graphics.get_material_for_color = function (color, alpha) {
            return { material: MaterialUtils.getDefaultColorMaterial() };
        };
        Graphics.get_material_for_gradient = function (gradient) {
            return { material: MaterialUtils.getDefaultTextureMaterial() };
        };
        Graphics.assetType = "[asset Graphics]";
        return Graphics;
    }(AssetBase));
    var IDENTITY_MATRIX = { a: 1, b: 0, c: 0, d: 1, tx: 0, ty: 0 };
    function processStyle(style, isLineStyle, isMorph, parser) {
        var shapeStyle = style;
        if (isMorph) {
            shapeStyle.morph = processMorphStyle(style, isLineStyle);
        }
        if (isLineStyle) {
            shapeStyle.miterLimit = (style.miterLimitFactor || 1.5) * 2;
            if (!style.color && style.hasFill) {
                var fillStyle = processStyle(style.fillStyle, false, false, parser);
                shapeStyle.type = fillStyle.type;
                shapeStyle.transform = fillStyle.transform;
                shapeStyle.colors = fillStyle.colors;
                shapeStyle.ratios = fillStyle.ratios;
                shapeStyle.focalPoint = fillStyle.focalPoint;
                shapeStyle.bitmapId = fillStyle.bitmapId;
                shapeStyle.material = fillStyle.material;
                shapeStyle.repeat = fillStyle.repeat;
                style.fillStyle = null;
                return shapeStyle;
            }
            else {
                shapeStyle.type = FillType.Solid;
                return shapeStyle;
            }
        }
        if (style.type === undefined || style.type === FillType.Solid) {
            return shapeStyle;
        }
        switch (style.type) {
            case FillType.LinearGradient:
            case FillType.RadialGradient:
            case FillType.FocalRadialGradient:
                var records = style.records;
                var colors = shapeStyle.colors = [];
                var ratios = shapeStyle.ratios = [];
                for (var i = 0; i < records.length; i++) {
                    var record = records[i];
                    if (ratios.length == 0 || ratios[ratios.length - 1] != record.ratio) {
                        colors.push(record.color);
                        ratios.push(record.ratio);
                    }
                }
                break;
            case FillType.RepeatingBitmap:
            case FillType.ClippedBitmap:
            case FillType.NonsmoothedRepeatingBitmap:
            case FillType.NonsmoothedClippedBitmap:
                shapeStyle.smooth = style.type !== FillType.NonsmoothedRepeatingBitmap &&
                    style.type !== FillType.NonsmoothedClippedBitmap;
                shapeStyle.repeat = style.type !== FillType.ClippedBitmap &&
                    style.type !== FillType.NonsmoothedClippedBitmap;
                /*var index = dependencies.indexOf(style.bitmapId);
                if (index === -1) {
                    index = dependencies.length;
                    dependencies.push(style.bitmapId);
                }*/
                shapeStyle.material = parser.getMaterial(style.bitmapId);
                break;
            default:
                console.log('shape parser encountered invalid fill style ' + style.type);
        }
        if (!style.matrix) {
            shapeStyle.transform = IDENTITY_MATRIX;
            return shapeStyle;
        }
        var matrix = style.matrix;
        shapeStyle.transform = {
            /*a: (matrix.a * scale),
            b: (matrix.b * scale),
            c: (matrix.c * scale),
            d: (matrix.d * scale),
            tx: matrix.tx/20,
            ty: matrix.ty/20*/
            a: (matrix.a),
            b: (matrix.b),
            c: (matrix.c),
            d: (matrix.d),
            tx: matrix.tx / 20,
            ty: matrix.ty / 20
        };
        // null data that's unused from here on out
        style.matrix = null;
        return shapeStyle;
    }
    function processMorphStyle(style, isLineStyle) {
        var morphStyle = Object.create(style);
        if (isLineStyle) {
            morphStyle.width = style.widthMorph;
            if (!style.color && style.hasFill) {
                var fillStyle = processMorphStyle(style.fillStyle, false);
                morphStyle.transform = fillStyle.transform;
                morphStyle.colors = fillStyle.colors;
                morphStyle.ratios = fillStyle.ratios;
                return morphStyle;
            }
            else {
                morphStyle.color = style.colorMorph;
                return morphStyle;
            }
        }
        if (style.type === undefined) {
            return morphStyle;
        }
        if (style.type === FillType.Solid) {
            morphStyle.color = style.colorMorph;
            return morphStyle;
        }
        switch (style.type) {
            case FillType.LinearGradient:
            case FillType.RadialGradient:
            case FillType.FocalRadialGradient:
                var records = style.records;
                var colors = morphStyle.colors = [];
                var ratios = morphStyle.ratios = [];
                for (var i = 0; i < records.length; i++) {
                    var record = records[i];
                    colors.push(record.colorMorph);
                    ratios.push(record.ratioMorph);
                }
                break;
            case FillType.RepeatingBitmap:
            case FillType.ClippedBitmap:
            case FillType.NonsmoothedRepeatingBitmap:
            case FillType.NonsmoothedClippedBitmap:
                break;
            default:
                console.log('shape parser encountered invalid fill style');
        }
        if (!style.matrix) {
            morphStyle.transform = IDENTITY_MATRIX;
            return morphStyle;
        }
        var matrix = style.matrixMorph;
        morphStyle.transform = {
            /*
            a: (matrix.a * scale),
            b: (matrix.b * scale),
            c: (matrix.c * scale),
            d: (matrix.d * scale),
            tx: matrix.tx/20,
            ty: matrix.ty/20*/
            a: (matrix.a),
            b: (matrix.b),
            c: (matrix.c),
            d: (matrix.d),
            tx: matrix.tx / 20,
            ty: matrix.ty / 20
        };
        return morphStyle;
    }
    /*
    * Paths are stored in 2-dimensional arrays. Each of the inner arrays contains
    * all the paths for a certain fill or line style.
    */
    function createPathsList(styles, isLineStyle, isMorph, parser) {
        var paths = [];
        for (var i = 0; i < styles.length; i++) {
            var style = processStyle(styles[i], isLineStyle, isMorph, parser);
            if (!isLineStyle) {
                paths[i] = new SegmentedPath(style, null);
            }
            else {
                paths[i] = new SegmentedPath(null, style);
            }
        }
        return paths;
    }

    var GraphicsFactoryHelper = /** @class */ (function () {
        function GraphicsFactoryHelper() {
        }
        GraphicsFactoryHelper.drawRectangles = function (inputRectangles, color, alpha) {
            if (inputRectangles.length % 4 > 0) {
                console.log("GraphicsFactoryHelper.drawRectangles: inputRectangles.length is not a multiple of 4", inputRectangles);
                return;
            }
            var final_vert_list = [];
            final_vert_list.length = (inputRectangles.length / 4) * 12;
            var i = 0;
            var outCnt = 0;
            var len = inputRectangles.length;
            var x = 0;
            var y = 0;
            var w = 0;
            var h = 0;
            for (i = 0; i < len; i += 4) {
                x = inputRectangles[i];
                y = inputRectangles[i + 1];
                w = inputRectangles[i + 2];
                h = inputRectangles[i + 3];
                final_vert_list[outCnt++] = x;
                final_vert_list[outCnt++] = y;
                final_vert_list[outCnt++] = x + w;
                final_vert_list[outCnt++] = y;
                final_vert_list[outCnt++] = x + w;
                final_vert_list[outCnt++] = y + h;
                final_vert_list[outCnt++] = x;
                final_vert_list[outCnt++] = y;
                final_vert_list[outCnt++] = x;
                final_vert_list[outCnt++] = y + h;
                final_vert_list[outCnt++] = x + w;
                final_vert_list[outCnt++] = y + h;
            }
            var obj = Graphics.get_material_for_color(color, alpha);
            var material = obj.material;
            var attributesView = new AttributesView(Float32Array, material.curves ? 3 : 2);
            attributesView.set(final_vert_list);
            var attributesBuffer = attributesView.attributesBuffer.cloneBufferView();
            attributesView.dispose();
            var elements = new TriangleElements(attributesBuffer);
            elements.setPositions(new Float2Attributes(attributesBuffer));
            var shape = Shape.getShape(elements, material);
            if (obj.colorPos) {
                shape.style = new Style();
                var sampler = new ImageSampler();
                material.animateUVs = true;
                shape.style.color = color;
                shape.style.addSamplerAt(sampler, material.getTextureAt(0));
                shape.style.uvMatrix = new Matrix(0, 0, 0, 0, obj.colorPos.x, obj.colorPos.y);
            }
            return shape;
        };
        GraphicsFactoryHelper.updateRectanglesShape = function (shape, inputRectangles) {
            var final_vert_list = [];
            final_vert_list.length = (inputRectangles.length / 4) * 12;
            var i = 0;
            var outCnt = 0;
            var len = inputRectangles.length;
            var x = 0;
            var y = 0;
            var w = 0;
            var h = 0;
            for (i = 0; i < len; i += 4) {
                x = inputRectangles[i];
                y = inputRectangles[i + 1];
                w = inputRectangles[i + 2];
                h = inputRectangles[i + 3];
                final_vert_list[outCnt++] = x;
                final_vert_list[outCnt++] = y;
                final_vert_list[outCnt++] = x + w;
                final_vert_list[outCnt++] = y;
                final_vert_list[outCnt++] = x + w;
                final_vert_list[outCnt++] = y + h;
                final_vert_list[outCnt++] = x;
                final_vert_list[outCnt++] = y;
                final_vert_list[outCnt++] = x;
                final_vert_list[outCnt++] = y + h;
                final_vert_list[outCnt++] = x + w;
                final_vert_list[outCnt++] = y + h;
            }
            var elements = shape.elements;
            elements.concatenatedBuffer.count = final_vert_list.length / 2;
            elements.setPositions(final_vert_list);
            elements.invalidate();
        };
        GraphicsFactoryHelper.isClockWiseXY = function (point1x, point1y, point2x, point2y, point3x, point3y) {
            var num = (point1x - point2x) * (point3y - point2y) - (point1y - point2y) * (point3x - point2x);
            if (num < 0)
                return false;
            return true;
        };
        GraphicsFactoryHelper.getSign = function (ax, ay, cx, cy, bx, by) {
            return (ax - bx) * (cy - by) - (ay - by) * (cx - bx);
        };
        GraphicsFactoryHelper.pointInTri = function (ax, ay, bx, by, cx, cy, xx, xy) {
            var b1 = GraphicsFactoryHelper.getSign(ax, ay, xx, xy, bx, by) > 0;
            var b2 = GraphicsFactoryHelper.getSign(bx, by, xx, xy, cx, cy) > 0;
            var b3 = GraphicsFactoryHelper.getSign(cx, cy, xx, xy, ax, ay) > 0;
            return ((b1 == b2) && (b2 == b3));
        };
        GraphicsFactoryHelper.getControlXForCurveX = function (a, c, b) {
            return c;
        };
        GraphicsFactoryHelper.getControlYForCurveY = function (a, c, b) {
            return c;
        };
        GraphicsFactoryHelper.drawPoint = function (startX, startY, vertices, curves) {
            GraphicsFactoryHelper.addTriangle(startX - 2, startY - 2, startX + 2, startY - 2, startX + 2, startY + 2, 0, vertices, curves);
            GraphicsFactoryHelper.addTriangle(startX - 2, startY - 2, startX - 2, startY + 2, startX + 2, startY + 2, 0, vertices, curves);
        };
        GraphicsFactoryHelper.drawElipse = function (x, y, width, height, vertices, startAngle, endAngle, stepAngle, curves) {
            // todo: validate input / check edge cases
            var degreeTotal = endAngle - startAngle;
            var steps = degreeTotal / stepAngle;
            var x_last = x + width * Math.cos(startAngle * (Math.PI / 180));
            var y_last = y + height * Math.sin(startAngle * (Math.PI / 180));
            for (var i = 1; i <= steps; i++) {
                var x_tmp = x + width * Math.cos((startAngle + i * stepAngle) * (Math.PI / 180));
                var y_tmp = y + height * Math.sin((startAngle + i * stepAngle) * (Math.PI / 180));
                GraphicsFactoryHelper.addTriangle(x, y, x_tmp, y_tmp, x_last, y_last, 0, vertices, curves);
                x_last = x_tmp;
                y_last = y_tmp;
            }
        };
        GraphicsFactoryHelper.drawElipseStrokes = function (x, y, width, height, vertices, startAngle, endAngle, stepAngle, thickness, curves) {
            // todo: validate input / check edge cases
            var degreeTotal = endAngle - startAngle;
            var steps = degreeTotal / stepAngle;
            var x_last = x + (width + thickness) * Math.cos(startAngle * (Math.PI / 180));
            var y_last = y + (height + thickness) * Math.sin(startAngle * (Math.PI / 180));
            var x_last2 = x + (width - thickness) * Math.cos(startAngle * (Math.PI / 180));
            var y_last2 = y + (height - thickness) * Math.sin(startAngle * (Math.PI / 180));
            for (var i = 1; i <= steps; i++) {
                var x_tmp = x + (width + thickness) * Math.cos((startAngle + i * stepAngle) * (Math.PI / 180));
                var y_tmp = y + (height + thickness) * Math.sin((startAngle + i * stepAngle) * (Math.PI / 180));
                var x_tmp2 = x + (width - thickness) * Math.cos((startAngle + i * stepAngle) * (Math.PI / 180));
                var y_tmp2 = y + (height - thickness) * Math.sin((startAngle + i * stepAngle) * (Math.PI / 180));
                GraphicsFactoryHelper.addTriangle(x_tmp, y_tmp, x_tmp2, y_tmp2, x_last, y_last, 0, vertices, curves);
                GraphicsFactoryHelper.addTriangle(x_last2, y_last2, x_tmp2, y_tmp2, x_last, y_last, 0, vertices, curves);
                x_last = x_tmp;
                y_last = y_tmp;
                x_last2 = x_tmp2;
                y_last2 = y_tmp2;
            }
        };
        GraphicsFactoryHelper.addTriangle = function (startX, startY, controlX, controlY, endX, endY, tri_type, vertices, curves) {
            var x1 = startX;
            var y1 = startY;
            var x2 = controlX;
            var y2 = controlY;
            var x3 = endX;
            var y3 = endY;
            if (GraphicsFactoryHelper.isClockWiseXY(x1, y1, x2, y2, x3, y3)) {
                startX = x3;
                startY = y3;
                controlX = x2;
                controlY = y2;
                endX = x1;
                endY = y1;
            }
            var final_vert_cnt = vertices.length;
            if (tri_type == 0) {
                vertices[final_vert_cnt++] = startX;
                vertices[final_vert_cnt++] = startY;
                if (curves)
                    vertices[final_vert_cnt++] = 4.5736980577097704e-41; // ((127<<24)+(127<<16)+0+0)
                vertices[final_vert_cnt++] = controlX;
                vertices[final_vert_cnt++] = controlY;
                if (curves)
                    vertices[final_vert_cnt++] = 4.5736980577097704e-41; // ((127<<24)+(127<<16)+0+0)
                vertices[final_vert_cnt++] = endX;
                vertices[final_vert_cnt++] = endY;
                if (curves)
                    vertices[final_vert_cnt++] = 4.5736980577097704e-41; // ((127<<24)+(127<<16)+0+0)
            }
            else if (tri_type < 0) {
                vertices[final_vert_cnt++] = startX;
                vertices[final_vert_cnt++] = startY;
                if (curves)
                    vertices[final_vert_cnt++] = 1.1708844992641982e-38; // ((127<<24)+(127<<16)+0+0)
                vertices[final_vert_cnt++] = controlX;
                vertices[final_vert_cnt++] = controlY;
                if (curves)
                    vertices[final_vert_cnt++] = 2.2778106537599901e-41; // ((127<<24)+(63<<16)+0+0)
                vertices[final_vert_cnt++] = endX;
                vertices[final_vert_cnt++] = endY;
                if (curves)
                    vertices[final_vert_cnt++] = 1.7796490496925177e-43; // ((127<<24)+0+0+0)
            }
            else if (tri_type > 0) {
                vertices[final_vert_cnt++] = startX;
                vertices[final_vert_cnt++] = startY;
                if (curves)
                    vertices[final_vert_cnt++] = 1.1708846393940446e-38; // ((-128<<24)+(127<<16)+0+0)
                vertices[final_vert_cnt++] = controlX;
                vertices[final_vert_cnt++] = controlY;
                if (curves)
                    vertices[final_vert_cnt++] = 2.2779507836064226e-41; // ((-128<<24)+(63<<16)+0+0)
                vertices[final_vert_cnt++] = endX;
                vertices[final_vert_cnt++] = endY;
                if (curves)
                    vertices[final_vert_cnt++] = 1.793662034335766e-43; // ((-128<<24)+0+0+0)
            }
        };
        GraphicsFactoryHelper.createCap = function (startX, startY, start_le_x, start_le_y, start_ri_x, start_ri_y, direction_x, direction_y, capstyle, cap_position, thicknessX, thicknessY, vertices, curves) {
            direction_x *= cap_position;
            direction_y *= cap_position;
            if (capstyle == CapsStyle.ROUND) {
                //console.log("add round cap");
                var end_x = startX + ((direction_x * thicknessX));
                var end_y = startY + ((direction_y * thicknessY));
                //end_x = end_x * 2 - start_le.x/2 - start_ri.x/2;
                //end_y = end_y * 2 - start_le.y/2 - start_ri.y/2;
                var tmp1_x = start_le_x + ((direction_x * thicknessX));
                var tmp1_y = start_le_y + ((direction_y * thicknessY));
                var tmp2_x = start_ri_x + ((direction_x * thicknessX));
                var tmp2_y = start_ri_y + ((direction_y * thicknessY));
                GraphicsFactoryHelper.tesselateCurve(start_le_x, start_le_y, tmp1_x, tmp1_y, end_x, end_y, vertices, true);
                GraphicsFactoryHelper.tesselateCurve(end_x, end_y, tmp2_x, tmp2_y, start_ri_x, start_ri_y, vertices, true);
                GraphicsFactoryHelper.addTriangle(start_le_x, start_le_y, end_x, end_y, start_ri_x, start_ri_y, -1, vertices, curves);
            }
            else if (capstyle == CapsStyle.SQUARE) {
                //console.log("add square cap");
                var tmp1_x = start_le_x + ((direction_x * thicknessX));
                var tmp1_y = start_le_y + ((direction_y * thicknessY));
                var tmp2_x = start_ri_x + ((direction_x * thicknessX));
                var tmp2_y = start_ri_y + ((direction_y * thicknessY));
                GraphicsFactoryHelper.addTriangle(tmp2_x, tmp2_y, tmp1_x, tmp1_y, start_le_x, start_le_y, 0, vertices, curves);
                GraphicsFactoryHelper.addTriangle(tmp2_x, tmp2_y, start_le_x, start_le_y, start_ri_x, start_ri_y, 0, vertices, curves);
            }
        };
        GraphicsFactoryHelper.getLineFormularData = function (a, b) {
            var tmp_x = b.x - a.x;
            var tmp_y = b.y - a.y;
            var return_point = new Point();
            if ((tmp_x != 0) && (tmp_y != 0))
                return_point.x = tmp_y / tmp_x;
            return_point.y = -(return_point.x * a.x - a.y);
            return return_point;
        };
        GraphicsFactoryHelper.getQuadricBezierPosition = function (t, start, control, end) {
            var xt = 1 - t;
            return xt * xt * start + 2 * xt * t * control + t * t * end;
        };
        GraphicsFactoryHelper.subdivideCurve = function (startx, starty, cx, cy, endx, endy, startx2, starty2, cx2, cy2, endx2, endy2, array_out, array2_out) {
            var angle_1 = Math.atan2(cy - starty, cx - startx) * MathConsts.RADIANS_TO_DEGREES;
            var angle_2 = Math.atan2(endy - cy, endx - cx) * MathConsts.RADIANS_TO_DEGREES;
            var angle_delta = angle_2 - angle_1;
            //console.log("angle_delta "+angle_delta);
            if (angle_delta > 180) {
                angle_delta -= 360;
            }
            if (angle_delta < -180) {
                angle_delta += 360;
            }
            if (Math.abs(angle_delta) >= 175) {
                array_out.push(startx, starty, cx, cy, endx, endy);
                array2_out.push(startx2, starty2, cx2, cy2, endx2, endy2);
                return;
            }
            var b1 = false;
            var b2 = false;
            if (angle_delta < 0) {
                // curve is curved to right side. right side is convex
                b1 = GraphicsFactoryHelper.getSign(startx, starty, cx2, cy2, endx, endy) > 0;
                b2 = GraphicsFactoryHelper.getSign(startx, starty, cx, cy, endx, endy) > 0;
                b1 = (((starty - endy) * (cx - startx) + (endx - startx) * (cy - starty)) * ((starty - endy) * (cx2 - startx) + (endx - startx) * (cy2 - starty))) < 0;
            }
            else {
                // curve is curved to left side. left side is convex
                b1 = GraphicsFactoryHelper.getSign(startx2, starty2, cx2, cy2, endx2, endy2) > 0;
                b2 = GraphicsFactoryHelper.getSign(startx2, starty2, cx, cy, endx2, endy2) > 0;
                b1 = (((starty2 - endy) * (cx - startx2) + (endx2 - startx2) * (cy - starty2)) * ((starty2 - endy2) * (cx2 - startx2) + (endx2 - startx2) * (cy2 - starty2))) < 0;
            }
            if (b1) {
                array_out.push(startx, starty, cx, cy, endx, endy);
                array2_out.push(startx2, starty2, cx2, cy2, endx2, endy2);
                return;
            }
            // triangles overlap. we must subdivide:
            var c1x = startx + (cx - startx) * 0.5; // new controlpoint 1.1
            var c1y = starty + (cy - starty) * 0.5;
            var c2x = cx + (endx - cx) * 0.5; // new controlpoint 1.2
            var c2y = cy + (endy - cy) * 0.5;
            var ax = c1x + (c2x - c1x) * 0.5; // new middlepoint 1
            var ay = c1y + (c2y - c1y) * 0.5;
            var c1x2 = startx2 + (cx2 - startx2) * 0.5; // new controlpoint 2.1
            var c1y2 = starty2 + (cy2 - starty2) * 0.5;
            var c2x2 = cx2 + (endx2 - cx2) * 0.5; // new controlpoint 2.2
            var c2y2 = cy2 + (endy2 - cy2) * 0.5;
            var ax2 = c1x2 + (c2x2 - c1x2) * 0.5; // new middlepoint 2
            var ay2 = c1y2 + (c2y2 - c1y2) * 0.5;
            GraphicsFactoryHelper.subdivideCurve(startx, starty, c1x, c1y, ax, ay, startx2, starty2, c1x2, c1y2, ax2, ay2, array_out, array2_out);
            GraphicsFactoryHelper.subdivideCurve(ax, ay, c2x, c2y, endx, endy, ax2, ay2, c2x2, c2y2, endx2, endy2, array_out, array2_out);
        };
        GraphicsFactoryHelper.tesselateCurve = function (startx, starty, cx, cy, endx, endy, array_out, filled, iterationCnt) {
            if (filled === void 0) { filled = false; }
            if (iterationCnt === void 0) { iterationCnt = 0; }
            var maxIterations = 6;
            var minAngle = 1;
            var minLength = 1;
            // if "filled" is true, we are collecting final vert positions in the array, ready to use for rendering. (6-position values for each tri)
            // if "filled" is false, we are collecting vert positions for a path (we do not need the start-position).
            // stop tesselation on maxIteration level. Set it to 0 for no tesselation at all.
            if (iterationCnt >= maxIterations) {
                if (filled) {
                    array_out.push(startx, starty, cx, cy, endx, endy);
                    return;
                }
                array_out.push(cx, cy, endx, endy);
                return;
            }
            // calculate angle between segments
            var angle_1 = Math.atan2(cy - starty, cx - startx) * MathConsts.RADIANS_TO_DEGREES;
            var angle_2 = Math.atan2(endy - cy, endx - cx) * MathConsts.RADIANS_TO_DEGREES;
            var angle_delta = angle_2 - angle_1;
            // make sure angle is in range -180 - 180
            while (angle_delta > 180) {
                angle_delta -= 360;
            }
            while (angle_delta < -180) {
                angle_delta += 360;
            }
            // calculate length of segment
            // this does not include the crtl-point position		
            var diff_x = endx - startx;
            var diff_y = endy - starty;
            var len = Math.sqrt(diff_x * diff_x + diff_y * diff_y);
            // subdivide the curve
            var c1x = startx + (cx - startx) * 0.5; // new controlpoint 1
            var c1y = starty + (cy - starty) * 0.5;
            var c2x = cx + (endx - cx) * 0.5; // new controlpoint 2
            var c2y = cy + (endy - cy) * 0.5;
            var ax = c1x + (c2x - c1x) * 0.5; // new middlepoint 1
            var ay = c1y + (c2y - c1y) * 0.5;
            // stop subdividing if the angle or the length is to small
            if (Math.abs(angle_delta) <= minAngle || len < minLength) {
                if (filled) {
                    array_out.push(startx, starty, ax, ay, endx, endy);
                }
                else {
                    array_out.push(endx, endy);
                }
                return;
            }
            // if the output should be directly in valid tris, we always must create a tri,
            // even when we will keep on subdividing.
            if (filled) {
                array_out.push(startx, starty, ax, ay, endx, endy);
            }
            iterationCnt++;
            GraphicsFactoryHelper.tesselateCurve(startx, starty, c1x, c1y, ax, ay, array_out, filled, iterationCnt);
            GraphicsFactoryHelper.tesselateCurve(ax, ay, c2x, c2y, endx, endy, array_out, filled, iterationCnt);
        };
        return GraphicsFactoryHelper;
    }());

    /*
    ** SGI FREE SOFTWARE LICENSE B (Version 2.0, Sept. 18, 2008) 
    ** Copyright (C) [dates of first publication] Silicon Graphics, Inc.
    ** All Rights Reserved.
    **
    ** Permission is hereby granted, free of charge, to any person obtaining a copy
    ** of this software and associated documentation files (the "Software"), to deal
    ** in the Software without restriction, including without limitation the rights
    ** to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
    ** of the Software, and to permit persons to whom the Software is furnished to do so,
    ** subject to the following conditions:
    ** 
    ** The above copyright notice including the dates of first publication and either this
    ** permission notice or a reference to http://oss.sgi.com/projects/FreeB/ shall be
    ** included in all copies or substantial portions of the Software. 
    **
    ** THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
    ** INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
    ** PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL SILICON GRAPHICS, INC.
    ** BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
    ** TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE
    ** OR OTHER DEALINGS IN THE SOFTWARE.
    ** 
    ** Except as contained in this notice, the name of Silicon Graphics, Inc. shall not
    ** be used in advertising or otherwise to promote the sale, use or other dealings in
    ** this Software without prior written authorization from Silicon Graphics, Inc.
    */

    	/* Public API */

    	var Tess2 = {};

    	var tess2 = Tess2;
    	
    	Tess2.WINDING_ODD = 0;
    	Tess2.WINDING_NONZERO = 1;
    	Tess2.WINDING_POSITIVE = 2;
    	Tess2.WINDING_NEGATIVE = 3;
    	Tess2.WINDING_ABS_GEQ_TWO = 4;

    	Tess2.POLYGONS = 0;
    	Tess2.CONNECTED_POLYGONS = 1;
    	Tess2.BOUNDARY_CONTOURS = 2;

    	Tess2.tesselate = function(opts) {
    		var debug =  opts.debug || false;
    		var tess = new Tesselator();
    		for (var i = 0; i < opts.contours.length; i++) {
    			tess.addContour(opts.vertexSize || 2, opts.contours[i]);
    		}
    		tess.tesselate(opts.windingRule || Tess2.WINDING_ODD,
    					   opts.elementType || Tess2.POLYGONS,
    					   opts.polySize || 3,
    					   opts.vertexSize || 2,
    					   opts.normal || [0,0,1]);
    		return {
    			vertices: tess.vertices,
    			vertexIndices: tess.vertexIndices,
    			vertexCount: tess.vertexCount,
    			elements: tess.elements,
    			elementCount: tess.elementCount,
    			mesh: debug ? tess.mesh : undefined
    		};
    	};

    	/* Internal */

    	var assert$1 = function(cond) {
    		if (!cond) {
    			throw "Assertion Failed!";
    		}
    	};

    	/* The mesh structure is similar in spirit, notation, and operations
    	* to the "quad-edge" structure (see L. Guibas and J. Stolfi, Primitives
    	* for the manipulation of general subdivisions and the computation of
    	* Voronoi diagrams, ACM Transactions on Graphics, 4(2):74-123, April 1985).
    	* For a simplified description, see the course notes for CS348a,
    	* "Mathematical Foundations of Computer Graphics", available at the
    	* Stanford bookstore (and taught during the fall quarter).
    	* The implementation also borrows a tiny subset of the graph-based approach
    	* use in Mantyla's Geometric Work Bench (see M. Mantyla, An Introduction
    	* to Sold Modeling, Computer Science Press, Rockville, Maryland, 1988).
    	*
    	* The fundamental data structure is the "half-edge".  Two half-edges
    	* go together to make an edge, but they point in opposite directions.
    	* Each half-edge has a pointer to its mate (the "symmetric" half-edge Sym),
    	* its origin vertex (Org), the face on its left side (Lface), and the
    	* adjacent half-edges in the CCW direction around the origin vertex
    	* (Onext) and around the left face (Lnext).  There is also a "next"
    	* pointer for the global edge list (see below).
    	*
    	* The notation used for mesh navigation:
    	*  Sym   = the mate of a half-edge (same edge, but opposite direction)
    	*  Onext = edge CCW around origin vertex (keep same origin)
    	*  Dnext = edge CCW around destination vertex (keep same dest)
    	*  Lnext = edge CCW around left face (dest becomes new origin)
    	*  Rnext = edge CCW around right face (origin becomes new dest)
    	*
    	* "prev" means to substitute CW for CCW in the definitions above.
    	*
    	* The mesh keeps global lists of all vertices, faces, and edges,
    	* stored as doubly-linked circular lists with a dummy header node.
    	* The mesh stores pointers to these dummy headers (vHead, fHead, eHead).
    	*
    	* The circular edge list is special; since half-edges always occur
    	* in pairs (e and e->Sym), each half-edge stores a pointer in only
    	* one direction.  Starting at eHead and following the e->next pointers
    	* will visit each *edge* once (ie. e or e->Sym, but not both).
    	* e->Sym stores a pointer in the opposite direction, thus it is
    	* always true that e->Sym->next->Sym->next == e.
    	*
    	* Each vertex has a pointer to next and previous vertices in the
    	* circular list, and a pointer to a half-edge with this vertex as
    	* the origin (NULL if this is the dummy header).  There is also a
    	* field "data" for client data.
    	*
    	* Each face has a pointer to the next and previous faces in the
    	* circular list, and a pointer to a half-edge with this face as
    	* the left face (NULL if this is the dummy header).  There is also
    	* a field "data" for client data.
    	*
    	* Note that what we call a "face" is really a loop; faces may consist
    	* of more than one loop (ie. not simply connected), but there is no
    	* record of this in the data structure.  The mesh may consist of
    	* several disconnected regions, so it may not be possible to visit
    	* the entire mesh by starting at a half-edge and traversing the edge
    	* structure.
    	*
    	* The mesh does NOT support isolated vertices; a vertex is deleted along
    	* with its last edge.  Similarly when two faces are merged, one of the
    	* faces is deleted (see tessMeshDelete below).  For mesh operations,
    	* all face (loop) and vertex pointers must not be NULL.  However, once
    	* mesh manipulation is finished, TESSmeshZapFace can be used to delete
    	* faces of the mesh, one at a time.  All external faces can be "zapped"
    	* before the mesh is returned to the client; then a NULL face indicates
    	* a region which is not part of the output polygon.
    	*/

    	function TESSvertex() {
    		this.next = null;	/* next vertex (never NULL) */
    		this.prev = null;	/* previous vertex (never NULL) */
    		this.anEdge = null;	/* a half-edge with this origin */

    		/* Internal data (keep hidden) */
    		this.coords = [0,0,0];	/* vertex location in 3D */
    		this.s = 0.0;
    		this.t = 0.0;			/* projection onto the sweep plane */
    		this.pqHandle = 0;		/* to allow deletion from priority queue */
    		this.n = 0;				/* to allow identify unique vertices */
    		this.idx = 0;			/* to allow map result to original verts */
    	} 

    	function TESSface() {
    		this.next = null;		/* next face (never NULL) */
    		this.prev = null;		/* previous face (never NULL) */
    		this.anEdge = null;		/* a half edge with this left face */

    		/* Internal data (keep hidden) */
    		this.trail = null;		/* "stack" for conversion to strips */
    		this.n = 0;				/* to allow identiy unique faces */
    		this.marked = false;	/* flag for conversion to strips */
    		this.inside = false;	/* this face is in the polygon interior */
    	}
    	function TESShalfEdge(side) {
    		this.next = null;		/* doubly-linked list (prev==Sym->next) */
    		this.Sym = null;		/* same edge, opposite direction */
    		this.Onext = null;		/* next edge CCW around origin */
    		this.Lnext = null;		/* next edge CCW around left face */
    		this.Org = null;		/* origin vertex (Overtex too long) */
    		this.Lface = null;		/* left face */

    		/* Internal data (keep hidden) */
    		this.activeRegion = null;	/* a region with this upper edge (sweep.c) */
    		this.winding = 0;			/* change in winding number when crossing
    									   from the right face to the left face */
    		this.side = side;
    	}
    	TESShalfEdge.prototype = {
    		get Rface() { return this.Sym.Lface; },
    		set Rface(v) { this.Sym.Lface = v; },
    		get Dst() { return this.Sym.Org; },
    		set Dst(v) { this.Sym.Org = v; },
    		get Oprev() { return this.Sym.Lnext; },
    		set Oprev(v) { this.Sym.Lnext = v; },
    		get Lprev() { return this.Onext.Sym; },
    		set Lprev(v) { this.Onext.Sym = v; },
    		get Dprev() { return this.Lnext.Sym; },
    		set Dprev(v) { this.Lnext.Sym = v; },
    		get Rprev() { return this.Sym.Onext; },
    		set Rprev(v) { this.Sym.Onext = v; },
    		get Dnext() { return /*this.Rprev*/this.Sym.Onext.Sym; },  /* 3 pointers */
    		set Dnext(v) { /*this.Rprev*/this.Sym.Onext.Sym = v; },  /* 3 pointers */
    		get Rnext() { return /*this.Oprev*/this.Sym.Lnext.Sym; },  /* 3 pointers */
    		set Rnext(v) { /*this.Oprev*/this.Sym.Lnext.Sym = v; },  /* 3 pointers */
    	};



    	function TESSmesh() {
    		var v = new TESSvertex();
    		var f = new TESSface();
    		var e = new TESShalfEdge(0);
    		var eSym = new TESShalfEdge(1);

    		v.next = v.prev = v;
    		v.anEdge = null;

    		f.next = f.prev = f;
    		f.anEdge = null;
    		f.trail = null;
    		f.marked = false;
    		f.inside = false;

    		e.next = e;
    		e.Sym = eSym;
    		e.Onext = null;
    		e.Lnext = null;
    		e.Org = null;
    		e.Lface = null;
    		e.winding = 0;
    		e.activeRegion = null;

    		eSym.next = eSym;
    		eSym.Sym = e;
    		eSym.Onext = null;
    		eSym.Lnext = null;
    		eSym.Org = null;
    		eSym.Lface = null;
    		eSym.winding = 0;
    		eSym.activeRegion = null;

    		this.vHead = v;		/* dummy header for vertex list */
    		this.fHead = f;		/* dummy header for face list */
    		this.eHead = e;		/* dummy header for edge list */
    		this.eHeadSym = eSym;	/* and its symmetric counterpart */
    	}
    	/* The mesh operations below have three motivations: completeness,
    	* convenience, and efficiency.  The basic mesh operations are MakeEdge,
    	* Splice, and Delete.  All the other edge operations can be implemented
    	* in terms of these.  The other operations are provided for convenience
    	* and/or efficiency.
    	*
    	* When a face is split or a vertex is added, they are inserted into the
    	* global list *before* the existing vertex or face (ie. e->Org or e->Lface).
    	* This makes it easier to process all vertices or faces in the global lists
    	* without worrying about processing the same data twice.  As a convenience,
    	* when a face is split, the "inside" flag is copied from the old face.
    	* Other internal data (v->data, v->activeRegion, f->data, f->marked,
    	* f->trail, e->winding) is set to zero.
    	*
    	* ********************** Basic Edge Operations **************************
    	*
    	* tessMeshMakeEdge( mesh ) creates one edge, two vertices, and a loop.
    	* The loop (face) consists of the two new half-edges.
    	*
    	* tessMeshSplice( eOrg, eDst ) is the basic operation for changing the
    	* mesh connectivity and topology.  It changes the mesh so that
    	*  eOrg->Onext <- OLD( eDst->Onext )
    	*  eDst->Onext <- OLD( eOrg->Onext )
    	* where OLD(...) means the value before the meshSplice operation.
    	*
    	* This can have two effects on the vertex structure:
    	*  - if eOrg->Org != eDst->Org, the two vertices are merged together
    	*  - if eOrg->Org == eDst->Org, the origin is split into two vertices
    	* In both cases, eDst->Org is changed and eOrg->Org is untouched.
    	*
    	* Similarly (and independently) for the face structure,
    	*  - if eOrg->Lface == eDst->Lface, one loop is split into two
    	*  - if eOrg->Lface != eDst->Lface, two distinct loops are joined into one
    	* In both cases, eDst->Lface is changed and eOrg->Lface is unaffected.
    	*
    	* tessMeshDelete( eDel ) removes the edge eDel.  There are several cases:
    	* if (eDel->Lface != eDel->Rface), we join two loops into one; the loop
    	* eDel->Lface is deleted.  Otherwise, we are splitting one loop into two;
    	* the newly created loop will contain eDel->Dst.  If the deletion of eDel
    	* would create isolated vertices, those are deleted as well.
    	*
    	* ********************** Other Edge Operations **************************
    	*
    	* tessMeshAddEdgeVertex( eOrg ) creates a new edge eNew such that
    	* eNew == eOrg->Lnext, and eNew->Dst is a newly created vertex.
    	* eOrg and eNew will have the same left face.
    	*
    	* tessMeshSplitEdge( eOrg ) splits eOrg into two edges eOrg and eNew,
    	* such that eNew == eOrg->Lnext.  The new vertex is eOrg->Dst == eNew->Org.
    	* eOrg and eNew will have the same left face.
    	*
    	* tessMeshConnect( eOrg, eDst ) creates a new edge from eOrg->Dst
    	* to eDst->Org, and returns the corresponding half-edge eNew.
    	* If eOrg->Lface == eDst->Lface, this splits one loop into two,
    	* and the newly created loop is eNew->Lface.  Otherwise, two disjoint
    	* loops are merged into one, and the loop eDst->Lface is destroyed.
    	*
    	* ************************ Other Operations *****************************
    	*
    	* tessMeshNewMesh() creates a new mesh with no edges, no vertices,
    	* and no loops (what we usually call a "face").
    	*
    	* tessMeshUnion( mesh1, mesh2 ) forms the union of all structures in
    	* both meshes, and returns the new mesh (the old meshes are destroyed).
    	*
    	* tessMeshDeleteMesh( mesh ) will free all storage for any valid mesh.
    	*
    	* tessMeshZapFace( fZap ) destroys a face and removes it from the
    	* global face list.  All edges of fZap will have a NULL pointer as their
    	* left face.  Any edges which also have a NULL pointer as their right face
    	* are deleted entirely (along with any isolated vertices this produces).
    	* An entire mesh can be deleted by zapping its faces, one at a time,
    	* in any order.  Zapped faces cannot be used in further mesh operations!
    	*
    	* tessMeshCheckMesh( mesh ) checks a mesh for self-consistency.
    	*/

    	TESSmesh.prototype = {

    		/* MakeEdge creates a new pair of half-edges which form their own loop.
    		* No vertex or face structures are allocated, but these must be assigned
    		* before the current edge operation is completed.
    		*/
    		//static TESShalfEdge *MakeEdge( TESSmesh* mesh, TESShalfEdge *eNext )
    		makeEdge_: function(eNext) {
    			var e = new TESShalfEdge(0);
    			var eSym = new TESShalfEdge(1);

    			/* Make sure eNext points to the first edge of the edge pair */
    			if( eNext.Sym.side < eNext.side ) { eNext = eNext.Sym; }

    			/* Insert in circular doubly-linked list before eNext.
    			* Note that the prev pointer is stored in Sym->next.
    			*/
    			var ePrev = eNext.Sym.next;
    			eSym.next = ePrev;
    			ePrev.Sym.next = e;
    			e.next = eNext;
    			eNext.Sym.next = eSym;

    			e.Sym = eSym;
    			e.Onext = e;
    			e.Lnext = eSym;
    			e.Org = null;
    			e.Lface = null;
    			e.winding = 0;
    			e.activeRegion = null;

    			eSym.Sym = e;
    			eSym.Onext = eSym;
    			eSym.Lnext = e;
    			eSym.Org = null;
    			eSym.Lface = null;
    			eSym.winding = 0;
    			eSym.activeRegion = null;

    			return e;
    		},

    		/* Splice( a, b ) is best described by the Guibas/Stolfi paper or the
    		* CS348a notes (see mesh.h).  Basically it modifies the mesh so that
    		* a->Onext and b->Onext are exchanged.  This can have various effects
    		* depending on whether a and b belong to different face or vertex rings.
    		* For more explanation see tessMeshSplice() below.
    		*/
    		// static void Splice( TESShalfEdge *a, TESShalfEdge *b )
    		splice_: function(a, b) {
    			var aOnext = a.Onext;
    			var bOnext = b.Onext;
    			aOnext.Sym.Lnext = b;
    			bOnext.Sym.Lnext = a;
    			a.Onext = bOnext;
    			b.Onext = aOnext;
    		},

    		/* MakeVertex( newVertex, eOrig, vNext ) attaches a new vertex and makes it the
    		* origin of all edges in the vertex loop to which eOrig belongs. "vNext" gives
    		* a place to insert the new vertex in the global vertex list.  We insert
    		* the new vertex *before* vNext so that algorithms which walk the vertex
    		* list will not see the newly created vertices.
    		*/
    		//static void MakeVertex( TESSvertex *newVertex, TESShalfEdge *eOrig, TESSvertex *vNext )
    		makeVertex_: function(newVertex, eOrig, vNext) {
    			var vNew = newVertex;
    			assert$1(vNew !== null);

    			/* insert in circular doubly-linked list before vNext */
    			var vPrev = vNext.prev;
    			vNew.prev = vPrev;
    			vPrev.next = vNew;
    			vNew.next = vNext;
    			vNext.prev = vNew;

    			vNew.anEdge = eOrig;
    			/* leave coords, s, t undefined */

    			/* fix other edges on this vertex loop */
    			var e = eOrig;
    			do {
    				e.Org = vNew;
    				e = e.Onext;
    			} while(e !== eOrig);
    		},

    		/* MakeFace( newFace, eOrig, fNext ) attaches a new face and makes it the left
    		* face of all edges in the face loop to which eOrig belongs.  "fNext" gives
    		* a place to insert the new face in the global face list.  We insert
    		* the new face *before* fNext so that algorithms which walk the face
    		* list will not see the newly created faces.
    		*/
    		// static void MakeFace( TESSface *newFace, TESShalfEdge *eOrig, TESSface *fNext )
    		makeFace_: function(newFace, eOrig, fNext) {
    			var fNew = newFace;
    			assert$1(fNew !== null); 

    			/* insert in circular doubly-linked list before fNext */
    			var fPrev = fNext.prev;
    			fNew.prev = fPrev;
    			fPrev.next = fNew;
    			fNew.next = fNext;
    			fNext.prev = fNew;

    			fNew.anEdge = eOrig;
    			fNew.trail = null;
    			fNew.marked = false;

    			/* The new face is marked "inside" if the old one was.  This is a
    			* convenience for the common case where a face has been split in two.
    			*/
    			fNew.inside = fNext.inside;

    			/* fix other edges on this face loop */
    			var e = eOrig;
    			do {
    				e.Lface = fNew;
    				e = e.Lnext;
    			} while(e !== eOrig);
    		},

    		/* KillEdge( eDel ) destroys an edge (the half-edges eDel and eDel->Sym),
    		* and removes from the global edge list.
    		*/
    		//static void KillEdge( TESSmesh *mesh, TESShalfEdge *eDel )
    		killEdge_: function(eDel) {
    			/* Half-edges are allocated in pairs, see EdgePair above */
    			if( eDel.Sym.side < eDel.side ) { eDel = eDel.Sym; }

    			/* delete from circular doubly-linked list */
    			var eNext = eDel.next;
    			var ePrev = eDel.Sym.next;
    			eNext.Sym.next = ePrev;
    			ePrev.Sym.next = eNext;
    		},


    		/* KillVertex( vDel ) destroys a vertex and removes it from the global
    		* vertex list.  It updates the vertex loop to point to a given new vertex.
    		*/
    		//static void KillVertex( TESSmesh *mesh, TESSvertex *vDel, TESSvertex *newOrg )
    		killVertex_: function(vDel, newOrg) {
    			var eStart = vDel.anEdge;
    			/* change the origin of all affected edges */
    			var e = eStart;
    			do {
    				e.Org = newOrg;
    				e = e.Onext;
    			} while(e !== eStart);

    			/* delete from circular doubly-linked list */
    			var vPrev = vDel.prev;
    			var vNext = vDel.next;
    			vNext.prev = vPrev;
    			vPrev.next = vNext;
    		},

    		/* KillFace( fDel ) destroys a face and removes it from the global face
    		* list.  It updates the face loop to point to a given new face.
    		*/
    		//static void KillFace( TESSmesh *mesh, TESSface *fDel, TESSface *newLface )
    		killFace_: function(fDel, newLface) {
    			var eStart = fDel.anEdge;

    			/* change the left face of all affected edges */
    			var e = eStart;
    			do {
    				e.Lface = newLface;
    				e = e.Lnext;
    			} while(e !== eStart);

    			/* delete from circular doubly-linked list */
    			var fPrev = fDel.prev;
    			var fNext = fDel.next;
    			fNext.prev = fPrev;
    			fPrev.next = fNext;
    		},

    		/****************** Basic Edge Operations **********************/

    		/* tessMeshMakeEdge creates one edge, two vertices, and a loop (face).
    		* The loop consists of the two new half-edges.
    		*/
    		//TESShalfEdge *tessMeshMakeEdge( TESSmesh *mesh )
    		makeEdge: function() {
    			var newVertex1 = new TESSvertex();
    			var newVertex2 = new TESSvertex();
    			var newFace = new TESSface();
    			var e = this.makeEdge_( this.eHead);
    			this.makeVertex_( newVertex1, e, this.vHead );
    			this.makeVertex_( newVertex2, e.Sym, this.vHead );
    			this.makeFace_( newFace, e, this.fHead );
    			return e;
    		},

    		/* tessMeshSplice( eOrg, eDst ) is the basic operation for changing the
    		* mesh connectivity and topology.  It changes the mesh so that
    		*	eOrg->Onext <- OLD( eDst->Onext )
    		*	eDst->Onext <- OLD( eOrg->Onext )
    		* where OLD(...) means the value before the meshSplice operation.
    		*
    		* This can have two effects on the vertex structure:
    		*  - if eOrg->Org != eDst->Org, the two vertices are merged together
    		*  - if eOrg->Org == eDst->Org, the origin is split into two vertices
    		* In both cases, eDst->Org is changed and eOrg->Org is untouched.
    		*
    		* Similarly (and independently) for the face structure,
    		*  - if eOrg->Lface == eDst->Lface, one loop is split into two
    		*  - if eOrg->Lface != eDst->Lface, two distinct loops are joined into one
    		* In both cases, eDst->Lface is changed and eOrg->Lface is unaffected.
    		*
    		* Some special cases:
    		* If eDst == eOrg, the operation has no effect.
    		* If eDst == eOrg->Lnext, the new face will have a single edge.
    		* If eDst == eOrg->Lprev, the old face will have a single edge.
    		* If eDst == eOrg->Onext, the new vertex will have a single edge.
    		* If eDst == eOrg->Oprev, the old vertex will have a single edge.
    		*/
    		//int tessMeshSplice( TESSmesh* mesh, TESShalfEdge *eOrg, TESShalfEdge *eDst )
    		splice: function(eOrg, eDst) {
    			var joiningLoops = false;
    			var joiningVertices = false;

    			if( eOrg === eDst ) return;

    			if( eDst.Org !== eOrg.Org ) {
    				/* We are merging two disjoint vertices -- destroy eDst->Org */
    				joiningVertices = true;
    				this.killVertex_( eDst.Org, eOrg.Org );
    			}
    			if( eDst.Lface !== eOrg.Lface ) {
    				/* We are connecting two disjoint loops -- destroy eDst->Lface */
    				joiningLoops = true;
    				this.killFace_( eDst.Lface, eOrg.Lface );
    			}

    			/* Change the edge structure */
    			this.splice_( eDst, eOrg );

    			if( ! joiningVertices ) {
    				var newVertex = new TESSvertex();

    				/* We split one vertex into two -- the new vertex is eDst->Org.
    				* Make sure the old vertex points to a valid half-edge.
    				*/
    				this.makeVertex_( newVertex, eDst, eOrg.Org );
    				eOrg.Org.anEdge = eOrg;
    			}
    			if( ! joiningLoops ) {
    				var newFace = new TESSface();  

    				/* We split one loop into two -- the new loop is eDst->Lface.
    				* Make sure the old face points to a valid half-edge.
    				*/
    				this.makeFace_( newFace, eDst, eOrg.Lface );
    				eOrg.Lface.anEdge = eOrg;
    			}
    		},

    		/* tessMeshDelete( eDel ) removes the edge eDel.  There are several cases:
    		* if (eDel->Lface != eDel->Rface), we join two loops into one; the loop
    		* eDel->Lface is deleted.  Otherwise, we are splitting one loop into two;
    		* the newly created loop will contain eDel->Dst.  If the deletion of eDel
    		* would create isolated vertices, those are deleted as well.
    		*
    		* This function could be implemented as two calls to tessMeshSplice
    		* plus a few calls to memFree, but this would allocate and delete
    		* unnecessary vertices and faces.
    		*/
    		//int tessMeshDelete( TESSmesh *mesh, TESShalfEdge *eDel )
    		delete: function(eDel) {
    			var eDelSym = eDel.Sym;
    			var joiningLoops = false;

    			/* First step: disconnect the origin vertex eDel->Org.  We make all
    			* changes to get a consistent mesh in this "intermediate" state.
    			*/
    			if( eDel.Lface !== eDel.Rface ) {
    				/* We are joining two loops into one -- remove the left face */
    				joiningLoops = true;
    				this.killFace_( eDel.Lface, eDel.Rface );
    			}

    			if( eDel.Onext === eDel ) {
    				this.killVertex_( eDel.Org, null );
    			} else {
    				/* Make sure that eDel->Org and eDel->Rface point to valid half-edges */
    				eDel.Rface.anEdge = eDel.Oprev;
    				eDel.Org.anEdge = eDel.Onext;

    				this.splice_( eDel, eDel.Oprev );
    				if( ! joiningLoops ) {
    					var newFace = new TESSface();

    					/* We are splitting one loop into two -- create a new loop for eDel. */
    					this.makeFace_( newFace, eDel, eDel.Lface );
    				}
    			}

    			/* Claim: the mesh is now in a consistent state, except that eDel->Org
    			* may have been deleted.  Now we disconnect eDel->Dst.
    			*/
    			if( eDelSym.Onext === eDelSym ) {
    				this.killVertex_( eDelSym.Org, null );
    				this.killFace_( eDelSym.Lface, null );
    			} else {
    				/* Make sure that eDel->Dst and eDel->Lface point to valid half-edges */
    				eDel.Lface.anEdge = eDelSym.Oprev;
    				eDelSym.Org.anEdge = eDelSym.Onext;
    				this.splice_( eDelSym, eDelSym.Oprev );
    			}

    			/* Any isolated vertices or faces have already been freed. */
    			this.killEdge_( eDel );
    		},

    		/******************** Other Edge Operations **********************/

    		/* All these routines can be implemented with the basic edge
    		* operations above.  They are provided for convenience and efficiency.
    		*/


    		/* tessMeshAddEdgeVertex( eOrg ) creates a new edge eNew such that
    		* eNew == eOrg->Lnext, and eNew->Dst is a newly created vertex.
    		* eOrg and eNew will have the same left face.
    		*/
    		// TESShalfEdge *tessMeshAddEdgeVertex( TESSmesh *mesh, TESShalfEdge *eOrg );
    		addEdgeVertex: function(eOrg) {
    			var eNew = this.makeEdge_( eOrg );
    			var eNewSym = eNew.Sym;

    			/* Connect the new edge appropriately */
    			this.splice_( eNew, eOrg.Lnext );

    			/* Set the vertex and face information */
    			eNew.Org = eOrg.Dst;

    			var newVertex = new TESSvertex();
    			this.makeVertex_( newVertex, eNewSym, eNew.Org );

    			eNew.Lface = eNewSym.Lface = eOrg.Lface;

    			return eNew;
    		},


    		/* tessMeshSplitEdge( eOrg ) splits eOrg into two edges eOrg and eNew,
    		* such that eNew == eOrg->Lnext.  The new vertex is eOrg->Dst == eNew->Org.
    		* eOrg and eNew will have the same left face.
    		*/
    		// TESShalfEdge *tessMeshSplitEdge( TESSmesh *mesh, TESShalfEdge *eOrg );
    		splitEdge: function(eOrg, eDst) {
    			var tempHalfEdge = this.addEdgeVertex( eOrg );
    			var eNew = tempHalfEdge.Sym;

    			/* Disconnect eOrg from eOrg->Dst and connect it to eNew->Org */
    			this.splice_( eOrg.Sym, eOrg.Sym.Oprev );
    			this.splice_( eOrg.Sym, eNew );

    			/* Set the vertex and face information */
    			eOrg.Dst = eNew.Org;
    			eNew.Dst.anEdge = eNew.Sym;	/* may have pointed to eOrg->Sym */
    			eNew.Rface = eOrg.Rface;
    			eNew.winding = eOrg.winding;	/* copy old winding information */
    			eNew.Sym.winding = eOrg.Sym.winding;

    			return eNew;
    		},


    		/* tessMeshConnect( eOrg, eDst ) creates a new edge from eOrg->Dst
    		* to eDst->Org, and returns the corresponding half-edge eNew.
    		* If eOrg->Lface == eDst->Lface, this splits one loop into two,
    		* and the newly created loop is eNew->Lface.  Otherwise, two disjoint
    		* loops are merged into one, and the loop eDst->Lface is destroyed.
    		*
    		* If (eOrg == eDst), the new face will have only two edges.
    		* If (eOrg->Lnext == eDst), the old face is reduced to a single edge.
    		* If (eOrg->Lnext->Lnext == eDst), the old face is reduced to two edges.
    		*/

    		// TESShalfEdge *tessMeshConnect( TESSmesh *mesh, TESShalfEdge *eOrg, TESShalfEdge *eDst );
    		connect: function(eOrg, eDst) {
    			var joiningLoops = false;  
    			var eNew = this.makeEdge_( eOrg );
    			var eNewSym = eNew.Sym;

    			if( eDst.Lface !== eOrg.Lface ) {
    				/* We are connecting two disjoint loops -- destroy eDst->Lface */
    				joiningLoops = true;
    				this.killFace_( eDst.Lface, eOrg.Lface );
    			}

    			/* Connect the new edge appropriately */
    			this.splice_( eNew, eOrg.Lnext );
    			this.splice_( eNewSym, eDst );

    			/* Set the vertex and face information */
    			eNew.Org = eOrg.Dst;
    			eNewSym.Org = eDst.Org;
    			eNew.Lface = eNewSym.Lface = eOrg.Lface;

    			/* Make sure the old face points to a valid half-edge */
    			eOrg.Lface.anEdge = eNewSym;

    			if( ! joiningLoops ) {
    				var newFace = new TESSface();
    				/* We split one loop into two -- the new loop is eNew->Lface */
    				this.makeFace_( newFace, eNew, eOrg.Lface );
    			}
    			return eNew;
    		},

    		/* tessMeshZapFace( fZap ) destroys a face and removes it from the
    		* global face list.  All edges of fZap will have a NULL pointer as their
    		* left face.  Any edges which also have a NULL pointer as their right face
    		* are deleted entirely (along with any isolated vertices this produces).
    		* An entire mesh can be deleted by zapping its faces, one at a time,
    		* in any order.  Zapped faces cannot be used in further mesh operations!
    		*/
    		zapFace: function( fZap )
    		{
    			var eStart = fZap.anEdge;
    			var e, eNext, eSym;
    			var fPrev, fNext;

    			/* walk around face, deleting edges whose right face is also NULL */
    			eNext = eStart.Lnext;
    			do {
    				e = eNext;
    				eNext = e.Lnext;

    				e.Lface = null;
    				if( e.Rface === null ) {
    					/* delete the edge -- see TESSmeshDelete above */

    					if( e.Onext === e ) {
    						this.killVertex_( e.Org, null );
    					} else {
    						/* Make sure that e->Org points to a valid half-edge */
    						e.Org.anEdge = e.Onext;
    						this.splice_( e, e.Oprev );
    					}
    					eSym = e.Sym;
    					if( eSym.Onext === eSym ) {
    						this.killVertex_( eSym.Org, null );
    					} else {
    						/* Make sure that eSym->Org points to a valid half-edge */
    						eSym.Org.anEdge = eSym.Onext;
    						this.splice_( eSym, eSym.Oprev );
    					}
    					this.killEdge_( e );
    				}
    			} while( e != eStart );

    			/* delete from circular doubly-linked list */
    			fPrev = fZap.prev;
    			fNext = fZap.next;
    			fNext.prev = fPrev;
    			fPrev.next = fNext;
    		},

    		countFaceVerts_: function(f) {
    			var eCur = f.anEdge;
    			var n = 0;
    			do
    			{
    				n++;
    				eCur = eCur.Lnext;
    			}
    			while (eCur !== f.anEdge);
    			return n;
    		},

    		//int tessMeshMergeConvexFaces( TESSmesh *mesh, int maxVertsPerFace )
    		mergeConvexFaces: function(maxVertsPerFace) {
    			var f;
    			var eCur, eNext, eSym;
    			var vStart;
    			var curNv, symNv;

    			for( f = this.fHead.next; f !== this.fHead; f = f.next )
    			{
    				// Skip faces which are outside the result.
    				if( !f.inside )
    					continue;

    				eCur = f.anEdge;
    				vStart = eCur.Org;
    					
    				while (true)
    				{
    					eNext = eCur.Lnext;
    					eSym = eCur.Sym;

    					// Try to merge if the neighbour face is valid.
    					if( eSym && eSym.Lface && eSym.Lface.inside )
    					{
    						// Try to merge the neighbour faces if the resulting polygons
    						// does not exceed maximum number of vertices.
    						curNv = this.countFaceVerts_( f );
    						symNv = this.countFaceVerts_( eSym.Lface );
    						if( (curNv+symNv-2) <= maxVertsPerFace )
    						{
    							// Merge if the resulting poly is convex.
    							if( Geom.vertCCW( eCur.Lprev.Org, eCur.Org, eSym.Lnext.Lnext.Org ) &&
    								Geom.vertCCW( eSym.Lprev.Org, eSym.Org, eCur.Lnext.Lnext.Org ) )
    							{
    								eNext = eSym.Lnext;
    								this.delete( eSym );
    								eCur = null;
    								eSym = null;
    							}
    						}
    					}
    					
    					if( eCur && eCur.Lnext.Org === vStart )
    						break;
    						
    					// Continue to next edge.
    					eCur = eNext;
    				}
    			}
    			
    			return true;
    		},

    		/* tessMeshCheckMesh( mesh ) checks a mesh for self-consistency.
    		*/
    		check: function() {
    			var fHead = this.fHead;
    			var vHead = this.vHead;
    			var eHead = this.eHead;
    			var f, fPrev, v, vPrev, e, ePrev;

    			fPrev = fHead;
    			for( fPrev = fHead ; (f = fPrev.next) !== fHead; fPrev = f) {
    				assert$1( f.prev === fPrev );
    				e = f.anEdge;
    				do {
    					assert$1( e.Sym !== e );
    					assert$1( e.Sym.Sym === e );
    					assert$1( e.Lnext.Onext.Sym === e );
    					assert$1( e.Onext.Sym.Lnext === e );
    					assert$1( e.Lface === f );
    					e = e.Lnext;
    				} while( e !== f.anEdge );
    			}
    			assert$1( f.prev === fPrev && f.anEdge === null );

    			vPrev = vHead;
    			for( vPrev = vHead ; (v = vPrev.next) !== vHead; vPrev = v) {
    				assert$1( v.prev === vPrev );
    				e = v.anEdge;
    				do {
    					assert$1( e.Sym !== e );
    					assert$1( e.Sym.Sym === e );
    					assert$1( e.Lnext.Onext.Sym === e );
    					assert$1( e.Onext.Sym.Lnext === e );
    					assert$1( e.Org === v );
    					e = e.Onext;
    				} while( e !== v.anEdge );
    			}
    			assert$1( v.prev === vPrev && v.anEdge === null );

    			ePrev = eHead;
    			for( ePrev = eHead ; (e = ePrev.next) !== eHead; ePrev = e) {
    				assert$1( e.Sym.next === ePrev.Sym );
    				assert$1( e.Sym !== e );
    				assert$1( e.Sym.Sym === e );
    				assert$1( e.Org !== null );
    				assert$1( e.Dst !== null );
    				assert$1( e.Lnext.Onext.Sym === e );
    				assert$1( e.Onext.Sym.Lnext === e );
    			}
    			assert$1( e.Sym.next === ePrev.Sym
    				&& e.Sym === this.eHeadSym
    				&& e.Sym.Sym === e
    				&& e.Org === null && e.Dst === null
    				&& e.Lface === null && e.Rface === null );
    		}

    	};

    	var Geom = {};

    	Geom.vertEq = function(u,v) {
    		return (u.s === v.s && u.t === v.t);
    	};

    	/* Returns TRUE if u is lexicographically <= v. */
    	Geom.vertLeq = function(u,v) {
    		return ((u.s < v.s) || (u.s === v.s && u.t <= v.t));
    	};

    	/* Versions of VertLeq, EdgeSign, EdgeEval with s and t transposed. */
    	Geom.transLeq = function(u,v) {
    		return ((u.t < v.t) || (u.t === v.t && u.s <= v.s));
    	};

    	Geom.edgeGoesLeft = function(e) {
    		return Geom.vertLeq( e.Dst, e.Org );
    	};

    	Geom.edgeGoesRight = function(e) {
    		return Geom.vertLeq( e.Org, e.Dst );
    	};

    	Geom.vertL1dist = function(u,v) {
    		return (Math.abs(u.s - v.s) + Math.abs(u.t - v.t));
    	};

    	//TESSreal tesedgeEval( TESSvertex *u, TESSvertex *v, TESSvertex *w )
    	Geom.edgeEval = function( u, v, w ) {
    		/* Given three vertices u,v,w such that VertLeq(u,v) && VertLeq(v,w),
    		* evaluates the t-coord of the edge uw at the s-coord of the vertex v.
    		* Returns v->t - (uw)(v->s), ie. the signed distance from uw to v.
    		* If uw is vertical (and thus passes thru v), the result is zero.
    		*
    		* The calculation is extremely accurate and stable, even when v
    		* is very close to u or w.  In particular if we set v->t = 0 and
    		* let r be the negated result (this evaluates (uw)(v->s)), then
    		* r is guaranteed to satisfy MIN(u->t,w->t) <= r <= MAX(u->t,w->t).
    		*/
    		assert$1( Geom.vertLeq( u, v ) && Geom.vertLeq( v, w ));

    		var gapL = v.s - u.s;
    		var gapR = w.s - v.s;

    		if( gapL + gapR > 0.0 ) {
    			if( gapL < gapR ) {
    				return (v.t - u.t) + (u.t - w.t) * (gapL / (gapL + gapR));
    			} else {
    				return (v.t - w.t) + (w.t - u.t) * (gapR / (gapL + gapR));
    			}
    		}
    		/* vertical line */
    		return 0.0;
    	};

    	//TESSreal tesedgeSign( TESSvertex *u, TESSvertex *v, TESSvertex *w )
    	Geom.edgeSign = function( u, v, w ) {
    		/* Returns a number whose sign matches EdgeEval(u,v,w) but which
    		* is cheaper to evaluate.  Returns > 0, == 0 , or < 0
    		* as v is above, on, or below the edge uw.
    		*/
    		assert$1( Geom.vertLeq( u, v ) && Geom.vertLeq( v, w ));

    		var gapL = v.s - u.s;
    		var gapR = w.s - v.s;

    		if( gapL + gapR > 0.0 ) {
    			return (v.t - w.t) * gapL + (v.t - u.t) * gapR;
    		}
    		/* vertical line */
    		return 0.0;
    	};


    	/***********************************************************************
    	* Define versions of EdgeSign, EdgeEval with s and t transposed.
    	*/

    	//TESSreal testransEval( TESSvertex *u, TESSvertex *v, TESSvertex *w )
    	Geom.transEval = function( u, v, w ) {
    		/* Given three vertices u,v,w such that TransLeq(u,v) && TransLeq(v,w),
    		* evaluates the t-coord of the edge uw at the s-coord of the vertex v.
    		* Returns v->s - (uw)(v->t), ie. the signed distance from uw to v.
    		* If uw is vertical (and thus passes thru v), the result is zero.
    		*
    		* The calculation is extremely accurate and stable, even when v
    		* is very close to u or w.  In particular if we set v->s = 0 and
    		* let r be the negated result (this evaluates (uw)(v->t)), then
    		* r is guaranteed to satisfy MIN(u->s,w->s) <= r <= MAX(u->s,w->s).
    		*/
    		assert$1( Geom.transLeq( u, v ) && Geom.transLeq( v, w ));

    		var gapL = v.t - u.t;
    		var gapR = w.t - v.t;

    		if( gapL + gapR > 0.0 ) {
    			if( gapL < gapR ) {
    				return (v.s - u.s) + (u.s - w.s) * (gapL / (gapL + gapR));
    			} else {
    				return (v.s - w.s) + (w.s - u.s) * (gapR / (gapL + gapR));
    			}
    		}
    		/* vertical line */
    		return 0.0;
    	};

    	//TESSreal testransSign( TESSvertex *u, TESSvertex *v, TESSvertex *w )
    	Geom.transSign = function( u, v, w ) {
    		/* Returns a number whose sign matches TransEval(u,v,w) but which
    		* is cheaper to evaluate.  Returns > 0, == 0 , or < 0
    		* as v is above, on, or below the edge uw.
    		*/
    		assert$1( Geom.transLeq( u, v ) && Geom.transLeq( v, w ));

    		var gapL = v.t - u.t;
    		var gapR = w.t - v.t;

    		if( gapL + gapR > 0.0 ) {
    			return (v.s - w.s) * gapL + (v.s - u.s) * gapR;
    		}
    		/* vertical line */
    		return 0.0;
    	};


    	//int tesvertCCW( TESSvertex *u, TESSvertex *v, TESSvertex *w )
    	Geom.vertCCW = function( u, v, w ) {
    		/* For almost-degenerate situations, the results are not reliable.
    		* Unless the floating-point arithmetic can be performed without
    		* rounding errors, *any* implementation will give incorrect results
    		* on some degenerate inputs, so the client must have some way to
    		* handle this situation.
    		*/
    		return (u.s*(v.t - w.t) + v.s*(w.t - u.t) + w.s*(u.t - v.t)) >= 0.0;
    	};

    	/* Given parameters a,x,b,y returns the value (b*x+a*y)/(a+b),
    	* or (x+y)/2 if a==b==0.  It requires that a,b >= 0, and enforces
    	* this in the rare case that one argument is slightly negative.
    	* The implementation is extremely stable numerically.
    	* In particular it guarantees that the result r satisfies
    	* MIN(x,y) <= r <= MAX(x,y), and the results are very accurate
    	* even when a and b differ greatly in magnitude.
    	*/
    	Geom.interpolate = function(a,x,b,y) {
    		return (a = (a < 0) ? 0 : a, b = (b < 0) ? 0 : b, (a <= b) ? ((b == 0) ? ((x+y) / 2) : (x + (y-x) * (a/(a+b)))) : (y + (x-y) * (b/(a+b))));
    	};

    	/*
    	#ifndef FOR_TRITE_TEST_PROGRAM
    	#define Interpolate(a,x,b,y)	RealInterpolate(a,x,b,y)
    	#else

    	// Claim: the ONLY property the sweep algorithm relies on is that
    	// MIN(x,y) <= r <= MAX(x,y).  This is a nasty way to test that.
    	#include <stdlib.h>
    	extern int RandomInterpolate;

    	double Interpolate( double a, double x, double b, double y)
    	{
    		printf("*********************%d\n",RandomInterpolate);
    		if( RandomInterpolate ) {
    			a = 1.2 * drand48() - 0.1;
    			a = (a < 0) ? 0 : ((a > 1) ? 1 : a);
    			b = 1.0 - a;
    		}
    		return RealInterpolate(a,x,b,y);
    	}
    	#endif*/

    	Geom.intersect = function( o1, d1, o2, d2, v ) {
    		/* Given edges (o1,d1) and (o2,d2), compute their point of intersection.
    		* The computed point is guaranteed to lie in the intersection of the
    		* bounding rectangles defined by each edge.
    		*/
    		var z1, z2;
    		var t;

    		/* This is certainly not the most efficient way to find the intersection
    		* of two line segments, but it is very numerically stable.
    		*
    		* Strategy: find the two middle vertices in the VertLeq ordering,
    		* and interpolate the intersection s-value from these.  Then repeat
    		* using the TransLeq ordering to find the intersection t-value.
    		*/

    		if( ! Geom.vertLeq( o1, d1 )) { t = o1; o1 = d1; d1 = t; } //swap( o1, d1 ); }
    		if( ! Geom.vertLeq( o2, d2 )) { t = o2; o2 = d2; d2 = t; } //swap( o2, d2 ); }
    		if( ! Geom.vertLeq( o1, o2 )) { t = o1; o1 = o2; o2 = t; t = d1; d1 = d2; d2 = t; }//swap( o1, o2 ); swap( d1, d2 ); }

    		if( ! Geom.vertLeq( o2, d1 )) {
    			/* Technically, no intersection -- do our best */
    			v.s = (o2.s + d1.s) / 2;
    		} else if( Geom.vertLeq( d1, d2 )) {
    			/* Interpolate between o2 and d1 */
    			z1 = Geom.edgeEval( o1, o2, d1 );
    			z2 = Geom.edgeEval( o2, d1, d2 );
    			if( z1+z2 < 0 ) { z1 = -z1; z2 = -z2; }
    			v.s = Geom.interpolate( z1, o2.s, z2, d1.s );
    		} else {
    			/* Interpolate between o2 and d2 */
    			z1 = Geom.edgeSign( o1, o2, d1 );
    			z2 = -Geom.edgeSign( o1, d2, d1 );
    			if( z1+z2 < 0 ) { z1 = -z1; z2 = -z2; }
    			v.s = Geom.interpolate( z1, o2.s, z2, d2.s );
    		}

    		/* Now repeat the process for t */

    		if( ! Geom.transLeq( o1, d1 )) { t = o1; o1 = d1; d1 = t; } //swap( o1, d1 ); }
    		if( ! Geom.transLeq( o2, d2 )) { t = o2; o2 = d2; d2 = t; } //swap( o2, d2 ); }
    		if( ! Geom.transLeq( o1, o2 )) { t = o1; o1 = o2; o2 = t; t = d1; d1 = d2; d2 = t; } //swap( o1, o2 ); swap( d1, d2 ); }

    		if( ! Geom.transLeq( o2, d1 )) {
    			/* Technically, no intersection -- do our best */
    			v.t = (o2.t + d1.t) / 2;
    		} else if( Geom.transLeq( d1, d2 )) {
    			/* Interpolate between o2 and d1 */
    			z1 = Geom.transEval( o1, o2, d1 );
    			z2 = Geom.transEval( o2, d1, d2 );
    			if( z1+z2 < 0 ) { z1 = -z1; z2 = -z2; }
    			v.t = Geom.interpolate( z1, o2.t, z2, d1.t );
    		} else {
    			/* Interpolate between o2 and d2 */
    			z1 = Geom.transSign( o1, o2, d1 );
    			z2 = -Geom.transSign( o1, d2, d1 );
    			if( z1+z2 < 0 ) { z1 = -z1; z2 = -z2; }
    			v.t = Geom.interpolate( z1, o2.t, z2, d2.t );
    		}
    	};



    	function DictNode() {
    		this.key = null;
    		this.next = null;
    		this.prev = null;
    	}
    	function Dict(frame, leq) {
    		this.head = new DictNode();
    		this.head.next = this.head;
    		this.head.prev = this.head;
    		this.frame = frame;
    		this.leq = leq;
    	}
    	Dict.prototype = {
    		min: function() {
    			return this.head.next;
    		},

    		max: function() {
    			return this.head.prev;
    		},

    		insert: function(k) {
    			return this.insertBefore(this.head, k);
    		},

    		search: function(key) {
    			/* Search returns the node with the smallest key greater than or equal
    			* to the given key.  If there is no such key, returns a node whose
    			* key is NULL.  Similarly, Succ(Max(d)) has a NULL key, etc.
    			*/
    			var node = this.head;
    			do {
    				node = node.next;
    			} while( node.key !== null && ! this.leq(this.frame, key, node.key));

    			return node;
    		},

    		insertBefore: function(node, key) {
    			do {
    				node = node.prev;
    			} while( node.key !== null && ! this.leq(this.frame, node.key, key));

    			var newNode = new DictNode();
    			newNode.key = key;
    			newNode.next = node.next;
    			node.next.prev = newNode;
    			newNode.prev = node;
    			node.next = newNode;

    			return newNode;
    		},

    		delete: function(node) {
    			node.next.prev = node.prev;
    			node.prev.next = node.next;
    		}
    	};


    	function PQnode() {
    		this.handle = null;
    	}

    	function PQhandleElem() {
    		this.key = null;
    		this.node = null;
    	}

    	function PriorityQ(size, leq) {
    		this.size = 0;
    		this.max = size;

    		this.nodes = [];
    		this.nodes.length = size+1;
    		for (var i = 0; i < this.nodes.length; i++)
    			this.nodes[i] = new PQnode();

    		this.handles = [];
    		this.handles.length = size+1;
    		for (var i = 0; i < this.handles.length; i++)
    			this.handles[i] = new PQhandleElem();

    		this.initialized = false;
    		this.freeList = 0;
    		this.leq = leq;

    		this.nodes[1].handle = 1;	/* so that Minimum() returns NULL */
    		this.handles[1].key = null;
    	}
    	PriorityQ.prototype = {

    		floatDown_: function( curr )
    		{
    			var n = this.nodes;
    			var h = this.handles;
    			var hCurr, hChild;
    			var child;

    			hCurr = n[curr].handle;
    			for( ;; ) {
    				child = curr << 1;
    				if( child < this.size && this.leq( h[n[child+1].handle].key, h[n[child].handle].key )) {
    					++child;
    				}

    				assert$1(child <= this.max);

    				hChild = n[child].handle;
    				if( child > this.size || this.leq( h[hCurr].key, h[hChild].key )) {
    					n[curr].handle = hCurr;
    					h[hCurr].node = curr;
    					break;
    				}
    				n[curr].handle = hChild;
    				h[hChild].node = curr;
    				curr = child;
    			}
    		},

    		floatUp_: function( curr )
    		{
    			var n = this.nodes;
    			var h = this.handles;
    			var hCurr, hParent;
    			var parent;

    			hCurr = n[curr].handle;
    			for( ;; ) {
    				parent = curr >> 1;
    				hParent = n[parent].handle;
    				if( parent == 0 || this.leq( h[hParent].key, h[hCurr].key )) {
    					n[curr].handle = hCurr;
    					h[hCurr].node = curr;
    					break;
    				}
    				n[curr].handle = hParent;
    				h[hParent].node = curr;
    				curr = parent;
    			}
    		},

    		init: function() {
    			/* This method of building a heap is O(n), rather than O(n lg n). */
    			for( var i = this.size; i >= 1; --i ) {
    				this.floatDown_( i );
    			}
    			this.initialized = true;
    		},

    		min: function() {
    			return this.handles[this.nodes[1].handle].key;
    		},

    		isEmpty: function() {
    			this.size === 0;
    		},

    		/* really pqHeapInsert */
    		/* returns INV_HANDLE iff out of memory */
    		//PQhandle pqHeapInsert( TESSalloc* alloc, PriorityQHeap *pq, PQkey keyNew )
    		insert: function(keyNew)
    		{
    			var curr;
    			var free;

    			curr = ++this.size;
    			if( (curr*2) > this.max ) {
    				this.max *= 2;
    				var s;
    				s = this.nodes.length;
    				this.nodes.length = this.max+1;
    				for (var i = s; i < this.nodes.length; i++)
    					this.nodes[i] = new PQnode();

    				s = this.handles.length;
    				this.handles.length = this.max+1;
    				for (var i = s; i < this.handles.length; i++)
    					this.handles[i] = new PQhandleElem();
    			}

    			if( this.freeList === 0 ) {
    				free = curr;
    			} else {
    				free = this.freeList;
    				this.freeList = this.handles[free].node;
    			}

    			this.nodes[curr].handle = free;
    			this.handles[free].node = curr;
    			this.handles[free].key = keyNew;

    			if( this.initialized ) {
    				this.floatUp_( curr );
    			}
    			return free;
    		},

    		//PQkey pqHeapExtractMin( PriorityQHeap *pq )
    		extractMin: function() {
    			var n = this.nodes;
    			var h = this.handles;
    			var hMin = n[1].handle;
    			var min = h[hMin].key;

    			if( this.size > 0 ) {
    				n[1].handle = n[this.size].handle;
    				h[n[1].handle].node = 1;

    				h[hMin].key = null;
    				h[hMin].node = this.freeList;
    				this.freeList = hMin;

    				--this.size;
    				if( this.size > 0 ) {
    					this.floatDown_( 1 );
    				}
    			}
    			return min;
    		},

    		delete: function( hCurr ) {
    			var n = this.nodes;
    			var h = this.handles;
    			var curr;

    			assert$1( hCurr >= 1 && hCurr <= this.max && h[hCurr].key !== null );

    			curr = h[hCurr].node;
    			n[curr].handle = n[this.size].handle;
    			h[n[curr].handle].node = curr;

    			--this.size;
    			if( curr <= this.size ) {
    				if( curr <= 1 || this.leq( h[n[curr>>1].handle].key, h[n[curr].handle].key )) {
    					this.floatDown_( curr );
    				} else {
    					this.floatUp_( curr );
    				}
    			}
    			h[hCurr].key = null;
    			h[hCurr].node = this.freeList;
    			this.freeList = hCurr;
    		}
    	};


    	/* For each pair of adjacent edges crossing the sweep line, there is
    	* an ActiveRegion to represent the region between them.  The active
    	* regions are kept in sorted order in a dynamic dictionary.  As the
    	* sweep line crosses each vertex, we update the affected regions.
    	*/

    	function ActiveRegion() {
    		this.eUp = null;		/* upper edge, directed right to left */
    		this.nodeUp = null;	/* dictionary node corresponding to eUp */
    		this.windingNumber = 0;	/* used to determine which regions are
    								* inside the polygon */
    		this.inside = false;		/* is this region inside the polygon? */
    		this.sentinel = false;	/* marks fake edges at t = +/-infinity */
    		this.dirty = false;		/* marks regions where the upper or lower
    						* edge has changed, but we haven't checked
    						* whether they intersect yet */
    		this.fixUpperEdge = false;	/* marks temporary edges introduced when
    							* we process a "right vertex" (one without
    							* any edges leaving to the right) */
    	}
    	var Sweep = {};

    	Sweep.regionBelow = function(r) {
    		return r.nodeUp.prev.key;
    	};

    	Sweep.regionAbove = function(r) {
    		return r.nodeUp.next.key;
    	};

    	Sweep.debugEvent = function( tess ) {
    		// empty
    	};


    	/*
    	* Invariants for the Edge Dictionary.
    	* - each pair of adjacent edges e2=Succ(e1) satisfies EdgeLeq(e1,e2)
    	*   at any valid location of the sweep event
    	* - if EdgeLeq(e2,e1) as well (at any valid sweep event), then e1 and e2
    	*   share a common endpoint
    	* - for each e, e->Dst has been processed, but not e->Org
    	* - each edge e satisfies VertLeq(e->Dst,event) && VertLeq(event,e->Org)
    	*   where "event" is the current sweep line event.
    	* - no edge e has zero length
    	*
    	* Invariants for the Mesh (the processed portion).
    	* - the portion of the mesh left of the sweep line is a planar graph,
    	*   ie. there is *some* way to embed it in the plane
    	* - no processed edge has zero length
    	* - no two processed vertices have identical coordinates
    	* - each "inside" region is monotone, ie. can be broken into two chains
    	*   of monotonically increasing vertices according to VertLeq(v1,v2)
    	*   - a non-invariant: these chains may intersect (very slightly)
    	*
    	* Invariants for the Sweep.
    	* - if none of the edges incident to the event vertex have an activeRegion
    	*   (ie. none of these edges are in the edge dictionary), then the vertex
    	*   has only right-going edges.
    	* - if an edge is marked "fixUpperEdge" (it is a temporary edge introduced
    	*   by ConnectRightVertex), then it is the only right-going edge from
    	*   its associated vertex.  (This says that these edges exist only
    	*   when it is necessary.)
    	*/

    	/* When we merge two edges into one, we need to compute the combined
    	* winding of the new edge.
    	*/
    	Sweep.addWinding = function(eDst,eSrc) {
    		eDst.winding += eSrc.winding;
    		eDst.Sym.winding += eSrc.Sym.winding;
    	};


    	//static int EdgeLeq( TESStesselator *tess, ActiveRegion *reg1, ActiveRegion *reg2 )
    	Sweep.edgeLeq = function( tess, reg1, reg2 ) {
    		/*
    		* Both edges must be directed from right to left (this is the canonical
    		* direction for the upper edge of each region).
    		*
    		* The strategy is to evaluate a "t" value for each edge at the
    		* current sweep line position, given by tess->event.  The calculations
    		* are designed to be very stable, but of course they are not perfect.
    		*
    		* Special case: if both edge destinations are at the sweep event,
    		* we sort the edges by slope (they would otherwise compare equally).
    		*/
    		var ev = tess.event;
    		var t1, t2;

    		var e1 = reg1.eUp;
    		var e2 = reg2.eUp;

    		if( e1.Dst === ev ) {
    			if( e2.Dst === ev ) {
    				/* Two edges right of the sweep line which meet at the sweep event.
    				* Sort them by slope.
    				*/
    				if( Geom.vertLeq( e1.Org, e2.Org )) {
    					return Geom.edgeSign( e2.Dst, e1.Org, e2.Org ) <= 0;
    				}
    				return Geom.edgeSign( e1.Dst, e2.Org, e1.Org ) >= 0;
    			}
    			return Geom.edgeSign( e2.Dst, ev, e2.Org ) <= 0;
    		}
    		if( e2.Dst === ev ) {
    			return Geom.edgeSign( e1.Dst, ev, e1.Org ) >= 0;
    		}

    		/* General case - compute signed distance *from* e1, e2 to event */
    		var t1 = Geom.edgeEval( e1.Dst, ev, e1.Org );
    		var t2 = Geom.edgeEval( e2.Dst, ev, e2.Org );
    		return (t1 >= t2);
    	};


    	//static void DeleteRegion( TESStesselator *tess, ActiveRegion *reg )
    	Sweep.deleteRegion = function( tess, reg ) {
    		if( reg.fixUpperEdge ) {
    			/* It was created with zero winding number, so it better be
    			* deleted with zero winding number (ie. it better not get merged
    			* with a real edge).
    			*/
    			assert$1( reg.eUp.winding === 0 );
    		}
    		reg.eUp.activeRegion = null;
    		tess.dict.delete( reg.nodeUp );
    	};

    	//static int FixUpperEdge( TESStesselator *tess, ActiveRegion *reg, TESShalfEdge *newEdge )
    	Sweep.fixUpperEdge = function( tess, reg, newEdge ) {
    		/*
    		* Replace an upper edge which needs fixing (see ConnectRightVertex).
    		*/
    		assert$1( reg.fixUpperEdge );
    		tess.mesh.delete( reg.eUp );
    		reg.fixUpperEdge = false;
    		reg.eUp = newEdge;
    		newEdge.activeRegion = reg;
    	};

    	//static ActiveRegion *TopLeftRegion( TESStesselator *tess, ActiveRegion *reg )
    	Sweep.topLeftRegion = function( tess, reg ) {
    		var org = reg.eUp.Org;
    		var e;

    		/* Find the region above the uppermost edge with the same origin */
    		do {
    			reg = Sweep.regionAbove( reg );
    		} while( reg.eUp.Org === org );

    		/* If the edge above was a temporary edge introduced by ConnectRightVertex,
    		* now is the time to fix it.
    		*/
    		if( reg.fixUpperEdge ) {
    			e = tess.mesh.connect( Sweep.regionBelow(reg).eUp.Sym, reg.eUp.Lnext );
    			if (e === null) return null;
    			Sweep.fixUpperEdge( tess, reg, e );
    			reg = Sweep.regionAbove( reg );
    		}
    		return reg;
    	};

    	//static ActiveRegion *TopRightRegion( ActiveRegion *reg )
    	Sweep.topRightRegion = function( reg )
    	{
    		var dst = reg.eUp.Dst;
    		var reg = null;
    		/* Find the region above the uppermost edge with the same destination */
    		do {
    			reg = Sweep.regionAbove( reg );
    		} while( reg.eUp.Dst === dst );
    		return reg;
    	};

    	//static ActiveRegion *AddRegionBelow( TESStesselator *tess, ActiveRegion *regAbove, TESShalfEdge *eNewUp )
    	Sweep.addRegionBelow = function( tess, regAbove, eNewUp ) {
    		/*
    		* Add a new active region to the sweep line, *somewhere* below "regAbove"
    		* (according to where the new edge belongs in the sweep-line dictionary).
    		* The upper edge of the new region will be "eNewUp".
    		* Winding number and "inside" flag are not updated.
    		*/
    		var regNew = new ActiveRegion();
    		regNew.eUp = eNewUp;
    		regNew.nodeUp = tess.dict.insertBefore( regAbove.nodeUp, regNew );
    	//	if (regNew->nodeUp == NULL) longjmp(tess->env,1);
    		regNew.fixUpperEdge = false;
    		regNew.sentinel = false;
    		regNew.dirty = false;

    		eNewUp.activeRegion = regNew;
    		return regNew;
    	};

    	//static int IsWindingInside( TESStesselator *tess, int n )
    	Sweep.isWindingInside = function( tess, n ) {
    		switch( tess.windingRule ) {
    			case Tess2.WINDING_ODD:
    				return (n & 1) != 0;
    			case Tess2.WINDING_NONZERO:
    				return (n != 0);
    			case Tess2.WINDING_POSITIVE:
    				return (n > 0);
    			case Tess2.WINDING_NEGATIVE:
    				return (n < 0);
    			case Tess2.WINDING_ABS_GEQ_TWO:
    				return (n >= 2) || (n <= -2);
    		}
    		assert$1( false );
    		return false;
    	};

    	//static void ComputeWinding( TESStesselator *tess, ActiveRegion *reg )
    	Sweep.computeWinding = function( tess, reg ) {
    		reg.windingNumber = Sweep.regionAbove(reg).windingNumber + reg.eUp.winding;
    		reg.inside = Sweep.isWindingInside( tess, reg.windingNumber );
    	};


    	//static void FinishRegion( TESStesselator *tess, ActiveRegion *reg )
    	Sweep.finishRegion = function( tess, reg ) {
    		/*
    		* Delete a region from the sweep line.  This happens when the upper
    		* and lower chains of a region meet (at a vertex on the sweep line).
    		* The "inside" flag is copied to the appropriate mesh face (we could
    		* not do this before -- since the structure of the mesh is always
    		* changing, this face may not have even existed until now).
    		*/
    		var e = reg.eUp;
    		var f = e.Lface;

    		f.inside = reg.inside;
    		f.anEdge = e;   /* optimization for tessMeshTessellateMonoRegion() */
    		Sweep.deleteRegion( tess, reg );
    	};


    	//static TESShalfEdge *FinishLeftRegions( TESStesselator *tess, ActiveRegion *regFirst, ActiveRegion *regLast )
    	Sweep.finishLeftRegions = function( tess, regFirst, regLast ) {
    		/*
    		* We are given a vertex with one or more left-going edges.  All affected
    		* edges should be in the edge dictionary.  Starting at regFirst->eUp,
    		* we walk down deleting all regions where both edges have the same
    		* origin vOrg.  At the same time we copy the "inside" flag from the
    		* active region to the face, since at this point each face will belong
    		* to at most one region (this was not necessarily true until this point
    		* in the sweep).  The walk stops at the region above regLast; if regLast
    		* is NULL we walk as far as possible.  At the same time we relink the
    		* mesh if necessary, so that the ordering of edges around vOrg is the
    		* same as in the dictionary.
    		*/
    		var e, ePrev;
    		var reg = null;
    		var regPrev = regFirst;
    		var ePrev = regFirst.eUp;
    		while( regPrev !== regLast ) {
    			regPrev.fixUpperEdge = false;	/* placement was OK */
    			reg = Sweep.regionBelow( regPrev );
    			e = reg.eUp;
    			if( e.Org != ePrev.Org ) {
    				if( ! reg.fixUpperEdge ) {
    					/* Remove the last left-going edge.  Even though there are no further
    					* edges in the dictionary with this origin, there may be further
    					* such edges in the mesh (if we are adding left edges to a vertex
    					* that has already been processed).  Thus it is important to call
    					* FinishRegion rather than just DeleteRegion.
    					*/
    					Sweep.finishRegion( tess, regPrev );
    					break;
    				}
    				/* If the edge below was a temporary edge introduced by
    				* ConnectRightVertex, now is the time to fix it.
    				*/
    				e = tess.mesh.connect( ePrev.Lprev, e.Sym );
    	//			if (e == NULL) longjmp(tess->env,1);
    				Sweep.fixUpperEdge( tess, reg, e );
    			}

    			/* Relink edges so that ePrev->Onext == e */
    			if( ePrev.Onext !== e ) {
    				tess.mesh.splice( e.Oprev, e );
    				tess.mesh.splice( ePrev, e );
    			}
    			Sweep.finishRegion( tess, regPrev );	/* may change reg->eUp */
    			ePrev = reg.eUp;
    			regPrev = reg;
    		}
    		return ePrev;
    	};


    	//static void AddRightEdges( TESStesselator *tess, ActiveRegion *regUp, TESShalfEdge *eFirst, TESShalfEdge *eLast, TESShalfEdge *eTopLeft, int cleanUp )
    	Sweep.addRightEdges = function( tess, regUp, eFirst, eLast, eTopLeft, cleanUp ) {
    		/*
    		* Purpose: insert right-going edges into the edge dictionary, and update
    		* winding numbers and mesh connectivity appropriately.  All right-going
    		* edges share a common origin vOrg.  Edges are inserted CCW starting at
    		* eFirst; the last edge inserted is eLast->Oprev.  If vOrg has any
    		* left-going edges already processed, then eTopLeft must be the edge
    		* such that an imaginary upward vertical segment from vOrg would be
    		* contained between eTopLeft->Oprev and eTopLeft; otherwise eTopLeft
    		* should be NULL.
    		*/
    		var reg, regPrev;
    		var e, ePrev;
    		var firstTime = true;

    		/* Insert the new right-going edges in the dictionary */
    		e = eFirst;
    		do {
    			assert$1( Geom.vertLeq( e.Org, e.Dst ));
    			Sweep.addRegionBelow( tess, regUp, e.Sym );
    			e = e.Onext;
    		} while ( e !== eLast );

    		/* Walk *all* right-going edges from e->Org, in the dictionary order,
    		* updating the winding numbers of each region, and re-linking the mesh
    		* edges to match the dictionary ordering (if necessary).
    		*/
    		if( eTopLeft === null ) {
    			eTopLeft = Sweep.regionBelow( regUp ).eUp.Rprev;
    		}
    		regPrev = regUp;
    		ePrev = eTopLeft;
    		for( ;; ) {
    			reg = Sweep.regionBelow( regPrev );
    			e = reg.eUp.Sym;
    			if( e.Org !== ePrev.Org ) break;

    			if( e.Onext !== ePrev ) {
    				/* Unlink e from its current position, and relink below ePrev */
    				tess.mesh.splice( e.Oprev, e );
    				tess.mesh.splice( ePrev.Oprev, e );
    			}
    			/* Compute the winding number and "inside" flag for the new regions */
    			reg.windingNumber = regPrev.windingNumber - e.winding;
    			reg.inside = Sweep.isWindingInside( tess, reg.windingNumber );

    			/* Check for two outgoing edges with same slope -- process these
    			* before any intersection tests (see example in tessComputeInterior).
    			*/
    			regPrev.dirty = true;
    			if( ! firstTime && Sweep.checkForRightSplice( tess, regPrev )) {
    				Sweep.addWinding( e, ePrev );
    				Sweep.deleteRegion( tess, regPrev );
    				tess.mesh.delete( ePrev );
    			}
    			firstTime = false;
    			regPrev = reg;
    			ePrev = e;
    		}
    		regPrev.dirty = true;
    		assert$1( regPrev.windingNumber - e.winding === reg.windingNumber );

    		if( cleanUp ) {
    			/* Check for intersections between newly adjacent edges. */
    			Sweep.walkDirtyRegions( tess, regPrev );
    		}
    	};


    	//static void SpliceMergeVertices( TESStesselator *tess, TESShalfEdge *e1, TESShalfEdge *e2 )
    	Sweep.spliceMergeVertices = function( tess, e1, e2 ) {
    		/*
    		* Two vertices with idential coordinates are combined into one.
    		* e1->Org is kept, while e2->Org is discarded.
    		*/
    		tess.mesh.splice( e1, e2 ); 
    	};

    	//static void VertexWeights( TESSvertex *isect, TESSvertex *org, TESSvertex *dst, TESSreal *weights )
    	Sweep.vertexWeights = function( isect, org, dst ) {
    		/*
    		* Find some weights which describe how the intersection vertex is
    		* a linear combination of "org" and "dest".  Each of the two edges
    		* which generated "isect" is allocated 50% of the weight; each edge
    		* splits the weight between its org and dst according to the
    		* relative distance to "isect".
    		*/
    		var t1 = Geom.vertL1dist( org, isect );
    		var t2 = Geom.vertL1dist( dst, isect );
    		var w0 = 0.5 * t2 / (t1 + t2);
    		var w1 = 0.5 * t1 / (t1 + t2);
    		isect.coords[0] += w0*org.coords[0] + w1*dst.coords[0];
    		isect.coords[1] += w0*org.coords[1] + w1*dst.coords[1];
    		isect.coords[2] += w0*org.coords[2] + w1*dst.coords[2];
    	};


    	//static void GetIntersectData( TESStesselator *tess, TESSvertex *isect, TESSvertex *orgUp, TESSvertex *dstUp, TESSvertex *orgLo, TESSvertex *dstLo )
    	Sweep.getIntersectData = function( tess, isect, orgUp, dstUp, orgLo, dstLo ) {
    		 /*
    		 * We've computed a new intersection point, now we need a "data" pointer
    		 * from the user so that we can refer to this new vertex in the
    		 * rendering callbacks.
    		 */
    		isect.coords[0] = isect.coords[1] = isect.coords[2] = 0;
    		isect.idx = -1;
    		Sweep.vertexWeights( isect, orgUp, dstUp );
    		Sweep.vertexWeights( isect, orgLo, dstLo );
    	};

    	//static int CheckForRightSplice( TESStesselator *tess, ActiveRegion *regUp )
    	Sweep.checkForRightSplice = function( tess, regUp ) {
    		/*
    		* Check the upper and lower edge of "regUp", to make sure that the
    		* eUp->Org is above eLo, or eLo->Org is below eUp (depending on which
    		* origin is leftmost).
    		*
    		* The main purpose is to splice right-going edges with the same
    		* dest vertex and nearly identical slopes (ie. we can't distinguish
    		* the slopes numerically).  However the splicing can also help us
    		* to recover from numerical errors.  For example, suppose at one
    		* point we checked eUp and eLo, and decided that eUp->Org is barely
    		* above eLo.  Then later, we split eLo into two edges (eg. from
    		* a splice operation like this one).  This can change the result of
    		* our test so that now eUp->Org is incident to eLo, or barely below it.
    		* We must correct this condition to maintain the dictionary invariants.
    		*
    		* One possibility is to check these edges for intersection again
    		* (ie. CheckForIntersect).  This is what we do if possible.  However
    		* CheckForIntersect requires that tess->event lies between eUp and eLo,
    		* so that it has something to fall back on when the intersection
    		* calculation gives us an unusable answer.  So, for those cases where
    		* we can't check for intersection, this routine fixes the problem
    		* by just splicing the offending vertex into the other edge.
    		* This is a guaranteed solution, no matter how degenerate things get.
    		* Basically this is a combinatorial solution to a numerical problem.
    		*/
    		var regLo = Sweep.regionBelow(regUp);
    		var eUp = regUp.eUp;
    		var eLo = regLo.eUp;

    		if( Geom.vertLeq( eUp.Org, eLo.Org )) {
    			if( Geom.edgeSign( eLo.Dst, eUp.Org, eLo.Org ) > 0 ) return false;

    			/* eUp->Org appears to be below eLo */
    			if( ! Geom.vertEq( eUp.Org, eLo.Org )) {
    				/* Splice eUp->Org into eLo */
    				tess.mesh.splitEdge( eLo.Sym );
    				tess.mesh.splice( eUp, eLo.Oprev );
    				regUp.dirty = regLo.dirty = true;

    			} else if( eUp.Org !== eLo.Org ) {
    				/* merge the two vertices, discarding eUp->Org */
    				tess.pq.delete( eUp.Org.pqHandle );
    				Sweep.spliceMergeVertices( tess, eLo.Oprev, eUp );
    			}
    		} else {
    			if( Geom.edgeSign( eUp.Dst, eLo.Org, eUp.Org ) < 0 ) return false;

    			/* eLo->Org appears to be above eUp, so splice eLo->Org into eUp */
    			Sweep.regionAbove(regUp).dirty = regUp.dirty = true;
    			tess.mesh.splitEdge( eUp.Sym );
    			tess.mesh.splice( eLo.Oprev, eUp );
    		}
    		return true;
    	};

    	//static int CheckForLeftSplice( TESStesselator *tess, ActiveRegion *regUp )
    	Sweep.checkForLeftSplice = function( tess, regUp ) {
    		/*
    		* Check the upper and lower edge of "regUp", to make sure that the
    		* eUp->Dst is above eLo, or eLo->Dst is below eUp (depending on which
    		* destination is rightmost).
    		*
    		* Theoretically, this should always be true.  However, splitting an edge
    		* into two pieces can change the results of previous tests.  For example,
    		* suppose at one point we checked eUp and eLo, and decided that eUp->Dst
    		* is barely above eLo.  Then later, we split eLo into two edges (eg. from
    		* a splice operation like this one).  This can change the result of
    		* the test so that now eUp->Dst is incident to eLo, or barely below it.
    		* We must correct this condition to maintain the dictionary invariants
    		* (otherwise new edges might get inserted in the wrong place in the
    		* dictionary, and bad stuff will happen).
    		*
    		* We fix the problem by just splicing the offending vertex into the
    		* other edge.
    		*/
    		var regLo = Sweep.regionBelow(regUp);
    		var eUp = regUp.eUp;
    		var eLo = regLo.eUp;
    		var e;

    		assert$1( ! Geom.vertEq( eUp.Dst, eLo.Dst ));

    		if( Geom.vertLeq( eUp.Dst, eLo.Dst )) {
    			if( Geom.edgeSign( eUp.Dst, eLo.Dst, eUp.Org ) < 0 ) return false;

    			/* eLo->Dst is above eUp, so splice eLo->Dst into eUp */
    			Sweep.regionAbove(regUp).dirty = regUp.dirty = true;
    			e = tess.mesh.splitEdge( eUp );
    			tess.mesh.splice( eLo.Sym, e );
    			e.Lface.inside = regUp.inside;
    		} else {
    			if( Geom.edgeSign( eLo.Dst, eUp.Dst, eLo.Org ) > 0 ) return false;

    			/* eUp->Dst is below eLo, so splice eUp->Dst into eLo */
    			regUp.dirty = regLo.dirty = true;
    			e = tess.mesh.splitEdge( eLo );
    			tess.mesh.splice( eUp.Lnext, eLo.Sym );
    			e.Rface.inside = regUp.inside;
    		}
    		return true;
    	};


    	//static int CheckForIntersect( TESStesselator *tess, ActiveRegion *regUp )
    	Sweep.checkForIntersect = function( tess, regUp ) {
    		/*
    		* Check the upper and lower edges of the given region to see if
    		* they intersect.  If so, create the intersection and add it
    		* to the data structures.
    		*
    		* Returns TRUE if adding the new intersection resulted in a recursive
    		* call to AddRightEdges(); in this case all "dirty" regions have been
    		* checked for intersections, and possibly regUp has been deleted.
    		*/
    		var regLo = Sweep.regionBelow(regUp);
    		var eUp = regUp.eUp;
    		var eLo = regLo.eUp;
    		var orgUp = eUp.Org;
    		var orgLo = eLo.Org;
    		var dstUp = eUp.Dst;
    		var dstLo = eLo.Dst;
    		var tMinUp, tMaxLo;
    		var isect = new TESSvertex, orgMin;
    		var e;

    		assert$1( ! Geom.vertEq( dstLo, dstUp ));
    		assert$1( Geom.edgeSign( dstUp, tess.event, orgUp ) <= 0 );
    		assert$1( Geom.edgeSign( dstLo, tess.event, orgLo ) >= 0 );
    		assert$1( orgUp !== tess.event && orgLo !== tess.event );
    		assert$1( ! regUp.fixUpperEdge && ! regLo.fixUpperEdge );

    		if( orgUp === orgLo ) return false;	/* right endpoints are the same */

    		tMinUp = Math.min( orgUp.t, dstUp.t );
    		tMaxLo = Math.max( orgLo.t, dstLo.t );
    		if( tMinUp > tMaxLo ) return false;	/* t ranges do not overlap */

    		if( Geom.vertLeq( orgUp, orgLo )) {
    			if( Geom.edgeSign( dstLo, orgUp, orgLo ) > 0 ) return false;
    		} else {
    			if( Geom.edgeSign( dstUp, orgLo, orgUp ) < 0 ) return false;
    		}

    		/* At this point the edges intersect, at least marginally */
    		Sweep.debugEvent( tess );

    		Geom.intersect( dstUp, orgUp, dstLo, orgLo, isect );
    		/* The following properties are guaranteed: */
    		assert$1( Math.min( orgUp.t, dstUp.t ) <= isect.t );
    		assert$1( isect.t <= Math.max( orgLo.t, dstLo.t ));
    		assert$1( Math.min( dstLo.s, dstUp.s ) <= isect.s );
    		assert$1( isect.s <= Math.max( orgLo.s, orgUp.s ));

    		if( Geom.vertLeq( isect, tess.event )) {
    			/* The intersection point lies slightly to the left of the sweep line,
    			* so move it until it''s slightly to the right of the sweep line.
    			* (If we had perfect numerical precision, this would never happen
    			* in the first place).  The easiest and safest thing to do is
    			* replace the intersection by tess->event.
    			*/
    			isect.s = tess.event.s;
    			isect.t = tess.event.t;
    		}
    		/* Similarly, if the computed intersection lies to the right of the
    		* rightmost origin (which should rarely happen), it can cause
    		* unbelievable inefficiency on sufficiently degenerate inputs.
    		* (If you have the test program, try running test54.d with the
    		* "X zoom" option turned on).
    		*/
    		orgMin = Geom.vertLeq( orgUp, orgLo ) ? orgUp : orgLo;
    		if( Geom.vertLeq( orgMin, isect )) {
    			isect.s = orgMin.s;
    			isect.t = orgMin.t;
    		}

    		if( Geom.vertEq( isect, orgUp ) || Geom.vertEq( isect, orgLo )) {
    			/* Easy case -- intersection at one of the right endpoints */
    			Sweep.checkForRightSplice( tess, regUp );
    			return false;
    		}

    		if(    (! Geom.vertEq( dstUp, tess.event )
    			&& Geom.edgeSign( dstUp, tess.event, isect ) >= 0)
    			|| (! Geom.vertEq( dstLo, tess.event )
    			&& Geom.edgeSign( dstLo, tess.event, isect ) <= 0 ))
    		{
    			/* Very unusual -- the new upper or lower edge would pass on the
    			* wrong side of the sweep event, or through it.  This can happen
    			* due to very small numerical errors in the intersection calculation.
    			*/
    			if( dstLo === tess.event ) {
    				/* Splice dstLo into eUp, and process the new region(s) */
    				tess.mesh.splitEdge( eUp.Sym );
    				tess.mesh.splice( eLo.Sym, eUp );
    				regUp = Sweep.topLeftRegion( tess, regUp );
    	//			if (regUp == NULL) longjmp(tess->env,1);
    				eUp = Sweep.regionBelow(regUp).eUp;
    				Sweep.finishLeftRegions( tess, Sweep.regionBelow(regUp), regLo );
    				Sweep.addRightEdges( tess, regUp, eUp.Oprev, eUp, eUp, true );
    				return TRUE;
    			}
    			if( dstUp === tess.event ) {
    				/* Splice dstUp into eLo, and process the new region(s) */
    				tess.mesh.splitEdge( eLo.Sym );
    				tess.mesh.splice( eUp.Lnext, eLo.Oprev ); 
    				regLo = regUp;
    				regUp = Sweep.topRightRegion( regUp );
    				e = Sweep.regionBelow(regUp).eUp.Rprev;
    				regLo.eUp = eLo.Oprev;
    				eLo = Sweep.finishLeftRegions( tess, regLo, null );
    				Sweep.addRightEdges( tess, regUp, eLo.Onext, eUp.Rprev, e, true );
    				return true;
    			}
    			/* Special case: called from ConnectRightVertex.  If either
    			* edge passes on the wrong side of tess->event, split it
    			* (and wait for ConnectRightVertex to splice it appropriately).
    			*/
    			if( Geom.edgeSign( dstUp, tess.event, isect ) >= 0 ) {
    				Sweep.regionAbove(regUp).dirty = regUp.dirty = true;
    				tess.mesh.splitEdge( eUp.Sym );
    				eUp.Org.s = tess.event.s;
    				eUp.Org.t = tess.event.t;
    			}
    			if( Geom.edgeSign( dstLo, tess.event, isect ) <= 0 ) {
    				regUp.dirty = regLo.dirty = true;
    				tess.mesh.splitEdge( eLo.Sym );
    				eLo.Org.s = tess.event.s;
    				eLo.Org.t = tess.event.t;
    			}
    			/* leave the rest for ConnectRightVertex */
    			return false;
    		}

    		/* General case -- split both edges, splice into new vertex.
    		* When we do the splice operation, the order of the arguments is
    		* arbitrary as far as correctness goes.  However, when the operation
    		* creates a new face, the work done is proportional to the size of
    		* the new face.  We expect the faces in the processed part of
    		* the mesh (ie. eUp->Lface) to be smaller than the faces in the
    		* unprocessed original contours (which will be eLo->Oprev->Lface).
    		*/
    		tess.mesh.splitEdge( eUp.Sym );
    		tess.mesh.splitEdge( eLo.Sym );
    		tess.mesh.splice( eLo.Oprev, eUp );
    		eUp.Org.s = isect.s;
    		eUp.Org.t = isect.t;
    		eUp.Org.pqHandle = tess.pq.insert( eUp.Org );
    		Sweep.getIntersectData( tess, eUp.Org, orgUp, dstUp, orgLo, dstLo );
    		Sweep.regionAbove(regUp).dirty = regUp.dirty = regLo.dirty = true;
    		return false;
    	};

    	//static void WalkDirtyRegions( TESStesselator *tess, ActiveRegion *regUp )
    	Sweep.walkDirtyRegions = function( tess, regUp ) {
    		/*
    		* When the upper or lower edge of any region changes, the region is
    		* marked "dirty".  This routine walks through all the dirty regions
    		* and makes sure that the dictionary invariants are satisfied
    		* (see the comments at the beginning of this file).  Of course
    		* new dirty regions can be created as we make changes to restore
    		* the invariants.
    		*/
    		var regLo = Sweep.regionBelow(regUp);
    		var eUp, eLo;

    		for( ;; ) {
    			/* Find the lowest dirty region (we walk from the bottom up). */
    			while( regLo.dirty ) {
    				regUp = regLo;
    				regLo = Sweep.regionBelow(regLo);
    			}
    			if( ! regUp.dirty ) {
    				regLo = regUp;
    				regUp = Sweep.regionAbove( regUp );
    				if( regUp == null || ! regUp.dirty ) {
    					/* We've walked all the dirty regions */
    					return;
    				}
    			}
    			regUp.dirty = false;
    			eUp = regUp.eUp;
    			eLo = regLo.eUp;

    			if( eUp.Dst !== eLo.Dst ) {
    				/* Check that the edge ordering is obeyed at the Dst vertices. */
    				if( Sweep.checkForLeftSplice( tess, regUp )) {

    					/* If the upper or lower edge was marked fixUpperEdge, then
    					* we no longer need it (since these edges are needed only for
    					* vertices which otherwise have no right-going edges).
    					*/
    					if( regLo.fixUpperEdge ) {
    						Sweep.deleteRegion( tess, regLo );
    						tess.mesh.delete( eLo );
    						regLo = Sweep.regionBelow( regUp );
    						eLo = regLo.eUp;
    					} else if( regUp.fixUpperEdge ) {
    						Sweep.deleteRegion( tess, regUp );
    						tess.mesh.delete( eUp );
    						regUp = Sweep.regionAbove( regLo );
    						eUp = regUp.eUp;
    					}
    				}
    			}
    			if( eUp.Org !== eLo.Org ) {
    				if(    eUp.Dst !== eLo.Dst
    					&& ! regUp.fixUpperEdge && ! regLo.fixUpperEdge
    					&& (eUp.Dst === tess.event || eLo.Dst === tess.event) )
    				{
    					/* When all else fails in CheckForIntersect(), it uses tess->event
    					* as the intersection location.  To make this possible, it requires
    					* that tess->event lie between the upper and lower edges, and also
    					* that neither of these is marked fixUpperEdge (since in the worst
    					* case it might splice one of these edges into tess->event, and
    					* violate the invariant that fixable edges are the only right-going
    					* edge from their associated vertex).
    					*/
    					if( Sweep.checkForIntersect( tess, regUp )) {
    						/* WalkDirtyRegions() was called recursively; we're done */
    						return;
    					}
    				} else {
    					/* Even though we can't use CheckForIntersect(), the Org vertices
    					* may violate the dictionary edge ordering.  Check and correct this.
    					*/
    					Sweep.checkForRightSplice( tess, regUp );
    				}
    			}
    			if( eUp.Org === eLo.Org && eUp.Dst === eLo.Dst ) {
    				/* A degenerate loop consisting of only two edges -- delete it. */
    				Sweep.addWinding( eLo, eUp );
    				Sweep.deleteRegion( tess, regUp );
    				tess.mesh.delete( eUp );
    				regUp = Sweep.regionAbove( regLo );
    			}
    		}
    	};


    	//static void ConnectRightVertex( TESStesselator *tess, ActiveRegion *regUp, TESShalfEdge *eBottomLeft )
    	Sweep.connectRightVertex = function( tess, regUp, eBottomLeft ) {
    		/*
    		* Purpose: connect a "right" vertex vEvent (one where all edges go left)
    		* to the unprocessed portion of the mesh.  Since there are no right-going
    		* edges, two regions (one above vEvent and one below) are being merged
    		* into one.  "regUp" is the upper of these two regions.
    		*
    		* There are two reasons for doing this (adding a right-going edge):
    		*  - if the two regions being merged are "inside", we must add an edge
    		*    to keep them separated (the combined region would not be monotone).
    		*  - in any case, we must leave some record of vEvent in the dictionary,
    		*    so that we can merge vEvent with features that we have not seen yet.
    		*    For example, maybe there is a vertical edge which passes just to
    		*    the right of vEvent; we would like to splice vEvent into this edge.
    		*
    		* However, we don't want to connect vEvent to just any vertex.  We don''t
    		* want the new edge to cross any other edges; otherwise we will create
    		* intersection vertices even when the input data had no self-intersections.
    		* (This is a bad thing; if the user's input data has no intersections,
    		* we don't want to generate any false intersections ourselves.)
    		*
    		* Our eventual goal is to connect vEvent to the leftmost unprocessed
    		* vertex of the combined region (the union of regUp and regLo).
    		* But because of unseen vertices with all right-going edges, and also
    		* new vertices which may be created by edge intersections, we don''t
    		* know where that leftmost unprocessed vertex is.  In the meantime, we
    		* connect vEvent to the closest vertex of either chain, and mark the region
    		* as "fixUpperEdge".  This flag says to delete and reconnect this edge
    		* to the next processed vertex on the boundary of the combined region.
    		* Quite possibly the vertex we connected to will turn out to be the
    		* closest one, in which case we won''t need to make any changes.
    		*/
    		var eNew;
    		var eTopLeft = eBottomLeft.Onext;
    		var regLo = Sweep.regionBelow(regUp);
    		var eUp = regUp.eUp;
    		var eLo = regLo.eUp;
    		var degenerate = false;

    		if( eUp.Dst !== eLo.Dst ) {
    			Sweep.checkForIntersect( tess, regUp );
    		}

    		/* Possible new degeneracies: upper or lower edge of regUp may pass
    		* through vEvent, or may coincide with new intersection vertex
    		*/
    		if( Geom.vertEq( eUp.Org, tess.event )) {
    			tess.mesh.splice( eTopLeft.Oprev, eUp );
    			regUp = Sweep.topLeftRegion( tess, regUp );
    			eTopLeft = Sweep.regionBelow( regUp ).eUp;
    			Sweep.finishLeftRegions( tess, Sweep.regionBelow(regUp), regLo );
    			degenerate = true;
    		}
    		if( Geom.vertEq( eLo.Org, tess.event )) {
    			tess.mesh.splice( eBottomLeft, eLo.Oprev );
    			eBottomLeft = Sweep.finishLeftRegions( tess, regLo, null );
    			degenerate = true;
    		}
    		if( degenerate ) {
    			Sweep.addRightEdges( tess, regUp, eBottomLeft.Onext, eTopLeft, eTopLeft, true );
    			return;
    		}

    		/* Non-degenerate situation -- need to add a temporary, fixable edge.
    		* Connect to the closer of eLo->Org, eUp->Org.
    		*/
    		if( Geom.vertLeq( eLo.Org, eUp.Org )) {
    			eNew = eLo.Oprev;
    		} else {
    			eNew = eUp;
    		}
    		eNew = tess.mesh.connect( eBottomLeft.Lprev, eNew );

    		/* Prevent cleanup, otherwise eNew might disappear before we've even
    		* had a chance to mark it as a temporary edge.
    		*/
    		Sweep.addRightEdges( tess, regUp, eNew, eNew.Onext, eNew.Onext, false );
    		eNew.Sym.activeRegion.fixUpperEdge = true;
    		Sweep.walkDirtyRegions( tess, regUp );
    	};

    	/* Because vertices at exactly the same location are merged together
    	* before we process the sweep event, some degenerate cases can't occur.
    	* However if someone eventually makes the modifications required to
    	* merge features which are close together, the cases below marked
    	* TOLERANCE_NONZERO will be useful.  They were debugged before the
    	* code to merge identical vertices in the main loop was added.
    	*/
    	//#define TOLERANCE_NONZERO	FALSE

    	//static void ConnectLeftDegenerate( TESStesselator *tess, ActiveRegion *regUp, TESSvertex *vEvent )
    	Sweep.connectLeftDegenerate = function( tess, regUp, vEvent ) {
    		/*
    		* The event vertex lies exacty on an already-processed edge or vertex.
    		* Adding the new vertex involves splicing it into the already-processed
    		* part of the mesh.
    		*/
    		var e, eTopLeft, eTopRight, eLast;
    		var reg;

    		e = regUp.eUp;
    		if( Geom.vertEq( e.Org, vEvent )) {
    			/* e->Org is an unprocessed vertex - just combine them, and wait
    			* for e->Org to be pulled from the queue
    			*/
    			assert$1( false /*TOLERANCE_NONZERO*/ );
    			Sweep.spliceMergeVertices( tess, e, vEvent.anEdge );
    			return;
    		}

    		if( ! Geom.vertEq( e.Dst, vEvent )) {
    			/* General case -- splice vEvent into edge e which passes through it */
    			tess.mesh.splitEdge( e.Sym );
    			if( regUp.fixUpperEdge ) {
    				/* This edge was fixable -- delete unused portion of original edge */
    				tess.mesh.delete( e.Onext );
    				regUp.fixUpperEdge = false;
    			}
    			tess.mesh.splice( vEvent.anEdge, e );
    			Sweep.sweepEvent( tess, vEvent );	/* recurse */
    			return;
    		}

    		/* vEvent coincides with e->Dst, which has already been processed.
    		* Splice in the additional right-going edges.
    		*/
    		assert$1( false /*TOLERANCE_NONZERO*/ );
    		regUp = Sweep.topRightRegion( regUp );
    		reg = Sweep.regionBelow( regUp );
    		eTopRight = reg.eUp.Sym;
    		eTopLeft = eLast = eTopRight.Onext;
    		if( reg.fixUpperEdge ) {
    			/* Here e->Dst has only a single fixable edge going right.
    			* We can delete it since now we have some real right-going edges.
    			*/
    			assert$1( eTopLeft !== eTopRight );   /* there are some left edges too */
    			Sweep.deleteRegion( tess, reg );
    			tess.mesh.delete( eTopRight );
    			eTopRight = eTopLeft.Oprev;
    		}
    		tess.mesh.splice( vEvent.anEdge, eTopRight );
    		if( ! Geom.edgeGoesLeft( eTopLeft )) {
    			/* e->Dst had no left-going edges -- indicate this to AddRightEdges() */
    			eTopLeft = null;
    		}
    		Sweep.addRightEdges( tess, regUp, eTopRight.Onext, eLast, eTopLeft, true );
    	};


    	//static void ConnectLeftVertex( TESStesselator *tess, TESSvertex *vEvent )
    	Sweep.connectLeftVertex = function( tess, vEvent ) {
    		/*
    		* Purpose: connect a "left" vertex (one where both edges go right)
    		* to the processed portion of the mesh.  Let R be the active region
    		* containing vEvent, and let U and L be the upper and lower edge
    		* chains of R.  There are two possibilities:
    		*
    		* - the normal case: split R into two regions, by connecting vEvent to
    		*   the rightmost vertex of U or L lying to the left of the sweep line
    		*
    		* - the degenerate case: if vEvent is close enough to U or L, we
    		*   merge vEvent into that edge chain.  The subcases are:
    		*	- merging with the rightmost vertex of U or L
    		*	- merging with the active edge of U or L
    		*	- merging with an already-processed portion of U or L
    		*/
    		var regUp, regLo, reg;
    		var eUp, eLo, eNew;
    		var tmp = new ActiveRegion();

    		/* assert( vEvent->anEdge->Onext->Onext == vEvent->anEdge ); */

    		/* Get a pointer to the active region containing vEvent */
    		tmp.eUp = vEvent.anEdge.Sym;
    		/* __GL_DICTLISTKEY */ /* tessDictListSearch */
    		regUp = tess.dict.search( tmp ).key;
    		regLo = Sweep.regionBelow( regUp );
    		if( !regLo ) {
    			// This may happen if the input polygon is coplanar.
    			return;
    		}
    		eUp = regUp.eUp;
    		eLo = regLo.eUp;

    		/* Try merging with U or L first */
    		if( Geom.edgeSign( eUp.Dst, vEvent, eUp.Org ) === 0.0 ) {
    			Sweep.connectLeftDegenerate( tess, regUp, vEvent );
    			return;
    		}

    		/* Connect vEvent to rightmost processed vertex of either chain.
    		* e->Dst is the vertex that we will connect to vEvent.
    		*/
    		reg = Geom.vertLeq( eLo.Dst, eUp.Dst ) ? regUp : regLo;

    		if( regUp.inside || reg.fixUpperEdge) {
    			if( reg === regUp ) {
    				eNew = tess.mesh.connect( vEvent.anEdge.Sym, eUp.Lnext );
    			} else {
    				var tempHalfEdge = tess.mesh.connect( eLo.Dnext, vEvent.anEdge);
    				eNew = tempHalfEdge.Sym;
    			}
    			if( reg.fixUpperEdge ) {
    				Sweep.fixUpperEdge( tess, reg, eNew );
    			} else {
    				Sweep.computeWinding( tess, Sweep.addRegionBelow( tess, regUp, eNew ));
    			}
    			Sweep.sweepEvent( tess, vEvent );
    		} else {
    			/* The new vertex is in a region which does not belong to the polygon.
    			* We don''t need to connect this vertex to the rest of the mesh.
    			*/
    			Sweep.addRightEdges( tess, regUp, vEvent.anEdge, vEvent.anEdge, null, true );
    		}
    	};


    	//static void SweepEvent( TESStesselator *tess, TESSvertex *vEvent )
    	Sweep.sweepEvent = function( tess, vEvent ) {
    		/*
    		* Does everything necessary when the sweep line crosses a vertex.
    		* Updates the mesh and the edge dictionary.
    		*/

    		tess.event = vEvent;		/* for access in EdgeLeq() */
    		Sweep.debugEvent( tess );

    		/* Check if this vertex is the right endpoint of an edge that is
    		* already in the dictionary.  In this case we don't need to waste
    		* time searching for the location to insert new edges.
    		*/
    		var e = vEvent.anEdge;
    		while( e.activeRegion === null ) {
    			e = e.Onext;
    			if( e == vEvent.anEdge ) {
    				/* All edges go right -- not incident to any processed edges */
    				Sweep.connectLeftVertex( tess, vEvent );
    				return;
    			}
    		}

    		/* Processing consists of two phases: first we "finish" all the
    		* active regions where both the upper and lower edges terminate
    		* at vEvent (ie. vEvent is closing off these regions).
    		* We mark these faces "inside" or "outside" the polygon according
    		* to their winding number, and delete the edges from the dictionary.
    		* This takes care of all the left-going edges from vEvent.
    		*/
    		var regUp = Sweep.topLeftRegion( tess, e.activeRegion );
    		assert$1( regUp !== null );
    	//	if (regUp == NULL) longjmp(tess->env,1);
    		var reg = Sweep.regionBelow( regUp );
    		var eTopLeft = reg.eUp;
    		var eBottomLeft = Sweep.finishLeftRegions( tess, reg, null );

    		/* Next we process all the right-going edges from vEvent.  This
    		* involves adding the edges to the dictionary, and creating the
    		* associated "active regions" which record information about the
    		* regions between adjacent dictionary edges.
    		*/
    		if( eBottomLeft.Onext === eTopLeft ) {
    			/* No right-going edges -- add a temporary "fixable" edge */
    			Sweep.connectRightVertex( tess, regUp, eBottomLeft );
    		} else {
    			Sweep.addRightEdges( tess, regUp, eBottomLeft.Onext, eTopLeft, eTopLeft, true );
    		}
    	};


    	/* Make the sentinel coordinates big enough that they will never be
    	* merged with real input features.
    	*/

    	//static void AddSentinel( TESStesselator *tess, TESSreal smin, TESSreal smax, TESSreal t )
    	Sweep.addSentinel = function( tess, smin, smax, t ) {
    		/*
    		* We add two sentinel edges above and below all other edges,
    		* to avoid special cases at the top and bottom.
    		*/
    		var reg = new ActiveRegion();
    		var e = tess.mesh.makeEdge();
    	//	if (e == NULL) longjmp(tess->env,1);

    		e.Org.s = smax;
    		e.Org.t = t;
    		e.Dst.s = smin;
    		e.Dst.t = t;
    		tess.event = e.Dst;		/* initialize it */

    		reg.eUp = e;
    		reg.windingNumber = 0;
    		reg.inside = false;
    		reg.fixUpperEdge = false;
    		reg.sentinel = true;
    		reg.dirty = false;
    		reg.nodeUp = tess.dict.insert( reg );
    	//	if (reg->nodeUp == NULL) longjmp(tess->env,1);
    	};


    	//static void InitEdgeDict( TESStesselator *tess )
    	Sweep.initEdgeDict = function( tess ) {
    		/*
    		* We maintain an ordering of edge intersections with the sweep line.
    		* This order is maintained in a dynamic dictionary.
    		*/
    		tess.dict = new Dict( tess, Sweep.edgeLeq );
    	//	if (tess->dict == NULL) longjmp(tess->env,1);

    		var w = (tess.bmax[0] - tess.bmin[0]);
    		var h = (tess.bmax[1] - tess.bmin[1]);

    		var smin = tess.bmin[0] - w;
    		var smax = tess.bmax[0] + w;
    		var tmin = tess.bmin[1] - h;
    		var tmax = tess.bmax[1] + h;

    		Sweep.addSentinel( tess, smin, smax, tmin );
    		Sweep.addSentinel( tess, smin, smax, tmax );
    	};


    	Sweep.doneEdgeDict = function( tess )
    	{
    		var reg;
    		var fixedEdges = 0;

    		while( (reg = tess.dict.min().key) !== null ) {
    			/*
    			* At the end of all processing, the dictionary should contain
    			* only the two sentinel edges, plus at most one "fixable" edge
    			* created by ConnectRightVertex().
    			*/
    			if( ! reg.sentinel ) {
    				assert$1( reg.fixUpperEdge );
    				assert$1( ++fixedEdges == 1 );
    			}
    			assert$1( reg.windingNumber == 0 );
    			Sweep.deleteRegion( tess, reg );
    			/*    tessMeshDelete( reg->eUp );*/
    		}
    	//	dictDeleteDict( &tess->alloc, tess->dict );
    	};


    	Sweep.removeDegenerateEdges = function( tess ) {
    		/*
    		* Remove zero-length edges, and contours with fewer than 3 vertices.
    		*/
    		var e, eNext, eLnext;
    		var eHead = tess.mesh.eHead;

    		/*LINTED*/
    		for( e = eHead.next; e !== eHead; e = eNext ) {
    			eNext = e.next;
    			eLnext = e.Lnext;

    			if( Geom.vertEq( e.Org, e.Dst ) && e.Lnext.Lnext !== e ) {
    				/* Zero-length edge, contour has at least 3 edges */
    				Sweep.spliceMergeVertices( tess, eLnext, e );	/* deletes e->Org */
    				tess.mesh.delete( e ); /* e is a self-loop */
    				e = eLnext;
    				eLnext = e.Lnext;
    			}
    			if( eLnext.Lnext === e ) {
    				/* Degenerate contour (one or two edges) */
    				if( eLnext !== e ) {
    					if( eLnext === eNext || eLnext === eNext.Sym ) { eNext = eNext.next; }
    					tess.mesh.delete( eLnext );
    				}
    				if( e === eNext || e === eNext.Sym ) { eNext = eNext.next; }
    				tess.mesh.delete( e );
    			}
    		}
    	};

    	Sweep.initPriorityQ = function( tess ) {
    		/*
    		* Insert all vertices into the priority queue which determines the
    		* order in which vertices cross the sweep line.
    		*/
    		var pq;
    		var v, vHead;
    		var vertexCount = 0;
    		
    		vHead = tess.mesh.vHead;
    		for( v = vHead.next; v !== vHead; v = v.next ) {
    			vertexCount++;
    		}
    		/* Make sure there is enough space for sentinels. */
    		vertexCount += 8; //MAX( 8, tess->alloc.extraVertices );
    		
    		pq = tess.pq = new PriorityQ( vertexCount, Geom.vertLeq );
    	//	if (pq == NULL) return 0;

    		vHead = tess.mesh.vHead;
    		for( v = vHead.next; v !== vHead; v = v.next ) {
    			v.pqHandle = pq.insert( v );
    	//		if (v.pqHandle == INV_HANDLE)
    	//			break;
    		}

    		if (v !== vHead) {
    			return false;
    		}

    		pq.init();

    		return true;
    	};


    	Sweep.donePriorityQ = function( tess ) {
    		tess.pq = null;
    	};


    	Sweep.removeDegenerateFaces = function( tess, mesh ) {
    		/*
    		* Delete any degenerate faces with only two edges.  WalkDirtyRegions()
    		* will catch almost all of these, but it won't catch degenerate faces
    		* produced by splice operations on already-processed edges.
    		* The two places this can happen are in FinishLeftRegions(), when
    		* we splice in a "temporary" edge produced by ConnectRightVertex(),
    		* and in CheckForLeftSplice(), where we splice already-processed
    		* edges to ensure that our dictionary invariants are not violated
    		* by numerical errors.
    		*
    		* In both these cases it is *very* dangerous to delete the offending
    		* edge at the time, since one of the routines further up the stack
    		* will sometimes be keeping a pointer to that edge.
    		*/
    		var f, fNext;
    		var e;

    		/*LINTED*/
    		for( f = mesh.fHead.next; f !== mesh.fHead; f = fNext ) {
    			fNext = f.next;
    			e = f.anEdge;
    			assert$1( e.Lnext !== e );

    			if( e.Lnext.Lnext === e ) {
    				/* A face with only two edges */
    				Sweep.addWinding( e.Onext, e );
    				tess.mesh.delete( e );
    			}
    		}
    		return true;
    	};

    	Sweep.computeInterior = function( tess ) {
    		/*
    		* tessComputeInterior( tess ) computes the planar arrangement specified
    		* by the given contours, and further subdivides this arrangement
    		* into regions.  Each region is marked "inside" if it belongs
    		* to the polygon, according to the rule given by tess->windingRule.
    		* Each interior region is guaranteed be monotone.
    		*/
    		var v, vNext;

    		/* Each vertex defines an event for our sweep line.  Start by inserting
    		* all the vertices in a priority queue.  Events are processed in
    		* lexicographic order, ie.
    		*
    		*	e1 < e2  iff  e1.x < e2.x || (e1.x == e2.x && e1.y < e2.y)
    		*/
    		Sweep.removeDegenerateEdges( tess );
    		if ( !Sweep.initPriorityQ( tess ) ) return false; /* if error */
    		Sweep.initEdgeDict( tess );

    		while( (v = tess.pq.extractMin()) !== null ) {
    			for( ;; ) {
    				vNext = tess.pq.min();
    				if( vNext === null || ! Geom.vertEq( vNext, v )) break;

    				/* Merge together all vertices at exactly the same location.
    				* This is more efficient than processing them one at a time,
    				* simplifies the code (see ConnectLeftDegenerate), and is also
    				* important for correct handling of certain degenerate cases.
    				* For example, suppose there are two identical edges A and B
    				* that belong to different contours (so without this code they would
    				* be processed by separate sweep events).  Suppose another edge C
    				* crosses A and B from above.  When A is processed, we split it
    				* at its intersection point with C.  However this also splits C,
    				* so when we insert B we may compute a slightly different
    				* intersection point.  This might leave two edges with a small
    				* gap between them.  This kind of error is especially obvious
    				* when using boundary extraction (TESS_BOUNDARY_ONLY).
    				*/
    				vNext = tess.pq.extractMin();
    				Sweep.spliceMergeVertices( tess, v.anEdge, vNext.anEdge );
    			}
    			Sweep.sweepEvent( tess, v );
    		}

    		/* Set tess->event for debugging purposes */
    		tess.event = tess.dict.min().key.eUp.Org;
    		Sweep.debugEvent( tess );
    		Sweep.doneEdgeDict( tess );
    		Sweep.donePriorityQ( tess );

    		if ( !Sweep.removeDegenerateFaces( tess, tess.mesh ) ) return false;
    		tess.mesh.check();

    		return true;
    	};


    	function Tesselator() {

    		/*** state needed for collecting the input data ***/
    		this.mesh = null;		/* stores the input contours, and eventually
    							the tessellation itself */

    		/*** state needed for projecting onto the sweep plane ***/

    		this.normal = [0.0, 0.0, 0.0];	/* user-specified normal (if provided) */
    		this.sUnit = [0.0, 0.0, 0.0];	/* unit vector in s-direction (debugging) */
    		this.tUnit = [0.0, 0.0, 0.0];	/* unit vector in t-direction (debugging) */

    		this.bmin = [0.0, 0.0];
    		this.bmax = [0.0, 0.0];

    		/*** state needed for the line sweep ***/
    		this.windingRule = Tess2.WINDING_ODD;	/* rule for determining polygon interior */

    		this.dict = null;		/* edge dictionary for sweep line */
    		this.pq = null;		/* priority queue of vertex events */
    		this.event = null;		/* current sweep event being processed */

    		this.vertexIndexCounter = 0;
    		
    		this.vertices = [];
    		this.vertexIndices = [];
    		this.vertexCount = 0;
    		this.elements = [];
    		this.elementCount = 0;
    	}
    	Tesselator.prototype = {

    		dot_: function(u, v) {
    			return (u[0]*v[0] + u[1]*v[1] + u[2]*v[2]);
    		},

    		normalize_: function( v ) {
    			var len = v[0]*v[0] + v[1]*v[1] + v[2]*v[2];
    			assert$1( len > 0.0 );
    			len = Math.sqrt( len );
    			v[0] /= len;
    			v[1] /= len;
    			v[2] /= len;
    		},

    		longAxis_: function( v ) {
    			var i = 0;
    			if( Math.abs(v[1]) > Math.abs(v[0]) ) { i = 1; }
    			if( Math.abs(v[2]) > Math.abs(v[i]) ) { i = 2; }
    			return i;
    		},

    		computeNormal_: function( norm )
    		{
    			var v, v1, v2;
    			var c, tLen2, maxLen2;
    			var maxVal = [0,0,0], minVal = [0,0,0], d1 = [0,0,0], d2 = [0,0,0], tNorm = [0,0,0];
    			var maxVert = [null,null,null], minVert = [null,null,null];
    			var vHead = this.mesh.vHead;
    			var i;

    			v = vHead.next;
    			for( i = 0; i < 3; ++i ) {
    				c = v.coords[i];
    				minVal[i] = c;
    				minVert[i] = v;
    				maxVal[i] = c;
    				maxVert[i] = v;
    			}

    			for( v = vHead.next; v !== vHead; v = v.next ) {
    				for( i = 0; i < 3; ++i ) {
    					c = v.coords[i];
    					if( c < minVal[i] ) { minVal[i] = c; minVert[i] = v; }
    					if( c > maxVal[i] ) { maxVal[i] = c; maxVert[i] = v; }
    				}
    			}

    			/* Find two vertices separated by at least 1/sqrt(3) of the maximum
    			* distance between any two vertices
    			*/
    			i = 0;
    			if( maxVal[1] - minVal[1] > maxVal[0] - minVal[0] ) { i = 1; }
    			if( maxVal[2] - minVal[2] > maxVal[i] - minVal[i] ) { i = 2; }
    			if( minVal[i] >= maxVal[i] ) {
    				/* All vertices are the same -- normal doesn't matter */
    				norm[0] = 0; norm[1] = 0; norm[2] = 1;
    				return;
    			}

    			/* Look for a third vertex which forms the triangle with maximum area
    			* (Length of normal == twice the triangle area)
    			*/
    			maxLen2 = 0;
    			v1 = minVert[i];
    			v2 = maxVert[i];
    			d1[0] = v1.coords[0] - v2.coords[0];
    			d1[1] = v1.coords[1] - v2.coords[1];
    			d1[2] = v1.coords[2] - v2.coords[2];
    			for( v = vHead.next; v !== vHead; v = v.next ) {
    				d2[0] = v.coords[0] - v2.coords[0];
    				d2[1] = v.coords[1] - v2.coords[1];
    				d2[2] = v.coords[2] - v2.coords[2];
    				tNorm[0] = d1[1]*d2[2] - d1[2]*d2[1];
    				tNorm[1] = d1[2]*d2[0] - d1[0]*d2[2];
    				tNorm[2] = d1[0]*d2[1] - d1[1]*d2[0];
    				tLen2 = tNorm[0]*tNorm[0] + tNorm[1]*tNorm[1] + tNorm[2]*tNorm[2];
    				if( tLen2 > maxLen2 ) {
    					maxLen2 = tLen2;
    					norm[0] = tNorm[0];
    					norm[1] = tNorm[1];
    					norm[2] = tNorm[2];
    				}
    			}

    			if( maxLen2 <= 0 ) {
    				/* All points lie on a single line -- any decent normal will do */
    				norm[0] = norm[1] = norm[2] = 0;
    				norm[this.longAxis_(d1)] = 1;
    			}
    		},

    		checkOrientation_: function() {
    			var area;
    			var f, fHead = this.mesh.fHead;
    			var v, vHead = this.mesh.vHead;
    			var e;

    			/* When we compute the normal automatically, we choose the orientation
    			* so that the the sum of the signed areas of all contours is non-negative.
    			*/
    			area = 0;
    			for( f = fHead.next; f !== fHead; f = f.next ) {
    				e = f.anEdge;
    				if( e.winding <= 0 ) continue;
    				do {
    					area += (e.Org.s - e.Dst.s) * (e.Org.t + e.Dst.t);
    					e = e.Lnext;
    				} while( e !== f.anEdge );
    			}
    			if( area < 0 ) {
    				/* Reverse the orientation by flipping all the t-coordinates */
    				for( v = vHead.next; v !== vHead; v = v.next ) {
    					v.t = - v.t;
    				}
    				this.tUnit[0] = - this.tUnit[0];
    				this.tUnit[1] = - this.tUnit[1];
    				this.tUnit[2] = - this.tUnit[2];
    			}
    		},

    	/*	#ifdef FOR_TRITE_TEST_PROGRAM
    		#include <stdlib.h>
    		extern int RandomSweep;
    		#define S_UNIT_X	(RandomSweep ? (2*drand48()-1) : 1.0)
    		#define S_UNIT_Y	(RandomSweep ? (2*drand48()-1) : 0.0)
    		#else
    		#if defined(SLANTED_SWEEP) */
    		/* The "feature merging" is not intended to be complete.  There are
    		* special cases where edges are nearly parallel to the sweep line
    		* which are not implemented.  The algorithm should still behave
    		* robustly (ie. produce a reasonable tesselation) in the presence
    		* of such edges, however it may miss features which could have been
    		* merged.  We could minimize this effect by choosing the sweep line
    		* direction to be something unusual (ie. not parallel to one of the
    		* coordinate axes).
    		*/
    	/*	#define S_UNIT_X	(TESSreal)0.50941539564955385	// Pre-normalized
    		#define S_UNIT_Y	(TESSreal)0.86052074622010633
    		#else
    		#define S_UNIT_X	(TESSreal)1.0
    		#define S_UNIT_Y	(TESSreal)0.0
    		#endif
    		#endif*/

    		/* Determine the polygon normal and project vertices onto the plane
    		* of the polygon.
    		*/
    		projectPolygon_: function() {
    			var v, vHead = this.mesh.vHead;
    			var norm = [0,0,0];
    			var sUnit, tUnit;
    			var i, first, computedNormal = false;

    			norm[0] = this.normal[0];
    			norm[1] = this.normal[1];
    			norm[2] = this.normal[2];
    			if( norm[0] === 0.0 && norm[1] === 0.0 && norm[2] === 0.0 ) {
    				this.computeNormal_( norm );
    				computedNormal = true;
    			}
    			sUnit = this.sUnit;
    			tUnit = this.tUnit;
    			i = this.longAxis_( norm );

    	/*	#if defined(FOR_TRITE_TEST_PROGRAM) || defined(TRUE_PROJECT)
    			// Choose the initial sUnit vector to be approximately perpendicular
    			// to the normal.
    			
    			Normalize( norm );

    			sUnit[i] = 0;
    			sUnit[(i+1)%3] = S_UNIT_X;
    			sUnit[(i+2)%3] = S_UNIT_Y;

    			// Now make it exactly perpendicular 
    			w = Dot( sUnit, norm );
    			sUnit[0] -= w * norm[0];
    			sUnit[1] -= w * norm[1];
    			sUnit[2] -= w * norm[2];
    			Normalize( sUnit );

    			// Choose tUnit so that (sUnit,tUnit,norm) form a right-handed frame 
    			tUnit[0] = norm[1]*sUnit[2] - norm[2]*sUnit[1];
    			tUnit[1] = norm[2]*sUnit[0] - norm[0]*sUnit[2];
    			tUnit[2] = norm[0]*sUnit[1] - norm[1]*sUnit[0];
    			Normalize( tUnit );
    		#else*/
    			/* Project perpendicular to a coordinate axis -- better numerically */
    			sUnit[i] = 0;
    			sUnit[(i+1)%3] = 1.0;
    			sUnit[(i+2)%3] = 0.0;

    			tUnit[i] = 0;
    			tUnit[(i+1)%3] = 0.0;
    			tUnit[(i+2)%3] = (norm[i] > 0) ? 1.0 : -1.0;
    	//	#endif

    			/* Project the vertices onto the sweep plane */
    			for( v = vHead.next; v !== vHead; v = v.next ) {
    				v.s = this.dot_( v.coords, sUnit );
    				v.t = this.dot_( v.coords, tUnit );
    			}
    			if( computedNormal ) {
    				this.checkOrientation_();
    			}

    			/* Compute ST bounds. */
    			first = true;
    			for( v = vHead.next; v !== vHead; v = v.next ) {
    				if (first) {
    					this.bmin[0] = this.bmax[0] = v.s;
    					this.bmin[1] = this.bmax[1] = v.t;
    					first = false;
    				} else {
    					if (v.s < this.bmin[0]) this.bmin[0] = v.s;
    					if (v.s > this.bmax[0]) this.bmax[0] = v.s;
    					if (v.t < this.bmin[1]) this.bmin[1] = v.t;
    					if (v.t > this.bmax[1]) this.bmax[1] = v.t;
    				}
    			}
    		},

    		addWinding_: function(eDst,eSrc) {
    			eDst.winding += eSrc.winding;
    			eDst.Sym.winding += eSrc.Sym.winding;
    		},
    		
    		/* tessMeshTessellateMonoRegion( face ) tessellates a monotone region
    		* (what else would it do??)  The region must consist of a single
    		* loop of half-edges (see mesh.h) oriented CCW.  "Monotone" in this
    		* case means that any vertical line intersects the interior of the
    		* region in a single interval.  
    		*
    		* Tessellation consists of adding interior edges (actually pairs of
    		* half-edges), to split the region into non-overlapping triangles.
    		*
    		* The basic idea is explained in Preparata and Shamos (which I don''t
    		* have handy right now), although their implementation is more
    		* complicated than this one.  The are two edge chains, an upper chain
    		* and a lower chain.  We process all vertices from both chains in order,
    		* from right to left.
    		*
    		* The algorithm ensures that the following invariant holds after each
    		* vertex is processed: the untessellated region consists of two
    		* chains, where one chain (say the upper) is a single edge, and
    		* the other chain is concave.  The left vertex of the single edge
    		* is always to the left of all vertices in the concave chain.
    		*
    		* Each step consists of adding the rightmost unprocessed vertex to one
    		* of the two chains, and forming a fan of triangles from the rightmost
    		* of two chain endpoints.  Determining whether we can add each triangle
    		* to the fan is a simple orientation test.  By making the fan as large
    		* as possible, we restore the invariant (check it yourself).
    		*/
    	//	int tessMeshTessellateMonoRegion( TESSmesh *mesh, TESSface *face )
    		tessellateMonoRegion_: function( mesh, face ) {
    			var up, lo;

    			/* All edges are oriented CCW around the boundary of the region.
    			* First, find the half-edge whose origin vertex is rightmost.
    			* Since the sweep goes from left to right, face->anEdge should
    			* be close to the edge we want.
    			*/
    			up = face.anEdge;
    			assert$1( up.Lnext !== up && up.Lnext.Lnext !== up );

    			for( ; Geom.vertLeq( up.Dst, up.Org ); up = up.Lprev )
    				;
    			for( ; Geom.vertLeq( up.Org, up.Dst ); up = up.Lnext )
    				;
    			lo = up.Lprev;

    			while( up.Lnext !== lo ) {
    				if( Geom.vertLeq( up.Dst, lo.Org )) {
    					/* up->Dst is on the left.  It is safe to form triangles from lo->Org.
    					* The EdgeGoesLeft test guarantees progress even when some triangles
    					* are CW, given that the upper and lower chains are truly monotone.
    					*/
    					while( lo.Lnext !== up && (Geom.edgeGoesLeft( lo.Lnext )
    						|| Geom.edgeSign( lo.Org, lo.Dst, lo.Lnext.Dst ) <= 0.0 )) {
    							var tempHalfEdge = mesh.connect( lo.Lnext, lo );
    							//if (tempHalfEdge == NULL) return 0;
    							lo = tempHalfEdge.Sym;
    					}
    					lo = lo.Lprev;
    				} else {
    					/* lo->Org is on the left.  We can make CCW triangles from up->Dst. */
    					while( lo.Lnext != up && (Geom.edgeGoesRight( up.Lprev )
    						|| Geom.edgeSign( up.Dst, up.Org, up.Lprev.Org ) >= 0.0 )) {
    							var tempHalfEdge = mesh.connect( up, up.Lprev );
    							//if (tempHalfEdge == NULL) return 0;
    							up = tempHalfEdge.Sym;
    					}
    					up = up.Lnext;
    				}
    			}

    			/* Now lo->Org == up->Dst == the leftmost vertex.  The remaining region
    			* can be tessellated in a fan from this leftmost vertex.
    			*/
    			assert$1( lo.Lnext !== up );
    			while( lo.Lnext.Lnext !== up ) {
    				var tempHalfEdge = mesh.connect( lo.Lnext, lo );
    				//if (tempHalfEdge == NULL) return 0;
    				lo = tempHalfEdge.Sym;
    			}

    			return true;
    		},


    		/* tessMeshTessellateInterior( mesh ) tessellates each region of
    		* the mesh which is marked "inside" the polygon.  Each such region
    		* must be monotone.
    		*/
    		//int tessMeshTessellateInterior( TESSmesh *mesh )
    		tessellateInterior_: function( mesh ) {
    			var f, next;

    			/*LINTED*/
    			for( f = mesh.fHead.next; f !== mesh.fHead; f = next ) {
    				/* Make sure we don''t try to tessellate the new triangles. */
    				next = f.next;
    				if( f.inside ) {
    					if ( !this.tessellateMonoRegion_( mesh, f ) ) return false;
    				}
    			}

    			return true;
    		},


    		/* tessMeshDiscardExterior( mesh ) zaps (ie. sets to NULL) all faces
    		* which are not marked "inside" the polygon.  Since further mesh operations
    		* on NULL faces are not allowed, the main purpose is to clean up the
    		* mesh so that exterior loops are not represented in the data structure.
    		*/
    		//void tessMeshDiscardExterior( TESSmesh *mesh )
    		discardExterior_: function( mesh ) {
    			var f, next;

    			/*LINTED*/
    			for( f = mesh.fHead.next; f !== mesh.fHead; f = next ) {
    				/* Since f will be destroyed, save its next pointer. */
    				next = f.next;
    				if( ! f.inside ) {
    					mesh.zapFace( f );
    				}
    			}
    		},

    		/* tessMeshSetWindingNumber( mesh, value, keepOnlyBoundary ) resets the
    		* winding numbers on all edges so that regions marked "inside" the
    		* polygon have a winding number of "value", and regions outside
    		* have a winding number of 0.
    		*
    		* If keepOnlyBoundary is TRUE, it also deletes all edges which do not
    		* separate an interior region from an exterior one.
    		*/
    	//	int tessMeshSetWindingNumber( TESSmesh *mesh, int value, int keepOnlyBoundary )
    		setWindingNumber_: function( mesh, value, keepOnlyBoundary ) {
    			var e, eNext;

    			for( e = mesh.eHead.next; e !== mesh.eHead; e = eNext ) {
    				eNext = e.next;
    				if( e.Rface.inside !== e.Lface.inside ) {

    					/* This is a boundary edge (one side is interior, one is exterior). */
    					e.winding = (e.Lface.inside) ? value : -value;
    				} else {

    					/* Both regions are interior, or both are exterior. */
    					if( ! keepOnlyBoundary ) {
    						e.winding = 0;
    					} else {
    						mesh.delete( e );
    					}
    				}
    			}
    		},

    		getNeighbourFace_: function(edge)
    		{
    			if (!edge.Rface)
    				return -1;
    			if (!edge.Rface.inside)
    				return -1;
    			return edge.Rface.n;
    		},

    		outputPolymesh_: function( mesh, elementType, polySize, vertexSize ) {
    			var v;
    			var f;
    			var edge;
    			var maxFaceCount = 0;
    			var maxVertexCount = 0;
    			var faceVerts, i;

    			// Assume that the input data is triangles now.
    			// Try to merge as many polygons as possible
    			if (polySize > 3)
    			{
    				mesh.mergeConvexFaces( polySize );
    			}

    			// Mark unused
    			for ( v = mesh.vHead.next; v !== mesh.vHead; v = v.next )
    				v.n = -1;

    			// Create unique IDs for all vertices and faces.
    			for ( f = mesh.fHead.next; f != mesh.fHead; f = f.next )
    			{
    				f.n = -1;
    				if( !f.inside ) continue;

    				edge = f.anEdge;
    				faceVerts = 0;
    				do
    				{
    					v = edge.Org;
    					if ( v.n === -1 )
    					{
    						v.n = maxVertexCount;
    						maxVertexCount++;
    					}
    					faceVerts++;
    					edge = edge.Lnext;
    				}
    				while (edge !== f.anEdge);
    				
    				assert$1( faceVerts <= polySize );

    				f.n = maxFaceCount;
    				++maxFaceCount;
    			}

    			this.elementCount = maxFaceCount;
    			if (elementType == Tess2.CONNECTED_POLYGONS)
    				maxFaceCount *= 2;
    	/*		tess.elements = (TESSindex*)tess->alloc.memalloc( tess->alloc.userData,
    															  sizeof(TESSindex) * maxFaceCount * polySize );
    			if (!tess->elements)
    			{
    				tess->outOfMemory = 1;
    				return;
    			}*/
    			this.elements = [];
    			this.elements.length = maxFaceCount * polySize;
    			
    			this.vertexCount = maxVertexCount;
    	/*		tess->vertices = (TESSreal*)tess->alloc.memalloc( tess->alloc.userData,
    															 sizeof(TESSreal) * tess->vertexCount * vertexSize );
    			if (!tess->vertices)
    			{
    				tess->outOfMemory = 1;
    				return;
    			}*/
    			this.vertices = [];
    			this.vertices.length = maxVertexCount * vertexSize;

    	/*		tess->vertexIndices = (TESSindex*)tess->alloc.memalloc( tess->alloc.userData,
    																    sizeof(TESSindex) * tess->vertexCount );
    			if (!tess->vertexIndices)
    			{
    				tess->outOfMemory = 1;
    				return;
    			}*/
    			this.vertexIndices = [];
    			this.vertexIndices.length = maxVertexCount;

    			
    			// Output vertices.
    			for ( v = mesh.vHead.next; v !== mesh.vHead; v = v.next )
    			{
    				if ( v.n != -1 )
    				{
    					// Store coordinate
    					var idx = v.n * vertexSize;
    					this.vertices[idx+0] = v.coords[0];
    					this.vertices[idx+1] = v.coords[1];
    					if ( vertexSize > 2 )
    						this.vertices[idx+2] = v.coords[2];
    					// Store vertex index.
    					this.vertexIndices[v.n] = v.idx;
    				}
    			}

    			// Output indices.
    			var nel = 0;
    			for ( f = mesh.fHead.next; f !== mesh.fHead; f = f.next )
    			{
    				if ( !f.inside ) continue;
    				
    				// Store polygon
    				edge = f.anEdge;
    				faceVerts = 0;
    				do
    				{
    					v = edge.Org;
    					this.elements[nel++] = v.n;
    					faceVerts++;
    					edge = edge.Lnext;
    				}
    				while (edge !== f.anEdge);
    				// Fill unused.
    				for (i = faceVerts; i < polySize; ++i)
    					this.elements[nel++] = -1;

    				// Store polygon connectivity
    				if ( elementType == Tess2.CONNECTED_POLYGONS )
    				{
    					edge = f.anEdge;
    					do
    					{
    						this.elements[nel++] = this.getNeighbourFace_( edge );
    						edge = edge.Lnext;
    					}
    					while (edge !== f.anEdge);
    					// Fill unused.
    					for (i = faceVerts; i < polySize; ++i)
    						this.elements[nel++] = -1;
    				}
    			}
    		},

    	//	void OutputContours( TESStesselator *tess, TESSmesh *mesh, int vertexSize )
    		outputContours_: function( mesh, vertexSize ) {
    			var f;
    			var edge;
    			var start;
    			var startVert = 0;
    			var vertCount = 0;

    			this.vertexCount = 0;
    			this.elementCount = 0;

    			for ( f = mesh.fHead.next; f !== mesh.fHead; f = f.next )
    			{
    				if ( !f.inside ) continue;

    				start = edge = f.anEdge;
    				do
    				{
    					this.vertexCount++;
    					edge = edge.Lnext;
    				}
    				while ( edge !== start );

    				this.elementCount++;
    			}

    	/*		tess->elements = (TESSindex*)tess->alloc.memalloc( tess->alloc.userData,
    															  sizeof(TESSindex) * tess->elementCount * 2 );
    			if (!tess->elements)
    			{
    				tess->outOfMemory = 1;
    				return;
    			}*/
    			this.elements = [];
    			this.elements.length = this.elementCount * 2;
    			
    	/*		tess->vertices = (TESSreal*)tess->alloc.memalloc( tess->alloc.userData,
    															  sizeof(TESSreal) * tess->vertexCount * vertexSize );
    			if (!tess->vertices)
    			{
    				tess->outOfMemory = 1;
    				return;
    			}*/
    			this.vertices = [];
    			this.vertices.length = this.vertexCount * vertexSize;

    	/*		tess->vertexIndices = (TESSindex*)tess->alloc.memalloc( tess->alloc.userData,
    																    sizeof(TESSindex) * tess->vertexCount );
    			if (!tess->vertexIndices)
    			{
    				tess->outOfMemory = 1;
    				return;
    			}*/
    			this.vertexIndices = [];
    			this.vertexIndices.length = this.vertexCount;

    			var nv = 0;
    			var nvi = 0;
    			var nel = 0;
    			startVert = 0;

    			for ( f = mesh.fHead.next; f !== mesh.fHead; f = f.next )
    			{
    				if ( !f.inside ) continue;

    				vertCount = 0;
    				start = edge = f.anEdge;
    				do
    				{
    					this.vertices[nv++] = edge.Org.coords[0];
    					this.vertices[nv++] = edge.Org.coords[1];
    					if ( vertexSize > 2 )
    						this.vertices[nv++] = edge.Org.coords[2];
    					this.vertexIndices[nvi++] = edge.Org.idx;
    					vertCount++;
    					edge = edge.Lnext;
    				}
    				while ( edge !== start );

    				this.elements[nel++] = startVert;
    				this.elements[nel++] = vertCount;

    				startVert += vertCount;
    			}
    		},

    		addContour: function( size, vertices )
    		{
    			var e;
    			var i;

    			if ( this.mesh === null )
    			  	this.mesh = new TESSmesh();
    	/*	 	if ( tess->mesh == NULL ) {
    				tess->outOfMemory = 1;
    				return;
    			}*/

    			if ( size < 2 )
    				size = 2;
    			if ( size > 3 )
    				size = 3;

    			e = null;

    			for( i = 0; i < vertices.length; i += size )
    			{
    				if( e == null ) {
    					/* Make a self-loop (one vertex, one edge). */
    					e = this.mesh.makeEdge();
    	/*				if ( e == NULL ) {
    						tess->outOfMemory = 1;
    						return;
    					}*/
    					this.mesh.splice( e, e.Sym );
    				} else {
    					/* Create a new vertex and edge which immediately follow e
    					* in the ordering around the left face.
    					*/
    					this.mesh.splitEdge( e );
    					e = e.Lnext;
    				}

    				/* The new vertex is now e->Org. */
    				e.Org.coords[0] = vertices[i+0];
    				e.Org.coords[1] = vertices[i+1];
    				if ( size > 2 )
    					e.Org.coords[2] = vertices[i+2];
    				else
    					e.Org.coords[2] = 0.0;
    				/* Store the insertion number so that the vertex can be later recognized. */
    				e.Org.idx = this.vertexIndexCounter++;

    				/* The winding of an edge says how the winding number changes as we
    				* cross from the edge''s right face to its left face.  We add the
    				* vertices in such an order that a CCW contour will add +1 to
    				* the winding number of the region inside the contour.
    				*/
    				e.winding = 1;
    				e.Sym.winding = -1;
    			}
    		},

    	//	int tessTesselate( TESStesselator *tess, int windingRule, int elementType, int polySize, int vertexSize, const TESSreal* normal )
    		tesselate: function( windingRule, elementType, polySize, vertexSize, normal ) {
    			this.vertices = [];
    			this.elements = [];
    			this.vertexIndices = [];

    			this.vertexIndexCounter = 0;
    			
    			if (normal)
    			{
    				this.normal[0] = normal[0];
    				this.normal[1] = normal[1];
    				this.normal[2] = normal[2];
    			}

    			this.windingRule = windingRule;

    			if (vertexSize < 2)
    				vertexSize = 2;
    			if (vertexSize > 3)
    				vertexSize = 3;

    	/*		if (setjmp(tess->env) != 0) { 
    				// come back here if out of memory
    				return 0;
    			}*/

    			if (!this.mesh)
    			{
    				return false;
    			}

    			/* Determine the polygon normal and project vertices onto the plane
    			* of the polygon.
    			*/
    			this.projectPolygon_();

    			/* tessComputeInterior( tess ) computes the planar arrangement specified
    			* by the given contours, and further subdivides this arrangement
    			* into regions.  Each region is marked "inside" if it belongs
    			* to the polygon, according to the rule given by tess->windingRule.
    			* Each interior region is guaranteed be monotone.
    			*/
    			Sweep.computeInterior( this );

    			var mesh = this.mesh;

    			/* If the user wants only the boundary contours, we throw away all edges
    			* except those which separate the interior from the exterior.
    			* Otherwise we tessellate all the regions marked "inside".
    			*/
    			if (elementType == Tess2.BOUNDARY_CONTOURS) {
    				this.setWindingNumber_( mesh, 1, true );
    			} else {
    				this.tessellateInterior_( mesh ); 
    			}
    	//		if (rc == 0) longjmp(tess->env,1);  /* could've used a label */

    			mesh.check();

    			if (elementType == Tess2.BOUNDARY_CONTOURS) {
    				this.outputContours_( mesh, vertexSize );     /* output contours */
    			}
    			else
    			{
    				this.outputPolymesh_( mesh, elementType, polySize, vertexSize );     /* output polygons */
    			}

    //			tess.mesh = null;

    			return true;
    		}
    	};

    var tess2$1 = tess2;

    /**
     * The Graphics class contains a set of methods that you can use to create a
     * vector shape. Display objects that support drawing include Sprite and Shape
     * objects. Each of these classes includes a <code>graphics</code> property
     * that is a Graphics object. The following are among those helper functions
     * provided for ease of use: <code>drawRect()</code>,
     * <code>drawRoundRect()</code>, <code>drawCircle()</code>, and
     * <code>drawEllipse()</code>.
     *
     * <p>You cannot create a Graphics object directly from ActionScript code. If
     * you call <code>new Graphics()</code>, an exception is thrown.</p>
     *
     * <p>The Graphics class is final; it cannot be subclassed.</p>
     */
    var GraphicsFactoryFills = /** @class */ (function () {
        function GraphicsFactoryFills() {
        }
        GraphicsFactoryFills.draw_pathes = function (targetGraphics) {
            //return;
            var len = targetGraphics.queued_fill_pathes.length;
            var cp = 0;
            for (cp = 0; cp < len; cp++) {
                var newBuffer = GraphicsFactoryFills.pathToAttributesBuffer(targetGraphics.queued_fill_pathes[cp]);
                if (newBuffer && newBuffer.length > 0) {
                    var elements = new TriangleElements(newBuffer);
                    elements.setPositions(new Float2Attributes(newBuffer));
                    //elements.setCustomAttributes("curves", new Float3Attributes(attributesBuffer));
                    //elements.setUVs(new Float2Attributes(attributesBuffer));
                    var sampler;
                    var material;
                    if (targetGraphics.queued_fill_pathes[cp].style.data_type == GraphicsFillStyle.data_type) {
                        var obj = Graphics.get_material_for_color(targetGraphics.queued_fill_pathes[cp].style.color, targetGraphics.queued_fill_pathes[cp].style.alpha);
                        material = obj.material;
                        var shape = targetGraphics.addShape(Shape.getShape(elements, material));
                        if (obj.colorPos) {
                            shape.style = new Style();
                            sampler = new ImageSampler();
                            material.animateUVs = true;
                            shape.style.addSamplerAt(sampler, material.getTextureAt(0));
                            shape.style.uvMatrix = new Matrix(0, 0, 0, 0, obj.colorPos.x, obj.colorPos.y);
                        }
                    }
                    else if (targetGraphics.queued_fill_pathes[cp].style.data_type == GradientFillStyle.data_type) {
                        var gradientStyle = targetGraphics.queued_fill_pathes[cp].style;
                        var obj = Graphics.get_material_for_gradient(gradientStyle);
                        material = obj.material;
                        var shape = targetGraphics.addShape(Shape.getShape(elements, material));
                        shape.style = new Style();
                        sampler = new ImageSampler();
                        shape.style.addSamplerAt(sampler, material.getTextureAt(0));
                        material.animateUVs = true;
                        shape.style.uvMatrix = gradientStyle.getUVMatrix();
                        //sampler.repeat=true;
                        // todo: always use mappingmode = Radial ?
                        if (gradientStyle.type == GradientType.LINEAR)
                            material.getTextureAt(0).mappingMode = MappingMode.LINEAR;
                        else if (gradientStyle.type == GradientType.RADIAL) {
                            sampler.imageRect = gradientStyle.uvRectangle;
                            material.imageRect = true;
                            material.getTextureAt(0).mappingMode = MappingMode.RADIAL;
                        }
                    }
                    else if (targetGraphics.queued_fill_pathes[cp].style.data_type == BitmapFillStyle.data_type) {
                        var bitmapStyle = targetGraphics.queued_fill_pathes[cp].style;
                        var material = bitmapStyle.material; //new ITexture(ImageUtils.getDefaultImage2D());//bitmapStyle.texture;
                        var shape = targetGraphics.addShape(Shape.getShape(elements, material));
                        shape.style = new Style();
                        sampler = new ImageSampler();
                        sampler.mipmap = true;
                        sampler.smooth = true;
                        sampler.repeat = bitmapStyle.repeat;
                        shape.style.addSamplerAt(sampler, material.getTextureAt(0));
                        material.animateUVs = true;
                        shape.style.uvMatrix = bitmapStyle.getUVMatrix();
                    }
                }
            }
            targetGraphics.queued_fill_pathes.length = 0;
        };
        GraphicsFactoryFills.pathToAttributesBuffer = function (graphicsPath, closePath) {
            if (closePath === void 0) { closePath = true; }
            graphicsPath.prepare();
            var contour_data = graphicsPath._positions;
            var contour;
            var i = 0;
            var k = 0;
            var final_vert_list = [];
            var final_vert_cnt = 0;
            var finalContours = [];
            var res;
            var numElems = 0;
            var p1x = 0;
            var p1y = 0;
            var p2x = 0;
            var p2y = 0;
            var p3x = 0;
            var p3y = 0;
            var attributesView;
            var attributesBuffer;
            for (k = 0; k < contour_data.length; k++) {
                // all contours should already be prepared by GraphicsPath.prepare()
                // we only want to make sure that each contour contains at least 3 pairs of x/y positions
                // otherwise there is no way they can form a shape				
                contour = contour_data[k];
                if (contour[0] == contour[contour.length - 2] && contour[1] == contour[contour.length - 1]) {
                    contour.pop();
                    contour.pop();
                }
                if (contour.length > 5) {
                    finalContours[finalContours.length] = contour;
                }
            }
            //console.log("execute Tess2 = ", finalContours);
            try {
                res = tess2$1.tesselate({
                    contours: finalContours,
                    windingRule: tess2$1.WINDING_ODD,
                    elementType: tess2$1.POLYGONS,
                    polySize: 3,
                    vertexSize: 2
                });
                //console.timeEnd("time Tess2.tesselate");
                numElems = res.elements.length / 3;
                p1x = 0;
                p1y = 0;
                p2x = 0;
                p2y = 0;
                p3x = 0;
                p3y = 0;
                for (i = 0; i < numElems; ++i) {
                    p1x = res.vertices[res.elements[i * 3] * 2];
                    p1y = res.vertices[res.elements[i * 3] * 2 + 1];
                    p2x = res.vertices[res.elements[i * 3 + 1] * 2];
                    p2y = res.vertices[res.elements[i * 3 + 1] * 2 + 1];
                    p3x = res.vertices[res.elements[i * 3 + 2] * 2];
                    p3y = res.vertices[res.elements[i * 3 + 2] * 2 + 1];
                    if (GraphicsFactoryHelper.isClockWiseXY(p1x, p1y, p2x, p2y, p3x, p3y)) {
                        final_vert_list[final_vert_cnt++] = p3x;
                        final_vert_list[final_vert_cnt++] = p3y;
                        final_vert_list[final_vert_cnt++] = p2x;
                        final_vert_list[final_vert_cnt++] = p2y;
                        final_vert_list[final_vert_cnt++] = p1x;
                        final_vert_list[final_vert_cnt++] = p1y;
                    }
                    else {
                        final_vert_list[final_vert_cnt++] = p1x;
                        final_vert_list[final_vert_cnt++] = p1y;
                        final_vert_list[final_vert_cnt++] = p2x;
                        final_vert_list[final_vert_cnt++] = p2y;
                        final_vert_list[final_vert_cnt++] = p3x;
                        final_vert_list[final_vert_cnt++] = p3y;
                    }
                }
            }
            catch (e) {
                console.log("error when trying to tesselate", finalContours);
            }
            //}
            final_vert_list = final_vert_list.concat(graphicsPath.verts);
            if (final_vert_list.length > 0) {
                attributesView = new AttributesView(Float32Array, 2);
                attributesView.set(final_vert_list);
                attributesBuffer = attributesView.attributesBuffer.cloneBufferView();
                attributesView.dispose();
                return attributesBuffer;
            }
            return null;
        };
        return GraphicsFactoryFills;
    }());

    /**
     * The InterpolationMethod class provides values for the
     * <code>interpolationMethod</code> parameter in the
     * <code>Graphics.beginGradientFill()</code> and
     * <code>Graphics.lineGradientStyle()</code> methods. This parameter
     * determines the RGB space to use when rendering the gradient.
     */

    /**
     * The PixelSnapping class is an enumeration of constant values for setting
     * the pixel snapping options by using the <code>pixelSnapping</code> property
     * of a Bitmap object.
     */

    /**
     * The SpreadMethod class provides values for the <code>spreadMethod</code>
     * parameter in the <code>beginGradientFill()</code> and
     * <code>lineGradientStyle()</code> methods of the Graphics class.
     *
     * <p>The following example shows the same gradient fill using various spread
     * methods:</p>
     */

    /**
     * Defines codes for culling algorithms that determine which triangles not to
     * render when drawing triangle paths.
     *
     * <p> The terms <code>POSITIVE</code> and <code>NEGATIVE</code> refer to the
     * sign of a triangle's normal along the z-axis. The normal is a 3D vector
     * that is perpendicular to the surface of the triangle. </p>
     *
     * <p> A triangle whose vertices 0, 1, and 2 are arranged in a clockwise order
     * has a positive normal value. That is, its normal points in a positive
     * z-axis direction, away from the current view point. When the
     * <code>TriangleCulling.POSITIVE</code> algorithm is used, triangles with
     * positive normals are not rendered. Another term for this is backface
     * culling. </p>
     *
     * <p> A triangle whose vertices are arranged in a counter-clockwise order has
     * a negative normal value. That is, its normal points in a negative z-axis
     * direction, toward the current view point. When the
     * <code>TriangleCulling.NEGATIVE</code> algorithm is used, triangles with
     * negative normals will not be rendered. </p>
     */

    var ElementsType = /** @class */ (function () {
        function ElementsType() {
        }
        /**
         *
         */
        ElementsType.TRIANGLE = "triangle";
        /**
         *
         */
        ElementsType.LINE = "line";
        return ElementsType;
    }());

    var TextureAtlas = /** @class */ (function () {
        function TextureAtlas() {
            this.availableRows = 256;
            this.gradient_row = -1;
            this.color_row = 255;
            this.color_position = 256;
            this.availableGradients = 256;
            this.availableColors = 0;
            this.bitmap = new BitmapImage2D(256, 256, false, 0xff0000);
            this.availableRows = 256;
            this.availableColors = 0;
        }
        TextureAtlas.clearAllMaterials = function () {
            for (var key in TextureAtlas._allColors) {
                TextureAtlas._allColors[key].material = null;
            }
            for (var key in TextureAtlas._allGradients) {
                TextureAtlas._allGradients[key].material = null;
            }
        };
        TextureAtlas.getTextureForColor = function (color, alpha) {
            var colorString = color.toString() + "#" + alpha.toString();
            if (TextureAtlas._allColors.hasOwnProperty(colorString)) {
                return TextureAtlas._allColors[colorString];
            }
            // find textureAtlas that has empty space:
            var t_len = TextureAtlas._allTextureAtlas.length;
            var t = 0;
            var textureAtlas;
            for (t = 0; t < t_len; t++) {
                if (TextureAtlas._allTextureAtlas[t].fit_color()) {
                    textureAtlas = TextureAtlas._allTextureAtlas[t];
                    break;
                }
            }
            if (!textureAtlas) {
                textureAtlas = new TextureAtlas();
                TextureAtlas._allTextureAtlas.push(textureAtlas);
            }
            var newColorObj = {};
            newColorObj.colorPos = textureAtlas.draw_color(color, alpha);
            newColorObj.bitmap = textureAtlas.bitmap;
            TextureAtlas._allColors[colorString] = newColorObj;
            return newColorObj;
        };
        TextureAtlas.getTextureForGradient = function (gradient) {
            var gradientStr = gradient.toString();
            if (TextureAtlas._allGradients.hasOwnProperty(gradientStr)) {
                gradient.uvRectangle = TextureAtlas._allGradients[gradientStr].uvRectangle;
                return TextureAtlas._allGradients[gradientStr];
            }
            var t_len = TextureAtlas._allTextureAtlas.length;
            var t = 0;
            var textureAtlas;
            for (t = 0; t < t_len; t++) {
                if (TextureAtlas._allTextureAtlas[t].fit_gradient()) {
                    textureAtlas = TextureAtlas._allTextureAtlas[t];
                    break;
                }
            }
            if (!textureAtlas) {
                textureAtlas = new TextureAtlas();
                TextureAtlas._allTextureAtlas.push(textureAtlas);
            }
            var newColorObj = {};
            textureAtlas.draw_gradient(gradient);
            newColorObj.uvRectangle = new Rectangle();
            newColorObj.uvRectangle.copyFrom(gradient.uvRectangle);
            newColorObj.bitmap = textureAtlas.bitmap;
            TextureAtlas._allGradients[gradientStr] = newColorObj;
            return newColorObj;
        };
        TextureAtlas.prototype.fit_gradient = function () {
            return (this.availableRows > 0);
        };
        TextureAtlas.prototype.fit_color = function () {
            if (this.availableColors > 0)
                return true;
            return (this.availableRows > 0);
        };
        TextureAtlas.prototype.draw_gradient = function (gradient) {
            if (this.availableRows < 0) {
                console.log("error in TextureAtlasManager.draw_color");
                return;
            }
            this.gradient_row++;
            this.availableRows--;
            var px;
            for (px = 0; px < 256; px++) {
                this.bitmap.setPixelFromArray(px, this.gradient_row, gradient.getColorAtPosition(px));
            }
            this.bitmap.invalidate();
            gradient.uvRectangle.x = 1 / 512;
            gradient.uvRectangle.y = 1 / 512 + (this.gradient_row / 256); //+1/512;
            gradient.uvRectangle.width = 1 - 1 / 512;
            gradient.uvRectangle.height = gradient.uvRectangle.y;
            return this.availableRows;
        };
        TextureAtlas.prototype.draw_color = function (color, alpha) {
            if (alpha === void 0) { alpha = 1; }
            this.color_position--;
            if (this.color_position < 0) {
                if (this.availableRows > 0) {
                    this.color_row--;
                    this.availableRows--;
                    this.color_position = 255;
                }
                else {
                    console.log("error in TextureAtlasManager.draw_color");
                }
            }
            var argb = ColorUtils.float32ColorToARGB(color);
            argb[0] = alpha;
            this.bitmap.setPixelFromArray(this.color_position, this.color_row, argb);
            this.bitmap.invalidate();
            return new Point(1 / 512 + this.color_position / 256, 1 / 512 + this.color_row / 256);
        };
        TextureAtlas._allTextureAtlas = [];
        TextureAtlas._allGradients = {};
        TextureAtlas._allColors = {};
        return TextureAtlas;
    }());

    /**
     * ...
     */
    var ParticleGraphicsTransform = /** @class */ (function () {
        function ParticleGraphicsTransform() {
        }
        Object.defineProperty(ParticleGraphicsTransform.prototype, "vertexTransform", {
            get: function () {
                return this._defaultVertexTransform;
            },
            set: function (value) {
                this._defaultVertexTransform = value;
                this._defaultInvVertexTransform = value.clone();
                this._defaultInvVertexTransform.invert();
                this._defaultInvVertexTransform.transpose();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleGraphicsTransform.prototype, "UVTransform", {
            get: function () {
                return this._defaultUVTransform;
            },
            set: function (value) {
                this._defaultUVTransform = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ParticleGraphicsTransform.prototype, "invVertexTransform", {
            get: function () {
                return this._defaultInvVertexTransform;
            },
            enumerable: true,
            configurable: true
        });
        return ParticleGraphicsTransform;
    }());

    console.debug("AwayJS - Graphics - 0.4.21");

    var DisplayObjectEvent = /** @class */ (function (_super) {
        __extends$3(DisplayObjectEvent, _super);
        function DisplayObjectEvent(type, object) {
            var _this = _super.call(this, type) || this;
            _this._object = object;
            return _this;
        }
        Object.defineProperty(DisplayObjectEvent.prototype, "object", {
            get: function () {
                return this._object;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the event.
         * @return An exact duplicate of the current object.
         */
        DisplayObjectEvent.prototype.clone = function () {
            return new DisplayObjectEvent(this.type, this._object);
        };
        /**
         *
         */
        DisplayObjectEvent.VISIBLITY_UPDATED = "visiblityUpdated";
        /**
         *
         */
        DisplayObjectEvent.SCENETRANSFORM_CHANGED = "scenetransformChanged";
        /**
         *
         */
        DisplayObjectEvent.PARTITION_CHANGED = "partitionChanged";
        return DisplayObjectEvent;
    }(EventBase));

    /**
     * A FocusEvent is dispatched when a entity is focused
     */
    var FocusEvent = /** @class */ (function (_super) {
        __extends$3(FocusEvent, _super);
        /**
         * Create a new MouseEvent object.
         * @param type The type of the MouseEvent.
         */
        function FocusEvent(type) {
            return _super.call(this, type) || this;
        }
        /**
         * Creates a copy of the MouseEvent object and sets the value of each property to match that of the original.
         */
        FocusEvent.prototype.clone = function () {
            var result = new FocusEvent(this.type);
            /* TODO: Debug / test - look into isDefaultPrevented
             if (isDefaultPrevented())
             result.preventDefault();
             */
            result.view = this.view;
            result.entity = this.entity;
            return result;
        };
        /**
         * Defines the value of the type property of a focusIn3d event object.
         */
        FocusEvent.FOCUS_IN = "focusIn3d";
        /**
         * Defines the value of the type property of a focusOut3d event object.
         */
        FocusEvent.FOCUS_OUT = "focusOut3d";
        return FocusEvent;
    }(EventBase));

    /**
     * PrefabBase is an abstract base class for prefabs, which are prebuilt display objects that allow easy cloning and updating
     */
    var PrefabBase = /** @class */ (function (_super) {
        __extends$3(PrefabBase, _super);
        //		public _pBatchObjects:Array<BatchObject> = new Array<BatchObject>();
        /**
         * Creates a new PrefabBase object.
         */
        function PrefabBase() {
            var _this = _super.call(this) || this;
            _this._pObjects = new Array();
            return _this;
        }
        /**
         * Returns a display object generated from this prefab
         */
        PrefabBase.prototype.getNewObject = function () {
            var object = this._pCreateObject();
            this._pObjects.push(object);
            return object;
        };
        //		public getNewBatchObject():BatchObject
        //		{
        //			var object:BatchObject = this._pCreateBatchObject();
        //
        //			this._pBatchObjects.push(object);
        //
        //			return object;
        //		}
        PrefabBase.prototype._pCreateObject = function () {
            throw new AbstractMethodError();
        };
        PrefabBase.prototype._iValidate = function () {
            // To be overridden when necessary
        };
        return PrefabBase;
    }(AssetBase));

    /**
     * PrimitivePrefabBase is an abstract base class for polytope prefabs, which are simple pre-built geometric shapes
     */
    var PrimitivePrefabBase = /** @class */ (function (_super) {
        __extends$3(PrimitivePrefabBase, _super);
        /**
         * Creates a new PrimitivePrefabBase object.
         *
         * @param material The material with which to render the object
         */
        function PrimitivePrefabBase(material, elementsType) {
            if (material === void 0) { material = null; }
            if (elementsType === void 0) { elementsType = "triangle"; }
            var _this = _super.call(this) || this;
            _this._primitiveDirty = true;
            _this._uvDirty = true;
            _this._scaleU = 1;
            _this._scaleV = 1;
            _this._material = material;
            _this._elementsType = elementsType;
            if (_this._elementsType == ElementsType.TRIANGLE) {
                var triangleElements = new TriangleElements(new AttributesBuffer());
                triangleElements.autoDeriveNormals = false;
                triangleElements.autoDeriveTangents = false;
                _this._elements = triangleElements;
            }
            else if (_this._elementsType == ElementsType.LINE) {
                _this._elements = new LineElements(new AttributesBuffer());
            }
            return _this;
        }
        Object.defineProperty(PrimitivePrefabBase.prototype, "assetType", {
            /**
             *
             */
            get: function () {
                return PrimitivePrefabBase.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitivePrefabBase.prototype, "elementsType", {
            /**
             *
             */
            get: function () {
                return this._elementsType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitivePrefabBase.prototype, "material", {
            /**
             * The material with which to render the primitive.
             */
            get: function () {
                return this._material;
            },
            set: function (value) {
                if (value == this._material)
                    return;
                this._material = value;
                var len = this._pObjects.length;
                for (var i = 0; i < len; i++)
                    this._pObjects[i].material = this._material;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitivePrefabBase.prototype, "scaleU", {
            get: function () {
                return this._scaleU;
            },
            set: function (value) {
                if (this._scaleU == value)
                    return;
                this._scaleU = value;
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitivePrefabBase.prototype, "scaleV", {
            get: function () {
                return this._scaleV;
            },
            set: function (value) {
                if (this._scaleV == value)
                    return;
                this._scaleV = value;
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Builds the primitive's geometry when invalid. This method should not be called directly. The calling should
         * be triggered by the invalidateGraphics method (and in turn by updateGraphics).
         */
        PrimitivePrefabBase.prototype._pBuildGraphics = function (target, elementsType) {
            throw new AbstractMethodError();
        };
        /**
         * Builds the primitive's uv coordinates when invalid. This method should not be called directly. The calling
         * should be triggered by the invalidateUVs method (and in turn by updateUVs).
         */
        PrimitivePrefabBase.prototype._pBuildUVs = function (target, elementsType) {
            throw new AbstractMethodError();
        };
        /**
         * Invalidates the primitive, causing it to be updated when requested.
         */
        PrimitivePrefabBase.prototype._pInvalidatePrimitive = function () {
            this._primitiveDirty = true;
        };
        /**
         * Invalidates the primitive's uv coordinates, causing them to be updated when requested.
         */
        PrimitivePrefabBase.prototype._pInvalidateUVs = function () {
            this._uvDirty = true;
        };
        /**
         * Updates the geometry when invalid.
         */
        PrimitivePrefabBase.prototype.updateGraphics = function () {
            this._pBuildGraphics(this._elements, this._elementsType);
            this._primitiveDirty = false;
        };
        /**
         * Updates the uv coordinates when invalid.
         */
        PrimitivePrefabBase.prototype.updateUVs = function () {
            this._pBuildUVs(this._elements, this._elementsType);
            this._uvDirty = false;
        };
        PrimitivePrefabBase.prototype._iValidate = function () {
            if (this._primitiveDirty)
                this.updateGraphics();
            if (this._uvDirty)
                this.updateUVs();
        };
        PrimitivePrefabBase.prototype._pCreateObject = function () {
            var sprite = new Sprite(null, this._material);
            sprite.graphics.addShape(Shape.getShape(this._elements));
            sprite._iSourcePrefab = this;
            return sprite;
        };
        PrimitivePrefabBase.assetType = "[asset PrimitivePrefab]";
        return PrimitivePrefabBase;
    }(PrefabBase));

    /**
     * A Cube primitive prefab.
     */
    var PrimitiveCubePrefab = /** @class */ (function (_super) {
        __extends$3(PrimitiveCubePrefab, _super);
        /**
         * Creates a new Cube object.
         * @param width The size of the cube along its X-axis.
         * @param height The size of the cube along its Y-axis.
         * @param depth The size of the cube along its Z-axis.
         * @param segmentsW The number of segments that make up the cube along the X-axis.
         * @param segmentsH The number of segments that make up the cube along the Y-axis.
         * @param segmentsD The number of segments that make up the cube along the Z-axis.
         * @param tile6 The type of uv mapping to use. When true, a texture will be subdivided in a 2x3 grid, each used for a single face. When false, the entire image is mapped on each face.
         */
        function PrimitiveCubePrefab(material, elementsType, width, height, depth, segmentsW, segmentsH, segmentsD, tile6) {
            if (material === void 0) { material = null; }
            if (elementsType === void 0) { elementsType = "triangle"; }
            if (width === void 0) { width = 100; }
            if (height === void 0) { height = 100; }
            if (depth === void 0) { depth = 100; }
            if (segmentsW === void 0) { segmentsW = 1; }
            if (segmentsH === void 0) { segmentsH = 1; }
            if (segmentsD === void 0) { segmentsD = 1; }
            if (tile6 === void 0) { tile6 = true; }
            var _this = _super.call(this, material, elementsType) || this;
            _this._width = width;
            _this._height = height;
            _this._depth = depth;
            _this._segmentsW = segmentsW;
            _this._segmentsH = segmentsH;
            _this._segmentsD = segmentsD;
            _this._tile6 = tile6;
            return _this;
        }
        Object.defineProperty(PrimitiveCubePrefab.prototype, "width", {
            /**
             * The size of the cube along its X-axis.
             */
            get: function () {
                return this._width;
            },
            set: function (value) {
                this._width = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCubePrefab.prototype, "height", {
            /**
             * The size of the cube along its Y-axis.
             */
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCubePrefab.prototype, "depth", {
            /**
             * The size of the cube along its Z-axis.
             */
            get: function () {
                return this._depth;
            },
            set: function (value) {
                this._depth = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCubePrefab.prototype, "tile6", {
            /**
             * The type of uv mapping to use. When false, the entire image is mapped on each face.
             * When true, a texture will be subdivided in a 3x2 grid, each used for a single face.
             * Reading the tiles from left to right, top to bottom they represent the faces of the
             * cube in the following order: bottom, top, back, left, front, right. This creates
             * several shared edges (between the top, front, left and right faces) which simplifies
             * texture painting.
             */
            get: function () {
                return this._tile6;
            },
            set: function (value) {
                this._tile6 = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCubePrefab.prototype, "segmentsW", {
            /**
             * The number of segments that make up the cube along the X-axis. Defaults to 1.
             */
            get: function () {
                return this._segmentsW;
            },
            set: function (value) {
                this._segmentsW = value;
                this._pInvalidatePrimitive();
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCubePrefab.prototype, "segmentsH", {
            /**
             * The number of segments that make up the cube along the Y-axis. Defaults to 1.
             */
            get: function () {
                return this._segmentsH;
            },
            set: function (value) {
                this._segmentsH = value;
                this._pInvalidatePrimitive();
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCubePrefab.prototype, "segmentsD", {
            /**
             * The number of segments that make up the cube along the Z-axis. Defaults to 1.
             */
            get: function () {
                return this._segmentsD;
            },
            set: function (value) {
                this._segmentsD = value;
                this._pInvalidatePrimitive();
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        PrimitiveCubePrefab.prototype._pBuildGraphics = function (target, elementsType) {
            var indices;
            var positions;
            var normals;
            var tangents;
            var stride;
            var tl, tr, bl, br;
            var i, j, inc = 0;
            var vidx, fidx; // indices
            var hw, hh, hd; // halves
            var dw, dh, dd; // deltas
            var outer_pos;
            // half cube dimensions
            hw = this._width / 2;
            hh = this._height / 2;
            hd = this._depth / 2;
            if (elementsType == ElementsType.TRIANGLE) {
                var triangleGraphics = target;
                var numVertices = ((this._segmentsW + 1) * (this._segmentsH + 1) + (this._segmentsW + 1) * (this._segmentsD + 1) + (this._segmentsH + 1) * (this._segmentsD + 1)) * 2;
                var numIndices = ((this._segmentsW * this._segmentsH + this._segmentsW * this._segmentsD + this._segmentsH * this._segmentsD) * 12);
                if (numVertices == triangleGraphics.numVertices && triangleGraphics.indices != null) {
                    triangleGraphics.invalidateIndices();
                    triangleGraphics.invalidateVertices(triangleGraphics.positions);
                    triangleGraphics.invalidateVertices(triangleGraphics.normals);
                    triangleGraphics.invalidateVertices(triangleGraphics.tangents);
                }
                else {
                    triangleGraphics.setIndices(new Uint16Array(numIndices));
                    triangleGraphics.setPositions(new Float32Array(numVertices * 3));
                    triangleGraphics.setNormals(new Float32Array(numVertices * 3));
                    triangleGraphics.setTangents(new Float32Array(numVertices * 3));
                    this._pInvalidateUVs();
                }
                indices = triangleGraphics.indices.get(triangleGraphics.numElements);
                positions = triangleGraphics.positions.get(numVertices);
                normals = triangleGraphics.normals.get(numVertices);
                tangents = triangleGraphics.tangents.get(numVertices);
                stride = triangleGraphics.concatenatedBuffer.stride / 4;
                vidx = 0;
                fidx = 0;
                // Segment dimensions
                dw = this._width / this._segmentsW;
                dh = this._height / this._segmentsH;
                dd = this._depth / this._segmentsD;
                for (i = 0; i <= this._segmentsW; i++) {
                    outer_pos = -hw + i * dw;
                    for (j = 0; j <= this._segmentsH; j++) {
                        // front
                        positions[vidx] = outer_pos;
                        positions[vidx + 1] = -hh + j * dh;
                        positions[vidx + 2] = -hd;
                        normals[vidx] = 0;
                        normals[vidx + 1] = 0;
                        normals[vidx + 2] = -1;
                        tangents[vidx] = 1;
                        tangents[vidx + 1] = 0;
                        tangents[vidx + 2] = 0;
                        vidx += stride;
                        // back
                        positions[vidx] = outer_pos;
                        positions[vidx + 1] = -hh + j * dh;
                        positions[vidx + 2] = hd;
                        normals[vidx] = 0;
                        normals[vidx + 1] = 0;
                        normals[vidx + 2] = 1;
                        tangents[vidx] = -1;
                        tangents[vidx + 1] = 0;
                        tangents[vidx + 2] = 0;
                        vidx += stride;
                        if (i && j) {
                            tl = 2 * ((i - 1) * (this._segmentsH + 1) + (j - 1));
                            tr = 2 * (i * (this._segmentsH + 1) + (j - 1));
                            bl = tl + 2;
                            br = tr + 2;
                            indices[fidx++] = tl;
                            indices[fidx++] = bl;
                            indices[fidx++] = br;
                            indices[fidx++] = tl;
                            indices[fidx++] = br;
                            indices[fidx++] = tr;
                            indices[fidx++] = tr + 1;
                            indices[fidx++] = br + 1;
                            indices[fidx++] = bl + 1;
                            indices[fidx++] = tr + 1;
                            indices[fidx++] = bl + 1;
                            indices[fidx++] = tl + 1;
                        }
                    }
                }
                inc += 2 * (this._segmentsW + 1) * (this._segmentsH + 1);
                for (i = 0; i <= this._segmentsW; i++) {
                    outer_pos = -hw + i * dw;
                    for (j = 0; j <= this._segmentsD; j++) {
                        // top
                        positions[vidx] = outer_pos;
                        positions[vidx + 1] = hh;
                        positions[vidx + 2] = -hd + j * dd;
                        normals[vidx] = 0;
                        normals[vidx + 1] = 1;
                        normals[vidx + 2] = 0;
                        tangents[vidx] = 1;
                        tangents[vidx + 1] = 0;
                        tangents[vidx + 2] = 0;
                        vidx += stride;
                        // bottom
                        positions[vidx] = outer_pos;
                        positions[vidx + 1] = -hh;
                        positions[vidx + 2] = -hd + j * dd;
                        normals[vidx] = 0;
                        normals[vidx + 1] = -1;
                        normals[vidx + 2] = 0;
                        tangents[vidx] = 1;
                        tangents[vidx + 1] = 0;
                        tangents[vidx + 2] = 0;
                        vidx += stride;
                        if (i && j) {
                            tl = inc + 2 * ((i - 1) * (this._segmentsD + 1) + (j - 1));
                            tr = inc + 2 * (i * (this._segmentsD + 1) + (j - 1));
                            bl = tl + 2;
                            br = tr + 2;
                            indices[fidx++] = tl;
                            indices[fidx++] = bl;
                            indices[fidx++] = br;
                            indices[fidx++] = tl;
                            indices[fidx++] = br;
                            indices[fidx++] = tr;
                            indices[fidx++] = tr + 1;
                            indices[fidx++] = br + 1;
                            indices[fidx++] = bl + 1;
                            indices[fidx++] = tr + 1;
                            indices[fidx++] = bl + 1;
                            indices[fidx++] = tl + 1;
                        }
                    }
                }
                inc += 2 * (this._segmentsW + 1) * (this._segmentsD + 1);
                for (i = 0; i <= this._segmentsD; i++) {
                    outer_pos = hd - i * dd;
                    for (j = 0; j <= this._segmentsH; j++) {
                        // left
                        positions[vidx] = -hw;
                        positions[vidx + 1] = -hh + j * dh;
                        positions[vidx + 2] = outer_pos;
                        normals[vidx] = -1;
                        normals[vidx + 1] = 0;
                        normals[vidx + 2] = 0;
                        tangents[vidx] = 0;
                        tangents[vidx + 1] = 0;
                        tangents[vidx + 2] = -1;
                        vidx += stride;
                        // right
                        positions[vidx] = hw;
                        positions[vidx + 1] = -hh + j * dh;
                        positions[vidx + 2] = outer_pos;
                        normals[vidx] = 1;
                        normals[vidx + 1] = 0;
                        normals[vidx + 2] = 0;
                        tangents[vidx] = 0;
                        tangents[vidx + 1] = 0;
                        tangents[vidx + 2] = 1;
                        vidx += stride;
                        if (i && j) {
                            tl = inc + 2 * ((i - 1) * (this._segmentsH + 1) + (j - 1));
                            tr = inc + 2 * (i * (this._segmentsH + 1) + (j - 1));
                            bl = tl + 2;
                            br = tr + 2;
                            indices[fidx++] = tl;
                            indices[fidx++] = bl;
                            indices[fidx++] = br;
                            indices[fidx++] = tl;
                            indices[fidx++] = br;
                            indices[fidx++] = tr;
                            indices[fidx++] = tr + 1;
                            indices[fidx++] = br + 1;
                            indices[fidx++] = bl + 1;
                            indices[fidx++] = tr + 1;
                            indices[fidx++] = bl + 1;
                            indices[fidx++] = tl + 1;
                        }
                    }
                }
            }
            else if (elementsType == ElementsType.LINE) {
                var lineGraphics = target;
                var numSegments = this._segmentsH * 4 + this._segmentsW * 4 + this._segmentsD * 4;
                var thickness;
                positions = new Float32Array(numSegments * 6);
                thickness = new Float32Array(numSegments);
                vidx = 0;
                fidx = 0;
                //front/back face
                for (i = 0; i < this._segmentsH; ++i) {
                    positions[vidx++] = -hw;
                    positions[vidx++] = i * this._height / this._segmentsH - hh;
                    positions[vidx++] = -hd;
                    positions[vidx++] = hw;
                    positions[vidx++] = i * this._height / this._segmentsH - hh;
                    positions[vidx++] = -hd;
                    thickness[fidx++] = 1;
                    positions[vidx++] = -hw;
                    positions[vidx++] = hh - i * this._height / this._segmentsH;
                    positions[vidx++] = hd;
                    positions[vidx++] = hw;
                    positions[vidx++] = hh - i * this._height / this._segmentsH;
                    positions[vidx++] = hd;
                    thickness[fidx++] = 1;
                }
                for (i = 0; i < this._segmentsW; ++i) {
                    positions[vidx++] = i * this._width / this._segmentsW - hw;
                    positions[vidx++] = -hh;
                    positions[vidx++] = -hd;
                    positions[vidx++] = i * this._width / this._segmentsW - hw;
                    positions[vidx++] = hh;
                    positions[vidx++] = -hd;
                    thickness[fidx++] = 1;
                    positions[vidx++] = hw - i * this._width / this._segmentsW;
                    positions[vidx++] = -hh;
                    positions[vidx++] = hd;
                    positions[vidx++] = hw - i * this._width / this._segmentsW;
                    positions[vidx++] = hh;
                    positions[vidx++] = hd;
                    thickness[fidx++] = 1;
                }
                //left/right face
                for (i = 0; i < this._segmentsH; ++i) {
                    positions[vidx++] = -hw;
                    positions[vidx++] = i * this._height / this._segmentsH - hh;
                    positions[vidx++] = -hd;
                    positions[vidx++] = -hw;
                    positions[vidx++] = i * this._height / this._segmentsH - hh;
                    positions[vidx++] = hd;
                    thickness[fidx++] = 1;
                    positions[vidx++] = hw;
                    positions[vidx++] = hh - i * this._height / this._segmentsH;
                    positions[vidx++] = -hd;
                    positions[vidx++] = hw;
                    positions[vidx++] = hh - i * this._height / this._segmentsH;
                    positions[vidx++] = hd;
                    thickness[fidx++] = 1;
                }
                for (i = 0; i < this._segmentsD; ++i) {
                    positions[vidx++] = hw;
                    positions[vidx++] = -hh;
                    positions[vidx++] = i * this._depth / this._segmentsD - hd;
                    positions[vidx++] = hw;
                    positions[vidx++] = hh;
                    positions[vidx++] = i * this._depth / this._segmentsD - hd;
                    thickness[fidx++] = 1;
                    positions[vidx++] = -hw;
                    positions[vidx++] = -hh;
                    positions[vidx++] = hd - i * this._depth / this._segmentsD;
                    positions[vidx++] = -hw;
                    positions[vidx++] = hh;
                    positions[vidx++] = hd - i * this._depth / this._segmentsD;
                    thickness[fidx++] = 1;
                }
                //top/bottom face
                for (i = 0; i < this._segmentsD; ++i) {
                    positions[vidx++] = -hw;
                    positions[vidx++] = -hh;
                    positions[vidx++] = hd - i * this._depth / this._segmentsD;
                    positions[vidx++] = hw;
                    positions[vidx++] = -hh;
                    positions[vidx++] = hd - i * this._depth / this._segmentsD;
                    thickness[fidx++] = 1;
                    positions[vidx++] = -hw;
                    positions[vidx++] = hh;
                    positions[vidx++] = i * this._depth / this._segmentsD - hd;
                    positions[vidx++] = hw;
                    positions[vidx++] = hh;
                    positions[vidx++] = i * this._depth / this._segmentsD - hd;
                    thickness[fidx++] = 1;
                }
                for (i = 0; i < this._segmentsW; ++i) {
                    positions[vidx++] = hw - i * this._width / this._segmentsW;
                    positions[vidx++] = -hh;
                    positions[vidx++] = -hd;
                    positions[vidx++] = hw - i * this._width / this._segmentsW;
                    positions[vidx++] = -hh;
                    positions[vidx++] = hd;
                    thickness[fidx++] = 1;
                    positions[vidx++] = i * this._width / this._segmentsW - hw;
                    positions[vidx++] = hh;
                    positions[vidx++] = -hd;
                    positions[vidx++] = i * this._width / this._segmentsW - hw;
                    positions[vidx++] = hh;
                    positions[vidx++] = hd;
                    thickness[fidx++] = 1;
                }
                // build real data from raw data
                lineGraphics.setPositions(positions);
                lineGraphics.setThickness(thickness);
            }
        };
        /**
         * @inheritDoc
         */
        PrimitiveCubePrefab.prototype._pBuildUVs = function (target, elementsType) {
            var i, j, index;
            var uvs;
            var stride;
            var u_tile_dim, v_tile_dim;
            var u_tile_step, v_tile_step;
            var tl0u, tl0v;
            var tl1u, tl1v;
            var du, dv;
            var numVertices;
            if (elementsType == ElementsType.TRIANGLE) {
                numVertices = ((this._segmentsW + 1) * (this._segmentsH + 1) + (this._segmentsW + 1) * (this._segmentsD + 1) + (this._segmentsH + 1) * (this._segmentsD + 1)) * 2;
                var triangleGraphics = target;
                if (triangleGraphics.uvs && numVertices == triangleGraphics.numVertices) {
                    triangleGraphics.invalidateVertices(triangleGraphics.uvs);
                }
                else {
                    triangleGraphics.setUVs(new Float32Array(numVertices * 2));
                }
                uvs = triangleGraphics.uvs.get(numVertices);
                stride = triangleGraphics.uvs.stride;
                if (this._tile6) {
                    u_tile_dim = u_tile_step = 1 / 3;
                    v_tile_dim = v_tile_step = 1 / 2;
                }
                else {
                    u_tile_dim = v_tile_dim = 1;
                    u_tile_step = v_tile_step = 0;
                }
                // Create planes two and two, the same way that they were
                // constructed in the buildGraphics() function. First calculate
                // the top-left UV coordinate for both planes, and then loop
                // over the points, calculating the UVs from these numbers.
                // When tile6 is true, the layout is as follows:
                //       .-----.-----.-----. (1,1)
                //       | Bot |  T  | Bak |
                //       |-----+-----+-----|
                //       |  L  |  F  |  R  |
                // (0,0)'-----'-----'-----'
                index = 0;
                // FRONT / BACK
                tl0u = 1 * u_tile_step;
                tl0v = 1 * v_tile_step;
                tl1u = 2 * u_tile_step;
                tl1v = 0 * v_tile_step;
                du = u_tile_dim / this._segmentsW;
                dv = v_tile_dim / this._segmentsH;
                for (i = 0; i <= this._segmentsW; i++) {
                    for (j = 0; j <= this._segmentsH; j++) {
                        uvs[index] = (tl0u + i * du) * this._scaleU;
                        uvs[index + 1] = (tl0v + (v_tile_dim - j * dv)) * this._scaleV;
                        index += stride;
                        uvs[index] = (tl1u + (u_tile_dim - i * du)) * this._scaleU;
                        uvs[index + 1] = (tl1v + (v_tile_dim - j * dv)) * this._scaleV;
                        index += stride;
                    }
                }
                // TOP / BOTTOM
                tl0u = 1 * u_tile_step;
                tl0v = 0 * v_tile_step;
                tl1u = 0 * u_tile_step;
                tl1v = 0 * v_tile_step;
                du = u_tile_dim / this._segmentsW;
                dv = v_tile_dim / this._segmentsD;
                for (i = 0; i <= this._segmentsW; i++) {
                    for (j = 0; j <= this._segmentsD; j++) {
                        uvs[index] = (tl0u + i * du) * this._scaleU;
                        uvs[index + 1] = (tl0v + (v_tile_dim - j * dv)) * this._scaleV;
                        index += stride;
                        uvs[index] = (tl1u + i * du) * this._scaleU;
                        uvs[index + 1] = (tl1v + j * dv) * this._scaleV;
                        index += stride;
                    }
                }
                // LEFT / RIGHT
                tl0u = 0 * u_tile_step;
                tl0v = 1 * v_tile_step;
                tl1u = 2 * u_tile_step;
                tl1v = 1 * v_tile_step;
                du = u_tile_dim / this._segmentsD;
                dv = v_tile_dim / this._segmentsH;
                for (i = 0; i <= this._segmentsD; i++) {
                    for (j = 0; j <= this._segmentsH; j++) {
                        uvs[index] = (tl0u + i * du) * this._scaleU;
                        uvs[index + 1] = (tl0v + (v_tile_dim - j * dv)) * this._scaleV;
                        index += stride;
                        uvs[index] = (tl1u + (u_tile_dim - i * du)) * this._scaleU;
                        uvs[index + 1] = (tl1v + (v_tile_dim - j * dv)) * this._scaleV;
                        index += stride;
                    }
                }
            }
            else if (elementsType == ElementsType.LINE) {
                //nothing to do here
            }
        };
        return PrimitiveCubePrefab;
    }(PrimitivePrefabBase));

    /**
     * A UV Sphere primitive sprite.
     */
    var PrimitiveSpherePrefab = /** @class */ (function (_super) {
        __extends$3(PrimitiveSpherePrefab, _super);
        /**
         * Creates a new Sphere object.
         *
         * @param radius The radius of the sphere.
         * @param segmentsW Defines the number of horizontal segments that make up the sphere.
         * @param segmentsH Defines the number of vertical segments that make up the sphere.
         * @param yUp Defines whether the sphere poles should lay on the Y-axis (true) or on the Z-axis (false).
         */
        function PrimitiveSpherePrefab(material, elementsType, radius, segmentsW, segmentsH, yUp) {
            if (material === void 0) { material = null; }
            if (elementsType === void 0) { elementsType = "triangle"; }
            if (radius === void 0) { radius = 50; }
            if (segmentsW === void 0) { segmentsW = 16; }
            if (segmentsH === void 0) { segmentsH = 12; }
            if (yUp === void 0) { yUp = true; }
            var _this = _super.call(this, material, elementsType) || this;
            _this._radius = radius;
            _this._segmentsW = segmentsW;
            _this._segmentsH = segmentsH;
            _this._yUp = yUp;
            return _this;
        }
        Object.defineProperty(PrimitiveSpherePrefab.prototype, "radius", {
            /**
             * The radius of the sphere.
             */
            get: function () {
                return this._radius;
            },
            set: function (value) {
                this._radius = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveSpherePrefab.prototype, "segmentsW", {
            /**
             * Defines the number of horizontal segments that make up the sphere. Defaults to 16.
             */
            get: function () {
                return this._segmentsW;
            },
            set: function (value) {
                this._segmentsW = value;
                this._pInvalidatePrimitive();
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveSpherePrefab.prototype, "segmentsH", {
            /**
             * Defines the number of vertical segments that make up the sphere. Defaults to 12.
             */
            get: function () {
                return this._segmentsH;
            },
            set: function (value) {
                this._segmentsH = value;
                this._pInvalidatePrimitive();
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveSpherePrefab.prototype, "yUp", {
            /**
             * Defines whether the sphere poles should lay on the Y-axis (true) or on the Z-axis (false).
             */
            get: function () {
                return this._yUp;
            },
            set: function (value) {
                this._yUp = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        PrimitiveSpherePrefab.prototype._pBuildGraphics = function (target, elementsType) {
            var indices;
            var positions;
            var normals;
            var tangents;
            var stride;
            var i;
            var j;
            var vidx, fidx; // indices
            var comp1;
            var comp2;
            var numVertices;
            if (elementsType == ElementsType.TRIANGLE) {
                var triangleGraphics = target;
                numVertices = (this._segmentsH + 1) * (this._segmentsW + 1);
                if (numVertices == triangleGraphics.numVertices && triangleGraphics.indices != null) {
                    triangleGraphics.invalidateIndices();
                    triangleGraphics.invalidateVertices(triangleGraphics.positions);
                    triangleGraphics.invalidateVertices(triangleGraphics.normals);
                    triangleGraphics.invalidateVertices(triangleGraphics.tangents);
                }
                else {
                    triangleGraphics.setIndices(new Uint16Array((this._segmentsH - 1) * this._segmentsW * 6));
                    triangleGraphics.setPositions(new Float32Array(numVertices * 3));
                    triangleGraphics.setNormals(new Float32Array(numVertices * 3));
                    triangleGraphics.setTangents(new Float32Array(numVertices * 3));
                    this._pInvalidateUVs();
                }
                indices = triangleGraphics.indices.get(triangleGraphics.numElements);
                positions = triangleGraphics.positions.get(numVertices);
                normals = triangleGraphics.normals.get(numVertices);
                tangents = triangleGraphics.tangents.get(numVertices);
                stride = triangleGraphics.concatenatedBuffer.stride / 4;
                vidx = 0;
                fidx = 0;
                var startIndex;
                var t1;
                var t2;
                for (j = 0; j <= this._segmentsH; ++j) {
                    startIndex = vidx;
                    var horangle = Math.PI * j / this._segmentsH;
                    var z = -this._radius * Math.cos(horangle);
                    var ringradius = this._radius * Math.sin(horangle);
                    for (i = 0; i <= this._segmentsW; ++i) {
                        var verangle = 2 * Math.PI * i / this._segmentsW;
                        var x = ringradius * Math.cos(verangle);
                        var y = ringradius * Math.sin(verangle);
                        var normLen = 1 / Math.sqrt(x * x + y * y + z * z);
                        var tanLen = Math.sqrt(y * y + x * x);
                        if (this._yUp) {
                            t1 = 0;
                            t2 = tanLen > .007 ? x / tanLen : 0;
                            comp1 = -z;
                            comp2 = y;
                        }
                        else {
                            t1 = tanLen > .007 ? x / tanLen : 0;
                            t2 = 0;
                            comp1 = y;
                            comp2 = z;
                        }
                        if (i == this._segmentsW) {
                            positions[vidx] = positions[startIndex];
                            positions[vidx + 1] = positions[startIndex + 1];
                            positions[vidx + 2] = positions[startIndex + 2];
                            normals[vidx] = normals[startIndex] + (x * normLen) * .5;
                            normals[vidx + 1] = normals[startIndex + 1] + (comp1 * normLen) * .5;
                            normals[vidx + 2] = normals[startIndex + 2] + (comp2 * normLen) * .5;
                            tangents[vidx] = tanLen > .007 ? -y / tanLen : 1;
                            tangents[vidx + 1] = t1;
                            tangents[vidx + 2] = t2;
                        }
                        else {
                            positions[vidx] = x;
                            positions[vidx + 1] = comp1;
                            positions[vidx + 2] = comp2;
                            normals[vidx] = x * normLen;
                            normals[vidx + 1] = comp1 * normLen;
                            normals[vidx + 2] = comp2 * normLen;
                            tangents[vidx] = tanLen > .007 ? -y / tanLen : 1;
                            tangents[vidx + 1] = t1;
                            tangents[vidx + 2] = t2;
                        }
                        if (i > 0 && j > 0) {
                            var a = (this._segmentsW + 1) * j + i;
                            var b = (this._segmentsW + 1) * j + i - 1;
                            var c = (this._segmentsW + 1) * (j - 1) + i - 1;
                            var d = (this._segmentsW + 1) * (j - 1) + i;
                            if (j == this._segmentsH) {
                                positions[vidx] = positions[startIndex];
                                positions[vidx + 1] = positions[startIndex + 1];
                                positions[vidx + 2] = positions[startIndex + 2];
                                indices[fidx++] = a;
                                indices[fidx++] = c;
                                indices[fidx++] = d;
                            }
                            else if (j == 1) {
                                indices[fidx++] = a;
                                indices[fidx++] = b;
                                indices[fidx++] = c;
                            }
                            else {
                                indices[fidx++] = a;
                                indices[fidx++] = b;
                                indices[fidx++] = c;
                                indices[fidx++] = a;
                                indices[fidx++] = c;
                                indices[fidx++] = d;
                            }
                        }
                        vidx += stride;
                    }
                }
            }
            else if (elementsType == ElementsType.LINE) {
                var lineGraphics = target;
                var numSegments = this._segmentsH * this._segmentsW * 2 + this._segmentsW;
                var positions = new Float32Array(numSegments * 6);
                var thickness = new Float32Array(numSegments);
                vidx = 0;
                fidx = 0;
                for (j = 0; j <= this._segmentsH; ++j) {
                    var horangle = Math.PI * j / this._segmentsH;
                    var z = -this._radius * Math.cos(horangle);
                    var ringradius = this._radius * Math.sin(horangle);
                    for (i = 0; i <= this._segmentsW; ++i) {
                        var verangle = 2 * Math.PI * i / this._segmentsW;
                        var x = ringradius * Math.cos(verangle);
                        var y = ringradius * Math.sin(verangle);
                        if (this._yUp) {
                            comp1 = -z;
                            comp2 = y;
                        }
                        else {
                            comp1 = y;
                            comp2 = z;
                        }
                        if (i > 0) {
                            //horizonal lines
                            positions[vidx++] = x;
                            positions[vidx++] = comp1;
                            positions[vidx++] = comp2;
                            thickness[fidx++] = 1;
                            //vertical lines
                            if (j > 0) {
                                var addx = (j == 1) ? 3 - (6 * (this._segmentsW - i) + 12 * i) : 3 - this._segmentsW * 12;
                                positions[vidx] = positions[vidx++ + addx];
                                positions[vidx] = positions[vidx++ + addx];
                                positions[vidx] = positions[vidx++ + addx];
                                positions[vidx++] = x;
                                positions[vidx++] = comp1;
                                positions[vidx++] = comp2;
                                thickness[fidx++] = 1;
                            }
                        }
                        //horizonal lines
                        if (i < this._segmentsW) {
                            positions[vidx++] = x;
                            positions[vidx++] = comp1;
                            positions[vidx++] = comp2;
                        }
                    }
                }
                // build real data from raw data
                lineGraphics.setPositions(positions);
                lineGraphics.setThickness(thickness);
            }
        };
        /**
         * @inheritDoc
         */
        PrimitiveSpherePrefab.prototype._pBuildUVs = function (target, elementsType) {
            var i, j;
            var numVertices = (this._segmentsH + 1) * (this._segmentsW + 1);
            var uvs;
            var stride;
            if (elementsType == ElementsType.TRIANGLE) {
                numVertices = (this._segmentsH + 1) * (this._segmentsW + 1);
                var triangleGraphics = target;
                if (triangleGraphics.uvs && numVertices == triangleGraphics.numVertices) {
                    triangleGraphics.invalidateVertices(triangleGraphics.uvs);
                }
                else {
                    triangleGraphics.setUVs(new Float32Array(numVertices * 2));
                }
                uvs = triangleGraphics.uvs.get(numVertices);
                stride = triangleGraphics.uvs.stride;
                var index = 0;
                for (j = 0; j <= this._segmentsH; ++j) {
                    for (i = 0; i <= this._segmentsW; ++i) {
                        uvs[index] = (i / this._segmentsW) * this._scaleU;
                        uvs[index + 1] = (j / this._segmentsH) * this._scaleV;
                        index += stride;
                    }
                }
            }
            else if (elementsType == ElementsType.LINE) {
                //nothing to do here
            }
        };
        return PrimitiveSpherePrefab;
    }(PrimitivePrefabBase));

    /**
     * The DisplayObject class is the base class for all objects that can be
     * placed on the display list. The display list manages all objects displayed
     * in flash. Use the DisplayObjectContainer class to arrange the
     * display objects in the display list. DisplayObjectContainer objects can
     * have child display objects, while other display objects, such as Shape and
     * TextField objects, are "leaf" nodes that have only parents and siblings, no
     * children.
     *
     * <p>The DisplayObject class supports fbasic functionality like the <i>x</i>
     * and <i>y</i> position of an object, as well as more advanced properties of
     * the object such as its transformation matrix. </p>
     *
     * <p>DisplayObject is an abstract base class; therefore, you cannot call
     * DisplayObject directly. Invoking <code>new DisplayObject()</code> throws an
     * <code>ArgumentError</code> exception. </p>
     *
     * <p>All display objects inherit from the DisplayObject class.</p>
     *
     * <p>The DisplayObject class itself does not include any APIs for rendering
     * content onscreen. For that reason, if you want create a custom subclass of
     * the DisplayObject class, you will want to extend one of its subclasses that
     * do have APIs for rendering content onscreen, such as the Shape, Sprite,
     * Bitmap, SimpleButton, TextField, or MovieClip class.</p>
     *
     * <p>The DisplayObject class contains several broadcast events. Normally, the
     * target of any particular event is a specific DisplayObject instance. For
     * example, the target of an <code>added</code> event is the specific
     * DisplayObject instance that was added to the display list. Having a single
     * target restricts the placement of event listeners to that target and in
     * some cases the target's ancestors on the display list. With broadcast
     * events, however, the target is not a specific DisplayObject instance, but
     * rather all DisplayObject instances, including those that are not on the
     * display list. This means that you can add a listener to any DisplayObject
     * instance to listen for broadcast events. In addition to the broadcast
     * events listed in the DisplayObject class's Events table, the DisplayObject
     * class also inherits two broadcast events from the EventDispatcher class:
     * <code>activate</code> and <code>deactivate</code>.</p>
     *
     * <p>Some properties previously used in the ActionScript 1.0 and 2.0
     * MovieClip, TextField, and Button classes(such as <code>_alpha</code>,
     * <code>_height</code>, <code>_pName</code>, <code>_width</code>,
     * <code>_x</code>, <code>_y</code>, and others) have equivalents in the
     * ActionScript 3.0 DisplayObject class that are renamed so that they no
     * longer begin with the underscore(_) character.</p>
     *
     * <p>For more information, see the "Display Programming" chapter of the
     * <i>ActionScript 3.0 Developer's Guide</i>.</p>
     *
     * @event added            Dispatched when a display object is added to the
     *                         display list. The following methods trigger this
     *                         event:
     *                         <code>DisplayObjectContainer.addChild()</code>,
     *                         <code>DisplayObjectContainer.addChildAt()</code>.
     * @event addedToScene     Dispatched when a display object is added to the on
     *                         scene display list, either directly or through the
     *                         addition of a sub tree in which the display object
     *                         is contained. The following methods trigger this
     *                         event:
     *                         <code>DisplayObjectContainer.addChild()</code>,
     *                         <code>DisplayObjectContainer.addChildAt()</code>.
     * @event enterFrame       [broadcast event] Dispatched when the playhead is
     *                         entering a new frame. If the playhead is not
     *                         moving, or if there is only one frame, this event
     *                         is dispatched continuously in conjunction with the
     *                         frame rate. This event is a broadcast event, which
     *                         means that it is dispatched by all display objects
     *                         with a listener registered for this event.
     * @event exitFrame        [broadcast event] Dispatched when the playhead is
     *                         exiting the current frame. All frame scripts have
     *                         been run. If the playhead is not moving, or if
     *                         there is only one frame, this event is dispatched
     *                         continuously in conjunction with the frame rate.
     *                         This event is a broadcast event, which means that
     *                         it is dispatched by all display objects with a
     *                         listener registered for this event.
     * @event frameConstructed [broadcast event] Dispatched after the constructors
     *                         of frame display objects have run but before frame
     *                         scripts have run. If the playhead is not moving, or
     *                         if there is only one frame, this event is
     *                         dispatched continuously in conjunction with the
     *                         frame rate. This event is a broadcast event, which
     *                         means that it is dispatched by all display objects
     *                         with a listener registered for this event.
     * @event removed          Dispatched when a display object is about to be
     *                         removed from the display list. Two methods of the
     *                         DisplayObjectContainer class generate this event:
     *                         <code>removeChild()</code> and
     *                         <code>removeChildAt()</code>.
     *
     *                         <p>The following methods of a
     *                         DisplayObjectContainer object also generate this
     *                         event if an object must be removed to make room for
     *                         the new object: <code>addChild()</code>,
     *                         <code>addChildAt()</code>, and
     *                         <code>setChildIndex()</code>. </p>
     * @event removedFromScene Dispatched when a display object is about to be
     *                         removed from the display list, either directly or
     *                         through the removal of a sub tree in which the
     *                         display object is contained. Two methods of the
     *                         DisplayObjectContainer class generate this event:
     *                         <code>removeChild()</code> and
     *                         <code>removeChildAt()</code>.
     *
     *                         <p>The following methods of a
     *                         DisplayObjectContainer object also generate this
     *                         event if an object must be removed to make room for
     *                         the new object: <code>addChild()</code>,
     *                         <code>addChildAt()</code>, and
     *                         <code>setChildIndex()</code>. </p>
     * @event render           [broadcast event] Dispatched when the display list
     *                         is about to be updated and rendered. This event
     *                         provides the last opportunity for objects listening
     *                         for this event to make changes before the display
     *                         list is rendered. You must call the
     *                         <code>invalidate()</code> method of the Scene
     *                         object each time you want a <code>render</code>
     *                         event to be dispatched. <code>Render</code> events
     *                         are dispatched to an object only if there is mutual
     *                         trust between it and the object that called
     *                         <code>Scene.invalidate()</code>. This event is a
     *                         broadcast event, which means that it is dispatched
     *                         by all display objects with a listener registered
     *                         for this event.
     *
     *                         <p><b>Note: </b>This event is not dispatched if the
     *                         display is not rendering. This is the case when the
     *                         content is either minimized or obscured. </p>
     */
    var DisplayObject = /** @class */ (function (_super) {
        __extends$3(DisplayObject, _super);
        /**
         * Creates a new <code>DisplayObject</code> instance.
         */
        function DisplayObject() {
            var _this = _super.call(this) || this;
            _this._queuedEvents = new Array();
            _this._concatenatedMatrix3D = new Matrix3D();
            _this._sessionID = -1;
            _this._depthID = -16384;
            _this._scenePosition = new Vector3D();
            _this._explicitVisibility = true;
            _this._explicitMaskId = -1;
            _this._implicitVisibility = true;
            _this._implicitMaskId = -1;
            _this._explicitMouseEnabled = true;
            _this._implicitMouseEnabled = true;
            _this._orientationMatrix = new Matrix3D();
            _this._inheritColorTransform = true;
            _this._maskMode = false;
            _this._renderMode = true;
            _this.isSlice9ScaledMC = false;
            _this.isSlice9ScaledSprite = false;
            _this.instanceID = "";
            _this.addedOnFrame = 0;
            _this.isAVMScene = false;
            // this is needed for AVM1 - todo: maybe do this on adapters ?
            _this.placeObjectTag = null;
            /**
             *
             */
            _this.alignmentMode = AlignmentMode.REGISTRATION_POINT;
            /**
             *
             */
            _this.castsShadows = true;
            /**
             *
             */
            _this.orientationMode = OrientationMode.DEFAULT;
            /**
             *
             */
            _this.zOffset = 0;
            _this.cursorType = "";
            _this._isInFocus = false;
            _this._tabEnabled = false;
            _this._tabIndex = -1;
            //global debug bounding boxes:
            //this._boundsVisible=true;
            _this._onInvalidatePropertiesDelegate = function (event) { return _this._onInvalidateProperties(event); };
            //creation of associated transform object
            _this._transform = new Transform(null, _this._concatenatedMatrix3D);
            //setup transform listeners
            _this._transform.addEventListener(TransformEvent.INVALIDATE_MATRIX3D, function (event) { return _this._onInvalidateMatrix3D(event); });
            _this._transform.addEventListener(TransformEvent.UPDATE_CONCATENATED_MATRIX3D, function (event) { return _this._onUpdateConcatenatedMatrix3D(event); });
            _this._transform.addEventListener(TransformEvent.INVALIDATE_COLOR_TRANSFORM, function (event) { return _this._onInvalidateColorTransform(event); });
            //bounding volume dictonary
            //default bounds type
            _this._defaultBoundingVolume = _this._getDefaultBoundingVolume();
            return _this;
        }
        DisplayObject.prototype.getScriptPrecedence = function () {
            if (!this._parent) {
                return [];
            }
            var result = this._parent.getScriptPrecedence();
            if (this.placeObjectTag) {
                result.push(this.placeObjectTag.actionBlocksPrecedence);
            }
            return result;
        };
        DisplayObject.prototype.dispatchFrameEvents = function (events) {
            this.dispatchEvent(events[0]); //ENTER_FRAME
            this.dispatchEvent(events[1]); //EXIT_FRAME
        };
        DisplayObject.prototype.dispatchEnterFrame = function (event) {
            this.dispatchEvent(event); //ENTER_FRAME
        };
        DisplayObject.prototype.dispatchExitFrame = function (event) {
            this.dispatchEvent(event); //Exit
        };
        DisplayObject.prototype.getMouseCursor = function () {
            return "initial";
        };
        Object.defineProperty(DisplayObject.prototype, "tabEnabled", {
            get: function () {
                return this._tabEnabled;
            },
            set: function (value) {
                this._tabEnabled = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "tabIndex", {
            get: function () {
                return this._tabIndex;
            },
            set: function (value) {
                this._tabIndex = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "isInFocus", {
            get: function () {
                return this._isInFocus;
            },
            set: function (value) {
                this._isInFocus = value;
            },
            enumerable: true,
            configurable: true
        });
        DisplayObject.prototype.setFocus = function (value, fromMouseDown, sendSoftKeyEvent) {
            if (fromMouseDown === void 0) { fromMouseDown = false; }
            if (sendSoftKeyEvent === void 0) { sendSoftKeyEvent = true; }
            if (this._isInFocus == value)
                return;
            this._isInFocus = value;
            if (this._isInFocus)
                DisplayObject.focusEvent.type = FocusEvent.FOCUS_IN;
            else
                DisplayObject.focusEvent.type = FocusEvent.FOCUS_OUT;
            this.dispatchEnterFrame(DisplayObject.focusEvent);
        };
        Object.defineProperty(DisplayObject.prototype, "inheritColorTransform", {
            get: function () {
                return this._inheritColorTransform;
            },
            set: function (value) {
                if (this._inheritColorTransform == value)
                    return;
                this._inheritColorTransform = value;
                this._invalidateHierarchicalProperties(HierarchicalProperties.COLOR_TRANSFORM);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "alpha", {
            /**
             * Indicates the alpha transparency value of the object specified. Valid
             * values are 0(fully transparent) to 1(fully opaque). The default value is
             * 1. Display objects with <code>alpha</code> set to 0 <i>are</i> active,
             * even though they are invisible.
             */
            get: function () {
                return this._transform.colorTransform.alphaMultiplier;
            },
            set: function (value) {
                this._transform.colorTransform.alphaMultiplier = value;
                this._transform.invalidateColorTransform();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "defaultBoundingVolume", {
            /**
             *
             */
            get: function () {
                return this._defaultBoundingVolume;
            },
            set: function (value) {
                if (this._defaultBoundingVolume == value)
                    return;
                this._defaultBoundingVolume = value;
                if (this._boundsPrimitive) {
                    this._boundsPrimitive.dispose();
                    this._boundsPrimitive = null;
                }
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "eulers", {
            /**
             * Defines the rotation of the 3d object as a <code>Vector3D</code> object containing euler angles for rotation around x, y and z axis.
             */
            get: function () {
                if (!this._eulers)
                    this._eulers = new Vector3D();
                this._eulers.x = this.rotationX;
                this._eulers.y = this.rotationY;
                this._eulers.z = this.rotationZ;
                return this._eulers;
            },
            set: function (value) {
                // previously this was using the setters for rotationX etc
                // but because this will convert from radians to degree, i changed it to update directly
                this._transform.rotation.x = value.x;
                this._transform.rotation.y = value.y;
                this._transform.rotation.z = value.z;
                this._transform.invalidateMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "index", {
            /**
             * An indexed array that contains each filter object currently associated
             * with the display object. The flash.filters package contains several
             * classes that define specific filters you can use.
             *
             * <p>Filters can be applied in Flash Professional at design time, or at run
             * time by using ActionScript code. To apply a filter by using ActionScript,
             * you must make a temporary copy of the entire <code>filters</code> array,
             * modify the temporary array, then assign the value of the temporary array
             * back to the <code>filters</code> array. You cannot directly add a new
             * filter object to the <code>filters</code> array.</p>
             *
             * <p>To add a filter by using ActionScript, perform the following steps
             * (assume that the target display object is named
             * <code>myDisplayObject</code>):</p>
             *
             * <ol>
             *   <li>Create a new filter object by using the constructor method of your
             * chosen filter class.</li>
             *   <li>Assign the value of the <code>myDisplayObject.filters</code> array
             * to a temporary array, such as one named <code>myFilters</code>.</li>
             *   <li>Add the new filter object to the <code>myFilters</code> temporary
             * array.</li>
             *   <li>Assign the value of the temporary array to the
             * <code>myDisplayObject.filters</code> array.</li>
             * </ol>
             *
             * <p>If the <code>filters</code> array is undefined, you do not need to use
             * a temporary array. Instead, you can directly assign an array literal that
             * contains one or more filter objects that you create. The first example in
             * the Examples section adds a drop shadow filter by using code that handles
             * both defined and undefined <code>filters</code> arrays.</p>
             *
             * <p>To modify an existing filter object, you must use the technique of
             * modifying a copy of the <code>filters</code> array:</p>
             *
             * <ol>
             *   <li>Assign the value of the <code>filters</code> array to a temporary
             * array, such as one named <code>myFilters</code>.</li>
             *   <li>Modify the property by using the temporary array,
             * <code>myFilters</code>. For example, to set the quality property of the
             * first filter in the array, you could use the following code:
             * <code>myFilters[0].quality = 1;</code></li>
             *   <li>Assign the value of the temporary array to the <code>filters</code>
             * array.</li>
             * </ol>
             *
             * <p>At load time, if a display object has an associated filter, it is
             * marked to cache itself as a transparent bitmap. From this point forward,
             * as long as the display object has a valid filter list, the player caches
             * the display object as a bitmap. This source bitmap is used as a source
             * image for the filter effects. Each display object usually has two bitmaps:
             * one with the original unfiltered source display object and another for the
             * final image after filtering. The final image is used when rendering. As
             * long as the display object does not change, the final image does not need
             * updating.</p>
             *
             * <p>The flash.filters package includes classes for filters. For example, to
             * create a DropShadow filter, you would write:</p>
             *
             * @throws ArgumentError When <code>filters</code> includes a ShaderFilter
             *                       and the shader output type is not compatible with
             *                       this operation(the shader must specify a
             *                       <code>pixel4</code> output).
             * @throws ArgumentError When <code>filters</code> includes a ShaderFilter
             *                       and the shader doesn't specify any image input or
             *                       the first input is not an <code>image4</code> input.
             * @throws ArgumentError When <code>filters</code> includes a ShaderFilter
             *                       and the shader specifies an image input that isn't
             *                       provided.
             * @throws ArgumentError When <code>filters</code> includes a ShaderFilter, a
             *                       ByteArray or Vector.<Number> instance as a shader
             *                       input, and the <code>width</code> and
             *                       <code>height</code> properties aren't specified for
             *                       the ShaderInput object, or the specified values
             *                       don't match the amount of data in the input data.
             *                       See the <code>ShaderInput.input</code> property for
             *                       more information.
             */
            //		public filters:Array<Dynamic>;
            /**
             * Indicates the instance container index of the DisplayObject. The object can be
             * identified in the child list of its parent display object container by
             * calling the <code>getChildByIndex()</code> method of the display object
             * container.
             *
             * <p>If the DisplayObject has no parent container, index defaults to 0.</p>
             */
            get: function () {
                if (this._parent)
                    return this._parent.getChildIndex(this);
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "isRenderable", {
            get: function () {
                return this._renderMode && this._iAssignedColorTransform()._isRenderable();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "loaderInfo", {
            /**
             * Returns a LoaderInfo object containing information about loading the file
             * to which this display object belongs. The <code>loaderInfo</code> property
             * is defined only for the root display object of a SWF file or for a loaded
             * Bitmap(not for a Bitmap that is drawn with ActionScript). To find the
             * <code>loaderInfo</code> object associated with the SWF file that contains
             * a display object named <code>myDisplayObject</code>, use
             * <code>myDisplayObject.root.loaderInfo</code>.
             *
             * <p>A large SWF file can monitor its download by calling
             * <code>this.root.loaderInfo.addEventListener(Event.COMPLETE,
             * func)</code>.</p>
             */
            get: function () {
                return this._loaderInfo;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "mask", {
            /**
             * The calling display object is masked by the specified <code>mask</code>
             * object. To ensure that masking works when the Stage is scaled, the
             * <code>mask</code> display object must be in an active part of the display
             * list. The <code>mask</code> object itself is not drawn. Set
             * <code>mask</code> to <code>null</code> to remove the mask.
             *
             * <p>To be able to scale a mask object, it must be on the display list. To
             * be able to drag a mask Sprite object(by calling its
             * <code>startDrag()</code> method), it must be on the display list. To call
             * the <code>startDrag()</code> method for a mask sprite based on a
             * <code>mouseDown</code> event being dispatched by the sprite, set the
             * sprite's <code>buttonMode</code> property to <code>true</code>.</p>
             *
             * <p>When display objects are cached by setting the
             * <code>cacheAsBitmap</code> property to <code>true</code> an the
             * <code>cacheAsBitmapMatrix</code> property to a Matrix object, both the
             * mask and the display object being masked must be part of the same cached
             * bitmap. Thus, if the display object is cached, then the mask must be a
             * child of the display object. If an ancestor of the display object on the
             * display list is cached, then the mask must be a child of that ancestor or
             * one of its descendents. If more than one ancestor of the masked object is
             * cached, then the mask must be a descendent of the cached container closest
             * to the masked object in the display list.</p>
             *
             * <p><b>Note:</b> A single <code>mask</code> object cannot be used to mask
             * more than one calling display object. When the <code>mask</code> is
             * assigned to a second display object, it is removed as the mask of the
             * first object, and that object's <code>mask</code> property becomes
             * <code>null</code>.</p>
             */
            set: function (value) {
                if (value) {
                    value.maskMode = true;
                }
                if (!this.masks)
                    this.masks = [];
                this.masks.push(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "maskMode", {
            get: function () {
                return this._maskMode;
            },
            set: function (value) {
                if (this._maskMode == value)
                    return;
                var parent;
                if (this._partition && (parent = this._partition.parent))
                    parent.removeChild(this._partition);
                if (this._implicitPartition)
                    this._implicitPartition.clearEntity(this);
                this._maskMode = value;
                if (this._partition && parent)
                    parent.addChild(this._partition);
                if (this._implicitPartition)
                    this._implicitPartition.invalidateEntity(this);
                this._explicitMaskId = value ? this.id : -1;
                this._updateMaskMode();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "pickObject", {
            get: function () {
                if (this._pickObject && this._pickObjectDirty)
                    this._updatePickObject();
                return this._pickObject;
            },
            set: function (value) {
                if (this._pickObject == value)
                    return;
                if (this._pickObject)
                    this._pickObject.partition = null;
                this._pickObject = value.clone();
                if (this._pickObject) {
                    this._pickObject.partition = new BasicPartition(this._pickObject);
                    this._pickObject.mouseChildren = false;
                    this._pickObject.mouseEnabled = false;
                    this._updatePickObject();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "mouseEnabled", {
            /**
             * Specifies whether this object receives mouse, or other user input,
             * messages. The default value is <code>true</code>, which means that by
             * default any InteractiveObject instance that is on the display list
             * receives mouse events or other user input events. If
             * <code>mouseEnabled</code> is set to <code>false</code>, the instance does
             * not receive any mouse events(or other user input events like keyboard
             * events). Any children of this instance on the display list are not
             * affected. To change the <code>mouseEnabled</code> behavior for all
             * children of an object on the display list, use
             * <code>flash.display.DisplayObjectContainer.mouseChildren</code>.
             *
             * <p> No event is dispatched by setting this property. You must use the
             * <code>addEventListener()</code> method to create interactive
             * functionality.</p>
             */
            get: function () {
                return this._explicitMouseEnabled;
            },
            set: function (value) {
                if (this._explicitMouseEnabled == value)
                    return;
                this._explicitMouseEnabled = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "mouseX", {
            /**
             * Indicates the x coordinate of the mouse or user input device position, in
             * pixels.
             *
             * <p><b>Note</b>: For a DisplayObject that has been rotated, the returned x
             * coordinate will reflect the non-rotated object.</p>
             */
            get: function () {
                return this._mouseX;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "mouseY", {
            /**
             * Indicates the y coordinate of the mouse or user input device position, in
             * pixels.
             *
             * <p><b>Note</b>: For a DisplayObject that has been rotated, the returned y
             * coordinate will reflect the non-rotated object.</p>
             */
            get: function () {
                return this._mouseY;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "name", {
            /**
             * Indicates the instance name of the DisplayObject. The object can be
             * identified in the child list of its parent display object container by
             * calling the <code>getChildByName()</code> method of the display object
             * container.
             *
             * @throws IllegalOperationError If you are attempting to set this property
             *                               on an object that was placed on the timeline
             *                               in the Flash authoring tool.
             */
            get: function () {
                return this._pName ? this._pName : "";
            },
            set: function (value) {
                this._pName = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "parent", {
            /**
             * Indicates the DisplayObjectContainer object that contains this display
             * object. Use the <code>parent</code> property to specify a relative path to
             * display objects that are above the current display object in the display
             * list hierarchy.
             *
             * <p>You can use <code>parent</code> to move up multiple levels in the
             * display list as in the following:</p>
             *
             * @throws SecurityError The parent display object belongs to a security
             *                       sandbox to which you do not have access. You can
             *                       avoid this situation by having the parent movie call
             *                       the <code>Security.allowDomain()</code> method.
             */
            get: function () {
                return this._parent;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "partition", {
            /**
             *
             */
            get: function () {
                return this._partition;
            },
            set: function (value) {
                if (this._partition == value)
                    return;
                if (this._partition && this._partition.parent)
                    this._partition.parent.removeChild(this._partition);
                this._partition = value;
                this._setPartition(this._parent ? this._parent._implicitPartition : null);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "registrationPoint", {
            /**
             * Defines the local point around which the object rotates.
             */
            get: function () {
                if (this._registrationMatrix3D)
                    return new Vector3D(-this._registrationMatrix3D._rawData[12] * this.scaleX, -this._registrationMatrix3D._rawData[13] * this.scaleY, -this._registrationMatrix3D._rawData[14] * this.scaleZ);
                return null;
            },
            set: function (value) {
                if (!value) {
                    if (!this._registrationMatrix3D)
                        return;
                    this._registrationMatrix3D._rawData[12] = 0;
                    this._registrationMatrix3D._rawData[13] = 0;
                    this._registrationMatrix3D._rawData[14] = 0;
                    if (this._registrationMatrix3D.isIdentity())
                        this._registrationMatrix3D = null;
                }
                else {
                    if (!this._registrationMatrix3D)
                        this._registrationMatrix3D = new Matrix3D();
                    this._registrationMatrix3D._rawData[12] = -value.x / this._transform.scale.x;
                    this._registrationMatrix3D._rawData[13] = -value.y / this._transform.scale.y;
                    this._registrationMatrix3D._rawData[14] = -value.z / this._transform.scale.z;
                }
                this._registrationMatrix3D.invalidatePosition();
                this._invalidateHierarchicalProperties(HierarchicalProperties.SCENE_TRANSFORM);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "registrationScale", {
            /**
             * Defines the local scale.
             */
            get: function () {
                if (this._registrationMatrix3D)
                    return new Vector3D(this._registrationMatrix3D._rawData[0], this._registrationMatrix3D._rawData[5], this._registrationMatrix3D._rawData[10]);
                return null;
            },
            set: function (value) {
                if (!value) {
                    if (!this._registrationMatrix3D)
                        return;
                    this._registrationMatrix3D._rawData[0] = 1;
                    this._registrationMatrix3D._rawData[5] = 1;
                    this._registrationMatrix3D._rawData[10] = 1;
                    if (this._registrationMatrix3D.isIdentity())
                        this._registrationMatrix3D = null;
                }
                else {
                    if (!this._registrationMatrix3D)
                        this._registrationMatrix3D = new Matrix3D();
                    this._registrationMatrix3D._rawData[0] = value.x;
                    this._registrationMatrix3D._rawData[5] = value.y;
                    this._registrationMatrix3D._rawData[10] = value.z;
                }
                this._invalidateHierarchicalProperties(HierarchicalProperties.SCENE_TRANSFORM);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "root", {
            /**
             * For a display object in a loaded SWF file, the <code>root</code> property
             * is the top-most display object in the portion of the display list's tree
             * structure represented by that SWF file. For a Bitmap object representing a
             * loaded image file, the <code>root</code> property is the Bitmap object
             * itself. For the instance of the main class of the first SWF file loaded,
             * the <code>root</code> property is the display object itself. The
             * <code>root</code> property of the Scene object is the Scene object itself.
             * The <code>root</code> property is set to <code>null</code> for any display
             * object that has not been added to the display list, unless it has been
             * added to a display object container that is off the display list but that
             * is a child of the top-most display object in a loaded SWF file.
             *
             * <p>For example, if you create a new Sprite object by calling the
             * <code>Sprite()</code> constructor method, its <code>root</code> property
             * is <code>null</code> until you add it to the display list(or to a display
             * object container that is off the display list but that is a child of the
             * top-most display object in a SWF file).</p>
             *
             * <p>For a loaded SWF file, even though the Loader object used to load the
             * file may not be on the display list, the top-most display object in the
             * SWF file has its <code>root</code> property set to itself. The Loader
             * object does not have its <code>root</code> property set until it is added
             * as a child of a display object for which the <code>root</code> property is
             * set.</p>
             */
            get: function () {
                return this._root;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "rotationX", {
            /**
             * Indicates the x-axis rotation of the DisplayObject instance, in degrees,
             * from its original orientation relative to the 3D parent container. Values
             * from 0 to 180 represent clockwise rotation; values from 0 to -180
             * represent counterclockwise rotation. Values outside this range are added
             * to or subtracted from 360 to obtain a value within the range.
             */
            get: function () {
                return this._transform.rotation.x * MathConsts.RADIANS_TO_DEGREES;
            },
            set: function (val) {
                if (this.rotationX == val)
                    return;
                this._transform.rotation.x = val * MathConsts.DEGREES_TO_RADIANS;
                this._transform.invalidateMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "rotationY", {
            /**
             * Indicates the y-axis rotation of the DisplayObject instance, in degrees,
             * from its original orientation relative to the 3D parent container. Values
             * from 0 to 180 represent clockwise rotation; values from 0 to -180
             * represent counterclockwise rotation. Values outside this range are added
             * to or subtracted from 360 to obtain a value within the range.
             */
            get: function () {
                return this._transform.rotation.y * MathConsts.RADIANS_TO_DEGREES;
            },
            set: function (val) {
                if (this.rotationY == val)
                    return;
                this._transform.rotation.y = val * MathConsts.DEGREES_TO_RADIANS;
                this._transform.invalidateMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "rotationZ", {
            /**
             * Indicates the z-axis rotation of the DisplayObject instance, in degrees,
             * from its original orientation relative to the 3D parent container. Values
             * from 0 to 180 represent clockwise rotation; values from 0 to -180
             * represent counterclockwise rotation. Values outside this range are added
             * to or subtracted from 360 to obtain a value within the range.
             */
            get: function () {
                return this._transform.rotation.z * MathConsts.RADIANS_TO_DEGREES;
            },
            set: function (val) {
                if (this.rotationZ == val)
                    return;
                this._transform.rotation.z = val * MathConsts.DEGREES_TO_RADIANS;
                this._transform.invalidateMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "scaleX", {
            /**
             * Indicates the horizontal scale(percentage) of the object as applied from
             * the registration point. The default registration point is(0,0). 1.0
             * equals 100% scale.
             *
             * <p>Scaling the local coordinate system changes the <code>x</code> and
             * <code>y</code> property values, which are defined in whole pixels. </p>
             */
            get: function () {
                return this._transform.scale.x;
            },
            set: function (val) {
                //this._updateAbsoluteDimension();
                this._setScaleX(val);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "scaleY", {
            /**
             * Indicates the vertical scale(percentage) of an object as applied from the
             * registration point of the object. The default registration point is(0,0).
             * 1.0 is 100% scale.
             *
             * <p>Scaling the local coordinate system changes the <code>x</code> and
             * <code>y</code> property values, which are defined in whole pixels. </p>
             */
            get: function () {
                return this._transform.scale.y;
            },
            set: function (val) {
                //this._updateAbsoluteDimension();
                this._setScaleY(val);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "scaleZ", {
            /**
             * Indicates the depth scale(percentage) of an object as applied from the
             * registration point of the object. The default registration point is(0,0).
             * 1.0 is 100% scale.
             *
             * <p>Scaling the local coordinate system changes the <code>x</code>,
             * <code>y</code> and <code>z</code> property values, which are defined in
             * whole pixels. </p>
             */
            get: function () {
                return this._transform.scale.z;
            },
            set: function (val) {
                //this._updateAbsoluteDimension();
                this._setScaleZ(val);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "skewX", {
            /**
             * Indicates the horizontal skew(angle) of the object as applied from
             * the registration point. The default registration point is(0,0).
             */
            get: function () {
                return this._transform.skew.x;
            },
            set: function (val) {
                if (this.skewX == val)
                    return;
                this._transform.skew.x = val;
                this._transform.invalidateMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "skewY", {
            /**
             * Indicates the vertical skew(angle) of an object as applied from the
             * registration point of the object. The default registration point is(0,0).
             */
            get: function () {
                return this._transform.skew.y;
            },
            set: function (val) {
                if (this.skewY == val)
                    return;
                this._transform.skew.y = val;
                this._transform.invalidateMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "skewZ", {
            /**
             * Indicates the depth skew(angle) of an object as applied from the
             * registration point of the object. The default registration point is(0,0).
             */
            get: function () {
                return this._transform.skew.z;
            },
            set: function (val) {
                if (this.skewZ == val)
                    return;
                this._transform.skew.z = val;
                this._transform.invalidateMatrix3D();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "scenePosition", {
            /**
             *
             */
            get: function () {
                if (this._scenePositionDirty) {
                    if (this._registrationMatrix3D && this.alignmentMode == AlignmentMode.REGISTRATION_POINT) {
                        this._scenePosition.x = -this._registrationMatrix3D._rawData[12];
                        this._scenePosition.y = -this._registrationMatrix3D._rawData[13];
                        this._scenePosition.z = -this._registrationMatrix3D._rawData[14];
                        this._scenePosition = this._transform.concatenatedMatrix3D.transformVector(this._scenePosition, this._scenePosition);
                        //this._scenePosition.decrementBy(new Vector3D(this._registrationPoint.x*this._scaleX, this._registrationPoint.y*this._scaleY, this._registrationPoint.z*this._scaleZ));
                    }
                    else {
                        this._transform.concatenatedMatrix3D.copyColumnTo(3, this._scenePosition);
                    }
                    this._scenePositionDirty = false;
                }
                return this._scenePosition;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "animator", {
            /**
             * Defines the animator of the display object.  Default value is <code>null</code>.
             */
            get: function () {
                return this._animator;
            },
            set: function (value) {
                if (this._animator)
                    this._animator.removeOwner(this);
                this._animator = value;
                if (this._animator)
                    this._animator.addOwner(this);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "material", {
            /**
             *
             */
            get: function () {
                return this._material;
            },
            set: function (value) {
                if (this._material == value)
                    return;
                this._material = value;
                this._invalidateMaterial();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "style", {
            /**
             *
             */
            get: function () {
                return this._style;
            },
            set: function (value) {
                if (this._style == value)
                    return;
                if (this._style)
                    this._style.removeEventListener(StyleEvent.INVALIDATE_PROPERTIES, this._onInvalidatePropertiesDelegate);
                this._style = value;
                if (this._style)
                    this._style.addEventListener(StyleEvent.INVALIDATE_PROPERTIES, this._onInvalidatePropertiesDelegate);
                this._invalidateStyle();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "boundsVisible", {
            /**
             *
             */
            get: function () {
                return this._boundsVisible;
            },
            set: function (value) {
                if (value == this._boundsVisible)
                    return;
                this._boundsVisible = value;
                if (this._boundsVisible && !this.partition)
                    this.partition = new BasicPartition(this);
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        DisplayObject.prototype.getBoundsPrimitive = function (pickGroup) {
            if (this._boundsPrimitive == null) {
                switch (this._defaultBoundingVolume) {
                    case BoundingVolumeType.BOX:
                    case BoundingVolumeType.BOX_BOUNDS:
                    case BoundingVolumeType.BOX_BOUNDS_FAST:
                    case BoundingVolumeType.BOX_FAST:
                        this._boundsPrefab = new PrimitiveCubePrefab(null, ElementsType.LINE);
                        this._boundsPrimitive = this._boundsPrefab.getNewObject();
                        break;
                    case BoundingVolumeType.SPHERE:
                    case BoundingVolumeType.SPHERE_BOUNDS:
                    case BoundingVolumeType.SPHERE_BOUNDS_FAST:
                    case BoundingVolumeType.SPHERE_FAST:
                        this._boundsPrefab = new PrimitiveSpherePrefab(null, ElementsType.LINE);
                        this._boundsPrimitive = this._boundsPrefab.getNewObject();
                        break;
                    default:
                }
                this._boundsPrefabDirty = true;
                this._boundsPrimitiveDirty = true;
            }
            if (this._boundsPrefabDirty)
                this._updateBoundsPrefab(pickGroup);
            if (this._boundsPrimitiveDirty)
                this._updateBoundsPrimitive();
            return this._boundsPrimitive;
        };
        Object.defineProperty(DisplayObject.prototype, "transform", {
            /**
             * An object with properties pertaining to a display object's matrix, color
             * transform, and pixel bounds. The specific properties  -  matrix,
             * colorTransform, and three read-only properties
             * (<code>concatenatedMatrix</code>, <code>concatenatedColorTransform</code>,
             * and <code>pixelBounds</code>)  -  are described in the entry for the
             * Transform class.
             *
             * <p>Each of the transform object's properties is itself an object. This
             * concept is important because the only way to set new values for the matrix
             * or colorTransform objects is to create a new object and copy that object
             * into the transform.matrix or transform.colorTransform property.</p>
             *
             * <p>For example, to increase the <code>tx</code> value of a display
             * object's matrix, you must make a copy of the entire matrix object, then
             * copy the new object into the matrix property of the transform object:</p>
             * <pre xml:space="preserve"><code> public myMatrix:Matrix =
             * myDisplayObject.transform.matrix; myMatrix.tx += 10;
             * myDisplayObject.transform.matrix = myMatrix; </code></pre>
             *
             * <p>You cannot directly set the <code>tx</code> property. The following
             * code has no effect on <code>myDisplayObject</code>: </p>
             * <pre xml:space="preserve"><code> myDisplayObject.transform.matrix.tx +=
             * 10; </code></pre>
             *
             * <p>You can also copy an entire transform object and assign it to another
             * display object's transform property. For example, the following code
             * copies the entire transform object from <code>myOldDisplayObj</code> to
             * <code>myNewDisplayObj</code>:</p>
             * <code>myNewDisplayObj.transform = myOldDisplayObj.transform;</code>
             *
             * <p>The resulting display object, <code>myNewDisplayObj</code>, now has the
             * same values for its matrix, color transform, and pixel bounds as the old
             * display object, <code>myOldDisplayObj</code>.</p>
             *
             * <p>Note that AIR for TV devices use hardware acceleration, if it is
             * available, for color transforms.</p>
             */
            get: function () {
                return this._transform;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "visible", {
            /**
             * Whether or not the display object is visible. Display objects that are not
             * visible are disabled. For example, if <code>visible=false</code> for an
             * InteractiveObject instance, it cannot be clicked.
             */
            get: function () {
                return this._explicitVisibility;
            },
            set: function (value) {
                if (this._explicitVisibility == value)
                    return;
                this._explicitVisibility = value;
                this._invalidateHierarchicalProperties(HierarchicalProperties.VISIBLE);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "masks", {
            get: function () {
                return this._explicitMasks;
            },
            set: function (value) {
                if (this._explicitMasks == value)
                    return;
                this._explicitMasks = value;
                //make sure maskMode is set to true for all masks
                if (value != null && value.length) {
                    var len = value.length;
                    for (var i = 0; i < len; i++)
                        value[i].maskMode = true;
                }
                this._invalidateHierarchicalProperties(HierarchicalProperties.MASKS);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "x", {
            /**
             * Indicates the <i>x</i> coordinate of the DisplayObject instance relative
             * to the local coordinates of the parent DisplayObjectContainer. If the
             * object is inside a DisplayObjectContainer that has transformations, it is
             * in the local coordinate system of the enclosing DisplayObjectContainer.
             * Thus, for a DisplayObjectContainer rotated 90° counterclockwise, the
             * DisplayObjectContainer's children inherit a coordinate system that is
             * rotated 90° counterclockwise. The object's coordinates refer to the
             * registration point position.
             */
            get: function () {
                return this._transform.position.x;
            },
            set: function (val) {
                if (this._transform.position.x == val)
                    return;
                this._transform.matrix3D._rawData[12] = val;
                this._transform.invalidatePosition();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "y", {
            /**
             * Indicates the <i>y</i> coordinate of the DisplayObject instance relative
             * to the local coordinates of the parent DisplayObjectContainer. If the
             * object is inside a DisplayObjectContainer that has transformations, it is
             * in the local coordinate system of the enclosing DisplayObjectContainer.
             * Thus, for a DisplayObjectContainer rotated 90° counterclockwise, the
             * DisplayObjectContainer's children inherit a coordinate system that is
             * rotated 90° counterclockwise. The object's coordinates refer to the
             * registration point position.
             */
            get: function () {
                return this._transform.position.y;
            },
            set: function (val) {
                if (this._transform.position.y == val)
                    return;
                this._transform.matrix3D._rawData[13] = val;
                this._transform.invalidatePosition();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "z", {
            /**
             * Indicates the z coordinate position along the z-axis of the DisplayObject
             * instance relative to the 3D parent container. The z property is used for
             * 3D coordinates, not screen or pixel coordinates.
             *
             * <p>When you set a <code>z</code> property for a display object to
             * something other than the default value of <code>0</code>, a corresponding
             * Matrix3D object is automatically created. for adjusting a display object's
             * position and orientation in three dimensions. When working with the
             * z-axis, the existing behavior of x and y properties changes from screen or
             * pixel coordinates to positions relative to the 3D parent container.</p>
             *
             * <p>For example, a child of the <code>_root</code> at position x = 100, y =
             * 100, z = 200 is not drawn at pixel location(100,100). The child is drawn
             * wherever the 3D projection calculation puts it. The calculation is:</p>
             *
             * <p><code>(x~~cameraFocalLength/cameraRelativeZPosition,
             * y~~cameraFocalLength/cameraRelativeZPosition)</code></p>
             */
            get: function () {
                return this._transform.position.z;
            },
            set: function (val) {
                if (this._transform.position.z == val)
                    return;
                this._transform.matrix3D._rawData[14] = val;
                this._transform.invalidatePosition();
            },
            enumerable: true,
            configurable: true
        });
        DisplayObject.prototype.isEntity = function () {
            return false;
        };
        /**
         *
         */
        DisplayObject.prototype.addEventListener = function (type, listener) {
            _super.prototype.addEventListener.call(this, type, listener);
            switch (type) {
                case DisplayObjectEvent.SCENETRANSFORM_CHANGED:
                    this._listenToSceneTransformChanged = true;
                    break;
            }
        };
        /**
         *
         */
        DisplayObject.prototype.clone = function () {
            var newInstance = new DisplayObject();
            this.copyTo(newInstance);
            return newInstance;
        };
        DisplayObject.prototype.copyTo = function (displayObject) {
            displayObject.defaultBoundingVolume = this._defaultBoundingVolume;
            if (this._registrationMatrix3D)
                displayObject._registrationMatrix3D = this._registrationMatrix3D.clone();
            displayObject.material = this._material;
            displayObject.style = this._style;
            displayObject.pickObject = this._pickObject;
            displayObject.boundsVisible = this._boundsVisible;
            displayObject.name = this._pName;
            displayObject.mouseEnabled = this._explicitMouseEnabled;
            displayObject.extra = this.extra;
            displayObject.maskMode = this._maskMode;
            displayObject.castsShadows = this.castsShadows;
            displayObject.isSlice9ScaledMC = this.isSlice9ScaledMC;
            displayObject.assetNamespace = this.assetNamespace;
            displayObject._symbol = this._symbol;
            displayObject.avm1Symbol = this.avm1Symbol;
            if (this._explicitMasks)
                displayObject.masks = this._explicitMasks;
            if (this._animator)
                displayObject.animator = this._animator.clone();
            this._transform.copyRawDataTo(displayObject._transform);
        };
        /**
         *
         */
        DisplayObject.prototype.dispose = function () {
            this.disposeValues();
        };
        DisplayObject.prototype.disposeValues = function () {
            if (this._parent)
                this._parent.removeChild(this);
            this.material = null;
            if (this._animator)
                this._animator.dispose();
            if (this._adapter) {
                this._adapter.dispose();
                this._adapter = null;
            }
            this._pickObject = null;
            //this._pos = null;
            //this._rot = null;
            //this._sca = null;
            //this._ske = null;
            //this._transformComponents = null;
            //this._transform.dispose();
            //this._transform = null;
            //
            //this._matrix3D = null;
            //this._concatenatedMatrix3D = null;
            //this._inverseSceneTransform = null;
            this._explicitMasks = null;
            // if (this._partition) {
            // 	this._partition.dispose();
            // 	this._partition = null;
            // }
        };
        /**
         * Rotates the 3d object around to face a point defined relative to the local coordinates of the parent <code>ObjectContainer3D</code>.
         *
         * @param    target        The vector defining the point to be looked at
         * @param    upAxis        An optional vector used to define the desired up orientation of the 3d object after rotation has occurred
         */
        DisplayObject.prototype.lookAt = function (scenePosition, upAxis) {
            if (upAxis === void 0) { upAxis = null; }
            this.transform.lookAt(scenePosition, upAxis);
        };
        /**
         * Converts a three-dimensional point of the three-dimensional display
         * object's(local) coordinates to a three-dimensional point in the Scene
         * (global) coordinates.
         *
         * <p>This method allows you to convert any given <i>x</i>, <i>y</i> and
         * <i>z</i> coordinates from values that are relative to the origin(0,0,0) of
         * a specific display object(local coordinates) to values that are relative to
         * the origin of the Scene(global coordinates).</p>
         *
         * <p>To use this method, first create an instance of the Point class. The
         * <i>x</i> and <i>y</i> values that you assign represent local coordinates
         * because they relate to the origin of the display object.</p>
         *
         * <p>You then pass the Vector3D instance that you created as the parameter to
         * the <code>localToGlobal3D()</code> method. The method returns a new
         * Vector3D object with <i>x</i>, <i>y</i> and <i>z</i> values that relate to
         * the origin of the Scene instead of the origin of the display object.</p>
         *
         * @param position A Vector3D object containing either a three-dimensional
         *                position or the coordinates of the three-dimensional
         *                display object.
         * @return A Vector3D object representing a three-dimensional position in
         *         the Scene.
         */
        DisplayObject.prototype.localToGlobal3D = function (position) {
            return this._transform.concatenatedMatrix3D.transformVector(position);
        };
        /**
         * Moves the local point around which the object rotates.
         *
         * @param    dx        The amount of movement along the local x axis.
         * @param    dy        The amount of movement along the local y axis.
         * @param    dz        The amount of movement along the local z axis.
         */
        DisplayObject.prototype.movePivot = function (dx, dy, dz) {
            if (dx == 0 && dy == 0 && dz == 0)
                return;
            if (!this._registrationMatrix3D)
                this._registrationMatrix3D = new Matrix3D();
            this._registrationMatrix3D._rawData[12] -= dx / this._transform.scale.x;
            this._registrationMatrix3D._rawData[13] -= dy / this._transform.scale.y;
            this._registrationMatrix3D._rawData[14] -= dz / this._transform.scale.z;
            this._invalidateHierarchicalProperties(HierarchicalProperties.SCENE_TRANSFORM);
        };
        DisplayObject.prototype.reset = function () {
            this.visible = true;
            if (!this.noTimelineUpdate)
                this._transform.clearMatrix3D();
            this._transform.clearColorTransform();
            //this.name="";
            this.masks = null;
            this.maskMode = false;
        };
        /**
         *
         */
        DisplayObject.prototype.getRenderSceneTransform = function (cameraTransform) {
            if (this.orientationMode == OrientationMode.CAMERA_PLANE) {
                var comps = cameraTransform.decompose();
                comps[0].copyFrom(this.scenePosition);
                comps[3].copyFrom(this._transform.scale);
                this._orientationMatrix.recompose(comps);
                //add in case of registration point
                if (this._registrationMatrix3D) {
                    this._orientationMatrix.prepend(this._registrationMatrix3D);
                    if (this.alignmentMode != AlignmentMode.REGISTRATION_POINT)
                        this._orientationMatrix.appendTranslation(-this._registrationMatrix3D._rawData[12] * this._transform.scale.x, -this._registrationMatrix3D._rawData[13] * this._transform.scale.y, -this._registrationMatrix3D._rawData[14] * this._transform.scale.z);
                }
                return this._orientationMatrix;
            }
            return this._transform.concatenatedMatrix3D;
        };
        /**
         *
         */
        DisplayObject.prototype.removeEventListener = function (type, listener) {
            _super.prototype.removeEventListener.call(this, type, listener);
            if (this.hasEventListener(type))
                return;
            switch (type) {
                case DisplayObjectEvent.SCENETRANSFORM_CHANGED:
                    this._listenToSceneTransformChanged = true;
                    break;
            }
        };
        /**
         * @internal
         */
        DisplayObject.prototype._setParent = function (parent) {
            // if (!parent && this._partition) //if there is a new parent, the addChild(partition) will remove from the previous partition
            // 	this._parent._implicitPartition.removeChild(this._partition);
            if (this._partition) {
                if (!parent && (this._parent && this._parent._implicitPartition)) { //if there is a new parent, the addChild(partition) will remove from the previous partition
                    this._parent._implicitPartition.removeChild(this._partition);
                    this.clear();
                }
                else if (this._implicitPartition && this._implicitPartition == this._partition && this.isEntity()) {
                    this._implicitPartition.invalidateEntity(this);
                }
            }
            this._parent = parent;
            this._setPartition((parent && parent._implicitPartition) ? parent._implicitPartition : null);
            this._invalidateHierarchicalProperties(HierarchicalProperties.ALL);
        };
        DisplayObject.prototype._invalidateHierarchicalProperties = function (propDirty) {
            var newPropDirty = (this._hierarchicalPropsDirty ^ propDirty) & propDirty;
            if (!newPropDirty)
                return true;
            this._hierarchicalPropsDirty |= propDirty;
            if (newPropDirty & HierarchicalProperties.SCENE_TRANSFORM) {
                this.transform.invalidateConcatenatedMatrix3D();
                this._scenePositionDirty = true;
                this._boundsPrimitiveDirty = true;
                this._pickObjectDirty = true;
                if (this._implicitPartition && this.isEntity())
                    this._implicitPartition.invalidateEntity(this);
                if (this._listenToSceneTransformChanged)
                    this.queueDispatch(this._sceneTransformChanged || (this._sceneTransformChanged = new DisplayObjectEvent(DisplayObjectEvent.SCENETRANSFORM_CHANGED, this)));
            }
            return false;
        };
        /**
         * @protected
         */
        DisplayObject.prototype._setPartition = function (parentPartition) {
            if (parentPartition && this._partition == null)
                this._partition = parentPartition.getPartition(this) || this._partition;
            //add partition as a child of parentPartition
            if (this._partition && parentPartition)
                parentPartition.addChild(this._partition);
            // assign parent partition if _partition is null
            var partition = this._partition || parentPartition;
            if (this._implicitPartition == partition)
                return true;
            //gc any old abstraction objects
            if (this._implicitPartition)
                this.clear();
            this._implicitPartition = partition;
            //register entity with new partition
            if (this._implicitPartition && this.isEntity())
                this._implicitPartition.invalidateEntity(this);
            this.dispatchEvent(new DisplayObjectEvent(DisplayObjectEvent.PARTITION_CHANGED, this));
            return false;
        };
        /**
         * @protected
         */
        DisplayObject.prototype._onUpdateConcatenatedMatrix3D = function (event) {
            // call getBoxBounds() if absolute size need to update transform
            // if (this._absoluteDimension) {
            // 	var box:Box = this.getBoxBounds();
            // 	if(box){
            // 		if (this._width != null)
            // 			this._setScaleX(this._width/box.width);
            // 		if (this._height != null)
            // 			this._setScaleY(this._height/box.height);
            // 		if (this._depth != null)
            // 			this._setScaleZ(this._depth/box.depth);
            // 	}
            // }
            this._concatenatedMatrix3D.copyFrom(this._transform.matrix3D);
            if (this._registrationMatrix3D) {
                this._concatenatedMatrix3D.prepend(this._registrationMatrix3D);
                if (this.alignmentMode != AlignmentMode.REGISTRATION_POINT)
                    this._concatenatedMatrix3D.appendTranslation(-this._registrationMatrix3D._rawData[12] * this._transform.scale.x, -this._registrationMatrix3D._rawData[13] * this._transform.scale.y, -this._registrationMatrix3D._rawData[14] * this._transform.scale.z);
            }
            if (this._parent)
                this._concatenatedMatrix3D.append(this._parent._transform.concatenatedMatrix3D);
            this._matrix3DDirty = false;
            this._hierarchicalPropsDirty ^= HierarchicalProperties.SCENE_TRANSFORM;
            if (this._iController)
                this._iController.updateController();
        };
        /**
         *
         */
        DisplayObject.prototype._iInternalUpdate = function () {
            if (this._iController)
                this._iController.update();
            // Dispatch all queued events.
            var len = this._queuedEvents.length;
            for (var i = 0; i < len; ++i)
                this.dispatchEvent(this._queuedEvents[i]);
            this._queuedEvents.length = 0;
        };
        /**
         * @internal
         */
        DisplayObject.prototype._iIsVisible = function () {
            if (this._hierarchicalPropsDirty & HierarchicalProperties.VISIBLE)
                this._updateVisible();
            return this._implicitVisibility;
        };
        Object.defineProperty(DisplayObject.prototype, "maskId", {
            /**
             * @internal
             */
            get: function () {
                if (this._hierarchicalPropsDirty & HierarchicalProperties.MASK_ID)
                    this._updateMaskId();
                return this._implicitMaskId;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject.prototype, "maskOwners", {
            /**
             * @internal
             */
            get: function () {
                if (this._hierarchicalPropsDirty & HierarchicalProperties.MASKS)
                    this._updateMaskOwners();
                return this._maskOwners;
            },
            enumerable: true,
            configurable: true
        });
        DisplayObject.prototype._iAssignedColorTransform = function () {
            if (this._hierarchicalPropsDirty & HierarchicalProperties.COLOR_TRANSFORM)
                this._updateColorTransform();
            return this._pImplicitColorTransform || (this._pImplicitColorTransform = new ColorTransform());
        };
        DisplayObject.prototype._startDrag = function () {
            this._isDragEntity = true;
        };
        DisplayObject.prototype._stopDrag = function () {
            this._isDragEntity = false;
        };
        DisplayObject.prototype.isDragEntity = function () {
            return this._isDragEntity;
        };
        /**
         * @internal
         */
        DisplayObject.prototype._iIsMouseEnabled = function () {
            if (this._hierarchicalPropsDirty & HierarchicalProperties.MOUSE_ENABLED)
                this._updateMouseEnabled();
            return this._implicitMouseEnabled && this._explicitMouseEnabled;
        };
        DisplayObject.prototype.isDescendant = function (displayObject) {
            var parent = this;
            while (parent.parent) {
                parent = parent.parent;
                if (parent == displayObject)
                    return true;
            }
            return false;
        };
        DisplayObject.prototype.isAncestor = function (displayObject) {
            return displayObject.isDescendant(this);
        };
        DisplayObject.prototype._acceptTraverser = function (traverser) {
            //nothing to do here
        };
        /**
         * Invalidates the 3D transformation matrix, causing it to be updated upon the next request
         *
         * @private
         */
        DisplayObject.prototype._onInvalidateMatrix3D = function (event) {
            if (this._matrix3DDirty)
                return;
            this._matrix3DDirty = true;
            this._invalidateHierarchicalProperties(HierarchicalProperties.SCENE_TRANSFORM);
        };
        /**
         * @private
         */
        DisplayObject.prototype._onInvalidateColorTransform = function (event) {
            this._invalidateHierarchicalProperties(HierarchicalProperties.COLOR_TRANSFORM);
        };
        DisplayObject.prototype.queueDispatch = function (event) {
            // Store event to be dispatched later.
            this._queuedEvents.push(event);
        };
        DisplayObject.prototype._setScaleX = function (val) {
            if (this.scaleX == val)
                return;
            this._transform.scale.x = val;
            this._transform.invalidateMatrix3D();
        };
        DisplayObject.prototype._setScaleY = function (val) {
            if (this.scaleY == val)
                return;
            this._transform.scale.y = val;
            this._transform.invalidateMatrix3D();
        };
        DisplayObject.prototype._setScaleZ = function (val) {
            if (this.scaleZ == val)
                return;
            this._transform.scale.z = val;
            this._transform.invalidateMatrix3D();
        };
        DisplayObject.prototype._updateMouseEnabled = function () {
            this._implicitMouseEnabled = (this._parent) ? this._parent.mouseChildren && this._parent._implicitMouseEnabled : true;
            this._hierarchicalPropsDirty ^= HierarchicalProperties.MOUSE_ENABLED;
        };
        DisplayObject.prototype._updateVisible = function () {
            this._implicitVisibility = (this._parent) ? this._explicitVisibility && this._parent._iIsVisible() : this._explicitVisibility;
            this._hierarchicalPropsDirty ^= HierarchicalProperties.VISIBLE;
        };
        DisplayObject.prototype._updateMaskId = function () {
            this._implicitMaskId = (this._explicitMaskId != -1) ? this._explicitMaskId : (this._parent && this._parent.maskId != -1) ? this._parent.maskId : -1;
            this._hierarchicalPropsDirty ^= HierarchicalProperties.MASK_ID;
        };
        DisplayObject.prototype._updateMaskOwners = function () {
            this._maskOwners = (this._parent && this._parent.maskOwners && this.maskId == -1) ? this._explicitMasks ? this._parent.maskOwners.concat([this]) : this._parent.maskOwners.concat() : (this._explicitMasks != null) ? [this] : null;
            this._hierarchicalPropsDirty ^= HierarchicalProperties.MASKS;
        };
        DisplayObject.prototype._updateColorTransform = function () {
            if (!this._pImplicitColorTransform)
                this._pImplicitColorTransform = new ColorTransform();
            if (this._inheritColorTransform && this._parent && this._parent._iAssignedColorTransform()) {
                this._pImplicitColorTransform.copyFrom(this._parent._iAssignedColorTransform());
                this._pImplicitColorTransform.prepend(this._transform.colorTransform);
            }
            else {
                this._pImplicitColorTransform.copyFrom(this._transform.colorTransform);
            }
            this._hierarchicalPropsDirty ^= HierarchicalProperties.COLOR_TRANSFORM;
        };
        DisplayObject.prototype._updateBoundsPrefab = function (pickGroup) {
            if (this._boundsPrefab instanceof PrimitiveCubePrefab) {
                var box = pickGroup.getBoundsPicker(this.partition).getBoundingVolume(null, this._defaultBoundingVolume).getBox();
                //TODO: if box is null, no prefab should be visible
                if (box == null)
                    return;
                this._boundsPrefab.width = box.width;
                this._boundsPrefab.height = box.height;
                this._boundsPrefab.depth = box.depth;
                this._boundsPrimitive.registrationPoint = new Vector3D(-(box.x + box.width / 2) * this._boundsPrimitive.transform.scale.x, -(box.y + box.height / 2) * this._boundsPrimitive.transform.scale.y, -(box.z + box.depth / 2) * this._boundsPrimitive.transform.scale.z);
            }
            else if (this._boundsPrefab instanceof PrimitiveSpherePrefab) {
                var sphere = pickGroup.getBoundsPicker(this.partition).getBoundingVolume(null, this._defaultBoundingVolume).getSphere();
                console.log(sphere);
                if (sphere == null)
                    return;
                this._boundsPrefab.radius = sphere.radius;
                this._boundsPrimitive.registrationPoint = new Vector3D(-sphere.x * this._boundsPrimitive.transform.scale.x, -sphere.y * this._boundsPrimitive.transform.scale.y, -sphere.z * this._boundsPrimitive.transform.scale.z);
            }
        };
        DisplayObject.prototype._updatePickObject = function () {
            this._pickObject.transform.matrix3D = this.transform.concatenatedMatrix3D;
        };
        DisplayObject.prototype._updateBoundsPrimitive = function () {
            this._boundsPrimitiveDirty = false;
            this._boundsPrimitive.transform.matrix3D = this.transform.concatenatedMatrix3D;
        };
        DisplayObject.prototype._updateMaskMode = function () {
            if (this.maskMode)
                this.mouseEnabled = false;
            this._invalidateHierarchicalProperties(HierarchicalProperties.MASK_ID);
        };
        DisplayObject.prototype.invalidate = function () {
            _super.prototype.invalidate.call(this);
            if (this._implicitPartition && this.isEntity())
                this._implicitPartition.invalidateEntity(this);
        };
        DisplayObject.prototype.clear = function () {
            _super.prototype.clear.call(this);
            this._pImplicitColorTransform = null;
            this._maskOwners = null;
        };
        DisplayObject.prototype._invalidateMaterial = function () {
            this.dispatchEvent(new RenderableEvent(RenderableEvent.INVALIDATE_MATERIAL, this));
        };
        DisplayObject.prototype._invalidateStyle = function () {
            this.dispatchEvent(new RenderableEvent(RenderableEvent.INVALIDATE_STYLE, this));
        };
        DisplayObject.prototype.invalidateElements = function () {
            this.dispatchEvent(new RenderableEvent(RenderableEvent.INVALIDATE_ELEMENTS, this));
        };
        DisplayObject.prototype._onInvalidateProperties = function (event) {
            if (event === void 0) { event = null; }
            this._invalidateStyle();
        };
        DisplayObject.prototype._getDefaultBoundingVolume = function () {
            return BoundingVolumeType.BOX_BOUNDS_FAST;
        };
        DisplayObject.focusEvent = new FocusEvent(FocusEvent.FOCUS_IN);
        return DisplayObject;
    }(AssetBase));

    //import {Sprite} from "./Sprite";
    /**
     * The DisplayObjectContainer class is the base class for all objects that can
     * serve as display object containers on the display list. The display list
     * manages all objects displayed in the Flash runtimes. Use the
     * DisplayObjectContainer class to arrange the display objects in the display
     * list. Each DisplayObjectContainer object has its own child list for
     * organizing the z-order of the objects. The z-order is the front-to-back
     * order that determines which object is drawn in front, which is behind, and
     * so on.
     *
     * <p>DisplayObject is an abstract base class; therefore, you cannot call
     * DisplayObject directly. Invoking <code>new DisplayObject()</code> throws an
     * <code>ArgumentError</code> exception.</p>
     * The DisplayObjectContainer class is an abstract base class for all objects
     * that can contain child objects. It cannot be instantiated directly; calling
     * the <code>new DisplayObjectContainer()</code> constructor throws an
     * <code>ArgumentError</code> exception.
     *
     * <p>For more information, see the "Display Programming" chapter of the
     * <i>ActionScript 3.0 Developer's Guide</i>.</p>
     */
    var DisplayObjectContainer = /** @class */ (function (_super) {
        __extends$3(DisplayObjectContainer, _super);
        /**
         * Calling the <code>new DisplayObjectContainer()</code> constructor throws
         * an <code>ArgumentError</code> exception. You <i>can</i>, however, call
         * constructors for the following subclasses of DisplayObjectContainer:
         * <ul>
         *   <li><code>new Loader()</code></li>
         *   <li><code>new Sprite()</code></li>
         *   <li><code>new MovieClip()</code></li>
         * </ul>
         */
        function DisplayObjectContainer() {
            var _this = _super.call(this) || this;
            _this._mouseChildren = true;
            _this._depth_childs = {};
            _this._nextHighestDepth = 0;
            _this._children = new Array();
            _this.doingSwap = false;
            _this.tabChildren = false;
            return _this;
        }
        Object.defineProperty(DisplayObjectContainer.prototype, "assetType", {
            /**
             *
             */
            get: function () {
                return DisplayObjectContainer.assetType;
            },
            enumerable: true,
            configurable: true
        });
        DisplayObjectContainer.prototype.dispatchFrameEvents = function (events) {
            this.dispatchEvent(events[0]); //ENTER_FRAME
            var i = this._children.length;
            while (i > 0) {
                i--;
                this._children[i].dispatchFrameEvents(events);
            }
            this.dispatchEvent(events[1]); //EXIT_FRAME
        };
        DisplayObjectContainer.prototype.dispatchEnterFrame = function (event) {
            var i = this._children.length;
            while (i > 0) {
                i--;
                // the dispatched Event might change the childs, so make sure they still exits
                if (i < this._children.length) {
                    this._children[i].dispatchEnterFrame(event);
                }
            }
            this.dispatchEvent(event); //ENTER_FRAME
        };
        DisplayObjectContainer.prototype.dispatchExitFrame = function (event) {
            var i = this._children.length;
            while (i > 0) {
                i--;
                // the dispatched Event might change the childs, so make sure they still exits
                if (i < this._children.length) {
                    this._children[i].dispatchExitFrame(event);
                }
            }
            this.dispatchEvent(event); //Exit
        };
        Object.defineProperty(DisplayObjectContainer.prototype, "mouseChildren", {
            /**
             * Determines whether or not the children of the object are mouse, or user
             * input device, enabled. If an object is enabled, a user can interact with
             * it by using a mouse or user input device. The default is
             * <code>true</code>.
             *
             * <p>This property is useful when you create a button with an instance of
             * the Sprite class(instead of using the SimpleButton class). When you use a
             * Sprite instance to create a button, you can choose to decorate the button
             * by using the <code>addChild()</code> method to add additional Sprite
             * instances. This process can cause unexpected behavior with mouse events
             * because the Sprite instances you add as children can become the target
             * object of a mouse event when you expect the parent instance to be the
             * target object. To ensure that the parent instance serves as the target
             * objects for mouse events, you can set the <code>mouseChildren</code>
             * property of the parent instance to <code>false</code>.</p>
             *
             * <p> No event is dispatched by setting this property. You must use the
             * <code>addEventListener()</code> method to create interactive
             * functionality.</p>
             */
            get: function () {
                //ensure the update of _implicitMouseEnabled for cases where child _implicitMouseEnabled is calculated
                if (this._hierarchicalPropsDirty & HierarchicalProperties.MOUSE_ENABLED)
                    this._updateMouseEnabled();
                return this._mouseChildren;
            },
            set: function (value) {
                if (this._mouseChildren == value)
                    return;
                this._mouseChildren = value;
                this._invalidateHierarchicalProperties(HierarchicalProperties.MOUSE_ENABLED);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObjectContainer.prototype, "numChildren", {
            /**
             * Returns the number of children of this object.
             */
            get: function () {
                return this._children.length;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Adds a child DisplayObject instance to this DisplayObjectContainer
         * instance. The child is added to the front(top) of all other children in
         * this DisplayObjectContainer instance.(To add a child to a specific index
         * position, use the <code>addChildAt()</code> method.)
         *
         * <p>If you add a child object that already has a different display object
         * container as a parent, the object is removed from the child list of the
         * other display object container. </p>
         *
         * <p><b>Note:</b> The command <code>stage.addChild()</code> can cause
         * problems with a published SWF file, including security problems and
         * conflicts with other loaded SWF files. There is only one Stage within a
         * Flash runtime instance, no matter how many SWF files you load into the
         * runtime. So, generally, objects should not be added to the Stage,
         * directly, at all. The only object the Stage should contain is the root
         * object. Create a DisplayObjectContainer to contain all of the items on the
         * display list. Then, if necessary, add that DisplayObjectContainer instance
         * to the Stage.</p>
         *
         * @param child The DisplayObject instance to add as a child of this
         *              DisplayObjectContainer instance.
         * @return The DisplayObject instance that you pass in the <code>child</code>
         *         parameter.
         * @throws ArgumentError Throws if the child is the same as the parent. Also
         *                       throws if the caller is a child(or grandchild etc.)
         *                       of the child being added.
         * @event added Dispatched when a display object is added to the display
         *              list.
         */
        DisplayObjectContainer.prototype.addChild = function (child) {
            return this.addChildAt(child, this._children.length);
        };
        DisplayObjectContainer.prototype.addChildAtDepth = function (child, depth, replace) {
            if (replace === void 0) { replace = true; }
            if (!this.doingSwap && (!child.adapter || !child.adapter.noReset)) {
                child.reset(); // this takes care of transform and visibility
            }
            if (child == null)
                throw new ArgumentError("Parameter child cannot be null.");
            //if child already has a parent, remove it.
            if (child.parent)
                child.parent.removeChildAtInternal(child.parent.getChildIndex(child));
            if (this.isSlice9ScaledMC && child.assetType == "[asset Sprite]") {
                child.isSlice9ScaledSprite = true;
            }
            var index = this.getDepthIndexInternal(depth);
            if (index != -1) {
                if (replace) {
                    this.removeChildAt(index);
                }
                else {
                    //move depth of existing child up by 1
                    this.addChildAtDepth(this._children[index], depth + 1, false);
                }
            }
            if (this._nextHighestDepth < depth + 1)
                this._nextHighestDepth = depth + 1;
            this._depth_childs[depth] = child;
            this._children.push(child);
            child._depthID = depth;
            child._setParent(this);
            if (!this.doingSwap) {
                if (child.adapter != child) {
                    // initAdapter (avm1): 
                    //		- executes the initial actionscript for the timeline (if any)
                    //		- initialize the events (this might add the "onLoaded"-event)
                    //		- add the Constructor function to FrameScriptManager
                    // initAdapter (avm1): 
                    //		- executes the initial actionscript for the timeline (if any)
                    //		- add the Constructor function to FrameScriptManager
                    child.adapter.initAdapter();
                }
            }
            return child;
        };
        /**
         * Adds a child DisplayObject instance to this DisplayObjectContainer
         * instance. The child is added at the index position specified. An index of
         * 0 represents the back(bottom) of the display list for this
         * DisplayObjectContainer object.
         *
         * <p>For example, the following example shows three display objects, labeled
         * a, b, and c, at index positions 0, 2, and 1, respectively:</p>
         *
         * <p>If you add a child object that already has a different display object
         * container as a parent, the object is removed from the child list of the
         * other display object container. </p>
         *
         * @param child The DisplayObject instance to add as a child of this
         *              DisplayObjectContainer instance.
         * @param index The index position to which the child is added. If you
         *              specify a currently occupied index position, the child object
         *              that exists at that position and all higher positions are
         *              moved up one position in the child list.
         * @return The DisplayObject instance that you pass in the <code>child</code>
         *         parameter.
         * @throws ArgumentError Throws if the child is the same as the parent. Also
         *                       throws if the caller is a child(or grandchild etc.)
         *                       of the child being added.
         * @throws RangeError    Throws if the index position does not exist in the
         *                       child list.
         * @event added Dispatched when a display object is added to the display
         *              list.
         */
        DisplayObjectContainer.prototype.addChildAt = function (child, index) {
            return this.addChildAtDepth(child, (index < this._children.length) ? this._children[index]._depthID : this.getNextHighestDepth(), false);
        };
        DisplayObjectContainer.prototype.addChildren = function () {
            var childarray = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                childarray[_i] = arguments[_i];
            }
            var len = childarray.length;
            for (var i = 0; i < len; i++)
                this.addChild(childarray[i]);
        };
        /**
         *
         */
        DisplayObjectContainer.prototype.clone = function () {
            var newInstance = new DisplayObjectContainer();
            this.copyTo(newInstance);
            return newInstance;
        };
        DisplayObjectContainer.prototype.copyTo = function (newInstance) {
            _super.prototype.copyTo.call(this, newInstance);
            newInstance.mouseChildren = this._mouseChildren;
            var len = this._children.length;
            for (var i = 0; i < len; ++i)
                newInstance.addChild(this._children[i].adapter.clone().adaptee);
        };
        /**
         * Determines whether the specified display object is a child of the
         * DisplayObjectContainer instance or the instance itself. The search
         * includes the entire display list including this DisplayObjectContainer
         * instance. Grandchildren, great-grandchildren, and so on each return
         * <code>true</code>.
         *
         * @param child The child object to test.
         * @return <code>true</code> if the <code>child</code> object is a child of
         *         the DisplayObjectContainer or the container itself; otherwise
         *         <code>false</code>.
         */
        DisplayObjectContainer.prototype.contains = function (child) {
            return this._children.indexOf(child) >= 0;
        };
        /**
         *
         */
        DisplayObjectContainer.prototype.disposeValues = function () {
            for (var i = this._children.length - 1; i >= 0; i--)
                this.removeChild(this._children[i]);
            _super.prototype.disposeValues.call(this);
        };
        DisplayObjectContainer.prototype.getChildAtDepth = function (depth) {
            return this._depth_childs[depth];
        };
        /**
         * Returns the child display object instance that exists at the specified
         * index.
         *
         * @param index The index position of the child object.
         * @return The child display object at the specified index position.
         * @throws RangeError    Throws if the index does not exist in the child
         *                       list.
         */
        DisplayObjectContainer.prototype.getChildAt = function (index) {
            var child = this._children[index];
            if (child == null)
                throw new RangeError$1("Index does not exist in the child list of the caller");
            return child;
        };
        /**
         * Returns the child display object that exists with the specified name. If
         * more that one child display object has the specified name, the method
         * returns the first object in the child list.
         *
         * <p>The <code>getChildAt()</code> method is faster than the
         * <code>getChildByName()</code> method. The <code>getChildAt()</code> method
         * accesses a child from a cached array, whereas the
         * <code>getChildByName()</code> method has to traverse a linked list to
         * access a child.</p>
         *
         * @param name The name of the child to return.
         * @return The child display object with the specified name.
         */
        DisplayObjectContainer.prototype.getChildByName = function (name) {
            var len = this._children.length;
            for (var i = 0; i < len; ++i)
                if (this._children[i].name == name)
                    return this._children[i];
            return null;
        };
        /**
         * Returns the index position of a <code>child</code> DisplayObject instance.
         *
         * @param child The DisplayObject instance to identify.
         * @return The index position of the child display object to identify.
         * @throws ArgumentError Throws if the child parameter is not a child of this
         *                       object.
         */
        DisplayObjectContainer.prototype.getChildIndex = function (child) {
            var childIndex = this._children.indexOf(child);
            if (childIndex == -1)
                throw new ArgumentError("Child parameter is not a child of the caller");
            return childIndex;
        };
        DisplayObjectContainer.prototype.getNextHighestDepth = function () {
            if (this._nextHighestDepthDirty)
                this._updateNextHighestDepth();
            return this._nextHighestDepth;
        };
        /**
         * Returns an array of objects that lie under the specified point and are
         * children(or grandchildren, and so on) of this DisplayObjectContainer
         * instance. Any child objects that are inaccessible for security reasons are
         * omitted from the returned array. To determine whether this security
         * restriction affects the returned array, call the
         * <code>areInaccessibleObjectsUnderPoint()</code> method.
         *
         * <p>The <code>point</code> parameter is in the coordinate space of the
         * Stage, which may differ from the coordinate space of the display object
         * container(unless the display object container is the Stage). You can use
         * the <code>globalToLocal()</code> and the <code>localToGlobal()</code>
         * methods to convert points between these coordinate spaces.</p>
         *
         * @param point The point under which to look.
         * @return An array of objects that lie under the specified point and are
         *         children(or grandchildren, and so on) of this
         *         DisplayObjectContainer instance.
         */
        DisplayObjectContainer.prototype.getObjectsUnderPoint = function (point) {
            return new Array();
        };
        /**
         * Removes the specified <code>child</code> DisplayObject instance from the
         * child list of the DisplayObjectContainer instance. The <code>parent</code>
         * property of the removed child is set to <code>null</code> , and the object
         * is garbage collected if no other references to the child exist. The index
         * positions of any display objects above the child in the
         * DisplayObjectContainer are decreased by 1.
         *
         * <p>The garbage collector reallocates unused memory space. When a variable
         * or object is no longer actively referenced or stored somewhere, the
         * garbage collector sweeps through and wipes out the memory space it used to
         * occupy if no other references to it exist.</p>
         *
         * @param child The DisplayObject instance to remove.
         * @return The DisplayObject instance that you pass in the <code>child</code>
         *         parameter.
         * @throws ArgumentError Throws if the child parameter is not a child of this
         *                       object.
         */
        DisplayObjectContainer.prototype.removeChild = function (child) {
            if (child == null)
                throw new ArgumentError("Parameter child cannot be null");
            this.removeChildAt(this.getChildIndex(child));
            return child;
        };
        DisplayObjectContainer.prototype.removeChildAtDepth = function (depth) {
            return this.removeChildAt(this.getDepthIndexInternal(depth));
        };
        /**
         * Removes a child DisplayObject from the specified <code>index</code>
         * position in the child list of the DisplayObjectContainer. The
         * <code>parent</code> property of the removed child is set to
         * <code>null</code>, and the object is garbage collected if no other
         * references to the child exist. The index positions of any display objects
         * above the child in the DisplayObjectContainer are decreased by 1.
         *
         * <p>The garbage collector reallocates unused memory space. When a variable
         * or object is no longer actively referenced or stored somewhere, the
         * garbage collector sweeps through and wipes out the memory space it used to
         * occupy if no other references to it exist.</p>
         *
         * @param index The child index of the DisplayObject to remove.
         * @return The DisplayObject instance that was removed.
         * @throws RangeError    Throws if the index does not exist in the child
         *                       list.
         * @throws SecurityError This child display object belongs to a sandbox to
         *                       which the calling object does not have access. You
         *                       can avoid this situation by having the child movie
         *                       call the <code>Security.allowDomain()</code> method.
         */
        DisplayObjectContainer.prototype.removeChildAt = function (index) {
            var child = this.removeChildAtInternal(index);
            child._setParent(null);
            return child;
        };
        /**
         * Removes all <code>child</code> DisplayObject instances from the child list
         * of the DisplayObjectContainer instance. The <code>parent</code> property
         * of the removed children is set to <code>null</code>, and the objects are
         * garbage collected if no other references to the children exist.
         *
         * The garbage collector reallocates unused memory space. When a variable or
         * object is no longer actively referenced or stored somewhere, the garbage
         * collector sweeps through and wipes out the memory space it used to occupy
         * if no other references to it exist.
         *
         * @param beginIndex The beginning position. A value smaller than 0 throws a RangeError.
         * @param endIndex The ending position. A value smaller than 0 throws a RangeError.
         * @throws RangeError    Throws if the beginIndex or endIndex positions do
         *                       not exist in the child list.
         */
        DisplayObjectContainer.prototype.removeChildren = function (beginIndex, endIndex) {
            if (beginIndex === void 0) { beginIndex = 0; }
            if (endIndex === void 0) { endIndex = 2147483647; }
            if (beginIndex < 0)
                throw new RangeError$1("beginIndex is out of range of the child list");
            if (endIndex > this._children.length)
                throw new RangeError$1("endIndex is out of range of the child list");
            //var oldChilds:DisplayObject[]=this._children.slice();
            for (var i = endIndex - 1; i >= beginIndex; i--)
                this.removeChildAtInternal(i)._setParent(null);
        };
        /**
         * Changes the position of an existing child in the display object container.
         * This affects the layering of child objects. For example, the following
         * example shows three display objects, labeled a, b, and c, at index
         * positions 0, 1, and 2, respectively:
         *
         * <p>When you use the <code>setChildIndex()</code> method and specify an
         * index position that is already occupied, the only positions that change
         * are those in between the display object's former and new position. All
         * others will stay the same. If a child is moved to an index LOWER than its
         * current index, all children in between will INCREASE by 1 for their index
         * reference. If a child is moved to an index HIGHER than its current index,
         * all children in between will DECREASE by 1 for their index reference. For
         * example, if the display object container in the previous example is named
         * <code>container</code>, you can swap the position of the display objects
         * labeled a and b by calling the following code:</p>
         *
         * <p>This code results in the following arrangement of objects:</p>
         *
         * @param child The child DisplayObject instance for which you want to change
         *              the index number.
         * @param index The resulting index number for the <code>child</code> display
         *              object.
         * @throws ArgumentError Throws if the child parameter is not a child of this
         *                       object.
         * @throws RangeError    Throws if the index does not exist in the child
         *                       list.
         */
        DisplayObjectContainer.prototype.setChildIndex = function (child, index) {
            //TODO
        };
        /**
         * Swaps the z-order (front-to-back order) of the two specified child
         * objects. All other child objects in the display object container remain in
         * the same index positions.
         *
         * @param child1 The first child object.
         * @param child2 The second child object.
         * @throws ArgumentError Throws if either child parameter is not a child of
         *                       this object.
         */
        DisplayObjectContainer.prototype.swapChildren = function (child1, child2) {
            if (child1.parent != this || child2.parent != this)
                return;
            this.swapChildrenAt(this.getChildIndex(child1), this.getChildIndex(child2));
        };
        /**
         * Swaps the z-order(front-to-back order) of the child objects at the two
         * specified index positions in the child list. All other child objects in
         * the display object container remain in the same index positions.
         *
         * @param index1 The index position of the first child object.
         * @param index2 The index position of the second child object.
         * @throws RangeError If either index does not exist in the child list.
         */
        DisplayObjectContainer.prototype.swapChildrenAt = function (index1, index2) {
            var depth = this._children[index2]._depthID;
            var child = this._children[index1];
            this.addChildAtDepth(this._children[index2], this._children[index1]._depthID);
            this.addChildAtDepth(child, depth);
        };
        /**
         * @protected
         */
        DisplayObjectContainer.prototype._invalidateHierarchicalProperties = function (propDirty) {
            if (_super.prototype._invalidateHierarchicalProperties.call(this, propDirty))
                return true;
            var len = this._children.length;
            for (var i = 0; i < len; ++i)
                this._children[i]._invalidateHierarchicalProperties(propDirty);
            return false;
        };
        /**
         * @internal
         */
        DisplayObjectContainer.prototype._setPartition = function (parentPartition) {
            if (_super.prototype._setPartition.call(this, parentPartition))
                return true;
            var len = this._children.length;
            for (var i = 0; i < len; ++i)
                this._children[i]._setPartition(this._implicitPartition);
            return false;
        };
        /**
         * @private
         *
         * @param child
         */
        DisplayObjectContainer.prototype.removeChildAtInternal = function (index) {
            var child = this._children.splice(index, 1)[0];
            //update next highest depth
            if (this._nextHighestDepth == child._depthID + 1)
                this._nextHighestDepthDirty = true;
            delete this._depth_childs[child._depthID];
            child._depthID = -16384;
            return child;
        };
        DisplayObjectContainer.prototype.getDepthIndexInternal = function (depth) {
            if (!this._depth_childs[depth])
                return -1;
            return this._children.indexOf(this._depth_childs[depth]);
        };
        DisplayObjectContainer.prototype._updateNextHighestDepth = function () {
            this._nextHighestDepthDirty = false;
            this._nextHighestDepth = 0;
            var len = this._children.length;
            for (var i = 0; i < len; i++)
                if (this._nextHighestDepth < this._children[i]._depthID)
                    this._nextHighestDepth = this._children[i]._depthID;
            this._nextHighestDepth += 1;
        };
        DisplayObjectContainer.prototype._updateMaskMode = function () {
            if (this.maskMode)
                this.mouseChildren = false;
            _super.prototype._updateMaskMode.call(this);
        };
        DisplayObjectContainer.assetType = "[asset DisplayObjectContainer]";
        return DisplayObjectContainer;
    }(DisplayObject));

    /**
     * Sprite is an instance of a Graphics, augmenting it with a presence in the scene graph, a material, and an animation
     * state. It consists out of Graphices, which in turn correspond to SubGeometries. Graphices allow different parts
     * of the graphics to be assigned different materials.
     */
    var Sprite = /** @class */ (function (_super) {
        __extends$3(Sprite, _super);
        /**
         * Create a new Sprite object.
         *
         * @param material    [optional]        The material with which to render the Sprite.
         */
        function Sprite(graphics, material) {
            if (graphics === void 0) { graphics = null; }
            if (material === void 0) { material = null; }
            var _this = _super.call(this) || this;
            _this._isEntity = false;
            _this._onGraphicsInvalidateDelegate = function (event) { return _this._onGraphicsInvalidate(event); };
            _this.graphics = graphics || Graphics.getGraphics();
            _this.material = material;
            return _this;
        }
        Sprite.getNewSprite = function (graphics, material) {
            if (graphics === void 0) { graphics = null; }
            if (material === void 0) { material = null; }
            if (Sprite._sprites.length) {
                var sprite = Sprite._sprites.pop();
                sprite.graphics = graphics || Graphics.getGraphics();
                sprite.material = material;
                return sprite;
            }
            return new Sprite(graphics, material);
        };
        Sprite.clearPool = function () {
            Sprite._sprites = [];
        };
        Object.defineProperty(Sprite.prototype, "assetType", {
            /**
             *
             */
            get: function () {
                return Sprite.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sprite.prototype, "graphics", {
            /**
             * Specifies the Graphics object belonging to this Sprite object, where
             * drawing commands can occur.
             */
            get: function () {
                if (this._iSourcePrefab)
                    this._iSourcePrefab._iValidate();
                if (this.isSlice9ScaledSprite) {
                    //var comps:Array<Vector3D> = this.transform.concatenatedMatrix3D.decompose();
                    this._graphics.updateSlice9(this.parent.scaleX, this.parent.scaleY);
                }
                return this._graphics;
            },
            set: function (value) {
                if (this._graphics == value)
                    return;
                if (this._graphics) {
                    this._graphics.removeEventListener(AssetEvent.INVALIDATE, this._onGraphicsInvalidateDelegate);
                    this._graphics.usages--;
                    //if (!this._graphics.usages)
                    //	this.graphics.dispose();
                }
                this._graphics = value;
                if (this._graphics) {
                    this._graphics.addEventListener(AssetEvent.INVALIDATE, this._onGraphicsInvalidateDelegate);
                    this._graphics.usages++;
                }
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Sprite.prototype.isEntity = function () {
            return Boolean(this._graphics && this._graphics.count);
        };
        /**
         * @inheritDoc
         */
        Sprite.prototype.dispose = function () {
            this.disposeValues();
            Sprite._sprites.push(this);
        };
        /**
         * @inheritDoc
         */
        Sprite.prototype.disposeValues = function () {
            _super.prototype.disposeValues.call(this);
            this.graphics = null;
        };
        /**
         * Clones this Sprite instance along with all it's children, while re-using the same
         * material, graphics and animation set. The returned result will be a copy of this sprite,
         * containing copies of all of it's children.
         *
         * Properties that are re-used (i.e. not cloned) by the new copy include name,
         * graphics, and material. Properties that are cloned or created anew for the copy
         * include subSpritees, children of the sprite, and the animator.
         *
         * If you want to copy just the sprite, reusing it's graphics and material while not
         * cloning it's children, the simplest way is to create a new sprite manually:
         *
         * <code>
         * var clone : Sprite = new Sprite(original.graphics, original.material);
         * </code>
         */
        Sprite.prototype.clone = function () {
            var newInstance = Sprite.getNewSprite();
            this.copyTo(newInstance);
            return newInstance;
        };
        Sprite.prototype.copyTo = function (sprite, cloneShapes) {
            if (cloneShapes === void 0) { cloneShapes = false; }
            _super.prototype.copyTo.call(this, sprite);
            sprite._iSourcePrefab = this._iSourcePrefab;
            this._graphics.copyTo(sprite.graphics, cloneShapes);
        };
        /**
         *
         */
        Sprite.prototype._iInternalUpdate = function () {
            _super.prototype._iInternalUpdate.call(this);
            // if(this.parent)
            // 	this._graphics.updateScale(view);
        };
        /**
         * //TODO
         *
         * @private
         */
        Sprite.prototype._onGraphicsInvalidate = function (event) {
            var isEntity = this.isEntity();
            if (this._isEntity != isEntity) {
                if (!isEntity && this._implicitPartition)
                    this._implicitPartition.clearEntity(this);
                this._isEntity = isEntity;
            }
            this.invalidate();
        };
        /**
         *
         * @param renderer
         *
         * @internal
         */
        Sprite.prototype._acceptTraverser = function (traverser) {
            this.graphics._acceptTraverser(traverser);
        };
        /**
         *
         */
        Sprite.prototype.bakeTransformations = function () {
            this._graphics.applyTransformation(this.transform.matrix3D);
            this.transform.clearMatrix3D();
        };
        Sprite._sprites = new Array();
        Sprite.assetType = "[asset Sprite]";
        return Sprite;
    }(DisplayObjectContainer));
    PartitionBase.registerAbstraction(EntityNode, Sprite);

    var MorphSprite = /** @class */ (function (_super) {
        __extends$3(MorphSprite, _super);
        function MorphSprite() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        MorphSprite.getNewMorphSprite = function (graphics, material) {
            if (graphics === void 0) { graphics = null; }
            if (material === void 0) { material = null; }
            if (MorphSprite._morphSprites.length) {
                var sprite = MorphSprite._morphSprites.pop();
                sprite.graphics = graphics || Graphics.getGraphics();
                sprite.material = material;
                return sprite;
            }
            return new MorphSprite(graphics, material);
        };
        //todo: move to colorutils
        MorphSprite.interpolateColor = function (start, end, ratio) {
            var a = (start & 0xff000000) >>> 24;
            var r = (start & 0xff0000) >>> 16;
            var g = (start & 0xff00) >>> 8;
            var b = start & 0xff;
            var a2 = (end & 0xff000000) >>> 24;
            var r2 = (end & 0xff0000) >>> 16;
            var g2 = (end & 0xff00) >>> 8;
            var b2 = end & 0xff;
            var rs = 1 - ratio;
            var re = ratio;
            return (((a * rs + a2 * re) << 24) | ((r * rs + r2 * re) << 16) | ((g * rs + g2 * re) << 8) | (b * rs + b2 * re));
        };
        Object.defineProperty(MorphSprite.prototype, "assetType", {
            get: function () {
                return MorphSprite.assetType;
            },
            enumerable: true,
            configurable: true
        });
        MorphSprite.prototype.reset = function () {
            _super.prototype.reset.call(this);
            this.setRatio(0);
        };
        MorphSprite.prototype.setRatio = function (ratio) {
            var lookupRatio = Math.round(ratio * 0xffffff).toString();
            if (this._ratio == lookupRatio) {
                return;
            }
            this._ratio = lookupRatio;
            this._graphics.endFill(); //trigger a queue execution if one is needed
            this._graphics.clear();
            /*
            if(this._graphics.start.length!=this._graphics.end.length){
                throw("Error in morph data - different number of pathes");
            }
            var len=this._graphics.start.length;
            var ratioStart=1-ratio;
            var ratioEnd=ratio;
            var newPath:GraphicsPath;
            var startPath:GraphicsPath;
            var endPath:GraphicsPath;
            for(var i:number=0; i<len; i++){
                newPath=new GraphicsPath();
                startPath=this._graphics.start[i];
                endPath=this._graphics.end[i];
                if (startPath.style.data_type != endPath.style.data_type){
                    throw("Error in morph data - different styles of pathes");
                }
                switch(startPath.style.data_type){
                    case GraphicsFillStyle.data_type:
                        var alpha=ratioStart*(<GraphicsFillStyle>startPath.style).alpha + ratioEnd*(<GraphicsFillStyle>endPath.style).alpha;
                        var color=MorphSprite.interpolateColor((<GraphicsFillStyle>startPath.style).color, (<GraphicsFillStyle>endPath.style).color, ratio);
                        newPath.style=new GraphicsFillStyle(color, alpha);
                        break;
                    case GradientFillStyle.data_type:
                        var newColors=[];
                        var newRatios=[];
                        var newAlphas=[];
                        var startStyle:GradientFillStyle=(<GradientFillStyle>startPath.style);
                        var endStyle:GradientFillStyle=(<GradientFillStyle>endPath.style);
                        var clen=startStyle.colors.length;
                        for(var c:number=0; c<clen; c++){
                            newColors[newColors.length]= MorphSprite.interpolateColor(startStyle.colors[c], endStyle.colors[c], ratio);
                            newAlphas[newAlphas.length]=ratioStart*startStyle.alphas[c] + ratioEnd*endStyle.alphas[c];
                            newRatios[newRatios.length]=ratioStart*startStyle.ratios[c] + ratioEnd*endStyle.ratios[c];
                        }
                        //todo: interpolate uvtransform
                        var transform:Matrix=startStyle.matrix;
                        var transformb:Matrix=endStyle.matrix;
                        var transformnew:Matrix=new Matrix();
                        transformnew.a=transform.a*ratioStart + transformb.a*ratioEnd;
                        transformnew.b=transform.b*ratioStart + transformb.b*ratioEnd;
                        transformnew.c=transform.c*ratioStart + transformb.c*ratioEnd;
                        transformnew.d=transform.d*ratioStart + transformb.d*ratioEnd;
                        transformnew.tx=transform.tx*ratioStart + transformb.tx*ratioEnd;
                        transformnew.ty=transform.ty*ratioStart + transformb.ty*ratioEnd;
                        newPath.style=new GradientFillStyle(startStyle.type, newColors, newAlphas, newRatios, transformnew, startStyle.spreadMethod, startStyle.interpolationMethod, startStyle.focalPointRatio);
                        break;
                    case BitmapFillStyle.data_type:
                        //newPath.style=new BitmapFillStyle();
                        break;
                    case GraphicsStrokeStyle.data_type:
                        var startStrokeStyle:GraphicsStrokeStyle=(<GraphicsStrokeStyle>startPath.style);
                        var endSStroketyle:GraphicsStrokeStyle=(<GraphicsStrokeStyle>endPath.style);
                        var alpha=ratioStart*startStrokeStyle.alpha + ratioEnd*endSStroketyle.alpha;
                        var color=MorphSprite.interpolateColor(startStrokeStyle.color, endSStroketyle.color, ratio);
                        var thickness=ratioStart*startStrokeStyle.thickness + ratioEnd*endSStroketyle.thickness;;

                        newPath.style=new GraphicsStrokeStyle(color, alpha, thickness, startStrokeStyle.jointstyle, startStrokeStyle.capstyle, startStrokeStyle.miter_limit, startStrokeStyle.scaleMode);
                        break;
                }
                var startDataCnt=0;
                var endDataCnt=0;
                var startLastX=0;
                var startLastY=0;
                var endLastX=0;
                var endLastY=0;
                var len_contours=startPath._commands.length;
                startPath=this._graphics.start[0];
                endPath=this._graphics.end[0];
                if(endPath._commands.length!=len_contours) {
                    len_contours=Math.min(endPath._commands.length, len_contours);
                    //throw("Error in morph data - different number of contour");
                }
                for(var c:number=0; c < len_contours; c++){
                    var startCmds=startPath._commands[c];
                    var startData=startPath._data[c];
                    var endCmds=endPath._commands[c];
                    var endData=endPath._data[c];
                    var len_cmds=startCmds.length;
                    if(endCmds.length!=len_cmds){
                        len_cmds=Math.min(endCmds.length, len_cmds);
                        //throw("Error in morph data - different number of commands in contour");
                    }
                    //console.log("start", startData);
                    //console.log("end", endData);

                    for(var c2:number=0; c2<len_cmds; c2++){

                        switch(startCmds[c2]){
                            case GraphicsPathCommand.MOVE_TO:
                                if(endCmds[c2]!=GraphicsPathCommand.MOVE_TO){
                                    throw("Error in morph data - both shapes must start with Move too command");
                                }
                                startLastX=startData[startDataCnt++];
                                startLastY=startData[startDataCnt++];
                                endLastX=endData[endDataCnt++];
                                endLastY=endData[endDataCnt++];
                                newPath.moveTo(ratioStart * startLastX + ratioEnd * endLastX,ratioStart * startLastY + ratioEnd * endLastY);
                                break;
                            case GraphicsPathCommand.LINE_TO:
                                if(endCmds[c2]==GraphicsPathCommand.LINE_TO){
                                    startLastX=startData[startDataCnt++];
                                    startLastY=startData[startDataCnt++];
                                    endLastX=endData[endDataCnt++];
                                    endLastY=endData[endDataCnt++];
                                    newPath.lineTo(ratioStart * startLastX + ratioEnd * endLastX,ratioStart * startLastY + ratioEnd * endLastY);
                                }
                                else if(endCmds[c2]==GraphicsPathCommand.CURVE_TO){
                                    var ctrX=startLastX+(startData[startDataCnt++]-startLastX)/2;
                                    var ctrY=startLastY+(startData[startDataCnt++]-startLastY)/2;

                                    newPath.curveTo(ratioStart * ctrX + ratioEnd * endData[endDataCnt++],
                                        ratioStart * ctrY + ratioEnd * endData[endDataCnt++],
                                        ratioStart * startData[startDataCnt-2] + ratioEnd * endData[endDataCnt++],
                                        ratioStart * startData[startDataCnt-1] + ratioEnd * endData[endDataCnt++]
                                    )
                                    startLastX=startData[startDataCnt-2];
                                    startLastY=startData[startDataCnt-1];
                                    endLastX=endData[endDataCnt-2];
                                    endLastY=endData[endDataCnt-1];

                                }
                                break;
                            case GraphicsPathCommand.CURVE_TO:
                                if(endCmds[c2]==GraphicsPathCommand.LINE_TO){
                                    var ctrX=endLastX+(endData[endDataCnt++]-endLastX)/2;
                                    var ctrY=endLastY+(endData[endDataCnt++]-endLastY)/2;

                                    newPath.curveTo(ratioStart * startData[startDataCnt++] + ratioEnd * ctrX,
                                        ratioStart * startData[startDataCnt++] + ratioEnd * ctrY,
                                        ratioStart * startData[startDataCnt++] + ratioEnd * endData[endDataCnt-2],
                                        ratioStart * startData[startDataCnt++] + ratioEnd * endData[endDataCnt-1]
                                    )
                                    startLastX=startData[startDataCnt-2];
                                    startLastY=startData[startDataCnt-1];
                                    endLastX=endData[endDataCnt-2];
                                    endLastY=endData[endDataCnt-1];
                                }
                                else if(endCmds[c2]==GraphicsPathCommand.CURVE_TO){

                                    newPath.curveTo(ratioStart * startData[startDataCnt++] + ratioEnd * endData[endDataCnt++],
                                        ratioStart * startData[startDataCnt++] + ratioEnd * endData[endDataCnt++],
                                        ratioStart * startData[startDataCnt++] + ratioEnd * endData[endDataCnt++],
                                        ratioStart * startData[startDataCnt++] + ratioEnd * endData[endDataCnt++]
                                    )
                                    startLastX=startData[startDataCnt-2];
                                    startLastY=startData[startDataCnt-1];
                                    endLastX=endData[endDataCnt-2];
                                    endLastY=endData[endDataCnt-1];
                                }
                                break;
                        }
                    }
                }
                this._graphics.add_queued_path(newPath);
                //console.log(endPath);
                //console.log(startPath);

            }
            */
            /*
            var newPath:GraphicsPath=new GraphicsPath();
            newPath.moveTo(50,50);
            newPath.lineTo(50,100);
            newPath.lineTo(100,100);
            newPath.lineTo(100,50);
            newPath.lineTo(50,50);
            newPath.style=this.end[0].style;
            newGraphics.add_queued_path(newPath);
            */
            this._graphics.endFill();
        };
        /**
         * @inheritDoc
         */
        MorphSprite.prototype.dispose = function () {
            this.disposeValues();
            MorphSprite._morphSprites.push(this);
        };
        MorphSprite.prototype.clone = function () {
            var newInstance = MorphSprite.getNewMorphSprite();
            this.copyTo(newInstance);
            return newInstance;
        };
        MorphSprite.assetType = "[asset MorphSprite]";
        MorphSprite._morphSprites = new Array();
        return MorphSprite;
    }(Sprite));
    PartitionBase.registerAbstraction(EntityNode, MorphSprite);

    /**
     * A MouseEvent is dispatched when a mouse event occurs over a mouseEnabled object in View.
     * TODO: we don't have screenZ data, tho this should be easy to implement
     */
    var MouseEvent = /** @class */ (function (_super) {
        __extends$3(MouseEvent, _super);
        /**
         * Create a new MouseEvent object.
         * @param type The type of the MouseEvent.
         */
        function MouseEvent(type) {
            var _this = _super.call(this, type) || this;
            // Private.
            _this._iAllowedToPropagate = true;
            return _this;
        }
        Object.defineProperty(MouseEvent.prototype, "bubbles", {
            /**
             * @inheritDoc
             */
            get: function () {
                var doesBubble = this._iAllowedToPropagate;
                this._iAllowedToPropagate = true;
                // Don't bubble if propagation has been stopped.
                return doesBubble;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        MouseEvent.prototype.stopPropagation = function () {
            this._iAllowedToPropagate = false;
            if (this._iParentEvent)
                this._iParentEvent.stopPropagation();
        };
        /**
         * @inheritDoc
         */
        MouseEvent.prototype.stopImmediatePropagation = function () {
            this._iAllowedToPropagate = false;
            if (this._iParentEvent)
                this._iParentEvent.stopImmediatePropagation();
        };
        /**
         * Creates a copy of the MouseEvent object and sets the value of each property to match that of the original.
         */
        MouseEvent.prototype.clone = function () {
            var result = new MouseEvent(this.type);
            /* TODO: Debug / test - look into isDefaultPrevented
             if (isDefaultPrevented())
             result.preventDefault();
             */
            result.screenX = this.screenX;
            result.screenY = this.screenY;
            result.view = this.view;
            result.entity = this.entity;
            result.pickerEntity = this.pickerEntity;
            result.traversable = this.traversable;
            result.material = this.material;
            result.uv = this.uv;
            result.position = this.position;
            result.normal = this.normal;
            result.elementIndex = this.elementIndex;
            result.delta = this.delta;
            result.ctrlKey = this.ctrlKey;
            result.shiftKey = this.shiftKey;
            result._iParentEvent = this;
            result._iAllowedToPropagate = this._iAllowedToPropagate;
            return result;
        };
        Object.defineProperty(MouseEvent.prototype, "scenePosition", {
            /**
             * The position in scene space where the event took place
             */
            get: function () {
                return this.entity.transform.concatenatedMatrix3D.transformVector(this.position);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "sceneNormal", {
            /**
             * The normal in scene space where the event took place
             */
            get: function () {
                var sceneNormal = this.entity.transform.concatenatedMatrix3D.deltaTransformVector(this.normal);
                sceneNormal.normalize();
                return sceneNormal;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Defines the value of the type property of a mouseOver3d event object.
         */
        MouseEvent.MOUSE_OVER = "mouseOver3d";
        /**
         * Defines the value of the type property of a mouseOut3d event object.
         */
        MouseEvent.MOUSE_OUT = "mouseOut3d";
        /**
         * Defines the value of the type property of a mouseUp3d event object.
         */
        MouseEvent.MOUSE_UP = "mouseUp3d";
        /**
         * Defines the value of the type property of a mouseUp3d event object.
         */
        MouseEvent.MOUSE_UP_OUTSIDE = "mouseUpOutside3d";
        /**
         * Defines the value of the type property of a mouseDown3d event object.
         */
        MouseEvent.MOUSE_DOWN = "mouseDown3d";
        /**
         * Defines the value of the type property of a mouseMove3d event object.
         */
        MouseEvent.MOUSE_MOVE = "mouseMove3d";
        /**
         * Defines the value of the type property of a dragMove3d event object.
         */
        MouseEvent.DRAG_MOVE = "dragMove3d";
        /**
         * Defines the value of the type property of a dragOut3d event object.
         */
        MouseEvent.DRAG_OUT = "dragOut3d";
        /**
         * Defines the value of the type property of a dragOver3d event object.
         */
        MouseEvent.DRAG_OVER = "dragOver3d";
        /**
         * Defines the value of the type property of a dragStart3d event object.
         */
        MouseEvent.DRAG_START = "dragStart3d";
        /**
         * Defines the value of the type property of a dragStop3d event object.
         */
        MouseEvent.DRAG_STOP = "dragStop3d";
        /**
         * Defines the value of the type property of a focusIn3d event object.
         */
        MouseEvent.FOCUS_IN = "focusIn3d";
        /**
         * Defines the value of the type property of a focusOut3d event object.
         */
        MouseEvent.FOCUS_OUT = "focusOut3d";
        /**
         * Defines the value of the type property of a rollOver3d event object.
         */
        //		public static ROLL_OVER : string = "rollOver3d";
        /**
         * Defines the value of the type property of a rollOut3d event object.
         */
        //		public static ROLL_OUT : string = "rollOut3d";
        /**
         * Defines the value of the type property of a click3d event object.
         */
        MouseEvent.CLICK = "click3d";
        /**
         * Defines the value of the type property of a doubleClick3d event object.
         */
        MouseEvent.DOUBLE_CLICK = "doubleClick3d";
        /**
         * Defines the value of the type property of a mouseWheel3d event object.
         */
        MouseEvent.MOUSE_WHEEL = "mouseWheel3d";
        return MouseEvent;
    }(EventBase));

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics$7 = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };

    function __extends$7(d, b) {
        extendStatics$7(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var LightEvent = /** @class */ (function (_super) {
        __extends$7(LightEvent, _super);
        function LightEvent(type) {
            return _super.call(this, type) || this;
        }
        //@override
        LightEvent.prototype.clone = function () {
            return new LightEvent(this.type);
        };
        LightEvent.CASTS_SHADOW_CHANGE = "castsShadowChange";
        return LightEvent;
    }(EventBase));

    var TextureProjectorEvent = /** @class */ (function (_super) {
        __extends$7(TextureProjectorEvent, _super);
        function TextureProjectorEvent(type) {
            return _super.call(this, type) || this;
        }
        //@override
        TextureProjectorEvent.prototype.clone = function () {
            return new TextureProjectorEvent(this.type);
        };
        TextureProjectorEvent.TEXTURE_CHANGE = "textureChange";
        return TextureProjectorEvent;
    }(EventBase));

    var MethodEvent = /** @class */ (function (_super) {
        __extends$7(MethodEvent, _super);
        function MethodEvent(type) {
            return _super.call(this, type) || this;
        }
        MethodEvent.SHADER_INVALIDATED = "shaderInvalidated";
        return MethodEvent;
    }(EventBase));

    /**
     *
     */
    var TextureBase = /** @class */ (function (_super) {
        __extends$7(TextureBase, _super);
        /**
         *
         */
        function TextureBase() {
            var _this = _super.call(this) || this;
            _this._numImages = 0;
            _this._images = new Array();
            _this._samplers = new Array();
            return _this;
        }
        Object.defineProperty(TextureBase.prototype, "mappingMode", {
            get: function () {
                return this._mappingMode;
            },
            set: function (value) {
                if (this._mappingMode == value)
                    return;
                this._mappingMode = value;
            },
            enumerable: true,
            configurable: true
        });
        TextureBase.prototype.getNumImages = function () {
            return this._numImages;
        };
        TextureBase.prototype.setNumImages = function (value) {
            if (this._numImages == value)
                return;
            this._numImages = value;
            this._images.length = value;
            this._samplers.length = value;
            this.invalidate();
        };
        TextureBase.prototype.getImageAt = function (index) {
            return this._images[index];
        };
        TextureBase.prototype.setImageAt = function (image, index) {
            this._images[index] = image;
            this.invalidate();
        };
        TextureBase.prototype.getSamplerAt = function (index) {
            return this._samplers[index];
        };
        TextureBase.prototype.setSamplerAt = function (sampler, index) {
            this._samplers[index] = sampler;
            this.invalidate();
        };
        /**
         * Marks the shader program as invalid, so it will be recompiled before the next render.
         *
         * @internal
         */
        TextureBase.prototype.invalidateShaderProgram = function () {
            this.invalidate();
            this.dispatchEvent(new MethodEvent(MethodEvent.SHADER_INVALIDATED));
        };
        return TextureBase;
    }(AssetBase));

    /**
     *
     */
    var Texture2D = /** @class */ (function (_super) {
        __extends$7(Texture2D, _super);
        function Texture2D(mappingMode) {
            if (mappingMode === void 0) { mappingMode = null; }
            var _this = _super.call(this) || this;
            _this._mappingMode = mappingMode || MappingMode.LINEAR;
            return _this;
        }
        Object.defineProperty(Texture2D.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return Texture2D.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Texture2D.assetType = "[texture Texture2D]";
        return Texture2D;
    }(TextureBase));

    /**
     *
     */
    var TextureCube = /** @class */ (function (_super) {
        __extends$7(TextureCube, _super);
        function TextureCube() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(TextureCube.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return TextureCube.assetType;
            },
            enumerable: true,
            configurable: true
        });
        TextureCube.assetType = "[texture TextureCube]";
        return TextureCube;
    }(TextureBase));

    var ImageTextureCube = /** @class */ (function (_super) {
        __extends$7(ImageTextureCube, _super);
        function ImageTextureCube(image) {
            if (image === void 0) { image = null; }
            var _this = _super.call(this) || this;
            _this.setNumImages(1);
            _this.image = image;
            return _this;
        }
        Object.defineProperty(ImageTextureCube.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return ImageTextureCube.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ImageTextureCube.prototype, "sampler", {
            /**
             *
             * @returns {ImageCube}
             */
            get: function () {
                return this._samplers[0];
            },
            set: function (value) {
                if (this._samplers[0] == value)
                    return;
                this.setSamplerAt(value, 0);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ImageTextureCube.prototype, "image", {
            /**
             *
             * @returns {ImageCube}
             */
            get: function () {
                return this._images[0];
            },
            set: function (value) {
                if (this._images[0] == value)
                    return;
                this.setImageAt(value, 0);
            },
            enumerable: true,
            configurable: true
        });
        ImageTextureCube.assetType = "[texture ImageTextureCube]";
        return ImageTextureCube;
    }(TextureCube));
    /**
     *
     * @class away.pool.GL_SingleImageTexture
     */
    var _Shader_ImageTexture = /** @class */ (function (_super) {
        __extends$7(_Shader_ImageTexture, _super);
        function _Shader_ImageTexture() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         *
         * @param shader
         * @param regCache
         * @param targetReg The register in which to store the sampled colour.
         * @param uvReg The uv coordinate vector with which to sample the texture map.
         * @returns {string}
         * @private
         */
        _Shader_ImageTexture.prototype._getFragmentCode = function (targetReg, regCache, sharedReg, inputReg) {
            var wrap = "wrap";
            var format = "";
            var filter = "linear,miplinear";
            this._imageIndex = this._shader.renderMaterial.getImageIndex(this._texture, 0);
            var textureReg = this.getTextureReg(this._imageIndex, regCache, sharedReg);
            this._textureIndex = textureReg.index;
            return "tex " + targetReg + ", " + inputReg + ", " + textureReg + " <" + this._shader.renderMaterial.images[this._imageIndex].getType() + "," + filter + "," + format + wrap + ">\n";
        };
        _Shader_ImageTexture.prototype.activate = function () {
            var sampler = this._shader.renderMaterial.samplers[this._imageIndex];
            var stageImage = this._shader.renderMaterial.images[this._imageIndex];
            stageImage.activate(this._textureIndex, sampler);
        };
        _Shader_ImageTexture.prototype._setRenderState = function (renderState) {
            var sampler = renderState.samplers[this._imageIndex];
            var stageImage = renderState.images[this._imageIndex];
            if (stageImage && sampler)
                stageImage.activate(this._textureIndex, sampler);
        };
        return _Shader_ImageTexture;
    }(_Shader_TextureBase));
    ShaderBase.registerAbstraction(_Shader_ImageTexture, ImageTextureCube);

    var ImageTexture2D = /** @class */ (function (_super) {
        __extends$7(ImageTexture2D, _super);
        function ImageTexture2D(image, mappingMode) {
            if (image === void 0) { image = null; }
            if (mappingMode === void 0) { mappingMode = null; }
            var _this = _super.call(this, mappingMode) || this;
            _this.setNumImages(1);
            _this.image = image;
            return _this;
        }
        Object.defineProperty(ImageTexture2D.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return ImageTexture2D.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ImageTexture2D.prototype, "sampler", {
            /**
             *
             * @returns {ImageBase}
             */
            get: function () {
                return this._samplers[0];
            },
            set: function (value) {
                if (this._samplers[0] == value)
                    return;
                this.setSamplerAt(value, 0);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ImageTexture2D.prototype, "image", {
            /**
             *
             * @returns {ImageBase}
             */
            get: function () {
                return this._images[0];
            },
            set: function (value) {
                if (this._images[0] == value)
                    return;
                if (!ImageUtils.isImage2DValid(value))
                    throw new ErrorBase("Invalid imageData: Width and height must be power of 2 and cannot exceed 2048");
                this.setImageAt(value, 0);
            },
            enumerable: true,
            configurable: true
        });
        ImageTexture2D.assetType = "[texture ImageTexture2D]";
        return ImageTexture2D;
    }(Texture2D));
    /**
     *
     * @class away.pool.GL_SingleImageTexture
     */
    var _Shader_ImageTexture2D = /** @class */ (function (_super) {
        __extends$7(_Shader_ImageTexture2D, _super);
        function _Shader_ImageTexture2D() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         *
         * @param shader
         * @param regCache
         * @param targetReg The register in which to store the sampled colour.
         * @param uvReg The uv coordinate vector with which to sample the texture map.
         * @returns {string}
         * @private
         */
        _Shader_ImageTexture2D.prototype._getFragmentCode = function (targetReg, regCache, sharedReg, inputReg) {
            var code = "";
            var temp;
            //modify depending on mapping mode
            if (this._texture.mappingMode == MappingMode.RADIAL) {
                temp = regCache.getFreeFragmentVectorTemp();
                code += "mul " + temp + ".xy, " + inputReg + ", " + inputReg + "\n";
                code += "add " + temp + ".x, " + temp + ".x, " + temp + ".y\n";
                code += "sub " + temp + ".y, " + temp + ".y, " + temp + ".y\n";
                code += "sqt " + temp + ".x, " + temp + ".x, " + temp + ".x\n";
                inputReg = temp;
            }
            //handles texture atlasing
            if (this._shader.useImageRect) {
                var samplerReg = regCache.getFreeFragmentConstant();
                this._samplerIndex = samplerReg.index * 4;
                temp = regCache.getFreeFragmentVectorTemp();
                code += "mul " + temp + ", " + inputReg + ", " + samplerReg + ".xy\n";
                code += "add " + temp + ", " + temp + ", " + samplerReg + ".zw\n";
                inputReg = temp;
            }
            code += _super.prototype._getFragmentCode.call(this, targetReg, regCache, sharedReg, inputReg);
            return code;
        };
        _Shader_ImageTexture2D.prototype.activate = function () {
            _super.prototype.activate.call(this);
            var sampler = this._shader.renderMaterial.samplers[this._imageIndex];
            if (this._shader.useImageRect) {
                var index = this._samplerIndex;
                var data = this._shader.fragmentConstantData;
                if (!sampler.imageRect) {
                    data[index] = 1;
                    data[index + 1] = 1;
                    data[index + 2] = 0;
                    data[index + 3] = 0;
                }
                else {
                    data[index] = sampler.imageRect.width;
                    data[index + 1] = sampler.imageRect.height;
                    data[index + 2] = sampler.imageRect.x;
                    data[index + 3] = sampler.imageRect.y;
                }
            }
        };
        _Shader_ImageTexture2D.prototype._setRenderState = function (renderState) {
            _super.prototype._setRenderState.call(this, renderState);
            var sampler = renderState.samplers[this._imageIndex];
            if (this._shader.useImageRect && sampler) {
                var index = this._samplerIndex;
                var data = this._shader.fragmentConstantData;
                if (!sampler.imageRect) {
                    data[index] = 1;
                    data[index + 1] = 1;
                    data[index + 2] = 0;
                    data[index + 3] = 0;
                }
                else {
                    data[index] = sampler.imageRect.width;
                    data[index + 1] = sampler.imageRect.height;
                    data[index + 2] = sampler.imageRect.x;
                    data[index + 3] = sampler.imageRect.y;
                }
            }
        };
        return _Shader_ImageTexture2D;
    }(_Shader_ImageTexture));
    ShaderBase.registerAbstraction(_Shader_ImageTexture2D, ImageTexture2D);

    var DepthTextureCube = /** @class */ (function (_super) {
        __extends$7(DepthTextureCube, _super);
        function DepthTextureCube(image) {
            if (image === void 0) { image = null; }
            return _super.call(this, image) || this;
        }
        Object.defineProperty(DepthTextureCube.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return DepthTextureCube.assetType;
            },
            enumerable: true,
            configurable: true
        });
        DepthTextureCube.assetType = "[texture DepthTextureCube]";
        return DepthTextureCube;
    }(ImageTextureCube));
    /**
     *
     * @class away.pool._Shader_ImageTexture2D
     */
    var _Shader_DepthTexture = /** @class */ (function (_super) {
        __extends$7(_Shader_DepthTexture, _super);
        function _Shader_DepthTexture() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        _Shader_DepthTexture.prototype._initVO = function (chunkVO) {
            this._decodeReg = null;
            this._decodeIndex = -1;
        };
        /**
         *
         *
         * @internal
         */
        _Shader_DepthTexture.prototype._initConstants = function () {
            var fragmentData = this._shader.fragmentConstantData;
            var index = this._decodeIndex;
            fragmentData[index] = 1.0;
            fragmentData[index + 1] = 1 / 255.0;
            fragmentData[index + 2] = 1 / 65025.0;
            fragmentData[index + 3] = 1 / 16581375.0;
        };
        /**
         * @inheritDoc
         */
        _Shader_DepthTexture.prototype._getFragmentCode = function (targetReg, regCache, sharedReg, inputReg) {
            if (this._decodeIndex == -1)
                this._decodeIndex = (this._decodeReg = regCache.getFreeFragmentConstant()).index * 4;
            var temp = regCache.getFreeFragmentVectorTemp();
            return _super.prototype._getFragmentCode.call(this, temp, regCache, sharedReg, inputReg) +
                "dp4 " + targetReg + ".w, " + temp + ", " + this._decodeReg + "\n";
        };
        return _Shader_DepthTexture;
    }(_Shader_ImageTexture));
    ShaderBase.registerAbstraction(_Shader_DepthTexture, DepthTextureCube);

    var ShadowTexture2D = /** @class */ (function (_super) {
        __extends$7(ShadowTexture2D, _super);
        function ShadowTexture2D(image) {
            if (image === void 0) { image = null; }
            return _super.call(this, image) || this;
        }
        Object.defineProperty(ShadowTexture2D.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return ShadowTexture2D.assetType;
            },
            enumerable: true,
            configurable: true
        });
        ShadowTexture2D.assetType = "[texture ShadowTexture2D]";
        return ShadowTexture2D;
    }(ImageTexture2D));
    /**
     *
     * @class away.pool._Shader_DepthTexture
     */
    var _Shader_ShadowTexture2D = /** @class */ (function (_super) {
        __extends$7(_Shader_ShadowTexture2D, _super);
        function _Shader_ShadowTexture2D() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_ShadowTexture2D.prototype._getFragmentCode = function (targetReg, regCache, sharedRegisters, inputReg) {
            return _super.prototype._getFragmentCode.call(this, targetReg, regCache, sharedRegisters, inputReg) +
                "slt " + targetReg + ".w, " + inputReg + ".z, " + targetReg + ".w\n"; // 0 if in shadow, 1 if out of shadow
        };
        return _Shader_ShadowTexture2D;
    }(_Shader_DepthTexture));
    ShaderBase.registerAbstraction(_Shader_ShadowTexture2D, ShadowTexture2D);

    /**
     * MethodBase provides an abstract base method for shading methods, used by compiled passes to compile
     * the final shading program.
     */
    var MethodBase = /** @class */ (function (_super) {
        __extends$7(MethodBase, _super);
        /**
         * Create a new MethodBase object.
         */
        function MethodBase() {
            var _this = _super.call(this) || this;
            _this._textures = new Array();
            _this._owners = new Array();
            _this._counts = new Array();
            return _this;
        }
        /**
         * Cleans up any resources used by the current object.
         */
        MethodBase.prototype.dispose = function () {
        };
        MethodBase.prototype.iAddOwner = function (owner) {
            //a method can be used more than once in the same material, so we check for this
            var index = this._owners.indexOf(owner);
            if (index != -1) {
                this._counts[index]++;
            }
            else {
                this._owners.push(owner);
                this._counts.push(1);
                //add textures
                var len = this._textures.length;
                for (var i = 0; i < len; i++)
                    owner.addTexture(this._textures[i]);
            }
        };
        MethodBase.prototype.iRemoveOwner = function (owner) {
            var index = this._owners.indexOf(owner);
            if (this._counts[index] != 1) {
                this._counts[index]--;
            }
            else {
                this._owners.splice(index, 1);
                this._counts.splice(index, 1);
                //remove textures
                var len = this._textures.length;
                for (var i = 0; i < len; i++)
                    owner.removeTexture(this._textures[i]);
            }
        };
        /**
         *
         */
        MethodBase.prototype.iAddTexture = function (texture) {
            this._textures.push(texture);
            var len = this._owners.length;
            for (var i = 0; i < len; i++)
                this._owners[i].addTexture(texture);
        };
        /**
         *
         */
        MethodBase.prototype.iRemoveTexture = function (texture) {
            this._textures.splice(this._textures.indexOf(texture), 1);
            var len = this._owners.length;
            for (var i = 0; i < len; i++)
                this._owners[i].removeTexture(texture);
        };
        /**
         * Marks the shader program as invalid, so it will be recompiled before the next render.
         *
         * @internal
         */
        MethodBase.prototype.invalidateShaderProgram = function () {
            this.invalidate();
            this.dispatchEvent(new MethodEvent(MethodEvent.SHADER_INVALIDATED));
        };
        /**
         * Copies the state from a MethodBase object into the current object.
         */
        MethodBase.prototype.copyFrom = function (method) {
        };
        return MethodBase;
    }(AssetBase));
    /**
     * _Shader_MethodBase provides an abstract base method for shading methods, used by compiled passes to compile
     * the final shading program.
     */
    var _Shader_MethodBase = /** @class */ (function (_super) {
        __extends$7(_Shader_MethodBase, _super);
        /**
         * Create a new _Shader_MethodBase object.
         */
        function _Shader_MethodBase(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this.chunkVO = new ChunkVO();
            return _this;
        }
        _Shader_MethodBase.prototype._isUsed = function () {
            return true;
        };
        _Shader_MethodBase.prototype._usesTangentSpace = function () {
            return true;
        };
        /**
         * Initializes the properties for a MethodVO, including register and texture indices.
         *
         * @param methodVO The MethodVO object linking this method with the pass currently being compiled.
         *
         * @internal
         */
        _Shader_MethodBase.prototype._initVO = function (chunkVO) {
        };
        /**
         * Initializes unchanging shader constants using the data from a MethodVO.
         *
         * @param methodVO The MethodVO object linking this method with the pass currently being compiled.
         *
         * @internal
         */
        _Shader_MethodBase.prototype._initConstants = function () {
        };
        /**
         * Resets the compilation state of the method.
         *
         * @internal
         */
        _Shader_MethodBase.prototype._reset = function (chunkVO) {
            this._invalid = true;
            chunkVO.useChunk = false;
            chunkVO.needsProjection = false;
            chunkVO.needsView = false;
            chunkVO.needsNormals = false;
            chunkVO.needsTangents = false;
            chunkVO.needsGlobalVertexPos = false;
            chunkVO.needsGlobalFragmentPos = false;
            this._cleanCompilationData();
        };
        /**
         * Resets the method's state for compilation.
         *
         * @internal
         */
        _Shader_MethodBase.prototype._cleanCompilationData = function () {
        };
        /**
         * Get the vertex shader code for this method.
         * @param vo The MethodVO object linking this method with the pass currently being compiled.
         * @param regCache The register cache used during the compilation.
         *
         * @internal
         */
        _Shader_MethodBase.prototype._getVertexCode = function (registerCache, sharedRegisters) {
            return "";
        };
        /**
         * @inheritDoc
         */
        _Shader_MethodBase.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            return "";
        };
        /**
         * Sets the render state for this method.
         *
         * @param methodVO The MethodVO object linking this method with the pass currently being compiled.
         * @param stage The Stage object currently used for rendering.
         *
         * @internal
         */
        _Shader_MethodBase.prototype._activate = function () {
        };
        /**
         * Sets the render state for a single renderable.
         *
         * @param vo The MethodVO object linking this method with the pass currently being compiled.
         * @param renderable The renderable currently being rendered.
         * @param stage The Stage object currently used for rendering.
         * @param camera The camera from which the scene is currently rendered.
         *
         * @internal
         */
        _Shader_MethodBase.prototype._setRenderState = function (renderState, view) {
        };
        /**
         * Clears the render state for this method.
         * @param vo The MethodVO object linking this method with the pass currently being compiled.
         * @param stage The Stage object currently used for rendering.
         *
         * @internal
         */
        _Shader_MethodBase.prototype._deactivate = function () {
            this._invalid = false;
        };
        return _Shader_MethodBase;
    }(AbstractionBase));

    var ShadowMapperBase = /** @class */ (function (_super) {
        __extends$7(ShadowMapperBase, _super);
        function ShadowMapperBase() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._epsilon = .02;
            _this._alpha = 1;
            _this.autoUpdate = true;
            return _this;
        }
        Object.defineProperty(ShadowMapperBase.prototype, "textureMap", {
            get: function () {
                return this._textureMap;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShadowMapperBase.prototype, "alpha", {
            /**
             * The "transparency" of the shadows. This allows making shadows less strong.
             */
            get: function () {
                return this._alpha;
            },
            set: function (value) {
                this._alpha = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShadowMapperBase.prototype, "light", {
            get: function () {
                return this._light;
            },
            set: function (value) {
                if (this._light == value)
                    return;
                this._light = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShadowMapperBase.prototype, "epsilon", {
            /**
             * A small value to counter floating point precision errors when comparing values in the shadow map with the
             * calculated depth value. Increase this if shadow banding occurs, decrease it if the shadow seems to be too detached.
             */
            get: function () {
                return this._epsilon;
            },
            set: function (value) {
                this._epsilon = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShadowMapperBase.prototype, "size", {
            get: function () {
                return this._size;
            },
            set: function (value) {
                if (this._size == value)
                    return;
                this._size = value;
                this._updateSize();
            },
            enumerable: true,
            configurable: true
        });
        ShadowMapperBase.prototype.update = function (partition, renderGroup) {
            this._updateProjection(renderGroup.view.projection);
            this._renderMap(partition, renderGroup);
        };
        ShadowMapperBase.prototype._updateProjection = function (projection) {
            throw new AbstractMethodError();
        };
        ShadowMapperBase.prototype._renderMap = function (partition, renderGroup) {
            throw new AbstractMethodError();
        };
        ShadowMapperBase.prototype._updateSize = function () {
            throw new AbstractMethodError();
        };
        ShadowMapperBase.prototype.dispose = function () {
            this._light = null;
        };
        return ShadowMapperBase;
    }(MethodBase));
    /**
     * _Shader_ShadowMapperBase provides an abstract method for simple (non-wrapping) shadow map methods.
     */
    var _Shader_ShadowMapperBase = /** @class */ (function (_super) {
        __extends$7(_Shader_ShadowMapperBase, _super);
        /**
         * Creates a new _Shader_ShadowMapperBase object.
         */
        function _Shader_ShadowMapperBase(mapper, shader) {
            var _this = _super.call(this, mapper, shader) || this;
            _this.autoUpdate = true;
            _this._mapper = mapper;
            _this._shader = shader;
            _this._shader.renderMaterial.renderGroup._addMapper(_this._mapper);
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_ShadowMapperBase.prototype._cleanCompilationData = function () {
            _super.prototype._cleanCompilationData.call(this);
            this._depthMapCoordReg = null;
        };
        Object.defineProperty(_Shader_ShadowMapperBase.prototype, "texture", {
            get: function () {
                return this._texture;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Shader_ShadowMapperBase.prototype, "depthMapCoordReg", {
            /**
             * Wrappers that override the vertex shader need to set this explicitly
             */
            get: function () {
                return this._depthMapCoordReg;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        _Shader_ShadowMapperBase.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            this._shader.renderMaterial.renderGroup._removeMapper(this._mapper);
        };
        /**
         * @inheritDoc
         */
        _Shader_ShadowMapperBase.prototype._initVO = function (chunkVO) {
            this._texture = this._shader.getAbstraction(this._mapper.textureMap);
            this._texture._initVO(chunkVO);
        };
        _Shader_ShadowMapperBase.prototype._initConstants = function () {
            this._texture._initConstants();
        };
        /**
         * @inheritDoc
         */
        _Shader_ShadowMapperBase.prototype._getFragmentCode = function (targetReg, regCache, sharedRegs) {
            var dataReg = regCache.getFreeFragmentConstant();
            this._fragmentAlphaIndex = dataReg.index * 4;
            return "add " + targetReg + ".w, " + targetReg + ".w, " + dataReg + ".x\n" + // add alpha
                "sat " + targetReg + ".w, " + targetReg + ".w\n";
        };
        /**
         * @inheritDoc
         */
        _Shader_ShadowMapperBase.prototype._activate = function () {
            var fragmentData = this._shader.fragmentConstantData;
            var index = this._fragmentAlphaIndex;
            fragmentData[index] = 1 - this._mapper.alpha;
            this._texture.activate();
        };
        /**
         * @inheritDoc
         */
        _Shader_ShadowMapperBase.prototype._setRenderState = function (renderState, view) {
            this._texture._setRenderState(renderState);
        };
        return _Shader_ShadowMapperBase;
    }(_Shader_MethodBase));

    var DirectionalShadowMapper = /** @class */ (function (_super) {
        __extends$7(DirectionalShadowMapper, _super);
        function DirectionalShadowMapper(image2D) {
            if (image2D === void 0) { image2D = null; }
            var _this = _super.call(this) || this;
            _this._lightOffset = 10000;
            _this._snap = 64;
            _this._size = 2048;
            _this._image2D = image2D || new Image2D(_this._size, _this._size);
            _this._textureMap = new ShadowTexture2D(_this._image2D);
            _this.iAddTexture(_this._textureMap);
            _this._cullPlanes = [];
            _this._overallDepthProjection = new OrthographicProjection();
            _this._overallDepthProjection.transform = new Transform();
            _this._localFrustum = [];
            _this._matrix = new Matrix3D();
            return _this;
        }
        Object.defineProperty(DirectionalShadowMapper.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return DirectionalShadowMapper.assetType;
            },
            enumerable: true,
            configurable: true
        });
        DirectionalShadowMapper.prototype.dispose = function () {
            _super.prototype.dispose.call(this);
            this._textureMap.image = null;
            this._textureMap = null;
            this._image2D = null;
        };
        Object.defineProperty(DirectionalShadowMapper.prototype, "snap", {
            get: function () {
                return this._snap;
            },
            set: function (value) {
                this._snap = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DirectionalShadowMapper.prototype, "lightOffset", {
            get: function () {
                return this._lightOffset;
            },
            set: function (value) {
                this._lightOffset = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DirectionalShadowMapper.prototype, "depthProjection", {
            //@arcane
            get: function () {
                return this._overallDepthProjection.viewMatrix3D;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DirectionalShadowMapper.prototype, "depth", {
            //@arcane
            get: function () {
                return this._maxZ - this._minZ;
            },
            enumerable: true,
            configurable: true
        });
        DirectionalShadowMapper.prototype._updateSize = function () {
            this._image2D._setSize(this._size, this._size);
        };
        /**
         *
         * @param projection
         * @private
         */
        DirectionalShadowMapper.prototype._updateProjection = function (projection) {
            this._updateProjectionFromFrustumCorners(projection, projection.viewFrustumCorners, this._matrix);
            this._overallDepthProjection.frustumMatrix3D = this._matrix;
            this._updateCullPlanes(projection);
        };
        //@override
        DirectionalShadowMapper.prototype._renderMap = function (partition, renderGroup) {
            var depthRenderer = renderGroup.depthRenderGroup.getRenderer(partition);
            depthRenderer.cullPlanes = this._cullPlanes;
            depthRenderer.view.preservePixelRatio = false;
            depthRenderer.view.target = this._image2D;
            depthRenderer.view.projection = this._overallDepthProjection;
            depthRenderer.render();
        };
        /**
         *
         * @param projection
         * @private
         */
        DirectionalShadowMapper.prototype._updateCullPlanes = function (projection) {
            var lightFrustumPlanes = this._overallDepthProjection.viewFrustumPlanes;
            var viewFrustumPlanes = projection.viewFrustumPlanes;
            this._cullPlanes.length = 4;
            this._cullPlanes[0] = lightFrustumPlanes[0];
            this._cullPlanes[1] = lightFrustumPlanes[1];
            this._cullPlanes[2] = lightFrustumPlanes[2];
            this._cullPlanes[3] = lightFrustumPlanes[3];
            var dir = this._light.sceneDirection;
            var dirX = dir.x;
            var dirY = dir.y;
            var dirZ = dir.z;
            var j = 4;
            for (var i = 0; i < 6; ++i) {
                var plane = viewFrustumPlanes[i];
                if (plane.a * dirX + plane.b * dirY + plane.c * dirZ < 0)
                    this._cullPlanes[j++] = plane;
            }
        };
        /**
         *
         * @param projection
         * @param matrix
         * @private
         */
        DirectionalShadowMapper.prototype._updateProjectionFromFrustumCorners = function (projection, corners, matrix) {
            var x, y, z;
            var minX, minY;
            var maxX, maxY;
            var i;
            var pos = projection.transform.concatenatedMatrix3D.position;
            var dir = this._light.sceneDirection;
            this._overallDepthProjection.transform.matrix3D = this._light.transform.concatenatedMatrix3D;
            x = Math.floor((pos.x - dir.x * this._lightOffset) / this._snap) * this._snap;
            y = Math.floor((pos.y - dir.y * this._lightOffset) / this._snap) * this._snap;
            z = Math.floor((pos.z - dir.z * this._lightOffset) / this._snap) * this._snap;
            this._overallDepthProjection.transform.moveTo(x, y, z);
            this._overallDepthProjection.transform.inverseConcatenatedMatrix3D.transformVectors(corners, this._localFrustum);
            minX = maxX = this._localFrustum[0];
            minY = maxY = this._localFrustum[1];
            this._maxZ = this._localFrustum[2];
            i = 3;
            while (i < 24) {
                x = this._localFrustum[i];
                y = this._localFrustum[i + 1];
                z = this._localFrustum[i + 2];
                if (x < minX)
                    minX = x;
                if (x > maxX)
                    maxX = x;
                if (y < minY)
                    minY = y;
                if (y > maxY)
                    maxY = y;
                if (z > this._maxZ)
                    this._maxZ = z;
                i += 3;
            }
            this._minZ = 1;
            var w = maxX - minX;
            var h = maxY - minY;
            var d = 1 / (this._maxZ - this._minZ);
            if (minX < 0)
                minX -= this._snap; // because int() rounds up for < 0
            if (minY < 0)
                minY -= this._snap;
            minX = Math.floor(minX / this._snap) * this._snap;
            minY = Math.floor(minY / this._snap) * this._snap;
            var snap2 = 2 * this._snap;
            w = Math.floor(w / snap2 + 2) * snap2;
            h = Math.floor(h / snap2 + 2) * snap2;
            maxX = minX + w;
            maxY = minY + h;
            w = 1 / w;
            h = 1 / h;
            var raw = matrix._rawData;
            raw[0] = 2 * w;
            raw[5] = 2 * h;
            raw[10] = d;
            raw[12] = -(maxX + minX) * w;
            raw[13] = -(maxY + minY) * h;
            raw[14] = -this._minZ * d;
            raw[15] = 1;
            raw[1] = raw[2] = raw[3] = raw[4] = raw[6] = raw[7] = raw[8] = raw[9] = raw[11] = 0;
            matrix.invalidatePosition();
        };
        DirectionalShadowMapper.assetType = "[asset DirectionalShadowMapper]";
        return DirectionalShadowMapper;
    }(ShadowMapperBase));
    /**
     * ShadowChunkBase provides an abstract method for simple (non-wrapping) shadow map methods.
     */
    var _Shader_DirectionalShadowMapper = /** @class */ (function (_super) {
        __extends$7(_Shader_DirectionalShadowMapper, _super);
        function _Shader_DirectionalShadowMapper() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_DirectionalShadowMapper.prototype._initVO = function (chunkVO) {
            _super.prototype._initVO.call(this, chunkVO);
            chunkVO.needsView = true;
            chunkVO.needsGlobalVertexPos = true;
        };
        /**
         * @inheritDoc
         */
        _Shader_DirectionalShadowMapper.prototype._initConstants = function () {
            _super.prototype._initConstants.call(this);
            var vertexData = this._shader.vertexConstantData;
            var index = this._vertexScalingIndex;
            vertexData[index] = .5;
            vertexData[index + 1] = .5;
            vertexData[index + 2] = 0.0;
            vertexData[index + 3] = 1.0;
            this._depthProjectionMatrix = new Matrix3D(new Float32Array(this._shader.vertexConstantData.buffer, (index + 4) * 4, 16));
        };
        /**
         * @inheritDoc
         */
        _Shader_DirectionalShadowMapper.prototype._getVertexCode = function (regCache, sharedRegisters) {
            var code = "";
            var temp = regCache.getFreeVertexVectorTemp();
            var dataReg = regCache.getFreeVertexConstant();
            this._vertexScalingIndex = dataReg.index * 4;
            var depthMapProj = regCache.getFreeVertexConstant();
            regCache.getFreeVertexConstant();
            regCache.getFreeVertexConstant();
            regCache.getFreeVertexConstant();
            this._depthMapCoordReg = regCache.getFreeVarying();
            code += "m44 " + temp + ", " + sharedRegisters.globalPositionVertex + ", " + depthMapProj + "\n" +
                "div " + temp + ", " + temp + ", " + temp + ".w\n" +
                "mul " + temp + ".xy, " + temp + ".xy, " + dataReg + ".xy\n" +
                "add " + this._depthMapCoordReg + ", " + temp + ", " + dataReg + ".xxwz\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_DirectionalShadowMapper.prototype._activate = function () {
            _super.prototype._activate.call(this);
            var vertexData = this._shader.vertexConstantData;
            var index = this._vertexScalingIndex;
            vertexData[this._vertexScalingIndex + 3] = -1 / (this._mapper.depth * this._mapper.epsilon);
            this._depthProjectionMatrix.copyFrom(this._mapper.depthProjection, true);
        };
        return _Shader_DirectionalShadowMapper;
    }(_Shader_ShadowMapperBase));
    ShaderBase.registerAbstraction(_Shader_DirectionalShadowMapper, DirectionalShadowMapper);

    var LightBase = /** @class */ (function (_super) {
        __extends$7(LightBase, _super);
        function LightBase(transform) {
            if (transform === void 0) { transform = null; }
            var _this = _super.call(this) || this;
            _this._color = 0xffffff;
            _this._colorR = 1;
            _this._colorG = 1;
            _this._colorB = 1;
            _this._ambientColor = 0xffffff;
            _this._ambient = 0;
            _this._specular = 1;
            _this._diffuse = 1;
            _this._shadowsEnabled = false;
            _this._ambientR = 0;
            _this._ambientG = 0;
            _this._ambientB = 0;
            _this._specularR = 1;
            _this._specularG = 1;
            _this._specularB = 1;
            _this._diffuseR = 1;
            _this._diffuseG = 1;
            _this._diffuseB = 1;
            _this._onInvalidateConcatenatedMatrix3DDelegate = function (event) { return _this._onInvalidateConcatenatedMatrix3D(event); };
            _this.transform = transform || new Transform();
            return _this;
        }
        Object.defineProperty(LightBase.prototype, "transform", {
            get: function () {
                return this._transform;
            },
            set: function (value) {
                if (this._transform == value)
                    return;
                if (this._transform)
                    this._transform.removeEventListener(TransformEvent.INVALIDATE_CONCATENATED_MATRIX3D, this._onInvalidateConcatenatedMatrix3DDelegate);
                this._transform = value;
                if (this._transform)
                    this._transform.addEventListener(TransformEvent.INVALIDATE_CONCATENATED_MATRIX3D, this._onInvalidateConcatenatedMatrix3DDelegate);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightBase.prototype, "shadowsEnabled", {
            get: function () {
                return this._shadowsEnabled;
            },
            set: function (value) {
                if (this._shadowsEnabled == value)
                    return;
                this._shadowsEnabled = value;
                if (value && this._shadowMapper == null) {
                    this._shadowMapper = this._createShadowMapper();
                    this._shadowMapper.light = this;
                }
                else if (!value) {
                    this._shadowMapper.dispose();
                    this._shadowMapper = null;
                }
                this.dispatchEvent(new LightEvent(LightEvent.CASTS_SHADOW_CHANGE));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightBase.prototype, "specular", {
            get: function () {
                return this._specular;
            },
            set: function (value) {
                if (value < 0)
                    value = 0;
                this._specular = value;
                this._updateSpecular();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightBase.prototype, "diffuse", {
            get: function () {
                return this._diffuse;
            },
            set: function (value) {
                if (value < 0)
                    value = 0;
                this._diffuse = value;
                this._updateDiffuse();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightBase.prototype, "color", {
            get: function () {
                return this._color;
            },
            set: function (value) {
                this._color = value;
                this._colorR = ((this._color >> 16) & 0xff) / 0xff;
                this._colorG = ((this._color >> 8) & 0xff) / 0xff;
                this._colorB = (this._color & 0xff) / 0xff;
                this._updateDiffuse();
                this._updateSpecular();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightBase.prototype, "ambient", {
            get: function () {
                return this._ambient;
            },
            set: function (value) {
                if (value < 0)
                    value = 0;
                else if (value > 1)
                    value = 1;
                this._ambient = value;
                this._updateAmbient();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightBase.prototype, "ambientColor", {
            get: function () {
                return this._ambientColor;
            },
            set: function (value) {
                if (this._ambientColor == value)
                    return;
                this._ambientColor = value;
                this._updateAmbient();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightBase.prototype, "shadowMapper", {
            get: function () {
                this.shadowsEnabled = true; //ensure shadows are enabled on light
                return this._shadowMapper;
            },
            set: function (value) {
                if (this._shadowMapper == value)
                    return;
                this._shadowMapper = value;
                this._shadowMapper.light = this;
            },
            enumerable: true,
            configurable: true
        });
        // public _getEntityProjectionMatrix(entity:IEntity, cameraTransform:Matrix3D, target:Matrix3D = null):Matrix3D
        // {
        // 	throw new AbstractMethodError();
        // }
        LightBase.prototype._createShadowMapper = function () {
            throw new AbstractMethodError();
        };
        LightBase.prototype._updateSpecular = function () {
            this._specularR = this._colorR * this._specular;
            this._specularG = this._colorG * this._specular;
            this._specularB = this._colorB * this._specular;
        };
        LightBase.prototype._updateDiffuse = function () {
            this._diffuseR = this._colorR * this._diffuse;
            this._diffuseG = this._colorG * this._diffuse;
            this._diffuseB = this._colorB * this._diffuse;
        };
        LightBase.prototype._updateAmbient = function () {
            this._ambientR = ((this._ambientColor >> 16) & 0xff) / 0xff * this._ambient;
            this._ambientG = ((this._ambientColor >> 8) & 0xff) / 0xff * this._ambient;
            this._ambientB = (this._ambientColor & 0xff) / 0xff * this._ambient;
        };
        LightBase.prototype._onInvalidateConcatenatedMatrix3D = function (event) {
            //do nothing - to be overridden
        };
        return LightBase;
    }(AssetBase));

    var DirectionalLight = /** @class */ (function (_super) {
        __extends$7(DirectionalLight, _super);
        function DirectionalLight(direction, transform) {
            if (direction === void 0) { direction = null; }
            if (transform === void 0) { transform = null; }
            var _this = _super.call(this, transform) || this;
            _this._sceneDirectionDirty = true;
            if (direction)
                _this.direction = direction;
            _this._sceneDirection = new Vector3D();
            return _this;
        }
        Object.defineProperty(DirectionalLight.prototype, "assetType", {
            get: function () {
                return DirectionalLight.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DirectionalLight.prototype, "sceneDirection", {
            get: function () {
                if (this._sceneDirectionDirty)
                    this._updateSceneDirection();
                return this._sceneDirection;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DirectionalLight.prototype, "direction", {
            get: function () {
                return this._direction;
            },
            set: function (value) {
                this._direction = value;
                if (!this._tmpLookAt)
                    this._tmpLookAt = new Vector3D();
                this._tmpLookAt.x = this.transform.position.x + this._direction.x;
                this._tmpLookAt.y = this.transform.position.y + this._direction.y;
                this._tmpLookAt.z = this.transform.position.z + this._direction.z;
                this.transform.lookAt(this._tmpLookAt);
            },
            enumerable: true,
            configurable: true
        });
        DirectionalLight.prototype._onInvalidateConcatenatedMatrix3D = function (event) {
            this._sceneDirectionDirty = true;
        };
        DirectionalLight.prototype._updateSceneDirection = function () {
            this._sceneDirectionDirty = false;
            this.transform.concatenatedMatrix3D.copyColumnTo(2, this._sceneDirection);
            this._sceneDirection.normalize();
        };
        DirectionalLight.prototype._createShadowMapper = function () {
            return new DirectionalShadowMapper();
        };
        DirectionalLight.assetType = "[light DirectionalLight]";
        return DirectionalLight;
    }(LightBase));

    var LightProbe = /** @class */ (function (_super) {
        __extends$7(LightProbe, _super);
        function LightProbe(diffuseMap, specularMap) {
            if (specularMap === void 0) { specularMap = null; }
            var _this = _super.call(this) || this;
            _this.diffuseSampler = new ImageSampler();
            _this.specularSampler = new ImageSampler();
            _this.diffuseMap = diffuseMap;
            _this.specularMap = specularMap;
            return _this;
        }
        Object.defineProperty(LightProbe.prototype, "assetType", {
            get: function () {
                return LightProbe.assetType;
            },
            enumerable: true,
            configurable: true
        });
        LightProbe.assetType = "[light LightProbe]";
        return LightProbe;
    }(LightBase));

    var ShadowTextureCube = /** @class */ (function (_super) {
        __extends$7(ShadowTextureCube, _super);
        function ShadowTextureCube(mapper, image) {
            if (image === void 0) { image = null; }
            var _this = _super.call(this, image) || this;
            _this._mapper = mapper;
            return _this;
        }
        Object.defineProperty(ShadowTextureCube.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return ShadowTextureCube.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShadowTextureCube.prototype, "mapper", {
            get: function () {
                return this._mapper;
            },
            enumerable: true,
            configurable: true
        });
        ShadowTextureCube.assetType = "[texture ShadowTextureCube]";
        return ShadowTextureCube;
    }(ImageTextureCube));
    /**
     *
     * @class away.pool._Shader_DepthTexture
     */
    var _Shader_ShadowTextureCube = /** @class */ (function (_super) {
        __extends$7(_Shader_ShadowTextureCube, _super);
        function _Shader_ShadowTextureCube() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_ShadowTextureCube.prototype._getFragmentCode = function (targetReg, regCache, sharedRegisters, inputReg) {
            var posReg = regCache.getFreeFragmentConstant();
            this._positionIndex = posReg.index * 4;
            var epsReg = regCache.getFreeFragmentConstant();
            var code = "";
            var lightDir = regCache.getFreeFragmentVectorTemp();
            code += "sub " + lightDir + ", " + inputReg + ", " + posReg + "\n" +
                "dp3 " + lightDir + ".w, " + lightDir + ".xyz, " + lightDir + ".xyz\n" +
                "nrm " + lightDir + ".xyz, " + lightDir + ".xyz\n";
            code += _super.prototype._getFragmentCode.call(this, targetReg, regCache, sharedRegisters, lightDir) +
                "add " + lightDir + ".w, " + lightDir + ".w, " + epsReg + ".x\n" + // offset by epsilon (add 2*light*epsilon)?
                "mul " + lightDir + ".w, " + lightDir + ".w, " + posReg + ".w\n" + // divide by falloff squared to normalise
                "slt " + targetReg + ".w, " + lightDir + ".w, " + targetReg + ".w\n"; // 0 if in shadow
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_ShadowTextureCube.prototype._activate = function () {
            _super.prototype.activate.call(this);
            var fragmentData = this._shader.fragmentConstantData;
            var index = this._positionIndex;
            var pos = this._texture.mapper.light.transform.concatenatedMatrix3D.position;
            var fallOff = this._texture.mapper.light.fallOff; // used to decompress distance
            fragmentData[index] = pos.x;
            fragmentData[index + 1] = pos.y;
            fragmentData[index + 2] = pos.z;
            fragmentData[index + 3] = 1 / (2 * fallOff * fallOff); //TODO: do we need the 2?
            //epsilon
            fragmentData[index + 4] = -Math.pow(1 / (fallOff * this._texture.mapper.epsilon), 2);
        };
        return _Shader_ShadowTextureCube;
    }(_Shader_DepthTexture));
    ShaderBase.registerAbstraction(_Shader_ShadowTextureCube, ShadowTextureCube);

    var PointShadowMapper = /** @class */ (function (_super) {
        __extends$7(PointShadowMapper, _super);
        function PointShadowMapper(imageCube) {
            if (imageCube === void 0) { imageCube = null; }
            var _this = _super.call(this) || this;
            _this._needsRender = new Array();
            _this._size = 512;
            _this._imageCube = imageCube || new ImageCube(_this._size);
            _this._textureMap = new ShadowTextureCube(_this, _this._imageCube);
            _this.iAddTexture(_this._textureMap);
            _this.initCameras();
            return _this;
        }
        Object.defineProperty(PointShadowMapper.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return PointShadowMapper.assetType;
            },
            enumerable: true,
            configurable: true
        });
        PointShadowMapper.prototype.dispose = function () {
            _super.prototype.dispose.call(this);
            this._textureMap.image = null;
            this._textureMap = null;
            this._imageCube = null;
        };
        PointShadowMapper.prototype.initCameras = function () {
            this._depthProjections = new Array();
            // posX, negX, posY, negY, posZ, negZ
            this.addProjection(0, 90, 0);
            this.addProjection(0, -90, 0);
            this.addProjection(-90, 0, 0);
            this.addProjection(90, 0, 0);
            this.addProjection(0, 0, 0);
            this.addProjection(0, 180, 0);
        };
        PointShadowMapper.prototype.addProjection = function (rotationX, rotationY, rotationZ) {
            var projection = new PerspectiveProjection();
            projection.transform = new Transform();
            projection.transform.rotateTo(rotationX, rotationY, rotationZ);
            projection.near = .01;
            projection.fieldOfView = 90;
            this._depthProjections.push(projection);
        };
        PointShadowMapper.prototype._updateSize = function () {
            this._imageCube._setSize(this._size);
        };
        /**
         *
         * @param projection
         * @private
         */
        PointShadowMapper.prototype._updateProjection = function (projection) {
            var light = (this._light);
            var maxDistance = light.fallOff;
            var pos = this._light.transform.concatenatedMatrix3D.position;
            // todo: faces outside frustum which are pointing away from camera need not be rendered!
            for (var i = 0; i < 6; ++i) {
                this._depthProjections[i].far = maxDistance;
                this._depthProjections[i].transform.moveTo(pos.x, pos.y, pos.z);
                this._needsRender[i] = true;
            }
        };
        /**
         *
         * @param view
         * @param target
         * @param renderer
         * @private
         */
        PointShadowMapper.prototype._renderMap = function (partition, renderGroup) {
            var distanceRenderer = renderGroup.distanceRenderGroup.getRenderer(partition);
            for (var i = 0; i < 6; ++i) {
                if (this._needsRender[i]) {
                    distanceRenderer.view.target = this._imageCube;
                    distanceRenderer.view.projection = this._depthProjections[i];
                    distanceRenderer.render(null, i);
                }
            }
        };
        PointShadowMapper.assetType = "[asset PointShadowMapper]";
        return PointShadowMapper;
    }(ShadowMapperBase));
    /**
     * _Shader_PointShadowMapper provides an abstract method for simple (non-wrapping) shadow map methods.
     */
    var _Shader_PointShadowMapper = /** @class */ (function (_super) {
        __extends$7(_Shader_PointShadowMapper, _super);
        function _Shader_PointShadowMapper() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_PointShadowMapper.prototype._initVO = function (chunkVO) {
            _super.prototype._initVO.call(this, chunkVO);
            chunkVO.needsGlobalFragmentPos = true;
        };
        /**
         * @inheritDoc
         */
        _Shader_PointShadowMapper.prototype._getVertexCode = function (regCache, sharedRegisters) {
            this._depthMapCoordReg = sharedRegisters.globalPositionVarying;
            return "";
        };
        return _Shader_PointShadowMapper;
    }(_Shader_ShadowMapperBase));
    ShaderBase.registerAbstraction(_Shader_PointShadowMapper, PointShadowMapper);

    var PointLight = /** @class */ (function (_super) {
        __extends$7(PointLight, _super);
        /**
         *
         */
        function PointLight(position, transform) {
            if (position === void 0) { position = null; }
            if (transform === void 0) { transform = null; }
            var _this = _super.call(this, transform) || this;
            _this._radius = 90000;
            _this._fallOff = 100000;
            if (position) {
                _this._transform.matrix3D._rawData[12] = position.x;
                _this._transform.matrix3D._rawData[13] = position.y;
                _this._transform.matrix3D._rawData[14] = position.z;
                _this._transform.invalidatePosition();
            }
            _this._fallOffFactor = 1 / (_this._fallOff * _this._fallOff - _this._radius * _this._radius);
            return _this;
        }
        Object.defineProperty(PointLight.prototype, "assetType", {
            get: function () {
                return PointLight.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PointLight.prototype, "radius", {
            /**
             *
             */
            get: function () {
                return this._radius;
            },
            set: function (value) {
                this._radius = value;
                if (this._radius < 0) {
                    this._radius = 0;
                }
                else if (this._radius > this._fallOff) {
                    this._fallOff = this._radius;
                    //this._pInvalidateBounds();
                }
                this._fallOffFactor = 1 / (this._fallOff * this._fallOff - this._radius * this._radius);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PointLight.prototype, "fallOff", {
            /**
             *
             */
            get: function () {
                return this._fallOff;
            },
            set: function (value) {
                this._fallOff = value;
                if (this._fallOff < 0)
                    this._fallOff = 0;
                if (this._fallOff < this._radius)
                    this._radius = this._fallOff;
                this._fallOffFactor = 1 / (this._fallOff * this._fallOff - this._radius * this._radius);
                //this._pInvalidateBounds();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PointLight.prototype, "fallOffFactor", {
            get: function () {
                return this._fallOffFactor;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PointLight.prototype, "x", {
            /**
             * Indicates the <i>x</i> coordinate of the DisplayObject instance relative
             * to the local coordinates of the parent DisplayObjectContainer. If the
             * object is inside a DisplayObjectContainer that has transformations, it is
             * in the local coordinate system of the enclosing DisplayObjectContainer.
             * Thus, for a DisplayObjectContainer rotated 90° counterclockwise, the
             * DisplayObjectContainer's children inherit a coordinate system that is
             * rotated 90° counterclockwise. The object's coordinates refer to the
             * registration point position.
             */
            get: function () {
                return this._transform.position.x;
            },
            set: function (val) {
                if (this._transform.position.x == val)
                    return;
                this._transform.matrix3D._rawData[12] = val;
                this._transform.invalidatePosition();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PointLight.prototype, "y", {
            /**
             * Indicates the <i>y</i> coordinate of the DisplayObject instance relative
             * to the local coordinates of the parent DisplayObjectContainer. If the
             * object is inside a DisplayObjectContainer that has transformations, it is
             * in the local coordinate system of the enclosing DisplayObjectContainer.
             * Thus, for a DisplayObjectContainer rotated 90° counterclockwise, the
             * DisplayObjectContainer's children inherit a coordinate system that is
             * rotated 90° counterclockwise. The object's coordinates refer to the
             * registration point position.
             */
            get: function () {
                return this._transform.position.y;
            },
            set: function (val) {
                if (this._transform.position.y == val)
                    return;
                this._transform.matrix3D._rawData[13] = val;
                this._transform.invalidatePosition();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PointLight.prototype, "z", {
            /**
             * Indicates the z coordinate position along the z-axis of the DisplayObject
             * instance relative to the 3D parent container. The z property is used for
             * 3D coordinates, not screen or pixel coordinates.
             *
             * <p>When you set a <code>z</code> property for a display object to
             * something other than the default value of <code>0</code>, a corresponding
             * Matrix3D object is automatically created. for adjusting a display object's
             * position and orientation in three dimensions. When working with the
             * z-axis, the existing behavior of x and y properties changes from screen or
             * pixel coordinates to positions relative to the 3D parent container.</p>
             *
             * <p>For example, a child of the <code>_root</code> at position x = 100, y =
             * 100, z = 200 is not drawn at pixel location(100,100). The child is drawn
             * wherever the 3D projection calculation puts it. The calculation is:</p>
             *
             * <p><code>(x~~cameraFocalLength/cameraRelativeZPosition,
             * y~~cameraFocalLength/cameraRelativeZPosition)</code></p>
             */
            get: function () {
                return this._transform.position.z;
            },
            set: function (val) {
                if (this._transform.position.z == val)
                    return;
                this._transform.matrix3D._rawData[14] = val;
                this._transform.invalidatePosition();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PointLight.prototype, "scenePosition", {
            get: function () {
                return this._transform.concatenatedMatrix3D.position;
            },
            enumerable: true,
            configurable: true
        });
        PointLight.prototype._createShadowMapper = function () {
            return new PointShadowMapper();
        };
        PointLight.assetType = "[light PointLight]";
        return PointLight;
    }(LightBase));

    /**
     * TextureProjector is an object in the scene that can be used to project textures onto geometry. To do so,
     * the object's material must have a ProjectiveTextureMethod method added to it with a TextureProjector object
     * passed in the constructor.
     * This can be used for various effects apart from acting like a normal projector, such as projecting fake shadows
     * unto a surface, the impact of light coming through a stained glass window, ...
     *
     * @see away3d.materials.methods.ProjectiveTextureMethod
     */
    var TextureProjector = /** @class */ (function (_super) {
        __extends$7(TextureProjector, _super);
        /**
         * Creates a new TextureProjector object.
         * @param texture The texture to be projected on the geometry. Since any point that is projected out of the range
         * of the projector's cone is clamped to the texture's edges, the edges should be entirely neutral.
         */
        function TextureProjector(texture, transform) {
            if (transform === void 0) { transform = null; }
            var _this = _super.call(this) || this;
            _this._transform = transform || new Transform();
            _this._projection = new PerspectiveProjection();
            _this._projection.transform = _this._transform;
            _this._texture = texture;
            var width = texture.getImageAt(0).width;
            var height = texture.getImageAt(0).height;
            return _this;
        }
        Object.defineProperty(TextureProjector.prototype, "transform", {
            get: function () {
                return this._transform;
            },
            set: function (value) {
                if (this._transform == value)
                    return;
                this._transform = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextureProjector.prototype, "projection", {
            /**
             *
             */
            get: function () {
                return this._projection;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextureProjector.prototype, "assetType", {
            get: function () {
                return TextureProjector.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextureProjector.prototype, "texture", {
            /**
             * The texture to be projected on the geometry.
             * IMPORTANT: Since any point that is projected out of the range of the projector's cone is clamped to the texture's edges,
             * the edges should be entirely neutral. Depending on the blend mode, the neutral color is:
             * White for MULTIPLY,
             * Black for ADD,
             * Transparent for MIX
             */
            get: function () {
                return this._texture;
            },
            set: function (value) {
                if (value == this._texture)
                    return;
                this._texture = value;
                var width = value.getImageAt(0).width;
                var height = value.getImageAt(0).height;
                this.dispatchEvent(new TextureProjectorEvent(TextureProjectorEvent.TEXTURE_CHANGE));
            },
            enumerable: true,
            configurable: true
        });
        TextureProjector.assetType = "[asset TextureProjector]";
        return TextureProjector;
    }(AssetBase));

    /**
     * AmbientBasicMethod provides the default shading method for uniform ambient lighting.
     */
    var AmbientBasicMethod = /** @class */ (function (_super) {
        __extends$7(AmbientBasicMethod, _super);
        /**
         * Creates a new AmbientBasicMethod object.
         */
        function AmbientBasicMethod() {
            var _this = _super.call(this) || this;
            _this._alpha = 1;
            _this._strength = 1;
            return _this;
        }
        Object.defineProperty(AmbientBasicMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return AmbientBasicMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AmbientBasicMethod.prototype, "strength", {
            /**
             * The strength of the ambient reflection of the surface.
             */
            get: function () {
                return this._strength;
            },
            set: function (value) {
                if (this._strength == value)
                    return;
                this._strength = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AmbientBasicMethod.prototype, "alpha", {
            /**
             * The alpha component of the surface.
             */
            get: function () {
                return this._alpha;
            },
            set: function (value) {
                if (this._alpha == value)
                    return;
                this._alpha = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AmbientBasicMethod.prototype, "texture", {
            /**
             * The texture to use to define the diffuse reflection color per texel.
             */
            get: function () {
                return this._texture;
            },
            set: function (value) {
                if (this._texture == value)
                    return;
                if (this._texture)
                    this.iRemoveTexture(this._texture);
                this._texture = value;
                if (this._texture)
                    this.iAddTexture(this._texture);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        AmbientBasicMethod.prototype.copyFrom = function (method) {
        };
        AmbientBasicMethod.assetType = "[asset AmbientBasicMethod]";
        return AmbientBasicMethod;
    }(MethodBase));
    /**
     * _Shader_AmbientBasicMethod provides the default shading method for uniform ambient lighting.
     */
    var _Shader_AmbientBasicMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_AmbientBasicMethod, _super);
        /**
         * Creates a new _Shader_AmbientBasicMethod object.
         */
        function _Shader_AmbientBasicMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        /**
         *
         */
        _Shader_AmbientBasicMethod.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            this._method = null;
            this._shader = null;
            if (this._texture) {
                this._texture.onClear(new AssetEvent(AssetEvent.CLEAR, this._method.texture));
                this._texture = null;
            }
        };
        /**
         * @inheritDoc
         */
        _Shader_AmbientBasicMethod.prototype._initVO = function (chunkVO) {
            if (this._method.texture) {
                this._texture = this._shader.getAbstraction(this._method.texture);
                this._texture._initVO(chunkVO);
                if (this._method.texture instanceof TextureCube)
                    chunkVO.needsNormals = true;
                else
                    this._shader.uvDependencies++;
            }
            else if (this._texture) {
                this._texture = null;
            }
        };
        /**
         * @inheritDoc
         */
        _Shader_AmbientBasicMethod.prototype._initConstants = function () {
            if (this._texture)
                this._texture._initConstants();
        };
        /**
         * @inheritDoc
         */
        _Shader_AmbientBasicMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code = "";
            if (this._texture) {
                code += this._texture._getFragmentCode(targetReg, registerCache, sharedRegisters, (this._method.texture instanceof TextureCube) ? sharedRegisters.normalFragment : sharedRegisters.uvVarying);
                if (this._shader.alphaThreshold > 0) {
                    var cutOffReg = registerCache.getFreeFragmentConstant();
                    this._colorIndex = cutOffReg.index * 4;
                    code += "sub " + targetReg + ".w, " + targetReg + ".w, " + cutOffReg + ".x\n" +
                        "kil " + targetReg + ".w\n" +
                        "add " + targetReg + ".w, " + targetReg + ".w, " + cutOffReg + ".x\n";
                }
            }
            else {
                var ambientInputRegister = registerCache.getFreeFragmentConstant();
                this._colorIndex = ambientInputRegister.index * 4;
                code += "mov " + targetReg + ", " + ambientInputRegister + "\n";
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_AmbientBasicMethod.prototype._activate = function () {
            if (this._texture) {
                this._texture.activate();
                if (this._invalid && this._shader.alphaThreshold > 0)
                    this._shader.fragmentConstantData[this._colorIndex] = this._shader.alphaThreshold;
            }
            else if (this._invalid) {
                var index = this._colorIndex;
                var data = this._shader.fragmentConstantData;
                var color = this._shader.numLights ? 0xFFFFFF : this._shader.renderMaterial.style.color;
                data[index] = ((color >> 16) & 0xff) / 0xff * this._method.strength;
                data[index + 1] = ((color >> 8) & 0xff) / 0xff * this._method.strength;
                data[index + 2] = (color & 0xff) / 0xff * this._method.strength;
                data[index + 3] = this._method.alpha;
            }
        };
        _Shader_AmbientBasicMethod.prototype._setRenderState = function (renderState, view) {
            if (this._texture)
                this._texture._setRenderState(renderState);
        };
        return _Shader_AmbientBasicMethod;
    }(_Shader_MethodBase));
    ShaderBase.registerAbstraction(_Shader_AmbientBasicMethod, AmbientBasicMethod);

    /**
     * AmbientDepthMethod provides a debug method to visualise depth maps
     */
    var AmbientDepthMethod = /** @class */ (function (_super) {
        __extends$7(AmbientDepthMethod, _super);
        /**
         * Creates a new AmbientDepthMethod object.
         */
        function AmbientDepthMethod(castingLight) {
            var _this = _super.call(this) || this;
            _this._castingLight = castingLight;
            castingLight.shadowsEnabled = true;
            _this._shadowMapper = castingLight.shadowMapper;
            _this.iAddTexture(castingLight.shadowMapper.textureMap);
            return _this;
        }
        Object.defineProperty(AmbientDepthMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return AmbientDepthMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AmbientDepthMethod.prototype, "castingLight", {
            /**
             * The light casting the shadows.
             */
            get: function () {
                return this._castingLight;
            },
            enumerable: true,
            configurable: true
        });
        AmbientDepthMethod.assetType = "[asset AmbientDepthMethod]";
        return AmbientDepthMethod;
    }(AmbientBasicMethod));
    /**
     * AmbientDepthChunk provides a debug method to visualise depth maps
     */
    var _Shader_AmbientDepthMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_AmbientDepthMethod, _super);
        /**
         * Creates a new AmbientBasicChunk object.
         */
        function _Shader_AmbientDepthMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._shadowTexture = shader.getAbstraction(method.castingLight.shadowMapper.textureMap);
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_AmbientDepthMethod.prototype._initVO = function (chunkVO) {
            this._shadowTexture._initVO(chunkVO);
        };
        /**
         * @inheritDoc
         */
        _Shader_AmbientDepthMethod.prototype._initConstants = function () {
            this._shadowTexture._initConstants();
            var data = this._shader.fragmentConstantData;
            var index = this._decRegIndex;
            data[index] = 1.0;
            data[index + 1] = 1 / 255.0;
            data[index + 2] = 1 / 65025.0;
            data[index + 3] = 1 / 16581375.0;
        };
        _Shader_AmbientDepthMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code = "";
            var decReg;
            var decReg = registerCache.getFreeFragmentConstant();
            this._decRegIndex = decReg.index * 4;
            code += this._shadowTexture._getFragmentCode(targetReg, registerCache, sharedRegisters, sharedRegisters.uvVarying) +
                "dp4 " + targetReg + ".x, " + targetReg + ", " + decReg + "\n" +
                "mov " + targetReg + ".yz, " + targetReg + ".xx			\n" +
                "mov " + targetReg + ".w, " + decReg + ".x\n" +
                "sub " + targetReg + ".xyz, " + decReg + ".xxx, " + targetReg + ".xyz\n";
            return code;
        };
        return _Shader_AmbientDepthMethod;
    }(_Shader_AmbientBasicMethod));
    ShaderBase.registerAbstraction(_Shader_AmbientDepthMethod, AmbientDepthMethod);

    /**
     * CompositeMethodBase provides a base class for diffuse methods that wrap a diffuse method to alter the
     * calculated diffuse reflection strength.
     */
    var CompositeMethodBase = /** @class */ (function (_super) {
        __extends$7(CompositeMethodBase, _super);
        /**
         * Creates a new <code>CompositeMethodBase</code> object.
         *
         * @param modulateMethod The method which will add the code to alter the base method's strength. It needs to have the signature clampDiffuse(t:ShaderRegisterElement, regCache:ShaderRegisterCache):string, in which t.w will contain the diffuse strength.
         * @param baseMethod The base diffuse method on which this method's shading is based.
         */
        function CompositeMethodBase(baseMethod) {
            if (baseMethod === void 0) { baseMethod = null; }
            var _this = _super.call(this) || this;
            _this._onShaderInvalidatedDelegate = function (event) { return _this.onShaderInvalidated(event); };
            _this._baseMethod = baseMethod || _this.createBaseMethod();
            _this._baseMethod.addEventListener(MethodEvent.SHADER_INVALIDATED, _this._onShaderInvalidatedDelegate);
            return _this;
        }
        Object.defineProperty(CompositeMethodBase.prototype, "baseMethod", {
            /**
             * The base diffuse method on which this method's shading is based.
             */
            get: function () {
                return this._baseMethod;
            },
            set: function (value) {
                if (this._baseMethod == value)
                    return;
                this._baseMethod.removeEventListener(MethodEvent.SHADER_INVALIDATED, this._onShaderInvalidatedDelegate);
                this._baseMethod = value;
                this._baseMethod.addEventListener(MethodEvent.SHADER_INVALIDATED, this._onShaderInvalidatedDelegate);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        CompositeMethodBase.prototype.createBaseMethod = function () {
            throw new AbstractMethodError();
        };
        CompositeMethodBase.prototype.iAddOwner = function (owner) {
            _super.prototype.iAddOwner.call(this, owner);
            this._baseMethod.iAddOwner(owner);
        };
        CompositeMethodBase.prototype.iRemoveOwner = function (owner) {
            _super.prototype.iRemoveOwner.call(this, owner);
            this._baseMethod.iRemoveOwner(owner);
        };
        /**
         * @inheritDoc
         */
        CompositeMethodBase.prototype.dispose = function () {
            this._baseMethod.removeEventListener(MethodEvent.SHADER_INVALIDATED, this._onShaderInvalidatedDelegate);
        };
        /**
         * Called when the base method's shader code is invalidated.
         */
        CompositeMethodBase.prototype.onShaderInvalidated = function (event) {
            this.invalidateShaderProgram();
        };
        return CompositeMethodBase;
    }(MethodBase));
    /**
     * _Shader_CompositeMethodBase provides a base class for diffuse methods that wrap a diffuse method to alter the
     * calculated diffuse reflection strength.
     */
    var _Shader_CompositeMethodBase = /** @class */ (function (_super) {
        __extends$7(_Shader_CompositeMethodBase, _super);
        /**
         * Creates a new <code>_Shader_CompositeMethodBase</code> object.
         *
         * @param modulateMethod The method which will add the code to alter the base method's strength. It needs to have the signature clampDiffuse(t:ShaderRegisterElement, regCache:ShaderRegisterCache):string, in which t.w will contain the diffuse strength.
         * @param baseMethod The base diffuse method on which this method's shading is based.
         */
        function _Shader_CompositeMethodBase(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this.chunkVO = new ChunkVO();
            _this._baseChunk = shader.getAbstraction(method.baseMethod);
            return _this;
        }
        _Shader_CompositeMethodBase.prototype._isUsed = function () {
            return true;
        };
        _Shader_CompositeMethodBase.prototype._usesTangentSpace = function () {
            return this._baseChunk._usesTangentSpace();
        };
        /**
         * @inheritDoc
         */
        _Shader_CompositeMethodBase.prototype._initVO = function (chunkVO) {
            this._baseChunk._initVO(chunkVO);
        };
        /**
         * @inheritDoc
         */
        _Shader_CompositeMethodBase.prototype._initConstants = function () {
            this._baseChunk._initConstants();
        };
        /**
         * @inheritDoc
         */
        _Shader_CompositeMethodBase.prototype._activate = function () {
            this._baseChunk._activate();
        };
        /**
         * @inheritDoc
         */
        _Shader_CompositeMethodBase.prototype._setRenderState = function (renderState, view) {
            this._baseChunk._setRenderState(renderState, view);
        };
        /**
         * @inheritDoc
         */
        _Shader_CompositeMethodBase.prototype._deactivate = function () {
            this._baseChunk._deactivate();
            this._invalid = false;
        };
        /**
         * @inheritDoc
         */
        _Shader_CompositeMethodBase.prototype._getVertexCode = function (registerCache, sharedRegisters) {
            return this._baseChunk._getVertexCode(registerCache, sharedRegisters);
        };
        /**
         * @inheritDoc
         */
        _Shader_CompositeMethodBase.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            return this._baseChunk._getFragmentCode(targetReg, registerCache, sharedRegisters);
        };
        /**
         * @inheritDoc
         */
        _Shader_CompositeMethodBase.prototype._reset = function (chunkVO) {
            this._baseChunk._reset(chunkVO);
            this._invalid = true;
            this._cleanCompilationData();
        };
        /**
         * @inheritDoc
         */
        _Shader_CompositeMethodBase.prototype._cleanCompilationData = function () {
            this._baseChunk._cleanCompilationData();
        };
        return _Shader_CompositeMethodBase;
    }(AbstractionBase));
    /**
     * LightingCompositeBase provides a base class for diffuse methods that wrap a diffuse method to alter the
     * calculated diffuse reflection strength.
     */
    var _Shader_LightingCompositeMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_LightingCompositeMethod, _super);
        function _Shader_LightingCompositeMethod() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_LightingCompositeMethod.prototype._getFragmentPreLightingCode = function (registerCache, sharedRegisters) {
            return this._baseChunk._getFragmentPreLightingCode(registerCache, sharedRegisters);
        };
        /**
         * @inheritDoc
         */
        _Shader_LightingCompositeMethod.prototype._getFragmentCodePerLight = function (lightDirReg, lightColReg, registerCache, sharedRegisters) {
            var code = this._baseChunk._getFragmentCodePerLight(lightDirReg, lightColReg, registerCache, sharedRegisters);
            this._totalLightColorReg = this._baseChunk._totalLightColorReg;
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_LightingCompositeMethod.prototype._getFragmentCodePerProbe = function (cubeMapReg, weightRegister, registerCache, sharedRegisters) {
            var code = this._baseChunk._getFragmentCodePerProbe(cubeMapReg, weightRegister, registerCache, sharedRegisters);
            this._totalLightColorReg = this._baseChunk._totalLightColorReg;
            return code;
        };
        return _Shader_LightingCompositeMethod;
    }(_Shader_CompositeMethodBase));

    /**
     * DiffuseBasicMethod provides the default shading method for Lambert (dot3) diffuse lighting.
     */
    var DiffuseBasicMethod = /** @class */ (function (_super) {
        __extends$7(DiffuseBasicMethod, _super);
        /**
         * Creates a new DiffuseBasicMethod object.
         */
        function DiffuseBasicMethod() {
            var _this = _super.call(this) || this;
            _this._multiply = true;
            _this._ambientColorR = 1;
            _this._ambientColorG = 1;
            _this._ambientColorB = 1;
            _this._color = 0xffffff;
            _this._colorR = 1;
            _this._colorG = 1;
            _this._colorB = 1;
            return _this;
        }
        Object.defineProperty(DiffuseBasicMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return DiffuseBasicMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DiffuseBasicMethod.prototype, "multiply", {
            /**
             * Set internally if diffuse color component multiplies or replaces the ambient color
             */
            get: function () {
                return this._multiply;
            },
            set: function (value) {
                if (this._multiply == value)
                    return;
                this._multiply = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DiffuseBasicMethod.prototype, "color", {
            /**
             * The color of the diffuse reflection when not using a texture.
             */
            get: function () {
                return this._color;
            },
            set: function (value) {
                if (this._color == value)
                    return;
                this._color = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DiffuseBasicMethod.prototype, "texture", {
            /**
             * The texture to use to define the diffuse reflection color per texel.
             */
            get: function () {
                return this._texture;
            },
            set: function (value) {
                if (this._texture == value)
                    return;
                if (this._texture)
                    this.iRemoveTexture(this._texture);
                this._texture = value;
                if (this._texture)
                    this.iAddTexture(this._texture);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        DiffuseBasicMethod.prototype.dispose = function () {
            this._texture = null;
        };
        /**
         * @inheritDoc
         */
        DiffuseBasicMethod.prototype.copyFrom = function (method) {
            var diff = method;
            this.texture = diff.texture;
            this.multiply = diff.multiply;
            this.color = diff.color;
        };
        DiffuseBasicMethod.assetType = "[asset DiffuseBasicMethod]";
        return DiffuseBasicMethod;
    }(MethodBase));
    /**
     * _Shader_DiffuseBasicMethod provides the default shading method for Lambert (dot3) diffuse lighting.
     */
    var _Shader_DiffuseBasicMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_DiffuseBasicMethod, _super);
        /**
         * Creates a new _Shader_DiffuseBasicMethod object.
         */
        function _Shader_DiffuseBasicMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._ambientColorR = 1;
            _this._ambientColorG = 1;
            _this._ambientColorB = 1;
            _this._color = 0xffffff;
            _this._colorR = 1;
            _this._colorG = 1;
            _this._colorB = 1;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        /**
         *
         */
        _Shader_DiffuseBasicMethod.prototype.onInvalidate = function (event) {
            _super.prototype.onInvalidate.call(this, event);
            this._updateProperties();
        };
        _Shader_DiffuseBasicMethod.prototype._isUsed = function () {
            return Boolean(this._shader.numLights);
        };
        _Shader_DiffuseBasicMethod.prototype._initVO = function (chunkVO) {
            if (this._method.texture) {
                this._texture = this._shader.getAbstraction(this._method.texture);
                this._texture._initVO(chunkVO);
                if (this._method.texture instanceof TextureCube)
                    chunkVO.needsNormals = true;
                else
                    this._shader.uvDependencies++;
            }
            else if (this._texture) {
                this._texture = null;
            }
            if (this._shader.numLights) {
                this._shader.usesCommonData = true;
                chunkVO.needsNormals = true;
            }
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseBasicMethod.prototype._initConstants = function () {
            if (this._texture)
                this._texture._initConstants();
            this._updateProperties();
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseBasicMethod.prototype._cleanCompilationData = function () {
            _super.prototype._cleanCompilationData.call(this);
            this._totalLightColorReg = null;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseBasicMethod.prototype._getFragmentPreLightingCode = function (registerCache, sharedRegisters) {
            var code = "";
            this._pIsFirstLight = true;
            registerCache.addFragmentTempUsages(this._totalLightColorReg = registerCache.getFreeFragmentVectorTemp(), 1);
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseBasicMethod.prototype._getFragmentCodePerLight = function (lightDirReg, lightColReg, registerCache, sharedRegisters) {
            var code = "";
            var t;
            // write in temporary if not first light, so we can add to total diffuse colour
            if (this._pIsFirstLight) {
                t = this._totalLightColorReg;
            }
            else {
                t = registerCache.getFreeFragmentVectorTemp();
                registerCache.addFragmentTempUsages(t, 1);
            }
            code += "dp3 " + t + ".x, " + lightDirReg + ", " + sharedRegisters.normalFragment + "\n" +
                "max " + t + ".w, " + t + ".x, " + sharedRegisters.commons + ".y\n";
            if (this._shader.usesLightFallOff)
                code += "mul " + t + ".w, " + t + ".w, " + lightDirReg + ".w\n";
            if (this._modulateFunction != null)
                code += this._modulateFunction(t, registerCache, sharedRegisters);
            code += "mul " + t + ", " + t + ".w, " + lightColReg + "\n";
            if (!this._pIsFirstLight) {
                code += "add " + this._totalLightColorReg + ".xyz, " + this._totalLightColorReg + ", " + t + "\n";
                registerCache.removeFragmentTempUsage(t);
            }
            this._pIsFirstLight = false;
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseBasicMethod.prototype._getFragmentCodePerProbe = function (cubeMapReg, weightRegister, registerCache, sharedRegisters) {
            var code = "";
            var t;
            // write in temporary if not first light, so we can add to total diffuse colour
            if (this._pIsFirstLight) {
                t = this._totalLightColorReg;
            }
            else {
                t = registerCache.getFreeFragmentVectorTemp();
                registerCache.addFragmentTempUsages(t, 1);
            }
            code += "tex " + t + ", " + sharedRegisters.normalFragment + ", " + cubeMapReg + " <cube,linear,miplinear>\n" +
                "mul " + t + ".xyz, " + t + ".xyz, " + weightRegister + "\n";
            if (this._modulateFunction != null)
                code += this._modulateFunction(t, registerCache, sharedRegisters);
            if (!this._pIsFirstLight) {
                code += "add " + this._totalLightColorReg + ".xyz, " + this._totalLightColorReg + ", " + t + "\n";
                registerCache.removeFragmentTempUsage(t);
            }
            this._pIsFirstLight = false;
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseBasicMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code = "";
            var diffuseColor;
            // incorporate input from ambient
            if (sharedRegisters.shadowTarget)
                code += this._applyShadow(registerCache, sharedRegisters);
            registerCache.addFragmentTempUsages(diffuseColor = registerCache.getFreeFragmentVectorTemp(), 1);
            var ambientColorRegister = registerCache.getFreeFragmentConstant();
            this._ambientColorRegister = ambientColorRegister.index * 4;
            if (this._texture) {
                code += this._texture._getFragmentCode(diffuseColor, registerCache, sharedRegisters, (this._method.texture instanceof TextureCube) ? sharedRegisters.normalFragment : sharedRegisters.uvVarying);
            }
            else {
                var diffuseColorRegister = registerCache.getFreeFragmentConstant();
                this._diffuseColorRegister = diffuseColorRegister.index * 4;
                code += "mov " + diffuseColor + ", " + diffuseColorRegister + "\n";
            }
            code += "sat " + this._totalLightColorReg + ", " + this._totalLightColorReg + "\n" +
                "mul " + diffuseColor + ".xyz, " + diffuseColor + ", " + this._totalLightColorReg + "\n";
            if (this._method.multiply) {
                code += "add " + diffuseColor + ".xyz, " + diffuseColor + ", " + ambientColorRegister + "\n" +
                    "mul " + targetReg + ".xyz, " + targetReg + ", " + diffuseColor + "\n";
            }
            else if (this._texture) {
                code += "mul " + targetReg + ".xyz, " + targetReg + ", " + ambientColorRegister + "\n" + // multiply target by ambient for total ambient
                    "mul " + this._totalLightColorReg + ".xyz, " + targetReg + ", " + this._totalLightColorReg + "\n" +
                    "sub " + targetReg + ".xyz, " + targetReg + ", " + this._totalLightColorReg + "\n" + // ambient * (1 - totalLightColor)
                    "add " + targetReg + ".xyz, " + targetReg + ", " + diffuseColor + "\n"; //add diffuse color and ambient color
            }
            else {
                code += "mul " + this._totalLightColorReg + ".xyz, " + ambientColorRegister + ", " + this._totalLightColorReg + "\n" +
                    "sub " + this._totalLightColorReg + ".xyz, " + ambientColorRegister + ", " + this._totalLightColorReg + "\n" + // ambient * (1 - totalLightColor)
                    "add " + diffuseColor + ".xyz, " + diffuseColor + ", " + this._totalLightColorReg + "\n" + // add diffuse color and  ambient color
                    "mul " + targetReg + ".xyz, " + targetReg + ", " + diffuseColor + "\n"; // multiply by target which could be texture or white
            }
            registerCache.removeFragmentTempUsage(this._totalLightColorReg);
            registerCache.removeFragmentTempUsage(diffuseColor);
            return code;
        };
        /**
         * Generate the code that applies the calculated shadow to the diffuse light
         * @param methodVO The MethodVO object for which the compilation is currently happening.
         * @param regCache The register cache the compiler is currently using for the register management.
         */
        _Shader_DiffuseBasicMethod.prototype._applyShadow = function (regCache, sharedRegisters) {
            return "mul " + this._totalLightColorReg + ".xyz, " + this._totalLightColorReg + ", " + sharedRegisters.shadowTarget + ".w\n";
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseBasicMethod.prototype._activate = function () {
            if (this._texture) {
                this._texture.activate();
            }
            else {
                var index = this._diffuseColorRegister;
                var data = this._shader.fragmentConstantData;
                if (this._method.multiply) {
                    data[index] = this._colorR * this._ambientColorR;
                    data[index + 1] = this._colorG * this._ambientColorG;
                    data[index + 2] = this._colorB * this._ambientColorB;
                }
                else {
                    data[index] = this._colorR;
                    data[index + 1] = this._colorG;
                    data[index + 2] = this._colorB;
                }
                data[index + 3] = 1;
            }
        };
        /**
         * Updates the diffuse and ambient color data used by the render state.
         */
        _Shader_DiffuseBasicMethod.prototype._updateProperties = function () {
            this._ambientColor = this._shader.renderMaterial.style.color;
            this._ambientColorR = ((this._ambientColor >> 16) & 0xff) / 0xff;
            this._ambientColorG = ((this._ambientColor >> 8) & 0xff) / 0xff;
            this._ambientColorB = (this._ambientColor & 0xff) / 0xff;
            this._color = this._method.color;
            this._colorR = ((this._color >> 16) & 0xff) / 0xff;
            this._colorG = ((this._color >> 8) & 0xff) / 0xff;
            this._colorB = (this._color & 0xff) / 0xff;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseBasicMethod.prototype._setRenderState = function (renderState, view) {
            if (this._texture)
                this._texture._setRenderState(renderState);
            //TODO move this to Activate (ambientR/G/B currently calc'd in render state)
            var index = this._ambientColorRegister;
            var data = this._shader.fragmentConstantData;
            data[index] = this._shader.ambientR * this._ambientColorR;
            data[index + 1] = this._shader.ambientG * this._ambientColorG;
            data[index + 2] = this._shader.ambientB * this._ambientColorB;
            data[index + 3] = 1;
        };
        return _Shader_DiffuseBasicMethod;
    }(_Shader_MethodBase));
    ShaderBase.registerAbstraction(_Shader_DiffuseBasicMethod, DiffuseBasicMethod);

    /**
     * DiffuseCompositeMethod provides a base class for diffuse methods that wrap a diffuse method to alter the
     * calculated diffuse reflection strength.
     */
    var DiffuseCompositeMethod = /** @class */ (function (_super) {
        __extends$7(DiffuseCompositeMethod, _super);
        /**
         * Creates a new <code>DiffuseCompositeMethod</code> object.
         *
         * @param modulateMethod The method which will add the code to alter the base method's strength. It needs to have the signature clampDiffuse(t:ShaderRegisterElement, regCache:ShaderRegisterCache):string, in which t.w will contain the diffuse strength.
         * @param baseMethod The base diffuse method on which this method's shading is based.
         */
        function DiffuseCompositeMethod(baseMethod) {
            if (baseMethod === void 0) { baseMethod = null; }
            return _super.call(this, baseMethod) || this;
        }
        DiffuseCompositeMethod.prototype.createBaseMethod = function () {
            return new DiffuseBasicMethod();
        };
        Object.defineProperty(DiffuseCompositeMethod.prototype, "texture", {
            /**
             * @inheritDoc
             */
            get: function () {
                return this._baseMethod.texture;
            },
            set: function (value) {
                this._baseMethod.texture = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DiffuseCompositeMethod.prototype, "color", {
            /**
             * @inheritDoc
             */
            get: function () {
                return this._baseMethod.color;
            },
            set: function (value) {
                this._baseMethod.color = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DiffuseCompositeMethod.prototype, "multiply", {
            /**
             * @inheritDoc
             */
            get: function () {
                return this._baseMethod.multiply;
            },
            set: function (value) {
                this._baseMethod.multiply = value;
            },
            enumerable: true,
            configurable: true
        });
        return DiffuseCompositeMethod;
    }(CompositeMethodBase));

    /**
     * DiffuseCelMethod provides a shading method to add diffuse cel (cartoon) shading.
     */
    var DiffuseCelMethod = /** @class */ (function (_super) {
        __extends$7(DiffuseCelMethod, _super);
        /**
         * Creates a new DiffuseCelMethod object.
         * @param levels The amount of shadow gradations.
         * @param baseMethod An optional diffuse method on which the cartoon shading is based. If omitted, DiffuseBasicMethod is used.
         */
        function DiffuseCelMethod(levels, smoothness, baseMethod) {
            if (levels === void 0) { levels = 3; }
            if (smoothness === void 0) { smoothness = 0.1; }
            if (baseMethod === void 0) { baseMethod = null; }
            var _this = _super.call(this, baseMethod) || this;
            _this._levels = levels;
            _this._smoothness = smoothness;
            return _this;
        }
        Object.defineProperty(DiffuseCelMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return DiffuseCelMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DiffuseCelMethod.prototype, "levels", {
            /**
             * The amount of shadow gradations.
             */
            get: function () {
                return this._levels;
            },
            set: function (value) {
                this._levels = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DiffuseCelMethod.prototype, "smoothness", {
            /**
             * The smoothness of the edge between 2 shading levels.
             */
            get: function () {
                return this._smoothness;
            },
            set: function (value) {
                this._smoothness = value;
            },
            enumerable: true,
            configurable: true
        });
        DiffuseCelMethod.assetType = "[asset DiffuseCelMethod]";
        return DiffuseCelMethod;
    }(DiffuseCompositeMethod));
    /**
     * _Shader_DiffuseCelMethod provides a shading method to add diffuse cel (cartoon) shading.
     */
    var _Shader_DiffuseCelMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_DiffuseCelMethod, _super);
        /**
         * Creates a new _Shader_DiffuseCelMethod object.
         * @param levels The amount of shadow gradations.
         * @param baseMethod An optional diffuse method on which the cartoon shading is based. If omitted, DiffuseBasicMethod is used.
         */
        function _Shader_DiffuseCelMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            _this._baseChunk._modulateFunction = function (targetReg, registerCache, sharedRegisters) { return _this.clampDiffuse(targetReg, registerCache, sharedRegisters); };
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_DiffuseCelMethod.prototype._initConstants = function () {
            _super.prototype._initConstants.call(this);
            var data = this._shader.fragmentConstantData;
            var index = this._clampDataIndex;
            data[index + 1] = 1;
            data[index + 2] = 0;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseCelMethod.prototype._cleanCompilationData = function () {
            _super.prototype._cleanCompilationData.call(this);
            this._clampDataRegister = null;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseCelMethod.prototype._getFragmentPreLightingCode = function (registerCache, sharedRegisters) {
            this._clampDataRegister = registerCache.getFreeFragmentConstant();
            this._clampDataIndex = this._clampDataRegister.index * 4;
            return _super.prototype._getFragmentPreLightingCode.call(this, registerCache, sharedRegisters);
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseCelMethod.prototype._activate = function () {
            _super.prototype._activate.call(this);
            if (this._invalid) {
                var data = this._shader.fragmentConstantData;
                var index = this._clampDataIndex;
                data[index] = this._method.levels;
                data[index + 3] = this._method.smoothness;
            }
        };
        /**
         * Snaps the diffuse shading of the wrapped method to one of the levels.
         * @param vo The MethodVO used to compile the current shader.
         * @param t The register containing the diffuse strength in the "w" component.
         * @param regCache The register cache used for the shader compilation.
         * @param sharedRegisters The shared register data for this shader.
         * @return The AGAL fragment code for the method.
         */
        _Shader_DiffuseCelMethod.prototype.clampDiffuse = function (targetReg, registerCache, sharedRegisters) {
            return "mul " + targetReg + ".w, " + targetReg + ".w, " + this._clampDataRegister + ".x\n" +
                "frc " + targetReg + ".z, " + targetReg + ".w\n" +
                "sub " + targetReg + ".y, " + targetReg + ".w, " + targetReg + ".z\n" +
                "mov " + targetReg + ".x, " + this._clampDataRegister + ".x\n" +
                "sub " + targetReg + ".x, " + targetReg + ".x, " + this._clampDataRegister + ".y\n" +
                "rcp " + targetReg + ".x," + targetReg + ".x\n" +
                "mul " + targetReg + ".w, " + targetReg + ".y, " + targetReg + ".x\n" +
                // previous clamped strength
                "sub " + targetReg + ".y, " + targetReg + ".w, " + targetReg + ".x\n" +
                // fract/epsilon (so 0 - epsilon will become 0 - 1)
                "div " + targetReg + ".z, " + targetReg + ".z, " + this._clampDataRegister + ".w\n" +
                "sat " + targetReg + ".z, " + targetReg + ".z\n" +
                "mul " + targetReg + ".w, " + targetReg + ".w, " + targetReg + ".z\n" +
                // 1-z
                "sub " + targetReg + ".z, " + this._clampDataRegister + ".y, " + targetReg + ".z\n" +
                "mul " + targetReg + ".y, " + targetReg + ".y, " + targetReg + ".z\n" +
                "add " + targetReg + ".w, " + targetReg + ".w, " + targetReg + ".y\n" +
                "sat " + targetReg + ".w, " + targetReg + ".w\n";
        };
        return _Shader_DiffuseCelMethod;
    }(_Shader_LightingCompositeMethod));
    ShaderBase.registerAbstraction(_Shader_DiffuseCelMethod, DiffuseCelMethod);

    /**
     * DiffuseGradientMethod is an alternative to DiffuseBasicMethod in which the shading can be modulated with a gradient
     * to introduce color-tinted shading as opposed to the single-channel diffuse strength. This can be used as a crude
     * approximation to subsurface scattering (for instance, the mid-range shading for skin can be tinted red to similate
     * scattered light within the skin attributing to the final colour)
     */
    var DiffuseGradientMethod = /** @class */ (function (_super) {
        __extends$7(DiffuseGradientMethod, _super);
        /**
         * Creates a new DiffuseGradientMethod object.
         * @param gradient A texture that contains the light colour based on the angle. This can be used to change
         * the light colour due to subsurface scattering when the surface faces away from the light.
         */
        function DiffuseGradientMethod(gradient) {
            var _this = _super.call(this) || this;
            _this._gradient = gradient;
            _this.iAddTexture(_this._gradient);
            return _this;
        }
        Object.defineProperty(DiffuseGradientMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return DiffuseGradientMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DiffuseGradientMethod.prototype, "gradient", {
            /**
             * A texture that contains the light colour based on the angle. This can be used to change the light colour
             * due to subsurface scattering when the surface faces away from the light.
             */
            get: function () {
                return this._gradient;
            },
            set: function (value) {
                if (this._gradient == value)
                    return;
                if (this._gradient)
                    this.iRemoveTexture(this._gradient);
                this._gradient = value;
                if (this._gradient)
                    this.iAddTexture(this._gradient);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        DiffuseGradientMethod.assetType = "[asset DiffuseGradientMethod]";
        return DiffuseGradientMethod;
    }(DiffuseBasicMethod));
    /**
     * _Shader_DiffuseGradientMethod is an alternative to _Shader_DiffuseBasicMethod in which the shading can be modulated with a gradient
     * to introduce color-tinted shading as opposed to the single-channel diffuse strength. This can be used as a crude
     * approximation to subsurface scattering (for instance, the mid-range shading for skin can be tinted red to similate
     * scattered light within the skin attributing to the final colour)
     */
    var _Shader_DiffuseGradientMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_DiffuseGradientMethod, _super);
        /**
         * Creates a new _Shader_DiffuseGradientMethod object.
         * @param gradient A texture that contains the light colour based on the angle. This can be used to change
         * the light colour due to subsurface scattering when the surface faces away from the light.
         */
        function _Shader_DiffuseGradientMethod(method, shader) {
            return _super.call(this, method, shader) || this;
        }
        _Shader_DiffuseGradientMethod.prototype._initVO = function (chunkVO) {
            _super.prototype._initVO.call(this, chunkVO);
            this._gradient = this._shader.getAbstraction(this._method.gradient || new ImageTexture2D());
            this._gradient._initVO(chunkVO);
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseGradientMethod.prototype._initConstants = function () {
            this._gradient._initConstants();
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseGradientMethod.prototype._getFragmentPreLightingCode = function (registerCache, sharedRegisters) {
            var code = _super.prototype._getFragmentPreLightingCode.call(this, registerCache, sharedRegisters);
            this._pIsFirstLight = true;
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseGradientMethod.prototype._getFragmentCodePerLight = function (lightDirReg, lightColReg, registerCache, sharedRegisters) {
            var code = "";
            var t;
            // write in temporary if not first light, so we can add to total diffuse colour
            if (this._pIsFirstLight)
                t = this._totalLightColorReg;
            else {
                t = registerCache.getFreeFragmentVectorTemp();
                registerCache.addFragmentTempUsages(t, 1);
            }
            code += "dp3 " + t + ".w, " + lightDirReg + ".xyz, " + sharedRegisters.normalFragment + ".xyz\n" +
                "mul " + t + ".w, " + t + ".w, " + sharedRegisters.commons + ".x\n" +
                "add " + t + ".w, " + t + ".w, " + sharedRegisters.commons + ".x\n" +
                "mul " + t + ".xyz, " + t + ".w, " + lightDirReg + ".w\n";
            if (this._modulateFunction != null)
                code += this._modulateFunction(t, registerCache, sharedRegisters);
            code += this._gradient._getFragmentCode(t, registerCache, sharedRegisters, t) +
                //					"mul " + t + ".xyz, " + t + ".xyz, " + t + ".w\n" +
                "mul " + t + ".xyz, " + t + ".xyz, " + lightColReg + ".xyz\n";
            if (!this._pIsFirstLight) {
                code += "add " + this._totalLightColorReg + ".xyz, " + this._totalLightColorReg + ".xyz, " + t + ".xyz\n";
                registerCache.removeFragmentTempUsage(t);
            }
            this._pIsFirstLight = false;
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseGradientMethod.prototype._activate = function () {
            _super.prototype._activate.call(this);
            this._gradient.activate();
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseGradientMethod.prototype._setRenderState = function (renderState, view) {
            _super.prototype._setRenderState.call(this, renderState, view);
            this._gradient._setRenderState(renderState);
        };
        return _Shader_DiffuseGradientMethod;
    }(_Shader_DiffuseBasicMethod));
    ShaderBase.registerAbstraction(_Shader_DiffuseGradientMethod, DiffuseGradientMethod);

    /**
     * DiffuseLightMapMethod provides a diffuse shading method that uses a light map to modulate the calculated diffuse
     * lighting. It is different from EffectLightMapMethod in that the latter modulates the entire calculated pixel color, rather
     * than only the diffuse lighting value.
     */
    var DiffuseLightMapMethod = /** @class */ (function (_super) {
        __extends$7(DiffuseLightMapMethod, _super);
        /**
         * Creates a new DiffuseLightMapMethod method.
         *
         * @param lightMap The texture containing the light map.
         * @param blendMode The blend mode with which the light map should be applied to the lighting result.
         * @param useSecondaryUV Indicates whether the secondary UV set should be used to map the light map.
         * @param baseMethod The diffuse method used to calculate the regular diffuse-based lighting.
         */
        function DiffuseLightMapMethod(lightMap, blendMode, useSecondaryUV, baseMethod) {
            if (blendMode === void 0) { blendMode = "multiply"; }
            if (useSecondaryUV === void 0) { useSecondaryUV = false; }
            if (baseMethod === void 0) { baseMethod = null; }
            var _this = _super.call(this, baseMethod) || this;
            _this._lightMap = lightMap;
            _this.blendMode = blendMode;
            _this._useSecondaryUV = useSecondaryUV;
            if (_this._lightMap)
                _this.iAddTexture(_this._lightMap);
            return _this;
        }
        Object.defineProperty(DiffuseLightMapMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return DiffuseLightMapMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DiffuseLightMapMethod.prototype, "blendMode", {
            /**
             * The blend mode with which the light map should be applied to the lighting result.
             *
             * @see DiffuseLightMapMethod.ADD
             * @see DiffuseLightMapMethod.MULTIPLY
             */
            get: function () {
                return this._blendMode;
            },
            set: function (value) {
                if (value != DiffuseLightMapMethod.ADD && value != DiffuseLightMapMethod.MULTIPLY)
                    throw new Error("Unknown blendmode!");
                if (this._blendMode == value)
                    return;
                this._blendMode = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DiffuseLightMapMethod.prototype, "lightMap", {
            /**
             * The texture containing the light map data.
             */
            get: function () {
                return this._lightMap;
            },
            set: function (value) {
                if (this._lightMap == value)
                    return;
                if (this._lightMap)
                    this.iRemoveTexture(this._lightMap);
                this._lightMap = value;
                if (this._lightMap)
                    this.iAddTexture(this._lightMap);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DiffuseLightMapMethod.prototype, "useSecondaryUV", {
            /**
             * Indicates whether the secondary UV set should be used to map the light map.
             */
            get: function () {
                return this._useSecondaryUV;
            },
            set: function (value) {
                if (this._useSecondaryUV == value)
                    return;
                this._useSecondaryUV = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Indicates the light map should be multiplied with the calculated shading result.
         * This can be used to add pre-calculated shadows or occlusion.
         */
        DiffuseLightMapMethod.MULTIPLY = "multiply";
        /**
         * Indicates the light map should be added into the calculated shading result.
         * This can be used to add pre-calculated lighting or global illumination.
         */
        DiffuseLightMapMethod.ADD = "add";
        DiffuseLightMapMethod.assetType = "[asset DiffuseLightMapMethod]";
        return DiffuseLightMapMethod;
    }(DiffuseCompositeMethod));
    /**
     * _Shader_DiffuseLightMapMethod provides a diffuse shading method that uses a light map to modulate the calculated diffuse
     * lighting. It is different from EffectLightMapMethod in that the latter modulates the entire calculated pixel color, rather
     * than only the diffuse lighting value.
     */
    var _Shader_DiffuseLightMapMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_DiffuseLightMapMethod, _super);
        /**
         * Creates a new _Shader_DiffuseLightMapMethod method.
         */
        function _Shader_DiffuseLightMapMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_DiffuseLightMapMethod.prototype._initVO = function (chunkVO) {
            this._lightMap = this._shader.getAbstraction(this._method.lightMap || new ImageTexture2D());
            this._lightMap._initVO(chunkVO);
            if (this._method.useSecondaryUV)
                this._shader.secondaryUVDependencies++;
            else
                this._shader.uvDependencies++;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseLightMapMethod.prototype._initConstants = function () {
            this._lightMap._initConstants();
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseLightMapMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code;
            var temp = registerCache.getFreeFragmentVectorTemp();
            code = this._lightMap._getFragmentCode(temp, registerCache, sharedRegisters, this._method.useSecondaryUV ? sharedRegisters.secondaryUVVarying : sharedRegisters.uvVarying);
            switch (this._method.blendMode) {
                case DiffuseLightMapMethod.MULTIPLY:
                    code += "mul " + this._totalLightColorReg + ", " + this._totalLightColorReg + ", " + temp + "\n";
                    break;
                case DiffuseLightMapMethod.ADD:
                    code += "add " + this._totalLightColorReg + ", " + this._totalLightColorReg + ", " + temp + "\n";
                    break;
            }
            code += _super.prototype._getFragmentCode.call(this, targetReg, registerCache, sharedRegisters);
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseLightMapMethod.prototype._activate = function () {
            _super.prototype._activate.call(this);
            this._lightMap.activate();
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseLightMapMethod.prototype._setRenderState = function (renderState, view) {
            _super.prototype._setRenderState.call(this, renderState, view);
            this._lightMap._setRenderState(renderState);
        };
        return _Shader_DiffuseLightMapMethod;
    }(_Shader_LightingCompositeMethod));
    ShaderBase.registerAbstraction(_Shader_DiffuseLightMapMethod, DiffuseLightMapMethod);

    /**
     * DiffuseWrapMethod is an alternative to DiffuseBasicMethod in which the light is allowed to be "wrapped around" the normally dark area, to some extent.
     * It can be used as a crude approximation to Oren-Nayar or simple subsurface scattering.
     */
    var DiffuseWrapMethod = /** @class */ (function (_super) {
        __extends$7(DiffuseWrapMethod, _super);
        /**
         * Creates a new DiffuseWrapMethod object.
         * @param wrapFactor A factor to indicate the amount by which the light is allowed to wrap
         */
        function DiffuseWrapMethod(wrapFactor) {
            if (wrapFactor === void 0) { wrapFactor = .5; }
            var _this = _super.call(this) || this;
            _this.wrapFactor = wrapFactor;
            return _this;
        }
        Object.defineProperty(DiffuseWrapMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return DiffuseWrapMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DiffuseWrapMethod.prototype, "wrapFactor", {
            /**
             * A factor to indicate the amount by which the light is allowed to wrap.
             */
            get: function () {
                return this._wrapFactor;
            },
            set: function (value) {
                this._wrapFactor = value;
                this._wrapFactor = 1 / (value + 1);
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        DiffuseWrapMethod.assetType = "[asset DiffuseWrapMethod]";
        return DiffuseWrapMethod;
    }(DiffuseBasicMethod));
    /**
     * _Shader_DiffuseWrapMethod is an alternative to _Shader_DiffuseBasicMethod in which the light is allowed to be "wrapped around" the normally dark area, to some extent.
     * It can be used as a crude approximation to Oren-Nayar or simple subsurface scattering.
     */
    var _Shader_DiffuseWrapMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_DiffuseWrapMethod, _super);
        /**
         * Creates a new _Shader_DiffuseWrapMethod object.
         */
        function _Shader_DiffuseWrapMethod(method, shader) {
            return _super.call(this, method, shader) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_DiffuseWrapMethod.prototype._cleanCompilationData = function () {
            _super.prototype._cleanCompilationData.call(this);
            this._wrapDataRegister = null;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseWrapMethod.prototype._getFragmentPreLightingCode = function (registerCache, sharedRegisters) {
            var code = _super.prototype._getFragmentPreLightingCode.call(this, registerCache, sharedRegisters);
            this._pIsFirstLight = true;
            this._wrapDataRegister = registerCache.getFreeFragmentConstant();
            this._wrapDataIndex = this._wrapDataRegister.index * 4;
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseWrapMethod.prototype._getFragmentCodePerLight = function (lightDirReg, lightColReg, registerCache, sharedRegisters) {
            var code = "";
            var t;
            // write in temporary if not first light, so we can add to total diffuse colour
            if (this._pIsFirstLight) {
                t = this._totalLightColorReg;
            }
            else {
                t = registerCache.getFreeFragmentVectorTemp();
                registerCache.addFragmentTempUsages(t, 1);
            }
            code += "dp3 " + t + ".x, " + lightDirReg + ".xyz, " + sharedRegisters.normalFragment + ".xyz\n" +
                "add " + t + ".y, " + t + ".x, " + this._wrapDataRegister + ".x\n" +
                "mul " + t + ".y, " + t + ".y, " + this._wrapDataRegister + ".y\n" +
                "sat " + t + ".w, " + t + ".y\n" +
                "mul " + t + ".xz, " + t + ".w, " + lightDirReg + ".wz\n";
            if (this._modulateFunction != null)
                code += this._modulateFunction(lightDirReg, registerCache, sharedRegisters);
            code += "mul " + t + ", " + t + ".x, " + lightColReg + "\n";
            if (!this._pIsFirstLight) {
                code += "add " + this._totalLightColorReg + ".xyz, " + this._totalLightColorReg + ".xyz, " + t + ".xyz\n";
                registerCache.removeFragmentTempUsage(t);
            }
            this._pIsFirstLight = false;
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_DiffuseWrapMethod.prototype._activate = function () {
            _super.prototype._activate.call(this);
            if (this._invalid) {
                var index = this._wrapDataIndex;
                var data = this._shader.fragmentConstantData;
                data[index] = this._method.wrapFactor;
                data[index + 1] = 1 / (this._method.wrapFactor + 1);
            }
        };
        return _Shader_DiffuseWrapMethod;
    }(_Shader_DiffuseBasicMethod));
    ShaderBase.registerAbstraction(_Shader_DiffuseWrapMethod, DiffuseWrapMethod);

    /**
     * EffectAlphaMaskMethod allows the use of an additional texture to specify the alpha value of the material. When used
     * with the secondary uv set, it allows for a tiled main texture with independently varying alpha (useful for water
     * etc).
     */
    var EffectAlphaMaskMethod = /** @class */ (function (_super) {
        __extends$7(EffectAlphaMaskMethod, _super);
        /**
         * Creates a new EffectAlphaMaskMethod object.
         *
         * @param texture The texture to use as the alpha mask.
         * @param useSecondaryUV Indicated whether or not the secondary uv set for the mask. This allows mapping alpha independently.
         */
        function EffectAlphaMaskMethod(texture, useSecondaryUV) {
            if (useSecondaryUV === void 0) { useSecondaryUV = false; }
            var _this = _super.call(this) || this;
            _this._texture = texture;
            _this._useSecondaryUV = useSecondaryUV;
            if (_this._texture)
                _this.iAddTexture(_this._texture);
            return _this;
        }
        Object.defineProperty(EffectAlphaMaskMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return EffectAlphaMaskMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectAlphaMaskMethod.prototype, "texture", {
            /**
             * The texture to use as the alpha mask.
             */
            get: function () {
                return this._texture;
            },
            set: function (value) {
                if (this._texture == value)
                    return;
                if (this._texture)
                    this.iRemoveTexture(this._texture);
                this._texture = value;
                if (this._texture)
                    this.iAddTexture(this._texture);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectAlphaMaskMethod.prototype, "useSecondaryUV", {
            /**
             * Indicated whether or not the secondary uv set for the mask. This allows mapping alpha independently, for
             * instance to tile the main texture and normal map while providing untiled alpha, for example to define the
             * transparency over a tiled water surface.
             */
            get: function () {
                return this._useSecondaryUV;
            },
            set: function (value) {
                if (this._useSecondaryUV == value)
                    return;
                this._useSecondaryUV = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        EffectAlphaMaskMethod.assetType = "[asset EffectAlphaMaskMethod]";
        return EffectAlphaMaskMethod;
    }(MethodBase));
    /**
     * _Shader_EffectAlphaMaskMethod allows the use of an additional texture to specify the alpha value of the material. When used
     * with the secondary uv set, it allows for a tiled main texture with independently varying alpha (useful for water
     * etc).
     */
    var _Shader_EffectAlphaMaskMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_EffectAlphaMaskMethod, _super);
        /**
         * Creates a new _Shader_EffectAlphaMaskMethod object.
         */
        function _Shader_EffectAlphaMaskMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_EffectAlphaMaskMethod.prototype._initVO = function (chunkVO) {
            this._alphaMask = this._shader.getAbstraction(this._method.texture || new ImageTexture2D());
            this._alphaMask._initVO(chunkVO);
            if (this._method.useSecondaryUV)
                this._shader.secondaryUVDependencies++;
            else
                this._shader.uvDependencies++;
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectAlphaMaskMethod.prototype._initConstants = function () {
            this._alphaMask._initConstants();
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectAlphaMaskMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var temp = registerCache.getFreeFragmentVectorTemp();
            return this._alphaMask._getFragmentCode(temp, registerCache, sharedRegisters, this._method.useSecondaryUV ? sharedRegisters.secondaryUVVarying : sharedRegisters.uvVarying) +
                "mul " + targetReg + ", " + targetReg + ", " + temp + ".x\n";
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectAlphaMaskMethod.prototype._activate = function () {
            _super.prototype._activate.call(this);
            this._alphaMask.activate();
        };
        _Shader_EffectAlphaMaskMethod.prototype._setRenderState = function (renderState, view) {
            this._alphaMask._setRenderState(renderState);
        };
        return _Shader_EffectAlphaMaskMethod;
    }(_Shader_MethodBase));
    ShaderBase.registerAbstraction(_Shader_EffectAlphaMaskMethod, EffectAlphaMaskMethod);

    /**
     * EffectColorMatrixMethod provides a shading method that changes the colour of a material analogous to a ColorMatrixFilter.
     */
    var EffectColorMatrixMethod = /** @class */ (function (_super) {
        __extends$7(EffectColorMatrixMethod, _super);
        /**
         * Creates a new EffectColorTransformMethod.
         *
         * @param matrix An array of 20 items for 4 x 5 color transform.
         */
        function EffectColorMatrixMethod(matrix) {
            var _this = _super.call(this) || this;
            if (matrix.length != 20)
                throw new Error("Matrix length must be 20!");
            _this._matrix = matrix;
            return _this;
        }
        Object.defineProperty(EffectColorMatrixMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return EffectColorMatrixMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectColorMatrixMethod.prototype, "matrix", {
            /**
             * The 4 x 5 matrix to transform the color of the material.
             */
            get: function () {
                return this._matrix;
            },
            set: function (value) {
                if (value.length != 20)
                    throw new Error("Matrix length must be 20!");
                this._matrix = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        EffectColorMatrixMethod.assetType = "[asset EffectColorMatrixMethod]";
        return EffectColorMatrixMethod;
    }(MethodBase));
    /**
     * _Shader_EffectColorMatrixMethod provides a shading method that changes the colour of a material analogous to a ColorMatrixFilter.
     */
    var _Shader_EffectColorMatrixMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_EffectColorMatrixMethod, _super);
        /**
         * Creates a new _Shader_EffectColorMatrixMethod
         *
         * @param method
         * @param shader
         */
        function _Shader_EffectColorMatrixMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_EffectColorMatrixMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code = "";
            var colorMultReg = registerCache.getFreeFragmentConstant();
            registerCache.getFreeFragmentConstant();
            registerCache.getFreeFragmentConstant();
            registerCache.getFreeFragmentConstant();
            var colorOffsetReg = registerCache.getFreeFragmentConstant();
            this._colorMatrixIndex = colorMultReg.index * 4;
            var temp = registerCache.getFreeFragmentVectorTemp();
            code += "m44 " + temp + ", " + targetReg + ", " + colorMultReg + "\n" +
                "add " + targetReg + ", " + temp + ", " + colorOffsetReg + "\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectColorMatrixMethod.prototype._activate = function () {
            if (this._invalid) {
                var matrix = this._method.matrix;
                var index = this._colorMatrixIndex;
                var data = this._shader.fragmentConstantData;
                // r
                data[index] = matrix[0];
                data[index + 1] = matrix[1];
                data[index + 2] = matrix[2];
                data[index + 3] = matrix[3];
                // g
                data[index + 4] = matrix[5];
                data[index + 5] = matrix[6];
                data[index + 6] = matrix[7];
                data[index + 7] = matrix[8];
                // b
                data[index + 8] = matrix[10];
                data[index + 9] = matrix[11];
                data[index + 10] = matrix[12];
                data[index + 11] = matrix[13];
                // a
                data[index + 12] = matrix[15];
                data[index + 13] = matrix[16];
                data[index + 14] = matrix[17];
                data[index + 15] = matrix[18];
                // rgba offset
                data[index + 16] = matrix[4];
                data[index + 17] = matrix[9];
                data[index + 18] = matrix[14];
                data[index + 19] = matrix[19];
            }
        };
        return _Shader_EffectColorMatrixMethod;
    }(_Shader_MethodBase));
    ShaderBase.registerAbstraction(_Shader_EffectColorMatrixMethod, EffectColorMatrixMethod);

    /**
     * EffectColorTransformMethod provides a shading method that changes the colour of a material analogous to a
     * ColorTransform object.
     */
    var EffectColorTransformMethod = /** @class */ (function (_super) {
        __extends$7(EffectColorTransformMethod, _super);
        /**
         * Creates a new EffectColorTransformMethod.
         */
        function EffectColorTransformMethod(colorTransform) {
            if (colorTransform === void 0) { colorTransform = null; }
            var _this = _super.call(this) || this;
            _this._colorTransform = colorTransform;
            return _this;
        }
        Object.defineProperty(EffectColorTransformMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return EffectColorTransformMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectColorTransformMethod.prototype, "colorTransform", {
            /**
             * The ColorTransform object to transform the colour of the material with.
             */
            get: function () {
                return this._colorTransform;
            },
            set: function (value) {
                this._colorTransform = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        EffectColorTransformMethod.assetType = "[asset EffectColorTransformMethod]";
        return EffectColorTransformMethod;
    }(MethodBase));
    /**
     * EffectColorTransformChumk provides a shading method that changes the colour of a material analogous to a
     * ColorTransform object.
     */
    var _Shader_EffectColorTransformMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_EffectColorTransformMethod, _super);
        /**
         * Creates a new EffectColorTransformChumk.
         */
        function _Shader_EffectColorTransformMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_EffectColorTransformMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code = "";
            var colorMultReg = registerCache.getFreeFragmentConstant();
            var colorOffsReg = registerCache.getFreeFragmentConstant();
            this._colorTransformIndex = colorMultReg.index * 4;
            //TODO: AGAL <> GLSL
            code += "mul " + targetReg + ", " + targetReg + ", " + colorMultReg + "\n" +
                "add " + targetReg + ", " + targetReg + ", " + colorOffsReg + "\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectColorTransformMethod.prototype._activate = function () {
            if (this._invalid) {
                var index = this._colorTransformIndex;
                var data = this._shader.fragmentConstantData;
                var rawData = this._method.colorTransform._rawData;
                data[index] = rawData[0];
                data[index + 1] = rawData[1];
                data[index + 2] = rawData[2];
                data[index + 3] = rawData[3];
                data[index + 4] = rawData[4];
                data[index + 5] = rawData[5];
                data[index + 6] = rawData[6];
                data[index + 7] = rawData[7];
            }
        };
        return _Shader_EffectColorTransformMethod;
    }(_Shader_MethodBase));
    ShaderBase.registerAbstraction(_Shader_EffectColorTransformMethod, EffectColorTransformMethod);

    /**
     * EffectEnvMapMethod provides a material method to perform reflection mapping using cube maps.
     */
    var EffectEnvMapMethod = /** @class */ (function (_super) {
        __extends$7(EffectEnvMapMethod, _super);
        /**
         * Creates an EffectEnvMapMethod object.
         * @param envMap The environment map containing the reflected scene.
         * @param alpha The reflectivity of the surface.
         */
        function EffectEnvMapMethod(envMap, alpha) {
            if (alpha === void 0) { alpha = 1; }
            var _this = _super.call(this) || this;
            _this._envMap = envMap;
            _this._alpha = alpha;
            _this.iAddTexture(_this._envMap);
            return _this;
        }
        Object.defineProperty(EffectEnvMapMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return EffectEnvMapMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectEnvMapMethod.prototype, "envMap", {
            /**
             * The cubic environment map containing the reflected scene.
             */
            get: function () {
                return this._envMap;
            },
            set: function (value) {
                if (this._envMap == value)
                    return;
                if (this._envMap)
                    this.iRemoveTexture(this._envMap);
                this._envMap = value;
                if (this._envMap)
                    this.iAddTexture(this._envMap);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectEnvMapMethod.prototype, "mask", {
            /**
             * An optional texture to modulate the reflectivity of the surface.
             */
            get: function () {
                return this._mask;
            },
            set: function (value) {
                if (value == this._mask)
                    return;
                if (this._mask)
                    this.iRemoveTexture(this._mask);
                this._mask = value;
                if (this._mask)
                    this.iAddTexture(this._mask);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectEnvMapMethod.prototype, "alpha", {
            /**
             * The reflectivity of the surface.
             */
            get: function () {
                return this._alpha;
            },
            set: function (value) {
                this._alpha = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        EffectEnvMapMethod.prototype.dispose = function () {
        };
        EffectEnvMapMethod.assetType = "[asset EffectEnvMapMethod]";
        return EffectEnvMapMethod;
    }(MethodBase));
    /**
     * _Shader_EffectEnvMapMethod provides a material method to perform reflection mapping using cube maps.
     */
    var _Shader_EffectEnvMapMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_EffectEnvMapMethod, _super);
        /**
         * Creates a new _Shader_EffectEnvMapMethod.
         */
        function _Shader_EffectEnvMapMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_EffectEnvMapMethod.prototype._initVO = function (chunkVO) {
            chunkVO.needsNormals = true;
            chunkVO.needsView = true;
            this._envMap = this._shader.getAbstraction(this._method.envMap);
            this._envMap._initVO(chunkVO);
            if (this._method.mask) {
                this._maskMap = this._shader.getAbstraction(this._method.mask);
                this._shader.uvDependencies++;
            }
            else if (this._maskMap) {
                this._maskMap = null;
            }
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectEnvMapMethod.prototype._initConstants = function () {
            this._envMap._initConstants();
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectEnvMapMethod.prototype.dispose = function () {
            this._envMap = null;
            this._maskMap = null;
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectEnvMapMethod.prototype._activate = function () {
            this._envMap.activate();
            if (this._maskMap)
                this._maskMap.activate();
            if (this._invalid)
                this._updateProperties();
        };
        _Shader_EffectEnvMapMethod.prototype._setRenderState = function (renderState, view) {
            this._envMap._setRenderState(renderState);
            if (this._maskMap)
                this._maskMap._setRenderState(renderState);
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectEnvMapMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var alphaRegister = registerCache.getFreeFragmentConstant();
            var code = "";
            this._fragmentIndex = alphaRegister.index * 4;
            var temp = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp, 1);
            var temp2 = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp2, 1);
            // r = I - 2(I.N)*N
            code += "dp3 " + temp + ".w, " + sharedRegisters.viewDirFragment + ".xyz, " + sharedRegisters.normalFragment + ".xyz\n" +
                "add " + temp + ".w, " + temp + ".w, " + temp + ".w\n" +
                "mul " + temp + ".xyz, " + sharedRegisters.normalFragment + ".xyz, " + temp + ".w\n" +
                "sub " + temp + ".xyz, " + temp + ".xyz, " + sharedRegisters.viewDirFragment + ".xyz\n" +
                this._envMap._getFragmentCode(temp, registerCache, sharedRegisters, temp) +
                "sub " + temp2 + ".w, " + temp + ".w, fc0.x\n" + // -.5
                "kil " + temp2 + ".w\n" + // used for real time reflection mapping - if alpha is not 1 (mock texture) kil output
                "sub " + temp + ", " + temp + ", " + targetReg + "\n";
            if (this._maskMap) {
                code += this._maskMap._getFragmentCode(temp2, registerCache, sharedRegisters, sharedRegisters.uvVarying) +
                    "mul " + temp + ", " + temp2 + ", " + temp + "\n";
            }
            code += "mul " + temp + ", " + temp + ", " + alphaRegister + ".x\n" +
                "add " + targetReg + ", " + targetReg + ", " + temp + "\n";
            registerCache.removeFragmentTempUsage(temp);
            registerCache.removeFragmentTempUsage(temp2);
            return code;
        };
        _Shader_EffectEnvMapMethod.prototype._updateProperties = function () {
            this._shader.fragmentConstantData[this._fragmentIndex] = this._method.alpha;
        };
        return _Shader_EffectEnvMapMethod;
    }(_Shader_MethodBase));
    ShaderBase.registerAbstraction(_Shader_EffectEnvMapMethod, EffectEnvMapMethod);

    /**
     * EffectFogMethod provides a method to add distance-based fog to a material.
     */
    var EffectFogMethod = /** @class */ (function (_super) {
        __extends$7(EffectFogMethod, _super);
        /**
         * Creates a new EffectFogMethod object.
         * @param minDistance The distance from which the fog starts appearing.
         * @param maxDistance The distance at which the fog is densest.
         * @param fogColor The colour of the fog.
         */
        function EffectFogMethod(minDistance, maxDistance, fogColor) {
            if (minDistance === void 0) { minDistance = 0; }
            if (maxDistance === void 0) { maxDistance = 1000; }
            if (fogColor === void 0) { fogColor = 0x808080; }
            var _this = _super.call(this) || this;
            _this._minDistance = minDistance;
            _this._maxDistance = maxDistance;
            _this._fogColor = fogColor;
            return _this;
        }
        Object.defineProperty(EffectFogMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return EffectFogMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectFogMethod.prototype, "minDistance", {
            /**
             * The distance from which the fog starts appearing.
             */
            get: function () {
                return this._minDistance;
            },
            set: function (value) {
                this._minDistance = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectFogMethod.prototype, "maxDistance", {
            /**
             * The distance at which the fog is densest.
             */
            get: function () {
                return this._maxDistance;
            },
            set: function (value) {
                this._maxDistance = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectFogMethod.prototype, "fogColor", {
            /**
             * The colour of the fog.
             */
            get: function () {
                return this._fogColor;
            },
            set: function (value) {
                this._fogColor = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        EffectFogMethod.assetType = "[asset EffectFogMethod]";
        return EffectFogMethod;
    }(MethodBase));
    /**
     * _Shader_EffectFogMethod provides a method to add distance-based fog to a material.
     */
    var _Shader_EffectFogMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_EffectFogMethod, _super);
        /**
         * Creates a new EffectEnvMapChunk.
         */
        function _Shader_EffectFogMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_EffectFogMethod.prototype._initVO = function (chunkVO) {
            chunkVO.needsProjection = true;
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectFogMethod.prototype._activate = function () {
            if (this._invalid) {
                var data = this._shader.fragmentConstantData;
                var index = this._fogColorIndex;
                var color = this._method.fogColor;
                data[index] = ((color >> 16) & 0xff) / 0xff;
                data[index + 1] = ((color >> 8) & 0xff) / 0xff;
                data[index + 2] = (color & 0xff) / 0xff;
                data[index + 3] = 1;
                data[index + 4] = this._method.minDistance;
                data[index + 5] = 1 / (this._method.maxDistance - this._method.minDistance);
                data[index + 6] = 0;
                data[index + 7] = 0;
            }
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectFogMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var fogColor = registerCache.getFreeFragmentConstant();
            var fogData = registerCache.getFreeFragmentConstant();
            var temp = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp, 1);
            var temp2 = registerCache.getFreeFragmentVectorTemp();
            var code = "";
            this._fogColorIndex = fogColor.index * 4;
            code += "sub " + temp2 + ".w, " + sharedRegisters.projectionFragment + ".z, " + fogData + ".x\n" +
                "mul " + temp2 + ".w, " + temp2 + ".w, " + fogData + ".y\n" +
                "sat " + temp2 + ".w, " + temp2 + ".w\n" +
                "sub " + temp + ", " + fogColor + ", " + targetReg + "\n" + // (fogColor- col)
                "mul " + temp + ", " + temp + ", " + temp2 + ".w\n" + // (fogColor- col)*fogRatio
                "add " + targetReg + ", " + targetReg + ", " + temp + "\n"; // fogRatio*(fogColor- col) + col
            registerCache.removeFragmentTempUsage(temp);
            return code;
        };
        return _Shader_EffectFogMethod;
    }(_Shader_MethodBase));
    ShaderBase.registerAbstraction(_Shader_EffectFogMethod, EffectFogMethod);

    /**
     * EffectFresnelEnvMapMethod provides a method to add fresnel-based reflectivity to an object using cube maps, which gets
     * stronger as the viewing angle becomes more grazing.
     */
    var EffectFresnelEnvMapMethod = /** @class */ (function (_super) {
        __extends$7(EffectFresnelEnvMapMethod, _super);
        /**
         * Creates a new <code>EffectFresnelEnvMapMethod</code> object.
         *
         * @param envMap The environment map containing the reflected scene.
         * @param alpha The reflectivity of the material.
         */
        function EffectFresnelEnvMapMethod(envMap, alpha, fresnelPower, normalReflectance) {
            if (alpha === void 0) { alpha = 1; }
            if (fresnelPower === void 0) { fresnelPower = 5; }
            if (normalReflectance === void 0) { normalReflectance = 0; }
            var _this = _super.call(this, envMap, alpha) || this;
            _this._fresnelPower = fresnelPower;
            _this._normalReflectance = normalReflectance;
            return _this;
        }
        Object.defineProperty(EffectFresnelEnvMapMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return EffectFresnelEnvMapMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectFresnelEnvMapMethod.prototype, "fresnelPower", {
            /**
             * The power used in the Fresnel equation. Higher values make the fresnel effect more pronounced. Defaults to 5.
             */
            get: function () {
                return this._fresnelPower;
            },
            set: function (value) {
                this._fresnelPower = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectFresnelEnvMapMethod.prototype, "normalReflectance", {
            /**
             * The minimum amount of reflectance, ie the reflectance when the view direction is normal to the surface or light direction.
             */
            get: function () {
                return this._normalReflectance;
            },
            set: function (value) {
                if (this._normalReflectance == value)
                    return;
                this._normalReflectance = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        EffectFresnelEnvMapMethod.assetType = "[asset EffectFresnelEnvMapMethod]";
        return EffectFresnelEnvMapMethod;
    }(EffectEnvMapMethod));
    /**
     * _Shader_EffectFresnelEnvMapMethod provides a method to add fresnel-based reflectivity to an object using cube maps, which gets
     * stronger as the viewing angle becomes more grazing.
     */
    var _Shader_EffectFresnelEnvMapMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_EffectFresnelEnvMapMethod, _super);
        function _Shader_EffectFresnelEnvMapMethod() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_EffectFresnelEnvMapMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var dataRegister = registerCache.getFreeFragmentConstant();
            var code = "";
            var viewDirReg = sharedRegisters.viewDirFragment;
            var normalReg = sharedRegisters.normalFragment;
            this._fragmentIndex = dataRegister.index * 4;
            var temp = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp, 1);
            var temp2 = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp2, 1);
            // r = V - 2(V.N)*N
            code += "dp3 " + temp + ".w, " + viewDirReg + ".xyz, " + normalReg + ".xyz\n" +
                "add " + temp + ".w, " + temp + ".w, " + temp + ".w\n" +
                "mul " + temp + ".xyz, " + normalReg + ".xyz, " + temp + ".w\n" +
                "sub " + temp + ".xyz, " + temp + ".xyz, " + viewDirReg + ".xyz\n" +
                this._envMap._getFragmentCode(temp, registerCache, sharedRegisters, temp) +
                "sub " + temp2 + ".w, " + temp + ".w, fc0.x\n" + // -.5
                "kil " + temp2 + ".w\n" + // used for real time reflection mapping - if alpha is not 1 (mock texture) kil output
                "sub " + temp + ", " + temp + ", " + targetReg + "\n";
            // calculate fresnel term
            code += "dp3 " + viewDirReg + ".w, " + viewDirReg + ".xyz, " + normalReg + ".xyz\n" + // dot(V, H)
                "sub " + viewDirReg + ".w, " + dataRegister + ".w, " + viewDirReg + ".w\n" + // base = 1-dot(V, H)
                "pow " + viewDirReg + ".w, " + viewDirReg + ".w, " + dataRegister + ".z\n" + // exp = pow(base, 5)
                "sub " + normalReg + ".w, " + dataRegister + ".w, " + viewDirReg + ".w\n" + // 1 - exp
                "mul " + normalReg + ".w, " + dataRegister + ".y, " + normalReg + ".w\n" + // f0*(1 - exp)
                "add " + viewDirReg + ".w, " + viewDirReg + ".w, " + normalReg + ".w\n" + // exp + f0*(1 - exp)
                // total alpha
                "mul " + viewDirReg + ".w, " + dataRegister + ".x, " + viewDirReg + ".w\n";
            if (this._maskMap) {
                code += this._maskMap._getFragmentCode(temp2, registerCache, sharedRegisters, sharedRegisters.uvVarying) +
                    "mul " + viewDirReg + ".w, " + temp2 + ".x, " + viewDirReg + ".w\n";
            }
            // blend
            code += "mul " + temp + ", " + temp + ", " + viewDirReg + ".w\n" +
                "add " + targetReg + ", " + targetReg + ", " + temp + "\n";
            registerCache.removeFragmentTempUsage(temp);
            registerCache.removeFragmentTempUsage(temp2);
            return code;
        };
        _Shader_EffectFresnelEnvMapMethod.prototype._updateProperties = function () {
            var index = this._fragmentIndex;
            var data = this._shader.fragmentConstantData;
            data[index] = this._method.alpha;
            data[index + 1] = this._method.normalReflectance;
            data[index + 2] = this._method.fresnelPower;
        };
        return _Shader_EffectFresnelEnvMapMethod;
    }(_Shader_EffectEnvMapMethod));
    ShaderBase.registerAbstraction(_Shader_EffectFresnelEnvMapMethod, EffectFresnelEnvMapMethod);

    /**
     * EffectLightMapMethod provides a method that allows applying a light map texture to the calculated pixel colour.
     * It is different from DiffuseLightMapMethod in that the latter only modulates the diffuse shading value rather
     * than the whole pixel colour.
     */
    var EffectLightMapMethod = /** @class */ (function (_super) {
        __extends$7(EffectLightMapMethod, _super);
        /**
         * Creates a new EffectLightMapMethod object.
         *
         * @param lightMap The texture containing the light map.
         * @param blendMode The blend mode with which the light map should be applied to the lighting result.
         * @param useSecondaryUV Indicates whether the secondary UV set should be used to map the light map.
         */
        function EffectLightMapMethod(lightMap, blendMode, useSecondaryUV) {
            if (blendMode === void 0) { blendMode = "multiply"; }
            if (useSecondaryUV === void 0) { useSecondaryUV = false; }
            var _this = _super.call(this) || this;
            if (blendMode != EffectLightMapMethod.ADD && blendMode != EffectLightMapMethod.MULTIPLY)
                throw new Error("Unknown blendmode!");
            _this._lightMap = lightMap;
            _this._blendMode = blendMode;
            _this._useSecondaryUV = useSecondaryUV;
            if (_this._lightMap)
                _this.iAddTexture(_this._lightMap);
            return _this;
        }
        Object.defineProperty(EffectLightMapMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return EffectLightMapMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectLightMapMethod.prototype, "blendMode", {
            /**
             * The blend mode with which the light map should be applied to the lighting result.
             *
             * @see EffectLightMapMethod.ADD
             * @see EffectLightMapMethod.MULTIPLY
             */
            get: function () {
                return this._blendMode;
            },
            set: function (value) {
                if (this._blendMode == value)
                    return;
                if (value != EffectLightMapMethod.ADD && value != EffectLightMapMethod.MULTIPLY)
                    throw new Error("Unknown blendmode!");
                this._blendMode = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectLightMapMethod.prototype, "lightMap", {
            /**
             * The lightMap containing the light map.
             */
            get: function () {
                return this._lightMap;
            },
            set: function (value) {
                if (this._lightMap == value)
                    return;
                if (this._lightMap)
                    this.iRemoveTexture(this._lightMap);
                this._lightMap = value;
                if (this._lightMap)
                    this.iAddTexture(this._lightMap);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectLightMapMethod.prototype, "useSecondaryUV", {
            /**
             * Indicates whether the secondary UV set should be used to map the light map.
             */
            get: function () {
                return this._useSecondaryUV;
            },
            set: function (value) {
                if (this._useSecondaryUV == value)
                    return;
                this._useSecondaryUV = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Indicates the light map should be multiplied with the calculated shading result.
         */
        EffectLightMapMethod.MULTIPLY = "multiply";
        /**
         * Indicates the light map should be added into the calculated shading result.
         */
        EffectLightMapMethod.ADD = "add";
        EffectLightMapMethod.assetType = "[asset EffectLightMapMethod]";
        return EffectLightMapMethod;
    }(MethodBase));
    /**
     * _Shader_EffectLightMapMethod provides a method that allows applying a light map texture to the calculated pixel colour.
     * It is different from DiffuseLightMapMethod in that the latter only modulates the diffuse shading value rather
     * than the whole pixel colour.
     */
    var _Shader_EffectLightMapMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_EffectLightMapMethod, _super);
        /**
         * Creates a new EffectEnvMapChunk.
         */
        function _Shader_EffectLightMapMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_EffectLightMapMethod.prototype._initVO = function (chunkVO) {
            this._lightMap = this._shader.getAbstraction(this._method.lightMap);
            this._lightMap._initVO(chunkVO);
            if (this._method.useSecondaryUV)
                this._shader.secondaryUVDependencies++;
            else
                this._shader.uvDependencies++;
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectLightMapMethod.prototype._initConstants = function () {
            this._lightMap._initConstants();
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectLightMapMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code;
            var temp = registerCache.getFreeFragmentVectorTemp();
            code = this._lightMap._getFragmentCode(temp, registerCache, sharedRegisters, this._method.useSecondaryUV ? sharedRegisters.secondaryUVVarying : sharedRegisters.uvVarying);
            switch (this._method.blendMode) {
                case EffectLightMapMethod.MULTIPLY:
                    code += "mul " + targetReg + ", " + targetReg + ", " + temp + "\n";
                    break;
                case EffectLightMapMethod.ADD:
                    code += "add " + targetReg + ", " + targetReg + ", " + temp + "\n";
                    break;
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectLightMapMethod.prototype._activate = function () {
            this._lightMap.activate();
        };
        _Shader_EffectLightMapMethod.prototype._setRenderState = function (renderState, view) {
            this._lightMap._setRenderState(renderState);
        };
        return _Shader_EffectLightMapMethod;
    }(_Shader_MethodBase));
    ShaderBase.registerAbstraction(_Shader_EffectLightMapMethod, EffectLightMapMethod);

    /**
     * ProjectiveTextureMethod is a material method used to project a texture unto the surface of an object.
     * This can be used for various effects apart from acting like a normal projector, such as projecting fake shadows
     * unto a surface, the impact of light coming through a stained glass window, ...
     */
    var EffectProjectiveTextureMethod = /** @class */ (function (_super) {
        __extends$7(EffectProjectiveTextureMethod, _super);
        /**
         * Creates a new ProjectiveTextureMethod object.
         *
         * @param projector The TextureProjector object that defines the projection properties as well as the texture.
         * @param mode The blend mode with which the texture is blended unto the surface.
         *
         * @see away3d.entities.TextureProjector
         */
        function EffectProjectiveTextureMethod(projector, mode, exposure) {
            if (mode === void 0) { mode = "multiply"; }
            if (exposure === void 0) { exposure = 1; }
            var _this = _super.call(this) || this;
            _this._onTextureChangedDelegate = function (event) { return _this._onTextureChanged(event); };
            _this._projector = projector;
            _this._exposure = exposure;
            _this._mode = mode;
            _this._projector.addEventListener(TextureProjectorEvent.TEXTURE_CHANGE, _this._onTextureChangedDelegate);
            return _this;
        }
        Object.defineProperty(EffectProjectiveTextureMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return EffectProjectiveTextureMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectProjectiveTextureMethod.prototype, "exposure", {
            /**
             *
             */
            get: function () {
                return this._exposure;
            },
            set: function (value) {
                if (this._exposure == value)
                    return;
                this._exposure = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectProjectiveTextureMethod.prototype, "mode", {
            /**
             * The blend mode with which the texture is blended unto the object.
             * ProjectiveTextureMethod.MULTIPLY can be used to project shadows. To prevent clamping, the texture's alpha should be white!
             * ProjectiveTextureMethod.ADD can be used to project light, such as a slide projector or light coming through stained glass. To prevent clamping, the texture's alpha should be black!
             * ProjectiveTextureMethod.MIX provides normal alpha blending. To prevent clamping, the texture's alpha should be transparent!
             */
            get: function () {
                return this._mode;
            },
            set: function (value) {
                if (this._mode == value)
                    return;
                this._mode = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectProjectiveTextureMethod.prototype, "projector", {
            /**
             * The TextureProjector object that defines the projection properties as well as the texture.
             *
             * @see away3d.entities.TextureProjector
             */
            get: function () {
                return this._projector;
            },
            set: function (value) {
                if (this._projector == value)
                    return;
                if (this._projector)
                    this._projector.removeEventListener(TextureProjectorEvent.TEXTURE_CHANGE, this._onTextureChangedDelegate);
                this._projector = value;
                if (this._projector)
                    this._projector.addEventListener(TextureProjectorEvent.TEXTURE_CHANGE, this._onTextureChangedDelegate);
                this.updateTexture();
            },
            enumerable: true,
            configurable: true
        });
        EffectProjectiveTextureMethod.prototype._onTextureChanged = function (event) {
            this.updateTexture();
        };
        EffectProjectiveTextureMethod.prototype.updateTexture = function () {
            if (this._texture)
                this.iRemoveTexture(this._texture);
            this._texture = (this._projector) ? this._projector.texture : null;
            if (this._texture)
                this.iAddTexture(this._texture);
            this.invalidateShaderProgram();
        };
        EffectProjectiveTextureMethod.OVERLAY = "overlay";
        EffectProjectiveTextureMethod.MULTIPLY = "multiply";
        EffectProjectiveTextureMethod.ADD = "add";
        EffectProjectiveTextureMethod.MIX = "mix";
        EffectProjectiveTextureMethod.assetType = "[asset EffectProjectiveTextureMethod]";
        return EffectProjectiveTextureMethod;
    }(MethodBase));
    /**
     * ProjectiveTextureMethod is a material method used to project a texture unto the surface of an object.
     * This can be used for various effects apart from acting like a normal projector, such as projecting fake shadows
     * unto a surface, the impact of light coming through a stained glass window, ...
     */
    var _Shader_EffectProjectiveTextureMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_EffectProjectiveTextureMethod, _super);
        /**
         * Creates a new EffectEnvMapChunk.
         */
        function _Shader_EffectProjectiveTextureMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        _Shader_EffectProjectiveTextureMethod.prototype._initVO = function (chunkVO) {
            this._texture = this._shader.getAbstraction(this._method.projector.texture);
            this._texture._initVO(chunkVO);
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectProjectiveTextureMethod.prototype._initConstants = function () {
            this._texture._initConstants();
            var index = this._exposureIndex;
            var data = this._shader.fragmentConstantData;
            data[index] = this._method.exposure;
            data[index + 1] = 0.5;
            data[index + 2] = 4;
            data[index + 3] = -1;
            this._projectionMatrix = new Matrix3D(new Float32Array(this._shader.vertexConstantData.buffer, this._projectionIndex * 4, 16));
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectProjectiveTextureMethod.prototype._cleanCompilationData = function () {
            _super.prototype._cleanCompilationData.call(this);
            this._uvVarying = null;
            this._projectionMatrix = null;
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectProjectiveTextureMethod.prototype._getVertexCode = function (registerCache, sharedRegisters) {
            var code = "";
            var projReg = registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            this._projectionIndex = projReg.index * 4;
            this._uvVarying = registerCache.getFreeVarying();
            code += "m44 " + this._uvVarying + ", " + sharedRegisters.animatedPosition + ", " + projReg + "\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectProjectiveTextureMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code = "";
            var col = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(col, 1);
            var temp = registerCache.getFreeFragmentVectorTemp();
            //var toTexReg:ShaderRegisterElement = registerCache.getFreeFragmentConstant();
            //methodVO.fragmentConstantsIndex = toTexReg.index*4;
            var exposure = registerCache.getFreeFragmentConstant();
            this._exposureIndex = exposure.index * 4;
            // code += "mul " + col + ".xy, " + this._uvVarying + ".xy, " + toTexReg + ".xy	\n" +
            // 	"add " + col + ".xy, " + col + ".xy, " + toTexReg + ".xx	\n";
            code += this._texture._getFragmentCode(col, registerCache, sharedRegisters, this._uvVarying);
            code += "mul " + col + ", " + col + ", " + exposure + ".xxx\n" +
                "add " + col + ", " + col + ", " + exposure + ".xxx\n";
            if (this._method.mode == EffectProjectiveTextureMethod.MULTIPLY)
                code += "mul " + targetReg + ".xyz, " + targetReg + ".xyz, " + col + ".xyz			\n";
            else if (this._method.mode == EffectProjectiveTextureMethod.ADD)
                code += "add " + targetReg + ".xyz, " + targetReg + ".xyz, " + col + ".xyz			\n";
            else if (this._method.mode == EffectProjectiveTextureMethod.MIX) {
                code += "sub " + col + ".xyz, " + col + ".xyz, " + targetReg + ".xyz				\n" +
                    "mul " + col + ".xyz, " + col + ".xyz, " + col + ".w						\n" +
                    "add " + targetReg + ".xyz, " + targetReg + ".xyz, " + col + ".xyz			\n";
            }
            else if (this._method.mode == EffectProjectiveTextureMethod.OVERLAY) {
                code += "sge " + temp + ", " + targetReg + ", " + exposure + ".yyy\n"; // temp = (base >= 0.5)? 1 : 0
                code += "sub " + targetReg + ", " + targetReg + ", " + temp + "\n"; // base = temp? (base - 1 : base)
                code += "sub " + col + ", " + col + ", " + temp + "\n"; // blend = temp? (blend - 1 : blend)
                code += "mul " + col + ", " + col + ", " + targetReg + "\n"; // blend = blend * base
                code += "sub " + targetReg + ", " + exposure + ".yyy, " + temp + "\n"; // base = temp? -0.5 : 0.5
                code += "mul " + targetReg + ", " + exposure + ".zzz, " + targetReg + "\n"; // base = temp? -2 : 2
                code += "mul " + col + ", " + col + ", " + targetReg + "\n"; // blend = blend * ( -2 : 2)
                code += "add " + targetReg + ", " + col + ", " + temp + "\n"; //blend = temp? (blend + 1 : blend)
            }
            else
                throw new ErrorBase("Unknown mode \"" + this._method.mode + "\"");
            registerCache.removeFragmentTempUsage(col);
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectProjectiveTextureMethod.prototype._setRenderState = function (renderState, view) {
            var matrix3D = Matrix3D.CALCULATION_MATRIX;
            matrix3D.copyFrom(this._method.projector.projection.viewMatrix3D);
            matrix3D.prepend(renderState.renderSceneTransform);
            this._projectionMatrix.copyFrom(matrix3D, true);
            this._texture._setRenderState(renderState);
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectProjectiveTextureMethod.prototype._activate = function () {
            this._texture.activate();
            if (this._invalid)
                this._shader.fragmentConstantData[this._exposureIndex] = this._method.exposure;
        };
        return _Shader_EffectProjectiveTextureMethod;
    }(_Shader_MethodBase));
    ShaderBase.registerAbstraction(_Shader_EffectProjectiveTextureMethod, EffectProjectiveTextureMethod);

    /**
     * EffectRefractionEnvMapMethod provides a method to add refracted transparency based on cube maps.
     */
    var EffectRefractionEnvMapMethod = /** @class */ (function (_super) {
        __extends$7(EffectRefractionEnvMapMethod, _super);
        /**
         * Creates a new EffectRefractionEnvMapMethod object. Example values for dispersion are: dispersionR: -0.03, dispersionG: -0.01, dispersionB: = .0015
         *
         * @param envMap The environment map containing the refracted scene.
         * @param refractionIndex The refractive index of the material.
         * @param dispersionR The amount of chromatic dispersion of the red channel. Defaults to 0 (none).
         * @param dispersionG The amount of chromatic dispersion of the green channel. Defaults to 0 (none).
         * @param dispersionB The amount of chromatic dispersion of the blue channel. Defaults to 0 (none).
         */
        function EffectRefractionEnvMapMethod(envMap, alpha, refractionIndex, dispersionR, dispersionG, dispersionB) {
            if (alpha === void 0) { alpha = 1; }
            if (refractionIndex === void 0) { refractionIndex = .1; }
            if (dispersionR === void 0) { dispersionR = 0; }
            if (dispersionG === void 0) { dispersionG = 0; }
            if (dispersionB === void 0) { dispersionB = 0; }
            var _this = _super.call(this, envMap, alpha) || this;
            _this._dispersionR = 0;
            _this._dispersionG = 0;
            _this._dispersionB = 0;
            _this._refractionIndex = refractionIndex;
            _this._dispersionR = dispersionR;
            _this._dispersionG = dispersionG;
            _this._dispersionB = dispersionB;
            return _this;
        }
        Object.defineProperty(EffectRefractionEnvMapMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return EffectRefractionEnvMapMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectRefractionEnvMapMethod.prototype, "refractionIndex", {
            /**
             * The refractive index of the material.
             */
            get: function () {
                return this._refractionIndex;
            },
            set: function (value) {
                this._refractionIndex = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectRefractionEnvMapMethod.prototype, "dispersionR", {
            /**
             * The amount of chromatic dispersion of the red channel. Defaults to 0 (none).
             */
            get: function () {
                return this._dispersionR;
            },
            set: function (value) {
                if (this._dispersionR == value)
                    return;
                this._dispersionR = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectRefractionEnvMapMethod.prototype, "dispersionG", {
            /**
             * The amount of chromatic dispersion of the green channel. Defaults to 0 (none).
             */
            get: function () {
                return this._dispersionG;
            },
            set: function (value) {
                if (this._dispersionG == value)
                    return;
                this._dispersionG = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectRefractionEnvMapMethod.prototype, "dispersionB", {
            /**
             * The amount of chromatic dispersion of the blue channel. Defaults to 0 (none).
             */
            get: function () {
                return this._dispersionB;
            },
            set: function (value) {
                if (this._dispersionB == value)
                    return;
                this._dispersionB = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        EffectRefractionEnvMapMethod.assetType = "[asset EffectRefractionEnvMapMethod]";
        return EffectRefractionEnvMapMethod;
    }(EffectEnvMapMethod));
    /**
     * EffectRefractionEnvMapMethod provides a method to add refracted transparency based on cube maps.
     */
    var _Shader_EffectRefractionEnvMapMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_EffectRefractionEnvMapMethod, _super);
        function _Shader_EffectRefractionEnvMapMethod() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_EffectRefractionEnvMapMethod.prototype._initVO = function (chunkVO) {
            _super.prototype._initVO.call(this, chunkVO);
            this._useDispersion = !(this._method.dispersionR == this._method.dispersionB && this._method.dispersionR == this._method.dispersionG);
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectRefractionEnvMapMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            // todo: data2.x could use common reg, so only 1 reg is used
            var data = registerCache.getFreeFragmentConstant();
            var data2 = registerCache.getFreeFragmentConstant();
            var code = "";
            var refractionDir;
            var refractionColor;
            var temp;
            this._fragmentIndex = data.index * 4;
            refractionDir = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(refractionDir, 1);
            refractionColor = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(refractionColor, 1);
            temp = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp, 1);
            var viewDirReg = sharedRegisters.viewDirFragment;
            var normalReg = sharedRegisters.normalFragment;
            code += "neg " + viewDirReg + ".xyz, " + viewDirReg + ".xyz\n";
            code += "dp3 " + temp + ".x, " + viewDirReg + ".xyz, " + normalReg + ".xyz\n" +
                "mul " + temp + ".w, " + temp + ".x, " + temp + ".x\n" +
                "sub " + temp + ".w, " + data2 + ".x, " + temp + ".w\n" +
                "mul " + temp + ".w, " + data + ".x, " + temp + ".w\n" +
                "mul " + temp + ".w, " + data + ".x, " + temp + ".w\n" +
                "sub " + temp + ".w, " + data2 + ".x, " + temp + ".w\n" +
                "sqt " + temp + ".y, " + temp + ".w\n" +
                "mul " + temp + ".x, " + data + ".x, " + temp + ".x\n" +
                "add " + temp + ".x, " + temp + ".x, " + temp + ".y\n" +
                "mul " + temp + ".xyz, " + temp + ".x, " + normalReg + ".xyz\n" +
                "mul " + refractionDir + ", " + data + ".x, " + viewDirReg + "\n" +
                "sub " + refractionDir + ".xyz, " + refractionDir + ".xyz, " + temp + ".xyz\n" +
                "nrm " + refractionDir + ".xyz, " + refractionDir + ".xyz\n" +
                this._envMap._getFragmentCode(refractionColor, registerCache, sharedRegisters, refractionDir) +
                "sub " + refractionColor + ".w, " + refractionColor + ".w, fc0.x	\n" +
                "kil " + refractionColor + ".w\n";
            if (this._useDispersion) {
                // GREEN
                code += "dp3 " + temp + ".x, " + viewDirReg + ".xyz, " + normalReg + ".xyz\n" +
                    "mul " + temp + ".w, " + temp + ".x, " + temp + ".x\n" +
                    "sub " + temp + ".w, " + data2 + ".x, " + temp + ".w\n" +
                    "mul " + temp + ".w, " + data + ".y, " + temp + ".w\n" +
                    "mul " + temp + ".w, " + data + ".y, " + temp + ".w\n" +
                    "sub " + temp + ".w, " + data2 + ".x, " + temp + ".w\n" +
                    "sqt " + temp + ".y, " + temp + ".w\n" +
                    "mul " + temp + ".x, " + data + ".y, " + temp + ".x\n" +
                    "add " + temp + ".x, " + temp + ".x, " + temp + ".y\n" +
                    "mul " + temp + ".xyz, " + temp + ".x, " + normalReg + ".xyz\n" +
                    "mul " + refractionDir + ", " + data + ".y, " + viewDirReg + "\n" +
                    "sub " + refractionDir + ".xyz, " + refractionDir + ".xyz, " + temp + ".xyz\n" +
                    "nrm " + refractionDir + ".xyz, " + refractionDir + ".xyz\n" +
                    this._envMap._getFragmentCode(temp, registerCache, sharedRegisters, refractionDir) +
                    "mov " + refractionColor + ".y, " + temp + ".y\n";
                // BLUE
                code += "dp3 " + temp + ".x, " + viewDirReg + ".xyz, " + normalReg + ".xyz\n" +
                    "mul " + temp + ".w, " + temp + ".x, " + temp + ".x\n" +
                    "sub " + temp + ".w, " + data2 + ".x, " + temp + ".w\n" +
                    "mul " + temp + ".w, " + data + ".z, " + temp + ".w\n" +
                    "mul " + temp + ".w, " + data + ".z, " + temp + ".w\n" +
                    "sub " + temp + ".w, " + data2 + ".x, " + temp + ".w\n" +
                    "sqt " + temp + ".y, " + temp + ".w\n" +
                    "mul " + temp + ".x, " + data + ".z, " + temp + ".x\n" +
                    "add " + temp + ".x, " + temp + ".x, " + temp + ".y\n" +
                    "mul " + temp + ".xyz, " + temp + ".x, " + normalReg + ".xyz\n" +
                    "mul " + refractionDir + ", " + data + ".z, " + viewDirReg + "\n" +
                    "sub " + refractionDir + ".xyz, " + refractionDir + ".xyz, " + temp + ".xyz\n" +
                    "nrm " + refractionDir + ".xyz, " + refractionDir + ".xyz\n" +
                    this._envMap._getFragmentCode(temp, registerCache, sharedRegisters, refractionDir) +
                    "mov " + refractionColor + ".z, " + temp + ".z\n";
            }
            code += "sub " + refractionColor + ".xyz, " + refractionColor + ".xyz, " + targetReg + ".xyz\n" +
                "mul " + refractionColor + ".xyz, " + refractionColor + ".xyz, " + data + ".w\n" +
                "add " + targetReg + ".xyz, " + targetReg + ".xyz, " + refractionColor + ".xyz\n";
            registerCache.removeFragmentTempUsage(temp);
            registerCache.removeFragmentTempUsage(refractionDir);
            registerCache.removeFragmentTempUsage(refractionColor);
            // restore
            code += "neg " + viewDirReg + ".xyz, " + viewDirReg + ".xyz\n";
            return code;
        };
        _Shader_EffectRefractionEnvMapMethod.prototype._updateProperties = function () {
            var index = this._fragmentIndex;
            var data = this._shader.fragmentConstantData;
            var refractionIndex = this._method.refractionIndex;
            data[index] = this._method.dispersionR + refractionIndex;
            if (this._useDispersion) {
                data[index + 1] = this._method.dispersionG + refractionIndex;
                data[index + 2] = this._method.dispersionB + refractionIndex;
            }
            data[index + 3] = this._method.alpha;
        };
        return _Shader_EffectRefractionEnvMapMethod;
    }(_Shader_EffectEnvMapMethod));
    ShaderBase.registerAbstraction(_Shader_EffectRefractionEnvMapMethod, EffectRefractionEnvMapMethod);

    /**
     * EffectRimLightMethod provides a method to add rim lighting to a material. This adds a glow-like effect to edges of objects.
     */
    var EffectRimLightMethod = /** @class */ (function (_super) {
        __extends$7(EffectRimLightMethod, _super);
        /**
         * Creates a new <code>EffectRimLightMethod</code> object.
         *
         * @param color The colour of the rim light.
         * @param strength The strength of the rim light.
         * @param power The power of the rim light. Higher values will result in a higher edge fall-off.
         * @param blend The blend mode with which to add the light to the object.
         */
        function EffectRimLightMethod(color, strength, power, blend) {
            if (color === void 0) { color = 0xffffff; }
            if (strength === void 0) { strength = .4; }
            if (power === void 0) { power = 2; }
            if (blend === void 0) { blend = "mix"; }
            var _this = _super.call(this) || this;
            _this._blendMode = blend;
            _this._strength = strength;
            _this._power = power;
            _this._color = color;
            return _this;
        }
        Object.defineProperty(EffectRimLightMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return EffectRimLightMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectRimLightMethod.prototype, "color", {
            /**
             * The color of the rim light.
             */
            get: function () {
                return this._color;
            },
            set: function (value /*uint*/) {
                if (this._power == value)
                    return;
                this._color = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectRimLightMethod.prototype, "strength", {
            /**
             * The strength of the rim light.
             */
            get: function () {
                return this._strength;
            },
            set: function (value) {
                if (this._strength == value)
                    return;
                this._strength = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectRimLightMethod.prototype, "power", {
            /**
             * The power of the rim light. Higher values will result in a higher edge fall-off.
             */
            get: function () {
                return this._power;
            },
            set: function (value) {
                if (this._power == value)
                    return;
                this._power = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(EffectRimLightMethod.prototype, "blendMode", {
            /**
             * The blend mode with which to add the light to the object.
             *
             * EffectRimLightMethod.MULTIPLY multiplies the rim light with the material's colour.
             * EffectRimLightMethod.ADD adds the rim light with the material's colour.
             * EffectRimLightMethod.MIX provides normal alpha blending.
             */
            get: function () {
                return this._blendMode;
            },
            set: function (value) {
                if (this._blendMode == value)
                    return;
                this._blendMode = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        EffectRimLightMethod.ADD = "add";
        EffectRimLightMethod.MULTIPLY = "multiply";
        EffectRimLightMethod.MIX = "mix";
        EffectRimLightMethod.assetType = "[asset EffectRimLightMethod]";
        return EffectRimLightMethod;
    }(MethodBase));
    /**
     * _Shader_EffectRimLightMethod provides a method to add rim lighting to a material. This adds a glow-like effect to edges of objects.
     */
    var _Shader_EffectRimLightMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_EffectRimLightMethod, _super);
        /**
         * Creates a new EffectEnvMapChunk.
         */
        function _Shader_EffectRimLightMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_EffectRimLightMethod.prototype._initVO = function (chunkVO) {
            chunkVO.needsNormals = true;
            chunkVO.needsView = true;
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectRimLightMethod.prototype._activate = function () {
            if (this._invalid) {
                var index = this._rimColorIndex;
                var data = this._shader.fragmentConstantData;
                var color = this._method.color;
                data[index] = ((color >> 16) & 0xff) / 0xff;
                data[index + 1] = ((color >> 8) & 0xff) / 0xff;
                data[index + 2] = (color & 0xff) / 0xff;
                data[index + 3] = 1;
                data[index + 4] = this._method.strength;
                data[index + 5] = this._method.power;
            }
        };
        /**
         * @inheritDoc
         */
        _Shader_EffectRimLightMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var dataRegister = registerCache.getFreeFragmentConstant();
            var dataRegister2 = registerCache.getFreeFragmentConstant();
            var temp = registerCache.getFreeFragmentVectorTemp();
            var code = "";
            this._rimColorIndex = dataRegister.index * 4;
            code += "dp3 " + temp + ".x, " + sharedRegisters.viewDirFragment + ".xyz, " + sharedRegisters.normalFragment + ".xyz\n" +
                "sat " + temp + ".x, " + temp + ".x\n" +
                "sub " + temp + ".x, " + dataRegister + ".w, " + temp + ".x\n" +
                "pow " + temp + ".x, " + temp + ".x, " + dataRegister2 + ".y\n" +
                "mul " + temp + ".x, " + temp + ".x, " + dataRegister2 + ".x\n" +
                "sub " + temp + ".x, " + dataRegister + ".w, " + temp + ".x\n" +
                "mul " + targetReg + ".xyz, " + targetReg + ".xyz, " + temp + ".x\n" +
                "sub " + temp + ".w, " + dataRegister + ".w, " + temp + ".x\n";
            if (this._method.blendMode == EffectRimLightMethod.ADD) {
                code += "mul " + temp + ".xyz, " + temp + ".w, " + dataRegister + ".xyz\n" +
                    "add " + targetReg + ".xyz, " + targetReg + ".xyz, " + temp + ".xyz\n";
            }
            else if (this._method.blendMode == EffectRimLightMethod.MULTIPLY) {
                code += "mul " + temp + ".xyz, " + temp + ".w, " + dataRegister + ".xyz\n" +
                    "mul " + targetReg + ".xyz, " + targetReg + ".xyz, " + temp + ".xyz\n";
            }
            else {
                code += "sub " + temp + ".xyz, " + dataRegister + ".xyz, " + targetReg + ".xyz\n" +
                    "mul " + temp + ".xyz, " + temp + ".xyz, " + temp + ".w\n" +
                    "add " + targetReg + ".xyz, " + targetReg + ".xyz, " + temp + ".xyz\n";
            }
            return code;
        };
        return _Shader_EffectRimLightMethod;
    }(_Shader_MethodBase));
    ShaderBase.registerAbstraction(_Shader_EffectRimLightMethod, EffectRimLightMethod);

    /**
     * NormalBasicMethod is the default method for standard tangent-space normal mapping.
     */
    var NormalBasicMethod = /** @class */ (function (_super) {
        __extends$7(NormalBasicMethod, _super);
        /**
         * Creates a new NormalBasicMethod object.
         */
        function NormalBasicMethod(texture) {
            if (texture === void 0) { texture = null; }
            var _this = _super.call(this) || this;
            _this._texture = texture;
            if (_this._texture)
                _this.iAddTexture(_this._texture);
            return _this;
        }
        Object.defineProperty(NormalBasicMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return NormalBasicMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NormalBasicMethod.prototype, "texture", {
            /**
             * A texture to modulate the direction of the surface for each texel (normal map). The default normal method expects
             * tangent-space normal maps, but others could expect object-space maps.
             */
            get: function () {
                return this._texture;
            },
            set: function (value) {
                if (this._texture == value)
                    return;
                if (this._texture)
                    this.iRemoveTexture(this._texture);
                this._texture = value;
                if (this._texture)
                    this.iAddTexture(this._texture);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        NormalBasicMethod.prototype.copyFrom = function (method) {
            var bnm = method;
            if (bnm.texture != null)
                this.texture = bnm.texture;
        };
        /**
         * @inheritDoc
         */
        NormalBasicMethod.prototype.dispose = function () {
            if (this._texture)
                this._texture = null;
        };
        NormalBasicMethod.assetType = "[asset NormalBasicMethod]";
        return NormalBasicMethod;
    }(MethodBase));
    /**
     * _Shader_NormalBasicMethod is the default method for standard tangent-space normal mapping.
     */
    var _Shader_NormalBasicMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_NormalBasicMethod, _super);
        /**
         * Creates a new EffectEnvMapChunk.
         */
        function _Shader_NormalBasicMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        _Shader_NormalBasicMethod.prototype._isUsed = function () {
            if (this._texture && this._shader.normalDependencies)
                return true;
            return false;
        };
        /**
         * @inheritDoc
         */
        _Shader_NormalBasicMethod.prototype._initVO = function (chunkVO) {
            if (this._method.texture) {
                this._texture = this._shader.getAbstraction(this._method.texture);
                this._texture._initVO(chunkVO);
                this._shader.uvDependencies++;
            }
        };
        /**
         * @inheritDoc
         */
        _Shader_NormalBasicMethod.prototype._initConstants = function () {
            if (this._method.texture)
                this._texture._initConstants();
        };
        /**
         * Indicates whether or not this method outputs normals in tangent space. Override for object-space normals.
         */
        _Shader_NormalBasicMethod.prototype._outputsTangentNormals = function () {
            return true;
        };
        /**
         * @inheritDoc
         */
        _Shader_NormalBasicMethod.prototype._activate = function () {
            if (this._texture)
                this._texture.activate();
        };
        _Shader_NormalBasicMethod.prototype._setRenderState = function (renderState, view) {
            if (this._texture)
                this._texture._setRenderState(renderState);
        };
        /**
         * @inheritDoc
         */
        _Shader_NormalBasicMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code = "";
            if (this._texture)
                code += this._texture._getFragmentCode(targetReg, registerCache, sharedRegisters, sharedRegisters.uvVarying);
            code += "sub " + targetReg + ".xyz, " + targetReg + ".xyz, " + sharedRegisters.commons + ".xxx\n" +
                "nrm " + targetReg + ".xyz, " + targetReg + "\n";
            return code;
        };
        return _Shader_NormalBasicMethod;
    }(_Shader_MethodBase));
    ShaderBase.registerAbstraction(_Shader_NormalBasicMethod, NormalBasicMethod);

    /**
     * NormalHeightMapMethod provides a normal map method that uses a height map to calculate the normals.
     */
    var NormalHeightMapMethod = /** @class */ (function (_super) {
        __extends$7(NormalHeightMapMethod, _super);
        /**
         * Creates a new NormalHeightMapMethod method.
         *
         * @param heightMap The texture containing the height data. 0 means low, 1 means high.
         * @param worldWidth The width of the 'world'. This is used to map uv coordinates' u component to scene dimensions.
         * @param worldHeight The height of the 'world'. This is used to map the height map values to scene dimensions.
         * @param worldDepth The depth of the 'world'. This is used to map uv coordinates' v component to scene dimensions.
         */
        function NormalHeightMapMethod(heightMap, worldWidth, worldHeight, worldDepth) {
            var _this = _super.call(this) || this;
            _this.texture = heightMap;
            _this._worldXYRatio = worldWidth / worldHeight;
            _this._worldXZRatio = worldDepth / worldHeight;
            return _this;
        }
        Object.defineProperty(NormalHeightMapMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return NormalHeightMapMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NormalHeightMapMethod.prototype, "worldXYRatio", {
            get: function () {
                return this._worldXYRatio;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NormalHeightMapMethod.prototype, "worldXZRatio", {
            get: function () {
                return this._worldXZRatio;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        NormalHeightMapMethod.prototype.copyFrom = function (method) {
            _super.prototype.copyFrom.call(this, method);
            this._worldXYRatio = method._worldXYRatio;
            this._worldXZRatio = method._worldXZRatio;
        };
        NormalHeightMapMethod.assetType = "[asset NormalHeightMapMethod]";
        return NormalHeightMapMethod;
    }(NormalBasicMethod));
    /**
     * _Shader_NormalHeightMapMethod provides a normal map method that uses a height map to calculate the normals.
     */
    var _Shader_NormalHeightMapMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_NormalHeightMapMethod, _super);
        /**
         * Creates a new _Shader_NormalHeightMapMethod.
         */
        function _Shader_NormalHeightMapMethod(method, shader) {
            return _super.call(this, method, shader) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_NormalHeightMapMethod.prototype._initConstants = function () {
            _super.prototype._initConstants.call(this);
            var index = this._fragmentConstantsIndex;
            var data = this._shader.fragmentConstantData;
            var image = this._method.texture.image;
            data[index] = 1 / image.width;
            data[index + 1] = 1 / image.height;
            data[index + 2] = 0;
            data[index + 3] = 1;
            data[index + 4] = this._method.worldXYRatio;
            data[index + 5] = this._method.worldXZRatio;
        };
        Object.defineProperty(_Shader_NormalHeightMapMethod.prototype, "tangentSpace", {
            /**
             * @inheritDoc
             */
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        _Shader_NormalHeightMapMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code = "";
            var temp = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp, 1);
            var dataReg = registerCache.getFreeFragmentConstant();
            var dataReg2 = registerCache.getFreeFragmentConstant();
            this._fragmentConstantsIndex = dataReg.index * 4;
            code += this._texture._getFragmentCode(targetReg, registerCache, sharedRegisters, sharedRegisters.uvVarying) +
                "add " + temp + ", " + sharedRegisters.uvVarying + ", " + dataReg + ".xzzz\n" +
                this._texture._getFragmentCode(temp, registerCache, sharedRegisters, temp) +
                "sub " + targetReg + ".x, " + targetReg + ".x, " + temp + ".x\n" +
                "add " + temp + ", " + sharedRegisters.uvVarying + ", " + dataReg + ".zyzz\n" +
                this._texture._getFragmentCode(temp, registerCache, sharedRegisters, temp) +
                "sub " + targetReg + ".z, " + targetReg + ".z, " + temp + ".x\n" +
                "mov " + targetReg + ".y, " + dataReg + ".w\n" +
                "mul " + targetReg + ".xz, " + targetReg + ".xz, " + dataReg2 + ".xy\n" +
                "nrm " + targetReg + ".xyz, " + targetReg + ".xyz\n";
            registerCache.removeFragmentTempUsage(temp);
            return code;
        };
        return _Shader_NormalHeightMapMethod;
    }(_Shader_NormalBasicMethod));
    ShaderBase.registerAbstraction(_Shader_NormalHeightMapMethod, NormalHeightMapMethod);

    /**
     * NormalSimpleWaterMethod provides a basic normal map method to create water ripples by translating two wave normal maps.
     */
    var NormalSimpleWaterMethod = /** @class */ (function (_super) {
        __extends$7(NormalSimpleWaterMethod, _super);
        /**
         * Creates a new NormalSimpleWaterMethod object.
         * @param waveMap1 A normal map containing one layer of a wave structure.
         * @param waveMap2 A normal map containing a second layer of a wave structure.
         */
        function NormalSimpleWaterMethod(normalMap, secondaryNormalMap) {
            if (normalMap === void 0) { normalMap = null; }
            if (secondaryNormalMap === void 0) { secondaryNormalMap = null; }
            var _this = _super.call(this, normalMap) || this;
            _this._water1OffsetX = 0;
            _this._water1OffsetY = 0;
            _this._water2OffsetX = 0;
            _this._water2OffsetY = 0;
            _this._secondaryNormalMap = secondaryNormalMap;
            if (_this._secondaryNormalMap)
                _this.iAddTexture(_this._secondaryNormalMap);
            return _this;
        }
        Object.defineProperty(NormalSimpleWaterMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return NormalSimpleWaterMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NormalSimpleWaterMethod.prototype, "water1OffsetX", {
            /**
             * The translation of the first wave layer along the X-axis.
             */
            get: function () {
                return this._water1OffsetX;
            },
            set: function (value) {
                this._water1OffsetX = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NormalSimpleWaterMethod.prototype, "water1OffsetY", {
            /**
             * The translation of the first wave layer along the Y-axis.
             */
            get: function () {
                return this._water1OffsetY;
            },
            set: function (value) {
                this._water1OffsetY = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NormalSimpleWaterMethod.prototype, "water2OffsetX", {
            /**
             * The translation of the second wave layer along the X-axis.
             */
            get: function () {
                return this._water2OffsetX;
            },
            set: function (value) {
                this._water2OffsetX = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NormalSimpleWaterMethod.prototype, "water2OffsetY", {
            /**
             * The translation of the second wave layer along the Y-axis.
             */
            get: function () {
                return this._water2OffsetY;
            },
            set: function (value) {
                this._water2OffsetY = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NormalSimpleWaterMethod.prototype, "secondaryNormalMap", {
            /**
             * A second normal map that will be combined with the first to create a wave-like animation pattern.
             */
            get: function () {
                return this._secondaryNormalMap;
            },
            set: function (value) {
                if (this._secondaryNormalMap == value)
                    return;
                if (this._secondaryNormalMap)
                    this.iRemoveTexture(this._secondaryNormalMap);
                this._secondaryNormalMap = value;
                if (this._secondaryNormalMap)
                    this.iAddTexture(this._secondaryNormalMap);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        NormalSimpleWaterMethod.prototype.dispose = function () {
            _super.prototype.dispose.call(this);
            this._secondaryNormalMap = null;
        };
        NormalSimpleWaterMethod.assetType = "[asset NormalSimpleWaterMethod]";
        return NormalSimpleWaterMethod;
    }(NormalBasicMethod));
    /**
     * _Shader_NormalSimpleWaterMethod provides a basic normal map method to create water ripples by translating two wave normal maps.
     */
    var _Shader_NormalSimpleWaterMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_NormalSimpleWaterMethod, _super);
        /**
         * Creates a new NormalHeightMapChunk.
         */
        function _Shader_NormalSimpleWaterMethod(method, shader) {
            return _super.call(this, method, shader) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_NormalSimpleWaterMethod.prototype._initConstants = function () {
            _super.prototype._initConstants.call(this);
            var index = this._fragmentConstantsIndex;
            var data = this._shader.fragmentConstantData;
            data[index] = .5;
            data[index + 1] = 0;
            data[index + 2] = 0;
            data[index + 3] = 1;
        };
        /**
         * @inheritDoc
         */
        _Shader_NormalSimpleWaterMethod.prototype._initVO = function (chunkVO) {
            _super.prototype._initVO.call(this, chunkVO);
            if (this._method.secondaryNormalMap) {
                this._secondaryNormalMap = this._shader.getAbstraction(this._method.secondaryNormalMap);
                this._shader.uvDependencies++;
            }
        };
        /**
         * @inheritDoc
         */
        _Shader_NormalSimpleWaterMethod.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            this._secondaryNormalMap = null;
        };
        /**
         * @inheritDoc
         */
        _Shader_NormalSimpleWaterMethod.prototype._activate = function () {
            _super.prototype._activate.call(this);
            if (this._invalid) {
                var data = this._shader.fragmentConstantData;
                var index = this._fragmentConstantsIndex;
                data[index + 4] = this._method.water1OffsetX;
                data[index + 5] = this._method.water1OffsetY;
                data[index + 6] = this._method.water2OffsetX;
                data[index + 7] = this._method.water2OffsetY;
            }
            if (this._secondaryNormalMap)
                this._secondaryNormalMap.activate();
        };
        /**
         * @inheritDoc
         */
        _Shader_NormalSimpleWaterMethod.prototype._setRenderState = function (renderState, view) {
            _super.prototype._setRenderState.call(this, renderState, view);
            if (this._secondaryNormalMap)
                this._secondaryNormalMap._setRenderState(renderState);
        };
        /**
         * @inheritDoc
         */
        _Shader_NormalSimpleWaterMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code = "";
            var temp = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp, 1);
            var dataReg = registerCache.getFreeFragmentConstant();
            var dataReg2 = registerCache.getFreeFragmentConstant();
            this._fragmentConstantsIndex = dataReg.index * 4;
            code += "add " + temp + ", " + sharedRegisters.uvVarying + ", " + dataReg2 + ".xyxy\n";
            if (this._texture)
                code += this._texture._getFragmentCode(targetReg, registerCache, sharedRegisters, temp);
            code += "add " + temp + ", " + sharedRegisters.uvVarying + ", " + dataReg2 + ".zwzw\n";
            if (this._secondaryNormalMap)
                code += this._secondaryNormalMap._getFragmentCode(temp, registerCache, sharedRegisters, temp);
            code += "add " + targetReg + ", " + targetReg + ", " + temp + "		\n" +
                "mul " + targetReg + ", " + targetReg + ", " + dataReg + ".x	\n" +
                "sub " + targetReg + ".xyz, " + targetReg + ".xyz, " + sharedRegisters.commons + ".xxx	\n" +
                "nrm " + targetReg + ".xyz, " + targetReg + ".xyz							\n";
            return code;
        };
        return _Shader_NormalSimpleWaterMethod;
    }(_Shader_NormalBasicMethod));
    ShaderBase.registerAbstraction(_Shader_NormalSimpleWaterMethod, NormalSimpleWaterMethod);

    /**
     * ShadowMethodBase provides an abstract base method for shadow map methods.
     */
    var ShadowMethodBase = /** @class */ (function (_super) {
        __extends$7(ShadowMethodBase, _super);
        /**
         * Creates a new ShadowMethodBase object.
         * @param castingLight The light used to cast shadows.
         */
        function ShadowMethodBase(castingLight) {
            var _this = _super.call(this, castingLight.shadowMapper) || this;
            _this._castingLight = castingLight;
            return _this;
        }
        Object.defineProperty(ShadowMethodBase.prototype, "castingLight", {
            /**
             * The light casting the shadows.
             */
            get: function () {
                return this._castingLight;
            },
            enumerable: true,
            configurable: true
        });
        return ShadowMethodBase;
    }(CompositeMethodBase));
    /**
     * ShadowHardChunk provides the cheapest shadow map method by using a single tap without any filtering.
     */
    var _Shader_ShadowMethodBase = /** @class */ (function (_super) {
        __extends$7(_Shader_ShadowMethodBase, _super);
        /**
         * Creates a new ShadowHardChunk.
         */
        function _Shader_ShadowMethodBase(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        _Shader_ShadowMethodBase.prototype._initVO = function (chunkVO) {
            _super.prototype._initVO.call(this, chunkVO);
            this._baseTexture = this._baseChunk.texture;
        };
        return _Shader_ShadowMethodBase;
    }(_Shader_CompositeMethodBase));

    /**
     * ShadowDitheredMethod provides a soft shadowing technique by randomly distributing sample points differently for each fragment.
     */
    var ShadowDitheredMethod = /** @class */ (function (_super) {
        __extends$7(ShadowDitheredMethod, _super);
        /**
         * Creates a new ShadowDitheredMethod object.
         * @param castingLight The light casting the shadows
         * @param numSamples The amount of samples to take for dithering. Minimum 1, maximum 24.
         */
        function ShadowDitheredMethod(castingLight, numSamples, range) {
            if (numSamples === void 0) { numSamples = 4; }
            if (range === void 0) { range = 1; }
            var _this = _super.call(this, castingLight) || this;
            _this._depthMapSize = _this._castingLight.shadowMapper.size;
            _this.numSamples = numSamples;
            _this.range = range;
            ++ShadowDitheredMethod._grainUsages;
            if (!ShadowDitheredMethod._grainTexture)
                _this.initGrainTexture();
            return _this;
        }
        Object.defineProperty(ShadowDitheredMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return ShadowDitheredMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShadowDitheredMethod.prototype, "numSamples", {
            /**
             * The amount of samples to take for dithering. Minimum 1, maximum 24. The actual maximum may depend on the
             * complexity of the shader.
             */
            get: function () {
                return this._numSamples;
            },
            set: function (value) {
                if (value < 1)
                    value = 1;
                else if (value > 24)
                    value = 24;
                if (this._numSamples == value)
                    return;
                this._numSamples = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShadowDitheredMethod.prototype, "range", {
            /**
             * The range in the shadow map in which to distribute the samples.
             */
            get: function () {
                return this._range * 2;
            },
            set: function (value) {
                this._range = value / 2;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Creates a texture containing the dithering noise texture.
         */
        ShadowDitheredMethod.prototype.initGrainTexture = function () {
            ShadowDitheredMethod._grainBitmapImage2D = new BitmapImage2D(64, 64, false);
            var vec = new Array();
            var len = 4096;
            var step = 1 / (this._depthMapSize * this._range);
            var r, g;
            for (var i = 0; i < len; ++i) {
                r = 2 * (Math.random() - .5);
                g = 2 * (Math.random() - .5);
                if (r < 0)
                    r -= step;
                else
                    r += step;
                if (g < 0)
                    g -= step;
                else
                    g += step;
                if (r > 1)
                    r = 1;
                else if (r < -1)
                    r = -1;
                if (g > 1)
                    g = 1;
                else if (g < -1)
                    g = -1;
                vec[i] = (Math.floor((r * .5 + .5) * 0xff) << 16) | (Math.floor((g * .5 + .5) * 0xff) << 8);
            }
            ShadowDitheredMethod._grainBitmapImage2D.setArray(ShadowDitheredMethod._grainBitmapImage2D.rect, vec);
            ShadowDitheredMethod._grainTexture = new ImageTexture2D(ShadowDitheredMethod._grainBitmapImage2D);
        };
        /**
         * @inheritDoc
         */
        ShadowDitheredMethod.prototype.dispose = function () {
            if (--ShadowDitheredMethod._grainUsages == 0) {
                ShadowDitheredMethod._grainTexture.dispose();
                ShadowDitheredMethod._grainBitmapImage2D.dispose();
                ShadowDitheredMethod._grainTexture = null;
            }
        };
        ShadowDitheredMethod.assetType = "[asset ShadowDitheredMethod]";
        return ShadowDitheredMethod;
    }(ShadowMethodBase));
    /**
     * _Shader_ShadowDitheredMethod provides a soft shadowing technique by randomly distributing sample points differently for each fragment.
     */
    var _Shader_ShadowDitheredMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_ShadowDitheredMethod, _super);
        /**
         * Creates a new _Shader_ShadowDitheredMethod.
         */
        function _Shader_ShadowDitheredMethod(method, shader) {
            return _super.call(this, method, shader) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_ShadowDitheredMethod.prototype._initVO = function (chunkVO) {
            _super.prototype._initVO.call(this, chunkVO);
            chunkVO.needsProjection = true;
            this._grainMap = this._shader.getAbstraction(ShadowDitheredMethod._grainTexture);
        };
        /**
         * @inheritDoc
         */
        _Shader_ShadowDitheredMethod.prototype._initConstants = function () {
            _super.prototype._initConstants.call(this);
            var data = this._shader.fragmentConstantData;
            var index = this._fragmentConstantsIndex;
            data[index] = 1 / this._method.numSamples;
        };
        /**
         * @inheritDoc
         */
        _Shader_ShadowDitheredMethod.prototype._activate = function () {
            _super.prototype._activate.call(this);
            var data = this._shader.fragmentConstantData;
            var index = this._fragmentConstantsIndex;
            data[index + 1] = (this._shader.renderMaterial.renderGroup.view.width - 1) / 63;
            data[index + 2] = (this._shader.renderMaterial.renderGroup.view.height - 1) / 63;
            data[index + 3] = 2 * this._method.range / this._method.castingLight.shadowMapper.size;
            this._grainMap.activate();
        };
        /**
         * @inheritDoc
         */
        _Shader_ShadowDitheredMethod.prototype._getFragmentCode = function (targetReg, regCache, sharedRegisters) {
            var dataReg = regCache.getFreeFragmentConstant();
            this._fragmentConstantsIndex = dataReg.index * 4;
            var code = "";
            var numSamples = this._method.numSamples;
            var uvReg = regCache.getFreeFragmentVectorTemp();
            regCache.addFragmentTempUsages(uvReg, 1);
            var temp = regCache.getFreeFragmentVectorTemp();
            regCache.addFragmentTempUsages(temp, 1);
            var projectionReg = sharedRegisters.projectionFragment;
            code += "div " + uvReg + ", " + projectionReg + ", " + projectionReg + ".w\n" +
                "mul " + uvReg + ".xy, " + uvReg + ".xy, " + dataReg + ".yz\n";
            var index = numSamples;
            while (index > 0) {
                if (index == numSamples) {
                    code += this._grainMap._getFragmentCode(uvReg, regCache, sharedRegisters, uvReg);
                }
                else {
                    code += "mov " + temp + ", " + uvReg + ".zwxy \n" +
                        this._grainMap._getFragmentCode(uvReg, regCache, sharedRegisters, temp);
                }
                // keep grain in uvReg.zw
                code += "sub " + uvReg + ".zw, " + uvReg + ".xy, fc0.xx\n" + // uv-.5
                    "mul " + uvReg + ".zw, " + uvReg + ".zw, " + dataReg + ".w\n"; // (tex unpack scale and tex scale in one)
                if (index == numSamples) {
                    // first sample
                    code += "add " + uvReg + ".xy, " + uvReg + ".zw, " + this._baseChunk.depthMapCoordReg + ".xy\n" +
                        this._baseTexture._getFragmentCode(targetReg, regCache, sharedRegisters, uvReg);
                }
                else {
                    code += this._addSample(uvReg, targetReg, regCache, sharedRegisters);
                }
                if (index > 4)
                    code += "add " + uvReg + ".xy, " + uvReg + ".xy, " + uvReg + ".zw\n" +
                        this._addSample(uvReg, targetReg, regCache, sharedRegisters);
                if (index > 1)
                    code += "sub " + uvReg + ".xy, " + this._baseChunk.depthMapCoordReg + ".xy, " + uvReg + ".zw\n" +
                        this._addSample(uvReg, targetReg, regCache, sharedRegisters);
                if (index > 5)
                    code += "sub " + uvReg + ".xy, " + uvReg + ".xy, " + uvReg + ".zw\n" +
                        this._addSample(uvReg, targetReg, regCache, sharedRegisters);
                if (index > 2) {
                    code += "neg " + uvReg + ".w, " + uvReg + ".w\n" + // will be rotated 90 degrees when being accessed as wz
                        "add " + uvReg + ".xy, " + uvReg + ".wz, " + this._baseChunk.depthMapCoordReg + ".xy\n" +
                        this._addSample(uvReg, targetReg, regCache, sharedRegisters);
                }
                if (index > 6)
                    code += "add " + uvReg + ".xy, " + uvReg + ".xy, " + uvReg + ".wz\n" +
                        this._addSample(uvReg, targetReg, regCache, sharedRegisters);
                if (index > 3)
                    code += "sub " + uvReg + ".xy, " + this._baseChunk.depthMapCoordReg + ".xy, " + uvReg + ".wz\n" +
                        this._addSample(uvReg, targetReg, regCache, sharedRegisters);
                if (index > 7)
                    code += "sub " + uvReg + ".xy, " + uvReg + ".xy, " + uvReg + ".wz\n" +
                        this._addSample(uvReg, targetReg, regCache, sharedRegisters);
                index -= 8;
            }
            regCache.removeFragmentTempUsage(temp);
            regCache.removeFragmentTempUsage(uvReg);
            code += "mul " + targetReg + ".w, " + targetReg + ".w, " + dataReg + ".x\n" + // average
                _super.prototype._getFragmentCode.call(this, targetReg, regCache, sharedRegisters);
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_ShadowDitheredMethod.prototype._setRenderState = function (renderState, view) {
            _super.prototype._setRenderState.call(this, renderState, view);
            this._grainMap._setRenderState(renderState);
        };
        /**
         * Adds the code for another tap to the shader code.
         * @param uvReg The uv register for the tap.
         * @param depthMapRegister The texture register containing the depth map.
         * @param decReg The register containing the depth map decoding data.
         * @param targetReg The target register to add the tap comparison result.
         * @param regCache The register cache managing the registers.
         * @return
         */
        _Shader_ShadowDitheredMethod.prototype._addSample = function (uvReg, targetReg, regCache, sharedRegisters) {
            var temp = regCache.getFreeFragmentVectorTemp();
            regCache.addFragmentTempUsages(temp, 1);
            var code = this._baseTexture._getFragmentCode(temp, regCache, sharedRegisters, uvReg) +
                "add " + targetReg + ".w, " + targetReg + ".w, " + temp + ".w\n";
            regCache.removeFragmentTempUsage(temp);
            return code;
        };
        return _Shader_ShadowDitheredMethod;
    }(_Shader_ShadowMethodBase));
    ShaderBase.registerAbstraction(_Shader_ShadowDitheredMethod, ShadowDitheredMethod);

    /**
     * ShadowFilteredMethod provides a softened shadowing technique by bilinearly interpolating shadow comparison
     * results of neighbouring pixels.
     */
    var ShadowFilteredMethod = /** @class */ (function (_super) {
        __extends$7(ShadowFilteredMethod, _super);
        function ShadowFilteredMethod() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(ShadowFilteredMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return ShadowFilteredMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        ShadowFilteredMethod.assetType = "[asset ShadowFilteredMethod]";
        return ShadowFilteredMethod;
    }(ShadowMethodBase));
    /**
     * _Shader_ShadowFilteredMethod provides a softened shadowing technique by bilinearly interpolating shadow comparison
     * results of neighbouring pixels.
     */
    var _Shader_ShadowFilteredMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_ShadowFilteredMethod, _super);
        /**
         * Creates a new _Shader_ShadowFilteredMethod.
         */
        function _Shader_ShadowFilteredMethod(method, shader) {
            return _super.call(this, method, shader) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_ShadowFilteredMethod.prototype._initConstants = function () {
            _super.prototype._initConstants.call(this);
            var fragmentData = this._shader.fragmentConstantData;
            var index = this._fragmentConstantsIndex;
            fragmentData[index] = .5;
            var size = this._method.castingLight.shadowMapper.size;
            fragmentData[index + 1] = size;
            fragmentData[index + 2] = 1 / size;
        };
        /**
         * @inheritDoc
         */
        _Shader_ShadowFilteredMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var dataReg = registerCache.getFreeFragmentConstant();
            this._fragmentConstantsIndex = dataReg.index * 4;
            var code = "";
            var uvReg = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(uvReg, 1);
            var temp = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp, 1);
            code += "mov " + uvReg + ", " + this._baseChunk.depthMapCoordReg + "\n" +
                this._baseTexture._getFragmentCode(temp, registerCache, sharedRegisters, uvReg) +
                "mov " + uvReg + ".w, " + temp + ".w\n" +
                "add " + uvReg + ".x, " + this._baseChunk.depthMapCoordReg + ".x, " + dataReg + ".z\n" + // (1, 0)
                this._baseTexture._getFragmentCode(temp, registerCache, sharedRegisters, uvReg) +
                "mul " + temp + ".x, " + this._baseChunk.depthMapCoordReg + ".x, " + dataReg + ".y\n" +
                "frc " + temp + ".x, " + temp + ".x\n" +
                "sub " + temp + ".w, " + temp + ".w, " + uvReg + ".w\n" +
                "mul " + temp + ".w, " + temp + ".w, " + temp + ".x\n" +
                "add " + targetReg + ".w, " + uvReg + ".w, " + temp + ".w\n" +
                "mov " + uvReg + ".x, " + this._baseChunk.depthMapCoordReg + ".x\n" +
                "add " + uvReg + ".y, " + this._baseChunk.depthMapCoordReg + ".y, " + dataReg + ".z\n" + // (0, 1)
                this._baseTexture._getFragmentCode(temp, registerCache, sharedRegisters, uvReg) +
                "mov " + uvReg + ".w, " + temp + ".w\n" +
                "add " + uvReg + ".x, " + this._baseChunk.depthMapCoordReg + ".x, " + dataReg + ".z\n" + // (1, 1)
                this._baseTexture._getFragmentCode(temp, registerCache, sharedRegisters, uvReg) +
                // recalculate fraction, since we ran out of registers :(
                "mul " + temp + ".x, " + this._baseChunk.depthMapCoordReg + ".x, " + dataReg + ".y\n" +
                "frc " + temp + ".x, " + temp + ".x\n" +
                "sub " + temp + ".w, " + temp + ".w, " + uvReg + ".w\n" +
                "mul " + temp + ".w, " + temp + ".w, " + temp + ".x\n" +
                "add " + uvReg + ".w, " + uvReg + ".w, " + temp + ".w\n" +
                "mul " + temp + ".x, " + this._baseChunk.depthMapCoordReg + ".y, " + dataReg + ".y\n" +
                "frc " + temp + ".x, " + temp + ".x\n" +
                "sub " + uvReg + ".w, " + uvReg + ".w, " + targetReg + ".w\n" +
                "mul " + uvReg + ".w, " + uvReg + ".w, " + temp + ".x\n" +
                "add " + targetReg + ".w, " + targetReg + ".w, " + uvReg + ".w\n";
            registerCache.removeFragmentTempUsage(temp);
            registerCache.removeFragmentTempUsage(uvReg);
            _super.prototype._getFragmentCode.call(this, targetReg, registerCache, sharedRegisters);
            return code;
        };
        return _Shader_ShadowFilteredMethod;
    }(_Shader_ShadowMethodBase));
    ShaderBase.registerAbstraction(_Shader_ShadowFilteredMethod, ShadowFilteredMethod);

    /**
     * ShadowHardMethod provides the cheapest shadow map method by using a single tap without any filtering.
     */
    var ShadowHardMethod = /** @class */ (function (_super) {
        __extends$7(ShadowHardMethod, _super);
        function ShadowHardMethod() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(ShadowHardMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return ShadowHardMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        ShadowHardMethod.assetType = "[asset ShadowHardMethod]";
        return ShadowHardMethod;
    }(ShadowMethodBase));
    /**
     * _Shader_ShadowHardMethod provides the cheapest shadow map method by using a single tap without any filtering.
     */
    var _Shader_ShadowHardMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_ShadowHardMethod, _super);
        /**
         * Creates a new _Shader_ShadowHardMethod.
         */
        function _Shader_ShadowHardMethod(method, shader) {
            return _super.call(this, method, shader) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_ShadowHardMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code = this._baseTexture._getFragmentCode(targetReg, registerCache, sharedRegisters, this._baseChunk.depthMapCoordReg);
            code += _super.prototype._getFragmentCode.call(this, targetReg, registerCache, sharedRegisters);
            return code;
        };
        return _Shader_ShadowHardMethod;
    }(_Shader_ShadowMethodBase));
    ShaderBase.registerAbstraction(_Shader_ShadowHardMethod, ShadowHardMethod);

    /**
     * ShadowSoftMethod provides a soft shadowing technique by randomly distributing sample points.
     */
    var ShadowSoftMethod = /** @class */ (function (_super) {
        __extends$7(ShadowSoftMethod, _super);
        /**
         * Creates a new DiffuseBasicMethod object.
         *
         * @param castingLight The light casting the shadows
         * @param numSamples The amount of samples to take for dithering. Minimum 1, maximum 32.
         */
        function ShadowSoftMethod(castingLight, numSamples, range) {
            if (numSamples === void 0) { numSamples = 5; }
            if (range === void 0) { range = 1; }
            var _this = _super.call(this, castingLight) || this;
            _this.numSamples = numSamples;
            _this.range = range;
            return _this;
        }
        Object.defineProperty(ShadowSoftMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return ShadowSoftMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShadowSoftMethod.prototype, "offsets", {
            get: function () {
                return this._offsets;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShadowSoftMethod.prototype, "numSamples", {
            /**
             * The amount of samples to take for dithering. Minimum 1, maximum 32. The actual maximum may depend on the
             * complexity of the shader.
             */
            get: function () {
                return this._numSamples;
            },
            set: function (value) {
                this._numSamples = value;
                if (this._numSamples < 1)
                    this._numSamples = 1;
                else if (this._numSamples > 32)
                    this._numSamples = 32;
                this._offsets = PoissonLookup.getDistribution(this._numSamples);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ShadowSoftMethod.prototype, "range", {
            /**
             * The range in the shadow map in which to distribute the samples.
             */
            get: function () {
                return this._range;
            },
            set: function (value) {
                this._range = value;
            },
            enumerable: true,
            configurable: true
        });
        ShadowSoftMethod.assetType = "[asset ShadowSoftMethod]";
        return ShadowSoftMethod;
    }(ShadowMethodBase));
    /**
     * _Shader_ShadowSoftMethod provides a soft shadowing technique by randomly distributing sample points.
     */
    var _Shader_ShadowSoftMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_ShadowSoftMethod, _super);
        /**
         * Creates a new ShadowHardChunk.
         */
        function _Shader_ShadowSoftMethod(method, shader) {
            return _super.call(this, method, shader) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_ShadowSoftMethod.prototype._initConstants = function () {
            _super.prototype._initConstants.call(this);
            this._shader.fragmentConstantData[this._fragmentConstantsIndex] = 1 / this._method.numSamples;
            this._shader.fragmentConstantData[this._fragmentConstantsIndex + 1] = 0;
        };
        /**
         * @inheritDoc
         */
        _Shader_ShadowSoftMethod.prototype._activate = function () {
            _super.prototype._activate.call(this);
            var texRange = .5 * this._method.range / this._method.castingLight.shadowMapper.size;
            var data = this._shader.fragmentConstantData;
            var index = this._fragmentConstantsIndex + 2;
            var len = this._method.numSamples << 1;
            for (var i = 0; i < len; ++i)
                data[index + i] = this._method.offsets[i] * texRange;
        };
        /**
         * @inheritDoc
         */
        _Shader_ShadowSoftMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var dataReg = registerCache.getFreeFragmentConstant();
            this._fragmentConstantsIndex = dataReg.index * 4;
            var code = "";
            var uvReg = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(uvReg, 1);
            var offsets = new Array(dataReg + ".zw");
            var numRegs = this._method.numSamples >> 1;
            for (var i = 0; i < numRegs; ++i) {
                var reg = registerCache.getFreeFragmentConstant();
                offsets.push(reg + ".xy");
                offsets.push(reg + ".zw");
            }
            var temp = registerCache.getFreeFragmentVectorTemp();
            for (i = 0; i < this._method.numSamples; ++i) {
                if (i == 0) {
                    code += "add " + uvReg + ", " + this._baseChunk.depthMapCoordReg + ", " + dataReg + ".zwyy\n" +
                        this._baseTexture._getFragmentCode(targetReg, registerCache, sharedRegisters, uvReg);
                }
                else {
                    code += "add " + uvReg + ".xy, " + this._baseChunk.depthMapCoordReg + ".xy, " + offsets[i] + "\n" +
                        this._baseTexture._getFragmentCode(temp, registerCache, sharedRegisters, uvReg) +
                        "add " + targetReg + ".w, " + targetReg + ".w, " + temp + ".w\n";
                }
            }
            registerCache.removeFragmentTempUsage(uvReg);
            code += "mul " + targetReg + ".w, " + targetReg + ".w, " + dataReg + ".x\n" + // average
                _super.prototype._getFragmentCode.call(this, targetReg, registerCache, sharedRegisters);
            return code;
        };
        return _Shader_ShadowSoftMethod;
    }(_Shader_ShadowMethodBase));
    ShaderBase.registerAbstraction(_Shader_ShadowSoftMethod, ShadowSoftMethod);

    /**
     * SpecularBasicMethod provides the default shading method for Blinn-Phong specular highlights (an optimized but approximated
     * version of Phong specularity).
     */
    var SpecularBasicMethod = /** @class */ (function (_super) {
        __extends$7(SpecularBasicMethod, _super);
        /**
         * Creates a new SpecularBasicMethod object.
         */
        function SpecularBasicMethod() {
            var _this = _super.call(this) || this;
            _this._gloss = 50;
            _this._strength = 1;
            _this._color = 0xffffff;
            return _this;
        }
        Object.defineProperty(SpecularBasicMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return SpecularBasicMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularBasicMethod.prototype, "gloss", {
            /**
             * The glossiness of the material (sharpness of the specular highlight).
             */
            get: function () {
                return this._gloss;
            },
            set: function (value) {
                if (this._gloss == value)
                    return;
                this._gloss = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularBasicMethod.prototype, "strength", {
            /**
             * The overall strength of the specular highlights.
             */
            get: function () {
                return this._strength;
            },
            set: function (value) {
                if (this._strength == value)
                    return;
                this._strength = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularBasicMethod.prototype, "color", {
            /**
             * The colour of the specular reflection of the surface.
             */
            get: function () {
                return this._color;
            },
            set: function (value) {
                if (this._color == value)
                    return;
                this._color = value;
                // specular is now either enabled or disabled
                if (this._color == 0 || value == 0)
                    this.invalidateShaderProgram();
                else
                    this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularBasicMethod.prototype, "texture", {
            /**
             * A texture that defines the strength of specular reflections for each texel in the red channel,
             * and the gloss factor (sharpness) in the green channel. You can use Specular2DTexture if you want to easily set
             * specular and gloss maps from grayscale images, but correctly authored images are preferred.
             */
            get: function () {
                return this._texture;
            },
            set: function (value) {
                if (this._texture == value)
                    return;
                if (this._texture)
                    this.iRemoveTexture(this._texture);
                this._texture = value;
                if (this._texture)
                    this.iAddTexture(this._texture);
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        SpecularBasicMethod.prototype.dispose = function () {
            this._texture = null;
        };
        /**
         * @inheritDoc
         */
        SpecularBasicMethod.prototype.copyFrom = function (method) {
            var bsm = method;
            var spec = bsm; //SpecularBasicMethod(method);
            this.texture = spec.texture;
            this.strength = spec.strength;
            this.color = spec.color;
            this.gloss = spec.gloss;
        };
        SpecularBasicMethod.assetType = "[asset SpecularBasicMethod]";
        return SpecularBasicMethod;
    }(MethodBase));
    /**
     * _Shader_SpecularBasicMethod provides the default shading method for Blinn-Phong specular highlights (an optimized but approximated
     * version of Phong specularity).
     */
    var _Shader_SpecularBasicMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_SpecularBasicMethod, _super);
        /**
         * Creates a new EffectEnvMapChunk.
         */
        function _Shader_SpecularBasicMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            return _this;
        }
        _Shader_SpecularBasicMethod.prototype._isUsed = function () {
            if (!this._shader.numLights)
                return false;
            return true;
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularBasicMethod.prototype._initVO = function (chunkVO) {
            chunkVO.needsNormals = this._shader.numLights > 0;
            chunkVO.needsView = this._shader.numLights > 0;
            if (this._method.texture) {
                this._texture = this._shader.getAbstraction(this._method.texture);
                this._texture._initVO(chunkVO);
                this._shader.uvDependencies++;
            }
            else if (this._texture) {
                this._texture = null;
            }
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularBasicMethod.prototype._initConstants = function () {
            if (this._method.texture)
                this._texture._initConstants();
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularBasicMethod.prototype._cleanCompilationData = function () {
            _super.prototype._cleanCompilationData.call(this);
            this._totalLightColorReg = null;
            this._specularTexData = null;
            this._specularDataRegister = null;
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularBasicMethod.prototype._getFragmentPreLightingCode = function (registerCache, sharedRegisters) {
            var code = "";
            this._pIsFirstLight = true;
            this._specularDataRegister = registerCache.getFreeFragmentConstant();
            this._specularDataIndex = this._specularDataRegister.index * 4;
            if (this._texture) {
                this._specularTexData = registerCache.getFreeFragmentVectorTemp();
                registerCache.addFragmentTempUsages(this._specularTexData, 1);
                code += this._texture._getFragmentCode(this._specularTexData, registerCache, sharedRegisters, sharedRegisters.uvVarying);
            }
            this._totalLightColorReg = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(this._totalLightColorReg, 1);
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularBasicMethod.prototype._getFragmentCodePerLight = function (lightDirReg, lightColReg, registerCache, sharedRegisters) {
            var code = "";
            var t;
            if (this._pIsFirstLight) {
                t = this._totalLightColorReg;
            }
            else {
                t = registerCache.getFreeFragmentVectorTemp();
                registerCache.addFragmentTempUsages(t, 1);
            }
            var viewDirReg = sharedRegisters.viewDirFragment;
            var normalReg = sharedRegisters.normalFragment;
            // blinn-phong half vector model
            code += "add " + t + ", " + lightDirReg + ", " + viewDirReg + "\n" +
                "nrm " + t + ".xyz, " + t + "\n" +
                "dp3 " + t + ".w, " + normalReg + ", " + t + "\n" +
                "sat " + t + ".w, " + t + ".w\n";
            if (this._texture) {
                // apply gloss modulation from texture
                code += "mul " + this._specularTexData + ".w, " + this._specularTexData + ".y, " + this._specularDataRegister + ".w\n" +
                    "pow " + t + ".w, " + t + ".w, " + this._specularTexData + ".w\n";
            }
            else {
                code += "pow " + t + ".w, " + t + ".w, " + this._specularDataRegister + ".w\n";
            }
            // attenuate
            if (this._shader.usesLightFallOff)
                code += "mul " + t + ".w, " + t + ".w, " + lightDirReg + ".w\n";
            if (this._modulateFunction != null)
                code += this._modulateFunction(t, registerCache, sharedRegisters);
            code += "mul " + t + ".xyz, " + lightColReg + ", " + t + ".w\n";
            if (!this._pIsFirstLight) {
                code += "add " + this._totalLightColorReg + ".xyz, " + this._totalLightColorReg + ", " + t + "\n";
                registerCache.removeFragmentTempUsage(t);
            }
            this._pIsFirstLight = false;
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularBasicMethod.prototype._getFragmentCodePerProbe = function (cubeMapReg, weightRegister, registerCache, sharedRegisters) {
            var code = "";
            var t;
            // write in temporary if not first light, so we can add to total diffuse colour
            if (this._pIsFirstLight) {
                t = this._totalLightColorReg;
            }
            else {
                t = registerCache.getFreeFragmentVectorTemp();
                registerCache.addFragmentTempUsages(t, 1);
            }
            var normalReg = sharedRegisters.normalFragment;
            var viewDirReg = sharedRegisters.viewDirFragment;
            code += "dp3 " + t + ".w, " + normalReg + ", " + viewDirReg + "\n" +
                "add " + t + ".w, " + t + ".w, " + t + ".w\n" +
                "mul " + t + ", " + t + ".w, " + normalReg + "\n" +
                "sub " + t + ", " + t + ", " + viewDirReg + "\n" +
                "tex " + t + ", " + t + ", " + cubeMapReg + " <cube," + "linear" + ",miplinear>\n" +
                "mul " + t + ".xyz, " + t + ", " + weightRegister + "\n";
            if (this._modulateFunction != null)
                code += this._modulateFunction(t, registerCache, sharedRegisters);
            if (!this._pIsFirstLight) {
                code += "add " + this._totalLightColorReg + ".xyz, " + this._totalLightColorReg + ", " + t + "\n";
                registerCache.removeFragmentTempUsage(t);
            }
            this._pIsFirstLight = false;
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularBasicMethod.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code = "";
            if (sharedRegisters.shadowTarget)
                code += "mul " + this._totalLightColorReg + ".xyz, " + this._totalLightColorReg + ", " + sharedRegisters.shadowTarget + ".w\n";
            if (this._texture) {
                // apply strength modulation from texture
                code += "mul " + this._totalLightColorReg + ".xyz, " + this._totalLightColorReg + ", " + this._specularTexData + ".x\n";
                registerCache.removeFragmentTempUsage(this._specularTexData);
            }
            // apply material's specular reflection
            code += "mul " + this._totalLightColorReg + ".xyz, " + this._totalLightColorReg + ", " + this._specularDataRegister + "\n" +
                "add " + targetReg + ".xyz, " + targetReg + ", " + this._totalLightColorReg + "\n";
            registerCache.removeFragmentTempUsage(this._totalLightColorReg);
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularBasicMethod.prototype._activate = function () {
            if (this._texture)
                this._texture.activate();
            if (this._invalid) {
                var index = this._specularDataIndex;
                var data = this._shader.fragmentConstantData;
                data[index] = ((this._method.color >> 16) & 0xff) / 0xff * this._method.strength;
                data[index + 1] = ((this._method.color >> 8) & 0xff) / 0xff * this._method.strength;
                data[index + 2] = (this._method.color & 0xff) / 0xff * this._method.strength;
                data[index + 3] = this._method.gloss;
            }
        };
        _Shader_SpecularBasicMethod.prototype._setRenderState = function (renderState, view) {
            if (this._texture)
                this._texture._setRenderState(renderState);
        };
        return _Shader_SpecularBasicMethod;
    }(_Shader_MethodBase));
    ShaderBase.registerAbstraction(_Shader_SpecularBasicMethod, SpecularBasicMethod);

    /**
     * SpecularAnisotropicMethod provides a specular method resulting in anisotropic highlights. These are typical for
     * surfaces with microfacet details such as tiny grooves. In particular, this uses the Heidrich-Seidel distrubution.
     * The tangent vectors are used as the surface groove directions.
     */
    var SpecularAnisotropicMethod = /** @class */ (function (_super) {
        __extends$7(SpecularAnisotropicMethod, _super);
        /**
         * Creates a new SpecularAnisotropicMethod object.
         */
        function SpecularAnisotropicMethod() {
            return _super.call(this) || this;
        }
        Object.defineProperty(SpecularAnisotropicMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return SpecularAnisotropicMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        SpecularAnisotropicMethod.assetType = "[asset SpecularAnisotropicMethod]";
        return SpecularAnisotropicMethod;
    }(SpecularBasicMethod));
    /**
     * _Shader_SpecularAnisotropicMethod provides a specular method resulting in anisotropic highlights. These are typical for
     * surfaces with microfacet details such as tiny grooves. In particular, this uses the Heidrich-Seidel distrubution.
     * The tangent vectors are used as the surface groove directions.
     */
    var _Shader_SpecularAnisotropicMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_SpecularAnisotropicMethod, _super);
        /**
         * Creates a new EffectEnvMapChunk.
         */
        function _Shader_SpecularAnisotropicMethod(method, shader) {
            return _super.call(this, method, shader) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_SpecularAnisotropicMethod.prototype._initVO = function (chunkVO) {
            _super.prototype._initVO.call(this, chunkVO);
            chunkVO.needsTangents = this._shader.numLights > 0;
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularAnisotropicMethod.prototype._getFragmentCodePerLight = function (lightDirReg, lightColReg, registerCache, sharedRegisters) {
            var code = "";
            var t;
            if (this._pIsFirstLight)
                t = this._totalLightColorReg;
            else {
                t = registerCache.getFreeFragmentVectorTemp();
                registerCache.addFragmentTempUsages(t, 1);
            }
            // (sin(l,t) * sin(v,t) - cos(l,t)*cos(v,t)) ^ k
            code += "nrm " + t + ".xyz, " + sharedRegisters.tangentVarying + ".xyz\n" +
                "dp3 " + t + ".w, " + t + ".xyz, " + lightDirReg + ".xyz\n" +
                "dp3 " + t + ".z, " + t + ".xyz, " + sharedRegisters.viewDirFragment + ".xyz\n";
            // (sin(t.w) * sin(t.z) - cos(t.w)*cos(t.z)) ^ k
            code += "sin " + t + ".x, " + t + ".w\n" +
                "sin " + t + ".y, " + t + ".z\n" +
                // (t.x * t.y - cos(t.w)*cos(t.z)) ^ k
                "mul " + t + ".x, " + t + ".x, " + t + ".y\n" +
                // (t.x - cos(t.w)*cos(t.z)) ^ k
                "cos " + t + ".z, " + t + ".z\n" +
                "cos " + t + ".w, " + t + ".w\n" +
                // (t.x - t.w*t.z) ^ k
                "mul " + t + ".w, " + t + ".w, " + t + ".z\n" +
                // (t.x - t.w) ^ k
                "sub " + t + ".w, " + t + ".x, " + t + ".w\n";
            if (this._texture) {
                // apply gloss modulation from texture
                code += "mul " + this._specularTexData + ".w, " + this._specularTexData + ".y, " + this._specularDataRegister + ".w\n" +
                    "pow " + t + ".w, " + t + ".w, " + this._specularTexData + ".w\n";
            }
            else
                code += "pow " + t + ".w, " + t + ".w, " + this._specularDataRegister + ".w\n";
            // attenuate
            code += "mul " + t + ".w, " + t + ".w, " + lightDirReg + ".w\n";
            if (this._modulateFunction != null)
                code += this._modulateFunction(t, registerCache, sharedRegisters);
            code += "mul " + t + ".xyz, " + lightColReg + ".xyz, " + t + ".w\n";
            if (!this._pIsFirstLight) {
                code += "add " + this._totalLightColorReg + ".xyz, " + this._totalLightColorReg + ".xyz, " + t + ".xyz\n";
                registerCache.removeFragmentTempUsage(t);
            }
            this._pIsFirstLight = false;
            return code;
        };
        return _Shader_SpecularAnisotropicMethod;
    }(_Shader_SpecularBasicMethod));
    ShaderBase.registerAbstraction(_Shader_SpecularAnisotropicMethod, SpecularAnisotropicMethod);

    /**
     * SpecularCompositeMethod provides a base class for specular methods that wrap a specular method to alter the
     * calculated specular reflection strength.
     */
    var SpecularCompositeMethod = /** @class */ (function (_super) {
        __extends$7(SpecularCompositeMethod, _super);
        /**
         * Creates a new <code>SpecularCompositeMethod</code> object.
         *
         * @param modulateMethod The method which will add the code to alter the base method's strength. It needs to have the signature clampDiffuse(t:ShaderRegisterElement, regCache:ShaderRegisterCache):string, in which t.w will contain the diffuse strength.
         * @param baseMethod The base specular method on which this method's shading is based.
         */
        function SpecularCompositeMethod(baseMethod) {
            if (baseMethod === void 0) { baseMethod = null; }
            return _super.call(this, baseMethod) || this;
        }
        SpecularCompositeMethod.prototype.createBaseMethod = function () {
            return new SpecularBasicMethod();
        };
        Object.defineProperty(SpecularCompositeMethod.prototype, "gloss", {
            /**
             * @inheritDoc
             */
            get: function () {
                return this._baseMethod.gloss;
            },
            set: function (value) {
                this._baseMethod.gloss = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularCompositeMethod.prototype, "strength", {
            /**
             * @inheritDoc
             */
            get: function () {
                return this._baseMethod.strength;
            },
            set: function (value) {
                this._baseMethod.strength = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularCompositeMethod.prototype, "color", {
            /**
             * @inheritDoc
             */
            get: function () {
                return this._baseMethod.color;
            },
            /**
             * @inheritDoc
             */
            set: function (value) {
                this._baseMethod.color = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularCompositeMethod.prototype, "texture", {
            /**
             * @inheritDoc
             */
            get: function () {
                return this._baseMethod.texture;
            },
            set: function (value) {
                this._baseMethod.texture = value;
            },
            enumerable: true,
            configurable: true
        });
        return SpecularCompositeMethod;
    }(CompositeMethodBase));

    /**
     * SpecularCelMethod provides a shading method to add specular cel (cartoon) shading.
     */
    var SpecularCelMethod = /** @class */ (function (_super) {
        __extends$7(SpecularCelMethod, _super);
        /**
         * Creates a new SpecularCelMethod object.
         * @param specularCutOff The threshold at which the specular highlight should be shown.
         * @param smoothness The smoothness of the highlight edge.
         * @param baseMethod An optional specular method on which the cartoon shading is based. If ommitted, SpecularBasicMethod is used.
         */
        function SpecularCelMethod(specularCutOff, smoothness, baseMethod) {
            if (specularCutOff === void 0) { specularCutOff = 0.5; }
            if (smoothness === void 0) { smoothness = 0.1; }
            if (baseMethod === void 0) { baseMethod = null; }
            var _this = _super.call(this, baseMethod) || this;
            _this._specularCutOff = specularCutOff;
            _this._smoothness = smoothness;
            return _this;
        }
        Object.defineProperty(SpecularCelMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return SpecularCelMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularCelMethod.prototype, "smoothness", {
            /**
             * The smoothness of the highlight edge.
             */
            get: function () {
                return this._smoothness;
            },
            set: function (value) {
                if (this._smoothness == value)
                    return;
                this._smoothness = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularCelMethod.prototype, "specularCutOff", {
            /**
             * The threshold at which the specular highlight should be shown.
             */
            get: function () {
                return this._specularCutOff;
            },
            set: function (value) {
                if (this._specularCutOff == value)
                    return;
                this._specularCutOff = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        SpecularCelMethod.assetType = "[asset SpecularCelMethod]";
        return SpecularCelMethod;
    }(SpecularCompositeMethod));
    /**
     * _Shader_SpecularCelMethod provides a shading method to add specular cel (cartoon) shading.
     */
    var _Shader_SpecularCelMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_SpecularCelMethod, _super);
        /**
         * Creates a new DiffuseCelChunk object.
         * @param levels The amount of shadow gradations.
         * @param baseMethod An optional diffuse method on which the cartoon shading is based. If omitted, DiffuseBasicMethod is used.
         */
        function _Shader_SpecularCelMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            _this._baseChunk._modulateFunction = function (targetReg, registerCache, sharedRegisters) { return _this.clampSpecular(targetReg, registerCache, sharedRegisters); };
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_SpecularCelMethod.prototype._activate = function () {
            _super.prototype._activate.call(this);
            if (this._invalid) {
                var index = this._cutoffDataIndex;
                var data = this._shader.fragmentConstantData;
                data[index] = this._method.smoothness;
                data[index + 1] = this._method.specularCutOff;
            }
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularCelMethod.prototype._cleanCompilationData = function () {
            _super.prototype._cleanCompilationData.call(this);
            this._cutoffDataRegister = null;
        };
        /**
         * Snaps the specular shading strength of the wrapped method to zero or one, depending on whether or not it exceeds the specularCutOff
         * @param vo The MethodVO used to compile the current shader.
         * @param t The register containing the specular strength in the "w" component, and either the half-vector or the reflection vector in "xyz".
         * @param regCache The register cache used for the shader compilation.
         * @param sharedRegisters The shared register data for this shader.
         * @return The AGAL fragment code for the method.
         */
        _Shader_SpecularCelMethod.prototype.clampSpecular = function (targetReg, registerCache, sharedRegisters) {
            return "sub " + targetReg + ".y, " + targetReg + ".w, " + this._cutoffDataRegister + ".y\n" + // x - cutoff
                "div " + targetReg + ".y, " + targetReg + ".y, " + this._cutoffDataRegister + ".x\n" + // (x - cutoff)/epsilon
                "sat " + targetReg + ".y, " + targetReg + ".y\n" +
                "sge " + targetReg + ".w, " + targetReg + ".w, " + this._cutoffDataRegister + ".y\n" +
                "mul " + targetReg + ".w, " + targetReg + ".w, " + targetReg + ".y\n";
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularCelMethod.prototype._getFragmentPreLightingCode = function (registerCache, sharedRegisters) {
            this._cutoffDataRegister = registerCache.getFreeFragmentConstant();
            this._cutoffDataIndex = this._cutoffDataRegister.index * 4;
            return _super.prototype._getFragmentPreLightingCode.call(this, registerCache, sharedRegisters);
        };
        return _Shader_SpecularCelMethod;
    }(_Shader_LightingCompositeMethod));
    ShaderBase.registerAbstraction(_Shader_SpecularCelMethod, SpecularCelMethod);

    /**
     * SpecularFresnelMethod provides a specular shading method that causes stronger highlights on grazing view angles.
     */
    var SpecularFresnelMethod = /** @class */ (function (_super) {
        __extends$7(SpecularFresnelMethod, _super);
        /**
         * Creates a new SpecularFresnelMethod object.
         * @param basedOnSurface Defines whether the fresnel effect should be based on the view angle on the surface (if true), or on the angle between the light and the view.
         * @param baseMethod The specular method to which the fresnel equation. Defaults to SpecularBasicMethod.
         */
        function SpecularFresnelMethod(basedOnSurface, fresnelPower, normalReflectance, baseMethod) {
            if (basedOnSurface === void 0) { basedOnSurface = true; }
            if (fresnelPower === void 0) { fresnelPower = 5; }
            if (normalReflectance === void 0) { normalReflectance = 0.028; }
            if (baseMethod === void 0) { baseMethod = null; }
            var _this = _super.call(this, baseMethod) || this;
            _this._basedOnSurface = basedOnSurface;
            _this._fresnelPower = fresnelPower;
            _this._normalReflectance = normalReflectance;
            return _this;
        }
        Object.defineProperty(SpecularFresnelMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return SpecularFresnelMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularFresnelMethod.prototype, "basedOnSurface", {
            /**
             * Defines whether the fresnel effect should be based on the view angle on the surface (if true), or on the angle between the light and the view.
             */
            get: function () {
                return this._basedOnSurface;
            },
            set: function (value) {
                if (this._basedOnSurface == value)
                    return;
                this._basedOnSurface = value;
                this.invalidateShaderProgram();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularFresnelMethod.prototype, "fresnelPower", {
            /**
             * The power used in the Fresnel equation. Higher values make the fresnel effect more pronounced. Defaults to 5.
             */
            get: function () {
                return this._fresnelPower;
            },
            set: function (value) {
                if (this._fresnelPower == value)
                    return;
                this._fresnelPower = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SpecularFresnelMethod.prototype, "normalReflectance", {
            /**
             * The minimum amount of reflectance, ie the reflectance when the view direction is normal to the surface or light direction.
             */
            get: function () {
                return this._normalReflectance;
            },
            set: function (value) {
                if (this._normalReflectance == value)
                    return;
                this._normalReflectance = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        SpecularFresnelMethod.assetType = "[asset SpecularFresnelMethod]";
        return SpecularFresnelMethod;
    }(SpecularCompositeMethod));
    /**
     * _Shader_SpecularFresnelMethod provides a specular shading method that causes stronger highlights on grazing view angles.
     */
    var _Shader_SpecularFresnelMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_SpecularFresnelMethod, _super);
        /**
         * Creates a new _Shader_SpecularFresnelMethod object.
         */
        function _Shader_SpecularFresnelMethod(method, shader) {
            var _this = _super.call(this, method, shader) || this;
            _this._method = method;
            _this._shader = shader;
            _this._baseChunk._modulateFunction = function (targetReg, registerCache, sharedRegisters) { return _this.modulateSpecular(targetReg, registerCache, sharedRegisters); };
            return _this;
        }
        /**
         * @inheritDoc
         */
        _Shader_SpecularFresnelMethod.prototype._cleanCompilationData = function () {
            _super.prototype._cleanCompilationData.call(this);
            this._fresnelDataRegister = null;
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularFresnelMethod.prototype._activate = function () {
            _super.prototype._activate.call(this);
            if (this._invalid) {
                var data = this._shader.fragmentConstantData;
                var index = this._fresnelDataIndex;
                data[index] = this._method.normalReflectance;
                data[index + 1] = this._method.fresnelPower;
                data[index + 2] = 1;
                data[index + 3] = 0;
            }
        };
        /**
         * @inheritDoc
         */
        _Shader_SpecularFresnelMethod.prototype._getFragmentPreLightingCode = function (registerCache, sharedRegisters) {
            this._fresnelDataRegister = registerCache.getFreeFragmentConstant();
            this._fresnelDataIndex = this._fresnelDataRegister.index * 4;
            return _super.prototype._getFragmentPreLightingCode.call(this, registerCache, sharedRegisters);
        };
        /**
         * Applies the fresnel effect to the specular strength.
         *
         * @param vo The MethodVO object containing the method data for the currently compiled material pass.
         * @param target The register containing the specular strength in the "w" component, and the half-vector/reflection vector in "xyz".
         * @param regCache The register cache used for the shader compilation.
         * @param sharedRegisters The shared registers created by the compiler.
         * @return The AGAL fragment code for the method.
         */
        _Shader_SpecularFresnelMethod.prototype.modulateSpecular = function (targetReg, registerCache, sharedRegisters) {
            var code;
            code = "dp3 " + targetReg + ".y, " + sharedRegisters.viewDirFragment + ".xyz, " + (this._method.basedOnSurface ? sharedRegisters.normalFragment : targetReg) + ".xyz\n" + // dot(V, H)
                "sub " + targetReg + ".y, " + this._fresnelDataRegister + ".z, " + targetReg + ".y\n" + // base = 1-dot(V, H)
                "pow " + targetReg + ".x, " + targetReg + ".y, " + this._fresnelDataRegister + ".y\n" + // exp = pow(base, 5)
                "sub " + targetReg + ".y, " + this._fresnelDataRegister + ".z, " + targetReg + ".y\n" + // 1 - exp
                "mul " + targetReg + ".y, " + this._fresnelDataRegister + ".x, " + targetReg + ".y\n" + // f0*(1 - exp)
                "add " + targetReg + ".y, " + targetReg + ".x, " + targetReg + ".y\n" + // exp + f0*(1 - exp)
                "mul " + targetReg + ".w, " + targetReg + ".w, " + targetReg + ".y\n";
            return code;
        };
        return _Shader_SpecularFresnelMethod;
    }(_Shader_LightingCompositeMethod));
    ShaderBase.registerAbstraction(_Shader_SpecularFresnelMethod, SpecularFresnelMethod);

    /**
     * SpecularPhongMethod provides a specular method that provides Phong highlights.
     */
    var SpecularPhongMethod = /** @class */ (function (_super) {
        __extends$7(SpecularPhongMethod, _super);
        /**
         * Creates a new SpecularPhongMethod object.
         */
        function SpecularPhongMethod() {
            return _super.call(this) || this;
        }
        Object.defineProperty(SpecularPhongMethod.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return SpecularPhongMethod.assetType;
            },
            enumerable: true,
            configurable: true
        });
        SpecularPhongMethod.assetType = "[asset SpecularPhongMethod]";
        return SpecularPhongMethod;
    }(SpecularBasicMethod));
    /**
     * _Shader_SpecularPhongMethod provides a specular method that provides Phong highlights.
     */
    var _Shader_SpecularPhongMethod = /** @class */ (function (_super) {
        __extends$7(_Shader_SpecularPhongMethod, _super);
        /**
         * Creates a new _Shader_SpecularPhongMethod object.
         */
        function _Shader_SpecularPhongMethod(method, shader) {
            return _super.call(this, method, shader) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_SpecularPhongMethod.prototype._getFragmentCodePerLight = function (lightDirReg, lightColReg, registerCache, sharedRegisters) {
            var code = "";
            var t;
            if (this._pIsFirstLight) {
                t = this._totalLightColorReg;
            }
            else {
                t = registerCache.getFreeFragmentVectorTemp();
                registerCache.addFragmentTempUsages(t, 1);
            }
            var viewDirReg = sharedRegisters.viewDirFragment;
            var normalReg = sharedRegisters.normalFragment;
            // phong model
            code += "dp3 " + t + ".w, " + lightDirReg + ", " + normalReg + "\n" + // sca1 = light.normal
                //find the reflected light vector R
                "add " + t + ".w, " + t + ".w, " + t + ".w\n" + // sca1 = sca1*2
                "mul " + t + ".xyz, " + normalReg + ", " + t + ".w\n" + // vec1 = normal*sca1
                "sub " + t + ".xyz, " + t + ", " + lightDirReg + "\n" + // vec1 = vec1 - light (light vector is negative)
                //smooth the edge as incidence angle approaches 90
                "add " + t + ".w, " + t + ".w, " + sharedRegisters.commons + ".w\n" + // sca1 = sca1 + smoothtep;
                "sat " + t + ".w, " + t + ".w\n" + // sca1 range 0 - 1
                "mul " + t + ".xyz, " + t + ", " + t + ".w\n" + // vec1 = vec1*sca1
                //find the dot product between R and V
                "dp3 " + t + ".w, " + t + ", " + viewDirReg + "\n" + // sca1 = vec1.view
                "sat " + t + ".w, " + t + ".w\n";
            if (this._texture) {
                // apply gloss modulation from texture
                code += "mul " + this._specularTexData + ".w, " + this._specularTexData + ".y, " + this._specularDataRegister + ".w\n" +
                    "pow " + t + ".w, " + t + ".w, " + this._specularTexData + ".w\n";
            }
            else
                code += "pow " + t + ".w, " + t + ".w, " + this._specularDataRegister + ".w\n";
            // attenuate
            if (this._shader.usesLightFallOff)
                code += "mul " + t + ".w, " + t + ".w, " + lightDirReg + ".w\n";
            if (this._modulateFunction != null)
                code += this._modulateFunction(t, registerCache, sharedRegisters);
            code += "mul " + t + ".xyz, " + lightColReg + ".xyz, " + t + ".w\n";
            if (!this._pIsFirstLight) {
                code += "add " + this._totalLightColorReg + ".xyz, " + this._totalLightColorReg + ".xyz, " + t + ".xyz\n";
                registerCache.removeFragmentTempUsage(t);
            }
            this._pIsFirstLight = false;
            return code;
        };
        return _Shader_SpecularPhongMethod;
    }(_Shader_SpecularBasicMethod));
    ShaderBase.registerAbstraction(_Shader_SpecularPhongMethod, SpecularPhongMethod);

    /**
     * Enumeration class for defining which lighting types affect the specific material
     * lighting component (diffuse and specular). This can be useful if, for example, you
     * want to use light probes for diffuse global lighting, but want specular reflections from
     * traditional light sources without those affecting the diffuse light.
     *
     * @see away.materials.ColorMaterial.diffuseLightSources
     * @see away.materials.ColorMaterial.specularLightSources
     * @see away.materials.TextureMaterial.diffuseLightSources
     * @see away.materials.TextureMaterial.specularLightSources
     */
    var LightSources = /** @class */ (function () {
        function LightSources() {
        }
        /**
         * Defines normal lights are to be used as the source for the lighting
         * component.
         */
        LightSources.LIGHTS = 0x01;
        /**
         * Defines that global lighting probes are to be used as the source for the
         * lighting component.
         */
        LightSources.PROBES = 0x02;
        /**
         * Defines that both normal and global lighting probes  are to be used as the
         * source for the lighting component. This is equivalent to LightSources.LIGHTS | LightSources.PROBES.
         */
        LightSources.ALL = 0x03;
        return LightSources;
    }());

    /**
     * PassBase provides an abstract base class for material shader passes. A material pass constitutes at least
     * a render call per required renderable.
     */
    var PassBase = /** @class */ (function (_super) {
        __extends$7(PassBase, _super);
        /**
         * Creates a new PassBase object.
         */
        function PassBase(renderMaterial, renderElements) {
            var _this = _super.call(this) || this;
            _this._preserveAlpha = true;
            _this._forceSeparateMVP = false;
            _this._renderMaterial = renderMaterial;
            _this._renderElements = renderElements;
            _this._stage = renderElements.stage;
            return _this;
        }
        Object.defineProperty(PassBase.prototype, "shader", {
            get: function () {
                return this._shader;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PassBase.prototype, "preserveAlpha", {
            /**
             * Indicates whether the output alpha value should remain unchanged compared to the material's original alpha.
             */
            get: function () {
                return this._preserveAlpha;
            },
            set: function (value) {
                if (this._preserveAlpha == value)
                    return;
                this._preserveAlpha = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PassBase.prototype, "forceSeparateMVP", {
            /**
             * Indicates whether the screen projection should be calculated by forcing a separate scene matrix and
             * view-projection matrix. This is used to prevent rounding errors when using multiple passes with different
             * projection code.
             */
            get: function () {
                return this._forceSeparateMVP;
            },
            set: function (value) {
                if (this._forceSeparateMVP == value)
                    return;
                this._forceSeparateMVP = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Marks the shader program as invalid, so it will be recompiled before the next render.
         */
        PassBase.prototype.invalidate = function () {
            this._shader.invalidateProgram();
            this.dispatchEvent(new PassEvent(PassEvent.INVALIDATE, this));
        };
        /**
         * Cleans up any resources used by the current object.
         * @param deep Indicates whether other resources should be cleaned up, that could potentially be shared across different instances.
         */
        PassBase.prototype.dispose = function () {
            this._renderMaterial = null;
            this._renderElements = null;
            this._stage = null;
            if (this._shader) {
                this._shader.dispose();
                this._shader = null;
            }
        };
        /**
         * Renders the current pass. Before calling pass, activatePass needs to be called with the same index.
         * @param pass The pass used to render the renderable.
         * @param renderable The IRenderable object to draw.
         * @param stage The Stage object used for rendering.
         * @param entityCollector The EntityCollector object that contains the visible scene data.
         * @param viewProjection The view-projection matrix used to project to the screen. This is not the same as
         * camera.viewProjection as it includes the scaling factors when rendering to textures.
         *
         * @internal
         */
        PassBase.prototype._setRenderState = function (renderState, view) {
            this._shader._setRenderState(renderState, view.projection);
        };
        /**
         * Sets the render state for the pass that is independent of the rendered object. This needs to be called before
         * calling pass. Before activating a pass, the previously used pass needs to be deactivated.
         * @param stage The Stage object which is currently used for rendering.
         * @param camera The camera from which the scene is viewed.
         * @private
         */
        PassBase.prototype._activate = function (view) {
            this._shader._activate(view.projection);
        };
        /**
         * Clears the render state for the pass. This needs to be called before activating another pass.
         * @param stage The Stage used for rendering
         *
         * @private
         */
        PassBase.prototype._deactivate = function () {
            this._shader._deactivate();
        };
        PassBase.prototype._includeDependencies = function (shader) {
            shader.alphaThreshold = this._renderMaterial.material.alphaThreshold;
            shader.useImageRect = this._renderMaterial.material.imageRect;
            shader.usesCurves = this._renderMaterial.material.curves;
            shader.useAlphaPremultiplied = this._renderMaterial.material.alphaPremultiplied;
            shader.useBothSides = this._renderMaterial.material.bothSides;
            shader.usesUVTransform = this._renderMaterial.material.animateUVs;
            shader.usesColorTransform = this._renderMaterial.material.useColorTransform;
            if (this._forceSeparateMVP)
                this._shader.globalPosDependencies++;
        };
        PassBase.prototype._initConstantData = function () {
        };
        PassBase.prototype._getVertexCode = function (registerCache, sharedRegisters) {
            return "";
        };
        PassBase.prototype._getFragmentCode = function (registerCache, sharedRegisters) {
            return "";
        };
        PassBase.prototype._getPostAnimationFragmentCode = function (registerCache, sharedRegisters) {
            return "";
        };
        PassBase.prototype._getNormalVertexCode = function (registerCache, sharedRegisters) {
            return "";
        };
        PassBase.prototype._getNormalFragmentCode = function (registerCache, sharedRegisters) {
            return "";
        };
        return PassBase;
    }(EventDispatcher));

    /**
     * ShaderBase keeps track of the number of dependencies for "named registers" used across a pass.
     * Named registers are that are not necessarily limited to a single method. They are created by the compiler and
     * passed on to methods. The compiler uses the results to reserve usages through RegisterPool, which can be removed
     * each time a method has been compiled into the shader.
     *
     * @see RegisterPool.addUsage
     */
    var LightingShader = /** @class */ (function (_super) {
        __extends$7(LightingShader, _super);
        /**
         * Creates a new MethodCompilerVO object.
         */
        function LightingShader(renderElements, renderMaterial, lightingPass, stage) {
            var _this = _super.call(this, renderElements, renderMaterial, lightingPass, stage) || this;
            _this._includeCasters = true;
            _this._lightingPass = lightingPass;
            return _this;
        }
        LightingShader.prototype._includeDependencies = function () {
            this.numPointLights = this._lightingPass.numPointLights;
            this.numDirectionalLights = this._lightingPass.numDirectionalLights;
            this.numLightProbes = this._lightingPass.numLightProbes;
            var numAllLights = this._lightingPass.numPointLights + this._lightingPass.numDirectionalLights;
            var numLightProbes = this._lightingPass.numLightProbes;
            var diffuseLightSources = this._lightingPass._iUsesDiffuse(this) ? this._lightingPass.diffuseLightSources : 0x00;
            var specularLightSources = this._lightingPass._iUsesSpecular(this) ? this._lightingPass.specularLightSources : 0x00;
            var combinedLightSources = diffuseLightSources | specularLightSources;
            this.usesLightFallOff = this._lightingPass.enableLightFallOff && this.profile != ContextGLProfile.BASELINE_CONSTRAINED;
            this.usesCommonData = this.usesLightFallOff || this.usesCommonData;
            this.numLights = numAllLights + numLightProbes;
            this.usesLights = numAllLights > 0 && (combinedLightSources & LightSources.LIGHTS) != 0;
            this.usesProbes = numLightProbes > 0 && (combinedLightSources & LightSources.PROBES) != 0;
            this.usesLightsForSpecular = numAllLights > 0 && (specularLightSources & LightSources.LIGHTS) != 0;
            this.usesProbesForSpecular = numLightProbes > 0 && (specularLightSources & LightSources.PROBES) != 0;
            this.usesLightsForDiffuse = numAllLights > 0 && (diffuseLightSources & LightSources.LIGHTS) != 0;
            this.usesProbesForDiffuse = numLightProbes > 0 && (diffuseLightSources & LightSources.PROBES) != 0;
            this.usesShadows = this._lightingPass._iUsesShadows(this);
            //IMPORTANT this must occur after shader lighting initialisation above
            _super.prototype._includeDependencies.call(this);
        };
        /**
         *
         *
         * @param renderable
         * @param stage
         * @param camera
         */
        LightingShader.prototype._setRenderState = function (renderable, projection) {
            _super.prototype._setRenderState.call(this, renderable, projection);
            if (this._lightingPass.lightPicker)
                this._lightingPass.lightPicker.collectLights(renderable.sourceEntity);
            if (this.usesLights)
                this.updateLights();
            if (this.usesProbes)
                this.updateProbes();
        };
        /**
         * Reset all the indices to "unused".
         */
        LightingShader.prototype._initRegisterIndices = function () {
            _super.prototype._initRegisterIndices.call(this);
            this.lightVertexConstantIndex = -1;
            this.lightFragmentConstantIndex = -1;
            this.probeWeightsIndex = -1;
            this._numProbeRegisters = Math.ceil(this.numLightProbes / 4);
            //init light data
            if (this.usesTangentSpace || !this.usesGlobalPosFragment) {
                this._pointLightVertexConstants = new Array(this.numPointLights);
                this._pointLightFragmentConstants = new Array(this.numPointLights * 2);
            }
            else {
                this._pointLightVertexConstants = null;
                this._pointLightFragmentConstants = new Array(this.numPointLights * 3);
            }
            if (this.usesTangentSpace) {
                this._dirLightVertexConstants = new Array(this.numDirectionalLights);
                this._dirLightFragmentConstants = new Array(this.numDirectionalLights * 2);
            }
            else {
                this._dirLightVertexConstants = null;
                this._dirLightFragmentConstants = new Array(this.numDirectionalLights * 3);
            }
            if (this.usesLights) {
                // init these first so we're sure they're in sequence
                var i, len;
                if (this._dirLightVertexConstants) {
                    len = this._dirLightVertexConstants.length;
                    for (i = 0; i < len; ++i) {
                        this._dirLightVertexConstants[i] = this._registerCache.getFreeVertexConstant();
                        if (this.lightVertexConstantIndex == -1)
                            this.lightVertexConstantIndex = this._dirLightVertexConstants[i].index * 4;
                    }
                }
                if (this._pointLightVertexConstants) {
                    len = this._pointLightVertexConstants.length;
                    for (i = 0; i < len; ++i) {
                        this._pointLightVertexConstants[i] = this._registerCache.getFreeVertexConstant();
                        if (this.lightVertexConstantIndex == -1)
                            this.lightVertexConstantIndex = this._pointLightVertexConstants[i].index * 4;
                    }
                }
                len = this._dirLightFragmentConstants.length;
                for (i = 0; i < len; ++i) {
                    this._dirLightFragmentConstants[i] = this._registerCache.getFreeFragmentConstant();
                    if (this.lightFragmentConstantIndex == -1)
                        this.lightFragmentConstantIndex = this._dirLightFragmentConstants[i].index * 4;
                }
                len = this._pointLightFragmentConstants.length;
                for (i = 0; i < len; ++i) {
                    this._pointLightFragmentConstants[i] = this._registerCache.getFreeFragmentConstant();
                    if (this.lightFragmentConstantIndex == -1)
                        this.lightFragmentConstantIndex = this._pointLightFragmentConstants[i].index * 4;
                }
            }
        };
        /**
         * Compile the code for the methods.
         */
        LightingShader.prototype._compileDependencies = function () {
            _super.prototype._compileDependencies.call(this);
            //collect code from pass
            this._vertexCode += this._lightingPass._getPreLightingVertexCode(this._registerCache, this._sharedRegisters);
            this._postAnimationFragmentCode += this._lightingPass._getPreLightingFragmentCode(this._registerCache, this._sharedRegisters);
            //compile the lighting code
            if (this.usesShadows)
                this._compileShadowCode();
            if (this.usesLights)
                this._compileLightCode();
            if (this.usesProbes)
                this._compileLightProbeCode();
        };
        /**
         * Provides the code to provide shadow mapping.
         */
        LightingShader.prototype._compileShadowCode = function () {
            if (this.normalDependencies > 0) {
                this._sharedRegisters.shadowTarget = this._sharedRegisters.normalFragment;
            }
            else {
                this._sharedRegisters.shadowTarget = this._registerCache.getFreeFragmentVectorTemp();
                this._registerCache.addFragmentTempUsages(this._sharedRegisters.shadowTarget, 1);
            }
        };
        /**
         * Compiles the shading code for directional and point lights.
         */
        LightingShader.prototype._compileLightCode = function () {
            var diffuseColorReg;
            var specularColorReg;
            var lightPosReg;
            var lightDirReg;
            var vertexRegIndex = 0;
            var fragmentRegIndex = 0;
            var addSpec = this.usesLightsForSpecular;
            var addDiff = this.usesLightsForDiffuse;
            //compile the shading code for directional lights.
            for (var i = 0; i < this.numDirectionalLights; ++i) {
                if (this.usesTangentSpace) {
                    lightDirReg = this._dirLightVertexConstants[vertexRegIndex++];
                    var lightVarying = this._registerCache.getFreeVarying();
                    this._vertexCode += "m33 " + lightVarying + ".xyz, " + lightDirReg + ", " + this._sharedRegisters.animatedTangent + "\n" +
                        "mov " + lightVarying + ".w, " + lightDirReg + ".w\n";
                    lightDirReg = this._registerCache.getFreeFragmentVectorTemp();
                    this._registerCache.addVertexTempUsages(lightDirReg, 1);
                    this._postAnimationFragmentCode += "nrm " + lightDirReg + ".xyz, " + lightVarying + "\n" +
                        "mov " + lightDirReg + ".w, " + lightVarying + ".w\n";
                }
                else {
                    lightDirReg = this._dirLightFragmentConstants[fragmentRegIndex++];
                }
                diffuseColorReg = this._dirLightFragmentConstants[fragmentRegIndex++];
                specularColorReg = this._dirLightFragmentConstants[fragmentRegIndex++];
                if (addDiff)
                    this._postAnimationFragmentCode += this._lightingPass._getPerLightDiffuseFragmentCode(lightDirReg, diffuseColorReg, this._registerCache, this._sharedRegisters);
                if (addSpec)
                    this._postAnimationFragmentCode += this._lightingPass._getPerLightSpecularFragmentCode(lightDirReg, specularColorReg, this._registerCache, this._sharedRegisters);
                if (this.usesTangentSpace)
                    this._registerCache.removeVertexTempUsage(lightDirReg);
            }
            vertexRegIndex = 0;
            fragmentRegIndex = 0;
            //compile the shading code for point lights
            for (var i = 0; i < this.numPointLights; ++i) {
                if (this.usesTangentSpace || !this.usesGlobalPosFragment)
                    lightPosReg = this._pointLightVertexConstants[vertexRegIndex++];
                else
                    lightPosReg = this._pointLightFragmentConstants[fragmentRegIndex++];
                diffuseColorReg = this._pointLightFragmentConstants[fragmentRegIndex++];
                specularColorReg = this._pointLightFragmentConstants[fragmentRegIndex++];
                lightDirReg = this._registerCache.getFreeFragmentVectorTemp();
                this._registerCache.addFragmentTempUsages(lightDirReg, 1);
                var lightVarying;
                if (this.usesTangentSpace) {
                    lightVarying = this._registerCache.getFreeVarying();
                    var temp = this._registerCache.getFreeVertexVectorTemp();
                    this._vertexCode += "sub " + temp + ", " + lightPosReg + ", " + this._sharedRegisters.animatedPosition + "\n" +
                        "m33 " + lightVarying + ".xyz, " + temp + ", " + this._sharedRegisters.animatedTangent + "\n" +
                        "mov " + lightVarying + ".w, " + this._sharedRegisters.animatedPosition + ".w\n";
                }
                else if (!this.usesGlobalPosFragment) {
                    lightVarying = this._registerCache.getFreeVarying();
                    this._vertexCode += "sub " + lightVarying + ", " + lightPosReg + ", " + this._sharedRegisters.globalPositionVertex + "\n";
                }
                else {
                    lightVarying = lightDirReg;
                    this._postAnimationFragmentCode += "sub " + lightDirReg + ", " + lightPosReg + ", " + this._sharedRegisters.globalPositionVarying + "\n";
                }
                if (this.usesLightFallOff) {
                    // calculate attenuation
                    this._postAnimationFragmentCode += // attenuate
                        "dp3 " + lightDirReg + ".w, " + lightVarying + ", " + lightVarying + "\n" + // w = d - radius
                            "sub " + lightDirReg + ".w, " + lightDirReg + ".w, " + diffuseColorReg + ".w\n" + // w = (d - radius)/(max-min)
                            "mul " + lightDirReg + ".w, " + lightDirReg + ".w, " + specularColorReg + ".w\n" + // w = clamp(w, 0, 1)
                            "sat " + lightDirReg + ".w, " + lightDirReg + ".w\n" + // w = 1-w
                            "sub " + lightDirReg + ".w, " + this._sharedRegisters.commons + ".w, " + lightDirReg + ".w\n" + // normalize
                            "nrm " + lightDirReg + ".xyz, " + lightVarying + "\n";
                }
                else {
                    this._postAnimationFragmentCode += "nrm " + lightDirReg + ".xyz, " + lightVarying + "\n" +
                        "mov " + lightDirReg + ".w, " + lightVarying + ".w\n";
                }
                if (this.lightFragmentConstantIndex == -1)
                    this.lightFragmentConstantIndex = lightPosReg.index * 4;
                if (addDiff)
                    this._postAnimationFragmentCode += this._lightingPass._getPerLightDiffuseFragmentCode(lightDirReg, diffuseColorReg, this._registerCache, this._sharedRegisters);
                if (addSpec)
                    this._postAnimationFragmentCode += this._lightingPass._getPerLightSpecularFragmentCode(lightDirReg, specularColorReg, this._registerCache, this._sharedRegisters);
                this._registerCache.removeFragmentTempUsage(lightDirReg);
            }
        };
        /**
         * Compiles shading code for light probes.
         */
        LightingShader.prototype._compileLightProbeCode = function () {
            var weightReg;
            var weightComponents = [".x", ".y", ".z", ".w"];
            var weightRegisters = new Array();
            var i;
            var texReg;
            var addSpec = this.usesProbesForSpecular;
            var addDiff = this.usesProbesForDiffuse;
            if (addDiff)
                this.lightProbeDiffuseIndices = new Array();
            if (addSpec)
                this.lightProbeSpecularIndices = new Array();
            for (i = 0; i < this._numProbeRegisters; ++i) {
                weightRegisters[i] = this._registerCache.getFreeFragmentConstant();
                if (i == 0)
                    this.probeWeightsIndex = weightRegisters[i].index * 4;
            }
            for (i = 0; i < this.numLightProbes; ++i) {
                weightReg = weightRegisters[Math.floor(i / 4)].toString() + weightComponents[i % 4];
                if (addDiff) {
                    texReg = this._registerCache.getFreeTextureReg();
                    this.lightProbeDiffuseIndices[i] = texReg.index;
                    this._postAnimationFragmentCode += this._lightingPass._getPerProbeDiffuseFragmentCode(texReg, weightReg, this._registerCache, this._sharedRegisters);
                }
                if (addSpec) {
                    texReg = this._registerCache.getFreeTextureReg();
                    this.lightProbeSpecularIndices[i] = texReg.index;
                    this._postAnimationFragmentCode += this._lightingPass._getPerProbeSpecularFragmentCode(texReg, weightReg, this._registerCache, this._sharedRegisters);
                }
            }
        };
        /**
         * Updates constant data render state used by the lights. This method is optional for subclasses to implement.
         */
        LightingShader.prototype.updateLights = function () {
            var dirLight;
            var pointLight;
            var i = 0;
            var k = 0;
            var len;
            var dirPos;
            var total = 0;
            var numLightTypes = this.usesShadows ? 2 : 1;
            var l;
            var offset;
            this.ambientR = this.ambientG = this.ambientB = 0;
            l = this.lightVertexConstantIndex;
            k = this.lightFragmentConstantIndex;
            var cast = 0;
            var dirLights = this._lightingPass.lightPicker.directionalLights;
            offset = this._lightingPass.directionalLightsOffset;
            len = this._lightingPass.lightPicker.directionalLights.length;
            if (offset > len) {
                cast = 1;
                offset -= len;
            }
            for (; cast < numLightTypes; ++cast) {
                if (cast)
                    dirLights = this._lightingPass.lightPicker.castingDirectionalLights;
                len = dirLights.length;
                if (len > this.numDirectionalLights)
                    len = this.numDirectionalLights;
                for (i = 0; i < len; ++i) {
                    dirLight = dirLights[offset + i];
                    dirPos = dirLight.sceneDirection;
                    this.ambientR += dirLight._ambientR;
                    this.ambientG += dirLight._ambientG;
                    this.ambientB += dirLight._ambientB;
                    if (this.usesTangentSpace) {
                        var x = -dirPos.x;
                        var y = -dirPos.y;
                        var z = -dirPos.z;
                        this.vertexConstantData[l++] = this._pInverseSceneMatrix[0] * x + this._pInverseSceneMatrix[4] * y + this._pInverseSceneMatrix[8] * z;
                        this.vertexConstantData[l++] = this._pInverseSceneMatrix[1] * x + this._pInverseSceneMatrix[5] * y + this._pInverseSceneMatrix[9] * z;
                        this.vertexConstantData[l++] = this._pInverseSceneMatrix[2] * x + this._pInverseSceneMatrix[6] * y + this._pInverseSceneMatrix[10] * z;
                        this.vertexConstantData[l++] = 1;
                    }
                    else {
                        this.fragmentConstantData[k++] = -dirPos.x;
                        this.fragmentConstantData[k++] = -dirPos.y;
                        this.fragmentConstantData[k++] = -dirPos.z;
                        this.fragmentConstantData[k++] = 1;
                    }
                    this.fragmentConstantData[k++] = dirLight._diffuseR;
                    this.fragmentConstantData[k++] = dirLight._diffuseG;
                    this.fragmentConstantData[k++] = dirLight._diffuseB;
                    this.fragmentConstantData[k++] = 1;
                    this.fragmentConstantData[k++] = dirLight._specularR;
                    this.fragmentConstantData[k++] = dirLight._specularG;
                    this.fragmentConstantData[k++] = dirLight._specularB;
                    this.fragmentConstantData[k++] = 1;
                    if (++total == this.numDirectionalLights) {
                        // break loop
                        i = len;
                        cast = numLightTypes;
                    }
                }
            }
            // more directional supported than currently picked, need to clamp all to 0
            if (this.numDirectionalLights > total) {
                i = k + (this.numDirectionalLights - total) * 12;
                while (k < i)
                    this.fragmentConstantData[k++] = 0;
            }
            total = 0;
            var pointLights = this._lightingPass.lightPicker.pointLights;
            offset = this._lightingPass.pointLightsOffset;
            len = this._lightingPass.lightPicker.pointLights.length;
            if (offset > len) {
                cast = 1;
                offset -= len;
            }
            else {
                cast = 0;
            }
            for (; cast < numLightTypes; ++cast) {
                if (cast)
                    pointLights = this._lightingPass.lightPicker.castingPointLights;
                len = pointLights.length;
                for (i = 0; i < len; ++i) {
                    pointLight = pointLights[offset + i];
                    dirPos = pointLight.transform.concatenatedMatrix3D.position;
                    this.ambientR += pointLight._ambientR;
                    this.ambientG += pointLight._ambientG;
                    this.ambientB += pointLight._ambientB;
                    if (this.usesTangentSpace) {
                        x = dirPos.x;
                        y = dirPos.y;
                        z = dirPos.z;
                        this.vertexConstantData[l++] = this._pInverseSceneMatrix[0] * x + this._pInverseSceneMatrix[4] * y + this._pInverseSceneMatrix[8] * z + this._pInverseSceneMatrix[12];
                        this.vertexConstantData[l++] = this._pInverseSceneMatrix[1] * x + this._pInverseSceneMatrix[5] * y + this._pInverseSceneMatrix[9] * z + this._pInverseSceneMatrix[13];
                        this.vertexConstantData[l++] = this._pInverseSceneMatrix[2] * x + this._pInverseSceneMatrix[6] * y + this._pInverseSceneMatrix[10] * z + this._pInverseSceneMatrix[14];
                        this.vertexConstantData[l++] = 1;
                    }
                    else if (!this.usesGlobalPosFragment) {
                        this.vertexConstantData[l++] = dirPos.x;
                        this.vertexConstantData[l++] = dirPos.y;
                        this.vertexConstantData[l++] = dirPos.z;
                        this.vertexConstantData[l++] = 1;
                    }
                    else {
                        this.fragmentConstantData[k++] = dirPos.x;
                        this.fragmentConstantData[k++] = dirPos.y;
                        this.fragmentConstantData[k++] = dirPos.z;
                        this.fragmentConstantData[k++] = 1;
                    }
                    this.fragmentConstantData[k++] = pointLight._diffuseR;
                    this.fragmentConstantData[k++] = pointLight._diffuseG;
                    this.fragmentConstantData[k++] = pointLight._diffuseB;
                    var radius = pointLight.radius;
                    this.fragmentConstantData[k++] = radius * radius;
                    this.fragmentConstantData[k++] = pointLight._specularR;
                    this.fragmentConstantData[k++] = pointLight._specularG;
                    this.fragmentConstantData[k++] = pointLight._specularB;
                    this.fragmentConstantData[k++] = pointLight.fallOffFactor;
                    if (++total == this.numPointLights) {
                        // break loop
                        i = len;
                        cast = numLightTypes;
                    }
                }
            }
            // more directional supported than currently picked, need to clamp all to 0
            if (this.numPointLights > total) {
                i = k + (total - this.numPointLights) * 12;
                for (; k < i; ++k)
                    this.fragmentConstantData[k] = 0;
            }
        };
        /**
         * Updates constant data render state used by the light probes. This method is optional for subclasses to implement.
         */
        LightingShader.prototype.updateProbes = function () {
            var probe;
            var lightProbes = this._lightingPass.lightPicker.lightProbes;
            var weights = this._lightingPass.lightPicker.lightProbeWeights;
            var len = lightProbes.length - this._lightingPass.lightProbesOffset;
            var addDiff = this.usesProbesForDiffuse;
            var addSpec = this.usesProbesForSpecular;
            if (!(addDiff || addSpec))
                return;
            if (len > this.numLightProbes)
                len = this.numLightProbes;
            for (var i = 0; i < len; ++i) {
                probe = lightProbes[this._lightingPass.lightProbesOffset + i];
                if (addDiff)
                    this._stage.getAbstraction(probe.diffuseMap).activate(this.lightProbeDiffuseIndices[i], probe.diffuseSampler);
                if (addSpec)
                    this._stage.getAbstraction(probe.specularMap).activate(this.lightProbeSpecularIndices[i], probe.diffuseSampler);
            }
            for (i = 0; i < len; ++i)
                this.fragmentConstantData[this.probeWeightsIndex + i] = weights[this._lightingPass.lightProbesOffset + i];
        };
        return LightingShader;
    }(ShaderBase));

    var MethodPassMode = /** @class */ (function () {
        function MethodPassMode() {
        }
        /**
         *
         */
        MethodPassMode.EFFECTS = 0x01;
        /**
         *
         */
        MethodPassMode.LIGHTING = 0x02;
        /**
         *
         */
        MethodPassMode.SUPER_SHADER = 0x03;
        return MethodPassMode;
    }());

    /**
     * CompiledPass forms an abstract base class for the default compiled pass materials provided by Away3D,
     * using material methods to define their appearance.
     */
    var MethodPass = /** @class */ (function (_super) {
        __extends$7(MethodPass, _super);
        /**
         * Creates a new CompiledPass object.
         *
         * @param material The material to which this pass belongs.
         */
        function MethodPass(mode, renderMaterial, renderElements) {
            var _this = _super.call(this, renderMaterial, renderElements) || this;
            _this._maxLights = 3;
            _this._mode = 0x03;
            _this._includeCasters = true;
            _this._chunks = new Array();
            _this._methods = new Array();
            _this._numEffectDependencies = 0;
            _this.numDirectionalLights = 0;
            _this.numPointLights = 0;
            _this.numLightProbes = 0;
            _this.pointLightsOffset = 0;
            _this.directionalLightsOffset = 0;
            _this.lightProbesOffset = 0;
            _this._mode = mode;
            _this._onLightsChangeDelegate = function (event) { return _this.onLightsChange(event); };
            _this._onMethodInvalidatedDelegate = function (event) { return _this.onMethodInvalidated(event); };
            _this.lightPicker = renderMaterial.lightPicker;
            if (_this._shader == null)
                _this._updateShader();
            return _this;
        }
        Object.defineProperty(MethodPass.prototype, "mode", {
            /**
             *
             */
            get: function () {
                return this._mode;
            },
            set: function (value) {
                if (this._mode == value)
                    return;
                this._mode = value;
                this._updateLights();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodPass.prototype, "includeCasters", {
            /**
             * Indicates whether or not shadow casting lights need to be included.
             */
            get: function () {
                return this._includeCasters;
            },
            set: function (value) {
                if (this._includeCasters == value)
                    return;
                this._includeCasters = value;
                this._updateLights();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodPass.prototype, "lightPicker", {
            /**
             *
             * @returns {LightPickerBase}
             */
            get: function () {
                return this._lightPicker;
            },
            set: function (value) {
                //if (this._lightPicker == value)
                //	return;
                if (this._lightPicker)
                    this._lightPicker.removeEventListener(AssetEvent.INVALIDATE, this._onLightsChangeDelegate);
                this._lightPicker = value;
                if (this._lightPicker)
                    this._lightPicker.addEventListener(AssetEvent.INVALIDATE, this._onLightsChangeDelegate);
                this._updateLights();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodPass.prototype, "enableLightFallOff", {
            /**
             * Whether or not to use fallOff and radius properties for lights. This can be used to improve performance and
             * compatibility for constrained mode.
             */
            get: function () {
                return this._renderMaterial.enableLightFallOff;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodPass.prototype, "diffuseLightSources", {
            /**
             * Define which light source types to use for diffuse reflections. This allows choosing between regular lights
             * and/or light probes for diffuse reflections.
             *
             * @see away3d.materials.LightSources
             */
            get: function () {
                return this._renderMaterial.diffuseLightSources;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodPass.prototype, "specularLightSources", {
            /**
             * Define which light source types to use for specular reflections. This allows choosing between regular lights
             * and/or light probes for specular reflections.
             *
             * @see away3d.materials.LightSources
             */
            get: function () {
                return this._renderMaterial.specularLightSources;
            },
            enumerable: true,
            configurable: true
        });
        MethodPass.prototype._updateShader = function () {
            if ((this.numDirectionalLights || this.numPointLights || this.numLightProbes) && !(this._shader instanceof LightingShader)) {
                if (this._shader != null) {
                    this._shader.dispose();
                    this._shader = null;
                }
                this._shader = new LightingShader(this._renderElements, this._renderMaterial, this, this._stage);
            }
            else if (this._shader == null) { // !(_shader instanceof ShaderBase) because there are only two shader types atm
                if (this._shader != null) {
                    this._shader.dispose();
                    this._shader = null;
                }
                this._shader = new ShaderBase(this._renderElements, this._renderMaterial, this, this._stage);
            }
        };
        /**
         * Initializes the unchanging constant data for this material.
         */
        MethodPass.prototype._initConstantData = function () {
            //Updates method constants if they have changed.
            var len = this._chunks.length;
            for (var i = 0; i < len; ++i)
                this._chunks[i]._initConstants();
        };
        Object.defineProperty(MethodPass.prototype, "colorTransform", {
            /**
             * The ColorTransform object to transform the colour of the material with. Defaults to null.
             */
            get: function () {
                return this.colorTransformMethod ? this.colorTransformMethod.colorTransform : null;
            },
            set: function (value) {
                if (value) {
                    if (this.colorTransformMethod == null)
                        this.colorTransformMethod = new EffectColorTransformMethod();
                    this.colorTransformMethod.colorTransform = value;
                }
                else if (!value) {
                    if (this.colorTransformMethod)
                        this.colorTransformMethod = null;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodPass.prototype, "colorTransformMethod", {
            /**
             * The EffectColorTransformMethod object to transform the colour of the material with. Defaults to null.
             */
            get: function () {
                return this._colorTransformMethod;
            },
            set: function (value) {
                if (this._colorTransformMethod == value)
                    return;
                if (this._colorTransformMethod) {
                    this._removeDependency(this._colorTransformMethod);
                    this._colorTransformChunk = null;
                }
                this._colorTransformMethod = value;
                if (value) {
                    this._colorTransformChunk = this._shader.getAbstraction(value);
                    this._addDependency(value);
                }
            },
            enumerable: true,
            configurable: true
        });
        MethodPass.prototype._removeDependency = function (method, effectsDependency) {
            if (effectsDependency === void 0) { effectsDependency = false; }
            var index = this._methods.indexOf(method);
            if (index == -1)
                return;
            if (!effectsDependency)
                this._numEffectDependencies--;
            method.removeEventListener(MethodEvent.SHADER_INVALIDATED, this._onMethodInvalidatedDelegate);
            this._methods.splice(index, 1);
            this._chunks.splice(index, 1);
            this.invalidate();
        };
        MethodPass.prototype._addDependency = function (method, effectsDependency, index) {
            if (effectsDependency === void 0) { effectsDependency = false; }
            if (index === void 0) { index = -1; }
            method.addEventListener(MethodEvent.SHADER_INVALIDATED, this._onMethodInvalidatedDelegate);
            var chunk = this._shader.getAbstraction(method);
            if (effectsDependency) {
                if (index != -1) {
                    this._methods.splice(index + this._methods.length - this._numEffectDependencies, 0, method);
                    this._chunks.splice(index + this._chunks.length - this._numEffectDependencies, 0, chunk);
                }
                else {
                    this._methods.push(method);
                    this._chunks.push(chunk);
                }
                this._numEffectDependencies++;
            }
            else {
                this._methods.splice(this._methods.length - this._numEffectDependencies, 0, method);
                this._chunks.splice(this._chunks.length - this._numEffectDependencies, 0, chunk);
            }
            this.invalidate();
        };
        /**
         * Appends an "effect" shading method to the shader. Effect methods are those that do not influence the lighting
         * but modulate the shaded colour, used for fog, outlines, etc. The method will be applied to the result of the
         * methods added prior.
         */
        MethodPass.prototype.addEffectMethod = function (method) {
            this._addDependency(method, true);
        };
        Object.defineProperty(MethodPass.prototype, "numEffectMethods", {
            /**
             * The number of "effect" methods added to the material.
             */
            get: function () {
                return this._numEffectDependencies;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Queries whether a given effects method was added to the material.
         *
         * @param method The method to be queried.
         * @return true if the method was added to the material, false otherwise.
         */
        MethodPass.prototype.hasEffectMethod = function (method) {
            return this._methods.indexOf(method) != -1;
        };
        /**
         * Returns the method added at the given index.
         * @param index The index of the method to retrieve.
         * @return The method at the given index.
         */
        MethodPass.prototype.getEffectMethodAt = function (index) {
            if (index < 0 || index > this._numEffectDependencies - 1)
                return null;
            return this._methods[index + this._methods.length - this._numEffectDependencies];
        };
        /**
         * Adds an effect method at the specified index amongst the methods already added to the material. Effect
         * methods are those that do not influence the lighting but modulate the shaded colour, used for fog, outlines,
         * etc. The method will be applied to the result of the methods with a lower index.
         */
        MethodPass.prototype.addEffectMethodAt = function (method, index) {
            this._addDependency(method, true, index);
        };
        /**
         * Removes an effect method from the material.
         * @param method The method to be removed.
         */
        MethodPass.prototype.removeEffectMethod = function (method) {
            this._removeDependency(method, true);
        };
        /**
         * remove an effect method at the specified index from the material.
         */
        MethodPass.prototype.removeEffectMethodAt = function (index) {
            var method = this.getEffectMethodAt(index);
            if (method != null)
                this._removeDependency(method, true);
        };
        Object.defineProperty(MethodPass.prototype, "normalMethod", {
            /**
             * The method used to generate the per-pixel normals. Defaults to NormalBasicMethod.
             */
            get: function () {
                return this._normalMethod;
            },
            set: function (value) {
                if (this._normalMethod == value)
                    return;
                if (this._normalMethod) {
                    this._removeDependency(this._normalMethod);
                    this._normalChunk = null;
                }
                this._normalMethod = value;
                if (value) {
                    this._normalChunk = this._shader.getAbstraction(value);
                    this._addDependency(value);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodPass.prototype, "ambientMethod", {
            /**
             * The method that provides the ambient lighting contribution. Defaults to AmbientBasicMethod.
             */
            get: function () {
                return this._ambientMethod;
            },
            set: function (value) {
                if (this._ambientMethod == value)
                    return;
                if (this._ambientMethod) {
                    this._removeDependency(this._ambientMethod);
                    this._ambientChunk = null;
                }
                this._ambientMethod = value;
                if (value) {
                    this._ambientChunk = this._shader.getAbstraction(value);
                    this._addDependency(value);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodPass.prototype, "shadowMethod", {
            /**
             * The method used to render shadows cast on this surface, or null if no shadows are to be rendered. Defaults to null.
             */
            get: function () {
                return this._shadowMethod;
            },
            set: function (value) {
                if (this._shadowMethod == value)
                    return;
                if (this._shadowMethod) {
                    this._removeDependency(this._shadowMethod);
                    this._shadowChunk = null;
                }
                this._shadowMethod = value;
                if (value) {
                    this._shadowChunk = this._shader.getAbstraction(value);
                    this._addDependency(value);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodPass.prototype, "diffuseMethod", {
            /**
             * The method that provides the diffuse lighting contribution. Defaults to DiffuseBasicMethod.
             */
            get: function () {
                return this._diffuseMethod;
            },
            set: function (value) {
                if (this._diffuseMethod == value)
                    return;
                if (this._diffuseMethod) {
                    this._removeDependency(this._diffuseMethod);
                    this._diffuseChunk = null;
                }
                if (value) {
                    this._diffuseChunk = this._shader.getAbstraction(value);
                    this._addDependency(value);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodPass.prototype, "specularMethod", {
            /**
             * The method that provides the specular lighting contribution. Defaults to SpecularBasicMethod.
             */
            get: function () {
                return this._specularMethod;
            },
            set: function (value) {
                if (this._specularMethod == value)
                    return;
                if (this._specularMethod) {
                    this._removeDependency(this._specularMethod);
                    this._specularChunk = null;
                }
                if (value) {
                    this._specularChunk = this._shader.getAbstraction(value);
                    this._addDependency(value);
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        MethodPass.prototype.dispose = function () {
            if (this._lightPicker)
                this._lightPicker.removeEventListener(AssetEvent.INVALIDATE, this._onLightsChangeDelegate);
            while (this._methods.length)
                this._removeDependency(this._methods[0]);
            _super.prototype.dispose.call(this);
            this._chunks = null;
            this._methods = null;
        };
        /**
         * Called when any method's shader code is invalidated.
         */
        MethodPass.prototype.onMethodInvalidated = function (event) {
            this.invalidate();
        };
        // RENDER LOOP
        /**
         * @inheritDoc
         */
        MethodPass.prototype._activate = function (view) {
            _super.prototype._activate.call(this, view);
            var chunk;
            var len = this._chunks.length;
            for (var i = 0; i < len; ++i) {
                chunk = this._chunks[i];
                if (chunk.chunkVO.useChunk)
                    chunk._activate();
            }
        };
        /**
         *
         *
         * @param renderable
         * @param stage
         * @param camera
         */
        MethodPass.prototype._setRenderState = function (renderState, view) {
            _super.prototype._setRenderState.call(this, renderState, view);
            var chunk;
            var len = this._chunks.length;
            for (var i = 0; i < len; ++i) {
                chunk = this._chunks[i];
                if (chunk.chunkVO.useChunk)
                    chunk._setRenderState(renderState, view);
            }
        };
        /**
         * @inheritDoc
         */
        MethodPass.prototype._deactivate = function () {
            _super.prototype._deactivate.call(this);
            var chunk;
            var len = this._chunks.length;
            for (var i = 0; i < len; ++i) {
                chunk = this._chunks[i];
                if (chunk.chunkVO.useChunk)
                    chunk._deactivate();
            }
        };
        MethodPass.prototype._includeDependencies = function (shader) {
            _super.prototype._includeDependencies.call(this, shader);
            //TODO: fragment animtion should be compatible with lighting pass
            shader.usesFragmentAnimation = Boolean(this._mode == MethodPassMode.SUPER_SHADER);
            if (shader.useAlphaPremultiplied && shader.usesBlending)
                shader.usesCommonData = true;
            var i;
            var len = this._chunks.length;
            for (i = 0; i < len; ++i)
                this.setupAndCountDependencies(shader, this._chunks[i]);
            var usesTangentSpace = true;
            var chunk;
            for (i = 0; i < len; ++i) {
                chunk = this._chunks[i];
                if ((chunk.chunkVO.useChunk = chunk._isUsed()) && !chunk._usesTangentSpace())
                    usesTangentSpace = false;
            }
            shader.outputsNormals = this._normalChunk && this._normalChunk.chunkVO.useChunk;
            shader.outputsTangentNormals = shader.outputsNormals && this._normalChunk._outputsTangentNormals();
            shader.usesTangentSpace = shader.outputsTangentNormals && !shader.usesProbes && usesTangentSpace;
            if (!shader.usesTangentSpace) {
                if (shader.viewDirDependencies > 0) {
                    shader.globalPosDependencies++;
                }
                else if (this.numPointLights > 0 && shader.usesLights) {
                    shader.globalPosDependencies++;
                    if (Boolean(this._mode & MethodPassMode.EFFECTS))
                        shader.usesGlobalPosFragment = true;
                }
            }
        };
        /**
         * Counts the dependencies for a given method.
         * @param method The method to count the dependencies for.
         * @param chunk The method's data for this material.
         */
        MethodPass.prototype.setupAndCountDependencies = function (shader, chunk) {
            var chunkVO = chunk.chunkVO;
            chunk._reset(chunkVO);
            chunk._initVO(chunkVO);
            if (chunkVO.needsProjection)
                shader.projectionDependencies++;
            if (chunkVO.needsGlobalVertexPos || chunkVO.needsGlobalFragmentPos) {
                shader.globalPosDependencies++;
                if (chunkVO.needsGlobalFragmentPos)
                    shader.usesGlobalPosFragment = true;
            }
            if (chunkVO.needsNormals)
                shader.normalDependencies++;
            if (chunkVO.needsTangents)
                shader.tangentDependencies++;
            if (chunkVO.needsView)
                shader.viewDirDependencies++;
        };
        MethodPass.prototype._getPreLightingVertexCode = function (registerCache, sharedRegisters) {
            var code = "";
            return code;
        };
        MethodPass.prototype._getPreLightingFragmentCode = function (registerCache, sharedRegisters) {
            var code = "";
            if (this._diffuseChunk && this._diffuseChunk.chunkVO.useChunk)
                code += this._diffuseChunk._getFragmentPreLightingCode(registerCache, sharedRegisters);
            if (this._specularChunk && this._specularChunk.chunkVO.useChunk)
                code += this._specularChunk._getFragmentPreLightingCode(registerCache, sharedRegisters);
            return code;
        };
        MethodPass.prototype._getPerLightDiffuseFragmentCode = function (lightDirReg, diffuseColorReg, registerCache, sharedRegisters) {
            return this._diffuseChunk._getFragmentCodePerLight(lightDirReg, diffuseColorReg, registerCache, sharedRegisters);
        };
        MethodPass.prototype._getPerLightSpecularFragmentCode = function (lightDirReg, specularColorReg, registerCache, sharedRegisters) {
            return this._specularChunk._getFragmentCodePerLight(lightDirReg, specularColorReg, registerCache, sharedRegisters);
        };
        MethodPass.prototype._getPerProbeDiffuseFragmentCode = function (texReg, weightReg, registerCache, sharedRegisters) {
            return this._diffuseChunk._getFragmentCodePerProbe(texReg, weightReg, registerCache, sharedRegisters);
        };
        MethodPass.prototype._getPerProbeSpecularFragmentCode = function (texReg, weightReg, registerCache, sharedRegisters) {
            return this._specularChunk._getFragmentCodePerProbe(texReg, weightReg, registerCache, sharedRegisters);
        };
        MethodPass.prototype._getNormalVertexCode = function (registerCache, sharedRegisters) {
            return this._normalChunk._getVertexCode(registerCache, sharedRegisters);
        };
        MethodPass.prototype._getNormalFragmentCode = function (registerCache, sharedRegisters) {
            var code = this._normalChunk._getFragmentCode(sharedRegisters.normalFragment, registerCache, sharedRegisters);
            if (this._normalChunk.chunkVO.needsView)
                registerCache.removeFragmentTempUsage(sharedRegisters.viewDirFragment);
            if (this._normalChunk.chunkVO.needsGlobalFragmentPos || this._normalChunk.chunkVO.needsGlobalVertexPos)
                registerCache.removeVertexTempUsage(sharedRegisters.globalPositionVertex);
            return code;
        };
        /**
         * @inheritDoc
         */
        MethodPass.prototype._getVertexCode = function (registerCache, sharedRegisters) {
            var code = "";
            if (this._ambientChunk && this._ambientChunk.chunkVO.useChunk)
                code += this._ambientChunk._getVertexCode(registerCache, sharedRegisters);
            if (this._shadowChunk)
                code += this._shadowChunk._getVertexCode(registerCache, sharedRegisters);
            if (this._diffuseChunk && this._diffuseChunk.chunkVO.useChunk)
                code += this._diffuseChunk._getVertexCode(registerCache, sharedRegisters);
            if (this._specularChunk && this._specularChunk.chunkVO.useChunk)
                code += this._specularChunk._getVertexCode(registerCache, sharedRegisters);
            var chunk;
            var len = this._chunks.length;
            for (var i = len - this._numEffectDependencies; i < len; i++) {
                chunk = this._chunks[i];
                if (chunk.chunkVO.useChunk) {
                    code += chunk._getVertexCode(registerCache, sharedRegisters);
                    if (chunk.chunkVO.needsGlobalVertexPos || chunk.chunkVO.needsGlobalFragmentPos)
                        registerCache.removeVertexTempUsage(sharedRegisters.globalPositionVertex);
                }
            }
            if (this._colorTransformChunk && this._colorTransformChunk.chunkVO.useChunk)
                code += this._colorTransformChunk._getVertexCode(registerCache, sharedRegisters);
            return code;
        };
        /**
         * @inheritDoc
         */
        MethodPass.prototype._getFragmentCode = function (registerCache, sharedRegisters) {
            var code = "";
            if (this._ambientChunk && this._ambientChunk.chunkVO.useChunk) {
                code += this._ambientChunk._getFragmentCode(sharedRegisters.shadedTarget, registerCache, sharedRegisters);
                if (this._ambientChunk.chunkVO.needsNormals)
                    registerCache.removeFragmentTempUsage(sharedRegisters.normalFragment);
                if (this._ambientChunk.chunkVO.needsView)
                    registerCache.removeFragmentTempUsage(sharedRegisters.viewDirFragment);
            }
            return code;
        };
        MethodPass.prototype._getPostAnimationFragmentCode = function (registerCache, sharedRegisters) {
            var code = "";
            //if blending with premultiplied alpha, make sure ambient color is correctly multiplied
            if (this._shader.useAlphaPremultiplied && this._shader.usesBlending) {
                code += "add " + sharedRegisters.shadedTarget + ".w, " + sharedRegisters.shadedTarget + ".w, " + sharedRegisters.commons + ".z\n" +
                    "div " + sharedRegisters.shadedTarget + ".xyz, " + sharedRegisters.shadedTarget + ", " + sharedRegisters.shadedTarget + ".w\n" +
                    "sub " + sharedRegisters.shadedTarget + ".w, " + sharedRegisters.shadedTarget + ".w, " + sharedRegisters.commons + ".z\n" +
                    "sat " + sharedRegisters.shadedTarget + ".xyz, " + sharedRegisters.shadedTarget + "\n";
            }
            ///////////////begin lighting shading
            if (this._shadowChunk)
                code += this._shadowChunk._getFragmentCode(sharedRegisters.shadowTarget, registerCache, sharedRegisters);
            if (this._diffuseChunk && this._diffuseChunk.chunkVO.useChunk) {
                code += this._diffuseChunk._getFragmentCode(sharedRegisters.shadedTarget, registerCache, sharedRegisters);
                // resolve other dependencies as well?
                if (this._diffuseChunk.chunkVO.needsNormals)
                    registerCache.removeFragmentTempUsage(sharedRegisters.normalFragment);
                if (this._diffuseChunk.chunkVO.needsView)
                    registerCache.removeFragmentTempUsage(sharedRegisters.viewDirFragment);
            }
            if (this._specularChunk && this._specularChunk.chunkVO.useChunk) {
                code += this._specularChunk._getFragmentCode(sharedRegisters.shadedTarget, registerCache, sharedRegisters);
                if (this._specularChunk.chunkVO.needsNormals)
                    registerCache.removeFragmentTempUsage(sharedRegisters.normalFragment);
                if (this._specularChunk.chunkVO.needsView)
                    registerCache.removeFragmentTempUsage(sharedRegisters.viewDirFragment);
            }
            if (this._shadowChunk && !this._shader.normalDependencies)
                registerCache.removeFragmentTempUsage(sharedRegisters.shadowTarget);
            ///////////////end lighting shading
            var alphaReg;
            //check if alpha is preserved while performing effects shading and store value
            if (this.preserveAlpha && this._numEffectDependencies > 0) {
                alphaReg = registerCache.getFreeFragmentSingleTemp();
                registerCache.addFragmentTempUsages(alphaReg, 1);
                code += "mov " + alphaReg + ", " + sharedRegisters.shadedTarget + ".w\n";
            }
            //perform effects shading
            var chunk;
            var len = this._chunks.length;
            for (var i = len - this._numEffectDependencies; i < len; i++) {
                chunk = this._chunks[i];
                if (chunk.chunkVO.useChunk) {
                    code += chunk._getFragmentCode(sharedRegisters.shadedTarget, registerCache, sharedRegisters);
                    if (chunk.chunkVO.needsNormals)
                        registerCache.removeFragmentTempUsage(sharedRegisters.normalFragment);
                    if (chunk.chunkVO.needsView)
                        registerCache.removeFragmentTempUsage(sharedRegisters.viewDirFragment);
                }
            }
            //check if alpha is preserved while performing effects shading and restore value
            if (this.preserveAlpha && this._numEffectDependencies > 0) {
                code += "mov " + sharedRegisters.shadedTarget + ".w, " + alphaReg + "\n";
                registerCache.removeFragmentTempUsage(alphaReg);
            }
            //peform final colortransform chunk if it exists
            if (this._colorTransformChunk && this._colorTransformChunk.chunkVO.useChunk)
                code += this._colorTransformChunk._getFragmentCode(sharedRegisters.shadedTarget, registerCache, sharedRegisters);
            return code;
        };
        /**
         * Indicates whether the shader uses any shadows.
         */
        MethodPass.prototype._iUsesShadows = function (shader) {
            return Boolean(this._shadowChunk && (this._lightPicker.castingDirectionalLights.length > 0 || this._lightPicker.castingPointLights.length > 0));
        };
        /**
         * Indicates whether the shader uses any specular component.
         */
        MethodPass.prototype._iUsesSpecular = function (shader) {
            return Boolean(this._specularChunk);
        };
        /**
         * Indicates whether the shader uses any specular component.
         */
        MethodPass.prototype._iUsesDiffuse = function (shader) {
            return Boolean(this._diffuseChunk);
        };
        MethodPass.prototype.onLightsChange = function (event) {
            this._updateLights();
        };
        MethodPass.prototype._updateLights = function () {
            var numDirectionalLightsOld = this.numDirectionalLights;
            var numPointLightsOld = this.numPointLights;
            var numLightProbesOld = this.numLightProbes;
            if (this._lightPicker && (this._mode & MethodPassMode.LIGHTING)) {
                this.numDirectionalLights = this.calculateNumDirectionalLights(this._lightPicker.numDirectionalLights);
                this.numPointLights = this.calculateNumPointLights(this._lightPicker.numPointLights);
                this.numLightProbes = this.calculateNumProbes(this._lightPicker.numLightProbes);
                if (this._includeCasters) {
                    this.numDirectionalLights += this._lightPicker.numCastingDirectionalLights;
                    this.numPointLights += this._lightPicker.numCastingPointLights;
                }
            }
            else {
                this.numDirectionalLights = 0;
                this.numPointLights = 0;
                this.numLightProbes = 0;
            }
            if (numDirectionalLightsOld != this.numDirectionalLights || numPointLightsOld != this.numPointLights || numLightProbesOld != this.numLightProbes) {
                this._updateShader();
                this.invalidate();
            }
        };
        /**
         * Calculates the amount of directional lights this material will support.
         * @param numDirectionalLights The maximum amount of directional lights to support.
         * @return The amount of directional lights this material will support, bounded by the amount necessary.
         */
        MethodPass.prototype.calculateNumDirectionalLights = function (numDirectionalLights) {
            return Math.min(numDirectionalLights - this.directionalLightsOffset, this._maxLights);
        };
        /**
         * Calculates the amount of point lights this material will support.
         * @param numDirectionalLights The maximum amount of point lights to support.
         * @return The amount of point lights this material will support, bounded by the amount necessary.
         */
        MethodPass.prototype.calculateNumPointLights = function (numPointLights) {
            var numFree = this._maxLights - this.numDirectionalLights;
            return Math.min(numPointLights - this.pointLightsOffset, numFree);
        };
        /**
         * Calculates the amount of light probes this material will support.
         * @param numDirectionalLights The maximum amount of light probes to support.
         * @return The amount of light probes this material will support, bounded by the amount necessary.
         */
        MethodPass.prototype.calculateNumProbes = function (numLightProbes) {
            var numChannels = 0;
            if ((this._renderMaterial.specularLightSources & LightSources.PROBES) != 0)
                ++numChannels;
            if ((this._renderMaterial.diffuseLightSources & LightSources.PROBES) != 0)
                ++numChannels;
            // 4 channels available
            return Math.min(numLightProbes - this.lightProbesOffset, (4 / numChannels) | 0);
        };
        return MethodPass;
    }(PassBase));

    /**
     * BasicMaterialPass forms an abstract base class for the default shaded materials provided by Stage,
     * using material methods to define their appearance.
     */
    var BasicMaterialPass = /** @class */ (function (_super) {
        __extends$7(BasicMaterialPass, _super);
        function BasicMaterialPass(renderMaterial, renderElements) {
            var _this = _super.call(this, renderMaterial, renderElements) || this;
            _this._diffuseR = 1;
            _this._diffuseG = 1;
            _this._diffuseB = 1;
            _this._diffuseA = 1;
            _this._shader = new ShaderBase(renderElements, renderMaterial, _this, _this._stage);
            _this.invalidate();
            return _this;
        }
        BasicMaterialPass.prototype._includeDependencies = function (shader) {
            _super.prototype._includeDependencies.call(this, shader);
            if (this._shaderTexture != null)
                shader.uvDependencies++;
        };
        BasicMaterialPass.prototype.invalidate = function () {
            _super.prototype.invalidate.call(this);
            this._shaderTexture = this._renderMaterial.material.getTextureAt(0) ? this._shader.getAbstraction(this._renderMaterial.material.getTextureAt(0)) : null;
        };
        BasicMaterialPass.prototype.dispose = function () {
            if (this._shaderTexture) {
                this._shaderTexture.onClear(new AssetEvent(AssetEvent.CLEAR, this._renderMaterial.material.getTextureAt(0)));
                this._shaderTexture = null;
            }
            _super.prototype.dispose.call(this);
        };
        /**
         * @inheritDoc
         */
        BasicMaterialPass.prototype._getFragmentCode = function (regCache, sharedReg) {
            var code = "";
            var alphaReg;
            if (this.preserveAlpha) {
                alphaReg = regCache.getFreeFragmentSingleTemp();
                regCache.addFragmentTempUsages(alphaReg, 1);
                code += "mov " + alphaReg + ", " + sharedReg.shadedTarget + ".w\n";
            }
            var targetReg = sharedReg.shadedTarget;
            if (this._shaderTexture != null) {
                code += this._shaderTexture._getFragmentCode(targetReg, regCache, sharedReg, sharedReg.uvVarying);
                if (this._shader.alphaThreshold > 0) {
                    var cutOffReg = regCache.getFreeFragmentConstant();
                    this._fragmentConstantsIndex = cutOffReg.index * 4;
                    code += "sub " + targetReg + ".w, " + targetReg + ".w, " + cutOffReg + ".x\n" + "kil " + targetReg + ".w\n" + "add " + targetReg + ".w, " + targetReg + ".w, " + cutOffReg + ".x\n";
                }
            }
            else if (this._shader.colorBufferIndex != -1) {
                code += "mov " + targetReg + ", " + sharedReg.colorVarying + "\n";
            }
            else {
                var diffuseInputReg = regCache.getFreeFragmentConstant();
                this._fragmentConstantsIndex = diffuseInputReg.index * 4;
                code += "mov " + targetReg + ", " + diffuseInputReg + "\n";
            }
            if (this.preserveAlpha) {
                code += "mul " + sharedReg.shadedTarget + ".w, " + sharedReg.shadedTarget + ".w, " + alphaReg + "\n";
                regCache.removeFragmentTempUsage(alphaReg);
            }
            return code;
        };
        BasicMaterialPass.prototype._setRenderState = function (renderState, view) {
            _super.prototype._setRenderState.call(this, renderState, view);
            if (this._shaderTexture != null)
                this._shaderTexture._setRenderState(renderState);
        };
        /**
         * @inheritDoc
         */
        BasicMaterialPass.prototype._activate = function (view) {
            _super.prototype._activate.call(this, view);
            if (this._shaderTexture != null) {
                this._shaderTexture.activate();
                if (this._shader.alphaThreshold > 0)
                    this._shader.fragmentConstantData[this._fragmentConstantsIndex] = this._shader.alphaThreshold;
            }
            else if (this._shader.colorBufferIndex == -1) {
                var index = this._fragmentConstantsIndex;
                var data = this._shader.fragmentConstantData;
                data[index] = this._diffuseR;
                data[index + 1] = this._diffuseG;
                data[index + 2] = this._diffuseB;
                data[index + 3] = this._diffuseA;
            }
        };
        return BasicMaterialPass;
    }(PassBase));

    /**
     * LightPickerBase provides an abstract base clase for light picker classes. These classes are responsible for
     * feeding materials with relevant lights. Usually, StaticLightPicker can be used, but LightPickerBase can be
     * extended to provide more application-specific dynamic selection of lights.
     *
     * @see StaticLightPicker
     */
    var LightPickerBase = /** @class */ (function (_super) {
        __extends$7(LightPickerBase, _super);
        /**
         * Creates a new LightPickerBase object.
         */
        function LightPickerBase() {
            var _this = _super.call(this) || this;
            _this._numPointLights = 0;
            _this._numDirectionalLights = 0;
            _this._numCastingPointLights = 0;
            _this._numCastingDirectionalLights = 0;
            _this._numLightProbes = 0;
            return _this;
        }
        /**
         * Disposes resources used by the light picker.
         */
        LightPickerBase.prototype.dispose = function () {
        };
        Object.defineProperty(LightPickerBase.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return LightPickerBase.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightPickerBase.prototype, "numDirectionalLights", {
            /**
             * The maximum amount of directional lights that will be provided.
             */
            get: function () {
                return this._numDirectionalLights;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightPickerBase.prototype, "numPointLights", {
            /**
             * The maximum amount of point lights that will be provided.
             */
            get: function () {
                return this._numPointLights;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightPickerBase.prototype, "numCastingDirectionalLights", {
            /**
             * The maximum amount of directional lights that cast shadows.
             */
            get: function () {
                return this._numCastingDirectionalLights;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightPickerBase.prototype, "numCastingPointLights", {
            /**
             * The amount of point lights that cast shadows.
             */
            get: function () {
                return this._numCastingPointLights;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightPickerBase.prototype, "numLightProbes", {
            /**
             * The maximum amount of light probes that will be provided.
             */
            get: function () {
                return this._numLightProbes;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightPickerBase.prototype, "pointLights", {
            /**
             * The collected point lights to be used for shading.
             */
            get: function () {
                return this._pointLights;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightPickerBase.prototype, "directionalLights", {
            /**
             * The collected directional lights to be used for shading.
             */
            get: function () {
                return this._directionalLights;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightPickerBase.prototype, "castingPointLights", {
            /**
             * The collected point lights that cast shadows to be used for shading.
             */
            get: function () {
                return this._castingPointLights;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightPickerBase.prototype, "castingDirectionalLights", {
            /**
             * The collected directional lights that cast shadows to be used for shading.
             */
            get: function () {
                return this._castingDirectionalLights;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightPickerBase.prototype, "lightProbes", {
            /**
             * The collected light probes to be used for shading.
             */
            get: function () {
                return this._lightProbes;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightPickerBase.prototype, "lightProbeWeights", {
            /**
             * The weights for each light probe, defining their influence on the object.
             */
            get: function () {
                return this._lightProbeWeights;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LightPickerBase.prototype, "allPickedLights", {
            /**
             * A collection of all the collected lights.
             */
            get: function () {
                return this._allPickedLights;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Updates set of lights for a given renderable and EntityCollector. Always call super.collectLights() after custom overridden code.
         */
        LightPickerBase.prototype.collectLights = function (entity) {
            this.updateProbeWeights(entity);
        };
        /**
         * Updates the weights for the light probes, based on the renderable's position relative to them.
         * @param renderable The renderble for which to calculate the light probes' influence.
         */
        LightPickerBase.prototype.updateProbeWeights = function (entity) {
            // todo: this will cause the same calculations to occur per TriangleGraphic. See if this can be improved.
            var objectPos = entity.scenePosition;
            var lightPos;
            var rx = objectPos.x, ry = objectPos.y, rz = objectPos.z;
            var dx, dy, dz;
            var w, total = 0;
            var i;
            // calculates weights for probes
            for (i = 0; i < this._numLightProbes; ++i) {
                lightPos = this._lightProbes[i].transform.concatenatedMatrix3D.position;
                dx = rx - lightPos.x;
                dy = ry - lightPos.y;
                dz = rz - lightPos.z;
                // weight is inversely proportional to square of distance
                w = dx * dx + dy * dy + dz * dz;
                // just... huge if at the same spot
                w = w > .00001 ? 1 / w : 50000000;
                this._lightProbeWeights[i] = w;
                total += w;
            }
            // normalize
            total = 1 / total;
            for (i = 0; i < this._numLightProbes; ++i)
                this._lightProbeWeights[i] *= total;
        };
        LightPickerBase.assetType = "[asset LightPicker]";
        return LightPickerBase;
    }(AssetBase));

    /**
     * StaticLightPicker is a light picker that provides a static set of lights. The lights can be reassigned, but
     * if the configuration changes (number of directional lights, point lights, etc), a material recompilation may
     * occur.
     */
    var StaticLightPicker = /** @class */ (function (_super) {
        __extends$7(StaticLightPicker, _super);
        /**
         * Creates a new StaticLightPicker object.
         * @param lights The lights to be used for shading.
         */
        function StaticLightPicker(lights) {
            var _this = _super.call(this) || this;
            _this._onCastShadowChangeDelegate = function (event) { return _this.onCastShadowChange(event); };
            _this.lights = lights;
            return _this;
        }
        Object.defineProperty(StaticLightPicker.prototype, "lights", {
            /**
             * The lights used for shading.
             */
            get: function () {
                return this._lights;
            },
            set: function (value) {
                var numPointLights = 0;
                var numDirectionalLights = 0;
                var numCastingPointLights = 0;
                var numCastingDirectionalLights = 0;
                var numLightProbes = 0;
                var light;
                if (this._lights)
                    this.clearListeners();
                this._lights = value;
                this._allPickedLights = value;
                this._pointLights = new Array();
                this._castingPointLights = new Array();
                this._directionalLights = new Array();
                this._castingDirectionalLights = new Array();
                this._lightProbes = new Array();
                var len = value.length;
                for (var i = 0; i < len; ++i) {
                    light = value[i];
                    light.addEventListener(LightEvent.CASTS_SHADOW_CHANGE, this._onCastShadowChangeDelegate);
                    if (light instanceof PointLight) {
                        if (light.shadowsEnabled)
                            this._castingPointLights[numCastingPointLights++] = light;
                        else
                            this._pointLights[numPointLights++] = light;
                    }
                    else if (light instanceof DirectionalLight) {
                        if (light.shadowsEnabled)
                            this._castingDirectionalLights[numCastingDirectionalLights++] = light;
                        else
                            this._directionalLights[numDirectionalLights++] = light;
                    }
                    else if (light instanceof LightProbe) {
                        this._lightProbes[numLightProbes++] = light;
                    }
                }
                if (this._numDirectionalLights == numDirectionalLights && this._numPointLights == numPointLights && this._numLightProbes == numLightProbes && this._numCastingPointLights == numCastingPointLights && this._numCastingDirectionalLights == numCastingDirectionalLights)
                    return;
                this._numDirectionalLights = numDirectionalLights;
                this._numCastingDirectionalLights = numCastingDirectionalLights;
                this._numPointLights = numPointLights;
                this._numCastingPointLights = numCastingPointLights;
                this._numLightProbes = numLightProbes;
                // MUST HAVE MULTIPLE OF 4 ELEMENTS!
                this._lightProbeWeights = new Array(Math.ceil(numLightProbes / 4) * 4);
                // notify material lights have changed
                this.dispatchEvent(new AssetEvent(AssetEvent.INVALIDATE, this));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Remove configuration change listeners on the lights.
         */
        StaticLightPicker.prototype.clearListeners = function () {
            var len = this._lights.length;
            for (var i = 0; i < len; ++i)
                this._lights[i].removeEventListener(LightEvent.CASTS_SHADOW_CHANGE, this._onCastShadowChangeDelegate);
        };
        /**
         * Notifies the material of a configuration change.
         */
        StaticLightPicker.prototype.onCastShadowChange = function (event) {
            // TODO: Assign to special caster collections, just append it to the lights in SinglePass
            // But keep seperated in multipass
            var light = event.target;
            if (light instanceof PointLight)
                this.updatePointCasting(light);
            else if (light instanceof DirectionalLight)
                this.updateDirectionalCasting(light);
            this.dispatchEvent(new AssetEvent(AssetEvent.INVALIDATE, this));
        };
        /**
         * Called when a directional light's shadow casting configuration changes.
         */
        StaticLightPicker.prototype.updateDirectionalCasting = function (light) {
            var dl = light;
            if (light.shadowsEnabled) {
                --this._numDirectionalLights;
                ++this._numCastingDirectionalLights;
                this._directionalLights.splice(this._directionalLights.indexOf(dl), 1);
                this._castingDirectionalLights.push(light);
            }
            else {
                ++this._numDirectionalLights;
                --this._numCastingDirectionalLights;
                this._castingDirectionalLights.splice(this._castingDirectionalLights.indexOf(dl), 1);
                this._directionalLights.push(light);
            }
        };
        /**
         * Called when a point light's shadow casting configuration changes.
         */
        StaticLightPicker.prototype.updatePointCasting = function (light) {
            var pl = light;
            if (light.shadowsEnabled) {
                --this._numPointLights;
                ++this._numCastingPointLights;
                this._pointLights.splice(this._pointLights.indexOf(pl), 1);
                this._castingPointLights.push(light);
            }
            else {
                ++this._numPointLights;
                --this._numCastingPointLights;
                this._castingPointLights.splice(this._castingPointLights.indexOf(pl), 1);
                this._pointLights.push(light);
            }
        };
        return StaticLightPicker;
    }(LightPickerBase));

    var CascadeShadowMapper = /** @class */ (function (_super) {
        __extends$7(CascadeShadowMapper, _super);
        function CascadeShadowMapper(image2D, numCascades) {
            if (image2D === void 0) { image2D = null; }
            if (numCascades === void 0) { numCascades = 3; }
            var _this = _super.call(this, image2D) || this;
            _this._scissorRectsInvalid = true;
            _this._onClearDelegate = function (event) { return _this.onClear(event); };
            image2D.addEventListener(AssetEvent.CLEAR, _this._onClearDelegate);
            if (numCascades < 1 || numCascades > 4)
                throw new Error("numCascades must be an integer between 1 and 4");
            _this._numCascades = numCascades;
            _this.init();
            return _this;
        }
        Object.defineProperty(CascadeShadowMapper.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return CascadeShadowMapper.assetType;
            },
            enumerable: true,
            configurable: true
        });
        CascadeShadowMapper.prototype.dispose = function () {
            this._image2D.removeEventListener(AssetEvent.CLEAR, this._onClearDelegate);
            _super.prototype.dispose.call(this);
        };
        CascadeShadowMapper.prototype.getSplitRatio = function (index) {
            return this._splitRatios[index];
        };
        CascadeShadowMapper.prototype.setSplitRatio = function (index, value) {
            if (value < 0)
                value = 0;
            else if (value > 1)
                value = 1;
            if (index >= this._numCascades)
                throw new Error("index must be smaller than the number of cascades!");
            this._splitRatios[index] = value;
        };
        CascadeShadowMapper.prototype.getDepthProjections = function (partition) {
            return this._depthProjections[partition].viewMatrix3D;
        };
        CascadeShadowMapper.prototype.init = function () {
            this._splitRatios = new Array(this._numCascades);
            this._nearPlaneDistances = new Array(this._numCascades);
            var s = 1;
            for (var i = this._numCascades - 1; i >= 0; --i) {
                this._splitRatios[i] = s;
                s *= .4;
            }
            this._texOffsetsX = Array(-1, 1, -1, 1);
            this._texOffsetsY = Array(1, 1, -1, -1);
            this._pScissorRects = new Array(4);
            this._depthProjections = new Array();
            for (i = 0; i < this._numCascades; ++i)
                this._depthProjections[i] = new PerspectiveProjection();
        };
        /**
         *
         */
        CascadeShadowMapper.prototype.onClear = function (event) {
            this._scissorRectsInvalid = true;
        };
        Object.defineProperty(CascadeShadowMapper.prototype, "numCascades", {
            get: function () {
                return this._numCascades;
            },
            set: function (value /*int*/) {
                if (value == this._numCascades)
                    return;
                if (value < 1 || value > 4)
                    throw new Error("numCascades must be an integer between 1 and 4");
                this._numCascades = value;
                this._scissorRectsInvalid = true;
                this.init();
                this.dispatchEvent(new AssetEvent(AssetEvent.INVALIDATE, this));
            },
            enumerable: true,
            configurable: true
        });
        CascadeShadowMapper.prototype._renderMap = function (partition, renderGroup) {
            if (this._scissorRectsInvalid)
                this.updateScissorRects();
            renderGroup.depthRenderGroup.getRenderer(partition).cullPlanes = this._cullPlanes;
            //rootRenderer.getDepthRenderer()._iRenderCascades(this._overallDepthProjection, view, this._image2D, this._numCascades, this._pScissorRects, this._depthProjections);
        };
        CascadeShadowMapper.prototype.updateScissorRects = function () {
            var half = this._image2D.width * .5;
            this._pScissorRects[0] = new Rectangle(0, 0, half, half);
            this._pScissorRects[1] = new Rectangle(half, 0, half, half);
            this._pScissorRects[2] = new Rectangle(0, half, half, half);
            this._pScissorRects[3] = new Rectangle(half, half, half, half);
            this._scissorRectsInvalid = false;
        };
        CascadeShadowMapper.prototype._updateProjection = function (projection) {
            var matrix;
            var projectionNear = projection.near;
            var projectionRange = projection.far - projectionNear;
            this._updateProjectionFromFrustumCorners(projection, projection.viewFrustumCorners, this._matrix);
            this._matrix.appendScale(.96, .96, 1);
            this._overallDepthProjection.frustumMatrix3D = this._matrix;
            this._updateCullPlanes(projection);
            for (var i = 0; i < this._numCascades; ++i) {
                matrix = this._depthProjections[i].frustumMatrix3D;
                this._nearPlaneDistances[i] = projectionNear + this._splitRatios[i] * projectionRange;
                this._depthProjections[i].transform.matrix3D = this._overallDepthProjection.transform.matrix3D;
                this.updateProjectionPartition(matrix, this._splitRatios[i], this._texOffsetsX[i], this._texOffsetsY[i]);
                this._depthProjections[i].frustumMatrix3D = matrix;
            }
        };
        CascadeShadowMapper.prototype.updateProjectionPartition = function (matrix, splitRatio, texOffsetX, texOffsetY) {
            var xN, yN, zN;
            var xF, yF, zF;
            var minX = Number.POSITIVE_INFINITY, minY = Number.POSITIVE_INFINITY, minZ;
            var maxX = Number.NEGATIVE_INFINITY, maxY = Number.NEGATIVE_INFINITY, maxZ = Number.NEGATIVE_INFINITY;
            var i = 0;
            while (i < 12) {
                xN = this._localFrustum[i];
                yN = this._localFrustum[i + 1];
                zN = this._localFrustum[i + 2];
                xF = xN + (this._localFrustum[i + 12] - xN) * splitRatio;
                yF = yN + (this._localFrustum[i + 13] - yN) * splitRatio;
                zF = zN + (this._localFrustum[i + 14] - zN) * splitRatio;
                if (xN < minX)
                    minX = xN;
                if (xN > maxX)
                    maxX = xN;
                if (yN < minY)
                    minY = yN;
                if (yN > maxY)
                    maxY = yN;
                if (zN > maxZ)
                    maxZ = zN;
                if (xF < minX)
                    minX = xF;
                if (xF > maxX)
                    maxX = xF;
                if (yF < minY)
                    minY = yF;
                if (yF > maxY)
                    maxY = yF;
                if (zF > maxZ)
                    maxZ = zF;
                i += 3;
            }
            minZ = 1;
            var w = (maxX - minX);
            var h = (maxY - minY);
            var d = 1 / (maxZ - minZ);
            if (minX < 0)
                minX -= this._snap; // because int() rounds up for < 0
            if (minY < 0)
                minY -= this._snap;
            minX = Math.floor(minX / this._snap) * this._snap;
            minY = Math.floor(minY / this._snap) * this._snap;
            var snap2 = 2 * this._snap;
            w = Math.floor(w / snap2 + 1) * snap2;
            h = Math.floor(h / snap2 + 1) * snap2;
            maxX = minX + w;
            maxY = minY + h;
            w = 1 / w;
            h = 1 / h;
            var raw = matrix._rawData;
            raw[0] = 2 * w;
            raw[5] = 2 * h;
            raw[10] = d;
            raw[12] = -(maxX + minX) * w;
            raw[13] = -(maxY + minY) * h;
            raw[14] = -minZ * d;
            raw[15] = 1;
            raw[1] = raw[2] = raw[3] = raw[4] = raw[6] = raw[7] = raw[8] = raw[9] = raw[11] = 0;
            matrix.appendScale(.96, .96, 1);
            matrix.appendTranslation(texOffsetX, texOffsetY, 0);
            matrix.appendScale(.5, .5, 1);
        };
        Object.defineProperty(CascadeShadowMapper.prototype, "_iNearPlaneDistances", {
            get: function () {
                return this._nearPlaneDistances;
            },
            enumerable: true,
            configurable: true
        });
        CascadeShadowMapper.assetType = "[asset CascadeShadowMapper]";
        return CascadeShadowMapper;
    }(DirectionalShadowMapper));
    /**
     * _Shader_CascadeShadowMapper is a shadow map method to apply cascade shadow mapping on materials.
     * Must be used with a DirectionalLight with a CascadeShadowMapper assigned to its shadowMapper property.
     *
     * @see away.lights.CascadeShadowMapper
     */
    var _Shader_CascadeShadowMapper = /** @class */ (function (_super) {
        __extends$7(_Shader_CascadeShadowMapper, _super);
        function _Shader_CascadeShadowMapper() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_CascadeShadowMapper.prototype._initVO = function (chunkVO) {
            _super.prototype._initVO.call(this, chunkVO);
            chunkVO.needsProjection = true;
        };
        /**
         * @inheritDoc
         */
        _Shader_CascadeShadowMapper.prototype._initConstants = function () {
            _super.prototype._initConstants.call(this);
            var fragmentData = this._shader.fragmentConstantData;
            var vertexData = this._shader.vertexConstantData;
            var index = this._fragmentConstantsIndex;
            fragmentData[index] = 1.0;
            fragmentData[index + 1] = 1 / 255.0;
            fragmentData[index + 2] = 1 / 65025.0;
            fragmentData[index + 3] = 1 / 16581375.0;
            fragmentData[index + 6] = .5;
            fragmentData[index + 7] = -.5;
            index = this._vertexConstantsIndex;
            vertexData[index] = .5;
            vertexData[index + 1] = -.5;
            vertexData[index + 2] = 0;
            var numCascades = this._mapper.numCascades;
            this._projectionMatrices = new Array(numCascades);
            for (var k = 0; k < numCascades; ++k)
                this._projectionMatrices[k] = new Matrix3D(new Float32Array(this._shader.vertexConstantData.buffer, (this._vertexConstantsIndex + 4 + k * 16) * 4, 16));
        };
        /**
         * @inheritDoc
         */
        _Shader_CascadeShadowMapper.prototype._cleanCompilationData = function () {
            _super.prototype._cleanCompilationData.call(this);
            this._cascadeProjections = null;
            this._depthMapCoordVaryings = null;
            this._projectionMatrices = null;
        };
        /**
         * @inheritDoc
         */
        _Shader_CascadeShadowMapper.prototype._getVertexCode = function (registerCache, sharedRegisters) {
            var code = "";
            var dataReg = registerCache.getFreeVertexConstant();
            this._vertexConstantsIndex = dataReg.index * 4;
            //Create the registers for the cascades' projection coordinates.
            this._cascadeProjections = new Array(this._mapper.numCascades);
            this._depthMapCoordVaryings = new Array(this._mapper.numCascades);
            for (var i = 0; i < this._mapper.numCascades; ++i) {
                this._depthMapCoordVaryings[i] = registerCache.getFreeVarying();
                this._cascadeProjections[i] = registerCache.getFreeVertexConstant();
                registerCache.getFreeVertexConstant();
                registerCache.getFreeVertexConstant();
                registerCache.getFreeVertexConstant();
            }
            var temp = registerCache.getFreeVertexVectorTemp();
            for (var i = 0; i < this._mapper.numCascades; ++i) {
                code += "m44 " + temp + ", " + sharedRegisters.globalPositionVertex + ", " + this._cascadeProjections[i] + "\n" +
                    "add " + this._depthMapCoordVaryings[i] + ", " + temp + ", " + dataReg + ".zzwz\n";
            }
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_CascadeShadowMapper.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var numCascades = this._mapper.numCascades;
            var decReg = registerCache.getFreeFragmentConstant();
            var dataReg = registerCache.getFreeFragmentConstant();
            var planeDistanceReg = registerCache.getFreeFragmentConstant();
            var planeDistances = Array(planeDistanceReg + ".x", planeDistanceReg + ".y", planeDistanceReg + ".z", planeDistanceReg + ".w");
            var code;
            this._fragmentConstantsIndex = decReg.index * 4;
            var inQuad = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(inQuad, 1);
            var uvCoord = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(uvCoord, 1);
            // assume lowest partition is selected, will be overwritten later otherwise
            code = "mov " + uvCoord + ", " + this._depthMapCoordVaryings[numCascades - 1] + "\n";
            for (var i = numCascades - 2; i >= 0; --i) {
                var uvProjection = this._depthMapCoordVaryings[i];
                // calculate if in texturemap (result == 0 or 1, only 1 for a single partition)
                code += "slt " + inQuad + ".z, " + sharedRegisters.projectionFragment + ".z, " + planeDistances[i] + "\n"; // z = x > minX, w = y > minY
                var temp = registerCache.getFreeFragmentVectorTemp();
                // linearly interpolate between old and new uv coords using predicate value == conditional toggle to new value if predicate == 1 (true)
                code += "sub " + temp + ", " + uvProjection + ", " + uvCoord + "\n" +
                    "mul " + temp + ", " + temp + ", " + inQuad + ".z\n" +
                    "add " + uvCoord + ", " + uvCoord + ", " + temp + "\n";
            }
            registerCache.removeFragmentTempUsage(inQuad);
            code += "div " + uvCoord + ", " + uvCoord + ", " + uvCoord + ".w\n" +
                "mul " + uvCoord + ".xy, " + uvCoord + ".xy, " + dataReg + ".zw\n" +
                "add " + uvCoord + ".xy, " + uvCoord + ".xy, " + dataReg + ".zz\n";
            // code += (<ShadowChunkBase> this._baseChunk)._getCascadeFragmentCode(decReg, uvCoord, targetReg, registerCache, sharedRegisters) +
            // 	"add " + targetReg + ".w, " + targetReg + ".w, " + dataReg + ".y\n";
            //
            registerCache.removeFragmentTempUsage(uvCoord);
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_CascadeShadowMapper.prototype._activate = function () {
            // (<ShadowChunkBase> this._baseChunk).depthMap.activate();
            this._shader.vertexConstantData[this._vertexConstantsIndex + 3] = -1 / (this._mapper.depth * this._mapper.epsilon);
            var numCascades = this._mapper.numCascades;
            for (var k = 0; k < numCascades; ++k)
                this._projectionMatrices[k].copyFrom(this._mapper.getDepthProjections(k), true);
            var fragmentData = this._shader.fragmentConstantData;
            var fragmentIndex = this._fragmentConstantsIndex;
            fragmentData[fragmentIndex + 5] = 1 - this._mapper.alpha;
            var nearPlaneDistances = this._mapper._iNearPlaneDistances;
            fragmentIndex += 8;
            for (var i = 0; i < numCascades; ++i)
                fragmentData[fragmentIndex + i] = nearPlaneDistances[i];
            // (<ShadowChunkBase> this._baseChunk)._activateForCascade();
        };
        /**
         * @inheritDoc
         */
        _Shader_CascadeShadowMapper.prototype._setRenderState = function (renderState, view) {
        };
        return _Shader_CascadeShadowMapper;
    }(_Shader_DirectionalShadowMapper));
    ShaderBase.registerAbstraction(_Shader_CascadeShadowMapper, CascadeShadowMapper);

    var NearDirectionalShadowMapper = /** @class */ (function (_super) {
        __extends$7(NearDirectionalShadowMapper, _super);
        function NearDirectionalShadowMapper(image2D, coverageRatio, fadeRatio) {
            if (image2D === void 0) { image2D = null; }
            if (coverageRatio === void 0) { coverageRatio = .5; }
            if (fadeRatio === void 0) { fadeRatio = .1; }
            var _this = _super.call(this, image2D) || this;
            _this.coverageRatio = coverageRatio;
            _this._fadeRatio = fadeRatio;
            return _this;
        }
        Object.defineProperty(NearDirectionalShadowMapper.prototype, "assetType", {
            /**
             * @inheritDoc
             */
            get: function () {
                return NearDirectionalShadowMapper.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NearDirectionalShadowMapper.prototype, "coverageRatio", {
            /**
             * A value between 0 and 1 to indicate the ratio of the view frustum that needs to be covered by the shadow map.
             */
            get: function () {
                return this._coverageRatio;
            },
            set: function (value) {
                if (value > 1)
                    value = 1;
                else if (value < 0)
                    value = 0;
                this._coverageRatio = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NearDirectionalShadowMapper.prototype, "fadeRatio", {
            /**
             * The amount of shadow fading to the outer shadow area. A value of 1 would mean the shadows start fading from the camera's near plane.
             */
            get: function () {
                return this._fadeRatio;
            },
            set: function (value) {
                this._fadeRatio = value;
            },
            enumerable: true,
            configurable: true
        });
        NearDirectionalShadowMapper.prototype._updateProjection = function (projection) {
            var corners = projection.viewFrustumCorners;
            for (var i = 0; i < 12; ++i) {
                var v = corners[i];
                this._localFrustum[i] = v;
                this._localFrustum[i + 12] = v + (corners[i + 12] - v) * this._coverageRatio;
            }
            this._updateProjectionFromFrustumCorners(projection, this._localFrustum, this._matrix);
            this._overallDepthProjection.frustumMatrix3D = this._matrix;
        };
        NearDirectionalShadowMapper.assetType = "[asset NearDirectionalShadowMapper]";
        return NearDirectionalShadowMapper;
    }(DirectionalShadowMapper));
    // TODO: shadow mappers references in materials should be an interface so that this class should NOT extend ShadowMapMethodBase just for some delegation work
    /**
     * ShadowNearChunk provides a shadow map method that restricts the shadowed area near the camera to optimize
     * shadow map usage. This method needs to be used in conjunction with a NearDirectionalShadowMapper.
     *
     * @see away.lights.NearDirectionalShadowMapper
     */
    var _Shader_NearDirectionalShadowMapper = /** @class */ (function (_super) {
        __extends$7(_Shader_NearDirectionalShadowMapper, _super);
        function _Shader_NearDirectionalShadowMapper() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @inheritDoc
         */
        _Shader_NearDirectionalShadowMapper.prototype._initConstants = function () {
            _super.prototype._initConstants.call(this);
            var fragmentData = this._shader.fragmentConstantData;
            var index = this._fragmentDistanceIndex;
            fragmentData[index + 2] = 0;
            fragmentData[index + 3] = 1;
        };
        /**
         * @inheritDoc
         */
        _Shader_NearDirectionalShadowMapper.prototype._initVO = function (chunkVO) {
            _super.prototype._initVO.call(this, chunkVO);
            chunkVO.needsProjection = true;
        };
        /**
         * @inheritDoc
         */
        _Shader_NearDirectionalShadowMapper.prototype._getFragmentCode = function (targetReg, registerCache, sharedRegisters) {
            var code = _super.prototype._getFragmentCode.call(this, targetReg, registerCache, sharedRegisters);
            var dataReg = registerCache.getFreeFragmentConstant();
            var temp = registerCache.getFreeFragmentSingleTemp();
            this._fragmentDistanceIndex = dataReg.index * 4;
            code += "abs " + temp + ", " + sharedRegisters.projectionFragment + ".w\n" +
                "sub " + temp + ", " + temp + ", " + dataReg + ".x\n" +
                "mul " + temp + ", " + temp + ", " + dataReg + ".y\n" +
                "sat " + temp + ", " + temp + "\n" +
                "sub " + temp + ", " + dataReg + ".w," + temp + "\n" +
                "sub " + targetReg + ".w, " + dataReg + ".w," + targetReg + ".w\n" +
                "mul " + targetReg + ".w, " + targetReg + ".w, " + temp + "\n" +
                "sub " + targetReg + ".w, " + dataReg + ".w," + targetReg + ".w\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        _Shader_NearDirectionalShadowMapper.prototype._setRenderState = function (renderState, view) {
            // todo: move this to activate (needs camera)
            var near = view.projection.near;
            var d = view.projection.far - near;
            var maxDistance = this._mapper.coverageRatio;
            var minDistance = maxDistance * (1 - this._mapper.fadeRatio);
            maxDistance = near + maxDistance * d;
            minDistance = near + minDistance * d;
            var fragmentData = this._shader.fragmentConstantData;
            var index = this._fragmentDistanceIndex;
            fragmentData[index] = minDistance;
            fragmentData[index + 1] = 1 / (maxDistance - minDistance);
            _super.prototype._setRenderState.call(this, renderState, view);
        };
        return _Shader_NearDirectionalShadowMapper;
    }(_Shader_DirectionalShadowMapper));
    ShaderBase.registerAbstraction(_Shader_NearDirectionalShadowMapper, NearDirectionalShadowMapper);

    var DepthTexture2D = /** @class */ (function (_super) {
        __extends$7(DepthTexture2D, _super);
        function DepthTexture2D(image) {
            if (image === void 0) { image = null; }
            return _super.call(this, image) || this;
        }
        Object.defineProperty(DepthTexture2D.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return DepthTexture2D.assetType;
            },
            enumerable: true,
            configurable: true
        });
        DepthTexture2D.assetType = "[texture DepthTexture2D]";
        return DepthTexture2D;
    }(ImageTexture2D));
    ShaderBase.registerAbstraction(_Shader_DepthTexture, DepthTexture2D);

    var VideoTexture = /** @class */ (function (_super) {
        __extends$7(VideoTexture, _super);
        function VideoTexture() {
            return _super.call(this) || this;
        }
        Object.defineProperty(VideoTexture.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return VideoTexture.assetType;
            },
            enumerable: true,
            configurable: true
        });
        VideoTexture.assetType = "[texture VideoTexture]";
        return VideoTexture;
    }(ImageTexture2D));

    /**
     * MaterialBase forms an abstract base class for any material.
     * A material consists of several passes, each of which constitutes at least one render call. Several passes could
     * be used for special effects (render lighting for many lights in several passes, render an outline in a separate
     * pass) or to provide additional render-to-texture passes (rendering diffuse light to texture for texture-space
     * subsurface scattering, or rendering a depth map for specialized self-shadowing).
     *
     * Away3D provides default materials trough SinglePassMaterialBase and TriangleMaterial, which use modular
     * methods to build the shader code. MaterialBase can be extended to build specific and high-performant custom
     * shaders, or entire new material frameworks.
    */
    var MaterialBase = /** @class */ (function (_super) {
        __extends$7(MaterialBase, _super);
        function MaterialBase(imageColor, alpha) {
            if (imageColor === void 0) { imageColor = 0xFFFFFF; }
            if (alpha === void 0) { alpha = 1; }
            var _this = _super.call(this) || this;
            _this._textures = new Array();
            _this._pUseColorTransform = false;
            _this._alphaBlending = false;
            _this._alpha = 1;
            _this._pAlphaThreshold = 0;
            _this._pAnimateUVs = false;
            _this._style = new Style();
            _this._iBaseScreenPassIndex = 0;
            _this._bothSides = false; // update
            _this._pBlendMode = BlendMode.NORMAL;
            _this._imageRect = false;
            _this._curves = false;
            _this._onInvalidatePropertiesDelegate = function (event) { return _this._onInvalidateProperties(event); };
            _this._style.addEventListener(StyleEvent.INVALIDATE_PROPERTIES, _this._onInvalidatePropertiesDelegate);
            if (imageColor instanceof ImageBase)
                _this._style.image = imageColor;
            else
                _this._style.color = Number(imageColor);
            _this.alpha = alpha;
            _this._onTextureInvalidateDelegate = function (event) { return _this.onTextureInvalidate(event); };
            _this.alphaPremultiplied = false; //TODO: work out why this is different for WebGL
            return _this;
        }
        Object.defineProperty(MaterialBase.prototype, "alpha", {
            /**
             * The alpha of the surface.
             */
            get: function () {
                return this._alpha;
            },
            set: function (value) {
                if (value > 1)
                    value = 1;
                else if (value < 0)
                    value = 0;
                if (this._alpha == value)
                    return;
                this._alpha = value;
                if (this._colorTransform == null)
                    this._colorTransform = new ColorTransform();
                this._colorTransform.alphaMultiplier = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MaterialBase.prototype, "colorTransform", {
            /**
             * The ColorTransform object to transform the colour of the material with. Defaults to null.
             */
            get: function () {
                return this._colorTransform;
            },
            set: function (value) {
                this._colorTransform = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MaterialBase.prototype, "alphaBlending", {
            /**
             * Indicates whether or not the material has transparency. If binary transparency is sufficient, for
             * example when using textures of foliage, consider using alphaThreshold instead.
             */
            get: function () {
                return this._alphaBlending;
            },
            set: function (value) {
                if (this._alphaBlending == value)
                    return;
                this._alphaBlending = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MaterialBase.prototype, "curves", {
            /**
             * Indicates whether material should use curves. Defaults to false.
             */
            get: function () {
                return this._curves;
            },
            set: function (value) {
                if (this._curves == value)
                    return;
                this._curves = value;
                this.invalidatePasses();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MaterialBase.prototype, "imageRect", {
            /**
             * Indicates whether or not any used textures should use an atlas. Defaults to false.
             */
            get: function () {
                return this._imageRect;
            },
            set: function (value) {
                if (this._imageRect == value)
                    return;
                this._imageRect = value;
                this.invalidatePasses();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MaterialBase.prototype, "style", {
            /**
             * The style used to render the current TriangleGraphic. If set to null, its parent Sprite's style will be used instead.
             */
            get: function () {
                return this._style;
            },
            set: function (value) {
                if (this._style == value)
                    return;
                if (this._style)
                    this._style.removeEventListener(StyleEvent.INVALIDATE_PROPERTIES, this._onInvalidatePropertiesDelegate);
                this._style = value;
                if (this._style)
                    this._style.addEventListener(StyleEvent.INVALIDATE_PROPERTIES, this._onInvalidatePropertiesDelegate);
                this.invalidatePasses();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MaterialBase.prototype, "animateUVs", {
            /**
             * Specifies whether or not the UV coordinates should be animated using a transformation matrix.
             */
            get: function () {
                return this._pAnimateUVs;
            },
            set: function (value) {
                if (this._pAnimateUVs == value)
                    return;
                this._pAnimateUVs = value;
                this.invalidatePasses();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MaterialBase.prototype, "useColorTransform", {
            /**
             * Specifies whether or not the UV coordinates should be animated using a transformation matrix.
             */
            get: function () {
                return this._pUseColorTransform;
            },
            set: function (value) {
                if (this._pUseColorTransform == value)
                    return;
                this._pUseColorTransform = value;
                this.invalidatePasses();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MaterialBase.prototype, "bothSides", {
            /**
             * Defines whether or not the material should cull triangles facing away from the camera.
             */
            get: function () {
                return this._bothSides;
            },
            set: function (value) {
                if (this._bothSides = value)
                    return;
                this._bothSides = value;
                this.invalidatePasses();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MaterialBase.prototype, "blendMode", {
            /**
             * The blend mode to use when drawing this renderable. The following blend modes are supported:
             * <ul>
             * <li>BlendMode.NORMAL: No blending, unless the material inherently needs it</li>
             * <li>BlendMode.LAYER: Force blending. This will draw the object the same as NORMAL, but without writing depth writes.</li>
             * <li>BlendMode.MULTIPLY</li>
             * <li>BlendMode.ADD</li>
             * <li>BlendMode.ALPHA</li>
             * </ul>
             */
            get: function () {
                return this._pBlendMode;
            },
            set: function (value) {
                if (this._pBlendMode == value)
                    return;
                this._pBlendMode = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MaterialBase.prototype, "alphaPremultiplied", {
            /**
             * Indicates whether visible textures (or other pixels) used by this material have
             * already been premultiplied. Toggle this if you are seeing black halos around your
             * blended alpha edges.
             */
            get: function () {
                return this._alphaPremultiplied;
            },
            set: function (value) {
                if (this._alphaPremultiplied == value)
                    return;
                this._alphaPremultiplied = value;
                this.invalidatePasses();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MaterialBase.prototype, "alphaThreshold", {
            /**
             * The minimum alpha value for which pixels should be drawn. This is used for transparency that is either
             * invisible or entirely opaque, often used with textures for foliage, etc.
             * Recommended values are 0 to disable alpha, or 0.5 to create smooth edges. Default value is 0 (disabled).
             */
            get: function () {
                return this._pAlphaThreshold;
            },
            set: function (value) {
                if (value < 0)
                    value = 0;
                else if (value > 1)
                    value = 1;
                if (this._pAlphaThreshold == value)
                    return;
                this._pAlphaThreshold = value;
                this.invalidatePasses();
            },
            enumerable: true,
            configurable: true
        });
        MaterialBase.prototype.getNumTextures = function () {
            return this._textures.length;
        };
        MaterialBase.prototype.getTextureAt = function (index) {
            return this._textures[index];
        };
        MaterialBase.prototype.dispose = function () {
            this.clear();
        };
        /**
         * Marks the shader programs for all passes as invalid, so they will be recompiled before the next use.
         *
         * @private
         */
        MaterialBase.prototype.invalidatePasses = function () {
            this.dispatchEvent(new MaterialEvent(MaterialEvent.INVALIDATE_PASSES, this));
        };
        MaterialBase.prototype.invalidateTextures = function () {
            this.dispatchEvent(new MaterialEvent(MaterialEvent.INVALIDATE_TEXTURES, this));
        };
        MaterialBase.prototype.addTextureAt = function (texture, index) {
            var i = this._textures.indexOf(texture);
            if (i == index)
                return;
            else if (i != -1)
                this._textures.splice(i, 1);
            this._textures.splice(index, 0, texture);
            texture.addEventListener(AssetEvent.INVALIDATE, this._onTextureInvalidateDelegate);
            this.onTextureInvalidate();
        };
        MaterialBase.prototype.addTexture = function (texture) {
            if (this._textures.indexOf(texture) != -1)
                return;
            this._textures.push(texture);
            texture.addEventListener(AssetEvent.INVALIDATE, this._onTextureInvalidateDelegate);
            this.onTextureInvalidate();
        };
        MaterialBase.prototype.removeTexture = function (texture) {
            this._textures.splice(this._textures.indexOf(texture), 1);
            texture.removeEventListener(AssetEvent.INVALIDATE, this._onTextureInvalidateDelegate);
            this.onTextureInvalidate();
        };
        MaterialBase.prototype.onTextureInvalidate = function (event) {
            if (event === void 0) { event = null; }
            this.invalidatePasses();
            this.invalidateTextures();
        };
        MaterialBase.prototype._onInvalidateProperties = function (event) {
            this.invalidatePasses();
            this.invalidateTextures();
        };
        return MaterialBase;
    }(AssetBase));
    /**
     * _Render_MaterialPassBase provides an abstract base class for material shader passes. A material pass constitutes at least
     * a render call per required renderable.
     */
    var _Render_MaterialPassBase = /** @class */ (function (_super) {
        __extends$7(_Render_MaterialPassBase, _super);
        function _Render_MaterialPassBase() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(_Render_MaterialPassBase.prototype, "shader", {
            get: function () {
                return this._shader;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MaterialPassBase.prototype, "numUsedStreams", {
            get: function () {
                return this._shader.numUsedStreams;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MaterialPassBase.prototype, "numUsedTextures", {
            get: function () {
                return this._shader.numUsedTextures;
            },
            enumerable: true,
            configurable: true
        });
        _Render_MaterialPassBase.prototype._includeDependencies = function (shader) {
            shader.alphaThreshold = this._material.alphaThreshold;
            shader.useImageRect = this._material.imageRect;
            shader.usesCurves = this._material.curves;
            shader.useAlphaPremultiplied = this._material.alphaPremultiplied;
            shader.useBothSides = this._material.bothSides;
            shader.usesUVTransform = this._material.animateUVs;
            shader.usesColorTransform = this._material.useColorTransform;
        };
        /**
         * Marks the shader program as invalid, so it will be recompiled before the next render.
         */
        _Render_MaterialPassBase.prototype.invalidate = function () {
            this._shader.invalidateProgram();
            this.dispatchEvent(new PassEvent(PassEvent.INVALIDATE, this));
        };
        _Render_MaterialPassBase.prototype.dispose = function () {
            if (this._shader) {
                this._shader.dispose();
                this._shader = null;
            }
        };
        /**
         * Renders the current pass. Before calling pass, activatePass needs to be called with the same index.
         * @param pass The pass used to render the renderable.
         * @param renderable The IRenderable object to draw.
         * @param stage The Stage object used for rendering.
         * @param entityCollector The EntityCollector object that contains the visible scene data.
         * @param viewProjection The view-projection matrix used to project to the screen. This is not the same as
         * camera.viewProjection as it includes the scaling factors when rendering to textures.
         *
         * @internal
         */
        _Render_MaterialPassBase.prototype._setRenderState = function (renderState, view) {
            this._shader._setRenderState(renderState, view.projection);
        };
        /**
         * Sets the render state for the pass that is independent of the rendered object. This needs to be called before
         * calling pass. Before activating a pass, the previously used pass needs to be deactivated.
         * @param stage The Stage object which is currently used for rendering.
         * @param camera The camera from which the scene is viewed.
         * @private
         */
        _Render_MaterialPassBase.prototype._activate = function (view) {
            this._shader._activate(view.projection);
        };
        /**
         * Clears the render state for the pass. This needs to be called before activating another pass.
         * @param stage The Stage used for rendering
         *
         * @private
         */
        _Render_MaterialPassBase.prototype._deactivate = function () {
            this._shader._deactivate();
        };
        _Render_MaterialPassBase.prototype._initConstantData = function () {
        };
        _Render_MaterialPassBase.prototype._getVertexCode = function (registerCache, sharedRegisters) {
            return "";
        };
        _Render_MaterialPassBase.prototype._getFragmentCode = function (registerCache, sharedRegisters) {
            return "";
        };
        _Render_MaterialPassBase.prototype._getPostAnimationFragmentCode = function (registerCache, sharedRegisters) {
            return "";
        };
        _Render_MaterialPassBase.prototype._getNormalVertexCode = function (registerCache, sharedRegisters) {
            return "";
        };
        _Render_MaterialPassBase.prototype._getNormalFragmentCode = function (registerCache, sharedRegisters) {
            return "";
        };
        return _Render_MaterialPassBase;
    }(_Render_MaterialBase));
    /**
     * _Render_DepthMaterial forms an abstract base class for the default shaded materials provided by Stage,
     * using material methods to define their appearance.
     */
    var _Render_DepthMaterial = /** @class */ (function (_super) {
        __extends$7(_Render_DepthMaterial, _super);
        /**
         *
         * @param pool
         * @param surface
         * @param elementsClass
         * @param stage
         */
        function _Render_DepthMaterial(material, renderElements) {
            var _this = _super.call(this, material, renderElements) || this;
            _this._shader = new ShaderBase(renderElements, _this, _this, _this._stage);
            _this._pAddPass(_this);
            _this.invalidate();
            return _this;
        }
        _Render_DepthMaterial.prototype.invalidate = function () {
            _super.prototype.invalidate.call(this);
            this._shaderTexture = this._material.getTextureAt(0) ? this._shader.getAbstraction(this._material.getTextureAt(0)) : null;
        };
        _Render_DepthMaterial.prototype._includeDependencies = function (shader) {
            _super.prototype._includeDependencies.call(this, shader);
            shader.projectionDependencies++;
            if (shader.alphaThreshold > 0)
                shader.uvDependencies++;
        };
        _Render_DepthMaterial.prototype._initConstantData = function () {
            var index = this._fragmentConstantsIndex;
            var data = this._shader.fragmentConstantData;
            data[index] = 1.0;
            data[index + 1] = 255.0;
            data[index + 2] = 65025.0;
            data[index + 3] = 16581375.0;
            data[index + 4] = 1.0 / 255.0;
            data[index + 5] = 1.0 / 255.0;
            data[index + 6] = 1.0 / 255.0;
            data[index + 7] = 0.0;
        };
        /**
         * @inheritDoc
         */
        _Render_DepthMaterial.prototype._getFragmentCode = function (registerCache, sharedRegisters) {
            var code = "";
            var targetReg = sharedRegisters.shadedTarget;
            var dataReg1 = registerCache.getFreeFragmentConstant();
            var dataReg2 = registerCache.getFreeFragmentConstant();
            this._fragmentConstantsIndex = dataReg1.index * 4;
            var temp1 = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp1, 1);
            var temp2 = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp2, 1);
            code += "div " + temp1 + ", " + sharedRegisters.projectionFragment + ", " + sharedRegisters.projectionFragment + ".w\n" + //"sub ft2.z, fc0.x, ft2.z\n" +    //invert
                "mul " + temp1 + ", " + dataReg1 + ", " + temp1 + ".z\n" +
                "frc " + temp1 + ", " + temp1 + "\n" +
                "mul " + temp2 + ", " + temp1 + ".yzww, " + dataReg2 + "\n";
            //codeF += "mov ft1.w, fc1.w	\n" +
            //    "mov ft0.w, fc0.x	\n";
            if (this._shaderTexture && this._shader.alphaThreshold > 0) {
                var albedo = registerCache.getFreeFragmentVectorTemp();
                code += this._shaderTexture._getFragmentCode(albedo, registerCache, sharedRegisters, sharedRegisters.uvVarying);
                var cutOffReg = registerCache.getFreeFragmentConstant();
                code += "sub " + albedo + ".w, " + albedo + ".w, " + cutOffReg + ".x\n" +
                    "kil " + albedo + ".w\n";
            }
            code += "sub " + targetReg + ", " + temp1 + ", " + temp2 + "\n";
            //DEBUG OPTION: MAKE DEPTHTEXTURES VISIBLE
            //code += "sub " + targetReg + ".xyz, " + temp1 + ".xyz, " + temp2 + ".xyz\n";
            //code += "mov " + targetReg + ".w, " + dataReg1 + ".x\n";
            registerCache.removeFragmentTempUsage(temp1);
            registerCache.removeFragmentTempUsage(temp2);
            return code;
        };
        /**
         * @inheritDoc
         */
        _Render_DepthMaterial.prototype._activate = function (view) {
            _super.prototype._activate.call(this, view);
            if (this._shaderTexture && this._shader.alphaThreshold > 0) {
                this._shaderTexture.activate();
                this._shader.fragmentConstantData[this._fragmentConstantsIndex + 8] = this._shader.alphaThreshold;
            }
        };
        return _Render_DepthMaterial;
    }(_Render_MaterialPassBase));
    /**
     * DistanceRender is a pass that writes distance values to a depth map as a 32-bit value exploded over the 4 texture channels.
     * This is used to render omnidirectional shadow maps.
     */
    var _Render_DistanceMaterial = /** @class */ (function (_super) {
        __extends$7(_Render_DistanceMaterial, _super);
        /**
         * Creates a new DistanceRender object.
         *
         * @param material The material to which this pass belongs.
         */
        function _Render_DistanceMaterial(material, renderElements) {
            var _this = _super.call(this, material, renderElements) || this;
            _this._shader = new ShaderBase(renderElements, _this, _this, _this._stage);
            _this._pAddPass(_this);
            _this.invalidate();
            return _this;
        }
        _Render_DistanceMaterial.prototype.invalidate = function () {
            _super.prototype.invalidate.call(this);
            this._shaderTexture = this._material.getTextureAt(0) ? this._shader.getAbstraction(this._material.getTextureAt(0)) : null;
        };
        /**
         * Initializes the unchanging constant data for this material.
         */
        _Render_DistanceMaterial.prototype._initConstantData = function () {
            var index = this._fragmentConstantsIndex;
            var data = this._shader.fragmentConstantData;
            data[index + 4] = 1.0 / 255.0;
            data[index + 5] = 1.0 / 255.0;
            data[index + 6] = 1.0 / 255.0;
            data[index + 7] = 0.0;
        };
        _Render_DistanceMaterial.prototype._includeDependencies = function (shader) {
            _super.prototype._includeDependencies.call(this, shader);
            shader.projectionDependencies++;
            shader.viewDirDependencies++;
            if (shader.alphaThreshold > 0)
                shader.uvDependencies++;
            if (shader.viewDirDependencies > 0)
                shader.globalPosDependencies++;
        };
        /**
         * @inheritDoc
         */
        _Render_DistanceMaterial.prototype._getFragmentCode = function (registerCache, sharedRegisters) {
            var code;
            var targetReg = sharedRegisters.shadedTarget;
            var dataReg1 = registerCache.getFreeFragmentConstant();
            var dataReg2 = registerCache.getFreeFragmentConstant();
            this._fragmentConstantsIndex = dataReg1.index * 4;
            var temp1 = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp1, 1);
            var temp2 = registerCache.getFreeFragmentVectorTemp();
            registerCache.addFragmentTempUsages(temp2, 1);
            // squared distance to view
            code = "dp3 " + temp1 + ".z, " + sharedRegisters.viewDirVarying + ".xyz, " + sharedRegisters.viewDirVarying + ".xyz\n" +
                "mul " + temp1 + ", " + dataReg1 + ", " + temp1 + ".z\n" +
                "frc " + temp1 + ", " + temp1 + "\n" +
                "mul " + temp2 + ", " + temp1 + ".yzww, " + dataReg2 + "\n";
            if (this._shaderTexture && this._shader.alphaThreshold > 0) {
                var albedo = registerCache.getFreeFragmentVectorTemp();
                code += this._shaderTexture._getFragmentCode(albedo, registerCache, sharedRegisters, sharedRegisters.uvVarying);
                var cutOffReg = registerCache.getFreeFragmentConstant();
                code += "sub " + albedo + ".w, " + albedo + ".w, " + cutOffReg + ".x\n" +
                    "kil " + albedo + ".w\n";
            }
            code += "sub " + targetReg + ", " + temp1 + ", " + temp2 + "\n";
            return code;
        };
        /**
         * @inheritDoc
         */
        _Render_DistanceMaterial.prototype._activate = function (view) {
            _super.prototype._activate.call(this, view);
            var f = view.projection.far;
            f = 1 / (2 * f * f);
            // sqrt(f*f+f*f) is largest possible distance for any frustum, so we need to divide by it. Rarely a tight fit, but with 32 bits precision, it's enough.
            var index = this._fragmentConstantsIndex;
            var data = this._shader.fragmentConstantData;
            data[index] = 1.0 * f;
            data[index + 1] = 255.0 * f;
            data[index + 2] = 65025.0 * f;
            data[index + 3] = 16581375.0 * f;
            if (this._shaderTexture && this._shader.alphaThreshold > 0) {
                this._shaderTexture.activate();
                data[index + 8] = this._shader.alphaThreshold;
            }
        };
        return _Render_DistanceMaterial;
    }(_Render_MaterialPassBase));

    /**
     * BasicMaterial forms an abstract base class for the default shaded materials provided by Stage,
     * using material methods to define their appearance.
     */
    var BasicMaterial = /** @class */ (function (_super) {
        __extends$7(BasicMaterial, _super);
        function BasicMaterial(imageColor, alpha) {
            if (imageColor === void 0) { imageColor = null; }
            if (alpha === void 0) { alpha = 1; }
            var _this = _super.call(this, imageColor, alpha) || this;
            _this._preserveAlpha = false;
            //set a texture if an image is present
            if (imageColor instanceof ImageBase)
                _this.texture = new ImageTexture2D();
            return _this;
        }
        Object.defineProperty(BasicMaterial.prototype, "assetType", {
            /**
             *
             */
            get: function () {
                return BasicMaterial.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BasicMaterial.prototype, "preserveAlpha", {
            /**
             * Indicates whether alpha should be preserved - defaults to false
             */
            get: function () {
                return this._preserveAlpha;
            },
            set: function (value) {
                if (this._preserveAlpha == value)
                    return;
                this._preserveAlpha = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BasicMaterial.prototype, "texture", {
            /**
             * The texture object to use for the albedo colour.
             */
            get: function () {
                return this._texture;
            },
            set: function (value) {
                if (this._texture == value)
                    return;
                if (this._texture)
                    this.removeTexture(this._texture);
                this._texture = value;
                if (this._texture)
                    this.addTexture(this._texture);
            },
            enumerable: true,
            configurable: true
        });
        BasicMaterial.assetType = "[materials BasicMaterial]";
        return BasicMaterial;
    }(MaterialBase));
    /**
     * RenderMaterialObject forms an abstract base class for the default shaded materials provided by Stage,
     * using material methods to define their appearance.
     */
    var _Render_BasicMaterial = /** @class */ (function (_super) {
        __extends$7(_Render_BasicMaterial, _super);
        function _Render_BasicMaterial(material, renderElements) {
            var _this = _super.call(this, material, renderElements) || this;
            _this._basicMaterial = material;
            _this._pAddPass(_this._pass = new BasicMaterialPass(_this, renderElements));
            return _this;
        }
        _Render_BasicMaterial.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            this._basicMaterial = null;
        };
        /**
         * @inheritDoc
         */
        _Render_BasicMaterial.prototype._pUpdateRender = function () {
            _super.prototype._pUpdateRender.call(this);
            this.requiresBlending = (this._basicMaterial.blendMode != BlendMode.NORMAL || this._basicMaterial.alphaBlending || (this._basicMaterial.colorTransform && this._basicMaterial.colorTransform.alphaMultiplier < 1));
            this._pass.preserveAlpha = this._basicMaterial.preserveAlpha; //this._pRequiresBlending;
            this._pass.shader.setBlendMode((this._basicMaterial.blendMode == BlendMode.NORMAL && this.requiresBlending) ? BlendMode.LAYER : this._basicMaterial.blendMode);
            //this._pass.forceSeparateMVP = false;
        };
        return _Render_BasicMaterial;
    }(_Render_MaterialBase));
    RenderGroup.registerDefaultMaterial(_Render_BasicMaterial, BasicMaterial);
    RenderGroup.registerDepthMaterial(_Render_DepthMaterial, BasicMaterial);
    RenderGroup.registerDistanceMaterial(_Render_DistanceMaterial, BasicMaterial);
    MaterialUtils.setDefaultMaterialClass(BasicMaterial);

    var MethodMaterialMode = /** @class */ (function () {
        function MethodMaterialMode() {
        }
        /**
         *
         */
        MethodMaterialMode.SINGLE_PASS = "singlePass";
        /**
         *
         */
        MethodMaterialMode.MULTI_PASS = "multiPass";
        return MethodMaterialMode;
    }());

    /**
     * MethodMaterial forms an abstract base class for the default shaded materials provided by Stage,
     * using material methods to define their appearance.
     */
    var MethodMaterial = /** @class */ (function (_super) {
        __extends$7(MethodMaterial, _super);
        function MethodMaterial(imageColor, alpha) {
            if (imageColor === void 0) { imageColor = 0xFFFFFF; }
            if (alpha === void 0) { alpha = 1; }
            var _this = _super.call(this, imageColor, alpha) || this;
            _this._effectMethods = new Array();
            _this._enableLightFallOff = true;
            _this._specularLightSources = 0x01;
            _this._diffuseLightSources = 0x03;
            _this._ambientMethod = new AmbientBasicMethod();
            _this._diffuseMethod = new DiffuseBasicMethod();
            _this._normalMethod = new NormalBasicMethod();
            _this._specularMethod = new SpecularBasicMethod();
            _this._depthCompareMode = ContextGLCompareMode.LESS_EQUAL;
            _this._mode = MethodMaterialMode.SINGLE_PASS;
            //add default methods owners
            _this._ambientMethod.iAddOwner(_this);
            _this._diffuseMethod.iAddOwner(_this);
            _this._normalMethod.iAddOwner(_this);
            _this._specularMethod.iAddOwner(_this);
            _this._onLightChangeDelegate = function (event) { return _this.onLightsChange(event); };
            //set a texture if an image is present
            if (imageColor instanceof ImageBase)
                _this._ambientMethod.texture = new ImageTexture2D();
            return _this;
        }
        Object.defineProperty(MethodMaterial.prototype, "assetType", {
            /**
             *
             */
            get: function () {
                return MethodMaterial.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodMaterial.prototype, "lightPicker", {
            /**
             * The light picker used by the material to provide lights to the material if it supports lighting.
             *
             * @see LightPickerBase
             * @see StaticLightPicker
             */
            get: function () {
                return this._pLightPicker;
            },
            set: function (value) {
                if (this._pLightPicker == value)
                    return;
                if (this._pLightPicker)
                    this._pLightPicker.removeEventListener(AssetEvent.INVALIDATE, this._onLightChangeDelegate);
                this._pLightPicker = value;
                if (this._pLightPicker)
                    this._pLightPicker.addEventListener(AssetEvent.INVALIDATE, this._onLightChangeDelegate);
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodMaterial.prototype, "enableLightFallOff", {
            /**
             * Whether or not to use fallOff and radius properties for lights. This can be used to improve performance and
             * compatibility for constrained mode.
             */
            get: function () {
                return this._enableLightFallOff;
            },
            set: function (value) {
                if (this._enableLightFallOff == value)
                    return;
                this._enableLightFallOff = value;
                this.invalidatePasses();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodMaterial.prototype, "diffuseLightSources", {
            /**
             * Define which light source types to use for diffuse reflections. This allows choosing between regular lights
             * and/or light probes for diffuse reflections.
             *
             * @see away3d.materials.LightSources
             */
            get: function () {
                return this._diffuseLightSources;
            },
            set: function (value) {
                if (this._diffuseLightSources == value)
                    return;
                this._diffuseLightSources = value;
                this.invalidatePasses();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodMaterial.prototype, "specularLightSources", {
            /**
             * Define which light source types to use for specular reflections. This allows choosing between regular lights
             * and/or light probes for specular reflections.
             *
             * @see away3d.materials.LightSources
             */
            get: function () {
                return this._specularLightSources;
            },
            set: function (value) {
                if (this._specularLightSources == value)
                    return;
                this._specularLightSources = value;
                this.invalidatePasses();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodMaterial.prototype, "mode", {
            get: function () {
                return this._mode;
            },
            set: function (value) {
                if (this._mode == value)
                    return;
                this._mode = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodMaterial.prototype, "depthCompareMode", {
            /**
             * The depth compare mode used to render the renderables using this material.
             *
             * @see away.stagegl.ContextGLCompareMode
             */
            get: function () {
                return this._depthCompareMode;
            },
            set: function (value) {
                if (this._depthCompareMode == value)
                    return;
                this._depthCompareMode = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodMaterial.prototype, "ambientMethod", {
            /**
             * The method that provides the ambient lighting contribution. Defaults to AmbientBasicMethod.
             */
            get: function () {
                return this._ambientMethod;
            },
            set: function (value) {
                if (this._ambientMethod == value)
                    return;
                if (this._ambientMethod)
                    this._ambientMethod.iRemoveOwner(this);
                this._ambientMethod = value;
                if (this._ambientMethod)
                    this._ambientMethod.iAddOwner(this);
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodMaterial.prototype, "shadowMethod", {
            /**
             * The method used to render shadows cast on this surface, or null if no shadows are to be rendered. Defaults to null.
             */
            get: function () {
                return this._shadowMethod;
            },
            set: function (value) {
                if (this._shadowMethod == value)
                    return;
                if (this._shadowMethod)
                    this._shadowMethod.iRemoveOwner(this);
                this._shadowMethod = value;
                if (this._shadowMethod)
                    this._shadowMethod.iAddOwner(this);
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodMaterial.prototype, "diffuseMethod", {
            /**
             * The method that provides the diffuse lighting contribution. Defaults to DiffuseBasicMethod.
             */
            get: function () {
                return this._diffuseMethod;
            },
            set: function (value) {
                if (this._diffuseMethod == value)
                    return;
                if (this._diffuseMethod)
                    this._diffuseMethod.iRemoveOwner(this);
                this._diffuseMethod = value;
                if (this._diffuseMethod)
                    this._diffuseMethod.iAddOwner(this);
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodMaterial.prototype, "specularMethod", {
            /**
             * The method that provides the specular lighting contribution. Defaults to SpecularBasicMethod.
             */
            get: function () {
                return this._specularMethod;
            },
            set: function (value) {
                if (this._specularMethod == value)
                    return;
                if (this._specularMethod)
                    this._specularMethod.iRemoveOwner(this);
                this._specularMethod = value;
                if (this._specularMethod)
                    this._specularMethod.iAddOwner(this);
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodMaterial.prototype, "normalMethod", {
            /**
             * The method used to generate the per-pixel normals. Defaults to NormalBasicMethod.
             */
            get: function () {
                return this._normalMethod;
            },
            set: function (value) {
                if (this._normalMethod == value)
                    return;
                if (this._normalMethod)
                    this._normalMethod.iRemoveOwner(this);
                this._normalMethod = value;
                if (this._normalMethod)
                    this._normalMethod.iAddOwner(this);
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MethodMaterial.prototype, "numEffectMethods", {
            get: function () {
                return this._effectMethods.length;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Appends an "effect" shading method to the shader. Effect methods are those that do not influence the lighting
         * but modulate the shaded colour, used for fog, outlines, etc. The method will be applied to the result of the
         * methods added prior.
         */
        MethodMaterial.prototype.addEffectMethod = function (method) {
            method.iAddOwner(this);
            this._effectMethods.push(method);
            this.invalidate();
        };
        /**
         * Returns the method added at the given index.
         * @param index The index of the method to retrieve.
         * @return The method at the given index.
         */
        MethodMaterial.prototype.getEffectMethodAt = function (index) {
            return this._effectMethods[index];
        };
        /**
         * Adds an effect method at the specified index amongst the methods already added to the material. Effect
         * methods are those that do not influence the lighting but modulate the shaded colour, used for fog, outlines,
         * etc. The method will be applied to the result of the methods with a lower index.
         */
        MethodMaterial.prototype.addEffectMethodAt = function (method, index) {
            method.iAddOwner(this);
            this._effectMethods.splice(index, 0, method);
            this.invalidate();
        };
        /**
         * Removes an effect method from the material.
         * @param method The method to be removed.
         */
        MethodMaterial.prototype.removeEffectMethod = function (method) {
            method.iRemoveOwner(this);
            this._effectMethods.splice(this._effectMethods.indexOf(method), 1);
            this.invalidate();
        };
        /**
         * Called when the light picker's configuration changed.
         */
        MethodMaterial.prototype.onLightsChange = function (event) {
            this.invalidate();
        };
        MethodMaterial.assetType = "[materials MethodMaterial]";
        return MethodMaterial;
    }(MaterialBase));
    /**
     * CompiledPass forms an abstract base class for the default compiled pass materials provided by Away3D,
     * using material methods to define their appearance.
     */
    var _Render_MethodMaterial = /** @class */ (function (_super) {
        __extends$7(_Render_MethodMaterial, _super);
        /**
         * Creates a new CompiledPass object.
         *
         * @param material The material to which this pass belongs.
         */
        function _Render_MethodMaterial(material, renderElements) {
            var _this = _super.call(this, material, renderElements) || this;
            _this._methodMaterial = material;
            _this._renderElements = renderElements;
            return _this;
        }
        Object.defineProperty(_Render_MethodMaterial.prototype, "numLights", {
            /**
             * The maximum total number of lights provided by the light picker.
             */
            get: function () {
                return this._methodMaterial.lightPicker ? this._methodMaterial.lightPicker.numLightProbes + this._methodMaterial.lightPicker.numDirectionalLights + this._methodMaterial.lightPicker.numPointLights + this._methodMaterial.lightPicker.numCastingDirectionalLights + this._methodMaterial.lightPicker.numCastingPointLights : 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MethodMaterial.prototype, "numNonCasters", {
            /**
             * The amount of lights that don't cast shadows.
             */
            get: function () {
                return this._methodMaterial.lightPicker ? this._methodMaterial.lightPicker.numLightProbes + this._methodMaterial.lightPicker.numDirectionalLights + this._methodMaterial.lightPicker.numPointLights : 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MethodMaterial.prototype, "lightPicker", {
            get: function () {
                return this._methodMaterial.lightPicker;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MethodMaterial.prototype, "enableLightFallOff", {
            /**
             * Whether or not to use fallOff and radius properties for lights. This can be used to improve performance and
             * compatibility for constrained mode.
             */
            get: function () {
                return this._methodMaterial.enableLightFallOff;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MethodMaterial.prototype, "diffuseLightSources", {
            /**
             * Define which light source types to use for diffuse reflections. This allows choosing between regular lights
             * and/or light probes for diffuse reflections.
             *
             * @see away3d.materials.LightSources
             */
            get: function () {
                return this._methodMaterial.diffuseLightSources;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(_Render_MethodMaterial.prototype, "specularLightSources", {
            /**
             * Define which light source types to use for specular reflections. This allows choosing between regular lights
             * and/or light probes for specular reflections.
             *
             * @see away3d.materials.LightSources
             */
            get: function () {
                return this._methodMaterial.specularLightSources;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        _Render_MethodMaterial.prototype._pUpdateRender = function () {
            _super.prototype._pUpdateRender.call(this);
            this.initPasses();
            this.setBlendAndCompareModes();
            this._pClearPasses();
            if (this._methodMaterial.mode == MethodMaterialMode.MULTI_PASS) {
                if (this._casterLightPass)
                    this._pAddPass(this._casterLightPass);
                if (this._nonCasterLightPasses)
                    for (var i = 0; i < this._nonCasterLightPasses.length; ++i)
                        this._pAddPass(this._nonCasterLightPasses[i]);
            }
            if (this._pass)
                this._pAddPass(this._pass);
        };
        /**
         * Initializes all the passes and their dependent passes.
         */
        _Render_MethodMaterial.prototype.initPasses = function () {
            // let the effects pass handle everything if there are no lights, when there are effect methods applied
            // after shading, or when the material mode is single pass.
            if (this.numLights == 0 || this._methodMaterial.numEffectMethods > 0 || this._methodMaterial.mode == MethodMaterialMode.SINGLE_PASS)
                this.initEffectPass();
            else if (this._pass)
                this.removeEffectPass();
            // only use a caster light pass if shadows need to be rendered
            if (this._methodMaterial.shadowMethod && this._methodMaterial.mode == MethodMaterialMode.MULTI_PASS)
                this.initCasterLightPass();
            else if (this._casterLightPass)
                this.removeCasterLightPass();
            // only use non caster light passes if there are lights that don't cast
            if (this.numNonCasters > 0 && this._methodMaterial.mode == MethodMaterialMode.MULTI_PASS)
                this.initNonCasterLightPasses();
            else if (this._nonCasterLightPasses)
                this.removeNonCasterLightPasses();
        };
        /**
         * Sets up the various blending modes for all screen passes, based on whether or not there are previous passes.
         */
        _Render_MethodMaterial.prototype.setBlendAndCompareModes = function () {
            var forceSeparateMVP = Boolean(this._casterLightPass || this._pass);
            // caster light pass is always first if it exists, hence it uses normal blending
            if (this._casterLightPass) {
                this._casterLightPass.forceSeparateMVP = forceSeparateMVP;
                this._casterLightPass.shader.setBlendMode(BlendMode.NORMAL);
                this._casterLightPass.shader.depthCompareMode = this._methodMaterial.depthCompareMode;
            }
            if (this._nonCasterLightPasses) {
                var firstAdditiveIndex = 0;
                // if there's no caster light pass, the first non caster light pass will be the first
                // and should use normal blending
                if (!this._casterLightPass) {
                    this._nonCasterLightPasses[0].forceSeparateMVP = forceSeparateMVP;
                    this._nonCasterLightPasses[0].shader.setBlendMode(BlendMode.NORMAL);
                    this._nonCasterLightPasses[0].shader.depthCompareMode = this._methodMaterial.depthCompareMode;
                    firstAdditiveIndex = 1;
                }
                // all lighting passes following the first light pass should use additive blending
                for (var i = firstAdditiveIndex; i < this._nonCasterLightPasses.length; ++i) {
                    this._nonCasterLightPasses[i].forceSeparateMVP = forceSeparateMVP;
                    this._nonCasterLightPasses[i].shader.setBlendMode(BlendMode.ADD);
                    this._nonCasterLightPasses[i].shader.depthCompareMode = ContextGLCompareMode.LESS_EQUAL;
                }
            }
            if (this._casterLightPass || this._nonCasterLightPasses) {
                //cannot be blended by blendmode property if multipass enabled
                this.requiresBlending = false;
                // there are light passes, so this should be blended in
                if (this._pass) {
                    this._pass.mode = MethodPassMode.EFFECTS;
                    this._pass.forceSeparateMVP = forceSeparateMVP;
                    this._pass.shader.depthCompareMode = ContextGLCompareMode.LESS_EQUAL;
                    this._pass.shader.setBlendMode(BlendMode.LAYER);
                }
            }
            else if (this._pass) {
                this.requiresBlending = (this._methodMaterial.blendMode != BlendMode.NORMAL || this._methodMaterial.alphaBlending || (this._methodMaterial.colorTransform && this._methodMaterial.colorTransform.alphaMultiplier < 1));
                // effects pass is the only pass, so it should just blend normally
                this._pass.mode = MethodPassMode.SUPER_SHADER;
                this._pass.preserveAlpha = this.requiresBlending;
                this._pass.forceSeparateMVP = false;
                this._pass.colorTransform = this._methodMaterial.colorTransform;
                this._pass.shader.setBlendMode((this._methodMaterial.blendMode == BlendMode.NORMAL && this.requiresBlending) ? BlendMode.LAYER : this._methodMaterial.blendMode);
                this._pass.shader.depthCompareMode = this._methodMaterial.depthCompareMode;
            }
        };
        _Render_MethodMaterial.prototype.initCasterLightPass = function () {
            if (this._casterLightPass == null)
                this._casterLightPass = new MethodPass(MethodPassMode.LIGHTING, this, this._renderElements);
            this._casterLightPass.lightPicker = new StaticLightPicker([this._methodMaterial.shadowMethod.castingLight]);
            this._casterLightPass.shadowMethod = this._methodMaterial.shadowMethod;
            this._casterLightPass.diffuseMethod = this._methodMaterial.diffuseMethod;
            this._casterLightPass.ambientMethod = this._methodMaterial.ambientMethod;
            this._casterLightPass.normalMethod = this._methodMaterial.normalMethod;
            this._casterLightPass.specularMethod = this._methodMaterial.specularMethod;
        };
        _Render_MethodMaterial.prototype.removeCasterLightPass = function () {
            this._casterLightPass.dispose();
            this._pRemovePass(this._casterLightPass);
            this._casterLightPass = null;
        };
        _Render_MethodMaterial.prototype.initNonCasterLightPasses = function () {
            this.removeNonCasterLightPasses();
            var pass;
            var numDirLights = this._methodMaterial.lightPicker.numDirectionalLights;
            var numPointLights = this._methodMaterial.lightPicker.numPointLights;
            var numLightProbes = this._methodMaterial.lightPicker.numLightProbes;
            var dirLightOffset = 0;
            var pointLightOffset = 0;
            var probeOffset = 0;
            if (!this._casterLightPass) {
                numDirLights += this._methodMaterial.lightPicker.numCastingDirectionalLights;
                numPointLights += this._methodMaterial.lightPicker.numCastingPointLights;
            }
            this._nonCasterLightPasses = new Array();
            while (dirLightOffset < numDirLights || pointLightOffset < numPointLights || probeOffset < numLightProbes) {
                pass = new MethodPass(MethodPassMode.LIGHTING, this, this._renderElements);
                pass.includeCasters = this._methodMaterial.shadowMethod == null;
                pass.directionalLightsOffset = dirLightOffset;
                pass.pointLightsOffset = pointLightOffset;
                pass.lightProbesOffset = probeOffset;
                pass.lightPicker = this._methodMaterial.lightPicker;
                pass.diffuseMethod = this._methodMaterial.diffuseMethod;
                pass.ambientMethod = this._methodMaterial.ambientMethod;
                pass.normalMethod = this._methodMaterial.normalMethod;
                pass.specularMethod = this._methodMaterial.specularMethod;
                this._nonCasterLightPasses.push(pass);
                dirLightOffset += pass.numDirectionalLights;
                pointLightOffset += pass.numPointLights;
                probeOffset += pass.numLightProbes;
            }
        };
        _Render_MethodMaterial.prototype.removeNonCasterLightPasses = function () {
            if (!this._nonCasterLightPasses)
                return;
            for (var i = 0; i < this._nonCasterLightPasses.length; ++i)
                this._pRemovePass(this._nonCasterLightPasses[i]);
            this._nonCasterLightPasses = null;
        };
        _Render_MethodMaterial.prototype.removeEffectPass = function () {
            if (this._pass.ambientMethod != this._methodMaterial.ambientMethod)
                this._pass.ambientMethod.dispose();
            if (this._pass.diffuseMethod != this._methodMaterial.diffuseMethod)
                this._pass.diffuseMethod.dispose();
            if (this._pass.specularMethod != this._methodMaterial.specularMethod)
                this._pass.specularMethod.dispose();
            if (this._pass.normalMethod != this._methodMaterial.normalMethod)
                this._pass.normalMethod.dispose();
            this._pRemovePass(this._pass);
            this._pass = null;
        };
        _Render_MethodMaterial.prototype.initEffectPass = function () {
            if (this._pass == null)
                this._pass = new MethodPass(MethodPassMode.SUPER_SHADER, this, this._renderElements);
            if (this._methodMaterial.mode == MethodMaterialMode.SINGLE_PASS) {
                this._pass.ambientMethod = this._methodMaterial.ambientMethod;
                this._pass.diffuseMethod = this._methodMaterial.diffuseMethod;
                this._pass.specularMethod = this._methodMaterial.specularMethod;
                this._pass.normalMethod = this._methodMaterial.normalMethod;
                this._pass.shadowMethod = this._methodMaterial.shadowMethod;
            }
            else if (this._methodMaterial.mode == MethodMaterialMode.MULTI_PASS) {
                if (this.numLights == 0) {
                    this._pass.ambientMethod = this._methodMaterial.ambientMethod;
                }
                else {
                    this._pass.ambientMethod = null;
                }
                this._pass.preserveAlpha = false;
                this._pass.normalMethod = this._methodMaterial.normalMethod;
            }
            //update effect methods
            var i = 0;
            var effectMethod;
            var len = Math.max(this._methodMaterial.numEffectMethods, this._pass.numEffectMethods);
            while (i < len) {
                effectMethod = this._methodMaterial.getEffectMethodAt(i);
                if (effectMethod != this._pass.getEffectMethodAt(i)) {
                    this._pass.removeEffectMethodAt(i);
                    if (effectMethod != null) {
                        if (i < this._pass.numEffectMethods)
                            this._pass.addEffectMethodAt(effectMethod, i);
                        else
                            this._pass.addEffectMethod(effectMethod);
                    }
                }
                i++;
            }
        };
        /**
         * @inheritDoc
         */
        _Render_MethodMaterial.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            //TODO
        };
        return _Render_MethodMaterial;
    }(_Render_MaterialBase));
    RenderGroup.registerDefaultMaterial(_Render_MethodMaterial, MethodMaterial);
    RenderGroup.registerDepthMaterial(_Render_DepthMaterial, MethodMaterial);
    RenderGroup.registerDistanceMaterial(_Render_DistanceMaterial, MethodMaterial);

    console.debug("AwayJS - Materials - 0.5.6");

    /**
     * The TextFormat class represents character formatting information. Use the
     * TextFormat class to create specific text formatting for text fields. You
     * can apply text formatting to both static and dynamic text fields. The
     * properties of the TextFormat class apply to device and embedded fonts.
     * However, for embedded fonts, bold and italic text actually require specific
     * fonts. If you want to display bold or italic text with an embedded font,
     * you need to embed the bold and italic variations of that font.
     *
     * <p> You must use the constructor <code>new TextFormat()</code> to create a
     * TextFormat object before setting its properties. When you apply a
     * TextFormat object to a text field using the
     * <code>TextField.defaultTextFormat</code> property or the
     * <code>TextField.setTextFormat()</code> method, only its defined properties
     * are applied. Use the <code>TextField.defaultTextFormat</code> property to
     * apply formatting BEFORE you add text to the <code>TextField</code>, and the
     * <code>setTextFormat()</code> method to add formatting AFTER you add text to
     * the <code>TextField</code>. The TextFormat properties are <code>null</code>
     * by default because if you don't provide values for the properties, Flash
     * Player uses its own default formatting. The default formatting that Flash
     * Player uses for each property(if property's value is <code>null</code>) is
     * as follows:</p>
     *
     * <p>The default formatting for each property is also described in each
     * property description.</p>
     */
    var TesselatedFontChar = /** @class */ (function () {
        function TesselatedFontChar(fill_data, stroke_data, fill_data_path) {
            if (fill_data === void 0) { fill_data = null; }
            if (stroke_data === void 0) { stroke_data = null; }
            if (fill_data_path === void 0) { fill_data_path = null; }
            this.fnt_channel = 0;
            /**
             * the char_codes that this geom has kerning set for
             */
            this.kerningCharCodes = [];
            /**
             * the kerning values per char_code
             */
            this.kerningValues = [];
            this.fill_data = fill_data;
            this.stroke_data = stroke_data;
            this.fill_data_path = fill_data_path;
        }
        TesselatedFontChar.prototype.dispose = function () {
            if (this.stroke_data) {
                //this.stroke_data.dispose();
                this.stroke_data = null;
            }
            if (this.fill_data) {
                //this.fill_data.dispose();
                this.fill_data = null;
            }
            if (this.fill_data_path) {
                //this.fill_data_path.dispose();
                this.fill_data_path = null;
            }
        };
        return TesselatedFontChar;
    }());

    /**
     * The TextFormat class represents character formatting information. Use the
     * TextFormat class to create specific text formatting for text fields. You
     * can apply text formatting to both static and dynamic text fields. The
     * properties of the TextFormat class apply to device and embedded fonts.
     * However, for embedded fonts, bold and italic text actually require specific
     * fonts. If you want to display bold or italic text with an embedded font,
     * you need to embed the bold and italic variations of that font.
     *
     * <p> You must use the constructor <code>new TextFormat()</code> to create a
     * TextFormat object before setting its properties. When you apply a
     * TextFormat object to a text field using the
     * <code>TextField.defaultTextFormat</code> property or the
     * <code>TextField.setTextFormat()</code> method, only its defined properties
     * are applied. Use the <code>TextField.defaultTextFormat</code> property to
     * apply formatting BEFORE you add text to the <code>TextField</code>, and the
     * <code>setTextFormat()</code> method to add formatting AFTER you add text to
     * the <code>TextField</code>. The TextFormat properties are <code>null</code>
     * by default because if you don't provide values for the properties, Flash
     * Player uses its own default formatting. The default formatting that Flash
     * Player uses for each property(if property's value is <code>null</code>) is
     * as follows:</p>
     *
     * <p>The default formatting for each property is also described in each
     * property description.</p>
     */
    var BitmapFontChar = /** @class */ (function () {
        function BitmapFontChar(id, x, y, width, height, xoff, yoff, xadv, page, channel) {
            this.id = id;
            this.x = x;
            this.y = y;
            this.width = width;
            this.height = height;
            this.x_offset = xoff;
            this.y_offset = yoff;
            this.x_advance = xadv;
            this.page = page;
            this.channel = channel;
        }
        return BitmapFontChar;
    }());

    /**
     * GraphicBase wraps a TriangleElements as a scene graph instantiation. A GraphicBase is owned by a Sprite object.
     *
     *
     * @see away.base.TriangleElements
     * @see away.entities.Sprite
     *
     * @class away.base.GraphicBase
     */
    var BitmapFontTable = /** @class */ (function (_super) {
        __extends$3(BitmapFontTable, _super);
        /**
         * Creates a new TesselatedFont object
         */
        function BitmapFontTable() {
            var _this = _super.call(this) || this;
            _this._font_chars = [];
            _this._materials = [];
            _this._font_chars_dic = new Object();
            _this._ascent = 0;
            _this._descent = 0;
            _this._current_size = 0;
            _this._size_multiply = 0;
            _this._init_size = 0;
            _this._texture_width = 0;
            _this._texture_height = 0;
            _this._adjust_size = 0;
            return _this;
        }
        BitmapFontTable.prototype.getGlyphCount = function () {
            return this._font_chars.length;
        };
        Object.defineProperty(BitmapFontTable.prototype, "assetType", {
            get: function () {
                return BitmapFontTable.assetType;
            },
            enumerable: true,
            configurable: true
        });
        BitmapFontTable.prototype.initFontSize = function (font_size) {
            if (this.fallbackTable)
                this.fallbackTable.initFontSize(font_size);
            if (this._adjust_size)
                font_size *= this._adjust_size;
            if (this._current_size == font_size)
                return;
            this._current_size = font_size;
            this._size_multiply = font_size / this._init_size;
        };
        BitmapFontTable.prototype.getCharDataCanvas = function (char_code) {
            var this_char = this._font_chars_dic[char_code];
            if (this_char) {
                //console.log("this_char found");
                return [this_char.x, this_char.y, this_char.width, this_char.height, this_char.x_offset * this._size_multiply, this_char.y_offset * this._size_multiply];
            }
            //console.log("this_char not found" + char_code);
            return [];
        };
        BitmapFontTable.prototype.getCharData = function (char_code) {
            var this_char = this._font_chars_dic[char_code];
            if (this_char) {
                var realheight = (this_char.height / this._init_size) * this._current_size;
                var realWidth = (this_char.width / this._init_size) * this._current_size;
                //console.log("this_char found");
                return [this_char.x / this._texture_width, this_char.y / this._texture_height, this_char.width / this._texture_width, this_char.height / this._texture_height, this_char.x_offset * this._size_multiply, this_char.y_offset * this._size_multiply, realheight, realWidth];
            }
            //console.log("this_char not found" + char_code);
            return [];
        };
        BitmapFontTable.prototype.getCharVertCnt = function (char_code) {
            return 6 * 4;
        };
        Object.defineProperty(BitmapFontTable.prototype, "texture_width", {
            get: function () {
                return this._texture_width;
            },
            set: function (value) {
                this._texture_width = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BitmapFontTable.prototype, "texture_height", {
            get: function () {
                return this._texture_height;
            },
            set: function (value) {
                this._texture_height = value;
            },
            enumerable: true,
            configurable: true
        });
        BitmapFontTable.prototype.hasChar = function (char_code) {
            return this._font_chars_dic[char_code] != null;
        };
        BitmapFontTable.prototype.getCharWidth = function (char_code) {
            var this_char = this._font_chars_dic[char_code];
            if (this_char)
                return this._size_multiply * (this_char.x_advance);
            return 0;
        };
        BitmapFontTable.prototype.fillTextRun = function (tf, format, startWord, wordCnt) {
        };
        BitmapFontTable.prototype.getLineHeight = function () {
            return this._current_size;
        };
        /**
         *
         */
        BitmapFontTable.prototype.dispose = function () {
            var len = this._materials.length;
            for (var i = 0; i < len; ++i) {
                this._materials[i].dispose();
            }
            this._materials.length = 0;
            this._font_chars.length = 0;
            this._font_chars_dic = null;
        };
        BitmapFontTable.prototype.addMaterial = function (material) {
            this._materials.push(material);
        };
        BitmapFontTable.prototype.getMaterial = function (idx) {
            if (idx === void 0) { idx = 0; }
            return this._materials[idx];
        };
        Object.defineProperty(BitmapFontTable.prototype, "ascent", {
            get: function () {
                return this._ascent;
            },
            set: function (value) {
                this._ascent = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BitmapFontTable.prototype, "descent", {
            get: function () {
                return this._descent;
            },
            set: function (value) {
                this._descent = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BitmapFontTable.prototype, "offset_x", {
            get: function () {
                return this._offset_x;
            },
            set: function (value) {
                this._offset_x = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BitmapFontTable.prototype, "offset_y", {
            get: function () {
                return this._offset_y;
            },
            set: function (value) {
                this._offset_y = value;
            },
            enumerable: true,
            configurable: true
        });
        BitmapFontTable.prototype.get_font_chars = function () {
            return this._font_chars;
        };
        BitmapFontTable.prototype.get_font_em_size = function () {
            return this._font_em_size;
        };
        BitmapFontTable.prototype.set_whitespace_width = function (value) {
            this._whitespace_width = value;
        };
        BitmapFontTable.prototype.get_whitespace_width = function () {
            return this._whitespace_width;
        };
        BitmapFontTable.prototype.set_font_em_size = function (font_em_size) {
            this._font_em_size = font_em_size;
        };
        /**
         *
         */
        BitmapFontTable.prototype.getChar = function (name) {
            return this._font_chars_dic[name];
        };
        /**
         *
         */
        BitmapFontTable.prototype.setChar = function (id, x, y, width, height, xoff, yoff, xadv, page, channel) {
            var bitmap_font_char = new BitmapFontChar(id, x, y, width, height, xoff, yoff, xadv, page, channel);
            this._font_chars.push(bitmap_font_char);
            this._font_chars_dic[id] = bitmap_font_char;
        };
        BitmapFontTable.assetType = "[asset BitmapFontTable]";
        return BitmapFontTable;
    }(AssetBase));

    /**
     * Font is a container for FontTables.
     *
     *
     *
     */
    var Font = /** @class */ (function (_super) {
        __extends$3(Font, _super);
        /**
         * Creates a new TesselatedFont object
         */
        function Font() {
            var _this = _super.call(this) || this;
            _this._font_styles = [];
            _this.fontName = null;
            _this.regularFontStyle = null;
            return _this;
        }
        // ------------ dummys for as3web:
        Font.registerFont = function (any) {
        };
        Object.defineProperty(Font.prototype, "font_styles", {
            // ------------
            get: function () {
                return this._font_styles;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Font.prototype, "assetType", {
            /**
             *
             */
            get: function () {
                return Font.assetType;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        Font.prototype.dispose = function () {
            var len = this._font_styles.length;
            for (var i = 0; i < len; ++i) {
                this._font_styles[i].dispose();
            }
            this._font_styles.length = 0;
        };
        Font.prototype.replace_font_table = function (style_name, table) {
            var len = this._font_styles.length;
            for (var i = 0; i < len; ++i) {
                if (this._font_styles[i].name == style_name) {
                    /*if(style_name!=FontStyleName.STANDART){
                        this._font_styles[i].fallbackTable=this.regularFontStyle;
                    }*/
                    this._font_styles[i] = table;
                }
            }
        };
        /**
         *Get a font-table for a specific name, or create one if it does not exists.
         */
        Font.prototype.get_font_table = function (style_name, assetType, openTypeFont, createTable) {
            if (assetType === void 0) { assetType = TesselatedFontTable.assetType; }
            if (openTypeFont === void 0) { openTypeFont = null; }
            if (createTable === void 0) { createTable = true; }
            var len = this._font_styles.length;
            /*if(this.regularFontStyle==null){
                for (var i:number = 0; i < len; ++i) {
                    if((this._font_styles[i].assetType==assetType)&&(this._font_styles[i].name==FontStyleName.STANDART)){
                        this.regularFontStyle=this._font_styles[i];
                    }
                }
            }*/
            //console.log("font name", this.name, style_name);
            for (var i = 0; i < len; ++i) {
                if ((this._font_styles[i].assetType == assetType) && (this._font_styles[i].name == style_name)) {
                    /*if(style_name!=FontStyleName.STANDART){
                        this._font_styles[i].fallbackTable=this.regularFontStyle;
                    }*/
                    return this._font_styles[i];
                }
            }
            if (!createTable)
                return null;
            var font_style = null;
            if (assetType == TesselatedFontTable.assetType) {
                font_style = new TesselatedFontTable(openTypeFont);
            }
            else if (assetType == BitmapFontTable.assetType) {
                font_style = new BitmapFontTable();
            }
            font_style.name = style_name;
            font_style.font = this;
            this._font_styles.push(font_style);
            /*
            if(style_name==FontStyleName.STANDART){
                this.regularFontStyle=font_style;
                for (var i:number = 0; i < len; ++i) {
                    if(this._font_styles[i].name!=FontStyleName.STANDART){
                        this._font_styles[i].fallbackTable=this.regularFontStyle;
                    }
                }
            }
            else{
                font_style.fallbackTable=this.regularFontStyle;
            }
            */
            return font_style;
        };
        Font.assetType = "[asset Font]";
        return Font;
    }(AssetBase));

    var DefaultFontManager = /** @class */ (function () {
        function DefaultFontManager() {
        }
        DefaultFontManager.getDefaultFont = function () {
            if (DefaultFontManager._default_font == null) {
                DefaultFontManager.setDefaultFont();
            }
            return DefaultFontManager._default_font;
        };
        DefaultFontManager.applySharedFonts = function (ns) {
            if (ns == DefaultFontManager.shared_fonts_ns)
                return;
            if (!DefaultFontManager._registered_fonts[ns]) {
                DefaultFontManager._registered_fonts[ns] = {};
            }
            if (!DefaultFontManager._registered_fonts[DefaultFontManager.shared_fonts_ns]) {
                DefaultFontManager._registered_fonts[DefaultFontManager.shared_fonts_ns] = {};
            }
            if (!DefaultFontManager._default_font) {
                if (DefaultFontManager._registered_fonts[DefaultFontManager.shared_fonts_ns]["arial"]) {
                    DefaultFontManager._default_font = DefaultFontManager._registered_fonts[DefaultFontManager.shared_fonts_ns]["arial"];
                }
            }
            var fontsInSharedSWF = DefaultFontManager._registered_fonts[DefaultFontManager.shared_fonts_ns];
            for (var key in fontsInSharedSWF) {
                if (!DefaultFontManager._registered_fonts[ns][key]) {
                    DefaultFontManager._registered_fonts[ns][key] = fontsInSharedSWF[key];
                }
                else {
                    var len = DefaultFontManager._registered_fonts[DefaultFontManager.shared_fonts_ns][key].font_styles.length;
                    for (var i = 0; i < len; i++) {
                        var fontStyle = DefaultFontManager._registered_fonts[DefaultFontManager.shared_fonts_ns][key].font_styles[i];
                        var oldTable = DefaultFontManager._registered_fonts[ns][key].get_font_table(fontStyle.name, TesselatedFontTable.assetType, null, false);
                        if (!oldTable)
                            DefaultFontManager._registered_fonts[ns][key].font_styles.push(fontStyle);
                        else {
                            if (oldTable.getGlyphCount() == 0) {
                                DefaultFontManager._registered_fonts[ns][key].replace_font_table(fontStyle.name, fontStyle);
                            }
                        }
                    }
                }
                if (DefaultFontManager._registered_fonts[ns][key].font) {
                    DefaultFontManager._registered_fonts[ns][key] = fontsInSharedSWF[key];
                }
            }
        };
        DefaultFontManager.getFont = function (fontName, ns) {
            if (ns === void 0) { ns = AssetBase.DEFAULT_NAMESPACE; }
            //console.warn("get font", fontName, DefaultFontManager._registered_fonts);
            if (!fontName)
                return DefaultFontManager.getDefaultFont();
            fontName = fontName.toString().toLowerCase();
            if (!DefaultFontManager._registered_fonts[ns]) {
                DefaultFontManager._registered_fonts[ns] = {};
            }
            if (ns == AssetBase.DEFAULT_NAMESPACE) {
                if (!DefaultFontManager._registered_fonts[DefaultFontManager.shared_fonts_ns]) {
                    DefaultFontManager._registered_fonts[DefaultFontManager.shared_fonts_ns] = {};
                }
                if (DefaultFontManager._registered_fonts[DefaultFontManager.shared_fonts_ns][fontName]) {
                    return DefaultFontManager._registered_fonts[DefaultFontManager.shared_fonts_ns][fontName];
                }
                for (var key in DefaultFontManager._registered_fonts) {
                    if (DefaultFontManager._registered_fonts[key][fontName]) {
                        return DefaultFontManager._registered_fonts[key][fontName];
                    }
                }
            }
            if (DefaultFontManager._registered_fonts[ns][fontName]) {
                return DefaultFontManager._registered_fonts[ns][fontName];
            }
            var newFont = new Font();
            newFont.name = fontName;
            //DefaultFontManager._registered_fonts[fontName.toString().split(" ")[0].toLowerCase()]=newFont;
            DefaultFontManager._registered_fonts[ns][fontName] = newFont;
            return newFont;
        };
        DefaultFontManager.setDefaultFont = function (font) {
            if (font === void 0) { font = null; }
            if (!font)
                font = new Font();
            DefaultFontManager._default_font = font;
            /*
            var allchars=[];
            //allchars[cnt1++] = ['33',[0,0,226,67,0,192,11,68,127,127,0,0,0,128,177,67,0,80,137,68,127,127,0,0,0,0,212,67,0,192,204,68,127,127,0,0,0,0,212,67,0,192,204,68,127,127,0,0,0,128,177,67,0,80,137,68,127,127,0,0,0,0,129,67,0,192,204,68,127,127,0,0,0,0,129,67,0,192,204,68,127,127,0,0,0,128,177,67,0,80,137,68,127,127,0,0,0,0,100,67,0,192,11,68,127,127,0,0,0,0,100,67,0,192,11,68,127,127,0,0,0,128,177,67,0,80,137,68,127,127,0,0,0,0,226,67,0,192,11,68,127,127,0,0,0,0,221,67,0,0,0,69,127,127,0,0,0,0,170,67,0,208,242,68,127,127,0,0,0,0,110,67,0,0,0,69,127,127,0,0,0,0,110,67,0,0,0,69,127,127,0,0,0,0,170,67,0,208,242,68,127,127,0,0,0,0,110,67,0,160,229,68,127,127,0,0,0,0,110,67,0,160,229,68,127,127,0,0,0,0,170,67,0,208,242,68,127,127,0,0,0,0,221,67,0,160,229,68,127,127,0,0,0,0,221,67,0,160,229,68,127,127,0,0,0,0,170,67,0,208,242,68,127,127,0,0,0,0,221,67,0,0,0,69,127,127]]
            var i:number=0;
            for(i=0; i<cnt1;i++){
                var vertexBuffer:AttributesBuffer = new AttributesBuffer(20, allchars[i][1].length / 20);
                vertexBuffer.bufferView = new Uint8Array(<ArrayBuffer> allchars[i][1]);

                var curve_elements:TriangleElements = new TriangleElements(vertexBuffer);

                curve_elements.setPositions(new Float2Attributes(vertexBuffer));
                curve_elements.setCustomAttributes("curves", new Float3Attributes(vertexBuffer));

                //add UVs if they exist in the data
                if (attr_count == 28)
                    curve_elements.setUVs(new Float2Attributes(vertexBuffer));

                new_font_style.setChar(font_style_char.toString(), curve_elements, char_width);
                DefaultFontManager._default_font_table = new TesselatedFontTable();
            }
            */
            //DefaultFontManager._default_font_table.
        };
        DefaultFontManager.clearAll = function () {
            DefaultFontManager._default_font = null;
            DefaultFontManager._registered_fonts = {};
            DefaultFontManager.shared_fonts_ns = null;
        };
        DefaultFontManager._registered_fonts = {};
        DefaultFontManager.deviceFont = null;
        return DefaultFontManager;
    }());

    /**
     * GraphicBase wraps a TriangleElements as a scene graph instantiation. A GraphicBase is owned by a Sprite object.
     *
     *
     * @see away.base.TriangleElements
     * @see away.entities.Sprite
     *
     * @class away.base.GraphicBase
     */
    var TesselatedFontTable = /** @class */ (function (_super) {
        __extends$3(TesselatedFontTable, _super);
        /**
         * Creates a new TesselatedFont object
         * If a opentype_font object is passed, the chars will get tessellated whenever requested.
         * If no opentype font object is passed, it is expected that tesselated chars
         */
        function TesselatedFontTable(opentype_font) {
            if (opentype_font === void 0) { opentype_font = null; }
            var _this = _super.call(this) || this;
            _this._fntSizeLimit = -1;
            _this._font_chars = [];
            _this._font_chars_dic = new Object();
            _this._current_size = 0;
            _this._size_multiply = 0;
            _this._ascent = 0;
            _this._descent = 0;
            _this._usesCurves = false;
            _this._glyphIdxToChar = {};
            _this._whitespace_width = 0;
            _this._fnt_channels = [];
            _this.vertical_glyph_offset = 0;
            if (opentype_font) {
                _this._opentype_font = opentype_font;
                /*
                console.log("head.yMax ",opentype_font);
                
                 console.log("head.yMax "+opentype_font.tables.head.yMax);
                 console.log("head.yMin "+opentype_font.tables.head.yMin);
                 console.log("font.numGlyphs "+opentype_font.numGlyphs);
                 console.log('Ascender', opentype_font.tables.hhea.ascender);
                 console.log('Descender', opentype_font.tables.hhea.descender);
                 console.log('Typo Ascender', opentype_font.tables.os2.sTypoAscender);
                 console.log('Typo Descender', opentype_font.tables.os2.sTypoDescender);
                 */
                _this._font_em_size = 72; //2048;
                _this._ascent = opentype_font.tables.hhea.ascender / (_this._opentype_font.unitsPerEm / 72); ///this._font_em_size;
                _this._descent = -2 + opentype_font.tables.hhea.descender / (_this._opentype_font.unitsPerEm / 72);
                /* console.log("this._ascent", this._ascent);
                 console.log("this._descent", this._descent);(this._ascent-this.descent)
                 console.log("this._ascent-this._descent", this._ascent-this.descent)*/
                _this._current_size = 0;
                _this._size_multiply = 0;
                var thisGlyph = _this._opentype_font.charToGlyph(String.fromCharCode(32));
                if (thisGlyph) {
                    //this._whitespace_width=(opentype_font.tables.hhea.advanceWidthMax/72);//*(1 / thisGlyph.path.unitsPerEm * 72));
                    _this._whitespace_width = thisGlyph.advanceWidth / (_this._opentype_font.unitsPerEm / 72);
                    //console.log("this._whitespace_width", thisGlyph.advanceWidth);
                }
                return _this;
            }
            return _this;
        }
        Object.defineProperty(TesselatedFontTable.prototype, "fallbackTable", {
            get: function () {
                if (DefaultFontManager.deviceFont && DefaultFontManager.deviceFont.font_styles[0] != this) {
                    return DefaultFontManager.deviceFont.font_styles[0];
                }
                return null;
            },
            enumerable: true,
            configurable: true
        });
        TesselatedFontTable.prototype.addFNTChannel = function (mat) {
            this._fnt_channels.push(mat);
        };
        TesselatedFontTable.prototype.getGlyphCount = function () {
            return this._font_chars.length;
        };
        TesselatedFontTable.prototype._drawDebugRect = function (glyph_verts, minx, maxx, miny, maxy) {
            // left
            glyph_verts[glyph_verts.length] = minx;
            glyph_verts[glyph_verts.length] = miny;
            glyph_verts[glyph_verts.length] = minx + 1;
            glyph_verts[glyph_verts.length] = maxy;
            glyph_verts[glyph_verts.length] = minx;
            glyph_verts[glyph_verts.length] = maxy;
            glyph_verts[glyph_verts.length] = minx;
            glyph_verts[glyph_verts.length] = miny;
            glyph_verts[glyph_verts.length] = minx + 1;
            glyph_verts[glyph_verts.length] = miny;
            glyph_verts[glyph_verts.length] = minx + 1;
            glyph_verts[glyph_verts.length] = maxy;
            // right
            glyph_verts[glyph_verts.length] = maxx;
            glyph_verts[glyph_verts.length] = miny;
            glyph_verts[glyph_verts.length] = maxx - 1;
            glyph_verts[glyph_verts.length] = maxy;
            glyph_verts[glyph_verts.length] = maxx;
            glyph_verts[glyph_verts.length] = maxy;
            glyph_verts[glyph_verts.length] = maxx;
            glyph_verts[glyph_verts.length] = miny;
            glyph_verts[glyph_verts.length] = maxx - 1;
            glyph_verts[glyph_verts.length] = miny;
            glyph_verts[glyph_verts.length] = maxx - 1;
            glyph_verts[glyph_verts.length] = maxy;
            // top
            glyph_verts[glyph_verts.length] = minx + 1;
            glyph_verts[glyph_verts.length] = miny;
            glyph_verts[glyph_verts.length] = minx + 1;
            glyph_verts[glyph_verts.length] = miny + 1;
            glyph_verts[glyph_verts.length] = maxx - 1;
            glyph_verts[glyph_verts.length] = miny;
            glyph_verts[glyph_verts.length] = minx + 1;
            glyph_verts[glyph_verts.length] = miny + 1;
            glyph_verts[glyph_verts.length] = maxx - 1;
            glyph_verts[glyph_verts.length] = miny + 1;
            glyph_verts[glyph_verts.length] = maxx - 1;
            glyph_verts[glyph_verts.length] = miny;
            // bottom
            glyph_verts[glyph_verts.length] = minx + 1;
            glyph_verts[glyph_verts.length] = maxy;
            glyph_verts[glyph_verts.length] = minx + 1;
            glyph_verts[glyph_verts.length] = maxy - 1;
            glyph_verts[glyph_verts.length] = maxx - 1;
            glyph_verts[glyph_verts.length] = maxy;
            glyph_verts[glyph_verts.length] = minx + 1;
            glyph_verts[glyph_verts.length] = maxy - 1;
            glyph_verts[glyph_verts.length] = maxx - 1;
            glyph_verts[glyph_verts.length] = maxy - 1;
            glyph_verts[glyph_verts.length] = maxx - 1;
            glyph_verts[glyph_verts.length] = maxy;
        };
        TesselatedFontTable.prototype.generateFNTTextures = function (padding, fontSize, texSize) {
            console.log("generateFNTTextures");
            if (fontSize) {
                this._fntSizeLimit = fontSize * 0.5; //why half?
                this.initFontSize(fontSize);
            }
            if (this._opentype_font) {
                // 	if this was loaded from opentype, 
                //	we make sure all glyphs are tesselated first
                for (var g = 0; g < this._opentype_font.glyphs.length; g++) {
                    var thisGlyph = this._opentype_font.charToGlyph(String.fromCharCode(this._opentype_font.glyphs.glyphs[g].unicode)); //this._opentype_font.glyphs.glyphs[g].name);
                    if (thisGlyph) {
                        var thisPath = thisGlyph.getPath();
                        var awayPath = new GraphicsPath();
                        var i = 0;
                        var len = thisPath.commands.length;
                        var startx = 0;
                        var starty = 0;
                        var y_offset = this._ascent;
                        for (i = 0; i < len; i++) {
                            var cmd = thisPath.commands[i];
                            //console.log("cmd", cmd.type, cmd.x, cmd.y, cmd.x1, cmd.y1, cmd.x2, cmd.y2);
                            if (cmd.type === 'M') {
                                awayPath.moveTo(cmd.x, cmd.y + y_offset);
                                startx = cmd.x;
                                starty = cmd.y + y_offset;
                            }
                            else if (cmd.type === 'L') {
                                awayPath.lineTo(cmd.x, cmd.y + y_offset);
                            }
                            else if (cmd.type === 'Q') {
                                awayPath.curveTo(cmd.x1, cmd.y1 + y_offset, cmd.x, cmd.y + y_offset);
                            }
                            else if (cmd.type === 'C') {
                                awayPath.cubicCurveTo(cmd.x1, cmd.y1 + y_offset, cmd.x2, cmd.y2 + y_offset, cmd.x, cmd.y + y_offset);
                            }
                            else if (cmd.type === 'Z') {
                                awayPath.lineTo(startx, starty);
                            }
                        }
                        var tesselated_font_char = new TesselatedFontChar(null, null, awayPath);
                        tesselated_font_char.char_width = (thisGlyph.advanceWidth * (1 / thisGlyph.path.unitsPerEm * 72));
                        tesselated_font_char.fill_data = GraphicsFactoryFills.pathToAttributesBuffer(awayPath, true);
                        if (!tesselated_font_char.fill_data) {
                            console.log("error tesselating opentype glyph", this._opentype_font.glyphs.glyphs[g]);
                            //return null;
                        }
                        else {
                            this._font_chars.push(tesselated_font_char);
                            this._font_chars_dic[this._opentype_font.glyphs.glyphs[g].unicode] = tesselated_font_char;
                        }
                        //console.log("unicode:",this._opentype_font.glyphs.glyphs[g].unicode);
                        //console.log("name:",this._opentype_font.glyphs.glyphs[g].name);
                    }
                    else {
                        console.log("no char found for", this._opentype_font.glyphs.glyphs[g]);
                    }
                }
            }
            var char_vertices;
            var x = 0;
            var y = 0;
            var buffer;
            var v;
            var glyph_verts = [[]];
            var channel_idx = 0;
            var maxSize = 0;
            var allChars = [];
            var maxy = Number.MIN_VALUE;
            var maxx = Number.MIN_VALUE;
            var miny = Number.MAX_VALUE;
            var minx = Number.MAX_VALUE;
            var tmpx = 0;
            var tmpy = 0;
            // 	step1: loop over all chars, get their bounds and sort them by there height
            //	done without applying any font-scale to the glyphdata
            var allAreas = 0;
            for (var i = 0; i < this._font_chars.length; i++) {
                char_vertices = this._font_chars[i].fill_data;
                //console.log("got the glyph from opentype", this._opentype_font.glyphs.glyphs[g]);
                buffer = new Float32Array(char_vertices.buffer);
                maxy = Number.MIN_VALUE;
                maxx = Number.MIN_VALUE;
                miny = Number.MAX_VALUE;
                minx = Number.MAX_VALUE;
                tmpx = 0;
                tmpy = 0;
                for (v = 0; v < char_vertices.count; v++) {
                    tmpx = (buffer[v * 2]);
                    tmpy = (buffer[v * 2 + 1]);
                    if (tmpx < minx)
                        minx = tmpx;
                    if (tmpx > maxx)
                        maxx = tmpx;
                    if (tmpy < miny)
                        miny = tmpy;
                    if (tmpy > maxy)
                        maxy = tmpy;
                }
                this._font_chars[i].fnt_rect = new Rectangle((minx) / (this._font_chars[i].char_width), (miny) / (this._font_em_size), (maxx - minx) / (this._font_chars[i].char_width), (maxy - miny) / (this._font_em_size));
                allAreas += (maxx - minx + padding + padding) * (maxy - miny + padding + padding);
                allChars[allChars.length] = {
                    idx: i,
                    minx: minx,
                    miny: miny,
                    width: maxx - minx,
                    height: maxy - miny
                };
            }
            allChars.sort(function (a, b) {
                return a.height > b.height ? -1 : 1;
            });
            // now allChars contains all glyphs sorted by height 
            var curHeight = 0;
            maxSize = texSize;
            var size_multiply = 1;
            if (fontSize) {
                this.initFontSize(fontSize);
                size_multiply = this._size_multiply;
            }
            else {
                // 	figure out the optiomal fontSize so that the glyphs fill the texture
                //	imagine the spaces needed by all glyphs would be a perfect quat
                //	compare the width of that quat with the available width to have a first guess at fontSize
                // 	make the size slightly bigger as the estimate and check if all glyphs will fit
                //	if they do not fit, slightly reduce the scale.
                // 	repeat until all glyphs fit
                size_multiply = maxSize / (Math.sqrt(allAreas)) * 1.2;
                var invalid = true;
                var curCharHeight = 0;
                while (invalid) {
                    invalid = false;
                    x = 0;
                    y = padding;
                    for (var i = 0; i < allChars.length; i++) {
                        curCharHeight = allChars[i].height * size_multiply;
                        tmpx = 0;
                        tmpy = 0;
                        x += padding;
                        if (x + allChars[i].width * size_multiply + padding >= maxSize) {
                            x = padding;
                            y += curHeight + padding * 2;
                            curHeight = 0;
                        }
                        if (curCharHeight > curHeight) {
                            curHeight = curCharHeight;
                        }
                        if (y + curCharHeight + padding * 2 >= maxSize) {
                            invalid = true;
                            size_multiply = size_multiply * 0.995;
                            break;
                        }
                        x += (allChars[i].width) * size_multiply + padding;
                    }
                }
            }
            this._fntSizeLimit = size_multiply * this._font_em_size * 0.5; //why half?	
            // collect the glyph-data:
            var font_char;
            x = 0;
            y = padding;
            for (var i = 0; i < allChars.length; i++) {
                font_char = this._font_chars[allChars[i].idx];
                char_vertices = font_char.fill_data;
                buffer = new Float32Array(char_vertices.buffer);
                minx = allChars[i].minx;
                maxx = Number.MIN_VALUE;
                miny = allChars[i].miny;
                maxy = Number.MIN_VALUE;
                tmpx = 0;
                tmpy = 0;
                x += padding;
                if (x + allChars[i].width * size_multiply + padding >= maxSize) {
                    x = padding;
                    y += curHeight + padding * 2;
                    curHeight = 0;
                }
                allChars[i].height *= size_multiply;
                if (allChars[i].height > curHeight) {
                    curHeight = allChars[i].height;
                }
                if (y + curHeight + padding * 2 >= maxSize) {
                    x = padding;
                    y = padding;
                    curHeight = 0;
                    channel_idx++;
                    glyph_verts[channel_idx] = [];
                }
                font_char.fnt_channel = channel_idx;
                for (v = 0; v < char_vertices.count; v++) {
                    tmpx = ((buffer[v * 2] - minx) * size_multiply) + x;
                    tmpy = ((buffer[v * 2 + 1] - miny) * size_multiply) + y;
                    glyph_verts[channel_idx][glyph_verts[channel_idx].length] = tmpx;
                    glyph_verts[channel_idx][glyph_verts[channel_idx].length] = tmpy;
                    if (tmpx > maxx) {
                        maxx = tmpx;
                    }
                    if (tmpy > maxy) {
                        maxy = tmpy;
                    }
                }
                font_char.fnt_uv = new Rectangle(x / maxSize, 1 - (y / maxSize), (maxx - x) / maxSize, ((maxy - y) / maxSize));
                //this._drawDebugRect(glyph_verts[channel_idx], x, maxx, y, maxy);
                x += (allChars[i].width) * size_multiply + padding;
            }
            var shapes = [];
            for (var i = 0; i < glyph_verts.length; i++) {
                var attr_length = 2; //(tess_fontTable.usesCurves)?3:2;
                var attributesView = new AttributesView(Float32Array, attr_length);
                attributesView.set(glyph_verts[i]);
                var vertexBuffer = attributesView.attributesBuffer.cloneBufferView();
                attributesView.dispose();
                var elements = new TriangleElements(vertexBuffer);
                elements.setPositions(new Float2Attributes(vertexBuffer));
                var shape = Shape.getShape(elements);
                var sampler = new ImageSampler();
                shape.style = new Style();
                var color = 0xFFFFFF;
                var alpha = 1;
                var obj = Graphics.get_material_for_color(color, alpha);
                shape.material = obj.material;
                if (obj.colorPos) {
                    shape.style.addSamplerAt(sampler, shape.material.getTextureAt(0));
                    shape.material.animateUVs = true;
                    shape.style.uvMatrix = new Matrix(0, 0, 0, 0, obj.colorPos.x, obj.colorPos.y);
                }
                shapes[i] = shape;
            }
            return shapes;
        };
        TesselatedFontTable.prototype.getRatio = function (size) {
            return this._size_multiply;
        };
        TesselatedFontTable.prototype.hasChar = function (char_code) {
            var tesselated_font_char = this._font_chars_dic[name];
            if (tesselated_font_char == null) {
                if (this._opentype_font) {
                    //console.log("get char for '"+String.fromCharCode(parseInt(name))+"'. char does not exists yet. try creating it from opentype.");
                    var thisGlyph = this._opentype_font.charToGlyph(String.fromCharCode(parseInt(name)));
                    if (thisGlyph) {
                        return true;
                    }
                }
            }
            return this._font_chars_dic[char_code] != null;
        };
        TesselatedFontTable.prototype.changeOpenTypeFont = function (newOpenTypeFont, tesselateAllOld) {
            if (tesselateAllOld === void 0) { tesselateAllOld = true; }
            if ((tesselateAllOld) && (this._opentype_font)) {
                //todo: make sure all available chars are tesselated
            }
            // todo: when updating a font we must take care that they are compatible in terms of em_size
            this._opentype_font = newOpenTypeFont;
        };
        TesselatedFontTable.prototype.initFontSize = function (font_size) {
            if (this.fallbackTable)
                this.fallbackTable.initFontSize(font_size);
            if (this._current_size == font_size)
                return;
            this._current_size = font_size;
            this._size_multiply = font_size / this._font_em_size;
            //console.log("text-font-table: ",this._ascent, this._descent, this._font_em_size)
        };
        TesselatedFontTable.prototype.getCharVertCnt = function (char_code) {
            var tesselated_font_char = this._font_chars_dic[char_code];
            if (tesselated_font_char) {
                return tesselated_font_char.fill_data.length;
            }
            return 0;
        };
        TesselatedFontTable.prototype.getCharWidth = function (char_code) {
            if (char_code == "32") {
                return (Math.floor(this._whitespace_width * this._size_multiply * 20)) / 20;
            }
            if (char_code == "9") {
                return (Math.floor(this._whitespace_width * this._size_multiply * 8 * 20)) / 20;
            }
            var tesselated_font_char = this.getChar(char_code);
            if (tesselated_font_char) {
                return (Math.floor(tesselated_font_char.char_width * this._size_multiply * 20)) / 20;
            }
            else {
                if (char_code == "9679") {
                    tesselated_font_char = this.createPointGlyph_9679();
                    return (Math.floor(tesselated_font_char.char_width * this._size_multiply * 20)) / 20;
                }
            }
            if (this.fallbackTable)
                return this.fallbackTable.getCharWidth(char_code);
            return 0;
        };
        Object.defineProperty(TesselatedFontTable.prototype, "usesCurves", {
            get: function () {
                return this._usesCurves;
            },
            enumerable: true,
            configurable: true
        });
        TesselatedFontTable.prototype.getLineHeight = function () {
            var thisLineheighttest = this._size_multiply * (this._ascent - this.descent);
            return thisLineheighttest; // sf
            //return this._size_multiply*this._font_em_size;
            //	return (this._ascent+this._descent)*this._size_multiply;	// enable for icycle
        };
        TesselatedFontTable.prototype.getUnderLineHeight = function () {
            return this._size_multiply * (this._ascent - this.descent / 2);
        };
        Object.defineProperty(TesselatedFontTable.prototype, "assetType", {
            get: function () {
                return TesselatedFontTable.assetType;
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         */
        TesselatedFontTable.prototype.dispose = function () {
            for (var i = 0; i < this._font_chars.length; i++) {
                this._font_chars[i].dispose();
            }
            this._font_chars.length = 0;
            this._font_chars_dic = null;
        };
        Object.defineProperty(TesselatedFontTable.prototype, "fntSizeLimit", {
            get: function () {
                return this._fntSizeLimit;
            },
            set: function (value) {
                this._fntSizeLimit = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TesselatedFontTable.prototype, "ascent", {
            get: function () {
                return this._ascent;
            },
            set: function (value) {
                this._ascent = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TesselatedFontTable.prototype, "descent", {
            get: function () {
                return this._descent;
            },
            set: function (value) {
                this._descent = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TesselatedFontTable.prototype, "offset_x", {
            get: function () {
                return this._offset_x;
            },
            set: function (value) {
                this._offset_x = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TesselatedFontTable.prototype, "offset_y", {
            get: function () {
                return this._offset_y;
            },
            set: function (value) {
                this._offset_y = value;
            },
            enumerable: true,
            configurable: true
        });
        TesselatedFontTable.prototype.get_font_chars = function () {
            return this._font_chars;
        };
        TesselatedFontTable.prototype.get_font_em_size = function () {
            return this._font_em_size;
        };
        TesselatedFontTable.prototype.set_whitespace_width = function (value) {
            this._whitespace_width = value;
        };
        TesselatedFontTable.prototype.get_whitespace_width = function () {
            return this._whitespace_width;
        };
        TesselatedFontTable.prototype.set_font_em_size = function (font_em_size) {
            this._font_em_size = font_em_size;
        };
        TesselatedFontTable.prototype.buildTextLineFromIndices = function (tf, format, x, y, indices, advance) {
            var textShape = tf.getTextShapeForIdentifierAndFormat(format.color.toString(), format);
            var origin_x = x;
            y -= this._ascent * this._size_multiply; //this.getLineHeight();
            var charGlyph;
            var char_vertices;
            var buffer;
            var v;
            var size_multiply;
            var idx = 0;
            var i = 0;
            var i_len = indices.length;
            if (this._glyphIdxToChar[tf["fileurl"]] == null) {
                console.log("no glyphIdx-map for textfield", tf.adaptee.assetNamespace);
                return new Point(0, 0);
            }
            // loop over all the words and create the text data for it
            // each word provides its own start-x and start-y values, so we can just ignore whitespace-here
            for (i = 0; i < i_len; i++) {
                idx = indices[i];
                charGlyph = this._glyphIdxToChar[tf["fileurl"]][idx];
                size_multiply = this._size_multiply;
                if (!charGlyph) {
                    //console.log("no glyph found at idx", idx, "todo: support fallback fonts");
                }
                else {
                    if (charGlyph.fill_data == null) {
                        if (charGlyph.fill_data_path.commands[0][0] == 1 && charGlyph.fill_data_path.data[0][0] == 0 && charGlyph.fill_data_path.data[0][1] == 0) {
                            charGlyph.fill_data_path.data[0].shift();
                            charGlyph.fill_data_path.data[0].shift();
                            charGlyph.fill_data_path.commands[0].shift();
                            charGlyph.fill_data_path.commands[0][0] = 2;
                        }
                        charGlyph.fill_data = GraphicsFactoryFills.pathToAttributesBuffer(charGlyph.fill_data_path, true);
                    }
                    char_vertices = charGlyph.fill_data;
                    if (char_vertices) {
                        buffer = new Float32Array(char_vertices.buffer);
                        if (this.usesCurves) {
                            for (v = 0; v < char_vertices.count; v++) {
                                textShape.verts[textShape.verts.length] = buffer[v * 3] * size_multiply + x;
                                textShape.verts[textShape.verts.length] = buffer[v * 3 + 1] * size_multiply + y;
                                textShape.verts[textShape.verts.length] = buffer[v * 3 + 2];
                            }
                        }
                        else {
                            for (v = 0; v < char_vertices.count; v++) {
                                textShape.verts[textShape.verts.length] = buffer[v * 2] * size_multiply + x;
                                textShape.verts[textShape.verts.length] = buffer[v * 2 + 1] * size_multiply + y;
                            }
                        }
                    }
                }
                x += advance[i]; // * size_multiply;
            }
            return new Point(x - origin_x, this.getLineHeight());
        };
        TesselatedFontTable.prototype.fillTextRun = function (tf, format, startWord, wordCnt) {
            var useFNT = this._fntSizeLimit >= 0 && (this._fntSizeLimit == 0 || this._fntSizeLimit >= format.size);
            var textShape = tf.getTextShapeForIdentifierAndFormat(format.color.toString() + useFNT.toString() + "0", format);
            var fntTextShapesByChannel = {};
            var fntSelectedTextShapesByChannel = {};
            //var currentFNTTextShapeMap:any;
            var argb = ColorUtils.float32ColorToARGB(format.color);
            var mat = new MethodMaterial(this._fnt_channels[0]);
            mat.colorTransform = new ColorTransform(argb[1] / 255, argb[2] / 255, argb[3] / 255);
            mat.bothSides = true;
            mat.alphaBlending = true;
            mat.alphaPremultiplied = true;
            mat.useColorTransform = true;
            mat.style.sampler = new ImageSampler(false, true, true);
            textShape.fntMaterial = useFNT ? mat : null;
            fntTextShapesByChannel[format.color.toString() + useFNT.toString() + "0"] = textShape;
            var newFormat = format.clone();
            newFormat.color = 0xffffff;
            var textShapeSelected = tf.getTextShapeForIdentifierAndFormat(useFNT.toString() + "0", newFormat);
            fntSelectedTextShapesByChannel[useFNT.toString() + "0"] = textShapeSelected;
            var mat = new MethodMaterial(this._fnt_channels[0]);
            mat.bothSides = true;
            mat.alphaBlending = true;
            mat.alphaPremultiplied = true;
            mat.useColorTransform = true;
            mat.style.sampler = new ImageSampler(false, true, true);
            textShapeSelected.fntMaterial = useFNT ? mat : null;
            var currentTextShape = null;
            var charGlyph;
            var w = 0;
            var w_len = startWord + (wordCnt * 5);
            var char_vertices;
            var c = 0;
            var c_len = 0;
            var x = 0;
            var y = 0;
            var startIdx = 0;
            var buffer;
            var v;
            var size_multiply;
            var hack_x_mirror = false;
            var select_start = tf.selectionBeginIndex;
            var select_end = tf.selectionEndIndex;
            if (tf.selectionEndIndex < tf.selectionBeginIndex) {
                select_start = tf.selectionEndIndex;
                select_end = tf.selectionBeginIndex;
            }
            var start_x = 0;
            if (newFormat.underline && (startWord + 1) < tf.words.length) {
                start_x = tf.words[startWord + 1];
            }
            // loop over all the words and create the text data for it
            // each word provides its own start-x and start-y values, so we can just ignore whitespace-here
            for (w = startWord; w < w_len; w += 5) {
                startIdx = tf.words[w];
                x = tf.words[w + 1];
                y = tf.words[w + 2];
                if (this.name == "BoldStyle") {
                    y -= 0.2 * this.getLineHeight();
                }
                else {
                    //y-=0.03*this._current_size;
                }
                //todo: this is a temporary fix for sunflower `si` VoltMeter text vertical align
                if (format.font_name == "DJB Get Digital") {
                    y -= 2;
                }
                //y=tf.words[w+2]+(this.ascent-this.get_font_em_size())*this._size_multiply; // enable for icycle
                c_len = startIdx + tf.words[w + 4];
                for (c = startIdx; c < c_len; c++) {
                    hack_x_mirror = false;
                    if (tf.chars_codes[c] == 40) {
                        //tf.chars_codes[c]=41;
                        //hack_x_mirror=true;
                    }
                    currentTextShape = (tf.isInFocus && c >= select_start && c < select_end) ? textShapeSelected : textShape;
                    if (tf.chars_codes[c] != 32 && tf.chars_codes[c] != 9) {
                        charGlyph = this.getChar(tf.chars_codes[c].toString());
                        size_multiply = this._size_multiply;
                        if (!charGlyph && this.fallbackTable) {
                            charGlyph = this.fallbackTable.getChar(tf.chars_codes[c].toString());
                            size_multiply = this.fallbackTable._size_multiply;
                        }
                        if (charGlyph) {
                            if (useFNT) {
                                // the font should use fnt							
                                var curFormat = currentTextShape.format;
                                var currentTextShapeFNT = (tf.isInFocus && c >= select_start && c < select_end) ? fntSelectedTextShapesByChannel[useFNT.toString() + charGlyph.fnt_channel] : fntTextShapesByChannel[curFormat.color.toString() + useFNT.toString() + charGlyph.fnt_channel];
                                if (!currentTextShapeFNT) {
                                    var newtextShape = tf.getTextShapeForIdentifierAndFormat(curFormat.color.toString() + useFNT.toString() + charGlyph.fnt_channel.toString(), curFormat);
                                    var argb = ColorUtils.float32ColorToARGB(curFormat.color);
                                    var mat = new MethodMaterial(this._fnt_channels[charGlyph.fnt_channel]);
                                    mat.colorTransform = new ColorTransform(argb[1] / 255, argb[2] / 255, argb[3] / 255);
                                    mat.bothSides = true;
                                    mat.alphaBlending = true;
                                    mat.alphaPremultiplied = true;
                                    mat.useColorTransform = true;
                                    mat.style.sampler = new ImageSampler(false, true, true);
                                    newtextShape.fntMaterial = mat;
                                    fntTextShapesByChannel[curFormat.color.toString() + useFNT.toString() + charGlyph.fnt_channel] = newtextShape;
                                    currentTextShapeFNT = newtextShape;
                                }
                                var x1 = x + ((charGlyph.char_width * size_multiply) * charGlyph.fnt_rect.x);
                                var x2 = x1 + ((charGlyph.char_width * size_multiply) * charGlyph.fnt_rect.width);
                                var y1 = y + ((this._font_em_size * size_multiply) * charGlyph.fnt_rect.y);
                                var y2 = y1 + ((this._font_em_size * size_multiply) * charGlyph.fnt_rect.height);
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = x1;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = y1;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = charGlyph.fnt_uv.x;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = charGlyph.fnt_uv.y;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = x2;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = y1;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = charGlyph.fnt_uv.x + charGlyph.fnt_uv.width;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = charGlyph.fnt_uv.y;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = x2;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = y2;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = charGlyph.fnt_uv.x + charGlyph.fnt_uv.width;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = charGlyph.fnt_uv.y - charGlyph.fnt_uv.height;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = x1; // 
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = y1;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = charGlyph.fnt_uv.x;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = charGlyph.fnt_uv.y;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = x1;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = y2;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = charGlyph.fnt_uv.x;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = charGlyph.fnt_uv.y - charGlyph.fnt_uv.height;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = x2;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = y2;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = charGlyph.fnt_uv.x + charGlyph.fnt_uv.width;
                                currentTextShapeFNT.verts[currentTextShapeFNT.verts.length] = charGlyph.fnt_uv.y - charGlyph.fnt_uv.height;
                            }
                            else {
                                char_vertices = charGlyph.fill_data;
                                buffer = new Float32Array(char_vertices.buffer);
                                if (this.usesCurves) {
                                    for (v = 0; v < char_vertices.count; v++) {
                                        currentTextShape.verts[currentTextShape.verts.length] = (buffer[v * 3] * size_multiply) + x;
                                        currentTextShape.verts[currentTextShape.verts.length] = (buffer[v * 3 + 1] * size_multiply) + y;
                                        currentTextShape.verts[currentTextShape.verts.length] = buffer[v * 3 + 2];
                                    }
                                }
                                else {
                                    if (hack_x_mirror) {
                                        for (v = 0; v < char_vertices.count; v++) {
                                            currentTextShape.verts[currentTextShape.verts.length] = ((charGlyph.char_width - buffer[v * 2]) * size_multiply) + x;
                                            currentTextShape.verts[currentTextShape.verts.length] = ((buffer[v * 2 + 1] - this.vertical_glyph_offset) * size_multiply) + y;
                                        }
                                    }
                                    else {
                                        for (v = 0; v < char_vertices.count; v++) {
                                            currentTextShape.verts[currentTextShape.verts.length] = ((buffer[v * 2]) * size_multiply) + x;
                                            currentTextShape.verts[currentTextShape.verts.length] = ((buffer[v * 2 + 1] - this.vertical_glyph_offset) * size_multiply) + y;
                                        }
                                    }
                                }
                            }
                            x += charGlyph.char_width * size_multiply;
                            // todo: handle kerning
                        }
                        else {
                            console.log("TesselatedFontTable: Error: char not found in fontTable", tf.chars_codes[c], tf.chars_codes[c].toString());
                        }
                    }
                }
                var half_thickness = 0.25 * tf.internalScale.y;
                var topY = y + this.getUnderLineHeight() + half_thickness;
                var bottomY = y + this.getUnderLineHeight() - half_thickness;
                if (newFormat.underline && (startWord + 1) < tf.words.length) {
                    currentTextShape.verts[currentTextShape.verts.length] = start_x;
                    currentTextShape.verts[currentTextShape.verts.length] = bottomY;
                    currentTextShape.verts[currentTextShape.verts.length] = start_x;
                    currentTextShape.verts[currentTextShape.verts.length] = topY;
                    currentTextShape.verts[currentTextShape.verts.length] = x;
                    currentTextShape.verts[currentTextShape.verts.length] = topY;
                    currentTextShape.verts[currentTextShape.verts.length] = x;
                    currentTextShape.verts[currentTextShape.verts.length] = topY;
                    currentTextShape.verts[currentTextShape.verts.length] = x;
                    currentTextShape.verts[currentTextShape.verts.length] = bottomY;
                    currentTextShape.verts[currentTextShape.verts.length] = start_x;
                    currentTextShape.verts[currentTextShape.verts.length] = bottomY;
                }
            }
            buffer = null;
        };
        TesselatedFontTable.prototype.createPointGlyph_9679 = function () {
            var verts = [];
            GraphicsFactoryHelper.drawElipse(this._font_em_size / 2, this._font_em_size / 2, this._font_em_size / 8, this._font_em_size / 8, verts, 0, 360, 5, false);
            var attributesView = new AttributesView(Float32Array, 2);
            attributesView.set(verts);
            var attributesBuffer = attributesView.attributesBuffer.cloneBufferView();
            attributesView.dispose();
            var tesselated_font_char = new TesselatedFontChar(attributesBuffer, null, null);
            tesselated_font_char.char_width = this._font_em_size;
            this._font_chars.push(tesselated_font_char);
            this._font_chars_dic["9679"] = tesselated_font_char;
            return tesselated_font_char;
        };
        /**
         *
         */
        TesselatedFontTable.prototype.getChar = function (name) {
            var tesselated_font_char = this._font_chars_dic[name];
            if (tesselated_font_char == null) {
                if (this._opentype_font) {
                    //console.log("get char for '"+String.fromCharCode(parseInt(name))+"'. char does not exists yet. try creating it from opentype.");
                    var thisGlyph = this._opentype_font.charToGlyph(String.fromCharCode(parseInt(name)));
                    if (thisGlyph) {
                        //console.log("got the glyph from opentype");
                        { //todo: only do this for webGL
                            var thisPath = thisGlyph.getPath();
                            var awayPath = new GraphicsPath();
                            var i = 0;
                            var len = thisPath.commands.length;
                            //awayPath.lineTo(0, 0);
                            //awayPath.moveTo(0,0);//-100);
                            //awayPath.curveTo(100, 250, 200,0);
                            //awayPath.lineTo(150, 100);
                            //awayPath.moveTo(0,20);
                            //awayPath.curveTo(100, 270, 200,20);
                            //awayPath.moveTo(0,-20);
                            //awayPath.moveTo(0,-10);
                            //awayPath.curveTo(100, -110, 200,-10);
                            var startx = 0;
                            var starty = 0;
                            var y_offset = this._ascent;
                            //40 = 66
                            for (i = 0; i < len; i++) {
                                var cmd = thisPath.commands[i];
                                //console.log("cmd", cmd.type, cmd.x, cmd.y, cmd.x1, cmd.y1, cmd.x2, cmd.y2);
                                if (cmd.type === 'M') {
                                    awayPath.moveTo(cmd.x, cmd.y + y_offset);
                                    startx = cmd.x;
                                    starty = cmd.y + y_offset;
                                }
                                else if (cmd.type === 'L') {
                                    awayPath.lineTo(cmd.x, cmd.y + y_offset);
                                }
                                else if (cmd.type === 'Q') {
                                    awayPath.curveTo(cmd.x1, cmd.y1 + y_offset, cmd.x, cmd.y + y_offset);
                                }
                                else if (cmd.type === 'C') {
                                    awayPath.cubicCurveTo(cmd.x1, cmd.y1 + y_offset, cmd.x2, cmd.y2 + y_offset, cmd.x, cmd.y + y_offset);
                                }
                                else if (cmd.type === 'Z') {
                                    awayPath.lineTo(startx, starty);
                                }
                            }
                            /*
                                    awayPath.moveTo(0, 0);
                                    awayPath.lineTo(-5000, 500);
                                    awayPath.lineTo(-5000, 5000);
                                    awayPath.lineTo(-500, 5000);
                                    awayPath.lineTo(-500, 500);
                                    */
                            //awayPath.style = new GraphicsStrokeStyle(0xff0000, 1, 1, JointStyle.MITER, CapsStyle.NONE, 100);
                            /*
                                                    var final_vert_list:Array<number>=[];
                                                    //todo
                                                    //GraphicsFactoryStrokes.draw_pathes([awayPath], final_vert_list, false);
                                                    var attributesView:AttributesView = new AttributesView(Float32Array, 3);
                                                    attributesView.set(final_vert_list);
                                                    var attributesBuffer:AttributesBuffer = attributesView.attributesBuffer.cloneBufferView();
                                                    attributesView.dispose();
                            
                                                    //console.log("tesselated_font_char.char_width "+tesselated_font_char.char_width);
                                                    */
                            var tesselated_font_char = new TesselatedFontChar(null, null, awayPath);
                            tesselated_font_char.char_width = (thisGlyph.advanceWidth * (1 / thisGlyph.path.unitsPerEm * 72));
                            tesselated_font_char.fill_data = GraphicsFactoryFills.pathToAttributesBuffer(awayPath, true);
                            if (!tesselated_font_char.fill_data) {
                                console.log("error tesselating opentype glyph");
                                return null;
                            }
                            this._font_chars.push(tesselated_font_char);
                            this._font_chars_dic[name] = tesselated_font_char;
                        }
                    }
                }
                if (name == "9679") {
                    tesselated_font_char = this.createPointGlyph_9679();
                }
            }
            else if (tesselated_font_char.fill_data == null && tesselated_font_char.stroke_data == null && tesselated_font_char.fill_data_path != null) {
                // 	hack for messed up "X": remove the first command if it is moveTo that points to 0,0
                //	change the new first command to moveTo
                if (tesselated_font_char.fill_data_path.commands[0][0] == 1 && tesselated_font_char.fill_data_path.data[0][0] == 0 && tesselated_font_char.fill_data_path.data[0][1] == 0) {
                    tesselated_font_char.fill_data_path.data[0].shift();
                    tesselated_font_char.fill_data_path.data[0].shift();
                    tesselated_font_char.fill_data_path.commands[0].shift();
                    tesselated_font_char.fill_data_path.commands[0][0] = 2;
                }
                tesselated_font_char.fill_data = GraphicsFactoryFills.pathToAttributesBuffer(tesselated_font_char.fill_data_path, true);
                if (!tesselated_font_char.fill_data) {
                    console.log("error tesselating glyph");
                    return null;
                }
            }
            return tesselated_font_char;
        };
        TesselatedFontTable.prototype.setChar = function (name, char_width, fills_data, stroke_data, uses_curves, glyph_idx, fill_data_path, fileURL) {
            if (fills_data === void 0) { fills_data = null; }
            if (stroke_data === void 0) { stroke_data = null; }
            if (uses_curves === void 0) { uses_curves = false; }
            if (glyph_idx === void 0) { glyph_idx = 0; }
            if (fill_data_path === void 0) { fill_data_path = null; }
            if (fileURL === void 0) { fileURL = ""; }
            char_width = Math.floor(char_width * 20) / 20;
            //console.log("adding char", name, String.fromCharCode(parseInt(name)));
            if ((fills_data == null) && (stroke_data == null) && (fill_data_path == null))
                throw ("TesselatedFontTable: trying to create a TesselatedFontChar with no data (fills_data, stroke_data and fill_data_path is null)");
            if (this._font_chars.length > 0) {
                if (uses_curves != this._usesCurves) {
                    throw ("TesselatedFontTable: Can not set different types of graphic-glyphs (curves vs non-cuves) on the same FontTable!");
                }
            }
            else {
                this._usesCurves = uses_curves;
            }
            var tesselated_font_char = new TesselatedFontChar(fills_data, stroke_data, fill_data_path);
            tesselated_font_char.char_width = char_width;
            tesselated_font_char.glyph_idx = glyph_idx;
            tesselated_font_char.name = name;
            if (this._glyphIdxToChar[fileURL] == null) {
                this._glyphIdxToChar[fileURL] = {};
            }
            this._glyphIdxToChar[fileURL][glyph_idx] = tesselated_font_char;
            this._font_chars.push(tesselated_font_char);
            this._font_chars_dic[name] = tesselated_font_char;
        };
        TesselatedFontTable.prototype.buildTextRuns = function (textRuns, output_verts) {
            if ((textRuns.length * 2) != (output_verts.length))
                throw ("Invalid data passed to TesselatedFontTable.buildTextRuns(). output_verts.length is not double textRuns.length.");
            var i = 0;
            var font_size = 0;
            var drawMode = 0;
            var charCode = 0;
            var xpos = 0;
            var ypos = 0;
            var runCnt = 0;
            var runLen = 0;
            var len = textRuns.length;
            var textrun;
            var thisChar;
            for (i = 0; i < len; i++) {
                textrun = textRuns[i];
                font_size = textrun[0];
                drawMode = textrun[1];
                ypos = textrun[2];
                runLen = textrun.length;
                for (runCnt = 3; runCnt < runLen; runCnt += 2) {
                    charCode = textrun[runCnt];
                    xpos = textrun[runCnt + 1];
                    thisChar = this.getChar(charCode.toString());
                    if ((drawMode == DrawMode.BOTH) || (drawMode == DrawMode.STROKE)) {
                        if (output_verts[i * 2] == null) {
                            throw ("Trying to render strokes for a textrun, but no output_vert list was set for this textrun strokes");
                        }
                    }
                    if ((drawMode == DrawMode.BOTH) || (drawMode == DrawMode.FILL)) {
                        if (output_verts[i * 2 + 1] == null) {
                            throw ("Trying to render fills for a textrun, but no output_vert list was set for this textrun fills");
                        }
                    }
                }
            }
        };
        TesselatedFontTable.assetType = "[asset TesselatedFontTable]";
        return TesselatedFontTable;
    }(AssetBase));

    /**
     * The TextFieldAutoSize class is an enumeration of constant values used in
     * setting the <code>autoSize</code> property of the TextField class.
     */
    var TextFieldAutoSize = /** @class */ (function () {
        function TextFieldAutoSize() {
        }
        /**
         * Specifies that the text is to be treated as center-justified text. Any
         * resizing of a single line of a text field is equally distributed to both
         * the right and left sides.
         */
        TextFieldAutoSize.CENTER = "center";
        /**
         * Specifies that the text is to be treated as left-justified text, meaning
         * that the left side of the text field remains fixed and any resizing of a
         * single line is on the right side.
         */
        TextFieldAutoSize.LEFT = "left";
        /**
         * Specifies that no resizing is to occur.
         */
        TextFieldAutoSize.NONE = "none";
        /**
         * Specifies that the text is to be treated as right-justified text, meaning
         * that the right side of the text field remains fixed and any resizing of a
         * single line is on the left side.
         */
        TextFieldAutoSize.RIGHT = "right";
        return TextFieldAutoSize;
    }());

    /**
     * The TextFieldType class is an enumeration of constant values used in setting the
     * <code>type</code> property of the TextField class.
     *
     * @see away.entities.TextField#type
     */
    var TextFieldType = /** @class */ (function () {
        function TextFieldType() {
        }
        /**
         * Used to specify a <code>dynamic</code> TextField.
         */
        TextFieldType.DYNAMIC = "dynamic";
        /**
         * Used to specify an <code>input</code> TextField.
         */
        TextFieldType.INPUT = "input";
        /**
         * Used to specify an <code>static</code> TextField.
         */
        TextFieldType.STATIC = "input";
        return TextFieldType;
    }());

    var FontStyleName = /** @class */ (function () {
        function FontStyleName() {
        }
        FontStyleName.STANDART = "standart";
        FontStyleName.BOLD = "bold";
        FontStyleName.ITALIC = "italic";
        FontStyleName.BOLDITALIC = "boldItalic";
        return FontStyleName;
    }());

    /**
     * The TextFormatAlign class provides values for text alignment in the
     * TextFormat class.
     */
    var TextFormatAlign = /** @class */ (function () {
        function TextFormatAlign() {
        }
        /**
         * Constant; centers the text in the text field. Use the syntax
         * <code>TextFormatAlign.CENTER</code>.
         */
        TextFormatAlign.CENTER = "center";
        /**
         * Constant; justifies text within the text field. Use the syntax
         * <code>TextFormatAlign.JUSTIFY</code>.
         */
        TextFormatAlign.JUSTIFY = "justify";
        /**
         * Constant; aligns text to the left within the text field. Use the syntax
         * <code>TextFormatAlign.LEFT</code>.
         */
        TextFormatAlign.LEFT = "left";
        /**
         * Constant; aligns text to the right within the text field. Use the syntax
         * <code>TextFormatAlign.RIGHT</code>.
         */
        TextFormatAlign.RIGHT = "right";
        return TextFormatAlign;
    }());

    /**
     * The TextFormat class represents character formatting information. Use the
     * TextFormat class to create specific text formatting for text fields. You
     * can apply text formatting to both static and dynamic text fields. The
     * properties of the TextFormat class apply to device and embedded fonts.
     * However, for embedded fonts, bold and italic text actually require specific
     * fonts. If you want to display bold or italic text with an embedded font,
     * you need to embed the bold and italic variations of that font.
     *
     * <p> You must use the constructor <code>new TextFormat()</code> to create a
     * TextFormat object before setting its properties. When you apply a
     * TextFormat object to a text field using the
     * <code>TextField.defaultTextFormat</code> property or the
     * <code>TextField.setTextFormat()</code> method, only its defined properties
     * are applied. Use the <code>TextField.defaultTextFormat</code> property to
     * apply formatting BEFORE you add text to the <code>TextField</code>, and the
     * <code>setTextFormat()</code> method to add formatting AFTER you add text to
     * the <code>TextField</code>. The TextFormat properties are <code>null</code>
     * by default because if you don't provide values for the properties, Flash
     * Player uses its own default formatting. The default formatting that Flash
     * Player uses for each property(if property's value is <code>null</code>) is
     * as follows:</p>
     *
     * <p>The default formatting for each property is also described in each
     * property description.</p>
     */
    var TextFormat = /** @class */ (function (_super) {
        __extends$3(TextFormat, _super);
        /**
         * Creates a TextFormat object with the specified properties. You can then
         * change the properties of the TextFormat object to change the formatting of
         * text fields.
         *
         * <p>Any parameter may be set to <code>null</code> to indicate that it is
         * not defined. All of the parameters are optional; any omitted parameters
         * are treated as <code>null</code>.</p>
         *
         * @param font        The name of a font for text as a string.
         * @param size        An integer that indicates the size in pixels.
         * @param color       The color of text using this text format. A number
         *                    containing three 8-bit RGB components; for example,
         *                    0xFF0000 is red, and 0x00FF00 is green.
         * @param bold        A Boolean value that indicates whether the text is
         *                    boldface.
         * @param italic      A Boolean value that indicates whether the text is
         *                    italicized.
         * @param underline   A Boolean value that indicates whether the text is
         *                    underlined.
         * @param url         The URL to which the text in this text format
         *                    hyperlinks. If <code>url</code> is an empty string, the
         *                    text does not have a hyperlink.
         * @param target      The target window where the hyperlink is displayed. If
         *                    the target window is an empty string, the text is
         *                    displayed in the default target window
         *                    <code>_self</code>. If the <code>url</code> parameter
         *                    is set to an empty string or to the value
         *                    <code>null</code>, you can get or set this property,
         *                    but the property will have no effect.
         * @param align       The alignment of the paragraph, as a TextFormatAlign
         *                    value.
         * @param leftMargin  Indicates the left margin of the paragraph, in pixels.
         * @param rightMargin Indicates the right margin of the paragraph, in pixels.
         * @param indent      An integer that indicates the indentation from the left
         *                    margin to the first character in the paragraph.
         * @param leading     A number that indicates the amount of leading vertical
         *                    space between lines.
         */
        function TextFormat(font, size, color, bold, italic, underline, url, link_target, align, leftMargin, rightMargin, indent, leading) {
            if (font === void 0) { font = null; }
            if (size === void 0) { size = null; }
            if (color === void 0) { color = null; }
            if (bold === void 0) { bold = null; }
            if (italic === void 0) { italic = null; }
            if (underline === void 0) { underline = null; }
            if (url === void 0) { url = null; }
            if (link_target === void 0) { link_target = null; }
            if (align === void 0) { align = null; }
            if (leftMargin === void 0) { leftMargin = null; }
            if (rightMargin === void 0) { rightMargin = null; }
            if (indent === void 0) { indent = null; }
            if (leading === void 0) { leading = null; }
            var _this = _super.call(this) || this;
            /**
             * Specifies custom tab stops as an array of non-negative integers. Each tab
             * stop is specified in pixels. If custom tab stops are not specified
             * (<code>null</code>), the default tab stop is 4(average character width).
             */
            //todo: not used with in tesselated-font-table yet
            _this.tabStops = [];
            _this._align = align;
            _this._leftMargin = leftMargin;
            _this._rightMargin = rightMargin;
            _this._indent = indent;
            _this._font_name = font;
            _this._size = size;
            _this._color = color;
            _this._bold = bold;
            _this._italic = italic;
            _this._underline = underline;
            _this._leading = leading;
            _this._letterSpacing = null;
            // not really used yet:
            _this.url = url;
            _this.link_target = link_target;
            // make sure a fontTable exists:
            _this._font = null; //DefaultFontManager.getFont(font);
            _this._font_table = null; //=<TesselatedFontTable>this._font.get_font_table(FontStyleName.STANDART, TesselatedFontTable.assetType);
            _this._style_name = FontStyleName.STANDART;
            return _this;
        }
        /**
         * return true if a certain property was set for this format.
         *
         * @param property_name
         */
        TextFormat.prototype.hasPropertySet = function (property_name) {
            return this["_" + property_name] !== null;
        };
        Object.defineProperty(TextFormat.prototype, "align", {
            get: function () {
                return this._align ? this._align : TextFormatAlign.LEFT;
            },
            set: function (value) {
                this._align = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "blockIndent", {
            get: function () {
                return this._blockIndent ? this._blockIndent : 0;
            },
            set: function (value) {
                this._blockIndent = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "leftMargin", {
            get: function () {
                return this._leftMargin ? this._leftMargin : 0;
            },
            set: function (value) {
                this._leftMargin = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "rightMargin", {
            get: function () {
                return this._rightMargin ? this._rightMargin : 0;
            },
            set: function (value) {
                this._rightMargin = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "indent", {
            get: function () {
                return this._indent ? this._indent : 0;
            },
            set: function (value) {
                this._indent = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "color", {
            get: function () {
                return (this._color !== null) ? this._color : 0x000000;
            },
            set: function (value) {
                this._color = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "kerning", {
            get: function () {
                return this._kerning ? this._kerning : false;
            },
            set: function (value) {
                this._kerning = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "leading", {
            get: function () {
                return this._leading ? this._leading : 0;
            },
            set: function (value) {
                this._leading = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "letterSpacing", {
            get: function () {
                return this._letterSpacing ? this._letterSpacing : 0;
            },
            set: function (value) {
                this._letterSpacing = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "size", {
            get: function () {
                return this._size ? this._size : 12;
            },
            set: function (value) {
                this._size = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "bold", {
            get: function () {
                return this._bold ? this._bold : false;
            },
            set: function (value) {
                this._bold = value;
                if (this._font) {
                    this.font_table = this.font.get_font_table(this.style_name, TesselatedFontTable.assetType);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "italic", {
            get: function () {
                return this._italic ? this._italic : false;
            },
            set: function (value) {
                this._italic = value;
                if (this._font) {
                    this.font_table = this.font.get_font_table(this.style_name, TesselatedFontTable.assetType);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "underline", {
            get: function () {
                return this._underline ? this._underline : false;
            },
            set: function (value) {
                this._underline = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "font_table", {
            get: function () {
                if (!this._font_table) {
                    this.font_table = this.font.get_font_table(this.style_name, TesselatedFontTable.assetType);
                }
                return this._font_table;
            },
            set: function (value) {
                this._font_table = value;
                this._style_name = this._font_table.name;
                if (this._style_name == FontStyleName.ITALIC)
                    this._italic = true;
                if (this._style_name == FontStyleName.BOLD)
                    this._bold = true;
                if (this._style_name == FontStyleName.BOLDITALIC) {
                    this._bold = true;
                    this._italic = true;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "font_name", {
            get: function () {
                return this._font_name ? this._font_name : "";
            },
            set: function (value) {
                var newFont = DefaultFontManager.getFont(value);
                if (newFont) {
                    this._font = newFont;
                    this.font_table = newFont.get_font_table(FontStyleName.STANDART, TesselatedFontTable.assetType);
                    if (!this.font_table) {
                        console.log("could not find font-table on font", value, this._font);
                    }
                    if (this.font_table.get_font_chars().length == 0) {
                        this.font_table = newFont.get_font_table(FontStyleName.STANDART, TesselatedFontTable.assetType);
                        if (!this.font_table) {
                            console.log("could not find font-table on font", value, this._font);
                        }
                    }
                    this._font_name = value;
                }
                else {
                    console.log("could not find font for name ", value);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "style_name", {
            get: function () {
                if (!this._italic && !this._bold)
                    this._style_name = FontStyleName.STANDART;
                else if (this._italic && !this._bold)
                    this._style_name = FontStyleName.ITALIC;
                else if (!this._italic && this._bold)
                    this._style_name = FontStyleName.BOLD;
                else if (this._italic && this._bold)
                    this._style_name = FontStyleName.BOLDITALIC;
                return this._style_name;
            },
            set: function (value) {
                this._style_name = value;
                if (this._style_name == FontStyleName.BOLD || this._style_name == FontStyleName.BOLDITALIC)
                    this._bold = true;
                if (this._style_name == FontStyleName.ITALIC || this._style_name == FontStyleName.BOLDITALIC)
                    this._italic = true;
                if (this._font)
                    this.font_table = this.font.get_font_table(this._style_name, TesselatedFontTable.assetType);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "font", {
            get: function () {
                if (this._font) {
                    return this._font;
                }
                this._font = DefaultFontManager.getFont(null);
                this._font_table = this._font.get_font_table(FontStyleName.STANDART, TesselatedFontTable.assetType);
                return this._font;
            },
            set: function (value) {
                this._font_name = value.name;
                this._font = value;
                this._font_table = this._font.get_font_table(this._style_name, TesselatedFontTable.assetType);
            },
            enumerable: true,
            configurable: true
        });
        TextFormat.prototype.clone = function () {
            var clonedFormat = new TextFormat();
            this.applyToFormat(clonedFormat);
            return clonedFormat;
        };
        /*

        public cloneForStyle(style_name:FontStyleName):TextFormat{
            if(this._style_name==style_name){
                return this;
            }
            var clonedFormat:TextFormat=this.clone();
            clonedFormat.style_name=style_name;
            return clonedFormat;
        }*/
        TextFormat.prototype.applyToFormat = function (format) {
            /*if(this._style_name!==null){
                format.style_name=this._style_name;
            }*/
            if (this._font !== null) {
                format.font = this._font;
            }
            if (this._align !== null)
                format.align = this._align;
            if (this._leftMargin !== null)
                format.leftMargin = this._leftMargin;
            if (this._rightMargin !== null)
                format.rightMargin = this._rightMargin;
            if (this._indent !== null)
                format.indent = this._indent;
            if (this._size !== null)
                format.size = this._size;
            if (this._color !== null)
                format.color = this._color;
            if (this._bold !== null)
                format.bold = this._bold;
            if (this._italic !== null)
                format.italic = this._italic;
            if (this._underline !== null)
                format.underline = this._underline;
            if (this._leading !== null)
                format.leading = this._leading;
            if (this._letterSpacing !== null)
                format.letterSpacing = this._letterSpacing;
            //if(this._font_name!==null)
            //    format.font_name=this._font_name;
            return format;
        };
        Object.defineProperty(TextFormat.prototype, "assetType", {
            /**
             *
             */
            get: function () {
                return TextFormat.assetType;
            },
            enumerable: true,
            configurable: true
        });
        TextFormat.assetType = "[asset TextFormat]";
        return TextFormat;
    }(AssetBase));

    /**
     * The TextLineMetrics class contains information about the text position and
     * measurements of a line of text within a text field. All measurements are in
     * pixels. Objects of this class are returned by the
     * <code>away.entities.TextField.getLineMetrics()</code> method.
     */
    var TextLineMetrics = /** @class */ (function () {
        /**
         * Creates a TextLineMetrics object. The TextLineMetrics object contains
         * information about the text metrics of a line of text in a text field.
         * Objects of this class are returned by the
         * away.entities.TextField.getLineMetrics() method.
         *
         * @param x           The left position of the first character in pixels.
         * @param width       The width of the text of the selected lines (not
         *                    necessarily the complete text) in pixels.
         * @param height      The height of the text of the selected lines (not
         *                    necessarily the complete text) in pixels.
         * @param ascent      The length from the baseline to the top of the line
         *                    height in pixels.
         * @param descent     The length from the baseline to the bottom depth of
         *                    the line in pixels.
         * @param leading     The measurement of the vertical distance between the
         *                    lines of text.
         */
        function TextLineMetrics(x, width, height, ascent, descent, leading) {
            if (x === void 0) { x = NaN; }
            if (width === void 0) { width = NaN; }
            if (height === void 0) { height = NaN; }
            if (ascent === void 0) { ascent = NaN; }
            if (descent === void 0) { descent = NaN; }
            if (leading === void 0) { leading = NaN; }
        }
        // for AVM1:
        TextLineMetrics.prototype.axCallPublicProperty = function (value1, value2) {
            return null;
        };
        TextLineMetrics.prototype.axGetPublicProperty = function (value) {
            return null;
        };
        TextLineMetrics.prototype.axSetPublicProperty = function (value) {
            return null;
        };
        return TextLineMetrics;
    }());

    /**
     * @class away.events.CameraEvent
     */
    var KeyboardEvent = /** @class */ (function (_super) {
        __extends$3(KeyboardEvent, _super);
        function KeyboardEvent(type, char, charCode) {
            if (charCode === void 0) { charCode = 0; }
            var _this = _super.call(this, type) || this;
            _this._char = char;
            _this._charCode = charCode;
            _this.isShift = false;
            _this.isCTRL = false;
            _this.isAlt = false;
            return _this;
        }
        Object.defineProperty(KeyboardEvent.prototype, "char", {
            get: function () {
                return this._char;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(KeyboardEvent.prototype, "charCode", {
            get: function () {
                return this._charCode;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the event.
         * @return An exact duplicate of the current object.
         */
        KeyboardEvent.prototype.clone = function () {
            return new KeyboardEvent(this.type, this._char, this._charCode);
        };
        KeyboardEvent.KEYDOWN = "keydown";
        KeyboardEvent.KEYUP = "keyup";
        return KeyboardEvent;
    }(EventBase));

    /**
     * A FocusEvent is dispatched when a entity is focused
     */
    var TextfieldEvent = /** @class */ (function (_super) {
        __extends$3(TextfieldEvent, _super);
        /**
         * Create a new MouseEvent object.
         * @param type The type of the MouseEvent.
         */
        function TextfieldEvent(type) {
            return _super.call(this, type) || this;
        }
        /**
         * Creates a copy of the MouseEvent object and sets the value of each property to match that of the original.
         */
        TextfieldEvent.prototype.clone = function () {
            var result = new TextfieldEvent(this.type);
            return result;
        };
        /**
         * Defines the value of the type property of a focusIn3d event object.
         */
        TextfieldEvent.CHANGED = "onChanged";
        return TextfieldEvent;
    }(EventBase));

    /**
     * TextSprite is used for masked text. It is a child of the textfield that is used to render all visible (masked) graphics
     */
    var TextSprite = /** @class */ (function (_super) {
        __extends$3(TextSprite, _super);
        function TextSprite() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        TextSprite.prototype._acceptTraverser = function (traverser) {
            var tf = this.parentTextField;
            tf.reConstruct(true);
            if (tf._textFormat && !tf._textFormat.font_table.isAsset(TesselatedFontTable) && !tf._textFormat.material) {
                var new_ct = tf.transform.colorTransform || (tf.transform.colorTransform = new ColorTransform());
                this.transform.colorTransform.color = (tf.textColor != null) ? tf.textColor : tf._textFormat.color;
                this._invalidateHierarchicalProperties(HierarchicalProperties.COLOR_TRANSFORM);
            }
            /*if(!tf.cursorBlinking &&  tf.isInFocus && tf.cursorShape && tf._type==TextFieldType.INPUT){
                traverser[tf.cursorShape.elements.traverseName](tf.cursorShape);
            }*/
            this._graphics._acceptTraverser(traverser);
            //if(tf.showSelection && tf.isInFocus && tf.bgShapeSelect){
            //	traverser[tf.bgShapeSelect.elements.traverseName](tf.bgShapeSelect);
            //}
            //if(tf.bgShape && tf.background){
            //	traverser[tf.bgShape.elements.traverseName](tf.bgShape);
            //}
        };
        return TextSprite;
    }(Sprite));

    var TextShape = /** @class */ (function () {
        function TextShape() {
            this.verts = [];
        }
        return TextShape;
    }());

    var HTMLTextProcessor = /** @class */ (function () {
        function HTMLTextProcessor() {
        }
        HTMLTextProcessor.get = function () {
            if (!HTMLTextProcessor.instance)
                HTMLTextProcessor.instance = new HTMLTextProcessor();
            return HTMLTextProcessor.instance;
        };
        HTMLTextProcessor.prototype.processHTML = function (target_tf, input) {
            //console.log("html in", input);
            input = input.replace(new RegExp("&nbsp;", 'g'), " ");
            input = input.replace(new RegExp("â", 'g'), String.fromCharCode(8730));
            input = input.replace(new RegExp("Ã", 'g'), String.fromCharCode(215));
            input = input.replace(new RegExp("<\\\\", 'g'), "</");
            input = input.replace(new RegExp("<br>", 'g'), "<br/>");
            input = input.replace(new RegExp("<BR>", 'g'), "<br/>");
            input = input.replace(new RegExp("<BR/>", 'g'), "<br/>");
            input = input.replace(new RegExp("<B", 'g'), "<b");
            input = input.replace(new RegExp("</B>", 'g'), "</b>");
            input = input.replace(new RegExp("<I", 'g'), "<i");
            input = input.replace(new RegExp("</I>", 'g'), "</i>");
            input = input.replace(new RegExp("<P", 'g'), "<p");
            input = input.replace(new RegExp("</P>", 'g'), "</p>");
            input = input.replace(new RegExp("<U", 'g'), "<u");
            input = input.replace(new RegExp("</U>", 'g'), "</u>");
            input = input.replace(new RegExp("<LI", 'g'), "<li");
            input = input.replace(new RegExp("</LI>", 'g'), "</li>");
            input = input.replace(new RegExp("<FONT", 'g'), "<font");
            input = input.replace(new RegExp("</FONT>", 'g'), "</font>");
            input = input.replace(new RegExp("& ", 'g'), "&amp; ");
            // 	some preprocessing to make sure that html-tags are closing
            // 	todo: this can probably be done better
            var cnt = 0;
            var openTags = [];
            var insertAt = [];
            var insert = [];
            while (cnt < input.length) {
                if (input[cnt] == "<") {
                    if (input[cnt + 1] == "p") {
                        //console.log("html p");
                        openTags[openTags.length] = "p";
                    }
                    else if (input[cnt + 1] == "b" && input[cnt + 2] != "r") {
                        //console.log("html b");
                        openTags[openTags.length] = "b";
                    }
                    else if (input[cnt + 1] == "i") {
                        //console.log("html i");
                        openTags[openTags.length] = "i";
                    }
                    else if (input[cnt + 1] == "u") {
                        //console.log("html i");
                        openTags[openTags.length] = "u";
                    }
                    else if (input[cnt + 1] == "f" && input[cnt + 2] == "o" && input[cnt + 3] == "n" && input[cnt + 4] == "t") {
                        //console.log("html font");
                        openTags[openTags.length] = "font";
                        cnt += 2;
                    }
                    else if (input[cnt + 1] == "l" && input[cnt + 2] == "i") {
                        //console.log("html font");
                        openTags[openTags.length] = "li";
                        cnt++;
                    }
                    else if (input[cnt + 1] == "/" && input[cnt + 2] == "p") {
                        var c = openTags.length;
                        var lastOpenTag = -1;
                        while (c > 0) {
                            c--;
                            if (openTags[c] == "p") {
                                lastOpenTag = c;
                                break;
                            }
                        }
                        if (lastOpenTag < 0) {
                            insertAt[insertAt.length] = cnt;
                            insert[insert.length] = 4;
                        }
                        else {
                            var c = openTags.length - 1;
                            while (c > lastOpenTag) {
                                insertAt[insertAt.length] = cnt;
                                insert[insert.length] = "</" + openTags[c] + ">";
                                openTags.pop();
                                c--;
                            }
                            openTags.pop();
                        }
                    }
                    else if (input[cnt + 1] == "/" && input[cnt + 2] == "b") {
                        var c = openTags.length;
                        var lastOpenTag = -1;
                        while (c > 0) {
                            c--;
                            if (openTags[c] == "b") {
                                lastOpenTag = c;
                                break;
                            }
                        }
                        if (lastOpenTag < 0) {
                            insertAt[insertAt.length] = cnt;
                            insert[insert.length] = 4;
                        }
                        else {
                            var c = openTags.length - 1;
                            while (c > lastOpenTag) {
                                insertAt[insertAt.length] = cnt;
                                insert[insert.length] = "</" + openTags[c] + ">";
                                openTags.pop();
                                c--;
                            }
                            openTags.pop();
                        }
                    }
                    else if (input[cnt + 1] == "/" && input[cnt + 2] == "i") {
                        var c = openTags.length;
                        var lastOpenTag = -1;
                        while (c > 0) {
                            c--;
                            if (openTags[c] == "i") {
                                lastOpenTag = c;
                                break;
                            }
                        }
                        if (lastOpenTag < 0) {
                            insertAt[insertAt.length] = cnt;
                            insert[insert.length] = 4;
                        }
                        else {
                            var c = openTags.length - 1;
                            while (c > lastOpenTag) {
                                insertAt[insertAt.length] = cnt;
                                insert[insert.length] = "</" + openTags[c] + ">";
                                openTags.pop();
                                c--;
                            }
                            openTags.pop();
                        }
                    }
                    else if (input[cnt + 1] == "/" && input[cnt + 2] == "u") {
                        var c = openTags.length;
                        var lastOpenTag = -1;
                        while (c > 0) {
                            c--;
                            if (openTags[c] == "u") {
                                lastOpenTag = c;
                                break;
                            }
                        }
                        if (lastOpenTag < 0) {
                            insertAt[insertAt.length] = cnt;
                            insert[insert.length] = 4;
                        }
                        else {
                            var c = openTags.length - 1;
                            while (c > lastOpenTag) {
                                insertAt[insertAt.length] = cnt;
                                insert[insert.length] = "</" + openTags[c] + ">";
                                openTags.pop();
                                c--;
                            }
                            openTags.pop();
                        }
                    }
                    else if (input[cnt + 1] == "/" && input[cnt + 2] == "l" && input[cnt + 3] == "i") {
                        var c = openTags.length;
                        var lastOpenTag = -1;
                        while (c > 0) {
                            c--;
                            if (openTags[c] == "li") {
                                lastOpenTag = c;
                                break;
                            }
                        }
                        if (lastOpenTag < 0) {
                            insertAt[insertAt.length] = cnt;
                            insert[insert.length] = 7;
                        }
                        else {
                            var c = openTags.length - 1;
                            while (c > lastOpenTag) {
                                insertAt[insertAt.length] = cnt;
                                insert[insert.length] = "</" + openTags[c] + ">";
                                openTags.pop();
                                c--;
                            }
                            openTags.pop();
                        }
                    }
                    else if (input[cnt + 1] == "/" && input[cnt + 2] == "f" && input[cnt + 3] == "o" && input[cnt + 4] == "n" && input[cnt + 5] == "t") {
                        var c = openTags.length;
                        var lastOpenTag = -1;
                        while (c > 0) {
                            c--;
                            if (openTags[c] == "font") {
                                lastOpenTag = c;
                                break;
                            }
                        }
                        if (lastOpenTag < 0) {
                            insertAt[insertAt.length] = cnt;
                            insert[insert.length] = 7;
                        }
                        else {
                            var c = openTags.length - 1;
                            while (c > lastOpenTag) {
                                insertAt[insertAt.length] = cnt;
                                insert[insert.length] = "</" + openTags[c] + ">";
                                openTags.pop();
                                c--;
                            }
                            openTags.pop();
                        }
                    }
                    cnt++;
                }
                else {
                    cnt++;
                }
            }
            var c = openTags.length;
            while (c > 0) {
                c--;
                insertAt[insertAt.length] = cnt;
                insert[insert.length] = "</" + openTags[c] + ">";
            }
            var additional = 0;
            var len = insert.length;
            for (var i = 0; i < len; i++) {
                if (typeof insert[i] === "number") {
                    input = input.slice(0, insertAt[i] + additional) + input.slice(insertAt[i] + additional + insert[i]);
                    additional -= insert[i];
                }
                else {
                    input = input.slice(0, insertAt[i] + additional) + insert[i] + input.slice(insertAt[i] + additional);
                    additional += insert[i].length;
                }
            }
            //console.log("html fixed",  input);
            var textProps = {
                text: ""
                /*size:this.textFormat.size,
                color:this.textFormat.color,
                indent:this.le,
                leftMargin:symbol.tag.leftMargin/20,
                rightMargin:symbol.tag.rightMargin/20,
                variableName:symbol.tag.variableName,
                align:symbol.tag.align,
                multiline:false*/
            };
            target_tf._textFormat.italic = false;
            target_tf._textFormat.bold = false;
            target_tf._textFormat.align = TextFormatAlign.LEFT;
            target_tf._textFormats = [target_tf._textFormat];
            //target_tf._textFormat.size=16;
            target_tf._textFormatsIdx = [0];
            var parser = new DOMParser();
            var doc = parser.parseFromString("<p>" + input + "</p>", "application/xml");
            if (doc && doc.firstChild) {
                textProps.multiline = doc.firstChild.childNodes.length > 0;
                var startNode = doc;
                if (doc.firstChild.childNodes.length > 0) {
                    if (doc.firstChild.childNodes[0].nodeName == "parsererror") {
                        startNode = doc.firstChild.childNodes[1];
                        //console.log("html errored",  doc.firstChild);
                    }
                }
                this.readHTMLTextPropertiesRecursive(target_tf, startNode, textProps, target_tf._textFormat);
            }
            if (textProps.text != "" && ((textProps.text.charCodeAt(textProps.text.length - 1) == 13) || (textProps.text.charCodeAt(textProps.text.length - 1) == 10))) {
                textProps.text = textProps.text.slice(0, textProps.text.length - 1);
            }
            if (textProps.text != "" && (textProps.text.length >= 3 && textProps.text[textProps.text.length - 1] == "n" && textProps.text[textProps.text.length - 2] == "\\" && textProps.text[textProps.text.length - 3] == "\\")) {
                textProps.text = textProps.text.slice(0, textProps.text.length - 3);
            }
            else if (textProps.text != "" && (textProps.text.length >= 2 && textProps.text[textProps.text.length - 1] == "n" && textProps.text[textProps.text.length - 2] == "\\")) {
                textProps.text = textProps.text.slice(0, textProps.text.length - 2);
            }
            if (textProps.text != "" && (textProps.text.length >= 3 && textProps.text[textProps.text.length - 1] == "n" && textProps.text[textProps.text.length - 2] == "\\" && textProps.text[textProps.text.length - 3] == "\\")) {
                textProps.text = textProps.text.slice(0, textProps.text.length - 3);
            }
            else if (textProps.text != "" && (textProps.text.length >= 2 && textProps.text[textProps.text.length - 1] == "n" && textProps.text[textProps.text.length - 2] == "\\")) {
                textProps.text = textProps.text.slice(0, textProps.text.length - 2);
            }
            target_tf._textFormatsIdx[target_tf._textFormatsIdx.length - 1] = textProps.text.length;
            return textProps.text;
        };
        HTMLTextProcessor.prototype.readHTMLTextPropertiesRecursive = function (target_tf, myChild, textProps, currentFormat) {
            //console.log("textfied content xml node:",myChild);
            //console.log(myChild.tagName);
            var newProps_values = [];
            var newProps_names = [];
            if (myChild.attributes) {
                if (myChild.attributes.size || myChild.attributes.SIZE) {
                    var value = myChild.attributes.size ? myChild.attributes.size.nodeValue : myChild.attributes.SIZE.nodeValue;
                    value = value.replace(/[^0-9.]/g, "");
                    newProps_values[newProps_values.length] = parseInt(value);
                    newProps_names[newProps_names.length] = "size";
                }
                if (myChild.attributes.color || myChild.attributes.COLOR) {
                    var value = myChild.attributes.color ? myChild.attributes.color.nodeValue : myChild.attributes.COLOR.nodeValue;
                    value = value.replace("#", "0x");
                    newProps_values[newProps_values.length] = parseInt(value);
                    newProps_names[newProps_names.length] = "color";
                }
                if (myChild.attributes.indent || myChild.attributes.INDENT) {
                    var value = myChild.attributes.indent ? myChild.attributes.indent.nodeValue : myChild.attributes.INDENT.nodeValue;
                    value = value.replace(/[^0-9.]/g, "");
                    newProps_values[newProps_values.length] = parseInt(value);
                    newProps_names[newProps_names.length] = "indent";
                }
                if (myChild.attributes.leftMargin || myChild.attributes.LEFTMARGIN) {
                    var value = myChild.attributes.leftMargin ? myChild.attributes.leftMargin.nodeValue : myChild.attributes.LEFTMARGIN.nodeValue;
                    value = value.replace(/[^0-9.]/g, "");
                    newProps_values[newProps_values.length] = parseInt(value);
                    newProps_names[newProps_names.length] = "leftMargin";
                }
                if (myChild.attributes.rightMargin || myChild.attributes.RIGHTMARGIN) {
                    var value = myChild.attributes.rightMargin ? myChild.attributes.rightMargin.nodeValue : myChild.attributes.RIGHTMARGIN.nodeValue;
                    value = value.replace(/[^0-9.]/g, "");
                    newProps_values[newProps_values.length] = parseInt(value);
                    newProps_names[newProps_names.length] = "rightMargin";
                }
                if (myChild.attributes.align || myChild.attributes.ALIGN) {
                    var value = myChild.attributes.align ? myChild.attributes.align.nodeValue : myChild.attributes.ALIGN.nodeValue;
                    newProps_values[newProps_values.length] = value;
                    newProps_names[newProps_names.length] = "align";
                }
                if (myChild.attributes.face || myChild.attributes.FACE) {
                    var value = myChild.attributes.face ? myChild.attributes.face.nodeValue : myChild.attributes.FACE.nodeValue;
                    newProps_values[newProps_values.length] = value;
                    newProps_names[newProps_names.length] = "font_name";
                }
            }
            var i = newProps_values.length;
            var cloneFormat = false;
            while (i > 0) {
                i--;
                if (currentFormat[newProps_names[i]] != newProps_values[i]) {
                    cloneFormat = true;
                    break;
                }
            }
            /*if(target_tf._textFormats[target_tf._textFormats.length-1]!=currentFormat){
                target_tf._textFormats.push(currentFormat);
                target_tf._textFormatsIdx.push(textProps.text.length);

            }*/
            // check if this is a paragraph. if it is, we want to add a linebreak in case there is text already present
            // we also check if there is already a linebreak in the text, and do not add another if there is
            if (myChild.tagName == "p") {
                /*if(textProps.text!="" && !(textProps.text.length>2 && textProps.text[textProps.text.length-1]=="n"&& textProps.text[textProps.text.length-2]=="\\")){
                            
                    textProps.text+="\\n";
                }*/
            }
            // if this is a bold-tag, we create a new textformat if the current format is not bold
            else if (myChild.tagName == "b") {
                if (!currentFormat.bold) {
                    cloneFormat = true;
                    newProps_values[newProps_values.length] = true;
                    newProps_names[newProps_names.length] = "bold";
                }
            }
            // if this is a italic-tag, we create a new textformat if the current format is not italic
            else if (myChild.tagName == "i") {
                if (!currentFormat.italic) {
                    cloneFormat = true;
                    newProps_values[newProps_values.length] = true;
                    newProps_names[newProps_names.length] = "italic";
                }
            }
            else if (myChild.tagName == "u") {
                if (!currentFormat.underline) {
                    cloneFormat = true;
                    newProps_values[newProps_values.length] = true;
                    newProps_names[newProps_names.length] = "underline";
                }
            }
            else if (myChild.tagName == "font") {
                // todo 
                cloneFormat = true;
            }
            else if (myChild.tagName == "li") {
                /*	if(textProps.text!="" && !(textProps.text.length>2 && textProps.text[textProps.text.length-1]=="n"&& textProps.text[textProps.text.length-2]=="\\")){
                        textProps.text+="\\n";
                    }*/
                textProps.text += "    ●    ";
            }
            else if (myChild.tagName == "br") {
                textProps.text += "\\n";
            }
            var childFormat = currentFormat;
            if (cloneFormat) {
                childFormat = currentFormat.clone(); //(FontStyleName.BOLD);
                i = newProps_values.length;
                while (i > 0) {
                    i--;
                    childFormat[newProps_names[i]] = newProps_values[i];
                }
                target_tf._textFormats.push(childFormat);
                target_tf._textFormatsIdx[target_tf._textFormatsIdx.length - 1] = textProps.text.length;
                target_tf._textFormatsIdx.push(textProps.text.length);
            }
            // if the node has children, we just traverse children, and do not consider adding the nodeValue as text
            // todo: double check if above behavior is true for html text
            if (myChild.childNodes && myChild.childNodes.length > 0) {
                for (var k = 0; k < myChild.childNodes.length; k++) {
                    if (target_tf._textFormats[target_tf._textFormats.length - 1] != childFormat) {
                        target_tf._textFormats.push(childFormat);
                        target_tf._textFormatsIdx[target_tf._textFormatsIdx.length - 1] = textProps.text.length;
                        target_tf._textFormatsIdx.push(textProps.text.length);
                    }
                    this.readHTMLTextPropertiesRecursive(target_tf, myChild.childNodes[k], textProps, childFormat);
                }
            }
            else {
                // if nodeValue exists, we add it to the text
                if (myChild.nodeValue) {
                    // if a nodes content contains only line-breaks or whitespace, flash seem to ignore it
                    var testContent = myChild.nodeValue.replace(/[\s\r\n]/gi, '');
                    if (testContent != "") {
                        //if(!myChild.tagName){
                        //	textProps.text+="\\n";
                        //}
                        textProps.text += myChild.nodeValue.replace("\n", "\\n");
                    }
                }
            }
            if (myChild.tagName == "li" || myChild.tagName == "p") {
                //if(textProps.text!="" && !(textProps.text.length>=2 && textProps.text[textProps.text.length-1]=="n"&& textProps.text[textProps.text.length-2]=="\\")){
                textProps.text += "\\n";
                //}						
            }
        };
        return HTMLTextProcessor;
    }());

    /**
     * The TextField class is used to create display objects for text display and
     * input. <ph outputclass="flexonly">You can use the TextField class to
     * perform low-level text rendering. However, in Flex, you typically use the
     * Label, Text, TextArea, and TextInput controls to process text. <ph
     * outputclass="flashonly">You can give a text field an instance name in the
     * Property inspector and use the methods and properties of the TextField
     * class to manipulate it with ActionScript. TextField instance names are
     * displayed in the Movie Explorer and in the Insert Target Path dialog box in
     * the Actions panel.
     *
     * <p>To create a text field dynamically, use the <code>TextField()</code>
     * constructor.</p>
     *
     * <p>The methods of the TextField class let you set, select, and manipulate
     * text in a dynamic or input text field that you create during authoring or
     * at runtime. </p>
     *
     * <p>ActionScript provides several ways to format your text at runtime. The
     * TextFormat class lets you set character and paragraph formatting for
     * TextField objects. You can apply Cascading Style Sheets(CSS) styles to
     * text fields by using the <code>TextField.styleSheet</code> property and the
     * StyleSheet class. You can use CSS to style built-in HTML tags, define new
     * formatting tags, or apply styles. You can assign HTML formatted text, which
     * optionally uses CSS styles, directly to a text field. HTML text that you
     * assign to a text field can contain embedded media(movie clips, SWF files,
     * GIF files, PNG files, and JPEG files). The text wraps around the embedded
     * media in the same way that a web browser wraps text around media embedded
     * in an HTML document. </p>
     *
     * <p>Flash Player supports a subset of HTML tags that you can use to format
     * text. See the list of supported HTML tags in the description of the
     * <code>htmlText</code> property.</p>
     *
     * @event change                    Dispatched after a control value is
     *                                  modified, unlike the
     *                                  <code>textInput</code> event, which is
     *                                  dispatched before the value is modified.
     *                                  Unlike the W3C DOM Event Model version of
     *                                  the <code>change</code> event, which
     *                                  dispatches the event only after the
     *                                  control loses focus, the ActionScript 3.0
     *                                  version of the <code>change</code> event
     *                                  is dispatched any time the control
     *                                  changes. For example, if a user types text
     *                                  into a text field, a <code>change</code>
     *                                  event is dispatched after every keystroke.
     * @event link                      Dispatched when a user clicks a hyperlink
     *                                  in an HTML-enabled text field, where the
     *                                  URL begins with "event:". The remainder of
     *                                  the URL after "event:" is placed in the
     *                                  text property of the LINK event.
     *
     *                                  <p><b>Note:</b> The default behavior,
     *                                  adding the text to the text field, occurs
     *                                  only when Flash Player generates the
     *                                  event, which in this case happens when a
     *                                  user attempts to input text. You cannot
     *                                  put text into a text field by sending it
     *                                  <code>textInput</code> events.</p>
     * @event scroll                    Dispatched by a TextField object
     *                                  <i>after</i> the user scrolls.
     * @event textInput                 Flash Player dispatches the
     *                                  <code>textInput</code> event when a user
     *                                  enters one or more characters of text.
     *                                  Various text input methods can generate
     *                                  this event, including standard keyboards,
     *                                  input method editors(IMEs), voice or
     *                                  speech recognition systems, and even the
     *                                  act of pasting plain text with no
     *                                  formatting or style information.
     * @event textInteractionModeChange Flash Player dispatches the
     *                                  <code>textInteractionModeChange</code>
     *                                  event when a user changes the interaction
     *                                  mode of a text field. for example on
     *                                  Android, one can toggle from NORMAL mode
     *                                  to SELECTION mode using context menu
     *                                  options
     */
    var TextField = /** @class */ (function (_super) {
        __extends$3(TextField, _super);
        /**
         * Creates a new TextField instance. After you create the TextField instance,
         * call the <code>addChild()</code> or <code>addChildAt()</code> method of
         * the parent DisplayObjectContainer object to add the TextField instance to
         * the display list.
         *
         * <p>The default size for a text field is 100 x 100 pixels.</p>
         */
        function TextField() {
            var _this = _super.call(this) || this;
            _this._isEntity = false;
            _this.textOffsetX = 0;
            _this.textOffsetY = 0;
            _this._selectionBeginIndex = 0;
            _this._selectionEndIndex = 0;
            _this._biggestLine = 0;
            _this._iText = "";
            _this._text = "";
            _this.inMaskMode = false;
            _this.cursorIntervalID = -1;
            _this.cursorBlinking = false;
            _this.showSelection = false;
            _this._textDirty = false; // if text is dirty, the text-content or the text-size has changed, and we need to recalculate word-width
            _this._positionsDirty = false; // if formatting is dirty, we need to recalculate text-positions / size
            _this._glyphsDirty = false; // if glyphs are dirty, we need to recollect the glyphdata and build the text-graphics. this should ony be done max once a frame
            _this._shapesDirty = false;
            _this.chars_codes = []; // stores charcode per char
            _this.chars_width = [];
            _this.tf_per_char = [];
            _this.words = []; // stores offset and length and width for each word
            _this._textRuns_formats = []; // stores textFormat for each textrun
            _this._textRuns_words = []; // stores words-offset, word-count and width for each textrun
            _this._paragraph_textRuns_indices = []; // stores textFormat for each textrun
            _this._maxWidthLine = 0;
            _this._labelData = null;
            _this.lines_wordStartIndices = [];
            _this.lines_wordEndIndices = [];
            _this.lines_start_y = [];
            _this.lines_start_x = [];
            _this.lines_charIdx_start = [];
            _this.lines_charIdx_end = [];
            _this.lines_width = [];
            _this.lines_height = [];
            _this.lines_numSpacesPerline = [];
            _this.char_positions_x = [];
            _this.char_positions_y = [];
            // keeping track of the original textfield that was used for cloning this one.
            _this.sourceTextField = null;
            _this._maskWidth = 0;
            _this._maskHeight = 0;
            _this._maskTextOffsetX = 0;
            _this._maskTextOffsetY = 0;
            _this.isStatic = false;
            _this._internalScale = new Vector3D(1, 1, 1);
            _this.onKeyDelegate = function (event) { return _this.onKey(event); };
            _this.startSelectionByMouseDelegate = function (event) { return _this.startSelectionByMouse(event); };
            _this.stopSelectionByMouseDelegate = function (event) { return _this.stopSelectionByMouse(event); };
            _this.updateSelectionByMouseDelegate = function (event) { return _this.updateSelectionByMouse(event); };
            _this._onGraphicsInvalidateDelegate = function (event) { return _this._onGraphicsInvalidate(event); };
            _this.cursorIntervalID = -1;
            _this._tabEnabled = true;
            _this.cursorType = "text";
            _this.textOffsetX = 0;
            _this.textOffsetY = 0;
            _this.textShapes = {};
            _this._textColor = 0;
            _this._width = 100;
            _this._height = 100;
            _this._textWidth = 0;
            _this._textHeight = 0;
            _this._type = TextFieldType.DYNAMIC;
            _this._selectable = false;
            _this._numLines = 0;
            _this.multiline = false;
            _this._autoSize = TextFieldAutoSize.NONE;
            _this._wordWrap = false;
            _this._background = false;
            _this._backgroundColor = 0xffffff;
            _this._border = false;
            _this._borderColor = 0x000000;
            _this.html = false;
            _this.maxChars = 0;
            _this._selectionBeginIndex = 0;
            _this._selectionEndIndex = 0;
            _this._graphics = Graphics.getGraphics(); //unique graphics object for each TextField
            _this._graphics.addEventListener(AssetEvent.INVALIDATE, _this._onGraphicsInvalidateDelegate);
            _this.mouseEnabled = _this._selectable;
            return _this;
        }
        TextField.getNewTextField = function () {
            return (TextField._textFields.length) ? TextField._textFields.pop() : new TextField();
        };
        TextField.clearPool = function () {
            TextField._textFields = [];
        };
        TextField.prototype.updateMaskMode = function () {
            //if(this._textWidth>this._width || this._textHeight>this._height){
            // mask needed
            if (this.inMaskMode) {
                if (this._maskWidth != this._width || this._maskHeight != this._height ||
                    this._maskTextOffsetX != this.textOffsetX || this._maskTextOffsetY != this.textOffsetY) {
                    this._maskWidth = this._width;
                    this._maskHeight = this._height;
                    this._maskTextOffsetX = this.textOffsetX;
                    this._maskTextOffsetY = this.textOffsetY;
                    this.maskChild.graphics.clear();
                    this.maskChild.graphics.beginFill(0xffffff);
                    this.maskChild.graphics.drawRect(this.textOffsetX, this.textOffsetY, this._width, this._height);
                    this.maskChild.graphics.endFill();
                }
                this._graphics.clear();
            }
            if (!this.inMaskMode) {
                // 	masking already setup 
                // 	just make sure the mask has correct size 
                this.inMaskMode = true;
                if (!this.maskChild)
                    this.maskChild = new Sprite();
                if (!this.textChild)
                    this.textChild = new TextSprite();
                this.textChild.mouseEnabled = false;
                this.textChild.parentTextField = this;
                this.maskChild.mouseEnabled = false;
                this.maskChild.graphics.beginFill(0xffffff);
                this.maskChild.graphics.drawRect(this.textOffsetX, this.textOffsetY, this._width, this._height);
                this.maskChild.graphics.endFill();
                this.addChild(this.maskChild);
                this.addChild(this.textChild);
                this.maskChild.maskMode = true;
                this.textChild.masks = [this.maskChild];
                this._graphics.clear();
                this.targetGraphics = this.textChild.graphics;
                return;
            }
            return;
            //}
            // mask not needed
            /*this.inMaskMode=false;
            if(this.textChild)
                this.textChild.graphics.clear();
            this.targetGraphics=this._graphics;
            if(this.numChildren>0)
                this.removeChildren(0, this.numChildren);*/
        };
        TextField.prototype.getMouseCursor = function () {
            return this.cursorType;
        };
        Object.defineProperty(TextField.prototype, "isInFocus", {
            get: function () {
                return this._isInFocus;
            },
            set: function (value) {
            },
            enumerable: true,
            configurable: true
        });
        TextField.prototype.setFocus = function (value, fromMouseDown, sendSoftKeyEvent) {
            if (fromMouseDown === void 0) { fromMouseDown = false; }
            if (sendSoftKeyEvent === void 0) { sendSoftKeyEvent = true; }
            if (this._isInFocus == value) {
                return;
            }
            _super.prototype.setFocus.call(this, value, fromMouseDown, sendSoftKeyEvent);
            this.enableInput(value);
            if (value) {
                this.setSelection(0, this._iText.length);
            }
            else {
                this.setSelection(0, 0);
            }
            // check if a adapter exists
            if (value && sendSoftKeyEvent && this.adapter != this) {
                // todo: create a ITextFieldAdapter, so we can use selectText() without casting to any
                this.adapter.selectTextField(fromMouseDown);
            }
            this._glyphsDirty = true;
            if (this._implicitPartition)
                this._implicitPartition.invalidateEntity(this);
        };
        TextField.prototype.enableInput = function (enable) {
            if (enable === void 0) { enable = true; }
            if (this.cursorIntervalID >= 0) {
                window.clearInterval(this.cursorIntervalID);
                this.cursorIntervalID = -1;
            }
            if (enable && this._isInFocus && this.selectable) {
                this.drawSelectionGraphics();
                var myThis = this;
                this.cursorIntervalID = window.setInterval(function () {
                    myThis.cursorBlinking = !myThis.cursorBlinking;
                    if (!myThis.selectable) {
                        myThis.cursorBlinking = true;
                    }
                    myThis._shapesDirty = true;
                    myThis.invalidate();
                }, 500);
            }
        };
        TextField.prototype.findCharIdxForMouse = function (event) {
            var myPoint = this.textChild.transform.globalToLocal(new Point(event.scenePosition.x, event.scenePosition.y));
            var lineIdx = this.getLineIndexAtPoint(myPoint.x, myPoint.y);
            var charIdx = this.getCharIndexAtPoint(myPoint.x, myPoint.y, lineIdx);
            if (lineIdx >= this.lines_start_x.length)
                lineIdx = this.lines_start_x.length - 1;
            if (lineIdx >= 0 && charIdx < 0 && this.lines_start_x[lineIdx]) {
                if (myPoint.x <= this.lines_start_x[lineIdx])
                    charIdx = this.lines_charIdx_start[lineIdx];
                else
                    charIdx = this.lines_charIdx_end[lineIdx];
            }
            if (lineIdx < 0 || charIdx < 0)
                charIdx = 0;
            //console.log("lineIdx", lineIdx, "charIdx", charIdx);
            return charIdx;
        };
        TextField.prototype.startSelectionByMouse = function (event) {
            this._selectionBeginIndex = this.findCharIdxForMouse(event);
            this._selectionEndIndex = this._selectionBeginIndex;
            //console.log("startSelectionByMouse", this._selectionBeginIndex, this._selectionEndIndex);	
            this._glyphsDirty = true;
            this.reConstruct();
            this.cursorBlinking = false;
            this.drawSelectionGraphics();
        };
        TextField.prototype.stopSelectionByMouse = function (event) {
            this._selectionEndIndex = this.findCharIdxForMouse(event);
            //console.log("stopSelectionByMouse", this._selectionBeginIndex, this._selectionEndIndex);
            this._glyphsDirty = true;
            this.reConstruct();
            this.drawSelectionGraphics();
        };
        TextField.prototype.updateSelectionByMouse = function (event) {
            this._selectionEndIndex = this.findCharIdxForMouse(event);
            //console.log("updateSelectionByMouse", this._selectionBeginIndex, this._selectionEndIndex);
            this._glyphsDirty = true;
            this.reConstruct();
            this.drawSelectionGraphics();
        };
        TextField.prototype.drawSelectionGraphics = function () {
            if (this._selectionBeginIndex < 0) {
                this._selectionBeginIndex = 0;
            }
            if (this._selectionBeginIndex > this.char_positions_x.length) {
                this._selectionBeginIndex = this.char_positions_x.length;
            }
            if (this._selectionEndIndex < 0) {
                this._selectionEndIndex = 0;
            }
            if (this._selectionEndIndex > this.char_positions_x.length) {
                this._selectionEndIndex = this.char_positions_x.length;
            }
            if (this._selectionBeginIndex == this._selectionEndIndex) {
                this.bgShapeSelect = null;
                this.drawCursor();
            }
            else {
                this.showSelection = true;
                this.drawSelectedBG();
            }
        };
        TextField.prototype.scrollToCursor = function (x, y) {
            // if(!this.textChild){
            //     return;
            // }
            // if(x>this._width){
            //     this.textChild.x-=10;
            // }
            // if(x<Math.abs(this.textChild.x)){
            //     this.textChild.x=this.textChild.x+x+2;
            // }
            // if(this.textChild.x<(this._width-this.textChild.width)){
            //     this.textChild.x=this._width-this.textChild.width;
            // }
            // if(this.textChild.x>0){
            //     this.textChild.x=0;
            // }
        };
        TextField.prototype.drawCursor = function () {
            this._shapesDirty = true;
            if (this.cursorBlinking || !this.selectable || this.selectionBeginIndex != this.selectionEndIndex) {
                this.cursorShape = null;
                return;
            }
            var x = 0;
            var y = 0;
            var tf = this.newTextFormat;
            if (this.char_positions_x.length == 0) {
                x = this.textOffsetX + (this._width / 2) + this._textWidth / 2;
                if (tf.align == "justify") {
                }
                else if (tf.align == "center") {
                }
                else if (tf.align == "right") {
                    x = this.textOffsetX + this._width - 2;
                }
                else if (tf.align == "left") {
                    x = this.textOffsetX + 4 + this._textWidth;
                }
            }
            else if (this._selectionBeginIndex == this.char_positions_x.length) {
                x = this.char_positions_x[this._selectionBeginIndex - 1] + this.chars_width[this._selectionBeginIndex - 1];
                y = this.char_positions_y[this._selectionBeginIndex - 1];
                tf = this.tf_per_char[this._selectionBeginIndex - 1];
            }
            else {
                x = this.char_positions_x[this._selectionBeginIndex];
                y = this.char_positions_y[this._selectionBeginIndex];
                tf = this.tf_per_char[this._selectionBeginIndex];
            }
            tf.font_table.initFontSize(tf.size);
            var height = tf.font_table.getLineHeight();
            var color = this.getTextColorForTextFormat(tf);
            var cursorScale = this.internalScale.x;
            if (cursorScale <= 0)
                cursorScale = 1;
            this.cursorShape = GraphicsFactoryHelper.drawRectangles([x - (0.5 * cursorScale), y, cursorScale, height], color, 1);
            this.cursorShape.usages++; //TODO: get rid of this memory leak
            if (this.cursorShape.style.color != color) {
                var alpha = ColorUtils.float32ColorToARGB(color)[0];
                if (alpha == 0) {
                    alpha = 255;
                }
                var obj = Graphics.get_material_for_color(color, alpha / 255);
                if (obj.colorPos) {
                    this.cursorShape.style = new Style();
                    var sampler = new ImageSampler();
                    obj.material.animateUVs = true;
                    this.cursorShape.style.color = color;
                    this.cursorShape.style.addSamplerAt(sampler, obj.material.getTextureAt(0));
                    this.cursorShape.style.uvMatrix = new Matrix(0, 0, 0, 0, obj.colorPos.x, obj.colorPos.y);
                }
            }
            this.scrollToCursor(x, y);
        };
        TextField.prototype.drawSelectedBG = function () {
            this._shapesDirty = true;
            if (this._selectionBeginIndex < 0) {
                this._selectionBeginIndex = 0;
            }
            if (this._selectionBeginIndex > this.char_positions_x.length) {
                this._selectionBeginIndex = this.char_positions_x.length;
            }
            var select_start = this._selectionBeginIndex;
            var select_end = this._selectionEndIndex;
            if (this._selectionEndIndex < this._selectionBeginIndex) {
                select_start = this._selectionEndIndex;
                select_end = this._selectionBeginIndex;
            }
            var x = 0;
            var y = 0;
            var oldy = -1;
            var tf = null;
            var startx = -1;
            var width = 0;
            var height = 0;
            var rectangles = [];
            if (this.char_positions_x.length != 0 && this._selectionEndIndex != this._selectionBeginIndex) {
                var len = (select_end > this.char_positions_x.length) ? this.char_positions_x.length : select_end;
                //console.log(select_start, select_end);
                for (var i = select_start; i < len; i++) {
                    if (i == this.char_positions_x.length) {
                        x = this.char_positions_x[i - 1] + this.chars_width[i - 1];
                        y = this.char_positions_y[i - 1];
                        tf = this.tf_per_char[i - 1];
                    }
                    else {
                        x = this.char_positions_x[i];
                        y = this.char_positions_y[i];
                        tf = this.tf_per_char[i];
                    }
                    if (startx < 0) {
                        startx = x;
                    }
                    if (oldy >= 0 && oldy != y) {
                        // new line
                        rectangles.push(startx, oldy, width, height);
                        width = 0;
                        startx = x;
                    }
                    width += this.chars_width[i];
                    oldy = y;
                    tf.font_table.initFontSize(tf.size);
                    height = tf.font_table.getLineHeight();
                }
            }
            // if (this.bgShapeSelect) {
            // 	this.bgShapeSelect.dispose();
            // 	this.bgShapeSelect=null;
            // }
            if (width > 0) {
                rectangles.push(startx, oldy, width, height);
                this.bgShapeSelect = GraphicsFactoryHelper.drawRectangles(rectangles, 0x000000, 1);
                this.bgShapeSelect.usages++; //TODO: get rid of this memory leak
                return;
            }
            this.scrollToCursor(startx + width, oldy + height);
        };
        TextField.prototype.drawBG = function () {
            this._graphics.beginFill(this.backgroundColor, (!this._background && this._type == TextFieldType.INPUT) ? 0 : 1);
            this._graphics.drawRect(this.textOffsetX, this.textOffsetY, this.width, this.height);
            this._graphics.endFill();
        };
        TextField.prototype.drawBorder = function () {
            var half_thickness_x = this.border ? 0.25 * this.internalScale.x : 0;
            var half_thickness_y = this.border ? 0.25 * this.internalScale.y : 0;
            this._graphics.beginFill(this._borderColor, 1);
            this._graphics.drawRect(this.textOffsetX, this.textOffsetY, this._width, half_thickness_y * 2);
            this._graphics.drawRect(this.textOffsetX, this.textOffsetY + this._height - half_thickness_y * 2, this._width, half_thickness_y * 2);
            this._graphics.drawRect(this.textOffsetX, this.textOffsetY + half_thickness_y * 2, half_thickness_x * 2, this._height - half_thickness_y * 2);
            this._graphics.drawRect(this.textOffsetX + this._width - half_thickness_x * 2, this.textOffsetY + half_thickness_y * 2, half_thickness_x * 2, this._height - half_thickness_y * 2);
            this._graphics.endFill();
        };
        TextField.prototype.getTextShapeForIdentifierAndFormat = function (id, format) {
            if (this.textShapes.hasOwnProperty(id)) {
                return this.textShapes[id];
            }
            this.textShapes[id] = new TextShape();
            this.textShapes[id].format = format;
            return this.textShapes[id];
        };
        Object.defineProperty(TextField.prototype, "autoSize", {
            get: function () {
                return this._autoSize;
            },
            set: function (value) {
                if (this._autoSize == value)
                    return;
                if (typeof value === "string") {
                    if (value != TextFieldAutoSize.CENTER &&
                        value != TextFieldAutoSize.NONE &&
                        value != TextFieldAutoSize.LEFT &&
                        value != TextFieldAutoSize.RIGHT) {
                        return;
                    }
                }
                else {
                    if (typeof value === "boolean") {
                        if (value)
                            value = TextFieldAutoSize.LEFT;
                        else
                            value = TextFieldAutoSize.NONE;
                    }
                    if (typeof value === "number") {
                        if (value > 0)
                            value = TextFieldAutoSize.LEFT;
                        else
                            value = TextFieldAutoSize.NONE;
                    }
                }
                this._autoSize = value;
                this._positionsDirty = true;
                if (this._autoSize != TextFieldAutoSize.NONE)
                    this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "internalScale", {
            get: function () {
                return this._internalScale;
            },
            enumerable: true,
            configurable: true
        });
        // public getInternalScale(view:View = null):Vector3D
        // {
        // 	if(this.parent)
        // 		this._internalScale.copyFrom(this.parent.transform.concatenatedMatrix3D.decompose()[3]);
        // 	else
        // 		this._internalScale.identity();
        // 	if (view) {
        // 		this._internalScale.x *= view.focalLength*view.pixelRatio/1000;
        // 		this._internalScale.y *= view.focalLength/1000;
        // 	}
        //     this._internalScale.x=1/this._internalScale.x;
        //     this._internalScale.y=1/this._internalScale.y;
        // 	return this._internalScale;
        // }
        TextField.prototype._iInternalUpdate = function () {
            _super.prototype._iInternalUpdate.call(this);
            //if (!this.inMaskMode) {
            this.reConstruct(true);
            if (this._textFormat && !this._textFormat.font_table.isAsset(TesselatedFontTable) && !this._textFormat.material) {
                // only for FNT font-tables
                // todo: do we still need this ?
                this.transform.colorTransform || (this.transform.colorTransform = new ColorTransform());
                this.transform.colorTransform.color = (this.textColor != null) ? this.textColor : this._textFormat.color;
                this._invalidateHierarchicalProperties(HierarchicalProperties.COLOR_TRANSFORM);
            }
            //}
            /*
            if (projection) {
                this._strokeScale.x = (<PerspectiveProjection> projection).hFocalLength/1000;
                this._strokeScale.y = (<PerspectiveProjection> projection).focalLength/1000;
            }else{
                this._strokeScale.x = 1;
                this._strokeScale.y = 1;
            }
            this._graphics.updateScale(projection);*/
            var prevScaleX = this._internalScale.x;
            var prevScaleY = this._internalScale.y;
            // var scale:Vector3D = this.getInternalScale(view);
            // if (scale.x == prevScaleX && scale.y == prevScaleY)
            //      return;
            // this._internalScale=scale;
            // this._glyphsDirty=true;
        };
        /**
         * //TODO
         *
         * @private
         */
        TextField.prototype._onGraphicsInvalidate = function (event) {
            var isEntity = this.isEntity();
            if (this._isEntity != isEntity) {
                if (!isEntity && this._implicitPartition)
                    this._implicitPartition.clearEntity(this);
                this._isEntity = isEntity;
            }
            this.invalidate();
        };
        Object.defineProperty(TextField.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return TextField.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "background", {
            get: function () {
                return this._background;
            },
            set: function (value) {
                if (this._background == value)
                    return;
                this._background = value;
                this._shapesDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "backgroundColor", {
            get: function () {
                return this._backgroundColor;
            },
            set: function (value) {
                this._backgroundColor = value;
                this._shapesDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "border", {
            get: function () {
                return this._border;
            },
            set: function (value) {
                if (value == this._border)
                    return;
                this._border = value;
                this._shapesDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "borderColor", {
            get: function () {
                return this._borderColor;
            },
            set: function (value) {
                if (value == this.borderColor)
                    return;
                this._borderColor = value;
                this._shapesDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "bottomScrollV", {
            /**
             * An integer(1-based index) that indicates the bottommost line that is
             * currently visible in the specified text field. Think of the text field as
             * a window onto a block of text. The <code>scrollV</code> property is the
             * 1-based index of the topmost visible line in the window.
             *
             * <p>All the text between the lines indicated by <code>scrollV</code> and
             * <code>bottomScrollV</code> is currently visible in the text field.</p>
             */
            get: function () {
                return this._bottomScrollV;
            },
            set: function (value) {
                if (value == this._bottomScrollV)
                    return;
                this._bottomScrollV = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "caretIndex", {
            /**
             * The index of the insertion point(caret) position. If no insertion point
             * is displayed, the value is the position the insertion point would be if
             * you restored focus to the field(typically where the insertion point last
             * was, or 0 if the field has not had focus).
             *
             * <p>Selection span indexes are zero-based(for example, the first position
             * is 0, the second position is 1, and so on).</p>
             */
            get: function () {
                return this._caretIndex;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "defaultTextFormat", {
            get: function () {
                if (this._defaultTextFormat == null) {
                    this._defaultTextFormat = new TextFormat();
                }
                return this._defaultTextFormat;
            },
            set: function (value) {
                if (this._defaultTextFormat == value)
                    return;
                this._defaultTextFormat = value;
                this._textDirty = true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "height", {
            /**
             *
             */
            get: function () {
                if (this._autoSize != TextFieldAutoSize.NONE)
                    this.reConstruct();
                return this._height;
            },
            set: function (val) {
                if (this._height == val)
                    return;
                if (this._autoSize != TextFieldAutoSize.NONE)
                    return;
                this._height = val;
                this._positionsDirty = true;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "htmlText", {
            get: function () {
                return this._htmlText;
            },
            set: function (value) {
                if (value == this._htmlText)
                    return;
                this._htmlText = value;
                var processedText = HTMLTextProcessor.get().processHTML(this, value);
                // 	text might be the same, 
                //	we still need to set textDirty, because formatting might have changed
                //console.log("html out",  textProps.text);
                this._labelData = null;
                this._text = processedText;
                this._iText = processedText;
                this._textDirty = true;
                //console.log("set text", value, "on" , this);
                if (this._autoSize != TextFieldAutoSize.NONE)
                    this.invalidate();
                else if (this._implicitPartition)
                    this._implicitPartition.invalidateEntity(this);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "length", {
            /**
             * The number of characters in a text field. A character such as tab
             * (<code>\t</code>) counts as one character.
             */
            get: function () {
                return this._iText.length;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "maxScrollH", {
            /**
             * The maximum value of <code>scrollH</code>.
             */
            get: function () {
                this.reConstruct();
                return this._maxScrollH;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "maxScrollV", {
            /**
             * The maximum value of <code>scrollV</code>.
             */
            get: function () {
                this.reConstruct();
                return this._maxScrollV;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "numLines", {
            /**
             * Defines the number of text lines in a multiline text field. If
             * <code>wordWrap</code> property is set to <code>true</code>, the number of
             * lines increases when text wraps.
             */
            get: function () {
                this.reConstruct();
                return this._numLines;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "restrict", {
            get: function () {
                return this._restrict;
            },
            set: function (value) {
                if (value == this._restrict)
                    return;
                this._restrict = value;
                this._restrictRegex = null;
                if (typeof value == "undefined")
                    return;
                value = value.toString();
                // flash allows something like -9 to be used instaed 0-9. fix this here:
                if (value.length >= 2 && value[0] == "-" && !isNaN(parseInt(value[1])))
                    value = "0" + value;
                // remove all backslashes. flash does not allow to use backslash as allowed char
                value = value.replace(/\\/g, "");
                // remove all ^. flash does not allow to use ^ as allowed char
                value = value.replace(/\^/g, "");
                // make sure all "-" are escaped if they are not used to define a range
                value = value.replace(/([^a-zA-Z0-9])\-/g, "$1\\-");
                // escape all special chars so that regex will be valid
                //todo: should be able to do the following with a single regex:
                value = value.replace(/\./g, "\\.");
                value = value.replace(/\</g, "\\<");
                value = value.replace(/\>/g, "\\>");
                value = value.replace(/\+/g, "\\+");
                value = value.replace(/\*/g, "\\*");
                value = value.replace(/\?/g, "\\?");
                value = value.replace(/\[/g, "\\[");
                value = value.replace(/\]/g, "\\]");
                value = value.replace(/\$/g, "\\$");
                value = value.replace(/\(/g, "\\(");
                value = value.replace(/\)/g, "\\)");
                value = value.replace(/\{/g, "\\{");
                value = value.replace(/\}/g, "\\}");
                value = value.replace(/\=/g, "\\=");
                value = value.replace(/\!/g, "\\!");
                value = value.replace(/\:/g, "\\:");
                value = value.replace(/\|/g, "\\|");
                value = value.replace(/\//g, "\\/");
                value = value.replace(/\%/g, "\\%");
                this._restrictRegex = new RegExp("[^" + value + "]", "g");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "scrollH", {
            get: function () {
                return this._scrollH;
            },
            set: function (value) {
                if (value == this._scrollH)
                    return;
                this._scrollH = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "scrollV", {
            get: function () {
                return this._scrollV;
            },
            set: function (value) {
                if (Math.floor(value) == this._scrollH)
                    return;
                this._scrollV = Math.floor(value);
                if (this._scrollV > this._maxScrollV)
                    this._scrollV = this._maxScrollV;
                if (!this.textChild) {
                    return;
                }
                this.textChild.y = -this.lines_start_y[this._scrollV];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "selectable", {
            get: function () {
                return this._selectable;
            },
            set: function (value) {
                if (this.selectable == value) {
                    return;
                }
                this._selectable = value;
                this.mouseEnabled = value;
                if (value) {
                    this.addEventListener(MouseEvent.DRAG_START, this.startSelectionByMouseDelegate);
                    this.addEventListener(MouseEvent.DRAG_STOP, this.stopSelectionByMouseDelegate);
                    this.addEventListener(MouseEvent.DRAG_MOVE, this.updateSelectionByMouseDelegate);
                }
                else {
                    this.removeEventListener(MouseEvent.DRAG_START, this.startSelectionByMouseDelegate);
                    this.removeEventListener(MouseEvent.DRAG_STOP, this.stopSelectionByMouseDelegate);
                    this.removeEventListener(MouseEvent.DRAG_MOVE, this.updateSelectionByMouseDelegate);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "selectionBeginIndex", {
            /**
             * The zero-based character index value of the first character in the current
             * selection. For example, the first character is 0, the second character is
             * 1, and so on. If no text is selected, this property is the value of
             * <code>caretIndex</code>.
             */
            get: function () {
                return this._selectionBeginIndex;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "selectionEndIndex", {
            /**
             * The zero-based character index value of the last character in the current
             * selection. For example, the first character is 0, the second character is
             * 1, and so on. If no text is selected, this property is the value of
             * <code>caretIndex</code>.
             */
            get: function () {
                return this._selectionEndIndex;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "text", {
            /**
             * A string that is the current text in the text field. Lines are separated
             * by the carriage return character(<code>'\r'</code>, ASCII 13). This
             * property contains unformatted text in the text field, without HTML tags.
             *
             * <p>To get the text in HTML form, use the <code>htmlText</code>
             * property.</p>
             */
            get: function () {
                return this._text;
            },
            set: function (value) {
                value = (typeof value === "undefined") ? "" : value.toString();
                value = value.replace(String.fromCharCode(160), " ");
                if (this._text == value)
                    return;
                this._labelData = null;
                this._text = value;
                if (value != "" && ((value.charCodeAt(value.length - 1) == 13) || (value.charCodeAt(value.length - 1) == 10))) {
                    value = value.slice(0, value.length - 1);
                }
                if (value != "" && (value.length >= 3 && value[value.length - 1] == "n" && value[value.length - 2] == "\\" && value[value.length - 3] == "\\")) {
                    value = value.slice(0, value.length - 3);
                }
                if (value != "" && (value.length >= 3 && value[value.length - 1] == "n" && value[value.length - 2] == "\\")) {
                    value = value.slice(0, value.length - 2);
                }
                this._iText = value;
                this._textFormats = [this.newTextFormat];
                this._textFormatsIdx = [this._iText.length];
                this._textDirty = true;
                //console.log("set text", value, "on" , this);
                if (this._autoSize != TextFieldAutoSize.NONE)
                    this.invalidate();
                else if (this._implicitPartition)
                    this._implicitPartition.invalidateEntity(this);
            },
            enumerable: true,
            configurable: true
        });
        TextField.prototype.setLabelData = function (labelData) {
            this._labelData = labelData;
            this.isStatic = true;
            this._iText = "";
            this._textDirty = false;
            this._positionsDirty = false;
            this._glyphsDirty = true;
            if (this._autoSize != TextFieldAutoSize.NONE)
                this.invalidate();
            else if (this._implicitPartition)
                this._implicitPartition.invalidateEntity(this);
        };
        Object.defineProperty(TextField.prototype, "newTextFormat", {
            get: function () {
                // only use the newTextformat if it is available, otherwise fall back to textFormat
                return this._newTextFormat ? this._newTextFormat : this._textFormat ? this._textFormat : new TextFormat();
            },
            set: function (value) {
                if (value) {
                    this._newTextFormat = value.applyToFormat(this._textFormat.clone());
                    return;
                }
                this._newTextFormat = null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "textFormat", {
            get: function () {
                if (this._textFormat == null) {
                    this._textFormat = new TextFormat();
                }
                return this._textFormat;
            },
            set: function (value) {
                if (this._textFormat == value) {
                    return;
                }
                this._textDirty = true;
                this._textFormat = value;
                //this.reConstruct();
                if (this._autoSize != TextFieldAutoSize.NONE)
                    this.invalidate();
                else if (this._implicitPartition)
                    this._implicitPartition.invalidateEntity(this);
            },
            enumerable: true,
            configurable: true
        });
        /**
         *
         * @param renderer
         *
         * @internal
         */
        TextField.prototype._acceptTraverser = function (traverser) {
            if (!this.maskMode) {
                //if(!this.cursorBlinking &&  this._isInFocus && this.cursorShape && this._type==TextFieldType.INPUT){
                //	traverser[this.cursorShape.elements.traverseName](this.cursorShape);
                //}
                this._graphics._acceptTraverser(traverser);
                //if(this.showSelection && this._isInFocus && this.bgShapeSelect){
                //	traverser[this.bgShapeSelect.elements.traverseName](this.bgShapeSelect);
                //}
                //if(this.bgShape){// && this.background){
                //	traverser[this.bgShape.elements.traverseName](this.bgShape);
                //}
            }
        };
        Object.defineProperty(TextField.prototype, "scaleX", {
            /**
             * Indicates the horizontal scale(percentage) of the object as applied from
             * the registration point. The default registration point is(0,0). 1.0
             * equals 100% scale.
             *
             * <p>Scaling the local coordinate system changes the <code>x</code> and
             * <code>y</code> property values, which are defined in whole pixels. </p>
             */
            get: function () {
                return this._transform.scale.x;
            },
            set: function (val) {
                if (this._transform.scale.x == val) {
                    return;
                }
                this._setScaleX(val);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "scaleY", {
            /**
             * Indicates the vertical scale(percentage) of an object as applied from the
             * registration point of the object. The default registration point is(0,0).
             * 1.0 is 100% scale.
             *
             * <p>Scaling the local coordinate system changes the <code>x</code> and
             * <code>y</code> property values, which are defined in whole pixels. </p>
             */
            get: function () {
                return this._transform.scale.y;
            },
            set: function (val) {
                if (this._transform.scale.y == val) {
                    return;
                }
                this._setScaleY(val);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "textColor", {
            get: function () {
                return this._textColor;
            },
            set: function (value) {
                if (this._textColor == value) {
                    return;
                }
                this._textColor = value;
                //this._textFormat.color=value;
                if (this._textFormats) {
                    var i = this._textFormats.length;
                    while (i > 0) {
                        i--;
                        if (this._textFormats[i])
                            this._textFormats[i].color = value;
                    }
                    this._textDirty = true;
                }
                if (this._textFormat && !this._textFormat.font_table.isAsset(TesselatedFontTable) && !this._textFormat.material) {
                    if (!this.transform.colorTransform)
                        this.transform.colorTransform = new ColorTransform();
                    this.transform.colorTransform.color = value;
                    this._invalidateHierarchicalProperties(HierarchicalProperties.COLOR_TRANSFORM);
                }
                else {
                    this._glyphsDirty = true;
                    if (this._implicitPartition)
                        this._implicitPartition.invalidateEntity(this);
                }
            },
            enumerable: true,
            configurable: true
        });
        TextField.prototype.getTextColorForTextFormat = function (format) {
            if (format.hasPropertySet("color")) {
                return format.color;
            }
            return this._textColor;
        };
        Object.defineProperty(TextField.prototype, "textInteractionMode", {
            /**
             * The interaction mode property, Default value is
             * TextInteractionMode.NORMAL. On mobile platforms, the normal mode implies
             * that the text can be scrolled but not selected. One can switch to the
             * selectable mode through the in-built context menu on the text field. On
             * Desktop, the normal mode implies that the text is in scrollable as well as
             * selection mode.
             */
            get: function () {
                return this._textInteractionMode;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "textWidth", {
            /**
             * The width of the text in pixels.
             */
            get: function () {
                this.reConstruct();
                return this._textWidth;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "textHeight", {
            /**
             * The width of the text in pixels.
             */
            get: function () {
                this.reConstruct();
                return this._textHeight;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "type", {
            get: function () {
                return this._type;
            },
            set: function (value) {
                if (this._type == value) {
                    return;
                }
                this._type = value;
                this._textDirty = true;
                if (this._implicitPartition)
                    this._implicitPartition.invalidateEntity(this);
                if (value == TextFieldType.INPUT) {
                    //this._selectable=true;
                    this.enableInput(true);
                    this.addEventListener(KeyboardEvent.KEYDOWN, this.onKeyDelegate);
                }
                else {
                    this.enableInput(false);
                    this.removeEventListener(KeyboardEvent.KEYDOWN, this.onKeyDelegate);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "x", {
            get: function () {
                if (this._autoSize != TextFieldAutoSize.NONE && !this._wordWrap) {
                    this.reConstruct();
                }
                return this._transform.position.x;
            },
            set: function (val) {
                if (this._autoSize != TextFieldAutoSize.NONE && !this._wordWrap)
                    this.reConstruct();
                if (this._transform.position.x == val)
                    return;
                this._transform.matrix3D._rawData[12] = val;
                this._transform.invalidatePosition();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "width", {
            /**
             *
             */
            get: function () {
                if (this._autoSize != TextFieldAutoSize.NONE && !this._wordWrap) {
                    this.reConstruct();
                }
                return this._width;
            },
            set: function (val) {
                if (this._width == val)
                    return;
                //if (this._autoSize != TextFieldAutoSize.NONE && !this._wordWrap)
                //	return;
                this._width = val;
                this._positionsDirty = true;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField.prototype, "wordWrap", {
            /**
             * The width of the text in pixels.
             */
            get: function () {
                return this._wordWrap;
            },
            set: function (val) {
                if (this._wordWrap == val)
                    return;
                this._wordWrap = val;
                this._positionsDirty = true;
                if (!val)
                    this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        TextField.prototype.isEntity = function () {
            return true;
        };
        TextField.prototype.clear = function () {
            _super.prototype.clear.call(this);
        };
        /**
         * @inheritDoc
         */
        TextField.prototype.dispose = function () {
            this.disposeValues();
            TextField._textFields.push(this);
        };
        /**
         * @inheritDoc
         */
        TextField.prototype.disposeValues = function () {
            _super.prototype.disposeValues.call(this);
            if (this.maskChild) {
                this.maskChild.dispose();
                this.maskChild = null;
            }
            if (this.textChild) {
                this.textChild.dispose();
                this.textChild = null;
            }
            if (this.cursorShape) {
                this.cursorShape.dispose();
                this.cursorShape = null;
            }
            if (this.bgShapeSelect) {
                this.bgShapeSelect.dispose();
                this.bgShapeSelect = null;
            }
            if (this._labelData) {
                this._labelData = null;
            }
            this._clearTextShapes();
            this._textFormat = null;
        };
        /**
         * Reconstructs the Graphics for this Text-field.
         */
        TextField.prototype.reConstruct = function (buildGraphics) {
            if (buildGraphics === void 0) { buildGraphics = false; }
            if (!this._textDirty && !this._positionsDirty && !this._glyphsDirty && !this._shapesDirty)
                return;
            // Step1: init text-data
            // this step splits the text into textRuns and sort them into paragraphs
            // each textRun spans a range of words that share the same text-format
            // a textRun can not be shared between paragraphs
            // for each word, 5 numbers are stored:
            // 		char-index,
            // 		x-pos,
            // 		y-pos,
            // 		word-width,
            // 		char-count,
            // a whitespace is considered as a word
            if (this._textDirty) {
                this._positionsDirty = true;
                this.chars_codes.length = 0;
                this.chars_width.length = 0;
                this.char_positions_x.length = 0;
                this.char_positions_y.length = 0;
                this.tf_per_char.length = 0;
                this.words.length = 0;
                this._textRuns_words.length = 0;
                this._textRuns_formats.length = 0;
                this._paragraph_textRuns_indices.length = 0;
                this.lines_wordStartIndices.length = 0;
                this.lines_wordEndIndices.length = 0;
                this.lines_start_y.length = 0;
                this.lines_start_x.length = 0;
                this.lines_charIdx_start.length = 0;
                this.lines_charIdx_end.length = 0;
                this.lines_width.length = 0;
                this.lines_height.length = 0;
                this.lines_numSpacesPerline.length = 0;
                this._maxScrollH = 0;
                this._maxScrollV = 0;
                this._maxWidthLine = 0;
                if (this._iText != "" && this._textFormat != null) {
                    //console.log("textlength", this.text.toString().length, this.text.toString());
                    this.buildParagraphs();
                }
                //console.log("TextField buildParagraph", this.id, this._iText);
                //console.log("TextField buildParagraph", this.id, this._autoSize);
                //console.log("TextField buildParagraph", this.id, this._wordWrap);
                //console.log("TextField buildParagraph", this.id, this.multiline);
            }
            // 	Step 2: positioning the words
            // 	if position is dirty, the text formatting has changed.
            // 	this step will modify the word-data stored in previous step.
            //	for each word, it adjusts the x-pos and y-pos position.
            //	this step also takes care of adjusting the textWidth and textHeight,
            //	if we have AUTOSIZE!=None
            if (this._positionsDirty) {
                this._glyphsDirty = true;
                if (this._iText != "" && this._textFormat != null) {
                    //console.log("TextField getWordPositions", this.id, this.words);
                    this.getWordPositions();
                }
                else {
                    // this is empty text, we need to reset the text-size
                    this._textWidth = 0;
                    this._textHeight = 0;
                    if (this._autoSize != TextFieldAutoSize.NONE) {
                        if (!this.wordWrap)
                            this.adjustPositionForAutoSize(0); //(this._width - 4)/2);
                        this._height = 4;
                        if (this._type == TextFieldType.INPUT) {
                            this.newTextFormat.font_table.initFontSize(this.newTextFormat.size);
                            this._height = this.newTextFormat.font_table.getLineHeight() + 4;
                        }
                    }
                    if (this._type == TextFieldType.INPUT)
                        this.drawSelectionGraphics();
                }
                this.updateMaskMode();
            }
            this._textDirty = false;
            this._positionsDirty = false;
            if (!buildGraphics)
                return;
            // 	Step 3: building the glyphs
            // 	this step is only done if this function was called when renderer collects the graphics.
            //	only than should the reconstruct function be called with "buildGraphics=true".
            // 	in this step, the text-shapes are cleared,
            //	the data for new text-shapes is collected from the font-tables
            //	and the new text-shapes are created and assigned to the graphics
            if (this._glyphsDirty) {
                //console.log("TextField buildGlyphs", this.id, this.words);
                if (this._labelData) {
                    this.buildGlyphsForLabelData();
                }
                else {
                    this.buildGlyphs();
                }
            }
            this._glyphsDirty = false;
            if (this._labelData)
                return;
            this.buildShapes();
            this._shapesDirty = false;
        };
        TextField.prototype.reset = function () {
            _super.prototype.reset.call(this);
            //if(this.name && typeof this.name !== "number"){
            // if the textfield has a valid name, it might have been changed by scripts. 
            // in that case we want to reset it to its original state
            if (this.sourceTextField) {
                this.sourceTextField.copyTo(this);
                this._textFormats = [this.newTextFormat];
                this._textFormatsIdx = [this._iText.length];
            }
            //}
            /*if(this.adapter != this){
                (<any>this.adapter).syncTextFieldValue();
            }*/
        };
        TextField.prototype.buildParagraphs = function () {
            var thisText = this._iText.toString();
            var tf;
            var f = 0;
            var f_len = this._textFormatsIdx.length;
            var c = 0;
            var char_code = 0;
            var char_width = 0;
            var next_char_code = 0;
            var startNewWord = true;
            var word_cnt = 0;
            var linewidth = 0;
            var whitespace_cnt = 0;
            this._paragraph_textRuns_indices[this._paragraph_textRuns_indices.length] = this._textRuns_formats.length;
            linewidth = 0;
            var c_start = 0;
            var c_end = 0;
            // loop over all textFormats
            for (f = 0; f < f_len; f++) {
                word_cnt = 0;
                whitespace_cnt = 0;
                startNewWord = true;
                tf = this._textFormats[f];
                var maxLineWidth = this._width - (tf.indent + tf.leftMargin + tf.rightMargin);
                tf.font_table.initFontSize(tf.size);
                c_end = (f == f_len - 1) ? thisText.length : this._textFormatsIdx[f];
                // create a new textrun
                this._textRuns_formats[this._textRuns_formats.length] = tf;
                this._textRuns_words[this._textRuns_words.length] = this.words.length;
                // loop over all chars for this format
                //console.log("textrun tf = ", tf);
                for (c = c_start; c < c_end; c++) {
                    char_code = thisText.charCodeAt(c);
                    // todo: clean this up + allow exscaping of special chars
                    //console.log("char = ", char_code);
                    //console.log("process char", c, thisText[c], char_code, tf.id);
                    if (char_code == 92 || char_code == 10 || char_code == 13) {
                        // this is a backslash. if it is last char, we do not handle it special
                        // if it is followed by a "n" or a "r", we add a new paragraph
                        // if it is followed by a "\n" we add a paragraph too (legacy for icycle and sunflower - needs cleanup)
                        if (char_code == 10 || char_code == 13 || c < thisText.length - 1) {
                            next_char_code = thisText.charCodeAt(c + 1);
                            if (char_code == 10 || char_code == 13 || (next_char_code == 10) || (next_char_code == 110) || (next_char_code == 114)
                                || (next_char_code == 92 && (c < thisText.length - 2) && thisText.charCodeAt(c + 2) == 110)) {
                                // next chars are "n" or "\n". we create a new paragraph
                                //console.log("create new paragraph");
                                //finish textrun:
                                /*this.words[this.words.length]=this.chars_codes.length-1;	// 	index into chars
                                this.words[this.words.length]=0;							// 	x-position
                                this.words[this.words.length]=0;							// 	y-position
                                this.words[this.words.length]=0;					// 	word width
                                this.words[this.words.length]=(char_code == 10)?1:(next_char_code == 110)?2:3;	*/
                                this._textRuns_words[this._textRuns_words.length] = word_cnt;
                                this._textRuns_words[this._textRuns_words.length] = linewidth;
                                this._textRuns_words[this._textRuns_words.length] = whitespace_cnt;
                                this._paragraph_textRuns_indices[this._paragraph_textRuns_indices.length] = this._textRuns_formats.length;
                                // create a new textrun
                                this._textRuns_formats[this._textRuns_formats.length] = tf;
                                this._textRuns_words[this._textRuns_words.length] = this.words.length;
                                c += (char_code == 10 || char_code == 13) ? 0 : (next_char_code == 110 || next_char_code == 114) ? 1 : 2;
                                this.chars_codes[this.chars_codes.length] = 55;
                                this.chars_width[this.chars_width.length] = 0;
                                this.tf_per_char[this.tf_per_char.length] = tf;
                                /*if(next_char_code != 110){
                                    this.chars_codes[this.chars_codes.length]=55;
                                    this.chars_width[this.chars_width.length]=0;
                                    this.tf_per_char[this.tf_per_char.length]=tf;

                                }*/
                                startNewWord = true;
                                whitespace_cnt = 0;
                                word_cnt = 0;
                                if (this._maxWidthLine < linewidth) {
                                    this._maxWidthLine = linewidth;
                                }
                                linewidth = 0;
                                continue;
                            }
                        }
                    }
                    this.chars_codes[this.chars_codes.length] = char_code;
                    this.tf_per_char[this.tf_per_char.length] = tf;
                    char_width = tf.font_table.getCharWidth(char_code.toString());
                    if (char_width <= 0) {
                        char_width = tf.font_table.getCharWidth("32");
                        //console.log("ERROR in TextField.buildTextRuns(): char is not provided by FontTable", char_code, this.text[c]);
                    }
                    // if this is a letter, and next char is no whitespace, we add the letterSpacing to the letter-width
                    // todo: we might need to add the letterspacing also if next char is a linebreak ?
                    if (char_code != 32 && char_code != 9 && c < c_end - 1) {
                        char_width += (thisText.charCodeAt(c + 1) == 32 || thisText.charCodeAt(c + 1) == 9) ? 0 : tf.letterSpacing;
                    }
                    linewidth += char_width;
                    this.chars_width[this.chars_width.length] = char_width;
                    // we create a new word if the char is either:
                    // 	- first char of paragraph
                    //	- is a whitespace
                    //  - follows a whitespace
                    if (char_code == 32 || char_code == 9) {
                        //console.log("add WhiteSpace");
                        whitespace_cnt++;
                        this.words[this.words.length] = this.chars_codes.length - 1; // 	index into chars
                        this.words[this.words.length] = 0; // 	x-position
                        this.words[this.words.length] = 0; // 	y-position
                        this.words[this.words.length] = char_width; // 	word width
                        this.words[this.words.length] = 1; // 	char count
                        word_cnt++;
                        // we also make sure to begin a new word for next char (could be whitespace again)
                        startNewWord = true;
                    }
                    else {
                        // no whitespace
                        if (this.multiline && this._autoSize == TextFieldAutoSize.NONE && this._wordWrap) {
                            if (this.words[this.words.length - 2] + char_width >= maxLineWidth) {
                                /*this._textRuns_words[this._textRuns_words.length]=word_cnt;
                                this._textRuns_words[this._textRuns_words.length]=linewidth;
                                this._textRuns_words[this._textRuns_words.length]=whitespace_cnt;

                                this._paragraph_textRuns_indices[this._paragraph_textRuns_indices.length]=this._textRuns_formats.length;
                                // create a new textrun
                                this._textRuns_formats[this._textRuns_formats.length]=tf;
                                this._textRuns_words[this._textRuns_words.length]=this.words.length;*/
                                startNewWord = true;
                            }
                        }
                        if (startNewWord) {
                            //console.log("startNewWord");
                            // create new word (either this is the first char, or the last char was whitespace)
                            this.words[this.words.length] = this.chars_codes.length - 1; // 	index into chars
                            this.words[this.words.length] = 0; //	x-position
                            this.words[this.words.length] = 0; //	y-position
                            this.words[this.words.length] = char_width; // 	word width
                            this.words[this.words.length] = 1; // 	char count
                            word_cnt++;
                        }
                        else {
                            // update-char length and width of active word.
                            this.words[this.words.length - 2] += char_width;
                            this.words[this.words.length - 1]++;
                        }
                        startNewWord = false;
                    }
                }
                this._textRuns_words[this._textRuns_words.length] = word_cnt;
                this._textRuns_words[this._textRuns_words.length] = linewidth;
                this._textRuns_words[this._textRuns_words.length] = whitespace_cnt;
                if (this._maxWidthLine < linewidth) {
                    this._maxWidthLine = linewidth;
                }
                c_start = c_end;
            }
        };
        TextField.prototype.adjustPositionForAutoSize = function (newWidth) {
            var oldSize = this._width;
            this._width = 4 + newWidth;
            if (this._autoSize == TextFieldAutoSize.RIGHT) {
                this._transform.matrix3D._rawData[12] -= this._width - oldSize;
                this._transform.invalidatePosition();
            }
            else if (this._autoSize == TextFieldAutoSize.CENTER) {
                this._transform.matrix3D._rawData[12] -= (this._width - oldSize) / 2;
                this._transform.invalidatePosition();
            }
        };
        TextField.prototype.getWordPositions = function () {
            /*console.log("this._iText", this._iText);
            console.log("this._width", this._width);
            console.log("this._height", this._height);*/
            /*for(var i=0; i<this.chars_codes.length; i++){
                console.log("test: ", this.chars_codes[i], this.chars_width[i]);
            }*/
            var tr = 0;
            var tr_len = this._textRuns_formats.length;
            var w = 0;
            var w_len = 0;
            var tr_length = 0;
            var format;
            var text_width = 0;
            var indent = 0;
            this._numLines = 0;
            var linecnt = 0;
            var linelength = 0;
            var word_width = 0;
            var offsety = this.textOffsetY + 2;
            //console.log("text old_width", this._width);
            //console.log("text old_x", this._transform.matrix3D._rawData[12]);
            //console.log("this._autoSize", this._autoSize);
            //console.log("this._wordWrap", this._wordWrap);
            // if we have autosize enabled, and no wordWrap, we can adjust the textfield width
            if (this._autoSize != TextFieldAutoSize.NONE && !this._wordWrap && this._textDirty) {
                var maxSizeComplete = this._maxWidthLine + this._textFormat.indent + this._textFormat.leftMargin + this._textFormat.rightMargin;
                this.adjustPositionForAutoSize(maxSizeComplete);
            }
            var maxLineWidth = this._width - (this._textFormat.indent + this._textFormat.leftMargin + this._textFormat.rightMargin);
            var p = 0;
            var p_len = this._paragraph_textRuns_indices.length;
            linecnt = 0;
            this.lines_wordStartIndices.length = 0;
            this.lines_wordEndIndices.length = 0;
            this.lines_start_y.length = 0;
            this.lines_start_x.length = 0;
            this.lines_width.length = 0;
            this.lines_height.length = 0;
            this.lines_numSpacesPerline.length = 0;
            this.lines_charIdx_start.length = 0;
            this.lines_charIdx_end.length = 0;
            var lines_heights = [];
            var lines_formats = [];
            // loop over all paragraphs
            for (p = 0; p < p_len; p++) {
                tr_len = (p == (p_len - 1)) ? this._textRuns_formats.length : this._paragraph_textRuns_indices[p + 1];
                //console.log("process word positions for paragraph", p, "textruns", this._paragraph_textRuns_indices[p], tr_len);
                tr_length = 0;
                lines_heights[lines_heights.length] = 0;
                for (tr = this._paragraph_textRuns_indices[p]; tr < tr_len; tr++) {
                    format = this._textRuns_formats[tr];
                    format.font_table.initFontSize(format.size);
                    if (lines_heights[lines_heights.length - 1] < (format.font_table.getLineHeight() + format.leading)) {
                        lines_heights[lines_heights.length - 1] = format.font_table.getLineHeight() + format.leading;
                    }
                    //console.log("process word positions for textrun", tr, "textruns",  this._textRuns_words);
                    w_len = this._textRuns_words[(tr * 4)] + (this._textRuns_words[(tr * 4) + 1] * 5);
                    tr_length += this._textRuns_words[(tr * 4) + 2];
                    //console.log(this._textFieldWidth, tr_length, maxLineWidth);
                }
                this.lines_wordStartIndices[this.lines_wordStartIndices.length] = this._textRuns_words[(this._paragraph_textRuns_indices[p] * 4)];
                this.lines_wordEndIndices[this.lines_wordEndIndices.length] = w_len;
                this.lines_width[this.lines_width.length] = 0;
                this.lines_numSpacesPerline[this.lines_numSpacesPerline.length] = 0;
                var lineHeightCnt = 0;
                this.lines_height[this.lines_height.length] = lines_heights[lineHeightCnt];
                lines_formats[linecnt] = format;
                var line_width = 0;
                for (tr = this._paragraph_textRuns_indices[p]; tr < tr_len; tr++) {
                    format = this._textRuns_formats[tr];
                    format.font_table.initFontSize(format.size);
                    indent = format.indent;
                    w_len = this._textRuns_words[(tr * 4)] + (this._textRuns_words[(tr * 4) + 1] * 5);
                    if (!this.multiline || tr_length <= maxLineWidth || !this.wordWrap) {
                        //if(tr_length<maxLineWidth || !this.wordWrap){
                        // this must be a single textline
                        //console.log("just add to line",(tr * 4) , w_len, this.words, this._textRuns_words);
                        for (w = this._textRuns_words[(tr * 4)]; w < w_len; w += 5) {
                            word_width = this.words[w + 3];
                            //console.log("add word to line", this.words[w + 3], word_width, String.fromCharCode(this.chars_codes[this.words[w]]));
                            linelength += word_width;
                            this.lines_wordEndIndices[linecnt] = w + 5;
                            this.lines_width[linecnt] += word_width;
                            lines_formats[linecnt] = format;
                            if (this.chars_codes[this.words[w]] == 32 || this.chars_codes[this.words[w]] == 9) {
                                this.lines_numSpacesPerline[linecnt] += 1;
                            }
                        }
                    }
                    else {
                        //console.log("split lines");
                        word_width = 0;
                        indent = 0;
                        for (w = this._textRuns_words[(tr * 4)]; w < w_len; w += 5) {
                            word_width = this.words[w + 3];
                            var isSpace = false;
                            if (this.chars_codes[this.words[w]] == 32 || this.chars_codes[this.words[w]] == 9) {
                                this.lines_numSpacesPerline[linecnt] += 1;
                                isSpace = true;
                            }
                            // (1.5* format.font_table.getCharWidth("32")) is to replicate flash behavior
                            //console.log(String.fromCharCode(this.chars_codes[this.words[w]]), maxLineWidth, this.lines_width[linecnt], word_width);
                            if (isSpace || (this.lines_width[linecnt] + word_width) <= (maxLineWidth - indent - (1 * format.font_table.getCharWidth("32"))) || this.lines_width[linecnt] == 0) {
                                this.lines_wordEndIndices[linecnt] = w + 5;
                                this.lines_width[linecnt] += word_width;
                                lines_formats[linecnt] = format;
                            }
                            else {
                                linecnt++;
                                this.lines_wordStartIndices[linecnt] = w;
                                this.lines_wordEndIndices[linecnt] = w + 5;
                                this.lines_width[linecnt] = word_width;
                                this.lines_numSpacesPerline[linecnt] = 0;
                                this.lines_height[this.lines_height.length] = lines_heights[lineHeightCnt];
                                lines_formats[linecnt] = format;
                                indent = format.indent;
                            }
                        }
                        //console.log("split lines",linecnt );
                    }
                    //}
                }
                lineHeightCnt++;
                linecnt++;
            }
            var offsetx = this.textOffsetX;
            var start_idx;
            var numSpaces;
            var lineHeight;
            var end_idx;
            var lineSpaceLeft;
            var l;
            var l_cnt = this.lines_wordStartIndices.length;
            var charCnt = 0;
            this._biggestLine = 0;
            this._numLines = l_cnt;
            for (l = 0; l < l_cnt; l++) {
                linelength = this.lines_width[l];
                lineHeight = this.lines_height[l];
                start_idx = this.lines_wordStartIndices[l];
                end_idx = this.lines_wordEndIndices[l];
                numSpaces = this.lines_numSpacesPerline[l];
                format = lines_formats[l];
                //console.log("numLine:", l,linelength,start_idx,end_idx,numSpaces);
                lineSpaceLeft = maxLineWidth - linelength;
                offsetx = this.textOffsetX + format.leftMargin + format.indent;
                if (format.align == TextFormatAlign.JUSTIFY) {
                    if (l != 0) {
                        // only first line has indent
                        offsetx -= format.indent;
                    }
                }
                else if (format.align == TextFormatAlign.CENTER) {
                    if (lineSpaceLeft > 0)
                        offsetx += lineSpaceLeft / 2;
                    else {
                        offsetx += 2;
                    }
                }
                else if (format.align == TextFormatAlign.RIGHT) {
                    if (lineSpaceLeft > 0)
                        offsetx += lineSpaceLeft - 2;
                    else {
                        offsetx += 2;
                    }
                }
                else if (format.align == TextFormatAlign.LEFT) {
                    offsetx += 2;
                }
                var c_len = 0;
                var c = 0;
                var char_pos = offsetx;
                this.lines_start_x[l] = offsetx;
                this.lines_start_y[l] = offsety;
                this.lines_charIdx_start[l] = charCnt;
                var line_width = 0; //format.leftMargin + format.indent + format.rightMargin;
                for (w = start_idx; w < end_idx; w += 5) {
                    this.words[w + 1] = offsetx;
                    char_pos = 0;
                    start_idx = this.words[w];
                    c_len = start_idx + this.words[w + 4];
                    var tf = this.tf_per_char[start_idx];
                    tf.font_table.initFontSize(tf.size);
                    //console.log("lineHeight", lineHeight);
                    //console.log("lineHeight", tf.font_table.getLineHeight()+tf.leading);
                    var diff = (lineHeight) - (tf.font_table.getLineHeight() + tf.leading);
                    diff = ((diff > 0) ? diff - 2 : 0);
                    this.words[w + 2] = offsety + diff;
                    for (c = start_idx; c < c_len; c++) {
                        this.char_positions_x[this.char_positions_x.length] = offsetx + char_pos;
                        this.char_positions_y[this.char_positions_y.length] = offsety + diff;
                        char_pos += this.chars_width[c];
                        charCnt++;
                    }
                    //console.log("word_width", char_pos, "word:'"+wordstr+"'");
                    offsetx += char_pos; //this.words[w + 3];
                    line_width += char_pos; //this.words[w + 3];
                    //console.log("word offset: x",offsetx ,String.fromCharCode(this.chars_codes[this.words[w]]));
                    //if (format.align == "justify" && (this.chars_codes[this.words[w]] == 32 || this.chars_codes[this.words[w]] == 9)) {
                    // this is whitepace, we need to add extra space for justified text
                    //offsetx += additionalWhiteSpace;
                    //line_width += additionalWhiteSpace;
                    //}
                }
                this.lines_charIdx_end[l] = charCnt;
                //console.log("line_width",line_width);
                offsety += lineHeight;
                /* enable for icycle:
                if(format.leading==11 && format.font_name=="DayPosterBlack"){
                    offsety+=1.5;
                }*/
                if (line_width > text_width) {
                    this._biggestLine = l;
                    text_width = line_width;
                }
            }
            this._textWidth = text_width;
            this._textHeight = offsety;
            // if autosize is enabled, we adjust the textFieldHeight
            if (this.autoSize != TextFieldAutoSize.NONE)
                this._height = this._textHeight + 4;
            if (this._textWidth > this._width) {
                // get the max-scroll horizontal value 
                start_idx = this.lines_charIdx_start[this._biggestLine];
                c = this.lines_charIdx_end[this._biggestLine];
                var maxCnt = 0;
                while (c > start_idx) {
                    c--;
                    maxCnt += this.chars_width[c];
                    if (maxCnt > this._width) {
                        this._maxScrollH = c;
                        break;
                    }
                }
            }
            if (this._textHeight > this._height) {
                // get the max-scroll vertical value 
                var l_len = this.lines_height.length;
                var maxCnt = 4;
                while (l_len > 0) {
                    l_len--;
                    maxCnt += this.lines_height[l_len];
                    if (maxCnt > this._height) {
                        this._maxScrollV = l_len + 1;
                        break;
                    }
                }
            }
            this.updateMaskMode();
        };
        TextField.prototype.buildGlyphsForLabelData = function () {
            this._clearTextShapes();
            var formats = [];
            var glyphdata = [];
            var advance = [];
            var positions = [];
            var xpos = (this.staticMatrix.tx / 20);
            var ypos = (this.staticMatrix.ty / 20);
            var record;
            var lastMoveY = 0;
            for (var r = 0; r < this._labelData.records.length; r++) {
                formats[r] = new TextFormat();
                glyphdata[r] = [];
                advance[r] = [];
                record = this._labelData.records[r];
                if (record.font_table) {
                    formats[r].font_table = record.font_table;
                }
                else if (r > 0) {
                    formats[r].font_table = formats[r - 1].font_table;
                }
                else {
                    console.log("error - no font for label");
                }
                if (record.fontHeight) {
                    formats[r].size = record.fontHeight / 20;
                }
                else if (r > 0) {
                    formats[r].size = formats[r - 1].size;
                }
                if (record.color) {
                    //textProps.color =  this.rgbaToArgb((<any>myChild.attributes).color.nodeValue);
                    formats[r].color = ColorUtils.f32_RGBA_To_f32_ARGB(record.color);
                }
                else if (r > 0) {
                    formats[r].color = formats[r - 1].color;
                }
                //positions.push(this.textOffsetX+(record.moveX? record.moveX/20:0));
                //positions.push(this.textOffsetY+(record.moveY? record.moveY/20:0));
                //moveY=(record.moveY? record.moveY/20:0)-moveY;
                if (record.moveY != null) {
                    ypos += (record.moveY / 20) - lastMoveY;
                    lastMoveY = ypos;
                }
                else {
                    //ypos+=this.staticMatrix.ty/20;
                }
                //ypos=this.textOffsetY+(record.moveY? record.moveY/20:0);
                if (record.moveX != null) {
                    xpos = (this.staticMatrix.tx / 20) + (record.moveX / 20);
                }
                positions.push(xpos);
                positions.push(ypos);
                //console.log(-3+this.textOffsetX+((record.moveX? record.moveX/20:0)));
                //console.log(-7+this.textOffsetY+((record.moveY? record.moveY/20:0)));
                //var text="";
                //moveY=(record.moveY? record.moveY/20:0)-moveY;
                for (var e = 0; e < record.entries.length; e++) {
                    glyphdata[r][e] = record.entries[e].glyphIndex;
                    advance[r][e] = record.entries[e].advance / 20;
                    xpos += record.entries[e].advance / 20;
                    //text+=String.fromCharCode(parseInt((<TesselatedFontTable>formats[r].font_table).getStringForIdx(record.entries[e].glyphIndex)));
                }
                //console.log("\nrecord.entries.length: ", formats[r].font_table, record, record.entries.length);
                //console.log("textOffsetX ", this.textOffsetX, "textOffsetY ", this.textOffsetY, "moveX ", record.moveX, "moveY ", record.moveY, " staticMtx", this.staticMatrix);
            }
            var textShape;
            // process all textRuns
            var tr = 0;
            var tr_len = formats.length;
            var lineSize;
            var text_width = 0;
            var text_height = 0;
            for (tr = 0; tr < tr_len; tr++) {
                formats[tr].font_table.initFontSize(formats[tr].size);
                lineSize = formats[tr].font_table.buildTextLineFromIndices(this, formats[tr], positions[tr * 2], positions[tr * 2 + 1], glyphdata[tr], advance[tr]);
                text_height += lineSize.y;
                text_width = (lineSize.x > text_width) ? lineSize.x : text_width;
            }
            this._textWidth = text_width;
            this._textHeight = text_height;
            //this._width=text_width+4;
            //this._height=text_height+4;
            this.targetGraphics = this._graphics;
            this.targetGraphics.clear();
            if (this._background || this._type == TextFieldType.INPUT)
                this.drawBG();
            if (this.border || (!this._background && this._type != TextFieldType.INPUT))
                this.drawBorder();
            /*
            this._graphics.clear();
            this._graphics.beginFill(0xff0000, 1);//this.background?1:0);
            this._graphics.drawRect(-1,-1,this._width, this._height);
            this._graphics.endFill();
            */
            for (var key in this.textShapes) {
                textShape = this.textShapes[key];
                var attr_length = 2; //(tess_fontTable.usesCurves)?3:2;
                var attributesView = new AttributesView(Float32Array, attr_length);
                attributesView.set(textShape.verts);
                var vertexBuffer = attributesView.attributesBuffer.cloneBufferView();
                attributesView.dispose();
                textShape.elements = new TriangleElements(vertexBuffer);
                textShape.elements.setPositions(new Float2Attributes(vertexBuffer));
                //if(tess_fontTable.usesCurves){
                //	this._textElements.setCustomAttributes("curves", new Byte4Attributes(vertexBuffer, false));
                //}
                textShape.shape = this.targetGraphics.addShape(Shape.getShape(textShape.elements));
                textShape.shape.usages++;
                var sampler = new ImageSampler();
                textShape.shape.style = new Style();
                if (textShape.format.material && this._textColor == 0) {
                    textShape.shape.material = this._textFormat.material;
                    textShape.shape.style.addSamplerAt(sampler, textShape.shape.material.getTextureAt(0));
                    textShape.shape.material.animateUVs = true;
                    textShape.shape.style.uvMatrix = new Matrix(0, 0, 0, 0, textShape.format.uv_values[0], textShape.format.uv_values[1]);
                }
                else {
                    var color = this.getTextColorForTextFormat(textShape.format);
                    var alpha = ColorUtils.float32ColorToARGB(color)[0];
                    if (alpha == 0) {
                        alpha = 255;
                    }
                    var obj = Graphics.get_material_for_color(color, alpha / 255);
                    textShape.shape.material = obj.material;
                    if (obj.colorPos) {
                        textShape.shape.style.addSamplerAt(sampler, textShape.shape.material.getTextureAt(0));
                        textShape.shape.material.animateUVs = true;
                        textShape.shape.style.uvMatrix = new Matrix(0, 0, 0, 0, obj.colorPos.x, obj.colorPos.y);
                    }
                    /*
                                    (<any>textShape.shape.material).useColorTransform = true;
                                    var new_ct:ColorTransform = this.transform.colorTransform || (this.transform.colorTransform = new ColorTransform());
                                    this.transform.colorTransform.color = textShape.format.color;
                                    this._invalidateHierarchicalProperties(HierarchicalProperties.COLOR_TRANSFORM);
                    */
                }
            }
        };
        TextField.prototype.buildGlyphs = function () {
            this._clearTextShapes();
            // process all textRuns
            var tr = 0;
            var tr_len = this._textRuns_formats.length;
            for (tr = 0; tr < tr_len; tr++) {
                this._textRuns_formats[tr].font_table.initFontSize(this._textRuns_formats[tr].size);
                //	console.log( this._textRuns_formats[tr],  this._textRuns_words[tr*4],  this._textRuns_words[(tr*4)+1]);
                this._textRuns_formats[tr].font_table.fillTextRun(this, this._textRuns_formats[tr], this._textRuns_words[(tr * 4)], this._textRuns_words[(tr * 4) + 1]);
            }
            var textShape;
            for (var key in this.textShapes) {
                textShape = this.textShapes[key];
                var color = this.getTextColorForTextFormat(textShape.format);
                var alpha = ColorUtils.float32ColorToARGB(color)[0];
                if (alpha == 0) {
                    alpha = 255;
                }
                // this textShapeshape is for FNT font
                var attr_length = textShape.fntMaterial ? 4 : 2;
                var attributesView = new AttributesView(Float32Array, attr_length);
                attributesView.set(textShape.verts);
                var vertexBuffer = attributesView.attributesBuffer.cloneBufferView();
                attributesView.dispose();
                textShape.elements = new TriangleElements(vertexBuffer);
                textShape.elements.setPositions(new Float2Attributes(vertexBuffer));
                if (textShape.fntMaterial)
                    textShape.elements.setUVs(new Float2Attributes(vertexBuffer));
                textShape.shape = Shape.getShape(textShape.elements);
                textShape.shape.usages++;
                var sampler = new ImageSampler(false, true, true);
                textShape.shape.style = new Style();
                if (textShape.fntMaterial) {
                    // 	used by FNT fonts
                    textShape.shape.material = textShape.fntMaterial;
                    textShape.shape.style.addSamplerAt(sampler, textShape.shape.material.getTextureAt(0));
                    //(<MaterialBase> textShape.shape.material).colorTransform=new ColorTransform();
                    //(<MaterialBase> textShape.shape.material).colorTransform.color=color;					
                }
                else if (textShape.format.material && this._textColor == 0) {
                    // 	used for textfields loaded from awd. 
                    //	the material on the format uses textureAtlas from awd
                    textShape.shape.material = this._textFormat.material;
                    textShape.shape.style.addSamplerAt(sampler, textShape.shape.material.getTextureAt(0));
                    textShape.shape.material.animateUVs = true;
                    textShape.shape.style.uvMatrix = new Matrix(0, 0, 0, 0, textShape.format.uv_values[0], textShape.format.uv_values[1]);
                }
                else {
                    // 	used by runtime textureatlas. 
                    //	(standart for dynamic created text and text loaded from swf)					
                    var obj = Graphics.get_material_for_color(color, alpha / 255);
                    textShape.shape.material = obj.material;
                    if (obj.colorPos) {
                        textShape.shape.style.addSamplerAt(sampler, textShape.shape.material.getTextureAt(0));
                        textShape.shape.material.animateUVs = true;
                        textShape.shape.style.uvMatrix = new Matrix(0, 0, 0, 0, obj.colorPos.x, obj.colorPos.y);
                    }
                }
            }
        };
        TextField.prototype.buildShapes = function () {
            if (!this.targetGraphics) {
                this.targetGraphics = this._graphics;
            }
            else {
                this._graphics.clear();
            }
            this.targetGraphics.clear();
            if (this._background || this._type == TextFieldType.INPUT)
                this.drawBG();
            if (this._border || !this._background)
                this.drawBorder();
            this.drawSelectionGraphics();
            if (this.bgShapeSelect && this.isInFocus) {
                this.targetGraphics.addShape(this.bgShapeSelect);
            }
            var textShape;
            for (var key in this.textShapes) {
                textShape = this.textShapes[key];
                this.targetGraphics.addShape(textShape.shape);
            }
            if (this.type == TextFieldType.INPUT && this.isInFocus && this.cursorShape) {
                this.targetGraphics.addShape(this.cursorShape);
            }
        };
        /**
         * Appends the string specified by the <code>newText</code> parameter to the
         * end of the text of the text field. This method is more efficient than an
         * addition assignment(<code>+=</code>) on a <code>text</code> property
         * (such as <code>someTextField.text += moreText</code>), particularly for a
         * text field that contains a significant amount of content.
         *
         * @param newText The string to append to the existing text.
         */
        TextField.prototype.appendText = function (newText) {
            this._iText += newText;
            this._textDirty = true;
            if (this._autoSize != TextFieldAutoSize.NONE)
                this.invalidate();
            else if (this._implicitPartition)
                this._implicitPartition.invalidateEntity(this);
        };
        /**
         * *tells the Textfield that a paragraph is defined completly.
         * e.g. the textfield will start a new line for future added text.
         */
        TextField.prototype.closeParagraph = function () {
            this._iText += "\n";
            this._textDirty = true;
            if (this._autoSize != TextFieldAutoSize.NONE)
                this.invalidate();
            else if (this._implicitPartition)
                this._implicitPartition.invalidateEntity(this);
        };
        /**
         * Returns a rectangle that is the bounding box of the character.
         *
         * @param charIndex The zero-based index value for the character(for
         *                  example, the first position is 0, the second position is
         *                  1, and so on).
         * @return A rectangle with <code>x</code> and <code>y</code> minimum and
         *         maximum values defining the bounding box of the character.
         */
        TextField.prototype.getCharBoundaries = function (charIndex) {
            console.log("Textfield.getCharBoundaries() not implemented");
            return this._charBoundaries;
        };
        /**
         * Returns the zero-based index value of the character at the point specified
         * by the <code>x</code> and <code>y</code> parameters.
         *
         * @param x The <i>x</i> coordinate of the character.
         * @param y The <i>y</i> coordinate of the character.
         * @return The zero-based index value of the character(for example, the
         *         first position is 0, the second position is 1, and so on). Returns
         *         -1 if the point is not over any character.
         */
        TextField.prototype.getCharIndexAtPoint = function (x, y, lineIdx) {
            if (lineIdx === void 0) { lineIdx = -1; }
            if (lineIdx < 0)
                lineIdx = this.getLineIndexAtPoint(x, y);
            var startIdx = this.lines_charIdx_start[lineIdx];
            var endIdx = this.lines_charIdx_end[lineIdx];
            for (var i = startIdx; i < endIdx; i++) {
                if (x >= this.char_positions_x[i]) {
                    if (x <= this.char_positions_x[i] + this.chars_width[i] / 2) {
                        return i;
                    }
                    else if (x <= this.char_positions_x[i] + this.chars_width[i]) {
                        return i + 1;
                    }
                }
            }
            return -1;
        };
        /**
         * Given a character index, returns the index of the first character in the
         * same paragraph.
         *
         * @param charIndex The zero-based index value of the character(for example,
         *                  the first character is 0, the second character is 1, and
         *                  so on).
         * @return The zero-based index value of the first character in the same
         *         paragraph.
         * @throws RangeError The character index specified is out of range.
         */
        TextField.prototype.getFirstCharInParagraph = function (charIndex /*int*/) {
            console.log("Textfield.getFirstCharInParagraph() not implemented");
            return this._firstCharInParagraph;
        };
        /**
         * Returns a DisplayObject reference for the given <code>id</code>, for an
         * image or SWF file that has been added to an HTML-formatted text field by
         * using an <code><img></code> tag. The <code><img></code> tag is in the
         * following format:
         *
         * <p><pre xml:space="preserve"><code> <img src = 'filename.jpg' id =
         * 'instanceName' ></code></pre></p>
         *
         * @param id The <code>id</code> to match(in the <code>id</code> attribute
         *           of the <code><img></code> tag).
         * @return The display object corresponding to the image or SWF file with the
         *         matching <code>id</code> attribute in the <code><img></code> tag
         *         of the text field. For media loaded from an external source, this
         *         object is a Loader object, and, once loaded, the media object is a
         *         child of that Loader object. For media embedded in the SWF file,
         *         it is the loaded object. If no <code><img></code> tag with the
         *         matching <code>id</code> exists, the method returns
         *         <code>null</code>.
         */
        TextField.prototype.getImageReference = function (id) {
            console.log("TextField.getImageReference() not implemented");
            return this._imageReference;
        };
        /**
         * Returns the zero-based index value of the line at the point specified by
         * the <code>x</code> and <code>y</code> parameters.
         *
         * @param x The <i>x</i> coordinate of the line.
         * @param y The <i>y</i> coordinate of the line.
         * @return The zero-based index value of the line(for example, the first
         *         line is 0, the second line is 1, and so on). Returns -1 if the
         *         point is not over any line.
         */
        TextField.prototype.getLineIndexAtPoint = function (x, y) {
            var len = this.lines_start_y.length;
            for (var i = 0; i < len - 1; i++) {
                if (y >= this.lines_start_y[i] && y <= this.lines_start_y[i + 1])
                    return i;
            }
            // no line found. it must be the last
            if (y >= this.lines_start_y[len - 1])
                return len - 1;
            return 0;
        };
        /**
         * Returns the zero-based index value of the line containing the character
         * specified by the <code>charIndex</code> parameter.
         *
         * @param charIndex The zero-based index value of the character(for example,
         *                  the first character is 0, the second character is 1, and
         *                  so on).
         * @return The zero-based index value of the line.
         * @throws RangeError The character index specified is out of range.
         */
        TextField.prototype.getLineIndexOfChar = function (charIndex /*int*/) {
            var len = this.lines_charIdx_start.length - 1;
            for (var i; i < len; i++) {
                if (charIndex >= this.lines_charIdx_start[i] && charIndex <= this.lines_charIdx_end[i + 1])
                    return i;
            }
            // no line found. it must be the last
            return len;
        };
        /**
         * Returns the number of characters in a specific text line.
         *
         * @param lineIndex The line number for which you want the length.
         * @return The number of characters in the line.
         * @throws RangeError The line number specified is out of range.
         */
        TextField.prototype.getLineLength = function (lineIndex /*int*/) {
            if (this.lines_width.length == 0) {
                return 0;
            }
            if (lineIndex >= this.lines_width.length)
                return this.lines_width[this.lines_width.length - 1];
            return this.lines_width[lineIndex];
        };
        /**
         * Returns metrics information about a given text line.
         *
         * @param lineIndex The line number for which you want metrics information.
         * @return A TextLineMetrics object.
         * @throws RangeError The line number specified is out of range.
         */
        TextField.prototype.getLineMetrics = function (lineIndex /*int*/) {
            var newLineMetrics = new TextLineMetrics();
            if (this.lines_width.length == 0) {
                return newLineMetrics;
            }
            if (lineIndex >= this.lines_width.length)
                lineIndex = this.lines_width.length - 1;
            newLineMetrics.x = this.lines_start_x[lineIndex];
            newLineMetrics.width = this.lines_width[lineIndex];
            //newLineMetrics.ascent=
            //newLineMetrics.descent
            //newLineMetrics.height
            //newLineMetrics.leading
            return this._lineMetrics;
        };
        /**
         * Returns the character index of the first character in the line that the
         * <code>lineIndex</code> parameter specifies.
         *
         * @param lineIndex The zero-based index value of the line(for example, the
         *                  first line is 0, the second line is 1, and so on).
         * @return The zero-based index value of the first character in the line.
         * @throws RangeError The line number specified is out of range.
         */
        TextField.prototype.getLineOffset = function (lineIndex /*int*/) {
            if (this.lines_charIdx_start.length == 0) {
                return 0;
            }
            if (lineIndex >= this.lines_charIdx_start.length)
                return this.lines_charIdx_start[this.lines_charIdx_start.length - 1];
            return this.lines_charIdx_start[lineIndex];
        };
        /**
         * Returns the text of the line specified by the <code>lineIndex</code>
         * parameter.
         *
         * @param lineIndex The zero-based index value of the line(for example, the
         *                  first line is 0, the second line is 1, and so on).
         * @return The text string contained in the specified line.
         * @throws RangeError The line number specified is out of range.
         */
        TextField.prototype.getLineText = function (lineIndex /*int*/) {
            if (this.lines_charIdx_start.length == 0) {
                return "";
            }
            if (lineIndex >= this.lines_width.length)
                lineIndex = this.lines_width.length - 1;
            return this._iText.slice(this.lines_charIdx_start[lineIndex], this.lines_charIdx_end[lineIndex]);
        };
        /**
         * Given a character index, returns the length of the paragraph containing
         * the given character. The length is relative to the first character in the
         * paragraph(as returned by <code>getFirstCharInParagraph()</code>), not to
         * the character index passed in.
         *
         * @param charIndex The zero-based index value of the character(for example,
         *                  the first character is 0, the second character is 1, and
         *                  so on).
         * @return Returns the number of characters in the paragraph.
         * @throws RangeError The character index specified is out of range.
         */
        TextField.prototype.getParagraphLength = function (charIndex /*int*/) {
            return this._paragraphLength;
        };
        /**
         * Returns a TextFormat object that contains formatting information for the
         * range of text that the <code>beginIndex</code> and <code>endIndex</code>
         * parameters specify. Only properties that are common to the entire text
         * specified are set in the resulting TextFormat object. Any property that is
         * <i>mixed</i>, meaning that it has different values at different points in
         * the text, has a value of <code>null</code>.
         *
         * <p>If you do not specify values for these parameters, this method is
         * applied to all the text in the text field. </p>
         *
         * <p>The following table describes three possible usages:</p>
         *
         * @return The TextFormat object that represents the formatting properties
         *         for the specified text.
         * @throws RangeError The <code>beginIndex</code> or <code>endIndex</code>
         *                    specified is out of range.
         */
        TextField.prototype.getTextFormat = function (beginIndex, endIndex) {
            if (beginIndex === void 0) { beginIndex = -1; }
            if (endIndex === void 0) { endIndex = -1; }
            if (beginIndex >= 0 || endIndex >= 0)
                console.warn("Textfield.getTextFormat() not correctly implemented for multi-formatted text");
            return this._textFormat;
        };
        /**
         * Replaces the current selection with the contents of the <code>value</code>
         * parameter. The text is inserted at the position of the current selection,
         * using the current default character format and default paragraph format.
         * The text is not treated as HTML.
         *
         * <p>You can use the <code>replaceSelectedText()</code> method to insert and
         * delete text without disrupting the character and paragraph formatting of
         * the rest of the text.</p>
         *
         * <p><b>Note:</b> This method does not work if a style sheet is applied to
         * the text field.</p>
         *
         * @param value The string to replace the currently selected text.
         * @throws Error This method cannot be used on a text field with a style
         *               sheet.
         */
        TextField.prototype.replaceSelectedText = function (value) {
            var selectionStart = this._selectionBeginIndex;
            var selectionEnd = this._selectionEndIndex;
            if (selectionEnd != selectionStart) {
                if (selectionEnd < selectionStart) {
                    selectionStart = this._selectionEndIndex;
                    selectionEnd = this._selectionBeginIndex;
                }
                var textBeforeCursor = this._iText.slice(0, selectionStart - 1);
                var textAfterCursor = this._iText.slice(selectionEnd, this._iText.length);
                this.text = textBeforeCursor + value + textAfterCursor;
                this._selectionBeginIndex = selectionStart;
                this._selectionEndIndex = this._selectionBeginIndex + value.length;
                return;
            }
            var textBeforeCursor = this._iText.slice(0, selectionStart);
            var textAfterCursor = this._iText.slice(selectionEnd, this._iText.length);
            this.text = textBeforeCursor + value + textAfterCursor;
            this._selectionBeginIndex = selectionStart + 1;
            this._selectionEndIndex = this._selectionBeginIndex;
        };
        /**
         * Replaces the range of characters that the <code>beginIndex</code> and
         * <code>endIndex</code> parameters specify with the contents of the
         * <code>newText</code> parameter. As designed, the text from
         * <code>beginIndex</code> to <code>endIndex-1</code> is replaced.
         *
         * <p><b>Note:</b> This method does not work if a style sheet is applied to
         * the text field.</p>
         *
         * @param beginIndex The zero-based index value for the start position of the
         *                   replacement range.
         * @param endIndex   The zero-based index position of the first character
         *                   after the desired text span.
         * @param newText    The text to use to replace the specified range of
         *                   characters.
         * @throws Error This method cannot be used on a text field with a style
         *               sheet.
         */
        TextField.prototype.replaceText = function (beginIndex /*int*/, endIndex /*int*/, newText) {
            var textBeforeCursor = this._iText.slice(0, beginIndex - 1);
            var textAfterCursor = this._iText.slice(endIndex, this._iText.length);
            this.text = textBeforeCursor + newText + textAfterCursor;
            this._selectionEndIndex = this._selectionBeginIndex + newText.length;
        };
        /**
         * Sets as selected the text designated by the index values of the first and
         * last characters, which are specified with the <code>beginIndex</code> and
         * <code>endIndex</code> parameters. If the two parameter values are the
         * same, this method sets the insertion point, as if you set the
         * <code>caretIndex</code> property.
         *
         * @param beginIndex The zero-based index value of the first character in the
         *                   selection(for example, the first character is 0, the
         *                   second character is 1, and so on).
         * @param endIndex   The zero-based index value of the last character in the
         *                   selection.
         */
        TextField.prototype.setSelection = function (beginIndex /*int*/, endIndex /*int*/) {
            if (this._selectionBeginIndex == beginIndex && this._selectionBeginIndex == endIndex)
                return;
            this._selectionBeginIndex = beginIndex;
            this._selectionEndIndex = endIndex;
            this._glyphsDirty = true;
            this.reConstruct();
            this.drawSelectionGraphics();
        };
        /**
         * Applies the text formatting that the <code>format</code> parameter
         * specifies to the specified text in a text field. The value of
         * <code>format</code> must be a TextFormat object that specifies the desired
         * text formatting changes. Only the non-null properties of
         * <code>format</code> are applied to the text field. Any property of
         * <code>format</code> that is set to <code>null</code> is not applied. By
         * default, all of the properties of a newly created TextFormat object are
         * set to <code>null</code>.
         *
         * <p><b>Note:</b> This method does not work if a style sheet is applied to
         * the text field.</p>
         *
         * <p>The <code>setTextFormat()</code> method changes the text formatting
         * applied to a range of characters or to the entire body of text in a text
         * field. To apply the properties of format to all text in the text field, do
         * not specify values for <code>beginIndex</code> and <code>endIndex</code>.
         * To apply the properties of the format to a range of text, specify values
         * for the <code>beginIndex</code> and the <code>endIndex</code> parameters.
         * You can use the <code>length</code> property to determine the index
         * values.</p>
         *
         * <p>The two types of formatting information in a TextFormat object are
         * character level formatting and paragraph level formatting. Each character
         * in a text field can have its own character formatting settings, such as
         * font name, font size, bold, and italic.</p>
         *
         * <p>For paragraphs, the first character of the paragraph is examined for
         * the paragraph formatting settings for the entire paragraph. Examples of
         * paragraph formatting settings are left margin, right margin, and
         * indentation.</p>
         *
         * <p>Any text inserted manually by the user, or replaced by the
         * <code>replaceSelectedText()</code> method, receives the default text field
         * formatting for new text, and not the formatting specified for the text
         * insertion point. To set the default formatting for new text, use
         * <code>defaultTextFormat</code>.</p>
         *
         * @param format A TextFormat object that contains character and paragraph
         *               formatting information.
         * @throws Error      This method cannot be used on a text field with a style
         *                    sheet.
         * @throws RangeError The <code>beginIndex</code> or <code>endIndex</code>
         *                    specified is out of range.
         */
        TextField.prototype.setTextFormat = function (format, beginIndex, endIndex) {
            if (beginIndex === void 0) { beginIndex = -1; }
            if (endIndex === void 0) { endIndex = -1; }
            if (this._textDirty) {
                this.reConstruct();
            }
            /**
             *  this should only effect existing text
             *  if no text exist, this function does nothing
             *
             *  this means that we only want to act on the existing textFormats list,
             *  never on the textFormat property directly
             * */
            //console.log("setTextFormat", this.chars_codes.length, format, this._iText);
            if (this.chars_codes.length == 0 || !format)
                return;
            var i = 0;
            if ((beginIndex == -1 && endIndex == -1)
                || (beginIndex == 0 && endIndex == -1)
                || ((beginIndex == -1 || beginIndex == 0) && endIndex >= this.chars_codes.length)) {
                // easy: apply the format to all formats in the list
                for (i = 0; i < this._textFormats.length; i++) {
                    this._textFormats[i] = this._textFormats[i].clone();
                    format.applyToFormat(this._textFormats[i]);
                }
                this._textDirty = true;
                return;
            }
            // todo: the above conditions are a hack to get it working for a AVM1 lesson.
            // below is the code that should actually do the job more, but could not get it to work 100% yet
            //console.log("\n\nadd format", this.id, this._iText, beginIndex, endIndex, format.color);
            //console.log("this._textFormats", this._textFormats, this._textFormatsIdx);
            /**
             * _textformatsIdx list should always be ordered numeric
             * todo: should this be verified here, or is it already taken care of ?
             */
            var newFormatsTextFormats = [];
            var newFormatsTextFormatsIdx = [];
            var oldStartIdx = 0;
            var oldEndIdx = -1;
            var oldFormat;
            var formatLen = this._textFormats.length;
            var charLen = this.chars_codes.length;
            if (beginIndex == -1)
                beginIndex = 0;
            if (endIndex == -1) {
                endIndex = charLen;
            }
            if (endIndex < beginIndex) {
                var tmp = endIndex;
                endIndex = beginIndex;
                beginIndex = tmp;
            }
            if (endIndex == beginIndex) {
                endIndex++;
            }
            //console.log("check formats");
            for (i = 0; i < formatLen; i++) {
                if (i > 0)
                    oldStartIdx = oldEndIdx;
                oldEndIdx = this._textFormatsIdx[i];
                oldFormat = this._textFormats[i];
                //console.log("oldFormat", oldStartIdx, oldEndIdx);
                //console.log("check formats", oldStartIdx, oldEndIdx, beginIndex, endIndex);
                if (oldStartIdx <= beginIndex && oldEndIdx > beginIndex) {
                    // we have a interset in the range.
                    //console.log("intersects");
                    // we have a bit of text that should remain the original format
                    if (oldStartIdx < beginIndex) {
                        newFormatsTextFormats.push(oldFormat);
                        newFormatsTextFormatsIdx.push(beginIndex);
                        //console.log("add old format", beginIndex);
                    }
                    while (oldEndIdx < endIndex) {
                        //console.log("add new merged format", oldEndIdx);
                        var newFormat = this._textFormats[i].clone();
                        format.applyToFormat(newFormat);
                        newFormatsTextFormats.push(newFormat);
                        newFormatsTextFormatsIdx.push(oldEndIdx);
                        i++;
                        if (i < formatLen) {
                            oldEndIdx = this._textFormatsIdx[i];
                            oldFormat = this._textFormats[i];
                        }
                        else {
                            oldEndIdx = endIndex + 1;
                        }
                    }
                    if (oldEndIdx == endIndex) {
                        //console.log("add new format rest", endIndex);
                        var newFormat = oldFormat.clone();
                        format.applyToFormat(newFormat);
                        newFormatsTextFormats.push(newFormat);
                        newFormatsTextFormatsIdx.push(endIndex);
                    }
                    if (oldEndIdx > endIndex) {
                        //console.log("add new format rest", endIndex);
                        var newFormat = oldFormat.clone();
                        format.applyToFormat(newFormat);
                        newFormatsTextFormats.push(newFormat);
                        newFormatsTextFormatsIdx.push(endIndex);
                        //console.log("add old format rest", oldEndIdx);
                        newFormatsTextFormats.push(oldFormat);
                        newFormatsTextFormatsIdx.push(oldEndIdx);
                    }
                }
                else {
                    //console.log("outside of new range. just add it", oldStartIdx, oldEndIdx);
                    // outside of new range. just add it
                    newFormatsTextFormats.push(this._textFormats[i]);
                    newFormatsTextFormatsIdx.push(this._textFormatsIdx[i]);
                }
            }
            //console.log("new formats");
            this._textFormats.length = 0;
            this._textFormatsIdx.length = 0;
            for (i = 0; i < newFormatsTextFormats.length; i++) {
                //console.log("new formats ", newFormatsTextFormatsIdx[i], newFormatsTextFormats[i]);
                this._textFormats[i] = newFormatsTextFormats[i];
                this._textFormatsIdx[i] = newFormatsTextFormatsIdx[i];
            }
            this._textDirty = true;
        };
        /**
         * Returns true if an embedded font is available with the specified
         * <code>fontName</code> and <code>fontStyle</code> where
         * <code>Font.fontType</code> is <code>flash.text.FontType.EMBEDDED</code>.
         * Starting with Flash Player 10, two kinds of embedded fonts can appear in a
         * SWF file. Normal embedded fonts are only used with TextField objects. CFF
         * embedded fonts are only used with the flash.text.engine classes. The two
         * types are distinguished by the <code>fontType</code> property of the
         * <code>Font</code> class, as returned by the <code>enumerateFonts()</code>
         * function.
         *
         * <p>TextField cannot use a font of type <code>EMBEDDED_CFF</code>. If
         * <code>embedFonts</code> is set to <code>true</code> and the only font
         * available at run time with the specified name and style is of type
         * <code>EMBEDDED_CFF</code>, Flash Player fails to render the text, as if no
         * embedded font were available with the specified name and style.</p>
         *
         * <p>If both <code>EMBEDDED</code> and <code>EMBEDDED_CFF</code> fonts are
         * available with the same name and style, the <code>EMBEDDED</code> font is
         * selected and text renders with the <code>EMBEDDED</code> font.</p>
         *
         * @param fontName  The name of the embedded font to check.
         * @param fontStyle Specifies the font style to check. Use
         *                  <code>flash.text.FontStyle</code>
         * @return <code>true</code> if a compatible embedded font is available,
         *         otherwise <code>false</code>.
         * @throws ArgumentError The <code>fontStyle</code> specified is not a member
         *                       of <code>flash.text.FontStyle</code>.
         */
        TextField.isFontCompatible = function (fontName, fontStyle) {
            return false;
        };
        TextField.prototype.onKey = function (e) {
            var keyEvent = e;
            this.addChar(keyEvent.char, keyEvent.isShift, keyEvent.isCTRL, keyEvent.isAlt);
            //console.log("textfield.onKey this.text", this.text);
        };
        TextField.prototype.addCharCode = function (charCode) {
            this.addChar(String.fromCharCode(charCode));
        };
        TextField.prototype.deleteSelectedText = function (deleteMode) {
            if (deleteMode === void 0) { deleteMode = "Backspace"; }
            if (this.text.length == 0)
                return;
            if (this._selectionBeginIndex != this._selectionEndIndex) {
                var textBeforeCursor = (this._selectionBeginIndex != 0) ? this._iText.slice(0, this._selectionBeginIndex) : "";
                var textAfterCursor = (this._selectionEndIndex < this._iText.length) ? this._iText.slice(this._selectionEndIndex, this._iText.length) : "";
                this.text = textBeforeCursor + textAfterCursor;
                this._selectionEndIndex = this._selectionBeginIndex;
                return;
            }
            if (deleteMode == "Backspace") {
                if (this._selectionBeginIndex == 0) {
                    return;
                }
                var textBeforeCursor = this._iText.slice(0, this._selectionBeginIndex - 1);
                var textAfterCursor = this._iText.slice(this._selectionEndIndex, this._iText.length);
                this.text = textBeforeCursor + textAfterCursor;
                this._selectionBeginIndex -= 1;
                this._selectionEndIndex = this._selectionBeginIndex;
            }
            else if (deleteMode == "Delete") {
                var textBeforeCursor = this._iText.slice(0, this._selectionBeginIndex);
                var textAfterCursor = this._iText.slice(this._selectionEndIndex + 1, this._iText.length);
                this.text = textBeforeCursor + textAfterCursor;
                this._selectionEndIndex = this._selectionBeginIndex;
            }
        };
        TextField.prototype.addChar = function (char, isShift, isCTRL, isAlt) {
            if (isShift === void 0) { isShift = false; }
            if (isCTRL === void 0) { isCTRL = false; }
            if (isAlt === void 0) { isAlt = false; }
            //console.log("addChar")
            var oldText = this._iText;
            if (!this._selectionBeginIndex) {
                this._selectionBeginIndex = 0;
            }
            if (!this._selectionEndIndex) {
                this._selectionEndIndex = 0;
            }
            if (this._selectionEndIndex < this._selectionBeginIndex) {
                var tmpStart = this._selectionEndIndex;
                this._selectionEndIndex = this._selectionBeginIndex;
                this._selectionBeginIndex = tmpStart;
            }
            //console.log("textfield.onKey char", String.fromCharCode(keyEvent.charCode));
            // todo: correctly implement text-cursor, and delete / add from its position
            if (char == "Backspace" || char == "Delete") {
                this.deleteSelectedText(char);
            }
            else if (char == "ArrowRight") {
                if (!isShift && this._selectionEndIndex != this._selectionBeginIndex) {
                    if (this._selectionEndIndex > this._selectionBeginIndex)
                        this._selectionBeginIndex = this._selectionEndIndex;
                    else
                        this._selectionEndIndex = this._selectionBeginIndex;
                }
                else {
                    if (this._selectionEndIndex > this._selectionBeginIndex) {
                        this._selectionEndIndex += 1;
                        if (!isShift)
                            this._selectionBeginIndex = this._selectionEndIndex;
                    }
                    else {
                        this._selectionBeginIndex += 1;
                        if (!isShift)
                            this._selectionEndIndex = this._selectionBeginIndex;
                    }
                }
                //this._selectionEndIndex=this._selectionBeginIndex;
            }
            else if (char == "ArrowLeft") {
                if (!isShift && this._selectionEndIndex != this._selectionBeginIndex) {
                    if (this._selectionEndIndex > this._selectionBeginIndex)
                        this._selectionEndIndex = this._selectionBeginIndex;
                    else
                        this._selectionBeginIndex = this._selectionEndIndex;
                }
                else {
                    if (this._selectionEndIndex > this._selectionBeginIndex) {
                        this._selectionBeginIndex -= 1;
                        if (!isShift)
                            this._selectionEndIndex = this._selectionBeginIndex;
                    }
                    else {
                        this._selectionEndIndex -= 1;
                        if (!isShift)
                            this._selectionBeginIndex = this._selectionEndIndex;
                    }
                }
                //this._selectionEndIndex=this._selectionBeginIndex;
            }
            else if (char == "Enter" && this.multiline) {
                this._insertNewText("\n");
            }
            else if (char.length == 1) {
                if (this._restrictRegex) {
                    var chartest1 = char.replace(this._restrictRegex, "");
                    if (chartest1.length < char.length) {
                        var chartest2 = char.toUpperCase().replace(this._restrictRegex, "");
                        var chartest3 = char.toLowerCase().replace(this._restrictRegex, "");
                        char = chartest2;
                        if (chartest2.length < chartest3.length) {
                            char = chartest3;
                        }
                        if (chartest1.length > char.length) {
                            char = chartest1;
                        }
                    }
                    if (char == "")
                        return;
                }
                if (this.newTextFormat.font_table) {
                    if (!this.newTextFormat.font_table.hasChar(char.charCodeAt(0).toString())) {
                        char = char.toUpperCase();
                        if (!this.newTextFormat.font_table.hasChar(char.charCodeAt(0).toString())) {
                            char = char.toLowerCase();
                            if (!this.newTextFormat.font_table.hasChar(char.charCodeAt(0).toString())) {
                                return;
                            }
                        }
                    }
                }
                this._insertNewText(char);
            }
            else if (char.length > 1) {
                console.log("invalid keyboard input: ", char);
            }
            this._glyphsDirty = true;
            this.reConstruct();
            this.drawSelectionGraphics();
            this.invalidate();
            if (oldText !== this._iText)
                this.dispatchEvent(TextField._onChangedEvent);
            if (char && char.length > 0 && this.adapter != this) {
                var charCode;
                switch (char) {
                    case "Backspace":
                        charCode = 8;
                        break;
                    case "Delete":
                        charCode = 46;
                        break;
                    case "ArrowRight":
                        charCode = 39;
                        break;
                    case "ArrowLeft":
                        charCode = 37;
                        break;
                    case ".":
                        charCode = 189;
                        break;
                    default:
                        charCode = char.charCodeAt(0);
                        break;
                }
                //console.log("dispatchKeyEvent");
                this.adapter.dispatchKeyEvent(charCode, isShift, isCTRL, isAlt);
            }
        };
        TextField.prototype._insertNewText = function (newText) {
            if (this._selectionBeginIndex != this._selectionEndIndex) {
                var textBeforeCursor = this._iText.slice(0, this._selectionBeginIndex);
                var textAfterCursor = this._iText.slice(this._selectionEndIndex, this._iText.length);
                if (this.maxChars > 0 && (textBeforeCursor.length + textAfterCursor.length + newText.length) > this.maxChars) {
                    var maxNewChars = this.maxChars - textBeforeCursor.length + textAfterCursor.length;
                    if (maxNewChars > 0) {
                        newText = newText.slice(0, maxNewChars);
                    }
                }
                this.text = textBeforeCursor + newText + textAfterCursor;
                this._selectionBeginIndex += 1;
                this._selectionEndIndex = this._selectionBeginIndex;
            }
            else {
                if (this.maxChars > 0 && this._iText.length >= this.maxChars) {
                }
                else {
                    var textBeforeCursor = this._iText.slice(0, this._selectionBeginIndex);
                    var textAfterCursor = this._iText.slice(this._selectionEndIndex, this._iText.length);
                    this.text = textBeforeCursor + newText + textAfterCursor;
                    this._selectionBeginIndex += 1;
                    this._selectionEndIndex = this._selectionBeginIndex;
                }
            }
        };
        TextField.prototype.clone = function () {
            var newInstance = TextField.getNewTextField();
            this.copyTo(newInstance);
            return newInstance;
        };
        TextField.prototype.copyTo = function (newInstance) {
            _super.prototype.copyTo.call(this, newInstance);
            newInstance.autoSize = this.autoSize;
            newInstance.type = this._type;
            newInstance.html = this.html;
            newInstance.width = this._width;
            newInstance.height = this._height;
            if (this._textFormat)
                newInstance.textFormat = this._textFormat.clone();
            newInstance.textColor = this._textColor;
            newInstance.border = this._border;
            newInstance.borderColor = this._borderColor;
            newInstance.background = this._background;
            newInstance.backgroundColor = this._backgroundColor;
            newInstance.textOffsetX = this.textOffsetX;
            newInstance.textOffsetY = this.textOffsetY;
            newInstance.staticMatrix = this.staticMatrix;
            newInstance.selectable = this._selectable;
            newInstance.multiline = this.multiline;
            newInstance.wordWrap = this.wordWrap;
            newInstance.maxChars = this.maxChars;
            newInstance.sourceTextField = this;
            newInstance["fileurl"] = this["fileurl"];
            if (newInstance.html) {
                newInstance.htmlText = this.htmlText;
            }
            else {
                newInstance.text = this.text;
            }
            if (this._labelData) {
                newInstance.setLabelData(this._labelData);
            }
        };
        TextField.prototype._clearTextShapes = function () {
            if (this.targetGraphics)
                this.targetGraphics.clear();
            var textShape;
            for (var key in this.textShapes) {
                textShape = this.textShapes[key];
                textShape.shape.dispose();
                textShape.shape = null;
                textShape.elements = null;
                textShape.verts.length = 0;
                delete this.textShapes[key];
            }
        };
        TextField._textFields = [];
        TextField.assetType = "[asset TextField]";
        TextField._onChangedEvent = new TextfieldEvent(TextfieldEvent.CHANGED);
        return TextField;
    }(DisplayObjectContainer));
    PartitionBase.registerAbstraction(EntityNode, TextField);

    var MovieClip = /** @class */ (function (_super) {
        __extends$3(MovieClip, _super);
        function MovieClip(timeline) {
            if (timeline === void 0) { timeline = null; }
            var _this = _super.call(this) || this;
            _this.preventScript = false;
            _this.symbolID = 0;
            // buttonMode specifies if the mc has any mouse-listeners attached that should trigger showing the hand-cursor
            // if this is set once to true; it will never get set back to false again.
            _this._buttonMode = false;
            // isButton specifies if the mc-timeline is actually considered a button-timeline
            _this._isButton = false;
            _this._time = 0; // the current time inside the animation
            _this._currentFrameIndex = -1; // the current frame
            _this._isPlaying = true; // false if paused or stopped
            _this._isInit = true;
            _this._potentialInstances = {};
            _this._depth_sessionIDs = {};
            _this._sessionID_childs = {};
            _this._sounds = {};
            _this.buttonEnabled = true;
            /**
             *
             */
            _this.loop = true;
            /**
             * the current index of the current active frame
             */
            _this.constructedKeyFrameIndex = -1;
            _this._skipFramesForStream = 0;
            _this.timelineMC = false;
            _this._soundVolume = 1;
            _this._parentSoundVolume = 1;
            _this.doingSwap = false;
            _this._isButton = false;
            _this._buttonMode = false;
            _this._useHandCursor = true;
            _this.cursorType = "pointer";
            //this.debugVisible=true;
            _this._enterFrame = new AssetEvent(AssetEvent.ENTER_FRAME, _this);
            _this.inheritColorTransform = true;
            _this._onMouseOver = function (event) {
                if (_this.buttonEnabled)
                    _this.currentFrameIndex = 1;
                else
                    _this.currentFrameIndex = 0;
            };
            _this._onMouseOut = function (event) {
                _this.currentFrameIndex = 0;
            };
            _this._onMouseDown = function (event) {
                if (_this.buttonEnabled)
                    _this.currentFrameIndex = 2;
                else
                    _this.currentFrameIndex = 0;
            };
            _this._onMouseUp = function (event) {
                _this.currentFrameIndex = _this.currentFrameIndex == 0 ? 0 : 1;
            };
            _this._onDragOver = function (event) {
                if (_this.buttonEnabled)
                    _this.currentFrameIndex = 2;
                else
                    _this.currentFrameIndex = 0;
            };
            _this._onDragOut = function (event) {
                _this.currentFrameIndex = 1;
            };
            _this._timeline = timeline || new Timeline();
            return _this;
        }
        MovieClip.getNewMovieClip = function (timeline) {
            if (timeline === void 0) { timeline = null; }
            if (MovieClip._movieClips.length) {
                var movieClip = MovieClip._movieClips.pop();
                movieClip.timeline = timeline || new Timeline();
                movieClip.graphics = Graphics.getGraphics();
                return movieClip;
            }
            return new MovieClip(timeline);
        };
        MovieClip.clearPool = function () {
            MovieClip._movieClips = [];
        };
        MovieClip.prototype.initSoundStream = function (streamInfo, maxFrameNum) {
            if (!this._soundStreams) {
                this._soundStreams = new MovieClip.movieClipSoundsManagerClass(this);
            }
            this._soundStreams.initSoundStream(streamInfo, maxFrameNum);
        };
        MovieClip.prototype.addSoundStreamBlock = function (frameNum, streamBlock) {
            if (!this._soundStreams) {
                this._soundStreams = new MovieClip.movieClipSoundsManagerClass(this);
            }
            this._soundStreams.addSoundStreamBlock(frameNum, streamBlock);
        };
        MovieClip.prototype._syncSounds = function (frameNum) {
            if (this._soundStreams) {
                return this._soundStreams.syncSounds(frameNum, this._isPlaying, this.parent);
            }
            return 0;
        };
        MovieClip.prototype.startSound = function (id, sound, loopsToPlay) {
            if (this._sounds[id]) {
                this._sounds[id].stop();
            }
            sound.loopsToPlay = loopsToPlay;
            sound.play(0, false);
            this._sounds[id] = sound;
            if (!MovieClip._activeSounds[id])
                MovieClip._activeSounds[id] = [];
            MovieClip._activeSounds[id].push(sound);
        };
        MovieClip.prototype.stopSounds = function (soundID) {
            if (soundID === void 0) { soundID = null; }
            if (soundID) {
                if (this._sounds[soundID]) {
                    this._sounds[soundID].stop();
                    delete this._sounds[soundID];
                }
            }
            else {
                for (var key in this._sounds) {
                    this._sounds[key].stop();
                }
                this._sounds = {};
            }
            var len = this._children.length;
            var child;
            for (var i = 0; i < len; ++i) {
                child = this._children[i];
                if (child.isAsset(MovieClip))
                    child.stopSounds(soundID);
            }
            MovieClip._activeSounds = {};
            if (this._soundStreams) {
                this._soundStreams.syncSounds(0, false, this.parent);
            }
        };
        Object.defineProperty(MovieClip.prototype, "soundVolume", {
            get: function () {
                return this._soundVolume;
            },
            set: function (value) {
                if (this._soundVolume == value) {
                    return;
                }
                this._soundVolume = value;
                for (var key in this._sounds) {
                    this._sounds[key].volume = value;
                }
                var len = this._children.length;
                var child;
                for (var i = 0; i < len; ++i) {
                    child = this._children[i];
                    if (child.isAsset(MovieClip))
                        child.soundVolume = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        MovieClip.prototype.stopSound = function (id) {
            if (this._sounds[id]) {
                this._sounds[id].stop();
                delete this._sounds[id];
            }
            if (MovieClip._activeSounds[id]) {
                for (var i = 0; i < MovieClip._activeSounds[id].length; i++) {
                    MovieClip._activeSounds[id][i].stop();
                }
                delete MovieClip._activeSounds[id];
            }
        };
        MovieClip.prototype.buttonReset = function () {
            if (this._isButton && !this.buttonEnabled) {
                this.currentFrameIndex = 0;
            }
        };
        MovieClip.prototype.getMouseCursor = function () {
            if (this.name == "scene")
                return "initial";
            if (this._useHandCursor) { //} && (this.buttonMode)) {
                return this.cursorType;
            }
            return "initial";
            /*
            var cursorName:string;
            var parent:DisplayObject=this.parent;
            while(parent){
                if(parent.isAsset(MovieClip)){
                    cursorName=(<MovieClip>parent).getMouseCursor();
                    if(cursorName!="initial"){
                        return cursorName;
                    }
                }
                parent=parent.parent;
                if(parent && parent.name=="scene"){
                    return "initial";
                }
            }
            return "initial";
            */
        };
        MovieClip.prototype.registerScriptObject = function (child) {
            this[child.name] = child;
            if (child.isAsset(MovieClip))
                child.removeButtonListeners();
        };
        MovieClip.prototype.unregisterScriptObject = function (child) {
            delete this[child.name];
            if (child.isAsset(MovieClip))
                child.removeButtonListeners();
        };
        MovieClip.prototype.dispose = function () {
            this.disposeValues();
            MovieClip._movieClips.push(this);
        };
        MovieClip.prototype.disposeValues = function () {
            _super.prototype.disposeValues.call(this);
            this._potentialInstances = {};
            this._depth_sessionIDs = {};
            this._sessionID_childs = {};
            this._timeline = null;
        };
        MovieClip.prototype.reset_textclones = function () {
            if (this.timeline) {
                //var len:number = this._potentialInstances.length;
                for (var key in this._potentialInstances) {
                    if (this._potentialInstances[key] != null) {
                        if (this._potentialInstances[key].isAsset(TextField)) {
                            this._potentialInstances[key].text = this.timeline.getPotentialChildPrototype(parseInt(key)).text;
                        }
                        else if (this._potentialInstances[key].isAsset(MovieClip))
                            this._potentialInstances[key].reset_textclones();
                    }
                }
            }
        };
        Object.defineProperty(MovieClip.prototype, "useHandCursor", {
            get: function () {
                return this._useHandCursor;
            },
            set: function (value) {
                this._useHandCursor = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip.prototype, "buttonMode", {
            get: function () {
                return this._buttonMode;
            },
            set: function (value) {
                this._buttonMode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip.prototype, "isButton", {
            get: function () {
                return this._isButton;
            },
            set: function (value) {
                this._isButton = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip.prototype, "isInit", {
            get: function () {
                return this._isInit;
            },
            set: function (value) {
                this._isInit = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip.prototype, "timeline", {
            get: function () {
                return this._timeline;
            },
            set: function (value) {
                if (this._timeline == value)
                    return;
                this._timeline = value;
                this.reset(false);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip.prototype, "numFrames", {
            get: function () {
                return this._timeline.numFrames;
            },
            enumerable: true,
            configurable: true
        });
        MovieClip.prototype.jumpToLabel = function (label, offset) {
            if (offset === void 0) { offset = 0; }
            // the timeline.jumpTolabel will set currentFrameIndex
            this._timeline.jumpToLabel(this, label, offset);
        };
        MovieClip.prototype.reset = function (fireScripts) {
            if (fireScripts === void 0) { fireScripts = true; }
            if (!this.timelineMC)
                return;
            _super.prototype.reset.call(this);
            // time only is relevant for the root mc, as it is the only one that executes the update function
            this._time = 0;
            //this.stopSounds();
            if (this._adapter)
                this.adapter.freeFromScript();
            this.constructedKeyFrameIndex = -1;
            for (var i = this.numChildren - 1; i >= 0; i--)
                this.removeChildAt(i);
            this.graphics.clear();
            if (fireScripts) {
                var numFrames = this._timeline.keyframe_indices.length;
                this._isPlaying = Boolean(numFrames > 1);
                if (numFrames) {
                    this._currentFrameIndex = 0;
                    // contruct the timeline and queue the script.
                    //if(fireScripts){
                    this._timeline.constructNextFrame(this, fireScripts && !this.doingSwap && !this.preventScript, true);
                    //}
                }
                else {
                    this._currentFrameIndex = -1;
                }
            }
            // prevents the playhead to get moved in the advance frame again:	
            this._skipAdvance = true;
            //FrameScriptManager.execute_queue();
        };
        MovieClip.prototype.resetSessionIDs = function () {
            this._depth_sessionIDs = {};
        };
        Object.defineProperty(MovieClip.prototype, "currentFrameIndex", {
            /*
            * Setting the currentFrameIndex will move the playhead for this movieclip to the new position
             */
            get: function () {
                return this._currentFrameIndex;
            },
            set: function (value) {
                var queue_script = true;
                var numFrames = this._timeline.keyframe_indices.length;
                if (!numFrames)
                    return;
                if (value < 0) {
                    value = 0;
                }
                else if (value >= numFrames) {
                    // if value is greater than the available number of
                    // frames, the playhead is moved to the last frame in the timeline.
                    // In this case the frame specified is not considered a keyframe, 
                    // no scripts should be executed in this case
                    value = numFrames - 1;
                    queue_script = false;
                }
                this._skipAdvance = false;
                if (this._currentFrameIndex == value)
                    return;
                this._currentFrameIndex = value;
                //console.log("_currentFrameIndex ", this.name, this._currentFrameIndex);
                //changing current frame will ignore advance command for that
                //update's advanceFrame function, unless advanceFrame has
                //already been executed
                //this._skipAdvance = MovieClip._skipAdvance;
                this._timeline.gotoFrame(this, value, queue_script, false, true);
            },
            enumerable: true,
            configurable: true
        });
        MovieClip.prototype.addButtonListeners = function () {
            this._isButton = true;
            this.stop();
            this.addEventListener(MouseEvent.MOUSE_OVER, this._onMouseOver);
            this.addEventListener(MouseEvent.MOUSE_OUT, this._onMouseOut);
            this.addEventListener(MouseEvent.MOUSE_DOWN, this._onMouseDown);
            this.addEventListener(MouseEvent.MOUSE_UP, this._onMouseUp);
            this.addEventListener(MouseEvent.DRAG_OVER, this._onDragOver);
            this.addEventListener(MouseEvent.DRAG_OUT, this._onDragOut);
            this.mouseChildren = false;
        };
        MovieClip.prototype.removeButtonListeners = function () {
            this.removeEventListener(MouseEvent.MOUSE_OVER, this._onMouseOver);
            this.removeEventListener(MouseEvent.MOUSE_OUT, this._onMouseOut);
            this.removeEventListener(MouseEvent.MOUSE_DOWN, this._onMouseDown);
            this.removeEventListener(MouseEvent.MOUSE_UP, this._onMouseUp);
            this.removeEventListener(MouseEvent.DRAG_OVER, this._onDragOver);
            this.removeEventListener(MouseEvent.DRAG_OUT, this._onDragOut);
        };
        MovieClip.prototype.getChildAtSessionID = function (sessionID) {
            return this._sessionID_childs[sessionID];
        };
        MovieClip.prototype.getSessionIDDepths = function () {
            return this._depth_sessionIDs;
        };
        MovieClip.prototype.swapChildrenAt = function (index1, index2) {
            var depth = this._children[index2]._depthID;
            var child = this._children[index1];
            this.doingSwap = true;
            this.addChildAtDepth(this._children[index2], this._children[index1]._depthID);
            this.addChildAtDepth(child, depth);
            this._depth_sessionIDs[depth] = child._sessionID;
            this._depth_sessionIDs[this._children[index1]._depthID] = this._children[index2]._sessionID;
            this.doingSwap = false;
        };
        MovieClip.prototype.swapDepths = function (child, depth) {
            var existingChild = this.getChildAtDepth(depth);
            var currentDepth = child._depthID;
            if (currentDepth == depth) {
                return;
            }
            delete this._depth_sessionIDs[currentDepth];
            this._depth_sessionIDs[depth] = child._sessionID;
            this.doingSwap = true;
            _super.prototype.removeChildAtDepth.call(this, currentDepth);
            if (existingChild) {
                _super.prototype.removeChildAtDepth.call(this, depth);
                _super.prototype.addChildAtDepth.call(this, existingChild, currentDepth);
            }
            _super.prototype.addChildAtDepth.call(this, child, depth);
            this.doingSwap = false;
        };
        /*
            public addChildAtDepth(child: DisplayObject, depth: number, replace: boolean = true): DisplayObject {
                
                return child;
            }
        */
        MovieClip.prototype._addTimelineChildAt = function (child, depth, sessionID) {
            this._depth_sessionIDs[depth] = child._sessionID = sessionID;
            if (child.adapter != child && child.adapter.deleteOwnProperties) {
                child.adapter.deleteOwnProperties();
            }
            var returnObj = this.addChildAtDepth(child, depth);
            this._sessionID_childs[sessionID] = child;
            if (child.adapter && child.adapter.dispatchStaticEvent) {
                //(<DisplayObject>oneChild.adapter).dispatchEventRecursive(new Event(Event.REMOVED_FROM_STAGE));
                child.adapter.dispatchStaticEvent("added");
                child.adapter.dispatchStaticEvent("addedToStage");
                //(<any>child.adapter).dispatchStaticEvent("frameConstructed");
            }
            return returnObj;
        };
        MovieClip.prototype.removeChildAtInternal = function (index) {
            var child = this._children[index];
            if (!this.doingSwap) {
                if (child._adapter)
                    child.adapter.freeFromScript();
                this.adapter.unregisterScriptObject(child);
            }
            //check to make sure _depth_sessionIDs wasn't modified with a new child
            //if (this._depth_sessionIDs[child._depthID] == child._sessionID)
            //delete this._depth_sessionIDs[child._depthID];
            delete this._sessionID_childs[child._sessionID];
            if (!this.doingSwap) {
                child._sessionID = -1;
            }
            else {
                child._sessionID = -2;
            }
            return _super.prototype.removeChildAtInternal.call(this, index);
        };
        Object.defineProperty(MovieClip.prototype, "assetType", {
            get: function () {
                return MovieClip.assetType;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Starts playback of animation from current position
         */
        MovieClip.prototype.play = function () {
            if (this._timeline.keyframe_indices.length > 1)
                this._isPlaying = true;
        };
        /**
         * should be called right before the call to away3d-render.
         */
        MovieClip.prototype.update = function (events, dt) {
            // Not used for AVM1 !!!
            // in AVM1 this in done in the onEnter of AVMAwayStage, because we have multiple roots
            if (events === void 0) { events = null; }
            if (dt === void 0) { dt = 0; }
            //if events is null, this is as2, if it is not null, this is as3web
            MovieClip._skipAdvance = true;
            //if(events!=null){
            //	(<any>this.adapter).dispatchEvent(events[0]);
            //}
            //if(this._timeline && this._timeline.numFrames>0)
            this.advanceFrame(events);
            MovieClip._skipAdvance = false;
            /*
            // after we advanced the scenegraph, we might have some script that needs executing
            FrameScriptManager.execute_queue();

            //this.dispatchEvent(this._enterFrame);

            // after we executed the onEnter, we might have some script that needs executing
            FrameScriptManager.execute_queue();

            // now we execute any intervals queued
            FrameScriptManager.execute_intervals(dt);

            // finally, we execute any scripts that were added from intervals
            FrameScriptManager.execute_queue();

            //execute any disposes as a result of framescripts
            FrameScriptManager.execute_dispose();

            if (events != null) {
                (<any>this.adapter).dispatchEvent(events[1]);
            }*/
        };
        MovieClip.prototype.getPotentialChildInstance = function (id, instanceID, forceClone) {
            if (forceClone === void 0) { forceClone = false; }
            if (!this._potentialInstances[id] || this._potentialInstances[id]._sessionID == -2 ||
                (this._potentialInstances[id].cloneForEveryInstance && forceClone))
                this._potentialInstances[id] = this._timeline.getPotentialChildInstance(id, instanceID);
            this._timeline.initChildInstance(this._potentialInstances[id], instanceID);
            return this._potentialInstances[id];
        };
        /**
         * Stop playback of animation and hold current position
         */
        MovieClip.prototype.stop = function () {
            //this.stopSounds();
            this._isPlaying = false;
        };
        MovieClip.prototype.clone = function () {
            var newInstance = MovieClip.getNewMovieClip(this._timeline);
            this.copyTo(newInstance);
            return newInstance;
        };
        MovieClip.prototype.copyTo = function (movieClip) {
            _super.prototype.copyTo.call(this, movieClip);
            movieClip.timelineMC = this.timelineMC;
            movieClip.loop = this.loop;
            movieClip._soundStreams = this._soundStreams;
            movieClip.symbolID = this.symbolID;
        };
        /*
        public getScriptsForFrameConstruct(): void {

            if (this._skipAdvance) {
                this._timeline.add_script_for_postcontruct(this, this._currentFrameIndex, true);
            }
            var len: number = this._children.length;
            var child: DisplayObject;
            for (var i: number = 0; i < len; ++i) {
                child = this._children[i];

                if (child.isAsset(MovieClip))
                    (<MovieClip>child).getScriptsForFrameConstruct();
            }
            this._skipAdvance = false;
        }
        */
        MovieClip.prototype.advanceFrameInternal = function (events) {
            // if this._skipadvance is true, the mc has already been moving on its timeline this frame
            // this happens for objects that have been newly added to parent
            // they still need to queue their scripts
            if (events === void 0) { events = null; }
            //if(this._timeline && this._timeline.numFrames>0)
            if (this._timeline && this._timeline.numFrames > 0 && this._isPlaying && !this._skipAdvance) {
                if (this._currentFrameIndex == this._timeline.keyframe_indices.length - 1) {
                    if (this.loop) {
                        // end of loop - jump to first frame.
                        if (this._currentFrameIndex == 0) {
                            // do nothing if we are already on frame 1
                        }
                        else {
                            this._currentFrameIndex = 0;
                            this._timeline.gotoFrame(this, 0, true, true, true);
                        }
                    }
                    else //end of timeline, stop playing
                        this._isPlaying = false;
                }
                else { // not end - construct next frame
                    this._currentFrameIndex++;
                    this._timeline.constructNextFrame(this);
                }
                //console.log("advancedFrame ", this.name, this._currentFrameIndex);
            }
            // than come the children from bottom up:
            var child;
            for (var i = 0; i < this._children.length; i++) {
                child = this._children[i];
                if (child && child.isAsset(MovieClip)) {
                    child.advanceFrame(events);
                }
                if (child && child.isAsset(Sprite) && child.numChildren && child.adapter.advanceFrame) {
                    child.adapter.advanceFrame(events);
                }
            }
            if (events)
                this.adapter.dispatchEvent(events[0]);
            this._skipAdvance = false;
        };
        MovieClip.prototype.advanceFrame = function (events) {
            if (events === void 0) { events = null; }
            if (this._skipFramesForStream == 0) {
                this.advanceFrameInternal(events);
            }
            /*if(this._skipFramesForStream<0){
                console.log("wait for audio to catch up");
            }*/
            this._skipFramesForStream = this._syncSounds(this._currentFrameIndex);
            while (this._skipFramesForStream > 0) {
                //console.log("skip frame for keeping audio stream synced");
                FrameScriptManager.execute_queue();
                this.advanceFrameInternal(events);
                this._skipFramesForStream = this._syncSounds(this._currentFrameIndex);
            }
        };
        // DEBUG CODE:
        MovieClip.prototype.logHierarchy = function (depth) {
            if (depth === void 0) { depth = 0; }
            this.printHierarchyName(depth, this);
            var len = this._children.length;
            var child;
            for (var i = 0; i < len; i++) {
                child = this._children[i];
                if (child.isAsset(MovieClip))
                    child.logHierarchy(depth + 1);
                else
                    this.printHierarchyName(depth + 1, child);
            }
        };
        MovieClip.prototype.printHierarchyName = function (depth, target) {
            var str = "";
            for (var i = 0; i < depth; ++i)
                str += "--";
            str += " " + target.name + " = " + target.id;
            console.log(str);
        };
        MovieClip.prototype.clear = function () {
            //clear out potential instances
            for (var key in this._potentialInstances) {
                var instance = this._potentialInstances[key];
                //only dispose instances that are not used in script ie. do not have an instance name
                if (instance && !instance.name) {
                    if (!instance.isAsset(Sprite)) {
                        FrameScriptManager.add_child_to_dispose(instance);
                    }
                    delete this._potentialInstances[key];
                }
            }
            _super.prototype.clear.call(this);
        };
        //todo: this 3 are no longer used (?)
        MovieClip.avm1ScriptQueue = [];
        MovieClip.avm1ScriptQueueScripts = [];
        MovieClip.avm1LoadedActions = [];
        MovieClip._movieClips = new Array();
        MovieClip._activeSounds = {};
        MovieClip.assetType = "[asset MovieClip]";
        MovieClip.movieClipSoundsManagerClass = null;
        return MovieClip;
    }(Sprite));
    PartitionBase.registerAbstraction(EntityNode, MovieClip);

    var FrameScriptManager = /** @class */ (function () {
        function FrameScriptManager() {
        }
        FrameScriptManager.setInterval = function (fun, time) {
            this._intervalID++;
            // make sure we have at least 4ms intervals
            if (time < 4) {
                time = 4;
            }
            this._active_intervals[this._intervalID] = { "f": fun, "t": time, "dt": 0, "isTimeout": false };
            return this._intervalID;
        };
        FrameScriptManager.setTimeOut = function (fun, time) {
            this._intervalID++;
            // make sure we have at least 4ms intervals
            if (time < 4) {
                time = 4;
            }
            this._active_intervals[this._intervalID] = { "f": fun, "t": time, "dt": 0, "isTimeout": true };
            return this._intervalID;
        };
        FrameScriptManager.clearInterval = function (id) {
            delete this._active_intervals[id];
        };
        FrameScriptManager.clearTimeout = function (id) {
            delete this._active_intervals[id];
        };
        FrameScriptManager.execute_intervals = function (dt) {
            if (dt === void 0) { dt = 0; }
            var interval;
            for (var key in this._active_intervals) {
                interval = this._active_intervals[key];
                interval.dt += dt;
                // keep executing the setInterval for as many times as the dt allows
                // a setInterval can delete itself, so we need to check if it still exists
                while (this._active_intervals[key] && interval.dt >= interval.t) {
                    interval.dt -= interval.t;
                    interval.f();
                    if (interval.isTimeout) {
                        delete this._active_intervals[key];
                    }
                }
            }
        };
        FrameScriptManager.add_child_to_dispose = function (child) {
            this._queued_dispose.push(child);
        };
        FrameScriptManager.add_script_to_queue = function (mc, script) {
            // whenever we queue scripts of new objects, we first inject the lists of pass2
            var i = this._queued_mcs_pass2.length;
            while (i > 0) {
                i--;
                this._queued_mcs.push(this._queued_mcs_pass2[i]);
                this._queued_scripts.push(this._queued_scripts_pass2[i]);
            }
            this._queued_mcs_pass2.length = 0;
            this._queued_scripts_pass2.length = 0;
            this._queued_mcs.push(mc);
            this._queued_scripts.push(script);
        };
        FrameScriptManager.add_loaded_action_to_queue = function (mc) {
            // whenever we queue scripts of new objects, we first inject the lists of pass2
            var i = this._queued_mcs_pass2.length;
            while (i > 0) {
                i--;
                this._queued_mcs.push(this._queued_mcs_pass2[i]);
                this._queued_scripts.push(this._queued_scripts_pass2[i]);
            }
            this._queued_mcs_pass2.length = 0;
            this._queued_scripts_pass2.length = 0;
            if (this._queued_mcs[this._queued_mcs.length - 1] == mc) {
                return;
            }
            this._queued_mcs.push(mc);
            this._queued_scripts.push(null);
        };
        FrameScriptManager.add_script_to_queue_pass2 = function (mc, script) {
            this._queued_mcs_pass2.push(mc);
            this._queued_scripts_pass2.push(script);
        };
        FrameScriptManager.queue_as3_constructor = function (mc) {
            this._as3_constructor_queue.push(mc);
        };
        FrameScriptManager.execute_as3_constructors = function () {
            if (this._as3_constructor_queue.length == 0)
                return;
            while (this._as3_constructor_queue.length > 0) {
                var queue_tmp = this._as3_constructor_queue.concat();
                this._as3_constructor_queue.length = 0;
                var mc;
                var i = 0;
                var len = queue_tmp.length;
                /*
                as3 constructors for objects created via as3-code execute immediatly, so they are never queued
                as3 constructors added by timeline get executed in the order they are addChilded in awayjs
                (childs first, than parents, so in the first frame, the main-scene should come last)
                */
                /*
                // print list of queued as3_constructors
                for(i=0; i<len; i++){
                    console.log("i", i);
                    mc=this._as3_constructor_queue[i];
                    if(mc._implicitPartition && mc._implicitPartition.root) {
                        if ((<IDisplayObjectAdapter>mc.adapter).executeConstructor) {
                            console.log("- run constructor", mc.parent.name, mc.parent.id, mc.name, mc.id, mc);
                        }
                    }
                }*/
                for (i = 0; i < len; i++) {
                    // during the loop we might add more scripts to the queue
                    mc = queue_tmp[i];
                    if (mc._implicitPartition && mc._implicitPartition.root) {
                        if (mc.adapter.executeConstructor) {
                            var myFunc = mc.adapter.executeConstructor;
                            mc.adapter.executeConstructor = null;
                            myFunc();
                            // in avm2, framescripts get added to timeline in the constructor of the mc
                            // so when the mc was added to parent, no framescripts exists and therefore none are queued now
                            // we need to execute the script manually. 
                            if (mc.isAsset(MovieClip)) {
                                var script = mc.timeline.get_script_for_frame(mc, mc.currentFrameIndex);
                                if (script) {
                                    FrameScriptManager.add_script_to_queue(mc, script);
                                }
                            }
                        }
                    }
                }
                queue_tmp.length = 0;
            }
        };
        FrameScriptManager.execute_queue = function () {
            if (this._queued_mcs.length == 0 && this._queued_mcs_pass2.length == 0)
                return;
            while (this._queued_mcs.length > 0 || this._queued_mcs_pass2.length > 0) {
                var queues_tmp = this._queued_mcs.concat();
                var queues_scripts_tmp = this._queued_scripts.concat();
                this._queued_mcs.length = 0;
                this._queued_scripts.length = 0;
                var i = this._queued_mcs_pass2.length;
                while (i > 0) {
                    i--;
                    queues_tmp.push(this._queued_mcs_pass2[i]);
                    queues_scripts_tmp.push(this._queued_scripts_pass2[i]);
                }
                this._queued_mcs_pass2.length = 0;
                this._queued_scripts_pass2.length = 0;
                //console.log("execute queue",this._queued_scripts);
                var mc;
                for (i = 0; i < queues_tmp.length; i++) {
                    // during the loop we might add more scripts to the queue
                    mc = queues_tmp[i];
                    if (mc._implicitPartition && mc._implicitPartition.root) {
                        // first we execute any pending loadedAction for this MC
                        if (mc.onLoaded) {
                            //atm this is only used for avm1, to execute queued "onloaded" actions. 
                            var myFunc = mc.onLoaded;
                            mc.onLoaded = null;
                            myFunc();
                        }
                        if (mc.adapter.executeConstructor) {
                            var myFunc = mc.adapter.executeConstructor;
                            mc.adapter.executeConstructor = null;
                            myFunc();
                        }
                        if (queues_scripts_tmp[i] != null) {
                            //console.log("execute script", mc.name, queues_scripts_tmp[i]);
                            // before we run any framescript, we must make sure that all timeline objects have run their constructors
                            this.execute_as3_constructors();
                            if (mc && mc.adapter && mc.adapter.executeScript)
                                mc.adapter.executeScript(queues_scripts_tmp[i]);
                        }
                    }
                }
            }
        };
        FrameScriptManager.execute_dispose = function () {
            var len = this._queued_dispose.length;
            for (var i = 0; i < len; i++)
                this._queued_dispose[i].dispose();
            this._queued_dispose.length = 0;
        };
        // FrameScript debugging:
        // the first line of a FrameScript should be a comment that represents the functions unique name
        // the exporter creates a js file, containing a object that has the framescripts functions set as properties according to the unique names
        // this object can be set as "frameScriptDebug" in order to enable debug mode
        FrameScriptManager.frameScriptDebug = undefined;
        //queue of objects for disposal
        FrameScriptManager._queued_dispose = [];
        // queues pass1 of scripts.
        FrameScriptManager._queued_mcs = [];
        FrameScriptManager._queued_scripts = [];
        // queues pass2 of scripts. this will be inserted in reversed order into pass1 queue right before something should be added to pass1
        FrameScriptManager._queued_mcs_pass2 = [];
        FrameScriptManager._queued_scripts_pass2 = [];
        FrameScriptManager._active_intervals = new Object(); // maps id to function
        FrameScriptManager._as3_constructor_queue = [];
        FrameScriptManager._intervalID = 0;
        return FrameScriptManager;
    }());

    var Timeline = /** @class */ (function () {
        function Timeline() {
            this._functions = [];
            this._update_indices = [];
            this._update_frames = [];
            this.isButton = false;
            this.numKeyFrames = 0;
            this.keyframe_indices = [];
            this.avm1Exports = {};
            this.avm1InitActions = {};
            this.avm1ButtonActions = [];
            this.graphicsPool = {};
            this.audioPool = {};
            this.potentialPrototypesInitEventsMap = {};
            this._potentialPrototypes = [];
            this._labels = {};
            this._framescripts = {};
            this._framescripts_translated = {};
            this.keyframe_to_frameidx = {};
            //cache functions
            this._functions[1] = this.update_mtx_all;
            this._functions[2] = this.update_colortransform;
            this._functions[3] = this.update_masks;
            this._functions[4] = this.update_name;
            this._functions[5] = this.update_button_name;
            this._functions[6] = this.update_visibility;
            this._functions[7] = this.update_blendmode;
            this._functions[8] = this.update_rendermode;
            this._functions[11] = this.update_mtx_scale_rot;
            this._functions[12] = this.update_mtx_pos;
            this._functions[200] = this.enable_maskmode;
            this._functions[201] = this.remove_masks;
            this._functions[202] = this.swap_graphics;
            this._functions[203] = this.set_ratio;
            this._functions[204] = this.start_audio;
        }
        Timeline.prototype.resetScripts = function () {
            this._framescripts = {};
            this._framescripts_translated = {};
        };
        Timeline.prototype.init = function () {
            if ((this.frame_command_indices == null) || (this.frame_recipe == null) || (this.keyframe_durations == null)) {
                return;
            }
            this.keyframe_firstframes = [];
            this.keyframe_constructframes = [];
            this.keyframe_indices = [];
            var frame_cnt = 0;
            var ic = 0;
            var ic2 = 0;
            var keyframe_cnt = 0;
            var last_construct_frame = 0;
            this.keyframe_to_frameidx = {};
            this.keyframe_to_frameidx[0] = 0;
            var duration_all = 0;
            for (ic = 0; ic < this.numKeyFrames; ic++) {
                this.keyframe_to_frameidx[ic] = duration_all;
                var duration = this.keyframe_durations[(ic)];
                duration_all += duration;
                if (this.frame_recipe[ic] & 1)
                    last_construct_frame = keyframe_cnt;
                this.keyframe_firstframes[keyframe_cnt] = frame_cnt;
                this.keyframe_constructframes[keyframe_cnt++] = last_construct_frame;
                for (ic2 = 0; ic2 < duration; ic2++)
                    this.keyframe_indices[frame_cnt++] = ic;
                //frame_cnt+=this.keyframe_durations[(ic)];
            }
        };
        Timeline.prototype.get_framescript = function (frame_index) {
            if (this._framescripts[frame_index] == null)
                return "";
            if (typeof this._framescripts[frame_index] == "string")
                return this._framescripts[frame_index];
            else {
                throw new Error("Framescript is already translated to Function!!!");
            }
        };
        Timeline.prototype.add_framescript = function (script, frame_idx) {
            /*
            // disable for now. but keep in mind to find a nicer way to allow debuggibgn for framescripts
            if(FrameScriptManager.frameScriptDebug){
                // todo: this is only for as2_as_js scripts
                // if we are in debug mode, we try to extract the function name from the first line of framescript code,
                // and check if this function is available on the object that is set as frameScriptDebug
                // try to get the functions name (it should be the first line as comment)
                var functionname = value.split(/[\r\n]+/g)[0].split("//")[1];
                if(FrameScriptManager.frameScriptDebug[functionname]){
                    this._framescripts[frame_idx] = FrameScriptManager.frameScriptDebug[functionname];
                    this._framescripts_translated[frame_idx]=true;
                    return;
                }
                else{
                    throw new Error("Framescript could not be found on FrameScriptManager.frameScriptDebug.\n the Object set as FrameScriptmanager.frameScriptDebug should contain a function with the name '"+functionname+"' !!!");
                }
            }*/
            if (!this._framescripts[frame_idx]) {
                this._framescripts[frame_idx] = [];
            }
            this._framescripts[frame_idx].push(script);
        };
        Timeline.prototype.regexIndexOf = function (str, regex, startpos) {
            var indexOf = str.substring(startpos || 0).search(regex);
            return (indexOf >= 0) ? (indexOf + (startpos || 0)) : indexOf;
        };
        Timeline.prototype.get_deferred_script = function (target_mc, frame_idx) {
            /*	if(this.avm1framescripts[frame_idx]!=null){
                    //(<IMovieClipAdapter>target_mc.adapter).callFrameScript(this.avm1framescripts_translated[target_mc.currentFrameIndex]);
                    MovieClip.avm1ScriptQueue.push(target_mc);
                    MovieClip.avm1ScriptQueueScripts.push(this.avm1framescripts_translated[frame_idx]);
                    
                }*/
        };
        Timeline.prototype.add_script_for_postcontruct = function (target_mc, frame_idx, scriptPass1) {
            if (scriptPass1 === void 0) { scriptPass1 = false; }
            if (this._framescripts[frame_idx] != null) {
                if (this._framescripts_translated[frame_idx] == null) {
                    this._framescripts[frame_idx] = target_mc.adapter.addScript(this._framescripts[frame_idx], frame_idx);
                    this._framescripts_translated[frame_idx] = true;
                }
                //console.log("add framescript", target_mc, target_mc.name, keyframe_idx, scriptPass1 );
                if (scriptPass1)
                    FrameScriptManager.add_script_to_queue(target_mc, this._framescripts[frame_idx]);
                else
                    FrameScriptManager.add_script_to_queue_pass2(target_mc, this._framescripts[frame_idx]);
            }
        };
        Timeline.prototype.get_script_for_frame = function (target_mc, frame_idx) {
            if (frame_idx >= 0 && this._framescripts[frame_idx] != null) {
                if (this._framescripts_translated[frame_idx] == null) {
                    this._framescripts[frame_idx] = target_mc.adapter.addScript(this._framescripts[frame_idx], frame_idx);
                    this._framescripts_translated[frame_idx] = true;
                }
                return this._framescripts[frame_idx];
            }
        };
        Object.defineProperty(Timeline.prototype, "numFrames", {
            get: function () {
                return this.keyframe_indices.length;
            },
            enumerable: true,
            configurable: true
        });
        Timeline.prototype.getPotentialChildPrototype = function (id) {
            return this._potentialPrototypes[id];
        };
        Timeline.prototype.getKeyframeIndexForFrameIndex = function (frame_index) {
            return this.keyframe_indices[frame_index];
        };
        Timeline.prototype.getPotentialChildInstance = function (id, instanceID) {
            if (instanceID === void 0) { instanceID = null; }
            var asset = this._potentialPrototypes[id];
            if (asset.isAsset(Sprite)) {
                //In the case of Sprites, do not duplicate graphics
                //(<Graphics>asset).endFill();
                var sprite = Sprite.getNewSprite(asset.graphics);
                sprite.mouseEnabled = false;
                return sprite;
            }
            if (asset.isAsset(MorphSprite)) {
                //In the case of Sprites, do not duplicate graphics
                //(<Graphics>asset).endFill();
                var morphSprite = MorphSprite.getNewMorphSprite(asset.graphics);
                morphSprite.mouseEnabled = false;
                return morphSprite;
            }
            if (instanceID) {
                var placeObjectTag = this.potentialPrototypesInitEventsMap[instanceID];
                if (placeObjectTag && (placeObjectTag.name)) {
                    Timeline.currentInstanceName = placeObjectTag.name;
                }
                if (placeObjectTag && (placeObjectTag.matrix)) {
                    Timeline.currentInstanceMatrix = placeObjectTag.matrix;
                }
            }
            return asset.adapter.clone(false).adaptee;
        };
        Timeline.prototype.initChildInstance = function (child, id) {
            var placeObjectTag = this.potentialPrototypesInitEventsMap[id];
            child.adapter.placeObjectTag = null;
            child.adapter.initEvents = null;
            child.instanceID = id;
            // todo: refactor so the addedOnFrame can be set in nicer way
            child.addedOnFrame = parseInt(id.split("#")[1]);
            if (placeObjectTag && (placeObjectTag.variableName || (placeObjectTag.events && placeObjectTag.events.length > 0))) {
                child.adapter.placeObjectTag = placeObjectTag;
                child.adapter.initEvents = this.potentialPrototypesInitEventsMap[id];
            }
        };
        Timeline.prototype.registerPotentialChild = function (prototype) {
            var id = this._potentialPrototypes.length;
            this._potentialPrototypes[id] = prototype;
            return id;
        };
        Timeline.prototype.extractHitArea = function (target_mc) {
            target_mc.reset(false);
            this.gotoFrame(target_mc, this.numFrames - 1, false);
            var i = target_mc.numChildren;
            var hitArea = new DisplayObjectContainer();
            var child;
            var originalChild;
            while (i > 0) {
                i--;
                originalChild = target_mc.getChildAt(i);
                child = originalChild.clone();
                //child.reset();
                child.x = originalChild.x;
                child.scaleX = originalChild.scaleX;
                child.y = originalChild.y;
                child.scaleY = originalChild.scaleY;
                child.rotationZ = originalChild.rotationZ;
                hitArea.addChild(child);
            }
            target_mc.pickObject = hitArea;
            target_mc.reset(false);
            return hitArea;
        };
        Timeline.prototype.getCurrentFrameLabel = function (target_mc) {
            var label = null;
            for (var key in this._labels) {
                if (this._labels[key] == target_mc.constructedKeyFrameIndex) {
                    return label;
                }
            }
            return label;
        };
        Timeline.prototype.getCurrentLabel = function (target_mc) {
            var label = null;
            var lastLabelframeIdx = -1;
            for (var key in this._labels) {
                if (this._labels[key] > lastLabelframeIdx && this._labels[key] <= target_mc.constructedKeyFrameIndex) {
                    lastLabelframeIdx = this._labels[key];
                    label = key;
                }
            }
            return label;
        };
        Timeline.prototype.jumpToLabel = function (target_mc, label, offset) {
            if (offset === void 0) { offset = 0; }
            var key_frame_index = this._labels[label];
            if (key_frame_index >= 0)
                target_mc.currentFrameIndex = this.keyframe_firstframes[key_frame_index] + offset;
        };
        Timeline.prototype.getScriptForLabel = function (target_mc, label) {
            var key_frame_index = this._labels[label.toLowerCase()];
            if (key_frame_index < 0)
                return null;
            var frameIdx = this.keyframe_firstframes[key_frame_index];
            if (frameIdx >= 0 && this._framescripts[frameIdx] != null) {
                if (this._framescripts_translated[frameIdx] == null) {
                    this._framescripts[frameIdx] = target_mc.adapter.addScript(this._framescripts[frameIdx], frameIdx);
                    this._framescripts_translated[frameIdx] = true;
                }
                return this._framescripts[frameIdx];
            }
        };
        Timeline.prototype.gotoFrame = function (target_mc, frame_idx, queue_script, queue_pass2, forceReconstruct) {
            if (queue_script === void 0) { queue_script = true; }
            if (queue_pass2 === void 0) { queue_pass2 = false; }
            if (forceReconstruct === void 0) { forceReconstruct = false; }
            var current_keyframe_idx = target_mc.constructedKeyFrameIndex;
            var target_keyframe_idx = this.keyframe_indices[frame_idx];
            var jumpBackToSameKeyFrame = false;
            if (current_keyframe_idx == target_keyframe_idx) {
                if (!forceReconstruct)
                    return;
                //  if the mc is already on same keyframe, it must be on different frame,
                //  so it must be jumping back to the first frame of a keyframe
                jumpBackToSameKeyFrame = true;
            }
            var i;
            var child;
            if (current_keyframe_idx + 1 == target_keyframe_idx) { // target_keyframe_idx is the next keyframe. we can just use constructnext for this
                this.constructNextFrame(target_mc, queue_script, true);
                return;
            }
            var break_frame_idx = this.keyframe_constructframes[target_keyframe_idx];
            //  we now have 3 index to keyframes: current_keyframe_idx / target_keyframe_idx / break_frame_idx
            var jump_forward = (target_keyframe_idx > current_keyframe_idx);
            if (jumpBackToSameKeyFrame) {
                jump_forward = false;
            }
            var jump_gap = (break_frame_idx > current_keyframe_idx);
            // in case we jump forward, but not jump a gap, we start at current_keyframe_idx + 1
            // in case we jump back or we jump a gap, we want to start constructing at BreakFrame
            var start_construct_idx = (jump_forward && !jump_gap) ? current_keyframe_idx + 1 : break_frame_idx;
            if (jump_gap) { // if we jump a gap forward, we just can remove all childs from mc. all script blockage will be gone
                for (i = target_mc.numChildren - 1; i >= 0; i--) {
                    if (target_mc._children[i]._depthID < 0)
                        target_mc.removeChildAt(i);
                }
            }
            if (target_mc.adapter && target_mc.adapter["$Bg__setPropDict"] && target_mc.adapter.clearPropsDic) {
                target_mc.adapter.clearPropsDic();
            }
            //if we jump back, we want to reset all objects (but not the timelines of the mcs)
            // in other cases, we want to collect the current objects to compare state of targetframe with state of currentframe
            var depth_sessionIDs = {};
            var new_depth_sessionIDs = {};
            if (jump_forward) {
                var depth_sessionIDs2 = {};
                depth_sessionIDs = target_mc.getSessionIDDepths();
                for (var key in depth_sessionIDs) {
                    depth_sessionIDs2[key] = { id: depth_sessionIDs[key], instanceID: "oldID" };
                }
                depth_sessionIDs = depth_sessionIDs2;
            }
            //pass1: only apply add/remove commands into depth_sessionIDs.
            this.pass1(target_mc, start_construct_idx, target_keyframe_idx, depth_sessionIDs, new_depth_sessionIDs, queue_pass2);
            // check what childs are alive on both frames.
            // child-instances that are not alive anymore get removed and unregistered
            // child-instances that are alive on both frames have their properties reset if we are jumping back
            // child-instances that are alive on both frames but have different instance-id get fully reset
            for (i = target_mc.numChildren - 1; i >= 0; i--) {
                child = target_mc._children[i];
                if (child._depthID < 0) {
                    if (!depth_sessionIDs[child._depthID]) {
                        target_mc.removeChildAt(i);
                    }
                    else if (depth_sessionIDs[child._depthID].instanceID == "oldID") {
                        // child-instance was not changed by timeline (should never happen when jumping back)
                    }
                    else if (depth_sessionIDs[child._depthID].instanceID == child.instanceID) {
                        // child-instance was not changed by timeline
                        // if we jump back we still want to reset the childs-properties
                        if (!jump_forward) {
                            if (child._adapter) {
                                if (!child.adapter.isColorTransformByScript()) {
                                    child.transform.clearColorTransform();
                                }
                                if (!child.adapter.isBlockedByScript() && !child.noTimelineUpdate) {
                                    child.transform.clearMatrix3D();
                                    //this.name="";
                                    child.masks = null;
                                    child.maskMode = false;
                                }
                                if (!child.adapter.isVisibilityByScript()) {
                                    child.visible = true;
                                }
                            }
                            else {
                                child.transform.clearColorTransform();
                                child.transform.clearMatrix3D();
                                child.visible = true;
                                child.masks = null;
                                child.maskMode = false;
                            }
                        }
                    }
                    else if (depth_sessionIDs[child._depthID].instanceID != child.instanceID) {
                        //  child-instance was changed by timeline.
                        //  force a full reset by re-adding it to timeline
                        target_mc.removeChildAt(i);
                    }
                }
            }
            // add the children that have been placed on frames that we jumped but are still alive
            // for this childs, the initAdapter should execute before any framescripts
            // for as3, the adapter should to be recloned, so that it can do a clean constructor 
            // framescripts for this child should not be executed (// todo: double check)
            target_mc.preventScript = true;
            for (var key in depth_sessionIDs) {
                if (!new_depth_sessionIDs[key] && depth_sessionIDs[key].instanceID != "oldID") {
                    child = target_mc.getPotentialChildInstance(depth_sessionIDs[key].id, depth_sessionIDs[key].instanceID, false);
                    if (child._sessionID == -1) {
                        child = target_mc.getPotentialChildInstance(depth_sessionIDs[key].id, depth_sessionIDs[key].instanceID, true);
                        target_mc._addTimelineChildAt(child, Number(key), depth_sessionIDs[key].id);
                    }
                }
            }
            target_mc.preventScript = false;
            // if there is a framescript on this frame, we queue it now, so it sits after the initAdapter of the children
            if (queue_script && this._framescripts[frame_idx])
                this.add_script_for_postcontruct(target_mc, frame_idx, !queue_pass2);
            // add the children that have been placed on the target frame
            // only reclone if it did not exists on the mc already
            // for this childs, we queue the framescripts
            for (var key in depth_sessionIDs) {
                if (new_depth_sessionIDs[key] && depth_sessionIDs[key].instanceID != "oldID") {
                    child = target_mc.getPotentialChildInstance(depth_sessionIDs[key].id, depth_sessionIDs[key].instanceID, false);
                    if (child._sessionID == -1) {
                        child = target_mc.getPotentialChildInstance(depth_sessionIDs[key].id, depth_sessionIDs[key].instanceID, true);
                        target_mc._addTimelineChildAt(child, Number(key), depth_sessionIDs[key].id);
                    }
                }
            }
            //pass2: apply update commands for objects on stage (only if they are not blocked by script)
            this.pass2(target_mc);
            target_mc.constructedKeyFrameIndex = target_keyframe_idx;
        };
        Timeline.prototype.pass1 = function (target_mc, start_construct_idx, target_keyframe_idx, depth_sessionIDs, new_depth_sessionIDs, queue_pass2) {
            var i;
            var k;
            this._update_indices.length = 0; // store a list of updatecommand_indices, so we dont have to read frame_recipe again
            this._update_frames.length = 0;
            var update_cnt = 0;
            var start_index;
            var end_index;
            for (k = start_construct_idx; k <= target_keyframe_idx; k++) {
                var frame_command_idx = this.frame_command_indices[k];
                var frame_recipe = this.frame_recipe[k];
                if (frame_recipe & 2) {
                    // remove childs
                    start_index = this.command_index_stream[frame_command_idx];
                    end_index = start_index + this.command_length_stream[frame_command_idx++];
                    for (i = start_index; i < end_index; i++)
                        delete depth_sessionIDs[this.remove_child_stream[i] - 16383];
                }
                if (frame_recipe & 4) {
                    start_index = this.command_index_stream[frame_command_idx];
                    end_index = start_index + this.command_length_stream[frame_command_idx++];
                    if (queue_pass2) {
                        for (i = end_index - 1; i >= start_index; i--)
                            depth_sessionIDs[this.add_child_stream[i * 2 + 1] - 16383] = { id: this.add_child_stream[i * 2], instanceID: this.add_child_stream[i * 2] + "#" + this.keyframe_firstframes[k] };
                    }
                    else {
                        for (i = start_index; i < end_index; i++)
                            depth_sessionIDs[this.add_child_stream[i * 2 + 1] - 16383] = { id: this.add_child_stream[i * 2], instanceID: this.add_child_stream[i * 2] + "#" + this.keyframe_firstframes[k] };
                    }
                    if (k == target_keyframe_idx) {
                        if (queue_pass2) {
                            for (i = end_index - 1; i >= start_index; i--) {
                                new_depth_sessionIDs[this.add_child_stream[i * 2 + 1] - 16383] = true;
                            }
                        }
                        else {
                            for (i = start_index; i < end_index; i++) {
                                new_depth_sessionIDs[this.add_child_stream[i * 2 + 1] - 16383] = true;
                            }
                        }
                    }
                }
                if (frame_recipe & 8) {
                    this._update_frames[update_cnt] = this.keyframe_firstframes[k];
                    this._update_indices[update_cnt++] = frame_command_idx++; // execute update command later
                }
                if (frame_recipe & 16 && k == target_keyframe_idx) {
                    this.start_sounds(target_mc, frame_command_idx);
                }
            }
        };
        Timeline.prototype.pass2 = function (target_mc) {
            var k;
            var len = this._update_indices.length;
            for (k = 0; k < len; k++)
                this.update_childs(target_mc, this._update_indices[k], this._update_frames[k]);
        };
        /* constructs the next frame of a mc.
            the function expects the currentFrameIndex already to be incremented
        */
        Timeline.prototype.constructNextFrame = function (target_mc, queueScript, scriptPass1) {
            if (queueScript === void 0) { queueScript = true; }
            if (scriptPass1 === void 0) { scriptPass1 = false; }
            var frameIndex = target_mc.currentFrameIndex;
            var new_keyFrameIndex = this.keyframe_indices[frameIndex];
            if (queueScript && this._framescripts[frameIndex])
                this.add_script_for_postcontruct(target_mc, frameIndex, scriptPass1);
            if (target_mc.constructedKeyFrameIndex != new_keyFrameIndex) {
                target_mc.constructedKeyFrameIndex = new_keyFrameIndex;
                var frame_command_idx = this.frame_command_indices[new_keyFrameIndex];
                var frame_recipe = this.frame_recipe[new_keyFrameIndex];
                if (frame_recipe & 1) {
                    for (var i = target_mc.numChildren - 1; i >= 0; i--)
                        if (target_mc._children[i]._depthID < 0)
                            target_mc.removeChildAt(i);
                }
                else if (frame_recipe & 2) {
                    this.remove_childs_continous(target_mc, frame_command_idx++);
                }
                if (frame_recipe & 4)
                    this.add_childs_continous(target_mc, frame_command_idx++);
                if (frame_recipe & 8)
                    this.update_childs(target_mc, frame_command_idx++);
                if (frame_recipe & 16)
                    this.start_sounds(target_mc, frame_command_idx++);
            }
        };
        Timeline.prototype.remove_childs_continous = function (sourceMovieClip, frame_command_idx) {
            var start_index = this.command_index_stream[frame_command_idx];
            var end_index = start_index + this.command_length_stream[frame_command_idx];
            var depth;
            for (var i = start_index; i < end_index; i++) {
                depth = this.remove_child_stream[i] - 16383;
                var idx = sourceMovieClip.getDepthIndexInternal(depth);
                if (idx >= 0)
                    sourceMovieClip.removeChildAt(idx);
            }
        };
        Timeline.prototype.add_childs_continous = function (sourceMovieClip, frame_command_idx) {
            // apply add commands in reversed order to have script exeucted in correct order.
            // this could be changed in exporter
            var idx;
            var start_index = this.command_index_stream[frame_command_idx];
            var end_index = start_index + this.command_length_stream[frame_command_idx];
            for (var i = start_index; i < end_index; i++) {
                idx = i * 2;
                if (typeof this.add_child_stream[idx] === "undefined") {
                    console.log("ERROR in timeline. could not find child-id in child_stream for idx", idx, this.add_child_stream);
                    continue;
                }
                var childAsset = sourceMovieClip.getPotentialChildInstance(this.add_child_stream[idx], this.add_child_stream[idx] + "#" + sourceMovieClip.currentFrameIndex, true);
                sourceMovieClip._addTimelineChildAt(childAsset, this.add_child_stream[idx + 1] - 16383, this.add_child_stream[idx]); //this.add_child_stream[idx]);
            }
        };
        Timeline.prototype.start_sounds = function (target_mc, frame_command_idx) {
            var start_index = this.command_index_stream[frame_command_idx];
            var end_index = start_index + this.command_length_stream[frame_command_idx];
            for (var i = start_index; i < end_index; i++) {
                var audioProps = this.audioPool[this.add_sounds_stream[i]];
                if (audioProps) {
                    if (audioProps.cmd == 15) { // start sound
                        var child = audioProps.sound;
                        if (audioProps.props.loopCount > 0) {
                            child.loopsToPlay = audioProps.props.loopCount;
                        }
                        else {
                            child.loopsToPlay = 0;
                        }
                        target_mc.startSound(audioProps.id, child, child.loopsToPlay);
                    }
                    else if (audioProps.cmd == 16) { // stop sound
                        target_mc.stopSound(audioProps.id);
                    }
                    //console.log("start sound:", child);
                }
            }
        };
        Timeline.prototype.update_childs = function (target_mc, frame_command_idx, frameIdx) {
            if (frameIdx === void 0) { frameIdx = -1; }
            var p;
            var props_start_idx;
            var props_end_index;
            var start_index = this.command_index_stream[frame_command_idx];
            var end_index = start_index + this.command_length_stream[frame_command_idx];
            var child;
            for (var i = start_index; i < end_index; i++) {
                //for(var i:number = end_index; i >= start_index; i--) {
                child = target_mc.getChildAtSessionID(this.update_child_stream[i]);
                if (child) {
                    if (frameIdx > 0 && child.addedOnFrame > frameIdx)
                        continue;
                    // check if the child is active + not blocked by script
                    this._blocked = Boolean(child._adapter && child.adapter.isBlockedByScript());
                    props_start_idx = this.update_child_props_indices_stream[i];
                    props_end_index = props_start_idx + this.update_child_props_length_stream[i];
                    for (p = props_start_idx; p < props_end_index; p++)
                        this._functions[this.property_type_stream[p]].call(this, child, target_mc, this.property_index_stream[p]);
                }
                else {
                    //console.log("timeline: child not found");
                }
            }
        };
        Timeline.prototype.update_mtx_all = function (child, target_mc, i) {
            if (this._blocked || child.noTimelineUpdate)
                return;
            i *= 6;
            var new_matrix = child.transform.matrix3D;
            new_matrix._rawData[0] = this.properties_stream_f32_mtx_all[i++];
            new_matrix._rawData[1] = this.properties_stream_f32_mtx_all[i++];
            new_matrix._rawData[4] = this.properties_stream_f32_mtx_all[i++];
            new_matrix._rawData[5] = this.properties_stream_f32_mtx_all[i++];
            new_matrix._rawData[12] = this.properties_stream_f32_mtx_all[i++];
            new_matrix._rawData[13] = this.properties_stream_f32_mtx_all[i];
            child.transform.invalidateComponents();
        };
        Timeline.prototype.update_colortransform = function (child, target_mc, i) {
            if (Boolean(child._adapter && child.adapter.isColorTransformByScript()))
                return;
            i *= 8;
            var new_ct = child.transform.colorTransform || (child.transform.colorTransform = new ColorTransform());
            new_ct._rawData[0] = this.properties_stream_f32_ct[i++];
            new_ct._rawData[1] = this.properties_stream_f32_ct[i++];
            new_ct._rawData[2] = this.properties_stream_f32_ct[i++];
            new_ct._rawData[3] = this.properties_stream_f32_ct[i++];
            new_ct._rawData[4] = this.properties_stream_f32_ct[i++];
            new_ct._rawData[5] = this.properties_stream_f32_ct[i++];
            new_ct._rawData[6] = this.properties_stream_f32_ct[i++];
            new_ct._rawData[7] = this.properties_stream_f32_ct[i];
            child.transform.invalidateColorTransform();
        };
        Timeline.prototype.update_masks = function (child, target_mc, i) {
            // an object could have multiple groups of masks, in case a graphic clip was merged into the timeline
            // this is not implmeented in the runtime yet
            // for now, a second mask-groupd would overwrite the first one
            var mask;
            var masks = new Array();
            var numMasks = this.properties_stream_int[i++];
            if (numMasks == 0) {
                child.masks = null;
                return;
            }
            //mask may not exist if a goto command moves the playhead to a point in the timeline after
            //one of the masks in a mask array has already been removed. Therefore a check is needed.
            for (var m = 0; m < numMasks; m++)
                if ((mask = target_mc.getChildAtSessionID(this.properties_stream_int[i++])))
                    masks.push(mask);
            child.masks = masks;
        };
        Timeline.prototype.update_name = function (child, target_mc, i) {
            child.name = this.properties_stream_strings[i];
            target_mc.adapter.registerScriptObject(child);
        };
        Timeline.prototype.update_button_name = function (target, sourceMovieClip, i) {
            target.name = this.properties_stream_strings[i];
            // todo: creating the buttonlistenrs later should also be done, but for icycle i dont think this will cause problems
            target.addButtonListeners();
            sourceMovieClip.adapter.registerScriptObject(target);
        };
        Timeline.prototype.update_visibility = function (child, target_mc, i) {
            if (!child._adapter || !child.adapter.isVisibilityByScript())
                child.visible = Boolean(i);
        };
        Timeline.prototype.update_mtx_scale_rot = function (child, target_mc, i) {
            if (this._blocked || child.noTimelineUpdate)
                return;
            i *= 4;
            var new_matrix = child.transform.matrix3D;
            new_matrix._rawData[0] = this.properties_stream_f32_mtx_scale_rot[i++];
            new_matrix._rawData[1] = this.properties_stream_f32_mtx_scale_rot[i++];
            new_matrix._rawData[4] = this.properties_stream_f32_mtx_scale_rot[i++];
            new_matrix._rawData[5] = this.properties_stream_f32_mtx_scale_rot[i];
            child.transform.invalidateComponents();
            child._invalidateHierarchicalProperties(HierarchicalProperties.SCENE_TRANSFORM);
        };
        Timeline.prototype.update_mtx_pos = function (child, target_mc, i) {
            if (this._blocked || child.noTimelineUpdate)
                return;
            i *= 2;
            var new_matrix = child.transform.matrix3D;
            new_matrix._rawData[12] = this.properties_stream_f32_mtx_pos[i++];
            new_matrix._rawData[13] = this.properties_stream_f32_mtx_pos[i];
            child.transform.invalidatePosition();
        };
        Timeline.prototype.enable_maskmode = function (child, target_mc, i) {
            child.maskMode = true;
        };
        Timeline.prototype.remove_masks = function (child, target_mc, i) {
            child.masks = null;
        };
        Timeline.prototype.swap_graphics = function (child, target_mc, i) {
            if (child.isAsset(Sprite)) {
                var myGraphics = this.graphicsPool[this.properties_stream_int[i]];
                //console.log("frame:", target_mc.currentFrameIndex ,"swap graphics: ", target_mc.id, i, myGraphics.id);
                child.graphics = myGraphics;
            }
        };
        Timeline.prototype.start_audio = function (child, target_mc, i) {
        };
        Timeline.prototype.set_ratio = function (child, target_mc, i) {
            child.setRatio(this.properties_stream_int[i] / 0xffff);
        };
        Timeline.prototype.update_blendmode = function (child, target_mc, i) {
            console.log("update blendmode " + i);
        };
        Timeline.prototype.update_rendermode = function (child, target_mc, i) {
            console.log("update rendermode " + i);
        };
        Timeline.prototype.dispose = function () {
            for (var i = 0; i < this._potentialPrototypes.length; i++) {
                if (this._potentialPrototypes[i].dispose)
                    this._potentialPrototypes[i].dispose();
            }
            this.keyframe_indices = [];
            this.avm1Exports = {};
            this.avm1InitActions = {};
            this.avm1ButtonActions = [];
            this.graphicsPool = {};
            this.audioPool = {};
            this.potentialPrototypesInitEventsMap = {};
            this._potentialPrototypes = [];
            this._labels = {};
            this._framescripts = {};
            this._framescripts_translated = {};
        };
        Timeline.currentInstanceName = null;
        Timeline.currentInstanceMatrix = null;
        return Timeline;
    }());

    /**
     *
     */
    var TouchPoint = /** @class */ (function () {
        function TouchPoint(x, y, id) {
            this.x = x;
            this.y = y;
            this.id = id;
        }
        return TouchPoint;
    }());

    var ControllerBase = /** @class */ (function () {
        function ControllerBase(targetObject) {
            if (targetObject === void 0) { targetObject = null; }
            this._pAutoUpdate = true;
            this.targetObject = targetObject;
        }
        ControllerBase.prototype.pNotifyUpdate = function () {
            if (this._pTargetObject)
                this._pTargetObject._invalidateHierarchicalProperties(HierarchicalProperties.SCENE_TRANSFORM);
        };
        Object.defineProperty(ControllerBase.prototype, "targetObject", {
            get: function () {
                return this._pTargetObject;
            },
            set: function (val) {
                if (this._pTargetObject == val)
                    return;
                if (this._pTargetObject && this._pAutoUpdate)
                    this._pTargetObject._iController = null;
                this._pTargetObject = val;
                if (this._pTargetObject && this._pAutoUpdate)
                    this._pTargetObject._iController = this;
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ControllerBase.prototype, "autoUpdate", {
            get: function () {
                return this._pAutoUpdate;
            },
            set: function (val) {
                if (this._pAutoUpdate == val)
                    return;
                this._pAutoUpdate = val;
                if (this._pTargetObject) {
                    if (this._pAutoUpdate)
                        this._pTargetObject._iController = this;
                    else
                        this._pTargetObject._iController = null;
                }
            },
            enumerable: true,
            configurable: true
        });
        ControllerBase.prototype.update = function (interpolate) {
            if (interpolate === void 0) { interpolate = true; }
            throw new AbstractMethodError();
        };
        ControllerBase.prototype.updateController = function () {
            if (this._pControllerDirty && this._pAutoUpdate) {
                this._pControllerDirty = false;
                this.pNotifyUpdate();
            }
        };
        return ControllerBase;
    }());

    /**
     * Extended camera used to hover round a specified target object.
     *
     * @see    away3d.containers.View3D
     */
    var FirstPersonController = /** @class */ (function (_super) {
        __extends$3(FirstPersonController, _super);
        /**
         * Creates a new <code>HoverController</code> object.
         */
        function FirstPersonController(targetObject, panAngle, tiltAngle, minTiltAngle, maxTiltAngle, steps, wrapPanAngle) {
            if (targetObject === void 0) { targetObject = null; }
            if (panAngle === void 0) { panAngle = 0; }
            if (tiltAngle === void 0) { tiltAngle = 90; }
            if (minTiltAngle === void 0) { minTiltAngle = -90; }
            if (maxTiltAngle === void 0) { maxTiltAngle = 90; }
            if (steps === void 0) { steps = 8; }
            if (wrapPanAngle === void 0) { wrapPanAngle = false; }
            var _this = _super.call(this, targetObject) || this;
            _this._iCurrentPanAngle = 0;
            _this._iCurrentTiltAngle = 90;
            _this._panAngle = 0;
            _this._tiltAngle = 90;
            _this._minTiltAngle = -90;
            _this._maxTiltAngle = 90;
            _this._steps = 8;
            _this._walkIncrement = 0;
            _this._strafeIncrement = 0;
            _this._wrapPanAngle = false;
            _this.fly = false;
            _this.panAngle = panAngle;
            _this.tiltAngle = tiltAngle;
            _this.minTiltAngle = minTiltAngle;
            _this.maxTiltAngle = maxTiltAngle;
            _this.steps = steps;
            _this.wrapPanAngle = wrapPanAngle;
            //values passed in contrustor are applied immediately
            _this._iCurrentPanAngle = _this._panAngle;
            _this._iCurrentTiltAngle = _this._tiltAngle;
            return _this;
        }
        Object.defineProperty(FirstPersonController.prototype, "steps", {
            /**
             * Fractional step taken each time the <code>hover()</code> method is called. Defaults to 8.
             *
             * Affects the speed at which the <code>tiltAngle</code> and <code>panAngle</code> resolve to their targets.
             *
             * @see    #tiltAngle
             * @see    #panAngle
             */
            get: function () {
                return this._steps;
            },
            set: function (val) {
                val = (val < 1) ? 1 : val;
                if (this._steps == val)
                    return;
                this._steps = val;
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FirstPersonController.prototype, "panAngle", {
            /**
             * Rotation of the camera in degrees around the y axis. Defaults to 0.
             */
            get: function () {
                return this._panAngle;
            },
            set: function (val) {
                if (this._panAngle == val)
                    return;
                this._panAngle = val;
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FirstPersonController.prototype, "tiltAngle", {
            /**
             * Elevation angle of the camera in degrees. Defaults to 90.
             */
            get: function () {
                return this._tiltAngle;
            },
            set: function (val) {
                val = Math.max(this._minTiltAngle, Math.min(this._maxTiltAngle, val));
                if (this._tiltAngle == val)
                    return;
                this._tiltAngle = val;
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FirstPersonController.prototype, "minTiltAngle", {
            /**
             * Minimum bounds for the <code>tiltAngle</code>. Defaults to -90.
             *
             * @see    #tiltAngle
             */
            get: function () {
                return this._minTiltAngle;
            },
            set: function (val) {
                if (this._minTiltAngle == val)
                    return;
                this._minTiltAngle = val;
                this.tiltAngle = Math.max(this._minTiltAngle, Math.min(this._maxTiltAngle, this._tiltAngle));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FirstPersonController.prototype, "maxTiltAngle", {
            /**
             * Maximum bounds for the <code>tiltAngle</code>. Defaults to 90.
             *
             * @see    #tiltAngle
             */
            get: function () {
                return this._maxTiltAngle;
            },
            set: function (val) {
                if (this._maxTiltAngle == val)
                    return;
                this._maxTiltAngle = val;
                this.tiltAngle = Math.max(this._minTiltAngle, Math.min(this._maxTiltAngle, this._tiltAngle));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(FirstPersonController.prototype, "wrapPanAngle", {
            /**
             * Defines whether the value of the pan angle wraps when over 360 degrees or under 0 degrees. Defaults to false.
             */
            get: function () {
                return this._wrapPanAngle;
            },
            set: function (val) {
                if (this._wrapPanAngle == val)
                    return;
                this._wrapPanAngle = val;
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Updates the current tilt angle and pan angle values.
         *
         * Values are calculated using the defined <code>tiltAngle</code>, <code>panAngle</code> and <code>steps</code> variables.
         *
         * @param interpolate   If the update to a target pan- or tiltAngle is interpolated. Default is true.
         *
         * @see    #tiltAngle
         * @see    #panAngle
         * @see    #steps
         */
        FirstPersonController.prototype.update = function (interpolate) {
            if (interpolate === void 0) { interpolate = true; }
            if (this._tiltAngle != this._iCurrentTiltAngle || this._panAngle != this._iCurrentPanAngle) {
                this._pControllerDirty = true;
                if (this._wrapPanAngle) {
                    if (this._panAngle < 0) {
                        this._iCurrentPanAngle += this._panAngle % 360 + 360 - this._panAngle;
                        this._panAngle = this._panAngle % 360 + 360;
                    }
                    else {
                        this._iCurrentPanAngle += this._panAngle % 360 - this._panAngle;
                        this._panAngle = this._panAngle % 360;
                    }
                    while (this._panAngle - this._iCurrentPanAngle < -180)
                        this._iCurrentPanAngle -= 360;
                    while (this._panAngle - this._iCurrentPanAngle > 180)
                        this._iCurrentPanAngle += 360;
                }
                if (interpolate) {
                    this._iCurrentTiltAngle += (this._tiltAngle - this._iCurrentTiltAngle) / (this.steps + 1);
                    this._iCurrentPanAngle += (this._panAngle - this._iCurrentPanAngle) / (this.steps + 1);
                }
                else {
                    this._iCurrentTiltAngle = this._tiltAngle;
                    this._iCurrentPanAngle = this._panAngle;
                }
                //snap coords if angle differences are close
                if ((Math.abs(this.tiltAngle - this._iCurrentTiltAngle) < 0.01) && (Math.abs(this._panAngle - this._iCurrentPanAngle) < 0.01)) {
                    this._iCurrentTiltAngle = this._tiltAngle;
                    this._iCurrentPanAngle = this._panAngle;
                }
            }
            this.targetObject.rotationX = this._iCurrentTiltAngle;
            this.targetObject.rotationY = this._iCurrentPanAngle;
            if (this._walkIncrement) {
                if (this.fly) {
                    this.targetObject.transform.moveForward(this._walkIncrement);
                }
                else {
                    this.targetObject.x += this._walkIncrement * Math.sin(this._panAngle * MathConsts.DEGREES_TO_RADIANS);
                    this.targetObject.z += this._walkIncrement * Math.cos(this._panAngle * MathConsts.DEGREES_TO_RADIANS);
                }
                this._walkIncrement = 0;
            }
            if (this._strafeIncrement) {
                this.targetObject.transform.moveRight(this._strafeIncrement);
                this._strafeIncrement = 0;
            }
        };
        FirstPersonController.prototype.incrementWalk = function (val) {
            if (val == 0)
                return;
            this._walkIncrement += val;
            this.pNotifyUpdate();
        };
        FirstPersonController.prototype.incrementStrafe = function (val) {
            if (val == 0)
                return;
            this._strafeIncrement += val;
            this.pNotifyUpdate();
        };
        return FirstPersonController;
    }(ControllerBase));

    var LookAtController = /** @class */ (function (_super) {
        __extends$3(LookAtController, _super);
        function LookAtController(targetObject, lookAtObject) {
            if (targetObject === void 0) { targetObject = null; }
            if (lookAtObject === void 0) { lookAtObject = null; }
            var _this = _super.call(this, targetObject) || this;
            _this._pOrigin = new Vector3D(0.0, 0.0, 0.0);
            _this._onLookAtObjectChangedDelegate = function (event) { return _this.onLookAtObjectChanged(event); };
            if (lookAtObject)
                _this.lookAtObject = lookAtObject;
            else
                _this.lookAtPosition = new Vector3D();
            return _this;
        }
        Object.defineProperty(LookAtController.prototype, "lookAtPosition", {
            get: function () {
                return this._pLookAtPosition;
            },
            set: function (val) {
                if (this._pLookAtObject) {
                    this._pLookAtObject.removeEventListener(DisplayObjectEvent.SCENETRANSFORM_CHANGED, this._onLookAtObjectChangedDelegate);
                    this._pLookAtObject = null;
                }
                this._pLookAtPosition = val;
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LookAtController.prototype, "lookAtObject", {
            get: function () {
                return this._pLookAtObject;
            },
            set: function (val) {
                if (this._pLookAtPosition)
                    this._pLookAtPosition = null;
                if (this._pLookAtObject == val)
                    return;
                if (this._pLookAtObject)
                    this._pLookAtObject.removeEventListener(DisplayObjectEvent.SCENETRANSFORM_CHANGED, this._onLookAtObjectChangedDelegate);
                this._pLookAtObject = val;
                if (this._pLookAtObject)
                    this._pLookAtObject.addEventListener(DisplayObjectEvent.SCENETRANSFORM_CHANGED, this._onLookAtObjectChangedDelegate);
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        //@override
        LookAtController.prototype.update = function (interpolate) {
            if (interpolate === void 0) { interpolate = true; }
            if (this._pTargetObject) {
                if (this._pLookAtPosition)
                    this._pTargetObject.lookAt(this._pLookAtPosition);
                else if (this._pLookAtObject)
                    this._pTargetObject.lookAt(this._pLookAtObject.transform.concatenatedMatrix3D.position);
            }
        };
        LookAtController.prototype.onLookAtObjectChanged = function (event) {
            this.pNotifyUpdate();
        };
        return LookAtController;
    }(ControllerBase));

    /**
     * Extended camera used to hover round a specified target object.
     *
     * @see    away.containers.View
     */
    var HoverController = /** @class */ (function (_super) {
        __extends$3(HoverController, _super);
        /**
         * Creates a new <code>HoverController</code> object.
         */
        function HoverController(targetObject, lookAtObject, panAngle, tiltAngle, distance, minTiltAngle, maxTiltAngle, minPanAngle, maxPanAngle, steps, yFactor, wrapPanAngle) {
            if (targetObject === void 0) { targetObject = null; }
            if (lookAtObject === void 0) { lookAtObject = null; }
            if (panAngle === void 0) { panAngle = 0; }
            if (tiltAngle === void 0) { tiltAngle = 90; }
            if (distance === void 0) { distance = 1000; }
            if (minTiltAngle === void 0) { minTiltAngle = -90; }
            if (maxTiltAngle === void 0) { maxTiltAngle = 90; }
            if (minPanAngle === void 0) { minPanAngle = null; }
            if (maxPanAngle === void 0) { maxPanAngle = null; }
            if (steps === void 0) { steps = 8; }
            if (yFactor === void 0) { yFactor = 2; }
            if (wrapPanAngle === void 0) { wrapPanAngle = false; }
            var _this = _super.call(this, targetObject, lookAtObject) || this;
            _this._iCurrentPanAngle = 0;
            _this._iCurrentTiltAngle = 90;
            _this._panAngle = 0;
            _this._tiltAngle = 90;
            _this._distance = 1000;
            _this._minPanAngle = -Infinity;
            _this._maxPanAngle = Infinity;
            _this._minTiltAngle = -90;
            _this._maxTiltAngle = 90;
            _this._steps = 8;
            _this._yFactor = 2;
            _this._wrapPanAngle = false;
            _this._upAxis = new Vector3D();
            _this.distance = distance;
            _this.panAngle = panAngle;
            _this.tiltAngle = tiltAngle;
            _this.minPanAngle = (minPanAngle != null) ? minPanAngle : -Infinity;
            _this.maxPanAngle = (maxPanAngle != null) ? maxPanAngle : Infinity;
            _this.minTiltAngle = minTiltAngle;
            _this.maxTiltAngle = maxTiltAngle;
            _this.steps = steps;
            _this.yFactor = yFactor;
            _this.wrapPanAngle = wrapPanAngle;
            //values passed in contrustor are applied immediately
            _this._iCurrentPanAngle = _this._panAngle;
            _this._iCurrentTiltAngle = _this._tiltAngle;
            return _this;
        }
        Object.defineProperty(HoverController.prototype, "steps", {
            /**
             * Fractional step taken each time the <code>hover()</code> method is called. Defaults to 8.
             *
             * Affects the speed at which the <code>tiltAngle</code> and <code>panAngle</code> resolve to their targets.
             *
             * @see    #tiltAngle
             * @see    #panAngle
             */
            get: function () {
                return this._steps;
            },
            set: function (val) {
                val = (val < 1) ? 1 : val;
                if (this._steps == val)
                    return;
                this._steps = val;
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HoverController.prototype, "panAngle", {
            /**
             * Rotation of the camera in degrees around the y axis. Defaults to 0.
             */
            get: function () {
                return this._panAngle;
            },
            set: function (val) {
                val = Math.max(this._minPanAngle, Math.min(this._maxPanAngle, val));
                if (this._panAngle == val)
                    return;
                this._panAngle = val;
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HoverController.prototype, "tiltAngle", {
            /**
             * Elevation angle of the camera in degrees. Defaults to 90.
             */
            get: function () {
                return this._tiltAngle;
            },
            set: function (val) {
                val = Math.max(this._minTiltAngle, Math.min(this._maxTiltAngle, val));
                if (this._tiltAngle == val)
                    return;
                this._tiltAngle = val;
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HoverController.prototype, "distance", {
            /**
             * Distance between the camera and the specified target. Defaults to 1000.
             */
            get: function () {
                return this._distance;
            },
            set: function (val) {
                if (this._distance == val)
                    return;
                this._distance = val;
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HoverController.prototype, "minPanAngle", {
            /**
             * Minimum bounds for the <code>panAngle</code>. Defaults to -Infinity.
             *
             * @see    #panAngle
             */
            get: function () {
                return this._minPanAngle;
            },
            set: function (val) {
                if (this._minPanAngle == val)
                    return;
                this._minPanAngle = val;
                this.panAngle = Math.max(this._minPanAngle, Math.min(this._maxPanAngle, this._panAngle));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HoverController.prototype, "maxPanAngle", {
            /**
             * Maximum bounds for the <code>panAngle</code>. Defaults to Infinity.
             *
             * @see    #panAngle
             */
            get: function () {
                return this._maxPanAngle;
            },
            set: function (val) {
                if (this._maxPanAngle == val)
                    return;
                this._maxPanAngle = val;
                this.panAngle = Math.max(this._minPanAngle, Math.min(this._maxPanAngle, this._panAngle));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HoverController.prototype, "minTiltAngle", {
            /**
             * Minimum bounds for the <code>tiltAngle</code>. Defaults to -90.
             *
             * @see    #tiltAngle
             */
            get: function () {
                return this._minTiltAngle;
            },
            set: function (val) {
                if (this._minTiltAngle == val)
                    return;
                this._minTiltAngle = val;
                this.tiltAngle = Math.max(this._minTiltAngle, Math.min(this._maxTiltAngle, this._tiltAngle));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HoverController.prototype, "maxTiltAngle", {
            /**
             * Maximum bounds for the <code>tiltAngle</code>. Defaults to 90.
             *
             * @see    #tiltAngle
             */
            get: function () {
                return this._maxTiltAngle;
            },
            set: function (val) {
                if (this._maxTiltAngle == val)
                    return;
                this._maxTiltAngle = val;
                this.tiltAngle = Math.max(this._minTiltAngle, Math.min(this._maxTiltAngle, this._tiltAngle));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HoverController.prototype, "yFactor", {
            /**
             * Fractional difference in distance between the horizontal camera orientation and vertical camera orientation. Defaults to 2.
             *
             * @see    #distance
             */
            get: function () {
                return this._yFactor;
            },
            set: function (val) {
                if (this._yFactor == val)
                    return;
                this._yFactor = val;
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(HoverController.prototype, "wrapPanAngle", {
            /**
             * Defines whether the value of the pan angle wraps when over 360 degrees or under 0 degrees. Defaults to false.
             */
            get: function () {
                return this._wrapPanAngle;
            },
            set: function (val) {
                if (this._wrapPanAngle == val)
                    return;
                this._wrapPanAngle = val;
                this.pNotifyUpdate();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Updates the current tilt angle and pan angle values.
         *
         * Values are calculated using the defined <code>tiltAngle</code>, <code>panAngle</code> and <code>steps</code> variables.
         *
         * @param interpolate   If the update to a target pan- or tiltAngle is interpolated. Default is true.
         *
         * @see    #tiltAngle
         * @see    #panAngle
         * @see    #steps
         */
        HoverController.prototype.update = function (interpolate) {
            if (interpolate === void 0) { interpolate = true; }
            if (this._tiltAngle != this._iCurrentTiltAngle || this._panAngle != this._iCurrentPanAngle) {
                this._pControllerDirty = true;
                if (this._wrapPanAngle) {
                    if (this._panAngle < 0) {
                        this._iCurrentPanAngle += this._panAngle % 360 + 360 - this._panAngle;
                        this._panAngle = this._panAngle % 360 + 360;
                    }
                    else {
                        this._iCurrentPanAngle += this._panAngle % 360 - this._panAngle;
                        this._panAngle = this._panAngle % 360;
                    }
                    while (this._panAngle - this._iCurrentPanAngle < -180)
                        this._iCurrentPanAngle -= 360;
                    while (this._panAngle - this._iCurrentPanAngle > 180)
                        this._iCurrentPanAngle += 360;
                }
                if (interpolate) {
                    this._iCurrentTiltAngle += (this._tiltAngle - this._iCurrentTiltAngle) / (this.steps + 1);
                    this._iCurrentPanAngle += (this._panAngle - this._iCurrentPanAngle) / (this.steps + 1);
                }
                else {
                    this._iCurrentPanAngle = this._panAngle;
                    this._iCurrentTiltAngle = this._tiltAngle;
                }
                //snap coords if angle differences are close
                if ((Math.abs(this.tiltAngle - this._iCurrentTiltAngle) < 0.01) && (Math.abs(this._panAngle - this._iCurrentPanAngle) < 0.01)) {
                    this._iCurrentTiltAngle = this._tiltAngle;
                    this._iCurrentPanAngle = this._panAngle;
                }
            }
            var pos = (this.lookAtObject) ? this.lookAtObject.transform.position : (this.lookAtPosition) ? this.lookAtPosition : this._pOrigin;
            this.targetObject.x = pos.x + this.distance * Math.sin(this._iCurrentPanAngle * MathConsts.DEGREES_TO_RADIANS) * Math.cos(this._iCurrentTiltAngle * MathConsts.DEGREES_TO_RADIANS);
            this.targetObject.y = pos.y + this.distance * Math.sin(this._iCurrentTiltAngle * MathConsts.DEGREES_TO_RADIANS) * this.yFactor;
            this.targetObject.z = pos.z + this.distance * Math.cos(this._iCurrentPanAngle * MathConsts.DEGREES_TO_RADIANS) * Math.cos(this._iCurrentTiltAngle * MathConsts.DEGREES_TO_RADIANS);
            this._upAxis.x = -Math.sin(this._iCurrentPanAngle * MathConsts.DEGREES_TO_RADIANS) * Math.sin(this._iCurrentTiltAngle * MathConsts.DEGREES_TO_RADIANS);
            this._upAxis.y = Math.cos(this._iCurrentTiltAngle * MathConsts.DEGREES_TO_RADIANS);
            this._upAxis.z = -Math.cos(this._iCurrentPanAngle * MathConsts.DEGREES_TO_RADIANS) * Math.sin(this._iCurrentTiltAngle * MathConsts.DEGREES_TO_RADIANS);
            if (this._pTargetObject) {
                if (this._pLookAtPosition)
                    this._pTargetObject.lookAt(this._pLookAtPosition, this._upAxis);
                else if (this._pLookAtObject)
                    this._pTargetObject.lookAt(this._pLookAtObject.transform.concatenatedMatrix3D.position, this._upAxis);
            }
        };
        return HoverController;
    }(LookAtController));

    /**
     * Controller used to follow behind an object on the XZ plane, with an optional
     * elevation (tiltAngle).
     *
     * @see    away3d.containers.View3D
     */
    var FollowController = /** @class */ (function (_super) {
        __extends$3(FollowController, _super);
        function FollowController(targetObject, lookAtObject, tiltAngle, distance) {
            if (targetObject === void 0) { targetObject = null; }
            if (lookAtObject === void 0) { lookAtObject = null; }
            if (tiltAngle === void 0) { tiltAngle = 45; }
            if (distance === void 0) { distance = 700; }
            return _super.call(this, targetObject, lookAtObject, 0, tiltAngle, distance) || this;
        }
        FollowController.prototype.update = function (interpolate) {
            if (interpolate === void 0) { interpolate = true; }
            if (!this.lookAtObject)
                return;
            this.panAngle = this._pLookAtObject.rotationY - 180;
            _super.prototype.update.call(this);
        };
        return FollowController;
    }(HoverController));

    /**
     * Uses spring physics to animate the target object towards a position that is
     * defined as the lookAtTarget object's position plus the vector defined by the
     * positionOffset property.
     */
    var SpringController = /** @class */ (function (_super) {
        __extends$3(SpringController, _super);
        function SpringController(targetObject, lookAtObject, stiffness, mass, damping) {
            if (targetObject === void 0) { targetObject = null; }
            if (lookAtObject === void 0) { lookAtObject = null; }
            if (stiffness === void 0) { stiffness = 1; }
            if (mass === void 0) { mass = 40; }
            if (damping === void 0) { damping = 4; }
            var _this = _super.call(this, targetObject, lookAtObject) || this;
            /**
             * Offset of spring center from target in target object space, ie: Where the camera should ideally be in the target object space.
             */
            _this.positionOffset = new Vector3D(0, 500, -1000);
            _this.stiffness = stiffness;
            _this.damping = damping;
            _this.mass = mass;
            _this._velocity = new Vector3D();
            _this._dv = new Vector3D();
            _this._stretch = new Vector3D();
            _this._force = new Vector3D();
            _this._acceleration = new Vector3D();
            _this._desiredPosition = new Vector3D();
            return _this;
        }
        SpringController.prototype.update = function (interpolate) {
            if (interpolate === void 0) { interpolate = true; }
            var offs;
            if (!this._pLookAtObject || !this._pTargetObject)
                return;
            this._pControllerDirty = true;
            offs = this._pLookAtObject.transform.matrix3D.deltaTransformVector(this.positionOffset);
            this._desiredPosition.x = this._pLookAtObject.x + offs.x;
            this._desiredPosition.y = this._pLookAtObject.y + offs.y;
            this._desiredPosition.z = this._pLookAtObject.z + offs.z;
            this._stretch = this._pTargetObject.transform.position.add(this._desiredPosition);
            this._stretch.scaleBy(-this.stiffness);
            this._dv.copyFrom(this._velocity);
            this._dv.scaleBy(this.damping);
            this._force.x = this._stretch.x - this._dv.x;
            this._force.y = this._stretch.y - this._dv.y;
            this._force.z = this._stretch.z - this._dv.z;
            this._acceleration.copyFrom(this._force);
            this._acceleration.scaleBy(1 / this.mass);
            this._velocity.incrementBy(this._acceleration);
            var position = this._pTargetObject.transform.position.add(this._velocity);
            this._pTargetObject.transform.moveTo(position.x, position.y, position.z);
            _super.prototype.update.call(this);
        };
        return SpringController;
    }(LookAtController));

    /**
     * The Billboard class represents display objects that represent bitmap images.
     * These can be images that you load with the <code>flash.Assets</code> or
     * <code>flash.display.Loader</code> classes, or they can be images that you
     * create with the <code>Billboard()</code> constructor.
     *
     * <p>The <code>Billboard()</code> constructor allows you to create a Billboard
     * object that contains a reference to a Image2D object. After you create a
     * Billboard object, use the <code>addChild()</code> or <code>addChildAt()</code>
     * method of the parent DisplayObjectContainer instance to place the bitmap on
     * the display list.</p>
     *
     * <p>A Billboard object can share its Image2D reference among several Billboard
     * objects, independent of translation or rotation properties. Because you can
     * create multiple Billboard objects that reference the same Image2D object,
     * multiple display objects can use the same complex Image2D object without
     * incurring the memory overhead of a Image2D object for each display
     * object instance.</p>
     *
     * <p>A Image2D object can be drawn to the screen by a Billboard object in one
     * of two ways: by using the default hardware renderer with a single hardware surface,
     * or by using the slower software renderer when 3D acceleration is not available.</p>
     *
     * <p>If you would prefer to perform a batch rendering command, rather than using a
     * single surface for each Billboard object, you can also draw to the screen using the
     * <code>drawTiles()</code> or <code>drawTriangles()</code> methods which are
     * available to <code>flash.display.Tilesheet</code> and <code>flash.display.Graphics
     * objects.</code></p>
     *
     * <p><b>Note:</b> The Billboard class is not a subclass of the InteractiveObject
     * class, so it cannot dispatch mouse events. However, you can use the
     * <code>addEventListener()</code> method of the display object container that
     * contains the Billboard object.</p>
     */
    // todo: billboard needed to extend on DisplayObjectContainer in order for as3web/away3d adapters to compile without errors
    // (in away3d Sprite3D extends on ObjectContainer3D)
    var Billboard = /** @class */ (function (_super) {
        __extends$3(Billboard, _super);
        function Billboard(material, pixelSnapping, smoothing) {
            if (pixelSnapping === void 0) { pixelSnapping = "auto"; }
            if (smoothing === void 0) { smoothing = false; }
            var _this = _super.call(this) || this;
            _this.preserveDimensions = false;
            _this._onInvalidateTextureDelegate = function (event) { return _this._onInvalidateTexture(event); };
            _this.material = material;
            _this._updateDimensions();
            return _this;
        }
        Billboard.getNewBillboard = function (material, pixelSnapping, smoothing) {
            if (pixelSnapping === void 0) { pixelSnapping = "auto"; }
            if (smoothing === void 0) { smoothing = false; }
            if (Billboard._billboards.length) {
                var billboard = Billboard._billboards.pop();
                billboard.material = material;
                //billboard.pixelSnapping = pixelSnapping;
                //billboard.smoothing = smoothing;
                return billboard;
            }
            return new Billboard(material, pixelSnapping, smoothing);
        };
        Object.defineProperty(Billboard.prototype, "assetType", {
            /**
             *
             */
            get: function () {
                return Billboard.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Billboard.prototype, "billboardRect", {
            /**
             *
             */
            get: function () {
                return this._billboardRect;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Billboard.prototype, "billboardHeight", {
            /**
             *
             */
            get: function () {
                return this._billboardHeight;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Billboard.prototype, "billboardWidth", {
            /**
             *
             */
            get: function () {
                return this._billboardWidth;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Billboard.prototype, "material", {
            /**
             *
             */
            get: function () {
                return this._material;
            },
            set: function (value) {
                if (value == this._material)
                    return;
                if (this._material)
                    this._material.removeEventListener(MaterialEvent.INVALIDATE_TEXTURES, this._onInvalidateTextureDelegate);
                this._material = value;
                if (this._material)
                    this._material.addEventListener(MaterialEvent.INVALIDATE_TEXTURES, this._onInvalidateTextureDelegate);
                this._updateDimensions();
                this._invalidateMaterial();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Billboard.prototype, "width", {
            /**
             *
             */
            get: function () {
                return this._width;
            },
            set: function (val) {
                if (this._width == val)
                    return;
                this._width = val;
                this.scaleX = this._width / this._billboardRect.width;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Billboard.prototype, "height", {
            /**
             *
             */
            get: function () {
                return this._height;
            },
            set: function (val) {
                if (this._height == val)
                    return;
                this._height = val;
                this.scaleY = this._height / this._billboardRect.height;
            },
            enumerable: true,
            configurable: true
        });
        Billboard.prototype.isEntity = function () {
            return true;
        };
        /**
         * @inheritDoc
         */
        Billboard.prototype.dispose = function () {
            this.disposeValues();
            Billboard._billboards.push(this);
        };
        Billboard.prototype.clone = function () {
            var newInstance = Billboard.getNewBillboard(this._material);
            this.copyTo(newInstance);
            return newInstance;
        };
        Billboard.prototype._acceptTraverser = function (traverser) {
            traverser.applyTraversable(this);
        };
        Billboard.prototype._updateDimensions = function () {
            var texture = this.material.getTextureAt(0);
            var image = texture ? ((this._style ? this._style.getImageAt(texture) : null) || (this.material.style ? this.material.style.getImageAt(texture) : null) || texture.getImageAt(0)) : null;
            if (image) {
                var sampler = ((this._style ? this._style.getSamplerAt(texture) : null) || (this.material.style ? this.material.style.getSamplerAt(texture) : null) || texture.getSamplerAt(0) || ImageUtils.getDefaultSampler());
                if (sampler.imageRect) {
                    this._billboardWidth = sampler.imageRect.width * image.width;
                    this._billboardHeight = sampler.imageRect.height * image.height;
                }
                else {
                    this._billboardWidth = image.rect.width;
                    this._billboardHeight = image.rect.height;
                }
                this._billboardRect = sampler.frameRect || new Rectangle(0, 0, this._billboardWidth, this._billboardHeight);
            }
            else {
                this._billboardWidth = 1;
                this._billboardHeight = 1;
                this._billboardRect = new Rectangle(0, 0, 1, 1);
            }
            this.invalidate();
            this.invalidateElements();
            if (!this.preserveDimensions) {
                this._width = this._billboardRect.width * this.scaleX;
                this._height = this._billboardRect.height * this.scaleY;
            }
            else {
                this.scaleX = this._width / this._billboardRect.width;
                this.scaleY = this._height / this._billboardRect.height;
            }
        };
        Billboard.prototype._onInvalidateProperties = function (event) {
            if (event === void 0) { event = null; }
            _super.prototype._onInvalidateProperties.call(this, event);
            this._updateDimensions();
        };
        /**
         * @private
         */
        Billboard.prototype._onInvalidateTexture = function (event) {
            this._updateDimensions();
        };
        Billboard._billboards = new Array();
        Billboard.assetType = "[asset Billboard]";
        return Billboard;
    }(DisplayObjectContainer));
    /**
     * @class away.pool.RenderableListItem
     */
    var _Render_Billboard = /** @class */ (function (_super) {
        __extends$3(_Render_Billboard, _super);
        function _Render_Billboard() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * //TODO
         *
         * @returns {away.base.TriangleElements}
         */
        _Render_Billboard.prototype._getStageElements = function () {
            var width = this._asset.billboardWidth;
            var height = this._asset.billboardHeight;
            var billboardRect = this._asset.billboardRect;
            var id = width.toString() + height.toString() + billboardRect.toString();
            this._id = id;
            var elements = _Render_Billboard._samplerElements[id];
            if (!elements) {
                elements = _Render_Billboard._samplerElements[id] = new TriangleElements(new AttributesBuffer(11, 4));
                elements.autoDeriveNormals = false;
                elements.autoDeriveTangents = false;
                elements.setIndices(Array(0, 1, 2, 0, 2, 3));
                elements.setPositions(Array(-billboardRect.x, height - billboardRect.y, 0, width - billboardRect.x, height - billboardRect.y, 0, width - billboardRect.x, -billboardRect.y, 0, -billboardRect.x, -billboardRect.y, 0));
                elements.setNormals(Array(1, 0, 0, 1, 0, 0, 1, 0, 0, 1, 0, 0));
                elements.setTangents(Array(0, 0, -1, 0, 0, -1, 0, 0, -1, 0, 0, -1));
                elements.setUVs(Array(0, 1, 1, 1, 1, 0, 0, 0));
            }
            else {
                elements.setPositions(Array(-billboardRect.x, height - billboardRect.y, 0, width - billboardRect.x, height - billboardRect.y, 0, width - billboardRect.x, -billboardRect.y, 0, -billboardRect.x, -billboardRect.y, 0));
            }
            return this._stage.getAbstraction(elements);
        };
        _Render_Billboard.prototype._getRenderMaterial = function () {
            return this.renderGroup.getRenderElements(this.stageElements.elements).getAbstraction(this._asset.material || MaterialUtils.getDefaultColorMaterial());
        };
        _Render_Billboard.prototype._getStyle = function () {
            return this._asset.style;
        };
        _Render_Billboard._samplerElements = new Object();
        return _Render_Billboard;
    }(_Render_RenderableBase));
    /**
     * @class away.pool._Render_Shape
     */
    var _Pick_Billboard = /** @class */ (function (_super) {
        __extends$3(_Pick_Billboard, _super);
        /**
         * //TODO
         *
         * @param renderEntity
         * @param shape
         * @param level
         * @param indexOffset
         */
        function _Pick_Billboard(billboard, pickEntity) {
            var _this = _super.call(this, billboard, pickEntity) || this;
            _this._billboardBoxDirty = true;
            _this._onInvalidateElementsDelegate = function (event) { return _this._onInvalidateElements(event); };
            _this._asset.addEventListener(RenderableEvent.INVALIDATE_ELEMENTS, _this._onInvalidateElementsDelegate);
            return _this;
        }
        _Pick_Billboard.prototype._onInvalidateElements = function (event) {
            this._billboardBoxDirty = true;
        };
        _Pick_Billboard.prototype.onClear = function (event) {
            this._asset.removeEventListener(RenderableEvent.INVALIDATE_ELEMENTS, this._onInvalidateElementsDelegate);
            _super.prototype.onClear.call(this, event);
        };
        _Pick_Billboard.prototype.hitTestPoint = function (x, y, z) {
            return true;
        };
        _Pick_Billboard.prototype.getBoxBounds = function (matrix3D, strokeFlag, cache, target) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (this._billboardBoxDirty) {
                this._billboardBoxDirty = false;
                var billboardRect = this._asset.billboardRect;
                this._billboardBox = new Box(billboardRect.x, billboardRect.y, 0, billboardRect.width, billboardRect.height, 0);
            }
            return (matrix3D ? matrix3D.transformBox(this._billboardBox) : this._billboardBox).union(target, target || cache);
        };
        _Pick_Billboard.prototype.getSphereBounds = function (center, matrix3D, strokeFlag, cache, target) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            //TODO
            return target;
        };
        _Pick_Billboard.prototype.testCollision = function (collision, closestFlag) {
            collision.pickable = null;
            //if (this._testGraphicCollision(<RenderableBase> this._renderablePool.getItem(billboard), pickingCollision, shortestCollisionDistance)) {
            //	shortestCollisionDistance = pickingCollision.rayEntryDistance;
            //
            //	pickingCollision.renderable = billboard;
            //
            //	return true;
            //}
            return false;
        };
        return _Pick_Billboard;
    }(_Pick_PickableBase));
    RenderEntity.registerRenderable(_Render_Billboard, Billboard);
    PickEntity.registerPickable(_Pick_Billboard, Billboard);
    PartitionBase.registerAbstraction(EntityNode, Billboard);

    /**
     * @class away.events.CameraEvent
     */
    var CameraEvent = /** @class */ (function (_super) {
        __extends$3(CameraEvent, _super);
        function CameraEvent(type, camera) {
            var _this = _super.call(this, type) || this;
            _this._camera = camera;
            return _this;
        }
        Object.defineProperty(CameraEvent.prototype, "camera", {
            get: function () {
                return this._camera;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the event.
         * @return An exact duplicate of the current object.
         */
        CameraEvent.prototype.clone = function () {
            return new CameraEvent(this.type, this._camera);
        };
        CameraEvent.PROJECTION_CHANGED = "projectionChanged";
        return CameraEvent;
    }(EventBase));

    var Camera = /** @class */ (function (_super) {
        __extends$3(Camera, _super);
        function Camera(projection) {
            if (projection === void 0) { projection = null; }
            var _this = _super.call(this) || this;
            _this._projection = projection || new PerspectiveProjection();
            _this._projection.transform = _this._transform;
            _this.z = -1000;
            return _this;
        }
        Camera.prototype.isEntity = function () {
            return true;
        };
        Object.defineProperty(Camera.prototype, "assetType", {
            //@override
            get: function () {
                return Camera.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Camera.prototype, "projection", {
            /**
             *
             */
            get: function () {
                return this._projection;
            },
            set: function (value) {
                if (this._projection == value)
                    return;
                if (!value)
                    throw new Error("Projection cannot be null!");
                this._projection.transform = null;
                this._projection = value;
                this._projection.transform = this._transform;
                this.dispatchEvent(new CameraEvent(CameraEvent.PROJECTION_CHANGED, this));
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Calculates the normalised position in screen space of the given scene position.
         *
         * @param point3d the position vector of the scene coordinates to be projected.
         * @return The normalised screen position of the given scene coordinates.
         */
        Camera.prototype.project = function (position, target) {
            if (target === void 0) { target = null; }
            return this._projection.project(this._transform.inverseConcatenatedMatrix3D.transformVector(position, target), target);
        };
        /**
         * Calculates the scene position of the given normalized coordinates in screen space.
         *
         * @param nX The normalised x coordinate in screen space, minus the originX offset of the projection property.
         * @param nY The normalised y coordinate in screen space, minus the originY offset of the projection property.
         * @param sZ The z coordinate in screen space, representing the distance into the screen.
         * @return The scene position of the given screen coordinates.
         */
        Camera.prototype.unproject = function (nX, nY, sZ, target) {
            if (target === void 0) { target = null; }
            return this._transform.concatenatedMatrix3D.transformVector(this._projection.unproject(nX, nY, sZ, target));
        };
        Camera.prototype._getDefaultBoundingVolume = function () {
            return BoundingVolumeType.NULL;
        };
        Camera.assetType = "[asset Camera]";
        return Camera;
    }(DisplayObjectContainer));
    /**
     * @class away.partition.CameraNode
     */
    var CameraNode = /** @class */ (function (_super) {
        __extends$3(CameraNode, _super);
        function CameraNode() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * @inheritDoc
         */
        CameraNode.prototype.acceptTraverser = function (traverser) {
            // todo: dead end for now, if it has a debug sprite, then sure accept that
        };
        return CameraNode;
    }(EntityNode));
    PartitionBase.registerAbstraction(CameraNode, Camera);

    /**
     * A Line Segment primitive.
     */
    var LineSegment = /** @class */ (function (_super) {
        __extends$3(LineSegment, _super);
        /**
         * Create a line segment
         *
         * @param startPosition Start position of the line segment
         * @param endPosition Ending position of the line segment
         * @param thickness Thickness of the line
         */
        function LineSegment(material, startPosition, endPosition, thickness) {
            if (thickness === void 0) { thickness = 1; }
            var _this = _super.call(this) || this;
            _this.material = material;
            _this._startPosition = startPosition;
            _this._endPosition = endPosition;
            _this._halfThickness = thickness * 0.5;
            return _this;
        }
        Object.defineProperty(LineSegment.prototype, "assetType", {
            /**
             *
             */
            get: function () {
                return LineSegment.assetType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineSegment.prototype, "startPosition", {
            /**
             *
             */
            get: function () {
                return this._startPosition;
            },
            set: function (value) {
                if (this._startPosition == value)
                    return;
                this._startPosition = value;
                this.invalidateElements();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineSegment.prototype, "endPosition", {
            /**
             *
             */
            get: function () {
                return this._endPosition;
            },
            set: function (value) {
                if (this._endPosition == value)
                    return;
                this._endPosition = value;
                this.invalidateElements();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LineSegment.prototype, "thickness", {
            /**
             *
             */
            get: function () {
                return this._halfThickness * 2;
            },
            set: function (value) {
                if (this._halfThickness == value)
                    return;
                this._halfThickness = value * 0.5;
                this.invalidateElements();
            },
            enumerable: true,
            configurable: true
        });
        LineSegment.prototype.isEntity = function () {
            return true;
        };
        LineSegment.prototype._acceptTraverser = function (traverser) {
            traverser.applyTraversable(this);
        };
        LineSegment.assetType = "[asset LineSegment]";
        return LineSegment;
    }(DisplayObject));
    /**
     * @class away.pool._Render_LineSegment
     */
    var _Render_LineSegment = /** @class */ (function (_super) {
        __extends$3(_Render_LineSegment, _super);
        function _Render_LineSegment() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * //TODO
         *
         * @returns {base.LineElements}
         * @protected
         */
        _Render_LineSegment.prototype._getStageElements = function () {
            var elements = _Render_LineSegment._lineGraphics[this._asset.id] || (_Render_LineSegment._lineGraphics[this._asset.id] = new LineElements());
            var start = this._asset.startPosition;
            var end = this._asset.endPosition;
            var positions = new Float32Array(6);
            var thickness = new Float32Array(1);
            positions[0] = start.x;
            positions[1] = start.y;
            positions[2] = start.z;
            positions[3] = end.x;
            positions[4] = end.y;
            positions[5] = end.z;
            thickness[0] = this._asset.thickness;
            elements.setPositions(positions);
            elements.setThickness(thickness);
            return this._stage.getAbstraction(elements);
        };
        _Render_LineSegment.prototype._getRenderMaterial = function () {
            return this.renderGroup.getRenderElements(this.stageElements.elements).getAbstraction(this._asset.material || MaterialUtils.getDefaultColorMaterial());
        };
        _Render_LineSegment.prototype._getStyle = function () {
            return this._asset.style;
        };
        _Render_LineSegment._lineGraphics = new Object();
        return _Render_LineSegment;
    }(_Render_RenderableBase));
    /**
     * @class away.pool._Render_Shape
     */
    var _Pick_LineSegment = /** @class */ (function (_super) {
        __extends$3(_Pick_LineSegment, _super);
        /**
         * //TODO
         *
         * @param renderEntity
         * @param shape
         * @param level
         * @param indexOffset
         */
        function _Pick_LineSegment(lineSegment, pickEntity) {
            var _this = _super.call(this, lineSegment, pickEntity) || this;
            _this._lineSegmentBoxDirty = true;
            _this._lineSegmentSphereDirty = true;
            _this._onInvalidateElementsDelegate = function (event) { return _this._onInvalidateElements(event); };
            _this._asset.addEventListener(RenderableEvent.INVALIDATE_ELEMENTS, _this._onInvalidateElementsDelegate);
            return _this;
        }
        _Pick_LineSegment.prototype._onInvalidateElements = function (event) {
            this._lineSegmentBoxDirty = true;
            this._lineSegmentSphereDirty = true;
        };
        _Pick_LineSegment.prototype.onClear = function (event) {
            this._asset.removeEventListener(RenderableEvent.INVALIDATE_ELEMENTS, this._onInvalidateElementsDelegate);
            _super.prototype.onClear.call(this, event);
        };
        _Pick_LineSegment.prototype.hitTestPoint = function (x, y, z) {
            return true;
        };
        _Pick_LineSegment.prototype.getBoxBounds = function (matrix3D, strokeFlag, cache, target) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (this._lineSegmentBoxDirty) {
                this._lineSegmentBoxDirty = false;
                var startPosition = this._asset.startPosition;
                var endPosition = this._asset.endPosition;
                this._lineSegmentBox = new Box(Math.min(startPosition.x, endPosition.x), Math.min(startPosition.y, endPosition.y), Math.min(startPosition.z, endPosition.z), Math.abs(startPosition.x - endPosition.x), Math.abs(startPosition.y - endPosition.y), Math.abs(startPosition.z - endPosition.z));
            }
            return (matrix3D ? matrix3D.transformBox(this._lineSegmentBox) : this._lineSegmentBox).union(target, target || cache);
        };
        _Pick_LineSegment.prototype.getSphereBounds = function (center, matrix3D, strokeFlag, cache, target) {
            if (matrix3D === void 0) { matrix3D = null; }
            if (strokeFlag === void 0) { strokeFlag = true; }
            if (cache === void 0) { cache = null; }
            if (target === void 0) { target = null; }
            if (this._lineSegmentSphereDirty) {
                this._lineSegmentSphereDirty = false;
                var startPosition = this._asset.startPosition;
                var endPosition = this._asset.endPosition;
                var halfWidth = (endPosition.x - startPosition.x) / 2;
                var halfHeight = (endPosition.y - startPosition.y) / 2;
                var halfDepth = (endPosition.z - startPosition.z) / 2;
                this._lineSegmentSphere = new Sphere(startPosition.x + halfWidth, startPosition.y + halfHeight, startPosition.z + halfDepth, Math.sqrt(halfWidth * halfWidth + halfHeight * halfHeight + halfDepth * halfDepth));
            }
            return (matrix3D ? matrix3D.transformSphere(this._lineSegmentSphere) : this._lineSegmentSphere).union(target, target || cache);
        };
        _Pick_LineSegment.prototype.testCollision = function (collision, closestFlag) {
            collision.pickable = null;
            //TODO
            return false;
        };
        return _Pick_LineSegment;
    }(_Pick_PickableBase));
    RenderEntity.registerRenderable(_Render_LineSegment, LineSegment);
    PickEntity.registerPickable(_Pick_LineSegment, LineSegment);
    PartitionBase.registerAbstraction(EntityNode, LineSegment);

    /**
     * The LoaderContainer class is used to load SWF files or image(JPG, PNG, or GIF)
     * files. Use the <code>load()</code> method to initiate loading. The loaded
     * display object is added as a child of the LoaderContainer object.
     *
     * <p>Use the URLLoader class to load text or binary data.</p>
     *
     * <p>The LoaderContainer class overrides the following methods that it inherits,
     * because a LoaderContainer object can only have one child display object - the
     * display object that it loads. Calling the following methods throws an
     * exception: <code>addChild()</code>, <code>addChildAt()</code>,
     * <code>removeChild()</code>, <code>removeChildAt()</code>, and
     * <code>setChildIndex()</code>. To remove a loaded display object, you must
     * remove the <i>LoaderContainer</i> object from its parent DisplayObjectContainer
     * child array. </p>
     *
     * <p><b>Note:</b> The ActionScript 2.0 MovieClipLoader and LoadVars classes
     * are not used in ActionScript 3.0. The LoaderContainer and URLLoader classes replace
     * them.</p>
     *
     * <p>When you use the LoaderContainer class, consider the Flash Player and Adobe AIR
     * security model: </p>
     *
     * <ul>
     *   <li>You can load content from any accessible source. </li>
     *   <li>Loading is not allowed if the calling SWF file is in a network
     * sandbox and the file to be loaded is local. </li>
     *   <li>If the loaded content is a SWF file written with ActionScript 3.0, it
     * cannot be cross-scripted by a SWF file in another security sandbox unless
     * that cross-scripting arrangement was approved through a call to the
     * <code>System.allowDomain()</code> or the
     * <code>System.allowInsecureDomain()</code> method in the loaded content
     * file.</li>
     *   <li>If the loaded content is an AVM1 SWF file(written using ActionScript
     * 1.0 or 2.0), it cannot be cross-scripted by an AVM2 SWF file(written using
     * ActionScript 3.0). However, you can communicate between the two SWF files
     * by using the LocalConnection class.</li>
     *   <li>If the loaded content is an image, its data cannot be accessed by a
     * SWF file outside of the security sandbox, unless the domain of that SWF
     * file was included in a URL policy file at the origin domain of the
     * image.</li>
     *   <li>Movie clips in the local-with-file-system sandbox cannot script movie
     * clips in the local-with-networking sandbox, and the reverse is also
     * prevented. </li>
     *   <li>You cannot connect to commonly reserved ports. For a complete list of
     * blocked ports, see "Restricting Networking APIs" in the <i>ActionScript 3.0
     * Developer's Guide</i>. </li>
     * </ul>
     *
     * <p>However, in AIR, content in the <code>application</code> security
     * sandbox(content installed with the AIR application) are not restricted by
     * these security limitations.</p>
     *
     * <p>For more information related to security, see the Flash Player Developer
     * Center Topic: <a href="http://www.adobe.com/go/devnet_security_en"
     * scope="external">Security</a>.</p>
     *
     * <p>When loading a SWF file from an untrusted source(such as a domain other
     * than that of the LoaderContainer object's root SWF file), you may want to define a
     * mask for the LoaderContainer object, to prevent the loaded content(which is a child
     * of the LoaderContainer object) from drawing to portions of the Stage outside of that
     * mask, as shown in the following code:</p>
     */
    var LoaderContainer = /** @class */ (function (_super) {
        __extends$3(LoaderContainer, _super);
        /**
         * Creates a Loader object that you can use to load files, such as SWF, JPEG,
         * GIF, or PNG files. Call the <code>load()</code> method to load the asset
         * as a child of the Loader instance. You can then add the Loader object to
         * the display list(for instance, by using the <code>addChild()</code>
         * method of a DisplayObjectContainer instance). The asset appears on the
         * Stage as it loads.
         *
         * <p>You can also use a Loader instance "offlist," that is without adding it
         * to a display object container on the display list. In this mode, the
         * Loader instance might be used to load a SWF file that contains additional
         * modules of an application. </p>
         *
         * <p>To detect when the SWF file is finished loading, you can use the events
         * of the LoaderInfo object associated with the
         * <code>contentLoaderInfo</code> property of the Loader object. At that
         * point, the code in the module SWF file can be executed to initialize and
         * start the module. In the offlist mode, a Loader instance might also be
         * used to load a SWF file that contains components or media assets. Again,
         * you can use the LoaderInfo object event notifications to detect when the
         * components are finished loading. At that point, the application can start
         * using the components and media assets in the library of the SWF file by
         * instantiating the ActionScript 3.0 classes that represent those components
         * and assets.</p>
         *
         * <p>To determine the status of a Loader object, monitor the following
         * events that the LoaderInfo object associated with the
         * <code>contentLoaderInfo</code> property of the Loader object:</p>
         *
         * <ul>
         *   <li>The <code>open</code> event is dispatched when loading begins.</li>
         *   <li>The <code>ioError</code> or <code>securityError</code> event is
         * dispatched if the file cannot be loaded or if an error occured during the
         * load process. </li>
         *   <li>The <code>progress</code> event fires continuously while the file is
         * being loaded.</li>
         *   <li>The <code>complete</code> event is dispatched when a file completes
         * downloading, but before the loaded movie clip's methods and properties are
         * available. </li>
         *   <li>The <code>init</code> event is dispatched after the properties and
         * methods of the loaded SWF file are accessible, so you can begin
         * manipulating the loaded SWF file. This event is dispatched before the
         * <code>complete</code> handler. In streaming SWF files, the
         * <code>init</code> event can occur significantly earlier than the
         * <code>complete</code> event. For most purposes, use the <code>init</code>
         * handler.</li>
         * </ul>
         */
        function LoaderContainer(useAssetLibrary, assetLibraryId) {
            if (useAssetLibrary === void 0) { useAssetLibrary = true; }
            if (assetLibraryId === void 0) { assetLibraryId = null; }
            var _this = _super.call(this) || this;
            _this._useAssetLib = useAssetLibrary;
            _this._assetLibId = assetLibraryId;
            _this._onAssetCompleteDelegate = function (event) { return _this.onAssetComplete(event); };
            _this._onTextureSizeErrorDelegate = function (event) { return _this.onTextureSizeError(event); };
            _this._onLoadCompleteDelegate = function (event) { return _this.onLoadComplete(event); };
            _this._onLoadErrorDelegate = function (event) { return _this.onLoadError(event); };
            _this._onParseErrorDelegate = function (event) { return _this.onParseError(event); };
            return _this;
        }
        Object.defineProperty(LoaderContainer.prototype, "content", {
            /**
             * Contains the root display object of the SWF file or image(JPG, PNG, or
             * GIF) file that was loaded by using the <code>load()</code> or
             * <code>loadBytes()</code> methods.
             *
             * @throws SecurityError The loaded SWF file or image file belongs to a
             *                       security sandbox to which you do not have access.
             *                       For a loaded SWF file, you can avoid this situation
             *                       by having the file call the
             *                       <code>Security.allowDomain()</code> method or by
             *                       having the loading file specify a
             *                       <code>loaderContext</code> parameter with its
             *                       <code>securityDomain</code> property set to
             *                       <code>SecurityDomain.currentDomain</code> when you
             *                       call the <code>load()</code> or
             *                       <code>loadBytes()</code> method.
             */
            get: function () {
                return this._content;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Cancels a <code>load()</code> method operation that is currently in
         * progress for the Loader instance.
         *
         */
        LoaderContainer.prototype.close = function () {
            if (!this._loader)
                return;
            if (this._useAssetLib) {
                var lib;
                lib = AssetLibraryBundle.getInstance(this._assetLibId);
                lib.disposeLoader(this._loader);
            }
            this._disposeLoader();
        };
        /**
         * Loads a SWF, JPEG, progressive JPEG, unanimated GIF, or PNG file into an
         * object that is a child of this Loader object. If you load an animated GIF
         * file, only the first frame is displayed. As the Loader object can contain
         * only a single child, issuing a subsequent <code>load()</code> request
         * terminates the previous request, if still pending, and commences a new
         * load.
         *
         * <p><b>Note</b>: In AIR 1.5 and Flash Player 10, the maximum size for a
         * loaded image is 8,191 pixels in width or height, and the total number of
         * pixels cannot exceed 16,777,215 pixels.(So, if an loaded image is 8,191
         * pixels wide, it can only be 2,048 pixels high.) In Flash Player 9 and
         * earlier and AIR 1.1 and earlier, the limitation is 2,880 pixels in height
         * and 2,880 pixels in width.</p>
         *
         * <p>A SWF file or image loaded into a Loader object inherits the position,
         * rotation, and scale properties of the parent display objects of the Loader
         * object. </p>
         *
         * <p>Use the <code>unload()</code> method to remove movies or images loaded
         * with this method, or to cancel a load operation that is in progress.</p>
         *
         * <p>You can prevent a SWF file from using this method by setting the
         * <code>allowNetworking</code> parameter of the the <code>object</code> and
         * <code>embed</code> tags in the HTML page that contains the SWF
         * content.</p>
         *
         * <p>When you use this method, consider the Flash Player security model,
         * which is described in the Loader class description. </p>
         *
         * <p> In Flash Player 10 and later, if you use a multipart Content-Type(for
         * example "multipart/form-data") that contains an upload(indicated by a
         * "filename" parameter in a "content-disposition" header within the POST
         * body), the POST operation is subject to the security rules applied to
         * uploads:</p>
         *
         * <ul>
         *   <li>The POST operation must be performed in response to a user-initiated
         * action, such as a mouse click or key press.</li>
         *   <li>If the POST operation is cross-domain(the POST target is not on the
         * same server as the SWF file that is sending the POST request), the target
         * server must provide a URL policy file that permits cross-domain
         * access.</li>
         * </ul>
         *
         * <p>Also, for any multipart Content-Type, the syntax must be valid
         * (according to the RFC2046 standard). If the syntax appears to be invalid,
         * the POST operation is subject to the security rules applied to
         * uploads.</p>
         *
         * <p>For more information related to security, see the Flash Player
         * Developer Center Topic: <a
         * href="http://www.adobe.com/go/devnet_security_en"
         * scope="external">Security</a>.</p>
         *
         * @param request The absolute or relative URL of the SWF, JPEG, GIF, or PNG
         *                file to be loaded. A relative path must be relative to the
         *                main SWF file. Absolute URLs must include the protocol
         *                reference, such as http:// or file:///. Filenames cannot
         *                include disk drive specifications.
         * @param context A LoaderContext object, which has properties that define
         *                the following:
         *                <ul>
         *                  <li>Whether or not to check for the existence of a policy
         *                file upon loading the object</li>
         *                  <li>The ApplicationDomain for the loaded object</li>
         *                  <li>The SecurityDomain for the loaded object</li>
         *                  <li>The ImageDecodingPolicy for the loaded image
         *                object</li>
         *                </ul>
         *
         *                <p>If the <code>context</code> parameter is not specified
         *                or refers to a null object, the loaded content remains in
         *                its own security domain.</p>
         *
         *                <p>For complete details, see the description of the
         *                properties in the <a
         *                href="../system/LoaderContext.html">LoaderContext</a>
         *                class.</p>
         * @param ns      An optional namespace string under which the file is to be
         *                loaded, allowing the differentiation of two resources with
         *                identical assets.
         * @param parser  An optional parser object for translating the loaded data
         *                into a usable resource. If not provided, Loader will
         *                attempt to auto-detect the file type.
         * @throws IOError               The <code>digest</code> property of the
         *                               <code>request</code> object is not
         *                               <code>null</code>. You should only set the
         *                               <code>digest</code> property of a URLRequest
         *                               object when calling the
         *                               <code>URLLoader.load()</code> method when
         *                               loading a SWZ file(an Adobe platform
         *                               component).
         * @throws IllegalOperationError If the <code>requestedContentParent</code>
         *                               property of the <code>context</code>
         *                               parameter is a <code>Loader</code>.
         * @throws IllegalOperationError If the <code>LoaderContext.parameters</code>
         *                               parameter is set to non-null and has some
         *                               values which are not Strings.
         * @throws SecurityError         The value of
         *                               <code>LoaderContext.securityDomain</code>
         *                               must be either <code>null</code> or
         *                               <code>SecurityDomain.currentDomain</code>.
         *                               This reflects the fact that you can only
         *                               place the loaded media in its natural
         *                               security sandbox or your own(the latter
         *                               requires a policy file).
         * @throws SecurityError         Local SWF files may not set
         *                               LoaderContext.securityDomain to anything
         *                               other than <code>null</code>. It is not
         *                               permitted to import non-local media into a
         *                               local sandbox, or to place other local media
         *                               in anything other than its natural sandbox.
         * @throws SecurityError         You cannot connect to commonly reserved
         *                               ports. For a complete list of blocked ports,
         *                               see "Restricting Networking APIs" in the
         *                               <i>ActionScript 3.0 Developer's Guide</i>.
         * @throws SecurityError         If the <code>applicationDomain</code> or
         *                               <code>securityDomain</code> properties of
         *                               the <code>context</code> parameter are from
         *                               a disallowed domain.
         * @throws SecurityError         If a local SWF file is attempting to use the
         *                               <code>securityDomain</code> property of the
         *                               <code>context</code> parameter.
         * @event asyncError    Dispatched by the <code>contentLoaderInfo</code>
         *                      object if the
         *                      <code>LoaderContext.requestedContentParent</code>
         *                      property has been specified and it is not possible to
         *                      add the loaded content as a child to the specified
         *                      DisplayObjectContainer. This could happen if the
         *                      loaded content is a
         *                      <code>flash.display.AVM1Movie</code> or if the
         *                      <code>addChild()</code> call to the
         *                      requestedContentParent throws an error.
         * @event complete      Dispatched by the <code>contentLoaderInfo</code>
         *                      object when the file has completed loading. The
         *                      <code>complete</code> event is always dispatched
         *                      after the <code>init</code> event.
         * @event httpStatus    Dispatched by the <code>contentLoaderInfo</code>
         *                      object when a network request is made over HTTP and
         *                      Flash Player can detect the HTTP status code.
         * @event init          Dispatched by the <code>contentLoaderInfo</code>
         *                      object when the properties and methods of the loaded
         *                      SWF file are accessible. The <code>init</code> event
         *                      always precedes the <code>complete</code> event.
         * @event ioError       Dispatched by the <code>contentLoaderInfo</code>
         *                      object when an input or output error occurs that
         *                      causes a load operation to fail.
         * @event open          Dispatched by the <code>contentLoaderInfo</code>
         *                      object when the loading operation starts.
         * @event progress      Dispatched by the <code>contentLoaderInfo</code>
         *                      object as data is received while load operation
         *                      progresses.
         * @event securityError Dispatched by the <code>contentLoaderInfo</code>
         *                      object if a SWF file in the local-with-filesystem
         *                      sandbox attempts to load content in the
         *                      local-with-networking sandbox, or vice versa.
         * @event securityError Dispatched by the <code>contentLoaderInfo</code>
         *                      object if the
         *                      <code>LoaderContext.requestedContentParent</code>
         *                      property has been specified and the security sandbox
         *                      of the
         *                      <code>LoaderContext.requestedContentParent</code>
         *                      does not have access to the loaded SWF.
         * @event unload        Dispatched by the <code>contentLoaderInfo</code>
         *                      object when a loaded object is removed.
         */
        LoaderContainer.prototype.load = function (request, context, ns, parser) {
            if (context === void 0) { context = null; }
            if (ns === void 0) { ns = null; }
            if (parser === void 0) { parser = null; }
            this._getLoader().load(request, context, ns, parser);
        };
        /**
         * Loads from binary data stored in a ByteArray object.
         *
         * <p>The <code>loadBytes()</code> method is asynchronous. You must wait for
         * the "init" event before accessing the properties of a loaded object.</p>
         *
         * <p>When you use this method, consider the Flash Player security model,
         * which is described in the Loader class description. </p>
         *
         * @param bytes   A ByteArray object. The contents of the ByteArray can be
         *                any of the file formats supported by the Loader class: SWF,
         *                GIF, JPEG, or PNG.
         * @param context A LoaderContext object. Only the
         *                <code>applicationDomain</code> property of the
         *                LoaderContext object applies; the
         *                <code>checkPolicyFile</code> and
         *                <code>securityDomain</code> properties of the LoaderContext
         *                object do not apply.
         *
         *                <p>If the <code>context</code> parameter is not specified
         *                or refers to a null object, the content is loaded into the
         *                current security domain -  a process referred to as "import
         *                loading" in Flash Player security documentation.
         *                Specifically, if the loading SWF file trusts the remote SWF
         *                by incorporating the remote SWF into its code, then the
         *                loading SWF can import it directly into its own security
         *                domain.</p>
         *
         *                <p>For more information related to security, see the Flash
         *                Player Developer Center Topic: <a
         *                href="http://www.adobe.com/go/devnet_security_en"
         *                scope="external">Security</a>.</p>
         * @throws ArgumentError         If the <code>length</code> property of the
         *                               ByteArray object is not greater than 0.
         * @throws IllegalOperationError If the <code>checkPolicyFile</code> or
         *                               <code>securityDomain</code> property of the
         *                               <code>context</code> parameter are non-null.
         * @throws IllegalOperationError If the <code>requestedContentParent</code>
         *                               property of the <code>context</code>
         *                               parameter is a <code>Loader</code>.
         * @throws IllegalOperationError If the <code>LoaderContext.parameters</code>
         *                               parameter is set to non-null and has some
         *                               values which are not Strings.
         * @throws SecurityError         If the provided
         *                               <code>applicationDomain</code> property of
         *                               the <code>context</code> property is from a
         *                               disallowed domain.
         * @throws SecurityError         You cannot connect to commonly reserved
         *                               ports. For a complete list of blocked ports,
         *                               see "Restricting Networking APIs" in the
         *                               <i>ActionScript 3.0 Developer's Guide</i>.
         * @event asyncError    Dispatched by the <code>contentLoaderInfo</code>
         *                      object if the
         *                      <code>LoaderContext.requestedContentParent</code>
         *                      property has been specified and it is not possible to
         *                      add the loaded content as a child to the specified
         *                      DisplayObjectContainer. This could happen if the
         *                      loaded content is a
         *                      <code>flash.display.AVM1Movie</code> or if the
         *                      <code>addChild()</code> call to the
         *                      requestedContentParent throws an error.
         * @event complete      Dispatched by the <code>contentLoaderInfo</code>
         *                      object when the operation is complete. The
         *                      <code>complete</code> event is always dispatched
         *                      after the <code>init</code> event.
         * @event init          Dispatched by the <code>contentLoaderInfo</code>
         *                      object when the properties and methods of the loaded
         *                      data are accessible. The <code>init</code> event
         *                      always precedes the <code>complete</code> event.
         * @event ioError       Dispatched by the <code>contentLoaderInfo</code>
         *                      object when the runtime cannot parse the data in the
         *                      byte array.
         * @event open          Dispatched by the <code>contentLoaderInfo</code>
         *                      object when the operation starts.
         * @event progress      Dispatched by the <code>contentLoaderInfo</code>
         *                      object as data is transfered in memory.
         * @event securityError Dispatched by the <code>contentLoaderInfo</code>
         *                      object if the
         *                      <code>LoaderContext.requestedContentParent</code>
         *                      property has been specified and the security sandbox
         *                      of the
         *                      <code>LoaderContext.requestedContentParent</code>
         *                      does not have access to the loaded SWF.
         * @event unload        Dispatched by the <code>contentLoaderInfo</code>
         *                      object when a loaded object is removed.
         */
        LoaderContainer.prototype.loadData = function (data, context, ns, parser) {
            if (context === void 0) { context = null; }
            if (ns === void 0) { ns = null; }
            if (parser === void 0) { parser = null; }
            this._getLoader().loadData(data, '', context, ns, parser);
        };
        LoaderContainer.prototype._getLoader = function () {
            if (this._useAssetLib) {
                var lib = AssetLibraryBundle.getInstance(this._assetLibId);
                this._loader = lib.getLoader();
            }
            else {
                this._loader = new Loader();
            }
            this._loader.addEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoadCompleteDelegate);
            this._loader.addEventListener(AssetEvent.TEXTURE_SIZE_ERROR, this._onTextureSizeErrorDelegate);
            this._loader.addEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            // Error are handled separately (see documentation for addErrorHandler)
            this._loader._iAddErrorHandler(this._onLoadErrorDelegate);
            this._loader._iAddParseErrorHandler(this._onParseErrorDelegate);
            return this._loader;
        };
        LoaderContainer.prototype._disposeLoader = function () {
            this._loader.removeEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoadCompleteDelegate);
            this._loader.removeEventListener(AssetEvent.TEXTURE_SIZE_ERROR, this._onTextureSizeErrorDelegate);
            this._loader.removeEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            if (!this._useAssetLib)
                this._loader.stop();
            this._loader = null;
        };
        /**
         * Removes a child of this Loader object that was loaded by using the
         * <code>load()</code> method. The <code>property</code> of the associated
         * LoaderInfo object is reset to <code>null</code>. The child is not
         * necessarily destroyed because other objects might have references to it;
         * however, it is no longer a child of the Loader object.
         *
         * <p>As a best practice, before you unload a child SWF file, you should
         * explicitly close any streams in the child SWF file's objects, such as
         * LocalConnection, NetConnection, NetStream, and Sound objects. Otherwise,
         * audio in the child SWF file might continue to play, even though the child
         * SWF file was unloaded. To close streams in the child SWF file, add an
         * event listener to the child that listens for the <code>unload</code>
         * event. When the parent calls <code>Loader.unload()</code>, the
         * <code>unload</code> event is dispatched to the child. The following code
         * shows how you might do this:</p>
         * <pre xml:space="preserve"> public closeAllStreams(evt:Event) {
         * myNetStream.close(); mySound.close(); myNetConnection.close();
         * myLocalConnection.close(); }
         * myMovieClip.loaderInfo.addEventListener(Event.UNLOAD,
         * closeAllStreams);</pre>
         *
         */
        LoaderContainer.prototype.unload = function () {
            //TODO
        };
        /**
         * Enables a specific parser.
         * When no specific parser is set for a loading/parsing opperation,
         * loader3d can autoselect the correct parser to use.
         * A parser must have been enabled, to be considered when autoselecting the parser.
         *
         * @param parserClass The parser class to enable.
         * @see away.parsers.Parsers
         */
        LoaderContainer.enableParser = function (parserClass) {
            Loader.enableParser(parserClass);
        };
        /**
         * Enables a list of parsers.
         * When no specific parser is set for a loading/parsing opperation,
         * loader3d can autoselect the correct parser to use.
         * A parser must have been enabled, to be considered when autoselecting the parser.
         *
         * @param parserClasses A Vector of parser classes to enable.
         * @see away.parsers.Parsers
         */
        LoaderContainer.enableParsers = function (parserClasses) {
            Loader.enableParsers(parserClasses);
        };
        LoaderContainer.prototype.onAssetComplete = function (event) {
            this.dispatchEvent(event);
        };
        /**
         * Called when an error occurs during loading
         */
        LoaderContainer.prototype.onLoadError = function (event) {
            if (this.hasEventListener(URLLoaderEvent.LOAD_ERROR)) {
                this.dispatchEvent(event);
                return true;
            }
            else {
                return false;
            }
        };
        /**
         * Called when a an error occurs during parsing
         */
        LoaderContainer.prototype.onParseError = function (event) {
            if (this.hasEventListener(ParserEvent.PARSE_ERROR)) {
                this.dispatchEvent(event);
                return true;
            }
            else {
                return false;
            }
        };
        LoaderContainer.prototype.onTextureSizeError = function (event) {
            this.dispatchEvent(event);
        };
        /**
         * Called when the resource and all of its dependencies was retrieved.
         */
        LoaderContainer.prototype.onLoadComplete = function (event) {
            this._content = event.content;
            if (this._content)
                this.addChild(this._content);
            this.dispatchEvent(event);
            this._disposeLoader();
        };
        return LoaderContainer;
    }(DisplayObjectContainer));

    //import {SoundTransform} from "../media/SoundTransform";
    /**
     * The SimpleButton class lets you control all instances of button symbols in a SWF
     * file.
     *
     *   <p class="- topic/p ">In Flash Professional, you can give a button an instance name in the
     * Property inspector. SimpleButton instance names are displayed in the Movie
     * Explorer and in the Insert Target Path dialog box in the Actions
     * panel. After you create an instance of a button in Flash Professional, you can
     * use the methods and properties of the SimpleButton class to manipulate buttons
     * with ActionScript.</p><p class="- topic/p ">In ActionScript 3.0, you use the <codeph class="+ topic/ph pr-d/codeph ">new SimpleButton()</codeph> constructor to create a
     * SimpleButton instance.</p><p class="- topic/p ">The SimpleButton class inherits from the InteractiveObject class.</p>
     *
     *   EXAMPLE:
     *
     *   The following example uses the SimpleButtonExample class, which in
     * turn uses the CustomSimpleButton class, and this class then instantiates four
     * ButtonDisplayState objects.  The result is a button that is created in the shape of
     * a square, whose background color changes based on the mouse state by overriding instance properties of
     * the SimpleButton class.  This is accomplished by performing the following steps:
     * <ol class="- topic/ol "><li class="- topic/li ">In the <codeph class="+ topic/ph pr-d/codeph ">SimpleButtonExample()</codeph> constructor, a new CustomSimpleButton object of type
     * SimpleButton, called <codeph class="+ topic/ph pr-d/codeph ">button</codeph>, is created, which calls the <codeph class="+ topic/ph pr-d/codeph ">CustomSimpleButton</codeph> constructor
     * method.  The <codeph class="+ topic/ph pr-d/codeph ">button</codeph> object is the added to the display list.  The button's color and size are
     * determined in the steps that follow.</li><li class="- topic/li ">In the CustomSimpleButton class, instance properties are declared that are later used
     * to control the size and background color of <codeph class="+ topic/ph pr-d/codeph ">button</codeph>, based on the state it is in (orange
     * in the normal state, dark yellow in the mouse over state, an light blue in the mouse down state).
     * In all of the <codeph class="+ topic/ph pr-d/codeph ">button</codeph>'s states, the size of the square is set to 80 pixels by using the
     * <codeph class="+ topic/ph pr-d/codeph ">size</codeph> property.</li><li class="- topic/li ">The constructor function for the CustomSimpleButton class sets the
     * <codeph class="+ topic/ph pr-d/codeph ">downState</codeph>, <codeph class="+ topic/ph pr-d/codeph ">overState</codeph>, <codeph class="+ topic/ph pr-d/codeph ">upState</codeph>,
     * <codeph class="+ topic/ph pr-d/codeph ">hitTestState</codeph>, and <codeph class="+ topic/ph pr-d/codeph ">useHandCursor</codeph> properties with
     * four instances of the ButtonDisplayState class.</li><li class="- topic/li ">In the ButtonDisplayState class, the constructor sets the value of the
     * square's size and background color and calls the <codeph class="+ topic/ph pr-d/codeph ">draw()</codeph> method.</li><li class="- topic/li ">The <codeph class="+ topic/ph pr-d/codeph ">draw()</codeph> method redraws the square with the size and background color set in
     * the constructor based on the button's state.</li></ol><codeblock xml:space="preserve" class="+ topic/pre pr-d/codeblock ">

     */
    var SimpleButton = /** @class */ (function (_super) {
        __extends$3(SimpleButton, _super);
        /**
         * Creates a new SimpleButton instance. Any or all of the display objects that represent
         * the various button states can be set as parameters in the constructor.
         * @param	upState	The initial value for the SimpleButton up state.
         * @param	overState	The initial value for the SimpleButton over state.
         * @param	downState	The initial value for the SimpleButton down state.
         * @param	hitTestState	The initial value for the SimpleButton hitTest state.
         */
        function SimpleButton(upState, overState, downState, hitTestState) {
            if (upState === void 0) { upState = null; }
            if (overState === void 0) { overState = null; }
            if (downState === void 0) { downState = null; }
            if (hitTestState === void 0) { hitTestState = null; }
            return _super.call(this) || this;
        }
        Object.defineProperty(SimpleButton.prototype, "downState", {
            /**
             * Specifies a display object that is used as the visual
             * object for the button "Down" state —the state that the button is in when the user
             * selects the hitTestState object.
             */
            get: function () {
                return this._downState;
            },
            set: function (value) {
                this._downState = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton.prototype, "enabled", {
            /**
             * A Boolean value that specifies whether a button is enabled. When a
             * button is disabled (the enabled property is set to false),
             * the button is visible but cannot be clicked. The default value is
             * true. This property is useful if you want to
             * disable part of your navigation; for example, you might want to disable a
             * button in the currently displayed page so that it can't be clicked and
             * the page cannot be reloaded.
             *
             *   Note: To prevent mouseClicks on a button, set both the enabled
             * and mouseEnabled properties to false.
             */
            get: function () {
                return this._enabled;
            },
            set: function (value) {
                this.enabled = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton.prototype, "hitTestState", {
            /**
             * Specifies a display object that is used as the hit testing object for the button. For a basic button, set the
             * hitTestState property to the same display object as the overState
             * property. If you do not set the hitTestState property, the SimpleButton
             * is inactive — it does not respond to user input events.
             */
            get: function () {
                return this._hitTestState;
            },
            set: function (value) {
                this._hitTestState = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton.prototype, "overState", {
            /**
             * Specifies a display object that is used as the visual
             * object for the button over state — the state that the button is in when
             * the pointer is positioned over the button.
             */
            get: function () {
                return this._overState;
            },
            set: function (value) {
                this._overState = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton.prototype, "soundTransform", {
            /**
             * The SoundTransform object assigned to this button. A SoundTransform object
             * includes properties for setting volume, panning, left speaker assignment, and right
             * speaker assignment. This SoundTransform object applies to all states of the button.
             * This SoundTransform object affects only embedded sounds.
             * @internal	Should information from AS2 setTransform be here? e.g. percentage values indicating
             *   how much of the left input to play in the left speaker or right speaker; it is generally
             *   best to use 22-KHZ 6-bit mono sounds?
             */
            get: function () {
                console.log("soundTransform not implemented yet in flash/SimpleButton");
                return null;
            },
            set: function (sndTransform) {
                console.log("soundTransform not implemented yet in flash/SimpleButton");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton.prototype, "trackAsMenu", {
            /**
             * Indicates whether other display objects that are SimpleButton or MovieClip objects can receive
             * user input release events. The trackAsMenu property lets you create menus. You
             * can set the trackAsMenu property on any SimpleButton or MovieClip object.
             * If the trackAsMenu property does not exist, the default behavior is
             * false.
             *
             *   You can change the trackAsMenu property at any time; the
             * modified button immediately takes on the new behavior.
             */
            get: function () {
                console.log("trackAsMenu not implemented yet in flash/SimpleButton");
                return false;
            },
            set: function (value) {
                console.log("trackAsMenu not implemented yet in flash/SimpleButton");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton.prototype, "upState", {
            /**
             * Specifies a display object that is used as the visual
             * object for the button up state — the state that the button is in when
             * the pointer is not positioned over the button.
             */
            get: function () {
                return this._upState;
            },
            set: function (value) {
                this._upState = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton.prototype, "useHandCursor", {
            /**
             * A Boolean value that, when set to true, indicates whether
             * the hand cursor is shown when the pointer rolls over a button.
             * If this property is set to false, the arrow pointer cursor is displayed
             * instead. The default is true.
             *
             *   You can change the useHandCursor property at any time;
             * the modified button immediately uses the new cursor behavior.
             * @maelexample	Create two buttons on the Stage with the instance names <code>myBtn1_btn</code> and <code>myBtn2_btn</code>. Enter the following ActionScript in Frame 1 of the Timeline:
             *   <listing>
             *   myBtn1_btn.useHandCursor = false;
             *   myBtn1_btn.onRelease = buttonClick;
             *   myBtn2_btn.onRelease = buttonClick;
             *   function buttonClick() {
                 *   trace(this._name);
                 *   }
             *   </listing><p class="- topic/p ">When the mouse is over and clicks <code>myBtn1_btn</code>, there is no pointing hand. However, you see the pointing hand when the button is over and clicks <code>myBtn2_btn</code>.</p>
             */
            get: function () {
                console.log("useHandCursor not implemented yet in flash/SimpleButton");
                return false;
            },
            set: function (value) {
                console.log("useHandCursor not implemented yet in flash/SimpleButton");
            },
            enumerable: true,
            configurable: true
        });
        return SimpleButton;
    }(Sprite));

    /**
     * @class away.base.TriangleElements
     */
    var SkyboxElements = /** @class */ (function (_super) {
        __extends$3(SkyboxElements, _super);
        function SkyboxElements() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(SkyboxElements.prototype, "assetType", {
            get: function () {
                return SkyboxElements.assetType;
            },
            enumerable: true,
            configurable: true
        });
        SkyboxElements.assetType = "[asset SkyboxElements]";
        return SkyboxElements;
    }(TriangleElements));
    /**
     * @class away.pool.LineMaterialPool
     */
    var _Render_SkyboxElements = /** @class */ (function (_super) {
        __extends$3(_Render_SkyboxElements, _super);
        function _Render_SkyboxElements() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        _Render_SkyboxElements.prototype._includeDependencies = function (shader) {
        };
        /**
         * @inheritDoc
         */
        _Render_SkyboxElements.prototype._getVertexCode = function (shader, registerCache, sharedRegisters) {
            var code = "";
            //get the projection coordinates
            var position = (shader.globalPosDependencies > 0) ? sharedRegisters.globalPositionVertex : sharedRegisters.animatedPosition;
            //reserving vertex constants for projection matrix
            var viewMatrixReg = registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            registerCache.getFreeVertexConstant();
            shader.viewMatrixIndex = viewMatrixReg.index * 4;
            var scenePosition = registerCache.getFreeVertexConstant();
            shader.scenePositionIndex = scenePosition.index * 4;
            var skyboxScale = registerCache.getFreeVertexConstant();
            var temp = registerCache.getFreeVertexVectorTemp();
            code += "mul " + temp + ", " + position + ", " + skyboxScale + "\n" +
                "add " + temp + ", " + temp + ", " + scenePosition + "\n";
            if (shader.projectionDependencies > 0) {
                sharedRegisters.projectionFragment = registerCache.getFreeVarying();
                code += "m44 " + temp + ", " + temp + ", " + viewMatrixReg + "\n" +
                    "mov " + sharedRegisters.projectionFragment + ", " + temp + "\n" +
                    "mov op, " + temp + "\n";
            }
            else {
                code += "m44 op, " + temp + ", " + viewMatrixReg + "\n";
            }
            return code;
        };
        _Render_SkyboxElements.prototype._getFragmentCode = function (shader, registerCache, sharedRegisters) {
            return "";
        };
        return _Render_SkyboxElements;
    }(_Render_ElementsBase));
    /**
     *
     * @class away.pool._Stage_SkyboxElements
     */
    var _Stage_SkyboxElements = /** @class */ (function (_super) {
        __extends$3(_Stage_SkyboxElements, _super);
        function _Stage_SkyboxElements() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._skyboxProjection = new Matrix3D();
            return _this;
        }
        _Stage_SkyboxElements.prototype.draw = function (renderable, shader, view, count, offset) {
            var index = shader.scenePositionIndex;
            var camPos = view.projection.transform.concatenatedMatrix3D.position;
            shader.vertexConstantData[index++] = 2 * camPos.x;
            shader.vertexConstantData[index++] = 2 * camPos.y;
            shader.vertexConstantData[index++] = 2 * camPos.z;
            shader.vertexConstantData[index++] = 1;
            shader.vertexConstantData[index++] = shader.vertexConstantData[index++] = shader.vertexConstantData[index++] = view.projection.far / Math.sqrt(3);
            shader.vertexConstantData[index] = 1;
            var near = new Vector3D();
            this._skyboxProjection.copyFrom(view.viewMatrix3D);
            this._skyboxProjection.copyRowTo(2, near);
            var cx = near.x;
            var cy = near.y;
            var cz = near.z;
            var cw = -(near.x * camPos.x + near.y * camPos.y + near.z * camPos.z + Math.sqrt(cx * cx + cy * cy + cz * cz));
            var signX = cx >= 0 ? 1 : -1;
            var signY = cy >= 0 ? 1 : -1;
            var p = new Vector3D(signX, signY, 1, 1);
            var inverse = this._skyboxProjection.clone();
            inverse.invert();
            var q = inverse.transformVector(p);
            this._skyboxProjection.copyRowTo(3, p);
            var a = (q.x * p.x + q.y * p.y + q.z * p.z + q.w * p.w) / (cx * q.x + cy * q.y + cz * q.z + cw * q.w);
            this._skyboxProjection.copyRowFrom(2, new Vector3D(cx * a, cy * a, cz * a, cw * a));
            //set constants
            if (shader.sceneMatrixIndex >= 0)
                shader.sceneMatrix.copyFrom(renderable.renderSceneTransform, true);
            shader.viewMatrix.copyFrom(this._skyboxProjection, true);
            var context = this._stage.context;
            context.setProgramConstantsFromArray(ContextGLProgramType.VERTEX, shader.vertexConstantData);
            context.setProgramConstantsFromArray(ContextGLProgramType.FRAGMENT, shader.fragmentConstantData);
            if (this._indices)
                this.getIndexBufferGL().draw(ContextGLDrawMode.TRIANGLES, 0, this.numIndices);
            else
                this._stage.context.drawVertices(ContextGLDrawMode.TRIANGLES, offset, count || this.numVertices);
        };
        return _Stage_SkyboxElements;
    }(_Stage_TriangleElements));
    RenderGroup.registerElements(_Render_SkyboxElements, SkyboxElements);
    Stage.registerAbstraction(_Stage_SkyboxElements, SkyboxElements);

    /**
     * A Skybox class is used to render a sky in the scene. It's always considered static and 'at infinity', and as
     * such it's always centered at the camera's position and sized to exactly fit within the camera's frustum, ensuring
     * the sky box is always as large as possible without being clipped.
     */
    var Skybox = /** @class */ (function (_super) {
        __extends$3(Skybox, _super);
        function Skybox(imageColor, alpha) {
            if (imageColor === void 0) { imageColor = 0xFFFFFF; }
            if (alpha === void 0) { alpha = 1; }
            var _this = _super.call(this) || this;
            _this._textures = new Array();
            _this._pBlendMode = BlendMode.NORMAL;
            _this.animateUVs = false;
            _this.bothSides = false;
            _this.curves = false;
            _this.imageRect = false;
            _this._onTextureInvalidateDelegate = function (event) { return _this.onTextureInvalidate(event); };
            _this._owners = [_this];
            _this.style = new Style();
            if (imageColor instanceof ImageCube) {
                _this._style.image = imageColor;
                _this.texture = new ImageTextureCube();
            }
            else {
                _this._style.color = Number(imageColor);
            }
            return _this;
        }
        Object.defineProperty(Skybox.prototype, "animationSet", {
            /**
             *
             */
            get: function () {
                return this._animationSet;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Skybox.prototype, "blendMode", {
            /**
             * The blend mode to use when drawing this renderable. The following blend modes are supported:
             * <ul>
             * <li>BlendMode.NORMAL: No blending, unless the material inherently needs it</li>
             * <li>BlendMode.LAYER: Force blending. This will draw the object the same as NORMAL, but without writing depth writes.</li>
             * <li>BlendMode.MULTIPLY</li>
             * <li>BlendMode.ADD</li>
             * <li>BlendMode.ALPHA</li>
             * </ul>
             */
            get: function () {
                return this._pBlendMode;
            },
            set: function (value) {
                if (this._pBlendMode == value)
                    return;
                this._pBlendMode = value;
                this.invalidate();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Skybox.prototype, "iOwners", {
            /**
             * A list of the IRenderables that use this material
             *
             * @private
             */
            get: function () {
                return this._owners;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Skybox.prototype, "texture", {
            /**
            * The cube texture to use as the skybox.
            */
            get: function () {
                return this._texture;
            },
            set: function (value) {
                if (this._texture == value)
                    return;
                if (this._texture)
                    this.removeTexture(this._texture);
                this._texture = value;
                if (this._texture)
                    this.addTexture(this._texture);
                this.invalidatePasses();
            },
            enumerable: true,
            configurable: true
        });
        Skybox.prototype.getNumTextures = function () {
            return this._textures.length;
        };
        Skybox.prototype.getTextureAt = function (index) {
            return this._textures[index];
        };
        Skybox.prototype.isEntity = function () {
            return true;
        };
        Object.defineProperty(Skybox.prototype, "assetType", {
            get: function () {
                return Skybox.assetType;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Marks the shader programs for all passes as invalid, so they will be recompiled before the next use.
         *
         * @private
         */
        Skybox.prototype.invalidatePasses = function () {
            this.dispatchEvent(new MaterialEvent(MaterialEvent.INVALIDATE_PASSES, this));
        };
        Skybox.prototype.invalidateElements = function () {
            this.dispatchEvent(new RenderableEvent(RenderableEvent.INVALIDATE_ELEMENTS, this));
        };
        Skybox.prototype.invalidateMaterial = function () {
            this.dispatchEvent(new RenderableEvent(RenderableEvent.INVALIDATE_MATERIAL, this));
        };
        Skybox.prototype.invalidateStyle = function () {
            this.dispatchEvent(new RenderableEvent(RenderableEvent.INVALIDATE_STYLE, this));
        };
        Skybox.prototype.addTexture = function (texture) {
            this._textures.push(texture);
            texture.addEventListener(AssetEvent.INVALIDATE, this._onTextureInvalidateDelegate);
            this.onTextureInvalidate();
        };
        Skybox.prototype.removeTexture = function (texture) {
            this._textures.splice(this._textures.indexOf(texture), 1);
            texture.removeEventListener(AssetEvent.INVALIDATE, this._onTextureInvalidateDelegate);
            this.onTextureInvalidate();
        };
        Skybox.prototype.onTextureInvalidate = function (event) {
            if (event === void 0) { event = null; }
            this.invalidate();
        };
        Skybox.prototype._onInvalidateProperties = function (event) {
            this.invalidateMaterial();
            this.invalidatePasses();
        };
        Skybox.prototype._acceptTraverser = function (traverser) {
            traverser.applyTraversable(this);
        };
        Skybox.prototype.iAddOwner = function (owner) {
        };
        /**
         * Removes an IEntity as owner.
         * @param owner
         *
         * @internal
         */
        Skybox.prototype.iRemoveOwner = function (owner) {
        };
        Skybox.prototype._getDefaultBoundingVolume = function () {
            return BoundingVolumeType.NULL;
        };
        Skybox.prototype.testCollision = function (collision, closestFlag) {
            collision.pickable = null;
            return false;
        };
        Skybox.assetType = "[asset Skybox]";
        return Skybox;
    }(DisplayObject));
    /**
     * _Render_SkyboxMaterial forms an abstract base class for the default shaded materials provided by Stage,
     * using material methods to define their appearance.
     */
    var _Render_SkyboxMaterial = /** @class */ (function (_super) {
        __extends$3(_Render_SkyboxMaterial, _super);
        function _Render_SkyboxMaterial(skybox, renderElements) {
            var _this = _super.call(this, skybox, renderElements) || this;
            _this._skybox = skybox;
            _this._shader = new ShaderBase(renderElements, _this, _this, _this._stage);
            _this._texture = _this._shader.getAbstraction(_this._skybox.texture);
            _this._pAddPass(_this);
            return _this;
        }
        _Render_SkyboxMaterial.prototype.onClear = function (event) {
            _super.prototype.onClear.call(this, event);
            this._texture.onClear(new AssetEvent(AssetEvent.CLEAR, this._skybox.texture));
            this._texture = null;
            this._skybox = null;
        };
        /**
         * @inheritDoc
         */
        _Render_SkyboxMaterial.prototype._pUpdateRender = function () {
            _super.prototype._pUpdateRender.call(this);
            this.requiresBlending = (this._material.blendMode != BlendMode.NORMAL);
            this.shader.setBlendMode((this._material.blendMode == BlendMode.NORMAL && this.requiresBlending) ? BlendMode.LAYER : this._material.blendMode);
        };
        _Render_SkyboxMaterial.prototype._includeDependencies = function (shader) {
            _super.prototype._includeDependencies.call(this, shader);
            shader.usesPositionFragment = true;
        };
        /**
         * @inheritDoc
         */
        _Render_SkyboxMaterial.prototype._getFragmentCode = function (registerCache, sharedRegisters) {
            return this._texture._getFragmentCode(sharedRegisters.shadedTarget, registerCache, sharedRegisters, sharedRegisters.positionVarying);
        };
        _Render_SkyboxMaterial.prototype._setRenderState = function (renderable, view) {
            _super.prototype._setRenderState.call(this, renderable, view);
            this._texture._setRenderState(renderable);
        };
        /**
         * @inheritDoc
         */
        _Render_SkyboxMaterial.prototype._activate = function (view) {
            _super.prototype._activate.call(this, view);
            this._stage.context.setDepthTest(false, ContextGLCompareMode.LESS);
            this._texture.activate();
        };
        return _Render_SkyboxMaterial;
    }(_Render_MaterialPassBase));
    /**
     * @class away.pool._Render_Skybox
     */
    var _Render_Skybox = /** @class */ (function (_super) {
        __extends$3(_Render_Skybox, _super);
        function _Render_Skybox() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         * //TODO
         *
         * @returns {away.base.TriangleElements}
         * @private
         */
        _Render_Skybox.prototype._getStageElements = function () {
            var elements = _Render_Skybox._elements;
            if (!elements) {
                elements = new SkyboxElements(new AttributesBuffer(11, 4));
                elements.autoDeriveNormals = false;
                elements.autoDeriveTangents = false;
                elements.setIndices(Array(0, 1, 2, 2, 3, 0, 6, 5, 4, 4, 7, 6, 2, 6, 7, 7, 3, 2, 4, 5, 1, 1, 0, 4, 4, 0, 3, 3, 7, 4, 2, 1, 5, 5, 6, 2));
                elements.setPositions(Array(-1, 1, -1, 1, 1, -1, 1, 1, 1, -1, 1, 1, -1, -1, -1, 1, -1, -1, 1, -1, 1, -1, -1, 1));
            }
            return this._stage.getAbstraction(elements);
        };
        _Render_Skybox.prototype._getRenderMaterial = function () {
            return this.renderGroup.getRenderElements(this.stageElements.elements).getAbstraction(this._asset);
        };
        _Render_Skybox.prototype._getStyle = function () {
            return this._asset.style;
        };
        return _Render_Skybox;
    }(_Render_RenderableBase));
    /**
     * SkyboxNode is a space partitioning leaf node that contains a Skybox object.
     *
     * @class away.partition.SkyboxNode
     */
    var SkyboxNode = /** @class */ (function (_super) {
        __extends$3(SkyboxNode, _super);
        function SkyboxNode() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        /**
         *
         * @param planes
         * @param numPlanes
         * @returns {boolean}
         */
        SkyboxNode.prototype.isInFrustum = function (planes, numPlanes) {
            if (!this.isVisible())
                return false;
            //a skybox is always in view unless its visibility is set to false
            return true;
        };
        /**
         *
         * @returns {boolean}
         */
        SkyboxNode.prototype.isCastingShadow = function () {
            return false; //skybox never casts shadows
        };
        return SkyboxNode;
    }(EntityNode));
    RenderGroup.registerDefaultMaterial(_Render_SkyboxMaterial, Skybox);
    RenderEntity.registerRenderable(_Render_Skybox, Skybox);
    PartitionBase.registerAbstraction(SkyboxNode, Skybox);

    var CastError = /** @class */ (function (_super) {
        __extends$3(CastError, _super);
        function CastError(message) {
            return _super.call(this, message) || this;
        }
        return CastError;
    }(ErrorBase));

    var ResizeEvent = /** @class */ (function (_super) {
        __extends$3(ResizeEvent, _super);
        function ResizeEvent(type, oldHeight, oldWidth) {
            if (oldHeight === void 0) { oldHeight = NaN; }
            if (oldWidth === void 0) { oldWidth = NaN; }
            var _this = _super.call(this, type) || this;
            _this._oldHeight = oldHeight;
            _this._oldWidth = oldWidth;
            return _this;
        }
        Object.defineProperty(ResizeEvent.prototype, "oldHeight", {
            get: function () {
                return this._oldHeight;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ResizeEvent.prototype, "oldWidth", {
            get: function () {
                return this._oldWidth;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Clones the event.
         *
         * @return An exact duplicate of the current object.
         */
        ResizeEvent.prototype.clone = function () {
            return new ResizeEvent(this.type, this._oldHeight, this._oldWidth);
        };
        ResizeEvent.RESIZE = "resize";
        return ResizeEvent;
    }(EventBase));

    var DefaultSceneGraphFactory = /** @class */ (function (_super) {
        __extends$3(DefaultSceneGraphFactory, _super);
        function DefaultSceneGraphFactory() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        DefaultSceneGraphFactory.prototype.createMovieClip = function (timeline, symbol) {
            if (timeline === void 0) { timeline = null; }
            if (symbol === void 0) { symbol = null; }
            return new MovieClip(timeline);
        };
        DefaultSceneGraphFactory.prototype.createSprite = function (prefab, graphics, symbol) {
            if (prefab === void 0) { prefab = null; }
            if (graphics === void 0) { graphics = null; }
            if (symbol === void 0) { symbol = null; }
            if (prefab)
                return prefab.getNewObject();
            return new Sprite();
        };
        DefaultSceneGraphFactory.prototype.createDisplayObjectContainer = function (symbol) {
            if (symbol === void 0) { symbol = null; }
            return new DisplayObjectContainer();
        };
        DefaultSceneGraphFactory.prototype.createTextField = function (symbol) {
            if (symbol === void 0) { symbol = null; }
            return new TextField();
        };
        DefaultSceneGraphFactory.prototype.createBillboard = function (material, symbol) {
            if (symbol === void 0) { symbol = null; }
            return new Billboard(material);
        };
        DefaultSceneGraphFactory.prototype.createMaterial = function (imageColor, alpha, symbol) {
            if (symbol === void 0) { symbol = null; }
            return new MethodMaterial(imageColor, alpha);
        };
        return DefaultSceneGraphFactory;
    }(DefaultGraphicsFactory));

    /**
     * Maintains scenegraph heirarchy when collecting nodes
     */
    var SceneGraphNode = /** @class */ (function (_super) {
        __extends$3(SceneGraphNode, _super);
        function SceneGraphNode() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._numNodes = 0;
            _this._pChildNodes = new Array();
            _this._childDepths = new Array();
            return _this;
        }
        /**
         *
         * @param traverser
         */
        SceneGraphNode.prototype.acceptTraverser = function (traverser) {
            if (this._partition.root == this._entity)
                this._partition.updateEntities();
            //get the sub-traverser for the partition, if different, terminate this traversal
            if (traverser.partition != this._partition && traverser != traverser.getTraverser(this._partition))
                return;
            if (!traverser.enterNode(this))
                return;
            var i;
            for (i = this._numNodes - 1; i >= 0; i--)
                this._pChildNodes[i].acceptTraverser(traverser);
        };
        /**
         *
         * @param node
         * @internal
         */
        SceneGraphNode.prototype.iAddNode = function (node) {
            node.parent = this;
            var depth = (this._entity != node.entity) ? node.entity._depthID : -16384;
            var len = this._childDepths.length;
            var index = len;
            while (index--)
                if (this._childDepths[index] < depth)
                    break;
            index++;
            if (index < len) {
                this._pChildNodes.splice(index, 0, node);
                this._childDepths.splice(index, 0, depth);
            }
            else {
                this._pChildNodes.push(node);
                this._childDepths.push(depth);
            }
            this._numNodes++;
        };
        SceneGraphNode.prototype.isVisible = function () {
            return this._entity._iIsVisible();
        };
        /**
         *
         * @param node
         * @internal
         */
        SceneGraphNode.prototype.iRemoveNode = function (node) {
            var index = this._pChildNodes.indexOf(node);
            this._pChildNodes.splice(index, 1);
            this._childDepths.splice(index, 1);
            this._numNodes--;
        };
        return SceneGraphNode;
    }(NodeBase));

    /**
     * @class away.partition.Partition
     */
    var SceneGraphPartition = /** @class */ (function (_super) {
        __extends$3(SceneGraphPartition, _super);
        function SceneGraphPartition(root, isScene) {
            if (isScene === void 0) { isScene = false; }
            var _this = _super.call(this, root, isScene) || this;
            _this._rootNode = new SceneGraphNode(root, _this);
            return _this;
        }
        SceneGraphPartition.prototype.getPartition = function (entity) {
            //get a new partition for every displayobjectcontainer
            return new SceneGraphPartition(entity);
        };
        return SceneGraphPartition;
    }(PartitionBase));

    /**
     *
     */
    var SceneImage2D = /** @class */ (function (_super) {
        __extends$3(SceneImage2D, _super);
        /**
         * Creates a BitmapImage2D object with a specified width and height. If you
         * specify a value for the <code>fillColor</code> parameter, every pixel in
         * the bitmap is set to that color.
         *
         * <p>By default, the bitmap is created as transparent, unless you pass
         * the value <code>false</code> for the transparent parameter. After you
         * create an opaque bitmap, you cannot change it to a transparent bitmap.
         * Every pixel in an opaque bitmap uses only 24 bits of color channel
         * information. If you define the bitmap as transparent, every pixel uses 32
         * bits of color channel information, including an alpha transparency
         * channel.</p>
         *
         * @param width       The width of the bitmap image in pixels.
         * @param height      The height of the bitmap image in pixels.
         * @param transparent Specifies whether the bitmap image supports per-pixel
         *                    transparency. The default value is <code>true</code>
         *                    (transparent). To create a fully transparent bitmap,
         *                    set the value of the <code>transparent</code>
         *                    parameter to <code>true</code> and the value of the
         *                    <code>fillColor</code> parameter to 0x00000000(or to
         *                    0). Setting the <code>transparent</code> property to
         *                    <code>false</code> can result in minor improvements
         *                    in rendering performance.
         * @param fillColor   A 32-bit ARGB color value that you use to fill the
         *                    bitmap image area. The default value is
         *                    0xFFFFFFFF(solid white).
         */
        function SceneImage2D(width, height, transparent, fillColor, powerOfTwo, stage) {
            if (transparent === void 0) { transparent = true; }
            if (fillColor === void 0) { fillColor = 0xffffffff; }
            if (powerOfTwo === void 0) { powerOfTwo = true; }
            if (stage === void 0) { stage = null; }
            return _super.call(this, width, height, transparent, fillColor, powerOfTwo, stage) || this;
        }
        Object.defineProperty(SceneImage2D.prototype, "assetType", {
            /**
             *
             * @returns {string}
             */
            get: function () {
                return SceneImage2D.assetType;
            },
            enumerable: true,
            configurable: true
        });
        SceneImage2D.prototype.createRenderer = function () {
            //create the projection
            var projection = new PerspectiveProjection();
            projection.coordinateSystem = CoordinateSystem.RIGHT_HANDED;
            projection.originX = -1;
            projection.originY = 1;
            //create the view
            SceneImage2D._root = new DisplayObjectContainer();
            SceneImage2D._renderer = RenderGroup.getInstance(new View(projection, this._stage, null, null, null, true), RendererType.DEFAULT).getRenderer(new SceneGraphPartition(SceneImage2D._root));
            SceneImage2D._root.partition = SceneImage2D._renderer.partition;
            //setup the projection
            SceneImage2D._renderer.disableClear = true;
            SceneImage2D._renderer.view.backgroundAlpha = 0;
            SceneImage2D._renderer.view.projection = projection;
            SceneImage2D._renderer.view.projection.transform = new Transform();
            SceneImage2D._renderer.view.projection.transform.moveTo(0, 0, -1000);
            SceneImage2D._renderer.view.projection.transform.lookAt(new Vector3D());
            SceneImage2D._renderer.renderableSorter = null; //new RenderableSort2D();
        };
        SceneImage2D.prototype.createBillboardRenderer = function () {
            //create the projection
            var projection = new PerspectiveProjection();
            projection.coordinateSystem = CoordinateSystem.RIGHT_HANDED;
            projection.originX = -1;
            projection.originY = 1;
            //create the view
            SceneImage2D._billboardRoot = new DisplayObjectContainer();
            SceneImage2D._billboardRenderer = RenderGroup.getInstance(new View(projection, this._stage, null, null, null, true), RendererType.DEFAULT).getRenderer(new SceneGraphPartition(SceneImage2D._billboardRoot));
            SceneImage2D._billboardRoot.partition = SceneImage2D._billboardRenderer.partition;
            //setup the projection
            SceneImage2D._billboardRenderer.disableClear = true;
            SceneImage2D._billboardRenderer.view.backgroundAlpha = 0;
            SceneImage2D._billboardRenderer.view.projection = projection;
            SceneImage2D._billboardRenderer.view.projection.transform = new Transform();
            SceneImage2D._billboardRenderer.view.projection.transform.moveTo(0, 0, -1000);
            SceneImage2D._billboardRenderer.view.projection.transform.lookAt(new Vector3D());
            SceneImage2D._billboardRenderer.renderableSorter = null; //new RenderableSort2D();
            var mat = new MethodMaterial(new BitmapImage2D(128, 128, false, 0x0));
            //mat.colorTransform = new ColorTransform(argb[1]/255, argb[2]/255, argb[3]/255);
            mat.bothSides = true;
            mat.alphaBlending = true;
            mat.alphaPremultiplied = true;
            SceneImage2D._billboard = new Billboard(mat);
            SceneImage2D._billboard.style = new Style();
            SceneImage2D._billboardRoot.addChild(SceneImage2D._billboard);
        };
        /**
         * Frees memory that is used to store the BitmapImage2D object.
         *
         * <p>When the <code>dispose()</code> method is called on an image, the width
         * and height of the image are set to 0. All subsequent calls to methods or
         * properties of this BitmapImage2D instance fail, and an exception is thrown.
         * </p>
         *
         * <p><code>BitmapImage2D.dispose()</code> releases the memory occupied by the
         * actual bitmap data, immediately(a bitmap can consume up to 64 MB of
         * memory). After using <code>BitmapImage2D.dispose()</code>, the BitmapImage2D
         * object is no longer usable and an exception may be thrown if
         * you call functions on the BitmapImage2D object. However,
         * <code>BitmapImage2D.dispose()</code> does not garbage collect the BitmapImage2D
         * object(approximately 128 bytes); the memory occupied by the actual
         * BitmapImage2D object is released at the time the BitmapImage2D object is
         * collected by the garbage collector.</p>
         *
         */
        SceneImage2D.prototype.dispose = function () {
            _super.prototype.dispose.call(this);
            //todo
        };
        /**
         * Fills a rectangular area of pixels with a specified ARGB color.
         *
         * @param rect  The rectangular area to fill.
         * @param color The ARGB color value that fills the area. ARGB colors are
         *              often specified in hexadecimal format; for example,
         *              0xFF336699.
         * @throws TypeError The rect is null.
         */
        SceneImage2D.prototype.fillRect = function (rect, color) {
            if (!SceneImage2D._renderer)
                this.createRenderer();
            //set target and scale value
            SceneImage2D._renderer.view.target = this;
            SceneImage2D._renderer.view.projection.scale = 1000 / this.rect.height;
            //make sure we are setup on view
            SceneImage2D._renderer.view.x = rect.x;
            SceneImage2D._renderer.view.y = rect.y;
            SceneImage2D._renderer.view.width = rect.width;
            SceneImage2D._renderer.view.height = rect.height;
            SceneImage2D._renderer.view.backgroundAlpha = this._transparent ? (color >> 24) / 255 : 1;
            SceneImage2D._renderer.view.backgroundColor = color & 0xFFFFFF;
            SceneImage2D._renderer.view.clear(true, true);
            this._imageDataDirty = true;
        };
        /**
     * Provides a fast routine to perform pixel manipulation between images with
     * no stretching, rotation, or color effects. This method copies a
     * rectangular area of a source image to a rectangular area of the same size
     * at the destination point of the destination BitmapImage2D object.
     *
     * <p>If you include the <code>alphaBitmap</code> and <code>alphaPoint</code>
     * parameters, you can use a secondary image as an alpha source for the
     * source image. If the source image has alpha data, both sets of alpha data
     * are used to composite pixels from the source image to the destination
     * image. The <code>alphaPoint</code> parameter is the point in the alpha
     * image that corresponds to the upper-left corner of the source rectangle.
     * Any pixels outside the intersection of the source image and alpha image
     * are not copied to the destination image.</p>
     *
     * <p>The <code>mergeAlpha</code> property controls whether or not the alpha
     * channel is used when a transparent image is copied onto another
     * transparent image. To copy pixels with the alpha channel data, set the
     * <code>mergeAlpha</code> property to <code>true</code>. By default, the
     * <code>mergeAlpha</code> property is <code>false</code>.</p>
     *
     * @param sourceBitmapImage2D The input bitmap image from which to copy pixels.
     *                         The source image can be a different BitmapImage2D
     *                         instance, or it can refer to the current
     *                         BitmapImage2D instance.
     * @param sourceRect       A rectangle that defines the area of the source
     *                         image to use as input.
     * @param destPoint        The destination point that represents the
     *                         upper-left corner of the rectangular area where
     *                         the new pixels are placed.
     * @param alphaBitmapImage2D  A secondary, alpha BitmapImage2D object source.
     * @param alphaPoint       The point in the alpha BitmapImage2D object source
     *                         that corresponds to the upper-left corner of the
     *                         <code>sourceRect</code> parameter.
     * @param mergeAlpha       To use the alpha channel, set the value to
     *                         <code>true</code>. To copy pixels with no alpha
     *                         channel, set the value to <code>false</code>.
     * @throws TypeError The sourceBitmapImage2D, sourceRect, destPoint are null.
     */
        SceneImage2D.prototype.copyPixels = function (source, sourceRect, destPoint, alphaBitmapData, alphaPoint, mergeAlpha) {
            this._stage.context.setCulling(ContextGLTriangleFace.NONE);
            this._stage.context.setBlendFactors(ContextGLBlendFactor.ONE, ContextGLBlendFactor.ONE_MINUS_SOURCE_ALPHA);
            this._stage.copyPixels(source, this, sourceRect, destPoint, alphaBitmapData, alphaPoint, mergeAlpha);
            this._imageDataDirty = true;
        };
        SceneImage2D.prototype.draw = function (source, matrix, colorTransform, blendMode, clipRect, smoothing) {
            if (source instanceof DisplayObject) {
                if (!SceneImage2D._renderer)
                    this.createRenderer();
                var oldParent = source.parent;
                var oldChildIdx = oldParent ? oldParent.getChildIndex(source) : 0;
                var oldx = source.x;
                var oldy = source.y;
                var oldVisible = source.visible;
                var oldColorTransform = source.transform.colorTransform.clone();
                if (matrix) {
                    SceneImage2D._root.transform.scaleTo(matrix.a, -matrix.d, 1);
                    SceneImage2D._root.transform.moveTo(matrix.tx, this.rect.height - matrix.ty, 0);
                }
                else {
                    SceneImage2D._root.transform.scaleTo(1, -1, 1);
                    SceneImage2D._root.transform.moveTo(0, this.rect.height, 0);
                }
                //root.transform.colorTransform = colorTransform;
                SceneImage2D._renderer.view.target = this;
                SceneImage2D._renderer.view.projection.scale = 1000 / this.rect.height;
                SceneImage2D._renderer.view.x = 0;
                SceneImage2D._renderer.view.y = 0;
                SceneImage2D._renderer.view.width = this.width;
                SceneImage2D._renderer.view.height = this.height;
                SceneImage2D._root.removeChildren(0, SceneImage2D._root.numChildren);
                source.adapter.noReset = true;
                SceneImage2D._root.addChild(source);
                source.adapter.noReset = false;
                source.x = 0;
                source.y = 0;
                source.visible = true;
                source.transform.colorTransform = null;
                //save snapshot if unlocked
                //if (!this._locked)
                //SceneImage2D.scene.view.target=this;
                //SceneImage2D.scene.renderer.disableClear = !this._locked;
                //render
                SceneImage2D._renderer.render();
                if (oldParent) {
                    if (oldParent.adapter && oldParent.adapter != oldParent &&
                        source.adapter && source.adapter != source) {
                        source.adapter.noReset = true;
                        oldParent.adapter.addChildAt(source.adapter, oldChildIdx);
                        source.adapter.noReset = false;
                    }
                    else {
                        source.adapter.noReset = true;
                        oldParent.addChildAt(source, oldChildIdx);
                        source.adapter.noReset = false;
                    }
                }
                source.x = oldx;
                source.y = oldy;
                source.visible = oldVisible;
                source.transform.colorTransform = oldColorTransform;
                //SceneImage2D.scene.dispose();
                //SceneImage2D.scene=null;
                this._imageDataDirty = true;
                return;
            }
            if (!SceneImage2D._billboardRenderer)
                this.createBillboardRenderer();
            SceneImage2D._billboardRenderer.disableClear = true;
            SceneImage2D._billboardRenderer.view.target = this;
            SceneImage2D._billboardRenderer.view.projection.scale = 1000 / this.rect.height;
            SceneImage2D._billboard.material.style.image = source;
            if (matrix) {
                SceneImage2D._billboardRoot.transform.scaleTo(matrix.a, -matrix.d, 1);
                SceneImage2D._billboardRoot.transform.moveTo(matrix.tx, this.rect.height - matrix.ty, 0);
            }
            else {
                SceneImage2D._billboardRoot.transform.scaleTo(1, -1, 1);
                SceneImage2D._billboardRoot.transform.moveTo(0, this.rect.height, 0);
            }
            //render
            SceneImage2D._billboardRenderer.render();
            this._imageDataDirty = true;
        };
        SceneImage2D.assetType = "[image SceneImage2D]";
        return SceneImage2D;
    }(BitmapImage2D));
    Stage.registerAbstraction(_Stage_BitmapImage2D, SceneImage2D);

    /**
     * MouseManager enforces a singleton pattern and is not intended to be instanced.
     * it provides a manager class for detecting mouse hits on scene objects and sending out mouse events.
     */
    var MouseManager = /** @class */ (function () {
        /**
         * Creates a new <code>MouseManager</code> object.
         */
        function MouseManager(pickGroup) {
            var _this = this;
            this._sceneLookup = new Array();
            this._containerLookup = new Array();
            this.allowKeyInput = true;
            this._collisionIsEnabledButton = false;
            this._eventBubbling = true; //  should events bubble up
            this._allowFocusOnUnfocusable = true; // should unfocus-able object steal focus ?
            this._nullVector = new Vector3D();
            this._queuedEvents = new Array();
            this._mouseUp = new MouseEvent(MouseEvent.MOUSE_UP);
            this._mouseUpOutside = new MouseEvent(MouseEvent.MOUSE_UP_OUTSIDE);
            this._mouseClick = new MouseEvent(MouseEvent.CLICK);
            this._mouseOut = new MouseEvent(MouseEvent.MOUSE_OUT);
            this._dragOut = new MouseEvent(MouseEvent.DRAG_OUT);
            this._dragOver = new MouseEvent(MouseEvent.DRAG_OVER);
            this._mouseDown = new MouseEvent(MouseEvent.MOUSE_DOWN);
            this._mouseMove = new MouseEvent(MouseEvent.MOUSE_MOVE);
            this._mouseOver = new MouseEvent(MouseEvent.MOUSE_OVER);
            this._mouseWheel = new MouseEvent(MouseEvent.MOUSE_WHEEL);
            this._mouseDoubleClick = new MouseEvent(MouseEvent.DOUBLE_CLICK);
            this._dragMove = new MouseEvent(MouseEvent.DRAG_MOVE);
            this._dragStart = new MouseEvent(MouseEvent.DRAG_START);
            this._dragStop = new MouseEvent(MouseEvent.DRAG_STOP);
            this._useSoftkeyboard = false;
            this.isAVM1Dragging = false;
            this._isDown = false;
            this._pickGroup = pickGroup;
            this.onClickDelegate = function (event) { return _this.onClick(event); };
            this.onDoubleClickDelegate = function (event) { return _this.onDoubleClick(event); };
            this.onMouseDownDelegate = function (event) { return _this.onMouseDown(event); };
            this.onMouseMoveDelegate = function (event) { return _this.onMouseMove(event); };
            this.onMouseUpDelegate = function (event) { return _this.onMouseUp(event); };
            this.onMouseWheelDelegate = function (event) { return _this.onMouseWheel(event); };
            this.onMouseOverDelegate = function (event) { return _this.onMouseOver(event); };
            this.onMouseOutDelegate = function (event) { return _this.onMouseOut(event); };
            this.onKeyDownDelegate = function (event) { return _this.onKeyDown(event); };
            this.onKeyUpDelegate = function (event) { return _this.onKeyUp(event); };
            this.onFirstTouchDelegate = function (event) { return _this.onFirstTouch(event); };
            this.buttonEnabledDirty = false;
            this._isTouch = false;
            this._showCursor = true;
            this._mouseDragging = false;
            window.addEventListener('touchstart', this.onFirstTouchDelegate, false);
        }
        Object.defineProperty(MouseManager.prototype, "showCursor", {
            get: function () {
                return this._showCursor;
            },
            set: function (value) {
                this._showCursor = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseManager.prototype, "eventBubbling", {
            get: function () {
                return this._eventBubbling;
            },
            set: function (value) {
                this._eventBubbling = value;
            },
            enumerable: true,
            configurable: true
        });
        MouseManager.prototype.onFirstTouch = function (event) {
            this._isTouch = true;
            // we only need to know once that a human touched the screen, so we can stop listening now
            window.removeEventListener('touchstart', this.onFirstTouchDelegate, false);
        };
        Object.defineProperty(MouseManager.prototype, "useSoftkeyboard", {
            get: function () {
                return this._useSoftkeyboard;
            },
            set: function (value) {
                this._useSoftkeyboard = value;
                if (!value && BuildMode.mode == BuildMode.AVM1) {
                    window.addEventListener("keydown", this.onKeyDownDelegate);
                    window.addEventListener("keyup", this.onKeyUpDelegate);
                }
                else if (value) {
                    window.removeEventListener("keydown", this.onKeyDownDelegate);
                    window.removeEventListener("keyup", this.onKeyUpDelegate);
                }
            },
            enumerable: true,
            configurable: true
        });
        MouseManager.prototype.registerContainer = function (container) {
            if (container && this._containerLookup.indexOf(container) == -1) {
                container.addEventListener("click", this.onClickDelegate);
                container.addEventListener("dblclick", this.onDoubleClickDelegate);
                container.addEventListener("touchstart", this.onMouseDownDelegate);
                container.addEventListener("mousedown", this.onMouseDownDelegate);
                container.addEventListener("touchmove", this.onMouseMoveDelegate);
                container.addEventListener("mousemove", this.onMouseMoveDelegate);
                container.addEventListener("mouseup", this.onMouseUpDelegate);
                container.addEventListener("touchend", this.onMouseUpDelegate);
                container.addEventListener("touchend", this.onClickDelegate);
                container.addEventListener("mousewheel", this.onMouseWheelDelegate);
                container.addEventListener("mouseover", this.onMouseOverDelegate);
                container.addEventListener("mouseout", this.onMouseOutDelegate);
                // if (BuildMode.mode == BuildMode.AVM1) {
                window.addEventListener("keydown", this.onKeyDownDelegate);
                window.addEventListener("keyup", this.onKeyUpDelegate);
                // }
                this._containerLookup.push(container);
            }
        };
        MouseManager.prototype.unregisterContainer = function (container) {
            if (container && this._containerLookup.indexOf(container) != -1) {
                container.removeEventListener("click", this.onClickDelegate);
                container.removeEventListener("dblclick", this.onDoubleClickDelegate);
                container.removeEventListener("touchstart", this.onMouseDownDelegate);
                container.removeEventListener("mousedown", this.onMouseDownDelegate);
                container.removeEventListener("touchmove", this.onMouseMoveDelegate);
                container.removeEventListener("mousemove", this.onMouseMoveDelegate);
                container.removeEventListener("mouseup", this.onMouseUpDelegate);
                container.removeEventListener("touchend", this.onMouseUpDelegate);
                container.removeEventListener("touchend", this.onClickDelegate);
                container.removeEventListener("mousewheel", this.onMouseWheelDelegate);
                container.removeEventListener("mouseover", this.onMouseOverDelegate);
                container.removeEventListener("mouseout", this.onMouseOutDelegate);
                //if (BuildMode.mode == BuildMode.AVM1) {
                window.removeEventListener("keydown", this.onKeyDownDelegate);
                window.removeEventListener("keyup", this.onKeyUpDelegate);
                //}
                this._containerLookup.splice(this._containerLookup.indexOf(container), 1);
            }
        };
        MouseManager.prototype.dispose = function () {
            this._stage = null;
            this.onClickDelegate = null;
            this.onDoubleClickDelegate = null;
            this.onMouseDownDelegate = null;
            this.onMouseMoveDelegate = null;
            this.onMouseUpDelegate = null;
            this.onMouseWheelDelegate = null;
            this.onMouseOverDelegate = null;
            this.onMouseOutDelegate = null;
            this.onKeyDownDelegate = null;
            this.onKeyUpDelegate = null;
            window.removeEventListener('touchstart', this.onFirstTouchDelegate);
            this.onFirstTouchDelegate = null;
            this._mouseMoveEvent = null;
            this._mouseUp = null;
            this._mouseUpOutside = null;
            this._mouseClick = null;
            this._mouseOut = null;
            this._dragOut = null;
            this._dragOver = null;
            this._mouseDown = null;
            this._mouseMove = null;
            this._mouseOver = null;
            this._mouseWheel = null;
            this._mouseDoubleClick = null;
            this._dragMove = null;
            this._dragStart = null;
            this._dragStop = null;
        };
        MouseManager.clearInstance = function () {
            if (this._instance) {
                this._instance.dispose();
                this._instance = null;
            }
        };
        MouseManager.getInstance = function (pickGroup) {
            if (this._instance)
                return this._instance;
            //  todo: this is only needed due to MW react-lesson-player requesting a MouseManager with pickGroup=null
            //  can be removed once the MW code is adjusted
            if (!pickGroup)
                return new MouseManager(pickGroup);
            return (this._instance = new MouseManager(pickGroup));
        };
        MouseManager.prototype.setFocus = function (obj) {
            if (this._currentFocusEntity == obj) {
                return;
            }
            if (this._currentFocusEntity) {
                this._currentFocusEntity.setFocus(false, false);
            }
            this._currentFocusEntity = obj;
            if (this._currentFocusEntity) {
                this._currentFocusEntity.setFocus(true, false);
            }
        };
        MouseManager.prototype.getFocus = function () {
            return this._currentFocusEntity;
        };
        MouseManager.prototype.focusNextTab = function () {
            if (this._sceneLookup.length == 0)
                return;
            var newFocus = this._sceneLookup[0].tabPicker.getNextTabEntity(this._currentFocusEntity);
            if (newFocus == this._currentFocusEntity)
                return;
            if (this._currentFocusEntity)
                this._currentFocusEntity.setFocus(false, false);
            this._currentFocusEntity = newFocus;
            this._currentFocusEntity.setFocus(true, false);
        };
        MouseManager.prototype.focusPreviousTab = function () {
            if (this._sceneLookup.length == 0)
                return;
            var newFocus = this._sceneLookup[0].tabPicker.getPrevTabEntity(this._currentFocusEntity);
            if (newFocus == this._currentFocusEntity)
                return;
            if (this._currentFocusEntity)
                this._currentFocusEntity.setFocus(false, false);
            this._currentFocusEntity = newFocus;
            this._currentFocusEntity.setFocus(true, false);
        };
        MouseManager.prototype.dispatchEvent = function (event, dispatcher) {
            if (!this._eventBubbling) {
                if (dispatcher) {
                    dispatcher.dispatchEvent(event);
                    FrameScriptManager.execute_queue();
                }
                return;
            }
            while (dispatcher) {
                if (dispatcher._iIsMouseEnabled())
                    dispatcher.dispatchEvent(event);
                dispatcher = dispatcher.parent;
            }
        };
        MouseManager.prototype.setupAndDispatchEvent = function (event, sourceEvent, collision) {
            event = this.setUpEvent(event, sourceEvent, collision);
            this.dispatchEvent(event, event.pickerEntity);
        };
        MouseManager.prototype.fireMouseEvents = function (forceMouseMove) {
            this._iCollisionEntity = ((this._iCollision) ? this._iCollision.pickerEntity : null);
            if (this._iCollisionEntity != this._prevICollisionEntity) {
                //  If colliding object has changed, queue OVER and OUT events.
                //  If the mouse is dragged (mouse-down is hold), use DRAG_OVER and DRAG_OUT instead of MOUSE_OVER MOUSE_OUT
                //  DRAG_OVER and DRAG_OUT are only dispatched on the object that was hit on the mouse-down (_mouseDragEntity)
                //  Store the info if the collision is a enabled Button (_collisionIsEnabledButton)
                if (this._prevICollisionEntity) {
                    if (!this._isTouch && !this._mouseDragging)
                        this.queueDispatch(this._mouseOut, this._mouseMoveEvent, this._prevICollision);
                    else if (this._mouseDragging && this._mouseDragPickerEntity && this._mouseDragPickerEntity == this._prevICollisionEntity)
                        this.queueDispatch(this._dragOut, this._mouseMoveEvent, this._prevICollision);
                }
                this._collisionIsEnabledButton = this._iCollisionEntity ? this._iCollisionEntity.buttonEnabled : false;
                if (this._iCollisionEntity) {
                    if (!this._isTouch && !this._mouseDragging)
                        this.queueDispatch(this._mouseOver, this._mouseMoveEvent, this._iCollision);
                    else if (this._mouseDragging && this._mouseDragPickerEntity && this._mouseDragPickerEntity == this._iCollisionEntity)
                        this.queueDispatch(this._dragOver, this._mouseMoveEvent, this._iCollision);
                }
                this._prevICollision = this._iCollision;
                this._prevICollisionEntity = this._iCollisionEntity;
            }
            else {
                //  colliding object has not changed
                //  Check if we need to send any MOUSE_OVER/DRAG_OVER event to handle the case when a Button has become active while under the mouse.
                var isActiveButton = this._iCollisionEntity ? this._iCollisionEntity.buttonEnabled : false;
                if (this._collisionIsEnabledButton != isActiveButton && isActiveButton) {
                    if (!this._isTouch)
                        this.queueDispatch(this._mouseOver, this._mouseMoveEvent, this._iCollision);
                    else if (this._mouseDragPickerEntity && this._mouseDragPickerEntity == this._iCollisionEntity)
                        this.queueDispatch(this._dragOver, this._mouseMoveEvent, this._iCollision);
                }
                this._collisionIsEnabledButton = isActiveButton;
            }
            // set cursor if not dragging mouse
            if (!this._mouseDragging)
                document.body.style.cursor = this._showCursor ? (this._iCollisionEntity ? this._iCollisionEntity.getMouseCursor() : "initial") : "none";
            var event;
            var dispatcher;
            var len = this._queuedEvents.length;
            // Dispatch all queued events.
            /*var logEvents="";
            for (var i: number = 0; i < len; ++i) {
                logEvents+= " / "+this._queuedEvents[i].type;
            }
            console.log(logEvents);*/
            for (var i = 0; i < len; ++i) {
                event = this._queuedEvents[i];
                dispatcher = event.pickerEntity;
                if (event.type == MouseEvent.MOUSE_DOWN) {
                    this._mouseDragging = true;
                    // no event-bubbling. dispatch on stage first
                    if (!this._eventBubbling && this._stage)
                        this._stage.dispatchEvent(event);
                    // todo: at this point the object under the mouse might have been changed, so we need to recheck the collision
                    // on Touch dispatch mouseOver Command
                    if (this._isTouch)
                        this.setupAndDispatchEvent(this._mouseOver, this._mouseMoveEvent, this._iCollision);
                    this._mouseDragEntity = event.entity;
                    this._mouseDragPickerEntity = event.pickerEntity;
                    if (dispatcher) {
                        //console.log("onPress", dispatcher)
                        this.dispatchEvent(event, dispatcher);
                    }
                    //  in FP6, a mouseclick on non focus-able object still steal the focus
                    //  in newer FP they only steal the focus if the the new hit is focusable
                    if (this._allowFocusOnUnfocusable || (this._mouseDragPickerEntity && this._mouseDragPickerEntity.tabEnabled)) {
                        if (this._currentFocusEntity)
                            this._currentFocusEntity.setFocus(false, true);
                        this._currentFocusEntity = this._mouseDragPickerEntity;
                        if (this._currentFocusEntity)
                            this._currentFocusEntity.setFocus(true, true);
                    }
                    if (this._mouseDragEntity)
                        this.setupAndDispatchEvent(this._dragStart, event, this._pickGroup.getAbstraction(this._mouseDragEntity).pickingCollision);
                }
                else if (event.type == MouseEvent.MOUSE_UP) {
                    // no event-bubbling. dispatch on stage first
                    if (!this._eventBubbling && this._stage)
                        this._stage.dispatchEvent(event);
                    // todo: at this point the object under the mouse might have been changed, so we need to recheck the collision               
                    var upEntity = null;
                    var upPickerEntity = null;
                    if (this.isAVM1Dragging && this._mouseDragPickerEntity) {
                        // avm1dragging is in process, dispatch the mouse-up on this._mouseDragEntity instead of the current collision
                        upPickerEntity = this._mouseDragPickerEntity;
                        upEntity = this._mouseDragEntity;
                    }
                    else if (this._mouseDragging && this._mouseDragPickerEntity && this._mouseDragPickerEntity != dispatcher) {
                        // no avm1dragging is in process, but current collision is not the same as collision that appeared on mouse-down,
                        // need to dispatch a MOUSE_UP_OUTSIDE on _mouseDragEntity
                        if (this._mouseDragPickerEntity.buttonEnabled)
                            this.setupAndDispatchEvent(this._mouseOut, event, this._pickGroup.getAbstraction(this._mouseDragEntity).pickingCollision);
                        this.setupAndDispatchEvent(this._mouseUpOutside, event, this._pickGroup.getAbstraction(this._mouseDragEntity).pickingCollision);
                    }
                    else if (this._mouseDragging && this._mouseDragPickerEntity && this._mouseDragPickerEntity == dispatcher) {
                        // no avm1dragging is in process, but current collision is not the same as collision that appeared on mouse-down,
                        // need to dispatch a MOUSE_UP_OUTSIDE on _mouseDragEntity
                        upPickerEntity = this._mouseDragPickerEntity;
                        upEntity = this._mouseDragEntity;
                    }
                    if (this._mouseDragging && dispatcher)
                        this.setupAndDispatchEvent(this._mouseOver, event, this._iCollision);
                    if (this._isTouch && upEntity)
                        this.setupAndDispatchEvent(this._mouseOut, this._mouseMoveEvent, this._pickGroup.getAbstraction(upEntity).pickingCollision);
                    if (upPickerEntity) {
                        //console.log("onRelease", upPickerEntity)
                        this.dispatchEvent(event, upPickerEntity);
                    }
                    if (upEntity)
                        this.setupAndDispatchEvent(this._dragStop, event, this._pickGroup.getAbstraction(upEntity).pickingCollision);
                    this._mouseDragPickerEntity = null;
                    this._mouseDragEntity = null;
                    this._mouseDragging = false;
                    this.isAVM1Dragging = false;
                }
                else if (event.type == MouseEvent.MOUSE_MOVE) {
                    // no event-bubbling. dispatch on stage first
                    if (!this._eventBubbling) {
                        if (this._stage)
                            this._stage.dispatchEvent(event);
                    }
                    else {
                        this.dispatchEvent(event, event.pickerEntity);
                    }
                    if (this._mouseDragEntity)
                        this.setupAndDispatchEvent(this._dragMove, event, this._pickGroup.getAbstraction(this._mouseDragEntity).pickingCollision);
                }
                else {
                    // MouseEvent.MOUSE_OVER / MouseEvent.MOUSE_OUT / MouseEvent.DRAG_OVER / MouseEvent.DRAG_OUT
                    this.dispatchEvent(event, dispatcher);
                }
            }
            this._queuedEvents.length = 0;
            this._iUpdateDirty = false;
        };
        //		public addSceneLayer(scene:Scene)
        //		{
        //			var stg:Stage = scene.stage;
        //
        //			// Add instance to mouse3dmanager to fire mouse events for multiple scenes
        //			if (!scene.stageGL.mouse3DManager)
        //				scene.stageGL.mouse3DManager = this;
        //
        //			if (!hasKey(scene))
        //				_scene3Ds[scene] = 0;
        //
        //			_childDepth = 0;
        //			traverseDisplayObjects(stg);
        //			_sceneCount = _childDepth;
        //		}
        MouseManager.prototype.registerScene = function (scene) {
            if (scene)
                this._sceneLookup.push(scene);
        };
        MouseManager.prototype.unregisterScene = function (scene) {
            if (scene)
                this._sceneLookup.splice(this._sceneLookup.indexOf(scene), 1);
        };
        MouseManager.prototype.addEventsForSceneBinary = function (touchMessage, sceneIdx) {
            if (sceneIdx === void 0) { sceneIdx = 0; }
            var newTouchEvent = {};
            newTouchEvent.clientX = null; // we get the x position from the active touch
            newTouchEvent.clientY = null; // we get the y position from the active touch
            newTouchEvent.touches = [];
            newTouchEvent.changedTouches = [];
            newTouchEvent.preventDefault = function () { };
            var messageScene = new Float32Array(touchMessage);
            // transfer touches to event
            var i = 0;
            var cnt = 0;
            var touchCnt = 0;
            cnt++; //we temporary added 1 float to transfer fps from java to js. skip this
            var numTouches = messageScene[cnt++];
            var touchtype = messageScene[cnt++];
            var activeTouchID = messageScene[cnt++];
            var x = 0;
            var y = 0;
            if ((touchtype != 1) && (touchtype != 6) && (touchtype != 12) && (touchtype != 262) && (touchtype != 518)) {
                // if this is not a UP command, we add all touches
                for (i = 0; i < numTouches; i++) {
                    var newTouch = {};
                    newTouch.identifier = messageScene[cnt++];
                    newTouch.clientX = messageScene[cnt++];
                    newTouch.clientY = messageScene[cnt++];
                    newTouchEvent.touches[i] = newTouch;
                    //newTouchEvent.changedTouches[i] = newTouch;
                }
                newTouchEvent.changedTouches[0] = newTouchEvent.touches[activeTouchID];
                x = newTouchEvent.changedTouches[0].clientX;
                y = newTouchEvent.changedTouches[0].clientY;
            }
            else {
                // if this is a UP command, we add all touches, except the active one
                if (numTouches == 1) {
                    var newTouch = {};
                    newTouch.identifier = messageScene[cnt++];
                    newTouch.clientX = messageScene[cnt++];
                    newTouch.clientY = messageScene[cnt++];
                    newTouchEvent.clientX = newTouch.clientX;
                    newTouchEvent.clientY = newTouch.clientY;
                    x = newTouchEvent.clientX;
                    y = newTouchEvent.clientY;
                }
                else {
                    for (i = 0; i < numTouches; i++) {
                        var newTouch = {};
                        newTouch.identifier = messageScene[cnt++];
                        newTouch.clientX = messageScene[cnt++];
                        newTouch.clientY = messageScene[cnt++];
                        if (i != activeTouchID) {
                            newTouchEvent.touches[touchCnt] = newTouch;
                            //newTouchEvent.changedTouches[touchCnt++] = newTouch;
                        }
                        else {
                            newTouchEvent.clientX = newTouch.clientX;
                            newTouchEvent.clientY = newTouch.clientY;
                            x = newTouchEvent.clientX;
                            y = newTouchEvent.clientY;
                        }
                    }
                }
            }
            //console.log("Touch ID:"+touchtype+" activeTouchID "+activeTouchID+" numTouches "+numTouches+" x"+x+" y"+y);
            /*
             public static final int ACTION_DOWN = 0;
             public static final int ACTION_POINTER_1_DOWN = 5;
             public static final int ACTION_POINTER_DOWN = 5;
             public static final int ACTION_BUTTON_PRESS = 11;
             public static final int ACTION_POINTER_2_DOWN = 261;
             public static final int ACTION_POINTER_3_DOWN = 517;


             public static final int ACTION_UP = 1;
             public static final int ACTION_POINTER_1_UP = 6;
             public static final int ACTION_POINTER_UP = 6;
             public static final int ACTION_BUTTON_RELEASE = 12;
             public static final int ACTION_POINTER_2_UP = 262;
             public static final int ACTION_POINTER_3_UP = 518;

             public static final int ACTION_MOVE = 2;


             */
            if ((touchtype == 0) || (touchtype == 5) || (touchtype == 11) || (touchtype == 261) || (touchtype == 517)) {
                this.onMouseDown(newTouchEvent);
            }
            else if ((touchtype == 1) || (touchtype == 6) || (touchtype == 12) || (touchtype == 262) || (touchtype == 518)) {
                this.onMouseUp(newTouchEvent);
            }
            else if (touchtype == 2) {
                this.onMouseMove(newTouchEvent);
            }
            else {
                console.log("recieved unknown touch event-type: " + touchtype);
            }
        };
        MouseManager.prototype.fireEventsForSceneFromString = function (touchMessage, sceneIdx) {
            if (sceneIdx === void 0) { sceneIdx = 0; }
            var newTouchEvent = {};
            newTouchEvent.clientX = null; // set the x position from the active touch
            newTouchEvent.clientY = null; // set the y position from the active touch
            newTouchEvent.preventDefault = function () { };
            var touchesFromMessage = touchMessage.split(",");
            // transfer touches to event
            var i = 0;
            var cnt = 0;
            var numTouches = parseInt(touchesFromMessage[cnt++]);
            var touchtype = parseInt(touchesFromMessage[cnt++]);
            var activeTouch = parseInt(touchesFromMessage[cnt++]);
            newTouchEvent.touches = [];
            newTouchEvent.changedTouches = [];
            if ((touchtype != 1) && (touchtype != 6)) {
                for (i = 0; i < numTouches; i++) {
                    var newTouch = {};
                    newTouch.identifier = touchesFromMessage[cnt++];
                    newTouch.clientX = touchesFromMessage[cnt++];
                    newTouch.clientY = touchesFromMessage[cnt++];
                    newTouchEvent.touches[i] = newTouch;
                    newTouchEvent.changedTouches[i] = newTouch;
                }
                newTouchEvent.changedTouches[i] = newTouchEvent.touches[activeTouch];
            }
            else {
                for (i = 0; i < numTouches; i++) {
                    if (i != activeTouch) {
                        var newTouch = {};
                        newTouch.identifier = touchesFromMessage[cnt++];
                        newTouch.clientX = touchesFromMessage[cnt++];
                        newTouch.clientY = touchesFromMessage[cnt++];
                        newTouchEvent.touches[i] = newTouch;
                        newTouchEvent.changedTouches[i] = newTouch;
                    }
                    else {
                        newTouchEvent.clientX = touchesFromMessage[cnt++];
                        newTouchEvent.clientY = touchesFromMessage[cnt++];
                        cnt++;
                    }
                }
            }
            if (touchtype == 0) { //mousedown
                this.onMouseDown(newTouchEvent);
            }
            else if (touchtype == 1) { //mouseup
                this.onMouseUp(newTouchEvent);
            }
            else if (touchtype == 2) { //mousemove
                this.onMouseMove(newTouchEvent);
            }
            else if (touchtype == 261) { //mousedownPointer
                this.onMouseDown(newTouchEvent);
            }
            else if (touchtype == 6) { //mouseupPointer
                this.onMouseUp(newTouchEvent);
            }
        };
        // ---------------------------------------------------------------------
        // Private.
        // ---------------------------------------------------------------------
        MouseManager.prototype.setUpEvent = function (event, sourceEvent, collision) {
            // 2D properties.
            if (sourceEvent) {
                event.delta = sourceEvent.wheelDelta;
                event.ctrlKey = sourceEvent.ctrlKey;
                event.altKey = sourceEvent.altKey;
                event.shiftKey = sourceEvent.shiftKey;
                event.screenX = (sourceEvent.clientX != null) ? sourceEvent.clientX : sourceEvent.changedTouches ? sourceEvent.changedTouches[0].clientX : 0;
                event.screenY = (sourceEvent.clientY != null) ? sourceEvent.clientY : sourceEvent.changedTouches ? sourceEvent.changedTouches[0].clientY : 0;
            }
            //console.log("event", event, collisionEntity, collisionEntity);
            // 3D properties.
            if (collision) {
                event.entity = collision.entity;
                event.pickerEntity = collision.pickerEntity;
                // Object.
                event.traversable = collision.pickable;
                // UV.
                event.uv = collision.uv;
                // Position.
                event.position = collision.position ? collision.position.clone() : null;
                // Normal.
                event.normal = collision.normal ? collision.normal.clone() : null;
                // Face index.
                event.elementIndex = collision.elementIndex;
            }
            else {
                // Set all to null.
                event.entity = null;
                event.pickerEntity = null;
                event.traversable = null;
                event.uv = null;
                event.position = this._nullVector;
                event.normal = this._nullVector;
                event.elementIndex = 0;
            }
            return event;
        };
        MouseManager.prototype.queueDispatch = function (event, sourceEvent, collision) {
            // Store event to be dispatched later.
            this._queuedEvents.push(this.setUpEvent(event, sourceEvent, collision));
        };
        // ---------------------------------------------------------------------
        // Listeners.
        // ---------------------------------------------------------------------
        MouseManager.prototype.onKeyDown = function (event) {
            //console.log("Keydown", event);
            if (this.allowKeyInput) {
                event.preventDefault();
                if (this._currentFocusEntity || this._stage) {
                    //console.log("dispatch keydown on ", this._currentFocusEntity);
                    var newEvent = new KeyboardEvent(KeyboardEvent.KEYDOWN, event.key, event.code);
                    newEvent.isShift = event.shiftKey;
                    newEvent.isCTRL = event.ctrlKey;
                    newEvent.isAlt = event.altKey;
                    newEvent.keyCode = event.keyCode;
                    if (this._currentFocusEntity)
                        this._currentFocusEntity.dispatchEvent(newEvent);
                    if (this._stage)
                        this._stage.dispatchEvent(newEvent);
                }
            }
        };
        MouseManager.prototype.onKeyUp = function (event) {
            //console.log("Keyup", event);
            if (this.allowKeyInput) {
                event.preventDefault();
                if (this._currentFocusEntity || this._stage) {
                    //console.log("dispatch keydown on ", this._currentFocusEntity);
                    var newEvent = new KeyboardEvent(KeyboardEvent.KEYUP, event.key, event.code);
                    newEvent.isShift = event.shiftKey;
                    newEvent.isCTRL = event.ctrlKey;
                    newEvent.isAlt = event.altKey;
                    newEvent.keyCode = event.keyCode;
                    if (this._currentFocusEntity)
                        this._currentFocusEntity.dispatchEvent(newEvent);
                    if (this._stage)
                        this._stage.dispatchEvent(newEvent);
                }
            }
        };
        MouseManager.prototype.onMouseMove = function (event) {
            this._isTouch = (event.type != "mousemove");
            this.updateColliders(event);
            this.queueDispatch(this._mouseMove, this._mouseMoveEvent = event, this._iCollision);
        };
        MouseManager.prototype.onMouseOut = function (event) {
            this.updateColliders(event);
            this.queueDispatch(this._mouseOut, event, this._iCollision);
        };
        MouseManager.prototype.onMouseOver = function (event) {
            this.updateColliders(event);
            this.queueDispatch(this._mouseOver, event, this._iCollision);
        };
        MouseManager.prototype.onClick = function (event) {
            this.updateColliders(event);
            this.queueDispatch(this._mouseClick, event, this._iCollision);
        };
        MouseManager.prototype.onDoubleClick = function (event) {
            this.updateColliders(event);
            this.queueDispatch(this._mouseDoubleClick, event, this._iCollision);
        };
        MouseManager.prototype.onMouseDown = function (event) {
            if (this._isDown) {
                return;
            }
            this._isDown = true;
            this.updateColliders(event);
            //console.log("this._iCollisionEntity", this._iCollisionEntity);
            if (this._isTouch) {
                event.preventDefault();
                for (var key in this._containerLookup) {
                    this._containerLookup[key].focus();
                }
            }
            this.queueDispatch(this._mouseDown, event, this._iCollision);
        };
        MouseManager.prototype.onMouseUp = function (event) {
            if (!this._isDown) {
                return;
            }
            this._isDown = false;
            this.updateColliders(event);
            if (this._isTouch) {
                event.preventDefault();
                for (var key in this._containerLookup) {
                    this._containerLookup[key].focus();
                }
            }
            this.queueDispatch(this._mouseUp, event, this._iCollision);
        };
        MouseManager.prototype.onMouseWheel = function (event) {
            this.updateColliders(event);
            this.queueDispatch(this._mouseWheel, event, this._iCollision);
        };
        MouseManager.prototype.updateColliders = function (event) {
            var scene;
            var mouseX = (event.clientX != null) ? event.clientX : event.changedTouches[0].clientX;
            var mouseY = (event.clientY != null) ? event.clientY : event.changedTouches[0].clientY;
            var len = this._sceneLookup.length;
            for (var i = 0; i < len; i++) {
                scene = this._sceneLookup[i];
                scene._touchPoints.length = 0;
                if (event.touches) {
                    var touch;
                    var len_touches = event.touches.length;
                    for (var t = 0; t < len_touches; t++) {
                        touch = event.touches[t];
                        scene._touchPoints.push(new TouchPoint(touch.clientX + scene.view.x, touch.clientY + scene.view.y, touch.identifier));
                    }
                }
                if (this._iUpdateDirty)
                    continue;
                scene._mouseX = (mouseX < scene.view.x) ? scene.view.x : (mouseX > scene.view.x + scene.view.width) ? scene.view.x + scene.view.width : mouseX - scene.view.x;
                scene._mouseY = (mouseY < scene.view.y) ? scene.view.y : (mouseY > scene.view.y + scene.view.height) ? scene.view.y + scene.view.height : mouseY - scene.view.y;
                scene.updateCollider();
                if (scene.layeredView && this._iCollision)
                    break;
            }
            this._iUpdateDirty = true;
        };
        return MouseManager;
    }());

    /**
     * A Capsule primitive sprite.
     */
    var PrimitiveCapsulePrefab = /** @class */ (function (_super) {
        __extends$3(PrimitiveCapsulePrefab, _super);
        /**
         * Creates a new Capsule object.
         * @param radius The radius of the capsule.
         * @param height The height of the capsule.
         * @param segmentsW Defines the number of horizontal segments that make up the capsule. Defaults to 16.
         * @param segmentsH Defines the number of vertical segments that make up the capsule. Defaults to 15. Must be uneven value.
         * @param yUp Defines whether the capsule poles should lay on the Y-axis (true) or on the Z-axis (false).
         */
        function PrimitiveCapsulePrefab(material, elementsType, radius, height, segmentsW, segmentsH, yUp) {
            if (material === void 0) { material = null; }
            if (elementsType === void 0) { elementsType = "triangle"; }
            if (radius === void 0) { radius = 50; }
            if (height === void 0) { height = 100; }
            if (segmentsW === void 0) { segmentsW = 16; }
            if (segmentsH === void 0) { segmentsH = 15; }
            if (yUp === void 0) { yUp = true; }
            var _this = _super.call(this, material, elementsType) || this;
            _this._numVertices = 0;
            _this._radius = radius;
            _this._height = height;
            _this._segmentsW = segmentsW;
            _this._segmentsH = (segmentsH % 2 == 0) ? segmentsH + 1 : segmentsH;
            _this._yUp = yUp;
            return _this;
        }
        Object.defineProperty(PrimitiveCapsulePrefab.prototype, "radius", {
            /**
             * The radius of the capsule.
             */
            get: function () {
                return this._radius;
            },
            set: function (value) {
                this._radius = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCapsulePrefab.prototype, "height", {
            /**
             * The height of the capsule.
             */
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCapsulePrefab.prototype, "segmentsW", {
            /**
             * Defines the number of horizontal segments that make up the capsule. Defaults to 16.
             */
            get: function () {
                return this._segmentsW;
            },
            set: function (value) {
                this._segmentsW = value;
                this._pInvalidatePrimitive();
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCapsulePrefab.prototype, "segmentsH", {
            /**
             * Defines the number of vertical segments that make up the capsule. Defaults to 15. Must be uneven.
             */
            get: function () {
                return this._segmentsH;
            },
            set: function (value) {
                this._segmentsH = (value % 2 == 0) ? value + 1 : value;
                this._pInvalidatePrimitive();
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCapsulePrefab.prototype, "yUp", {
            /**
             * Defines whether the capsule poles should lay on the Y-axis (true) or on the Z-axis (false).
             */
            get: function () {
                return this._yUp;
            },
            set: function (value) {
                this._yUp = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        PrimitiveCapsulePrefab.prototype._pBuildGraphics = function (target, elementsType) {
            var indices;
            var positions;
            var normals;
            var tangents;
            var stride;
            var i;
            var j;
            var triIndex = 0;
            var index = 0;
            var startIndex;
            var comp1, comp2, t1, t2;
            var numIndices = 0;
            if (elementsType == ElementsType.TRIANGLE) {
                var triangleGraphics = target;
                // evaluate target number of vertices, triangles and indices
                this._numVertices = (this._segmentsH + 1) * (this._segmentsW + 1); // segmentsH + 1 because of closure, segmentsW + 1 because of closure
                numIndices = (this._segmentsH - 1) * this._segmentsW * 6; // each level has segmentH quads, each of 2 triangles
                // need to initialize raw arrays or can be reused?
                if (this._numVertices == triangleGraphics.numVertices) {
                    triangleGraphics.invalidateIndices();
                    triangleGraphics.invalidateVertices(triangleGraphics.positions);
                    triangleGraphics.invalidateVertices(triangleGraphics.normals);
                    triangleGraphics.invalidateVertices(triangleGraphics.tangents);
                }
                else {
                    triangleGraphics.setIndices(new Uint16Array(numIndices));
                    triangleGraphics.setPositions(new Float32Array(this._numVertices * 3));
                    triangleGraphics.setNormals(new Float32Array(this._numVertices * 3));
                    triangleGraphics.setTangents(new Float32Array(this._numVertices * 3));
                    this._pInvalidateUVs();
                }
                indices = triangleGraphics.indices.get(triangleGraphics.numElements);
                positions = triangleGraphics.positions.get(this._numVertices);
                normals = triangleGraphics.normals.get(this._numVertices);
                tangents = triangleGraphics.tangents.get(this._numVertices);
                stride = triangleGraphics.concatenatedBuffer.stride / 4;
                for (j = 0; j <= this._segmentsH; ++j) {
                    var horangle = Math.PI * j / this._segmentsH;
                    var z = -this._radius * Math.cos(horangle);
                    var ringradius = this._radius * Math.sin(horangle);
                    startIndex = index;
                    for (i = 0; i <= this._segmentsW; ++i) {
                        var verangle = 2 * Math.PI * i / this._segmentsW;
                        var x = ringradius * Math.cos(verangle);
                        var offset = j > this._segmentsH / 2 ? this._height / 2 : -this._height / 2;
                        var y = ringradius * Math.sin(verangle);
                        var normLen = 1 / Math.sqrt(x * x + y * y + z * z);
                        var tanLen = Math.sqrt(y * y + x * x);
                        if (this._yUp) {
                            t1 = 0;
                            t2 = tanLen > .007 ? x / tanLen : 0;
                            comp1 = -z;
                            comp2 = y;
                        }
                        else {
                            t1 = tanLen > .007 ? x / tanLen : 0;
                            t2 = 0;
                            comp1 = y;
                            comp2 = z;
                        }
                        if (i == this._segmentsW) {
                            positions[index] = positions[startIndex];
                            positions[index + 1] = positions[startIndex + 1];
                            positions[index + 2] = positions[startIndex + 2];
                            normals[index] = (normals[startIndex] + (x * normLen)) * .5;
                            normals[index + 1] = (normals[startIndex + 1] + (comp1 * normLen)) * .5;
                            normals[index + 2] = (normals[startIndex + 2] + (comp2 * normLen)) * .5;
                            tangents[index] = (tangents[startIndex] + (tanLen > .007 ? -y / tanLen : 1)) * .5;
                            tangents[index + 1] = (tangents[startIndex + 1] + t1) * .5;
                            tangents[index + 2] = (tangents[startIndex + 2] + t2) * .5;
                        }
                        else {
                            // vertex
                            positions[index] = x;
                            positions[index + 1] = (this._yUp) ? comp1 - offset : comp1;
                            positions[index + 2] = (this._yUp) ? comp2 : comp2 + offset;
                            // normal
                            normals[index] = x * normLen;
                            normals[index + 1] = comp1 * normLen;
                            normals[index + 2] = comp2 * normLen;
                            // tangent
                            tangents[index] = tanLen > .007 ? -y / tanLen : 1;
                            tangents[index + 1] = t1;
                            tangents[index + 2] = t2;
                        }
                        if (i > 0 && j > 0) {
                            var a = (this._segmentsW + 1) * j + i;
                            var b = (this._segmentsW + 1) * j + i - 1;
                            var c = (this._segmentsW + 1) * (j - 1) + i - 1;
                            var d = (this._segmentsW + 1) * (j - 1) + i;
                            if (j == this._segmentsH) {
                                positions[index] = positions[startIndex];
                                positions[index + 1] = positions[startIndex + 1];
                                positions[index + 2] = positions[startIndex + 2];
                                indices[triIndex++] = a;
                                indices[triIndex++] = c;
                                indices[triIndex++] = d;
                            }
                            else if (j == 1) {
                                indices[triIndex++] = a;
                                indices[triIndex++] = b;
                                indices[triIndex++] = c;
                            }
                            else {
                                indices[triIndex++] = a;
                                indices[triIndex++] = b;
                                indices[triIndex++] = c;
                                indices[triIndex++] = a;
                                indices[triIndex++] = c;
                                indices[triIndex++] = d;
                            }
                        }
                        index += stride;
                    }
                }
            }
            else if (elementsType == ElementsType.LINE) {
                //TODO
            }
        };
        /**
         * @inheritDoc
         */
        PrimitiveCapsulePrefab.prototype._pBuildUVs = function (target, elementsType) {
            var i, j;
            var uvs;
            var stride;
            if (elementsType == ElementsType.TRIANGLE) {
                var triangleGraphics = target;
                // need to initialize raw array or can be reused?
                if (triangleGraphics.uvs && this._numVertices == triangleGraphics.numVertices) {
                    triangleGraphics.invalidateVertices(triangleGraphics.uvs);
                }
                else {
                    triangleGraphics.setUVs(new Float32Array(this._numVertices * 2));
                }
                uvs = triangleGraphics.uvs.get(this._numVertices);
                stride = triangleGraphics.uvs.stride;
                // current uv component index
                var index = 0;
                // surface
                for (j = 0; j <= this._segmentsH; ++j) {
                    for (i = 0; i <= this._segmentsW; ++i) {
                        // revolution vertex
                        uvs[index] = (i / this._segmentsW) * this._scaleU;
                        uvs[index + 1] = (j / this._segmentsH) * this._scaleV;
                        index += stride;
                    }
                }
            }
            else if (elementsType == ElementsType.LINE) {
                //nothing to do here
            }
        };
        return PrimitiveCapsulePrefab;
    }(PrimitivePrefabBase));

    /**
     * A Cylinder primitive sprite.
     */
    var PrimitiveCylinderPrefab = /** @class */ (function (_super) {
        __extends$3(PrimitiveCylinderPrefab, _super);
        /**
         * Creates a new Cylinder object.
         * @param topRadius The radius of the top end of the cylinder.
         * @param bottomRadius The radius of the bottom end of the cylinder
         * @param height The radius of the bottom end of the cylinder
         * @param segmentsW Defines the number of horizontal segments that make up the cylinder. Defaults to 16.
         * @param segmentsH Defines the number of vertical segments that make up the cylinder. Defaults to 1.
         * @param topClosed Defines whether the top end of the cylinder is closed (true) or open.
         * @param bottomClosed Defines whether the bottom end of the cylinder is closed (true) or open.
         * @param yUp Defines whether the cone poles should lay on the Y-axis (true) or on the Z-axis (false).
         */
        function PrimitiveCylinderPrefab(material, elementsType, topRadius, bottomRadius, height, segmentsW, segmentsH, topClosed, bottomClosed, surfaceClosed, yUp) {
            if (material === void 0) { material = null; }
            if (elementsType === void 0) { elementsType = "triangle"; }
            if (topRadius === void 0) { topRadius = 50; }
            if (bottomRadius === void 0) { bottomRadius = 50; }
            if (height === void 0) { height = 100; }
            if (segmentsW === void 0) { segmentsW = 16; }
            if (segmentsH === void 0) { segmentsH = 1; }
            if (topClosed === void 0) { topClosed = true; }
            if (bottomClosed === void 0) { bottomClosed = true; }
            if (surfaceClosed === void 0) { surfaceClosed = true; }
            if (yUp === void 0) { yUp = true; }
            var _this = _super.call(this, material, elementsType) || this;
            _this._numVertices = 0;
            _this._topRadius = topRadius;
            _this._pBottomRadius = bottomRadius;
            _this._height = height;
            _this._pSegmentsW = segmentsW;
            _this._pSegmentsH = segmentsH;
            _this._topClosed = topClosed;
            _this._bottomClosed = bottomClosed;
            _this._surfaceClosed = surfaceClosed;
            _this._yUp = yUp;
            return _this;
        }
        Object.defineProperty(PrimitiveCylinderPrefab.prototype, "topRadius", {
            /**
             * The radius of the top end of the cylinder.
             */
            get: function () {
                return this._topRadius;
            },
            set: function (value) {
                this._topRadius = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCylinderPrefab.prototype, "bottomRadius", {
            /**
             * The radius of the bottom end of the cylinder.
             */
            get: function () {
                return this._pBottomRadius;
            },
            set: function (value) {
                this._pBottomRadius = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCylinderPrefab.prototype, "height", {
            /**
             * The radius of the top end of the cylinder.
             */
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCylinderPrefab.prototype, "segmentsW", {
            /**
             * Defines the number of horizontal segments that make up the cylinder. Defaults to 16.
             */
            get: function () {
                return this._pSegmentsW;
            },
            set: function (value) {
                this.setSegmentsW(value);
            },
            enumerable: true,
            configurable: true
        });
        PrimitiveCylinderPrefab.prototype.setSegmentsW = function (value) {
            this._pSegmentsW = value;
            this._pInvalidatePrimitive();
            this._pInvalidateUVs();
        };
        Object.defineProperty(PrimitiveCylinderPrefab.prototype, "segmentsH", {
            /**
             * Defines the number of vertical segments that make up the cylinder. Defaults to 1.
             */
            get: function () {
                return this._pSegmentsH;
            },
            set: function (value) {
                this.setSegmentsH(value);
            },
            enumerable: true,
            configurable: true
        });
        PrimitiveCylinderPrefab.prototype.setSegmentsH = function (value) {
            this._pSegmentsH = value;
            this._pInvalidatePrimitive();
            this._pInvalidateUVs();
        };
        Object.defineProperty(PrimitiveCylinderPrefab.prototype, "topClosed", {
            /**
             * Defines whether the top end of the cylinder is closed (true) or open.
             */
            get: function () {
                return this._topClosed;
            },
            set: function (value) {
                this._topClosed = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCylinderPrefab.prototype, "bottomClosed", {
            /**
             * Defines whether the bottom end of the cylinder is closed (true) or open.
             */
            get: function () {
                return this._bottomClosed;
            },
            set: function (value) {
                this._bottomClosed = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveCylinderPrefab.prototype, "yUp", {
            /**
             * Defines whether the cylinder poles should lay on the Y-axis (true) or on the Z-axis (false).
             */
            get: function () {
                return this._yUp;
            },
            set: function (value) {
                this._yUp = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        PrimitiveCylinderPrefab.prototype._pBuildGraphics = function (target, elementsType) {
            var indices;
            var positions;
            var normals;
            var tangents;
            var stride;
            var i;
            var j;
            var x;
            var y;
            var z;
            var vidx;
            var fidx;
            var radius;
            var revolutionAngle;
            var dr;
            var latNormElev;
            var latNormBase;
            var numIndices = 0;
            var comp1;
            var comp2;
            var startIndex = 0;
            var nextVertexIndex = 0;
            var centerVertexIndex = 0;
            var t1;
            var t2;
            // reset utility variables
            this._numVertices = 0;
            // evaluate revolution steps
            var revolutionAngleDelta = 2 * Math.PI / this._pSegmentsW;
            if (elementsType == ElementsType.TRIANGLE) {
                var triangleGraphics = target;
                // evaluate target number of vertices, triangles and indices
                if (this._surfaceClosed) {
                    this._numVertices += (this._pSegmentsH + 1) * (this._pSegmentsW + 1); // segmentsH + 1 because of closure, segmentsW + 1 because of UV unwrapping
                    numIndices += this._pSegmentsH * this._pSegmentsW * 6; // each level has segmentW quads, each of 2 triangles
                }
                if (this._topClosed) {
                    this._numVertices += 2 * (this._pSegmentsW + 1); // segmentsW + 1 because of unwrapping
                    numIndices += this._pSegmentsW * 3; // one triangle for each segment
                }
                if (this._bottomClosed) {
                    this._numVertices += 2 * (this._pSegmentsW + 1);
                    numIndices += this._pSegmentsW * 3;
                }
                // need to initialize raw arrays or can be reused?
                if (this._numVertices == triangleGraphics.numVertices) {
                    /*triangleGraphics.invalidateIndices();
                    triangleGraphics.invalidateVertices(triangleGraphics.positions);
                    triangleGraphics.invalidateVertices(triangleGraphics.normals);
                    triangleGraphics.invalidateVertices(triangleGraphics.tangents);*/
                    triangleGraphics.positions.invalidate();
                    triangleGraphics.normals.invalidate();
                    triangleGraphics.tangents.invalidate();
                    triangleGraphics.indices.invalidate();
                }
                else {
                    triangleGraphics.setIndices(new Uint16Array(numIndices));
                    triangleGraphics.setPositions(new Float32Array(this._numVertices * 3));
                    triangleGraphics.setNormals(new Float32Array(this._numVertices * 3));
                    triangleGraphics.setTangents(new Float32Array(this._numVertices * 3));
                    this._pInvalidateUVs();
                }
                indices = triangleGraphics.indices.get(triangleGraphics.numElements);
                positions = triangleGraphics.positions.get(this._numVertices);
                normals = triangleGraphics.normals.get(this._numVertices);
                tangents = triangleGraphics.tangents.get(this._numVertices);
                stride = triangleGraphics.concatenatedBuffer.stride / 4;
                vidx = 0;
                fidx = 0;
                // top
                if (this._topClosed && this._topRadius > 0) {
                    z = -0.5 * this._height;
                    // central vertex
                    if (this._yUp) {
                        t1 = 1;
                        t2 = 0;
                        comp1 = -z;
                        comp2 = 0;
                    }
                    else {
                        t1 = 0;
                        t2 = -1;
                        comp1 = 0;
                        comp2 = z;
                    }
                    positions[vidx] = 0;
                    positions[vidx + 1] = comp1;
                    positions[vidx + 2] = comp2;
                    normals[vidx] = 0;
                    normals[vidx + 1] = t1;
                    normals[vidx + 2] = t2;
                    tangents[vidx] = 1;
                    tangents[vidx + 1] = 0;
                    tangents[vidx + 2] = 0;
                    vidx += stride;
                    nextVertexIndex++;
                    for (i = 0; i <= this._pSegmentsW; ++i) {
                        // revolution vertex
                        revolutionAngle = i * revolutionAngleDelta;
                        x = this._topRadius * Math.cos(revolutionAngle);
                        y = this._topRadius * Math.sin(revolutionAngle);
                        if (this._yUp) {
                            comp1 = -z;
                            comp2 = y;
                        }
                        else {
                            comp1 = y;
                            comp2 = z;
                        }
                        if (i == this._pSegmentsW) {
                            positions[vidx] = positions[startIndex + stride];
                            positions[vidx + 1] = positions[startIndex + stride + 1];
                            positions[vidx + 2] = positions[startIndex + stride + 2];
                        }
                        else {
                            positions[vidx] = x;
                            positions[vidx + 1] = comp1;
                            positions[vidx + 2] = comp2;
                        }
                        normals[vidx] = 0;
                        normals[vidx + 1] = t1;
                        normals[vidx + 2] = t2;
                        tangents[vidx] = 1;
                        tangents[vidx + 1] = 0;
                        tangents[vidx + 2] = 0;
                        vidx += stride;
                        if (i > 0) {
                            // add triangle
                            indices[fidx++] = nextVertexIndex - 1;
                            indices[fidx++] = centerVertexIndex;
                            indices[fidx++] = nextVertexIndex;
                        }
                        nextVertexIndex++;
                    }
                }
                // bottom
                if (this._bottomClosed && this._pBottomRadius > 0) {
                    z = 0.5 * this._height;
                    startIndex = nextVertexIndex * stride;
                    centerVertexIndex = nextVertexIndex;
                    // central vertex
                    if (this._yUp) {
                        t1 = -1;
                        t2 = 0;
                        comp1 = -z;
                        comp2 = 0;
                    }
                    else {
                        t1 = 0;
                        t2 = 1;
                        comp1 = 0;
                        comp2 = z;
                    }
                    if (i > 0) {
                        positions[vidx] = 0;
                        positions[vidx + 1] = comp1;
                        positions[vidx + 2] = comp2;
                        normals[vidx] = 0;
                        normals[vidx + 1] = t1;
                        normals[vidx + 2] = t2;
                        tangents[vidx] = 1;
                        tangents[vidx + 1] = 0;
                        tangents[vidx + 2] = 0;
                        vidx += stride;
                    }
                    nextVertexIndex++;
                    for (i = 0; i <= this._pSegmentsW; ++i) {
                        // revolution vertex
                        revolutionAngle = i * revolutionAngleDelta;
                        x = this._pBottomRadius * Math.cos(revolutionAngle);
                        y = this._pBottomRadius * Math.sin(revolutionAngle);
                        if (this._yUp) {
                            comp1 = -z;
                            comp2 = y;
                        }
                        else {
                            comp1 = y;
                            comp2 = z;
                        }
                        if (i == this._pSegmentsW) {
                            positions[vidx] = positions[startIndex + stride];
                            positions[vidx + 1] = positions[startIndex + stride + 1];
                            positions[vidx + 2] = positions[startIndex + stride + 2];
                        }
                        else {
                            positions[vidx] = x;
                            positions[vidx + 1] = comp1;
                            positions[vidx + 2] = comp2;
                        }
                        normals[vidx] = 0;
                        normals[vidx + 1] = t1;
                        normals[vidx + 2] = t2;
                        tangents[vidx] = 1;
                        tangents[vidx + 1] = 0;
                        tangents[vidx + 2] = 0;
                        vidx += stride;
                        if (i > 0) {
                            // add triangle
                            indices[fidx++] = nextVertexIndex - 1;
                            indices[fidx++] = nextVertexIndex;
                            indices[fidx++] = centerVertexIndex;
                        }
                        nextVertexIndex++;
                    }
                }
                // The normals on the lateral surface all have the same incline, i.e.
                // the "elevation" component (Y or Z depending on yUp) is constant.
                // Same principle goes for the "base" of these vectors, which will be
                // calculated such that a vector [base,elev] will be a unit vector.
                dr = (this._pBottomRadius - this._topRadius);
                latNormElev = dr / this._height;
                latNormBase = (latNormElev == 0) ? 1 : this._height / dr;
                // lateral surface
                if (this._surfaceClosed) {
                    var a;
                    var b;
                    var c;
                    var d;
                    var na0, na1, naComp1, naComp2;
                    for (j = 0; j <= this._pSegmentsH; ++j) {
                        radius = this._topRadius - ((j / this._pSegmentsH) * (this._topRadius - this._pBottomRadius));
                        z = -(this._height / 2) + (j / this._pSegmentsH * this._height);
                        startIndex = nextVertexIndex * stride;
                        for (i = 0; i <= this._pSegmentsW; ++i) {
                            // revolution vertex
                            revolutionAngle = i * revolutionAngleDelta;
                            x = radius * Math.cos(revolutionAngle);
                            y = radius * Math.sin(revolutionAngle);
                            na0 = latNormBase * Math.cos(revolutionAngle);
                            na1 = latNormBase * Math.sin(revolutionAngle);
                            if (this._yUp) {
                                t1 = 0;
                                t2 = -na0;
                                comp1 = -z;
                                comp2 = y;
                                naComp1 = latNormElev;
                                naComp2 = na1;
                            }
                            else {
                                t1 = -na0;
                                t2 = 0;
                                comp1 = y;
                                comp2 = z;
                                naComp1 = na1;
                                naComp2 = latNormElev;
                            }
                            if (i == this._pSegmentsW) {
                                positions[vidx] = positions[startIndex];
                                positions[vidx + 1] = positions[startIndex + 1];
                                positions[vidx + 2] = positions[startIndex + 2];
                                normals[vidx] = na0;
                                normals[vidx + 1] = latNormElev;
                                normals[vidx + 2] = na1;
                                tangents[vidx] = na1;
                                tangents[vidx + 1] = t1;
                                tangents[vidx + 2] = t2;
                            }
                            else {
                                positions[vidx] = x;
                                positions[vidx + 1] = comp1;
                                positions[vidx + 2] = comp2;
                                normals[vidx] = na0;
                                normals[vidx + 1] = naComp1;
                                normals[vidx + 2] = naComp2;
                                tangents[vidx] = -na1;
                                tangents[vidx + 1] = t1;
                                tangents[vidx + 2] = t2;
                            }
                            vidx += stride;
                            // close triangle
                            if (i > 0 && j > 0) {
                                a = nextVertexIndex; // current
                                b = nextVertexIndex - 1; // previous
                                c = b - this._pSegmentsW - 1; // previous of last level
                                d = a - this._pSegmentsW - 1; // current of last level
                                indices[fidx++] = a;
                                indices[fidx++] = b;
                                indices[fidx++] = c;
                                indices[fidx++] = a;
                                indices[fidx++] = c;
                                indices[fidx++] = d;
                            }
                            nextVertexIndex++;
                        }
                    }
                }
            }
            else if (elementsType == ElementsType.LINE) {
                var lineGraphics = target;
                var numSegments = this._pSegmentsH * this._pSegmentsW * 2 + this._pSegmentsW;
                positions = new Float32Array(numSegments * 6);
                var thickness = new Float32Array(numSegments);
                vidx = 0;
                fidx = 0;
                for (j = 0; j <= this._pSegmentsH; ++j) {
                    radius = this._topRadius - ((j / this._pSegmentsH) * (this._topRadius - this._pBottomRadius));
                    z = -(this._height / 2) + (j / this._pSegmentsH * this._height);
                    for (i = 0; i <= this._pSegmentsW; ++i) {
                        // revolution vertex
                        revolutionAngle = i * revolutionAngleDelta;
                        x = radius * Math.cos(revolutionAngle);
                        y = radius * Math.sin(revolutionAngle);
                        if (this._yUp) {
                            comp1 = -z;
                            comp2 = y;
                        }
                        else {
                            comp1 = y;
                            comp2 = z;
                        }
                        if (i > 0) {
                            //horizonal lines
                            positions[vidx++] = x;
                            positions[vidx++] = comp1;
                            positions[vidx++] = comp2;
                            thickness[fidx++] = 1;
                            //vertical lines
                            if (j > 0) {
                                var addx = (j == 1) ? 3 - (6 * (this._pSegmentsW - i) + 12 * i) : 3 - this._pSegmentsW * 12;
                                positions[vidx] = positions[vidx++ + addx];
                                positions[vidx] = positions[vidx++ + addx];
                                positions[vidx] = positions[vidx++ + addx];
                                positions[vidx++] = x;
                                positions[vidx++] = comp1;
                                positions[vidx++] = comp2;
                                thickness[fidx++] = 1;
                            }
                        }
                        //horizonal lines
                        if (i < this._pSegmentsW) {
                            positions[vidx++] = x;
                            positions[vidx++] = comp1;
                            positions[vidx++] = comp2;
                        }
                    }
                }
                // build real data from raw data
                lineGraphics.setPositions(positions);
                lineGraphics.setThickness(thickness);
            }
        };
        /**
         * @inheritDoc
         */
        PrimitiveCylinderPrefab.prototype._pBuildUVs = function (target, elementsType) {
            var i;
            var j;
            var x;
            var y;
            var revolutionAngle;
            var uvs;
            var stride;
            if (elementsType == ElementsType.TRIANGLE) {
                var triangleGraphics = target;
                // need to initialize raw array or can be reused?
                if (triangleGraphics.uvs && this._numVertices == triangleGraphics.numVertices) {
                    triangleGraphics.invalidateVertices(triangleGraphics.uvs);
                }
                else {
                    triangleGraphics.setUVs(new Float32Array(this._numVertices * 2));
                }
                uvs = triangleGraphics.uvs.get(this._numVertices);
                stride = triangleGraphics.uvs.stride;
                // evaluate revolution steps
                var revolutionAngleDelta = 2 * Math.PI / this._pSegmentsW;
                // current uv component index
                var index = 0;
                // top
                if (this._topClosed) {
                    uvs[index] = 0.5 * this._scaleU; // central vertex
                    uvs[index + 1] = 0.5 * this._scaleV;
                    index += stride;
                    for (i = 0; i <= this._pSegmentsW; ++i) {
                        revolutionAngle = i * revolutionAngleDelta;
                        x = 0.5 + 0.5 * -Math.cos(revolutionAngle);
                        y = 0.5 + 0.5 * Math.sin(revolutionAngle);
                        uvs[index] = x * this._scaleU; // revolution vertex
                        uvs[index + 1] = y * this._scaleV;
                        index += stride;
                    }
                }
                // bottom
                if (this._bottomClosed) {
                    uvs[index] = 0.5 * this._scaleU; // central vertex
                    uvs[index + 1] = 0.5 * this._scaleV;
                    index += stride;
                    for (i = 0; i <= this._pSegmentsW; ++i) {
                        revolutionAngle = i * revolutionAngleDelta;
                        x = 0.5 + 0.5 * Math.cos(revolutionAngle);
                        y = 0.5 + 0.5 * Math.sin(revolutionAngle);
                        uvs[index] = x * this._scaleU; // revolution vertex
                        uvs[index + 1] = y * this._scaleV;
                        index += stride;
                    }
                }
                // lateral surface
                if (this._surfaceClosed) {
                    for (j = 0; j <= this._pSegmentsH; ++j) {
                        for (i = 0; i <= this._pSegmentsW; ++i) {
                            // revolution vertex
                            uvs[index] = (i / this._pSegmentsW) * this._scaleU;
                            uvs[index + 1] = (j / this._pSegmentsH) * this._scaleV;
                            index += stride;
                        }
                    }
                }
            }
            else if (elementsType == ElementsType.LINE) {
                //nothing to do here
            }
        };
        return PrimitiveCylinderPrefab;
    }(PrimitivePrefabBase));

    /**
     * A UV Cone primitive sprite.
     */
    var PrimitiveConePrefab = /** @class */ (function (_super) {
        __extends$3(PrimitiveConePrefab, _super);
        /**
         * Creates a new Cone object.
         * @param radius The radius of the bottom end of the cone
         * @param height The height of the cone
         * @param segmentsW Defines the number of horizontal segments that make up the cone. Defaults to 16.
         * @param segmentsH Defines the number of vertical segments that make up the cone. Defaults to 1.
         * @param yUp Defines whether the cone poles should lay on the Y-axis (true) or on the Z-axis (false).
         */
        function PrimitiveConePrefab(material, elementsType, radius, height, segmentsW, segmentsH, closed, yUp) {
            if (material === void 0) { material = null; }
            if (elementsType === void 0) { elementsType = "triangle"; }
            if (radius === void 0) { radius = 50; }
            if (height === void 0) { height = 100; }
            if (segmentsW === void 0) { segmentsW = 16; }
            if (segmentsH === void 0) { segmentsH = 1; }
            if (closed === void 0) { closed = true; }
            if (yUp === void 0) { yUp = true; }
            return _super.call(this, material, elementsType, 0, radius, height, segmentsW, segmentsH, false, closed, true, yUp) || this;
        }
        Object.defineProperty(PrimitiveConePrefab.prototype, "radius", {
            /**
             * The radius of the bottom end of the cone.
             */
            get: function () {
                return this._pBottomRadius;
            },
            set: function (value) {
                this._pBottomRadius = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        return PrimitiveConePrefab;
    }(PrimitiveCylinderPrefab));

    /**
     * A Plane primitive sprite.
     */
    var PrimitivePlanePrefab = /** @class */ (function (_super) {
        __extends$3(PrimitivePlanePrefab, _super);
        /**
         * Creates a new Plane object.
         * @param width The width of the plane.
         * @param height The height of the plane.
         * @param segmentsW The number of segments that make up the plane along the X-axis.
         * @param segmentsH The number of segments that make up the plane along the Y or Z-axis.
         * @param yUp Defines whether the normal vector of the plane should point along the Y-axis (true) or Z-axis (false).
         * @param doubleSided Defines whether the plane will be visible from both sides, with correct vertex normals.
         */
        function PrimitivePlanePrefab(material, elementsType, width, height, segmentsW, segmentsH, yUp, doubleSided) {
            if (material === void 0) { material = null; }
            if (elementsType === void 0) { elementsType = "triangle"; }
            if (width === void 0) { width = 100; }
            if (height === void 0) { height = 100; }
            if (segmentsW === void 0) { segmentsW = 1; }
            if (segmentsH === void 0) { segmentsH = 1; }
            if (yUp === void 0) { yUp = true; }
            if (doubleSided === void 0) { doubleSided = false; }
            var _this = _super.call(this, material, elementsType) || this;
            _this._segmentsW = segmentsW;
            _this._segmentsH = segmentsH;
            _this._yUp = yUp;
            _this._width = width;
            _this._height = height;
            _this._doubleSided = doubleSided;
            return _this;
        }
        Object.defineProperty(PrimitivePlanePrefab.prototype, "segmentsW", {
            /**
             * The number of segments that make up the plane along the X-axis. Defaults to 1.
             */
            get: function () {
                return this._segmentsW;
            },
            set: function (value) {
                this._segmentsW = value;
                this._pInvalidatePrimitive();
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitivePlanePrefab.prototype, "segmentsH", {
            /**
             * The number of segments that make up the plane along the Y or Z-axis, depending on whether yUp is true or
             * false, respectively. Defaults to 1.
             */
            get: function () {
                return this._segmentsH;
            },
            set: function (value) {
                this._segmentsH = value;
                this._pInvalidatePrimitive();
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitivePlanePrefab.prototype, "yUp", {
            /**
             *  Defines whether the normal vector of the plane should point along the Y-axis (true) or Z-axis (false). Defaults to true.
             */
            get: function () {
                return this._yUp;
            },
            set: function (value) {
                this._yUp = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitivePlanePrefab.prototype, "doubleSided", {
            /**
             * Defines whether the plane will be visible from both sides, with correct vertex normals (as opposed to bothSides on Material). Defaults to false.
             */
            get: function () {
                return this._doubleSided;
            },
            set: function (value) {
                this._doubleSided = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitivePlanePrefab.prototype, "width", {
            /**
             * The width of the plane.
             */
            get: function () {
                return this._width;
            },
            set: function (value) {
                this._width = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitivePlanePrefab.prototype, "height", {
            /**
             * The height of the plane.
             */
            get: function () {
                return this._height;
            },
            set: function (value) {
                this._height = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        PrimitivePlanePrefab.prototype._pBuildGraphics = function (target, elementsType) {
            var indices;
            var x, y;
            var numIndices;
            var stride;
            var base;
            var tw = this._segmentsW + 1;
            var vidx, fidx; // indices
            var xi;
            var yi;
            if (elementsType == ElementsType.TRIANGLE) {
                var triangleGraphics = target;
                var numVertices = (this._segmentsH + 1) * tw;
                var positions;
                var normals;
                var tangents;
                if (this._doubleSided)
                    numVertices *= 2;
                numIndices = this._segmentsH * this._segmentsW * 6;
                if (this._doubleSided)
                    numIndices *= 2;
                if (triangleGraphics.indices != null && numIndices == triangleGraphics.indices.length) {
                    triangleGraphics.invalidateIndices();
                }
                else {
                    triangleGraphics.setIndices(new Uint16Array(numIndices));
                    this._pInvalidateUVs();
                }
                indices = triangleGraphics.indices.get(triangleGraphics.numElements);
                if (numVertices == triangleGraphics.numVertices) {
                    triangleGraphics.invalidateVertices(triangleGraphics.positions);
                    triangleGraphics.invalidateVertices(triangleGraphics.normals);
                    triangleGraphics.invalidateVertices(triangleGraphics.tangents);
                }
                else {
                    triangleGraphics.setPositions(new Float32Array(numVertices * 3));
                    triangleGraphics.setNormals(new Float32Array(numVertices * 3));
                    triangleGraphics.setTangents(new Float32Array(numVertices * 3));
                    this._pInvalidateUVs();
                }
                positions = triangleGraphics.positions.get(numVertices);
                normals = triangleGraphics.normals.get(numVertices);
                tangents = triangleGraphics.tangents.get(numVertices);
                stride = triangleGraphics.concatenatedBuffer.stride / 4;
                fidx = 0;
                vidx = 0;
                for (yi = 0; yi <= this._segmentsH; ++yi) {
                    for (xi = 0; xi <= this._segmentsW; ++xi) {
                        x = (xi / this._segmentsW - .5) * this._width;
                        y = (yi / this._segmentsH - .5) * this._height;
                        positions[vidx] = x;
                        if (this._yUp) {
                            positions[vidx + 1] = 0;
                            positions[vidx + 2] = y;
                        }
                        else {
                            positions[vidx + 1] = y;
                            positions[vidx + 2] = 0;
                        }
                        normals[vidx] = 0;
                        if (this._yUp) {
                            normals[vidx + 1] = 1;
                            normals[vidx + 2] = 0;
                        }
                        else {
                            normals[vidx + 1] = 0;
                            normals[vidx + 2] = -1;
                        }
                        tangents[vidx] = 1;
                        tangents[vidx + 1] = 0;
                        tangents[vidx + 2] = 0;
                        vidx += stride;
                        // add vertex with same position, but with inverted normal & tangent
                        if (this._doubleSided) {
                            for (var i = vidx; i < vidx + 3; ++i) {
                                positions[i] = positions[i - 3];
                                normals[i] = -normals[i - 3];
                                tangents[i] = -tangents[i - 3];
                            }
                            vidx += stride;
                        }
                        if (xi != this._segmentsW && yi != this._segmentsH) {
                            base = xi + yi * tw;
                            var mult = this._doubleSided ? 2 : 1;
                            indices[fidx++] = base * mult;
                            indices[fidx++] = (base + tw) * mult;
                            indices[fidx++] = (base + tw + 1) * mult;
                            indices[fidx++] = base * mult;
                            indices[fidx++] = (base + tw + 1) * mult;
                            indices[fidx++] = (base + 1) * mult;
                            if (this._doubleSided) {
                                indices[fidx++] = (base + tw + 1) * mult + 1;
                                indices[fidx++] = (base + tw) * mult + 1;
                                indices[fidx++] = base * mult + 1;
                                indices[fidx++] = (base + 1) * mult + 1;
                                indices[fidx++] = (base + tw + 1) * mult + 1;
                                indices[fidx++] = base * mult + 1;
                            }
                        }
                    }
                }
            }
            else if (elementsType == ElementsType.LINE) {
                var lineGraphics = target;
                var numSegments = (this._segmentsH + 1) + tw;
                var positions;
                var thickness;
                var hw = this._width / 2;
                var hh = this._height / 2;
                positions = new Float32Array(numSegments * 6);
                thickness = new Float32Array(numSegments);
                fidx = 0;
                vidx = 0;
                for (yi = 0; yi <= this._segmentsH; ++yi) {
                    positions[vidx++] = -hw;
                    positions[vidx++] = 0;
                    positions[vidx++] = yi * this._height - hh;
                    positions[vidx++] = hw;
                    positions[vidx++] = 0;
                    positions[vidx++] = yi * this._height - hh;
                    thickness[fidx++] = 1;
                }
                for (xi = 0; xi <= this._segmentsW; ++xi) {
                    positions[vidx++] = xi * this._width - hw;
                    positions[vidx++] = 0;
                    positions[vidx++] = -hh;
                    positions[vidx++] = xi * this._width - hw;
                    positions[vidx++] = 0;
                    positions[vidx++] = hh;
                    thickness[fidx++] = 1;
                }
                // build real data from raw data
                lineGraphics.setPositions(positions);
                lineGraphics.setThickness(thickness);
            }
        };
        /**
         * @inheritDoc
         */
        PrimitivePlanePrefab.prototype._pBuildUVs = function (target, elementsType) {
            var uvs;
            var stride;
            var numVertices;
            if (elementsType == ElementsType.TRIANGLE) {
                numVertices = (this._segmentsH + 1) * (this._segmentsW + 1);
                if (this._doubleSided)
                    numVertices *= 2;
                var triangleGraphics = target;
                if (triangleGraphics.uvs && numVertices == triangleGraphics.numVertices) {
                    triangleGraphics.invalidateVertices(triangleGraphics.uvs);
                }
                else {
                    triangleGraphics.setUVs(new Float32Array(numVertices * 2));
                }
                uvs = triangleGraphics.uvs.get(numVertices);
                stride = triangleGraphics.uvs.stride;
                var index = 0;
                for (var yi = 0; yi <= this._segmentsH; ++yi) {
                    for (var xi = 0; xi <= this._segmentsW; ++xi) {
                        uvs[index] = (xi / this._segmentsW) * this._scaleU;
                        uvs[index + 1] = (1 - yi / this._segmentsH) * this._scaleV;
                        index += stride;
                        if (this._doubleSided) {
                            uvs[index] = (xi / this._segmentsW) * this._scaleU;
                            uvs[index + 1] = (1 - yi / this._segmentsH) * this._scaleV;
                            index += stride;
                        }
                    }
                }
            }
            else if (elementsType == ElementsType.LINE) {
                //nothing to do here
            }
        };
        return PrimitivePlanePrefab;
    }(PrimitivePrefabBase));

    /**
     * A UV RegularPolygon primitive sprite.
     */
    var PrimitivePolygonPrefab = /** @class */ (function (_super) {
        __extends$3(PrimitivePolygonPrefab, _super);
        /**
         * Creates a new RegularPolygon disc object.
         * @param radius The radius of the regular polygon
         * @param sides Defines the number of sides of the regular polygon.
         * @param yUp Defines whether the regular polygon should lay on the Y-axis (true) or on the Z-axis (false).
         */
        function PrimitivePolygonPrefab(material, elementsType, radius, sides, yUp) {
            if (material === void 0) { material = null; }
            if (elementsType === void 0) { elementsType = "triangle"; }
            if (radius === void 0) { radius = 100; }
            if (sides === void 0) { sides = 16; }
            if (yUp === void 0) { yUp = true; }
            return _super.call(this, material, elementsType, radius, 0, 0, sides, 1, true, false, false, yUp) || this;
        }
        Object.defineProperty(PrimitivePolygonPrefab.prototype, "radius", {
            /**
             * The radius of the regular polygon.
             */
            get: function () {
                return this._pBottomRadius;
            },
            set: function (value) {
                this._pBottomRadius = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitivePolygonPrefab.prototype, "sides", {
            /**
             * The number of sides of the regular polygon.
             */
            get: function () {
                return this._pSegmentsW;
            },
            set: function (value) {
                this.setSegmentsW(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitivePolygonPrefab.prototype, "subdivisions", {
            /**
             * The number of subdivisions from the edge to the center of the regular polygon.
             */
            get: function () {
                return this._pSegmentsH;
            },
            set: function (value) {
                this.setSegmentsH(value);
            },
            enumerable: true,
            configurable: true
        });
        return PrimitivePolygonPrefab;
    }(PrimitiveCylinderPrefab));

    /**
     * A UV Cylinder primitive sprite.
     */
    var PrimitiveTorusPrefab = /** @class */ (function (_super) {
        __extends$3(PrimitiveTorusPrefab, _super);
        /**
         * Creates a new <code>Torus</code> object.
         * @param radius The radius of the torus.
         * @param tuebRadius The radius of the inner tube of the torus.
         * @param segmentsR Defines the number of horizontal segments that make up the torus.
         * @param segmentsT Defines the number of vertical segments that make up the torus.
         * @param yUp Defines whether the torus poles should lay on the Y-axis (true) or on the Z-axis (false).
         */
        function PrimitiveTorusPrefab(material, elementsType, radius, tubeRadius, segmentsR, segmentsT, yUp) {
            if (material === void 0) { material = null; }
            if (elementsType === void 0) { elementsType = "triangle"; }
            if (radius === void 0) { radius = 50; }
            if (tubeRadius === void 0) { tubeRadius = 50; }
            if (segmentsR === void 0) { segmentsR = 16; }
            if (segmentsT === void 0) { segmentsT = 8; }
            if (yUp === void 0) { yUp = true; }
            var _this = _super.call(this, material, elementsType) || this;
            _this._numVertices = 0;
            _this._radius = radius;
            _this._tubeRadius = tubeRadius;
            _this._segmentsR = segmentsR;
            _this._segmentsT = segmentsT;
            _this._yUp = yUp;
            return _this;
        }
        Object.defineProperty(PrimitiveTorusPrefab.prototype, "radius", {
            /**
             * The radius of the torus.
             */
            get: function () {
                return this._radius;
            },
            set: function (value) {
                this._radius = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveTorusPrefab.prototype, "tubeRadius", {
            /**
             * The radius of the inner tube of the torus.
             */
            get: function () {
                return this._tubeRadius;
            },
            set: function (value) {
                this._tubeRadius = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveTorusPrefab.prototype, "segmentsR", {
            /**
             * Defines the number of horizontal segments that make up the torus. Defaults to 16.
             */
            get: function () {
                return this._segmentsR;
            },
            set: function (value) {
                this._segmentsR = value;
                this._pInvalidatePrimitive();
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveTorusPrefab.prototype, "segmentsT", {
            /**
             * Defines the number of vertical segments that make up the torus. Defaults to 8.
             */
            get: function () {
                return this._segmentsT;
            },
            set: function (value) {
                this._segmentsT = value;
                this._pInvalidatePrimitive();
                this._pInvalidateUVs();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(PrimitiveTorusPrefab.prototype, "yUp", {
            /**
             * Defines whether the torus poles should lay on the Y-axis (true) or on the Z-axis (false).
             */
            get: function () {
                return this._yUp;
            },
            set: function (value) {
                this._yUp = value;
                this._pInvalidatePrimitive();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @inheritDoc
         */
        PrimitiveTorusPrefab.prototype._pBuildGraphics = function (target, elementsType) {
            var indices;
            var positions;
            var normals;
            var tangents;
            var stride;
            var i, j;
            var x, y, z, nx, ny, nz, revolutionAngleR, revolutionAngleT;
            var vidx;
            var fidx;
            var numIndices = 0;
            if (elementsType == ElementsType.TRIANGLE) {
                var triangleGraphics = target;
                // evaluate target number of vertices, triangles and indices
                this._numVertices = (this._segmentsT + 1) * (this._segmentsR + 1); // segmentsT + 1 because of closure, segmentsR + 1 because of closure
                numIndices = this._segmentsT * this._segmentsR * 6; // each level has segmentR quads, each of 2 triangles
                // need to initialize raw arrays or can be reused?
                if (this._numVertices == triangleGraphics.numVertices) {
                    triangleGraphics.invalidateIndices();
                    triangleGraphics.invalidateVertices(triangleGraphics.positions);
                    triangleGraphics.invalidateVertices(triangleGraphics.normals);
                    triangleGraphics.invalidateVertices(triangleGraphics.tangents);
                }
                else {
                    triangleGraphics.setIndices(new Uint16Array(numIndices));
                    triangleGraphics.setPositions(new Float32Array(this._numVertices * 3));
                    triangleGraphics.setNormals(new Float32Array(this._numVertices * 3));
                    triangleGraphics.setTangents(new Float32Array(this._numVertices * 3));
                    this._pInvalidateUVs();
                }
                indices = triangleGraphics.indices.get(triangleGraphics.numElements);
                positions = triangleGraphics.positions.get(this._numVertices);
                normals = triangleGraphics.normals.get(this._numVertices);
                tangents = triangleGraphics.tangents.get(this._numVertices);
                stride = triangleGraphics.concatenatedBuffer.stride / 4;
                vidx = 0;
                fidx = 0;
                // evaluate revolution steps
                var revolutionAngleDeltaR = 2 * Math.PI / this._segmentsR;
                var revolutionAngleDeltaT = 2 * Math.PI / this._segmentsT;
                var comp1, comp2;
                var t1, t2, n1, n2;
                var startIndex = 0;
                var nextVertexIndex = 0;
                // surface
                var a, b, c, d, length;
                for (j = 0; j <= this._segmentsT; ++j) {
                    startIndex = vidx;
                    for (i = 0; i <= this._segmentsR; ++i) {
                        // revolution vertex
                        revolutionAngleR = i * revolutionAngleDeltaR;
                        revolutionAngleT = j * revolutionAngleDeltaT;
                        length = Math.cos(revolutionAngleT);
                        nx = length * Math.cos(revolutionAngleR);
                        ny = length * Math.sin(revolutionAngleR);
                        nz = Math.sin(revolutionAngleT);
                        x = this._radius * Math.cos(revolutionAngleR) + this._tubeRadius * nx;
                        y = this._radius * Math.sin(revolutionAngleR) + this._tubeRadius * ny;
                        z = (j == this._segmentsT) ? 0 : this._tubeRadius * nz;
                        if (this._yUp) {
                            n1 = -nz;
                            n2 = ny;
                            t1 = 0;
                            t2 = (length ? nx / length : x / this._radius);
                            comp1 = -z;
                            comp2 = y;
                        }
                        else {
                            n1 = ny;
                            n2 = nz;
                            t1 = (length ? nx / length : x / this._radius);
                            t2 = 0;
                            comp1 = y;
                            comp2 = z;
                        }
                        if (i == this._segmentsR) {
                            positions[vidx] = x;
                            positions[vidx + 1] = positions[startIndex + 1];
                            positions[vidx + 2] = positions[startIndex + 2];
                        }
                        else {
                            positions[vidx] = x;
                            positions[vidx + 1] = comp1;
                            positions[vidx + 2] = comp2;
                        }
                        normals[vidx] = nx;
                        normals[vidx + 1] = n1;
                        normals[vidx + 2] = n2;
                        tangents[vidx] = -(length ? ny / length : y / this._radius);
                        tangents[vidx + 1] = t1;
                        tangents[vidx + 2] = t2;
                        vidx += stride;
                        // close triangle
                        if (i > 0 && j > 0) {
                            a = nextVertexIndex; // current
                            b = nextVertexIndex - 1; // previous
                            c = b - this._segmentsR - 1; // previous of last level
                            d = a - this._segmentsR - 1; // current of last level
                            indices[fidx++] = a;
                            indices[fidx++] = b;
                            indices[fidx++] = c;
                            indices[fidx++] = a;
                            indices[fidx++] = c;
                            indices[fidx++] = d;
                        }
                        nextVertexIndex++;
                    }
                }
            }
            else if (elementsType == ElementsType.LINE) {
                //TODO
            }
        };
        /**
         * @inheritDoc
         */
        PrimitiveTorusPrefab.prototype._pBuildUVs = function (target, elementsType) {
            var i, j;
            var uvs;
            var stride;
            if (elementsType == ElementsType.TRIANGLE) {
                var triangleGraphics = target;
                // need to initialize raw array or can be reused?
                if (triangleGraphics.uvs && this._numVertices == triangleGraphics.numVertices) {
                    triangleGraphics.invalidateVertices(triangleGraphics.uvs);
                }
                else {
                    triangleGraphics.setUVs(new Float32Array(this._numVertices * 2));
                }
                uvs = triangleGraphics.uvs.get(this._numVertices);
                stride = triangleGraphics.uvs.stride;
                // current uv component index
                var index = 0;
                // surface
                for (j = 0; j <= this._segmentsT; ++j) {
                    for (i = 0; i <= this._segmentsR; ++i) {
                        // revolution vertex
                        uvs[index] = (i / this._segmentsR) * this._scaleU;
                        uvs[index + 1] = (j / this._segmentsT) * this._scaleV;
                        index += stride;
                    }
                }
            }
            else if (elementsType == ElementsType.LINE) {
                //nothing to do here
            }
        };
        return PrimitiveTorusPrefab;
    }(PrimitivePrefabBase));

    /**
     * The AntiAliasType class provides values for anti-aliasing in the
     * away.text.TextField class.
     */

    /**
     * The GridFitType class defines values for grid fitting in the TextField class.
     */

    /**
     * A class that defines the Interactive mode of a text field object.
     *
     * @see away.entities.TextField#textInteractionMode
     */

    /**
     *  Class Merge merges two or more static sprites into one.<code>Merge</code>
     */
    var Merge = /** @class */ (function () {
        /**
         * @param    keepMaterial    [optional]    Determines if the merged object uses the recevier sprite material information or keeps its source material(s). Defaults to false.
         * If false and receiver object has multiple materials, the last material found in receiver subsprites is applied to the merged subsprite(es).
         * @param    disposeSources  [optional]    Determines if the sprite and geometry source(s) used for the merging are disposed. Defaults to false.
         * If true, only receiver geometry and resulting sprite are kept in  memory.
         * @param    objectSpace     [optional]    Determines if source sprite(es) is/are merged using objectSpace or worldspace. Defaults to false.
         */
        function Merge(keepMaterial, disposeSources, objectSpace) {
            if (keepMaterial === void 0) { keepMaterial = false; }
            if (disposeSources === void 0) { disposeSources = false; }
            if (objectSpace === void 0) { objectSpace = false; }
            this._keepMaterial = keepMaterial;
            this._disposeSources = disposeSources;
            this._objectSpace = objectSpace;
        }
        Object.defineProperty(Merge.prototype, "disposeSources", {
            get: function () {
                return this._disposeSources;
            },
            /**
             * Determines if the sprite and geometry source(s) used for the merging are disposed. Defaults to false.
             */
            set: function (b) {
                this._disposeSources = b;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Merge.prototype, "keepMaterial", {
            get: function () {
                return this._keepMaterial;
            },
            /**
             * Determines if the material source(s) used for the merging are disposed. Defaults to false.
             */
            set: function (b) {
                this._keepMaterial = b;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Merge.prototype, "objectSpace", {
            get: function () {
                return this._objectSpace;
            },
            /**
             * Determines if source sprite(es) is/are merged using objectSpace or worldspace. Defaults to false.
             */
            set: function (b) {
                this._objectSpace = b;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Merges all the children of a container into a single Sprite. If no Sprite object is found, method returns the receiver without modification.
         *
         * @param    receiver           The Sprite to receive the merged contents of the container.
         * @param    objectContainer    The DisplayObjectContainer holding the sprites to be mergd.
         *
         * @return The merged Sprite instance.
         */
        Merge.prototype.applyToContainer = function (receiver, objectContainer) {
            this.reset();
            //collect container sprites
            this.parseContainer(receiver, objectContainer);
            //collect receiver
            this.collect(receiver, false);
            //merge to receiver
            this.merge(receiver, this._disposeSources);
        };
        /**
         * Merges all the sprites found in the Array&lt;Sprite&gt; into a single Sprite.
         *
         * @param    receiver    The Sprite to receive the merged contents of the sprites.
         * @param    sprites      A series of Sprites to be merged with the reciever sprite.
         */
        Merge.prototype.applyToSprites = function (receiver, sprites) {
            this.reset();
            if (!sprites.length)
                return;
            //collect sprites in vector
            for (var i = 0; i < sprites.length; i++)
                if (sprites[i] != receiver)
                    this.collect(sprites[i], this._disposeSources);
            //collect receiver
            this.collect(receiver, false);
            //merge to receiver
            this.merge(receiver, this._disposeSources);
        };
        /**
         *  Merges 2 sprites into one. It is recommand to use apply when 2 sprites are to be merged. If more need to be merged, use either applyToSprites or applyToContainer methods.
         *
         * @param    receiver    The Sprite to receive the merged contents of both sprites.
         * @param    sprite        The Sprite to be merged with the receiver sprite
         */
        Merge.prototype.apply = function (receiver, sprite) {
            this.reset();
            //collect sprite
            this.collect(sprite, this._disposeSources);
            //collect receiver
            this.collect(receiver, false);
            //merge to receiver
            this.merge(receiver, this._disposeSources);
        };
        Merge.prototype.reset = function () {
            this._toDispose = new Array();
            this._shapeVOs = new Array();
        };
        Merge.prototype.merge = function (destSprite, dispose) {
            var i;
            //var oldGraphics:Graphics;
            var destGraphics;
            var useSubMaterials;
            //oldGraphics = destSprite.graphics.clone();
            destGraphics = destSprite.graphics;
            // Only apply materials directly to sub-sprites if necessary,
            // i.e. if there is more than one material available.
            useSubMaterials = (this._shapeVOs.length > 1);
            for (i = 0; i < this._shapeVOs.length; i++) {
                var elements = new TriangleElements(new AttributesBuffer());
                elements.autoDeriveNormals = false;
                elements.autoDeriveTangents = false;
                var data = this._shapeVOs[i];
                elements.setIndices(data.indices);
                elements.setPositions(data.vertices);
                elements.setNormals(data.normals);
                elements.setTangents(data.tangents);
                elements.setUVs(data.uvs);
                if (this._keepMaterial && useSubMaterials)
                    destGraphics.addShape(Shape.getShape(elements, data.material));
                else
                    destGraphics.addShape(Shape.getShape(elements));
            }
            if (this._keepMaterial && !useSubMaterials && this._shapeVOs.length)
                destSprite.material = this._shapeVOs[0].material;
            if (dispose) {
                var len = this._toDispose.length;
                for (var i; i < len; i++)
                    this._toDispose[i].dispose();
            }
            this._toDispose = null;
        };
        Merge.prototype.collect = function (sprite, dispose) {
            var subIdx;
            var calc;
            for (subIdx = 0; subIdx < sprite.graphics.count; subIdx++) {
                var i;
                var len;
                var iIdx, vIdx, nIdx, tIdx, uIdx;
                var indexOffset;
                var elements;
                var vo;
                var vertices;
                var normals;
                var tangents;
                var ind;
                elements = sprite.graphics.getShapeAt(subIdx).elements;
                // Get (or create) a VO for this material
                vo = this.getShapeData(sprite.graphics.getShapeAt(subIdx).material);
                // Vertices and normals are copied to temporary vectors, to be transformed
                // before concatenated onto those of the data. This is unnecessary if no
                // transformation will be performed, i.e. for object space merging.
                vertices = (this._objectSpace) ? vo.vertices : new Array();
                normals = (this._objectSpace) ? vo.normals : new Array();
                tangents = (this._objectSpace) ? vo.tangents : new Array();
                // Copy over vertex attributes
                vIdx = vertices.length;
                nIdx = normals.length;
                tIdx = tangents.length;
                uIdx = vo.uvs.length;
                this.copyAttributes(elements.positions, vertices, elements.numVertices, vIdx);
                this.copyAttributes(elements.normals, normals, elements.numVertices, nIdx);
                this.copyAttributes(elements.tangents, tangents, elements.numVertices, tIdx);
                this.copyAttributes(elements.uvs, vo.uvs, elements.numVertices, uIdx);
                // Copy over triangle indices
                indexOffset = (!this._objectSpace) ? vo.vertices.length / 3 : 0;
                iIdx = vo.indices.length;
                len = elements.numElements;
                ind = elements.indices.get(len);
                for (i = 0; i < len; i++) {
                    calc = i * 3;
                    vo.indices[iIdx++] = ind[calc] + indexOffset;
                    vo.indices[iIdx++] = ind[calc + 1] + indexOffset;
                    vo.indices[iIdx++] = ind[calc + 2] + indexOffset;
                }
                if (!this._objectSpace) {
                    sprite.transform.concatenatedMatrix3D.transformVectors(vertices, vertices);
                    sprite.transform.concatenatedMatrix3D.deltaTransformVectors(normals, normals);
                    sprite.transform.concatenatedMatrix3D.deltaTransformVectors(tangents, tangents);
                    // Copy vertex data from temporary (transformed) vectors
                    vIdx = vo.vertices.length;
                    nIdx = vo.normals.length;
                    tIdx = vo.tangents.length;
                    len = vertices.length;
                    for (i = 0; i < len; i++) {
                        vo.vertices[vIdx++] = vertices[i];
                        vo.normals[nIdx++] = normals[i];
                        vo.tangents[tIdx++] = tangents[i];
                    }
                }
            }
            if (dispose)
                this._toDispose.push(sprite);
        };
        Merge.prototype.copyAttributes = function (attributes, array, count, startIndex) {
            var vertices = attributes.get(count);
            var dim = attributes.dimensions;
            var stride = attributes.stride;
            var len = count * stride;
            for (var i = 0; i < len; i += stride)
                for (var j = 0; j < dim; j++)
                    array[startIndex++] = vertices[i + j];
        };
        Merge.prototype.getShapeData = function (material) {
            var data;
            if (this._keepMaterial) {
                var i;
                var len;
                len = this._shapeVOs.length;
                for (i = 0; i < len; i++) {
                    if (this._shapeVOs[i].material == material) {
                        data = this._shapeVOs[i];
                        break;
                    }
                }
            }
            else if (this._shapeVOs.length) {
                // If materials are not to be kept, all data can be
                // put into a single VO, so return that one.
                data = this._shapeVOs[0];
            }
            // No data (for this material) found, create new.
            if (!data) {
                data = new ShapeVO();
                data.vertices = new Array();
                data.normals = new Array();
                data.tangents = new Array();
                data.uvs = new Array();
                data.indices = new Array();
                data.material = material;
                this._shapeVOs.push(data);
            }
            return data;
        };
        Merge.prototype.parseContainer = function (receiver, object) {
            var child;
            var i;
            if (object instanceof Sprite && object != receiver)
                this.collect(object, this._disposeSources);
            for (i = 0; i < object.numChildren; ++i) {
                child = object.getChildAt(i);
                this.parseContainer(receiver, child);
            }
        };
        return Merge;
    }());
    var ShapeVO = /** @class */ (function () {
        function ShapeVO() {
        }
        return ShapeVO;
    }());

    var Scene = /** @class */ (function () {
        /*
         ***********************************************************************
         * Disabled / Not yet implemented
         ***********************************************************************
         *
         * private _background:away.textures.Texture2DBase;
         *
         * public _pTouch3DManager:away.managers.Touch3DManager;
         *
         */
        function Scene(partition, camera, view, rendererType) {
            var _this = this;
            if (partition === void 0) { partition = null; }
            if (camera === void 0) { camera = null; }
            if (view === void 0) { view = null; }
            if (rendererType === void 0) { rendererType = null; }
            this._time = 0;
            this._deltaTime = 0;
            this._touchPoints = new Array();
            this._onProjectionChangedDelegate = function (event) { return _this._onProjectionChanged(event); };
            this._rendererType = rendererType || RendererType.DEFAULT;
            this.view = view || new View();
            this.partition = partition || new BasicPartition(new DisplayObjectContainer());
            this.camera = camera || new Camera();
            //			if (this._shareContext)
            //				this._mouse3DManager.addViewLayer(this);
        }
        Object.defineProperty(Scene.prototype, "partition", {
            get: function () {
                return this._partition;
            },
            set: function (value) {
                if (this._partition == value)
                    return;
                this._partition = value;
                this._mousePicker = this._pickGroup.getRaycastPicker(this._partition);
                this._tabPicker = this._pickGroup.getTabPicker(this._partition);
                this._mousePicker.findClosestCollision = true;
                if (this._camera) {
                    this._camera.clear();
                    this._partition.invalidateEntity(this._camera);
                    this._camera.partition = this._partition;
                }
                this._mousePicker = this._pickGroup.getRaycastPicker(this._partition);
                this._tabPicker = this._pickGroup.getTabPicker(this._partition);
                this._mousePicker.findClosestCollision = true;
                this._partition.root.partition = this._partition;
                //this._disposeRenderer();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "view", {
            get: function () {
                return this._view;
            },
            set: function (value) {
                if (this._view == value)
                    return;
                if (this._view)
                    this._mouseManager.unregisterContainer(this._view.stage.container);
                this._view = value;
                this._pickGroup = PickGroup.getInstance(this._view);
                this._mouseManager = MouseManager.getInstance(this._pickGroup);
                this._mouseManager.registerContainer(this._view.stage.container);
                this._mouseManager.registerScene(this);
                if (this._camera)
                    this._view.projection = this._camera.projection;
                this._disposeRenderer();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "renderer", {
            get: function () {
                if (!this._renderer)
                    this._renderer = RenderGroup.getInstance(this._view, this._rendererType).getRenderer(this._partition);
                return this._renderer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "root", {
            get: function () {
                return this._partition.root;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "mouseX", {
            get: function () {
                return this._mouseX;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "mouseY", {
            get: function () {
                return this._mouseY;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "touchPoints", {
            get: function () {
                return this._touchPoints;
            },
            enumerable: true,
            configurable: true
        });
        Scene.prototype.getLocalMouseX = function (entity) {
            return entity.transform.inverseConcatenatedMatrix3D.transformVector(this._renderer.view.unproject(this._mouseX, this._mouseY, 1000)).x;
        };
        Scene.prototype.getLocalMouseY = function (entity) {
            return entity.transform.inverseConcatenatedMatrix3D.transformVector(this._renderer.view.unproject(this._mouseX, this._mouseY, 1000)).y;
        };
        Scene.prototype.getLocalTouchPoints = function (entity) {
            var localPosition;
            var localTouchPoints = new Array();
            var len = this._touchPoints.length;
            for (var i = 0; i < len; i++) {
                localPosition = entity.transform.inverseConcatenatedMatrix3D.transformVector(this._renderer.view.unproject(this._touchPoints[i].x, this._touchPoints[i].y, 1000));
                localTouchPoints.push(new TouchPoint(localPosition.x, localPosition.y, this._touchPoints[i].id));
            }
            return localTouchPoints;
        };
        Object.defineProperty(Scene.prototype, "rendererType", {
            /**
             *
             */
            get: function () {
                return this._rendererType;
            },
            set: function (value) {
                if (this._rendererType == value)
                    return;
                this._rendererType = value;
                this._disposeRenderer();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "camera", {
            /**
             *
             * @returns {Camera3D}
             */
            get: function () {
                return this._camera;
            },
            /**
             * Set camera that's used to render the scene for this view
             */
            set: function (value) {
                if (this._camera == value)
                    return;
                if (this._camera) {
                    this._camera.clear();
                    this._camera.removeEventListener(CameraEvent.PROJECTION_CHANGED, this._onProjectionChangedDelegate);
                }
                this._camera = value;
                this._camera.addEventListener(CameraEvent.PROJECTION_CHANGED, this._onProjectionChangedDelegate);
                if (this._view)
                    this._view.projection = this._camera.projection;
                this._partition.invalidateEntity(this._camera);
                this._camera.partition = this._partition;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "deltaTime", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                return this._deltaTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "mouseManager", {
            get: function () {
                return this._mouseManager;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "mousePicker", {
            /**
             *
             */
            get: function () {
                return this._mousePicker;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "tabPicker", {
            /**
             *
             */
            get: function () {
                return this._tabPicker;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "renderedFacesCount", {
            /**
             *
             * @returns {number}
             */
            get: function () {
                return 0; //TODO
                //return this._pEntityCollector._pNumTriangles;//numTriangles;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Renders the view.
         */
        Scene.prototype.render = function () {
            this._updateTime();
            if (!this._renderer)
                this._renderer = RenderGroup.getInstance(this._view, this._rendererType).getRenderer(this._partition);
            // update picking
            if (!this.disableMouseEvents) {
                if (this.forceMouseMove && !this._mouseManager._iUpdateDirty)
                    this._mouseManager._iCollision = this.getViewCollision(this._mouseX, this._mouseY, this._view);
                this._mouseManager.fireMouseEvents(this.forceMouseMove);
                //_touch3DManager.fireTouchEvents();
            }
            if (this.beforeRenderCallback) {
                this.beforeRenderCallback();
            }
            //_touch3DManager.updateCollider();
            //render the contents of the scene
            this._renderer.render();
        };
        /**
         *
         */
        Scene.prototype._updateTime = function () {
            var time = getTimer();
            if (this._time == 0)
                this._time = time;
            this._deltaTime = time - this._time;
            this._time = time;
        };
        Scene.prototype._disposeRenderer = function () {
            if (this._renderer) {
                this._renderer.dispose();
                this._renderer = null;
            }
        };
        /**
         *
         */
        Scene.prototype.dispose = function () {
            this._disposeRenderer();
            // TODO: imeplement mouseManager / touch3DManager
            this._mouseManager.unregisterScene(this);
            //this._touch3DManager.disableTouchListeners(this);
            //this._touch3DManager.dispose();
            this._mouseManager = null;
            //this._touch3DManager = null;
        };
        /**
         *
         */
        Scene.prototype._onProjectionChanged = function (event) {
            this._view.projection = this._camera.projection;
        };
        /*TODO: implement Background
         public get background():away.textures.Texture2DBase
         {
         return this._background;
         }
         */
        /*TODO: implement Background
         public set background( value:away.textures.Texture2DBase )
         {
         this._background = value;
         this._renderer.background = _background;
         }
         */
        // TODO: required dependency stageGL
        Scene.prototype.updateCollider = function () {
            if (!this.disableMouseEvents) {
                // if (!this._renderer.shareContext) {
                this._mouseManager._iCollision = this.getViewCollision(this._mouseX, this._mouseY, this._view);
                // } else {
                // 	var collidingObject:PickingCollision = this.getViewCollision(this._mouseX, this._mouseY, this);
                //
                // 	if (this.layeredView || this._mouseManager._iCollision == null || collidingObject.rayEntryDistance < this._mouseManager._iCollision.rayEntryDistance)
                // 		this._mouseManager._iCollision = collidingObject;
                // }
            }
        };
        Scene.prototype.getViewCollision = function (x, y, view) {
            //update ray
            var rayPosition = view.unproject(x, y, 0);
            var rayDirection = view.unproject(x, y, 1).subtract(rayPosition);
            return this._mousePicker.getCollision(rayPosition, rayDirection);
        };
        return Scene;
    }());

    console.debug("AwayJS - Scene - 0.12.62");

    var jsGlobal = Function('return this')();

    function pow2(exponent) {
        if (exponent === (exponent | 0)) {
            if (exponent < 0) {
                return 1 / (1 << -exponent);
            }
            return 1 << exponent;
        }
        return Math.pow(2, exponent);
    }
    function clamp$1(value, min, max) {
        return Math.max(min, Math.min(max, value));
    }
    /**
     * Rounds *.5 to the nearest even number.
     * See https://en.wikipedia.org/wiki/Rounding#Round_half_to_even for details.
     */
    function roundHalfEven(value) {
        if (Math.abs(value % 1) === 0.5) {
            var floor = Math.floor(value);
            return floor % 2 === 0 ? floor : Math.ceil(value);
        }
        return Math.round(value);
    }
    /**
     * Rounds *.5 up on even occurrences, down on odd occurrences.
     * See https://en.wikipedia.org/wiki/Rounding#Alternating_tie-breaking for details.
     */
    function altTieBreakRound(value, even) {
        if (Math.abs(value % 1) === 0.5 && !even) {
            return value | 0;
        }
        return Math.round(value);
    }
    function epsilonEquals(value, other) {
        return Math.abs(value - other) < 0.0000001;
    }
    var NumberUtilities = {
        pow2: pow2,
        clamp: clamp$1,
        roundHalfEven: roundHalfEven,
        altTieBreakRound: altTieBreakRound,
        epsilonEquals: epsilonEquals
    };

    function repeatString(c, n) {
        var s = "";
        for (var i = 0; i < n; i++) {
            s += c;
        }
        return s;
    }
    function memorySizeToString(value) {
        value |= 0;
        var K = 1024;
        var M = K * K;
        if (value < K) {
            return value + " B";
        }
        else if (value < M) {
            return (value / K).toFixed(2) + "KB";
        }
        else {
            return (value / M).toFixed(2) + "MB";
        }
    }
    /**
     * Returns a reasonably sized description of the |value|, to be used for debugging purposes.
     */
    function toSafeString(value) {
        if (typeof value === "string") {
            return "\"" + value + "\"";
        }
        if (typeof value === "number" || typeof value === "boolean") {
            return String(value);
        }
        if (value instanceof Array) {
            return "[] " + value.length;
        }
        return typeof value;
    }
    function toSafeArrayString(array) {
        var str = [];
        for (var i = 0; i < array.length; i++) {
            str.push(toSafeString(array[i]));
        }
        return str.join(", ");
    }
    function utf8decode$1(str) {
        var bytes = new Uint8Array(str.length * 4);
        var b = 0;
        for (var i = 0, j = str.length; i < j; i++) {
            var code = str.charCodeAt(i);
            if (code <= 0x7f) {
                bytes[b++] = code;
                continue;
            }
            if (0xD800 <= code && code <= 0xDBFF) {
                var codeLow = str.charCodeAt(i + 1);
                if (0xDC00 <= codeLow && codeLow <= 0xDFFF) {
                    // convert only when both high and low surrogates are present
                    code = ((code & 0x3FF) << 10) + (codeLow & 0x3FF) + 0x10000;
                    ++i;
                }
            }
            if ((code & 0xFFE00000) !== 0) {
                bytes[b++] = 0xF8 | ((code >>> 24) & 0x03);
                bytes[b++] = 0x80 | ((code >>> 18) & 0x3F);
                bytes[b++] = 0x80 | ((code >>> 12) & 0x3F);
                bytes[b++] = 0x80 | ((code >>> 6) & 0x3F);
                bytes[b++] = 0x80 | (code & 0x3F);
            }
            else if ((code & 0xFFFF0000) !== 0) {
                bytes[b++] = 0xF0 | ((code >>> 18) & 0x07);
                bytes[b++] = 0x80 | ((code >>> 12) & 0x3F);
                bytes[b++] = 0x80 | ((code >>> 6) & 0x3F);
                bytes[b++] = 0x80 | (code & 0x3F);
            }
            else if ((code & 0xFFFFF800) !== 0) {
                bytes[b++] = 0xE0 | ((code >>> 12) & 0x0F);
                bytes[b++] = 0x80 | ((code >>> 6) & 0x3F);
                bytes[b++] = 0x80 | (code & 0x3F);
            }
            else {
                bytes[b++] = 0xC0 | ((code >>> 6) & 0x1F);
                bytes[b++] = 0x80 | (code & 0x3F);
            }
        }
        return bytes.subarray(0, b);
    }
    function utf8encode$1(bytes) {
        var j = 0, str = "";
        while (j < bytes.length) {
            var b1 = bytes[j++] & 0xFF;
            if (b1 <= 0x7F) {
                str += String.fromCharCode(b1);
            }
            else {
                var currentPrefix = 0xC0;
                var validBits = 5;
                do {
                    var mask = (currentPrefix >> 1) | 0x80;
                    if ((b1 & mask) === currentPrefix)
                        break;
                    currentPrefix = (currentPrefix >> 1) | 0x80;
                    --validBits;
                } while (validBits >= 0);
                if (validBits <= 0) {
                    // Invalid UTF8 character -- copying as is
                    str += String.fromCharCode(b1);
                    continue;
                }
                var code = (b1 & ((1 << validBits) - 1));
                var invalid = false;
                for (var i = 5; i >= validBits; --i) {
                    var bi = bytes[j++];
                    if ((bi & 0xC0) != 0x80) {
                        // Invalid UTF8 character sequence
                        invalid = true;
                        break;
                    }
                    code = (code << 6) | (bi & 0x3F);
                }
                if (invalid) {
                    // Copying invalid sequence as is
                    for (var k = j - (7 - i); k < j; ++k) {
                        str += String.fromCharCode(bytes[k] & 255);
                    }
                    continue;
                }
                if (code >= 0x10000) {
                    str += String.fromCharCode((((code - 0x10000) >> 10) & 0x3FF) |
                        0xD800, (code & 0x3FF) | 0xDC00);
                }
                else {
                    str += String.fromCharCode(code);
                }
            }
        }
        return str;
    }
    // https://gist.github.com/958841
    function base64EncodeBytes(bytes) {
        var base64 = '';
        var encodings = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
        var byteLength = bytes.byteLength;
        var byteRemainder = byteLength % 3;
        var mainLength = byteLength - byteRemainder;
        var a, b, c, d;
        var chunk;
        // Main loop deals with bytes in chunks of 3
        for (var i = 0; i < mainLength; i = i + 3) {
            // Combine the three bytes into a single integer
            chunk = (bytes[i] << 16) | (bytes[i + 1] << 8) | bytes[i + 2];
            // Use bitmasks to extract 6-bit segments from the triplet
            a = (chunk & 16515072) >> 18; // 16515072 = (2^6 - 1) << 18
            b = (chunk & 258048) >> 12; // 258048 = (2^6 - 1) << 12
            c = (chunk & 4032) >> 6; // 4032 = (2^6 - 1) << 6
            d = chunk & 63; // 63 = 2^6 - 1
            // Convert the raw binary segments to the appropriate ASCII encoding
            base64 += concat4(encodings[a], encodings[b], encodings[c], encodings[d]);
        }
        // Deal with the remaining bytes and padding
        if (byteRemainder == 1) {
            chunk = bytes[mainLength];
            a = (chunk & 252) >> 2; // 252 = (2^6 - 1) << 2
            // Set the 4 least significant bits to zero
            b = (chunk & 3) << 4; // 3 = 2^2 - 1
            base64 += concat3(encodings[a], encodings[b], '==');
        }
        else if (byteRemainder == 2) {
            chunk = (bytes[mainLength] << 8) | bytes[mainLength + 1];
            a = (chunk & 64512) >> 10; // 64512 = (2^6 - 1) << 10
            b = (chunk & 1008) >> 4; // 1008 = (2^6 - 1) << 4
            // Set the 2 least significant bits to zero
            c = (chunk & 15) << 2; // 15 = 2^4 - 1
            base64 += concat4(encodings[a], encodings[b], encodings[c], '=');
        }
        return base64;
    }
    var base64DecodeMap = [
        62, 0, 0, 0, 63, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
        0, 0, 0, 0, 0, 0, 0,
        0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
        19, 20, 21, 22, 23, 24, 25, 0, 0, 0, 0, 0, 0,
        26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43,
        44, 45, 46, 47, 48, 49, 50, 51
    ];
    var base64DecodeMapOffset = 0x2B;
    var base64EOF = 0x3D;
    /**
     * Decodes the result of encoding with base64EncodeBytes, but not necessarily any other
     * base64-encoded data. Note that this also doesn't do any error checking.
     */
    function decodeRestrictedBase64ToBytes(encoded) {
        var ch;
        var code;
        var code2;
        var len = encoded.length;
        var padding = encoded.charAt(len - 2) === '=' ? 2 : encoded.charAt(len - 1) === '=' ? 1 : 0;
        release$1 || assert$2(encoded.length % 4 === 0);
        var decoded = new Uint8Array((encoded.length >> 2) * 3 - padding);
        for (var i = 0, j = 0; i < encoded.length;) {
            ch = encoded.charCodeAt(i++);
            code = base64DecodeMap[ch - base64DecodeMapOffset];
            ch = encoded.charCodeAt(i++);
            code2 = base64DecodeMap[ch - base64DecodeMapOffset];
            decoded[j++] = (code << 2) | ((code2 & 0x30) >> 4);
            ch = encoded.charCodeAt(i++);
            if (ch == base64EOF) {
                return decoded;
            }
            code = base64DecodeMap[ch - base64DecodeMapOffset];
            decoded[j++] = ((code2 & 0x0f) << 4) | ((code & 0x3c) >> 2);
            ch = encoded.charCodeAt(i++);
            if (ch == base64EOF) {
                return decoded;
            }
            code2 = base64DecodeMap[ch - base64DecodeMapOffset];
            decoded[j++] = ((code & 0x03) << 6) | code2;
        }
        return decoded;
    }
    function escapeString(str) {
        if (str !== undefined) {
            str = str.replace(/[^\w$]/gi, "$"); /* No dots, colons, dashes and /s */
            if (/^\d/.test(str)) { /* No digits at the beginning */
                str = '$' + str;
            }
        }
        return str;
    }
    /**
     * Workaround for max stack size limit.
     */
    function fromCharCodeArray(buffer) {
        var str = "", SLICE = 1024 * 16;
        for (var i = 0; i < buffer.length; i += SLICE) {
            var chunk = Math.min(buffer.length - i, SLICE);
            str += String.fromCharCode.apply(null, buffer.subarray(i, i + chunk));
        }
        return str;
    }
    var _encoding = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789$_';
    function variableLengthEncodeInt32(n) {
        var e = _encoding;
        var bitCount = (32 - Math.clz32(n));
        release$1 || assert$2(bitCount <= 32, bitCount);
        var l = Math.ceil(bitCount / 6);
        // Encode length followed by six bit chunks.
        var s = e[l];
        for (var i = l - 1; i >= 0; i--) {
            var offset = (i * 6);
            s += e[(n >> offset) & 0x3F];
        }
        release$1 || assert$2(StringUtilities.variableLengthDecodeInt32(s) === n, n + " : " + s + " - " + l + " bits: " + bitCount);
        return s;
    }
    function toEncoding(n) {
        return _encoding[n];
    }
    function fromEncoding(c) {
        if (c >= 65 && c <= 90) {
            return c - 65;
        }
        else if (c >= 97 && c <= 122) {
            return c - 71;
        }
        else if (c >= 48 && c <= 57) {
            return c + 4;
        }
        else if (c === 36) {
            return 62;
        }
        else if (c === 95) {
            return 63;
        }
        release$1 || assert$2(false, "Invalid Encoding");
    }
    function variableLengthDecodeInt32(s) {
        var l = fromEncoding(s.charCodeAt(0));
        var n = 0;
        for (var i = 0; i < l; i++) {
            var offset = ((l - i - 1) * 6);
            n |= fromEncoding(s.charCodeAt(1 + i)) << offset;
        }
        return n;
    }
    function trimMiddle(s, maxLength) {
        if (s.length <= maxLength) {
            return s;
        }
        var leftHalf = maxLength >> 1;
        var rightHalf = maxLength - leftHalf - 1;
        return s.substr(0, leftHalf) + "\u2026" + s.substr(s.length - rightHalf, rightHalf);
    }
    function multiple(s, count) {
        var o = "";
        for (var i = 0; i < count; i++) {
            o += s;
        }
        return o;
    }
    function indexOfAny(s, chars, position) {
        var index = s.length;
        for (var i = 0; i < chars.length; i++) {
            var j = s.indexOf(chars[i], position);
            if (j >= 0) {
                index = Math.min(index, j);
            }
        }
        return index === s.length ? -1 : index;
    }
    var _concat3array = new Array(3);
    var _concat4array = new Array(4);
    var _concat9array = new Array(9);
    /**
     * The concatN() functions concatenate multiple strings in a way that
     * avoids creating intermediate strings, unlike String.prototype.concat().
     *
     * Note that these functions don't have identical behaviour to using '+',
     * because they will ignore any arguments that are |undefined| or |null|.
     * This usually doesn't matter.
     */
    function concat3(s0, s1, s2) {
        _concat3array[0] = s0;
        _concat3array[1] = s1;
        _concat3array[2] = s2;
        return _concat3array.join('');
    }
    function concat4(s0, s1, s2, s3) {
        _concat4array[0] = s0;
        _concat4array[1] = s1;
        _concat4array[2] = s2;
        _concat4array[3] = s3;
        return _concat4array.join('');
    }
    function concat9(s0, s1, s2, s3, s4, s5, s6, s7, s8) {
        _concat9array[0] = s0;
        _concat9array[1] = s1;
        _concat9array[2] = s2;
        _concat9array[3] = s3;
        _concat9array[4] = s4;
        _concat9array[5] = s5;
        _concat9array[6] = s6;
        _concat9array[7] = s7;
        _concat9array[8] = s8;
        return _concat9array.join('');
    }
    var StringUtilities = {
        repeatString: repeatString,
        memorySizeToString: memorySizeToString,
        toSafeString: toSafeString,
        toSafeArrayString: toSafeArrayString,
        utf8decode: utf8decode$1,
        utf8encode: utf8encode$1,
        base64EncodeBytes: base64EncodeBytes,
        base64DecodeMap: base64DecodeMap,
        base64DecodeMapOffset: base64DecodeMapOffset,
        base64EOF: base64EOF,
        decodeRestrictedBase64ToBytes: decodeRestrictedBase64ToBytes,
        escapeString: escapeString,
        fromCharCodeArray: fromCharCodeArray,
        variableLengthEncodeInt32: variableLengthEncodeInt32,
        toEncoding: toEncoding,
        fromEncoding: fromEncoding,
        variableLengthDecodeInt32: variableLengthDecodeInt32,
        trimMiddle: trimMiddle,
        multiple: multiple,
        indexOfAny: indexOfAny,
        _concat3array: _concat3array,
        _concat4array: _concat4array,
        _concat9array: _concat9array,
        concat3: concat3,
        concat4: concat4,
        concat9: concat9
    };

    /**
     * Converts a number to s8.u8 fixed point representation.
     */
    function toS8U8(v) {
        return ((v * 256) << 16) >> 16;
    }
    /**
     * Converts a number from s8.u8 fixed point representation.
     */
    function fromS8U8(i) {
        return i / 256;
    }
    /**
     * Round trips a number through s8.u8 conversion.
     */
    function clampS8U8(v) {
        return fromS8U8(toS8U8(v));
    }
    /**
     * Converts a number to signed 16 bits.
     */
    function toS16(v) {
        return (v << 16) >> 16;
    }
    function ones(i) {
        i = i - ((i >> 1) & 0x55555555);
        i = (i & 0x33333333) + ((i >> 2) & 0x33333333);
        return ((i + (i >> 4) & 0xF0F0F0F) * 0x1010101) >> 24;
    }
    /**
     * Polyfill imul.
     */
    if (!Math.imul) {
        Math.imul = function imul(a, b) {
            var ah = (a >>> 16) & 0xffff;
            var al = a & 0xffff;
            var bh = (b >>> 16) & 0xffff;
            var bl = b & 0xffff;
            // the shift by 0 fixes the sign on the high part
            // the final |0 converts the unsigned value into a signed value
            return ((al * bl) + (((ah * bl + al * bh) << 16) >>> 0) | 0);
        };
    }
    /**
     * Polyfill clz32.
     */
    if (!Math.clz32) {
        Math.clz32 = function clz32(i) {
            i |= (i >> 1);
            i |= (i >> 2);
            i |= (i >> 4);
            i |= (i >> 8);
            i |= (i >> 16);
            return 32 - ones(i);
        };
    }

    /*
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var ShumwayCom = {
        "getWeakMapKeys": function (param) { return null; },
    };

    /*
    export declare var Shumway: {
        version: string;
        build: string;
    }*/
    var Shumway = {
        version: "",
        build: ""
    };

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    //import {Promise} from 'es6-promise'
    // Our polyfills for some DOM things make testing this slightly more onerous than it ought to be.
    var inBrowser = typeof window !== 'undefined' && 'document' in window && 'plugins' in window.document;
    var inFirefox = typeof navigator !== 'undefined' && navigator.userAgent.indexOf('Firefox') >= 0;
    // declare var print;
    // declare var console;
    // declare var performance;
    // declare var XMLHttpRequest;
    // declare var document;
    // declare var getComputedStyle;
    /** @define {boolean} */ var release = false;
    function dumpLine(line) {
        if (!release && typeof dump !== "undefined") {
            dump(line + "\n");
        }
    }
    if (!jsGlobal.performance) {
        jsGlobal.performance = {};
    }
    if (!jsGlobal.performance.now) {
        jsGlobal.performance.now = function () {
            return Date.now();
        };
    }
    var START_TIME = performance.now();
    /**
     * The buffer length required to contain any unsigned 32-bit integer.
     */
    /** @const */ var UINT32_CHAR_BUFFER_LENGTH = 10; // "4294967295".length;
    /** @const */ var UINT32_MAX_DIV_10 = 0x19999999; // UINT32_MAX / 10;
    /** @const */ var UINT32_MAX_MOD_10 = 0x5; // UINT32_MAX % 10
    function isString(value) {
        return typeof value === "string";
    }
    function isNumber(value) {
        return typeof value === "number";
    }
    function isInteger(value) {
        return (value | 0) === value;
    }
    function isObject$1(value) {
        return typeof value === "object" || typeof value === 'function';
    }
    function toNumber(x) {
        return +x;
    }
    function isNumericString(value) {
        // ECMAScript 5.1 - 9.8.1 Note 1, this expression is true for all
        // numbers x other than -0.
        return String(Number(value)) === value;
    }
    /**
     * Whether the specified |value| is a number or the string representation of a number.
     */
    function isNumeric(value) {
        if (typeof value === "number") {
            return true;
        }
        if (typeof value === "string") {
            // |value| is rarely numeric (it's usually an identifier), and the
            // isIndex()/isNumericString() pair is slow and expensive, so we do a
            // quick check for obvious non-numericalness first. Just checking if the
            // first char is a 7-bit identifier char catches most cases.
            var c = value.charCodeAt(0);
            if ((65 <= c && c <= 90) || // 'A'..'Z'
                (97 <= c && c <= 122) || // 'a'..'z'
                (c === 36) || // '$'
                (c === 95)) { // '_'
                return false;
            }
            return isIndex(value) || isNumericString(value);
        }
        return false;
    }
    /**
     * Whether the specified |value| is an unsigned 32 bit number expressed as a number
     * or string.
     */
    function isIndex(value) {
        // js/src/vm/String.cpp JSFlatString::isIndexSlow
        // http://dxr.mozilla.org/mozilla-central/source/js/src/vm/String.cpp#474
        var index = 0;
        if (typeof value === "number") {
            index = (value | 0);
            if (value === index && index >= 0) {
                return true;
            }
            return value >>> 0 === value;
        }
        if (typeof value !== "string") {
            return false;
        }
        var length = value.length;
        if (length === 0) {
            return false;
        }
        if (value === "0") {
            return true;
        }
        // Is there any way this will fit?
        if (length > UINT32_CHAR_BUFFER_LENGTH) {
            return false;
        }
        var i = 0;
        index = value.charCodeAt(i++) - 48 /* _0 */;
        if (index < 1 || index > 9) {
            return false;
        }
        var oldIndex = 0;
        var c = 0;
        while (i < length) {
            c = value.charCodeAt(i++) - 48 /* _0 */;
            if (c < 0 || c > 9) {
                return false;
            }
            oldIndex = index;
            index = 10 * index + c;
        }
        /*
         * Look out for "4294967296" and larger-number strings that fit in UINT32_CHAR_BUFFER_LENGTH.
         * Only unsigned 32-bit integers shall pass.
         */
        if ((oldIndex < UINT32_MAX_DIV_10) || (oldIndex === UINT32_MAX_DIV_10 && c <= UINT32_MAX_MOD_10)) {
            return true;
        }
        return false;
    }
    function isNullOrUndefined$1(value) {
        return value == undefined;
    }
    function argumentsToString(args) {
        var resultList = [];
        for (var i = 0; i < args.length; i++) {
            var arg = args[i];
            try {
                var argStr;
                if (typeof arg !== 'object' || !arg) {
                    argStr = arg + '';
                }
                else if ('toString' in arg) {
                    argStr = arg.toString();
                }
                else {
                    argStr = Object.prototype.toString.call(arg);
                }
                resultList.push(argStr);
            }
            catch (e) {
                resultList.push('<unprintable value>');
            }
        }
        return resultList.join(', ');
    }
    function polyfillWeakMap() {
        if (typeof jsGlobal.WeakMap === 'function') {
            return; // weak map is supported
        }
        var id = 0;
        function WeakMap() {
            this.id = '$weakmap' + (id++);
        }
        WeakMap.prototype = {
            has: function (obj) {
                return obj.hasOwnProperty(this.id);
            },
            get: function (obj, defaultValue) {
                return obj.hasOwnProperty(this.id) ? obj[this.id] : defaultValue;
            },
            set: function (obj, value) {
                Object.defineProperty(obj, this.id, {
                    value: value,
                    enumerable: false,
                    configurable: true
                });
            },
            delete: function (obj) {
                delete obj[this.id];
            }
        };
        jsGlobal.WeakMap = WeakMap;
    }
    polyfillWeakMap();
    var useReferenceCounting = true;
    var WeakList = /** @class */ (function () {
        function WeakList() {
            if (typeof ShumwayCom !== "undefined" && ShumwayCom.getWeakMapKeys) {
                this._map = new WeakMap();
                this._id = 0;
                this._newAdditions = [];
            }
            else {
                this._list = [];
            }
        }
        WeakList.prototype.clear = function () {
            if (this._map) {
                this._map.clear();
            }
            else {
                this._list.length = 0;
            }
        };
        WeakList.prototype.push = function (value) {
            if (this._map) {
                release || assert$2(!this._map.has(value));
                // We store an increasing id as the value so that keys can be sorted by it.
                this._map.set(value, this._id++);
                this._newAdditions.forEach(function (additions) {
                    additions.push(value);
                });
            }
            else {
                release || assert$2(this._list.indexOf(value) === -1);
                this._list.push(value);
            }
        };
        WeakList.prototype.remove = function (value) {
            if (this._map) {
                release || assert$2(this._map.has(value));
                this._map.delete(value);
            }
            else {
                release || assert$2(this._list.indexOf(value) > -1);
                this._list[this._list.indexOf(value)] = null;
                release || assert$2(this._list.indexOf(value) === -1);
            }
        };
        WeakList.prototype.forEach = function (callback) {
            if (this._map) {
                var newAdditionsToKeys = [];
                this._newAdditions.push(newAdditionsToKeys);
                var map = this._map;
                var keys = ShumwayCom.getWeakMapKeys(map);
                // The keys returned by ShumwayCom.getWeakMapKeys are not guaranteed to
                // be in insertion order. Therefore we have to sort them manually.
                keys.sort(function (a, b) {
                    return map.get(a) - map.get(b);
                });
                keys.forEach(function (value) {
                    if (value._referenceCount !== 0) {
                        callback(value);
                    }
                });
                // ShumwayCom.getWeakMapKeys take snapshot of the keys, but we are also
                // interested in new added keys while keys.forEach was run.
                newAdditionsToKeys.forEach(function (value) {
                    if (value._referenceCount !== 0) {
                        callback(value);
                    }
                });
                this._newAdditions.splice(this._newAdditions.indexOf(newAdditionsToKeys), 1);
                return;
            }
            var list = this._list;
            var zeroCount = 0;
            for (var i = 0; i < list.length; i++) {
                var value = list[i];
                if (!value) {
                    continue;
                }
                if (useReferenceCounting && value._referenceCount === 0) {
                    list[i] = null;
                    zeroCount++;
                }
                else {
                    callback(value);
                }
            }
            if (zeroCount > 16 && zeroCount > (list.length >> 2)) {
                var newList = [];
                for (var i = 0; i < list.length; i++) {
                    var value = list[i];
                    if (value && value._referenceCount > 0) {
                        newList.push(value);
                    }
                }
                this._list = newList;
            }
        };
        Object.defineProperty(WeakList.prototype, "length", {
            get: function () {
                if (this._map) {
                    // TODO: Implement this.
                    return -1;
                }
                else {
                    return this._list.length;
                }
            },
            enumerable: true,
            configurable: true
        });
        return WeakList;
    }());
    var IndentingWriter = /** @class */ (function () {
        function IndentingWriter(suppressOutput, out) {
            if (suppressOutput === void 0) { suppressOutput = false; }
            this._tab = "  ";
            this._padding = "";
            this._suppressOutput = suppressOutput;
            this._out = out || IndentingWriter._consoleOut;
            this._outNoNewline = out || IndentingWriter._consoleOutNoNewline;
        }
        Object.defineProperty(IndentingWriter.prototype, "suppressOutput", {
            get: function () {
                return this._suppressOutput;
            },
            set: function (val) {
                this._suppressOutput = val;
            },
            enumerable: true,
            configurable: true
        });
        IndentingWriter.prototype.write = function (str, writePadding) {
            if (str === void 0) { str = ""; }
            if (writePadding === void 0) { writePadding = false; }
            if (!this._suppressOutput) {
                this._outNoNewline((writePadding ? this._padding : "") + str);
            }
        };
        IndentingWriter.prototype.writeLn = function (str) {
            if (str === void 0) { str = ""; }
            if (!this._suppressOutput) {
                this._out(this._padding + str);
            }
        };
        IndentingWriter.prototype.writeObject = function (str, object) {
            if (str === void 0) { str = ""; }
            if (!this._suppressOutput) {
                this._out(this._padding + str, object);
            }
        };
        IndentingWriter.prototype.writeTimeLn = function (str) {
            if (str === void 0) { str = ""; }
            if (!this._suppressOutput) {
                this._out(this._padding + performance.now().toFixed(2) + " " + str);
            }
        };
        IndentingWriter.prototype.writeComment = function (str) {
            var lines = (str || '').split("\n");
            if (lines.length === 1) {
                this.writeLn("// " + lines[0]);
            }
            else {
                this.writeLn("/**");
                for (var i = 0; i < lines.length; i++) {
                    this.writeLn(" * " + lines[i]);
                }
                this.writeLn(" */");
            }
        };
        IndentingWriter.prototype.writeLns = function (str) {
            var lines = (str || '').split("\n");
            for (var i = 0; i < lines.length; i++) {
                this.writeLn(lines[i]);
            }
        };
        IndentingWriter.prototype.errorLn = function (str) {
            if (IndentingWriter.logLevel & 1 /* Error */) {
                this.boldRedLn(str);
            }
        };
        IndentingWriter.prototype.warnLn = function (str) {
            if (IndentingWriter.logLevel & 2 /* Warn */) {
                this.yellowLn(str);
            }
        };
        IndentingWriter.prototype.debugLn = function (str) {
            if (IndentingWriter.logLevel & 4 /* Debug */) {
                this.purpleLn(str);
            }
        };
        IndentingWriter.prototype.logLn = function (str) {
            if (IndentingWriter.logLevel & 8 /* Log */) {
                this.writeLn(str);
            }
        };
        IndentingWriter.prototype.infoLn = function (str) {
            if (IndentingWriter.logLevel & 16 /* Info */) {
                this.writeLn(str);
            }
        };
        IndentingWriter.prototype.yellowLn = function (str) {
            this.colorLn(IndentingWriter.YELLOW, str);
        };
        IndentingWriter.prototype.greenLn = function (str) {
            this.colorLn(IndentingWriter.GREEN, str);
        };
        IndentingWriter.prototype.boldRedLn = function (str) {
            this.colorLn(IndentingWriter.BOLD_RED, str);
        };
        IndentingWriter.prototype.redLn = function (str) {
            this.colorLn(IndentingWriter.RED, str);
        };
        IndentingWriter.prototype.purpleLn = function (str) {
            this.colorLn(IndentingWriter.PURPLE, str);
        };
        IndentingWriter.prototype.colorLn = function (color, str) {
            if (!this._suppressOutput) {
                if (!inBrowser) {
                    this._out(this._padding + color + str + IndentingWriter.ENDC);
                }
                else {
                    this._out(this._padding + str);
                }
            }
        };
        IndentingWriter.prototype.redLns = function (str) {
            this.colorLns(IndentingWriter.RED, str);
        };
        IndentingWriter.prototype.colorLns = function (color, str) {
            var lines = (str || '').split("\n");
            for (var i = 0; i < lines.length; i++) {
                this.colorLn(color, lines[i]);
            }
        };
        IndentingWriter.prototype.enter = function (str) {
            if (!this._suppressOutput) {
                this._out(this._padding + str);
            }
            this.indent();
        };
        IndentingWriter.prototype.leaveAndEnter = function (str) {
            this.leave(str);
            this.indent();
        };
        IndentingWriter.prototype.leave = function (str) {
            this.outdent();
            if (!this._suppressOutput && str) {
                this._out(this._padding + str);
            }
        };
        IndentingWriter.prototype.indent = function () {
            this._padding += this._tab;
        };
        IndentingWriter.prototype.outdent = function () {
            if (this._padding.length > 0) {
                this._padding = this._padding.substring(0, this._padding.length - this._tab.length);
            }
        };
        IndentingWriter.prototype.writeArray = function (arr, detailed, noNumbers) {
            if (detailed === void 0) { detailed = false; }
            if (noNumbers === void 0) { noNumbers = false; }
            detailed = detailed || false;
            for (var i = 0, j = arr.length; i < j; i++) {
                var prefix = "";
                if (detailed) {
                    if (arr[i] === null) {
                        prefix = "null";
                    }
                    else if (arr[i] === undefined) {
                        prefix = "undefined";
                    }
                    else {
                        prefix = arr[i].constructor.name;
                    }
                    prefix += " ";
                }
                var number = noNumbers ? "" : ("" + i).padRight(' ', 4);
                this.writeLn(number + prefix + arr[i]);
            }
        };
        IndentingWriter.PURPLE = '33[94m'; //\033[94m';
        IndentingWriter.YELLOW = '33[93m'; //\033[93m';
        IndentingWriter.GREEN = '33[92m'; //\033[92m';
        IndentingWriter.RED = '33[91m'; //\033[91m';
        IndentingWriter.BOLD_RED = '33[1;91m'; //\033[1;91m';
        IndentingWriter.ENDC = '33[0m'; //\033[0m';
        IndentingWriter.logLevel = 31 /* All */;
        IndentingWriter._consoleOut = console.log.bind(console);
        IndentingWriter._consoleOutNoNewline = console.log.bind(console);
        return IndentingWriter;
    }());
    /**
     * Faster release version of bounds.
     */
    var Bounds$1 = /** @class */ (function () {
        function Bounds(xMin, yMin, xMax, yMax) {
            this.xMin = xMin | 0;
            this.yMin = yMin | 0;
            this.xMax = xMax | 0;
            this.yMax = yMax | 0;
        }
        Bounds.FromUntyped = function (source) {
            return new Bounds(source.xMin, source.yMin, source.xMax, source.yMax);
        };
        Bounds.FromRectangle = function (source) {
            return new Bounds(source.x * 20 | 0, source.y * 20 | 0, (source.x + source.width) * 20 | 0, (source.y + source.height) * 20 | 0);
        };
        Bounds.prototype.setElements = function (xMin, yMin, xMax, yMax) {
            this.xMin = xMin;
            this.yMin = yMin;
            this.xMax = xMax;
            this.yMax = yMax;
        };
        Bounds.prototype.copyFrom = function (source) {
            this.setElements(source.xMin, source.yMin, source.xMax, source.yMax);
        };
        Bounds.prototype.contains = function (x, y) {
            return x < this.xMin !== x < this.xMax &&
                y < this.yMin !== y < this.yMax;
        };
        Bounds.prototype.unionInPlace = function (other) {
            if (other.isEmpty()) {
                return;
            }
            this.extendByPoint(other.xMin, other.yMin);
            this.extendByPoint(other.xMax, other.yMax);
        };
        Bounds.prototype.extendByPoint = function (x, y) {
            this.extendByX(x);
            this.extendByY(y);
        };
        Bounds.prototype.extendByX = function (x) {
            // Exclude default values.
            if (this.xMin === 0x8000000) {
                this.xMin = this.xMax = x;
                return;
            }
            this.xMin = Math.min(this.xMin, x);
            this.xMax = Math.max(this.xMax, x);
        };
        Bounds.prototype.extendByY = function (y) {
            // Exclude default values.
            if (this.yMin === 0x8000000) {
                this.yMin = this.yMax = y;
                return;
            }
            this.yMin = Math.min(this.yMin, y);
            this.yMax = Math.max(this.yMax, y);
        };
        Bounds.prototype.intersects = function (toIntersect) {
            return this.contains(toIntersect.xMin, toIntersect.yMin) ||
                this.contains(toIntersect.xMax, toIntersect.yMax);
        };
        Bounds.prototype.isEmpty = function () {
            return this.xMax <= this.xMin || this.yMax <= this.yMin;
        };
        Object.defineProperty(Bounds.prototype, "width", {
            get: function () {
                return this.xMax - this.xMin;
            },
            set: function (value) {
                this.xMax = this.xMin + value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Bounds.prototype, "height", {
            get: function () {
                return this.yMax - this.yMin;
            },
            set: function (value) {
                this.yMax = this.yMin + value;
            },
            enumerable: true,
            configurable: true
        });
        Bounds.prototype.getBaseWidth = function (angle) {
            var u = Math.abs(Math.cos(angle));
            var v = Math.abs(Math.sin(angle));
            return u * (this.xMax - this.xMin) + v * (this.yMax - this.yMin);
        };
        Bounds.prototype.getBaseHeight = function (angle) {
            var u = Math.abs(Math.cos(angle));
            var v = Math.abs(Math.sin(angle));
            return v * (this.xMax - this.xMin) + u * (this.yMax - this.yMin);
        };
        Bounds.prototype.setEmpty = function () {
            this.xMin = this.yMin = this.xMax = this.yMax = 0;
        };
        /**
         * Set all fields to the sentinel value 0x8000000.
         *
         * This is what Flash uses to indicate uninitialized bounds. Important for bounds calculation
         * in `Graphics` instances, which start out with empty bounds but must not just extend them
         * from an 0,0 origin.
         */
        Bounds.prototype.setToSentinels = function () {
            this.xMin = this.yMin = this.xMax = this.yMax = 0x8000000;
        };
        Bounds.prototype.clone = function () {
            return new Bounds(this.xMin, this.yMin, this.xMax, this.yMax);
        };
        Bounds.prototype.toString = function () {
            return "{ " +
                "xMin: " + this.xMin + ", " +
                "xMin: " + this.yMin + ", " +
                "xMax: " + this.xMax + ", " +
                "xMax: " + this.yMax +
                " }";
        };
        return Bounds;
    }());
    /**
     * Slower debug version of bounds, makes sure that all points have integer coordinates.
     */
    var DebugBounds = /** @class */ (function () {
        function DebugBounds(xMin, yMin, xMax, yMax) {
            assert$2(isInteger(xMin));
            assert$2(isInteger(yMin));
            assert$2(isInteger(xMax));
            assert$2(isInteger(yMax));
            this._xMin = xMin | 0;
            this._yMin = yMin | 0;
            this._xMax = xMax | 0;
            this._yMax = yMax | 0;
            this.assertValid();
        }
        DebugBounds.FromUntyped = function (source) {
            return new DebugBounds(source.xMin, source.yMin, source.xMax, source.yMax);
        };
        DebugBounds.FromRectangle = function (source) {
            return new DebugBounds(source.x * 20 | 0, source.y * 20 | 0, (source.x + source.width) * 20 | 0, (source.y + source.height) * 20 | 0);
        };
        DebugBounds.prototype.setElements = function (xMin, yMin, xMax, yMax) {
            this.xMin = xMin;
            this.yMin = yMin;
            this.xMax = xMax;
            this.yMax = yMax;
        };
        DebugBounds.prototype.copyFrom = function (source) {
            this.setElements(source.xMin, source.yMin, source.xMax, source.yMax);
        };
        DebugBounds.prototype.contains = function (x, y) {
            return x < this.xMin !== x < this.xMax &&
                y < this.yMin !== y < this.yMax;
        };
        DebugBounds.prototype.unionInPlace = function (other) {
            if (other.isEmpty()) {
                return;
            }
            this.extendByPoint(other.xMin, other.yMin);
            this.extendByPoint(other.xMax, other.yMax);
        };
        DebugBounds.prototype.extendByPoint = function (x, y) {
            this.extendByX(x);
            this.extendByY(y);
        };
        DebugBounds.prototype.extendByX = function (x) {
            if (this.xMin === 0x8000000) {
                this.xMin = this.xMax = x;
                return;
            }
            this.xMin = Math.min(this.xMin, x);
            this.xMax = Math.max(this.xMax, x);
        };
        DebugBounds.prototype.extendByY = function (y) {
            if (this.yMin === 0x8000000) {
                this.yMin = this.yMax = y;
                return;
            }
            this.yMin = Math.min(this.yMin, y);
            this.yMax = Math.max(this.yMax, y);
        };
        DebugBounds.prototype.intersects = function (toIntersect) {
            return this.contains(toIntersect._xMin, toIntersect._yMin) ||
                this.contains(toIntersect._xMax, toIntersect._yMax);
        };
        DebugBounds.prototype.isEmpty = function () {
            return this._xMax <= this._xMin || this._yMax <= this._yMin;
        };
        Object.defineProperty(DebugBounds.prototype, "xMin", {
            get: function () {
                return this._xMin;
            },
            set: function (value) {
                assert$2(isInteger(value));
                this._xMin = value;
                this.assertValid();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugBounds.prototype, "yMin", {
            get: function () {
                return this._yMin;
            },
            set: function (value) {
                assert$2(isInteger(value));
                this._yMin = value | 0;
                this.assertValid();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugBounds.prototype, "xMax", {
            get: function () {
                return this._xMax;
            },
            set: function (value) {
                assert$2(isInteger(value));
                this._xMax = value | 0;
                this.assertValid();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugBounds.prototype, "width", {
            get: function () {
                return this._xMax - this._xMin;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugBounds.prototype, "yMax", {
            get: function () {
                return this._yMax;
            },
            set: function (value) {
                assert$2(isInteger(value));
                this._yMax = value | 0;
                this.assertValid();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DebugBounds.prototype, "height", {
            get: function () {
                return this._yMax - this._yMin;
            },
            enumerable: true,
            configurable: true
        });
        DebugBounds.prototype.getBaseWidth = function (angle) {
            var u = Math.abs(Math.cos(angle));
            var v = Math.abs(Math.sin(angle));
            return u * (this._xMax - this._xMin) + v * (this._yMax - this._yMin);
        };
        DebugBounds.prototype.getBaseHeight = function (angle) {
            var u = Math.abs(Math.cos(angle));
            var v = Math.abs(Math.sin(angle));
            return v * (this._xMax - this._xMin) + u * (this._yMax - this._yMin);
        };
        DebugBounds.prototype.setEmpty = function () {
            this._xMin = this._yMin = this._xMax = this._yMax = 0;
        };
        DebugBounds.prototype.clone = function () {
            return new DebugBounds(this.xMin, this.yMin, this.xMax, this.yMax);
        };
        DebugBounds.prototype.toString = function () {
            return "{ " +
                "xMin: " + this._xMin + ", " +
                "yMin: " + this._yMin + ", " +
                "xMax: " + this._xMax + ", " +
                "yMax: " + this._yMax +
                " }";
        };
        DebugBounds.prototype.assertValid = function () {
            //      release || assert(this._xMax >= this._xMin);
            //      release || assert(this._yMax >= this._yMin);
        };
        return DebugBounds;
    }());
    var ImageType$1;
    (function (ImageType) {
        ImageType[ImageType["None"] = 0] = "None";
        /**
         * Premultiplied ARGB (byte-order).
         */
        ImageType[ImageType["PremultipliedAlphaARGB"] = 1] = "PremultipliedAlphaARGB";
        /**
         * Unpremultiplied ARGB (byte-order).
         */
        ImageType[ImageType["StraightAlphaARGB"] = 2] = "StraightAlphaARGB";
        /**
         * Unpremultiplied RGBA (byte-order), this is what putImageData expects.
         */
        ImageType[ImageType["StraightAlphaRGBA"] = 3] = "StraightAlphaRGBA";
        ImageType[ImageType["JPEG"] = 4] = "JPEG";
        ImageType[ImageType["PNG"] = 5] = "PNG";
        ImageType[ImageType["GIF"] = 6] = "GIF";
    })(ImageType$1 || (ImageType$1 = {}));
    var PromiseWrapper = /** @class */ (function () {
        function PromiseWrapper() {
            this.promise = new Promise(function (resolve, reject) {
                this.resolve = resolve;
                this.reject = reject;
            }.bind(this));
        }
        PromiseWrapper.prototype.then = function (onFulfilled, onRejected) {
            return this.promise.then(onFulfilled, onRejected);
        };
        return PromiseWrapper;
    }());
    if (typeof exports !== "undefined") {
        exports["Shumway"] = Shumway;
    }
    /**
     * Extend builtin prototypes.
     *
     * TODO: Go through the code and remove all references to these.
     */
    (function () {
        function extendBuiltin(prototype, property, value) {
            if (!prototype[property]) {
                Object.defineProperty(prototype, property, { value: value,
                    writable: true,
                    configurable: true,
                    enumerable: false });
            }
        }
        function removeColors(s) {
            return s.replace(/\033\[[0-9]*m/g, "");
        }
        extendBuiltin(String.prototype, "padRight", function (c, n) {
            var str = this;
            var length = removeColors(str).length;
            if (!c || length >= n) {
                return str;
            }
            var max = (n - length) / c.length;
            for (var i = 0; i < max; i++) {
                str += c;
            }
            return str;
        });
        extendBuiltin(String.prototype, "padLeft", function (c, n) {
            var str = this;
            var length = str.length;
            if (!c || length >= n) {
                return str;
            }
            var max = (n - length) / c.length;
            for (var i = 0; i < max; i++) {
                str = c + str;
            }
            return str;
        });
        extendBuiltin(String.prototype, "trim", function () {
            return this.replace(/^\s+|\s+$/g, "");
        });
        extendBuiltin(String.prototype, "endsWith", function (str) {
            return this.indexOf(str, this.length - str.length) !== -1;
        });
        extendBuiltin(Array.prototype, "replace", function (x, y) {
            if (x === y) {
                return 0;
            }
            var count = 0;
            for (var i = 0; i < this.length; i++) {
                if (this[i] === x) {
                    this[i] = y;
                    count++;
                }
            }
            return count;
        });
    })();

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var OptionSet = /** @class */ (function () {
        function OptionSet(name, settings) {
            if (settings === void 0) { settings = null; }
            this.open = false;
            this.name = name;
            this.settings = settings || {};
            this.options = [];
        }
        OptionSet.isOptionSet = function (obj) {
            // We will be getting options from different iframe, so this function will
            // check if the obj somewhat like OptionSet.
            if (obj instanceof OptionSet) {
                return true;
            }
            if (typeof obj !== 'object' || obj === null ||
                obj instanceof Option) {
                return false;
            }
            return ('options' in obj) && ('name' in obj) && ('settings' in obj);
        };
        OptionSet.prototype.register = function (option) {
            if (OptionSet.isOptionSet(option)) {
                // check for duplicate option sets (bail if found)
                for (var i = 0; i < this.options.length; i++) {
                    var optionSet = this.options[i];
                    if (OptionSet.isOptionSet(optionSet) && optionSet.name === option.name) {
                        return optionSet;
                    }
                }
            }
            this.options.push(option);
            if (this.settings) {
                if (OptionSet.isOptionSet(option)) {
                    var optionSettings = this.settings[option.name];
                    if (isObject$1(optionSettings)) {
                        option.settings = optionSettings.settings;
                        option.open = optionSettings.open;
                    }
                }
                else {
                    // build_bundle chokes on this:
                    // if (!isNullOrUndefined(this.settings[option.longName])) {
                    if (typeof this.settings[option.longName] !== "undefined") {
                        switch (option.type) {
                            case "boolean":
                                option.value = !!this.settings[option.longName];
                                break;
                            case "number":
                                option.value = +this.settings[option.longName];
                                break;
                            default:
                                option.value = this.settings[option.longName];
                                break;
                        }
                    }
                }
            }
            return option;
        };
        OptionSet.prototype.trace = function (writer) {
            writer.enter(this.name + " {");
            this.options.forEach(function (option) {
                option.trace(writer);
            });
            writer.leave("}");
        };
        OptionSet.prototype.getSettings = function () {
            var settings = {};
            this.options.forEach(function (option) {
                if (OptionSet.isOptionSet(option)) {
                    settings[option.name] = {
                        settings: option.getSettings(),
                        open: option.open
                    };
                }
                else {
                    settings[option.longName] = option.value;
                }
            });
            return settings;
        };
        OptionSet.prototype.setSettings = function (settings) {
            if (!settings) {
                return;
            }
            this.options.forEach(function (option) {
                if (OptionSet.isOptionSet(option)) {
                    if (option.name in settings) {
                        option.setSettings(settings[option.name].settings);
                    }
                }
                else {
                    if (option.longName in settings) {
                        option.value = settings[option.longName];
                    }
                }
            });
        };
        return OptionSet;
    }());
    var Option = /** @class */ (function () {
        // config:
        //  { range: { min: 1, max: 5, step: 1 } }
        //  { list: [ "item 1", "item 2", "item 3" ] }
        //  { choices: { "choice 1": 1, "choice 2": 2, "choice 3": 3 } }
        function Option(shortName, longName, type, defaultValue, description, config) {
            if (config === void 0) { config = null; }
            this.longName = longName;
            this.shortName = shortName;
            this.type = type;
            this.defaultValue = defaultValue;
            this.value = defaultValue;
            this.description = description;
            this.config = config;
        }
        Option.prototype.parse = function (value) {
            this.value = value;
        };
        Option.prototype.trace = function (writer) {
            writer.writeLn(("-" + this.shortName + "|--" + this.longName).padRight(" ", 30) +
                " = " + this.type + " " + this.value + " [" + this.defaultValue + "]" +
                " (" + this.description + ")");
        };
        return Option;
    }());

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var ROOT = "Shumway Options";
    var shumwayOptions = new OptionSet(ROOT);
    var loggingOptions = shumwayOptions.register(new OptionSet("Logging Options"));
    var omitRepeatedWarnings = loggingOptions.register(new Option("wo", "warnOnce", "boolean", true, 'Omit Repeated Warnings'));

    var release$1 = true;
    var Debug$1 = /** @class */ (function () {
        function Debug() {
        }
        Debug.release = release$1;
        Debug.assert = assert$2;
        Debug.error = error;
        Debug.assertUnreachable = assertUnreachable;
        Debug.assertNotImplemented = assertNotImplemented;
        Debug.warning = warning;
        Debug.notImplemented = notImplemented;
        Debug.dummyConstructor = dummyConstructor;
        Debug.warnCounts = warnCounts;
        Debug.abstractMethod = abstractMethod;
        Debug.somewhatImplemented = somewhatImplemented;
        Debug.unexpected = unexpected;
        Debug.unexpectedCase = unexpectedCase;
        return Debug;
    }());
    function notImplemented(message) {
        warning('AVM1 not implemented: ' + message);
    }
    function somewhatImplemented(message) {
        warning("AVM1 somewhatImplemented: " + message);
    }
    function error(message) {
        console.error(message);
        throw new Error(message);
    }
    function assert$2(condition, message) {
        if (message === void 0) { message = "assertion failed"; }
        if (condition === "") { // avoid inadvertent false positive
            condition = true;
        }
        if (!condition) {
            if (typeof console !== 'undefined' && 'assert' in console) {
                console.assert(false, message);
                throw new Error(message);
            }
            else {
                error(message.toString());
            }
        }
    }
    function assertUnreachable(msg) {
        var location = new Error().stack.split('\n')[1];
        throw new Error("Reached unreachable location " + location + msg);
    }
    function assertNotImplemented(condition, message) {
        if (!condition) {
            error("notImplemented: " + message);
        }
    }
    var _warnedCounts = Object.create(null);
    function warning(message, arg1, arg2 /*...messages: any[]*/) {
        if (release$1) {
            return;
        }
        var key = argumentsToString(arguments);
        if (_warnedCounts[key]) {
            _warnedCounts[key]++;
            if (omitRepeatedWarnings.value) {
                return;
            }
        }
        _warnedCounts[key] = 1;
        console.warn.apply(console, arguments);
    }
    function warnCounts() {
        var list = [];
        for (var key in _warnedCounts) {
            list.push({ key: key, count: _warnedCounts[key] });
        }
        list.sort(function (entry, prev) { return prev.count - entry.count; });
        return list.reduce(function (result, entry) { return (result += '\n' + entry.count + '\t' + entry.key); }, '');
    }
    function dummyConstructor(message) {
        release$1 || assert$2(false, "Dummy Constructor: " + message);
    }
    function abstractMethod(message) {
        release$1 || assert$2(false, "Abstract Method " + message);
    }
    function unexpected(message) {
        assert$2(false, "Unexpected: " + message);
    }
    function unexpectedCase(message) {
        assert$2(false, "Unexpected Case: " + message);
    }

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var SOUND_SIZE_16_BIT = 1;
    var SOUND_TYPE_STEREO = 1;
    var SOUND_FORMAT_PCM_BE = 0;
    var SOUND_FORMAT_ADPCM = 1;
    var SOUND_FORMAT_MP3 = 2;
    var SOUND_FORMAT_PCM_LE = 3;
    var SOUND_RATES = [5512, 11250, 22500, 44100];
    var WaveHeader = new Uint8Array([0x52, 0x49, 0x46, 0x46, 0x00, 0x00, 0x00, 0x00,
        0x57, 0x41, 0x56, 0x45, 0x66, 0x6D, 0x74, 0x20, 0x10, 0x00, 0x00, 0x00,
        0x01, 0x00, 0x02, 0x00, 0x44, 0xAC, 0x00, 0x00, 0x10, 0xB1, 0x02, 0x00,
        0x04, 0x00, 0x10, 0x00, 0x64, 0x61, 0x74, 0x61, 0x00, 0x00, 0x00, 0x00]);
    function packageWave(data, sampleRate, channels, size, swapBytes) {
        var sizeInBytes = size >> 3;
        var sizePerSecond = channels * sampleRate * sizeInBytes;
        var sizePerSample = channels * sizeInBytes;
        var dataLength = data.length + (data.length & 1);
        var buffer = new ArrayBuffer(WaveHeader.length + dataLength);
        var bytes = new Uint8Array(buffer);
        bytes.set(WaveHeader);
        if (swapBytes) {
            for (var i = 0, j = WaveHeader.length; i < data.length; i += 2, j += 2) {
                bytes[j] = data[i + 1];
                bytes[j + 1] = data[i];
            }
        }
        else {
            bytes.set(data, WaveHeader.length);
        }
        var view = new DataView(buffer);
        view.setUint32(4, dataLength + 36, true);
        view.setUint16(22, channels, true);
        view.setUint32(24, sampleRate, true);
        view.setUint32(28, sizePerSecond, true);
        view.setUint16(32, sizePerSample, true);
        view.setUint16(34, size, true);
        view.setUint32(40, dataLength, true);
        return {
            data: bytes,
            mimeType: 'audio/wav'
        };
    }
    function defineSound(tag) {
        var channels = tag.soundType == SOUND_TYPE_STEREO ? 2 : 1;
        var samplesCount = tag.samplesCount;
        var sampleRate = SOUND_RATES[tag.soundRate];
        var data = tag.soundData;
        var pcm, packaged;
        switch (tag.soundFormat) {
            case SOUND_FORMAT_PCM_BE:
                pcm = new Float32Array(samplesCount * channels);
                if (tag.soundSize == SOUND_SIZE_16_BIT) {
                    for (var i = 0, j = 0; i < pcm.length; i++, j += 2)
                        pcm[i] = ((data[j] << 24) | (data[j + 1] << 16)) / 2147483648;
                    packaged = packageWave(data, sampleRate, channels, 16, true);
                }
                else {
                    for (var i = 0; i < pcm.length; i++)
                        pcm[i] = (data[i] - 128) / 128;
                    packaged = packageWave(data, sampleRate, channels, 8, false);
                }
                break;
            case SOUND_FORMAT_PCM_LE:
                pcm = new Float32Array(samplesCount * channels);
                if (tag.soundSize == SOUND_SIZE_16_BIT) {
                    for (var i = 0, j = 0; i < pcm.length; i++, j += 2)
                        pcm[i] = ((data[j + 1] << 24) | (data[j] << 16)) / 2147483648;
                    packaged = packageWave(data, sampleRate, channels, 16, false);
                }
                else {
                    for (var i = 0; i < pcm.length; i++)
                        pcm[i] = (data[i] - 128) / 128;
                    packaged = packageWave(data, sampleRate, channels, 8, false);
                }
                break;
            case SOUND_FORMAT_MP3:
                packaged = {
                    data: new Uint8Array(data.subarray(2)),
                    mimeType: 'audio/mpeg'
                };
                break;
            case SOUND_FORMAT_ADPCM:
                var pcm16 = new Int16Array(samplesCount * channels);
                decodeACPCMSoundData(data, pcm16, channels);
                pcm = new Float32Array(samplesCount * channels);
                for (var i = 0; i < pcm.length; i++)
                    pcm[i] = pcm16[i] / 32768;
                packaged = packageWave(new Uint8Array(pcm16.buffer), sampleRate, channels, 16, !(new Uint8Array(new Uint16Array([1]).buffer))[0]);
                break;
            default:
                release$1 || console.log('Unsupported audio format: ' + tag.soundFormat);
        }
        var sound = {
            type: 'sound',
            id: tag.id,
            sampleRate: sampleRate,
            channels: channels,
            pcm: pcm,
            packaged: null
        };
        if (packaged) {
            sound.packaged = packaged;
        }
        return sound;
    }
    var ACPCMIndexTables = [
        [-1, 2],
        [-1, -1, 2, 4],
        [-1, -1, -1, -1, 2, 4, 6, 8],
        [-1, -1, -1, -1, -1, -1, -1, -1, 1, 2, 4, 6, 8, 10, 13, 16]
    ];
    var ACPCMStepSizeTable = [
        7, 8, 9, 10, 11, 12, 13, 14, 16, 17, 19, 21, 23, 25, 28, 31, 34, 37, 41, 45,
        50, 55, 60, 66, 73, 80, 88, 97, 107, 118, 130, 143, 157, 173, 190, 209, 230,
        253, 279, 307, 337, 371, 408, 449, 494, 544, 598, 658, 724, 796, 876, 963,
        1060, 1166, 1282, 1411, 1552, 1707, 1878, 2066, 2272, 2499, 2749, 3024, 3327,
        3660, 4026, 4428, 4871, 5358, 5894, 6484, 7132, 7845, 8630, 9493, 10442, 11487,
        12635, 13899, 15289, 16818, 18500, 20350, 22385, 24623, 27086, 29794, 32767
    ];
    function decodeACPCMSoundData(data, pcm16, channels) {
        function readBits(n) {
            while (dataBufferLength < n) {
                dataBuffer = (dataBuffer << 8) | data[dataPosition++];
                dataBufferLength += 8;
            }
            dataBufferLength -= n;
            return (dataBuffer >>> dataBufferLength) & ((1 << n) - 1);
        }
        var dataPosition = 0;
        var dataBuffer = 0;
        var dataBufferLength = 0;
        var pcmPosition = 0;
        var codeSize = readBits(2);
        var indexTable = ACPCMIndexTables[codeSize];
        while (pcmPosition < pcm16.length) {
            var x = pcm16[pcmPosition++] = (readBits(16) << 16) >> 16, x2;
            var stepIndex = readBits(6), stepIndex2;
            if (channels > 1) {
                x2 = pcm16[pcmPosition++] = (readBits(16) << 16) >> 16;
                stepIndex2 = readBits(6);
            }
            var signMask = 1 << (codeSize + 1);
            for (var i = 0; i < 4095; i++) {
                var nibble = readBits(codeSize + 2);
                var step = ACPCMStepSizeTable[stepIndex];
                var sum = 0;
                for (var currentBit = signMask >> 1; currentBit; currentBit >>= 1, step >>= 1) {
                    if (nibble & currentBit)
                        sum += step;
                }
                x += (nibble & signMask ? -1 : 1) * (sum + step);
                pcm16[pcmPosition++] = (x = (x < -32768 ? -32768 : x > 32767 ? 32767 : x));
                stepIndex += indexTable[nibble & ~signMask];
                stepIndex = stepIndex < 0 ? 0 : stepIndex > 88 ? 88 : stepIndex;
                if (channels > 1) {
                    nibble = readBits(codeSize + 2);
                    step = ACPCMStepSizeTable[stepIndex2];
                    sum = 0;
                    for (var currentBit = signMask >> 1; currentBit; currentBit >>= 1, step >>= 1) {
                        if (nibble & currentBit)
                            sum += step;
                    }
                    x2 += (nibble & signMask ? -1 : 1) * (sum + step);
                    pcm16[pcmPosition++] = (x2 = (x2 < -32768 ? -32768 : x2 > 32767 ? 32767 : x2));
                    stepIndex2 += indexTable[nibble & ~signMask];
                    stepIndex2 = stepIndex2 < 0 ? 0 : stepIndex2 > 88 ? 88 : stepIndex2;
                }
            }
        }
    }
    var nextSoundStreamId = 0;
    var SoundStream = /** @class */ (function () {
        function SoundStream(samplesCount, sampleRate, channels, streamSize) {
            this.streamId = (nextSoundStreamId++);
            this.samplesCount = samplesCount;
            this.sampleRate = sampleRate;
            this.channels = channels;
            this.streamSize = streamSize;
            this.format = null;
            this.currentSample = 0;
            this.allChunks = [];
        }
        SoundStream.FromTag = function (tag) {
            var channels = tag.streamType == SOUND_TYPE_STEREO ? 2 : 1;
            var samplesCount = tag.samplesCount;
            var sampleRate = SOUND_RATES[tag.streamRate];
            var streamSize = tag.streamSize;
            var stream = new SoundStream(samplesCount, sampleRate, channels, streamSize);
            switch (tag.streamCompression) {
                case SOUND_FORMAT_PCM_BE:
                case SOUND_FORMAT_PCM_LE:
                    stream.format = 'wave';
                    if (tag.soundSize == SOUND_SIZE_16_BIT) {
                        stream.decode = tag.streamCompression === SOUND_FORMAT_PCM_BE ?
                            SwfSoundStream_decode_PCM_be :
                            SwfSoundStream_decode_PCM_le;
                    }
                    else {
                        stream.decode = SwfSoundStream_decode_PCM;
                    }
                    break;
                case SOUND_FORMAT_MP3:
                    stream.format = 'mp3';
                    stream.decode = SwfSoundStream_decode_MP3;
                    break;
                default:
                    release$1 || console.log('Unsupported audio stream format: ' + tag.streamCompression);
                    return null;
            }
            return stream;
        };
        return SoundStream;
    }());
    function SwfSoundStream_decode_PCM(data) {
        var pcm = new Float32Array(data.length);
        for (var i = 0; i < pcm.length; i++)
            pcm[i] = (data[i] - 128) / 128;
        this.currentSample += pcm.length / this.channels;
        return {
            streamId: this.streamId,
            samplesCount: pcm.length / this.channels,
            pcm: pcm,
            data: data,
            seek: 0
        };
    }
    function SwfSoundStream_decode_PCM_be(data) {
        var pcm = new Float32Array(data.length / 2);
        for (var i = 0, j = 0; i < pcm.length; i++, j += 2)
            pcm[i] = ((data[j] << 24) | (data[j + 1] << 16)) / 2147483648;
        this.currentSample += pcm.length / this.channels;
        return {
            streamId: this.streamId,
            samplesCount: pcm.length / this.channels,
            pcm: pcm,
            data: data,
            seek: 0
        };
    }
    function SwfSoundStream_decode_PCM_le(data) {
        var pcm = new Float32Array(data.length / 2);
        for (var i = 0, j = 0; i < pcm.length; i++, j += 2)
            pcm[i] = ((data[j + 1] << 24) | (data[j] << 16)) / 2147483648;
        this.currentSample += pcm.length / this.channels;
        return {
            streamId: this.streamId,
            samplesCount: pcm.length / this.channels,
            pcm: pcm,
            data: data,
            seek: 0
        };
    }
    function SwfSoundStream_decode_MP3(data) {
        var samplesCount = (data[1] << 8) | data[0];
        var seek = (data[3] << 8) | data[2];
        this.currentSample += samplesCount;
        return {
            streamId: this.streamId,
            samplesCount: samplesCount,
            data: new Uint8Array(data.subarray(4)),
            seek: seek
        };
    }

    /*
    class HTMLAudioElementAdapter implements ISoundStreamAdapter {
      private _sec: ISecurityDomain;
      private _element: HTMLAudioElement;

      get isReady(): boolean {
        return false;//!!this._channel;
      }

      get element(): HTMLAudioElement {
        return this._element;
      }

      get currentTime(): number {
        return this._element.currentTime;
      }

      playFrom(time: number) {
        var element = this._element;
        if (element.paused) {
          element.play();
          element.addEventListener('playing', function setTime(e) {
            element.removeEventListener('playing', setTime);
            element.currentTime = time;
          });
        } else {
          element.currentTime = time;
        }
      }
      
      get isPlaying(): boolean {
        return false;
      }
      stop(){
      }
      
      get paused(): boolean {
        return this._element.paused;
      }

      set paused(value: boolean) {
        var element = this._element;
        if (value) {
          if (!element.paused) {
            element.pause();
          }
        } else {
          if (element.paused) {
            element.play();
          }
        }
      }

      constructor(element: HTMLAudioElement) {
        this._element = element;
      }

      createChannel() {
      }

      queueData(frame: DecodedSound) {
      }

      finish() {
      }
    }

    class MediaSourceStreamAdapter extends HTMLAudioElementAdapter {
      private _mediaSource: MediaSource;
      private _sourceBuffer: SourceBuffer;
      private _updating: boolean;
      private _loading: boolean;
      private _rawFrames: any[];
      private _isReady: boolean;

      constructor(element: HTMLAudioElement) {
        super(element);
        this._mediaSource = new MediaSource();
        this._sourceBuffer = null;
        this._updating = false;
        this._loading = true;
        this._rawFrames = [];
        this._isReady = false;

        this._mediaSource.addEventListener('sourceopen', this._openMediaSource.bind(this));
        this.element.src = URL.createObjectURL(this._mediaSource);
      }

      private _appendSoundData() {
        if (this._rawFrames.length === 0 || this._updating || !this._sourceBuffer) {
          return;
        }
        if (!this._loading) {
          this._mediaSource.endOfStream();
          return;
        }

        this._updating = true;
        // There is an issue when multiple appendBuffers are added in a sequence,
        // pushing frames one-by-one.
        this._sourceBuffer.appendBuffer(this._rawFrames.shift());

        // Making MediaSourceStreamAdapter be ready on first packet.
        if (!this._isReady) {
          this._isReady = true;
          this.createChannel();
        }
      }

      private _openMediaSource() {
        var sourceBuffer = this._mediaSource.addSourceBuffer(MP3_MIME_TYPE);
        sourceBuffer.addEventListener('update', function () {
          this._updating = false;
          this._appendSoundData();
        }.bind(this));
        this._sourceBuffer = sourceBuffer;
        this._appendSoundData();
      }

      queueData(frame: DecodedSound) {
        this._rawFrames.push(frame.data);
        this._appendSoundData();
      }

      finish() {
        this._loading = false;
        this._appendSoundData();
      }
    }

    class BlobStreamAdapter extends HTMLAudioElementAdapter {
      private _rawFrames: any[];

      constructor(element: HTMLAudioElement) {
        super(element);
        this._rawFrames = [];
      }

      queueData(frame: DecodedSound) {
        this._rawFrames.push(frame.data);
      }

      finish() {
        var blob = new Blob(this._rawFrames);
        this.element.src = URL.createObjectURL(blob);
        this.createChannel();
      }
    }

    function syncTime(element, movieClip) {
      var initialized = false;
      var startMediaTime, startRealTime;
      element.addEventListener('timeupdate', function (e) {
        if (!initialized) {
          startMediaTime = element.currentTime;
          startRealTime = performance.now();
          initialized = true;
          //movieClip._stage._frameScheduler.startTrackDelta();
          return;
        }
        var mediaDelta = element.currentTime - startMediaTime;
        var realDelta = performance.now() - startRealTime;
        //movieClip._stage._frameScheduler.setDelta(realDelta - mediaDelta * 1000);
      });
      element.addEventListener('pause', function (e) {
        //movieClip._stage._frameScheduler.endTrackDelta();
        initialized = false;
      });
      element.addEventListener('seeking', function (e) {
        //movieClip._stage._frameScheduler.endTrackDelta();
        initialized = false;
      });
    }
    */
    var WebAudioAdapter = /** @class */ (function () {
        function WebAudioAdapter(data) {
            this._sound = null;
            this._frameData = [];
            this._data = data;
            this._position = 0;
        }
        Object.defineProperty(WebAudioAdapter.prototype, "currentTime", {
            get: function () {
                return this._sound.currentTime;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioAdapter.prototype, "sound", {
            get: function () {
                return this._sound;
            },
            enumerable: true,
            configurable: true
        });
        WebAudioAdapter.prototype.playFrom = function (time) {
            /*var startPlay=true;
            if(this._sound.duration<this._sound.currentTime){
              startPlay=false;
            }*/
            this.stop();
            //if(startPlay){
            this._sound.play(time);
            //}
        };
        WebAudioAdapter.prototype.stop = function () {
            if (this._sound)
                this._sound.stop();
        };
        Object.defineProperty(WebAudioAdapter.prototype, "paused", {
            get: function () {
                return false;
            },
            set: function (value) {
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioAdapter.prototype, "isPlaying", {
            get: function () {
                return this._sound.isPlaying;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(WebAudioAdapter.prototype, "isReady", {
            get: function () {
                return !!this._sound;
            },
            enumerable: true,
            configurable: true
        });
        WebAudioAdapter.prototype.queueData = function (frame) {
            if (!frame.pcm) {
                release$1 || console.log("error in WebAudioAdapter.queueData - frame does not provide pcm data");
                return;
            }
            this._frameData.push(frame);
        };
        WebAudioAdapter.prototype.finish = function () {
            var totalLength = 0;
            for (var i = 0; i < this._frameData.length; i++) {
                totalLength += this._frameData[i].data.length;
            }
            var finalBytes = new Int8Array(totalLength);
            for (var i = 0; i < this._frameData.length; i++) {
                finalBytes.set(this._frameData[i].data, this._position);
                this._position += this._frameData[i].data.length;
            }
            var packagedWave = packageWave(finalBytes, this._data.sampleRate, this._data.channels, this._data.streamSize, false);
            var sound = new WaveAudio(new WaveAudioData(packagedWave.data.buffer));
            this._sound = sound;
        };
        return WebAudioAdapter;
    }());
    var WebAudioMP3Adapter = /** @class */ (function (_super) {
        __extends(WebAudioMP3Adapter, _super);
        //private _decoderPosition: number;
        //private _decoderSession: MP3DecoderSession;
        function WebAudioMP3Adapter(data) {
            return _super.call(this, data) || this;
            /*this._decoderPosition = 0;
            this._decoderSession = new MP3DecoderSession();
            this._decoderSession.onframedata = function (frameData) {
              var position = this._decoderPosition;
              data.pcm.set(frameData, position);
              this._decoderPosition = position + frameData.length;
            }.bind(this);
            this._decoderSession.onclosed = function () {
              WebAudioAdapter.prototype.finish.call(this);
            }.bind(this);
            this._decoderSession.onerror = function (error) {
              console.log('MP3DecoderSession error: ' + error);
            };
            */
        }
        WebAudioMP3Adapter.prototype.queueData = function (frame) {
            if (!frame.data) {
                release$1 || console.log("error in WebAudioAdapter.queueData - frame does not provide data");
                return;
            }
            this._frameData.push(frame);
        };
        WebAudioMP3Adapter.prototype.finish = function () {
            var totalLength = 0;
            for (var i = 0; i < this._frameData.length; i++) {
                totalLength += this._frameData[i].data.length;
            }
            var finalBytes = new Uint8Array(totalLength);
            for (var i = 0; i < this._frameData.length; i++) {
                finalBytes.set(this._frameData[i].data, this._position);
                this._position += this._frameData[i].data.length;
            }
            /*var a = document.createElement("a");
            var file = new Blob([finalBytes.buffer], {type: 'text/plain'});
            a.href = URL.createObjectURL(file);
            a.download = "testmp3.mp3";
            a.click();
            //sound._symbol = data;
            //sound.applySymbol();
            //sound.play(0);
            //var mp3Parser=new MP3Parser();
            //mp3Parser.push(this._data.pcm);
            //this._decoderSession.close();
            */
            var sound = new WaveAudio(new WaveAudioData(finalBytes.buffer));
            this._sound = sound;
        };
        return WebAudioMP3Adapter;
    }(WebAudioAdapter));
    var MovieClipSoundStream = /** @class */ (function () {
        function MovieClipSoundStream(streamInfo) {
            this.decode = streamInfo.decode.bind(streamInfo);
            this.data = {
                sampleRate: streamInfo.sampleRate,
                channels: streamInfo.channels,
                streamSize: streamInfo.streamSize,
            };
            this.seekIndex = [];
            this.position = 0;
            this.isMP3 = streamInfo.format === 'mp3';
            this.soundStreamAdapter = !this.isMP3 ? new WebAudioAdapter(this.data) : new WebAudioMP3Adapter(this.data);
            /*
            try {
              // todo: do this check only once
              let audioContext = new (window.AudioContext || (<any>window).webkitAudioContext)();
            } catch (error) {
              window.alert(
                `Sorry, but your browser doesn't support the Web Audio API!`
              );
            }
            */
            //var sec = (<any>movieClip).sec;
            /*if (isMP3 && !webAudioMP3Option) {
              var element = document.createElement('audio');
              element.preload = 'metadata'; // for mobile devices
              element.loop = false;
              syncTime(element, movieClip);
              if (element.canPlayType(MP3_MIME_TYPE)) {
                this.element = element;
                if (!mediaSourceMP3Option) {
                  this.soundStreamAdapter = new BlobStreamAdapter(sec, element);
                } else if (typeof MediaSource !== 'undefined' &&
                  (<any>MediaSource).isTypeSupported(MP3_MIME_TYPE)) {
                  this.soundStreamAdapter = new MediaSourceStreamAdapter(sec, element);
                } else {
                  // Falls back to blob playback.
                  //Debug.warning('MediaSource is not supported');
                  this.soundStreamAdapter = new BlobStreamAdapter(sec, element);
                }
                return;
              }
              // Falls through to WebAudio if element cannot play MP3.
            }*/
        }
        MovieClipSoundStream.prototype.appendBlock = function (frameNum, streamBlock) {
            var decodedBlock = this.decode(streamBlock);
            var streamPosition = this.position;
            /*if(!this.seekIndex[frameNum-1]){
              this.seekIndex[frameNum-1]=streamPosition;
              var time = this.seekIndex[frameNum-1]  / this.data.channels / this.data.sampleRate;
              if(this.isMP3){
                time*=this.data.channels;
              }
              console.log("add soundblock", frameNum-1, this.seekIndex[frameNum-1], time)
            }*/
            this.seekIndex[frameNum] = (streamPosition + decodedBlock.seek);
            var time = this.seekIndex[frameNum] / this.data.channels / this.data.sampleRate;
            if (this.isMP3) {
                time *= this.data.channels;
            }
            //console.log("add soundblock", frameNum, this.seekIndex[frameNum], time)
            this.position = streamPosition + decodedBlock.samplesCount;
            this.soundStreamAdapter.queueData(decodedBlock);
        };
        MovieClipSoundStream.prototype.stop = function () {
            this.soundStreamAdapter.stop();
        };
        MovieClipSoundStream.prototype.playFrame = function (frameNum) {
            if (isNaN(this.seekIndex[frameNum])) {
                return 0;
            }
            this.isPlaying = true;
            if (!this.finalized) {
                this.finalized = true;
                this.soundStreamAdapter.finish();
            }
            var soundStreamData = this.data;
            var time = this.seekIndex[frameNum] / soundStreamData.channels / soundStreamData.sampleRate;
            var elementTime = this.soundStreamAdapter.currentTime;
            if (this.isMP3) {
                time *= soundStreamData.channels;
            }
            MovieClipSoundsManager.addActiveSound(this.soundStreamAdapter.sound);
            //console.log("start sound at: time", time, "elementTime", elementTime, this.soundStreamAdapter.isPlaying);
            if (!this.soundStreamAdapter.isPlaying) { //} || Math.abs(time-elementTime)>PLAYBACK_ADJUSTMENT){
                this.soundStreamAdapter.playFrom(time);
            }
            /*console.log("should be at time: ", time);
            console.log("is at time: ", elementTime);
            console.log("diff: ", time-elementTime);
            console.log("diff in frames: ", Math.round(((elementTime-time)*1000)/(1000/MovieClipSoundStream.frameRate)));*/
            if ((elementTime - time) < 0) {
                return Math.ceil(((elementTime - time) * 1000) / (1000 / MovieClipSoundStream.frameRate));
            }
            return Math.floor(((elementTime - time) * 1000) / (1000 / MovieClipSoundStream.frameRate));
        };
        MovieClipSoundStream.frameRate = 25;
        return MovieClipSoundStream;
    }());

    var MovieClipSoundsManager = /** @class */ (function () {
        function MovieClipSoundsManager() {
            this.lastFrameNum = -2;
            this._soundStreams = [];
        }
        MovieClipSoundsManager.addActiveSound = function (sound) {
            //console.log("start sound with id", sound.id)
            if (!MovieClipSoundsManager.activeSounds[sound.id]) {
                MovieClipSoundsManager.activeSounds[sound.id] = {};
            }
            MovieClipSoundsManager.activeSounds[sound.id].active = true;
            MovieClipSoundsManager.activeSounds[sound.id].sound = sound;
        };
        MovieClipSoundsManager.enterFrame = function () {
            for (var key in MovieClipSoundsManager.activeSounds) {
                //console.log("set sound to inactive", key)
                var sound = MovieClipSoundsManager.activeSounds[key];
                sound.active = false;
            }
        };
        MovieClipSoundsManager.exitFrame = function () {
            for (var key in MovieClipSoundsManager.activeSounds) {
                var sound = MovieClipSoundsManager.activeSounds[key];
                if (!sound.active) {
                    //console.log("stop inactive sound", key)
                    sound.sound.stop();
                    delete MovieClipSoundsManager.activeSounds[key];
                }
            }
        };
        MovieClipSoundsManager.prototype.initSoundStream = function (streamInfo) {
            this.soundStreamHead = streamInfo;
        };
        MovieClipSoundsManager.prototype.addSoundStreamBlock = function (frameNum, streamBlock) {
            if (!this.soundStreamHead) {
                release$1 || console.log("can not add soundstreamblock if no soundstreamHead exists");
                return;
            }
            if (this._soundStreams.length == 0 || (frameNum - this.lastFrameNum) > 1) {
                this._soundStreams.push(new MovieClipSoundStream(this.soundStreamHead));
            }
            this.lastFrameNum = frameNum;
            this._soundStreams[this._soundStreams.length - 1].appendBlock(frameNum, streamBlock);
        };
        MovieClipSoundsManager.prototype.syncSounds = function (frameNum, isPlaying, parent) {
            var skipFrames = 0;
            for (var i = 0; i < this._soundStreams.length; i++) {
                if (isPlaying && parent) {
                    var skipFrames_oneStream = this._soundStreams[i].playFrame(frameNum);
                    if (Math.abs(skipFrames_oneStream) > Math.abs(skipFrames)) {
                        skipFrames = skipFrames_oneStream;
                    }
                }
            }
            return skipFrames;
        };
        MovieClipSoundsManager.activeSounds = {};
        return MovieClipSoundsManager;
    }());

    /*
     * Copyright 2013 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var StreamNoDataError = {};
    var masks = new Uint32Array(33);
    for (var i$1 = 1, mask$1 = 0; i$1 <= 32; ++i$1) {
        masks[i$1] = mask$1 = (mask$1 << 1) | 1;
    }
    var Stream = /** @class */ (function () {
        function Stream(buffer, offset, length, maxLength) {
            if (offset === undefined)
                offset = 0;
            if (buffer.buffer instanceof ArrayBuffer) {
                offset += buffer.byteOffset;
                buffer = buffer.buffer;
            }
            if (length === undefined)
                length = buffer.byteLength - offset;
            if (maxLength === undefined)
                maxLength = length;
            this.bytes = new Uint8Array(buffer, offset, maxLength);
            this.view = new DataView(buffer, offset, maxLength);
            this.pos = 0;
            this.end = length;
            this.bitBuffer = 0;
            this.bitLength = 0;
        }
        Stream.prototype.align = function () {
            this.bitBuffer = this.bitLength = 0;
        };
        Stream.prototype.ensure = function (size) {
            if (this.pos + size > this.end) {
                throw StreamNoDataError;
            }
        };
        Stream.prototype.remaining = function () {
            return this.end - this.pos;
        };
        Stream.prototype.substream = function (begin, end) {
            var stream = new Stream(this.bytes);
            stream.pos = begin;
            stream.end = end;
            return stream;
        };
        Stream.prototype.push = function (data) {
            var bytes = this.bytes;
            var newBytesLength = this.end + data.length;
            if (newBytesLength > bytes.length) {
                throw 'stream buffer overfow';
            }
            bytes.set(data, this.end);
            this.end = newBytesLength;
        };
        Stream.prototype.readSi8 = function () {
            return this.view.getInt8(this.pos++);
        };
        Stream.prototype.readSi16 = function () {
            var r = this.view.getInt16(this.pos, true);
            this.pos += 2;
            return r;
        };
        Stream.prototype.readSi32 = function () {
            var r = this.view.getInt32(this.pos, true);
            this.pos += 4;
            return r;
        };
        Stream.prototype.readUi8 = function () {
            return this.bytes[this.pos++];
        };
        Stream.prototype.readUi16 = function () {
            var r = this.view.getUint16(this.pos, true);
            this.pos += 2;
            return r;
        };
        Stream.prototype.readUi32 = function () {
            var r = this.view.getUint32(this.pos, true);
            this.pos += 4;
            return r;
        };
        Stream.prototype.readFixed = function () {
            var r = this.view.getInt32(this.pos, true) / 65536;
            this.pos += 4;
            return r;
        };
        Stream.prototype.readFixed8 = function () {
            var r = this.view.getInt16(this.pos, true) / 256;
            this.pos += 2;
            return r;
        };
        Stream.prototype.readFloat16 = function () {
            var ui16 = this.view.getUint16(this.pos, false);
            this.pos += 2;
            var sign = ui16 >> 15 ? -1 : 1;
            var exponent = (ui16 & 0x7c00) >> 10;
            var fraction = ui16 & 0x03ff;
            if (!exponent)
                return sign * Math.pow(2, -14) * (fraction / 1024);
            if (exponent === 0x1f)
                return fraction ? NaN : sign * Infinity;
            return sign * Math.pow(2, exponent - 15) * (1 + (fraction / 1024));
        };
        Stream.prototype.readFloat = function () {
            var r = this.view.getFloat32(this.pos, true);
            this.pos += 4;
            return r;
        };
        Stream.prototype.readDouble = function () {
            var r = this.view.getFloat64(this.pos, true);
            this.pos += 8;
            return r;
        };
        Stream.prototype.readEncodedU32 = function () {
            var bytes = this.bytes;
            var val = bytes[this.pos++];
            if (!(val & 0x080))
                return val;
            val = (val & 0x7f) | bytes[this.pos++] << 7;
            if (!(val & 0x4000))
                return val;
            val = (val & 0x3fff) | bytes[this.pos++] << 14;
            if (!(val & 0x200000))
                return val;
            val = (val & 0x1FFFFF) | bytes[this.pos++] << 21;
            if (!(val & 0x10000000))
                return val;
            return (val & 0xFFFFFFF) | (bytes[this.pos++] << 28);
        };
        Stream.prototype.readBool = function () {
            return !!this.bytes[this.pos++];
        };
        Stream.prototype.readSb = function (size) {
            return (this.readUb(size) << (32 - size)) >> (32 - size);
        };
        Stream.prototype.readUb = function (size) {
            var buffer = this.bitBuffer;
            var bitlen = this.bitLength;
            var val = 0;
            while (size > bitlen) {
                if (bitlen > 24) {
                    // Avoid overflow. Save current buffer in val and add remaining bits later.
                    size -= bitlen;
                    val = buffer << size;
                    bitlen = 0;
                }
                buffer = (buffer << 8) | this.bytes[this.pos++];
                bitlen += 8;
            }
            bitlen -= size;
            val |= (buffer >>> bitlen) & masks[size];
            this.bitBuffer = buffer;
            this.bitLength = bitlen;
            return val;
        };
        Stream.prototype.readFb = function (size) {
            return this.readSb(size) / 65536;
        };
        Stream.prototype.readString = function (length) {
            var bytes = this.bytes;
            var codes;
            var pos = this.pos;
            if (length > -1) {
                codes = bytes.subarray(pos, pos += length);
            }
            else {
                length = 0;
                for (var i = pos; bytes[i]; i++) {
                    length++;
                }
                codes = bytes.subarray(pos, pos += length);
                pos++;
            }
            this.pos = pos;
            var str = utf8encode(codes);
            if (str.indexOf('\0') >= 0) {
                str = str.split('\0').join('');
            }
            return str;
        };
        return Stream;
    }());

    /*
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function parseBbox(stream) {
        stream.align();
        var bits = stream.readUb(5);
        var xMin = stream.readSb(bits);
        var xMax = stream.readSb(bits);
        var yMin = stream.readSb(bits);
        var yMax = stream.readSb(bits);
        stream.align();
        return { xMin: xMin, xMax: xMax, yMin: yMin, yMax: yMax };
    }
    function parseRgb(stream) {
        return ((stream.readUi8() << 24) | (stream.readUi8() << 16) |
            (stream.readUi8() << 8) | 0xff) >>> 0;
    }
    function parseRgba(stream) {
        return (stream.readUi8() << 24) | (stream.readUi8() << 16) |
            (stream.readUi8() << 8) | stream.readUi8();
    }
    function parseArgb(stream) {
        return stream.readUi8() | (stream.readUi8() << 24) |
            (stream.readUi8() << 16) | (stream.readUi8() << 8);
    }
    function parseMatrix(stream) {
        var matrix = { a: 1, b: 0, c: 0, d: 1, tx: 0, ty: 0 };
        stream.align();
        var hasScale = stream.readUb(1);
        if (hasScale) {
            var bits = stream.readUb(5);
            matrix.a = stream.readFb(bits);
            matrix.d = stream.readFb(bits);
        }
        var hasRotate = stream.readUb(1);
        if (hasRotate) {
            var bits = stream.readUb(5);
            matrix.b = stream.readFb(bits);
            matrix.c = stream.readFb(bits);
        }
        var bits = stream.readUb(5);
        matrix.tx = stream.readSb(bits);
        matrix.ty = stream.readSb(bits);
        stream.align();
        return matrix;
    }
    function parseColorTransform(stream, hasAlpha) {
        var cxform = {
            redMultiplier: 0xff,
            greenMultiplier: 0xff,
            blueMultiplier: 0xff,
            alphaMultiplier: 0xff,
            redOffset: 0,
            greenOffset: 0,
            blueOffset: 0,
            alphaOffset: 0,
        };
        stream.align();
        var hasOffsets = stream.readUb(1);
        var hasMultipliers = stream.readUb(1);
        var bits = stream.readUb(4);
        if (hasMultipliers) {
            cxform.redMultiplier = stream.readSb(bits);
            cxform.greenMultiplier = stream.readSb(bits);
            cxform.blueMultiplier = stream.readSb(bits);
            if (hasAlpha) {
                cxform.alphaMultiplier = stream.readSb(bits);
            }
        }
        if (hasOffsets) {
            cxform.redOffset = stream.readSb(bits);
            cxform.greenOffset = stream.readSb(bits);
            cxform.blueOffset = stream.readSb(bits);
            if (hasAlpha) {
                cxform.alphaOffset = stream.readSb(bits);
            }
        }
        stream.align();
        return cxform;
    }
    function parsePlaceObjectTag(stream, swfVersion, tagCode, tagEnd) {
        var tag = { code: tagCode };
        tag.actionBlocksPrecedence = stream.pos;
        if (tagCode === 4 /* CODE_PLACE_OBJECT */) {
            tag.symbolId = stream.readUi16();
            tag.depth = stream.readUi16();
            tag.flags |= 4 /* HasMatrix */;
            tag.matrix = parseMatrix(stream);
            if (stream.pos < tagEnd) {
                tag.flags |= 8 /* HasColorTransform */;
                tag.cxform = parseColorTransform(stream, false);
            }
            return tag;
        }
        var flags = tag.flags = tagCode > 26 /* CODE_PLACE_OBJECT2 */ ?
            stream.readUi16() :
            stream.readUi8();
        tag.depth = stream.readUi16();
        if (flags & 2048 /* HasClassName */) {
            tag.className = stream.readString(-1);
        }
        if (flags & 2 /* HasCharacter */) {
            tag.symbolId = stream.readUi16();
        }
        if (flags & 4 /* HasMatrix */) {
            tag.matrix = parseMatrix(stream);
        }
        if (flags & 8 /* HasColorTransform */) {
            tag.cxform = parseColorTransform(stream, true);
        }
        if (flags & 16 /* HasRatio */) {
            tag.ratio = stream.readUi16();
        }
        if (flags & 32 /* HasName */) {
            tag.name = stream.readString(-1);
        }
        if (flags & 64 /* HasClipDepth */) {
            tag.clipDepth = stream.readUi16();
        }
        if (flags & 256 /* HasFilterList */) {
            var count = stream.readUi8();
            var filters = tag.filters = [];
            while (count--) {
                filters.push(parseFilter(stream));
            }
        }
        if (flags & 512 /* HasBlendMode */) {
            tag.blendMode = stream.readUi8();
        }
        if (flags & 1024 /* HasCacheAsBitmap */) {
            tag.bmpCache = stream.readUi8();
        }
        if (flags & 8192 /* HasVisible */) {
            tag.visibility = stream.readBool();
        }
        if (flags & 16384 /* OpaqueBackground */) {
            tag.backgroundColor = parseArgb(stream);
        }
        if (flags & 128 /* HasClipActions */) {
            var reserved = stream.readUi16();
            var allFlags = swfVersion >= 6 ? stream.readUi32() : stream.readUi16();
            var allEvents = tag.events = [];
            var events;
            while (events = parseEvents(stream, swfVersion)) {
                if (stream.pos > tagEnd) {
                    console.log('PlaceObject handler attempted to read clip events beyond tag end');
                    stream.pos = tagEnd;
                    break;
                }
                allEvents.push(events);
            }
        }
        return tag;
    }
    function parseEvents(stream, swfVersion) {
        var flags = swfVersion >= 6 ? stream.readUi32() : stream.readUi16();
        if (!flags) {
            // `true` means this is the EndOfEvents marker.
            return null;
        }
        var events = {};
        // The Construct event is only allowed in 7+. It can't be set in < 6, so mask it out for 6.
        if (swfVersion === 6) {
            flags = flags & ~262144 /* Construct */;
        }
        events.flags = flags;
        var length = stream.readUi32();
        if (flags & 131072 /* KeyPress */) {
            events.keyCode = stream.readUi8();
            length--;
        }
        var end = stream.pos + length;
        events.actionsBlock = stream.bytes.subarray(stream.pos, end);
        stream.pos = end;
        return events;
    }
    function parseFilter(stream) {
        var filter = {};
        var type = filter.type = stream.readUi8();
        switch (type) {
            case 0:
            case 2:
            case 3:
            case 4:
            case 7:
                var glow = filter;
                var count;
                if (type === 4 || type === 7) {
                    count = stream.readUi8();
                }
                else {
                    count = type === 3 ? 2 : 1;
                }
                var colors = glow.colors = [];
                var i = count;
                while (i--) {
                    colors.push(parseRgba(stream));
                }
                if (type === 4 || type === 7) {
                    var ratios = glow.ratios = [];
                    var i = count;
                    while (i--) {
                        ratios.push(stream.readUi8());
                    }
                }
                glow.blurX = stream.readFixed();
                glow.blurY = stream.readFixed();
                if (type !== 2) {
                    glow.angle = stream.readFixed();
                    glow.distance = stream.readFixed();
                }
                glow.strength = stream.readFixed8();
                glow.inner = !!stream.readUb(1);
                glow.knockout = !!stream.readUb(1);
                glow.compositeSource = !!stream.readUb(1);
                if (type === 3 || type === 4 || type === 7) {
                    glow.onTop = !!stream.readUb(1);
                    glow.quality = stream.readUb(4);
                }
                else {
                    glow.quality = stream.readUb(5);
                }
                return glow;
            case 1:
                var blur = filter;
                blur.blurX = stream.readFixed();
                blur.blurY = stream.readFixed();
                blur.quality = stream.readUb(5);
                stream.readUb(3);
                return blur;
            case 5:
                var conv = filter;
                var matrixX = conv.matrixX = stream.readUi8();
                var matrixY = conv.matrixY = stream.readUi8();
                conv.divisor = stream.readFloat();
                conv.bias = stream.readFloat();
                var matrix = conv.matrix = [];
                var i = matrixX * matrixY;
                while (i--) {
                    matrix.push(stream.readFloat());
                }
                conv.color = parseRgba(stream);
                var reserved = stream.readUb(6);
                conv.clamp = !!stream.readUb(1);
                conv.preserveAlpha = !!stream.readUb(1);
                return conv;
            case 6:
                var cm = filter;
                var matrix = cm.matrix = [];
                var i = 20;
                while (i--) {
                    matrix.push(stream.readFloat());
                }
                return cm;
            default:
        }
        return filter;
    }
    function parseRemoveObjectTag(stream, swfVersion, tagCode) {
        var tag = { code: tagCode };
        if (tagCode === 5 /* CODE_REMOVE_OBJECT */) {
            tag.depth = stream.readUi16();
            tag.symbolId = stream.readUi16();
        }
        else {
            tag.depth = stream.readUi16();
        }
        return tag;
    }
    function parseDefineImageTag(stream, swfVersion, tagCode, tagEnd, jpegTables) {
        var tag = { code: tagCode };
        tag.id = stream.readUi16();
        var imgData;
        if (tagCode > 21 /* CODE_DEFINE_BITS_JPEG2 */) {
            var alphaDataOffset = stream.readUi32();
            if (tagCode === 90 /* CODE_DEFINE_BITS_JPEG4 */) {
                tag.deblock = stream.readFixed8();
            }
            alphaDataOffset += stream.pos;
            imgData = tag.imgData = stream.bytes.subarray(stream.pos, alphaDataOffset);
            tag.alphaData = stream.bytes.subarray(alphaDataOffset, tagEnd);
            stream.pos = tagEnd;
        }
        else {
            imgData = tag.imgData = stream.bytes.subarray(stream.pos, tagEnd);
            stream.pos = tagEnd;
        }
        switch (imgData[0] << 8 | imgData[1]) {
            case 65496:
            case 65497:
                tag.mimeType = "image/jpeg";
                break;
            case 35152:
                tag.mimeType = "image/png";
                break;
            case 18249:
                tag.mimeType = "image/gif";
                break;
            default:
                tag.mimeType = "application/octet-stream";
        }
        if (tagCode === 6 /* CODE_DEFINE_BITS */) {
            tag.jpegTables = { data: jpegTables };
        }
        return tag;
    }
    function parseDefineButtonTag(stream, swfVersion, tagCode, tagEnd) {
        var tag = { code: tagCode };
        tag.id = stream.readUi16();
        var characters = tag.characters = [];
        var character;
        if (tagCode == 7 /* CODE_DEFINE_BUTTON */) {
            while (character = parseButtonCharacter(stream, swfVersion, tagCode)) {
                characters.push(character);
            }
            tag.actionsData = stream.bytes.subarray(stream.pos, tagEnd);
            stream.pos = tagEnd;
        }
        else {
            var trackFlags = stream.readUi8();
            tag.trackAsMenu = !!(trackFlags >> 7 & 1);
            var actionOffset = stream.readUi16();
            while (character = parseButtonCharacter(stream, swfVersion, tagCode)) {
                characters.push(character);
            }
            if (!!actionOffset) {
                var buttonActions = tag.buttonActions = [];
                while (stream.pos < tagEnd) {
                    var action = parseButtonCondAction(stream, tagEnd);
                    // Ignore actions that exceed the tag length.
                    if (stream.pos > tagEnd) {
                        break;
                    }
                    buttonActions.push(action);
                }
                stream.pos = tagEnd;
            }
        }
        return tag;
    }
    function parseButtonCharacter(stream, swfVersion, tagCode) {
        var flags = stream.readUi8();
        if (!flags) {
            return null;
        }
        var character = {};
        if (swfVersion < 8) {
            // Clear HasBlendMode and HasFilterList flags.
            flags &= ~(512 /* HasBlendMode */ | 256 /* HasFilterList */);
        }
        character.flags = flags;
        character.symbolId = stream.readUi16();
        character.depth = stream.readUi16();
        character.matrix = parseMatrix(stream);
        if (tagCode === 34 /* CODE_DEFINE_BUTTON2 */) {
            character.cxform = parseColorTransform(stream, true);
        }
        if (character.flags & 16 /* HasFilterList */) {
            var count = stream.readUi8();
            var filters = character.filters = [];
            var i = count;
            while (i--) {
                filters.push(parseFilter(stream));
            }
        }
        if (character.flags & 32 /* HasBlendMode */) {
            character.blendMode = stream.readUi8();
        }
        return character;
    }
    function parseButtonCondAction(stream, tagEnd) {
        var start = stream.pos;
        var tagSize = stream.readUi16();
        // If no tagSize is given, read to the tag's end.
        var end = tagSize ? start + tagSize : tagEnd;
        var conditions = stream.readUi16();
        stream.pos = end;
        return {
            // The 7 upper bits hold a key code the button should respond to.
            keyCode: (conditions & 0xfe00) >> 9,
            // The lower 9 bits hold state transition flags. See the enum in AVM1Button for details.
            stateTransitionFlags: conditions & 0x1ff,
            // If no tagSize is given, pass `0` to readBinary.
            actionsData: stream.bytes.subarray(start + 4, end)
        };
    }
    function parseDefineBinaryDataTag(stream, swfVersion, tagCode, tagEnd) {
        var tag = { code: tagCode };
        tag.id = stream.readUi16();
        stream.pos += 4; // Reserved
        tag.data = stream.bytes.subarray(stream.pos, tagEnd);
        stream.pos = tagEnd;
        return tag;
    }
    function parseDefineFontTag(stream, swfVersion, tagCode) {
        var tag = { code: tagCode };
        tag.id = stream.readUi16();
        var firstOffset = stream.readUi16();
        var glyphCount = firstOffset / 2;
        var restOffsets = [];
        var i = glyphCount - 1;
        while (i--) {
            restOffsets.push(stream.readUi16());
        }
        tag.offsets = [firstOffset].concat(restOffsets);
        var glyphs = tag.glyphs = [];
        var i = glyphCount;
        while (i--) {
            glyphs.push(parseGlyph(stream, swfVersion, tagCode));
        }
        return tag;
    }
    function parseGlyph(stream, swfVersion, tagCode) {
        stream.align();
        var fillBits = stream.readUb(4);
        var lineBits = stream.readUb(4);
        return parseShapeRecords(stream, swfVersion, tagCode, false, fillBits, lineBits, false);
    }
    function parseDefineTextTag(stream, swfVersion, tagCode) {
        var tag = { code: tagCode };
        tag.id = stream.readUi16();
        tag.bbox = parseBbox(stream);
        tag.matrix = parseMatrix(stream);
        var glyphBits = stream.readUi8();
        var advanceBits = stream.readUi8();
        var records = tag.records = [];
        var record;
        while (record = parseTextRecord(stream, swfVersion, tagCode, glyphBits, advanceBits)) {
            records.push(record);
        }
        return tag;
    }
    function parseTextRecord(stream, swfVersion, tagCode, glyphBits, advanceBits) {
        stream.align();
        var flags = stream.readUb(8);
        if (!flags) {
            return null;
        }
        var record = {};
        record.flags = flags;
        if (flags & 8 /* HasFont */) {
            record.fontId = stream.readUi16();
        }
        if (flags & 4 /* HasColor */) {
            record.color = tagCode === 33 /* CODE_DEFINE_TEXT2 */ ?
                parseRgba(stream) :
                parseRgb(stream);
        }
        if (flags & 1 /* HasMoveX */) {
            record.moveX = stream.readSi16();
        }
        if (flags & 2 /* HasMoveY */) {
            record.moveY = stream.readSi16();
        }
        if (flags & 8 /* HasFont */) {
            record.fontHeight = stream.readUi16();
        }
        var glyphCount = stream.readUi8();
        if (swfVersion <= 6) {
            glyphCount = glyphCount; // & 0x7f ???;
        }
        var entries = record.entries = [];
        var i = glyphCount;
        while (i--) {
            entries.push({
                glyphIndex: stream.readUb(glyphBits),
                advance: stream.readSb(advanceBits)
            });
        }
        return record;
    }
    function parseDefineSoundTag(stream, swfVersion, tagCode, tagEnd) {
        var tag = { code: tagCode };
        tag.id = stream.readUi16();
        var soundFlags = stream.readUi8();
        tag.soundFormat = soundFlags >> 4 & 15;
        tag.soundRate = soundFlags >> 2 & 3;
        tag.soundSize = soundFlags >> 1 & 1;
        tag.soundType = soundFlags & 1;
        tag.samplesCount = stream.readUi32();
        tag.soundData = stream.bytes.subarray(stream.pos, tagEnd);
        stream.pos = tagEnd;
        return tag;
    }
    function parseStartSoundTag(stream, swfVersion, tagCode) {
        var tag = { code: tagCode };
        if (tagCode == 15 /* CODE_START_SOUND */) {
            tag.soundId = stream.readUi16();
        }
        if (tagCode == 89 /* CODE_START_SOUND2 */) {
            tag.soundClassName = stream.readString(-1);
        }
        tag.soundInfo = parseSoundInfo(stream);
        return tag;
    }
    function parseSoundInfo(stream) {
        var info = {};
        var flags = info.flags = stream.readUi8();
        if (flags & 1 /* HasInPoint */) {
            info.inPoint = stream.readUi32();
        }
        if (flags & 2 /* HasOutPoint */) {
            info.outPoint = stream.readUi32();
        }
        if (flags & 4 /* HasLoops */) {
            info.loopCount = stream.readUi16();
        }
        if (flags & 8 /* HasEnvelope */) {
            var envelopeCount = stream.readUi8();
            var envelopes = info.envelopes = [];
            var i = envelopeCount;
            while (i--) {
                envelopes.push({
                    pos44: stream.readUi32(),
                    volumeLeft: stream.readUi16(),
                    volumeRight: stream.readUi16()
                });
            }
        }
        return info;
    }
    function parseSoundStreamHeadTag(stream, tagEnd) {
        var tag = {};
        var playbackFlags = stream.readUi8();
        tag.playbackRate = playbackFlags >> 2 & 3;
        tag.playbackSize = playbackFlags >> 1 & 1;
        tag.playbackType = playbackFlags & 1;
        var streamFlags = stream.readUi8();
        var streamCompression = tag.streamCompression = streamFlags >> 4 & 15;
        tag.streamRate = streamFlags >> 2 & 3;
        tag.streamSize = (streamFlags >> 1 & 1) == 0 ? 8 : 16;
        tag.streamType = streamFlags & 1;
        tag.samplesCount = stream.readUi16();
        if (streamCompression == 2 && tagEnd - stream.pos >= 2) {
            tag.latencySeek = stream.readSi16();
        }
        return tag;
    }
    function parseDefineBitmapTag(stream, swfVersion, tagCode, tagEnd) {
        var tag = { code: tagCode };
        tag.id = stream.readUi16();
        var format = tag.format = stream.readUi8();
        tag.width = stream.readUi16();
        tag.height = stream.readUi16();
        tag.hasAlpha = tagCode === 36 /* CODE_DEFINE_BITS_LOSSLESS2 */;
        if (format === 3) {
            tag.colorTableSize = stream.readUi8();
        }
        tag.bmpData = stream.bytes.subarray(stream.pos, tagEnd);
        stream.pos = tagEnd;
        return tag;
    }
    function parseDefineEditTextTag(stream, swfVersion, tagCode) {
        var tag = { code: tagCode };
        tag.id = stream.readUi16();
        tag.bbox = parseBbox(stream);
        var flags = tag.flags = stream.readUi16();
        if (flags & 1 /* HasFont */) {
            tag.fontId = stream.readUi16();
        }
        if (flags & 32768 /* HasFontClass */) {
            tag.fontClass = stream.readString(-1);
        }
        if (flags & 1 /* HasFont */) {
            tag.fontHeight = stream.readUi16();
        }
        if (flags & 4 /* HasColor */) {
            tag.color = parseRgba(stream);
        }
        if (flags & 2 /* HasMaxLength */) {
            tag.maxLength = stream.readUi16();
        }
        if (flags & 8192 /* HasLayout */) {
            tag.align = stream.readUi8();
            tag.leftMargin = stream.readUi16();
            tag.rightMargin = stream.readUi16();
            tag.indent = stream.readSi16();
            tag.leading = stream.readSi16();
        }
        tag.variableName = stream.readString(-1);
        if (flags & 128 /* HasText */) {
            tag.initialText = stream.readString(-1);
        }
        return tag;
    }
    function parseDefineFont2Tag(stream, swfVersion, tagCode, tagEnd) {
        var tag = { code: tagCode };
        tag.id = stream.readUi16();
        var flags = tag.flags = stream.readUi8();
        var wide = !!(flags & 4 /* WideOrHasFontData */);
        if (swfVersion > 5) {
            tag.language = stream.readUi8();
        }
        else {
            // Clear ShiftJis flag.
            flags = tag.flags = flags & ~64 /* ShiftJis */;
            // Skip reserved byte.
            stream.pos += 1;
            tag.language = 0;
        }
        var nameLength = stream.readUi8();
        tag.name = stream.readString(nameLength);
        if (tagCode === 75 /* CODE_DEFINE_FONT3 */) {
            tag.resolution = 20;
        }
        var glyphCount = stream.readUi16();
        // The SWF format docs doesn't say that, but the DefineFont{2,3} tag ends here for device fonts.
        if (glyphCount === 0) {
            return tag;
        }
        var startpos = stream.pos;
        var offsets = tag.offsets = [];
        var i = glyphCount;
        if (flags & 8 /* WideOffset */) {
            while (i--) {
                offsets.push(stream.readUi32());
            }
            tag.mapOffset = stream.readUi32();
        }
        else {
            while (i--) {
                offsets.push(stream.readUi16());
            }
            tag.mapOffset = stream.readUi16();
        }
        var glyphs = tag.glyphs = [];
        var i = glyphCount;
        while (i--) {
            var dist = tag.offsets[glyphCount - i] + startpos - stream.pos;
            // when just one byte difference between two offsets, just read that and insert an empty glyph.
            if (dist === 1) {
                stream.pos += 1;
                glyphs.push([]);
                continue;
            }
            glyphs.push(parseGlyph(stream, swfVersion, tagCode));
        }
        var codes = tag.codes = [];
        var i = glyphCount;
        while (i--) {
            codes.push(wide ? stream.readUi16() : stream.readUi8());
        }
        if (flags & 128 /* HasLayout */) {
            tag.ascent = stream.readUi16();
            tag.descent = stream.readUi16();
            tag.leading = stream.readSi16();
            var advance = tag.advance = [];
            var i = glyphCount;
            while (i--) {
                advance.push(stream.readSi16());
            }
            var bbox = tag.bbox = [];
            var i = glyphCount;
            while (i--) {
                bbox.push(parseBbox(stream));
            }
            var kerningCount = stream.readUi16();
            var kernings = tag.kerning = [];
            var i = kerningCount;
            // DefineFont2 tags tend to have a wrong kerning count so we have to make sure here that there is enough unread
            // data remaining before parsing the next kerning record. If not, we have to bail out earlier in the following
            // loop to avoid reading out of bound.
            while (i-- && tagEnd - stream.pos >= (wide ? 4 : 2) + 2) {
                kernings.push(parseKerning(stream, wide));
            }
        }
        return tag;
    }
    function parseKerning(stream, wide) {
        var kerning = {};
        if (wide) {
            kerning.code1 = stream.readUi16();
            kerning.code2 = stream.readUi16();
        }
        else {
            kerning.code1 = stream.readUi8();
            kerning.code2 = stream.readUi8();
        }
        kerning.adjustment = stream.readUi16();
        return kerning;
    }
    function parseDefineFont4Tag(stream, swfVersion, tagCode, tagEnd) {
        var tag = { code: tagCode };
        tag.id = stream.readUi16();
        var flags = tag.flags = stream.readUi8();
        tag.name = stream.readString(-1);
        if (flags & 4 /* WideOrHasFontData */) {
            tag.data = stream.bytes.subarray(stream.pos, tagEnd);
            stream.pos = tagEnd;
        }
        return tag;
    }
    function parseDefineScalingGridTag(stream, swfVersion, tagCode) {
        var tag = { code: tagCode };
        tag.symbolId = stream.readUi16();
        tag.splitter = parseBbox(stream);
        return tag;
    }
    function parseDefineSceneTag(stream, tagCode) {
        var tag = { code: tagCode };
        var sceneCount = stream.readEncodedU32();
        var scenes = tag.scenes = [];
        var i = sceneCount;
        while (i--) {
            scenes.push({
                offset: stream.readEncodedU32(),
                name: stream.readString(-1)
            });
        }
        var labelCount = stream.readEncodedU32();
        var labels = tag.labels = [];
        var i = labelCount;
        while (i--) {
            labels.push({
                frame: stream.readEncodedU32(),
                name: stream.readString(-1)
            });
        }
        return tag;
    }
    function parseDefineShapeTag(stream, swfVersion, tagCode) {
        var tag = { code: tagCode };
        tag.id = stream.readUi16();
        tag.lineBounds = parseBbox(stream);
        var flags = 0;
        var isMorph = tagCode === 46 /* CODE_DEFINE_MORPH_SHAPE */ ||
            tagCode === 84 /* CODE_DEFINE_MORPH_SHAPE2 */;
        if (isMorph) {
            flags |= 8 /* IsMorph */;
            tag.lineBoundsMorph = parseBbox(stream);
        }
        var canHaveStrokes = tagCode === 83 /* CODE_DEFINE_SHAPE4 */ ||
            tagCode === 84 /* CODE_DEFINE_MORPH_SHAPE2 */;
        if (canHaveStrokes) {
            var fillBounds = tag.fillBounds = parseBbox(stream);
            if (isMorph) {
                tag.fillBoundsMorph = parseBbox(stream);
            }
            flags |= stream.readUi8() & 0x07;
        }
        tag.flags = flags;
        if (isMorph) {
            stream.pos += 4;
        }
        tag.fillStyles = parseFillStyles(stream, swfVersion, tagCode, isMorph);
        tag.lineStyles = parseLineStyles(stream, swfVersion, tagCode, isMorph, canHaveStrokes);
        stream.align();
        var fillBits = stream.readUb(4);
        var lineBits = stream.readUb(4);
        tag.records = parseShapeRecords(stream, swfVersion, tagCode, isMorph, fillBits, lineBits, canHaveStrokes);
        if (isMorph) {
            stream.align();
            fillBits = stream.readUb(4);
            lineBits = stream.readUb(4);
            tag.recordsMorph = parseShapeRecords(stream, swfVersion, tagCode, isMorph, fillBits, lineBits, canHaveStrokes);
        }
        return tag;
    }
    function parseShapeRecords(stream, swfVersion, tagCode, isMorph, fillBits, lineBits, hasStrokes) {
        var records = [];
        var bits;
        do {
            var record = {};
            var type = record.type = stream.readUb(1);
            var flags = stream.readUb(5);
            if (!(type || flags)) {
                break;
            }
            if (type) {
                var bits = (flags & 0x0f) + 2;
                flags = (flags & 0xf0) << 1;
                if (flags & 32 /* IsStraight */) {
                    var isGeneral = record.isGeneral = stream.readUb(1);
                    if (isGeneral) {
                        flags |= 64 /* IsGeneral */;
                        record.deltaX = stream.readSb(bits);
                        record.deltaY = stream.readSb(bits);
                    }
                    else {
                        var isVertical = record.isVertical = stream.readUb(1);
                        if (isVertical) {
                            flags |= 128 /* IsVertical */;
                            record.deltaY = stream.readSb(bits);
                        }
                        else {
                            record.deltaX = stream.readSb(bits);
                        }
                    }
                }
                else {
                    record.controlDeltaX = stream.readSb(bits);
                    record.controlDeltaY = stream.readSb(bits);
                    record.anchorDeltaX = stream.readSb(bits);
                    record.anchorDeltaY = stream.readSb(bits);
                }
            }
            else {
                if (tagCode <= 2 /* CODE_DEFINE_SHAPE */) {
                    // Clear HasNewStyles flag.
                    flags &= ~16 /* HasNewStyles */;
                }
                if (flags & 1 /* Move */) {
                    bits = stream.readUb(5);
                    record.moveX = stream.readSb(bits);
                    record.moveY = stream.readSb(bits);
                }
                if (flags & 2 /* HasFillStyle0 */) {
                    record.fillStyle0 = stream.readUb(fillBits);
                }
                if (flags & 4 /* HasFillStyle1 */) {
                    record.fillStyle1 = stream.readUb(fillBits);
                }
                if (flags & 8 /* HasLineStyle */) {
                    record.lineStyle = stream.readUb(lineBits);
                }
                if (flags & 16 /* HasNewStyles */) {
                    record.fillStyles = parseFillStyles(stream, swfVersion, tagCode, isMorph);
                    record.lineStyles = parseLineStyles(stream, swfVersion, tagCode, isMorph, hasStrokes);
                    stream.align();
                    fillBits = stream.readUb(4);
                    lineBits = stream.readUb(4);
                }
            }
            record.flags = flags;
            records.push(record);
        } while (true);
        return records;
    }
    function parseFillStyles(stream, swfVersion, tagCode, isMorph) {
        var count = stream.readUi8();
        if (tagCode > 2 /* CODE_DEFINE_SHAPE */ && count === 255) {
            count = stream.readUi16();
        }
        var styles = [];
        var i = count;
        while (i--) {
            styles.push(parseFillStyle(stream, swfVersion, tagCode, isMorph));
        }
        return styles;
    }
    function parseFillStyle(stream, swfVersion, tagCode, isMorph) {
        var style = {};
        var type = style.type = stream.readUi8();
        switch (type) {
            case 0:
                var solid = style;
                solid.color = tagCode > 22 /* CODE_DEFINE_SHAPE2 */ || isMorph ?
                    parseRgba(stream) :
                    parseRgb(stream);
                if (isMorph) {
                    solid.colorMorph = parseRgba(stream);
                }
                return solid;
            case 16:
            case 18:
            case 19:
                var gradient = style;
                gradient.matrix = parseMatrix(stream);
                if (isMorph) {
                    gradient.matrixMorph = parseMatrix(stream);
                }
                //console.log("GradientFill", tagCode);
                if (tagCode === 83 /* CODE_DEFINE_SHAPE4 */) {
                    gradient.spreadMode = stream.readUb(2);
                    gradient.interpolationMode = stream.readUb(2);
                    //console.log("gradient.spreadMode", gradient.spreadMode);
                    //console.log("gradient.interpolationMode", gradient.interpolationMode);
                }
                else {
                    stream.readUb(4);
                }
                var count = stream.readUb(4);
                var records = gradient.records = [];
                var j = count;
                while (j--) {
                    records.push(parseGradientRecord(stream, tagCode, isMorph));
                }
                if (type === 19) {
                    gradient.focalPoint = stream.readSi16();
                    if (isMorph) {
                        gradient.focalPointMorph = stream.readSi16();
                    }
                }
                return gradient;
            case 64:
            case 65:
            case 66:
            case 67:
                var pattern = style;
                pattern.bitmapId = stream.readUi16();
                pattern.condition = type === 64 || type === 67;
                pattern.matrix = parseMatrix(stream);
                if (isMorph) {
                    pattern.matrixMorph = parseMatrix(stream);
                }
                return pattern;
        }
        return style;
    }
    function parseGradientRecord(stream, tagCode, isMorph) {
        var record = {};
        record.ratio = stream.readUi8();
        if (tagCode > 22 /* CODE_DEFINE_SHAPE2 */) {
            record.color = parseRgba(stream);
        }
        else {
            record.color = parseRgb(stream);
        }
        if (isMorph) {
            record.ratioMorph = stream.readUi8();
            record.colorMorph = parseRgba(stream);
        }
        return record;
    }
    function parseLineStyles(stream, swfVersion, tagCode, isMorph, hasStrokes) {
        var count = stream.readUi8();
        if (tagCode > 2 /* CODE_DEFINE_SHAPE */ && count === 255) {
            count = stream.readUi16();
        }
        var styles = [];
        var i = count;
        while (i--) {
            var style = {};
            style.width = stream.readUi16();
            if (isMorph) {
                style.widthMorph = stream.readUi16();
            }
            if (hasStrokes) {
                stream.align();
                style.startCapsStyle = stream.readUb(2);
                var jointStyle = style.jointStyle = stream.readUb(2);
                var hasFill = style.hasFill = stream.readUb(1);
                style.noHscale = !!stream.readUb(1);
                style.noVscale = !!stream.readUb(1);
                // console.log("style.noHscale", style.noHscale, "style.noVscale", style.noVscale);
                style.pixelHinting = !!stream.readUb(1);
                stream.readUb(5);
                style.noClose = !!stream.readUb(1);
                style.endCapsStyle = stream.readUb(2);
                if (jointStyle === 2) {
                    style.miterLimitFactor = stream.readFixed8();
                }
                if (hasFill) {
                    style.fillStyle = parseFillStyle(stream, swfVersion, tagCode, isMorph);
                }
                else {
                    style.color = parseRgba(stream);
                    if (isMorph) {
                        style.colorMorph = parseRgba(stream);
                    }
                }
            }
            else {
                //console.log("No strokes");
                if (tagCode > 22 /* CODE_DEFINE_SHAPE2 */) {
                    style.color = parseRgba(stream);
                }
                else {
                    style.color = parseRgb(stream);
                }
                if (isMorph) {
                    style.colorMorph = parseRgba(stream);
                }
            }
            styles.push(style);
        }
        return styles;
    }
    function parseDefineVideoStreamTag(stream, swfVersion, tagCode) {
        var tag = { code: tagCode };
        tag.id = stream.readUi16();
        tag.numFrames = stream.readUi16();
        tag.width = stream.readUi16();
        tag.height = stream.readUi16();
        stream.readUb(4);
        tag.deblocking = stream.readUb(3);
        tag.smoothing = !!stream.readUb(1);
        tag.codecId = stream.readUi8();
        return tag;
    }
    function parseVideoFrameTag(stream, swfVersion, tagCode, tagEnd) {
        var tag = { code: tagCode };
        tag.streamId = stream.readUi16();
        tag.frameNum = stream.readUi16();
        tag.videoData = stream.bytes.subarray(stream.pos, tagEnd);
        stream.pos = tagEnd;
        return tag;
    }
    var tagHandlers = {
        /* End */ 0: undefined,
        /* ShowFrame */ 1: undefined,
        /* DefineShape */ 2: parseDefineShapeTag,
        /* PlaceObject */ 4: parsePlaceObjectTag,
        /* RemoveObject */ 5: parseRemoveObjectTag,
        /* DefineBits */ 6: parseDefineImageTag,
        /* DefineButton */ 7: parseDefineButtonTag,
        /* JPEGTables */ 8: undefined,
        /* SetBackgroundColor */ 9: undefined,
        /* DefineFont */ 10: parseDefineFontTag,
        /* DefineText */ 11: parseDefineTextTag,
        /* DoAction */ 12: undefined,
        /* DefineFontInfo */ 13: undefined,
        /* DefineSound */ 14: parseDefineSoundTag,
        /* StartSound */ 15: parseStartSoundTag,
        /* DefineButtonSound */ 17: undefined,
        /* SoundStreamHead */ 18: undefined,
        /* SoundStreamBlock */ 19: undefined,
        /* DefineBitsLossless */ 20: parseDefineBitmapTag,
        /* DefineBitsJPEG2 */ 21: parseDefineImageTag,
        /* DefineShape2 */ 22: parseDefineShapeTag,
        /* DefineButtonCxform */ 23: undefined,
        /* Protect */ 24: undefined,
        /* PlaceObject2 */ 26: parsePlaceObjectTag,
        /* RemoveObject2 */ 28: parseRemoveObjectTag,
        /* DefineShape3 */ 32: parseDefineShapeTag,
        /* DefineText2 */ 33: parseDefineTextTag,
        /* DefineButton2 */ 34: parseDefineButtonTag,
        /* DefineBitsJPEG3 */ 35: parseDefineImageTag,
        /* DefineBitsLossless2 */ 36: parseDefineBitmapTag,
        /* DefineEditText */ 37: parseDefineEditTextTag,
        /* DefineSprite */ 39: undefined,
        /* FrameLabel */ 43: undefined,
        /* SoundStreamHead2 */ 45: undefined,
        /* DefineMorphShape */ 46: parseDefineShapeTag,
        /* DefineFont2 */ 48: parseDefineFont2Tag,
        /* ExportAssets */ 56: undefined,
        /* ImportAssets */ 57: undefined,
        /* EnableDebugger */ 58: undefined,
        /* DoInitAction */ 59: undefined,
        /* DefineVideoStream */ 60: parseDefineVideoStreamTag,
        /* VideoFrame */ 61: parseVideoFrameTag,
        /* DefineFontInfo2 */ 62: undefined,
        /* EnableDebugger2 */ 64: undefined,
        /* ScriptLimits */ 65: undefined,
        /* SetTabIndex */ 66: undefined,
        /* FileAttributes */ 69: undefined,
        /* PlaceObject3 */ 70: parsePlaceObjectTag,
        /* ImportAssets2 */ 71: undefined,
        /* DoABC (undoc) */ 72: undefined,
        /* DefineFontAlignZones */ 73: undefined,
        /* CSMTextSettings */ 74: undefined,
        /* DefineFont3 */ 75: parseDefineFont2Tag,
        /* SymbolClass */ 76: undefined,
        /* Metadata */ 77: undefined,
        /* DefineScalingGrid */ 78: parseDefineScalingGridTag,
        /* DoABC */ 82: undefined,
        /* DefineShape4 */ 83: parseDefineShapeTag,
        /* DefineMorphShape2 */ 84: parseDefineShapeTag,
        /* DefineSceneAndFrameLabelData */ 86: parseDefineSceneTag,
        /* DefineBinaryData */ 87: parseDefineBinaryDataTag,
        /* DefineFontName */ 88: undefined,
        /* StartSound2 */ 89: parseStartSoundTag,
        /* DefineBitsJPEG4 */ 90: parseDefineImageTag,
        /* DefineFont4 */ 91: parseDefineFont4Tag
    };
    function parseHeader(stream) {
        var bits = stream.readUb(5);
        var xMin = stream.readSb(bits);
        var xMax = stream.readSb(bits);
        var yMin = stream.readSb(bits);
        var yMax = stream.readSb(bits);
        stream.align();
        var frameRateFraction = stream.readUi8();
        var frameRate = stream.readUi8() + frameRateFraction / 256;
        var frameCount = stream.readUi16();
        return {
            frameRate: frameRate,
            frameCount: frameCount,
            bounds: new Bounds(xMin, yMin, xMax, yMax)
        };
    }

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    /*
     * Applies the current segment1 to the paths of all styles specified in the last
     * style-change record.
     *
     * For fill0, we have to apply commands and their data in reverse order, to turn
     * left fills into right ones.
     *
     * If we have more than one style, we only recorded commands for the first one
     * and have to duplicate them for the other styles. The order is: fill1, line,
     * fill0. (That means we only ever recorded into fill0 if that's the only style.)
     */
    /*

    // 80pro: 	i simplified the code so that it doesnt use this function anymore.
    //			now we directly create needed amount of segments and apply them to the pathes
    function applySegmentToStyles(segment1: PathSegment, styles,
                                  linePaths: SegmentedPath[], fillPaths: SegmentedPath[])
    {
        if (!segment1) {
            return;
        }
        if(styles.fill0 && styles.fill1 && styles.fill0==styles.fill1){
            console.log("		same fill on both sides");
            return;//80pro: ignore segments with same fill on both sides
        }
        var path1: SegmentedPath;
        if (styles.fill0) {
            path1 = fillPaths[styles.fill0 - 1];
            // If fill0 is the only style, we have pushed the segment1 to its stack. In
            // that case, just mark it as reversed and move on.
            if (!(styles.fill1 || styles.line)) {
                segment1.isReversed = true;
                return;
            } else {
                path1.addSegment(segment1.toReversed());
            }
        }
        if (styles.line && styles.fill1) {
            path1 = linePaths[styles.line - 1];
            path1.addSegment(segment1.clone());
        }
    }
    */
    function defineShape(tag, parser) {
        //console.log(fillPaths, linePaths);
        tag.parser = parser;
        //var shape = convertRecordsToShapeData(tag.records, tag.fillStyles, tag.lineStyles, tag.recordsMorph || null, parser);
        var shape = new Graphics();
        //shape.convertRecordsToShapeData(tag);
        shape.queueShapeTag(tag);
        return {
            type: tag.recordsMorph ? 'morphshape' : 'shape',
            id: tag.id,
            fillBounds: tag.fillBounds,
            lineBounds: tag.lineBounds,
            morphFillBounds: tag.fillBoundsMorph || null,
            morphLineBounds: tag.lineBoundsMorph || null,
            shape: tag.recordsMorph ? new MorphSprite(shape) : shape,
            //shape_swf: shape.toPlainObject(),
            //transferables: shape.buffers,
            require: null
        };
    }
    // function writeLineStyle(style: ShapeStyle, shape: ShapeData): void {
    // 	// No scaling == 0, normal == 1, vertical only == 2, horizontal only == 3.
    // 	var scaleMode = style.noHscale ?
    // 		(style.noVscale ? 0 : 2) :
    // 		style.noVscale ? 3 : 1;
    // 	// TODO: Figure out how to handle startCapsStyle
    // 	var thickness = clamp(style.width, 0, 0xff * 20)|0;
    // 	shape.lineStyle(thickness, style.color,
    // 		style.pixelHinting, scaleMode, style.endCapsStyle,
    // 		style.jointStyle, style.miterLimit);
    // }
    // function writeMorphLineStyle(style: ShapeStyle, shape: ShapeData): void {
    // 	// TODO: Figure out how to handle startCapsStyle
    // 	var thickness = clamp(style.width, 0, 0xff * 20)|0;
    // 	shape.writeMorphLineStyle(thickness, style.color);
    // }
    // function writeGradient(command: PathCommand, style: ShapeStyle, shape: ShapeData): void {
    // 	var gradientType = style.type === FillType.LinearGradient ?
    // 		GradientType.Linear :
    // 		GradientType.Radial;
    // 	shape.beginGradient(command, style.colors, style.ratios,
    // 		gradientType, style.transform, style.spreadMethod,
    // 		style.interpolationMode, style.focalPoint / 2 | 0);
    // }
    // function writeMorphGradient(style: ShapeStyle, shape: ShapeData) {
    // 	shape.writeMorphGradient(style.colors, style.ratios, style.transform);
    // }
    // function writeBitmap(command: PathCommand, style: ShapeStyle, shape: ShapeData): void {
    // 	shape.beginBitmap(command, style.bitmapIndex, style.transform, style.repeat, style.smooth);
    // }
    // function writeMorphBitmap(style: ShapeStyle, shape: ShapeData) {
    // 	shape.writeMorphBitmap(style.transform);
    // }

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var pow = Math.pow;
    var logE = Math.log;
    var fromCharCode = String.fromCharCode;
    function maxPower2(num) {
        var maxPower = 0;
        var val = num;
        while (val >= 2) {
            val /= 2;
            ++maxPower;
        }
        return pow(2, maxPower);
    }
    function toString16(val) {
        return fromCharCode((val >> 8) & 0xff, val & 0xff);
    }
    /**
     * Heuristic to detect if DefineFont2 was scaled as Font3: scanning all
     * x and y coordinates of the glyphs and if their bounding box dimensions
     * greater than 5000 (that's more than enough for normal TrueType font),
     * then the font coordinates were scaled by 20.
     */
    function isScaledFont2(glyphs) {
        var xMin = 0, yMin = 0, xMax = 0, yMax = 0;
        for (var i = 0; i < glyphs.length; i++) {
            var records = glyphs[i];
            if (!records) {
                continue;
            }
            var record;
            var x = 0;
            var y = 0;
            for (var j = 0; j < records.length; j++) {
                record = records[j];
                if (record.type) {
                    if (record.flags & 32 /* IsStraight */) {
                        x += (record.deltaX || 0);
                        y += -(record.deltaY || 0);
                    }
                    else {
                        x += record.controlDeltaX;
                        y += -record.controlDeltaY;
                        x += record.anchorDeltaX;
                        y += -record.anchorDeltaY;
                    }
                }
                else {
                    if (record.flags & 1 /* Move */) {
                        x = record.moveX;
                        y = -record.moveY;
                    }
                }
                if (xMin > x) {
                    xMin = x;
                }
                if (yMin > y) {
                    yMin = y;
                }
                if (xMax < x) {
                    xMax = x;
                }
                if (yMax < y) {
                    yMax = y;
                }
            }
        }
        var maxDimension = Math.max(xMax - xMin, yMax - yMin);
        return maxDimension > 5000;
    }
    function defineFont(tag, ns) {
        var uniqueName = 'swf-font-' + tag.id;
        var fontName = tag.name || uniqueName;
        if (fontName == "Helvetica")
            fontName = "arial";
        var fontAJS = DefaultFontManager.getFont(fontName, ns);
        var font = {
            type: 'font',
            id: tag.id,
            name: fontName,
            bold: !!(tag.flags & 1 /* Bold */),
            italic: !!(tag.flags & 2 /* Italic */),
            codes: null,
            metrics: null,
            data: tag.data,
            originalSize: false,
            away: fontAJS,
            fontStyleName: FontStyleName.STANDART
        };
        fontAJS.name = fontName;
        var fontStyleName = FontStyleName.STANDART;
        if (font.bold && !font.italic) {
            fontStyleName = FontStyleName.BOLD;
        }
        else if (!font.bold && font.italic) {
            fontStyleName = FontStyleName.ITALIC;
        }
        else if (font.bold && font.italic) {
            fontStyleName = FontStyleName.BOLDITALIC;
        }
        font.fontStyleName = fontStyleName;
        var tessFontTableAJS = fontAJS.get_font_table(fontStyleName, TesselatedFontTable.assetType);
        //var tessFontTableAJS:TesselatedFontTable=new TesselatedFontTable();
        //fontAJS.font_styles.push(tessFontTableAJS);
        //console.log("parsed font = ", fontName, fontStyleName);
        var glyphs = tag.glyphs;
        var glyphCount = glyphs ? glyphs.length : 0;
        if (!glyphCount) {
            return font;
        }
        var codes = [];
        var glyphIndex = {};
        var ranges = [];
        var originalCode;
        var generateAdvancement = !('advance' in tag);
        var isFont2 = tag.code === 48 /* CODE_DEFINE_FONT2 */;
        var isFont3 = tag.code === 75 /* CODE_DEFINE_FONT3 */;
        if (generateAdvancement) {
            tag.advance = [];
        }
        var maxCode = Math.max.apply(null, tag.codes) || 35;
        if (tag.codes) {
            for (var i = 0; i < tag.codes.length; i++) {
                var code = tag.codes[i];
                //console.log(code);
                if (code < 32 || code in glyphIndex) {
                    maxCode++;
                    if (maxCode == 8232) {
                        maxCode = 8240;
                    }
                    code = maxCode;
                }
                codes.push(code);
                glyphIndex[code] = i;
            }
            originalCode = codes.concat();
            codes.sort(function (a, b) {
                return a - b;
            });
            var i = 0;
            var code;
            var indices;
            while ((code = codes[i++]) !== undefined) {
                var start = code;
                var end = start;
                indices = [i - 1];
                while (((code = codes[i]) !== undefined) && end + 1 === code) {
                    ++end;
                    indices.push(i);
                    ++i;
                }
                ranges.push([start, end, indices]);
            }
        }
        else {
            indices = [];
            var UAC_OFFSET = 0xe000;
            for (var i = 0; i < glyphCount; i++) {
                code = UAC_OFFSET + i;
                //console.log(code);
                codes.push(code);
                glyphIndex[code] = i;
                indices.push(i);
            }
            ranges.push([UAC_OFFSET, UAC_OFFSET + glyphCount - 1, indices]);
            originalCode = codes.concat();
        }
        var resolution = tag.resolution || 1;
        if (isFont2 && isScaledFont2(glyphs)) {
            // some DefineFont2 without layout using DefineFont3 resolution, why?
            resolution = 20;
            font.originalSize = true;
        }
        var ascent = Math.ceil(tag.ascent / resolution) || 1024;
        var descent = -Math.ceil(tag.descent / resolution) || 0;
        if (tessFontTableAJS.ascent != 0) {
        }
        else {
            tessFontTableAJS.ascent = ascent;
            tessFontTableAJS.descent = descent;
        }
        var offsetY = tessFontTableAJS.ascent;
        var leading = (tag.leading / resolution) || 0;
        var i = 0;
        var range;
        while ((range = ranges[i++])) {
            var start = range[0];
            var end = range[1];
            var code = range[2][0];
        }
        var segCount = ranges.length + 1;
        var searchRange = maxPower2(segCount) * 2;
        var yMins = [];
        var i = 0;
        var code;
        var rawData = {};
        while ((code = codes[i++]) !== undefined) {
            var records = glyphs[glyphIndex[code]];
            var x = 0;
            var y = 0;
            var segments = [];
            var segmentIndex = -1;
            for (var j = 0; j < records.length; j++) {
                record = records[j];
                if (record.type) {
                    if (segmentIndex < 0) {
                        segmentIndex = 0;
                        segments[segmentIndex] = { data: [], commands: [], xMin: 0, xMax: 0, yMin: 0, yMax: 0 };
                    }
                    if (record.flags & 32 /* IsStraight */) {
                        segments[segmentIndex].commands.push(2);
                        var dx = (record.deltaX || 0) / resolution;
                        var dy = -(record.deltaY || 0) / resolution;
                        x += dx;
                        y += dy;
                        segments[segmentIndex].data.push(x, y);
                    }
                    else {
                        segments[segmentIndex].commands.push(3);
                        var cx = record.controlDeltaX / resolution;
                        var cy = -record.controlDeltaY / resolution;
                        x += cx;
                        y += cy;
                        segments[segmentIndex].data.push(x, y);
                        var dx = record.anchorDeltaX / resolution;
                        var dy = -record.anchorDeltaY / resolution;
                        x += dx;
                        y += dy;
                        segments[segmentIndex].data.push(x, y);
                    }
                }
                else {
                    if (record.flags & 1 /* Move */) {
                        segmentIndex++;
                        segments[segmentIndex] = { data: [], commands: [], xMin: 0, xMax: 0, yMin: 0, yMax: 0 };
                        segments[segmentIndex].commands.push(1);
                        var moveX = record.moveX / resolution;
                        var moveY = -record.moveY / resolution;
                        var dx = moveX - x;
                        var dy = moveY - y;
                        x = moveX;
                        y = moveY;
                        segments[segmentIndex].data.push(x, y);
                    }
                }
                if (segmentIndex > -1) {
                    if (segments[segmentIndex].xMin > x) {
                        segments[segmentIndex].xMin = x;
                    }
                    if (segments[segmentIndex].yMin > y) {
                        segments[segmentIndex].yMin = y;
                    }
                    if (segments[segmentIndex].xMax < x) {
                        segments[segmentIndex].xMax = x;
                    }
                    if (segments[segmentIndex].yMax < y) {
                        segments[segmentIndex].yMax = y;
                    }
                }
            }
            if (!isFont3) {
                segments.sort(function (a, b) {
                    return (b.xMax - b.xMin) * (b.yMax - b.yMin) - (a.xMax - a.xMin) * (a.yMax - a.yMin);
                });
            }
            rawData[code] = segments;
        }
        var whiteSpaceWidth = 0;
        i = 0;
        while ((code = codes[i++]) !== undefined) {
            var glyphPath = new GraphicsPath();
            var records = glyphs[glyphIndex[code]];
            var idx = glyphIndex[code];
            segments = rawData[code];
            var x = 0;
            var y = 0;
            var xMin = 0;
            var xMax = -1024;
            var yMin = 0;
            var yMax = -1024;
            var segmentIndex = -1;
            var data = [];
            var commands = [];
            for (j = 0; j < segments.length; j++) {
                data = data.concat(segments[j].data);
                commands = commands.concat(segments[j].commands);
            }
            x = 0;
            y = 0;
            var nx = 0;
            var ny = 0;
            var dataIndex = 0;
            for (j = 0; j < commands.length; j++) {
                var command = commands[j];
                if (command === 1) {
                    nx = data[dataIndex++];
                    ny = data[dataIndex++];
                    var dx = nx - x;
                    var dy = ny - y;
                    glyphPath.moveTo(nx, -1 * ny + offsetY);
                    x = nx;
                    y = ny;
                }
                else if (command === 2) {
                    nx = data[dataIndex++];
                    ny = data[dataIndex++];
                    var dx = nx - x;
                    var dy = ny - y;
                    x = nx;
                    y = ny;
                    glyphPath.lineTo(nx, -1 * ny + offsetY);
                }
                else if (command === 3) {
                    nx = data[dataIndex++];
                    ny = data[dataIndex++];
                    var cx = nx - x;
                    var cy = ny - y;
                    x = nx;
                    y = ny;
                    var cx = nx;
                    var cy = ny;
                    nx = data[dataIndex++];
                    ny = data[dataIndex++];
                    var dx = nx - x;
                    var dy = ny - y;
                    x = nx;
                    y = ny;
                    glyphPath.curveTo(cx, -1 * cy + offsetY, nx, -1 * ny + offsetY);
                }
                if (xMin > x) {
                    xMin = x;
                }
                if (yMin > y) {
                    yMin = y;
                }
                if (xMax < x) {
                    xMax = x;
                }
                if (yMax < y) {
                    yMax = y;
                }
            }
            if (!j) {
                xMin = xMax = yMin = yMax = 0;
            }
            yMins.push(yMin);
            var glyphAdvance = 0;
            if (generateAdvancement) {
                tag.advance.push((xMax - xMin) * resolution * 1.3);
                glyphAdvance = (xMax - xMin);
            }
            else {
                glyphAdvance = tag.advance[i - 1] / resolution;
            }
            if (code == 32) {
                //console.log("32 = ", code, (xMax - xMin));
                //console.log("32 = ", tag.advance[i-1]);
                whiteSpaceWidth = tag.advance[i - 1] / resolution;
            }
            tessFontTableAJS.setChar(code.toString(), glyphAdvance, null, null, false, idx, glyphPath, tag.fileURL);
            /*	var vertexBuffer=GraphicsFactoryFills.pathToAttributesBuffer(glyphPath, true);
                if(vertexBuffer){
                    //console.log("created glyph for ", String.fromCharCode(code))
                }
                else{
                    //console.log("failed to create glyph for ", String.fromCharCode(code))
                }*/
        }
        //console.log("min-max x:", minx, maxx, "min-max y:", miny, maxy);
        //console.log("FontTag.advanced = ", tag.advance.toString());
        //loca += toString16(offset / 2);
        //tables['glyf'] = glyf;
        if (!isFont3) {
            var minYmin = Math.min.apply(null, yMins);
            if (minYmin < 0) {
                descent = descent || minYmin;
            }
        }
        /*
        tables['OS/2'] =
            '\x00\x01' + // version
            '\x00\x00' + // xAvgCharWidth
            toString16(font.bold ? 700 : 400) + // usWeightClass
            '\x00\x05' + // usWidthClass
            '\x00\x00' + // fstype
            '\x00\x00' + // ySubscriptXSize
            '\x00\x00' + // ySubscriptYSize
            '\x00\x00' + // ySubscriptXOffset
            '\x00\x00' + // ySubscriptYOffset
            '\x00\x00' + // ySuperScriptXSize
            '\x00\x00' + // ySuperScriptYSize
            '\x00\x00' + // ySuperScriptXOffset
            '\x00\x00' + // ySuperScriptYOffset
            '\x00\x00' + // yStrikeoutSize
            '\x00\x00' + // yStrikeoutPosition
            '\x00\x00' + // sFamilyClass
            '\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00' + // panose
            '\x00\x00\x00\x00' + // ulUnicodeRange1
            '\x00\x00\x00\x00' + // ulUnicodeRange2
            '\x00\x00\x00\x00' + // ulUnicodeRange3
            '\x00\x00\x00\x00' + // ulUnicodeRange4
            'ALF ' + // achVendID
            toString16((font.italic ? 0x01 : 0) | (font.bold ? 0x20 : 0)) + // fsSelection
            toString16(codes[0]) + // usFirstCharIndex
            toString16(codes[codes.length - 1]) + // usLastCharIndex
            toString16(ascent) + // sTypoAscender
            toString16(descent) + // sTypoDescender
            toString16(leading) + // sTypoLineGap
            toString16(ascent) + // usWinAscent
            toString16(-descent) + // usWinDescent
            '\x00\x00\x00\x00' + // ulCodePageRange1
            '\x00\x00\x00\x00' // ulCodePageRange2
        ;

        tables['head'] =
            '\x00\x01\x00\x00' + // version
            '\x00\x01\x00\x00' + // fontRevision
            '\x00\x00\x00\x00' + // checkSumAdjustement
            '\x5f\x0f\x3c\xf5' + // magicNumber
            '\x00\x0b' + // flags
            '\x04\x00' + // unitsPerEm
            '\x00\x00\x00\x00' + toString32(Date.now()) + // created
            '\x00\x00\x00\x00' + toString32(Date.now()) + // modified
            toString16(min.apply(null, xMins)) + // xMin
            toString16(min.apply(null, yMins)) + // yMin
            toString16(max.apply(null, xMaxs)) + // xMax
            toString16(max.apply(null, yMaxs)) + // yMax
            toString16((font.italic ? 2 : 0) | (font.bold ? 1 : 0)) + // macStyle
            '\x00\x08' + // lowestRecPPEM
            '\x00\x02' + // fontDirectionHint
            '\x00\x00' + // indexToLocFormat
            '\x00\x00' // glyphDataFormat
        ;

        var advance = tag.advance;
        tables['hhea'] =
            '\x00\x01\x00\x00' + // version
            toString16(ascent) + // ascender
            toString16(descent) + // descender
            toString16(leading) + // lineGap
            toString16(advance ? max.apply(null, advance) : 1024) + // advanceWidthMax
            '\x00\x00' + // minLeftSidebearing
            '\x00\x00' + // minRightSidebearing
            '\x03\xb8' + // xMaxExtent
            '\x00\x01' + // caretSlopeRise
            '\x00\x00' + // caretSlopeRun
            '\x00\x00' + // caretOffset
            '\x00\x00' + // reserved
            '\x00\x00' + // reserved
            '\x00\x00' + // reserved
            '\x00\x00' + // reserved
            '\x00\x00' + // metricDataFormat
            toString16(glyphCount + 1) // numberOfHMetrics
        ;

        var hmtx = '\x00\x00\x00\x00';
        for (var i = 0; i < glyphCount; ++i) {
            hmtx += toString16(advance ? (advance[i] / resolution) : 1024) + '\x00\x00';
        }
        tables['hmtx'] = hmtx;
        */
        if (tag.kerning && tag.kerning.length) {
            var kerning = tag.kerning;
            var nPairs = kerning.length;
            var searchRange = maxPower2(nPairs) * 2;
            var kern = '\x00\x00' + // version
                '\x00\x01' + // nTables
                '\x00\x00' + // subtable version
                toString16(14 + (nPairs * 6)) + // length
                '\x00\x01' + // coverage
                toString16(nPairs) +
                toString16(searchRange) +
                toString16(logE(nPairs) / logE(2)) + // entrySelector
                toString16((2 * nPairs) - searchRange) // rangeShift
            ;
            var i = 0;
            var record;
            while ((record = kerning[i++])) {
                kern +=
                    toString16(glyphIndex[record.code1]) + // left
                        toString16(glyphIndex[record.code2]) + // right
                        toString16(record.adjustment) // value
                ;
            }
            //tables['kern'] = kern;
        }
        /*
            tables['loca'] = loca;

            tables['maxp'] =
                '\x00\x01\x00\x00' + // version
                toString16(glyphCount + 1) + // numGlyphs
                toString16(maxPoints) +
                toString16(maxContours) +
                '\x00\x00' + // maxCompositePoints
                '\x00\x00' + // maxCompositeContours
                '\x00\x01' + // maxZones
                '\x00\x00' + // maxTwilightPoints
                '\x00\x00' + // maxStorage
                '\x00\x00' + // maxFunctionDefs
                '\x00\x00' + // maxInstructionDefs
                '\x00\x00' + // maxStackElements
                '\x00\x00' + // maxSizeOfInstructions
                '\x00\x00' + // maxComponentElements
                '\x00\x00' // maxComponentDepth
            ;

            var psName = fontName.replace(/ /g, '');
            var strings = [
                tag.copyright || 'Original licence', // 0. Copyright
                fontName, // 1. Font family
                'Unknown', // 2. Font subfamily
                uniqueName, // 3. Unique ID
                fontName, // 4. Full font name
                '1.0', // 5. Version
                psName, // 6. Postscript name
                'Unknown', // 7. Trademark
                'Unknown', // 8. Manufacturer
                'Unknown' // 9. Designer
            ];
            var count = strings.length;
            var name =
                '\x00\x00' + // format
                toString16(count) + // count
                toString16((count * 12) + 6); // stringOffset
            var offset = 0;
            var i = 0;
            var str;
            while ((str = strings[i++])) {
                name +=
                    '\x00\x01' + // platformID
                    '\x00\x00' + // encodingID
                    '\x00\x00' + // languageID
                    toString16(i - 1) + // nameID
                    toString16(str.length) +
                    toString16(offset);
                offset += str.length;
            }
            tables['name'] = name + strings.join('');

            tables['post'] =
                '\x00\x03\x00\x00' + // version
                '\x00\x00\x00\x00' + // italicAngle
                '\x00\x00' + // underlinePosition
                '\x00\x00' + // underlineThickness
                '\x00\x00\x00\x00' + // isFixedPitch
                '\x00\x00\x00\x00' + // minMemType42
                '\x00\x00\x00\x00' + // maxMemType42
                '\x00\x00\x00\x00' + // minMemType1
                '\x00\x00\x00\x00' // maxMemType1
            ;
            var names = Object.keys(tables);
            var numTables = names.length;
            var header =
                '\x00\x01\x00\x00' + // version
                toString16(numTables) +
                '\x00\x80' + // searchRange
                '\x00\x03' + // entrySelector
                '\x00\x20' // rangeShift
            ;
            var dataString = '';
            var offset = (numTables * 16) + header.length;
            var i = 0;
            while ((name = names[i++])) {
                var table = tables[name];
                var length = table.length;
                header +=
                    name +
                    '\x00\x00\x00\x00' + // checkSum
                    toString32(offset) +
                    toString32(length)
                ;
                while (length & 3) {
                    table += '\x00';
                    ++length;
                }
                dataString += table;
                while (offset & 3) {
                    ++offset;
                }
                offset += length;
            }
            */
        /*var otf = header + dataString;
        var unitPerEm = 1024;
        var metrics = {
            ascent: ascent / unitPerEm,
            descent: -descent / unitPerEm,
            leading: leading / unitPerEm
        };*/
        // TODO: use a buffer to generate font data
        /*var dataBuffer = new Uint8Array(otf.length);
        for (var i = 0; i < otf.length; i++) {
            dataBuffer[i] = otf.charCodeAt(i) & 0xff;
        }*/
        //font.codes = originalCode;
        //font.metrics = metrics;
        //font.data = dataBuffer;
        tessFontTableAJS.set_font_em_size(1024);
        if (tessFontTableAJS.get_whitespace_width() == 0)
            tessFontTableAJS.set_whitespace_width(whiteSpaceWidth);
        return font;
    }

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function defineText(tag) {
        var bold = false;
        var italic = false;
        return {
            type: 'text',
            id: tag.id,
            fillBounds: tag.bbox,
            variableName: tag.variableName,
            tag: tag,
            bold: bold,
            italic: italic
        };
    }

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function defineButton(tag, dictionary) {
        var characters = tag.characters;
        var states = {
            up: [],
            over: [],
            down: [],
            hitTest: []
        };
        var i = 0, character;
        while ((character = characters[i++])) {
            var characterItem = dictionary[character.symbolId];
            // The Flash Player ignores references to undefined symbols here. So should we.
            // TODO: What should happen if the symbol gets defined later in the file?
            if (characterItem) {
                var cmd = {
                    symbolId: characterItem.id,
                    code: 4 /* CODE_PLACE_OBJECT */,
                    depth: character.depth,
                    flags: 0,
                    matrix: null,
                    cxform: null
                };
                if (character.matrix) {
                    cmd.flags |= 4 /* HasMatrix */;
                    cmd.matrix = character.matrix;
                }
                if (character.cxform) {
                    cmd.flags |= 8 /* HasColorTransform */;
                    cmd.cxform = character.cxform;
                }
                if (character.flags & 1 /* StateUp */)
                    states.up.push(cmd);
                if (character.flags & 2 /* StateOver */)
                    states.over.push(cmd);
                if (character.flags & 4 /* StateDown */)
                    states.down.push(cmd);
                if (character.flags & 8 /* StateHitTest */)
                    states.hitTest.push(cmd);
            }
            else {
                console.log('undefined character in button ' + tag.id);
            }
        }
        var button = {
            type: 'button',
            id: tag.id,
            buttonActions: tag.buttonActions,
            states: states
        };
        return button;
    }

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    /*
     * Returns a Uint8ClampedArray of RGBA values. The source image is color mapped meaning
     * that the buffer is first prefixed with a color table:
     *
     * +--------------|--------------------------------------------------+
     * | Color Table  |  Image Data (byte indices into the color table)  |
     * +--------------|--------------------------------------------------+
     *
     * Color Table entries are either in RGB or RGBA format.
     *
     * There are two variations of these file formats, with or without alpha.
     *
     * Row pixels always start at 32 bit alinged offsets, the color table as
     * well as the end of each row may be padded so that the next row of pixels
     * is aligned.
     */
    function parseColorMapped(tag) {
        var width = tag.width, height = tag.height;
        var hasAlpha = tag.hasAlpha;
        var padding = roundToMultipleOfFour(width) - width;
        var colorTableLength = tag.colorTableSize + 1;
        var colorTableEntrySize = hasAlpha ? 4 : 3;
        var colorTableSize = roundToMultipleOfFour(colorTableLength * colorTableEntrySize);
        var outputDataSize = colorTableEntrySize * ((width + padding) * height);
        var bytes = Inflate.inflate(tag.bmpData, outputDataSize, true);
        var view = new Uint8ClampedArray(width * height * 4);
        var p = colorTableSize, i = 0, offset = 0;
        if (hasAlpha) {
            for (var y = 0; y < height; y++) {
                for (var x = 0; x < width; x++) {
                    offset = bytes[p++] << 2;
                    view[i++] = bytes[offset + 0]; // R
                    view[i++] = bytes[offset + 1]; // G
                    view[i++] = bytes[offset + 2]; // B
                    view[i++] = bytes[offset + 3]; // A
                }
                p += padding;
            }
        }
        else {
            for (var y = 0; y < height; y++) {
                for (var x = 0; x < width; x++) {
                    offset = bytes[p++] * colorTableEntrySize;
                    view[i++] = bytes[offset + 0]; // R
                    view[i++] = bytes[offset + 1]; // G
                    view[i++] = bytes[offset + 2]; // B
                    view[i++] = 0xff; // A
                }
                p += padding;
            }
        }
        return view;
    }
    /**
     * Returns a Uint8ClampedArray of RGBA values.
     */
    function parse24BPP(tag) {
        var width = tag.width, height = tag.height;
        var hasAlpha = tag.hasAlpha;
        // Even without alpha, 24BPP is stored as 4 bytes, probably for alignment reasons.
        var dataSize = height * width * 4;
        var bytes = Inflate.inflate(tag.bmpData, dataSize, true);
        //bytes are in ARGB format, so we need to convert to RGBA
        var view = new Uint8ClampedArray(dataSize);
        var p = 0;
        for (var i = 0; i < dataSize; i += 4) {
            view[p++] = bytes[i + 1]; // R
            view[p++] = bytes[i + 2]; // G
            view[p++] = bytes[i + 3]; // B
            view[p++] = bytes[i]; // A
        }
        assert(p === dataSize, "We should be at the end of the data buffer now.");
        return view;
    }
    function parse15BPP(tag) {
        console.log("parse15BPP");
        //notImplemented("parse15BPP");
        /*
         case FORMAT_15BPP:
         var colorType = 0x02;
         var bytesPerLine = ((width * 2) + 3) & ~3;
         var stream = createInflatedStream(bmpData, bytesPerLine * height);
      
         for (var y = 0, i = 0; y < height; ++y) {
         stream.ensure(bytesPerLine);
         for (var x = 0; x < width; ++x, i += 4) {
         var word = stream.readUi16();
         // Extracting RGB color components and changing values range
         // from 0..31 to 0..255.
         data[i] = 0 | (FACTOR_5BBP * ((word >> 10) & 0x1f));
         data[i + 1] = 0 | (FACTOR_5BBP * ((word >> 5) & 0x1f));
         data[i + 2] = 0 | (FACTOR_5BBP * (word & 0x1f));
         data[i + 3] = 255;
         }
         stream += bytesPerLine;
         }
         break;
         */
        return null;
    }
    function defineBitmap(tag) {
        // enterTimeline("defineBitmap");
        var data;
        var type = ImageType.None;
        switch (tag.format) {
            case 3 /* FORMAT_COLORMAPPED */:
                data = parseColorMapped(tag);
                type = ImageType.PremultipliedAlphaARGB;
                break;
            case 5 /* FORMAT_24BPP */:
                data = parse24BPP(tag);
                type = ImageType.PremultipliedAlphaARGB;
                break;
            case 4 /* FORMAT_15BPP */:
                data = parse15BPP(tag);
                type = ImageType.PremultipliedAlphaARGB;
                break;
            default:
                console.log('invalid bitmap format');
        }
        //leaveTimeline();
        return {
            definition: {
                type: 'image',
                id: tag.id,
                width: tag.width,
                height: tag.height,
                mimeType: 'application/octet-stream',
                data: data,
                dataType: type,
                image: null
            },
            type: 'image'
        };
    }

    /*
     * Copyright 2013 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    /**
     * Reads the next two bytes at the specified position.
     */
    function readUint16(bytes, position) {
        return (bytes[position] << 8) | bytes[position + 1];
    }
    /**
     * Reads the next four bytes at the specified position.
     */
    function readInt32(bytes, position) {
        return (bytes[position] << 24) | (bytes[position + 1] << 16) |
            (bytes[position + 2] << 8) | bytes[position + 3];
    }
    /**
     * Parses JPEG chunks and reads image width and height information. JPEG data
     * in SWFs is encoded in chunks and not directly decodable by the JPEG parser.
     */
    function parseJpegChunks(bytes, chunks) {
        var i = 0;
        var n = bytes.length;
        // Finding first marker, and skipping the data before this marker.
        // (FF 00 - code is escaped FF; FF FF ... (FF xx) - fill bytes before marker).
        while (i < n && (bytes[i] !== 0xff ||
            (i + 1 < n && (bytes[i + 1] === 0x00 || bytes[i + 1] === 0xff)))) {
            ++i;
        }
        if (i >= n) {
            return; // no valid data was found
        }
        do {
            //release || Debug.assert(bytes[i] === 0xff);
            var begin = i++;
            var code = bytes[i++];
            // Some tags have length field -- using it
            if ((code >= 0xc0 && code <= 0xc7) || (code >= 0xc9 && code <= 0xcf) ||
                (code >= 0xda && code <= 0xef) || code === 0xfe) {
                var length = readUint16(bytes, i);
                i += length;
            }
            // Finding next marker.
            while (i < n && (bytes[i] !== 0xff ||
                (i + 1 < n && (bytes[i + 1] === 0x00 || bytes[i + 1] === 0xff)))) {
                ++i;
            }
            if (code === 0xd8 || code === 0xd9) {
                // Removing SOI and EOI to avoid wrong EOI-SOI pairs in the middle.
                continue;
            }
            chunks.push(bytes.subarray(begin, i));
        } while (i < n);
    }
    /**
     * Extracts PNG width and height information.
     */
    function parsePngHeaders(image, bytes) {
        var ihdrOffset = 12;
        if (bytes[ihdrOffset] !== 0x49 || bytes[ihdrOffset + 1] !== 0x48 ||
            bytes[ihdrOffset + 2] !== 0x44 || bytes[ihdrOffset + 3] !== 0x52) {
            return;
        }
        image.width = readInt32(bytes, ihdrOffset + 4);
        image.height = readInt32(bytes, ihdrOffset + 8);
        var type = bytes[ihdrOffset + 14];
        image.hasAlpha = type === 4 || type === 6;
    }
    /**
     * Joins all the chunks in a larger byte array.
     */
    function joinChunks(chunks) {
        var length = 0;
        for (var i = 0; i < chunks.length; i++) {
            length += chunks[i].length;
        }
        var bytes = new Uint8Array(length);
        var offset = 0;
        for (var i = 0; i < chunks.length; i++) {
            var chunk = chunks[i];
            bytes.set(chunk, offset);
            offset += chunk.length;
        }
        return bytes;
    }
    function injectJPEGTables(chunks, state) {
        if (!state.parsedChunks) {
            var parsedChunks = [];
            parseJpegChunks(state.data, parsedChunks);
            state.parsedChunks = parsedChunks;
        }
        // Finding first SOF and inserting tables there
        var i = 0;
        while (i < chunks.length &&
            !(chunks[i][1] >= 0xc0 && chunks[i][1] <= 0xc0)) {
            i++;
        }
        Array.prototype.splice.apply(chunks, Array.prototype.concat.call([i, 0], state.parsedChunks));
    }
    var JPEG_SOI = new Uint8Array([0xff, 0xd8]);
    var JPEG_EOI = new Uint8Array([0xff, 0xd9]);
    function defineImage(tag) {
        //enterTimeline("defineImage");
        var image = {
            type: 'image',
            id: tag.id,
            mimeType: tag.mimeType
        };
        var imgData = tag.imgData;
        if (tag.mimeType === 'image/jpeg') {
            // Parsing/repairing the SWF JPEG data.
            var chunks = [];
            chunks.push(JPEG_SOI);
            parseJpegChunks(imgData, chunks);
            if (tag.jpegTables) {
                injectJPEGTables(chunks, tag.jpegTables);
            }
            chunks.push(JPEG_EOI);
            // Finding SOF to extract image size.
            chunks.forEach(function (chunk) {
                var code = chunk[1];
                if (code >= 0xc0 && code <= 0xc3) {
                    image.height = readUint16(chunk, 5);
                    image.width = readUint16(chunk, 7);
                }
            });
            image.data = joinChunks(chunks);
            image.dataType = ImageType.JPEG;
            var alphaData = tag.alphaData;
            if (alphaData) {
                var length = image.width * image.height;
                try {
                    image.alphaData = Inflate.inflate(alphaData, length, true);
                }
                catch (e) {
                    // Alpha layer is invalid, so hiding everything.
                    image.alphaData = new Uint8Array(length);
                }
            }
        }
        else {
            parsePngHeaders(image, imgData);
            image.data = imgData;
            image.dataType = ImageType.PNG;
        }
        //leaveTimeline();
        return image;
    }

    function defineLabel(tag) {
        var label = {
            type: 'label',
            id: tag.id,
            fillBounds: tag.bbox,
            matrix: tag.matrix,
            tag: {
                hasText: true,
                initialText: '',
                html: true,
                readonly: true
            },
            records: tag.records,
            coords: null,
            static: true,
            require: null
        };
        return label;
    }

    var SWFFrame = /** @class */ (function () {
        function SWFFrame(controlTags, labelNames, soundStreamHead, soundStreamBlock, actionBlocks, initActionBlocks, exports) {
            controlTags && Object.freeze(controlTags);
            this.controlTags = controlTags;
            this.labelNames = labelNames;
            actionBlocks && Object.freeze(actionBlocks);
            this.soundStreamHead = soundStreamHead;
            this.soundStreamBlock = soundStreamBlock;
            this.actionBlocks = actionBlocks;
            initActionBlocks && Object.freeze(initActionBlocks);
            this.initActionBlocks = initActionBlocks;
            this.buttonStateName = "";
            exports && Object.freeze(exports);
            this.exports = exports;
        }
        return SWFFrame;
    }());

    var CompressionMethod;
    (function (CompressionMethod) {
        CompressionMethod[CompressionMethod["None"] = 0] = "None";
        CompressionMethod[CompressionMethod["Deflate"] = 1] = "Deflate";
        CompressionMethod[CompressionMethod["LZMA"] = 2] = "LZMA";
    })(CompressionMethod || (CompressionMethod = {}));

    var SWFFile = /** @class */ (function () {
        function SWFFile() {
            this.compression = CompressionMethod.None;
            this.swfVersion = 0;
            this.useAVM1 = true;
            this.backgroundColor = 0xffffffff;
            this.bounds = null;
            this.frameRate = 0;
            this.frameCount = 0;
            this.attributes = null;
            this.sceneAndFrameLabelData = null;
            this.bytesLoaded = 0;
            this.bytesTotal = length;
            this.pendingUpdateDelays = 0;
            this.framesLoaded = 0;
        }
        return SWFFile;
    }());

    var SwfTagCodeNames = ["CODE_END", "CODE_SHOW_FRAME", "CODE_DEFINE_SHAPE", "CODE_FREE_CHARACTER", "CODE_PLACE_OBJECT", "CODE_REMOVE_OBJECT", "CODE_DEFINE_BITS", "CODE_DEFINE_BUTTON", "CODE_JPEG_TABLES", "CODE_SET_BACKGROUND_COLOR", "CODE_DEFINE_FONT", "CODE_DEFINE_TEXT", "CODE_DO_ACTION", "CODE_DEFINE_FONT_INFO", "CODE_DEFINE_SOUND", "CODE_START_SOUND", "CODE_STOP_SOUND", "CODE_DEFINE_BUTTON_SOUND", "CODE_SOUND_STREAM_HEAD", "CODE_SOUND_STREAM_BLOCK", "CODE_DEFINE_BITS_LOSSLESS", "CODE_DEFINE_BITS_JPEG2", "CODE_DEFINE_SHAPE2", "CODE_DEFINE_BUTTON_CXFORM", "CODE_PROTECT", "CODE_PATHS_ARE_POSTSCRIPT", "CODE_PLACE_OBJECT2", "INVALID", "CODE_REMOVE_OBJECT2", "CODE_SYNC_FRAME", "INVALID", "CODE_FREE_ALL", "CODE_DEFINE_SHAPE3", "CODE_DEFINE_TEXT2", "CODE_DEFINE_BUTTON2", "CODE_DEFINE_BITS_JPEG3", "CODE_DEFINE_BITS_LOSSLESS2", "CODE_DEFINE_EDIT_TEXT", "CODE_DEFINE_VIDEO", "CODE_DEFINE_SPRITE", "CODE_NAME_CHARACTER", "CODE_PRODUCT_INFO", "CODE_DEFINE_TEXT_FORMAT", "CODE_FRAME_LABEL", "CODE_DEFINE_BEHAVIOUR", "CODE_SOUND_STREAM_HEAD2", "CODE_DEFINE_MORPH_SHAPE", "CODE_GENERATE_FRAME", "CODE_DEFINE_FONT2", "CODE_GEN_COMMAND", "CODE_DEFINE_COMMAND_OBJECT", "CODE_CHARACTER_SET", "CODE_EXTERNAL_FONT", "CODE_DEFINE_FUNCTION", "CODE_PLACE_FUNCTION", "CODE_GEN_TAG_OBJECTS", "CODE_EXPORT_ASSETS", "CODE_IMPORT_ASSETS", "CODE_ENABLE_DEBUGGER", "CODE_DO_INIT_ACTION", "CODE_DEFINE_VIDEO_STREAM", "CODE_VIDEO_FRAME", "CODE_DEFINE_FONT_INFO2", "CODE_DEBUG_ID", "CODE_ENABLE_DEBUGGER2", "CODE_SCRIPT_LIMITS", "CODE_SET_TAB_INDEX", "CODE_DEFINE_SHAPE4", "INVALID", "CODE_FILE_ATTRIBUTES", "CODE_PLACE_OBJECT3", "CODE_IMPORT_ASSETS2", "CODE_DO_ABC_DEFINE", "CODE_DEFINE_FONT_ALIGN_ZONES", "CODE_CSM_TEXT_SETTINGS", "CODE_DEFINE_FONT3", "CODE_SYMBOL_CLASS", "CODE_METADATA", "CODE_DEFINE_SCALING_GRID", "INVALID", "INVALID", "INVALID", "CODE_DO_ABC", "CODE_DEFINE_SHAPE4", "CODE_DEFINE_MORPH_SHAPE2", "INVALID", "CODE_DEFINE_SCENE_AND_FRAME_LABEL_DATA", "CODE_DEFINE_BINARY_DATA", "CODE_DEFINE_FONT_NAME", "CODE_START_SOUND2", "CODE_DEFINE_BITS_JPEG4", "CODE_DEFINE_FONT4", "CODE_TELEMETRY"];
    function getSwfTagCodeName(tagCode) {
        return SwfTagCodeNames[tagCode];
    }
    var DefinitionTags;
    (function (DefinitionTags) {
        DefinitionTags[DefinitionTags["CODE_DEFINE_SHAPE"] = 2] = "CODE_DEFINE_SHAPE";
        DefinitionTags[DefinitionTags["CODE_DEFINE_BITS"] = 6] = "CODE_DEFINE_BITS";
        DefinitionTags[DefinitionTags["CODE_DEFINE_BUTTON"] = 7] = "CODE_DEFINE_BUTTON";
        DefinitionTags[DefinitionTags["CODE_DEFINE_FONT"] = 10] = "CODE_DEFINE_FONT";
        DefinitionTags[DefinitionTags["CODE_DEFINE_TEXT"] = 11] = "CODE_DEFINE_TEXT";
        DefinitionTags[DefinitionTags["CODE_DEFINE_SOUND"] = 14] = "CODE_DEFINE_SOUND";
        DefinitionTags[DefinitionTags["CODE_DEFINE_BITS_LOSSLESS"] = 20] = "CODE_DEFINE_BITS_LOSSLESS";
        DefinitionTags[DefinitionTags["CODE_DEFINE_BITS_JPEG2"] = 21] = "CODE_DEFINE_BITS_JPEG2";
        DefinitionTags[DefinitionTags["CODE_DEFINE_SHAPE2"] = 22] = "CODE_DEFINE_SHAPE2";
        DefinitionTags[DefinitionTags["CODE_DEFINE_SHAPE3"] = 32] = "CODE_DEFINE_SHAPE3";
        DefinitionTags[DefinitionTags["CODE_DEFINE_TEXT2"] = 33] = "CODE_DEFINE_TEXT2";
        DefinitionTags[DefinitionTags["CODE_DEFINE_BUTTON2"] = 34] = "CODE_DEFINE_BUTTON2";
        DefinitionTags[DefinitionTags["CODE_DEFINE_BITS_JPEG3"] = 35] = "CODE_DEFINE_BITS_JPEG3";
        DefinitionTags[DefinitionTags["CODE_DEFINE_BITS_LOSSLESS2"] = 36] = "CODE_DEFINE_BITS_LOSSLESS2";
        DefinitionTags[DefinitionTags["CODE_DEFINE_EDIT_TEXT"] = 37] = "CODE_DEFINE_EDIT_TEXT";
        DefinitionTags[DefinitionTags["CODE_DEFINE_SPRITE"] = 39] = "CODE_DEFINE_SPRITE";
        DefinitionTags[DefinitionTags["CODE_DEFINE_MORPH_SHAPE"] = 46] = "CODE_DEFINE_MORPH_SHAPE";
        DefinitionTags[DefinitionTags["CODE_DEFINE_FONT2"] = 48] = "CODE_DEFINE_FONT2";
        DefinitionTags[DefinitionTags["CODE_DEFINE_VIDEO_STREAM"] = 60] = "CODE_DEFINE_VIDEO_STREAM";
        DefinitionTags[DefinitionTags["CODE_DEFINE_FONT3"] = 75] = "CODE_DEFINE_FONT3";
        DefinitionTags[DefinitionTags["CODE_DEFINE_SHAPE4"] = 83] = "CODE_DEFINE_SHAPE4";
        DefinitionTags[DefinitionTags["CODE_DEFINE_MORPH_SHAPE2"] = 84] = "CODE_DEFINE_MORPH_SHAPE2";
        DefinitionTags[DefinitionTags["CODE_DEFINE_BINARY_DATA"] = 87] = "CODE_DEFINE_BINARY_DATA";
        DefinitionTags[DefinitionTags["CODE_DEFINE_BITS_JPEG4"] = 90] = "CODE_DEFINE_BITS_JPEG4";
        DefinitionTags[DefinitionTags["CODE_DEFINE_FONT4"] = 91] = "CODE_DEFINE_FONT4";
    })(DefinitionTags || (DefinitionTags = {}));
    var ImageDefinitionTags;
    (function (ImageDefinitionTags) {
        ImageDefinitionTags[ImageDefinitionTags["CODE_DEFINE_BITS"] = 6] = "CODE_DEFINE_BITS";
        ImageDefinitionTags[ImageDefinitionTags["CODE_DEFINE_BITS_JPEG2"] = 21] = "CODE_DEFINE_BITS_JPEG2";
        ImageDefinitionTags[ImageDefinitionTags["CODE_DEFINE_BITS_JPEG3"] = 35] = "CODE_DEFINE_BITS_JPEG3";
        ImageDefinitionTags[ImageDefinitionTags["CODE_DEFINE_BITS_JPEG4"] = 90] = "CODE_DEFINE_BITS_JPEG4";
    })(ImageDefinitionTags || (ImageDefinitionTags = {}));
    var FontDefinitionTags;
    (function (FontDefinitionTags) {
        FontDefinitionTags[FontDefinitionTags["CODE_DEFINE_FONT"] = 10] = "CODE_DEFINE_FONT";
        FontDefinitionTags[FontDefinitionTags["CODE_DEFINE_FONT2"] = 48] = "CODE_DEFINE_FONT2";
        FontDefinitionTags[FontDefinitionTags["CODE_DEFINE_FONT3"] = 75] = "CODE_DEFINE_FONT3";
        FontDefinitionTags[FontDefinitionTags["CODE_DEFINE_FONT4"] = 91] = "CODE_DEFINE_FONT4";
    })(FontDefinitionTags || (FontDefinitionTags = {}));
    var ControlTags;
    (function (ControlTags) {
        ControlTags[ControlTags["CODE_PLACE_OBJECT"] = 4] = "CODE_PLACE_OBJECT";
        ControlTags[ControlTags["CODE_PLACE_OBJECT2"] = 26] = "CODE_PLACE_OBJECT2";
        ControlTags[ControlTags["CODE_PLACE_OBJECT3"] = 70] = "CODE_PLACE_OBJECT3";
        ControlTags[ControlTags["CODE_REMOVE_OBJECT"] = 5] = "CODE_REMOVE_OBJECT";
        ControlTags[ControlTags["CODE_REMOVE_OBJECT2"] = 28] = "CODE_REMOVE_OBJECT2";
        ControlTags[ControlTags["CODE_START_SOUND"] = 15] = "CODE_START_SOUND";
        ControlTags[ControlTags["CODE_START_SOUND2"] = 89] = "CODE_START_SOUND2";
        ControlTags[ControlTags["CODE_VIDEO_FRAME"] = 61] = "CODE_VIDEO_FRAME";
    })(ControlTags || (ControlTags = {}));

    var noTimelineDebug = true;
    var noExportsDebug = true;
    var noSceneGraphDebug = true;
    /**
     * SWFParser provides a parser for the SWF data type.
     * Based on Shumway
     */
    var SWFParser = /** @class */ (function (_super) {
        __extends(SWFParser, _super);
        /**
         * Creates a new AWD3Parserutils object.
         * @param uri The url or id of the data or file to be parsed.
         * @param extra The holder for extra contextual data that the parser might need.
         */
        function SWFParser(factory) {
            if (factory === void 0) { factory = null; }
            var _this = _super.call(this, URLLoaderDataFormat.ARRAY_BUFFER) || this;
            //set to "true" to have some console.logs in the Console
            _this._parsed_header = false;
            _this._debug = false;
            _this._startedParsing = false;
            _this.soundExports = {};
            _this.externalDependenciesCount = 0;
            // helper for handling buttons
            _this._buttonIds = {};
            _this._mcIds = {};
            _this.textFormatAlignMap = [TextFormatAlign.LEFT, TextFormatAlign.RIGHT, TextFormatAlign.CENTER, TextFormatAlign.JUSTIFY];
            _this._buttonSounds = {};
            _this._swfFile = new SWFFile();
            _this._factory = factory || new DefaultSceneGraphFactory();
            return _this;
        }
        Object.defineProperty(SWFParser.prototype, "swfFile", {
            get: function () {
                return this._swfFile;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Indicates whether or not a given file extension is supported by the parser.
         * @param extension The file extension of a potential file to be parsed.
         * @return Whether or not the given file type is supported.
         */
        SWFParser.supportsType = function (extension) {
            extension = extension.toLowerCase();
            console.log("SWFParser supportsType extension: ", extension, "result: ", extension == "swf");
            return extension == "swf";
        };
        /**
         * Tests whether a data block can be parsed by the parser.
         * @param data The data block to potentially be parsed.
         * @return Whether or not the given data is supported.
         */
        SWFParser.supportsData = function (data) {
            var magic = (data[0] << 16) | (data[1] << 8) | data[2];
            console.log("SWFParser supportsData data: ", data);
            // check if header is 
            if ((magic & 0xffff) === 0x5753) {
                console.log("SWFParser supportsData result: ", true);
                return true;
            }
            console.log("SWFParser supportsData result: ", false);
            return false;
        };
        /**
         * @inheritDoc
         */
        SWFParser.prototype._iResolveDependency = function (resourceDependency) {
            //console.log("_iResolveDependency", resourceDependency);
            // this will be called when Dependency has finished loading.
            // the ressource dependecniy has a id that point to the awd_block waiting for it.
            //console.log("SWFParser resolve dependencies";
            if (resourceDependency.assets.length == 1) {
                var awaitedObject = this.eagerlyParsedSymbolsMap[resourceDependency.id];
                if (awaitedObject) {
                    switch (awaitedObject.type) {
                        case "image":
                            //console.log("finished image parsing", resourceDependency);
                            var myBitmap = resourceDependency.assets[0];
                            //myBitmap.width=awaitedObject.definition.width;
                            //myBitmap.height=awaitedObject.definition.height;
                            this._awaySymbols[resourceDependency.id] = myBitmap;
                            break;
                        case "font":
                            //console.log("finished font parsing", resourceDependency);
                            break;
                        case "sound":
                            //console.log("finished sound parsing", resourceDependency);
                            var waveAudio = resourceDependency.assets[0];
                            //myBitmap.width=awaitedObject.definition.width;
                            //myBitmap.height=awaitedObject.definition.height;
                            this._awaySymbols[resourceDependency.id] = waveAudio;
                            break;
                        default:
                            console.log("finished unknown parsing", resourceDependency);
                            break;
                    }
                }
                else
                    console.log("no eagerlyParsedSymbolsMap for id", resourceDependency.id);
            }
            else {
                throw ("SWFParser: error when resolving dependency");
            }
            this.externalDependenciesCount--;
            if (this.externalDependenciesCount == 0) {
                this.parseSymbolsToAwayJS();
            }
        };
        /**
         * @inheritDoc
         */
        SWFParser.prototype._iResolveDependencyFailure = function (resourceDependency) {
            //not used - if a dependcy fails, the awaiting Texture or CubeTexture will never be finalized, and the default-bitmaps will be used.
            // this means, that if one Bitmap of a CubeTexture fails, the CubeTexture will have the DefaultTexture applied for all six Bitmaps.
            //console.log("_iResolveDependencyFailure", resourceDependency);
            this.externalDependenciesCount--;
            if (this.externalDependenciesCount == 0) {
                this.parseSymbolsToAwayJS();
            }
        };
        /**
         * Resolve a dependency name
         *
         * @param resourceDependency The dependency to be resolved.
         */
        SWFParser.prototype._iResolveDependencyName = function (resourceDependency, asset) {
            var oldName = asset.name;
            var newName = asset.name;
            asset.name = oldName;
            return newName;
        };
        /**
         * @inheritDoc
         */
        SWFParser.prototype._pProceedParsing = function () {
            //console.log("SWFParser - _pProceedParsing");
            if (!this._startedParsing) {
                this._factory.url = this._iFileName;
                this._startedParsing = true;
                // get the bytedata
                var byteData = this._pGetByteData();
                var int8Array = new Uint8Array(byteData.arraybytes);
                // preparse all data. after this step we can deal with tag-objects rather than bytedata
                this.initSWFLoading(int8Array, int8Array.length);
                // now we have a list of symbols that we want to convert to awayjs-symbols
                this._awaySymbols = {};
                this._mapMatsForBitmaps = {};
                if (this.abcBlocks.length && this._factory.executeABCBytes) {
                    this._factory.executeABCBytes(this.abcBlocks);
                }
                // this.eagerlyParsedSymbolsList can contain image/font data,
                // that must be resolved externally before we can start creating assets for symbols
                this.externalDependenciesCount = 0;
                if (this.eagerlyParsedSymbolsList.length > 0) {
                    //console.log("this.eagerlyParsedSymbolsList", this.eagerlyParsedSymbolsList);
                    //console.log("this.eagerlyParsedSymbolsMap", this.eagerlyParsedSymbolsMap);
                    for (var i = 0; i < this.eagerlyParsedSymbolsList.length; i++) {
                        var eagerlySymbol = this.eagerlyParsedSymbolsList[i];
                        if (eagerlySymbol) {
                            switch (eagerlySymbol.type) {
                                case "image":
                                    //console.log("init image parsing", eagerlySymbol);
                                    this._pAddDependency(eagerlySymbol.id.toString(), null, new Image2DParser(this._factory, eagerlySymbol.definition.alphaData), new Blob([eagerlySymbol.definition.data], { type: eagerlySymbol.definition.mimeType }), false, true);
                                    this.externalDependenciesCount++;
                                    break;
                                case "sound":
                                    //console.log("init sound parsing", eagerlySymbol);
                                    this._pAddDependency(eagerlySymbol.id.toString(), null, new WaveAudioParser(), new Blob([eagerlySymbol.definition.packaged.data], { type: eagerlySymbol.definition.packaged.mimeType }), false, true);
                                    this.externalDependenciesCount++;
                                    break;
                                case "font":
                                    //console.log("encountered eagerly parsed font: ", eagerlySymbol);
                                    break;
                                default:
                                    console.log("encountered eagerly parsed unknown type: ", eagerlySymbol);
                                    break;
                            }
                        }
                    }
                }
                if (this.externalDependenciesCount > 0) {
                    this._pPauseAndRetrieveDependencies();
                }
                else {
                    this.parseSymbolsToAwayJS();
                }
            }
            if (this.externalDependenciesCount > 0) {
                return ParserBase.MORE_TO_PARSE;
            }
            return ParserBase.PARSING_DONE;
        };
        SWFParser.prototype.getMaterial = function (bitmapIndex) {
            var material = this._mapMatsForBitmaps[bitmapIndex];
            if (!material) {
                material = new MethodMaterial();
                var myImage = this._awaySymbols[bitmapIndex];
                if (!myImage || (!myImage.isAsset(BitmapImage2D) && !myImage.isAsset(SceneImage2D))) {
                    release$1 || console.log("error: can not find image for bitmapfill", myImage);
                    myImage = new BitmapImage2D(512, 512, false, 0xff0000ff, true);
                }
                material.ambientMethod.texture = new ImageTexture2D(myImage);
                material.alphaBlending = true;
                material.useColorTransform = true;
                material.bothSides = true;
                this._mapMatsForBitmaps[bitmapIndex] = material;
            }
            return material;
        };
        SWFParser.prototype.parseSymbolsToAwayJS = function () {
            var parser = new DOMParser();
            var dictionary = this.dictionary;
            var assetsToFinalize = {};
            for (var i = 0; i < dictionary.length; i++) {
                if (dictionary[i]) {
                    var s = performance.now();
                    var symbol = this.getSymbol(dictionary[i].id);
                    noSceneGraphDebug || console.log("symbol: ", dictionary[i].id, symbol.type, symbol);
                    switch (symbol.type) {
                        case "morphshape":
                            //console.warn("Warning: SWF contains shapetweening!!!");
                            symbol.shape.name = symbol.id;
                            symbol.shape.name = "AwayJS_morphshape_" + symbol.id.toString();
                            symbol.shape.className = symbol.className;
                            this._awaySymbols[dictionary[i].id] = symbol.shape;
                            assetsToFinalize[dictionary[i].id] = symbol.shape;
                            break;
                        case "shape":
                            symbol.shape.name = "AwayJS_shape_" + symbol.id.toString();
                            symbol.shape.className = symbol.className;
                            this._awaySymbols[dictionary[i].id] = symbol.shape;
                            assetsToFinalize[dictionary[i].id] = symbol.shape;
                            break;
                        case "font":
                            //symbol.away._smybol=symbol;
                            symbol.away.className = symbol.className;
                            this._awaySymbols[dictionary[i].id] = symbol;
                            assetsToFinalize[symbol.name] = symbol.away;
                            break;
                        case "sprite":
                            noTimelineDebug || console.log("start parsing timeline: ", symbol);
                            var awayMc = this.framesToTimeline(symbol, symbol.frames, null, null);
                            awayMc.className = symbol.className;
                            if (awayMc.buttonMode) {
                                this._buttonIds[symbol.id] = true;
                            }
                            else {
                                this._mcIds[symbol.id] = true;
                            }
                            awayMc.name = "AwayJS_mc_" + symbol.id.toString();
                            this._awaySymbols[dictionary[i].id] = awayMc;
                            assetsToFinalize[dictionary[i].id] = awayMc;
                            break;
                        case "text":
                            var awayText = this._factory.createTextField(symbol);
                            awayText._symbol = symbol;
                            awayText.textFormat = new TextFormat();
                            awayText.className = symbol.className;
                            var flashFont = this._awaySymbols[symbol.tag.fontId];
                            if (flashFont) {
                                awayText.textFormat.font = flashFont.away;
                                awayText.textFormat.font_table = flashFont.away.get_font_table(flashFont.fontStyleName, TesselatedFontTable.assetType);
                            }
                            awayText.textFormat.size = symbol.tag.fontHeight / 20;
                            //awayText.textFormat.color = (symbol.tag.flags & TextFlags.HasColor)?ColorUtils.f32_RGBA_To_f32_ARGB(symbol.tag.color):0xffffff;
                            awayText.textColor = (symbol.tag.flags & 4 /* HasColor */) ? ColorUtils.f32_RGBA_To_f32_ARGB(symbol.tag.color) : 0xffffff;
                            awayText.textFormat.leftMargin = symbol.tag.leftMargin / 20;
                            awayText.textFormat.rightMargin = symbol.tag.rightMargin / 20;
                            awayText.textFormat.letterSpacing = symbol.tag.letterSpacing / 20;
                            awayText.textFormat.leading = symbol.tag.leading / 20;
                            awayText.textFormat.align = this.textFormatAlignMap[symbol.tag.align];
                            awayText.textOffsetX = symbol.fillBounds.xMin / 20;
                            awayText.textOffsetY = symbol.fillBounds.yMin / 20;
                            awayText.width = ((symbol.fillBounds.xMax - symbol.fillBounds.xMin) / 20);
                            awayText.height = (symbol.fillBounds.yMax - symbol.fillBounds.yMin) / 20;
                            awayText.border = !!(symbol.tag.flags & 2048 /* Border */);
                            awayText.background = awayText.border;
                            awayText.multiline = (symbol.tag.flags & 32 /* Multiline */) ? true : false;
                            awayText.wordWrap = (symbol.tag.flags & 64 /* WordWrap */) ? true : false;
                            awayText.selectable = symbol.tag.flags ? !(symbol.tag.flags & 4096 /* NoSelect */) : false;
                            if (symbol.tag.maxLength && symbol.tag.maxLength > 0) {
                                awayText.maxChars = symbol.tag.maxLength;
                            }
                            if (symbol.tag.flags & 8 /* ReadOnly */) {
                                awayText.type = "dynamic";
                            }
                            else {
                                awayText.type = "input";
                            }
                            if (symbol.tag.flags & 512 /* Html */) {
                                awayText.html = true;
                                if (symbol.tag.initialText && symbol.tag.initialText != "")
                                    awayText.htmlText = symbol.tag.initialText;
                            }
                            else {
                                awayText.html = false;
                                if (symbol.tag.initialText && symbol.tag.initialText != "")
                                    awayText.text = symbol.tag.initialText;
                            }
                            awayText.name = "tf_" + symbol.id.toString();
                            assetsToFinalize[dictionary[i].id] = awayText;
                            this._awaySymbols[dictionary[i].id] = awayText;
                            break;
                        case "sound":
                            var awaySound = this._awaySymbols[dictionary[i].id];
                            if (awaySound) {
                                awaySound.className = this.symbolClassesMap[symbol.id] ? this.symbolClassesMap[symbol.id] : null;
                                awaySound.name = awaySound.className;
                                assetsToFinalize[dictionary[i].id] = awaySound;
                                //awaySound.play(0,false);
                            }
                            else {
                                console.warn("SWF-parser: no sound loaded for sound-id:", dictionary[i].id);
                            }
                            break;
                        case "button":
                            noTimelineDebug || console.log("start parsing button: ", symbol);
                            var awayMc = this.framesToTimeline(symbol, null, symbol.states, symbol.buttonActions, this._buttonSounds[symbol.id]);
                            //awayMc._symbol=symbol;
                            awayMc.name = "AwayJS_button_" + symbol.id.toString();
                            awayMc.className = symbol.className;
                            assetsToFinalize[dictionary[i].id] = awayMc;
                            this._awaySymbols[dictionary[i].id] = awayMc;
                            this._buttonIds[symbol.id] = true;
                            /*
                            var mySprite:SimpleButton=new SimpleButton();
                            console.log("Button:", symbol);
                            //var awayMc = this.framesToAwayTimeline(symbol.frames);
                            //mySprite._symbol=symbol;
                            this._pFinalizeAsset(mySprite, symbol.id);
                            this._awaySymbols[dictionary[i].id] = mySprite;
                            */
                            break;
                        case "label":
                            var awayText = this._factory.createTextField(symbol);
                            var font = null;
                            var invalid_font = false;
                            awayText.className = symbol.className;
                            for (var r = 0; r < symbol.records.length; r++) {
                                var record = symbol.records[r];
                                if (record.fontId) {
                                    font = this._awaySymbols[record.fontId];
                                    if (font) {
                                        //awayText.textFormat.font=font.away;
                                        record.font_table = font.away.get_font_table(font.fontStyleName, TesselatedFontTable.assetType);
                                        if (!record.font_table) {
                                            invalid_font = true;
                                            console.log("no font_table set");
                                        }
                                        //record.font_table=font.away.font_styles[0];
                                    }
                                }
                            }
                            awayText.staticMatrix = symbol.matrix;
                            awayText.textOffsetX = symbol.fillBounds.xMin / 20;
                            awayText.textOffsetY = symbol.fillBounds.yMin / 20;
                            awayText.width = (symbol.fillBounds.xMax / 20 - symbol.fillBounds.xMin / 20) - 1;
                            awayText.height = (symbol.fillBounds.yMax / 20 - symbol.fillBounds.yMin / 20) - 1;
                            if (!invalid_font)
                                awayText.setLabelData(symbol);
                            awayText.name = "AwayJS_label_" + symbol.id.toString();
                            assetsToFinalize[dictionary[i].id] = awayText;
                            this._awaySymbols[dictionary[i].id] = awayText;
                            awayText.selectable = symbol.tag.flags ? !(symbol.tag.flags & 4096 /* NoSelect */) : false;
                            break;
                        case "image":
                            var awayBitmap = this._awaySymbols[dictionary[i].id];
                            if (!awayBitmap && symbol.definition) {
                                awayBitmap = new BitmapImage2D(symbol.definition.width, symbol.definition.height, true, 0xff0000, false);
                                if (symbol.definition.data.length != (4 * symbol.definition.width * symbol.definition.height)
                                    && symbol.definition.data.length != (3 * symbol.definition.width * symbol.definition.height)) {
                                    symbol.definition.data = new Uint8ClampedArray(4 * symbol.definition.width * symbol.definition.height);
                                    //symbol.definition.data.fill
                                }
                                awayBitmap.setPixels(new Rectangle(0, 0, symbol.definition.width, symbol.definition.height), symbol.definition.data);
                            }
                            if (awayBitmap) {
                                this._awaySymbols[dictionary[i].id] = awayBitmap;
                                awayBitmap.className = this.symbolClassesMap[symbol.id] ? this.symbolClassesMap[symbol.id] : symbol.className;
                                awayBitmap.name = awayBitmap.className;
                                assetsToFinalize[dictionary[i].id] = awayBitmap;
                            }
                            break;
                        case "binary":
                            if (this._factory.createBinarySymbol)
                                this._factory.createBinarySymbol(symbol);
                            break;
                        default:
                            console.log("unknown symbol type:", symbol.type, symbol);
                            break;
                    }
                }
            }
            var rootSymbol = this.dictionary[0];
            if (!rootSymbol) {
                rootSymbol = {
                    id: 0,
                    className: this.symbolClassesMap[0]
                };
            }
            noTimelineDebug || console.log("start parsing root-timeline: ", rootSymbol);
            var awayMc = this.framesToTimeline(rootSymbol, this._swfFile.frames, null, null);
            for (var key in assetsToFinalize) {
                assetsToFinalize[key]["fileurl"] = this._iFileName;
                this._pFinalizeAsset(assetsToFinalize[key]);
            }
            awayMc.isAVMScene = true;
            this._pFinalizeAsset(awayMc, "scene");
            DefaultFontManager.applySharedFonts(this._iFileName);
            //console.log("root-timeline: ", awayMc);
            //console.log("AwayJS loaded SWF with "+ dictionary.length+" symbols", this._swfFile.sceneAndFrameLabelData);
        };
        SWFParser.prototype.framesToTimeline = function (symbol, swfFrames, states, buttonActions, buttonSound) {
            if (buttonSound === void 0) { buttonSound = null; }
            if (!states && !swfFrames)
                throw ("error when creating timeline - neither movieclip frames nor button-states present");
            //console.log("swfFrames", swfFrames);
            var isButton = false;
            var key;
            symbol.isButton = false;
            if (states && !swfFrames) {
                isButton = true;
                symbol.isButton = true;
                swfFrames = [];
                for (key in states) {
                    var newSWFFrame = new SWFFrame();
                    newSWFFrame.controlTags = states[key];
                    newSWFFrame.buttonStateName = key;
                    swfFrames[swfFrames.length] = newSWFFrame;
                    //console.log("buttonSound ", buttonSound);
                }
            }
            var awayMc = this._factory.createMovieClip(null, symbol);
            awayMc.symbolID = symbol.id;
            var awayTimeline = awayMc.timeline;
            var keyframe_durations = [];
            var frame_command_indices = [];
            var frame_recipe = [];
            var command_length_stream = [];
            var command_index_stream = [];
            var add_child_stream = [];
            var add_sounds_stream = [];
            var remove_child_stream = [];
            var update_child_stream = [];
            var update_child_props_indices_stream = [];
            var update_child_props_length_stream = [];
            var property_type_stream = [];
            var property_index_stream = [];
            var properties_stream_int = [];
            var properties_stream_f32_mtx_scale_rot = [];
            var properties_stream_f32_mtx_pos = [];
            var properties_stream_f32_mtx_all = [];
            var properties_stream_f32_ct = [];
            var properties_stream_strings = [];
            var virtualScenegraph = {};
            var freeChilds = {};
            var keyFrameCount = 0;
            var framesLen = 0;
            var cmds_removed = [];
            var cmds_add = [];
            var cmds_update = [];
            var cmds_startSounds = [];
            var cmds_stopSounds = [];
            var unparsedTags = [];
            var transformsAtDepth = {};
            var instanceCNT = 0;
            var child;
            var name;
            var freeChildsForID;
            var i;
            var framesLen = swfFrames.length;
            var command_recipe_flag = 0;
            var audio_commands_cnt = 0;
            var labelName;
            var fl;
            var fl_len;
            var isEmpty;
            var len;
            var ct;
            var unparsedTag;
            var placeObjectTag;
            var hasCharacter;
            var awaySymbol = null;
            var sessionID = -1;
            var swapGraphicsID = -1;
            var ratio = -1;
            var flashSymbol;
            var graphicsSprite;
            var doAdd = true;
            var tag;
            MovieClip.movieClipSoundsManagerClass = MovieClipSoundsManager;
            for (i = 0; i < framesLen; i++) {
                noTimelineDebug || console.log("	process frame:", i + 1, "/", framesLen);
                cmds_removed.length = 0;
                cmds_add.length = 0;
                cmds_update.length = 0;
                cmds_startSounds.length = 0;
                cmds_stopSounds.length = 0;
                unparsedTags.length = 0;
                if (swfFrames[i].soundStreamHead) {
                    awayMc.initSoundStream(swfFrames[i].soundStreamHead, framesLen);
                    //console.log("stream encountered", swfFrames[i].soundStreamHead)
                }
                if (swfFrames[i].soundStreamBlock) {
                    awayMc.addSoundStreamBlock(i, swfFrames[i].soundStreamBlock);
                    //console.log("stream encountered", swfFrames[i].soundStreamHead)
                }
                if (swfFrames[i].initActionBlocks) {
                    awayTimeline.avm1InitActions[i] = swfFrames[i].initActionBlocks;
                }
                if (swfFrames[i].exports) {
                    awayTimeline.avm1Exports[i] = swfFrames[i].exports;
                    for (key in swfFrames[i].exports) {
                        //console.log("\n\nfound export\n\n", swfFrames[i].exports[key]);
                        var asset = swfFrames[i].exports[key];
                        var awayAsset = this._awaySymbols[asset.symbolId];
                        if (!awayAsset) {
                            console.log("\n\nerror: no away-asset for export\n\n", swfFrames[i].exports[key]);
                        }
                        else {
                            if (awayAsset.isAsset) {
                                //  this is a awayjs asset. we just update its name. 
                                //  all awayjs-assets will get registered on AssetLibrary by name at very end of parseSymbolsToAwayJS function
                                awayAsset.name = asset.className.toLowerCase();
                            }
                            else if (awayAsset.away) {
                                // this is a font. for now we do nothing (?)
                            }
                        }
                        noExportsDebug || console.log("			added export", swfFrames[i].exports[key], asset.className, asset.symbolId, awayAsset);
                    }
                }
                // check if this is a empty frame
                isEmpty = ((!swfFrames[i].controlTags || swfFrames[i].controlTags.length == 0) &&
                    (!swfFrames[i].labelNames || swfFrames[i].labelNames.length == 0) &&
                    (!swfFrames[i].actionBlocks || swfFrames[i].actionBlocks.length == 0));
                noTimelineDebug || console.log("	process frame:", i + 1, "/", isEmpty, swfFrames[i]);
                if ((keyframe_durations.length != 0) && isEmpty) {
                    // frame is empty and it is not the first frame
                    // we just add to the duration of the last keyframe			
                    if (isButton) {
                        command_recipe_flag = 0;
                        command_recipe_flag |= 0x01;
                        frame_command_indices.push(command_index_stream.length);
                        keyframe_durations[keyframe_durations.length] = 1;
                        frame_recipe.push(command_recipe_flag);
                        for (key in virtualScenegraph) {
                            child = virtualScenegraph[key];
                            freeChildsForID = freeChilds[child.id];
                            if (!freeChildsForID) {
                                freeChildsForID = freeChilds[child.id] = {};
                            }
                            name = child.name; //+"#"+key;
                            if (!freeChildsForID[name]) {
                                freeChildsForID[name] = [];
                            }
                            freeChildsForID[name].push(child.sessionID);
                        }
                        virtualScenegraph = {};
                        keyFrameCount++;
                        //transformsAtDepth[tag.depth.toString()]=null;
                        noTimelineDebug || console.log("			remove all to  create empty button frame");
                    }
                    else {
                        noTimelineDebug || console.log("			extending last frames duration");
                        keyframe_durations[keyframe_durations.length - 1] += 1;
                    }
                }
                else {
                    // frame is not empty, or it is the first frame, or both
                    command_recipe_flag = 0;
                    if (isButton) {
                        command_recipe_flag |= 0x01;
                        for (key in virtualScenegraph) {
                            child = virtualScenegraph[key];
                            freeChildsForID = freeChilds[child.id];
                            if (!freeChildsForID) {
                                freeChildsForID = freeChilds[child.id] = {};
                            }
                            name = child.name; //+"#"+key;
                            if (!freeChildsForID[name]) {
                                freeChildsForID[name] = [];
                            }
                            freeChildsForID[name].push(child.sessionID);
                        }
                        virtualScenegraph = {};
                    }
                    frame_command_indices.push(command_index_stream.length);
                    keyframe_durations[keyframe_durations.length] = 1;
                    if (!isEmpty && (swfFrames[i].labelNames && swfFrames[i].labelNames.length > 0)) {
                        fl_len = swfFrames[i].labelNames.length;
                        for (fl = 0; fl < fl_len; fl++) {
                            labelName = swfFrames[i].labelNames[fl];
                            if (this.swfFile.swfVersion <= 9) {
                                labelName = labelName.toLowerCase();
                            }
                            if (!awayTimeline._labels[labelName])
                                awayTimeline._labels[labelName] = keyFrameCount;
                        }
                    }
                    if (!isEmpty && swfFrames[i].actionBlocks && swfFrames[i].actionBlocks.length > 0) {
                        awayTimeline.add_framescript(swfFrames[i].actionBlocks, i);
                    }
                    if (buttonSound && buttonSound[keyFrameCount] && buttonSound[keyFrameCount].id != 0) {
                        awaySymbol = this._awaySymbols[buttonSound[keyFrameCount].id];
                        if (awaySymbol) {
                            awayTimeline.audioPool[audio_commands_cnt] = { cmd: 15 /* CODE_START_SOUND */, id: buttonSound[keyFrameCount].id, sound: awaySymbol, props: buttonSound[keyFrameCount].info };
                            cmds_startSounds.push(audio_commands_cnt++);
                        }
                    }
                    keyFrameCount++;
                    if (!isEmpty && swfFrames[i].controlTags && swfFrames[i].controlTags.length > 0) {
                        noTimelineDebug || console.log("			Start parsing controltags", swfFrames[i].controlTags.length);
                        len = swfFrames[i].controlTags.length;
                        for (ct = 0; ct < len; ct++) {
                            unparsedTag = swfFrames[i].controlTags[ct];
                            tag = unparsedTag.tagCode === undefined ? unparsedTag : this.getParsedTag(unparsedTag);
                            //console.log("parsed tag", tag);
                            switch (tag.code) {
                                case 15 /* CODE_START_SOUND */:
                                    //console.log("CODE_START_SOUND", tag)
                                    awaySymbol = this._awaySymbols[tag.soundId];
                                    if (tag.soundInfo && (tag.soundInfo.flags & 32 /* Stop */)) {
                                        awayTimeline.audioPool[audio_commands_cnt] = { cmd: 16 /* CODE_STOP_SOUND */, id: tag.soundId, sound: this._awaySymbols[tag.soundId], props: tag.soundInfo };
                                        noTimelineDebug || console.log("stopsound", tag.soundId, tag.soundInfo, i + 1);
                                    }
                                    else {
                                        awayTimeline.audioPool[audio_commands_cnt] = { cmd: 15 /* CODE_START_SOUND */, id: tag.soundId, sound: this._awaySymbols[tag.soundId], props: tag.soundInfo };
                                        noTimelineDebug || console.log("startsound", tag.soundId, tag.soundInfo, awaySymbol, i + 1);
                                    }
                                    // todo: volume / pan / other properties
                                    cmds_startSounds.push(audio_commands_cnt++);
                                    break;
                                case 16 /* CODE_STOP_SOUND */:
                                    //console.log("CODE_STOP_SOUND", tag)
                                    // todo
                                    //console.log("stopsound", tag.soundId, tag.soundInfo);
                                    awayTimeline.audioPool[audio_commands_cnt] = { cmd: 16 /* CODE_STOP_SOUND */, id: tag.soundId, sound: this._awaySymbols[tag.soundId], props: tag.soundInfo };
                                    noTimelineDebug || console.log("stopsound", tag.soundId, tag.soundInfo, i + 1);
                                    cmds_startSounds.push(audio_commands_cnt++);
                                    break;
                                case 5 /* CODE_REMOVE_OBJECT */:
                                case 28 /* CODE_REMOVE_OBJECT2 */:
                                    child = virtualScenegraph[tag.depth];
                                    if (!child) {
                                        console.log("Error in timeline. remove cant find the obejct to remove");
                                    }
                                    cmds_removed[cmds_removed.length] = { depth: tag.depth | 0 };
                                    //awayTimeline.freePotentialChild(child.awayChild, child.sessionID);
                                    virtualScenegraph[tag.depth] = null;
                                    transformsAtDepth[tag.depth.toString()] = null;
                                    freeChildsForID = freeChilds[child.id];
                                    if (!freeChildsForID) {
                                        freeChildsForID = freeChilds[child.id] = {};
                                    }
                                    name = child.name; //+"#"+tag.depth;
                                    if (!freeChildsForID[name]) {
                                        freeChildsForID[name] = [];
                                    }
                                    freeChildsForID[name].push(child.sessionID);
                                    delete virtualScenegraph[tag.depth];
                                    noTimelineDebug || console.log("				remove", "depth", tag.depth);
                                    break;
                                case 4 /* CODE_PLACE_OBJECT */:
                                case 26 /* CODE_PLACE_OBJECT2 */:
                                case 70 /* CODE_PLACE_OBJECT3 */:
                                    placeObjectTag = tag;
                                    //console.log("CODE_PLACE_OBJECT", tag.depth | 0, placeObjectTag);
                                    child = virtualScenegraph[tag.depth];
                                    hasCharacter = placeObjectTag.symbolId > -1;
                                    // Check for invalid flag constellations.
                                    if (placeObjectTag.flags & 1 /* Move */) {
                                        // Invalid case 1: Move flag set but no child found at given depth.
                                        if (!child) {
                                            //  Ignore the current tag.
                                            break;
                                        }
                                    }
                                    awaySymbol = null;
                                    sessionID = -1;
                                    swapGraphicsID = -1;
                                    ratio = -1;
                                    // possible options:
                                    // hasCharacter && !child
                                    //		we need to put a child into the display list. might need to create sprite for graphics !
                                    // hasCharacter && child
                                    //		need to update a child with a new graphic
                                    //		if the existing child is not a graphic, we need to remove it and add a new sprite for it, so we can update the graphics there
                                    // !hasCharacter && child
                                    //		need to update a child
                                    // !hasCharacter && !child
                                    //		something is wrong ?
                                    if (hasCharacter) {
                                        //console.log("placeTag symbol id",placeObjectTag.symbolId )
                                        awaySymbol = this._awaySymbols[placeObjectTag.symbolId];
                                        flashSymbol = this.dictionary[placeObjectTag.symbolId];
                                        //addedIds[addedIds.length]=placeObjectTag.symbolId;
                                        if (awaySymbol.isAsset(Graphics)) {
                                            swapGraphicsID = placeObjectTag.symbolId;
                                            if (!awayTimeline.graphicsPool[placeObjectTag.symbolId]) {
                                                awayTimeline.graphicsPool[placeObjectTag.symbolId] = awaySymbol;
                                            }
                                            // register a new instance for this object
                                            graphicsSprite = this._factory.createSprite(null, awaySymbol, flashSymbol);
                                            graphicsSprite.mouseEnabled = false;
                                            // if this a child is already existing, and it is a sprite, we will just use the swapGraphics command to exchange the graphics it holds
                                            if (child && child.awayChild.isAsset(Sprite)) {
                                                sessionID = child.sessionID;
                                                // a child (sprite) already exists and the swapGraphicsId will be handled in the update command
                                            }
                                            else {
                                                if (placeObjectTag != null && ((placeObjectTag.name && placeObjectTag.name != "") || (this._buttonIds[placeObjectTag.symbolId]) || (this._mcIds[placeObjectTag.symbolId]))) {
                                                    if (!placeObjectTag.name || placeObjectTag.name == "")
                                                        placeObjectTag.name = "instance" + placeObjectTag.symbolId + "_" + instanceCNT++;
                                                }
                                                if (child) {
                                                    cmds_removed[cmds_removed.length] = { depth: tag.depth | 0 };
                                                    //awayTimeline.freePotentialChild(child.awayChild, child.sessionID);
                                                    freeChildsForID = freeChilds[child.id];
                                                    if (!freeChildsForID) {
                                                        freeChildsForID = freeChilds[child.id] = {};
                                                    }
                                                    name = child.name; //+"#"+tag.depth;
                                                    if (!freeChildsForID[name]) {
                                                        freeChildsForID[name] = [];
                                                    }
                                                    freeChildsForID[name].push(child.sessionID);
                                                    virtualScenegraph[tag.depth] = null;
                                                    transformsAtDepth[tag.depth.toString()] = null;
                                                    delete virtualScenegraph[tag.depth];
                                                    noTimelineDebug || console.log("				remove because we want to add a shape at this depth", "depth", tag.depth);
                                                }
                                                // check if we can reuse a free instance for this symbol:
                                                if (freeChilds[placeObjectTag.symbolId]) {
                                                    name = placeObjectTag.name ? placeObjectTag.name : "noname";
                                                    // first we check if a instance is available that had the same instance-name
                                                    if (freeChilds[placeObjectTag.symbolId][name] && freeChilds[placeObjectTag.symbolId][name].length > 0) {
                                                        sessionID = freeChilds[placeObjectTag.symbolId][name].shift();
                                                    }
                                                    else {
                                                        // if not, we try to grab any other                                                    
                                                        for (key in freeChilds[placeObjectTag.symbolId]) {
                                                            if (freeChilds[placeObjectTag.symbolId][key].length > 0) {
                                                                sessionID = freeChilds[placeObjectTag.symbolId][key].shift();
                                                                break;
                                                            }
                                                        }
                                                    }
                                                }
                                                if (sessionID == -1) {
                                                    sessionID = awayTimeline.registerPotentialChild(graphicsSprite);
                                                }
                                                if (placeObjectTag.name || placeObjectTag.variableName || (placeObjectTag.events && placeObjectTag.events.length > 0)) {
                                                    awayTimeline.potentialPrototypesInitEventsMap[sessionID + "#" + i] = placeObjectTag;
                                                }
                                                noTimelineDebug || console.log("				add shape", "session-id", sessionID, "depth", tag.depth, tag, awaySymbol);
                                                child = virtualScenegraph[tag.depth] = {
                                                    sessionID: sessionID,
                                                    id: placeObjectTag.symbolId,
                                                    masks: [],
                                                    isMask: false,
                                                    clipDepth: 0,
                                                    depth: 0,
                                                    awayChild: graphicsSprite,
                                                    name: placeObjectTag.name ? placeObjectTag.name : "noname"
                                                };
                                                cmds_add[cmds_add.length] = { sessionID: sessionID, depth: tag.depth, id: placeObjectTag.symbolId, name: placeObjectTag.name };
                                            }
                                        }
                                        else {
                                            if (!placeObjectTag.name || placeObjectTag.name == "")
                                                placeObjectTag.name = "instance" + placeObjectTag.symbolId + "_" + instanceCNT++;
                                            // check if we can reuse a free instance for this symbol:
                                            if (freeChilds[placeObjectTag.symbolId]) {
                                                name = placeObjectTag.name ? placeObjectTag.name : "noname";
                                                // first we check if a instance is available that had the same instance-name
                                                if (freeChilds[placeObjectTag.symbolId][name] && freeChilds[placeObjectTag.symbolId][name].length > 0) {
                                                    sessionID = freeChilds[placeObjectTag.symbolId][name].shift();
                                                }
                                                else {
                                                    // if not, we try to grab any other
                                                    for (key in freeChilds[placeObjectTag.symbolId]) {
                                                        if (freeChilds[placeObjectTag.symbolId][key].length > 0) {
                                                            sessionID = freeChilds[placeObjectTag.symbolId][key].shift();
                                                            break;
                                                        }
                                                    }
                                                }
                                            }
                                            if (sessionID == -1) {
                                                sessionID = awayTimeline.registerPotentialChild(awaySymbol);
                                            }
                                            if (placeObjectTag.name || placeObjectTag.variableName || (placeObjectTag.events && placeObjectTag.events.length > 0)) {
                                                awayTimeline.potentialPrototypesInitEventsMap[sessionID + "#" + i] = placeObjectTag;
                                            }
                                            doAdd = true;
                                            if (virtualScenegraph[tag.depth] && virtualScenegraph[tag.depth].id == placeObjectTag.symbolId) {
                                                doAdd = false;
                                            }
                                            child = virtualScenegraph[tag.depth] = {
                                                sessionID: sessionID,
                                                id: placeObjectTag.symbolId,
                                                masks: [],
                                                isMask: false,
                                                clipDepth: 0,
                                                depth: 0,
                                                awayChild: awaySymbol,
                                                name: placeObjectTag.name ? placeObjectTag.name : "noname"
                                            };
                                            if (doAdd) {
                                                noTimelineDebug || console.log("				add", "session-id", sessionID, "depth", tag.depth, tag, awaySymbol);
                                                cmds_add[cmds_add.length] = { sessionID: sessionID, depth: tag.depth, id: placeObjectTag.symbolId, name: placeObjectTag.name };
                                            }
                                        }
                                    }
                                    if (placeObjectTag.flags & 16 /* HasRatio */) {
                                        if (!awaySymbol)
                                            awaySymbol = this._awaySymbols[child.id];
                                        if (awaySymbol.isAsset(MorphSprite))
                                            ratio = placeObjectTag.ratio;
                                    }
                                    if (child) {
                                        cmds_update[cmds_update.length] = { child: child, placeObjectTag: placeObjectTag, swapGraphicsID: swapGraphicsID, ratio: ratio, depth: tag.depth };
                                        noTimelineDebug || console.log("				update", "session-id", child.sessionID, "hasCharacter", hasCharacter, "depth", tag.depth, "swapGraphicsID", swapGraphicsID, tag, awaySymbol);
                                    }
                                    else {
                                        throw ("error in add command");
                                    }
                                    break;
                                default:
                                    console.log("unknown timeline command tag", tag);
                            }
                            //console.log("parsed a tag: ", tag);
                        }
                        // create remove commands:
                        var start_index = remove_child_stream.length;
                        var command_cnt = cmds_removed.length;
                        if (command_cnt) {
                            start_index = remove_child_stream.length;
                            for (var cmd = 0; cmd < command_cnt; cmd++) {
                                remove_child_stream.push(cmds_removed[cmd].depth);
                            }
                            command_recipe_flag |= 0x02;
                            command_length_stream.push(remove_child_stream.length - start_index);
                            command_index_stream.push(start_index);
                            if (!noTimelineDebug) {
                                for (var iDebug = 0; iDebug < cmds_removed.length; iDebug++) {
                                    console.log("				removeCmd", cmds_removed[iDebug]);
                                }
                            }
                        }
                        // create add commands:
                        var command_cnt = cmds_add.length;
                        if (command_cnt) {
                            start_index = add_child_stream.length;
                            for (var cmd = 0; cmd < command_cnt; cmd++) {
                                add_child_stream.push(cmds_add[cmd].sessionID);
                                add_child_stream.push(cmds_add[cmd].depth);
                            }
                            command_recipe_flag |= 0x04;
                            command_length_stream.push(command_cnt);
                            command_index_stream.push(start_index / 2);
                            if (!noTimelineDebug) {
                                for (var iDebug = 0; iDebug < cmds_add.length; iDebug++) {
                                    console.log("				addCommands", cmds_add[iDebug]);
                                }
                            }
                        }
                        // create update commands:
                        var command_cnt = cmds_update.length;
                        // virtualScenegraph is already updated.
                        // making sure all childs update their masking if needed:
                        for (var key in virtualScenegraph) {
                            virtualScenegraph[key].oldMasks = virtualScenegraph[key].masks;
                            virtualScenegraph[key].masks = [];
                            virtualScenegraph[key].maskingChanged = false;
                        }
                        // for newly added objects, we translate the clipDepth to isMask
                        if (command_cnt) {
                            for (var cmd = 0; cmd < command_cnt; cmd++) {
                                placeObjectTag = cmds_update[cmd].placeObjectTag;
                                child = cmds_update[cmd].child;
                                child.maskingChanged = true;
                                if (placeObjectTag.flags & 64 /* HasClipDepth */) {
                                    virtualScenegraph[placeObjectTag.depth].isMask = true;
                                    virtualScenegraph[placeObjectTag.depth].clipDepth = placeObjectTag.clipDepth - 1;
                                    virtualScenegraph[placeObjectTag.depth].depth = placeObjectTag.depth;
                                }
                            }
                        }
                        // now we are sure all scenegraphobjects know if they are a mask.
                        // we loop over all of them and apply the masking to the maskee
                        for (var key in virtualScenegraph) {
                            if (virtualScenegraph[key].isMask) {
                                var depth = virtualScenegraph[key].clipDepth;
                                while (depth > virtualScenegraph[key].depth) {
                                    if (virtualScenegraph[depth])
                                        virtualScenegraph[depth].masks.push(virtualScenegraph[key].sessionID);
                                    depth--;
                                }
                            }
                        }
                        var m = 0;
                        var mLen = 0;
                        var childsWithMaskChanges = [];
                        // check for what objects the masking has been changed in this frame
                        for (var key in virtualScenegraph) {
                            var myChild = virtualScenegraph[key];
                            myChild.masks.sort();
                            myChild.oldMasks.sort();
                            if (myChild.masks.length != myChild.oldMasks.length) {
                                childsWithMaskChanges.push(myChild);
                                myChild.maskingChanged = true;
                            }
                            else {
                                m = 0;
                                mLen = myChild.masks.length;
                                for (m = 0; m < mLen; m++) {
                                    if (myChild.masks[m] != myChild.oldMasks[m]) {
                                        childsWithMaskChanges.push(myChild);
                                        myChild.maskingChanged = true;
                                        break;
                                    }
                                }
                            }
                        }
                        mLen = childsWithMaskChanges.length;
                        for (m = 0; m < mLen; m++) {
                            var hasCmd = false;
                            if (command_cnt) {
                                for (var cmd = 0; cmd < command_cnt; cmd++) {
                                    if (cmds_update[cmd].child == childsWithMaskChanges[m]) {
                                        hasCmd = true;
                                    }
                                }
                            }
                            if (!hasCmd) {
                                cmds_update[cmds_update.length] = { child: childsWithMaskChanges[m], placeObjectTag: null, swapGraphicsID: null, ratio: null, depth: null };
                            }
                        }
                        command_cnt = cmds_update.length;
                        if (command_cnt) {
                            // process updated props
                            if (!noTimelineDebug) {
                                for (var iDebug = 0; iDebug < cmds_update.length; iDebug++) {
                                    console.log("				cmds_update", cmds_update[iDebug]);
                                }
                            }
                            start_index = update_child_stream.length;
                            var updateCnt = 0;
                            var updateCmd;
                            for (var cmd = 0; cmd < command_cnt; cmd++) {
                                updateCmd = cmds_update[cmd];
                                placeObjectTag = updateCmd.placeObjectTag;
                                child = updateCmd.child;
                                var childStartIdx = property_type_stream.length;
                                var num_updated_props = 0;
                                if ((updateCmd.swapGraphicsID != null && updateCmd.swapGraphicsID >= 0)) {
                                    num_updated_props++;
                                    property_type_stream.push(202);
                                    property_index_stream.push(properties_stream_int.length);
                                    properties_stream_int.push(updateCmd.swapGraphicsID);
                                }
                                if (placeObjectTag != null && ((placeObjectTag.name && placeObjectTag.name != "") || (this._buttonIds[placeObjectTag.symbolId]) || (this._mcIds[placeObjectTag.symbolId]))) {
                                    num_updated_props++;
                                    if (this._buttonIds[placeObjectTag.symbolId]) {
                                        property_type_stream.push(5);
                                    }
                                    else {
                                        property_type_stream.push(4);
                                    }
                                    property_index_stream.push(properties_stream_strings.length);
                                    properties_stream_strings.push(placeObjectTag.name);
                                }
                                if (placeObjectTag != null && placeObjectTag.flags & 4 /* HasMatrix */) {
                                    num_updated_props++;
                                    property_type_stream.push(1); //matrix type: 1=all, 11=no position, 12=no scale
                                    property_index_stream.push(properties_stream_f32_mtx_all.length / 6);
                                    // todo: we can save memory by checking if only scale or position was changed,
                                    // but it means we would need to check against the matrix of the current child, not against identy matrix
                                    //  in swf there seem to a some transforms coming in with scale=0 when it should be scale=1
                                    //  This is a flash-bug (?) todo with sharing graphics across multiple mc
                                    //  i checked and if we set a object to scale=0 on purpose in Flash, we still get a scale>0 in swf,
                                    //  so looks like we can fix this by making sure that scale=0 is converted to scale = 1
                                    if (placeObjectTag.matrix.a == 0 && placeObjectTag.matrix.b == 0 && placeObjectTag.matrix.c == 0 && placeObjectTag.matrix.d != 0) {
                                        placeObjectTag.matrix.a = 1;
                                    }
                                    else if (placeObjectTag.matrix.d == 0 && placeObjectTag.matrix.b == 0 && placeObjectTag.matrix.c == 0 && placeObjectTag.matrix.a != 0) {
                                        placeObjectTag.matrix.d = 1;
                                    }
                                    properties_stream_f32_mtx_all[properties_stream_f32_mtx_all.length] = placeObjectTag.matrix.a;
                                    properties_stream_f32_mtx_all[properties_stream_f32_mtx_all.length] = placeObjectTag.matrix.b;
                                    properties_stream_f32_mtx_all[properties_stream_f32_mtx_all.length] = placeObjectTag.matrix.c;
                                    properties_stream_f32_mtx_all[properties_stream_f32_mtx_all.length] = placeObjectTag.matrix.d;
                                    properties_stream_f32_mtx_all[properties_stream_f32_mtx_all.length] = placeObjectTag.matrix.tx / 20;
                                    properties_stream_f32_mtx_all[properties_stream_f32_mtx_all.length] = placeObjectTag.matrix.ty / 20;
                                    transformsAtDepth[updateCmd.depth.toString()] = placeObjectTag.matrix;
                                }
                                else if (updateCmd.depth != null) {
                                    var exTransform = transformsAtDepth[updateCmd.depth.toString()];
                                    if (exTransform) {
                                        num_updated_props++;
                                        property_type_stream.push(1); //matrix type: 1=all, 11=no position, 12=no scale
                                        property_index_stream.push(properties_stream_f32_mtx_all.length / 6);
                                        properties_stream_f32_mtx_all[properties_stream_f32_mtx_all.length] = exTransform.a;
                                        properties_stream_f32_mtx_all[properties_stream_f32_mtx_all.length] = exTransform.b;
                                        properties_stream_f32_mtx_all[properties_stream_f32_mtx_all.length] = exTransform.c;
                                        properties_stream_f32_mtx_all[properties_stream_f32_mtx_all.length] = exTransform.d;
                                        properties_stream_f32_mtx_all[properties_stream_f32_mtx_all.length] = exTransform.tx / 20;
                                        properties_stream_f32_mtx_all[properties_stream_f32_mtx_all.length] = exTransform.ty / 20;
                                    }
                                }
                                if (placeObjectTag != null && placeObjectTag.flags & 8 /* HasColorTransform */) {
                                    //console.log("PlaceObjectFlags.HasColorTransform", placeObjectTag.cxform);
                                    property_type_stream.push(2);
                                    property_index_stream.push(properties_stream_f32_ct.length / 8);
                                    num_updated_props++;
                                    properties_stream_f32_ct[properties_stream_f32_ct.length] = placeObjectTag.cxform.redMultiplier / 255;
                                    properties_stream_f32_ct[properties_stream_f32_ct.length] = placeObjectTag.cxform.greenMultiplier / 255;
                                    properties_stream_f32_ct[properties_stream_f32_ct.length] = placeObjectTag.cxform.blueMultiplier / 255;
                                    properties_stream_f32_ct[properties_stream_f32_ct.length] = placeObjectTag.cxform.alphaMultiplier / 255;
                                    properties_stream_f32_ct[properties_stream_f32_ct.length] = placeObjectTag.cxform.redOffset;
                                    properties_stream_f32_ct[properties_stream_f32_ct.length] = placeObjectTag.cxform.greenOffset;
                                    properties_stream_f32_ct[properties_stream_f32_ct.length] = placeObjectTag.cxform.blueOffset;
                                    properties_stream_f32_ct[properties_stream_f32_ct.length] = placeObjectTag.cxform.alphaOffset;
                                }
                                if (updateCmd.ratio != null && updateCmd.ratio >= 0) {
                                    num_updated_props++;
                                    property_type_stream.push(203);
                                    property_index_stream.push(properties_stream_int.length);
                                    properties_stream_int.push(updateCmd.ratio | 0);
                                    //console.log("PlaceObjectFlags.HasRatio", placeObjectTag, child);
                                }
                                if (child.maskingChanged) {
                                    num_updated_props++;
                                    property_type_stream.push(3);
                                    property_index_stream.push(properties_stream_int.length);
                                    properties_stream_int.push(child.masks.length);
                                    for (var _i = 0, _a = child.masks; _i < _a.length; _i++) {
                                        var val = _a[_i];
                                        properties_stream_int.push(val);
                                    }
                                }
                                if (placeObjectTag != null && placeObjectTag.flags & 64 /* HasClipDepth */) {
                                    num_updated_props++;
                                    property_type_stream.push(200);
                                    property_index_stream.push(0);
                                }
                                if (placeObjectTag != null && placeObjectTag.flags & 256 /* HasFilterList */) { }
                                if (placeObjectTag != null && placeObjectTag.flags & 8192 /* HasVisible */) {
                                    num_updated_props++;
                                    property_type_stream.push(6);
                                    property_index_stream.push(placeObjectTag.visibility ? 1 : 0);
                                }
                                if (num_updated_props > 0) {
                                    updateCnt++;
                                    update_child_stream.push(child.sessionID);
                                    update_child_props_indices_stream.push(childStartIdx);
                                    update_child_props_length_stream.push(num_updated_props);
                                }
                            }
                            if (updateCnt > 0) {
                                command_recipe_flag |= 0x08;
                                command_length_stream.push(command_cnt);
                                command_index_stream.push(start_index);
                            }
                        }
                        var command_cnt = cmds_startSounds.length;
                        if (command_cnt) {
                            command_recipe_flag |= 16;
                            start_index = add_sounds_stream.length;
                            //console.log("startsound", tag.soundId, tag.soundInfo, awaySymbol);
                            for (var cmd = 0; cmd < command_cnt; cmd++) {
                                add_sounds_stream.push(cmds_startSounds[cmd]);
                                //console.log("add", cmds_add[cmd].childID , cmds_add[cmd].depth);
                            }
                            command_length_stream.push(command_cnt);
                            command_index_stream.push(start_index);
                            noTimelineDebug || console.log("				cmds_startSounds", cmds_startSounds.length, cmds_startSounds);
                        }
                    }
                    else {
                        //console.log("empty frame");
                    }
                    if (frame_recipe.length == 0) {
                        command_recipe_flag |= 0x01;
                    }
                    frame_recipe.push(command_recipe_flag);
                }
            }
            var buttonFrameNames = ["_up", "_over", "_down", "_hit"];
            if (framesLen == 4) {
                var isButtonFrames = 0;
                for (i = 0; i < framesLen; i++) {
                    if (swfFrames[i].labelNames && swfFrames[i].labelNames.length > 0 && swfFrames[i].labelNames[0] == buttonFrameNames[i]) {
                        isButtonFrames++;
                    }
                }
                if (isButtonFrames == 4) {
                    isButton = true;
                }
            }
            awayTimeline.numKeyFrames = keyFrameCount;
            awayTimeline.keyframe_durations = new Uint32Array(keyframe_durations);
            awayTimeline.frame_command_indices = new Uint32Array(frame_command_indices);
            awayTimeline.frame_recipe = new Uint32Array(frame_recipe);
            awayTimeline.command_length_stream = new Uint32Array(command_length_stream);
            awayTimeline.command_index_stream = new Uint32Array(command_index_stream);
            awayTimeline.add_child_stream = new Uint32Array(add_child_stream);
            awayTimeline.add_sounds_stream = new Uint32Array(add_sounds_stream);
            awayTimeline.remove_child_stream = new Uint32Array(remove_child_stream);
            awayTimeline.update_child_stream = new Uint32Array(update_child_stream);
            awayTimeline.update_child_props_indices_stream = new Uint32Array(update_child_props_indices_stream);
            awayTimeline.update_child_props_length_stream = new Uint32Array(update_child_props_length_stream);
            awayTimeline.property_type_stream = new Uint32Array(property_type_stream);
            awayTimeline.property_index_stream = new Uint32Array(property_index_stream);
            awayTimeline.properties_stream_int = new Uint32Array(properties_stream_int);
            awayTimeline.properties_stream_f32_mtx_scale_rot = new Float32Array(properties_stream_f32_mtx_scale_rot);
            awayTimeline.properties_stream_f32_mtx_pos = new Float32Array(properties_stream_f32_mtx_pos);
            awayTimeline.properties_stream_f32_mtx_all = new Float32Array(properties_stream_f32_mtx_all);
            awayTimeline.properties_stream_f32_ct = new Float32Array(properties_stream_f32_ct);
            awayTimeline.properties_stream_strings = properties_stream_strings;
            awayTimeline.init();
            if (isButton) {
                // this is a button - set ButtonActions and also get the hitArea from the last frame
                awayMc.buttonMode = true;
                awayTimeline.isButton = true;
                if (buttonActions) {
                    awayTimeline.avm1ButtonActions = buttonActions;
                }
                awayTimeline.extractHitArea(awayMc);
            }
            else {
                awayMc.mouseEnabled = false; //a movieclip that isn't a button automatically defaults to mouesEnabled = false
            }
            return awayMc;
        };
        SWFParser.prototype._pStartParsing = function (frameLimit) {
            //console.log("SWFParser - _pStartParsing");
            //create a content object for Loaders
            this._pContent = this._factory.createDisplayObjectContainer();
            _super.prototype._pStartParsing.call(this, frameLimit);
        };
        SWFParser.prototype.dispose = function () {
            this.swfData = null;
            this._dataStream = null;
        };
        SWFParser.prototype.updateTimers = function (type) {
        };
        //--SWF stuff : ---------------------------------------------------------------------------
        SWFParser.prototype.initSWFLoading = function (initialBytes, length) {
            // TODO: cleanly abort loading/parsing instead of just asserting here.
            assert(initialBytes[0] === 67 || initialBytes[0] === 70 || initialBytes[0] === 90, "Unsupported compression format: " + initialBytes[0]);
            assert(initialBytes[1] === 87);
            assert(initialBytes[2] === 83);
            assert(initialBytes.length >= 30, "At least the header must be complete here.");
            /*if (!release && SWF.traceLevel.value > 0) {
              console.log('Create SWFFile');
            }*/
            this._swfFile.bytesTotal = length;
            this._swfFile.frames = [];
            this.abcBlocks = [];
            this.dictionary = [];
            this.fonts = [];
            this.symbolClassesMap = [];
            this.symbolClassesList = [];
            this.eagerlyParsedSymbolsMap = [];
            this.eagerlyParsedSymbolsList = [];
            this._jpegTables = null;
            this._currentFrameLabels = [];
            this._currentSoundStreamHead = null;
            this._currentSoundStreamBlock = null;
            this._currentControlTags = null;
            this._currentActionBlocks = null;
            this._currentInitActionBlocks = null;
            this._currentExports = null;
            this._endTagEncountered = false;
            this.readHeaderAndInitialize(initialBytes);
        };
        SWFParser.prototype.finishLoading = function () {
            if (this._swfFile.compression !== CompressionMethod.None) {
                this._decompressor.close();
                this._decompressor = null;
                this.scanLoadedData();
            }
        };
        SWFParser.prototype.getSymbol = function (id) {
            //console.log("getSymbol", id);
            if (this.eagerlyParsedSymbolsMap[id]) {
                return this.eagerlyParsedSymbolsMap[id];
            }
            var unparsed = this.dictionary[id];
            if (!unparsed) {
                return null;
            }
            var symbol;
            if (unparsed.tagCode === 39 /* CODE_DEFINE_SPRITE */) {
                // TODO: replace this whole silly `type` business with tagCode checking.
                symbol = this.parseSpriteTimeline(unparsed);
            }
            else {
                symbol = this.getParsedTag(unparsed);
            }
            symbol.className = this.symbolClassesMap[id] || null;
            symbol.env = this.env;
            return symbol;
        };
        SWFParser.prototype.getParsedTag = function (unparsed) {
            ////SWF.enterTimeline('Parse tag ' + getSwfTagCodeName(unparsed.tagCode));
            //console.log("getParsedTag", unparsed);
            this._dataStream.align();
            this._dataStream.pos = unparsed.byteOffset;
            var handler = tagHandlers[unparsed.tagCode];
            //  release || Debug.assert(handler, 'handler shall exists here');
            var tagEnd = Math.min(unparsed.byteOffset + unparsed.byteLength, this._dataStream.end);
            var tag = handler(this._dataStream, this._swfFile.swfVersion, unparsed.tagCode, tagEnd, this._jpegTables);
            tag.fileURL = this._iFileName;
            var finalPos = this._dataStream.pos;
            if (finalPos !== tagEnd) {
                this.emitTagSlopWarning(unparsed, tagEnd);
            }
            var symbol = defineSymbol(tag, this.dictionary, this);
            //SWF.leaveTimeline();
            return symbol;
        };
        SWFParser.prototype.readHeaderAndInitialize = function (initialBytes) {
            ////SWF.enterTimeline('Initialize SWFFile');
            var isDeflateCompressed = initialBytes[0] === 67;
            var isLzmaCompressed = initialBytes[0] === 90;
            if (isDeflateCompressed) {
                this._swfFile.compression = CompressionMethod.Deflate;
            }
            else if (isLzmaCompressed) {
                this._swfFile.compression = CompressionMethod.LZMA;
            }
            this._swfFile.swfVersion = initialBytes[3];
            if (this._swfFile.swfVersion != 6) {
                //console.log("WARNING: SWF VERSION IS NOT 6", this._swfFile.swfVersion)
            }
            this._loadStarted = Date.now();
            this._uncompressedLength = readSWFLength(initialBytes);
            this._swfFile.bytesLoaded = initialBytes.length;
            // In some malformed SWFs, the parsed length in the header doesn't exactly match the actual size of the file. For
            // uncompressed files it seems to be safer to make the buffer large enough from the beginning to fit the entire
            // file than having to resize it later or risking an exception when reading out of bounds.
            this.swfData = new Uint8Array(this._swfFile.compression === CompressionMethod.None ?
                this._swfFile.bytesTotal : this._uncompressedLength);
            this._dataStream = new Stream(this.swfData.buffer);
            this._dataStream.pos = 8;
            this._dataView = this._dataStream.view;
            if (isDeflateCompressed) {
                //console.log("readHeaderAndInitialize isDeflateCompressed");
                this.swfData.set(initialBytes.subarray(0, 8));
                this._uncompressedLoadedLength = 8;
                this._decompressor = Inflate.create(true);
                // Parts of the header are compressed. Get those out of the way before starting tag parsing.
                this._decompressor.onData = this.processFirstBatchOfDecompressedData.bind(this);
                this._decompressor.onError = function (error$$1) {
                    // TODO: Let the loader handle this error.
                    throw new Error(error$$1);
                };
                this._decompressor.push(initialBytes.subarray(8));
            }
            else if (isLzmaCompressed) {
                //console.log("readHeaderAndInitialize isLzmaCompressed");
                this.swfData.set(initialBytes.subarray(0, 8));
                this._uncompressedLoadedLength = 8;
                this._decompressor = new LzmaDecoder(true);
                this._decompressor.onData = this.processFirstBatchOfDecompressedData.bind(this);
                this._decompressor.onError = function (error$$1) {
                    // TODO: Let the loader handle this error.
                    //console.log('Invalid LZMA stream: ' + error);
                };
                this._decompressor.push(initialBytes);
            }
            else {
                //console.log("readHeaderAndInitialize isUncompressed");
                this.swfData.set(initialBytes);
                this._uncompressedLoadedLength = initialBytes.length;
                this._decompressor = null;
                this.parseHeaderContents();
            }
            ////SWF.leaveTimeline();
            this._lastScanPosition = this._dataStream.pos;
            this.scanLoadedData();
        };
        SWFParser.prototype.parseHeaderContents = function () {
            var obj = parseHeader(this._dataStream);
            this._swfFile.bounds = this._swfFile.bounds = obj.bounds;
            this._swfFile.frameRate = this._swfFile.frameRate = obj.frameRate;
            this._swfFile.frameCount = this._swfFile.frameCount = obj.frameCount;
            //var str = String.fromCharCode.apply(null, data);
            //console.log(obj);
            //console.log("parseHeaderContents this._swfFile.bounds", this._swfFile.bounds);
            //console.log("parseHeaderContents this._swfFile.frameRate", this._swfFile.frameRate);
            //console.log("parseHeaderContents this._swfFile.frameCount", this._swfFile.frameCount);
        };
        SWFParser.prototype.processFirstBatchOfDecompressedData = function (data) {
            this.processDecompressedData(data);
            this.parseHeaderContents();
            this._decompressor.onData = this.processDecompressedData.bind(this);
        };
        SWFParser.prototype.processDecompressedData = function (data) {
            // Make sure we don't cause an exception here when trying to set out-of-bound data by clamping the number of bytes
            // to write to the remaining space in our buffer. If this is the case, we probably got a wrong file length from
            // the SWF header. The Flash Player ignores data that goes over that given length, so should we.
            var length = Math.min(data.length, this._uncompressedLength - this._uncompressedLoadedLength);
            memCopy(this.swfData, data, this._uncompressedLoadedLength, 0, length);
            this._uncompressedLoadedLength += length;
        };
        SWFParser.prototype.scanLoadedData = function () {
            //SWF.enterTimeline('Scan loaded SWF file tags');
            this._dataStream.pos = this._lastScanPosition;
            this.scanTagsToOffset(this._uncompressedLoadedLength, true);
            this._lastScanPosition = this._dataStream.pos;
            //SWF.leaveTimeline();
        };
        SWFParser.prototype.scanTagsToOffset = function (endOffset, rootTimelineMode) {
            // `parsePos` is always at the start of a tag at this point, because it only gets updated
            // when a tag has been fully parsed.
            var tempTag = new UnparsedTag(0, 0, 0);
            var pos;
            while ((pos = this._dataStream.pos) < endOffset - 1) {
                //console.log("scanTagsToOffset", tempTag);
                if (!this.parseNextTagHeader(tempTag)) {
                    break;
                }
                if (tempTag.tagCode === 0 /* CODE_END */) {
                    if (rootTimelineMode) {
                        this._endTagEncountered = true;
                    }
                    return;
                }
                var tagEnd = tempTag.byteOffset + tempTag.byteLength;
                if (tagEnd > endOffset) {
                    this._dataStream.pos = pos;
                    return;
                }
                this.scanTag(tempTag, rootTimelineMode);
                if (this._dataStream.pos !== tagEnd) {
                    this.emitTagSlopWarning(tempTag, tagEnd);
                }
            }
        };
        /**
         * Parses tag header information at the current seek offset and stores it in the given object.
         *
         * Public so it can be used by tools to parse through entire SWFs.
         */
        SWFParser.prototype.parseNextTagHeader = function (target) {
            var position = this._dataStream.pos;
            var tagCodeAndLength = this._dataView.getUint16(position, true);
            position += 2;
            target.tagCode = tagCodeAndLength >> 6;
            var tagLength = tagCodeAndLength & 0x3f;
            var extendedLength = tagLength === 0x3f;
            if (extendedLength) {
                if (position + 4 > this._uncompressedLoadedLength) {
                    return false;
                }
                tagLength = this._dataView.getUint32(position, true);
                position += 4;
            }
            this._dataStream.pos = position;
            target.byteOffset = position;
            target.byteLength = tagLength;
            return true;
        };
        SWFParser.prototype.Utf8ArrayToStr = function (array) {
            var out, i, len, c;
            var char2, char3;
            out = "";
            len = array.length;
            i = 0;
            while (i < len) {
                c = array[i++];
                switch (c >> 4) {
                    case 0:
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                    case 6:
                    case 7:
                        // 0xxxxxxx
                        out += String.fromCharCode(c);
                        break;
                    case 12:
                    case 13:
                        // 110x xxxx   10xx xxxx
                        char2 = array[i++];
                        out += String.fromCharCode(((c & 0x1F) << 6) | (char2 & 0x3F));
                        break;
                    case 14:
                        // 1110 xxxx  10xx xxxx  10xx xxxx
                        char2 = array[i++];
                        char3 = array[i++];
                        out += String.fromCharCode(((c & 0x0F) << 12) |
                            ((char2 & 0x3F) << 6) |
                            ((char3 & 0x3F) << 0));
                        break;
                }
            }
            return out;
        };
        SWFParser.prototype.scanTag = function (tag, rootTimelineMode) {
            var stream = this._dataStream;
            var byteOffset = stream.pos;
            assert(byteOffset === tag.byteOffset);
            var tagCode = tag.tagCode;
            var tagLength = tag.byteLength;
            //console.info("Scanning tag " + getSwfTagCodeName(tagCode) + " (start: " + byteOffset +  ", end: " + (byteOffset + tagLength) + ")");
            if (tagCode === 39 /* CODE_DEFINE_SPRITE */) {
                // According to Chapter 13 of the SWF format spec, no nested definition tags are
                // allowed within DefineSprite. However, they're added to the symbol dictionary
                // anyway, and some tools produce them. Notably swfmill.
                // We essentially treat them as though they came before the current sprite. That
                // should be ok because it doesn't make sense for them to rely on their parent being
                // fully defined - so they don't have to come after it -, and any control tags within
                // the parent will just pick them up the moment they're defined, just as always.
                this.addLazySymbol(tagCode, byteOffset, tagLength);
                var spriteTagEnd = byteOffset + tagLength;
                stream.pos += 4; // Jump over symbol ID and frameCount.
                this.scanTagsToOffset(spriteTagEnd, false);
                if (this._dataStream.pos !== spriteTagEnd) {
                    this.emitTagSlopWarning(tag, spriteTagEnd);
                }
                return;
            }
            if (ImageDefinitionTags[tagCode]) {
                // Images are decoded asynchronously, so we have to deal with them ahead of time to
                // ensure they're ready when used.
                var unparsed = this.addLazySymbol(tagCode, byteOffset, tagLength);
                this.decodeEmbeddedImage(unparsed);
                return;
            }
            if (tagCode === 14 /* CODE_DEFINE_SOUND */) {
                var unparsed = this.addLazySymbol(tagCode, byteOffset, tagLength);
                var definition = this.getParsedTag(unparsed);
                var symbol = new EagerlyParsedDictionaryEntry(definition.id, unparsed, 'sound', definition);
                /*if (!release && traceLevel.value > 0) {
                  var style = flagsToFontStyle(definition.bold, definition.italic);
                  console.info("Decoding embedded font " + definition.id + " with name '" + definition.name +
                      "' and style " + style, definition);
                }*/
                this.eagerlyParsedSymbolsMap[symbol.id] = symbol;
                this.eagerlyParsedSymbolsList.push(symbol);
                return;
            }
            if (FontDefinitionTags[tagCode]) {
                var unparsed = this.addLazySymbol(tagCode, byteOffset, tagLength);
                this.registerEmbeddedFont(unparsed);
                return;
            }
            if (DefinitionTags[tagCode]) {
                this.addLazySymbol(tagCode, byteOffset, tagLength);
                this.jumpToNextTag(tagLength);
                return;
            }
            if (!rootTimelineMode &&
                !(tagCode === 76 /* CODE_SYMBOL_CLASS */ || tagCode === 56 /* CODE_EXPORT_ASSETS */)) {
                this.jumpToNextTag(tagLength);
                return;
            }
            if (ControlTags[tagCode]) {
                this.addControlTag(tagCode, byteOffset, tagLength);
                return;
            }
            //console.log("tagCode", tagCode);
            switch (tagCode) {
                case 69 /* CODE_FILE_ATTRIBUTES */:
                    this.setFileAttributes(tagLength);
                    break;
                case 86 /* CODE_DEFINE_SCENE_AND_FRAME_LABEL_DATA */:
                    //console.log('CODE_DEFINE_SCENE_AND_FRAME_LABEL_DATA ');
                    this.setSceneAndFrameLabelData(tagLength);
                    break;
                case 9 /* CODE_SET_BACKGROUND_COLOR */:
                    this._swfFile.backgroundColor = this._swfFile.backgroundColor = parseRgb(this._dataStream);
                    break;
                case 8 /* CODE_JPEG_TABLES */:
                    // Only use the first JpegTables tag, ignore any following.
                    // TODO test it, swfdec is using the last one
                    if (!this._jpegTables) {
                        this._jpegTables = tagLength === 0 ?
                            new Uint8Array(0) :
                            this.swfData.subarray(stream.pos, stream.pos + tagLength - 2);
                    }
                    this.jumpToNextTag(tagLength);
                    break;
                case 82 /* CODE_DO_ABC */:
                case 72 /* CODE_DO_ABC_DEFINE */:
                    if (!this._swfFile.useAVM1) {
                        var tagEnd = byteOffset + tagLength;
                        var abcBlock = new ABCBlock();
                        if (tagCode === 82 /* CODE_DO_ABC */) {
                            abcBlock.flags = stream.readUi32();
                            abcBlock.name = stream.readString(-1);
                        }
                        else {
                            abcBlock.flags = 0;
                            abcBlock.name = "";
                        }
                        abcBlock.data = this.swfData.subarray(stream.pos, tagEnd);
                        //console.log(this.Utf8ArrayToStr(abcBlock.data));
                        this.abcBlocks.push(abcBlock);
                        stream.pos = tagEnd;
                    }
                    else {
                        this.jumpToNextTag(tagLength);
                    }
                    break;
                case 76 /* CODE_SYMBOL_CLASS */:
                    var tagEnd = byteOffset + tagLength;
                    var symbolCount = stream.readUi16();
                    // TODO: check if symbols can be reassociated after instances have been created.
                    while (symbolCount--) {
                        var symbolId = stream.readUi16();
                        var symbolClassName = stream.readString(-1);
                        /* if (!release && traceLevel.value > 0) {
                           console.log('Registering symbol class ' + symbolClassName + ' to symbol ' + symbolId);
                         }*/
                        //console.log('Registering symbol class ' + symbolClassName + ' to symbol ' + symbolId);
                        this.symbolClassesMap[symbolId] = symbolClassName;
                        this.symbolClassesList.push({ id: symbolId, className: symbolClassName });
                    }
                    // Make sure we move to end of tag even if the content is invalid.
                    stream.pos = tagEnd;
                    break;
                case 59 /* CODE_DO_INIT_ACTION */:
                    if (this._swfFile.useAVM1) {
                        var initActionBlocks = this._currentInitActionBlocks ||
                            (this._currentInitActionBlocks = []);
                        var spriteId = this._dataView.getUint16(stream.pos, true);
                        var actionsData = this.swfData.subarray(byteOffset + 2, byteOffset + tagLength);
                        initActionBlocks.push({ spriteId: spriteId, actionsData: actionsData });
                    }
                    this.jumpToNextTag(tagLength);
                    break;
                case 12 /* CODE_DO_ACTION */:
                    if (this._swfFile.useAVM1) {
                        var actionBlocks = this._currentActionBlocks || (this._currentActionBlocks = []);
                        var actionsData = this.swfData.subarray(stream.pos, stream.pos + tagLength);
                        actionBlocks.push({ actionsData: actionsData, precedence: stream.pos });
                    }
                    this.jumpToNextTag(tagLength);
                    break;
                case 18 /* CODE_SOUND_STREAM_HEAD */:
                case 45 /* CODE_SOUND_STREAM_HEAD2 */:
                    //console.warn("Timeline sound is set to streaming!");
                    var soundStreamTag = parseSoundStreamHeadTag(this._dataStream, byteOffset + tagLength);
                    this._currentSoundStreamHead = SoundStream.FromTag(soundStreamTag);
                    break;
                case 19 /* CODE_SOUND_STREAM_BLOCK */:
                    //if(!this._currentSoundStreamHead)
                    //	throw("Error when parsing CODE_SOUND_STREAM_BLOCK - a _currentSoundStreamHead must exist")
                    this._currentSoundStreamBlock = this.swfData.subarray(stream.pos, stream.pos += tagLength);
                    //this._currentSoundStreamHead.allChunks.push(this._currentSoundStreamBlock);
                    /*console.log(this._currentSoundStreamBlock.buffer);
                    console.log(this._currentSoundStreamBlock.length);
                    console.log(this._currentSoundStreamBlock.byteLength);
                    console.log(this._currentSoundStreamBlock.byteOffset);
                    console.log(this._currentSoundStreamBlock.buffer.byteLength);
                    var int16array=new Uint16Array(this._currentSoundStreamBlock.buffer, this._currentSoundStreamBlock.byteOffset, this._currentSoundStreamBlock.length);
                    console.log(int16array.buffer);
                    console.log(int16array.length);
                    console.log(int16array.byteLength);
                    console.log(int16array[0]);*/
                    break;
                case 43 /* CODE_FRAME_LABEL */:
                    var tagEnd = stream.pos + tagLength;
                    this._currentFrameLabels[this._currentFrameLabels.length] = stream.readString(-1);
                    // TODO: support SWF6+ anchors.
                    stream.pos = tagEnd;
                    break;
                case 1 /* CODE_SHOW_FRAME */:
                    this.finishFrame();
                    break;
                case 0 /* CODE_END */:
                    return;
                case 56 /* CODE_EXPORT_ASSETS */:
                    var tagEnd = stream.pos + tagLength;
                    var exportsCount = stream.readUi16();
                    var exports = this._currentExports || (this._currentExports = []);
                    while (exportsCount--) {
                        var symbolId = stream.readUi16();
                        var className = stream.readString(-1);
                        if (stream.pos > tagEnd) {
                            stream.pos = tagEnd;
                            break;
                        }
                        exports.push(new SymbolExport(symbolId, className));
                    }
                    stream.pos = tagEnd;
                    break;
                case 17 /* CODE_DEFINE_BUTTON_SOUND */:
                    var tagEnd = stream.pos + tagLength;
                    var btn_id = stream.readUi16();
                    this._buttonSounds[btn_id] = {};
                    for (var s = 0; s < 4; s++) {
                        this._buttonSounds[btn_id][s] = {};
                        this._buttonSounds[btn_id][s].id = stream.readUi16();
                        if (this._buttonSounds[btn_id][s].id != 0) {
                            this._buttonSounds[btn_id][s].info = parseSoundInfo(stream);
                        }
                    }
                    stream.pos = tagEnd;
                    break;
                case 23 /* CODE_DEFINE_BUTTON_CXFORM */:
                case 13 /* CODE_DEFINE_FONT_INFO */:
                case 62 /* CODE_DEFINE_FONT_INFO2 */:
                case 78 /* CODE_DEFINE_SCALING_GRID */:
                case 57 /* CODE_IMPORT_ASSETS */:
                case 71 /* CODE_IMPORT_ASSETS2 */:
                    //console.log('Unsupported tag encountered ' + tagCode + ': ' + getSwfTagCodeName(tagCode));
                    this.jumpToNextTag(tagLength);
                    break;
                case 77 /* CODE_METADATA */:
                    //console.log('tag encountered ' + tagCode + ': ' + getSwfTagCodeName(tagCode));
                    this.parseMetaData(tagLength);
                    break;
                // These tags should be supported at some point, but for now, we ignore them.
                case 74 /* CODE_CSM_TEXT_SETTINGS */:
                case 73 /* CODE_DEFINE_FONT_ALIGN_ZONES */:
                case 65 /* CODE_SCRIPT_LIMITS */:
                case 66 /* CODE_SET_TAB_INDEX */:
                // These tags are used by the player, but not relevant to us.
                case 58 /* CODE_ENABLE_DEBUGGER */:
                case 64 /* CODE_ENABLE_DEBUGGER2 */:
                case 63 /* CODE_DEBUG_ID */:
                case 88 /* CODE_DEFINE_FONT_NAME */:
                case 40 /* CODE_NAME_CHARACTER */:
                case 41 /* CODE_PRODUCT_INFO */:
                case 24 /* CODE_PROTECT */:
                case 25 /* CODE_PATHS_ARE_POSTSCRIPT */:
                case 93 /* CODE_TELEMETRY */:
                // These are obsolete Generator-related tags.
                case 55 /* CODE_GEN_TAG_OBJECTS */:
                case 49 /* CODE_GEN_COMMAND */:
                    //console.log('tag encountered ' + tagCode + ': ' + getSwfTagCodeName(tagCode));
                    this.jumpToNextTag(tagLength);
                    break;
                // These tags aren't used in the player.
                case 51 /* CODE_CHARACTER_SET */:
                case 44 /* CODE_DEFINE_BEHAVIOUR */:
                case 50 /* CODE_DEFINE_COMMAND_OBJECT */:
                case 53 /* CODE_DEFINE_FUNCTION */:
                case 42 /* CODE_DEFINE_TEXT_FORMAT */:
                case 38 /* CODE_DEFINE_VIDEO */:
                case 52 /* CODE_EXTERNAL_FONT */:
                case 3 /* CODE_FREE_CHARACTER */:
                case 31 /* CODE_FREE_ALL */:
                case 47 /* CODE_GENERATE_FRAME */:
                case 16 /* CODE_STOP_SOUND */:
                case 29 /* CODE_SYNC_FRAME */:
                    //console.info("Ignored tag (these shouldn't occur) " + tagCode + ': ' + getSwfTagCodeName(tagCode));
                    this.jumpToNextTag(tagLength);
                    break;
                default:
                    if (tagCode > 100) {
                        console.log("Encountered undefined tag " + tagCode + ", probably used for AVM1 " +
                            "obfuscation. See http://ijs.mtasa.com/files/swfdecrypt.cpp.");
                    }
                    else {
                        console.log('Tag not handled by the parser: ' + tagCode + ': ' + getSwfTagCodeName(tagCode));
                    }
                    this.jumpToNextTag(tagLength);
            }
        };
        SWFParser.prototype.parseSpriteTimeline = function (spriteTag) {
            //SWF.enterTimeline("parseSpriteTimeline");
            //console.log("parseSpriteTimeline", spriteTag);
            var data = this.swfData;
            var stream = this._dataStream;
            var dataView = this._dataView;
            var timeline = {
                id: spriteTag.id,
                type: 'sprite',
                frames: []
            };
            var spriteTagEnd = spriteTag.byteOffset + spriteTag.byteLength;
            var frames = timeline.frames;
            var labels = [];
            var controlTags = [];
            var soundStreamHead = null;
            var soundStreamBlock = null;
            var actionBlocks = null;
            var initActionBlocks = null;
            // Skip ID.
            stream.pos = spriteTag.byteOffset + 2;
            // TODO: check if numFrames or the real number of ShowFrame tags wins. (Probably the former.)
            timeline.frameCount = dataView.getUint16(stream.pos, true);
            stream.pos += 2;
            var spriteContentTag = new UnparsedTag(0, 0, 0);
            while (stream.pos < spriteTagEnd) {
                this.parseNextTagHeader(spriteContentTag);
                var tagLength = spriteContentTag.byteLength;
                var tagCode = spriteContentTag.tagCode;
                if (stream.pos + tagLength > spriteTagEnd) {
                    console.log("DefineSprite child tags exceed DefineSprite tag length and are dropped");
                    break;
                }
                if (ControlTags[tagCode]) {
                    controlTags.push(new UnparsedTag(tagCode, stream.pos, tagLength));
                    stream.pos += tagLength;
                    continue;
                }
                switch (tagCode) {
                    case 12 /* CODE_DO_ACTION */:
                        if (this._swfFile.useAVM1) {
                            if (!actionBlocks) {
                                actionBlocks = [];
                            }
                            var actionsData = data.subarray(stream.pos, stream.pos + tagLength);
                            actionBlocks.push({ actionsData: actionsData, precedence: stream.pos });
                        }
                        break;
                    case 59 /* CODE_DO_INIT_ACTION */:
                        if (this._swfFile.useAVM1) {
                            if (!initActionBlocks) {
                                initActionBlocks = [];
                            }
                            var spriteId = dataView.getUint16(stream.pos, true);
                            stream.pos += 2;
                            var actionsData = data.subarray(stream.pos, stream.pos + tagLength);
                            initActionBlocks.push({ spriteId: spriteId, actionsData: actionsData });
                        }
                        break;
                    case 43 /* CODE_FRAME_LABEL */:
                        var tagEnd = stream.pos + tagLength;
                        labels[labels.length] = stream.readString(-1);
                        // TODO: support SWF6+ anchors.
                        stream.pos = tagEnd;
                        tagLength = 0;
                        break;
                    case 1 /* CODE_SHOW_FRAME */:
                        frames.push(new SWFFrame(controlTags, labels.concat(), soundStreamHead, soundStreamBlock, actionBlocks, initActionBlocks, null));
                        labels.length = 0;
                        controlTags = [];
                        soundStreamHead = null;
                        soundStreamBlock = null;
                        actionBlocks = null;
                        initActionBlocks = null;
                        break;
                    case 0 /* CODE_END */:
                        stream.pos = spriteTagEnd;
                        tagLength = 0;
                        break;
                    case 18 /* CODE_SOUND_STREAM_HEAD */:
                    case 45 /* CODE_SOUND_STREAM_HEAD2 */:
                        //console.warn("Timeline sound is set to streaming!");
                        var tagStart = stream.pos;
                        var tagEnd = stream.pos + tagLength;
                        var soundStreamTag = parseSoundStreamHeadTag(stream, tagEnd);
                        soundStreamHead = SoundStream.FromTag(soundStreamTag);
                        stream.pos = tagStart;
                        break;
                    case 19 /* CODE_SOUND_STREAM_BLOCK */:
                        var tagStart = stream.pos;
                        var tagEnd = stream.pos + tagLength;
                        //if(!this._currentSoundStreamHead)
                        //	throw("Error when parsing CODE_SOUND_STREAM_BLOCK - a _currentSoundStreamHead must exist")
                        soundStreamBlock = this.swfData.subarray(stream.pos, tagEnd);
                        stream.pos = tagStart;
                        break;
                    default:
                        //console.log("ignored timeline tag", tagCode);
                        break; //console.log("ignored timeline tag", tagCode);
                    // Ignore other tags.
                }
                stream.pos += tagLength;
                assert(stream.pos <= spriteTagEnd);
            }
            //awayMC.timeline.
            //SWF.leaveTimeline();
            return timeline;
        };
        SWFParser.prototype.parseMetaData = function (currentTagLength) {
            //var string=this._dataStream.readString(currentTagLength);
            this._dataStream.pos += currentTagLength;
        };
        SWFParser.prototype.jumpToNextTag = function (currentTagLength) {
            this._dataStream.pos += currentTagLength;
        };
        SWFParser.prototype.emitTagSlopWarning = function (tag, tagEnd) {
            var consumedBytes = this._dataStream.pos - tag.byteOffset;
            //console.log('Scanning ' + getSwfTagCodeName(tag.tagCode) + ' at offset ' + tag.byteOffset +' consumed ' + consumedBytes + ' of ' + tag.byteLength + ' bytes. (' +(tag.byteLength - consumedBytes) + ' left)');
            this._dataStream.pos = tagEnd;
        };
        SWFParser.prototype.finishFrame = function () {
            if (this.pendingUpdateDelays === 0) {
                this._swfFile.framesLoaded++;
            }
            this._swfFile.frames.push(new SWFFrame(this._currentControlTags, this._currentFrameLabels.concat(), this._currentSoundStreamHead, this._currentSoundStreamBlock, this._currentActionBlocks, this._currentInitActionBlocks, this._currentExports));
            this._currentFrameLabels.length = 0;
            this._currentControlTags = null;
            this._currentSoundStreamHead = null;
            this._currentSoundStreamBlock = null;
            this._currentActionBlocks = null;
            this._currentInitActionBlocks = null;
            this._currentExports = null;
        };
        SWFParser.prototype.setFileAttributes = function (tagLength) {
            // TODO: check what happens to attributes tags that aren't the first tag.
            if (this._swfFile.attributes) {
                this.jumpToNextTag(tagLength);
            }
            var bits = this.swfData[this._dataStream.pos];
            this._dataStream.pos += 4;
            this._swfFile.attributes = {
                network: bits & 0x1,
                relativeUrls: bits & 0x2,
                noCrossDomainCaching: bits & 0x4,
                doAbc: bits & 0x8,
                hasMetadata: bits & 0x10,
                useGpu: bits & 0x20,
                useDirectBlit: bits & 0x40
            };
            this._swfFile.useAVM1 = !this._swfFile.attributes.doAbc;
            //console.log("use AVM1: ", this._swfFile.useAVM1)
        };
        SWFParser.prototype.setSceneAndFrameLabelData = function (tagLength) {
            if (this._swfFile.sceneAndFrameLabelData) {
                this.jumpToNextTag(tagLength);
                return;
            }
            this._swfFile.sceneAndFrameLabelData = this._swfFile.sceneAndFrameLabelData = parseDefineSceneTag(this._dataStream, 86 /* CODE_DEFINE_SCENE_AND_FRAME_LABEL_DATA */);
        };
        SWFParser.prototype.addControlTag = function (tagCode, byteOffset, tagLength) {
            var controlTags = this._currentControlTags || (this._currentControlTags = []);
            controlTags.push(new UnparsedTag(tagCode, byteOffset, tagLength));
            this.jumpToNextTag(tagLength);
        };
        SWFParser.prototype.addLazySymbol = function (tagCode, byteOffset, tagLength) {
            var id = this._dataView.getUint16(this._dataStream.pos, true);
            var symbol = new DictionaryEntry(id, tagCode, byteOffset, tagLength);
            this.dictionary[id] = symbol;
            /*if (!release && traceLevel.value > 0) {
              console.info("Registering symbol " + id + " of type " + getSwfTagCodeName(tagCode));
            }*/
            return symbol;
        };
        SWFParser.prototype.decodeEmbeddedFont = function (unparsed) {
            var definition = this.getParsedTag(unparsed);
            var symbol = new EagerlyParsedDictionaryEntry(definition.id, unparsed, 'font', definition);
            /*if (!release && traceLevel.value > 0) {
              var style = flagsToFontStyle(definition.bold, definition.italic);
              console.info("Decoding embedded font " + definition.id + " with name '" + definition.name +
                  "' and style " + style, definition);
            }*/
            this.eagerlyParsedSymbolsMap[symbol.id] = symbol;
            this.eagerlyParsedSymbolsList.push(symbol);
            var style = flagsToFontStyle(definition.bold, definition.italic);
            this.fonts.push({ name: definition.name, id: definition.id, style: style });
        };
        SWFParser.prototype.registerEmbeddedFont = function (unparsed) {
            /*  if (!inFirefox) {
                this.decodeEmbeddedFont(unparsed);
                return;
              }*/
            var stream = this._dataStream;
            var id = this._dataView.getUint16(stream.pos, true);
            var style;
            var name;
            // DefineFont only specifies a symbol ID, no font name or style.
            if (unparsed.tagCode === 10 /* CODE_DEFINE_FONT */) {
                // Assigning some unique name to simplify font registration and look ups.
                name = '__autofont__' + unparsed.byteOffset;
                style = 'regular';
            }
            else {
                var flags = this.swfData[stream.pos + 2];
                style = flagsToFontStyle(!!(flags & 0x1), !!(flags & 0x2));
                var nameLength = this.swfData[stream.pos + 4];
                // Skip language code.
                stream.pos += 5;
                name = stream.readString(nameLength);
            }
            this.fonts.push({ name: name, id: id, style: style });
            /*  if (!release && traceLevel.value > 0) {
                console.info("Registering embedded font " + id + " with name '" + name + "' and style " +
                    style);
              }*/
            stream.pos = unparsed.byteOffset + unparsed.byteLength;
        };
        SWFParser.prototype.decodeEmbeddedImage = function (unparsed) {
            var definition = this.getParsedTag(unparsed);
            var symbol = new EagerlyParsedDictionaryEntry(definition.id, unparsed, 'image', definition);
            /*if (!release && traceLevel.value > 0) {
               console.info("Decoding embedded image " + definition.id + " of type " +
                   getSwfTagCodeName(unparsed.tagCode) + " (start: " + unparsed.byteOffset +
                   ", end: " + (unparsed.byteOffset + unparsed.byteLength) + ")");
             }*/
            this.eagerlyParsedSymbolsMap[symbol.id] = symbol;
            this.eagerlyParsedSymbolsList.push(symbol);
        };
        return SWFParser;
    }(ParserBase));
    function flagsToFontStyle(bold, italic) {
        if (bold && italic) {
            return 'boldItalic';
        }
        if (bold) {
            return 'bold';
        }
        if (italic) {
            return 'italic';
        }
        return 'regular';
    }
    function readSWFLength(bytes) {
        // We read the length manually because creating a DataView just for that is silly.
        return (bytes[4] | bytes[5] << 8 | bytes[6] << 16 | bytes[7] << 24) >>> 0;
    }
    function defineSymbol(swfTag, symbols, parser) {
        switch (swfTag.code) {
            case 6 /* CODE_DEFINE_BITS */:
            case 21 /* CODE_DEFINE_BITS_JPEG2 */:
            case 35 /* CODE_DEFINE_BITS_JPEG3 */:
            case 90 /* CODE_DEFINE_BITS_JPEG4 */:
                return defineImage(swfTag);
            case 20 /* CODE_DEFINE_BITS_LOSSLESS */:
            case 36 /* CODE_DEFINE_BITS_LOSSLESS2 */:
                return defineBitmap(swfTag);
            case 7 /* CODE_DEFINE_BUTTON */:
            case 34 /* CODE_DEFINE_BUTTON2 */:
                return defineButton(swfTag, symbols);
            case 37 /* CODE_DEFINE_EDIT_TEXT */:
                return defineText(swfTag);
            case 10 /* CODE_DEFINE_FONT */:
            case 48 /* CODE_DEFINE_FONT2 */:
            case 75 /* CODE_DEFINE_FONT3 */:
            case 91 /* CODE_DEFINE_FONT4 */:
                return defineFont(swfTag, parser._iFileName);
            case 46 /* CODE_DEFINE_MORPH_SHAPE */:
            case 84 /* CODE_DEFINE_MORPH_SHAPE2 */:
            case 2 /* CODE_DEFINE_SHAPE */:
            case 22 /* CODE_DEFINE_SHAPE2 */:
            case 32 /* CODE_DEFINE_SHAPE3 */:
            case 83 /* CODE_DEFINE_SHAPE4 */:
                return defineShape(swfTag, parser);
            case 14 /* CODE_DEFINE_SOUND */:
                return defineSound(swfTag);
            case 60 /* CODE_DEFINE_VIDEO_STREAM */:
                return {
                    type: 'video',
                    id: swfTag.id,
                    width: swfTag.width,
                    height: swfTag.height,
                    deblocking: swfTag.deblocking,
                    smoothing: swfTag.smoothing,
                    codec: swfTag.codecId
                };
            case 39 /* CODE_DEFINE_SPRITE */:
                // Sprites are fully defined at this point.
                return swfTag;
            case 87 /* CODE_DEFINE_BINARY_DATA */:
                return {
                    type: 'binary',
                    id: swfTag.id,
                    data: swfTag.data
                };
            case 11 /* CODE_DEFINE_TEXT */:
            case 33 /* CODE_DEFINE_TEXT2 */:
                return defineLabel(swfTag);
            default:
                //console.log("define default symbol", swfTag, symbols, parser);
                return swfTag;
        }
    }

    var AVM1PropertyDescriptor = /** @class */ (function () {
        function AVM1PropertyDescriptor(flags, value, get, set, watcher) {
            this.flags = flags;
            this.value = value;
            this.get = get;
            this.set = set;
            this.watcher = watcher;
            // Empty block
        }
        return AVM1PropertyDescriptor;
    }());

    /**
     * Base class for object instances we prefer to not inherit Object.prototype properties.
     */
    var NullPrototypeObject = /** @class */ (function () {
        function NullPrototypeObject() {
        }
        return NullPrototypeObject;
    }());
    var DEBUG_PROPERTY_PREFIX = '$Bg';
    /**
     * Base class for the ActionScript AVM1 object.
     */
    var AVM1Object = /** @class */ (function (_super) {
        __extends(AVM1Object, _super);
        function AVM1Object(avm1Context) {
            var _this = _super.call(this) || this;
            _this.initialDepth = 0;
            _this.scriptRefsToChilds = {};
            _this._avm1Context = avm1Context;
            _this._ownProperties = Object.create(null);
            _this.scriptRefsToChilds = {};
            _this._prototype = null;
            _this._blockedByScript = false;
            _this._ctBlockedByScript = false;
            _this._visibilityByScript = false;
            var self = _this;
            // Using IAVM1Callable here to avoid circular calls between AVM1Object and
            // AVM1Function during constructions.
            // TODO do we need to support __proto__ for all SWF versions?
            var getter = { alCall: function (thisArg, args) { return self.alPrototype; } };
            var setter = { alCall: function (thisArg, args) { self.alPrototype = args[0]; } };
            var desc = new AVM1PropertyDescriptor(128 /* ACCESSOR */ |
                2 /* DONT_DELETE */ |
                1 /* DONT_ENUM */, null, getter, setter);
            _this.alSetOwnProperty('__proto__', desc);
            return _this;
        }
        Object.defineProperty(AVM1Object.prototype, "eventObserver", {
            get: function () {
                return this._eventObserver;
            },
            set: function (value) {
                this._eventObserver = value;
            },
            enumerable: true,
            configurable: true
        });
        AVM1Object.prototype.dispose = function () {
        };
        AVM1Object.prototype.isBlockedByScript = function () {
            return this._blockedByScript;
        };
        AVM1Object.prototype.isColorTransformByScript = function () {
            return this._ctBlockedByScript;
        };
        AVM1Object.prototype.isVisibilityByScript = function () {
            return this._visibilityByScript;
        };
        AVM1Object.prototype.initAdapter = function () {
        };
        AVM1Object.prototype.freeFromScript = function () {
            this.protoTypeChanged = false;
            this._blockedByScript = false;
            this._ctBlockedByScript = false;
            this._visibilityByScript = false;
        };
        AVM1Object.prototype.clone = function () {
            var newAVM1Object = new AVM1Object(this._avm1Context);
            return newAVM1Object;
        };
        Object.defineProperty(AVM1Object.prototype, "context", {
            get: function () {
                return this._avm1Context;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVM1Object.prototype, "alPrototype", {
            get: function () {
                return this._prototype;
            },
            set: function (v) {
                // checking for circular references
                var p = v;
                while (p) {
                    if (p === this) {
                        return; // possible loop in __proto__ chain is found
                    }
                    p = p.alPrototype;
                }
                // TODO recursive chain check
                this._prototype = v;
            },
            enumerable: true,
            configurable: true
        });
        AVM1Object.prototype.alGetPrototypeProperty = function () {
            return this.alGet('prototype');
        };
        // TODO shall we add mode for readonly/native flags of the prototype property?
        AVM1Object.prototype.alSetOwnPrototypeProperty = function (v) {
            this.alSetOwnProperty('prototype', new AVM1PropertyDescriptor(64 /* DATA */ |
                1 /* DONT_ENUM */, v));
        };
        AVM1Object.prototype.alGetConstructorProperty = function () {
            return this.alGet('__constructor__');
        };
        AVM1Object.prototype.alSetOwnConstructorProperty = function (v) {
            this.alSetOwnProperty('__constructor__', new AVM1PropertyDescriptor(64 /* DATA */ |
                1 /* DONT_ENUM */, v));
        };
        AVM1Object.prototype._debugEscapeProperty = function (p) {
            var context = this.context;
            var name = alToString(context, p);
            if (!context.isPropertyCaseSensitive) {
                name = name.toLowerCase();
            }
            return DEBUG_PROPERTY_PREFIX + name;
        };
        AVM1Object.prototype.alGetOwnProperty = function (name) {
            if (typeof name === 'string' && !this.context.isPropertyCaseSensitive) {
                name = name.toLowerCase();
            }
            release$1 || Debug$1.assert(alIsName(this.context, name));
            // TODO __resolve
            return this._ownProperties[name];
        };
        AVM1Object.prototype.alSetOwnProperty = function (p, desc) {
            var name = this.context.normalizeName(p);
            if (!desc.originalName && !this.context.isPropertyCaseSensitive) {
                desc.originalName = p;
            }
            if (!release$1) {
                Debug$1.assert(desc instanceof AVM1PropertyDescriptor);
                // Ensure that a descriptor isn't used multiple times. If it were, we couldn't update
                // values in-place.
                Debug$1.assert(!desc['owningObject'] || desc['owningObject'] === this);
                desc['owningObject'] = this;
                // adding data property on the main object for convenience of debugging.
                if ((desc.flags & 64 /* DATA */) &&
                    !(desc.flags & 1 /* DONT_ENUM */)) {
                    Object.defineProperty(this, this._debugEscapeProperty(name), { value: desc.value, enumerable: true, configurable: true });
                }
            }
            this._ownProperties[name] = desc;
        };
        AVM1Object.prototype.alHasOwnProperty = function (p) {
            var name = this.context.normalizeName(p);
            return !!this._ownProperties[name];
        };
        AVM1Object.prototype.alDeleteOwnProperty = function (p) {
            var name = this.context.normalizeName(p);
            delete this._ownProperties[name];
            if (!release$1) {
                delete this[this._debugEscapeProperty(p)];
            }
        };
        AVM1Object.prototype.deleteOwnProperties = function () {
            var allProps = this.alGetOwnPropertiesKeys();
            for (var i = 0; i < allProps.length; i++) {
                this.alDeleteOwnProperty(allProps[i]);
            }
        };
        AVM1Object.prototype.alGetOwnPropertiesKeys = function () {
            var keys = [];
            var desc;
            if (!this.context.isPropertyCaseSensitive) {
                for (var name in this._ownProperties) {
                    desc = this._ownProperties[name];
                    release$1 || Debug$1.assert("originalName" in desc);
                    if (!(desc.flags & 1 /* DONT_ENUM */)) {
                        keys.push(desc.originalName);
                    }
                }
            }
            else {
                for (var name in this._ownProperties) {
                    desc = this._ownProperties[name];
                    if (!(desc.flags & 1 /* DONT_ENUM */)) {
                        keys.push(name);
                    }
                }
            }
            return keys;
        };
        AVM1Object.prototype.alGetProperty = function (p) {
            var desc = this.alGetOwnProperty(p);
            if (desc) {
                return desc;
            }
            if (!this._prototype) {
                return undefined;
            }
            return this._prototype.alGetProperty(p);
        };
        AVM1Object.prototype.alGet = function (p) {
            var name = this.context.normalizeName(p);
            var desc = this.alGetProperty(name);
            if (!desc) {
                return undefined;
            }
            if ((desc.flags & 64 /* DATA */)) {
                if (desc.value && desc.value.adaptee && desc.value.adaptee instanceof DisplayObject && !desc.value.adaptee.parent) {
                    return undefined;
                }
                return desc.value;
            }
            release$1 || Debug$1.assert((desc.flags & 128 /* ACCESSOR */));
            var getter = desc.get;
            if (!getter) {
                return undefined;
            }
            var value = getter.alCall(this);
            if (value && value.adaptee && value.adaptee instanceof DisplayObject && !value.adaptee.parent) {
                return undefined;
            }
            return value;
        };
        AVM1Object.prototype.alCanPut = function (p) {
            var desc = this.alGetOwnProperty(p);
            if (desc) {
                if ((desc.flags & 128 /* ACCESSOR */)) {
                    return !!desc.set;
                }
                else {
                    return !(desc.flags & 4 /* READ_ONLY */);
                }
            }
            var proto = this._prototype;
            if (!proto) {
                return true;
            }
            return proto.alCanPut(p);
        };
        AVM1Object.prototype.alPut = function (p, v) {
            // Perform all lookups with the canonicalized name, but keep the original name around to
            // pass it to `alSetOwnProperty`, which stores it on the descriptor.
            var originalName = p;
            p = this.context.normalizeName(p);
            //  stupid hack to make sure we can update references to objects in cases when the timeline changes the objects 
            //  if a new object is registered for the same name, we can use the "scriptRefsToChilds" to update all references to the old object with the new one
            if (v && typeof v === "object" && v.avmType === "symbol" && p != "this" && p != "_parent" && !v.dynamicallyCreated) {
                if (v.adaptee && v.adaptee.parent && v.adaptee.parent.adapter && v.adaptee.parent.adapter.scriptRefsToChilds) {
                    v.adaptee.parent.adapter.scriptRefsToChilds[v.adaptee.name] = { obj: this, name: p };
                }
            }
            if (!this.alCanPut(p)) {
                return;
            }
            var ownDesc = this.alGetOwnProperty(p);
            if (ownDesc && (ownDesc.flags & 64 /* DATA */)) {
                if (ownDesc.watcher) {
                    v = ownDesc.watcher.callback.alCall(this, [ownDesc.watcher.name, ownDesc.value, v, ownDesc.watcher.userData]);
                }
                // Real properties (i.e., not things like "_root" on MovieClips) can be updated in-place.
                if (p in this._ownProperties) {
                    ownDesc.value = v;
                }
                else {
                    this.alSetOwnProperty(originalName, new AVM1PropertyDescriptor(ownDesc.flags, v));
                }
                return;
            }
            if (typeof v === "undefined" && (p == "_x" || p == "_y" || p == "_xscale" || p == "_yscale" || p == "_width" || p == "_height")) {
                // certain props do not allow their value to be set to "undefined", so we exit here
                // todo: there might be more props that do not allow "undefined"
                return;
            }
            var desc = this.alGetProperty(p);
            if (desc && (desc.flags & 128 /* ACCESSOR */)) {
                if (desc.watcher) {
                    var oldValue = desc.get ? desc.get.alCall(this) : undefined;
                    v = desc.watcher.callback.alCall(this, [desc.watcher.name, oldValue, v, desc.watcher.userData]);
                }
                var setter = desc.set;
                release$1 || Debug$1.assert(setter);
                setter.alCall(this, [v]);
            }
            else {
                if (desc && desc.watcher) {
                    release$1 || Debug$1.assert(desc.flags & 64 /* DATA */);
                    v = desc.watcher.callback.alCall(this, [desc.watcher.name, desc.value, v, desc.watcher.userData]);
                }
                var newDesc = new AVM1PropertyDescriptor(desc ? desc.flags : 64 /* DATA */, v);
                this.alSetOwnProperty(originalName, newDesc);
            }
        };
        AVM1Object.prototype.alHasProperty = function (p) {
            var desc = this.alGetProperty(p);
            return !!desc;
        };
        AVM1Object.prototype.alDeleteProperty = function (p) {
            var desc = this.alGetOwnProperty(p);
            if (!desc) {
                return true;
            }
            if ((desc.flags & 2 /* DONT_DELETE */)) {
                return false;
            }
            this.alDeleteOwnProperty(p);
            return true;
        };
        AVM1Object.prototype.alAddPropertyWatcher = function (p, callback, userData) {
            // TODO verify/test this functionality to match ActionScript
            var desc = this.alGetProperty(p);
            if (!desc) {
                return false;
            }
            desc.watcher = {
                name: p,
                callback: callback,
                userData: userData
            };
            return true;
        };
        AVM1Object.prototype.alRemotePropertyWatcher = function (p) {
            var desc = this.alGetProperty(p);
            if (!desc || !desc.watcher) {
                return false;
            }
            desc.watcher = undefined;
            return true;
        };
        AVM1Object.prototype.alDefaultValue = function (hint) {
            if (hint === void 0) { hint = 0 /* NUMBER */; }
            if (hint === 1 /* STRING */) {
                var toString = this.alGet(this.context.normalizeName('toString'));
                if (alIsFunction(toString)) {
                    var str = toString.alCall(this);
                    return str;
                }
                var valueOf = this.alGet(this.context.normalizeName('valueOf'));
                if (alIsFunction(valueOf)) {
                    var val = valueOf.alCall(this);
                    return val;
                }
            }
            else {
                release$1 || Debug$1.assert(hint === 0 /* NUMBER */);
                var valueOf = this.alGet(this.context.normalizeName('valueOf'));
                if (alIsFunction(valueOf)) {
                    var val = valueOf.alCall(this);
                    return val;
                }
                var toString = this.alGet(this.context.normalizeName('toString'));
                if (alIsFunction(toString)) {
                    var str = toString.alCall(this);
                    return str;
                }
            }
            // TODO is this a default?
            return this;
        };
        AVM1Object.prototype.alGetKeys = function () {
            var ownKeys = this.alGetOwnPropertiesKeys();
            var proto = this._prototype;
            if (!proto) {
                return ownKeys;
            }
            var otherKeys = proto.alGetKeys();
            if (ownKeys.length === 0) {
                return otherKeys;
            }
            // Merging two keys sets
            // TODO check if we shall worry about __proto__ usage here
            var context = this.context;
            var k;
            // If the context is case-insensitive, names only differing in their casing overwrite each
            // other. Iterating over the keys returns the first original, case-preserved key that was
            // ever used for the property, though.
            if (!context.isPropertyCaseSensitive) {
                var keyLists = [ownKeys, otherKeys];
                var canonicalKeysMap = Object.create(null);
                var keys = [];
                var keyList;
                var key;
                var canonicalKey;
                for (k = 0; k < keyLists.length; k++) {
                    keyList = keyLists[k];
                    for (var i = keyList.length; i--;) {
                        key = keyList[i];
                        canonicalKey = context.normalizeName(key);
                        if (canonicalKeysMap[canonicalKey]) {
                            continue;
                        }
                        canonicalKeysMap[canonicalKey] = true;
                        keys.push(key);
                    }
                }
                return keys;
            }
            else {
                var processed = Object.create(null);
                var keyLength = ownKeys.length;
                for (k = 0; k < keyLength; k++) {
                    processed[ownKeys[k]] = true;
                }
                var keyLength = otherKeys.length;
                for (k = 0; k < keyLength; k++) {
                    processed[otherKeys[k]] = true;
                }
                return Object.getOwnPropertyNames(processed);
            }
        };
        return AVM1Object;
    }(NullPrototypeObject));

    /**
     * Base class for ActionsScript functions.
     */
    var AVM1Function = /** @class */ (function (_super) {
        __extends(AVM1Function, _super);
        function AVM1Function(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Function.alGetPrototypeProperty();
            _this.isOnEnter = false;
            return _this;
        }
        AVM1Function.prototype.alConstruct = function (args) {
            throw new Error('not implemented AVM1Function.alConstruct');
        };
        AVM1Function.prototype.alCall = function (thisArg, args) {
            throw new Error('not implemented AVM1Function.alCall');
        };
        /**
         * Wraps the function to the callable JavaScript function.
         * @returns {Function} a JavaScript function.
         */
        AVM1Function.prototype.toJSFunction = function (thisArg) {
            if (thisArg === void 0) { thisArg = null; }
            var fn = this;
            var context = this.context;
            return function () {
                var args = Array.prototype.slice.call(arguments, 0);
                return context.executeFunction(fn, thisArg, args);
            };
        };
        return AVM1Function;
    }(AVM1Object));

    var AVM1EventHandler = /** @class */ (function () {
        function AVM1EventHandler(propertyName, eventName, stageEvent, allowDisable, isMouse, isButton) {
            this.propertyName = propertyName;
            this.eventName = eventName;
            this.stageEvent = stageEvent;
            this.allowDisable = allowDisable;
            this.isMouse = isMouse;
            this.isButton = isButton;
        }
        return AVM1EventHandler;
    }());
    var AVM1EventProps = /** @class */ (function () {
        function AVM1EventProps() {
        }
        return AVM1EventProps;
    }());
    /**
     * Key codes below 32 aren't interpreted as char codes, but are mapped to specific buttons instead.
     * This array uses the key code as the index and KeyboardEvent.keyCode values matching the
     * specific keys as the value.
     * @type {number[]}
     */
    var AVM1KeyCodeMap = [-1, 37, 39, 36, 35, 45, 46, -1, 8, -1, -1, -1, -1, 13, 38, 40, 33, 34, 9, 27];
    var ClipEventMappings = Object.create(null);
    ClipEventMappings[262144 /* Construct */] = true;
    ClipEventMappings[512 /* Initialize */] = true;
    ClipEventMappings[131072 /* KeyPress */] = new AVM1EventHandler('onKey', KeyboardEvent.KEYDOWN, true, true, false, false);
    ClipEventMappings[1 /* Load */] = new AVM1EventHandler('onLoad', 'load', false, false, false, false);
    ClipEventMappings[4 /* Unload */] = new AVM1EventHandler('onUnload', 'unload', false, false, false, false), ClipEventMappings[256 /* Data */] = new AVM1EventHandler('onData', 'data', false, false, false, false), ClipEventMappings[2 /* EnterFrame */] = new AVM1EventHandler('onEnterFrame', 'enterFrame', false, false, false, false), ClipEventMappings[64 /* KeyDown */] = new AVM1EventHandler('onKeyDown', KeyboardEvent.KEYDOWN, true, true, false, false);
    ClipEventMappings[128 /* KeyUp */] = new AVM1EventHandler('onKeyUp', KeyboardEvent.KEYUP, true, true, false, false);
    ClipEventMappings[8 /* MouseMove */] = new AVM1EventHandler('onMouseMove', MouseEvent.MOUSE_MOVE, true, true, true, false);
    ClipEventMappings[16 /* MouseDown */] = new AVM1EventHandler('onMouseDown', MouseEvent.MOUSE_DOWN, true, true, true, false);
    ClipEventMappings[32 /* MouseUp */] = new AVM1EventHandler('onMouseUp', MouseEvent.MOUSE_UP, true, true, true, false);
    ClipEventMappings[1024 /* Press */] = new AVM1EventHandler('onPress', MouseEvent.MOUSE_DOWN, false, true, true, true);
    ClipEventMappings[2048 /* Release */] = new AVM1EventHandler('onRelease', MouseEvent.MOUSE_UP, false, true, true, true);
    ClipEventMappings[4096 /* ReleaseOutside */] = new AVM1EventHandler('onReleaseOutside', MouseEvent.MOUSE_UP_OUTSIDE, false, true, true, true);
    ClipEventMappings[8192 /* RollOver */] = new AVM1EventHandler('onRollOver', MouseEvent.MOUSE_OVER, false, true, true, true);
    ClipEventMappings[16384 /* RollOut */] = new AVM1EventHandler('onRollOut', MouseEvent.MOUSE_OUT, false, true, true, true);
    ClipEventMappings[32768 /* DragOver */] = new AVM1EventHandler('onDragOver', MouseEvent.DRAG_OVER, false, true, true, true);
    ClipEventMappings[65536 /* DragOut */] = new AVM1EventHandler('onDragOut', MouseEvent.DRAG_OUT, false, true, true, true);
    var setFocusEventMapping = new AVM1EventHandler('onSetFocus', FocusEvent.FOCUS_IN, false, true, false, false);
    var unFocusEventMapping = new AVM1EventHandler('onKillFocus', FocusEvent.FOCUS_OUT, false, true, false, false);
    var onChangedEventMapping = new AVM1EventHandler('onChanged', TextfieldEvent.CHANGED, false, true, false, false);
    var EventsListForMC = [
        ClipEventMappings[1 /* Load */],
        ClipEventMappings[4 /* Unload */],
        ClipEventMappings[256 /* Data */],
        ClipEventMappings[2 /* EnterFrame */],
        ClipEventMappings[64 /* KeyDown */],
        ClipEventMappings[128 /* KeyUp */],
        ClipEventMappings[8 /* MouseMove */],
        ClipEventMappings[16 /* MouseDown */],
        ClipEventMappings[32 /* MouseUp */],
        ClipEventMappings[1024 /* Press */],
        ClipEventMappings[2048 /* Release */],
        ClipEventMappings[4096 /* ReleaseOutside */],
        ClipEventMappings[8192 /* RollOver */],
        ClipEventMappings[16384 /* RollOut */],
        ClipEventMappings[32768 /* DragOver */],
        ClipEventMappings[65536 /* DragOut */],
        ClipEventMappings[131072 /* KeyPress */],
        setFocusEventMapping,
        unFocusEventMapping,
        onChangedEventMapping
    ];
    var EventsListForButton = [
        ClipEventMappings[1 /* Load */],
        ClipEventMappings[4 /* Unload */],
        ClipEventMappings[256 /* Data */],
        ClipEventMappings[2 /* EnterFrame */],
        ClipEventMappings[64 /* KeyDown */],
        ClipEventMappings[128 /* KeyUp */],
        ClipEventMappings[1024 /* Press */],
        ClipEventMappings[2048 /* Release */],
        ClipEventMappings[4096 /* ReleaseOutside */],
        ClipEventMappings[8192 /* RollOver */],
        ClipEventMappings[16384 /* RollOut */],
        ClipEventMappings[32768 /* DragOver */],
        ClipEventMappings[65536 /* DragOut */],
        ClipEventMappings[131072 /* KeyPress */],
        setFocusEventMapping,
        unFocusEventMapping,
        onChangedEventMapping
    ];

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var DEPTH_OFFSET = 16384;
    /**
     * Checks if an object contains a reference to a native AS3 object.
     * Returns false for MovieClip instances or instances of constructors with
     * MovieClip on their prototype chain that were created in script using,
     * e.g. new MovieClip(). Those lack the part of their internal structure
     * that makes them displayable.
     */
    function hasAwayJSAdaptee(obj) {
        return !!obj.adaptee;
    }
    /**
     * Returns obj's reference to a native AS3 object. If the reference
     * does not exist, returns undefined.
     */
    function getAwayJSAdaptee(obj) {
        return obj.adaptee;
    }
    /**
     * Returns obj's reference to a native AS3 object. If the reference
     * doesn't exist, obj was created in script, e.g. with new MovieClip(),
     * and doesn't reflect a real, displayable display object. In that case,
     * an empty null-proto object is created and returned. This is used for
     * classes that are linked to embedded symbols that extend MovieClip. Their
     * inheritance chain is built by assigning new MovieClip to their prototype.
     * When a proper, displayable, instance of such a class is created via
     * attachMovie, initial values for properties such as tabEnabled
     * can be initialized from values set on the template object.
     */
    function getAwayObjectOrTemplate(obj) {
        if (obj.adaptee) {
            return obj.adaptee;
        }
        // The _as3ObjectTemplate is not really an ASObject type, but we will fake
        // that for AVM1SymbolBase's properties transfers.
        if (!obj._as3ObjectTemplate) {
            var template;
            var proto = obj.alPrototype;
            while (proto && !proto.initAVM1SymbolInstance) {
                template = proto._as3ObjectTemplate;
                if (template) {
                    break;
                }
                proto = proto.alPrototype;
            }
            obj._as3ObjectTemplate = Object.create(template || null);
        }
        return obj._as3ObjectTemplate;
    }
    var BlendModesMap = [undefined, "normal", "layer", "multiply",
        "screen", "lighten", "darken", "difference", "add", "subtract", "invert",
        "alpha", "erase", "overlay", "hardlight"];
    function avm1HasEventProperty(context, target, propertyName) {
        if (target.alHasProperty(propertyName) &&
            (target.alGet(propertyName) instanceof AVM1Function)) {
            return true;
        }
        if (target.alHasProperty(propertyName) &&
            (target._ownProperties[propertyName] && target._ownProperties[propertyName].value)) {
            return true;
        }
        var listenersField = target.alGet('_listeners');
        if (!(listenersField instanceof AVM1ArrayNative)) {
            return false;
        }
        var listeners = listenersField.value;
        return listeners.some(function (listener) {
            return (listener instanceof AVM1Object) && listener.alHasProperty(propertyName);
        });
    }
    function avm1BroadcastNativeEvent(context, target, propertyName, args) {
        if (args === void 0) { args = null; }
        //console.log("avm1BroadcastNativeEvent", propertyName)
        var handler = target.alGet(propertyName);
        if (handler instanceof AVM1Function) {
            if (propertyName.toLowerCase() == "onenterframe")
                handler.isOnEnter = true;
            context.executeFunction(handler, target, args);
        }
        var _listeners = target.alGet('_listeners');
        if (_listeners instanceof AVM1ArrayNative) {
            var handlerOnListener = null;
            _listeners.value.forEach(function (listener) {
                if (!(listener instanceof AVM1Object)) {
                    return;
                }
                handlerOnListener = listener.alGet(propertyName);
                if (handlerOnListener instanceof AVM1Function) {
                    context.executeFunction(handlerOnListener, target, args);
                }
            });
        }
    }
    function avm1BroadcastEvent(context, target, propertyName, args) {
        if (args === void 0) { args = null; }
        var handler = target.alGet(propertyName);
        if (handler instanceof AVM1Function) {
            handler.alCall(target, args);
        }
        var _listeners = target.alGet('_listeners');
        if (_listeners instanceof AVM1ArrayNative) {
            var handlerOnListener = null;
            _listeners.value.forEach(function (listener) {
                if (!(listener instanceof AVM1Object)) {
                    return;
                }
                handlerOnListener = listener.alGet(propertyName);
                if (handlerOnListener instanceof AVM1Function) {
                    handlerOnListener.alCall(target, args);
                }
            });
        }
    }
    var myCount = 0;
    function createAVM1NativeObject(ctor, nativeObject, context) {
        // We need to walk on __proto__ to find right ctor.prototype.
        var template;
        var proto = ctor.alGetPrototypeProperty();
        while (proto && !proto.initAVM1SymbolInstance) {
            if (proto._as3ObjectTemplate && !template) {
                template = proto._as3ObjectTemplate;
            }
            proto = proto.alPrototype;
        }
        release$1 || Debug$1.assert(proto);
        var avm1Object = Object.create(proto);
        proto.initAVM1SymbolInstance.call(avm1Object, context, nativeObject);
        avm1Object.alPrototype = ctor.alGetPrototypeProperty();
        avm1Object.alSetOwnConstructorProperty(ctor);
        nativeObject._as2Object = avm1Object;
        ctor.alCall(avm1Object);
        avm1Object.aCount = myCount++;
        //	80pro: creating a new _ownProperties
        //  makes sure that newly added properties are added to instance, not to prototype
        //avm1Object._ownProperties={};
        //avm1Object._ownProperties = Object.create(null);
        if (template) {
            // transfer properties from the template
            for (var prop in template) {
                nativeObject[prop] = template[prop];
            }
        }
        return avm1Object;
    }
    function getAVM1Object(awayObject, context) {
        if (!awayObject) {
            return null;
        }
        if (awayObject._as2Object) {
            return awayObject._as2Object;
        }
        var avmObject;
        if (awayObject.isAsset(MovieClip)) {
            if (awayObject.timeline.isButton) {
                avmObject = createAVM1NativeObject(context.globals.Button, awayObject, context);
            }
            else {
                avmObject = createAVM1NativeObject(context.globals.MovieClip, awayObject, context);
            }
        }
        else if (awayObject.isAsset(TextField)) {
            avmObject = createAVM1NativeObject(context.globals.TextField, awayObject, context);
        }
        if (avmObject) {
            awayObject._as2Object = avmObject;
            awayObject.adapter = avmObject;
            avmObject.adaptee = awayObject;
        }
        awayObject._as2Object = avmObject;
        return avmObject;
    }
    function wrapAVM1NativeMembers(context, wrap, obj, members, prefixFunctions) {
        if (prefixFunctions === void 0) { prefixFunctions = false; }
        function wrapFunction(fn) {
            if (isNullOrUndefined$1(fn)) {
                return undefined;
            }
            release$1 || Debug$1.assert(typeof fn === 'function');
            if (!prefixFunctions) {
                return new AVM1NativeFunction(context, fn);
            }
            return new AVM1NativeFunction(context, function () {
                var args = Array.prototype.slice.call(arguments, 0);
                args.unshift(context);
                return fn.apply(this, args);
            });
        }
        function getMemberDescriptor(memberName) {
            var desc;
            for (var p = obj; p; p = Object.getPrototypeOf(p)) {
                desc = Object.getOwnPropertyDescriptor(p, memberName);
                if (desc) {
                    return desc;
                }
            }
            return null;
        }
        if (!members) {
            return;
        }
        members.forEach(function (memberName) {
            if (memberName[memberName.length - 1] === '#') {
                // Property mapping
                var getterName = 'get' + memberName[0].toUpperCase() + memberName.slice(1, -1);
                var getter = obj[getterName];
                var setterName = 'set' + memberName[0].toUpperCase() + memberName.slice(1, -1);
                var setter = obj[setterName];
                release$1 || Debug$1.assert(getter || setter, 'define getter or setter');
                var desc = new AVM1PropertyDescriptor(128 /* ACCESSOR */ |
                    2 /* DONT_DELETE */ |
                    1 /* DONT_ENUM */, null, wrapFunction(getter), wrapFunction(setter));
                wrap.alSetOwnProperty(memberName.slice(0, -1), desc);
                return;
            }
            var nativeDesc = getMemberDescriptor(memberName);
            if (!nativeDesc) {
                return;
            }
            if (nativeDesc.get || nativeDesc.set) {
                release$1 || Debug$1.assert(false, 'Redefine ' + memberName + ' property getter/setter as functions');
                return;
            }
            var value = nativeDesc.value;
            if (typeof value === 'function') {
                value = wrapFunction(value);
            }
            var desc = new AVM1PropertyDescriptor(64 /* DATA */ |
                2 /* DONT_DELETE */ |
                1 /* DONT_ENUM */, value);
            wrap.alSetOwnProperty(memberName, desc);
        });
    }
    function wrapAVM1NativeClass(context, wrapAsFunction, cls, staticMembers, members, call, cstr) {
        var wrappedFn = wrapAsFunction ?
            new AVM1NativeFunction(context, call || function () { }, function () {
                // Creating simple AVM1 object
                var obj = new cls(context);
                obj.alPrototype = wrappedPrototype;
                obj.alSetOwnConstructorProperty(wrappedFn);
                if (cstr) {
                    cstr.apply(obj, arguments);
                }
                return obj;
            }) :
            new AVM1Object(context);
        wrapAVM1NativeMembers(context, wrappedFn, cls, staticMembers, true);
        var wrappedPrototype = new cls(context);
        wrappedPrototype.alPrototype = context.builtins.Object.alGetPrototypeProperty();
        wrapAVM1NativeMembers(context, wrappedPrototype, cls.prototype, members, false);
        alDefineObjectProperties(wrappedFn, {
            prototype: {
                value: wrappedPrototype
            }
        });
        alDefineObjectProperties(wrappedPrototype, {
            constructor: {
                value: wrappedFn,
                writable: true
            }
        });
        return wrappedFn;
    }
    function initializeAVM1Object(awayObject, context, placeObjectTag) {
        var instanceAVM1 = getAVM1Object(awayObject, context);
        release$1 || Debug$1.assert(instanceAVM1);
        if (placeObjectTag.variableName) {
            instanceAVM1.alPut('variable', placeObjectTag.variableName);
        }
        var events = placeObjectTag.events;
        if (!events) {
            return;
        }
        var swfEvent;
        var actionsData;
        var handler;
        var flags;
        var eventFlag;
        var eventMapping;
        var eventName;
        var eventProps = null;
        for (var j = 0; j < events.length; j++) {
            swfEvent = events[j];
            if (swfEvent.actionsBlock) {
                actionsData = context.actionsDataFactory.createActionsData(swfEvent.actionsBlock, 's' + placeObjectTag.symbolId + 'd' + placeObjectTag.depth + 'e' + j);
                swfEvent.actionsBlock = null;
                swfEvent.compiled = actionsData;
            }
            else {
                actionsData = swfEvent.compiled;
            }
            release$1 || Debug$1.assert(actionsData);
            handler = clipEventHandler.bind(null, actionsData, instanceAVM1);
            flags = swfEvent.flags;
            for (var key in ClipEventMappings) {
                eventFlag = parseInt(key);
                eventFlag |= 0;
                if (!(flags & (eventFlag | 0))) {
                    continue;
                }
                if (eventFlag == 262144 /* Construct */ || eventFlag == 512 /* Initialize */) {
                    handler();
                    continue;
                }
                if (eventFlag == 1 /* Load */) {
                    awayObject.onLoaded = handler;
                    continue;
                }
                eventMapping = ClipEventMappings[eventFlag];
                eventName = eventMapping.eventName;
                //console.log("eventName", eventName, eventMapping, eventFlag, swfEvent);
                if (!eventName) {
                    Debug$1.warning("ClipEvent: " + eventFlag + ' not implemented');
                    continue;
                }
                if (swfEvent.keyCode) {
                    eventProps = new AVM1EventProps();
                    eventProps.keyCode = swfEvent.keyCode;
                    if (swfEvent.keyCode < 32 && AVM1KeyCodeMap[swfEvent.keyCode])
                        eventProps.keyCode = AVM1KeyCodeMap[swfEvent.keyCode];
                }
                instanceAVM1._addOnClipEventListener(eventMapping, handler, eventProps);
            }
        }
    }
    function toTwipFloor(value) {
        // in theory this should do:
        //return Math.round(value*20)/20;
        // because AwayJS does not use big.js internally, floats might have this nasty rounding error
        // we need to floor twips, and add a additional twip in case it had the floating error
        var twip = Math.floor(value * 20) / 20;
        if (value > twip && (value - twip) > 0.04995) {
            twip += 0.05;
        }
        return twip;
    }
    function toTwipRound(value) {
        return Math.round(value * 20) / 20;
    }
    function avm2AwayDepth(value) {
        return value + 1;
    }
    function away2avmDepth(value) {
        return value - 1;
    }
    function clipEventHandler(actionsData, receiver) {
        return receiver.context.executeActions(actionsData, receiver);
    }

    /**
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function toAS3Point(v) {
        var context = v.context;
        var x, y;
        if (v instanceof AVM1Object) {
            x = alCoerceNumber(context, v.alGet('x'));
            y = alCoerceNumber(context, v.alGet('y'));
        }
        return new Point(x, y);
    }
    function copyAS3PointTo(p, v) {
        v.alPut('x', p.x);
        v.alPut('y', p.y);
    }
    var AVM1Point = /** @class */ (function (_super) {
        __extends(AVM1Point, _super);
        function AVM1Point(context, x, y) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.globals.Point.alGetPrototypeProperty();
            _this.alPut('x', x);
            _this.alPut('y', y);
            return _this;
        }
        AVM1Point.fromAS3Point = function (context, p) {
            return new AVM1Point(context, p.x, p.y);
        };
        return AVM1Point;
    }(AVM1Object));
    var AVM1PointFunction = /** @class */ (function (_super) {
        __extends(AVM1PointFunction, _super);
        function AVM1PointFunction(context) {
            var _this = _super.call(this, context) || this;
            alDefineObjectProperties(_this, {
                prototype: {
                    value: new AVM1PointPrototype(context, _this)
                },
                distance: {
                    value: _this.distance,
                    writable: true
                },
                interpolate: {
                    value: _this.interpolate,
                    writable: true
                },
                polar: {
                    value: _this.polar,
                    writable: true
                }
            });
            return _this;
        }
        AVM1PointFunction.prototype.alConstruct = function (args) {
            if (args && args.length > 0) {
                return new AVM1Point(this.context, args[0], args[1]);
            }
            else {
                return new AVM1Point(this.context, 0, 0);
            }
        };
        AVM1PointFunction.prototype.distance = function (pt1, pt2) {
            return Point.distance(toAS3Point(pt1), toAS3Point(pt2));
        };
        AVM1PointFunction.prototype.interpolate = function (pt1, pt2, f) {
            f = alToNumber(this.context, f);
            var p = Point.interpolate(toAS3Point(pt1), toAS3Point(pt2), f);
            return AVM1Point.fromAS3Point(this.context, p);
        };
        AVM1PointFunction.prototype.polar = function (len, angle) {
            len = alToNumber(this.context, len);
            angle = alToNumber(this.context, angle);
            return AVM1Point.fromAS3Point(this.context, Point.polar(len, angle));
        };
        return AVM1PointFunction;
    }(AVM1Function));
    var AVM1PointPrototype = /** @class */ (function (_super) {
        __extends(AVM1PointPrototype, _super);
        function AVM1PointPrototype(context, fn) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                constructor: {
                    value: fn,
                    writable: true
                },
                length: {
                    get: _this.getLength
                },
                add: {
                    value: _this.add,
                    writable: true
                },
                clone: {
                    value: _this.clone,
                    writable: true
                },
                equals: {
                    value: _this.equals,
                    writable: true
                },
                normalize: {
                    value: _this.normalize,
                    writable: true
                },
                offset: {
                    value: _this.offset,
                    writable: true
                },
                subtract: {
                    value: _this.subtract,
                    writable: true
                },
                toString: {
                    value: _this._toString,
                    writable: true
                }
            });
            return _this;
        }
        AVM1PointPrototype.prototype.getLength = function () {
            return toAS3Point(this).length;
        };
        AVM1PointPrototype.prototype.add = function (v) {
            return AVM1Point.fromAS3Point(this.context, toAS3Point(this).add(toAS3Point(v)));
        };
        AVM1PointPrototype.prototype.clone = function () {
            var result = new AVM1Point(this.context);
            if (this instanceof AVM1Object) {
                result.alPut('x', this.alGet('x'));
                result.alPut('y', this.alGet('y'));
            }
            return result;
        };
        AVM1PointPrototype.prototype.equals = function (toCompare) {
            return toAS3Point(this).equals(toAS3Point(toCompare));
        };
        AVM1PointPrototype.prototype.normalize = function (length) {
            length = alToNumber(this.context, length);
            var p = toAS3Point(this);
            p.normalize(length);
            copyAS3PointTo(p, this);
        };
        AVM1PointPrototype.prototype.offset = function (dx, dy) {
            dx = alToNumber(this.context, dx);
            dy = alToNumber(this.context, dy);
            var p = toAS3Point(this);
            p.offset(dx, dy);
            copyAS3PointTo(p, this);
        };
        AVM1PointPrototype.prototype.subtract = function (v) {
            return AVM1Point.fromAS3Point(this.context, toAS3Point(this).subtract(toAS3Point(v)));
        };
        AVM1PointPrototype.prototype._toString = function () {
            return '(x=' + this.alGet('x') + ', y=' + this.alGet('y') + ')';
        };
        return AVM1PointPrototype;
    }(AVM1Object));

    /**
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function toAS3Rectangle(v) {
        var context = v.context;
        var x, y, width, height;
        if (v instanceof AVM1Object) {
            x = alCoerceNumber(context, v.alGet('x'));
            y = alCoerceNumber(context, v.alGet('y'));
            width = alCoerceNumber(context, v.alGet('width'));
            height = alCoerceNumber(context, v.alGet('height'));
        }
        return new Rectangle(x, y, width, height);
    }
    function copyAS3RectangleTo(r, v) {
        v.alPut('x', r.x);
        v.alPut('y', r.y);
        v.alPut('width', r.width);
        v.alPut('height', r.height);
    }
    var AVM1Rectangle = /** @class */ (function (_super) {
        __extends(AVM1Rectangle, _super);
        function AVM1Rectangle(context, x, y, width, height) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.globals.Rectangle.alGetPrototypeProperty();
            _this.alPut('x', x);
            _this.alPut('y', y);
            _this.alPut('width', width);
            _this.alPut('height', height);
            return _this;
        }
        AVM1Rectangle.fromAS3Rectangle = function (context, r) {
            return new AVM1Rectangle(context, r.x, r.y, r.width, r.height);
        };
        return AVM1Rectangle;
    }(AVM1Object));
    var AVM1RectangleFunction = /** @class */ (function (_super) {
        __extends(AVM1RectangleFunction, _super);
        function AVM1RectangleFunction(context) {
            var _this = _super.call(this, context) || this;
            alDefineObjectProperties(_this, {
                prototype: {
                    value: new AVM1RectanglePrototype(context, _this)
                }
            });
            return _this;
        }
        AVM1RectangleFunction.prototype.alConstruct = function (args) {
            if (args && args.length > 0) {
                return new AVM1Rectangle(this.context, args[0], args[1], args[2], args[3]);
            }
            else {
                return new AVM1Rectangle(this.context, 0, 0, 0, 0);
            }
        };
        return AVM1RectangleFunction;
    }(AVM1Function));
    var AVM1RectanglePrototype = /** @class */ (function (_super) {
        __extends(AVM1RectanglePrototype, _super);
        function AVM1RectanglePrototype(context, fn) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                constructor: {
                    value: fn,
                    writable: true
                },
                bottom: {
                    get: _this.getBottom,
                    set: _this.setBottom
                },
                bottomRight: {
                    get: _this.getBottomRight,
                    set: _this.setBottomRight
                },
                left: {
                    get: _this.getLeft,
                    set: _this.setLeft
                },
                right: {
                    get: _this.getRight,
                    set: _this.setRight
                },
                size: {
                    get: _this.getSize,
                    set: _this.setSize
                },
                top: {
                    get: _this.getTop,
                    set: _this.setTop
                },
                topLeft: {
                    get: _this.getTopLeft,
                    set: _this.setTopLeft
                },
                clone: {
                    value: _this.clone,
                    writable: true
                },
                contains: {
                    value: _this.contains,
                    writable: true
                },
                containsPoint: {
                    value: _this.containsPoint,
                    writable: true
                },
                containsRectangle: {
                    value: _this.containsRectangle,
                    writable: true
                },
                equals: {
                    value: _this.equals,
                    writable: true
                },
                inflate: {
                    value: _this.inflate,
                    writable: true
                },
                inflatePoint: {
                    value: _this.inflatePoint,
                    writable: true
                },
                intersection: {
                    value: _this.intersection,
                    writable: true
                },
                intersects: {
                    value: _this.intersects,
                    writable: true
                },
                isEmpty: {
                    value: _this.isEmpty,
                    writable: true
                },
                offset: {
                    value: _this.offset,
                    writable: true
                },
                offsetPoint: {
                    value: _this.offsetPoint,
                    writable: true
                },
                setEmpty: {
                    value: _this.setEmpty,
                    writable: true
                },
                toString: {
                    value: _this._toString,
                    writable: true
                },
                union: {
                    value: _this.union,
                    writable: true
                }
            });
            return _this;
        }
        AVM1RectanglePrototype.prototype.getBottom = function () {
            return alToNumber(this.context, this.alGet('y')) + alToNumber(this.context, this.alGet('height'));
        };
        AVM1RectanglePrototype.prototype.setBottom = function (value) {
            this.alPut('height', alToNumber(this.context, value) - alToNumber(this.context, this.alGet('y')));
        };
        AVM1RectanglePrototype.prototype.getBottomRight = function () {
            return new AVM1Point(this.context, AVM1RectanglePrototype.prototype.getRight.call(this), AVM1RectanglePrototype.prototype.getBottom.call(this));
        };
        AVM1RectanglePrototype.prototype.setBottomRight = function (pt) {
            AVM1RectanglePrototype.prototype.setRight.call(this, pt.alGet('x'));
            AVM1RectanglePrototype.prototype.setBottom.call(this, pt.alGet('y'));
        };
        AVM1RectanglePrototype.prototype.getLeft = function () {
            return alToNumber(this.context, this.alGet('x'));
        };
        AVM1RectanglePrototype.prototype.setLeft = function (value) {
            this.alPut('x', alToNumber(this.context, value));
        };
        AVM1RectanglePrototype.prototype.getSize = function () {
            return new AVM1Point(this.context, this.alGet('width'), this.alGet('height'));
        };
        AVM1RectanglePrototype.prototype.setSize = function (pt) {
            this.alPut('width', pt.alGet('x'));
            this.alPut('height', pt.alGet('y'));
        };
        AVM1RectanglePrototype.prototype.getRight = function () {
            return alToNumber(this.context, this.alGet('x')) + alToNumber(this.context, this.alGet('width'));
        };
        AVM1RectanglePrototype.prototype.setRight = function (value) {
            this.alPut('width', alToNumber(this.context, value) - alToNumber(this.context, this.alGet('x')));
        };
        AVM1RectanglePrototype.prototype.getTop = function () {
            return alToNumber(this.context, this.alGet('y'));
        };
        AVM1RectanglePrototype.prototype.setTop = function (value) {
            this.alPut('y', alToNumber(this.context, value));
        };
        AVM1RectanglePrototype.prototype.getTopLeft = function () {
            return new AVM1Point(this.context, AVM1RectanglePrototype.prototype.getLeft.call(this), AVM1RectanglePrototype.prototype.getTop.call(this));
        };
        AVM1RectanglePrototype.prototype.setTopLeft = function (pt) {
            AVM1RectanglePrototype.prototype.setLeft.call(this, pt.alGet('x'));
            AVM1RectanglePrototype.prototype.setTop.call(this, pt.alGet('y'));
        };
        AVM1RectanglePrototype.prototype.clone = function () {
            var result = new AVM1Rectangle(this.context);
            if (this instanceof AVM1Object) {
                result.alPut('x', this.alGet('x'));
                result.alPut('y', this.alGet('y'));
                result.alPut('width', this.alGet('width'));
                result.alPut('height', this.alGet('height'));
            }
            return result;
        };
        AVM1RectanglePrototype.prototype.contains = function (x, y) {
            x = alToNumber(this.context, x);
            y = alToNumber(this.context, y);
            var r = toAS3Rectangle(this);
            return r.contains(x, y);
        };
        AVM1RectanglePrototype.prototype.containsPoint = function (pt) {
            var r = toAS3Rectangle(this), p = toAS3Point(pt);
            return r.containsPoint(p);
        };
        AVM1RectanglePrototype.prototype.containsRectangle = function (rect) {
            var r = toAS3Rectangle(this), other = toAS3Rectangle(rect);
            return r.containsRect(other);
        };
        AVM1RectanglePrototype.prototype.equals = function (toCompare) {
            var r = toAS3Rectangle(this), other = toAS3Rectangle(toCompare);
            return r.equals(other);
        };
        AVM1RectanglePrototype.prototype.inflate = function (dx, dy) {
            dx = alToNumber(this.context, dx);
            dy = alToNumber(this.context, dy);
            var r = toAS3Rectangle(this);
            r.inflate(dx, dy);
            copyAS3RectangleTo(r, this);
        };
        AVM1RectanglePrototype.prototype.inflatePoint = function (pt) {
            var r = toAS3Rectangle(this), p = toAS3Point(pt);
            r.inflatePoint(p);
            copyAS3RectangleTo(r, this);
        };
        AVM1RectanglePrototype.prototype.intersection = function (toIntersect) {
            var r = toAS3Rectangle(this), other = toAS3Rectangle(toIntersect);
            return AVM1Rectangle.fromAS3Rectangle(this.context, r.intersection(other));
        };
        AVM1RectanglePrototype.prototype.intersects = function (toIntersect) {
            var r = toAS3Rectangle(this), other = toAS3Rectangle(toIntersect);
            return r.intersects(other);
        };
        AVM1RectanglePrototype.prototype.isEmpty = function () {
            return toAS3Rectangle(this).isEmpty();
        };
        AVM1RectanglePrototype.prototype.offset = function (dx, dy) {
            dx = alToNumber(this.context, dx);
            dy = alToNumber(this.context, dy);
            var r = toAS3Rectangle(this);
            r.offset(dx, dy);
            copyAS3RectangleTo(r, this);
        };
        AVM1RectanglePrototype.prototype.offsetPoint = function (pt) {
            var r = toAS3Rectangle(this), p = toAS3Point(pt);
            r.offsetPoint(p);
            copyAS3RectangleTo(r, this);
        };
        AVM1RectanglePrototype.prototype.setEmpty = function () {
            this.alPut('x', 0);
            this.alPut('y', 0);
            this.alPut('width', 0);
            this.alPut('height', 0);
        };
        AVM1RectanglePrototype.prototype._toString = function () {
            return '(x=' + this.alGet('x') + ', y=' + this.alGet('y') +
                ', w=' + this.alGet('width') + ', h=' + this.alGet('height') + ')';
        };
        AVM1RectanglePrototype.prototype.union = function (toUnion) {
            var r = toAS3Rectangle(this), other = toAS3Rectangle(toUnion);
            return AVM1Rectangle.fromAS3Rectangle(this.context, r.union(other));
        };
        return AVM1RectanglePrototype;
    }(AVM1Object));

    /**
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Base class/function for all AVM1 filters.
    var AVM1BitmapFilterFunction = /** @class */ (function (_super) {
        __extends(AVM1BitmapFilterFunction, _super);
        function AVM1BitmapFilterFunction(context) {
            var _this = _super.call(this, context) || this;
            _this.alSetOwnPrototypeProperty(new AVM1BitmapFilterPrototype(context, _this));
            return _this;
        }
        AVM1BitmapFilterFunction.prototype.alConstruct = function (args) {
            var obj = new AVM1Object(this.context);
            obj.alPrototype = this.alGetPrototypeProperty();
            return obj;
        };
        return AVM1BitmapFilterFunction;
    }(AVM1Function));
    var AVM1BitmapFilterPrototype = /** @class */ (function (_super) {
        __extends(AVM1BitmapFilterPrototype, _super);
        function AVM1BitmapFilterPrototype(context, fn) {
            var _this = _super.call(this, context) || this;
            alDefineObjectProperties(_this, {
                constructor: {
                    value: fn,
                    writable: true
                },
                clone: {
                    value: _this.clone,
                    writable: true
                }
            });
            return _this;
        }
        AVM1BitmapFilterPrototype.prototype.clone = function () {
            var obj = new AVM1Object(this.context);
            obj.alPrototype = this.alGetPrototypeProperty();
            return obj;
        };
        return AVM1BitmapFilterPrototype;
    }(AVM1Object));
    // Automates creation of the AVM1 filter classes.
    function createFilterClass(context, filtersObj, base, name, fields) {
        // Simple constructor for the class function.
        function construct(args) {
            var as2Object = new AVM1Object(context);
            as2Object.alPrototype = wrappedProto;
            if (args) {
                for (var i = 0; i < args.length; i++) {
                    as2Object.alPut(fields[i << 1], args[i]);
                }
            }
            return as2Object;
        }
        function clone() {
            var as2Object = new AVM1Object(context);
            as2Object.alPrototype = wrappedProto;
            for (var i = 0; i < fields.length; i += 2) {
                as2Object.alPut(fields[i], this.alGet(fields[i]));
            }
            return as2Object;
        }
        function getAS3Class() {
            // The AS3 class name shall match
            return context.sec.flash.filters[name].axClass;
        }
        function toAS3Filter(as2Object) {
            var awayObject = getAS3Class().axConstruct([]);
            // Just copying all defined properties.
            for (var i = 0; i < fields.length; i += 2) {
                var as2Value = as2Object.alGet(fields[i]);
                if (as2Value === undefined) {
                    continue; // skipping undefined
                }
                awayObject.axSetPublicProperty(fields[i], convertToAS3Field(context, as2Value, fields[i + 1]));
            }
            return awayObject;
        }
        function fromAS3Filter(awayObject) {
            var as2Object = new AVM1Object(context);
            as2Object.alPrototype = wrappedProto;
            for (var i = 0; i < fields.length; i += 2) {
                as2Object.alPut(fields[i], convertFromAS3Field(context, awayObject.axGetPublicProperty(fields[i]), fields[i + 1]));
            }
            return as2Object;
        }
        // Creates new prototype object and function for the class.
        var proto = base.alGetPrototypeProperty();
        var wrappedProto = Object.create(AVM1BitmapFilterPrototype.prototype);
        AVM1Object.call(wrappedProto, context);
        wrappedProto.alPrototype = proto;
        var wrapped = Object.create(AVM1BitmapFilterFunction.prototype);
        AVM1Function.call(wrapped, context);
        wrapped.alSetOwnPrototypeProperty(wrappedProto);
        wrapped.alConstruct = construct;
        alDefineObjectProperties(wrappedProto, {
            constructor: {
                value: wrapped,
                writable: true
            },
            clone: {
                value: clone,
                writable: true
            }
        });
        // ... and also attaches conversion utility.
        wrappedProto.asFilterConverter = {
            toAS3Filter: toAS3Filter,
            fromAS3Filter: fromAS3Filter,
            getAS3Class: getAS3Class
        };
        filtersObj.alPut(name, wrapped);
    }
    function createFiltersClasses(context) {
        var filters = alNewObject(context);
        var base = new AVM1BitmapFilterFunction(context);
        filters.alPut('BitmapFilter', base);
        // TODO make field types non-string
        createFilterClass(context, filters, base, 'BevelFilter', ['distance', 'Number', 'angle', 'Number', 'highlightColor', 'Number',
            'highlightAlpha', 'Number', 'shadowColor', 'Number', 'shadowAlpha', 'Number',
            'blurX', 'Number', 'blurY', 'Number', 'strength', 'Number', 'quality', 'Number',
            'type', 'String', 'knockout', 'Boolean']);
        createFilterClass(context, filters, base, 'BlurFilter', ['blurX', 'Number', 'blurY', 'Number', 'quality', 'Number']);
        createFilterClass(context, filters, base, 'ColorMatrixFilter', ['matrix', 'Numbers']);
        createFilterClass(context, filters, base, 'ConvolutionFilter', ['matrixX', 'Number', 'matrixY', 'Number', 'matrix', 'Numbers',
            'divisor', 'Number', 'bias', 'Number', 'preserveAlpha', 'Boolean',
            'clamp', 'Boolean', 'color', 'Number', 'alpha', 'Number']);
        createFilterClass(context, filters, base, 'DisplacementMapFilter', ['mapBitmap', 'BitmapData', 'mapPoint', 'Point', 'componentX', 'Number',
            'componentY', 'Number', 'scaleX', 'Number', 'scaleY', 'Number',
            'mode', 'String', 'color', 'Number', 'alpha', 'Number']);
        createFilterClass(context, filters, base, 'DropShadowFilter', ['distance', 'Number', 'angle', 'Number', 'color', 'Number',
            'alpha', 'Number', 'blurX', 'Number', 'blurY', 'Number',
            'strength', 'Number', 'quality', 'Number', 'inner', 'Boolean',
            'knockout', 'Boolean', 'hideObject', 'Boolean']);
        createFilterClass(context, filters, base, 'GlowFilter', ['color', 'Number', 'alpha', 'Number', 'blurX', 'Number', 'blurY', 'Number',
            'strength', 'Number', 'quality', 'Number', 'inner', 'Boolean', 'knockout', 'Boolean']);
        createFilterClass(context, filters, base, 'GradientBevelFilter', ['distance', 'Number', 'angle', 'Number', 'colors', 'Numbers',
            'alphas', 'Numbers', 'ratios', 'Numbers', 'blurX', 'Number', 'blurY', 'Number',
            'strength', 'Number', 'quality', 'Number', 'type', 'String', 'knockout', 'Boolean']);
        createFilterClass(context, filters, base, 'GradientGlowFilter', ['distance', 'Number', 'angle', 'Number', 'colors', 'Numbers',
            'alphas', 'Numbers', 'ratios', 'Numbers', 'blurX', 'Number', 'blurY', 'Number',
            'strength', 'Number', 'quality', 'Number', 'type', 'String', 'knockout', 'Boolean']);
        return filters;
    }
    function convertToAS3Field(context, value, type) {
        switch (type) {
            case 'String':
                return alToString(context, value);
            case 'Boolean':
                return alToBoolean(context, value);
            case 'Number':
                return alToNumber(context, value);
            case 'Numbers':
                var arr = [];
                if (value) {
                    for (var i = 0, length = value.alGet('length'); i < length; i++) {
                        arr[i] = alToNumber(context, value.alGet(i));
                    }
                }
                return context.sec.createArray(arr);
            case 'BitmapData':
                return toAS3BitmapData(value);
            case 'Point':
                return toAS3Point(value);
            default:
                release$1 || Debug$1.assert(false, 'Unknown convertToAS3Field type: ' + type);
        }
    }
    function convertFromAS3Field(context, value, type) {
        switch (type) {
            case 'String':
            case 'Boolean':
            case 'Number':
                return value;
            case 'Numbers':
                var arr = [];
                if (value) {
                    for (var i = 0, length = value.value.length; i < length; i++) {
                        arr[i] = +value.value[i];
                    }
                }
                return new AVM1ArrayNative(context, arr);
            case 'BitmapData':
                return AVM1BitmapData.fromAS3BitmapData(context, value);
            case 'Point':
                return AVM1Point.fromAS3Point(context, value);
            default:
                release$1 || Debug$1.assert(false, 'Unknown convertFromAS3Field type: ' + type);
        }
    }
    function convertToAS3Filter(context, as2Filter) {
        var proto = as2Filter ? as2Filter.alPrototype : null;
        while (proto && !proto.asFilterConverter) {
            proto = proto.alPrototype;
        }
        if (proto) {
            return proto.asFilterConverter.toAS3Filter(as2Filter);
        }
        return undefined;
    }

    /**
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function defaultTo(v, defaultValue) {
        return v === undefined ? defaultValue : v;
    }
    function fromAVM1Object(v) {
        var context = v.context;
        if (!(v instanceof AVM1Object)) {
            return new AVM1ColorTransform(context, 1, 1, 1, 1, 0, 0, 0, 0);
        }
        var off_a = v.alGet('alphaOffset');
        if (off_a == null) {
            off_a = v.alGet("ab");
        }
        var mul_a = v.alGet('alphaMultiplier');
        if (mul_a == null) {
            mul_a = v.alGet("aa");
            if (mul_a != null) {
                mul_a = mul_a / 100;
            }
        }
        var off_r = v.alGet('redOffset');
        if (off_r == null) {
            off_r = v.alGet("rb");
        }
        var mul_r = v.alGet('redMultiplier');
        if (mul_r == null) {
            mul_r = v.alGet("ra");
            if (mul_r != null) {
                mul_r = mul_r / 100;
            }
        }
        var off_g = v.alGet('greenOffset');
        if (off_g == null) {
            off_g = v.alGet("gb");
        }
        var mul_g = v.alGet('greenMultiplier');
        if (mul_g == null) {
            mul_g = v.alGet("ga");
            if (mul_g != null) {
                mul_g = mul_g / 100;
            }
        }
        var off_b = v.alGet('blueOffset');
        if (off_b == null) {
            off_b = v.alGet("bb");
        }
        var mul_b = v.alGet('blueMultiplier');
        if (mul_b == null) {
            mul_b = v.alGet("ba");
            if (mul_b != null) {
                mul_b = mul_b / 100;
            }
        }
        return new AVM1ColorTransform(context, alCoerceNumber(context, defaultTo(mul_r, 1)), alCoerceNumber(context, defaultTo(mul_g, 1)), alCoerceNumber(context, defaultTo(mul_b, 1)), alCoerceNumber(context, defaultTo(mul_a, 1)), alCoerceNumber(context, defaultTo(off_r, 0)), alCoerceNumber(context, defaultTo(off_g, 0)), alCoerceNumber(context, defaultTo(off_b, 0)), alCoerceNumber(context, defaultTo(off_a, 0)));
    }
    function toAwayColorTransform(v) {
        var context = v.context;
        if (!(v instanceof AVM1ColorTransform)) {
            return new ColorTransform(1, 1, 1, 1, 0, 0, 0, 0);
        }
        return new ColorTransform(alCoerceNumber(context, defaultTo(v._rawData[0], 1)), alCoerceNumber(context, defaultTo(v._rawData[1], 1)), alCoerceNumber(context, defaultTo(v._rawData[2], 1)), alCoerceNumber(context, defaultTo(v._rawData[3], 1)), alCoerceNumber(context, defaultTo(v._rawData[4], 0)), alCoerceNumber(context, defaultTo(v._rawData[5], 0)), alCoerceNumber(context, defaultTo(v._rawData[6], 0)), alCoerceNumber(context, defaultTo(v._rawData[7], 0)));
    }
    var AVM1ColorTransform = /** @class */ (function (_super) {
        __extends(AVM1ColorTransform, _super);
        function AVM1ColorTransform(context, redMultiplier, greenMultiplier, blueMultiplier, alphaMultiplier, redOffset, greenOffset, blueOffset, alphaOffset) {
            if (redMultiplier === void 0) { redMultiplier = 1; }
            if (greenMultiplier === void 0) { greenMultiplier = 1; }
            if (blueMultiplier === void 0) { blueMultiplier = 1; }
            if (alphaMultiplier === void 0) { alphaMultiplier = 1; }
            if (redOffset === void 0) { redOffset = 0; }
            if (greenOffset === void 0) { greenOffset = 0; }
            if (blueOffset === void 0) { blueOffset = 0; }
            if (alphaOffset === void 0) { alphaOffset = 0; }
            var _this = _super.call(this, context) || this;
            _this._rawData = [redMultiplier, greenMultiplier, blueMultiplier, alphaMultiplier,
                redOffset, greenOffset, blueOffset, alphaOffset];
            _this.alPrototype = context.globals.ColorTransform.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                rgb: {
                    get: _this.getRgb,
                    set: _this.setRgb
                },
                ra: {
                    get: _this.getRM,
                    set: _this.setRM
                },
                ga: {
                    get: _this.getGM,
                    set: _this.setGM
                },
                ba: {
                    get: _this.getBM,
                    set: _this.setBM
                },
                aa: {
                    get: _this.getAM,
                    set: _this.setAM
                },
                rb: {
                    get: _this.getRO,
                    set: _this.setRO
                },
                gb: {
                    get: _this.getGO,
                    set: _this.setGO
                },
                bb: {
                    get: _this.getBO,
                    set: _this.setBO
                },
                ab: {
                    get: _this.getAO,
                    set: _this.setAO
                },
                redMultiplier: {
                    get: _this.getRedMultiplier,
                    set: _this.setRedMultiplier
                },
                greenMultiplier: {
                    get: _this.getGreenMultiplier,
                    set: _this.setGreenMultiplier
                },
                blueMultiplier: {
                    get: _this.getBlueMultiplier,
                    set: _this.setBlueMultiplier
                },
                alphaMultiplier: {
                    get: _this.getAlphaMultiplier,
                    set: _this.setAlphaMultiplier
                },
                redOffset: {
                    get: _this.getRedOffset,
                    set: _this.setRedOffset
                },
                greenOffset: {
                    get: _this.getGreenOffset,
                    set: _this.setGreenOffset
                },
                blueOffset: {
                    get: _this.getBlueOffset,
                    set: _this.setBlueOffset
                },
                alphaOffset: {
                    get: _this.getAlphaOffset,
                    set: _this.setAlphaOffset
                },
                concat: {
                    value: _this.concat,
                    writable: true
                },
                toString: {
                    value: _this._toString,
                    writable: true
                }
            });
            return _this;
        }
        AVM1ColorTransform.prototype.getRedMultiplier = function () {
            return this._rawData[0];
        };
        AVM1ColorTransform.prototype.setRedMultiplier = function (value) {
            this._rawData[0] = value;
        };
        AVM1ColorTransform.prototype.getGreenMultiplier = function () {
            return this._rawData[1];
        };
        AVM1ColorTransform.prototype.setGreenMultiplier = function (value) {
            this._rawData[1] = value;
        };
        AVM1ColorTransform.prototype.getBlueMultiplier = function () {
            return this._rawData[2];
        };
        AVM1ColorTransform.prototype.setBlueMultiplier = function (value) {
            this._rawData[2] = value;
        };
        AVM1ColorTransform.prototype.getAlphaMultiplier = function () {
            return this._rawData[3];
        };
        AVM1ColorTransform.prototype.setAlphaMultiplier = function (value) {
            this._rawData[3] = value;
        };
        AVM1ColorTransform.prototype.getRedOffset = function () {
            return this._rawData[4];
        };
        AVM1ColorTransform.prototype.setRedOffset = function (value) {
            this._rawData[4] = value;
        };
        AVM1ColorTransform.prototype.getGreenOffset = function () {
            return this._rawData[5];
        };
        AVM1ColorTransform.prototype.setGreenOffset = function (value) {
            this._rawData[5] = value;
        };
        AVM1ColorTransform.prototype.getBlueOffset = function () {
            return this._rawData[6];
        };
        AVM1ColorTransform.prototype.setBlueOffset = function (value) {
            this._rawData[6] = value;
        };
        AVM1ColorTransform.prototype.getAlphaOffset = function () {
            return this._rawData[7];
        };
        AVM1ColorTransform.prototype.setAlphaOffset = function (value) {
            this._rawData[7] = value;
        };
        AVM1ColorTransform.prototype.getRM = function () {
            return this._rawData[0] * 100;
        };
        AVM1ColorTransform.prototype.setRM = function (value) {
            this._rawData[0] = value / 100;
        };
        AVM1ColorTransform.prototype.getGM = function () {
            return this._rawData[1] * 100;
        };
        AVM1ColorTransform.prototype.setGM = function (value) {
            this._rawData[1] = value / 100;
        };
        AVM1ColorTransform.prototype.getBM = function () {
            return this._rawData[2] * 100;
        };
        AVM1ColorTransform.prototype.setBM = function (value) {
            this._rawData[2] = value / 100;
        };
        AVM1ColorTransform.prototype.getAM = function () {
            return this._rawData[3] * 100;
        };
        AVM1ColorTransform.prototype.setAM = function (value) {
            this._rawData[3] = value / 100;
        };
        AVM1ColorTransform.prototype.getRO = function () {
            return this._rawData[4];
        };
        AVM1ColorTransform.prototype.setRO = function (value) {
            this._rawData[4] = value;
        };
        AVM1ColorTransform.prototype.getGO = function () {
            return this._rawData[5];
        };
        AVM1ColorTransform.prototype.setGO = function (value) {
            this._rawData[5] = value;
        };
        AVM1ColorTransform.prototype.getBO = function () {
            return this._rawData[6];
        };
        AVM1ColorTransform.prototype.setBO = function (value) {
            this._rawData[6] = value;
        };
        AVM1ColorTransform.prototype.getAO = function () {
            return this._rawData[7];
        };
        AVM1ColorTransform.prototype.setAO = function (value) {
            this._rawData[7] = value;
        };
        AVM1ColorTransform.prototype.getRgb = function () {
            return ((this._rawData[4] << 16) | (this._rawData[5] << 8) | this._rawData[6]);
        };
        AVM1ColorTransform.prototype.setRgb = function (rgb) {
            var argb = ColorUtils.float32ColorToARGB(rgb);
            this._rawData[4] = argb[1]; //(value >> 16) & 0xFF;
            this._rawData[5] = argb[2]; //(value >> 8) & 0xFF;
            this._rawData[6] = argb[3]; //value & 0xFF;
            this._rawData[0] = 0;
            this._rawData[1] = 0;
            this._rawData[2] = 0;
        };
        AVM1ColorTransform.prototype.concat = function (second) {
            console.warn("AVM1ColorTransform concat is not implemented");
            //this._ctAdaptee.concat(second._ctAdaptee);
        };
        AVM1ColorTransform.prototype._toString = function () {
            return "[object Object]";
        };
        AVM1ColorTransform.fromAwayColorTransform = function (context, t) {
            return new AVM1ColorTransform(context, t.redMultiplier, t.greenMultiplier, t.blueMultiplier, t.alphaMultiplier, t.redOffset, t.greenOffset, t.blueOffset, t.alphaOffset);
        };
        return AVM1ColorTransform;
    }(AVM1Object));
    var AVM1ColorTransformFunction = /** @class */ (function (_super) {
        __extends(AVM1ColorTransformFunction, _super);
        function AVM1ColorTransformFunction(context) {
            var _this = _super.call(this, context) || this;
            alDefineObjectProperties(_this, {
                prototype: {
                    value: new AVM1ColorTransformPrototype(context, _this)
                }
            });
            return _this;
        }
        AVM1ColorTransformFunction.prototype.alConstruct = function (args) {
            var obj = Object.create(AVM1ColorTransform.prototype);
            args = args || [];
            AVM1ColorTransform.apply(obj, [this.context].concat(args));
            return obj;
        };
        return AVM1ColorTransformFunction;
    }(AVM1Function));
    var AVM1ColorTransformPrototype = /** @class */ (function (_super) {
        __extends(AVM1ColorTransformPrototype, _super);
        function AVM1ColorTransformPrototype(context, fn) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                constructor: {
                    value: fn,
                    writable: true
                }
            });
            return _this;
        }
        return AVM1ColorTransformPrototype;
    }(AVM1Object));

    /**
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function toAS3Matrix(v) {
        var context = v.context;
        var a, b, c, d, tx, ty;
        if (v instanceof AVM1Object) {
            a = alCoerceNumber(context, v.alGet('a'));
            b = alCoerceNumber(context, v.alGet('b'));
            c = alCoerceNumber(context, v.alGet('c'));
            d = alCoerceNumber(context, v.alGet('d'));
            tx = alCoerceNumber(context, v.alGet('tx'));
            ty = alCoerceNumber(context, v.alGet('ty'));
        }
        return new Matrix(a, b, c, d, tx, ty);
    }
    function copyAS3MatrixTo(m, v) {
        v.alPut('a', m.a);
        v.alPut('b', m.b);
        v.alPut('c', m.c);
        v.alPut('d', m.d);
        v.alPut('tx', m.tx);
        v.alPut('ty', m.ty);
    }
    var AVM1Matrix = /** @class */ (function (_super) {
        __extends(AVM1Matrix, _super);
        function AVM1Matrix(context, a, b, c, d, tx, ty) {
            if (a === void 0) { a = 1; }
            if (b === void 0) { b = 0; }
            if (c === void 0) { c = 0; }
            if (d === void 0) { d = 1; }
            if (tx === void 0) { tx = 0; }
            if (ty === void 0) { ty = 0; }
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.globals.Matrix.alGetPrototypeProperty();
            _this.alPut('a', a);
            _this.alPut('b', b);
            _this.alPut('c', c);
            _this.alPut('d', d);
            _this.alPut('tx', tx);
            _this.alPut('ty', ty);
            return _this;
        }
        AVM1Matrix.fromAS3Matrix = function (context, m) {
            return new AVM1Matrix(context, m.a, m.b, m.c, m.d, m.tx, m.ty);
        };
        return AVM1Matrix;
    }(AVM1Object));
    var AVM1MatrixFunction = /** @class */ (function (_super) {
        __extends(AVM1MatrixFunction, _super);
        function AVM1MatrixFunction(context) {
            var _this = _super.call(this, context) || this;
            alDefineObjectProperties(_this, {
                prototype: {
                    value: new AVM1MatrixPrototype(context, _this)
                }
            });
            return _this;
        }
        AVM1MatrixFunction.prototype.alConstruct = function (args) {
            if (args && args.length > 0) {
                return new AVM1Matrix(this.context, args[0], args[1], args[2], args[3], args[4], args[5]);
            }
            else {
                return new AVM1Matrix(this.context);
            }
        };
        return AVM1MatrixFunction;
    }(AVM1Function));
    var AVM1MatrixPrototype = /** @class */ (function (_super) {
        __extends(AVM1MatrixPrototype, _super);
        function AVM1MatrixPrototype(context, fn) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                constructor: {
                    value: fn,
                    writable: true
                },
                clone: {
                    value: _this.clone,
                    writable: true
                },
                concat: {
                    value: _this.concat,
                    writable: true
                },
                createBox: {
                    value: _this.createBox,
                    writable: true
                },
                createGradientBox: {
                    value: _this.createGradientBox,
                    writable: true
                },
                deltaTransformPoint: {
                    value: _this.deltaTransformPoint,
                    writable: true
                },
                identity: {
                    value: _this.identity,
                    writable: true
                },
                invert: {
                    value: _this.invert,
                    writable: true
                },
                rotate: {
                    value: _this.rotate,
                    writable: true
                },
                scale: {
                    value: _this.scale,
                    writable: true
                },
                toString: {
                    value: _this._toString,
                    writable: true
                },
                transformPoint: {
                    value: _this.transformPoint,
                    writable: true
                },
                translate: {
                    value: _this.translate,
                    writable: true
                }
            });
            return _this;
        }
        AVM1MatrixPrototype.prototype.clone = function () {
            var result = new AVM1Matrix(this.context);
            if (this instanceof AVM1Object) {
                result.alPut('a', this.alGet('a'));
                result.alPut('b', this.alGet('b'));
                result.alPut('c', this.alGet('c'));
                result.alPut('d', this.alGet('d'));
                result.alPut('tx', this.alGet('tx'));
                result.alPut('ty', this.alGet('ty'));
            }
            return result;
        };
        AVM1MatrixPrototype.prototype.concat = function (other) {
            var m = toAS3Matrix(this), m2 = toAS3Matrix(other);
            m.concat(m2);
            copyAS3MatrixTo(m, this);
        };
        AVM1MatrixPrototype.prototype.createBox = function (scaleX, scaleY, rotation, tx, ty) {
            if (rotation === void 0) { rotation = 0; }
            if (tx === void 0) { tx = 0; }
            if (ty === void 0) { ty = 0; }
            scaleX = alCoerceNumber(this.context, scaleX);
            scaleY = alCoerceNumber(this.context, scaleY);
            rotation = alCoerceNumber(this.context, rotation);
            tx = alCoerceNumber(this.context, tx);
            ty = alCoerceNumber(this.context, ty);
            var m = toAS3Matrix(this);
            m.createBox(scaleX, scaleY, rotation, tx, ty);
            copyAS3MatrixTo(m, this);
        };
        AVM1MatrixPrototype.prototype.createGradientBox = function (width, height, rotation, tx, ty) {
            if (rotation === void 0) { rotation = 0; }
            if (tx === void 0) { tx = 0; }
            if (ty === void 0) { ty = 0; }
            width = alCoerceNumber(this.context, width);
            height = alCoerceNumber(this.context, height);
            rotation = alCoerceNumber(this.context, rotation);
            tx = alCoerceNumber(this.context, tx);
            ty = alCoerceNumber(this.context, ty);
            var m = toAS3Matrix(this);
            m.createGradientBox(width, height, rotation, tx, ty);
            copyAS3MatrixTo(m, this);
        };
        AVM1MatrixPrototype.prototype.deltaTransformPoint = function (pt) {
            var p = toAS3Point(pt);
            var m = toAS3Matrix(this);
            return AVM1Point.fromAS3Point(this.context, m.deltaTransformPoint(p));
        };
        AVM1MatrixPrototype.prototype.identity = function () {
            this.alPut('a', 1);
            this.alPut('b', 0);
            this.alPut('c', 0);
            this.alPut('d', 1);
            this.alPut('tx', 0);
            this.alPut('ty', 0);
        };
        AVM1MatrixPrototype.prototype.invert = function () {
            var m = toAS3Matrix(this);
            m.invert();
            copyAS3MatrixTo(m, this);
        };
        AVM1MatrixPrototype.prototype.rotate = function (angle) {
            angle = alCoerceNumber(this.context, angle);
            var m = toAS3Matrix(this);
            m.rotate(angle);
            copyAS3MatrixTo(m, this);
        };
        AVM1MatrixPrototype.prototype.scale = function (sx, sy) {
            sx = alCoerceNumber(this.context, sx);
            sy = alCoerceNumber(this.context, sy);
            var m = toAS3Matrix(this);
            m.scale(sx, sy);
            copyAS3MatrixTo(m, this);
        };
        AVM1MatrixPrototype.prototype._toString = function () {
            return toAS3Matrix(this).toString();
        };
        AVM1MatrixPrototype.prototype.transformPoint = function (pt) {
            var p = toAS3Point(pt);
            var m = toAS3Matrix(this);
            return AVM1Point.fromAS3Point(this.context, m.transformPoint(p));
        };
        AVM1MatrixPrototype.prototype.translate = function (tx, ty) {
            tx = alCoerceNumber(this.context, tx);
            ty = alCoerceNumber(this.context, ty);
            var m = toAS3Matrix(this);
            m.translate(tx, ty);
            copyAS3MatrixTo(m, this);
        };
        return AVM1MatrixPrototype;
    }(AVM1Object));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AVM1Stage = /** @class */ (function (_super) {
        __extends(AVM1Stage, _super);
        function AVM1Stage() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1Stage.createAVM1Class = function (context) {
            var wrapped = new AVM1Stage(context);
            wrapAVM1NativeMembers(context, wrapped, AVM1Stage.prototype, ['align#', 'displayState#', 'fullScreenSourceRect#', 'height#',
                'scaleMode#', 'showMenu#', 'width#'], false);
            return wrapped;
        };
        AVM1Stage.bindStage = function (context, cls, stage, htmlElement) {
            cls._awayAVMStage = stage;
            AVM1Stage.stage = stage;
        };
        AVM1Stage.prototype.getAlign = function () { return this._awayAVMStage.align; };
        AVM1Stage.prototype.setAlign = function (value) { this._awayAVMStage.align = value; };
        AVM1Stage.prototype.getDisplayState = function () { return this._awayAVMStage.displayState; };
        AVM1Stage.prototype.setDisplayState = function (value) { this._awayAVMStage.displayState = value; };
        AVM1Stage.prototype.getFullScreenSourceRect = function () { return this._awayAVMStage.fullScreenSourceRect; };
        AVM1Stage.prototype.setFullScreenSourceRect = function (value) { this._awayAVMStage.fullScreenSourceRect = value; };
        AVM1Stage.prototype.getHeight = function () { return this._awayAVMStage.stageHeight; };
        AVM1Stage.prototype.getScaleMode = function () { return this._awayAVMStage.scaleMode; };
        AVM1Stage.prototype.setScaleMode = function (value) { this._awayAVMStage.scaleMode = value; };
        AVM1Stage.prototype.getShowMenu = function () { return this._awayAVMStage.showDefaultContextMenu; };
        AVM1Stage.prototype.setShowMenu = function (value) { this._awayAVMStage.showDefaultContextMenu = value; };
        AVM1Stage.prototype.getWidth = function () { return this._awayAVMStage.stageWidth; };
        return AVM1Stage;
    }(AVM1Object));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function toAS3BitmapData(as2Object) {
        if (!(as2Object instanceof AVM1BitmapData)) {
            return null;
        }
        return as2Object.as3BitmapData;
    }
    var AVM1BitmapData = /** @class */ (function (_super) {
        __extends(AVM1BitmapData, _super);
        function AVM1BitmapData() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1BitmapData.createAVM1Class = function (context) {
            return wrapAVM1NativeClass(context, true, AVM1BitmapData, ['loadBitmap'], ['height#', 'rectangle#', 'transparent#', 'width#',
                'applyFilter', 'clone', 'colorTransform', 'compare', 'copyChannel',
                'copyPixels', 'dispose', 'draw', 'fillRect', 'floodFill',
                'generateFilterRect', 'getColorBoundsRect', 'getPixel', 'getPixel32',
                'hitTest', 'merge', 'noise', 'paletteMap', 'perlinNoise',
                'pixelDissolve', 'scroll', 'setPixel', 'setPixel32', 'threshold'
            ], null, AVM1BitmapData.prototype.avm1Constructor);
        };
        Object.defineProperty(AVM1BitmapData.prototype, "as3BitmapData", {
            //adaptee: BitmapData;
            get: function () {
                return this.adaptee;
            },
            enumerable: true,
            configurable: true
        });
        AVM1BitmapData.prototype.avm1Constructor = function (width, height, transparent, fillColor) {
            width = alToNumber(this.context, width);
            height = alToNumber(this.context, height);
            transparent = arguments.length < 3 ? true : alToBoolean(this.context, transparent);
            fillColor = arguments.length < 4 ? 0xFFFFFFFF : alToInt32(this.context, fillColor);
            var awayObject = new SceneImage2D(width, height, transparent, fillColor, false, AVM1Stage.stage.rendererStage);
            this.adaptee = awayObject;
        };
        AVM1BitmapData.fromAS3BitmapData = function (context, awayObject) {
            var as2Object = new AVM1BitmapData(context);
            as2Object.alPrototype = context.globals.BitmapData.alGetPrototypeProperty();
            as2Object.adaptee = awayObject;
            return as2Object;
        };
        AVM1BitmapData.loadBitmap = function (context, symbolId) {
            symbolId = alToString(context, symbolId);
            //var symbol = context.getAsset(symbolId);
            var symbol = AssetLibrary.getAsset(symbolId);
            // REDUX verify
            if (symbol && symbol.isAsset(BitmapImage2D)) {
                var bitmapData = new AVM1BitmapData(context);
                bitmapData.adaptee = symbol;
                return bitmapData;
            }
            /*
            var symbolClass = symbol.symbolProps.symbolClass;
            var bitmapClass = context.sec.flash.display.BitmapData.axClass;
            if (symbol && (bitmapClass === symbolClass ||
                    bitmapClass.dPrototype.isPrototypeOf((<any>symbolClass).dPrototype))) {
                var awayObject = constructClassFromSymbol(symbol.symbolProps, bitmapClass);
                bitmap.alPrototype = context.globals.BitmapData.alGetPrototypeProperty();
                bitmap.adaptee = awayObject;
                return bitmap;
            }*/
            return null;
        };
        AVM1BitmapData.prototype.getHeight = function () {
            return this.adaptee.height;
        };
        AVM1BitmapData.prototype.getRectangle = function () {
            var rect = this.as3BitmapData;
            return new AVM1Rectangle(this.context, 0, 0, rect.width, rect.height);
        };
        AVM1BitmapData.prototype.getTransparent = function () {
            return this.adaptee.transparent;
        };
        AVM1BitmapData.prototype.getWidth = function () {
            return this.adaptee.width;
        };
        AVM1BitmapData.prototype.applyFilter = function (sourceBitmap, sourceRect, destPoint, filter) {
            // TODO handle incorrect arguments
            var as3BitmapData = sourceBitmap.as3BitmapData;
            var as3SourceRect = toAS3Rectangle(sourceRect);
            var as3DestPoint = toAS3Point(destPoint);
            var as3Filter = convertToAS3Filter(this.context, filter);
            // todo 80pro
            //this.as3BitmapData.applyFilter(as3BitmapData, as3SourceRect, as3DestPoint, as3Filter);
            return 0;
        };
        AVM1BitmapData.prototype.clone = function () {
            var bitmap = new AVM1BitmapData(this.context);
            bitmap.alPrototype = this.context.globals.BitmapData.alGetPrototypeProperty();
            bitmap.adaptee = this.adaptee.clone();
            return bitmap;
        };
        AVM1BitmapData.prototype.colorTransform = function (rect, colorTransform) {
            var as3Rect = toAS3Rectangle(rect);
            var as3ColorTransform = toAwayColorTransform(colorTransform);
            this.adaptee.colorTransform(as3Rect, as3ColorTransform);
        };
        AVM1BitmapData.prototype.compare = function (other) {
            if (!(other instanceof AVM1BitmapData)) {
                return false;
            }
            return true; // todo 80pro this.adaptee.compare((<AVM1BitmapData>other).adaptee);
        };
        AVM1BitmapData.prototype.copyChannel = function (sourceBitmap, sourceRect, destPoint, sourceChannel, destChannel) {
            var as3BitmapData = sourceBitmap.as3BitmapData;
            var as3SourceRect = toAS3Rectangle(sourceRect);
            var as3DestPoint = toAS3Point(destPoint);
            sourceChannel = alCoerceNumber(this.context, sourceChannel);
            destChannel = alCoerceNumber(this.context, destChannel);
            this.as3BitmapData.copyChannel(as3BitmapData, as3SourceRect, as3DestPoint, sourceChannel, destChannel);
        };
        AVM1BitmapData.prototype.copyPixels = function (sourceBitmap, sourceRect, destPoint, alphaBitmap, alphaPoint, mergeAlpha) {
            var as3BitmapData = sourceBitmap.as3BitmapData;
            var as3SourceRect = toAS3Rectangle(sourceRect);
            var as3DestPoint = toAS3Point(destPoint);
            var as3AlphaData = alphaBitmap ? alphaBitmap.as3BitmapData : null;
            var as3AlphaPoint = alphaPoint ? toAS3Point(alphaPoint) : null;
            mergeAlpha = alToBoolean(this.context, mergeAlpha);
            // todo: 80pro
            //this.as3BitmapData.copyPixels(as3BitmapData, as3SourceRect, as3DestPoint, as3AlphaData,	as3AlphaPoint, mergeAlpha);
        };
        AVM1BitmapData.prototype.dispose = function () {
            this.as3BitmapData.dispose();
        };
        AVM1BitmapData.prototype.draw = function (source, matrix, colorTransform, blendMode, clipRect, smooth) {
            var as3BitmapData = source.adaptee; // movies and bitmaps
            var as3Matrix = matrix ? toAS3Matrix(matrix) : null;
            var as3ColorTransform = colorTransform ? toAwayColorTransform(colorTransform) : null;
            var as3ClipRect = clipRect ? toAS3Rectangle(clipRect) : null;
            blendMode = typeof blendMode === 'number' ? BlendModesMap[blendMode] : alCoerceString(this.context, blendMode);
            blendMode = blendMode || null;
            smooth = alToBoolean(this.context, smooth);
            this.as3BitmapData.draw(as3BitmapData, as3Matrix, as3ColorTransform, blendMode, as3ClipRect, smooth);
        };
        AVM1BitmapData.prototype.fillRect = function (rect, color) {
            var as3Rect = toAS3Rectangle(rect);
            color = alToInt32(this.context, color);
            this.as3BitmapData.fillRect(as3Rect, color);
        };
        AVM1BitmapData.prototype.floodFill = function (x, y, color) {
            x = alCoerceNumber(this.context, x);
            y = alCoerceNumber(this.context, y);
            color = alToInt32(this.context, color);
            // todo 80pro
            Debug$1.notImplemented('AVM1BitmapData.floodFill');
            //this.adaptee.floodFill(x, y, color);
        };
        AVM1BitmapData.prototype.generateFilterRect = function (sourceRect, filter) {
            Debug$1.notImplemented('AVM1BitmapData.generateFilterRect');
            return undefined;
        };
        AVM1BitmapData.prototype.getColorBoundsRect = function (mask, color, findColor) {
            mask = alToInt32(this.context, mask);
            color = alToInt32(this.context, color);
            findColor = alToBoolean(this.context, findColor);
            // todo 80pro
            Debug$1.notImplemented('AVM1BitmapData.getColorBoundsRect');
            /*
            var rect = this.adaptee.getColorBoundsRect(mask, color, findColor);
            return new AVM1Rectangle(this.context, rect.x, rect.y, rect.width, rect.height);
            */
            return null;
        };
        AVM1BitmapData.prototype.getPixel = function (x, y) {
            return this.adaptee.getPixel(x, y);
        };
        AVM1BitmapData.prototype.getPixel32 = function (x, y) {
            return this.adaptee.getPixel32(x, y);
        };
        AVM1BitmapData.prototype.hitTest = function (firstPoint, firstAlphaThreshold, secondObject, secondBitmapPoint, secondAlphaThreshold) {
            Debug$1.somewhatImplemented('AVM1BitmapData.hitTest');
            var as3FirstPoint = toAS3Point(firstPoint);
            firstAlphaThreshold = alToInt32(this.context, firstAlphaThreshold);
            // todo 80pro
            Debug$1.notImplemented('AVM1BitmapData.hitTest');
            return false;
            /*
            // TODO: Check for Rectangle, Point, Bitmap, or BitmapData here. Or whatever AVM1 allows.
            var as3SecondObject = (<any>secondObject).adaptee; // movies and bitmaps
            if (arguments.length < 4) {
                return this.adaptee.hitTest(as3FirstPoint, firstAlphaThreshold, as3SecondObject);
            }
            var as3SecondBitmapPoint = secondBitmapPoint != null ? toAS3Point(secondBitmapPoint) : null;
            if (arguments.length < 4) {
                return this.adaptee.hitTest(as3FirstPoint, firstAlphaThreshold, as3SecondObject,
                    as3SecondBitmapPoint);
            }
            secondAlphaThreshold = alToInt32(this.context, secondAlphaThreshold);
            return this.adaptee.hitTest(as3FirstPoint, firstAlphaThreshold, as3SecondObject,	as3SecondBitmapPoint, secondAlphaThreshold);
            */
        };
        AVM1BitmapData.prototype.merge = function (sourceBitmap, sourceRect, destPoint, redMult, greenMult, blueMult, alphaMult) {
            var as3BitmapData = sourceBitmap.as3BitmapData;
            var as3SourceRect = toAS3Rectangle(sourceRect);
            var as3DestPoint = toAS3Point(destPoint);
            redMult = alToInt32(this.context, redMult);
            greenMult = alToInt32(this.context, greenMult);
            blueMult = alToInt32(this.context, blueMult);
            alphaMult = alToInt32(this.context, alphaMult);
            this.as3BitmapData.merge(as3BitmapData, as3SourceRect, as3DestPoint, redMult, greenMult, blueMult, alphaMult);
        };
        AVM1BitmapData.prototype.noise = function (randomSeed, low, high, channelOptions, grayScale) {
            randomSeed = alToInt32(this.context, randomSeed);
            low = arguments.length < 2 ? 0 : alToInt32(this.context, low);
            high = arguments.length < 3 ? 255 : alToInt32(this.context, high);
            channelOptions = arguments.length < 4 ? 1 | 2 | 4 : alToInt32(this.context, channelOptions);
            grayScale = arguments.length < 5 ? false : alToBoolean(this.context, grayScale);
            // todo 80pro
            Debug$1.notImplemented('AVM1BitmapData.noise');
            //this.adaptee.noise(randomSeed, low, high, channelOptions, grayScale);
        };
        AVM1BitmapData.prototype.paletteMap = function (sourceBitmap, sourceRect, destPoint, redArray, greenArray, blueArray, alphaArray) {
            Debug$1.notImplemented('AVM1BitmapData.paletteMap');
        };
        AVM1BitmapData.prototype.perlinNoise = function (baseX, baseY, numOctaves, randomSeed, stitch, fractalNoise, channelOptions, grayScale, offsets) {
            var _this = this;
            baseX = alCoerceNumber(this.context, baseX);
            baseY = alCoerceNumber(this.context, baseY);
            numOctaves = alCoerceNumber(this.context, numOctaves);
            randomSeed = alCoerceNumber(this.context, randomSeed);
            stitch = alToBoolean(this.context, stitch);
            fractalNoise = alToBoolean(this.context, fractalNoise);
            channelOptions = channelOptions === undefined ? 7 : alCoerceNumber(this.context, channelOptions);
            grayScale = alToBoolean(this.context, grayScale);
            var as3Offsets = isNullOrUndefined$1(offsets) ? null : this.context.sec.createArray(AVM1ArrayNative.mapToJSArray(offsets, function (item) { return alCoerceNumber(_this.context, item); }, this));
            // todo 80pro
            Debug$1.notImplemented('AVM1BitmapData.perlinNoise');
            //this.as3BitmapData.perlinNoise(baseX, baseY, numOctaves, randomSeed, stitch, fractalNoise, channelOptions, grayScale, as3Offsets);
        };
        AVM1BitmapData.prototype.pixelDissolve = function (sourceBitmap, sourceRect, destPoint, randomSeed, numberOfPixels, fillColor) {
            var as3BitmapData = sourceBitmap.as3BitmapData;
            var as3SourceRect = toAS3Rectangle(sourceRect);
            var as3DestPoint = toAS3Point(destPoint);
            randomSeed = arguments.length < 4 ? 0 : alToInt32(this.context, randomSeed);
            numberOfPixels = arguments.length < 5 ?
                as3SourceRect.width * as3SourceRect.height / 30 :
                alToInt32(this.context, numberOfPixels);
            fillColor = arguments.length < 6 ? 0 : alToInt32(this.context, fillColor);
            // todo 80pro
            Debug$1.notImplemented('AVM1BitmapData.pixelDissolve');
            return 0;
            //return this.as3BitmapData.pixelDissolve(as3BitmapData, as3SourceRect, as3DestPoint,	randomSeed, numberOfPixels, fillColor);
        };
        AVM1BitmapData.prototype.scroll = function (x, y) {
            x = alCoerceNumber(this.context, x);
            y = alCoerceNumber(this.context, y);
            // todo 80pro
            Debug$1.notImplemented('AVM1BitmapData.scroll');
            //this.adaptee.scroll(x, y);
        };
        AVM1BitmapData.prototype.setPixel = function (x, y, color) {
            x = alCoerceNumber(this.context, x);
            y = alCoerceNumber(this.context, y);
            color = alToInt32(this.context, color);
            this.adaptee.setPixel(x, y, color);
        };
        AVM1BitmapData.prototype.setPixel32 = function (x, y, color) {
            x = alCoerceNumber(this.context, x);
            y = alCoerceNumber(this.context, y);
            color = alToInt32(this.context, color);
            this.adaptee.setPixel32(x, y, color);
        };
        AVM1BitmapData.prototype.threshold = function (sourceBitmap, sourceRect, destPoint, operation, threshold, color, mask, copySource) {
            var as3BitmapData = sourceBitmap.as3BitmapData;
            var as3SourceRect = toAS3Rectangle(sourceRect);
            var as3DestPoint = toAS3Point(destPoint);
            operation = alCoerceString(this.context, operation);
            threshold = alToInt32(this.context, threshold);
            color = arguments.length < 6 ? 0 : alToInt32(this.context, color);
            mask = arguments.length < 7 ? 0xFFFFFFFF : alToInt32(this.context, mask);
            copySource = arguments.length < 8 ? false : alToBoolean(this.context, copySource);
            // todo 80pro
            Debug$1.notImplemented('AVM1BitmapData.threshold');
            return 0;
            //return this.adaptee.threshold(as3BitmapData, as3SourceRect, as3DestPoint, operation,	threshold, color, mask, copySource);
        };
        return AVM1BitmapData;
    }(AVM1Object));

    var ASObject = /** @class */ (function () {
        function ASObject() {
        }
        ASObject.prototype.axCallPublicProperty = function (value1, value2) {
            return null;
        };
        ASObject.prototype.axGetPublicProperty = function (value) {
            return null;
        };
        ASObject.prototype.axSetPublicProperty = function (value, value2) {
            return null;
        };
        ASObject.prototype.axHasPublicProperty = function (value) {
            return null;
        };
        ASObject.prototype.axDeletePublicProperty = function (value) {
            return null;
        };
        ASObject.prototype.axGetEnumerableKeys = function () {
            return [];
        };
        return ASObject;
    }());
    var ASBoolean = /** @class */ (function (_super) {
        __extends(ASBoolean, _super);
        function ASBoolean() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASBoolean;
    }(ASObject));
    var ASArray = /** @class */ (function (_super) {
        __extends(ASArray, _super);
        function ASArray() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASArray;
    }(ASObject));
    var ASFunction = /** @class */ (function (_super) {
        __extends(ASFunction, _super);
        function ASFunction() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASFunction;
    }(ASObject));
    var ASNumber = /** @class */ (function (_super) {
        __extends(ASNumber, _super);
        function ASNumber() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASNumber;
    }(ASObject));
    var ASString = /** @class */ (function (_super) {
        __extends(ASString, _super);
        function ASString() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASString;
    }(ASObject));
    var ASClass = /** @class */ (function (_super) {
        __extends(ASClass, _super);
        function ASClass() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASClass;
    }(ASObject));
    function FlashNetScript_navigateToURL(param1, param2, param3) {
        if (param3 === void 0) { param3 = null; }
        if (param2.url && param2.url.toLowerCase().indexOf('fscommand:') === 0) {
            //console.log("fsCommand not implemented in FlashNetScript_navigateToURL");
            return;
        }
        window.open(param2.url, param3);
    }
    function axCoerceString$2(x) {
        if (typeof x === "string") {
            return x;
        }
        else if (x == undefined) {
            return null;
        }
        return x + '';
    }

    var MovieClipProperties;
    (function (MovieClipProperties) {
        MovieClipProperties[MovieClipProperties["_x"] = 0] = "_x";
        MovieClipProperties[MovieClipProperties["_y"] = 1] = "_y";
        MovieClipProperties[MovieClipProperties["_xscale"] = 2] = "_xscale";
        MovieClipProperties[MovieClipProperties["_yscale"] = 3] = "_yscale";
        MovieClipProperties[MovieClipProperties["_currentframe"] = 4] = "_currentframe";
        MovieClipProperties[MovieClipProperties["_totalframes"] = 5] = "_totalframes";
        MovieClipProperties[MovieClipProperties["_alpha"] = 6] = "_alpha";
        MovieClipProperties[MovieClipProperties["_visible"] = 7] = "_visible";
        MovieClipProperties[MovieClipProperties["_width"] = 8] = "_width";
        MovieClipProperties[MovieClipProperties["_height"] = 9] = "_height";
        MovieClipProperties[MovieClipProperties["_rotation"] = 10] = "_rotation";
        MovieClipProperties[MovieClipProperties["_target"] = 11] = "_target";
        MovieClipProperties[MovieClipProperties["_framesloaded"] = 12] = "_framesloaded";
        MovieClipProperties[MovieClipProperties["_name"] = 13] = "_name";
        MovieClipProperties[MovieClipProperties["_droptarget"] = 14] = "_droptarget";
        MovieClipProperties[MovieClipProperties["_url"] = 15] = "_url";
        MovieClipProperties[MovieClipProperties["_highquality"] = 16] = "_highquality";
        MovieClipProperties[MovieClipProperties["_focusrect"] = 17] = "_focusrect";
        MovieClipProperties[MovieClipProperties["_soundbuftime"] = 18] = "_soundbuftime";
        MovieClipProperties[MovieClipProperties["_quality"] = 19] = "_quality";
        MovieClipProperties[MovieClipProperties["_xmouse"] = 20] = "_xmouse";
        MovieClipProperties[MovieClipProperties["_ymouse"] = 21] = "_ymouse";
    })(MovieClipProperties || (MovieClipProperties = {}));

    var AVM1SymbolBase = /** @class */ (function (_super) {
        __extends(AVM1SymbolBase, _super);
        function AVM1SymbolBase() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.hasSwappedDepth = false;
            _this.dynamicallyCreated = false;
            _this.enabled = true;
            return _this;
        }
        AVM1SymbolBase.prototype.initAVM1SymbolInstance = function (context, awayObject) {
            //AVM1Object.call(this, context);
            this.avmType = "symbol";
            this.scriptRefsToChilds = {};
            this._mouseListenerCount = 0;
            this._avm1Context = context;
            this._ownProperties = Object.create(null);
            this._prototype = null;
            var self = this;
            // Using IAVM1Callable here to avoid circular calls between AVM1Object and
            // AVM1Function during constructions.
            // TODO do we need to support __proto__ for all SWF versions?
            this._onClipEventsListeners = [];
            var getter = { alCall: function (thisArg, args) { return self.alPrototype; } };
            var setter = { alCall: function (thisArg, args) { self.alPrototype = args[0]; } };
            var desc = new AVM1PropertyDescriptor(128 /* ACCESSOR */ |
                2 /* DONT_DELETE */ |
                1 /* DONT_ENUM */, null, getter, setter);
            this.alSetOwnProperty('__proto__', desc);
            release$1 || assert$2(awayObject);
            this.adaptee = awayObject;
            var name = awayObject.name;
            var parent = this.get_parent();
            if (name && parent) {
                parent._addChildName(this, name);
            }
        };
        AVM1SymbolBase.prototype.bindEvents = function (events, autoUnbind) {
            if (autoUnbind === void 0) { autoUnbind = true; }
            this._events = events;
            var eventsMap = Object.create(null);
            this._eventsMap = eventsMap;
            this._eventsListeners = Object.create(null);
            this._eventHandlers = Object.create(null);
            var observer = this;
            var context = this.context;
            events.forEach(function (event) {
                // Normalization will always stay valid in a player instance, so we can safely modify
                // the event itself, here.
                var propertyName = event.propertyName = context.normalizeName(event.propertyName);
                eventsMap[propertyName] = event;
                //context.registerEventPropertyObserver(propertyName, observer);
                observer._updateEvent(event);
            });
        };
        AVM1SymbolBase.prototype.unbindEvents = function () {
            var events = this._events;
            var observer = this;
            var context = this.context;
            events.forEach(function (event) {
                context.unregisterEventPropertyObserver(event.propertyName, observer);
                observer._removeEventListener(event);
            });
            this._events = null;
            this._eventsMap = null;
            this._eventsListeners = null;
            this._eventHandlers = null;
        };
        AVM1SymbolBase.prototype.updateEventByPropName = function (eventName) {
            if (!this._eventsMap) {
                console.log("no eventsmap set", this);
            }
            else if (this._eventsMap[eventName]) {
                this._updateEvent(this._eventsMap[eventName]);
            }
        };
        AVM1SymbolBase.prototype.updateAllEvents = function () {
            this._events.forEach(function (event) {
                this._updateEvent(event);
            }, this);
        };
        AVM1SymbolBase.prototype._updateEvent = function (event) {
            if (avm1HasEventProperty(this.context, this, event.propertyName)) {
                this._addEventListener(event);
            }
            else {
                this._removeEventListener(event);
            }
        };
        AVM1SymbolBase.prototype._addOnClipEventListener = function (event, callback, eventProps) {
            if (callback === void 0) { callback = null; }
            if (eventProps === void 0) { eventProps = null; }
            event.propertyName = this.context.normalizeName(event.propertyName);
            this._onClipEventsListeners.push({ event: event, callback: callback });
            if (this.enabled || !event.allowDisable)
                this.addEventListenerOnAdapter(event, callback, eventProps);
        };
        AVM1SymbolBase.prototype._addEventListener = function (event, callback) {
            if (callback === void 0) { callback = null; }
            var propertyName = this.context.normalizeName(event.propertyName);
            var listener = this._eventsListeners[propertyName];
            var myThis = this;
            if (!listener) {
                if (!callback) {
                    listener = function avm1EventHandler() {
                        var args = null;
                        if (propertyName.toLowerCase() == "onchanged") {
                            args = [myThis];
                        }
                        //var args = event.argsConverter ? event.argsConverter.apply(null, arguments) : null;
                        avm1BroadcastNativeEvent(this.context, this, propertyName, args); //args);
                    }.bind(this);
                }
                else {
                    listener = callback;
                }
                this._eventsListeners[propertyName] = listener;
                this._eventHandlers[propertyName] = event;
            }
            if (this.enabled || !event.allowDisable) {
                this.addEventListenerOnAdapter(event, listener);
            }
        };
        AVM1SymbolBase.prototype.addEventListenerOnAdapter = function (event, callback, eventProps) {
            if (eventProps === void 0) { eventProps = null; }
            if (event.stageEvent) {
                var awayAVMStage = this.context.globals.Stage._awayAVMStage;
                awayAVMStage.addAVM1EventListener(this.adaptee, event.eventName, callback, eventProps);
            }
            else {
                this.adaptee.addEventListener(event.eventName, callback);
                this._updateMouseEnabled(event, true);
            }
        };
        AVM1SymbolBase.prototype.removeEventListenerOnAdapter = function (event, callback) {
            if (event.stageEvent) {
                var awayAVMStage = this.context.globals.Stage._awayAVMStage;
                if (awayAVMStage)
                    awayAVMStage.removeAVM1EventListener(this.adaptee, event.eventName, callback);
            }
            else {
                this.adaptee.removeEventListener(event.eventName, callback);
                this._updateMouseEnabled(event, false);
            }
        };
        AVM1SymbolBase.prototype._updateMouseEnabled = function (event, enabled) {
            if (!this.adaptee.isAVMScene) {
                if (event.isMouse) {
                    if (enabled) {
                        this._mouseListenerCount++;
                        this.adaptee.mouseEnabled = true;
                        this.adaptee.mouseChildren = false;
                    }
                    else {
                        this._mouseListenerCount--;
                        if (this._mouseListenerCount <= 0) {
                            this._mouseListenerCount = 0;
                            this.adaptee.mouseEnabled = false;
                            this.adaptee.mouseChildren = true;
                        }
                    }
                }
            }
        };
        AVM1SymbolBase.prototype.freeFromScript = function () {
            _super.prototype.freeFromScript.call(this);
            this.enabled = true;
            this.adaptee.mouseEnabled = false;
            this.adaptee.mouseChildren = true;
            for (var key in this._eventsListeners) {
                this.removeEventListenerOnAdapter(this._eventHandlers[key], this._eventsListeners[key]);
            }
            this._eventsListeners = {};
            var cnt = this._onClipEventsListeners.length;
            while (cnt > 0) {
                cnt--;
                this.removeEventListenerOnAdapter(this._onClipEventsListeners[cnt].event, this._onClipEventsListeners[cnt].callback);
            }
            this._onClipEventsListeners = [];
            this._mouseListenerCount = 0;
        };
        AVM1SymbolBase.prototype._removeEventListener = function (event) {
            var propertyName = this.context.normalizeName(event.propertyName);
            var listener = this._eventsListeners[propertyName];
            if (listener) {
                this.removeEventListenerOnAdapter(event, listener);
                delete this._eventsListeners[propertyName];
            }
        };
        AVM1SymbolBase.prototype.onEventPropertyModified = function (propertyName) {
            var propertyName = this.context.normalizeName(propertyName);
            var event = this._eventsMap[propertyName];
            this._updateEvent(event);
        };
        AVM1SymbolBase.prototype.getEnabled = function () {
            return this.enabled;
        };
        AVM1SymbolBase.prototype.setEnabled = function (value) {
            if (value == this.enabled)
                return;
            this.enabled = value;
            this.setEnabledListener(value);
        };
        AVM1SymbolBase.prototype.setEnabledListener = function (value) {
            if (value !== false && value !== 0) {
                for (var key in this._eventsListeners) {
                    if (this._eventHandlers[key].allowDisable) {
                        this.addEventListenerOnAdapter(this._eventHandlers[key], this._eventsListeners[key]);
                    }
                }
                for (var key in this._onClipEventsListeners) {
                    if (this._onClipEventsListeners[key].event.allowDisable) {
                        this.addEventListenerOnAdapter(this._onClipEventsListeners[key].event, this._onClipEventsListeners[key].callback);
                    }
                }
            }
            else {
                for (var key in this._eventsListeners) {
                    if (this._eventHandlers[key].allowDisable) {
                        this.removeEventListenerOnAdapter(this._eventHandlers[key], this._eventsListeners[key]);
                    }
                }
                for (var key in this._onClipEventsListeners) {
                    if (this._onClipEventsListeners[key].event.allowDisable) {
                        this.removeEventListenerOnAdapter(this._onClipEventsListeners[key].event, this._onClipEventsListeners[key].callback);
                    }
                }
            }
        };
        AVM1SymbolBase.prototype.get_alpha = function () {
            return this.adaptee.alpha * 100;
        };
        AVM1SymbolBase.prototype.set_alpha = function (value) {
            this._ctBlockedByScript = true;
            value = alToNumber(this.context, value);
            if (isNaN(value)) {
                return;
            }
            this.adaptee.alpha = value / 100;
        };
        AVM1SymbolBase.prototype.getBlendMode = function () {
            notImplemented("AVM1SymbolBase.getBlendMode");
            return ""; //this.adaptee.blendMode;
        };
        AVM1SymbolBase.prototype.setBlendMode = function (value) {
            notImplemented("AVM1SymbolBase.setBlendMode");
            /*value = typeof value === 'number' ? BlendModesMap[value] : alCoerceString(this.context, value);
            this.adaptee.blendMode = value || null;*/
        };
        AVM1SymbolBase.prototype.getCacheAsBitmap = function () {
            return this.adaptee.cacheAsBitmap;
        };
        AVM1SymbolBase.prototype.setCacheAsBitmap = function (value) {
            value = alToBoolean(this.context, value);
            this.adaptee.cacheAsBitmap = value;
        };
        AVM1SymbolBase.prototype.getFilters = function () {
            notImplemented("AVM1SymbolBase.getFilters");
            return null; //80pro convertFromAS3Filters(this.context, this.adaptee.filters);
        };
        AVM1SymbolBase.prototype.setFilters = function (value) {
            notImplemented("AVM1SymbolBase.setFilters");
            //80pro this.adaptee.filters = convertToAS3Filters(this.context, value);
        };
        AVM1SymbolBase.prototype.get_focusrect = function () {
            notImplemented("AVM1SymbolBase.setOpaqueBackground");
            return false; //this.adaptee.focusRect || false; // suppressing null
        };
        AVM1SymbolBase.prototype.set_focusrect = function (value) {
            notImplemented("AVM1SymbolBase.setOpaqueBackground");
            /*
            value = alToBoolean(this.context, value);
            this.adaptee.focusRect = value;
            */
        };
        AVM1SymbolBase.prototype.get_height = function () {
            var box = PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.view).getBoundsPicker(this.adaptee.partition).getBoxBounds(this.adaptee);
            return (box == null) ? 0 : toTwipFloor(box.height);
        };
        AVM1SymbolBase.prototype.set_height = function (value) {
            value = toTwipFloor(alToNumber(this.context, value));
            this._blockedByScript = true;
            if (isNaN(value))
                return;
            PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.view).getBoundsPicker(this.adaptee.partition).height = value;
        };
        AVM1SymbolBase.prototype.get_highquality = function () {
            switch (this.get_quality()) {
                case 'BEST':
                    return 2;
                case 'HIGH':
                    return 1;
                default: // case 'LOW':
                    return 0;
            }
        };
        AVM1SymbolBase.prototype.set_highquality = function (value) {
            var quality;
            switch (alToInteger(this.context, value)) {
                case 2:
                    quality = 'BEST';
                    break;
                case 1:
                    quality = 'HIGH';
                    break;
                default:
                    quality = 'LOW';
                    break;
            }
            this.set_quality(quality);
        };
        AVM1SymbolBase.prototype.getMenu = function () {
            notImplemented('AVM1SymbolBase.getMenu');
            // return this.adaptee.contextMenu;
        };
        AVM1SymbolBase.prototype.setMenu = function (value) {
            notImplemented('AVM1SymbolBase.setMenu');
            // this.adaptee.contextMenu = value;
        };
        AVM1SymbolBase.prototype.get_name = function () {
            return this.adaptee ? this.adaptee.name : undefined;
        };
        AVM1SymbolBase.prototype.set_name = function (value) {
            value = alCoerceString(this.context, value);
            var oldName = this.adaptee.name;
            this.adaptee.name = value;
            var avmParent = this.get_parent();
            if (avmParent) {
                avmParent.registerScriptObject(this.adaptee);
                avmParent._updateChildName(this, oldName, value);
            }
        };
        AVM1SymbolBase.prototype.get_parent = function () {
            var parent = getAVM1Object(this.adaptee.parent, this.context);
            // In AVM1, the _parent property is `undefined`, not `null` if the element has no parent.
            return parent || undefined;
        };
        AVM1SymbolBase.prototype.set_parent = function (value) {
            notImplemented('AVM1SymbolBase.set_parent');
        };
        AVM1SymbolBase.prototype.getOpaqueBackground = function () {
            notImplemented("AVM1SymbolBase.getOpaqueBackground");
            return 0; //this.adaptee.opaqueBackground;
        };
        AVM1SymbolBase.prototype.setOpaqueBackground = function (value) {
            notImplemented("AVM1SymbolBase.setOpaqueBackground");
            /*
            if (isNullOrUndefined(value)) {
                this.adaptee.opaqueBackground = null;
            } else {
                this.adaptee.opaqueBackground = alToInt32(this.context, value);
            }
            */
        };
        AVM1SymbolBase.prototype.get_quality = function () {
            somewhatImplemented('AVM1SymbolBase.get_quality');
            return 'HIGH';
        };
        AVM1SymbolBase.prototype.set_quality = function (value) {
            somewhatImplemented('AVM1SymbolBase.set_quality');
        };
        AVM1SymbolBase.prototype.set_root = function (value) {
            notImplemented('AVM1SymbolBase.set_root');
        };
        AVM1SymbolBase.prototype.get_root = function () {
            var awayObject = this.adaptee;
            var avmObject = null;
            while (awayObject && !awayObject.isAVMScene) {
                avmObject = getAVM1Object(awayObject, this.context);
                if (avmObject && avmObject.get_lockroot()) {
                    return avmObject;
                }
                awayObject = awayObject.parent;
            }
            if (!awayObject) {
                return undefined;
            }
            return getAVM1Object(awayObject, this.context);
        };
        AVM1SymbolBase.prototype.get_rotation = function () {
            var value = this.adaptee.rotationZ;
            while (value > 180) {
                value -= 360;
            }
            while (value < -180) {
                value += 360;
            }
            return Math.round(value * 10000) / 10000;
        };
        AVM1SymbolBase.prototype.set_rotation = function (value) {
            value = alToNumber(this.context, value);
            this._blockedByScript = true;
            if (isNaN(value)) {
                return;
            }
            this.adaptee.rotationZ = value;
        };
        AVM1SymbolBase.prototype.getScale9Grid = function () {
            return AVM1Rectangle.fromAS3Rectangle(this.context, this.adaptee.scale9Grid);
        };
        AVM1SymbolBase.prototype.setScale9Grid = function (value) {
            this.adaptee.scale9Grid = isNullOrUndefined$1(value) ? null : toAS3Rectangle(value);
        };
        AVM1SymbolBase.prototype.getScrollRect = function () {
            return AVM1Rectangle.fromAS3Rectangle(this.context, this.adaptee.scrollRect);
        };
        AVM1SymbolBase.prototype.setScrollRect = function (value) {
            this.adaptee.scrollRect = isNullOrUndefined$1(value) ? null : toAS3Rectangle(value);
        };
        AVM1SymbolBase.prototype.get_soundbuftime = function () {
            notImplemented('AVM1SymbolBase.get_soundbuftime');
            return 0;
        };
        AVM1SymbolBase.prototype.set_soundbuftime = function (value) {
            notImplemented('AVM1SymbolBase.set_soundbuftime');
        };
        AVM1SymbolBase.prototype.getTabEnabled = function () {
            return this.adaptee ? this.adaptee.tabEnabled : false;
        };
        AVM1SymbolBase.prototype.setTabEnabled = function (value) {
            if (!this.adaptee)
                return;
            this.adaptee.tabEnabled = value;
        };
        AVM1SymbolBase.prototype.getTabIndex = function () {
            return this.adaptee.tabIndex;
        };
        AVM1SymbolBase.prototype.setTabIndex = function (value) {
            this.adaptee.tabIndex = value;
        };
        AVM1SymbolBase.prototype.get_target = function () {
            var awayObject = this.adaptee;
            if (awayObject === awayObject.root) {
                return '/';
            }
            var path = '';
            do {
                if (isNullOrUndefined$1(awayObject)) {
                    warning("AVM1SymbolBase.get_target returns undefined");
                    return undefined; // something went wrong
                }
                path = '/' + awayObject.name + path;
                awayObject = awayObject.parent;
            } while (awayObject && !awayObject.isAVMScene);
            return path;
        };
        AVM1SymbolBase.prototype.removeMovieClip = function () {
            if (this.adaptee.isAVMScene) {
                return; // let's not remove root symbol
            }
            if (this.adaptee.parent && away2avmDepth(this.adaptee._depthID) >= 0)
                this.adaptee.parent.removeChild(this.adaptee);
        };
        /*
        // transform is only available in FP8, and cause problems in FP6
        public getTransform(): AVM1Object {
            somewhatImplemented("AVM1SymbolBase.setTransform");
            var transformCtor = <AVM1Function>this.context.globals.Transform;
            return transformCtor.alConstruct([this]);
        }

        public setTransform(value: AVM1Transform) {
            if (!(value instanceof AVM1Transform)) {
                return;
            }
            var as3Transform = value.as3Transform;
            notImplemented("AVM1SymbolBase.setTransform");
            //this.adaptee.transform = as3Transform;
        }*/
        AVM1SymbolBase.prototype.get_visible = function () {
            return this.adaptee.visible;
        };
        AVM1SymbolBase.prototype.set_visible = function (value) {
            this._visibilityByScript = true;
            value = alToBoolean(this.context, value);
            this.adaptee.visible = value;
        };
        AVM1SymbolBase.prototype.get_url = function () {
            return this.adaptee.assetNamespace;
        };
        AVM1SymbolBase.prototype.get_width = function () {
            var box = PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.view).getBoundsPicker(this.adaptee.partition).getBoxBounds(this.adaptee);
            return (box == null) ? 0 : toTwipRound(box.width);
        };
        AVM1SymbolBase.prototype.set_width = function (value) {
            value = toTwipRound(alToNumber(this.context, value));
            this._blockedByScript = true;
            if (isNaN(value))
                return;
            PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.view).getBoundsPicker(this.adaptee.partition).width = value;
        };
        AVM1SymbolBase.prototype.get_x = function () {
            return toTwipFloor(this.adaptee.x);
        };
        AVM1SymbolBase.prototype.set_x = function (value) {
            value = toTwipFloor(alToNumber(this.context, value));
            this._blockedByScript = true;
            if (isNaN(value)) {
                return;
            }
            this.adaptee.x = value;
        };
        AVM1SymbolBase.prototype.get_xmouse = function () {
            return toTwipFloor(this.context.globals.Stage._awayAVMStage.scene.getLocalMouseX(this.adaptee));
        };
        AVM1SymbolBase.prototype.get_xscale = function () {
            return this.adaptee.scaleX * 100;
        };
        AVM1SymbolBase.prototype.set_xscale = function (value) {
            value = alToNumber(this.context, value);
            this._blockedByScript = true;
            if (isNaN(value)) {
                return;
            }
            this.adaptee.scaleX = value / 100;
        };
        AVM1SymbolBase.prototype.get_y = function () {
            return toTwipFloor(this.adaptee.y);
        };
        AVM1SymbolBase.prototype.set_y = function (value) {
            value = toTwipFloor(alToNumber(this.context, value));
            this._blockedByScript = true;
            if (isNaN(value)) {
                return;
            }
            this.adaptee.y = value;
        };
        AVM1SymbolBase.prototype.get_ymouse = function () {
            return toTwipFloor(this.context.globals.Stage._awayAVMStage.scene.getLocalMouseY(this.adaptee));
        };
        AVM1SymbolBase.prototype.get_yscale = function () {
            return this.adaptee.scaleY * 100;
        };
        AVM1SymbolBase.prototype.set_yscale = function (value) {
            value = alToNumber(this.context, value);
            this._blockedByScript = true;
            if (isNaN(value)) {
                return;
            }
            this.adaptee.scaleY = value / 100;
        };
        AVM1SymbolBase.prototype.getDepth = function () {
            if (this.protoTypeChanged)
                return null;
            return away2avmDepth(this.adaptee._depthID);
        };
        AVM1SymbolBase.prototype.toString = function () {
            var mc = this.adaptee;
            var names = [];
            while (mc) {
                if (mc.isAVMScene) {
                    names.push("_level0");
                    mc = null;
                }
                else {
                    names.push(mc.name);
                    mc = mc.parent;
                }
            }
            var i = names.length;
            var mc_path = "";
            while (i > 0) {
                i--;
                mc_path += names[i];
                if (i > 0)
                    mc_path += ".";
            }
            //console.log(mc_path);
            return mc_path;
        };
        return AVM1SymbolBase;
    }(AVM1Object));

    var AVM1LoaderHelper = /** @class */ (function () {
        function AVM1LoaderHelper(context) {
            var _this = this;
            this.result = new PromiseWrapper();
            this._context = context;
            this._onAssetCompleteDelegate = function (event) { return _this.onAssetComplete(event); };
            this._onLoadCompleteDelegate = function (event) { return _this.onLoadComplete(event); };
            this._onLoadErrorDelegate = function (event) { return _this.onLoadError(event); };
            this._loader = new Loader();
        }
        Object.defineProperty(AVM1LoaderHelper.prototype, "loader", {
            get: function () {
                return this._loader;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVM1LoaderHelper.prototype, "loaderInfo", {
            get: function () {
                return this._loader.loaderInfo;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVM1LoaderHelper.prototype, "content", {
            get: function () {
                return this._content;
            },
            enumerable: true,
            configurable: true
        });
        AVM1LoaderHelper.prototype.onAssetComplete = function (event) {
            var asset = event.asset;
            if (asset.isAsset(MovieClip)) {
                if (asset.assetNamespace != this._url) {
                    return;
                }
                if (asset.isAVMScene) {
                    this._content = asset;
                    this.result.resolve(asset);
                    asset.adapter.initAdapter();
                }
            }
        };
        AVM1LoaderHelper.prototype.onLoadComplete = function (event) {
            if (event.url != this._url) {
                return;
            }
            AssetLibrary.removeEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            AssetLibrary.removeEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoadCompleteDelegate);
            AssetLibrary.removeEventListener(URLLoaderEvent.LOAD_ERROR, this._onLoadErrorDelegate);
        };
        AVM1LoaderHelper.prototype.onLoadError = function (event) {
            AssetLibrary.removeEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            AssetLibrary.removeEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoadCompleteDelegate);
            AssetLibrary.removeEventListener(URLLoaderEvent.LOAD_ERROR, this._onLoadErrorDelegate);
            console.log("load error in loadMovie", event);
        };
        AVM1LoaderHelper.prototype.load = function (url, method) {
            this._url = url;
            this.result = new PromiseWrapper();
            AssetLibrary.addEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            AssetLibrary.addEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoadCompleteDelegate);
            AssetLibrary.addEventListener(URLLoaderEvent.LOAD_ERROR, this._onLoadErrorDelegate);
            AssetLibrary.load(new URLRequest(url), null, url, new SWFParser(AVM1Globals._scenegraphFactory));
            return this.result.promise;
            /*
            todo:
            
            var context = this._context;
            var loader = this._loader;
            var loaderContext: LoaderContext = new context.sec.flash.system.LoaderContext();
            loaderContext._avm1Context = context;
            var request = new context.sec.flash.net.URLRequest(url);
            if (method) {
                request.method = method;
            }

            var loaderInfo = loader.contentLoaderInfo;
            // Waiting for content in the progress event -- the result promise will be resolved
            // as soon as loader's content will be set to non-empty value.
            var progressEventHandler = function (e: ProgressEvent): void {
                if (!loader._content) {
                    return;
                }
                loaderInfo.removeEventListener(ProgressEvent.PROGRESS, progressEventHandler);
                result.resolve(loader._content);

            };
            loaderInfo.addEventListener(ProgressEvent.PROGRESS, progressEventHandler);
            loader.load(request, loaderContext);
            */
            //return null;
        };
        return AVM1LoaderHelper;
    }());

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function convertAS3RectangeToBounds(as3Rectange, context) {
        var result = alNewObject(context);
        result.alPut('xMin', as3Rectange.left);
        result.alPut('yMin', as3Rectange.top);
        result.alPut('xMax', as3Rectange.right);
        result.alPut('yMax', as3Rectange.bottom);
        return result;
    }
    var AVM1MovieClip = /** @class */ (function (_super) {
        __extends(AVM1MovieClip, _super);
        function AVM1MovieClip() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.onLoaded = null;
            _this.executeConstructor = null;
            _this.unregisteredColors = {};
            _this.isDragging = false;
            _this.startDragPoint = new Point();
            _this.startDragMCPosition = new Point();
            return _this;
        }
        AVM1MovieClip.createAVM1Class = function (context) {
            return wrapAVM1NativeClass(context, true, AVM1MovieClip, [], ['$version#', '_alpha#', 'getAwayJSID', 'attachAudio', 'attachBitmap', 'attachMovie',
                'beginFill', 'beginBitmapFill', 'beginGradientFill', 'blendMode#',
                'cacheAsBitmap#', '_callFrame', 'clear', 'createEmptyMovieClip',
                'createTextField', '_currentframe#', 'curveTo', '_droptarget#',
                'duplicateMovieClip', 'enabled#', 'endFill', 'filters#', '_framesloaded#',
                '_focusrect#', 'forceSmoothing#', 'getBounds',
                'getBytesLoaded', 'getBytesTotal', 'getDepth', 'getInstanceAtDepth',
                'getNextHighestDepth', 'getRect', 'getSWFVersion', 'getTextSnapshot',
                'getURL', 'globalToLocal', 'gotoAndPlay', 'gotoAndStop', '_height#',
                '_highquality#', 'hitArea#', 'hitTest', 'lineGradientStyle', 'lineStyle',
                'lineTo', 'loadMovie', 'loadVariables', 'localToGlobal', '_lockroot#',
                'menu#', 'moveTo', '_name#', 'nextFrame', 'opaqueBackground#', '_parent#',
                'play', 'prevFrame', '_quality#', 'removeMovieClip', '_root#', '_rotation#',
                'scale9Grid#', 'scrollRect#', 'setMask', '_soundbuftime#', 'startDrag',
                'stop', 'stopDrag', 'swapDepths', 'tabChildren#', 'tabEnabled#', 'tabIndex#',
                '_target#', '_totalframes#', 'trackAsMenu#', 'toString',
                'unloadMovie', '_url#', 'useHandCursor#', '_visible#', '_width#',
                '_x#', '_xmouse#', '_xscale#', '_y#', '_ymouse#', '_yscale#']);
        };
        AVM1MovieClip.prototype._updateMouseEnabled = function (event, enabled) {
            if (!this.adaptee.isAVMScene) {
                if (event.isMouse) {
                    if (enabled) {
                        this._mouseListenerCount++;
                        this.adaptee.mouseEnabled = true;
                        this.adaptee.mouseChildren = false;
                        if (event.isButton) {
                            this._mouseButtonListenerCount++;
                            this.adaptee.buttonMode = true;
                        }
                    }
                    else {
                        this._mouseListenerCount--;
                        if (this._mouseListenerCount <= 0) {
                            this._mouseListenerCount = 0;
                            this.adaptee.mouseEnabled = false;
                            this.adaptee.mouseChildren = true;
                        }
                        if (event.isButton) {
                            this._mouseButtonListenerCount--;
                            if (this._mouseButtonListenerCount <= 0) {
                                this._mouseButtonListenerCount = 0;
                                this.adaptee.buttonMode = false;
                            }
                        }
                    }
                }
            }
            if (!this.enabled) {
                this.adaptee.mouseChildren = false;
            }
        };
        AVM1MovieClip.prototype.clone = function () {
            return getAVM1Object(this.adaptee.clone(), this._avm1Context);
        };
        AVM1MovieClip.prototype.attachCustomConstructor = function () {
            if (this.adaptee) {
                var symbolClass = this.adaptee.avm1Symbol;
                if (symbolClass) {
                    this.alPut("__proto__", symbolClass._ownProperties.prototype.value);
                    var myThis = this;
                    this.executeConstructor = function () {
                        symbolClass.alCall(myThis);
                    };
                }
            }
        };
        // this is used for ordering AVM1 Framescripts into correct order
        AVM1MovieClip.prototype.compareAVM1FrameScripts = function (a, b) {
            if (!a.precedence) {
                return !b.precedence ? 0 : -1;
            }
            else if (!b.precedence) {
                return 1;
            }
            var i = 0;
            while (i < a.precedence.length && i < b.precedence.length && a.precedence[i] === b.precedence[i]) {
                i++;
            }
            if (i >= a.precedence.length) {
                return a.precedence.length === b.precedence.length ? 0 : -1;
            }
            else {
                return i >= b.precedence.length ? 1 : a.precedence[i] - b.precedence[i];
            }
        };
        AVM1MovieClip.prototype.executeScript = function (actionsBlocks) {
            AVM1MovieClip.currentMCAssetNameSpace = this.adaptee.assetNamespace;
            AVM1TextField.syncQueedTextfields();
            var name = this.adaptee.name.replace(/[^\w]/g, '');
            if (!actionsBlocks) {
                window.alert("actionsBlocks is empty, can not execute framescript" + name + this.adaptee.currentFrameIndex);
                return;
            }
            var unsortedScripts = [];
            for (var k = 0; k < actionsBlocks.length; k++) {
                var actionsBlock = actionsBlocks[k];
                var script = function (actionsData) {
                    this._avm1Context.executeActions(actionsData, this);
                }.bind(this, actionsBlock.data);
                // this uses parents of current scenegraph. so its not possible to easy preset in parser 
                script.precedence = this.adaptee.getScriptPrecedence().concat(actionsBlock.precedence);
                script.context = this.adaptee;
                unsortedScripts.push(script);
            }
            if (unsortedScripts.length) {
                unsortedScripts.sort(this.compareAVM1FrameScripts);
                var sortedFrameScripts = unsortedScripts;
                for (var k = 0; k < sortedFrameScripts.length; k++) {
                    var myScript = sortedFrameScripts[k];
                    var mc = myScript.context;
                    myScript.call(mc);
                }
            }
        };
        AVM1MovieClip.prototype.addScript = function (source, frameIdx) {
            var allscripts = source;
            var translatedScripts = [];
            for (var i = 0; i < allscripts.length; i++) {
                var scripts = allscripts[i];
                for (var s = 0; s < scripts.length; s++) {
                    var script = scripts[s];
                    var mcName = this.adaptee.name;
                    if (typeof mcName != "string") {
                        mcName = mcName.toString();
                    }
                    script.data = this._avm1Context.actionsDataFactory.createActionsData(script.actionsData, 'script_' + mcName.replace(/[^\w]/g, '') + "_" + this.adaptee.id + '_frame_' + frameIdx + '_idx_' + i);
                    translatedScripts[translatedScripts.length] = script;
                }
            }
            return translatedScripts;
        };
        AVM1MovieClip.prototype.stopAllSounds = function () {
            var allProps = this.alGetKeys();
            for (var i = 0; i < allProps.length; i++) {
                var desc = this.alGetProperty(allProps[i]);
                var val = desc ? desc.value : null;
                if (val && val._sound && val._sound.isAsset && val._sound.isAsset(WaveAudio)) {
                    val.stop();
                }
            }
            var child;
            i = this.adaptee.numChildren;
            while (i > 0) {
                i--;
                child = this.adaptee.getChildAt(i);
                if (child.isAsset(MovieClip) && child.adapter != child) {
                    child.adapter.freeFromScript();
                }
            }
        };
        // called from adaptee whenever the mc gets reset
        AVM1MovieClip.prototype.freeFromScript = function () {
            //this.stopAllSounds();
            this.hasSwappedDepth = false;
            _super.prototype.freeFromScript.call(this);
            this._mouseButtonListenerCount = 0;
        };
        // called from adaptee whenever the mc gets added to a parent
        AVM1MovieClip.prototype.initAdapter = function () {
            this._dropTarget = "";
            this._mouseButtonListenerCount = 0;
            AVM1MovieClip.currentMCAssetNameSpace = this.adaptee.assetNamespace;
            // execute the init-actionscript that is stored on timeline
            for (var key in this.adaptee.timeline.avm1InitActions)
                this.executeScript(this.addScript(this.adaptee.timeline.avm1InitActions[key], ("initActionsData" + key)));
            // execute the init-actionscript that is stored on timeline
            if (this.initEvents) {
                initializeAVM1Object(this.adaptee, this._avm1Context, this.initEvents);
            }
            this.attachCustomConstructor();
            this.initialDepth = this.adaptee._depthID;
            if (this.adaptee.onLoaded || this.executeConstructor) {
                FrameScriptManager.add_loaded_action_to_queue(this.adaptee);
            }
        };
        AVM1MovieClip.prototype.registerScriptObject = function (child, fromTimeline) {
            // 	whenever multiple childs get registered for the same name, the child with the lowest depth wins
            //	this is true for objects added via timeline, attachMovie, duplicateMovieClip and CreateEmptyMovieClip and also when renaming objects
            if (fromTimeline === void 0) { fromTimeline = true; }
            // 	if a avm1 variable for a registered child-name was defined via script, it always wins over the child registration. 
            //	for example, after setting "testMC='something'" in script, trying to get "testMC" will return "something", 
            //	and childs with the name "testMC" will no longer be accessible.
            //	this is true for all datatypes. once a variable is set by script, the value set by script will be returned.
            //	also true if the we do something like "testMC=null"
            //	if a avm1 script creates a variable as reference to a registered child, it behaves like this:
            //	the var is not updated if the child registered for the name changes
            //	if we do something like this:
            //			indirectRef = testMC;
            //			this.attachMovie("somethingFromLib", "testMC", -16380)
            //			testMC._x=100;
            //			testMC._y=100;
            //			indirectRef._x=100;
            //			indirectRef._y=100;
            //	this code will move both objects, because the attachMovie changes the object that is available under the name "testMC",
            //	but the indirectRef still holds the reference to the original object.
            //	however, if we remove the original child via removeMovieCLip or if it is removed via timeline, 
            //	the variable will return a reference to the current object that might now be registered 
            //	under the same name as the object that the variable was created for. 
            // 	if a movieclip was tinted by a color object, and than another mc gets registered for the name, the tinting is applied to the new mc
            if (child.adapter != child)
                child.adapter.setEnabled(true);
            var name = child.name;
            if (name) {
                // 	in AVM1 FP<8, all names ignore case, so we can just convert everything to lower case
                //	for FP>=8, only method names can be handled this way, object names need to keep their case
                name = name.toLowerCase();
                var hasVar = this.alHasOwnProperty(name);
                if (fromTimeline && hasVar) {
                    // there exists a avm1 var for this name. Object registration should fail
                    return;
                }
                //	only register object if:
                //			- no object is registered for this name,
                //			- a already registered object has no valid parent
                //			- the already registered object has a higher depthID than the new object
                if (!this._childrenByName[name]
                    || (this._childrenByName[name].adaptee && this._childrenByName[name].adaptee.parent == null)
                    || (this._childrenByName[name].adaptee && this._childrenByName[name].adaptee._depthID > child._depthID)) {
                    if (this._childrenByName[name] && this._childrenByName[name].avmColor) {
                        // if a object already is registered for this name, and we are going to replace it, 
                        // we need to check if it is tinted by a color-class, and if so change the target of the color class to the new object		
                        this.unregisteredColors[name] = this._childrenByName[name].avmColor;
                    }
                    //register new object
                    this._childrenByName[name] = getAVM1Object(child, this.context);
                    if (!fromTimeline) {
                        this.alPut(name, this._childrenByName[name]);
                    }
                    // if a object was previous unregistered for this name, we need to check if it was tinted by a color 
                    // and if so, we need to apply the tint to the new object
                    if (this.unregisteredColors[name]) {
                        this.unregisteredColors[name].changeTarget(child.adapter);
                        this.unregisteredColors[name] = null;
                    }
                }
                /* old stuff:
                if(force || !this._childrenByName[child.name] || (this._childrenByName[child.name].adaptee && this._childrenByName[child.name].adaptee.parent==null) ||
                    this._childrenByName[child.name].adaptee._depthID>child._depthID){
                    
                    
                    // only replace value if no property exists yet, or if a existing prop was a Away-Object
                    var existingValue=this.alGet(child.name);
                    if(existingValue && existingValue.adaptee){
                        this.alPut(child.name, child.adapter);
                        if(this.scriptRefsToChilds[child.name]){
                            // update indirectReferences to this prop
                            this.scriptRefsToChilds[child.name].obj.alPut(this.scriptRefsToChilds[child.name].name, child.adapter);
                        }
                    }
                    else if(existingValue){
                    }
                    else{
                        this.alPut(child.name, child.adapter);
                        if(this.scriptRefsToChilds[child.name]){
                            // update indirectReferences to this prop
                            this.scriptRefsToChilds[child.name].obj.alPut(this.scriptRefsToChilds[child.name].name, child.adapter);
                        }
                    }
                    if(this.unregisteredColors[child.name]){
                        this.unregisteredColors[child.name].changeTarget(child.adapter);
                        this.unregisteredColors[child.name]=null;
                    }
                    // always register the child by name on the parent, no matter what avm1prop existed previously
                    this._childrenByName[child.name]=child._adapter;
                }
                */
                /*
                else{
                    
                    this._unregisteredChilds[child.name]=child;
                }
                */
            }
        };
        AVM1MovieClip.prototype.unregisterScriptObject = function (child) {
            if (child && child.adapter != child)
                child.adapter.alPut("onEnterFrame", null);
            var name = child.name;
            if (name) {
                // 	in AVM1 FP<8, all names ignore case, so we can just convert everything to lower case
                //	for FP>=8, only method names can be handled this way, object names need to keep their case
                name = name.toLowerCase();
                if (this._childrenByName[name] && this._childrenByName[name].adaptee.id == child.id) {
                    if (this._childrenByName[name] && this._childrenByName[name].avmColor) {
                        this.unregisteredColors[name] = this._childrenByName[name].avmColor;
                    }
                    // 	check if there is another child with the same name on the movieclip
                    //	and if so, register it instead
                    //	if multiple childs match the name, get the one with highest depth
                    //	attention: at this point the child that we unregister right now is still child of the mc
                    var allChilds = this.adaptee._children;
                    var allChildsLen = allChilds.length;
                    var tmpChild = null;
                    var newChild = null;
                    for (var i = 0; i < allChildsLen; i++) {
                        tmpChild = allChilds[i];
                        if (tmpChild != child && tmpChild.name && tmpChild.name.toLowerCase() == name) {
                            if (!newChild || newChild._depthID > tmpChild._depthID) {
                                newChild = tmpChild;
                            }
                        }
                    }
                    //	if we have a new child to register, we register it
                    //	if not, we delete the registration for this name
                    if (newChild) {
                        this._childrenByName[name] = getAVM1Object(newChild, this.context);
                        if (this.unregisteredColors[name]) {
                            this.unregisteredColors[name].changeTarget(newChild.adapter);
                            this.unregisteredColors[name] = null;
                        }
                    }
                    else {
                        delete this._childrenByName[name];
                    }
                }
            }
        };
        AVM1MovieClip.prototype.getLatestObjectForName = function (name) {
            var hasVar = this.alHasOwnProperty(name);
            if (hasVar) {
                // there exists a avm1 var for this name. Object registration should fail
                return;
            }
            var allChilds = this.adaptee._children;
            var allChildsLen = allChilds.length;
            var tmpChild = null;
            var newChild = null;
            for (var i = 0; i < allChildsLen; i++) {
                tmpChild = allChilds[i];
                if (tmpChild.name && tmpChild.name.toLowerCase() == name) {
                    if (!newChild || newChild._depthID > tmpChild._depthID) {
                        newChild = tmpChild;
                    }
                }
            }
            //	if we have a new child to register, we register it
            //	if not, we delete the registration for this name
            if (newChild) {
                this._childrenByName[name] = getAVM1Object(newChild, this.context);
                if (this.unregisteredColors[name]) {
                    this.unregisteredColors[name].changeTarget(newChild.adapter);
                    this.unregisteredColors[name] = null;
                }
            }
        };
        Object.defineProperty(AVM1MovieClip.prototype, "graphics", {
            get: function () {
                return this.adaptee.graphics;
            },
            enumerable: true,
            configurable: true
        });
        AVM1MovieClip.prototype.initAVM1SymbolInstance = function (context, awayObject) {
            var _this = this;
            this._childrenByName = Object.create(null);
            _super.prototype.initAVM1SymbolInstance.call(this, context, awayObject);
            this.dragListenerDelegate = function (event) { return _this.dragListener(event); };
            this.stopDragDelegate = function (event) { return _this.stopDrag(event); };
            this.dynamicallyCreated = false;
            this.adaptee = awayObject;
            this._initEventsHandlers();
        };
        AVM1MovieClip.prototype._lookupChildByName = function (name) {
            release$1 || assert$2(alIsName(this.context, name));
            return this._childrenByName[name];
        };
        AVM1MovieClip.prototype._lookupChildInAS3Object = function (name) {
            if (!this.context.isPropertyCaseSensitive) {
            }
            //80pro todo lookupOptions
            var as3Child = this.adaptee.getChildByName(name); //, lookupOptions);
            return getAVM1Object(as3Child, this.context);
        };
        Object.defineProperty(AVM1MovieClip.prototype, "__targetPath", {
            get: function () {
                //return "";
                var target = this.get_target();
                var as3Root = this.adaptee.root;
                release$1 || Debug$1.assert(as3Root);
                var level = this.context.levelsContainer._getLevelForRoot(as3Root);
                release$1 || Debug$1.assert(level >= 0);
                var prefix = '_level' + level;
                return target != '/' ? prefix + target.replace(/\//g, '.') : prefix;
            },
            enumerable: true,
            configurable: true
        });
        AVM1MovieClip.prototype.getAwayJSID = function () {
            return this.adaptee.id;
        };
        AVM1MovieClip.prototype.attachAudio = function (id) {
            if (isNullOrUndefined$1(id)) {
                return; // ignoring all undefined objects, probably nothing to attach
            }
            if (id === false) {
                return; // TODO stop playing all attached audio source (when implemented).
            }
            // TODO implement NetStream and Microphone objects to make this work.
            notImplemented('AVM1MovieClip.attachAudio');
        };
        AVM1MovieClip.prototype.attachBitmap = function (bmp, depth, pixelSnapping, smoothing) {
            if (pixelSnapping === void 0) { pixelSnapping = 'auto'; }
            if (smoothing === void 0) { smoothing = false; }
            pixelSnapping = alCoerceString(this.context, pixelSnapping);
            smoothing = alToBoolean(this.context, smoothing);
            var awayBitmapImage2D = bmp.as3BitmapData;
            awayBitmapImage2D.transparent = true;
            var billboardMaterial = new MethodMaterial(awayBitmapImage2D);
            billboardMaterial.alphaBlending = true;
            billboardMaterial.useColorTransform = true;
            var billboard = new Billboard(billboardMaterial, pixelSnapping, smoothing); // this.context.sec.flash.display.Bitmap.axClass.axConstruct([as3BitmapData, pixelSnapping, smoothing]);
            this._insertChildAtDepth(billboard, depth);
        };
        AVM1MovieClip.prototype._constructMovieClipSymbol = function (symbolId, name) {
            symbolId = alToString(this.context, symbolId);
            name = alToString(this.context, name);
            var symbol = AssetLibrary.getAsset(symbolId, this.adaptee.assetNamespace);
            if (!symbol) {
                return undefined;
            }
            /*
            var props: SpriteSymbol = Object.create(symbol.symbolProps);
            props.avm1Name = name;
            */
            var mc;
            mc = symbol.adaptee.clone(); //constructClassFromSymbol(props, this.context.sec.flash.display.MovieClip.axClass);
            mc.name = name;
            getAVM1Object(mc, this._avm1Context);
            return mc;
        };
        AVM1MovieClip.prototype.get$version = function () {
            return "";
            //return Capabilities.version;
        };
        AVM1MovieClip.prototype.rgbaToArgb = function (float32Color) {
            var r = (float32Color & 0xff000000) >>> 24;
            var g = (float32Color & 0xff0000) >>> 16;
            var b = (float32Color & 0xff00) >>> 8;
            var a = float32Color & 0xff;
            return (a << 24) | (r << 16) | (g << 8) | b;
        };
        AVM1MovieClip.prototype.attachMovie = function (symbolId, name, depth, initObject) {
            if (!this._constructMovieClipSymbol)
                return;
            var mc = this._constructMovieClipSymbol(symbolId, name);
            if (!mc) {
                return undefined;
            }
            depth = alToNumber(this.context, depth);
            var oldAVMMC = this._childrenByName[name.toLowerCase()];
            //console.log("attachMovie", name, avm2AwayDepth(depth));
            var avmMc = this._insertChildAtDepth(mc, avm2AwayDepth(depth));
            if (initObject) {
                avmMc._init(initObject);
            }
            if (oldAVMMC && oldAVMMC.avmColor) {
                oldAVMMC.avmColor.changeTarget(avmMc);
            }
            if (mc.timeline && mc.timeline.isButton) {
                mc.addButtonListeners();
            }
            avmMc.dynamicallyCreated = true;
            this.registerScriptObject(mc, false);
            return avmMc;
        };
        AVM1MovieClip.prototype.beginFill = function (color, alpha) {
            color = alToInt32(this.context, color);
            if (typeof alpha == "undefined") {
                if (arguments.length == 2) {
                    // alpha was set with "undefined" variable - should be 0
                    alpha = 0;
                }
                else if (arguments.length <= 1) {
                    // alpha was not set at all - should be 100
                    alpha = 100;
                }
            }
            alpha = alToNumber(this.context, alpha);
            this.graphics.beginFill(color, alpha / 100.0);
        };
        AVM1MovieClip.prototype.beginBitmapFill = function (bmp, matrix, repeat, smoothing) {
            if (matrix === void 0) { matrix = null; }
            if (repeat === void 0) { repeat = false; }
            if (smoothing === void 0) { smoothing = false; }
            if (!alInstanceOf(this.context, bmp, this.context.globals.BitmapData)) {
                return; // skipping operation if first parameter is not a BitmapData.
            }
            var bmpNative = toAS3BitmapData(bmp);
            var matrixNative = isNullOrUndefined$1(matrix) ? null : toAS3Matrix(matrix);
            repeat = alToBoolean(this.context, repeat);
            smoothing = alToBoolean(this.context, smoothing);
            notImplemented('AVM1MovieClip.beginBitmapFill');
            //this.graphics.beginBitmapFill(bmpNative.adaptee, matrixNative, repeat, smoothing);
        };
        AVM1MovieClip.prototype.beginGradientFill = function (fillType, colors, alphas, ratios, matrix, spreadMethod, interpolationMethod, focalPointRatio) {
            var _this = this;
            if (spreadMethod === void 0) { spreadMethod = 'pad'; }
            if (interpolationMethod === void 0) { interpolationMethod = 'rgb'; }
            if (focalPointRatio === void 0) { focalPointRatio = 0.0; }
            var context = this.context, sec = context.sec;
            // fillType = alToString(this.context, fillType);
            var colorsNative = sec.createArray(AVM1ArrayNative.mapToJSArray(colors, function (item) { return alToInt32(_this.context, item); }));
            var alphasNative = sec.createArray(AVM1ArrayNative.mapToJSArray(alphas, function (item) { return alToNumber(_this.context, item) / 100.0; }));
            var ratiosNative = sec.createArray(AVM1ArrayNative.mapToJSArray(ratios, function (item) { return alToNumber(_this.context, item); }));
            var matrixNative = null;
            if (isNullOrUndefined$1(matrix)) {
                somewhatImplemented('AVM1MovieClip.beginGradientFill');
            }
            spreadMethod = alToString(this.context, spreadMethod);
            interpolationMethod = alToString(this.context, interpolationMethod);
            focalPointRatio = alToNumber(this.context, focalPointRatio);
            this.graphics.beginGradientFill(fillType, colorsNative, alphasNative, ratiosNative, matrixNative, spreadMethod, interpolationMethod, focalPointRatio);
        };
        AVM1MovieClip.prototype._callFrame = function (frame) {
            var script;
            if (typeof frame === "string")
                script = this.adaptee.timeline.getScriptForLabel(this.adaptee, frame);
            else if (typeof frame === "number")
                script = this.adaptee.timeline.get_script_for_frame(this.adaptee, frame - 1);
            if (script)
                this.executeScript(script);
        };
        AVM1MovieClip.prototype.clear = function () {
            this.graphics.clear();
        };
        AVM1MovieClip.prototype._insertChildAtDepth = function (mc, depth) {
            this.adaptee.addChildAtDepth(mc, depth);
            return getAVM1Object(mc, this._avm1Context);
        };
        AVM1MovieClip.prototype._updateChildName = function (child, oldName, newName) {
            oldName && this._removeChildName(child, oldName);
            newName && this._addChildName(child, newName);
        };
        AVM1MovieClip.prototype._removeChildName = function (child, name) {
            release$1 || assert$2(name);
            if (!this.context.isPropertyCaseSensitive) {
                name = name.toLowerCase();
            }
            if (!this._childrenByName || !this._childrenByName[name])
                return;
            if (this._childrenByName[name] !== child) {
                return;
            }
            var newChildForName = this._lookupChildInAS3Object(name);
            if (newChildForName) {
                this._childrenByName[name] = newChildForName;
            }
            else {
                delete this._childrenByName[name];
            }
        };
        AVM1MovieClip.prototype._addChildName = function (child, name) {
            release$1 || assert$2(name);
            if (!this.context.isPropertyCaseSensitive) {
                name = name.toLowerCase();
            }
            release$1 || assert$2(this._childrenByName[name] !== child);
            var currentChild = this._childrenByName[name];
            if (!currentChild || currentChild.getDepth() > child.getDepth()) {
                this._childrenByName[name] = child;
            }
        };
        AVM1MovieClip.prototype.createEmptyMovieClip = function (name, depth) {
            // 	creates a new empty movieclip.
            //	if a mc already exists for the name, but at different depth, it will create a new movieclip, and also keep the existing alive
            //	if a mc already exists at same depth, it will replace the existing movieclip with the new one
            name = alToString(this.context, name);
            var mc = new MovieClip();
            mc.name = name;
            mc.assetNamespace = this.adaptee.assetNamespace;
            getAVM1Object(mc, this._avm1Context);
            //console.log("createEmptyMovieClip", name, avm2AwayDepth(depth));
            var avmMC = this._insertChildAtDepth(mc, avm2AwayDepth(depth));
            avmMC.dynamicallyCreated = true;
            this.registerScriptObject(mc, false);
            // dynamicallyCreated needs to be set after adding child, otherwise it gets reset
            return avmMC;
        };
        AVM1MovieClip.prototype.createTextField = function (name, depth, x, y, width, height) {
            name = alToString(this.context, name);
            var text = new TextField();
            text.name = name;
            text.textFormat = new TextFormat();
            getAVM1Object(text, this._avm1Context);
            var myTF = this._insertChildAtDepth(text, avm2AwayDepth(depth));
            this.registerScriptObject(text, false);
            text.x = x;
            text.y = y;
            text.width = width;
            text.height = height;
            myTF.dynamicallyCreated = true;
            return myTF;
        };
        AVM1MovieClip.prototype.get_currentframe = function () {
            return this.adaptee.currentFrameIndex + 1;
        };
        AVM1MovieClip.prototype.curveTo = function (controlX, controlY, anchorX, anchorY) {
            controlX = alToNumber(this.context, controlX);
            controlY = alToNumber(this.context, controlY);
            anchorX = alToNumber(this.context, anchorX);
            anchorY = alToNumber(this.context, anchorY);
            this.graphics.curveTo(controlX, controlY, anchorX, anchorY);
        };
        AVM1MovieClip.prototype.setDropTarget = function (dropTarget) {
            if (dropTarget) {
                //console.log((<AVMRaycastPicker>AVM1Stage.stage.view.mousePicker).getDropTarget().name);
                var names = [];
                while (dropTarget) {
                    if (dropTarget.isAVMScene) {
                        dropTarget = null;
                    }
                    else {
                        if (dropTarget.name != null)
                            names.push(dropTarget.name);
                        dropTarget = dropTarget.parent;
                    }
                }
                var i = names.length;
                var mc_path = "";
                while (i > 0) {
                    i--;
                    if (names[i] != "")
                        mc_path += "/";
                    mc_path += names[i];
                }
                //console.log(mc_path);
                this._dropTarget = mc_path;
                return;
            }
            this._dropTarget = "";
        };
        AVM1MovieClip.prototype.get_droptarget = function () {
            return this._dropTarget;
        };
        AVM1MovieClip.prototype.duplicateMovieClip = function (name, depth, initObject) {
            name = alToString(this.context, name);
            if (name == this.adaptee.name) {
                return this;
            }
            var parent = this.get_parent();
            if (!parent) {
                warning("AVM1MovieClip.duplicateMovieClip could not get parent");
                parent = this.context.resolveTarget(null);
            }
            var mc;
            if (this.adaptee._symbol) {
                notImplemented('AVM1MovieClip.duplicateMovieClip from symbol');
                //mc = constructClassFromSymbol(nativeAS3Object._symbol, nativeAS3Object.axClass);
            }
            else {
                mc = this.clone().adaptee; //new this.context.sec.flash.display.MovieClip();
            }
            mc.name = name;
            mc.adapter.placeObjectTag = this.placeObjectTag;
            mc.adapter.initEvents = this.initEvents;
            var avmMc = parent._insertChildAtDepth(mc, avm2AwayDepth(depth));
            // dynamicallyCreated needs to be set after adding child, otherwise it gets reset
            avmMc.dynamicallyCreated = true;
            avmMc._avm1Context = this._avm1Context;
            parent.registerScriptObject(mc, false);
            var new_matrix = mc.transform.matrix3D;
            var originalMatrix = this.adaptee.transform.matrix3D._rawData;
            new_matrix._rawData[0] = originalMatrix[0];
            new_matrix._rawData[1] = originalMatrix[1];
            new_matrix._rawData[4] = originalMatrix[4];
            new_matrix._rawData[5] = originalMatrix[5];
            new_matrix._rawData[12] = originalMatrix[12];
            new_matrix._rawData[13] = originalMatrix[13];
            mc.transform.invalidateComponents();
            mc.alpha = this.adaptee.alpha;
            mc.blendMode = this.adaptee.blendMode;
            mc.cacheAsBitmap = this.adaptee.cacheAsBitmap;
            if (initObject) {
                avmMc._init(initObject);
            }
            return avmMc;
        };
        AVM1MovieClip.prototype.endFill = function () {
            this.graphics.endFill();
        };
        AVM1MovieClip.prototype.getForceSmoothing = function () {
            notImplemented('AVM1MovieClip.getForceSmoothing');
            return false;
        };
        AVM1MovieClip.prototype.setForceSmoothing = function (value) {
            value = alToBoolean(this.context, value);
            notImplemented('AVM1MovieClip.setForceSmoothing');
        };
        AVM1MovieClip.prototype.get_framesloaded = function () {
            notImplemented('AVM1MovieClip.get_framesloaded');
            return 0; //this.adaptee.framesLoaded;
        };
        AVM1MovieClip.prototype.getBounds = function (bounds) {
            var obj = getAwayJSAdaptee(bounds);
            if (!obj) {
                return undefined;
            }
            return convertAS3RectangeToBounds(PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.renderer.view).getBoundsPicker(this.adaptee.partition).getBoxBounds(obj, true), this.context);
        };
        AVM1MovieClip.prototype.getBytesLoaded = function () {
            //var loaderInfo = this.adaptee.loaderInfo;
            return this.adaptee.currentFrameIndex >= 0 ? 100 : -1; //loaderInfo.bytesLoaded;
        };
        AVM1MovieClip.prototype.getBytesTotal = function () {
            //var loaderInfo = this.adaptee.loaderInfo;
            return 100; //loaderInfo.bytesTotal;
        };
        AVM1MovieClip.prototype.getInstanceAtDepth = function (depth) {
            //Debug.notImplemented('AVM1MovieClip.getInstanceAtDepth');
            // 80pro: why does this always return movieclip ?
            // todo: check if in as3 this could be a textfield
            var child = this.adaptee.getChildAtDepth(avm2AwayDepth(depth));
            if (!child) {
                return null;
            }
            if (child.isAsset(Billboard)) {
                return this;
            }
            else if (child.isAsset(MovieClip)) {
                return this;
            }
            return getAVM1Object(child, this.context);
            /*
            var symbolDepth = alCoerceNumber(this.context, depth) + DEPTH_OFFSET;
            var nativeObject = this.adaptee;
            var lookupChildOptions = LookupChildOptions.INCLUDE_NON_INITIALIZED;
            for (var i = 0, numChildren = nativeObject.numChildren; i < numChildren; i++) {
                var child = nativeObject._lookupChildByIndex(i, lookupChildOptions);
                // child is null if it hasn't been constructed yet. This can happen in InitActionBlocks.
                if (child && child._depth === symbolDepth) {
                    // Somewhat absurdly, this method returns the mc if a bitmap is at the given depth.
                    if (this.context.sec.flash.display.Bitmap.axIsType(child)) {
                        return this;
                    }
                    return <AVM1MovieClip>getAVM1Object(child, this.context);
                }
            }
            return undefined;
            */
        };
        AVM1MovieClip.prototype.getNextHighestDepth = function () {
            return away2avmDepth(this.adaptee.getNextHighestDepth());
        };
        AVM1MovieClip.prototype.getRect = function (bounds) {
            var obj = getAwayJSAdaptee(bounds);
            if (!obj) {
                return undefined;
            }
            return convertAS3RectangeToBounds(PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.renderer.view).getBoundsPicker(this.adaptee.partition).getBoxBounds(obj), this.context);
        };
        AVM1MovieClip.prototype.getSWFVersion = function () {
            var loaderInfo = this.adaptee.loaderInfo;
            return 0; //loaderInfo.swfVersion;
        };
        AVM1MovieClip.prototype.getTextSnapshot = function () {
            notImplemented('AVM1MovieClip.getTextSnapshot');
        };
        AVM1MovieClip.prototype.getURL = function (url, window, method) {
            var request = new URLRequest(url);
            if (method) {
                request.method = method;
            }
            FlashNetScript_navigateToURL(request, window);
        };
        AVM1MovieClip.prototype.globalToLocal = function (pt) {
            if (!pt)
                return;
            var tmp = toAS3Point(pt);
            this.adaptee.transform.globalToLocal(tmp, tmp);
            copyAS3PointTo(tmp, pt);
        };
        AVM1MovieClip.prototype.gotoAndPlay = function (frame) {
            if (this.protoTypeChanged || frame == null)
                return;
            if (Array.isArray(frame)) {
                if (frame.length == 0)
                    return;
                frame = frame[0];
            }
            if (frame instanceof AVM1ArrayNative) {
                if (!frame.value || frame.value.length == 0)
                    return;
                frame = frame.value[0];
            }
            if (typeof frame === "string") {
                if (this.adaptee.timeline._labels[frame.toLowerCase()] == null) {
                    frame = parseInt(frame);
                    if (!isNaN(frame)) {
                        this.adaptee.currentFrameIndex = frame - 1;
                        this.adaptee.play();
                    }
                    return;
                }
            }
            if (typeof frame === "number" && frame <= 0)
                return;
            this.adaptee.play();
            this._gotoFrame(frame);
        };
        AVM1MovieClip.prototype.gotoAndStop = function (frame) {
            if (this.protoTypeChanged || frame == null)
                return;
            if (Array.isArray(frame)) {
                if (frame.length == 0)
                    return;
                frame = frame[0];
            }
            if (frame instanceof AVM1ArrayNative) {
                if (!frame.value || frame.value.length == 0)
                    return;
                frame = frame.value[0];
            }
            if (typeof frame === "number" && frame <= 0)
                return;
            this.adaptee.stop();
            this._gotoFrame(frame);
        };
        AVM1MovieClip.prototype._gotoFrame = function (frame) {
            if (typeof frame === "number") {
                if (frame % 1 !== 0) {
                    frame = frame.toString();
                }
            }
            if (typeof frame === "string") {
                if (this.adaptee.timeline._labels[frame.toLowerCase()] == null) {
                    frame = parseInt(frame);
                    if (!isNaN(frame)) {
                        this.adaptee.currentFrameIndex = frame - 1;
                    }
                    return;
                }
                this.adaptee.jumpToLabel(frame.toLowerCase());
            }
            else {
                this.adaptee.currentFrameIndex = frame - 1;
            }
        };
        AVM1MovieClip.prototype.getHitArea = function () {
            return this._hitArea;
        };
        AVM1MovieClip.prototype.setHitArea = function (value) {
            // The hitArea getter always returns exactly the value set here, so we have to store that.
            this._hitArea = value;
            var obj = value ? getAwayJSAdaptee(value) : null;
            if (obj && !obj.isAsset(MovieClip))
                obj = null;
            // 	MA_GBR_0700AAx0100 is the first lesson encountered that makes use of hitArea
            // 	if the hitArea is set, the mouse-interactions on the ducks stop working
            //	this.adaptee.hitArea=obj;
        };
        AVM1MovieClip.prototype.hitTest = function (x, y, shapeFlag) {
            if (arguments.length <= 1) {
                // Alternative method signature: hitTest(target: AVM1Object): boolean
                var target = arguments[0];
                if (typeof target === "string") {
                    target = this.context.resolveTarget(target);
                }
                if (isNullOrUndefined$1(target) || !hasAwayJSAdaptee(target)) {
                    return false; // target is undefined or not a AVM1 display object, returning false.
                }
                return PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.renderer.view).getBoundsPicker(this.adaptee.partition).hitTestObject(PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.renderer.view).getBoundsPicker(getAwayJSAdaptee(target).partition));
            }
            x = alToNumber(this.context, x);
            y = alToNumber(this.context, y);
            x += this.get_root().get_x();
            y += this.get_root().get_y();
            shapeFlag = alToBoolean(this.context, shapeFlag);
            return PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.renderer.view).getBoundsPicker(this.adaptee.partition).hitTestPoint(x, y, shapeFlag);
        };
        AVM1MovieClip.prototype.lineGradientStyle = function (fillType, colors, alphas, ratios, matrix, spreadMethod, interpolationMethod, focalPointRatio) {
            var _this = this;
            if (spreadMethod === void 0) { spreadMethod = 'pad'; }
            if (interpolationMethod === void 0) { interpolationMethod = 'rgb'; }
            if (focalPointRatio === void 0) { focalPointRatio = 0.0; }
            var context = this.context, sec = context.sec;
            // fillType = alToString(this.context, fillType);
            var colorsNative = sec.createArray(AVM1ArrayNative.mapToJSArray(colors, function (item) { return alToInt32(_this.context, item); }));
            var alphasNative = sec.createArray(AVM1ArrayNative.mapToJSArray(alphas, function (item) { return alToNumber(_this.context, item) / 100.0; }));
            var ratiosNative = sec.createArray(AVM1ArrayNative.mapToJSArray(ratios, function (item) { return alToNumber(_this.context, item); }));
            var matrixNative = null;
            if (isNullOrUndefined$1(matrix)) {
                somewhatImplemented('AVM1MovieClip.lineGradientStyle');
            }
            spreadMethod = alToString(this.context, spreadMethod);
            interpolationMethod = alToString(this.context, interpolationMethod);
            focalPointRatio = alToNumber(this.context, focalPointRatio);
            this.graphics.lineGradientStyle(fillType, colorsNative, alphasNative, ratiosNative, matrixNative, spreadMethod, interpolationMethod, focalPointRatio);
        };
        AVM1MovieClip.prototype.lineStyle = function (thickness, rgb, alpha, pixelHinting, noScale, capsStyle, jointStyle, miterLimit) {
            if (thickness === void 0) { thickness = NaN; }
            if (rgb === void 0) { rgb = 0x000000; }
            if (alpha === void 0) { alpha = 100; }
            if (pixelHinting === void 0) { pixelHinting = false; }
            if (noScale === void 0) { noScale = 'normal'; }
            if (capsStyle === void 0) { capsStyle = 'round'; }
            if (jointStyle === void 0) { jointStyle = 'round'; }
            if (miterLimit === void 0) { miterLimit = 3; }
            thickness = alToNumber(this.context, thickness);
            rgb = alToInt32(this.context, rgb);
            pixelHinting = alToBoolean(this.context, pixelHinting);
            noScale = alToString(this.context, noScale);
            var capsStyleInt = AVM1MovieClip.capStyleMapStringToInt[alToString(this.context, capsStyle)];
            var jointStyleInt = AVM1MovieClip.jointStyleMapStringToInt[alToString(this.context, jointStyle)];
            miterLimit = alToNumber(this.context, miterLimit);
            this.graphics.lineStyle(thickness, rgb, alpha / 100.0, pixelHinting, AVM1MovieClip.noScaleDictionary[noScale], capsStyleInt, jointStyleInt, miterLimit);
        };
        AVM1MovieClip.prototype.lineTo = function (x, y) {
            x = toTwipFloor(alToNumber(this.context, x));
            y = toTwipFloor(alToNumber(this.context, y));
            this.graphics.lineTo(x, y);
        };
        AVM1MovieClip.prototype.loadMovie = function (url, method) {
            var loaderHelper = new AVM1LoaderHelper(this.context);
            loaderHelper.load(url, method).then(function () {
                if (loaderHelper.content == null) {
                    warning("loadMovie - content is null");
                    return;
                }
                this.adaptee.timeline = loaderHelper.content.timeline;
                this.adaptee.assetNamespace = loaderHelper.content.assetNamespace;
                this.adaptee.reset(true);
            }.bind(this));
        };
        AVM1MovieClip.prototype.loadVariables = function (url, method) {
            this.context.actions._loadVariables(this, url, method);
        };
        AVM1MovieClip.prototype.localToGlobal = function (pt) {
            if (!pt) {
                return;
            }
            var tmp = toAS3Point(pt);
            this.adaptee.transform.localToGlobal(tmp, tmp);
            copyAS3PointTo(tmp, pt);
        };
        AVM1MovieClip.prototype.get_lockroot = function () {
            return this._lockroot;
        };
        AVM1MovieClip.prototype.set_lockroot = function (value) {
            somewhatImplemented('AVM1MovieClip._lockroot');
            this._lockroot = alToBoolean(this.context, value);
        };
        AVM1MovieClip.prototype.moveTo = function (x, y) {
            x = toTwipFloor(alToNumber(this.context, x));
            y = toTwipFloor(alToNumber(this.context, y));
            this.graphics.moveTo(x, y);
        };
        AVM1MovieClip.prototype.nextFrame = function () {
            ++this.adaptee.currentFrameIndex;
        };
        AVM1MovieClip.prototype.nextScene = function () {
            notImplemented('AVM1MovieClip.nextScene');
        };
        AVM1MovieClip.prototype.play = function () {
            this.adaptee.play();
        };
        AVM1MovieClip.prototype.prevFrame = function () {
            --this.adaptee.currentFrameIndex;
            this.adaptee.stop();
        };
        AVM1MovieClip.prototype.prevScene = function () {
            notImplemented('AVM1MovieClip.prevScene');
        };
        AVM1MovieClip.prototype.setMask = function (mc) {
            if (mc == null) {
                // Cancel a mask.
                this.adaptee.mask = null;
                return;
            }
            var mask = this.context.resolveTarget(mc);
            if (mask) {
                this.adaptee.mask = getAwayJSAdaptee(mask);
            }
        };
        AVM1MovieClip.prototype.startDrag = function (lock, left, top, right, bottom) {
            if (AVM1MovieClip.currentDraggedMC) {
                AVM1MovieClip.currentDraggedMC.stopDrag();
            }
            AVM1MovieClip.currentDraggedMC = this;
            lock = alToBoolean(this.context, lock);
            this._dragBounds = null;
            if (left > right) {
                var tmp = right;
                right = left;
                left = tmp;
            }
            if (top > bottom) {
                var tmp = bottom;
                bottom = top;
                top = tmp;
            }
            if (arguments.length > 1) {
                left = alToNumber(this.context, left);
                top = alToNumber(this.context, top);
                right = alToNumber(this.context, right);
                bottom = alToNumber(this.context, bottom);
                //console.log("left", left,"top", top, "right", right, "bottom", bottom );
                this._dragBounds = new Rectangle(left, top, right - left, bottom - top);
            } //todo: listen on stage
            if (!this.isDragging) {
                this.isDragging = true;
                this.startDragPoint = this.adaptee.parent.transform.globalToLocal(new Point(this.context.globals.Stage._awayAVMStage.mouseX, this.context.globals.Stage._awayAVMStage.mouseY));
                if (lock) {
                    this.adaptee.x = this.startDragPoint.x;
                    this.adaptee.y = this.startDragPoint.y;
                }
                if (this._dragBounds)
                    this.checkBounds();
                this.startDragMCPosition.x = this.adaptee.x;
                this.startDragMCPosition.y = this.adaptee.y;
                AVM1Stage.stage.addEventListener("mouseMove3d", this.dragListenerDelegate);
                //window.addEventListener("mouseup", this.stopDragDelegate);
                //window.addEventListener("touchend", this.stopDragDelegate);
                AVM1Stage.stage.scene.mousePicker.dragEntity = this.adaptee;
                MouseManager.getInstance(AVM1Stage.stage.scene.renderer.renderGroup.pickGroup).isAVM1Dragging = true;
            }
        };
        AVM1MovieClip.prototype.dragListener = function (e) {
            //console.log("drag", e);
            //console.log("mouseX", (<any>this.context.globals.Stage)._awayAVMStage.mouseX);
            //console.log("mouseY", (<any>this.context.globals.Stage)._awayAVMStage.mouseY);
            if (this.adaptee.parent) {
                var tmpPoint = this.adaptee.parent.transform.globalToLocal(new Point(this.context.globals.Stage._awayAVMStage.mouseX, this.context.globals.Stage._awayAVMStage.mouseY));
                this.adaptee.x = this.startDragMCPosition.x + (tmpPoint.x - this.startDragPoint.x);
                this.adaptee.y = this.startDragMCPosition.y + (tmpPoint.y - this.startDragPoint.y);
                if (this._dragBounds)
                    this.checkBounds();
            }
        };
        AVM1MovieClip.prototype.checkBounds = function () {
            if (this.adaptee.x < (this._dragBounds.left)) {
                this.adaptee.x = this._dragBounds.left;
            }
            if (this.adaptee.x > (this._dragBounds.right)) {
                this.adaptee.x = (this._dragBounds.right);
            }
            if (this.adaptee.y < this._dragBounds.top) {
                this.adaptee.y = this._dragBounds.top;
            }
            if (this.adaptee.y > (this._dragBounds.bottom)) {
                this.adaptee.y = this._dragBounds.bottom;
            }
        };
        AVM1MovieClip.prototype.stop = function () {
            return this.adaptee.stop();
        };
        AVM1MovieClip.prototype.stopDrag = function (e) {
            if (e === void 0) { e = null; }
            if (AVM1MovieClip.currentDraggedMC && AVM1MovieClip.currentDraggedMC != this) {
                AVM1MovieClip.currentDraggedMC.stopDrag();
            }
            this.isDragging = false;
            AVM1MovieClip.currentDraggedMC = null;
            AVM1Stage.stage.scene.mousePicker.dragEntity = null;
            MouseManager.getInstance(AVM1Stage.stage.scene.renderer.renderGroup.pickGroup).isAVM1Dragging = true;
            AVM1Stage.stage.removeEventListener("mouseMove3d", this.dragListenerDelegate);
            window.removeEventListener("mouseup", this.stopDragDelegate);
            window.removeEventListener("touchend", this.stopDragDelegate);
        };
        AVM1MovieClip.prototype.swapDepths = function (target) {
            //return;
            // if this is the scene, or if no parent exists, we do not want to do anything
            if (this.adaptee.isAVMScene || !this.get_parent()) {
                return;
            }
            var parent = getAwayJSAdaptee(this.get_parent());
            if (!parent) {
                warning("AVM1MovieClip.swapDepth called for object with no parent");
                return;
            }
            if (typeof target === 'undefined') {
                warning("AVM1MovieClip.swapDepth called with undefined as target depth");
                return;
            }
            if (typeof target === 'number') {
                //console.log("swap to number", this.adaptee.name, target);
                parent.swapDepths(this.adaptee, avm2AwayDepth(target));
            }
            else if (target.adaptee) {
                target._blockedByScript = true;
                target._ctBlockedByScript = true;
                //console.log("swap to children", this.adaptee.name, target.adaptee.name);
                parent.swapChildren(this.adaptee, target.adaptee);
            }
            this._blockedByScript = true;
            this._ctBlockedByScript = true;
            if (this.adaptee._depthID == this.initialDepth) {
                this.hasSwappedDepth = false;
            }
            else {
                this.hasSwappedDepth = true;
            }
            if (this.adaptee.name && parent && parent.adapter) {
                // the object has a name, and might be registered for access via script
                // we need to check if that registration must be updated to another mc that has a higher depth
                parent.adapter.getLatestObjectForName(this.adaptee.name.toLowerCase());
            }
        };
        AVM1MovieClip.prototype.getTabChildren = function () {
            return getAwayObjectOrTemplate(this).tabChildren;
        };
        AVM1MovieClip.prototype.setTabChildren = function (value) {
            getAwayObjectOrTemplate(this).tabChildren = alToBoolean(this.context, value);
        };
        AVM1MovieClip.prototype.get_totalframes = function () {
            return this.adaptee.numFrames;
        };
        AVM1MovieClip.prototype.getTrackAsMenu = function () {
            notImplemented("AVM1MovieClip.getTrackAsMenu()");
            return getAwayObjectOrTemplate(this).trackAsMenu;
        };
        AVM1MovieClip.prototype.setTrackAsMenu = function (value) {
            notImplemented("AVM1MovieClip.setTrackAsMenu()");
            getAwayObjectOrTemplate(this).trackAsMenu = alToBoolean(this.context, value);
        };
        AVM1MovieClip.prototype.unloadMovie = function () {
            var nativeObject = this.adaptee;
            this.adaptee.constructedKeyFrameIndex = 0;
            this.adaptee.stop();
            nativeObject.removeChildren(0, nativeObject.numChildren);
            if ((this.dynamicallyCreated || this.hasSwappedDepth) && nativeObject.parent && nativeObject.parent.adapter) {
                nativeObject.parent.adapter.unregisterScriptObject(nativeObject);
            }
        };
        AVM1MovieClip.prototype.getUseHandCursor = function () {
            return this.adaptee.useHandCursor;
        };
        AVM1MovieClip.prototype.setUseHandCursor = function (value) {
            if (!this.adaptee)
                return;
            this.adaptee.useHandCursor = value;
        };
        AVM1MovieClip.prototype.setParameters = function (parameters) {
            for (var paramName in parameters) {
                if (!this.alHasProperty(paramName)) {
                    this.alPut(paramName, parameters[paramName]);
                }
            }
        };
        // Special and children names properties resolutions
        AVM1MovieClip.prototype._resolveLevelNProperty = function (name) {
            release$1 || assert$2(alIsName(this.context, name));
            if (name === '_level0') {
                return this.context.resolveLevel(0);
            }
            else if (name === '_root') {
                return this.context.resolveRoot();
            }
            else if (name.indexOf('_level') === 0) {
                var level = name.substring(6);
                var levelNum = level | 0;
                if (levelNum > 0 && level == levelNum) {
                    return this.context.resolveLevel(levelNum);
                }
            }
            return null;
        };
        AVM1MovieClip.prototype._getCachedPropertyResult = function (value) {
            if (!this._cachedPropertyResult) {
                this._cachedPropertyResult = {
                    flags: 64 /* DATA */ | 1 /* DONT_ENUM */, value: value
                };
            }
            else {
                this._cachedPropertyResult.value = value;
            }
            return this._cachedPropertyResult;
        };
        AVM1MovieClip.prototype.alGetOwnProperty = function (name) {
            var desc = _super.prototype.alGetOwnProperty.call(this, name);
            if (desc) {
                return desc;
            }
            if (name[0] === '_') {
                if ((name[1] === 'l' && name.indexOf('_level') === 0 ||
                    name[1] === 'r' && name.indexOf('_root') === 0)) {
                    var level = this._resolveLevelNProperty(name);
                    if (level) {
                        return this._getCachedPropertyResult(level);
                    }
                }
                else if (name.toLowerCase() in MovieClipProperties) {
                    // For MovieClip's properties that start from '_' case does not matter.
                    return _super.prototype.alGetOwnProperty.call(this, name.toLowerCase());
                }
            }
            if (hasAwayJSAdaptee(this)) {
                var child = this._lookupChildByName(name);
                if (child) {
                    return this._getCachedPropertyResult(child);
                }
            }
            return undefined;
        };
        AVM1MovieClip.prototype.alGetOwnPropertiesKeys = function () {
            var keys = _super.prototype.alGetOwnPropertiesKeys.call(this);
            // if it's a movie listing the children as well
            if (!hasAwayJSAdaptee(this)) {
                return keys; // not initialized yet
            }
            var as3MovieClip = this.adaptee;
            if (as3MovieClip._children.length === 0) {
                return keys; // no children
            }
            var processed = Object.create(null);
            var keysLength = keys.length;
            var i = 0;
            for (i = 0; i < keysLength; i++) {
                processed[keys[i]] = true;
            }
            var numChilds = as3MovieClip._children.length;
            var child = null;
            var name = null;
            var normalizedName = null;
            for (i = 0; i < numChilds; i++) {
                child = as3MovieClip._children[i];
                name = child.name;
                normalizedName = name; // TODO something like this._unescapeProperty(this._escapeProperty(name));
                processed[normalizedName] = true;
            }
            return Object.getOwnPropertyNames(processed);
        };
        AVM1MovieClip.prototype._init = function (initObject) {
            var _this = this;
            if (initObject instanceof AVM1Object) {
                alForEachProperty(initObject, function (name) {
                    _this.alPut(name, initObject.alGet(name));
                }, null);
            }
        };
        AVM1MovieClip.prototype._initEventsHandlers = function () {
            this.bindEvents(EventsListForMC);
        };
        AVM1MovieClip.currentMCAssetNameSpace = "";
        AVM1MovieClip.currentDraggedMC = null;
        // if a stop-action occurs, we check if a child with this name is present, and if so, we execute the function provided
        AVM1MovieClip.pokiSDKonStopActionChildName = null;
        AVM1MovieClip.pokiSDKonStopAction = null;
        AVM1MovieClip.capStyleMapStringToInt = { "none": 0, "round": 1, "square": 2 };
        AVM1MovieClip.jointStyleMapStringToInt = { "round": 0, "bevel": 1, "miter": 2 };
        AVM1MovieClip.noScaleDictionary = {
            'normal': LineScaleMode.NORMAL,
            'none': LineScaleMode.NONE,
            'vertical': LineScaleMode.VERTICAL,
            'horizontal': LineScaleMode.HORIZONTAL
        };
        return AVM1MovieClip;
    }(AVM1SymbolBase));

    function _updateAllSymbolEvents(symbolInstance) {
        if (!hasAwayJSAdaptee(symbolInstance)) {
            return;
        }
        symbolInstance.updateAllEvents();
    }
    var AVM1Broadcaster = /** @class */ (function (_super) {
        __extends(AVM1Broadcaster, _super);
        function AVM1Broadcaster() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1Broadcaster.createAVM1Class = function (context) {
            return wrapAVM1NativeClass(context, true, AVM1Broadcaster, ['initialize'], []);
        };
        AVM1Broadcaster.initialize = function (context, obj) {
            var desc = new AVM1PropertyDescriptor(64 /* DATA */ | 1 /* DONT_ENUM */, new AVM1ArrayNative(context, []));
            obj.alSetOwnProperty('_listeners', desc);
            desc = new AVM1PropertyDescriptor(64 /* DATA */ | 1 /* DONT_ENUM */, new AVM1NativeFunction(context, function broadcastMessage(eventName) {
                var args = [];
                for (var _i = 1; _i < arguments.length; _i++) {
                    args[_i - 1] = arguments[_i];
                }
                var listenersField = this.alGet('_listeners');
                if (!(listenersField instanceof AVM1ArrayNative)) {
                    return;
                }
                avm1BroadcastEvent(context, this, eventName, args);
            }));
            obj.alSetOwnProperty('broadcastMessage', desc);
            desc = new AVM1PropertyDescriptor(64 /* DATA */ | 1 /* DONT_ENUM */, new AVM1NativeFunction(context, function addListener(listener) {
                var listenersField = this.alGet('_listeners');
                if (!(listenersField instanceof AVM1ArrayNative)) {
                    return false;
                }
                var listeners = listenersField.value;
                listeners.push(listener);
                _updateAllSymbolEvents(this);
                return true;
            }));
            obj.alSetOwnProperty('addListener', desc);
            desc = new AVM1PropertyDescriptor(64 /* DATA */ | 1 /* DONT_ENUM */, new AVM1NativeFunction(context, function removeListener(listener) {
                var listenersField = this.alGet('_listeners');
                if (!(listenersField instanceof AVM1ArrayNative)) {
                    return false;
                }
                var listeners = listenersField.value;
                var i = listeners.indexOf(listener);
                if (i < 0) {
                    return false;
                }
                listeners.splice(i, 1);
                _updateAllSymbolEvents(this);
                return true;
            }));
            obj.alSetOwnProperty('removeListener', desc);
        };
        return AVM1Broadcaster;
    }(AVM1Object));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var capabilitiesProperties = [
        'avHardwareDisable', 'hasAccessibility', 'hasAudio', 'hasAudioEncoder',
        'hasEmbeddedVideo', 'hasIME', 'hasMP3', 'hasPrinting', 'hasScreenBroadcast',
        'hasScreenPlayback', 'hasStreamingAudio', 'hasStreamingVideo',
        'hasVideoEncoder', 'isDebugger', 'language', 'localFileReadDisable',
        'manufacturer', 'os', 'pixelAspectRatio', 'playerType', 'screenColor',
        'screenDPI', 'screenResolutionX', 'screenResolutionY', 'serverString',
        'version'
    ];
    var AVM1Capabilities = /** @class */ (function (_super) {
        __extends(AVM1Capabilities, _super);
        function AVM1Capabilities(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            //var as3Capabilities = context.sec.flash.system.Capabilities.axClass;
            var getter = null;
            var desc = null;
            capabilitiesProperties.forEach(function (name) {
                getter = { alCall: function () { return null; } }; //as3Capabilities.axGetPublicProperty(name); }};
                desc = new AVM1PropertyDescriptor(128 /* ACCESSOR */ |
                    2 /* DONT_DELETE */ |
                    1 /* DONT_ENUM */, null, getter);
                _this.alSetOwnProperty(name, desc);
            }, _this);
            return _this;
        }
        return AVM1Capabilities;
    }(AVM1Object));
    var AVM1Security = /** @class */ (function (_super) {
        __extends(AVM1Security, _super);
        function AVM1Security(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                sandboxType: {
                    get: _this.getSandboxType
                },
                allowDomain: {
                    value: _this.allowDomain
                },
                allowInsecureDomain: {
                    value: _this.allowInsecureDomain
                },
                loadPolicyFile: {
                    value: _this.loadPolicyFile
                }
            });
            return _this;
        }
        AVM1Security.prototype.getSandboxType = function () {
            return null; //this.context.sec.flash.system.Security.axClass.sandboxType;
        };
        AVM1Security.prototype.allowDomain = function (domain) {
            domain = alCoerceString(this.context, domain);
            //this.context.sec.flash.system.Security.axClass.allowDomain(domain);
        };
        AVM1Security.prototype.allowInsecureDomain = function (domain) {
            domain = alCoerceString(this.context, domain);
            //this.context.sec.flash.system.Security.axClass.allowInsecureDomain(domain);
        };
        AVM1Security.prototype.loadPolicyFile = function (url) {
            url = alCoerceString(this.context, url);
            //this.context.sec.flash.system.Security.axClass.loadPolicyFile(url);
        };
        return AVM1Security;
    }(AVM1Object));
    var AVM1System = /** @class */ (function (_super) {
        __extends(AVM1System, _super);
        function AVM1System() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1System.alInitStatic = function (context) {
            this._capabilities = new AVM1Capabilities(context);
            this._security = new AVM1Security(context);
        };
        AVM1System.createAVM1Class = function (context) {
            return wrapAVM1NativeClass(context, false, AVM1System, ['capabilities#', 'security#'], []);
        };
        AVM1System.getCapabilities = function (context) {
            var staticState = context.getStaticState(AVM1System);
            return staticState._capabilities;
        };
        AVM1System.getSecurity = function (context) {
            var staticState = context.getStaticState(AVM1System);
            return staticState._security;
        };
        return AVM1System;
    }(AVM1Object));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var StateTransitions;
    (function (StateTransitions) {
        StateTransitions[StateTransitions["IdleToOverUp"] = 1] = "IdleToOverUp";
        StateTransitions[StateTransitions["OverUpToIdle"] = 2] = "OverUpToIdle";
        StateTransitions[StateTransitions["OverUpToOverDown"] = 4] = "OverUpToOverDown";
        StateTransitions[StateTransitions["OverDownToOverUp"] = 8] = "OverDownToOverUp";
        StateTransitions[StateTransitions["OverDownToOutDown"] = 16] = "OverDownToOutDown";
        StateTransitions[StateTransitions["OutDownToOverDown"] = 32] = "OutDownToOverDown";
        StateTransitions[StateTransitions["OutDownToIdle"] = 64] = "OutDownToIdle";
        StateTransitions[StateTransitions["IdleToOverDown"] = 128] = "IdleToOverDown";
        StateTransitions[StateTransitions["OverDownToIdle"] = 256] = "OverDownToIdle"; // ???
    })(StateTransitions || (StateTransitions = {}));
    /**
     * Key codes below 32 aren't interpreted as char codes, but are mapped to specific buttons instead.
     * This array uses the key code as the index and KeyboardEvent.keyCode values matching the
     * specific keys as the value.
     * @type {number[]}
     */
    var AVM1KeyCodeMap$1 = [-1, 37, 39, 36, 35, 45, 46, -1, 8, -1, -1, -1, -1, 13, 38, 40, 33, 34, 9, 27];
    var buttonActionsMap = {
        1: ClipEventMappings[8192 /* RollOver */],
        2: ClipEventMappings[16384 /* RollOut */],
        4: ClipEventMappings[1024 /* Press */],
        8: ClipEventMappings[2048 /* Release */],
        64: ClipEventMappings[4096 /* ReleaseOutside */],
        160: ClipEventMappings[32768 /* DragOver */],
        272: ClipEventMappings[65536 /* DragOut */]
    };
    var AVM1Button = /** @class */ (function (_super) {
        __extends(AVM1Button, _super);
        function AVM1Button() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1Button.createAVM1Class = function (context) {
            return wrapAVM1NativeClass(context, true, AVM1Button, [], ['$version#', '_alpha#', 'getAwayJSID', 'attachAudio', 'attachBitmap', 'attachMovie',
                'beginFill', 'beginBitmapFill', 'beginGradientFill', 'blendMode#',
                'cacheAsBitmap#', '_callFrame', 'clear', 'createEmptyMovieClip',
                'createTextField', '_currentframe#', 'curveTo', '_droptarget#',
                'duplicateMovieClip', 'enabled#', 'endFill', 'filters#', '_framesloaded#',
                '_focusrect#', 'forceSmoothing#', 'getBounds',
                'getBytesLoaded', 'getBytesTotal', 'getDepth', 'getInstanceAtDepth',
                'getNextHighestDepth', 'getRect', 'getSWFVersion', 'getTextSnapshot',
                'getURL', 'globalToLocal', 'gotoAndPlay', 'gotoAndStop', '_height#',
                '_highquality#', 'hitArea#', 'hitTest', 'lineGradientStyle', 'lineStyle',
                'lineTo', 'loadMovie', 'loadVariables', 'localToGlobal', '_lockroot#',
                'menu#', 'moveTo', '_name#', 'nextFrame', 'opaqueBackground#', '_parent#',
                'play', 'prevFrame', '_quality#', 'removeMovieClip', '_root#', '_rotation#',
                'scale9Grid#', 'scrollRect#', 'setMask', '_soundbuftime#', 'startDrag',
                'stop', 'stopDrag', 'swapDepths', 'tabChildren#', 'tabEnabled#', 'tabIndex#',
                '_target#', '_totalframes#', 'trackAsMenu#', 'toString',
                'unloadMovie', '_url#', 'useHandCursor#', '_visible#', '_width#',
                '_x#', '_xmouse#', '_xscale#', '_y#', '_ymouse#', '_yscale#']);
        };
        AVM1Button.prototype._updateMouseEnabled = function (event, enabled) {
            if (!this.adaptee.isAVMScene) {
                if (event.isMouse) {
                    if (enabled) {
                        this._mouseListenerCount++;
                        this.adaptee.mouseEnabled = true;
                        this.adaptee.mouseChildren = false;
                        if (event.isButton) {
                            this._mouseButtonListenerCount++;
                            this.adaptee.buttonMode = true;
                        }
                    }
                    else {
                        this._mouseListenerCount--;
                        if (this._mouseListenerCount <= 0) {
                            this._mouseListenerCount = 0;
                            this.adaptee.mouseEnabled = false;
                            this.adaptee.mouseChildren = false;
                        }
                        if (event.isButton) {
                            this._mouseButtonListenerCount--;
                            if (this._mouseButtonListenerCount <= 0) {
                                this._mouseButtonListenerCount = 0;
                                this.adaptee.buttonMode = false;
                            }
                        }
                    }
                }
            }
        };
        AVM1Button.prototype.initAVM1SymbolInstance = function (context, awayObject) {
            _super.prototype.initAVM1SymbolInstance.call(this, context, awayObject);
            var nativeButton = this.adaptee;
            var requiredListeners = this._requiredListeners = Object.create(null);
            var actions = this._actions = nativeButton.timeline.avm1ButtonActions;
            var action = null;
            var boundListener = null;
            var foundValidAction = false;
            var actionsLength = actions.length;
            for (var i = 0; i < actionsLength; i++) {
                action = actions[i];
                if (!action.actionsBlock) {
                    action.actionsBlock = context.actionsDataFactory.createActionsData(action.actionsData, 's' + nativeButton.id + 'e' + i);
                }
                if (action.keyCode) {
                    //requiredListeners['keyDown'] = this._keyDownHandler.bind(this);
                    //continue;
                }
                if (action.stateTransitionFlags != 0) {
                    boundListener = this._mouseEventHandler.bind(this, action.stateTransitionFlags);
                    foundValidAction = false;
                    for (var key in buttonActionsMap) {
                        if (action.stateTransitionFlags & parseInt(key)) {
                            foundValidAction = true;
                            //console.log("added event for name:",buttonActionsMap[key].eventName)
                            requiredListeners[buttonActionsMap[key].eventName] = { handler: buttonActionsMap[key], boundListener: boundListener };
                        }
                    }
                    if (!foundValidAction) {
                        console.warn("unknown button event flag", action.stateTransitionFlags);
                    }
                }
            }
            this.adaptee.addButtonListeners();
            this._initEventsHandlers();
            this._addListeners();
        };
        AVM1Button.prototype.initAdapter = function () {
            _super.prototype.initAdapter.call(this);
            this._addListeners();
        };
        AVM1Button.prototype.stop = function () {
            return this.adaptee.stop();
        };
        AVM1Button.prototype.getEnabled = function () {
            return this.enabled;
        };
        AVM1Button.prototype.setEnabled = function (value) {
            this.adaptee.buttonEnabled = value;
            if (value == this.enabled)
                return;
            this.enabled = value;
            this.setEnabledListener(value);
            this.adaptee.mouseEnabled = true;
        };
        AVM1Button.prototype.getTrackAsMenu = function () {
            notImplemented("AVM1Textfield.getTrackAsMenu");
            return false; //getAwayObjectOrTemplate(this).trackAsMenu;
        };
        AVM1Button.prototype.setTrackAsMenu = function (value) {
            notImplemented("AVM1Textfield.setTrackAsMenu");
            //getAwayObjectOrTemplate(this).trackAsMenu = alToBoolean(this.context, value);
        };
        AVM1Button.prototype._addListeners = function () {
            for (var type in this._requiredListeners) {
                this._eventHandlers[type] = this._requiredListeners[type].handler;
                this._eventsListeners[type] = this._requiredListeners[type].boundListener;
            }
            this.setEnabledListener(this.enabled);
        };
        AVM1Button.prototype._removeListeners = function () {
            var target = null;
            for (var type in this._requiredListeners) {
                //var target: EventDispatcher = type === 'keyDown' ?	(<any>this.adaptee).stage :	this.adaptee;
                target = this.adaptee;
                target.removeEventListener(type, this._requiredListeners[type].boundListener);
            }
        };
        AVM1Button.prototype._keyDownHandler = function (event) {
            var actions = this._actions;
            var actionsLength = actions.length;
            for (var i = 0; i < actionsLength; i++) {
                var action = actions[i];
                if (!action.keyCode) {
                    continue;
                }
                if ((action.keyCode < 32 &&
                    AVM1KeyCodeMap$1[action.keyCode] === event.axGetPublicProperty('keyCode')) ||
                    action.keyCode === event.axGetPublicProperty('charCode')) {
                    this._runAction(action);
                }
            }
        };
        AVM1Button.prototype._mouseEventHandler = function (type) {
            var actions = this._actions;
            var actionsLength = actions.length;
            for (var i = 0; i < actionsLength; i++) {
                var action = actions[i];
                if (action.stateTransitionFlags === type) {
                    this._runAction(action);
                }
            }
        };
        AVM1Button.prototype._runAction = function (action) {
            var avm1Context = this._avm1Context; // (<LoaderInfo>this.adaptee.loaderInfo)._avm1Context;
            if (this.adaptee.parent) {
                avm1Context.executeActions(action.actionsBlock, getAVM1Object(this.adaptee.parent, this.context));
            }
        };
        AVM1Button.prototype._initEventsHandlers = function () {
            this.bindEvents(EventsListForButton);
        };
        return AVM1Button;
    }(AVM1MovieClip));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AVM1Color = /** @class */ (function (_super) {
        __extends(AVM1Color, _super);
        function AVM1Color() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1Color.createAVM1Class = function (context) {
            return wrapAVM1NativeClass(context, true, AVM1Color, [], ['getRGB', 'getTransform', 'setRGB', 'setTransform'], null, AVM1Color.prototype.avm1Constructor);
        };
        AVM1Color.prototype.avm1Constructor = function (target_mc) {
            if (target_mc) {
                this._target = this.context.resolveTarget(target_mc);
                if (this._target && this._target.adaptee && !this._target.adaptee.isAVMScene) {
                    this._target.avmColor = this;
                    this._targetAwayObject = getAwayJSAdaptee(this._target);
                }
            }
        };
        AVM1Color.prototype.changeTarget = function (target_mc) {
            if (target_mc && target_mc instanceof AVM1SymbolBase) {
                this._target = target_mc;
                this._target.avmColor = this;
                this._target._ctBlockedByScript = true;
                this._targetAwayObject = getAwayJSAdaptee(this._target);
            }
            else {
                this._target = null;
            }
        };
        AVM1Color.prototype.getRGB = function () {
            var transform = AVM1Color.prototype.getTransform.call(this);
            if (transform)
                return transform.getRgb();
            return null;
        };
        AVM1Color.prototype.getTransform = function () {
            if (this._targetAwayObject) {
                return AVM1ColorTransform.fromAwayColorTransform(this.context, this._targetAwayObject.transform.colorTransform);
            }
            return null;
        };
        AVM1Color.prototype.setRGB = function (offset) {
            var transform = AVM1Color.prototype.getTransform.call(this);
            if (transform) {
                transform.setRgb(offset);
                AVM1Color.prototype.setTransform.call(this, transform);
            }
            if (this._target)
                this._target._ctBlockedByScript = true;
        };
        AVM1Color.prototype.setTransform = function (transform) {
            if (this._targetAwayObject && transform) {
                var tf = transform;
                if (!(transform instanceof AVM1ColorTransform)) {
                    if (transform instanceof AVM1Object) {
                        tf = fromAVM1Object(transform);
                    }
                }
                if (tf) {
                    this._targetAwayObject.transform.colorTransform._rawData[0] = tf._rawData[0];
                    this._targetAwayObject.transform.colorTransform._rawData[1] = tf._rawData[1];
                    this._targetAwayObject.transform.colorTransform._rawData[2] = tf._rawData[2];
                    this._targetAwayObject.transform.colorTransform._rawData[3] = tf._rawData[3];
                    this._targetAwayObject.transform.colorTransform._rawData[4] = tf._rawData[4];
                    this._targetAwayObject.transform.colorTransform._rawData[5] = tf._rawData[5];
                    this._targetAwayObject.transform.colorTransform._rawData[6] = tf._rawData[6];
                    this._targetAwayObject.transform.colorTransform._rawData[7] = tf._rawData[7];
                    this._targetAwayObject.transform.invalidateColorTransform();
                    this._targetAwayObject.invalidate();
                    this._targetAwayObject._invalidateHierarchicalProperties(HierarchicalProperties.COLOR_TRANSFORM);
                }
            }
            if (this._target)
                this._target._ctBlockedByScript = true;
        };
        return AVM1Color;
    }(AVM1Object));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AVM1Key = /** @class */ (function (_super) {
        __extends(AVM1Key, _super);
        function AVM1Key() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1Key.createAVM1Class = function (context) {
            var wrapped = wrapAVM1NativeClass(context, false, AVM1Key, ['BACKSPACE', 'CAPSLOCK', 'CONTROL', 'DELETEKEY', 'DOWN',
                'END', 'ENTER', 'ESCAPE', 'HOME', 'INSERT', 'LEFT',
                'PGDN', 'PGUP', 'RIGHT', 'SHIFT', 'SPACE', 'TAB', 'UP', 'isDown', 'getCode'], []);
            return wrapped;
        };
        AVM1Key.alInitStatic = function (context) {
            this._keyStates = [];
            this._lastKeyCode = 0;
        };
        AVM1Key.bindStage = function (context, cls, stage, htmlElement) {
            if (AVM1Key.keyDownDelegate)
                htmlElement.removeEventListener('keydown', AVM1Key.keyDownDelegate);
            if (AVM1Key.keyUpDelegate)
                htmlElement.removeEventListener('keyup', AVM1Key.keyUpDelegate);
            AVM1Key.keyDownDelegate = function (e) {
                var staticState = context.getStaticState(AVM1Key);
                staticState._lastKeyCode = e.keyCode;
                staticState._keyStates[e.keyCode] = 1;
                alCallProperty(cls, 'broadcastMessage', ['onKeyDown']);
            };
            AVM1Key.keyUpDelegate = function (e) {
                var staticState = context.getStaticState(AVM1Key);
                staticState._lastKeyCode = e.keyCode;
                delete staticState._keyStates[e.keyCode];
                alCallProperty(cls, 'broadcastMessage', ['onKeyUp']);
            };
            htmlElement.addEventListener('keydown', AVM1Key.keyDownDelegate);
            htmlElement.addEventListener('keyup', AVM1Key.keyUpDelegate);
        };
        AVM1Key.isDown = function (context, code) {
            var staticState = context.getStaticState(AVM1Key);
            return !!staticState._keyStates[code];
        };
        AVM1Key.getCode = function (context) {
            var staticState = context.getStaticState(AVM1Key);
            return staticState._lastKeyCode;
        };
        AVM1Key.BACKSPACE = 8;
        AVM1Key.CAPSLOCK = 20;
        AVM1Key.CONTROL = 17;
        AVM1Key.DELETEKEY = 46;
        AVM1Key.DOWN = 40;
        AVM1Key.END = 35;
        AVM1Key.ENTER = 13;
        AVM1Key.ESCAPE = 27;
        AVM1Key.HOME = 36;
        AVM1Key.INSERT = 45;
        AVM1Key.LEFT = 37;
        AVM1Key.PGDN = 34;
        AVM1Key.PGUP = 33;
        AVM1Key.RIGHT = 39;
        AVM1Key.SHIFT = 16;
        AVM1Key.SPACE = 32;
        AVM1Key.TAB = 9;
        AVM1Key.UP = 38;
        AVM1Key.keyDownDelegate = null;
        AVM1Key.keyUpDelegate = null;
        return AVM1Key;
    }(AVM1Object));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AVM1Mouse = /** @class */ (function (_super) {
        __extends(AVM1Mouse, _super);
        function AVM1Mouse() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1Mouse.createAVM1Class = function (context) {
            var wrapped = wrapAVM1NativeClass(context, false, AVM1Mouse, ['show', 'hide'], []);
            return wrapped;
        };
        AVM1Mouse.bindStage = function (context, cls, stage, htmlElement) {
            if (AVM1Mouse.mouseDownDelegate)
                stage.removeEventListener('keydown', AVM1Mouse.mouseDownDelegate);
            if (AVM1Mouse.mouseMoveDelegate)
                stage.removeEventListener('keyup', AVM1Mouse.mouseMoveDelegate);
            if (AVM1Mouse.mouseOutDelegate)
                stage.removeEventListener('keyup', AVM1Mouse.mouseOutDelegate);
            if (AVM1Mouse.mouseUpDelegate)
                stage.removeEventListener('keyup', AVM1Mouse.mouseUpDelegate);
            AVM1Mouse.mouseDownDelegate = function (e) {
                alCallProperty(cls, 'broadcastMessage', ['onMouseDown']);
            };
            AVM1Mouse.mouseMoveDelegate = function (e) {
                alCallProperty(cls, 'broadcastMessage', ['onMouseMove']);
            };
            AVM1Mouse.mouseOutDelegate = function (e) {
                alCallProperty(cls, 'broadcastMessage', ['onMouseOut']);
            };
            AVM1Mouse.mouseUpDelegate = function (e) {
                alCallProperty(cls, 'broadcastMessage', ['onMouseUp']);
            };
            stage.addEventListener('mouseDown', AVM1Mouse.mouseDownDelegate);
            stage.addEventListener('mouseMove', AVM1Mouse.mouseMoveDelegate);
            stage.addEventListener('mouseOut', AVM1Mouse.mouseOutDelegate);
            stage.addEventListener('mouseUp', AVM1Mouse.mouseUpDelegate);
        };
        AVM1Mouse.hide = function () {
            AVM1Globals.instance.Stage._awayAVMStage.scene.mouseManager.showCursor = false;
        };
        AVM1Mouse.show = function () {
            AVM1Globals.instance.Stage._awayAVMStage.scene.mouseManager.showCursor = true;
        };
        AVM1Mouse.mouseDownDelegate = null;
        AVM1Mouse.mouseMoveDelegate = null;
        AVM1Mouse.mouseOutDelegate = null;
        AVM1Mouse.mouseUpDelegate = null;
        return AVM1Mouse;
    }(AVM1Object));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AVM1MovieClipLoader = /** @class */ (function (_super) {
        __extends(AVM1MovieClipLoader, _super);
        function AVM1MovieClipLoader() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1MovieClipLoader.createAVM1Class = function (context) {
            return wrapAVM1NativeClass(context, true, AVM1MovieClipLoader, [], ['loadClip', 'unloadClip', 'getProgress'], null, AVM1MovieClipLoader.prototype.avm1Constructor);
        };
        AVM1MovieClipLoader.prototype.avm1Constructor = function () {
            AVM1Broadcaster.initialize(this.context, this);
        };
        AVM1MovieClipLoader.prototype.loadClip = function (url, target) {
            var loadLevel = typeof target === 'number';
            var level;
            var target_mc;
            if (loadLevel) {
                level = target;
                if (level === 0) {
                    notImplemented('MovieClipLoader.loadClip at _level0');
                    return false;
                }
            }
            else {
                target_mc = this.context.resolveTarget(target);
                if (!target_mc) {
                    return false; // target was not found -- doing nothing
                }
            }
            var loaderHelper = new AVM1LoaderHelper(this.context);
            this._loaderHelper = loaderHelper;
            this._target = null;
            //80pro todo
            /*
            loaderInfo.addEventListener(Event.OPEN, this.openHandler.bind(this));
            loaderInfo.addEventListener(ProgressEvent.PROGRESS, this.progressHandler.bind(this));
            loaderInfo.addEventListener(IOErrorEvent.IO_ERROR, this.ioErrorHandler.bind(this));
            loaderInfo.addEventListener(Event.COMPLETE, this.completeHandler.bind(this));
            loaderInfo.addEventListener(Event.INIT, this.initHandler.bind(this));

            loaderHelper.load(url, null).then(function () {
                var newChild = loaderHelper.content;
                this._target = getAVM1Object(newChild, this.context);

                if (loadLevel) {
                    var avm1LevelHolder = this.context.levelsContainer;
                    avm1LevelHolder._addRoot(level, newChild);
                } else {
                    // TODO fix newChild name to match target_mc
                    var parent = target_mc.adaptee.parent;
                    var depth = target_mc.adaptee._depth;
                    parent.removeChild(target_mc.adaptee);
                    parent.addTimelineObjectAtDepth(newChild, depth);
                }
            }.bind(this));
            */
            return true;
        };
        AVM1MovieClipLoader.prototype.unloadClip = function (target) {
            notImplemented('MovieClipLoader.unloadClip');
            /*
            if (!this._loaderHelper) {
                return false; // nothing was loaded by this loader
            }
            var loadLevel: boolean = typeof target === 'number';
            var level: number;
            var target_mc: AVM1MovieClip;
            var originalLoader = this._loaderHelper.loader;
            if (loadLevel) {
                level = <number>target;
                if (level === 0) {
                    release || Debug.notImplemented('MovieClipLoader.unloadClip at _level0');
                    return false;
                }
                var avm1LevelHolder = this.context.levelsContainer;
                if (avm1LevelHolder._getRootForLevel(level) !== originalLoader.content) {
                    return false; // did not load this root
                }
                avm1LevelHolder._removeRoot(level);
            } else {
                target_mc = target ? this.context.resolveTarget(target) : undefined;
                if (!target_mc) {
                    return false; // target was not found -- doing nothing
                }
                if (target_mc.adaptee !== originalLoader.content) {
                    return false; // did not load this movie clip
                }
                target_mc.unloadMovie();
            }
            this._target = null;
            this._loaderHelper = null;
            // TODO: find out under which conditions unloading a clip can fail
            */
            return true;
        };
        AVM1MovieClipLoader.prototype.getProgress = function (target) {
            return this._loaderHelper.loaderInfo.bytesLoaded;
        };
        return AVM1MovieClipLoader;
    }(AVM1Object));

    /**
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function loadAVM1DataObject(context, url, method, contentType, data, target) {
        var request = new URLRequest(url);
        if (method) {
            request.method = method;
        }
        if (data) {
            release$1 || Debug$1.assert(typeof data === 'string');
            request.data = data;
        }
        var loader = new URLLoader();
        loader.dataFormat = 'text'; // flash.net.URLLoaderDataFormat.TEXT;
        var completeHandler = function (event) {
            loader.removeEventListener(URLLoaderEvent.LOAD_COMPLETE, completeHandler);
            release$1 || Debug$1.assert(typeof loader.data === 'string');
            avm1BroadcastEvent(context, target, 'onData', [loader.data]);
        };
        loader.addEventListener(URLLoaderEvent.LOAD_COMPLETE, completeHandler);
        target._as3Loader = loader;
        loader.load(request);
    }
    var AVM1LoadVarsFunction = /** @class */ (function (_super) {
        __extends(AVM1LoadVarsFunction, _super);
        function AVM1LoadVarsFunction(context) {
            var _this = _super.call(this, context) || this;
            _this.alSetOwnPrototypeProperty(new AVM1LoadVarsPrototype(context, _this));
            return _this;
        }
        AVM1LoadVarsFunction.prototype.alConstruct = function (args) {
            var obj = new AVM1Object(this.context);
            obj.alPrototype = this.alGetPrototypeProperty();
            obj.isAVM1DataObject = true;
            return obj;
        };
        AVM1LoadVarsFunction.prototype.alCall = function (thisArg, args) {
            return this.alConstruct(args);
        };
        return AVM1LoadVarsFunction;
    }(AVM1Function));
    var AVM1LoadVarsPrototype = /** @class */ (function (_super) {
        __extends(AVM1LoadVarsPrototype, _super);
        function AVM1LoadVarsPrototype(context, fn) {
            var _this = _super.call(this, context) || this;
            alDefineObjectProperties(_this, {
                constructor: {
                    value: fn,
                    writable: true
                },
                toString: {
                    value: _this._toString
                },
                load: {
                    value: _this.load
                },
                onData: {
                    value: _this.defaultOnData
                },
                decode: {
                    value: _this.decode
                },
                send: {
                    value: _this.load
                },
                sendAndload: {
                    value: _this.load
                }
            });
            return _this;
        }
        AVM1LoadVarsPrototype.prototype.getBytesLoaded = function () {
            if (!this._as3Loader) {
                return undefined;
            }
            return this._as3Loader.bytesLoaded;
        };
        AVM1LoadVarsPrototype.prototype.getBytesTotal = function () {
            if (!this._as3Loader) {
                return undefined;
            }
            return this._as3Loader.bytesTotal;
        };
        AVM1LoadVarsPrototype.prototype.load = function (url) {
            url = alCoerceString(this.context, url);
            if (!url) {
                return false;
            }
            loadAVM1DataObject(this.context, url, null, null, null, this);
            return true;
        };
        AVM1LoadVarsPrototype.prototype.defaultOnData = function (src) {
            if (isNullOrUndefined$1(src)) {
                avm1BroadcastEvent(this.context, this, 'onLoad', [false]);
                return;
            }
            AVM1LoadVarsPrototype.prototype.decode.call(this, src);
            this.alPut('loaded', true);
            avm1BroadcastEvent(this.context, this, 'onLoad', [true]);
        };
        AVM1LoadVarsPrototype.prototype.decode = function (queryString) {
            queryString = alCoerceString(this.context, queryString);
            /*var as3Variables = new URLVariables();
            as3Variables._ignoreDecodingErrors = true;
            as3Variables.decode(queryString);
            forEachPublicProperty(as3Variables, function (name, value) {
                // TODO Are we leaking some AS3 properties/fields here?
                if (typeof value === 'string') {
                    this.alPut(name, value);
                }
            }, this);*/
        };
        AVM1LoadVarsPrototype.prototype._toString = function () {
            var context = this.context;
            /*var as3Variables = new context.sec.flash.net.URLVariables();
            alForEachProperty(this, function (name) {
                if (this.alHasOwnProperty(name)) {
                    as3Variables.axSetPublicProperty(name, alToString(context, this.alGet(name)));
                }
            }, this);
            return as3Variables.axCallPublicProperty('toString', null);*/
            return "";
        };
        AVM1LoadVarsPrototype.prototype.send = function (url, target, method) {
            url = alCoerceString(this.context, url);
            method = isNullOrUndefined$1(method) ? 'POST' : alCoerceString(this.context, method);
            notImplemented('AVM1LoadVarsPrototype.send');
            return false;
        };
        AVM1LoadVarsPrototype.prototype.sendAndLoad = function (url, target, method) {
            url = alCoerceString(this.context, url);
            method = isNullOrUndefined$1(method) ? 'POST' : alCoerceString(this.context, method);
            if (!url || !(target instanceof AVM1Object)) {
                return false;
            }
            if (!target.isAVM1DataObject) {
                return false;
            }
            var contentType = this.alGet('contentType');
            contentType = isNullOrUndefined$1(contentType) ?
                'application/x-www-form-urlencoded' :
                alCoerceString(this.context, contentType);
            var data = alToString(this.context, this);
            loadAVM1DataObject(this.context, url, method, contentType, data, target);
            return true;
        };
        return AVM1LoadVarsPrototype;
    }(AVM1Object));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AVM1Sound = /** @class */ (function (_super) {
        __extends(AVM1Sound, _super);
        function AVM1Sound() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.loopsToPlay = 0;
            return _this;
        }
        AVM1Sound.createAVM1Class = function (context) {
            return wrapAVM1NativeClass(context, true, AVM1Sound, [], ['attachSound', 'duration#', 'getBytesLoaded', 'getBytesTotal',
                'getPan', 'setPan', 'getTransform', 'setTransform', 'getVolume', 'setVolume',
                'start', 'stop', 'onSoundComplete'], null, AVM1Sound.prototype.avm1Constructor);
        };
        AVM1Sound.prototype.avm1Constructor = function (target_mc) {
            this._target = this.context.resolveTarget(target_mc);
            this._sound = null;
            this._channel = null;
            this._linkageID = null;
            this._assetNameSpace = AVM1MovieClip.currentMCAssetNameSpace;
        };
        AVM1Sound.prototype.alPut = function (p, v) {
            _super.prototype.alPut.call(this, p, v);
            if (p && p.toLowerCase() == "onsoundcomplete") {
                this.onSoundComplete(v);
            }
        };
        AVM1Sound.prototype.alDeleteProperty = function (p) {
            _super.prototype.alDeleteProperty.call(this, p);
            if (p && p.toLowerCase() == "onsoundcomplete") {
                this.onSoundComplete();
            }
            return true;
        };
        AVM1Sound.prototype.attachSound = function (id) {
            var _this = this;
            if (typeof id !== "string" && typeof id !== "number")
                return;
            var symbol = AssetLibrary.getAsset(id, this._assetNameSpace);
            if (!symbol) {
                warning("AVM1Sound.attachSound no symbol found " + id);
                return;
            }
            this._linkageID = id;
            this._sound = symbol.clone();
            if (!this._sound) {
                warning("AVM1Sound.attachSound no WaveAudio found " + id);
                return;
            }
            this._sound.onSoundComplete = function () { return _this.soundCompleteInternal(); };
        };
        AVM1Sound.prototype.soundCompleteInternal = function () {
            this.loopsToPlay--;
            if (this.loopsToPlay > 0) {
                this.stop();
                this._sound.play(0, false);
            }
            else {
                if (this._onCompleteCallback) {
                    this._onCompleteCallback();
                }
            }
        };
        AVM1Sound.prototype.onSoundComplete = function (callback) {
            if (callback === void 0) { callback = null; }
            var myThis = this;
            this._onCompleteCallback = null;
            if (callback) {
                this._onCompleteCallback = function () {
                    callback.alCall(myThis);
                };
            }
            if (!this._sound) {
                warning("AVM1Sound.onSoundComplete called, but no WaveAudio set");
                return;
            }
        };
        AVM1Sound.prototype.loadSound = function (url, isStreaming) {
            console.warn("AVM1Sound.loadSound");
        };
        AVM1Sound.prototype.getBytesLoaded = function () {
            console.warn("AVM1Sound.getBytesLoaded");
            return 0;
        };
        AVM1Sound.prototype.getBytesTotal = function () {
            console.warn("AVM1Sound.getBytesTotal");
            return 0;
        };
        AVM1Sound.prototype.getDuration = function () {
            console.warn("AVM1Sound.getDuration");
            return 0;
        };
        AVM1Sound.prototype.getPan = function () {
            console.warn("AVM1Sound.getPan");
            // todo 80pro var transform: ASObject =(<ASObject> this._channel && this._channel.soundTransform);
            return 0; //transform ? transform.axGetPublicProperty('pan') * 100 : 0;
        };
        AVM1Sound.prototype.setPan = function (value) {
            console.warn("AVM1Sound.setPan");
            // todo 80pro
            /*
            var transform: ASObject = this._channel && this._channel.soundTransform;
            if (transform) {
                transform.axSetPublicProperty('pan', value / 100);
                this._channel.soundTransform = <SoundTransform>transform;
            }
            */
        };
        AVM1Sound.prototype.getTransform = function () {
            console.warn("AVM1Sound.getTransform");
            return null;
        };
        AVM1Sound.prototype.setTransform = function (transformObject) {
            console.warn("AVM1Sound.setTransform");
        };
        AVM1Sound.prototype.getVolume = function () {
            if (!this._sound) {
                console.warn("AVM1Sound.getVolume called, but no WaveAudio set");
                return 100;
            }
            return this._sound.volume * 100;
        };
        AVM1Sound.prototype.setVolume = function (value) {
            if (!this._sound) {
                console.warn("AVM1Sound.setVolume called, but no WaveAudio set");
                return;
            }
            if (this._target && this._target.adaptee) {
                this._target.adaptee.soundVolume = value / 100;
            }
            this._sound.volume = value / 100;
        };
        AVM1Sound.prototype.start = function (secondOffset, loops) {
            if (!this._sound) {
                warning("AVM1Sound.start called, but no WaveAudio set");
                return;
            }
            secondOffset = isNaN(secondOffset) || secondOffset < 0 ? 0 : +secondOffset;
            loops = isNaN(loops) || loops < 1 ? 1 : Math.floor(loops);
            this.loopsToPlay = loops;
            if (this._target && this._target.adaptee) {
                this._target.adaptee.startSound(this._linkageID, this._sound, this.loopsToPlay);
            }
            //this._sound.play(secondOffset, false);
        };
        AVM1Sound.prototype.stop = function (linkageID) {
            if (!this._sound) {
                warning("AVM1Sound.stop called, but no WaveAudio set");
                return;
            }
            if (this._target && this._target.adaptee) {
                this._target.adaptee.stopSounds(this._linkageID);
            }
        };
        return AVM1Sound;
    }(AVM1Object));

    /**
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AVM1SharedObject = /** @class */ (function (_super) {
        __extends(AVM1SharedObject, _super);
        function AVM1SharedObject(context) {
            var _this = _super.call(this, context) || this;
            alDefineObjectProperties(_this, {
                data: {
                    get: _this.getData
                },
                clear: {
                    value: _this.clear,
                    writable: true
                },
                flush: {
                    value: _this.flush,
                    writable: true
                }
            });
            return _this;
        }
        AVM1SharedObject.createAVM1Class = function (context) {
            return wrapAVM1NativeClass(context, true, AVM1SharedObject, ['getLocal'], ['data#', 'flush', 'clear']);
        };
        AVM1SharedObject.prototype.setName = function (name) {
            this._data = alNewObject(this.context);
            name = alCoerceString(this.context, name);
            this._storage_name = name;
            if (typeof (Storage) !== "undefined") {
                var jsData = JSON.parse(localStorage.getItem(name));
                if (jsData) {
                    this._data = this.getAVM1Value(jsData);
                }
            }
            console.log("no shared object found");
            return null; //context.sec.flash.external.ExternalInterface.axClass.available;
        };
        AVM1SharedObject.getLocal = function (context, name, localPath, secure) {
            if (localPath || secure) {
                console.warn("SharedObject.getLocal: params 'localPath' and 'secure' not supported");
            }
            //localPath = alCoerceString(this.context, localPath);
            //secure = alToBoolean(this.context, secure);
            var newSharedObj = new AVM1SharedObject(context);
            newSharedObj.setName(name);
            return newSharedObj;
        };
        AVM1SharedObject.prototype.getData = function () {
            return this._data;
        };
        AVM1SharedObject.prototype.clear = function () {
            //this._as3SharedObject.clear();
        };
        AVM1SharedObject.prototype.getAVM1Value = function (jsValue) {
            if (typeof jsValue === "number" || typeof jsValue === "string" || typeof jsValue === "boolean") {
                return jsValue;
            }
            if (Array.isArray(jsValue)) {
                for (var i = 0; i < jsValue.length; i++) {
                    jsValue[i] = this.getAVM1Value(jsValue[i]);
                }
                return new AVM1ArrayNative(this.context, jsValue);
            }
            if (typeof jsValue === "object") {
                var newAVM1Obj = alNewObject(this.context);
                for (var key in jsValue) {
                    newAVM1Obj.alSetOwnProperty(key, new AVM1PropertyDescriptor(64 /* DATA */ |
                        1 /* DONT_ENUM */, this.getAVM1Value(jsValue[key])));
                }
                return newAVM1Obj;
            }
        };
        AVM1SharedObject.prototype.getJSValue = function (avm1value) {
            if (typeof avm1value === "number" || typeof avm1value === "string" || typeof avm1value === "boolean") {
                return avm1value;
            }
            if (alIsArray(this.context, avm1value)) {
                console.log("array");
                var jsArray = avm1value.value;
                var arr = [];
                if (jsArray) {
                    var arrLength = jsArray.length;
                    for (var i = 0; i < arrLength; i++) {
                        arr[i] = this.getJSValue(jsArray[i]);
                    }
                }
                return arr;
            }
            if (avm1value instanceof AVM1Object) {
                var jsValue = {};
                for (var key in avm1value._ownProperties) {
                    if (key != "__proto__" && key != "__constructor__") {
                        jsValue[key] = this.getJSValue(avm1value._ownProperties[key].value);
                    }
                }
                return jsValue;
            }
            console.log("unknown datatype");
        };
        AVM1SharedObject.prototype.flush = function (minDiskSpace) {
            //minDiskSpace = alCoerceNumber(this.context, minDiskSpace);
            //this._as3SharedObject.flush(minDiskSpace);
            var jsValue = this.getJSValue(this._data);
            localStorage.setItem(this._storage_name, JSON.stringify(jsValue));
            return false; // can be a string 'pending' or boolean
        };
        return AVM1SharedObject;
    }(AVM1Object));
    /*
    export class AVM1SharedObjectFunction extends AVM1Function {
        constructor(context: AVM1Context) {
            super(context);
            alDefineObjectProperties(this, {
                prototype: {
                    value: new AVM1SharedObjectPrototype(context, this)
                },
                getLocal: {
                    value: this.getLocal,
                    writable: true
                }
            });
        }

        public getLocal(name: string, localPath?: string, secure?: boolean): AVM1SharedObject {
            name = alCoerceString(this.context, name);
            if(localPath || secure){
                console.warn("SharedObject.getLocal: params 'localPath' and 'secure' not supported")
            }
            //localPath = alCoerceString(this.context, localPath);
            //secure = alToBoolean(this.context, secure);
            return new AVM1SharedObject(this.context, name);
        }

    }

    export class AVM1SharedObjectPrototype extends AVM1Object {
        constructor(context: AVM1Context, fn: AVM1Function) {
            super(context);
            this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(this, {
                constructor: {
                    value: fn,
                    writable: true
                },
                data: {
                    get: this.getData
                },
                clear: {
                    value: this.clear,
                    writable: true
                },
                flush: {
                    value: this.flush,
                    writable: true
                }
            })
        }

        private _as3SharedObject: SharedObject; // mirror of AVM1SharedObject's one

        public getData(): any {
            // TODO implement transform from AVM2 -> AVM1 objects
            Debug.somewhatImplemented('AVM1SharedObject.getData');
            var data = (<any>this).__data || ((<any>this).__data = alNewObject(this.context));
            return data;
        }

        public clear(): void {
            this._as3SharedObject.clear();
        }

        public flush(minDiskSpace?: number): any {
            minDiskSpace = alCoerceNumber(this.context, minDiskSpace);
            this._as3SharedObject.flush(minDiskSpace);
            Debug.somewhatImplemented('AVM1SharedObject.flush');
            return false; // can be a string 'pending' or boolean
        }

        public getSize(): number {
            Debug.somewhatImplemented('AVM1SharedObject.getSize');
            return (<any>this).__data ? 10 : 0;
        }

        public setFps(updatesPerSecond: number) : boolean {
            updatesPerSecond = alCoerceNumber(this.context, updatesPerSecond) || 0;
            this._as3SharedObject.fps = updatesPerSecond;
            return this._as3SharedObject.fps === updatesPerSecond;
        }
    }

    // TODO event handlers for
    // onStatus(infoObject: AVM1Object)
    // onSync(objArray: AVM1Array)

    */

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AVM1TextFormat = /** @class */ (function (_super) {
        __extends(AVM1TextFormat, _super);
        function AVM1TextFormat() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1TextFormat.createAVM1Class = function (context) {
            var members = ['align#', 'blockIndent#', 'bold#', 'bullet#', 'color#', 'font#',
                'getTextExtent', 'indent#', 'italic#', 'kerning#', 'leading#',
                'leftMargin#', 'letterSpacing#', 'rightMargin#', 'size#', 'tabStops#',
                'target#', 'adaptee#', 'underline#', 'url#'];
            var wrapped = wrapAVM1NativeClass(context, true, AVM1TextFormat, [], members, null, AVM1TextFormat.prototype.avm1Constructor);
            var proto = wrapped.alGetPrototypeProperty();
            var p = null;
            members.forEach(function (x) {
                if (x[x.length - 1] === '#') {
                    x = x.slice(0, -1);
                }
                p = proto.alGetOwnProperty(x);
                p.flags &= ~1 /* DONT_ENUM */;
                proto.alSetOwnProperty(x, p);
            });
            return wrapped;
        };
        AVM1TextFormat.createFromNative = function (context, awayObject) {
            var TextFormat$$1 = context.globals.TextFormat;
            var obj = new AVM1TextFormat(context);
            obj.alPrototype = TextFormat$$1.alGetPrototypeProperty();
            obj.adaptee = awayObject;
            return obj;
        };
        AVM1TextFormat.prototype.alPut = function (p, v) {
            if (p == "font") {
                this.setFont(v);
            }
            _super.prototype.alPut.call(this, p, v);
        };
        AVM1TextFormat.prototype.avm1Constructor = function (font, size, color, bold, italic, underline, url, target, align, leftMargin, rightMargin, indent, leading) {
            var context = this.context;
            font = (font == null) ? null : alToString(context, font);
            size = (size == null) ? null : alToNumber(context, size);
            color = (color == null) ? null : alToNumber(context, color);
            bold = (bold == null) ? null : alToBoolean(context, bold);
            italic = (italic == null) ? null : alToBoolean(context, italic);
            underline = (underline == null) ? null : alToBoolean(context, underline);
            url = (url == null) ? null : alToString(context, url);
            target = (target == null) ? null : alToString(context, target);
            align = (align == null) ? null : alToString(context, align);
            leftMargin = (leftMargin == null) ? null : alToNumber(context, leftMargin);
            rightMargin = (rightMargin == null) ? null : alToNumber(context, rightMargin);
            indent = (indent == null) ? null : alToNumber(context, indent);
            leading = (leading == null) ? null : alToNumber(context, leading);
            var awayObject = new TextFormat(font, size, color, bold, italic, underline, url, target, align, leftMargin, rightMargin, indent, leading);
            this.adaptee = awayObject;
        };
        AVM1TextFormat.alInitStatic = function (context) {
            // See _measureTextField usage in the getTextExtent() below.
            var measureTextField = new TextField();
            measureTextField.multiline = true;
            this._measureTextField = measureTextField;
        };
        AVM1TextFormat.prototype.getAdaptee = function () {
            return this.adaptee.id;
        };
        AVM1TextFormat.prototype.setAdaptee = function (value) { };
        AVM1TextFormat.prototype.getAlign = function () {
            return this.adaptee.align;
        };
        AVM1TextFormat.prototype.setAlign = function (value) {
            var alignAsString = alToString(this.context, value);
            if (alignAsString == "") {
                alignAsString = "center";
            }
            this.adaptee.align = alignAsString;
        };
        AVM1TextFormat.prototype.getBlockIndent = function () {
            notImplemented('AVM1TextFormat.getBlockIndent');
            return this.adaptee.blockIndent;
        };
        AVM1TextFormat.prototype.setBlockIndent = function (value) {
            notImplemented('AVM1TextFormat.setBlockIndent');
            this.adaptee.blockIndent = alToNumber(this.context, value);
        };
        AVM1TextFormat.prototype.getBold = function () {
            return this.adaptee.bold;
        };
        AVM1TextFormat.prototype.setBold = function (value) {
            this.adaptee.bold = alToBoolean(this.context, value);
        };
        AVM1TextFormat.prototype.getBullet = function () {
            notImplemented('AVM1TextFormat.getBullet');
            return this.adaptee.bullet;
        };
        AVM1TextFormat.prototype.setBullet = function (value) {
            notImplemented('AVM1TextFormat.setBullet');
            this.adaptee.bullet = alToBoolean(this.context, value);
        };
        AVM1TextFormat.prototype.getColor = function () {
            return this.adaptee.color;
        };
        AVM1TextFormat.prototype.setColor = function (value) {
            this.adaptee.color = alToNumber(this.context, value);
        };
        AVM1TextFormat.prototype.getFont = function () {
            return this.adaptee.font;
        };
        AVM1TextFormat.prototype.setFont = function (value) {
            this.adaptee.font_name = alToString(this.context, value);
        };
        AVM1TextFormat.prototype.getIndent = function () {
            return this.adaptee.indent;
        };
        AVM1TextFormat.prototype.setIndent = function (value) {
            this.adaptee.indent = alToNumber(this.context, value);
        };
        AVM1TextFormat.prototype.getItalic = function () {
            return this.adaptee.italic;
        };
        AVM1TextFormat.prototype.setItalic = function (value) {
            this.adaptee.italic = alToBoolean(this.context, value);
        };
        AVM1TextFormat.prototype.getKerning = function () {
            notImplemented('AVM1TextFormat.getKerning');
            return this.adaptee.kerning;
        };
        AVM1TextFormat.prototype.setKerning = function (value) {
            notImplemented('AVM1TextFormat.setKerning');
            this.adaptee.kerning = alToBoolean(this.context, value);
        };
        AVM1TextFormat.prototype.getLeading = function () {
            return this.adaptee.leading;
        };
        AVM1TextFormat.prototype.setLeading = function (value) {
            this.adaptee.leading = alToNumber(this.context, value);
        };
        AVM1TextFormat.prototype.getLeftMargin = function () {
            return this.adaptee.leftMargin;
        };
        AVM1TextFormat.prototype.setLeftMargin = function (value) {
            this.adaptee.leftMargin = alToNumber(this.context, value);
        };
        AVM1TextFormat.prototype.getLetterSpacing = function () {
            return this.adaptee.letterSpacing;
        };
        AVM1TextFormat.prototype.setLetterSpacing = function (value) {
            this.adaptee.letterSpacing = alToNumber(this.context, value);
        };
        AVM1TextFormat.prototype.getRightMargin = function () {
            return this.adaptee.rightMargin;
        };
        AVM1TextFormat.prototype.setRightMargin = function (value) {
            this.adaptee.rightMargin = alToNumber(this.context, value);
        };
        AVM1TextFormat.prototype.getSize = function () {
            return this.adaptee.size;
        };
        AVM1TextFormat.prototype.setSize = function (value) {
            this.adaptee.size = alToNumber(this.context, value);
        };
        AVM1TextFormat.prototype.getTabStops = function () {
            notImplemented('AVM1TextFormat.getTabStops');
            var tabStops = this.adaptee.tabStops;
            return tabStops ? tabStops.value : null;
        };
        AVM1TextFormat.prototype.setTabStops = function (value) {
            notImplemented('AVM1TextFormat.setTabStops');
            if (!(value instanceof AVM1ArrayNative) &&
                !(value == null)) {
                return; // TODO
            }
            var tabStops = value && this.context.sec.createArray(value);
            this.adaptee.tabStops = tabStops;
        };
        AVM1TextFormat.prototype.getTarget = function () {
            notImplemented('AVM1TextFormat.getTarget');
            return this.adaptee.target;
        };
        AVM1TextFormat.prototype.setTarget = function (value) {
            notImplemented('AVM1TextFormat.setTarget');
            this.adaptee.target = alToString(this.context, value);
        };
        AVM1TextFormat.prototype.getTextExtent = function (text, width) {
            notImplemented('AVM1TextFormat.getTextExtent');
            text = alCoerceString(this.context, text);
            width = +width;
            var staticState = this.context.getStaticState(AVM1TextFormat);
            var measureTextField = staticState._measureTextField;
            if (!isNaN(width) && width > 0) {
                measureTextField.width = width + 4;
                measureTextField.wordWrap = true;
            }
            else {
                measureTextField.wordWrap = false;
            }
            measureTextField.defaultTextFormat = this.adaptee;
            measureTextField.text = text;
            var result = alNewObject(this.context);
            var textWidth = measureTextField.textWidth;
            var textHeight = measureTextField.textHeight;
            result.alPut('width', textWidth);
            result.alPut('height', textHeight);
            result.alPut('textFieldWidth', textWidth + 4);
            result.alPut('textFieldHeight', textHeight + 4);
            var metrics = measureTextField.getLineMetrics(0);
            result.alPut('ascent', metrics.axGetPublicProperty('ascent'));
            result.alPut('descent', metrics.axGetPublicProperty('descent'));
            return result;
        };
        AVM1TextFormat.prototype.getUnderline = function () {
            notImplemented('AVM1TextFormat.getUnderline');
            return this.adaptee.underline;
        };
        AVM1TextFormat.prototype.setUnderline = function (value) {
            notImplemented('AVM1TextFormat.setUnderline');
            this.adaptee.underline = alToBoolean(this.context, value);
        };
        AVM1TextFormat.prototype.getUrl = function () {
            notImplemented('AVM1TextFormat.getUrl');
            return this.adaptee.url;
        };
        AVM1TextFormat.prototype.setUrl = function (value) {
            notImplemented('AVM1TextFormat.setUrl');
            this.adaptee.url = alToString(this.context, value);
        };
        return AVM1TextFormat;
    }(AVM1Object));

    /**
     * The XMLNode class represents the legacy XML object
     * that was present in ActionScript 2.0 and that was renamed in ActionScript 3.0.
     * In ActionScript 3.0, consider using the new top-level <xref href="../../XML.html" class="- topic/xref ">XML</xref>
     * class and related classes instead,
     * which support E4X (ECMAScript for XML).
     * The XMLNode class is present for backward compatibility.
     */
    var XMLNode = /** @class */ (function () {
        /**
         * Creates a new XMLNode object. You must use the constructor to create an XMLNode object before you
         * call any of the methods of the XMLNode class.
         * Note: Use the createElement() and createTextNode()
         * methods to add elements and text nodes to an XML document tree.
         * @param	type	The node type: either 1 for an XML element or 3 for a text node.
         * @param	value	The XML text parsed to create the new XMLNode object.
         */
        function XMLNode(type, value) {
        }
        // for AVM1:
        XMLNode.prototype.axCallPublicProperty = function (value1, value2) {
            return null;
        };
        XMLNode.prototype.axGetPublicProperty = function (value) {
            return null;
        };
        XMLNode.prototype.axSetPublicProperty = function (value, value2) {
            return null;
        };
        XMLNode.prototype.removeChild = function (child) {
        };
        Object.defineProperty(XMLNode.prototype, "attributes", {
            /**
             * An object containing all of the attributes of the specified XMLNode instance. The
             * XMLNode.attributes object contains one variable for each attribute of the XMLNode instance.
             * Because these variables are defined as part of the object, they are generally referred to as
             * properties of the object. The value of each attribute is stored in the corresponding property as a
             * string. For example, if you have an attribute named color, you would retrieve
             * that attribute's value
             * by specifying color as the property name, as the following code shows:
             *
             *   var myColor:String = doc.firstChild.attributes.color
             */
            get: function () {
                console.log("attributes not implemented yet in flash/XMLNode");
                return null;
            },
            set: function (value) {
                console.log("attributes not implemented yet in flash/XMLNode");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(XMLNode.prototype, "childNodes", {
            /**
             * An array of the specified XMLNode object's children. Each element in the array is a reference
             * to an XMLNode object that represents a child node. This is a read-only property and cannot be
             * used to manipulate child nodes. Use the appendChild(), insertBefore(),
             * and removeNode()  methods to manipulate child nodes.
             *
             *   This property is undefined for text nodes (nodeType == 3).
             */
            get: function () {
                console.log("childNodes not implemented yet in flash/XMLNode");
                return [];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(XMLNode.prototype, "localName", {
            /**
             * The local name portion of the XML node's name. This is the element name without
             * the namespace prefix. For example, the node
             * <contact:mailbox/>bob@example.com</contact:mailbox>
             *   has the local name "mailbox", and the prefix "contact", which comprise the full
             *   element name "contact.mailbox".
             *
             *     You can access the namespace prefix through the prefix property of
             *   the XML node object. The nodeName property returns the full name
             *   (including the prefix and the local name).
             */
            get: function () {
                console.log("localName not implemented yet in flash/XMLNode");
                return "";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(XMLNode.prototype, "namespaceURI", {
            /**
             * If the XML node has a prefix, namespaceURI is the value of the xmlns
             * declaration for that prefix (the URI), which is typically called the namespace URI.
             * The xmlns declaration is in the current node or in a node higher in the XML
             * hierarchy.
             *
             *   If the XML node does not have a prefix, the value of the namespaceURI property
             * depends on whether there is a default namespace defined (as in
             * xmlns="http://www.example.com/"). If there is a default namespace, the value of
             * the namespaceURI property is the value of the default namespace.
             * If there is no default namespace, the namespaceURI property for
             * that node is an empty string ("").You can use the getNamespaceForPrefix() method to identify the namespace associated with a
             * specific prefix. The namespaceURI property returns the prefix associated with the node name.
             */
            get: function () {
                console.log("namespaceURI not implemented yet in flash/XMLNode");
                return "";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(XMLNode.prototype, "prefix", {
            /**
             * The prefix portion of the XML node name. For example, the node
             * <contact:mailbox/>bob@example.com</contact:mailbox> prefix
             *   "contact" and the local name "mailbox", which comprise the full element name "contact.mailbox".
             *
             *     The nodeName property of an XML node object returns the full name
             *   (including the prefix and the  local name). You can access the local name portion of the
             *   element's name via the localName property.
             */
            get: function () {
                console.log("prefix not implemented yet in flash/XMLNode");
                return "";
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Appends the specified node to the XML object's child list. This method operates directly on the
         * node referenced by the childNode parameter; it does not append a copy of the
         * node. If the node to be appended already exists in another tree structure, appending the node to the
         * new location will remove it from its current location. If the childNode
         * parameter refers to a node that already exists in another XML tree structure, the appended child node
         * is placed in the new tree structure after it is removed from its existing parent node.
         * @param	node	An XMLNode that represents the node to be moved from its current location to the child
         *   list of the my_xml object.
         */
        XMLNode.prototype.appendChild = function (node) {
            console.log("appendChild not implemented yet in flash/XMLNode");
        };
        /**
         * Constructs and returns a new XML node of the same type, name, value, and attributes as the
         * specified XML object. If deep is set to true, all child nodes are
         * recursively cloned, resulting in an exact copy of the original object's document tree.
         * The clone of the node that is returned is no longer associated with the tree of the cloned item.
         * Consequently, nextSibling, parentNode, and previousSibling
         * all have a value of null. If the deep parameter is set to
         * false, or the my_xml node has no child nodes,
         * firstChild and lastChild are also null.
         * @param	deep	A Boolean value; if set to true, the children of the specified XML object will be recursively cloned.
         * @return	An XMLNode Object.
         */
        XMLNode.prototype.cloneNode = function (deep) {
            console.log("cloneNode not implemented yet in flash/XMLNode");
            return null;
        };
        /**
         * Returns the namespace URI that is associated with the specified prefix for the node. To determine
         * the URI, getPrefixForNamespace() searches up the XML hierarchy from the node, as
         * necessary, and returns the namespace URI of the first xmlns declaration for the
         * given prefix.
         *
         *   If no namespace is defined for the specified prefix, the method returns null.If you specify an empty string ("") as the prefix and there is a
         * default namespace defined for the node (as in xmlns="http://www.example.com/"),
         * the method returns that default namespace URI.
         * @param	prefix	The prefix for which the method returns the associated namespace.
         * @return	The namespace that is associated with the specified prefix.
         * @refpath
         */
        XMLNode.prototype.getNamespaceForPrefix = function (prefix) {
            console.log("getNamespaceForPrefix not implemented yet in flash/XMLNode");
            return "";
        };
        /**
         * Returns the prefix that is associated with the specified namespace URI for the node. To determine
         * the prefix, getPrefixForNamespace() searches up the XML hierarchy from the node, as
         * necessary, and returns the prefix of the first xmlns declaration with a namespace URI
         * that matches ns.
         *
         *   If there is no xmlns
         * assignment for the given URI, the method returns null. If there is an
         * xmlns assignment for the given URI but no prefix is associated with the assignment,
         * the method returns an empty string
         * ("").
         * @param	ns	The namespace URI for which the method returns the associated prefix.
         * @return	The prefix associated with the specified namespace.
         */
        XMLNode.prototype.getPrefixForNamespace = function (ns) {
            console.log("getPrefixForNamespace not implemented yet in flash/XMLNode");
            return "";
        };
        /**
         * Indicates whether the specified XMLNode object has child nodes. This property is true if the
         * specified XMLNode object has child nodes; otherwise, it is false.
         * @return	Returns true if the
         *   specified XMLNode object has child nodes; otherwise, false.
         */
        XMLNode.prototype.hasChildNodes = function () {
            console.log("hasChildNodes not implemented yet in flash/XMLNode");
            return false;
        };
        /**
         * Inserts a new child node into the XML object's child list, before the
         * beforeNode node. If the beforeNode parameter is undefined
         * or null, the node is added using the appendChild() method. If beforeNode
         * is not a child of my_xml, the insertion fails.
         * @param	node	The XMLNode object to be inserted.
         * @param	before	The XMLNode object before the insertion point for the childNode.
         */
        XMLNode.prototype.insertBefore = function (node, before) {
            console.log("insertBefore not implemented yet in flash/XMLNode");
        };
        /**
         * Removes the specified XML object from its parent. Also deletes all descendants of the node.
         */
        XMLNode.prototype.removeNode = function () {
            console.log("removeNode not implemented yet in flash/XMLNode");
        };
        /**
         * Evaluates the specified XMLNode object, constructs a textual representation of the XML structure,
         * including the node, children, and attributes, and returns the result as a string.
         *
         *   For top-level XMLDocument objects (those created with the constructor),
         * the XMLDocument.toString() method outputs the document's XML declaration
         * (stored in the XMLDocument.xmlDecl property), followed by the document's
         * DOCTYPE declaration (stored in the XMLDocument.docTypeDecl property),
         * followed by the text representation of all XML nodes in the object. The XML declaration is not
         * output if the XMLDocument.xmlDecl property is null.
         * The DOCTYPE declaration is not output if the
         * XMLDocument.docTypeDecl property is null.
         * @return	The string representing the XMLNode object.
         */
        XMLNode.prototype.toString = function () {
            console.log("toString not implemented yet in flash/XMLNode");
            return "";
        };
        return XMLNode;
    }());

    var AVM1XMLNodeType;
    (function (AVM1XMLNodeType) {
        AVM1XMLNodeType[AVM1XMLNodeType["ELEMENT_NODE"] = 1] = "ELEMENT_NODE";
        AVM1XMLNodeType[AVM1XMLNodeType["TEXT_NODE"] = 3] = "TEXT_NODE";
    })(AVM1XMLNodeType || (AVM1XMLNodeType = {}));
    function toAS3XMLNode(as2Node) {
        if (!(as2Node instanceof AVM1Object)) {
            return null;
        }
        var context = as2Node.context;
        if (!alInstanceOf(context, as2Node, context.globals.XMLNode)) {
            return null;
        }
        release$1 || Debug$1.assert(as2Node.as3XMLNode);
        return as2Node.as3XMLNode;
    }
    function fromAS3XMLNode(context, as3Node) {
        if (isNullOrUndefined$1(as3Node)) {
            return undefined;
        }
        var as2Node = as3Node._as2Node;
        if (!as2Node) {
            as2Node = new AVM1Object(context);
            as2Node.alPrototype = context.globals.XMLNode.alGetPrototypeProperty();
            AVM1XMLNodePrototype.prototype.initializeFromAS3Node.call(as2Node, as3Node);
        }
        else {
            release$1 || Debug$1.assert(as2Node.context === context);
        }
        return as2Node;
    }
    var AVM1XMLNodeFunction = /** @class */ (function (_super) {
        __extends(AVM1XMLNodeFunction, _super);
        function AVM1XMLNodeFunction(context) {
            var _this = _super.call(this, context) || this;
            _this.alSetOwnPrototypeProperty(new AVM1XMLNodePrototype(context, _this));
            return _this;
        }
        AVM1XMLNodeFunction.prototype.alConstruct = function (args) {
            if (!args && args.length < 2) {
                Debug$1.notImplemented('Unsupported amount of parameters for AVM1XMLNode constructor');
                return undefined;
            }
            var type = alCoerceNumber(this.context, args[0]);
            var value = alCoerceString(this.context, args[1]);
            if (type !== AVM1XMLNodeType.ELEMENT_NODE && type !== AVM1XMLNodeType.TEXT_NODE) {
                Debug$1.notImplemented('Unsupported AVM1XMLNode type: ' + type);
                return undefined;
            }
            var obj = new AVM1Object(this.context);
            obj.alPrototype = this.alGetPrototypeProperty();
            AVM1XMLNodePrototype.prototype.initializeNode.call(obj, type, value);
            return obj;
        };
        AVM1XMLNodeFunction.prototype.alCall = function (thisArg, args) {
            return this.alConstruct(args);
        };
        return AVM1XMLNodeFunction;
    }(AVM1Function));
    var AVM1XMLNodeChildNodes = /** @class */ (function (_super) {
        __extends(AVM1XMLNodeChildNodes, _super);
        function AVM1XMLNodeChildNodes(context, as3XMLNode) {
            var _this = _super.call(this, context) || this;
            _this._as3XMLNode = as3XMLNode;
            _this._cachedNodePropertyDescriptor = new AVM1PropertyDescriptor(64 /* DATA */ |
                2 /* DONT_DELETE */ |
                4 /* READ_ONLY */, undefined);
            alDefineObjectProperties(_this, {
                length: {
                    get: _this.getLength
                }
            });
            return _this;
        }
        Object.defineProperty(AVM1XMLNodeChildNodes.prototype, "as3ChildNodes", {
            get: function () {
                return this._as3XMLNode.axGetPublicProperty('childNodes').value; // TODO .childNodes
            },
            enumerable: true,
            configurable: true
        });
        AVM1XMLNodeChildNodes.prototype.getLength = function () {
            return this.as3ChildNodes.length;
        };
        AVM1XMLNodeChildNodes.prototype.alGetOwnProperty = function (p) {
            if (alIsIndex(this.context, p)) {
                var index = alToInteger(this.context, p);
                if (index >= 0 && index < this.as3ChildNodes.length) {
                    this._cachedNodePropertyDescriptor.value = fromAS3XMLNode(this.context, this.as3ChildNodes[index]);
                    return this._cachedNodePropertyDescriptor;
                }
            }
            return _super.prototype.alGetOwnProperty.call(this, p);
        };
        return AVM1XMLNodeChildNodes;
    }(AVM1Object));
    var AVM1XMLNodeAttributes = /** @class */ (function (_super) {
        __extends(AVM1XMLNodeAttributes, _super);
        function AVM1XMLNodeAttributes(context, as3Attributes) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            _this._as3Attributes = as3Attributes;
            _this._cachedNodePropertyDescriptor = new AVM1PropertyDescriptor(64 /* DATA */, undefined);
            return _this;
        }
        AVM1XMLNodeAttributes.prototype.alGetOwnProperty = function (p) {
            var name = alCoerceString(this.context, p);
            if (this._as3Attributes.axHasPublicProperty(name)) {
                this._cachedNodePropertyDescriptor.value =
                    this._as3Attributes.axGetPublicProperty(name);
                return this._cachedNodePropertyDescriptor;
            }
            return undefined;
        };
        AVM1XMLNodeAttributes.prototype.alSetOwnProperty = function (p, desc) {
            var name = alCoerceString(this.context, p);
            if ((desc.flags & 64 /* DATA */)) {
                var value = alCoerceString(this.context, desc.value);
                this._as3Attributes.axSetPublicProperty(name, value);
            }
        };
        AVM1XMLNodeAttributes.prototype.alHasOwnProperty = function (p) {
            var name = alCoerceString(this.context, p);
            return this._as3Attributes.axHasPublicProperty(name);
        };
        AVM1XMLNodeAttributes.prototype.alDeleteOwnProperty = function (p) {
            var name = alCoerceString(this.context, p);
            this._as3Attributes.axDeletePublicProperty(name);
        };
        AVM1XMLNodeAttributes.prototype.alGetOwnPropertiesKeys = function () {
            var as3Keys = this._as3Attributes.axGetEnumerableKeys();
            return as3Keys.map(function (key) { return axCoerceString$2(key); });
        };
        return AVM1XMLNodeAttributes;
    }(AVM1Object));
    var AVM1XMLNodePrototype = /** @class */ (function (_super) {
        __extends(AVM1XMLNodePrototype, _super);
        function AVM1XMLNodePrototype(context, fn) {
            var _this = _super.call(this, context) || this;
            alDefineObjectProperties(_this, {
                constructor: {
                    value: fn,
                    writable: true
                },
                attributes: {
                    get: _this.getAttributes,
                    set: _this.setAttributes
                },
                childNodes: {
                    get: _this.getChildNodes
                },
                firstChild: {
                    get: _this.getFirstChild
                },
                lastChild: {
                    get: _this.getLastChild
                },
                localName: {
                    get: _this.getLocalName
                },
                namespaceURI: {
                    get: _this.getNamespaceURI
                },
                nextSibling: {
                    get: _this.getNextSibling
                },
                nodeName: {
                    get: _this.getNodeName,
                    set: _this.setNodeName
                },
                nodeType: {
                    get: _this.getNodeType
                },
                nodeValue: {
                    get: _this.getNodeValue,
                    set: _this.setNodeValue
                },
                parentNode: {
                    get: _this.getParentNode
                },
                prefix: {
                    get: _this.getPrefix
                },
                previousSibling: {
                    get: _this.getPreviousSibling
                },
                appendChild: {
                    value: _this.appendChild
                },
                cloneNode: {
                    value: _this.cloneNode
                },
                getNamespaceForPrefix: {
                    value: _this.getNamespaceForPrefix
                },
                getPrefixForNamespace: {
                    value: _this.getPrefixForNamespace
                },
                hasChildNodes: {
                    value: _this.hasChildNodes
                },
                insertBefore: {
                    value: _this.insertBefore
                },
                removeNode: {
                    value: _this.removeNode
                },
                toString: {
                    value: _this._toString
                }
            });
            return _this;
        }
        AVM1XMLNodePrototype.prototype.initializeNode = function (type, value) {
            this.as3XMLNode = new XMLNode(type, value);
            this._attributes = undefined;
            this._childNodes = undefined;
            AVM1XMLNodePrototype.addMap(this.as3XMLNode, this);
        };
        AVM1XMLNodePrototype.prototype.initializeFromAS3Node = function (as3XMLNode) {
            this.as3XMLNode = as3XMLNode;
            this._attributes = undefined;
            this._childNodes = undefined;
            AVM1XMLNodePrototype.addMap(this.as3XMLNode, this);
        };
        AVM1XMLNodePrototype.prototype._toString = function () {
            return this.as3XMLNode.toString(); //80pro axCallPublicProperty('toString', null);
        };
        AVM1XMLNodePrototype.prototype.appendChild = function (newChild) {
            this.as3XMLNode.axCallPublicProperty('appendChild', [toAS3XMLNode(newChild)]);
        };
        AVM1XMLNodePrototype.prototype.getAttributes = function () {
            var as3Attributes = this.as3XMLNode.axGetPublicProperty('attributes');
            if (isNullOrUndefined$1(as3Attributes)) {
                return undefined;
            }
            // TODO create a proxy to map AVM2 object stuff to AVM1
            if (!this._attributes) {
                this._attributes = new AVM1XMLNodeAttributes(this.context, as3Attributes);
            }
            return this._attributes;
        };
        AVM1XMLNodePrototype.prototype.setAttributes = function (value) {
            var _this = this;
            if (isNullOrUndefined$1(value)) {
                this._attributes = undefined;
                return;
            }
            if (value instanceof AVM1XMLNodeAttributes) {
                this._attributes = value;
                return;
            }
            var context = this.context;
            var as3Attributes = context.sec.createObject();
            alForEachProperty(value, function (prop) {
                var name = alCoerceString(context, prop);
                var value = alCoerceString(context, _this.alGet(prop));
                as3Attributes.axSetPublicProperty(name, value);
            }, this);
            this._attributes = new AVM1XMLNodeAttributes(context, as3Attributes);
        };
        AVM1XMLNodePrototype.prototype.getChildNodes = function () {
            if (!this._childNodes) {
                this._childNodes = new AVM1XMLNodeChildNodes(this.context, this.as3XMLNode);
            }
            return this._childNodes;
        };
        AVM1XMLNodePrototype.prototype.cloneNode = function (deepClone) {
            deepClone = alToBoolean(this.context, deepClone);
            var clone = this.as3XMLNode.axCallPublicProperty('cloneNode', [deepClone]);
            return fromAS3XMLNode(this.context, clone);
        };
        AVM1XMLNodePrototype.prototype.getFirstChild = function () {
            return fromAS3XMLNode(this.context, this.as3XMLNode.axGetPublicProperty('firstChild'));
        };
        AVM1XMLNodePrototype.prototype.getNamespaceForPrefix = function (prefix) {
            return this.as3XMLNode.axCallPublicProperty('getNamespaceForPrefix', [prefix]);
        };
        AVM1XMLNodePrototype.prototype.getPrefixForNamespace = function (nsURI) {
            return this.as3XMLNode.axCallPublicProperty('getNamespaceForPrefix', [nsURI]);
        };
        AVM1XMLNodePrototype.prototype.hasChildNodes = function () {
            return this.as3XMLNode.axCallPublicProperty('hasChildNodes', null);
        };
        AVM1XMLNodePrototype.prototype.insertBefore = function (newChild, insertPoint) {
            this.as3XMLNode.axCallPublicProperty('insertBefore', [toAS3XMLNode(newChild), toAS3XMLNode(insertPoint)]);
        };
        AVM1XMLNodePrototype.prototype.getLastChild = function () {
            return fromAS3XMLNode(this.context, this.as3XMLNode.axGetPublicProperty('lastChild'));
        };
        AVM1XMLNodePrototype.prototype.getLocalName = function () {
            return this.as3XMLNode.axGetPublicProperty('localName');
        };
        AVM1XMLNodePrototype.prototype.getNamespaceURI = function () {
            return this.as3XMLNode.axGetPublicProperty('namespaceURI');
        };
        AVM1XMLNodePrototype.prototype.getNextSibling = function () {
            return fromAS3XMLNode(this.context, this.as3XMLNode.axGetPublicProperty('nextSibling'));
        };
        AVM1XMLNodePrototype.prototype.getNodeName = function () {
            return this.as3XMLNode.axGetPublicProperty('nodeName');
        };
        AVM1XMLNodePrototype.prototype.setNodeName = function (value) {
            value = alCoerceString(this.context, value);
            this.as3XMLNode.axSetPublicProperty('nodeName', value);
        };
        AVM1XMLNodePrototype.prototype.getNodeType = function () {
            return this.as3XMLNode.axGetPublicProperty('nodeType');
        };
        AVM1XMLNodePrototype.prototype.getNodeValue = function () {
            return this.as3XMLNode.axGetPublicProperty('nodeValue');
        };
        AVM1XMLNodePrototype.prototype.setNodeValue = function (value) {
            value = alCoerceString(this.context, value);
            this.as3XMLNode.axSetPublicProperty('nodeValue', value);
        };
        AVM1XMLNodePrototype.prototype.getParentNode = function () {
            return fromAS3XMLNode(this.context, this.as3XMLNode.axGetPublicProperty('parentNode'));
        };
        AVM1XMLNodePrototype.prototype.getPrefix = function () {
            return this.as3XMLNode.axGetPublicProperty('prefix');
        };
        AVM1XMLNodePrototype.prototype.getPreviousSibling = function () {
            return fromAS3XMLNode(this.context, this.as3XMLNode.axGetPublicProperty('previousSibling'));
        };
        AVM1XMLNodePrototype.prototype.removeNode = function () {
            this.as3XMLNode.axCallPublicProperty('removeNode', null);
        };
        AVM1XMLNodePrototype.addMap = function (as3Node, as2Node) {
            release$1 || Debug$1.assert(!as3Node._as2Node);
            as3Node._as2Node = as2Node;
        };
        return AVM1XMLNodePrototype;
    }(AVM1Object));
    var AVM1XMLFunction = /** @class */ (function (_super) {
        __extends(AVM1XMLFunction, _super);
        function AVM1XMLFunction(context, xmlNodeClass) {
            var _this = _super.call(this, context) || this;
            _this.alSetOwnPrototypeProperty(new AVM1XMLPrototype(context, _this, xmlNodeClass));
            return _this;
        }
        AVM1XMLFunction.prototype.alConstruct = function (args) {
            var text = args && alCoerceString(this.context, args[0]);
            var obj = new AVM1Object(this.context);
            obj.alPrototype = this.alGetPrototypeProperty();
            obj.isAVM1DataObject = true;
            if (!text)
                text = "";
            AVM1XMLPrototype.prototype.initializeDocument.call(obj, text);
            return obj;
        };
        AVM1XMLFunction.prototype.alCall = function (thisArg, args) {
            return this.alConstruct(args);
        };
        return AVM1XMLFunction;
    }(AVM1Function));
    var AVM1XMLPrototype = /** @class */ (function (_super) {
        __extends(AVM1XMLPrototype, _super);
        function AVM1XMLPrototype(context, fn, xmlNodeClass) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = xmlNodeClass.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                constructor: {
                    value: fn,
                    writable: true
                },
                addRequestHeader: {
                    value: _this.addRequestHeader
                },
                createElement: {
                    value: _this.createElement
                },
                createTextNode: {
                    value: _this.createTextNode
                },
                getBytesLoaded: {
                    value: _this.getBytesLoaded
                },
                getBytesTotal: {
                    value: _this.getBytesTotal
                },
                ignoreWhite: {
                    value: false,
                    writable: true
                },
                load: {
                    value: _this.load
                },
                parseXML: {
                    value: _this.parseXML
                },
                send: {
                    value: _this.send
                },
                sendAndLoad: {
                    value: _this.sendAndLoad
                },
                onData: {
                    value: _this.defaultOnData,
                    writable: true
                }
            });
            return _this;
        }
        AVM1XMLPrototype.prototype.initializeDocument = function (text) {
            text = alCoerceString(this.context, text) || null;
            var as3Doc = new XMLDocument();
            as3Doc.body.innerHTML = text;
            AVM1XMLNodePrototype.prototype.initializeFromAS3Node.call(this, as3Doc);
            this.as3XMLDocument = as3Doc;
        };
        AVM1XMLPrototype.prototype.addRequestHeader = function (headers, headerValue) {
            Debug$1.notImplemented('AVM1XMLPrototype.addRequestHeader');
        };
        AVM1XMLPrototype.prototype.createElement = function (name) {
            name = alCoerceString(this.context, name);
            var as3Node = this.as3XMLDocument.axCallPublicProperty('createElement', [name]);
            return fromAS3XMLNode(this.context, as3Node);
        };
        AVM1XMLPrototype.prototype.createTextNode = function (value) {
            value = alCoerceString(this.context, value);
            var as3Node = this.as3XMLDocument.axCallPublicProperty('createTextNode', [value]);
            return fromAS3XMLNode(this.context, as3Node);
        };
        AVM1XMLPrototype.prototype.getBytesLoaded = function () {
            if (!this._as3Loader) {
                return undefined;
            }
            return this._as3Loader.bytesLoaded;
        };
        AVM1XMLPrototype.prototype.getBytesTotal = function () {
            if (!this._as3Loader) {
                return undefined;
            }
            return this._as3Loader.bytesTotal;
        };
        AVM1XMLPrototype.prototype.load = function (url) {
            url = alCoerceString(this.context, url);
            if (!url) {
                return false;
            }
            loadAVM1DataObject(this.context, url, null, null, null, this);
            return true;
        };
        AVM1XMLPrototype.prototype.defaultOnData = function (src) {
            if (isNullOrUndefined$1(src)) {
                avm1BroadcastEvent(this.context, this, 'onLoad', [false]);
                return;
            }
            AVM1XMLPrototype.prototype.parseXML.call(this, src);
            this.alPut('loaded', true);
            avm1BroadcastEvent(this.context, this, 'onLoad', [true]);
        };
        AVM1XMLPrototype.prototype.parseXML = function (value) {
            value = alCoerceString(this.context, value);
            this.as3XMLDocument.axSetPublicProperty('ignoreWhite', alToBoolean(this.context, this.alGet('ignoreWhite')));
            this.as3XMLDocument.axCallPublicProperty('parseXML', [value]);
        };
        AVM1XMLPrototype.prototype.send = function (url, target, method) {
            url = alCoerceString(this.context, url);
            target = isNullOrUndefined$1(target) ? undefined : alCoerceString(this.context, target);
            method = isNullOrUndefined$1(method) ? undefined : alCoerceString(this.context, method);
            Debug$1.notImplemented('AVM1XMLPrototype.send');
            return false;
        };
        AVM1XMLPrototype.prototype.sendAndLoad = function (url, resultXML) {
            url = alCoerceString(this.context, url);
            if (!url) {
                return;
            }
            if (!resultXML.isAVM1DataObject) {
                return;
            }
            Debug$1.somewhatImplemented('AVM1XMLPrototype.send');
            // TODO check content types and test
            var contentType = this.alGet('contentType');
            contentType = isNullOrUndefined$1(contentType) ? undefined : alCoerceString(this.context, contentType);
            var data = alToString(this.context, this);
            loadAVM1DataObject(this.context, url, 'POST', contentType, data, resultXML);
        };
        return AVM1XMLPrototype;
    }(AVM1Object));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AVM1Transform = /** @class */ (function (_super) {
        __extends(AVM1Transform, _super);
        function AVM1Transform() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1Transform.createAVM1Class = function (context) {
            return wrapAVM1NativeClass(context, true, AVM1Transform, [], ['matrix#', 'concatenatedMatrix#', 'colorTransform#', 'pixelBounds#'], null, AVM1Transform.prototype.avm1Constructor);
        };
        Object.defineProperty(AVM1Transform.prototype, "as3Transform", {
            get: function () {
                return this._targetAwayObject.transform;
            },
            enumerable: true,
            configurable: true
        });
        AVM1Transform.prototype.avm1Constructor = function (target_mc) {
            this._target = this.context.resolveTarget(target_mc);
            this._targetAwayObject = getAwayJSAdaptee(this._target);
        };
        AVM1Transform.prototype.getMatrix = function () {
            var transform = this._targetAwayObject.transform;
            return AVM1Matrix.fromAS3Matrix(this.context, transform.matrix);
        };
        AVM1Transform.prototype.setMatrix = function (value) {
            var transform = this._targetAwayObject.transform;
            transform.matrix = toAS3Matrix(value);
        };
        AVM1Transform.prototype.getConcatenatedMatrix = function () {
            var transform = this._targetAwayObject.transform;
            return AVM1Matrix.fromAS3Matrix(this.context, transform.concatenatedMatrix);
        };
        AVM1Transform.prototype.getColorTransform = function () {
            var transform = this._targetAwayObject.transform;
            return AVM1ColorTransform.fromAwayColorTransform(this.context, transform.colorTransform);
        };
        AVM1Transform.prototype.setColorTransform = function (value) {
            var transform = this._targetAwayObject.transform;
            transform.colorTransform = toAwayColorTransform(value);
        };
        AVM1Transform.prototype.getPixelBounds = function () {
            var transform = this._targetAwayObject.transform;
            return AVM1Rectangle.fromAS3Rectangle(this.context, transform.pixelBounds);
        };
        return AVM1Transform;
    }(AVM1Object));

    //module Shumway.AVM1.Lib {
    var AVM1ExternalInterface = /** @class */ (function (_super) {
        __extends(AVM1ExternalInterface, _super);
        function AVM1ExternalInterface() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1ExternalInterface.createAVM1Class = function (context) {
            return wrapAVM1NativeClass(context, true, AVM1ExternalInterface, ['available#', 'addCallback', 'call'], []);
        };
        AVM1ExternalInterface.getAvailable = function (context) {
            return true; //context.sec.flash.external.ExternalInterface.axClass.available;
        };
        AVM1ExternalInterface.addCallback = function (context, methodName, instance, method) {
            methodName = alCoerceString(context, methodName);
            if (!alIsFunction(method)) {
                return false;
            }
            try {
                if (!window["flashObject"]) {
                    window["flashObject"] = {};
                }
                window["flashObject"][methodName] = function () {
                    var args = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        args[_i] = arguments[_i];
                    }
                    var desc = instance.alGet(methodName.toLowerCase());
                    if (desc && alIsFunction(desc))
                        desc.alCall(instance, args);
                    else if (desc && desc.value)
                        desc.value.alCall(instance, args);
                    //_this.mwAdaptee.runScripts();
                };
                /*context.sec.flash.external.ExternalInterface.axClass.addCallback(methodName, function () {
                    var args = Array.prototype.slice.call(arguments, 0);
                    var result = context.executeFunction(method, instance, args);
                    return result;
                });*/
                return true;
            }
            catch (e) {
            }
            return false;
        };
        AVM1ExternalInterface.call = function (context, methodName) {
            var parameters = [];
            for (var _i = 2; _i < arguments.length; _i++) {
                parameters[_i - 2] = arguments[_i];
            }
            var args = []; // [alCoerceString(context, methodName)];
            var paramsLength = parameters.length;
            var i = 0;
            for (i = 0; i < paramsLength; i++) {
                // TODO convert AVM1 objects to AVM2
                args.push(parameters[i]);
            }
            if (args.length == 1) {
                args = args[0];
            }
            try {
                var methodnames = methodName.split(".");
                var method = window;
                for (i = 0; i < methodnames.length; i++) {
                    method = method[methodnames[i]];
                }
                method(args);
                /*var result = context.sec.flash.external.ExternalInterface.axClass.call.apply(
                    context.sec.flash.external.ExternalInterface.axClass, args);
                    */
                var result = "";
                // TODO convert AVM2 result to AVM1
                return result;
            }
            catch (e) {
                return undefined;
            }
        };
        return AVM1ExternalInterface;
    }(AVM1Object));

    function createCommonjsModule(fn, module) {
    	return module = { exports: {} }, fn(module, module.exports), module.exports;
    }

    var stringify_1 = createCommonjsModule(function (module, exports) {
    exports = module.exports = stringify;
    exports.getSerialize = serializer;

    function stringify(obj, replacer, spaces, cycleReplacer) {
      return JSON.stringify(obj, serializer(replacer, cycleReplacer), spaces)
    }

    function serializer(replacer, cycleReplacer) {
      var stack = [], keys = [];

      if (cycleReplacer == null) cycleReplacer = function(key, value) {
        if (stack[0] === value) return "[Circular ~]"
        return "[Circular ~." + keys.slice(0, stack.indexOf(value)).join(".") + "]"
      };

      return function(key, value) {
        if (stack.length > 0) {
          var thisPos = stack.indexOf(this);
          ~thisPos ? stack.splice(thisPos + 1) : stack.push(this);
          ~thisPos ? keys.splice(thisPos, Infinity, key) : keys.push(key);
          if (~stack.indexOf(value)) value = cycleReplacer.call(this, key, value);
        }
        else stack.push(value);

        return replacer == null ? value : replacer.call(this, key, value)
      }
    }
    });
    var stringify_2 = stringify_1.getSerialize;

    /*	============================================================================
    This is based upon Johannes Baagoe's carefully designed and efficient hash
    function for use with JavaScript.  It has a proven "avalanche" effect such
    that every bit of the input affects every bit of the output 50% of the time,
    which is good.	See: http://baagoe.com/en/RandomMusings/hash/avalanche.xhtml
    ============================================================================
    */
    var Mash = function () {
    	var n = 0xefc8249d;
    	var mash = function (data) {
    		if (data) {
    			data = data.toString();
    			for (var i = 0; i < data.length; i++) {
    				n += data.charCodeAt(i);
    				var h = 0.02519603282416938 * n;
    				n = h >>> 0;
    				h -= n;
    				h *= n;
    				n = h >>> 0;
    				h -= n;
    				n += h * 0x100000000; // 2^32
    			}
    			return (n >>> 0) * 2.3283064365386963e-10; // 2^-32
    		} else {
    			n = 0xefc8249d;
    		}
    	};
    	return mash;
    };

    var uheprng = function (seed) {
    	return (function () {
    		var o = 48; // set the 'order' number of ENTROPY-holding 32-bit values
    		var c = 1; // init the 'carry' used by the multiply-with-carry (MWC) algorithm
    		var p = o; // init the 'phase' (max-1) of the intermediate variable pointer
    		var s = new Array(o); // declare our intermediate variables array
    		var i; // general purpose local
    		var j; // general purpose local
    		var k = 0; // general purpose local

    		// when our "uheprng" is initially invoked our PRNG state is initialized from the
    		// browser's own local PRNG. This is okay since although its generator might not
    		// be wonderful, it's useful for establishing large startup entropy for our usage.
    		var mash = new Mash(); // get a pointer to our high-performance "Mash" hash

    		// fill the array with initial mash hash values
    		for (i = 0; i < o; i++) {
    			s[i] = mash(Math.random());
    		}

    		// this PRIVATE (internal access only) function is the heart of the multiply-with-carry
    		// (MWC) PRNG algorithm. When called it returns a pseudo-random number in the form of a
    		// 32-bit JavaScript fraction (0.0 to <1.0) it is a PRIVATE function used by the default
    		// [0-1] return function, and by the random 'string(n)' function which returns 'n'
    		// characters from 33 to 126.
    		var rawprng = function () {
    			if (++p >= o) {
    				p = 0;
    			}
    			var t = 1768863 * s[p] + c * 2.3283064365386963e-10; // 2^-32
    			return s[p] = t - (c = t | 0);
    		};

    		// this EXPORTED function is the default function returned by this library.
    		// The values returned are integers in the range from 0 to range-1. We first
    		// obtain two 32-bit fractions (from rawprng) to synthesize a single high
    		// resolution 53-bit prng (0 to <1), then we multiply this by the caller's
    		// "range" param and take the "floor" to return a equally probable integer.
    		var random = function (range) {
    			return Math.floor(range * (rawprng() + (rawprng() * 0x200000 | 0) * 1.1102230246251565e-16)); // 2^-53
    		};

    		// this EXPORTED function 'string(n)' returns a pseudo-random string of
    		// 'n' printable characters ranging from chr(33) to chr(126) inclusive.
    		random.string = function (count) {
    			var i;
    			var s = '';
    			for (i = 0; i < count; i++) {
    				s += String.fromCharCode(33 + random(94));
    			}
    			return s;
    		};

    		// this PRIVATE "hash" function is used to evolve the generator's internal
    		// entropy state. It is also called by the EXPORTED addEntropy() function
    		// which is used to pour entropy into the PRNG.
    		var hash = function () {
    			var args = Array.prototype.slice.call(arguments);
    			for (i = 0; i < args.length; i++) {
    				for (j = 0; j < o; j++) {
    					s[j] -= mash(args[i]);
    					if (s[j] < 0) {
    						s[j] += 1;
    					}
    				}
    			}
    		};

    		// this EXPORTED "clean string" function removes leading and trailing spaces and non-printing
    		// control characters, including any embedded carriage-return (CR) and line-feed (LF) characters,
    		// from any string it is handed. this is also used by the 'hashstring' function (below) to help
    		// users always obtain the same EFFECTIVE uheprng seeding key.
    		random.cleanString = function (inStr) {
    			inStr = inStr.replace(/(^\s*)|(\s*$)/gi, ''); // remove any/all leading spaces
    			inStr = inStr.replace(/[\x00-\x1F]/gi, ''); // remove any/all control characters
    			inStr = inStr.replace(/\n /, '\n'); // remove any/all trailing spaces
    			return inStr; // return the cleaned up result
    		};

    		// this EXPORTED "hash string" function hashes the provided character string after first removing
    		// any leading or trailing spaces and ignoring any embedded carriage returns (CR) or Line Feeds (LF)
    		random.hashString = function (inStr) {
    			inStr = random.cleanString(inStr);
    			mash(inStr); // use the string to evolve the 'mash' state
    			for (i = 0; i < inStr.length; i++) { // scan through the characters in our string
    				k = inStr.charCodeAt(i); // get the character code at the location
    				for (j = 0; j < o; j++) { //	"mash" it into the UHEPRNG state
    					s[j] -= mash(k);
    					if (s[j] < 0) {
    						s[j] += 1;
    					}
    				}
    			}
    		};

    		// this EXPORTED function allows you to seed the random generator.
    		random.seed = function (seed) {
    			if (typeof seed === 'undefined' || seed === null) {
    				seed = Math.random();
    			}
    			if (typeof seed !== 'string') {
    				seed = stringify_1(seed, function (key, value) {
    					if (typeof value === 'function') {
    						return (value).toString();
    					}
    					return value;
    				});
    			}
    			random.initState();
    			random.hashString(seed);
    		};

    		// this handy exported function is used to add entropy to our uheprng at any time
    		random.addEntropy = function ( /* accept zero or more arguments */ ) {
    			var args = [];
    			for (i = 0; i < arguments.length; i++) {
    				args.push(arguments[i]);
    			}
    			hash((k++) + (new Date().getTime()) + args.join('') + Math.random());
    		};

    		// if we want to provide a deterministic startup context for our PRNG,
    		// but without directly setting the internal state variables, this allows
    		// us to initialize the mash hash and PRNG's internal state before providing
    		// some hashing input
    		random.initState = function () {
    			mash(); // pass a null arg to force mash hash to init
    			for (i = 0; i < o; i++) {
    				s[i] = mash(' '); // fill the array with initial mash hash values
    			}
    			c = 1; // init our multiply-with-carry carry
    			p = o; // init our phase
    		};

    		// we use this (optional) exported function to signal the JavaScript interpreter
    		// that we're finished using the "Mash" hash function so that it can free up the
    		// local "instance variables" is will have been maintaining.  It's not strictly
    		// necessary, of course, but it's good JavaScript citizenship.
    		random.done = function () {
    			mash = null;
    		};

    		// if we called "uheprng" with a seed value, then execute random.seed() before returning
    		if (typeof seed !== 'undefined') {
    			random.seed(seed);
    		}

    		// Returns a random integer between 0 (inclusive) and range (exclusive)
    		random.range = function (range) {
    			return random(range);
    		};

    		// Returns a random float between 0 (inclusive) and 1 (exclusive)
    		random.random = function () {
    			return random(Number.MAX_VALUE - 1) / Number.MAX_VALUE;
    		};

    		// Returns a random float between min (inclusive) and max (exclusive)
    		random.floatBetween = function (min, max) {
    			return random.random() * (max - min) + min;
    		};

    		// Returns a random integer between min (inclusive) and max (inclusive)
    		random.intBetween = function (min, max) {
    			return Math.floor(random.random() * (max - min + 1)) + min;
    		};

    		// when our main outer "uheprng" function is called, after setting up our
    		// initial variables and entropic state, we return an "instance pointer"
    		// to the internal anonymous function which can then be used to access
    		// the uheprng's various exported functions.  As with the ".done" function
    		// above, we should set the returned value to 'null' once we're finished
    		// using any of these functions.
    		return random;
    	}());
    };

    // Modification for use in node:
    uheprng.create = function (seed) {
    	return new uheprng(seed);
    };
    var randomSeed = uheprng;
    var randomSeed_1 = randomSeed.create;

    var AVM1Selection = /** @class */ (function (_super) {
        __extends(AVM1Selection, _super);
        function AVM1Selection() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.url = "";
            _this.targetMC = null;
            _this._queued_focus_value = null;
            _this._queued_focus = false;
            _this.callbackName = "";
            _this.callbackTarget = null;
            return _this;
        }
        AVM1Selection.createAVM1Class = function (context) {
            var wrapped = wrapAVM1NativeClass(context, true, AVM1Selection, [], ['addListener', 'getFocus', 'getBeginIndex', 'getEndIndex', 'removeListener', 'setFocus', 'setSelection', 'getCaretIndex'], null, AVM1Selection.prototype.avm1Constructor);
            return wrapped;
        };
        AVM1Selection.prototype.avm1Constructor = function (url, targetMC) {
            this.url = url;
            this.targetMC = targetMC;
            this._queued_focus = false;
        };
        //	Registers an object to receive keyboard focus change notifications.
        AVM1Selection.prototype.addListener = function (listener) {
            notImplemented("AVM1Selection.addListener");
        };
        //	Removes an object previously registered with the Selection.addListener() method.
        AVM1Selection.prototype.removeListener = function (listener) {
            notImplemented("AVM1Selection.removeListener");
            return true;
        };
        AVM1Selection.prototype.getBeginIndex = function () {
            var objectinFocus = MouseManager.getInstance(PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.renderer.view)).getFocus();
            if (objectinFocus && objectinFocus.isAsset(TextField)) {
                return objectinFocus.selectionBeginIndex;
            }
            return -1;
        };
        AVM1Selection.prototype.getEndIndex = function () {
            var objectinFocus = MouseManager.getInstance(PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.view)).getFocus();
            if (objectinFocus && objectinFocus.isAsset(TextField)) {
                return objectinFocus.selectionEndIndex;
            }
            return -1;
        };
        AVM1Selection.prototype.getCaretIndex = function () {
            var objectinFocus = MouseManager.getInstance(PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.view)).getFocus();
            if (objectinFocus && objectinFocus.isAsset(TextField)) {
                return objectinFocus.selectionBeginIndex;
            }
            return -1;
        };
        // 	Returns a string specifying the target path of the object that has focus.
        AVM1Selection.prototype.getFocus = function () {
            var objectinFocus = MouseManager.getInstance(PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.view)).getFocus();
            if (objectinFocus) {
                var names = [];
                while (objectinFocus) {
                    if (objectinFocus.isAVMScene) {
                        objectinFocus = null;
                    }
                    else {
                        names.push(objectinFocus.name);
                        objectinFocus = objectinFocus.parent;
                    }
                }
                var i = names.length;
                var mc_path = "";
                while (i > 0) {
                    i--;
                    mc_path += names[i];
                    if (i > 0)
                        mc_path += ".";
                }
                //console.log(mc_path);
                return mc_path;
            }
            return "";
        };
        // 	Gives focus to the selectable (editable) text field, button, or movie clip, 
        //	that the newFocus parameter specifies.
        //	also might be a path to a variable that is bound to a textfield.
        //	in that case we want to focus the textfield
        //	todo: potential bug (?): it might happen that this variable is not yet defined, because that script has not run yet
        //	either queue the getFocus, or maybe add it as a callback for MosueManager to execute before fireEvents?
        AVM1Selection.prototype.setFocus = function (newFocus) {
            if (newFocus === "")
                return;
            if (typeof newFocus === "string") {
                var focusObj = this.context.resolveTarget(newFocus);
                if (focusObj && focusObj.adaptee) {
                    MouseManager.getInstance(PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.view)).setFocus(focusObj.adaptee);
                    return;
                }
                var focusObj = this.context.resolveTarget(newFocus + "_internal_TF");
                if (focusObj && focusObj.adaptee) {
                    MouseManager.getInstance(PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.view)).setFocus(focusObj.adaptee);
                    return;
                }
                warning("AVM1Selection.setFocus - no object found for string " + newFocus);
                return;
            }
            var focusObj = this.context.resolveTarget(newFocus);
            if (focusObj && focusObj.adaptee)
                MouseManager.getInstance(PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.view)).setFocus(focusObj.adaptee);
            else {
                warning("AVM1Selection.setFocus - no object found '" + newFocus.toString() + "'");
            }
            return true;
        };
        // Sets the selection span of the currently focused text field.
        AVM1Selection.prototype.setSelection = function (beginIndex, endIndex) {
            var objectinFocus = MouseManager.getInstance(PickGroup.getInstance(this.context.globals.Stage._awayAVMStage.scene.view)).getFocus();
            if (objectinFocus && objectinFocus.isAsset(TextField)) {
                objectinFocus.setSelection(beginIndex, endIndex);
            }
        };
        return AVM1Selection;
    }(AVM1Object));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var _escape = jsGlobal.escape;
    var _internalTimeouts = [];
    var AVM1MatrixFunction$1 = /** @class */ (function (_super) {
        __extends(AVM1MatrixFunction, _super);
        function AVM1MatrixFunction(context) {
            return _super.call(this, context) || this;
        }
        return AVM1MatrixFunction;
    }(AVM1Object));
    var TraceLevel = /** @class */ (function () {
        function TraceLevel() {
        }
        TraceLevel.ALL = "all";
        TraceLevel.NONE = "none";
        TraceLevel.IMPORTANT = "important";
        return TraceLevel;
    }());
    var AVM1Globals = /** @class */ (function (_super) {
        __extends(AVM1Globals, _super);
        function AVM1Globals(context) {
            var _this = _super.call(this, context) || this;
            // built-ins
            _this.NaN = Number.NaN;
            _this.Infinity = Number.POSITIVE_INFINITY;
            _this.undefined = undefined;
            _this._initBuiltins(context);
            var swfVersion = context.loaderInfo.swfVersion;
            //if (swfVersion >= 8) {
            _this._initializeFlashObject(context);
            return _this;
            //}
        }
        AVM1Globals.setRandom = function (seed) {
            if (seed === void 0) { seed = null; }
            if (seed) {
                AVM1Globals.randomProvider = randomSeed_1(seed);
                return;
            }
            AVM1Globals.randomProvider = null;
        };
        AVM1Globals.registerCustomClass = function (name, avm1Class) {
            AVM1Globals._registeredCustomClasses[name] = avm1Class;
            if (AVM1Globals.instance) {
                AVM1Globals.instance.alPut(name, avm1Class);
            }
        };
        AVM1Globals.registerCustomClassInstance = function (name, avm1Class) {
            AVM1Globals._registeredCustomClassInstances[name] = avm1Class;
            if (AVM1Globals.instance) {
                AVM1Globals.instance.alPut(name, avm1Class);
            }
        };
        AVM1Globals.createGlobalsObject = function (context) {
            var globals = new AVM1Globals(context);
            wrapAVM1NativeMembers(context, globals, globals, ['flash', 'ASSetPropFlags', 'BitmapData', 'clearInterval', 'clearTimeout', "ExternalInterface",
                'escape', 'unescape', 'setInterval', 'setTimeout', 'showRedrawRegions',
                'trace', 'updateAfterEvent', 'myName',
                'NaN', 'Infinity', 'isFinite', 'isNaN', 'parseFloat', 'parseInt', 'undefined',
                'Object', 'Function', 'Array', 'Number', 'Math', 'Boolean', 'Date', 'Selection', 'String', 'Error',
                'MovieClip', 'AsBroadcaster', 'System', 'Stage', 'Button',
                'TextField', 'Color', 'Key', 'Mouse', 'MovieClipLoader', 'XML', 'XMLNode', 'LoadVars',
                'Sound', 'SharedObject', 'ContextMenu', 'ContextMenuItem', 'TextFormat'], false);
            //'myManager', 'SoundManager'], false);
            AVM1Globals.instance = globals;
            return globals;
        };
        AVM1Globals.prototype.ASSetPropFlags = function (obj, children, flags, allowFalse) {
            // flags (from bit 0): dontenum, dontdelete, readonly, ....
            // TODO
        };
        AVM1Globals.prototype.clearIntervals = function () {
            var i = 0;
            var len = _internalTimeouts.length;
            for (i = 0; i < len; i++) {
                FrameScriptManager.clearInterval(_internalTimeouts[i]);
            }
            _internalTimeouts.length = 0;
        };
        AVM1Globals.prototype.clearInterval = function (id /* uint */) {
            var internalId = _internalTimeouts[id - 1];
            if (internalId) {
                FrameScriptManager.clearInterval(internalId);
                delete _internalTimeouts[id - 1];
            }
        };
        AVM1Globals.prototype.clearTimeout = function (id /* uint */) {
            var internalId = _internalTimeouts[id - 1];
            if (internalId) {
                FrameScriptManager.clearTimeout(internalId);
                delete _internalTimeouts[id - 1];
            }
        };
        /**
         * AVM1 escapes slightly more characters than JS's encodeURIComponent, and even more than
         * the deprecated JS version of escape. That leaves no other option but to do manual post-
         * processing of the encoded result. :/
         *
         * Luckily, unescape isn't thus afflicted - it happily unescapes all the additional things
         * we escape here.
         */
        AVM1Globals.prototype.escape = function (str) {
            var result = encodeURIComponent(str);
            return result.replace(/!|'|\(|\)|\*|-|\.|_|~/g, function (char) {
                switch (char) {
                    case '*':
                        return '%2A';
                    case '-':
                        return '%2D';
                    case '.':
                        return '%2E';
                    case '_':
                        return '%5F';
                    default:
                        return _escape(char);
                }
            });
        };
        AVM1Globals.prototype.unescape = function (str) {
            return decodeURIComponent(str);
        };
        AVM1Globals.prototype.setInterval = function () {
            // AVM1 setInterval silently swallows everything that vaguely looks like an error.
            if (arguments.length < 2) {
                return undefined;
            }
            var context = this.context;
            var fn;
            var time = alToInteger(context, arguments[1]);
            var argsStartIdx = 2;
            if (alIsFunction(arguments[0])) {
                fn = arguments[0].toJSFunction();
            }
            else {
                if (arguments.length < 3) {
                    return undefined;
                }
                var obj = arguments[0];
                var funName = arguments[1];
                time = alToInteger(context, arguments[2]);
                argsStartIdx = 3;
                if (!(obj instanceof AVM1Object) || typeof funName !== 'string') {
                    return undefined;
                }
                fn = function () {
                    var avmFn = obj.alGet(funName);
                    if (!alIsFunction(avmFn)) {
                        return;
                    }
                    var args = Array.prototype.slice.call(arguments, 0);
                    context.executeFunction(avmFn, obj, args);
                };
            }
            var args = [];
            var argsLength = arguments.length;
            for (var i = argsStartIdx; i < argsLength; i++) {
                args.push(arguments[i]);
            }
            // Unconditionally coerce interval to int, as one would do.
            var internalId;
            if (fn) {
                var callback = function () {
                    fn.apply(null, args);
                };
                internalId = FrameScriptManager.setInterval(callback, time);
            }
            return _internalTimeouts.push(internalId);
        };
        AVM1Globals.prototype.setTimeout = function () {
            // AVM1 setTimeout silently swallows most things that vaguely look like errors.
            if (arguments.length < 2 || !alIsFunction(arguments[0])) {
                return undefined;
            }
            var fn = arguments[0].toJSFunction();
            var time = alToInteger(this.context, arguments[1]);
            var args = [];
            var argsLength = arguments.length;
            for (var i = 2; i < argsLength; i++) {
                args.push(arguments[i]);
            }
            var callback = function () {
                fn.apply(null, args);
            };
            var internalId = FrameScriptManager.setTimeOut(callback, time);
            return _internalTimeouts.push(internalId);
        };
        AVM1Globals.prototype.showRedrawRegions = function (enable, color) {
            // flash.profiler.showRedrawRegions.apply(null, arguments);
            notImplemented('AVM1Globals.showRedrawRegions');
        };
        AVM1Globals.prototype.trace = function (expression) {
            if (this)
                this.context.actions.trace(expression);
        };
        AVM1Globals.prototype.updateAfterEvent = function () {
            notImplemented('AVM1Globals.updateAfterEvent');
            //this.context.sec.player.requestRendering();
        };
        AVM1Globals.prototype.isFinite = function (n) {
            return isFinite(alToNumber(this.context, n));
        };
        AVM1Globals.prototype.isNaN = function (n) {
            if (n === " ") {
                return true;
            }
            return isNaN(alToNumber(this.context, n));
        };
        AVM1Globals.prototype.parseFloat = function (s) {
            return parseFloat(alToString(this.context, s));
        };
        AVM1Globals.prototype.parseInt = function (s, radix) {
            return parseInt(alToString(this.context, s), alToInt32(this.context, radix));
        };
        AVM1Globals.prototype._initBuiltins = function (context) {
            var builtins = context.builtins;
            this.Object = builtins.Object;
            this.Function = builtins.Function;
            this.Array = builtins.Array;
            this.Number = builtins.Number;
            this.Math = builtins.Math;
            this.Boolean = builtins.Boolean;
            this.Date = builtins.Date;
            this.String = builtins.String;
            this.Error = builtins.Error;
            this.Selection = AVM1Selection.createAVM1Class(context)._ownProperties["prototype"].value;
            this.ExternalInterface = AVM1ExternalInterface.createAVM1Class(context);
            this.MovieClip = AVM1MovieClip.createAVM1Class(context);
            this.AsBroadcaster = AVM1Broadcaster.createAVM1Class(context);
            this.System = AVM1System.createAVM1Class(context);
            this.Stage = AVM1Stage.createAVM1Class(context);
            this.Button = AVM1Button.createAVM1Class(context);
            this.TextField = AVM1TextField.createAVM1Class(context);
            this.Color = AVM1Color.createAVM1Class(context);
            this.Key = AVM1Key.createAVM1Class(context);
            this.Mouse = AVM1Mouse.createAVM1Class(context);
            this.MovieClipLoader = AVM1MovieClipLoader.createAVM1Class(context);
            this.LoadVars = new AVM1LoadVarsFunction(context);
            this.Sound = AVM1Sound.createAVM1Class(context);
            this.SharedObject = AVM1SharedObject.createAVM1Class(context);
            this.ContextMenu = undefined; // wrapAVM1Builtin(sec.flash.ui.ContextMenu.axClass);
            this.ContextMenuItem = undefined; // wrapAVM1Builtin(sec.flash.ui.ContextMenuItem.axClass);
            this.TextFormat = AVM1TextFormat.createAVM1Class(context);
            this.XMLNode = new AVM1XMLNodeFunction(context);
            this.XML = new AVM1XMLFunction(context, this.XMLNode);
            this.BitmapData = AVM1BitmapData.createAVM1Class(context);
            this.Matrix = new AVM1MatrixFunction$1(context);
            this.Point = new AVM1PointFunction(context);
            this.Rectangle = new AVM1RectangleFunction(context);
            this.Transform = AVM1Transform.createAVM1Class(context);
            this.ColorTransform = new AVM1ColorTransformFunction(context);
            AVM1Broadcaster.initialize(context, this.Stage);
            AVM1Broadcaster.initialize(context, this.Key);
            AVM1Broadcaster.initialize(context, this.Mouse);
            // register own custom classes and class identifier
            for (var k in AVM1Globals._registeredCustomClasses) {
                this.alPut(k, AVM1Globals._registeredCustomClasses[k]);
            }
            for (var k in AVM1Globals._registeredCustomClassInstances) {
                this.alPut(k, AVM1Globals._registeredCustomClassInstances[k]);
            }
        };
        AVM1Globals.prototype._initializeFlashObject = function (context) {
            this.flash = alNewObject(context);
            var display = alNewObject(context);
            display.alPut('BitmapData', this.BitmapData);
            this.flash.alPut('display', display);
            var external = alNewObject(context);
            external.alPut('ExternalInterface', AVM1ExternalInterface.createAVM1Class(context));
            this.flash.alPut('external', external);
            var filters = createFiltersClasses(context);
            this.flash.alPut('filters', filters);
            this.filters = filters;
            var geom = alNewObject(context);
            geom.alPut('ColorTransform', this.ColorTransform);
            geom.alPut('Matrix', this.Matrix);
            geom.alPut('Point', this.Point);
            geom.alPut('Rectangle', this.Rectangle);
            geom.alPut('Transform', this.Transform);
            this.flash.alPut('geom', geom);
            var text = alNewObject(context);
            this.flash.alPut('text', text);
        };
        AVM1Globals._registeredCustomClasses = {};
        AVM1Globals._registeredCustomClassInstances = {};
        AVM1Globals.tracelevel = TraceLevel.NONE;
        AVM1Globals.toStringPrecision = -1;
        return AVM1Globals;
    }(AVM1Object));
    var AVM1NativeActions = /** @class */ (function () {
        function AVM1NativeActions(context) {
            this.context = context;
            // TODO ?
        }
        AVM1NativeActions.prototype.asfunction = function (link) {
            notImplemented('AVM1NativeActions.$asfunction');
        };
        AVM1NativeActions.prototype.call = function (frame) {
            // 	calls a framescript on a given frame (label or frame-number) 
            //	without navigating the mc to that frame 
            var nativeTarget = this.context.resolveTarget(null);
            nativeTarget._callFrame(frame);
        };
        AVM1NativeActions.prototype.chr = function (code) {
            // return the string for a given charcode
            code = alToInteger(this.context, code);
            if (this.context.swfVersion <= 5) {
                code &= 0xFF;
            }
            return code ? String.fromCharCode(code) : '';
        };
        AVM1NativeActions.prototype.duplicateMovieClip = function (target, newname, depth) {
            // todo: check if the DEPTH_OFFSET is 100% correct for working with AwayJS
            var normalizedDepth = alCoerceNumber(this.context, depth) - DEPTH_OFFSET;
            var nativeTarget = this.context.resolveTarget(target);
            nativeTarget.duplicateMovieClip(newname, normalizedDepth, null);
        };
        AVM1NativeActions.prototype.fscommand = function (command, args) {
            // todo: untested
            somewhatImplemented('AVM1NativeActions.fscommand');
            return this.context.sec.flash.system.fscommand.axCall(null, this.context.sec, command, args);
        };
        AVM1NativeActions.prototype.getTimer = function () {
            return new Date().getTime() - AVM1Globals.lessonStartTime;
        };
        AVM1NativeActions.prototype.getURL = function (url, target, method) {
            var sec = this.context.sec;
            var request = new URLRequest(String(url));
            if (method) {
                request.method = method;
            }
            if (typeof target === 'string' && target.indexOf('_level') === 0) {
                this.loadMovieNum(url, +target.substr(6), method);
                return;
            }
            FlashNetScript_navigateToURL(sec, request, target);
        };
        AVM1NativeActions.prototype.gotoAndPlay = function (label, frame) {
            //console.log("AVM1Globals.gotoAndPlay", label, frame);
            // even if gotoAndPlay fails to find a label, the mc wills till be set to play 
            // this is diffeent when calling gotoAndPlaycalling on mc directly)
            var avmMC = this.context.resolveTarget(null);
            avmMC.adaptee.play();
            this._gotoFrame(avmMC.adaptee, label, frame);
        };
        AVM1NativeActions.prototype.gotoAndStop = function (label, frame) {
            // see comments in gotoAndPlay
            //console.log("AVM1Globals.gotoAndStop", label, frame);
            //console.log("Scene navigation", arguments[0], scene);
            var avmMC = this.context.resolveTarget(null);
            if (typeof frame === "number" && frame <= 0)
                return;
            avmMC.adaptee.stop();
            this._gotoFrame(avmMC.adaptee, label, frame);
        };
        AVM1NativeActions.prototype._gotoFrame = function (mc, frame, offset) {
            if (Array.isArray(frame)) {
                if (frame.length == 0)
                    return;
                frame = frame[0];
            }
            if (frame instanceof AVM1ArrayNative) {
                if (!frame.value || frame.value.length == 0)
                    return;
                frame = frame.value[0];
            }
            if (typeof frame === "number") {
                if (frame % 1 !== 0) {
                    frame = frame.toString();
                }
            }
            if (typeof frame === "string") {
                if (mc.timeline._labels[frame.toLowerCase()] === null) {
                    frame = parseInt(frame);
                    if (!isNaN(frame)) {
                        mc.currentFrameIndex = frame - 1;
                    }
                    return;
                }
                mc.jumpToLabel(frame.toLowerCase(), offset);
            }
            else
                mc.currentFrameIndex = frame - 1;
        };
        AVM1NativeActions.prototype.ifFrameLoaded = function (scene, frame) {
            // ignoring scene parameter ?
            var nativeTarget = this.context.resolveTarget(null);
            var frameNum = arguments.length < 2 ? arguments[0] : arguments[1];
            var framesLoaded = nativeTarget.alGet('_framesloaded');
            var totalFrames = nativeTarget.alGet('_totalframes');
            // The (0-based) requested frame index is clamped to (the 1-based) totalFrames value.
            // I.e., asking if frame 20 is loaded in a timline with only 10 frames returns true if all
            // frames have been loaded.
            return Math.min(frameNum + 1, totalFrames) <= framesLoaded;
        };
        AVM1NativeActions.prototype.length_ = function (expression) {
            return ('' + expression).length; // ASCII Only?
        };
        AVM1NativeActions.prototype.loadMovie = function (url, target, method) {
            // some swfs are using loadMovie to call fscommmand
            if (url && url.toLowerCase().indexOf('fscommand:') === 0) {
                this.fscommand(url.substring('fscommand:'.length), target);
                return;
            }
            var loadLevel = typeof target === 'string' && target.indexOf('_level') === 0;
            var levelNumber;
            if (loadLevel) {
                var levelStr = target.substr(6);
                levelNumber = parseInt(levelStr, 10);
                loadLevel = levelNumber.toString() === levelStr;
            }
            if (loadLevel) {
                this.loadMovieNum(url, levelNumber, method);
            }
            else {
                var nativeTarget = this.context.resolveTarget(target);
                nativeTarget.loadMovie(url, method);
            }
        };
        AVM1NativeActions.prototype.loadMovieNum = function (url, level, method) {
            notImplemented("AVM1NativeActions.loadMovieNum");
            return;
            /*
            url = alCoerceString(this.context, url);
            level = alToInteger(this.context, level);
            method = alCoerceString(this.context, method);

            // some swfs are using loadMovieNum to call fscommmand
            if (url && url.toLowerCase().indexOf('fscommand:') === 0) {
                return this.fscommand(url.substring('fscommand:'.length));
            }

            if (level === 0) {
                release || Debug.notImplemented('loadMovieNum at _level0');
                return;
            }

            var avm1LevelHolder = this.context.levelsContainer;
            var loaderHelper = new AVM1LoaderHelper(this.context);
            loaderHelper.load(url, method).then(function () {
                avm1LevelHolder._addRoot(level, loaderHelper.content);
            });
            */
        };
        AVM1NativeActions.prototype.loadVariables = function (url, target, method) {
            if (method === void 0) { method = ''; }
            url = alCoerceString(this.context, url);
            method = alCoerceString(this.context, method);
            var nativeTarget = this.context.resolveTarget(target);
            if (!nativeTarget) {
                return; // target was not found
            }
            this._loadVariables(nativeTarget, url, method);
        };
        AVM1NativeActions.prototype.loadVariablesNum = function (url, level, method) {
            if (method === void 0) { method = ''; }
            url = alCoerceString(this.context, url);
            level = alToInteger(this.context, level);
            method = alCoerceString(this.context, method);
            var nativeTarget = this.context.resolveLevel(level);
            if (!nativeTarget) {
                return; // target was not found
            }
            this._loadVariables(nativeTarget, url, method);
        };
        AVM1NativeActions.prototype._loadVariables = function (nativeTarget, url, method) {
            var context = this.context;
            var request = new URLRequest(url);
            if (method) {
                request.method = method;
            }
            var loader = new URLLoader();
            //loader._ignoreDecodeErrors = true;			
            loader.dataFormat = 'variables'; // flash.net.URLLoaderDataFormat.VARIABLES;
            var completeHandler = context.sec.boxFunction(function (event) {
                loader.removeEventListener(URLLoaderEvent.LOAD_COMPLETE, completeHandler);
                // If the response data is empty, URLLoader#data contains an empty string.
                if (loader.data !== '') {
                    release$1 || Debug$1.assert(typeof loader.data === 'object');
                }
                if (nativeTarget instanceof AVM1MovieClip) {
                    avm1BroadcastEvent(context, nativeTarget, 'onData');
                }
            });
            loader.addEventListener(URLLoaderEvent.LOAD_COMPLETE, completeHandler);
            loader.load(request);
        };
        AVM1NativeActions.prototype.mbchr = function (code) {
            code = alToInteger(this.context, code);
            return code ? String.fromCharCode(code) : '';
        };
        AVM1NativeActions.prototype.mblength = function (expression) {
            return ('' + expression).length;
        };
        AVM1NativeActions.prototype.mbord = function (character) {
            return ('' + character).charCodeAt(0);
        };
        AVM1NativeActions.prototype.mbsubstring = function (value, index, count) {
            if (index !== (0 | index) || count !== (0 | count)) {
                // index or count are not integers, the result is the empty string.
                return '';
            }
            index = (index < 1) ? 0 : index - 1;
            if (count < 0)
                count = undefined;
            return ('' + value).substr(index, count);
        };
        AVM1NativeActions.prototype.nextFrame = function () {
            var nativeTarget = this.context.resolveTarget(null);
            var awayObject = getAwayJSAdaptee(nativeTarget);
            ++awayObject.currentFrameIndex;
        };
        AVM1NativeActions.prototype.nextScene = function () {
            notImplemented('AVM1NativeActions.nextScene');
            //var nativeTarget:AVM1MovieClip = <AVM1MovieClip>this.context.resolveTarget(null);
            //var awayObject:MovieClip = <MovieClip>getAwayJSAdaptee(nativeTarget);
        };
        AVM1NativeActions.prototype.ord = function (character) {
            return ('' + character).charCodeAt(0); // ASCII only?
        };
        AVM1NativeActions.prototype.play = function () {
            this.context.resolveTarget(null).play();
        };
        AVM1NativeActions.prototype.prevFrame = function () {
            var awayObject = getAwayJSAdaptee(this.context.resolveTarget(null));
            --awayObject.currentFrameIndex;
            awayObject.stop();
        };
        AVM1NativeActions.prototype.prevScene = function () {
            notImplemented('AVM1NativeActions.prevScene');
        };
        AVM1NativeActions.prototype.print = function (target, boundingBox) {
            notImplemented('AVM1NativeActions.print');
        };
        AVM1NativeActions.prototype.printAsBitmap = function (target, boundingBox) {
            notImplemented('AVM1NativeActions.printAsBitmap');
        };
        AVM1NativeActions.prototype.printAsBitmapNum = function (level, boundingBox) {
            notImplemented('AVM1NativeActions.printAsBitmapNum');
        };
        AVM1NativeActions.prototype.printNum = function (level, bondingBox) {
            notImplemented('AVM1NativeActions.printNum');
        };
        AVM1NativeActions.prototype.random = function (value) {
            if (AVM1Globals.randomProvider) {
                return 0 | (AVM1Globals.randomProvider.random() * (0 | value));
            }
            return 0 | (Math.random() * (0 | value));
        };
        AVM1NativeActions.prototype.removeMovieClip = function (target) {
            if (!target) {
                warning("AVM1NativeActions.removeMovieClip - called for undefined");
                return;
            }
            var nativeTarget = this.context.resolveTarget(target);
            if (!nativeTarget) {
                warning("AVM1NativeActions.removeMovieClip - target not found");
                return;
            }
            nativeTarget.removeMovieClip();
        };
        AVM1NativeActions.prototype.startDrag = function (target) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            var mc = this.context.resolveTarget(target);
            if (mc)
                mc.startDrag.apply(mc, args);
        };
        AVM1NativeActions.prototype.stop = function () {
            var nativeTarget = this.context.resolveTarget(null);
            nativeTarget.stop();
        };
        AVM1NativeActions.prototype.stopAllSounds = function () {
            AudioManager.stopAllSounds();
        };
        AVM1NativeActions.prototype.stopDrag = function () {
            if (AVM1MovieClip.currentDraggedMC) {
                AVM1MovieClip.currentDraggedMC.stopDrag();
            }
        };
        AVM1NativeActions.prototype.substring = function (value, index, count) {
            return this.mbsubstring(value, index, count); // ASCII Only?
        };
        AVM1NativeActions.prototype.toggleHighQuality = function () {
            // flash.display.Stage.quality
            notImplemented('AVM1NativeActions.toggleHighQuality');
        };
        AVM1NativeActions.prototype.trace = function (expression) {
            if (AVM1Globals.tracelevel == TraceLevel.NONE)
                return;
            var value;
            var isImportantTrace = false;
            switch (typeof expression) {
                case 'undefined':
                    // undefined is always 'undefined' for trace (even for SWF6).
                    value = 'undefined';
                    break;
                case 'string':
                    value = expression;
                    isImportantTrace = value.length > 0 && value[0] == "!";
                    break;
                default:
                    value = alToString(this.context, expression);
                    break;
            }
            if (AVM1Globals.tracelevel == TraceLevel.IMPORTANT && !isImportantTrace)
                return;
            console.log('%cAVM1 trace: %c ' + value + ' ', 'color: #054996', 'background: #eee; color: #054996');
        };
        AVM1NativeActions.prototype.unloadMovie = function (target) {
            var nativeTarget = this.context.resolveTarget(target);
            if (!nativeTarget) {
                warning("AVM1Globals.unloadMovie - target not found");
                return; // target was not found
            }
            nativeTarget.unloadMovie();
        };
        AVM1NativeActions.prototype.unloadMovieNum = function (level) {
            level = alToInt32(this.context, level);
            if (level === 0) {
                notImplemented('unloadMovieNum at _level0');
                return;
            }
            var avm1MovieHolder = this.context.levelsContainer;
            avm1MovieHolder._removeRoot(level);
        };
        return AVM1NativeActions;
    }());

    /*
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AVM1ObjectPrototype = /** @class */ (function (_super) {
        __extends(AVM1ObjectPrototype, _super);
        function AVM1ObjectPrototype(context) {
            return _super.call(this, context) || this;
            // Initialization must be perfromed later after the Function creation.
            // See the _initializePrototype and createBuiltins below.
        }
        AVM1ObjectPrototype.prototype._initializePrototype = function () {
            var context = this.context;
            alDefineObjectProperties(this, {
                constructor: {
                    value: context.builtins.Object,
                    writable: true
                },
                valueOf: {
                    value: this._valueOf,
                    writable: true
                },
                toString: {
                    value: this._toString,
                    writable: true
                },
                addProperty: {
                    value: this.addProperty
                },
                hasOwnProperty: {
                    value: this.hasOwnProperty
                },
                isPropertyEnumerable: {
                    value: this.isPropertyEnumerable
                },
                isPrototypeOf: {
                    value: this.isPrototypeOf
                },
                unwatch: {
                    value: this.unwatch
                },
                watch: {
                    value: this.watch
                }
            });
        };
        AVM1ObjectPrototype.prototype._valueOf = function () {
            return this;
        };
        AVM1ObjectPrototype.prototype._toString = function () {
            if (alIsFunction(this)) {
                // Really weird case of functions.
                return '[type ' + alGetObjectClass(this) + ']';
            }
            return '[object ' + alGetObjectClass(this) + ']';
        };
        AVM1ObjectPrototype.prototype.addProperty = function (name, getter, setter) {
            if (typeof name !== 'string' || name === '') {
                return false;
            }
            if (!alIsFunction(getter)) {
                return false;
            }
            if (!alIsFunction(setter) && setter !== null) {
                return false;
            }
            var desc = this.alGetOwnProperty(name);
            if (desc && !!(desc.flags & 2 /* DONT_DELETE */)) {
                return false; // protected property
            }
            this.alSetOwnProperty(name, new AVM1PropertyDescriptor(128 /* ACCESSOR */, null, getter, setter || undefined));
            return true;
        };
        AVM1ObjectPrototype.prototype.hasOwnProperty = function (name) {
            return this.alHasOwnProperty(name);
        };
        AVM1ObjectPrototype.prototype.isPropertyEnumerable = function (name) {
            var desc = this.alGetProperty(name);
            return !(desc.flags & 1 /* DONT_ENUM */);
        };
        AVM1ObjectPrototype.prototype.isPrototypeOf = function (theClass) {
            return alInstanceOf(this.context, this, theClass);
        };
        AVM1ObjectPrototype.prototype.unwatch = function (name) {
            name = alCoerceString(this.context, name);
            return this.alRemotePropertyWatcher(name);
        };
        AVM1ObjectPrototype.prototype.watch = function (name, callback, userData) {
            name = alCoerceString(this.context, name);
            if (!alIsFunction(callback)) {
                return false;
            }
            return this.alAddPropertyWatcher(name, callback, userData);
        };
        return AVM1ObjectPrototype;
    }(AVM1Object));
    var AVM1ObjectFunction = /** @class */ (function (_super) {
        __extends(AVM1ObjectFunction, _super);
        function AVM1ObjectFunction(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Function.alGetPrototypeProperty();
            var proto = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                prototype: {
                    value: proto
                },
                registerClass: {
                    value: _this.registerClass
                }
            });
            return _this;
        }
        AVM1ObjectFunction.prototype.registerClass = function (name, theClass) {
            this.context.registerClass(name, theClass);
        };
        AVM1ObjectFunction.prototype.alConstruct = function (args) {
            if (args) {
                var value = args[0];
                if (value instanceof AVM1Object) {
                    return value;
                }
                switch (typeof value) {
                    case 'string':
                    case 'boolean':
                    case 'number':
                        return alToObject(this.context, value);
                }
            }
            // null or undefined
            return alNewObject(this.context);
        };
        AVM1ObjectFunction.prototype.alCall = function (thisArg, args) {
            if (!args || args[0] === null || args[0] === undefined) {
                return alNewObject(this.context);
            }
            return alToObject(this.context, args[0]);
        };
        return AVM1ObjectFunction;
    }(AVM1Function));
    // Function natives
    var AVM1FunctionPrototype = /** @class */ (function (_super) {
        __extends(AVM1FunctionPrototype, _super);
        function AVM1FunctionPrototype(context) {
            return _super.call(this, context) || this;
        }
        AVM1FunctionPrototype.prototype._initializePrototype = function () {
            var context = this.context;
            this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(this, {
                constructor: {
                    value: context.builtins.Function,
                    writable: true
                },
                call: this.call,
                apply: this.apply
            });
        };
        AVM1FunctionPrototype.prototype.call = function (thisArg) {
            var args = [];
            for (var _a = 1; _a < arguments.length; _a++) {
                args[_a - 1] = arguments[_a];
            }
            var fn = alEnsureType(this, AVM1Function);
            return fn.alCall(thisArg, args);
        };
        AVM1FunctionPrototype.prototype.apply = function (thisArg, args) {
            var fn = alEnsureType(this, AVM1Function);
            var nativeArgs = !args ? undefined :
                alEnsureType(args, AVM1ArrayNative).value;
            return fn.alCall(thisArg, nativeArgs);
        };
        return AVM1FunctionPrototype;
    }(AVM1Object));
    var AVM1FunctionFunction = /** @class */ (function (_super) {
        __extends(AVM1FunctionFunction, _super);
        function AVM1FunctionFunction(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Function.alGetPrototypeProperty();
            var proto = context.builtins.Function.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                prototype: {
                    value: proto
                }
            });
            return _this;
        }
        AVM1FunctionFunction.prototype.alConstruct = function (args) {
            // ActionScript just returns the first argument.
            return args ? args[0] : undefined;
        };
        AVM1FunctionFunction.prototype.alCall = function (thisArg, args) {
            // ActionScript just returns the first argument.
            return args ? args[0] : undefined;
        };
        return AVM1FunctionFunction;
    }(AVM1Function));
    // Boolean natives
    var AVM1BooleanNative = /** @class */ (function (_super) {
        __extends(AVM1BooleanNative, _super);
        function AVM1BooleanNative(context, value) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Boolean.alGetPrototypeProperty();
            _this.alSetOwnConstructorProperty(context.builtins.Boolean);
            _this.value = value;
            return _this;
        }
        AVM1BooleanNative.prototype.valueOf = function () {
            return this.value;
        };
        return AVM1BooleanNative;
    }(AVM1Object));
    var AVM1BooleanPrototype = /** @class */ (function (_super) {
        __extends(AVM1BooleanPrototype, _super);
        function AVM1BooleanPrototype(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                constructor: {
                    value: context.builtins.Boolean,
                    writable: true
                },
                valueOf: {
                    value: _this._valueOf,
                    writable: true
                },
                toString: {
                    value: _this._toString,
                    writable: true
                }
            });
            return _this;
        }
        AVM1BooleanPrototype.prototype._valueOf = function () {
            var native = alEnsureType(this, AVM1BooleanNative);
            return native.value;
        };
        AVM1BooleanPrototype.prototype._toString = function () {
            var native = alEnsureType(this, AVM1BooleanNative);
            return native.value ? 'true' : 'false';
        };
        return AVM1BooleanPrototype;
    }(AVM1Object));
    var AVM1BooleanFunction = /** @class */ (function (_super) {
        __extends(AVM1BooleanFunction, _super);
        function AVM1BooleanFunction(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Function.alGetPrototypeProperty();
            var proto = new AVM1BooleanPrototype(context);
            alDefineObjectProperties(_this, {
                prototype: {
                    value: proto
                }
            });
            return _this;
        }
        AVM1BooleanFunction.prototype.alConstruct = function (args) {
            var value = args ? alToBoolean(this.context, args[0]) : false;
            return new AVM1BooleanNative(this.context, value);
        };
        AVM1BooleanFunction.prototype.alCall = function (thisArg, args) {
            // TODO returns boolean value?
            var value = args ? alToBoolean(this.context, args[0]) : false;
            return value;
        };
        return AVM1BooleanFunction;
    }(AVM1Function));
    // Number natives
    var AVM1NumberNative = /** @class */ (function (_super) {
        __extends(AVM1NumberNative, _super);
        function AVM1NumberNative(context, value) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Number.alGetPrototypeProperty();
            _this.alSetOwnConstructorProperty(context.builtins.Number);
            _this.value = value;
            return _this;
        }
        AVM1NumberNative.prototype.valueOf = function () {
            return this.value;
        };
        return AVM1NumberNative;
    }(AVM1Object));
    var AVM1NumberPrototype = /** @class */ (function (_super) {
        __extends(AVM1NumberPrototype, _super);
        function AVM1NumberPrototype(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                constructor: {
                    value: context.builtins.Number,
                    writable: true
                },
                valueOf: {
                    value: _this._valueOf,
                    writable: true
                },
                toString: {
                    value: _this._toString,
                    writable: true
                }
            });
            return _this;
        }
        AVM1NumberPrototype.prototype._valueOf = function () {
            var native = alEnsureType(this, AVM1NumberNative);
            return native.value;
        };
        AVM1NumberPrototype.prototype._toString = function (radix) {
            var native = alEnsureType(this, AVM1NumberNative);
            return native.value.toString(radix || 10);
        };
        return AVM1NumberPrototype;
    }(AVM1Object));
    var AVM1NumberFunction = /** @class */ (function (_super) {
        __extends(AVM1NumberFunction, _super);
        function AVM1NumberFunction(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Function.alGetPrototypeProperty();
            var proto = new AVM1NumberPrototype(context);
            alDefineObjectProperties(_this, {
                prototype: {
                    value: proto
                },
                MAX_VALUE: Number.MAX_VALUE,
                MIN_VALUE: Number.MIN_VALUE,
                NaN: Number.NaN,
                NEGATIVE_INFINITY: Number.NEGATIVE_INFINITY,
                POSITIVE_INFINITY: Number.POSITIVE_INFINITY
            });
            return _this;
        }
        AVM1NumberFunction.prototype.alConstruct = function (args) {
            var value = args ? alToNumber(this.context, args[0]) : 0;
            return new AVM1NumberNative(this.context, value);
        };
        AVM1NumberFunction.prototype.alCall = function (thisArg, args) {
            // TODO returns number value?
            var value = args ? alToNumber(this.context, args[0]) : 0;
            return value;
        };
        return AVM1NumberFunction;
    }(AVM1Function));
    // String natives
    var AVM1StringNative = /** @class */ (function (_super) {
        __extends(AVM1StringNative, _super);
        function AVM1StringNative(context, value) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.String.alGetPrototypeProperty();
            _this.alSetOwnConstructorProperty(context.builtins.String);
            _this.value = value;
            return _this;
        }
        AVM1StringNative.prototype.toString = function () {
            return this.value;
        };
        return AVM1StringNative;
    }(AVM1Object));
    // Most of the methods of String prototype are generic and accept any object.
    var AVM1StringPrototype = /** @class */ (function (_super) {
        __extends(AVM1StringPrototype, _super);
        function AVM1StringPrototype(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                constructor: {
                    value: context.builtins.String,
                    writable: true
                },
                valueOf: {
                    value: _this._valueOf,
                    writable: true
                },
                toString: {
                    value: _this._toString,
                    writable: true
                },
                length: {
                    get: _this.getLength
                },
                charAt: {
                    value: _this.charAt,
                    writable: true
                },
                charCodeAt: {
                    value: _this.charCodeAt,
                    writable: true
                },
                concat: {
                    value: _this.concat,
                    writable: true
                },
                indexOf: {
                    value: _this.indexOf,
                    writable: true
                },
                lastIndexOf: {
                    value: _this.lastIndexOf,
                    writable: true
                },
                slice: {
                    value: _this.slice,
                    writable: true
                },
                split: {
                    value: _this.split,
                    writable: true
                },
                substr: {
                    value: _this.substr,
                    writable: true
                },
                substring: {
                    value: _this.substring,
                    writable: true
                },
                toLowerCase: {
                    value: _this.toLowerCase,
                    writable: true
                },
                toUpperCase: {
                    value: _this.toUpperCase,
                    writable: true
                }
            });
            return _this;
        }
        AVM1StringPrototype.prototype._valueOf = function () {
            var native = alEnsureType(this, AVM1StringNative);
            return native.value;
        };
        AVM1StringPrototype.prototype._toString = function () {
            var native = alEnsureType(this, AVM1StringNative);
            return native.value;
        };
        AVM1StringPrototype.prototype.getLength = function () {
            var native = alEnsureType(this, AVM1StringNative);
            return native.value.length;
        };
        AVM1StringPrototype.prototype.charAt = function (index) {
            var value = alToString(this.context, this);
            return value.charAt(alToInteger(this.context, index));
        };
        AVM1StringPrototype.prototype.charCodeAt = function (index) {
            var value = alToString(this.context, this);
            return value.charCodeAt(alToInteger(this.context, index));
        };
        AVM1StringPrototype.prototype.concat = function () {
            var items = [];
            for (var _a = 0; _a < arguments.length; _a++) {
                items[_a] = arguments[_a];
            }
            var stringItems = [alToString(this.context, this)];
            for (var i = 0; i < items.length; ++i) {
                stringItems.push(alToString(this.context, items[i]));
            }
            return stringItems.join('');
        };
        AVM1StringPrototype.prototype.indexOf = function (searchString, position) {
            var value = alToString(this.context, this);
            searchString = alToString(this.context, searchString);
            position = alToInteger(this.context, position);
            return value.indexOf(searchString, position);
        };
        AVM1StringPrototype.prototype.lastIndexOf = function (searchString, position) {
            var value = alToString(this.context, this);
            searchString = alToString(this.context, searchString);
            position = arguments.length < 2 ? NaN : alToNumber(this.context, position); // SWF6 alToNumber(undefined) === 0
            if (position < 0) {
                // Different from JS
                return -1;
            }
            return value.lastIndexOf(searchString, isNaN(position) ? undefined : position);
        };
        AVM1StringPrototype.prototype.slice = function (start, end) {
            if (arguments.length === 0) {
                // Different from JS
                return undefined;
            }
            var value = alToString(this.context, this);
            start = alToInteger(this.context, start);
            end = end === undefined ? undefined : alToInteger(this.context, end);
            return value.slice(start, end);
        };
        AVM1StringPrototype.prototype.split = function (separator, limit) {
            var value = alToString(this.context, this);
            // TODO separator as regular expression?
            // for undefined seperator, flash does not do any split at all
            if (typeof separator !== "undefined") {
                separator = alToString(this.context, separator);
                limit = (limit === undefined ? ~0 : alToInt32(this.context, limit)) >>> 0;
                return new AVM1ArrayNative(this.context, value.split(separator, limit));
            }
            return new AVM1ArrayNative(this.context, [value]);
        };
        AVM1StringPrototype.prototype.substr = function (start, length) {
            // Different from JS
            var value = alToString(this.context, this);
            var valueLength = value.length;
            start = alToInteger(this.context, start);
            length = length === undefined ? valueLength : alToInteger(this.context, length);
            if (start < 0) {
                start = Math.max(0, valueLength + start);
            }
            if (length < 0) {
                if (-length <= start) { // this one is weird -- don't ask
                    return '';
                }
                length = Math.max(0, valueLength + length);
            }
            return value.substr(start, length);
        };
        AVM1StringPrototype.prototype.substring = function (start, end) {
            var value = alToString(this.context, this);
            start = alToInteger(this.context, start);
            if (start >= value.length) {
                // Different from JS
                return '';
            }
            end = end === undefined ? undefined : alToInteger(this.context, end);
            return value.substring(start, end);
        };
        AVM1StringPrototype.prototype.toLowerCase = function () {
            var value = alToString(this.context, this);
            return value.toLowerCase();
        };
        AVM1StringPrototype.prototype.toUpperCase = function () {
            var value = alToString(this.context, this);
            return value.toUpperCase();
        };
        return AVM1StringPrototype;
    }(AVM1Object));
    var AVM1StringFunction = /** @class */ (function (_super) {
        __extends(AVM1StringFunction, _super);
        function AVM1StringFunction(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Function.alGetPrototypeProperty();
            var proto = new AVM1StringPrototype(context);
            alDefineObjectProperties(_this, {
                prototype: {
                    value: proto
                },
                fromCharCode: {
                    value: _this.fromCharCode
                }
            });
            return _this;
        }
        AVM1StringFunction.prototype.alConstruct = function (args) {
            var value = args ? alToString(this.context, args[0]) : '';
            return new AVM1StringNative(this.context, value);
        };
        AVM1StringFunction.prototype.alCall = function (thisArg, args) {
            var value = args ? alToString(this.context, args[0]) : '';
            return value;
        };
        AVM1StringFunction.prototype.fromCharCode = function () {
            var _this = this;
            var codes = [];
            for (var _a = 0; _a < arguments.length; _a++) {
                codes[_a] = arguments[_a];
            }
            codes = codes.map(function (code) { return alToInt32(_this.context, code) & 0xFFFF; });
            return String.fromCharCode.apply(String, codes);
        };
        return AVM1StringFunction;
    }(AVM1Function));
    // Array natives
    var cachedArrayPropertyDescriptor = new AVM1PropertyDescriptor(64 /* DATA */, undefined);
    var AVM1ArrayNative = /** @class */ (function (_super) {
        __extends(AVM1ArrayNative, _super);
        function AVM1ArrayNative(context, value) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Array.alGetPrototypeProperty();
            _this.alSetOwnConstructorProperty(context.builtins.Array);
            _this.value = value;
            return _this;
        }
        AVM1ArrayNative.prototype.alGetOwnProperty = function (p) {
            if (alIsIndex(this.context, p)) {
                var index = alToInt32(this.context, p);
                if (Object.getOwnPropertyDescriptor(this.value, index)) {
                    cachedArrayPropertyDescriptor.value = this.value[index];
                    return cachedArrayPropertyDescriptor;
                }
            }
            return _super.prototype.alGetOwnProperty.call(this, p);
        };
        AVM1ArrayNative.prototype.alSetOwnProperty = function (p, v) {
            if (alIsIndex(this.context, p)) {
                var index = alToInt32(this.context, p);
                if (!(v.flags & 64 /* DATA */) ||
                    !!(v.flags & 1 /* DONT_ENUM */) ||
                    !!(v.flags & 2 /* DONT_DELETE */)) {
                    throw new Error('Special property is non-supported for array');
                }
                this.value[index] = v.value;
                return;
            }
            _super.prototype.alSetOwnProperty.call(this, p, v);
        };
        AVM1ArrayNative.prototype.alDeleteOwnProperty = function (p) {
            if (alIsIndex(this.context, p)) {
                var index = alToInt32(this.context, p);
                delete this.value[index];
                return;
            }
            _super.prototype.alDeleteOwnProperty.call(this, p);
        };
        AVM1ArrayNative.prototype.alGetOwnPropertiesKeys = function () {
            var keys = _super.prototype.alGetOwnPropertiesKeys.call(this);
            var itemIndices = [];
            for (var i in this.value) {
                itemIndices.push(i);
            }
            return itemIndices.concat(keys);
        };
        /**
         * Creates a JavaScript array from the AVM1 list object.
         * @param arr     An array-like AVM1 object.
         * @param fn      A function that converts AVM1 list object item to JavaScript object.
         * @param thisArg Optional. Value to use as this when executing fn.
         * @returns {any[]} A JavaScript array.
         */
        AVM1ArrayNative.mapToJSArray = function (arr, fn, thisArg) {
            if (arr instanceof AVM1ArrayNative) {
                return arr.value.map(fn, thisArg);
            }
            // This method is generic, so array-like objects can use it.
            if (!alIsArrayLike(arr.context, arr)) {
                // TODO generate proper AVM1 exception.
                throw new Error('Invalid type'); // Interpreter will catch this.
            }
            var result = [];
            alIterateArray(arr.context, arr, function (item, index) {
                result.push(fn.call(thisArg, item, index));
            });
            return result;
        };
        return AVM1ArrayNative;
    }(AVM1Object));
    var AVM1ArraySortOnOptions;
    (function (AVM1ArraySortOnOptions) {
        AVM1ArraySortOnOptions[AVM1ArraySortOnOptions["CASEINSENSITIVE"] = 1] = "CASEINSENSITIVE";
        AVM1ArraySortOnOptions[AVM1ArraySortOnOptions["DESCENDING"] = 2] = "DESCENDING";
        AVM1ArraySortOnOptions[AVM1ArraySortOnOptions["UNIQUESORT"] = 4] = "UNIQUESORT";
        AVM1ArraySortOnOptions[AVM1ArraySortOnOptions["RETURNINDEXEDARRAY"] = 8] = "RETURNINDEXEDARRAY";
        AVM1ArraySortOnOptions[AVM1ArraySortOnOptions["NUMERIC"] = 16] = "NUMERIC";
    })(AVM1ArraySortOnOptions || (AVM1ArraySortOnOptions = {}));
    var sortArray = function (arr_in, comparefn) {
        var arr = alEnsureType(arr_in, AVM1ArrayNative).value;
        if (!alIsFunction(comparefn)) {
            var doNumeric = typeof comparefn === "number" && (comparefn & AVM1ArraySortOnOptions.NUMERIC || comparefn == -1);
            var doDescending = typeof comparefn === "number" && (comparefn & AVM1ArraySortOnOptions.DESCENDING);
            if (doNumeric) {
                arr.sort(function (a, b) {
                    while (a instanceof AVM1ArrayNative) {
                        a = alEnsureType(a, AVM1ArrayNative).value;
                        if (a && a.length > 0)
                            a = a[0];
                    }
                    while (b instanceof AVM1ArrayNative) {
                        b = alEnsureType(b, AVM1ArrayNative).value;
                        if (b && b.length > 0)
                            b = b[0];
                    }
                    return a - b;
                });
            }
            else {
                // ugly hack for moving undefined values to the beginning of the array
                var i = arr.length;
                while (i > 0) {
                    i--;
                    if (typeof arr[i] === "undefined" || arr[i] === null) {
                        arr[i] = "00000000000AwayInternal";
                    }
                }
                arr.sort(function (a, b) {
                    while (a instanceof AVM1ArrayNative) {
                        a = alEnsureType(a, AVM1ArrayNative).value;
                        if (a && a.length > 0)
                            a = a[0];
                    }
                    while (b instanceof AVM1ArrayNative) {
                        b = alEnsureType(b, AVM1ArrayNative).value;
                        if (b && b.length > 0)
                            b = b[0];
                    }
                    return (a < b) ? -1 : 1;
                });
                i = arr.length;
                while (i > 0) {
                    i--;
                    if (arr[i] == "00000000000AwayInternal") {
                        arr[i] = undefined;
                    }
                }
            }
            if (doDescending)
                arr.reverse();
        }
        else {
            var args = [undefined, undefined];
            arr.sort(function (a, b) {
                args[0] = a;
                args[1] = b;
                return comparefn.alCall(null, args);
            });
        }
        return arr_in;
    };
    // TODO implement all the Array class and its prototype natives
    var AVM1ArrayPrototype = /** @class */ (function (_super) {
        __extends(AVM1ArrayPrototype, _super);
        function AVM1ArrayPrototype(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                constructor: {
                    value: context.builtins.Array,
                    writable: true
                },
                join: {
                    value: _this.join,
                    writable: true
                },
                length: {
                    get: _this.getLength,
                    set: _this.setLength
                },
                concat: {
                    value: _this.concat,
                    writable: true
                },
                pop: {
                    value: _this.pop,
                    writable: true
                },
                push: {
                    value: _this.push,
                    writable: true
                },
                reverse: {
                    value: _this.reverse,
                    writable: true
                },
                shift: {
                    value: _this.shift,
                    writable: true
                },
                slice: {
                    value: _this.slice,
                    writable: true
                },
                splice: {
                    value: _this.splice,
                    writable: true
                },
                sort: {
                    value: _this.sort,
                    writable: true
                },
                sortOn: {
                    value: _this.sortOn,
                    writable: true
                },
                toString: {
                    value: _this._toString,
                    writable: true
                },
                unshift: {
                    value: _this.unshift,
                    writable: true
                },
            });
            return _this;
        }
        AVM1ArrayPrototype.prototype._toString = function () {
            var len = this.alGet("length");
            var _i = 0;
            var outputStr = "";
            var tmpitem;
            for (_i = 0; _i < len; _i++) {
                tmpitem = this.alGet(_i);
                if (typeof tmpitem !== "undefined") {
                    outputStr += alToString(this.context, tmpitem) + ((_i == len - 1) ? "" : ",");
                }
                else {
                    outputStr += ((_i == len - 1) ? "" : ",");
                }
            }
            return outputStr;
        };
        AVM1ArrayPrototype.prototype.getLength = function () {
            var arr = alEnsureType(this, AVM1ArrayNative).value;
            return arr.length;
        };
        AVM1ArrayPrototype.prototype.setLength = function (length) {
            if (length === null) {
                length = 0;
            }
            if (!isIndex(length)) {
                return; // no action on invalid length
            }
            length = alToInt32(this.context, length) >>> 0;
            var arr = alEnsureType(this, AVM1ArrayNative).value;
            arr.length = length;
        };
        AVM1ArrayPrototype.prototype.concat = function () {
            var items = [];
            for (var _a = 0; _a < arguments.length; _a++) {
                items[_a] = arguments[_a];
            }
            if (this instanceof AVM1ArrayNative) {
                // Faster case for native array implementation
                var arr = alEnsureType(this, AVM1ArrayNative).value;
                for (var i = 0; i < items.length; i++) {
                    if (items[i] instanceof AVM1ArrayNative) {
                        items[i] = alEnsureType(items[i], AVM1ArrayNative).value;
                    }
                }
                //this.value=arr.concat(items);
                return new AVM1ArrayNative(this.context, Array.prototype.concat.apply(arr, items));
                //return this;
            }
            // Generic behavior
            var a = [];
            var e = this;
            var isArrayObject = alIsArrayLike(this.context, this);
            var i = 0;
            while (true) {
                if (isArrayObject) {
                    alIterateArray(this.context, e, function (value) { return a.push(value); });
                }
                else {
                    a.push(alToString(this.context, e));
                }
                if (i >= items.length) {
                    break;
                }
                e = items[i++];
                isArrayObject = alIsArray(this.context, e); // not-logical behavior
            }
            return new AVM1ArrayNative(this.context, a);
        };
        AVM1ArrayPrototype.prototype.join = function (separator) {
            separator = separator === undefined ? ',' : alCoerceString(this.context, separator);
            if (this instanceof AVM1ArrayNative) {
                // Faster case for native array implementation
                var arr = alEnsureType(this, AVM1ArrayNative).value;
                if (arr.length === 0) {
                    return '';
                }
                if (arr.every(function (i) { return !(i instanceof AVM1Object); })) {
                    return arr.join(separator);
                }
            }
            var context = this.context;
            var length = alToInt32(context, this.alGet('length')) >>> 0;
            if (length === 0) {
                return '';
            }
            var result = [];
            for (var i = 0; i < length; i++) {
                var item = this.alGet(i);
                result[i] = item === null || item === undefined ? '' : alCoerceString(context, item);
            }
            return result.join(separator);
        };
        AVM1ArrayPrototype.prototype.pop = function () {
            if (this instanceof AVM1ArrayNative) {
                // Faster case for native array implementation
                var arr = alEnsureType(this, AVM1ArrayNative).value;
                return arr.pop();
            }
            var length = alToInt32(this.context, this.alGet('length')) >>> 0;
            if (length === 0) {
                return undefined;
            }
            var i = length - 1;
            var result = this.alGet(i);
            this.alDeleteProperty(i);
            this.alPut('length', i);
            return result;
        };
        AVM1ArrayPrototype.prototype.push = function () {
            var items = [];
            for (var _a = 0; _a < arguments.length; _a++) {
                items[_a] = arguments[_a];
            }
            if (this instanceof AVM1ArrayNative) {
                // Faster case for native array implementation
                var arr = alEnsureType(this, AVM1ArrayNative).value;
                return Array.prototype.push.apply(arr, items);
            }
            var length = alToInt32(this.context, this.alGet('length')) >>> 0;
            for (var i = 0; i < items.length; i++) {
                this.alPut(length, items[i]);
                length++; // TODO check overflow
            }
            this.alPut('length', length);
            return length;
        };
        AVM1ArrayPrototype.prototype.reverse = function () {
            var items = [];
            var len = this.alGet("length");
            var _i = 0;
            for (_i = 0; _i < len; _i++) {
                items[_i] = this.alGet(_i);
            }
            _i = len - 1;
            while (_i >= 0) {
                this.alPut((len - 1 - _i), items[_i]);
                _i--;
            }
            return this.value;
        };
        AVM1ArrayPrototype.prototype.shift = function () {
            if (this instanceof AVM1ArrayNative) {
                // Faster case for native array implementation
                var arr = alEnsureType(this, AVM1ArrayNative).value;
                return arr.shift();
            }
            var length = alToInt32(this.context, this.alGet('length')) >>> 0;
            if (length === 0) {
                return undefined;
            }
            var result = this.alGet(0);
            for (var i = 1; i < length; i++) {
                if (this.alHasProperty(i)) {
                    this.alPut(i - 1, this.alGet(i));
                }
                else {
                    this.alDeleteProperty(i - 1);
                }
            }
            this.alDeleteProperty(length - 1);
            this.alPut('length', length - 1);
            return result;
        };
        AVM1ArrayPrototype.prototype.slice = function (start, end) {
            start = alToInteger(this.context, start);
            end = end !== undefined ? alToInteger(this.context, end) : undefined;
            if (this instanceof AVM1ArrayNative) {
                // Faster case for native array implementation
                var arr = alEnsureType(this, AVM1ArrayNative).value;
                return new AVM1ArrayNative(this.context, arr.slice(start, end));
            }
            var a = [];
            var length = alToInt32(this.context, this.alGet('length')) >>> 0;
            start = start < 0 ? Math.max(length + start, 0) : Math.min(length, start);
            end = end === undefined ? length :
                (end < 0 ? Math.max(length + end, 0) : Math.min(length, end));
            for (var i = start, j = 0; i < end; i++, j++) {
                if (this.alHasProperty(i)) {
                    a[j] = this.alGet(i);
                }
            }
            return new AVM1ArrayNative(this.context, a);
        };
        AVM1ArrayPrototype.prototype.splice = function (start, deleteCount) {
            var items = [];
            for (var _a = 2; _a < arguments.length; _a++) {
                items[_a - 2] = arguments[_a];
            }
            start = alToInteger(this.context, start);
            var length = alToInt32(this.context, this.alGet('length')) >>> 0;
            start = start < 0 ? Math.max(length + start, 0) : Math.min(length, start);
            //if(deleteCount || typeof deleteCount==="number")
            //    deleteCount = alToInteger(this.context, deleteCount);
            if (deleteCount || typeof deleteCount === "number")
                deleteCount = alToInteger(this.context, deleteCount);
            else
                deleteCount = length - start;
            if (this instanceof AVM1ArrayNative) {
                // Faster case for native array implementation
                var arr = alEnsureType(this, AVM1ArrayNative).value;
                return new AVM1ArrayNative(this.context, Array.prototype.splice.apply(arr, [start, deleteCount].concat(items)));
            }
            var a = [];
            for (var i = 0; i < deleteCount; i++) {
                if (this.alHasProperty(start + i)) {
                    a[i] = this.alGet(start + i);
                }
            }
            var delta = items.length - deleteCount;
            if (delta < 0) {
                for (var i = start - delta; i < length; i++) {
                    if (this.alHasProperty(i)) {
                        this.alPut(i + delta, this.alGet(i));
                    }
                    else {
                        this.alDeleteProperty(i + delta);
                    }
                }
                for (var i = delta; i < 0; i++) {
                    this.alDeleteProperty(length + i);
                }
            }
            else if (delta > 0) {
                // TODO check overflow
                for (var i = length - 1; i >= start + delta; i--) {
                    if (this.alHasProperty(i)) {
                        this.alPut(i + delta, this.alGet(i));
                    }
                    else {
                        this.alDeleteProperty(i + delta);
                    }
                }
            }
            for (var i = 0; i < items.length; i++) {
                this.alPut(start + i, items[i]);
            }
            this.alPut('length', length + delta);
            return new AVM1ArrayNative(this.context, a);
        };
        AVM1ArrayPrototype.prototype.sort = function (comparefn) {
            return sortArray(this, comparefn);
        };
        AVM1ArrayPrototype.prototype.sortOn = function (fieldNames, options) {
            var context = this.context;
            // The field names and options we'll end up using.
            var fieldNamesList = [];
            var optionsList = [];
            if (alIsString(context, fieldNames)) {
                fieldNamesList = [alToString(context, fieldNames)];
                optionsList = [alToInt32(context, options)];
            }
            else if (alIsArray(context, fieldNames)) {
                fieldNamesList = [];
                optionsList = [];
                var optionsArray = alIsArray(context, options) ? options : null;
                var length = alToInteger(context, fieldNames.alGet('length'));
                if (optionsArray) {
                    // checking in length of fieldNames == options
                    var optionsLength = alToInteger(context, optionsArray.alGet('length'));
                    if (length !== optionsLength) {
                        optionsArray = null;
                    }
                }
                for (var i = 0; i < length; i++) {
                    fieldNamesList.push(alToString(context, fieldNames.alGet(i)));
                    optionsList.push(optionsArray ? alToInt32(context, optionsArray.alGet(i)) : 0);
                }
            }
            else {
                // Field parameters are incorrect.
                return sortArray(this, options);
            }
            // TODO revisit this code
            var optionsVal = optionsList[0];
            release$1 || Debug$1.assertNotImplemented(!(optionsVal & AVM1ArraySortOnOptions.UNIQUESORT), "UNIQUESORT");
            release$1 || Debug$1.assertNotImplemented(!(optionsVal & AVM1ArraySortOnOptions.RETURNINDEXEDARRAY), "RETURNINDEXEDARRAY");
            var comparer = function (a, b) {
                while (a instanceof AVM1ArrayNative) {
                    a = alEnsureType(a, AVM1ArrayNative).value;
                    if (a && a.length > 0)
                        a = a[0];
                }
                while (b instanceof AVM1ArrayNative) {
                    b = alEnsureType(b, AVM1ArrayNative).value;
                    if (b && b.length > 0)
                        b = b[0];
                }
                var aObj = alToObject(context, a);
                var bObj = alToObject(context, b);
                for (var i = 0; i < fieldNamesList.length; i++) {
                    var aField = aObj.alGet(fieldNamesList[i]);
                    var bField = bObj.alGet(fieldNamesList[i]);
                    var result;
                    if (optionsList[i] & AVM1ArraySortOnOptions.NUMERIC) {
                        var aNum = alToNumber(context, aField);
                        var bNum = alToNumber(context, bField);
                        result = aNum < bNum ? -1 : aNum > bNum ? +1 : 0;
                    }
                    else {
                        var aStr = alToString(context, aField);
                        var bStr = alToString(context, bField);
                        if (optionsList[i] & AVM1ArraySortOnOptions.CASEINSENSITIVE) {
                            aStr = aStr.toLowerCase();
                            bStr = bStr.toLowerCase();
                        }
                        result = aStr < bStr ? -1 : aStr > bStr ? +1 : 0;
                    }
                    if (result !== 0) {
                        return !(optionsList[i] & AVM1ArraySortOnOptions.DESCENDING) ? result : -result;
                    }
                }
                return 0;
            };
            var arr = alEnsureType(this, AVM1ArrayNative).value;
            arr.sort(comparer);
            // Strange, the documentation said to do not return anything.
            return this;
        };
        AVM1ArrayPrototype.prototype.unshift = function () {
            var items = [];
            for (var _a = 0; _a < arguments.length; _a++) {
                items[_a] = arguments[_a];
            }
            if (this instanceof AVM1ArrayNative) {
                // Faster case for native array implementation
                var arr = alEnsureType(this, AVM1ArrayNative).value;
                return Array.prototype.unshift.apply(arr, items);
            }
            var length = alToInt32(this.context, this.alGet('length')) >>> 0;
            var insertCount = items.length;
            // TODO check overflow
            for (var i = length - 1; i >= 0; i--) {
                if (this.alHasProperty(i)) {
                    this.alPut(i + insertCount, this.alGet(i));
                }
                else {
                    this.alDeleteProperty(i + insertCount);
                }
            }
            for (var i = 0; i < items.length; i++) {
                this.alPut(i, items[i]);
            }
            length += insertCount;
            this.alPut('length', length); // ActionScript does not do that?
            return length;
        };
        return AVM1ArrayPrototype;
    }(AVM1Object));
    var AVM1ArrayFunction = /** @class */ (function (_super) {
        __extends(AVM1ArrayFunction, _super);
        function AVM1ArrayFunction(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Function.alGetPrototypeProperty();
            var proto = new AVM1ArrayPrototype(context);
            alDefineObjectProperties(_this, {
                prototype: {
                    value: proto
                }
            });
            alDefineObjectProperties(_this, {
                NUMERIC: {
                    value: AVM1ArraySortOnOptions.NUMERIC
                }
            });
            alDefineObjectProperties(_this, {
                DESCENDING: {
                    value: AVM1ArraySortOnOptions.DESCENDING
                }
            });
            return _this;
        }
        AVM1ArrayFunction.prototype.alConstruct = function (args) {
            if (!args) {
                return new AVM1ArrayNative(this.context, []);
            }
            if (args.length === 1 && typeof args[0] === 'number') {
                var len = args[0];
                if (len >>> 0 !== len) {
                    throw new Error('Range error'); // TODO avm1 native
                }
                return new AVM1ArrayNative(this.context, new Array(len));
            }
            return new AVM1ArrayNative(this.context, args);
        };
        AVM1ArrayFunction.prototype.alCall = function (thisArg, args) {
            return this.alConstruct.apply(this, args);
        };
        return AVM1ArrayFunction;
    }(AVM1Function));
    // Math natives
    var AVM1MathObject = /** @class */ (function (_super) {
        __extends(AVM1MathObject, _super);
        function AVM1MathObject(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                E: Math.E,
                LN10: Math.LN10,
                LN2: Math.LN2,
                LOG10E: Math.LOG10E,
                LOG2E: Math.LOG2E,
                PI: Math.PI,
                SQRT1_2: Math.SQRT1_2,
                SQRT2: Math.SQRT2,
                abs: _this.abs,
                acos: _this.acos,
                asin: _this.asin,
                atan: _this.atan,
                atan2: _this.atan2,
                ceil: _this.ceil,
                cos: _this.cos,
                exp: _this.exp,
                floor: _this.floor,
                log: _this.log,
                max: _this.max,
                min: _this.min,
                pow: _this.pow,
                random: _this.random,
                round: _this.round,
                sin: _this.sin,
                sqrt: _this.sqrt,
                tan: _this.tan
            });
            return _this;
        }
        AVM1MathObject.prototype.abs = function (x) {
            return Math.abs(alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.acos = function (x) {
            return Math.acos(alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.asin = function (x) {
            return Math.asin(alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.atan = function (x) {
            return Math.atan(alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.atan2 = function (y, x) {
            return Math.atan2(alToNumber(this.context, y), alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.ceil = function (x) {
            return Math.ceil(alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.cos = function (x) {
            return Math.cos(alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.exp = function (x) {
            return Math.exp(alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.floor = function (x) {
            return Math.floor(alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.log = function (x) {
            return Math.log(alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.max = function () {
            var _this = this;
            var values = [];
            for (var _a = 0; _a < arguments.length; _a++) {
                values[_a] = arguments[_a];
            }
            values = values.map(function (x) { return alToNumber(_this.context, x); });
            return Math.max.apply(null, values);
        };
        AVM1MathObject.prototype.min = function () {
            var _this = this;
            var values = [];
            for (var _a = 0; _a < arguments.length; _a++) {
                values[_a] = arguments[_a];
            }
            values = values.map(function (x) { return alToNumber(_this.context, x); });
            return Math.min.apply(null, values);
        };
        AVM1MathObject.prototype.pow = function (x, y) {
            return Math.pow(alToNumber(this.context, x), alToNumber(this.context, y));
        };
        AVM1MathObject.prototype.random = function () {
            if (AVM1Globals.randomProvider) {
                return AVM1Globals.randomProvider.random();
            }
            return Math.random();
        };
        AVM1MathObject.prototype.round = function (x) {
            return Math.round(alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.sin = function (x) {
            return Math.sin(alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.sqrt = function (x) {
            return Math.sqrt(alToNumber(this.context, x));
        };
        AVM1MathObject.prototype.tan = function (x) {
            return Math.tan(alToNumber(this.context, x));
        };
        return AVM1MathObject;
    }(AVM1Object));
    // Date natives
    var AVM1DateNative = /** @class */ (function (_super) {
        __extends(AVM1DateNative, _super);
        function AVM1DateNative(context, value) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Date.alGetPrototypeProperty();
            _this.alSetOwnConstructorProperty(context.builtins.Date);
            _this.value = value;
            return _this;
        }
        AVM1DateNative.prototype.alDefaultValue = function (hint) {
            if (hint !== undefined) {
                return _super.prototype.alDefaultValue.call(this, hint);
            }
            if (this.context.swfVersion >= 6) {
                return _super.prototype.alDefaultValue.call(this, 1 /* STRING */);
            }
            else {
                return _super.prototype.alDefaultValue.call(this, 0 /* NUMBER */);
            }
        };
        return AVM1DateNative;
    }(AVM1Object));
    // TODO implement all the Date class and its prototype natives
    var AVM1DatePrototype = /** @class */ (function (_super) {
        __extends(AVM1DatePrototype, _super);
        function AVM1DatePrototype(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                constructor: {
                    value: context.builtins.Date,
                    writable: true
                },
                valueOf: {
                    value: _this._valueOf,
                    writable: true
                },
                toString: {
                    value: _this._toString,
                    writable: true
                },
                toLocaleString: {
                    value: _this._toLocaleString,
                    writable: true
                },
                toDateString: {
                    value: _this.toDateString,
                    writable: true
                },
                toTimeString: {
                    value: _this.toTimeString,
                    writable: true
                },
                toLocaleDateString: {
                    value: _this.toLocaleDateString,
                    writable: true
                },
                toLocaleTimeString: {
                    value: _this.toLocaleTimeString,
                    writable: true
                },
                getTime: {
                    value: _this.getTime,
                    writable: true
                },
                getFullYear: {
                    value: _this.getFullYear,
                    writable: true
                },
                getUTCFullYear: {
                    value: _this.getUTCFullYear,
                    writable: true
                },
                getMonth: {
                    value: _this.getMonth,
                    writable: true
                },
                getUTCMonth: {
                    value: _this.getUTCMonth,
                    writable: true
                },
                getDate: {
                    value: _this.getDate,
                    writable: true
                },
                getUTCDate: {
                    value: _this.getUTCDate,
                    writable: true
                },
                getDay: {
                    value: _this.getDay,
                    writable: true
                },
                getUTCDay: {
                    value: _this.getUTCDay,
                    writable: true
                },
                getHours: {
                    value: _this.getHours,
                    writable: true
                },
                getUTCHours: {
                    value: _this.getUTCHours,
                    writable: true
                },
                getMinutes: {
                    value: _this.getMinutes,
                    writable: true
                },
                getUTCMinutes: {
                    value: _this.getUTCMinutes,
                    writable: true
                },
                getSeconds: {
                    value: _this.getSeconds,
                    writable: true
                },
                getUTCSeconds: {
                    value: _this.getUTCSeconds,
                    writable: true
                },
                getMilliseconds: {
                    value: _this.getMilliseconds,
                    writable: true
                },
                getUTCMilliseconds: {
                    value: _this.getUTCMilliseconds,
                    writable: true
                },
                getTimezoneOffset: {
                    value: _this.getTimezoneOffset,
                    writable: true
                },
                setTime: {
                    value: _this.setTime,
                    writable: true
                },
                setMilliseconds: {
                    value: _this.setMilliseconds,
                    writable: true
                },
                setUTCMilliseconds: {
                    value: _this.setUTCMilliseconds,
                    writable: true
                },
                setSeconds: {
                    value: _this.setSeconds,
                    writable: true
                },
                setUTCSeconds: {
                    value: _this.setUTCSeconds,
                    writable: true
                },
                setMinutes: {
                    value: _this.setMinutes,
                    writable: true
                },
                setUTCMinutes: {
                    value: _this.setUTCMinutes,
                    writable: true
                },
                setHours: {
                    value: _this.setHours,
                    writable: true
                },
                setUTCHours: {
                    value: _this.setUTCHours,
                    writable: true
                },
                setDate: {
                    value: _this.setDate,
                    writable: true
                },
                setUTCDate: {
                    value: _this.setUTCDate,
                    writable: true
                },
                setMonth: {
                    value: _this.setMonth,
                    writable: true
                },
                setUTCMonth: {
                    value: _this.setUTCMonth,
                    writable: true
                },
                setFullYear: {
                    value: _this.setFullYear,
                    writable: true
                },
                setUTCFullYear: {
                    value: _this.setUTCFullYear,
                    writable: true
                },
                toUTCString: {
                    value: _this.toUTCString,
                    writable: true
                }
            });
            return _this;
        }
        AVM1DatePrototype.prototype._valueOf = function () {
            var native = alEnsureType(this, AVM1DateNative);
            return native.value.valueOf();
        };
        AVM1DatePrototype.prototype._toString = function () {
            var native = alEnsureType(this, AVM1DateNative);
            return native.value.toString();
        };
        AVM1DatePrototype.prototype._toLocaleString = function () {
            var native = alEnsureType(this, AVM1DateNative);
            return native.value.toLocaleString();
        };
        AVM1DatePrototype.prototype.toDateString = function () {
            return alEnsureType(this, AVM1DateNative).value.toDateString();
        };
        AVM1DatePrototype.prototype.toTimeString = function () {
            return alEnsureType(this, AVM1DateNative).value.toTimeString();
        };
        AVM1DatePrototype.prototype.toLocaleDateString = function () {
            return alEnsureType(this, AVM1DateNative).value.toLocaleDateString();
        };
        AVM1DatePrototype.prototype.toLocaleTimeString = function () {
            return alEnsureType(this, AVM1DateNative).value.toLocaleTimeString();
        };
        AVM1DatePrototype.prototype.getTime = function () {
            return alEnsureType(this, AVM1DateNative).value.getTime();
        };
        AVM1DatePrototype.prototype.getFullYear = function () {
            return alEnsureType(this, AVM1DateNative).value.getFullYear();
        };
        AVM1DatePrototype.prototype.getUTCFullYear = function () {
            return alEnsureType(this, AVM1DateNative).value.getUTCFullYear();
        };
        AVM1DatePrototype.prototype.getMonth = function () {
            return alEnsureType(this, AVM1DateNative).value.getMonth();
        };
        AVM1DatePrototype.prototype.getUTCMonth = function () {
            return alEnsureType(this, AVM1DateNative).value.getUTCMonth();
        };
        AVM1DatePrototype.prototype.getDate = function () {
            return alEnsureType(this, AVM1DateNative).value.getDate();
        };
        AVM1DatePrototype.prototype.getUTCDate = function () {
            return alEnsureType(this, AVM1DateNative).value.getUTCDate();
        };
        AVM1DatePrototype.prototype.getDay = function () {
            return alEnsureType(this, AVM1DateNative).value.getDay();
        };
        AVM1DatePrototype.prototype.getUTCDay = function () {
            return alEnsureType(this, AVM1DateNative).value.getUTCDay();
        };
        AVM1DatePrototype.prototype.getHours = function () {
            return alEnsureType(this, AVM1DateNative).value.getHours();
        };
        AVM1DatePrototype.prototype.getUTCHours = function () {
            return alEnsureType(this, AVM1DateNative).value.getUTCHours();
        };
        AVM1DatePrototype.prototype.getMinutes = function () {
            return alEnsureType(this, AVM1DateNative).value.getMinutes();
        };
        AVM1DatePrototype.prototype.getUTCMinutes = function () {
            return alEnsureType(this, AVM1DateNative).value.getUTCMinutes();
        };
        AVM1DatePrototype.prototype.getSeconds = function () {
            return alEnsureType(this, AVM1DateNative).value.getSeconds();
        };
        AVM1DatePrototype.prototype.getUTCSeconds = function () {
            return alEnsureType(this, AVM1DateNative).value.getUTCSeconds();
        };
        AVM1DatePrototype.prototype.getMilliseconds = function () {
            return alEnsureType(this, AVM1DateNative).value.getMilliseconds();
        };
        AVM1DatePrototype.prototype.getUTCMilliseconds = function () {
            return alEnsureType(this, AVM1DateNative).value.getUTCMilliseconds();
        };
        AVM1DatePrototype.prototype.getTimezoneOffset = function () {
            return alEnsureType(this, AVM1DateNative).value.getTimezoneOffset();
        };
        AVM1DatePrototype.prototype.setTime = function (time) {
            time = alToNumber(this.context, time);
            return alEnsureType(this, AVM1DateNative).value.setTime(time);
        };
        AVM1DatePrototype.prototype.setMilliseconds = function (ms) {
            ms = alToNumber(this.context, ms);
            return alEnsureType(this, AVM1DateNative).value.setMilliseconds(ms);
        };
        AVM1DatePrototype.prototype.setUTCMilliseconds = function (ms) {
            ms = alToNumber(this.context, ms);
            return alEnsureType(this, AVM1DateNative).value.setUTCMilliseconds(ms);
        };
        AVM1DatePrototype.prototype.setSeconds = function (sec, ms) {
            sec = alToNumber(this.context, sec);
            if (arguments.length <= 1) {
                return alEnsureType(this, AVM1DateNative).value.setSeconds(sec);
            }
            else {
                ms = alToNumber(this.context, ms);
                return alEnsureType(this, AVM1DateNative).value.setSeconds(sec, ms);
            }
        };
        AVM1DatePrototype.prototype.setUTCSeconds = function (sec, ms) {
            sec = alToNumber(this.context, sec);
            if (arguments.length <= 1) {
                return alEnsureType(this, AVM1DateNative).value.setUTCSeconds(sec);
            }
            else {
                ms = alToNumber(this.context, ms);
                return alEnsureType(this, AVM1DateNative).value.setUTCSeconds(sec, ms);
            }
        };
        AVM1DatePrototype.prototype.setMinutes = function (min, sec, ms) {
            min = alToNumber(this.context, min);
            if (arguments.length <= 1) {
                return alEnsureType(this, AVM1DateNative).value.setMinutes(min);
            }
            else {
                sec = alToNumber(this.context, sec);
                if (arguments.length <= 2) {
                    return alEnsureType(this, AVM1DateNative).value.setMinutes(min, sec);
                }
                else {
                    ms = alToNumber(this.context, ms);
                    return alEnsureType(this, AVM1DateNative).value.setMinutes(min, sec, ms);
                }
            }
        };
        AVM1DatePrototype.prototype.setUTCMinutes = function (min, sec, ms) {
            min = alToNumber(this.context, min);
            if (arguments.length <= 1) {
                return alEnsureType(this, AVM1DateNative).value.setUTCMinutes(min);
            }
            else {
                sec = alToNumber(this.context, sec);
                if (arguments.length <= 2) {
                    return alEnsureType(this, AVM1DateNative).value.setUTCMinutes(min, sec);
                }
                else {
                    ms = alToNumber(this.context, ms);
                    return alEnsureType(this, AVM1DateNative).value.setUTCMinutes(min, sec, ms);
                }
            }
        };
        AVM1DatePrototype.prototype.setHours = function (hour, min, sec, ms) {
            hour = alToNumber(this.context, hour);
            if (arguments.length <= 1) {
                return alEnsureType(this, AVM1DateNative).value.setHours(hour);
            }
            else {
                min = alToNumber(this.context, min);
                if (arguments.length <= 2) {
                    return alEnsureType(this, AVM1DateNative).value.setHours(hour, min);
                }
                else {
                    sec = alToNumber(this.context, sec);
                    if (arguments.length <= 3) {
                        return alEnsureType(this, AVM1DateNative).value.setHours(hour, min, sec);
                    }
                    else {
                        ms = alToNumber(this.context, ms);
                        return alEnsureType(this, AVM1DateNative).value.setHours(hour, min, sec, ms);
                    }
                }
            }
        };
        AVM1DatePrototype.prototype.setUTCHours = function (hour, min, sec, ms) {
            hour = alToNumber(this.context, hour);
            if (arguments.length <= 1) {
                return alEnsureType(this, AVM1DateNative).value.setUTCHours(hour);
            }
            else {
                min = alToNumber(this.context, min);
                if (arguments.length <= 2) {
                    return alEnsureType(this, AVM1DateNative).value.setUTCHours(hour, min);
                }
                else {
                    sec = alToNumber(this.context, sec);
                    if (arguments.length <= 3) {
                        return alEnsureType(this, AVM1DateNative).value.setUTCHours(hour, min, sec);
                    }
                    else {
                        ms = alToNumber(this.context, ms);
                        return alEnsureType(this, AVM1DateNative).value.setUTCHours(hour, min, sec, ms);
                    }
                }
            }
        };
        AVM1DatePrototype.prototype.setDate = function (date) {
            date = alToNumber(this.context, date);
            return alEnsureType(this, AVM1DateNative).value.setDate(date);
        };
        AVM1DatePrototype.prototype.setUTCDate = function (date) {
            date = alToNumber(this.context, date);
            return alEnsureType(this, AVM1DateNative).value.setUTCDate(date);
        };
        AVM1DatePrototype.prototype.setMonth = function (month, date) {
            month = alToNumber(this.context, month);
            if (arguments.length <= 1) {
                return alEnsureType(this, AVM1DateNative).value.setMonth(month);
            }
            else {
                date = alToNumber(this.context, date);
                return alEnsureType(this, AVM1DateNative).value.setMonth(month, date);
            }
        };
        AVM1DatePrototype.prototype.setUTCMonth = function (month, date) {
            month = alToNumber(this.context, month);
            if (arguments.length <= 1) {
                return alEnsureType(this, AVM1DateNative).value.setUTCMonth(month);
            }
            else {
                date = alToNumber(this.context, date);
                return alEnsureType(this, AVM1DateNative).value.setUTCMonth(month, date);
            }
        };
        AVM1DatePrototype.prototype.setFullYear = function (year, month, date) {
            year = alToNumber(this.context, year);
            if (arguments.length <= 1) {
                return alEnsureType(this, AVM1DateNative).value.setFullYear(year);
            }
            else {
                month = alToNumber(this.context, month);
                if (arguments.length <= 2) {
                    return alEnsureType(this, AVM1DateNative).value.setFullYear(year, month);
                }
                else {
                    date = alToNumber(this.context, date);
                    return alEnsureType(this, AVM1DateNative).value.setFullYear(year, month, date);
                }
            }
        };
        AVM1DatePrototype.prototype.setUTCFullYear = function (year, month, date) {
            year = alToNumber(this.context, year);
            if (arguments.length <= 1) {
                return alEnsureType(this, AVM1DateNative).value.setUTCFullYear(year);
            }
            else {
                month = alToNumber(this.context, month);
                if (arguments.length <= 2) {
                    return alEnsureType(this, AVM1DateNative).value.setUTCFullYear(year, month);
                }
                else {
                    date = alToNumber(this.context, date);
                    return alEnsureType(this, AVM1DateNative).value.setUTCFullYear(year, month, date);
                }
            }
        };
        AVM1DatePrototype.prototype.toUTCString = function () {
            return alEnsureType(this, AVM1DateNative).value.toUTCString();
        };
        return AVM1DatePrototype;
    }(AVM1Object));
    var AVM1DateFunction = /** @class */ (function (_super) {
        __extends(AVM1DateFunction, _super);
        function AVM1DateFunction(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Function.alGetPrototypeProperty();
            var proto = new AVM1DatePrototype(context);
            alDefineObjectProperties(_this, {
                prototype: {
                    value: proto
                },
                UTC: {
                    value: _this._UTC,
                    writable: true
                }
            });
            return _this;
        }
        AVM1DateFunction.prototype.alConstruct = function (args) {
            var context = this.context;
            var value;
            switch (args.length) {
                case 0:
                    value = new Date();
                    break;
                case 1:
                    value = new Date(alToPrimitive(context, args[0]));
                    break;
                default: // case 2-7
                    var numbers = [];
                    for (var i = 0; i < args.length; i++) {
                        numbers.push(alToNumber(context, args[i]));
                    }
                    value = new Date(alToNumber(context, args[0]), alToNumber(context, args[1]), args.length > 2 ? alToNumber(context, args[2]) : 1, args.length > 3 ? alToNumber(context, args[3]) : 0, args.length > 4 ? alToNumber(context, args[4]) : 0, args.length > 5 ? alToNumber(context, args[5]) : 0, args.length > 6 ? alToNumber(context, args[6]) : 0);
                    break;
            }
            return new AVM1DateNative(context, value);
        };
        AVM1DateFunction.prototype.alCall = function (thisArg, args) {
            return alCallProperty(this.alConstruct.apply(this, args), 'toString');
        };
        AVM1DateFunction.prototype._UTC = function (year, month, date, hours, seconds, ms) {
            var context = this.context;
            return Date.UTC(alToNumber(context, arguments[0]), alToNumber(context, arguments[1]), arguments.length > 2 ? alToNumber(context, arguments[2]) : 1, arguments.length > 3 ? alToNumber(context, arguments[3]) : 0, arguments.length > 4 ? alToNumber(context, arguments[4]) : 0, arguments.length > 5 ? alToNumber(context, arguments[5]) : 0, arguments.length > 6 ? alToNumber(context, arguments[6]) : 0);
        };
        return AVM1DateFunction;
    }(AVM1Function));
    // Error natives
    var AVM1ErrorNative = /** @class */ (function (_super) {
        __extends(AVM1ErrorNative, _super);
        function AVM1ErrorNative(context, message) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Error.alGetPrototypeProperty();
            _this.alSetOwnConstructorProperty(context.builtins.Error);
            if (message !== undefined) {
                _this.alPut('message', message);
            }
            return _this;
        }
        return AVM1ErrorNative;
    }(AVM1Object));
    var AVM1ErrorPrototype = /** @class */ (function (_super) {
        __extends(AVM1ErrorPrototype, _super);
        function AVM1ErrorPrototype(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            alDefineObjectProperties(_this, {
                constructor: {
                    value: context.builtins.Error,
                    writable: true
                },
                name: {
                    value: 'Error',
                    writable: true
                },
                message: {
                    value: 'Error',
                    writable: true,
                },
                toString: {
                    value: _this._toString,
                    writable: true
                }
            });
            return _this;
        }
        AVM1ErrorPrototype.prototype._toString = function () {
            return this.alGet('message');
        };
        return AVM1ErrorPrototype;
    }(AVM1Object));
    var AVM1ErrorFunction = /** @class */ (function (_super) {
        __extends(AVM1ErrorFunction, _super);
        function AVM1ErrorFunction(context) {
            var _this = _super.call(this, context) || this;
            _this.alPrototype = context.builtins.Function.alGetPrototypeProperty();
            var proto = new AVM1ErrorPrototype(context);
            alDefineObjectProperties(_this, {
                prototype: {
                    value: proto
                }
            });
            return _this;
        }
        AVM1ErrorFunction.prototype.alConstruct = function (args) {
            var value = args && args[0] !== undefined ? alCoerceString(this.context, args[0]) : undefined;
            return new AVM1ErrorNative(this.context, value);
        };
        AVM1ErrorFunction.prototype.alCall = function (thisArg, args) {
            var value = args && args[0] !== undefined ? alCoerceString(this.context, args[0]) : undefined;
            return new AVM1ErrorNative(this.context, value);
        };
        return AVM1ErrorFunction;
    }(AVM1Function));
    function alEnsureType(obj, cls /* typeof AVM1Object */) {
        if (obj instanceof cls) {
            return obj;
        }
        throw new Error('Invalid type');
    }
    /**
     * Installs built-ins on the AVM1Context. It shall be a first call before
     * any AVM1Object is instantiated.
     * @param {IAVM1Context} context
     */
    function installBuiltins(context) {
        var builtins = context.builtins;
        // Resolving cyclic dependency between Object/Function functions and their prototypes.
        var objectProto = new AVM1ObjectPrototype(context);
        var dummyObject = new AVM1Object(context);
        dummyObject.alSetOwnPrototypeProperty(objectProto);
        builtins.Object = dummyObject;
        var functionProto = new AVM1FunctionPrototype(context);
        var dummyFunction = new AVM1Object(context);
        dummyFunction.alSetOwnPrototypeProperty(functionProto);
        builtins.Function = dummyFunction;
        objectProto._initializePrototype();
        functionProto._initializePrototype();
        builtins.Object = new AVM1ObjectFunction(context);
        builtins.Function = new AVM1FunctionFunction(context);
        builtins.Boolean = new AVM1BooleanFunction(context);
        builtins.Number = new AVM1NumberFunction(context);
        builtins.String = new AVM1StringFunction(context);
        builtins.Array = new AVM1ArrayFunction(context);
        builtins.Date = new AVM1DateFunction(context);
        builtins.Math = new AVM1MathObject(context);
        builtins.Error = new AVM1ErrorFunction(context);
    }

    /*
     *  big.js v5.1.2
     *  A small, fast, easy-to-use library for arbitrary-precision decimal arithmetic.
     *  Copyright (c) 2017 Michael Mclaughlin <M8ch88l@gmail.com>
     *  https://github.com/MikeMcl/big.js/LICENCE
     */


    /************************************** EDITABLE DEFAULTS *****************************************/


      // The default values below must be integers within the stated ranges.

      /*
       * The maximum number of decimal places (DP) of the results of operations involving division:
       * div and sqrt, and pow with negative exponents.
       */
    var DP = 20,          // 0 to MAX_DP

      /*
       * The rounding mode (RM) used when rounding to the above decimal places.
       *
       *  0  Towards zero (i.e. truncate, no rounding).       (ROUND_DOWN)
       *  1  To nearest neighbour. If equidistant, round up.  (ROUND_HALF_UP)
       *  2  To nearest neighbour. If equidistant, to even.   (ROUND_HALF_EVEN)
       *  3  Away from zero.                                  (ROUND_UP)
       */
      RM = 1,             // 0, 1, 2 or 3

      // The maximum value of DP and Big.DP.
      MAX_DP = 1E6,       // 0 to 1000000

      // The maximum magnitude of the exponent argument to the pow method.
      MAX_POWER = 1E6,    // 1 to 1000000

      /*
       * The negative exponent (NE) at and beneath which toString returns exponential notation.
       * (JavaScript numbers: -7)
       * -1000000 is the minimum recommended exponent value of a Big.
       */
      NE = -7,            // 0 to -1000000

      /*
       * The positive exponent (PE) at and above which toString returns exponential notation.
       * (JavaScript numbers: 21)
       * 1000000 is the maximum recommended exponent value of a Big.
       * (This limit is not enforced or checked.)
       */
      PE = 21,            // 0 to 1000000


    /**************************************************************************************************/


      // Error messages.
      NAME = '[big.js] ',
      INVALID = NAME + 'Invalid ',
      INVALID_DP = INVALID + 'decimal places',
      INVALID_RM = INVALID + 'rounding mode',
      DIV_BY_ZERO = NAME + 'Division by zero',

      // The shared prototype object.
      P = {},
      UNDEFINED = void 0,
      NUMERIC = /^-?(\d+(\.\d*)?|\.\d+)(e[+-]?\d+)?$/i;


    /*
     * Create and return a Big constructor.
     *
     */
    function _Big_() {

      /*
       * The Big constructor and exported function.
       * Create and return a new instance of a Big number object.
       *
       * n {number|string|Big} A numeric value.
       */
      function Big(n) {
        var x = this;

        // Enable constructor usage without new.
        if (!(x instanceof Big)) return n === UNDEFINED ? _Big_() : new Big(n);

        // Duplicate.
        if (n instanceof Big) {
          x.s = n.s;
          x.e = n.e;
          x.c = n.c.slice();
        } else {
          parse(x, n);
        }

        /*
         * Retain a reference to this Big constructor, and shadow Big.prototype.constructor which
         * points to Object.
         */
        x.constructor = Big;
      }

      Big.prototype = P;
      Big.DP = DP;
      Big.RM = RM;
      Big.NE = NE;
      Big.PE = PE;
      Big.version = '5.0.2';

      return Big;
    }


    /*
     * Parse the number or string value passed to a Big constructor.
     *
     * x {Big} A Big number instance.
     * n {number|string} A numeric value.
     */
    function parse(x, n) {
      var e, i, nl;

      // Minus zero?
      if (n === 0 && 1 / n < 0) n = '-0';
      else if (!NUMERIC.test(n += '')) throw Error(INVALID + 'number');

      // Determine sign.
      x.s = n.charAt(0) == '-' ? (n = n.slice(1), -1) : 1;

      // Decimal point?
      if ((e = n.indexOf('.')) > -1) n = n.replace('.', '');

      // Exponential form?
      if ((i = n.search(/e/i)) > 0) {

        // Determine exponent.
        if (e < 0) e = i;
        e += +n.slice(i + 1);
        n = n.substring(0, i);
      } else if (e < 0) {

        // Integer.
        e = n.length;
      }

      nl = n.length;

      // Determine leading zeros.
      for (i = 0; i < nl && n.charAt(i) == '0';) ++i;

      if (i == nl) {

        // Zero.
        x.c = [x.e = 0];
      } else {

        // Determine trailing zeros.
        for (; nl > 0 && n.charAt(--nl) == '0';);
        x.e = e - i - 1;
        x.c = [];

        // Convert string to array of digits without leading/trailing zeros.
        for (e = 0; i <= nl;) x.c[e++] = +n.charAt(i++);
      }

      return x;
    }


    /*
     * Round Big x to a maximum of dp decimal places using rounding mode rm.
     * Called by stringify, P.div, P.round and P.sqrt.
     *
     * x {Big} The Big to round.
     * dp {number} Integer, 0 to MAX_DP inclusive.
     * rm {number} 0, 1, 2 or 3 (DOWN, HALF_UP, HALF_EVEN, UP)
     * [more] {boolean} Whether the result of division was truncated.
     */
    function round(x, dp, rm, more) {
      var xc = x.c,
        i = x.e + dp + 1;

      if (i < xc.length) {
        if (rm === 1) {

          // xc[i] is the digit after the digit that may be rounded up.
          more = xc[i] >= 5;
        } else if (rm === 2) {
          more = xc[i] > 5 || xc[i] == 5 &&
            (more || i < 0 || xc[i + 1] !== UNDEFINED || xc[i - 1] & 1);
        } else if (rm === 3) {
          more = more || xc[i] !== UNDEFINED || i < 0;
        } else {
          more = false;
          if (rm !== 0) throw Error(INVALID_RM);
        }

        if (i < 1) {
          xc.length = 1;

          if (more) {

            // 1, 0.1, 0.01, 0.001, 0.0001 etc.
            x.e = -dp;
            xc[0] = 1;
          } else {

            // Zero.
            xc[0] = x.e = 0;
          }
        } else {

          // Remove any digits after the required decimal places.
          xc.length = i--;

          // Round up?
          if (more) {

            // Rounding up may mean the previous digit has to be rounded up.
            for (; ++xc[i] > 9;) {
              xc[i] = 0;
              if (!i--) {
                ++x.e;
                xc.unshift(1);
              }
            }
          }

          // Remove trailing zeros.
          for (i = xc.length; !xc[--i];) xc.pop();
        }
      } else if (rm < 0 || rm > 3 || rm !== ~~rm) {
        throw Error(INVALID_RM);
      }

      return x;
    }


    /*
     * Return a string representing the value of Big x in normal or exponential notation.
     * Handles P.toExponential, P.toFixed, P.toJSON, P.toPrecision, P.toString and P.valueOf.
     *
     * x {Big}
     * id? {number} Caller id.
     *         1 toExponential
     *         2 toFixed
     *         3 toPrecision
     *         4 valueOf
     * n? {number|undefined} Caller's argument.
     * k? {number|undefined}
     */
    function stringify(x, id, n, k) {
      var e, s,
        Big = x.constructor,
        z = !x.c[0];

      if (n !== UNDEFINED) {
        if (n !== ~~n || n < (id == 3) || n > MAX_DP) {
          throw Error(id == 3 ? INVALID + 'precision' : INVALID_DP);
        }

        x = new Big(x);

        // The index of the digit that may be rounded up.
        n = k - x.e;

        // Round?
        if (x.c.length > ++k) round(x, n, Big.RM);

        // toFixed: recalculate k as x.e may have changed if value rounded up.
        if (id == 2) k = x.e + n + 1;

        // Append zeros?
        for (; x.c.length < k;) x.c.push(0);
      }

      e = x.e;
      s = x.c.join('');
      n = s.length;

      // Exponential notation?
      if (id != 2 && (id == 1 || id == 3 && k <= e || e <= Big.NE || e >= Big.PE)) {
        s = s.charAt(0) + (n > 1 ? '.' + s.slice(1) : '') + (e < 0 ? 'e' : 'e+') + e;

      // Normal notation.
      } else if (e < 0) {
        for (; ++e;) s = '0' + s;
        s = '0.' + s;
      } else if (e > 0) {
        if (++e > n) for (e -= n; e--;) s += '0';
        else if (e < n) s = s.slice(0, e) + '.' + s.slice(e);
      } else if (n > 1) {
        s = s.charAt(0) + '.' + s.slice(1);
      }

      return x.s < 0 && (!z || id == 4) ? '-' + s : s;
    }


    // Prototype/instance methods


    /*
     * Return a new Big whose value is the absolute value of this Big.
     */
    P.abs = function () {
      var x = new this.constructor(this);
      x.s = 1;
      return x;
    };


    /*
     * Return 1 if the value of this Big is greater than the value of Big y,
     *       -1 if the value of this Big is less than the value of Big y, or
     *        0 if they have the same value.
    */
    P.cmp = function (y) {
      var isneg,
        x = this,
        xc = x.c,
        yc = (y = new x.constructor(y)).c,
        i = x.s,
        j = y.s,
        k = x.e,
        l = y.e;

      // Either zero?
      if (!xc[0] || !yc[0]) return !xc[0] ? !yc[0] ? 0 : -j : i;

      // Signs differ?
      if (i != j) return i;

      isneg = i < 0;

      // Compare exponents.
      if (k != l) return k > l ^ isneg ? 1 : -1;

      j = (k = xc.length) < (l = yc.length) ? k : l;

      // Compare digit by digit.
      for (i = -1; ++i < j;) {
        if (xc[i] != yc[i]) return xc[i] > yc[i] ^ isneg ? 1 : -1;
      }

      // Compare lengths.
      return k == l ? 0 : k > l ^ isneg ? 1 : -1;
    };


    /*
     * Return a new Big whose value is the value of this Big divided by the value of Big y, rounded,
     * if necessary, to a maximum of Big.DP decimal places using rounding mode Big.RM.
     */
    P.div = function (y) {
      var x = this,
        Big = x.constructor,
        a = x.c,                  // dividend
        b = (y = new Big(y)).c,   // divisor
        k = x.s == y.s ? 1 : -1,
        dp = Big.DP;

      if (dp !== ~~dp || dp < 0 || dp > MAX_DP) throw Error(INVALID_DP);

      // Divisor is zero?
      if (!b[0]) throw Error(DIV_BY_ZERO);

      // Dividend is 0? Return +-0.
      if (!a[0]) return new Big(k * 0);

      var bl, bt, n, cmp, ri,
        bz = b.slice(),
        ai = bl = b.length,
        al = a.length,
        r = a.slice(0, bl),   // remainder
        rl = r.length,
        q = y,                // quotient
        qc = q.c = [],
        qi = 0,
        d = dp + (q.e = x.e - y.e) + 1;    // number of digits of the result

      q.s = k;
      k = d < 0 ? 0 : d;

      // Create version of divisor with leading zero.
      bz.unshift(0);

      // Add zeros to make remainder as long as divisor.
      for (; rl++ < bl;) r.push(0);

      do {

        // n is how many times the divisor goes into current remainder.
        for (n = 0; n < 10; n++) {

          // Compare divisor and remainder.
          if (bl != (rl = r.length)) {
            cmp = bl > rl ? 1 : -1;
          } else {
            for (ri = -1, cmp = 0; ++ri < bl;) {
              if (b[ri] != r[ri]) {
                cmp = b[ri] > r[ri] ? 1 : -1;
                break;
              }
            }
          }

          // If divisor < remainder, subtract divisor from remainder.
          if (cmp < 0) {

            // Remainder can't be more than 1 digit longer than divisor.
            // Equalise lengths using divisor with extra leading zero?
            for (bt = rl == bl ? b : bz; rl;) {
              if (r[--rl] < bt[rl]) {
                ri = rl;
                for (; ri && !r[--ri];) r[ri] = 9;
                --r[ri];
                r[rl] += 10;
              }
              r[rl] -= bt[rl];
            }

            for (; !r[0];) r.shift();
          } else {
            break;
          }
        }

        // Add the digit n to the result array.
        qc[qi++] = cmp ? n : ++n;

        // Update the remainder.
        if (r[0] && cmp) r[rl] = a[ai] || 0;
        else r = [a[ai]];

      } while ((ai++ < al || r[0] !== UNDEFINED) && k--);

      // Leading zero? Do not remove if result is simply zero (qi == 1).
      if (!qc[0] && qi != 1) {

        // There can't be more than one zero.
        qc.shift();
        q.e--;
      }

      // Round?
      if (qi > d) round(q, dp, Big.RM, r[0] !== UNDEFINED);

      return q;
    };


    /*
     * Return true if the value of this Big is equal to the value of Big y, otherwise return false.
     */
    P.eq = function (y) {
      return !this.cmp(y);
    };


    /*
     * Return true if the value of this Big is greater than the value of Big y, otherwise return
     * false.
     */
    P.gt = function (y) {
      return this.cmp(y) > 0;
    };


    /*
     * Return true if the value of this Big is greater than or equal to the value of Big y, otherwise
     * return false.
     */
    P.gte = function (y) {
      return this.cmp(y) > -1;
    };


    /*
     * Return true if the value of this Big is less than the value of Big y, otherwise return false.
     */
    P.lt = function (y) {
      return this.cmp(y) < 0;
    };


    /*
     * Return true if the value of this Big is less than or equal to the value of Big y, otherwise
     * return false.
     */
    P.lte = function (y) {
      return this.cmp(y) < 1;
    };


    /*
     * Return a new Big whose value is the value of this Big minus the value of Big y.
     */
    P.minus = P.sub = function (y) {
      var i, j, t, xlty,
        x = this,
        Big = x.constructor,
        a = x.s,
        b = (y = new Big(y)).s;

      // Signs differ?
      if (a != b) {
        y.s = -b;
        return x.plus(y);
      }

      var xc = x.c.slice(),
        xe = x.e,
        yc = y.c,
        ye = y.e;

      // Either zero?
      if (!xc[0] || !yc[0]) {

        // y is non-zero? x is non-zero? Or both are zero.
        return yc[0] ? (y.s = -b, y) : new Big(xc[0] ? x : 0);
      }

      // Determine which is the bigger number. Prepend zeros to equalise exponents.
      if (a = xe - ye) {

        if (xlty = a < 0) {
          a = -a;
          t = xc;
        } else {
          ye = xe;
          t = yc;
        }

        t.reverse();
        for (b = a; b--;) t.push(0);
        t.reverse();
      } else {

        // Exponents equal. Check digit by digit.
        j = ((xlty = xc.length < yc.length) ? xc : yc).length;

        for (a = b = 0; b < j; b++) {
          if (xc[b] != yc[b]) {
            xlty = xc[b] < yc[b];
            break;
          }
        }
      }

      // x < y? Point xc to the array of the bigger number.
      if (xlty) {
        t = xc;
        xc = yc;
        yc = t;
        y.s = -y.s;
      }

      /*
       * Append zeros to xc if shorter. No need to add zeros to yc if shorter as subtraction only
       * needs to start at yc.length.
       */
      if ((b = (j = yc.length) - (i = xc.length)) > 0) for (; b--;) xc[i++] = 0;

      // Subtract yc from xc.
      for (b = i; j > a;) {
        if (xc[--j] < yc[j]) {
          for (i = j; i && !xc[--i];) xc[i] = 9;
          --xc[i];
          xc[j] += 10;
        }

        xc[j] -= yc[j];
      }

      // Remove trailing zeros.
      for (; xc[--b] === 0;) xc.pop();

      // Remove leading zeros and adjust exponent accordingly.
      for (; xc[0] === 0;) {
        xc.shift();
        --ye;
      }

      if (!xc[0]) {

        // n - n = +0
        y.s = 1;

        // Result must be zero.
        xc = [ye = 0];
      }

      y.c = xc;
      y.e = ye;

      return y;
    };


    /*
     * Return a new Big whose value is the value of this Big modulo the value of Big y.
     */
    P.mod = function (y) {
      var ygtx,
        x = this,
        Big = x.constructor,
        a = x.s,
        b = (y = new Big(y)).s;

      if (!y.c[0]) throw Error(DIV_BY_ZERO);

      x.s = y.s = 1;
      ygtx = y.cmp(x) == 1;
      x.s = a;
      y.s = b;

      if (ygtx) return new Big(x);

      a = Big.DP;
      b = Big.RM;
      Big.DP = Big.RM = 0;
      x = x.div(y);
      Big.DP = a;
      Big.RM = b;

      return this.minus(x.times(y));
    };


    /*
     * Return a new Big whose value is the value of this Big plus the value of Big y.
     */
    P.plus = P.add = function (y) {
      var t,
        x = this,
        Big = x.constructor,
        a = x.s,
        b = (y = new Big(y)).s;

      // Signs differ?
      if (a != b) {
        y.s = -b;
        return x.minus(y);
      }

      var xe = x.e,
        xc = x.c,
        ye = y.e,
        yc = y.c;

      // Either zero? y is non-zero? x is non-zero? Or both are zero.
      if (!xc[0] || !yc[0]) return yc[0] ? y : new Big(xc[0] ? x : a * 0);

      xc = xc.slice();

      // Prepend zeros to equalise exponents.
      // Note: Faster to use reverse then do unshifts.
      if (a = xe - ye) {
        if (a > 0) {
          ye = xe;
          t = yc;
        } else {
          a = -a;
          t = xc;
        }

        t.reverse();
        for (; a--;) t.push(0);
        t.reverse();
      }

      // Point xc to the longer array.
      if (xc.length - yc.length < 0) {
        t = yc;
        yc = xc;
        xc = t;
      }

      a = yc.length;

      // Only start adding at yc.length - 1 as the further digits of xc can be left as they are.
      for (b = 0; a; xc[a] %= 10) b = (xc[--a] = xc[a] + yc[a] + b) / 10 | 0;

      // No need to check for zero, as +x + +y != 0 && -x + -y != 0

      if (b) {
        xc.unshift(b);
        ++ye;
      }

      // Remove trailing zeros.
      for (a = xc.length; xc[--a] === 0;) xc.pop();

      y.c = xc;
      y.e = ye;

      return y;
    };


    /*
     * Return a Big whose value is the value of this Big raised to the power n.
     * If n is negative, round to a maximum of Big.DP decimal places using rounding
     * mode Big.RM.
     *
     * n {number} Integer, -MAX_POWER to MAX_POWER inclusive.
     */
    P.pow = function (n) {
      var x = this,
        one = new x.constructor(1),
        y = one,
        isneg = n < 0;

      if (n !== ~~n || n < -MAX_POWER || n > MAX_POWER) throw Error(INVALID + 'exponent');
      if (isneg) n = -n;

      for (;;) {
        if (n & 1) y = y.times(x);
        n >>= 1;
        if (!n) break;
        x = x.times(x);
      }

      return isneg ? one.div(y) : y;
    };


    /*
     * Return a new Big whose value is the value of this Big rounded to a maximum of dp decimal
     * places using rounding mode rm.
     * If dp is not specified, round to 0 decimal places.
     * If rm is not specified, use Big.RM.
     *
     * dp? {number} Integer, 0 to MAX_DP inclusive.
     * rm? 0, 1, 2 or 3 (ROUND_DOWN, ROUND_HALF_UP, ROUND_HALF_EVEN, ROUND_UP)
     */
    P.round = function (dp, rm) {
      var Big = this.constructor;
      if (dp === UNDEFINED) dp = 0;
      else if (dp !== ~~dp || dp < 0 || dp > MAX_DP) throw Error(INVALID_DP);
      return round(new Big(this), dp, rm === UNDEFINED ? Big.RM : rm);
    };


    /*
     * Return a new Big whose value is the square root of the value of this Big, rounded, if
     * necessary, to a maximum of Big.DP decimal places using rounding mode Big.RM.
     */
    P.sqrt = function () {
      var r, c, t,
        x = this,
        Big = x.constructor,
        s = x.s,
        e = x.e,
        half = new Big(0.5);

      // Zero?
      if (!x.c[0]) return new Big(x);

      // Negative?
      if (s < 0) throw Error(NAME + 'No square root');

      // Estimate.
      s = Math.sqrt(x.toString());

      // Math.sqrt underflow/overflow?
      // Re-estimate: pass x to Math.sqrt as integer, then adjust the result exponent.
      if (s === 0 || s === 1 / 0) {
        c = x.c.join('');
        if (!(c.length + e & 1)) c += '0';
        r = new Big(Math.sqrt(c).toString());
        r.e = ((e + 1) / 2 | 0) - (e < 0 || e & 1);
      } else {
        r = new Big(s.toString());
      }

      e = r.e + (Big.DP += 4);

      // Newton-Raphson iteration.
      do {
        t = r;
        r = half.times(t.plus(x.div(t)));
      } while (t.c.slice(0, e).join('') !== r.c.slice(0, e).join(''));

      return round(r, Big.DP -= 4, Big.RM);
    };


    /*
     * Return a new Big whose value is the value of this Big times the value of Big y.
     */
    P.times = P.mul = function (y) {
      var c,
        x = this,
        Big = x.constructor,
        xc = x.c,
        yc = (y = new Big(y)).c,
        a = xc.length,
        b = yc.length,
        i = x.e,
        j = y.e;

      // Determine sign of result.
      y.s = x.s == y.s ? 1 : -1;

      // Return signed 0 if either 0.
      if (!xc[0] || !yc[0]) return new Big(y.s * 0);

      // Initialise exponent of result as x.e + y.e.
      y.e = i + j;

      // If array xc has fewer digits than yc, swap xc and yc, and lengths.
      if (a < b) {
        c = xc;
        xc = yc;
        yc = c;
        j = a;
        a = b;
        b = j;
      }

      // Initialise coefficient array of result with zeros.
      for (c = new Array(j = a + b); j--;) c[j] = 0;

      // Multiply.

      // i is initially xc.length.
      for (i = b; i--;) {
        b = 0;

        // a is yc.length.
        for (j = a + i; j > i;) {

          // Current sum of products at this digit position, plus carry.
          b = c[j] + yc[i] * xc[j - i - 1] + b;
          c[j--] = b % 10;

          // carry
          b = b / 10 | 0;
        }

        c[j] = (c[j] + b) % 10;
      }

      // Increment result exponent if there is a final carry, otherwise remove leading zero.
      if (b) ++y.e;
      else c.shift();

      // Remove trailing zeros.
      for (i = c.length; !c[--i];) c.pop();
      y.c = c;

      return y;
    };


    /*
     * Return a string representing the value of this Big in exponential notation to dp fixed decimal
     * places and rounded using Big.RM.
     *
     * dp? {number} Integer, 0 to MAX_DP inclusive.
     */
    P.toExponential = function (dp) {
      return stringify(this, 1, dp, dp);
    };


    /*
     * Return a string representing the value of this Big in normal notation to dp fixed decimal
     * places and rounded using Big.RM.
     *
     * dp? {number} Integer, 0 to MAX_DP inclusive.
     *
     * (-0).toFixed(0) is '0', but (-0.1).toFixed(0) is '-0'.
     * (-0).toFixed(1) is '0.0', but (-0.01).toFixed(1) is '-0.0'.
     */
    P.toFixed = function (dp) {
      return stringify(this, 2, dp, this.e + dp);
    };


    /*
     * Return a string representing the value of this Big rounded to sd significant digits using
     * Big.RM. Use exponential notation if sd is less than the number of digits necessary to represent
     * the integer part of the value in normal notation.
     *
     * sd {number} Integer, 1 to MAX_DP inclusive.
     */
    P.toPrecision = function (sd) {
      return stringify(this, 3, sd, sd - 1);
    };


    /*
     * Return a string representing the value of this Big.
     * Return exponential notation if this Big has a positive exponent equal to or greater than
     * Big.PE, or a negative exponent equal to or less than Big.NE.
     * Omit the sign for negative zero.
     */
    P.toString = function () {
      return stringify(this);
    };


    /*
     * Return a string representing the value of this Big.
     * Return exponential notation if this Big has a positive exponent equal to or greater than
     * Big.PE, or a negative exponent equal to or less than Big.NE.
     * Include the sign for negative zero.
     */
    P.valueOf = P.toJSON = function () {
      return stringify(this, 4);
    };


    // Export


    var Big = _Big_();

    /*
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    /**
     * Base class for ActionScript functions with native JavaScript implementation.
     */
    var AVM1NativeFunction = /** @class */ (function (_super) {
        __extends(AVM1NativeFunction, _super);
        /**
         * @param {IAVM1Context} context
         * @param {Function} fn The native function for regular calling.
         * @param {Function} ctor The native function for construction.
         */
        function AVM1NativeFunction(context, fn, ctor) {
            var _this = _super.call(this, context) || this;
            _this._fn = fn;
            if (ctor) {
                _this._ctor = ctor;
            }
            return _this;
        }
        AVM1NativeFunction.prototype.alConstruct = function (args) {
            if (!this._ctor) {
                throw new Error('not a constructor');
            }
            return this._ctor.apply(this, args);
        };
        AVM1NativeFunction.prototype.alCall = function (thisArg, args) {
            if (!this._fn) {
                throw new Error('not callable');
            }
            return this._fn.apply(thisArg, args);
        };
        return AVM1NativeFunction;
    }(AVM1Function));
    /**
     * Base class the is used for the interpreter.
     * See {AVM1InterpretedFunction} implementation
     */
    var AVM1EvalFunction = /** @class */ (function (_super) {
        __extends(AVM1EvalFunction, _super);
        function AVM1EvalFunction(context) {
            var _this = _super.call(this, context) || this;
            var proto = new AVM1Object(context);
            proto.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            proto.alSetOwnProperty('constructor', new AVM1PropertyDescriptor(64 /* DATA */ |
                1 /* DONT_ENUM */ |
                2 /* DONT_DELETE */));
            _this.alSetOwnPrototypeProperty(proto);
            return _this;
        }
        AVM1EvalFunction.prototype.alConstruct = function (args) {
            var obj = new AVM1Object(this.context);
            var objPrototype = this.alGetPrototypeProperty();
            if (!(objPrototype instanceof AVM1Object)) {
                objPrototype = this.context.builtins.Object.alGetPrototypeProperty();
            }
            obj.alPrototype = objPrototype;
            obj.alSetOwnConstructorProperty(this);
            var result = this.alCall(obj, args);
            return result instanceof AVM1Object ? result : obj;
        };
        return AVM1EvalFunction;
    }(AVM1Function));
    // TODO create classes for the ActionScript errors.
    function AVM1TypeError(msg) {
    }
    AVM1TypeError.prototype = Object.create(Error.prototype);
    function alToPrimitive(context, v, preferredType) {
        if (!(v instanceof AVM1Object)) {
            return v;
        }
        var obj = v;
        return preferredType !== undefined ? obj.alDefaultValue(preferredType) : obj.alDefaultValue();
    }
    function alToBoolean(context, v) {
        switch (typeof v) {
            case 'undefined':
                return false;
            case 'object':
                return v !== null;
            case 'boolean':
                return v;
            case 'string':
            case 'number':
                return !!v;
            default:
                release$1 || Debug$1.assert(false);
        }
    }
    function alToNumber(context, v) {
        if (typeof v === 'object' && v !== null) {
            v = alToPrimitive(context, v, 0 /* NUMBER */);
        }
        switch (typeof v) {
            case 'undefined':
                return context.swfVersion >= 7 ? NaN : 0;
            case 'object':
                if (v === null) {
                    return context.swfVersion >= 7 ? NaN : 0;
                }
                return context.swfVersion >= 5 ? NaN : 0;
            case 'boolean':
                return v ? 1 : 0;
            case 'number':
                return v;
            case 'string':
                if (v === '' && context.swfVersion < 5) {
                    return 0;
                }
                if (v === "") {
                    return NaN;
                }
                return +v;
            default:
                release$1 || Debug$1.assert(false);
        }
    }
    function alToInteger(context, v) {
        var n = alToNumber(context, v);
        if (isNaN(n)) {
            return 0;
        }
        if (n === 0 || n === Number.POSITIVE_INFINITY || n === Number.NEGATIVE_INFINITY) {
            return n;
        }
        return n < 0 ? Math.ceil(n) : Math.floor(n);
    }
    function alToInt32(context, v) {
        var n = alToNumber(context, v);
        return n | 0;
    }
    function alToString(context, v) {
        if (typeof v === 'object' && v !== null) {
            v = alToPrimitive(context, v, 1 /* STRING */);
        }
        switch (typeof v) {
            case 'undefined':
                return context.swfVersion >= 7 ? 'undefined' : '';
            case 'object':
                if (v === null) {
                    return 'null';
                }
                if (v && v instanceof Array) {
                    var outputStr = "";
                    for (var i = 0; i < v.length; i++) {
                        outputStr += alToString(context, v[i]);
                        outputStr += i == v.length - 1 ? "" : ",";
                    }
                    return outputStr;
                }
                return '[type ' + alGetObjectClass(v) + ']';
            case 'boolean':
                return v ? 'true' : 'false';
            case 'number':
                if (!isNaN(v)) {
                    var bigv = Big(v);
                    if (Math.abs(bigv.e) < 14)
                        bigv = bigv.round(14 - bigv.e, 1);
                    return bigv.toString();
                }
                return v.toString();
            case 'string':
                return v;
            default:
                release$1 || Debug$1.assert(false);
        }
    }
    function alIsName(context, v) {
        return typeof v === 'number' ||
            typeof v === 'string' &&
                (!context.isPropertyCaseSensitive || v === v.toLowerCase());
    }
    function alToObject(context, v) {
        switch (typeof v) {
            case 'undefined':
                throw new AVM1TypeError();
            case 'object':
                if (v === null) {
                    throw new AVM1TypeError();
                }
                // TODO verify if all objects here are inherited from AVM1Object
                if (Array.isArray(v)) {
                    return new AVM1ArrayNative(context, v);
                }
                return v;
            case 'boolean':
                return new AVM1BooleanNative(context, v);
            case 'number':
                return new AVM1NumberNative(context, v);
            case 'string':
                return new AVM1StringNative(context, v);
            default:
                release$1 || Debug$1.assert(false);
        }
    }
    function alNewObject(context) {
        var obj = new AVM1Object(context);
        obj.alPrototype = context.builtins.Object.alGetPrototypeProperty();
        obj.alSetOwnConstructorProperty(context.builtins.Object);
        return obj;
    }
    function alGetObjectClass(obj) {
        if (obj instanceof AVM1Function) {
            return 'Function';
        }
        // TODO more cases
        return 'Object';
    }
    /**
     * Non-standard string coercion function roughly matching the behavior of AVM2's axCoerceString.
     *
     * This is useful when dealing with AVM2 objects in the implementation of AVM1 builtins: they
     * frequently expect either a string or `null`, but not `undefined`.
     */
    function alCoerceString(context, x) {
        if (x instanceof AVM1Object) {
            return alToString(context, x);
        }
        return axCoerceString$2(x);
    }
    function alCoerceNumber(context, x) {
        if (isNullOrUndefined$1(x)) {
            return undefined;
        }
        return alToNumber(context, x);
    }
    function alIsIndex(context, p) {
        if (p instanceof AVM1Object) {
            return isIndex(alToString(context, p));
        }
        return isIndex(p);
    }
    function alForEachProperty(obj, fn, thisArg) {
        obj.alGetKeys().forEach(fn, thisArg);
    }
    function alIsFunction(obj) {
        return obj instanceof AVM1Function;
    }
    function alCallProperty(obj, p, args) {
        var callable = obj.alGet(p);
        callable.alCall(obj, args);
    }
    function alInstanceOf(context, obj, cls) {
        if (!(obj instanceof AVM1Object)) {
            return false;
        }
        if (!(cls instanceof AVM1Object)) {
            return false;
        }
        var proto = cls.alGetPrototypeProperty();
        for (var i = obj; i; i = i.alPrototype) {
            if (i === proto) {
                return true;
            }
        }
        return false;
    }
    function alIsArray(context, v) {
        return alInstanceOf(context, v, context.builtins.Array);
    }
    function alIsArrayLike(context, v) {
        if (!(v instanceof AVM1Object)) {
            return false;
        }
        var length = alToInteger(context, v.alGet('length'));
        if (isNaN(length) || length < 0 || length >= 4294967296) {
            return false;
        }
        return true;
    }
    function alIterateArray(context, arr, fn, thisArg) {
        if (thisArg === void 0) { thisArg = null; }
        var length = alToInteger(context, arr.alGet('length'));
        if (isNaN(length) || length >= 4294967296) {
            return;
        }
        for (var i = 0; i < length; i++) {
            fn.call(thisArg, arr.alGet(i), i);
        }
    }
    function alIsString(context, v) {
        return typeof v === 'string';
    }
    function alDefineObjectProperties(obj, descriptors) {
        var context = obj.context;
        Object.getOwnPropertyNames(descriptors).forEach(function (name) {
            var desc = descriptors[name];
            var value, getter, setter;
            var flags = 0;
            if (typeof desc === 'object') {
                if (desc.get || desc.set) {
                    getter = desc.get ? new AVM1NativeFunction(context, desc.get) : undefined;
                    setter = desc.set ? new AVM1NativeFunction(context, desc.set) : undefined;
                    flags |= 128 /* ACCESSOR */;
                }
                else {
                    value = desc.value;
                    if (typeof value === 'function') {
                        value = new AVM1NativeFunction(context, value);
                    }
                    flags |= 64 /* DATA */;
                    if (!desc.writable) {
                        flags |= 4 /* READ_ONLY */;
                    }
                }
                if (!desc.enumerable) {
                    flags |= 1 /* DONT_ENUM */;
                }
                if (!desc.configurable) {
                    flags |= 2 /* DONT_DELETE */;
                }
            }
            else {
                value = desc;
                if (typeof value === 'function') {
                    value = new AVM1NativeFunction(context, value);
                }
                flags |= 64 /* DATA */ | 2 /* DONT_DELETE */ |
                    1 /* DONT_ENUM */ | 4 /* READ_ONLY */;
            }
            obj.alSetOwnProperty(name, new AVM1PropertyDescriptor(flags, value, getter, setter));
        });
    }

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AVM1TextField = /** @class */ (function (_super) {
        __extends(AVM1TextField, _super);
        function AVM1TextField() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._prevTextVarContent = "";
            _this._textVarHolder = null;
            _this._textVarPropName = "";
            return _this;
        }
        AVM1TextField.createAVM1Class = function (context) {
            return wrapAVM1NativeClass(context, true, AVM1TextField, [], ['_alpha#', 'addListener', 'antiAliasType#', 'autoSize#', 'background#', 'backgroundColor#',
                'border#', 'borderColor#', 'bottomScroll#', 'condenseWhite#', 'embedFonts#',
                'filters#', 'getAwayJSID', 'getNewTextFormat', 'getTextFormat', 'gridFitType#', 'getDepth',
                '_height#', '_highquality#', 'hscroll#', 'html#', 'htmlText#', 'length#',
                'maxChars#', 'maxhscroll#', 'maxscroll#', 'multiline#',
                '_name#', '_parent#', 'password#', '_quality#', '_rotation#',
                'replaceSel', 'removeMovieClip',
                'removeTextField', 'restrict#', 'scroll#', 'selectable#', 'setNewTextFormat', 'setTextFormat',
                '_soundbuftime#', 'tabEnabled#', 'tabIndex#', '_target#', 'toString',
                'text#', 'textColor#', 'textHeight#', 'textWidth#', 'type#',
                '_url#', 'variable#', '_visible#', '_width#', 'wordWrap#',
                '_x#', '_xmouse#', '_xscale#', '_y#', '_ymouse#', '_yscale#']);
        };
        AVM1TextField.prototype.dispatchKeyEvent = function (keyCode, isShift, isCTRL, isAlt) {
            // this is called from the adaptee whenever a text-input occurs
            if (!this.context.globals.Stage
                || !this.context.globals.Stage._awayAVMStage
                || !this.context.globals.Stage._awayAVMStage.scene) {
                return;
            }
            //console.log("dispatch keyEvent", (<AVM1Stage>this.context.globals.Stage)._awayAVMStage.scene.mouseManager.useSoftkeyboard)
            if (this.context.globals.Stage._awayAVMStage.scene.mouseManager.useSoftkeyboard) {
                //console.log("dispatch keyEvent")
                var staticState = this.context.getStaticState(AVM1Key);
                staticState._lastKeyCode = keyCode;
                staticState._keyStates[keyCode] = 1;
                alCallProperty(AVM1Globals.instance.Key, 'broadcastMessage', ['onKeyDown']);
                var newEvent = new KeyboardEvent(KeyboardEvent.KEYDOWN, "", keyCode);
                newEvent.isShift = isShift;
                newEvent.isCTRL = isCTRL;
                newEvent.isAlt = isAlt;
                this.context.globals.Stage._awayAVMStage.dispatchEvent(newEvent);
                delete staticState._keyStates[keyCode];
                alCallProperty(AVM1Globals.instance.Key, 'broadcastMessage', ['onKeyUp']);
                var newEvent = new KeyboardEvent(KeyboardEvent.KEYUP, "", keyCode);
                newEvent.isShift = isShift;
                newEvent.isCTRL = isCTRL;
                newEvent.isAlt = isAlt;
                this.context.globals.Stage._awayAVMStage.dispatchEvent(newEvent);
            }
        };
        AVM1TextField.syncAllTextfields = function () {
            for (var key in AVM1TextField.allTextfields) {
                if (AVM1TextField.allTextfields[key]) {
                    AVM1TextField.allTextfields[key].syncTextFieldValue();
                }
                else {
                    delete AVM1TextField.allTextfields[key];
                }
            }
        };
        AVM1TextField.syncQueedTextfields = function () {
            if (AVM1TextField.textFieldVars.length > 0) {
                var len = AVM1TextField.textFieldVars.length;
                for (var i = 0; i < len; i++) {
                    AVM1TextField.textFieldVars[i].syncTextFieldValue();
                }
                AVM1TextField.textFieldVars.length = 0;
            }
        };
        AVM1TextField.prototype.getAwayJSID = function () {
            return this.adaptee.id;
        };
        AVM1TextField.prototype.selectTextField = function (fromMouseDown) {
            if (fromMouseDown === void 0) { fromMouseDown = false; }
            // this is called from the adaptee whenever it is selected in MouseManager
            if (AVM1Globals.softKeyboardManager) {
                if (this.adaptee.name == "dummy_txt" || this.adaptee.name.indexOf("temp") == 0)
                    fromMouseDown = true;
                AVM1Globals.softKeyboardManager.openKeyboard(this.adaptee, fromMouseDown);
            }
        };
        AVM1TextField.prototype.removeTextField = function () {
            this.removeMovieClip();
        };
        AVM1TextField.prototype.alPut = function (p, v) {
            _super.prototype.alPut.call(this, p, v);
        };
        AVM1TextField.prototype.initAdapter = function () {
            var _this = this;
            if (this.adaptee._symbol) {
                //console.log("do init", this.adaptee._symbol.variableName, this);
                this.setVariable(this.adaptee._symbol.variableName || '');
            }
            this.adaptee.addEventListener(TextfieldEvent.CHANGED, function () {
                // make sure text-var is synced before onChanged is called:
                _this.updateVarFromText();
                _this.syncTextFieldValue();
            });
            //this._initEventsHandlers();
        };
        AVM1TextField.prototype.initAVM1SymbolInstance = function (context, awayObject) {
            _super.prototype.initAVM1SymbolInstance.call(this, context, awayObject);
            //this.dynamicallyCreated=false;
            this.adaptee = awayObject;
            this._initEventsHandlers();
            this._variable = '';
            this._exitFrameHandler = null;
            this.adaptee = awayObject;
        };
        AVM1TextField.prototype.clone = function () {
            return getAVM1Object(this.adaptee.clone(), this._avm1Context);
        };
        AVM1TextField.prototype.getAntiAliasType = function () {
            notImplemented("AVM1Textfield.getAntiAliasType");
            return ""; // this.adaptee.antiAliasType;
        };
        AVM1TextField.prototype.setAntiAliasType = function (value) {
            notImplemented("AVM1Textfield.getAntiAliasType");
            //value = alCoerceString(this.context, value);
            //this.adaptee.antiAliasType = value;
        };
        AVM1TextField.prototype.get_width = function () {
            this.syncTextFieldValue();
            //this.replicateWeirdFlashBehavior();
            //var box:Box = PickGroup.getInstance((<AVM1Stage>this.context.globals.Stage)._awayAVMStage.view.renderer.view).getBoundsPicker(this.adaptee.partition).getBoxBounds(this.adaptee)
            return toTwipRound(this.adaptee.width);
            //return this._prevWidth;
        };
        AVM1TextField.prototype.get_height = function () {
            this.syncTextFieldValue();
            //this.replicateWeirdFlashBehavior();
            //var box:Box = PickGroup.getInstance((<AVM1Stage>this.context.globals.Stage)._awayAVMStage.view.renderer.view).getBoundsPicker(this.adaptee.partition).getBoxBounds(this.adaptee)
            return toTwipRound(this.adaptee.height);
            //return this._prevWidth;
        };
        AVM1TextField.prototype.set_width = function (value) {
            value = toTwipRound(alToNumber(this.context, value));
            this._blockedByScript = true;
            if (isNaN(value))
                return;
            this.adaptee.width = value;
            //var box:Box = this.adaptee.getBoxBounds(this.adaptee);
            //this._prevWidth=(box == null)? 0 : toTwipRound(box.width);
        };
        AVM1TextField.prototype.set_height = function (value) {
            value = toTwipRound(alToNumber(this.context, value));
            this._blockedByScript = true;
            if (isNaN(value))
                return;
            this.adaptee.height = value;
            //var box:Box = this.adaptee.getBoxBounds(this.adaptee);
            //this._prevWidth=(box == null)? 0 : toTwipRound(box.width);
        };
        AVM1TextField.prototype.get_x = function () {
            this.syncTextFieldValue();
            //this.replicateWeirdFlashBehavior();
            return toTwipFloor(this.adaptee.x + (this.adaptee.scaleX * this.adaptee.textOffsetX));
        };
        AVM1TextField.prototype.get_y = function () {
            this.syncTextFieldValue();
            return toTwipFloor(this.adaptee.y + (this.adaptee.scaleY * this.adaptee.textOffsetY));
        };
        AVM1TextField.prototype.set_x = function (value) {
            this.syncTextFieldValue();
            this.adaptee.x = toTwipFloor(value - (this.adaptee.scaleX * this.adaptee.textOffsetX));
        };
        AVM1TextField.prototype.set_y = function (value) {
            this.syncTextFieldValue();
            this.adaptee.y = toTwipFloor(value - (this.adaptee.scaleY * this.adaptee.textOffsetY));
        };
        AVM1TextField.prototype.getAutoSize = function () {
            return this.adaptee.autoSize;
        };
        AVM1TextField.prototype.setAutoSize = function (value) {
            // AVM1 treats |true| as "LEFT" and |false| as "NONE".
            if (value === true) {
                value = "left";
            }
            else if (value === false) {
                value = "none";
            }
            value = alCoerceString(this.context, value);
            this.adaptee.autoSize = value;
        };
        AVM1TextField.prototype.getBackground = function () {
            return this.adaptee.background;
        };
        AVM1TextField.prototype.setBackground = function (value) {
            value = alToBoolean(this.context, value);
            this.adaptee.background = value;
        };
        AVM1TextField.prototype.getBackgroundColor = function () {
            return this.adaptee.backgroundColor;
        };
        AVM1TextField.prototype.setBackgroundColor = function (value) {
            value = alToInt32(this.context, value);
            this.adaptee.backgroundColor = value;
        };
        AVM1TextField.prototype.getBorder = function () {
            return this.adaptee.border;
        };
        AVM1TextField.prototype.setBorder = function (value) {
            value = alToBoolean(this.context, value);
            this.adaptee.border = value;
        };
        AVM1TextField.prototype.getBorderColor = function () {
            return this.adaptee.borderColor;
        };
        AVM1TextField.prototype.setBorderColor = function (value) {
            value = alToInt32(this.context, value);
            this.adaptee.borderColor = value;
        };
        AVM1TextField.prototype.getBottomScroll = function () {
            return this.adaptee.bottomScrollV + 1;
        };
        AVM1TextField.prototype.getCondenseWhite = function () {
            notImplemented("AVM1Textfield.getCondenseWhite");
            return this.adaptee.condenseWhite;
        };
        AVM1TextField.prototype.setCondenseWhite = function (value) {
            notImplemented("AVM1Textfield.setCondenseWhite");
            value = alToBoolean(this.context, value);
            this.adaptee.condenseWhite = value;
        };
        AVM1TextField.prototype.getEmbedFonts = function () {
            notImplemented("AVM1Textfield.getEmbedFonts");
            return this.adaptee.embedFonts;
        };
        AVM1TextField.prototype.setEmbedFonts = function (value) {
            notImplemented("AVM1Textfield.setEmbedFonts");
            value = alToBoolean(this.context, value);
            this.adaptee.embedFonts = value;
        };
        AVM1TextField.prototype.getNewTextFormat = function () {
            return AVM1TextFormat.createFromNative(this.context, this.adaptee.defaultTextFormat);
        };
        AVM1TextField.prototype.getTextFormat = function (beginIndex, endIndex) {
            if (beginIndex === void 0) { beginIndex = -1; }
            if (endIndex === void 0) { endIndex = -1; }
            beginIndex = alToInteger(this.context, beginIndex);
            endIndex = alToInteger(this.context, endIndex);
            var as3TextFormat = this.adaptee.getTextFormat(beginIndex, endIndex);
            return AVM1TextFormat.createFromNative(this.context, as3TextFormat);
        };
        AVM1TextField.prototype.getGridFitType = function () {
            notImplemented("AVM1Textfield.getGridFitType");
            return ""; // this.adaptee.gridFitType;
        };
        AVM1TextField.prototype.setGridFitType = function (value) {
            notImplemented("AVM1Textfield.setGridFitType");
            //value = alCoerceString(this.context, value);
            //this.adaptee.gridFitType = value;
        };
        AVM1TextField.prototype.getHscroll = function () {
            return this.adaptee.scrollH + 1;
        };
        AVM1TextField.prototype.setHscroll = function (value) {
            value = alCoerceNumber(this.context, value);
            if (value <= 0)
                value = 1;
            this.adaptee.scrollH = value - 1;
        };
        AVM1TextField.prototype.getHtml = function () {
            return this.adaptee.html;
        };
        AVM1TextField.prototype.setHtml = function (value) {
            this.adaptee.html = !!value;
            // Flash doesn't update the displayed text at this point, but the return
            // value of `TextField#htmlText` is as though `TextField#htmlText = TextField#text` had
            // also been called. For now, we ignore that.
        };
        AVM1TextField.prototype.getHtmlText = function () {
            return this.adaptee.html ? this.adaptee.htmlText : this.adaptee.text;
        };
        AVM1TextField.prototype.setHtmlText = function (value) {
            // alToString turns `undefined` into an empty string, but we really do want "undefined" here.
            value = value === undefined ? 'undefined' : alToString(this.context, value);
            if (this.adaptee.html) {
                this.adaptee.htmlText = value;
            }
            else {
                this.adaptee.text = value;
            }
            this.updateVarFromText();
            this.syncTextFieldValue();
        };
        AVM1TextField.prototype.getLength = function () {
            return this.adaptee.length;
        };
        AVM1TextField.prototype.getMaxChars = function () {
            return this.adaptee.maxChars == 0 ? null : this.adaptee.maxChars;
        };
        AVM1TextField.prototype.setMaxChars = function (value) {
            value = alCoerceNumber(this.context, value);
            this.adaptee.maxChars = value;
        };
        AVM1TextField.prototype.getRestrict = function () {
            return this.adaptee.restrict;
        };
        AVM1TextField.prototype.setRestrict = function (value) {
            value = alCoerceString(this.context, value);
            this.adaptee.restrict = value;
        };
        AVM1TextField.prototype.getMaxhscroll = function () {
            return this.adaptee.maxScrollH + 1;
        };
        AVM1TextField.prototype.getMaxscroll = function () {
            return this.adaptee.maxScrollV + 1;
        };
        AVM1TextField.prototype.getMultiline = function () {
            return this.adaptee.multiline;
        };
        AVM1TextField.prototype.setMultiline = function (value) {
            value = alToBoolean(this.context, value);
            this.adaptee.multiline = value;
        };
        AVM1TextField.prototype.getPassword = function () {
            notImplemented("AVM1Textfield.getPassword");
            return this.adaptee.displayAsPassword;
        };
        AVM1TextField.prototype.setPassword = function (value) {
            notImplemented("AVM1Textfield.setPassword");
            value = alToBoolean(this.context, value);
            this.adaptee.displayAsPassword = value;
        };
        AVM1TextField.prototype.getScroll = function () {
            return this.adaptee.scrollV + 1;
        };
        AVM1TextField.prototype.setScroll = function (value) {
            value = alCoerceNumber(this.context, value);
            if (value <= 0)
                value = 1;
            this.adaptee.scrollV = value - 1;
        };
        AVM1TextField.prototype.getSelectable = function () {
            return this.adaptee.selectable;
        };
        AVM1TextField.prototype.setSelectable = function (value) {
            if (value == "false") {
                value = false;
            }
            value = alToBoolean(this.context, value);
            if (!value && this.context.globals.Stage._awayAVMStage.scene.mouseManager.getFocus() == this.adaptee) {
                this.context.globals.Stage._awayAVMStage.scene.mouseManager.setFocus(null);
            }
            this.adaptee.selectable = value;
        };
        AVM1TextField.prototype.replaceSel = function (value) {
            value = alToString(this.context, value);
            this.adaptee.replaceSelectedText(value);
        };
        /**
         * for html text this will get ignored
         */
        AVM1TextField.prototype.setNewTextFormat = function (value) {
            var away3TextFormat;
            if (value instanceof AVM1TextFormat) {
                away3TextFormat = value.adaptee;
            }
            else {
                console.log("AVM1Textfield.setNewtextFormat - trying to set something other than a TextFormat", value);
                return;
            }
            if (!this.adaptee.textFormat) {
                this.adaptee.textFormat = new TextFormat();
            }
            //away3TextFormat.font_table=this.adaptee.textFormat.font_table;
            this.adaptee.newTextFormat = away3TextFormat;
        };
        /**
         * This should only have effect on text that is currently existent on the Textfield.
         * for new text we must use setNewTextFormat
         */
        AVM1TextField.prototype.setTextFormat = function () {
            if (this._variable) {
                this.syncTextFieldValue();
            }
            var beginIndex = -1, endIndex = -1, tf;
            switch (arguments.length) {
                case 0:
                    return; // invalid amount of arguments
                case 1:
                    tf = arguments[0];
                    break;
                case 2:
                    beginIndex = alToNumber(this.context, arguments[0]);
                    tf = arguments[1];
                    break;
                default:
                    beginIndex = alToNumber(this.context, arguments[0]);
                    endIndex = alToNumber(this.context, arguments[1]);
                    tf = arguments[2];
                    break;
            }
            //console.log(arguments);
            if (beginIndex >= 0 && endIndex == -1) {
                endIndex = beginIndex;
            }
            var as3TextFormat;
            if (tf instanceof AVM1TextFormat) {
                as3TextFormat = tf.adaptee;
                this.adaptee.setTextFormat(as3TextFormat, beginIndex, endIndex);
            }
        };
        AVM1TextField.prototype.getText = function () {
            if (this._variable) {
                this.syncTextFieldValue();
            }
            return this.adaptee.text;
        };
        AVM1TextField.prototype.setText = function (value) {
            // alToString turns `undefined` into an empty string, but we really do want "undefined" here.
            value = value === undefined ? '' : alToString(this.context, value);
            var avm1ContextUtils = this.context.utils;
            if (this.adaptee.parent) {
                var clip = getAVM1Object(this.adaptee.parent, this.context);
                avm1ContextUtils.setProperty(clip, this._variable, value);
            }
            this.adaptee.text = value;
            if (this._variable) {
                this.updateVarFromText();
                this.syncTextFieldValue();
            }
        };
        AVM1TextField.prototype.getTextColor = function () {
            return this.adaptee.textColor;
        };
        AVM1TextField.prototype.setTextColor = function (value) {
            value = alToInt32(this.context, value);
            this.adaptee.textColor = value;
        };
        AVM1TextField.prototype.getTextHeight = function () {
            if (this._variable) {
                this.syncTextFieldValue();
            }
            return this.adaptee.textHeight;
        };
        AVM1TextField.prototype.setTextHeight = function (value) {
            notImplemented('AVM1TextField.setTextHeight');
        };
        AVM1TextField.prototype.getTextWidth = function () {
            if (this._variable) {
                this.syncTextFieldValue();
            }
            return this.adaptee.textWidth;
        };
        AVM1TextField.prototype.setTextWidth = function (value) {
            notImplemented('AVM1TextField.setTextWidth');
        };
        AVM1TextField.prototype.getType = function () {
            return this.adaptee.type;
        };
        AVM1TextField.prototype.setType = function (value) {
            value = alCoerceString(this.context, value);
            if (value)
                value = value.toLowerCase();
            this.adaptee.type = value;
        };
        AVM1TextField.prototype.getVariable = function () {
            return this._variable;
        };
        AVM1TextField.prototype.setVariable = function (name) {
            name = alCoerceString(this.context, name);
            if (name === this._variable) {
                return;
            }
            var instance = this.adaptee;
            AVM1TextField.allTextfields[instance.id] = this;
            this._prevTextVarContent = this.adaptee.text;
            this._syncTextFieldValue(instance, name);
            if (this._exitFrameHandler && !name) {
                instance.removeEventListener('exitFrame', this._exitFrameHandler); //80pro: should be exitFrame
                this._exitFrameHandler = null;
            }
            this._variable = name;
            if (!this._exitFrameHandler && name) {
                this._exitFrameHandler = this._onAS3ObjectExitFrame.bind(this);
                instance.addEventListener('exitFrame', this._exitFrameHandler); //80pro: should be exitFrame
            }
        };
        AVM1TextField.prototype._onAS3ObjectExitFrame = function () {
            if (this._variable)
                this._syncTextFieldValue(this.adaptee, this._variable);
        };
        AVM1TextField.prototype.syncTextFieldValue = function () {
            this._syncTextFieldValue(this.adaptee, this._variable);
        };
        AVM1TextField.prototype.updateVarFromText = function () {
            //warning("AVM1Textfield.updateVarFromText - '"+this._textVarHolder.toString()+this._textVarPropName+"' / '"+this.adaptee.text+"'");
            if (this._textVarHolder) { // && !this.adaptee.html){
                this.context.utils.setProperty(this._textVarHolder, this._textVarPropName, this.adaptee.html ? this.adaptee.htmlText : this.adaptee.text);
                this._prevTextVarContent = this.adaptee.text;
            }
        };
        AVM1TextField.prototype._syncTextFieldValue = function (instance, name) {
            if (!name || name == "") {
                return;
            }
            var avm1ContextUtils = this.context.utils;
            if (this._textVarHolder == null) {
                // todo: this could be probably done by using this.context.resolveTarget
                var hasPath = name.indexOf('.') >= 0 || name.indexOf(':') >= 0;
                if (hasPath) {
                    var targetPath = name.split(/[.:\/]/g);
                    this._textVarPropName = targetPath.pop();
                    if (targetPath[0] == '_root' || targetPath[0] == '_level0' || targetPath[0] === '') {
                        var parent = instance.parent;
                        this._textVarHolder = null;
                        while (parent) {
                            if (parent.isAVMScene) {
                                this._textVarHolder = parent.adapter;
                                parent = null;
                            }
                            else {
                                parent = parent.parent;
                            }
                        }
                        if (this._textVarHolder === null) {
                            return; // text field is not part of the stage yet
                        }
                        targetPath.shift();
                        if (targetPath[0] === '') {
                            targetPath.shift();
                        }
                    }
                    else if (targetPath[0] == '_global') {
                        targetPath.shift();
                        this._textVarHolder = this.context.globals;
                    }
                    else {
                        if (!instance.parent) {
                            return;
                        }
                        this._textVarHolder = getAVM1Object(instance.parent, this.context);
                    }
                    var childName = null;
                    while (targetPath.length > 0) {
                        childName = targetPath.shift();
                        this._textVarHolder = avm1ContextUtils.getProperty(this._textVarHolder, childName);
                        if (!this._textVarHolder) {
                            return; // cannot find child clip
                        }
                    }
                }
                else {
                    this._textVarPropName = name;
                    if (instance.parent && instance.parent.parent) {
                        this._textVarHolder = getAVM1Object(instance.parent, this.context);
                        // in cases where another object exists at the same path, and also has a textvar set,
                        // we want to set the already existing path as "textVarHolder", 
                        // so that the text-var-property descripten is shared, and both textields update in sync
                        var child;
                        var parentParent = instance.parent.parent;
                        var len = parentParent.numChildren;
                        for (var i = 0; i < len; i++) {
                            child = parentParent.getChildAt(i);
                            if (child != instance.parent && child.name == instance.parent.name) {
                                if (avm1ContextUtils.hasProperty(child.adapter, this._textVarPropName)) {
                                    this._textVarHolder = child.adapter;
                                }
                            }
                        }
                    }
                }
            }
            if (!this._textVarHolder) {
                // the object that holds the variable could not be found yet
                // we add it to a queue that will be worked off before any script executes
                AVM1TextField.textFieldVars.push(this);
                if (instance.html) {
                    return this._prevTextVarContent = instance.htmlText;
                }
                this._prevTextVarContent = instance.text;
                return;
            }
            // if the variable does not exist, fill it from textfield-content
            if (!avm1ContextUtils.hasProperty(this._textVarHolder, this._textVarPropName)) {
                // the textvar does not exists yet. we create it and fill it with text-content
                if (instance.html) {
                    if (instance.htmlText != "") {
                        avm1ContextUtils.setProperty(this._textVarHolder, this._textVarPropName, instance.htmlText);
                    }
                    else {
                        avm1ContextUtils.setProperty(this._textVarHolder, this._textVarPropName, undefined);
                    }
                    avm1ContextUtils.setProperty(this._textVarHolder, this._textVarPropName + "_internal_TF", this);
                    this._prevTextVarContent = instance.htmlText;
                    return;
                }
                if (instance.text != "") {
                    avm1ContextUtils.setProperty(this._textVarHolder, this._textVarPropName, instance.text);
                }
                else {
                    avm1ContextUtils.setProperty(this._textVarHolder, this._textVarPropName, undefined);
                }
                avm1ContextUtils.setProperty(this._textVarHolder, this._textVarPropName + "_internal_TF", this);
                this._prevTextVarContent = instance.text;
                return;
            }
            //  if no "_internal_TF" property exists next to the variable, we create it, and set its value to "this"
            //  this is used to find textfields to focus, when setFocus is called on a textfield-variable
            if (!avm1ContextUtils.hasProperty(this._textVarHolder, this._textVarPropName + "_internal_TF")) {
                avm1ContextUtils.setProperty(this._textVarHolder, this._textVarPropName + "_internal_TF", this);
            }
            // get the value of the text-variable
            var newTextVarContent = avm1ContextUtils.getProperty(this._textVarHolder, this._textVarPropName);
            if (typeof newTextVarContent !== "string") {
                newTextVarContent = alToString(this.context, newTextVarContent);
            }
            if (instance.html) {
                // the value of the text-variable has changed
                if (newTextVarContent !== this._prevTextVarContent) {
                    // textvar has changed. update text from var
                    instance.htmlText = (typeof newTextVarContent === "undefined") ? "" : newTextVarContent;
                    this._prevTextVarContent = newTextVarContent;
                    return;
                }
                if (instance.htmlText !== newTextVarContent && (!(typeof newTextVarContent === "undefined" && instance.htmlText === ""))) {
                    // makes sure text is set correctly in case the timeline has interferred.
                    instance.htmlText = (typeof newTextVarContent === "undefined") ? "" : newTextVarContent;
                }
            }
            else {
                if (newTextVarContent !== this._prevTextVarContent) {
                    // textvar has changed. update text from var
                    instance.text = (typeof newTextVarContent === "undefined") ? "" : newTextVarContent;
                    this._prevTextVarContent = newTextVarContent;
                    return;
                }
                if (instance.text !== newTextVarContent && (!(typeof newTextVarContent === "undefined" && instance.text === ""))) {
                    // makes sure text is set correctly in case the timeline has interferred.
                    instance.text = (typeof newTextVarContent === "undefined") ? "" : newTextVarContent;
                }
            }
        };
        AVM1TextField.prototype.getWordWrap = function () {
            return this.adaptee.wordWrap;
        };
        AVM1TextField.prototype.setWordWrap = function (value) {
            value = alToBoolean(this.context, value);
            this.adaptee.wordWrap = value;
        };
        AVM1TextField.prototype._initEventsHandlers = function () {
            this.bindEvents(EventsListForMC);
        };
        AVM1TextField.allTextfields = {};
        AVM1TextField.textFieldVars = [];
        return AVM1TextField;
    }(AVM1SymbolBase));

    var StageScaleMode = /** @class */ (function () {
        function StageScaleMode() {
        }
        StageScaleMode.EXACT_FIT = "EXACT_FIT";
        StageScaleMode.NO_BORDER = "noBorder";
        StageScaleMode.NO_SCALE = "noScale";
        StageScaleMode.SHOW_ALL = "showAll";
        return StageScaleMode;
    }());

    var StageAlign = /** @class */ (function () {
        function StageAlign() {
        }
        StageAlign.BOTTOM = "B";
        StageAlign.BOTTOM_LEFT = "BL";
        StageAlign.BOTTOM_RIGHT = "BR";
        StageAlign.LEFT = "L";
        StageAlign.RIGHT = "R";
        StageAlign.TOP = "T";
        StageAlign.TOP_LEFT = "TL";
        StageAlign.TOP_RIGHT = "TR";
        return StageAlign;
    }());

    var AVMAwayStage = /** @class */ (function (_super) {
        __extends(AVMAwayStage, _super);
        function AVMAwayStage(width, height, backgroundColor, frameRate, htmlCanvas, stageWidth, stageHeight, show_fps) {
            if (width === void 0) { width = 550; }
            if (height === void 0) { height = 400; }
            if (backgroundColor === void 0) { backgroundColor = null; }
            if (frameRate === void 0) { frameRate = 30; }
            if (htmlCanvas === void 0) { htmlCanvas = null; }
            if (stageWidth === void 0) { stageWidth = 550; }
            if (stageHeight === void 0) { stageHeight = 400; }
            if (show_fps === void 0) { show_fps = false; }
            var _this = _super.call(this) || this;
            _this._frameRate = 30;
            _this._currentFps = 0;
            _this._stageTime = 0;
            _this.isStage = true;
            _this.enterEvent = new EventBase("enterFrame");
            _this.exitEvent = new EventBase("exitFrame");
            // no need to create new events on each frame. we can reuse them
            _this.SHOW_FRAME_RATE = true;
            _this._debugtimer = 0;
            _this.avm1Listener = {};
            _this._collectedDispatcher = [];
            _this._align = 1;
            _this._scaleMode = 1;
            BuildMode.mode = BuildMode.AVM1;
            _this._stage3Ds = [];
            _this._layers = [];
            _this.SHOW_FRAME_RATE = show_fps;
            //todo: better implement this in graphics (this function provides the drawing api with materials for a color / alpha)
            Graphics.get_material_for_color = function (color, alpha) {
                if (alpha === void 0) { alpha = 1; }
                if (color == 0) {
                    color = 0x000001;
                }
                //color=0xFF8100;
                //console.log("get color");
                //alpha=0.5;
                var texObj = {};
                var newmat;
                if (AVMAwayStage._useTextureAtlasForColors) {
                    texObj = TextureAtlas.getTextureForColor(color, alpha);
                    if (AVMAwayStage._colorMaterials[texObj.bitmap.id]) {
                        texObj.material = AVMAwayStage._colorMaterials[texObj.bitmap.id];
                        return texObj;
                    }
                    newmat = new MethodMaterial(texObj.bitmap);
                    newmat.alphaBlending = true;
                    newmat.useColorTransform = true;
                    newmat.bothSides = true;
                    AVMAwayStage._colorMaterials[texObj.bitmap.id] = newmat;
                    texObj.material = newmat;
                    return texObj;
                }
                var colorstr = color + "_" + Math.round(alpha * 100).toString();
                if (AVMAwayStage._colorMaterials[colorstr]) {
                    texObj.material = AVMAwayStage._colorMaterials[colorstr];
                    return texObj;
                }
                newmat = new MethodMaterial(color, alpha);
                newmat.alphaBlending = true;
                newmat.useColorTransform = true;
                newmat.bothSides = true;
                texObj.material = newmat;
                AVMAwayStage._colorMaterials[colorstr] = newmat;
                return texObj;
            };
            Graphics.get_material_for_gradient = function (gradient) {
                var texObj = TextureAtlas.getTextureForGradient(gradient);
                /*if(alpha==0){
                 alpha=1;
                 }*/
                //alpha=0.5;
                /*if(color==0xffffff){
                 color=0xcccccc;
                 }*/
                var lookupId = texObj.bitmap.id + gradient.type;
                if (AVMAwayStage._textureMaterials[lookupId]) {
                    texObj.material = AVMAwayStage._textureMaterials[lookupId];
                    return texObj;
                }
                var newmat = new MethodMaterial(texObj.bitmap);
                newmat.useColorTransform = true;
                newmat.alphaBlending = true;
                newmat.bothSides = true;
                AVMAwayStage._textureMaterials[lookupId] = newmat;
                texObj.material = newmat;
                return texObj;
            };
            // init awayengine
            _this._stageWidth = stageWidth;
            _this._stageHeight = stageHeight;
            _this.initEninge(htmlCanvas);
            _this.partition = new SceneGraphPartition(_this, true);
            _this._scene.root.addChild(_this);
            _this.mouseEnabled = true;
            //backgroundColor=0xcccccc;
            _this._scene.view.backgroundColor = (isNaN(backgroundColor)) ? 0xFF00FF : backgroundColor;
            _this._frameRate = frameRate;
            MouseManager.getInstance(PickGroup.getInstance(_this._scene.renderer.view))._stage = _this;
            MouseManager.getInstance(PickGroup.getInstance(_this._scene.renderer.view)).eventBubbling = false;
            // prevent backspace and other default shortcutz for our document:
            // todo: make this optional (?)
            /*
            document.onkeydown = function (event) {
                if (!event) {// This will happen in IE
                    event = <any>window.event;
                }
                var keyCode = event.keyCode;
                if (keyCode == 8 &&
                    ((<any>(event.target || event.srcElement)).tagName != "TEXTAREA") &&
                    ((<any>(event.target || event.srcElement)).tagName != "INPUT")) {

                    if (navigator.userAgent.toLowerCase().indexOf("msie") == -1) {
                        event.stopPropagation();
                    } else {
                        alert("prevented");
                        event.returnValue = false;
                    }
                    MouseManager.getInstance().onKeyDown(event);
                    return false;
                }
            }*/
            if (_this.SHOW_FRAME_RATE) {
                _this._fpsTextField = document.createElement('div'); // disable in RC
                _this._fpsTextField.style.cssFloat = 'none';
                _this._fpsTextField.style.position = 'absolute';
                _this._fpsTextField.style.top = '15px';
                _this._fpsTextField.style.width = '200px';
                _this._fpsTextField.style.height = '20px';
                _this._fpsTextField.style.left = window.innerWidth * 0.5 - 100 + 'px';
                _this._fpsTextField.style.textAlign = 'center';
                _this._fpsTextField.style.color = '#ff0000';
                _this._fpsTextField.style.fontSize = '30px';
                _this._fpsTextField.style.zIndex = '9999';
                _this._fpsTextField.innerHTML = "30";
                document.body.appendChild(_this._fpsTextField);
                setInterval(function () { return _this.updateFPS(); }, 1000);
            }
            _this.initListeners();
            //console.log("constructed AVMAwayStage and create the entranceclass");
            _this.htmlElement = _this._stage.container;
            _this.htmlElement.tabIndex = 1000;
            return _this;
        }
        Object.defineProperty(AVMAwayStage.prototype, "scene", {
            get: function () {
                return this._scene;
            },
            enumerable: true,
            configurable: true
        });
        AVMAwayStage.prototype.getLayer = function (idx) {
            while (this._layers.length <= idx) {
                this._layers[this._layers.length] = new Sprite();
                //this._layers[this._layers.length-1].mouseChildren=true;
                //this._layers[this._layers.length-1].mouseEnabled=false;
                this.addChild(this._layers[this._layers.length - 1]);
            }
            return this._layers[idx];
        };
        Object.defineProperty(AVMAwayStage.prototype, "rendererStageContainer", {
            get: function () {
                return this._stage.container;
            },
            enumerable: true,
            configurable: true
        });
        AVMAwayStage.prototype.updateFPS = function () {
            if (this._fpsTextField)
                this._fpsTextField.innerText = this._currentFps.toFixed(2) + ' / ' + this._frameRate + " fps";
            this._currentFps = 0;
        };
        Object.defineProperty(AVMAwayStage.prototype, "onlyMouseEnabled", {
            set: function (value) {
                //this._scene.mousePicker.onlyMouseEnabled = value;
            },
            enumerable: true,
            configurable: true
        });
        // ---------- event mapping functions Event.RESIZE
        AVMAwayStage.prototype.initResizeListener = function (type, callback) {
            //window.addEventListener("resize", callback);
        };
        AVMAwayStage.prototype.removeResizeListener = function (type, callback) {
            //window.removeEventListener("resize", callback);
        };
        AVMAwayStage.prototype.resizeCallback = function (event) {
            // todo: correctly implement all StageScaleModes;
            if (event === void 0) { event = null; }
            var newWidth = window.innerWidth;
            var newHeight = window.innerHeight;
            var newX = 0;
            var newY = 0;
            switch (this.scaleMode) {
                case StageScaleMode.NO_SCALE:
                    this._projection.fieldOfView = Math.atan(this._stageHeight / 1000 / 2) * 360 / Math.PI;
                    break;
                case StageScaleMode.SHOW_ALL:
                    newHeight = window.innerHeight;
                    newWidth = (this._stageWidth / this._stageHeight) * newHeight;
                    if (newWidth > window.innerWidth) {
                        newWidth = window.innerWidth;
                        newHeight = newWidth * (this._stageHeight / this._stageWidth);
                    }
                    newX = (window.innerWidth - newWidth) / 2;
                    newY = (window.innerHeight - newHeight) / 2;
                    this._projection.fieldOfView = Math.atan(this._stageHeight / 1000 / 2) * 360 / Math.PI;
                    break;
                case StageScaleMode.EXACT_FIT:
                case StageScaleMode.NO_BORDER:
                    this._projection.fieldOfView = Math.atan(window.innerHeight / 1000 / 2) * 360 / Math.PI;
                    break;
                default:
                    release$1 || console.log("Stage: only implemented StageScaleMode are NO_SCALE, SHOW_ALL");
                    break;
            }
            // todo: correctly implement all alignModes;
            switch (this.align) {
                case StageAlign.TOP_LEFT:
                    this._scene.renderer.view.y = 0;
                    this._scene.renderer.view.x = 0;
                    break;
                default:
                    //this._scene.renderer.view.y         = 0;
                    //this._scene.renderer.view.x         = 0;
                    release$1 || console.log("Stage: only implemented StageAlign is TOP_LEFT");
                    break;
            }
            //console.log("test28");
            this.updateSize(newX, newY, newWidth, newHeight);
        };
        AVMAwayStage.prototype.updateSize = function (x, y, w, h) {
            //this._stageWidth=w;
            //this._stageHeight=h;
            //if(this._scene && this._scene.view && this._stage){
            this._scene.view.x = x;
            this._scene.view.y = y;
            this._stage.x = x;
            this._stage.y = y;
            //	this._renderer.stage.container.style.zIndex="-100";
            this._stage.width = w;
            this._stage.height = h;
            this._scene.view.width = w;
            this._scene.view.height = h;
            if (this._fpsTextField)
                this._fpsTextField.style.left = window.innerWidth * 0.5 - 100 + 'px';
            //}
        };
        AVMAwayStage.prototype.show = function () {
            //this._scene.renderer.stage.container.style.display="initial";
        };
        // ---------- event mapping functions Event.MOUSE_LEAVE
        //---------------------------stuff added to make it work:
        AVMAwayStage.prototype.takeSnapShot = function () {
            var myBitmap = new BitmapImage2D(550, 400, true, 0xffffffff, false);
            this._scene.renderer.queueSnapshot(myBitmap);
            this._scene.render();
            myBitmap.invalidate();
            // flip vertical:
            var oldData = myBitmap.data;
            var myBitmap2 = new BitmapImage2D(550, 400, true, 0xff00ffff, false);
            var x = 0;
            var y = 0;
            var idx = 0;
            var color = 0;
            var awayPixels = [];
            // get all pixels of our image (BitmapData)
            for (y = 0; y < 400; y++) {
                for (x = 0; x < 550; x++) {
                    idx = ((399 - y) * 550 + x) * 4;
                    color = ColorUtils.ARGBtoFloat32(oldData[idx + 3], oldData[idx], oldData[idx + 1], oldData[idx + 2]);
                    awayPixels[awayPixels.length] = color;
                    myBitmap2.setPixel32(x, y, color);
                }
            }
            myBitmap2.invalidate();
            var htmlImage = document.createElement("canvas");
            htmlImage.width = myBitmap2.width;
            htmlImage.height = myBitmap2.height;
            htmlImage.style.position = "absolute";
            htmlImage.style.top = "0px";
            htmlImage.style.left = "0px";
            htmlImage.style.width = "100%";
            var context = htmlImage.getContext("2d");
            var imageData = context.getImageData(0, 0, myBitmap2.width, myBitmap2.height);
            imageData.data.set(myBitmap2.data);
            context.putImageData(imageData, 0, 0);
            return htmlImage;
        };
        AVMAwayStage.prototype.initEninge = function (htmlCanvas) {
            //create the view
            //this._rendererStage = StageManager.getInstance().getStageAt(0);
            StageManager.htmlCanvas = htmlCanvas;
            this._scene = new Scene(new BasicPartition(new DisplayObjectContainer()));
            this._scene.renderer.renderableSorter = null; //new RenderableSort2D();
            StageManager.htmlCanvas = null;
            this._stage = this._scene.view.stage;
            this._stage.antiAlias = 0;
            this._stage.color = 0xFFFFFFFF;
            //this._scene.mousePicker=new AVMRaycastPicker(this._renderer.partition, true, this);
            this._scene.mousePicker.shapeFlag = true;
            this._scene.forceMouseMove = true;
            this._scene.beforeRenderCallback = function () {
                FrameScriptManager.execute_queue();
                AVM1TextField.syncAllTextfields();
            };
            this._projection = new PerspectiveProjection();
            this._projection.coordinateSystem = CoordinateSystem.RIGHT_HANDED;
            this._projection.fieldOfView = 30;
            this._projection.originX = -1;
            this._projection.originY = 1;
            var camera = new Camera();
            camera.projection = this._projection;
            //this._hoverControl = new HoverController(camera, null, 180, 0, 1000);
            this._scene.camera = camera;
            //this._projection.preserveFocalLength=true;
            this._projection.fieldOfView = Math.atan(this._stageHeight / 1000 / 2) * 360 / Math.PI;
            //	this._renderer.stage.container.style.zIndex="-100";
        };
        /**
         * Initialise the listeners
         */
        AVMAwayStage.prototype.initListeners = function () {
            //window.addEventListener("resize", this._resizeCallbackDelegate);
            var _this = this;
            this._timer = new RequestAnimationFrame(this.internalOnEnterFrame, this);
            this._timer.start();
            this.clearAllAVM1Listener();
            this.addEventListener(MouseEvent.MOUSE_DOWN, function (evt) { return _this.onMouseEvent(evt); });
            this.addEventListener(MouseEvent.MOUSE_UP, function (evt) { return _this.onMouseEvent(evt); });
            this.addEventListener(MouseEvent.MOUSE_MOVE, function (evt) { return _this.onMouseEvent(evt); });
            this.addEventListener(KeyboardEvent.KEYDOWN, function (evt) { return _this.onKeyEvent(evt); });
            this.addEventListener(KeyboardEvent.KEYUP, function (evt) { return _this.onKeyEvent(evt); });
            //this._resizeCallbackDelegate(null);
        };
        AVMAwayStage.prototype.onKeyEvent = function (event) {
            if (!this.avm1Listener[event.type])
                return;
            // the correct order for stage-event on childs is children first, highest depth first
            this._collectedDispatcher.length = 0;
            var i = 0;
            var myLayer;
            var numChilds;
            var c;
            var child;
            var len = this._layers.length;
            for (i = 0; i < len; i++) {
                myLayer = this._layers[i];
                numChilds = myLayer.numChildren;
                for (c = 0; c < numChilds; ++c) {
                    child = myLayer.getChildAt(c);
                    if (child.isAsset(MovieClip)) {
                        this.collectMousEvents(child);
                    }
                }
            }
            len = this._collectedDispatcher.length;
            for (i = 0; i < len; i++) {
                if (this.avm1Listener[event.type] && this.avm1Listener[event.type][this._collectedDispatcher[i].id]) {
                    for (var e = 0; e < this.avm1Listener[event.type][this._collectedDispatcher[i].id].length; e++) {
                        if (typeof this.avm1Listener[event.type][this._collectedDispatcher[i].id][e].keyCode !== "number" ||
                            this.avm1Listener[event.type][this._collectedDispatcher[i].id][e].keyCode == event.keyCode)
                            this.avm1Listener[event.type][this._collectedDispatcher[i].id][e].callback();
                    }
                }
            }
            FrameScriptManager.execute_queue();
        };
        AVMAwayStage.prototype.addAVM1EventListener = function (asset, type, callback, eventProps) {
            if (!this.avm1Listener[type])
                this.avm1Listener[type] = {};
            if (!this.avm1Listener[type][asset.id])
                this.avm1Listener[type][asset.id] = [];
            this.avm1Listener[type][asset.id].push({ type: type, callback: callback });
            if (eventProps && typeof eventProps.keyCode === "number") {
                this.avm1Listener[type][asset.id][this.avm1Listener[type][asset.id].length - 1].keyCode = eventProps.keyCode;
            }
        };
        AVMAwayStage.prototype.removeAVM1EventListener = function (asset, type, callback) {
            if (!this.avm1Listener[type])
                return;
            delete this.avm1Listener[type][asset.id];
        };
        AVMAwayStage.prototype.clearAllAVM1Listener = function () {
            this.avm1Listener = {};
        };
        AVMAwayStage.prototype.collectMousEvents = function (child) {
            var child2;
            var c = child.numChildren;
            while (c > 0) {
                c--;
                child2 = child.getChildAt(c);
                this.collectMousEvents(child2);
            }
            if (child.isAsset(MovieClip)) {
                this._collectedDispatcher[this._collectedDispatcher.length] = child;
            }
        };
        AVMAwayStage.prototype.onMouseEvent = function (mouseEvent) {
            if (!this.avm1Listener[mouseEvent.type])
                return;
            // the correct order for stage-event on childs is children first, highest depth first
            this._collectedDispatcher.length = 0;
            var i = 0;
            var myLayer;
            var numChilds;
            var c;
            var child;
            var len = this._layers.length;
            for (i = 0; i < len; i++) {
                myLayer = this._layers[i];
                numChilds = myLayer.numChildren;
                for (c = 0; c < numChilds; ++c) {
                    child = myLayer.getChildAt(c);
                    if (child.isAsset(MovieClip)) {
                        this.collectMousEvents(child);
                    }
                }
            }
            len = this._collectedDispatcher.length;
            var dispatcherLen;
            for (i = 0; i < len; i++) {
                if (this.avm1Listener[mouseEvent.type] && this.avm1Listener[mouseEvent.type][this._collectedDispatcher[i].id]) {
                    dispatcherLen = this.avm1Listener[mouseEvent.type][this._collectedDispatcher[i].id].length;
                    for (var e = 0; e < dispatcherLen; e++) {
                        this.avm1Listener[mouseEvent.type][this._collectedDispatcher[i].id][e].callback();
                    }
                }
            }
            FrameScriptManager.execute_queue();
        };
        AVMAwayStage.prototype.runAVM1Framescripts = function () {
            FrameScriptManager.execute_queue();
        };
        AVMAwayStage.prototype.executeEnterFrame = function (child, enterFramesChilds) {
            var child2;
            var c = child.numChildren;
            while (c > 0) {
                c--;
                child2 = child.getChildAt(c);
                this.executeEnterFrame(child2, enterFramesChilds);
            }
            if (child.isAsset(MovieClip)) {
                if (child.hasEventListener(this.enterEvent.type))
                    enterFramesChilds.push(child);
            }
        };
        AVMAwayStage.prototype.onEnterFrame = function (dt) {
            // make sure all things are processed already (mouseEvents)
            FrameScriptManager.execute_queue();
            var i = 0;
            var myLayer;
            var numChilds;
            var c;
            var child;
            var len = this._layers.length;
            MovieClip._skipAdvance = true;
            for (i = 0; i < len; i++) {
                myLayer = this._layers[i];
                numChilds = myLayer.numChildren;
                for (c = 0; c < numChilds; ++c) {
                    child = myLayer.getChildAt(c);
                    // each child in here should be a swf-scene
                    if (child.isAsset(MovieClip)) {
                        child.advanceFrame();
                    }
                }
            }
            MovieClip._skipAdvance = false;
            FrameScriptManager.execute_queue();
            var enterFramesChilds = [];
            len = this._layers.length;
            // now dispatch the onEnterFrame
            for (i = 0; i < len; i++) {
                myLayer = this._layers[i];
                numChilds = myLayer.numChildren;
                for (c = 0; c < numChilds; ++c) {
                    child = myLayer.getChildAt(c);
                    // each child in here should be a swf-scene
                    this.executeEnterFrame(child, enterFramesChilds);
                }
            }
            len = enterFramesChilds.length;
            for (i = 0; i < len; i++) {
                enterFramesChilds[i].dispatchEvent(this.enterEvent);
            }
            FrameScriptManager.execute_queue();
            FrameScriptManager.execute_intervals(dt);
            FrameScriptManager.execute_queue();
            len = this._layers.length;
            //this.runAVM1Framescripts();
            for (i = 0; i < len; i++) {
                myLayer = this._layers[i];
                numChilds = myLayer.numChildren;
                for (c = 0; c < numChilds; ++c) {
                    child = myLayer.getChildAt(c);
                    if (child.isAsset(MovieClip)) {
                        child.dispatchExitFrame(this.exitEvent);
                    }
                }
            }
            // process all queued scripts
            FrameScriptManager.execute_queue();
        };
        /**
         * Render loop
         */
        AVMAwayStage.prototype.internalOnEnterFrame = function (dt) {
            //console.log("START NEW FRAME \n")
            if (!this._stage || !this._scene || !this._scene.renderer) {
                this._timer.stop();
                return;
            }
            var frameMarker = 1000 / this._frameRate;
            this._stageTime += Math.min(dt, frameMarker);
            if (this._stageTime >= frameMarker) {
                MovieClipSoundsManager.enterFrame();
                this._stage.clear();
                this.onEnterFrame(this._stageTime);
                this._stageTime -= frameMarker;
                //this.dispatchEventRecursive(this._eventOnEnter);
                //this.update(this._events);
                //this.dispatchEventRecursive(this._eventFrameConstructed);
                // todo: move Framescriptexecution and rest from frame-update logic from Movieclip.update to here
                //this.dispatchEventRecursive(this._eventExitFrame);
                //this.dispatchEventRecursive(this._eventRender);
                if (!this._stage || !this._scene || !this._scene.renderer) {
                    this._timer.stop();
                    return;
                }
                this._currentFps++;
                this._scene.render();
                MovieClipSoundsManager.exitFrame();
                /*
                            this._debugtimer++;
            
                            if(this._debugtimer%150==0){
            
                                var displayGraph={};
                                this.debugDisplayGraph(displayGraph);
                                console.log("SceneGraph frame :", this._debugtimer, displayGraph);
            
                            }
                            */
            }
        };
        Object.defineProperty(AVMAwayStage.prototype, "rendererStage", {
            get: function () {
                return this._stage;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "mouseX", {
            //---------------------------original as3 properties / methods:
            get: function () {
                //console.log("mouseX not implemented yet in flash/DisplayObject");
                return this._scene.getLocalMouseX(this);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "mouseY", {
            /**
             * Indicates the y coordinate of the mouse or user input device position, in pixels.
             *
             *   Note: For a DisplayObject that has been rotated, the returned y coordinate will reflect the
             * non-rotated any.
             */
            get: function () {
                //console.log("mouseY not implemented yet in flash/DisplayObject");
                return this._scene.getLocalMouseY(this);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "accessibilityImplementation", {
            set: function (value) {
                //todo: any is AccessibilityImplementation
                console.log("textSnapshot not implemented yet in flash/AVMAwayStage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "align", {
            get: function () {
                return this._align;
            },
            set: function (value) {
                this._align = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "scaleMode", {
            get: function () {
                return this._scaleMode;
            },
            set: function (value) {
                this._scaleMode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "allowsFullScreen", {
            /**
             * Specifies whether this stage allows the use of the full screen mode
             * @langversion	3.0
             * @playerversion	Flash 10.2
             * @oldexample	The following example traces the value of this read-only property:
             *   <pre xml:space="preserve" class="- topic/pre ">
             *   trace(AVMAwayStage.allowsFullsreen);
             *   </pre>
             */
            get: function () {
                //todo
                console.log("allowsFullScreen not implemented yet in flash/AVMAwayStage");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "allowsFullScreenInteractive", {
            get: function () {
                //todo
                console.log("allowsFullScreenInteractive not implemented yet in flash/AVMAwayStage");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "browserZoomFactor", {
            get: function () {
                //todo
                console.log("browserZoomFactor not implemented yet in flash/AVMAwayStage");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "color", {
            get: function () {
                return this._scene.view.backgroundColor;
            },
            set: function (color) {
                this._scene.view.backgroundColor = color;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "colorCorrection", {
            /**
             * Controls Flash runtime color correction for displays.
             * Color correction works only if the main monitor is assigned a valid ICC color profile, which specifies
             * the device's particular color attributes.
             * By default, the Flash runtime tries to match the color correction of its host (usually a browser).
             *
             *   Use the AVMAwayStage.colorCorrectionSupport property
             * to determine if color correction is available on the current system and the default state.
             * .    If color correction is available, all colors on the stage are assumed to be in
             * the sRGB color space, which is the most standard color space. Source profiles of input devices are not considered during color correction.
             * No input color correction is applied; only the stage output is mapped to the main
             * monitor's ICC color profile.In general, the benefits of activating color management include predictable and consistent color, better conversion,
             * accurate proofing and more efficient cross-media output. Be aware, though, that color management does not provide
             * perfect conversions due to devices having a different gamut from each other or original images.
             * Nor does color management eliminate the need for custom or edited profiles.
             * Color profiles are dependent on browsers, operating systems (OS), OS extensions, output devices, and application support.Applying color correction degrades the Flash runtime performance.
             * A Flash runtime's color correction is document style color correction because
             * all SWF movies are considered documents with implicit sRGB profiles.
             * Use the AVMAwayStage.colorCorrectionSupport property to tell the Flash runtime
             * to correct colors when displaying the SWF file (document) to the display color space.
             * Flash runtimes only compensates for differences between monitors, not for differences between input devices (camera/scanner/etc.).
             * The three possible values are strings with corresponding constants in the flash.display.ColorCorrection class:"default": Use the same color correction as the host system."on": Always perform color correction."off": Never perform color correction.
             */
            get: function () {
                //todo
                console.log("colorCorrection not implemented yet in flash/AVMAwayStage");
                return "";
            },
            set: function (value) {
                //todo
                console.log("colorCorrection not implemented yet in flash/AVMAwayStage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "colorCorrectionSupport", {
            /**
             * Specifies whether the Flash runtime is running on an operating system that supports
             * color correction and whether the color profile of the main (primary)
             * monitor can be read and understood by the Flash runtime. This property also returns the default state
             * of color correction on the host system (usually the browser).
             * Currently the return values can be:
             * The three possible values are strings with corresponding constants in the flash.display.ColorCorrectionSupport class:"unsupported": Color correction is not available."defaultOn": Always performs color correction."defaultOff": Never performs color correction.
        
             */
            get: function () {
                //todo
                console.log("colorCorrectionSupport not implemented yet in flash/AVMAwayStage");
                return "";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "contentsScaleFactor", {
            get: function () {
                //todo
                console.log("contentsScaleFactor not implemented yet in flash/AVMAwayStage");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "displayContextInfo", {
            get: function () {
                //todo
                console.log("displayContextInfo not implemented yet in flash/AVMAwayStage");
                return "";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "displayState", {
            /**
             * A value from the StageDisplayState class that specifies which display state to use. The following
             * are valid values:
             *
             *   StageDisplayState.FULL_SCREEN Sets AIR application or Flash runtime to expand the
             * stage over the user's entire screen, with keyboard input disabled.StageDisplayState.FULL_SCREEN_INTERACTIVE Sets the AIR application to expand the
             * stage over the user's entire screen, with keyboard input allowed.
             * (Not available for content running in Flash Player.)StageDisplayState.NORMAL Sets the Flash runtime back to the standard stage display mode.The scaling behavior of the movie in full-screen mode is determined by the scaleMode
             * setting (set using the AVMAwayStage.scaleMode property or the SWF file's embed
             * tag settings in the HTML file). If the scaleMode property is set to noScale
             * while the application transitions to full-screen mode, the AVMAwayStage width and height
             * properties are updated, and the AVMAwayStage dispatches a resize event. If any other scale mode is set,
             * the stage and its contents are scaled to fill the new screen dimensions. The AVMAwayStage object retains its original
             * width and height values and does not dispatch a resize event.The following restrictions apply to SWF files that play within an HTML page (not those using the stand-alone
             * Flash Player or not running in the AIR runtime):To enable full-screen mode, add the allowFullScreen parameter to the object
             * and embed tags in the HTML page that includes the SWF file, with allowFullScreen set
             * to "true", as shown in the following example:
             *
             *   <codeblock>
             * <param name="allowFullScreen" value="true" />
             * ...
             * <embed src="example.swf" allowFullScreen="true" ... >
             * </codeblock>
             * An HTML page may also use a script to generate SWF-embedding tags. You need to alter the script
             * so that it inserts the proper allowFullScreen settings. HTML pages generated by Flash Professional and
             * Flash Builder use the AC_FL_RunContent() to embed references to SWF files, and you
             * need to add the allowFullScreen parameter settings, as in the following:
             * <codeblock>
             * AC_FL_RunContent( ... "allowFullScreen", "true", ... )
             * </codeblock>
             * Full-screen mode is initiated in response to a mouse click or key press by the user; the movie cannot change
             * AVMAwayStage.displayState without user input. Flash runtimes restrict keyboard input  in full-screen mode.
             * Acceptable keys include keyboard shortcuts that terminate full-screen mode and non-printing keys such as arrows, space, Shift,
             * and Tab keys. Keyboard shortcuts that terminate full-screen mode are: Escape (Windows, Linux, and Mac), Control+W (Windows),
             * Command+W (Mac), and Alt+F4.
             * A Flash runtime dialog box appears over the movie when users enter full-screen mode to inform the users they are in
             * full-screen mode and that they can press the Escape key to end full-screen mode.Starting with Flash Player 9.0.115.0, full-screen works the same in windowless mode as it does in window mode.
             * If you set the Window Mode (wmode in the HTML) to Opaque Windowless (opaque)
             * or Transparent Windowless (transparent), full-screen can be initiated,
             * but the full-screen window will always be opaque.These restrictions are not present for SWF content running in the
             * stand-alone Flash Player or in AIR. AIR supports an interactive full-screen mode which allows keyboard input.For AIR content running in full-screen mode, the system screen saver
             * and power saving options are disabled while video content is playing and until either the video stops
             * or full-screen mode is exited.On Linux, setting displayState to StageDisplayState.FULL_SCREEN or
             * StageDisplayState.FULL_SCREEN_INTERACTIVE is an asynchronous operation.
             * @throws	SecurityError Calling the displayState property of a AVMAwayStage object throws an exception for
             *   any caller that is not in the same security sandbox as the AVMAwayStage owner (the main SWF file).
             *   To avoid this, the AVMAwayStage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             *   Trying to set the displayState property while the settings dialog is displayed, without a user response, or
             *   if the param or embed HTML tag's allowFullScreen attribute is not set to
             *   true throws a security error.
             */
            get: function () {
                //todo
                console.log("displayState not implemented yet in flash/AVMAwayStage");
                return "";
            },
            set: function (value) {
                //todo
                console.log("displayState not implemented yet in flash/AVMAwayStage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "focus", {
            /**
             * The interactive object with keyboard focus; or null if focus is not set
             * or if the focused object belongs to a security sandbox to which the calling object does not
             * have access.
             * @throws	Error Throws an error if focus cannot be set to the target.
             */
            get: function () {
                //todo: any is InteractiveObject
                console.log("focus not implemented yet in flash/AVMAwayStage");
                return null;
            },
            set: function (newFocus) {
                //todo: any is InteractiveObject
                console.log("focus not implemented yet in flash/AVMAwayStage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "frameRate", {
            /**
             * Gets and sets the frame rate of the stage. The frame rate is defined as frames per second.
             * By default the rate is set to the frame rate of the first SWF file loaded. Valid range for the frame rate
             * is from 0.01 to 1000 frames per second.
             *
             *   Note: An application might not be able to follow
             * high frame rate settings, either because the target platform is not fast enough or the player is
             * synchronized to the vertical blank timing of the display device (usually 60 Hz on LCD devices).
             * In some cases, a target platform might also choose to lower the maximum frame rate if it
             * anticipates high CPU usage.For content running in Adobe AIR, setting the frameRate property of one AVMAwayStage
             * object changes the frame rate for all AVMAwayStage objects (used by different NativeWindow objects).
             * @throws	SecurityError Calling the frameRate property of a AVMAwayStage object throws an exception for
             *   any caller that is not in the same security sandbox as the AVMAwayStage owner (the main SWF file).
             *   To avoid this, the AVMAwayStage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                return this._frameRate;
            },
            set: function (value) {
                this._frameRate = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "fullScreenHeight", {
            /**
             * Returns the height of the monitor that will be used when going to full screen size, if that state
             * is entered immediately. If the user has multiple monitors, the monitor that's used is the
             * monitor that most of the stage is on at the time.
             *
             *   Note: If the user has the opportunity to move the browser from one
             * monitor to another between retrieving the value and going to full screen
             * size, the value could be incorrect. If you retrieve the value in an event handler that
             * sets AVMAwayStage.displayState to StageDisplayState.FULL_SCREEN, the value will be
             * correct.This is the pixel height of the monitor and is the same as the
             * stage height would be if AVMAwayStage.align is set to StageAlign.TOP_LEFT
             * and AVMAwayStage.scaleMode is set to StageScaleMode.NO_SCALE.
             */
            get: function () {
                //todo
                console.log("fullScreenHeight not implemented yet in flash/AVMAwayStage");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "fullScreenSourceRect", {
            /**
             * Sets the Flash runtime to scale a specific region of the stage to full-screen mode.
             * If available, the Flash runtime scales in hardware, which uses the graphics and video card on a user's computer,
             * and generally displays content more quickly than software scaling.
             *
             *   When this property is set to a valid rectangle and the displayState property is set to full-screen mode,
             * the Flash runtime scales the specified area. The actual AVMAwayStage size in pixels within ActionScript does not change.
             * The Flash runtime enforces a minimum limit for the size of the rectangle to accommodate the standard "Press Esc to exit full-screen mode" message.
             * This limit is usually around 260 by 30 pixels but can vary on platform and Flash runtime version.This property can only be set when the Flash runtime is not in full-screen mode.
             * To use this property correctly, set this property first, then set the displayState property to full-screen mode, as shown in the code examples.To enable scaling, set the fullScreenSourceRect property to a rectangle object:
             * <codeblock>
             *
             *   // valid, will enable hardware scaling
             * stage.fullScreenSourceRect = new Rectangle(0,0,320,240);
             *
             *   </codeblock>
             * To disable scaling, set the fullScreenSourceRect=null in ActionScript 3.0, and undefined in ActionScript 2.0.
             * <codeblock>
             *
             *   stage.fullScreenSourceRect = null;
             *
             *   </codeblock>
             * The end user also can select within Flash Player Display Settings to turn off hardware scaling, which is enabled by default.
             * For more information, see www.adobe.com/go/display_settings.
             */
            get: function () {
                //todo
                console.log("fullScreenSourceRect not implemented yet in flash/AVMAwayStage");
                return null;
            },
            set: function (Rectangle$$1) {
                //todo
                console.log("fullScreenSourceRect not implemented yet in flash/AVMAwayStage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "fullScreenWidth", {
            /**
             * Returns the width of the monitor that will be used when going to full screen size, if that state
             * is entered immediately. If the user has multiple monitors, the monitor that's used is the
             * monitor that most of the stage is on at the time.
             *
             *   Note: If the user has the opportunity to move the browser from one
             * monitor to another between retrieving the value and going to full screen
             * size, the value could be incorrect. If you retrieve the value in an event handler that
             * sets AVMAwayStage.displayState to StageDisplayState.FULL_SCREEN, the value will be
             * correct.This is the pixel width of the monitor and is the same as the stage width would be if
             * AVMAwayStage.align is set to StageAlign.TOP_LEFT and
             * AVMAwayStage.scaleMode is set to StageScaleMode.NO_SCALE.
             */
            get: function () {
                //todo
                console.log("fullScreenWidth not implemented yet in flash/AVMAwayStage");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "mouseLock", {
            get: function () {
                //todo
                console.log("mouseLock not implemented yet in flash/AVMAwayStage");
                return false;
            },
            set: function (value) {
                //todo
                console.log("mouseLock not implemented yet in flash/AVMAwayStage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "quality", {
            /**
             * A value from the StageQuality class that specifies which rendering quality is used.
             * The following are valid values:
             *
             *   StageQuality.LOW—Low rendering quality. Graphics are not
             * anti-aliased, and bitmaps are not smoothed, but runtimes still use mip-mapping.StageQuality.MEDIUM—Medium rendering quality. Graphics are
             * anti-aliased using a 2 x 2 pixel grid, bitmap smoothing is dependent on the Bitmap.smoothing setting.
             * Runtimes use mip-mapping. This setting is suitable for movies that do not contain text.StageQuality.HIGH—High rendering quality. Graphics are anti-aliased
             * using a 4 x 4 pixel grid, and bitmap smoothing is dependent on the Bitmap.smoothing setting.
             * Runtimes use mip-mapping. This is the default rendering quality setting that Flash Player uses.StageQuality.BEST—Very high rendering quality. Graphics are
             * anti-aliased using a 4 x 4 pixel grid. If Bitmap.smoothing is true the runtime uses a high quality
             * downscale algorithm that produces fewer artifacts (however, using StageQuality.BEST with Bitmap.smoothing set to true
             * slows performance significantly and is not a recommended setting).Higher quality settings produce better rendering of scaled bitmaps. However, higher
             * quality settings are computationally more expensive. In particular, when rendering scaled video,
             * using higher quality settings can reduce the frame rate.
             * In the desktop profile of Adobe AIR, quality can be set
             * to StageQuality.BEST or StageQuality.HIGH (and the default value
             * is StageQuality.HIGH). Attempting to set it to another value has no effect
             * (and the property remains unchanged). In the moble profile of AIR, all four quality settings
             * are available. The default value on mobile devices is StageQuality.MEDIUM.For content running in Adobe AIR, setting the quality property of one AVMAwayStage
             * object changes the rendering quality for all AVMAwayStage objects (used by different NativeWindow objects).
             * Note: The operating system draws the device fonts,
             * which are therefore unaffected by the quality property.
             * @throws	SecurityError Calling the quality property of a AVMAwayStage object throws an exception for
             *   any caller that is not in the same security sandbox as the AVMAwayStage owner (the main SWF file).
             *   To avoid this, the AVMAwayStage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                //todo
                console.log("quality not implemented yet in flash/AVMAwayStage");
                return "";
            },
            set: function (value) {
                //todo
                console.log("quality not implemented yet in flash/AVMAwayStage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "showDefaultContextMenu", {
            /**
             * A value from the StageScaleMode class that specifies which scale mode to use.
             * The following are valid values:
             *
             *   StageScaleMode.EXACT_FIT—The entire application is visible
             * in the specified area without trying to preserve the original aspect ratio. Distortion can occur, and the application may appear stretched or compressed.
             * StageScaleMode.SHOW_ALL—The entire application is visible
             * in the specified area without distortion while maintaining the original aspect ratio of the application.
             * Borders can appear on two sides of the application.
             * StageScaleMode.NO_BORDER—The entire application fills the specified area,
             * without distortion but possibly with some cropping, while maintaining the original aspect ratio
             * of the application.
             * StageScaleMode.NO_SCALE—The entire application is fixed, so that
             * it remains unchanged even as the size of the player window changes. Cropping might
             * occur if the player window is smaller than the content.
             * @throws	SecurityError Calling the scaleMode property of a AVMAwayStage object throws an exception for
             *   any caller that is not in the same security sandbox as the AVMAwayStage owner (the main SWF file).
             *   To avoid this, the AVMAwayStage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            /**
             * Specifies whether to show or hide the default items in the Flash runtime
             * context menu.
             *
             *   If the showDefaultContextMenu property is set to true (the
             * default), all context menu items appear. If the showDefaultContextMenu property
             * is set to false, only the Settings and About... menu items appear.
             * @throws	SecurityError Calling the showDefaultContextMenu property of a AVMAwayStage object throws an exception for
             *   any caller that is not in the same security sandbox as the AVMAwayStage owner (the main SWF file).
             *   To avoid this, the AVMAwayStage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                //todo
                release$1 || console.log("showDefaultContextMenu not implemented yet in flash/AVMAwayStage");
                return false;
            },
            set: function (value) {
                //todo
                release$1 || console.log("showDefaultContextMenu not implemented yet in flash/AVMAwayStage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "softKeyboardRect", {
            /**
             * The area of the stage that is currently covered by the software keyboard.
             *
             *   The area has a size of zero (0,0,0,0) when the soft keyboard is not visible.When the keyboard opens, the softKeyboardRect is set at the time the
             * softKeyboardActivate event is dispatched. If the keyboard changes size while open,
             * the runtime updates the softKeyboardRect property and dispatches an
             * additional softKeyboardActivate event.Note: On Android, the area covered by the keyboard is estimated when
             * the operating system does not provide the information necessary to determine the exact
             * area. This problem occurs in fullscreen mode and also when the keyboard opens in response to
             * an InteractiveObject receiving focus or invoking the requestSoftKeyboard() method.
             */
            get: function () {
                //todo
                console.log("softKeyboardRect not implemented yet in flash/AVMAwayStage");
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "stage3Ds", {
            get: function () {
                // todo: any is stage3d
                console.log("stage3Ds not implemented yet in flash/AVMAwayStage");
                return this._stage3Ds;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "stageFocusRect", {
            /**
             * Specifies whether or not objects display a glowing border when they have focus.
             * @throws	SecurityError Calling the stageFocusRect property of a AVMAwayStage object throws an exception for
             *   any caller that is not in the same security sandbox as the AVMAwayStage owner (the main SWF file).
             *   To avoid this, the AVMAwayStage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                //todo
                console.log("stageFocusRect not implemented yet in flash/AVMAwayStage");
                return false;
            },
            set: function (on) {
                //todo
                console.log("stageFocusRect not implemented yet in flash/AVMAwayStage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "stageHeight", {
            /**
             * The current height, in pixels, of the AVMAwayStage.
             *
             *   If the value of the AVMAwayStage.scaleMode property is set to StageScaleMode.NO_SCALE
             * when the user resizes the window, the AVMAwayStage content maintains its size while the
             * stageHeight property changes to reflect the new height size of the screen area occupied by
             * the SWF file. (In the other scale modes, the stageHeight property always reflects the original
             * height of the SWF file.) You can add an event listener for the resize event and then use the
             * stageHeight property of the AVMAwayStage class to determine the actual pixel dimension of the resized
             * Flash runtime window. The event listener allows you to control how
             * the screen content adjusts when the user resizes the window.Air for TV devices have slightly different behavior than desktop devices
             * when you set the stageHeight property.
             * If the AVMAwayStage.scaleMode
             * property is set to StageScaleMode.NO_SCALE and you set the stageHeight
             * property, the stage height does not change until the next
             * frame of the SWF.Note: In an HTML page hosting the SWF file, both the object and embed tags' height attributes must be set to a percentage (such as 100%), not pixels. If the
             * settings are generated by JavaScript code, the height parameter of the AC_FL_RunContent()
             * method must be set to a percentage, too. This percentage is applied to the stageHeight
             * value.
             * @throws	SecurityError Calling the stageHeight property of a AVMAwayStage object throws an exception for
             *   any caller that is not in the same security sandbox as the AVMAwayStage owner (the main SWF file).
             *   To avoid this, the AVMAwayStage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                return this._stageHeight;
            },
            set: function (value) {
                this._stageHeight = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "stageVideos", {
            /**
             * A list of StageVideo objects available for playing external videos.
             *
             *   You can use only a limited number of StageVideo objects at a time.
             * When a SWF begins to run, the number of available StageVideo objects depends on the platform
             * and on available hardware.
             * To use a StageVideo object, assign a member of the stageVideos Vector object to a StageVideo variable.
             * All StageVideo objects are displayed on the stage behind any display objects.
             * The StageVideo objects are displayed on the stage in the order they appear in
             * the stageVideos Vector object. For example, if the stageVideos Vector object contains
             * three entries:The StageVideo object in the 0 index of the stageVideos Vector object is
             * displayed behind all StageVideo objects.The StageVideo object at index 1 is displayed in front
             * of the StageVideo object at index 0.The StageVideo object at index 2 is displayed in front
             * of the StageVideo object at index 1.Use the StageVideo.depth property to change this ordering.Note: AIR for TV devices support only one StageVideo object.
             */
            get: function () {
                //todo: any is StageVideo
                console.log("stageVideos not implemented yet in flash/AVMAwayStage");
                return [];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "stageWidth", {
            /**
             * Specifies the current width, in pixels, of the AVMAwayStage.
             *
             *   If the value of the AVMAwayStage.scaleMode property is set to StageScaleMode.NO_SCALE
             * when the user resizes the window, the AVMAwayStage content maintains its defined size while the stageWidth
             * property changes to reflect the new width size of the screen area occupied by the SWF file. (In the other scale
             * modes, the stageWidth property always reflects the original width of the SWF file.) You can add an event
             * listener for the resize event and then use the stageWidth property of the AVMAwayStage class to
             * determine the actual pixel dimension of the resized Flash runtime window. The event listener allows you to control how
             * the screen content adjusts when the user resizes the window.Air for TV devices have slightly different behavior than desktop devices
             * when you set the stageWidth property.
             * If the AVMAwayStage.scaleMode
             * property is set to StageScaleMode.NO_SCALE and you set the stageWidth
             * property, the stage width does not change until the next
             * frame of the SWF.Note: In an HTML page hosting the SWF file, both the object and embed tags' width attributes must be set to a percentage (such as 100%), not pixels. If the
             * settings are generated by JavaScript code, the width parameter of the AC_FL_RunContent()
             * method must be set to a percentage, too. This percentage is applied to the stageWidth
             * value.
             * @throws	SecurityError Calling the stageWidth property of a AVMAwayStage object throws an exception for
             *   any caller that is not in the same security sandbox as the AVMAwayStage owner (the main SWF file).
             *   To avoid this, the AVMAwayStage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                return this._stageWidth;
            },
            set: function (value) {
                this._stageWidth = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "tabChildren", {
            /**
             * Determines whether the children of the object are tab enabled. Enables or disables tabbing for the
             * children of the object. The default is true.
             * Note: Do not use the tabChildren property with Flex.
             * Instead, use the mx.core.UIComponent.hasFocusableChildren property.
             * @throws	SecurityError Referencing the tabChildren property of a AVMAwayStage object throws an exception for
             *   any caller that is not in the same security sandbox as the AVMAwayStage owner (the main SWF file).
             *   To avoid this, the AVMAwayStage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                //todo
                console.log("tabChildren not implemented yet in flash/AVMAwayStage");
                return false;
            },
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "textSnapshot", {
            /**
             * Returns a TextSnapshot object for this DisplayObjectContainer instance.
             * @throws	IllegalOperationError Referencing the textSnapshot property of a AVMAwayStage object throws an
             *   exception because the AVMAwayStage class does not implement this property. To avoid this, call the
             *   textSnapshot property of a display object container other than the AVMAwayStage object.
             */
            get: function () {
                //todo
                console.log("textSnapshot not implemented yet in flash/AVMAwayStage");
                //todo: any is flash.text.TextSnapshot
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "wmodeGPU", {
            /**
             * Indicates whether GPU compositing is available and in use. The wmodeGPU value is trueonly
             * when all three of the following conditions exist:
             * GPU compositing has been requested.GPU compositing is available.GPU compositing is in use.Specifically, the wmodeGPU property indicates one of the following:GPU compositing has not been requested or is unavailable. In this case, the wmodeGPU property value is false.GPU compositing has been requested (if applicable and available), but the environment is operating in "fallback mode"
             * (not optimal rendering) due to limitations of the content. In this case, the wmodeGPU property value is true.GPU compositing has been requested (if applicable and available), and the environment is operating in the best mode. In this case, the
             * wmodeGPU property value is also true.In other words, the wmodeGPU property identifies the capability and state of the rendering environment. For runtimes
             * that do not support GPU compositing, such as AIR 1.5.2, the value is always false, because (as stated above) the value is
             * true only when GPU compositing has been requested, is available, and is in use.The wmodeGPU property is useful to determine, at runtime, whether or not GPU compositing is in use. The value of
             * wmodeGPU indicates if your content is going to be scaled by hardware, or not, so you can present graphics at the correct size.
             * You can also determine if you're rendering in a fast path or not, so that you can adjust your content complexity accordingly.For Flash Player in a browser, GPU compositing can be requested by the value of gpu for the wmode HTML
             * parameter in the page hosting the SWF file. For other configurations, GPU compositing can be requested in the header of a SWF file
             * (set using SWF authoring tools).However, the wmodeGPU property does not identify the current rendering performance. Even if GPU compositing is "in use" the rendering
             * process might not be operating in the best mode. To adjust your content for optimal rendering, use a Flash runtime debugger version,
             * and set the DisplayGPUBlendsetting in your mm.cfg file.Note: This property is always false when referenced
             * from ActionScript that runs before the runtime performs its first rendering
             * pass.  For example, if you examine wmodeGPU from a script in Frame 1 of
             * Adobe Flash Professional, and your SWF file is the first SWF file loaded in a new
             * instance of the runtime, then the wmodeGPU value is false.
             * To get an accurate value, wait until at least one rendering pass
             * has occurred. If you write an event listener for the
             * exitFrame event of any DisplayObject, the wmodeGPU value at
             * is the correct value.
             */
            get: function () {
                //todo
                console.log("wmodeGPU not implemented yet in flash/AVMAwayStage");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "accessibilityProperties", {
            //empty functions to prevent inherited actions
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "alpha", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "blendMode", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "cacheAsBitmap", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "contextMenu", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "filters", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "focusRect", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "loaderInfo", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "mask", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "opaqueBackground", {
            //public set mouseEnabled (value:boolean){};
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "name", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "rotation", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "rotationX", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "rotationY", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "rotationZ", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "scale9Grid", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "scrollRect", {
            /*
            public set scaleX (value:number){};
            public set scaleY (value:number){};
            public set scaleZ (value:number){};
            */
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "tabEnabled", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "tabIndex", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "visible", {
            //public set transform (value:Transform){};
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "x", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "y", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AVMAwayStage.prototype, "z", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        /**
         * Calling the invalidate() method signals Flash runtimes to alert display objects
         * on the next opportunity it has to render the display list (for example, when the playhead
         * advances to a new frame). After you call the invalidate() method, when the display
         * list is next rendered, the Flash runtime sends a render event to each display object that has
         * registered to listen for the render event. You must call the invalidate()
         * method each time you want the Flash runtime to send render events.
         *
         *   The render event gives you an opportunity to make changes to the display list
         * immediately before it is actually rendered. This lets you defer updates to the display list until the
         * latest opportunity. This can increase performance by eliminating unnecessary screen updates.The render event is dispatched only to display objects that are in the same
         * security domain as the code that calls the stage.invalidate() method,
         * or to display objects from a security domain that has been granted permission via the
         * Security.allowDomain() method.
         */
        AVMAwayStage.prototype.invalidate = function () {
            //todo
            //console.log("invalidate not implemented yet in flash/AVMAwayStage");
        };
        /**
         * Determines whether the AVMAwayStage.focus property returns null for
         * security reasons.
         * In other words, isFocusInaccessible returns true if the
         * object that has focus belongs to a security sandbox to which the SWF file does not have access.
         * @return	true if the object that has focus belongs to a security sandbox to which
         *   the SWF file does not have access.
         */
        AVMAwayStage.prototype.isFocusInaccessible = function () {
            //todo
            console.log("isFocusInaccessible not implemented yet in flash/AVMAwayStage");
            return false;
        };
        AVMAwayStage.prototype.dispose = function () {
            if (this._scene && this._scene.renderer && this._scene.renderer.view && this._scene.renderer && this._scene.renderer.stage && this._scene.renderer.stage.container)
                MouseManager.getInstance(PickGroup.getInstance(this._scene.renderer.view)).unregisterContainer(this._scene.renderer.stage.container);
            if (this._scene)
                this._scene.dispose();
            this._scene = null;
            AVMAwayStage._colorMaterials = {};
            AVMAwayStage._textureMaterials = {};
            PickGroup.clearAllInstances();
            TextureAtlas.clearAllMaterials();
            this._timer.stop();
            var len = this._layers.length;
            //this.runAVM1Framescripts();
            var myLayer;
            var numChilds;
            var child;
            for (var i = 0; i < len; i++) {
                myLayer = this._layers[i];
                numChilds = myLayer.numChildren;
                for (var c = 0; c < numChilds; ++c) {
                    child = myLayer.getChildAt(c);
                    child.dispose();
                }
            }
            this._layers.length = 0;
            AVM1TextField.allTextfields = {};
            MovieClip.clearPool();
            TextField.clearPool();
            Sprite.clearPool();
            Graphics.clearPool();
            Shape.clearPool();
        };
        AVMAwayStage._colorMaterials = {};
        AVMAwayStage._textureMaterials = {};
        AVMAwayStage._useTextureAtlasForColors = true;
        return AVMAwayStage;
    }(Sprite));

    var AVM1SceneGraphFactory = /** @class */ (function (_super) {
        __extends(AVM1SceneGraphFactory, _super);
        function AVM1SceneGraphFactory(avm1Context) {
            var _this = _super.call(this) || this;
            _this.imageStore = {};
            _this.avm1Context = avm1Context;
            AVM1SceneGraphFactory._instance = _this;
            return _this;
        }
        Object.defineProperty(AVM1SceneGraphFactory, "instance", {
            get: function () {
                if (!AVM1SceneGraphFactory._instance) {
                    console.log("Error. A instance of AVM1SceneGraphFactory must be created manually before accessing the singleton AVM1SceneGraphFactory._instance");
                    //AVM1SceneGraphFactory._instance=new AVM1SceneGraphFactory();
                }
                return AVM1SceneGraphFactory._instance;
            },
            enumerable: true,
            configurable: true
        });
        AVM1SceneGraphFactory.prototype.createSprite = function (prefab) {
            if (prefab === void 0) { prefab = null; }
            return new Sprite();
        };
        AVM1SceneGraphFactory.prototype.createDisplayObjectContainer = function () {
            return new DisplayObjectContainer();
        };
        AVM1SceneGraphFactory.prototype.createMovieClip = function (timeline, symbol) {
            if (timeline === void 0) { timeline = null; }
            if (symbol === void 0) { symbol = null; }
            //var avm1MovieClip:AVM1MovieClip=<AVM1MovieClip>AVM1MovieClip.createAVM1Class(this.avm1Context)._ownProperties["prototype"].value;
            var awayMovieClip = new MovieClip(timeline || new Timeline());
            awayMovieClip.timelineMC = true;
            if (symbol.isButton) {
                var avm1Button = getAVM1Object(awayMovieClip, this.avm1Context);
            }
            else {
                var avm1MovieClip = getAVM1Object(awayMovieClip, this.avm1Context);
            }
            return awayMovieClip;
            /*
            for(let key in timeline.avm1InitActions){
                console.log("\n\nfound init actions\n\n", timeline.avm1InitActions[key]);
                //this._addAvm1InitActionBlocks(frameIndex, initActionBlocks);
            }
            for(let key in timeline.avm1Exports){
                console.log("\n\nfound export\n\n", timeline.avm1Exports[key]);
                for(let i:number=0; i<timeline.avm1Exports[key].length; i++){
                    let asset=timeline.avm1Exports[key][i];
                    //this.avm1Context.addAsset(asset.className, asset.symbolId, null);
                }
                //this._addAvm1InitActionBlocks(frameIndex, initActionBlocks);
            }
            */
            /*
            
                        if(frames[i].initActionBlocks){
                            awayTimeline.avm1InitActions[i]=frames[i].initActionBlocks;
                        }
                        if(frames[i].exports){
                            awayTimeline.avm1Exports[i]=frames[i].exports;
                        }
                    if (frameInfo.exports) {
                        var exports = frameInfo.exports;
                        for (var i = 0; i < exports.length; i++) {
                            var asset = exports[i];
                            avm1Context.addAsset(asset.className, asset.symbolId, null);
                        }
                    }
            
                    var initActionBlocks = frameInfo.initActionBlocks;
                    if (initActionBlocks) {
                        this._addAvm1InitActionBlocks(frameIndex, initActionBlocks);
                    }*/
            //return awayMovieClip;
        };
        AVM1SceneGraphFactory.prototype.createTextField = function () {
            var awayTextfield = new TextField();
            awayTextfield.multiline = true;
            awayTextfield.wordWrap = true;
            var avm1textField = getAVM1Object(awayTextfield, this.avm1Context);
            return awayTextfield;
        };
        AVM1SceneGraphFactory.prototype.createBillboard = function (material) {
            return null; //new Billboard();
        };
        AVM1SceneGraphFactory.prototype.createImage2D = function (width, height, transparent, fillColor, powerOfTwo) {
            if (transparent === void 0) { transparent = true; }
            if (fillColor === void 0) { fillColor = null; }
            if (powerOfTwo === void 0) { powerOfTwo = true; }
            return new BitmapImage2D(width, height, transparent, fillColor, powerOfTwo);
        };
        return AVM1SceneGraphFactory;
    }(DefaultSceneGraphFactory));

    /*
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var avm1Options = shumwayOptions.register(new OptionSet("AVM1"));
    var avm1TraceEnabled = avm1Options.register(new Option("t1", "traceAvm1", "boolean", false, "trace AVM1 execution"));
    var avm1ErrorsEnabled = avm1Options.register(new Option("e1", "errorsAvm1", "boolean", false, "fail on AVM1 warnings and errors"));
    var avm1WarningsEnabled = avm1Options.register(new Option("w1", "warningsAvm1", "boolean", true, "Emit messages for AVM1 warnings and errors"));
    var avm1TimeoutDisabled = avm1Options.register(new Option("ha1", "nohangAvm1", "boolean", false, "disable fail on AVM1 hang"));
    var avm1CompilerEnabled = avm1Options.register(new Option("ca1", "compileAvm1", "boolean", true, "compiles AVM1 code"));
    var avm1DebuggerEnabled = avm1Options.register(new Option("da1", "debugAvm1", "boolean", false, "allows AVM1 code debugging"));
    var avm1WellknownActionsCompilationsEnabled = avm1Options.register(new Option("cw1", "wellknownAvm1", "boolean", true, "Replaces well-known actions patterns instead of compilation"));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    //import {WeakMap} from "es6-weak-map";
    //import {Map} from "es6-map";
    var AVM1ActionsData = /** @class */ (function () {
        function AVM1ActionsData(bytes, id, parent) {
            if (parent === void 0) { parent = null; }
            this.bytes = bytes;
            this.id = id;
            this.parent = parent;
            release$1 || assert$2(bytes instanceof Uint8Array);
            this.ir = null;
            this.compiled = null;
        }
        return AVM1ActionsData;
    }());
    var ActionsDataFactory = /** @class */ (function () {
        function ActionsDataFactory() {
            this._cache = new WeakMap();
        }
        ActionsDataFactory.prototype.createActionsData = function (bytes, id, parent) {
            if (parent === void 0) { parent = null; }
            var actionsData = this._cache.get(bytes);
            if (!actionsData) {
                actionsData = new AVM1ActionsData(bytes, id, parent);
                this._cache.set(bytes, actionsData);
            }
            release$1 || assert$2(actionsData.bytes === bytes && actionsData.id === id && actionsData.parent === parent);
            return actionsData;
        };
        return ActionsDataFactory;
    }());
    var AVM1Context = /** @class */ (function () {
        function AVM1Context(swfVersion) {
            this.swfVersion = swfVersion;
            this.globals = null;
            this.actionsDataFactory = new ActionsDataFactory();
            if (swfVersion > 6) {
                this.isPropertyCaseSensitive = true;
                this.normalizeName = this.normalizeNameCaseSensitive;
            }
            else {
                this.isPropertyCaseSensitive = false;
                this._nameCache = Object.create(null);
                this.normalizeName = this.normalizeNameCaseInsensitive;
            }
            this.builtins = {};
            installBuiltins(this);
            this.eventObservers = Object.create(null);
            this.assets = {};
            this.assetsSymbols = [];
            this.assetsClasses = [];
            this.awayAssets = {};
            this.staticStates = new WeakMap();
        }
        AVM1Context.prototype.resolveTarget = function (target) { };
        AVM1Context.prototype.resolveRoot = function () { };
        AVM1Context.prototype.checkTimeout = function () { };
        AVM1Context.prototype.executeActions = function (actionsData, scopeObj) { };
        AVM1Context.prototype.executeFunction = function (fn, thisArg, args) { };
        AVM1Context.prototype.normalizeNameCaseSensitive = function (name) {
            switch (typeof name) {
                case 'number':
                case 'string':
                    return name;
                default:
                    return alToString(this, name);
            }
        };
        AVM1Context.prototype.normalizeNameCaseInsensitive = function (name) {
            switch (typeof name) {
                case 'number':
                    return name.toString();
                case 'string':
                    break;
                default:
                    name = alToString(this, name);
            }
            var normalizedName = this._nameCache[name];
            if (normalizedName) {
                return normalizedName;
            }
            normalizedName = name.toLowerCase();
            this._nameCache[name] = normalizedName;
            return normalizedName;
        };
        AVM1Context.prototype._getEventPropertyObservers = function (propertyName, create) {
            if (!this.isPropertyCaseSensitive) {
                propertyName = propertyName.toLowerCase();
            }
            var observers = this.eventObservers[propertyName];
            if (observers) {
                return observers;
            }
            if (create) {
                observers = [];
                this.eventObservers[propertyName] = observers;
                return observers;
            }
            return null;
        };
        AVM1Context.prototype.registerEventPropertyObserver = function (propertyName, observer) {
            var observers = this._getEventPropertyObservers(propertyName, true);
            observers.push(observer);
        };
        AVM1Context.prototype.unregisterEventPropertyObserver = function (propertyName, observer) {
            var observers = this._getEventPropertyObservers(propertyName, false);
            if (!observers) {
                return;
            }
            var j = observers.indexOf(observer);
            if (j < 0) {
                return;
            }
            observers.splice(j, 1);
        };
        AVM1Context.prototype.broadcastEventPropertyChange = function (propertyName) {
            var observers = this._getEventPropertyObservers(propertyName, false);
            if (!observers) {
                return;
            }
            observers.forEach(function (observer) { return observer.onEventPropertyModified(propertyName); });
        };
        AVM1Context.prototype.addAsset = function (className, symbolId, symbolProps) {
            //console.log("addAsset", className, symbolId, symbolProps);
            release$1 || Debug$1.assert(typeof className === 'string' && !isNaN(symbolId));
            this.assets[className.toLowerCase()] = symbolId;
            this.assetsSymbols[symbolId] = symbolProps;
            //80pro: directly store assets in dictionary
            this.awayAssets[className.toLowerCase()] = symbolProps;
        };
        AVM1Context.prototype.registerClass = function (className, theClass) {
            className = alCoerceString(this, className);
            if (className === null) {
                this.utils.warn('Cannot register class for symbol: className is missing');
                return null;
            }
            var myAsset = AssetLibrary.getAsset(className, AVM1MovieClip.currentMCAssetNameSpace);
            if (!myAsset.adaptee) {
                console.warn("can not find symbol to register class " + className);
                return;
            }
            console.log("register", myAsset.adaptee.name, myAsset.adaptee.id);
            myAsset.adaptee.avm1Symbol = theClass;
            /*
            var symbolId = this.assets[className.toLowerCase()];
            if (symbolId === undefined) {
                this.utils.warn('Cannot register ' + className + ' class for symbol');
                return;
            }
            this.assetsClasses[symbolId] = theClass;*/
        };
        AVM1Context.prototype.getSymbolClass = function (symbolId) {
            return this.assetsClasses[symbolId] || null;
        };
        AVM1Context.prototype.getAsset = function (className) {
            className = alCoerceString(this, className);
            if (className === null) {
                return undefined;
            }
            var symbolId = this.assets[className.toLowerCase()];
            if (symbolId === undefined) {
                return undefined;
            }
            var symbol = this.awayAssets[className.toLowerCase()];
            if (!symbol) {
                console.log("error in getAsset. not implemented to grab assets from loaderInfo");
                /*symbol = this.loaderInfo.getSymbolById(symbolId);
                if (!symbol) {
                    Debug.warning("Symbol " + symbolId + " is not defined.");
                    return undefined;
                }
                this.assetsSymbols[symbolId] = symbol;*/
            }
            return {
                symbolId: symbolId,
                symbolProps: symbol
            };
        };
        AVM1Context.prototype.reset = function () {
            this.eventObservers = Object.create(null);
            this.assets = {};
            this.assetsSymbols = [];
            this.assetsClasses = [];
            this.awayAssets = {};
            this.staticStates = new WeakMap();
            /*
            function removescripts(){
                var allsuspects=document.getElementsByTagName("script")
                for (var i=allsuspects.length; i>=0; i--){ //search backwards within nodelist for matching elements to remove
                    if (allsuspects[i] && allsuspects[i].getAttribute("src")!=null){
                        console.log(allsuspects[i].getAttribute("src"));
                        //allsuspects[i].parentNode.removeChild(allsuspects[i]) //remove element by calling parentNode.removeChild()
                    }
                }
            }
             
            removescripts();
            var len=ActionsDataCompiler.allScripts.length;
            for(var i=0; i<len; i++){
                delete ActionsDataCompiler.allScripts[i];
            }
            ActionsDataCompiler.allScripts.length=0;*/
            AVM1Stage.bindStage(this, this.globals.Stage, null, null);
        };
        AVM1Context.prototype.setStage = function (stage, htmlElement) {
            AVM1Key.bindStage(this, this.globals.Key, stage, htmlElement);
            AVM1Mouse.bindStage(this, this.globals.Mouse, stage, htmlElement);
            AVM1Stage.bindStage(this, this.globals.Stage, stage, htmlElement);
        };
        AVM1Context.prototype.getStaticState = function (cls) {
            var state = this.staticStates.get(cls);
            if (!state) {
                state = Object.create(null);
                var initStatic = cls.alInitStatic;
                if (initStatic) {
                    initStatic.call(state, this);
                }
                this.staticStates.set(cls, state);
            }
            return state;
        };
        AVM1Context.prototype.resolveLevel = function (level) {
            release$1 || Debug$1.assert(typeof level === 'number');
            var as3Root = null; //this.levelsContainer._getRootForLevel(level);
            if (!as3Root) {
                this.utils.warn('Unable to resolve level ' + level + ' root');
                return undefined;
            }
            return getAVM1Object(as3Root, this);
        };
        return AVM1Context;
    }());

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var ActionsDataAnalyzer = /** @class */ (function () {
        function ActionsDataAnalyzer() {
            this.parentResults = null;
            this.registersLimit = 0;
        }
        ActionsDataAnalyzer.prototype.analyze = function (parser) {
            var actions = [];
            var labels = [0];
            var processedLabels = [true];
            var constantPoolFound = false;
            var singleConstantPoolAt0 = null;
            // Parsing all actions we can reach. Every action will have next position
            // and conditional jump location.
            var queue = [0];
            var position;
            var action;
            var nextPosition;
            var item;
            var jumpPosition;
            var branching;
            var nonConditionalBranching;
            var skipCount;
            while (queue.length > 0) {
                position = queue.shift();
                if (actions[position]) {
                    continue;
                }
                parser.position = position;
                // reading block of actions until the first jump of end of actions
                while (!parser.eof && !actions[position]) {
                    action = parser.readNext();
                    if (action.actionCode === 0) {
                        break;
                    }
                    nextPosition = parser.position;
                    item = {
                        action: action,
                        next: nextPosition,
                        conditionalJumpTo: -1
                    };
                    jumpPosition = 0;
                    branching = false;
                    nonConditionalBranching = false;
                    switch (action.actionCode) {
                        case 138 /* ActionWaitForFrame */:
                        case 141 /* ActionWaitForFrame2 */:
                            branching = true;
                            // skip is specified in amount of actions (instead of bytes)
                            skipCount = action.actionCode === 138 /* ActionWaitForFrame */ ?
                                action.args[1] : action.args[0];
                            parser.skip(skipCount);
                            jumpPosition = parser.position;
                            parser.position = nextPosition;
                            break;
                        case 153 /* ActionJump */:
                            nonConditionalBranching = true;
                            branching = true;
                            jumpPosition = nextPosition + action.args[0];
                            break;
                        case 157 /* ActionIf */:
                            branching = true;
                            jumpPosition = nextPosition + action.args[0];
                            break;
                        case 42 /* ActionThrow */:
                        case 62 /* ActionReturn */:
                        case 0 /* None */:
                            nonConditionalBranching = true;
                            branching = true;
                            jumpPosition = parser.length;
                            break;
                        case 136 /* ActionConstantPool */:
                            if (constantPoolFound) {
                                singleConstantPoolAt0 = null; // reset if more than one found
                                break;
                            }
                            constantPoolFound = true;
                            if (position === 0) {
                                // For now only counting at position 0 of the block of actions
                                singleConstantPoolAt0 = action.args[0];
                            }
                            break;
                    }
                    if (branching) {
                        if (jumpPosition < 0 || jumpPosition > parser.length) {
                            release$1 || console.error('jump outside the action block;');
                            jumpPosition = parser.length;
                        }
                        if (nonConditionalBranching) {
                            item.next = jumpPosition;
                        }
                        else {
                            item.conditionalJumpTo = jumpPosition;
                        }
                        if (!processedLabels[jumpPosition]) {
                            labels.push(jumpPosition);
                            queue.push(jumpPosition);
                            processedLabels[jumpPosition] = true;
                        }
                    }
                    actions[position] = item;
                    if (nonConditionalBranching) {
                        break;
                    }
                    position = nextPosition;
                }
            }
            // Creating blocks for every unique label
            var blocks = [];
            var items;
            var lastPosition;
            var item;
            labels.forEach(function (position) {
                if (!actions[position]) {
                    return;
                }
                items = [];
                lastPosition = position;
                // continue grabbing items until other label or next code exist
                do {
                    item = actions[lastPosition];
                    items.push(item);
                    lastPosition = item.next;
                } while (!processedLabels[lastPosition] && actions[lastPosition]);
                blocks.push({
                    label: position,
                    items: items,
                    jump: lastPosition
                });
            });
            // Determines if action blocks (or defined function) is using the single
            // constants pool defined at the beginning of the action block.
            var singleConstantPool = null;
            if (constantPoolFound) {
                singleConstantPool = singleConstantPoolAt0;
            }
            else if (this.parentResults) {
                // Trying to use parent's constant pool if available.
                singleConstantPool = this.parentResults.singleConstantPool;
            }
            return {
                actions: actions,
                blocks: blocks,
                dataId: parser.dataId,
                singleConstantPool: singleConstantPool,
                registersLimit: this.registersLimit
            };
        };
        return ActionsDataAnalyzer;
    }());

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var ActionsDataStream = /** @class */ (function () {
        function ActionsDataStream(array, swfVersion) {
            this.array = array;
            this.position = 0;
            this.end = array.length;
            // TODO use system locale to determine if the shift-JIS
            // decoding is necessary
            this.readANSI = swfVersion < 6;
            // endianess sanity check
            var buffer = new ArrayBuffer(4);
            (new Int32Array(buffer))[0] = 1;
            if (!(new Uint8Array(buffer))[0]) {
                throw new Error("big-endian platform");
            }
        }
        ActionsDataStream.prototype.readUI8 = function () {
            return this.array[this.position++];
        };
        ActionsDataStream.prototype.readUI16 = function () {
            var position = this.position, array = this.array;
            var value = (array[position + 1] << 8) | array[position];
            this.position = position + 2;
            return value;
        };
        ActionsDataStream.prototype.readSI16 = function () {
            var position = this.position, array = this.array;
            var value = (array[position + 1] << 8) | array[position];
            this.position = position + 2;
            return value < 0x8000 ? value : (value - 0x10000);
        };
        ActionsDataStream.prototype.readInteger = function () {
            var position = this.position, array = this.array;
            var value = array[position] | (array[position + 1] << 8) |
                (array[position + 2] << 16) | (array[position + 3] << 24);
            this.position = position + 4;
            return value;
        };
        ActionsDataStream.prototype.readFloat = function () {
            var position = this.position;
            var array = this.array;
            var buffer = new ArrayBuffer(4);
            var bytes = new Uint8Array(buffer);
            bytes[0] = array[position];
            bytes[1] = array[position + 1];
            bytes[2] = array[position + 2];
            bytes[3] = array[position + 3];
            this.position = position + 4;
            return (new Float32Array(buffer))[0];
        };
        ActionsDataStream.prototype.readDouble = function () {
            var position = this.position;
            var array = this.array;
            var buffer = new ArrayBuffer(8);
            var bytes = new Uint8Array(buffer);
            bytes[4] = array[position];
            bytes[5] = array[position + 1];
            bytes[6] = array[position + 2];
            bytes[7] = array[position + 3];
            bytes[0] = array[position + 4];
            bytes[1] = array[position + 5];
            bytes[2] = array[position + 6];
            bytes[3] = array[position + 7];
            this.position = position + 8;
            return (new Float64Array(buffer))[0];
        };
        ActionsDataStream.prototype.readBoolean = function () {
            return !!this.readUI8();
        };
        ActionsDataStream.prototype.readANSIString = function () {
            var value = '';
            var ch;
            while ((ch = this.readUI8())) {
                value += String.fromCharCode(ch);
            }
            return value;
        };
        ActionsDataStream.prototype.readUTF8String = function () {
            var value = '';
            var ch;
            while ((ch = this.readUI8())) {
                if (ch < 0x80) {
                    value += String.fromCharCode(ch);
                    continue;
                }
                if ((ch & 0xC0) === 0x80) {
                    // Invalid UTF8 encoding: initial char -- using it as is
                    value += String.fromCharCode(ch);
                    continue;
                }
                var lastPosition = this.position - 1; // in case if we need to recover
                var currentPrefix = 0xC0;
                var validBits = 5;
                do {
                    var mask = (currentPrefix >> 1) | 0x80;
                    if ((ch & mask) === currentPrefix) {
                        break;
                    }
                    currentPrefix = mask;
                    --validBits;
                } while (validBits >= 0);
                var code = (ch & ((1 << validBits) - 1));
                for (var i = 5; i >= validBits; --i) {
                    ch = this.readUI8();
                    if ((ch & 0xC0) !== 0x80) {
                        // Invalid UTF8 encoding: bad chars in the tail, using previous chars as is
                        var skipToPosition = this.position - 1;
                        this.position = lastPosition;
                        while (this.position < skipToPosition) {
                            value += String.fromCharCode(this.readUI8());
                        }
                        continue;
                    }
                    code = (code << 6) | (ch & 0x3F);
                }
                if (code >= 0x10000) {
                    value += String.fromCharCode((((code - 0x10000) >> 10) & 0x3FF) |
                        0xD800, (code & 0x3FF) | 0xDC00);
                }
                else {
                    value += String.fromCharCode(code);
                }
            }
            return value;
        };
        ActionsDataStream.prototype.readString = function () {
            return this.readANSI ? this.readANSIString() : this.readUTF8String();
        };
        ActionsDataStream.prototype.readBytes = function (length) {
            var position = this.position;
            var remaining = Math.max(this.end - position, 0);
            if (remaining < length) {
                length = remaining;
            }
            var subarray = this.array.subarray(position, position + length);
            this.position = position + length;
            return subarray;
        };
        return ActionsDataStream;
    }());

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var ParsedPushRegisterAction = /** @class */ (function () {
        function ParsedPushRegisterAction(registerNumber) {
            this.registerNumber = registerNumber;
        }
        return ParsedPushRegisterAction;
    }());
    var ParsedPushConstantAction = /** @class */ (function () {
        function ParsedPushConstantAction(constantIndex) {
            this.constantIndex = constantIndex;
        }
        return ParsedPushConstantAction;
    }());
    var ActionsDataParser = /** @class */ (function () {
        function ActionsDataParser(actionsData, swfVersion) {
            this._actionsData = actionsData;
            this.dataId = actionsData.id;
            this._stream = new ActionsDataStream(actionsData.bytes, swfVersion);
        }
        Object.defineProperty(ActionsDataParser.prototype, "position", {
            get: function () {
                return this._stream.position;
            },
            set: function (value) {
                this._stream.position = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActionsDataParser.prototype, "eof", {
            get: function () {
                return this._stream.position >= this._stream.end;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ActionsDataParser.prototype, "length", {
            get: function () {
                return this._stream.end;
            },
            enumerable: true,
            configurable: true
        });
        ActionsDataParser.prototype.readNext = function () {
            var stream = this._stream;
            var currentPosition = stream.position;
            var actionCode = stream.readUI8();
            var length = actionCode >= 0x80 ? stream.readUI16() : 0;
            var nextPosition = stream.position + length;
            var args = null;
            switch (actionCode | 0) {
                case 129 /* ActionGotoFrame */:
                    var frame = stream.readUI16();
                    var nextActionCode = stream.readUI8();
                    var play = false;
                    if (nextActionCode !== 0x06 && nextActionCode !== 0x07) {
                        stream.position--;
                    }
                    else {
                        nextPosition++;
                        play = nextActionCode === 0x06;
                    }
                    args = [frame, play];
                    break;
                case 131 /* ActionGetURL */:
                    var urlString = stream.readString();
                    var targetString = stream.readString();
                    args = [urlString, targetString];
                    break;
                case 138 /* ActionWaitForFrame */:
                    var frame = stream.readUI16();
                    var count = stream.readUI8();
                    args = [frame, count];
                    break;
                case 139 /* ActionSetTarget */:
                    var targetName = stream.readString();
                    args = [targetName];
                    break;
                case 140 /* ActionGoToLabel */:
                    var label = stream.readString();
                    var nextActionCode = stream.readUI8();
                    var play = false;
                    if (nextActionCode !== 0x06 && nextActionCode !== 0x07) {
                        stream.position--;
                    }
                    else {
                        nextPosition++;
                        play = nextActionCode === 0x06;
                    }
                    args = [label, play];
                    break;
                case 150 /* ActionPush */:
                    var type, value;
                    args = [];
                    while (stream.position < nextPosition) {
                        type = stream.readUI8();
                        switch (type | 0) {
                            case 0: // STRING
                                value = stream.readString();
                                break;
                            case 1: // FLOAT
                                value = stream.readFloat();
                                break;
                            case 2: // null
                                value = null;
                                break;
                            case 3: // undefined
                                value = void (0);
                                break;
                            case 4: // Register number
                                value = new ParsedPushRegisterAction(stream.readUI8());
                                break;
                            case 5: // Boolean
                                value = stream.readBoolean();
                                break;
                            case 6: // Double
                                value = stream.readDouble();
                                break;
                            case 7: // Integer
                                value = stream.readInteger();
                                break;
                            case 8: // Constant8
                                value = new ParsedPushConstantAction(stream.readUI8());
                                break;
                            case 9: // Constant16
                                value = new ParsedPushConstantAction(stream.readUI16());
                                break;
                            default:
                                console.error('Unknown value type: ' + type);
                                stream.position = nextPosition;
                                continue;
                        }
                        args.push(value);
                    }
                    break;
                case 153 /* ActionJump */:
                    var offset = stream.readSI16();
                    args = [offset];
                    break;
                case 157 /* ActionIf */:
                    var offset = stream.readSI16();
                    args = [offset];
                    break;
                case 154 /* ActionGetURL2 */:
                    var flags = stream.readUI8();
                    args = [flags];
                    break;
                case 159 /* ActionGotoFrame2 */:
                    var flags = stream.readUI8();
                    args = [flags];
                    if (!!(flags & 2)) {
                        args.push(stream.readUI16());
                    }
                    break;
                case 141 /* ActionWaitForFrame2 */:
                    var count = stream.readUI8();
                    args = [count];
                    break;
                case 136 /* ActionConstantPool */:
                    var count = stream.readUI16();
                    var constantPool = [];
                    for (var i = 0; i < count; i++) {
                        constantPool.push(stream.readString());
                    }
                    args = [constantPool];
                    break;
                case 155 /* ActionDefineFunction */:
                    var functionName = stream.readString();
                    var count = stream.readUI16();
                    var functionParams = [];
                    for (var i = 0; i < count; i++) {
                        functionParams.push(stream.readString());
                    }
                    var codeSize = stream.readUI16();
                    nextPosition += codeSize;
                    var functionBody = new AVM1ActionsData(stream.readBytes(codeSize), this.dataId + '_f' + stream.position, this._actionsData);
                    args = [functionBody, functionName, functionParams];
                    break;
                case 148 /* ActionWith */:
                    var codeSize = stream.readUI16();
                    nextPosition += codeSize;
                    var withBody = new AVM1ActionsData(stream.readBytes(codeSize), this.dataId + '_w' + stream.position, this._actionsData);
                    args = [withBody];
                    break;
                case 135 /* ActionStoreRegister */:
                    var register = stream.readUI8();
                    args = [register];
                    break;
                case 142 /* ActionDefineFunction2 */:
                    var functionName = stream.readString();
                    var count = stream.readUI16();
                    var registerCount = stream.readUI8();
                    var flags = stream.readUI16();
                    var registerAllocation = [];
                    var functionParams = [];
                    for (var i = 0; i < count; i++) {
                        var register = stream.readUI8();
                        var paramName = stream.readString();
                        functionParams.push(paramName);
                        if (register) {
                            registerAllocation[register] = {
                                type: 1 /* Argument */,
                                name: paramName,
                                index: i
                            };
                        }
                    }
                    var j = 1;
                    // order this, arguments, super, _root, _parent, and _global
                    if (flags & 0x0001) { // preloadThis
                        registerAllocation[j++] = { type: 2 /* This */ };
                    }
                    if (flags & 0x0004) { // preloadArguments
                        registerAllocation[j++] = { type: 4 /* Arguments */ };
                    }
                    if (flags & 0x0010) { // preloadSuper
                        registerAllocation[j++] = { type: 8 /* Super */ };
                    }
                    if (flags & 0x0040) { // preloadRoot
                        registerAllocation[j++] = { type: 64 /* Root */ };
                    }
                    if (flags & 0x0080) { // preloadParent
                        registerAllocation[j++] = { type: 32 /* Parent */ };
                    }
                    if (flags & 0x0100) { // preloadGlobal
                        registerAllocation[j++] = { type: 16 /* Global */ };
                    }
                    var suppressArguments = 0;
                    if (flags & 0x0002) { // suppressThis
                        suppressArguments |= 2 /* This */;
                    }
                    if (flags & 0x0008) { // suppressArguments
                        suppressArguments |= 4 /* Arguments */;
                    }
                    if (flags & 0x0020) { // suppressSuper
                        suppressArguments |= 8 /* Super */;
                    }
                    var codeSize = stream.readUI16();
                    nextPosition += codeSize;
                    var functionBody = new AVM1ActionsData(stream.readBytes(codeSize), this.dataId + '_f' + stream.position, this._actionsData);
                    args = [functionBody, functionName, functionParams, registerCount,
                        registerAllocation, suppressArguments];
                    break;
                case 143 /* ActionTry */:
                    var flags = stream.readUI8();
                    var catchIsRegisterFlag = !!(flags & 4);
                    var finallyBlockFlag = !!(flags & 2);
                    var catchBlockFlag = !!(flags & 1);
                    var trySize = stream.readUI16();
                    var catchSize = stream.readUI16();
                    var finallySize = stream.readUI16();
                    var catchTarget = catchIsRegisterFlag ? stream.readUI8() : stream.readString();
                    nextPosition += trySize + catchSize + finallySize;
                    var tryBody = new AVM1ActionsData(stream.readBytes(trySize), this.dataId + '_t' + stream.position, this._actionsData);
                    var catchBody = new AVM1ActionsData(stream.readBytes(catchSize), this.dataId + '_c' + stream.position, this._actionsData);
                    var finallyBody = new AVM1ActionsData(stream.readBytes(finallySize), this.dataId + '_z' + stream.position, this._actionsData);
                    args = [catchIsRegisterFlag, catchTarget, tryBody,
                        catchBlockFlag, catchBody, finallyBlockFlag, finallyBody];
                    break;
                case 137 /* ActionStrictMode */:
                    var mode = stream.readUI8();
                    args = [mode];
                    break;
            }
            stream.position = nextPosition;
            return {
                position: currentPosition,
                actionCode: actionCode,
                actionName: ActionNamesMap[actionCode],
                args: args
            };
        };
        ActionsDataParser.prototype.skip = function (count) {
            var stream = this._stream;
            while (count > 0 && stream.position < stream.end) {
                var actionCode = stream.readUI8();
                var length = actionCode >= 0x80 ? stream.readUI16() : 0;
                stream.position += length;
                count--;
            }
        };
        return ActionsDataParser;
    }());
    var ActionNamesMap = {
        0x00: 'EOA',
        0x04: 'ActionNextFrame',
        0x05: 'ActionPreviousFrame',
        0x06: 'ActionPlay',
        0x07: 'ActionStop',
        0x08: 'ActionToggleQuality',
        0x09: 'ActionStopSounds',
        0x0A: 'ActionAdd',
        0x0B: 'ActionSubtract',
        0x0C: 'ActionMultiply',
        0x0D: 'ActionDivide',
        0x0E: 'ActionEquals',
        0x0F: 'ActionLess',
        0x10: 'ActionAnd',
        0x11: 'ActionOr',
        0x12: 'ActionNot',
        0x13: 'ActionStringEquals',
        0x14: 'ActionStringLength',
        0x15: 'ActionStringExtract',
        0x17: 'ActionPop',
        0x18: 'ActionToInteger',
        0x1C: 'ActionGetVariable',
        0x1D: 'ActionSetVariable',
        0x20: 'ActionSetTarget2',
        0x21: 'ActionStringAdd',
        0x22: 'ActionGetProperty',
        0x23: 'ActionSetProperty',
        0x24: 'ActionCloneSprite',
        0x25: 'ActionRemoveSprite',
        0x26: 'ActionTrace',
        0x27: 'ActionStartDrag',
        0x28: 'ActionEndDrag',
        0x29: 'ActionStringLess',
        0x2A: 'ActionThrow',
        0x2B: 'ActionCastOp',
        0x2C: 'ActionImplementsOp',
        0x2D: 'ActionFSCommand2',
        0x30: 'ActionRandomNumber',
        0x31: 'ActionMBStringLength',
        0x32: 'ActionCharToAscii',
        0x33: 'ActionAsciiToChar',
        0x34: 'ActionGetTime',
        0x35: 'ActionMBStringExtract',
        0x36: 'ActionMBCharToAscii',
        0x37: 'ActionMBAsciiToChar',
        0x3A: 'ActionDelete',
        0x3B: 'ActionDelete2',
        0x3C: 'ActionDefineLocal',
        0x3D: 'ActionCallFunction',
        0x3E: 'ActionReturn',
        0x3F: 'ActionModulo',
        0x40: 'ActionNewObject',
        0x41: 'ActionDefineLocal2',
        0x42: 'ActionInitArray',
        0x43: 'ActionInitObject',
        0x44: 'ActionTypeOf',
        0x45: 'ActionTargetPath',
        0x46: 'ActionEnumerate',
        0x47: 'ActionAdd2',
        0x48: 'ActionLess2',
        0x49: 'ActionEquals2',
        0x4A: 'ActionToNumber',
        0x4B: 'ActionToString',
        0x4C: 'ActionPushDuplicate',
        0x4D: 'ActionStackSwap',
        0x4E: 'ActionGetMember',
        0x4F: 'ActionSetMember',
        0x50: 'ActionIncrement',
        0x51: 'ActionDecrement',
        0x52: 'ActionCallMethod',
        0x53: 'ActionNewMethod',
        0x54: 'ActionInstanceOf',
        0x55: 'ActionEnumerate2',
        0x60: 'ActionBitAnd',
        0x61: 'ActionBitOr',
        0x62: 'ActionBitXor',
        0x63: 'ActionBitLShift',
        0x64: 'ActionBitRShift',
        0x65: 'ActionBitURShift',
        0x66: 'ActionStrictEquals',
        0x67: 'ActionGreater',
        0x68: 'ActionStringGreater',
        0x69: 'ActionExtends',
        0x81: 'ActionGotoFrame',
        0x83: 'ActionGetURL',
        0x87: 'ActionStoreRegister',
        0x88: 'ActionConstantPool',
        0x89: 'ActionStrictMode',
        0x8A: 'ActionWaitForFrame',
        0x8B: 'ActionSetTarget',
        0x8C: 'ActionGoToLabel',
        0x8D: 'ActionWaitForFrame2',
        0x8E: 'ActionDefineFunction2',
        0x8F: 'ActionTry',
        0x94: 'ActionWith',
        0x96: 'ActionPush',
        0x99: 'ActionJump',
        0x9A: 'ActionGetURL2',
        0x9B: 'ActionDefineFunction',
        0x9D: 'ActionIf',
        0x9E: 'ActionCall',
        0x9F: 'ActionGotoFrame2'
    };

    /*
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var cachedActionsCalls = null;
    function getActionsCalls() {
        if (!cachedActionsCalls) {
            cachedActionsCalls = generateActionCalls();
        }
        return cachedActionsCalls;
    }
    /**
     *  Bare-minimum JavaScript code generator to make debugging better.
     */
    var ActionsDataCompiler = /** @class */ (function () {
        function ActionsDataCompiler() {
        }
        ActionsDataCompiler.prototype.convertArgs = function (args, id, res, ir) {
            var parts = [];
            var arg;
            var argsLen = args.length;
            var constant;
            var hint;
            var currentConstantPool;
            var registerNumber;
            var resName;
            for (var i = 0; i < argsLen; i++) {
                arg = args[i];
                if (typeof arg === 'object' && arg !== null && !Array.isArray(arg)) {
                    if (arg instanceof ParsedPushConstantAction) {
                        if (ir.singleConstantPool) {
                            constant = ir.singleConstantPool[arg.constantIndex];
                            parts.push(constant === undefined ? 'undefined' : JSON.stringify(constant));
                        }
                        else {
                            hint = '';
                            currentConstantPool = res.constantPool;
                            if (currentConstantPool) {
                                constant = currentConstantPool[arg.constantIndex];
                                hint = constant === undefined ? 'undefined' : JSON.stringify(constant);
                                // preventing code breakage due to bad constant
                                hint = hint.indexOf('*/') >= 0 ? '' : ' /* ' + hint + ' */';
                            }
                            parts.push('constantPool[' + arg.constantIndex + ']' + hint);
                        }
                    }
                    else if (arg instanceof ParsedPushRegisterAction) {
                        registerNumber = arg.registerNumber;
                        if (registerNumber < 0 || registerNumber >= ir.registersLimit) {
                            parts.push('undefined'); // register is out of bounds -- undefined
                        }
                        else {
                            parts.push('registers[' + registerNumber + ']');
                        }
                    }
                    else if (arg instanceof AVM1ActionsData) {
                        resName = 'code_' + id + '_' + i;
                        res[resName] = arg;
                        parts.push('res.' + resName);
                    }
                    else {
                        notImplemented('Unknown AVM1 action argument type');
                    }
                }
                else if (arg === undefined) {
                    parts.push('undefined'); // special case
                }
                else {
                    parts.push(JSON.stringify(arg));
                }
            }
            return parts.join(',');
        };
        ActionsDataCompiler.prototype.convertAction = function (item, id, res, indexInBlock, ir) {
            switch (item.action.actionCode) {
                case 153 /* ActionJump */:
                case 62 /* ActionReturn */:
                    return '';
                case 136 /* ActionConstantPool */:
                    res.constantPool = item.action.args[0];
                    return '  constantPool = [' + this.convertArgs(item.action.args[0], id, res, ir) + '];\n' +
                        '  ectx.constantPool = constantPool;\n';
                case 150 /* ActionPush */:
                    return '  stack.push(' + this.convertArgs(item.action.args, id, res, ir) + ');\n';
                case 135 /* ActionStoreRegister */:
                    var registerNumber = item.action.args[0];
                    if (registerNumber < 0 || registerNumber >= ir.registersLimit) {
                        return ''; // register is out of bounds -- noop
                    }
                    return '  registers[' + registerNumber + '] = stack[stack.length - 1];\n';
                case 138 /* ActionWaitForFrame */:
                case 141 /* ActionWaitForFrame2 */:
                    return '  if (calls.' + item.action.actionName + '(ectx,[' +
                        this.convertArgs(item.action.args, id, res, ir) + '])) { position = ' + item.conditionalJumpTo + '; ' +
                        'checkTimeAfter -= ' + (indexInBlock + 1) + '; break; }\n';
                case 157 /* ActionIf */:
                    return '  if (!!stack.pop()) { position = ' + item.conditionalJumpTo + '; ' +
                        'checkTimeAfter -= ' + (indexInBlock + 1) + '; break; }\n';
                default:
                    var result = '  calls.' + item.action.actionName + '(ectx' +
                        (item.action.args ? ',[' + this.convertArgs(item.action.args, id, res, ir) + ']' : '') +
                        ');\n';
                    return result;
            }
        };
        ActionsDataCompiler.prototype.generate = function (ir) {
            var _this = this;
            var blocks = ir.blocks;
            var res = {};
            var uniqueId = 0;
            var debugName = ir.dataId;
            var fn = 'return function ' + debugName + '(ectx) {\n' +
                'var position = 0;\n' +
                'var checkTimeAfter = 0;\n' +
                'var constantPool = ectx.constantPool, registers = ectx.registers, stack = ectx.stack;\n';
            if (avm1DebuggerEnabled.value) {
                fn += '/* Running ' + debugName + ' */ ' +
                    'if (Shumway.AVM1.Debugger.pause || Shumway.AVM1.Debugger.breakpoints.' +
                    debugName + ') { debugger; }\n';
            }
            fn += 'while (!ectx.isEndOfActions) {\n' +
                'if (checkTimeAfter <= 0) { checkTimeAfter = ' + CHECK_AVM1_HANG_EVERY + '; ectx.context.checkTimeout(); }\n' +
                'switch(position) {\n';
            blocks.forEach(function (b) {
                fn += ' case ' + b.label + ':\n';
                b.items.forEach(function (item, index) {
                    fn += _this.convertAction(item, uniqueId++, res, index, ir);
                });
                fn += '  position = ' + b.jump + ';\n' +
                    '  checkTimeAfter -= ' + b.items.length + ';\n' +
                    '  break;\n';
            });
            fn += ' default: ectx.isEndOfActions = true; break;\n}\n}\n' +
                'return stack.pop();};';
            fn += '//# sourceURL=' + debugName;
            return (new Function('calls', 'res', fn))(getActionsCalls(), res);
        };
        return ActionsDataCompiler;
    }());

    var instance;
    var Telemetry = {
        instance: instance
    };

    var noVarGetDebug = true;
    var Debugger = {
        pause: false,
        breakpoints: {}
    };
    function avm1Warn(message, arg1, arg2, arg3, arg4) {
        if (avm1ErrorsEnabled.value) {
            try {
                throw new Error(message); // using throw as a way to break in browsers debugger
            }
            catch (e) { /* ignoring since handled */
            }
        }
        if (avm1WarningsEnabled.value) {
            Debug$1.warning.apply(console, arguments);
        }
    }
    var MAX_AVM1_HANG_TIMEOUT = 1000;
    var CHECK_AVM1_HANG_EVERY = 1000;
    var MAX_AVM1_ERRORS_LIMIT = 1000;
    var MAX_AVM1_STACK_LIMIT = 256;
    var AVM1ScopeListItemFlags;
    (function (AVM1ScopeListItemFlags) {
        AVM1ScopeListItemFlags[AVM1ScopeListItemFlags["DEFAULT"] = 0] = "DEFAULT";
        AVM1ScopeListItemFlags[AVM1ScopeListItemFlags["TARGET"] = 1] = "TARGET";
        AVM1ScopeListItemFlags[AVM1ScopeListItemFlags["REPLACE_TARGET"] = 2] = "REPLACE_TARGET";
    })(AVM1ScopeListItemFlags || (AVM1ScopeListItemFlags = {}));
    var AVM1ScopeListItem = /** @class */ (function () {
        function AVM1ScopeListItem(scope, previousScopeItem) {
            this.scope = scope;
            this.previousScopeItem = previousScopeItem;
            this.flags = AVM1ScopeListItemFlags.DEFAULT;
        }
        return AVM1ScopeListItem;
    }());
    // Similar to function scope, mostly for 'this'.
    var GlobalPropertiesScope = /** @class */ (function (_super) {
        __extends(GlobalPropertiesScope, _super);
        function GlobalPropertiesScope(context, thisArg) {
            var _this = _super.call(this, context) || this;
            _this.alSetOwnProperty('this', new AVM1PropertyDescriptor(64 /* DATA */ |
                1 /* DONT_ENUM */ |
                2 /* DONT_DELETE */ |
                4 /* READ_ONLY */, thisArg));
            _this.alSetOwnProperty('_global', new AVM1PropertyDescriptor(64 /* DATA */ |
                1 /* DONT_ENUM */ |
                2 /* DONT_DELETE */ |
                4 /* READ_ONLY */, context.globals));
            return _this;
        }
        return GlobalPropertiesScope;
    }(AVM1Object));
    var AVM1CallFrame = /** @class */ (function () {
        function AVM1CallFrame(previousFrame, currentThis, fn, args, ectx) {
            this.previousFrame = previousFrame;
            this.currentThis = currentThis;
            this.fn = fn;
            this.args = args;
            this.ectx = ectx;
            this.inSequence = !previousFrame ? false :
                (previousFrame.calleeThis === currentThis && previousFrame.calleeFn === fn);
            this.resetCallee();
        }
        AVM1CallFrame.prototype.setCallee = function (thisArg, superArg, fn, args) {
            this.calleeThis = thisArg;
            this.calleeSuper = superArg;
            this.calleeFn = fn;
            if (!release$1) {
                this.calleeArgs = args;
            }
        };
        AVM1CallFrame.prototype.resetCallee = function () {
            this.calleeThis = null;
            this.calleeSuper = null;
            this.calleeFn = null;
        };
        return AVM1CallFrame;
    }());
    var AVM1RuntimeUtilsImpl = /** @class */ (function () {
        function AVM1RuntimeUtilsImpl(context) {
            this._context = context;
        }
        AVM1RuntimeUtilsImpl.prototype.hasProperty = function (obj, name) {
            return as2HasProperty(this._context, obj, name);
        };
        AVM1RuntimeUtilsImpl.prototype.getProperty = function (obj, name) {
            return as2GetProperty(this._context, obj, name);
        };
        AVM1RuntimeUtilsImpl.prototype.setProperty = function (obj, name, value) {
            return as2SetProperty(this._context, obj, name, value);
        };
        AVM1RuntimeUtilsImpl.prototype.warn = function (msg) {
            avm1Warn.apply(null, arguments);
        };
        return AVM1RuntimeUtilsImpl;
    }());
    var AVM1ContextImpl = /** @class */ (function (_super) {
        __extends(AVM1ContextImpl, _super);
        function AVM1ContextImpl(loaderInfo) {
            var _this = this;
            var swfVersion = loaderInfo.swfVersion;
            _this = _super.call(this, swfVersion) || this;
            _this.loaderInfo = loaderInfo;
            _this.sec = loaderInfo.sec; // REDUX:
            _this.globals = AVM1Globals.createGlobalsObject(_this);
            _this.actions = new AVM1NativeActions(_this);
            _this.initialScope = new AVM1ScopeListItem(_this.globals, null);
            _this.utils = new AVM1RuntimeUtilsImpl(_this);
            _this.isActive = false;
            _this.executionProhibited = false;
            _this.actionTracer = avm1TraceEnabled.value ? new ActionTracer() : null;
            _this.abortExecutionAt = 0;
            _this.stackDepth = 0;
            _this.frame = null;
            _this.isTryCatchListening = false;
            _this.errorsIgnored = 0;
            _this.deferScriptExecution = true;
            return _this;
        }
        AVM1ContextImpl.prototype._getExecutionContext = function () {
            // We probably entering this function from some native function,
            // so faking execution context. Let's reuse last created context.
            return this.frame.ectx;
        };
        AVM1ContextImpl.prototype.resolveTarget = function (target) {
            var ectx = this._getExecutionContext();
            return avm1ResolveTarget(ectx, target, true);
        };
        AVM1ContextImpl.prototype.resolveRoot = function () {
            var ectx = this._getExecutionContext();
            return avm1ResolveRoot(ectx);
        };
        AVM1ContextImpl.prototype.checkTimeout = function () {
            if (Date.now() >= this.abortExecutionAt) {
                //80pro - this fires even for short scripts:
                //throw new AVM1CriticalError('long running script -- AVM1 instruction hang timeout');
            }
        };
        AVM1ContextImpl.prototype.pushCallFrame = function (thisArg, fn, args, ectx) {
            var nextFrame = new AVM1CallFrame(this.frame, thisArg, fn, args, ectx);
            this.frame = nextFrame;
            return nextFrame;
        };
        AVM1ContextImpl.prototype.popCallFrame = function () {
            var previousFrame = this.frame.previousFrame;
            this.frame = previousFrame;
            return previousFrame;
        };
        AVM1ContextImpl.prototype.executeActions = function (actionsData, scopeObj) {
            if (this.executionProhibited) {
                return; // no more avm1 for this context
            }
            var savedIsActive = this.isActive;
            if (!savedIsActive) {
                this.isActive = true;
                this.abortExecutionAt = avm1TimeoutDisabled.value ?
                    Number.MAX_VALUE : Date.now() + MAX_AVM1_HANG_TIMEOUT;
                this.errorsIgnored = 0;
            }
            //console.log("executeActions", scopeObj.aCount);
            try {
                executeActionsData(this, actionsData, scopeObj);
            }
            catch (e) {
            }
            this.isActive = savedIsActive;
        };
        AVM1ContextImpl.prototype.executeFunction = function (fn, thisArg, args) {
            if (this.executionProhibited) {
                return; // no more avm1 for this context
            }
            var savedIsActive = this.isActive;
            if (!savedIsActive) {
                this.isActive = true;
                this.abortExecutionAt = avm1TimeoutDisabled.value ?
                    Number.MAX_VALUE : Date.now() + MAX_AVM1_HANG_TIMEOUT;
                this.errorsIgnored = 0;
            }
            var caughtError;
            var result;
            try {
                result = fn.alCall(thisArg, args);
            }
            catch (e) {
                caughtError = e;
            }
            this.isActive = savedIsActive;
            if (caughtError) {
                // Note: this doesn't use `finally` because that's a no-go for performance.
                throw caughtError;
            }
            return result;
        };
        return AVM1ContextImpl;
    }(AVM1Context));
    AVM1Context.create = function (loaderInfo) {
        return new AVM1ContextImpl(loaderInfo);
    };
    var AVM1Error = /** @class */ (function () {
        function AVM1Error(error$$1) {
            this.error = error$$1;
        }
        return AVM1Error;
    }());
    var AVM1CriticalError = /** @class */ (function (_super) {
        __extends(AVM1CriticalError, _super);
        function AVM1CriticalError(message, error$$1) {
            var _this = _super.call(this, message) || this;
            _this.error = error$$1;
            return _this;
        }
        return AVM1CriticalError;
    }(Error));
    function isAVM1MovieClip(obj) {
        return typeof obj === 'object' && obj &&
            obj instanceof AVM1MovieClip;
    }
    function as2GetType(v) {
        if (v === null) {
            return 'null';
        }
        var type = typeof v;
        if (typeof v === 'object') {
            if (v instanceof AVM1MovieClip) {
                return 'movieclip';
            }
            if (v instanceof AVM1Function) {
                return 'function';
            }
        }
        return type;
    }
    function as2ToAddPrimitive(context, value) {
        return alToPrimitive(context, value);
    }
    /**
     * Performs "less" comparison of two arugments.
     * @returns {boolean} Returns true if x is less than y, otherwise false
     */
    function as2Compare(context, x, y) {
        var x2 = alToPrimitive(context, x);
        var y2 = alToPrimitive(context, y);
        if (typeof x2 === 'string' && typeof y2 === 'string') {
            var xs = alToString(context, x2), ys = alToString(context, y2);
            return xs < ys;
        }
        else {
            var xn = alToNumber(context, x2), yn = alToNumber(context, y2);
            return isNaN(xn) || isNaN(yn) ? undefined : xn < yn;
        }
    }
    /**
     * Performs equality comparison of two arugments. The equality comparison
     * algorithm from EcmaScript 3, Section 11.9.3 is applied.
     * http://ecma-international.org/publications/files/ECMA-ST-ARCH/ECMA-262,%203rd%20edition,%20December%201999.pdf#page=67
     * @returns {boolean} Coerces x and y to the same type and returns true if they're equal, false otherwise.
     */
    function as2Equals(context, x, y) {
        // Spec steps 1 through 13 can be condensed to ...
        if (typeof x === typeof y) {
            return x === y;
        }
        // Spec steps 14 and 15.
        if (x == null && y == null) {
            return true;
        }
        /*
        if (typeof x === 'undefined' && typeof y === 'string' && y=="") {
            // Unfolding the recursion for `as2Equals(context, x, alToNumber(y))`
            return true; // in AVM1, ToNumber('') === NaN
        }
        if (typeof y === 'undefined' && typeof x === 'string' && x=="") {
            // Unfolding the recursion for `as2Equals(context, x, alToNumber(y))`
            return true; // in AVM1, ToNumber('') === NaN
        }
        */
        // Spec steps 16 and 17.
        if (typeof x === 'number' && typeof y === 'string') {
            // Unfolding the recursion for `as2Equals(context, x, alToNumber(y))`
            return y === '' ? false : x === +y; // in AVM1, ToNumber('') === NaN
        }
        if (typeof x === 'string' && typeof y === 'number') {
            // Unfolding the recursion for `as2Equals(context, alToNumber(x), y)`
            return x === '' ? false : +x === y; // in AVM1, ToNumber('') === NaN
        }
        // Spec step 18.
        if (typeof x === 'boolean') {
            // Unfolding the recursion for `as2Equals(context, alToNumber(x), y)`
            x = +x; // typeof x === 'number'
            if (typeof y === 'number' || typeof y === 'string') {
                return y === '' ? false : x === +y;
            }
            // Fall through for typeof y === 'object', 'boolean', 'undefined' cases
        }
        // Spec step 19.
        if (typeof y === 'boolean') {
            // Unfolding the recursion for `as2Equals(context, x, alToNumber(y))`
            y = +y; // typeof y === 'number'
            if (typeof x === 'number' || typeof x === 'string') {
                return x === '' ? false : +x === y;
            }
            // Fall through for typeof x === 'object', 'undefined' cases
        }
        // Spec step 20.
        if ((typeof x === 'number' || typeof x === 'string') &&
            typeof y === 'object' && y !== null) {
            y = alToPrimitive(context, y);
            if (typeof y === 'object') {
                return false; // avoiding infinite recursion
            }
            return as2Equals(context, x, y);
        }
        // Spec step 21.
        if (typeof x === 'object' && x !== null &&
            (typeof y === 'number' || typeof y === 'string')) {
            x = alToPrimitive(context, x);
            if (typeof x === 'object') {
                return false; // avoiding infinite recursion
            }
            return as2Equals(context, x, y);
        }
        return false;
    }
    function as2InstanceOf(obj, constructor) {
        // TODO refactor this -- quick and dirty hack for now
        if (isNullOrUndefined$1(obj) || isNullOrUndefined$1(constructor)) {
            return false;
        }
        if (constructor === ASString) {
            return typeof obj === 'string';
        }
        else if (constructor === ASNumber) {
            return typeof obj === 'number';
        }
        else if (constructor === ASBoolean) {
            return typeof obj === 'boolean';
        }
        else if (constructor === ASArray) {
            return Array.isArray(obj);
        }
        else if (constructor === ASFunction) {
            return typeof obj === 'function';
        }
        else if (constructor === ASObject) {
            return typeof obj === 'object';
        }
        var baseProto = constructor.alGetPrototypeProperty();
        if (!baseProto) {
            return false;
        }
        var proto = obj;
        while (proto) {
            if (proto === baseProto) {
                return true; // found the type if the chain
            }
            proto = proto.alPrototype;
        }
        // TODO interface check
        return false;
    }
    function as2HasProperty(context, obj, name) {
        var avm1Obj = alToObject(context, obj);
        name = context.normalizeName(name);
        return avm1Obj.alHasProperty(name);
    }
    function as2GetProperty(context, obj, name) {
        var avm1Obj = alToObject(context, obj);
        if (!avm1Obj)
            return undefined;
        var value = avm1Obj.alGet(name);
        //if(typeof name==="string" && name.toLowerCase()=="ox"){
        //	console.log("get ox", avm1Obj.adaptee.id, avm1Obj.adaptee.name, value);
        //}
        return value;
    }
    function as2SetProperty(context, obj, name, value) {
        var avm1Obj = alToObject(context, obj);
        if (!avm1Obj)
            return;
        //if(typeof name==="string" && name.toLowerCase()=="ox"){
        //	console.log("set ox", avm1Obj.adaptee.id, avm1Obj.adaptee.name, value);
        //}
        if (name == "__proto__") {
            if (value) {
                var allKeys = value.alGetKeys();
                for (var i = 0; i < allKeys.length; i++) {
                    var key = allKeys[i];
                    if (key != "") {
                        avm1Obj.alPut(key, value.alGet(key));
                        as2SyncEvents(context, key, avm1Obj);
                    }
                }
                avm1Obj.protoTypeChanged = !(value instanceof AVM1MovieClip);
            }
        }
        else {
            avm1Obj.alPut(name, value);
            as2SyncEvents(context, name, avm1Obj);
        }
    }
    function as2DeleteProperty(context, obj, name) {
        var avm1Obj = alToObject(context, obj);
        name = context.normalizeName(name);
        var result = avm1Obj.alDeleteProperty(name);
        as2SyncEvents(context, name, avm1Obj);
        return result;
    }
    function as2SyncEvents(context, name, avm1Obj) {
        if (typeof name === "undefined")
            return;
        name = alCoerceString(context, name);
        name = context.normalizeName(name);
        if (name[0] !== 'o' || name[1] !== 'n') { // TODO check case?
            return;
        }
        if (avm1Obj && avm1Obj.updateEventByPropName)
            avm1Obj.updateEventByPropName(name);
        // Maybe an event property, trying to broadcast change.
        //(<AVM1ContextImpl>context).broadcastEventPropertyChange(name);
    }
    function as2CastError(ex) {
        if (typeof InternalError !== 'undefined' &&
            ex instanceof InternalError && ex.message === 'too much recursion') {
            // HACK converting too much recursion into AVM1CriticalError
            //console.log('long running script -- AVM1 recursion limit is reached');
            return new AVM1CriticalError('long running script -- AVM1 recursion limit is reached');
        }
        return ex;
    }
    function as2Construct(ctor, args) {
        var result;
        if (alIsFunction(ctor)) {
            result = ctor.alConstruct(args);
        }
        else {
            // AVM1 simply ignores attempts to invoke non-methods.
            return undefined;
        }
        return result;
    }
    function as2Enumerate(obj, fn, thisArg) {
        // todo: better just whitelist "typeof === object" instead of blacklisting ?
        if (typeof obj === "boolean" || typeof obj === "string" || typeof obj === "number") {
            return;
        }
        var processed = Object.create(null); // TODO remove/refactor
        var props = [];
        alForEachProperty(obj, function (name) {
            if (typeof name == "string" && name.indexOf("_internal_TF") != -1)
                return;
            if (processed[name]) {
                return; // skipping already reported properties
            }
            // if(obj.adaptee && obj.adaptee.isAsset(TextField) && obj.adaptee.isStatic)
            //     return;
            props[props.length] = name;
            processed[name] = true;
        }, thisArg);
        var i = props.length;
        var avmObj = null;
        while (i > 0) {
            i--;
            avmObj = obj.alGet(props[i]);
            if (!avmObj || (avmObj.adaptee && avmObj.adaptee.isAsset(TextField) && avmObj.adaptee.isStatic))
                continue;
            fn.call(thisArg, props[i]);
        }
    }
    function avm1FindSuperPropertyOwner(context, frame, propertyName) {
        if (context.swfVersion < 6) {
            return null;
        }
        var proto = (frame.inSequence && frame.previousFrame.calleeSuper);
        if (!proto) {
            // Finding first object in prototype chain link that has the property.
            proto = frame.currentThis;
            while (proto && !proto.alHasOwnProperty(propertyName)) {
                proto = proto.alPrototype;
            }
            if (!proto) {
                return null;
            }
        }
        // Skipping one chain link
        proto = proto.alPrototype;
        return proto;
    }
    var DEFAULT_REGISTER_COUNT = 4;
    function executeActionsData(context, actionsData, scope) {
        var actionTracer = context.actionTracer;
        var globalPropertiesScopeList = new AVM1ScopeListItem(new GlobalPropertiesScope(context, scope), context.initialScope);
        var scopeList = new AVM1ScopeListItem(scope, globalPropertiesScopeList);
        scopeList.flags |= AVM1ScopeListItemFlags.TARGET;
        var caughtError;
        release$1 || (actionTracer && actionTracer.message('ActionScript Execution Starts'));
        release$1 || (actionTracer && actionTracer.indent());
        var ectx = ExecutionContext.create(context, scopeList, [], DEFAULT_REGISTER_COUNT);
        context.pushCallFrame(scope, null, null, ectx);
        try {
            interpretActionsData(ectx, actionsData);
        }
        catch (e) {
            caughtError = as2CastError(e);
        }
        ectx.dispose();
        if (caughtError instanceof AVM1CriticalError) {
            context.executionProhibited = true;
            console.error('Disabling AVM1 execution');
        }
        context.popCallFrame();
        release$1 || (actionTracer && actionTracer.unindent());
        release$1 || (actionTracer && actionTracer.message('ActionScript Execution Stops'));
        if (caughtError) {
            // Note: this doesn't use `finally` because that's a no-go for performance.
            throw caughtError; // TODO shall we just ignore it?
        }
    }
    function createBuiltinType(context, cls, args) {
        var builtins = context.builtins;
        var obj = undefined;
        if (cls === builtins.Array || cls === builtins.Object ||
            cls === builtins.Date || cls === builtins.String ||
            cls === builtins.Function) {
            obj = cls.alConstruct(args);
        }
        if (cls === builtins.Boolean || cls === builtins.Number) {
            obj = cls.alConstruct(args).value;
        }
        if (obj instanceof AVM1Object) {
            var desc = new AVM1PropertyDescriptor(64 /* DATA */ | 1 /* DONT_ENUM */, cls);
            obj.alSetOwnProperty('__constructor__', desc);
        }
        return obj;
    }
    var AVM1SuperWrapper = /** @class */ (function (_super) {
        __extends(AVM1SuperWrapper, _super);
        function AVM1SuperWrapper(context, callFrame) {
            var _this = _super.call(this, context) || this;
            _this.callFrame = callFrame;
            _this.alPrototype = context.builtins.Object.alGetPrototypeProperty();
            return _this;
        }
        return AVM1SuperWrapper;
    }(AVM1Object));
    var AVM1Arguments = /** @class */ (function (_super) {
        __extends(AVM1Arguments, _super);
        function AVM1Arguments(context, args, callee, caller) {
            var _this = _super.call(this, context, args) || this;
            alDefineObjectProperties(_this, {
                callee: {
                    value: callee
                },
                caller: {
                    value: caller
                }
            });
            return _this;
        }
        return AVM1Arguments;
    }(AVM1ArrayNative));
    var ExecutionContext = /** @class */ (function () {
        function ExecutionContext(context, scopeList, constantPool, registerCount) {
            this.context = context;
            this.actions = context.actions;
            this.isSwfVersion5 = context.swfVersion >= 5;
            this.isSwfVersion7 = context.swfVersion >= 7;
            this.registers = [];
            this.stack = [];
            this.frame = null;
            this.recoveringFromError = false;
            this.isEndOfActions = false;
            this.reset(scopeList, constantPool, registerCount);
        }
        ExecutionContext.alInitStatic = function () {
            this.cache = [];
        };
        ExecutionContext.prototype.reset = function (scopeList, constantPool, registerCount) {
            this.scopeList = scopeList;
            this.constantPool = constantPool;
            this.registers.length = registerCount;
        };
        ExecutionContext.prototype.clean = function () {
            this.scopeList = null;
            this.constantPool = null;
            this.registers.length = 0;
            this.stack.length = 0;
            this.frame = null;
            this.recoveringFromError = false;
            this.isEndOfActions = false;
        };
        ExecutionContext.prototype.pushScope = function (newScopeList) {
            var newContext = Object.create(this);
            newContext.stack = [];
            if (!isNullOrUndefined$1(newScopeList)) {
                newContext.scopeList = newScopeList;
            }
            return newContext;
        };
        ExecutionContext.prototype.dispose = function () {
            this.clean();
            var state = this.context.getStaticState(ExecutionContext);
            if (state.cache.length < ExecutionContext.MAX_CACHED_EXECUTIONCONTEXTS) {
                state.cache.push(this);
            }
        };
        ExecutionContext.create = function (context, scopeList, constantPool, registerCount) {
            var state = context.getStaticState(ExecutionContext);
            var ectx;
            if (state.cache.length > 0) {
                ectx = state.cache.pop();
                ectx.reset(scopeList, constantPool, registerCount);
            }
            else {
                ectx = new ExecutionContext(context, scopeList, constantPool, registerCount);
            }
            return ectx;
        };
        ExecutionContext.MAX_CACHED_EXECUTIONCONTEXTS = 20;
        return ExecutionContext;
    }());
    /**
     * Interpreted function closure.
     */
    var AVM1InterpreterScope = /** @class */ (function (_super) {
        __extends(AVM1InterpreterScope, _super);
        function AVM1InterpreterScope(context) {
            var _this = _super.call(this, context) || this;
            _this.alPut('toString', new AVM1NativeFunction(context, _this._toString));
            return _this;
        }
        AVM1InterpreterScope.prototype._toString = function () {
            // It shall return 'this'
            return this;
        };
        return AVM1InterpreterScope;
    }(AVM1Object));
    var AVM1InterpretedFunction = /** @class */ (function (_super) {
        __extends(AVM1InterpretedFunction, _super);
        function AVM1InterpretedFunction(context, ectx, actionsData, functionName, parametersNames, registersCount, registersAllocation, suppressArguments) {
            var _this = _super.call(this, context) || this;
            _this.functionName = functionName;
            _this.actionsData = actionsData;
            _this.parametersNames = parametersNames;
            _this.registersAllocation = registersAllocation;
            _this.suppressArguments = suppressArguments;
            _this.scopeList = ectx.scopeList;
            _this.constantPool = ectx.constantPool;
            var skipArguments = null;
            var registersAllocationCount = !registersAllocation ? 0 : registersAllocation.length;
            for (var i = 0; i < registersAllocationCount; i++) {
                var registerAllocation = registersAllocation[i];
                if (registerAllocation &&
                    registerAllocation.type === 1 /* Argument */) {
                    if (!skipArguments) {
                        skipArguments = [];
                    }
                    skipArguments[registersAllocation[i].index] = true;
                }
            }
            _this.skipArguments = skipArguments;
            var registersLength = Math.min(registersCount, 255); // max allowed for DefineFunction2
            registersLength = Math.max(registersLength, registersAllocationCount + 1);
            _this.registersLength = registersLength;
            return _this;
        }
        AVM1InterpretedFunction.prototype.alCall = function (thisArg, args) {
            var currentContext = this.context;
            if (currentContext.executionProhibited) {
                return; // no more avm1 execution, ever
            }
            var newScope = new AVM1InterpreterScope(currentContext);
            var newScopeList = new AVM1ScopeListItem(newScope, this.scopeList);
            var oldScope = this.scopeList.scope;
            //thisArg = thisArg || oldScope; // REDUX no isGlobalObject check?
            args = args || [];
            var ectx = ExecutionContext.create(currentContext, newScopeList, this.constantPool, this.registersLength);
            var caller = currentContext.frame ? currentContext.frame.fn : undefined;
            var frame = currentContext.pushCallFrame(thisArg, this, args, ectx);
            var supperWrapper;
            var suppressArguments = this.suppressArguments;
            if (!(suppressArguments & 4 /* Arguments */)) {
                newScope.alPut('arguments', new AVM1Arguments(currentContext, args, this, caller));
            }
            if (!(suppressArguments & 2 /* This */)) {
                newScope.alPut('this', thisArg);
            }
            if (!(suppressArguments & 8 /* Super */)) {
                supperWrapper = new AVM1SuperWrapper(currentContext, frame);
                newScope.alPut('super', supperWrapper);
            }
            var i;
            var registers = ectx.registers;
            var registersAllocation = this.registersAllocation;
            var registersAllocationCount = !registersAllocation ? 0 : registersAllocation.length;
            for (i = 0; i < registersAllocationCount; i++) {
                var registerAllocation = registersAllocation[i];
                if (registerAllocation) {
                    switch (registerAllocation.type) {
                        case 1 /* Argument */:
                            registers[i] = args[registerAllocation.index];
                            break;
                        case 2 /* This */:
                            registers[i] = thisArg;
                            break;
                        case 4 /* Arguments */:
                            registers[i] = new AVM1Arguments(currentContext, args, this, caller);
                            break;
                        case 8 /* Super */:
                            supperWrapper = supperWrapper || new AVM1SuperWrapper(currentContext, frame);
                            registers[i] = supperWrapper;
                            break;
                        case 16 /* Global */:
                            registers[i] = currentContext.globals;
                            break;
                        case 32 /* Parent */:
                            var parentObj = null;
                            if (oldScope) {
                                parentObj = oldScope.alGet("_parent");
                                if (!parentObj) {
                                    parentObj = oldScope.alGet('this');
                                    if (parentObj) {
                                        parentObj = parentObj.alGet("_parent");
                                    }
                                }
                            }
                            if (!parentObj) {
                                // if the _parent was not set from oldScope, we get it from thisArg
                                parentObj = thisArg;
                                if (parentObj) {
                                    parentObj = parentObj.alGet("_parent");
                                }
                                //  if this is a onEnter, and the _parent was not set from oldScope,
                                //  we need to go up another parent if possible
                                if (parentObj && this.isOnEnter && parentObj.alGet("_parent")) {
                                    parentObj = parentObj.alGet("_parent");
                                }
                                // for setInterval: if its still not has a parent found
                                //  we look back at the previous-scopes until we find a scope that can provide a _parent
                                if (!parentObj) {
                                    if (this.scopeList && this.scopeList.previousScopeItem && this.scopeList.previousScopeItem.scope) {
                                        var currentScope = this.scopeList.previousScopeItem;
                                        while (currentScope) {
                                            if (currentScope.scope && currentScope.scope instanceof AVM1MovieClip) {
                                                parentObj = currentScope.scope;
                                            }
                                            else if (currentScope.scope) {
                                                parentObj = currentScope.scope.alGet("this");
                                            }
                                            if (parentObj) {
                                                parentObj = parentObj.alGet("_parent");
                                            }
                                            if (currentScope.previousScopeItem)
                                                currentScope = currentScope.previousScopeItem;
                                            else
                                                currentScope = null;
                                        }
                                    }
                                }
                            }
                            /*if(this.isOnEnter){
                                console.log("prepare on enter");
                                console.log("oldScope parent", oldScope.alGet("_parent"));
                                console.log("oldScope this", oldScope.alGet("this"));
                                console.log("newscope this", newScope.alGet("_parent"));
                                console.log("thisArg", thisArg);
                            }*/
                            if (parentObj) {
                                registers[i] = parentObj;
                            }
                            else {
                                //console.log("_parent not defined");
                            }
                            break;
                        case 64 /* Root */:
                            registers[i] = avm1ResolveRoot(ectx);
                            break;
                    }
                }
            }
            var parametersNames = this.parametersNames;
            var skipArguments = this.skipArguments;
            for (i = 0; i < args.length || i < parametersNames.length; i++) {
                if (skipArguments && skipArguments[i]) {
                    continue;
                }
                newScope.alPut(parametersNames[i], args[i]);
            }
            var result;
            var caughtError;
            var actionTracer = currentContext.actionTracer;
            var actionsData = this.actionsData;
            release$1 || (actionTracer && actionTracer.indent());
            if (++currentContext.stackDepth >= MAX_AVM1_STACK_LIMIT) {
                throw new AVM1CriticalError('long running script -- AVM1 recursion limit is reached');
            }
            try {
                result = interpretActionsData(ectx, actionsData);
            }
            catch (e) {
                caughtError = e;
            }
            currentContext.stackDepth--;
            currentContext.popCallFrame();
            ectx.dispose();
            release$1 || (actionTracer && actionTracer.unindent());
            if (caughtError) {
                // Note: this doesn't use `finally` because that's a no-go for performance.
                throw caughtError;
            }
            return result;
        };
        return AVM1InterpretedFunction;
    }(AVM1EvalFunction));
    function fixArgsCount(numArgs /* int */, maxAmount) {
        if (isNaN(numArgs) || numArgs < 0) {
            avm1Warn('Invalid amount of arguments: ' + numArgs);
            return 0;
        }
        numArgs |= 0;
        if (numArgs > maxAmount) {
            avm1Warn('Truncating amount of arguments: from ' + numArgs + ' to ' + maxAmount);
            return maxAmount;
        }
        return numArgs;
    }
    function avm1ReadFunctionArgs(stack) {
        var numArgs = +stack.pop();
        numArgs = fixArgsCount(numArgs, stack.length);
        var args = [];
        for (var i = 0; i < numArgs; i++) {
            args.push(stack.pop());
        }
        return args;
    }
    function avm1SetTarget(ectx, targetPath) {
        var newTarget = null;
        if (targetPath) {
            if (typeof targetPath === "string") {
                while (targetPath.length && targetPath[targetPath.length - 1] == ".") {
                    targetPath = targetPath.substring(0, targetPath.length - 1);
                }
            }
            try {
                newTarget = avm1ResolveTarget(ectx, targetPath, false);
                if (!avm1IsTarget(newTarget)) {
                    avm1Warn('Invalid AVM1 target object: ' + targetPath);
                    newTarget = undefined;
                }
            }
            catch (e) {
                avm1Warn('Unable to set target: ' + e);
            }
        }
        if (newTarget) {
            ectx.scopeList.flags |= AVM1ScopeListItemFlags.REPLACE_TARGET;
            ectx.scopeList.replaceTargetBy = newTarget;
        }
        else {
            ectx.scopeList.flags &= ~AVM1ScopeListItemFlags.REPLACE_TARGET;
            ectx.scopeList.replaceTargetBy = null;
        }
    }
    function avm1DefineFunction(ectx, actionsData, functionName, parametersNames, registersCount, registersAllocation, suppressArguments) {
        return new AVM1InterpretedFunction(ectx.context, ectx, actionsData, functionName, parametersNames, registersCount, registersAllocation, suppressArguments);
    }
    function avm1VariableNameHasPath(variableName) {
        return variableName && (variableName.indexOf('.') >= 0 || variableName.indexOf(':') >= 0 || variableName.indexOf('/') >= 0);
    }
    var cachedResolvedVariableResult = {
        scope: null,
        propertyName: null,
        value: undefined
    };
    function avm1IsTarget(target) {
        // TODO refactor
        return target instanceof AVM1Object && hasAwayJSAdaptee(target);
    }
    function avm1ResolveSimpleVariable(scopeList, variableName, flags, additionalName) {
        if (additionalName === void 0) { additionalName = null; }
        release$1 || Debug$1.assert(alIsName(scopeList.scope.context, variableName));
        var currentTarget;
        var resolved = cachedResolvedVariableResult;
        for (var p = scopeList; p; p = p.previousScopeItem) {
            if ((p.flags & AVM1ScopeListItemFlags.REPLACE_TARGET) &&
                !(flags & 64 /* DISALLOW_TARGET_OVERRIDE */) &&
                !currentTarget) {
                currentTarget = p.replaceTargetBy;
            }
            if ((p.flags & AVM1ScopeListItemFlags.TARGET)) {
                if ((flags & 2 /* WRITE */)) {
                    // last scope/target we can modify (exclude globals)
                    resolved.scope = currentTarget || p.scope;
                    resolved.propertyName = variableName;
                    resolved.value = (flags & 32 /* GET_VALUE */) ? resolved.scope.alGet(variableName) : undefined;
                    return resolved;
                }
                if ((flags & 1 /* READ */) && currentTarget) {
                    if (currentTarget.alHasProperty(variableName)) {
                        resolved.scope = currentTarget;
                        resolved.propertyName = variableName;
                        resolved.value = (flags & 32 /* GET_VALUE */) ? currentTarget.alGet(variableName) : undefined;
                        return resolved;
                    }
                    continue;
                }
            }
            //console.log("scope :", p.scope.aCount);
            if (p.scope.alHasProperty(variableName)) {
                var value = p.scope.alGet(variableName);
                if (additionalName && (!value || typeof value !== "object" || !value.alHasProperty || !value.alHasProperty(additionalName))) {
                    continue;
                }
                resolved.scope = p.scope;
                resolved.propertyName = variableName;
                resolved.value = (flags & 32 /* GET_VALUE */) ? p.scope.alGet(variableName) : undefined;
                return resolved;
            }
            //80pro: in some cases we are trying to find a mc by name, but it is only registered as "this" within the scope
            // in this cases, we check if the "this" object actually has the name that we are searching for
            /*	if(p.scope.alHasProperty("this")) {
                    var thisValue =	 (flags & AVM1ResolveVariableFlags.GET_VALUE) ? p.scope.alGet("this") : undefined;
                    if(thisValue && thisValue.adaptee && thisValue.adaptee.name && thisValue.adaptee.name==variableName){
                        resolved.scope = p.scope;
                        resolved.propertyName = variableName;
                        resolved.value = thisValue;
                        return resolved;
                    }
                }*/
        }
        noVarGetDebug || console.log("avm1ResolveSimpleVariable variableName", variableName);
        release$1 || Debug$1.assert(!(flags & 2 /* WRITE */));
        return undefined;
    }
    function avm1ResolveVariable(ectx, variableName, flags) {
        // For now it is just very much magical -- designed to pass some of the swfdec tests
        // FIXME refactor
        release$1 || Debug$1.assert(variableName);
        // Canonicalizing the name here is ok even for paths: the only thing that (potentially)
        // happens is that the name is converted to lower-case, which is always valid for paths.
        // The original name is saved because the final property name needs to be extracted from
        // it for property name paths.
        var originalName = variableName;
        variableName = ectx.context.normalizeName(variableName);
        if (typeof variableName === "string")
            variableName = variableName.replace("_level0", "_root");
        if (!avm1VariableNameHasPath(variableName)) {
            //noVarGetDebug || console.log("simple variableName", variableName);
            var resolvedVar = avm1ResolveSimpleVariable(ectx.scopeList, variableName, flags);
            noVarGetDebug || console.log("resolved", resolvedVar);
            return resolvedVar;
        }
        noVarGetDebug || console.log("originalName", originalName);
        // if this is a path, and the last item is a "." flash will not find anything
        if (variableName[variableName.length - 1] == ".") {
            return null;
        }
        var i = 0, j = variableName.length;
        var markedAsTarget = true;
        var resolved, ch, needsScopeResolution;
        var propertyName = null, scope = null, obj = undefined;
        if (variableName[0] === '/') {
            noVarGetDebug || console.log("originalName starts with a '/'");
            resolved = avm1ResolveSimpleVariable(ectx.scopeList, '_root', 1 /* READ */ | 32 /* GET_VALUE */);
            if (resolved) {
                noVarGetDebug || console.log("resolved", resolved);
                propertyName = resolved.propertyName;
                scope = resolved.scope;
                obj = resolved.value;
            }
            i++;
            needsScopeResolution = false;
        }
        else {
            resolved = null;
            needsScopeResolution = true;
        }
        noVarGetDebug || console.log("needsScopeResolution", needsScopeResolution);
        if (i >= j) {
            return resolved;
        }
        var q = i;
        while (i < j) {
            if (!needsScopeResolution && !(obj instanceof AVM1Object)) {
                noVarGetDebug || console.log('Unable to resolve variable on invalid object ' + variableName.substring(q, i - 1) + ' (expr ' + variableName + ')');
                avm1Warn('Unable to resolve variable on invalid object ' + variableName.substring(q, i - 1) + ' (expr ' + variableName + ')');
                return null;
            }
            var propertyName;
            var q = i;
            if (variableName[i] === '.' && variableName[i + 1] === '.') {
                i += 2;
                propertyName = '_parent';
            }
            else {
                while (i < j && ((ch = variableName[i]) !== '/' && ch !== '.' && ch !== ':')) {
                    i++;
                }
                propertyName = variableName.substring(q, i);
            }
            if (propertyName === '' && i < j) {
                // Ignoring double delimiters in the middle of the path
                i++;
                continue;
            }
            scope = obj;
            var valueFound = false;
            if (markedAsTarget) {
                // Trying movie clip children first
                var child = obj instanceof AVM1MovieClip ? obj._lookupChildByName(propertyName) : undefined;
                if (child) {
                    valueFound = true;
                    obj = child;
                }
            }
            if (!valueFound) {
                if (needsScopeResolution) {
                    //  80pro:
                    //  if we need to resolve the scope, we want to know the next property name
                    //  if a next property name exists, we pass it as extra argument to  avm1ResolveSimpleVariable
                    //  this will make sure that avm1ResolveSimpleVariable returns the scope that has the property name available
                    var q = i + 1;
                    var k = i + 1;
                    var nextPropName = "";
                    if (variableName[k] === '.' && variableName[k + 1] === '.') {
                        k += 2;
                        nextPropName = '_parent';
                    }
                    else {
                        while (k < j && ((ch = variableName[k]) !== '/' && ch !== '.' && ch !== ':')) {
                            k++;
                        }
                        nextPropName = variableName.substring(q, k);
                    }
                    if (nextPropName == "")
                        nextPropName = null;
                    resolved = avm1ResolveSimpleVariable(ectx.scopeList, propertyName, flags, nextPropName);
                    if (!resolved && nextPropName) {
                        // if we tried to get with a nextPropName, and got nothing returned, we try again without any nextpropName
                        resolved = avm1ResolveSimpleVariable(ectx.scopeList, propertyName, flags);
                    }
                    if (resolved) {
                        valueFound = true;
                        propertyName = resolved.propertyName;
                        scope = resolved.scope;
                        obj = resolved.value;
                        if (i < j && !obj && scope) {
                            obj = scope;
                        }
                    }
                    needsScopeResolution = false;
                }
                else if (obj.alHasProperty(propertyName)) {
                    obj = obj.alGet(propertyName);
                    valueFound = true;
                }
            }
            if (!valueFound && propertyName[0] === '_') {
                // FIXME hacking to pass some swfdec test cases
                if (propertyName === '_level0') {
                    obj = ectx.context.resolveLevel(0);
                    valueFound = true;
                }
                else if (propertyName === '_root') {
                    obj = avm1ResolveRoot(ectx);
                    valueFound = true;
                }
            }
            if (!valueFound && !(flags & 2 /* WRITE */)) {
                avm1Warn('Unable to resolve ' + propertyName + ' on ' + variableName.substring(q, i - 1) + ' (expr ' + variableName + ')');
                return null;
            }
            if (i >= j) {
                break;
            }
            var delimiter = variableName[i++];
            if (delimiter === '/' && ((ch = variableName[i]) === ':' || ch === '.')) {
                delimiter = variableName[i++];
            }
            markedAsTarget = delimiter === '/';
        }
        resolved = cachedResolvedVariableResult;
        resolved.scope = scope;
        resolved.propertyName = originalName.substring(q, i);
        resolved.value = (flags & 32 /* GET_VALUE */) ? obj : undefined;
        return resolved;
    }
    function avm1GetTarget(ectx, allowOverride) {
        var scopeList = ectx.scopeList;
        for (var p = scopeList; p.previousScopeItem; p = p.previousScopeItem) {
            if ((p.flags & AVM1ScopeListItemFlags.REPLACE_TARGET) && allowOverride) {
                return p.replaceTargetBy;
            }
            if ((p.flags & AVM1ScopeListItemFlags.TARGET)) {
                return p.scope;
            }
        }
        release$1 || Debug$1.assert(false, 'Shall not reach this statement');
        return undefined;
    }
    function avm1ResolveTarget(ectx, target, fromCurrentTarget) {
        var result;
        if (avm1IsTarget(target)) {
            result = target;
        }
        else {
            target = isNullOrUndefined$1(target) ? '' : alToString(this, target);
            if (target) {
                var targetPath = alToString(ectx.context, target);
                var resolved = avm1ResolveVariable(ectx, targetPath, 1 /* READ */ |
                    128 /* ONLY_TARGETS */ |
                    32 /* GET_VALUE */ |
                    (fromCurrentTarget ? 0 : 64 /* DISALLOW_TARGET_OVERRIDE */));
                if (!resolved || !avm1IsTarget(resolved.value)) {
                    avm1Warn('Invalid AVM1 target object: ' + targetPath);
                    result = undefined;
                }
                else {
                    result = resolved.value;
                }
            }
            else {
                result = avm1GetTarget(ectx, true);
            }
        }
        return result;
    }
    function avm1ResolveRoot(ectx) {
        var target = avm1GetTarget(ectx, true);
        return target.get_root();
    }
    function avm1ProcessWith(ectx, obj, withBlock) {
        if (isNullOrUndefined$1(obj)) {
            // Not executing anything in the block.
            avm1Warn('The with statement object cannot be undefined.');
            return;
        }
        var context = ectx.context;
        var scopeList = ectx.scopeList;
        var newScopeList = new AVM1ScopeListItem(alToObject(context, obj), scopeList);
        var newEctx = ectx.pushScope(newScopeList);
        interpretActionsData(newEctx, withBlock);
    }
    function avm1ProcessTry(ectx, catchIsRegisterFlag, finallyBlockFlag, catchBlockFlag, catchTarget, tryBlock, catchBlock, finallyBlock) {
        var currentContext = ectx.context;
        var scopeList = ectx.scopeList;
        var registers = ectx.registers;
        var savedTryCatchState = currentContext.isTryCatchListening;
        var caughtError;
        try {
            currentContext.isTryCatchListening = true;
            interpretActionsData(ectx.pushScope(), tryBlock);
        }
        catch (e) {
            currentContext.isTryCatchListening = savedTryCatchState;
            if (!catchBlockFlag || !(e instanceof AVM1Error)) {
                caughtError = e;
            }
            else {
                if (typeof catchTarget === 'string') { // TODO catchIsRegisterFlag?
                    var scope = scopeList.scope;
                    scope.alPut(catchTarget, e.error);
                }
                else {
                    registers[catchTarget] = e.error;
                }
                interpretActionsData(ectx.pushScope(), catchBlock);
            }
        }
        currentContext.isTryCatchListening = savedTryCatchState;
        if (finallyBlockFlag) {
            interpretActionsData(ectx.pushScope(), finallyBlock);
        }
        if (caughtError) {
            throw caughtError;
        }
    }
    // SWF 3 actions
    function avm1_0x81_ActionGotoFrame(ectx, args) {
        var frame = args[0];
        var play = args[1];
        if (play) {
            ectx.actions.gotoAndPlay(frame + 1);
        }
        else {
            ectx.actions.gotoAndStop(frame + 1);
        }
    }
    function avm1_0x83_ActionGetURL(ectx, args) {
        var actions = ectx.actions;
        var urlString = args[0];
        var targetString = args[1];
        ectx.actions.getURL(urlString, targetString);
    }
    function avm1_0x04_ActionNextFrame(ectx) {
        ectx.actions.nextFrame();
    }
    function avm1_0x05_ActionPreviousFrame(ectx) {
        ectx.actions.prevFrame();
    }
    function avm1_0x06_ActionPlay(ectx) {
        ectx.actions.play();
    }
    function avm1_0x07_ActionStop(ectx) {
        ectx.actions.stop();
    }
    function avm1_0x08_ActionToggleQuality(ectx) {
        ectx.actions.toggleHighQuality();
    }
    function avm1_0x09_ActionStopSounds(ectx) {
        ectx.actions.stopAllSounds();
    }
    function avm1_0x8A_ActionWaitForFrame(ectx, args) {
        var frame = args[0];
        var count = args[1];
        return !ectx.actions.ifFrameLoaded(frame);
    }
    function avm1_0x8B_ActionSetTarget(ectx, args) {
        var targetName = args[0];
        avm1SetTarget(ectx, targetName);
    }
    function avm1_0x8C_ActionGoToLabel(ectx, args) {
        var label = args[0];
        var play = args[1];
        if (play) {
            ectx.actions.gotoAndPlay(label);
        }
        else {
            ectx.actions.gotoAndStop(label);
        }
    }
    // SWF 4 actions
    function avm1_0x96_ActionPush(ectx, args) {
        var registers = ectx.registers;
        var constantPool = ectx.constantPool;
        var stack = ectx.stack;
        args.forEach(function (value) {
            if (value instanceof ParsedPushConstantAction) {
                stack.push(constantPool[value.constantIndex]);
            }
            else if (value instanceof ParsedPushRegisterAction) {
                var registerNumber = value.registerNumber;
                if (registerNumber < 0 || registerNumber >= registers.length) {
                    stack.push(undefined);
                }
                else {
                    stack.push(registers[registerNumber]);
                }
            }
            else {
                stack.push(value);
            }
        });
    }
    function avm1_0x17_ActionPop(ectx) {
        var stack = ectx.stack;
        stack.pop();
    }
    function avm1_0x0A_ActionAdd(ectx) {
        var stack = ectx.stack;
        var a = alToNumber(ectx.context, stack.pop());
        var b = alToNumber(ectx.context, stack.pop());
        if (!ectx.isSwfVersion7) {
            if (typeof a === 'undefined')
                a = 0;
            if (typeof b === 'undefined')
                b = 0;
        }
        if (isNaN(a) || isNaN(b)) {
            stack.push(NaN);
        }
        else {
            stack.push(Number(Big(Number(a)).add(Big(Number(b)))));
        }
    }
    function avm1_0x0B_ActionSubtract(ectx) {
        var stack = ectx.stack;
        var a = alToNumber(ectx.context, stack.pop());
        var b = alToNumber(ectx.context, stack.pop());
        if (!ectx.isSwfVersion7) {
            if (typeof a === 'undefined')
                a = 0;
            if (typeof b === 'undefined')
                b = 0;
        }
        if (isNaN(a) || isNaN(b)) {
            stack.push(NaN);
        }
        else {
            stack.push(Number(Big(Number(b)).sub(Big(Number(a)))));
        }
    }
    function avm1_0x0C_ActionMultiply(ectx) {
        var stack = ectx.stack;
        var a = alToNumber(ectx.context, stack.pop());
        var b = alToNumber(ectx.context, stack.pop());
        if (!ectx.isSwfVersion7) {
            if (typeof a === 'undefined')
                a = 0;
            if (typeof b === 'undefined')
                b = 0;
        }
        if (isNaN(a) || isNaN(b)) {
            stack.push(NaN);
        }
        else {
            stack.push(Number(Big(Number(a)).mul(Big(Number(b)))));
        }
    }
    function avm1_0x0D_ActionDivide(ectx) {
        var stack = ectx.stack;
        var isSwfVersion5 = ectx.isSwfVersion5;
        var a = alToNumber(ectx.context, stack.pop());
        var b = alToNumber(ectx.context, stack.pop());
        if (!ectx.isSwfVersion7) {
            if (typeof a === 'undefined')
                a = 0;
            if (typeof b === 'undefined')
                b = 0;
        }
        if (isNaN(a) || isNaN(b) || (a == 0 && b == 0)) {
            stack.push(NaN);
        }
        else if (a == 0) {
            stack.push(isSwfVersion5 ? '#ERROR#' : (b > 0) ? Infinity : -Infinity);
        }
        else {
            stack.push(Number(Big(Number(b)).div(Big(Number(a)))));
        }
    }
    function avm1_0x0E_ActionEquals(ectx) {
        var stack = ectx.stack;
        var isSwfVersion5 = ectx.isSwfVersion5;
        var a = alToNumber(ectx.context, stack.pop());
        var b = alToNumber(ectx.context, stack.pop());
        var f = a == b;
        stack.push(isSwfVersion5 ? f : f ? 1 : 0);
    }
    function avm1_0x0F_ActionLess(ectx) {
        var stack = ectx.stack;
        var isSwfVersion5 = ectx.isSwfVersion5;
        var a = alToNumber(ectx.context, stack.pop());
        var b = alToNumber(ectx.context, stack.pop());
        var f = b < a;
        stack.push(isSwfVersion5 ? f : f ? 1 : 0);
    }
    function avm1_0x10_ActionAnd(ectx) {
        var stack = ectx.stack;
        var isSwfVersion5 = ectx.isSwfVersion5;
        var a = alToBoolean(ectx.context, stack.pop());
        var b = alToBoolean(ectx.context, stack.pop());
        var f = a && b;
        stack.push(isSwfVersion5 ? f : f ? 1 : 0);
    }
    function avm1_0x11_ActionOr(ectx) {
        var stack = ectx.stack;
        var isSwfVersion5 = ectx.isSwfVersion5;
        var a = alToBoolean(ectx.context, stack.pop());
        var b = alToBoolean(ectx.context, stack.pop());
        var f = a || b;
        stack.push(isSwfVersion5 ? f : f ? 1 : 0);
    }
    function avm1_0x12_ActionNot(ectx) {
        var stack = ectx.stack;
        var isSwfVersion5 = ectx.isSwfVersion5;
        var v = stack.pop();
        if (typeof v === 'string')
            v = false;
        var f = !alToBoolean(ectx.context, v);
        stack.push(isSwfVersion5 ? f : f ? 1 : 0);
    }
    function avm1_0x13_ActionStringEquals(ectx) {
        var stack = ectx.stack;
        var isSwfVersion5 = ectx.isSwfVersion5;
        var sa = alToString(ectx.context, stack.pop());
        var sb = alToString(ectx.context, stack.pop());
        var f = sa == sb;
        stack.push(isSwfVersion5 ? f : f ? 1 : 0);
    }
    function avm1_0x14_ActionStringLength(ectx) {
        var stack = ectx.stack;
        var sa = alToString(ectx.context, stack.pop());
        stack.push(ectx.actions.length_(sa));
    }
    function avm1_0x31_ActionMBStringLength(ectx) {
        var stack = ectx.stack;
        var sa = alToString(ectx.context, stack.pop());
        stack.push(ectx.actions.length_(sa));
    }
    function avm1_0x21_ActionStringAdd(ectx) {
        var stack = ectx.stack;
        var sa = alToString(ectx.context, stack.pop());
        var sb = alToString(ectx.context, stack.pop());
        stack.push(sb + sa);
    }
    function avm1_0x15_ActionStringExtract(ectx) {
        var stack = ectx.stack;
        var count = stack.pop();
        var index = stack.pop();
        var value = alToString(ectx.context, stack.pop());
        stack.push(ectx.actions.substring(value, index, count));
    }
    function avm1_0x35_ActionMBStringExtract(ectx) {
        var stack = ectx.stack;
        var count = stack.pop();
        var index = stack.pop();
        var value = alToString(ectx.context, stack.pop());
        stack.push(ectx.actions.mbsubstring(value, index, count));
    }
    function avm1_0x29_ActionStringLess(ectx) {
        var stack = ectx.stack;
        var isSwfVersion5 = ectx.isSwfVersion5;
        var sa = alToString(ectx.context, stack.pop());
        var sb = alToString(ectx.context, stack.pop());
        var f = sb < sa;
        stack.push(isSwfVersion5 ? f : f ? 1 : 0);
    }
    function avm1_0x18_ActionToInteger(ectx) {
        var stack = ectx.stack;
        var value = alToInt32(ectx.context, stack.pop());
        stack.push(value);
    }
    function avm1_0x32_ActionCharToAscii(ectx) {
        var stack = ectx.stack;
        var ch = stack.pop();
        var charCode = ectx.actions.ord(ch);
        stack.push(charCode);
    }
    function avm1_0x36_ActionMBCharToAscii(ectx) {
        var stack = ectx.stack;
        var ch = stack.pop();
        var charCode = ectx.actions.mbord(ch);
        stack.push(charCode);
    }
    function avm1_0x33_ActionAsciiToChar(ectx) {
        var stack = ectx.stack;
        var charCode = +stack.pop();
        var ch = ectx.actions.chr(charCode);
        stack.push(ch);
    }
    function avm1_0x37_ActionMBAsciiToChar(ectx) {
        var stack = ectx.stack;
        var charCode = +stack.pop();
        var ch = ectx.actions.mbchr(charCode);
        stack.push(ch);
    }
    function avm1_0x99_ActionJump(ectx, args) {
        // implemented in the analyzer
    }
    function avm1_0x9D_ActionIf(ectx, args) {
        var stack = ectx.stack;
        var offset = args[0];
        return !!stack.pop();
    }
    function avm1_0x9E_ActionCall(ectx) {
        var stack = ectx.stack;
        var label = stack.pop();
        ectx.actions.call(label);
    }
    function avm1_0x1C_ActionGetVariable(ectx) {
        var stack = ectx.stack;
        var variableName = stack.pop();
        if (variableName)
            variableName = alToString(ectx.context, variableName);
        var sp = stack.length;
        stack.push(undefined);
        var resolved = avm1ResolveVariable(ectx, variableName, 1 /* READ */ | 32 /* GET_VALUE */);
        if (isNullOrUndefined$1(resolved)) {
            if (variableName == "TRUE")
                stack[sp] = true;
            else if (variableName == "FALSE")
                stack[sp] = false;
            else if (variableName && variableName.indexOf("this.") == 0) {
                variableName = variableName.replace("this.", "");
                resolved = avm1ResolveVariable(ectx, variableName, 1 /* READ */ | 32 /* GET_VALUE */);
                stack[sp] = resolved ? resolved.value : undefined;
            }
            /*
        else if (variableName && variableName.indexOf(".")>=0){
            var varnames=variableName.split(".");
            if (varnames.length>1 && varnames[0]=="this"){
                var resolved1 = avm1ResolveVariable(ectx, varnames[0],AVM1ResolveVariableFlags.READ | AVM1ResolveVariableFlags.GET_VALUE);
                if(resolved1 && resolved1.value && resolved1.value.adaptee && resolved1.value.adaptee.name==varnames[1]){
                    stack[sp]=resolved1.value;
                    return;
                }
                var resolved1 = avm1ResolveVariable(ectx, varnames[1],AVM1ResolveVariableFlags.READ | AVM1ResolveVariableFlags.GET_VALUE);
                if(resolved1 && resolved1.value && resolved1.value.adaptee){
                    stack[sp]=resolved1.value;
                    return;
                }
            }
        }
        */
            else if (avm1WarningsEnabled.value) {
                avm1Warn("AVM1 warning: cannot look up variable '" + variableName + "'");
            }
            //console.log("avm1_0x1C_ActionGetVariable", ectx, resolved, variableName);
            return;
        }
        stack[sp] = resolved ? resolved.value : undefined;
        //console.log("avm1_0x1C_ActionGetVariable", ectx, resolved, variableName);
    }
    function avm1_0x1D_ActionSetVariable(ectx) {
        var stack = ectx.stack;
        var value = stack.pop();
        var variableName = '' + stack.pop();
        var resolved = avm1ResolveVariable(ectx, variableName, 2 /* WRITE */);
        if (!resolved) {
            if (avm1WarningsEnabled.value) {
                avm1Warn("AVM1 warning: cannot look up variable '" + variableName + "'");
            }
            //console.log("avm1_0x1D_ActionSetVariable", resolved, variableName, value);
            return;
        }
        release$1 || assert$2(resolved.propertyName);
        resolved.scope.alPut(resolved.propertyName, value);
        as2SyncEvents(ectx.context, resolved.propertyName, resolved.scope);
        //console.log("avm1_0x1D_ActionSetVariable", resolved, variableName, value);
    }
    function avm1_0x9A_ActionGetURL2(ectx, args) {
        var stack = ectx.stack;
        var flags = args[0];
        var target = stack.pop();
        var url = stack.pop();
        var sendVarsMethod;
        if (flags & 1) {
            sendVarsMethod = 'GET';
        }
        else if (flags & 2) {
            sendVarsMethod = 'POST';
        }
        var loadTargetFlag = flags & 1 << 6;
        var loadVariablesFlag = flags & 1 << 7;
        if (loadVariablesFlag) {
            ectx.actions.loadVariables(url, target, sendVarsMethod);
        }
        else if (!loadTargetFlag) {
            ectx.actions.getURL(url, target, sendVarsMethod);
        }
        else {
            ectx.actions.loadMovie(url, target, sendVarsMethod);
        }
    }
    function avm1_0x9F_ActionGotoFrame2(ectx, args) {
        var stack = ectx.stack;
        var flags = args[0];
        var gotoParams = [stack.pop()];
        if (!!(flags & 2)) {
            gotoParams.push(args[1]);
        }
        var gotoMethod = !!(flags & 1) ? ectx.actions.gotoAndPlay : ectx.actions.gotoAndStop;
        gotoMethod.apply(ectx.actions, gotoParams);
    }
    function avm1_0x20_ActionSetTarget2(ectx) {
        var stack = ectx.stack;
        var target = alToString(ectx.context, stack.pop());
        avm1SetTarget(ectx, target);
    }
    function avm1_0x22_ActionGetProperty(ectx) {
        var stack = ectx.stack;
        var index = stack.pop();
        var target = stack.pop();
        var sp = stack.length;
        stack.push(undefined);
        var resolved = avm1ResolveTarget(ectx, target, true);
        var propertyName = MovieClipProperties[index];
        if (resolved && propertyName) {
            stack[sp] = resolved.alGet(propertyName);
        }
        //console.log("avm1_0x22_ActionGetProperty", resolved, propertyName, stack[sp]);
    }
    function avm1_0x23_ActionSetProperty(ectx) {
        var stack = ectx.stack;
        var value = stack.pop();
        var index = stack.pop();
        var target = stack.pop();
        var resolved = avm1ResolveTarget(ectx, target, true);
        var propertyName = MovieClipProperties[index];
        if (resolved && propertyName) {
            resolved.alPut(propertyName, value);
        }
        //console.log("avm1_0x23_ActionSetProperty", resolved, propertyName, value);
    }
    function avm1_0x24_ActionCloneSprite(ectx) {
        var stack = ectx.stack;
        var depth = stack.pop();
        var target = stack.pop();
        var source = stack.pop();
        ectx.actions.duplicateMovieClip(source, target, depth);
    }
    function avm1_0x25_ActionRemoveSprite(ectx) {
        var stack = ectx.stack;
        var target = stack.pop();
        ectx.actions.removeMovieClip(target);
    }
    function avm1_0x27_ActionStartDrag(ectx) {
        var stack = ectx.stack;
        var target = stack.pop();
        var lockcenter = stack.pop();
        var constrain = !stack.pop() ? null : {
            y2: stack.pop(),
            x2: stack.pop(),
            y1: stack.pop(),
            x1: stack.pop()
        };
        var dragParams = [target, lockcenter];
        if (constrain) {
            dragParams = dragParams.concat(constrain.x1, constrain.y1, constrain.x2, constrain.y2);
        }
        ectx.actions.startDrag.apply(ectx.actions, dragParams);
    }
    function avm1_0x28_ActionEndDrag(ectx) {
        ectx.actions.stopDrag();
    }
    function avm1_0x8D_ActionWaitForFrame2(ectx, args) {
        var stack = ectx.stack;
        var count = args[0];
        var frame = stack.pop();
        return !ectx.actions.ifFrameLoaded(frame);
    }
    function avm1_0x26_ActionTrace(ectx) {
        var stack = ectx.stack;
        var value = stack.pop();
        ectx.actions.trace(value);
    }
    function avm1_0x34_ActionGetTime(ectx) {
        var stack = ectx.stack;
        stack.push(ectx.actions.getTimer());
    }
    function avm1_0x30_ActionRandomNumber(ectx) {
        var stack = ectx.stack;
        stack.push(ectx.actions.random(stack.pop()));
    }
    // SWF 5
    function avm1_0x3D_ActionCallFunction(ectx) {
        var stack = ectx.stack;
        var functionName = stack.pop();
        var args = avm1ReadFunctionArgs(stack);
        var sp = stack.length;
        stack.push(undefined);
        var resolved = avm1ResolveVariable(ectx, functionName, 1 /* READ */ | 32 /* GET_VALUE */);
        if (isNullOrUndefined$1(resolved)) {
            avm1Warn("AVM1 warning: cannot look up function '" + functionName + "'");
            return;
        }
        var fn = resolved.value;
        // AVM1 simply ignores attempts to invoke non-functions.
        if (!alIsFunction(fn)) {
            avm1Warn("AVM1 warning: function '" + functionName +
                (fn ? "' is not callable" : "' is undefined"));
            return;
        }
        release$1 || assert$2(stack.length === sp + 1);
        if (functionName.toLowerCase() == "array")
            args = [args];
        // REDUX
        stack[sp] = fn.alCall(resolved.scope || null, args);
    }
    function avm1_0x52_ActionCallMethod(ectx) {
        var stack = ectx.stack;
        var methodName = stack.pop();
        var obj = stack.pop();
        var args = avm1ReadFunctionArgs(stack);
        var target;
        var sp = stack.length;
        stack.push(undefined);
        // AVM1 simply ignores attempts to invoke methods on non-existing objects.
        if (isNullOrUndefined$1(obj)) {
            avm1Warn("AVM1 warning: method '" + methodName + "' can't be called on undefined object");
            return;
        }
        var frame = ectx.context.frame;
        var superArg;
        var fn;
        // Per spec, a missing or blank method name causes the container to be treated as
        // a function to call.
        if (isNullOrUndefined$1(methodName) || methodName === '') {
            if (obj instanceof AVM1SuperWrapper) {
                var superFrame = obj.callFrame;
                superArg = avm1FindSuperPropertyOwner(ectx.context, superFrame, '__constructor__');
                if (superArg) {
                    fn = superArg.alGet('__constructor__');
                    target = superFrame.currentThis;
                }
            }
            else {
                // For non-super calls, we call obj with itself as the target.
                // TODO: ensure this is correct.
                fn = obj;
                target = obj;
            }
            // AVM1 simply ignores attempts to invoke non-functions.
            if (alIsFunction(fn)) {
                frame.setCallee(target, superArg, fn, args);
                stack[sp] = fn.alCall(target, args);
                frame.resetCallee();
            }
            else {
                avm1Warn("AVM1 warning: obj '" + obj + (obj ? "' is not callable" : "' is undefined"));
            }
            release$1 || assert$2(stack.length === sp + 1);
            return;
        }
        if (obj instanceof AVM1SuperWrapper) {
            var superFrame = obj.callFrame;
            var superArg = avm1FindSuperPropertyOwner(ectx.context, superFrame, methodName);
            if (superArg) {
                fn = superArg.alGet(methodName);
                target = superFrame.currentThis;
            }
        }
        else {
            fn = as2GetProperty(ectx.context, obj, methodName);
            target = alToObject(ectx.context, obj);
        }
        // AVM1 simply ignores attempts to invoke non-methods.
        if (!alIsFunction(fn)) {
            // we might have injected js function here, so we call that
            if (typeof fn === "function") {
                // do something
                stack[sp] = fn(args);
            }
            else {
                avm1Warn("AVM1 warning: method '" + methodName + "' on object", obj, (isNullOrUndefined$1(fn) ?
                    "is undefined" :
                    "is not callable"));
            }
            return;
        }
        release$1 || assert$2(stack.length === sp + 1);
        frame.setCallee(target, superArg, fn, args);
        if (methodName == "toString" && typeof obj == "number") {
            if (args.length == 1 && args[0] == 16) {
                stack[sp] = obj.toString(16).toString();
            }
            else {
                stack[sp] = alToString(ectx.context, obj);
            }
        }
        else {
            stack[sp] = fn.alCall(target, args);
        }
        frame.resetCallee();
    }
    function avm1_0x88_ActionConstantPool(ectx, args) {
        var constantPool = args[0];
        ectx.constantPool = constantPool;
    }
    function avm1_0x9B_ActionDefineFunction(ectx, args) {
        var stack = ectx.stack;
        var functionBody = args[0];
        var functionName = args[1];
        var functionParams = args[2];
        var fn = avm1DefineFunction(ectx, functionBody, functionName, functionParams, 4, null, 0);
        if (functionName) {
            var scope = ectx.scopeList.scope;
            scope.alPut(functionName, fn);
            as2SyncEvents(ectx.context, functionName, scope);
        }
        else {
            stack.push(fn);
        }
    }
    function avm1_0x3C_ActionDefineLocal(ectx) {
        var stack = ectx.stack;
        var scope = ectx.scopeList.scope;
        var value = stack.pop();
        var name = stack.pop();
        /*if(typeof value==="undefined" && scope.alHasProperty(name)){
            return;
        }*/
        scope.alPut(name, value);
    }
    function avm1_0x41_ActionDefineLocal2(ectx) {
        var stack = ectx.stack;
        var scope = ectx.scopeList.scope;
        var name = stack.pop();
        if (scope.alHasProperty(name)) {
            return;
        }
        scope.alPut(name, undefined);
    }
    function avm1_0x3A_ActionDelete(ectx) {
        var stack = ectx.stack;
        var name = stack.pop();
        var obj = stack.pop();
        if (isNullOrUndefined$1(obj)) {
            // AVM1 just ignores delete on non-existant containers.
            avm1Warn("AVM1 warning: cannot delete member '" + name + "' on undefined object");
            return;
        }
        stack.push(as2DeleteProperty(ectx.context, obj, name));
    }
    function avm1_0x3B_ActionDelete2(ectx) {
        var stack = ectx.stack;
        var name = stack.pop();
        var resolved = avm1ResolveVariable(ectx, name, 1 /* DELETE */);
        if (isNullOrUndefined$1(resolved)) {
            avm1Warn("AVM1 warning: cannot look up variable '" + name + "'");
            return;
        }
        var targetValue = resolved.scope.alGetProperty(name);
        if (targetValue && targetValue.value && targetValue.value.adaptee) {
            // this is a instance of a symbol. do not delete it
            return;
        }
        stack.push(as2DeleteProperty(ectx.context, resolved.scope, name));
    }
    function avm1_0x46_ActionEnumerate(ectx) {
        var stack = ectx.stack;
        var objectName = stack.pop();
        stack.push(null);
        var resolved = avm1ResolveVariable(ectx, objectName, 1 /* READ */ | 32 /* GET_VALUE */);
        if (isNullOrUndefined$1(resolved)) {
            avm1Warn("AVM1 warning: cannot look up variable '" + objectName + "'");
            return;
        }
        var obj = resolved.value;
        if (isNullOrUndefined$1(obj)) {
            avm1Warn("AVM1 warning: cannot iterate over undefined object");
            return;
        }
        as2Enumerate(obj, function (name) {
            stack.push(name);
        }, null);
    }
    function avm1_0x49_ActionEquals2(ectx) {
        var stack = ectx.stack;
        var a = stack.pop();
        var b = stack.pop();
        stack.push(as2Equals(ectx.context, a, b));
    }
    function avm1_0x4E_ActionGetMember(ectx) {
        var stack = ectx.stack;
        var name = stack.pop();
        var obj = stack.pop();
        stack.push(undefined);
        if (isNullOrUndefined$1(obj)) {
            // AVM1 just ignores gets on non-existant containers.
            avm1Warn("AVM1 warning: cannot get member '" + name + "' on undefined object");
            return;
        }
        if (obj instanceof AVM1SuperWrapper) {
            var superFrame = obj.callFrame;
            var superArg = avm1FindSuperPropertyOwner(ectx.context, superFrame, name);
            if (superArg) {
                stack[stack.length - 1] = superArg.alGet(name);
            }
            return;
        }
        stack[stack.length - 1] = as2GetProperty(ectx.context, obj, name);
    }
    function avm1_0x42_ActionInitArray(ectx) {
        var stack = ectx.stack;
        var obj = new AVM1ArrayNative(ectx.context, avm1ReadFunctionArgs(stack));
        stack.push(obj);
    }
    function avm1_0x43_ActionInitObject(ectx) {
        var stack = ectx.stack;
        var count = +stack.pop();
        count = fixArgsCount(count, stack.length >> 1);
        var obj = alNewObject(ectx.context);
        for (var i = 0; i < count; i++) {
            var value = stack.pop();
            var name = stack.pop();
            obj.alPut(name, value);
        }
        stack.push(obj);
    }
    function avm1_0x53_ActionNewMethod(ectx) {
        var stack = ectx.stack;
        var methodName = stack.pop();
        var obj = stack.pop();
        var args = avm1ReadFunctionArgs(stack);
        var sp = stack.length;
        stack.push(undefined);
        // AVM1 simply ignores attempts to construct methods on non-existing objects.
        if (isNullOrUndefined$1(obj)) {
            avm1Warn("AVM1 warning: method '" + methodName + "' can't be constructed on undefined object");
            return;
        }
        var ctor;
        // Per spec, a missing or blank method name causes the container to be treated as
        // a function to construct.
        if (isNullOrUndefined$1(methodName) || methodName === '') {
            ctor = obj;
        }
        else {
            ctor = as2GetProperty(ectx.context, obj, methodName);
        }
        var result = as2Construct(ctor, args);
        if (result === undefined) {
            avm1Warn("AVM1 warning: method '" + methodName + "' on object", obj, "is not constructible");
        }
        stack[sp] = result;
        release$1 || assert$2(stack.length === sp + 1);
    }
    function avm1_0x40_ActionNewObject(ectx) {
        var stack = ectx.stack;
        var objectName = stack.pop();
        var args = avm1ReadFunctionArgs(stack);
        var sp = stack.length;
        stack.push(undefined);
        var resolved = avm1ResolveVariable(ectx, objectName, 1 /* READ */ | 32 /* GET_VALUE */);
        if (isNullOrUndefined$1(resolved)) {
            avm1Warn("AVM1 warning: cannot look up object '" + objectName + "'");
            return;
        }
        var obj = resolved.value;
        var result = createBuiltinType(ectx.context, obj, args);
        if (result === undefined) {
            // obj in not a built-in type
            result = as2Construct(obj, args);
            if (result === undefined) {
                avm1Warn("AVM1 warning: object '" + objectName +
                    (obj ? "' is not constructible" : "' is undefined"));
            }
        }
        release$1 || assert$2(stack.length === sp + 1);
        stack[sp] = result;
    }
    function avm1_0x4F_ActionSetMember(ectx) {
        var stack = ectx.stack;
        var value = stack.pop();
        var name = stack.pop();
        var obj = stack.pop();
        if (isNullOrUndefined$1(obj)) {
            // AVM1 just ignores sets on non-existant containers
            avm1Warn("AVM1 warning: cannot set member '" + name + "' on undefined object");
            return;
        }
        if (obj instanceof AVM1SuperWrapper) {
            avm1Warn("AVM1 warning: cannot set member '" + name + "' on super");
            return;
        }
        if (typeof name === "undefined")
            return;
        if (typeof name === "string") {
            var name_array = name.split(".");
            if (name_array.length > 1) {
                while (name_array.length > 1) {
                    var propName = name_array.shift();
                    var propObj = obj.alGet(propName);
                    if (propObj instanceof AVM1Object) {
                        obj = propObj;
                    }
                    else {
                        avm1Warn("AVM1 warning: cannot set member '" + name + "' on super");
                        return;
                    }
                }
                if (name_array.length == 1) {
                    name = name_array[0];
                }
            }
        }
        as2SetProperty(ectx.context, obj, name, value);
    }
    function avm1_0x45_ActionTargetPath(ectx) {
        var stack = ectx.stack;
        var obj = stack.pop();
        stack.push(isAVM1MovieClip(obj) ? obj._target : void (0));
    }
    function avm1_0x94_ActionWith(ectx, args) {
        var stack = ectx.stack;
        var withBody = args[0];
        var obj = stack.pop();
        avm1ProcessWith(ectx, obj, withBody);
    }
    function avm1_0x4A_ActionToNumber(ectx) {
        var stack = ectx.stack;
        stack.push(alToNumber(ectx.context, stack.pop()));
    }
    function avm1_0x4B_ActionToString(ectx) {
        var stack = ectx.stack;
        stack.push(alToString(ectx.context, stack.pop()));
    }
    function avm1_0x44_ActionTypeOf(ectx) {
        var stack = ectx.stack;
        var obj = stack.pop();
        var result = as2GetType(obj);
        stack.push(result);
    }
    function avm1_0x47_ActionAdd2(ectx) {
        var stack = ectx.stack;
        var a = as2ToAddPrimitive(ectx.context, stack.pop());
        var b = as2ToAddPrimitive(ectx.context, stack.pop());
        if (typeof a === 'string' || typeof b === 'string') {
            stack.push(alToString(ectx.context, b) + alToString(ectx.context, a));
        }
        else {
            if (!ectx.isSwfVersion7) {
                if (typeof a === 'undefined')
                    a = 0;
                if (typeof b === 'undefined')
                    b = 0;
            }
            if (isNaN(a) || isNaN(b)) {
                stack.push(NaN);
            }
            else {
                stack.push(Number(Big(Number(a)).add(Big(Number(b)))));
            }
        }
    }
    function avm1_0x48_ActionLess2(ectx) {
        var stack = ectx.stack;
        var a = stack.pop();
        var b = stack.pop();
        stack.push(as2Compare(ectx.context, b, a));
    }
    function avm1_0x3F_ActionModulo(ectx) {
        var stack = ectx.stack;
        var a = alToNumber(ectx.context, stack.pop());
        var b = alToNumber(ectx.context, stack.pop());
        if (!ectx.isSwfVersion7) {
            if (typeof a === 'undefined')
                a = 0;
            if (typeof b === 'undefined')
                b = 0;
        }
        if (isNaN(a) || isNaN(b) || a == 0) {
            stack.push(NaN);
        }
        else {
            stack.push(Number(Big(Number(b)).mod(Big(Number(a)))));
        }
    }
    function avm1_0x60_ActionBitAnd(ectx) {
        var stack = ectx.stack;
        var a = alToInt32(ectx.context, stack.pop());
        var b = alToInt32(ectx.context, stack.pop());
        stack.push(b & a);
    }
    function avm1_0x63_ActionBitLShift(ectx) {
        var stack = ectx.stack;
        var a = alToInt32(ectx.context, stack.pop());
        var b = alToInt32(ectx.context, stack.pop());
        stack.push(b << a);
    }
    function avm1_0x61_ActionBitOr(ectx) {
        var stack = ectx.stack;
        var a = alToInt32(ectx.context, stack.pop());
        var b = alToInt32(ectx.context, stack.pop());
        stack.push(b | a);
    }
    function avm1_0x64_ActionBitRShift(ectx) {
        var stack = ectx.stack;
        var a = alToInt32(ectx.context, stack.pop());
        var b = alToInt32(ectx.context, stack.pop());
        stack.push(b >> a);
    }
    function avm1_0x65_ActionBitURShift(ectx) {
        var stack = ectx.stack;
        var a = alToInt32(ectx.context, stack.pop());
        var b = alToInt32(ectx.context, stack.pop());
        stack.push(b >>> a);
    }
    function avm1_0x62_ActionBitXor(ectx) {
        var stack = ectx.stack;
        var a = alToInt32(ectx.context, stack.pop());
        var b = alToInt32(ectx.context, stack.pop());
        stack.push(b ^ a);
    }
    function avm1_0x51_ActionDecrement(ectx) {
        var stack = ectx.stack;
        var a = alToNumber(ectx.context, stack.pop());
        a--;
        stack.push(a);
    }
    function avm1_0x50_ActionIncrement(ectx) {
        var stack = ectx.stack;
        var a = alToNumber(ectx.context, stack.pop());
        a++;
        stack.push(a);
    }
    function avm1_0x4C_ActionPushDuplicate(ectx) {
        var stack = ectx.stack;
        stack.push(stack[stack.length - 1]);
    }
    function avm1_0x3E_ActionReturn(ectx) {
        ectx.isEndOfActions = true;
    }
    function avm1_0x4D_ActionStackSwap(ectx) {
        var stack = ectx.stack;
        stack.push(stack.pop(), stack.pop());
    }
    function avm1_0x87_ActionStoreRegister(ectx, args) {
        var stack = ectx.stack;
        var registers = ectx.registers;
        var register = args[0];
        if (register < 0 || register >= registers.length) {
            return; // ignoring bad registers references
        }
        registers[register] = stack[stack.length - 1];
    }
    // SWF 6
    function avm1_0x54_ActionInstanceOf(ectx) {
        var stack = ectx.stack;
        var constr = stack.pop();
        var obj = stack.pop();
        stack.push(as2InstanceOf(obj, constr));
    }
    function avm1_0x55_ActionEnumerate2(ectx) {
        var stack = ectx.stack;
        var obj = stack.pop();
        stack.push(null);
        // AVM1 just ignores lookups on non-existant containers
        if (isNullOrUndefined$1(obj)) {
            avm1Warn("AVM1 warning: cannot iterate over undefined object");
            return;
        }
        as2Enumerate(obj, function (name) {
            stack.push(name);
        }, null);
    }
    function avm1_0x66_ActionStrictEquals(ectx) {
        var stack = ectx.stack;
        var a = stack.pop();
        var b = stack.pop();
        stack.push(b === a);
    }
    function avm1_0x67_ActionGreater(ectx) {
        var stack = ectx.stack;
        var a = stack.pop();
        var b = stack.pop();
        stack.push(as2Compare(ectx.context, a, b));
    }
    function avm1_0x68_ActionStringGreater(ectx) {
        var stack = ectx.stack;
        var isSwfVersion5 = ectx.isSwfVersion5;
        var sa = alToString(ectx.context, stack.pop());
        var sb = alToString(ectx.context, stack.pop());
        var f = sb > sa;
        stack.push(isSwfVersion5 ? f : f ? 1 : 0);
    }
    // SWF 7
    function avm1_0x8E_ActionDefineFunction2(ectx, args) {
        var stack = ectx.stack;
        var scope = ectx.scopeList.scope;
        var functionBody = args[0];
        var functionName = args[1];
        var functionParams = args[2];
        var registerCount = args[3];
        var registerAllocation = args[4];
        var suppressArguments = args[5];
        var fn = avm1DefineFunction(ectx, functionBody, functionName, functionParams, registerCount, registerAllocation, suppressArguments);
        if (functionName) {
            scope.alPut(functionName, fn);
            as2SyncEvents(ectx.context, functionName, scope);
        }
        else {
            stack.push(fn);
        }
    }
    function avm1_0x69_ActionExtends(ectx) {
        var stack = ectx.stack;
        var context = ectx.context;
        var constrSuper = alToObject(context, stack.pop());
        var constr = alToObject(context, stack.pop());
        var prototype = constr.alGetPrototypeProperty();
        var prototypeSuper = constrSuper.alGetPrototypeProperty();
        prototype.alPrototype = prototypeSuper;
        var desc = new AVM1PropertyDescriptor(64 /* DATA */ | 1 /* DONT_ENUM */, constrSuper);
        prototype.alSetOwnProperty('__constructor__', desc);
    }
    function avm1_0x2B_ActionCastOp(ectx) {
        var stack = ectx.stack;
        var obj = stack.pop();
        var constr = stack.pop();
        stack.push(as2InstanceOf(obj, constr) ? obj : null);
    }
    function avm1_0x2C_ActionImplementsOp(ectx) {
        var stack = ectx.stack;
        var constr = stack.pop();
        var count = +stack.pop();
        fixArgsCount(count, stack.length);
        var interfaces = [];
        for (var i = 0; i < count; i++) {
            interfaces.push(stack.pop());
        }
        constr._as2Interfaces = interfaces;
    }
    function avm1_0x8F_ActionTry(ectx, args) {
        var catchIsRegisterFlag = args[0];
        var catchTarget = args[1];
        var tryBody = args[2];
        var catchBlockFlag = args[3];
        var catchBody = args[4];
        var finallyBlockFlag = args[5];
        var finallyBody = args[6];
        avm1ProcessTry(ectx, catchIsRegisterFlag, finallyBlockFlag, catchBlockFlag, catchTarget, tryBody, catchBody, finallyBody);
    }
    function avm1_0x2A_ActionThrow(ectx) {
        var stack = ectx.stack;
        var obj = stack.pop();
        throw new AVM1Error(obj);
    }
    function avm1_0x2D_ActionFSCommand2(ectx) {
        var stack = ectx.stack;
        var args = avm1ReadFunctionArgs(stack);
        var sp = stack.length;
        stack.push(undefined);
        var result = ectx.actions.fscommand.apply(ectx.actions, args);
        stack[sp] = result;
    }
    function avm1_0x89_ActionStrictMode(ectx, args) {
        var mode = args[0];
    }
    function wrapAvm1Error(fn) {
        return function avm1ErrorWrapper(executionContext, args) {
            // try {
            fn(executionContext, args);
            executionContext.recoveringFromError = false;
            // } catch (e) {
            // 	// handling AVM1 errors
            // 	currentContext = executionContext.context;
            // 	e = as2CastError(e);
            // 	if (e instanceof AVM1CriticalError) {
            // 		throw e;
            // 	}
            // 	if (e instanceof AVM1Error) {
            // 		throw e;
            // 	}
            // 	//Telemetry.instance.reportTelemetry({topic: 'error', error: ErrorTypes.AVM1_ERROR});
            // 	if (!executionContext.recoveringFromError) {
            // 		if (currentContext.errorsIgnored++ >= MAX_AVM1_ERRORS_LIMIT) {
            // 			throw new AVM1CriticalError('long running script -- AVM1 errors limit is reached');
            // 		}
            // 		console.log(typeof e);
            // 		console.log(Object.getPrototypeOf(e));
            // 		console.log(Object.getPrototypeOf(Object.getPrototypeOf(e)));
            // 		console.error('AVM1 error: ' + e);
            // 		// REDUX
            // 		//var avm2 = Shumway.AVM2.Runtime.AVM2;
            // 		//avm2.instance.exceptions.push({source: 'avm1', message: e.message,
            // 		//  stack: e.stack});
            // 		//executionContext.recoveringFromError = true;
            // 	}
            // }
        };
    }
    function generateActionCalls() {
        var wrap;
        if (!avm1ErrorsEnabled.value) {
            wrap = wrapAvm1Error;
        }
        else {
            wrap = function (fn) {
                return fn;
            };
        }
        return {
            ActionGotoFrame: wrap(avm1_0x81_ActionGotoFrame),
            ActionGetURL: wrap(avm1_0x83_ActionGetURL),
            ActionNextFrame: wrap(avm1_0x04_ActionNextFrame),
            ActionPreviousFrame: wrap(avm1_0x05_ActionPreviousFrame),
            ActionPlay: wrap(avm1_0x06_ActionPlay),
            ActionStop: wrap(avm1_0x07_ActionStop),
            ActionToggleQuality: wrap(avm1_0x08_ActionToggleQuality),
            ActionStopSounds: wrap(avm1_0x09_ActionStopSounds),
            ActionWaitForFrame: wrap(avm1_0x8A_ActionWaitForFrame),
            ActionSetTarget: wrap(avm1_0x8B_ActionSetTarget),
            ActionGoToLabel: wrap(avm1_0x8C_ActionGoToLabel),
            ActionPush: wrap(avm1_0x96_ActionPush),
            ActionPop: wrap(avm1_0x17_ActionPop),
            ActionAdd: wrap(avm1_0x0A_ActionAdd),
            ActionSubtract: wrap(avm1_0x0B_ActionSubtract),
            ActionMultiply: wrap(avm1_0x0C_ActionMultiply),
            ActionDivide: wrap(avm1_0x0D_ActionDivide),
            ActionEquals: wrap(avm1_0x0E_ActionEquals),
            ActionLess: wrap(avm1_0x0F_ActionLess),
            ActionAnd: wrap(avm1_0x10_ActionAnd),
            ActionOr: wrap(avm1_0x11_ActionOr),
            ActionNot: wrap(avm1_0x12_ActionNot),
            ActionStringEquals: wrap(avm1_0x13_ActionStringEquals),
            ActionStringLength: wrap(avm1_0x14_ActionStringLength),
            ActionMBStringLength: wrap(avm1_0x31_ActionMBStringLength),
            ActionStringAdd: wrap(avm1_0x21_ActionStringAdd),
            ActionStringExtract: wrap(avm1_0x15_ActionStringExtract),
            ActionMBStringExtract: wrap(avm1_0x35_ActionMBStringExtract),
            ActionStringLess: wrap(avm1_0x29_ActionStringLess),
            ActionToInteger: wrap(avm1_0x18_ActionToInteger),
            ActionCharToAscii: wrap(avm1_0x32_ActionCharToAscii),
            ActionMBCharToAscii: wrap(avm1_0x36_ActionMBCharToAscii),
            ActionAsciiToChar: wrap(avm1_0x33_ActionAsciiToChar),
            ActionMBAsciiToChar: wrap(avm1_0x37_ActionMBAsciiToChar),
            ActionJump: wrap(avm1_0x99_ActionJump),
            ActionIf: wrap(avm1_0x9D_ActionIf),
            ActionCall: wrap(avm1_0x9E_ActionCall),
            ActionGetVariable: wrap(avm1_0x1C_ActionGetVariable),
            ActionSetVariable: wrap(avm1_0x1D_ActionSetVariable),
            ActionGetURL2: wrap(avm1_0x9A_ActionGetURL2),
            ActionGotoFrame2: wrap(avm1_0x9F_ActionGotoFrame2),
            ActionSetTarget2: wrap(avm1_0x20_ActionSetTarget2),
            ActionGetProperty: wrap(avm1_0x22_ActionGetProperty),
            ActionSetProperty: wrap(avm1_0x23_ActionSetProperty),
            ActionCloneSprite: wrap(avm1_0x24_ActionCloneSprite),
            ActionRemoveSprite: wrap(avm1_0x25_ActionRemoveSprite),
            ActionStartDrag: wrap(avm1_0x27_ActionStartDrag),
            ActionEndDrag: wrap(avm1_0x28_ActionEndDrag),
            ActionWaitForFrame2: wrap(avm1_0x8D_ActionWaitForFrame2),
            ActionTrace: wrap(avm1_0x26_ActionTrace),
            ActionGetTime: wrap(avm1_0x34_ActionGetTime),
            ActionRandomNumber: wrap(avm1_0x30_ActionRandomNumber),
            ActionCallFunction: wrap(avm1_0x3D_ActionCallFunction),
            ActionCallMethod: wrap(avm1_0x52_ActionCallMethod),
            ActionConstantPool: wrap(avm1_0x88_ActionConstantPool),
            ActionDefineFunction: wrap(avm1_0x9B_ActionDefineFunction),
            ActionDefineLocal: wrap(avm1_0x3C_ActionDefineLocal),
            ActionDefineLocal2: wrap(avm1_0x41_ActionDefineLocal2),
            ActionDelete: wrap(avm1_0x3A_ActionDelete),
            ActionDelete2: wrap(avm1_0x3B_ActionDelete2),
            ActionEnumerate: wrap(avm1_0x46_ActionEnumerate),
            ActionEquals2: wrap(avm1_0x49_ActionEquals2),
            ActionGetMember: wrap(avm1_0x4E_ActionGetMember),
            ActionInitArray: wrap(avm1_0x42_ActionInitArray),
            ActionInitObject: wrap(avm1_0x43_ActionInitObject),
            ActionNewMethod: wrap(avm1_0x53_ActionNewMethod),
            ActionNewObject: wrap(avm1_0x40_ActionNewObject),
            ActionSetMember: wrap(avm1_0x4F_ActionSetMember),
            ActionTargetPath: wrap(avm1_0x45_ActionTargetPath),
            ActionWith: wrap(avm1_0x94_ActionWith),
            ActionToNumber: wrap(avm1_0x4A_ActionToNumber),
            ActionToString: wrap(avm1_0x4B_ActionToString),
            ActionTypeOf: wrap(avm1_0x44_ActionTypeOf),
            ActionAdd2: wrap(avm1_0x47_ActionAdd2),
            ActionLess2: wrap(avm1_0x48_ActionLess2),
            ActionModulo: wrap(avm1_0x3F_ActionModulo),
            ActionBitAnd: wrap(avm1_0x60_ActionBitAnd),
            ActionBitLShift: wrap(avm1_0x63_ActionBitLShift),
            ActionBitOr: wrap(avm1_0x61_ActionBitOr),
            ActionBitRShift: wrap(avm1_0x64_ActionBitRShift),
            ActionBitURShift: wrap(avm1_0x65_ActionBitURShift),
            ActionBitXor: wrap(avm1_0x62_ActionBitXor),
            ActionDecrement: wrap(avm1_0x51_ActionDecrement),
            ActionIncrement: wrap(avm1_0x50_ActionIncrement),
            ActionPushDuplicate: wrap(avm1_0x4C_ActionPushDuplicate),
            ActionReturn: wrap(avm1_0x3E_ActionReturn),
            ActionStackSwap: wrap(avm1_0x4D_ActionStackSwap),
            ActionStoreRegister: wrap(avm1_0x87_ActionStoreRegister),
            ActionInstanceOf: wrap(avm1_0x54_ActionInstanceOf),
            ActionEnumerate2: wrap(avm1_0x55_ActionEnumerate2),
            ActionStrictEquals: wrap(avm1_0x66_ActionStrictEquals),
            ActionGreater: wrap(avm1_0x67_ActionGreater),
            ActionStringGreater: wrap(avm1_0x68_ActionStringGreater),
            ActionDefineFunction2: wrap(avm1_0x8E_ActionDefineFunction2),
            ActionExtends: wrap(avm1_0x69_ActionExtends),
            ActionCastOp: wrap(avm1_0x2B_ActionCastOp),
            ActionImplementsOp: wrap(avm1_0x2C_ActionImplementsOp),
            ActionTry: wrap(avm1_0x8F_ActionTry),
            ActionThrow: wrap(avm1_0x2A_ActionThrow),
            ActionFSCommand2: wrap(avm1_0x2D_ActionFSCommand2),
            ActionStrictMode: wrap(avm1_0x89_ActionStrictMode)
        };
    }
    function interpretAction(executionContext, parsedAction) {
        var stack = executionContext.stack;
        var actionCode = parsedAction.actionCode;
        var args = parsedAction.args;
        var actionTracer = executionContext.context.actionTracer;
        release$1 || (actionTracer && actionTracer.print(parsedAction, stack));
        var shallBranch = false;
        switch (actionCode | 0) {
            // SWF 3 actions
            case 129 /* ActionGotoFrame */:
                avm1_0x81_ActionGotoFrame(executionContext, args);
                break;
            case 131 /* ActionGetURL */:
                avm1_0x83_ActionGetURL(executionContext, args);
                break;
            case 4 /* ActionNextFrame */:
                avm1_0x04_ActionNextFrame(executionContext);
                break;
            case 5 /* ActionPreviousFrame */:
                avm1_0x05_ActionPreviousFrame(executionContext);
                break;
            case 6 /* ActionPlay */:
                avm1_0x06_ActionPlay(executionContext);
                break;
            case 7 /* ActionStop */:
                avm1_0x07_ActionStop(executionContext);
                break;
            case 8 /* ActionToggleQuality */:
                avm1_0x08_ActionToggleQuality(executionContext);
                break;
            case 9 /* ActionStopSounds */:
                avm1_0x09_ActionStopSounds(executionContext);
                break;
            case 138 /* ActionWaitForFrame */:
                shallBranch = avm1_0x8A_ActionWaitForFrame(executionContext, args);
                break;
            case 139 /* ActionSetTarget */:
                avm1_0x8B_ActionSetTarget(executionContext, args);
                break;
            case 140 /* ActionGoToLabel */:
                avm1_0x8C_ActionGoToLabel(executionContext, args);
                break;
            // SWF 4 actions
            case 150 /* ActionPush */:
                avm1_0x96_ActionPush(executionContext, args);
                break;
            case 23 /* ActionPop */:
                avm1_0x17_ActionPop(executionContext);
                break;
            case 10 /* ActionAdd */:
                avm1_0x0A_ActionAdd(executionContext);
                break;
            case 11 /* ActionSubtract */:
                avm1_0x0B_ActionSubtract(executionContext);
                break;
            case 12 /* ActionMultiply */:
                avm1_0x0C_ActionMultiply(executionContext);
                break;
            case 13 /* ActionDivide */:
                avm1_0x0D_ActionDivide(executionContext);
                break;
            case 14 /* ActionEquals */:
                avm1_0x0E_ActionEquals(executionContext);
                break;
            case 15 /* ActionLess */:
                avm1_0x0F_ActionLess(executionContext);
                break;
            case 16 /* ActionAnd */:
                avm1_0x10_ActionAnd(executionContext);
                break;
            case 17 /* ActionOr */:
                avm1_0x11_ActionOr(executionContext);
                break;
            case 18 /* ActionNot */:
                avm1_0x12_ActionNot(executionContext);
                break;
            case 19 /* ActionStringEquals */:
                avm1_0x13_ActionStringEquals(executionContext);
                break;
            case 20 /* ActionStringLength */:
                avm1_0x14_ActionStringLength(executionContext);
                break;
            case 49 /* ActionMBStringLength */:
                avm1_0x31_ActionMBStringLength(executionContext);
                break;
            case 33 /* ActionStringAdd */:
                avm1_0x21_ActionStringAdd(executionContext);
                break;
            case 21 /* ActionStringExtract */:
                avm1_0x15_ActionStringExtract(executionContext);
                break;
            case 53 /* ActionMBStringExtract */:
                avm1_0x35_ActionMBStringExtract(executionContext);
                break;
            case 41 /* ActionStringLess */:
                avm1_0x29_ActionStringLess(executionContext);
                break;
            case 24 /* ActionToInteger */:
                avm1_0x18_ActionToInteger(executionContext);
                break;
            case 50 /* ActionCharToAscii */:
                avm1_0x32_ActionCharToAscii(executionContext);
                break;
            case 54 /* ActionMBCharToAscii */:
                avm1_0x36_ActionMBCharToAscii(executionContext);
                break;
            case 51 /* ActionAsciiToChar */:
                avm1_0x33_ActionAsciiToChar(executionContext);
                break;
            case 55 /* ActionMBAsciiToChar */:
                avm1_0x37_ActionMBAsciiToChar(executionContext);
                break;
            case 153 /* ActionJump */:
                break;
            case 157 /* ActionIf */:
                shallBranch = avm1_0x9D_ActionIf(executionContext, args);
                break;
            case 158 /* ActionCall */:
                avm1_0x9E_ActionCall(executionContext);
                break;
            case 28 /* ActionGetVariable */:
                avm1_0x1C_ActionGetVariable(executionContext);
                break;
            case 29 /* ActionSetVariable */:
                avm1_0x1D_ActionSetVariable(executionContext);
                break;
            case 154 /* ActionGetURL2 */:
                avm1_0x9A_ActionGetURL2(executionContext, args);
                break;
            case 159 /* ActionGotoFrame2 */:
                avm1_0x9F_ActionGotoFrame2(executionContext, args);
                break;
            case 32 /* ActionSetTarget2 */:
                avm1_0x20_ActionSetTarget2(executionContext);
                break;
            case 34 /* ActionGetProperty */:
                avm1_0x22_ActionGetProperty(executionContext);
                break;
            case 35 /* ActionSetProperty */:
                avm1_0x23_ActionSetProperty(executionContext);
                break;
            case 36 /* ActionCloneSprite */:
                avm1_0x24_ActionCloneSprite(executionContext);
                break;
            case 37 /* ActionRemoveSprite */:
                avm1_0x25_ActionRemoveSprite(executionContext);
                break;
            case 39 /* ActionStartDrag */:
                avm1_0x27_ActionStartDrag(executionContext);
                break;
            case 40 /* ActionEndDrag */:
                avm1_0x28_ActionEndDrag(executionContext);
                break;
            case 141 /* ActionWaitForFrame2 */:
                shallBranch = avm1_0x8D_ActionWaitForFrame2(executionContext, args);
                break;
            case 38 /* ActionTrace */:
                avm1_0x26_ActionTrace(executionContext);
                break;
            case 52 /* ActionGetTime */:
                avm1_0x34_ActionGetTime(executionContext);
                break;
            case 48 /* ActionRandomNumber */:
                avm1_0x30_ActionRandomNumber(executionContext);
                break;
            // SWF 5
            case 61 /* ActionCallFunction */:
                avm1_0x3D_ActionCallFunction(executionContext);
                break;
            case 82 /* ActionCallMethod */:
                avm1_0x52_ActionCallMethod(executionContext);
                break;
            case 136 /* ActionConstantPool */:
                avm1_0x88_ActionConstantPool(executionContext, args);
                break;
            case 155 /* ActionDefineFunction */:
                avm1_0x9B_ActionDefineFunction(executionContext, args);
                break;
            case 60 /* ActionDefineLocal */:
                avm1_0x3C_ActionDefineLocal(executionContext);
                break;
            case 65 /* ActionDefineLocal2 */:
                avm1_0x41_ActionDefineLocal2(executionContext);
                break;
            case 58 /* ActionDelete */:
                avm1_0x3A_ActionDelete(executionContext);
                break;
            case 59 /* ActionDelete2 */:
                avm1_0x3B_ActionDelete2(executionContext);
                break;
            case 70 /* ActionEnumerate */:
                avm1_0x46_ActionEnumerate(executionContext);
                break;
            case 73 /* ActionEquals2 */:
                avm1_0x49_ActionEquals2(executionContext);
                break;
            case 78 /* ActionGetMember */:
                avm1_0x4E_ActionGetMember(executionContext);
                break;
            case 66 /* ActionInitArray */:
                avm1_0x42_ActionInitArray(executionContext);
                break;
            case 67 /* ActionInitObject */:
                avm1_0x43_ActionInitObject(executionContext);
                break;
            case 83 /* ActionNewMethod */:
                avm1_0x53_ActionNewMethod(executionContext);
                break;
            case 64 /* ActionNewObject */:
                avm1_0x40_ActionNewObject(executionContext);
                break;
            case 79 /* ActionSetMember */:
                avm1_0x4F_ActionSetMember(executionContext);
                break;
            case 69 /* ActionTargetPath */:
                avm1_0x45_ActionTargetPath(executionContext);
                break;
            case 148 /* ActionWith */:
                avm1_0x94_ActionWith(executionContext, args);
                break;
            case 74 /* ActionToNumber */:
                avm1_0x4A_ActionToNumber(executionContext);
                break;
            case 75 /* ActionToString */:
                avm1_0x4B_ActionToString(executionContext);
                break;
            case 68 /* ActionTypeOf */:
                avm1_0x44_ActionTypeOf(executionContext);
                break;
            case 71 /* ActionAdd2 */:
                avm1_0x47_ActionAdd2(executionContext);
                break;
            case 72 /* ActionLess2 */:
                avm1_0x48_ActionLess2(executionContext);
                break;
            case 63 /* ActionModulo */:
                avm1_0x3F_ActionModulo(executionContext);
                break;
            case 96 /* ActionBitAnd */:
                avm1_0x60_ActionBitAnd(executionContext);
                break;
            case 99 /* ActionBitLShift */:
                avm1_0x63_ActionBitLShift(executionContext);
                break;
            case 97 /* ActionBitOr */:
                avm1_0x61_ActionBitOr(executionContext);
                break;
            case 100 /* ActionBitRShift */:
                avm1_0x64_ActionBitRShift(executionContext);
                break;
            case 101 /* ActionBitURShift */:
                avm1_0x65_ActionBitURShift(executionContext);
                break;
            case 98 /* ActionBitXor */:
                avm1_0x62_ActionBitXor(executionContext);
                break;
            case 81 /* ActionDecrement */:
                avm1_0x51_ActionDecrement(executionContext);
                break;
            case 80 /* ActionIncrement */:
                avm1_0x50_ActionIncrement(executionContext);
                break;
            case 76 /* ActionPushDuplicate */:
                avm1_0x4C_ActionPushDuplicate(executionContext);
                break;
            case 62 /* ActionReturn */:
                avm1_0x3E_ActionReturn(executionContext);
                break;
            case 77 /* ActionStackSwap */:
                avm1_0x4D_ActionStackSwap(executionContext);
                break;
            case 135 /* ActionStoreRegister */:
                avm1_0x87_ActionStoreRegister(executionContext, args);
                break;
            // SWF 6
            case 84 /* ActionInstanceOf */:
                avm1_0x54_ActionInstanceOf(executionContext);
                break;
            case 85 /* ActionEnumerate2 */:
                avm1_0x55_ActionEnumerate2(executionContext);
                break;
            case 102 /* ActionStrictEquals */:
                avm1_0x66_ActionStrictEquals(executionContext);
                break;
            case 103 /* ActionGreater */:
                avm1_0x67_ActionGreater(executionContext);
                break;
            case 104 /* ActionStringGreater */:
                avm1_0x68_ActionStringGreater(executionContext);
                break;
            // SWF 7
            case 142 /* ActionDefineFunction2 */:
                avm1_0x8E_ActionDefineFunction2(executionContext, args);
                break;
            case 105 /* ActionExtends */:
                avm1_0x69_ActionExtends(executionContext);
                break;
            case 43 /* ActionCastOp */:
                avm1_0x2B_ActionCastOp(executionContext);
                break;
            case 44 /* ActionImplementsOp */:
                avm1_0x2C_ActionImplementsOp(executionContext);
                break;
            case 143 /* ActionTry */:
                avm1_0x8F_ActionTry(executionContext, args);
                break;
            case 42 /* ActionThrow */:
                avm1_0x2A_ActionThrow(executionContext);
                break;
            // Not documented by the spec
            case 45 /* ActionFSCommand2 */:
                avm1_0x2D_ActionFSCommand2(executionContext);
                break;
            case 137 /* ActionStrictMode */:
                avm1_0x89_ActionStrictMode(executionContext, args);
                break;
            case 0 /* None */: // End of actions
                executionContext.isEndOfActions = true;
                break;
            default:
                throw new Error('Unknown action code: ' + actionCode);
        }
        return shallBranch;
    }
    function interpretActionWithRecovery(executionContext, parsedAction) {
        var currentContext;
        var result;
        try {
            result = interpretAction(executionContext, parsedAction);
            executionContext.recoveringFromError = false;
        }
        catch (e) {
            // handling AVM1 errors
            currentContext = executionContext.context;
            e = as2CastError(e);
            if ((avm1ErrorsEnabled.value && !currentContext.isTryCatchListening) ||
                e instanceof AVM1CriticalError) {
                throw e;
            }
            if (e instanceof AVM1Error) {
                throw e;
            }
            Telemetry.instance.reportTelemetry({ topic: 'error', error: 1 /* AVM1_ERROR */ });
            if (!executionContext.recoveringFromError) {
                if (currentContext.errorsIgnored++ >= MAX_AVM1_ERRORS_LIMIT) {
                    throw new AVM1CriticalError('long running script -- AVM1 errors limit is reached');
                }
                console.error('AVM1 error: ' + e);
                // REDUX
                //var avm2 = Shumway.AVM2.Runtime.AVM2;
                //avm2.instance.exceptions.push({source: 'avm1', message: e.message,
                //  stack: e.stack});
                executionContext.recoveringFromError = true;
            }
        }
        return result;
    }
    function analyzeAndCompileActionsData(ectx, actionsData) {
        var context = ectx.context;
        var compiled;
        /*if (avm1WellknownActionsCompilationsEnabled.value) {
            compiled = findWellknowCompilation(actionsData, context);
            if (compiled) {
                actionsData.compiled = compiled;
                return;
            }
        }*/
        var parser = new ActionsDataParser(actionsData, context.swfVersion);
        var analyzer = new ActionsDataAnalyzer();
        analyzer.registersLimit = ectx.registers.length;
        analyzer.parentResults = actionsData.parent && actionsData.parent.ir;
        var ir = analyzer.analyze(parser);
        actionsData.ir = ir;
        if (avm1CompilerEnabled.value) {
            try {
                var c = new ActionsDataCompiler();
                compiled = c.generate(ir);
                actionsData.compiled = compiled;
            }
            catch (e) {
                console.error('Unable to compile AVM1 function: ' + e);
            }
        }
    }
    function interpretActionsData(ectx, actionsData) {
        if (!actionsData.ir && !actionsData.compiled) {
            analyzeAndCompileActionsData(ectx, actionsData);
        }
        var currentContext = ectx.context;
        var scopeList = ectx.scopeList;
        var scope = scopeList.scope;
        var awayObject = scope.adaptee; // FIXME refactor
        if (awayObject && awayObject._deferScriptExecution) {
            currentContext.deferScriptExecution = true;
        }
        if (awayObject) {
            AVM1MovieClip.currentMCAssetNameSpace = awayObject.assetNamespace;
        }
        var compiled = actionsData.compiled;
        if (compiled) {
            release$1 || (currentContext.actionTracer && currentContext.actionTracer.message('Running compiled ' + actionsData.id));
            return compiled(ectx);
        }
        var instructionsExecuted = 0;
        var abortExecutionAt = currentContext.abortExecutionAt;
        if (avm1DebuggerEnabled.value &&
            (Debugger.pause || Debugger.breakpoints[ir.dataId])) {
            debugger;
        }
        var ir = actionsData.ir;
        release$1 || Debug$1.assert(ir);
        var position = 0;
        var nextAction = ir.actions[position];
        // will try again if we are skipping errors
        while (nextAction && !ectx.isEndOfActions) {
            // let's check timeout/Date.now every some number of instructions
            if (instructionsExecuted++ % CHECK_AVM1_HANG_EVERY === 0 && Date.now() >= abortExecutionAt) {
                throw new AVM1CriticalError('long running script -- AVM1 instruction hang timeout');
            }
            var shallBranch = interpretActionWithRecovery(ectx, nextAction.action);
            if (shallBranch) {
                position = nextAction.conditionalJumpTo;
            }
            else {
                position = nextAction.next;
            }
            nextAction = ir.actions[position];
        }
        var stack = ectx.stack;
        return stack.pop();
    }
    var ActionTracer = /** @class */ (function () {
        function ActionTracer() {
            this._indentation = 0;
            this._indentStringCache = [];
        }
        ActionTracer.prototype._getIndentString = function () {
            return this._indentStringCache[this._indentation] ||
                (this._indentStringCache[this._indentation] = new Array(this._indentation + 1).join('..'));
        };
        ActionTracer.prototype.print = function (parsedAction, stack) {
            var position = parsedAction.position;
            var actionCode = parsedAction.actionCode;
            var actionName = parsedAction.actionName;
            var stackDump = [];
            for (var q = 0; q < stack.length; q++) {
                var item = stack[q];
                if (item && typeof item === 'object') {
                    var constr = item.alGetConstructorProperty();
                    stackDump.push('[' + (constr ? constr.name : 'Object') + ']');
                }
                else {
                    stackDump.push(item);
                }
            }
            console.log('AVM1 trace: ' + this._getIndentString() + position + ': ' +
                actionName + '(' + actionCode.toString(16) + '), ' +
                'stack=' + stackDump);
        };
        ActionTracer.prototype.indent = function () {
            this._indentation++;
        };
        ActionTracer.prototype.unindent = function () {
            this._indentation--;
        };
        ActionTracer.prototype.message = function (msg) {
            console.log('AVM1 trace: ------- ' + msg);
        };
        return ActionTracer;
    }());

    var LoaderInfo$1 = /** @class */ (function (_super) {
        __extends(LoaderInfo$$1, _super);
        function LoaderInfo$$1() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.swfVersion = 0;
            return _this;
        }
        LoaderInfo$$1.prototype.getSymbolById = function (id) {
        };
        return LoaderInfo$$1;
    }(LoaderInfo));

    /**
     * The XMLNodeType class contains constants used with
     * <codeph class="+ topic/ph pr-d/codeph ">XMLNode.nodeType</codeph>. The values are defined
     * by the NodeType enumeration in the
     * W3C DOM Level 1 recommendation:
     * <xref href="http://www.w3.org/TR/1998/REC-DOM-Level-1-19981001/level-one-core.html" scope="external" class="- topic/xref ">http://www.w3.org/TR/1998/REC-DOM-Level-1-19981001/level-one-core.html</xref>
     * @langversion	3.0
     * @playerversion	Flash 9
     * @playerversion	Lite 4
     */
    var XMLNodeType = /** @class */ (function () {
        function XMLNodeType() {
            // todo: why does this have a constructor ? it just provides static props...
        }
        //80pro todo: all values above 100 are value i assigned, maybe worth to check what they was in original as3
        XMLNodeType.CDATA_NODE = 100;
        XMLNodeType.COMMENT_NODE = 101;
        XMLNodeType.DOCUMENT_TYPE_NODE = 102;
        /**
         * Specifies that the node is an element.
         * This constant is used with XMLNode.nodeType.
         * The value is defined by the NodeType enumeration in the
         * W3C DOM Level 1 recommendation:
         * http://www.w3.org/TR/1998/REC-DOM-Level-1-19981001/level-one-core.html
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         */
        XMLNodeType.ELEMENT_NODE = 1;
        XMLNodeType.PROCESSING_INSTRUCTION_NODE = 103;
        /**
         * Specifies that the node is a text node.
         * This constant is used with XMLNode.nodeType.
         * The value is defined by the NodeType enumeration in the
         * W3C DOM Level 1 recommendation:
         * http://www.w3.org/TR/1998/REC-DOM-Level-1-19981001/level-one-core.html
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         */
        XMLNodeType.TEXT_NODE = 3;
        XMLNodeType.XML_DECLARATION = 104;
        return XMLNodeType;
    }());

    /**
     * The XMLDocument class represents the legacy XML object
     * that was present in ActionScript 2.0. It was renamed in ActionScript 3.0
     * to XMLDocument to avoid name conflicts with the new
     * XML class in ActionScript 3.0. In ActionScript 3.0,
     * it is recommended that you use the new
     * <xref href="../../XML.html" class="- topic/xref ">XML</xref> class and related classes,
     * which support E4X (ECMAScript for XML).
     *
     *   <p class="- topic/p ">The XMLDocument class, as well as XMLNode and XMLNodeType, are present for backward
     * compatibility. The functionality for loading XML documents can now be found in the
     * URLLoader class.</p>
     */
    var XMLDocumentAway = /** @class */ (function (_super) {
        __extends(XMLDocumentAway, _super);
        /**
         * Creates a new XMLDocument object. You must use the constructor to create an XMLDocument object before you call any of the methods of the XMLDocument class.
         * Note: Use the createElement() and createTextNode() methods to add elements and text nodes to an XML document tree.
         * @param	source	The XML text parsed to create the new XMLDocument object.
         */
        function XMLDocumentAway(source) {
            if (source === void 0) { source = null; }
            return _super.call(this, XMLNodeType.DOCUMENT_TYPE_NODE, "null") || this;
        }
        // for AVM1:
        XMLDocumentAway.prototype.axCallPublicProperty = function (value1, value2) {
            return null;
        };
        XMLDocumentAway.prototype.axGetPublicProperty = function (value) {
            return null;
        };
        XMLDocumentAway.prototype.axSetPublicProperty = function (value, value2) {
            return null;
        };
        /**
         * Creates a new XMLNode object with the name specified in the parameter.
         * The new node initially has no parent, no children, and no siblings.
         * The method returns a reference to the newly created XMLNode object
         * that represents the element. This method and the XMLDocument.createTextNode()
         * method are the constructor methods for creating nodes for an XMLDocument object.
         * @param	name	The tag name of the XMLDocument element being created.
         * @return	An XMLNode object.
         * */
        XMLDocumentAway.prototype.createElement = function (name) {
            console.log("createElement not implemented yet in flash/XMLDocument");
            return null;
        };
        /**
         * Creates a new XML text node with the specified text. The new node initially has no parent, and text nodes cannot have children or siblings. This method returns a reference to the XMLDocument object that represents the new text node. This method and the XMLDocument.createElement() method are the constructor methods for creating nodes for an XMLDocument object.
         * @param	text	The text used to create the new text node.
         * @return	An XMLNode object.
         */
        XMLDocumentAway.prototype.createTextNode = function (text) {
            console.log("createTextNode not implemented yet in flash/XMLDocument");
            return null;
        };
        /**
         * Parses the XML text specified in the value parameter
         * and populates the specified XMLDocument object with the resulting XML tree. Any existing trees in the XMLDocument object are discarded.
         * @param	source	The XML text to be parsed and passed to the specified XMLDocument object.
         */
        XMLDocumentAway.prototype.parseXML = function (source) {
            console.log("parseXML not implemented yet in flash/XMLDocument");
        };
        /**
         * Returns a string representation of the XML object.
         * @return	A string representation of the XML object.
         */
        XMLDocumentAway.prototype.toString = function () {
            console.log("toString not implemented yet in flash/XMLDocument");
            return "";
        };
        return XMLDocumentAway;
    }(XMLNode));

    var CONSTANTNames = ["Undefined", "Utf8|ClassSealed", "Float|ClassFinal", "Int", "UInt|ClassInterface", "PrivateNs", "Double", "QName", "Namespace|ClassProtectedNs", "Multiname", "False", "True", "Null", "QNameA", "MultinameA", "RTQName", "RTQNameA", "RTQNameL", "RTQNameLA", "NameL", "NameLA", "NamespaceSet", "PackageNamespace", "PackageInternalNs", "ProtectedNamespace", "ExplicitNamespace", "StaticProtectedNs", "MultinameL", "MultinameLA", "TypeName"];
    function getCONSTANTName(constant) {
        return release$1 ? String(constant) : CONSTANTNames[constant];
    }

    var _namespaces = {};

    var namespaceTypeNames = ["Public", "Protected", "PackageInternal", "Private", "Explicit", "StaticProtected"];
    function getNamespaceTypeName(namespaceType) {
        return release$1 ? String(namespaceType) : namespaceTypeNames[namespaceType];
    }

    var _md5R = new Uint8Array([
        7, 12, 17, 22, 7, 12, 17, 22, 7, 12, 17, 22, 7, 12, 17, 22,
        5, 9, 14, 20, 5, 9, 14, 20, 5, 9, 14, 20, 5, 9, 14, 20,
        4, 11, 16, 23, 4, 11, 16, 23, 4, 11, 16, 23, 4, 11, 16, 23,
        6, 10, 15, 21, 6, 10, 15, 21, 6, 10, 15, 21, 6, 10, 15, 21
    ]);
    var _md5K = new Int32Array([
        -680876936, -389564586, 606105819, -1044525330, -176418897, 1200080426,
        -1473231341, -45705983, 1770035416, -1958414417, -42063, -1990404162,
        1804603682, -40341101, -1502002290, 1236535329, -165796510, -1069501632,
        643717713, -373897302, -701558691, 38016083, -660478335, -405537848,
        568446438, -1019803690, -187363961, 1163531501, -1444681467, -51403784,
        1735328473, -1926607734, -378558, -2022574463, 1839030562, -35309556,
        -1530992060, 1272893353, -155497632, -1094730640, 681279174, -358537222,
        -722521979, 76029189, -640364487, -421815835, 530742520, -995338651,
        -198630844, 1126891415, -1416354905, -57434055, 1700485571, -1894986606,
        -1051523, -2054922799, 1873313359, -30611744, -1560198380, 1309151649,
        -145523070, -1120210379, 718787259, -343485551
    ]);
    function hashBytesTo32BitsMD5(data, offset, length) {
        var r = _md5R;
        var k = _md5K;
        var h0 = 1732584193, h1 = -271733879, h2 = -1732584194, h3 = 271733878;
        // pre-processing
        var paddedLength = (length + 72) & ~63; // data + 9 extra bytes
        var padded = new Uint8Array(paddedLength);
        var i, j, n;
        for (i = 0; i < length; ++i) {
            padded[i] = data[offset++];
        }
        padded[i++] = 0x80;
        n = paddedLength - 8;
        while (i < n) {
            padded[i++] = 0;
        }
        padded[i++] = (length << 3) & 0xFF;
        padded[i++] = (length >> 5) & 0xFF;
        padded[i++] = (length >> 13) & 0xFF;
        padded[i++] = (length >> 21) & 0xFF;
        padded[i++] = (length >>> 29) & 0xFF;
        padded[i++] = 0;
        padded[i++] = 0;
        padded[i++] = 0;
        // chunking
        // TODO ArrayBuffer ?
        var w = new Int32Array(16);
        for (i = 0; i < paddedLength;) {
            for (j = 0; j < 16; ++j, i += 4) {
                w[j] = (padded[i] | (padded[i + 1] << 8) |
                    (padded[i + 2] << 16) | (padded[i + 3] << 24));
            }
            var a = h0, b = h1, c = h2, d = h3, f, g;
            for (j = 0; j < 64; ++j) {
                if (j < 16) {
                    f = (b & c) | ((~b) & d);
                    g = j;
                }
                else if (j < 32) {
                    f = (d & b) | ((~d) & c);
                    g = (5 * j + 1) & 15;
                }
                else if (j < 48) {
                    f = b ^ c ^ d;
                    g = (3 * j + 5) & 15;
                }
                else {
                    f = c ^ (b | (~d));
                    g = (7 * j) & 15;
                }
                var tmp = d, rotateArg = (a + f + k[j] + w[g]) | 0, rotate = r[j];
                d = c;
                c = b;
                b = (b + ((rotateArg << rotate) | (rotateArg >>> (32 - rotate)))) | 0;
                a = tmp;
            }
            h0 = (h0 + a) | 0;
            h1 = (h1 + b) | 0;
            h2 = (h2 + c) | 0;
            h3 = (h3 + d) | 0;
        }
        return h0;
    }
    function mixHash(a, b) {
        return (((31 * a) | 0) + b) | 0;
    }
    var HashUtilities = {
        _md5R: _md5R,
        _md5K: _md5K,
        hashBytesTo32BitsMD5: hashBytesTo32BitsMD5,
        mixHash: mixHash
    };

    // Used in _hashNamespace so we don't need to allocate a new buffer each time.
    var namespaceHashingBuffer = new Uint8Array(100);

    var Namespace = /** @class */ (function () {
        function Namespace(type, uri, prefix) {
            this.type = type;
            this.uri = uri;
            this.prefix = prefix;
            this.mangledName = null;
            assert(type !== undefined);
            this.mangleName();
            if (!release$1) {
                Object.freeze(this);
            }
        }
        Namespace.prototype.toString = function () {
            return getNamespaceTypeName(this.type) + (this.uri !== "" ? ":" + this.uri : "");
        };
        Namespace._hashNamespace = function (type, uri, prefix) {
            uri = uri + '';
            prefix = prefix + '';
            var index = Namespace._knownNames.indexOf(uri);
            if (index >= 0) {
                return type << 2 | index;
            }
            var length = 1 + uri.length + prefix.length;
            var data = length < 101 ? namespaceHashingBuffer : new Uint8Array(length);
            var j = 0;
            data[j++] = type;
            for (var i = 0; i < uri.length; i++) {
                data[j++] = uri.charCodeAt(i);
            }
            for (var i = 0; i < prefix.length; i++) {
                data[j++] = prefix.charCodeAt(i);
            }
            return HashUtilities.hashBytesTo32BitsMD5(data, 0, j);
        };
        Namespace.prototype.mangleName = function () {
            if (this.type === 0 /* Public */ && this.uri === '') {
                this.mangledName = 'Bg';
                return;
            }
            var nsHash = Namespace._hashNamespace(this.type, this.uri, this.prefix);
            this.mangledName = StringUtilities.variableLengthEncodeInt32(nsHash);
        };
        Namespace.prototype.isPublic = function () {
            return this.type === 0 /* Public */;
        };
        Object.defineProperty(Namespace.prototype, "reflectedURI", {
            get: function () {
                // For public names without a URI, Tamarin uses `null`, we use `""`.
                // Hence: special-casing for reflection.
                return this.uri || (this.type === 0 /* Public */ ? null : this.uri);
            },
            enumerable: true,
            configurable: true
        });
        Namespace._knownNames = [
            ""
        ];
        return Namespace;
    }());

    function internNamespace(type, uri) {
        var key = type + uri;
        return _namespaces[key] || (_namespaces[key] = new Namespace(type, uri, ''));
    }

    function internPrefixedNamespace(type, uri, prefix) {
        var key = type + uri + prefix;
        var ns = _namespaces[key];
        if (!ns) {
            ns = _namespaces[key] = new Namespace(type, uri, prefix);
        }
        return ns;
    }

    /**
     * Similar to |toString| but returns |null| for |null| or |undefined| instead
     * of "null" or "undefined".
     */
    function axCoerceString$3(x) {
        if (typeof x === "string") {
            return x;
        }
        else if (x == undefined) {
            return null;
        }
        return x + '';
    }

    var Multiname = /** @class */ (function () {
        function Multiname(abc, index, kind, namespaces, name, parameterType, mutable) {
            if (parameterType === void 0) { parameterType = null; }
            if (mutable === void 0) { mutable = false; }
            this.abc = abc;
            this.index = index;
            this.kind = kind;
            this.namespaces = namespaces;
            this.name = name;
            this.parameterType = parameterType;
            this.mutable = mutable;
            this.id = Multiname._nextID++;
            this._mangledName = null;
            this.script = null;
            this.numeric = false;
            this.numericValue = 0;
            this.resolved = {};
            this.scope = null;
            this.value = null;
            this._key = null;
            this.others = null;
            // ...
        }
        Multiname.prototype.rename = function (name) {
            if (this.others == null)
                this.others = {};
            var rn = this.others[name];
            if (rn === undefined) {
                rn = new Multiname(this.abc, -1, null, this.namespaces, name, this.parameterType);
                rn.script = this.script;
                this.others[name] = rn;
            }
            return rn;
        };
        Multiname.prototype.key = function () {
            if (this._key)
                return this._key;
            var r = this.toString();
            if (!this.mutable)
                this._key = r;
            return r;
        };
        Multiname.FromFQNString = function (fqn, nsType) {
            var lastDot = fqn.lastIndexOf('.');
            var uri = lastDot === -1 ? '' : fqn.substr(0, lastDot);
            var name = lastDot === -1 ? fqn : fqn.substr(lastDot + 1);
            var ns = internNamespace(nsType, uri);
            return new Multiname(null, 0, 15 /* RTQName */, [ns], name);
        };
        Multiname.prototype._nameToString = function () {
            if (this.isAnyName()) {
                return "*";
            }
            return this.isRuntimeName() ? "[" + this.name + "]" : this.name;
        };
        Multiname.prototype.isRuntime = function () {
            switch (this.kind) {
                case 7 /* QName */:
                case 13 /* QNameA */:
                case 9 /* Multiname */:
                case 14 /* MultinameA */:
                    return false;
            }
            return true;
        };
        Multiname.prototype.isRuntimeName = function () {
            switch (this.kind) {
                case 17 /* RTQNameL */:
                case 18 /* RTQNameLA */:
                case 27 /* MultinameL */:
                case 28 /* MultinameLA */:
                    return true;
            }
            return false;
        };
        Multiname.prototype.isRuntimeNamespace = function () {
            switch (this.kind) {
                case 15 /* RTQName */:
                case 16 /* RTQNameA */:
                case 17 /* RTQNameL */:
                case 18 /* RTQNameLA */:
                    return true;
            }
            return false;
        };
        Multiname.prototype.isAnyName = function () {
            return this.name === null;
        };
        Multiname.prototype.isAnyNamespace = function () {
            if (this.isRuntimeNamespace() || this.namespaces.length > 1) {
                return false;
            }
            return this.namespaces.length === 0 || this.namespaces[0].uri === "";
            // x.* has the same meaning as x.*::*, so look for the former case and give
            // it the same meaning of the latter.
            // return !this.isRuntimeNamespace() &&
            //  (this.namespaces.length === 0 || (this.isAnyName() && this.namespaces.length !== 1));
        };
        Multiname.prototype.isQName = function () {
            var kind = this.kind;
            var result = kind === 29 /* TypeName */ ||
                kind === 7 /* QName */ || kind === 13 /* QNameA */ ||
                kind >= 15 /* RTQName */ && kind <= 18 /* RTQNameLA */;
            release$1 || assert(!(result && this.namespaces.length !== 1));
            return result;
        };
        Object.defineProperty(Multiname.prototype, "namespace", {
            get: function () {
                release$1 || assert(this.isQName());
                return this.namespaces[0];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Multiname.prototype, "uri", {
            get: function () {
                release$1 || assert(this.isQName());
                return this.namespaces[0].uri;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Multiname.prototype, "prefix", {
            get: function () {
                release$1 || assert(this.isQName());
                return this.namespaces[0].prefix;
            },
            set: function (prefix) {
                release$1 || assert(this.isQName());
                var ns = this.namespaces[0];
                if (ns.prefix === prefix) {
                    return;
                }
                this.namespaces[0] = internPrefixedNamespace(ns.type, ns.uri, prefix);
            },
            enumerable: true,
            configurable: true
        });
        Multiname.prototype.equalsQName = function (mn) {
            release$1 || assert(this.isQName());
            return this.name === mn.name && this.namespaces[0].uri === mn.namespaces[0].uri;
        };
        Multiname.prototype.matches = function (mn) {
            release$1 || assert(this.isQName());
            var anyName = mn.isAnyName();
            if (anyName && !mn.isQName()) {
                return true;
            }
            if (!anyName && this.name !== mn.name) {
                return false;
            }
            var uri = this.namespaces[0].uri;
            for (var i = mn.namespaces.length; i--;) {
                if (mn.namespaces[i].uri === uri) {
                    return true;
                }
            }
            return false;
        };
        Multiname.prototype.isAttribute = function () {
            switch (this.kind) {
                case 13 /* QNameA */:
                case 16 /* RTQNameA */:
                case 18 /* RTQNameLA */:
                case 14 /* MultinameA */:
                case 28 /* MultinameLA */:
                    return true;
            }
            return false;
        };
        Multiname.prototype.getMangledName = function () {
            release$1 || assert(this.isQName());
            return this._mangledName || this._mangleName();
        };
        Multiname.prototype._mangleName = function () {
            release$1 || assert(!this._mangledName);
            var mangledName = "$" + this.namespaces[0].mangledName + axCoerceString$3(this.name);
            if (!this.isRuntime()) {
                this._mangledName = mangledName;
            }
            return mangledName;
        };
        Multiname.prototype.getPublicMangledName = function () {
            if (isNumeric(this.name)) {
                return this.name;
            }
            return "$Bg" + axCoerceString$3(this.name);
        };
        Multiname.isPublicQualifiedName = function (value) {
            return value.indexOf('$Bg') === 0;
        };
        Multiname.getPublicMangledName = function (name) {
            if (isNumeric(name)) {
                return name;
            }
            return "$Bg" + name;
        };
        Multiname.prototype.toFQNString = function (useColons) {
            release$1 || assert(this.isQName());
            var prefix = this.namespaces[0].uri;
            if (prefix.length) {
                prefix += (useColons ? '::' : '.');
            }
            return prefix + this.name;
        };
        Multiname.prototype.toString = function () {
            var str = getCONSTANTName(this.kind) + " ";
            str += this.isAttribute() ? "@" : "";
            if (this.isRuntimeNamespace()) {
                var namespaces = this.namespaces ? this.namespaces.map(function (x) { return String(x); }).join(", ") : null;
                str += "[" + namespaces + "]::" + this._nameToString();
            }
            else if (this.isQName()) {
                str += this.namespaces[0] + "::";
                str += this._nameToString();
            }
            else if (this.namespaces) {
                str += "{" + this.namespaces.map(function (x) { return String(x); }).join(", ") + "}";
                str += "::" + this._nameToString();
            }
            else {
                str += "{" + this.namespaces + "}";
                str += "::" + this._nameToString();
            }
            if (this.parameterType) {
                str += "<" + this.parameterType + ">";
            }
            return str;
        };
        Multiname.prototype.toFlashlogString = function () {
            var namespaceUri = this.uri;
            return namespaceUri ? namespaceUri + "::" + this.name : this.name;
        };
        /**
         * Removes the public prefix, or returns undefined if the prefix doesn't exist.
         */
        Multiname.stripPublicMangledName = function (name) {
            if (name.indexOf("$Bg") === 0) {
                return name.substring(3);
            }
            return undefined;
        };
        Multiname.FromSimpleName = function (simpleName) {
            var nameIndex = simpleName.lastIndexOf(".");
            if (nameIndex <= 0) {
                nameIndex = simpleName.lastIndexOf(" ");
            }
            var uri = '';
            var name;
            if (nameIndex > 0 && nameIndex < simpleName.length - 1) {
                name = simpleName.substring(nameIndex + 1).trim();
                uri = simpleName.substring(0, nameIndex).trim();
            }
            else {
                name = simpleName;
            }
            var ns = internNamespace(0 /* Public */, uri);
            return new Multiname(null, 0, 15 /* RTQName */, [ns], name);
        };
        Multiname._nextID = 1;
        return Multiname;
    }());

    function boxValue(value) {
        if (isNullOrUndefined$1(value) || isObject$1(value)) {
            return value;
        }
        return Object(value);
    }
    function toKeyValueArray(object) {
        var hasOwnProperty = Object.prototype.hasOwnProperty;
        var array = [];
        for (var k in object) {
            if (hasOwnProperty.call(object, k)) {
                array.push([k, object[k]]);
            }
        }
        return array;
    }
    function isPrototypeWriteable(object) {
        return Object.getOwnPropertyDescriptor(object, "prototype").writable;
    }
    function hasOwnProperty(object, name) {
        return Object.prototype.hasOwnProperty.call(object, name);
    }
    function propertyIsEnumerable(object, name) {
        return Object.prototype.propertyIsEnumerable.call(object, name);
    }
    /**
     * Returns a property descriptor for the own or inherited property with the given name, or
     * null if one doesn't exist.
     */
    function getPropertyDescriptor(object, name) {
        do {
            var propDesc = Object.getOwnPropertyDescriptor(object, name);
            if (propDesc) {
                return propDesc;
            }
            object = Object.getPrototypeOf(object);
        } while (object);
        return null;
    }
    function hasOwnGetter(object, name) {
        var d = Object.getOwnPropertyDescriptor(object, name);
        return !!(d && d.get);
    }
    function getOwnGetter(object, name) {
        var d = Object.getOwnPropertyDescriptor(object, name);
        return d ? d.get : null;
    }
    function hasOwnSetter(object, name) {
        var d = Object.getOwnPropertyDescriptor(object, name);
        return !!(d && !!d.set);
    }
    function createMap() {
        return Object.create(null);
    }
    function createArrayMap() {
        return [];
    }
    function defineReadOnlyProperty(object, name, value) {
        Object.defineProperty(object, name, {
            value: value,
            writable: false,
            configurable: true,
            enumerable: false
        });
    }
    function copyProperties(object, template) {
        for (var property in template) {
            object[property] = template[property];
        }
    }
    function copyOwnProperties(object, template) {
        for (var property in template) {
            if (hasOwnProperty(template, property)) {
                object[property] = template[property];
            }
        }
    }
    function copyOwnPropertyDescriptors(object, template, filter, overwrite, makeWritable) {
        if (filter === void 0) { filter = null; }
        if (overwrite === void 0) { overwrite = true; }
        if (makeWritable === void 0) { makeWritable = false; }
        for (var property in template) {
            if (hasOwnProperty(template, property) && (!filter || filter(property))) {
                var descriptor = Object.getOwnPropertyDescriptor(template, property);
                if (!overwrite && hasOwnProperty(object, property)) {
                    continue;
                }
                release$1 || assert$2(descriptor);
                try {
                    if (makeWritable && descriptor.writable === false) {
                        descriptor.writable = true;
                    }
                    Object.defineProperty(object, property, descriptor);
                }
                catch (e) {
                    assert$2("Can't define: " + property);
                }
            }
        }
    }
    function copyPropertiesByList(object, template, propertyList) {
        for (var i = 0; i < propertyList.length; i++) {
            var property = propertyList[i];
            object[property] = template[property];
        }
    }
    function defineNonEnumerableGetter(obj, name, getter) {
        Object.defineProperty(obj, name, { get: getter,
            configurable: true,
            enumerable: false
        });
    }
    function defineNonEnumerableProperty(obj, name, value) {
        Object.defineProperty(obj, name, { value: value,
            writable: true,
            configurable: true,
            enumerable: false
        });
    }
    var ObjectUtilities = {
        boxValue: boxValue,
        toKeyValueArray: toKeyValueArray,
        isPrototypeWriteable: isPrototypeWriteable,
        hasOwnProperty: hasOwnProperty,
        propertyIsEnumerable: propertyIsEnumerable,
        getPropertyDescriptor: getPropertyDescriptor,
        hasOwnGetter: hasOwnGetter,
        getOwnGetter: getOwnGetter,
        hasOwnSetter: hasOwnSetter,
        createArrayMap: createArrayMap,
        createMap: createMap,
        defineReadOnlyProperty: defineReadOnlyProperty,
        copyProperties: copyProperties,
        copyOwnProperties: copyOwnProperties,
        copyOwnPropertyDescriptors: copyOwnPropertyDescriptors,
        copyPropertiesByList: copyPropertiesByList,
        defineNonEnumerableGetter: defineNonEnumerableGetter,
        defineNonEnumerableProperty: defineNonEnumerableProperty
    };

    function addPrototypeFunctionAlias(object, name, fun) {
        release$1 || assert(name.indexOf('$Bg') === 0);
        release$1 || assert(typeof fun === 'function');
        // REDUX: remove the need to box the function.
        defineNonEnumerableProperty(object, name, object.sec.AXFunction.axBox(fun));
    }

    function axImplementsInterface(type) {
        var interfaces = this.classInfo.instanceInfo.getInterfaces(this.axClass);
        return interfaces.has(type);
    }

    var RuntimeTraits = /** @class */ (function () {
        function RuntimeTraits(superTraits, protectedNs, protectedNsMappings) {
            this.superTraits = superTraits;
            this.protectedNs = protectedNs;
            this.protectedNsMappings = protectedNsMappings;
            this.slots = [];
            this._nextSlotID = 1;
            this.multinames = {};
            var traits = this._traits = Object.create(null);
            if (!superTraits) {
                return;
            }
            var superMappings = superTraits._traits;
            for (var key in superMappings) {
                traits[key] = Object.create(superMappings[key]);
            }
        }
        /**
         * Adds the given trait and returns any trait that might already exist under that name.
         *
         * See the comment for `Trait#resolveRuntimeTraits` for an explanation of the lookup scheme.
         */
        RuntimeTraits.prototype.addTrait = function (trait) {
            var mn = trait.name;
            var mappings = this._traits[mn.name];
            if (!mappings) {
                mappings = this._traits[mn.name] = Object.create(null);
            }
            var nsName = mn.namespaces[0].mangledName;
            var current = mappings[nsName];
            mappings[nsName] = trait;
            return current;
        };
        RuntimeTraits.prototype.addSlotTrait = function (trait) {
            var slot = trait.slot;
            if (!slot) {
                slot = trait.slot = this._nextSlotID++;
            }
            else {
                this._nextSlotID = slot + 1;
            }
            release$1 || assert(!this.slots[slot]);
            this.slots[slot] = trait;
        };
        RuntimeTraits.prototype.getTraitMultiname = function (mn) {
            if (mn.mutable)
                return this.getTrait(mn.namespaces, mn.name);
            return this.multinames[mn.id] || (this.multinames[mn.id] = this.getTrait(mn.namespaces, mn.name));
        };
        /**
         * Returns the trait matching the given multiname parts, if any.
         *
         * See the comment for `Trait#resolveRuntimeTraits` for an explanation of the lookup scheme.
         */
        RuntimeTraits.prototype.getTrait = function (namespaces, name) {
            release$1 || assert(typeof name === 'string');
            var mappings = this._traits[name];
            if (!mappings) {
                return null;
            }
            var trait;
            for (var i = 0; i < namespaces.length; i++) {
                var ns = namespaces[i];
                trait = mappings[ns.mangledName];
                if (trait) {
                    return trait;
                }
                if (ns.type === 1 /* Protected */) {
                    var protectedScope = this;
                    while (protectedScope) {
                        if (protectedScope.protectedNs === ns) {
                            trait = protectedScope.protectedNsMappings[name];
                            if (trait) {
                                return trait;
                            }
                        }
                        protectedScope = protectedScope.superTraits;
                    }
                }
            }
            return null;
        };
        RuntimeTraits.prototype.getTraitsList = function () {
            var list = [];
            var names = this._traits;
            for (var name in names) {
                var mappings = names[name];
                for (var nsName in mappings) {
                    list.push(mappings[nsName]);
                }
            }
            return list;
        };
        RuntimeTraits.prototype.getSlotPublicTraitNames = function () {
            var slots = this.slots;
            var names = [];
            for (var i = 1; i < slots.length; i++) {
                var slot = slots[i];
                if (!slot.name.namespace.isPublic()) {
                    continue;
                }
                names.push(slot.name.name);
            }
            return names;
        };
        RuntimeTraits.prototype.getSlot = function (i) {
            return this.slots[i];
        };
        return RuntimeTraits;
    }());

    function AXBasePrototype_$BgtoString() {
        // Dynamic prototypes just return [object Object], so we have to special-case them.
        // Since the dynamic object is the one holding the direct reference to `classInfo`,
        // we can check for that.
        var name = this.hasOwnProperty('classInfo') ?
            'Object' :
            this.classInfo.instanceInfo.name.name;
        return StringUtilities.concat3("[object ", name, "]");
    }

    /**
     * These values are allowed to exist without being boxed.
     */
    function isPrimitiveJSValue(value) {
        return value === null || value === undefined || typeof value === "number" ||
            typeof value === "string" || typeof value === "boolean";
    }

    function AXBasePrototype_toString() {
        return this.$BgtoString.axCall(this);
    }
    function AXBasePrototype_$BgvalueOf() {
        return this;
    }
    function AXBasePrototype_valueOf() {
        return this.$BgvalueOf.axCall(this);
    }
    var D = defineNonEnumerableProperty;
    var AXBasePrototype = null;
    function isValidASValue(value) {
        return AXBasePrototype.isPrototypeOf(value) || isPrimitiveJSValue(value);
    }
    /**
     * Execute this lazily because we want to make sure the AS package is available.
     */
    function initializeAXBasePrototype() {
        if (AXBasePrototype) {
            return;
        }
        var Op = ASObject$1.prototype;
        AXBasePrototype = Object.create(null);
        D(AXBasePrototype, "axHasPropertyInternal", Op.axHasPropertyInternal);
        D(AXBasePrototype, "axHasProperty", Op.axHasProperty);
        D(AXBasePrototype, "axSetProperty", Op.axSetProperty);
        D(AXBasePrototype, "axHasProperty", Op.axHasProperty);
        D(AXBasePrototype, "axHasPublicProperty", Op.axHasPublicProperty);
        D(AXBasePrototype, "axSetPublicProperty", Op.axSetPublicProperty);
        D(AXBasePrototype, "axGetPublicProperty", Op.axGetPublicProperty);
        D(AXBasePrototype, "axCallPublicProperty", Op.axCallPublicProperty);
        D(AXBasePrototype, "axDeletePublicProperty", Op.axDeletePublicProperty);
        D(AXBasePrototype, "axGetProperty", Op.axGetProperty);
        D(AXBasePrototype, "axDeleteProperty", Op.axDeleteProperty);
        D(AXBasePrototype, "axGetSuper", Op.axGetSuper);
        D(AXBasePrototype, "axSetSuper", Op.axSetSuper);
        D(AXBasePrototype, "axSetSlot", Op.axSetSlot);
        D(AXBasePrototype, "axGetSlot", Op.axGetSlot);
        D(AXBasePrototype, "axCallProperty", Op.axCallProperty);
        D(AXBasePrototype, "axCallSuper", Op.axCallSuper);
        D(AXBasePrototype, "axConstructProperty", Op.axConstructProperty);
        D(AXBasePrototype, "axResolveMultiname", Op.axResolveMultiname);
        D(AXBasePrototype, "axNextNameIndex", Op.axNextNameIndex);
        D(AXBasePrototype, "axNextName", Op.axNextName);
        D(AXBasePrototype, "axNextValue", Op.axNextValue);
        D(AXBasePrototype, "axGetEnumerableKeys", Op.axGetEnumerableKeys);
        D(AXBasePrototype, "axImplementsInterface", axImplementsInterface);
        // Dummy traits object so Object.prototype lookups succeed.
        D(AXBasePrototype, "traits", new RuntimeTraits(null, null, Object.create(null)));
        // Helper methods borrowed from Object.prototype.
        D(AXBasePrototype, "isPrototypeOf", Object.prototype.isPrototypeOf);
        D(AXBasePrototype, "hasOwnProperty", Object.prototype.hasOwnProperty);
        AXBasePrototype.$BgtoString = AXBasePrototype_$BgtoString;
        AXBasePrototype.toString = AXBasePrototype_toString;
        AXBasePrototype.$BgvalueOf = AXBasePrototype_$BgvalueOf;
        AXBasePrototype.valueOf = AXBasePrototype_valueOf;
    }

    function checkValue(value) {
        if (!release$1) {
            if (!isValidASValue(value)) {
                // Stringifying the value is potentially costly, so only do it if necessary,
                // even in debug mode.
                assert(false, "Value: " + value + " is not allowed to flow into AS3.");
            }
        }
    }

    function makeMultiname(v, namespace) {
        var rn = new Multiname(null, 0, 17 /* RTQNameL */, [], null);
        rn.namespaces = namespace ? [namespace] : [Namespace.PUBLIC];
        rn.name = v;
        return rn;
    }

    function qualifyPublicName(v) {
        return isIndex(v) ? v : '$Bg' + v;
    }

    /**
     * Same as |axCoerceString| except for returning "null" instead of |null| for
     * |null| or |undefined|, and calls |toString| instead of (implicitly) |valueOf|.
     */
    function axCoerceName(x) {
        if (typeof x === "string") {
            return x;
        }
        else if (x == undefined) {
            return 'null';
        }
        return x.toString();
    }

    var rn = new Multiname(null, 0, 17 /* RTQNameL */, [], null, null, true);

    var avm2Options = shumwayOptions.register(new OptionSet("AVM2"));
    var options = avm2Options.register(new OptionSet("Runtime"));
    var traceRuntime = options.register(new Option("tr", "traceRuntime", "boolean", false, "trace runtime"));
    var traceExecution = options.register(new Option("tx", "traceExecution", "boolean", false, "trace execution"));
    var traceInterpreter = options.register(new Option("ti", "traceInterpreter", "boolean", false, "trace interpreter"));
    var debuggerMode = options.register(new Option("db", "debuggerMode", "boolean", true, "enable debugger mode"));

    var Errors$1 = {
        /**
         * AVM2 Error Codes
         */
        //  OutOfMemoryError                     : {code: 1000, message: "The system is out of memory."},
        NotImplementedError: { code: 1001, message: "The method %1 is not implemented." },
        InvalidPrecisionError: { code: 1002, message: "Number.toPrecision has a range of 1 to 21. Number.toFixed and Number.toExponential have a range of 0 to 20. Specified value is not within expected range." },
        InvalidRadixError: { code: 1003, message: "The radix argument must be between 2 and 36; got %1." },
        InvokeOnIncompatibleObjectError: { code: 1004, message: "Method %1 was invoked on an incompatible object." },
        ArrayIndexNotIntegerError: { code: 1005, message: "Array index is not a positive integer (%1)." },
        CallOfNonFunctionError: { code: 1006, message: "%1 is not a function." },
        ConstructOfNonFunctionError: { code: 1007, message: "Instantiation attempted on a non-constructor." },
        //  AmbiguousBindingError                : {code: 1008, message: "%1 is ambiguous; Found more than one matching binding."},
        ConvertNullToObjectError: { code: 1009, message: "Cannot access a property or method of a null object reference." },
        ConvertUndefinedToObjectError: { code: 1010, message: "A term is undefined and has no properties." },
        //  IllegalOpcodeError                   : {code: 1011, message: "Method %1 contained illegal opcode %2 at offset %3."},
        //  LastInstExceedsCodeSizeError         : {code: 1012, message: "The last instruction exceeded code size."},
        //  FindVarWithNoScopeError              : {code: 1013, message: "Cannot call OP_findproperty when scopeDepth is 0."},
        ClassNotFoundError: { code: 1014, message: "Class %1 could not be found." },
        //  IllegalSetDxns                       : {code: 1015, message: "Method %1 cannot set default xml namespace"},
        DescendentsError: { code: 1016, message: "Descendants operator (..) not supported on type %1." },
        //  ScopeStackOverflowError              : {code: 1017, message: "Scope stack overflow occurred."},
        //  ScopeStackUnderflowError             : {code: 1018, message: "Scope stack underflow occurred."},
        //  GetScopeObjectBoundsError            : {code: 1019, message: "Getscopeobject %1 is out of bounds."},
        //  CannotFallOffMethodError             : {code: 1020, message: "Code cannot fall off the end of a method."},
        //  InvalidBranchTargetError             : {code: 1021, message: "At least one branch target was not on a valid instruction in the method."},
        //  IllegalVoidError                     : {code: 1022, message: "Type void may only be used as a function return type."},
        StackOverflowError: { code: 1023, message: "Stack overflow occurred." },
        //  StackUnderflowError                  : {code: 1024, message: "Stack underflow occurred."},
        //  InvalidRegisterError                 : {code: 1025, message: "An invalid register %1 was accessed."},
        //  SlotExceedsCountError                : {code: 1026, message: "Slot %1 exceeds slotCount=%2 of %3."},
        //  MethodInfoExceedsCountError          : {code: 1027, message: "Method_info %1 exceeds method_count=%2."},
        //  DispIdExceedsCountError              : {code: 1028, message: "Disp_id %1 exceeds max_disp_id=%2 of %3."},
        //  DispIdUndefinedError                 : {code: 1029, message: "Disp_id %1 is undefined on %2."},
        //  StackDepthUnbalancedError            : {code: 1030, message: "Stack depth is unbalanced. %1 != %2."},
        //  ScopeDepthUnbalancedError            : {code: 1031, message: "Scope depth is unbalanced. %1 != %2."},
        CpoolIndexRangeError: { code: 1032, message: "Cpool index %1 is out of range %2." },
        CpoolEntryWrongTypeError: { code: 1033, message: "Cpool entry %1 is wrong type." },
        CheckTypeFailedError: { code: 1034, message: "Type Coercion failed: cannot convert %1 to %2." },
        //  IllegalSuperCallError                : {code: 1035, message: "Illegal super expression found in method %1."},
        CannotAssignToMethodError: { code: 1037, message: "Cannot assign to a method %1 on %2." },
        //  RedefinedError                       : {code: 1038, message: "%1 is already defined."},
        //  CannotVerifyUntilReferencedError     : {code: 1039, message: "Cannot verify method until it is referenced."},
        CantUseInstanceofOnNonObjectError: { code: 1040, message: "The right-hand side of instanceof must be a class or function." },
        IsTypeMustBeClassError: { code: 1041, message: "The right-hand side of operator must be a class." },
        InvalidMagicError: { code: 1042, message: "Not an ABC file.  major_version=%1 minor_version=%2." },
        //  InvalidCodeLengthError               : {code: 1043, message: "Invalid code_length=%1."},
        //  InvalidMethodInfoFlagsError          : {code: 1044, message: "MethodInfo-%1 unsupported flags=%2."},
        UnsupportedTraitsKindError: { code: 1045, message: "Unsupported traits kind=%1." },
        //  MethodInfoOrderError                 : {code: 1046, message: "MethodInfo-%1 referenced before definition."},
        //  MissingEntryPointError               : {code: 1047, message: "No entry point was found."},
        PrototypeTypeError: { code: 1049, message: "Prototype objects must be vanilla Objects." },
        ConvertToPrimitiveError: { code: 1050, message: "Cannot convert %1 to primitive." },
        //  IllegalEarlyBindingError             : {code: 1051, message: "Illegal early binding access to %1."},
        InvalidURIError: { code: 1052, message: "Invalid URI passed to %1 function." },
        //  IllegalOverrideError                 : {code: 1053, message: "Illegal override of %1 in %2."},
        //  IllegalExceptionHandlerError         : {code: 1054, message: "Illegal range or target offsets in exception handler."},
        WriteSealedError: { code: 1056, message: "Cannot create property %1 on %2." },
        //  IllegalSlotError                     : {code: 1057, message: "%1 can only contain methods."},
        //  IllegalOperandTypeError              : {code: 1058, message: "Illegal operand type: %1 must be %2."},
        //  ClassInfoOrderError                  : {code: 1059, message: "ClassInfo-%1 is referenced before definition."},
        //  ClassInfoExceedsCountError           : {code: 1060, message: "ClassInfo %1 exceeds class_count=%2."},
        //  NumberOutOfRangeError                : {code: 1061, message: "The value %1 cannot be converted to %2 without losing precision."},
        WrongArgumentCountError: { code: 1063, message: "Argument count mismatch on %1. Expected %2, got %3." },
        //  CannotCallMethodAsConstructor        : {code: 1064, message: "Cannot call method %1 as constructor."},
        UndefinedVarError: { code: 1065, message: "Variable %1 is not defined." },
        //  FunctionConstructorError             : {code: 1066, message: "The form function('function body') is not supported."},
        //  IllegalNativeMethodBodyError         : {code: 1067, message: "Native method %1 has illegal method body."},
        //  CannotMergeTypesError                : {code: 1068, message: "%1 and %2 cannot be reconciled."},
        ReadSealedError: { code: 1069, message: "Property %1 not found on %2 and there is no default value." },
        //  CallNotFoundError                    : {code: 1070, message: "Method %1 not found on %2"},
        //  AlreadyBoundError                    : {code: 1071, message: "Function %1 has already been bound to %2."},
        //  ZeroDispIdError                      : {code: 1072, message: "Disp_id 0 is illegal."},
        //  DuplicateDispIdError                 : {code: 1073, message: "Non-override method %1 replaced because of duplicate disp_id %2."},
        ConstWriteError: { code: 1074, message: "Illegal write to read-only property %1 on %2." },
        //  MathNotFunctionError                 : {code: 1075, message: "Math is not a function."},
        //  MathNotConstructorError              : {code: 1076, message: "Math is not a constructor."},
        //  WriteOnlyError                       : {code: 1077, message: "Illegal read of write-only property %1 on %2."},
        //  IllegalOpMultinameError              : {code: 1078, message: "Illegal opcode/multiname combination: %1<%2>."},
        //  IllegalNativeMethodError             : {code: 1079, message: "Native methods are not allowed in loaded code."},
        //  IllegalNamespaceError                : {code: 1080, message: "Illegal value for namespace."},
        //  ReadSealedErrorNs                    : {code: 1081, message: "Property %1 not found on %2 and there is no default value."},
        //  NoDefaultNamespaceError              : {code: 1082, message: "No default namespace has been set."},
        XMLPrefixNotBound: { code: 1083, message: "The prefix \"%1\" for element \"%2\" is not bound." },
        //  XMLBadQName                          : {code: 1084, message: "Element or attribute (\"%1\") does not match QName production: QName::=(NCName':')?NCName."},
        XMLUnterminatedElementTag: { code: 1085, message: "The element type \"%1\" must be terminated by the matching end-tag \"</%2>\"." },
        XMLOnlyWorksWithOneItemLists: { code: 1086, message: "The %1 method only works on lists containing one item." },
        XMLAssignmentToIndexedXMLNotAllowed: { code: 1087, message: "Assignment to indexed XML is not allowed." },
        XMLMarkupMustBeWellFormed: { code: 1088, message: "The markup in the document following the root element must be well-formed." },
        XMLAssigmentOneItemLists: { code: 1089, message: "Assignment to lists with more than one item is not supported." },
        XMLMalformedElement: { code: 1090, message: "XML parser failure: element is malformed." },
        XMLUnterminatedCData: { code: 1091, message: "XML parser failure: Unterminated CDATA section." },
        XMLUnterminatedXMLDecl: { code: 1092, message: "XML parser failure: Unterminated XML declaration." },
        XMLUnterminatedDocTypeDecl: { code: 1093, message: "XML parser failure: Unterminated DOCTYPE declaration." },
        XMLUnterminatedComment: { code: 1094, message: "XML parser failure: Unterminated comment." },
        //  XMLUnterminatedAttribute             : {code: 1095, message: "XML parser failure: Unterminated attribute."},
        XMLUnterminatedElement: { code: 1096, message: "XML parser failure: Unterminated element." },
        //  XMLUnterminatedProcessingInstruction : {code: 1097, message: "XML parser failure: Unterminated processing instruction."},
        XMLNamespaceWithPrefixAndNoURI: { code: 1098, message: "Illegal prefix %1 for no namespace." },
        RegExpFlagsArgumentError: { code: 1100, message: "Cannot supply flags when constructing one RegExp from another." },
        //  NoScopeError                         : {code: 1101, message: "Cannot verify method %1 with unknown scope."},
        //  IllegalDefaultValue                  : {code: 1102, message: "Illegal default value for type %1."},
        //  CannotExtendFinalClass               : {code: 1103, message: "Class %1 cannot extend final base class."},
        //  XMLDuplicateAttribute                : {code: 1104, message: "Attribute \"%1\" was already specified for element \"%2\"."},
        //  CorruptABCError                      : {code: 1107, message: "The ABC data is corrupt, attempt to read out of bounds."},
        InvalidBaseClassError: { code: 1108, message: "The OP_newclass opcode was used with the incorrect base class." },
        //  DanglingFunctionError                : {code: 1109, message: "Attempt to directly call unbound function %1 from method %2."},
        //  CannotExtendError                    : {code: 1110, message: "%1 cannot extend %2."},
        //  CannotImplementError                 : {code: 1111, message: "%1 cannot implement %2."},
        //  CoerceArgumentCountError             : {code: 1112, message: "Argument count mismatch on class coercion.  Expected 1, got %1."},
        //  InvalidNewActivationError            : {code: 1113, message: "OP_newactivation used in method without NEED_ACTIVATION flag."},
        //  NoGlobalScopeError                   : {code: 1114, message: "OP_getglobalslot or OP_setglobalslot used with no global scope."},
        //  NotConstructorError                  : {code: 1115, message: "%1 is not a constructor."},
        //  ApplyError                           : {code: 1116, message: "second argument to Function.prototype.apply must be an array."},
        XMLInvalidName: { code: 1117, message: "Invalid XML name: %1." },
        XMLIllegalCyclicalLoop: { code: 1118, message: "Illegal cyclical loop between nodes." },
        //  DeleteTypeError                      : {code: 1119, message: "Delete operator is not supported with operand of type %1."},
        //  DeleteSealedError                    : {code: 1120, message: "Cannot delete property %1 on %2."},
        //  DuplicateMethodBodyError             : {code: 1121, message: "Method %1 has a duplicate method body."},
        //  IllegalInterfaceMethodBodyError      : {code: 1122, message: "Interface method %1 has illegal method body."},
        FilterError: { code: 1123, message: "Filter operator not supported on type %1." },
        //  InvalidHasNextError                  : {code: 1124, message: "OP_hasnext2 requires object and index to be distinct registers."},
        OutOfRangeError: { code: 1125, message: "The index %1 is out of range %2." },
        VectorFixedError: { code: 1126, message: "Cannot change the length of a fixed Vector." },
        TypeAppOfNonParamType: { code: 1127, message: "Type application attempted on a non-parameterized type." },
        WrongTypeArgCountError: { code: 1128, message: "Incorrect number of type parameters for %1. Expected %2, got %3." },
        JSONCyclicStructure: { code: 1129, message: "Cyclic structure cannot be converted to JSON string." },
        JSONInvalidReplacer: { code: 1131, message: "Replacer argument to JSON stringifier must be an array or a two parameter function." },
        JSONInvalidParseInput: { code: 1132, message: "Invalid JSON parse input." },
        //  FileOpenError                        : {code: 1500, message: "Error occurred opening file %1."},
        //  FileWriteError                       : {code: 1501, message: "Error occurred writing to file %1."},
        //  ScriptTimeoutError                   : {code: 1502, message: "A script has executed for longer than the default timeout period of 15 seconds."},
        //  ScriptTerminatedError                : {code: 1503, message: "A script failed to exit after 30 seconds and was terminated."},
        //  EndOfFileError                       : {code: 1504, message: "End of file."},
        //  StringIndexOutOfBoundsError          : {code: 1505, message: "The string index %1 is out of bounds; must be in range %2 to %3."},
        InvalidRangeError: { code: 1506, message: "The specified range is invalid." },
        NullArgumentError: { code: 1507, message: "Argument %1 cannot be null." },
        InvalidArgumentError: { code: 1508, message: "The value specified for argument %1 is invalid." },
        ArrayFilterNonNullObjectError: { code: 1510, message: "When the callback argument is a method of a class, the optional this argument must be null." },
        InvalidParamError: { code: 2004, message: "One of the parameters is invalid." },
        ParamRangeError: { code: 2006, message: "The supplied index is out of bounds." },
        NullPointerError: { code: 2007, message: "Parameter %1 must be non-null." },
        InvalidEnumError: { code: 2008, message: "Parameter %1 must be one of the accepted values." },
        CantInstantiateError: { code: 2012, message: "%1 class cannot be instantiated." },
        InvalidBitmapData: { code: 2015, message: "Invalid BitmapData." },
        EOFError: { code: 2030, message: "End of file was encountered.", fqn: 'flash.errors.EOFError' },
        CompressedDataError: { code: 2058, message: "There was an error decompressing the data.", fqn: 'flash.errors.IOError' },
        EmptyStringError: { code: 2085, message: "Parameter %1 must be non-empty string." },
        ProxyGetPropertyError: { code: 2088, message: "The Proxy class does not implement getProperty. It must be overridden by a subclass." },
        ProxySetPropertyError: { code: 2089, message: "The Proxy class does not implement setProperty. It must be overridden by a subclass." },
        ProxyCallPropertyError: { code: 2090, message: "The Proxy class does not implement callProperty. It must be overridden by a subclass." },
        ProxyHasPropertyError: { code: 2091, message: "The Proxy class does not implement hasProperty. It must be overridden by a subclass." },
        ProxyDeletePropertyError: { code: 2092, message: "The Proxy class does not implement deleteProperty. It must be overridden by a subclass." },
        ProxyGetDescendantsError: { code: 2093, message: "The Proxy class does not implement getDescendants. It must be overridden by a subclass." },
        ProxyNextNameIndexError: { code: 2105, message: "The Proxy class does not implement nextNameIndex. It must be overridden by a subclass." },
        ProxyNextNameError: { code: 2106, message: "The Proxy class does not implement nextName. It must be overridden by a subclass." },
        ProxyNextValueError: { code: 2107, message: "The Proxy class does not implement nextValue. It must be overridden by a subclass." },
        //  InvalidArrayLengthError              : {code: 2108, message: "The value %1 is not a valid Array length."},
        //  ReadExternalNotImplementedError      : {code: 2173, message: "Unable to read object in stream.  The class %1 does not implement flash.utils.IExternalizable but is aliased to an externalizable class."},
        /**
         * Player Error Codes
         */
        //  NoSecurityContextError                                    : { code: 2000, message: "No active security context."},
        TooFewArgumentsError: { code: 2001, message: "Too few arguments were specified; got %1, %2 expected." },
        //  InvalidSocketError                                        : { code: 2002, message: "Operation attempted on invalid socket."},
        //  InvalidSocketPortError                                    : { code: 2003, message: "Invalid socket port number specified."},
        ParamTypeError: { code: 2005, message: "Parameter %1 is of the incorrect type. Should be type %2." },
        //  HasStyleSheetError                                        : { code: 2009, message: "This method cannot be used on a text field with a style sheet."},
        //  SocketLocalFileSecurityError                              : { code: 2010, message: "Local-with-filesystem SWF files are not permitted to use sockets."},
        SocketConnectError: { code: 2011, message: "Socket connection failed to %1:%2." },
        //  AuthoringOnlyFeatureError                                 : { code: 2013, message: "Feature can only be used in Flash Authoring."},
        //  FeatureNotAvailableError                                  : { code: 2014, message: "Feature is not available at this time."},
        //  InvalidBitmapDataError                                    : { code: 2015, message: "Invalid BitmapData."},
        //  SystemExitSecurityError                                   : { code: 2017, message: "Only trusted local files may cause the Flash Player to exit."},
        //  SystemExitUnsupportedError                                : { code: 2018, message: "System.exit is only available in the standalone Flash Player."},
        //  InvalidDepthError                                         : { code: 2019, message: "Depth specified is invalid."},
        //  MovieClipSwapError                                        : { code: 2020, message: "MovieClips objects with different parents cannot be swapped."},
        //  ObjectCreationError                                       : { code: 2021, message: "Object creation failed."},
        //  NotDisplayObjectError                                     : { code: 2022, message: "Class %1 must inherit from DisplayObject to link to a symbol."},
        //  NotSpriteError                                            : { code: 2023, message: "Class %1 must inherit from Sprite to link to the root."},
        CantAddSelfError: { code: 2024, message: "An object cannot be added as a child of itself." },
        NotAChildError: { code: 2025, message: "The supplied DisplayObject must be a child of the caller." },
        //  NavigateURLError                                          : { code: 2026, message: "An error occurred navigating to the URL %1."},
        //  MustBeNonNegativeError                                    : { code: 2027, message: "Parameter %1 must be a non-negative number; got %2."},
        //  LocalSecurityError                                        : { code: 2028, message: "Local-with-filesystem SWF file %1 cannot access Internet URL %2."},
        //  InvalidStreamError                                        : { code: 2029, message: "This URLStream object does not have a stream opened."},
        //  SocketError                                               : { code: 2031, message: "Socket Error."},
        //  StreamError                                               : { code: 2032, message: "Stream Error."},
        //  KeyGenerationError                                        : { code: 2033, message: "Key Generation Failed."},
        //  InvalidKeyError                                           : { code: 2034, message: "An invalid digest was supplied."},
        //  URLNotFoundError                                          : { code: 2035, message: "URL Not Found."},
        //  LoadNeverCompletedError                                   : { code: 2036, message: "Load Never Completed."},
        //  InvalidCallError                                          : { code: 2037, message: "Functions called in incorrect sequence, or earlier call was unsuccessful."},
        //  FileIOError                                               : { code: 2038, message: "File I/O Error."},
        //  RemoteURLError                                            : { code: 2039, message: "Invalid remote URL protocol. The remote URL protocol must be HTTP or HTTPS."},
        //  BrowseInProgressError                                     : { code: 2041, message: "Only one file browsing session may be performed at a time."},
        //  DigestNotSupportedError                                   : { code: 2042, message: "The digest property is not supported by this load operation."},
        UnhandledError: { code: 2044, message: "Unhandled %1:." },
        //  FileVerificationError                                     : { code: 2046, message: "The loaded file did not have a valid signature."},
        //  DisplayListSecurityError                                  : { code: 2047, message: "Security sandbox violation: %1: %2 cannot access %3."},
        //  DownloadSecurityError                                     : { code: 2048, message: "Security sandbox violation: %1 cannot load data from %2."},
        //  UploadSecurityError                                       : { code: 2049, message: "Security sandbox violation: %1 cannot upload data to %2."},
        //  OutboundScriptingSecurityError                            : { code: 2051, message: "Security sandbox violation: %1 cannot evaluate scripting URLs within %2 (allowScriptAccess is %3). Attempted URL was %4."},
        AllowDomainArgumentError: { code: 2052, message: "Only String arguments are permitted for allowDomain and allowInsecureDomain." },
        //  IntervalSecurityError                                     : { code: 2053, message: "Security sandbox violation: %1 cannot clear an interval timer set by %2."},
        //  ExactSettingsError                                        : { code: 2054, message: "The value of Security.exactSettings cannot be changed after it has been used."},
        //  PrintJobStartError                                        : { code: 2055, message: "The print job could not be started."},
        //  PrintJobSendError                                         : { code: 2056, message: "The print job could not be sent to the printer."},
        //  PrintJobAddPageError                                      : { code: 2057, message: "The page could not be added to the print job."},
        //  ExternalCallbackSecurityError                             : { code: 2059, message: "Security sandbox violation: %1 cannot overwrite an ExternalInterface callback added by %2."},
        //  ExternalInterfaceSecurityError                            : { code: 2060, message: "Security sandbox violation: ExternalInterface caller %1 cannot access %2."},
        //  ExternalInterfaceNoCallbackError                          : { code: 2061, message: "No ExternalInterface callback %1 registered."},
        //  NoCloneMethodError                                        : { code: 2062, message: "Children of Event must override clone() {return new MyEventClass (...);}."},
        //  IMEError                                                  : { code: 2063, message: "Error attempting to execute IME command."},
        //  FocusNotSetError                                          : { code: 2065, message: "The focus cannot be set for this target."},
        DelayRangeError: { code: 2066, message: "The Timer delay specified is out of range." },
        ExternalInterfaceNotAvailableError: { code: 2067, message: "The ExternalInterface is not available in this container. ExternalInterface requires Internet Explorer ActiveX, Firefox, Mozilla 1.7.5 and greater, or other browsers that support NPRuntime." },
        //  InvalidSoundError                                         : { code: 2068, message: "Invalid sound."},
        InvalidLoaderMethodError: { code: 2069, message: "The Loader class does not implement this method." },
        //  StageOwnerSecurityError                                   : { code: 2070, message: "Security sandbox violation: caller %1 cannot access Stage owned by %2."},
        InvalidStageMethodError: { code: 2071, message: "The Stage class does not implement this property or method." },
        //  ProductManagerDiskError                                   : { code: 2073, message: "There was a problem saving the application to disk."},
        //  ProductManagerStageError                                  : { code: 2074, message: "The stage is too small to fit the download ui."},
        //  ProductManagerVerifyError                                 : { code: 2075, message: "The downloaded file is invalid."},
        //  FilterFailedError                                         : { code: 2077, message: "This filter operation cannot be performed with the specified input parameters."},
        TimelineObjectNameSealedError: { code: 2078, message: "The name property of a Timeline-placed object cannot be modified." },
        //  BitmapNotAssociatedWithBitsCharError                      : { code: 2079, message: "Classes derived from Bitmap can only be associated with defineBits characters (bitmaps)."},
        AlreadyConnectedError: { code: 2082, message: "Connect failed because the object is already connected." },
        CloseNotConnectedError: { code: 2083, message: "Close failed because the object is not connected." },
        ArgumentSizeError: { code: 2084, message: "The AMF encoding of the arguments cannot exceed 40K." },
        //  FileReferenceProhibitedError                              : { code: 2086, message: "A setting in the mms.cfg file prohibits this FileReference request."},
        //  DownloadFileNameProhibitedError                           : { code: 2087, message: "The FileReference.download() file name contains prohibited characters."},
        //  EventDispatchRecursionError                               : { code: 2094, message: "Event dispatch recursion overflow."},
        AsyncError: { code: 2095, message: "%1 was unable to invoke callback %2." },
        //  DisallowedHTTPHeaderError                                 : { code: 2096, message: "The HTTP request header %1 cannot be set via ActionScript."},
        //  FileFilterError                                           : { code: 2097, message: "The FileFilter Array is not in the correct format."},
        LoadingObjectNotSWFError: { code: 2098, message: "The loading object is not a .swf file, you cannot request SWF properties from it." },
        LoadingObjectNotInitializedError: { code: 2099, message: "The loading object is not sufficiently loaded to provide this information." },
        //  EmptyByteArrayError                                       : { code: 2100, message: "The ByteArray parameter in Loader.loadBytes() must have length greater than 0."},
        DecodeParamError: { code: 2101, message: "The String passed to URLVariables.decode() must be a URL-encoded query string containing name/value pairs." },
        //  NotAnXMLChildError                                        : { code: 2102, message: "The before XMLNode parameter must be a child of the caller."},
        //  XMLRecursionError                                         : { code: 2103, message: "XML recursion failure: new child would create infinite loop."},
        SceneNotFoundError: { code: 2108, message: "Scene %1 was not found." },
        FrameLabelNotFoundError: { code: 2109, message: "Frame label %1 not found in scene %2." },
        //  DisableAVM1LoadingError                                   : { code: 2110, message: "The value of Security.disableAVM1Loading cannot be set unless the caller can access the stage and is in an ActionScript 3.0 SWF file."},
        //  AVM1LoadingError                                          : { code: 2111, message: "Security.disableAVM1Loading is true so the current load of the ActionScript 1.0/2.0 SWF file has been blocked."},
        //  ApplicationDomainSecurityError                            : { code: 2112, message: "Provided parameter LoaderContext.ApplicationDomain is from a disallowed domain."},
        //  SecurityDomainSecurityError                               : { code: 2113, message: "Provided parameter LoaderContext.SecurityDomain is from a disallowed domain."},
        //  NonNullPointerError                                       : { code: 2114, message: "Parameter %1 must be null."},
        //  TrueParamError                                            : { code: 2115, message: "Parameter %1 must be false."},
        //  FalseParamError                                           : { code: 2116, message: "Parameter %1 must be true."},
        InvalidLoaderInfoMethodError: { code: 2118, message: "The LoaderInfo class does not implement this method." },
        //  LoaderInfoAppDomainSecurityError                          : { code: 2119, message: "Security sandbox violation: caller %1 cannot access LoaderInfo.applicationDomain owned by %2."},
        SecuritySwfNotAllowedError: { code: 2121, message: "Security sandbox violation: %1: %2 cannot access %3. This may be worked around by calling Security.allowDomain." },
        //  SecurityNonSwfIncompletePolicyFilesError                  : { code: 2122, message: "Security sandbox violation: %1: %2 cannot access %3. A policy file is required, but the checkPolicyFile flag was not set when this media was loaded."},
        //  SecurityNonSwfNotAllowedError                             : { code: 2123, message: "Security sandbox violation: %1: %2 cannot access %3. No policy files granted access."},
        UnknownFileTypeError: { code: 2124, message: "Loaded file is an unknown type." },
        //  SecurityCrossVMNotAllowedError                            : { code: 2125, message: "Security sandbox violation: %1 cannot use Runtime Shared Library %2 because crossing the boundary between ActionScript 3.0 and ActionScript 1.0/2.0 objects is not allowed."},
        //  NotConnectedError                                         : { code: 2126, message: "NetConnection object must be connected."},
        //  FileRefBadPostDataTypeError                               : { code: 2127, message: "FileReference POST data cannot be type ByteArray."},
        //  NetConnectionConnectError                                 : { code: 2129, message: "Connection to %1 failed."},
        //  SharedObjectFlushFailedError                              : { code: 2130, message: "Unable to flush SharedObject."},
        //  DefinitionNotFoundError                                   : { code: 2131, message: "Definition %1 cannot be found."},
        //  NetConnectionInvalidConnectFromNetStatusEventError        : { code: 2132, message: "NetConnection.connect cannot be called from a netStatus event handler."},
        //  CallbackNotRegisteredError                                : { code: 2133, message: "Callback %1 is not registered."},
        //  SharedObjectCreateError                                   : { code: 2134, message: "Cannot create SharedObject."},
        //  InvalidSWFError                                           : { code: 2136, message: "The SWF file %1 contains invalid data."},
        //  NavigationSecurityError                                   : { code: 2137, message: "Security sandbox violation: %1 cannot navigate window %2 within %3 (allowScriptAccess is %4). Attempted URL was %5."},
        //  NonParsableRichTextXMLError                               : { code: 2138, message: "Rich text XML could not be parsed."},
        //  SharedObjectConnectError                                  : { code: 2139, message: "SharedObject could not connect."},
        //  LocalSecurityLoadingError                                 : { code: 2140, message: "Security sandbox violation: %1 cannot load %2. Local-with-filesystem and local-with-networking SWF files cannot load each other."},
        //  MultiplePrintJobsError                                    : { code: 2141, message: "Only one PrintJob may be in use at a time."},
        //  LocalImportSecurityError                                  : { code: 2142, message: "Security sandbox violation: local SWF files cannot use the LoaderContext.sec property. %1 was attempting to load %2."},
        //  AccOverrideRole                                           : { code: 2143, message: "AccessibilityImplementation.get_accRole() must be overridden from its default."},
        //  AccOverrideState                                          : { code: 2144, message: "AccessibilityImplementation.get_accState() must be overridden from its default."},
        //  URLRequestHeaderInvalidLengthError                        : { code: 2145, message: "Cumulative length of requestHeaders must be less than 8192 characters."},
        //  AllowNetworkingSecurityError                              : { code: 2146, message: "Security sandbox violation: %1 cannot call %2 because the HTML/container parameter allowNetworking has the value %3."},
        //  ForbiddenProtocolError                                    : { code: 2147, message: "Forbidden protocol in URL %1."},
        //  RemoteToLocalSecurityError                                : { code: 2148, message: "SWF file %1 cannot access local resource %2. Only local-with-filesystem and trusted local SWF files may access local resources."},
        //  FsCommandSecurityError                                    : { code: 2149, message: "Security sandbox violation: %1 cannot make fscommand calls to %2 (allowScriptAccess is %3)."},
        CantAddParentError: { code: 2150, message: "An object cannot be added as a child to one of it's children (or children's children, etc.)." },
        //  FullScreenSecurityError                                   : { code: 2151, message: "You cannot enter full screen mode when the settings dialog is visible."},
        //  FullScreenNotAllowedError                                 : { code: 2152, message: "Full screen mode is not allowed."},
        //  URLRequestInvalidHeader                                   : { code: 2153, message: "The URLRequest.requestHeaders array must contain only non-NULL URLRequestHeader objects."},
        //  InvalidNetStreamObject                                    : { code: 2154, message: "The NetStream Object is invalid.  This may be due to a failed NetConnection."},
        //  InvalidFunctionName                                       : { code: 2155, message: "The ExternalInterface.call functionName parameter is invalid.  Only alphanumeric characters are supported."},
        //  ForbiddenPortForProtocolError                             : { code: 2156, message: "Port %1 may not be accessed using protocol %2. Calling SWF was %3."},
        //  NoAsfunctionErrror                                        : { code: 2157, message: "Rejecting URL %1 because the 'asfunction:' protocol may only be used for link targets, not for networking APIs."},
        //  InvalidNetConnectionObject                                : { code: 2158, message: "The NetConnection Object is invalid.  This may be due to a dropped NetConnection."},
        //  InvalidSharedObject                                       : { code: 2159, message: "The SharedObject Object is invalid."},
        //  InvalidTextLineError                                      : { code: 2160, message: "The TextLine is INVALID and cannot be used to access the current state of the TextBlock."},
        //  TextLayoutError                                           : { code: 2161, message: "An internal error occured while laying out the text."},
        //  FragmentOutputType                                        : { code: 2162, message: "The Shader output type is not compatible for this operation."},
        //  FragmentInputType                                         : { code: 2163, message: "The Shader input type %1 is not compatible for this operation."},
        //  FragmentInputMissing                                      : { code: 2164, message: "The Shader input %1 is missing or an unsupported type."},
        //  FragmentInputTooSmall                                     : { code: 2165, message: "The Shader input %1 does not have enough data."},
        //  FragmentInputNoDimension                                  : { code: 2166, message: "The Shader input %1 lacks valid dimensions."},
        //  FragmentNotEnoughInput                                    : { code: 2167, message: "The Shader does not have the required number of inputs for this operation."},
        //  StaticTextLineError                                       : { code: 2168, message: "Static text lines have no atoms and no reference to a text block."},
        //  SecurityQuestionableBrowserScriptingError                 : { code: 2169, message: "The method %1 may not be used for browser scripting.  The URL %2 requested by %3 is being ignored.  If you intend to call browser script, use navigateToURL instead."},
        //  HeaderSecurityError                                       : { code: 2170, message: "Security sandbox violation: %1 cannot send HTTP headers to %2."},
        //  FragmentMissing                                           : { code: 2171, message: "The Shader object contains no byte code to execute."},
        //  FragmentAlreadyRunning                                    : { code: 2172, message: "The ShaderJob is already running or finished."},
        //  FileReferenceBusyError                                    : { code: 2174, message: "Only one download, upload, load or save operation can be active at a time on each FileReference."},
        //  UnformattedElementError                                   : { code: 2175, message: "One or more elements of the content of the TextBlock has a null ElementFormat."},
        //  UserActionRequiredError                                   : { code: 2176, message: "Certain actions, such as those that display a pop-up window, may only be invoked upon user interaction, for example by a mouse click or button press."},
        //  FragmentInputTooLarge                                     : { code: 2177, message: "The Shader input %1 is too large."},
        //  ClipboardConstNotAllowed                                  : { code: 2178, message: "The Clipboard.generalClipboard object must be used instead of creating a new Clipboard."},
        //  ClipboardDisallowedRead                                   : { code: 2179, message: "The Clipboard.generalClipboard object may only be read while processing a flash.events.Event.PASTE event."},
        //  CantMoveAVM1ContentLoadedIntoAVM2                         : { code: 2180, message: "It is illegal to move AVM1 content (AS1 or AS2) to a different part of the displayList when it has been loaded into AVM2 (AS3) content."},
        //  InvalidTextLineMethodError                                : { code: 2181, message: "The TextLine class does not implement this property or method."},
        //  PerspectiveFieldOfViewValueInvalid                        : { code: 2182, message: "Invalid fieldOfView value.  The value must be greater than 0 and less than 180."},
        //  Invalid3DScale                                            : { code: 2183, message: "Scale values must not be zero."},
        //  LockedElementFormatError                                  : { code: 2184, message: "The ElementFormat object is locked and cannot be modified."},
        //  LockedFontDescriptionError                                : { code: 2185, message: "The FontDescription object is locked and cannot be modified."},
        //  PerspectiveFocalLengthInvalid                             : { code: 2186, message: "Invalid focalLength %1."},
        //  Matrix3DDecomposeTypeInvalid                              : { code: 2187, message: "Invalid orientation style %1.  Value must be one of 'Orientation3D.EULER_ANGLES', 'Orientation3D.AXIS_ANGLE', or 'Orientation3D.QUATERNION'."},
        //  MatrixNonInvertibleError                                  : { code: 2188, message: "Invalid raw matrix. Matrix must be invertible."},
        Matrix3DRefCannontBeShared: { code: 2189, message: "A Matrix3D can not be assigned to more than one DisplayObject." },
        //  ForceDownloadSecurityError                                : { code: 2190, message: "The attempted load of %1 failed as it had a Content-Disposition of attachment set."},
        //  ClipboardDisallowedWrite                                  : { code: 2191, message: "The Clipboard.generalClipboard object may only be written to as the result of user interaction, for example by a mouse click or button press."},
        //  MalformedUnicodeError                                     : { code: 2192, message: "An unpaired Unicode surrogate was encountered in the input."},
        //  SecurityContentAccessDeniedError                          : { code: 2193, message: "Security sandbox violation: %1: %2 cannot access %3."},
        //  LoaderParamError                                          : { code: 2194, message: "Parameter %1 cannot be a Loader."},
        //  LoaderAsyncError                                          : { code: 2195, message: "Error thrown as Loader called %1."},
        ObjectWithStringsParamError: { code: 2196, message: "Parameter %1 must be an Object with only String values." },
        //  SystemUpdaterPlayerNotSupportedError                      : { code: 2200, message: "The SystemUpdater class is not supported by this player."},
        //  SystemUpdaterOSNotSupportedError                          : { code: 2201, message: "The requested update type is not supported on this operating system."},
        //  SystemUpdaterBusy                                         : { code: 2202, message: "Only one SystemUpdater action is allowed at a time."},
        //  SystemUpdaterFailed                                       : { code: 2203, message: "The requested SystemUpdater action cannot be completed."},
        //  SystemUpdaterCannotCancel                                 : { code: 2204, message: "This operation cannot be canceled because it is waiting for user interaction."},
        //  SystemUpdaterUnknownTarget                                : { code: 2205, message: "Invalid update type %1."},
        //  SignedSWfLoadingError                                     : { code: 2500, message: "An error occurred decrypting the signed swf file. The swf will not be loaded."},
        //  NotScreenSharingError                                     : { code: 2501, message: "This property can only be accessed during screen sharing."},
        //  NotSharingMonitorError                                    : { code: 2502, message: "This property can only be accessed if sharing the entire screen."},
        //  FileBadPathName                                           : { code: 3000, message: "Illegal path name."},
        //  FileAccessDenied                                          : { code: 3001, message: "File or directory access denied."},
        //  FileExists                                                : { code: 3002, message: "File or directory exists."},
        //  FileDoesNotExist                                          : { code: 3003, message: "File or directory does not exist."},
        //  FileInsufficientSpace                                     : { code: 3004, message: "Insufficient file space."},
        //  FileSystemResources                                       : { code: 3005, message: "Insufficient system resources."},
        //  FileNotAFile                                              : { code: 3006, message: "Not a file."},
        //  FileNotADir                                               : { code: 3007, message: "Not a directory."},
        //  FileReadOnlyFileSys                                       : { code: 3008, message: "Read-only or write-protected media."},
        //  FileNotSameDevice                                         : { code: 3009, message: "Cannot move file or directory to a different device."},
        //  DirNotEmpty                                               : { code: 3010, message: "Directory is not empty."},
        //  FileDestinationExists                                     : { code: 3011, message: "Move or copy destination already exists."},
        //  FileCantDelete                                            : { code: 3012, message: "Cannot delete file or directory."},
        //  FileInUse                                                 : { code: 3013, message: "File or directory is in use."},
        //  FileCopyMoveAncestor                                      : { code: 3014, message: "Cannot copy or move a file or directory to overwrite a containing directory."},
        //  LoadBytesCodeExecutionSecurityError                       : { code: 3015, message: "Loader.loadBytes() is not permitted to load content with executable code."},
        //  FileApplicationNotFound                                   : { code: 3016, message: "No application was found that can open this file."},
        //  SQLConnectionCannotClose                                  : { code: 3100, message: "A SQLConnection cannot be closed while statements are still executing."},
        //  SQLConnectionAlreadyOpen                                  : { code: 3101, message: "Database connection is already open."},
        //  SQLConnectionInvalidName                                  : { code: 3102, message: "Name argument specified was invalid. It must not be null or empty."},
        //  SQLConnectionInTransaction                                : { code: 3103, message: "Operation cannot be performed while there is an open transaction on this connection."},
        //  SQLConnectionNotOpen                                      : { code: 3104, message: "A SQLConnection must be open to perform this operation."},
        //  SQLConnectionNoOpenTransaction                            : { code: 3105, message: "Operation is only allowed if a connection has an open transaction."},
        //  SQLStatementIsExecutingProperty                           : { code: 3106, message: "Property cannot be changed while SQLStatement.executing is true."},
        //  SQLStatementIvalidCall                                    : { code: 3107, message: "%1 may not be called unless SQLResult.complete is false."},
        //  SQLStatementInvalidText                                   : { code: 3108, message: "Operation is not permitted when the SQLStatement.text property is not set."},
        //  SQLStatementInvalidConnection                             : { code: 3109, message: "Operation is not permitted when the SQLStatement.sqlConnection property is not set."},
        //  SQLStatementIsExecutingCall                               : { code: 3110, message: "Operation cannot be performed while SQLStatement.executing is true."},
        //  SQLStatementInvalidSchemaType                             : { code: 3111, message: "An invalid schema type was specified."},
        //  SQLConnectionInvalidLockType                              : { code: 3112, message: "An invalid transaction lock type was specified."},
        //  SQLConnectionNotFileReference                             : { code: 3113, message: "Reference specified is not of type File."},
        //  SQLConnectionInvalidModeSpecified                         : { code: 3114, message: "An invalid open mode was specified."},
        //  SQLGeneralEngineError                                     : { code: 3115, message: "SQL Error."},
        //  SQLInternalEngineError                                    : { code: 3116, message: "An internal logic error occurred."},
        //  SQLPermissionError                                        : { code: 3117, message: "Access permission denied."},
        //  SQLOperationAbortedError                                  : { code: 3118, message: "Operation aborted."},
        //  SQLDatabaseLockedError                                    : { code: 3119, message: "Database file is currently locked."},
        //  SQLTableLockedError                                       : { code: 3120, message: "Table is locked."},
        //  SQLOutOfMemoryError                                       : { code: 3121, message: "Out of memory."},
        //  SQLDatabaseIsReadonlyError                                : { code: 3122, message: "Attempt to write a readonly database."},
        //  SQLDatabaseCorruptError                                   : { code: 3123, message: "Database disk image is malformed."},
        //  SQLDatabaseFullError                                      : { code: 3124, message: "Insertion failed because database is full."},
        //  SQLCannotOpenDatabaseError                                : { code: 3125, message: "Unable to open the database file."},
        //  SQLLockingProtocolError                                   : { code: 3126, message: "Database lock protocol error."},
        //  SQLDatabaseEmptyError                                     : { code: 3127, message: "Database is empty."},
        //  SQLDiskIOError                                            : { code: 3128, message: "Disk I/O error occurred."},
        //  SQLSchemaChangedError                                     : { code: 3129, message: "The database schema changed."},
        //  SQLTooMuchDataError                                       : { code: 3130, message: "Too much data for one row of a table."},
        //  SQLConstraintError                                        : { code: 3131, message: "Abort due to constraint violation."},
        //  SQLDataTypeMismatchError                                  : { code: 3132, message: "Data type mismatch."},
        //  SQLConcurrencyError                                       : { code: 3133, message: "An internal error occurred."},
        //  SQLNotSupportedOnOSError                                  : { code: 3134, message: "Feature not supported on this operating system."},
        //  SQLAuthorizationDeniedError                               : { code: 3135, message: "Authorization denied."},
        //  SQLAuxDatabaseFormatError                                 : { code: 3136, message: "Auxiliary database format error."},
        //  SQLBindingRangeError                                      : { code: 3137, message: "An index specified for a parameter was out of range."},
        //  SQLInvalidDatabaseFileError                               : { code: 3138, message: "File opened is not a database file."},
        //  SQLInvalidPageSizeError                                   : { code: 3139, message: "The page size specified was not valid for this operation."},
        //  SQLInvalidKeySizeError                                    : { code: 3140, message: "The encryption key size specified was not valid for this operation. Keys must be exactly 16 bytes in length"},
        //  SQLInvalidConfigurationError                              : { code: 3141, message: "The requested database configuration is not supported."},
        //  SQLCannotRekeyNonKeyedDatabase                            : { code: 3143, message: "Unencrypted databases may not be reencrypted."},
        //  NativeWindowClosedError                                   : { code: 3200, message: "Cannot perform operation on closed window."},
        //  PDFNoReaderInstalled                                      : { code: 3201, message: "Adobe Reader cannot be found."},
        //  PDFOldReaderInstalled                                     : { code: 3202, message: "Adobe Reader 8.1 or later cannot be found."},
        //  PDFOldDefaultText                                         : { code: 3203, message: "Default Adobe Reader must be version 8.1 or later."},
        //  PDFCannotLoadReader                                       : { code: 3204, message: "An error ocurred trying to load Adobe Reader."},
        //  ApplicationFeatureSecurityError                           : { code: 3205, message: "Only application-sandbox content can access this feature."},
        //  LoaderInfoDoorSecurityError                               : { code: 3206, message: "Caller %1 cannot set LoaderInfo property %2."},
        //  ApplicationNonFeatureSecurityError                        : { code: 3207, message: "Application-sandbox content cannot access this feature."},
        //  InvalidClipboardAccess                                    : { code: 3208, message: "Attempt to access invalid clipboard."},
        //  DeadClipboardAccess                                       : { code: 3209, message: "Attempt to access dead clipboard."},
        //  DeadJavaScriptObjectAccess                                : { code: 3210, message: "The application attempted to reference a JavaScript object in a HTML page that is no longer loaded."},
        //  FilePromiseIOError                                        : { code: 3211, message: "Drag and Drop File Promise error: %1"},
        //  NativeProcessNotRunning                                   : { code: 3212, message: "Cannot perform operation on a NativeProcess that is not running."},
        //  NativeProcessAlreadyRunning                               : { code: 3213, message: "Cannot perform operation on a NativeProcess that is already running."},
        //  NativeProcessBadExecutable                                : { code: 3214, message: "NativeProcessStartupInfo.executable does not specify a valid executable file."},
        //  NativeProcessBadWorkingDirectory                          : { code: 3215, message: "NativeProcessStartupInfo.workingDirectory does not specify a valid directory."},
        //  NativeProcessStdOutReadError                              : { code: 3216, message: "Error while reading data from NativeProcess.standardOutput."},
        //  NativeProcessStdErrReadError                              : { code: 3217, message: "Error while reading data from NativeProcess.standardError."},
        //  NativeProcessStdInWriteError                              : { code: 3218, message: "Error while writing data to NativeProcess.standardInput."},
        //  NativeProcessNotStarted                                   : { code: 3219, message: "The NativeProcess could not be started. '%1'"},
        //  ActionNotAllowedSecurityError                             : { code: 3220, message: "Action '%1' not allowed in current security context '%2'."},
        //  SWFNoPlayerInstalled                                      : { code: 3221, message: "Adobe Flash Player cannot be found."},
        //  SWFOldPlayerInstalled                                     : { code: 3222, message: "The installed version of Adobe Flash Player is too old."},
        //  DNSResolverLookupError                                    : { code: 3223, message: "DNS lookup error: platform error %1"},
        //  SocketMessageTooLongError                                 : { code: 3224, message: "Socket message too long"},
        //  SocketCannotSendDataToAddressAfterConnect                 : { code: 3225, message: "Cannot send data to a location when connected."},
        AllowCodeImportError: { code: 3226, message: "Cannot import a SWF file when LoaderContext.allowCodeImport is false." },
        //  BackgroundLaunchError                                     : { code: 3227, message: "Cannot launch another application from background."},
        //  StageWebViewLoadError                                     : { code: 3228, message: "StageWebView encountered an error during the load operation."},
        //  StageWebViewProtocolNotSupported                          : { code: 3229, message: "The protocol is not supported.:"},
        //  BrowseOperationUnsupported                                : { code: 3230, message: "The browse operation is unsupported."},
        //  InvalidVoucher                                            : { code: 3300, message: "Voucher is invalid."},
        //  AuthenticationFailed                                      : { code: 3301, message: "User authentication failed."},
        //  RequireSSLError                                           : { code: 3302, message: "Flash Access server does not support SSL."},
        //  ContentExpiredError                                       : { code: 3303, message: "Content expired."},
        //  AuthorizationFailed                                       : { code: 3304, message: "User authorization failed (for example, the user has not purchased the content)."},
        //  ServerConnectionFailed                                    : { code: 3305, message: "Can't connect to the server."},
        //  ClientUpdateRequired                                      : { code: 3306, message: "Client update required (Flash Access server requires new client)."},
        //  InternalError                                             : { code: 3307, message: "Generic internal Flash Access failure."},
        //  WrongVoucherKey                                           : { code: 3308, message: "Wrong voucher key."},
        //  CorruptedFLV                                              : { code: 3309, message: "Video content is corrupted."},
        //  AppIDMismatch                                             : { code: 3310, message: "The AIR application or Flash Player SWF does not match the one specified in the DRM policy."},
        //  AppVersionMismatch                                        : { code: 3311, message: "The version of the application does not match the one specified in the DRM policy."},
        //  VoucherIntegrityError                                     : { code: 3312, message: "Verification of voucher failed."},
        //  WriteFileSystemFailed                                     : { code: 3313, message: "Write to the file system failed."},
        //  FLVHeaderIntegrityFailed                                  : { code: 3314, message: "Verification of FLV/F4V header file failed."},
        PermissionDenied: { code: 3315, message: "The current security context does not allow this operation." },
        //  LocalConnectionUserScopedLocked                           : { code: 3316, message: "The value of LocalConnection.isPerUser cannot be changed because it has already been locked by a call to LocalConnection.connect, .send, or .close."},
        //  LoadAdobeCPFailed                                         : { code: 3317, message: "Failed to load Flash Access module."},
        //  IncompatibleAdobeCPVersion                                : { code: 3318, message: "Incompatible version of Flash Access module found."},
        //  MissingAdobeCPEntryPoint                                  : { code: 3319, message: "Missing Flash Access module API entry point."},
        //  InternalErrorHA                                           : { code: 3320, message: "Generic internal Flash Access failure."},
        //  IndividualizationFailed                                   : { code: 3321, message: "Individualization failed."},
        //  DeviceBindingFailed                                       : { code: 3322, message: "Device binding failed."},
        //  CorruptStore                                              : { code: 3323, message: "The internal stores are corrupted."},
        //  MachineTokenInvalid                                       : { code: 3324, message: "Reset license files and the client will fetch a new machine token."},
        //  CorruptServerStateStore                                   : { code: 3325, message: "Internal stores are corrupt."},
        //  TamperingDetected                                         : { code: 3326, message: "Call customer support."},
        //  ClockTamperingDetected                                    : { code: 3327, message: "Clock tampering detected."},
        //  ServerErrorTryAgain                                       : { code: 3328, message: "Server error; retry the request."},
        //  ApplicationSpecificError                                  : { code: 3329, message: "Error in application-specific namespace."},
        //  NeedAuthentication                                        : { code: 3330, message: "Need to authenticate the user and reacquire the voucher."},
        //  ContentNotYetValid                                        : { code: 3331, message: "Content is not yet valid."},
        //  CachedVoucherExpired                                      : { code: 3332, message: "Cached voucher has expired. Reacquire the voucher from the server."},
        //  PlaybackWindowExpired                                     : { code: 3333, message: "The playback window for this policy has expired."},
        //  InvalidDRMPlatform                                        : { code: 3334, message: "This platform is not allowed to play this content."},
        //  InvalidDRMVersion                                         : { code: 3335, message: "Invalid version of Flash Access module. Upgrade AIR or Flash Access module for the Flash Player."},
        //  InvalidRuntimePlatform                                    : { code: 3336, message: "This platform is not allowed to play this content."},
        //  InvalidRuntimeVersion                                     : { code: 3337, message: "Upgrade Flash Player or AIR  and retry playback."},
        //  UnknownConnectionType                                     : { code: 3338, message: "Unknown connection type."},
        //  NoAnalogPlaybackAllowed                                   : { code: 3339, message: "Can't play back on analog device. Connect to a digital device."},
        //  NoAnalogProtectionAvail                                   : { code: 3340, message: "Can't play back because connected analog device doesn't have the correct capabilities."},
        //  NoDigitalPlaybackAllowed                                  : { code: 3341, message: "Can't play back on digital device."},
        //  NoDigitalProtectionAvail                                  : { code: 3342, message: "The connected digital device doesn't have the correct capabilities."},
        InternalErrorIV: { code: 3343, message: "Internal Error." }
        //  MissingAdobeCPModule                                      : { code: 3344, message: "Missing Flash Access module."},
        //  DRMNoAccessError                                          : { code: 3345, message: "This operation is not permitted with content protected using Flash Access."},
        //  DRMDataMigrationFailed                                    : { code: 3346, message: "Failed migrating local DRM data, all locally cached DRM vouchers are lost."},
        //  DRMInsufficientDeviceCapabilites                          : { code: 3347, message: "The device does not meet the Flash Access server's playback device constraints."},
        //  DRMHardStopIntervalExpired                                : { code: 3348, message: "This protected content is expired."},
        //  DRMServerVersionTooHigh                                   : { code: 3349, message: "The Flash Access server is running at a version that's higher than the max supported by this runtime."},
        //  DRMServerVersionTooLow                                    : { code: 3350, message: "The Flash Access server is running at a version that's lower than the min supported by this runtime."},
        //  DRMDeviceGroupTokenInvalid                                : { code: 3351, message: "Device Group registration token is corrupted, please refresh the token by registering again to the DRMDeviceGroup."},
        //  DRMDeviceGroupTokenTooOld                                 : { code: 3352, message: "The server is using a newer version of the registration token for this Device Group. Please refresh the token by registering again to the DRMDeviceGroup."},
        //  DRMDeviceGroupTokenTooNew                                 : { code: 3353, message: "the server is using an older version of the registration token for this Device Group."},
        //  DRMDeviceGroupTokenExpired                                : { code: 3354, message: "Device Group registration is expired, please refresh the token by registering again to the DRMDeviceGroup."},
        //  JoinDRMDeviceGroupFailed                                  : { code: 3355, message: "The server denied this Device Group registration request."},
        //  DRMVoucherHasNoCorrespondingRoot                          : { code: 3356, message: "The root voucher for this content's DRMVoucher was not found."},
        //  NoValidEmbeddedDRMVoucher                                 : { code: 3357, message: "The DRMContentData provides no valid embedded voucher and no Flash Access server url to acquire the voucher from."},
        //  NoACPProtectionAvailable                                  : { code: 3358, message: "ACP protection is not available on the device but required to playback the content."},
        //  NoCGMSAProtectionAvailable                                : { code: 3359, message: "CGMSA protection is not available on the device but required to playback the content."},
        //  DRMDeviceGroupRegistrationRequired                        : { code: 3360, message: "Device Group registration is required before doing this operation."},
        //  DeviceIsNotRegisteredToDRMDeviceGroup                     : { code: 3361, message: "The device is not registered to this Device Group."},
        //  ScriptBridgeError                                         : { code: 3400, message: "An error occured while executing JavaScript code."},
        //  ScriptBridgeNameAccessSecurityError                       : { code: 3401, message: "Security sandbox violation: An object with this name has already been registered from another security domain."},
        //  ScriptBridgeBrowserAccessSecurityError                    : { code: 3402, message: "Security sandbox violation: Bridge caller %1 cannot access %2."},
        //  ExtensionContextNoSuchMethod                              : { code: 3500, message: "The extension context does not have a method with the name %1."},
        //  ExtensionContextAlreadyDisposed                           : { code: 3501, message: "The extension context has already been disposed."},
        //  ExtensionContextInvalidReturnValue                        : { code: 3502, message: "The extension returned an invalid value."},
        //  ExtensionContextInvalidState                              : { code: 3503, message: "The extension was left in an invalid state."},
        //  NoValidProgramSet                                         : { code: 3600, message: "No valid program set."},
        //  NoValidIndexBufferSet                                     : { code: 3601, message: "No valid index buffer set."},
        //  SanityCheckOnParametersFailed                             : { code: 3602, message: "Sanity check on parameters failed, %1 triangles and %2 index offset."},
        //  NotEnoughIndicesInThisBuffer                              : { code: 3603, message: "Not enough indices in this buffer. %1 triangles at offset %2, but there are only %3 indices in buffer."},
        //  SampleBindsTextureAlsoBoundToRender                       : { code: 3604, message: "Sampler %1 binds a texture that is also bound for render to texture."},
        //  SampleBindsInvalidTexture                                 : { code: 3605, message: "Sampler %1 binds an invalid texture."},
        //  SamplerFormatDoesNotMatchTextureFormat                    : { code: 3606, message: "Sampler %1 format does not match texture format."},
        //  StreamIsNotUsed                                           : { code: 3607, message: "Stream %1 is set but not used by the current vertex program."},
        //  StreamIsInvalid                                           : { code: 3608, message: "Stream %1 is invalid."},
        //  StreamDoesNotHaveEnoughVertices                           : { code: 3609, message: "Stream %1 does not have enough vertices."},
        //  StreamVertexOffsetOutOfBounds                             : { code: 3610, message: "Stream %1 vertex offset is out of bounds"},
        //  StreamReadButNotSet                                       : { code: 3611, message: "Stream %1 is read by the current vertex program but not set."},
        //  ProgramMustBeLittleEndian                                 : { code: 3612, message: "Programs must be in little endian format."},
        //  NativeShaderCompilationFailed                             : { code: 3613, message: "The native shader compilation failed."},
        //  NativeShaderCompilationFailedOpenGL                       : { code: 3614, message: "The native shader compilation failed.enGL specific: %1"},
        //  AgalProgramTooSmall                                       : { code: 3615, message: "AGAL validation failed: Program size below minimum length for %1 program."},
        //  NotAnAgalProgram                                          : { code: 3616, message: "AGAL validation failed: Not an AGAL program. Wrong magic byte for %1 program."},
        //  BadAgalVersion                                            : { code: 3617, message: "AGAL validation failed: Bad AGAL version for %1 program. Current version is %2."},
        //  BadAgalProgramType                                        : { code: 3618, message: "AGAL validation failed: Bad AGAL program type identifier for %1 program."},
        //  BadAgalShadertype                                         : { code: 3619, message: "AGAL validation failed: Shader type must be either fragment or vertex for %1 program."},
        //  InvalidAgalOpcodeOutOfRange                               : { code: 3620, message: "AGAL validation failed: Invalid opcode, value out of range: %2 at token %3 of %1 program."},
        //  InvalidAgalOpcodeNotImplemented                           : { code: 3621, message: "AGAL validation failed: Invalid opcode, %2 is not implemented in this version at token %3 of %1 program."},
        //  AgalOpcodeOnlyAllowedInFragmentProgram                    : { code: 3622, message: "AGAL validation failed: Opcode %2 only allowed in fragment programs at token %3 of %1 program."},
        //  OpenConditionNesting                                      : { code: 3623, message: "AGAL validation failed: Open condition nesting (close without open) at token %2 of %1 program."},
        //  ConditionNestingTooDeep                                   : { code: 3624, message: "AGAL validation failed: Condition nesting (%2) too deep at token %3 of %1 program."},
        //  BadAgalSourceOperands                                     : { code: 3625, message: "AGAL validation failed: Bad AGAL source operands. Both are constants (this must be precomputed) at token %2 of %1 program."},
        //  BothOperandsAreIndirectReads                              : { code: 3626, message: "AGAL validation failed: Opcode %2, both operands are indirect reads at token %3 of %1 program."},
        //  OpcodeDestinationMustBeAllZero                            : { code: 3627, message: "AGAL validation failed: Opcode %2 destination operand must be all zero at token %3 of %1 program."},
        //  OpcodeDestinationMustUseMask                              : { code: 3628, message: "AGAL validation failed: The destination operand for the %2 instruction must mask w (use .xyz or less) at token %3 of %1 program."},
        //  TooManyTokens                                             : { code: 3629, message: "AGAL validation failed: Too many tokens (%2) for %1 program."},
        //  FragmentShaderType                                        : { code: 3630, message: "Fragment shader type is not fragment."},
        //  VertexShaderType                                          : { code: 3631, message: "Vertex shader type is not vertex."},
        //  VaryingReadButNotWrittenTo                                : { code: 3632, message: "AGAL linkage: Varying %1 is read in the fragment shader but not written to by the vertex shader."},
        //  VaryingPartialWrite                                       : { code: 3633, message: "AGAL linkage: Varying %1 is only partially written to. Must write all four components."},
        //  FragmentWriteAllComponents                                : { code: 3634, message: "AGAL linkage: Fragment output needs to write to all components."},
        //  VertexWriteAllComponents                                  : { code: 3635, message: "AGAL linkage: Vertex output needs to write to all components."},
        //  UnusedOperand                                             : { code: 3636, message: "AGAL validation failed: Unused operand is not set to zero for %2 at token %3 of %1 program."},
        //  SamplerRegisterOnlyInFragment                             : { code: 3637, message: "AGAL validation failed: Sampler registers only allowed in fragment programs for %2 at token %3 of %1 program."},
        //  SamplerRegisterSecondOperand                              : { code: 3638, message: "AGAL validation failed: Sampler register only allowed as second operand in texture instructions for %2 at token %3 of %1 program."},
        //  IndirectOnlyAllowedInVertex                               : { code: 3639, message: "AGAL validation failed: Indirect addressing only allowed in vertex programs for %2 at token %3 of %1 program."},
        //  IndirectOnlyIntoConstantRegisters                         : { code: 3640, message: "AGAL validation failed: Indirect addressing only allowed into constant registers for %2 at token %3 of %1 program."},
        //  IndirectNotAllowed                                        : { code: 3641, message: "AGAL validation failed: Indirect addressing not allowed for this operand in this instruction for %2 at token %3 of %1 program."},
        //  IndirectSourceType                                        : { code: 3642, message: "AGAL validation failed: Indirect source type must be attribute, constant or temporary for %2 at token %3 of %1 program."},
        //  IndirectAddressingFieldsMustBeZero                        : { code: 3643, message: "AGAL validation failed: Indirect addressing fields must be zero for direct adressing for %2 at token %3 of %1 program."},
        //  VaryingRegistersOnlyReadInFragment                        : { code: 3644, message: "AGAL validation failed: Varying registers can only be read in fragment programs for %2 at token %3 of %1 program."},
        //  AttributeRegistersOnlyReadInVertex                        : { code: 3645, message: "AGAL validation failed: Attribute registers can only be read in vertex programs for %2 at token %3 of %1 program."},
        //  CanNotReadOutputRegister                                  : { code: 3646, message: "AGAL validation failed: Can not read from output register for %2 at token %3 of %1 program."},
        //  TempRegisterReadWithoutWrite                              : { code: 3647, message: "AGAL validation failed: Temporary register read without being written to for %2 at token %3 of %1 program."},
        //  TempRegisterComponentReadWithoutWrite                     : { code: 3648, message: "AGAL validation failed: Temporary register component read without being written to for %2 at token %3 of %1 program."},
        //  SamplerRegisterCannotBeWrittenTo                          : { code: 3649, message: "AGAL validation failed: Sampler registers can not be written to for %2 at token %3 of %1 program."},
        //  VaryingRegistersWrite                                     : { code: 3650, message: "AGAL validation failed: Varying registers can only be written in vertex programs for %2 at token %3 of %1 program."},
        //  AttributeRegisterCannotBeWrittenTo                        : { code: 3651, message: "AGAL validation failed: Attribute registers can not be written to for %2 at token %3 of %1 program."},
        //  ConstantRegisterCannotBeWrittenTo                         : { code: 3652, message: "AGAL validation failed: Constant registers can not be written to for %2 at token %3 of %1 program."},
        //  DestinationWritemaskIsZero                                : { code: 3653, message: "AGAL validation failed: Destination writemask is zero for %2 at token %3 of %1 program."},
        //  AGALReservedBitsShouldBeZero                              : { code: 3654, message: "AGAL validation failed: Reserve bits should be zero for %2 at token %3 of %1 program."},
        //  UnknownRegisterType                                       : { code: 3655, message: "AGAL validation failed: Unknown register type for %2 at token %3 of %1 program."},
        //  SamplerRegisterOutOfBounds                                : { code: 3656, message: "AGAL validation failed: Sampler register index out of bounds for %2 at token %3 of %1 program."},
        //  VaryingRegisterOutOfBounds                                : { code: 3657, message: "AGAL validation failed: Varying register index out of bounds for %2 at token %3 of %1 program."},
        //  AttributeRegisterOutOfBounds                              : { code: 3658, message: "AGAL validation failed: Attribute register index out of bounds for %2 at token %3 of %1 program."},
        //  ConstantRegisterOutOfBounds                               : { code: 3659, message: "AGAL validation failed: Constant register index out of bounds for %2 at token %3 of %1 program."},
        //  OutputRegisterOutOfBounds                                 : { code: 3660, message: "AGAL validation failed: Output register index out of bounds for %2 at token %3 of %1 program."},
        //  TemporaryRegisterOutOfBounds                              : { code: 3661, message: "AGAL validation failed: Temporary register index out of bounds for %2 at token %3 of %1 program."},
        //  CubeMapSamplerMustUseClamp                                : { code: 3662, message: "AGAL validation failed: Cube map samplers must set wrapping to clamp mode for %2 at token %3 of %1 program."},
        //  SampleBindsUndefinedTexture                               : { code: 3663, message: "Sampler %1 binds an undefined texture."},
        //  UnknownSamplerDimension                                   : { code: 3664, message: "AGAL validation failed: Unknown sampler dimension %4 for %2 at token %3 of %1 program."},
        //  UnknownFilterMode                                         : { code: 3665, message: "AGAL validation failed: Unknown filter mode in sampler: %4 for %2 at token %3 of %1 program."},
        //  UnknownMipmapMode                                         : { code: 3666, message: "AGAL validation failed: Unknown mipmap mode in sampler: %4 for %2 at token %3 of %1 program."},
        //  UnknownWrappingMode                                       : { code: 3667, message: "AGAL validation failed: Unknown wrapping mode in sampler: %4 for %2 at token %3 of %1 program."},
        //  UnknownSpecialFlag                                        : { code: 3668, message: "AGAL validation failed: Unknown special flag used in sampler: %4 for %2 at token %3 of %1 program."},
        //  BadInputSize                                              : { code: 3669, message: "Bad input size."},
        //  BufferTooBig                                              : { code: 3670, message: "Buffer too big."},
        //  BufferHasZeroSize                                         : { code: 3671, message: "Buffer has zero size."},
        //  BufferCreationFailed                                      : { code: 3672, message: "Buffer creation failed. Internal error."},
        //  InvalidCubeSide                                           : { code: 3673, message: "Cube side must be [0..5]."},
        //  MiplevelTooLarge                                          : { code: 3674, message: "Miplevel too large."},
        //  TextureFormatMismatch                                     : { code: 3675, message: "Texture format mismatch."},
        //  PlatformDoesNotSupportTextureFormat                       : { code: 3676, message: "Platform does not support desired texture format."},
        //  TextureDecodingFailed                                     : { code: 3677, message: "Texture decoding failed. Internal error."},
        //  TextureNeedsToBeSquare                                    : { code: 3678, message: "Texture needs to be square."},
        //  TextureSizeDoesNotMatch                                   : { code: 3679, message: "Texture size does not match."},
        //  DepthTextureNotImplemented                                : { code: 3680, message: "Depth texture not implemented yet."},
        //  TextureSizeIsZero                                         : { code: 3681, message: "Texture size is zero."},
        //  TextureNotPowerOfTwo                                      : { code: 3682, message: "Texture size not a power of two."},
        //  TextureTooBig                                             : { code: 3683, message: "Texture too big (max is 2048x2048)."},
        //  TextureCreationFailed                                     : { code: 3684, message: "Texture creation failed. Internal error."},
        //  CouldNotCreateRenderer                                    : { code: 3685, message: "Could not create renderer."},
        //  DisabledFormatNeedsNullVertexBuffer                       : { code: 3686, message: "'disabled' format only valid with a null vertex buffer."},
        //  NullVertexBufferNeedsDisabledFormat                       : { code: 3687, message: "Null vertex buffers require the 'disabled' format."},
        //  NeedListenerToRequestContext                              : { code: 3688, message: "You must add an event listener for the context3DCreate event before requesting a new Context3D."},
        //  CantSwizzle2ndSource                                      : { code: 3689, message: "You can not swizzle second operand for %2 at token %3 of %1 program."},
        //  TooManyDrawCalls                                          : { code: 3690, message: "Too many draw calls before calling present."},
        //  ResourceLimitExceeded                                     : { code: 3691, message: "Resource limit for this resource type exceeded."},
        //  NeedToClearBeforeDraw                                     : { code: 3692, message: "All buffers need to be cleared every frame before drawing."},
        //  SecondOperandMustBeSamplerRegister                        : { code: 3693, message: "AGAL validation failed: Sampler register must be used for second operand in texture instructions for %2 at token %3 of %1 program."},
        //  ObjectDisposed                                            : { code: 3694, message: "The object was disposed by an earlier call of dispose() on it."},
        //  SameTextureNeedsSameSamplerParams                         : { code: 3695, message: "A texture can only be bound to multiple samplers if the samplers also have the exact same properties. Mismatch at samplers %1 and %2."},
        //  SecondUseOfSamplerMustHaveSameParams                      : { code: 3696, message: "AGAL validation failed: Second use of sampler register needs to specify the exact same properties. At token %3 of %1 program."},
        //  TextureBoundButNotUsed                                    : { code: 3697, message: "A texture is bound on sampler %1 but not used by the fragment program."},
        //  BackBufferNotConfigured                                   : { code: 3698, message: "The back buffer is not configured."},
        //  OperationFailed                                           : { code: 3699, message: "Requested Operation failed to complete"},
        //  TextureMipchainIsNotComplete                              : { code: 3700, message: "A texture sampler binds an incomplete texture. Make sure to upload(). All miplevels are required when mipmapping is enabled."},
        //  OutputColorNotMaskable                                    : { code: 3701, message: "The output color register can not use a write mask. All components must be written."},
        //  Context3DNotAvailable                                     : { code: 3702, message: "Context3D not available."},
        //  SwizzleMustBeScalar                                       : { code: 3703, message: "AGAL validation failed: Source swizzle must be scalar (one of: xxxx, yyyy, zzzz, wwww) for %2 at token %3 of %1 program."},
        //  CubeMapSamplerMustUseMipmap                               : { code: 3704, message: "AGAL validation failed: Cube map samplers must enable mipmapping for %2 at token %3 of %1 program."}
    };
    for (var k in Errors$1) {
        var error$1 = Errors$1[k];
        error$1.typeName = k;
        Errors$1[error$1.code] = error$1;
    }
    function getErrorMessage(index) {
        var message = "Error #" + index;
        if (!debuggerMode.value) {
            return message;
        }
        var error$$1 = Errors$1[index];
        return message + ": " + (error$$1 && error$$1.message || "(unknown)");
    }
    function getErrorInfo(index) {
        return Errors$1[index];
    }
    function formatErrorMessage(error$$1) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var message = error$$1.message;
        args.forEach(function (x, i) {
            message = message.replace("%" + (i + 1), x);
        });
        return "Error #" + error$$1.code + ": " + message;
    }

    function validateCall(sec, fun, argc) {
        if (!fun || !fun.axApply) {
            sec.throwError('TypeError', Errors$1.CallOfNonFunctionError, fun && fun.methodInfo ? fun.methodInfo.getName() : 'value');
        }
        if (fun.methodInfo && argc < fun.methodInfo.minArgs) {
            sec.throwError('ArgumentError', Errors$1.WrongArgumentCountError, fun.methodInfo.getName(), fun.methodInfo.minArgs, argc);
        }
    }

    function validateConstruct(sec, axClass, argc) {
        if (!axClass || !axClass.axConstruct) {
            var name = axClass && axClass.classInfo ?
                axClass.classInfo.instanceInfo.getName().name :
                'value';
            sec.throwError('TypeError', Errors$1.ConstructOfNonFunctionError, name);
        }
        var methodInfo = axClass.classInfo.getInitializer();
        if (argc < methodInfo.minArgs) {
            sec.throwError('ArgumentError', Errors$1.WrongArgumentCountError, axClass.classInfo.instanceInfo.getName().name, methodInfo.minArgs, argc);
        }
    }

    var ASObject$1 = /** @class */ (function () {
        function ASObject() {
        }
        ASObject.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = ASObject.prototype;
            addPrototypeFunctionAlias(proto, "$BghasOwnProperty", asProto.native_hasOwnProperty);
            addPrototypeFunctionAlias(proto, "$BgpropertyIsEnumerable", asProto.native_propertyIsEnumerable);
            addPrototypeFunctionAlias(proto, "$BgsetPropertyIsEnumerable", asProto.native_setPropertyIsEnumerable);
            addPrototypeFunctionAlias(proto, "$BgisPrototypeOf", asProto.native_isPrototypeOf);
            addPrototypeFunctionAlias(proto, '$BgtoLocaleString', asProto.toString);
        };
        ASObject._init = function () {
            // Nop.
        };
        ASObject.init = function () {
            // Nop.
        };
        ASObject.prototype.native_isPrototypeOf = function (v) {
            return this.isPrototypeOf(this.sec.box(v));
        };
        ASObject.prototype.native_hasOwnProperty = function (nm) {
            return this.axHasOwnProperty(makeMultiname(nm));
        };
        ASObject.prototype.native_propertyIsEnumerable = function (nm) {
            var descriptor = Object.getOwnPropertyDescriptor(this, qualifyPublicName(axCoerceString$3(nm)));
            return !!descriptor && descriptor.enumerable;
        };
        ASObject.prototype.native_setPropertyIsEnumerable = function (nm, enumerable) {
            if (enumerable === void 0) { enumerable = true; }
            var qualifiedName = qualifyPublicName(axCoerceString$3(nm));
            enumerable = !!enumerable;
            var instanceInfo = this.axClass.classInfo.instanceInfo;
            if (instanceInfo.isSealed() && this !== this.axClass.dPrototype) {
                this.sec.throwError('ReferenceError', Errors$1.WriteSealedError, nm, instanceInfo.name.name);
            }
            // Silently ignore trait properties.
            var descriptor = Object.getOwnPropertyDescriptor(this.axClass.tPrototype, qualifiedName);
            if (descriptor && this !== this.axClass.dPrototype) {
                return;
            }
            var descriptor = Object.getOwnPropertyDescriptor(this, qualifiedName);
            // ... and non-existent properties.
            if (!descriptor) {
                return;
            }
            if (descriptor.enumerable !== enumerable) {
                descriptor.enumerable = enumerable;
                Object.defineProperty(this, qualifiedName, descriptor);
            }
        };
        ASObject.prototype.axResolveMultiname = function (mn) {
            if (mn.numeric)
                return mn.numericValue;
            var s = mn.name;
            if (mn.mutable) {
                var t = this.traits.getTrait(mn.namespaces, s);
                return t ? t.name.getMangledName() : '$Bg' + s;
            }
            else {
                var c = mn.resolved[this.axClassName];
                if (c)
                    return c;
                var t = this.traits.getTraitMultiname(mn);
                var r = t ? t.name.getMangledName() : ('$Bg' + s);
                mn.resolved[this.axClassName] = r;
                return r;
            }
        };
        ASObject.prototype.axHasProperty = function (mn) {
            return this.axHasPropertyInternal(mn);
        };
        ASObject.prototype.axHasPublicProperty = function (nm) {
            rn.name = nm;
            var result = this.axHasProperty(rn);
            release$1 || assert(rn.name === nm || isNaN(rn.name) && isNaN(nm));
            return result;
        };
        ASObject.prototype.axSetProperty = function (mn, value, bc) {
            //if(typeof value == "number" && isNaN(value))
            //    console.log("try to set NaN", mn);
            release$1 || checkValue(value);
            var name = mn.name;
            if (typeof name === 'number' || isNumeric(name = axCoerceName(name))) {
                release$1 || assert(mn.isRuntimeName());
                this[+name] = value;
                return;
            }
            var freeze = false;
            var t = this.traits.getTrait(mn.namespaces, name);
            if (t) {
                var mangledName = t.name.getMangledName();
                switch (t.kind) {
                    case 1 /* Method */:
                        this.sec.throwError('ReferenceError', Errors$1.CannotAssignToMethodError, name, this.axClass.name.name);
                    // Unreachable because of throwError.
                    case 2 /* Getter */:
                        this.sec.throwError('ReferenceError', Errors$1.ConstWriteError, name, this.axClass.name.name);
                    // Unreachable because of throwError.
                    case 4 /* Class */:
                    case 6 /* Const */:
                        // Technically, we need to check if the currently running function is the
                        // initializer of whatever class/package the property is initialized on.
                        // In practice, we freeze the property after first assignment, causing
                        // an internal error to be thrown if it's being initialized a second time.
                        // Invalid bytecode could leave out the assignent during first initialization,
                        // but it's hard to see how that could convert into real-world problems.
                        if (bc !== 104 /* INITPROPERTY */) {
                            this.sec.throwError('ReferenceError', Errors$1.ConstWriteError, name, this.axClass.name.name);
                        }
                        freeze = true;
                        break;
                }
                var type = t.getType();
                if (type)
                    value = type.axCoerce(value);
            }
            else {
                mangledName = '$Bg' + name;
            }
            this[mangledName] = value;
            if (freeze) {
                Object.defineProperty(this, mangledName, { writable: false });
            }
        };
        ASObject.prototype.axGetProperty = function (mn) {
            var name = this.axResolveMultiname(mn);
            var value = this[name];
            if (typeof value === "function")
                return this.axGetMethod(name);
            //80pro: workaround:
            if (typeof value === "undefined")
                value = this[name.replace("$Bg", "")];
            release$1 || checkValue(value);
            return value;
        };
        ASObject.prototype.axGetMethod = function (name) {
            release$1 || assert(typeof this[name] === 'function');
            var cache = this._methodClosureCache;
            if (!cache) {
                Object.defineProperty(this, '_methodClosureCache', { value: Object.create(null) });
                cache = this._methodClosureCache;
            }
            var method = cache[name];
            if (!method) {
                method = cache[name] = this.sec.AXMethodClosure.Create(this, this[name]);
            }
            return method;
        };
        ASObject.prototype.axGetSuper = function (mn, scope) {
            var name = axCoerceName(mn.name);
            var namespaces = mn.namespaces;
            var trait = scope.parent.object.tPrototype.traits.getTrait(namespaces, name);
            var value;
            if (trait.kind === 2 /* Getter */ || trait.kind === 7 /* GetterSetter */) {
                value = trait.get.call(this);
            }
            else {
                var mangledName = trait.name.getMangledName();
                value = this[mangledName];
                if (typeof value === 'function') {
                    return this.axGetMethod(mangledName);
                }
            }
            release$1 || checkValue(value);
            return value;
        };
        ASObject.prototype.axSetSuper = function (mn, scope, value) {
            release$1 || checkValue(value);
            var name = axCoerceName(mn.name);
            var namespaces = mn.namespaces;
            var trait = scope.parent.object.tPrototype.traits.getTrait(namespaces, name);
            var type = trait.getType();
            if (type) {
                value = type.axCoerce(value);
            }
            if (trait.kind === 3 /* Setter */ || trait.kind === 7 /* GetterSetter */) {
                trait.set.call(this, value);
            }
            else {
                this[trait.name.getMangledName()] = value;
            }
        };
        ASObject.prototype.axDeleteProperty = function (mn) {
            // Cannot delete traits.
            var name = axCoerceName(mn.name);
            var namespaces = mn.namespaces;
            if (this.traits.getTrait(namespaces, name)) {
                return false;
            }
            return delete this[mn.getPublicMangledName()];
        };
        ASObject.prototype.axCallProperty = function (mn, args, isLex) {
            var fun = this[this.axResolveMultiname(mn)];
            //console.log("call function name:", name);
            validateCall(this.sec, fun, args.length);
            return fun.axApply(isLex ? null : this, args);
        };
        ASObject.prototype.axCallSuper = function (mn, scope, args) {
            var fun = scope.parent.object.tPrototype[this.axResolveMultiname(mn)];
            validateCall(this.sec, fun, args.length);
            return fun.axApply(this, args);
        };
        ASObject.prototype.axConstructProperty = function (mn, args) {
            var ctor = this[this.axResolveMultiname(mn)];
            validateConstruct(this.sec, ctor, args.length);
            return ctor.axConstruct(args);
        };
        ASObject.prototype.axHasPropertyInternal = function (mn) {
            return this.axResolveMultiname(mn) in this;
        };
        ASObject.prototype.axHasOwnProperty = function (mn) {
            var name = this.axResolveMultiname(mn);
            // We have to check for trait properties too if a simple hasOwnProperty fails.
            // This is different to JavaScript's hasOwnProperty behaviour where hasOwnProperty returns
            // false for properties defined on the property chain and not on the instance itself.
            return this.hasOwnProperty(name) || this.axClass.tPrototype.hasOwnProperty(name);
        };
        ASObject.prototype.axGetEnumerableKeys = function () {
            if (this.sec.isPrimitive(this)) {
                return [];
            }
            var tPrototype = Object.getPrototypeOf(this);
            var keys = Object.keys(this);
            var result = [];
            for (var i = 0; i < keys.length; i++) {
                var key = keys[i];
                if (isNumeric(key)) {
                    result.push(key);
                }
                else {
                    if (tPrototype.hasOwnProperty(key)) {
                        continue;
                    }
                    var name = Multiname.stripPublicMangledName(key);
                    if (name !== undefined) {
                        result.push(name);
                    }
                }
            }
            return result;
        };
        ASObject.prototype.axGetPublicProperty = function (nm) {
            return this[Multiname.getPublicMangledName(nm)];
        };
        ASObject.prototype.axSetPublicProperty = function (nm, value) {
            release$1 || checkValue(value);
            this[Multiname.getPublicMangledName(nm)] = value;
        };
        ASObject.prototype.axCallPublicProperty = function (nm, argArray) {
            return this[Multiname.getPublicMangledName(nm)].axApply(this, argArray);
        };
        ASObject.prototype.axDeletePublicProperty = function (nm) {
            return delete this[Multiname.getPublicMangledName(nm)];
        };
        ASObject.prototype.axGetSlot = function (i) {
            var t = this.traits.getSlot(i);
            var value = this[t.name.getMangledName()];
            release$1 || checkValue(value);
            return value;
        };
        ASObject.prototype.axSetSlot = function (i, value) {
            release$1 || checkValue(value);
            var t = this.traits.getSlot(i);
            var name = t.name.getMangledName();
            var type = t.getType();
            this[name] = type ? type.axCoerce(value) : value;
        };
        /**
         * Gets the next name index of an object. Index |zero| is actually not an
         * index, but rather an indicator to start the iteration.
         */
        ASObject.prototype.axNextNameIndex = function (index) {
            var self = this;
            if (index === 0) {
                // Gather all enumerable keys since we're starting a new iteration.
                defineNonEnumerableProperty(self, "axEnumerableKeys", self.axGetEnumerableKeys());
            }
            var axEnumerableKeys = self.axEnumerableKeys;
            while (index < axEnumerableKeys.length) {
                rn.name = axEnumerableKeys[index];
                if (self.axHasPropertyInternal(rn)) {
                    release$1 || assert(rn.name === axEnumerableKeys[index]);
                    return index + 1;
                }
                index++;
            }
            return 0;
        };
        /**
         * Gets the nextName after the specified |index|, which you would expect to
         * be index + 1, but it's actually index - 1;
         */
        ASObject.prototype.axNextName = function (index) {
            var self = this;
            var axEnumerableKeys = self.axEnumerableKeys;
            release$1 || assert(axEnumerableKeys && index > 0 && index < axEnumerableKeys.length + 1);
            return axEnumerableKeys[index - 1];
        };
        ASObject.prototype.axNextValue = function (index) {
            return this.axGetPublicProperty(this.axNextName(index));
        };
        ASObject.prototype.axSetNumericProperty = function (nm, value) {
            this.axSetPublicProperty(nm, value);
        };
        ASObject.prototype.axGetNumericProperty = function (nm) {
            return this.axGetPublicProperty(nm);
        };
        ASObject.classSymbols = null;
        ASObject.instanceSymbols = null;
        return ASObject;
    }());

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: Event
    var Event = /** @class */ (function (_super) {
        __extends(Event, _super);
        function Event(type, bubbles, cancelable) {
            if (bubbles === void 0) { bubbles = true; }
            if (cancelable === void 0) { cancelable = true; }
            var _this = _super.call(this) || this;
            _this._type = axCoerceString(type);
            _this._bubbles = !!bubbles;
            _this._cancelable = !!cancelable;
            _this._target = null;
            _this._currentTarget = null;
            _this._eventPhase = null; //80pro: todo: EventPhase.AT_TARGET;
            _this._stopPropagation = false;
            _this._stopImmediatePropagation = false;
            _this._isDefaultPrevented = false;
            return _this;
        }
        Event.getInstance = function (type, bubbles, cancelable) {
            if (bubbles === void 0) { bubbles = false; }
            if (cancelable === void 0) { cancelable = false; }
            var instance = this._instances[type];
            if (!instance) {
                instance = new Event(type, bubbles, cancelable);
                this._instances[type] = instance;
            }
            instance._bubbles = bubbles;
            instance._cancelable = cancelable;
            return instance;
        };
        Event.getBroadcastInstance = function (type, bubbles, cancelable) {
            if (bubbles === void 0) { bubbles = false; }
            if (cancelable === void 0) { cancelable = false; }
            var instance = this._instances[type];
            if (!instance) {
                instance = new Event(type, bubbles, cancelable);
                this._instances[type] = instance;
                // Some events are documented as broadcast event in the AS3 docs. We can't set |_isBroadcastEvent| flag in the
                // constructor because if you create custom events with these types they do capture and bubble.
                release$1 || assert(Event.isBroadcastEventType(type));
            }
            instance._isBroadcastEvent = true;
            instance._bubbles = bubbles;
            instance._cancelable = cancelable;
            return instance;
        };
        /**
         * http://stackoverflow.com/questions/16900176/as3enterframe-event-propagation-understanding-issue
         */
        Event.isBroadcastEventType = function (type) {
            switch (type) {
                case Event.ENTER_FRAME:
                case Event.EXIT_FRAME:
                case Event.FRAME_CONSTRUCTED:
                case Event.RENDER:
                case Event.ACTIVATE:
                case Event.DEACTIVATE:
                    return true;
            }
            return false;
        };
        Object.defineProperty(Event.prototype, "type", {
            get: function () {
                return this._type;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Event.prototype, "bubbles", {
            get: function () {
                return this._bubbles;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Event.prototype, "cancelable", {
            get: function () {
                return this._cancelable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Event.prototype, "target", {
            get: function () {
                return this._target;
            },
            set: function (value) {
                this._target = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Event.prototype, "currentTarget", {
            get: function () {
                return this._currentTarget;
            },
            set: function (value) {
                this._currentTarget = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Event.prototype, "eventPhase", {
            get: function () {
                return this._eventPhase;
            },
            enumerable: true,
            configurable: true
        });
        Event.prototype.stopPropagation = function () {
            this._stopPropagation = true;
        };
        Event.prototype.stopImmediatePropagation = function () {
            this._stopImmediatePropagation = this._stopPropagation = true;
        };
        Event.prototype.preventDefault = function () {
            if (this._cancelable) {
                this._isDefaultPrevented = true;
            }
        };
        Event.prototype.isDefaultPrevented = function () {
            return this._isDefaultPrevented;
        };
        Event.prototype.isBroadcastEvent = function () {
            return !!this._isBroadcastEvent;
        };
        Event.prototype.clone = function () {
            return new Event(this._type, this._bubbles, this._cancelable);
        };
        Event.prototype.toString = function () {
            return this.formatToString('Event', 'type', 'bubbles', 'cancelable', 'eventPhase');
        };
        Event.prototype.formatToString = function (className) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            var str = '[' + className;
            for (var i = 0; i < args.length; i++) {
                var field = args[i];
                var value = this.axGetPublicProperty(field);
                if (typeof value === 'string') {
                    value = '"' + value + '"';
                }
                str += ' ' + field + '=' + value;
            }
            return str + ']';
        };
        Event.classInitializer = function () {
            var self = this;
            self._instances = ObjectUtilities.createMap();
        };
        // JS -> AS Bindings
        Event.ACTIVATE = "activate";
        Event.ADDED = "added";
        Event.ADDED_TO_STAGE = "addedToStage";
        Event.CANCEL = "cancel";
        Event.CHANGE = "change";
        Event.CLEAR = "clear";
        Event.CLOSE = "close";
        Event.COMPLETE = "complete";
        Event.CONNECT = "connect";
        Event.COPY = "copy";
        Event.CUT = "cut";
        Event.DEACTIVATE = "deactivate";
        Event.ENTER_FRAME = "enterFrame";
        Event.FRAME_CONSTRUCTED = "frameConstructed";
        Event.EXIT_FRAME = "exitFrame";
        Event.FRAME_LABEL = "frameLabel";
        Event.ID3 = "id3";
        Event.INIT = "init";
        Event.MOUSE_LEAVE = "mouseLeave";
        Event.OPEN = "open";
        Event.PASTE = "paste";
        Event.REMOVED = "removed";
        Event.REMOVED_FROM_STAGE = "removedFromStage";
        Event.RENDER = "render";
        Event.RESIZE = "resize";
        Event.SCROLL = "scroll";
        Event.TEXT_INTERACTION_MODE_CHANGE = "textInteractionModeChange";
        Event.SELECT = "select";
        Event.SELECT_ALL = "selectAll";
        Event.SOUND_COMPLETE = "soundComplete";
        Event.TAB_CHILDREN_CHANGE = "tabChildrenChange";
        Event.TAB_ENABLED_CHANGE = "tabEnabledChange";
        Event.TAB_INDEX_CHANGE = "tabIndexChange";
        Event.UNLOAD = "unload";
        Event.FULLSCREEN = "fullScreen";
        Event.CONTEXT3D_CREATE = "context3DCreate";
        Event.TEXTURE_READY = "textureReady";
        Event.VIDEO_FRAME = "videoFrame";
        Event.SUSPEND = "suspend";
        Event.AVM1_INIT = "initialize";
        Event.AVM1_CONSTRUCT = "construct";
        Event.AVM1_LOAD = "load";
        return Event;
    }(ASObject$1));

    /**
     * Base export class for dispatching events
    *
    * @export class away.events.EventDispatcher
    *
    */
    var EventDispatcherBase = /** @class */ (function (_super) {
        __extends(EventDispatcherBase, _super);
        function EventDispatcherBase(target) {
            if (target === void 0) { target = null; }
            var _this = _super.call(this) || this;
            _this._listenerObjects = new Array();
            _this._queuedEvents = [];
            _this._t = target || _this;
            return _this;
        }
        EventDispatcherBase.prototype.toString = function () {
            return "";
        };
        /**
         * Add an event listener
         * @method addEventListener
         * @param {String} Name of event to add a listener for
         * @param {Function} Callback function
         */
        EventDispatcherBase.prototype.addEventListener = function (type, listener) {
            if (!this._listenerObjects)
                return;
            var l = this._listenerObjects[type];
            if (l === undefined)
                l = this._listenerObjects[type] = new ListenerObject$1();
            l.addEventListener(listener);
        };
        /**
         * Remove an event listener
         * @method removeEventListener
         * @param {String} Name of event to remove a listener for
         * @param {Function} Callback function
         */
        EventDispatcherBase.prototype.removeEventListener = function (type, listener) {
            if (!this._listenerObjects)
                return;
            var l = this._listenerObjects[type];
            if (l) {
                l.removeEventListener(listener);
                if (l.numListeners == 0)
                    delete this._listenerObjects[type];
            }
        };
        EventDispatcherBase.prototype.getQueuedEvents = function () {
            if (!this._queuedEvents)
                return null;
            var returnEvents = this._queuedEvents.concat();
            this._queuedEvents.length = 0;
            return returnEvents;
        };
        /**
         * Dispatch an event
         * @method dispatchEvent
         * @param {Event} Event to dispatch
         */
        EventDispatcherBase.prototype.dispatchEvent = function (event) {
            if (!this._listenerObjects) {
                if (!this._queuedEvents)
                    this._queuedEvents = [];
                this._queuedEvents.push(event);
                return;
            }
            var l = this._listenerObjects[event.type];
            if (l) {
                event.target = this._t;
                l.dispatchEvent(event);
            }
        };
        /**
         * check if an object has an event listener assigned to it
         * @method hasListener
         * @param {String} Name of event to remove a listener for
         * @param {Function} Callback function
         */
        EventDispatcherBase.prototype.hasEventListener = function (type, listener) {
            if (!this._listenerObjects)
                return;
            if (this._listenerObjects[type] === undefined)
                return false;
            if (listener != null)
                return this._listenerObjects[type].getEventListenerIndex(listener) !== -1;
            return this._listenerObjects[type].numListeners > 0;
        };
        return EventDispatcherBase;
    }(ASObject$1));
    var ListenerObject$1 = /** @class */ (function () {
        function ListenerObject() {
            this._index = 0;
            this._listeners = new Array();
            this.numListeners = 0;
        }
        ListenerObject.prototype.addEventListener = function (listener) {
            //check if listener already added
            if (this.getEventListenerIndex(listener) !== -1)
                return;
            this._listeners.push(listener);
            this.numListeners++;
        };
        ListenerObject.prototype.removeEventListener = function (listener) {
            //check if listener exists
            var index = this.getEventListenerIndex(listener);
            if (index === -1)
                return;
            this._listeners.splice(index, 1);
            //deals with removing a listener mid-way through dispatching listeners
            if (index <= this._index)
                this._index--;
            this.numListeners--;
        };
        ListenerObject.prototype.dispatchEvent = function (event) {
            var len = this.numListeners;
            for (this._index = 0; this._index < len && this._index < this.numListeners; this._index++)
                this._listeners[this._index].call(this._listeners[this._index], event);
        };
        /**
         * get Event Listener Index in array. Returns -1 if no listener is added
         * @method getEventListenerIndex
         * @param {String} Name of event to remove a listener for
         * @param {Function} Callback function
         */
        ListenerObject.prototype.getEventListenerIndex = function (listener) {
            for (var index = 0; index < this.numListeners; index++)
                if (listener == this._listeners[index])
                    return index;
            return -1;
        };
        return ListenerObject;
    }());

    /**
         * [broadcast event] Dispatched when the Flash Player or AIR application operating
         * loses system focus and is becoming inactive.
         * @eventType	flash.events.Event.DEACTIVATE
        [Event(name="deactivate", type="flash.events.Event")]

         * [broadcast event] Dispatched when the Flash Player or AIR application gains
         * operating system focus and becomes active.
         * @eventType	flash.events.Event.ACTIVATE
        [Event(name="activate", type="flash.events.Event")]
     */
    var EventDispatcher$1 = /** @class */ (function (_super) {
        __extends(EventDispatcher, _super);
        function EventDispatcher(target) {
            if (target === void 0) { target = null; }
            var _this = _super.call(this, target) || this;
            _this.eventMapping = {};
            _this.eventMappingDummys = {};
            _this.eventMappingExtern = {};
            _this.eventMappingInvert = {}; //only needed in some cases, when we translate back from awayjs-type to flash-type
            _this._activateCallbackDelegate = function (event) { return _this.activateCallback(event); };
            _this.eventMapping[Event.ACTIVATE] = {
                adaptedType: "",
                addListener: _this.initActivateListener,
                removeListener: _this.removeActivateListener,
                callback: _this._activateCallbackDelegate
            };
            _this._deactivateCallbackDelegate = function (event) { return _this.deactivateCallback(event); };
            _this.eventMapping[Event.DEACTIVATE] = {
                adaptedType: "",
                addListener: _this.initDeactivateListener,
                removeListener: _this.removeDeactivateListener,
                callback: _this._deactivateCallbackDelegate
            };
            return _this;
        }
        EventDispatcher.prototype.toString = function () {
            return "";
        };
        EventDispatcher.prototype.hasEventListener = function (type, listener) {
            return _super.prototype.hasEventListener.call(this, type, listener);
        };
        EventDispatcher.prototype.willTrigger = function () {
        };
        EventDispatcher.prototype.dispatchQueuedEvents = function () {
            for (var i = 0; i < this._queuedEvents.length; i++) {
                this.dispatchEvent(this._queuedEvents[i]);
            }
            this._queuedEvents.length = 0;
        };
        EventDispatcher.prototype.getQueuedEvents = function () {
            return _super.prototype.getQueuedEvents.call(this);
        };
        EventDispatcher.prototype.dispatchEvent = function (event) {
            _super.prototype.dispatchEvent.call(this, event);
        };
        // ---------- event mapping functions Event.ACTIVATE
        EventDispatcher.prototype.initActivateListener = function (type, callback) {
            window.onfocus = callback;
        };
        EventDispatcher.prototype.removeActivateListener = function (type, callback) {
            window.onfocus = null;
        };
        EventDispatcher.prototype.activateCallback = function (event) {
            if (event === void 0) { event = null; }
            this.dispatchEvent(new this.sec.flash.events.Event(Event.ACTIVATE));
        };
        // ---------- event mapping functions Event.DEACTIVATE
        EventDispatcher.prototype.initDeactivateListener = function (type, callback) {
            window.onblur = callback;
        };
        EventDispatcher.prototype.removeDeactivateListener = function (type, callback) {
            window.onblur = null;
        };
        EventDispatcher.prototype.deactivateCallback = function (event) {
            if (event === void 0) { event = null; }
            this.dispatchEvent(new this.sec.flash.events.Event(Event.DEACTIVATE));
        };
        /*overwrite*/
        EventDispatcher.prototype.addEventListener = function (type, listener, useCapture, priority, useWeakReference) {
            if (useCapture === void 0) { useCapture = false; }
            if (priority === void 0) { priority = 0; }
            if (useWeakReference === void 0) { useWeakReference = false; }
            if (!useCapture && Event.isBroadcastEventType(type)) {
                BroadcastEventDispatchQueue.getInstance().add(type, this);
            }
            if (this.eventMappingExtern.hasOwnProperty(type)) {
                // this is a external eventMapping
                // this means that we do not need to create any mapping, and will manually dispatch the event
                // we still need to register it on superclass, so it will work if we dispatch it manually
                _super.prototype.addEventListener.call(this, type, listener);
                return;
            }
            if (this.eventMappingDummys.hasOwnProperty(type)) {
                // this is a dummy eventMapping
                // this means that this is a event-type, that is not yet supported
                // we do not need to register it on superclass
                // for now we output a warning
                //console.log("Warning - EventDispatcher:  trying to listen for unsupported event: : "+this.eventMappingDummys[type]);
                return;
            }
            if (this.eventMapping.hasOwnProperty(type)) {
                // a mapping exists for this event
                //making sure standart behaviour still works (listener is tracked in list)
                _super.prototype.addEventListener.call(this, type, listener);
                // call the provided "addListener" function
                this.eventMapping[type].addListener.call(this, this.eventMapping[type].adaptedType, this.eventMapping[type].callback);
                return;
            }
            // if we make it here, the event is not handled by this dispatcher
            // lets output a Warning for now.
            //console.log("EventDispatcher: trying to listen for unknown event: '"+type+"'")
        };
        /**
         * Remove an event listener
         * @method removeEventListener
         * @param {String} type of event to remove a listener for
         * @param {Function} listener function
         */
        EventDispatcher.prototype.removeEventListener = function (type, listener) {
            _super.prototype.removeEventListener.call(this, type, listener);
            if (this.eventMapping.hasOwnProperty(type)) {
                // a mapping exists
                this.eventMapping[type].removeListener.call(this, this.eventMapping[type].adaptedType, this.eventMapping[type].callback);
                if (!this.hasEventListener(type)) {
                    if (Event.isBroadcastEventType(type)) {
                        BroadcastEventDispatchQueue.getInstance().remove(type, this);
                    }
                }
            }
        };
        return EventDispatcher;
    }(EventDispatcherBase));
    var BroadcastEventDispatchQueue = /** @class */ (function () {
        function BroadcastEventDispatchQueue() {
            this.reset();
        }
        BroadcastEventDispatchQueue.getInstance = function () {
            if (!BroadcastEventDispatchQueue._instance)
                BroadcastEventDispatchQueue._instance = new BroadcastEventDispatchQueue();
            return BroadcastEventDispatchQueue._instance;
        };
        BroadcastEventDispatchQueue.prototype.reset = function () {
            this._queues = {};
        };
        BroadcastEventDispatchQueue.prototype.add = function (type, target) {
            release$1 || assert(Event.isBroadcastEventType(type), "Can only register broadcast events.");
            var queue = this._queues[type] || (this._queues[type] = []);
            if (queue.indexOf(target) >= 0) {
                return;
            }
            queue.push(target);
        };
        BroadcastEventDispatchQueue.prototype.remove = function (type, target) {
            release$1 || assert(Event.isBroadcastEventType(type), "Can only unregister broadcast events.");
            var queue = this._queues[type];
            release$1 || assert(queue, "There should already be a queue for this.");
            var index = queue.indexOf(target);
            release$1 || assert(index >= 0, "Target should be somewhere in this queue.");
            queue[index] = null;
            release$1 || assert(queue.indexOf(target) < 0, "Target shouldn't be in this queue anymore.");
        };
        BroadcastEventDispatchQueue.prototype.dispatchEvent = function (event) {
            release$1 || assert(event.isBroadcastEvent(), "Cannot dispatch non-broadcast events.");
            var queue = this._queues[event._type];
            if (!queue) {
                return;
            }
            /*
            if (!release && traceEventsOption.value) {
              console.log('Broadcast event of type ' + event._type + ' to ' + queue.length +
                          ' listeners');
            }*/
            var nullCount = 0;
            for (var i = 0; i < queue.length; i++) {
                var target = queue[i];
                if (target === null) {
                    nullCount++;
                }
                else {
                    target.dispatchEvent(event);
                }
            }
            // Compact the queue if there are too many holes in it.
            if (nullCount > 16 && nullCount > (queue.length >> 1)) {
                var compactedQueue = [];
                for (var i = 0; i < queue.length; i++) {
                    if (queue[i]) {
                        compactedQueue.push(queue[i]);
                    }
                }
                this._queues[event.type] = compactedQueue;
            }
        };
        BroadcastEventDispatchQueue.prototype.getQueueLength = function (type) {
            return this._queues[type] ? this._queues[type].length : 0;
        };
        return BroadcastEventDispatchQueue;
    }());

    function constructClassFromSymbol(symbol, axClass) {
        var instance = Object.create(axClass.tPrototype);
        if (instance._symbol) {
            release$1 || assert(instance._symbol === symbol);
        }
        else {
            instance._symbol = symbol;
        }
        if (instance.applySmybol)
            instance.applySymbol();
        return instance;
    }

    var OrphanManager = /** @class */ (function () {
        function OrphanManager() {
        }
        OrphanManager.addOrphan = function (orphan) {
            if (OrphanManager.orphans.indexOf(orphan) >= 0) {
                return;
            }
            OrphanManager.orphans.push(orphan);
        };
        OrphanManager.removeOrphan = function (orphan) {
            if (OrphanManager.orphans.indexOf(orphan) < 0) {
                return;
            }
            // todo: make this faster:
            var newOrphans = [];
            for (var i = 0; i < OrphanManager.orphans.length; i++) {
                if (OrphanManager.orphans[i] != orphan) {
                    newOrphans.push(OrphanManager.orphans[i]);
                }
            }
            OrphanManager.orphans = newOrphans;
        };
        OrphanManager.updateOrphans = function (events) {
            for (var i = 0; i < OrphanManager.orphans.length; i++) {
                if (OrphanManager.orphans[i].adaptee.isAsset(MovieClip)) {
                    OrphanManager.orphans[i].adaptee.update(events);
                }
                else {
                    OrphanManager.orphans[i].advanceFrame(events);
                }
                //(<any>OrphanManager.orphans[i]).dispatchQueuedEvents();
            }
        };
        OrphanManager.orphans = [];
        return OrphanManager;
    }());
    var StaticEvents = /** @class */ (function () {
        function StaticEvents() {
        }
        StaticEvents.events = {};
        return StaticEvents;
    }());
    var DisplayObject$1 = /** @class */ (function (_super) {
        __extends(DisplayObject$$1, _super);
        /**
         *
         *
         * these events are handled from DisplayObjectContainer.
         * nothing really to much needs to be cnnected to awayjs.
         *
         * [broadcast event] Dispatched when the playhead is entering a new
         * frame.
         * @eventType	flash.events.Event.ENTER_FRAME
         [Event(name="enterFrame", type="flash.events.Event")]

         * [broadcast event] Dispatched after the constructors of frame displayobjects have run but before frame scripts have run.
         * @eventType	flash.events.Event.FRAME_CONSTRUCTED
         [Event(name="frameConstructed", type="flash.events.Event")]

         * [broadcast event] Dispatched when the playhead is exiting the current frame.
         * @eventType	flash.events.Event.EXIT_FRAME
         [Event(name="exitFrame", type="flash.events.Event")]

         * [broadcast event] Dispatched when the display list is about to be updated and rendered.
         * @eventType	flash.events.Event.RENDER
         [Event(name="render", type="flash.events.Event")]
         
         * Dispatched when a displayobject is about to be removed from the display list,
         * either directly or through the removal of a sub tree in which the displayobject is contained.
         * @eventType	flash.events.Event.REMOVED_FROM_STAGE
         [Event(name="removedFromStage", type="flash.events.Event")]

         * Dispatched when a displayobject is about to be removed from the display list.
         * @eventType	flash.events.Event.REMOVED
         [Event(name="removed", type="flash.events.Event")]

         * Dispatched when a displayobject is added to the on stage display list,
         * either directly or through the addition of a sub tree in which the displayobject is contained.
         * @eventType	flash.events.Event.ADDED_TO_STAGE
         [Event(name="addedToStage", type="flash.events.Event")]

         * Dispatched when a displayobject is added to the display list.
         * @eventType	flash.events.Event.ADDED
         [Event(name="added", type="flash.events.Event")]

         * The DisplayObject class is the base class for all anys that can be placed on
         * the display list. The display list manages all anys displayed in the Flash runtimes.
         * Use the DisplayObjectContainer class to arrange the displayobjects in the display list.
         * DisplayObjectContainer anys can have child displayobjects, while other displayobjects, such as
         * Shape and TextField anys, are "leaf" nodes that have only parents and siblings, no children.
         *
         *   <p class="- topic/p ">The DisplayObject class supports basic ality like the <i class="+ topic/ph hi-d/i ">x</i> and <i class="+ topic/ph hi-d/i ">y</i> position of
         * an any, as well as more advanced properties of the any such as its transformation matrix.
         * </p><p class="- topic/p ">DisplayObject is an abstract base class; therefore, you cannot call DisplayObject directly. Invoking
         * <codeph class="+ topic/ph pr-d/codeph ">new DisplayObject()</codeph> console.logs an <codeph class="+ topic/ph pr-d/codeph ">ArgumentError</codeph> exception. </p><p class="- topic/p ">All displayobjects inherit from the DisplayObject class.</p><p class="- topic/p ">The DisplayObject class itself does not include any APIs for rendering content onscreen.
         * For that reason, if you want create a custom subclass of the DisplayObject class, you will want
         * to extend one of its subclasses that do have APIs for rendering content onscreen,
         * such as the Shape, Sprite, Bitmap, SimpleButton, TextField, or MovieClip class.</p><p class="- topic/p ">The DisplayObject class contains several broadcast events. Normally, the target
         * of any particular event is a specific DisplayObject instance. For example,
         * the target of an <codeph class="+ topic/ph pr-d/codeph ">added</codeph> event is the specific DisplayObject instance
         * that was added to the display list. Having a single target restricts the placement of
         * event listeners to that target and in some cases the target's ancestors on the display list.
         * With broadcast events, however, the target is not a specific DisplayObject instance,
         * but rather all DisplayObject instances, including those that are not on the display list.
         * This means that you can add a listener to any DisplayObject instance to listen for broadcast events.
         * In addition to the broadcast events listed in the DisplayObject class's Events table,
         * the DisplayObject class also inherits two broadcast events from the EventDispatcher
         * class: <codeph class="+ topic/ph pr-d/codeph ">activate</codeph> and <codeph class="+ topic/ph pr-d/codeph ">deactivate</codeph>.</p><p class="- topic/p ">Some properties previously used in the ActionScript 1.0 and 2.0 MovieClip, TextField, and Button
         * classes (such as <codeph class="+ topic/ph pr-d/codeph ">_alpha</codeph>, <codeph class="+ topic/ph pr-d/codeph ">_height</codeph>, <codeph class="+ topic/ph pr-d/codeph ">_name</codeph>, <codeph class="+ topic/ph pr-d/codeph ">_width</codeph>,
         * <codeph class="+ topic/ph pr-d/codeph ">_x</codeph>, <codeph class="+ topic/ph pr-d/codeph ">_y</codeph>, and others) have equivalents in the ActionScript 3.0
         * DisplayObject class that are renamed so that they no longer begin with the underscore (_) character.</p><p class="- topic/p ">For more information, see the "Display Programming" chapter of the <i class="+ topic/ph hi-d/i ">ActionScript 3.0 Developer's Guide</i>.</p>

         */
        function DisplayObject$$1() {
            var _this = _super.call(this) || this;
            _this._blockedByScript = false;
            _this._ctBlockedByScript = false;
            _this._visibilityByScript = false;
            // adaptee might already be set !
            _this.adaptee = _this.adaptee || _this.createAdaptee();
            // needed, because `this.stage` must already be available when constructor of extending classes are executed
            _this._stage = _this.activeStage;
            // no eventMapping needed for the DisplayObject-events.
            // they can all be dispatched without listening on other objects
            // still need to create a dummy mapping with empty message, in order to have them registered
            // (we want unknown events to fail when they try to register in addEventListener
            _this.eventMappingExtern[Event.ENTER_FRAME] = "";
            _this.eventMappingExtern[Event.FRAME_CONSTRUCTED] = "";
            _this.eventMappingExtern[Event.EXIT_FRAME] = "";
            _this.eventMappingExtern[Event.RENDER] = "";
            //this.eventMappingExtern[Event.REMOVED_FROM_STAGE]="";
            _this.eventMappingExtern[Event.REMOVED] = "";
            _this.eventMappingExtern[Event.ADDED_TO_STAGE] = "";
            _this.eventMappingExtern[Event.ADDED] = "";
            _this._transform = new _this.sec.flash.geom.Transform(_this.adaptee.transform);
            return _this;
        }
        DisplayObject$$1.prototype.toString = function () {
            return this.adaptee.name;
        };
        DisplayObject$$1.prototype.applySymbol = function () {
        };
        DisplayObject$$1.prototype.dispatchStaticEvent = function (eventName) {
            if (!StaticEvents.events[eventName])
                StaticEvents.events[eventName] = new this.sec.flash.events.Event(eventName);
            this.dispatchEvent(StaticEvents.events[eventName]);
        };
        DisplayObject$$1.prototype.dispatchStaticBroadCastEvent = function (eventName) {
            if (!StaticEvents.events[eventName])
                StaticEvents.events[eventName] = new this.sec.flash.events.Event(eventName);
            BroadcastEventDispatchQueue.getInstance().dispatchEvent(StaticEvents.events[eventName]);
        };
        DisplayObject$$1.prototype.createAdaptee = function () {
            return new DisplayObject();
        };
        Object.defineProperty(DisplayObject$$1.prototype, "activeStage", {
            get: function () {
                if (this.sec.flash.display.DisplayObject.axClass._activeStage == null) {
                    console.log("ERROR: a Stage must have been created before any Sprite can be created!");
                }
                return this.sec.flash.display.DisplayObject.axClass._activeStage;
            },
            enumerable: true,
            configurable: true
        });
        //		use to dispatch events on a object and all its childs
        //		overwritten in DisplayObjectContainer to work recursivly on children
        // 		used for:
        // 		- ENTER_FRAME
        // 		- FRAME_CONSTRUCTED
        // 		- EXIT_FRAME
        //		- RENDER
        //		- REMOVED_FROM_STAGE
        //		- ADDED_TO_STAGE
        DisplayObject$$1.prototype.dispatchEventRecursive = function (event) { this.dispatchEvent(event); };
        Object.defineProperty(DisplayObject$$1.prototype, "adaptee", {
            // --------------------- stuff needed because of implementing the existing IDisplayObjectAdapter
            get: function () {
                return this._adaptee;
            },
            set: function (value) {
                if (this._adaptee == value)
                    return;
                if (this._adaptee)
                    this._adaptee.adapter = null;
                this._adaptee = value;
                if (this._adaptee) {
                    if (!this._adaptee.partition)
                        this._adaptee.partition = new SceneGraphPartition(this._adaptee);
                    this._adaptee.adapter = this;
                }
            },
            enumerable: true,
            configurable: true
        });
        DisplayObject$$1.prototype.initAdapter = function () { };
        DisplayObject$$1.prototype.isBlockedByScript = function () {
            //console.log("isBlockedByScript not implemented yet in flash/DisplayObject");
            return this._blockedByScript;
        };
        DisplayObject$$1.prototype.isVisibilityByScript = function () {
            //console.log("isVisibilityByScript not implemented yet in flash/DisplayObject");
            return this._visibilityByScript;
        };
        DisplayObject$$1.prototype.isColorTransformByScript = function () {
            //console.log("isVisibilityByScript not implemented yet in flash/DisplayObject");
            return this._ctBlockedByScript;
        };
        DisplayObject$$1.prototype.freeFromScript = function () {
            //console.log("freeFromScript not implemented yet in flash/DisplayObject");
            this._blockedByScript = false;
            this._ctBlockedByScript = false;
            this._visibilityByScript = false;
        };
        DisplayObject$$1.prototype.clone = function () {
            if (!this._symbol) {
                throw ("_symbol not defined when cloning movieclip");
            }
            //var clone: MovieClip = MovieClip.getNewMovieClip(AwayMovieClip.getNewMovieClip((<AwayMovieClip>this.adaptee).timeline));
            var clone = constructClassFromSymbol(this._symbol, this._symbol.symbolClass);
            clone.axInitializer();
            this.adaptee.copyTo(clone.adaptee);
            return clone;
        };
        DisplayObject$$1.prototype.dispose = function () {
            throw new AbstractMethodError();
        };
        /**
         * @inheritDoc
         */
        DisplayObject$$1.prototype.disposeValues = function () {
            this.adaptee = null;
        };
        Object.defineProperty(DisplayObject$$1.prototype, "accessibilityProperties", {
            //---------------------------original as3 properties / methods:
            /**
             * The current accessibility options for this displayobject. If you modify the accessibilityProperties
             * property or any of the fields within accessibilityProperties, you must call
             * the Accessibility.updateProperties() method to make your changes take effect.
             *
             *   Note: For an any created in the Flash authoring environment, the value of accessibilityProperties
             * is prepopulated with any information you entered in the Accessibility panel for
             * that any.
             */
            get: function () {
                console.log("accessibilityProperties not implemented yet in flash/DisplayObject");
                //todo: flash.accessibility.AccessibilityProperties
                return null;
            },
            set: function (value) {
                console.log("accessibilityProperties not implemented yet in flash/DisplayObject");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "alpha", {
            /**
             * Indicates the alpha transparency value of the any specified.
             * Valid values are 0 (fully transparent) to 1 (fully opaque).
             * The default value is 1. displayobjects with alpha
             * set to 0 are active, even though they are invisible.
             */
            get: function () {
                return this.adaptee.alpha;
            },
            set: function (value) {
                this._ctBlockedByScript = true;
                this.adaptee.alpha = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "blendMode", {
            /**
             * A value from the BlendMode class that specifies which blend mode to use.
             * A bitmap can be drawn internally in two ways. If you have a blend mode enabled or an
             * external clipping mask, the bitmap is drawn by adding a bitmap-filled square shape to the vector
             * render. If you attempt to set this property to an invalid value, Flash runtimes set the value
             * to BlendMode.NORMAL.
             *
             *   The blendMode property affects each pixel of the displayobject.
             * Each pixel is composed of three constituent
             * colors (red, green, and blue), and each constituent color has a value between 0x00 and 0xFF.
             * Flash Player or Adobe AIR compares each constituent color of one pixel in the movie clip with
             * the corresponding color of the pixel in the background. For example, if blendMode
             * is set to BlendMode.LIGHTEN, Flash Player or Adobe AIR compares the red value of the displayobject with
             * the red value of the background, and uses the lighter of the two as the
             * value for the red component of the displayed color.The following table describes the blendMode settings.
             * The BlendMode class defines string values you can use.
             * The illustrations in the table show blendMode values applied to a circular
             * displayobject (2) superimposed on another displayobject (1).BlendMode ConstantIllustrationDescriptionBlendMode.NORMALThe displayobject appears in front of the background. Pixel values of the displayobject
             * override those of the background. Where the displayobject is transparent, the background is
             * visible.BlendMode.LAYERForces the creation of a transparency group for the displayobject. This means that the display
             * any is pre-composed in a temporary buffer before it is processed further. This is done
             * automatically if the displayobject is pre-cached using bitmap caching or if the displayobject is
             * a displayobject container with at least one child any with a blendMode
             * setting other than BlendMode.NORMAL. Not supported under GPU rendering.
             * BlendMode.MULTIPLYMultiplies the values of the displayobject constituent colors by the colors of the background color,
             * and then normalizes by dividing by 0xFF,
             * resulting in darker colors. This setting is commonly used for shadows and depth effects.
             *
             *   For example, if a constituent color (such as red) of one pixel in the displayobject and the
             * corresponding color of the pixel in the background both have the value 0x88, the multiplied
             * result is 0x4840. Dividing by 0xFF yields a value of 0x48 for that constituent color,
             * which is a darker shade than the color of the displayobject or the color of the background.BlendMode.SCREENMultiplies the complement (inverse) of the displayobject color by the complement of the background
             * color, resulting in a bleaching effect. This setting is commonly used for highlights or to remove black
             * areas of the displayobject.BlendMode.LIGHTENSelects the lighter of the constituent colors of the displayobject and the color of the background (the
             * colors with the larger values). This setting is commonly used for superimposing type.
             *
             *   For example, if the displayobject has a pixel with an RGB value of 0xFFCC33, and the background
             * pixel has an RGB value of 0xDDF800, the resulting RGB value for the displayed pixel is
             * 0xFFF833 (because 0xFF > 0xDD, 0xCC < 0xF8, and 0x33 > 0x00 = 33). Not supported under GPU rendering.BlendMode.DARKENSelects the darker of the constituent colors of the displayobject and the colors of the
             * background (the colors with the smaller values). This setting is commonly used for superimposing type.
             *
             *   For example, if the displayobject has a pixel with an RGB value of 0xFFCC33, and the background
             * pixel has an RGB value of 0xDDF800, the resulting RGB value for the displayed pixel is
             * 0xDDCC00 (because 0xFF > 0xDD, 0xCC < 0xF8, and 0x33 > 0x00 = 33). Not supported under GPU rendering.BlendMode.DIFFERENCECompares the constituent colors of the displayobject with the colors of its background, and subtracts
             * the darker of the values of the two constituent colors from the lighter value. This setting is commonly
             * used for more vibrant colors.
             *
             *   For example, if the displayobject has a pixel with an RGB value of 0xFFCC33, and the background
             * pixel has an RGB value of 0xDDF800, the resulting RGB value for the displayed pixel is
             * 0x222C33 (because 0xFF - 0xDD = 0x22, 0xF8 - 0xCC = 0x2C, and 0x33 - 0x00 = 0x33).BlendMode.ADDAdds the values of the constituent colors of the displayobject to the colors of its background, applying a
             * ceiling of 0xFF. This setting is commonly used for animating a lightening dissolve between
             * two anys.
             *
             *   For example, if the displayobject has a pixel with an RGB value of 0xAAA633, and the background
             * pixel has an RGB value of 0xDD2200, the resulting RGB value for the displayed pixel is
             * 0xFFC833 (because 0xAA + 0xDD > 0xFF, 0xA6 + 0x22 = 0xC8, and 0x33 + 0x00 = 0x33).BlendMode.SUBTRACTSubtracts the values of the constituent colors in the displayobject from the values of the
             * background color, applying a floor of 0. This setting is commonly used for animating a
             * darkening dissolve between two anys.
             *
             *   For example, if the displayobject has a pixel with an RGB value of 0xAA2233, and the background
             * pixel has an RGB value of 0xDDA600, the resulting RGB value for the displayed pixel is
             * 0x338400 (because 0xDD - 0xAA = 0x33, 0xA6 - 0x22 = 0x84, and 0x00 - 0x33 < 0x00).BlendMode.INVERTInverts the background.BlendMode.ALPHAApplies the alpha value of each pixel of the displayobject to the background.
             * This requires the blendMode setting of the parent displayobject to be set to
             * BlendMode.LAYER.
             * For example, in the illustration, the parent displayobject, which is a white background,
             * has blendMode = BlendMode.LAYER. Not supported under GPU rendering.BlendMode.ERASEErases the background based on the alpha value of the displayobject. This requires the
             * blendMode of the parent displayobject to be set to
             * BlendMode.LAYER. For example, in the
             * illustration, the parent displayobject, which is a white background, has
             * blendMode = BlendMode.LAYER. Not supported under GPU rendering.BlendMode.OVERLAYAdjusts the color of each pixel based on the darkness of the background.
             * If the background is lighter than 50% gray, the displayobject and background colors are
             * screened, which results in a lighter color. If the background is darker than 50% gray,
             * the colors are multiplied, which results in a darker color.
             * This setting is commonly used for shading effects. Not supported under GPU rendering.BlendMode.HARDLIGHTAdjusts the color of each pixel based on the darkness of the displayobject.
             * If the displayobject is lighter than 50% gray, the displayobject and background colors are
             * screened, which results in a lighter color. If the displayobject is darker than 50% gray,
             * the colors are multiplied, which results in a darker color.
             * This setting is commonly used for shading effects. Not supported under GPU rendering.BlendMode.SHADERN/AAdjusts the color using a custom shader routine. The shader that is used is specified
             * as the Shader instance assigned to the blendShader property. Setting the
             * blendShader property of a displayobject to a Shader instance
             * automatically sets the displayobject's blendMode property to
             * BlendMode.SHADER. If the blendMode property is set to
             * BlendMode.SHADER without first setting the blendShader property,
             * the blendMode property is set to BlendMode.NORMAL. Not supported under GPU rendering.
             */
            get: function () {
                console.log("blendMode not implemented yet in flash/DisplayObject");
                // todo: translate awayblendmode to as3blendmode
                return "";
            },
            set: function (value) {
                console.log("blendMode not implemented yet in flash/DisplayObject");
                //this._adaptee.blendMode=value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "blendShader", {
            /**
             * Sets a shader that is used for blending the foreground and background. When the
             * blendMode property is set to BlendMode.SHADER, the specified
             * Shader is used to create the blend mode output for the displayobject.
             *
             *   Setting the blendShader property of a displayobject to a Shader instance
             * automatically sets the displayobject's blendMode property to
             * BlendMode.SHADER. If the blendShader property is set (which sets the
             * blendMode property to BlendMode.SHADER), then the value of the
             * blendMode property is changed, the blend mode can be reset to use the blend
             * shader simply by setting the blendMode property to BlendMode.SHADER.
             * The blendShader property does not need to be set again except to change the
             * shader that's used for the blend mode.The Shader assigned to the blendShader property must specify at least two
             * image4 inputs. The inputs do not need to be specified in code using the
             * associated ShaderInput anys' input properties. The background displayobject
             * is automatically
             * used as the first input (the input with index 0). The foreground displayobject
             * is used as the second input (the input with index 1). A shader used as a blend
             * shader can specify more than two inputs. In that case, any additional input must be specified
             * by setting its ShaderInput instance's input property.When you assign a Shader instance to this property the shader is copied internally. The
             * blend operation uses that internal copy, not a reference to the original shader. Any changes
             * made to the shader, such as changing a parameter value, input, or bytecode, are not applied
             * to the copied shader that's used for the blend mode.
             * @langversion	3.0
             * @playerversion	Flash 10
             * @playerversion	AIR 1.5
             * @console.logs	ArgumentError When the shader output type is not compatible with this operation
             *   (the shader must specify a pixel4
             *   output).
             * @console.logs	ArgumentError When the shader specifies fewer than two image inputs or the first
             *   two inputs are not image4 inputs.
             * @console.logs	ArgumentError When the shader specifies an image input that isn't provided.
             * @console.logs	ArgumentError When a Byte[] or Vector.<number> instance is used as
             *   an input and the width
             *   and height properties aren't specified for the
             *   ShaderInput, or the specified values don't match the amount of
             *   data in the input any. See the ShaderInput.input
             *   property for more information.
             */
            set: function (value) {
                console.log("blendShader not implemented yet in flash/DisplayObject");
                //todo (if ever)
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "cacheAsBitmap", {
            /**
             * If set to true, Flash runtimes cache an internal bitmap representation of the
             * displayobject. This caching can increase performance for displayobjects that contain complex
             * vector content.
             *
             *   All vector data for a displayobject that has a cached bitmap is drawn to the bitmap
             * instead of the main display. If cacheAsBitmapMatrix is null or unsupported,
             * the bitmap is then copied to the main display as unstretched, unrotated pixels snapped to
             * the nearest pixel boundaries. Pixels are mapped 1 to 1 with
             * the parent any. If the bounds of the bitmap change, the bitmap is recreated instead
             * of being stretched.If cacheAsBitmapMatrix is non-null and supported, the any is drawn to the off-screen bitmap
             * using that matrix and the stretched and/or rotated results of that rendering are used
             * to draw the any to the main display.No internal bitmap is created unless the cacheAsBitmap property is set to
             * true.After you set the cacheAsBitmap property to true,
             * the rendering does not change, however the displayobject performs pixel snapping
             * automatically. The animation speed can be significantly faster depending
             * on the complexity of the vector content.
             * The cacheAsBitmap property is automatically set to true
             * whenever you apply a filter to a displayobject (when its filter [] is not empty),
             * and if a displayobject has a filter applied to it, cacheAsBitmap is reported as
             * true for that displayobject, even if you set the property to false.
             * If you clear all filters for a displayobject, the cacheAsBitmap setting changes to
             * what it was last set to.A displayobject does not use a bitmap even if the cacheAsBitmap
             * property is set to true and instead renders from vector data in the following cases:The bitmap is too large.
             * In  AIR 1.5 and Flash Player 10, the maximum size for a bitmap image is 8,191 pixels in width or height,
             * and the total number of pixels cannot exceed 16,777,215 pixels. (So, if a bitmap image is 8,191 pixels
             * wide, it can only be 2,048 pixels high.) In Flash Player 9 and earlier, the limitation is
             * is 2880 pixels in height and 2,880 pixels in width.The bitmap fails to allocate (out of memory error). The cacheAsBitmap property is best used with movie clips that have
             * mostly static content and that do not scale and rotate frequently. With such movie
             * clips, cacheAsBitmap can lead to performance increases when the
             * movie clip is translated (when its x and y position is changed).
             */
            get: function () {
                console.log("cacheAsBitmap not implemented yet in flash/DisplayObject");
                return false;
            },
            set: function (value) {
                console.log("cacheAsBitmap not implemented yet in flash/DisplayObject");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "filters", {
            /**
             * An indexed [] that contains each filter any currently associated with the displayobject.
             * The flash.filters package contains several classes that define specific filters you can
             * use.
             *
             *   Filters can be applied in Flash Professional at design time, or at run time by using
             * ActionScript code. To apply a filter by using ActionScript, you must make a temporary copy of the
             * entire filters [], modify the temporary [], then assign the value
             * of the temporary [] back to the filters []. You cannot directly
             * add a new filter any to the filters [].To add a filter by using ActionScript, perform the following steps (assume that the
             * target displayobject is named myDisplayObject):Create a new filter any by using the constructor method of your chosen filter
             * class.Assign the value of the myDisplayObject.filters [] to a temporary [], such
             * as one named myFilters.Add the new filter any to the myFilters temporary [].Assign the value of the temporary [] to the myDisplayObject.filters [].If the filters [] is undefined, you do not need to use a temporary [].
             * Instead, you can directly assign an [] literal that contains one or more filter anys that
             * you create. The first example in the Examples section adds a drop shadow filter by using
             * code that handles both defined and undefined filters []s.To modify an existing filter any,
             * you must use the technique of modifying a copy of the filters []:Assign the value of the filters [] to a temporary [], such as one
             * named myFilters.Modify the property by using the temporary [], myFilters. For example,
             * to set the quality property of the first filter in the [], you could use the
             * following code: myFilters[0].quality = 1;Assign the value of the temporary [] to the filters [].At load time, if a displayobject has an associated filter, it is marked to cache itself as a
             * transparent bitmap. From this point forward, as long as the displayobject has a valid filter list,
             * the player caches the displayobject as a bitmap. This source bitmap is used as a source
             * image for the filter effects. Each displayobject usually has two bitmaps: one with the
             * original unfiltered source displayobject and another for the final image after filtering.
             * The final image is used when rendering. As long as the displayobject does not
             * change, the final image does not need updating.The flash.filters package includes classes for filters. For example, to create a DropShadow
             * filter, you would write:
             * <codeblock>
             *
             *   import flash.filters.DropShadowFilter
             * var myFilter:DropShadowFilter = new DropShadowFilter (distance, angle, color, alpha, blurX, blurY, quality, inner, knockout)
             *
             *   </codeblock>
             * You can use the is operator to determine the type of filter assigned to
             * each index position in the filter []. For example, the following code shows
             * how to determine the position of the first filter in the filters [] that
             * is a DropShadowFilter:
             *
             *   <codeblock>
             *
             *   import flash.text.TextField;
             * import flash.filters.~~;
             * var tf:TextField = new TextField();
             * var filter1:DropShadowFilter = new DropShadowFilter();
             * var filter2:GradientGlowFilter = new GradientGlowFilter();
             * tf.filters = [filter1, filter2];
             *
             *   tf.text = "DropShadow index: " + filterPosition(tf, DropShadowFilter).tostring(); // 0
             * addChild(tf)
             *
             *    filterPosition(DisplayObject:DisplayObject, filterClass:Class):int {
                 * for (var i:uint = 0; i < DisplayObject.filters.length; i++) {
                 * if (DisplayObject.filters[i] is filterClass) {
                 * return i;
                 * }
                 * }
                 * return -1;
                 * }
             *
             *   </codeblock>
             * Note: Since you cannot directly add a new filter any to the
             * DisplayObject.filters [], the following code has no
             * effect on the target displayobject, named myDisplayObject:
             * <codeblock>
             *
             *   myDisplayObject.filters.push(myDropShadow);
             *
             *   </codeblock>
             * @langversion	3.0
             * @playerversion	Flash 9
             * @console.logs	ArgumentError When filters includes a ShaderFilter and the shader
             *   output type is not compatible with this operation
             *   (the shader must specify a pixel4
             *   output).
             * @console.logs	ArgumentError When filters includes a ShaderFilter and the shader
             *   doesn't specify any image input or the first
             *   input is not an image4 input.
             * @console.logs	ArgumentError When filters includes a ShaderFilter and the shader
             *   specifies an image input that isn't provided.
             * @console.logs	ArgumentError When filters includes a ShaderFilter, a
             *   Byte[] or Vector.<number> instance as
             *   a shader input, and the width
             *   and height properties aren't specified for the
             *   ShaderInput any, or the specified values don't match the amount of
             *   data in the input data. See the ShaderInput.input
             *   property for more information.
             */
            get: function () {
                //console.log("filters not implemented yet in flash/DisplayObject");
                return [];
            },
            set: function (value) {
                //console.log("filters not implemented yet in flash/DisplayObject");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "height", {
            /**
             * Indicates the height of the displayobject, in pixels. The height is calculated based on the bounds of the content of the displayobject.
             * When you set the height property, the scaleY property is adjusted accordingly, as shown in the
             * following code:
             *
             *   <codeblock>
             *
             *   var rect:Shape = new Shape();
             * rect.graphics.beginFill(0xFF0000);
             * rect.graphics.drawRect(0, 0, 100, 100);
             * trace(rect.scaleY) // 1;
             * rect.height = 200;
             * trace(rect.scaleY) // 2;
             * </codeblock>
             * Except for TextField and Video anys, a displayobject with no content (such as an empty sprite) has a height
             * of 0, even if you try to set height to a different value.
             */
            get: function () {
                if (!this._adaptee.partition) {
                    console.warn("Trying to get Display.height on orphan child!");
                    return 100;
                }
                var box = PickGroup.getInstance(this._stage.view).getBoundsPicker(this.adaptee.partition).getBoxBounds(this.adaptee);
                return (box == null) ? 0 : box.height;
            },
            set: function (value) {
                if (isNaN(value))
                    return;
                this._blockedByScript = true;
                if (!this._adaptee.partition) {
                    console.warn("Trying to set Display.height on orphan child!");
                    return;
                }
                PickGroup.getInstance(this._stage.view).getBoundsPicker(this.adaptee.partition).height = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "loaderInfo", {
            /**
             * Returns a LoaderInfo any containing information about loading the file
             * to which this displayobject belongs. The loaderInfo property is defined only
             * for the root displayobject of a SWF file or for a loaded Bitmap (not for a Bitmap that is drawn
             * with ActionScript). To find the loaderInfo any associated with the SWF file that contains
             * a displayobject named myDisplayObject, use myDisplayObject.root.loaderInfo.
             *
             *   A large SWF file can monitor its download by calling
             * this.root.loaderInfo.addEventListener(Event.COMPLETE, func).
             */
            get: function () {
                //console.log("loaderInfo not implemented yet in flash/DisplayObject");
                //this._adaptee.loaderInfo
                if (!this._loaderInfo) {
                    this._loaderInfo = new this.sec.flash.display.LoaderInfo();
                }
                return this._loaderInfo;
            },
            set: function (value) {
                //console.log("loaderInfo not implemented yet in flash/DisplayObject");
                //this._adaptee.loaderInfo
                this._loaderInfo = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "mask", {
            /**
             * The calling displayobject is masked by the specified mask any.
             * To ensure that masking works when the Stage is scaled, the mask displayobject
             * must be in an active part of the display list. The mask any itself is not drawn.
             * Set mask to null to remove the mask.
             *
             *   To be able to scale a mask any, it must be on the display list. To be able to drag a mask Sprite any
             * (by calling its startDrag() method), it must be on the display list. To call the
             * startDrag() method for a mask sprite based on a mouseDown event
             * being dispatched by the sprite, set the sprite's buttonMode property to true.When displayobjects are cached by setting the cacheAsBitmap property to
             * true an the cacheAsBitmapMatrix property to a Matrix any,
             * both the mask and the displayobject being masked must be part of the same cached
             * bitmap. Thus, if the displayobject is cached, then the mask must be a child of the displayobject.
             * If an ancestor of the displayobject on the display list is cached, then the mask must be a child of
             * that ancestor or one of its descendents. If more than one ancestor of the masked any is cached,
             * then the mask must be a descendent of the cached container closest to the masked any in the display list.Note: A single mask any cannot be used to mask more than one calling displayobject.
             * When the mask is assigned to a second displayobject, it is removed as the mask of the first
             * any, and that any's mask property becomes null.
             */
            get: function () {
                if (this.adaptee.masks == null) {
                    return null;
                }
                if (this.adaptee.masks.length == 0) {
                    return null;
                }
                return this.adaptee.masks[0].adapter;
            },
            set: function (value) {
                if (value == null) {
                    if (this.adaptee.masks != null) {
                        this.adaptee.masks[0].maskMode = false;
                    }
                    this.adaptee.masks = null;
                    return;
                }
                value.adaptee.maskMode = true;
                this.adaptee.masks = [value.adaptee];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "metaData", {
            get: function () {
                console.log("mask not implemented yet in flash/DisplayObject");
                return null;
            },
            set: function (data) {
                console.log("mask not implemented yet in flash/DisplayObject");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "mouseX", {
            /**
             * Indicates the x coordinate of the mouse or user input device position, in pixels.
             *
             *   Note: For a DisplayObject that has been rotated, the returned x coordinate will reflect the
             * non-rotated any.
             */
            get: function () {
                //console.log("mouseX not implemented yet in flash/DisplayObject");
                //todo: theres probably a faster option than this
                return this.adaptee.transform.globalToLocal(new Point(this.stage.mouseX, 0)).x;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "mouseY", {
            /**
             * Indicates the y coordinate of the mouse or user input device position, in pixels.
             *
             *   Note: For a DisplayObject that has been rotated, the returned y coordinate will reflect the
             * non-rotated any.
             */
            get: function () {
                //todo: theres probably a faster option than this
                return this.adaptee.transform.globalToLocal(new Point(0, this.stage.mouseY)).y;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "name", {
            /**
             * Indicates the instance name of the DisplayObject. The any can be identified in
             * the child list of its parent displayobject container by calling the
             * getChildByName() method of the displayobject container.
             * @langversion	3.0
             * @playerversion	Flash 9
             * @playerversion	Lite 4
             * @console.logs	IllegalOperationError If you are attempting to set this property on an any that was
             *   placed on the timeline in the Flash authoring tool.
             */
            get: function () {
                return this.adaptee.name;
            },
            set: function (value) {
                this.adaptee.name = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "opaqueBackground", {
            /**
             * Specifies whether the displayobject is opaque with a certain background color.
             * A transparent bitmap contains alpha
             * channel data and is drawn transparently. An opaque bitmap has no alpha channel (and renders faster
             * than a transparent bitmap). If the bitmap is opaque, you specify its own background color to use.
             *
             *   If set to a number value, the surface is opaque (not transparent) with the RGB background
             * color that the number specifies. If set to null (the default value), the display
             * any has a transparent background.The opaqueBackground property is intended mainly for use with the
             * cacheAsBitmap property, for rendering optimization. For displayobjects in which the
             * cacheAsBitmap property is set to true, setting opaqueBackground can
             * improve rendering performance.The opaque background region is not matched when calling the hitTestPoint()
             * method with the shapeFlag parameter set to true.The opaque background region does not respond to mouse events.
             */
            get: function () {
                console.log("opaqueBackground not implemented yet in flash/DisplayObject");
                return null;
            },
            set: function (value) {
                console.log("opaqueBackground not implemented yet in flash/DisplayObject");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "parent", {
            /**
             * Indicates the DisplayObjectContainer any that contains this displayobject. Use the parent
             * property to specify a relative path to displayobjects that are above the
             * current displayobject in the display list hierarchy.
             *
             *   You can use parent to move up multiple levels in the display list as in the following:
             * @console.logs	SecurityError The parent displayobject belongs to a security sandbox
             *   to which you do not have access. You can avoid this situation by having
             *   the parent movie call the Security.allowDomain() method.
             */
            get: function () {
                if (this.adaptee.parent == null || this.adaptee.parent.adapter == null || this.adaptee.parent.adapter == this.adaptee.parent) {
                    return null;
                }
                return this.adaptee.parent.adapter;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "root", {
            /**
             * For a displayobject in a loaded SWF file, the root property is the
             * top-most displayobject in the portion of the display list's tree structure represented by that SWF file.
             * For a Bitmap any representing a loaded image file, the root property is the Bitmap any
             * itself. For the instance of the main class of the first SWF file loaded, the root property is the
             * displayobject itself. The root property of the Stage any is the Stage any itself. The root
             * property is set to null for any displayobject that has not been added to the display list, unless
             * it has been added to a displayobject container that is off the display list but that is a child of the
             * top-most displayobject in a loaded SWF file.
             *
             *   For example, if you create a new Sprite any by calling the Sprite() constructor method,
             * its root property is null until you add it to the display list (or to a display
             * any container that is off the display list but that is a child of the top-most displayobject in a SWF file).For a loaded SWF file, even though the Loader any used to load the file may not be on the display list,
             * the top-most displayobject in the SWF file has its root property set to itself.  The Loader any
             * does not have its root property set until it is added as a child of a displayobject for which the
             * root property is set.
             */
            get: function () {
                //console.log("root not implemented yet in flash/DisplayObject");
                return this.stage.getChildAt(0);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "rotation", {
            /**
             * Indicates the rotation of the DisplayObject instance, in degrees, from its original orientation. Values from 0 to 180 represent
             * clockwise rotation; values from 0 to -180 represent counterclockwise rotation. Values outside this range are added to or
             * subtracted from 360 to obtain a value within the range. For example, the statement my_video.rotation = 450 is the
             * same as  my_video.rotation = 90.
             */
            get: function () {
                return this.adaptee.rotationZ;
            },
            set: function (value) {
                this.adaptee.rotationZ = isNaN(value) ? 0 : isFinite(value) ? value : -8;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "rotationX", {
            /**
             * Indicates the x-axis rotation of the DisplayObject instance, in degrees, from its original orientation relative to the 3D parent container. Values from 0 to 180 represent
             * clockwise rotation; values from 0 to -180 represent counterclockwise rotation. Values outside this range are added to or
             * subtracted from 360 to obtain a value within the range.
             */
            get: function () {
                return this.adaptee.rotationX;
            },
            set: function (value) {
                this.adaptee.rotationX = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "rotationY", {
            /**
             * Indicates the y-axis rotation of the DisplayObject instance, in degrees, from its original orientation relative to the 3D parent container. Values from 0 to 180 represent
             * clockwise rotation; values from 0 to -180 represent counterclockwise rotation. Values outside this range are added to or
             * subtracted from 360 to obtain a value within the range.
             * @langversion	3.0
             * @playerversion	Flash 10
             * @playerversion	AIR 1.5
             * @playerversion	Lite 4
             */
            get: function () {
                return this.adaptee.rotationY;
            },
            set: function (value) {
                this.adaptee.rotationY = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "rotationZ", {
            /**
             * Indicates the z-axis rotation of the DisplayObject instance, in degrees, from its original orientation relative to the 3D parent container. Values from 0 to 180 represent
             * clockwise rotation; values from 0 to -180 represent counterclockwise rotation. Values outside this range are added to or
             * subtracted from 360 to obtain a value within the range.
             */
            get: function () {
                return this.adaptee.rotationZ;
            },
            set: function (value) {
                this.adaptee.rotationZ = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "scale9Grid", {
            /**
             * The current scaling grid that is in effect. If set to null,
             * the entire displayobject is scaled normally when any scale transformation is
             * applied.
             *
             *   When you define the scale9Grid property, the displayobject is divided into a
             * grid with nine regions based on the scale9Grid rectangle, which defines the
             * center region of the grid. The eight other regions of the grid are the following areas: The upper-left corner outside of the rectangleThe area above the rectangle The upper-right corner outside of the rectangleThe area to the left of the rectangleThe area to the right of the rectangleThe lower-left corner outside of the rectangleThe area below the rectangleThe lower-right corner outside of the rectangleYou can think of the eight regions outside of the center (defined by the rectangle)
             * as being like a picture frame that has special rules applied to it when scaled.When the scale9Grid property is set and a displayobject is scaled, all text and
             * gradients are scaled normally; however, for other types of anys the following rules apply:Content in the center region is scaled normally. Content in the corners is not scaled. Content in the top and bottom regions is scaled horizontally only. Content in the
             * left and right regions is scaled vertically only.All fills (including bitmaps, video, and gradients) are stretched to fit their shapes.If a displayobject is rotated, all subsequent scaling is normal (and the
             * scale9Grid property is ignored).For example, consider the following displayobject and a rectangle that is applied as the display
             * any's scale9Grid:The displayobject.The red rectangle shows the scale9Grid.When the displayobject is scaled or stretched, the anys within the rectangle scale
             * normally, but the anys outside of the rectangle scale according to the
             * scale9Grid rules:Scaled to 75%:Scaled to 50%:Scaled to 25%:Stretched horizontally 150%: A common use for setting scale9Grid is to set up a displayobject to be used
             * as a component, in which edge regions retain the same width when the component is scaled.
             * @maelexample	The following creates a movie clip that contains a 20-pixel line (which forms a border)
             *   and a gradient fill. The movie clip scales based on the mouse position, and because of the
             *   <code>scale9Grid</code> set for the movie clip, the thickness of the 20-pixel line does not
             *   vary when the clip scales (although the gradient in the movie clip <em>does</em> scale):
             *
             *     <listing version="2.0">
             *   import Rectangle;
             *   import flash.geom.Matrix;
             *
             *     this.createEmptyMovieClip("my_mc", this.getNextHighestDepth());
             *
             *     var grid:Rectangle = new Rectangle(20, 20, 260, 260);
             *   my_mc.scale9Grid = grid ;
             *
             *     my_mc._x = 50;
             *   my_mc._y = 50;
             *
             *      onMouseMove()
             *   {
                 *   my_mc._width  = _xmouse;
                 *   my_mc._height = _ymouse;
                 *   }
             *
             *     my_mc.lineStyle(20, 0xff3333, 100);
             *   var gradient_matrix:Matrix = new Matrix();
             *   gradient_matrix.createGradientBox(15, 15, Math.PI, 10, 10);
             *   my_mc.beginGradientFill("radial", [0xffff00, 0x0000ff],
             *   [100, 100], [0, 0xFF], gradient_matrix,
             *   "reflect", "RGB", 0.9);
             *   my_mc.moveTo(0, 0);
             *   my_mc.lineTo(0, 300);
             *   my_mc.lineTo(300, 300);
             *   my_mc.lineTo(300, 0);
             *   my_mc.lineTo(0, 0);
             *   my_mc.endFill();
             *   </listing>
             * @console.logs	ArgumentError If you pass an invalid argument to the method.
             */
            get: function () {
                return new this.sec.flash.geom.Rectangle(this.adaptee.scale9Grid);
            },
            set: function (innerRectangle) {
                this.adaptee.scale9Grid = innerRectangle.adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "scaleX", {
            /**
             * Indicates the horizontal scale (percentage) of the any as applied from the registration point. The default
             * registration point is (0,0). 1.0 equals 100% scale.
             *
             *   Scaling the local coordinate system changes the x and y property values, which are defined in
             * whole pixels.
             */
            get: function () {
                return this.adaptee.scaleX;
            },
            set: function (value) {
                this._blockedByScript = true;
                this.adaptee.scaleX = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "scaleY", {
            /**
             * Indicates the vertical scale (percentage) of an any as applied from the registration point of the any. The
             * default registration point is (0,0). 1.0 is 100% scale.
             *
             *   Scaling the local coordinate system changes the x and y property values, which are defined in
             * whole pixels.
             */
            get: function () {
                return this.adaptee.scaleY;
            },
            set: function (value) {
                this._blockedByScript = true;
                this.adaptee.scaleY = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "scaleZ", {
            /**
             * Indicates the depth scale (percentage) of an any as applied from the registration point of the any. The
             * default registration point is (0,0). 1.0 is 100% scale.
             *
             *   Scaling the local coordinate system changes the x, y and z property values, which are defined in
             * whole pixels.
             */
            get: function () {
                return this.adaptee.scaleZ;
            },
            set: function (value) {
                this._blockedByScript = true;
                this.adaptee.scaleZ = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "scrollRect", {
            /**
             * The scroll rectangle bounds of the displayobject. The displayobject is cropped to the size
             * defined by the rectangle, and it scrolls within the rectangle when you change the
             * x and y properties of the scrollRect any.
             *
             *   The properties of the scrollRect Rectangle any use the displayobject's coordinate space
             * and are scaled just like the overall displayobject. The corner bounds of the cropped window on the scrolling
             * displayobject are the origin of the displayobject (0,0) and the point defined by the
             * width and height of the rectangle. They are not centered around the origin, but
             * use the origin to define the upper-left corner of the area. A scrolled displayobject always
             * scrolls in whole pixel increments. You can scroll an any left and right by setting the x property of the
             * scrollRect Rectangle any. You can scroll an any up and down by setting
             * the y property of the scrollRect Rectangle any. If the displayobject
             * is rotated 90° and you scroll it left and right, the displayobject actually scrolls up and down.
             */
            get: function () {
                return new this.sec.flash.geom.Rectangle(this.adaptee.scrollRect);
            },
            set: function (value) {
                this.adaptee.scrollRect = value.adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "stage", {
            /**
             * The Stage of the displayobject. A Flash runtime application has only one Stage any.
             * For example, you can create and load multiple displayobjects into the display list, and the
             * stage property of each displayobject refers to the same Stage any (even if the
             * displayobject belongs to a loaded SWF file).
             *
             *   If a displayobject is not added to the display list, its stage property is set to
             * null.
             */
            get: function () {
                return this._stage;
            },
            set: function (value) {
                this._stage = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "transform", {
            /**
             * An any with properties pertaining to a displayobject's matrix, color transform, and pixel bounds.
             * The specific properties — matrix, colorTransform, and three read-only properties
             * (concatenatedMatrix, concatenatedColorTransform,
             * and pixelBounds) — are described in the entry for the Transform class.
             *
             *   Each of the transform any's properties is itself an any. This concept is important because the only
             * way to set new values for the matrix or colorTransform anys is to create a new any and copy that
             * any into the transform.matrix or transform.colorTransform property.For example, to increase the tx value of a displayobject's matrix, you must make a
             * copy of the entire matrix any, then copy the new any into the matrix property of the transform
             * any:
             * var myMatrix:Matrix = myDisplayObject.transform.matrix;
             * myMatrix.tx += 10;
             * myDisplayObject.transform.matrix = myMatrix;
             * You cannot directly set the tx property. The following code has
             * no effect on myDisplayObject:
             * myDisplayObject.transform.matrix.tx += 10;
             * You can also copy an entire transform any and assign it to another
             * displayobject's transform property. For example, the following code
             * copies the entire transform any from myOldDisplayObj to
             * myNewDisplayObj:myNewDisplayObj.transform = myOldDisplayObj.transform;The resulting displayobject, myNewDisplayObj, now has the same values for its
             * matrix, color transform, and pixel bounds as the old displayobject, myOldDisplayObj.Note that AIR for TV devices use hardware acceleration, if it is available, for color transforms.
             */
            get: function () {
                this._ctBlockedByScript = true;
                return this._transform = new this.sec.flash.geom.Transform(this.adaptee.transform);
            },
            set: function (value) {
                console.log("DisplayObject:setter for transform not yet implemented");
                //this._adaptee.transform=value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "visible", {
            /**
             * Whether or not the displayobject is visible. displayobjects that are not visible
             * are disabled. For example, if visible=false for an Interactiveany instance,
             * it cannot be clicked.
             */
            get: function () {
                return this.adaptee.visible;
            },
            set: function (value) {
                this._visibilityByScript = true;
                this.adaptee.visible = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "width", {
            /**
             * Indicates the width of the displayobject, in pixels. The width is calculated based on the bounds of the content of the displayobject.
             * When you set the width property, the scaleX property is adjusted accordingly, as shown in the
             * following code:
             *
             *   <codeblock>
             *
             *   var rect:Shape = new Shape();
             * rect.graphics.beginFill(0xFF0000);
             * rect.graphics.drawRect(0, 0, 100, 100);
             * trace(rect.scaleX) // 1;
             * rect.width = 200;
             * trace(rect.scaleX) // 2;
             * </codeblock>
             * Except for TextField and Video anys, a displayobject with no content (such as an empty sprite) has a width
             * of 0, even if you try to set width to a different value.
             */
            get: function () {
                //todo2019
                if (!this.adaptee.partition) {
                    console.warn("Trying to get Display.width on orphan child!");
                    return 100;
                }
                var box = PickGroup.getInstance(this._stage.view).getBoundsPicker(this.adaptee.partition).getBoxBounds(this.adaptee);
                return (box == null) ? 0 : box.width;
            },
            set: function (value) {
                if (!this.adaptee.partition) {
                    console.warn("Trying to set Display.width on orphan child!");
                    return;
                }
                this._blockedByScript = true;
                //todo2019
                if (isNaN(value))
                    return;
                PickGroup.getInstance(this._stage.view).getBoundsPicker(this.adaptee.partition).width = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "x", {
            /**
             * Indicates the x coordinate of the DisplayObject instance relative to the local coordinates of
             * the parent DisplayObjectContainer. If the any is inside a DisplayObjectContainer that has
             * transformations, it is in the local coordinate system of the enclosing DisplayObjectContainer.
             * Thus, for a DisplayObjectContainer rotated 90° counterclockwise, the DisplayObjectContainer's
             * children inherit a coordinate system that is rotated 90° counterclockwise.
             * The any's coordinates refer to the registration point position.
             */
            get: function () {
                return this.adaptee.x;
            },
            set: function (value) {
                this._blockedByScript = true;
                this.adaptee.x = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "y", {
            /**
             * Indicates the y coordinate of the DisplayObject instance relative to the local coordinates of
             * the parent DisplayObjectContainer. If the any is inside a DisplayObjectContainer that has
             * transformations, it is in the local coordinate system of the enclosing DisplayObjectContainer.
             * Thus, for a DisplayObjectContainer rotated 90° counterclockwise, the DisplayObjectContainer's
             * children inherit a coordinate system that is rotated 90° counterclockwise.
             * The any's coordinates refer to the registration point position.
             */
            get: function () {
                return this.adaptee.y;
            },
            set: function (value) {
                this._blockedByScript = true;
                this.adaptee.y = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObject$$1.prototype, "z", {
            /**
             * Indicates the z coordinate position along the z-axis of the DisplayObject
             * instance relative to the 3D parent container. The z property is used for
             * 3D coordinates, not screen or pixel coordinates.
             * When you set a z property for a displayobject to something other than the default
             * value of 0, a corresponding Matrix3D any is automatically created. for adjusting a
             * displayobject's position and orientation
             * in three dimensions. When working with the z-axis,
             * the existing behavior of x and y properties changes from screen or pixel coordinates to
             * positions relative to the 3D parent container.For example, a child of the _root  at position x = 100, y = 100, z = 200
             * is not drawn at pixel location (100,100). The child is drawn wherever the 3D projection
             * calculation puts it. The calculation is: (x~~cameraFocalLength/cameraRelativeZPosition, y~~cameraFocalLength/cameraRelativeZPosition)
             */
            get: function () {
                return this.adaptee.z;
            },
            set: function (value) {
                this._blockedByScript = true;
                this.adaptee.z = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns a rectangle that defines the area of the displayobject relative to the coordinate system
         * of the targetCoordinateSpace any.
         * Consider the following code, which shows how the rectangle returned can vary depending on the
         * targetCoordinateSpace parameter that you pass to the method:
         *
         *   <codeblock>
         *
         *   var container:Sprite = new Sprite();
         * container.x = 100;
         * container.y = 100;
         * this.addChild(container);
         * var contents:Shape = new Shape();
         * contents.graphics.drawCircle(0,0,100);
         * container.addChild(contents);
         * trace(contents.getBounds(container));
         * // (x=-100, y=-100, w=200, h=200)
         * trace(contents.getBounds(this));
         * // (x=0, y=0, w=200, h=200)
         *
         *   </codeblock>
         * Note: Use the localToGlobal() and
         * globalToLocal() methods to convert the displayobject's local coordinates
         * to display coordinates, or display coordinates to local coordinates, respectively.The getBounds() method is similar to the getRect() method;
         * however, the Rectangle returned by the getBounds() method includes any strokes
         * on shapes, whereas the Rectangle returned by the getRect() method does not.
         * For an example, see the description of the getRect() method.
         * @param	targetCoordinateSpace	The displayobject that defines the coordinate system to use.
         * @return	The rectangle that defines the area of the displayobject relative to
         *   the targetCoordinateSpace any's coordinate system.
         */
        DisplayObject$$1.prototype.getBounds = function (targetCoordinateSpace) {
            //console.log("DisplayObject:getBounds not yet implemented");
            var box = PickGroup.getInstance(this._stage.view).getBoundsPicker(this.adaptee.partition).getBoxBounds(this.adaptee);
            return new this.sec.flash.geom.Rectangle(box.x - this.x, box.y - this.y, box.width, box.height);
        };
        /**
         * Returns a rectangle that defines the boundary of the displayobject,
         * based on the coordinate system defined by the targetCoordinateSpace
         * parameter, excluding any strokes on shapes. The values that the getRect() method
         * returns are the same or smaller than those returned by the getBounds() method.
         *
         *   Note: Use localToGlobal() and globalToLocal() methods
         * to convert the displayobject's local coordinates to Stage coordinates, or Stage coordinates to
         * local coordinates, respectively.
         * @param	targetCoordinateSpace	The displayobject that defines the coordinate system to use.
         * @return	The rectangle that defines the area of the displayobject relative to
         *   the targetCoordinateSpace any's coordinate system.
         */
        DisplayObject$$1.prototype.getRect = function (targetCoordinateSpace) {
            var box = PickGroup.getInstance(this._stage.view).getBoundsPicker(this.adaptee.partition).getBoxBounds(this.adaptee);
            if (!box) {
                return new this.sec.flash.geom.Rectangle();
            }
            //console.log("DisplayObject:getRect not yet implemented");FromBounds
            return new this.sec.flash.geom.Rectangle(box.x - this.x, box.y - this.y, box.width, box.height);
        };
        /**
         * Converts the point any from the Stage (global) coordinates
         * to the displayobject's (local) coordinates.
         *
         *   To use this method, first create an instance of the Point class. The
         * x and y values that you assign represent global coordinates because they
         * relate to the origin (0,0) of the main display area. Then pass the Point instance
         * as the parameter to the globalToLocal() method. The method returns a new Point any with
         * x and y values that relate to the origin of the displayobject
         * instead of the origin of the Stage.
         * @param	point	An any created with the Point class. The Point any
         *   specifies the x and y coordinates as properties.
         * @return	A Point any with coordinates relative to the displayobject.
         */
        DisplayObject$$1.prototype.globalToLocal = function (point) {
            return new this.sec.flash.geom.Point(this.adaptee.transform.globalToLocal(point.adaptee));
        };
        /**
         * Converts a two-dimensional point from the Stage (global) coordinates to a
         * three-dimensional displayobject's (local) coordinates.
         *
         *   To use this method, first create an instance of the Point class.
         * The x and y values that you assign to the Point any represent global
         * coordinates because they are relative to the origin (0,0) of the main display area.
         * Then pass the Point any to the globalToLocal3D()
         * method as the point parameter. The method returns three-dimensional
         * coordinates as a Vector3D any containing x, y, and
         * z values that are relative to the origin
         * of the three-dimensional displayobject.
         * @param	point	A two dimensional Point any representing global x and y coordinates.
         * @return	A Vector3D any with coordinates relative to the three-dimensional
         *   displayobject.
         */
        DisplayObject$$1.prototype.globalToLocal3D = function (point) {
            console.log("DisplayObject:globalToLocal3D not yet implemented");
            return new this.sec.flash.geom.Vector3D(); //todo: works with vector3D-input instead of pouibnt: this.adaptee.globalToLocal3D();
        };
        /**
         * Evaluates the bounding box of the displayobject to see if it overlaps or intersects with the
         * bounding box of the obj displayobject.
         * @param	obj	The displayobject to test against.
         * @return	true if the bounding boxes of the displayobjects intersect; false if not.
         */
        DisplayObject$$1.prototype.hitTestObject = function (obj) {
            return PickGroup.getInstance(this._stage.view).getBoundsPicker(this.adaptee.partition).hitTestObject(PickGroup.getInstance(this._stage.view).getBoundsPicker(obj.adaptee.partition));
        };
        /**
         * Evaluates the displayobject to see if it overlaps or intersects with the
         * point specified by the x and y parameters.
         * The x and y parameters specify a point in the
         * coordinate space of the Stage, not the displayobject container that contains the
         * displayobject (unless that displayobject container is the Stage).
         * @param	x	The x coordinate to test against this any.
         * @param	y	The y coordinate to test against this any.
         * @param	shapeFlag	Whether to check against the actual pixels of the any (true)
         *   or the bounding box (false).
         * @return	true if the displayobject overlaps or intersects with the specified point;
         *   false otherwise.
         */
        DisplayObject$$1.prototype.hitTestPoint = function (x, y, shapeFlag) {
            if (shapeFlag === void 0) { shapeFlag = false; }
            return PickGroup.getInstance(this._stage.view).getBoundsPicker(this.adaptee.partition).hitTestPoint(x, y, shapeFlag);
        };
        DisplayObject$$1.prototype._getObjectsUnderPointInternal = function (point, children) {
            //nothing to do here
        };
        /**
         * Converts a three-dimensional point of the three-dimensional display
         * any's (local) coordinates to a two-dimensional point in the Stage (global) coordinates.
         *
         *   For example, you can only use two-dimensional coordinates (x,y) to
         * draw with the display.Graphics methods. To draw a three-dimensional
         * any, you need to map the three-dimensional coordinates of a
         * displayobject to two-dimensional coordinates. First, create an instance of
         * the Vector3D class that holds the x-, y-, and z- coordinates of the three-dimensional
         * displayobject. Then pass the Vector3D any to the local3DToGlobal()
         * method as the point3d parameter. The method returns a two-dimensional Point
         * any that can be used
         * with the Graphics API to draw the three-dimensional any.
         * @param	point3d	A Vector3D any containing either a three-dimensional point or
         *   the coordinates of the three-dimensional displayobject.
         * @return	A two-dimensional point representing a three-dimensional point
         *   in two-dimensional space.
         */
        DisplayObject$$1.prototype.local3DToGlobal = function (point3d) {
            console.log("DisplayObject:local3DToGlobal not yet implemented");
            return new this.sec.flash.geom.Point(); //this._adaptee.getBounds();
        };
        /**
         * Converts the point any from the displayobject's (local) coordinates to the
         * Stage (global) coordinates.
         *
         *   This method allows you to convert any given x and y coordinates from
         * values that are relative to the origin (0,0) of a specific displayobject (local coordinates)
         * to values that are relative to the origin of the Stage (global coordinates).To use this method, first create an instance of the Point class. The
         * x and y values that you assign represent local coordinates because they
         * relate to the origin of the displayobject.You then pass the Point instance that you created as the parameter to
         * the localToGlobal() method. The method returns a new Point any with
         * x and y values that relate to the origin of the Stage
         * instead of the origin of the displayobject.
         * @param	point	The name or identifier of a point created with the Point class, specifying the
         *   x and y coordinates as properties.
         * @return	A Point any with coordinates relative to the Stage.
         */
        DisplayObject$$1.prototype.localToGlobal = function (point) {
            return new this.sec.flash.geom.Point(this.adaptee.transform.localToGlobal(point.adaptee));
        };
        DisplayObject$$1._activeStage = null;
        return DisplayObject$$1;
    }(EventDispatcher$1));

    /**
    /// @eventType	flash.events.MouseEvent.CLICK
    [Event(name="click", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.CONTEXT_MENU
    [Event(name="contextMenu", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.DOUBLE_CLICK
    [Event(name="doubleClick", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.MIDDLE_CLICK
    [Event(name="middleClick", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.MIDDLE_MOUSE_DOWN
    [Event(name="middleMouseDown", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.MIDDLE_MOUSE_UP
    [Event(name="middleMouseUp", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.MOUSE_DOWN
    [Event(name="mouseDown", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.MOUSE_MOVE
    [Event(name="mouseMove", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.MOUSE_OUT
    [Event(name="mouseOut", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.MOUSE_OVER
    [Event(name="mouseOver", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.MOUSE_UP
    [Event(name="mouseUp", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.MOUSE_WHEEL
    [Event(name="mouseWheel", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.RIGHT_CLICK
    [Event(name="rightClick", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.RIGHT_MOUSE_DOWN
    [Event(name="RightMouseDown", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.RIGHT_MOUSE_UP
    [Event(name="rightMouseUp", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.ROLL_OUT
    [Event(name="rollOut", type="flash.events.MouseEvent")]

    /// @eventType	flash.events.MouseEvent.ROLL_OVER
    [Event(name="rollOver", type="flash.events.MouseEvent")]

     * A MouseEvent object is dispatched into the event flow whenever mouse events occur.
     * A mouse event is usually generated by a user input device, such as a mouse or a trackball,
     * that uses a pointer.
     *
     *   <p class="- topic/p ">When nested nodes are involved, mouse events target the deepest possible nested node that
     * is visible in the display list. This node is called the <i class="+ topic/ph hi-d/i ">target node</i>. To have a
     * target node's ancestor receive notification of a mouse event, use
     * <codeph class="+ topic/ph pr-d/codeph ">EventDispatcher.addEventListener()</codeph> on the ancestor node with the
     * <codeph class="+ topic/ph pr-d/codeph ">type</codeph> parameter set to the specific mouse event you want to detect.</p>
     *
     *   EXAMPLE:
     *
     *   The following example uses the <codeph class="+ topic/ph pr-d/codeph ">MouseEventExample</codeph> and
     * <codeph class="+ topic/ph pr-d/codeph ">ChildSprite</codeph> classes to show how mouse events are dispatched using a simple image.
     * This example carries out the following tasks:
     * <ol class="- topic/ol "><li class="- topic/li ">The example declares properties for the size (100 x 100 pixels) and the background color
     * (orange) for later use in drawing the square.</li><li class="- topic/li ">The constructor creates a new ChildSprite object <codeph class="+ topic/ph pr-d/codeph ">child</codeph>. Its constructor first
     * draws an orange 100 x 100 pixel square at coordinates (0,0) by calling its <codeph class="+ topic/ph pr-d/codeph ">draw()</codeph>
     * method and then adds seven event listeners/subscribers.
     * <ul class="- topic/ul "><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">click</codeph>/<codeph class="+ topic/ph pr-d/codeph ">clickHandler()</codeph>: Dispatched when the user single-clicks with the left mouse button
     * over the square.</li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">doubleClick</codeph>/<codeph class="+ topic/ph pr-d/codeph ">doubleClickHandler()</codeph>: Dispatched when the user double-clicks the left mouse button
     * over the square.</li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">mouseDown</codeph>/<codeph class="+ topic/ph pr-d/codeph ">mouseDownHandler()</codeph>: When the ChildSprite
     * object (the orange square) is clicked, a <codeph class="+ topic/ph pr-d/codeph ">trace()</codeph> message is printed to the screen, and then
     * <codeph class="+ topic/ph pr-d/codeph ">ChildSprite.draw()</codeph> is called, which draws a dark yellow square in place
     * of the light blue one drawn in <codeph class="+ topic/ph pr-d/codeph ">mouseOverHandler()</codeph>.  The <codeph class="+ topic/ph pr-d/codeph ">mouseDownHandler()</codeph> method also adds a
     * <codeph class="+ topic/ph pr-d/codeph ">mouseMove</codeph>event listener and the <codeph class="+ topic/ph pr-d/codeph ">mouseMoveHandler()</codeph> subscriber (described below),
     * which processes the mouse moves.  Then the <codeph class="+ topic/ph pr-d/codeph ">startDrag()</codeph> method is called, which
     * allows the Sprite object to be dragged.</li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">mouseOut</codeph>/<codeph class="+ topic/ph pr-d/codeph ">mouseOutHandler()</codeph>: Dispatched whenever the pointer leaves the
     * square area.  The <codeph class="+ topic/ph pr-d/codeph ">draw()</codeph> method is called to return the square to its normal
     * size and color.</li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">mouseOver</codeph>/<codeph class="+ topic/ph pr-d/codeph ">mouseOverHandler()</codeph>: Dispatched when the mouse pointer is over the square.
     * This method redraws the square so that it is larger and its background color is dark yellow.</li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">mouseUp</codeph>/<codeph class="+ topic/ph pr-d/codeph ">mouseUpHandler()</codeph>: When the user releases the mouse button, the <codeph class="+ topic/ph pr-d/codeph ">mouseMove</codeph>
     * event listener is removed and <codeph class="+ topic/ph pr-d/codeph ">stopDrag</codeph> is called, which freezes the square in place.</li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">mouseMove</codeph>/<codeph class="+ topic/ph pr-d/codeph ">mouseMoveHandler()</codeph>: Called as part of the <codeph class="+ topic/ph pr-d/codeph ">mouseDownHandler()</codeph> function, and dispatched when the user is pressing the left mouse button and dragging the square.</li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">mouseWheel</codeph>/<codeph class="+ topic/ph pr-d/codeph ">mouseWheelHandler()</codeph>: Dispatched when the user rotates the mouse
     * wheel over the square.</li></ul></li><li class="- topic/li ">The ChildSprite instance <codeph class="+ topic/ph pr-d/codeph ">child</codeph> is then added to the display list by means of
     * <codeph class="+ topic/ph pr-d/codeph ">addChild()</codeph>, which promptly draws the orange square.</li></ol><p class="- topic/p "><b class="+ topic/ph hi-d/b ">Notes: </b></p><ul class="- topic/ul "><li class="- topic/li ">The <codeph class="+ topic/ph pr-d/codeph ">MouseEventExample</codeph> class should be the document root.</li><li class="- topic/li ">Some of the event methods listed above declare a local variable <codeph class="+ topic/ph pr-d/codeph ">sprite</codeph>, which
     * is assigned the cast of <codeph class="+ topic/ph pr-d/codeph ">event.target</codeph> to type Sprite.</li></ul><codeblock xml:space="preserve" class="+ topic/pre pr-d/codeblock ">
     
     */
    var MouseEvent$1 = /** @class */ (function (_super) {
        __extends(MouseEvent, _super);
        /**
         * Creates an Event object that contains information about mouse events.
         * Event objects are passed as parameters to event listeners.
         * @param	type	The type of the event. Possible values are: MouseEvent.CLICK,
         *   MouseEvent.DOUBLE_CLICK, MouseEvent.MOUSE_DOWN,
         *   MouseEvent.MOUSE_MOVE, MouseEvent.MOUSE_OUT,
         *   MouseEvent.MOUSE_OVER, MouseEvent.MOUSE_UP,
         *   MouseEvent.MIDDLE_CLICK, MouseEvent.MIDDLE_MOUSE_DOWN, MouseEvent.MIDDLE_MOUSE_UP,
         *   MouseEvent.RIGHT_CLICK, MouseEvent.RIGHT_MOUSE_DOWN, MouseEvent.RIGHT_MOUSE_UP,
         *   MouseEvent.MOUSE_WHEEL, MouseEvent.ROLL_OUT, and MouseEvent.ROLL_OVER.
         * @param	bubbles	Determines whether the Event object participates in the bubbling phase of the event flow.
         * @param	cancelable	Determines whether the Event object can be canceled.
         * @param	localX	The horizontal coordinate at which the event occurred relative to the containing sprite.
         * @param	localY	The vertical coordinate at which the event occurred relative to the containing sprite.
         * @param	relatedObject	The complementary InteractiveObject instance that is affected by the event. For example, when a mouseOut event occurs, relatedObject represents the display list object to which the pointing device now points.
         * @param	ctrlKey	On Windows or Linux, indicates whether the Ctrl key is activated. On Mac, indicates whether either the Ctrl key or the Command key is activated.
         * @param	altKey	Indicates whether the Alt key is activated (Windows or Linux only).
         * @param	shiftKey	Indicates whether the Shift key is activated.
         * @param	buttonDown	Indicates whether the primary mouse button is pressed.
         * @param	delta	Indicates how many lines should be scrolled for each unit the user rotates the mouse wheel. A positive delta value indicates an upward scroll; a negative value indicates a downward scroll. Typical values are 1 to 3, but faster rotation may produce larger values. This parameter is used only for the MouseEvent.mouseWheel event.
         * @param	commandKey	(AIR only) Indicates whether the Command key is activated (Mac only). This parameter is used only for the MouseEvent.click,
         *   MouseEvent.mouseDown, MouseEvent.mouseUp, MouseEvent.middleClick, MouseEvent.middleMouseDown,
         *   MouseEvent.middleMouseUp, MouseEvent.rightClick, MouseEvent.rightMouseDown, MouseEvent.rightMouseUp,
         *   and MouseEvent.doubleClick events. This parameter is for Adobe AIR only; do not set it for Flash Player content.
         * @param	controlKey	(AIR only) Indicates whether the Control or Ctrl key is activated. This parameter is used only for the MouseEvent.click,
         *   MouseEvent.mouseDown, MouseEvent.mouseUp, MouseEvent.middleClick, MouseEvent.middleMouseDown,
         *   MouseEvent.middleMouseUp, MouseEvent.rightClick, MouseEvent.rightMouseDown, MouseEvent.rightMouseUp,
         *   and MouseEvent.doubleClick events. This parameter is for Adobe AIR only; do not set it for Flash Player content.
         * @param	clickCount	(AIR only) Indicates whether or not the mouse event is part of a multi-click sequence. This parameter will be zero for all mouse events other than
         *   MouseEvent.mouseDown, MouseEvent.mouseUp, MouseEvent.middleMouseDown, MouseEvent.middleMouseUp,
         *   MouseEvent.rightMouseDown and MouseEvent.rightMouseUp. Listening for single clicks, double clicks, or any multi-click sequence
         *   is possible with the clickCount parameter. This parameter is for Adobe AIR only; do not set it for Flash Player content.
         */
        function MouseEvent(type, bubbles, cancelable, localX, localY, relatedObject, ctrlKey, altKey, shiftKey, buttonDown, delta) {
            if (bubbles === void 0) { bubbles = true; }
            if (cancelable === void 0) { cancelable = false; }
            if (localX === void 0) { localX = null; }
            if (localY === void 0) { localY = null; }
            if (relatedObject === void 0) { relatedObject = null; }
            if (ctrlKey === void 0) { ctrlKey = false; }
            if (altKey === void 0) { altKey = false; }
            if (shiftKey === void 0) { shiftKey = false; }
            if (buttonDown === void 0) { buttonDown = false; }
            if (delta === void 0) { delta = 0; }
            var _this = _super.call(this, type, bubbles, cancelable) || this;
            _this.localX = localX;
            _this.localY = localY;
            _this.relatedObject = relatedObject;
            _this.ctrlKey = ctrlKey;
            _this.altKey = altKey;
            _this.shiftKey = shiftKey;
            _this.buttonDown = buttonDown;
            _this.delta = delta;
            return _this;
        }
        Object.defineProperty(MouseEvent.prototype, "altKey", {
            get: function () {
                return this._altKey;
            },
            set: function (value) {
                this._altKey = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "buttonDown", {
            get: function () {
                return this._buttonDown;
            },
            set: function (value) {
                this._buttonDown = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "ctrlKey", {
            get: function () {
                return this._ctrlKey;
            },
            set: function (value) {
                this._ctrlKey = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "delta", {
            get: function () {
                return this._delta;
            },
            set: function (value) {
                this._delta = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "isRelatedObjectInaccessible", {
            get: function () {
                return this._isRelatedObjectInaccessible;
            },
            set: function (value) {
                this._isRelatedObjectInaccessible = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "localX", {
            get: function () {
                return this._localX;
            },
            set: function (value) {
                this._localX = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "localY", {
            get: function () {
                return this._localY;
            },
            set: function (value) {
                this._localY = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "movementX", {
            get: function () {
                return this._movementX;
            },
            set: function (value) {
                this._movementX = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "movementY", {
            get: function () {
                return this._movementY;
            },
            set: function (value) {
                this._movementY = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "relatedObject", {
            get: function () {
                return this._relatedObject;
            },
            set: function (value) {
                this._relatedObject = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "shiftKey", {
            get: function () {
                return this._shiftKey;
            },
            set: function (value) {
                this._shiftKey = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "stageX", {
            get: function () {
                return this._stageX;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "stageY", {
            get: function () {
                return this._stageY;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Creates a copy of the MouseEvent object and sets the value of each property to match that of the original.
         * @return	A new MouseEvent object with property values that match those of the original.
         */
        MouseEvent.prototype.clone = function () {
            return null;
        };
        MouseEvent.prototype.fillFromJS = function (jsEvent) {
            this._stageX = (jsEvent.clientX != null) ? jsEvent.clientX : jsEvent.changedTouches[0].clientX;
            this._stageY = (jsEvent.clientY != null) ? jsEvent.clientY : jsEvent.changedTouches[0].clientY;
            this.delta = jsEvent.delta;
            if (this._stageY < 0)
                this._stageY = 0;
            this.ctrlKey = jsEvent.ctrlKey;
            this.shiftKey = jsEvent.shiftKey;
        };
        /* added to clone events from away to as3web. */
        MouseEvent.prototype.fillFromAway = function (awayEvent) {
            //console.log("cloneFromAway not implemented yet in flash/MouseEvent");
            // todo: set targets correctly
            this.target = awayEvent.target;
            //this.currentTarget = awayEvent.currentTarget;
            this.delta = awayEvent.delta;
            this.ctrlKey = awayEvent.ctrlKey;
            this.shiftKey = awayEvent.shiftKey;
            this._stageX = awayEvent.screenX;
            this._stageY = awayEvent.screenY;
            //todo: translate more stuff from awayjs to as3
            //result.screenX = this.screenX;
            //result.screenY = this.screenY;
            /*
                    result.view = awayEvent.view;
                    result.entity = awayEvent.entity;
                    result.renderable = awayEvent.renderable;
                    result.material = awayEvent.material;
                    result.uv = awayEvent.uv;
                    result.position = awayEvent.position;
                    result.normal = awayEvent.normal;
                    result.elementIndex = awayEvent.elementIndex;
            */
            //result._iParentEvent = awayEvent;
            //result._iAllowedToPropagate = awayEvent._iAllowedToPropagate;
        };
        /**
         * Returns a string that contains all the properties of the MouseEvent object. The string is in the following format:
         * [MouseEvent type=value bubbles=value cancelable=value ... delta=value]
         * @return	A string that contains all the properties of the MouseEvent object.
         */
        MouseEvent.prototype.toString = function () {
            return "";
        };
        /**
         * Instructs Flash Player or Adobe AIR to render after processing of this event completes, if the display list has been modified.
         */
        MouseEvent.prototype.updateAfterEvent = function () {
        };
        /**
         * Defines the value of the type property of a click event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDownFor click events, this value is always false.cancelablefalse; there is no default behavior to cancel.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         */
        MouseEvent.CLICK = "click";
        /**
         * The MouseEvent.CONTEXT_MENU constant defines the value of the
         * type property of a contextMenu event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDowntrue if the right mouse button is pressed; false otherwise.cancelablefalse; the default behavior cannot be canceled.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.clickCountCount of the number of mouse clicks to indicate whether the event is part of a multi-click sequence.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	AIR 1.0
         * @playerversion	Lite 4
         */
        MouseEvent.CONTEXT_MENU = "contextMenu";
        /**
         * Defines the value of the type property of a doubleClick event object. The doubleClickEnabled property
         * must be true for an object to generate the doubleClick event.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDownFor double-click events, this value is always false.cancelablefalse; there is no default behavior to cancel.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         */
        MouseEvent.DOUBLE_CLICK = "doubleClick";
        /**
         * Defines the value of the type property of a middleClick event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDownFor middle-click events, this property is always false.cancelablefalse; there is no default behavior to cancel.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	AIR 1.0
         * @playerversion	Lite 4
         */
        MouseEvent.MIDDLE_CLICK = "middleClick";
        /**
         * Defines the value of the type property of a middleMouseDown event object.
         * This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDowntrue if the middle mouse button is pressed; false otherwise.cancelablefalse; the default behavior cannot be canceled.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.clickCountCount of the number of mouse clicks to indicate whether the event is part of a multi-click sequence.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	AIR 1.0
         * @playerversion	Lite 4
         */
        MouseEvent.MIDDLE_MOUSE_DOWN = "middleMouseDown";
        /**
         * Defines the value of the type property of a middleMouseUp event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDowntrue if the middle mouse button is pressed; false otherwise.cancelablefalse; the default behavior cannot be canceled.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.clickCountCount of the number of mouse clicks to indicate whether the event is part of a multi-click sequence.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	AIR 1.0
         * @playerversion	Lite 4
         */
        MouseEvent.MIDDLE_MOUSE_UP = "middleMouseUp";
        /**
         * Defines the value of the type property of a mouseDown event object.
         * This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDowntrue if the primary mouse button is pressed; false otherwise.cancelablefalse; the default behavior cannot be canceled.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows and Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.clickCountCount of the number of mouse clicks to indicate whether the event is part of a multi-click sequence.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         */
        MouseEvent.MOUSE_DOWN = "mouseDown";
        /**
         * Defines the value of the type property of a mouseMove event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDowntrue if the primary mouse button is pressed; false otherwise.cancelablefalse; the default behavior cannot be canceled.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         */
        MouseEvent.MOUSE_MOVE = "mouseMove";
        /**
         * Defines the value of the type property of a mouseOut event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDowntrue if the primary mouse button is pressed; false otherwise.cancelablefalse; the default behavior cannot be canceled.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.relatedObjectThe display list object to which the pointing device now points.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         */
        MouseEvent.MOUSE_OUT = "mouseOut";
        /**
         * Defines the value of the type property of a mouseOver event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDowntrue if the primary mouse button is pressed; false otherwise.cancelablefalse; the default behavior cannot be canceled.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.relatedObjectThe display list object to which the pointing device was pointing.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         */
        MouseEvent.MOUSE_OVER = "mouseOver";
        /**
         * Defines the value of the type property of a mouseUp event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDowntrue if the primary mouse button is pressed; false otherwise.cancelablefalse; the default behavior cannot be canceled.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.clickCountCount of the number of mouse clicks to indicate whether the event is part of a multi-click sequence.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         */
        MouseEvent.MOUSE_UP = "mouseUp";
        /**
         * Defines the value of the type property of a mouseWheel event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDowntrue if the primary mouse button is pressed; false otherwise.cancelablefalse; the default behavior cannot be canceled.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.deltaThe number of lines that that each notch on the mouse wheel represents.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	Flash 9
         */
        MouseEvent.MOUSE_WHEEL = "mouseWheel";
        /**
         * Defines the value of the type property of a rightClick event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDownFor right-click events, this property is always false.cancelablefalse; there is no default behavior to cancel.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	AIR 1.0
         * @playerversion	Lite 4
         */
        MouseEvent.RIGHT_CLICK = "rightClick";
        /**
         * Defines the value of the type property of a rightMouseDown event object.
         * This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDownFor right-click events, this property is always true.cancelablefalse; the default behavior cannot be canceled.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.clickCountCount of the number of mouse clicks to indicate whether the event is part of a multi-click sequence.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	AIR 1.0
         * @playerversion	Lite 4
         */
        MouseEvent.RIGHT_MOUSE_DOWN = "rightMouseDown";
        /**
         * Defines the value of the type property of a rightMouseUp event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblestruebuttonDowntrue if the right mouse button is pressed; false otherwise.cancelablefalse; the default behavior cannot be canceled.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.clickCountCount of the number of mouse clicks to indicate whether the event is part of a multi-click sequence.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         * @langversion	3.0
         * @playerversion	AIR 1.0
         * @playerversion	Lite 4
         */
        MouseEvent.RIGHT_MOUSE_UP = "rightMouseUp";
        /**
         * Defines the value of the type property of a rollOut event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblesfalsebuttonDowntrue if the primary mouse button is pressed; false otherwise.cancelablefalse; there is no default behavior to cancel.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.relatedObjectThe display list object to which the pointing device now points.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         */
        MouseEvent.ROLL_OUT = "rollOut";
        /**
         * Defines the value of the type property of a rollOver event object.
         *
         *   This event has the following properties:PropertyValuealtKeytrue if the Alt key is active (Windows).bubblesfalsebuttonDowntrue if the primary mouse button is pressed; false otherwise.cancelablefalse; there is no default behavior to cancel.commandKeytrue on the Mac if the Command key is active; false if it is inactive. Always false on Windows.controlKeytrue if the Ctrl or Control key is active; false if it is inactive.ctrlKeytrue on Windows or Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.relatedObjectThe display list object to which the pointing device was pointing.localXThe horizontal coordinate at which the event occurred relative to the containing sprite.localYThe vertical coordinate at which the event occurred relative to the containing sprite.shiftKeytrue if the Shift key is active; false if it is inactive.stageXThe horizontal coordinate at which the event occurred in global stage coordinates.stageYThe vertical coordinate at which the event occurred in global stage coordinates.targetThe InteractiveObject instance under the pointing device.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         */
        MouseEvent.ROLL_OVER = "rollOver";
        return MouseEvent;
    }(Event));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: EventPhase
    var EventPhase = /** @class */ (function (_super) {
        __extends(EventPhase, _super);
        function EventPhase() {
            return _super.call(this) || this;
        }
        EventPhase.classInitializer = null;
        EventPhase.classSymbols = null;
        EventPhase.instanceSymbols = null;
        // JS -> AS Bindings
        EventPhase.CAPTURING_PHASE = 1;
        EventPhase.AT_TARGET = 2;
        EventPhase.BUBBLING_PHASE = 3;
        return EventPhase;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: Event
    var Event$1 = /** @class */ (function (_super) {
        __extends(Event, _super);
        function Event(type, bubbles, cancelable) {
            var _this = _super.call(this) || this;
            _this._type = axCoerceString(type);
            _this._bubbles = !!bubbles;
            _this._cancelable = !!cancelable;
            _this._target = null;
            _this._currentTarget = null;
            _this._eventPhase = EventPhase.AT_TARGET;
            _this._stopPropagation = false;
            _this._stopImmediatePropagation = false;
            _this._isDefaultPrevented = false;
            return _this;
        }
        Event.getInstance = function (type, bubbles, cancelable) {
            if (bubbles === void 0) { bubbles = false; }
            if (cancelable === void 0) { cancelable = false; }
            var instance = this._instances[type];
            if (!instance) {
                instance = new Event(type, bubbles, cancelable);
                this._instances[type] = instance;
            }
            instance._bubbles = bubbles;
            instance._cancelable = cancelable;
            return instance;
        };
        Event.getBroadcastInstance = function (type, bubbles, cancelable) {
            if (bubbles === void 0) { bubbles = false; }
            if (cancelable === void 0) { cancelable = false; }
            var instance = this._instances[type];
            if (!instance) {
                instance = new Event(type, bubbles, cancelable);
                this._instances[type] = instance;
                // Some events are documented as broadcast event in the AS3 docs. We can't set |_isBroadcastEvent| flag in the
                // constructor because if you create custom events with these types they do capture and bubble.
                release$1 || assert(Event.isBroadcastEventType(type));
            }
            instance._isBroadcastEvent = true;
            instance._bubbles = bubbles;
            instance._cancelable = cancelable;
            return instance;
        };
        /**
         * http://stackoverflow.com/questions/16900176/as3enterframe-event-propagation-understanding-issue
         */
        Event.isBroadcastEventType = function (type) {
            switch (type) {
                case Event.ENTER_FRAME:
                case Event.EXIT_FRAME:
                case Event.FRAME_CONSTRUCTED:
                case Event.RENDER:
                case Event.ACTIVATE:
                case Event.DEACTIVATE:
                    return true;
            }
            return false;
        };
        Object.defineProperty(Event.prototype, "type", {
            get: function () {
                return this._type;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Event.prototype, "bubbles", {
            get: function () {
                return this._bubbles;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Event.prototype, "cancelable", {
            get: function () {
                return this._cancelable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Event.prototype, "target", {
            get: function () {
                return this._target;
            },
            set: function (value) {
                this._target = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Event.prototype, "currentTarget", {
            get: function () {
                return this._currentTarget;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Event.prototype, "eventPhase", {
            get: function () {
                return this._eventPhase;
            },
            enumerable: true,
            configurable: true
        });
        Event.prototype.stopPropagation = function () {
            this._stopPropagation = true;
        };
        Event.prototype.stopImmediatePropagation = function () {
            this._stopImmediatePropagation = this._stopPropagation = true;
        };
        Event.prototype.preventDefault = function () {
            if (this._cancelable) {
                this._isDefaultPrevented = true;
            }
        };
        Event.prototype.isDefaultPrevented = function () {
            return this._isDefaultPrevented;
        };
        Event.prototype.isBroadcastEvent = function () {
            return !!this._isBroadcastEvent;
        };
        Event.prototype.clone = function () {
            return new Event(this._type, this._bubbles, this._cancelable);
        };
        Event.prototype.toString = function () {
            return this.formatToString('Event', 'type', 'bubbles', 'cancelable', 'eventPhase');
        };
        Event.prototype.formatToString = function (className) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            var str = '[' + className;
            for (var i = 0; i < args.length; i++) {
                var field = args[i];
                var value = this.axGetPublicProperty(field);
                if (typeof value === 'string') {
                    value = '"' + value + '"';
                }
                str += ' ' + field + '=' + value;
            }
            return str + ']';
        };
        Event.classInitializer = function () {
            var self = this;
            self._instances = ObjectUtilities.createMap();
        };
        // JS -> AS Bindings
        Event.ACTIVATE = "activate";
        Event.ADDED = "added";
        Event.ADDED_TO_STAGE = "addedToStage";
        Event.CANCEL = "cancel";
        Event.CHANGE = "change";
        Event.CLEAR = "clear";
        Event.CLOSE = "close";
        Event.COMPLETE = "complete";
        Event.CONNECT = "connect";
        Event.COPY = "copy";
        Event.CUT = "cut";
        Event.DEACTIVATE = "deactivate";
        Event.ENTER_FRAME = "enterFrame";
        Event.FRAME_CONSTRUCTED = "frameConstructed";
        Event.EXIT_FRAME = "exitFrame";
        Event.FRAME_LABEL = "frameLabel";
        Event.ID3 = "id3";
        Event.INIT = "init";
        Event.MOUSE_LEAVE = "mouseLeave";
        Event.OPEN = "open";
        Event.PASTE = "paste";
        Event.REMOVED = "removed";
        Event.REMOVED_FROM_STAGE = "removedFromStage";
        Event.RENDER = "render";
        Event.RESIZE = "resize";
        Event.SCROLL = "scroll";
        Event.TEXT_INTERACTION_MODE_CHANGE = "textInteractionModeChange";
        Event.SELECT = "select";
        Event.SELECT_ALL = "selectAll";
        Event.SOUND_COMPLETE = "soundComplete";
        Event.TAB_CHILDREN_CHANGE = "tabChildrenChange";
        Event.TAB_ENABLED_CHANGE = "tabEnabledChange";
        Event.TAB_INDEX_CHANGE = "tabIndexChange";
        Event.UNLOAD = "unload";
        Event.FULLSCREEN = "fullScreen";
        Event.CONTEXT3D_CREATE = "context3DCreate";
        Event.TEXTURE_READY = "textureReady";
        Event.VIDEO_FRAME = "videoFrame";
        Event.SUSPEND = "suspend";
        Event.AVM1_INIT = "initialize";
        Event.AVM1_CONSTRUCT = "construct";
        Event.AVM1_LOAD = "load";
        return Event;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: KeyboardEvent
    var KeyboardEvent$1 = /** @class */ (function (_super) {
        __extends(KeyboardEvent, _super);
        function KeyboardEvent(type, bubbles, cancelable, charCodeValue, keyCodeValue, keyLocationValue, ctrlKeyValue, altKeyValue, shiftKeyValue) {
            if (bubbles === void 0) { bubbles = true; }
            if (cancelable === void 0) { cancelable = false; }
            if (charCodeValue === void 0) { charCodeValue = 0; }
            if (keyCodeValue === void 0) { keyCodeValue = 0; }
            if (keyLocationValue === void 0) { keyLocationValue = 0; }
            if (ctrlKeyValue === void 0) { ctrlKeyValue = false; }
            if (altKeyValue === void 0) { altKeyValue = false; }
            if (shiftKeyValue === void 0) { shiftKeyValue = false; }
            var _this = _super.call(this, type, bubbles, cancelable) || this;
            _this._charCode = charCodeValue >>> 0;
            _this._keyCode = keyCodeValue >>> 0;
            _this._keyLocation = keyLocationValue >>> 0;
            _this._ctrlKey = !!ctrlKeyValue;
            _this._altKey = !!altKeyValue;
            _this._shiftKey = !!shiftKeyValue;
            return _this;
        }
        Object.defineProperty(KeyboardEvent.prototype, "charCode", {
            get: function () {
                return this._charCode;
            },
            set: function (value) {
                this._charCode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(KeyboardEvent.prototype, "keyCode", {
            get: function () {
                return this._keyCode;
            },
            set: function (value) {
                this._keyCode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(KeyboardEvent.prototype, "keyLocation", {
            get: function () {
                return this._keyLocation;
            },
            set: function (value) {
                this._keyLocation = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(KeyboardEvent.prototype, "ctrlKey", {
            get: function () {
                return this._ctrlKey;
            },
            set: function (value) {
                this._ctrlKey = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(KeyboardEvent.prototype, "altKey", {
            get: function () {
                return this._altKey;
            },
            set: function (value) {
                this._altKey = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(KeyboardEvent.prototype, "shiftKey", {
            get: function () {
                return this._shiftKey;
            },
            set: function (value) {
                this._shiftKey = value;
            },
            enumerable: true,
            configurable: true
        });
        KeyboardEvent.prototype.clone = function () {
            return new KeyboardEvent(this.type, this.bubbles, this.cancelable, this.charCode, this.keyCode, this.keyLocation, this.ctrlKey, this.altKey, this.shiftKey);
        };
        KeyboardEvent.prototype.toString = function () {
            return this.formatToString('KeyboardEvent', 'type', 'bubbles', 'cancelable', 'eventPhase', 'charCode', 'keyCode', 'keyLocation', 'ctrlKey', 'altKey', 'shiftKey');
        };
        KeyboardEvent.prototype.updateAfterEvent = function () {
            this.sec.player.requestRendering();
        };
        KeyboardEvent.classInitializer = null;
        KeyboardEvent.classSymbols = null;
        KeyboardEvent.instanceSymbols = null;
        KeyboardEvent.KEY_DOWN = "keyDown";
        KeyboardEvent.KEY_UP = "keyUp";
        return KeyboardEvent;
    }(Event$1));

    var InteractiveObject = /** @class */ (function (_super) {
        __extends(InteractiveObject, _super);
        /** these should be able to get setup:
         

         // listen on key directly
         
         * Dispatched when the user releases a key.
         * @eventType	flash.events.KeyboardEvent.KEY_UP
         [Event(name="keyUp", type="flash.events.KeyboardEvent")]
         
         * Dispatched when the user presses a key.
         * @eventType	flash.events.KeyboardEvent.KEY_DOWN
         [Event(name="keyDown", type="flash.events.KeyboardEvent")]
         
         // listen on awayjs adapter and translate
         
         * Dispatched when a user releases the pointing device button over an
         * InteractiveObject instance.
         * @eventType	flash.events.MouseEvent.RIGHT_MOUSE_UP
         [Event(name="rightMouseUp", type="flash.events.MouseEvent")]
         
         * Dispatched when a user presses the pointing device button over an InteractiveObject instance.
         * @eventType	flash.events.MouseEvent.RIGHT_MOUSE_DOWN
         [Event(name="rightMouseDown", type="flash.events.MouseEvent")]
         
         * Dispatched when a user presses and releases the right button of the user's
         * pointing device over the same InteractiveObject.
         * @eventType	flash.events.MouseEvent.RIGHT_CLICK
         [Event(name="rightClick", type="flash.events.MouseEvent")]
         
         * Dispatched when a user releases the pointing device button over an
         * InteractiveObject instance.
         * @eventType	flash.events.MouseEvent.MIDDLE_MOUSE_UP
         [Event(name="middleMouseUp", type="flash.events.MouseEvent")]
         
         * Dispatched when a user presses the middle pointing device button over an InteractiveObject instance.
         * @eventType	flash.events.MouseEvent.MIDDLE_MOUSE_DOWN
         [Event(name="middleMouseDown", type="flash.events.MouseEvent")]
         
         * Dispatched when a user presses and releases the middle button of the user's
         * pointing device over the same InteractiveObject.
         * @eventType	flash.events.MouseEvent.MIDDLE_CLICK
         [Event(name="middleClick", type="flash.events.MouseEvent")]
         
         
         * Dispatched when the user moves a pointing device over an InteractiveObject instance.
         * @eventType	flash.events.MouseEvent.ROLL_OVER
         [Event(name="rollOver", type="flash.events.MouseEvent")]
         
         * Dispatched when the user moves a pointing device away from an InteractiveObject
         * instance.
         * @eventType	flash.events.MouseEvent.ROLL_OUT
         [Event(name="rollOut", type="flash.events.MouseEvent")]
         
         * Dispatched when a mouse wheel is spun over an InteractiveObject instance.
         * @eventType	flash.events.MouseEvent.MOUSE_WHEEL
         [Event(name="mouseWheel", type="flash.events.MouseEvent")]
         
         * Dispatched when a user releases the pointing device button over an
         * InteractiveObject instance.
         * @eventType	flash.events.MouseEvent.MOUSE_UP
         [Event(name="mouseUp", type="flash.events.MouseEvent")]
         
         * Dispatched when the user moves a pointing device over an InteractiveObject instance.
         * @eventType	flash.events.MouseEvent.MOUSE_OVER
         [Event(name="mouseOver", type="flash.events.MouseEvent")]
         
         * Dispatched when the user moves a pointing device away from an InteractiveObject instance.
         * @eventType	flash.events.MouseEvent.MOUSE_OUT
         [Event(name="mouseOut", type="flash.events.MouseEvent")]
         
         * Dispatched when a user moves the pointing device while it is over an InteractiveObject.
         * @eventType	flash.events.MouseEvent.MOUSE_MOVE
         [Event(name="mouseMove", type="flash.events.MouseEvent")]
         
         * Dispatched when a user presses the pointing device button over an InteractiveObject instance.
         * @eventType	flash.events.MouseEvent.MOUSE_DOWN
         [Event(name="mouseDown", type="flash.events.MouseEvent")]
         
         * Dispatched when a user presses and releases the main button of a pointing device twice in
         * rapid succession over the same InteractiveObject when that object's
         * doubleClickEnabled flag is set to true.
         * @eventType	flash.events.MouseEvent.DOUBLE_CLICK
         [Event(name="doubleClick", type="flash.events.MouseEvent")]
         
         * Dispatched when a user presses and releases the main button of the user's
         * pointing device over the same InteractiveObject.
         * @eventType	flash.events.MouseEvent.CLICK
         [Event(name="click", type="flash.events.MouseEvent")]

         */
        /**
        * Dispatched immediately after the soft keyboard is lowered.
        * @eventType	flash.events.SoftKeyboardEvent.SOFT_KEYBOARD_DEACTIVATE
        [Event(name="softKeyboardDeactivate", type="flash.events.SoftKeyboardEvent")]

        * Dispatched immediately after the soft keyboard is raised.
        * @eventType	flash.events.SoftKeyboardEvent.SOFT_KEYBOARD_ACTIVATE
        [Event(name="softKeyboardActivate", type="flash.events.SoftKeyboardEvent")]

        * Dispatched immediately before the soft keyboard is raised.
        * @eventType	flash.events.SoftKeyboardEvent.SOFT_KEYBOARD_ACTIVATING
        [Event(name="softKeyboardActivating", type="flash.events.SoftKeyboardEvent")]

        * Dispatched when a user enters one or more
        * characters of text.
        * @eventType	flash.events.TextEvent.TEXT_INPUT
        [Event(name="textInput", type="flash.events.TextEvent")]
        /// This event is dispatched to any client app that supports inline input with an IME
        [Event(name="imeStartComposition", type="flash.events.IMEEvent")]

        * Dispatched when a user gesture triggers the context menu associated with this interactive
        * object in an AIR application.
        * @eventType	flash.events.MouseEvent.CONTEXT_MENU
        [Event(name="contextMenu", type="flash.events.MouseEvent")]

        * Dispatched by the drag initiator InteractiveObject when the user releases the drag gesture.
        * @eventType	flash.events.NativeDragEvent.NATIVE_DRAG_COMPLETE
        [Event(name="nativeDragComplete", type="flash.events.NativeDragEvent")]

        * Dispatched during a drag operation by the InteractiveObject that is
        * specified as the drag initiator in the DragManager.doDrag() call.
        * @eventType	flash.events.NativeDragEvent.NATIVE_DRAG_UPDATE
        [Event(name="nativeDragUpdate", type="flash.events.NativeDragEvent")]

        * Dispatched at the beginning of a drag operation by the InteractiveObject that is
        * specified as the drag initiator in the DragManager.doDrag() call.
        * @eventType	flash.events.NativeDragEvent.NATIVE_DRAG_START
        [Event(name="nativeDragStart", type="flash.events.NativeDragEvent")]

        * Dispatched by an InteractiveObject when a drag gesture leaves its boundary.
        * @eventType	flash.events.NativeDragEvent.NATIVE_DRAG_EXIT
        [Event(name="nativeDragExit", type="flash.events.NativeDragEvent")]

        * Dispatched by the target InteractiveObject when a dragged object is
        * dropped on it and the drop has been accepted with a call to
        * DragManager.acceptDragDrop().
        * @eventType	flash.events.NativeDragEvent.NATIVE_DRAG_DROP
        [Event(name="nativeDragDrop", type="flash.events.NativeDragEvent")]

        * Dispatched by an InteractiveObject continually while a drag gesture remains within its
        * boundary.
        * @eventType	flash.events.NativeDragEvent.NATIVE_DRAG_OVER
        [Event(name="nativeDragOver", type="flash.events.NativeDragEvent")]

        * Dispatched by an InteractiveObject when a drag gesture enters its boundary.
        * @eventType	flash.events.NativeDragEvent.NATIVE_DRAG_ENTER

        * Dispatched when the value of the object's tabIndex property changes.
        * @eventType	flash.events.Event.TAB_INDEX_CHANGE
        [Event(name="tabIndexChange", type="flash.events.Event")]

        * Dispatched when the object's tabEnabled flag changes.
        * @eventType	flash.events.Event.TAB_ENABLED_CHANGE
        [Event(name="tabEnabledChange", type="flash.events.Event")]

        * Dispatched when the value of the object's tabChildren flag changes.
        * @eventType	flash.events.Event.TAB_CHILDREN_CHANGE
        [Event(name="tabChildrenChange", type="flash.events.Event")]

        * Dispatched when the user performs a swipe gesture at a point of contact with an InteractiveObject instance (such as touching three
        * fingers to a screen and then moving them in parallel over a display object on a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.TransformGestureEvent.GESTURE_SWIPE
        [Event(name="gestureSwipe", type="flash.events.TransformGestureEvent")]

        * Dispatched when the user performs a zoom gesture at a point of contact with an InteractiveObject instance (such as touching two
        * fingers to a screen and then quickly spreading the fingers apart over a display object on a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.TransformGestureEvent.GESTURE_ZOOM
        [Event(name="gestureZoom", type="flash.events.TransformGestureEvent")]

        * Dispatched when the user performs a rotation gesture at a point of contact with an InteractiveObject instance (such as touching two fingers
        * and rotating them over a display object on a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.TransformGestureEvent.GESTURE_ROTATE
        [Event(name="gestureRotate", type="flash.events.TransformGestureEvent")]

        * Dispatched when the user creates a point of contact with an InteractiveObject instance, then taps
        * on a touch-enabled device (such as placing several fingers over a display object to open a menu and then taps one finger to select a menu item
        * on a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.PressAndTapGestureEvent.GESTURE_PRESS_AND_TAP
        [Event(name="gesturePressAndTap", type="flash.events.PressAndTapGestureEvent")]

        * Dispatched when the user moves a point of contact over the InteractiveObject instance
        * on a touch-enabled device (such as moving a finger from left to right over a display object
        * on a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.TransformGestureEvent.GESTURE_PAN
        [Event(name="gesturePan", type="flash.events.TransformGestureEvent")]

        * Dispatched when the user presses two points of contact over the same InteractiveObject instance
        * on a touch-enabled device (such as presses and releases two fingers over a display object
        * on a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.GestureEvent.GESTURE_TWO_FINGER_TAP
        [Event(name="gestureTwoFingerTap", type="flash.events.GestureEvent")]

        * Dispatched when the user lifts the point of contact over the same InteractiveObject instance on which the contact was initiated
        * on a touch-enabled device (such as presses and releases a finger from a single point over a display object
        * on a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.TouchEvent.TOUCH_TAP
        [Event(name="touchTap", type="flash.events.TouchEvent")]

        * Dispatched when the user moves the point of contact over an InteractiveObject instance on a touch-enabled device
        * (such as drags a finger from a point outside a display object to a point over a display object on a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.TouchEvent.TOUCH_ROLL_OVER
        [Event(name="touchRollOver", type="flash.events.TouchEvent")]

        * Dispatched when the user moves the point of contact away from an InteractiveObject instance on a touch-enabled device
        * (such as drags a finger from over a display object to a point outside the display object on a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.TouchEvent.TOUCH_ROLL_OUT
        [Event(name="touchRollOut", type="flash.events.TouchEvent")]

        * Dispatched when the user moves the point of contact over an InteractiveObject instance on a touch-enabled device
        * (such as drags a finger from a point outside a display object to a point over a display object on a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.TouchEvent.TOUCH_OVER
        [Event(name="touchOver", type="flash.events.TouchEvent")]

        * Dispatched when the user moves the point of contact away from InteractiveObject instance on a touch-enabled device
        * (such as drags a finger from one display object to another on a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.TouchEvent.TOUCH_OUT
        [Event(name="touchOut", type="flash.events.TouchEvent")]

        * Dispatched when the user moves the point of contact with a touch-enabled device (such as drags a finger across a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.TouchEvent.TOUCH_MOVE
        [Event(name="touchMove", type="flash.events.TouchEvent")]

        * Dispatched when the user removes contact with a touch-enabled device (such as lifts a finger off a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.TouchEvent.TOUCH_END
        [Event(name="touchEnd", type="flash.events.TouchEvent")]

        * Dispatched when the user first contacts a touch-enabled device (such as touches a finger to a mobile phone or tablet with a touch screen).
        * @eventType	flash.events.TouchEvent.TOUCH_BEGIN
        [Event(name="touchBegin", type="flash.events.TouchEvent")]

        * Dispatched when the user attempts to change focus by using a pointer device.
        * @eventType	flash.events.FocusEvent.MOUSE_FOCUS_CHANGE
        [Event(name="mouseFocusChange", type="flash.events.FocusEvent")]

        * Dispatched when the user attempts to change focus by using keyboard navigation.
        * @eventType	flash.events.FocusEvent.KEY_FOCUS_CHANGE
        *
        * Dispatched after a display object loses focus.
        * @eventType	flash.events.FocusEvent.FOCUS_OUT
        [Event(name="focusOut", type="flash.events.FocusEvent")]

        * Dispatched after a display object gains focus.
        * @eventType	flash.events.FocusEvent.FOCUS_IN
        [Event(name="focusIn", type="flash.events.FocusEvent")]

        * Dispatched when the user activates the platform-specific accelerator key combination for a select all operation
        * or selects 'Select All' from the text context menu.
        * @eventType	flash.events.Event.SELECT_ALL
        [Event(name="selectAll", type="flash.events.Event")]

        * Dispatched when the user activates the platform-specific accelerator key combination for a paste operation
        * or selects 'Paste' from the text context menu.
        * @eventType	flash.events.Event.PASTE
        [Event(name="paste", type="flash.events.Event")]

        * Dispatched when the user activates the platform-specific accelerator key combination for a cut operation
        * or selects 'Cut' from the text context menu.
        * @eventType	flash.events.Event.CUT
        [Event(name="cut", type="flash.events.Event")]

        * Dispatched when the user activates the platform-specific accelerator key combination for a copy operation
        * or selects 'Copy' from the text context menu.
        * @eventType	flash.events.Event.COPY
        [Event(name="copy", type="flash.events.Event")]

        * Dispatched when the user selects 'Clear' (or 'Delete') from the text context menu.
        * @eventType	flash.events.Event.CLEAR
        [Event(name="clear", type="flash.events.Event")]
        */
        /**

       * The InteractiveObject class is the abstract base class for all display objects with which the user can
        * interact, using the mouse, keyboard, or other user input device.
        *
        *   <p class="- topic/p ">You cannot instantiate the InteractiveObject class directly. A call to the <codeph class="+ topic/ph pr-d/codeph ">new
        * InteractiveObject()</codeph> constructor throws an <codeph class="+ topic/ph pr-d/codeph ">ArgumentError</codeph> exception.</p><p class="- topic/p ">The InteractiveObject class itself does not include any APIs for rendering content onscreen.
        * To create a custom subclass of the InteractiveObject class,
        * extend one of the subclasses that do have APIs for rendering content onscreen,
        * such as the Sprite, SimpleButton, TextField, or MovieClip classes.</p>
        *
        *   EXAMPLE:
        *
        *   The following example uses the <codeph class="+ topic/ph pr-d/codeph ">InteractiveObjectExample</codeph> class, which in
        * turn uses the <codeph class="+ topic/ph pr-d/codeph ">ChildSprite</codeph> class to draw a rectangle and then manipulate that rectangle
        * based on various mouse events.  This task is accomplished by performing the following steps:
        * <ol class="- topic/ol "><li class="- topic/li ">In the <codeph class="+ topic/ph pr-d/codeph ">InteractiveObjectExample</codeph> constructor, a new ChildSprite object of type Sprite
        * called <codeph class="+ topic/ph pr-d/codeph ">child</codeph> is created, which calls the ChildSprite constructor method to draw the shape
        * and add mouse events for the shape (as explained in the following steps).  The <codeph class="+ topic/ph pr-d/codeph ">child</codeph>
        * object is added to the top of the display list at coordinates <i class="+ topic/ph hi-d/i ">x = 0, y = 0</i>.  </li><li class="- topic/li ">In the <codeph class="+ topic/ph pr-d/codeph ">ChildSprite</codeph> class, declare the <codeph class="+ topic/ph pr-d/codeph ">size</codeph> and
        * <codeph class="+ topic/ph pr-d/codeph ">overSize</codeph> properties that are used later in the <codeph class="+ topic/ph pr-d/codeph ">draw()</codeph> method and
        * MouseEvent methods.</li><li class="- topic/li ">Declare properties that set the background color to orange, the mouse-over color to
        * dark yellow, and the mouse-down color to light blue.</li><li class="- topic/li ">In the <codeph class="+ topic/ph pr-d/codeph ">ChildSprite</codeph> constructor, an orange square is drawn by using methods from
        * the Graphics class and the <codeph class="+ topic/ph pr-d/codeph ">draw()</codeph> method.</li><li class="- topic/li ">The constructor adds four MouseEvent event listener methods:
        *
        *   <ul class="- topic/ul "><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">mouseOverHandler</codeph>: redraws a larger 60 x 60 pixel square with a dark-yellow color
        * at the original coordinates.</li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">mouseOutHandler</codeph>: returns the square to its original size and color.</li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">mouseDownHandler</codeph>: redraws a larger 60 x 60 pixel square with a light-blue color
        * at the original coordinates.</li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">mouseUpHandler</codeph>: same as <codeph class="+ topic/ph pr-d/codeph ">mouseOverHandler</codeph>.</li></ul></li></ol><codeblock xml:space="preserve" class="+ topic/pre pr-d/codeblock ">
        *
        * Calling the new InteractiveObject() constructor
        * throws an ArgumentError exception.
        * You can, however, call constructors for the following subclasses of InteractiveObject:
        *
        *   new SimpleButton()new TextField()new Loader()new Sprite()new MovieClip()
        */
        function InteractiveObject() {
            var _this = _super.call(this) || this;
            // these events can not be mapped from awayjs: //todo (?)
            _this.eventMappingDummys[MouseEvent$1.RIGHT_MOUSE_UP] = "InteractiveObject:MouseEvent.RIGHT_MOUSE_UP";
            _this.eventMappingDummys[MouseEvent$1.RIGHT_MOUSE_DOWN] = "InteractiveObject:MouseEvent.RIGHT_MOUSE_DOWN";
            _this.eventMappingDummys[MouseEvent$1.RIGHT_MOUSE_DOWN] = "InteractiveObject:MouseEvent.RIGHT_MOUSE_DOWN";
            _this.eventMappingDummys[MouseEvent$1.RIGHT_CLICK] = "InteractiveObject:MouseEvent.RIGHT_CLICK";
            _this.eventMappingDummys[MouseEvent$1.MIDDLE_MOUSE_UP] = "InteractiveObject:MouseEvent.MIDDLE_MOUSE_UP";
            _this.eventMappingDummys[MouseEvent$1.MIDDLE_MOUSE_DOWN] = "InteractiveObject:MouseEvent.MIDDLE_MOUSE_DOWN";
            _this.eventMappingDummys[MouseEvent$1.MIDDLE_CLICK] = "InteractiveObject:MouseEvent.MIDDLE_CLICK";
            /*
            //todo
            this.eventMappingDummys[SoftKeyboardEvent.SOFT_KEYBOARD_DEACTIVATE]="SoftKeyboardEvent.SOFT_KEYBOARD_DEACTIVATE";
            this.eventMappingDummys[SoftKeyboardEvent.SOFT_KEYBOARD_ACTIVATE]="SoftKeyboardEvent.SOFT_KEYBOARD_ACTIVATE";
            this.eventMappingDummys[SoftKeyboardEvent.SOFT_KEYBOARD_ACTIVATING]="SoftKeyboardEvent.SOFT_KEYBOARD_ACTIVATING";
            this.eventMappingDummys[TextEvent.TEXT_INPUT]="TextEvent.TEXT_INPUT";
            this.eventMappingDummys[MouseEvent.CONTEXT_MENU]="MouseEvent.CONTEXT_MENU";
            this.eventMappingDummys[NativeDragEvent.NATIVE_DRAG_COMPLETE]="NativeDragEvent.NATIVE_DRAG_COMPLETE";
            this.eventMappingDummys[NativeDragEvent.NATIVE_DRAG_UPDATE]="NativeDragEvent.NATIVE_DRAG_UPDATE";
            this.eventMappingDummys[NativeDragEvent.NATIVE_DRAG_START]="NativeDragEvent.NATIVE_DRAG_START";
            this.eventMappingDummys[NativeDragEvent.NATIVE_DRAG_EXIT]="NativeDragEvent.NATIVE_DRAG_EXIT";
            this.eventMappingDummys[NativeDragEvent.NATIVE_DRAG_DROP]="NativeDragEvent.NATIVE_DRAG_DROP";
            this.eventMappingDummys[NativeDragEvent.NATIVE_DRAG_OVER]="NativeDragEvent.NATIVE_DRAG_OVER";
            this.eventMappingDummys[NativeDragEvent.NATIVE_DRAG_ENTER]="NativeDragEvent.NATIVE_DRAG_ENTER";
            this.eventMappingDummys[Event.TAB_INDEX_CHANGE]="Event.TAB_INDEX_CHANGE";
            this.eventMappingDummys[Event.TAB_ENABLED_CHANGE]="Event.TAB_ENABLED_CHANGE";
            this.eventMappingDummys[Event.TAB_CHILDREN_CHANGE]="Event.TAB_CHILDREN_CHANGE";
            this.eventMappingDummys[TransformGestureEvent.GESTURE_SWIPE]="TransformGestureEvent.GESTURE_SWIPE";
            this.eventMappingDummys[TransformGestureEvent.GESTURE_ROTATE]="TransformGestureEvent.GESTURE_ROTATE";
            this.eventMappingDummys[TransformGestureEvent.GESTURE_PRESS_AND_TAP]="TransformGestureEvent.GESTURE_PRESS_AND_TAP";
            this.eventMappingDummys[GestureEvent.GESTURE_PAN]="GestureEvent.GESTURE_PAN";
            this.eventMappingDummys[GestureEvent.GESTURE_TWO_FINGER_TAP]="GestureEvent.GESTURE_TWO_FINGER_TAP";
            this.eventMappingDummys[TouchEvent.TOUCH_TAP]="TouchEvent.TOUCH_TAP";
            this.eventMappingDummys[TouchEvent.TOUCH_ROLL_OVER]="TouchEvent.TOUCH_ROLL_OVER";
            this.eventMappingDummys[TouchEvent.TOUCH_ROLL_OUT]="TouchEvent.TOUCH_ROLL_OUT";
            this.eventMappingDummys[TouchEvent.TOUCH_OVER]="TouchEvent.TOUCH_OVER";
            this.eventMappingDummys[TouchEvent.TOUCH_OUT]="TouchEvent.TOUCH_OUT";
            this.eventMappingDummys[TouchEvent.TOUCH_MOVE]="TouchEvent.TOUCH_MOVE";
            this.eventMappingDummys[TouchEvent.TOUCH_END]="TouchEvent.TOUCH_END";
            this.eventMappingDummys[TouchEvent.TOUCH_BEGIN]="TouchEvent.TOUCH_BEGIN";
            this.eventMappingDummys[FocusEvent.MOUSE_FOCUS_CHANGE]="FocusEvent.MOUSE_FOCUS_CHANGE";
            this.eventMappingDummys[FocusEvent.KEY_FOCUS_CHANGE]="FocusEvent.KEY_FOCUS_CHANGE";
            this.eventMappingDummys[FocusEvent.FOCUS_OUT]="FocusEvent.FOCUS_OUT";
            this.eventMappingDummys[FocusEvent.FOCUS_IN]="FocusEvent.FOCUS_IN";
            this.eventMappingDummys[Event.SELECT_ALL]="Event.SELECT_ALL";
            this.eventMappingDummys[Event.PASTE]="Event.PASTE";
            this.eventMappingDummys[Event.CUT]="Event.CUT";
            this.eventMappingDummys[Event.COPY]="Event.COPY";
            this.eventMappingDummys[Event.CLEAR]="Event.CLEAR";
             */
            // KeyboardEvent events adapt to js-events. they listen on document.onKeyUp / onKeyDown:
            _this._keyUpCallbackDelegate = function (event) { return _this.keyUpCallback(event); };
            _this.eventMapping[KeyboardEvent$1.KEY_UP] = {
                adaptedType: "",
                addListener: _this.initKeyUpListener,
                removeListener: _this.removeKeyUpListener,
                callback: _this._keyUpCallbackDelegate
            };
            _this._keyDownCallbackDelegate = function (event) { return _this.keyDownCallback(event); };
            _this.eventMapping[KeyboardEvent$1.KEY_DOWN] = {
                adaptedType: "",
                addListener: _this.initKeyDownListener,
                removeListener: _this.removeKeyDownListener,
                callback: _this._keyDownCallbackDelegate
            };
            // MouseEvent events adapt to awayjs-MouseEvents. they listen on adapter:
            // these mapping share the same callback, thats why we need the setup the eventMappingInvert to
            _this._mouseCallbackDelegate = function (event) { return _this.mouseCallback(event); };
            _this.eventMappingInvert[MouseEvent.MOUSE_WHEEL] = MouseEvent$1.MOUSE_WHEEL;
            _this.eventMapping[MouseEvent$1.MOUSE_WHEEL] = {
                adaptedType: MouseEvent.MOUSE_WHEEL,
                addListener: _this.initMouseListener,
                removeListener: _this.removeMouseListener,
                callback: _this._mouseCallbackDelegate
            };
            _this.eventMappingInvert[MouseEvent.MOUSE_UP] = MouseEvent$1.MOUSE_UP;
            _this.eventMapping[MouseEvent$1.MOUSE_UP] = {
                adaptedType: MouseEvent.MOUSE_UP,
                addListener: _this.initMouseListener,
                removeListener: _this.removeMouseListener,
                callback: _this._mouseCallbackDelegate
            };
            _this.eventMappingInvert[MouseEvent.MOUSE_OVER] = MouseEvent$1.MOUSE_OVER;
            _this.eventMapping[MouseEvent$1.MOUSE_OVER] = {
                adaptedType: MouseEvent.MOUSE_OVER,
                addListener: _this.initMouseListener,
                removeListener: _this.removeMouseListener,
                callback: _this._mouseCallbackDelegate
            };
            _this.eventMappingInvert[MouseEvent.MOUSE_OUT] = MouseEvent$1.MOUSE_OUT;
            _this.eventMapping[MouseEvent$1.MOUSE_OUT] = {
                adaptedType: MouseEvent.MOUSE_OUT,
                addListener: _this.initMouseListener,
                removeListener: _this.removeMouseListener,
                callback: _this._mouseCallbackDelegate
            };
            _this.eventMappingInvert[MouseEvent.MOUSE_MOVE] = MouseEvent$1.MOUSE_MOVE;
            _this.eventMapping[MouseEvent$1.MOUSE_MOVE] = {
                adaptedType: MouseEvent.MOUSE_MOVE,
                addListener: _this.initMouseListener,
                removeListener: _this.removeMouseListener,
                callback: _this._mouseCallbackDelegate
            };
            _this.eventMappingInvert[MouseEvent.MOUSE_DOWN] = MouseEvent$1.MOUSE_DOWN;
            _this.eventMapping[MouseEvent$1.MOUSE_DOWN] = {
                adaptedType: MouseEvent.MOUSE_DOWN,
                addListener: _this.initMouseListener,
                removeListener: _this.removeMouseListener,
                callback: _this._mouseCallbackDelegate
            };
            _this.eventMappingInvert[MouseEvent.DOUBLE_CLICK] = MouseEvent$1.DOUBLE_CLICK;
            _this.eventMapping[MouseEvent$1.DOUBLE_CLICK] = {
                adaptedType: MouseEvent.DOUBLE_CLICK,
                addListener: _this.initMouseListener,
                removeListener: _this.removeMouseListener,
                callback: _this._mouseCallbackDelegate
            };
            _this.eventMappingInvert[MouseEvent.CLICK] = MouseEvent$1.CLICK;
            _this.eventMapping[MouseEvent$1.CLICK] = {
                adaptedType: MouseEvent.CLICK,
                addListener: _this.initMouseListener,
                removeListener: _this.removeMouseListener,
                callback: _this._mouseCallbackDelegate
            };
            return _this;
            /*this.eventMappingInvert[MouseEventAway.MOUSE_OUT]=MouseEvent.ROLL_OUT;
            this.eventMapping[MouseEvent.ROLL_OUT]=(<IEventMapper>{
                adaptedType:MouseEventAway.MOUSE_OUT,
                addListener:this.initMouseListener,
                removeListener:this.removeMouseListener,
                callback:this._mouseCallbackDelegate});
                
            this.eventMappingInvert[MouseEventAway.MOUSE_OVER]=MouseEvent.ROLL_OVER;
            this.eventMapping[MouseEvent.ROLL_OVER]=(<IEventMapper>{
                adaptedType:MouseEventAway.MOUSE_OVER,
                addListener:this.initMouseListener,
                removeListener:this.removeMouseListener,
                callback:this._mouseCallbackDelegate});*/
        }
        // ---------- event mapping functions for KeyboardEvent.KEY_UP:
        InteractiveObject.prototype.initKeyUpListener = function (type, callback) {
            document.addEventListener("keyup", callback);
            document.addEventListener("keypress", callback);
        };
        InteractiveObject.prototype.removeKeyUpListener = function (type, callback) {
            document.removeEventListener("keyup", callback);
        };
        InteractiveObject.prototype.keyUpCallback = function (event) {
            if (event === void 0) { event = null; }
            if (window.event) {
                window.event.returnValue = false;
            }
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            var newkeyBoardEvent = new this.sec.flash.events.KeyboardEvent(KeyboardEvent$1.KEY_UP, true, false, event.charCode, event.keyCode, event.location, event.ctrlKey, event.altKey, event.shiftKey);
            /*(<any>newkeyBoardEvent).axInitializer(KeyboardEvent.KEY_UP);
            newkeyBoardEvent.keyCode = event.keyCode;
            newkeyBoardEvent.charCode = event.charCode;
            newkeyBoardEvent.shiftKey = event.shiftKey;
            newkeyBoardEvent.ctrlKey = event.ctrlKey;
            newkeyBoardEvent.altKey = event.altKey;*/
            this.dispatchEvent(newkeyBoardEvent);
            return false;
        };
        // ---------- event mapping functions for KeyboardEvent.KEY_DOWN:
        InteractiveObject.prototype.initKeyDownListener = function (type, callback) {
            document.addEventListener("keydown", callback);
            document.addEventListener("keypress", callback);
        };
        InteractiveObject.prototype.removeKeyDownListener = function (type, callback) {
            document.removeEventListener("keydown", callback);
            document.removeEventListener("keypress", callback);
        };
        InteractiveObject.prototype.keyDownCallback = function (event) {
            if (event === void 0) { event = null; }
            if (window.event) {
                window.event.returnValue = false;
            }
            event.preventDefault ? event.preventDefault() : (event.returnValue = false);
            var newkeyBoardEvent = new this.sec.flash.events.KeyboardEvent(KeyboardEvent$1.KEY_DOWN);
            newkeyBoardEvent.axInitializer(KeyboardEvent$1.KEY_DOWN);
            //newkeyBoardEvent.type=KeyboardEvent.KEY_DOWN;
            newkeyBoardEvent.keyCode = event.keyCode;
            newkeyBoardEvent.charCode = event.charCode;
            newkeyBoardEvent.shiftKey = event.shiftKey;
            newkeyBoardEvent.ctrlKey = event.ctrlKey;
            newkeyBoardEvent.altKey = event.altKey;
            this.dispatchEvent(newkeyBoardEvent);
            return false;
        };
        // ---------- event mapping functions for MouseEvents:
        InteractiveObject.prototype.initMouseListener = function (type, callback) {
            this.adaptee.addEventListener(type, callback);
        };
        InteractiveObject.prototype.removeMouseListener = function (type, callback) {
            this.adaptee.removeEventListener(type, callback);
        };
        InteractiveObject.prototype.mouseCallback = function (event) {
            var adaptedEvent = new this.sec.flash.events.MouseEvent(this.eventMappingInvert[event.type]);
            adaptedEvent.fillFromAway(event);
            adaptedEvent.target = this;
            //adaptedEvent.currentTarget=this;
            this.dispatchEvent(adaptedEvent);
        };
        Object.defineProperty(InteractiveObject.prototype, "accessibilityImplementation", {
            //---------------------------stuff added to make it work:
            //---------------------------original as3 properties / methods:
            /**
             * The current accessibility implementation (AccessibilityImplementation)
             * for this InteractiveObject instance.
             * @langversion	3.0
             */
            get: function () {
                console.log("accessibilityImplementation not implemented yet in flash/InteractiveObject");
                //todo flash.accessibility.AccessibilityImplementation;
                return null;
            },
            set: function (value) {
                //todo
                console.log("accessibilityImplementation not implemented yet in flash/InteractiveObject");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InteractiveObject.prototype, "contextMenu", {
            /**
             * Specifies the context menu associated with this object.
             *
             *   For content running in Flash Player, this property is a ContextMenu object. In the AIR runtime,
             * the ContextMenu class extends the NativeMenu class, however Flash Player only supports the
             * ContextMenu class, not the NativeMenu class.
             * Note: TextField objects always include a clipboard menu in the context menu. The clipboard menu contains
             * Cut, Copy, Paste, Clear, and Select All commands. You cannot remove these commands from the context menu for TextField objects.
             * For TextField objects, selecting these commands (or their keyboard equivalents) does not generate clear,
             * copy, cut, paste, or selectAll events.
             */
            get: function () {
                console.log("contextMenu not implemented yet in flash/InteractiveObject");
                //todo flash.display.NativeMenu;
                return null;
            },
            set: function (cm) {
                //todo
                console.log("contextMenu not implemented yet in flash/InteractiveObject");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InteractiveObject.prototype, "doubleClickEnabled", {
            /**
             * Specifies whether the object receives doubleClick events. The default value
             * is false, which means that by default an InteractiveObject instance does not receive
             * doubleClick events. If the doubleClickEnabled property is set to
             * true, the instance receives doubleClick events within its bounds.
             * The mouseEnabled property of the InteractiveObject instance must also be
             * set to true for the object to receive doubleClick events.
             *
             *   No event is dispatched by setting this property. You must use the
             * addEventListener() method to add an event listener
             * for the doubleClick event.
             */
            get: function () {
                //todo
                console.log("doubleClickEnabled not implemented yet in flash/InteractiveObject");
                return false;
            },
            set: function (enabled) {
                //todo
                console.log("doubleClickEnabled not implemented yet in flash/InteractiveObject");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InteractiveObject.prototype, "focusRect", {
            /**
             * Specifies whether this object displays a focus rectangle. It can take one of three
             * values: true, false, or null. Values of true
             * and false work as expected, specifying whether or not the focus rectangle
             * appears. A value of null indicates that this object obeys the
             * stageFocusRect property of the Stage.
             */
            get: function () {
                //todo
                console.log("focusRect not implemented yet in flash/InteractiveObject");
                return null;
            },
            set: function (focusRect) {
                //todo
                console.log("focusRect not implemented yet in flash/InteractiveObject");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InteractiveObject.prototype, "mouseEnabled", {
            /**
             * Specifies whether this object receives mouse, or other user input, messages. The default value is true,
             * which means that by default any InteractiveObject instance that is on the display list
             * receives mouse events or other user input events.
             * If mouseEnabled is set to false, the instance does not receive any
             * mouse events (or other user input events like keyboard events). Any children of this instance on the display list are not affected. To change
             * the mouseEnabled behavior for all children of an object on the display list, use
             * flash.display.DisplayObjectContainer.mouseChildren.
             * No event is dispatched by setting this property. You must use the
             * addEventListener() method to create interactive functionality.
             */
            //private _mouseEnabled:boolean=true;
            get: function () {
                return this.adaptee.mouseEnabled;
            },
            set: function (enabled) {
                this.adaptee.mouseEnabled = enabled;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InteractiveObject.prototype, "needsSoftKeyboard", {
            /**
             * Specifies whether a virtual keyboard (an on-screen, software keyboard) should display
             * when this InteractiveObject instance receives focus.
             *
             *   By default, the value is false and focusing an InteractiveObject instance does
             * not raise a soft keyboard. If the needsSoftKeyboard property is set to true,
             * the runtime raises a soft keyboard when the InteractiveObject instance is ready to accept user input.
             * An InteractiveObject instance is ready to accept user input after a programmatic call to set the Stage
             * focus property or a user interaction, such as a "tap." If the client system has a
             * hardware keyboard available or does not support virtual keyboards, then the soft keyboard is not raised.The InteractiveObject instance dispatches softKeyboardActivating,
             * softKeyboardActivate, and softKeyboardDeactivate events
             * when the soft keyboard raises and lowers.Note: This property is not supported in AIR applications on iOS.
             */
            get: function () {
                //todo
                console.log("needsSoftKeyboard not implemented yet in flash/InteractiveObject");
                return false;
            },
            set: function (value) {
                //todo
                console.log("needsSoftKeyboard not implemented yet in flash/InteractiveObject");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InteractiveObject.prototype, "softKeyboardInputAreaOfInterest", {
            /**
             * Defines the area that should remain on-screen when a soft keyboard is displayed.
             *
             *   If the needsSoftKeyboard property of this InteractiveObject is
             * true, then the runtime adjusts the display as needed to keep the
             * object in view while the user types. Ordinarily, the runtime uses the object
             * bounds obtained from the DisplayObject.getBounds() method. You can
             * specify a different area using this softKeyboardInputAreaOfInterest
             * property.Specify the softKeyboardInputAreaOfInterest in stage coordinates.Note: On Android, the softKeyboardInputAreaOfInterest is not
             * respected in landscape orientations.
             */
            get: function () {
                //todo
                console.log("softKeyboardInputAreaOfInterest not implemented yet in flash/InteractiveObject");
                return null;
            },
            set: function (value) {
                //todo
                console.log("softKeyboardInputAreaOfInterest not implemented yet in flash/InteractiveObject");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InteractiveObject.prototype, "tabEnabled", {
            /**
             * Specifies whether this object is in the tab order. If this object is in the tab order,
             * the value is true; otherwise, the value is false. By default,
             * the value is false, except for the following:
             * For a SimpleButton object, the value is true.For a TextField object with type = "input", the value is true.For a Sprite object or MovieClip object with buttonMode = true, the value is true.
             */
            get: function () {
                //todo
                //console.log("tabEnabled not implemented yet in flash/InteractiveObject");
                return false;
            },
            set: function (enabled) {
                //todo
                //console.log("tabEnabled not implemented yet in flash/InteractiveObject");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(InteractiveObject.prototype, "tabIndex", {
            /**
             * Specifies the tab ordering of objects in a SWF file. The tabIndex
             * property is -1 by default, meaning no tab index is set for the object.
             *
             *   If any currently displayed object in the SWF file contains a tabIndex property, automatic
             * tab ordering is disabled, and the tab ordering is calculated from the tabIndex properties of
             * objects in the SWF file. The custom tab ordering includes only objects that have tabIndex
             * properties.The tabIndex property can be a non-negative integer. The objects are ordered according to
             * their tabIndex properties, in ascending order. An object with a tabIndex
             * value of 1 precedes an object with a tabIndex value of 2. Do not use the same tabIndex
             *
             *   value for multiple objects.The custom tab ordering that the tabIndex property defines is flat.
             * This means that no attention is paid to the hierarchical relationships of objects in the SWF file.
             * All objects in the SWF file with tabIndex properties are placed in the tab order, and the
             * tab order is determined by the order of the tabIndex values. Note: To set the tab order for TLFTextField instances, cast the display object child
             * of the TLFTextField as an InteractiveObject, then set the tabIndex property. For example:
             *
             *   InteractiveObject(tlfInstance.getChildAt(1)).tabIndex = 3;
             *
             *   To reverse the tab order from the default setting for three instances of a TLFTextField object
             * (tlfInstance1, tlfInstance2 and tlfInstance3), use:
             *
             *   InteractiveObject(tlfInstance1.getChildAt(1)).tabIndex = 3;
             * InteractiveObject(tlfInstance2.getChildAt(1)).tabIndex = 2;
             * InteractiveObject(tlfInstance3.getChildAt(1)).tabIndex = 1;
             */
            get: function () {
                //todo
                console.log("tabIndex not implemented yet in flash/InteractiveObject");
                return 0;
            },
            set: function (index) {
                //todo
                console.log("tabIndex not implemented yet in flash/InteractiveObject");
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Raises a virtual keyboard.
         *
         *   Calling this method focuses the InteractiveObject instance and raises the soft keyboard, if necessary.
         * The needsSoftKeyboard must also be true. A keyboard is not raised
         * if a hardware keyboard is available, or if the client system does not support virtual keyboards.Note: This method is not supported in AIR applications on iOS.
         * @return	A value of true means that the soft keyboard request was granted; false means that the soft keyboard was not raised.
         */
        InteractiveObject.prototype.requestSoftKeyboard = function () {
            //todo
            console.log("requestSoftKeyboard not implemented yet in flash/InteractiveObject");
            return false;
        };
        return InteractiveObject;
    }(DisplayObject$1));

    var DisplayObjectContainer$1 = /** @class */ (function (_super) {
        __extends(DisplayObjectContainer$$1, _super);
        /**
         * The DisplayObjectContainer class is the base class for all objects that can serve as display object containers on
         * the display list. The display list manages all objects displayed in the Flash runtimes.
         * Use the DisplayObjectContainer class to arrange the display objects in the display list.
         * Each DisplayObjectContainer object has its own child list for organizing the z-order of the objects.
         * The z-order is the front-to-back order that determines which object is drawn in front, which is behind,
         * and so on.
         *
         *   <p class="- topic/p ">DisplayObject is an abstract base class; therefore, you cannot call DisplayObject directly. Invoking
         * <codeph class="+ topic/ph pr-d/codeph ">new DisplayObject()</codeph> throws an <codeph class="+ topic/ph pr-d/codeph ">ArgumentError</codeph> exception.</p>
         *
         *   The DisplayObjectContainer class is an abstract base class for all objects that can contain child objects.
         * It cannot be instantiated directly; calling the <codeph class="+ topic/ph pr-d/codeph ">new DisplayObjectContainer()</codeph> constructor
         * throws an <codeph class="+ topic/ph pr-d/codeph ">ArgumentError</codeph> exception.
         *
         *   <p class="- topic/p ">For more information, see the "Display Programming" chapter of the <i class="+ topic/ph hi-d/i ">ActionScript 3.0 Developer's Guide</i>.</p>

         /**
         * Calling the new DisplayObjectContainer() constructor throws an
         * ArgumentError exception. You can, however, call constructors for
         * the following subclasses of DisplayObjectContainer:
         *
         *   new Loader()new Sprite()new MovieClip()
         */
        function DisplayObjectContainer$$1() {
            return _super.call(this) || this;
        }
        DisplayObjectContainer$$1.prototype.addTimelineObjectAtDepth = function (child, depth) {
        };
        DisplayObjectContainer$$1.prototype.getTimelineObjectAtDepth = function (depth) {
            return null;
        };
        DisplayObjectContainer$$1.prototype._lookupChildByName = function (name, lookupOptions) {
            if (lookupOptions === void 0) { lookupOptions = null; }
        };
        DisplayObjectContainer$$1.prototype._lookupChildByIndex = function (idx, lookupOptions) {
            if (lookupOptions === void 0) { lookupOptions = null; }
        };
        DisplayObjectContainer$$1.prototype.createAdaptee = function () {
            return new DisplayObjectContainer();
        };
        //---------------------------stuff added to make it work:
        DisplayObjectContainer$$1.prototype.clone = function () {
            if (!this._symbol) {
                throw ("_symbol not defined when cloning movieclip");
            }
            //var clone: MovieClip = MovieClip.getNewMovieClip(AwayMovieClip.getNewMovieClip((<AwayMovieClip>this.adaptee).timeline));
            var clone = constructClassFromSymbol(this._symbol, this._symbol.symbolClass);
            clone.axInitializer();
            this.adaptee.copyTo(clone.adaptee);
            return clone;
        };
        /* gets called from stage in order to move the playhead of the root-movieclips to next frame.
         the DisplayObjectContainer should call this function on all children if they extend DisplayObjectContainer themself.
         if any child is a MovieClip this function will not be called on its childrens adapter.
         */
        DisplayObjectContainer$$1.prototype.advanceFrame = function (events) {
            var i = this._adaptee._children.length;
            while (i > 0) {
                i--;
                var oneChild = this._adaptee._children[i];
                if (oneChild) {
                    if (oneChild.isAsset(DisplayObjectContainer)) {
                        if (oneChild.adapter) {
                            oneChild.adapter.advanceFrame(events);
                        }
                    }
                    else if (oneChild.isAsset(Sprite)) {
                        if (oneChild.adapter && oneChild.adapter.advanceFrame) {
                            // when Flash constructs Sprites for "Shape" it will not include the DispayObjectContainer in the inheritance chain
                            oneChild.adapter.advanceFrame(events);
                        }
                    }
                    else if (oneChild.isAsset(MovieClip)) {
                        oneChild.update();
                    }
                }
            }
        };
        DisplayObjectContainer$$1.prototype.dispatchQueuedEvents = function () {
            _super.prototype.dispatchQueuedEvents.call(this);
            for (var i = 0; i < this._adaptee.numChildren; i++) {
                var oneChild = this._adaptee.getChildAt(i);
                if (oneChild && oneChild.adapter && oneChild.adapter.dispatchQueuedEvents)
                    oneChild.adapter.dispatchQueuedEvents();
            }
        };
        DisplayObjectContainer$$1.prototype.debugDisplayGraph = function (obj) {
            obj.object = this;
            obj.rectangle = "x:" + this.x + ", y:" + this.y + ", width:" + this.width + ", height:" + this.height;
            obj.children = {};
            var i = 0;
            for (i = 0; i < this._adaptee.numChildren; i++) {
                var oneChild = this._adaptee.getChildAt(i);
                var childname = "child_" + i + " " + oneChild.adapter.constructor.name;
                if (oneChild.isAsset(Sprite) || oneChild.isAsset(DisplayObjectContainer)) {
                    if (oneChild.adapter) {
                        obj.children[childname] = {};
                        oneChild.adapter.debugDisplayGraph(obj.children[childname]);
                    }
                }
                else if (oneChild.isAsset(Billboard)) {
                    obj.children[childname] = {};
                    obj.children[childname].object = oneChild.adapter;
                    obj.children[childname].name = oneChild.name;
                    obj.children[childname].rectangle = "x:" + oneChild.x + ", y:" + oneChild.y; //+", width:"+oneChild.width+", height:"+oneChild.height;
                    /*var box:Box = PickGroup.getInstance(this._stage.view).getBoundsPicker(oneChild.partition).getBoxBounds(oneChild);
                    obj.children[childname].width=(box == null)? 0 : box.width;
                    obj.children[childname].height=(box == null)? 0 : box.height;*/
                    //(<AwayMovieClip>oneChild).graphics.endFill();
                    //console.log("Reached MC", oneChild);
                    //(<AwayMovieClip>oneChild).update();
                }
                else if (oneChild.isAsset(MovieClip)) {
                    obj.children[childname] = {};
                    obj.children[childname].object = oneChild.adapter;
                    obj.children[childname].name = oneChild.name;
                    obj.children[childname].rectangle = "x:" + oneChild.x + ", y:" + oneChild.y; //+", width:"+oneChild.width+", height:"+oneChild.height;
                    /*var box:Box = PickGroup.getInstance(this._stage.view).getBoundsPicker(oneChild.partition).getBoxBounds(oneChild);
                    obj.children[childname].width=(box == null)? 0 : box.width;
                    obj.children[childname].height=(box == null)? 0 : box.height;*/
                    //(<AwayMovieClip>oneChild).graphics.endFill();
                    //console.log("Reached MC", oneChild);
                    //(<AwayMovieClip>oneChild).update();
                }
                else if (oneChild.isAsset(TextField)) {
                    obj.children[childname] = {};
                    obj.children[childname].object = oneChild.adapter;
                    obj.children[childname].text = oneChild.text;
                    obj.children[childname].rectangle = "x:" + oneChild.x + ", y:" + oneChild.y; //+", width:"+oneChild.width+", height:"+oneChild.height;
                    var box = PickGroup.getInstance(this._stage.view).getBoundsPicker(oneChild.partition).getBoxBounds(oneChild);
                    obj.children[childname].width = (box == null) ? 0 : box.width;
                    obj.children[childname].height = (box == null) ? 0 : box.height;
                    //(<AwayMovieClip>oneChild).graphics.endFill();
                    //console.log("Reached MC", oneChild);
                    //(<AwayMovieClip>oneChild).update();
                }
            }
        };
        Object.defineProperty(DisplayObjectContainer$$1.prototype, "mouseChildren", {
            /*
            //	overwrite
            public dispatchEventRecursive(event:Event) {
                this.dispatchEvent(event);
        
                if((<AwayDisplayObjectContainer> this._adaptee)){
                    var i:number=(<AwayDisplayObjectContainer> this._adaptee).numChildren;
                    while(i>0){
                        i--;
                        var oneChild:AwayDisplayObject=(<AwayDisplayObjectContainer> this._adaptee).getChildAt(i);
                        if(oneChild.adapter){
                            (<DisplayObject>oneChild.adapter).dispatchEventRecursive(event);
                        }
                    }
                }
            };
            */
            //---------------------------original as3 properties / methods:
            /**
             * Determines whether or not the children of the object are mouse, or user input device, enabled.
             * If an object is enabled, a user can interact with it by using a mouse or user input device. The default is true.
             *
             *   This property is useful when you create a button with an instance of the Sprite class
             * (instead of using the SimpleButton class). When you use a Sprite instance to create a button,
             * you can choose to decorate the button by using the addChild() method to add additional
             * Sprite instances. This process can cause unexpected behavior with mouse events because
             * the Sprite instances you add as children can become the target object of a mouse event
             * when you expect the parent instance to be the target object. To ensure that the parent
             * instance serves as the target objects for mouse events, you can set the
             * mouseChildren property of the parent instance to false. No event is dispatched by setting this property. You must use the
             * addEventListener() method to create interactive functionality.
             * @langversion	3.0
             * @playerversion	Flash 9
             * @playerversion	Lite 4
             */
            get: function () {
                return this._adaptee.mouseChildren;
            },
            set: function (enable) {
                this._adaptee.mouseChildren = enable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObjectContainer$$1.prototype, "numChildren", {
            /**
             * Returns the number of children of this object.
             * @langversion	3.0
             * @playerversion	Flash 9
             * @playerversion	Lite 4
             */
            get: function () {
                return this._adaptee.numChildren;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObjectContainer$$1.prototype, "tabChildren", {
            /**
             * Determines whether the children of the object are tab enabled. Enables or disables tabbing for the
             * children of the object. The default is true.
             * Note: Do not use the tabChildren property with Flex.
             * Instead, use the mx.core.UIComponent.hasFocusableChildren property.
             * @langversion	3.0
             * @playerversion	Flash 9
             * @playerversion	Lite 4
             * @throws	IllegalOperationError Calling this property of the Stage object
             *   throws an exception. The Stage object does not implement this property.
             */
            get: function () {
                //todo
                //console.warn("tabChildren not implemented yet in flash/DisplayObjectContainer");
                return false;
            },
            set: function (enable) {
                //console.warn("tabChildren not implemented yet in flash/DisplayObjectContainer");
                //todo
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplayObjectContainer$$1.prototype, "textSnapshot", {
            /**
             * Returns a TextSnapshot object for this DisplayObjectContainer instance.
             * @langversion	3.0
             * @playerversion	Flash 9
             */
            get: function () {
                throw ("textSnapshot not implemented yet in flash/DisplayObjectContainer");
                // todo: flash.text.TextSnapshot;
                //return null;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Adds a child DisplayObject instance to this DisplayObjectContainer instance. The child is added
         * to the front (top) of all other children in this DisplayObjectContainer instance. (To add a child to a
         * specific index position, use the addChildAt() method.)
         *
         *   If you add a child object that already has a different display object container as
         * a parent, the object is removed from the child list of the other display object container. Note: The command stage.addChild() can cause problems with a published SWF file,
         * including security problems and conflicts with other loaded SWF files. There is only one Stage within a Flash runtime instance,
         * no matter how many SWF files you load into the runtime. So, generally, objects
         * should not be added to the Stage, directly, at all. The only object the Stage should
         * contain is the root object. Create a DisplayObjectContainer to contain all of the items on the
         * display list. Then, if necessary, add that DisplayObjectContainer instance to the Stage.
         * @param	child	The DisplayObject instance to add as a child of this DisplayObjectContainer instance.
         * @return	The DisplayObject instance that you pass in the
         *   child parameter.
         * @throws	ArgumentError Throws if the child is the same as the parent.  Also throws if
         *   the caller is a child (or grandchild etc.) of the child being added.
         */
        DisplayObjectContainer$$1.prototype.addChild = function (child) {
            //child.dispatchEventRecursive(new Event(Event.ADDED_TO_STAGE));
            child.noReset = true;
            this._adaptee.addChild(child.adaptee);
            child.noReset = false;
            child.dispatchStaticEvent(Event.ADDED);
            child.dispatchStaticEvent(Event.ADDED_TO_STAGE);
            //child.dispatchStaticEvent(Event.FRAME_CONSTRUCTED);
            OrphanManager.removeOrphan(child);
            return child;
        };
        /**
         * Adds a child DisplayObject instance to this DisplayObjectContainer
         * instance.  The child is added
         * at the index position specified. An index of 0 represents the back (bottom)
         * of the display list for this DisplayObjectContainer object.
         *
         *   For example, the following example shows three display objects, labeled a, b, and c, at
         * index positions 0, 2, and 1, respectively:If you add a child object that already has a different display object container as
         * a parent, the object is removed from the child list of the other display object container.
         * @param	child	The DisplayObject instance to add as a child of this
         *   DisplayObjectContainer instance.
         * @param	index	The index position to which the child is added. If you specify a
         *   currently occupied index position, the child object that exists at that position and all
         *   higher positions are moved up one position in the child list.
         * @return	The DisplayObject instance that you pass in the
         *   child parameter.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @throws	RangeError Throws if the index position does not exist in the child list.
         * @throws	ArgumentError Throws if the child is the same as the parent.  Also throws if
         *   the caller is a child (or grandchild etc.) of the child being added.
         */
        DisplayObjectContainer$$1.prototype.addChildAt = function (child, index) {
            //child.dispatchEventRecursive(new Event(Event.ADDED_TO_STAGE));
            // todo: this should be done much more efficient (in awayjs)
            var allChildren = [];
            child.noReset = true;
            for (var i = 0; i < this._adaptee.numChildren; i++) {
                if (child.adaptee.id != this._adaptee._children[i].id) {
                    allChildren[allChildren.length] = this._adaptee._children[i];
                }
            }
            for (i = 0; i < allChildren.length; i++) {
                this._adaptee.removeChild(allChildren[i]);
            }
            var newChildCnt = 0;
            for (i = 0; i < allChildren.length + 1; i++) {
                if (i == index) {
                    this._adaptee.addChild(child.adaptee);
                }
                else {
                    allChildren[newChildCnt].adapter.noReset = true;
                    this._adaptee.addChild(allChildren[newChildCnt++]);
                }
            }
            child.noReset = false;
            child.dispatchStaticEvent(Event.ADDED);
            child.dispatchStaticEvent(Event.ADDED_TO_STAGE);
            //child.dispatchStaticEvent(Event.FRAME_CONSTRUCTED);
            //(<AwayDisplayObjectContainer>(<AwayDisplayObjectContainer> this._adaptee)).addChildAt(child.adaptee, index);
            return child;
        };
        /**
         * Indicates whether the security restrictions
         * would cause any display objects to be omitted from the list returned by calling
         * the DisplayObjectContainer.getObjectsUnderPoint() method
         * with the specified point point. By default, content from one domain cannot
         * access objects from another domain unless they are permitted to do so with a call to the
         * Security.allowDomain() method. For more information, related to security,
         * see the Flash Player Developer Center Topic:
         * Security.
         *
         *   The point parameter is in the coordinate space of the Stage,
         * which may differ from the coordinate space of the display object container (unless the
         * display object container is the Stage). You can use the globalToLocal() and
         * the localToGlobal() methods to convert points between these coordinate
         * spaces.
         * @param	point	The point under which to look.
         * @return	true if the point contains child display objects with security restrictions.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         */
        DisplayObjectContainer$$1.prototype.areInaccessibleObjectsUnderPoint = function (point) {
            //todo
            throw ("areInaccessibleObjectsUnderPoint not implemented yet in flash/DisplayObjectContainer");
            //return false;
        };
        /**
         * Determines whether the specified display object is a child of the DisplayObjectContainer instance or
         * the instance itself.
         * The search includes the entire display list including this DisplayObjectContainer instance. Grandchildren,
         * great-grandchildren, and so on each return true.
         * @param	child	The child object to test.
         * @return	true if the child object is a child of the DisplayObjectContainer
         *   or the container itself; otherwise false.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         */
        DisplayObjectContainer$$1.prototype.contains = function (child) {
            return this._adaptee.contains(child.adaptee);
        };
        /**
         * Returns the child display object instance that exists at the specified index.
         * @param	index	The index position of the child object.
         * @return	The child display object at the specified index position.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @throws	RangeError Throws if the index does not exist in the child list.
         * @throws	SecurityError This child display object belongs to a sandbox
         *   to which you do not have access. You can avoid this situation by having
         *   the child movie call Security.allowDomain().
         */
        DisplayObjectContainer$$1.prototype.getChildAt = function (index) {
            var child = this._adaptee.getChildAt(index);
            if (!child.adapter || child.adapter == child) {
                child.adapter = this.sec.flash.display.Sprite(child);
            }
            return child.adapter;
        };
        /**
         * Returns the child display object that exists with the specified name.
         * If more that one child display object has the specified name,
         * the method returns the first object in the child list.
         *
         *   The getChildAt() method is faster than the
         * getChildByName() method. The getChildAt() method accesses
         * a child from a cached array, whereas the getChildByName() method
         * has to traverse a linked list to access a child.
         * @param	name	The name of the child to return.
         * @return	The child display object with the specified name.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @throws	SecurityError This child display object belongs to a sandbox
         *   to which you do not have access. You can avoid this situation by having
         *   the child movie call the Security.allowDomain() method.
         */
        DisplayObjectContainer$$1.prototype.getChildByName = function (name) {
            return this._adaptee.getChildByName(name) ? this._adaptee.getChildByName(name).adapter : null;
        };
        /**
         * Returns the index position of a child DisplayObject instance.
         * @param	child	The DisplayObject instance to identify.
         * @return	The index position of the child display object to identify.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @throws	ArgumentError Throws if the child parameter is not a child of this object.
         */
        DisplayObjectContainer$$1.prototype.getChildIndex = function (child) {
            return this._adaptee.getChildIndex(child.adaptee);
        };
        /**
         * Returns an array of objects that lie under the specified point and are children
         * (or grandchildren, and so on) of this DisplayObjectContainer instance. Any child objects that
         * are inaccessible for security reasons are omitted from the returned array. To determine whether
         * this security restriction affects the returned array, call the
         * areInaccessibleObjectsUnderPoint() method.
         *
         *   The point parameter is in the coordinate space of the Stage,
         * which may differ from the coordinate space of the display object container (unless the
         * display object container is the Stage). You can use the globalToLocal() and
         * the localToGlobal() methods to convert points between these coordinate
         * spaces.
         * @param	point	The point under which to look.
         * @return	An array of objects that lie under the specified point and are children
         *   (or grandchildren, and so on) of this DisplayObjectContainer instance.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         */
        DisplayObjectContainer$$1.prototype.getObjectsUnderPoint = function (point) {
            var children = [];
            this._getObjectsUnderPointInternal(point, children);
            return children;
        };
        DisplayObjectContainer$$1.prototype._getObjectsUnderPointInternal = function (point, children) {
            var numChildren = this._adaptee.numChildren;
            var child;
            for (var i = 0; i < numChildren; i++) {
                child = this._adaptee._children[i];
                if (child.visible) {
                    if (PickGroup.getInstance(this._stage.view).getBoundsPicker(child.adaptee.partition).hitTestPoint(point.x, point.y, true))
                        children.push(child.adapter);
                    child.adapter._getObjectsUnderPointInternal(point, children);
                }
            }
        };
        /**
         * Removes the specified child DisplayObject instance from the child list of the DisplayObjectContainer instance.
         * The parent property of the removed child is set to null
         * , and the object is garbage collected if no other
         * references to the child exist. The index positions of any display objects above the child in the
         * DisplayObjectContainer are decreased by 1.
         *
         *   The garbage collector reallocates unused memory space. When a variable
         * or object is no longer actively referenced or stored somewhere, the garbage collector sweeps
         * through and wipes out the memory space it used to occupy if no other references to it exist.
         * @param	child	The DisplayObject instance to remove.
         * @return	The DisplayObject instance that you pass in the
         *   child parameter.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @throws	ArgumentError Throws if the child parameter is not a child of this object.
         */
        DisplayObjectContainer$$1.prototype.removeChild = function (child) {
            //child.dispatchEventRecursive(new Event(Event.REMOVED_FROM_STAGE));
            child.dispatchStaticEvent(Event.REMOVED);
            this._adaptee.removeChild(child.adaptee);
            //console.log("removeChild not implemented yet in flash/DisplayObjectContainer");
            return child;
        };
        /**
         * Removes a child DisplayObject from the specified index position in the child list of
         * the DisplayObjectContainer. The parent property of the removed child is set to
         * null, and the object is garbage collected if no other references to the child exist. The index
         * positions of any display objects above the child in the DisplayObjectContainer are decreased by 1.
         *
         *   The garbage collector reallocates unused memory space. When a variable or
         * object is no longer actively referenced or stored somewhere, the garbage collector sweeps
         * through and wipes out the memory space it used to occupy if no other references to it exist.
         * @param	index	The child index of the DisplayObject to remove.
         * @return	The DisplayObject instance that was removed.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @throws	SecurityError This child display object belongs to a sandbox
         *   to which the calling object does not have access. You can avoid this situation by having
         *   the child movie call the Security.allowDomain() method.
         * @throws	RangeError Throws if the index does not exist in the child list.
         */
        DisplayObjectContainer$$1.prototype.removeChildAt = function (index) {
            var awayChild = this._adaptee.removeChildAt(index);
            var childadapter = awayChild.adapter;
            //childadapter.dispatchEventRecursive(new Event(Event.REMOVED_FROM_STAGE));
            childadapter.dispatchEvent(new Event(Event.REMOVED));
            //console.log("removeChildAt not implemented yet in flash/DisplayObjectContainer");
            return childadapter;
        };
        DisplayObjectContainer$$1.prototype.removeChildren = function (beginIndex, endIndex) {
            if (beginIndex === void 0) { beginIndex = 0; }
            if (endIndex === void 0) { endIndex = 2147483647; }
            if (endIndex >= this._adaptee.numChildren) {
                endIndex = this._adaptee.numChildren - 1;
            }
            for (var i = beginIndex; i <= endIndex; i++) {
                var oneChild = this._adaptee._children[i];
                if (oneChild.adapter) {
                    //(<DisplayObject>oneChild.adapter).dispatchEventRecursive(new Event(Event.REMOVED_FROM_STAGE));
                    oneChild.adapter.dispatchStaticEvent(Event.REMOVED);
                }
            }
            this._adaptee.removeChildren(beginIndex, endIndex + 1);
            //console.log("removeChildren not implemented yet in flash/DisplayObjectContainer");
        };
        /**
         * Changes the  position of an existing child in the display object container.
         * This affects the layering of child objects. For example, the following example shows three
         * display objects, labeled a, b, and c, at index positions 0, 1, and 2, respectively:
         *
         *   When you use the setChildIndex() method and specify an index position
         * that is already occupied, the only positions that change are those in between the display object's former and new position.
         * All others will stay the same.
         * If a child is moved to an index LOWER than its current index, all children in between will INCREASE by 1 for their index reference.
         * If a child is moved to an index HIGHER than its current index, all children in between will DECREASE by 1 for their index reference.
         * For example, if the display object container
         * in the previous example is named container, you can swap the position
         * of the display objects labeled a and b by calling the following code:
         * <codeblock>
         * container.setChildIndex(container.getChildAt(1), 0);
         * </codeblock>
         * This code results in the following arrangement of objects:
         * @param	child	The child DisplayObject instance for which you want to change
         *   the index number.
         * @param	index	The resulting index number for the child display object.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @throws	RangeError Throws if the index does not exist in the child list.
         * @throws	ArgumentError Throws if the child parameter is not a child of this object.
         */
        DisplayObjectContainer$$1.prototype.setChildIndex = function (child, index) {
            // todo: this should be done much more efficient (in awayjs)
            var allChildren = [];
            for (var i = 0; i < this._adaptee.numChildren; i++) {
                allChildren[allChildren.length] = this._adaptee._children[i];
            }
            for (i = 0; i < allChildren.length; i++) {
                this._adaptee.removeChild(allChildren[i]);
            }
            child.noReset = true;
            var newChildCnt = 0;
            var oldChild;
            for (i = 0; i < allChildren.length; i++) {
                if (i == index) {
                    this._adaptee.addChild(child.adaptee);
                }
                else {
                    oldChild = allChildren[newChildCnt++];
                    oldChild.adapter.noReset = true;
                    if (oldChild.id != child.adaptee.id) {
                        this._adaptee.addChild(oldChild);
                    }
                    else {
                        oldChild = allChildren[newChildCnt++];
                        oldChild.adapter.noReset = true;
                        this._adaptee.addChild(oldChild);
                    }
                    oldChild.adapter.noReset = false;
                }
            }
            child.noReset = false;
        };
        DisplayObjectContainer$$1.prototype.stopAllMovieClips = function () {
            //todo
            throw ("stopAllMovieClips not implemented yet in flash/DisplayObjectContainer");
        };
        /**
         * Swaps the z-order (front-to-back order) of the two specified child objects.  All other child
         * objects in the display object container remain in the same index positions.
         * @param	child1	The first child object.
         * @param	child2	The second child object.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @throws	ArgumentError Throws if either child parameter is not a child of this object.
         */
        DisplayObjectContainer$$1.prototype.swapChildren = function (child1, child2) {
            this._adaptee.swapChildren(child1.adaptee, child2.adaptee);
        };
        /**
         * Swaps the z-order (front-to-back order) of the child objects at the two specified index positions in the
         * child list. All other child objects in the display object container remain in the same index positions.
         * @param	index1	The index position of the first child object.
         * @param	index2	The index position of the second child object.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @throws	RangeError If either index does not exist in the child list.
         */
        DisplayObjectContainer$$1.prototype.swapChildrenAt = function (index1, index2) {
            //todo
            throw ("swapChildrenAt not implemented yet in flash/DisplayObjectContainer");
        };
        return DisplayObjectContainer$$1;
    }(InteractiveObject));

    /**
     * The Bitmap class represents display objects that represent bitmap images. These can be images
     * that you load with the flash.display.Loader class, or they can be images that you create with
     * the <codeph class="+ topic/ph pr-d/codeph ">Bitmap()</codeph> constructor.
     *
     *   <p class="- topic/p ">The <codeph class="+ topic/ph pr-d/codeph ">Bitmap()</codeph> constructor allows you to create a Bitmap object that
     * contains a reference to a BitmapData object. After you create a Bitmap object, use the
     * <codeph class="+ topic/ph pr-d/codeph ">addChild()</codeph> or <codeph class="+ topic/ph pr-d/codeph ">addChildAt()</codeph> method of the parent DisplayObjectContainer
     * instance to place the bitmap on the display list.</p><p class="- topic/p ">A Bitmap object can share its BitmapData reference among several Bitmap objects,
     * independent of translation or rotation properties. Because you can create multiple Bitmap
     * objects that reference the same BitmapData object, multiple display objects can use the
     * same complex BitmapData object without incurring the memory overhead of a BitmapData
     * object for each display object instance.</p><p class="- topic/p ">A BitmapData object can be drawn to the screen by a Bitmap object in one of two ways:
     * by using the vector renderer as a fill-bitmap shape, or by using a faster pixel-copying routine.
     * The pixel-copying routine is substantially faster than the vector renderer, but the Bitmap object
     * must meet certain conditions to use it:</p><ul class="- topic/ul "><li class="- topic/li "> No stretching, rotation, or skewing can be applied to the Bitmap object.</li><li class="- topic/li "> No color transform can be applied to the Bitmap object. </li><li class="- topic/li "> No blend mode can be applied to the Bitmap object. </li><li class="- topic/li "> No clipping can be done through mask layers or <codeph class="+ topic/ph pr-d/codeph ">setMask()</codeph> methods. </li><li class="- topic/li "> The image itself cannot be a mask. </li><li class="- topic/li "> The destination coordinates must be on a whole pixel boundary. </li></ul><p class="- topic/p ">If you load a Bitmap object from a domain other than that of the Loader object used to
     * load the image, and there is no URL policy file that permits access to the domain of
     * the Loader object, then a script in that domain cannot access the Bitmap
     * object or its properties and methods. For more information, see the Flash Player Developer Center Topic:
     * <xref href="http://www.adobe.com/go/devnet_security_en" scope="external" class="- topic/xref ">Security</xref>.</p><p class="- topic/p "><b class="+ topic/ph hi-d/b ">Note:</b> The Bitmap class is not a subclass of the InteractiveObject class, so
     * it cannot dispatch mouse events. However, you can use the <codeph class="+ topic/ph pr-d/codeph ">addEventListener()</codeph> method
     * of the display object container that contains the Bitmap object.</p>
     */
    var Bitmap = /** @class */ (function (_super) {
        __extends(Bitmap, _super);
        /**
         * Initializes a Bitmap object to refer to the specified BitmapData object.
         * @param	bitmapData	The BitmapData object being referenced.
         * @param	pixelSnapping	Whether or not the Bitmap object is snapped to the nearest pixel.
         * @param	smoothing	Whether or not the bitmap is smoothed when scaled. For example, the
         *   following examples show the same bitmap scaled by a factor of 3, with
         *   smoothing set to false (left) and true (right):
         */
        function Bitmap(bitmapData, pixelSnapping, smoothing) {
            if (bitmapData === void 0) { bitmapData = null; }
            if (pixelSnapping === void 0) { pixelSnapping = "auto"; }
            if (smoothing === void 0) { smoothing = false; }
            var _this = this;
            var newMaterial = bitmapData ? new MethodMaterial(bitmapData.adaptee) : new MethodMaterial(0x0);
            newMaterial.alphaBlending = true;
            newMaterial.useColorTransform = true;
            Bitmap.argBitmapMaterial = newMaterial;
            Bitmap.argPixelSnapping = pixelSnapping;
            Bitmap.argSmoothing = smoothing;
            _this = _super.call(this) || this;
            _this._bitmapData = bitmapData;
            if (_this._bitmapData)
                _this._bitmapData._addOwner(_this);
            return _this;
        }
        Bitmap.getNewBitmap = function (bitmapData, pixelSnapping, smoothing) {
            if (bitmapData === void 0) { bitmapData = null; }
            if (pixelSnapping === void 0) { pixelSnapping = "auto"; }
            if (smoothing === void 0) { smoothing = false; }
            if (Bitmap._bitmaps.length) {
                var newMaterial = bitmapData ? new MethodMaterial(bitmapData.adaptee) : new MethodMaterial(0x0);
                newMaterial.alphaBlending = true;
                newMaterial.useColorTransform = true;
                var bitmap = Bitmap._bitmaps.pop();
                bitmap.adaptee = Billboard.getNewBillboard(newMaterial, pixelSnapping, smoothing);
                return bitmap;
            }
            return new Bitmap(bitmapData, pixelSnapping, smoothing);
        };
        Bitmap.prototype.createAdaptee = function () {
            var newAdaptee = Billboard.getNewBillboard(Bitmap.argBitmapMaterial, Bitmap.argPixelSnapping, Bitmap.argSmoothing);
            Bitmap.argBitmapMaterial = null;
            Bitmap.argPixelSnapping = null;
            Bitmap.argSmoothing = null;
            return newAdaptee;
        };
        Bitmap.prototype.clone = function () {
            var newInstance = Bitmap.getNewBitmap(this._bitmapData);
            this._adaptee.copyTo(newInstance.adaptee);
            return newInstance;
        };
        /**
         * @inheritDoc
         */
        Bitmap.prototype.dispose = function () {
            this.disposeValues();
            Bitmap._bitmaps.push(this);
        };
        Bitmap.prototype.disposeValues = function () {
            this.bitmapData = null;
            _super.prototype.disposeValues.call(this);
        };
        Object.defineProperty(Bitmap.prototype, "bitmapData", {
            /**
             * The BitmapData object being referenced.
             */
            get: function () {
                return this._bitmapData;
            },
            set: function (value) {
                if (this._bitmapData == value)
                    return;
                if (this._bitmapData)
                    this._bitmapData._removeOwner(this);
                this._bitmapData = value;
                if (this._bitmapData)
                    this._bitmapData._addOwner(this);
                var material = this._adaptee.material;
                if (this._bitmapData) {
                    if (!material.ambientMethod.texture)
                        material.ambientMethod.texture = new ImageTexture2D();
                    material.style.image = this._bitmapData.adaptee;
                }
                else {
                    if (material.ambientMethod.texture)
                        material.ambientMethod.texture = null;
                    material.style.image = null;
                    material.style.color = 0x0;
                }
                material.invalidateTextures();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Bitmap.prototype, "pixelSnapping", {
            /**
             * Controls whether or not the Bitmap object is snapped to the nearest pixel. The PixelSnapping
             * class includes possible values:
             *
             *   PixelSnapping.NEVER—No pixel snapping occurs.PixelSnapping.ALWAYS—The image is always snapped to the nearest
             * pixel, independent of transformation.PixelSnapping.AUTO—The image is snapped
             * to the nearest pixel if it is drawn with no rotation
             * or skew and it is drawn at a scale factor of 99.9% to 100.1%. If these conditions are satisfied,
             * the bitmap image is drawn at 100% scale, snapped to the nearest pixel. Internally, this value allows the image
             * to be drawn as fast as possible using the vector renderer.
             */
            get: function () {
                return "";
            },
            set: function (value) {
                console.log("pixelSnapping not implemented yet in flash/Bitmap");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Bitmap.prototype, "smoothing", {
            /**
             * Controls whether or not the bitmap is smoothed when scaled. If true, the bitmap is
             * smoothed when scaled. If false, the bitmap is not smoothed when scaled.
             */
            get: function () {
                console.log("smoothing not implemented yet in flash/Bitmap");
                return false;
            },
            set: function (value) {
                console.log("smoothing not implemented yet in flash/Bitmap");
            },
            enumerable: true,
            configurable: true
        });
        Bitmap._bitmaps = new Array();
        return Bitmap;
    }(DisplayObject$1));

    var ProgressEvent = /** @class */ (function (_super) {
        __extends(ProgressEvent, _super);
        function ProgressEvent(type, bubbles, cancelable, byteLoaded, bytesTotal) {
            if (bubbles === void 0) { bubbles = true; }
            if (cancelable === void 0) { cancelable = false; }
            if (byteLoaded === void 0) { byteLoaded = 0; }
            if (bytesTotal === void 0) { bytesTotal = 0; }
            var _this = _super.call(this, type, bubbles, cancelable) || this;
            _this._byteLoaded = byteLoaded;
            _this._bytesTotal = bytesTotal;
            return _this;
        }
        Object.defineProperty(ProgressEvent.prototype, "bytesTotal", {
            get: function () {
                return this._bytesTotal;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProgressEvent.prototype, "bytesLoaded", {
            get: function () {
                return this._byteLoaded;
            },
            enumerable: true,
            configurable: true
        });
        ProgressEvent.prototype.clone = function () {
            return new ProgressEvent(this.type, null, null, this._byteLoaded, this._bytesTotal);
        };
        ProgressEvent.PROGRESS = "progress";
        ProgressEvent.SOCKET_DATA = "socketData";
        ProgressEvent.STANDARD_ERROR_DATA = "standardErrorData";
        ProgressEvent.STANDARD_OUTPUT_DATA = "standardOutputData";
        return ProgressEvent;
    }(Event));

    var BitmapData = /** @class */ (function (_super) {
        __extends(BitmapData, _super);
        function BitmapData(width, height, transparent, fillColor) {
            if (transparent === void 0) { transparent = true; }
            if (fillColor === void 0) { fillColor = 0xffffffff; }
            var _this = _super.call(this) || this;
            _this._owners = new Array();
            _this._adaptee = _this._adaptee || new SceneImage2D(width, height, transparent, fillColor, false, StageManager.getInstance().getStageAt(0));
            _this._adaptee.adapter = _this;
            return _this;
        }
        // for AVM1:
        BitmapData.prototype.compare = function (other) {
            return true;
        };
        Object.defineProperty(BitmapData.prototype, "adaptee", {
            get: function () {
                return this._adaptee;
            },
            set: function (value) {
                this._adaptee = value;
            },
            enumerable: true,
            configurable: true
        });
        BitmapData.loadBitmap = function (id) {
            console.log("loadBitmap not implemented yet in flash/BitmapData");
            return null;
        };
        BitmapData.prototype.setPixels = function (rect, inputByteArray) {
            console.log("todo: BitmapData.setPixels");
            //this._putPixelData(rect, new Int32Array(inputByteArray.readRawBytes()));
        };
        BitmapData.prototype.getPixels = function (rect) {
            /*var outputByteArray = new ByteArray();
            this.copyPixelsToByteArray(rect, outputByteArray);*/
            console.log("getPixels not implemented yet in flash/BitmapData");
            return null;
        };
        BitmapData.prototype.copyPixelsToByteArray = function (rect, data) {
            console.log("copyPixelsToByteArray not implemented yet in flash/BitmapData");
        };
        BitmapData.prototype.getVector = function (rect) {
            notImplemented("public flash.display.BitmapData::getVector");
            return null;
        };
        BitmapData.prototype.setVector = function (rect, inputVector) {
            notImplemented("public flash.display.BitmapData::encode");
        };
        BitmapData.prototype.histogram = function (hRect) {
            if (hRect === void 0) { hRect = null; }
            notImplemented("public flash.display.BitmapData::encode");
            return;
        };
        BitmapData.prototype.encode = function (rect, compressor, byteArray) {
            if (byteArray === void 0) { byteArray = null; }
            notImplemented("public flash.display.BitmapData::encode");
            return;
        };
        BitmapData.prototype.drawWithQuality = function (source, matrix, colorTransform, blendMode, clipRect, smoothing, quality) {
            if (matrix === void 0) { matrix = null; }
            if (colorTransform === void 0) { colorTransform = null; }
            if (blendMode === void 0) { blendMode = null; }
            if (clipRect === void 0) { clipRect = null; }
            if (smoothing === void 0) { smoothing = false; }
            if (quality === void 0) { quality = null; }
            notImplemented("public flash.display.BitmapData::drawWithQuality");
        };
        Object.defineProperty(BitmapData.prototype, "transparent", {
            get: function () {
                return this._adaptee.transparent;
            },
            set: function (value) {
                this._adaptee.transparent = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BitmapData.prototype, "width", {
            get: function () {
                return this._adaptee.width;
            },
            set: function (value) {
                this._adaptee.width = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BitmapData.prototype, "height", {
            get: function () {
                return this._adaptee.height;
            },
            set: function (value) {
                this._adaptee.height = value;
            },
            enumerable: true,
            configurable: true
        });
        BitmapData.prototype.clone = function () {
            var clone = new this.sec.flash.display.BitmapData(this._adaptee.width, this._adaptee.height, this._adaptee.transparent, 0x0);
            clone.copyPixels(this, this.rect, new this.sec.flash.geom.Point());
            return clone;
        };
        Object.defineProperty(BitmapData.prototype, "rect", {
            get: function () {
                return new this.sec.flash.geom.Rectangle(this._adaptee.rect.clone());
            },
            enumerable: true,
            configurable: true
        });
        BitmapData.prototype.getPixel = function (x, y) {
            return this._adaptee.getPixel(x, y);
        };
        BitmapData.prototype.getPixel32 = function (x, y) {
            return this._adaptee.getPixel32(x, y);
        };
        BitmapData.prototype.setPixel = function (x, y, color) {
            this._adaptee.setPixel(x, y, color);
        };
        BitmapData.prototype.setPixel32 = function (x, y, color) {
            this._adaptee.setPixel32(x, y, color);
        };
        BitmapData.prototype.applyFilter = function (sourceBitmap, sourceRect, destPoint, filter) {
            console.log("applyFilter not implemented yet in flash/BitmapData");
            return 0;
        };
        BitmapData.prototype.colorTransform = function (rect, colorTransform) {
            this._adaptee.colorTransform(rect.adaptee, colorTransform.adaptee);
        };
        BitmapData.prototype.copyChannel = function (sourceBitmap, sourceRect, destPoint, sourceChannel, destChannel) {
            this._adaptee.copyChannel(sourceBitmap.adaptee, sourceRect.adaptee, destPoint.adaptee, sourceChannel, destChannel);
        };
        BitmapData.prototype.copyPixels = function (sourceBitmap, sourceRect, destPoint, alphaBitmapData, alphaPoint, mergeAlpha) {
            if (alphaBitmapData === void 0) { alphaBitmapData = null; }
            if (alphaPoint === void 0) { alphaPoint = null; }
            if (mergeAlpha === void 0) { mergeAlpha = false; }
            this._adaptee.copyPixels(sourceBitmap.adaptee, sourceRect.adaptee, destPoint.adaptee, alphaBitmapData ? alphaBitmapData.adaptee : null, alphaPoint ? alphaPoint.adaptee : null, mergeAlpha);
        };
        BitmapData.prototype.dispose = function () {
            this._adaptee.dispose();
            this._adaptee = null;
        };
        BitmapData.prototype.draw = function (source, matrix, colorTransform, blendMode, clipRect, smooth) {
            if (colorTransform === void 0) { colorTransform = null; }
            if (blendMode === void 0) { blendMode = ""; }
            if (clipRect === void 0) { clipRect = null; }
            if (smooth === void 0) { smooth = false; }
            this._adaptee.draw(source.adaptee, matrix ? matrix.adaptee : null, colorTransform ? colorTransform.adaptee : null, blendMode, clipRect ? clipRect.adaptee : null, smooth);
        };
        BitmapData.prototype.fillRect = function (rect, color) {
            var colorArr = ColorUtils.float32ColorToARGB(color);
            color = ColorUtils.ARGBtoFloat32(colorArr[0], colorArr[3], colorArr[2], colorArr[1]);
            this._adaptee.fillRect(rect.adaptee, color);
        };
        BitmapData.prototype.floodFill = function (x, y, color) {
            console.log("floodFill not implemented yet in flash/BitmapData");
        };
        BitmapData.prototype.generateFilterRect = function (sourceRect, filter) {
            console.log("generateFilterRect not implemented yet in flash/BitmapData");
            return null;
        };
        BitmapData.prototype.getColorBoundsRect = function (mask, color, findColor) {
            console.log("getColorBoundsRect not implemented yet in flash/BitmapData");
            return null;
        };
        BitmapData.prototype.hitTest = function (firstPoint, firstAlphaThreshold, secondObject, secondBitmapPoint, secondAlphaThreshold) {
            if (secondBitmapPoint === void 0) { secondBitmapPoint = new this.sec.flash.geom.Point(0, 0); }
            if (secondAlphaThreshold === void 0) { secondAlphaThreshold = 0; }
            console.log("hitTest not implemented yet in flash/BitmapData");
            return false;
        };
        BitmapData.prototype.lock = function () {
            this._adaptee.lock();
        };
        BitmapData.prototype.merge = function (sourceBitmap, sourceRect, destPoint, redMult, greenMult, blueMult, alphaMult) {
            this._adaptee.merge(sourceBitmap.adaptee, sourceBitmap.rect.adaptee, destPoint.adaptee, redMult, greenMult, blueMult, alphaMult);
        };
        BitmapData.prototype.noise = function (randomSeed, low, high, channelOptions, grayScale) {
            console.log("noise not implemented yet in flash/BitmapData");
        };
        BitmapData.prototype.paletteMap = function (sourceBitmap, sourceRect, destPoint, redArray, greenArray, blueArray, alphaArray) {
            console.log("paletteMap not implemented yet in flash/BitmapData");
        };
        BitmapData.prototype.perlinNoise = function (baseX, baseY, numOctaves, randomSeed, stitch, fractalNoise, channelOptions, grayScale, offsets) {
            console.log("perlinNoise not implemented yet in flash/BitmapData");
        };
        BitmapData.prototype.pixelDissolve = function (sourceBitmap, sourceRect, destPoint, randomSeed, numberOfPixels, fillColor) {
            console.log("pixelDissolve not implemented yet in flash/BitmapData");
            return 0;
        };
        BitmapData.prototype.scroll = function (x, y) {
            console.log("scroll not implemented yet in flash/BitmapData");
        };
        BitmapData.prototype.threshold = function (sourceBitmap, sourceRect, destPoint, operation, threshold, color, mask, copySource) {
            //console.log("threshold not implemented yet in flash/BitmapData");
            return 0;
        };
        BitmapData.prototype.unlock = function () {
            this._adaptee.unlock();
        };
        BitmapData.prototype._addOwner = function (owner) {
            if (this._owners.indexOf(owner) == -1)
                this._owners.push(owner);
        };
        BitmapData.prototype._removeOwner = function (owner) {
            var index = this._owners.indexOf(owner);
            if (index != -1)
                this._owners.splice(index, 1);
            if (!this._owners.length)
                this._adaptee.clear();
        };
        return BitmapData;
    }(ASObject$1));

    var MetadataInfo = /** @class */ (function () {
        function MetadataInfo(abc, name, keys, values) {
            this.abc = abc;
            this.name = name;
            this.keys = keys;
            this.values = values;
            // ...
        }
        MetadataInfo.prototype.getName = function () {
            if (typeof this.name === "number") {
                this.name = this.abc.getString(this.name);
            }
            return this.name;
        };
        MetadataInfo.prototype.getKeyAt = function (i) {
            return this.abc.getString(this.keys[i]);
        };
        MetadataInfo.prototype.getValueAt = function (i) {
            return this.abc.getString(this.values[i]);
        };
        MetadataInfo.prototype.getValue = function (key) {
            for (var i = 0; i < this.keys.length; i++) {
                if (this.abc.getString(this.keys[i]) === key) {
                    return this.abc.getString(this.values[i]);
                }
            }
            return null;
        };
        return MetadataInfo;
    }());

    var Info = /** @class */ (function () {
        function Info() {
        }
        return Info;
    }());

    var InstanceInfo = /** @class */ (function (_super) {
        __extends(InstanceInfo, _super);
        function InstanceInfo(abc, name, superName, flags, protectedNs, interfaceNameIndices, initializer, traits) {
            var _this = _super.call(this) || this;
            _this.abc = abc;
            _this.name = name;
            _this.superName = superName;
            _this.flags = flags;
            _this.protectedNs = protectedNs;
            _this.interfaceNameIndices = interfaceNameIndices;
            _this.initializer = initializer;
            _this.traits = traits;
            _this.classInfo = null;
            _this.runtimeTraits = null;
            _this._interfaces = null;
            return _this;
        }
        InstanceInfo.prototype.getInitializer = function () {
            if (typeof this.initializer === "number") {
                this.initializer = this.abc.getMethodInfo(this.initializer);
            }
            return this.initializer;
        };
        InstanceInfo.prototype.getName = function () {
            if (typeof this.name === "number") {
                this.name = this.abc.getMultiname(this.name);
            }
            return this.name;
        };
        InstanceInfo.prototype.getClassName = function () {
            var name = this.getName();
            if (name.namespaces[0].uri) {
                return name.namespaces[0].uri + "." + name.name;
            }
            return name.name;
        };
        InstanceInfo.prototype.getSuperName = function () {
            if (typeof this.superName === "number") {
                this.superName = this.abc.getMultiname(this.superName);
            }
            return this.superName;
        };
        InstanceInfo.prototype.getInterfaces = function (ownerClass) {
            if (this._interfaces) {
                return this._interfaces;
            }
            var superClassInterfaces;
            var superClass = ownerClass.superClass;
            if (superClass) {
                superClassInterfaces = superClass.classInfo.instanceInfo.getInterfaces(superClass);
            }
            var SetCtor = Set;
            var interfaces = this._interfaces = new SetCtor(superClassInterfaces);
            for (var i = 0; i < this.interfaceNameIndices.length; i++) {
                var mn = this.abc.getMultiname(this.interfaceNameIndices[i]);
                var type = this.abc.applicationDomain.getClass(mn);
                interfaces.add(type);
                var implementedInterfaces = type.classInfo.instanceInfo.getInterfaces(type);
                implementedInterfaces.forEach(function (iface) { return interfaces.add(iface); });
            }
            return interfaces;
        };
        InstanceInfo.prototype.toString = function () {
            return "InstanceInfo " + this.getName().name;
        };
        InstanceInfo.prototype.toFlashlogString = function () {
            return this.getName().toFlashlogString();
        };
        InstanceInfo.prototype.trace = function (writer) {
            writer.enter("InstanceInfo: " + this.getName());
            this.superName && writer.writeLn("Super: " + this.getSuperName());
            this.traits.trace(writer);
            writer.outdent();
        };
        InstanceInfo.prototype.isInterface = function () {
            return !!(this.flags & 4 /* ClassInterface */);
        };
        InstanceInfo.prototype.isSealed = function () {
            return !!(this.flags & 1 /* ClassSealed */);
        };
        InstanceInfo.prototype.isFinal = function () {
            return !!(this.flags & 2 /* ClassFinal */);
        };
        return InstanceInfo;
    }(Info));

    var ClassInfo = /** @class */ (function (_super) {
        __extends(ClassInfo, _super);
        function ClassInfo(abc, instanceInfo, initializer, traits) {
            var _this = _super.call(this) || this;
            _this.abc = abc;
            _this.instanceInfo = instanceInfo;
            _this.initializer = initializer;
            _this.traits = traits;
            _this.trait = null;
            _this.runtimeTraits = null;
            return _this;
        }
        ClassInfo.prototype.getNativeMetadata = function () {
            if (!this.trait) {
                return null;
            }
            var metadata = this.trait.getMetadata();
            if (!metadata) {
                return null;
            }
            for (var i = 0; i < metadata.length; i++) {
                if (metadata[i].getName() === "native") {
                    return metadata[i];
                }
            }
            return null;
        };
        ClassInfo.prototype.getInitializer = function () {
            if (typeof this.initializer === "number") {
                return this.initializer = this.abc.getMethodInfo(this.initializer);
            }
            return this.initializer;
        };
        ClassInfo.prototype.toString = function () {
            return "ClassInfo " + this.instanceInfo.getName();
        };
        ClassInfo.prototype.trace = function (writer) {
            writer.enter("ClassInfo");
            this.traits.trace(writer);
            writer.outdent();
        };
        return ClassInfo;
    }(Info));

    var MethodInfo = /** @class */ (function () {
        function MethodInfo(abc, _index, name, returnTypeNameIndex, parameters, optionalCount, flags) {
            this.abc = abc;
            this._index = _index;
            this.name = name;
            this.returnTypeNameIndex = returnTypeNameIndex;
            this.parameters = parameters;
            this.optionalCount = optionalCount;
            this.flags = flags;
            this.trait = null;
            this.compiled = null;
            this.error = null;
            this._body = null;
            this.minArgs = parameters.length - optionalCount;
        }
        MethodInfo.prototype.getNativeMetadata = function () {
            if (!this.trait) {
                return null;
            }
            var metadata = this.trait.getMetadata();
            if (!metadata) {
                return null;
            }
            for (var i = 0; i < metadata.length; i++) {
                if (metadata[i].getName() === "native") {
                    return metadata[i];
                }
            }
            return null;
        };
        MethodInfo.prototype.getBody = function () {
            return this._body || (this._body = this.abc.getMethodBodyInfo(this._index));
        };
        MethodInfo.prototype.index = function () {
            return this._index;
        };
        MethodInfo.prototype.getType = function () {
            if (this._returnType !== undefined) {
                return this._returnType;
            }
            if (this.returnTypeNameIndex === 0) {
                this._returnType = null;
            }
            else {
                var mn = this.abc.getMultiname(this.returnTypeNameIndex);
                this._returnType = this.abc.applicationDomain.getClass(mn);
            }
            return this._returnType;
        };
        MethodInfo.prototype.getName = function () {
            if (this.name) {
                return this.abc.getString(this.name);
            }
            if (this.trait) {
                return this.trait.getName().name;
            }
            return 'anonymous';
        };
        MethodInfo.prototype.toString = function () {
            var str = "anonymous";
            if (this.name) {
                str = this.abc.getString(this.name);
            }
            str += " (" + this.parameters.join(", ") + ")";
            if (this.returnTypeNameIndex) {
                str += ": " + this.abc.getMultiname(this.returnTypeNameIndex).name;
            }
            return str;
        };
        MethodInfo.prototype.toFlashlogString = function () {
            var trait = this.trait;
            var prefix = trait.kind === 2 /* Getter */ ? 'get ' :
                trait.kind === 3 /* Setter */ ? 'set ' : '';
            var name = trait.toFlashlogString();
            var holder = trait.holder;
            var holderName;
            if (holder && holder instanceof InstanceInfo) {
                holderName = holder.toFlashlogString();
                prefix = holderName + '/' + prefix;
            }
            if (holder && holder instanceof ClassInfo && holder.trait) {
                holderName = holder.trait.toFlashlogString();
                prefix = holderName + '$/' + prefix;
            }
            var prefixPos;
            if (holderName && (prefixPos = name.indexOf('::')) > 0 &&
                holderName.indexOf(name.substring(0, prefixPos + 2)) === 0) {
                name = name.substring(prefixPos + 2);
            }
            return 'MTHD ' + prefix + name + ' ()';
        };
        MethodInfo.prototype.isNative = function () {
            return !!(this.flags & 32 /* Native */);
        };
        MethodInfo.prototype.needsRest = function () {
            return !!(this.flags & 4 /* NeedRest */);
        };
        MethodInfo.prototype.needsArguments = function () {
            return !!(this.flags & 1 /* NeedArguments */);
        };
        return MethodInfo;
    }());

    var bytecodeNames = ["", "BKPT", "NOP", "THROW", "GETSUPER", "SETSUPER", "DXNS", "DXNSLATE", "KILL", "LABEL", "LF32X4", "SF32X4", "IFNLT", "IFNLE", "IFNGT", "IFNGE", "JUMP", "IFTRUE", "IFFALSE", "IFEQ", "IFNE", "IFLT", "IFLE", "IFGT", "IFGE", "IFSTRICTEQ", "IFSTRICTNE", "LOOKUPSWITCH", "PUSHWITH", "POPSCOPE", "NEXTNAME", "HASNEXT", "PUSHNULL", "PUSHUNDEFINED", "PUSHFLOAT", "NEXTVALUE", "PUSHBYTE", "PUSHSHORT", "PUSHTRUE", "PUSHFALSE", "PUSHNAN", "POP", "DUP", "SWAP", "PUSHSTRING", "PUSHINT", "PUSHUINT", "PUSHDOUBLE", "PUSHSCOPE", "PUSHNAMESPACE", "HASNEXT2", , , "LI8", "LI16", "LI32", "LF32", "LF64", "SI8", "SI16", "SI32", "SF32", "SF64", , "NEWFUNCTION", "CALL", "CONSTRUCT", "CALLMETHOD", "CALLSTATIC", "CALLSUPER", "CALLPROPERTY", "RETURNVOID", "RETURNVALUE", "CONSTRUCTSUPER", "CONSTRUCTPROP", "CALLSUPERID", "CALLPROPLEX", "CALLINTERFACE", "CALLSUPERVOID", "CALLPROPVOID", "SXI1", "SXI8", "SXI16", "APPLYTYPE", "PUSHFLOAT4", "NEWOBJECT", "NEWARRAY", "NEWACTIVATION", "NEWCLASS", "GETDESCENDANTS", "NEWCATCH", , , "FINDPROPSTRICT", "FINDPROPERTY", "FINDDEF", "GETLEX", "SETPROPERTY", "GETLOCAL", "SETLOCAL", "GETGLOBALSCOPE", "GETSCOPEOBJECT", "GETPROPERTY", "GETOUTERSCOPE", "INITPROPERTY", "UNUSED_69", "DELETEPROPERTY", "UNUSED_6B", "GETSLOT", "SETSLOT", "GETGLOBALSLOT", "SETGLOBALSLOT", "CONVERT_S", "ESC_XELEM", "ESC_XATTR", "CONVERT_I", "CONVERT_U", "CONVERT_D", "CONVERT_B", "CONVERT_O", "CHECKFILTER", "CONVERT_F", "UNPLUS", "CONVERT_F4", "BC_7C", "BC_7D", "BC_7E", "BC_7F", "COERCE", "COERCE_B", "COERCE_A", "COERCE_I", "COERCE_D", "COERCE_S", "ASTYPE", "ASTYPELATE", "COERCE_U", "COERCE_O", , , , , , , "NEGATE", "INCREMENT", "INCLOCAL", "DECREMENT", "DECLOCAL", "TYPEOF", "NOT", "BITNOT", "UNUSED_98", "UNUSED_99", "UNUSED_9A", "UNUSED_9B", "UNUSED_9C", "UNUSED_9D", "UNUSED_9E", "UNUSED_9F", "ADD", "SUBTRACT", "MULTIPLY", "DIVIDE", "MODULO", "LSHIFT", "RSHIFT", "URSHIFT", "BITAND", "BITOR", "BITXOR", "EQUALS", "STRICTEQUALS", "LESSTHAN", "LESSEQUALS", "GREATERTHAN", "GREATEREQUALS", "INSTANCEOF", "ISTYPE", "ISTYPELATE", "IN", "UNUSED_B5", "UNUSED_B6", "UNUSED_B7", "UNUSED_B8", "UNUSED_B9", "UNUSED_BA", "UNUSED_BB", "UNUSED_BC", "UNUSED_BD", "UNUSED_BE", "UNUSED_BF", "INCREMENT_I", "DECREMENT_I", "INCLOCAL_I", "DECLOCAL_I", "NEGATE_I", "ADD_I", "SUBTRACT_I", "MULTIPLY_I", "UNUSED_C8", "UNUSED_C9", "UNUSED_CA", "UNUSED_CB", "UNUSED_CC", "UNUSED_CD", "UNUSED_CE", "UNUSED_CF", "GETLOCAL0", "GETLOCAL1", "GETLOCAL2", "GETLOCAL3", "SETLOCAL0", "SETLOCAL1", "SETLOCAL2", "SETLOCAL3", "UNUSED_D8", "UNUSED_D9", "UNUSED_DA", "UNUSED_DB", "UNUSED_DC", "UNUSED_DD", "UNUSED_DE", "UNUSED_DF", "UNUSED_E0", "UNUSED_E1", "UNUSED_E2", "UNUSED_E3", "UNUSED_E4", "UNUSED_E5", "UNUSED_E6", "UNUSED_E7", "UNUSED_E8", "UNUSED_E9", "UNUSED_EA", "UNUSED_EB", "UNUSED_EC", "INVALID", "UNUSED_EE", "DEBUG", "DEBUGLINE", "DEBUGFILE", "BKPTLINE", "TIMESTAMP", "RESTARGC", "RESTARG", "UNUSED_F6", "UNUSED_F7", "UNUSED_F8", "UNUSED_F9", "UNUSED_FA", "UNUSED_FB", "UNUSED_FC", "UNUSED_FD", "UNUSED_FE", "END"];
    function getBytecodeName(bytecode) {
        return release$1 ? "Bytecode: " + bytecode : bytecodeNames[bytecode];
    }
    /**
     * A array that maps from a bytecode value to the set of {@link OPFlags} for the corresponding instruction.
     */
    var BytecodeFlags = new Uint32Array(256);
    var BytecodeFormat = new Array(256);
    function define(bytecode, format, flags) {
        if (flags === void 0) { flags = 0; }
        var instructionLength = format.length;
        BytecodeFlags[bytecode] = flags;
        BytecodeFormat[bytecode] = format;
        // release || assert (!isConditionalBranch(opcode) || isBranch(opcode), "a conditional branch must also be a branch");
    }
    /**
     * Only call this before the compiler is used.
     */
    function defineBytecodes() {
        define(1 /* BKPT */, "");
        define(2 /* NOP */, "");
        define(3 /* THROW */, "");
        define(4 /* GETSUPER */, "e");
        define(5 /* SETSUPER */, "e");
        define(6 /* DXNS */, "e");
        define(7 /* DXNSLATE */, "");
        define(8 /* KILL */, "e");
        define(9 /* LABEL */, "");
        define(10 /* LF32X4 */, "");
        define(11 /* SF32X4 */, "");
        define(12 /* IFNLT */, "d");
        define(13 /* IFNLE */, "d");
        define(14 /* IFNGT */, "d");
        define(15 /* IFNGE */, "d");
        define(16 /* JUMP */, "d");
        define(17 /* IFTRUE */, "d");
        define(18 /* IFFALSE */, "d");
        define(19 /* IFEQ */, "d");
        define(20 /* IFNE */, "d");
        define(21 /* IFLT */, "d");
        define(22 /* IFLE */, "d");
        define(23 /* IFGT */, "d");
        define(24 /* IFGE */, "d");
        define(25 /* IFSTRICTEQ */, "d");
        define(26 /* IFSTRICTNE */, "d");
        define(27 /* LOOKUPSWITCH */, "");
        define(28 /* PUSHWITH */, "");
        define(29 /* POPSCOPE */, "");
        define(30 /* NEXTNAME */, "");
        define(31 /* HASNEXT */, "");
        define(32 /* PUSHNULL */, "");
        define(33 /* PUSHUNDEFINED */, "");
        define(35 /* NEXTVALUE */, "");
        define(36 /* PUSHBYTE */, "b");
        define(37 /* PUSHSHORT */, "c");
        define(38 /* PUSHTRUE */, "");
        define(39 /* PUSHFALSE */, "");
        define(40 /* PUSHNAN */, "");
        define(41 /* POP */, "");
        define(42 /* DUP */, "");
        define(43 /* SWAP */, "");
        define(44 /* PUSHSTRING */, "e");
        define(45 /* PUSHINT */, "e");
        define(46 /* PUSHUINT */, "e");
        define(47 /* PUSHDOUBLE */, "e");
        define(48 /* PUSHSCOPE */, "");
        define(49 /* PUSHNAMESPACE */, "e");
        define(50 /* HASNEXT2 */, "ee");
        // define(Bytecode.UNDEFINED, "");
        // define(Bytecode.UNDEFINED, "");
        define(53 /* LI8 */, "");
        define(54 /* LI16 */, "");
        define(55 /* LI32 */, "");
        define(56 /* LF32 */, "");
        define(57 /* LF64 */, "");
        define(58 /* SI8 */, "");
        define(59 /* SI16 */, "");
        define(60 /* SI32 */, "");
        define(61 /* SF32 */, "");
        define(62 /* SF64 */, "");
        define(64 /* NEWFUNCTION */, "e");
        define(65 /* CALL */, "e");
        define(66 /* CONSTRUCT */, "e");
        define(67 /* CALLMETHOD */, "ee");
        define(68 /* CALLSTATIC */, "ee");
        define(69 /* CALLSUPER */, "ee");
        define(70 /* CALLPROPERTY */, "ee");
        define(71 /* RETURNVOID */, "");
        define(72 /* RETURNVALUE */, "");
        define(73 /* CONSTRUCTSUPER */, "e");
        define(74 /* CONSTRUCTPROP */, "ee");
        define(75 /* CALLSUPERID */, "");
        define(76 /* CALLPROPLEX */, "ee");
        define(77 /* CALLINTERFACE */, "");
        define(78 /* CALLSUPERVOID */, "ee");
        define(79 /* CALLPROPVOID */, "ee");
        define(80 /* SXI1 */, "");
        define(81 /* SXI8 */, "");
        define(82 /* SXI16 */, "");
        define(83 /* APPLYTYPE */, "e");
        define(84 /* PUSHFLOAT4 */, "");
        define(85 /* NEWOBJECT */, "e");
        define(86 /* NEWARRAY */, "e");
        define(87 /* NEWACTIVATION */, "");
        define(88 /* NEWCLASS */, "e");
        define(89 /* GETDESCENDANTS */, "e");
        define(90 /* NEWCATCH */, "e");
        // define(Bytecode.UNDEFINED, "");
        // define(Bytecode.UNDEFINED, "");
        define(93 /* FINDPROPSTRICT */, "e");
        define(94 /* FINDPROPERTY */, "e");
        define(95 /* FINDDEF */, "");
        define(96 /* GETLEX */, "e");
        define(97 /* SETPROPERTY */, "e");
        define(98 /* GETLOCAL */, "e");
        define(99 /* SETLOCAL */, "e");
        define(100 /* GETGLOBALSCOPE */, "");
        define(101 /* GETSCOPEOBJECT */, "e");
        define(102 /* GETPROPERTY */, "e");
        define(103 /* GETOUTERSCOPE */, "");
        define(104 /* INITPROPERTY */, "e");
        define(106 /* DELETEPROPERTY */, "e");
        define(108 /* GETSLOT */, "e");
        define(109 /* SETSLOT */, "e");
        define(110 /* GETGLOBALSLOT */, "e");
        define(111 /* SETGLOBALSLOT */, "e");
        define(112 /* CONVERT_S */, "");
        define(113 /* ESC_XELEM */, "");
        define(114 /* ESC_XATTR */, "");
        define(115 /* CONVERT_I */, "");
        define(116 /* CONVERT_U */, "");
        define(117 /* CONVERT_D */, "");
        define(118 /* CONVERT_B */, "");
        define(119 /* CONVERT_O */, "");
        define(120 /* CHECKFILTER */, "");
        define(121 /* CONVERT_F */, "");
        define(122 /* UNPLUS */, "");
        define(123 /* CONVERT_F4 */, "");
        define(128 /* COERCE */, "e");
        define(129 /* COERCE_B */, "");
        define(130 /* COERCE_A */, "");
        define(131 /* COERCE_I */, "");
        define(132 /* COERCE_D */, "");
        define(133 /* COERCE_S */, "");
        define(134 /* ASTYPE */, "e");
        define(135 /* ASTYPELATE */, "");
        define(136 /* COERCE_U */, "");
        define(137 /* COERCE_O */, "");
        define(144 /* NEGATE */, "");
        define(145 /* INCREMENT */, "");
        define(146 /* INCLOCAL */, "e");
        define(147 /* DECREMENT */, "");
        define(148 /* DECLOCAL */, "e");
        define(149 /* TYPEOF */, "");
        define(150 /* NOT */, "");
        define(151 /* BITNOT */, "");
        define(160 /* ADD */, "");
        define(161 /* SUBTRACT */, "");
        define(162 /* MULTIPLY */, "");
        define(163 /* DIVIDE */, "");
        define(164 /* MODULO */, "");
        define(165 /* LSHIFT */, "");
        define(166 /* RSHIFT */, "");
        define(167 /* URSHIFT */, "");
        define(168 /* BITAND */, "");
        define(169 /* BITOR */, "");
        define(170 /* BITXOR */, "");
        define(171 /* EQUALS */, "");
        define(172 /* STRICTEQUALS */, "");
        define(173 /* LESSTHAN */, "");
        define(174 /* LESSEQUALS */, "");
        define(175 /* GREATERTHAN */, "");
        define(176 /* GREATEREQUALS */, "");
        define(177 /* INSTANCEOF */, "");
        define(178 /* ISTYPE */, "e");
        define(179 /* ISTYPELATE */, "");
        define(180 /* IN */, "");
        define(192 /* INCREMENT_I */, "");
        define(193 /* DECREMENT_I */, "");
        define(194 /* INCLOCAL_I */, "e");
        define(195 /* DECLOCAL_I */, "e");
        define(196 /* NEGATE_I */, "");
        define(197 /* ADD_I */, "");
        define(198 /* SUBTRACT_I */, "");
        define(199 /* MULTIPLY_I */, "");
        define(208 /* GETLOCAL0 */, "");
        define(209 /* GETLOCAL1 */, "");
        define(210 /* GETLOCAL2 */, "");
        define(211 /* GETLOCAL3 */, "");
        define(212 /* SETLOCAL0 */, "");
        define(213 /* SETLOCAL1 */, "");
        define(214 /* SETLOCAL2 */, "");
        define(215 /* SETLOCAL3 */, "");
        define(237 /* INVALID */, "");
        define(239 /* DEBUG */, "aeae");
        define(240 /* DEBUGLINE */, "e");
        define(241 /* DEBUGFILE */, "e");
        define(242 /* BKPTLINE */, "e");
        define(243 /* TIMESTAMP */, "");
        // define(Bytecode.UNUSED_6B, "", Flags.NONE);
        // define(Bytecode.UNUSED_DE, "", Flags.NONE);
        // define(Bytecode.UNUSED_BB, "", Flags.NONE);
    }
    defineBytecodes();
    var Bytes = /** @class */ (function () {
        function Bytes() {
        }
        Bytes.u8 = function (code, i) {
            return code[i];
        };
        Bytes.s32 = function (code, i) {
            var result = code[i];
            if (result & 0x80) {
                result = result & 0x7f | code[i + 1] << 7;
                if (result & 0x4000) {
                    result = result & 0x3fff | code[i + 2] << 14;
                    if (result & 0x200000) {
                        result = result & 0x1fffff | code[i + 3] << 21;
                        if (result & 0x10000000) {
                            result = result & 0x0fffffff | code[i + 4] << 28;
                            result = result & 0xffffffff;
                        }
                    }
                }
            }
            return result;
        };
        Bytes.u32 = function (code, i) {
            return Bytes.s32(code, i) >>> 0;
        };
        Bytes.u30 = function (code, i) {
            return Bytes.u32(code, i);
        };
        Bytes.s32Length = function (code, i) {
            var result = code[i];
            if (result & 0x80) {
                result = result & 0x7f | code[i + 1] << 7;
                if (result & 0x4000) {
                    result = result & 0x3fff | code[i + 2] << 14;
                    if (result & 0x200000) {
                        result = result & 0x1fffff | code[i + 3] << 21;
                        if (result & 0x10000000) {
                            return 5;
                        }
                        return 4;
                    }
                    return 3;
                }
                return 2;
            }
            return 1;
        };
        return Bytes;
    }());
    function lengthAt(code, i) {
        var l = 1;
        var bytecode = code[i];
        if (bytecode === 27 /* LOOKUPSWITCH */) {
            l += 3; // Default offset.
            var n = Bytes.u30(code, i + l) + 1; // Offsets
            l += Bytes.s32Length(code, i + l);
            l += n * 3;
            return l;
        }
        var format = BytecodeFormat[bytecode];
        if (format === "") {
            return l;
        }
        assert(format, "OP: " + getBytecodeName(bytecode));
        for (var j = 0; j < format.length; j++) {
            var f = format[j].charCodeAt(0) - 97;
            switch (f) {
                case 0 /* u08 */:
                case 1 /* s08 */:
                    l += 1;
                    continue;
                case 3 /* s24 */:
                    l += 3;
                    continue;
                case 2 /* s16 */:
                case 4 /* u30 */:
                case 5 /* u32 */:
                    l += Bytes.s32Length(code, i + l);
                    continue;
            }
        }
        return l;
    }
    var BytecodeStream = /** @class */ (function () {
        function BytecodeStream(code) {
            this._code = code;
            this.setBCI(0);
        }
        BytecodeStream.prototype.next = function () {
            this.setBCI(this._nextBCI);
        };
        BytecodeStream.prototype.endBCI = function () {
            return this._code.length;
        };
        Object.defineProperty(BytecodeStream.prototype, "nextBCI", {
            get: function () {
                return this._nextBCI;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BytecodeStream.prototype, "currentBCI", {
            get: function () {
                return this._currentBCI;
            },
            enumerable: true,
            configurable: true
        });
        BytecodeStream.prototype.currentBytecode = function () {
            return this._bytecode;
        };
        BytecodeStream.prototype.nextBC = function () {
            return Bytes.u8(this._code, this._nextBCI);
        };
        BytecodeStream.prototype.setBCI = function (bci) {
            this._currentBCI = bci;
            if (this._currentBCI < this._code.length) {
                this._bytecode = Bytes.u8(this._code, bci);
                var l = lengthAt(this._code, bci);
                this._nextBCI = bci + l;
            }
            else {
                this._bytecode = 255 /* END */;
                this._nextBCI = this._currentBCI;
            }
        };
        return BytecodeStream;
    }());

    var MethodBodyInfo = /** @class */ (function (_super) {
        __extends(MethodBodyInfo, _super);
        function MethodBodyInfo(maxStack, localCount, initScopeDepth, maxScopeDepth, code, catchBlocks, traits) {
            var _this = _super.call(this) || this;
            _this.maxStack = maxStack;
            _this.localCount = localCount;
            _this.initScopeDepth = initScopeDepth;
            _this.maxScopeDepth = maxScopeDepth;
            _this.code = code;
            _this.catchBlocks = catchBlocks;
            _this.traits = traits;
            _this.activationPrototype = null;
            return _this;
        }
        MethodBodyInfo.prototype.trace = function (writer) {
            writer.writeLn("Code: " + this.code.length);
            var stream = new BytecodeStream(this.code);
            while (stream.currentBytecode() !== 255 /* END */) {
                writer.writeLn(stream.currentBCI + ": " + getBytecodeName(stream.currentBytecode()));
                stream.next();
            }
        };
        return MethodBodyInfo;
    }(Info));

    var ScriptInfo = /** @class */ (function (_super) {
        __extends(ScriptInfo, _super);
        function ScriptInfo(abc, initializer, traits) {
            var _this = _super.call(this) || this;
            _this.abc = abc;
            _this.initializer = initializer;
            _this.traits = traits;
            _this.global = null;
            _this.state = 0 /* None */;
            return _this;
        }
        ScriptInfo.prototype.getInitializer = function () {
            return this.abc.getMethodInfo(this.initializer);
        };
        ScriptInfo.prototype.trace = function (writer) {
            writer.enter("ScriptInfo");
            this.traits.trace(writer);
            writer.outdent();
        };
        return ScriptInfo;
    }(Info));

    var ParameterInfo = /** @class */ (function () {
        function ParameterInfo(abc, type, 
        /**
         * Don't rely on the name being correct.
         */
        name, optionalValueKind, optionalValueIndex) {
            this.abc = abc;
            this.type = type;
            this.name = name;
            this.optionalValueKind = optionalValueKind;
            this.optionalValueIndex = optionalValueIndex;
            // ...
        }
        ParameterInfo.prototype.getName = function () {
            if (typeof this.name === "number") {
                this.name = this.abc.getString(this.name);
            }
            return this.name;
        };
        ParameterInfo.prototype.getType = function () {
            if (typeof this.type === "number") {
                this.type = this.abc.getMultiname(this.type);
            }
            return this.type;
        };
        ParameterInfo.prototype.hasOptionalValue = function () {
            return this.optionalValueKind >= 0;
        };
        ParameterInfo.prototype.getOptionalValue = function () {
            return this.abc.getConstant(this.optionalValueKind, this.optionalValueIndex);
        };
        ParameterInfo.prototype.toString = function () {
            var str = "";
            if (this.name) {
                str += this.getName();
            }
            else {
                str += "?";
            }
            if (this.type) {
                str += ": " + this.getType().name;
            }
            if (this.optionalValueKind >= 0) {
                str += " = " + this.abc.getConstant(this.optionalValueKind, this.optionalValueIndex);
            }
            return str;
        };
        return ParameterInfo;
    }());

    var RuntimeTraitInfo = /** @class */ (function () {
        function RuntimeTraitInfo(name, kind, abc) {
            this.name = name;
            this.kind = kind;
            this.abc = abc;
            this.configurable = true; // Always true.
            this._type = undefined;
            this.typeName = null;
        }
        RuntimeTraitInfo.prototype.getType = function () {
            if (this._type !== undefined) {
                return this._type;
            }
            if (this.typeName === null) {
                return this._type = null;
            }
            var type = this.abc.applicationDomain.getClass(this.typeName);
            return this._type = (type && type.axCoerce) ? type : null;
        };
        return RuntimeTraitInfo;
    }());

    function createGlobalNative(native, sec) {
        return function () {
            switch (arguments.length) {
                case 0: return native(sec);
                case 1: return native(sec, arguments[0]);
                case 2: return native(sec, arguments[0], arguments[1]);
                case 3: return native(sec, arguments[0], arguments[1], arguments[2]);
                default:
                    var args = [sec];
                    for (var i = 0; i < arguments.length; i++) {
                        args.push(arguments[i]);
                    }
                    return native.apply(this, args);
            }
        };
    }

    /*
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var FlashLog = /** @class */ (function () {
        function FlashLog() {
            this.isAS3TraceOn = true;
            this._startTime = Date.now();
        }
        Object.defineProperty(FlashLog.prototype, "currentTimestamp", {
            get: function () {
                return Date.now() - this._startTime;
            },
            enumerable: true,
            configurable: true
        });
        FlashLog.prototype._writeLine = function (line) {
            abstractMethod('FlashLog._writeLine');
        };
        FlashLog.prototype.writeAS3Trace = function (msg) {
            if (this.isAS3TraceOn) {
                this._writeLine(this.currentTimestamp + ' AVMINF: ' + msg);
            }
        };
        return FlashLog;
    }());
    var flashlog = null;

    var Scope = /** @class */ (function () {
        function Scope(parent, object, isWith) {
            if (isWith === void 0) { isWith = false; }
            this.parent = parent;
            this.object = object;
            this.global = parent ? parent.global : this;
            this.isWith = isWith;
            this.cache = [];
            this.defaultNamespace = null;
        }
        Scope.prototype.toString = function () {
            return "" + this.parent + " => " + this.object + " " + this.isWith;
        };
        Scope.prototype.extend = function (object) {
            if (object === this.object)
                return this;
            var c = object["__scope__"];
            if (c)
                if (c.parent == this)
                    return c;
            var s = new Scope(this, object, false);
            object["__scope__"] = s;
            return s;
        };
        Scope.prototype.findDepth = function (object) {
            var current = this;
            var depth = 0;
            while (current) {
                if (current.object === object) {
                    return depth;
                }
                depth++;
                current = current.parent;
            }
            return -1;
        };
        Scope.prototype.getScopeObjects = function () {
            var objects = [];
            var current = this;
            while (current) {
                objects.unshift(current.object);
                current = current.parent;
            }
            return objects;
        };
        Scope.prototype.getScopeProperty = function (mn, strict, scopeOnly) {
            return this.findScopeProperty(mn, strict, scopeOnly).axGetProperty(mn);
        };
        Scope.prototype.findScopeProperty = function (mn, strict, scopeOnly) {
            if (mn.mutable || scopeOnly)
                return this._findScopeProperty(mn, strict, scopeOnly);
            if (mn.scope === this.object)
                return mn.value;
            var value = this._findScopeProperty(mn, strict, scopeOnly);
            mn.value = value;
            mn.scope = this.object;
            return value;
        };
        Scope.prototype._findScopeProperty = function (mn, strict, scopeOnly) {
            // Multinames with a `null` name are the any name, '*'. Need to catch those here, because
            // otherwise we'll get a failing assert in `RuntimeTraits#getTrait` below.
            if (mn.name === null) {
                this.global.object.sec.throwError('ReferenceError', Errors$1.UndefinedVarError, '*');
            }
            var object;
            if ((object = this.cache[mn.id]))
                return object;
            // Scope lookups should not be trapped by proxies. Except for with scopes, check only trait
            // properties.
            if (this.object && (this.isWith ?
                this.object.axHasPropertyInternal(mn) :
                this.object.traits.getTrait(mn.namespaces, mn.name))) {
                return (this.isWith || mn.isRuntime()) ? this.object : (this.cache[mn.id] = this.object);
            }
            if (this.parent) {
                var object = this.parent.findScopeProperty(mn, strict, scopeOnly);
                if (mn.kind === 7 /* QName */) {
                    this.cache[mn.id] = object;
                }
                return object;
            }
            if (scopeOnly) {
                return null;
            }
            // Attributes can't be stored on globals or be directly defined in scripts.
            if (mn.isAttribute()) {
                this.object.sec.throwError("ReferenceError", Errors$1.UndefinedVarError, mn.name);
            }
            // If we can't find the property look in the domain.
            var globalObject = this.global.object;
            if ((object = globalObject.applicationDomain.findProperty(mn, strict, true))) {
                return object;
            }
            // If we still haven't found it, look for dynamic properties on the global.
            // No need to do this for non-strict lookups as we'll end up returning the
            // global anyways.
            if (strict) {
                if (!(mn.getPublicMangledName() in globalObject)) {
                    this.global.object.sec.throwError("ReferenceError", Errors$1.UndefinedVarError, mn.name);
                }
            }
            // Can't find it still, return the global object.
            return globalObject;
        };
        return Scope;
    }());

    var WriterFlags;
    (function (WriterFlags) {
        WriterFlags[WriterFlags["None"] = 0] = "None";
        WriterFlags[WriterFlags["Runtime"] = 1] = "Runtime";
        WriterFlags[WriterFlags["Execution"] = 2] = "Execution";
        WriterFlags[WriterFlags["Interpreter"] = 4] = "Interpreter";
    })(WriterFlags || (WriterFlags = {}));

    var writer = new IndentingWriter(false, function (x) { dumpLine(x); });
    var runtimeWriter = null;
    var interpreterWriter = null;
    function sliceArguments(args, offset) {
        return Array.prototype.slice.call(args, offset);
    }

    /**
     * Make sure we bottom out at the securityDomain's objectPrototype.
     */
    function safeGetPrototypeOf(object) {
        var axClass = object.axClass;
        if (!axClass || axClass === axClass.sec.AXObject) {
            return null;
        }
        var prototype = axClass.dPrototype;
        if (prototype === object) {
            prototype = axClass.superClass.dPrototype;
        }
        release$1 || assert(prototype.sec);
        return prototype;
    }

    var HasNext2Info = /** @class */ (function () {
        function HasNext2Info(object, index) {
            this.object = object;
            this.index = index;
            // ...
        }
        /**
         * Determine if the given object has any more properties after the specified |index| and if so,
         * return the next index or |zero| otherwise. If the |obj| has no more properties then continue
         * the search in
         * |obj.__proto__|. This function returns an updated index and object to be used during
         * iteration.
         *
         * the |for (x in obj) { ... }| statement is compiled into the following pseudo bytecode:
         *
         * index = 0;
         * while (true) {
         *   (obj, index) = hasNext2(obj, index);
         *   if (index) { #1
         *     x = nextName(obj, index); #2
         *   } else {
         *     break;
         *   }
         * }
         *
         * #1 If we return zero, the iteration stops.
         * #2 The spec says we need to get the nextName at index + 1, but it's actually index - 1, this
         * caused me two hours of my life that I will probably never get back.
         *
         * TODO: We can't match the iteration order semantics of Action Script, hopefully programmers
         * don't rely on it.
         */
        HasNext2Info.prototype.next = function (object, index) {
            if (isNullOrUndefined$1(object)) {
                this.index = 0;
                this.object = null;
                return;
            }
            else {
                this.object = object;
                this.index = index;
            }
            var nextIndex = object.axNextNameIndex(this.index);
            if (nextIndex > 0) {
                this.index = nextIndex;
                return;
            }
            // If there are no more properties in the object then follow the prototype chain.
            while (true) {
                var object = safeGetPrototypeOf(object);
                if (!object) {
                    this.index = 0;
                    this.object = null;
                    return;
                }
                nextIndex = object.axNextNameIndex(0);
                if (nextIndex > 0) {
                    this.index = nextIndex;
                    this.object = object;
                    return;
                }
            }
        };
        return HasNext2Info;
    }());

    var scopeStacks = [];

    function getCurrentScope() {
        if (scopeStacks.length === 0) {
            return null;
        }
        return scopeStacks[scopeStacks.length - 1].topScope();
    }

    /* tslint:disable */
    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    /*
     NOTE ON E4X METHOD CALLS

     E4X specifies some magic when making calls on XML and XMLList values. If a
     callee is not found on an XMLList value and the list has only one XML
     child, then the call is delegated to that XML child. If a callee is not
     found on an XML value and that value has simple content, then the simple
     content is converted to a string value and the call is made on that string
     value.

     Here are the relevant texts from the spec section 11.2.2.1:

     "If no such property exists and base is an XMLList of size 1, CallMethod
     delegates the method invocation to the single property it contains. This
     treatment intentionally blurs the distinction between XML objects and XMLLists
     of size 1."

     "If no such property exists and base is an XML object containing no XML valued
     children (i.e., an attribute, leaf node or element with simple content),
     CallMethod attempts to delegate the method lookup to the string value
     contained in the leaf node. This treatment allows users to perform operations
     directly on the value of a leaf node without having to explicitly select it."

     NOTE ON E4X ANY NAME AND NAMESPACE

     E4X allows the names of the form x.*, x.ns::*, x.*::id and x.*::* and their
     attribute name counterparts x.@*, x.@ns::*, etc. These forms result in
     Multiname values with the name part equal to undefined in the case of an ANY
     name, and the namespace set being empty in the case of an ANY namespace.

     Note also,
     x.*
     is shorthand for
     x.*::*
     .

     */
    function isXMLType(val, sec) {
        return typeof val === 'object' && val &&
            (val.axClass === sec.AXXML || val.axClass === sec.AXXMLList ||
                val.axClass === sec.AXQName || val.axClass === sec.AXNamespace);
    }
    function isXMLCollection(sec, val) {
        return typeof val === 'object' && val &&
            (val.axClass === sec.AXXML || val.axClass === sec.AXXMLList);
    }
    // 10.1 ToString
    function toString(node, sec) {
        if (!node || node.axClass !== sec.AXXML) {
            return axCoerceString$3(node);
        }
        switch (node._kind) {
            case 3 /* Text */:
            case 2 /* Attribute */:
                return node._value;
            default:
                if (node.hasSimpleContent()) {
                    var s = '';
                    for (var i = 0; i < node._children.length; i++) {
                        var child = node._children[i];
                        if (child._kind === 4 /* Comment */ ||
                            child._kind === 5 /* ProcessingInstruction */) {
                            continue;
                        }
                        s += toString(child, sec);
                    }
                    return s;
                }
                return toXMLString(sec, node);
        }
    }
    // 10.2.1.1 EscapeElementValue ( s )
    function escapeElementValue(sec, s) {
        if (isXMLCollection(sec, s)) {
            return s.toXMLString();
        }
        s = axCoerceString$3(s);
        var i = 0, ch;
        while (i < s.length && (ch = s[i]) !== '&' && ch !== '<' && ch !== '>') {
            i++;
        }
        if (i >= s.length) {
            return s;
        }
        var buf = s.substring(0, i);
        while (i < s.length) {
            ch = s[i++];
            switch (ch) {
                case '&':
                    buf += '&amp;';
                    break;
                case '<':
                    buf += '&lt;';
                    break;
                case '>':
                    buf += '&gt;';
                    break;
                default:
                    buf += ch;
                    break;
            }
        }
        return buf;
    }
    // 10.2.1.2 EscapeAttributeValue ( s )
    function escapeAttributeValue(s) {
        s = String(s);
        var i = 0, ch;
        while (i < s.length && (ch = s[i]) !== '&' && ch !== '<' &&
            ch !== '\"' && ch !== '\n' && ch !== '\r' && ch !== '\t') {
            i++;
        }
        if (i >= s.length) {
            return s;
        }
        var buf = s.substring(0, i);
        while (i < s.length) {
            ch = s[i++];
            switch (ch) {
                case '&':
                    buf += '&amp;';
                    break;
                case '<':
                    buf += '&lt;';
                    break;
                case '\"':
                    buf += '&quot;';
                    break;
                case '\n':
                    buf += '&#xA;';
                    break;
                case '\r':
                    buf += '&#xD;';
                    break;
                case '\t':
                    buf += '&#x9;';
                    break;
                default:
                    buf += ch;
                    break;
            }
        }
        return buf;
    }
    function isWhitespace(s, index) {
        var ch = s[index];
        return ch === ' ' || ch === '\n' || ch === '\r' || ch === '\t';
    }
    function isWhitespaceString(s) {
        release$1 || assert(typeof s === 'string');
        for (var i = 0; i < s.length; i++) {
            var ch = s[i];
            if (!(ch === ' ' || ch === '\n' || ch === '\r' || ch === '\t')) {
                return false;
            }
        }
        return true;
    }
    function trimWhitespaces(s) {
        var i = 0;
        while (i < s.length && isWhitespace(s, i)) {
            i++;
        }
        if (i >= s.length) {
            return '';
        }
        var j = s.length - 1;
        while (isWhitespace(s, j)) {
            j--;
        }
        return i === 0 && j === s.length - 1 ? s : s.substring(i, j + 1);
    }
    var indentStringCache = [];
    function getIndentString(indent) {
        if (indent > 0) {
            if (indentStringCache[indent] !== undefined) {
                return indentStringCache[indent];
            }
            var s = '';
            for (var i = 0; i < indent; i++) {
                s += ' ';
            }
            indentStringCache[indent] = s;
            return s;
        }
        return '';
    }
    function generateUniquePrefix(namespaces) {
        var i = 1, newPrefix;
        while (true) {
            newPrefix = '_ns' + i;
            if (!namespaces.some(function (ns) { return ns.prefix === newPrefix; })) {
                return newPrefix;
            }
            i++;
        }
    }
    // 10.2 ToXMLString
    function toXMLString(sec, node) {
        if (node === null || node === undefined) {
            throw new TypeError();
        }
        return escapeElementValue(sec, node);
    }
    // 10.3 ToXML
    function toXML(v, sec) {
        if (v === null) {
            sec.throwError('TypeError', Errors$1.ConvertNullToObjectError);
        }
        if (v === undefined) {
            sec.throwError('TypeError', Errors$1.ConvertUndefinedToObjectError);
        }
        if (v.axClass === sec.AXXML) {
            return v;
        }
        if (v.axClass === sec.AXXMLList) {
            if (v._children.length !== 1) {
                sec.throwError('TypeError', Errors$1.XMLMarkupMustBeWellFormed);
            }
            return v._children[0];
        }
        // The E4X spec says we must throw a TypeError for non-Boolean, Number, or String objects.
        // Flash thinks otherwise.
        var x = sec.xmlParser.parseFromString(axCoerceString$3(v));
        var length = x._children.length;
        if (length === 0) {
            return createXML(sec, 3 /* Text */);
        }
        if (length === 1) {
            x._children[0]._parent = null;
            return x._children[0];
        }
        if (length === 2) {
            x._children[1]._parent = null;
            return x._children[1];
        }
        sec.throwError('TypeError', Errors$1.XMLMarkupMustBeWellFormed);
    }
    // 10.4 ToXMLList
    function toXMLList(value, targetList) {
        // toXMLList is supposed to just return value if it's an XMLList already. For optimization
        // purposes, we handle that case at the callsites.
        release$1 || assert(typeof value !== 'object' || value && value.axClass !== targetList.axClass);
        if (value === null) {
            targetList.sec.throwError('TypeError', Errors$1.ConvertNullToObjectError);
        }
        if (value === undefined) {
            targetList.sec.throwError('TypeError', Errors$1.ConvertUndefinedToObjectError);
        }
        if (value.axClass === targetList.sec.AXXML) {
            targetList.append(value);
            return;
        }
        // The E4X spec says we must throw a TypeError for non-Boolean, Number, or String objects.
        // Flash thinks otherwise.
        var defaultNamespace = getDefaultNamespace(targetList.sec);
        var parentString = '<parent xmlns="' + escapeAttributeValue(defaultNamespace.uri) + '">' +
            value + '</parent>';
        var x = toXML(parentString, targetList.sec);
        var children = x._children;
        if (!children) {
            return;
        }
        for (var i = 0; i < children.length; i++) {
            var v = children[i];
            v._parent = null;
            targetList.append(v);
        }
    }
    // 10.6 ToXMLName
    function toXMLName(mn, sec) {
        if (mn === undefined) {
            return anyMultiname;
        }
        var name;
        // convert argument to a value of type AttributeName or a QName object
        // according to the following:
        if (typeof mn === 'object' && mn !== null) {
            if (mn instanceof Multiname) {
                return mn;
            }
            if (mn.axClass === sec.AXQName) {
                // Object - If the input argument is a QName object,
                // return its Multiname.
                return mn.name;
            }
            // Object - Otherwise, convert the input argument to a string using ToString.
            name = String(mn);
        }
        else if (typeof mn === 'number') {
            name = mn + '';
        }
        else if (typeof mn === 'string') {
            // String - Create a QName object or AttributeName from the String
            // as specified below in section 10.6.1. See below.
            if (mn === '*') {
                name = null;
            }
            else {
                name = mn;
            }
        }
        else {
            sec.throwError('TypeError', Errors$1.XMLInvalidName, mn);
        }
        // ... then convert the result to a QName object or AttributeName
        // as specified in section 10.6.1.
        if (name && name[0] === '@') {
            // If the first character of s is "@", ToXMLName creates an
            // AttributeName using the ToAttributeName operator.
            name = name.substr(1);
            if (name === '*') {
                name = null;
            }
            return new Multiname(null, 0, 13 /* QNameA */, [Namespace.PUBLIC], name);
        }
        return new Multiname(null, 0, 7 /* QName */, [Namespace.PUBLIC], name);
    }
    function coerceE4XMultiname(mn, sec) {
        var out = tmpMultiname;
        out.kind = mn.kind;
        // Queries of the foo[new QName('bar')] sort create this situation.
        if (mn.name && mn.name.axClass === sec.AXQName) {
            mn = mn.name.name;
        }
        if (mn.isQName()) {
            out.name = mn.name;
            out.namespaces = mn.namespaces;
        }
        else {
            if (mn.isAnyNamespace()) {
                out.namespaces = mn.namespaces;
            }
            else {
                var defaultNS = getDefaultNamespace(sec);
                var namespaces = mn.namespaces;
                var containsDefaultNS = false;
                for (var i = 0; i < namespaces.length; i++) {
                    var ns = namespaces[i];
                    if (ns.uri === defaultNS.uri && ns.prefix === defaultNS.prefix &&
                        ns.type === defaultNS.type) {
                        containsDefaultNS = true;
                        break;
                    }
                }
                if (!containsDefaultNS) {
                    out.namespaces = mn.namespaces.concat(defaultNS);
                }
                else {
                    out.namespaces = mn.namespaces;
                }
            }
        }
        var name = mn.name;
        if (mn.isAnyName() || name === '*' || name === null) {
            out.name = null;
        }
        else if (name.length > 1 && name[0] === '@') {
            if (!out.isAttribute()) {
                if (name === '@*') {
                    out.name = null;
                }
                else {
                    out.name = name.substr(1);
                }
                out.kind = out.namespaces.length === 1 ? 13 /* QNameA */ : 14 /* MultinameA */;
            }
            else {
                out.name = name;
            }
        }
        else {
            out.name = name;
        }
        return out;
    }
    // 12.1 GetDefaultNamespace
    function getDefaultNamespace(sec) {
        var scope = getCurrentScope();
        while (scope) {
            if (scope.defaultNamespace) {
                return scope.defaultNamespace;
            }
            scope = scope.parent;
        }
        if (!sec.AXNamespace.defaultNamespace) {
            sec.AXNamespace.defaultNamespace = new Namespace(0 /* Public */, "default", "");
        }
        // The outermost default xml namespace is stored in sec.AXNamespace.defaultNamespace.
        return sec.AXNamespace.defaultNamespace;
    }
    /**
     * 13.3.5.4 [[GetNamespace]] ( [ InScopeNamespaces ] )
     *
     * The [[GetNamespace]] method is an internal method that returns a Namespace object with a URI
     * matching the URI of this QName. InScopeNamespaces is an optional parameter. If
     * InScopeNamespaces is unspecified, it is set to the empty set. If one or more Namespaces
     * exists in InScopeNamespaces with a URI matching the URI of this QName, one of the matching
     * Namespaces will be returned. If no such namespace exists in InScopeNamespaces,
     * [[GetNamespace]] creates and returns a new Namespace with a URI matching that of this QName.
     * For implementations that preserve prefixes in QNames, [[GetNamespace]] may return a
     * Namespace that also has a matching prefix. The input argument InScopeNamespaces is a set of
     * Namespace objects.
     */
    function GetNamespace(mn, inScopeNamespaces) {
        release$1 || assert(mn.isQName());
        var uri = mn.uri;
        for (var i = 0; inScopeNamespaces && i < inScopeNamespaces.length; i++) {
            if (uri === inScopeNamespaces[i].uri) {
                return inScopeNamespaces[i];
            }
        }
        return mn.namespaces[0];
    }
    // 13.1.2.1 isXMLName ( value )
    function isXMLName(v, sec) {
        try {
            var qn = sec.AXQName.Create(v);
        }
        catch (e) {
            return false;
        }
        // FIXME scan v to see if it is a valid lexeme and return false if not
        return true;
    }
    var tmpMultiname = new Multiname(null, 0, 7 /* QName */, [], null, null, true);
    var anyMultiname = new Multiname(null, 0, 7 /* QName */, [], null, null, true);
    release$1 || Object.seal(anyMultiname);
    var XMLParserBase = /** @class */ (function () {
        function XMLParserBase() {
        }
        XMLParserBase.prototype.resolveEntities = function (s) {
            return s.replace(/&([^;]+);/g, function (all, entity) {
                if (entity.substring(0, 2) === '#x') {
                    return String.fromCharCode(parseInt(entity.substring(2), 16));
                }
                else if (entity.substring(0, 1) === '#') {
                    return String.fromCharCode(parseInt(entity.substring(1), 10));
                }
                switch (entity) {
                    case 'lt':
                        return '<';
                    case 'gt':
                        return '>';
                    case 'amp':
                        return '&';
                    case 'quot':
                        return '\"';
                }
                // throw "Unknown entity: " + entity;
                return all;
            });
        };
        XMLParserBase.prototype.parseContent = function (s, start) {
            var pos = start, name, attributes = [];
            function skipWs() {
                while (pos < s.length && isWhitespace(s, pos)) {
                    ++pos;
                }
            }
            while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== ">" && s[pos] !== "/") {
                ++pos;
            }
            name = s.substring(start, pos);
            skipWs();
            while (pos < s.length && s[pos] !== ">" &&
                s[pos] !== "/" && s[pos] !== "?") {
                skipWs();
                var attrName = "", attrValue = "";
                while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== "=") {
                    attrName += s[pos];
                    ++pos;
                }
                skipWs();
                if (s[pos] !== "=") {
                    return null;
                }
                ++pos;
                skipWs();
                var attrEndChar = s[pos];
                if (attrEndChar !== "\"" && attrEndChar !== "\'") {
                    return null;
                }
                var attrEndIndex = s.indexOf(attrEndChar, ++pos);
                if (attrEndIndex < 0) {
                    return null;
                }
                attrValue = s.substring(pos, attrEndIndex);
                attributes.push({ name: attrName, value: this.resolveEntities(attrValue) });
                pos = attrEndIndex + 1;
                skipWs();
            }
            return { name: name, attributes: attributes, parsed: pos - start };
        };
        XMLParserBase.prototype.parseProcessingInstruction = function (s, start) {
            var pos = start, name, value;
            function skipWs() {
                while (pos < s.length && isWhitespace(s, pos)) {
                    ++pos;
                }
            }
            while (pos < s.length && !isWhitespace(s, pos) && s[pos] !== ">" && s[pos] !== "/") {
                ++pos;
            }
            name = s.substring(start, pos);
            skipWs();
            var attrStart = pos;
            while (pos < s.length && (s[pos] !== "?" || s[pos + 1] != '>')) {
                ++pos;
            }
            value = s.substring(attrStart, pos);
            return { name: name, value: value, parsed: pos - start };
        };
        XMLParserBase.prototype.parseXml = function (s) {
            var i = 0;
            while (i < s.length) {
                var ch = s[i];
                var j = i;
                if (ch === "<") {
                    ++j;
                    var ch2 = s[j], q;
                    switch (ch2) {
                        case "/":
                            ++j;
                            q = s.indexOf(">", j);
                            if (q < 0) {
                                this.onError(-9 /* UnterminatedElement */);
                                return;
                            }
                            this.onEndElement(s.substring(j, q));
                            j = q + 1;
                            break;
                        case "?":
                            ++j;
                            var pi = this.parseProcessingInstruction(s, j);
                            if (s.substring(j + pi.parsed, j + pi.parsed + 2) != "?>") {
                                this.onError(-3 /* UnterminatedXmlDeclaration */);
                                return;
                            }
                            this.onPi(pi.name, pi.value);
                            j += pi.parsed + 2;
                            break;
                        case "!":
                            if (s.substring(j + 1, j + 3) === "--") {
                                q = s.indexOf("-->", j + 3);
                                if (q < 0) {
                                    this.onError(-5 /* UnterminatedComment */);
                                    return;
                                }
                                this.onComment(s.substring(j + 3, q));
                                j = q + 3;
                            }
                            else if (s.substring(j + 1, j + 8) === "[CDATA[") {
                                q = s.indexOf("]]>", j + 8);
                                if (q < 0) {
                                    this.onError(-2 /* UnterminatedCdat */);
                                    return;
                                }
                                this.onCdata(s.substring(j + 8, q));
                                j = q + 3;
                            }
                            else if (s.substring(j + 1, j + 8) === "DOCTYPE") {
                                var q2 = s.indexOf("[", j + 8), complexDoctype = false;
                                q = s.indexOf(">", j + 8);
                                if (q < 0) {
                                    this.onError(-4 /* UnterminatedDoctypeDeclaration */);
                                    return;
                                }
                                if (q2 > 0 && q > q2) {
                                    q = s.indexOf("]>", j + 8);
                                    if (q < 0) {
                                        this.onError(-4 /* UnterminatedDoctypeDeclaration */);
                                        return;
                                    }
                                    complexDoctype = true;
                                }
                                var doctypeContent = s.substring(j + 8, q + (complexDoctype ? 1 : 0));
                                this.onDoctype(doctypeContent);
                                // XXX pull entities ?
                                j = q + (complexDoctype ? 2 : 1);
                            }
                            else {
                                this.onError(-6 /* MalformedElement */);
                                return;
                            }
                            break;
                        default:
                            var content = this.parseContent(s, j);
                            if (content === null) {
                                this.onError(-6 /* MalformedElement */);
                                return;
                            }
                            var isClosed = false;
                            if (s.substring(j + content.parsed, j + content.parsed + 2) === "/>") {
                                isClosed = true;
                            }
                            else if (s.substring(j + content.parsed, j + content.parsed + 1) !== ">") {
                                this.onError(-9 /* UnterminatedElement */);
                                return;
                            }
                            this.onBeginElement(content.name, content.attributes, isClosed);
                            j += content.parsed + (isClosed ? 2 : 1);
                            break;
                    }
                }
                else {
                    do {
                    } while (j++ < s.length && s[j] !== "<");
                    var text = s.substring(i, j);
                    this.onText(this.resolveEntities(text));
                }
                i = j;
            }
        };
        XMLParserBase.prototype.onPi = function (name, value) {
        };
        XMLParserBase.prototype.onComment = function (text) {
        };
        XMLParserBase.prototype.onCdata = function (text) {
        };
        XMLParserBase.prototype.onDoctype = function (doctypeContent) {
        };
        XMLParserBase.prototype.onText = function (text) {
        };
        XMLParserBase.prototype.onBeginElement = function (name, attributes, isEmpty) {
        };
        XMLParserBase.prototype.onEndElement = function (name) {
        };
        XMLParserBase.prototype.onError = function (code) {
        };
        return XMLParserBase;
    }());
    var XMLParser = /** @class */ (function (_super) {
        __extends(XMLParser, _super);
        function XMLParser(sec) {
            var _this = _super.call(this) || this;
            _this.sec = sec;
            _this.scopes = [];
            return _this;
        }
        XMLParser.prototype.isWhitespacePreserved = function () {
            var scopes = this.scopes;
            for (var j = scopes.length - 1; j >= 0; --j) {
                if (scopes[j].space === "preserve") {
                    return true;
                }
            }
            return false;
        };
        XMLParser.prototype.lookupDefaultNs = function () {
            var scopes = this.scopes;
            for (var j = scopes.length - 1; j >= 0; --j) {
                if ('xmlns' in scopes[j]) {
                    return scopes[j].xmlns;
                }
            }
            return '';
        };
        XMLParser.prototype.lookupNs = function (prefix) {
            var scopes = this.scopes;
            for (var j = scopes.length - 1; j >= 0; --j) {
                if (prefix in scopes[j].lookup) {
                    return scopes[j].lookup[prefix];
                }
            }
            return undefined;
        };
        XMLParser.prototype.getName = function (name, resolveDefaultNs) {
            var j = name.indexOf(':');
            if (j >= 0) {
                var prefix = name.substring(0, j);
                var localName = name.substring(j + 1);
                var namespace = this.lookupNs(prefix);
                if (namespace === undefined) {
                    this.sec.throwError('TypeError', Errors$1.XMLPrefixNotBound, prefix, localName);
                }
                return {
                    name: namespace + '::' + localName,
                    localName: localName,
                    prefix: prefix,
                    namespace: namespace,
                };
            }
            else if (resolveDefaultNs) {
                return {
                    name: name,
                    localName: name,
                    prefix: '',
                    namespace: this.lookupDefaultNs()
                };
            }
            else {
                return {
                    name: name,
                    localName: name,
                    prefix: '',
                    namespace: ''
                };
            }
        };
        XMLParser.prototype.onError = function (code) {
            switch (code) {
                case -6 /* MalformedElement */:
                    this.sec.throwError('TypeError', Errors$1.XMLMalformedElement);
                    return;
                case -9 /* UnterminatedElement */:
                    this.sec.throwError('TypeError', Errors$1.XMLUnterminatedElement);
                    return;
                case -4 /* UnterminatedDoctypeDeclaration */:
                    this.sec.throwError('TypeError', Errors$1.XMLUnterminatedDocTypeDecl);
                    return;
                case -2 /* UnterminatedCdat */:
                    this.sec.throwError('TypeError', Errors$1.XMLUnterminatedCData);
                    return;
                case -5 /* UnterminatedComment */:
                    this.sec.throwError('TypeError', Errors$1.XMLUnterminatedComment);
                    return;
                case -3 /* UnterminatedXmlDeclaration */:
                    this.sec.throwError('TypeError', Errors$1.XMLUnterminatedXMLDecl);
                    return;
            }
        };
        XMLParser.prototype.onPi = function (name, value) {
            this.pi(name, value);
        };
        XMLParser.prototype.onComment = function (text) {
            this.comment(text);
        };
        XMLParser.prototype.onCdata = function (text) {
            this.cdata(text);
        };
        XMLParser.prototype.onDoctype = function (doctypeContent) {
            this.doctype(doctypeContent);
        };
        XMLParser.prototype.onText = function (text) {
            this.text(text, this.isWhitespacePreserved());
        };
        XMLParser.prototype.onBeginElement = function (name, contentAttributes, isEmpty) {
            var scopes = this.scopes;
            var scope = {
                namespaces: [],
                lookup: Object.create(null),
                inScopes: null
            };
            for (var q = 0; q < contentAttributes.length; ++q) {
                var attribute = contentAttributes[q];
                var attributeName = attribute.name;
                if (attributeName.substring(0, 6) === "xmlns:") {
                    var prefix = attributeName.substring(6);
                    var uri = attribute.value;
                    if (this.lookupNs(prefix) !== uri) {
                        scope.lookup[prefix] = trimWhitespaces(uri);
                        var ns = internPrefixedNamespace(0 /* Public */, uri, prefix);
                        scope.namespaces.push(ns);
                    }
                    contentAttributes[q] = null;
                }
                else if (attributeName === "xmlns") {
                    var uri = attribute.value;
                    if (this.lookupDefaultNs() !== uri) {
                        scope["xmlns"] = trimWhitespaces(uri);
                        var ns = internNamespace(0 /* Public */, uri);
                        scope.namespaces.push(ns);
                    }
                    contentAttributes[q] = null;
                }
                else if (attributeName.substring(0, 4) === "xml:") {
                    var xmlAttrName = attributeName.substring(4);
                    scope[xmlAttrName] = trimWhitespaces(attribute.value);
                }
                else {
                    // skip ordinary attributes until all xmlns have been handled
                }
            }
            // build list of all namespaces including ancestors'
            var inScopeNamespaces = [];
            scope.namespaces.forEach(function (ns) {
                if (!ns.prefix || scope.lookup[ns.prefix] === ns.uri) {
                    inScopeNamespaces.push(ns);
                }
            });
            scopes[scopes.length - 1].inScopes.forEach(function (ns) {
                if ((ns.prefix && !(ns.prefix in scope.lookup)) ||
                    (!ns.prefix && !('xmlns' in scope))) {
                    inScopeNamespaces.push(ns);
                }
            });
            scope.inScopes = inScopeNamespaces;
            scopes.push(scope);
            var attributes = [];
            for (q = 0; q < contentAttributes.length; ++q) {
                attribute = contentAttributes[q];
                if (attribute) {
                    attributes.push({
                        name: this.getName(attribute.name, false),
                        value: attribute.value
                    });
                }
            }
            this.beginElement(this.getName(name, true), attributes, inScopeNamespaces, isEmpty);
            if (isEmpty) {
                scopes.pop();
            }
        };
        XMLParser.prototype.onEndElement = function (name) {
            this.endElement(this.getName(name, true));
            this.scopes.pop();
        };
        XMLParser.prototype.beginElement = function (name, attrs, namespaces, isEmpty) {
            var parent = this.currentElement;
            this.elementsStack.push(parent);
            this.currentElement = createXML(this.sec, 1 /* Element */, name.namespace, name.localName, name.prefix);
            for (var i = 0; i < attrs.length; ++i) {
                var rawAttr = attrs[i];
                var attr = createXML(this.sec, 2 /* Attribute */, rawAttr.name.namespace, rawAttr.name.localName, rawAttr.name.prefix);
                attr._value = rawAttr.value;
                attr._parent = this.currentElement;
                this.currentElement._attributes.push(attr);
            }
            for (var i = 0; i < namespaces.length; ++i) {
                this.currentElement._inScopeNamespaces.push(namespaces[i]);
            }
            parent.insert(parent._children.length, this.currentElement);
            if (isEmpty) {
                this.currentElement = this.elementsStack.pop();
            }
        };
        XMLParser.prototype.endElement = function (name) {
            this.currentElement = this.elementsStack.pop();
        };
        XMLParser.prototype.text = function (text, isWhitespacePreserve) {
            if (this.sec.AXXML.ignoreWhitespace) {
                text = trimWhitespaces(text);
            }
            // TODO: do an in-depth analysis of what isWhitespacePreserve is about.
            if (text.length === 0 || isWhitespacePreserve && this.sec.AXXML.ignoreWhitespace) {
                return;
            }
            var node = createXML(this.sec);
            node._value = text;
            this.currentElement.insert(this.currentElement._children.length, node);
        };
        XMLParser.prototype.cdata = function (text) {
            var node = createXML(this.sec);
            node._value = text;
            this.currentElement.insert(this.currentElement._children.length, node);
        };
        XMLParser.prototype.comment = function (text) {
            if (this.sec.AXXML.ignoreComments) {
                return;
            }
            var node = createXML(this.sec, 4 /* Comment */, "", "");
            node._value = text;
            this.currentElement.insert(this.currentElement._children.length, node);
        };
        XMLParser.prototype.pi = function (name, value) {
            if (this.sec.AXXML.ignoreProcessingInstructions) {
                return;
            }
            var node = createXML(this.sec, 5 /* ProcessingInstruction */, "", name);
            node._value = value;
            this.currentElement.insert(this.currentElement._children.length, node);
        };
        XMLParser.prototype.doctype = function (text) { };
        XMLParser.prototype.parseFromString = function (s, mimeType) {
            // placeholder
            var currentElement = this.currentElement = createXML(this.sec, 1 /* Element */, '', '', '');
            this.elementsStack = [];
            var defaultNs = getDefaultNamespace(this.sec);
            var scopes = [{
                    namespaces: [],
                    lookup: {
                        "xmlns": 'http://www.w3.org/2000/xmlns/',
                        "xml": 'http://www.w3.org/XML/1998/namespace'
                    },
                    inScopes: [defaultNs],
                    space: 'default',
                    xmlns: defaultNs.uri
                }];
            this.scopes = scopes;
            this.parseXml(s);
            this.currentElement = null;
            if (this.elementsStack.length > 0) {
                var nm = this.elementsStack.pop()._name.name;
                this.sec.throwError('TypeError', Errors$1.XMLUnterminatedElementTag, nm, nm);
            }
            this.elementsStack = null;
            return currentElement;
        };
        return XMLParser;
    }(XMLParserBase));
    var ASNamespace = /** @class */ (function (_super) {
        __extends(ASNamespace, _super);
        /**
         * 13.2.2 The Namespace Constructor
         *
         * Namespace ()
         * Namespace (uriValue)
         * Namespace (prefixValue, uriValue)
         */
        function ASNamespace(uriOrPrefix_, uri_) {
            var _this = _super.call(this) || this;
            // 1. Create a new Namespace object n
            var uri = "";
            var prefix = "";
            // 2. If prefixValue is not specified and uriValue is not specified
            if (arguments.length === 0) {
                // a. Let n.prefix be the empty string
                // b. Let n.uri be the empty string
            }
            // 3. Else if prefixValue is not specified
            else if (arguments.length === 1) {
                var uriValue = uriOrPrefix_;
                if (uriValue instanceof Namespace) {
                    _this._ns = uriValue;
                    return _this;
                }
                release$1 || checkValue(uriValue);
                if (uriValue && typeof uriValue === 'object') {
                    // Non-spec'ed, but very useful:
                    // a. If Type(uriValue) is Object and uriValue.[[Class]] == "Namespace"
                    if (uriValue.axClass === _this.sec.AXNamespace) {
                        var uriValueAsNamespace = uriValue;
                        // i. Let n.prefix = uriValue.prefix
                        prefix = uriValueAsNamespace.prefix;
                        // ii. Let n.uri = uriValue.uri
                        uri = uriValueAsNamespace.uri;
                    }
                    // b. Else if Type(uriValue) is Object and uriValue.[[Class]] == "QName" and uriValue.uri
                    // is not null
                    else if (uriValue.axClass === _this.sec.AXQName &&
                        uriValue.uri !== null) {
                        // i. Let n.uri = uriValue.uri
                        uri = uriValue.uri;
                        // NOTE implementations that preserve prefixes in qualified names may also set n.prefix
                        // = uriValue.[[Prefix]]
                    }
                }
                // c. Else
                else {
                    // i. Let n.uri = ToString(uriValue)
                    uri = toString(uriValue, _this.sec);
                    // ii. If (n.uri is the empty string), let n.prefix be the empty string
                    if (uri === "") {
                        prefix = "";
                    }
                    // iii. Else n.prefix = undefined
                    else {
                        prefix = undefined;
                    }
                }
            }
            // 4. Else
            else {
                var prefixValue = uriOrPrefix_;
                var uriValue = uri_;
                // a. If Type(uriValue) is Object and uriValue.[[Class]] == "QName" and uriValue.uri is not
                // null
                if (isObject$1(uriValue) && uriValue.axClass === _this.sec.AXQName &&
                    uriValue.uri !== null) {
                    // i. Let n.uri = uriValue.uri
                    uri = uriValue.uri;
                }
                // b. Else
                else {
                    // i. Let n.uri = ToString(uriValue)
                    uri = toString(uriValue, _this.sec);
                }
                // c. If n.uri is the empty string
                if (uri === "") {
                    // i. If prefixValue is undefined or ToString(prefixValue) is the empty string
                    if (prefixValue === undefined || toString(prefixValue, _this.sec) === "") {
                        // 1. Let n.prefix be the empty string
                        prefix = "";
                    }
                    else {
                        // ii. Else throw a TypeError exception
                        _this.sec.throwError('TypeError', Errors$1.XMLNamespaceWithPrefixAndNoURI, prefixValue);
                    }
                }
                // d. Else if prefixValue is undefined, let n.prefix = undefined
                else if (prefixValue === undefined) {
                    prefix = undefined;
                }
                // e. Else if isXMLName(prefixValue) == false
                else if (isXMLName(prefixValue, _this.sec) === false) {
                    // i. Let n.prefix = undefined
                    prefix = undefined;
                }
                // f. Else let n.prefix = ToString(prefixValue)
                else {
                    prefix = toString(prefixValue, _this.sec);
                }
            }
            // 5. Return n
            _this._ns = internPrefixedNamespace(0 /* Public */, uri, prefix);
            return _this;
        }
        ASNamespace.classInitializer = function () {
            defineNonEnumerableProperty(this, '$Bglength', 2);
            var proto = this.dPrototype;
            var asProto = ASNamespace.prototype;
            defineNonEnumerableProperty(proto, '$BgtoString', asProto.toString);
        };
        /**
         * 13.2.1 The Namespace Constructor Called as a Function
         *
         * Namespace ()
         * Namespace (uriValue)
         * Namespace (prefixValue, uriValue)
         */
        ASNamespace.axApply = function (self, args) {
            var a = args[0];
            var b = args[1];
            // 1. If (prefixValue is not specified and Type(uriValue) is Object and
            // uriValue.[[Class]] == "Namespace")
            if (args.length === 1 && isObject$1(a) && a.axClass === this.sec.AXNamespace) {
                // a. Return uriValue
                return a;
            }
            // 2. Create and return a new Namespace object exactly as if the Namespace constructor had
            // been called with the same arguments (section 13.2.2).
            switch (args.length) {
                case 0:
                    return this.sec.AXNamespace.Create();
                case 1:
                    return this.sec.AXNamespace.Create(a);
                default:
                    return this.sec.AXNamespace.Create(a, b);
            }
        };
        ASNamespace.Create = function (uriOrPrefix_, uri_) {
            var ns = Object.create(this.sec.AXNamespace.tPrototype);
            // The initializer relies on arguments.length being correct.
            ns.axInitializer.apply(ns, arguments);
            return ns;
        };
        ASNamespace.FromNamespace = function (ns) {
            var result = Object.create(this.sec.AXNamespace.tPrototype);
            result._ns = ns;
            return result;
        };
        // E4X 11.5.1 The Abstract Equality Comparison Algorithm, step 3.c.
        ASNamespace.prototype.equals = function (other) {
            return other && other.axClass === this.axClass &&
                other._ns.uri === this._ns.uri ||
                typeof other === 'string' && this._ns.uri === other;
        };
        Object.defineProperty(ASNamespace.prototype, "prefix", {
            get: function () {
                return this._ns.prefix;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASNamespace.prototype, "uri", {
            get: function () {
                return this._ns.uri;
            },
            enumerable: true,
            configurable: true
        });
        ASNamespace.prototype.toString = function () {
            if (this === this.axClass.dPrototype) {
                return '';
            }
            return this._ns.uri;
        };
        ASNamespace.prototype.valueOf = function () {
            if (this === this.axClass.dPrototype) {
                return '';
            }
            return this._ns.uri;
        };
        ASNamespace.instanceConstructor = ASNamespace;
        ASNamespace.defaultNamespace = Namespace.PUBLIC;
        return ASNamespace;
    }(ASObject$1));
    var ASQName = /** @class */ (function (_super) {
        __extends(ASQName, _super);
        /**
         * 13.3.2 The QName Constructor
         *
         * new QName ()
         * new QName (Name)
         * new QName (Namespace, Name)
         */
        function ASQName(nameOrNS_, name_) {
            var _this = _super.call(this) || this;
            var name;
            var namespace;
            if (arguments.length === 0) {
                name = "";
            }
            else if (arguments.length === 1) {
                name = nameOrNS_;
            }
            else { // if (arguments.length === 2) {
                namespace = nameOrNS_;
                name = name_;
            }
            // 1. If (Type(Name) is Object and Name.[[Class]] == "QName")
            if (name && name.axClass === _this.sec.AXQName) {
                // a. If (Namespace is not specified), return a copy of Name
                if (arguments.length < 2) {
                    release$1 || assert(name !== tmpMultiname);
                    _this.name = name.name;
                    return _this;
                }
                // b. Else let Name = Name.localName
                else {
                    name = name.localName;
                }
            }
            // 2. If (Name is undefined or not specified)
            if (name === undefined) {
                // a. Let Name = ""
                name = "";
            }
            // 3. Else let Name = ToString(Name)
            else {
                name = toString(name, _this.sec);
            }
            // 4. If (Namespace is undefined or not specified)
            if (namespace === undefined) {
                // a. If Name = "*"
                if (name === "*") {
                    // i. Let Namespace = null
                    namespace = null;
                }
                // b. Else
                else {
                    // i. Let Namespace = GetDefaultNamespace()
                    namespace = getDefaultNamespace(_this.sec);
                }
            }
            // 5. Let q be a new QName with q.localName = Name
            var localName = name;
            var ns = null;
            // 6. If Namespace == null
            if (namespace !== null) {
                // a. Let Namespace be a new Namespace created as if by calling the constructor new
                // Namespace(Namespace)
                if (namespace.axClass !== _this.sec.AXNamespace) {
                    namespace = _this.sec.AXNamespace.Create(namespace);
                }
                ns = namespace._ns;
                //// b. Let q.uri = Namespace.uri
                //uri = namespace.uri;
                // NOTE implementations that preserve prefixes in qualified names may also set
                // q.[[Prefix]] to Namespace.prefix
                //} else {
                // a. Let q.uri = null
                // NOTE implementations that preserve prefixes in qualified names may also set q.[[Prefix]]
                // to undefined
                //uri = null;
            }
            // 8. Return q
            _this.name = new Multiname(null, 0, 7 /* QName */, [ns], localName);
            return _this;
        }
        ASQName.classInitializer = function () {
            defineNonEnumerableProperty(this, '$Bglength', 2);
            var proto = this.dPrototype;
            var asProto = ASQName.prototype;
            defineNonEnumerableProperty(proto, '$BgtoString', asProto.ecmaToString);
        };
        ASQName.Create = function (nameOrNS_, name_, isAttribute) {
            var name = Object.create(this.sec.AXQName.tPrototype);
            // The initializer relies on arguments.length being correct.
            name.axInitializer.apply(name, arguments);
            return name;
        };
        ASQName.FromMultiname = function (mn) {
            var name = Object.create(this.sec.AXQName.tPrototype);
            name.name = mn;
            return name;
        };
        /**
         * 13.3.1 The QName Constructor Called as a Function
         *
         * QName ( )
         * QName ( Name )
         * QName ( Namespace , Name )
         */
        ASQName.axApply = function (self, args) {
            var nameOrNS_ = args[0];
            var name_ = args[1];
            // 1. If Namespace is not specified and Type(Name) is Object and Name.[[Class]] == “QName”
            if (args.length === 1 && nameOrNS_ && nameOrNS_.axClass === this.sec.AXQName) {
                // a. Return Name
                return nameOrNS_;
            }
            // 2. Create and return a new QName object exactly as if the QName constructor had been
            // called with the same arguments (section 13.3.2).
            switch (args.length) {
                case 0:
                    return this.sec.AXQName.Create();
                case 1:
                    return this.sec.AXQName.Create(nameOrNS_);
                default:
                    return this.sec.AXQName.Create(nameOrNS_, name_);
            }
        };
        // E4X 11.5.1 The Abstract Equality Comparison Algorithm, step 3.b.
        ASQName.prototype.equals = function (other) {
            return other && other.axClass === this.sec.AXQName &&
                other.uri === this.uri && other.name.name === this.name.name ||
                typeof other === 'string' && this.toString() === other;
        };
        Object.defineProperty(ASQName.prototype, "localName", {
            get: function () {
                return this.name.name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASQName.prototype, "uri", {
            get: function () {
                var namespaces = this.name.namespaces;
                return namespaces.length > 1 ? '' : namespaces[0] ? namespaces[0].uri : null;
            },
            enumerable: true,
            configurable: true
        });
        ASQName.prototype.ecmaToString = function () {
            if (this && this === this.sec.AXQName.dPrototype) {
                return "";
            }
            if (!(this && this.axClass === this.sec.AXQName)) {
                this.sec.throwError('TypeError', Errors$1.InvokeOnIncompatibleObjectError, "QName.prototype.toString");
            }
            return this.toString();
        };
        ASQName.prototype.toString = function () {
            var uri = this.uri;
            if (uri === "") {
                return this.name.name;
            }
            if (uri === null) {
                return "*::" + this.name.name;
            }
            uri = uri + '';
            var cc = uri.charCodeAt(uri.length - 1);
            // strip the version mark, if there is one
            var base_uri = uri;
            if (cc >= 0xE000 && cc <= 0xF8FF) {
                base_uri = uri.substr(0, uri.length - 1);
            }
            if (base_uri === "") {
                return this.name.name;
            }
            return base_uri + "::" + this.name.name;
        };
        ASQName.prototype.valueOf = function () {
            return this;
        };
        Object.defineProperty(ASQName.prototype, "prefix", {
            /**
             * 13.3.5.3 [[Prefix]]
             * The [[Prefix]] property is an optional internal property that is not directly visible to
             * users. It may be used by implementations that preserve prefixes in qualified names. The
             * value of the [[Prefix]] property is a value of type string or undefined. If the [[Prefix]]
             * property is undefined, the prefix associated with this QName is unknown.
             */
            get: function () {
                return this.name.namespaces[0] ? this.name.namespaces[0].prefix : null;
            },
            enumerable: true,
            configurable: true
        });
        return ASQName;
    }(ASObject$1));
    var ASXML_FLAGS;
    (function (ASXML_FLAGS) {
        ASXML_FLAGS[ASXML_FLAGS["FLAG_IGNORE_COMMENTS"] = 1] = "FLAG_IGNORE_COMMENTS";
        ASXML_FLAGS[ASXML_FLAGS["FLAG_IGNORE_PROCESSING_INSTRUCTIONS"] = 2] = "FLAG_IGNORE_PROCESSING_INSTRUCTIONS";
        ASXML_FLAGS[ASXML_FLAGS["FLAG_IGNORE_WHITESPACE"] = 4] = "FLAG_IGNORE_WHITESPACE";
        ASXML_FLAGS[ASXML_FLAGS["FLAG_PRETTY_PRINTING"] = 8] = "FLAG_PRETTY_PRINTING";
        ASXML_FLAGS[ASXML_FLAGS["ALL"] = 15] = "ALL";
    })(ASXML_FLAGS || (ASXML_FLAGS = {}));
    var ASXMLKindNames = [null, 'element', 'attribute', 'text', 'comment', 'processing-instruction'];
    var ASXML = /** @class */ (function (_super) {
        __extends(ASXML, _super);
        function ASXML(value) {
            var _this = _super.call(this) || this;
            _this._parent = null;
            if (isNullOrUndefined$1(value)) {
                value = "";
            }
            if (typeof value === 'string' && value.length === 0) {
                _this._kind = 3 /* Text */;
                _this._value = '';
                return _this;
            }
            var x = toXML(value, _this.sec);
            if (isXMLType(value, _this.sec)) {
                x = x._deepCopy();
            }
            _this._kind = x._kind;
            _this._name = x._name;
            _this._value = x._value;
            _this._attributes = x._attributes;
            _this._inScopeNamespaces = x._inScopeNamespaces;
            var children = x._children;
            _this._children = children;
            if (children) {
                for (var i = 0; i < children.length; i++) {
                    var child = children[i];
                    child._parent = _this;
                }
            }
            return _this;
        }
        ASXML.classInitializer = function () {
            defineNonEnumerableProperty(this, '$Bglength', 1);
            var proto = this.dPrototype;
            var asProto = ASXML.prototype;
            addPrototypeFunctionAlias(proto, '$BgvalueOf', asProto.valueOf);
            defineNonEnumerableProperty(proto, '$BghasOwnProperty', asProto.native_hasOwnProperty);
            defineNonEnumerableProperty(proto, '$BgpropertyIsEnumerable', asProto.native_propertyIsEnumerable);
            addPrototypeFunctionAlias(this, '$Bgsettings', ASXML.native_settings);
            addPrototypeFunctionAlias(this, '$BgsetSettings', ASXML.native_setSettings);
            addPrototypeFunctionAlias(this, '$BgdefaultSettings', ASXML.native_defaultSettings);
            addPrototypeFunctionAlias(proto, '$BgtoString', asProto.toString);
            addPrototypeFunctionAlias(proto, '$BgaddNamespace', asProto.addNamespace);
            addPrototypeFunctionAlias(proto, '$BgappendChild', asProto.appendChild);
            addPrototypeFunctionAlias(proto, '$Bgattribute', asProto.attribute);
            addPrototypeFunctionAlias(proto, '$Bgattributes', asProto.attributes);
            addPrototypeFunctionAlias(proto, '$Bgchild', asProto.child);
            addPrototypeFunctionAlias(proto, '$BgchildIndex', asProto.childIndex);
            addPrototypeFunctionAlias(proto, '$Bgchildren', asProto.children);
            addPrototypeFunctionAlias(proto, '$Bgcomments', asProto.comments);
            addPrototypeFunctionAlias(proto, '$Bgcontains', asProto.contains);
            addPrototypeFunctionAlias(proto, '$Bgcopy', asProto.copy);
            addPrototypeFunctionAlias(proto, '$Bgdescendants', asProto.descendants);
            addPrototypeFunctionAlias(proto, '$Bgelements', asProto.elements);
            addPrototypeFunctionAlias(proto, '$BghasComplexContent', asProto.hasComplexContent);
            addPrototypeFunctionAlias(proto, '$BghasSimpleContent', asProto.hasSimpleContent);
            addPrototypeFunctionAlias(proto, '$BginScopeNamespaces', asProto.inScopeNamespaces);
            addPrototypeFunctionAlias(proto, '$BginsertChildAfter', asProto.insertChildAfter);
            addPrototypeFunctionAlias(proto, '$BginsertChildBefore', asProto.insertChildBefore);
            addPrototypeFunctionAlias(proto, '$Bglength', asProto.length);
            addPrototypeFunctionAlias(proto, '$BglocalName', asProto.localName);
            addPrototypeFunctionAlias(proto, '$Bgname', asProto.name);
            addPrototypeFunctionAlias(proto, '$Bgnamespace', asProto.namespace);
            addPrototypeFunctionAlias(proto, '$BgnamespaceDeclarations', asProto.namespaceDeclarations);
            addPrototypeFunctionAlias(proto, '$BgnodeKind', asProto.nodeKind);
            addPrototypeFunctionAlias(proto, '$Bgnormalize', asProto.normalize);
            addPrototypeFunctionAlias(proto, '$Bgparent', asProto.parent);
            addPrototypeFunctionAlias(proto, '$BgprocessingInstructions', asProto.processingInstructions);
            addPrototypeFunctionAlias(proto, '$BgprependChild', asProto.prependChild);
            addPrototypeFunctionAlias(proto, '$BgremoveNamespace', asProto.removeNamespace);
            addPrototypeFunctionAlias(proto, '$Bgreplace', asProto.replace);
            addPrototypeFunctionAlias(proto, '$BgsetChildren', asProto.setChildren);
            addPrototypeFunctionAlias(proto, '$BgsetLocalName', asProto.setLocalName);
            addPrototypeFunctionAlias(proto, '$BgsetName', asProto.setName);
            addPrototypeFunctionAlias(proto, '$BgsetNamespace', asProto.setNamespace);
            addPrototypeFunctionAlias(proto, '$Bgtext', asProto.text);
            addPrototypeFunctionAlias(proto, '$BgtoXMLString', asProto.toXMLString);
            addPrototypeFunctionAlias(proto, '$BgtoJSON', asProto.toJSON);
        };
        ASXML.Create = function (value) {
            var xml = Object.create(this.sec.AXXML.tPrototype);
            xml.axInitializer(value);
            return xml;
        };
        ASXML.resetSettings = function () {
            this._flags = ASXML_FLAGS.ALL;
        };
        ASXML.native_settings = function () {
            var settings = Object.create(this.sec.AXObject.tPrototype);
            settings.$BgignoreComments = this.ignoreComments;
            settings.$BgignoreProcessingInstructions = this.ignoreProcessingInstructions;
            settings.$BgignoreWhitespace = this.ignoreWhitespace;
            settings.$BgprettyPrinting = this.prettyPrinting;
            settings.$BgprettyIndent = this.prettyIndent;
            return settings;
        };
        ASXML.native_setSettings = function (o) {
            if (isNullOrUndefined$1(o)) {
                this.ignoreComments = true;
                this.ignoreProcessingInstructions = true;
                this.ignoreWhitespace = true;
                this.prettyPrinting = true;
                this.prettyIndent = 2;
                return;
            }
            if (typeof o.$BgignoreComments === 'boolean') {
                this.ignoreComments = o.$BgignoreComments;
            }
            if (typeof o.$BgignoreProcessingInstructions === 'boolean') {
                this.ignoreProcessingInstructions = o.$BgignoreProcessingInstructions;
            }
            if (typeof o.$BgignoreWhitespace === 'boolean') {
                this.ignoreWhitespace = o.$BgignoreWhitespace;
            }
            if (o.$BgprettyPrinting === 'boolean') {
                this.prettyPrinting = o.$BgprettyPrinting;
            }
            if (o.$BgprettyIndent === 'number') {
                this.prettyIndent = o.$BgprettyIndent;
            }
        };
        ASXML.native_defaultSettings = function () {
            return {
                __proto__: this.sec.AXObject.tPrototype,
                $BgignoreComments: true,
                $BgignoreProcessingInstructions: true,
                $BgignoreWhitespace: true,
                $BgprettyPrinting: true,
                $BgprettyIndent: 2
            };
        };
        ASXML.axApply = function (self, args) {
            var value = args[0];
            // 13.5.1 The XMLList Constructor Called as a Function
            if (isNullOrUndefined$1(value)) {
                value = '';
            }
            return toXML(value, this.sec);
        };
        ASXML.prototype.valueOf = function () {
            return this;
        };
        // E4X 11.5.1 The Abstract Equality Comparison Algorithm, steps 1-4.
        ASXML.prototype.equals = function (other) {
            // Steps 1,2.
            if (other && other.axClass === this.sec.AXXMLList) {
                return other.equals(this);
            }
            // Step 3.
            if (other && other.axClass === this.sec.AXXML) {
                // Step 3.a.i.
                var otherXML = other;
                if ((this._kind === 3 /* Text */ || this._kind === 2 /* Attribute */) &&
                    otherXML.hasSimpleContent() ||
                    (otherXML._kind === 3 /* Text */ || otherXML._kind === 2 /* Attribute */) &&
                        this.hasSimpleContent()) {
                    return this.toString() === other.toString();
                }
                // Step 3.a.ii.
                return this._deepEquals(other);
                // The rest of step 3 is implemented in {Namespace,QName}.equals and non-E4X parts of the
                // engine.
            }
            // Step 4.
            return this.hasSimpleContent() && this.toString() === axCoerceString$3(other);
            // The remaining steps are implemented by other means in the interpreter/compiler.
        };
        ASXML.prototype.init = function (kind, mn) {
            this._name = mn;
            this._kind = kind; // E4X [[Class]]
            this._parent = null;
            switch (kind) {
                case 1 /* Element */:
                    this._inScopeNamespaces = [];
                    this._attributes = [];
                    this._children = []; // child nodes go here
                    break;
                case 4 /* Comment */:
                case 5 /* ProcessingInstruction */:
                case 2 /* Attribute */:
                case 3 /* Text */:
                    this._value = '';
                    break;
                default:
                    break;
            }
            return this;
        };
        // 9.1.1.9 [[Equals]] (V)
        ASXML.prototype._deepEquals = function (V) {
            // Step 1.
            if (!V || V.axClass !== this.sec.AXXML) {
                return false;
            }
            var other = V;
            // Step 2.
            if (this._kind !== other._kind) {
                return false;
            }
            // Steps 3-4.
            if (!!this._name !== !!other._name || (this._name && !this._name.equalsQName(other._name))) {
                return false;
            }
            // Not in the spec, but a substantial optimization.
            if (this._kind !== 1 /* Element */) {
                // Step 7.
                // This only affects non-Element nodes, so moved up here.
                if (this._value !== other._value) {
                    return false;
                }
                return true;
            }
            // Step 5.
            var attributes = this._attributes;
            var otherAttributes = other._attributes;
            if (attributes.length !== otherAttributes.length) {
                return false;
            }
            // Step 6.
            var children = this._children;
            var otherChildren = other._children;
            if (children.length !== otherChildren.length) {
                return false;
            }
            // Step 8.
            attribOuter: for (var i = 0; i < attributes.length; i++) {
                var attribute = attributes[i];
                for (var j = 0; j < otherAttributes.length; j++) {
                    var otherAttribute = otherAttributes[j];
                    if (otherAttribute._name.equalsQName(attribute._name) &&
                        otherAttribute._value === attribute._value) {
                        continue attribOuter;
                    }
                }
                return false;
            }
            // Step 9.
            for (var i = 0; i < children.length; i++) {
                if (!children[i].equals(otherChildren[i])) {
                    return false;
                }
            }
            // Step 10.
            return true;
        };
        // 9.1.1.7 [[DeepCopy]] ( )
        ASXML.prototype._deepCopy = function () {
            var kind = this._kind;
            var clone = this.sec.AXXML.Create();
            clone._kind = kind;
            clone._name = this._name;
            switch (kind) {
                case 1 /* Element */:
                    clone._inScopeNamespaces = this._inScopeNamespaces.slice();
                    clone._attributes = this._attributes.map(function (attr) {
                        attr = attr._deepCopy();
                        attr._parent = clone;
                        return attr;
                    });
                    clone._children = this._children.map(function (child) {
                        child = child._deepCopy();
                        child._parent = clone;
                        return child;
                    });
                    break;
                case 4 /* Comment */:
                case 5 /* ProcessingInstruction */:
                case 2 /* Attribute */:
                case 3 /* Text */:
                    clone._value = this._value;
                    break;
                default:
                    break;
            }
            return clone;
        };
        // 9.1.1.10 [[ResolveValue]] ( )
        ASXML.prototype.resolveValue = function () {
            return this;
        };
        ASXML.prototype._addInScopeNamespace = function (ns) {
            if (this._inScopeNamespaces.some(function (ins) { return ins.uri === ns.uri && ins.prefix === ns.prefix; })) {
                return;
            }
            this._inScopeNamespaces.push(ns);
        };
        Object.defineProperty(ASXML, "ignoreComments", {
            get: function () {
                return !!(this._flags & ASXML_FLAGS.FLAG_IGNORE_COMMENTS);
            },
            set: function (newIgnore) {
                newIgnore = !!newIgnore;
                if (newIgnore) {
                    this._flags |= ASXML_FLAGS.FLAG_IGNORE_COMMENTS;
                }
                else {
                    this._flags &= ~ASXML_FLAGS.FLAG_IGNORE_COMMENTS;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASXML, "ignoreProcessingInstructions", {
            get: function () {
                return !!(this._flags & ASXML_FLAGS.FLAG_IGNORE_PROCESSING_INSTRUCTIONS);
            },
            set: function (newIgnore) {
                newIgnore = !!newIgnore;
                if (newIgnore) {
                    this._flags |= ASXML_FLAGS.FLAG_IGNORE_PROCESSING_INSTRUCTIONS;
                }
                else {
                    this._flags &= ~ASXML_FLAGS.FLAG_IGNORE_PROCESSING_INSTRUCTIONS;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASXML, "ignoreWhitespace", {
            get: function () {
                return !!(this._flags & ASXML_FLAGS.FLAG_IGNORE_WHITESPACE);
            },
            set: function (newIgnore) {
                newIgnore = !!newIgnore;
                if (newIgnore) {
                    this._flags |= ASXML_FLAGS.FLAG_IGNORE_WHITESPACE;
                }
                else {
                    this._flags &= ~ASXML_FLAGS.FLAG_IGNORE_WHITESPACE;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASXML, "prettyPrinting", {
            get: function () {
                return !!(this._flags & ASXML_FLAGS.FLAG_PRETTY_PRINTING);
            },
            set: function (newPretty) {
                newPretty = !!newPretty;
                if (newPretty) {
                    this._flags |= ASXML_FLAGS.FLAG_PRETTY_PRINTING;
                }
                else {
                    this._flags &= ~ASXML_FLAGS.FLAG_PRETTY_PRINTING;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASXML, "prettyIndent", {
            get: function () {
                return this._prettyIndent;
            },
            set: function (newIndent /*int*/) {
                newIndent = newIndent | 0;
                this._prettyIndent = newIndent;
            },
            enumerable: true,
            configurable: true
        });
        ASXML.prototype.toString = function () {
            if (this === this.axClass.dPrototype) {
                return '';
            }
            if (this.hasComplexContent()) {
                return this.toXMLString();
            }
            return toString(this, this.sec);
        };
        // 13.4.4.14 XML.prototype.hasOwnProperty ( P )
        ASXML.prototype.native_hasOwnProperty = function (P) {
            if (this === this.axClass.dPrototype) {
                return ASObject$1.prototype.native_hasOwnProperty.call(this, P);
            }
            var mn = toXMLName(P, this.sec);
            if (this.hasProperty(mn)) {
                return true;
            }
            return this.axHasOwnProperty(mn);
        };
        // 13.4.4.30 XML.prototype.propertyIsEnumerable ( P )
        ASXML.prototype.native_propertyIsEnumerable = function (P) {
            if (P === void 0) { P = undefined; }
            return String(P) === "0";
        };
        ASXML.prototype.addNamespace = function (ns) {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            // 13.4.4.2 XML.prototype.addNamespace ( namespace )
            this._addInScopeNamespace(ns);
            return this;
        };
        ASXML.prototype.appendChild = function (child) {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            this.insert(this._children.length, child);
            return this;
        };
        ASXML.prototype.attribute = function (arg) {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            if (isNullOrUndefined$1(arg) && arguments.length > 0) {
                this.sec.throwError('TypeError', Errors$1.ConvertUndefinedToObjectError);
            }
            if (arg && arg.axClass === this.sec.AXQName) {
                return this.getProperty(arg.name);
            }
            arg = axCoerceString$3(arg);
            if (arg === '*' || arguments.length === 0) {
                arg = null;
            }
            tmpMultiname.name = arg;
            tmpMultiname.namespaces = [Namespace.PUBLIC];
            tmpMultiname.kind = 13 /* QNameA */;
            return this.getProperty(tmpMultiname);
        };
        ASXML.prototype.attributes = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            var list = this.sec.AXXMLList.CreateList(this, this._name);
            Array.prototype.push.apply(list._children, this._attributes);
            return list;
        };
        // 13.4.4.6
        ASXML.prototype.child = function (propertyName /* string|number|QName */) {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            // Step 1.
            if (isIndex(propertyName)) {
                var list = this.sec.AXXMLList.CreateList(null, null);
                if (this._children && propertyName < this._children.length) {
                    list.append(this._children[propertyName | 0]);
                }
                return list;
            }
            // Steps 2-3.
            var mn;
            if (propertyName && propertyName.axClass === this.sec.AXQName) {
                mn = propertyName.name;
            }
            else {
                mn = tmpMultiname;
                mn.kind = 7 /* QName */;
                mn.name = toString(propertyName, this.sec);
            }
            return this.getProperty(mn);
        };
        ASXML.prototype.childIndex = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            // 13.4.4.7 XML.prototype.childIndex ( )
            if (!this._parent || this._kind === 2 /* Attribute */) {
                return -1;
            }
            return this._parent._children.indexOf(this);
        };
        ASXML.prototype.children = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            var xl = this.sec.AXXMLList.CreateList(this, this._name);
            xl._children = this._children.concat();
            return xl;
        };
        ASXML.prototype.comments = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            // 13.4.4.9 XML.prototype.comments ( )
            var xl = this.sec.AXXMLList.CreateList(this, this._name);
            this._children && this._children.forEach(function (v, i) {
                if (v._kind === 4 /* Comment */) {
                    xl.append(v);
                }
            });
            return xl;
        };
        ASXML.prototype.contains = function (value) {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            // 13.4.4.10 XML.prototype.contains ( value )
            return this === value;
        };
        ASXML.prototype.copy = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            return this._deepCopy();
        };
        // 9.1.1.8 [[Descendants]] (P)
        ASXML.prototype.descendants = function (name) {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            var xl = this.sec.AXXMLList.CreateList(this, this._name);
            return this.descendantsInto(toXMLName(name, this.sec), xl);
        };
        ASXML.prototype.elements = function (name) {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            // 13.4.4.13 XML.prototype.elements ( [ name ] )
            return this.getProperty(toXMLName(name, this.sec));
        };
        ASXML.prototype.hasComplexContent = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            // 13.4.4.15 XML.prototype.hasComplexContent( )
            if (this._kind === 2 /* Attribute */ ||
                this._kind === 4 /* Comment */ ||
                this._kind === 5 /* ProcessingInstruction */ ||
                this._kind === 3 /* Text */) {
                return false;
            }
            return this._children.some(function (child) {
                return child._kind === 1 /* Element */;
            });
        };
        ASXML.prototype.hasSimpleContent = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            // 13.4.4.16 XML.prototype.hasSimpleContent()
            if (this._kind === 4 /* Comment */ ||
                this._kind === 5 /* ProcessingInstruction */) {
                return false;
            }
            if (this._kind !== 1 /* Element */) {
                return true;
            }
            if (!this._children && this._children.length === 0) {
                return true;
            }
            return this._children.every(function (child) {
                return child._kind !== 1 /* Element */;
            });
        };
        // 13.4.4.17
        ASXML.prototype.inScopeNamespaces = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            var namespaces = this._inScopeNamespacesImpl();
            var result = [];
            for (var i = 0; i < namespaces.length; i++) {
                var AXNamespace = this.sec.AXNamespace;
                result[i] = AXNamespace.FromNamespace(namespaces[i]);
            }
            return this.sec.AXArray.axBox(result);
        };
        ASXML.prototype._inScopeNamespacesImpl = function () {
            // Step 1.
            var y = this;
            // Step 2.
            var inScopeNS = [];
            var inScopeNSMap = inScopeNS;
            // Step 3.
            while (y !== null) {
                // Step 3.a.
                var namespaces = y._inScopeNamespaces;
                for (var i = 0; namespaces && i < namespaces.length; i++) {
                    var ns = namespaces[i];
                    if (!inScopeNSMap[ns.prefix]) {
                        inScopeNSMap[ns.prefix] = ns;
                        inScopeNS.push(ns);
                    }
                }
                // Step 3.b.
                y = y._parent;
            }
            return inScopeNS;
        };
        // 13.4.4.18
        ASXML.prototype.insertChildAfter = function (child1, child2) {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            // Step 1.
            if (this._kind > 1 /* Element */) {
                return;
            }
            // Step 2.
            if (child1 == null) {
                this.insert(0, child2);
                return this;
            }
            // Step 3.
            // The spec doesn't mention it, but Tamarin seems to unpack single-entry XMLLists here.
            if (child1.axClass === this.sec.AXXMLList && child1._children.length === 1) {
                child1 = child1._children[0];
            }
            if (child1.axClass === this.sec.AXXML) {
                for (var i = 0; i < this._children.length; i++) {
                    var child = this._children[i];
                    if (child === child1) {
                        this.insert(i + 1, child2);
                        return this;
                    }
                }
            }
            // Step 4 (implicit).
        };
        // 13.4.4.19
        ASXML.prototype.insertChildBefore = function (child1, child2) {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            // Step 1.
            if (this._kind > 1 /* Element */) {
                return;
            }
            // Step 2.
            if (child1 == null) {
                this.insert(this._children.length, child2);
                return this;
            }
            // Step 3.
            // The spec doesn't mention it, but Tamarin seems to unpack single-entry XMLLists here.
            if (child1.axClass === this.sec.AXXMLList && child1._children.length === 1) {
                child1 = child1._children[0];
            }
            if (child1.axClass === this.sec.AXXML) {
                for (var i = 0; i < this._children.length; i++) {
                    var child = this._children[i];
                    if (child === child1) {
                        this.insert(i, child2);
                        return this;
                    }
                }
            }
            // Step 4 (implicit).
        };
        // XML.[[Length]]
        ASXML.prototype.length = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            if (!this._children) {
                return 0;
            }
            return this._children.length;
        };
        ASXML.prototype.localName = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            return this._name.name;
        };
        ASXML.prototype.name = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            return this.sec.AXQName.FromMultiname(this._name);
        };
        // 13.4.4.23
        ASXML.prototype.namespace = function (prefix) {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            // Step 4.a.
            if (arguments.length === 0 && this._kind >= 3 /* Text */) {
                return null;
            }
            // Steps 1-3.
            var inScopeNS = this._inScopeNamespacesImpl();
            // Step 4.
            if (arguments.length === 0) {
                // Step 4.b.
                return this.sec.AXNamespace.FromNamespace(GetNamespace(this._name, inScopeNS));
            }
            // Step 5.a.
            prefix = axCoerceString$3(prefix);
            // Step 5.b-c.
            for (var i = 0; i < inScopeNS.length; i++) {
                var ns = inScopeNS[i];
                if (ns.prefix === prefix) {
                    return this.sec.AXNamespace.FromNamespace(ns);
                }
            }
            // Step 5.b alternate clause implicit.
        };
        ASXML.prototype.namespaceDeclarations = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            release$1 || release$1 || notImplemented("public.XML::namespaceDeclarations");
            return;
        };
        ASXML.prototype.nodeKind = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            return ASXMLKindNames[this._kind];
        };
        ASXML.prototype.normalize = function () {
            if (!this || this.axClass !== this.sec.AXXML) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, this, 'XML');
            }
            // Steps 1-2.
            for (var i = 0; i < this._children.length;) {
                var child = this._children[i];
                // Step 2.a.
                if (child._kind === 1 /* Element */) {
                    child.normalize();
                    i++;
                }
                // Step 2.b.
                else if (child._kind === 3 /* Text */) {
                    // Step 2.b.i.
                    while (i + 1 < this._children.length) {
                        var nextChild = this._children[i + 1];
                        if (nextChild._kind !== 3 /* Text */) {
                            break;
                        }
                        child._value += nextChild._value;
                        this.removeByIndex(i + 1);
                    }
                    // Step 2.b.ii.
                    // The spec says to only remove 0-length nodes, but Tamarin removes whitespace-only
                    // nodes, too.
                    if (child._value.length === 0 || isWhitespaceString(child._value)) {
                        this.removeByIndex(i);
                    }
                    // Step 2.b.iii.
                    else {
                        i++;
                    }
                }
                // Step 2.c.
                else {
                    i++;
                }
            }
            return this;
        };
        ASXML.prototype.removeByIndex = function (index) {
            var child = this._children[index];
            child._parent = null;
            this._children.splice(index, 1);
        };
        ASXML.prototype.parent = function () {
            // Absurdly, and in difference to what the spec says, parent() returns `undefined` for null.
            return this._parent || undefined;
        };
        // 13.4.4.28 XML.prototype.processingInstructions ( [ name ] )
        ASXML.prototype.processingInstructions = function (name) {
            // Step 1 (implicit).
            // Step 3.
            var list = this.sec.AXXMLList.CreateList(this, this._name);
            list._targetObject = this;
            list._targetProperty = null;
            // Steps 2,4-5.
            return this.processingInstructionsInto(toXMLName(name, this.sec), list);
        };
        ASXML.prototype.processingInstructionsInto = function (name, list) {
            var localName = name || '*';
            // Step 4.
            var children = this._children;
            if (!children) {
                return list;
            }
            for (var i = 0; i < children.length; i++) {
                var child = children[i];
                if (child._kind === 5 /* ProcessingInstruction */ &&
                    (localName === '*' || child._name.name === localName)) {
                    list._children.push(child);
                }
            }
            // Step 5.
            return list;
        };
        // 13.4.4.29
        ASXML.prototype.prependChild = function (child) {
            this.insert(0, child);
            return this;
        };
        ASXML.prototype.removeNamespace = function (ns) {
            release$1 || release$1 || notImplemented("public.XML::removeNamespace");
            return;
        };
        // 13.4.4.32 XML.prototype.replace
        ASXML.prototype.replace = function (propertyName, value) {
            // Step 1.
            if (this._kind !== 1 /* Element */) {
                return;
            }
            var c;
            // Step 2.
            if (!value || value.axClass !== this.axClass && value.axClass !== this.sec.AXXMLList) {
                c = axCoerceString$3(value);
            }
            // Step 3.
            else {
                c = value._deepCopy();
            }
            // Step 4.
            var mn = toXMLName(propertyName, this.sec);
            if (isIndex(mn.name)) {
                this._replaceByIndex(mn.name | 0, c);
                // Step 10.
                return this;
            }
            var isAnyName = mn.isAnyName();
            // Step 5 (Implicit).
            // Step 6.
            var i = -1;
            // Step 7.
            var children = this._children;
            for (var k = children.length; k--;) {
                // Step 7.a.
                var child = children[k];
                if (isAnyName || child._kind === 1 /* Element */ && child._name.matches(mn)) {
                    // Step 7.a.i.
                    if (i !== -1) {
                        this.deleteByIndex(i);
                    }
                    // Step 7.a.i.
                    i = k;
                }
            }
            // Step 8.
            if (i === -1) {
                // Step 10.
                return this;
            }
            // Step 9.
            this._replaceByIndex(i, c);
            // Step 10.
            return this;
        };
        // 9.1.1.12 [[Replace]] (P, V)
        ASXML.prototype._replaceByIndex = function (p, v) {
            // Step 1.
            if (this._kind > 1 /* Element */) {
                return this;
            }
            // Steps 2-3. (Implicit, guaranteed by assert).
            release$1 || assert(typeof p === 'number' && p >>> 0 === p);
            // Step 4.
            var children = this._children;
            if (p > children.length) {
                p = children.length;
            }
            // Step 5.
            if (v && v.axClass === this.axClass && v._kind !== 2 /* Attribute */) {
                // Step 5.a.
                if (v._kind === 1 /* Element */) {
                    var a = this;
                    while (a) {
                        if (a === v) {
                            this.sec.throwError("Error", Errors$1.XMLIllegalCyclicalLoop);
                        }
                        a = a._parent;
                    }
                }
                // Step 5.b.
                v._parent = this;
                // Step 5.c.
                if (children[p]) {
                    children[p]._parent = null;
                }
                // Step 5.d.
                children[p] = v;
            }
            // Step 6.
            else if (v && v.axClass === this.sec.AXXMLList) {
                // Inlined steps.
                if (v._children.length === 0) {
                    this.deleteByIndex(p);
                }
                else {
                    var n = v._children.length;
                    if (p < children.length) {
                        children[p]._parent = null;
                        for (var i = children.length - 1; i > p; i--) {
                            children[i + n] = children[i];
                        }
                    }
                    for (var i = 0; i < n; i++) {
                        var child = v._children[i];
                        child._parent = this;
                        children[i + p] = child;
                    }
                }
            }
            // Step 7.
            else {
                // Step 7.a.
                var s = axCoerceString$3(v);
                // Step 7.b.
                var t = this.axClass.Create();
                t._kind = 3 /* Text */;
                t._value = s;
                t._parent = this;
                // Step 7.c.
                if (children[p]) {
                    children[p]._parent = null;
                }
                // Step 7.d.
                children[p] = t;
            }
        };
        ASXML.prototype.setChildren = function (value) {
            this.setProperty(anyMultiname, value);
            return this;
        };
        // 13.4.4.34 XML.prototype.setLocalName( name )
        ASXML.prototype.setLocalName = function (name_) {
            // Step 1.
            if (this._kind === 3 /* Text */ || this._kind === 4 /* Comment */) {
                return;
            }
            var name;
            // Step 2.
            if (name_ && name_.axClass === this.sec.AXQName) {
                name = name_.localName;
            }
            else {
                // Step 3.
                name = axCoerceString$3(name_);
            }
            // Step 4.
            this._name.name = name;
        };
        // 13.4.4.35 XML.prototype.setName( name )
        ASXML.prototype.setName = function (name_) {
            // Step 1.
            if (this._kind === 3 /* Text */ || this._kind === 4 /* Comment */) {
                return;
            }
            // Step 2.
            if (name_ && name_.axClass === this.sec.AXQName && name_.uri === null) {
                name_ = name_.localName;
            }
            // Step 3.
            var name = this.sec.AXQName.Create(name_).name;
            // Step 4.
            if (this._kind === 5 /* ProcessingInstruction */) {
                release$1 || assert(name.namespaces[0].type === 0 /* Public */);
                name.namespaces[0] = Namespace.PUBLIC;
            }
            // Step 5.
            this._name = name;
            // Steps 6-8.
            var node = this;
            if (this._kind === 2 /* Attribute */) {
                if (this._parent === null) {
                    return;
                }
                node = this._parent;
            }
            node.addInScopeNamespace(name.namespaces[0]);
        };
        ASXML.prototype.setNamespace = function (ns) {
            // Step 1.
            if (this._kind === 3 /* Text */ || this._kind === 4 /* Comment */ ||
                this._kind === 5 /* ProcessingInstruction */) {
                return;
            }
            // Step 2.
            var ns2 = this.sec.AXNamespace.Create(ns)._ns;
            // Step 3.
            this._name.namespaces = [ns2];
            // Step 4.
            if (this._kind === 2 /* Attribute */) {
                if (this._parent) {
                    this._parent.addInScopeNamespace(ns2);
                }
                // Step 5.
            }
            else if (this._kind === 1 /* Element */) {
                this.addInScopeNamespace(ns2);
            }
        };
        ASXML.prototype.text = function () {
            // 13.4.4.37 XML.prototype.text ( );
            var xl = this.sec.AXXMLList.CreateList(this, this._name);
            this._children && this._children.forEach(function (v, i) {
                if (v._kind === 3 /* Text */) {
                    xl.append(v);
                }
            });
            return xl;
        };
        ASXML.prototype.toXMLString = function () {
            return this.toXMLStringImpl();
        };
        ASXML.prototype.toXMLStringImpl = function (ancestorNamespaces, indentLevel) {
            var node = this;
            var sec = this.sec;
            // 10.2.1 ToXMLString Applied to the XML Type
            var prettyPrinting = sec.AXXML.prettyPrinting;
            indentLevel |= 0;
            var s = prettyPrinting ? getIndentString(indentLevel) : '';
            var kind = node._kind;
            switch (kind) {
                // 4. If x.[[Class]] == "text",
                case 3 /* Text */:
                    return prettyPrinting ?
                        s + escapeElementValue(sec, trimWhitespaces(node._value)) :
                        escapeElementValue(sec, node._value);
                // 5. If x.[[Class]] == "attribute", return the result of concatenating s and
                // EscapeAttributeValue(x.[[Value]])
                case 2 /* Attribute */:
                    return s + escapeAttributeValue(node._value);
                // 6. If x.[[Class]] == "comment", return the result of concatenating s, the string "<!--",
                // x.[[Value]] and the string "-->"
                case 4 /* Comment */:
                    return s + '<!--' + node._value + '-->';
                // 7 If x.[[Class]] == "processing-instruction", return the result of concatenating s, the
                // string "<?", x.[[Name]].localName, the space <SP> character, x.[[Value]] and the string
                // "?>"
                case 5 /* ProcessingInstruction */:
                    return s + '<?' + node._name.name + ' ' + node._value + '?>';
                default:
                    release$1 || assert(kind === 1 /* Element */);
                    break;
            }
            ancestorNamespaces = ancestorNamespaces || [];
            var namespaceDeclarations = [];
            // 10. For each ns in x.[[InScopeNamespaces]]
            for (var i = 0; node._inScopeNamespaces && i < node._inScopeNamespaces.length; i++) {
                var ns = node._inScopeNamespaces[i];
                if (ancestorNamespaces.every(function (ans) { return ans.uri !== ns.uri || ans.prefix !== ns.prefix; })) {
                    namespaceDeclarations.push(ns);
                }
            }
            // 11. For each name in the set of names consisting of x.[[Name]] and the name of each
            // attribute in x.[[Attributes]]
            var currentNamespaces = ancestorNamespaces.concat(namespaceDeclarations);
            var namespace = GetNamespace(node._name, currentNamespaces);
            if (namespace.prefix === undefined) {
                // Let namespace.prefix be an arbitrary implementation defined namespace prefix, such that
                // there is no ns2 ∈ (AncestorNamespaces ∪ namespaceDeclarations) with namespace.prefix ==
                // ns2.prefix
                var newPrefix = generateUniquePrefix(currentNamespaces);
                var ns2 = internPrefixedNamespace(0 /* Public */, namespace.uri, newPrefix);
                // Let namespaceDeclarations = namespaceDeclarations ∪ { namespace }
                namespaceDeclarations.push(ns2);
                currentNamespaces.push(ns2);
            }
            // 12. Let s be the result of concatenating s and the string "<"
            // 13. If namespace.prefix is not the empty string,
            //   a. Let s be the result of concatenating s, namespace.prefix and the string ":"
            // 14. Let s be the result of concatenating s and x.[[Name]].localName
            var elementName = (namespace.prefix ? namespace.prefix + ':' : '') + node._name.name;
            s += '<' + elementName;
            node._attributes && node._attributes.forEach(function (attr) {
                var name = attr._name;
                var namespace = GetNamespace(name, currentNamespaces);
                if (namespace.prefix === undefined) {
                    // Let namespace.prefix be an arbitrary implementation defined namespace prefix, such that
                    // there is no ns2 ∈ (AncestorNamespaces ∪ namespaceDeclarations) with namespace.prefix ==
                    // ns2.prefix
                    var newPrefix = generateUniquePrefix(currentNamespaces);
                    var ns2 = internPrefixedNamespace(0 /* Public */, namespace.uri, newPrefix);
                    // Let namespaceDeclarations = namespaceDeclarations ∪ { namespace }
                    namespaceDeclarations.push(ns2);
                    currentNamespaces.push(ns2);
                }
            });
            for (var i = 0; i < namespaceDeclarations.length; i++) {
                var namespace = namespaceDeclarations[i];
                if (namespace.uri === '') {
                    continue;
                }
                var attributeName = namespace.prefix ? 'xmlns:' + namespace.prefix : 'xmlns';
                s += ' ' + attributeName + '="' + escapeAttributeValue(namespace.uri) + '"';
            }
            node._attributes && node._attributes.forEach(function (attr) {
                var name = attr._name;
                var namespace = GetNamespace(name, ancestorNamespaces);
                var attributeName = namespace.prefix ? namespace.prefix + ':' + name.name : name.name;
                s += ' ' + attributeName + '="' + escapeAttributeValue(attr._value) + '"';
            });
            // 17. If x.[[Length]] == 0
            if (node._children.length === 0) {
                //   a. Let s be the result of concatenating s and "/>"
                s += '/>';
                //   b. Return s
                return s;
            }
            // 18. Let s be the result of concatenating s and the string ">"
            s += '>';
            // 19. Let indentChildren = ((x.[[Length]] > 1) or (x.[[Length]] == 1 and x[0].[[Class]] is
            // not equal to "text"))
            var indentChildren = node._children.length > 1 ||
                (node._children.length === 1 && node._children[0]._kind !== 3 /* Text */);
            var nextIndentLevel = (prettyPrinting && indentChildren) ?
                indentLevel + sec.AXXML._prettyIndent : 0;
            node._children.forEach(function (childNode, i) {
                if (prettyPrinting && indentChildren) {
                    s += '\n';
                }
                s += childNode.toXMLStringImpl(currentNamespaces, nextIndentLevel);
            });
            if (prettyPrinting && indentChildren) {
                s += '\n' + getIndentString(indentLevel);
            }
            s += '</' + elementName + '>';
            return s;
        };
        ASXML.prototype.toJSON = function (k) {
            return 'XML';
        };
        ASXML.prototype.axGetEnumerableKeys = function () {
            if (this === this.axClass.dPrototype) {
                return _super.prototype.axGetEnumerableKeys.call(this);
            }
            var keys = [];
            for (var i = 0; i < this._children.length; i++) {
                keys.push(this._children[i]._name.name);
            }
            return keys;
        };
        // 9.1.1.2 [[Put]] (P, V)
        ASXML.prototype.setProperty = function (mn, v) {
            release$1 || assert(mn instanceof Multiname);
            // Step 1. (Step 3 in Tamarin source.)
            var sec = this.sec;
            if (!mn.isAnyName() && !mn.isAttribute() && mn.name === mn.name >>> 0) {
                sec.throwError('TypeError', Errors$1.XMLAssignmentToIndexedXMLNotAllowed);
            }
            // Step 2. (Step 4 in Tamarin source.)
            if (this._kind === 3 /* Text */ || this._kind === 4 /* Comment */ ||
                this._kind === 5 /* ProcessingInstruction */ || this._kind === 2 /* Attribute */) {
                return;
            }
            // Step 3.
            var c;
            if (!isXMLType(v, sec) || v._kind === 3 /* Text */ ||
                v._kind === 2 /* Attribute */) {
                c = toString(v, sec);
                // Step 4.
            }
            else {
                c = v._deepCopy();
            }
            // Step 5 (implicit, mn is always a Multiname here).
            // Step 6 (7 in Tamarin).
            if (mn.isAttribute()) {
                // Step 6.a (omitted, as in Tamarin).
                // Step 6.b.
                if (c && c.axClass === sec.AXXMLList) {
                    // Step 6.b.i.
                    if (c._children.length === 0) {
                        c = '';
                        // Step 6.b.ii.
                    }
                    else {
                        // Step 6.b.ii.1.
                        var s = toString(c._children[0], sec);
                        // Step 6.b.ii.2.
                        for (var j = 1; j < c._children.length; j++) {
                            s += ' ' + toString(c._children[j], sec);
                        }
                        // Step 6.b.ii.3.
                        c = s;
                    }
                    // Step 6.c.
                }
                else {
                    c = axCoerceString$3(c);
                }
                // Step 6.d.
                var a = null;
                // Step 6.e.
                var attributes = this._attributes;
                var newAttributes = this._attributes = [];
                for (var j = 0; attributes && j < attributes.length; j++) {
                    var attribute = attributes[j];
                    if (attribute._name.matches(mn)) {
                        // Step 6.e.1.
                        if (!a) {
                            a = attribute;
                            // Step 6.e.2.
                        }
                        else {
                            attribute._parent = null;
                            continue;
                        }
                    }
                    newAttributes.push(attribute);
                }
                // Step 6.f.
                if (!a) {
                    // Wildcard attribute names shouldn't cause any attributes to be *added*, so we can bail
                    // here. Tamarin doesn't do this, and it's not entirely clear to me how they avoid
                    // adding attributes, but this works and doesn't regress any tests.
                    if (mn.isAnyName()) {
                        return;
                    }
                    var uri = '';
                    if (mn.namespaces.length === 1) {
                        uri = mn.namespaces[0].uri;
                    }
                    a = createXML(sec, 2 /* Attribute */, uri, mn.name);
                    a._parent = this;
                    newAttributes.push(a);
                    // TODO: implement the namespace parts of step f.
                }
                // Step 6.g.
                a._value = c;
                // Step 6.h.
                return;
            }
            var i;
            var isAny = mn.isAnyName();
            var primitiveAssign = !isXMLType(c, sec) && !isAny && mn.name !== '*';
            var isAnyNamespace = mn.isAnyNamespace();
            for (var k = this._children.length - 1; k >= 0; k--) {
                if ((isAny || this._children[k]._kind === 1 /* Element */ &&
                    this._children[k]._name.name === mn.name) &&
                    (isAnyNamespace ||
                        this._children[k]._kind === 1 /* Element */ &&
                            this._children[k]._name.matches(mn))) {
                    if (i !== undefined) {
                        this.deleteByIndex(i);
                    }
                    i = k;
                }
            }
            if (i === undefined) {
                i = this._children.length;
                if (primitiveAssign) {
                    var ns = mn.namespaces[0];
                    var uri = null;
                    var prefix;
                    if (ns.uri !== null) {
                        uri = ns.uri;
                        prefix = ns.prefix;
                    }
                    if (uri === null) {
                        var defaultNamespace = getDefaultNamespace(sec);
                        uri = defaultNamespace.uri;
                        prefix = defaultNamespace.prefix;
                    }
                    var y = createXML(sec, 1 /* Element */, uri, mn.name, prefix);
                    y._parent = this;
                    this._replaceByIndex(i, y);
                    var ns = y._name.namespace;
                    y.addInScopeNamespace(ns);
                }
            }
            if (primitiveAssign) {
                // Blow away kids of x[i].
                var subChildren = this._children[i]._children;
                for (var j = subChildren.length; j--;) {
                    subChildren[j]._parent = null;
                }
                subChildren.length = 0;
                var s = toString(c, sec);
                if (s !== "") {
                    this._children[i]._replaceByIndex(0, s);
                }
            }
            else {
                this._replaceByIndex(i, c);
            }
        };
        ASXML.prototype.axSetProperty = function (mn, value, bc) {
            if (this === this.axClass.dPrototype) {
                release$1 || checkValue(value);
                this[this.axResolveMultiname(mn)] = value;
                return;
            }
            this.setProperty(coerceE4XMultiname(mn, this.sec), value);
        };
        // 9.1.1.1 XML.[[Get]] (P)
        ASXML.prototype.getProperty = function (mn) {
            release$1 || assert(mn instanceof Multiname);
            // Step 1.
            var nm = mn.name;
            if (isIndex(nm)) {
                // this is a shortcut to the E4X logic that wants us to create a new
                // XMLList with of size 1 and access it with the given index.
                if ((nm | 0) === 0) {
                    return this;
                }
                return null;
            }
            // Step 2 (implicit).
            // Step 3.
            var list = this.sec.AXXMLList.CreateList(this, mn);
            var length = 0;
            var anyName = mn.isAnyName();
            var anyNamespace = mn.isAnyNamespace();
            // Step 4.
            if (mn.isAttribute()) {
                for (var i = 0; this._attributes && i < this._attributes.length; i++) {
                    var v = this._attributes[i];
                    if ((anyName || v._name.name === nm) &&
                        (anyNamespace || v._name.matches(mn))) {
                        list._children[length++] = v;
                        assert(list._children[0]);
                    }
                }
                return list;
            }
            // Step 5.
            for (var i = 0; this._children && i < this._children.length; i++) {
                var v = this._children[i];
                if ((anyName || v._kind === 1 /* Element */ && v._name.name === nm) &&
                    ((anyNamespace || v._name.matches(mn)))) {
                    list._children[length++] = v;
                    assert(list._children[0]);
                }
            }
            // Step 6.
            return list;
        };
        ASXML.prototype.axGetProperty = function (mn) {
            if (this === this.axClass.dPrototype) {
                var value = this[this.axResolveMultiname(mn)];
                release$1 || checkValue(value);
                return value;
            }
            return this.getProperty(coerceE4XMultiname(mn, this.sec));
        };
        // 9.1.1.6 [[HasProperty]] (P) (well, very roughly)
        ASXML.prototype.hasProperty = function (mn) {
            if (isIndex(mn.name)) {
                // this is a shortcut to the E4X logic that wants us to create a new
                // XMLList of size 1 and access it with the given index.
                return (mn.name | 0) === 0;
            }
            var name = toXMLName(mn, this.sec);
            var anyName = name.isAnyName();
            var anyNamespace = name.isAnyNamespace();
            if (mn.isAttribute()) {
                for (var i = 0; this._attributes && i < this._attributes.length; i++) {
                    var v = this._attributes[i];
                    if (anyName || v._name.matches(name)) {
                        return true;
                    }
                }
                return false;
            }
            for (var i = 0; i < this._children.length; i++) {
                var v = this._children[i];
                if ((anyName || v._kind === 1 /* Element */ && v._name.name === name.name) &&
                    (anyNamespace || v._kind === 1 /* Element */ && v._name.matches(name))) {
                    return true;
                }
            }
        };
        ASXML.prototype.deleteProperty = function (mn) {
            if (isIndex(mn.name)) {
                // This hasn't ever been implemented and silently does nothing in Tamarin (and Rhino).
                return true;
            }
            var name = toXMLName(mn, this.sec);
            var localName = name.name;
            var anyName = mn.isAnyName();
            var anyNamespace = mn.isAnyNamespace();
            if (mn.isAttribute()) {
                var attributes = this._attributes;
                if (attributes) {
                    var newAttributes = this._attributes = [];
                    for (var i = 0; i < attributes.length; i++) {
                        var node = attributes[i];
                        var attrName = node._name;
                        if ((anyName || attrName.name === localName) &&
                            (anyNamespace || attrName.matches(name))) {
                            node._parent = null;
                        }
                        else {
                            newAttributes.push(node);
                        }
                    }
                }
            }
            else {
                if (this._children.some(function (v, i) {
                    return (anyName || v._kind === 1 /* Element */ && v._name.name === name.name) &&
                        (anyNamespace || v._kind === 1 /* Element */ && v._name.matches(name));
                })) {
                    return true;
                }
            }
        };
        ASXML.prototype.axHasProperty = function (mn) {
            if (this === this.axClass.dPrototype) {
                return _super.prototype.axHasPropertyInternal.call(this, mn);
            }
            return this.axHasPropertyInternal(mn);
        };
        ASXML.prototype.axHasPropertyInternal = function (mn) {
            if (this.hasProperty(mn)) {
                return true;
            }
            // HACK if child with specific name is not present, check object's attributes.
            // The presence of the attribute/method can be checked during with(), see #850.
            return !!this[this.axResolveMultiname(mn)];
        };
        ASXML.prototype.axDeleteProperty = function (mn) {
            if (this.deleteProperty(mn)) {
                return true;
            }
            // HACK if child with specific name is not present, check object's attributes.
            // The presence of the attribute/method can be checked during with(), see #850.
            return delete this[this.axResolveMultiname(mn)];
        };
        ASXML.prototype.axCallProperty = function (mn, args) {
            var method = this[this.axResolveMultiname(mn)];
            // The method might be dynamically defined on XML.prototype.
            if (!method) {
                method = this['$Bg' + mn.name];
            }
            // Check if the method exists before calling it.
            if (method) {
                validateCall(this.sec, method, args.length);
                return method.axApply(this, args);
            }
            // Otherwise, 11.2.2.1 CallMethod ( r , args )
            // If f == undefined and Type(base) is XMLList and base.[[Length]] == 1
            //   ii. Return the result of calling CallMethod(r0, args) recursively
            // f. If f == undefined and Type(base) is XML and base.hasSimpleContent () == true
            //   i. Let r0 be a new Reference with base object = ToObject(ToString(base)) and property
            // name = P ii. Return the result of calling CallMethod(r0, args) recursively
            if (this.hasSimpleContent()) {
                return this.sec.box(toString(this, this.sec)).axCallProperty(mn, args);
            }
            this.sec.throwError('TypeError', Errors$1.CallOfNonFunctionError, 'value');
        };
        ASXML.prototype._delete = function (key, isMethod) {
            release$1 || release$1 || notImplemented("XML.[[Delete]]");
        };
        ASXML.prototype.deleteByIndex = function (p) {
            var i = p >>> 0;
            if (String(i) !== String(p)) {
                throw "TypeError in XML.prototype.deleteByIndex(): invalid index " + p;
            }
            var children = this._children;
            if (p < children.length && children[p]) {
                children[p]._parent = null;
                children.splice(p, 1);
            }
        };
        // 9.1.1.11 [[Insert]] (P, V)
        ASXML.prototype.insert = function (p, v) {
            // Step 1.
            if (this._kind > 1 /* Element */) {
                return;
            }
            // Steps 2-3 (Guaranteed by assert).
            release$1 || assert(typeof p === 'number' && isIndex(p));
            var i = p;
            // Step 4.
            if (v && v.axClass === this.axClass) {
                var a = this;
                while (a) {
                    if (a === v) {
                        this.sec.throwError('TypeError', Errors$1.XMLIllegalCyclicalLoop);
                    }
                    a = a._parent;
                }
            }
            // Step 5.
            var n = 1;
            // Step 6.
            if (v && v.axClass === this.sec.AXXMLList) {
                n = v._children.length;
                // Step 7.
                if (n === 0) {
                    return;
                }
            }
            // Step 8.
            var ownChildren = this._children;
            for (var j = ownChildren.length - 1; j >= i; j--) {
                ownChildren[j + n] = ownChildren[j];
                assert(ownChildren[0]);
            }
            // Step 9 (implicit).
            // Step 10.
            if (v && v.axClass === this.sec.AXXMLList) {
                n = v._children.length;
                for (var j = 0; j < n; j++) {
                    v._children[j]._parent = this;
                    ownChildren[i + j] = v._children[j];
                }
                // Step 11.
            }
            else {
                //x.replace(i, v), inlined;
                if (!(v && v.axClass === this.axClass)) {
                    v = this.sec.AXXML.Create(v);
                }
                v._parent = this;
                if (!ownChildren) {
                    this._children = ownChildren = [];
                }
                ownChildren[i] = v;
                assert(ownChildren[0]);
            }
        };
        // 9.1.1.13 [[AddInScopeNamespace]] ( N )
        ASXML.prototype.addInScopeNamespace = function (ns) {
            if (this._kind === 3 /* Text */ ||
                this._kind === 4 /* Comment */ ||
                this._kind === 5 /* ProcessingInstruction */ ||
                this._kind === 2 /* Attribute */) {
                return;
            }
            var prefix = ns.prefix;
            if (prefix !== undefined) {
                if (prefix === "" && this._name.uri === "") {
                    return;
                }
                var match = null;
                this._inScopeNamespaces.forEach(function (v, i) {
                    if (v.prefix === prefix) {
                        match = v;
                    }
                });
                if (match !== null && match.uri !== ns.uri) {
                    this._inScopeNamespaces.forEach(function (v, i) {
                        if (v.prefix === match.prefix) {
                            this._inScopeNamespaces[i] = ns; // replace old with new
                        }
                    });
                }
                if (this._name.prefix === prefix) {
                    this._name.prefix = undefined;
                }
                this._attributes.forEach(function (v, i) {
                    if (v._name.prefix === prefix) {
                        v._name.prefix = undefined;
                    }
                });
            }
        };
        ASXML.prototype.descendantsInto = function (name, xl) {
            if (this._kind !== 1 /* Element */) {
                return xl;
            }
            var length = xl._children.length;
            var isAny = name.isAnyName();
            if (name.isAttribute()) {
                // Get attributes
                this._attributes.forEach(function (v, i) {
                    if (isAny || v._name.matches(name)) {
                        xl._children[length++] = v;
                        assert(xl._children[0]);
                    }
                });
            }
            else {
                // Get children
                this._children.forEach(function (v, i) {
                    if (isAny || v._name.matches(name)) {
                        xl._children[length++] = v;
                        assert(xl._children[0]);
                    }
                });
            }
            // Descend
            this._children.forEach(function (v, i) {
                v.descendantsInto(name, xl);
            });
            return xl;
        };
        ASXML.instanceConstructor = ASXML;
        ASXML._flags = ASXML_FLAGS.ALL;
        ASXML._prettyIndent = 2;
        return ASXML;
    }(ASObject$1));
    function createXML(sec, kind, uri, name, prefix) {
        if (kind === void 0) { kind = 3 /* Text */; }
        if (uri === void 0) { uri = ''; }
        if (name === void 0) { name = ''; }
        var xml = sec.AXXML.Create();
        var ns = internPrefixedNamespace(0 /* Public */, uri, prefix || '');
        var mn = new Multiname(null, 0, kind === 2 /* Attribute */ ? 13 /* QNameA */ : 7 /* QName */, [ns], name, null);
        xml.init(kind, mn);
        return xml;
    }
    var ASXMLList = /** @class */ (function (_super) {
        __extends(ASXMLList, _super);
        function ASXMLList(value) {
            var _this = _super.call(this) || this;
            _this._children = [];
            if (isNullOrUndefined$1(value)) {
                value = "";
            }
            if (!value) {
                return _this;
            }
            if (value && value.axClass === _this.sec.AXXMLList) {
                var children = value._children;
                for (var i = 0; i < children.length; i++) {
                    var child = children[i];
                    _this._children[i] = child;
                    assert(_this._children[0]);
                }
            }
            else {
                toXMLList(value, _this);
            }
            return _this;
        }
        ASXMLList.classInitializer = function () {
            defineNonEnumerableProperty(this, '$Bglength', 1);
            var proto = this.dPrototype;
            var asProto = ASXMLList.prototype;
            defineNonEnumerableProperty(proto, '$BgvalueOf', Object.prototype['$BgvalueOf']);
            defineNonEnumerableProperty(proto, '$BghasOwnProperty', asProto.native_hasOwnProperty);
            defineNonEnumerableProperty(proto, '$BgpropertyIsEnumerable', asProto.native_propertyIsEnumerable);
            addPrototypeFunctionAlias(proto, '$BgtoString', asProto.toString);
            addPrototypeFunctionAlias(proto, '$BgaddNamespace', asProto.addNamespace);
            addPrototypeFunctionAlias(proto, '$BgappendChild', asProto.appendChild);
            addPrototypeFunctionAlias(proto, '$Bgattribute', asProto.attribute);
            addPrototypeFunctionAlias(proto, '$Bgattributes', asProto.attributes);
            addPrototypeFunctionAlias(proto, '$Bgchild', asProto.child);
            addPrototypeFunctionAlias(proto, '$BgchildIndex', asProto.childIndex);
            addPrototypeFunctionAlias(proto, '$Bgchildren', asProto.children);
            addPrototypeFunctionAlias(proto, '$Bgcomments', asProto.comments);
            addPrototypeFunctionAlias(proto, '$Bgcontains', asProto.contains);
            addPrototypeFunctionAlias(proto, '$Bgcopy', asProto.copy);
            addPrototypeFunctionAlias(proto, '$Bgdescendants', asProto.descendants);
            addPrototypeFunctionAlias(proto, '$Bgelements', asProto.elements);
            addPrototypeFunctionAlias(proto, '$BghasComplexContent', asProto.hasComplexContent);
            addPrototypeFunctionAlias(proto, '$BghasSimpleContent', asProto.hasSimpleContent);
            addPrototypeFunctionAlias(proto, '$BginScopeNamespaces', asProto.inScopeNamespaces);
            addPrototypeFunctionAlias(proto, '$BginsertChildAfter', asProto.insertChildAfter);
            addPrototypeFunctionAlias(proto, '$BginsertChildBefore', asProto.insertChildBefore);
            addPrototypeFunctionAlias(proto, '$Bglength', asProto.length);
            addPrototypeFunctionAlias(proto, '$BglocalName', asProto.localName);
            addPrototypeFunctionAlias(proto, '$Bgname', asProto.name);
            addPrototypeFunctionAlias(proto, '$Bgnamespace', asProto.namespace);
            addPrototypeFunctionAlias(proto, '$BgnamespaceDeclarations', asProto.namespaceDeclarations);
            addPrototypeFunctionAlias(proto, '$BgnodeKind', asProto.nodeKind);
            addPrototypeFunctionAlias(proto, '$Bgnormalize', asProto.normalize);
            addPrototypeFunctionAlias(proto, '$Bgparent', asProto.parent);
            addPrototypeFunctionAlias(proto, '$BgprocessingInstructions', asProto.processingInstructions);
            addPrototypeFunctionAlias(proto, '$BgprependChild', asProto.prependChild);
            addPrototypeFunctionAlias(proto, '$BgremoveNamespace', asProto.removeNamespace);
            addPrototypeFunctionAlias(proto, '$Bgreplace', asProto.replace);
            addPrototypeFunctionAlias(proto, '$BgsetChildren', asProto.setChildren);
            addPrototypeFunctionAlias(proto, '$BgsetLocalName', asProto.setLocalName);
            addPrototypeFunctionAlias(proto, '$BgsetName', asProto.setName);
            addPrototypeFunctionAlias(proto, '$BgsetNamespace', asProto.setNamespace);
            addPrototypeFunctionAlias(proto, '$Bgtext', asProto.text);
            addPrototypeFunctionAlias(proto, '$BgtoXMLString', asProto.toXMLString);
            addPrototypeFunctionAlias(proto, '$BgtoJSON', asProto.toJSON);
        };
        ASXMLList.axApply = function (self, args) {
            var value = args[0];
            // 13.5.1 The XMLList Constructor Called as a Function
            if (isNullOrUndefined$1(value)) {
                value = '';
            }
            if (value && value.axClass === this.sec.AXXMLList) {
                return value;
            }
            var list = this.sec.AXXMLList.Create();
            toXMLList(value, list);
            return list;
        };
        // 11.4.1 The Addition Operator ( + )
        ASXMLList.addXML = function (left, right) {
            var result;
            if (left.axClass === left.sec.AXXML) {
                result = left.sec.AXXMLList.Create();
                result.append(left);
            }
            else {
                result = left;
            }
            result.append(right);
            return result;
        };
        ASXMLList.Create = function (value) {
            var list = Object.create(this.sec.AXXMLList.tPrototype);
            list.axInitializer(value);
            return list;
        };
        ASXMLList.CreateList = function (targetObject, targetProperty) {
            var list = this.Create();
            list._targetObject = targetObject;
            list._targetProperty = targetProperty;
            return list;
        };
        ASXMLList.prototype.valueOf = function () {
            return this;
        };
        // E4X 11.5.1 The Abstract Equality Comparison Algorithm, steps 1-2.
        // (but really 9.2.1.9 [[Equals]] (V))
        ASXMLList.prototype.equals = function (other) {
            var children = this._children;
            // Step 1.
            if (other === undefined && children.length === 0) {
                return true;
            }
            // Step 2.
            if (other && other.axClass === this.sec.AXXMLList) {
                var otherChildren = other._children;
                // Step 2.a.
                if (otherChildren.length !== children.length) {
                    return false;
                }
                // Step 2.b.
                for (var i = 0; i < children.length; i++) {
                    if (!children[i].equals(otherChildren[i])) {
                        return false;
                    }
                }
                // Step 2.c.
                return true;
            }
            // Steps 3-4.
            return children.length === 1 && children[0].equals(other);
        };
        ASXMLList.prototype.toString = function () {
            if (this.hasComplexContent()) {
                return this.toXMLString();
            }
            var s = '';
            for (var i = 0; i < this._children.length; i++) {
                s += toString(this._children[i], this.sec);
            }
            return s;
        };
        // 9.2.1.7 [[DeepCopy]] ( )
        ASXMLList.prototype._deepCopy = function () {
            var xl = this.sec.AXXMLList.CreateList(this._targetObject, this._targetProperty);
            var length = this._children.length;
            for (var i = 0; i < length; i++) {
                xl._children[i] = this._children[i]._deepCopy();
                assert(xl._children[0]);
            }
            return xl;
        };
        ASXMLList.prototype._shallowCopy = function () {
            var xl = this.sec.AXXMLList.CreateList(this._targetObject, this._targetProperty);
            var length = this._children.length;
            for (var i = 0; i < length; i++) {
                xl._children[i] = this._children[i];
                assert(xl._children[0]);
            }
            return xl;
        };
        // 13.5.4.12 XMLList.prototype.hasOwnProperty ( P )
        ASXMLList.prototype.native_hasOwnProperty = function (P) {
            P = axCoerceString$3(P);
            if (this === this.sec.AXXMLList.dPrototype) {
                return ASObject$1.prototype.native_hasOwnProperty.call(this, P);
            }
            if (isIndex(P)) {
                return (P | 0) < this._children.length;
            }
            var mn = toXMLName(P, this.sec);
            var children = this._children;
            for (var i = 0; i < children.length; i++) {
                var node = children[i];
                if (node._kind === 1 /* Element */) {
                    if (node.hasProperty(mn)) {
                        return true;
                    }
                }
            }
            return false;
        };
        // 13.5.4.19 XMLList.prototype.propertyIsEnumerable ( P )
        ASXMLList.prototype.native_propertyIsEnumerable = function (P) {
            return isIndex(P) && (P | 0) < this._children.length;
        };
        ASXMLList.prototype.attribute = function (arg) {
            if (isNullOrUndefined$1(arg) && arguments.length > 0) {
                this.sec.throwError('TypeError', Errors$1.ConvertUndefinedToObjectError);
            }
            if (arg && arg.axClass === this.sec.AXQName) {
                return this.getProperty(arg.name);
            }
            arg = axCoerceString$3(arg);
            if (arg === '*' || arguments.length === 0) {
                arg = null;
            }
            tmpMultiname.name = arg;
            tmpMultiname.namespaces = [Namespace.PUBLIC];
            tmpMultiname.kind = 13 /* QNameA */;
            return this.getProperty(tmpMultiname);
        };
        ASXMLList.prototype.attributes = function () {
            // 13.5.4.3 XMLList.prototype.attributes ( )
            tmpMultiname.name = null;
            tmpMultiname.namespaces = [];
            tmpMultiname.kind = 13 /* QNameA */;
            return this.getProperty(tmpMultiname);
        };
        ASXMLList.prototype.child = function (propertyName) {
            if (isIndex(propertyName)) {
                var list = this.sec.AXXMLList.CreateList(this._targetObject, this._targetProperty);
                if ((propertyName | 0) < this._children.length) {
                    list._children[0] = this._children[propertyName | 0]._deepCopy();
                    assert(list._children[0]);
                }
                return list;
            }
            return this.getProperty(toXMLName(propertyName, this.sec));
        };
        ASXMLList.prototype.children = function () {
            // 13.5.4.4 XMLList.prototype.child ( propertyName )
            return this.getProperty(anyMultiname);
        };
        // 9.2.1.8 [[Descendants]] (P)
        ASXMLList.prototype.descendants = function (name_) {
            var name = toXMLName(name_, this.sec);
            var list = this.sec.AXXMLList.CreateList(this._targetObject, this._targetProperty);
            for (var i = 0; i < this._children.length; i++) {
                var child = this._children[i];
                if (child._kind === 1 /* Element */) {
                    child.descendantsInto(name, list);
                }
            }
            return list;
        };
        ASXMLList.prototype.comments = function () {
            // 13.5.4.6 XMLList.prototype.comments ( )
            var xl = this.sec.AXXMLList.CreateList(this._targetObject, this._targetProperty);
            this._children.forEach(function (child) {
                if (child._kind === 1 /* Element */) {
                    var r = child.comments();
                    Array.prototype.push.apply(xl._children, r._children);
                }
            });
            return xl;
        };
        // 13.5.4.8 XMLList.prototype.contains ( value )
        ASXMLList.prototype.contains = function (value) {
            var children = this._children;
            for (var i = 0; i < children.length; i++) {
                var child = children[i];
                if (child.equals(value)) {
                    return true;
                }
            }
            return false;
        };
        ASXMLList.prototype.copy = function () {
            // 13.5.4.9 XMLList.prototype.copy ( )
            return this._deepCopy();
        };
        ASXMLList.prototype.elements = function (name) {
            // 13.5.4.11 XMLList.prototype.elements ( [ name ] )
            var mn = toXMLName(name, this.sec);
            var xl = this.sec.AXXMLList.CreateList(this._targetObject, mn);
            this._children.forEach(function (child) {
                if (child._kind === 1 /* Element */) {
                    var r = child.elements(mn);
                    Array.prototype.push.apply(xl._children, r._children);
                }
            });
            return xl;
        };
        ASXMLList.prototype.hasComplexContent = function () {
            // 13.5.4.13 XMLList.prototype.hasComplexContent( )
            switch (this._children.length) {
                case 0:
                    return false;
                case 1:
                    return this._children[0].hasComplexContent();
                default:
                    return this._children.some(function (child) {
                        return child._kind === 1 /* Element */;
                    });
            }
        };
        ASXMLList.prototype.hasSimpleContent = function () {
            // 13.5.4.14 XMLList.prototype.hasSimpleContent( )
            switch (this._children.length) {
                case 0:
                    return true;
                case 1:
                    return this._children[0].hasSimpleContent();
                default:
                    return this._children.every(function (child) {
                        return child._kind !== 1 /* Element */;
                    });
            }
        };
        ASXMLList.prototype.length = function () {
            return this._children.length;
        };
        ASXMLList.prototype.name = function () {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'name');
            }
            return this._children[0].name();
        };
        // 13.5.4.16 XMLList.prototype.normalize ( )
        ASXMLList.prototype.normalize = function () {
            // Steps 1-2.
            for (var i = 0; i < this._children.length;) {
                var child = this._children[i];
                // Step 2.a.
                if (child._kind === 1 /* Element */) {
                    child.normalize();
                    i++;
                }
                // Step 2.b.
                else if (child._kind === 3 /* Text */) {
                    // Step 2.b.i.
                    for (i++; i < this._children.length;) {
                        var nextChild = this._children[i];
                        if (nextChild._kind !== 3 /* Text */) {
                            break;
                        }
                        child._value += nextChild._value;
                        this.removeByIndex(i);
                    }
                    // Step 2.b.ii.
                    if (child._value.length === 0) {
                        this.removeByIndex(i);
                    }
                    // Step 2.b.iii.
                    else {
                        i++;
                    }
                }
                // Step 2.c.
                else {
                    i++;
                }
            }
            return this;
        };
        ASXMLList.prototype.parent = function () {
            // 13.5.4.17 XMLList.prototype.parent ( )
            var children = this._children;
            if (children.length === 0) {
                return undefined;
            }
            var parent = children[0]._parent;
            for (var i = 1; i < children.length; i++) {
                if (children[i]._parent !== parent) {
                    return undefined;
                }
            }
            return parent;
        };
        // 13.5.4.18 XMLList.prototype.processingInstructions ( [ name ] )
        ASXMLList.prototype.processingInstructions = function (name_) {
            // (Numbering in the spec starts at 6.)
            // Step 6 (implicit).
            // Step 7.
            var name = toXMLName(name_, this.sec);
            // Step 8.
            var list = this.sec.AXXMLList.CreateList(this._targetObject, this._targetProperty);
            list._targetObject = this;
            list._targetProperty = null;
            // Step 9.
            var children = this._children;
            for (var i = 0; i < children.length; i++) {
                children[i].processingInstructionsInto(name, list);
            }
            // Step 10.
            return list;
        };
        ASXMLList.prototype.text = function () {
            // 13.5.4.20 XMLList.prototype.text ( )
            var xl = this.sec.AXXMLList.CreateList(this._targetObject, this._targetProperty);
            this._children.forEach(function (v, i) {
                if (v._kind === 1 /* Element */) {
                    var gq = v.text();
                    if (gq._children.length > 0) {
                        xl._children.push(gq);
                    }
                }
            });
            return xl;
        };
        ASXMLList.prototype.toXMLString = function () {
            // 10.2.2 ToXMLString Applied to the XMLList Type
            var sec = this.sec;
            return this._children.map(function (childNode) {
                return toXMLString(sec, childNode);
            }).join(sec.AXXML.prettyPrinting ? '\n' : '');
        };
        ASXMLList.prototype.toJSON = function (k) {
            return 'XMLList';
        };
        ASXMLList.prototype.addNamespace = function (ns) {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'addNamespace');
            }
            var xml = this._children[0];
            xml.addNamespace(ns);
            return xml;
        };
        ASXMLList.prototype.appendChild = function (child) {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'appendChild');
            }
            var xml = this._children[0];
            xml.appendChild(child);
            return xml;
        };
        // 9.2.1.6 [[append]] (V)
        ASXMLList.prototype.append = function (V) {
            // Step 1.
            var children = this._children;
            var i = children.length;
            // Step 2.
            var n = 1;
            // Step 3.
            if (V && V.axClass === this.sec.AXXMLList) {
                this._targetObject = V._targetObject;
                this._targetProperty = V._targetProperty;
                var valueChildren = V._children;
                n = valueChildren.length;
                if (n === 0) {
                    return;
                }
                for (var j = 0; j < valueChildren.length; j++) {
                    children[i + j] = valueChildren[j];
                }
                return;
            }
            release$1 || assert(V.axClass === this.sec.AXXML);
            // Step 4.
            children[i] = V;
            // Step 5 (implicit).
        };
        ASXMLList.prototype.childIndex = function () {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'childIndex');
            }
            return this._children[0].childIndex();
        };
        ASXMLList.prototype.inScopeNamespaces = function () {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'inScopeNamespaces');
            }
            return this._children[0].inScopeNamespaces();
        };
        ASXMLList.prototype.insertChildAfter = function (child1, child2) {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'insertChildAfter');
            }
            return this._children[0].insertChildAfter(child1, child2);
        };
        ASXMLList.prototype.insertChildBefore = function (child1, child2) {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'insertChildBefore');
            }
            return this._children[0].insertChildBefore(child1, child2);
        };
        ASXMLList.prototype.nodeKind = function () {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'nodeKind');
            }
            return this._children[0].nodeKind();
        };
        ASXMLList.prototype.namespace = function (prefix) {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'namespace');
            }
            var firstChild = this._children[0];
            return arguments.length ? firstChild.namespace(prefix) : firstChild.namespace();
        };
        ASXMLList.prototype.localName = function () {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'localName');
            }
            return this._children[0].localName();
        };
        ASXMLList.prototype.namespaceDeclarations = function () {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'namespaceDeclarations');
            }
            return this._children[0].namespaceDeclarations();
        };
        ASXMLList.prototype.prependChild = function (value) {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'prependChild');
            }
            return this._children[0].prependChild(value);
        };
        ASXMLList.prototype.removeNamespace = function (ns) {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'removeNamespace');
            }
            return this._children[0].removeNamespace(ns);
        };
        ASXMLList.prototype.replace = function (propertyName, value) {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'replace');
            }
            return this._children[0].replace(propertyName, value);
        };
        ASXMLList.prototype.setChildren = function (value) {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'setChildren');
            }
            return this._children[0].setChildren(value);
        };
        ASXMLList.prototype.setLocalName = function (name) {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'setLocalName');
            }
            return this._children[0].setLocalName(name);
        };
        ASXMLList.prototype.setName = function (name) {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'setName');
            }
            return this._children[0].setName(name);
        };
        ASXMLList.prototype.setNamespace = function (ns) {
            if (this._children.length !== 1) {
                this.sec.throwError('TypeError', Errors$1.XMLOnlyWorksWithOneItemLists, 'setNamespace');
            }
            return this._children[0].setNamespace(ns);
        };
        ASXMLList.prototype.axGetEnumerableKeys = function () {
            if (this === this.axClass.dPrototype) {
                return _super.prototype.axGetEnumerableKeys.call(this);
            }
            return Object.keys(this._children);
        };
        // 9.2.1.1 [[Get]] (P)
        ASXMLList.prototype.getProperty = function (mn) {
            var nm = mn.name;
            if (isIndex(nm)) {
                return this._children[nm | 0];
            }
            var isAnyName = nm === null || nm === '*';
            var isAnyNamespace = mn.isAnyNamespace();
            var isAttribute = mn.isAttribute();
            var xl = this.sec.AXXMLList.CreateList(this._targetObject, mn);
            var children = this._children;
            for (var i = 0; i < children.length; i++) {
                var v = children[i];
                if (v._kind === 1 /* Element */) {
                    // i. Let gq be the result of calling the [[Get]] method of x[i] with argument P
                    // We do this inline instead to reduce the amount of temporarily created XMLLists.
                    if (isAttribute) {
                        var attributes = v._attributes;
                        for (var j = 0; attributes && j < attributes.length; j++) {
                            var v = attributes[j];
                            if ((isAnyName || v._name.name === nm) &&
                                (isAnyNamespace || v._name.matches(mn))) {
                                xl._children.push(v);
                            }
                        }
                    }
                    else {
                        var descendants = v._children;
                        for (var j = 0; descendants && j < descendants.length; j++) {
                            var v = descendants[j];
                            if ((isAnyName || v._kind === 1 /* Element */ && v._name.name === nm) &&
                                (isAnyNamespace || v._name.matches(mn))) {
                                xl._children.push(v);
                            }
                        }
                    }
                }
            }
            return xl;
        };
        ASXMLList.prototype.axGetProperty = function (mn) {
            if (this === this.axClass.dPrototype) {
                var value = this[this.axResolveMultiname(mn)];
                release$1 || checkValue(value);
                return value;
            }
            return this.getProperty(coerceE4XMultiname(mn, this.sec));
        };
        ASXMLList.prototype.axGetPublicProperty = function (nm) {
            if (this === this.axClass.dPrototype) {
                var value = this[Multiname.getPublicMangledName(nm)];
                release$1 || checkValue(value);
                return value;
            }
            if (isIndex(nm)) {
                return this._children[nm | 0];
            }
            tmpMultiname.name = nm;
            tmpMultiname.namespaces = [Namespace.PUBLIC];
            tmpMultiname.kind = 7 /* QName */;
            return this.getProperty(tmpMultiname);
        };
        ASXMLList.prototype.hasProperty = function (mn) {
            if (isIndex(mn.name)) {
                return Number(mn.name) < this._children.length;
            }
            // TODO scan children on property presence?
            return true;
        };
        ASXMLList.prototype.axHasProperty = function (mn) {
            return this.hasProperty(mn);
        };
        ASXMLList.prototype.axHasPropertyInternal = function (mn) {
            return this.hasProperty(mn);
        };
        // 9.1.1.10 [[ResolveValue]] ( )
        ASXMLList.prototype.resolveValue = function () {
            return this;
        };
        // 9.2.1.2 [[Put]] (P, V)
        ASXMLList.prototype.setProperty = function (mn, value) {
            // Steps 1-2.
            if (isIndex(mn.name)) {
                var i = mn.name | 0;
                // Step 2.b.
                var r = null;
                // Step 2.a.
                if (this._targetObject) {
                    r = this._targetObject.resolveValue();
                    if (r === null) {
                        return;
                    }
                }
                // Step 2.c.
                var length = this._children.length;
                if (i >= length) {
                    // Step 2.c.i.
                    if (r && r.axClass === this.sec.AXXMLList) {
                        // Step 2.c.i.1.
                        if (r._children.length !== 1) {
                            return;
                        }
                        // Step 2.c.i.2.
                        r = r._children[0];
                    }
                    release$1 || assert(r === null || r.axClass === this.sec.AXXML);
                    // Step 2.c.ii.
                    if (r && r._kind !== 1 /* Element */) {
                        return;
                    }
                    // Step 2.c.iii.
                    var y = this.sec.AXXML.Create();
                    y._parent = r;
                    var yName = this._targetProperty;
                    var yKind = 3 /* Text */;
                    // Step 2.c.iv.
                    if (this._targetProperty && this._targetProperty.isAttribute()) {
                        if (r.hasProperty(this._targetProperty)) {
                            return;
                        }
                        yKind = 2 /* Attribute */;
                    }
                    // Step 2.c.v.
                    else if (!this._targetProperty || this._targetProperty.name === null) {
                        yName = null;
                        yKind = 3 /* Text */;
                    }
                    // Step 2.c.vi.
                    else {
                        yKind = 1 /* Element */;
                    }
                    y.init(yKind, yName);
                    // Step 2.c.vii.
                    i = length;
                    // Step 2.c.viii.
                    if (y._kind !== 2 /* Attribute */) {
                        // Step 2.c.viii.1.
                        if (r !== null) {
                            var j;
                            // Step 2.c.viii.1.a.
                            if (i > 0) {
                                var lastChild = this._children[i - 1];
                                var rLength = r._children.length - 1;
                                for (j = 0; j < rLength; j++) {
                                    if (r._children[j] === lastChild) {
                                        release$1 || assert(r._children[0]);
                                        break;
                                    }
                                }
                            }
                            // Step 2.c.viii.1.b.
                            else {
                                j = r._children.length - 1;
                            }
                            // Step 2.c.viii.1.c.
                            r._children[j + 1] = y;
                            assert(r._children[0]);
                            y._parent = r;
                        }
                        // Step 2.c.viii.2.
                        if (value && value.axClass === this.sec.AXXML) {
                            y._name = value._name;
                        }
                        // Step 2.c.viii.3.
                        else if (value && value.axClass === this.sec.AXXMLList) {
                            y._name = value._targetProperty;
                        }
                        // Step 2.c.ix.
                        this.append(y);
                    }
                }
                // Step 2.d.
                if (!isXMLType(value, this.sec) ||
                    value._kind === 3 /* Text */ || value._kind === 2 /* Attribute */) {
                    value = value + '';
                }
                var currentChild = this._children[i];
                var childKind = currentChild._kind;
                var parent = currentChild._parent;
                // Step 2.e.
                if (childKind === 2 /* Attribute */) {
                    var indexInParent = parent._children.indexOf(currentChild);
                    parent.setProperty(currentChild._name, false);
                    this._children[i] = parent._children[indexInParent];
                    assert(this._children[0]);
                    return;
                }
                // Step 2.f.
                if (value && value.axClass === this.sec.AXXMLList) {
                    // Step 2.f.i.
                    var c = value._shallowCopy();
                    var cLength = c._children.length;
                    // Step 2.f.ii. (implemented above.)
                    // Step 2.f.iii.
                    if (parent !== null) {
                        // Step 2.f.iii.1.
                        var q = parent._children.indexOf(currentChild);
                        // Step 2.f.iii.2.
                        parent._replaceByIndex(q, c);
                        // Step 2.f.iii.3.
                        for (var j = 0; j < cLength; j++) {
                            c._children[j] = parent._children[q + j];
                        }
                    }
                    // Step 2.f.iv.
                    if (cLength === 0) {
                        for (var j = i + 1; j < length; j++) {
                            this._children[j - 1] = this._children[j];
                            assert(this._children[0]);
                        }
                        // Step 2.f.vii. (only required if we're shrinking the XMLList).
                        this._children.length--;
                    }
                    // Step 2.f.v.
                    else {
                        for (var j = length - 1; j > i; j--) {
                            this._children[j + cLength - 1] = this._children[j];
                            assert(this._children[0]);
                        }
                    }
                    // Step 2.f.vi.
                    for (var j = 0; j < cLength; j++) {
                        this._children[i + j] = c._children[j];
                        assert(this._children[0]);
                    }
                    return;
                }
                // Step 2.g.
                if (childKind >= 3 /* Text */ || value && value.axClass === this.sec.AXXML) {
                    // Step 2.g.i. (implemented above.)
                    // Step 2.g.ii.
                    if (parent !== null) {
                        // Step 2.g.ii.1.
                        var q = parent._children.indexOf(currentChild);
                        // Step 2.g.ii.2.
                        parent._replaceByIndex(q, value);
                        // Step 2.g.ii.3.
                        value = parent._children[q];
                    }
                    // Step 2.g.iii.
                    if (typeof value === 'string') {
                        var t = this.sec.AXXML.Create(value);
                        this._children[i] = t;
                        assert(this._children[0]);
                    }
                    // Step 2.g.iv.
                    else {
                        release$1 || assert(this.sec.AXXML.axIsType(value));
                        this._children[i] = value;
                        assert(this._children[0]);
                    }
                    return;
                }
                // Step 2.h.
                currentChild.setProperty(anyMultiname, value);
                return;
            }
            // Step 3.
            if (this._children.length === 0) {
                // Step 3.a.i.
                r = this.resolveValue();
                // Step 3.a.ii.
                if (r === null || r._children.length !== 1) {
                    return;
                }
                // Step 3.a.iii.
                this.append(r._children[0]);
            }
            // Step 3.b.
            if (this._children.length === 1) {
                this._children[0].setProperty(mn, value);
                // Step 4.
                return;
            }
            // Not in the spec, but in Flash.
            this.sec.throwError('TypeError', Errors$1.XMLAssigmentOneItemLists);
        };
        ASXMLList.prototype.axSetProperty = function (mn, value, bc) {
            if (this === this.axClass.dPrototype) {
                release$1 || checkValue(value);
                this[this.axResolveMultiname(mn)] = value;
                return;
            }
            this.setProperty(coerceE4XMultiname(mn, this.sec), value);
        };
        // 9.2.1.3 [[Delete]] (P)
        ASXMLList.prototype.axDeleteProperty = function (mn) {
            var name = mn.name;
            // Steps 1-2.
            if (isIndex(name)) {
                var i = name | 0;
                // Step 2.a.
                if (i >= this._children.length) {
                    return true;
                }
                // Step 2.b.
                this.removeByIndex(i);
                return true;
            }
            // Step 3.
            for (var i = 0; i < this._children.length; i++) {
                var child = this._children[i];
                if (child._kind === 1 /* Element */) {
                    child.deleteProperty(mn);
                }
            }
            // Step 4.
            return true;
        };
        ASXMLList.prototype.removeByIndex = function (index) {
            var child = this._children[index];
            var parent = child._parent;
            if (parent) {
                child._parent = null;
                parent._children.splice(parent._children.indexOf(child), 1);
            }
            this._children.splice(index, 1);
        };
        ASXMLList.prototype.axCallProperty = function (mn, args) {
            var method = this[this.axResolveMultiname(mn)];
            // Check if the method exists before calling it.
            if (method) {
                validateCall(this.sec, method, args.length);
                return method.axApply(this, args);
            }
            // Otherwise, 11.2.2.1 CallMethod ( r , args )
            // If f == undefined and Type(base) is XMLList and base.[[Length]] == 1
            //   ii. Return the result of calling CallMethod(r0, args) recursively
            if (this._children.length === 1) {
                return this._children[0].axCallProperty(mn, args);
            }
            this.sec.throwError('TypeError', Errors$1.CallOfNonFunctionError, 'value');
        };
        ASXMLList.instanceConstructor = ASXMLList;
        return ASXMLList;
    }(ASObject$1));

    function axEquals(left, right, sec) {
        // See E4X spec, 11.5 Equality Operators for why this is required.
        if (isXMLType(left, sec)) {
            return left.equals(right);
        }
        if (isXMLType(right, sec)) {
            return right.equals(left);
        }
        return left == right;
    }

    function axIsXMLCollection(x, sec) {
        return sec.AXXML.dPrototype.isPrototypeOf(x) ||
            sec.AXXMLList.dPrototype.isPrototypeOf(x);
    }

    function axGetDescendants(object, mn, sec) {
        if (!axIsXMLCollection(object, sec)) {
            sec.throwError('TypeError', Errors$1.DescendentsError, object);
        }
        return object.descendants(mn);
    }

    function axCheckFilter(sec, value) {
        if (!value || !isXMLCollection(sec, value)) {
            var className = value && value.axClass ? value.axClass.name.toFQNString(false) : '[unknown]';
            sec.throwError('TypeError', Errors$1.FilterError, className);
        }
        return value;
    }

    function axConvertString(x) {
        if (typeof x === "string") {
            return x;
        }
        return x + '';
    }

    /**
     * ActionScript 3 has different behaviour when deciding whether to call toString or valueOf
     * when one operand is a string. Unlike JavaScript, it calls toString if one operand is a
     * string and valueOf otherwise. This sucks, but we have to emulate this behaviour because
     * YouTube depends on it.
     *
     * AS3 also overloads the `+` operator to concatenate XMLs/XMLLists instead of stringifying them.
     */
    function axAdd(l, r, sec) {
        release$1 || assert(!(typeof l === "number" && typeof r === "number"), 'Inline number addition.');
        if (typeof l === "string" || typeof r === "string") {
            return String(l) + String(r);
        }
        if (isXMLCollection(sec, l) && isXMLCollection(sec, r)) {
            return ASXMLList.addXML(l, r);
        }
        return l + r;
    }

    function axTypeOf(x, sec) {
        // ABC doesn't box primitives, so typeof returns the primitive type even when
        // the value is new'd
        if (x) {
            if (x.value) {
                return typeof x.value;
            }
            if (axIsXMLCollection(x, sec)) {
                return "xml";
            }
        }
        return typeof x;
    }

    /**
     * Pops elements from a source array into a destination array. This avoids
     * allocations and should be faster. The elements in the destination array
     * are pushed in the same order as they appear in the source array:
     *
     * popManyInto([1, 2, 3], 2, dst) => dst = [2, 3]
     */
    function popManyInto(src, count, dst) {
        release$1 || assert$2(src.length >= count);
        for (var i = count - 1; i >= 0; i--) {
            dst[i] = src.pop();
        }
        dst.length = count;
    }
    function pushMany(dst, src) {
        for (var i = 0; i < src.length; i++) {
            dst.push(src[i]);
        }
    }

    var Bytecode;
    (function (Bytecode) {
        Bytecode[Bytecode["BKPT"] = 1] = "BKPT";
        Bytecode[Bytecode["NOP"] = 2] = "NOP";
        Bytecode[Bytecode["THROW"] = 3] = "THROW";
        Bytecode[Bytecode["GETSUPER"] = 4] = "GETSUPER";
        Bytecode[Bytecode["GETSUPER_DYN"] = 260] = "GETSUPER_DYN";
        Bytecode[Bytecode["SETSUPER"] = 5] = "SETSUPER";
        Bytecode[Bytecode["SETSUPER_DYN"] = 261] = "SETSUPER_DYN";
        Bytecode[Bytecode["DXNS"] = 6] = "DXNS";
        Bytecode[Bytecode["DXNSLATE"] = 7] = "DXNSLATE";
        Bytecode[Bytecode["KILL"] = 8] = "KILL";
        Bytecode[Bytecode["LABEL"] = 9] = "LABEL";
        Bytecode[Bytecode["LF32X4"] = 10] = "LF32X4";
        Bytecode[Bytecode["SF32X4"] = 11] = "SF32X4";
        Bytecode[Bytecode["IFNLT"] = 12] = "IFNLT";
        Bytecode[Bytecode["IFNLE"] = 13] = "IFNLE";
        Bytecode[Bytecode["IFNGT"] = 14] = "IFNGT";
        Bytecode[Bytecode["IFNGE"] = 15] = "IFNGE";
        Bytecode[Bytecode["JUMP"] = 16] = "JUMP";
        Bytecode[Bytecode["IFTRUE"] = 17] = "IFTRUE";
        Bytecode[Bytecode["IFFALSE"] = 18] = "IFFALSE";
        Bytecode[Bytecode["IFEQ"] = 19] = "IFEQ";
        Bytecode[Bytecode["IFNE"] = 20] = "IFNE";
        Bytecode[Bytecode["IFLT"] = 21] = "IFLT";
        Bytecode[Bytecode["IFLE"] = 22] = "IFLE";
        Bytecode[Bytecode["IFGT"] = 23] = "IFGT";
        Bytecode[Bytecode["IFGE"] = 24] = "IFGE";
        Bytecode[Bytecode["IFSTRICTEQ"] = 25] = "IFSTRICTEQ";
        Bytecode[Bytecode["IFSTRICTNE"] = 26] = "IFSTRICTNE";
        Bytecode[Bytecode["LOOKUPSWITCH"] = 27] = "LOOKUPSWITCH";
        Bytecode[Bytecode["PUSHWITH"] = 28] = "PUSHWITH";
        Bytecode[Bytecode["POPSCOPE"] = 29] = "POPSCOPE";
        Bytecode[Bytecode["NEXTNAME"] = 30] = "NEXTNAME";
        Bytecode[Bytecode["HASNEXT"] = 31] = "HASNEXT";
        Bytecode[Bytecode["PUSHNULL"] = 32] = "PUSHNULL";
        Bytecode[Bytecode["PUSHUNDEFINED"] = 33] = "PUSHUNDEFINED";
        Bytecode[Bytecode["PUSHFLOAT"] = 34] = "PUSHFLOAT";
        Bytecode[Bytecode["NEXTVALUE"] = 35] = "NEXTVALUE";
        Bytecode[Bytecode["PUSHBYTE"] = 36] = "PUSHBYTE";
        Bytecode[Bytecode["PUSHSHORT"] = 37] = "PUSHSHORT";
        Bytecode[Bytecode["PUSHTRUE"] = 38] = "PUSHTRUE";
        Bytecode[Bytecode["PUSHFALSE"] = 39] = "PUSHFALSE";
        Bytecode[Bytecode["PUSHNAN"] = 40] = "PUSHNAN";
        Bytecode[Bytecode["POP"] = 41] = "POP";
        Bytecode[Bytecode["DUP"] = 42] = "DUP";
        Bytecode[Bytecode["SWAP"] = 43] = "SWAP";
        Bytecode[Bytecode["PUSHSTRING"] = 44] = "PUSHSTRING";
        Bytecode[Bytecode["PUSHINT"] = 45] = "PUSHINT";
        Bytecode[Bytecode["PUSHUINT"] = 46] = "PUSHUINT";
        Bytecode[Bytecode["PUSHDOUBLE"] = 47] = "PUSHDOUBLE";
        Bytecode[Bytecode["PUSHSCOPE"] = 48] = "PUSHSCOPE";
        Bytecode[Bytecode["PUSHNAMESPACE"] = 49] = "PUSHNAMESPACE";
        Bytecode[Bytecode["HASNEXT2"] = 50] = "HASNEXT2";
        Bytecode[Bytecode["LI8"] = 53] = "LI8";
        Bytecode[Bytecode["LI16"] = 54] = "LI16";
        Bytecode[Bytecode["LI32"] = 55] = "LI32";
        Bytecode[Bytecode["LF32"] = 56] = "LF32";
        Bytecode[Bytecode["LF64"] = 57] = "LF64";
        Bytecode[Bytecode["SI8"] = 58] = "SI8";
        Bytecode[Bytecode["SI16"] = 59] = "SI16";
        Bytecode[Bytecode["SI32"] = 60] = "SI32";
        Bytecode[Bytecode["SF32"] = 61] = "SF32";
        Bytecode[Bytecode["SF64"] = 62] = "SF64";
        Bytecode[Bytecode["NEWFUNCTION"] = 64] = "NEWFUNCTION";
        Bytecode[Bytecode["CALL"] = 65] = "CALL";
        Bytecode[Bytecode["CONSTRUCT"] = 66] = "CONSTRUCT";
        Bytecode[Bytecode["CALLMETHOD"] = 67] = "CALLMETHOD";
        Bytecode[Bytecode["CALLSTATIC"] = 68] = "CALLSTATIC";
        Bytecode[Bytecode["CALLSUPER"] = 69] = "CALLSUPER";
        Bytecode[Bytecode["CALLSUPER_DYN"] = 69] = "CALLSUPER_DYN";
        Bytecode[Bytecode["CALLPROPERTY"] = 70] = "CALLPROPERTY";
        Bytecode[Bytecode["CALLPROPERTY_DYN"] = 326] = "CALLPROPERTY_DYN";
        Bytecode[Bytecode["RETURNVOID"] = 71] = "RETURNVOID";
        Bytecode[Bytecode["RETURNVALUE"] = 72] = "RETURNVALUE";
        Bytecode[Bytecode["CONSTRUCTSUPER"] = 73] = "CONSTRUCTSUPER";
        Bytecode[Bytecode["CONSTRUCTSUPER_DYN"] = 329] = "CONSTRUCTSUPER_DYN";
        Bytecode[Bytecode["CONSTRUCTPROP"] = 74] = "CONSTRUCTPROP";
        Bytecode[Bytecode["CONSTRUCTPROP_DYN"] = 330] = "CONSTRUCTPROP_DYN";
        Bytecode[Bytecode["CALLSUPERID"] = 75] = "CALLSUPERID";
        Bytecode[Bytecode["CALLPROPLEX"] = 76] = "CALLPROPLEX";
        Bytecode[Bytecode["CALLPROPLEX_DYN"] = 332] = "CALLPROPLEX_DYN";
        Bytecode[Bytecode["CALLINTERFACE"] = 77] = "CALLINTERFACE";
        Bytecode[Bytecode["CALLSUPERVOID"] = 78] = "CALLSUPERVOID";
        Bytecode[Bytecode["CALLSUPERVOID_DYN"] = 334] = "CALLSUPERVOID_DYN";
        Bytecode[Bytecode["CALLPROPVOID"] = 79] = "CALLPROPVOID";
        Bytecode[Bytecode["SXI1"] = 80] = "SXI1";
        Bytecode[Bytecode["SXI8"] = 81] = "SXI8";
        Bytecode[Bytecode["SXI16"] = 82] = "SXI16";
        Bytecode[Bytecode["APPLYTYPE"] = 83] = "APPLYTYPE";
        Bytecode[Bytecode["PUSHFLOAT4"] = 84] = "PUSHFLOAT4";
        Bytecode[Bytecode["NEWOBJECT"] = 85] = "NEWOBJECT";
        Bytecode[Bytecode["NEWARRAY"] = 86] = "NEWARRAY";
        Bytecode[Bytecode["NEWACTIVATION"] = 87] = "NEWACTIVATION";
        Bytecode[Bytecode["NEWCLASS"] = 88] = "NEWCLASS";
        Bytecode[Bytecode["GETDESCENDANTS"] = 89] = "GETDESCENDANTS";
        Bytecode[Bytecode["NEWCATCH"] = 90] = "NEWCATCH";
        Bytecode[Bytecode["FINDPROPSTRICT"] = 93] = "FINDPROPSTRICT";
        Bytecode[Bytecode["FINDPROPSTRICT_DYN"] = 349] = "FINDPROPSTRICT_DYN";
        Bytecode[Bytecode["FINDPROPERTY"] = 94] = "FINDPROPERTY";
        Bytecode[Bytecode["FINDPROPERTY_DYN"] = 350] = "FINDPROPERTY_DYN";
        Bytecode[Bytecode["FINDDEF"] = 95] = "FINDDEF";
        Bytecode[Bytecode["GETLEX"] = 96] = "GETLEX";
        Bytecode[Bytecode["GETLEX_DYN"] = 352] = "GETLEX_DYN";
        Bytecode[Bytecode["SETPROPERTY"] = 97] = "SETPROPERTY";
        Bytecode[Bytecode["SETPROPERTY_DYN"] = 353] = "SETPROPERTY_DYN";
        Bytecode[Bytecode["GETLOCAL"] = 98] = "GETLOCAL";
        Bytecode[Bytecode["SETLOCAL"] = 99] = "SETLOCAL";
        Bytecode[Bytecode["GETGLOBALSCOPE"] = 100] = "GETGLOBALSCOPE";
        Bytecode[Bytecode["GETSCOPEOBJECT"] = 101] = "GETSCOPEOBJECT";
        Bytecode[Bytecode["GETPROPERTY"] = 102] = "GETPROPERTY";
        Bytecode[Bytecode["GETPROPERTY_DYN"] = 358] = "GETPROPERTY_DYN";
        Bytecode[Bytecode["GETOUTERSCOPE"] = 103] = "GETOUTERSCOPE";
        Bytecode[Bytecode["INITPROPERTY"] = 104] = "INITPROPERTY";
        Bytecode[Bytecode["UNUSED_69"] = 105] = "UNUSED_69";
        Bytecode[Bytecode["DELETEPROPERTY"] = 106] = "DELETEPROPERTY";
        Bytecode[Bytecode["DELETEPROPERTY_DYN"] = 362] = "DELETEPROPERTY_DYN";
        Bytecode[Bytecode["UNUSED_6B"] = 107] = "UNUSED_6B";
        Bytecode[Bytecode["GETSLOT"] = 108] = "GETSLOT";
        Bytecode[Bytecode["SETSLOT"] = 109] = "SETSLOT";
        Bytecode[Bytecode["GETGLOBALSLOT"] = 110] = "GETGLOBALSLOT";
        Bytecode[Bytecode["SETGLOBALSLOT"] = 111] = "SETGLOBALSLOT";
        Bytecode[Bytecode["CONVERT_S"] = 112] = "CONVERT_S";
        Bytecode[Bytecode["ESC_XELEM"] = 113] = "ESC_XELEM";
        Bytecode[Bytecode["ESC_XATTR"] = 114] = "ESC_XATTR";
        Bytecode[Bytecode["CONVERT_I"] = 115] = "CONVERT_I";
        Bytecode[Bytecode["CONVERT_U"] = 116] = "CONVERT_U";
        Bytecode[Bytecode["CONVERT_D"] = 117] = "CONVERT_D";
        Bytecode[Bytecode["CONVERT_B"] = 118] = "CONVERT_B";
        Bytecode[Bytecode["CONVERT_O"] = 119] = "CONVERT_O";
        Bytecode[Bytecode["CHECKFILTER"] = 120] = "CHECKFILTER";
        Bytecode[Bytecode["CONVERT_F"] = 121] = "CONVERT_F";
        Bytecode[Bytecode["UNPLUS"] = 122] = "UNPLUS";
        Bytecode[Bytecode["CONVERT_F4"] = 123] = "CONVERT_F4";
        Bytecode[Bytecode["BC_7C"] = 124] = "BC_7C";
        Bytecode[Bytecode["BC_7D"] = 125] = "BC_7D";
        Bytecode[Bytecode["BC_7E"] = 126] = "BC_7E";
        Bytecode[Bytecode["BC_7F"] = 127] = "BC_7F";
        Bytecode[Bytecode["COERCE"] = 128] = "COERCE";
        Bytecode[Bytecode["COERCE_DYN"] = 384] = "COERCE_DYN";
        Bytecode[Bytecode["COERCE_B"] = 129] = "COERCE_B";
        Bytecode[Bytecode["COERCE_A"] = 130] = "COERCE_A";
        Bytecode[Bytecode["COERCE_I"] = 131] = "COERCE_I";
        Bytecode[Bytecode["COERCE_D"] = 132] = "COERCE_D";
        Bytecode[Bytecode["COERCE_S"] = 133] = "COERCE_S";
        Bytecode[Bytecode["ASTYPE"] = 134] = "ASTYPE";
        Bytecode[Bytecode["ASTYPELATE"] = 135] = "ASTYPELATE";
        Bytecode[Bytecode["COERCE_U"] = 136] = "COERCE_U";
        Bytecode[Bytecode["COERCE_O"] = 137] = "COERCE_O";
        Bytecode[Bytecode["NEGATE"] = 144] = "NEGATE";
        Bytecode[Bytecode["INCREMENT"] = 145] = "INCREMENT";
        Bytecode[Bytecode["INCLOCAL"] = 146] = "INCLOCAL";
        Bytecode[Bytecode["DECREMENT"] = 147] = "DECREMENT";
        Bytecode[Bytecode["DECLOCAL"] = 148] = "DECLOCAL";
        Bytecode[Bytecode["TYPEOF"] = 149] = "TYPEOF";
        Bytecode[Bytecode["NOT"] = 150] = "NOT";
        Bytecode[Bytecode["BITNOT"] = 151] = "BITNOT";
        Bytecode[Bytecode["UNUSED_98"] = 152] = "UNUSED_98";
        Bytecode[Bytecode["UNUSED_99"] = 153] = "UNUSED_99";
        Bytecode[Bytecode["UNUSED_9A"] = 154] = "UNUSED_9A";
        Bytecode[Bytecode["UNUSED_9B"] = 155] = "UNUSED_9B";
        Bytecode[Bytecode["UNUSED_9C"] = 156] = "UNUSED_9C";
        Bytecode[Bytecode["UNUSED_9D"] = 157] = "UNUSED_9D";
        Bytecode[Bytecode["UNUSED_9E"] = 158] = "UNUSED_9E";
        Bytecode[Bytecode["UNUSED_9F"] = 159] = "UNUSED_9F";
        Bytecode[Bytecode["ADD"] = 160] = "ADD";
        Bytecode[Bytecode["SUBTRACT"] = 161] = "SUBTRACT";
        Bytecode[Bytecode["MULTIPLY"] = 162] = "MULTIPLY";
        Bytecode[Bytecode["DIVIDE"] = 163] = "DIVIDE";
        Bytecode[Bytecode["MODULO"] = 164] = "MODULO";
        Bytecode[Bytecode["LSHIFT"] = 165] = "LSHIFT";
        Bytecode[Bytecode["RSHIFT"] = 166] = "RSHIFT";
        Bytecode[Bytecode["URSHIFT"] = 167] = "URSHIFT";
        Bytecode[Bytecode["BITAND"] = 168] = "BITAND";
        Bytecode[Bytecode["BITOR"] = 169] = "BITOR";
        Bytecode[Bytecode["BITXOR"] = 170] = "BITXOR";
        Bytecode[Bytecode["EQUALS"] = 171] = "EQUALS";
        Bytecode[Bytecode["STRICTEQUALS"] = 172] = "STRICTEQUALS";
        Bytecode[Bytecode["LESSTHAN"] = 173] = "LESSTHAN";
        Bytecode[Bytecode["LESSEQUALS"] = 174] = "LESSEQUALS";
        Bytecode[Bytecode["GREATERTHAN"] = 175] = "GREATERTHAN";
        Bytecode[Bytecode["GREATEREQUALS"] = 176] = "GREATEREQUALS";
        Bytecode[Bytecode["INSTANCEOF"] = 177] = "INSTANCEOF";
        Bytecode[Bytecode["ISTYPE"] = 178] = "ISTYPE";
        Bytecode[Bytecode["ISTYPELATE"] = 179] = "ISTYPELATE";
        Bytecode[Bytecode["IN"] = 180] = "IN";
        Bytecode[Bytecode["UNUSED_B5"] = 181] = "UNUSED_B5";
        Bytecode[Bytecode["UNUSED_B6"] = 182] = "UNUSED_B6";
        Bytecode[Bytecode["UNUSED_B7"] = 183] = "UNUSED_B7";
        Bytecode[Bytecode["UNUSED_B8"] = 184] = "UNUSED_B8";
        Bytecode[Bytecode["UNUSED_B9"] = 185] = "UNUSED_B9";
        Bytecode[Bytecode["UNUSED_BA"] = 186] = "UNUSED_BA";
        Bytecode[Bytecode["UNUSED_BB"] = 187] = "UNUSED_BB";
        Bytecode[Bytecode["UNUSED_BC"] = 188] = "UNUSED_BC";
        Bytecode[Bytecode["UNUSED_BD"] = 189] = "UNUSED_BD";
        Bytecode[Bytecode["UNUSED_BE"] = 190] = "UNUSED_BE";
        Bytecode[Bytecode["UNUSED_BF"] = 191] = "UNUSED_BF";
        Bytecode[Bytecode["INCREMENT_I"] = 192] = "INCREMENT_I";
        Bytecode[Bytecode["DECREMENT_I"] = 193] = "DECREMENT_I";
        Bytecode[Bytecode["INCLOCAL_I"] = 194] = "INCLOCAL_I";
        Bytecode[Bytecode["DECLOCAL_I"] = 195] = "DECLOCAL_I";
        Bytecode[Bytecode["NEGATE_I"] = 196] = "NEGATE_I";
        Bytecode[Bytecode["ADD_I"] = 197] = "ADD_I";
        Bytecode[Bytecode["SUBTRACT_I"] = 198] = "SUBTRACT_I";
        Bytecode[Bytecode["MULTIPLY_I"] = 199] = "MULTIPLY_I";
        Bytecode[Bytecode["UNUSED_C8"] = 200] = "UNUSED_C8";
        Bytecode[Bytecode["UNUSED_C9"] = 201] = "UNUSED_C9";
        Bytecode[Bytecode["UNUSED_CA"] = 202] = "UNUSED_CA";
        Bytecode[Bytecode["UNUSED_CB"] = 203] = "UNUSED_CB";
        Bytecode[Bytecode["UNUSED_CC"] = 204] = "UNUSED_CC";
        Bytecode[Bytecode["UNUSED_CD"] = 205] = "UNUSED_CD";
        Bytecode[Bytecode["UNUSED_CE"] = 206] = "UNUSED_CE";
        Bytecode[Bytecode["UNUSED_CF"] = 207] = "UNUSED_CF";
        Bytecode[Bytecode["GETLOCAL0"] = 208] = "GETLOCAL0";
        Bytecode[Bytecode["GETLOCAL1"] = 209] = "GETLOCAL1";
        Bytecode[Bytecode["GETLOCAL2"] = 210] = "GETLOCAL2";
        Bytecode[Bytecode["GETLOCAL3"] = 211] = "GETLOCAL3";
        Bytecode[Bytecode["SETLOCAL0"] = 212] = "SETLOCAL0";
        Bytecode[Bytecode["SETLOCAL1"] = 213] = "SETLOCAL1";
        Bytecode[Bytecode["SETLOCAL2"] = 214] = "SETLOCAL2";
        Bytecode[Bytecode["SETLOCAL3"] = 215] = "SETLOCAL3";
        Bytecode[Bytecode["UNUSED_D8"] = 216] = "UNUSED_D8";
        Bytecode[Bytecode["UNUSED_D9"] = 217] = "UNUSED_D9";
        Bytecode[Bytecode["UNUSED_DA"] = 218] = "UNUSED_DA";
        Bytecode[Bytecode["UNUSED_DB"] = 219] = "UNUSED_DB";
        Bytecode[Bytecode["UNUSED_DC"] = 220] = "UNUSED_DC";
        Bytecode[Bytecode["UNUSED_DD"] = 221] = "UNUSED_DD";
        Bytecode[Bytecode["UNUSED_DE"] = 222] = "UNUSED_DE";
        Bytecode[Bytecode["UNUSED_DF"] = 223] = "UNUSED_DF";
        Bytecode[Bytecode["UNUSED_E0"] = 224] = "UNUSED_E0";
        Bytecode[Bytecode["UNUSED_E1"] = 225] = "UNUSED_E1";
        Bytecode[Bytecode["UNUSED_E2"] = 226] = "UNUSED_E2";
        Bytecode[Bytecode["UNUSED_E3"] = 227] = "UNUSED_E3";
        Bytecode[Bytecode["UNUSED_E4"] = 228] = "UNUSED_E4";
        Bytecode[Bytecode["UNUSED_E5"] = 229] = "UNUSED_E5";
        Bytecode[Bytecode["UNUSED_E6"] = 230] = "UNUSED_E6";
        Bytecode[Bytecode["UNUSED_E7"] = 231] = "UNUSED_E7";
        Bytecode[Bytecode["UNUSED_E8"] = 232] = "UNUSED_E8";
        Bytecode[Bytecode["UNUSED_E9"] = 233] = "UNUSED_E9";
        Bytecode[Bytecode["UNUSED_EA"] = 234] = "UNUSED_EA";
        Bytecode[Bytecode["UNUSED_EB"] = 235] = "UNUSED_EB";
        Bytecode[Bytecode["UNUSED_EC"] = 236] = "UNUSED_EC";
        Bytecode[Bytecode["UNUSED_ED"] = 237] = "UNUSED_ED";
        Bytecode[Bytecode["UNUSED_EE"] = 238] = "UNUSED_EE";
        Bytecode[Bytecode["INVALID"] = 237] = "INVALID";
        Bytecode[Bytecode["DEBUG"] = 239] = "DEBUG";
        Bytecode[Bytecode["DEBUGLINE"] = 240] = "DEBUGLINE";
        Bytecode[Bytecode["DEBUGFILE"] = 241] = "DEBUGFILE";
        Bytecode[Bytecode["BKPTLINE"] = 242] = "BKPTLINE";
        Bytecode[Bytecode["TIMESTAMP"] = 243] = "TIMESTAMP";
        Bytecode[Bytecode["RESTARGC"] = 244] = "RESTARGC";
        Bytecode[Bytecode["RESTARG"] = 245] = "RESTARG";
        Bytecode[Bytecode["UNUSED_F6"] = 246] = "UNUSED_F6";
        Bytecode[Bytecode["UNUSED_F7"] = 247] = "UNUSED_F7";
        Bytecode[Bytecode["UNUSED_F8"] = 248] = "UNUSED_F8";
        Bytecode[Bytecode["UNUSED_F9"] = 249] = "UNUSED_F9";
        Bytecode[Bytecode["UNUSED_FA"] = 250] = "UNUSED_FA";
        Bytecode[Bytecode["UNUSED_FB"] = 251] = "UNUSED_FB";
        Bytecode[Bytecode["UNUSED_FC"] = 252] = "UNUSED_FC";
        Bytecode[Bytecode["UNUSED_FD"] = 253] = "UNUSED_FD";
        Bytecode[Bytecode["UNUSED_FE"] = 254] = "UNUSED_FE";
        Bytecode[Bytecode["END"] = 255] = "END";
    })(Bytecode || (Bytecode = {}));
    var BytecodeName = Bytecode;
    var Instruction = /** @class */ (function () {
        function Instruction(position, name, params, delta, deltaScope, terminal, refs) {
            if (params === void 0) { params = []; }
            if (delta === void 0) { delta = 0; }
            if (deltaScope === void 0) { deltaScope = 0; }
            if (terminal === void 0) { terminal = false; }
            if (refs === void 0) { refs = []; }
            this.position = position;
            this.name = name;
            this.params = params;
            this.delta = delta;
            this.deltaScope = deltaScope;
            this.terminal = terminal;
            this.refs = refs;
            this.stack = -1024;
            this.scope = -1024;
        }
        Instruction.prototype.toString = function () {
            return "Instruction(" + this.position + ", " + BytecodeName[this.name] + " (" + this.name + "), [" + this.params + "], " + this.stack + " -> " + (this.stack + this.delta) + ", " + this.scope + " -> " + (this.scope + this.deltaScope) + ", " + this.terminal + ", [" + this.refs + "])";
        };
        return Instruction;
    }());
    function compile(methodInfo) {
        var abc = methodInfo.abc;
        var code = methodInfo.getBody().code;
        var q = [];
        var _loop_1 = function (i) {
            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q;
            var u30 = function () {
                var u = code[i++];
                if (u & 0x80) {
                    u = u & 0x7f | code[i++] << 7;
                    if (u & 0x4000) {
                        u = u & 0x3fff | code[i++] << 14;
                        if (u & 0x200000) {
                            u = u & 0x1fffff | code[i++] << 21;
                            if (u & 0x10000000) {
                                u = u & 0x0fffffff | code[i++] << 28;
                                u = u & 0xffffffff;
                            }
                        }
                    }
                }
                return u >>> 0;
            };
            var mn_1 = function () {
                var index = u30();
                var name = abc.getMultiname(index);
                if (name.isRuntimeName())
                    return [index, 256, -1];
                if (name.isRuntimeNamespace())
                    return [index, 512, -1];
                return [index, 0, 0];
            };
            var s24 = function () {
                var u = code[i++] | (code[i++] << 8) | (code[i++] << 16);
                return (u << 8) >> 8;
            };
            var s8 = function () {
                var u = code[i++];
                return (u << 24) >> 24;
            };
            var oldi = i;
            var z = code[i++];
            switch (z) {
                case Bytecode.LABEL:
                    q.push(new Instruction(oldi, z));
                    break;
                case Bytecode.DEBUGFILE:
                    q.push(new Instruction(oldi, z, [u30()]));
                    break;
                case Bytecode.DEBUGLINE:
                    q.push(new Instruction(oldi, z, [u30()]));
                    break;
                case Bytecode.DEBUG:
                    q.push(new Instruction(oldi, z, [s8(), u30(), s8(), u30()]));
                    break;
                case Bytecode.THROW:
                    q.push(new Instruction(oldi, z, [], -1, 0, true));
                    break;
                case Bytecode.PUSHSCOPE:
                    q.push(new Instruction(oldi, z, [], -1, 1));
                    break;
                case Bytecode.PUSHWITH:
                    q.push(new Instruction(oldi, z, [], -1, 1));
                    break;
                case Bytecode.POPSCOPE:
                    q.push(new Instruction(oldi, z, [], 0, -1));
                    break;
                case Bytecode.GETSCOPEOBJECT:
                    q.push(new Instruction(oldi, z, [s8()], 1, 0));
                    break;
                case Bytecode.GETGLOBALSCOPE:
                    q.push(new Instruction(oldi, z, [], 1));
                    break;
                case Bytecode.GETSLOT:
                    q.push(new Instruction(oldi, z, [u30()], 0));
                    break;
                case Bytecode.SETSLOT:
                    q.push(new Instruction(oldi, z, [u30()], -2));
                    break;
                case Bytecode.NEXTNAME:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.NEXTVALUE:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.HASNEXT2:
                    q.push(new Instruction(oldi, z, [u30(), u30()], 1));
                    break;
                case Bytecode.IN:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.DUP:
                    q.push(new Instruction(oldi, z, [], 1));
                    break;
                case Bytecode.POP:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.SWAP:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.PUSHTRUE:
                    q.push(new Instruction(oldi, z, [], 1));
                    break;
                case Bytecode.PUSHFALSE:
                    q.push(new Instruction(oldi, z, [], 1));
                    break;
                case Bytecode.PUSHBYTE:
                    q.push(new Instruction(oldi, z, [s8()], 1));
                    break;
                case Bytecode.PUSHSHORT:
                    q.push(new Instruction(oldi, z, [u30() << 16 >> 16], 1));
                    break;
                case Bytecode.PUSHINT:
                    q.push(new Instruction(oldi, z, [u30()], 1));
                    break;
                case Bytecode.PUSHDOUBLE:
                    q.push(new Instruction(oldi, z, [u30()], 1));
                    break;
                case Bytecode.PUSHNAN:
                    q.push(new Instruction(oldi, z, [], 1));
                    break;
                case Bytecode.PUSHNULL:
                    q.push(new Instruction(oldi, z, [], 1));
                    break;
                case Bytecode.PUSHUNDEFINED:
                    q.push(new Instruction(oldi, z, [], 1));
                    break;
                case Bytecode.PUSHSTRING:
                    q.push(new Instruction(oldi, z, [u30()], 1));
                    break;
                case Bytecode.IFEQ:
                    j = s24();
                    q.push(new Instruction(oldi, z, [i + j], -2, 0, false, [i + j]));
                    break;
                case Bytecode.IFNE:
                    j = s24();
                    q.push(new Instruction(oldi, z, [i + j], -2, 0, false, [i + j]));
                    break;
                case Bytecode.IFSTRICTEQ:
                    j = s24();
                    q.push(new Instruction(oldi, z, [i + j], -2, 0, false, [i + j]));
                    break;
                case Bytecode.IFSTRICTNE:
                    j = s24();
                    q.push(new Instruction(oldi, z, [i + j], -2, 0, false, [i + j]));
                    break;
                case Bytecode.IFGT:
                case Bytecode.IFNLE:
                    j = s24();
                    q.push(new Instruction(oldi, Bytecode.IFGT, [i + j], -2, 0, false, [i + j]));
                    break;
                case Bytecode.IFGE:
                case Bytecode.IFNLT:
                    j = s24();
                    q.push(new Instruction(oldi, Bytecode.IFGE, [i + j], -2, 0, false, [i + j]));
                    break;
                case Bytecode.IFLT:
                case Bytecode.IFNGE:
                    j = s24();
                    q.push(new Instruction(oldi, Bytecode.IFLT, [i + j], -2, 0, false, [i + j]));
                    break;
                case Bytecode.IFLE:
                case Bytecode.IFNGT:
                    j = s24();
                    q.push(new Instruction(oldi, Bytecode.IFLE, [i + j], -2, 0, false, [i + j]));
                    break;
                case Bytecode.IFTRUE:
                    j = s24();
                    q.push(new Instruction(oldi, z, [i + j], -1, 0, false, [i + j]));
                    break;
                case Bytecode.IFFALSE:
                    j = s24();
                    q.push(new Instruction(oldi, z, [i + j], -1, 0, false, [i + j]));
                    break;
                case Bytecode.LOOKUPSWITCH:
                    offset = oldi + s24();
                    cases = u30();
                    jumps = [offset];
                    for (var j_1 = 0; j_1 <= cases; j_1++)
                        jumps.push(oldi + s24());
                    q.push(new Instruction(oldi, z, jumps, -1, 0, true, jumps));
                    break;
                case Bytecode.JUMP:
                    j = s24();
                    q.push(new Instruction(oldi, z, [i + j], 0, 0, true, [i + j]));
                    break;
                case Bytecode.RETURNVALUE:
                    q.push(new Instruction(oldi, z, [], -1, 0, true));
                    break;
                case Bytecode.RETURNVOID:
                    q.push(new Instruction(oldi, z, [], 0, 0, true));
                    break;
                case Bytecode.NOT:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.BITNOT:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.NEGATE:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.INCREMENT:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.DECREMENT:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.INCREMENT_I:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.DECREMENT_I:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.INCLOCAL_I:
                    q.push(new Instruction(oldi, z, [u30()], 0));
                    break;
                case Bytecode.DECLOCAL_I:
                    q.push(new Instruction(oldi, z, [u30()], 0));
                    break;
                case Bytecode.ADD:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.SUBTRACT:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.MULTIPLY:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.DIVIDE:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.MODULO:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.LSHIFT:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.RSHIFT:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.URSHIFT:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.BITAND:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.BITOR:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.BITXOR:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.EQUALS:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.STRICTEQUALS:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.GREATERTHAN:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.GREATEREQUALS:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.LESSTHAN:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.LESSEQUALS:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.ISTYPELATE:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.ASTYPELATE:
                    q.push(new Instruction(oldi, z, [], -1));
                    break;
                case Bytecode.CALL:
                    argnum = u30();
                    q.push(new Instruction(oldi, z, [argnum], -argnum - 1));
                    break;
                case Bytecode.CONSTRUCT:
                    argnum = u30();
                    q.push(new Instruction(oldi, z, [argnum, index], -argnum));
                    break;
                case Bytecode.CALLPROPERTY:
                    _a = mn_1(), index = _a[0], dyn = _a[1], d = _a[2];
                    argnum = u30();
                    q.push(new Instruction(oldi, z + dyn, [argnum, index], -argnum + d));
                    break;
                case Bytecode.CALLPROPLEX:
                    _b = mn_1(), index = _b[0], dyn = _b[1], d = _b[2];
                    argnum = u30();
                    q.push(new Instruction(oldi, z + dyn, [argnum, index], -argnum + d));
                    break;
                case Bytecode.CALLPROPVOID:
                    _c = mn_1(), index = _c[0], dyn = _c[1], d = _c[2];
                    argnum = u30();
                    q.push(new Instruction(oldi, z + dyn, [argnum, index], -(argnum + 1) + d));
                    break;
                case Bytecode.APPLYTYPE:
                    argnum = u30();
                    q.push(new Instruction(oldi, z, [argnum], -argnum));
                    break;
                case Bytecode.FINDPROPSTRICT:
                    _d = mn_1(), index = _d[0], dyn = _d[1], d = _d[2];
                    q.push(new Instruction(oldi, z + dyn, [index], 1 + d));
                    break;
                case Bytecode.FINDPROPERTY:
                    _e = mn_1(), index = _e[0], dyn = _e[1], d = _e[2];
                    q.push(new Instruction(oldi, z + dyn, [index], 1 + d));
                    break;
                case Bytecode.NEWFUNCTION:
                    q.push(new Instruction(oldi, z, [u30()], 1));
                    break;
                case Bytecode.NEWCLASS:
                    q.push(new Instruction(oldi, z, [u30()], 0));
                    break;
                case Bytecode.NEWARRAY:
                    argnum = u30();
                    q.push(new Instruction(oldi, z, [argnum], -argnum + 1));
                    break;
                case Bytecode.NEWOBJECT:
                    argnum = u30();
                    q.push(new Instruction(oldi, z, [argnum], -2 * argnum + 1));
                    break;
                case Bytecode.NEWACTIVATION:
                    q.push(new Instruction(oldi, z, [], 1));
                    break;
                case Bytecode.NEWCATCH:
                    q.push(new Instruction(oldi, z, [u30()], 1));
                    break;
                case Bytecode.CONSTRUCTSUPER:
                    argnum = u30();
                    q.push(new Instruction(oldi, z, [argnum], -(argnum + 1)));
                    break;
                case Bytecode.CALLSUPER:
                    _f = mn_1(), index = _f[0], dyn = _f[1], d = _f[2];
                    argnum = u30();
                    q.push(new Instruction(oldi, z + dyn, [argnum, index], -argnum + d));
                    break;
                case Bytecode.CALLSUPERVOID:
                    _g = mn_1(), index = _g[0], dyn = _g[1], d = _g[2];
                    argnum = u30();
                    q.push(new Instruction(oldi, z + dyn, [argnum, index], -(argnum + 1) + d));
                    break;
                case Bytecode.CONSTRUCTPROP:
                    _h = mn_1(), index = _h[0], dyn = _h[1], d = _h[2];
                    argnum = u30();
                    q.push(new Instruction(oldi, z + dyn, [argnum, index], -argnum + d));
                    break;
                case Bytecode.GETPROPERTY:
                    _j = mn_1(), index = _j[0], dyn = _j[1], d = _j[2];
                    q.push(new Instruction(oldi, Bytecode.GETPROPERTY + dyn, [index], 0 + d));
                    break;
                case Bytecode.INITPROPERTY:
                case Bytecode.SETPROPERTY:
                    _k = mn_1(), index = _k[0], dyn = _k[1], d = _k[2];
                    q.push(new Instruction(oldi, Bytecode.SETPROPERTY + dyn, [index], -2 + d));
                    break;
                case Bytecode.DELETEPROPERTY:
                    _l = mn_1(), index = _l[0], dyn = _l[1], d = _l[2];
                    q.push(new Instruction(oldi, z + dyn, [index], 0 + d));
                case Bytecode.GETSUPER:
                    _m = mn_1(), index = _m[0], dyn = _m[1], d = _m[2];
                    q.push(new Instruction(oldi, z + dyn, [index], 0 + d));
                    break;
                case Bytecode.SETSUPER:
                    _o = mn_1(), index = _o[0], dyn = _o[1], d = _o[2];
                    q.push(new Instruction(oldi, z + dyn, [index], -2 + d));
                    break;
                case Bytecode.COERCE:
                    _p = mn_1(), index = _p[0], dyn = _p[1], d = _p[2];
                    q.push(new Instruction(oldi, z + dyn, [index], 0 + d));
                    break;
                case Bytecode.COERCE_A:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.COERCE_S:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.CONVERT_I:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.CONVERT_D:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.CONVERT_B:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.CONVERT_U:
                    q.push(new Instruction(oldi, z, [], 0));
                    break;
                case Bytecode.GETLOCAL:
                    q.push(new Instruction(oldi, Bytecode.GETLOCAL, [u30()], 1));
                    break;
                case Bytecode.GETLOCAL0:
                    q.push(new Instruction(oldi, Bytecode.GETLOCAL, [0], 1));
                    break;
                case Bytecode.GETLOCAL1:
                    q.push(new Instruction(oldi, Bytecode.GETLOCAL, [1], 1));
                    break;
                case Bytecode.GETLOCAL2:
                    q.push(new Instruction(oldi, Bytecode.GETLOCAL, [2], 1));
                    break;
                case Bytecode.GETLOCAL3:
                    q.push(new Instruction(oldi, Bytecode.GETLOCAL, [3], 1));
                    break;
                case Bytecode.SETLOCAL:
                    q.push(new Instruction(oldi, Bytecode.SETLOCAL, [u30()], -1));
                    break;
                case Bytecode.SETLOCAL0:
                    q.push(new Instruction(oldi, Bytecode.SETLOCAL, [0], -1));
                    break;
                case Bytecode.SETLOCAL1:
                    q.push(new Instruction(oldi, Bytecode.SETLOCAL, [1], -1));
                    break;
                case Bytecode.SETLOCAL2:
                    q.push(new Instruction(oldi, Bytecode.SETLOCAL, [2], -1));
                    break;
                case Bytecode.SETLOCAL3:
                    q.push(new Instruction(oldi, Bytecode.SETLOCAL, [3], -1));
                    break;
                case Bytecode.KILL:
                    q.push(new Instruction(oldi, z, [u30()], 0));
                    break;
                case Bytecode.GETLEX:
                    _q = mn_1(), index = _q[0], dyn = _q[1], d = _q[2];
                    q.push(new Instruction(oldi, z + dyn, [index], 1 + d));
                    break;
                default:
                    console.log("UNKNOWN #" + code[i - 1].toString(16) + " " + BytecodeName[code[i - 1]] + " (method N" + methodInfo.index() + ")");
                    return { value: "UNKNOWN BYTECODE $" + code[i - 1].toString(16) + " (" + BytecodeName[code[i - 1]] + ") at " + oldi };
            }
            out_i_1 = i;
        };
        var j, j, j, j, j, j, j, j, j, j, offset, cases, jumps, j, argnum, argnum, index, dyn, d, argnum, index, dyn, d, argnum, index, dyn, d, argnum, argnum, index, dyn, d, index, dyn, d, argnum, argnum, argnum, index, dyn, d, argnum, index, dyn, d, argnum, index, dyn, d, argnum, index, dyn, d, index, dyn, d, index, dyn, d, index, dyn, d, index, dyn, d, index, dyn, d, index, dyn, d, out_i_1;
        for (var i = 0; i < code.length;) {
            var state_1 = _loop_1(i);
            i = out_i_1;
            if (typeof state_1 === "object")
                return state_1.value;
        }
        var propagate = function (position, stack) {
            var v = stack;
            for (var i = 0; i < q.length; i++) {
                if (q[i].position >= position) {
                    if (q[i].stack >= 0)
                        return;
                    q[i].stack = v;
                    v += q[i].delta;
                    for (var j_2 = 0; j_2 < q[i].refs.length; j_2++)
                        propagate(q[i].refs[j_2], v);
                    if (q[i].terminal)
                        return;
                }
            }
        };
        propagate(0, 0);
        var propagateScope = function (position, scope) {
            var v = scope;
            for (var i = 0; i < q.length; i++) {
                if (q[i].position >= position) {
                    if (q[i].scope >= 0)
                        return;
                    q[i].scope = v;
                    v += q[i].deltaScope;
                    for (var j_3 = 0; j_3 < q[i].refs.length; j_3++)
                        propagateScope(q[i].refs[j_3], v);
                    if (q[i].terminal)
                        return;
                }
            }
        };
        propagateScope(0, 0);
        var targets = [];
        targets.push(0);
        for (var i = 0; i < q.length; i++)
            for (var j_4 = 0; j_4 < q[i].refs.length; j_4++)
                targets.push(q[i].refs[j_4]);
        var maxstack = 0;
        for (var i = 0; i < q.length; i++)
            if (q[i].stack > maxstack)
                maxstack = q[i].stack;
        var maxlocal = 0;
        for (var i = 0; i < q.length; i++)
            if (q[i].name == Bytecode.GETLOCAL || q[i].name == Bytecode.SETLOCAL)
                if (q[i].params[0] > maxlocal)
                    maxlocal = q[i].params[0];
        var temp = false;
        for (var i = 0; i < q.length; i++)
            if (q[i].name == Bytecode.NEWOBJECT || q[i].name == Bytecode.SWAP || q[i].name == Bytecode.HASNEXT2)
                temp = true;
        var maxscope = 0;
        for (var i = 0; i < q.length; i++)
            if (q[i].scope > maxscope)
                maxscope = q[i].scope;
        var params = methodInfo.parameters;
        var underrun = "[stack underrun]";
        var js0 = ["// (#" + methodInfo.index() + ") --- " + methodInfo];
        js0.push("(function (context) { return function compiled_" + (methodInfo.getName()).replace(/([^a-z0-9]+)/gi, "_") + "() {");
        for (var i = 0; i < params.length; i++)
            if (params[i].hasOptionalValue()) {
                js0.push("    let argnum = arguments.length;");
                break;
            }
        js0.push("    let local0 = this === context.jsGlobal ? context.savedScope.global.object : this;");
        for (var i = 0; i < params.length; i++) {
            var p = params[i];
            js0.push("    let local" + (i + 1) + " = arguments[" + i + "];");
            if (params[i].hasOptionalValue())
                switch (p.optionalValueKind) {
                    case 1 /* Utf8 */:
                        js0.push("    if (argnum <= " + i + ") local" + (i + 1) + " = context.abc.getString(" + p.optionalValueIndex + ");");
                        break;
                    default:
                        js0.push("    if (argnum <= " + i + ") local" + (i + 1) + " = " + p.getOptionalValue() + ";");
                        break;
                }
        }
        for (var i = params.length + 1; i <= maxlocal; i++)
            js0.push("    let local" + i + " = undefined;");
        for (var i = 0; i <= maxstack; i++)
            js0.push("    let stack" + i + " = undefined;");
        for (var i = 0; i <= maxscope; i++)
            js0.push("    let scope" + i + " = undefined;");
        if (temp)
            js0.push("    let temp = undefined;");
        js0.push("    let tr = undefined;");
        var names = [];
        var getname = function (n) {
            var mn = abc.getMultiname(n);
            var i = names.indexOf(mn);
            if (i < 0) {
                i = names.length;
                names.push(mn);
                js0.push("    let name" + i + " = context.names[" + i + "];");
            }
            return "name" + i;
        };
        js0.push("    let sec = context.sec;");
        var js = [];
        js.push("    let p = 0;");
        js.push("    while (true) {");
        js.push("        switch (p) {");
        var _loop_2 = function (i) {
            var z = q[i];
            if (targets.indexOf(z.position) >= 0)
                js.push("            case " + z.position + ":");
            js.push("                    //" + BytecodeName[z.name] + " " + z.params.join(" / "));
            var stackF = function (n) { return ((z.stack - 1 - n) >= 0) ? ("stack" + (z.stack - 1 - n)) : underrun; };
            var stack0 = stackF(0);
            var stack1 = stackF(1);
            var stack2 = stackF(2);
            var stack3 = stackF(3);
            var stackN = stackF(-1);
            var scope = z.scope > 0 ? "scope" + (z.scope - 1) : "context.savedScope";
            var scopeN = "scope" + z.scope;
            var local = function (n) { return "local" + n; };
            var param = function (n) { return z.params[n]; };
            if (z.stack < 0) {
                js.push("                    // unreachable");
            }
            else
                switch (z.name) {
                    case Bytecode.LABEL:
                        break;
                    case Bytecode.DEBUGFILE:
                        break;
                    case Bytecode.DEBUGLINE:
                        break;
                    case Bytecode.DEBUG:
                        break;
                    case Bytecode.THROW:
                        break;
                    case Bytecode.GETLOCAL:
                        js.push("                " + stackN + " = " + local(param(0)) + ";");
                        break;
                    case Bytecode.SETLOCAL:
                        js.push("                " + local(param(0)) + " = " + stack0 + ";");
                        break;
                    case Bytecode.GETSLOT:
                        js.push("                " + stack0 + " = sec.box(" + stack0 + ").axGetSlot(" + param(0) + ");");
                        break;
                    case Bytecode.SETSLOT:
                        js.push("                sec.box(" + stack1 + ").axSetSlot(" + param(0) + ", " + stack0 + ");");
                        break;
                    case Bytecode.GETGLOBALSCOPE:
                        js.push("                " + stackN + " = context.savedScope.global.object;");
                        break;
                    case Bytecode.PUSHSCOPE:
                        js.push("                " + scopeN + " = " + scope + ".extend(sec.box(" + stack0 + "));");
                        break;
                    case Bytecode.PUSHWITH:
                        js.push("                " + scopeN + " = context.pushwith(" + scope + ", " + stack0 + ");");
                        break;
                    case Bytecode.POPSCOPE:
                        js.push("                " + scope + " = undefined;");
                        break;
                    case Bytecode.GETSCOPEOBJECT:
                        js.push("                " + stackN + " = scope" + param(0) + ".object;");
                        break;
                    case Bytecode.NEXTNAME:
                        js.push("                " + stack1 + " = sec.box(" + stack1 + ").axNextName(" + stack0 + ");");
                        break;
                    case Bytecode.NEXTVALUE:
                        js.push("                " + stack1 + " = sec.box(" + stack1 + ").axNextValue(" + stack0 + ");");
                        break;
                    case Bytecode.HASNEXT2:
                        js.push("                temp = context.hasnext2(" + local(param(0)) + ", " + local(param(1)) + ");");
                        js.push("                " + local(param(0)) + " = temp[0];");
                        js.push("                " + local(param(1)) + " = temp[1];");
                        js.push("                " + stackN + " = " + local(param(1)) + " > 0;");
                        break;
                    case Bytecode.IN:
                        js.push("                " + stack1 + " = (" + stack1 + " && " + stack1 + ".axClass === sec.AXQName) ? obj.axHasProperty(" + stack1 + ".name) : " + stack0 + ".axHasPublicProperty(" + stack1 + ");");
                        break;
                    case Bytecode.DUP:
                        js.push("                " + stackN + " = " + stack0 + ";");
                        break;
                    case Bytecode.POP:
                        js.push("                ;");
                        break;
                    case Bytecode.SWAP:
                        js.push("                temp = " + stack0 + ";");
                        js.push("                " + stack0 + " = " + stack1 + ";");
                        js.push("                " + stack1 + " = temp;");
                        js.push("                temp = undefined;");
                        break;
                    case Bytecode.PUSHTRUE:
                        js.push("                " + stackN + " = true;");
                        break;
                    case Bytecode.PUSHFALSE:
                        js.push("                " + stackN + " = false;");
                        break;
                    case Bytecode.PUSHBYTE:
                        js.push("                " + stackN + " = " + param(0) + ";");
                        break;
                    case Bytecode.PUSHSHORT:
                        js.push("                " + stackN + " = " + param(0) + ";");
                        break;
                    case Bytecode.PUSHINT:
                        js.push("                " + stackN + " = " + abc.ints[param(0)] + ";");
                        break;
                    case Bytecode.PUSHDOUBLE:
                        js.push("                " + stackN + " = " + abc.doubles[param(0)] + ";");
                        break;
                    case Bytecode.PUSHSTRING:
                        js.push("                " + stackN + " = context.abc.getString(" + param(0) + ");");
                        break;
                    case Bytecode.PUSHNAN:
                        js.push("                " + stackN + " = NaN;");
                        break;
                    case Bytecode.PUSHNULL:
                        js.push("                " + stackN + " = null;");
                        break;
                    case Bytecode.PUSHUNDEFINED:
                        js.push("                " + stackN + " = undefined;");
                        break;
                    case Bytecode.IFEQ:
                        js.push("                if (" + stack0 + " == " + stack1 + ") { p = " + param(0) + "; continue; };");
                        break;
                    case Bytecode.IFNE:
                        js.push("                if (" + stack0 + " != " + stack1 + ") { p = " + param(0) + "; continue; };");
                        break;
                    case Bytecode.IFSTRICTEQ:
                        js.push("                if (" + stack0 + " === " + stack1 + ") { p = " + param(0) + "; continue; };");
                        break;
                    case Bytecode.IFSTRICTNE:
                        js.push("                if (" + stack0 + " !== " + stack1 + ") { p = " + param(0) + "; continue; };");
                        break;
                    case Bytecode.IFGT:
                        js.push("                if (" + stack0 + " < " + stack1 + ") { p = " + param(0) + "; continue; };");
                        break;
                    case Bytecode.IFGE:
                        js.push("                if (" + stack0 + " <= " + stack1 + ") { p = " + param(0) + "; continue; };");
                        break;
                    case Bytecode.IFLT:
                        js.push("                if (" + stack0 + " > " + stack1 + ") { p = " + param(0) + "; continue; };");
                        break;
                    case Bytecode.IFLE:
                        js.push("                if (" + stack0 + " >= " + stack1 + ") { p = " + param(0) + "; continue; };");
                        break;
                    case Bytecode.IFFALSE:
                        js.push("                if (!" + stack0 + ") { p = " + param(0) + "; continue; };");
                        break;
                    case Bytecode.IFTRUE:
                        js.push("                if (" + stack0 + ") { p = " + param(0) + "; continue; };");
                        break;
                    case Bytecode.LOOKUPSWITCH:
                        jj = z.params.concat();
                        dj = jj.shift();
                        js.push("                if (" + stack0 + " >= 0 && " + stack0 + " < " + jj.length + ") { p = [" + jj.join(", ") + "][" + stack0 + "]; continue; } else { p = " + dj + "; continue; };");
                        break;
                    case Bytecode.JUMP:
                        js.push("                { p = " + param(0) + "; continue; };");
                        break;
                    case Bytecode.INCREMENT:
                        js.push("                " + stack0 + "++;");
                        break;
                    case Bytecode.DECREMENT:
                        js.push("                " + stack0 + "--;");
                        break;
                    case Bytecode.INCREMENT_I:
                        js.push("                " + stack0 + " |= 0;");
                        js.push("                " + stack0 + "++;");
                        break;
                    case Bytecode.DECREMENT_I:
                        js.push("                " + stack0 + " |= 0;");
                        js.push("                " + stack0 + "--;");
                        break;
                    case Bytecode.INCLOCAL_I:
                        js.push("                " + local(param(0)) + " |= 0;");
                        js.push("                " + local(param(0)) + "++;");
                        break;
                    case Bytecode.DECLOCAL_I:
                        js.push("                " + local(param(0)) + " |= 0;");
                        js.push("                " + local(param(0)) + "++;");
                        break;
                    case Bytecode.ADD:
                        js.push("                " + stack1 + " = " + stack1 + " + " + stack0 + ";");
                        break;
                    case Bytecode.SUBTRACT:
                        js.push("                " + stack1 + " = " + stack1 + " - " + stack0 + ";");
                        break;
                    case Bytecode.MULTIPLY:
                        js.push("                " + stack1 + " = " + stack1 + " * " + stack0 + ";");
                        break;
                    case Bytecode.DIVIDE:
                        js.push("                " + stack1 + " = " + stack1 + " / " + stack0 + ";");
                        break;
                    case Bytecode.MODULO:
                        js.push("                " + stack1 + " = " + stack1 + " % " + stack0 + ";");
                        break;
                    case Bytecode.LSHIFT:
                        js.push("                " + stack1 + " = " + stack1 + " << " + stack0 + ";");
                        break;
                    case Bytecode.RSHIFT:
                        js.push("                " + stack1 + " = " + stack1 + " >> " + stack0 + ";");
                        break;
                    case Bytecode.URSHIFT:
                        js.push("                " + stack1 + " = " + stack1 + " >>> " + stack0 + ";");
                        break;
                    case Bytecode.BITAND:
                        js.push("                " + stack1 + " = " + stack1 + " & " + stack0 + ";");
                        break;
                    case Bytecode.BITOR:
                        js.push("                " + stack1 + " = " + stack1 + " | " + stack0 + ";");
                        break;
                    case Bytecode.BITXOR:
                        js.push("                " + stack1 + " = " + stack1 + " ^ " + stack0 + ";");
                        break;
                    case Bytecode.EQUALS:
                        js.push("                " + stack1 + " = " + stack1 + " == " + stack0 + ";");
                        break;
                    case Bytecode.STRICTEQUALS:
                        js.push("                " + stack1 + " = " + stack1 + " === " + stack0 + ";");
                        break;
                    case Bytecode.GREATERTHAN:
                        js.push("                " + stack1 + " = " + stack1 + " > " + stack0 + ";");
                        break;
                    case Bytecode.GREATEREQUALS:
                        js.push("                " + stack1 + " = " + stack1 + " >= " + stack0 + ";");
                        break;
                    case Bytecode.LESSTHAN:
                        js.push("                " + stack1 + " = " + stack1 + " < " + stack0 + ";");
                        break;
                    case Bytecode.LESSEQUALS:
                        js.push("                " + stack1 + " = " + stack1 + " <= " + stack0 + ";");
                        break;
                    case Bytecode.NOT:
                        js.push("                " + stack0 + " = !" + stack0 + ";");
                        break;
                    case Bytecode.BITNOT:
                        js.push("                " + stack0 + " = ~" + stack0 + ";");
                        break;
                    case Bytecode.NEGATE:
                        js.push("                " + stack0 + " = -" + stack0 + ";");
                        break;
                    case Bytecode.ISTYPELATE:
                        js.push("                " + stack1 + " = " + stack0 + ".axIsType(" + stack1 + ");");
                        break;
                    case Bytecode.ASTYPELATE:
                        js.push("                " + stack1 + " = " + stack0 + ".axAsType(" + stack1 + ");");
                        break;
                    case Bytecode.CALL:
                        {
                            var pp_1 = [];
                            for (var j_5 = 1; j_5 <= param(0); j_5++)
                                pp_1.push(stackF(param(0) - j_5));
                            js.push("                " + stackF(param(0) + 1) + " = context.call(" + stackF(param(0) + 1) + ", " + stackF(param(0)) + ", [" + pp_1.join(", ") + "]);");
                        }
                        break;
                    case Bytecode.CONSTRUCT:
                        {
                            var pp_2 = [];
                            for (var j_6 = 1; j_6 <= param(0); j_6++)
                                pp_2.push(stackF(param(0) - j_6));
                            js.push("                " + stackF(param(0)) + " = context.construct(" + stackF(param(0)) + ", [" + pp_2.join(", ") + "]);");
                        }
                        break;
                    case Bytecode.CALLPROPERTY:
                        var pp = [];
                        for (var j_7 = 0; j_7 <= param(0); j_7++)
                            pp.push(stackF(param(0) - j_7));
                        if (abc.getMultiname(param(1)).name == "getDefinitionByName") {
                            js.push("                " + stackF(param(0)) + " = context.getdefinitionbyname(" + scope + ", " + pp.shift() + ", [" + pp.join(", ") + "]);");
                        }
                        else {
                            js.push("                // " + abc.getMultiname(param(0)));
                            js.push("                " + stackF(param(0)) + " = sec.box(" + pp.shift() + ").axCallProperty(" + getname(param(1)) + ", [" + pp.join(", ") + "], false);");
                        }
                        break;
                    case Bytecode.CALLPROPLEX:
                        {
                            var pp_3 = [];
                            for (var j_8 = 0; j_8 <= param(0); j_8++)
                                pp_3.push(stackF(param(0) - j_8));
                            js.push("                " + stackF(param(0)) + " = sec.box(" + pp_3.shift() + ").axCallProperty(" + getname(param(1)) + ", [" + pp_3.join(", ") + "], true);");
                        }
                        break;
                    case Bytecode.CALLPROPVOID:
                        {
                            var pp_4 = [];
                            for (var j_9 = 0; j_9 <= param(0); j_9++)
                                pp_4.push(stackF(param(0) - j_9));
                            js.push("                sec.box(" + pp_4.shift() + ").axCallProperty(" + getname(param(1)) + ", [" + pp_4.join(", ") + "], false);");
                        }
                        break;
                    case Bytecode.APPLYTYPE:
                        {
                            var pp_5 = [];
                            for (var j_10 = 1; j_10 <= param(0); j_10++)
                                pp_5.push(stackF(param(0) - j_10));
                            js.push("                " + stackF(param(0)) + " = sec.applyType(" + stackF(param(0)) + ", [" + pp_5.join(", ") + "]);");
                        }
                        break;
                    case Bytecode.FINDPROPSTRICT:
                        js.push("                // " + abc.getMultiname(param(0)));
                        js.push("                " + stackN + " = " + scope + ".findScopeProperty(" + getname(param(0)) + ", true, false);");
                        break;
                    case Bytecode.FINDPROPERTY:
                        js.push("                // " + abc.getMultiname(param(0)));
                        js.push("                " + stackN + " = " + scope + ".findScopeProperty(" + getname(param(0)) + ", false, false);");
                        break;
                    case Bytecode.NEWFUNCTION:
                        js.push("                // " + abc.getMethodInfo(param(0)));
                        js.push("                " + stackN + " = sec.createFunction(context.abc.getMethodInfo(" + param(0) + "), " + scope + ", true);");
                        break;
                    case Bytecode.NEWCLASS:
                        js.push("                // " + abc.classes[param(0)]);
                        js.push("                " + stack0 + " = sec.createClass(context.abc.classes[" + param(0) + "], " + stack0 + ", " + scope + ");");
                        break;
                    case Bytecode.NEWARRAY:
                        {
                            var pp_6 = [];
                            for (var j_11 = 1; j_11 <= param(0); j_11++)
                                pp_6.push(stackF(param(0) - j_11));
                            js.push("                " + stackF(param(0) - 1) + " = sec.AXArray.axBox([" + pp_6.join(", ") + "]);");
                        }
                        break;
                    case Bytecode.NEWOBJECT:
                        js.push("                temp = Object.create(sec.AXObject.tPrototype);");
                        for (var j_12 = 1; j_12 <= param(0); j_12++) {
                            js.push("                temp.axSetPublicProperty(" + stackF(2 * param(0) - 2 * j_12 + 1) + ", " + stackF(2 * param(0) - 2 * j_12) + ");");
                        }
                        js.push("                " + stackF(2 * param(0) - 1) + " = temp;");
                        js.push("                temp = undefined;");
                        break;
                    case Bytecode.NEWACTIVATION:
                        js.push("                " + stackN + " = sec.createActivation(context.mi, " + scope + ");");
                        break;
                    case Bytecode.NEWCATCH:
                        js.push("                " + stackN + " = sec.createCatch(context.mi.getBody().catchBlocks[" + param(0) + "], " + scope + ");");
                        break;
                    case Bytecode.CONSTRUCTSUPER:
                        {
                            var pp_7 = [];
                            for (var j_13 = 1; j_13 <= param(0); j_13++)
                                pp_7.push(stackF(param(0) - j_13));
                            js.push("                context.savedScope.object.superClass.tPrototype.axInitializer.apply(" + stackF(param(0)) + ", [" + pp_7.join(", ") + "]);");
                        }
                        break;
                    case Bytecode.CALLSUPER_DYN:
                        {
                            var pp_8 = [];
                            for (var j_14 = 1; j_14 <= param(0); j_14++)
                                pp_8.push(stackF(param(0) - j_14));
                            js.push("                " + stackF(param(0) + 1) + " = sec.box(" + stackF(param(0) + 1) + ").axCallSuper(context.runtimename(" + stackF(param(0)) + ", " + param(1) + "), context.savedScope, [" + pp_8.join(", ") + "]);");
                        }
                        break;
                    case Bytecode.CALLSUPERVOID:
                        {
                            var pp_9 = [];
                            for (var j_15 = 1; j_15 <= param(0); j_15++)
                                pp_9.push(stackF(param(0) - j_15));
                            js.push("                sec.box(" + stackF(param(0)) + ").axCallSuper(" + getname(param(1)) + ", context.savedScope, [" + pp_9.join(", ") + "]);");
                        }
                        break;
                    case Bytecode.CONSTRUCTPROP:
                        {
                            var pp_10 = [];
                            for (var j_16 = 1; j_16 <= param(0); j_16++)
                                pp_10.push(stackF(param(0) - j_16));
                            js.push("                " + stackF(param(0)) + " = context.constructprop(" + getname(param(1)) + ", " + stackF(param(0)) + ", [" + pp_10.join(", ") + "]);");
                        }
                        break;
                    case Bytecode.GETPROPERTY:
                        mn = abc.getMultiname(param(0));
                        js.push("                // " + mn);
                        js.push("                tr = " + getname(param(0)) + ".resolved[" + stack0 + ".axClassName];");
                        js.push("                if (tr) {");
                        js.push("                    " + stack0 + " = " + stack0 + "[tr];");
                        js.push("                } else {");
                        js.push("                    " + stack0 + " = sec.box(" + stack0 + ").axGetProperty(" + getname(param(0)) + ")");
                        js.push("                }");
                        break;
                    case Bytecode.GETPROPERTY_DYN:
                        js.push("                " + stack1 + " = context.getpropertydyn(context.runtimename(" + stack0 + ", " + param(0) + "), " + stack1 + ");");
                        break;
                    case Bytecode.SETPROPERTY:
                        mn = abc.getMultiname(param(0));
                        js.push("                // " + mn);
                        js.push("                context.setproperty(" + getname(param(0)) + ", " + stack0 + ", " + stack1 + ");");
                        break;
                    case Bytecode.SETPROPERTY_DYN:
                        js.push("                context.setproperty(context.runtimename(" + stack1 + ", " + param(0) + "), " + stack0 + ", " + stack2 + ");");
                        break;
                    case Bytecode.DELETEPROPERTY:
                        js.push("                // " + abc.getMultiname(param(0)));
                        js.push("                " + stack0 + " = context.deleteproperty(" + getname(param(0)) + ", " + stack0 + ");");
                        break;
                    case Bytecode.DELETEPROPERTY_DYN:
                        js.push("                " + stack1 + " = context.deleteproperty(context.runtimename(" + stack0 + ", " + param(0) + "), " + stack1 + ");");
                        break;
                    case Bytecode.GETSUPER:
                        js.push("                " + stack0 + " = sec.box(" + stack0 + ").axGetSuper(" + getname(param(0)) + ", context.savedScope);");
                        break;
                    case Bytecode.GETSUPER_DYN:
                        js.push("                " + stack1 + " = sec.box(" + stack1 + ").axGetSuper(context.runtimename(" + stack0 + ", " + param(0) + "), context.savedScope);");
                        break;
                    case Bytecode.SETSUPER:
                        js.push("                sec.box(" + stack1 + ").axSetSuper(" + getname(param(0)) + ", context.savedScope, " + stack0 + ");");
                        break;
                    case Bytecode.SETSUPER_DYN:
                        js.push("                sec.box(" + stack2 + ").axSetSuper(context.runtimename(" + stack1 + ", " + param(0) + "), context.savedScope, " + stack0 + ");");
                        break;
                    case Bytecode.GETLEX:
                        mn = abc.getMultiname(param(0));
                        js.push("                // " + mn);
                        js.push("                temp = " + scope + ".findScopeProperty(" + getname(param(0)) + ", true, false);");
                        js.push("                tr = " + getname(param(0)) + ".resolved[temp.axClassName];");
                        js.push("                if (tr) {");
                        js.push("                    " + stackN + " = temp[tr];");
                        js.push("                    if (typeof " + stackN + " === 'function') {");
                        js.push("                        " + stackN + " = temp.axGetMethod(tr);");
                        js.push("                    }");
                        js.push("                } else {");
                        js.push("                    " + stackN + " = temp.axGetProperty(" + getname(param(0)) + ");");
                        js.push("                }");
                        break;
                    case Bytecode.RETURNVALUE:
                        js.push("                return " + stack0 + ";");
                        break;
                    case Bytecode.RETURNVOID:
                        js.push("                return;");
                        break;
                    case Bytecode.COERCE:
                        js.push("                " + stack0 + " = " + scope + ".getScopeProperty(" + getname(param(0)) + ", true, false).axCoerce(" + stack0 + ");");
                        break;
                    case Bytecode.COERCE_A:
                        js.push("                ;");
                        break;
                    case Bytecode.COERCE_S:
                        js.push("                " + stack0 + " = context.axCoerceString(" + stack0 + ");");
                        break;
                    case Bytecode.CONVERT_I:
                        js.push("                " + stack0 + " |= 0;");
                        break;
                    case Bytecode.CONVERT_D:
                        js.push("                " + stack0 + " = +" + stack0 + ";");
                        break;
                    case Bytecode.CONVERT_B:
                        js.push("                " + stack0 + " = !!" + stack0 + ";");
                        break;
                    case Bytecode.CONVERT_U:
                        js.push("                " + stack0 + " >>>= 0;");
                        break;
                    case Bytecode.KILL:
                        js.push("                " + local(param(0)) + " = undefined;");
                        break;
                    default:
                        js.push("                //" + "unknown instruction " + q[i]);
                        console.log("unknown instruction " + q[i] + " (method N" + methodInfo.index() + ")");
                        return { value: "unhandled instruction " + z };
                }
        };
        var jj, dj, mn, mn, mn;
        for (var i = 0; i < q.length; i++) {
            var state_2 = _loop_2(i);
            if (typeof state_2 === "object")
                return state_2.value;
        }
        js.push("        }");
        js.push("    }");
        js.push("}})");
        var w = js0.join("\n") + "\n" + js.join("\n");
        if (w.indexOf(underrun) >= 0)
            return "STACK UNDERRUN";
        return { names: names, compiled: eval(w) };
    }
    var Context = /** @class */ (function () {
        function Context(mi, savedScope, names) {
            this.jsGlobal = jsGlobal;
            this.axCoerceString = axCoerceString$3;
            this.mi = mi;
            this.savedScope = savedScope;
            this.abc = mi.abc;
            this.sec = mi.abc.applicationDomain.sec;
            this.names = names;
        }
        Context.prototype.call = function (value, obj, pp) {
            validateCall(this.sec, value, pp.length);
            return value.axApply(obj, pp);
        };
        Context.prototype.getdefinitionbyname = function (scope, obj, pp) {
            return scope.global.object.scriptInfo.abc.env.app.getClass(Multiname.FromSimpleName(pp[0]));
        };
        Context.prototype.getproperty = function (mn, obj) {
            return obj.axGetProperty(mn);
        };
        Context.prototype.getpropertydyn = function (mn, obj) {
            var b = this.sec.box(obj);
            if (typeof mn === "number")
                return b.axGetNumericProperty(mn);
            return b.axGetProperty(mn);
        };
        Context.prototype.setproperty = function (mn, value, obj) {
            if (typeof mn === "number")
                return this.sec.box(obj).axSetNumericProperty(mn, value);
            this.sec.box(obj).axSetProperty(mn, value, Bytecode.INITPROPERTY);
        };
        Context.prototype.deleteproperty = function (name, obj) {
            var b = this.sec.box(obj);
            if (typeof name === "number" || typeof name === "string")
                return delete b[name];
            return b.axDeleteProperty(name);
        };
        Context.prototype.construct = function (obj, pp) {
            var mn = obj.classInfo.instanceInfo.getName();
            // if (mn.name.indexOf("b2") >= 0)
            //     console.log("*B2: " + mn.name)
            validateConstruct(this.sec, obj, pp.length);
            return obj.axConstruct(pp);
        };
        Context.prototype.constructprop = function (mn, obj, pp) {
            // if (mn.name.indexOf("b2") >= 0)
            //     console.log("B2: " + mn.name)
            var b = this.sec.box(obj);
            var name = b.axResolveMultiname(mn);
            var ctor = b[name];
            validateConstruct(b.sec, ctor, pp.length);
            return ctor.axConstruct(pp);
        };
        Context.prototype.pushwith = function (scope, obj) {
            var b = this.sec.box(obj);
            return (scope.object === b && scope.isWith == true) ? scope : new Scope(scope, b, true);
        };
        Context.prototype.hasnext2 = function (obj, name) {
            var info = new HasNext2Info(null, 0);
            info.next(this.sec.box(obj), name);
            return [info.object, info.index];
        };
        Context.prototype.runtimename = function (name, index) {
            if (typeof name === "number")
                return name;
            var mn = this.abc.getMultiname(index);
            if (name && name.axClass && name.axClass === name.sec.AXQName) {
                var rn = new Multiname(this.abc, 0, null, null, null);
                rn.numeric = false;
                rn.id = mn.id;
                rn.kind = mn.kind;
                release$1 || assert(name.name instanceof Multiname);
                rn.kind = mn.isAttribute() ? 18 /* RTQNameLA */ : 17 /* RTQNameL */;
                rn.id = name.name.id;
                rn.name = name.name.name;
                rn.namespaces = name.name.namespaces;
                return rn;
            }
            if (typeof name === "number" || isNumeric(axCoerceName(name))) {
                var rn = new Multiname(this.abc, 0, null, null, null);
                rn.numeric = false;
                rn.id = mn.id;
                rn.kind = mn.kind;
                rn.numeric = true;
                rn.numericValue = +(axCoerceName(name));
            }
            return mn.rename(name);
        };
        return Context;
    }());

    /**
     * Helps the interpreter allocate fewer Scope objects.
     */
    var ScopeStack = /** @class */ (function () {
        function ScopeStack(parent) {
            this.parent = parent;
            this.stack = [];
            this.isWith = [];
        }
        ScopeStack.prototype.push = function (object, isWith) {
            this.stack.push(object);
            this.isWith.push(!!isWith);
        };
        ScopeStack.prototype.get = function (index) {
            return this.stack[index];
        };
        ScopeStack.prototype.clear = function () {
            this.stack.length = 0;
            this.isWith.length = 0;
        };
        ScopeStack.prototype.pop = function () {
            this.isWith.pop();
            this.stack.pop();
            if (this.scopes && this.scopes.length > this.stack.length) {
                this.scopes.length--;
                release$1 || assert(this.scopes.length === this.stack.length);
            }
        };
        ScopeStack.prototype.topScope = function () {
            if (!this.scopes) {
                if (this.stack.length === 0) {
                    return this.parent;
                }
                this.scopes = [];
            }
            var parent = this.parent;
            for (var i = 0; i < this.stack.length; i++) {
                var object = this.stack[i], isWith = this.isWith[i], scope = this.scopes[i];
                if (!scope || scope.parent !== parent || scope.object !== object || scope.isWith !== isWith) {
                    scope = this.scopes[i] = new Scope(parent, object, isWith);
                }
                parent = scope;
            }
            return parent;
        };
        return ScopeStack;
    }());
    function popNameInto(stack, mn, rn) {
        rn.resolved = {};
        rn.script = null;
        rn.numeric = false;
        rn.id = mn.id;
        rn.kind = mn.kind;
        if (mn.isRuntimeName()) {
            var name = stack.pop();
            // Unwrap content script-created AXQName instances.
            if (name && name.axClass && name.axClass === name.sec.AXQName) {
                name = name.name;
                release$1 || assert(name instanceof Multiname);
                rn.kind = mn.isAttribute() ? 18 /* RTQNameLA */ : 17 /* RTQNameL */;
                rn.id = name.id;
                rn.name = name.name;
                rn.namespaces = name.namespaces;
                return;
            }
            if (typeof name === "number" || isNumeric(axCoerceName(name))) {
                rn.numeric = true;
                rn.numericValue = +(axCoerceName(name));
            }
            rn.name = name;
            rn.id = -1;
        }
        else {
            rn.name = mn.name;
        }
        if (mn.isRuntimeNamespace()) {
            var ns = stack.pop();
            // Unwrap content script-created AXNamespace instances.
            if (ns._ns) {
                release$1 || assert(ns.sec && ns.axClass === ns.sec.AXNamespace);
                ns = ns._ns;
            }
            rn.namespaces = [ns];
            rn.id = -1;
        }
        else {
            rn.namespaces = mn.namespaces;
        }
        interpreterWriter && interpreterWriter.greenLn("Name: " + rn.name);
    }
    function interpret(methodInfo, savedScope, callee) {
        if (methodInfo.compiled == null && methodInfo.error == null) {
            var r = compile(methodInfo);
            if (typeof r === "string") {
                methodInfo.error = r;
            }
            else {
                methodInfo.compiled = r.compiled;
                methodInfo.names = r.names;
            }
        }
        return methodInfo.compiled ? methodInfo.compiled(new Context(methodInfo, savedScope, methodInfo.names)) : _interpret(methodInfo, savedScope, callee);
    }
    var InterpreterFrame = /** @class */ (function () {
        function InterpreterFrame(receiver, methodInfo, parentScope, callArgs, callee) {
            this.pc = 0;
            this.stack = [];
            this.hasNext2Infos = null;
            var body = this.body = methodInfo.getBody();
            this.code = body.code;
            this.scopes = new ScopeStack(parentScope);
            var locals = this.locals = [receiver];
            var app = this.app = methodInfo.abc.applicationDomain;
            var sec = this.sec = app.sec;
            var argCount = callArgs.length;
            var arg;
            for (var i = 0, j = methodInfo.parameters.length; i < j; i++) {
                var p = methodInfo.parameters[i];
                if (i < argCount) {
                    arg = callArgs[i];
                }
                else if (p.hasOptionalValue()) {
                    arg = p.getOptionalValue();
                }
                else {
                    arg = undefined;
                }
                var rn = p.getType();
                if (rn && !rn.isAnyName()) {
                    var type = parentScope.getScopeProperty(rn, true, false);
                    if (!type) {
                        // During class initialization the class' constructor isn't in scope and can't be
                        // resolved as a scope property: trying to do so yields `null`.
                        // However, using it as a constructor parameter type *does* work, and correctly
                        // applies coercion to the constructor. It's unclear why and how this works in
                        // Tamarin, but since it does work, we check for this scenario here and work around it.
                        if ('axClass' in receiver && receiver.axClass.name.matches(rn)) {
                            type = receiver.axClass;
                        }
                        else {
                            continue;
                        }
                    }
                    if (!release$1 && interpreterWriter) {
                        interpreterWriter.writeLn("Coercing argument to type " +
                            (type.axClass ? type.axClass.name.toFQNString(false) : type));
                    }
                    arg = type.axCoerce(arg);
                }
                locals.push(arg);
            }
            if (methodInfo.needsRest()) {
                locals.push(sec.createArrayUnsafe(sliceArguments(callArgs, methodInfo.parameters.length)));
            }
            else if (methodInfo.needsArguments()) {
                var argsArray = sliceArguments(callArgs, 0);
                var argumentsArray = Object.create(sec.argumentsPrototype);
                argumentsArray.value = argsArray;
                argumentsArray.callee = callee;
                argumentsArray.receiver = receiver;
                argumentsArray.methodInfo = methodInfo;
                locals.push(argumentsArray);
            }
        }
        InterpreterFrame.prototype.bc = function () {
            return this.code[this.pc++];
        };
        InterpreterFrame.prototype.u30 = function () {
            var code = this.code;
            var pc = this.pc;
            var result = code[pc++];
            if (result & 0x80) {
                result = result & 0x7f | code[pc++] << 7;
                if (result & 0x4000) {
                    result = result & 0x3fff | code[pc++] << 14;
                    if (result & 0x200000) {
                        result = result & 0x1fffff | code[pc++] << 21;
                        if (result & 0x10000000) {
                            result = result & 0x0fffffff | code[pc++] << 28;
                            result = result & 0xffffffff;
                        }
                    }
                }
            }
            this.pc = pc;
            return result >>> 0;
        };
        InterpreterFrame.prototype.s24 = function () {
            var code = this.code;
            var pc = this.pc;
            var u = code[pc] | (code[pc + 1] << 8) | (code[pc + 2] << 16);
            this.pc = pc + 3;
            return (u << 8) >> 8;
        };
        InterpreterFrame.prototype.getHasNext2Info = function () {
            var pc = this.pc;
            var hasNext2Infos = this.hasNext2Infos;
            if (!hasNext2Infos) {
                hasNext2Infos = this.hasNext2Infos = [];
            }
            if (!hasNext2Infos[pc]) {
                hasNext2Infos[pc] = new HasNext2Info(null, 0);
            }
            return hasNext2Infos[pc];
        };
        return InterpreterFrame;
    }());
    function _interpret(methodInfo, savedScope, callee) {
        if (methodInfo.error != null)
            console.log("interpret: (" + methodInfo.error + ")");
        return function () {
            var frame = new InterpreterFrame(this, methodInfo, savedScope, arguments, callee);
            var stack = frame.stack;
            var locals = frame.locals;
            var scopes = frame.scopes;
            var sec = frame.sec;
            var abc = methodInfo.abc;
            var rn = new Multiname(abc, 0, null, null, null, null, true);
            var value, object, receiver, a, b, offset, index, result;
            var args = [];
            var argCount = 0;
            var scopeStacksHeight = scopeStacks.length;
            scopeStacks.push(frame.scopes);
            interpretLabel: while (true) {
                if (!release$1 && interpreterWriter) {
                    interpreterWriter.greenLn("" + frame.pc + ": " + getBytecodeName(frame.code[frame.pc]) + " [" +
                        frame.stack.map(function (x) { return stringifyStackEntry(x); }).join(", ") + "]");
                }
                try {
                    var bc = frame.bc();
                    switch (bc) {
                        case 9 /* LABEL */:
                            continue;
                        case 3 /* THROW */:
                            throw stack.pop();
                        case 8 /* KILL */:
                            locals[frame.u30()] = undefined;
                            break;
                        case 12 /* IFNLT */:
                        case 24 /* IFGE */:
                            offset = frame.s24();
                            if (stack.pop() <= stack.pop()) {
                                frame.pc += offset;
                            }
                            continue;
                        case 13 /* IFNLE */:
                        case 23 /* IFGT */:
                            offset = frame.s24();
                            if (stack.pop() < stack.pop()) {
                                frame.pc += offset;
                            }
                            continue;
                        case 14 /* IFNGT */:
                        case 22 /* IFLE */:
                            offset = frame.s24();
                            if (stack.pop() >= stack.pop()) {
                                frame.pc += offset;
                            }
                            continue;
                        case 15 /* IFNGE */:
                        case 21 /* IFLT */:
                            offset = frame.s24();
                            if (stack.pop() > stack.pop()) {
                                frame.pc += offset;
                            }
                            continue;
                        case 16 /* JUMP */:
                            frame.pc = frame.s24() + frame.pc;
                            continue;
                        case 17 /* IFTRUE */:
                            offset = frame.s24();
                            if (!!stack.pop()) {
                                frame.pc += offset;
                            }
                            continue;
                        case 18 /* IFFALSE */:
                            offset = frame.s24();
                            if (!stack.pop()) {
                                frame.pc += offset;
                            }
                            continue;
                        case 19 /* IFEQ */:
                            offset = frame.s24();
                            if (axEquals(stack.pop(), stack.pop(), sec)) {
                                frame.pc += offset;
                            }
                            continue;
                        case 20 /* IFNE */:
                            offset = frame.s24();
                            if (!axEquals(stack.pop(), stack.pop(), sec)) {
                                frame.pc += offset;
                            }
                            continue;
                        case 25 /* IFSTRICTEQ */:
                            offset = frame.s24();
                            if (stack.pop() === stack.pop()) {
                                frame.pc += offset;
                            }
                            continue;
                        case 26 /* IFSTRICTNE */:
                            offset = frame.s24();
                            if (stack.pop() !== stack.pop()) {
                                frame.pc += offset;
                            }
                            continue;
                        case 27 /* LOOKUPSWITCH */:
                            var basePC = frame.pc - 1;
                            offset = frame.s24();
                            var caseCount = frame.u30();
                            index = stack.pop();
                            if (index <= caseCount) {
                                frame.pc += 3 * index; // Jump to case offset.
                                offset = frame.s24();
                            }
                            frame.pc = basePC + offset;
                            continue;
                        case 29 /* POPSCOPE */:
                            scopes.pop();
                            break;
                        case 30 /* NEXTNAME */:
                            stack[stack.length - 2] = sec.box(stack[stack.length - 2]).axNextName(stack.pop());
                            break;
                        case 35 /* NEXTVALUE */:
                            stack[stack.length - 2] = sec.box(stack[stack.length - 2]).axNextValue(stack.pop());
                            break;
                        case 50 /* HASNEXT2 */:
                            var hasNext2Info = frame.getHasNext2Info();
                            var objectIndex = frame.u30();
                            var indexIndex = frame.u30();
                            hasNext2Info.next(sec.box(locals[objectIndex]), locals[indexIndex]);
                            locals[objectIndex] = hasNext2Info.object;
                            locals[indexIndex] = hasNext2Info.index;
                            stack.push(!!hasNext2Info.index);
                            break;
                        case 32 /* PUSHNULL */:
                            stack.push(null);
                            break;
                        case 33 /* PUSHUNDEFINED */:
                            stack.push(undefined);
                            break;
                        case 36 /* PUSHBYTE */:
                            stack.push(frame.code[frame.pc++] << 24 >> 24);
                            break;
                        case 37 /* PUSHSHORT */:
                            stack.push(frame.u30() << 16 >> 16);
                            break;
                        case 44 /* PUSHSTRING */:
                            stack.push(abc.getString(frame.u30()));
                            break;
                        case 45 /* PUSHINT */:
                            stack.push(abc.ints[frame.u30()]);
                            break;
                        case 46 /* PUSHUINT */:
                            stack.push(abc.uints[frame.u30()]);
                            break;
                        case 47 /* PUSHDOUBLE */:
                            stack.push(abc.doubles[frame.u30()]);
                            break;
                        case 38 /* PUSHTRUE */:
                            stack.push(true);
                            break;
                        case 39 /* PUSHFALSE */:
                            stack.push(false);
                            break;
                        case 40 /* PUSHNAN */:
                            stack.push(NaN);
                            break;
                        case 41 /* POP */:
                            stack.pop();
                            break;
                        case 42 /* DUP */:
                            stack.push(stack[stack.length - 1]);
                            break;
                        case 43 /* SWAP */:
                            value = stack[stack.length - 1];
                            stack[stack.length - 1] = stack[stack.length - 2];
                            stack[stack.length - 2] = value;
                            break;
                        case 48 /* PUSHSCOPE */:
                            scopes.push(sec.box(stack.pop()), false);
                            break;
                        case 28 /* PUSHWITH */:
                            scopes.push(sec.box(stack.pop()), true);
                            break;
                        case 49 /* PUSHNAMESPACE */:
                            stack.push(sec.AXNamespace.FromNamespace(abc.getNamespace(frame.u30())));
                            break;
                        case 64 /* NEWFUNCTION */:
                            stack.push(sec.createFunction(abc.getMethodInfo(frame.u30()), scopes.topScope(), true));
                            break;
                        case 65 /* CALL */:
                            popManyInto(stack, frame.u30(), args);
                            object = stack.pop();
                            value = stack[stack.length - 1];
                            validateCall(sec, value, args.length);
                            stack[stack.length - 1] = value.axApply(object, args);
                            break;
                        case 66 /* CONSTRUCT */:
                            popManyInto(stack, frame.u30(), args);
                            receiver = sec.box(stack[stack.length - 1]);
                            validateConstruct(sec, receiver, args.length);
                            stack[stack.length - 1] = receiver.axConstruct(args);
                            break;
                        case 71 /* RETURNVOID */:
                            release$1 || assert(scopeStacks.length === scopeStacksHeight + 1);
                            scopeStacks.length--;
                            return;
                        case 72 /* RETURNVALUE */:
                            value = stack.pop();
                            // TODO: ensure proper unwinding of the scope stack.
                            if (methodInfo.returnTypeNameIndex) {
                                receiver = methodInfo.getType();
                                if (receiver) {
                                    value = receiver.axCoerce(value);
                                }
                            }
                            release$1 || assert(scopeStacks.length === scopeStacksHeight + 1);
                            scopeStacks.length--;
                            return value;
                        case 73 /* CONSTRUCTSUPER */:
                            popManyInto(stack, frame.u30(), args);
                            savedScope.object.superClass.tPrototype.axInitializer.apply(stack.pop(), args);
                            break;
                        case 74 /* CONSTRUCTPROP */:
                            index = frame.u30();
                            popManyInto(stack, frame.u30(), args);
                            popNameInto(stack, abc.getMultiname(index), rn);
                            stack[stack.length - 1] = sec.box(stack[stack.length - 1]).axConstructProperty(rn, args);
                            break;
                        case 76 /* CALLPROPLEX */:
                        case 70 /* CALLPROPERTY */:
                        case 79 /* CALLPROPVOID */:
                            index = frame.u30();
                            popManyInto(stack, frame.u30(), args);
                            popNameInto(stack, abc.getMultiname(index), rn);
                            result = sec.box(stack[stack.length - 1]).axCallProperty(rn, args, bc === 76 /* CALLPROPLEX */);
                            if (bc === 79 /* CALLPROPVOID */) {
                                stack.length--;
                            }
                            else {
                                stack[stack.length - 1] = result;
                            }
                            break;
                        case 69 /* CALLSUPER */:
                        case 78 /* CALLSUPERVOID */:
                            index = frame.u30();
                            popManyInto(stack, frame.u30(), args);
                            popNameInto(stack, abc.getMultiname(index), rn);
                            result = sec.box(stack[stack.length - 1]).axCallSuper(rn, savedScope, args);
                            if (bc === 78 /* CALLSUPERVOID */) {
                                stack.length--;
                            }
                            else {
                                stack[stack.length - 1] = result;
                            }
                            break;
                        //case Bytecode.CALLSTATIC:
                        //  index = frame.u30();
                        //  argCount = frame.u30();
                        //  popManyInto(stack, argCount, args);
                        //  value = abc.getMetadataInfo(index);
                        //  var receiver = box(stack[stack.length - 1]);
                        //  stack.push(value.axApply(receiver, args));
                        //  break;
                        case 83 /* APPLYTYPE */:
                            popManyInto(stack, frame.u30(), args);
                            stack[stack.length - 1] = sec.applyType(stack[stack.length - 1], args);
                            break;
                        case 85 /* NEWOBJECT */:
                            object = Object.create(sec.AXObject.tPrototype);
                            argCount = frame.u30();
                            // For LIFO-order iteration to be correct, we have to add items highest on the stack
                            // first.
                            for (var i = stack.length - argCount * 2; i < stack.length; i += 2) {
                                value = stack[i + 1];
                                object.axSetPublicProperty(stack[i], value);
                            }
                            stack.length -= argCount * 2;
                            stack.push(object);
                            break;
                        case 86 /* NEWARRAY */:
                            object = [];
                            argCount = frame.u30();
                            for (var i = stack.length - argCount; i < stack.length; i++) {
                                object.push(stack[i]);
                            }
                            stack.length -= argCount;
                            stack.push(sec.AXArray.axBox(object));
                            break;
                        case 87 /* NEWACTIVATION */:
                            stack.push(sec.createActivation(methodInfo, scopes.topScope()));
                            break;
                        case 88 /* NEWCLASS */:
                            // Storing super class in `value` to make exception handling easier.
                            value = stack[stack.length - 1];
                            stack[stack.length - 1] = sec.createClass(abc.classes[frame.u30()], value, scopes.topScope());
                            break;
                        case 89 /* GETDESCENDANTS */:
                            popNameInto(stack, abc.getMultiname(frame.u30()), rn);
                            if (rn.name === undefined)
                                rn.name = '*';
                            stack[stack.length - 1] = axGetDescendants(stack[stack.length - 1], rn, sec);
                            break;
                        case 90 /* NEWCATCH */:
                            stack.push(sec.createCatch(frame.body.catchBlocks[frame.u30()], scopes.topScope()));
                            break;
                        case 94 /* FINDPROPERTY */:
                        case 93 /* FINDPROPSTRICT */:
                            popNameInto(stack, abc.getMultiname(frame.u30()), rn);
                            stack.push(scopes.topScope().findScopeProperty(rn, bc === 93 /* FINDPROPSTRICT */, false));
                            break;
                        case 96 /* GETLEX */:
                            popNameInto(stack, abc.getMultiname(frame.u30()), rn);
                            stack.push(scopes.topScope().findScopeProperty(rn, true, false).axGetProperty(rn));
                            break;
                        case 104 /* INITPROPERTY */:
                        case 97 /* SETPROPERTY */:
                            value = stack.pop();
                            popNameInto(stack, abc.getMultiname(frame.u30()), rn);
                            sec.box(stack.pop()).axSetProperty(rn, value, 104 /* INITPROPERTY */, methodInfo);
                            break;
                        case 102 /* GETPROPERTY */:
                            popNameInto(stack, abc.getMultiname(frame.u30()), rn);
                            stack[stack.length - 1] = sec.box(stack[stack.length - 1]).axGetProperty(rn);
                            break;
                        case 106 /* DELETEPROPERTY */:
                            popNameInto(stack, abc.getMultiname(frame.u30()), rn);
                            stack[stack.length - 1] = sec.box(stack[stack.length - 1]).axDeleteProperty(rn);
                            break;
                        case 4 /* GETSUPER */:
                            popNameInto(stack, abc.getMultiname(frame.u30()), rn);
                            stack[stack.length - 1] = sec.box(stack[stack.length - 1]).axGetSuper(rn, savedScope);
                            break;
                        case 5 /* SETSUPER */:
                            value = stack.pop();
                            popNameInto(stack, abc.getMultiname(frame.u30()), rn);
                            sec.box(stack.pop()).axSetSuper(rn, savedScope, value);
                            break;
                        case 98 /* GETLOCAL */:
                            stack.push(locals[frame.u30()]);
                            break;
                        case 99 /* SETLOCAL */:
                            locals[frame.u30()] = stack.pop();
                            break;
                        case 100 /* GETGLOBALSCOPE */:
                            stack.push(savedScope.global.object);
                            break;
                        case 101 /* GETSCOPEOBJECT */:
                            stack.push(scopes.get(frame.code[frame.pc++]));
                            break;
                        case 108 /* GETSLOT */:
                            stack[stack.length - 1] = sec.box(stack[stack.length - 1]).axGetSlot(frame.u30());
                            break;
                        case 109 /* SETSLOT */:
                            value = stack.pop();
                            sec.box(stack.pop()).axSetSlot(frame.u30(), value);
                            break;
                        case 110 /* GETGLOBALSLOT */:
                            stack[stack.length - 1] = savedScope.global.object.axGetSlot(frame.u30());
                            break;
                        case 111 /* SETGLOBALSLOT */:
                            value = stack.pop();
                            savedScope.global.object.axSetSlot(frame.u30(), value);
                            break;
                        case 114 /* ESC_XATTR */:
                            stack[stack.length - 1] = escapeAttributeValue(stack[stack.length - 1]);
                            break;
                        case 113 /* ESC_XELEM */:
                            stack[stack.length - 1] = escapeElementValue(sec, stack[stack.length - 1]);
                            break;
                        case 131 /* COERCE_I */:
                        case 115 /* CONVERT_I */:
                            stack[stack.length - 1] |= 0;
                            break;
                        case 136 /* COERCE_U */:
                        case 116 /* CONVERT_U */:
                            stack[stack.length - 1] >>>= 0;
                            break;
                        case 132 /* COERCE_D */:
                        case 117 /* CONVERT_D */:
                            stack[stack.length - 1] = +stack[stack.length - 1];
                            break;
                        case 129 /* COERCE_B */:
                        case 118 /* CONVERT_B */:
                            stack[stack.length - 1] = !!stack[stack.length - 1];
                            break;
                        case 133 /* COERCE_S */:
                            stack[stack.length - 1] = axCoerceString$3(stack[stack.length - 1]);
                            break;
                        case 112 /* CONVERT_S */:
                            stack[stack.length - 1] = axConvertString(stack[stack.length - 1]);
                            break;
                        case 120 /* CHECKFILTER */:
                            stack[stack.length - 1] = axCheckFilter(sec, stack[stack.length - 1]);
                            break;
                        case 128 /* COERCE */:
                            popNameInto(stack, abc.getMultiname(frame.u30()), rn);
                            stack[stack.length - 1] = scopes.topScope().getScopeProperty(rn, true, false).axCoerce(stack[stack.length - 1]);
                            break;
                        case 130 /* COERCE_A */: /* NOP */
                            break;
                        case 134 /* ASTYPE */:
                            popNameInto(stack, abc.getMultiname(frame.u30()), rn);
                            stack[stack.length - 1] = scopes.topScope().getScopeProperty(rn, true, false).axAsType(stack[stack.length - 1]);
                            break;
                        case 135 /* ASTYPELATE */:
                            stack[stack.length - 2] = stack.pop().axAsType(stack[stack.length - 1]);
                            break;
                        case 137 /* COERCE_O */:
                            object = stack[stack.length - 1];
                            stack[stack.length - 1] = object == undefined ? null : object;
                            break;
                        case 144 /* NEGATE */:
                            stack[stack.length - 1] = -stack[stack.length - 1];
                            break;
                        case 145 /* INCREMENT */:
                            ++stack[stack.length - 1];
                            break;
                        case 146 /* INCLOCAL */:
                            ++locals[frame.u30()];
                            break;
                        case 147 /* DECREMENT */:
                            --stack[stack.length - 1];
                            break;
                        case 148 /* DECLOCAL */:
                            --locals[frame.u30()];
                            break;
                        case 149 /* TYPEOF */:
                            stack[stack.length - 1] = axTypeOf(stack[stack.length - 1], sec);
                            break;
                        case 150 /* NOT */:
                            stack[stack.length - 1] = !stack[stack.length - 1];
                            break;
                        case 151 /* BITNOT */:
                            stack[stack.length - 1] = ~stack[stack.length - 1];
                            break;
                        case 160 /* ADD */:
                            b = stack.pop();
                            a = stack[stack.length - 1];
                            if (typeof a === "number" && typeof b === "number") {
                                stack[stack.length - 1] = a + b;
                            }
                            else {
                                stack[stack.length - 1] = axAdd(a, b, sec);
                            }
                            break;
                        case 161 /* SUBTRACT */:
                            stack[stack.length - 2] -= stack.pop();
                            break;
                        case 162 /* MULTIPLY */:
                            stack[stack.length - 2] *= stack.pop();
                            break;
                        case 163 /* DIVIDE */:
                            stack[stack.length - 2] /= stack.pop();
                            break;
                        case 164 /* MODULO */:
                            stack[stack.length - 2] %= stack.pop();
                            break;
                        case 165 /* LSHIFT */:
                            stack[stack.length - 2] <<= stack.pop();
                            break;
                        case 166 /* RSHIFT */:
                            stack[stack.length - 2] >>= stack.pop();
                            break;
                        case 167 /* URSHIFT */:
                            stack[stack.length - 2] >>>= stack.pop();
                            break;
                        case 168 /* BITAND */:
                            stack[stack.length - 2] &= stack.pop();
                            break;
                        case 169 /* BITOR */:
                            stack[stack.length - 2] |= stack.pop();
                            break;
                        case 170 /* BITXOR */:
                            stack[stack.length - 2] ^= stack.pop();
                            break;
                        case 171 /* EQUALS */:
                            stack[stack.length - 2] = axEquals(stack[stack.length - 2], stack.pop(), sec);
                            break;
                        case 172 /* STRICTEQUALS */:
                            stack[stack.length - 2] = stack[stack.length - 2] === stack.pop();
                            break;
                        case 173 /* LESSTHAN */:
                            stack[stack.length - 2] = stack[stack.length - 2] < stack.pop();
                            break;
                        case 174 /* LESSEQUALS */:
                            stack[stack.length - 2] = stack[stack.length - 2] <= stack.pop();
                            break;
                        case 175 /* GREATERTHAN */:
                            stack[stack.length - 2] = stack[stack.length - 2] > stack.pop();
                            break;
                        case 176 /* GREATEREQUALS */:
                            stack[stack.length - 2] = stack[stack.length - 2] >= stack.pop();
                            break;
                        case 177 /* INSTANCEOF */:
                            stack[stack.length - 2] = stack.pop().axIsInstanceOf(stack[stack.length - 1]);
                            break;
                        case 178 /* ISTYPE */:
                            popNameInto(stack, abc.getMultiname(frame.u30()), rn);
                            stack[stack.length - 1] = scopes.topScope().findScopeProperty(rn, true, false).axIsType(stack[stack.length - 1]);
                            break;
                        case 179 /* ISTYPELATE */:
                            stack[stack.length - 2] = stack.pop().axIsType(stack[stack.length - 1]);
                            break;
                        case 180 /* IN */:
                            receiver = sec.box(stack.pop());
                            var name = stack[stack.length - 1];
                            stack[stack.length - 1] = (name && name.axClass === sec.AXQName) ? receiver.axHasProperty(name.name) : receiver.axHasPublicProperty(name);
                            break;
                        case 192 /* INCREMENT_I */:
                            stack[stack.length - 1] = (stack[stack.length - 1] | 0) + 1;
                            break;
                        case 193 /* DECREMENT_I */:
                            stack[stack.length - 1] = (stack[stack.length - 1] | 0) - 1;
                            break;
                        case 194 /* INCLOCAL_I */:
                            index = frame.u30();
                            locals[index] = (locals[index] | 0) + 1;
                            break;
                        case 195 /* DECLOCAL_I */:
                            index = frame.u30();
                            locals[index] = (locals[index] | 0) - 1;
                            break;
                        case 196 /* NEGATE_I */:
                            stack[stack.length - 1] = -(stack[stack.length - 1] | 0);
                            break;
                        case 197 /* ADD_I */:
                            stack[stack.length - 2] = (stack[stack.length - 2] | 0) + (stack.pop() | 0) | 0;
                            break;
                        case 198 /* SUBTRACT_I */:
                            stack[stack.length - 2] = (stack[stack.length - 2] | 0) - (stack.pop() | 0) | 0;
                            break;
                        case 199 /* MULTIPLY_I */:
                            stack[stack.length - 2] = (stack[stack.length - 2] | 0) * (stack.pop() | 0) | 0;
                            break;
                        case 208 /* GETLOCAL0 */:
                            stack.push(locals[0]);
                            break;
                        case 209 /* GETLOCAL1 */:
                            stack.push(locals[1]);
                            break;
                        case 210 /* GETLOCAL2 */:
                            stack.push(locals[2]);
                            break;
                        case 211 /* GETLOCAL3 */:
                            stack.push(locals[3]);
                            break;
                        case 212 /* SETLOCAL0 */:
                            locals[0] = stack.pop();
                            break;
                        case 213 /* SETLOCAL1 */:
                            locals[1] = stack.pop();
                            break;
                        case 214 /* SETLOCAL2 */:
                            locals[2] = stack.pop();
                            break;
                        case 215 /* SETLOCAL3 */:
                            locals[3] = stack.pop();
                            break;
                        case 6 /* DXNS */:
                            scopes.topScope().defaultNamespace = internNamespace(0 /* Public */, abc.getString(frame.u30()));
                            break;
                        case 7 /* DXNSLATE */:
                            scopes.topScope().defaultNamespace = internNamespace(0 /* Public */, stack.pop());
                            break;
                        case 239 /* DEBUG */:
                            frame.pc++;
                            frame.u30();
                            frame.pc++;
                            frame.u30();
                            break;
                        case 240 /* DEBUGLINE */:
                        case 241 /* DEBUGFILE */:
                            frame.u30();
                            break;
                        case 2 /* NOP */:
                        case 1 /* BKPT */:
                            break;
                        default:
                            notImplemented(getBytecodeName(bc));
                    }
                }
                catch (e) {
                    // TODO: e = translateError(e);
                    // All script exceptions must be primitive or have a security domain, if they don't then
                    // this must be a VM exception.
                    if (!isValidASValue(e)) {
                        // We omit many checks in the interpreter loop above to keep the code small. These
                        // checks can be done after the fact here by turning the VM-internal exception into a
                        // proper error according to the current operation.
                        e = createValidException(sec, e, bc, value, receiver, a, b, rn, scopeStacksHeight + 1);
                    }
                    var catchBlocks = frame.body.catchBlocks;
                    for (var i = 0; i < catchBlocks.length; i++) {
                        var handler = catchBlocks[i];
                        if (frame.pc >= handler.start && frame.pc <= handler.end) {
                            var typeName = handler.getType();
                            if (!typeName || frame.app.getClass(typeName).axIsType(e)) {
                                stack.length = 0;
                                stack.push(e);
                                scopes.clear();
                                frame.pc = handler.target;
                                continue interpretLabel;
                            }
                        }
                    }
                    release$1 || assert(scopeStacks.length === scopeStacksHeight + 1);
                    scopeStacks.length--;
                    throw e;
                }
            }
        };
    }
    function createValidException(sec, internalError, bc, value, receiver, a, b, mn, expectedScopeStacksHeight) {
        var isProperErrorObject = internalError instanceof Error &&
            typeof internalError.name === 'string' &&
            typeof internalError.message === 'string';
        if (isProperErrorObject) {
            if (internalError instanceof RangeError || internalError.name === 'InternalError') {
                var obj = Object.create(sec.AXError.tPrototype);
                obj._errorID = 1023;
                // Stack exhaustion errors are annoying to catch: Identifying them requires
                // pattern-matching of error messages, and throwing them must be done very
                // carefully to not cause the next one.
                if (internalError.message === 'allocation size overflow') {
                    obj.$Bgmessage = "allocation size overflow";
                    return obj;
                }
                if (internalError.message.indexOf('recursion') > -1 ||
                    internalError.message.indexOf('call stack size exceeded') > -1) {
                    obj.$Bgmessage = "Stack overflow occurred";
                    scopeStacks.length = expectedScopeStacksHeight;
                    return obj;
                }
            }
            else if (internalError instanceof TypeError) {
                if (internalError.message.indexOf("convert") > -1 &&
                    (internalError.message.indexOf("to primitive") > -1 ||
                        internalError.message.indexOf("to string") > -1)) {
                    return sec.createError('TypeError', Errors$1.ConvertToPrimitiveError, 'value');
                }
                // Internal error thrown by generic Array methods.
                if (internalError.message === 'Conversion to Array failed') {
                    return sec.createError('TypeError', Errors$1.CheckTypeFailedError, 'value', 'Array');
                }
            }
        }
        var message;
        var isSuper = false;
        switch (bc) {
            case 65 /* CALL */:
                if (!value || !value.axApply) {
                    return sec.createError('TypeError', Errors$1.CallOfNonFunctionError, 'value');
                }
                break;
            case 66 /* CONSTRUCT */:
                if (!receiver || !receiver.axConstruct) {
                    return sec.createError('TypeError', Errors$1.ConstructOfNonFunctionError);
                }
                break;
            case 88 /* NEWCLASS */:
                if (!value || !sec.AXClass.axIsType(value)) {
                    return sec.createError('VerifyError', Errors$1.InvalidBaseClassError);
                }
                break;
            case 78 /* CALLSUPERVOID */:
            case 73 /* CONSTRUCTSUPER */:
                isSuper = true;
            // Fallthrough.
            case 70 /* CALLPROPERTY */:
            case 79 /* CALLPROPVOID */:
            case 76 /* CALLPROPLEX */:
            case 74 /* CONSTRUCTPROP */:
            case 69 /* CALLSUPER */:
                if (receiver === null) {
                    return sec.createError('TypeError', Errors$1.ConvertNullToObjectError);
                }
                if (receiver === undefined) {
                    return sec.createError('TypeError', Errors$1.ConvertUndefinedToObjectError);
                }
                if (!(receiver.axResolveMultiname(mn) in receiver)) {
                    var axClass = isSuper ? receiver.axClass.superClass : receiver.axClass;
                    if (axClass.classInfo.instanceInfo.isSealed()) {
                        return sec.createError('ReferenceError', Errors$1.ReadSealedError, mn.name, axClass.name.toFQNString(false));
                    }
                    return sec.createError('TypeError', isSuper ?
                        Errors$1.ConstructOfNonFunctionError :
                        Errors$1.CallOfNonFunctionError, mn.name);
                }
                if (isProperErrorObject && internalError.name === 'RangeError' &&
                    (internalError.message.indexOf('arguments array passed') > -1 ||
                        internalError.message.indexOf('call stack size') > -1)) {
                    return sec.createError('RangeError', Errors$1.StackOverflowError);
                }
                break;
            case 4 /* GETSUPER */:
                isSuper = true;
            // Fallthrough.
            case 102 /* GETPROPERTY */:
                if (receiver === null) {
                    return sec.createError('TypeError', Errors$1.ConvertNullToObjectError);
                }
                if (receiver === undefined) {
                    return sec.createError('TypeError', Errors$1.ConvertUndefinedToObjectError);
                }
                break;
            case 104 /* INITPROPERTY */:
            case 97 /* SETPROPERTY */:
                if (receiver === null) {
                    return sec.createError('TypeError', Errors$1.ConvertNullToObjectError);
                }
                if (receiver === undefined) {
                    return sec.createError('TypeError', Errors$1.ConvertUndefinedToObjectError);
                }
                var nm = receiver.axResolveMultiname(mn);
                if (nm in receiver && getPropertyDescriptor(receiver, nm).writable === false) {
                    return sec.createError('ReferenceError', Errors$1.ConstWriteError, nm, receiver.axClass.name.name);
                }
                break;
            case 177 /* INSTANCEOF */:
                if (!receiver || !receiver.axIsInstanceOf) {
                    return sec.createError('TypeError', Errors$1.CantUseInstanceofOnNonObjectError);
                }
                break;
            case 134 /* ASTYPE */:
            case 135 /* ASTYPELATE */:
                // ASTYPE(LATE) have almost the same error messages as ISTYPE(LATE), but not *quite*.
                if (receiver && !receiver.axAsType) {
                    return sec.createError('TypeError', Errors$1.ConvertNullToObjectError);
                }
            // Fallthrough.
            case 178 /* ISTYPE */:
            case 179 /* ISTYPELATE */:
                if (receiver === null) {
                    return sec.createError('TypeError', Errors$1.ConvertNullToObjectError);
                }
                if (receiver === undefined) {
                    return sec.createError('TypeError', Errors$1.ConvertUndefinedToObjectError);
                }
                if (!receiver.axIsType) {
                    return sec.createError('TypeError', Errors$1.IsTypeMustBeClassError);
                }
                break;
            case 128 /* COERCE */:
                if (!receiver) {
                    return sec.createError('ReferenceError', Errors$1.ClassNotFoundError, mn.toFQNString(false));
                }
                break;
            case 180 /* IN */:
                if (receiver === null) {
                    return sec.createError('TypeError', Errors$1.ConvertNullToObjectError);
                }
                if (receiver === undefined) {
                    return sec.createError('TypeError', Errors$1.ConvertUndefinedToObjectError);
                }
                break;
            case 19 /* IFEQ */:
            case 20 /* IFNE */:
            case 171 /* EQUALS */:
                if (typeof a !== typeof b) {
                    if (typeof a === 'object' && a && typeof b !== 'object' ||
                        typeof b === 'object' && b && typeof a !== 'object') {
                        return sec.createError('TypeError', Errors$1.ConvertToPrimitiveError, 'Object');
                    }
                }
                break;
            default:
                // Pattern-match some otherwise-annoying-to-convert exceptions. This is all best-effort,
                // so we fail if we're not sure about something.
                if (!internalError || typeof internalError.message !== 'string' ||
                    typeof internalError.stack !== 'string' ||
                    typeof internalError.name !== 'string') {
                    break;
                }
                message = internalError.message;
                var stack = internalError.stack.split('\n');
                var lastFunctionEntry = stack[0].indexOf('at ') === 0 ? stack[0].substr(3) : stack[0];
                switch (internalError.name) {
                    case 'TypeError':
                        if (lastFunctionEntry.indexOf('AXBasePrototype_valueOf') === 0 ||
                            lastFunctionEntry.indexOf('AXBasePrototype_toString') === 0) {
                            return sec.createError('TypeError', Errors$1.CallOfNonFunctionError, 'value');
                        }
                }
        }
        // To be sure we don't let VM exceptions flow into the player, box them manually here,
        // even in release builds.
        message = 'Uncaught VM-internal exception during op ' + getBytecodeName(bc) + ': ';
        var stack;
        try {
            message += internalError.toString();
            stack = internalError.stack;
        }
        catch (e) {
            message += '[Failed to stringify exception]';
        }
        // In the extension, we can just kill all the things.
        var player = sec['player'];
        console.error(message, '\n', stack);
        // In other packagings, at least throw a valid value.
        return sec.createError('Error', Errors$1.InternalErrorIV);
    }
    function stringifyStackEntry(x) {
        if (!x || !x.toString) {
            return String(x);
        }
        if (x.$BgtoString && x.$BgtoString.isInterpreted) {
            return '<unprintable ' + (x.axClass ? x.axClass.name.toFQNString(false) : 'object') + '>';
        }
        try {
            return x.toString();
        }
        catch (e) {
            return '<unprintable ' + (x.axClass ? x.axClass.name.toFQNString(false) : 'object') + '>';
        }
    }

    var nativeFunctions = ObjectUtilities.createMap();

    function wrapJSGlobalFunction(fun) {
        return function (sec) {
            var args = [];
            for (var _i = 1; _i < arguments.length; _i++) {
                args[_i - 1] = arguments[_i];
            }
            return fun.apply(jsGlobal, args);
        };
    }

    function getCurrentABC() {
        if (scopeStacks.length === 0) {
            return null;
        }
        var globalObject = scopeStacks[scopeStacks.length - 1].topScope().global.object;
        return globalObject.scriptInfo.abc;
    }

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function createNullOrUndefinedDescription(sec, o) {
        return {
            __proto__: sec.objectPrototype,
            $Bgname: o === undefined ? "void" : "null",
            $BgisDynamic: false,
            $BgisFinal: true,
            $BgisStatic: false,
            $Bgtraits: {
                __proto__: sec.objectPrototype,
                $Bgvariables: null,
                $Bgaccessors: null,
                $Bgmetadata: sec.createArray([]),
                $Bgconstructor: null,
                $Bginterfaces: sec.createArray([]),
                $Bgmethods: null,
                $Bgbases: sec.createArray([])
            }
        };
    }
    function describeTypeJSON(sec, o, flags) {
        // Class traits aren't returned for numeric primitives, undefined, null, bound methods, or
        // non-class-constructor functions.
        var isInt = (o | 0) === o;
        var nullOrUndefined = isNullOrUndefined$1(o);
        if (flags & 512 /* USE_ITRAITS */ && (nullOrUndefined || isInt)) {
            return null;
        }
        if (nullOrUndefined) {
            return createNullOrUndefinedDescription(sec, o);
        }
        // Use the object's own sec if we're not dealing with a primitive to make sure
        // type checks are correct.
        if (o.sec) {
            sec = o.sec;
        }
        o = sec.box(o);
        if (sec.AXFunction.axIsType(o)) {
            if (sec.AXMethodClosure.axIsType(o)) {
                if (flags & 512 /* USE_ITRAITS */) {
                    return null;
                }
                // Non-bound functions with a `receiver` property are bare functions, not ctors.
            }
            else if ('receiver' in o) {
                return null;
            }
        }
        var cls = o.hasOwnProperty('classInfo') ? o : o.axClass;
        release$1 || assert(cls, "No class found for object " + o);
        var describeClass = cls === o && !(flags & 512 /* USE_ITRAITS */);
        var info = cls.classInfo;
        var description = sec.createObject();
        // For numeric literals that fit into ints, special case the name.
        if (isInt) {
            description.$Bgname = 'int';
        }
        else {
            description.$Bgname = info.instanceInfo.getName().toFQNString(true);
        }
        // More special casing for bound methods. See bug 1057750.
        description.$BgisDynamic = describeClass || !(info.instanceInfo.flags & 1 /* ClassSealed */);
        description.$BgisFinal = describeClass || !!(info.instanceInfo.flags & 2 /* ClassFinal */);
        //TODO: verify that `isStatic` is false for all instances, true for classes
        description.$BgisStatic = describeClass;
        if (flags & 256 /* INCLUDE_TRAITS */) {
            description.$Bgtraits = addTraits(cls, info, describeClass, flags);
        }
        return description;
    }
    var tmpName = new Multiname(null, 0, 7 /* QName */, [Namespace.PUBLIC], null, null, true);
    var tmpAttr = new Multiname(null, 0, 13 /* QNameA */, [Namespace.PUBLIC], null, null, true);
    function describeType(sec, value, flags) {
        // Ensure that the XML classes have been initialized:
        tmpName.name = 'XML';
        var xmlClass = sec.application.getClass(tmpName);
        var classDescription = describeTypeJSON(sec, value, flags);
        var x = xmlClass.Create('<type/>');
        tmpAttr.name = 'name';
        x.setProperty(tmpAttr, classDescription.$Bgname);
        var bases = classDescription.$Bgtraits.$Bgbases.value;
        if (bases.length) {
            tmpAttr.name = 'base';
            x.setProperty(tmpAttr, bases[0]);
        }
        tmpAttr.name = 'isDynamic';
        x.setProperty(tmpAttr, classDescription.$BgisDynamic.toString());
        tmpAttr.name = 'isFinal';
        x.setProperty(tmpAttr, classDescription.$BgisFinal.toString());
        tmpAttr.name = 'isStatic';
        x.setProperty(tmpAttr, classDescription.$BgisStatic.toString());
        describeTraits(x, classDescription.$Bgtraits);
        var instanceDescription = describeTypeJSON(sec, value, flags | 512 /* USE_ITRAITS */);
        if (instanceDescription) {
            var e = xmlClass.Create('<factory/>');
            tmpAttr.name = 'type';
            e.setProperty(tmpAttr, instanceDescription.$Bgname);
            if (describeTraits(e, instanceDescription.$Bgtraits)) {
                x.appendChild(e);
            }
        }
        return x;
    }
    function describeTraits(x, traits) {
        var traitsCount = 0;
        var bases = traits.$Bgbases && traits.$Bgbases.value;
        for (var i = 0; bases && i < bases.length; i++) {
            var base = bases[i];
            var e = x.sec.AXXML.Create('<extendsClass type="' + escapeAttributeValue(base) + '"/>');
            x.appendChild(e);
            traitsCount++;
        }
        var interfaces = traits.$Bginterfaces && traits.$Bginterfaces.value;
        for (var i = 0; interfaces && i < interfaces.length; i++) {
            var e = x.sec.AXXML.Create('<implementsInterface type="' +
                escapeAttributeValue(interfaces[i]) + '"/>');
            x.appendChild(e);
            traitsCount++;
        }
        if (traits.$Bgconstructor !== null) {
            var e = x.sec.AXXML.Create('<constructor/>');
            describeParams(e, traits.$Bgconstructor);
            x.appendChild(e);
            traitsCount++;
        }
        var variables = traits.$Bgvariables && traits.$Bgvariables.value;
        for (var i = 0; variables && i < variables.length; i++) {
            var variable = variables[i];
            var nodeName = variable.$Bgaccess === 'readonly' ? 'constant' : 'variable';
            var e = x.sec.AXXML.Create('<' + nodeName +
                ' name="' + escapeAttributeValue(variable.$Bgname) +
                '" type="' + variable.$Bgtype + '"/>');
            finishTraitDescription(variable, e, x);
            traitsCount++;
        }
        var accessors = traits.$Bgaccessors && traits.$Bgaccessors.value;
        for (var i = 0; accessors && i < accessors.length; i++) {
            var accessor = accessors[i];
            var e = x.sec.AXXML.Create('<accessor ' +
                'name="' + escapeAttributeValue(accessor.$Bgname) +
                '" access="' + accessor.$Bgaccess +
                '" type="' + escapeAttributeValue(accessor.$Bgtype) +
                '" declaredBy="' +
                escapeAttributeValue(accessor.$BgdeclaredBy) + '"/>');
            finishTraitDescription(accessor, e, x);
            traitsCount++;
        }
        var methods = traits.$Bgmethods && traits.$Bgmethods.value;
        for (var i = 0; methods && i < methods.length; i++) {
            var method = methods[i];
            var e = x.sec.AXXML.Create('<method ' + 'name="' +
                escapeAttributeValue(method.$Bgname) +
                '" declaredBy="' +
                escapeAttributeValue(method.$BgdeclaredBy) +
                '" returnType="' +
                escapeAttributeValue(method.$BgreturnType) + '"/>');
            describeParams(e, method.$Bgparameters.value);
            finishTraitDescription(method, e, x);
            traitsCount++;
        }
        describeMetadataXML(x, traits.$Bgmetadata);
        return traitsCount > 0;
    }
    function finishTraitDescription(trait, traitXML, traitsListXML) {
        if (trait.$Bguri !== null) {
            tmpAttr.name = 'uri';
            traitXML.setProperty(tmpAttr, trait.$Bguri);
        }
        if (trait.$Bgmetadata !== null) {
            describeMetadataXML(traitXML, trait.$Bgmetadata);
        }
        traitsListXML.appendChild(traitXML);
    }
    function describeParams(x, parameters) {
        if (!parameters) {
            return;
        }
        for (var i = 0; i < parameters.length; i++) {
            var p = parameters[i];
            var f = x.sec.AXXML.Create('<parameter index="' + (i + 1) + '" type="' +
                escapeAttributeValue(p.$Bgtype) + '" optional="' +
                p.$Bgoptional + '"/>');
            x.appendChild(f);
        }
    }
    function describeMetadataXML(x, metadata_) {
        if (!metadata_) {
            return;
        }
        var metadata = metadata_.value;
        for (var i = 0; i < metadata.length; i++) {
            var md = metadata[i];
            var m = x.sec.AXXML.Create('<metadata name="' + escapeAttributeValue(md.$Bgname)
                + '"/>');
            var values = md.$Bgvalue.value;
            for (var j = 0; j < values.length; j++) {
                var value = values[j];
                var a = x.sec.AXXML.Create('<arg key="' +
                    escapeAttributeValue(value.$Bgkey) + '" value="' +
                    escapeAttributeValue(value.$Bgvalue) + '"/>');
                m.appendChild(a);
            }
            x.appendChild(m);
        }
    }
    function describeMetadataList(sec, list /*MetadataInfo[]*/) {
        if (!list) {
            return null;
        }
        var result = sec.createArray([]);
        for (var i = 0; i < list.length; i++) {
            var metadata = list[i];
            var key = metadata.getName();
            // Filter out the [native] metadata nodes. These are implementation details Flash doesn't
            // expose, so we don't, either.
            if (key === 'native') {
                continue;
            }
            result.push(describeMetadata(sec, metadata));
        }
        return result;
    }
    function describeMetadata(sec, metadata /*MetadataInfo*/) {
        var result = sec.createObject();
        result.$Bgname = metadata.name;
        var values = [];
        result.$Bgvalue = sec.createArray(values);
        for (var i = 0; i < metadata.keys.length; i++) {
            var val = sec.createObject();
            val.$Bgvalue = metadata.getValueAt(i);
            val.$Bgkey = metadata.getKeyAt(i);
            values.push(val);
        }
        return result;
    }
    function addTraits(cls, info, describingClass, flags) {
        var sec = cls.sec;
        var includeBases = flags & 2 /* INCLUDE_BASES */;
        var includeMethods = flags & 32 /* INCLUDE_METHODS */ && !describingClass;
        var obj = sec.createObject();
        var variablesVal = obj.$Bgvariables =
            flags & 8 /* INCLUDE_VARIABLES */ ? sec.createArray([]) : null;
        var accessorsVal = obj.$Bgaccessors =
            flags & 16 /* INCLUDE_ACCESSORS */ ? sec.createArray([]) : null;
        var metadataList = null;
        // Somewhat absurdly, class metadata is only included when describing instances.
        if (flags & 64 /* INCLUDE_METADATA */ && !describingClass) {
            var metadata = info.trait.getMetadata();
            if (metadata) {
                metadataList = describeMetadataList(sec, metadata);
            }
        }
        // This particular metadata list is always created, even if no metadata exists.
        obj.$Bgmetadata = metadataList || sec.createArray([]);
        // TODO: fill in.
        obj.$Bgconstructor = null;
        if (flags & 4 /* INCLUDE_INTERFACES */) {
            obj.$Bginterfaces = sec.createArray([]);
            if (!describingClass) {
                var interfacesVal = obj.$Bginterfaces.value;
                var interfaces = cls.classInfo.instanceInfo.getInterfaces(cls);
                interfaces.forEach(function (iface) { return interfacesVal.push(iface.name.toFQNString(true)); });
            }
        }
        else {
            obj.$Bginterfaces = null;
        }
        var methodsVal = obj.$Bgmethods = includeMethods ? sec.createArray([]) : null;
        var basesVal = obj.$Bgbases = includeBases ? sec.createArray([]) : null;
        var encounteredKeys = Object.create(null);
        // Needed for accessor-merging.
        var encounteredGetters = Object.create(null);
        var encounteredSetters = Object.create(null);
        var addBase = false;
        var isInterface = info.instanceInfo.isInterface();
        while (cls) {
            var className = cls.classInfo.instanceInfo.getName().toFQNString(true);
            if (includeBases && addBase && !describingClass) {
                basesVal.push(className);
            }
            else {
                addBase = true;
            }
            if (flags & 1024 /* HIDE_OBJECT */ && cls === sec.AXObject) {
                break;
            }
            if (!describingClass) {
                describeTraits(sec, cls.classInfo.instanceInfo.traits.traits, isInterface);
            }
            else {
                describeTraits(sec, cls.classInfo.traits.traits, isInterface);
            }
            cls = cls.superClass;
        }
        release$1 || assert(cls === sec.AXObject || isInterface);
        // When describing Class objects, the bases to add are always Class and Object.
        if (describingClass) {
            // When describing Class objects, accessors are ignored. *Except* the `prototype` accessor.
            if (flags & 16 /* INCLUDE_ACCESSORS */) {
                var val = sec.createObject();
                val.$Bgname = 'prototype';
                val.$Bgtype = '*';
                val.$Bgaccess = "readonly";
                val.$Bgmetadata = null;
                val.$Bguri = null;
                val.$BgdeclaredBy = 'Class';
                accessorsVal.push(val);
            }
            if (includeBases) {
                basesVal.pop();
                basesVal.push('Class', 'Object');
                cls = sec.AXClass;
            }
        }
        // Having a hot function closed over isn't all that great, but moving this out would involve
        // passing lots and lots of arguments. We might do that if performance becomes an issue.
        function describeTraits(sec, traits /*TraitInfo[]*/, isInterface) {
            release$1 || assert(traits, "No traits array found on class" + cls.name);
            // All types share some fields, but setting them in one place changes the order in which
            // they're defined - and hence show up in iteration. While it is somewhat unlikely that
            // real content relies on that order, tests certainly do, so we duplicate the code.
            for (var i = 0; i < traits.length; i++) {
                var t = traits[i];
                var mn = t.getName();
                var ns = mn.namespace;
                // Hide all non-public members whose namespace doesn't have a URI specified.
                // Or, if HIDE_NSURI_METHODS is set, hide those, too, because bugs in Flash.
                // For interfaces, include all traits. We should've made sure to only have
                // public methods in them during bytecode parsing/verification.
                if (!isInterface && (!ns.isPublic() && !ns.uri ||
                    (flags & 1 /* HIDE_NSURI_METHODS */ && ns.uri))) {
                    continue;
                }
                // Strip the namespace off of interface methods. They're always treated as public.
                var name = isInterface ? mn.name : mn.toFQNString(true);
                if (encounteredGetters[name] !== encounteredSetters[name]) {
                    var val = encounteredKeys[name];
                    val.$Bgaccess = 'readwrite';
                    if (t.kind === 2 /* Getter */) {
                        var type = t.getMethodInfo().getType();
                        val.$Bgtype = type ? type.name.toFQNString(true) : '*';
                    }
                    continue;
                }
                if (encounteredKeys[name]) {
                    continue;
                }
                //TODO: check why we have public$$_init in `Object`
                var val = sec.createObject();
                encounteredKeys[name] = val;
                var metadata = t.getMetadata();
                switch (t.kind) {
                    case 6 /* Const */:
                    case 0 /* Slot */:
                        if (!(flags & 8 /* INCLUDE_VARIABLES */)) {
                            continue;
                        }
                        val.$Bgname = name;
                        val.$Bguri = ns.reflectedURI;
                        var typeName = t.getTypeName();
                        val.$Bgtype = typeName ? typeName.toFQNString(true) : '*';
                        val.$Bgaccess = "readwrite";
                        val.$Bgmetadata = flags & 64 /* INCLUDE_METADATA */ ?
                            describeMetadataList(sec, metadata) :
                            null;
                        variablesVal.push(val);
                        break;
                    case 1 /* Method */:
                        if (!includeMethods) {
                            continue;
                        }
                        var returnType = t.getMethodInfo().getType();
                        val.$BgreturnType = returnType ? returnType.name.toFQNString(true) : '*';
                        val.$Bgmetadata = flags & 64 /* INCLUDE_METADATA */ ?
                            describeMetadataList(sec, metadata) :
                            null;
                        val.$Bgname = name;
                        val.$Bguri = ns.reflectedURI;
                        var parametersVal = val.$Bgparameters = sec.createArray([]);
                        var parameters = t.getMethodInfo().parameters;
                        for (var j = 0; j < parameters.length; j++) {
                            var param = parameters[j];
                            var paramVal = sec.createObject();
                            paramVal.$Bgtype = param.type ? param.getType().toFQNString(true) : '*';
                            paramVal.$Bgoptional = 'value' in param;
                            parametersVal.push(paramVal);
                        }
                        val.$BgdeclaredBy = className;
                        methodsVal.push(val);
                        break;
                    case 2 /* Getter */:
                    case 3 /* Setter */:
                        if (!(flags & 16 /* INCLUDE_ACCESSORS */) || describingClass) {
                            continue;
                        }
                        val.$Bgname = name;
                        if (t.kind === 2 /* Getter */) {
                            var returnType = t.getMethodInfo().getType();
                            val.$Bgtype = returnType ? returnType.name.toFQNString(true) : '*';
                            encounteredGetters[name] = val;
                        }
                        else {
                            var paramType = t.getMethodInfo().parameters[0].getType();
                            val.$Bgtype = paramType ? paramType.toFQNString(true) : '*';
                            encounteredSetters[name] = val;
                        }
                        val.$Bgaccess = t.kind === 2 /* Getter */ ? "readonly" : "writeonly";
                        val.$Bgmetadata = flags & 64 /* INCLUDE_METADATA */ ?
                            describeMetadataList(sec, metadata) :
                            null;
                        val.$Bguri = ns.reflectedURI;
                        val.$BgdeclaredBy = className;
                        accessorsVal.push(val);
                        break;
                    default:
                        release$1 || assert(false, "Unknown trait type: " + t.kind);
                        break;
                }
            }
        }
        // `methods` and `variables` are the only list that are `null`-ed if empty.
        if (!methodsVal || methodsVal.value.length === 0) {
            obj.$Bgmethods = null;
        }
        if (!variablesVal || variablesVal.value.length === 0) {
            obj.$Bgvariables = null;
        }
        return obj;
    }

    /**
     * Other natives can live in this module
     */
    var Natives = {
        print: function (sec, expression, arg1, arg2, arg3, arg4) {
            var args = Array.prototype.slice.call(arguments, 1);
            if (args.length == 1) {
                console.log("%c Trace from SWF:", "color: DodgerBlue", args[0]);
            }
            else {
                console.log("%c Trace from SWF:", "color: DodgerBlue", args);
            }
            //jsGlobal.print.apply(null, args);
        },
        debugBreak: function (v) {
            /* tslint:disable */
            debugger;
            /* tslint:enable */
        },
        bugzilla: function (_, n) {
            switch (n) {
                case 574600: // AS3 Vector::map Bug
                    return true;
            }
            return false;
        },
        decodeURI: function (sec, encodedURI) {
            try {
                return jsGlobal.decodeURI(encodedURI);
            }
            catch (e) {
                sec.throwError('URIError', Errors$1.InvalidURIError, 'decodeURI');
            }
        },
        decodeURIComponent: function (sec, encodedURI) {
            try {
                return jsGlobal.decodeURIComponent(encodedURI);
            }
            catch (e) {
                sec.throwError('URIError', Errors$1.InvalidURIError, 'decodeURIComponent');
            }
        },
        encodeURI: function (sec, uri) {
            try {
                return jsGlobal.encodeURI(uri);
            }
            catch (e) {
                sec.throwError('URIError', Errors$1.InvalidURIError, 'encodeURI');
            }
        },
        encodeURIComponent: function (sec, uri) {
            try {
                return jsGlobal.encodeURIComponent(uri);
            }
            catch (e) {
                sec.throwError('URIError', Errors$1.InvalidURIError, 'encodeURIComponent');
            }
        },
        isNaN: wrapJSGlobalFunction(jsGlobal.isNaN),
        isFinite: wrapJSGlobalFunction(jsGlobal.isFinite),
        parseInt: wrapJSGlobalFunction(jsGlobal.parseInt),
        parseFloat: wrapJSGlobalFunction(jsGlobal.parseFloat),
        escape: wrapJSGlobalFunction(jsGlobal.escape),
        unescape: wrapJSGlobalFunction(jsGlobal.unescape),
        isXMLName: function () {
            return false; // "FIX ME";
        },
        notImplemented: wrapJSGlobalFunction(notImplemented),
        /**
         * Returns the fully qualified class name of an object.
         */
        getQualifiedClassName: function (_, value) {
            release$1 || checkValue(value);
            var valueType = typeof value;
            switch (valueType) {
                case 'undefined':
                    return 'void';
                case 'object':
                    if (value === null) {
                        return 'null';
                    }
                    return value.classInfo.instanceInfo.name.toFQNString(true);
                case 'number':
                    return (value | 0) === value ? 'int' : 'Number';
                case 'string':
                    return 'String';
                case 'boolean':
                    return 'Boolean';
            }
            release$1 || assertUnreachable('invalid value type ' + valueType);
        },
        /**
         * Returns the fully qualified class name of the base class of the object specified by the
         * |value| parameter.
         */
        getQualifiedSuperclassName: function (sec, value) {
            if (isNullOrUndefined(value)) {
                return "null";
            }
            value = sec.box(value);
            // The value might be from another domain, so don't use passed-in the current
            // AXSecurityDomain.
            var axClass = value.sec.AXClass.axIsType(value) ?
                value.superClass :
                value.axClass.superClass;
            return this.getQualifiedClassName(sec, axClass);
        },
        /**
         * Returns the class with the specified name, or |null| if no such class exists.
         */
        getDefinitionByName: function (sec, name) {
            name = axCoerceString$3(name).replace("::", ".");
            var mn = Multiname.FromFQNString(name, 0 /* Public */);
            return getCurrentABC().env.app.getClass(mn);
        },
        describeType: function (sec, value, flags) {
            console.log("describeType not implemented");
            return describeType(sec, value, flags);
        },
        describeTypeJSON: function (sec, value, flags) {
            console.log("describeTypeJSON not implemented");
            return null; //describeTypeJSON(sec, value, flags);
        },
        getArgv: function () {
            return null;
        }
    };

    /**
     * Searches for natives using a string path "a.b.c...".
     */
    function getNative(path) {
        var chain = path.split(".");
        var v = Natives;
        for (var i = 0, j = chain.length; i < j; i++) {
            v = v && v[chain[i]];
        }
        if (!v) {
            v = nativeFunctions[path];
        }
        release$1 || assert(v, "getNative(" + path + ") not found.");
        return v;
    }

    var builtinNativeClasses = ObjectUtilities.createMap();
    var nativeClasses = ObjectUtilities.createMap();
    var nativeClassLoaderNames = [];

    function getNativesForTrait(trait) {
        var className = null;
        var natives;
        if (trait.holder instanceof InstanceInfo) {
            var instanceInfo = trait.holder;
            className = instanceInfo.getClassName();
            var native = builtinNativeClasses[className] || nativeClasses[className];
            release$1 || assert(native, "Class native is not defined: " + className);
            natives = [native.prototype];
            if (native.instanceNatives) {
                pushMany(natives, native.instanceNatives);
            }
        }
        else if (trait.holder instanceof ClassInfo) {
            var classInfo = trait.holder;
            className = classInfo.instanceInfo.getClassName();
            var native = builtinNativeClasses[className] || nativeClasses[className];
            release$1 || assert(native, "Class native is not defined: " + className);
            natives = [native];
            if (native.classNatives) {
                pushMany(natives, native.classNatives);
            }
        }
        else {
            release$1 || assertUnreachable('Invalid trait type');
        }
        return natives;
    }

    /**
     * Searches for a native property in a list of native holders.
     */
    function getMethodOrAccessorNative(trait) {
        var natives = getNativesForTrait(trait);
        var name = trait.getName().name;
        for (var i = 0; i < natives.length; i++) {
            var native = natives[i];
            var fullName = name;
            // We prefix methods that should not be exported with "native_", check to see
            // if a method exists with that prefix first when looking for native methods.
            if (!hasOwnProperty(native, name) && hasOwnProperty(native, "native_" + name)) {
                fullName = "native_" + name;
            }
            if (hasOwnProperty(native, fullName)) {
                var value;
                if (trait.isAccessor()) {
                    var pd = Object.getOwnPropertyDescriptor(native, fullName);
                    if (trait.isGetter()) {
                        value = pd.get;
                    }
                    else {
                        value = pd.set;
                    }
                }
                else {
                    release$1 || assert(trait.isMethod());
                    value = native[fullName];
                }
                release$1 || assert(value, "Method or Accessor property exists but it's undefined: " + trait.holder + " " + trait);
                return value;
            }
        }
        warning("No native method for: " + trait.holder + " " + trait + ", make sure you've got the static keyword for static methods.");
        release$1 || assertUnreachable("Cannot find " + trait + " in natives.");
        return null;
    }

    function createMethodForTrait(methodTraitInfo, scope) {
        if (methodTraitInfo.method) {
            return methodTraitInfo.method;
        }
        var methodInfo = methodTraitInfo.getMethodInfo();
        var method;
        if (methodInfo.flags & 32 /* Native */) {
            var metadata = methodInfo.getNativeMetadata();
            if (metadata || methodTraitInfo.holder instanceof ScriptInfo) {
                if (metadata) {
                    method = getNative(metadata.getValueAt(0));
                }
                else {
                    var mn = methodTraitInfo.getName();
                    method = getNative(mn.uri + '.' + mn.name);
                }
                method = createGlobalNative(method, scope.object.sec);
            }
            else {
                method = getMethodOrAccessorNative(methodTraitInfo);
            }
            if (!release$1) {
                method.toString = function () {
                    return "Native " + methodTraitInfo.toString();
                };
                method.isInterpreted = false;
            }
        }
        else {
            method = interpret(methodInfo, scope, null);
            if (!release$1) {
                method.toString = function () {
                    return "Interpreted " + methodTraitInfo.toString();
                };
                method.isInterpreted = true;
            }
        }
        if (!release$1 && flashlog && methodInfo.trait) {
            method = (function (wrapped, methodInfo) {
                var traceMsg = methodInfo.toFlashlogString();
                var result = function () {
                    flashlog.writeAS3Trace(traceMsg);
                    return wrapped.apply(this, arguments);
                };
                result.toString = wrapped.toString;
                result.isInterpreted = wrapped.isInterpreted;
                return result;
            })(method, methodInfo);
        }
        methodTraitInfo.method = method;
        method.methodInfo = methodInfo;
        if (!release$1) {
            try {
                Object.defineProperty(method, 'name', { value: methodInfo.getName() });
            }
            catch (e) {
                // Ignore errors in browsers that don't allow overriding Function#length;
            }
        }
        method.methodInfo = methodInfo;
        return method;
    }

    /**
     * The Traits class represents the collection of compile-time traits associated with a type.
     * It's not used for runtime name resolution on instances; instead, the combined traits for
     * a type and all its super types is resolved and translated to an instance of RuntimeTraits.
     */
    var Traits = /** @class */ (function () {
        function Traits(traits) {
            this.traits = traits;
            this._resolved = false;
            this.multinames = {};
            // ...
        }
        Traits.prototype.resolve = function () {
            if (this._resolved) {
                return;
            }
            for (var i = 0; i < this.traits.length; i++) {
                this.traits[i].resolve();
            }
            this._resolved = true;
        };
        Traits.prototype.attachHolder = function (holder) {
            for (var i = 0; i < this.traits.length; i++) {
                release$1 || assert(!this.traits[i].holder);
                this.traits[i].holder = holder;
            }
        };
        Traits.prototype.trace = function (writer) {
            if (writer === void 0) { writer = new IndentingWriter(); }
            this.resolve();
            this.traits.forEach(function (x) { return writer.writeLn(x.toString()); });
        };
        /**
         * Searches for a trait with the specified name.
         */
        Traits.prototype.indexOf = function (mn) {
            release$1 || assert(this._resolved);
            var mnName = mn.name;
            var nss = mn.namespaces;
            var traits = this.traits;
            for (var i = 0; i < traits.length; i++) {
                var trait = traits[i];
                var traitMn = trait.name;
                if (traitMn.name === mnName) {
                    var ns = traitMn.namespaces[0];
                    for (var j = 0; j < nss.length; j++) {
                        if (ns === nss[j]) {
                            return i;
                        }
                    }
                }
            }
            return -1;
        };
        Traits.prototype.getTrait = function (mn) {
            var t = this.multinames[mn.id];
            if (t === undefined) {
                var i = this.indexOf(mn);
                t = i >= 0 ? this.traits[i] : this;
                this.multinames[mn.id] = t;
            }
            return t === this ? null : t;
        };
        /**
         * Turns a list of compile-time traits into runtime traits with resolved bindings.
         *
         * Runtime traits are stored in 2-dimensional maps. The outer dimension is keyed on the
         * trait's local name. The inner dimension is a map of mangled namespace names to traits.
         *
         * Lookups are thus O(n) in the number of namespaces present in the query, instead of O(n+m)
         * in the number of traits (n) on the type times the number of namespaces present in the
         * query (m).
         *
         * Negative result note: an implementation with ECMAScript Maps with Namespace objects as
         * keys was tried and found to be much slower than the Object-based one implemented here.
         * Mostly, the difference was in how well accesses are optimized in JS engines, with Maps
         * being new-ish and less well-optimized.
         *
         * Additionally, all protected traits get added to a map with their unqualified name as key.
         * That map is created with the super type's map on its prototype chain. If a type overrides
         * a protected trait, it gets set as that type's value for the unqualified name. Additionally,
         * its name is canonicalized to use the namespace used in the initially introducing type.
         * During name lookup, we first check for a hit in that map and (after verifying that the mn
         * has a correct protected name in its namespaces set) return the most recent trait. That way,
         * all lookups always get the most recent trait, even if they originate from a super class.
         */
        Traits.prototype.resolveRuntimeTraits = function (superTraits, protectedNs, scope) {
            // Resolve traits so that indexOf works out.
            this.resolve();
            var protectedNsMappings = Object.create(superTraits ? superTraits.protectedNsMappings : null);
            var result = new RuntimeTraits(superTraits, protectedNs, protectedNsMappings);
            // Add all of the child traits, replacing or extending parent traits where necessary.
            for (var i = 0; i < this.traits.length; i++) {
                var trait = this.traits[i];
                var name = trait.name;
                var runtimeTrait = new RuntimeTraitInfo(name, trait.kind, trait.abc);
                if (name.namespaces[0].type === 1 /* Protected */) {
                    // Names for protected traits get canonicalized to the name of the type that initially
                    // introduces the trait.
                    if (result.protectedNsMappings[name.name]) {
                        runtimeTrait.name = result.protectedNsMappings[name.name].name;
                    }
                    result.protectedNsMappings[name.name] = runtimeTrait;
                }
                var currentTrait = result.addTrait(runtimeTrait);
                switch (trait.kind) {
                    case 1 /* Method */:
                        var method = createMethodForTrait(trait, scope);
                        runtimeTrait.value = method;
                        break;
                    case 2 /* Getter */:
                        runtimeTrait.get = createMethodForTrait(trait, scope);
                        if (currentTrait && currentTrait.set) {
                            runtimeTrait.set = currentTrait.set;
                            runtimeTrait.kind = 7 /* GetterSetter */;
                        }
                        break;
                    case 3 /* Setter */:
                        runtimeTrait.set = createMethodForTrait(trait, scope);
                        if (currentTrait && currentTrait.get) {
                            runtimeTrait.get = currentTrait.get;
                            runtimeTrait.kind = 7 /* GetterSetter */;
                        }
                        break;
                    case 0 /* Slot */:
                    case 6 /* Const */:
                    case 4 /* Class */:
                        // Only non-const slots need to be writable. Everything else is fixed.
                        runtimeTrait.writable = true;
                        var slotTrait = trait;
                        runtimeTrait.slot = slotTrait.slot;
                        runtimeTrait.value = slotTrait.getDefaultValue();
                        runtimeTrait.typeName = slotTrait.typeName;
                        // TODO: Throw error for const without default.
                        result.addSlotTrait(runtimeTrait);
                }
            }
            return result;
        };
        return Traits;
    }());

    var TRAITNames = ["Slot", "Method", "Getter", "Setter", "Class", "Function", "Const", "GetterSetter"];
    function getTRAITName(trait) {
        return release$1 ? String(trait) : TRAITNames[trait];
    }

    var TraitInfo = /** @class */ (function () {
        function TraitInfo(abc, kind, name) {
            this.abc = abc;
            this.kind = kind;
            this.name = name;
            this.metadata = null;
            this.holder = null;
        }
        TraitInfo.prototype.getMetadata = function () {
            if (!this.metadata) {
                return null;
            }
            if (this.metadata instanceof Uint32Array) {
                var metadata = new Array(this.metadata.length);
                for (var i = 0; i < this.metadata.length; i++) {
                    metadata[i] = this.abc.getMetadataInfo(this.metadata[i]);
                }
                this.metadata = metadata;
            }
            return this.metadata;
        };
        TraitInfo.prototype.getName = function () {
            return this.name;
        };
        TraitInfo.prototype.resolve = function () {
            if (typeof this.name === "number") {
                this.name = this.abc.getMultiname(this.name);
            }
        };
        TraitInfo.prototype.toString = function () {
            return getTRAITName(this.kind) + " " + this.name;
        };
        TraitInfo.prototype.toFlashlogString = function () {
            this.resolve();
            return this.getName().toFlashlogString();
        };
        TraitInfo.prototype.isConst = function () {
            return this.kind === 6 /* Const */;
        };
        TraitInfo.prototype.isSlot = function () {
            return this.kind === 0 /* Slot */;
        };
        TraitInfo.prototype.isMethod = function () {
            return this.kind === 1 /* Method */;
        };
        TraitInfo.prototype.isGetter = function () {
            return this.kind === 2 /* Getter */;
        };
        TraitInfo.prototype.isSetter = function () {
            return this.kind === 3 /* Setter */;
        };
        TraitInfo.prototype.isAccessor = function () {
            return this.kind === 2 /* Getter */ ||
                this.kind === 3 /* Setter */;
        };
        TraitInfo.prototype.isMethodOrAccessor = function () {
            return this.isAccessor() || this.kind === 1 /* Method */;
        };
        return TraitInfo;
    }());

    var typeDefaultValues = {
        __proto__: null,
        $BgNumber: NaN,
        $Bgint: 0,
        $Bguint: 0,
        $BgBoolean: false
    };

    var SlotTraitInfo = /** @class */ (function (_super) {
        __extends(SlotTraitInfo, _super);
        function SlotTraitInfo(abc, kind, name, slot, typeName, defaultValueKind, defaultValueIndex) {
            var _this = _super.call(this, abc, kind, name) || this;
            _this.slot = slot;
            _this.typeName = typeName;
            _this.defaultValueKind = defaultValueKind;
            _this.defaultValueIndex = defaultValueIndex;
            return _this;
        }
        SlotTraitInfo.prototype.resolve = function () {
            _super.prototype.resolve.call(this);
            if (typeof this.typeName === "number") {
                this.typeName = this.abc.getMultiname(this.typeName);
            }
        };
        SlotTraitInfo.prototype.getTypeName = function () {
            this.resolve();
            return this.typeName;
        };
        SlotTraitInfo.prototype.getDefaultValue = function () {
            if (this.defaultValueKind === -1) {
                if (this.typeName === null) {
                    return undefined;
                }
                var value = typeDefaultValues[this.typeName.getMangledName()];
                return value === undefined ? null : value;
            }
            return this.abc.getConstant(this.defaultValueKind, this.defaultValueIndex);
        };
        return SlotTraitInfo;
    }(TraitInfo));

    var MethodTraitInfo = /** @class */ (function (_super) {
        __extends(MethodTraitInfo, _super);
        function MethodTraitInfo(abc, kind, name, methodInfo) {
            var _this = _super.call(this, abc, kind, name) || this;
            _this.methodInfo = methodInfo;
            _this.method = null;
            return _this;
        }
        MethodTraitInfo.prototype.getMethodInfo = function () {
            return this.methodInfo;
        };
        MethodTraitInfo.prototype.resolve = function () {
            _super.prototype.resolve.call(this);
            if (typeof this.methodInfo === "number") {
                this.methodInfo = this.abc.getMethodInfo(this.methodInfo);
            }
        };
        return MethodTraitInfo;
    }(TraitInfo));

    var ClassTraitInfo = /** @class */ (function (_super) {
        __extends(ClassTraitInfo, _super);
        function ClassTraitInfo(abc, kind, name, slot, classInfo) {
            var _this = _super.call(this, abc, kind, name, slot, 0, 0, -1) || this;
            _this.classInfo = classInfo;
            return _this;
        }
        return ClassTraitInfo;
    }(SlotTraitInfo));

    var ExceptionInfo = /** @class */ (function () {
        function ExceptionInfo(abc, start, end, target, type, varName) {
            this.abc = abc;
            this.start = start;
            this.end = end;
            this.target = target;
            this.type = type;
            this.varName = varName;
            this.catchPrototype = null;
            this._traits = null;
            // ...
        }
        ExceptionInfo.prototype.getType = function () {
            if (typeof this.type === "number") {
                this.type = this.abc.getMultiname(this.type);
            }
            return this.type;
        };
        ExceptionInfo.prototype.getTraits = function () {
            if (!this._traits) {
                var traits = [];
                if (this.varName) {
                    traits.push(new SlotTraitInfo(this.abc, 0 /* Slot */, this.varName, 1, this.type, 0, 0));
                }
                this._traits = new Traits(traits);
                this._traits.resolve();
            }
            return this._traits;
        };
        return ExceptionInfo;
    }());

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var textDecoder = null;
    if (typeof TextDecoder !== "undefined") {
        textDecoder = new TextDecoder();
    }
    var AbcStream = /** @class */ (function () {
        function AbcStream(bytes) {
            this._bytes = bytes;
            this._view = new DataView(bytes.buffer, bytes.byteOffset);
            this._position = 0;
        }
        AbcStream._getResultBuffer = function (length) {
            if (!AbcStream._resultBuffer || AbcStream._resultBuffer.length < length) {
                AbcStream._resultBuffer = new Uint32Array(length * 2);
            }
            return AbcStream._resultBuffer;
        };
        Object.defineProperty(AbcStream.prototype, "position", {
            get: function () {
                return this._position;
            },
            enumerable: true,
            configurable: true
        });
        AbcStream.prototype.remaining = function () {
            return this._bytes.length - this._position;
        };
        AbcStream.prototype.seek = function (position) {
            this._position = position;
        };
        AbcStream.prototype.advance = function (length) {
            this._position += length;
        };
        AbcStream.prototype.readU8 = function () {
            return this._bytes[this._position++];
        };
        AbcStream.prototype.readU8s = function (count) {
            var b = new Uint8Array(count);
            b.set(this._bytes.subarray(this._position, this._position + count), 0);
            this._position += count;
            return b;
        };
        AbcStream.prototype.viewU8s = function (count) {
            var view = this._bytes.subarray(this._position, this._position + count);
            this._position += count;
            return view;
        };
        AbcStream.prototype.readS8 = function () {
            return this._bytes[this._position++] << 24 >> 24;
        };
        AbcStream.prototype.readU32 = function () {
            return this.readS32() >>> 0;
        };
        AbcStream.prototype.readU30 = function () {
            var result = this.readU32();
            if (result & 0xc0000000) {
                // TODO: Spec says this is a corrupt ABC file, but it seems that some content
                // has this, e.g. 1000-0.abc
                // error("Corrupt ABC File");
                return result;
            }
            return result;
        };
        AbcStream.prototype.readU30Unsafe = function () {
            return this.readU32();
        };
        AbcStream.prototype.readS16 = function () {
            return (this.readU30Unsafe() << 16) >> 16;
        };
        /**
         * Read a variable-length encoded 32-bit signed integer. The value may use one to five bytes (little endian),
         * each contributing 7 bits. The most significant bit of each byte indicates that the next byte is part of
         * the value. The spec indicates that the most significant bit of the last byte to be read is sign extended
         * but this turns out not to be the case in the real implementation, for instance 0x7f should technically be
         * -1, but instead it's 127. Moreover, what happens to the remaining 4 high bits of the fifth byte that is
         * read? Who knows, here we'll just stay true to the Tamarin implementation.
         */
        AbcStream.prototype.readS32 = function () {
            var result = this.readU8();
            if (result & 0x80) {
                result = result & 0x7f | this.readU8() << 7;
                if (result & 0x4000) {
                    result = result & 0x3fff | this.readU8() << 14;
                    if (result & 0x200000) {
                        result = result & 0x1fffff | this.readU8() << 21;
                        if (result & 0x10000000) {
                            result = result & 0x0fffffff | this.readU8() << 28;
                            result = result & 0xffffffff;
                        }
                    }
                }
            }
            return result;
        };
        AbcStream.prototype.readWord = function () {
            var result = this._view.getUint32(this._position, true);
            this._position += 4;
            return result;
        };
        AbcStream.prototype.readS24 = function () {
            var u = this.readU8() | (this.readU8() << 8) | (this.readU8() << 16);
            return (u << 8) >> 8;
        };
        AbcStream.prototype.readDouble = function () {
            var result = this._view.getFloat64(this._position, true);
            this._position += 8;
            return result;
        };
        AbcStream.prototype.readUTFString = function (length) {
            /**
             * Use the TextDecoder API whenever available.
             * http://encoding.spec.whatwg.org/#concept-encoding-get
             */
            if (textDecoder) {
                var position = this._position;
                this._position += length;
                return textDecoder.decode(this._bytes.subarray(position, position + length));
            }
            var pos = this._position;
            var end = pos + length;
            var bytes = this._bytes;
            var i = 0;
            var result = AbcStream._getResultBuffer(length * 2);
            while (pos < end) {
                var c = bytes[pos++];
                if (c <= 0x7f) {
                    result[i++] = c;
                }
                else if (c >= 0xc0) { // multibyte
                    var code = 0;
                    if (c < 0xe0) { // 2 bytes
                        code = ((c & 0x1f) << 6) | (bytes[pos++] & 0x3f);
                    }
                    else if (c < 0xf0) { // 3 bytes
                        code = ((c & 0x0f) << 12) | ((bytes[pos++] & 0x3f) << 6) | (bytes[pos++] & 0x3f);
                    }
                    else { // 4 bytes
                        // turned into two characters in JS as surrogate pair
                        code = (((c & 0x07) << 18) | ((bytes[pos++] & 0x3f) << 12) | ((bytes[pos++] & 0x3f) << 6) | (bytes[pos++] & 0x3f)) - 0x10000;
                        // High surrogate
                        result[i++] = ((code & 0xffc00) >>> 10) + 0xd800;
                        // Low surrogate
                        code = (code & 0x3ff) + 0xdc00;
                    }
                    result[i++] = code;
                } // Otherwise it's an invalid UTF8, skipped.
            }
            this._position = pos;
            return StringUtilities.fromCharCodeArray(result.subarray(0, i));
        };
        AbcStream._resultBuffer = new Uint32Array(256);
        return AbcStream;
    }());

    var ABCFile = /** @class */ (function () {
        function ABCFile(env, _buffer) {
            this._buffer = _buffer;
            this.env = env;
            this._stream = new AbcStream(_buffer);
            this._checkMagic();
            this._parseConstantPool();
            this._parseNamespaces();
            this._parseNamespaceSets();
            this._parseMultinames();
            this._parseMethodInfos();
            this._parseMetaData();
            this._parseInstanceAndClassInfos();
            this._parseScriptInfos();
            this._parseMethodBodyInfos();
        }
        Object.defineProperty(ABCFile.prototype, "applicationDomain", {
            get: function () {
                release$1 || assert(this.env.app);
                return this.env.app;
            },
            enumerable: true,
            configurable: true
        });
        ABCFile.prototype._parseConstantPool = function () {
            this._parseNumericConstants();
            this._parseStringConstants();
        };
        ABCFile.prototype._parseNumericConstants = function () {
            var n = 0, s = this._stream;
            // Parse Signed Integers
            n = s.readU30();
            var ints = new Int32Array(n);
            ints[0] = 0;
            for (var i = 1; i < n; i++) {
                ints[i] = s.readS32();
            }
            this.ints = ints;
            // Parse Unsigned Integers
            n = s.readU30();
            var uints = new Uint32Array(n);
            uints[0] = 0;
            for (var i = 1; i < n; i++) {
                uints[i] = s.readS32();
            }
            this.uints = uints;
            // Parse Doubles
            n = s.readU30();
            var doubles = new Float64Array(n);
            doubles[0] = NaN;
            for (var i = 1; i < n; i++) {
                doubles[i] = s.readDouble();
            }
            this.doubles = doubles;
        };
        ABCFile.prototype._parseStringConstants = function () {
            var n = 0, s = this._stream;
            n = s.readU30();
            this._strings = new Array(n);
            this._strings[0] = null;
            // Record the offset of each string in |stringOffsets|. This array has one extra
            // element so that we can compute the length of the last string.
            var stringOffsets = this._stringOffsets = new Uint32Array(n);
            stringOffsets[0] = -1;
            for (var i = 1; i < n; i++) {
                stringOffsets[i] = s.position;
                s.advance(s.readU30());
            }
        };
        ABCFile.prototype._parseNamespaces = function () {
            var s = this._stream;
            var n = s.readU30();
            this._namespaces = new Array(n);
            var namespaceOffsets = this._namespaceOffsets = new Uint32Array(n);
            namespaceOffsets[0] = -1;
            for (var i = 1; i < n; i++) {
                namespaceOffsets[i] = s.position;
                s.readU8(); // Kind
                s.readU30(); // String
            }
        };
        ABCFile.prototype._parseNamespaceSets = function () {
            var s = this._stream;
            var n = s.readU30();
            this._namespaceSets = new Array(n);
            var namespaceSetOffsets = this._namespaceSetOffsets = new Uint32Array(n);
            namespaceSetOffsets[0] = -1;
            for (var i = 1; i < n; i++) {
                namespaceSetOffsets[i] = s.position;
                var c = s.readU30(); // Count
                for (var j = 0; j < c; j++) {
                    s.readU30(); // Namespace
                }
            }
        };
        ABCFile.prototype._consumeMultiname = function () {
            var s = this._stream;
            var kind = s.readU8();
            switch (kind) {
                case 7 /* QName */:
                case 13 /* QNameA */:
                    s.readU30();
                    s.readU30();
                    break;
                case 15 /* RTQName */:
                case 16 /* RTQNameA */:
                    s.readU30();
                    break;
                case 17 /* RTQNameL */:
                case 18 /* RTQNameLA */:
                    break;
                case 9 /* Multiname */:
                case 14 /* MultinameA */:
                    s.readU30();
                    s.readU30();
                    break;
                case 27 /* MultinameL */:
                case 28 /* MultinameLA */:
                    s.readU30();
                    break;
                case 29 /* TypeName */:
                    s.readU32();
                    var typeParameterCount = s.readU32();
                    release$1 || assert(typeParameterCount === 1); // This is probably the number of type
                    // parameters.
                    s.readU32();
                    break;
                default:
                    unexpected(kind);
                    break;
            }
        };
        ABCFile.prototype._parseMultinames = function () {
            var s = this._stream;
            var n = s.readU30();
            this._multinames = new Array(n);
            var multinameOffsets = this._multinameOffsets = new Uint32Array(n);
            multinameOffsets[0] = -1;
            for (var i = 1; i < n; i++) {
                multinameOffsets[i] = s.position;
                this._consumeMultiname();
            }
        };
        ABCFile.prototype._parseMultiname = function (i) {
            var stream = this._stream;
            var namespaceIsRuntime = false;
            var namespaceIndex;
            var useNamespaceSet = true;
            var nameIndex = 0;
            var kind = stream.readU8();
            switch (kind) {
                case 7 /* QName */:
                case 13 /* QNameA */:
                    namespaceIndex = stream.readU30();
                    useNamespaceSet = false;
                    nameIndex = stream.readU30();
                    break;
                case 15 /* RTQName */:
                case 16 /* RTQNameA */:
                    namespaceIsRuntime = true;
                    nameIndex = stream.readU30();
                    break;
                case 17 /* RTQNameL */:
                case 18 /* RTQNameLA */:
                    namespaceIsRuntime = true;
                    break;
                case 9 /* Multiname */:
                case 14 /* MultinameA */:
                    nameIndex = stream.readU30();
                    namespaceIndex = stream.readU30();
                    break;
                case 27 /* MultinameL */:
                case 28 /* MultinameLA */:
                    namespaceIndex = stream.readU30();
                    if (!release$1 && namespaceIndex === 0) {
                        // TODO: figure out what to do in this case. What would Tamarin do?
                        warning("Invalid multiname: namespace-set index is 0");
                    }
                    break;
                /**
                 * This is undocumented, looking at Tamarin source for this one.
                 */
                case 29 /* TypeName */:
                    var mn = stream.readU32();
                    var typeParameterCount = stream.readU32();
                    if (!release$1 && typeParameterCount !== 1) {
                        // TODO: figure out what to do in this case. What would Tamarin do?
                        warning("Invalid multiname: bad type parameter count " + typeParameterCount);
                    }
                    var typeParameter = this.getMultiname(stream.readU32());
                    var factory = this.getMultiname(mn);
                    return new Multiname(this, i, kind, factory.namespaces, factory.name, typeParameter);
                default:
                    unexpected();
                    break;
            }
            // A name index of 0 means that it's a runtime name.
            var name = nameIndex === 0 ? null : this.getString(nameIndex);
            var namespaces;
            if (namespaceIsRuntime) {
                namespaces = null;
            }
            else {
                namespaces = useNamespaceSet ?
                    this.getNamespaceSet(namespaceIndex) :
                    [this.getNamespace(namespaceIndex)];
            }
            return new Multiname(this, i, kind, namespaces, name);
        };
        ABCFile.prototype._checkMagic = function () {
            var magic = this._stream.readWord();
            var flashPlayerBrannan = 46 << 16 | 15;
            if (magic < flashPlayerBrannan) {
                this.env.app.sec.throwError('VerifierError', Errors$1.InvalidMagicError, magic >> 16, magic & 0xffff);
            }
        };
        /**
         * String duplicates exist in practice but are extremely rare.
         */
        ABCFile.prototype._checkForDuplicateStrings = function () {
            var a = [];
            for (var i = 0; i < this._strings.length; i++) {
                a.push(this.getString(i));
            }
            a.sort();
            for (var i = 0; i < a.length - 1; i++) {
                if (a[i] === a[i + 1]) {
                    return true;
                }
            }
            return false;
        };
        /**
         * Returns the string at the specified index in the string table.
         */
        ABCFile.prototype.getString = function (i) {
            release$1 || assert(i >= 0 && i < this._stringOffsets.length);
            var str = this._strings[i];
            if (str === undefined) {
                var s = this._stream;
                s.seek(this._stringOffsets[i]);
                var l = s.readU30();
                str = this._strings[i] = s.readUTFString(l);
            }
            return str;
        };
        /**
         * Returns the multiname at the specified index in the multiname table.
         */
        ABCFile.prototype.getMultiname = function (i) {
            if (i < 0 || i >= this._multinameOffsets.length) {
                this.applicationDomain.sec.throwError("VerifierError", Errors$1.CpoolIndexRangeError, i, this._multinameOffsets.length);
            }
            if (i === 0) {
                return null;
            }
            var mn = this._multinames[i];
            if (mn === undefined) {
                var s = this._stream;
                s.seek(this._multinameOffsets[i]);
                mn = this._multinames[i] = this._parseMultiname(i);
            }
            return mn;
        };
        /**
         * Returns the namespace at the specified index in the namespace table.
         */
        ABCFile.prototype.getNamespace = function (i) {
            if (i < 0 || i >= this._namespaceOffsets.length) {
                this.applicationDomain.sec.throwError("VerifierError", Errors$1.CpoolIndexRangeError, i, this._namespaceOffsets.length);
            }
            if (i === 0) {
                return Namespace.PUBLIC;
            }
            var ns = this._namespaces[i];
            if (ns !== undefined) {
                return ns;
            }
            var s = this._stream;
            s.seek(this._namespaceOffsets[i]);
            var kind = s.readU8();
            var uriIndex = s.readU30();
            var uri = uriIndex ? this.getString(uriIndex) : undefined;
            var type;
            switch (kind) {
                case 8 /* Namespace */:
                case 22 /* PackageNamespace */:
                    type = 0 /* Public */;
                    break;
                case 23 /* PackageInternalNs */:
                    type = 2 /* PackageInternal */;
                    break;
                case 24 /* ProtectedNamespace */:
                    type = 1 /* Protected */;
                    break;
                case 25 /* ExplicitNamespace */:
                    type = 4 /* Explicit */;
                    break;
                case 26 /* StaticProtectedNs */:
                    type = 5 /* StaticProtected */;
                    break;
                case 5 /* PrivateNs */:
                    type = 3 /* Private */;
                    break;
                default:
                    this.applicationDomain.sec.throwError("VerifierError", Errors$1.CpoolEntryWrongTypeError, i);
            }
            if (uri && type !== 3 /* Private */) {
                // TODO: deal with API versions here. Those are suffixed to the uri. We used to
                // just strip them out, but we also had an assert against them occurring at all,
                // so it might be the case that we don't even need to do anything at all.
            }
            else if (uri === undefined) {
                // Only private namespaces gets the empty string instead of undefined. A comment
                // in Tamarin source code indicates this might not be intentional, but oh well.
                uri = '';
            }
            ns = this._namespaces[i] = internNamespace(type, uri);
            return ns;
        };
        /**
         * Returns the namespace set at the specified index in the namespace set table.
         */
        ABCFile.prototype.getNamespaceSet = function (i) {
            if (i < 0 || i >= this._namespaceSets.length) {
                this.applicationDomain.sec.throwError("VerifierError", Errors$1.CpoolIndexRangeError, i, this._namespaceSets.length);
            }
            if (i === 0) {
                return null;
            }
            var nss = this._namespaceSets[i];
            if (nss === undefined) {
                var s = this._stream;
                var o = this._namespaceSetOffsets[i];
                s.seek(o);
                var c = s.readU30(); // Count
                nss = this._namespaceSets[i] = new Array(c);
                o = s.position;
                for (var j = 0; j < c; j++) {
                    s.seek(o);
                    var x = s.readU30();
                    o = s.position; // The call to |getNamespace| can change our current position.
                    nss[j] = this.getNamespace(x);
                }
            }
            return nss;
        };
        ABCFile.prototype._parseMethodInfos = function () {
            var s = this._stream;
            var n = s.readU30();
            this._methods = new Array(n);
            this._methodInfoOffsets = new Uint32Array(n);
            for (var i = 0; i < n; ++i) {
                this._methodInfoOffsets[i] = s.position;
                this._consumeMethodInfo();
            }
        };
        ABCFile.prototype._consumeMethodInfo = function () {
            var s = this._stream;
            var parameterCount = s.readU30();
            s.readU30(); // Return Type
            var parameterOffset = s.position;
            for (var i = 0; i < parameterCount; i++) {
                s.readU30();
            }
            var nm = s.readU30();
            var flags = s.readU8();
            if (flags & 8 /* HasOptional */) {
                var optionalCount = s.readU30();
                release$1 || assert(parameterCount >= optionalCount);
                for (var i = parameterCount - optionalCount; i < parameterCount; i++) {
                    s.readU30(); // Value Index
                    s.readU8(); // Value Kind
                }
            }
            if (flags & 128 /* HasParamNames */) {
                for (var i = 0; i < parameterCount; i++) {
                    s.readU30();
                }
            }
        };
        ABCFile.prototype._parseMethodInfo = function (j) {
            var s = this._stream;
            var parameterCount = s.readU30();
            var returnType = s.readU30();
            var parameterOffset = s.position;
            var parameters = new Array(parameterCount);
            for (var i = 0; i < parameterCount; i++) {
                parameters[i] = new ParameterInfo(this, s.readU30(), 0, -1, -1);
            }
            var name = s.readU30();
            var flags = s.readU8();
            var optionalCount = 0;
            if (flags & 8 /* HasOptional */) {
                optionalCount = s.readU30();
                release$1 || assert(parameterCount >= optionalCount);
                for (var i = parameterCount - optionalCount; i < parameterCount; i++) {
                    parameters[i].optionalValueIndex = s.readU30();
                    parameters[i].optionalValueKind = s.readU8();
                }
            }
            if (flags & 128 /* HasParamNames */) {
                for (var i = 0; i < parameterCount; i++) {
                    // NOTE: We can't get the parameter name as described in the spec because some SWFs have
                    // invalid parameter names. Tamarin ignores parameter names and so do we.
                    parameters[i].name = s.readU30();
                }
            }
            return new MethodInfo(this, j, name, returnType, parameters, optionalCount, flags);
        };
        /**
         * Returns the method info at the specified index in the method info table.
         */
        ABCFile.prototype.getMethodInfo = function (i) {
            release$1 || assert(i >= 0 && i < this._methodInfoOffsets.length);
            var mi = this._methods[i];
            if (mi === undefined) {
                var s = this._stream;
                s.seek(this._methodInfoOffsets[i]);
                mi = this._methods[i] = this._parseMethodInfo(i);
            }
            return mi;
        };
        ABCFile.prototype.getMethodBodyInfo = function (i) {
            return this._methodBodies[i];
        };
        ABCFile.prototype._parseMetaData = function () {
            var s = this._stream;
            var n = s.readU30();
            this._metadata = new Array(n);
            var metadataInfoOffsets = this._metadataInfoOffsets = new Uint32Array(n);
            for (var i = 0; i < n; i++) {
                metadataInfoOffsets[i] = s.position;
                s.readU30(); // Name
                var itemCount = s.readU30(); // Item Count
                for (var j = 0; j < itemCount; j++) {
                    s.readU30();
                    s.readU30();
                }
            }
        };
        ABCFile.prototype.getMetadataInfo = function (i) {
            release$1 || assert(i >= 0 && i < this._metadata.length);
            var mi = this._metadata[i];
            if (mi === undefined) {
                var s = this._stream;
                s.seek(this._metadataInfoOffsets[i]);
                var name = s.readU30(); // Name
                var itemCount = s.readU30(); // Item Count
                var keys = new Uint32Array(itemCount);
                for (var j = 0; j < itemCount; j++) {
                    keys[j] = s.readU30();
                }
                var values = new Uint32Array(itemCount);
                for (var j = 0; j < itemCount; j++) {
                    values[j] = s.readU30();
                }
                mi = this._metadata[i] = new MetadataInfo(this, name, keys, values);
            }
            return mi;
        };
        ABCFile.prototype._parseInstanceAndClassInfos = function () {
            var s = this._stream;
            var n = s.readU30();
            var instances = this.instances = new Array(n);
            for (var i = 0; i < n; i++) {
                instances[i] = this._parseInstanceInfo();
            }
            this._parseClassInfos(n);
            var o = s.position;
            for (var i = 0; i < n; i++) {
                instances[i].classInfo = this.classes[i];
            }
            s.seek(o);
        };
        ABCFile.prototype._parseInstanceInfo = function () {
            var s = this._stream;
            var name = s.readU30();
            var superName = s.readU30();
            var flags = s.readU8();
            var protectedNsIndex = 0;
            if (flags & 8 /* ClassProtectedNs */) {
                protectedNsIndex = s.readU30();
            }
            var interfaceCount = s.readU30();
            var interfaces = [];
            for (var i = 0; i < interfaceCount; i++) {
                interfaces[i] = s.readU30();
            }
            var initializer = s.readU30();
            var traits = this._parseTraits();
            var instanceInfo = new InstanceInfo(this, name, superName, flags, protectedNsIndex, interfaces, initializer, traits);
            traits.attachHolder(instanceInfo);
            return instanceInfo;
        };
        ABCFile.prototype._parseTraits = function () {
            var s = this._stream;
            var n = s.readU30();
            var traits = [];
            for (var i = 0; i < n; i++) {
                traits.push(this._parseTrait());
            }
            return new Traits(traits);
        };
        ABCFile.prototype._parseTrait = function () {
            var s = this._stream;
            var name = s.readU30();
            var tag = s.readU8();
            var kind = tag & 0x0F;
            var attributes = (tag >> 4) & 0x0F;
            var trait;
            switch (kind) {
                case 0 /* Slot */:
                case 6 /* Const */:
                    var slot = s.readU30();
                    var type = s.readU30();
                    var valueIndex = s.readU30();
                    var valueKind = -1;
                    if (valueIndex !== 0) {
                        valueKind = s.readU8();
                    }
                    trait = new SlotTraitInfo(this, kind, name, slot, type, valueKind, valueIndex);
                    break;
                case 1 /* Method */:
                case 2 /* Getter */:
                case 3 /* Setter */:
                    var dispID = s.readU30(); // Tamarin optimization.
                    var methodInfoIndex = s.readU30();
                    var o = s.position;
                    var methodInfo = this.getMethodInfo(methodInfoIndex);
                    trait = methodInfo.trait = new MethodTraitInfo(this, kind, name, methodInfo);
                    s.seek(o);
                    break;
                case 4 /* Class */:
                    var slot = s.readU30();
                    var classInfo = this.classes[s.readU30()];
                    trait = classInfo.trait = new ClassTraitInfo(this, kind, name, slot, classInfo);
                    break;
                default:
                    this.applicationDomain.sec.throwError("VerifierError", Errors$1.UnsupportedTraitsKindError, kind);
            }
            if (attributes & 4 /* Metadata */) {
                var n = s.readU30();
                var metadata = new Uint32Array(n);
                for (var i = 0; i < n; i++) {
                    metadata[i] = s.readU30();
                }
                trait.metadata = metadata;
            }
            return trait;
        };
        ABCFile.prototype._parseClassInfos = function (n) {
            var s = this._stream;
            var classes = this.classes = new Array(n);
            for (var i = 0; i < n; i++) {
                classes[i] = this._parseClassInfo(i);
            }
        };
        ABCFile.prototype._parseClassInfo = function (i) {
            var s = this._stream;
            var initializer = s.readU30();
            var traits = this._parseTraits();
            var classInfo = new ClassInfo(this, this.instances[i], initializer, traits);
            traits.attachHolder(classInfo);
            return classInfo;
        };
        ABCFile.prototype._parseScriptInfos = function () {
            var s = this._stream;
            var n = s.readU30();
            var scripts = this.scripts = new Array(n);
            for (var i = 0; i < n; i++) {
                scripts[i] = this._parseScriptInfo();
            }
        };
        ABCFile.prototype._parseScriptInfo = function () {
            var s = this._stream;
            var initializer = s.readU30();
            var traits = this._parseTraits();
            var scriptInfo = new ScriptInfo(this, initializer, traits);
            traits.attachHolder(scriptInfo);
            return scriptInfo;
        };
        ABCFile.prototype._parseMethodBodyInfos = function () {
            var s = this._stream;
            var methodBodies = this._methodBodies = new Array(this._methods.length);
            var n = s.readU30();
            var o = s.position;
            for (var i = 0; i < n; i++) {
                var methodInfo = s.readU30();
                var maxStack = s.readU30();
                var localCount = s.readU30();
                var initScopeDepth = s.readU30();
                var maxScopeDepth = s.readU30();
                var code = s.viewU8s(s.readU30());
                var e = s.readU30();
                var exceptions = new Array(e);
                for (var j = 0; j < e; ++j) {
                    exceptions[j] = this._parseException();
                }
                var traits = this._parseTraits();
                methodBodies[methodInfo] = new MethodBodyInfo(maxStack, localCount, initScopeDepth, maxScopeDepth, code, exceptions, traits);
                traits.attachHolder(methodBodies[methodInfo]);
            }
        };
        ABCFile.prototype._parseException = function () {
            var s = this._stream;
            var start = s.readU30();
            var end = s.readU30();
            var target = s.readU30();
            var type = s.readU30();
            var varName = s.readU30();
            return new ExceptionInfo(this, start, end, target, type, varName);
        };
        ABCFile.prototype.getConstant = function (kind, i) {
            switch (kind) {
                case 3 /* Int */:
                    return this.ints[i];
                case 4 /* UInt */:
                    return this.uints[i];
                case 6 /* Double */:
                    return this.doubles[i];
                case 1 /* Utf8 */:
                    return this.getString(i);
                case 11 /* True */:
                    return true;
                case 10 /* False */:
                    return false;
                case 12 /* Null */:
                    return null;
                case 0 /* Undefined */:
                    return undefined;
                case 8 /* Namespace */:
                case 23 /* PackageInternalNs */:
                    return this.getNamespace(i);
                case 7 /* QName */:
                case 14 /* MultinameA */:
                case 15 /* RTQName */:
                case 16 /* RTQNameA */:
                case 17 /* RTQNameL */:
                case 18 /* RTQNameLA */:
                case 19 /* NameL */:
                case 20 /* NameLA */:
                    return this.getMultiname(i);
                case 2 /* Float */:
                    warning("TODO: CONSTANT.Float may be deprecated?");
                    break;
                default:
                    release$1 || assert(false, "Not Implemented Kind " + kind);
            }
        };
        ABCFile.prototype.stress = function () {
            for (var i = 0; i < this._multinames.length; i++) {
                this.getMultiname(i);
            }
            for (var i = 0; i < this._namespaceSets.length; i++) {
                this.getNamespaceSet(i);
            }
            for (var i = 0; i < this._namespaces.length; i++) {
                this.getNamespace(i);
            }
            for (var i = 0; i < this._strings.length; i++) {
                this.getString(i);
            }
        };
        ABCFile.prototype.trace = function (writer) {
            writer.writeLn("Multinames: " + this._multinames.length);
            {
                writer.indent();
                for (var i = 0; i < this._multinames.length; i++) {
                    writer.writeLn(i + " " + this.getMultiname(i));
                }
                writer.outdent();
            }
            writer.writeLn("Namespace Sets: " + this._namespaceSets.length);
            {
                writer.indent();
                for (var i = 0; i < this._namespaceSets.length; i++) {
                    writer.writeLn(i + " " + this.getNamespaceSet(i));
                }
                writer.outdent();
            }
            writer.writeLn("Namespaces: " + this._namespaces.length);
            {
                writer.indent();
                for (var i = 0; i < this._namespaces.length; i++) {
                    writer.writeLn(i + " " + this.getNamespace(i));
                }
                writer.outdent();
            }
            writer.writeLn("Strings: " + this._strings.length);
            {
                writer.indent();
                for (var i = 0; i < this._strings.length; i++) {
                    writer.writeLn(i + " " + this.getString(i));
                }
                writer.outdent();
            }
            writer.writeLn("MethodInfos: " + this._methods.length);
            {
                writer.indent();
                for (var i = 0; i < this._methods.length; i++) {
                    writer.writeLn(i + " " + this.getMethodInfo(i));
                    if (this._methodBodies[i]) {
                        this._methodBodies[i].trace(writer);
                    }
                }
                writer.outdent();
            }
            writer.writeLn("InstanceInfos: " + this.instances.length);
            {
                writer.indent();
                for (var i = 0; i < this.instances.length; i++) {
                    writer.writeLn(i + " " + this.instances[i]);
                    this.instances[i].trace(writer);
                }
                writer.outdent();
            }
            writer.writeLn("ClassInfos: " + this.classes.length);
            {
                writer.indent();
                for (var i = 0; i < this.classes.length; i++) {
                    this.classes[i].trace(writer);
                }
                writer.outdent();
            }
            writer.writeLn("ScriptInfos: " + this.scripts.length);
            {
                writer.indent();
                for (var i = 0; i < this.scripts.length; i++) {
                    this.scripts[i].trace(writer);
                }
                writer.outdent();
            }
        };
        return ABCFile;
    }());

    var FlashSceneGraphFactory = /** @class */ (function (_super) {
        __extends(FlashSceneGraphFactory, _super);
        function FlashSceneGraphFactory(sec) {
            var _this = _super.call(this) || this;
            _this.imageStore = {};
            _this.url = "";
            _this._sec = sec;
            return _this;
        }
        FlashSceneGraphFactory.prototype.executeABCBytes = function (abcBlocks) {
            for (var i = 0; i < abcBlocks.length; i++) {
                var abcBlock = abcBlocks[i];
                var abc = new ABCFile({ app: this._sec.application, url: "" }, abcBlock.data);
                if (abcBlock.flags) {
                    // kDoAbcLazyInitializeFlag = 1 Indicates that the ABC block should not be executed
                    // immediately.
                    this._sec.application.loadABC(abc);
                }
                else {
                    // TODO: probably delay execution until playhead reaches the frame.
                    this._sec.application.loadAndExecuteABC(abc);
                }
            }
            return null;
        };
        FlashSceneGraphFactory.prototype.createSprite = function (prefab, graphics, symbol) {
            if (prefab === void 0) { prefab = null; }
            if (graphics === void 0) { graphics = null; }
            if (symbol === void 0) { symbol = null; }
            if (!symbol || !this._sec)
                throw ("no symbol provided");
            var symbolClass = null;
            if (symbol.className)
                symbolClass = this._sec.application.getClass(Multiname.FromFQNString(symbol.className, 0 /* Public */));
            else
                symbolClass = this._sec.flash.display.Sprite.axClass;
            symbol.symbolClass = symbolClass;
            //Graphicsadapter.currentAwayGraphics=graphics;
            // create the root for the root-symbol
            var asObj = constructClassFromSymbol(symbol, symbolClass);
            asObj.adaptee = new Sprite(graphics);
            // manually call the axInitializer for now:
            //asObj.axInitializer(AwaySprite.getNewSprite(new this._sec.flash.display.Graphics(graphics).adaptee));
            asObj.adaptee["fileurl"] = this.url;
            return asObj.adaptee;
        };
        FlashSceneGraphFactory.prototype.createDisplayObjectContainer = function (symbol) {
            if (symbol === void 0) { symbol = null; }
            return new this._sec.flash.display.DisplayObjectContainer().adaptee;
        };
        FlashSceneGraphFactory.prototype.createBinarySymbol = function (symbol) {
            if (symbol === void 0) { symbol = null; }
            this._sec.application.addBinarySymbol(symbol);
        };
        FlashSceneGraphFactory.prototype.createMovieClip = function (timeline, symbol) {
            if (timeline === void 0) { timeline = null; }
            if (symbol === void 0) { symbol = null; }
            if (!symbol || !this._sec)
                throw ("no symbol provided");
            var symbolClass = null;
            if (symbol.className) {
                symbolClass = this._sec.application.getClass(Multiname.FromFQNString(symbol.className, 0 /* Public */));
                symbolClass._symbol = symbol;
            }
            else
                symbolClass = this._sec.flash.display.MovieClip.axClass;
            //console.log("parsed symbolClass", symbolClass, symbol);
            symbol.symbolClass = symbolClass;
            // create the root for the root-symbol
            var asObj = constructClassFromSymbol(symbol, this._sec.flash.display.MovieClip.axClass);
            asObj.adaptee = new MovieClip();
            symbol.timeline = asObj.adaptee.timeline;
            //(<AwayMovieClip>asObj.adaptee).timeline.resetScripts();
            //(<any>asObj).axInitializer();
            asObj.adaptee.timelineMC = true;
            asObj.adaptee["fileurl"] = this.url;
            return asObj.adaptee;
        };
        FlashSceneGraphFactory.prototype.createTextField = function (symbol) {
            if (symbol === void 0) { symbol = null; }
            var symbolClass = null;
            if (symbol.className)
                symbolClass = this._sec.application.getClass(Multiname.FromFQNString(symbol.className, 0 /* Public */));
            else
                symbolClass = this._sec.flash.text.TextField.axClass;
            symbol.symbolClass = symbolClass;
            // create the root for the root-symbol
            var asObj = constructClassFromSymbol(symbol, symbolClass);
            // 	manually call the axInitializer - this will run the constructor
            //	creating new Away-MovieClip and timeline, and registers framescripts on the timeline:
            asObj.axInitializer();
            asObj.adaptee["fileurl"] = this.url;
            return asObj.adaptee;
        };
        FlashSceneGraphFactory.prototype.createBillboard = function (material, symbol) {
            if (symbol === void 0) { symbol = null; }
            return new Bitmap(material.style.image.adapter).adaptee;
        };
        FlashSceneGraphFactory.prototype.createImage2D = function (width, height, transparent, fillColor, powerOfTwo, symbol) {
            if (transparent === void 0) { transparent = true; }
            if (fillColor === void 0) { fillColor = null; }
            if (powerOfTwo === void 0) { powerOfTwo = true; }
            if (symbol === void 0) { symbol = null; }
            return new BitmapData(width, height, transparent, fillColor).adaptee;
        };
        return FlashSceneGraphFactory;
    }(DefaultSceneGraphFactory));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: UncaughtErrorEvents
    var UncaughtErrorEvents = /** @class */ (function (_super) {
        __extends(UncaughtErrorEvents, _super);
        function UncaughtErrorEvents() {
            return _super.call(this) || this;
        }
        UncaughtErrorEvents.classInitializer = null;
        UncaughtErrorEvents.classSymbols = null;
        UncaughtErrorEvents.instanceSymbols = null;
        return UncaughtErrorEvents;
    }(EventDispatcher$1));

    // todo: define all methods (start new with converting as3-Loader to ts ?)
    var Loader$1 = /** @class */ (function (_super) {
        __extends(Loader$$1, _super);
        function Loader$$1(parser) {
            var _this = _super.call(this) || this;
            _this._onLoaderProgressDelegate = function (event) { return _this.onLoaderProgress(event); };
            _this._onLoaderCompleteDelegate = function (event) { return _this.onLoaderComplete(event); };
            _this._onAssetCompleteDelegate = function (event) { return _this.onAssetComplete(event); };
            _this._parser = parser;
            _this._loaderInfo = new _this.sec.flash.display.LoaderInfo();
            _this._loaderInfo._loader = _this;
            _this._factory = new FlashSceneGraphFactory(null);
            return _this;
        }
        Object.defineProperty(Loader$$1.prototype, "content", {
            // for AVM1:
            get: function () {
                return this._content;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Loader$$1.prototype, "uncaughtErrorEvents", {
            get: function () {
                release$1 || somewhatImplemented("public flash.display.Loader::uncaughtErrorEvents");
                if (!this._uncaughtErrorEvents) {
                    this._uncaughtErrorEvents = new UncaughtErrorEvents();
                }
                return this._uncaughtErrorEvents;
            },
            enumerable: true,
            configurable: true
        });
        Loader$$1.prototype.onLoaderProgress = function (event) {
            var newEvent = new ProgressEvent(ProgressEvent.PROGRESS, null, null, event.urlLoader.bytesLoaded, event.urlLoader.bytesTotal);
            newEvent.currentTarget = this._loaderInfo;
            this._loaderInfo.dispatchEventInternal(newEvent);
        };
        Loader$$1.prototype.onLoaderComplete = function (event) {
            var newEvent = new Event(Event.COMPLETE);
            newEvent.currentTarget = this._loaderInfo;
            this._loaderInfo.dispatchEventInternal(newEvent);
            this._loader.removeEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoaderCompleteDelegate);
            this._loader.removeEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            this._loader = null;
            //AssetLibrary.removeEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoaderCompleteDelegate);
            //AssetLibrary.removeEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
        };
        Loader$$1.prototype.onAssetComplete = function (event) {
            // 	todo: take care of all needed asset-types (sounds / fonts / textfield)
            //	todo: update awd to support as3-class-identifier as extra property. 
            //  atm the name of the exported symbols will be the as3-class name, 
            //  and all exported symbols are handled as if exposed to as3
            var asset = event.asset;
            if (asset.isAsset(TextField)) {
                this._loaderContext.applicationDomain.addDefinition(asset.name, asset);
            }
            else if (asset.isAsset(SceneImage2D) || asset.isAsset(BitmapImage2D)) {
                this._loaderContext.applicationDomain.addDefinition(asset.name, asset);
                // we should only do this for bitmaps loaded from jpg or png
                if (this._isImage)
                    this._adaptee.addChild(new Bitmap(asset.adapter).adaptee);
                //this.addChild(this._loaderInfo.content = new Bitmap(<BitmapData> (<SceneImage2D> asset).adapter));
            }
            else if (asset.isAsset(WaveAudio)) {
                this._loaderContext.applicationDomain.addAudioDefinition(asset.name, asset);
            }
            else if (asset.isAsset(Font)) {
                this._loaderContext.applicationDomain.addFontDefinition(asset.name, asset);
            }
            else if (asset.isAsset(Sprite)) {
                //if((<AwaySprite> asset).material)
                //	(<AwaySprite> asset).material.bothSides=false;
                this._loaderContext.applicationDomain.addDefinition(asset.name, asset);
            }
            else if (asset.isAsset(MovieClip)) {
                this._loaderContext.applicationDomain.addDefinition(asset.name, asset);
                // if this is the "Scene 1", we make it a child of the loader
                if (asset.name == "Scene 1" || asset.isAVMScene) { // "Scene 1" when AWDParser, isAVMScene when using SWFParser
                    var newClone = asset.adapter.clone();
                    newClone.loaderInfo = this.loaderInfo;
                    newClone.adaptee.reset();
                    this.addChild(newClone);
                    //this.addChild(this._loaderInfo.content = (<MovieClip>(<AwayMovieClip>asset).adapter));
                }
            }
            else if (asset.isAsset(Graphics)) {
            }
            else {
                console.log("loaded unhandled asset-type");
            }
        };
        Loader$$1.prototype.addChild = function (child) {
            return _super.prototype.addChild.call(this, child);
        };
        Loader$$1.prototype.addChildAt = function (child, index) {
            this.sec.throwError('IllegalOperationError', Errors$1.InvalidLoaderMethodError);
            return null;
        };
        Loader$$1.prototype.removeChild = function (child) {
            this.sec.throwError('IllegalOperationError', Errors$1.InvalidLoaderMethodError);
            return null;
        };
        Loader$$1.prototype.removeChildAt = function (index) {
            this.sec.throwError('IllegalOperationError', Errors$1.InvalidLoaderMethodError);
            return null;
        };
        Loader$$1.prototype.setChildIndex = function (child, index) {
            this.sec.throwError('IllegalOperationError', Errors$1.InvalidLoaderMethodError);
        };
        Loader$$1.prototype.load = function (url, context) {
            if (context === void 0) { context = null; }
            console.log("start loading the url:" + url.url);
            var ext = url.url.substr(-3);
            this._isImage = (ext == "jpg" || ext == "png");
            //url.url=url.url.replace(".swf", ".awd");
            this._loaderContext = context;
            this._loaderInfo.applicationDomain = context.applicationDomain;
            this._loader = new Loader();
            this._loader.addEventListener(URLLoaderEvent.LOAD_PROGRESS, this._onLoaderProgressDelegate);
            this._loader.addEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoaderCompleteDelegate);
            this._loader.addEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            this._loader.load(url.adaptee, null, null, (this._isImage) ? new Image2DParser(this._factory) : this._parser);
        };
        Loader$$1.prototype.loadData = function (buffer, context) {
            if (context === void 0) { context = null; }
            console.log("start loading swfdata", buffer);
            this._loaderContext = context;
            this._loaderInfo.applicationDomain = context.applicationDomain;
            this._loader = new Loader();
            this._loader.addEventListener(URLLoaderEvent.LOAD_PROGRESS, this._onLoaderProgressDelegate);
            this._loader.addEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoaderCompleteDelegate);
            this._loader.addEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            this._loader.loadData(buffer, null, null, null, this._parser);
        };
        Loader$$1.prototype.loadBytes = function (data, context) {
            this.close();
            console.log("80pro todo: loader.loadBytes");
            /*
            // TODO: properly coerce object arguments to their types.
            var loaderClass = Loader.axClass;
            // In case this is the initial root loader, we won't have a loaderInfo object. That should
            // only happen in the inspector when a file is loaded from a Blob, though.
            this._contentLoaderInfo._url = (this.loaderInfo ? this.loaderInfo._url : '') +
                                            '/[[DYNAMIC]]/' + (++loaderClass._embeddedContentLoadCount);
            this._applyLoaderContext(context);
            this._loadingType = LoadingType.Bytes;
            this._fileLoader = new FileLoader(this, this._contentLoaderInfo);
            this._queuedLoadUpdate = null;
            if (!release && traceLoaderOption.value) {
                console.log("Loading embedded symbol " + this._contentLoaderInfo._url);
            }
            // Just passing in the bytes won't do, because the buffer can contain slop at the end.
            this._fileLoader.loadBytes(new Uint8Array((<any>data).bytes, 0, data.length));

            release || assert(loaderClass._loadQueue.indexOf(this) === -1);
            loaderClass._loadQueue.push(this);
            */
        };
        Loader$$1.prototype.close = function () {
            console.log("80pro todo: loader.close");
            // var queueIndex = Loader.axClass._loadQueue.indexOf(this);
            // if (queueIndex > -1) {
            //   Loader.axClass._loadQueue.splice(queueIndex, 1);
            // }
            // this._contentLoaderInfo.reset();
            // if (!this._fileLoader) {
            //   return;
            // }
            // this._fileLoader.abortLoad();
            // this._fileLoader = null;
        };
        Loader$$1.prototype._unload = function (stopExecution, gc) {
            console.log("80pro todo: loader._unload");
            // if (this._loadStatus < LoadStatus.Initialized) {
            //   this._loadStatus = LoadStatus.Unloaded;
            //   return;
            // }
            // this.close();
            // this._content = null;
            // this._contentLoaderInfo._loader = null;
            // this._loadStatus = LoadStatus.Unloaded;
            // this.dispatchEvent(Event.axClass.getInstance(Event.UNLOAD));
        };
        Loader$$1.prototype.unload = function () {
            this._unload(false, false);
        };
        Loader$$1.prototype.unloadAndStop = function (gc) {
            // TODO: remove all DisplayObjects originating from the unloaded SWF from all lists and stop
            // them.
            this._unload(true, !!gc);
        };
        Object.defineProperty(Loader$$1.prototype, "contentLoaderInfo", {
            get: function () {
                return this._loaderInfo;
            },
            set: function (value) {
                this._loaderInfo = value;
            },
            enumerable: true,
            configurable: true
        });
        return Loader$$1;
    }(DisplayObjectContainer$1));

    var TextEvent = /** @class */ (function (_super) {
        __extends(TextEvent, _super);
        function TextEvent(type, bubbles, cancelable, text) {
            if (bubbles === void 0) { bubbles = false; }
            if (cancelable === void 0) { cancelable = false; }
            if (text === void 0) { text = ""; }
            var _this = _super.call(this, type, bubbles, cancelable) || this;
            _this._text = text;
            return _this;
        }
        Object.defineProperty(TextEvent.prototype, "text", {
            get: function () {
                return this._text;
            },
            set: function (value) {
                this._text = value;
            },
            enumerable: true,
            configurable: true
        });
        TextEvent.prototype.clone = function () {
            console.log("clone not implemented yet in flash/IOErrorEvent");
            return null;
        };
        TextEvent.prototype.toString = function () {
            console.log("toString not implemented yet in flash/IOErrorEvent");
            return "";
        };
        TextEvent.LINK = "link";
        TextEvent.TEXT_INPUT = "textInput";
        TextEvent.NETWORK_ERROR = "networkError";
        TextEvent.VERIFY_ERROR = "verifyError";
        return TextEvent;
    }(Event));

    var ErrorEvent = /** @class */ (function (_super) {
        __extends(ErrorEvent, _super);
        function ErrorEvent(type, bubbles, cancelable, text, id) {
            if (bubbles === void 0) { bubbles = false; }
            if (cancelable === void 0) { cancelable = false; }
            if (text === void 0) { text = ""; }
            if (id === void 0) { id = 0; }
            return _super.call(this, type, bubbles, cancelable, text) || this;
        }
        Object.defineProperty(ErrorEvent.prototype, "errorID", {
            get: function () {
                console.log("errorID not implemented yet in flash/ErrorEvent");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        ErrorEvent.prototype.clone = function () {
            console.log("clone not implemented yet in flash/ErrorEvent");
            return null;
        };
        ErrorEvent.prototype.toString = function () {
            console.log("toString not implemented yet in flash/ErrorEvent");
            return "";
        };
        ErrorEvent.ERROR = "error";
        return ErrorEvent;
    }(TextEvent));

    var IOErrorEvent = /** @class */ (function (_super) {
        __extends(IOErrorEvent, _super);
        function IOErrorEvent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        IOErrorEvent.prototype.clone = function () {
            console.log("clone not implemented yet in flash/IOErrorEvent");
            return null;
        };
        IOErrorEvent.prototype.toString = function () {
            console.log("toString not implemented yet in flash/IOErrorEvent");
            return "";
        };
        IOErrorEvent.IO_ERROR = "ioError";
        IOErrorEvent.DISK_ERROR = "diskError";
        IOErrorEvent.NETWORK_ERROR = "networkError";
        IOErrorEvent.VERIFY_ERROR = "verifyError";
        return IOErrorEvent;
    }(ErrorEvent));

    /**
     * Dispatched when a network request is made over HTTP and an HTTP status code can be detected.
     * @eventType	flash.events.HTTPStatusEvent.HTTP_STATUS

    [Event(name="httpStatus", type="flash.events.HTTPStatusEvent")]

     * Dispatched by a LoaderInfo object whenever a loaded object is removed by using the unload()
     * method of the Loader object, or when a second load is performed by the same Loader object and the
     * original content is removed prior to the load beginning.
     * @eventType	flash.events.Event.UNLOAD

    [Event(name="unload", type="flash.events.Event")]

     * Dispatched when data is received as the download operation progresses.
     * @eventType	flash.events.ProgressEvent.PROGRESS
     
    [Event(name="progress", type="flash.events.ProgressEvent")]

     * Dispatched when a load operation starts.
     * @eventType	flash.events.Event.OPEN

    [Event(name="open", type="flash.events.Event")]

     * Dispatched when an input or output error occurs that causes a load operation to fail.
     * @eventType	flash.events.IOErrorEvent.IO_ERROR
     
    [Event(name="ioError", type="flash.events.IOErrorEvent")]

     * Dispatched when the properties and methods of a loaded SWF file are
     * accessible and ready for use.
     * @eventType	flash.events.Event.INIT
     
    [Event(name="init", type="flash.events.Event")]

     * Dispatched when data has loaded successfully.
     * @eventType	flash.events.Event.COMPLETE
     
    [Event(name="complete", type="flash.events.Event")]

     * The LoaderInfo class provides information about a loaded SWF file or a loaded image file
     * (JPEG, GIF, or PNG).  LoaderInfo objects are available for any display object.
     * The information provided includes load progress, the URLs of the loader and
     * loaded content, the number of bytes total for the media, and the nominal height and width of the
     * media.
     *
     *   <p class="- topic/p ">You can access LoaderInfo objects in two ways: </p><ul class="- topic/ul "><li class="- topic/li ">The <codeph class="+ topic/ph pr-d/codeph ">contentLoaderInfo</codeph> property of a flash.display.Loader object—
     * The <codeph class="+ topic/ph pr-d/codeph ">contentLoaderInfo</codeph> property is always available for any Loader object.
     * For a Loader object that has not called the <codeph class="+ topic/ph pr-d/codeph ">load()</codeph> or <codeph class="+ topic/ph pr-d/codeph ">loadBytes()</codeph>
     * method, or that has not sufficiently loaded, attempting to access many of the properties of the
     * <codeph class="+ topic/ph pr-d/codeph ">contentLoaderInfo</codeph> property throws an error.</li><li class="- topic/li ">The <codeph class="+ topic/ph pr-d/codeph ">loaderInfo</codeph> property of a display object. </li></ul><p class="- topic/p ">The <codeph class="+ topic/ph pr-d/codeph ">contentLoaderInfo</codeph> property of a Loader object provides information about
     * the content that the Loader object is loading, whereas the <codeph class="+ topic/ph pr-d/codeph ">loaderInfo</codeph> property of
     * a DisplayObject provides information about the root SWF file for that display object. </p><p class="- topic/p ">When you use a Loader object to load a display object (such as a SWF file or a bitmap), the
     * <codeph class="+ topic/ph pr-d/codeph ">loaderInfo</codeph> property of the display object is the same as the <codeph class="+ topic/ph pr-d/codeph ">contentLoaderInfo</codeph>
     * property of the Loader object (<codeph class="+ topic/ph pr-d/codeph ">DisplayObject.loaderInfo = Loader.contentLoaderInfo</codeph>).
     * Because the instance of the main class of the SWF file has
     * no Loader object, the <codeph class="+ topic/ph pr-d/codeph ">loaderInfo</codeph> property is the only way to
     * access the LoaderInfo for the instance of the main class of the SWF file.</p><p class="- topic/p ">The following diagram shows the different uses of the LoaderInfo object—for the instance of the main class of
     * the SWF file, for the <codeph class="+ topic/ph pr-d/codeph ">contentLoaderInfo</codeph> property of a Loader object, and for the <codeph class="+ topic/ph pr-d/codeph ">loaderInfo</codeph>
     * property of a loaded object:</p><p class="- topic/p "><adobeimage alt="An image of different LoaderInfo situations" href="../../images/loaderInfo_object.jpg" placement="inline" class="+ topic/image adobe-d/adobeimage " /></p><p class="- topic/p ">When a loading operation is not complete, some properties of the <codeph class="+ topic/ph pr-d/codeph ">contentLoaderInfo</codeph>
     * property of a Loader object are not available.  You can obtain some properties, such as
     * <codeph class="+ topic/ph pr-d/codeph ">bytesLoaded</codeph>, <codeph class="+ topic/ph pr-d/codeph ">bytesTotal</codeph>, <codeph class="+ topic/ph pr-d/codeph ">url</codeph>, <codeph class="+ topic/ph pr-d/codeph ">loaderURL</codeph>,
     * and <codeph class="+ topic/ph pr-d/codeph ">applicationDomain</codeph>. When the <codeph class="+ topic/ph pr-d/codeph ">loaderInfo</codeph> object dispatches the
     * <codeph class="+ topic/ph pr-d/codeph ">init</codeph> event, you can access all properties of the <codeph class="+ topic/ph pr-d/codeph ">loaderInfo</codeph> object and
     * the loaded image or SWF file.</p><p class="- topic/p "><b class="+ topic/ph hi-d/b ">Note:</b> All properties of LoaderInfo objects are read-only.</p><p class="- topic/p ">The <codeph class="+ topic/ph pr-d/codeph ">EventDispatcher.dispatchEvent()</codeph> method
     *
     *   is not applicable to LoaderInfo objects. If you call <codeph class="+ topic/ph pr-d/codeph ">dispatchEvent()</codeph>
     * on a LoaderInfo object, an IllegalOperationError exception is thrown.</p>
     *
     *   EXAMPLE:
     *
     *   The following example uses the LoaderInfoExample class to display an image on
     * the stage.  This is accomplished by performing the following steps:
     * <ol class="- topic/ol "><li class="- topic/li ">A property <codeph class="+ topic/ph pr-d/codeph ">url</codeph> is created, which is the location and name of the image.</li><li class="- topic/li ">The class constructor creates a Loader object named <codeph class="+ topic/ph pr-d/codeph ">loader</codeph>.</li><li class="- topic/li ">The <codeph class="+ topic/ph pr-d/codeph ">loader</codeph> object instantiates an event listener to ensure that the image loads properly.</li><li class="- topic/li ">The constructor creates a new instance of a URLRequest object, <codeph class="+ topic/ph pr-d/codeph ">request</codeph>,
     * with <codeph class="+ topic/ph pr-d/codeph ">url</codeph> passed so that the file name and location are known.</li><li class="- topic/li ">The <codeph class="+ topic/ph pr-d/codeph ">request</codeph> object is then passed to the <codeph class="+ topic/ph pr-d/codeph ">load()</codeph> method of the
     * <codeph class="+ topic/ph pr-d/codeph ">loader</codeph> object, which loads the image onto the display list.</li></ol><p class="- topic/p "><b class="+ topic/ph hi-d/b ">Important:</b> This example requires that you add a file named Image.gif in the same directory
     * as the compiled SWF file. Use an image that has an area that fits within the dimensions of the main SWF file.</p><codeblock xml:space="preserve" class="+ topic/pre pr-d/codeblock ">
     * package {
         * import flash.display.Loader;
         * import flash.display.LoaderInfo;
         * import flash.display.Sprite;
         * import flash.events.*;
         * import flash.net.URLRequest;
         *
         *   public class LoaderInfoExample extends Sprite {
         * private var url:String = "Image.gif";
         *
         *   public function LoaderInfoExample() {
         * var loader:Loader = new Loader();
         * loader.contentLoaderInfo.addEventListener(Event.INIT, initHandler);
         * loader.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, ioErrorHandler);
         * var request:URLRequest = new URLRequest(url);
         * loader.load(request);
         * addChild(loader);
         * }
         *
         *   private function initHandler(event:Event):void {
         * var loader:Loader = Loader(event.target.loader);
         * var info:LoaderInfo = LoaderInfo(loader.contentLoaderInfo);
         * trace("initHandler: loaderURL=" + info.loaderURL + " url=" + info.url);
         * }
         *
         *   private function ioErrorHandler(event:IOErrorEvent):void {
         * trace("ioErrorHandler: " + event);
         * }
         * }
         * }
     * </codeblock>
     * @langversion	3.0
     * @playerversion	Flash 9
     * @playerversion	Lite 4
     * @internal	Update the places LoaderInfo can be obtained from (playerglobal.as) and double-check loader vs. loadee.
     */
    var LoaderInfo$2 = /** @class */ (function (_super) {
        __extends(LoaderInfo$$1, _super);
        function LoaderInfo$$1(target) {
            if (target === void 0) { target = null; }
            var _this = _super.call(this, target) || this;
            // for now all LoaderInfo-Events will be handled in Loader.ts
            // Events that are supposed to be working are registered as eventMappingExtern:
            _this.eventMappingExtern[Event.COMPLETE] = "LoaderInfo:Event.COMPLETE";
            _this.eventMappingExtern[ProgressEvent.PROGRESS] = "LoaderInfo:ProgressEvent.PROGRESS";
            // Events not supported yet are registered as eventMappingDummys:
            _this.eventMappingDummys[Event.UNLOAD] = "LoaderInfo:Event.UNLOAD";
            _this.eventMappingDummys[IOErrorEvent.IO_ERROR] = "LoaderInfo:IOErrorEvent.IO_ERROR";
            //this.eventMappingDummys[HTTPStatusEvent.IO_ERROR]="HTTPStatusEvent.IO_ERROR";
            _this.eventMappingDummys[Event.OPEN] = "LoaderInfo:Event.OPEN";
            _this.eventMappingDummys[Event.INIT] = "LoaderInfo:Event.INIT";
            _this.adaptee = new LoaderInfo();
            return _this;
        }
        Object.defineProperty(LoaderInfo$$1.prototype, "actionScriptVersion", {
            /**
             * The ActionScript version of the loaded SWF file.
             *
             *   The language version is specified by using the enumerations in the
             * ActionScriptVersion class, such as ActionScriptVersion.ACTIONSCRIPT2
             * and ActionScriptVersion.ACTIONSCRIPT3.
             *
             *   Note: This property always has a value of either ActionScriptVersion.ACTIONSCRIPT2 or
             * ActionScriptVersion.ACTIONSCRIPT3.  ActionScript 1.0 and 2.0 are
             * both reported as ActionScriptVersion.ACTIONSCRIPT2 (version 2.0).  This property
             * only distinguishes ActionScript 1.0 and 2.0 from ActionScript 3.0.
             * @throws	Error If the file is not downloaded sufficiently to retrieve the requested information.
             * @throws	Error If the file is not a SWF file.
             */
            get: function () {
                console.log("actionScriptVersion not implemented yet in flash/LoaderInfo");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        LoaderInfo$$1.prototype.getSymbolById = function (value) { };
        Object.defineProperty(LoaderInfo$$1.prototype, "applicationDomain", {
            /**
             * When an external SWF file is loaded, all ActionScript 3.0 definitions contained in the loaded
             * class are stored in the applicationDomain property.
             *
             *   All code in a SWF file is defined to exist in an application domain. The current application
             * domain is where your main application runs. The system domain contains all application domains,
             * including the current domain and all classes used by Flash Player or Adobe AIR.All application domains, except the system domain, have an associated parent domain.
             * The parent domain of your main application's applicationDomain is the system domain.
             * Loaded classes are defined only when their parent doesn't already define them.
             * You cannot override a loaded class definition with a newer definition.For usage examples of application domains, see the "Client System Environment" chapter
             * in the ActionScript 3.0 Developer's Guide.
             * @internal	Need better description and example.
             * @throws	SecurityError This security sandbox of the caller is not allowed to access this ApplicationDomain.
             */
            get: function () {
                return this._applicationDomain;
            },
            set: function (value) {
                this._applicationDomain = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "bytes", {
            /**
             * The bytes associated with a LoaderInfo object.
             * @throws	SecurityError If the object accessing this API is prevented from
             *   accessing the loaded object due to security restrictions. This situation can occur,
             *   for instance, when a Loader object attempts to access the contentLoaderInfo.content
             *   property and it is not granted security permission to access the loaded content.
             *
             *     For more information related to security, see the Flash Player Developer Center Topic:
             *   Security.
             */
            get: function () {
                console.log("bytes not implemented yet in flash/LoaderInfo");
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "bytesLoaded", {
            /**
             * The number of bytes that are loaded for the media. When this number equals
             * the value of bytesTotal, all of the bytes are loaded.
             */
            get: function () {
                return this.adaptee.bytesLoaded;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "bytesTotal", {
            /**
             * The number of compressed bytes in the entire media file.
             *
             *   Before the first progress event is dispatched by
             * this LoaderInfo object's corresponding Loader object, bytesTotal is 0.
             * After the first progress event from the Loader object, bytesTotal
             * reflects the actual number of bytes to be downloaded.
             */
            get: function () {
                return this.adaptee.bytesTotal;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "childAllowsParent", {
            /**
             * Expresses the trust relationship from content (child) to the Loader (parent).
             * If the child has allowed the parent access, true; otherwise,
             * false. This property is set to true if the child object
             * has called the allowDomain() method to grant permission to the parent domain
             * or if a URL policy is loaded at the child domain that grants permission
             * to the parent domain. If child and parent are in
             * the same domain, this property is set to true.
             *
             *   For more information related to security, see the Flash Player Developer Center Topic:
             * Security.
             * @throws	Error  Thrown if the file is not downloaded sufficiently
             *   to retrieve the requested information.
             */
            get: function () {
                console.log("childAllowsParent not implemented yet in flash/LoaderInfo");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "childSandboxBridge", {
            /**
             * A object that can be set by the loaded content's code to expose properties and methods that can be accessed
             * by code in the Loader object's sandbox. This sandbox bridge lets content from a non-application domain have
             * controlled access to scripts in the AIR application sandbox, and vice versa. The sandbox bridge serves as a gateway between
             * the sandboxes, providing explicit interaction between application and non-application security sandboxes.
             * @throws	SecurityError Only content in the loaded content's sandbox can set this property.
             */
            get: function () {
                console.log("childSandboxBridge not implemented yet in flash/LoaderInfo");
                return null;
            },
            set: function (door) {
                console.log("childSandboxBridge not implemented yet in flash/LoaderInfo");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "content", {
            /**
             * The loaded object associated with this LoaderInfo object.
             * @throws	SecurityError If the object accessing this API is prevented from
             *   accessing the loaded object due to security restrictions. This situation can occur,
             *   for instance, when a Loader object attempts to access the contentLoaderInfo.content
             *   property and it is not granted security permission to access the loaded content.
             *
             *     For more information related to security, see the Flash Player Developer Center Topic:
             *   Security.
             */
            get: function () {
                return (this._loader && this._loader.content) ? this._loader.content : null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "contentType", {
            /**
             * The MIME type of the loaded file. The value is null if not enough of the file has loaded
             * in order to determine the type. The following list gives the possible values:
             *
             *   "application/x-shockwave-flash"
             *   "image/jpeg"
             *   "image/gif"
             *   "image/png"
             */
            get: function () {
                return this.adaptee.contentType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "frameRate", {
            /**
             * The nominal frame rate, in frames per second, of the loaded SWF file. This
             * number is often an integer, but need not be.
             *
             *   This value may differ from the actual frame rate in use.
             * Flash Player or Adobe AIR only uses a single frame rate for all loaded SWF files at
             * any one time, and this frame rate is determined by the nominal
             * frame rate of the main SWF file. Also, the main frame rate may not be able to be achieved, depending on hardware, sound synchronization,
             * and other factors.
             * @throws	Error If the file is not downloaded sufficiently to retrieve the requested information.
             * @throws	Error If the file is not a SWF file.
             */
            get: function () {
                return 0; //this.adaptee.frameRate;		
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "height", {
            /**
             * The nominal height of the loaded file. This value might differ from the actual
             * height at which the content is displayed, since the loaded content or its parent
             * display objects might be scaled.
             * @throws	Error If the file is not downloaded sufficiently to retrieve the requested information.
             */
            get: function () {
                console.log("height not implemented yet in flash/LoaderInfo");
                return 0; //this.adaptee.height;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "isURLInaccessible", {
            /**
             * Indicates if the LoaderInfo.url property has been
             * truncated. When the isURLInaccessible value is true the
             * LoaderInfo.url value is only the domain of the final URL from which the content loaded.
             * For example, the property is truncated if the content is loaded from http://www.adobe.com/assets/hello.swf,
             * and the LoaderInfo.url property has the value http://www.adobe.com. The isURLInaccessible
             * value is true only when all of the following are also true:
             *
             *   An HTTP redirect occurred while loading the content.The SWF file calling Loader.load() is from a different domain than
             * the content's final URL.The SWF file calling Loader.load() does not have permission to access
             * the content. Permission is granted to access the content the same way permission is granted for
             * BitmapData.draw():
             * call Security.allowDomain() to access a SWF file
             * (or for non-SWF file content, establish a policy file and use the LoaderContext.checkPolicyFile
             * property).Note: The isURLInaccessible property was added for Flash Player 10.1 and AIR 2.0.
             * However, this property is made available to SWF files of all versions when the
             * Flash runtime supports it. So, using some authoring tools in "strict mode" causes a compilation error. To work around the error
             * use the indirect syntax myLoaderInfo["isURLInaccessible"], or disable strict mode. If you are using Flash Professional CS5
             * or Flex SDK 4.1, you can use and compile this API for runtimes released before Flash Player 10.1 and AIR 2.For application content in AIR, the value of this property is always false.
             */
            get: function () {
                console.log("isURLInaccessible not implemented yet in flash/LoaderInfo");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "loader", {
            /**
             * The Loader object associated with this LoaderInfo object. If this LoaderInfo object
             * is the loaderInfo property of the instance of the main class of the SWF file, no
             * Loader object is associated.
             * @throws	SecurityError If the object accessing this API is prevented from
             *   accessing the Loader object because of security restrictions. This can occur,
             *   for instance, when a loaded SWF file attempts to access its loaderInfo.loader
             *   property and it is not granted security permission to access the loading SWF file.
             *
             *     For more information related to security, see the Flash Player Developer Center Topic:
             *   Security.
             */
            get: function () {
                return this._loader;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "loaderURL", {
            /**
             * The URL of the SWF file that initiated the loading of the media
             * described by this LoaderInfo object.  For the instance of the main class of the SWF file, this
             * URL is the same as the SWF file's own URL.
             */
            get: function () {
                console.log("loaderURL not implemented yet in flash/LoaderInfo");
                return "";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "parameters", {
            /**
             * An object that contains name-value pairs that represent the parameters provided
             * to the loaded SWF file.
             *
             *   You can use a for-in loop to extract all the names and values
             * from the parameters object.The two sources of parameters are: the query string in the
             * URL of the main SWF file, and the value of the FlashVars HTML parameter (this affects
             * only the main SWF file).The parameters property replaces the ActionScript 1.0 and 2.0 technique of
             * providing SWF file parameters as properties of the main timeline.The value of the parameters property is null for Loader objects
             * that contain SWF files that use ActionScript 1.0 or 2.0. It is only
             * non-null for Loader objects that contain SWF files that use ActionScript 3.0.
             */
            get: function () {
                console.log("parameters not implemented yet in flash/LoaderInfo");
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "parentAllowsChild", {
            /**
             * Expresses the trust relationship from Loader (parent) to the content (child).
             * If the parent has allowed the child access, true; otherwise,
             * false. This property is set to true if the parent object
             * called the allowDomain() method to grant permission to the child domain
             * or if a URL policy file is loaded at the parent domain granting permission
             * to the child domain. If child and parent are in
             * the same domain, this property is set to true.
             *
             *   For more information related to security, see the Flash Player Developer Center Topic:
             * Security.
             * @throws	Error  Thrown if the file is not downloaded sufficiently
             *   to retrieve the requested information.
             */
            get: function () {
                console.log("parentAllowsChild not implemented yet in flash/LoaderInfo");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "parentSandboxBridge", {
            /**
             * A object that can be set by code in the Loader object's sandbox to expose properties and methods that can be accessed
             * by the loaded content's code. This sandbox bridge lets content from a non-application domain have controlled
             * access to scripts in the AIR application sandbox, and vice versa. The sandbox bridge serves as a gateway between
             * the sandboxes, providing explicit interaction between application and non-application security sandboxes.
             * @throws	SecurityError Only content in the Loader object's sandbox can set this property.
             */
            get: function () {
                console.log("parentSandboxBridge not implemented yet in flash/LoaderInfo");
                return null;
            },
            set: function (door) {
                console.log("parentSandboxBridge not implemented yet in flash/LoaderInfo");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "sameDomain", {
            /**
             * Expresses the domain relationship between the loader and the content: true if they have
             * the same origin domain; false otherwise.
             * @throws	Error  Thrown if the file is not downloaded sufficiently
             *   to retrieve the requested information.
             */
            get: function () {
                console.log("sameDomain not implemented yet in flash/LoaderInfo");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "sharedEvents", {
            /**
             * An EventDispatcher instance that can be used to exchange events across security boundaries.
             * Even when the Loader object and the loaded content originate from security domains that do not trust
             * one another, both can access sharedEvents and send and receive events via this object.
             */
            get: function () {
                console.log("sharedEvents not implemented yet in flash/LoaderInfo");
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "swfVersion", {
            /**
             * The file format version of the loaded SWF file.
             *
             *   The file format is specified using the enumerations in the
             * SWFVersion class, such as SWFVersion.FLASH7 and SWFVersion.FLASH9.
             * @throws	Error If the file is not downloaded sufficiently to retrieve the requested information.
             * @throws	Error If the file is not a SWF file.
             */
            get: function () {
                console.log("swfVersion not implemented yet in flash/LoaderInfo");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "uncaughtErrorEvents", {
            /**
             * An object that dispatches an uncaughtError event when an unhandled error
             * occurs in code in this LoaderInfo object's SWF file. An uncaught error happens when
             * an error is thrown outside of any try..catch blocks or when an ErrorEvent
             * object is dispatched with no registered listeners.
             *
             *   This property is created when the SWF associated with this LoaderInfo has finished
             * loading. Until then the uncaughtErrorEvents property is null.
             * In an ActionScript-only project, you can access this property during or after the execution
             * of the constructor function of the main class of the SWF file. For a Flex project,
             * the uncaughtErrorEvents property is available after the
             * applicationComplete event is dispatched.
             */
            get: function () {
                //todo: any is UncaughtErrorEvents
                console.log("uncaughtErrorEvents not implemented yet in flash/LoaderInfo");
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "url", {
            /**
             * The URL of the media being loaded.
             *
             *   Before the first progress event is dispatched by this LoaderInfo
             * object's corresponding Loader object, the value of the url property
             * might reflect only the initial URL specified in the call to the load()
             * method  of the Loader object.  After the first progress event, the
             * url property reflects the media's final URL, after any redirects and relative
             * URLs are resolved.In some cases, the value of the url property is truncated; see the
             * isURLInaccessible property for details.
             */
            get: function () {
                if (!this.adaptee || !this.adaptee.url)
                    return "";
                return this.adaptee.url;
            },
            set: function (value) {
                console.log("url not implemented yet in flash/LoaderInfo");
                //this.adaptee.url=value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(LoaderInfo$$1.prototype, "width", {
            /**
             * The nominal width of the loaded content. This value might differ from the actual
             * width at which the content is displayed, since the loaded content or its parent
             * display objects might be scaled.
             * @throws	Error If the file is not downloaded sufficiently to retrieve the requested information.
             */
            get: function () {
                console.log("width not implemented yet in flash/LoaderInfo");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        LoaderInfo$$1.prototype.dispatchEventInternal = function (event) {
            return _super.prototype.dispatchEvent.call(this, event);
        };
        LoaderInfo$$1.prototype.dispatchEvent = function (event) {
            throw ("LoaderInfo.dispatchEvent should never be called");
        };
        /**
         * Returns the LoaderInfo object associated with a SWF file defined as an object.
         * @param	object	The object for which you want to get an associated LoaderInfo object.
         * @return	The associated LoaderInfo object. Returns null when called
         *   in non-debugger builds (or when debugging is not enabled) or if the referenced object
         *   does not have an associated LoaderInfo object (such as some objects used by the AIR runtime).

         * @throws	SecurityError The caller is not running in the local trusted sandbox.
         */
        LoaderInfo$$1.getLoaderInfoByDefinition = function (object) {
            console.log("getLoaderInfoByDefinition not implemented yet in flash/LoaderInfo");
            return null;
        };
        return LoaderInfo$$1;
    }(EventDispatcher$1));

    var Sprite$1 = /** @class */ (function (_super) {
        __extends(Sprite$$1, _super);
        /**
         * The Sprite class is a basic display list building block: a display list node that can display
         * graphics and can also contain children.
         *
         *   <p class="- topic/p ">A Sprite object is similar to a movie clip, but does not have a timeline. Sprite is an
         * appropriate base class for objects that do not require timelines. For example, Sprite would be a
         * logical base class for user numbererface (UI) components that typically do not use the timeline.</p><p class="- topic/p ">The Sprite class is new in ActionScript 3.0. It provides an alternative to the functionality of
         * the MovieClip class, which retains all the functionality of previous ActionScript releases to
         * provide backward compatibility.</p>
         *
         * Creates a new Sprite instance. After you create the Sprite instance, call the
         * DisplayObjectContainer.addChild() or DisplayObjectContainer.addChildAt()
         * method to add the Sprite to a parent DisplayObjectContainer.
         */
        function Sprite$$1() {
            var _this = 
            /*if(!adaptee && AwayMovieClip.mcForConstructor){
                adaptee=AwayMovieClip.mcForConstructor;
            }*/
            _super.call(this) || this;
            /*if(!this.adaptee.parent && !(<any>this).noReset){

            }*/
            _this._graphics = new _this.sec.flash.display.Graphics(_this._adaptee.graphics);
            return _this;
        }
        Sprite$$1.getNewSprite = function (adaptee) {
            if (Sprite$$1._sprites.length) {
                var sprite = Sprite$$1._sprites.pop();
                sprite.adaptee = adaptee;
                return sprite;
            }
            return new Sprite$$1();
        };
        Sprite$$1.prototype.initAdapter = function () {
            if (this.executeConstructor) {
                FrameScriptManager.queue_as3_constructor(this.adaptee);
            }
        };
        Sprite$$1.prototype.createAdaptee = function () {
            var newAdaptee = Sprite.getNewSprite();
            //console.log("createAdaptee AwaySprite");
            newAdaptee.timelineMC = true;
            newAdaptee.reset();
            this.noReset = true;
            //FrameScriptManager.execute_queue();
            return newAdaptee;
        };
        //---------------------------stuff added to make it work:
        Sprite$$1.prototype.registerScriptObject = function (child) {
            if (child.name) {
                this[child.name] = child._adapter ? child.adapter : child;
                this.axSetPublicProperty(child.name, child.adapter);
            }
        };
        Sprite$$1.prototype.unregisterScriptObject = function (child) {
            delete this[child.name];
            if (child.isAsset(MovieClip))
                child.removeButtonListeners();
        };
        Sprite$$1.prototype.clearPropsDic = function () {
            this["$Bg__setPropDict"].map = new WeakMap();
        };
        Sprite$$1.prototype.clone = function () {
            if (!this._symbol) {
                throw ("_symbol not defined when cloning movieclip");
            }
            //var clone: MovieClip = MovieClip.getNewMovieClip(AwayMovieClip.getNewMovieClip((<AwayMovieClip>this.adaptee).timeline));
            var clone = constructClassFromSymbol(this._symbol, this._symbol.symbolClass);
            var adaptee = new Sprite();
            this.adaptee.copyTo(adaptee);
            clone.adaptee = adaptee;
            clone._stage = this.activeStage;
            clone.executeConstructor = function () {
                var events = clone.getQueuedEvents();
                clone.axInitializer();
                if (events) {
                    for (var i = 0; i < events.length; i++) {
                        clone.dispatchEvent(events[i]);
                    }
                }
            };
            clone.adaptee.graphics = this.graphics;
            return clone;
        };
        /**
         * @inheritDoc
         */
        Sprite$$1.prototype.dispose = function () {
            this.disposeValues();
            //Sprite._sprites.push(this);
        };
        Object.defineProperty(Sprite$$1.prototype, "buttonMode", {
            //---------------------------original as3 properties / methods:
            /**
             * Specifies the button mode of this sprite. If true, this
             * sprite behaves as a button, which means that it triggers the display
             * of the hand cursor when the ponumberer passes over the sprite and can
             * receive a click event if the enter or space keys are pressed
             * when the sprite has focus. You can suppress the display of the hand cursor
             * by setting the useHandCursor property to false,
             * in which case the ponumberer is displayed.
             *
             *   Although it is better to use the SimpleButton class to create buttons,
             * you can use the buttonMode property to give a sprite
             * some button-like functionality. To include a sprite in the tab order,
             * set the tabEnabled property (inherited from the
             * numbereractiveObject class and false by default) to
             * true. Additionally, consider whether you want
             * the children of your sprite to be user input enabled. Most buttons
             * do not enable user input numbereractivity for their child objects because
             * it confuses the event flow. To disable user input numbereractivity for all child
             * objects, you must set the mouseChildren property (inherited
             * from the DisplayObjectContainer class) to false.If you use the buttonMode property with the MovieClip class (which is a
             * subclass of the Sprite class), your button might have some added
             * functionality. If you include frames labeled _up, _over, and _down,
             * Flash Player provides automatic state changes (functionality
             * similar to that provided in previous versions of ActionScript for movie
             * clips used as buttons). These automatic state changes are
             * not available for sprites, which have no timeline, and thus no frames
             * to label.
             */
            get: function () {
                //todo
                //console.log("buttonMode not implemented yet in flash/Sprite");
                return false;
            },
            set: function (value) {
                //todo
                //console.log("buttonMode not implemented yet in flash/Sprite");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sprite$$1.prototype, "dropTarget", {
            /**
             * Specifies the display object over which the sprite is being dragged, or on
             * which the sprite was dropped.
             */
            get: function () {
                //todo
                console.log("dropTarget not implemented yet in flash/Sprite");
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sprite$$1.prototype, "graphics", {
            /**
             * Specifies the Graphics object that belongs to this sprite where vector
             * drawing commands can occur.
             */
            get: function () {
                return this._graphics;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sprite$$1.prototype, "hitArea", {
            /**
             * Designates another sprite to serve as the hit area for a sprite. If the hitArea
             * property does not exist or the value is null or undefined, the
             * sprite itself is used as the hit area. The value of the hitArea property can
             * be a reference to a Sprite object.
             *
             *   You can change the hitArea property at any time; the modified sprite immediately
             * uses the new hit area behavior. The sprite designated as the hit area does not need to be
             * visible; its graphical shape, although not visible, is still detected as the hit area.Note: You must set to false the mouseEnabled
             * property of the sprite designated as the hit area. Otherwise, your sprite button might
             * not work because the sprite designated as the hit area receives the user input events instead
             * of your sprite button.
             */
            get: function () {
                //todo
                console.log("hitArea not implemented yet in flash/Sprite");
                return null;
            },
            set: function (value) {
                //todo
                console.log("hitArea not implemented yet in flash/Sprite");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sprite$$1.prototype, "soundTransform", {
            /**
             * Controls sound within this sprite.
             *
             *   Note: This property does not affect HTML content in an HTMLControl object (in Adobe AIR).
             */
            get: function () {
                // todo: any = SoundTransform
                console.log("soundTransform not implemented yet in flash/Sprite");
                return null;
            },
            set: function (sndTransform) {
                //todo
                console.log("soundTransform not implemented yet in flash/Sprite");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sprite$$1.prototype, "useHandCursor", {
            /**
             * A boolean value that indicates whether the ponumbering hand (hand cursor) appears when the ponumberer rolls
             * over a sprite in which the buttonMode property is set to true.
             * The default value of the useHandCursor property is true.
             * If useHandCursor is set to true, the ponumbering hand used for buttons
             * appears when the ponumberer rolls over a button sprite. If useHandCursor is
             * false, the arrow ponumberer is used instead.
             *
             *   You can change the useHandCursor property at any time; the modified sprite
             * immediately takes on the new cursor appearance. Note: In Flex or Flash Builder, if your sprite has child sprites, you might want to
             * set the mouseChildren property to false. For example, if you want a hand
             * cursor to appear over a Flex <mx:Label> control, set the useHandCursor and
             * buttonMode properties to true, and the mouseChildren property
             * to false.
             */
            get: function () {
                //todo
                //console.log("useHandCursor not implemented yet in flash/Sprite");
                return this.adaptee._useHandCursor;
            },
            set: function (value) {
                //todo
                this.adaptee._useHandCursor = value;
                //console.log("useHandCursor not implemented yet in flash/Sprite");
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Lets the user drag the specified sprite. The sprite remains draggable until explicitly
         * stopped through a call to the Sprite.stopDrag() method, or until
         * another sprite is made draggable. Only one sprite is draggable at a time.
         * Three-dimensional display objects follow the ponumberer and
         * Sprite.startDrag() moves the object within
         * the three-dimensional plane defined by the display object. Or, if the display object is a two-dimensional object
         * and the child of a three-dimensional object, the two-dimensional object
         * moves within the three dimensional plane defined by the three-dimensional parent object.
         * @param	lockCenter	Specifies whether the draggable sprite is locked to the center of
         *   the ponumberer position (true), or locked to the ponumber where the user first clicked the
         *   sprite (false).
         * @param	bounds	Value relative to the coordinates of the Sprite's parent that specify a constranumber
         *   rectangle for the Sprite.
         */
        Sprite$$1.prototype.startDrag = function (lockCenter, bounds) {
            if (lockCenter === void 0) { lockCenter = false; }
            if (bounds === void 0) { bounds = null; }
            //todo
            console.log("startDrag not implemented yet in flash/Sprite");
        };
        /**
         * Lets the user drag the specified sprite on a touch-enabled device. The sprite remains draggable until explicitly
         * stopped through a call to the Sprite.stopTouchDrag() method, or until
         * another sprite is made draggable. Only one sprite is draggable at a time.
         * Three-dimensional display objects follow the ponumberer and
         * Sprite.startTouchDrag() moves the object within
         * the three-dimensional plane defined by the display object. Or, if the display object is a two-dimensional object
         * and the child of a three-dimensional object, the two-dimensional object
         * moves within the three dimensional plane defined by the three-dimensional parent object.
         * @param	touchPonumberID	An numbereger to assign to the touch ponumber.
         * @param	lockCenter	Specifies whether the draggable sprite is locked to the center of
         *   the ponumberer position (true), or locked to the ponumber where the user first clicked the
         *   sprite (false).
         * @param	bounds	Value relative to the coordinates of the Sprite's parent that specify a constranumber
         *   rectangle for the Sprite.
         */
        Sprite$$1.prototype.startTouchDrag = function (touchPonumberID, lockCenter, bounds) {
            if (lockCenter === void 0) { lockCenter = false; }
            if (bounds === void 0) { bounds = null; }
            //todo
            console.log("startTouchDrag not implemented yet in flash/Sprite");
        };
        /**
         * Ends the startDrag() method. A sprite that was made draggable with the
         * startDrag() method remains draggable until a
         * stopDrag() method is added, or until another
         * sprite becomes draggable. Only one sprite is draggable at a time.
         */
        Sprite$$1.prototype.stopDrag = function () {
            //todo
            console.log("startTouchDrag not implemented yet in flash/Sprite");
        };
        /**
         * Ends the startTouchDrag() method, for use with touch-enabled devices. A sprite that was made draggable with the
         * startTouchDrag() method remains draggable until a
         * stopTouchDrag() method is added, or until another
         * sprite becomes draggable. Only one sprite is draggable at a time.
         * @param	touchPonumberID	The numbereger assigned to the touch ponumber in the startTouchDrag method.
         */
        Sprite$$1.prototype.stopTouchDrag = function (touchPonumberID) {
            //todo
            console.log("startTouchDrag not implemented yet in flash/Sprite");
        };
        Sprite$$1._sprites = new Array();
        return Sprite$$1;
    }(DisplayObjectContainer$1));

    var includeString = ''; //TODO
    /**
     * The MovieClip class inherits from the following classes: Sprite, DisplayObjectContainer,
     * InteractiveObject, DisplayObject, and EventDispatcher.
     *
     *   <p class="- topic/p ">Unlike the Sprite object, a MovieClip object has a timeline.</p><p class="- topic/p ">&gt;In Flash Professional, the methods for the MovieClip class provide the same functionality
     * as actions that target movie clips. Some additional methods do not have equivalent
     * actions in the Actions toolbox in the Actions panel in the Flash authoring tool. </p><p class="- topic/p ">Children instances placed on the Stage in Flash Professional cannot be accessed by code from within the
     * constructor of a parent instance since they have not been created at that ponumber in code execution.
     * Before accessing the child, the parent must instead either create the child instance
     * by code or delay access to a callback that listens for the child to dispatch
     * its <codeph class="+ topic/ph pr-d/codeph ">Event.ADDED_TO_STAGE</codeph> event.</p><p class="- topic/p ">If you modify any of the following properties of a MovieClip object that contains a motion tween,
     * the playhead is stopped in that MovieClip object: <codeph class="+ topic/ph pr-d/codeph ">alpha</codeph>, <codeph class="+ topic/ph pr-d/codeph ">blendMode</codeph>,
     * <codeph class="+ topic/ph pr-d/codeph ">filters</codeph>, <codeph class="+ topic/ph pr-d/codeph ">height</codeph>, <codeph class="+ topic/ph pr-d/codeph ">opaqueBackground</codeph>, <codeph class="+ topic/ph pr-d/codeph ">rotation</codeph>,
     * <codeph class="+ topic/ph pr-d/codeph ">scaleX</codeph>, <codeph class="+ topic/ph pr-d/codeph ">scaleY</codeph>, <codeph class="+ topic/ph pr-d/codeph ">scale9Grid</codeph>, <codeph class="+ topic/ph pr-d/codeph ">scrollRect</codeph>,
     * <codeph class="+ topic/ph pr-d/codeph ">transform</codeph>, <codeph class="+ topic/ph pr-d/codeph ">visible</codeph>, <codeph class="+ topic/ph pr-d/codeph ">width</codeph>, <codeph class="+ topic/ph pr-d/codeph ">x</codeph>,
     * or <codeph class="+ topic/ph pr-d/codeph ">y</codeph>. However, it does not stop the playhead in any child MovieClip objects of that
     * MovieClip object.</p><p class="- topic/p "><b class="+ topic/ph hi-d/b ">Note:</b>Flash Lite 4 supports the MovieClip.opaqueBackground property only if
     * FEATURE_BITMAPCACHE is defined. The default configuration of Flash Lite 4 does not define
     * FEATURE_BITMAPCACHE. To enable the MovieClip.opaqueBackground property for a suitable device,
     * define FEATURE_BITMAPCACHE in your project.</p>*/
    var MovieClip$1 = /** @class */ (function (_super) {
        __extends(MovieClip$$1, _super);
        /**
         * Creates a new MovieClip instance. After creating the MovieClip, call the
         * addChild() or addChildAt() method of a
         * display object container that is onstage.
         */
        function MovieClip$$1() {
            return _super.call(this) || this;
        }
        // 	executed directly after a MC has been constructed via Object.create,
        //	befre the actual constructors have been run
        MovieClip$$1.prototype.applySymbol = function () { };
        MovieClip$$1.getNewMovieClip = function (adaptee) {
            if (MovieClip$$1._movieClips.length) {
                var movieClip = MovieClip$$1._movieClips.pop();
                movieClip.adaptee = adaptee;
                return movieClip;
            }
            return new MovieClip$$1();
        };
        //forAVM1:
        MovieClip$$1.prototype._getAbsFrameNumber = function (param1, param2) {
            return 0;
        };
        MovieClip$$1.prototype.callFrame = function (param1) {
        };
        MovieClip$$1.prototype._callFrame = function (param1) {
        };
        MovieClip$$1.prototype.addScript = function (param1) {
            return param1;
        };
        MovieClip$$1.prototype.executeScript = function (scripts) {
            if (scripts) {
                for (var k = 0; k < scripts.length; k++) {
                    scripts[k].setReceiver(this);
                    scripts[k].axCall(this);
                }
            }
        };
        MovieClip$$1.prototype.initAdapter = function () {
            if (this.executeConstructor) {
                FrameScriptManager.queue_as3_constructor(this.adaptee);
            }
        };
        MovieClip$$1.prototype.createAdaptee = function () {
            var adaptee = MovieClip.getNewMovieClip();
            adaptee.timelineMC = true;
            adaptee.reset();
            //console.log("createAdaptee AwayMovieClip");
            this.noReset = true;
            //FrameScriptManager.execute_queue();
            return adaptee;
        };
        // --------------------- stuff needed because of implementing the existing IMovieClipAdapter
        MovieClip$$1.prototype.clearPropsDic = function () {
            this["$Bg__setPropDict"].map = new WeakMap();
        };
        MovieClip$$1.prototype.evalScript = function (str) {
            var tag = document.createElement('script');
            tag.text = 'var __framescript__ = function() {\n' + includeString + str + '\n}';
            //add and remove script tag to dom to trigger compilation
            var sibling = document.scripts[0];
            sibling.parentNode.insertBefore(tag, sibling).parentNode.removeChild(tag);
            var script = __framescript__;
            window['__framescript__'] = null;
            return script;
        };
        MovieClip$$1.prototype.freeFromScript = function () {
            //this.stopAllSounds();
            _super.prototype.freeFromScript.call(this);
        };
        MovieClip$$1.prototype.clone = function () {
            if (!this._symbol) {
                throw ("_symbol not defined when cloning movieclip");
            }
            //var clone: MovieClip = MovieClip.getNewMovieClip(AwayMovieClip.getNewMovieClip((<AwayMovieClip>this.adaptee).timeline));
            var newMC = constructClassFromSymbol(this._symbol, this._symbol.symbolClass);
            //console.log("clone", (<any>this)._symbol, (<any>this)._symbol.symbolClass);
            var adaptee = new MovieClip(this.adaptee.timeline);
            //console.log("clone mc", newMC, adaptee, adaptee.id, (<any>this)._symbol, (<any>this)._symbol.symbolClass)
            this.adaptee.copyTo(adaptee);
            newMC.adaptee = adaptee;
            newMC._stage = this.activeStage;
            newMC.executeConstructor = function () {
                newMC.adaptee.timeline.resetScripts();
                //console.log("executeConstructor mc", newMC, newMC.adaptee.id);
                var events = newMC.getQueuedEvents();
                newMC.axInitializer();
                if (events) {
                    for (var i = 0; i < events.length; i++) {
                        newMC.dispatchEvent(events[i]);
                    }
                }
            };
            // if this is a custom class (not a plain MC or Sprite)
            // make sure that the clone will not be reused on the timeline.
            // it must reclone for every new instance thats added to scene, so that the as3 constructor (axInitializer) will run again...
            // (if cloneForEveryInstance is true, the awayjs-mc will not cache the instance on the potentialinstance-list)
            if (this._symbol.className) {
                newMC.adaptee.cloneForEveryInstance = true;
            }
            if (newMC.adaptee.timeline) {
                // 	hack to BadIceCreamFont compiledClip:
                //	the compiledClip "BadIcecreamFont" seem to behave different to other classes
                //	it seem to always stick to frame 0, 
                if (this._symbol.className && this._symbol.className == "BadIcecreamFont") {
                    newMC.adaptee.adaptee.timeline.frame_command_indices = [newMC.adaptee.timeline.frame_command_indices[0]];
                    newMC.adaptee.adaptee.timeline.frame_recipe = [newMC.adaptee.timeline.frame_recipe[0]];
                    newMC.adaptee.adaptee.timeline.keyframe_constructframes = [newMC.adaptee.timeline.keyframe_constructframes[0]];
                    newMC.adaptee.adaptee.timeline.keyframe_durations = [newMC.adaptee.timeline.keyframe_durations[0]];
                    newMC.adaptee.adaptee.timeline.keyframe_firstframes = [newMC.adaptee.timeline.keyframe_firstframes[0]];
                    newMC.adaptee.adaptee.timeline.keyframe_indices = [newMC.adaptee.timeline.keyframe_indices[0]];
                }
            }
            return newMC;
        };
        /**
         * @inheritDoc
         */
        MovieClip$$1.prototype.dispose = function () {
            this.disposeValues();
            //MovieClip._movieClips.push(this);
        };
        Object.defineProperty(MovieClip$$1.prototype, "currentFrame", {
            //---------------------------original as3 properties / methods:
            /**
             * Specifies the number of the frame in which the playhead is located in the timeline of
             * the MovieClip instance. If the movie clip has multiple scenes, this value is the
             * frame number in the current scene.
             */
            get: function () {
                return this._adaptee.currentFrameIndex + 1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip$$1.prototype, "currentFrameLabel", {
            /**
             * The label at the current frame in the timeline of the MovieClip instance.
             * If the current frame has no label, currentLabel is null.
             */
            get: function () {
                return this.adaptee.timeline.getCurrentFrameLabel(this.adaptee);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip$$1.prototype, "currentLabel", {
            /**
             * The current label in which the playhead is located in the timeline of the MovieClip instance.
             * If the current frame has no label, currentLabel is set to the name of the previous frame
             * that includes a label. If the current frame and previous frames do not include a label,
             * currentLabel returns null.
             */
            get: function () {
                return this.adaptee.timeline.getCurrentLabel(this.adaptee);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip$$1.prototype, "currentLabels", {
            /**
             * Returns an array of FrameLabel objects from the current scene. If the MovieClip instance does
             * not use scenes, the array includes all frame labels from the entire MovieClip instance.
             */
            get: function () {
                //todo
                console.log("currentFrameLabel not implemented yet in flash/MovieClip");
                return [];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip$$1.prototype, "currentScene", {
            /**
             * The current scene in which the playhead is located in the timeline of the MovieClip instance.
             */
            get: function () {
                //todo
                console.log("currentScene not implemented yet in flash/MovieClip");
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip$$1.prototype, "enabled", {
            /**
             * A boolean value that indicates whether a movie clip is enabled. The default value of enabled
             * is true. If enabled is set to false, the movie clip's
             * Over, Down, and Up frames are disabled. The movie clip
             * continues to receive events (for example, mouseDown,
             * mouseUp, keyDown, and keyUp).
             *
             *   The enabled property governs only the button-like properties of a movie clip. You
             * can change the enabled property at any time; the modified movie clip is immediately
             * enabled or disabled. If enabled is set to false, the object is not
             * included in automatic tab ordering.
             */
            get: function () {
                //todo
                //console.log("enabled not implemented yet in flash/MovieClip");
                return false;
            },
            set: function (value) {
                //todo
                //console.log("enabled not implemented yet in flash/MovieClip");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip$$1.prototype, "framesLoaded", {
            /**
             * The number of frames that are loaded from a streaming SWF file. You can use the framesLoaded
             * property to determine whether the contents of a specific frame and all the frames before it
             * loaded and are available locally in the browser. You can also use it to monitor the downloading
             * of large SWF files. For example, you might want to display a message to users indicating that
             * the SWF file is loading until a specified frame in the SWF file finishes loading.
             *
             *   If the movie clip contains multiple scenes, the framesLoaded property returns the number
             * of frames loaded for all scenes in the movie clip.
             */
            get: function () {
                //todo
                console.log("framesLoaded not implemented yet in flash/MovieClip");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip$$1.prototype, "isPlaying", {
            get: function () {
                //todo
                console.log("isPlaying not implemented yet in flash/MovieClip");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip$$1.prototype, "scenes", {
            /**
             * An array of Scene objects, each listing the name, the number of frames,
             * and the frame labels for a scene in the MovieClip instance.
             */
            get: function () {
                //todo
                console.log("scenes not implemented yet in flash/MovieClip");
                return [];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip$$1.prototype, "totalFrames", {
            /**
             * The total number of frames in the MovieClip instance.
             *
             *   If the movie clip contains multiple frames, the totalFrames property returns
             * the total number of frames in all scenes in the movie clip.
             */
            get: function () {
                return this._adaptee.numFrames;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MovieClip$$1.prototype, "trackAsMenu", {
            /**
             * Indicates whether other display objects that are SimpleButton or MovieClip objects can receive
             * mouse release events or other user input release events. The trackAsMenu property lets you create menus. You
             * can set the trackAsMenu property on any SimpleButton or MovieClip object.
             * The default value of the trackAsMenu property is false.
             *
             *   You can change the trackAsMenu property at any time; the modified movie
             * clip immediately uses the new behavior.
             */
            get: function () {
                //todo
                console.log("trackAsMenu not implemented yet in flash/MovieClip");
                return false;
            },
            set: function (value) {
                //todo
                console.log("trackAsMenu not implemented yet in flash/MovieClip");
            },
            enumerable: true,
            configurable: true
        });
        MovieClip$$1.prototype.addFrameScript = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            // arguments are pairs of frameIndex and script/function
            // frameIndex is in range 0..totalFrames-1
            var numArgs = arguments.length;
            if (numArgs & 1) {
                this.sec.throwError('ArgumentError TooFewArgumentsError', numArgs, numArgs + 1);
            }
            for (var i = 0; i < numArgs; i += 2) {
                var frameNum = (arguments[i] | 0);
                var fn = arguments[i + 1];
                this.adaptee.timeline.add_framescript(fn, frameNum);
                // 	if the mc was already added to scene before the construcor was run,
                //	no framescript was defined, and therefore we might need to add scripts for the current frame manually
                //	todo: make sure that this is correctly behaving in case constructor navigates the mc to another frame
                /*if(this.adaptee.parent && frameNum==0){//(<AwayMovieClip>this.adaptee).currentFrameIndex==frameNum){
                    FrameScriptManager.add_script_to_queue_pass2(<AwayMovieClip>this.adaptee, [fn]);
                }*/
            }
        };
        /**
         * Starts playing the SWF file at the specified frame.  This happens after all
         * remaining actions in the frame have finished executing.  To specify a scene
         * as well as a frame, specify a value for the scene parameter.
         * @param	frame	A number representing the frame number, or a string representing the label of the
         *   frame, to which the playhead is sent. If you specify a number, it is relative to the
         *   scene you specify. If you do not specify a scene, the current scene determines the global frame number to play. If you do specify a scene, the playhead
         *   jumps to the frame number in the specified scene.
         * @param	scene	The name of the scene to play. This parameter is optional.
         */
        MovieClip$$1.prototype.gotoAndPlay = function (frame, scene) {
            if (scene === void 0) { scene = null; }
            if (frame == null)
                return;
            if (typeof frame === "string") {
                // todo: only do toLowerCase if FP version <=9
                frame = frame.toLowerCase();
                if (this.adaptee.timeline._labels[frame] == null) {
                    frame = parseInt(frame);
                    if (!isNaN(frame)) {
                        this.adaptee.currentFrameIndex = frame - 1;
                        this.adaptee.play();
                    }
                    return;
                }
            }
            if (typeof frame === "number" && frame <= 0)
                return;
            this.play();
            this._gotoFrame(frame);
            FrameScriptManager.execute_as3_constructors();
            this.dispatchStaticBroadCastEvent(Event.FRAME_CONSTRUCTED);
            FrameScriptManager.execute_queue();
        };
        /**
         * Brings the playhead to the specified frame of the movie clip and stops it there.  This happens after all
         * remaining actions in the frame have finished executing.  If you want to specify a scene in addition to a frame,
         * specify a scene parameter.
         * @param	frame	A number representing the frame number, or a string representing the label of the
         *   frame, to which the playhead is sent. If you specify a number, it is relative to the
         *   scene you specify. If you do not specify a scene, the current scene determines the global frame number at which to go to and stop. If you do specify a scene,
         *   the playhead goes to the frame number in the specified scene and stops.
         * @param	scene	The name of the scene. This parameter is optional.
         * @throws	ArgumentError If the scene or frame specified are
         *   not found in this movie clip.
         */
        MovieClip$$1.prototype.gotoAndStop = function (frame, scene) {
            if (scene === void 0) { scene = null; }
            // in FP for frame==null, we need to stop the mc
            if (frame == null) {
                this.stop();
                return;
            }
            if (typeof frame === "string") {
                // todo: only do toLowerCase if FP version <=9
                frame = frame.toLowerCase();
                if (this.adaptee.timeline._labels[frame] == null) {
                    frame = parseInt(frame);
                    if (!isNaN(frame)) {
                        this.adaptee.currentFrameIndex = frame - 1;
                        this.adaptee.stop();
                    }
                    return;
                }
            }
            if (typeof frame === "number" && frame <= 0)
                return;
            this.stop();
            this._gotoFrame(frame);
            FrameScriptManager.execute_as3_constructors();
            this.dispatchStaticBroadCastEvent(Event.FRAME_CONSTRUCTED);
            FrameScriptManager.execute_queue();
        };
        MovieClip$$1.prototype._gotoFrame = function (frame) {
            if (typeof frame === "string") {
                this._adaptee.jumpToLabel(frame);
                return;
            }
            if (typeof frame === "number" && frame <= 0)
                return;
            this._adaptee.currentFrameIndex = frame - 1;
        };
        /**
         * Sends the playhead to the next frame and stops it.  This happens after all
         * remaining actions in the frame have finished executing.
         */
        MovieClip$$1.prototype.nextFrame = function () {
            //todo
            console.log("nextFrame not implemented yet in flash/MovieClip");
        };
        /**
         * Moves the playhead to the next scene of the MovieClip instance.  This happens after all
         * remaining actions in the frame have finished executing.
         */
        MovieClip$$1.prototype.nextScene = function () {
            //todo
            console.log("nextScene not implemented yet in flash/MovieClip");
        };
        /**
         * Moves the playhead in the timeline of the movie clip.
         */
        MovieClip$$1.prototype.play = function () {
            return this._adaptee.play();
        };
        /**
         * Sends the playhead to the previous frame and stops it.  This happens after all
         * remaining actions in the frame have finished executing.
         */
        MovieClip$$1.prototype.prevFrame = function () {
            if (this._adaptee.currentFrameIndex > 0) {
                this._adaptee.currentFrameIndex = this._adaptee.currentFrameIndex - 1;
            }
        };
        /**
         * Moves the playhead to the previous scene of the MovieClip instance.  This happens after all
         * remaining actions in the frame have finished executing.
         */
        MovieClip$$1.prototype.prevScene = function () {
            //todo
            console.log("prevScene not implemented yet in flash/MovieClip");
        };
        /**
         * Stops the playhead in the movie clip.
         */
        MovieClip$$1.prototype.stop = function () {
            return this._adaptee.stop();
        };
        MovieClip$$1._movieClips = new Array();
        return MovieClip$$1;
    }(Sprite$1));

    var Graphics$1 = /** @class */ (function (_super) {
        __extends(Graphics$$1, _super);
        function Graphics$$1(adaptee) {
            if (adaptee === void 0) { adaptee = null; }
            var _this = _super.call(this) || this;
            _this._adaptee = adaptee || new Graphics();
            _this._adaptee.adapter = _this;
            return _this;
        }
        Graphics$$1.prototype.dispose = function () {
        };
        Object.defineProperty(Graphics$$1.prototype, "adaptee", {
            get: function () {
                return this._adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Graphics$$1.FromData = function (data, loaderInfo) {
            var graphics = this.sec.flash.display.Graphics();
            return graphics;
        };
        /*
            public getGraphicsData(): ShapeData {
                return this._graphicsData;
            }
        
            public getUsedTextures(): BitmapData[] {
                return this._textures;
            }*/
        Graphics$$1.prototype.clear = function () {
            this.adaptee.clear();
        };
        /**
         * Sets a solid color and opacity as the fill for subsequent drawing commands.
         *
         * @see http://help.adobe.com/en_US/FlashPlatform/reference/actionscript/3/flash/display/Graphics.html#beginFill%28%29
         * @param color
         * @param alpha While any Number is a valid input, the value is clamped to [0,1] and then scaled
         * to an integer in the interval [0,0xff].
         */
        Graphics$$1.prototype.beginFill = function (color /*uint*/, alpha) {
            if (alpha === void 0) { alpha = 1; }
            this.adaptee.beginFill(color, alpha);
        };
        Graphics$$1.prototype.beginGradientFill = function (type, colors, alphas, ratios, matrix, spreadMethod, interpolationMethod, focalPointRatio) {
            if (matrix === void 0) { matrix = null; }
            if (spreadMethod === void 0) { spreadMethod = "pad"; }
            if (interpolationMethod === void 0) { interpolationMethod = "rgb"; }
            if (focalPointRatio === void 0) { focalPointRatio = 0; }
            notImplemented("Graphics.beginGradientFill");
            //this.adaptee.beginGradientFill(type, colors, alphas, ratios,  matrix , spreadMethod , interpolationMethod, focalPointRatio);
        };
        Graphics$$1.prototype.beginBitmapFill = function (bitmap, matrix, repeat, smooth) {
            if (matrix === void 0) { matrix = null; }
            if (repeat === void 0) { repeat = true; }
            if (smooth === void 0) { smooth = false; }
            this.adaptee.beginBitmapFill(bitmap.adaptee, matrix, repeat, smooth);
        };
        Graphics$$1.prototype.endFill = function () {
            this.adaptee.endFill();
        };
        //    beginShaderFill(shader: flash.display.Shader, matrix: flash.geom.Matrix = null): void {
        //      //shader = shader; matrix = matrix;
        //      release || notImplemented("public flash.display.Graphics::beginShaderFill"); return;
        //    }
        Graphics$$1.prototype.lineStyle = function (thickness, color, alpha, pixelHinting, scaleMode, caps, joints, miterLimit) {
            if (color === void 0) { color = 0; }
            if (alpha === void 0) { alpha = 1; }
            if (pixelHinting === void 0) { pixelHinting = false; }
            if (scaleMode === void 0) { scaleMode = "normal"; }
            if (caps === void 0) { caps = null; }
            if (joints === void 0) { joints = null; }
            if (miterLimit === void 0) { miterLimit = 3; }
            notImplemented("Graphics.lineStyle");
            //this.adaptee.lineStyle(thickness, color, alpha, pixelHinting, scaleMode, caps, joints, miterLimit);
        };
        Graphics$$1.prototype.lineGradientStyle = function (type, colors, alphas, ratios, matrix, spreadMethod, interpolationMethod, focalPointRatio) {
            if (matrix === void 0) { matrix = null; }
            if (spreadMethod === void 0) { spreadMethod = "pad"; }
            if (interpolationMethod === void 0) { interpolationMethod = "rgb"; }
            if (focalPointRatio === void 0) { focalPointRatio = 0; }
            notImplemented("Graphics.lineGradientStyle");
            //this.adaptee.lineGradientStyle(type, colors, alphas, ratios, matrix, spreadMethod, interpolationMethod, focalPointRatio);
        };
        Graphics$$1.prototype.lineBitmapStyle = function (bitmap, matrix, repeat, smooth) {
            if (matrix === void 0) { matrix = null; }
            if (repeat === void 0) { repeat = true; }
            if (smooth === void 0) { smooth = false; }
            notImplemented("Graphics.lineBitmapStyle");
            //this.adaptee.lineBitmapStyle(bitmap, matrix, repeat, smooth);
        };
        Graphics$$1.prototype.drawRect = function (x, y, width, height) {
            this.adaptee.drawRect(x, y, width, height);
        };
        Graphics$$1.prototype.drawRoundRect = function (x, y, width, height, ellipseWidth, ellipseHeight) {
            this.adaptee.drawRoundRect(x, y, width, height, ellipseWidth, ellipseHeight);
        };
        Graphics$$1.prototype.drawRoundRectComplex = function (x, y, width, height, topLeftRadius, topRightRadius, bottomLeftRadius, bottomRightRadius) {
            this.adaptee.drawRoundRectComplex(x, y, width, height, topLeftRadius, topRightRadius, bottomLeftRadius, bottomRightRadius);
        };
        Graphics$$1.prototype.drawCircle = function (x, y, radius) {
            this.adaptee.drawCircle(x, y, radius);
        };
        /**
         * Here x and y are the top-left coordinates of the bounding box of the
         * ellipse not the center as is the case for circles.
         */
        Graphics$$1.prototype.drawEllipse = function (x, y, width, height) {
            this.adaptee.drawEllipse(x, y, width, height);
        };
        Graphics$$1.prototype.moveTo = function (x, y) {
            this.adaptee.moveTo(x, y);
        };
        Graphics$$1.prototype.lineTo = function (x, y) {
            this.adaptee.lineTo(x, y);
        };
        Graphics$$1.prototype.curveTo = function (controlX, controlY, anchorX, anchorY) {
            this.adaptee.curveTo(controlX, controlY, anchorX, anchorY);
        };
        Graphics$$1.prototype.cubicCurveTo = function (controlX1, controlY1, controlX2, controlY2, anchorX, anchorY) {
            this.adaptee.cubicCurveTo(controlX1, controlY1, controlX2, controlY2, anchorX, anchorY);
        };
        Graphics$$1.prototype.copyFrom = function (sourceGraphics) {
            this.adaptee.copyFrom(sourceGraphics.adaptee);
        };
        Graphics$$1.prototype.drawPath = function (commands, data, winding) {
            if (winding === void 0) { winding = "evenOdd"; }
            notImplemented("Graphics.drawPath");
            //this.adaptee.drawPath(commands, data, winding);
        };
        Graphics$$1.prototype.drawTriangles = function (vertices, indices, uvtData, culling) {
            if (indices === void 0) { indices = null; }
            if (uvtData === void 0) { uvtData = null; }
            if (culling === void 0) { culling = "none"; }
            notImplemented("Graphics.drawTriangles");
            //this.adaptee.drawPath(commands, data, winding);
        };
        Graphics$$1.prototype.drawGraphicsData = function (graphicsData) {
            notImplemented("Graphics.drawTriangles");
            //this.adaptee.drawPath(commands, data, winding);
        };
        Graphics$$1.classInitializer = null;
        return Graphics$$1;
    }(ASObject$1));

    /**
     * The SimpleButton class lets you control all instances of button symbols in a SWF
     * file.
     *
     *   <p class="- topic/p ">In Flash Professional, you can give a button an instance name in the
     * Property inspector. SimpleButton instance names are displayed in the Movie
     * Explorer and in the Insert Target Path dialog box in the Actions
     * panel. After you create an instance of a button in Flash Professional, you can
     * use the methods and properties of the SimpleButton class to manipulate buttons
     * with ActionScript.</p><p class="- topic/p ">In ActionScript 3.0, you use the <codeph class="+ topic/ph pr-d/codeph ">new SimpleButton()</codeph> constructor to create a
     * SimpleButton instance.</p><p class="- topic/p ">The SimpleButton class inherits from the InteractiveObject class.</p>
     *
     *   EXAMPLE:
     *
     *   The following example uses the SimpleButtonExample class, which in
     * turn uses the CustomSimpleButton class, and this class then instantiates four
     * ButtonDisplayState objects.  The result is a button that is created in the shape of
     * a square, whose background color changes based on the mouse state by overriding instance properties of
     * the SimpleButton class.  This is accomplished by performing the following steps:
     * <ol class="- topic/ol "><li class="- topic/li ">In the <codeph class="+ topic/ph pr-d/codeph ">SimpleButtonExample()</codeph> constructor, a new CustomSimpleButton object of type
     * SimpleButton, called <codeph class="+ topic/ph pr-d/codeph ">button</codeph>, is created, which calls the <codeph class="+ topic/ph pr-d/codeph ">CustomSimpleButton</codeph> constructor
     * method.  The <codeph class="+ topic/ph pr-d/codeph ">button</codeph> object is the added to the display list.  The button's color and size are
     * determined in the steps that follow.</li><li class="- topic/li ">In the CustomSimpleButton class, instance properties are declared that are later used
     * to control the size and background color of <codeph class="+ topic/ph pr-d/codeph ">button</codeph>, based on the state it is in (orange
     * in the normal state, dark yellow in the mouse over state, an light blue in the mouse down state).
     * In all of the <codeph class="+ topic/ph pr-d/codeph ">button</codeph>'s states, the size of the square is set to 80 pixels by using the
     * <codeph class="+ topic/ph pr-d/codeph ">size</codeph> property.</li><li class="- topic/li ">The constructor function for the CustomSimpleButton class sets the
     * <codeph class="+ topic/ph pr-d/codeph ">downState</codeph>, <codeph class="+ topic/ph pr-d/codeph ">overState</codeph>, <codeph class="+ topic/ph pr-d/codeph ">upState</codeph>,
     * <codeph class="+ topic/ph pr-d/codeph ">hitTestState</codeph>, and <codeph class="+ topic/ph pr-d/codeph ">useHandCursor</codeph> properties with
     * four instances of the ButtonDisplayState class.</li><li class="- topic/li ">In the ButtonDisplayState class, the constructor sets the value of the
     * square's size and background color and calls the <codeph class="+ topic/ph pr-d/codeph ">draw()</codeph> method.</li><li class="- topic/li ">The <codeph class="+ topic/ph pr-d/codeph ">draw()</codeph> method redraws the square with the size and background color set in
     * the constructor based on the button's state.</li></ol><codeblock xml:space="preserve" class="+ topic/pre pr-d/codeblock ">

     */
    var SimpleButton$1 = /** @class */ (function (_super) {
        __extends(SimpleButton$$1, _super);
        /**
         * Creates a new SimpleButton instance. Any or all of the display objects that represent
         * the various button states can be set as parameters in the constructor.
         * @param	upState	The initial value for the SimpleButton up state.
         * @param	overState	The initial value for the SimpleButton over state.
         * @param	downState	The initial value for the SimpleButton down state.
         * @param	hitTestState	The initial value for the SimpleButton hitTest state.
         */
        function SimpleButton$$1(upState, overState, downState, hitTestState) {
            if (upState === void 0) { upState = null; }
            if (overState === void 0) { overState = null; }
            if (downState === void 0) { downState = null; }
            if (hitTestState === void 0) { hitTestState = null; }
            return _super.call(this) || this;
        }
        SimpleButton$$1.prototype.initAdapter = function () {
            if (this.executeConstructor) {
                FrameScriptManager.queue_as3_constructor(this.adaptee);
            }
        };
        SimpleButton$$1.prototype.registerScriptObject = function (child) {
        };
        SimpleButton$$1.prototype.unregisterScriptObject = function (child) {
        };
        Object.defineProperty(SimpleButton$$1.prototype, "downState", {
            /**
             * Specifies a display object that is used as the visual
             * object for the button "Down" state —the state that the button is in when the user
             * selects the hitTestState object.
             */
            get: function () {
                console.log("downState not implemented yet in flash/SimpleButton");
                return null;
            },
            set: function (value) {
                console.log("downState not implemented yet in flash/SimpleButton");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton$$1.prototype, "enabled", {
            /**
             * A Boolean value that specifies whether a button is enabled. When a
             * button is disabled (the enabled property is set to false),
             * the button is visible but cannot be clicked. The default value is
             * true. This property is useful if you want to
             * disable part of your navigation; for example, you might want to disable a
             * button in the currently displayed page so that it can't be clicked and
             * the page cannot be reloaded.
             *
             *   Note: To prevent mouseClicks on a button, set both the enabled
             * and mouseEnabled properties to false.
             */
            get: function () {
                console.log("enabled not implemented yet in flash/SimpleButton");
                return false;
            },
            set: function (value) {
                console.log("enabled not implemented yet in flash/SimpleButton");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton$$1.prototype, "hitTestState", {
            /**
             * Specifies a display object that is used as the hit testing object for the button. For a basic button, set the
             * hitTestState property to the same display object as the overState
             * property. If you do not set the hitTestState property, the SimpleButton
             * is inactive — it does not respond to user input events.
             */
            get: function () {
                console.log("hitTestState not implemented yet in flash/SimpleButton");
                return null;
            },
            set: function (value) {
                console.log("hitTestState not implemented yet in flash/SimpleButton");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton$$1.prototype, "overState", {
            /**
             * Specifies a display object that is used as the visual
             * object for the button over state — the state that the button is in when
             * the pointer is positioned over the button.
             */
            get: function () {
                console.log("overState not implemented yet in flash/SimpleButton");
                return null;
            },
            set: function (value) {
                console.log("overState not implemented yet in flash/SimpleButton");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton$$1.prototype, "soundTransform", {
            /**
             * The SoundTransform object assigned to this button. A SoundTransform object
             * includes properties for setting volume, panning, left speaker assignment, and right
             * speaker assignment. This SoundTransform object applies to all states of the button.
             * This SoundTransform object affects only embedded sounds.
             * @internal	Should information from AS2 setTransform be here? e.g. percentage values indicating
             *   how much of the left input to play in the left speaker or right speaker; it is generally
             *   best to use 22-KHZ 6-bit mono sounds?
             */
            get: function () {
                console.log("soundTransform not implemented yet in flash/SimpleButton");
                return null;
            },
            set: function (sndTransform) {
                console.log("soundTransform not implemented yet in flash/SimpleButton");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton$$1.prototype, "trackAsMenu", {
            /**
             * Indicates whether other display objects that are SimpleButton or MovieClip objects can receive
             * user input release events. The trackAsMenu property lets you create menus. You
             * can set the trackAsMenu property on any SimpleButton or MovieClip object.
             * If the trackAsMenu property does not exist, the default behavior is
             * false.
             *
             *   You can change the trackAsMenu property at any time; the
             * modified button immediately takes on the new behavior.
             */
            get: function () {
                console.log("trackAsMenu not implemented yet in flash/SimpleButton");
                return false;
            },
            set: function (value) {
                console.log("trackAsMenu not implemented yet in flash/SimpleButton");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton$$1.prototype, "upState", {
            /**
             * Specifies a display object that is used as the visual
             * object for the button up state — the state that the button is in when
             * the pointer is not positioned over the button.
             */
            get: function () {
                console.log("upState not implemented yet in flash/SimpleButton");
                return null;
            },
            set: function (value) {
                console.log("upState not implemented yet in flash/SimpleButton");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SimpleButton$$1.prototype, "useHandCursor", {
            /**
             * A Boolean value that, when set to true, indicates whether
             * the hand cursor is shown when the pointer rolls over a button.
             * If this property is set to false, the arrow pointer cursor is displayed
             * instead. The default is true.
             *
             *   You can change the useHandCursor property at any time;
             * the modified button immediately uses the new cursor behavior.
             * @maelexample	Create two buttons on the Stage with the instance names <code>myBtn1_btn</code> and <code>myBtn2_btn</code>. Enter the following ActionScript in Frame 1 of the Timeline:
             *   <listing>
             *   myBtn1_btn.useHandCursor = false;
             *   myBtn1_btn.onRelease = buttonClick;
             *   myBtn2_btn.onRelease = buttonClick;
             *   function buttonClick() {
                 *   trace(this._name);
                 *   }
             *   </listing><p class="- topic/p ">When the mouse is over and clicks <code>myBtn1_btn</code>, there is no pointing hand. However, you see the pointing hand when the button is over and clicks <code>myBtn2_btn</code>.</p>
             */
            get: function () {
                console.log("useHandCursor not implemented yet in flash/SimpleButton");
                return false;
            },
            set: function (value) {
                console.log("useHandCursor not implemented yet in flash/SimpleButton");
            },
            enumerable: true,
            configurable: true
        });
        return SimpleButton$$1;
    }(MovieClip$1));

    /**
     * Flash Player dispatches the textInteractionModeChange event when a user
     * changes the interaction mode of a text field.
     [Event(name="textInteractionModeChange", type="flash.events.Event")]

     * Flash Player dispatches the textInput event when a user enters one or more
     * characters of text.
     * @eventType	flash.events.TextEvent.TEXT_INPUT
     [Event(name="textInput", type="flash.events.TextEvent")]

     * Dispatched by a TextField object after the user scrolls.
     * @eventType	flash.events.Event.SCROLL
     [Event(name="scroll", type="flash.events.Event")]

     * Dispatched when a user clicks a hyperlink in an
     * HTML-enabled text field, where the URL begins with "event:".
     * @eventType	flash.events.TextEvent.LINK
     *
     [Event(name="link", type="flash.events.TextEvent")]

     * Dispatched after a control value is modified, unlike
     * the textInput event, which is dispatched before the value is modified.
     * @eventType	flash.events.Event.CHANGE
     [Event(name="change", type="flash.events.Event")]

     * The TextField class is used to create display objects for text display and input.
     * <ph outputclass="flexonly" class="- topic/ph ">You can use the TextField class to perform low-level text rendering.
     * However, in Flex, you typically use the Label, Text, TextArea, and TextInput controls to process text.</ph><ph outputclass="flashonly" class="- topic/ph ">You can give a text field an instance name in the Property inspector and
     * use the methods and properties of the TextField class to manipulate it with ActionScript.
     * TextField instance names are displayed in the Movie Explorer and in the Insert Target Path dialog box
     * in the Actions panel.</ph><p class="- topic/p ">To create a text field dynamically, use the <codeph class="+ topic/ph pr-d/codeph ">TextField()</codeph> constructor.</p><p class="- topic/p ">The methods of the TextField class let you set, select, and manipulate text in a dynamic or input
     * text field that you create during authoring or at runtime. </p><p class="- topic/p ">ActionScript provides several ways to
     * format your text at runtime. The TextFormat class lets you set character and paragraph formatting
     * for TextField objects. You can apply Cascading Style Sheets (CSS) styles
     * to text fields by using the <codeph class="+ topic/ph pr-d/codeph ">TextField.styleSheet</codeph> property and the StyleSheet class. You can use CSS to
     * style built-in HTML tags, define new formatting tags, or apply styles.
     * You can assign HTML formatted text, which optionally uses CSS styles, directly to a text
     * field. HTML text that you assign to a text field can contain embedded
     * media (movie clips, SWF files, GIF files, PNG files, and JPEG files). The text wraps around the
     * embedded media in the same way that a web browser wraps text around media embedded in an HTML document. </p><p class="- topic/p ">Flash Player supports a subset of HTML tags that you can use to format text. See the list of supported
     * HTML tags in the description of the <codeph class="+ topic/ph pr-d/codeph ">htmlText</codeph> property.</p>
     */
    var TextField$1 = /** @class */ (function (_super) {
        __extends(TextField$$1, _super);
        /**
         * Creates a new TextField instance. After you create the TextField instance, call the
         * addChild() or addChildAt() method of the parent
         * DisplayObjectContainer object to add the TextField instance to the display list.
         * The default size for a text field is 100 x 100 pixels.
         */
        function TextField$$1() {
            var _this = _super.call(this) || this;
            _this.adaptee.autoSize = TextFieldAutoSize.NONE;
            _this.adaptee.textFormat.align = TextFormatAlign.CENTER;
            //(<AwayTextField> this._adaptee).width=100;//80pro!
            // register all events for Textfield as dummys right now
            _this.eventMappingDummys[TextEvent.TEXT_INPUT] = "TextField:TextEvent.TEXT_INPUT";
            _this.eventMappingDummys[TextEvent.LINK] = "TextField:TextEvent.LINK";
            _this.eventMappingDummys[Event.SCROLL] = "TextField:Event.SCROLL";
            _this.eventMappingDummys[Event.CHANGE] = "TextField:Event.CHANGE";
            _this.eventMappingDummys[Event.TEXT_INTERACTION_MODE_CHANGE] = "TextField:Event.TEXT_INTERACTION_MODE_CHANGE";
            return _this;
        }
        TextField$$1.getNewTextField = function (adaptee) {
            if (adaptee === void 0) { adaptee = null; }
            if (TextField$$1._textFields.length) {
                var textField = TextField$$1._textFields.pop();
                textField.adaptee = adaptee || TextField.getNewTextField();
                return textField;
            }
            return new TextField$$1();
        };
        TextField$$1.prototype.createAdaptee = function () {
            var newAdaptee = TextField.getNewTextField();
            this.noReset = true;
            newAdaptee.reset();
            return newAdaptee;
        };
        TextField$$1.prototype.initAdapter = function () {
            if (this.executeConstructor) {
                FrameScriptManager.queue_as3_constructor(this.adaptee);
            }
        };
        TextField$$1.prototype.dispatchKeyEvent = function (charCode, isShift, isCTRL, isAlt) {
        };
        TextField$$1.prototype.selectTextField = function () {
        };
        TextField$$1.prototype.clone = function () {
            var clone = constructClassFromSymbol(this._symbol, this._symbol.symbolClass);
            //var clone:TextField = new this.sec.flash.text.TextField();
            var newText = new TextField();
            this.adaptee.copyTo(newText);
            clone.adaptee = newText;
            clone._stage = this.activeStage;
            clone.executeConstructor = function () {
                clone.axInitializer();
            };
            return clone;
        };
        /**
         * @inheritDoc
         */
        TextField$$1.prototype.dispose = function () {
            this.disposeValues();
            TextField$$1._textFields.push(this);
        };
        Object.defineProperty(TextField$$1.prototype, "alwaysShowSelection", {
            /**
             * When set to true and the text field is not in focus, Flash Player highlights the
             * selection in the text field in gray. When set to false and the text field is not in
             * focus, Flash Player does not highlight the selection in the text field.
             */
            get: function () {
                return this._adaptee.alwaysShowSelection;
            },
            set: function (value) {
                this._adaptee.alwaysShowSelection = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "antiAliasType", {
            /**
             * The type of anti-aliasing used for this text field. Use flash.text.AntiAliasType
             * constants for this property. You can control this setting only if the font is
             * embedded (with the embedFonts property set to true).
             * The default setting is flash.text.AntiAliasType.NORMAL.
             *
             *   To set values for this property, use the following string values:String valueDescriptionflash.text.AntiAliasType.NORMALApplies the regular text anti-aliasing. This value matches the type of anti-aliasing that
             * Flash Player 7 and earlier versions used.flash.text.AntiAliasType.ADVANCEDApplies advanced anti-aliasing, which makes text more legible. (This feature became
             * available in Flash Player 8.) Advanced anti-aliasing allows for high-quality rendering
             * of font faces at small sizes. It is best used with applications
             * with a lot of small text. Advanced anti-aliasing is not recommended for
             * fonts that are larger than 48 points.
             */
            get: function () {
                return ""; //(<AwayTextField> this._adaptee).antiAliasType;
            },
            set: function (antiAliasType) {
                //(<AwayTextField> this._adaptee).antiAliasType=value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "autoSize", {
            /**
             * Controls automatic sizing and alignment of text fields.
             * Acceptable values for the TextFieldAutoSize constants: TextFieldAutoSize.NONE (the default),
             * TextFieldAutoSize.LEFT, TextFieldAutoSize.RIGHT, and TextFieldAutoSize.CENTER.
             *
             *   If autoSize is set to TextFieldAutoSize.NONE (the default) no resizing occurs.If autoSize is set to TextFieldAutoSize.LEFT, the text is
             * treated as left-justified text, meaning that the left margin of the text field remains fixed and any
             * resizing of a single line of the text field is on the right margin. If the text includes a line break
             * (for example, "\n" or "\r"), the bottom is also resized to fit the next
             * line of text. If wordWrap is also set to true, only the bottom
             * of the text field is resized and the right side remains fixed.If autoSize is set to TextFieldAutoSize.RIGHT, the text is treated as
             * right-justified text, meaning that the right margin of the text field remains fixed and any resizing
             * of a single line of the text field is on the left margin. If the text includes a line break
             * (for example, "\n" or "\r"), the bottom is also resized to fit the next
             * line of text. If wordWrap is also set to true, only the bottom
             * of the text field is resized and the left side remains fixed.If autoSize is set to TextFieldAutoSize.CENTER, the text is treated as
             * center-justified text, meaning that any resizing of a single line of the text field is equally distributed
             * to both the right and left margins. If the text includes a line break (for example, "\n" or
             * "\r"), the bottom is also resized to fit the next line of text. If wordWrap is also
             * set to true, only the bottom of the text field is resized and the left and
             * right sides remain fixed.
             * @throws	ArgumentError The autoSize specified is not a member of flash.text.TextFieldAutoSize.
             */
            get: function () {
                return this._adaptee.autoSize;
            },
            set: function (value) {
                this._adaptee.autoSize = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "background", {
            /**
             * Specifies whether the text field has a background fill. If true, the text field has a
             * background fill. If false, the text field has no background fill.
             * Use the backgroundColor property to set the background color of a text field.
             */
            get: function () {
                return this._adaptee.background;
            },
            set: function (value) {
                this._adaptee.background = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "backgroundColor", {
            /**
             * The color of the text field background. The default value is 0xFFFFFF (white).
             * This property can be retrieved or set, even if there currently is no background, but the
             * color is visible only if the text field has the background property set to
             * true.
             */
            get: function () {
                return this._adaptee.backgroundColor;
            },
            set: function (value) {
                this._adaptee.backgroundColor = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "border", {
            /**
             * Specifies whether the text field has a border. If true, the text field has a border.
             * If false, the text field has no border. Use the borderColor property
             * to set the border color.
             */
            get: function () {
                return this._adaptee.border;
            },
            set: function (value) {
                this._adaptee.border = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "borderColor", {
            /**
             * The color of the text field border. The default value is 0x000000 (black).
             * This property can be retrieved or set, even if there currently is no border, but the
             * color is visible only if the text field has the border property set to
             * true.
             */
            get: function () {
                return this._adaptee.borderColor;
            },
            set: function (value) {
                this._adaptee.borderColor = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "bottomScrollV", {
            /**
             * An integer (1-based index) that indicates the bottommost line that is currently visible in
             * the specified text field. Think of the text field as a window onto a block of text.
             * The scrollV property is the 1-based index of the topmost visible line
             * in the window.
             *
             *   All the text between the lines indicated by scrollV and bottomScrollV
             * is currently visible in the text field.
             */
            get: function () {
                //todo
                throw ("bottomScrollV not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "caretIndex", {
            /**
             * The index of the insertion point (caret) position. If no insertion point is displayed,
             * the value is the position the insertion point would be if you restored focus to the field (typically where the
             * insertion point last was, or 0 if the field has not had focus).
             *
             *   Selection span indexes are zero-based (for example, the first position is 0,
             * the second position is 1, and so on).
             */
            get: function () {
                //todo
                throw ("caretIndex not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "condenseWhite", {
            /**
             * A Boolean value that specifies whether extra white space (spaces, line breaks, and so on)
             * in a text field with HTML text is removed. The default value is false.
             * The condenseWhite property only affects text set with
             * the htmlText property, not the text property. If you set
             * text with the text property, condenseWhite is ignored.
             *
             *   If condenseWhite is set to true, use standard HTML commands such as
             * <BR> and <P> to place line breaks in the text field.Set the condenseWhite property before setting the htmlText property.
             */
            get: function () {
                //todo
                throw ("condenseWhite not implemented yet in flash/TextField");
            },
            set: function (value) {
                //todo
                throw ("condenseWhite not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "defaultTextFormat", {
            /**
             * Specifies the format applied to newly inserted text, such as text entered by a user or text inserted with the
             * replaceSelectedText() method.
             *
             *   Note: When selecting characters to be replaced with setSelection() and
             * replaceSelectedText(), the defaultTextFormat will be applied only if the
             * text has been selected up to and including the last character. Here is an example:
             * var my_txt:TextField new TextField();
             * my_txt.text = "Flash Macintosh version";
             * var my_fmt:TextFormat = new TextFormat();
             * my_fmt.color = 0xFF0000;
             * my_txt.defaultTextFormat = my_fmt;
             * my_txt.setSelection(6,15); // partial text selected - defaultTextFormat not applied
             * my_txt.setSelection(6,23); // text selected to end - defaultTextFormat applied
             * my_txt.replaceSelectedText("Windows version");
             * When you access the defaultTextFormat property, the returned TextFormat object has all
             * of its properties defined. No property is null.Note: You can't set this property if a style sheet is applied to the text field.
             * @throws	Error This method cannot be used on a text field with a style sheet.
             */
            get: function () {
                return (this._adaptee.textFormat.adapter);
            },
            set: function (format) {
                console.log("todo TextFormat");
                //<TextFormat><any>(<AwayTextField> this._adaptee).textFormat.adapter=format;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "displayAsPassword", {
            /**
             * Specifies whether the text field is a password text field. If the value of this property is true,
             * the text field is treated as a password text field and hides the input characters using asterisks instead of the
             * actual characters. If false, the text field is not treated as a password text field. When password mode
             * is enabled, the Cut and Copy commands and their corresponding keyboard shortcuts will
             * not function.  This security mechanism prevents an unscrupulous user from using the shortcuts to discover
             * a password on an unattended computer.
             */
            get: function () {
                return this._adaptee.displayAsPassword;
            },
            set: function (value) {
                this._adaptee.displayAsPassword = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "embedFonts", {
            /**
             * Specifies whether to render by using embedded font outlines.
             * If false, Flash Player renders the text field by using
             * device fonts.
             *
             *   If you set the embedFonts property to true for a text field,
             * you must specify a font for that text by using the font property of
             * a TextFormat object applied to the text field.
             * If the specified font is not embedded in the SWF file, the text is not displayed.
             */
            get: function () {
                //todo
                //console.log("embedFonts not implemented yet in flash/TextField");
                return false;
            },
            set: function (value) {
                //todo
                //console.log("embedFonts not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "gridFitType", {
            /**
             * The type of grid fitting used for this text field. This property applies only if the
             * flash.text.AntiAliasType property of the text field is set to flash.text.AntiAliasType.ADVANCED.
             *
             *   The type of grid fitting used determines whether Flash Player forces strong horizontal and
             * vertical lines to fit to a pixel or subpixel grid, or not at all.For the flash.text.GridFitType property, you can use the following string values:String valueDescriptionflash.text.GridFitType.NONESpecifies no grid fitting. Horizontal and vertical lines in the glyphs are not
             * forced to the pixel grid. This setting is recommended for animation or
             * for large font sizes.flash.text.GridFitType.PIXELSpecifies that strong horizontal and vertical lines are fit to the
             * pixel grid. This setting works only for left-aligned text fields.
             * To use this setting, the flash.dispaly.AntiAliasType property of the text field
             * must be set to flash.text.AntiAliasType.ADVANCED.
             * This setting generally provides the best legibility for
             * left-aligned text.flash.text.GridFitType.SUBPIXELSpecifies that strong horizontal and vertical lines are fit to the subpixel grid on
             * an LCD monitor. To use this setting, the
             * flash.text.AntiAliasType property of the text field must be set to
             * flash.text.AntiAliasType.ADVANCED. The flash.text.GridFitType.SUBPIXEL setting is often good
             * for right-aligned or centered
             * dynamic text, and it is sometimes a useful trade-off for animation versus text quality.
             */
            get: function () {
                //todo
                return "";
                //throw("gridFitType not implemented yet in flash/TextField");
            },
            set: function (gridFitType) {
                //todo
                //throw("gridFitType not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "htmlText", {
            /**
             * Contains the HTML representation of the text field contents.
             *
             *   Flash Player supports the following HTML tags:
             * Tag
             *
             *   Description
             *
             *   Anchor tag
             *
             *   The <a> tag creates a hypertext link and supports the following attributes:
             * target: Specifies the name of the target window where you load the page.
             * Options include _self, _blank, _parent, and
             * _top. The _self option specifies the current frame in the current window,
             * _blank specifies a new window, _parent specifies the parent of the
             * current frame, and _top specifies the top-level frame in the current window.
             * href: Specifies a URL or an ActionScript link event.The URL can
             * be either absolute or relative to the location of the SWF file that
             * is loading the page. An example of an absolute reference to a URL is
             * http://www.adobe.com; an example of a relative reference is
             * /index.html. Absolute URLs must be prefixed with
             * http://; otherwise, Flash Player or AIR treats them as relative URLs.
             *
             *   You can use the link event to cause the link to execute an ActionScript
             * function in a SWF file instead of opening a URL. To specify a link event, use
             * the event scheme instead of the http scheme in your href attribute. An example
             * is href="event:myText" instead of href="http://myURL"; when the
             * user clicks a hypertext link that contains the event scheme, the text field dispatches a
             * link TextEvent with its text property set to "myText". You can then create an ActionScript
             * function that executes whenever the link TextEvent is dispatched.
             *
             *   You can also define a:link, a:hover, and a:active
             * styles for anchor tags by using style sheets.
             *
             *   Bold tag
             *
             *   The <b> tag renders text as bold. A bold typeface must be available for the font used.
             *
             *   Break tag
             *
             *   The <br> tag creates a line break in the text field. Set the text field to
             * be a multiline text field to use this tag.
             *
             *   Font tag
             *
             *   The <font> tag specifies a font or list of fonts to display the text.The font tag
             * supports the following attributes:
             * color: Only hexadecimal color (#FFFFFF) values are supported.
             * face: Specifies the name of the font to use. As shown in the following example,
             * you can specify a list of comma-delimited font names, in which case Flash Player selects the first available
             * font. If the specified font is not installed on the local computer system or isn't embedded in the SWF file,
             * Flash Player selects a substitute font.
             * size: Specifies the size of the font. You can use absolute pixel sizes, such as 16 or 18,
             * or relative point sizes, such as +2 or -4.
             *
             *   Image tag
             *
             *   The <img> tag lets you embed external image files (JPEG, GIF, PNG), SWF files, and
             * movie clips inside text fields. Text automatically flows around images you embed in text fields. You
             * must set the text field to be multiline to wrap text around an image.
             *
             *   The <img> tag supports the following attributes: src: Specifies the URL to an image or SWF file, or the linkage identifier for a movie clip
             * symbol in the library. This attribute is required; all other attributes are optional. External files (JPEG, GIF, PNG,
             * and SWF files) do not show until they are downloaded completely.
             * width: The width of the image, SWF file, or movie clip being inserted, in pixels.
             * height: The height of the image, SWF file, or movie clip being inserted, in pixels.
             * align: Specifies the horizontal alignment of the embedded image within the text field.
             * Valid values are left and right. The default value is left.
             * hspace: Specifies the amount of horizontal space that surrounds the image where
             * no text appears. The default value is 8.
             * vspace: Specifies the amount of vertical space that surrounds the image where no
             * text appears. The default value is 8.
             * id: Specifies the name for the movie clip instance (created by Flash Player) that contains
             * the embedded image file, SWF file, or movie clip. This approach is used to control the embedded content with
             * ActionScript.
             * checkPolicyFile: Specifies that Flash Player checks for a URL policy file
             * on the server associated with the image domain. If a policy file exists, SWF files in the domains
             * listed in the file can access the data of the loaded image, for example, by calling the
             * BitmapData.draw() method with this image as the source parameter.
             * For more information related to security, see the Flash Player Developer Center Topic:
             * Security.
             *
             *   Flash displays media embedded in a text field at full size. To specify the dimensions of the media
             * you are embedding, use the <img> tag height and width
             * attributes. In general, an image embedded in a text field appears on the line following the
             * <img> tag. However, when the <img> tag
             * is the first character in the text field, the image appears on the first line of the text field. For AIR content in the application security sandbox, AIR ignores img tags in
             * HTML content in ActionScript TextField objects. This is to prevent possible phishing attacks,
             * Italic tag
             *
             *   The <i> tag displays the tagged text in italics. An italic typeface must be available
             * for the font used.
             *
             *   List item tag
             *
             *   The <li> tag places a bullet in front of the text that it encloses.
             * Note: Because Flash Player and AIR do not recognize ordered and unordered list tags (<ol>
             * and <ul>, they do not modify how your list is rendered. All lists are unordered and all
             * list items use bullets.
             *
             *   Paragraph tag
             *
             *   The <p> tag creates a new paragraph. The text field must be set to be a multiline
             * text field to use this tag.
             *
             *   The <p> tag supports the following attributes:
             *
             *   align: Specifies alignment of text within the paragraph; valid values are left, right, justify, and center.
             *
             *   class: Specifies a CSS style class defined by a flash.text.StyleSheet object.
             *
             *   Span tag
             *
             *   The <span> tag is available only for use with CSS text styles. It supports the
             * following attribute:
             *
             *   class: Specifies a CSS style class defined by a flash.text.StyleSheet object.
             *
             *   Text format tag
             * The <textformat> tag lets you use a subset of paragraph formatting
             * properties of the TextFormat class within text fields, including line leading, indentation,
             * margins, and tab stops. You can combine <textformat> tags with the
             * built-in HTML tags. The <textformat> tag has the following attributes: blockindent: Specifies the block indentation in points; corresponds to
             * TextFormat.blockIndent.
             * indent: Specifies the indentation from the left margin to the first character
             * in the paragraph; corresponds to TextFormat.indent. Both positive and negative
             * numbers are acceptable.
             * leading: Specifies the amount of leading (vertical space) between lines;
             * corresponds to TextFormat.leading. Both positive and negative numbers are acceptable.
             * leftmargin: Specifies the left margin of the paragraph, in points; corresponds
             * to TextFormat.leftMargin.
             * rightmargin: Specifies the right margin of the paragraph, in points; corresponds
             * to TextFormat.rightMargin.
             * tabstops: Specifies custom tab stops as an array of non-negative integers;
             * corresponds to TextFormat.tabStops.
             *
             *   Underline tag
             *
             *   The <u> tag underlines the tagged text.
             * Flash Player and AIR support the following HTML entities:
             * Entity
             *
             *   Description
             *
             *   &amp;lt;
             *
             *   < (less than)
             *
             *   &amp;gt;
             *
             *   > (greater than)
             *
             *   &amp;amp;
             *
             *   & (ampersand)
             *
             *   &amp;quot;
             *
             *   " (double quotes)
             *
             *   &amp;apos;
             *
             *   ' (apostrophe, single quote)
             *
             *   Flash Player and AIR also support explicit character codes, such as
             * &#38; (ASCII ampersand) and &#x20AC; (Unicode € symbol).
             */
            get: function () {
                return this.adaptee.htmlText;
            },
            set: function (value) {
                this.adaptee.htmlText = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "length", {
            /**
             * The number of characters in a text field. A character such as tab (\t) counts as one
             * character.
             */
            get: function () {
                //todo
                return this._adaptee.length;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "maxChars", {
            /**
             * The maximum number of characters that the text field can contain, as entered by a user.
             * A script can insert more text than maxChars allows; the maxChars property
             * indicates only how much text a user can enter. If the value of this property is 0,
             * a user can enter an unlimited amount of text.
             */
            get: function () {
                //todo
                console.log("maxChars not implemented yet in flash/TextField");
                return 0;
            },
            set: function (value) {
                //todo
                console.log("maxChars not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "maxScrollH", {
            /**
             * The maximum value of scrollH.
             */
            get: function () {
                //todo
                //console.log("maxScrollH not implemented yet in flash/TextField");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "maxScrollV", {
            /**
             * The maximum value of scrollV.
             */
            get: function () {
                //todo
                //console.log("maxScrollV not implemented yet in flash/TextField");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "mouseWheelEnabled", {
            /**
             * A Boolean value that indicates whether Flash Player automatically scrolls multiline
             * text fields when the user clicks a text field and rolls the mouse wheel.
             * By default, this value is true. This property is useful if you want to prevent
             * mouse wheel scrolling of text fields, or implement your own text field scrolling.
             */
            get: function () {
                //todo
                //console.log("mouseWheelEnabled not implemented yet in flash/TextField");
                return false;
            },
            set: function (value) {
                //todo
                //console.log("mouseWheelEnabled not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "multiline", {
            /**
             * Indicates whether field is a multiline text field. If the value is true,
             * the text field is multiline; if the value is false, the text field is a single-line
             * text field. In a field of type TextFieldType.INPUT, the multiline value
             * determines whether the Enter key creates a new line (a value of false,
             * and the Enter key is ignored).
             * If you paste text into a TextField with a multiline value of false,
             * newlines are stripped out of the text.
             */
            get: function () {
                //todo
                //console.log("multiline not implemented yet in flash/TextField");
                return this._adaptee.multiline;
            },
            set: function (value) {
                //todo
                //console.log("multiline not implemented yet in flash/TextField");
                this._adaptee.multiline = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "numLines", {
            /**
             * Defines the number of text lines in a multiline text field.
             * If wordWrap property is set to true,
             * the number of lines increases when text wraps.
             */
            get: function () {
                //todo
                console.log("numLines not implemented yet in flash/TextField");
                return this._adaptee.numLines;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "restrict", {
            /**
             * Indicates the set of characters that a user can enter into the text field. If the value of the
             * restrict property is null, you can enter any character. If the value of
             * the restrict property is an empty string, you cannot enter any character. If the value
             * of the restrict property is a string of characters, you can enter only characters in
             * the string into the text field. The string is scanned from left to right. You can specify a range by
             * using the hyphen (-) character. Only user interaction is restricted; a script can put any text into the
             * text field. This property does not synchronize with the Embed font options
             * in the Property inspector.If the string begins with a caret (^) character, all characters are initially accepted and
             * succeeding characters in the string are excluded from the set of accepted characters. If the string does
             * not begin with a caret (^) character, no characters are initially accepted and succeeding characters in the
             * string are included in the set of accepted characters.The following example allows only uppercase characters, spaces, and numbers to be entered into
             * a text field:
             * my_txt.restrict = "A-Z 0-9";
             * The following example includes all characters, but excludes lowercase letters:
             * my_txt.restrict = "^a-z";
             * You can use a backslash to enter a ^ or - verbatim. The accepted backslash sequences are \-, \^ or \\.
             * The backslash must be an actual character in the string, so when specified in ActionScript, a double backslash
             * must be used. For example, the following code includes only the dash (-) and caret (^):
             * my_txt.restrict = "\\-\\^";
             * The ^ can be used anywhere in the string to toggle between including characters and excluding characters.
             * The following code includes only uppercase letters, but excludes the uppercase letter Q:
             * my_txt.restrict = "A-Z^Q";
             * You can use the \u escape sequence to construct restrict strings.
             * The following code includes only the characters from ASCII 32 (space) to ASCII 126 (tilde).
             * my_txt.restrict = "\u0020-\u007E";
             */
            get: function () {
                return this.adaptee.restrict;
            },
            set: function (value) {
                this.adaptee.restrict = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "scrollH", {
            /**
             * The current horizontal scrolling position. If the scrollH property is 0, the text
             * is not horizontally scrolled. This property value is an integer that represents the horizontal
             * position in pixels.
             *
             *   The units of horizontal scrolling are pixels, whereas the units of vertical scrolling are lines.
             * Horizontal scrolling is measured in pixels because most fonts you typically use are proportionally
             * spaced; that is, the characters can have different widths. Flash Player performs vertical scrolling by
             * line because users usually want to see a complete line of text rather than a
             * partial line. Even if a line uses multiple fonts, the height of the line adjusts to fit
             * the largest font in use.Note: The scrollH property is zero-based, not 1-based like
             * the scrollV vertical scrolling property.
             */
            get: function () {
                //todo
                console.log("scrollH not implemented yet in flash/TextField");
                return 0;
            },
            set: function (value) {
                //todo
                console.log("scrollH not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "scrollV", {
            /**
             * The vertical position of text in a text field. The scrollV property is useful for
             * directing users to a specific paragraph in a long passage, or creating scrolling text fields.
             *
             *   The units of vertical scrolling are lines, whereas the units of horizontal scrolling are pixels.
             * If the first line displayed is the first line in the text field, scrollV is set to 1 (not 0).
             * Horizontal scrolling is measured in pixels because most fonts are proportionally
             * spaced; that is, the characters can have different widths. Flash performs vertical scrolling by line
             * because users usually want to see a complete line of text rather than a partial line.
             * Even if there are multiple fonts on a line, the height of the line adjusts to fit the largest font in
             * use.
             */
            get: function () {
                //todo
                console.log("scrollV not implemented yet in flash/TextField");
                return 0;
            },
            set: function (value) {
                //todo
                console.log("scrollV not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "selectable", {
            /**
             * A Boolean value that indicates whether the text field is selectable. The value true
             * indicates that the text is selectable. The selectable property controls whether
             * a text field is selectable, not whether a text field is editable. A dynamic text field can
             * be selectable even if it is not editable. If a dynamic text field is not selectable, the user
             * cannot select its text.
             *
             *   If selectable is set to false, the text in the text field does not
             * respond to selection commands from the mouse or keyboard, and the text cannot be copied with the
             * Copy command. If selectable is set to true, the text in the text field
             * can be selected with the mouse or keyboard, and the text can be copied with the Copy command.
             * You can select text this way even if the text field is a dynamic text field instead of an input text field.
             */
            get: function () {
                //todo
                //console.log("selectable not implemented yet in flash/TextField");
                return false;
            },
            set: function (value) {
                //todo
                this._adaptee.selectable = value;
                //console.log("selectable not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "selectedText", {
            get: function () {
                //todo
                console.log("selectedText not implemented yet in flash/TextField");
                return "";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "selectionBeginIndex", {
            /**
             * The zero-based character index value of the first character in the current selection.
             * For example, the first character is 0, the second character is 1, and so on. If no
             * text is selected, this property is the value of caretIndex.
             */
            get: function () {
                //todo
                console.log("selectionBeginIndex not implemented yet in flash/TextField");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "selectionEndIndex", {
            /**
             * The zero-based character index value of the last character in the current selection.
             * For example, the first character is 0, the second character is 1, and so on. If no
             * text is selected, this property is the value of caretIndex.
             */
            get: function () {
                //todo
                console.log("selectionEndIndex not implemented yet in flash/TextField");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "sharpness", {
            /**
             * The sharpness of the glyph edges in this text field. This property applies
             * only if the flash.text.AntiAliasType property of the text field is set to
             * flash.text.AntiAliasType.ADVANCED. The range for
             * sharpness is a number from -400 to 400. If you attempt to set
             * sharpness to a value outside that range, Flash sets the property to
             * the nearest value in the range (either -400 or 400).
             */
            get: function () {
                //todo
                console.log("sharpness not implemented yet in flash/TextField");
                return 0;
            },
            set: function (value) {
                //todo
                console.log("sharpness not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "styleSheet", {
            /**
             * Attaches a style sheet to the text field. For information on creating style sheets, see the StyleSheet class
             * and the ActionScript 3.0 Developer's Guide.
             *
             *   You can change the style sheet associated with a text field at any time. If you change
             * the style sheet in use, the text field is redrawn with the new style sheet.
             * You can set the style sheet to null or undefined
             * to remove the style sheet. If the style sheet in use is removed, the text field is redrawn without a style sheet. Note: If the style sheet is removed, the contents of both TextField.text and
             * TextField.htmlText change to incorporate the formatting previously applied by the style sheet. To preserve
             * the original TextField.htmlText contents without the formatting, save the value in a variable before
             * removing the style sheet.
             */
            get: function () {
                //todo
                console.log("styleSheet not implemented yet in flash/TextField");
                return null;
            },
            set: function (value) {
                //todo
                console.log("styleSheet not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "text", {
            /**
             * A string that is the current text in the text field. Lines are separated by the carriage
             * return character ('\r', ASCII 13). This property contains unformatted text in the text
             * field, without HTML tags.
             *
             *   To get the text in HTML form, use the htmlText property.
             */
            get: function () {
                return this._adaptee.text;
            },
            set: function (value) {
                this._adaptee.text = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "textColor", {
            /**
             * The color of the text in a text field, in hexadecimal format.
             * The hexadecimal color system uses six digits to represent
             * color values. Each digit has 16 possible values or characters. The characters range from
             * 0-9 and then A-F. For example, black is 0x000000; white is
             * 0xFFFFFF.
             */
            get: function () {
                return this._adaptee.textColor;
            },
            set: function (value) {
                this._adaptee.textColor = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "textHeight", {
            /**
             * The height of the text in pixels.
             */
            get: function () {
                return this._adaptee.textHeight;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "textInteractionMode", {
            /**
             * The interaction mode property, Default value is TextInteractionMode.NORMAL.
             * On mobile platforms, the normal mode implies that the text can be scrolled but not selected.
             * One can switch to the selectable mode through the in-built context menu on the text field.
             * On Desktop, the normal mode implies that the text is in scrollable as well as selection mode.
             */
            get: function () {
                //todo
                console.log("textInteractionMode not implemented yet in flash/TextField");
                return "";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "textWidth", {
            /**
             * The width of the text in pixels.
             */
            get: function () {
                return this._adaptee.textWidth;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "thickness", {
            /**
             * The thickness of the glyph edges in this text field. This property applies only
             * when flash.text.AntiAliasType is set to flash.text.AntiAliasType.ADVANCED.
             *
             *   The range for thickness is a number from -200 to 200. If you attempt to
             * set thickness to a value outside that range, the property is set to the
             * nearest value in the range (either -200 or 200).
             */
            get: function () {
                //todo
                console.log("thickness not implemented yet in flash/TextField");
                return 0;
            },
            set: function (value) {
                //todo
                console.log("thickness not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "type", {
            /**
             * The type of the text field.
             * Either one of the following TextFieldType constants: TextFieldType.DYNAMIC,
             * which specifies a dynamic text field, which a user cannot edit, or TextFieldType.INPUT,
             * which specifies an input text field, which a user can edit.
             * @throws	ArgumentError The type specified is not a member of flash.text.TextFieldType.
             */
            get: function () {
                //todo
                console.log("type not implemented yet in flash/TextField");
                return "";
            },
            set: function (value) {
                //this.adaptee.
                //todo
                console.log("type not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "useRichTextClipboard", {
            /**
             * Specifies whether to copy and paste the text formatting along with the text. When set to true,
             * Flash Player copies and pastes formatting (such as alignment, bold, and italics) when you copy and paste between text fields. Both the origin and destination text fields for the copy and paste procedure must have
             * useRichTextClipboard set to true. The default value
             * is false.
             */
            get: function () {
                //todo
                console.log("useRichTextClipboard not implemented yet in flash/TextField");
                return false;
            },
            set: function (value) {
                //todo
                console.log("useRichTextClipboard not implemented yet in flash/TextField");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextField$$1.prototype, "wordWrap", {
            /**
             * A Boolean value that indicates whether the text field has word wrap. If the value of
             * wordWrap is true, the text field has word wrap;
             * if the value is false, the text field does not have word wrap. The default
             * value is false.
             */
            get: function () {
                return this._adaptee.wordWrap;
            },
            set: function (value) {
                this._adaptee.wordWrap = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Appends the string specified by the newText parameter to the end of the text
         * of the text field. This method is more efficient than an addition assignment (+=) on
         * a text property (such as someTextField.text += moreText),
         * particularly for a text field that contains a significant amount of content.
         * @param	newText	The string to append to the existing text.
         */
        TextField$$1.prototype.appendText = function (newText) {
            this._adaptee.appendText(newText);
        };
        TextField$$1.prototype.copyRichText = function () {
            //todo
            console.log("copyRichText not implemented yet in flash/TextField");
            return "";
        };
        /**
         * Returns a rectangle that is the bounding box of the character.
         * @param	charIndex	The zero-based index value for the character (for example, the first
         *   position is 0, the second position is 1, and so on).
         * @return	A rectangle with x and y minimum and maximum values
         *   defining the bounding box of the character.
         */
        TextField$$1.prototype.getCharBoundaries = function (charIndex) {
            //todo
            console.log("getCharBoundaries not implemented yet in flash/TextField");
            return null;
        };
        /**
         * Returns the zero-based index value of the character at the point specified by the x
         * and y parameters.
         * @param	x	The x coordinate of the character.
         * @param	y	The y coordinate of the character.
         * @return	The zero-based index value of the character (for example, the first position is 0,
         *   the second position is 1, and so on).  Returns -1 if the point is not over any character.
         */
        TextField$$1.prototype.getCharIndexAtPoint = function (x, y) {
            //todo
            console.log("getCharIndexAtPoint not implemented yet in flash/TextField");
            return 0;
        };
        /**
         * Given a character index, returns the index of the first character in the same paragraph.
         * @param	charIndex	The zero-based index value of the character (for example, the first character is 0,
         *   the second character is 1, and so on).
         * @return	The zero-based index value of the first character in the same paragraph.
         * @throws	RangeError The character index specified is out of range.
         */
        TextField$$1.prototype.getFirstCharInParagraph = function (charIndex) {
            //todo
            console.log("getFirstCharInParagraph not implemented yet in flash/TextField");
            return 0;
        };
        /**
         * Returns a DisplayObject reference for the given id, for an image or SWF file
         * that has been added to an HTML-formatted text field by using an <img> tag.
         * The <img> tag is in the following format:
         *
         *   <img src = 'filename.jpg' id = 'instanceName' >
         * @param	id	The id to match (in the id attribute of the
         *   <img> tag).
         * @return	The display object corresponding to the image or SWF file with the matching id
         *   attribute in the <img> tag of the text field. For media loaded from an external source,
         *   this object is a Loader object, and, once loaded, the media object is a child of that Loader object. For media
         *   embedded in the SWF file, it is the loaded object. If no <img> tag with
         *   the matching id exists, the method returns null.
         */
        TextField$$1.prototype.getImageReference = function (id) {
            //todo
            console.log("getImageReference not implemented yet in flash/TextField");
            return null;
        };
        /**
         * Returns the zero-based index value of the line at the point specified by the x
         * and y parameters.
         * @param	x	The x coordinate of the line.
         * @param	y	The y coordinate of the line.
         * @return	The zero-based index value of the line (for example, the first line is 0, the
         *   second line is 1, and so on).  Returns -1 if the point is not over any line.
         */
        TextField$$1.prototype.getLineIndexAtPoint = function (x, y) {
            //todo
            console.log("getLineIndexAtPoint not implemented yet in flash/TextField");
            return 0;
        };
        /**
         * Returns the zero-based index value of the line containing the character specified
         * by the charIndex parameter.
         * @param	charIndex	The zero-based index value of the character (for example, the first character is 0,
         *   the second character is 1, and so on).
         * @return	The zero-based index value of the line.
         */
        TextField$$1.prototype.getLineIndexOfChar = function (charIndex) {
            //todo
            console.log("getLineIndexOfChar not implemented yet in flash/TextField");
            return 0;
        };
        /**
         * Returns the number of characters in a specific text line.
         * @param	lineIndex	The line number for which you want the length.
         * @return	The number of characters in the line.
         * @throws	RangeError The line number specified is out of range.
         */
        TextField$$1.prototype.getLineLength = function (lineIndex) {
            //todo
            console.log("getLineLength not implemented yet in flash/TextField");
            return 0;
        };
        /**
         * Returns metrics information about a given text line.
         * @param	lineIndex	The line number for which you want metrics information.
         * @return	A TextLineMetrics object.
         * @throws	RangeError The line number specified is out of range.
         */
        TextField$$1.prototype.getLineMetrics = function (lineIndex) {
            //todo
            console.log("getLineMetrics not implemented yet in flash/TextField");
            return null;
        };
        /**
         * Returns the character index of the first character in the line that
         * the lineIndex parameter specifies.
         * @param	lineIndex	The zero-based index value of the line (for example, the first line is 0,
         *   the second line is 1, and so on).
         * @return	The zero-based index value of the first character in the line.
         * @throws	RangeError The line number specified is out of range.
         */
        TextField$$1.prototype.getLineOffset = function (lineIndex) {
            //todo
            console.log("getLineOffset not implemented yet in flash/TextField");
            return 0;
        };
        /**
         * Returns the text of the line specified by the lineIndex parameter.
         * @param	lineIndex	The zero-based index value of the line (for example, the first line is 0,
         *   the second line is 1, and so on).
         * @return	The text string contained in the specified line.
         * @throws	RangeError The line number specified is out of range.
         */
        TextField$$1.prototype.getLineText = function (lineIndex) {
            //todo
            console.log("getLineText not implemented yet in flash/TextField");
            return "";
        };
        /**
         * Given a character index, returns the length of the paragraph containing the given character.
         * The length is relative to the first character in the paragraph (as returned by
         * getFirstCharInParagraph()), not to the character index passed in.
         * @param	charIndex	The zero-based index value of the character (for example, the first character is 0,
         *   the second character is 1, and so on).
         * @return	Returns the number of characters in the paragraph.
         * @throws	RangeError The character index specified is out of range.
         */
        TextField$$1.prototype.getParagraphLength = function (charIndex) {
            //todo
            console.log("getParagraphLength not implemented yet in flash/TextField");
            return 0;
        };
        TextField$$1.prototype.getRawText = function () {
            //todo
            console.log("getRawText not implemented yet in flash/TextField");
            return "";
        };
        /**
         * Returns a TextFormat object that contains formatting information for the range of text that the
         * beginIndex and endIndex parameters specify. Only properties
         * that are common to the entire text specified are set in the resulting TextFormat object.
         * Any property that is mixed, meaning that it has different values
         * at different points in the text, has a value of null.
         *
         *   If you do not specify
         * values for these parameters, this method is applied to all the text in the text field.  The following table describes three possible usages:UsageDescriptionmy_textField.getTextFormat()Returns a TextFormat object containing formatting information for all text in a text field.
         * Only properties that are common to all text in the text field are set in the resulting TextFormat
         * object. Any property that is mixed, meaning that it has different values at different
         * points in the text, has a value of null.my_textField.getTextFormat(beginIndex:Number)Returns a TextFormat object containing a copy of the text format of the character at the
         * beginIndex position.my_textField.getTextFormat(beginIndex:Number,endIndex:Number)Returns a TextFormat object containing formatting information for the span of
         * text from beginIndex to endIndex-1. Only properties that are common
         * to all of the text in the specified range are set in the resulting TextFormat object. Any property
         * that is mixed (that is, has different values at different points in the range) has its value set to null.
         * @param	beginIndex	Optional; an integer that specifies the starting location of a range of text within the text field.
         * @param	endIndex	Optional; an integer that specifies the position of the first character after the desired
         *   text span. As designed, if you specify beginIndex and endIndex values,
         *   the text from beginIndex to endIndex-1 is read.
         * @return	The TextFormat object that represents the formatting properties for the specified text.
         * @throws	RangeError The beginIndex or endIndex specified is out of range.
         */
        TextField$$1.prototype.getTextFormat = function (beginIndex, endIndex) {
            if (beginIndex === void 0) { beginIndex = -1; }
            if (endIndex === void 0) { endIndex = -1; }
            // todo: support multiple formats
            console.log("todo: textformats");
            return null; //(<AwayTextField> this._adaptee).textFormat;
        };
        TextField$$1.prototype.getTextRuns = function (beginIndex, endIndex) {
            if (beginIndex === void 0) { beginIndex = 0; }
            if (endIndex === void 0) { endIndex = 2147483647; }
            //todo
            console.log("getTextRuns not implemented yet in flash/TextField");
            return [];
        };
        TextField$$1.prototype.getXMLText = function (beginIndex, endIndex) {
            if (beginIndex === void 0) { beginIndex = 0; }
            if (endIndex === void 0) { endIndex = 2147483647; }
            //todo
            console.log("getXMLText not implemented yet in flash/TextField");
            return "";
        };
        TextField$$1.prototype.insertXMLText = function (beginIndex, endIndex, richText, pasting) {
            if (pasting === void 0) { pasting = false; }
            //todo
            console.log("insertXMLText not implemented yet in flash/TextField");
        };
        /**
         * Returns true if an embedded font is available with the specified fontName and fontStyle
         * where Font.fontType is flash.text.FontType.EMBEDDED.  Starting with Flash Player 10,
         * two kinds of embedded fonts can appear in a SWF file.  Normal embedded fonts are only used with
         * TextField objects.
         * CFF embedded fonts are only used with the flash.text.engine classes.  The two types are distinguished by the
         * fontType property of the Font class, as returned by the enumerateFonts() function.
         *
         *   TextField cannot use a font of type EMBEDDED_CFF. If embedFonts is set to true
         * and the only font available at run time with the specified name and style is of type EMBEDDED_CFF,
         * Flash Player fails to render the text, as if no embedded font were available with the specified name and style.If both EMBEDDED and EMBEDDED_CFF fonts are available with the same name and style, the EMBEDDED
         * font is selected and text renders with the EMBEDDED font.
         * @param	fontName	The name of the embedded font to check.
         * @param	fontStyle	Specifies the font style to check.  Use flash.text.FontStyle
         * @return	true if a compatible embedded font is available, otherwise false.
         * @throws	ArgumentError The fontStyle specified is not a member of flash.text.FontStyle.
         */
        TextField$$1.isFontCompatible = function (fontName, fontStyle) {
            //todo
            console.log("isFontCompatible not implemented yet in flash/TextField");
            return false;
        };
        TextField$$1.prototype.pasteRichText = function (richText) {
            //todo
            console.log("pasteRichText not implemented yet in flash/TextField");
            return false;
        };
        /**
         * Replaces the current selection with the contents of the value parameter.
         * The text is inserted at the position of the current selection, using the current default character
         * format and default paragraph format. The text is not treated as HTML.
         *
         *   You can use the replaceSelectedText() method to insert and delete text without disrupting
         * the character and paragraph formatting of the rest of the text.Note: This method does not work if a style sheet is applied to the text field.
         * @param	value	The string to replace the currently selected text.
         * @throws	Error This method cannot be used on a text field with a style sheet.
         */
        TextField$$1.prototype.replaceSelectedText = function (value) {
            //todo
            console.log("replaceSelectedText not implemented yet in flash/TextField");
        };
        /**
         * Replaces the range of characters that the beginIndex and
         * endIndex parameters specify with the contents
         * of the newText parameter. As designed, the text from
         * beginIndex to endIndex-1 is replaced.
         * Note: This method does not work if a style sheet is applied to the text field.
         * @param	beginIndex	The zero-based index value for the start position of the replacement range.
         * @param	endIndex	The zero-based index position of the first character after the desired
         *   text span.
         * @param	newText	The text to use to replace the specified range of characters.
         * @throws	Error This method cannot be used on a text field with a style sheet.
         */
        TextField$$1.prototype.replaceText = function (beginIndex, endIndex, newText) {
            //todo
            console.log("replaceText not implemented yet in flash/TextField");
        };
        /**
         * Sets as selected the text designated by the index values of the
         * first and last characters, which are specified with the beginIndex
         * and endIndex parameters. If the two parameter values are the same,
         * this method sets the insertion point, as if you set the
         * caretIndex property.
         * @param	beginIndex	The zero-based index value of the first character in the selection
         *   (for example, the first character is 0, the second character is 1, and so on).
         * @param	endIndex	The zero-based index value of the last character in the selection.
         * @internal	Need to add an example.
         */
        TextField$$1.prototype.setSelection = function (beginIndex, endIndex) {
            //todo
            console.log("setSelection not implemented yet in flash/TextField");
        };
        /**
         * Applies the text formatting that the format parameter specifies to the specified text in a text field.
         * The value of format must be a TextFormat object that specifies the
         * desired text formatting changes. Only the non-null properties of format are applied
         * to the text field. Any property of format that is set to null is not
         * applied. By default, all of the properties of a newly created TextFormat object are set to null.
         * Note: This method does not work if a style sheet is applied to the text field.The setTextFormat() method changes the text formatting applied to a range of
         * characters or to the entire body of text in a text field. To apply the properties of format to all text in the text
         * field, do not specify values for beginIndex and endIndex. To apply the
         * properties of the format to a range of text, specify values for the beginIndex and
         * the endIndex parameters. You can use the length property to determine
         * the index values.The two types of formatting information in a TextFormat object are
         * character level formatting and paragraph level formatting.
         * Each character in a text field can have its own character formatting
         * settings, such as font name, font size, bold, and italic.For paragraphs, the first character of the paragraph is examined for the paragraph formatting
         * settings for the entire paragraph. Examples of paragraph formatting settings are left margin,
         * right margin, and indentation.Any text inserted manually by the user, or replaced by the
         * replaceSelectedText() method, receives the default text field formatting for new text,
         * and not the formatting specified for the text insertion point. To set the default
         * formatting for new text, use defaultTextFormat.
         * @param	format	A TextFormat object that contains character and paragraph formatting information.
         * @param	beginIndex	Optional; an integer that specifies the zero-based index position specifying the
         *   first character of the desired range of text.
         * @param	endIndex	Optional; an integer that specifies the first character after the desired text span.
         *   As designed, if you specify beginIndex and endIndex values,
         *   the text from beginIndex to endIndex-1 is updated.
         *
         *     UsageDescriptionmy_textField.setTextFormat(textFormat:TextFormat)Applies the properties of textFormat to all text in the text
         *   field.my_textField.setTextFormat(textFormat:TextFormat, beginIndex:int)Applies the properties of textFormat to the text starting with the
         *   beginIndex position.my_textField.setTextFormat(textFormat:TextFormat, beginIndex:int,
         *   endIndex:int)Applies the properties of the textFormat parameter to the span of
         *   text from the beginIndex position to the endIndex-1 position.Notice that any text inserted manually by the user, or replaced by the
         *   replaceSelectedText() method, receives the default text field formatting for new
         *   text, and not the formatting specified for the text insertion point. To set a text field's
         *   default formatting for new text, use the defaultTextFormat property.
         * @throws	Error This method cannot be used on a text field with a style sheet.
         * @throws	RangeError The beginIndex or endIndex specified is out of range.
         */
        TextField$$1.prototype.setTextFormat = function (format, beginIndex, endIndex) {
            if (beginIndex === void 0) { beginIndex = -1; }
            if (endIndex === void 0) { endIndex = -1; }
            //todo implement for multi-formats
            this._adaptee.setTextFormat(format.adaptee, beginIndex, endIndex);
        };
        TextField$$1._textFields = new Array();
        return TextField$$1;
    }(InteractiveObject));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: Point
    var Point$1 = /** @class */ (function (_super) {
        __extends(Point$$1, _super);
        /**
         * Creates a new point. If you pass no parameters to this method, a point is
         * created at(0,0).
         *
         * @param x The horizontal coordinate.
         * @param y The vertical coordinate.
         */
        function Point$$1(xAdaptee, y) {
            if (xAdaptee === void 0) { xAdaptee = 0; }
            if (y === void 0) { y = 0; }
            var _this = _super.call(this) || this;
            _this._adaptee = (xAdaptee instanceof Point) ? xAdaptee : new Point(+xAdaptee, +y);
            return _this;
        }
        Object.defineProperty(Point$$1.prototype, "adaptee", {
            get: function () {
                return this._adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Point$$1.prototype, "x", {
            /**
             * The horizontal coordinate of the point. The default value is 0.
             */
            get: function () {
                return this._adaptee._rawData[0];
            },
            set: function (value) {
                this._adaptee._rawData[0] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Point$$1.prototype, "y", {
            /**
             * The vertical coordinate of the point. The default value is 0.
             */
            get: function () {
                return this._adaptee._rawData[1];
            },
            set: function (value) {
                this._adaptee._rawData[1] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Point$$1.prototype, "length", {
            /**
             * The length of the line segment from(0,0) to this point.
             */
            get: function () {
                return this._adaptee.length;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Determines a point between two specified points. The parameter
         * <code>f</code> determines where the new interpolated point is located
         * relative to the two end points specified by parameters <code>pt1</code>
         * and <code>pt2</code>. The closer the value of the parameter <code>f</code>
         * is to <code>1.0</code>, the closer the interpolated point is to the first
         * point(parameter <code>pt1</code>). The closer the value of the parameter
         * <code>f</code> is to 0, the closer the interpolated point is to the second
         * point(parameter <code>pt2</code>).
         *
         * @param pt1 The first point.
         * @param pt2 The second point.
         * @param f   The level of interpolation between the two points. Indicates
         *            where the new point will be, along the line between
         *            <code>pt1</code> and <code>pt2</code>. If <code>f</code>=1,
         *            <code>pt1</code> is returned; if <code>f</code>=0,
         *            <code>pt2</code> is returned.
         * @return The new, interpolated point.
         */
        Point$$1.interpolate = function (pt1, pt2, f) {
            return new this.sec.flash.geom.Point(Point.interpolate(pt1.adaptee, pt2.adaptee, f));
        };
        /**
         * Returns the distance between <code>pt1</code> and <code>pt2</code>.
         *
         * @param pt1 The first point.
         * @param pt2 The second point.
         * @return The distance between the first and second points.
         */
        Point$$1.distance = function (pt1, pt2) {
            return Point.distance(pt1.adaptee, pt2.adaptee);
        };
        /**
         * Converts a pair of polar coordinates to a Cartesian point coordinate.
         *
         * @param len   The length coordinate of the polar pair.
         * @param angle The angle, in radians, of the polar pair.
         * @return The Cartesian point.
         */
        Point$$1.polar = function (len, angle) {
            return new this.sec.flash.geom.Point(Point.polar(+len, +angle));
        };
        /**
         * Creates a copy of this Point object.
         *
         * @return The new Point object.
         */
        Point$$1.prototype.clone = function () {
            return new this.sec.flash.geom.Point(this._adaptee.clone());
        };
        /**
         * Offsets the Point object by the specified amount. The value of
         * <code>dx</code> is added to the original value of <i>x</i> to create the
         * new <i>x</i> value. The value of <code>dy</code> is added to the original
         * value of <i>y</i> to create the new <i>y</i> value.
         *
         * @param dx The amount by which to offset the horizontal coordinate,
         *           <i>x</i>.
         * @param dy The amount by which to offset the vertical coordinate, <i>y</i>.
         */
        Point$$1.prototype.offset = function (dx, dy) {
            this._adaptee.offset(dx, dy);
        };
        /**
         * Determines whether two points are equal. Two points are equal if they have
         * the same <i>x</i> and <i>y</i> values.
         *
         * @param toCompare The point to be compared.
         * @return A value of <code>true</code> if the object is equal to this Point
         *         object; <code>false</code> if it is not equal.
         */
        Point$$1.prototype.equals = function (toCompare) {
            return this._adaptee.equals(toCompare.adaptee);
        };
        /**
         * Subtracts the coordinates of another point from the coordinates of this
         * point to create a new point.
         *
         * @param v The point to be subtracted.
         * @return The new point.
         */
        Point$$1.prototype.subtract = function (v) {
            return new this.sec.flash.geom.Point(this._adaptee.subtract(v.adaptee));
        };
        /**
         * Adds the coordinates of another point to the coordinates of this point to
         * create a new point.
         *
         * @param v The point to be added.
         * @return The new point.
         */
        Point$$1.prototype.add = function (v) {
            return new this.sec.flash.geom.Point(this._adaptee.add(v.adaptee));
        };
        /**
         * Scales the line segment between(0,0) and the current point to a set
         * length.
         *
         * @param thickness The scaling value. For example, if the current point is
         *                 (0,5), and you normalize it to 1, the point returned is
         *                  at(0,1).
         */
        Point$$1.prototype.normalize = function (thickness) {
            if (thickness === void 0) { thickness = 1; }
            this._adaptee.normalize(+thickness);
        };
        Point$$1.prototype.copyFrom = function (sourcePoint) {
            this._adaptee.copyFrom(sourcePoint.adaptee);
        };
        Point$$1.prototype.setTo = function (x, y) {
            this._adaptee.setTo(x, y);
        };
        Point$$1.prototype.toString = function () {
            return "(x=" + this.x + ", y=" + this.y + ")";
        };
        // Called whenever the class is initialized.
        Point$$1.classInitializer = null;
        // List of static symbols to link.
        Point$$1.classSymbols = null; // ["interpolate", "distance", "polar"];
        // List of instance symbols to link.
        Point$$1.instanceSymbols = null; // ["x", "y", "length", "clone", "offset", "equals", "subtract", "add", "normalize", "copyFrom", "setTo", "toString"];
        return Point$$1;
    }(ASObject$1));

    /**
    /// @eventType	flash.events.KeyboardEvent.KEY_DOWN
    [Event(name="keyDown", type="flash.events.KeyboardEvent")]

    /// @eventType	flash.events.KeyboardEvent.KEY_UP
    [Event(name="keyUp", type="flash.events.KeyboardEvent")]

     * A KeyboardEvent object id dispatched in response to user input through a keyboard.
     * There are two types of keyboard events: <codeph class="+ topic/ph pr-d/codeph ">KeyboardEvent.KEY_DOWN</codeph> and
     * <codeph class="+ topic/ph pr-d/codeph ">KeyboardEvent.KEY_UP</codeph><p class="- topic/p ">Because mappings between keys and specific characters vary by device
     * and operating system, use the TextEvent event type for processing character input.</p><p class="- topic/p ">To listen globally for key events, listen on the Stage for the capture and target
     * or bubble phase.</p>
     */
    var KeyboardEvent$2 = /** @class */ (function (_super) {
        __extends(KeyboardEvent, _super);
        /**
         * Creates an Event object that contains specific information about keyboard events.
         * Event objects are passed as parameters to event listeners.
         * @param	type	The type of the event. Possible values are:
         *   KeyboardEvent.KEY_DOWN and KeyboardEvent.KEY_UP
         * @param	bubbles	Determines whether the Event object participates in the bubbling stage of the event flow.
         * @param	cancelable	Determines whether the Event object can be canceled.
         * @param	charCodeValue	The character code value of the key pressed or released. The character code values returned are English keyboard values. For example, if you press Shift+3, the Keyboard.charCode() property returns # on a Japanese keyboard, just as it does on an English keyboard.
         * @param	keyCodeValue	The key code value of the key pressed or released.
         * @param	keyLocationValue	The location of the key on the keyboard.
         * @param	ctrlKeyValue	On Windows, indicates whether the Ctrl key is activated. On Mac, indicates whether either the Ctrl key or the Command key is activated.
         * @param	altKeyValue	Indicates whether the Alt key modifier is activated (Windows only).
         * @param	shiftKeyValue	Indicates whether the Shift key modifier is activated.
         * @param	controlKeyValue	Indicates whether the Control key is activated on Mac, and whether the Control or Ctrl keys are activated on WIndows and Linux.
         * @param	commandKeyValue	Indicates whether the Command key is activated (Mac only).
         */
        function KeyboardEvent(type, bubbles, cancelable, charCodeValue, keyCodeValue, keyLocationValue, ctrlKeyValue, altKeyValue, shiftKeyValue) {
            if (bubbles === void 0) { bubbles = true; }
            if (cancelable === void 0) { cancelable = false; }
            if (charCodeValue === void 0) { charCodeValue = 0; }
            if (keyCodeValue === void 0) { keyCodeValue = 0; }
            if (keyLocationValue === void 0) { keyLocationValue = 0; }
            if (ctrlKeyValue === void 0) { ctrlKeyValue = false; }
            if (altKeyValue === void 0) { altKeyValue = false; }
            if (shiftKeyValue === void 0) { shiftKeyValue = false; }
            return _super.call(this, type, bubbles, cancelable) || this;
        }
        Object.defineProperty(KeyboardEvent.prototype, "altKey", {
            get: function () {
                return this._altKey;
            },
            set: function (value) {
                this._altKey = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(KeyboardEvent.prototype, "charCode", {
            get: function () {
                return this._charCode;
            },
            set: function (value) {
                this._charCode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(KeyboardEvent.prototype, "ctrlKey", {
            get: function () {
                return this._ctrlKey;
            },
            set: function (value) {
                this._ctrlKey = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(KeyboardEvent.prototype, "keyCode", {
            get: function () {
                return this._keyCode;
            },
            set: function (value) {
                this._keyCode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(KeyboardEvent.prototype, "keyLocation", {
            /**
             * Indicates the location of the key on the keyboard. This is useful for differentiating keys
             * that appear more than once on a keyboard. For example, you can differentiate between the
             * left and right Shift keys by the value of this property: KeyLocation.LEFT
             * for the left and KeyLocation.RIGHT for the right. Another example is
             * differentiating between number keys pressed on the standard keyboard
             * (KeyLocation.STANDARD) versus the numeric keypad (KeyLocation.NUM_PAD).
             */
            get: function () {
                console.log("keyLocation not implemented yet in flash/KeyboardEvent");
                return 0;
            },
            set: function (value) {
                console.log("keyLocation not implemented yet in flash/KeyboardEvent");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(KeyboardEvent.prototype, "shiftKey", {
            get: function () {
                return this._shiftKey;
            },
            set: function (value) {
                this._shiftKey = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Creates a copy of the KeyboardEvent object and sets the value of each property to match that of the original.
         * @return	A new KeyboardEvent object with property values that match those of the original.
         */
        KeyboardEvent.prototype.clone = function () {
            console.log("clone not implemented yet in flash/KeyboardEvent");
            return null;
        };
        /**
         * Returns a string that contains all the properties of the KeyboardEvent object. The string
         * is in the following format:
         * [KeyboardEvent type=value bubbles=value cancelable=value ... shiftKey=value]
         * @return	A string that contains all the properties of the KeyboardEvent object.
         */
        KeyboardEvent.prototype.toString = function () {
            console.log("toString not implemented yet in flash/KeyboardEvent");
            return "";
        };
        /**
         * Indicates that the display should be rendered after processing of this event completes, if the display
         * list has been modified
         */
        KeyboardEvent.prototype.updateAfterEvent = function () {
            console.log("updateAfterEvent not implemented yet in flash/KeyboardEvent");
        };
        /**
         * The KeyboardEvent.KEY_DOWN constant defines the value of the type property of a keyDown event object.
         *
         *   This event has the following properties:PropertyValuebubblestruecancelabletrue in AIR, false in Flash Player;
         * in AIR, canceling this event prevents the character from being entered into a text field.charCodeThe character code value of the key pressed or released.commandKeytrue on Mac if the Command key is active. Otherwise, falsecontrolKeytrue on Windows and Linux if the Ctrl key is active. true on Mac if either the Control key is active. Otherwise, falsectrlKeytrue on Windows and Linux if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.keyCodeThe key code value of the key pressed or released.keyLocationThe location of the key on the keyboard.shiftKeytrue if the Shift key is active; false if it is inactive.targetThe InteractiveObject instance with focus.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         */
        KeyboardEvent.KEY_DOWN = "keyDown";
        /**
         * The KeyboardEvent.KEY_UP constant defines the value of the type property of a keyUp event object.
         * This event has the following properties:PropertyValuebubblestruecancelablefalse; there is no default behavior to cancel.charCodeContains the character code value of the key pressed or released.commandKeytrue on Mac if the Command key is active. Otherwise, falsecontrolKeytrue on Windows and Linux if the Ctrl key is active. true on Mac if either the Control key is active. Otherwise, falsectrlKeytrue on Windows if the Ctrl key is active. true on Mac if either the Ctrl key or the Command key is active. Otherwise, false.currentTargetThe object that is actively processing the Event
         * object with an event listener.keyCodeThe key code value of the key pressed or released.keyLocationThe location of the key on the keyboard.shiftKeytrue if the Shift key is active; false if it is inactive.targetThe InteractiveObject instance with focus.
         * The target is not always the object in the display list
         * that registered the event listener. Use the currentTarget
         * property to access the object in the display list that is currently processing the event.
         */
        KeyboardEvent.KEY_UP = "keyUp";
        return KeyboardEvent;
    }(Event));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: Rectangle
    var Rectangle$1 = /** @class */ (function (_super) {
        __extends(Rectangle$$1, _super);
        /**
         * Creates a new Rectangle object with the top-left corner specified by the
         * <code>x</code> and <code>y</code> parameters and with the specified
         * <code>width</code> and <code>height</code> parameters. If you call this
         * public without parameters, a rectangle with <code>x</code>,
         * <code>y</code>, <code>width</code>, and <code>height</code> properties set
         * to 0 is created.
         *
         * @param x      The <i>x</i> coordinate of the top-left corner of the
         *               rectangle.
         * @param y      The <i>y</i> coordinate of the top-left corner of the
         *               rectangle.
         * @param width  The width of the rectangle, in pixels.
         * @param height The height of the rectangle, in pixels.
         */
        function Rectangle$$1(xAdaptee, y, width, height) {
            if (xAdaptee === void 0) { xAdaptee = 0; }
            if (y === void 0) { y = 0; }
            if (width === void 0) { width = 0; }
            if (height === void 0) { height = 0; }
            var _this = _super.call(this) || this;
            _this._adaptee = (xAdaptee instanceof Rectangle) ? xAdaptee : new Rectangle(+xAdaptee, +y, +width, +height);
            return _this;
        }
        Object.defineProperty(Rectangle$$1.prototype, "adaptee", {
            get: function () {
                return this._adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle$$1.prototype, "height", {
            /**
             * The height of the rectangle, in pixels. Changing the <code>height</code>
             * value of a Rectangle object has no effect on the <code>x</code>,
             * <code>y</code>, and <code>width</code> properties.
             */
            get: function () {
                return this._adaptee._rawData[3];
            },
            set: function (value) {
                this._adaptee._rawData[3] = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle$$1.prototype, "width", {
            /**
             * The width of the rectangle, in pixels. Changing the <code>width</code>
             * value of a Rectangle object has no effect on the <code>x</code>,
             * <code>y</code>, and <code>height</code> properties.
             */
            get: function () {
                return this._adaptee._rawData[2];
            },
            set: function (value) {
                this._adaptee._rawData[2] = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle$$1.prototype, "x", {
            /**
             * The <i>x</i> coordinate of the top-left corner of the rectangle. Changing
             * the value of the <code>x</code> property of a Rectangle object has no
             * effect on the <code>y</code>, <code>width</code>, and <code>height</code>
             * properties.
             *
             * <p>The value of the <code>x</code> property is equal to the value of the
             * <code>left</code> property.</p>
             */
            get: function () {
                return this._adaptee._rawData[0];
            },
            set: function (value) {
                this._adaptee._rawData[0] = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle$$1.prototype, "y", {
            /**
             * The <i>y</i> coordinate of the top-left corner of the rectangle. Changing
             * the value of the <code>y</code> property of a Rectangle object has no
             * effect on the <code>x</code>, <code>width</code>, and <code>height</code>
             * properties.
             *
             * <p>The value of the <code>y</code> property is equal to the value of the
             * <code>top</code> property.</p>
             */
            get: function () {
                return this._adaptee._rawData[1];
            },
            set: function (value) {
                this._adaptee._rawData[1] = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle$$1.prototype, "bottom", {
            /**
             * The sum of the <code>y</code> and <code>height</code> properties.
             */
            get: function () {
                return this._adaptee.bottom;
            },
            set: function (value) {
                this._adaptee.bottom = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle$$1.prototype, "bottomRight", {
            /**
             * The location of the Rectangle object's bottom-right corner, determined by
             * the values of the <code>right</code> and <code>bottom</code> properties.
             */
            get: function () {
                return new this.sec.flash.geom.Point(this._adaptee.bottomRight);
            },
            set: function (value) {
                this.bottom = value.y;
                this.right = value.x;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle$$1.prototype, "left", {
            /**
             * The <i>x</i> coordinate of the top-left corner of the rectangle. Changing
             * the <code>left</code> property of a Rectangle object has no effect on the
             * <code>y</code> and <code>height</code> properties. However it does affect
             * the <code>width</code> property, whereas changing the <code>x</code> value
             * does <i>not</i> affect the <code>width</code> property.
             *
             * <p>The value of the <code>left</code> property is equal to the value of
             * the <code>x</code> property.</p>
             */
            get: function () {
                return this._adaptee.left;
            },
            set: function (value) {
                this._adaptee.left = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle$$1.prototype, "right", {
            /**
             * The sum of the <code>x</code> and <code>width</code> properties.
             */
            get: function () {
                return this._adaptee.right;
            },
            set: function (value) {
                this._adaptee.right = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle$$1.prototype, "size", {
            /**
             * The size of the Rectangle object, expressed as a Point object with the
             * values of the <code>width</code> and <code>height</code> properties.
             */
            get: function () {
                return new this.sec.flash.geom.Point(this._adaptee.size);
            },
            set: function (value) {
                this.width = value.x;
                this.height = value.y;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle$$1.prototype, "top", {
            /**
             * The <i>y</i> coordinate of the top-left corner of the rectangle. Changing
             * the <code>top</code> property of a Rectangle object has no effect on the
             * <code>x</code> and <code>width</code> properties. However it does affect
             * the <code>height</code> property, whereas changing the <code>y</code>
             * value does <i>not</i> affect the <code>height</code> property.
             *
             * <p>The value of the <code>top</code> property is equal to the value of the
             * <code>y</code> property.</p>
             */
            get: function () {
                return this._adaptee.top;
            },
            set: function (value) {
                this._adaptee.top = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle$$1.prototype, "topLeft", {
            /**
             * The location of the Rectangle object's top-left corner, determined by the
             * <i>x</i> and <i>y</i> coordinates of the point.
             */
            get: function () {
                return new this.sec.flash.geom.Point(this._adaptee.topLeft);
            },
            set: function (value) {
                this.top = value.y;
                this.left = value.x;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Rectangle$$1.prototype, "area", {
            get: function () {
                return this.width * this.height;
            },
            enumerable: true,
            configurable: true
        });
        Rectangle$$1.FromBounds = function (bounds) {
            var xMin = bounds.xMin;
            var yMin = bounds.yMin;
            return new this.sec.flash.geom.Rectangle(xMin / 20, yMin / 20, (bounds.xMax - xMin) / 20, (bounds.yMax - yMin) / 20);
        };
        /**
         * Returns a new Rectangle object with the same values for the
         * <code>x</code>, <code>y</code>, <code>width</code>, and
         * <code>height</code> properties as the original Rectangle object.
         *
         * @return A new Rectangle object with the same values for the
         *         <code>x</code>, <code>y</code>, <code>width</code>, and
         *         <code>height</code> properties as the original Rectangle object.
         */
        Rectangle$$1.prototype.clone = function () {
            return new this.sec.flash.geom.Rectangle(this._adaptee.clone());
        };
        /**
         * Determines whether or not this Rectangle object is empty.
         *
         * @return A value of <code>true</code> if the Rectangle object's width or
         *         height is less than or equal to 0; otherwise <code>false</code>.
         */
        Rectangle$$1.prototype.isEmpty = function () {
            return this._adaptee.isEmpty();
        };
        /**
         * Sets all of the Rectangle object's properties to 0. A Rectangle object is
         * empty if its width or height is less than or equal to 0.
         *
         * <p> This method sets the values of the <code>x</code>, <code>y</code>,
         * <code>width</code>, and <code>height</code> properties to 0.</p>
         *
         */
        Rectangle$$1.prototype.setEmpty = function () {
            return this._adaptee.setEmpty();
        };
        /**
         * Increases the size of the Rectangle object by the specified amounts, in
         * pixels. The center point of the Rectangle object stays the same, and its
         * size increases to the left and right by the <code>dx</code> value, and to
         * the top and the bottom by the <code>dy</code> value.
         *
         * @param dx The value to be added to the left and the right of the Rectangle
         *           object. The following equation is used to calculate the new
         *           width and position of the rectangle:
         * @param dy The value to be added to the top and the bottom of the
         *           Rectangle. The following equation is used to calculate the new
         *           height and position of the rectangle:
         */
        Rectangle$$1.prototype.inflate = function (dx, dy) {
            this._adaptee.inflate(+dx, +dy);
        };
        /**
         * Increases the size of the Rectangle object. This method is similar to the
         * <code>Rectangle.inflate()</code> method except it takes a Point object as
         * a parameter.
         *
         * <p>The following two code examples give the same result:</p>
         *
         * @param point The <code>x</code> property of this Point object is used to
         *              increase the horizontal dimension of the Rectangle object.
         *              The <code>y</code> property is used to increase the vertical
         *              dimension of the Rectangle object.
         */
        Rectangle$$1.prototype.inflatePoint = function (point) {
            this._adaptee.inflatePoint(point.adaptee);
        };
        /**
         * Adjusts the location of the Rectangle object, as determined by its
         * top-left corner, by the specified amounts.
         *
         * @param dx Moves the <i>x</i> value of the Rectangle object by this amount.
         * @param dy Moves the <i>y</i> value of the Rectangle object by this amount.
         */
        Rectangle$$1.prototype.offset = function (dx, dy) {
            this._adaptee.offset(+dx, +dy);
        };
        /**
         * Adjusts the location of the Rectangle object using a Point object as a
         * parameter. This method is similar to the <code>Rectangle.offset()</code>
         * method, except that it takes a Point object as a parameter.
         *
         * @param point A Point object to use to offset this Rectangle object.
         */
        Rectangle$$1.prototype.offsetPoint = function (point) {
            this._adaptee.offsetPoint(point.adaptee);
        };
        /**
         * Determines whether the specified point is contained within the rectangular
         * region defined by this Rectangle object.
         *
         * @param x The <i>x</i> coordinate(horizontal position) of the point.
         * @param y The <i>y</i> coordinate(vertical position) of the point.
         * @return A value of <code>true</code> if the Rectangle object contains the
         *         specified point; otherwise <code>false</code>.
         */
        Rectangle$$1.prototype.contains = function (x, y) {
            return this._adaptee.contains(+x, +y);
        };
        /**
         * Determines whether the specified point is contained within the rectangular
         * region defined by this Rectangle object. This method is similar to the
         * <code>Rectangle.contains()</code> method, except that it takes a Point
         * object as a parameter.
         *
         * @param point The point, as represented by its <i>x</i> and <i>y</i>
         *              coordinates.
         * @return A value of <code>true</code> if the Rectangle object contains the
         *         specified point; otherwise <code>false</code>.
         */
        Rectangle$$1.prototype.containsPoint = function (point) {
            return this._adaptee.containsPoint(point.adaptee);
        };
        /**
         * Determines whether the Rectangle object specified by the <code>rect</code>
         * parameter is contained within this Rectangle object. A Rectangle object is
         * said to contain another if the second Rectangle object falls entirely
         * within the boundaries of the first.
         *
         * @param rect The Rectangle object being checked.
         * @return A value of <code>true</code> if the Rectangle object that you
         *         specify is contained by this Rectangle object; otherwise
         *         <code>false</code>.
         */
        Rectangle$$1.prototype.containsRect = function (rect) {
            return this._adaptee.containsRect(rect.adaptee);
        };
        /**
         * If the Rectangle object specified in the <code>toIntersect</code>
         * parameter intersects with this Rectangle object, returns the area of
         * intersection as a Rectangle object. If the rectangles do not intersect,
         * this method returns an empty Rectangle object with its properties set to
         * 0.
         *
         * @param toIntersect The Rectangle object to compare against to see if it
         *                    intersects with this Rectangle object.
         * @return A Rectangle object that equals the area of intersection. If the
         *         rectangles do not intersect, this method returns an empty
         *         Rectangle object; that is, a rectangle with its <code>x</code>,
         *         <code>y</code>, <code>width</code>, and <code>height</code>
         *         properties set to 0.
         */
        Rectangle$$1.prototype.intersection = function (toIntersect) {
            return new this.sec.flash.geom.Rectangle(this._adaptee.intersection(toIntersect.adaptee));
        };
        /**
         * Determines whether the object specified in the <code>toIntersect</code>
         * parameter intersects with this Rectangle object. This method checks the
         * <code>x</code>, <code>y</code>, <code>width</code>, and
         * <code>height</code> properties of the specified Rectangle object to see if
         * it intersects with this Rectangle object.
         *
         * @param toIntersect The Rectangle object to compare against this Rectangle
         *                    object.
         * @return A value of <code>true</code> if the specified object intersects
         *         with this Rectangle object; otherwise <code>false</code>.
         */
        Rectangle$$1.prototype.intersects = function (toIntersect) {
            return this._adaptee.intersects(toIntersect.adaptee);
        };
        /**
         * Adds two rectangles together to create a new Rectangle object, by filling
         * in the horizontal and vertical space between the two rectangles.
         *
         * <p><b>Note:</b> The <code>union()</code> method ignores rectangles with
         * <code>0</code> as the height or width value, such as: <code>var
         * rect2:Rectangle = new Rectangle(300,300,50,0);</code></p>
         *
         * @param toUnion A Rectangle object to add to this Rectangle object.
         * @return A new Rectangle object that is the union of the two rectangles.
         */
        Rectangle$$1.prototype.union = function (toUnion) {
            return new this.sec.flash.geom.Rectangle(this._adaptee.union(toUnion.adaptee));
        };
        /**
           * Determines whether the object specified in the <code>toCompare</code>
           * parameter is equal to this Rectangle object. This method compares the
           * <code>x</code>, <code>y</code>, <code>width</code>, and
           * <code>height</code> properties of an object against the same properties of
           * this Rectangle object.
           *
           * @param toCompare The rectangle to compare to this Rectangle object.
           * @return A value of <code>true</code> if the object has exactly the same
           *         values for the <code>x</code>, <code>y</code>, <code>width</code>,
           *         and <code>height</code> properties as this Rectangle object;
           *         otherwise <code>false</code>.
           */
        Rectangle$$1.prototype.equals = function (toCompare) {
            return this._adaptee.equals(toCompare.adaptee);
        };
        /**
         * Copies all of rectangle data from the source Rectangle object into the
         * calling Rectangle object.
         *
         * @param sourceRect The Rectangle object from which to copy the data.
         */
        Rectangle$$1.prototype.copyFrom = function (sourceRect) {
            this._adaptee.copyFrom(sourceRect.adaptee);
        };
        /**
         * Sets the members of Rectangle to the specified values
         *
         * @param xa      The <i>x</i> coordinate of the top-left corner of the
         *                rectangle.
         * @param ya      The <i>y</i> coordinate of the top-left corner of the
         *                rectangle.
         * @param widtha  The width of the rectangle, in pixels.
         * @param heighta The height of the rectangle, in pixels.
         */
        Rectangle$$1.prototype.setTo = function (x, y, width, height) {
            this._adaptee.setTo(+x, +y, +width, +height);
        };
        /**
         * Builds and returns a string that lists the horizontal and vertical
         * positions and the width and height of the Rectangle object.
         *
         * @return A string listing the value of each of the following properties of
         *         the Rectangle object: <code>x</code>, <code>y</code>,
         *         <code>width</code>, and <code>height</code>.
         */
        Rectangle$$1.prototype.toString = function () {
            return "(x=" + this.x + ", y=" + this.y + ", w=" + this.width + ", h=" + this.height + ")";
        };
        Rectangle$$1.prototype.hashCode = function () {
            var hash = 0;
            hash += this.x * 20 | 0;
            hash *= 37;
            hash += this.y * 20 | 0;
            hash *= 37;
            hash += this.width * 20 | 0;
            hash *= 37;
            hash += this.height * 20 | 0;
            return hash;
        };
        Rectangle$$1.prototype.writeExternal = function (output) {
            output.writeFloat(this.x);
            output.writeFloat(this.y);
            output.writeFloat(this.width);
            output.writeFloat(this.height);
        };
        Rectangle$$1.prototype.readExternal = function (input) {
            this.x = input.readFloat();
            this.y = input.readFloat();
            this.width = input.readFloat();
            this.height = input.readFloat();
        };
        // Called whenever the class is initialized.
        Rectangle$$1.classInitializer = null;
        // List of static symbols to link.
        Rectangle$$1.classSymbols = null; // [];
        // List of instance symbols to link.
        Rectangle$$1.instanceSymbols = null;
        return Rectangle$$1;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: Matrix
    var Matrix$1 = /** @class */ (function (_super) {
        __extends(Matrix$$1, _super);
        /**
         * Creates a new Matrix object with the specified parameters. In matrix
         * notation, the properties are organized like this:
         *
         * <p>If you do not provide any parameters to the <code>new Matrix()</code>
         * constructor, it creates an <i>identity matrix</i> with the following
         * values:</p>
         *
         * <p>In matrix notation, the identity matrix looks like this:</p>
         *
         * @param a  The value that affects the positioning of pixels along the
         *           <i>x</i> axis when scaling or rotating an image.
         * @param b  The value that affects the positioning of pixels along the
         *           <i>y</i> axis when rotating or skewing an image.
         * @param c  The value that affects the positioning of pixels along the
         *           <i>x</i> axis when rotating or skewing an image.
         * @param d  The value that affects the positioning of pixels along the
         *           <i>y</i> axis when scaling or rotating an image..
         * @param tx The distance by which to translate each point along the <i>x</i>
         *           axis.
         * @param ty The distance by which to translate each point along the <i>y</i>
         *           axis.
         */
        function Matrix$$1(aAdaptee, b, c, d, tx, ty) {
            if (aAdaptee === void 0) { aAdaptee = 1; }
            if (b === void 0) { b = 0; }
            if (c === void 0) { c = 0; }
            if (d === void 0) { d = 1; }
            if (tx === void 0) { tx = 0; }
            if (ty === void 0) { ty = 0; }
            var _this = _super.call(this) || this;
            _this._adaptee = (aAdaptee instanceof Matrix) ? aAdaptee : new Matrix(+aAdaptee, +b, +c, +d, +tx, +ty);
            return _this;
        }
        Matrix$$1.classInitializer = function () {
            this.FROZEN_IDENTITY_MATRIX = Object.freeze(this.axConstruct([]));
            this.TEMP_MATRIX = this.axConstruct([]);
        };
        Object.defineProperty(Matrix$$1.prototype, "adaptee", {
            // "invert", "identity", "createBox",
            // "createGradientBox", "rotate", "translate",
            // "scale", "deltaTransformPoint", "transformPoint",
            // "copyFrom", "setTo", "copyRowTo", "copyColumnTo",
            // "copyRowFrom", "copyColumnFrom", "clone",
            // "toString"];
            get: function () {
                return this._adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix$$1.prototype, "a", {
            /**
             * The value that affects the positioning of pixels along the <i>x</i> axis
             * when scaling or rotating an image.
             */
            get: function () {
                return this._adaptee.rawData[0];
            },
            set: function (value) {
                this._adaptee.rawData[0] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix$$1.prototype, "b", {
            /**
             * The value that affects the positioning of pixels along the <i>y</i> axis
             * when rotating or skewing an image.
             */
            get: function () {
                return this._adaptee.rawData[2];
            },
            set: function (value) {
                this._adaptee.rawData[2] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix$$1.prototype, "c", {
            /**
             * The value that affects the positioning of pixels along the <i>x</i> axis
             * when rotating or skewing an image.
             */
            get: function () {
                return this._adaptee.rawData[1];
            },
            set: function (value) {
                this._adaptee.rawData[1] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix$$1.prototype, "d", {
            /**
             * The value that affects the positioning of pixels along the <i>y</i> axis
             * when scaling or rotating an image.
             */
            get: function () {
                return this._adaptee.rawData[3];
            },
            set: function (value) {
                this._adaptee.rawData[3] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix$$1.prototype, "tx", {
            /**
             * The distance by which to translate each point along the <i>x</i> axis.
             */
            get: function () {
                return this._adaptee.rawData[4];
            },
            set: function (value) {
                this._adaptee.rawData[4] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix$$1.prototype, "ty", {
            /**
             * The distance by which to translate each point along the <i>y</i> axis.
             */
            get: function () {
                return this._adaptee.rawData[5];
            },
            set: function (value) {
                this._adaptee.rawData[5] = value;
            },
            enumerable: true,
            configurable: true
        });
        Matrix$$1.FromUntyped = function (object) {
            return new this.sec.flash.geom.Matrix(object.a, object.b, object.c, object.d, object.tx, object.ty);
        };
        // Keep in sync with writeExternal below!
        Matrix$$1.FromDataBuffer = function (input) {
            return new this.sec.flash.geom.Matrix(input.readFloat(), input.readFloat(), input.readFloat(), input.readFloat(), input.readFloat(), input.readFloat());
        };
        /**
         * Concatenates a matrix with the current matrix, effectively combining the
         * geometric effects of the two. In mathematical terms, concatenating two
         * matrixes is the same as combining them using matrix multiplication.
         *
         * <p>For example, if matrix <code>m1</code> scales an object by a factor of
         * four, and matrix <code>m2</code> rotates an object by 1.5707963267949
         * radians(<code>Math.PI/2</code>), then <code>m1.concat(m2)</code>
         * transforms <code>m1</code> into a matrix that scales an object by a factor
         * of four and rotates the object by <code>Math.PI/2</code> radians. </p>
         *
         * <p>This method replaces the source matrix with the concatenated matrix. If
         * you want to concatenate two matrixes without altering either of the two
         * source matrixes, first copy the source matrix by using the
         * <code>clone()</code> method, as shown in the Class Examples section.</p>
         *
         * @param matrix The matrix to be concatenated to the source matrix.
         */
        Matrix$$1.prototype.concat = function (other) {
            this._adaptee.concat(other.adaptee);
        };
        /**
         * Performs the opposite transformation of the original matrix. You can apply
         * an inverted matrix to an object to undo the transformation performed when
         * applying the original matrix.
         */
        Matrix$$1.prototype.invert = function () {
            this._adaptee.invert();
        };
        /**
         * Sets each matrix property to a value that causes a null transformation. An
         * object transformed by applying an identity matrix will be identical to the
         * original.
         *
         * <p>After calling the <code>identity()</code> method, the resulting matrix
         * has the following properties: <code>a</code>=1, <code>b</code>=0,
         * <code>c</code>=0, <code>d</code>=1, <code>tx</code>=0,
         * <code>ty</code>=0.</p>
         *
         * <p>In matrix notation, the identity matrix looks like this:</p>
         *
         */
        Matrix$$1.prototype.identity = function () {
            this._adaptee.identity();
        };
        /**
       * Includes parameters for scaling, rotation, and translation. When applied
       * to a matrix it sets the matrix's values based on those parameters.
       *
       * <p>Using the <code>createBox()</code> method lets you obtain the same
       * matrix as you would if you applied the <code>identity()</code>,
       * <code>rotate()</code>, <code>scale()</code>, and <code>translate()</code>
       * methods in succession. For example, <code>mat1.createBox(2,2,Math.PI/4,
       * 100, 100)</code> has the same effect as the following:</p>
       *
       * @param scaleX   The factor by which to scale horizontally.
       * @param scaleY   The factor by which scale vertically.
       * @param rotation The amount to rotate, in radians.
       * @param tx       The number of pixels to translate(move) to the right
       *                 along the <i>x</i> axis.
       * @param ty       The number of pixels to translate(move) down along the
       *                 <i>y</i> axis.
       */
        Matrix$$1.prototype.createBox = function (scaleX, scaleY, rotation, tx, ty) {
            if (rotation === void 0) { rotation = 0; }
            if (tx === void 0) { tx = 0; }
            if (ty === void 0) { ty = 0; }
            this._adaptee.createBox(scaleX, scaleY, rotation, tx, ty);
        };
        /**
         * Creates the specific style of matrix expected by the
         * <code>beginGradientFill()</code> and <code>lineGradientStyle()</code>
         * methods of the Graphics class. Width and height are scaled to a
         * <code>scaleX</code>/<code>scaleY</code> pair and the
         * <code>tx</code>/<code>ty</code> values are offset by half the width and
         * height.
         *
         * <p>For example, consider a gradient with the following
         * characteristics:</p>
         *
         * <ul>
         *   <li><code>GradientType.LINEAR</code></li>
         *   <li>Two colors, green and blue, with the ratios array set to <code>[0,
         * 255]</code></li>
         *   <li><code>SpreadMethod.PAD</code></li>
         *   <li><code>InterpolationMethod.LINEAR_RGB</code></li>
         * </ul>
         *
         * <p>The following illustrations show gradients in which the matrix was
         * defined using the <code>createGradientBox()</code> method with different
         * parameter settings:</p>
         *
         * @param width    The width of the gradient box.
         * @param height   The height of the gradient box.
         * @param rotation The amount to rotate, in radians.
         * @param tx       The distance, in pixels, to translate to the right along
         *                 the <i>x</i> axis. This value is offset by half of the
         *                 <code>width</code> parameter.
         * @param ty       The distance, in pixels, to translate down along the
         *                 <i>y</i> axis. This value is offset by half of the
         *                 <code>height</code> parameter.
         */
        Matrix$$1.prototype.createGradientBox = function (width, height, rotation, tx, ty) {
            if (rotation === void 0) { rotation = 0; }
            if (tx === void 0) { tx = 0; }
            if (ty === void 0) { ty = 0; }
            this._adaptee.createGradientBox(width, height, rotation, tx, ty);
        };
        /**
         * Applies a rotation transformation to the Matrix object.
         *
         * <p>The <code>rotate()</code> method alters the <code>a</code>,
         * <code>b</code>, <code>c</code>, and <code>d</code> properties of the
         * Matrix object. In matrix notation, this is the same as concatenating the
         * current matrix with the following:</p>
         *
         * @param angle The rotation angle in radians.
         */
        Matrix$$1.prototype.rotate = function (angle) {
            this._adaptee.rotate(angle);
        };
        /**
         * Translates the matrix along the <i>x</i> and <i>y</i> axes, as specified
         * by the <code>dx</code> and <code>dy</code> parameters.
         *
         * @param dx The amount of movement along the <i>x</i> axis to the right, in
         *           pixels.
         * @param dy The amount of movement down along the <i>y</i> axis, in pixels.
         */
        Matrix$$1.prototype.translate = function (dx, dy) {
            this._adaptee.translate(dx, dy);
        };
        /**
         * Applies a scaling transformation to the matrix. The <i>x</i> axis is
         * multiplied by <code>sx</code>, and the <i>y</i> axis it is multiplied by
         * <code>sy</code>.
         *
         * <p>The <code>scale()</code> method alters the <code>a</code> and
         * <code>d</code> properties of the Matrix object. In matrix notation, this
         * is the same as concatenating the current matrix with the following
         * matrix:</p>
         *
         * @param sx A multiplier used to scale the object along the <i>x</i> axis.
         * @param sy A multiplier used to scale the object along the <i>y</i> axis.
         */
        Matrix$$1.prototype.scale = function (sx, sy) {
            this._adaptee.scale(sx, sy);
        };
        /**
         * Given a point in the pretransform coordinate space, returns the
         * coordinates of that point after the transformation occurs. Unlike the
         * standard transformation applied using the <code>transformPoint()</code>
         * method, the <code>deltaTransformPoint()</code> method's transformation
         * does not consider the translation parameters <code>tx</code> and
         * <code>ty</code>.
         *
         * @param point The point for which you want to get the result of the matrix
         *              transformation.
         * @return The point resulting from applying the matrix transformation.
         */
        Matrix$$1.prototype.deltaTransformPoint = function (point) {
            return new this.sec.flash.geom.Point(this._adaptee.deltaTransformPoint(point.adaptee));
        };
        /**
         * Returns the result of applying the geometric transformation represented by
         * the Matrix object to the specified point.
         *
         * @param point The point for which you want to get the result of the Matrix
         *              transformation.
         * @return The point resulting from applying the Matrix transformation.
         */
        Matrix$$1.prototype.transformPoint = function (point) {
            return new this.sec.flash.geom.Point(this._adaptee.transformPoint(point.adaptee));
        };
        /**
         * Copies all of the matrix data from the source Point object into the
         * calling Matrix object.
         *
         * @param sourceMatrix The Matrix object from which to copy the data.
         */
        Matrix$$1.prototype.copyFrom = function (sourceMatrix) {
            this._adaptee.copyFrom(sourceMatrix.adaptee);
        };
        /**
         * Sets the members of Matrix to the specified values.
         *
         * @param a  The value that affects the positioning of pixels along the
         *           <i>x</i> axis when scaling or rotating an image.
         * @param b  The value that affects the positioning of pixels along the
         *           <i>y</i> axis when rotating or skewing an image.
         * @param c  The value that affects the positioning of pixels along the
         *           <i>x</i> axis when rotating or skewing an image.
         * @param d  The value that affects the positioning of pixels along the
         *           <i>y</i> axis when scaling or rotating an image..
         * @param tx The distance by which to translate each point along the <i>x</i>
         *           axis.
         * @param ty The distance by which to translate each point along the <i>y</i>
         *           axis.
         */
        Matrix$$1.prototype.setTo = function (a, b, c, d, tx, ty) {
            this._adaptee.setTo(a, b, c, d, tx, ty);
        };
        /**
         * Copies specific row of the calling Matrix object into the Vector3D object.
         * The w element of the Vector3D object will not be changed.
         *
         * @param row      The row from which to copy the data from.
         * @param vector3D The Vector3D object from which to copy the data.
         */
        Matrix$$1.prototype.copyRowTo = function (row, vector3D) {
            this._adaptee.copyRowTo(row, vector3D.adaptee);
        };
        /**
         * Copies specific column of the calling Matrix object into the Vector3D
         * object. The w element of the Vector3D object will not be changed.
         *
         * @param column   The column from which to copy the data from.
         * @param vector3D The Vector3D object from which to copy the data.
         */
        Matrix$$1.prototype.copyColumnTo = function (column, vector3D) {
            this._adaptee.copyColumnTo(column, vector3D.adaptee);
        };
        /**
         * Copies a Vector3D object into specific row of the calling Matrix object.
         *
         * @param row      The row from which to copy the data from.
         * @param vector3D The Vector3D object from which to copy the data.
         */
        Matrix$$1.prototype.copyRowFrom = function (row, vector3D) {
            this._adaptee.copyRowFrom(row, vector3D.adaptee);
        };
        /**
         * Copies a Vector3D object into specific column of the calling Matrix3D
         * object.
         *
         * @param column   The column from which to copy the data from.
         * @param vector3D The Vector3D object from which to copy the data.
         */
        Matrix$$1.prototype.copyColumnFrom = function (column, vector3D) {
            this._adaptee.copyColumnFrom(column, vector3D.adaptee);
        };
        /**
         * Returns a new Matrix object that is a clone of this matrix, with an exact
         * copy of the contained object.
         *
         * @return A Matrix object.
         */
        Matrix$$1.prototype.clone = function () {
            return new this.sec.flash.geom.Matrix(this._adaptee.clone());
        };
        Matrix$$1.prototype.toString = function () {
            var m = this._adaptee.rawData;
            return "(a=" + m[0] + ", b=" + m[1] + ", c=" + m[2] + ", d=" + m[3] + ", tx=" + m[4] + ", ty=" + m[5] + ")";
        };
        // Keep in sync with static FromDataBuffer above!
        Matrix$$1.prototype.writeExternal = function (output) {
            var m = this._adaptee.rawData;
            output.writeFloat(m[0]);
            output.writeFloat(m[1]);
            output.writeFloat(m[2]);
            output.writeFloat(m[3]);
            output.writeFloat(m[4]);
            output.writeFloat(m[5]);
        };
        Matrix$$1.classSymbols = null; // [];
        Matrix$$1.instanceSymbols = null; // ["a", "b", "c", "d", "tx", "ty", "concat",
        return Matrix$$1;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: ColorTransform
    var ColorTransform$1 = /** @class */ (function (_super) {
        __extends(ColorTransform$$1, _super);
        function ColorTransform$$1(redMultiplierAdaptee, greenMultiplier, blueMultiplier, alphaMultiplier, redOffset, greenOffset, blueOffset, alphaOffset) {
            if (redMultiplierAdaptee === void 0) { redMultiplierAdaptee = 1; }
            if (greenMultiplier === void 0) { greenMultiplier = 1; }
            if (blueMultiplier === void 0) { blueMultiplier = 1; }
            if (alphaMultiplier === void 0) { alphaMultiplier = 1; }
            if (redOffset === void 0) { redOffset = 0; }
            if (greenOffset === void 0) { greenOffset = 0; }
            if (blueOffset === void 0) { blueOffset = 0; }
            if (alphaOffset === void 0) { alphaOffset = 0; }
            var _this = _super.call(this) || this;
            _this._adaptee = (redMultiplierAdaptee instanceof ColorTransform) ? redMultiplierAdaptee : new ColorTransform(+redMultiplierAdaptee, +greenMultiplier, +blueMultiplier, +alphaMultiplier, +redOffset, +greenOffset, +blueOffset, +alphaOffset);
            return _this;
        }
        ColorTransform$$1.classInitializer = function () {
            this.FROZEN_IDENTITY_COLOR_TRANSFORM = Object.freeze(this.axConstruct([]));
            this.TEMP_COLOR_TRANSFORM = this.axConstruct([]);
        };
        Object.defineProperty(ColorTransform$$1.prototype, "adaptee", {
            // "blueMultiplier", "alphaMultiplier", "redOffset",
            // "greenOffset", "blueOffset", "alphaOffset",
            // "color", "color", "concat", "toString"];
            get: function () {
                return this._adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform$$1.prototype, "alphaMultiplier", {
            /**
             * A decimal value that is multiplied with the alpha transparency channel
             * value.
             *
             * <p>If you set the alpha transparency value of a display object directly by
             * using the <code>alpha</code> property of the DisplayObject instance, it
             * affects the value of the <code>alphaMultiplier</code> property of that
             * display object's <code>transform.colorTransform</code> property.</p>
             */
            get: function () {
                return this._adaptee._rawData[3];
            },
            set: function (value) {
                this._adaptee._rawData[3] = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform$$1.prototype, "alphaOffset", {
            /**
             * A number from -255 to 255 that is added to the alpha transparency channel
             * value after it has been multiplied by the <code>alphaMultiplier</code>
             * value.
             */
            get: function () {
                return this._adaptee._rawData[7];
            },
            set: function (value) {
                this._adaptee._rawData[7] = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform$$1.prototype, "blueMultiplier", {
            /**
             * A decimal value that is multiplied with the blue channel value.
             */
            get: function () {
                return this._adaptee._rawData[2];
            },
            set: function (value) {
                this._adaptee._rawData[2] = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform$$1.prototype, "blueOffset", {
            /**
             * A number from -255 to 255 that is added to the blue channel value after it
             * has been multiplied by the <code>blueMultiplier</code> value.
             */
            get: function () {
                return this._adaptee._rawData[6];
            },
            set: function (value) {
                this._adaptee._rawData[6] = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform$$1.prototype, "greenMultiplier", {
            /**
             * A decimal value that is multiplied with the green channel value.
             */
            get: function () {
                return this._adaptee._rawData[1];
            },
            set: function (value) {
                this._adaptee._rawData[1] = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform$$1.prototype, "greenOffset", {
            /**
             * A number from -255 to 255 that is added to the green channel value after
             * it has been multiplied by the <code>greenMultiplier</code> value.
             */
            get: function () {
                return this._adaptee._rawData[5];
            },
            set: function (value) {
                this._adaptee._rawData[5] = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform$$1.prototype, "redMultiplier", {
            /**
             * A decimal value that is multiplied with the red channel value.
             */
            get: function () {
                return this._adaptee._rawData[0];
            },
            set: function (value) {
                this._adaptee._rawData[0] = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform$$1.prototype, "redOffset", {
            /**
             * A number from -255 to 255 that is added to the red channel value after it
             * has been multiplied by the <code>redMultiplier</code> value.
             */
            get: function () {
                return this._adaptee._rawData[4];
            },
            set: function (value) {
                this._adaptee._rawData[4] = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ColorTransform$$1.prototype, "color", {
            get: function () {
                return this._adaptee.color;
            },
            set: function (value) {
                this._adaptee.color = +value;
            },
            enumerable: true,
            configurable: true
        });
        ColorTransform$$1.prototype.concat = function (second) {
            this._adaptee.concat(second.adaptee);
        };
        ColorTransform$$1.prototype.preMultiply = function (second) {
            this._adaptee._rawData[4] += second.adaptee._rawData[4] * this._adaptee._rawData[0];
            this._adaptee._rawData[5] += second.adaptee._rawData[5] * this._adaptee._rawData[1];
            this._adaptee._rawData[6] += second.adaptee._rawData[6] * this._adaptee._rawData[2];
            this._adaptee._rawData[7] += second.adaptee._rawData[7] * this._adaptee._rawData[3];
            this._adaptee._rawData[0] *= second.adaptee._rawData[0];
            this._adaptee._rawData[1] *= second.adaptee._rawData[1];
            this._adaptee._rawData[2] *= second.adaptee._rawData[2];
            this._adaptee._rawData[3] *= second.adaptee._rawData[3];
        };
        ColorTransform$$1.prototype.copyFrom = function (sourceColorTransform) {
            this._adaptee.copyFrom(sourceColorTransform.adaptee);
        };
        ColorTransform$$1.prototype.setTo = function (redMultiplier, greenMultiplier, blueMultiplier, alphaMultiplier, redOffset, greenOffset, blueOffset, alphaOffset) {
            this._adaptee._rawData[0] = redMultiplier;
            this._adaptee._rawData[1] = greenMultiplier;
            this._adaptee._rawData[2] = blueMultiplier;
            this._adaptee._rawData[3] = alphaMultiplier;
            this._adaptee._rawData[4] = redOffset;
            this._adaptee._rawData[5] = greenOffset;
            this._adaptee._rawData[6] = blueOffset;
            this._adaptee._rawData[7] = alphaOffset;
        };
        ColorTransform$$1.prototype.clone = function () {
            return new this.sec.flash.geom.ColorTransform(this._adaptee._rawData[0], this._adaptee._rawData[1], this._adaptee._rawData[2], this._adaptee._rawData[3], this._adaptee._rawData[4], this._adaptee._rawData[5], this._adaptee._rawData[6], this._adaptee._rawData[7]);
        };
        ColorTransform$$1.prototype.convertToFixedPoint = function () {
            this._adaptee._rawData[0] = clampS8U8(this._adaptee._rawData[0]);
            this._adaptee._rawData[1] = clampS8U8(this._adaptee._rawData[1]);
            this._adaptee._rawData[2] = clampS8U8(this._adaptee._rawData[2]);
            this._adaptee._rawData[3] = clampS8U8(this._adaptee._rawData[3]);
            this._adaptee._rawData[4] = toS16(this._adaptee._rawData[4]);
            this._adaptee._rawData[5] = toS16(this._adaptee._rawData[5]);
            this._adaptee._rawData[6] = toS16(this._adaptee._rawData[6]);
            this._adaptee._rawData[7] = toS16(this._adaptee._rawData[7]);
            return this;
        };
        ColorTransform$$1.prototype.dispose = function () {
            throw new AbstractMethodError();
        };
        ColorTransform$$1.prototype.equals = function (other) {
            if (this === other)
                return true;
            return this._adaptee._rawData[0] === other._adaptee._rawData[0] &&
                this._adaptee._rawData[1] === other._adaptee._rawData[1] &&
                this._adaptee._rawData[2] === other._adaptee._rawData[2] &&
                this._adaptee._rawData[3] === other._adaptee._rawData[3] &&
                this._adaptee._rawData[4] === other._adaptee._rawData[4] &&
                this._adaptee._rawData[5] === other._adaptee._rawData[5] &&
                this._adaptee._rawData[6] === other._adaptee._rawData[6] &&
                this._adaptee._rawData[7] === other._adaptee._rawData[7];
        };
        ColorTransform$$1.prototype.toString = function () {
            return "(redMultiplier=" + this._adaptee._rawData[0] +
                ", greenMultiplier=" + this._adaptee._rawData[1] +
                ", blueMultiplier=" + this._adaptee._rawData[2] +
                ", alphaMultiplier=" + this._adaptee._rawData[3] +
                ", redOffset=" + this._adaptee._rawData[4] +
                ", greenOffset=" + this._adaptee._rawData[5] +
                ", blueOffset=" + this._adaptee._rawData[6] +
                ", alphaOffset=" + this._adaptee._rawData[7] +
                ")";
        };
        ColorTransform$$1.classSymbols = null; // [];
        ColorTransform$$1.instanceSymbols = null; // ["redMultiplier", "greenMultiplier",
        return ColorTransform$$1;
    }(ASObject$1));

    function checkNullParameter(argument, name, sec) {
        if (argument == undefined) {
            sec.throwError('TypeError', Errors$1.NullPointerError, name);
        }
    }

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: Transform
    var Transform$1 = /** @class */ (function (_super) {
        __extends(Transform$$1, _super);
        function Transform$$1(displayObjectAdaptee) {
            var _this = _super.call(this) || this;
            if (!displayObjectAdaptee)
                _this.sec.throwError("ArgumentError", Errors$1.NullPointerError, "displayObject");
            _this._adaptee = (displayObjectAdaptee instanceof Transform) ? displayObjectAdaptee : new Transform();
            return _this;
        }
        Object.defineProperty(Transform$$1.prototype, "adaptee", {
            get: function () {
                return this._adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform$$1.prototype, "matrix", {
            get: function () {
                return new this.sec.flash.geom.Matrix(this._adaptee.matrix);
            },
            set: function (value) {
                this._adaptee.matrix = value.adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform$$1.prototype, "colorTransform", {
            get: function () {
                return new this.sec.flash.geom.ColorTransform(this._adaptee.colorTransform);
            },
            set: function (value) {
                this._adaptee.colorTransform = value.adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform$$1.prototype, "concatenatedMatrix", {
            get: function () {
                return new this.sec.flash.geom.Matrix(this._adaptee.matrix);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform$$1.prototype, "concatenatedColorTransform", {
            get: function () {
                release$1 || notImplemented("public flash.geom.Transform::get concatenatedColorTransform");
                return new this.sec.flash.geom.ColorTransform(this._adaptee.colorTransform);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform$$1.prototype, "pixelBounds", {
            get: function () {
                // Only somewhat implemented because this is largely untested.
                release$1 || notImplemented("public flash.geom.Transform::get pixelBounds");
                return new this.sec.flash.geom.Rectangle(this._adaptee.pixelBounds);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Transform$$1.prototype, "matrix3D", {
            get: function () {
                return new this.sec.flash.geom.Matrix3D(this._adaptee.matrix3D);
            },
            set: function (m) {
                release$1 || notImplemented("public flash.geom.Transform::set matrix3D");
            },
            enumerable: true,
            configurable: true
        });
        Transform$$1.prototype.getRelativeMatrix3D = function (relativeTo) {
            checkNullParameter(relativeTo, "relativeTo", this.sec);
            release$1 || notImplemented("public flash.geom.Transform::getRelativeMatrix3D");
            // TODO: actually calculate the relative matrix.
            return new this.sec.flash.geom.Matrix3D(this._adaptee.matrix3D);
        };
        Object.defineProperty(Transform$$1.prototype, "perspectiveProjection", {
            get: function () {
                release$1 || notImplemented("public flash.geom.Transform::get perspectiveProjection");
                return new PerspectiveProjection();
            },
            set: function (projection) {
                release$1 || notImplemented("public flash.geom.Transform::set perspectiveProjection");
            },
            enumerable: true,
            configurable: true
        });
        Transform$$1.classInitializer = null;
        return Transform$$1;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: URLRequest
    var URLRequest$1 = /** @class */ (function (_super) {
        __extends(URLRequest$$1, _super);
        function URLRequest$$1(url) {
            if (url === void 0) { url = null; }
            var _this = _super.call(this) || this;
            _this._adaptee = new URLRequest(url);
            return _this;
        }
        Object.defineProperty(URLRequest$$1.prototype, "adaptee", {
            get: function () {
                return this._adaptee;
            },
            set: function (value) {
                this._adaptee = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(URLRequest$$1.prototype, "url", {
            get: function () {
                return this._adaptee.url;
            },
            set: function (value) {
                value = axCoerceString$3(value);
                this._adaptee.url = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(URLRequest$$1.prototype, "data", {
            get: function () {
                return this._adaptee.data;
            },
            set: function (value) {
                this._adaptee.data = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(URLRequest$$1.prototype, "method", {
            get: function () {
                return this._adaptee.method;
            },
            set: function (value) {
                this._adaptee.method = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(URLRequest$$1.prototype, "contentType", {
            get: function () {
                console.log("TODO: URLRequest.contentType");
                return ""; //this._adaptee.contentType;
            },
            set: function (value) {
                console.log("TODO: URLRequest.contentType");
                //this._adaptee.contentType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(URLRequest$$1.prototype, "requestHeaders", {
            get: function () {
                console.log("TODO: URLRequest.requestHeaders");
                return null; //this._adaptee.contentType;
            },
            set: function (value) {
                console.log("TODO: URLRequest.requestHeaders");
                //this._adaptee.contentType = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(URLRequest$$1.prototype, "digest", {
            get: function () {
                console.log("TODO: URLRequest.digest");
                return null; //this._adaptee.contentType;
            },
            set: function (value) {
                console.log("TODO: URLRequest.digest");
                //this._adaptee.contentType = value;
            },
            enumerable: true,
            configurable: true
        });
        return URLRequest$$1;
    }(ASObject$1));

    var URLLoader$1 = /** @class */ (function (_super) {
        __extends(URLLoader$$1, _super);
        function URLLoader$$1() {
            var _this = _super.call(this) || this;
            _this._adaptee = new URLLoader();
            _this._completeCallbackDelegate = function (event) { return _this.completeCallback(event); };
            _this._progressCallbackDelegate = function (event) { return _this.progressCallback(event); };
            _this._loadErrorDelegate = function (event) { return _this.loadErrorDelegate(event); };
            _this.eventMapping[Event.COMPLETE] = {
                adaptedType: URLLoaderEvent.LOAD_COMPLETE,
                addListener: _this.initListener,
                removeListener: _this.removeListener,
                callback: _this._completeCallbackDelegate
            };
            _this.eventMapping[ProgressEvent.PROGRESS] = {
                adaptedType: URLLoaderEvent.LOAD_PROGRESS,
                addListener: _this.initListener,
                removeListener: _this.removeListener,
                callback: _this._progressCallbackDelegate
            };
            _this.eventMapping[IOErrorEvent.IO_ERROR] = {
                adaptedType: URLLoaderEvent.LOAD_ERROR,
                addListener: _this.initListener,
                removeListener: _this.removeListener,
                callback: _this._loadErrorDelegate
            };
            return _this;
        }
        URLLoader$$1.prototype.close = function () {
            console.log("not mimplemented: URLoader.close");
        };
        Object.defineProperty(URLLoader$$1.prototype, "data", {
            get: function () {
                return this._adaptee.data;
            },
            enumerable: true,
            configurable: true
        });
        URLLoader$$1.prototype.initListener = function (type, callback) {
            this._adaptee.addEventListener(type, callback);
        };
        URLLoader$$1.prototype.removeListener = function (type, callback) {
            this._adaptee.removeEventListener(type, callback);
        };
        URLLoader$$1.prototype.addEventListener = function (type, callback) {
            _super.prototype.addEventListener.call(this, type, callback);
        };
        URLLoader$$1.prototype.loadErrorDelegate = function (event) {
            if (event === void 0) { event = null; }
            var newEvent = new this.sec.flash.events.IOErrorEvent(IOErrorEvent.IO_ERROR);
            newEvent.currentTarget = this;
            this.dispatchEvent(newEvent);
        };
        URLLoader$$1.prototype.progressCallback = function (event) {
            if (event === void 0) { event = null; }
            var newEvent = new this.sec.flash.events.ProgressEvent(ProgressEvent.PROGRESS, null, null, event.urlLoader.bytesLoaded, event.urlLoader.bytesTotal);
            newEvent.currentTarget = this;
            this.dispatchEvent(newEvent);
        };
        URLLoader$$1.prototype.completeCallback = function (event) {
            if (event === void 0) { event = null; }
            var newEvent = new this.sec.flash.events.Event(Event.COMPLETE);
            newEvent.currentTarget = this;
            newEvent.target = this;
            this.dispatchEvent(newEvent);
        };
        URLLoader$$1.prototype.load = function (request) {
            this._adaptee.load(request.adaptee);
        };
        return URLLoader$$1;
    }(EventDispatcher$1));

    function forEachPublicProperty$1(object, callbackfn, thisArg) {
        // REDUX: Do we need to walk the proto chain here?
        var properties = object.axGetEnumerableKeys();
        for (var i = 0; i < properties.length; i++) {
            var property = properties[i];
            var value = object.axGetPublicProperty(property);
            callbackfn.call(thisArg, property, value);
        }
    }

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AMF3ReferenceTables = /** @class */ (function () {
        function AMF3ReferenceTables() {
            this.strings = [];
            this.objects = [];
            this.traits = [];
            /**
             * Trait names are kept in sync with |traits| and are used to optimize fetching public trait names.
             */
            this.traitNames = [];
        }
        return AMF3ReferenceTables;
    }());
    var ClassAliases = /** @class */ (function () {
        function ClassAliases() {
            this._classMap = new WeakMap();
            this._nameMap = Object.create(null);
        }
        ClassAliases.prototype.getAliasByClass = function (axClass) {
            return this._classMap.get(axClass);
        };
        ClassAliases.prototype.getClassByAlias = function (alias) {
            return this._nameMap[alias];
        };
        ClassAliases.prototype.registerClassAlias = function (alias, axClass) {
            this._classMap.set(axClass, alias);
            release$1 || assert(!this._nameMap[alias] || (this._nameMap[alias] === axClass));
            this._nameMap[alias] = axClass;
        };
        return ClassAliases;
    }());
    function writeString(ba, s) {
        if (s.length > 0xFFFF) {
            throw "AMF short string exceeded";
        }
        if (!s.length) {
            ba.writeByte(0x00);
            ba.writeByte(0x00);
            return;
        }
        var bytes = StringUtilities.utf8decode(s);
        ba.writeByte((bytes.length >> 8) & 255);
        ba.writeByte(bytes.length & 255);
        for (var i = 0; i < bytes.length; i++) {
            ba.writeByte(bytes[i]);
        }
    }
    function readString(ba) {
        var byteLength = (ba.readByte() << 8) | ba.readByte();
        if (!byteLength) {
            return "";
        }
        var buffer = new Uint8Array(byteLength);
        for (var i = 0; i < byteLength; i++) {
            buffer[i] = ba.readByte();
        }
        return StringUtilities.utf8encode(buffer);
    }
    function writeDouble(ba, value) {
        var buffer = new ArrayBuffer(8);
        var view = new DataView(buffer);
        view.setFloat64(0, value, false);
        for (var i = 0; i < buffer.byteLength; i++) {
            ba.writeByte(view.getUint8(i));
        }
    }
    function readDouble(ba) {
        var buffer = new ArrayBuffer(8);
        var view = new DataView(buffer);
        for (var i = 0; i < buffer.byteLength; i++) {
            view.setUint8(i, ba.readByte());
        }
        return view.getFloat64(0, false);
    }
    var AMF0 = /** @class */ (function () {
        function AMF0() {
        }
        AMF0.write = function (ba, value) {
            switch (typeof value) {
                case "boolean":
                    ba.writeByte(1 /* BOOLEAN */);
                    ba.writeByte(value ? 0x01 : 0x00);
                    break;
                case "number":
                    ba.writeByte(0 /* NUMBER */);
                    writeDouble(ba, value);
                    break;
                case "undefined":
                    ba.writeByte(6 /* UNDEFINED */);
                    break;
                case "string":
                    ba.writeByte(2 /* STRING */);
                    writeString(ba, value);
                    break;
                case "object":
                    var object = value;
                    release$1 || assert(object === null || AXBasePrototype.isPrototypeOf(object));
                    if (object === null) {
                        ba.writeByte(5 /* NULL */);
                    }
                    else if (ba.sec.AXArray.axIsType(object)) {
                        var array = object.value;
                        ba.writeByte(8 /* ECMA_ARRAY */);
                        ba.writeByte((array.length >>> 24) & 255);
                        ba.writeByte((array.length >> 16) & 255);
                        ba.writeByte((array.length >> 8) & 255);
                        ba.writeByte(array.length & 255);
                        // REDUX: What about sparse arrays?
                        forEachPublicProperty$1(object, function (key, value) {
                            writeString(ba, key);
                            this.write(ba, value);
                        }, this);
                        ba.writeByte(0x00);
                        ba.writeByte(0x00);
                        ba.writeByte(9 /* OBJECT_END */);
                    }
                    else {
                        ba.writeByte(3 /* OBJECT */);
                        forEachPublicProperty$1(object, function (key, value) {
                            writeString(ba, key);
                            this.write(ba, value);
                        }, this);
                        ba.writeByte(0x00);
                        ba.writeByte(0x00);
                        ba.writeByte(9 /* OBJECT_END */);
                    }
                    return;
            }
        };
        AMF0.read = function (ba) {
            var marker = ba.readByte();
            switch (marker) {
                case 0 /* NUMBER */:
                    return readDouble(ba);
                case 1 /* BOOLEAN */:
                    return !!ba.readByte();
                case 2 /* STRING */:
                    return readString(ba);
                case 3 /* OBJECT */:
                    var object = ba.sec.createObject();
                    while (true) {
                        var key = readString(ba);
                        if (!key.length)
                            break;
                        object.axSetPublicProperty(key, this.read(ba));
                    }
                    if (ba.readByte() !== 9 /* OBJECT_END */) {
                        throw "AMF0 End marker is not found";
                    }
                    return object;
                case 5 /* NULL */:
                    return null;
                case 6 /* UNDEFINED */:
                    return undefined;
                case 8 /* ECMA_ARRAY */:
                    var array = ba.sec.createArray([]);
                    array.length = (ba.readByte() << 24) | (ba.readByte() << 16) |
                        (ba.readByte() << 8) | ba.readByte();
                    while (true) {
                        var key = readString(ba);
                        if (!key.length)
                            break;
                        array.axSetPublicProperty(key, this.read(ba));
                    }
                    if (ba.readByte() !== 9 /* OBJECT_END */) {
                        throw "AMF0 End marker is not found";
                    }
                    return array;
                case 10 /* STRICT_ARRAY */:
                    var array = ba.sec.createArray([]);
                    var length = array.length = (ba.readByte() << 24) | (ba.readByte() << 16) |
                        (ba.readByte() << 8) | ba.readByte();
                    for (var i = 0; i < length; i++) {
                        array.axSetPublicProperty(i, this.read(ba));
                    }
                    return array;
                case 17 /* AVMPLUS */:
                    return readAMF3Value(ba, new AMF3ReferenceTables());
                default:
                    throw "AMF0 Unknown marker " + marker;
            }
        };
        return AMF0;
    }());
    function readU29(ba) {
        var b1 = ba.readByte();
        if ((b1 & 0x80) === 0) {
            return b1;
        }
        var b2 = ba.readByte();
        if ((b2 & 0x80) === 0) {
            return ((b1 & 0x7F) << 7) | b2;
        }
        var b3 = ba.readByte();
        if ((b3 & 0x80) === 0) {
            return ((b1 & 0x7F) << 14) | ((b2 & 0x7F) << 7) | b3;
        }
        var b4 = ba.readByte();
        return ((b1 & 0x7F) << 22) | ((b2 & 0x7F) << 15) | ((b3 & 0x7F) << 8) | b4;
    }
    function writeU29(ba, value) {
        if ((value & 0xFFFFFF80) === 0) {
            ba.writeByte(value & 0x7F);
        }
        else if ((value & 0xFFFFC000) === 0) {
            ba.writeByte(0x80 | ((value >> 7) & 0x7F));
            ba.writeByte(value & 0x7F);
        }
        else if ((value & 0xFFE00000) === 0) {
            ba.writeByte(0x80 | ((value >> 14) & 0x7F));
            ba.writeByte(0x80 | ((value >> 7) & 0x7F));
            ba.writeByte(value & 0x7F);
        }
        else if ((value & 0xC0000000) === 0) {
            ba.writeByte(0x80 | ((value >> 22) & 0x7F));
            ba.writeByte(0x80 | ((value >> 15) & 0x7F));
            ba.writeByte(0x80 | ((value >> 8) & 0x7F));
            ba.writeByte(value & 0xFF);
        }
        else {
            throw "AMF3 U29 range";
        }
    }
    function readUTF8(ba, references) {
        var u29s = readU29(ba);
        if (u29s === 0x01) {
            return "";
        }
        var strings = references.strings;
        if ((u29s & 1) === 0) {
            return strings[u29s >> 1];
        }
        var byteLength = u29s >> 1;
        var buffer = new Uint8Array(byteLength);
        for (var i = 0; i < byteLength; i++) {
            buffer[i] = ba.readByte();
        }
        var value = StringUtilities.utf8encode(buffer);
        strings.push(value);
        return value;
    }
    function writeUTF8(ba, s, references) {
        if (s === "") {
            ba.writeByte(0x01); // empty string
            return;
        }
        var strings = references.strings;
        var index = strings.indexOf(s);
        if (index >= 0) {
            writeU29(ba, index << 1);
            return;
        }
        strings.push(s);
        var bytes = StringUtilities.utf8decode(s);
        writeU29(ba, 1 | (bytes.length << 1));
        for (var i = 0; i < bytes.length; i++) {
            ba.writeByte(bytes[i]);
        }
    }
    function readAMF3Value(ba, references) {
        var marker = ba.readByte();
        switch (marker) {
            case 1 /* NULL */:
                return null;
            case 0 /* UNDEFINED */:
                return undefined;
            case 2 /* FALSE */:
                return false;
            case 3 /* TRUE */:
                return true;
            case 4 /* INTEGER */:
                return readU29(ba);
            case 5 /* DOUBLE */:
                return readDouble(ba);
            case 6 /* STRING */:
                return readUTF8(ba, references);
            case 8 /* DATE */:
                var u29o = readU29(ba);
                release$1 || assert((u29o & 1) === 1);
                return ba.sec.AXDate.axConstruct([readDouble(ba)]);
            case 10 /* OBJECT */:
                var u29o = readU29(ba);
                if ((u29o & 1) === 0) {
                    return references.objects[u29o >> 1];
                }
                if ((u29o & 4) !== 0) {
                    throw "AMF3 Traits-Ext is not supported";
                }
                var axClass;
                var traits;
                var isDynamic = true;
                var traitNames;
                if ((u29o & 2) === 0) {
                    traits = references.traits[u29o >> 2];
                    traitNames = references.traitNames[u29o >> 2];
                }
                else {
                    var alias = readUTF8(ba, references);
                    if (alias) {
                        traits = axClass = ba.sec.classAliases.getClassByAlias(alias);
                    }
                    isDynamic = (u29o & 8) !== 0;
                    traitNames = [];
                    for (var i = 0, j = u29o >> 4; i < j; i++) {
                        traitNames.push(readUTF8(ba, references));
                    }
                    references.traits.push(traits);
                    references.traitNames.push(traitNames);
                }
                var object = axClass ? axClass.axConstruct([]) : ba.sec.createObject();
                references.objects.push(object);
                // Read trait properties.
                for (var i = 0; i < traitNames.length; i++) {
                    var value = readAMF3Value(ba, references);
                    object.axSetPublicProperty(traitNames[i], value);
                }
                // Read dynamic properties.
                if (isDynamic) {
                    while (true) {
                        var key = readUTF8(ba, references);
                        if (key === "")
                            break;
                        var value = readAMF3Value(ba, references);
                        object.axSetPublicProperty(key, value);
                    }
                }
                return object;
            case 9 /* ARRAY */:
                var u29o = readU29(ba);
                if ((u29o & 1) === 0) {
                    return references.objects[u29o >> 1];
                }
                var array = ba.sec.createArray([]);
                references.objects.push(array);
                var densePortionLength = u29o >> 1;
                while (true) {
                    var key = readUTF8(ba, references);
                    if (!key.length)
                        break;
                    var value = readAMF3Value(ba, references);
                    array.axSetPublicProperty(key, value);
                }
                for (var i = 0; i < densePortionLength; i++) {
                    var value = readAMF3Value(ba, references);
                    array.axSetPublicProperty(i, value);
                }
                return array;
            default:
                throw "AMF3 Unknown marker " + marker;
        }
    }
    /**
     * Tries to write a reference to a previously written object.
     */
    function tryWriteAndStartTrackingReference(ba, object, references) {
        var objects = references.objects;
        var index = objects.indexOf(object);
        if (index < 0) {
            objects.push(object);
            return false;
        }
        writeU29(ba, index << 1);
        return true;
    }
    var MAX_INT = 268435456 - 1; // 2^28 - 1
    var MIN_INT = -268435456; // -2^28
    function writeAMF3Value(ba, value, references) {
        switch (typeof value) {
            case "boolean":
                ba.writeByte(value ? 3 /* TRUE */ : 2 /* FALSE */);
                break;
            case "number":
                var useInteger = value === (value | 0);
                if (useInteger) {
                    if (value > MAX_INT || value < MIN_INT) {
                        useInteger = false;
                    }
                }
                if (useInteger) {
                    ba.writeByte(4 /* INTEGER */);
                    writeU29(ba, value);
                }
                else {
                    ba.writeByte(5 /* DOUBLE */);
                    writeDouble(ba, value);
                }
                break;
            case "undefined":
                ba.writeByte(0 /* UNDEFINED */);
                break;
            case "string":
                ba.writeByte(6 /* STRING */);
                writeUTF8(ba, value, references);
                break;
            case "object":
                if (value === null) {
                    ba.writeByte(1 /* NULL */);
                }
                else if (ba.sec.AXArray.axIsType(value)) {
                    var array = value;
                    ba.writeByte(9 /* ARRAY */);
                    if (tryWriteAndStartTrackingReference(ba, array, references)) {
                        break;
                    }
                    var densePortionLength = 0;
                    while (array.axHasPublicProperty(densePortionLength)) {
                        ++densePortionLength;
                    }
                    writeU29(ba, (densePortionLength << 1) | 1);
                    forEachPublicProperty$1(array, function (i, value) {
                        if (isNumeric(i) && i >= 0 && i < densePortionLength) {
                            return;
                        }
                        writeUTF8(ba, i, references);
                        writeAMF3Value(ba, value, references);
                    });
                    writeUTF8(ba, "", references);
                    for (var j = 0; j < densePortionLength; j++) {
                        writeAMF3Value(ba, array.axGetPublicProperty(j), references);
                    }
                }
                else if (ba.sec.AXDate.axIsType(value)) {
                    ba.writeByte(8 /* DATE */);
                    if (tryWriteAndStartTrackingReference(ba, value, references))
                        break;
                    writeU29(ba, 1);
                    writeDouble(ba, value.valueOf());
                }
                else {
                    var object = value;
                    // TODO Vector, Dictionary, ByteArray and XML support
                    ba.writeByte(10 /* OBJECT */);
                    if (tryWriteAndStartTrackingReference(ba, object, references)) {
                        break;
                    }
                    var isDynamic = true;
                    var axClass = object.axClass;
                    if (axClass) {
                        var classInfo = axClass.classInfo;
                        isDynamic = !classInfo.instanceInfo.isSealed();
                        var alias = ba.sec.classAliases.getAliasByClass(axClass) || "";
                        var traitsRef = references.traits.indexOf(axClass);
                        var traitNames = null;
                        if (traitsRef < 0) {
                            // Write traits since we haven't done so yet.
                            traitNames = classInfo.instanceInfo.runtimeTraits.getSlotPublicTraitNames();
                            references.traits.push(axClass);
                            references.traitNames.push(traitNames);
                            writeU29(ba, (isDynamic ? 0x0B : 0x03) + (traitNames.length << 4));
                            writeUTF8(ba, alias, references);
                            // Write trait names.
                            for (var i = 0; i < traitNames.length; i++) {
                                writeUTF8(ba, traitNames[i], references);
                            }
                        }
                        else {
                            // Write a reference to the previously written traits.
                            traitNames = references.traitNames[traitsRef];
                            writeU29(ba, 0x01 + (traitsRef << 2));
                        }
                        // Write the actual trait values.
                        for (var i = 0; i < traitNames.length; i++) {
                            writeAMF3Value(ba, object.axGetPublicProperty(traitNames[i]), references);
                        }
                    }
                    else {
                        // REDUX: I don't understand in what situations we wouldn't have a class definition, ask Yury.
                        // object with no class definition
                        writeU29(ba, 0x0B);
                        writeUTF8(ba, "", references); // empty alias name
                    }
                    // Write dynamic properties.
                    if (isDynamic) {
                        forEachPublicProperty$1(object, function (i, value) {
                            writeUTF8(ba, i, references);
                            writeAMF3Value(ba, value, references);
                        });
                        writeUTF8(ba, "", references);
                    }
                }
                return;
        }
    }
    var AMF3 = /** @class */ (function () {
        function AMF3() {
        }
        AMF3.write = function (ba, object) {
            writeAMF3Value(ba, object, new AMF3ReferenceTables());
        };
        AMF3.read = function (ba) {
            return readAMF3Value(ba, new AMF3ReferenceTables());
        };
        return AMF3;
    }());

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var AMFEncoding;
    (function (AMFEncoding) {
        AMFEncoding[AMFEncoding["AMF0"] = 0] = "AMF0";
        AMFEncoding[AMFEncoding["AMF3"] = 3] = "AMF3";
        AMFEncoding[AMFEncoding["DEFAULT"] = 3] = "DEFAULT";
    })(AMFEncoding || (AMFEncoding = {}));
    var ObjectEncoding = /** @class */ (function (_super) {
        __extends(ObjectEncoding, _super);
        function ObjectEncoding() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Object.defineProperty(ObjectEncoding, "dynamicPropertyWriter", {
            get: function () {
                release$1 || release$1 || notImplemented("public ObjectEncoding::get dynamicPropertyWriter");
                return null;
            },
            set: function (value /* flash.net.IDynamicPropertyWriter */) {
                release$1 || release$1 || notImplemented("public ObjectEncoding::set dynamicPropertyWriter");
            },
            enumerable: true,
            configurable: true
        });
        ObjectEncoding.AMF0 = AMFEncoding.AMF0;
        ObjectEncoding.AMF3 = AMFEncoding.AMF3;
        ObjectEncoding.DEFAULT = AMFEncoding.DEFAULT;
        return ObjectEncoding;
    }(ASObject$1));
    var ByteArrayDataProvider = /** @class */ (function () {
        function ByteArrayDataProvider() {
        }
        return ByteArrayDataProvider;
    }());
    var ByteArray$1 = /** @class */ (function (_super) {
        __extends(ByteArray, _super);
        function ByteArray(source) {
            var _this = _super.call(this) || this;
            if (ByteArrayDataProvider.symbolForConstructor) {
                source = ByteArrayDataProvider.symbolForConstructor;
                ByteArrayDataProvider.symbolForConstructor = null;
            }
            var buffer;
            var length = 0;
            if (source) {
                if (source instanceof ArrayBuffer) {
                    buffer = source.slice(0);
                }
                else if (Array.isArray(source)) {
                    buffer = new Uint8Array(source).buffer;
                }
                else if ('buffer' in source) {
                    if (source.buffer instanceof ArrayBuffer) {
                        buffer = new Uint8Array(source.buffer).buffer;
                    }
                    else if (source.buffer instanceof Uint8Array) {
                        var begin = source.buffer.byteOffset;
                        buffer = source.buffer.buffer.slice(begin, begin + source.buffer.length);
                    }
                    else {
                        release$1 || assert(source.buffer instanceof ArrayBuffer);
                        buffer = source.buffer.slice();
                    }
                }
                else {
                    unexpected("Source type.");
                }
                length = buffer.byteLength;
            }
            else {
                buffer = new ArrayBuffer(ByteArray.INITIAL_SIZE);
            }
            _this._buffer = buffer;
            _this._length = length;
            _this._position = 0;
            _this._resetViews();
            _this._objectEncoding = ByteArray.defaultObjectEncoding;
            _this._littleEndian = false; // AS3 is bigEndian by default.
            _this._bitBuffer = 0;
            _this._bitLength = 0;
            return _this;
        }
        ByteArray.classInitializer = function () {
            var proto = DataBuffer.prototype;
            ObjectUtilities.defineNonEnumerableProperty(proto, '$BgtoJSON', proto.toJSON);
        };
        Object.defineProperty(ByteArray, "defaultObjectEncoding", {
            get: function () {
                return this._defaultObjectEncoding;
            },
            set: function (version /*uint*/) {
                version = version >>> 0;
                this._defaultObjectEncoding = version;
            },
            enumerable: true,
            configurable: true
        });
        ByteArray.prototype.toJSON = function () {
            return "ByteArray";
        };
        ByteArray.prototype.readObject = function () {
            switch (this._objectEncoding) {
                case ObjectEncoding.AMF0:
                    return AMF0.read(this);
                case ObjectEncoding.AMF3:
                    return AMF3.read(this);
                default:
                    unexpected("Object Encoding");
            }
        };
        ByteArray.prototype.writeObject = function (object) {
            switch (this._objectEncoding) {
                case ObjectEncoding.AMF0:
                    return AMF0.write(this, object);
                case ObjectEncoding.AMF3:
                    return AMF3.write(this, object);
                default:
                    unexpected("Object Encoding");
            }
        };
        ByteArray.prototype.axGetPublicProperty = function (nm) {
            if (typeof nm === 'number' || isNumeric(nm = axCoerceName(nm))) {
                return this.axGetNumericProperty(nm);
            }
            return this['$Bg' + nm];
        };
        ByteArray.prototype.axGetNumericProperty = function (nm) {
            release$1 || assert(typeof nm === 'number');
            return this.getValue(nm);
        };
        ByteArray.prototype.axSetPublicProperty = function (nm, value) {
            release$1 || checkValue(value);
            if (typeof nm === 'number' || isNumeric(nm = axCoerceName(nm))) {
                this.axSetNumericProperty(nm, value);
                return;
            }
            this['$Bg' + nm] = value;
        };
        ByteArray.prototype.axSetNumericProperty = function (nm, value) {
            release$1 || assert(typeof nm === 'number');
            this.setValue(nm, value);
        };
        ByteArray.prototype.axGetProperty = function (mn) {
            var name = mn.name;
            if (typeof name === 'number' || isNumeric(name = axCoerceName(name))) {
                release$1 || assert(mn.isRuntimeName());
                return this.getValue(+name);
            }
            return _super.prototype.axGetProperty.call(this, mn);
        };
        ByteArray.prototype.axSetProperty = function (mn, value, bc) {
            release$1 || checkValue(value);
            var name = mn.name;
            if (typeof name === 'number' || isNumeric(name = axCoerceName(name))) {
                release$1 || assert(mn.isRuntimeName());
                this.setValue(+name, value);
                return;
            }
            _super.prototype.axSetProperty.call(this, mn, value, bc);
        };
        ByteArray.classNatives = [DataBuffer];
        ByteArray.instanceNatives = [DataBuffer.prototype];
        /* The initial size of the backing, in bytes. Doubled every OOM. */
        ByteArray.INITIAL_SIZE = 128;
        ByteArray._defaultObjectEncoding = ObjectEncoding.DEFAULT;
        return ByteArray;
    }(ASObject$1));

    var _sharedObjectStorage;
    function getSharedObjectStorage() {
        /*if (!_sharedObjectStorage) {
          if (typeof ShumwayCom !== 'undefined' && ShumwayCom.createSpecialStorage) {
            _sharedObjectStorage = ShumwayCom.createSpecialStorage();
          } else {
            _sharedObjectStorage = (<any>window).sessionStorage;
          }
        }
        release || assert(_sharedObjectStorage, "SharedObjectStorage is not available.");
        */
        if (typeof (Storage) !== "undefined") {
            _sharedObjectStorage = localStorage;
        }
        return _sharedObjectStorage;
    }
    var SharedObject = /** @class */ (function (_super) {
        __extends(SharedObject, _super);
        //for AVM1:
        //public fps: number;
        function SharedObject() {
            return _super.call(this) || this;
        }
        Object.defineProperty(SharedObject, "defaultObjectEncoding", {
            get: function () {
                notImplemented("public flash.net.SharedObject::static defaultObjectEncoding");
                return;
            },
            set: function (version /*uint*/) {
                notImplemented("public flash.net.SharedObject::static defaultObjectEncoding");
                return;
            },
            enumerable: true,
            configurable: true
        });
        SharedObject.deleteAll = function (url) {
            notImplemented("public flash.net.SharedObject::static deleteAll");
            return;
        };
        SharedObject.getDiskUsage = function (url) {
            notImplemented("public flash.net.SharedObject::static getDiskUsage");
            return 0;
        };
        SharedObject.getLocal = function (name, localPath, secure) {
            name = axCoerceString$3(name);
            localPath = axCoerceString$3(localPath);
            secure = !!secure;
            var path = (localPath || '') + '/' + name;
            /*if (this._sharedObjects[path]) {
            return this._sharedObjects[path];
            }*/
            var encodedData = getSharedObjectStorage().getItem(path);
            var data;
            var encoding = this._defaultObjectEncoding;
            if (encodedData) {
                try {
                    var bytes = StringUtilities.decodeRestrictedBase64ToBytes(encodedData);
                    //console.log("loaded bytes", bytes);
                    var serializedData = new ByteArray(bytes.length);
                    serializedData.sec = this.sec;
                    serializedData.setArrayBuffer(bytes.buffer);
                    //console.log("serializedData.arraybytes", serializedData.arraybytes);
                    //	unexpected("Object Encoding");
                    //}
                    data = AMF3.read(serializedData); //serializedData.readObject();
                    //encoding = serializedData.objectEncoding;
                }
                catch (e) {
                    warning('Error encountered while decoding LocalStorage entry. Resetting data.');
                }
                if (!data || typeof data !== 'object') {
                    data = this.sec.createObject();
                }
            }
            else {
                data = this.sec.createObject();
            }
            var so = this.sec.flash.net.SharedObject();
            so._path = path;
            so._objectEncoding = encoding;
            so._data = data;
            return so;
        };
        SharedObject.getRemote = function (name, remotePath, persistence, secure) {
            return new SharedObject();
        };
        SharedObject.prototype.flush = function (minDiskSpace) {
            if (minDiskSpace === void 0) { minDiskSpace = 0; }
            /*if (typeof (Storage) !== "undefined") {
                localStorage.setItem(this._object_name, JSON.stringify(this._data));
            }
            else {
                console.log("no local storage available");

            }*/
            minDiskSpace = minDiskSpace | 0;
            // Check if the object is empty. If it is, don't create a stored object if one doesn't exist.
            var isEmpty = true;
            for (var key in this._data) {
                if (this._data.hasOwnProperty(key)) {
                    isEmpty = false;
                    break;
                }
            }
            if (isEmpty && !getSharedObjectStorage().getItem(this._path)) {
                return;
            }
            var serializedData = new ByteArray();
            serializedData.sec = this.sec;
            //serializedData.objectEncoding = this._objectEncoding;
            serializedData.writeObject(this._data);
            AMF3.write(serializedData, this._data);
            //data = AMF3.write(<any>serializedData); //serializedData.readObject();
            var bytes = new Uint8Array(serializedData.arraybytes);
            var encodedData = StringUtilities.base64EncodeBytes(bytes);
            /*if (!release) {
              var decoded = StringUtilities.decodeRestrictedBase64ToBytes(encodedData);
              assert(decoded.byteLength === bytes.byteLength);
              for (var i = 0; i < decoded.byteLength; i++) {
                assert(decoded[i] === bytes[i]);
              }
            }*/
            getSharedObjectStorage().setItem(this._path, encodedData);
        };
        Object.defineProperty(SharedObject.prototype, "data", {
            get: function () {
                return this._data;
            },
            set: function (object) {
                this._data = object;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SharedObject.prototype, "objectEncoding", {
            get: function () {
                notImplemented("public flash.net.SharedObject::get objectEncoding");
                return;
            },
            set: function (version /*uint*/) {
                notImplemented("public flash.net.SharedObject::set objectEncoding");
                return;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SharedObject.prototype, "client", {
            get: function () {
                notImplemented("public flash.net.SharedObject::get client");
                return;
                // return this._client;
            },
            set: function (object) {
                notImplemented("public flash.net.SharedObject::set client");
                return;
                // this._client = object;
            },
            enumerable: true,
            configurable: true
        });
        SharedObject.prototype.setDirty = function (propertyName) {
            notImplemented("public flash.net.SharedObject::setDirty");
            return;
        };
        SharedObject.prototype.connect = function (myConnection, params) {
            if (params === void 0) { params = null; }
            notImplemented("public flash.net.SharedObject::connect");
            return;
        };
        SharedObject.prototype.send = function () {
            notImplemented("public flash.net.SharedObject::send");
            return;
        };
        SharedObject.prototype.close = function () {
            notImplemented("public flash.net.SharedObject::close");
            return;
        };
        SharedObject.prototype.clear = function () {
            notImplemented("public flash.net.SharedObject::clear");
            return;
        };
        Object.defineProperty(SharedObject.prototype, "size", {
            get: function () {
                notImplemented("public flash.net.SharedObject::get size");
                return;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SharedObject.prototype, "fps", {
            set: function (updatesPerSecond) {
                notImplemented("public flash.net.SharedObject::set fps");
                return;
            },
            enumerable: true,
            configurable: true
        });
        SharedObject.prototype.setProperty = function (propertyName, value) {
            if (value === void 0) { value = null; }
            notImplemented("public flash.net.SharedObject::setProperty");
            return;
        };
        SharedObject._defaultObjectEncoding = ObjectEncoding.DEFAULT;
        return SharedObject;
    }(ASObject$1));

    var LoaderContext$1 = /** @class */ (function (_super) {
        __extends(LoaderContext, _super);
        function LoaderContext(checkPolicyFile, applicationDomain, securityDomain) {
            if (checkPolicyFile === void 0) { checkPolicyFile = false; }
            if (applicationDomain === void 0) { applicationDomain = null; }
            if (securityDomain === void 0) { securityDomain = null; }
            var _this = _super.call(this) || this;
            _this._applicationDomain = applicationDomain;
            return _this;
        }
        Object.defineProperty(LoaderContext.prototype, "applicationDomain", {
            get: function () {
                return this._applicationDomain;
            },
            set: function (value) {
                this._applicationDomain = value;
            },
            enumerable: true,
            configurable: true
        });
        return LoaderContext;
    }(ASObject$1));

    //
    /**
     * Dispatched when data is received as a load operation progresses.
     * @eventType	flash.events.ProgressEvent.PROGRESS
     [Event(name="progress", type="flash.events.Progress [EventEvent")]
     
     * Dispatched when a load operation starts.
     * @eventType	flash.events.Event.OPEN
     [Event(name="open", type="flash.events. [EventEvent")]
     
     * Dispatched when an input/output error occurs that causes a load operation to fail.
     * @eventType	flash.events.IOErrorEvent.IO_ERROR
     [Event(name="ioError", type="flash.events.IOError [EventEvent")]
     
     * Dispatched by a Sound object when ID3 data is available for an MP3 sound.
     * @eventType	flash.events.Event.ID3
     [Event(name="id3", type="flash.events. [EventEvent")]
     
     * Dispatched when data has loaded successfully.
     * @eventType	flash.events.Event.COMPLETE
     [Event(name="complete", type="flash.events. [EventEvent")]
     
     * Dispatched when the runtime requests new audio data.
     * @eventType	flash.events.SampleDataEvent.SAMPLE_DATA
     [Event(name="sampleData", type="flash.events.SampleData [EventEvent")]
     
     * The Sound class lets you work with sound in an application. The Sound class
     * lets you create a Sound object, load and play an external MP3 file into that object,
     * close the sound stream, and access
     * data about the sound, such as information about the number of bytes in the stream and
     * ID3 metadata. More detailed control of the sound is performed through the sound source —
     * the SoundChannel or Microphone object for the sound — and through the properties
     * in the SoundTransform class that control the output of the sound to the computer's speakers.
     *
     *   <p class="- topic/p ">In Flash Player 10 and later and AIR 1.5 and later, you can also use this
     * class to work with sound that is generated dynamically.
     * In this case, the Sound object uses the function you assign to a <codeph class="+ topic/ph pr-d/codeph ">sampleData</codeph> event handler to
     * poll for sound data. The sound is played as it is retrieved from a ByteArray object that
     * you populate with sound data. You can use <codeph class="+ topic/ph pr-d/codeph ">Sound.extract()</codeph> to extract sound data from a
     * Sound object,
     * after which you can manipulate it before writing it back to the stream for playback.</p><p class="- topic/p ">To control sounds that are embedded in a SWF file, use the properties in the SoundMixer class.</p><p class="- topic/p "><b class="+ topic/ph hi-d/b ">Note</b>: The ActionScript 3.0 Sound API differs from ActionScript 2.0.
     * In ActionScript 3.0, you cannot take sound objects and arrange them in a hierarchy
     * to control their properties.</p><p class="- topic/p ">When you use this class, consider the following security model: </p><ul class="- topic/ul "><li class="- topic/li ">Loading and playing a sound is not allowed if the calling file is in a network sandbox
     * and the sound file to be loaded is local.</li><li class="- topic/li ">By default, loading and playing a sound is not allowed if the calling file is local and
     * tries to load and play a remote sound. A user must grant explicit permission to allow this type of access.</li><li class="- topic/li ">Certain operations dealing with sound are restricted. The data in a loaded sound cannot
     * be accessed by a file in a different domain unless you implement a cross-domain policy file.
     * Sound-related APIs that fall under this restriction are <codeph class="+ topic/ph pr-d/codeph ">Sound.id3</codeph>,
     * <codeph class="+ topic/ph pr-d/codeph ">SoundMixer.computeSpectrum()</codeph>, <codeph class="+ topic/ph pr-d/codeph ">SoundMixer.bufferTime</codeph>,
     * and the <codeph class="+ topic/ph pr-d/codeph ">SoundTransform</codeph> class.</li></ul><p class="- topic/p ">However, in Adobe AIR, content in the <codeph class="+ topic/ph pr-d/codeph ">application</codeph> security sandbox (content
     * installed with the AIR application) are not restricted by these security limitations.</p><p class="- topic/p ">For more information related to security, see the Flash Player Developer Center Topic:
     * <xref href="http://www.adobe.com/go/devnet_security_en" scope="external" class="- topic/xref ">Security</xref>.</p>
     */
    var Sound = /** @class */ (function (_super) {
        __extends(Sound, _super);
        /**
         * Creates a new Sound object. If you pass a valid URLRequest object to the
         * Sound constructor, the constructor automatically calls the load() function
         * for the Sound object.
         * If you do not pass a valid URLRequest object to the Sound constructor,
         * you must call the load() function for the Sound object yourself,
         * or the stream will not load.
         *
         *   Once load() is called on a Sound object, you can't later load
         * a different sound file into that Sound object. To load a different sound file,
         * create a new Sound object.
         *
         *   In Flash Player 10 and later and AIR 1.5 and later, instead of using load(),
         * you can use the sampleData event handler to load sound dynamically into the Sound object.
         * @param	stream	The URL that points to an external MP3 file.
         * @param	context	An optional SoundLoader context object, which can define the buffer time
         *   (the minimum number of milliseconds of MP3 data to hold in the Sound object's
         *   buffer) and can specify whether the application should check for a cross-domain
         *   policy file prior to loading the sound.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @refpath
         */
        function Sound(stream, context) {
            if (stream === void 0) { stream = null; }
            if (context === void 0) { context = null; }
            var _this = _super.call(this) || this;
            _this.loopsToPlay = 0;
            return _this;
            //this.adaptee=this.adaptee;
            //console.log("sound is not implemented yet in flash/Sound");
        }
        Object.defineProperty(Sound.prototype, "adaptee", {
            get: function () {
                return this._adaptee;
            },
            set: function (adaptee) {
                this._adaptee = adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sound.prototype, "bytesLoaded", {
            /**
             * Returns the currently available number of bytes in this sound object. This property is
             * usually useful only for externally loaded files.
             * @langversion	3.0
             * @playerversion	Flash 9
             * @playerversion	Lite 4
             * @refpath
             */
            get: function () {
                console.log("bytesLoaded not implemented yet in flash/Sound");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sound.prototype, "bytesTotal", {
            /**
             * Returns the total number of bytes in this sound object.
             * @langversion	3.0
             * @playerversion	Flash 9
             * @playerversion	Lite 4
             * @refpath
             */
            get: function () {
                console.log("bytesTotal not implemented yet in flash/Sound");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sound.prototype, "id3", {
            /**
             * Provides access to the metadata that is part of an MP3 file.
             *
             *   MP3 sound files can contain ID3 tags, which provide metadata about the
             * file. If an MP3 sound that you load using the Sound.load()
             * method contains ID3 tags, you can query these properties. Only ID3 tags
             * that use the UTF-8 character set are supported.Flash Player 9 and later and AIR support
             * ID3 2.0 tags,
             * specifically 2.3 and 2.4. The following tables list the standard ID3 2.0 tags
             * and the type of content the tags represent. The Sound.id3 property provides
             * access to these tags through the format
             * my_sound.id3.COMM, my_sound.id3.TIME, and so on. The first
             * table describes tags that can be accessed either through the ID3 2.0 property name or
             * the ActionScript property name. The second table describes ID3 tags that are supported but do not have
             * predefined properties in ActionScript. ID3 2.0 tagCorresponding Sound class propertyCOMMSound.id3.commentTALBSound.id3.album TCONSound.id3.genreTIT2Sound.id3.songName TPE1Sound.id3.artistTRCKSound.id3.track TYERSound.id3.year The following table describes ID3 tags that are supported but do not have
             * predefined properties in the Sound class. You access them by calling
             * mySound.id3.TFLT, mySound.id3.TIME, and so on. NOTE: None of
             * these tags are supported in Flash Lite 4.PropertyDescriptionTFLTFile typeTIMETimeTIT1Content group descriptionTIT2Title/song name/content descriptionTIT3Subtitle/description refinementTKEYInitial keyTLANLanguagesTLENLengthTMEDMedia typeTOALOriginal album/movie/show titleTOFNOriginal filenameTOLYOriginal lyricists/text writersTOPEOriginal artists/performersTORYOriginal release yearTOWNFile owner/licenseeTPE1Lead performers/soloistsTPE2Band/orchestra/accompanimentTPE3Conductor/performer refinementTPE4Interpreted, remixed, or otherwise modified byTPOSPart of a setTPUBPublisherTRCKTrack number/position in setTRDARecording datesTRSNInternet radio station nameTRSOInternet radio station ownerTSIZSizeTSRCISRC (international standard recording code)TSSESoftware/hardware and settings used for encodingTYERYearWXXXURL link frameWhen using this property, consider the Flash Player security model:The id3 property of a Sound object is always permitted for SWF files
             * that are in the same security sandbox as the sound file. For files in other sandboxes, there
             * are security checks.When you load the sound, using the load() method of the Sound class, you can
             * specify a context parameter, which is a SoundLoaderContext object. If you set the
             * checkPolicyFile  property of the SoundLoaderContext object to true, Flash Player
             * checks for a URL policy file on the server from which the sound is loaded. If a
             * policy file exists and permits access from the domain of the loading SWF file, then the file is allowed
             * to access the id3 property of the Sound object; otherwise it is not.However, in Adobe AIR, content in the application security sandbox (content
             * installed with the AIR application) are not restricted by these security limitations.For more information related to security, see the Flash Player Developer Center Topic:
             * Security.
             * @langversion	3.0
             * @playerversion	Flash 9
             * @playerversion	Lite 4
             */
            get: function () {
                console.log("id3 not implemented yet in flash/Sound");
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sound.prototype, "isBuffering", {
            /**
             * Returns the buffering state of external MP3 files. If the value is true,
             * any playback is
             * currently suspended while the object waits for more data.
             * @langversion	3.0
             * @playerversion	Flash 9
             * @playerversion	Lite 4
             * @refpath
             */
            get: function () {
                console.log("isBuffering not implemented yet in flash/Sound");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sound.prototype, "isURLInaccessible", {
            /**
             * Indicates if the Sound.url property has been
             * truncated. When the isURLInaccessible value is true the
             * Sound.url value is only the domain of the final URL from which the sound loaded.
             * For example, the property is truncated if the sound is loaded from http://www.adobe.com/assets/hello.mp3,
             * and the Sound.url property has the value http://www.adobe.com.
             * The isURLInaccessible value is true only when all of the following are also true:
             *
             *   An HTTP redirect occurred while loading the sound file.The SWF file calling Sound.load() is from a different domain than
             * the sound file's final URL.The SWF file calling Sound.load() does not have permission to access
             * the sound file.  Permission is granted to access the sound file the same way permission is granted
             * for the Sound.id3 property: establish a policy file and use the SoundLoaderContext.checkPolicyFile
             * property.Note: The isURLInaccessible property was added for Flash Player 10.1 and AIR 2.0.
             * However, this property is made available to SWF files of all versions when the
             * Flash runtime supports it. So, using some authoring tools in "strict mode" causes a compilation error. To work around the error
             * use the indirect syntax mySound["isURLInaccessible"], or disable strict mode. If you are using Flash Professional CS5
             * or Flex SDK 4.1, you can use and compile this API for runtimes released before Flash Player 10.1 and AIR 2.For application content in AIR, the value of this property is always false.
             * @langversion	3.0
             * @playerversion	Flash 10.1
             * @playerversion	AIR 2
             */
            get: function () {
                console.log("isURLInaccessible not implemented yet in flash/Sound");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sound.prototype, "length", {
            /**
             * The length of the current sound in milliseconds.
             * @langversion	3.0
             * @playerversion	Flash 9
             * @playerversion	Lite 4
             */
            get: function () {
                console.log("length not implemented yet in flash/Sound");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Sound.prototype, "url", {
            /**
             * The URL from which this sound was loaded. This property is applicable only to Sound
             * objects that were loaded using the Sound.load() method. For
             * Sound objects that are associated with a sound asset from a SWF file's library, the
             * value of the url property is null.
             *
             *   When you first call Sound.load(), the url property
             * initially has a value of null, because the final URL is not yet known.
             * The url property will have a non-null value as soon as an
             * open event is dispatched from the Sound object.The url property contains the final, absolute URL from which a sound was
             * loaded. The value of url is usually the same as the value passed to the
             * stream parameter of Sound.load().
             * However, if you passed a relative URL to Sound.load()
             * the value of the url property represents the absolute URL.
             * Additionally, if the original URL request is redirected by an HTTP server, the value
             * of the url property reflects the final URL from which the sound file was actually
             * downloaded.  This reporting of an absolute, final URL is equivalent to the behavior of
             * LoaderInfo.url.In some cases, the value of the url property is truncated; see the
             * isURLInaccessible property for details.
             * @langversion	3.0
             * @playerversion	Flash 9
             * @playerversion	Lite 4
             */
            get: function () {
                console.log("url not implemented yet in flash/Sound");
                return "";
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Closes the stream, causing any download of data to cease.
         * No data may be read from the stream after the close()
         * method is called.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @refpath
         * @throws	IOError The stream could not be closed, or
         *   the stream was not open.
         */
        Sound.prototype.close = function () {
            console.log("close not implemented yet in flash/Sound");
        };
        /**
         * Extracts raw sound data from a Sound object.
         *
         *   This method is designed to be used when you are working
         * with dynamically generated audio, using a function you assign
         * to the sampleData event for a different Sound object.
         * That is, you can use this method to extract sound data from a Sound object.
         * Then you can write the data to the byte array that another Sound object is using
         * to stream dynamic audio.The audio data is placed in the target byte array starting from the current position of the byte array.
         * The audio data is always exposed as 44100 Hz Stereo. The sample type is a 32-bit floating-point value,
         * which can be converted to a Number using ByteArray.readFloat().
         * @param	target	A ByteArray object in which the extracted sound samples are placed.
         * @param	length	The number of sound samples to extract.
         *   A sample contains both the left and right channels — that is, two 32-bit floating-point values.
         * @param	startPosition	The sample at which extraction begins.
         *   If you don't specify a value, the first call to Sound.extract() starts at the beginning
         *   of the sound; subsequent calls without a value for startPosition
         *   progress sequentially through the file.
         * @return	The number of samples written to the ByteArray specified in the target parameter.
         * @langversion	3.0
         * @playerversion	Flash 10
         * @playerversion	AIR 1.5
         * @refpath
         */
        Sound.prototype.extract = function (target, length, startPosition) {
            if (startPosition === void 0) { startPosition = -1; }
            console.log("extract not implemented yet in flash/Sound");
            return 0;
        };
        /**
         * Initiates loading of an external MP3 file from the specified URL. If you provide
         * a valid URLRequest object to the Sound constructor, the constructor calls
         * Sound.load() for you. You only need to call Sound.load()
         * yourself if you
         * don't pass a valid URLRequest object to the Sound constructor or you pass a null
         * value.
         *
         *   Once load() is called on a Sound object, you can't later load
         * a different sound file into that Sound object. To load a different sound file,
         * create a new Sound object.When using this method, consider the following security model:Calling Sound.load() is not allowed if the calling file is in the
         * local-with-file-system sandbox and the sound is in a network sandbox.Access from the local-trusted or local-with-networking sandbox requires permission
         * from a website through a URL policy file.You cannot connect to commonly reserved ports.
         * For a complete list of blocked ports, see "Restricting Networking APIs" in the
         * ActionScript 3.0 Developer's Guide.You can prevent a SWF file from using this method by setting the
         * allowNetworking parameter of the object and embed
         * tags in the HTML page that contains the SWF content. In Flash Player 10 and later, if you use a multipart Content-Type (for example "multipart/form-data")
         * that contains an upload (indicated by a "filename" parameter in a "content-disposition" header within the POST body),
         * the POST operation is subject to the security rules applied to uploads:The POST operation must be performed in response to a user-initiated action, such as a mouse click or key press.If the POST operation is cross-domain (the POST target is not on the same server as the SWF file
         * that is sending the POST request),
         * the target server must provide a URL policy file that permits cross-domain access.Also, for any multipart Content-Type, the syntax must be valid (according to the RFC2046 standards).
         * If the syntax appears to be invalid, the POST operation is subject to the security rules applied to uploads.In Adobe AIR, content in the application security sandbox (content
         * installed with the AIR application) are not restricted by these security limitations.For more information related to security, see the Flash Player Developer Center Topic:
         * Security.
         * @param	stream	A URL that points to an external MP3 file.
         * @param	context	An optional SoundLoader context object, which can define the buffer time
         *   (the minimum number of milliseconds of MP3 data to hold in the Sound object's
         *   buffer) and can specify whether the application should check for a cross-domain
         *   policy file prior to loading the sound.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @refpath
         * @throws	IOError A network error caused the load to fail.
         * @throws	SecurityError Local untrusted files may not communicate with
         *   the Internet. You can work around this by reclassifying this file
         *   as local-with-networking or trusted.
         * @throws	SecurityError You cannot connect to commonly reserved ports.
         *   For a complete list of blocked ports, see "Restricting Networking APIs" in the
         *   ActionScript 3.0 Developer's Guide.
         * @throws	IOError The digest property of the stream object is not
         *   null. You should only set the digest property of a URLRequest object
         *   when calling the URLLoader.load() method when loading a SWZ file (an Adobe
         *   platform component).
         */
        Sound.prototype.load = function (stream, context) {
            if (context === void 0) { context = null; }
            console.log("load not implemented yet in flash/Sound");
        };
        Sound.prototype.loadCompressedDataFromByteArray = function (bytes, bytesLength) {
            console.log("loadCompressedDataFromByteArray not implemented yet in flash/Sound");
        };
        Sound.prototype.loadPCMFromByteArray = function (bytes, samples, format, stereo, sampleRate) {
            if (format === void 0) { format = "float"; }
            if (stereo === void 0) { stereo = true; }
            if (sampleRate === void 0) { sampleRate = 44100; }
            console.log("loadPCMFromByteArray not implemented yet in flash/Sound");
        };
        Sound.prototype.soundCompleteInternal = function () {
            this.loopsToPlay--;
            if (this.loopsToPlay > 0) {
                this.stop();
                this.adaptee.play(0, false);
            }
            else {
                if (this._onCompleteCallback) {
                    this._onCompleteCallback();
                }
            }
        };
        /**
         * Generates a new SoundChannel object to play back the sound. This method
         * returns a SoundChannel object, which you access to stop the sound and to monitor volume.
         * (To control the volume, panning, and balance, access the SoundTransform object assigned
         * to the sound channel.)
         * @param	startTime	The initial position in milliseconds at which playback should
         *   start.
         * @param	loops	Defines the number of times a sound loops back to the startTime value
         *   before the sound channel stops playback.
         * @param	sndTransform	The initial SoundTransform object assigned to the sound channel.
         * @return	A SoundChannel object, which you use to control the sound.
         *   This method returns null if you have no sound card
         *   or if you run out of available sound channels. The maximum number of
         *   sound channels available at once is 32.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @refpath
         */
        Sound.prototype.play = function (startTime, loops, sndTransform) {
            var _this = this;
            if (startTime === void 0) { startTime = 0; }
            if (loops === void 0) { loops = 0; }
            if (sndTransform === void 0) { sndTransform = null; }
            if (!this.adaptee) {
                console.log("Sound.play : no adaptee exists!");
                return;
            }
            if (sndTransform) {
                this.adaptee.volume = sndTransform.volume;
                this.adaptee.pan = sndTransform.pan;
            }
            loops = isNaN(loops) || loops < 1 ? 1 : Math.floor(loops);
            this.loopsToPlay = loops;
            this._adaptee.onSoundComplete = function () { return _this.soundCompleteInternal(); };
            this._adaptee.play(startTime, false);
            var newSoundChannel = new this.sec.flash.media.SoundChannel();
            newSoundChannel._sound = this;
            if (!sndTransform) {
                sndTransform = new this.sec.flash.media.SoundTransform();
            }
            newSoundChannel.soundTransform = sndTransform;
            //console.log("play not implemented yet in flash/Sound");
            // todo: should return a flash soundchannel
            return newSoundChannel;
        };
        Sound.prototype.stop = function () {
            this._adaptee.stop();
        };
        return Sound;
    }(EventDispatcher$1));

    /**
     * Copyright 2015 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var XMLSpecialChars;
    (function (XMLSpecialChars) {
        XMLSpecialChars[XMLSpecialChars["APOS"] = 39] = "APOS";
        XMLSpecialChars[XMLSpecialChars["AMP"] = 38] = "AMP";
        XMLSpecialChars[XMLSpecialChars["QUOT"] = 34] = "QUOT";
        XMLSpecialChars[XMLSpecialChars["LT"] = 60] = "LT";
        XMLSpecialChars[XMLSpecialChars["GT"] = 62] = "GT";
    })(XMLSpecialChars || (XMLSpecialChars = {}));
    var XMLNode$1 = /** @class */ (function (_super) {
        __extends(XMLNode, _super);
        function XMLNode(type /*uint*/, value) {
            var _this = this;
            type = type >>> 0;
            value = axCoerceString$3(value);
            _this = _super.call(this) || this;
            return _this;
        }
        // Static   JS -> AS Bindings
        // Static   AS -> JS Bindings
        XMLNode.escapeXML = function (value) {
            value = axCoerceString$3(value);
            var i = 0, length = value.length, ch;
            while (i < length) {
                ch = value.charCodeAt(i);
                if (ch === XMLSpecialChars.APOS || ch === XMLSpecialChars.AMP ||
                    ch === XMLSpecialChars.QUOT || ch === XMLSpecialChars.LT ||
                    ch === XMLSpecialChars.GT) {
                    break;
                }
                i++;
            }
            if (i >= length) {
                return value;
            }
            var parts = [value.substring(0, i)];
            while (i < length) {
                switch (ch) {
                    case XMLSpecialChars.APOS:
                        parts.push('&apos;');
                        break;
                    case XMLSpecialChars.AMP:
                        parts.push('&amp;');
                        break;
                    case XMLSpecialChars.QUOT:
                        parts.push('&quot;');
                        break;
                    case XMLSpecialChars.LT:
                        parts.push('&lt;');
                        break;
                    case XMLSpecialChars.GT:
                        parts.push('&gt;');
                        break;
                }
                ++i;
                var j = i;
                while (i < length) {
                    ch = value.charCodeAt(i);
                    if (ch === XMLSpecialChars.APOS || ch === XMLSpecialChars.AMP ||
                        ch === XMLSpecialChars.QUOT || ch === XMLSpecialChars.LT ||
                        ch === XMLSpecialChars.GT) {
                        break;
                    }
                    i++;
                }
                if (j < i) {
                    parts.push(value.substring(j, i));
                }
            }
            return parts.join('');
        };
        return XMLNode;
    }(ASObject$1));
    var XMLDocument$1 = /** @class */ (function (_super) {
        __extends(XMLDocument, _super);
        function XMLDocument(text) {
            if (text === void 0) { text = null; }
            var _this = this;
            text = axCoerceString$3(text);
            _this = _super.call(this, 1, "") || this;
            return _this;
        }
        return XMLDocument;
    }(XMLNode$1));
    var XMLTag = /** @class */ (function (_super) {
        __extends(XMLTag, _super);
        function XMLTag() {
            var _this = _super.call(this) || this;
            _this._type = 0;
            _this._value = null;
            _this._empty = false;
            _this._attrs = null;
            return _this;
        }
        Object.defineProperty(XMLTag.prototype, "type", {
            // Static   JS -> AS Bindings
            // Static   AS -> JS Bindings
            // Instance JS -> AS Bindings
            // Instance AS -> JS Bindings
            get: function () {
                return this._type;
            },
            set: function (value /*uint*/) {
                value = value >>> 0;
                this._type = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(XMLTag.prototype, "empty", {
            get: function () {
                return this._empty;
            },
            set: function (value) {
                value = !!value;
                this._empty = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(XMLTag.prototype, "value", {
            get: function () {
                return this._value;
            },
            set: function (v) {
                v = axCoerceString$3(v);
                this._value = v;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(XMLTag.prototype, "attrs", {
            get: function () {
                return this._attrs;
            },
            set: function (value) {
                this._attrs = value;
            },
            enumerable: true,
            configurable: true
        });
        return XMLTag;
    }(ASObject$1));
    var XMLNodeType$1 = /** @class */ (function (_super) {
        __extends(XMLNodeType, _super);
        function XMLNodeType() {
            return _super.call(this) || this;
        }
        return XMLNodeType;
    }(ASObject$1));
    function isWhitespace$1(s) {
        for (var i = 0; i < s.length; i++) {
            var ch = s[i];
            if (!(ch === ' ' || ch === '\n' || ch === '\r' || ch === '\t')) {
                return false;
            }
        }
        return true;
    }
    var XMLParserForXMLDocument = /** @class */ (function (_super) {
        __extends(XMLParserForXMLDocument, _super);
        function XMLParserForXMLDocument(sec) {
            var _this = _super.call(this) || this;
            _this.sec = sec;
            _this.queue = [];
            _this.ignoreWhitespace = false;
            return _this;
        }
        XMLParserForXMLDocument.prototype.onError = function (code) {
            this.queue.push(code);
        };
        XMLParserForXMLDocument.prototype.onPi = function (name, value) {
            warning('Unhandled XMLParserForXMLDocument.onPi');
        };
        XMLParserForXMLDocument.prototype.onComment = function (text) {
            warning('Unhandled XMLParserForXMLDocument.onComment');
        };
        XMLParserForXMLDocument.prototype.onCdata = function (text) {
            this.queue.push({
                type: 4,
                value: text
            });
        };
        XMLParserForXMLDocument.prototype.onDoctype = function (doctypeContent) {
            warning('Unhandled XMLParserForXMLDocument.onDoctype');
        };
        XMLParserForXMLDocument.prototype.onBeginElement = function (name, attributes, isEmpty) {
            var attrObj = this.sec.createObject();
            attributes.forEach(function (a) {
                attrObj.axSetPublicProperty(a.name, a.value);
            });
            this.queue.push({
                type: 1,
                value: name,
                empty: isEmpty,
                attrs: attrObj
            });
        };
        XMLParserForXMLDocument.prototype.onEndElement = function (name) {
            this.queue.push({
                type: 1,
                value: '/' + name
            });
        };
        XMLParserForXMLDocument.prototype.onText = function (text) {
            if (this.ignoreWhitespace && isWhitespace$1(text)) {
                return;
            }
            this.queue.push({
                type: 3,
                value: text
            });
        };
        return XMLParserForXMLDocument;
    }(XMLParserBase));
    var XMLParser$1 = /** @class */ (function (_super) {
        __extends(XMLParser$$1, _super);
        function XMLParser$$1() {
            return _super.call(this) || this;
        }
        XMLParser$$1.prototype.startParse = function (source, ignoreWhite) {
            source = axCoerceString$3(source);
            ignoreWhite = !!ignoreWhite;
            var parser = new XMLParserForXMLDocument(this.sec);
            parser.ignoreWhitespace = ignoreWhite;
            parser.parseXml(source);
            this.queue = parser.queue;
        };
        XMLParser$$1.prototype.getNext = function (tag) {
            if (this.queue.length === 0) {
                return -1 /* EndOfDocument */;
            }
            var nextItem = this.queue.shift();
            if (typeof nextItem === 'number') {
                return nextItem;
            }
            var parseResult = nextItem;
            tag.type = parseResult.type;
            tag.value = parseResult.value;
            tag.empty = parseResult.empty || false;
            tag.attrs = parseResult.attrs || null;
            return 0 /* NoError */;
        };
        return XMLParser$$1;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: FontStyle
    var FontStyle = /** @class */ (function (_super) {
        __extends(FontStyle, _super);
        function FontStyle() {
            return _super.call(this) || this;
        }
        FontStyle.classInitializer = null;
        FontStyle.classSymbols = null;
        FontStyle.instanceSymbols = null;
        // JS -> AS Bindings
        FontStyle.REGULAR = "regular";
        FontStyle.BOLD = "bold";
        FontStyle.ITALIC = "italic";
        FontStyle.BOLD_ITALIC = "boldItalic";
        return FontStyle;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: TextFormatDisplay
    var TextFormatDisplay = /** @class */ (function (_super) {
        __extends(TextFormatDisplay, _super);
        function TextFormatDisplay() {
            return _super.call(this) || this;
        }
        TextFormatDisplay.classInitializer = null;
        TextFormatDisplay.classSymbols = null;
        TextFormatDisplay.instanceSymbols = null;
        // JS -> AS Bindings
        TextFormatDisplay.INLINE = "inline";
        TextFormatDisplay.BLOCK = "block";
        return TextFormatDisplay;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: TextFormat
    var TextFormat$1 = /** @class */ (function (_super) {
        __extends(TextFormat, _super);
        function TextFormat(font, size, color, bold, italic, underline, url, target, align, leftMargin, rightMargin, indent, leading) {
            if (font === void 0) { font = null; }
            if (size === void 0) { size = null; }
            if (color === void 0) { color = null; }
            if (bold === void 0) { bold = null; }
            if (italic === void 0) { italic = null; }
            if (underline === void 0) { underline = null; }
            if (url === void 0) { url = null; }
            if (target === void 0) { target = null; }
            if (align === void 0) { align = null; }
            if (leftMargin === void 0) { leftMargin = null; }
            if (rightMargin === void 0) { rightMargin = null; }
            if (indent === void 0) { indent = null; }
            if (leading === void 0) { leading = null; }
            var _this = _super.call(this) || this;
            _this.font = font;
            _this.size = size;
            _this.color = color;
            _this.bold = bold;
            _this.italic = italic;
            _this.underline = underline;
            _this.url = url;
            _this.target = target;
            _this.align = align;
            _this.leftMargin = leftMargin;
            _this.rightMargin = rightMargin;
            _this.indent = indent;
            _this.leading = leading;
            _this._blockIndent = null;
            _this._bullet = null;
            _this._display = TextFormatDisplay.BLOCK;
            _this._kerning = null;
            _this._letterSpacing = null;
            _this._tabStops = null;
            return _this;
        }
        Object.defineProperty(TextFormat.prototype, "align", {
            // AS -> JS Bindings
            get: function () {
                return this._align;
            },
            set: function (value) {
                value = axCoerceString$3(value);
                //if (TextFormatAlign.toNumber(value) < 0) {
                //  this.sec.throwError("ArgumentError", Errors.InvalidEnumError, "align");
                //}
                this._align = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "blockIndent", {
            get: function () {
                return this._blockIndent;
            },
            set: function (value) {
                this._blockIndent = TextFormat.coerceNumber(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "bold", {
            get: function () {
                return this._bold;
            },
            set: function (value) {
                this._bold = TextFormat.coerceBoolean(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "bullet", {
            get: function () {
                return this._bullet;
            },
            set: function (value) {
                this._bullet = TextFormat.coerceBoolean(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "color", {
            get: function () {
                return this._color;
            },
            set: function (value) {
                this._color = value != null ? +value | 0 : null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "display", {
            get: function () {
                return this._display;
            },
            set: function (value) {
                this._display = axCoerceString$3(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "font", {
            get: function () {
                return this._font;
            },
            set: function (value) {
                this._font = axCoerceString$3(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "style", {
            get: function () {
                if (this._bold && this._italic) {
                    return FontStyle.BOLD_ITALIC;
                }
                else if (this._bold) {
                    return FontStyle.BOLD;
                }
                else if (this._italic) {
                    return FontStyle.ITALIC;
                }
                else {
                    return FontStyle.REGULAR;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "indent", {
            get: function () {
                return this._indent;
            },
            set: function (value) {
                this._indent = TextFormat.coerceNumber(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "italic", {
            get: function () {
                return this._italic;
            },
            set: function (value) {
                this._italic = TextFormat.coerceBoolean(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "kerning", {
            get: function () {
                return this._kerning;
            },
            set: function (value) {
                this._kerning = TextFormat.coerceBoolean(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "leading", {
            get: function () {
                return this._leading;
            },
            set: function (value) {
                this._leading = TextFormat.coerceNumber(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "leftMargin", {
            get: function () {
                return this._leftMargin;
            },
            set: function (value) {
                this._leftMargin = TextFormat.coerceNumber(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "letterSpacing", {
            get: function () {
                return this._letterSpacing;
            },
            set: function (value) {
                this._letterSpacing = TextFormat.coerceNumber(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "rightMargin", {
            get: function () {
                return this._rightMargin;
            },
            set: function (value) {
                this._rightMargin = TextFormat.coerceNumber(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "size", {
            get: function () {
                return this._size;
            },
            set: function (value) {
                this._size = TextFormat.coerceNumber(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "tabStops", {
            get: function () {
                return this.sec.createArrayUnsafe(this._tabStops);
            },
            set: function (value) {
                if (value == null) {
                    this._tabStops = null;
                    return;
                }
                if (!this.sec.AXArray.axIsType(value)) {
                    this.sec.throwError("ArgumentError", Errors$1.CheckTypeFailedError, value, 'Array');
                }
                this._tabStops = value.value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "target", {
            get: function () {
                return this._target;
            },
            set: function (value) {
                this._target = axCoerceString$3(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "underline", {
            get: function () {
                return this._underline;
            },
            set: function (value) {
                this._underline = TextFormat.coerceBoolean(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat.prototype, "url", {
            get: function () {
                return this._url;
            },
            set: function (value) {
                this._url = axCoerceString$3(value);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * All integer values on TextFormat are typed as Object and coerced to ints using the following
         * "algorithm":
         * - if the supplied value is null or undefined, the field is set to null
         * - else if coercing to number results in NaN or the value is greater than MAX_INT, set to
         *   -0x80000000
         * - else, round the coerced value using half-even rounding
         */
        TextFormat.coerceNumber = function (value) {
            /* tslint:disable */
            if (value == undefined) {
                return null;
            }
            /* tslint:enable */
            if (isNaN(value) || value > 0xfffffff) {
                return -0x80000000;
            }
            return roundHalfEven(value);
        };
        /**
         * Boolean values are only stored as bools if they're not undefined or null. In that case,
         * they're stored as null.
         */
        TextFormat.coerceBoolean = function (value) {
            /* tslint:disable */
            return value == undefined ? null : !!value;
            /* tslint:enable */
        };
        TextFormat.prototype.clone = function () {
            var tf = new TextFormat(this._font, this._size, this._color, this._bold, this._italic, this._underline, this._url, this._target, this._align, this._leftMargin, this._rightMargin, this._indent, this._leading);
            tf._blockIndent = this._blockIndent;
            tf._bullet = this._bullet;
            tf._display = this._display;
            tf._kerning = this._kerning;
            tf._letterSpacing = this._letterSpacing;
            tf._tabStops = this._tabStops;
            return tf;
        };
        TextFormat.prototype.equals = function (other) {
            return this._align === other._align &&
                this._blockIndent === other._blockIndent &&
                this._bold === other._bold &&
                this._bullet === other._bullet &&
                this._color === other._color &&
                this._display === other._display &&
                this._font === other._font &&
                this._indent === other._indent &&
                this._italic === other._italic &&
                this._kerning === other._kerning &&
                this._leading === other._leading &&
                this._leftMargin === other._leftMargin &&
                this._letterSpacing === other._letterSpacing &&
                this._rightMargin === other._rightMargin &&
                this._size === other._size &&
                this._tabStops === other._tabStops &&
                this._target === other._target &&
                this._underline === other._underline &&
                this._url === other._url;
        };
        TextFormat.prototype.merge = function (other) {
            if (other._align !== null) {
                this._align = other._align;
            }
            if (other._blockIndent !== null) {
                this._blockIndent = other._blockIndent;
            }
            if (other._bold !== null) {
                this._bold = other._bold;
            }
            if (other._bullet !== null) {
                this._bullet = other._bullet;
            }
            if (other._color !== null) {
                this._color = other._color;
            }
            if (other._display !== null) {
                this._display = other._display;
            }
            if (other._font) {
                this._font = other._font;
            }
            if (other._indent !== null) {
                this._indent = other._indent;
            }
            if (other._italic !== null) {
                this._italic = other._italic;
            }
            if (other._kerning !== null) {
                this._kerning = other._kerning;
            }
            if (other._leading !== null) {
                this._leading = other._leading;
            }
            if (other._leftMargin !== null) {
                this._leftMargin = other._leftMargin;
            }
            if (other._letterSpacing !== null) {
                this._letterSpacing = other._letterSpacing;
            }
            if (other._rightMargin !== null) {
                this._rightMargin = other._rightMargin;
            }
            if (other._size !== null) {
                this._size = other._size;
            }
            if (other._tabStops !== null) {
                this._tabStops = other._tabStops;
            }
            if (other._target) {
                this._target = other._target;
            }
            if (other._underline !== null) {
                this._underline = other._underline;
            }
            if (other._url) {
                this._url = other._url;
            }
        };
        TextFormat.prototype.intersect = function (other) {
            if (other._align !== this._align) {
                this._align = null;
            }
            if (other._blockIndent !== this._blockIndent) {
                this._blockIndent = null;
            }
            if (other._bold !== this._bold) {
                this._bold = null;
            }
            if (other._bullet !== this._bullet) {
                this._bullet = null;
            }
            if (other._color !== this._color) {
                this._color = null;
            }
            if (other._display !== this._display) {
                this._display = null;
            }
            if (other._font !== this._font) {
                this._font = null;
            }
            if (other._indent !== this._indent) {
                this._indent = null;
            }
            if (other._italic !== this._italic) {
                this._italic = null;
            }
            if (other._kerning !== this._kerning) {
                this._kerning = null;
            }
            if (other._leading !== this._leading) {
                this._leading = null;
            }
            if (other._leftMargin !== this._leftMargin) {
                this._leftMargin = null;
            }
            if (other._letterSpacing !== this._letterSpacing) {
                this._letterSpacing = null;
            }
            if (other._rightMargin !== this._rightMargin) {
                this._rightMargin = null;
            }
            if (other._size !== this._size) {
                this._size = null;
            }
            if (other._tabStops !== this._tabStops) {
                this._tabStops = null;
            }
            if (other._target !== this._target) {
                this._target = null;
            }
            if (other._underline !== this._underline) {
                this._underline = null;
            }
            if (other._url !== this._url) {
                this._url = null;
            }
        };
        TextFormat.prototype.transform = function (formatObject) {
            var v = formatObject.textAlign;
            if (v) {
                this.align = v;
            }
            v = formatObject.fontWeight;
            if (v === "bold") {
                this.bold = true;
            }
            else if (v === "normal") {
                this.bold = false;
            }
            v = formatObject.color;
            if (v) {
                // When parsing colors, whitespace is trimmed away, and all numbers are accepted, as long
                // as they make up the full string after the "#", without any non-numeric pre- or suffix.
                // This implementation is somewhat atrocious, but it should be reasonably fast and works.
                var colorStr = axCoerceString$3(v).trim().toLowerCase();
                if (colorStr[0] === '#') {
                    var numericPart = colorStr.substr(1);
                    while (numericPart[0] === '0') {
                        numericPart = numericPart.substr(1);
                    }
                    var colorVal = parseInt(numericPart, 16);
                    if (colorVal.toString(16) === numericPart) {
                        this.color = colorVal;
                    }
                }
            }
            v = formatObject.display;
            if (v) {
                this.display = v;
            }
            v = formatObject.fontFamily;
            if (v) {
                // TODO: Sanitize fontFamily string.
                this.font = v.replace('sans-serif', '_sans').replace('serif', '_serif');
            }
            v = formatObject.textIndent;
            if (v) {
                this.indent = parseInt(v);
            }
            v = formatObject.fontStyle;
            if (v === "italic") {
                this.italic = true;
            }
            else if (v === "normal") {
                this.italic = false;
            }
            v = formatObject.kerning;
            if (v === "true") {
                this.kerning = 1;
            }
            else if (v === "false") {
                this.kerning = 0;
            }
            else {
                this.kerning = parseInt(v);
            }
            v = formatObject.leading;
            if (v) {
                this.leading = parseInt(v);
            }
            v = formatObject.marginLeft;
            if (v) {
                this.leftMargin = parseInt(v);
            }
            v = formatObject.letterSpacing;
            if (v) {
                this.letterSpacing = parseFloat(v);
            }
            v = formatObject.marginRight;
            if (v) {
                this.rightMargin = parseInt(v);
            }
            v = formatObject.fontSize;
            if (v) {
                var size = parseInt(v);
                if (size > 0) {
                    this.size = size;
                }
            }
            v = formatObject.textDecoration;
            if (v === "none") {
                this.underline = false;
            }
            else if (v === "underline") {
                this.underline = true;
            }
            return this;
        };
        TextFormat.classInitializer = null;
        TextFormat.classSymbols = null; // [];
        TextFormat.instanceSymbols = null; // [];
        return TextFormat;
    }(ASObject$1));

    var AVM1Movie = /** @class */ (function (_super) {
        __extends(AVM1Movie, _super);
        function AVM1Movie() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVM1Movie.prototype._getLevelForRoot = function (root) { return 0; };
        AVM1Movie.prototype._getRootForLevel = function (level) { return null; };
        AVM1Movie.prototype._addRoot = function (level, root) { };
        AVM1Movie.prototype._removeRoot = function (level) { };
        return AVM1Movie;
    }(DisplayObject));
    var ContextMenu = /** @class */ (function () {
        function ContextMenu() {
        }
        return ContextMenu;
    }());
    var ContextMenuItem = /** @class */ (function () {
        function ContextMenuItem() {
        }
        return ContextMenuItem;
    }());
    var fscommand = /** @class */ (function () {
        function fscommand() {
        }
        return fscommand;
    }());
    var Security = /** @class */ (function () {
        function Security() {
        }
        return Security;
    }());
    var Capabilities = /** @class */ (function () {
        function Capabilities() {
        }
        return Capabilities;
    }());
    var ExternalInterface = /** @class */ (function () {
        function ExternalInterface() {
        }
        return ExternalInterface;
    }());
    var Mouse = /** @class */ (function () {
        function Mouse() {
        }
        return Mouse;
    }());
    var SoundChannel$1 = /** @class */ (function () {
        function SoundChannel() {
        }
        return SoundChannel;
    }());
    var SoundTransform$1 = /** @class */ (function () {
        function SoundTransform() {
        }
        return SoundTransform;
    }());
    var SoundMixer = /** @class */ (function () {
        function SoundMixer() {
        }
        return SoundMixer;
    }());
    var SecurityDomain = /** @class */ (function () {
        function SecurityDomain() {
            this.flash = {
                display: {
                    EventDispatcher: EventDispatcher$1,
                    DisplayObject: DisplayObject$1,
                    DisplayObjectContainer: DisplayObjectContainer$1,
                    AVM1Movie: AVM1Movie,
                    Stage: AVMAwayStage,
                    Loader: Loader$1,
                    LoaderInfo: LoaderInfo$2,
                    MovieClip: MovieClip$1,
                    Graphics: Graphics$1,
                    Bitmap: Bitmap,
                    BitmapData: BitmapData,
                    SimpleButton: SimpleButton$1
                },
                events: {
                    EventDispatcher: EventDispatcher$1,
                    Event: Event,
                    KeyboardEvent: KeyboardEvent$2,
                    MouseEvent: MouseEvent$1,
                    ProgressEvent: ProgressEvent
                },
                external: {
                    ExternalInterface: ExternalInterface
                },
                filters: {},
                text: {
                    TextField: TextField$1,
                    TextFormat: TextFormat$1
                },
                geom: {
                    Point: Point$1,
                    Rectangle: Rectangle$1,
                    Matrix: Matrix$1,
                    ColorTransform: ColorTransform$1,
                    Transform: Transform$1
                },
                net: {
                    URLRequest: URLRequest$1,
                    URLLoader: URLLoader$1,
                    URLVariables: URLVariables,
                    SharedObject: SharedObject
                },
                system: {
                    Capabilities: Capabilities,
                    LoaderContext: LoaderContext$1,
                    Security: Security,
                    fscommand: fscommand
                },
                ui: {
                    ContextMenu: ContextMenu,
                    ContextMenuItem: ContextMenuItem,
                    Mouse: Mouse
                },
                utils: {
                    ByteArray: ByteArray$1
                },
                media: {
                    Sound: Sound,
                    SoundChannel: SoundChannel$1,
                    SoundTransform: SoundTransform$1,
                    SoundMixer: SoundMixer
                },
                xml: {
                    XMLDocument: XMLDocumentAway,
                    XMLNode: XMLNode$1
                }
            };
            this.player = {}; //80pro Shumway.Player.Player;
        }
        return SecurityDomain;
    }());

    function axIsCallable(value) {
        return (value && typeof value.axApply === 'function');
    }

    /**
     * Make Shumway bug-for-bug compatible with Tamarin.
     */
    var as3Compatibility = true;

    var ASNumber$1 = /** @class */ (function (_super) {
        __extends(ASNumber, _super);
        function ASNumber() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ASNumber.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = ASNumber.prototype;
            addPrototypeFunctionAlias(proto, '$BgtoString', asProto.toString);
            addPrototypeFunctionAlias(proto, '$BgtoLocaleString', asProto.toString);
            addPrototypeFunctionAlias(proto, '$BgvalueOf', asProto.valueOf);
            addPrototypeFunctionAlias(proto, '$BgtoFixed', asProto.toFixed);
            addPrototypeFunctionAlias(proto, '$BgtoExponential', asProto.toExponential);
            addPrototypeFunctionAlias(proto, '$BgtoPrecision', asProto.toPrecision);
            defineNonEnumerableProperty(this, '$BgNaN', Number.NaN);
            defineNonEnumerableProperty(this, '$BgNEGATIVE_INFINITY', -1 / 0);
            defineNonEnumerableProperty(this, '$BgPOSITIVE_INFINITY', 1 / 0);
            defineNonEnumerableProperty(this, '$BgMAX_VALUE', Number.MAX_VALUE);
            defineNonEnumerableProperty(this, '$BgMIN_VALUE', Number.MIN_VALUE);
            defineNonEnumerableProperty(this, '$BgE', Math.E);
            defineNonEnumerableProperty(this, '$BgLN10', Math.LN10);
            defineNonEnumerableProperty(this, '$BgLN2', Math.LN2);
            defineNonEnumerableProperty(this, '$BgLOG10E', Math.LOG10E);
            defineNonEnumerableProperty(this, '$BgLOG2E', Math.LOG2E);
            defineNonEnumerableProperty(this, '$BgPI', Math.PI);
            defineNonEnumerableProperty(this, '$BgSQRT1_2', Math.SQRT2);
            defineNonEnumerableProperty(this, '$BgSQRT2', Math.SQRT2);
        };
        ASNumber.prototype.toString = function (radix) {
            if (arguments.length === 0) {
                radix = 10;
            }
            else {
                radix = radix | 0;
                if (radix < 2 || radix > 36) {
                    this.sec.throwError('RangeError', Errors$1.InvalidRadixError, radix);
                }
            }
            if (this.axClass !== this.sec.AXNumber) {
                this.sec.throwError('TypeError', Errors$1.InvokeOnIncompatibleObjectError, 'Number.prototype.toString');
            }
            return this.value.toString(radix);
        };
        ASNumber.prototype.valueOf = function () {
            if (this.axClass !== this.sec.AXNumber) {
                this.sec.throwError('TypeError', Errors$1.InvokeOnIncompatibleObjectError, 'Number.prototype.valueOf');
            }
            return this.value;
        };
        ASNumber.prototype.toExponential = function (p) {
            p = p | 0;
            if (p < 0 || p > 20) {
                this.sec.throwError('RangeError', Errors$1.InvalidPrecisionError);
            }
            if (this.axClass !== this.sec.AXNumber) {
                return 'NaN';
            }
            return this.value.toExponential(p);
        };
        ASNumber.prototype.toPrecision = function (p) {
            if (!p) {
                p = 1;
            }
            else {
                p = p | 0;
            }
            if (p < 1 || p > 21) {
                this.sec.throwError('RangeError', Errors$1.InvalidPrecisionError);
            }
            if (this.axClass !== this.sec.AXNumber) {
                return 'NaN';
            }
            return this.value.toPrecision(p);
        };
        ASNumber.prototype.toFixed = function (p) {
            p = p | 0;
            if (p < 0 || p > 20) {
                this.sec.throwError('RangeError', Errors$1.InvalidPrecisionError);
            }
            if (this.axClass !== this.sec.AXNumber) {
                return 'NaN';
            }
            return this.value.toFixed(p);
        };
        ASNumber._minValue = function () {
            return Number.MIN_VALUE;
        };
        // https://bugzilla.mozilla.org/show_bug.cgi?id=564839
        ASNumber.convertStringToDouble = function (s) {
            var i = s.indexOf(String.fromCharCode(0));
            if (i >= 0) {
                return +s.substring(0, i);
            }
            return +s;
        };
        ASNumber.classNatives = [Math];
        return ASNumber;
    }(ASObject$1));

    function axCoerceNumber(x) {
        if (as3Compatibility) {
            if (typeof x === "string") {
                return ASNumber$1.convertStringToDouble(x);
            }
            if (x && typeof x === "object") {
                x = x.valueOf(); // Make sure to only call valueOf() once.
                if (typeof x === "string") {
                    return ASNumber$1.convertStringToDouble(x);
                }
            }
        }
        return +x;
    }

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var BaseVector = /** @class */ (function (_super) {
        __extends(BaseVector, _super);
        function BaseVector() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        BaseVector.prototype.axGetProperty = function (mn) {
            var nm = mn.name;
            nm = typeof nm === 'number' ? nm : axCoerceName(nm);
            if ((nm | 0) === nm || isNumeric(nm)) {
                release$1 || assert(mn.isRuntimeName());
                return this.axGetNumericProperty(typeof nm === 'number' ? nm : nm | 0);
            }
            return _super.prototype.axGetProperty.call(this, mn);
        };
        BaseVector.prototype.axSetProperty = function (mn, value, bc) {
            release$1 || checkValue(value);
            var nm = mn.name;
            nm = typeof nm === 'number' ? nm : axCoerceName(nm);
            if ((nm | 0) === nm || isNumeric(nm)) {
                release$1 || assert(mn.isRuntimeName());
                this.axSetNumericProperty(typeof nm === 'number' ? nm : nm | 0, value);
                return;
            }
            _super.prototype.axSetProperty.call(this, mn, value, bc);
        };
        BaseVector.prototype.axGetPublicProperty = function (nm) {
            nm = typeof nm === 'number' ? nm : axCoerceName(nm);
            if ((nm | 0) === nm || isNumeric(nm)) {
                return this.axGetNumericProperty(typeof nm === 'number' ? nm : nm | 0);
            }
            return this['$Bg' + nm];
        };
        BaseVector.prototype.axSetPublicProperty = function (nm, value) {
            release$1 || checkValue(value);
            nm = typeof nm === 'number' ? nm : axCoerceName(nm);
            if ((nm | 0) === nm || isNumeric(nm)) {
                this.axSetNumericProperty(typeof nm === 'number' ? nm : nm | 0, value);
                return;
            }
            this['$Bg' + nm] = value;
        };
        BaseVector.prototype.axNextName = function (index) {
            return index - 1;
        };
        /**
         * Throws exceptions for the cases where Flash does, and returns false if the callback
         * is null or undefined. In that case, the calling function returns its default value.
         */
        BaseVector.prototype.checkVectorMethodArgs = function (callback, thisObject) {
            if (isNullOrUndefined$1(callback)) {
                return false;
            }
            var sec = this.sec;
            if (!axIsCallable(callback)) {
                sec.throwError("TypeError", Errors$1.CheckTypeFailedError, callback, 'Function');
            }
            if (callback.axClass === sec.AXMethodClosure &&
                !isNullOrUndefined$1(thisObject)) {
                sec.throwError("TypeError", Errors$1.ArrayFilterNonNullObjectError);
            }
            return true;
        };
        return BaseVector;
    }(ASObject$1));
    var Vector = /** @class */ (function (_super) {
        __extends(Vector, _super);
        function Vector() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        Vector.axIsType = function (x) {
            return this.dPrototype.isPrototypeOf(x) ||
                this.sec.Int32Vector.axClass.dPrototype.isPrototypeOf(x) ||
                this.sec.Uint32Vector.axClass.dPrototype.isPrototypeOf(x) ||
                this.sec.Float64Vector.axClass.dPrototype.isPrototypeOf(x) ||
                this.sec.ObjectVector.axClass.dPrototype.isPrototypeOf(x);
        };
        return Vector;
    }(ASObject$1));
    var GenericVector = /** @class */ (function (_super) {
        __extends(GenericVector, _super);
        function GenericVector(length, fixed) {
            if (length === void 0) { length = 0; }
            if (fixed === void 0) { fixed = false; }
            var _this = _super.call(this) || this;
            length = length >>> 0;
            fixed = !!fixed;
            _this._fixed = !!fixed;
            _this._buffer = new Array(length);
            _this._fill(0, length, _this.axClass.defaultValue);
            return _this;
        }
        GenericVector.classInitializer = function () {
            var proto = this.dPrototype;
            var tProto = this.tPrototype;
            // Fix up MOP handlers to not apply to the dynamic prototype, which is a plain object.
            tProto.axGetProperty = proto.axGetProperty;
            tProto.axGetNumericProperty = proto.axGetNumericProperty;
            tProto.axSetProperty = proto.axSetProperty;
            tProto.axSetNumericProperty = proto.axSetNumericProperty;
            tProto.axHasPropertyInternal = proto.axHasPropertyInternal;
            tProto.axNextName = proto.axNextName;
            tProto.axNextNameIndex = proto.axNextNameIndex;
            tProto.axNextValue = proto.axNextValue;
            proto.axGetProperty = ASObject$1.prototype.axGetProperty;
            proto.axGetNumericProperty = ASObject$1.prototype.axGetNumericProperty;
            proto.axSetProperty = ASObject$1.prototype.axSetProperty;
            proto.axSetNumericProperty = ASObject$1.prototype.axSetNumericProperty;
            proto.axHasPropertyInternal = ASObject$1.prototype.axHasPropertyInternal;
            proto.axNextName = ASObject$1.prototype.axNextName;
            proto.axNextNameIndex = ASObject$1.prototype.axNextNameIndex;
            proto.axNextValue = ASObject$1.prototype.axNextValue;
            var asProto = GenericVector.prototype;
            defineNonEnumerableProperty(proto, '$Bgjoin', asProto.join);
            // Same as join, see VectorImpl.as in Tamarin repository.
            defineNonEnumerableProperty(proto, '$BgtoString', asProto.join);
            defineNonEnumerableProperty(proto, '$BgtoLocaleString', asProto.toLocaleString);
            defineNonEnumerableProperty(proto, '$Bgpop', asProto.pop);
            defineNonEnumerableProperty(proto, '$Bgpush', asProto.push);
            defineNonEnumerableProperty(proto, '$Bgreverse', asProto.reverse);
            defineNonEnumerableProperty(proto, '$Bgconcat', asProto.concat);
            defineNonEnumerableProperty(proto, '$Bgsplice', asProto.splice);
            defineNonEnumerableProperty(proto, '$Bgslice', asProto.slice);
            defineNonEnumerableProperty(proto, '$Bgshift', asProto.shift);
            defineNonEnumerableProperty(proto, '$Bgunshift', asProto.unshift);
            defineNonEnumerableProperty(proto, '$BgindexOf', asProto.indexOf);
            defineNonEnumerableProperty(proto, '$BglastIndexOf', asProto.lastIndexOf);
            defineNonEnumerableProperty(proto, '$BgforEach', asProto.forEach);
            defineNonEnumerableProperty(proto, '$Bgmap', asProto.map);
            defineNonEnumerableProperty(proto, '$Bgfilter', asProto.filter);
            defineNonEnumerableProperty(proto, '$Bgsome', asProto.some);
            defineNonEnumerableProperty(proto, '$Bgevery', asProto.every);
            defineNonEnumerableProperty(proto, '$Bgsort', asProto.sort);
            defineNonEnumerableProperty(proto, 'checkVectorMethodArgs', asProto.checkVectorMethodArgs);
        };
        GenericVector.axApply = function (_, args) {
            var object = args[0];
            if (this.axIsType(object)) {
                return object;
            }
            var length = object.axGetPublicProperty("length");
            if (length !== undefined) {
                var v = this.axConstruct([length, false]);
                for (var i = 0; i < length; i++) {
                    v.axSetNumericProperty(i, object.axGetPublicProperty(i));
                }
                return v;
            }
            unexpected();
        };
        GenericVector.defaultCompareFunction = function (a, b) {
            return String(a).localeCompare(String(b));
        };
        GenericVector.compare = function (a, b, options, compareFunction) {
            release$1 || assertNotImplemented(!(options & GenericVector.CASEINSENSITIVE), "CASEINSENSITIVE");
            release$1 || assertNotImplemented(!(options & GenericVector.UNIQUESORT), "UNIQUESORT");
            release$1 || assertNotImplemented(!(options & GenericVector.RETURNINDEXEDARRAY), "RETURNINDEXEDARRAY");
            var result = 0;
            if (!compareFunction) {
                compareFunction = GenericVector.defaultCompareFunction;
            }
            if (options & GenericVector.NUMERIC) {
                a = toNumber(a);
                b = toNumber(b);
                result = a < b ? -1 : (a > b ? 1 : 0);
            }
            else {
                result = compareFunction(a, b);
            }
            if (options & GenericVector.DESCENDING) {
                result *= -1;
            }
            return result;
        };
        GenericVector.prototype._fill = function (index, length, value) {
            for (var i = 0; i < length; i++) {
                this._buffer[index + i] = value;
            }
        };
        /**
         * Can't use Array.prototype.toString because it doesn't print |null|s the same way as AS3.
         */
        GenericVector.prototype.toString = function () {
            var result = [];
            for (var i = 0; i < this._buffer.length; i++) {
                var entry = this._buffer[i];
                result.push(entry === null ? 'null' : (entry + ''));
            }
            return result.join(',');
        };
        GenericVector.prototype.toLocaleString = function () {
            var result = [];
            for (var i = 0; i < this._buffer.length; i++) {
                var entry = this._buffer[i];
                if (entry && typeof entry === 'object') {
                    result.push(entry.$BgtoLocaleString());
                }
                else {
                    result.push(entry + '');
                }
            }
            return result.join(',');
        };
        GenericVector.prototype.sort = function (sortBehavior) {
            if (arguments.length === 0) {
                this._buffer.sort();
                return this;
            }
            if (this.sec.AXFunction.axIsType(sortBehavior)) {
                this._buffer.sort(sortBehavior.value);
                return this;
            }
            var options = sortBehavior | 0;
            // 80pro: todo:
            //release || assertNotImplemented (!(options & Int32Vector.UNIQUESORT), "UNIQUESORT");
            //release || assertNotImplemented (!(options & Int32Vector.RETURNINDEXEDARRAY), "RETURNINDEXEDARRAY");
            if (options & GenericVector.NUMERIC) {
                if (options & GenericVector.DESCENDING) {
                    this._buffer.sort(function (a, b) { return axCoerceNumber(b) - axCoerceNumber(a); });
                    return this;
                }
                this._buffer.sort(function (a, b) { return axCoerceNumber(a) - axCoerceNumber(b); });
                return this;
            }
            if (options & GenericVector.CASEINSENSITIVE) {
                if (options & GenericVector.DESCENDING) {
                    this._buffer.sort(function (a, b) { return axCoerceString$3(b).toLowerCase() -
                        axCoerceString$3(a).toLowerCase(); });
                    return this;
                }
                this._buffer.sort(function (a, b) { return axCoerceString$3(a).toLowerCase() -
                    axCoerceString$3(b).toLowerCase(); });
                return this;
            }
            if (options & GenericVector.DESCENDING) {
                this._buffer.sort(function (a, b) { return b - a; });
                return this;
            }
            this._buffer.sort();
            return this;
        };
        /**
         * Executes a |callback| function with three arguments: element, index, the vector itself as
         * well as passing the |thisObject| as |this| for each of the elements in the vector. If any of
         * the callbacks return |false| the function terminates, otherwise it returns |true|.
         */
        GenericVector.prototype.every = function (callback, thisObject) {
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return true;
            }
            for (var i = 0; i < this._buffer.length; i++) {
                if (!callback.axCall(thisObject, this.axGetNumericProperty(i), i, this)) {
                    return false;
                }
            }
            return true;
        };
        /**
         * Filters the elements for which the |callback| method returns |true|. The |callback| function
         * is called with three arguments: element, index, the vector itself as well as passing the
         * |thisObject| as |this| for each of the elements in the vector.
         */
        GenericVector.prototype.filter = function (callback, thisObject) {
            var v = this.axClass.axConstruct([0, false]);
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return v;
            }
            for (var i = 0; i < this._buffer.length; i++) {
                if (callback.call(thisObject, this.axGetNumericProperty(i), i, this)) {
                    v.push(this.axGetNumericProperty(i));
                }
            }
            return v;
        };
        GenericVector.prototype.map = function (callback, thisObject) {
            var v = this.axClass.axConstruct([this.length, false]);
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return v;
            }
            for (var i = 0; i < this._buffer.length; i++) {
                v.push(this._coerce(callback.call(thisObject, this.axGetNumericProperty(i), i, this)));
            }
            return v;
        };
        GenericVector.prototype.some = function (callback, thisObject) {
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return false;
            }
            for (var i = 0; i < this._buffer.length; i++) {
                if (callback.call(thisObject, this.axGetNumericProperty(i), i, this)) {
                    return true;
                }
            }
            return false;
        };
        GenericVector.prototype.forEach = function (callback, thisObject) {
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return;
            }
            for (var i = 0; i < this._buffer.length; i++) {
                callback.call(thisObject, this.axGetNumericProperty(i), i, this);
            }
        };
        GenericVector.prototype.join = function (separator) {
            if (separator === void 0) { separator = ','; }
            var buffer = this._buffer;
            var limit = this._buffer.length;
            var result = "";
            for (var i = 0; i < limit - 1; i++) {
                result += buffer[i] + separator;
            }
            if (limit > 0) {
                result += buffer[limit - 1];
            }
            return result;
        };
        GenericVector.prototype.indexOf = function (searchElement, fromIndex) {
            if (fromIndex === void 0) { fromIndex = 0; }
            return this._buffer.indexOf(searchElement, fromIndex);
        };
        GenericVector.prototype.lastIndexOf = function (searchElement, fromIndex) {
            if (fromIndex === void 0) { fromIndex = 0x7fffffff; }
            return this._buffer.lastIndexOf(searchElement, fromIndex);
        };
        GenericVector.prototype.push = function (arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8 /*...rest*/) {
            this._checkFixed();
            for (var i = 0; i < arguments.length; i++) {
                this._buffer.push(this._coerce(arguments[i]));
            }
        };
        GenericVector.prototype.pop = function () {
            this._checkFixed();
            if (this._buffer.length === 0) {
                return undefined;
            }
            return this._buffer.pop();
        };
        GenericVector.prototype.concat = function () {
            // TODO: need to type check the arguments, but isType doesn't exist.
            var buffers = [];
            for (var i = 0; i < arguments.length; i++) {
                buffers.push(this._coerce(arguments[i])._buffer);
            }
            var buffer = this._buffer.concat.apply(this._buffer, buffers);
            var result = this.axClass.axConstruct([]);
            result._buffer = buffer;
            return result;
        };
        GenericVector.prototype.reverse = function () {
            this._buffer.reverse();
            return this;
        };
        GenericVector.prototype._coerce = function (v) {
            return this.axClass.type.axCoerce(v);
        };
        GenericVector.prototype.shift = function () {
            this._checkFixed();
            if (this._buffer.length === 0) {
                return undefined;
            }
            return this._buffer.shift();
        };
        GenericVector.prototype.unshift = function () {
            if (!arguments.length) {
                return;
            }
            this._checkFixed();
            for (var i = 0; i < arguments.length; i++) {
                this._buffer.unshift(this._coerce(arguments[i]));
            }
        };
        GenericVector.prototype.slice = function (start, end) {
            if (start === void 0) { start = 0; }
            if (end === void 0) { end = 0x7fffffff; }
            var buffer = this._buffer;
            var length = buffer.length;
            var first = Math.min(Math.max(start, 0), length);
            var last = Math.min(Math.max(end, first), length);
            var result = this.axClass.axConstruct([last - first, this.fixed]);
            result._buffer = buffer.slice(first, last);
            return result;
        };
        GenericVector.prototype.splice = function (start, deleteCount_ /*, ...items */) {
            var buffer = this._buffer;
            var length = buffer.length;
            var first = Math.min(Math.max(start, 0), length);
            var deleteCount = Math.min(Math.max(deleteCount_, 0), length - first);
            var insertCount = arguments.length - 2;
            if (deleteCount !== insertCount) {
                this._checkFixed();
            }
            var items = [first, deleteCount];
            for (var i = 2; i < insertCount + 2; i++) {
                items[i] = this._coerce(arguments[i]);
            }
            var result = this.axClass.axConstruct([deleteCount, this.fixed]);
            result._buffer = buffer.splice.apply(buffer, items);
            return result;
        };
        Object.defineProperty(GenericVector.prototype, "length", {
            get: function () {
                return this._buffer.length;
            },
            set: function (value) {
                value = value >>> 0;
                if (value > this._buffer.length) {
                    for (var i = this._buffer.length; i < value; i++) {
                        this._buffer[i] = this.axClass.defaultValue;
                    }
                }
                else {
                    this._buffer.length = value;
                }
                release$1 || assert(this._buffer.length === value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GenericVector.prototype, "fixed", {
            get: function () {
                return this._fixed;
            },
            set: function (f) {
                this._fixed = !!f;
            },
            enumerable: true,
            configurable: true
        });
        GenericVector.prototype._checkFixed = function () {
            if (this._fixed) {
                this.sec.throwError("RangeError", Errors$1.VectorFixedError);
            }
        };
        GenericVector.prototype.axGetNumericProperty = function (nm) {
            release$1 || assert(isNumeric(nm));
            var idx = nm | 0;
            if (idx < 0 || idx >= this._buffer.length || idx != nm) {
                this.sec.throwError("RangeError", Errors$1.OutOfRangeError, nm, this._buffer.length);
            }
            return this._buffer[idx];
        };
        GenericVector.prototype.axSetNumericProperty = function (nm, v) {
            release$1 || assert(isNumeric(nm));
            var length = this._buffer.length;
            var idx = nm | 0;
            if (idx < 0 || idx > length || idx != nm || (idx === length && this._fixed)) {
                this.sec.throwError("RangeError", Errors$1.OutOfRangeError, nm, length);
            }
            this._buffer[idx] = this._coerce(v);
        };
        GenericVector.prototype.axHasPropertyInternal = function (mn) {
            // Optimization for the common case of indexed element accesses.
            if ((mn.name | 0) === mn.name) {
                release$1 || assert(mn.isRuntimeName());
                return mn.name >= 0 && mn.name < this._buffer.length;
            }
            var name = axCoerceName(mn.name);
            if (mn.isRuntimeName() && isIndex(name)) {
                var index = name >>> 0;
                return index >= 0 && index < this._buffer.length;
            }
            return this.axResolveMultiname(mn) in this;
        };
        GenericVector.prototype.axNextValue = function (index) {
            return this._buffer[index - 1];
        };
        GenericVector.prototype.axNextNameIndex = function (index) {
            var nextNameIndex = index + 1;
            if (nextNameIndex <= this._buffer.length) {
                return nextNameIndex;
            }
            return 0;
        };
        GenericVector.CASEINSENSITIVE = 1;
        GenericVector.DESCENDING = 2;
        GenericVector.UNIQUESORT = 4;
        GenericVector.RETURNINDEXEDARRAY = 8;
        GenericVector.NUMERIC = 16;
        GenericVector.defaultValue = null;
        return GenericVector;
    }(BaseVector));

    var BrowserSystemResourcesLoadingService = /** @class */ (function () {
        function BrowserSystemResourcesLoadingService() {
        }
        BrowserSystemResourcesLoadingService.getInstance = function () {
            if (BrowserSystemResourcesLoadingService._instance)
                return BrowserSystemResourcesLoadingService._instance;
            return (BrowserSystemResourcesLoadingService._instance = new BrowserSystemResourcesLoadingService());
        };
        BrowserSystemResourcesLoadingService.prototype.load = function (url, type) {
            return this._promiseFile(url, type);
        };
        BrowserSystemResourcesLoadingService.prototype._promiseFile = function (path, responseType) {
            return new Promise(function (resolve, reject) {
                //SWF.enterTimeline('Load file', path);
                var xhr = new XMLHttpRequest();
                xhr.open("GET", path);
                xhr.responseType = responseType;
                xhr.onload = function () {
                    var response = xhr.response;
                    if (response) {
                        if (responseType === "json" && xhr.responseType !== "json") {
                            // some browsers (e.g. Safari) have no idea what json is
                            response = JSON.parse(response);
                        }
                        resolve(response);
                    }
                    else {
                        reject("Unable to load " + path + ": " + xhr.statusText);
                    }
                };
                xhr.onerror = function () {
                    reject("Unable to load: xhr error");
                };
                xhr.send();
            });
        };
        return BrowserSystemResourcesLoadingService;
    }());

    var ABCCatalog = /** @class */ (function () {
        function ABCCatalog(app, abcs, index) {
            this.app = app;
            this.map = ObjectUtilities.createMap();
            this.abcs = abcs;
            this.scripts = ObjectUtilities.createMap();
            for (var i = 0; i < index.length; i++) {
                var abc = index[i];
                this.scripts[abc.name] = abc;
                release$1 || assert(Array.isArray(abc.defs));
                for (var j = 0; j < abc.defs.length; j++) {
                    var def = abc.defs[j].split(':');
                    var nameMappings = this.map[def[1]];
                    if (!nameMappings) {
                        nameMappings = this.map[def[1]] = Object.create(null);
                    }
                    nameMappings[def[0]] = abc.name;
                }
            }
        }
        ABCCatalog.prototype.getABCByScriptName = function (scriptName) {
            var entry = this.scripts[scriptName];
            if (!entry) {
                return null;
            }
            var env = { url: scriptName, app: this.app };
            return new ABCFile(env, this.abcs.subarray(entry.offset, entry.offset + entry.length));
        };
        ABCCatalog.prototype.getABCByMultiname = function (mn) {
            var mappings = this.map[mn.name];
            if (!mappings) {
                return null;
            }
            var namespaces = mn.namespaces;
            for (var i = 0; i < namespaces.length; i++) {
                var ns = namespaces[i];
                var scriptName = mappings[ns.uri];
                if (scriptName) {
                    return this.getABCByScriptName(scriptName);
                }
            }
            return null;
        };
        return ABCCatalog;
    }());

    /**
     * All code lives within an application domain.
     */
    var AXApplicationDomain = /** @class */ (function () {
        function AXApplicationDomain(sec, parent) {
            this.sec = sec;
            this.parent = parent;
            this.system = parent ? parent.system : this;
            this._abcs = [];
            this._binarySymbols = {};
        }
        AXApplicationDomain.prototype.addBinarySymbol = function (symbol) {
            this._binarySymbols[symbol.className] = symbol;
        };
        AXApplicationDomain.prototype.getBinarySymbol = function (className) {
            return this._binarySymbols[className];
        };
        AXApplicationDomain.prototype.loadABC = function (abc) {
            assert(this._abcs.indexOf(abc) < 0);
            this._abcs.push(abc);
        };
        AXApplicationDomain.prototype.loadAndExecuteABC = function (abc) {
            this.loadABC(abc);
            this.executeABC(abc);
        };
        AXApplicationDomain.prototype.executeABC = function (abc) {
            var lastScript = abc.scripts[abc.scripts.length - 1];
            this.executeScript(lastScript);
        };
        AXApplicationDomain.prototype.findClassInfo = function (name) {
            for (var i = 0; i < this._abcs.length; i++) {
                var abc = this._abcs[i];
                for (var j = 0; j < abc.instances.length; j++) {
                    var c = abc.classes[j];
                    if (c.instanceInfo.getName().name === name) {
                        return c;
                    }
                }
            }
            return null;
        };
        AXApplicationDomain.prototype.executeScript = function (scriptInfo) {
            assert(scriptInfo.state === 0 /* None */);
            runtimeWriter && runtimeWriter.writeLn("Running Script: " + scriptInfo);
            var global = this.sec.createAXGlobal(this, scriptInfo);
            scriptInfo.global = global;
            scriptInfo.state = 1 /* Executing */;
            interpret(scriptInfo.getInitializer(), global.scope, null).apply(global, []);
            scriptInfo.state = 2 /* Executed */;
        };
        AXApplicationDomain.prototype.findProperty = function (mn, strict, execute) {
            release$1 || assert(mn instanceof Multiname);
            var script = this.findDefiningScript(mn, execute);
            if (script) {
                return script.global;
            }
            return null;
        };
        AXApplicationDomain.prototype.getClass = function (mn) {
            release$1 || assert(mn instanceof Multiname);
            return this.getProperty(mn, true, true);
        };
        AXApplicationDomain.prototype.getProperty = function (mn, strict, execute) {
            release$1 || assert(mn instanceof Multiname);
            var global = this.findProperty(mn, strict, execute);
            if (global) {
                return global.axGetProperty(mn);
            }
            return null;
        };
        AXApplicationDomain.prototype.findDefiningScript = function (mn, execute) {
            release$1 || assert(mn instanceof Multiname);
            if (mn.script)
                return mn.script;
            // Look in parent domain first.
            var script;
            if (this.parent) {
                script = this.parent.findDefiningScript(mn, execute);
                if (script) {
                    return script;
                }
            }
            // Search through the loaded abcs.
            for (var i = 0; i < this._abcs.length; i++) {
                var abc = this._abcs[i];
                script = this._findDefiningScriptInABC(abc, mn, execute);
                if (script) {
                    if (!mn.mutable)
                        mn.script = script;
                    return script;
                }
            }
            // Still no luck, so let's ask the security domain to load additional ABCs and try again.
            var abc = this.system.sec.findDefiningABC(mn);
            if (abc) {
                this.loadABC(abc);
                script = this._findDefiningScriptInABC(abc, mn, execute);
                release$1 || assert(script, 'Shall find class in loaded ABC');
                if (!mn.mutable)
                    mn.script = script;
                return script;
            }
            return null;
        };
        AXApplicationDomain.prototype._findDefiningScriptInABC = function (abc, mn, execute) {
            var scripts = abc.scripts;
            for (var j = 0; j < scripts.length; j++) {
                var script = scripts[j];
                var traits = script.traits;
                traits.resolve();
                if (traits.getTrait(mn)) {
                    // Ensure script is executed.
                    if (execute && script.state === 0 /* None */) {
                        this.executeScript(script);
                    }
                    return script;
                }
            }
            return null;
        };
        return AXApplicationDomain;
    }());

    /**
     * Transforms a JS value into an AS value.
     */
    function transformJSValueToAS(sec, value, deep) {
        release$1 || assert(typeof value !== 'function');
        if (typeof value !== "object") {
            return value;
        }
        if (isNullOrUndefined(value)) {
            return value;
        }
        if (Array.isArray(value)) {
            var list = [];
            for (var i = 0; i < value.length; i++) {
                var entry = value[i];
                var axValue = deep ? transformJSValueToAS(sec, entry, true) : entry;
                list.push(axValue);
            }
            return sec.createArray(list);
        }
        return sec.createObjectFromJS(value, deep);
    }

    /**
     * Returns |true| if the symbol is available in debug or release modes. Only symbols
     * followed by the  "!" suffix are available in release builds.
     */
    function containsSymbol(symbols, name) {
        for (var i = 0; i < symbols.length; i++) {
            var symbol = symbols[i];
            if (symbol.indexOf(name) >= 0) {
                var releaseSymbol = symbol[symbol.length - 1] === "!";
                if (releaseSymbol) {
                    symbol = symbol.slice(0, symbol.length - 1);
                }
                if (name !== symbol) {
                    continue;
                }
                if (release$1) {
                    return releaseSymbol;
                }
                return true;
            }
        }
        return false;
    }

    function linkSymbols(symbols, traits, object) {
        for (var i = 0; i < traits.traits.length; i++) {
            var trait = traits.traits[i];
            if (!containsSymbol(symbols, trait.getName().name)) {
                continue;
            }
            release$1 || assert(trait.getName().namespace.type !== 3 /* Private */, "Why are you linking against private members?");
            if (trait.isConst()) {
                release$1 || release$1 || notImplemented("Don't link against const traits.");
                return;
            }
            var name = trait.getName().name;
            var qn = trait.getName().getMangledName();
            if (trait.isSlot()) {
                Object.defineProperty(object, name, {
                    get: new Function("", "return this." + qn +
                        "//# sourceURL=get-" + qn + ".as"),
                    set: new Function("v", "this." + qn + " = v;" +
                        "//# sourceURL=set-" + qn + ".as")
                });
            }
            else if (trait.isGetter()) {
                release$1 || assert(hasOwnGetter(object, qn), "There should be an getter method for this symbol.");
                Object.defineProperty(object, name, {
                    get: new Function("", "return this." + qn +
                        "//# sourceURL=get-" + qn + ".as")
                });
            }
            else {
                notImplemented(trait.toString());
            }
        }
    }

    function filter(propertyName) {
        return propertyName.indexOf("native_") !== 0;
    }

    function traceASClass(axClass, asClass) {
        runtimeWriter.enter("Class: " + axClass.classInfo);
        runtimeWriter.enter("Traps:");
        for (var k in asClass.prototype) {
            if (k.indexOf("ax") !== 0) {
                continue;
            }
            var hasOwn = asClass.hasOwnProperty(k);
            runtimeWriter.writeLn((hasOwn ? "Own" : "Inherited") + " trap: " + k);
        }
        runtimeWriter.leave();
        runtimeWriter.leave();
    }

    var axTrapNames = [
        "axResolveMultiname",
        "axHasProperty",
        "axDeleteProperty",
        "axCallProperty",
        "axCallSuper",
        "axConstructProperty",
        "axHasPropertyInternal",
        "axHasOwnProperty",
        "axSetProperty",
        "axGetProperty",
        "axGetSuper",
        "axSetSuper",
        "axNextNameIndex",
        "axNextName",
        "axNextValue",
        "axGetEnumerableKeys",
        "axHasPublicProperty",
        "axSetPublicProperty",
        "axGetPublicProperty",
        "axCallPublicProperty",
        "axDeletePublicProperty",
        "axSetNumericProperty",
        "axGetNumericProperty",
        "axGetSlot",
        "axSetSlot"
    ];

    function linkClass(axClass, asClass) {
        // Save asClass on the axClass.
        axClass.asClass = asClass;
        // TypeScript's static inheritance can lead to subtle linking bugs. Make sure we don't fall
        // victim to this by checking that we don't inherit non-null static properties.
        /*if (false && !release && axClass.superClass) {
          if (asClass.classSymbols) {
            release || assert(asClass.classSymbols !== axClass.superClass.asClass.classSymbols,
              "Make sure class " + axClass + " doesn't inherit super class's classSymbols.");
          }
          if (asClass.instanceSymbols) {
            release || assert(asClass.instanceSymbols !== axClass.superClass.asClass.instanceSymbols,
              "Make sure class " + axClass + " doesn't inherit super class's instanceSymbols.");
          }
          if (asClass.classInitializer) {
            release || assert(asClass.classInitializer !== axClass.superClass.asClass.classInitializer,
              "Make sure class " + axClass + " doesn't inherit super class's class initializer.");
          }
        }*/
        if (asClass.classSymbols) {
            linkSymbols(asClass.classSymbols, axClass.classInfo.traits, axClass);
        }
        if (asClass.instanceSymbols) {
            linkSymbols(asClass.instanceSymbols, axClass.classInfo.instanceInfo.traits, axClass.tPrototype);
        }
        // Copy class methods and properties.
        if (asClass.classNatives) {
            for (var i = 0; i < asClass.classNatives.length; i++) {
                copyOwnPropertyDescriptors(axClass, asClass.classNatives[i], filter);
            }
        }
        copyOwnPropertyDescriptors(axClass, asClass, filter, true, true);
        if (axClass.superClass) {
            // Inherit prototype descriptors from the super class. This is a bit risky because
            // it copies over all properties and may overwrite properties that we don't expect.
            // TODO: Look into a safer way to do this, for now it doesn't overwrite already
            // defined properties.
            // copyOwnPropertyDescriptors(axClass.dPrototype, axClass.superClass.dPrototype, null, false,
            // true);
        }
        // Copy instance methods and properties.
        if (asClass.instanceNatives) {
            for (var i = 0; i < asClass.instanceNatives.length; i++) {
                copyOwnPropertyDescriptors(axClass.dPrototype, asClass.instanceNatives[i], filter);
            }
        }
        // Inherit or override prototype descriptors from the template class.
        copyOwnPropertyDescriptors(axClass.dPrototype, asClass.prototype, filter);
        // Copy inherited traps. We want to make sure we copy all the in inherited traps, not just the
        // traps defined in asClass.Prototype.
        copyPropertiesByList(axClass.dPrototype, asClass.prototype, axTrapNames);
        if (asClass.classInitializer) {
            asClass.classInitializer.call(axClass, asClass);
            if (!release$1) {
                Object.freeze(asClass);
            }
        }
        runtimeWriter && traceASClass(axClass, asClass);
    }

    function tryLinkNativeClass(axClass) {
        var className = axClass.classInfo.instanceInfo.getClassName();
        var asClass = builtinNativeClasses[className] || nativeClasses[className];
        if (asClass) {
            linkClass(axClass, asClass);
        }
    }

    function getNativeInitializer(classInfo) {
        var methodInfo = classInfo.instanceInfo.getInitializer();
        var className = classInfo.instanceInfo.getClassName();
        var asClass = builtinNativeClasses[className] || nativeClasses[className];
        if (methodInfo.isNative()) {
            // Use TS constructor as the initializer function.
            return asClass;
        }
        //// TODO: Assert eagerly.
        //return function () {
        //  release || assert (!methodInfo.isNative(), "Must supply a constructor for " + classInfo +
        // "."); }
        return null;
    }

    var createContainersFromPath = function (pathTokens, container) {
        for (var i = 0, j = pathTokens.length; i < j; i++) {
            if (!container[pathTokens[i]]) {
                container[pathTokens[i]] = Object.create(null);
            }
            container = container[pathTokens[i]];
        }
        return container;
    };

    /**
     * Creates a self patching getter that lazily constructs the class and memoizes
     * to the class's instance constructor.
     */
    function defineClassLoader(applicationDomain, container, mn, classAlias) {
        Object.defineProperty(container, classAlias, {
            get: function () {
                runtimeWriter && runtimeWriter.writeLn("Running Memoizer: " + mn.name);
                var axClass = applicationDomain.getClass(mn);
                release$1 || assert(axClass, "Class " + mn + " is not found.");
                release$1 || assert(axClass.axConstruct);
                var loader = function () {
                    return axClass.axConstruct(arguments);
                };
                loader.axIsType = function (value) {
                    return axClass.axIsType(value);
                };
                loader.axClass = axClass;
                Object.defineProperty(container, classAlias, {
                    value: loader,
                    writable: false
                });
                return loader;
            },
            configurable: true
        });
    }

    function makeClassLoader(applicationDomain, container, classPath, aliasPath, nsType) {
        runtimeWriter && runtimeWriter.writeLn("Defining Memoizer: " + classPath);
        var aliasPathTokens = aliasPath.split(".");
        var aliasClassName = aliasPathTokens.pop();
        container = createContainersFromPath(aliasPathTokens, container);
        var mn = Multiname.FromFQNString(classPath, nsType);
        defineClassLoader(applicationDomain, container, mn, aliasClassName);
    }

    /**
     * Installs class loaders for all the previously registered native classes.
     */
    function installClassLoaders(applicationDomain, container) {
        for (var i = 0; i < nativeClassLoaderNames.length; i++) {
            var loaderName = nativeClassLoaderNames[i].name;
            var loaderAlias = nativeClassLoaderNames[i].alias;
            var nsType = nativeClassLoaderNames[i].nsType;
            makeClassLoader(applicationDomain, container, loaderName, loaderAlias, nsType);
        }
    }

    /**
     * Installs all the previously registered native functions on the AXSecurityDomain.
     *
     * Note that this doesn't use memoizers and doesn't run the functions' AS3 script.
     */
    function installNativeFunctions(sec) {
        for (var i in nativeFunctions) {
            var pathTokens = i.split('.');
            var funName = pathTokens.pop();
            var container = createContainersFromPath(pathTokens, sec);
            container[funName] = sec.boxFunction(nativeFunctions[i]);
        }
    }

    /**
     * Throwing initializer for interfaces.
     */
    function axInterfaceInitializer() {
        this.sec.throwError("VerifierError", Errors$1.NotImplementedError, this.name.name);
    }

    function axIsInstanceOfInterface(x) {
        return false;
    }

    function axIsTypeInterface(x) {
        if (!x || typeof x !== 'object') {
            return false;
        }
        release$1 || checkValue(x);
        return x.axImplementsInterface(this);
    }

    function applyTraits(object, traits) {
        release$1 || assert(!object.hasOwnProperty("traits"));
        defineReadOnlyProperty(object, "traits", traits);
        var T = traits.getTraitsList();
        for (var i = 0; i < T.length; i++) {
            var t = T[i];
            var p = t;
            if (p.value instanceof Namespace) {
                // We can't call |object.sec.AXNamespace.FromNamespace(...)| because the
                // AXNamespace class may not have been loaded yet. However, at this point we do have a
                // valid reference to |object.sec.AXNamespace| because |prepareNativeClass| has
                // been called.
                p = { value: ASNamespace.FromNamespace.call(object.sec.AXNamespace, p.value) };
            }
            if (!release$1 && (t.kind === 0 /* Slot */ || t.kind === 6 /* Const */)) {
                checkValue(p.value);
            }
            Object.defineProperty(object, t.name.getMangledName(), p);
        }
    }

    function axCoerce(x) {
        if (isNullOrUndefined$1(x)) {
            return null;
        }
        if (!this.axIsType(x)) {
            this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, x, this.classInfo.instanceInfo.getClassName());
        }
        return x;
    }

    function axIsInstanceOfObject(x) {
        return this.dPrototype.isPrototypeOf(this.sec.box(x));
    }

    var ActiveLoaderContext = /** @class */ (function () {
        function ActiveLoaderContext() {
        }
        return ActiveLoaderContext;
    }());
    /**
     * Generic axConstruct method that lives on the AXClass prototype. This just
     * creates an empty object with the right prototype and then calls the
     * instance initializer.
     *
     * TODO: Flatten out the argArray, or create an alternate ax helper to
     * make object construction faster.
     */
    function axConstruct(argArray) {
        var object = Object.create(this.tPrototype);
        var symbol = null;
        var timeline = null;
        var classToCheck = this;
        //  find the AwayJS-timline that should be used for this MC. might be on superclass...
        while (classToCheck && !timeline) {
            symbol = classToCheck._symbol;
            if (symbol && symbol.timeline)
                timeline = symbol.timeline;
            classToCheck = classToCheck.superClass;
        }
        if (timeline) {
            var newMC = new MovieClip(timeline);
            //console.log("create mc via axConstruct");
            object.adaptee = newMC;
            newMC.timelineMC = true;
            newMC.reset();
            object.noReset = true;
            FrameScriptManager.execute_as3_constructors();
            //FrameScriptManager.execute_queue();
            //(<any>object).dispatchStaticEvent(Event.FRAME_CONSTRUCTED)
            OrphanManager.addOrphan(object);
        }
        if (this.superClass && this.superClass.classInfo && this.superClass.classInfo.instanceInfo && this.superClass.classInfo.instanceInfo.name.name == "Sound") {
            //console.log("find sound for name", this.classInfo.instanceInfo.name.name)
            if (ActiveLoaderContext.loaderContext) {
                var asset = ActiveLoaderContext.loaderContext.applicationDomain.getAwayJSAudio(this.classInfo.instanceInfo.name.name);
                if (asset && asset.isAsset(WaveAudio)) {
                    //ActiveLoaderContext.waveAudioForSoundConstructor = <WaveAudio>asset;
                    object.adaptee = asset;
                }
                else {
                    console.log("error: could not find audio for class", this.classInfo.instanceInfo.name.name, asset);
                }
            }
            else {
                console.log("error: ActiveLoaderContext.loaderContext not set. can not rerieve Sound");
            }
        }
        else if (this.superClass && this.superClass.classInfo && this.superClass.classInfo.instanceInfo && this.superClass.classInfo.instanceInfo.name.name == "BitmapData") {
            //console.log("find sound for name", this.classInfo.instanceInfo.name.name)
            if (ActiveLoaderContext.loaderContext) {
                var asset = ActiveLoaderContext.loaderContext.applicationDomain.getDefinition(this.classInfo.instanceInfo.name.name);
                if (asset && asset.isAsset(SceneImage2D) || asset.isAsset(BitmapImage2D)) {
                    //ActiveLoaderContext.sceneImage2DForBitmapConstructor = <SceneImage2D>asset;
                    object.adaptee = asset;
                }
                else {
                    console.log("error: could not find audio for class", this.classInfo.instanceInfo.name.name, asset);
                }
            }
            else {
                console.log("error: ActiveLoaderContext.loaderContext not set. can not rerieve Sound");
            }
        }
        object.noReset = true;
        if (object.getQueuedEvents) {
            var events = object.getQueuedEvents();
            object.axInitializer.apply(object, argArray);
            if (events) {
                for (var i = 0; i < events.length; i++) {
                    object.dispatchEvent(events[i]);
                }
            }
        }
        else {
            object.axInitializer.apply(object, argArray);
        }
        return object;
    }

    /**
     * Default axApply.
     */
    function axDefaultApply(self, args) {
        return this.axCoerce(args ? args[0] : undefined);
    }

    /**
     * Default initializer.
     */
    function axDefaultInitializer() {
        // Nop.
    }

    /**
     * Returns the current interpreter frame's callee.
     */
    function axGetArgumentsCallee() {
        var callee = this.callee;
        if (callee) {
            return callee;
        }
        release$1 || assert(this.receiver);
        release$1 || assert(this.methodInfo);
        if (this.methodInfo.trait === null) {
            console.error('arguments.callee used on trait-less methodInfo function. Probably a constructor');
            return null;
        }
        release$1 || assert(this.methodInfo.trait);
        var mn = this.methodInfo.trait.name;
        var methodClosure = this.receiver.axGetProperty(mn);
        release$1 || assert(this.sec.AXMethodClosure.tPrototype === Object.getPrototypeOf(methodClosure));
        return methodClosure;
    }

    function axCoerceBoolean(x) {
        return !!x;
    }

    function axIsTypeBoolean(x) {
        return typeof x === "boolean";
    }

    function axIsTypeString(x) {
        return typeof x === "string";
    }

    function axIsTypeNumber(x) {
        return typeof x === "number";
    }

    function axCoerceInt(x) {
        return x | 0;
    }

    function axFalse() {
        return false;
    }

    function axIsTypeInt(x) {
        return typeof x === "number" && ((x | 0) === x);
    }

    function axCoerceUint(x) {
        return x >>> 0;
    }

    function axIsTypeUint(x) {
        return typeof x === "number" && ((x >>> 0) === x);
    }

    function axBoxIdentity(args) {
        return args[0];
    }

    function axIsTypeObject(x) {
        return this.dPrototype.isPrototypeOf(this.sec.box(x)) || x === this.dPrototype;
    }

    function axAsType(x) {
        return this.axIsType(x) ? x : null;
    }

    function axBoxPrimitive(value) {
        var boxed = Object.create(this.tPrototype);
        boxed.value = value;
        return boxed;
    }

    function axApplyObject(_, args) {
        var x = args[0];
        if (x == null) {
            return Object.create(this.tPrototype);
        }
        return x;
    }

    function axConstructObject(args) {
        var x = args[0];
        if (x == null) {
            return Object.create(this.tPrototype);
        }
        return x;
    }

    function axCoerceObject(x) {
        if (x == null) {
            return null;
        }
        return x;
    }

    /**
     * Provides security isolation between application domains.
     */
    var AXSecurityDomain = /** @class */ (function () {
        function AXSecurityDomain() {
            initializeAXBasePrototype();
            this.system = new AXApplicationDomain(this, null);
            this.application = new AXApplicationDomain(this, this.system);
            this.classAliases = new ClassAliases();
            this.nativeClasses = Object.create(null);
            this.vectorClasses = new Map();
            this._catalogs = [];
        }
        Object.defineProperty(AXSecurityDomain.prototype, "xmlParser", {
            get: function () {
                return this._xmlParser || (this._xmlParser = new XMLParser(this));
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AXSecurityDomain.prototype, "AXFunctionUndefinedPrototype", {
            get: function () {
                return this._AXFunctionUndefinedPrototype ||
                    (this._AXFunctionUndefinedPrototype = this.createObject());
            },
            enumerable: true,
            configurable: true
        });
        AXSecurityDomain.prototype.addCatalog = function (abcCatalog) {
            this._catalogs.push(abcCatalog);
        };
        AXSecurityDomain.prototype.findDefiningABC = function (mn) {
            runtimeWriter && runtimeWriter.writeLn("findDefiningABC: " + mn);
            var abcFile = null;
            for (var i = 0; i < this._catalogs.length; i++) {
                var abcCatalog = this._catalogs[i];
                abcFile = abcCatalog.getABCByMultiname(mn);
                if (abcFile) {
                    return abcFile;
                }
            }
            return null;
        };
        AXSecurityDomain.prototype.throwError = function (className, error$$1, replacement1, replacement2, replacement3, replacement4) {
            throw this.createError.apply(this, arguments);
        };
        AXSecurityDomain.prototype.createError = function (className, error$$1, replacement1, replacement2, replacement3, replacement4) {
            var message = formatErrorMessage.apply(null, sliceArguments(arguments, 1));
            var mn = Multiname.FromFQNString(className, 0 /* Public */);
            var axClass = this.system.getProperty(mn, true, true);
            return axClass.axConstruct([message, error$$1.code]);
        };
        AXSecurityDomain.prototype.applyType = function (axClass, types) {
            var vectorProto = this.ObjectVector.axClass.superClass.dPrototype;
            if (!vectorProto.isPrototypeOf(axClass.dPrototype)) {
                this.throwError('TypeError', Errors$1.TypeAppOfNonParamType);
            }
            if (types.length !== 1) {
                this.throwError('TypeError', Errors$1.WrongTypeArgCountError, '__AS3__.vec::Vector', 1, types.length);
            }
            var type = types[0] || this.AXObject;
            return this.getVectorClass(type);
        };
        AXSecurityDomain.prototype.getVectorClass = function (type) {
            var vectorClass = this.vectorClasses.get(type);
            if (vectorClass) {
                return vectorClass;
            }
            var typeClassName = type ?
                type.classInfo.instanceInfo.getName().getMangledName() :
                '$BgObject';
            switch (typeClassName) {
                case "$BgNumber":
                case "$Bgdouble":
                    vectorClass = this.Float64Vector.axClass;
                    break;
                case "$Bgint":
                    vectorClass = this.Int32Vector.axClass;
                    break;
                case "$Bguint":
                    vectorClass = this.Uint32Vector.axClass;
                    break;
                default:
                    vectorClass = this.createVectorClass(type);
            }
            this.vectorClasses.set(type, vectorClass);
            return vectorClass;
        };
        AXSecurityDomain.prototype.createVectorClass = function (type) {
            var genericVectorClass = this.ObjectVector.axClass;
            var axClass = Object.create(genericVectorClass);
            // Put the superClass tPrototype on the prototype chain so we have access
            // to all factory protocol handlers by default.
            axClass.tPrototype = Object.create(genericVectorClass.tPrototype);
            axClass.tPrototype.axClass = axClass;
            axClass.tPrototype.axClassName = axClass.classInfo.instanceInfo.getClassName();
            // We don't need a new dPrototype object.
            axClass.dPrototype = genericVectorClass.dPrototype;
            axClass.superClass = genericVectorClass;
            axClass.type = type;
            return axClass;
        };
        /**
         * Constructs a plain vanilla object in this security domain.
         */
        AXSecurityDomain.prototype.createObject = function () {
            return Object.create(this.AXObject.tPrototype);
        };
        /**
         * Takes a JS Object and transforms it into an AXObject.
         */
        AXSecurityDomain.prototype.createObjectFromJS = function (value, deep) {
            if (deep === void 0) { deep = false; }
            var keys = Object.keys(value);
            var result = this.createObject();
            for (var i = 0; i < keys.length; i++) {
                var v = value[keys[i]];
                if (deep) {
                    v = transformJSValueToAS(this, v, true);
                }
                result.axSetPublicProperty(keys[i], v);
            }
            return result;
        };
        /**
         * Constructs an AXArray in this security domain and sets its value to the given array.
         * Warning: This doesn't handle non-indexed keys.
         */
        AXSecurityDomain.prototype.createArrayUnsafe = function (value) {
            var array = Object.create(this.AXArray.tPrototype);
            array.value = value;
            if (!release$1) { // Array values must only hold index keys.
                for (var k in value) {
                    assert(isIndex(k));
                    checkValue(value[k]);
                }
            }
            return array;
        };
        /**
         * Constructs an AXArray in this security domain and copies all enumerable properties of
         * the given array, setting them as public properties on the AXArray.
         * Warning: this does not use the given Array as the `value`.
         */
        AXSecurityDomain.prototype.createArray = function (value) {
            var array = this.createArrayUnsafe([]);
            for (var k in value) {
                array.axSetPublicProperty(k, value[k]);
                release$1 || checkValue(value[k]);
            }
            array.length = value.length;
            return array;
        };
        /**
         * Constructs an AXFunction in this security domain and sets its value to the given function.
         */
        AXSecurityDomain.prototype.boxFunction = function (value) {
            var fn = Object.create(this.AXFunction.tPrototype);
            fn.value = value;
            return fn;
        };
        AXSecurityDomain.prototype.createClass = function (classInfo, superClass, scope) {
            var instanceInfo = classInfo.instanceInfo;
            var className = instanceInfo.getName().toFQNString(false);
            var axClass = this.nativeClasses[className] ||
                Object.create(this.AXClass.tPrototype);
            var classScope = new Scope(scope, axClass);
            if (!this.nativeClasses[className]) {
                if (instanceInfo.isInterface()) {
                    axClass.dPrototype = Object.create(this.objectPrototype);
                    axClass.tPrototype = Object.create(axClass.dPrototype);
                    axClass.tPrototype.axInitializer = axInterfaceInitializer;
                    axClass.axIsInstanceOf = axIsInstanceOfInterface;
                    axClass.axIsType = axIsTypeInterface;
                }
                else {
                    // For direct descendants of Object, we want the dynamic prototype to inherit from
                    // Object's tPrototype because Foo.prototype is always a proper instance of Object.
                    // For all other cases, the dynamic prototype should extend the parent class's
                    // dynamic prototype not the tPrototype.
                    if (superClass === this.AXObject) {
                        axClass.dPrototype = Object.create(this.objectPrototype);
                    }
                    else {
                        axClass.dPrototype = Object.create(superClass.dPrototype);
                    }
                    axClass.tPrototype = Object.create(axClass.dPrototype);
                    axClass.tPrototype.axInitializer = this.createInitializerFunction(classInfo, classScope);
                }
            }
            else {
                axClass.tPrototype.axInitializer = this.createInitializerFunction(classInfo, classScope);
                // Native classes have their inheritance structure set up during initial SecurityDomain
                // creation.
                release$1 || assert(axClass.dPrototype);
                release$1 || assert(axClass.tPrototype);
            }
            axClass.classInfo = axClass.dPrototype.classInfo = classInfo;
            axClass.dPrototype.axClass = axClass;
            axClass.dPrototype.axClassName = classInfo.instanceInfo.getClassName();
            axClass.superClass = superClass;
            axClass.scope = scope;
            // Object and Class have their traits initialized earlier to avoid circular dependencies.
            if (className !== 'Object' && className !== 'Class') {
                this.initializeRuntimeTraits(axClass, superClass, classScope);
            }
            // Add the |constructor| property on the class dynamic prototype so that all instances can
            // get to their class constructor, and FooClass.prototype.constructor returns FooClass.
            defineNonEnumerableProperty(axClass.dPrototype, "$Bgconstructor", axClass);
            // Copy over all TS symbols.
            tryLinkNativeClass(axClass);
            // Run the static initializer.
            var initializer = classInfo.getInitializer();
            var initializerCode = initializer.getBody().code;
            // ... except if it's the standard class initializer that doesn't really do anything.
            if (initializerCode[0] !== 208 || initializerCode[1] !== 48 || initializerCode[2] !== 71) {
                interpret(initializer, classScope, null).apply(axClass, [axClass]);
            }
            return axClass;
        };
        AXSecurityDomain.prototype.initializeRuntimeTraits = function (axClass, superClass, scope) {
            var classInfo = axClass.classInfo;
            var instanceInfo = classInfo.instanceInfo;
            // Prepare class traits.
            var classTraits;
            if (axClass === this.AXClass) {
                classTraits = instanceInfo.traits.resolveRuntimeTraits(null, null, scope);
            }
            else {
                var rootClassTraits = this.AXClass.classInfo.instanceInfo.runtimeTraits;
                release$1 || assert(rootClassTraits);
                // Class traits don't capture the class' scope. This is relevant because it allows
                // referring to global names that would be shadowed if the class scope were active.
                // Haxe's stdlib uses just such constructs, e.g. Std.parseFloat calls the global
                // parseFloat.
                classTraits = classInfo.traits.resolveRuntimeTraits(rootClassTraits, null, scope.parent);
            }
            classInfo.runtimeTraits = classTraits;
            applyTraits(axClass, classTraits);
            // Prepare instance traits.
            var superInstanceTraits = superClass ? superClass.classInfo.instanceInfo.runtimeTraits : null;
            var protectedNs = classInfo.abc.getNamespace(instanceInfo.protectedNs);
            var instanceTraits = instanceInfo.traits.resolveRuntimeTraits(superInstanceTraits, protectedNs, scope);
            instanceInfo.runtimeTraits = instanceTraits;
            applyTraits(axClass.tPrototype, instanceTraits);
        };
        AXSecurityDomain.prototype.createFunction = function (methodInfo, scope, hasDynamicScope) {
            var traceMsg = !release$1 && flashlog && methodInfo.trait ? methodInfo.toFlashlogString() : null;
            var fun = this.boxFunction(interpret(methodInfo, scope, fun));
            //fun.methodInfo = methodInfo;
            fun.receiver = { scope: scope };
            if (!release$1) {
                try {
                    Object.defineProperty(fun.value, 'name', { value: methodInfo.getName() });
                }
                catch (e) {
                    // Ignore errors in browsers that don't allow overriding Function#length;
                }
            }
            return fun;
        };
        AXSecurityDomain.prototype.createInitializerFunction = function (classInfo, scope) {
            var methodInfo = classInfo.instanceInfo.getInitializer();
            var traceMsg = !release$1 && flashlog && methodInfo.trait ? methodInfo.toFlashlogString() : null;
            var fun = getNativeInitializer(classInfo);
            if (!fun) {
                release$1 || assert(!methodInfo.isNative(), "Must provide a native initializer for " +
                    classInfo.instanceInfo.getClassName());
                var binarySymbol = this.application.getBinarySymbol(classInfo.instanceInfo.getClassName());
                if (binarySymbol) {
                    binarySymbol.buffer = binarySymbol.data;
                    fun = function () {
                        console.log("create instance for binary data:", classInfo.instanceInfo.getClassName());
                        ByteArrayDataProvider.symbolForConstructor = binarySymbol;
                        release$1 || (traceMsg && flashlog.writeAS3Trace(methodInfo.toFlashlogString()));
                        return interpret(methodInfo, scope, null).apply(this, arguments);
                    };
                }
                else {
                    fun = interpret(methodInfo, scope, null);
                }
                if (!release$1) {
                    try {
                        var className = classInfo.instanceInfo.getName().toFQNString(false);
                        Object.defineProperty(fun, 'name', { value: className });
                    }
                    catch (e) {
                        // Ignore errors in browsers that don't allow overriding Function#length;
                    }
                }
                // REDUX: enable arg count checking on native ctors. Currently impossible because natives
                // are frozen.
                fun.methodInfo = methodInfo;
            }
            return fun;
        };
        AXSecurityDomain.prototype.createActivation = function (methodInfo, scope) {
            var body = methodInfo.getBody();
            if (!body.activationPrototype) {
                body.traits.resolve();
                body.activationPrototype = Object.create(this.AXActivationPrototype);
                defineReadOnlyProperty(body.activationPrototype, "traits", body.traits.resolveRuntimeTraits(null, null, scope));
            }
            return Object.create(body.activationPrototype);
        };
        AXSecurityDomain.prototype.createCatch = function (exceptionInfo, scope) {
            if (!exceptionInfo.catchPrototype) {
                var traits = exceptionInfo.getTraits();
                exceptionInfo.catchPrototype = Object.create(this.AXCatchPrototype);
                defineReadOnlyProperty(exceptionInfo.catchPrototype, "traits", traits.resolveRuntimeTraits(null, null, scope));
            }
            return Object.create(exceptionInfo.catchPrototype);
        };
        AXSecurityDomain.prototype.box = function (v) {
            if (v == undefined)
                return v;
            if (v.constructor === Array)
                return this.AXArray.axBox(v);
            var t = typeof v;
            if (t === "number")
                return this.AXNumber.axBox(v);
            if (t === "boolean")
                return this.AXBoolean.axBox(v);
            if (t === "string")
                return this.AXString.axBox(v);
            release$1 || assert(AXBasePrototype.isPrototypeOf(v));
            return v;
        };
        AXSecurityDomain.prototype.isPrimitive = function (v) {
            return isPrimitiveJSValue(v) || this.AXPrimitiveBox.dPrototype.isPrototypeOf(v);
        };
        AXSecurityDomain.prototype.createAXGlobal = function (applicationDomain, scriptInfo) {
            var global = Object.create(this.AXGlobalPrototype);
            global.applicationDomain = applicationDomain;
            global.scriptInfo = scriptInfo;
            var scope = global.scope = new Scope(null, global, false);
            var objectTraits = this.AXObject.classInfo.instanceInfo.runtimeTraits;
            var traits = scriptInfo.traits.resolveRuntimeTraits(objectTraits, null, scope);
            applyTraits(global, traits);
            return global;
        };
        /**
         * Prepares the dynamic Class prototype that all Class instances (including Class) have in
         * their prototype chain.
         *
         * This prototype defines the default hooks for all classes. Classes can override some or
         * all of them.
         */
        AXSecurityDomain.prototype.prepareRootClassPrototype = function () {
            var dynamicClassPrototype = Object.create(this.objectPrototype);
            var rootClassPrototype = Object.create(dynamicClassPrototype);
            rootClassPrototype.$BgtoString = function axClassToString() {
                return "[class " + this.classInfo.instanceInfo.getName().name + "]";
            };
            var D = defineNonEnumerableProperty;
            D(rootClassPrototype, "axBox", axBoxIdentity);
            D(rootClassPrototype, "axCoerce", axCoerce);
            D(rootClassPrototype, "axIsType", axIsTypeObject);
            D(rootClassPrototype, "axAsType", axAsType);
            D(rootClassPrototype, "axIsInstanceOf", axIsInstanceOfObject);
            D(rootClassPrototype, "axConstruct", axConstruct);
            D(rootClassPrototype, "axApply", axDefaultApply);
            Object.defineProperty(rootClassPrototype, 'name', {
                get: function () {
                    return this.classInfo.instanceInfo.name;
                }
            });
            this.rootClassPrototype = rootClassPrototype;
        };
        AXSecurityDomain.prototype.initializeCoreNatives = function () {
            // Some facts:
            // - The Class constructor is itself an instance of Class.
            // - The Class constructor is an instance of Object.
            // - The Object constructor is an instance of Class.
            // - The Object constructor is an instance of Object.
            this.prepareRootClassPrototype();
            var AXClass = this.prepareNativeClass("AXClass", "Class", false);
            AXClass.classInfo = this.system.findClassInfo("Class");
            AXClass.defaultValue = null;
            var AXObject = this.prepareNativeClass("AXObject", "Object", false);
            AXObject.classInfo = this.system.findClassInfo("Object");
            var AXObject = this.AXObject;
            // AXFunction needs to exist for runtime trait resolution.
            var AXFunction = this.prepareNativeClass("AXFunction", "Function", false);
            defineNonEnumerableProperty(AXFunction, "axBox", axBoxPrimitive);
            // Initialization of the core classes' traits is a messy multi-step process:
            // First, create a scope for looking up all the things.
            var scope = new Scope(null, AXClass, false);
            // Then, create the runtime traits all Object instances share.
            var objectCI = this.AXObject.classInfo;
            var objectII = objectCI.instanceInfo;
            var objectRTT = objectII.runtimeTraits = objectII.traits.resolveRuntimeTraits(null, null, scope);
            applyTraits(this.AXObject.tPrototype, objectRTT);
            // Building on that, create the runtime traits all Class instances share.
            var classCI = this.AXClass.classInfo;
            var classII = classCI.instanceInfo;
            classII.runtimeTraits = classII.traits.resolveRuntimeTraits(objectRTT, null, scope);
            applyTraits(this.AXClass.tPrototype, classII.runtimeTraits);
            // As sort of a loose end, also create the one class trait Class itself has.
            classCI.runtimeTraits = classCI.traits.resolveRuntimeTraits(objectRTT, null, scope);
            applyTraits(this.AXClass, classCI.runtimeTraits);
            // Now we can create Object's runtime class traits.
            objectCI.runtimeTraits = objectCI.traits.resolveRuntimeTraits(classII.runtimeTraits, null, scope);
            applyTraits(this.AXObject, objectCI.runtimeTraits);
            return AXObject;
        };
        AXSecurityDomain.prototype.prepareNativeClass = function (exportName, name, isPrimitiveClass) {
            var axClass = Object.create(this.rootClassPrototype);
            // For Object and Class, we've already created the instance prototype to break
            // circular dependencies.
            if (name === 'Object') {
                axClass.dPrototype = Object.getPrototypeOf(this.objectPrototype);
                axClass.tPrototype = this.objectPrototype;
            }
            else if (name === 'Class') {
                axClass.dPrototype = Object.getPrototypeOf(this.rootClassPrototype);
                axClass.tPrototype = this.rootClassPrototype;
            }
            else {
                var instancePrototype = isPrimitiveClass ?
                    this.AXPrimitiveBox.dPrototype :
                    exportName === 'AXMethodClosure' ?
                        this.AXFunction.dPrototype :
                        this.objectPrototype;
                axClass.dPrototype = Object.create(instancePrototype);
                axClass.tPrototype = Object.create(axClass.dPrototype);
            }
            this[exportName] = this.nativeClasses[name] = axClass;
            return axClass;
        };
        AXSecurityDomain.prototype.preparePrimitiveClass = function (exportName, name, convert, defaultValue, coerce, isType, isInstanceOf) {
            var axClass = this.prepareNativeClass(exportName, name, true);
            var D = defineNonEnumerableProperty;
            D(axClass, 'axBox', axBoxPrimitive);
            D(axClass, "axApply", function axApply(_, args) {
                return convert(args && args.length ? args[0] : defaultValue);
            });
            D(axClass, "axConstruct", function axConstruct$$1(args) {
                return convert(args && args.length ? args[0] : defaultValue);
            });
            D(axClass, "axCoerce", coerce);
            D(axClass, "axIsType", isType);
            D(axClass, "axIsInstanceOf", isInstanceOf);
            D(axClass.dPrototype, "value", defaultValue);
            return axClass;
        };
        /**
         * Configures all the builtin Objects.
         */
        AXSecurityDomain.prototype.initialize = function () {
            var D = defineNonEnumerableProperty;
            // The basic dynamic prototype that all objects in this security domain have in common.
            var dynamicObjectPrototype = Object.create(AXBasePrototype);
            dynamicObjectPrototype.sec = this;
            // The basic traits prototype that all objects in this security domain have in common.
            Object.defineProperty(this, 'objectPrototype', { value: Object.create(dynamicObjectPrototype) });
            this.initializeCoreNatives();
            // Debugging Helper
            release$1 || (this.objectPrototype['trace'] = function trace() {
                var self = this;
                var writer = new IndentingWriter();
                this.traits.traits.forEach(function (t) {
                    writer.writeLn(t + ": " + self[t.getName().getMangledName()]);
                });
            });
            this.AXGlobalPrototype = Object.create(this.objectPrototype);
            this.AXGlobalPrototype.$BgtoString = function () {
                return '[object global]';
            };
            this.AXActivationPrototype = Object.create(this.objectPrototype);
            this.AXActivationPrototype.$BgtoString = function () {
                return '[Activation]';
            };
            this.AXCatchPrototype = Object.create(this.objectPrototype);
            this.AXCatchPrototype.$BgtoString = function () {
                return '[Catch]';
            };
            // The core classes' MOP hooks and dynamic prototype methods are defined
            // here to keep all the hooks initialization in one place.
            var AXObject = this.AXObject;
            var AXFunction = this.AXFunction;
            // Object(null) creates an object, and this behaves differently than:
            // (function (x: Object) { trace (x); })(null) which prints null.
            D(AXObject, "axApply", axApplyObject);
            D(AXObject, "axConstruct", axConstructObject);
            D(AXObject.tPrototype, "axInitializer", axDefaultInitializer);
            D(AXObject, "axCoerce", axCoerceObject);
            this.prepareNativeClass("AXMethodClosure", "builtin.as$0.MethodClosure", false);
            this.prepareNativeClass("AXError", "Error", false);
            this.prepareNativeClass("AXMath", "Math", false);
            this.prepareNativeClass("AXDate", "Date", false);
            this.prepareNativeClass("AXXML", "XML", false);
            this.prepareNativeClass("AXXMLList", "XMLList", false);
            this.prepareNativeClass("AXQName", "QName", false);
            this.prepareNativeClass("AXNamespace", "Namespace", false);
            var AXArray = this.prepareNativeClass("AXArray", "Array", false);
            D(AXArray, 'axBox', axBoxPrimitive);
            AXArray.tPrototype.$BgtoString = AXFunction.axBox(function () {
                return this.value.toString();
            });
            // Array.prototype is an Array, and behaves like one.
            AXArray.dPrototype['value'] = [];
            this.argumentsPrototype = Object.create(this.AXArray.tPrototype);
            Object.defineProperty(this.argumentsPrototype, '$Bgcallee', { get: axGetArgumentsCallee });
            var AXRegExp = this.prepareNativeClass("AXRegExp", "RegExp", false);
            // RegExp.prototype is an (empty string matching) RegExp, and behaves like one.
            AXRegExp.dPrototype['value'] = /(?:)/;
            // Boolean, int, Number, String, and uint are primitives in AS3. We create a placeholder
            // base class to help us with instanceof tests.
            var AXPrimitiveBox = this.prepareNativeClass("AXPrimitiveBox", "PrimitiveBox", false);
            D(AXPrimitiveBox.dPrototype, '$BgtoString', AXFunction.axBox(function () { return this.value.toString(); }));
            var AXBoolean = this.preparePrimitiveClass("AXBoolean", "Boolean", axCoerceBoolean, false, axCoerceBoolean, axIsTypeBoolean, axIsTypeBoolean);
            var AXString = this.preparePrimitiveClass("AXString", "String", axConvertString, '', axCoerceString$3, axIsTypeString, axIsTypeString);
            var AXNumber = this.preparePrimitiveClass("AXNumber", "Number", axCoerceNumber, 0, axCoerceNumber, axIsTypeNumber, axIsTypeNumber);
            var AXInt = this.preparePrimitiveClass("AXInt", "int", axCoerceInt, 0, axCoerceInt, axIsTypeInt, axFalse);
            var AXUint = this.preparePrimitiveClass("AXUint", "uint", axCoerceUint, 0, axCoerceUint, axIsTypeUint, axFalse);
            // Install class loaders on the security domain.
            installClassLoaders(this.application, this);
            installNativeFunctions(this);
        };
        return AXSecurityDomain;
    }());

    var AVM2LoadLibrariesFlags;
    (function (AVM2LoadLibrariesFlags) {
        AVM2LoadLibrariesFlags[AVM2LoadLibrariesFlags["Builtin"] = 1] = "Builtin";
        AVM2LoadLibrariesFlags[AVM2LoadLibrariesFlags["Playerglobal"] = 2] = "Playerglobal";
        AVM2LoadLibrariesFlags[AVM2LoadLibrariesFlags["Shell"] = 4] = "Shell";
    })(AVM2LoadLibrariesFlags || (AVM2LoadLibrariesFlags = {}));
    function createSecurityDomain(libraries) {
        var result = new PromiseWrapper();
        console.log("createSecurityDomain");
        release$1 || assert$2(!!(libraries & AVM2LoadLibrariesFlags.Builtin));
        console.log("Load builton.abc file");
        BrowserSystemResourcesLoadingService.getInstance()
            .load("./assets/builtins/builtin.abc", "arraybuffer")
            .then(function (buffer) {
            var sec = new AXSecurityDomain();
            var env = { url: "builtin.abc", app: sec.system };
            var builtinABC = new ABCFile(env, new Uint8Array(buffer));
            sec.system.loadABC(builtinABC);
            sec.initialize();
            sec.system.executeABC(builtinABC);
            //SWF.leaveTimeline();
            //// If library is shell.abc, then just go ahead and run it now since
            //// it's not worth doing it lazily given that it is so small.
            //if (!!(libraries & AVM2LoadLibrariesFlags.Shell)) {
            //  var shellABC = new Shumway.AVMX.ABCFile(new Uint8Array(buffer));
            //  sec.system.loadAndExecuteABC(shellABC);
            //  result.resolve(sec);
            //  SystemResourcesLoadingService.instance.load(SystemResourceId.ShellAbc).then(function (buffer) {
            //    var shellABC = new Shumway.AVMX.ABCFile(new Uint8Array(buffer));
            //    sec.system.loadAndExecuteABC(shellABC);
            //    result.resolve(sec);
            //  }, result.reject);
            //  return;
            //}
            if (!!(libraries & AVM2LoadLibrariesFlags.Playerglobal)) {
                return Promise.all([
                    BrowserSystemResourcesLoadingService.getInstance().load("./assets/builtins/playerglobal.abcs", "arraybuffer"),
                    BrowserSystemResourcesLoadingService.getInstance().load("./assets/builtins/playerglobal.json", "json")
                ]).then(function (results) {
                    console.log("Load playerglobal.abcs & playerglobal.json");
                    var catalog = new ABCCatalog(sec.system, new Uint8Array(results[0]), results[1]);
                    console.log("add playerglobals as ABCCatalog");
                    sec.addCatalog(catalog);
                    BrowserSystemResourcesLoadingService.getInstance()
                        .load("./assets/builtins/avmplus.abc", "arraybuffer")
                        .then(function (buffer) {
                        //var sec = new AXSecurityDomain();
                        var env = { url: "avmplus.File", app: sec.system };
                        var avmPlusABC = new ABCFile(env, new Uint8Array(buffer));
                        sec.system.loadABC(avmPlusABC);
                        //sec.initialize();
                        sec.system.executeABC(avmPlusABC);
                        result.resolve(sec);
                    }, result.reject);
                }, result.reject);
            }
            result.resolve(sec);
        }, result.reject);
        return result.promise;
    }

    var ASClass$1 = /** @class */ (function (_super) {
        __extends(ASClass, _super);
        function ASClass() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ASClass.prototype.axCoerce = function (v) {
            return v;
        };
        Object.defineProperty(ASClass.prototype, "prototype", {
            get: function () {
                release$1 || assert(this.dPrototype);
                return this.dPrototype;
            },
            enumerable: true,
            configurable: true
        });
        ASClass.classInitializer = null;
        return ASClass;
    }(ASObject$1));

    function ensureBoxedReceiver(sec, receiver, callable) {
        if (receiver && typeof receiver === 'object') {
            release$1 || checkValue(receiver);
            return receiver;
        }
        var boxedReceiver = sec.box(receiver);
        // Boxing still leaves `null` and `undefined` unboxed, so return the current global instead.
        if (!boxedReceiver) {
            if (scopeStacks.length) {
                boxedReceiver = scopeStacks[scopeStacks.length - 1].topScope().global.object;
            }
            else if (callable.receiver) {
                // If no scripts are on the stack (e.g., for ExternalInterface calls), use the function's
                // own global.
                boxedReceiver = callable.receiver.scope.global.object;
            }
        }
        return boxedReceiver;
    }

    var ASFunction$1 = /** @class */ (function (_super) {
        __extends(ASFunction, _super);
        function ASFunction() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this._prototypeInitialzed = false;
            return _this;
        }
        ASFunction.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = ASFunction.prototype;
            addPrototypeFunctionAlias(proto, "$BgtoString", asProto.toString);
            addPrototypeFunctionAlias(proto, "$Bgcall", asProto.call);
            addPrototypeFunctionAlias(proto, "$Bgapply", asProto.apply);
            defineNonEnumerableProperty(proto, "value", asProto.native_functionValue);
        };
        ASFunction.prototype.setReceiver = function (receiver) {
            this.receiver = receiver;
        };
        ASFunction.prototype.axConstruct = function (args) {
            var prototype = this.prototype;
            // AS3 allows setting null/undefined prototypes. In order to make our value checking work,
            // we need to set a null-prototype that has the right inheritance chain. Since AS3 doesn't
            // have `__proto__` or `getPrototypeOf`, this is completely hidden from content.
            if (isNullOrUndefined(prototype)) {
                prototype = this.sec.AXFunctionUndefinedPrototype;
            }
            release$1 || assert(typeof prototype === 'object');
            release$1 || checkValue(prototype);
            var object = Object.create(prototype);
            object.__ctorFunction = this;
            this.value.apply(object, args);
            return object;
        };
        ASFunction.prototype.axIsInstanceOf = function (obj) {
            return obj && obj.__ctorFunction === this;
        };
        ASFunction.prototype.native_functionValue = function () {
            // Empty base function.
        };
        Object.defineProperty(ASFunction.prototype, "prototype", {
            get: function () {
                if (!this._prototypeInitialzed) {
                    this._prototype = Object.create(this.sec.AXObject.tPrototype);
                    this._prototypeInitialzed = true;
                }
                return this._prototype;
            },
            set: function (prototype) {
                if (isNullOrUndefined(prototype)) {
                    prototype = undefined;
                }
                else if (typeof prototype !== 'object' || this.sec.isPrimitive(prototype)) {
                    this.sec.throwError('TypeError', Errors$1.PrototypeTypeError);
                }
                this._prototypeInitialzed = true;
                this._prototype = prototype;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASFunction.prototype, "length", {
            get: function () {
                if (this.value.methodInfo) {
                    return this.value.methodInfo.parameters.length;
                }
                return this.value.length;
            },
            enumerable: true,
            configurable: true
        });
        ASFunction.prototype.toString = function () {
            return "function Function() {}";
        };
        ASFunction.prototype.call = function (thisArg) {
            thisArg = ensureBoxedReceiver(this.sec, thisArg, this);
            return this.value.apply(thisArg, sliceArguments(arguments, 1));
        };
        ASFunction.prototype.apply = function (thisArg, argArray) {
            thisArg = ensureBoxedReceiver(this.sec, thisArg, this);
            return this.value.apply(thisArg, argArray ? argArray.value : undefined);
        };
        ASFunction.prototype.axCall = function (thisArg) {
            return this.value.apply(thisArg, sliceArguments(arguments, 1));
        };
        ASFunction.prototype.axApply = function (thisArg, argArray) {
            return this.value.apply(thisArg, argArray);
        };
        return ASFunction;
    }(ASObject$1));

    var ASMethodClosure = /** @class */ (function (_super) {
        __extends(ASMethodClosure, _super);
        function ASMethodClosure() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ASMethodClosure.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = ASMethodClosure.prototype;
            defineNonEnumerableProperty(proto, '$Bgcall', asProto.call);
            defineNonEnumerableProperty(proto, '$Bgapply', asProto.apply);
        };
        ASMethodClosure.Create = function (receiver, method) {
            var closure = Object.create(this.sec.AXMethodClosure.tPrototype);
            closure.receiver = receiver;
            closure.value = method;
            closure.methodInfo = method.methodInfo;
            return closure;
        };
        Object.defineProperty(ASMethodClosure.prototype, "prototype", {
            get: function () {
                return null;
            },
            set: function (prototype) {
                this.sec.throwError("ReferenceError", Errors$1.ConstWriteError, "prototype", "MethodClosure");
            },
            enumerable: true,
            configurable: true
        });
        ASMethodClosure.prototype.axCall = function (ignoredThisArg) {
            return this.value.apply(this.receiver, sliceArguments(arguments, 1));
        };
        ASMethodClosure.prototype.axApply = function (ignoredThisArg, argArray) {
            return this.value.apply(this.receiver, argArray);
        };
        ASMethodClosure.prototype.call = function (ignoredThisArg) {
            return this.value.apply(this.receiver, sliceArguments(arguments, 1));
        };
        ASMethodClosure.prototype.apply = function (ignoredThisArg, argArray) {
            return this.value.apply(this.receiver, argArray ? argArray.value : undefined);
        };
        return ASMethodClosure;
    }(ASFunction$1));

    var ASInt = /** @class */ (function (_super) {
        __extends(ASInt, _super);
        function ASInt() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ASInt.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = ASInt.prototype;
            addPrototypeFunctionAlias(proto, '$BgtoString', asProto.toString);
            addPrototypeFunctionAlias(proto, '$BgtoLocaleString', asProto.toString);
            addPrototypeFunctionAlias(proto, '$BgvalueOf', asProto.valueOf);
            defineNonEnumerableProperty(this, '$BgMAX_VALUE', 0x7fffffff);
            defineNonEnumerableProperty(this, '$BgMIN_VALUE', -0x80000000);
        };
        ASInt.prototype.toString = function (radix) {
            if (arguments.length === 0) {
                radix = 10;
            }
            else {
                radix = radix | 0;
                if (radix < 2 || radix > 36) {
                    this.sec.throwError('RangeError', Errors$1.InvalidRadixError, radix);
                }
            }
            if (this.axClass !== this.sec.AXNumber) {
                this.sec.throwError('TypeError', Errors$1.InvokeOnIncompatibleObjectError, 'Number.prototype.toString');
            }
            return this.value.toString(radix);
        };
        ASInt.prototype.valueOf = function () {
            if (this.axClass !== this.sec.AXNumber) {
                this.sec.throwError('TypeError', Errors$1.InvokeOnIncompatibleObjectError, 'Number.prototype.valueOf');
            }
            return this.value;
        };
        ASInt.staticNatives = [Math];
        ASInt.instanceNatives = [ASNumber$1.prototype];
        return ASInt;
    }(ASNumber$1));

    function transformJStoASRegExpMatchArray(sec, value) {
        var result = sec.createArray(value);
        result.axSetPublicProperty('index', value.index);
        result.axSetPublicProperty('input', value.input);
        return result;
    }

    /**
     * AS3 has a bug when converting a certain character range to lower case.
     */
    function as3ToLowerCase(value) {
        var chars = null;
        for (var i = 0; i < value.length; i++) {
            var charCode = value.charCodeAt(i);
            if (charCode >= 0x10A0 && charCode <= 0x10C5) {
                if (!chars) {
                    chars = new Array(value.length);
                }
                chars[i] = String.fromCharCode(charCode + 48);
            }
        }
        if (chars) {
            // Fill in remaining chars if the bug needs to be emulated.
            for (var i = 0; i < chars.length; i++) {
                var char = chars[i];
                if (!char) {
                    chars[i] = value.charAt(i).toLocaleString();
                }
            }
            return chars.join("");
        }
        return value.toLowerCase();
    }

    var ASString$1 = /** @class */ (function (_super) {
        __extends(ASString, _super);
        function ASString() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ASString.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = ASString.prototype;
            addPrototypeFunctionAlias(proto, '$BgindexOf', asProto.generic_indexOf);
            addPrototypeFunctionAlias(proto, '$BglastIndexOf', asProto.generic_lastIndexOf);
            addPrototypeFunctionAlias(proto, '$BgcharAt', asProto.generic_charAt);
            addPrototypeFunctionAlias(proto, '$BgcharCodeAt', asProto.generic_charCodeAt);
            addPrototypeFunctionAlias(proto, '$Bgconcat', asProto.generic_concat);
            addPrototypeFunctionAlias(proto, '$BglocaleCompare', asProto.generic_localeCompare);
            addPrototypeFunctionAlias(proto, '$Bgmatch', asProto.generic_match);
            addPrototypeFunctionAlias(proto, '$Bgreplace', asProto.generic_replace);
            addPrototypeFunctionAlias(proto, '$Bgsearch', asProto.generic_search);
            addPrototypeFunctionAlias(proto, '$Bgslice', asProto.generic_slice);
            addPrototypeFunctionAlias(proto, '$Bgsplit', asProto.generic_split);
            addPrototypeFunctionAlias(proto, '$Bgsubstring', asProto.generic_substring);
            addPrototypeFunctionAlias(proto, '$Bgsubstr', asProto.generic_substr);
            addPrototypeFunctionAlias(proto, '$BgtoLowerCase', asProto.generic_toLowerCase);
            addPrototypeFunctionAlias(proto, '$BgtoLocaleLowerCase', asProto.generic_toLowerCase);
            addPrototypeFunctionAlias(proto, '$BgtoUpperCase', asProto.generic_toUpperCase);
            addPrototypeFunctionAlias(proto, '$BgtoLocaleUpperCase', asProto.generic_toUpperCase);
            addPrototypeFunctionAlias(proto, '$BgtoString', asProto.toString);
            addPrototypeFunctionAlias(proto, '$BgtoString', asProto.public_toString);
            addPrototypeFunctionAlias(proto, '$BgvalueOf', asProto.public_valueOf);
            addPrototypeFunctionAlias(this, '$BgfromCharCode', ASString.fromCharCode);
        };
        ASString.fromCharCode = function () {
            var charcodes = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                charcodes[_i] = arguments[_i];
            }
            return String.fromCharCode.apply(null, charcodes);
        };
        ASString.prototype.indexOf = function (char, i) {
            return this.value.indexOf(char, i);
        };
        ASString.prototype.lastIndexOf = function (char, i) {
            return this.value.lastIndexOf(char, i);
        };
        ASString.prototype.charAt = function (index) {
            return this.value.charAt(index);
        };
        ASString.prototype.charCodeAt = function (index) {
            return this.value.charCodeAt(index);
        };
        ASString.prototype.concat = function () {
            return this.value.concat.apply(this.value, arguments);
        };
        ASString.prototype.localeCompare = function (other) {
            if (arguments.length > 1) {
                this.sec.throwError('ArgumentError', Errors$1.WrongArgumentCountError, 'Function/<anonymous>()', 0, 2);
            }
            var value = this.value;
            release$1 || assert(typeof this.value === 'string');
            other = String(other);
            if (other === value) {
                return 0;
            }
            var len = Math.min(value.length, other.length);
            for (var j = 0; j < len; j++) {
                if (value[j] !== other[j]) {
                    return value.charCodeAt(j) - other.charCodeAt(j);
                }
            }
            return value.length > other.length ? 1 : -1;
        };
        ASString.prototype.match = function (pattern /* : string | ASRegExp */) {
            if (this.sec.AXRegExp.axIsType(pattern)) {
                pattern = pattern.value;
            }
            else {
                pattern = axCoerceString$3(pattern);
            }
            var result = this.value.match(pattern);
            if (!result) {
                return null;
            }
            try {
                return transformJStoASRegExpMatchArray(this.sec, result);
            }
            catch (e) {
                return null;
            }
        };
        ASString.prototype.replace = function (pattern /* : string | ASRegExp */, repl /* : string | ASFunction */) {
            if (this.sec.AXRegExp.axIsType(pattern)) {
                pattern = pattern.value;
            }
            else {
                pattern = axCoerceString$3(pattern);
            }
            if (this.sec.AXFunction.axIsType(repl)) {
                repl = repl.value;
            }
            try {
                return this.value.replace(pattern, repl);
            }
            catch (e) {
                return this.value;
            }
        };
        ASString.prototype.search = function (pattern /* : string | ASRegExp */) {
            if (this.sec.AXRegExp.axIsType(pattern)) {
                pattern = pattern.value;
            }
            else {
                pattern = axCoerceString$3(pattern);
            }
            try {
                return this.value.search(pattern);
            }
            catch (e) {
                return -1;
            }
        };
        ASString.prototype.slice = function (start, end) {
            start = arguments.length < 1 ? 0 : start | 0;
            end = arguments.length < 2 ? 0xffffffff : end | 0;
            return this.value.slice(start, end);
        };
        ASString.prototype.split = function (separator /* : string | ASRegExp */, limit) {
            if (this.sec.AXRegExp.axIsType(separator)) {
                separator = separator.value;
            }
            else {
                separator = axCoerceString$3(separator);
            }
            limit = limit === undefined ? -1 : limit | 0;
            try {
                return this.sec.createArray(this.value.split(separator, limit));
            }
            catch (e) {
                return this.sec.createArrayUnsafe([this.value]);
            }
        };
        ASString.prototype.substring = function (start, end) {
            return this.value.substring(start, end);
        };
        ASString.prototype.substr = function (from, length) {
            return this.value.substr(from, length);
        };
        ASString.prototype.toLocaleLowerCase = function () {
            return this.value.toLowerCase();
        };
        ASString.prototype.toLowerCase = function () {
            if (as3Compatibility) {
                return as3ToLowerCase(this.value);
            }
            return this.value.toLowerCase();
        };
        ASString.prototype.toLocaleUpperCase = function () {
            return this.value.toUpperCase();
        };
        ASString.prototype.toUpperCase = function () {
            return this.value.toUpperCase();
        };
        // The String.prototype versions of these methods are generic, so the implementation is
        // different.
        ASString.prototype.generic_indexOf = function (char, i) {
            var receiver = this == undefined ? '' : this;
            return String.prototype.indexOf.call(receiver, char, i);
        };
        ASString.prototype.generic_lastIndexOf = function (char, i) {
            var receiver = this == undefined ? '' : this;
            return String.prototype.lastIndexOf.call(receiver, char, i);
        };
        ASString.prototype.generic_charAt = function (index) {
            var receiver = this == undefined ? '' : this;
            return String.prototype.charAt.call(receiver, index);
        };
        ASString.prototype.generic_charCodeAt = function (index) {
            var receiver = this == undefined ? '' : this;
            return String.prototype.charCodeAt.call(receiver, index);
        };
        ASString.prototype.generic_concat = function () {
            var receiver = this == undefined ? '' : this;
            return String.prototype.concat.apply(receiver, arguments);
        };
        ASString.prototype.generic_localeCompare = function (other) {
            var receiver = this.sec.AXString.axBox(String(this));
            return receiver.localeCompare.apply(receiver, arguments);
        };
        ASString.prototype.generic_match = function (pattern) {
            return this.sec.AXString.axBox(String(this)).match(pattern);
        };
        ASString.prototype.generic_replace = function (pattern, repl) {
            return this.sec.AXString.axBox(String(this)).replace(pattern, repl);
        };
        ASString.prototype.generic_search = function (pattern) {
            return this.sec.AXString.axBox(String(this)).search(pattern);
        };
        ASString.prototype.generic_slice = function (start, end) {
            var receiver = this == undefined ? '' : this;
            return String.prototype.slice.call(receiver, start, end);
        };
        ASString.prototype.generic_split = function (separator, limit) {
            limit = arguments.length < 2 ? 0xffffffff : limit | 0;
            return this.sec.AXString.axBox(String(this)).split(separator, limit);
        };
        ASString.prototype.generic_substring = function (start, end) {
            var receiver = this == undefined ? '' : this;
            return String.prototype.substring.call(receiver, start, end);
        };
        ASString.prototype.generic_substr = function (from, length) {
            var receiver = this == undefined ? '' : this;
            return String.prototype.substr.call(receiver, from, length);
        };
        ASString.prototype.generic_toLowerCase = function () {
            var receiver = this == undefined ? '' : this;
            if (as3Compatibility) {
                return as3ToLowerCase(String(receiver));
            }
            String.prototype.toLowerCase.call(receiver);
        };
        ASString.prototype.generic_toUpperCase = function () {
            var receiver = this == undefined ? '' : this;
            return String.prototype.toUpperCase.call(receiver);
        };
        ASString.prototype.toString = function () {
            return this.value.toString();
        };
        ASString.prototype.public_toString = function () {
            if (this === this.sec.AXString.dPrototype) {
                return '';
            }
            if (this.axClass !== this.sec.AXString) {
                this.sec.throwError('TypeError', Errors$1.InvokeOnIncompatibleObjectError, 'String.prototype.toString');
            }
            return this.value.toString();
        };
        ASString.prototype.valueOf = function () {
            return this.value.valueOf();
        };
        ASString.prototype.public_valueOf = function () {
            if (this === this.sec.AXString.dPrototype) {
                return '';
            }
            if (this.axClass !== this.sec.AXString) {
                this.sec.throwError('TypeError', Errors$1.InvokeOnIncompatibleObjectError, 'String.prototype.valueOf');
            }
            return this.value.valueOf();
        };
        Object.defineProperty(ASString.prototype, "length", {
            get: function () {
                return this.value.length;
            },
            enumerable: true,
            configurable: true
        });
        ASString.classNatives = [String];
        return ASString;
    }(ASObject$1));

    var ASUint = /** @class */ (function (_super) {
        __extends(ASUint, _super);
        function ASUint() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ASUint.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = ASUint.prototype;
            addPrototypeFunctionAlias(proto, '$BgtoString', asProto.toString);
            addPrototypeFunctionAlias(proto, '$BgtoLocaleString', asProto.toString);
            addPrototypeFunctionAlias(proto, '$BgvalueOf', asProto.valueOf);
            defineNonEnumerableProperty(this, '$BgMAX_VALUE', 0xffffffff);
            defineNonEnumerableProperty(this, '$BgMIN_VALUE', 0);
        };
        ASUint.prototype.toString = function (radix) {
            if (arguments.length === 0) {
                radix = 10;
            }
            else {
                radix = radix | 0;
                if (radix < 2 || radix > 36) {
                    this.sec.throwError('RangeError', Errors$1.InvalidRadixError, radix);
                }
            }
            if (this.axClass !== this.sec.AXNumber) {
                this.sec.throwError('TypeError', Errors$1.InvokeOnIncompatibleObjectError, 'Number.prototype.toString');
            }
            return this.value.toString(radix);
        };
        ASUint.prototype.valueOf = function () {
            if (this.axClass !== this.sec.AXNumber) {
                this.sec.throwError('TypeError', Errors$1.InvokeOnIncompatibleObjectError, 'Number.prototype.valueOf');
            }
            return this.value;
        };
        ASUint.staticNatives = [Math];
        ASUint.instanceNatives = [ASNumber$1.prototype];
        return ASUint;
    }(ASNumber$1));

    var ASBoolean$1 = /** @class */ (function (_super) {
        __extends(ASBoolean, _super);
        function ASBoolean() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ASBoolean.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = ASBoolean.prototype;
            addPrototypeFunctionAlias(proto, '$BgtoString', asProto.toString);
            addPrototypeFunctionAlias(proto, '$BgvalueOf', asProto.valueOf);
        };
        ASBoolean.prototype.toString = function () {
            return this.value.toString();
        };
        ASBoolean.prototype.valueOf = function () {
            return this.value.valueOf();
        };
        return ASBoolean;
    }(ASObject$1));

    function coerceArray(obj) {
        if (!obj || !obj.sec) {
            throw new TypeError('Conversion to Array failed');
        }
        return obj.sec.AXArray.axCoerce(obj);
    }

    function createArrayValueFromArgs(sec, args) {
        if (args.length === 1 && typeof args[0] === 'number') {
            var len = args[0];
            try {
                return new Array(len);
            }
            catch (e) {
                sec.throwError('RangeError', Errors$1.ArrayIndexNotIntegerError, len);
            }
        }
        return Array.apply(Array, args);
    }

    function axDefaultCompareFunction(a, b) {
        return String(a).localeCompare(String(b));
    }

    function axCompare(a, b, options, sortOrder, compareFunction) {
        release$1 || assertNotImplemented(!(options & 4 /* UNIQUESORT */), "UNIQUESORT");
        release$1 || assertNotImplemented(!(options & 8 /* RETURNINDEXEDARRAY */), "RETURNINDEXEDARRAY");
        var result = 0;
        if (options & 1 /* CASEINSENSITIVE */) {
            a = String(a).toLowerCase();
            b = String(b).toLowerCase();
        }
        if (options & 16 /* NUMERIC */) {
            a = +a;
            b = +b;
            result = a < b ? -1 : (a > b ? 1 : 0);
        }
        else {
            result = compareFunction(a, b);
        }
        return result * sortOrder;
    }

    function axCompareFields(objA, objB, names, optionsList) {
        release$1 || assert(names.length === optionsList.length);
        release$1 || assert(names.length > 0);
        var result = 0;
        var i;
        for (i = 0; i < names.length && result === 0; i++) {
            var name = names[i];
            var a = objA[name];
            var b = objB[name];
            var options = optionsList[i];
            if (options & 1 /* CASEINSENSITIVE */) {
                a = String(a).toLowerCase();
                b = String(b).toLowerCase();
            }
            if (options & 16 /* NUMERIC */) {
                a = +a;
                b = +b;
                result = a < b ? -1 : (a > b ? 1 : 0);
            }
            else {
                result = String(a).localeCompare(String(b));
            }
        }
        if (optionsList[i - 1] & 2 /* DESCENDING */) {
            result *= -1;
        }
        return result;
    }

    var ASArray$1 = /** @class */ (function (_super) {
        __extends(ASArray, _super);
        function ASArray() {
            var _this = _super.call(this) || this;
            _this.value = createArrayValueFromArgs(_this.sec, arguments);
            return _this;
        }
        ASArray.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = ASArray.prototype;
            // option flags for sort and sortOn
            defineNonEnumerableProperty(this, '$BgCASEINSENSITIVE', 1);
            defineNonEnumerableProperty(this, '$BgDESCENDING', 2);
            defineNonEnumerableProperty(this, '$BgUNIQUESORT', 4);
            defineNonEnumerableProperty(this, '$BgRETURNINDEXEDARRAY', 8);
            defineNonEnumerableProperty(this, '$BgNUMERIC', 16);
            addPrototypeFunctionAlias(proto, "$Bgpush", asProto.generic_push);
            addPrototypeFunctionAlias(proto, "$Bgpop", asProto.generic_pop);
            addPrototypeFunctionAlias(proto, "$Bgshift", asProto.generic_shift);
            addPrototypeFunctionAlias(proto, "$Bgunshift", asProto.generic_unshift);
            addPrototypeFunctionAlias(proto, "$Bgreverse", asProto.generic_reverse);
            addPrototypeFunctionAlias(proto, "$Bgconcat", asProto.generic_concat);
            addPrototypeFunctionAlias(proto, "$Bgslice", asProto.generic_slice);
            addPrototypeFunctionAlias(proto, "$Bgsplice", asProto.generic_splice);
            addPrototypeFunctionAlias(proto, "$Bgjoin", asProto.generic_join);
            addPrototypeFunctionAlias(proto, "$BgtoString", asProto.generic_toString);
            addPrototypeFunctionAlias(proto, "$BgindexOf", asProto.generic_indexOf);
            addPrototypeFunctionAlias(proto, "$BglastIndexOf", asProto.generic_lastIndexOf);
            addPrototypeFunctionAlias(proto, "$Bgevery", asProto.generic_every);
            addPrototypeFunctionAlias(proto, "$Bgsome", asProto.generic_some);
            addPrototypeFunctionAlias(proto, "$BgforEach", asProto.generic_forEach);
            addPrototypeFunctionAlias(proto, "$Bgmap", asProto.generic_map);
            addPrototypeFunctionAlias(proto, "$Bgfilter", asProto.generic_filter);
            addPrototypeFunctionAlias(proto, "$Bgsort", asProto.generic_sort);
            addPrototypeFunctionAlias(proto, "$BgsortOn", asProto.generic_sortOn);
            addPrototypeFunctionAlias(proto, "$BghasOwnProperty", asProto.native_hasOwnProperty);
            addPrototypeFunctionAlias(proto, "$BgpropertyIsEnumerable", asProto.native_propertyIsEnumerable);
            addPrototypeFunctionAlias(proto, '$BgtoLocaleString', asProto.generic_toString);
        };
        ASArray.prototype.native_hasOwnProperty = function (nm) {
            return this.axHasOwnProperty(makeMultiname(nm));
        };
        ASArray.prototype.native_propertyIsEnumerable = function (nm) {
            if (typeof nm === 'number' || isNumeric(nm = axCoerceName(nm))) {
                var descriptor = Object.getOwnPropertyDescriptor(this.value, nm);
                return !!descriptor && descriptor.enumerable;
            }
            _super.prototype.native_propertyIsEnumerable.call(this, nm);
        };
        ASArray.axApply = function (self, args) {
            return this.sec.createArrayUnsafe(createArrayValueFromArgs(this.sec, args));
        };
        ASArray.axConstruct = function (args) {
            return this.sec.createArrayUnsafe(createArrayValueFromArgs(this.sec, args));
        };
        ASArray.prototype.push = function () {
            // Amazingly, AS3 doesn't throw an error if `push` would make the argument too large.
            // Instead, it just replaces the last element.
            if (this.value.length + arguments.length > 0xffffffff) {
                var limit = 0xffffffff - this.value.length;
                for (var i = 0; i < limit; i++) {
                    this.value.push(arguments[i]);
                }
                return 0xffffffff;
            }
            return this.value.push.apply(this.value, arguments);
        };
        ASArray.prototype.generic_push = function () {
            if (this && this.value instanceof Array) {
                return this.push.apply(this, arguments);
            }
            var n = this.axGetPublicProperty('length') >>> 0;
            for (var i = 0; i < arguments.length; i++) {
                this.axSetNumericProperty(n++, arguments[i]);
            }
            this.axSetPublicProperty('length', n);
            return n;
        };
        ASArray.prototype.pop = function () {
            return this.value.pop();
        };
        ASArray.prototype.generic_pop = function () {
            if (this && this.value instanceof Array) {
                return this.value.pop();
            }
            var len = this.axGetPublicProperty('length') >>> 0;
            if (!len) {
                this.axSetPublicProperty('length', 0);
                return;
            }
            var retVal = this.axGetNumericProperty(len - 1);
            rn.name = len - 1;
            rn.namespaces = [Namespace.PUBLIC];
            this.axDeleteProperty(rn);
            this.axSetPublicProperty('length', len - 1);
            return retVal;
        };
        ASArray.prototype.shift = function () {
            return this.value.shift();
        };
        ASArray.prototype.generic_shift = function () {
            return coerceArray(this).shift();
        };
        ASArray.prototype.unshift = function () {
            return this.value.unshift.apply(this.value, arguments);
        };
        ASArray.prototype.generic_unshift = function () {
            var self = coerceArray(this);
            return self.value.unshift.apply(self.value, arguments);
        };
        ASArray.prototype.reverse = function () {
            this.value.reverse();
            return this;
        };
        ASArray.prototype.generic_reverse = function () {
            return coerceArray(this).reverse();
        };
        ASArray.prototype.concat = function () {
            var value = this.value.slice();
            for (var i = 0; i < arguments.length; i++) {
                var a = arguments[i];
                // Treat all objects with a `sec` property and a value that's an Array as
                // concat-spreadable.
                // TODO: verify that this is correct.
                if (typeof a === 'object' && a && a.sec && Array.isArray(a.value)) {
                    value.push.apply(value, a.value);
                }
                else {
                    value.push(a);
                }
            }
            return this.sec.createArrayUnsafe(value);
        };
        ASArray.prototype.generic_concat = function () {
            return coerceArray(this).concat.apply(this, arguments);
        };
        ASArray.prototype.slice = function (startIndex, endIndex) {
            return this.sec.createArray(this.value.slice(startIndex, endIndex));
        };
        ASArray.prototype.generic_slice = function (startIndex, endIndex) {
            return coerceArray(this).slice(startIndex, endIndex);
        };
        ASArray.prototype.splice = function () {
            var o = this.value;
            if (arguments.length === 0) {
                return undefined;
            }
            return this.sec.createArray(o.splice.apply(o, arguments));
        };
        ASArray.prototype.generic_splice = function () {
            return coerceArray(this).splice.apply(this, arguments);
        };
        ASArray.prototype.join = function (sep) {
            return this.value.join(sep);
        };
        ASArray.prototype.generic_join = function (sep) {
            return coerceArray(this).join(sep);
        };
        ASArray.prototype.toString = function () {
            return this.value.join(',');
        };
        ASArray.prototype.generic_toString = function () {
            return coerceArray(this).join(',');
        };
        ASArray.prototype.indexOf = function (value, fromIndex) {
            return this.value.indexOf(value, fromIndex | 0);
        };
        ASArray.prototype.generic_indexOf = function (value, fromIndex) {
            return coerceArray(this).indexOf(value, fromIndex | 0);
        };
        ASArray.prototype.lastIndexOf = function (value, fromIndex) {
            return this.value.lastIndexOf(value, arguments.length > 1 ? fromIndex : 0x7fffffff);
        };
        ASArray.prototype.generic_lastIndexOf = function (value, fromIndex) {
            return coerceArray(this).lastIndexOf(value, arguments.length > 1 ? fromIndex : 0x7fffffff);
        };
        ASArray.prototype.every = function (callbackfn, thisArg) {
            if (!callbackfn || !callbackfn.value || typeof callbackfn.value !== 'function') {
                return true;
            }
            thisArg = ensureBoxedReceiver(this.sec, thisArg, callbackfn);
            var o = this.value;
            for (var i = 0; i < o.length; i++) {
                if (callbackfn.value.call(thisArg, o[i], i, this) !== true) {
                    return false;
                }
            }
            return true;
        };
        ASArray.prototype.generic_every = function (callbackfn, thisArg) {
            return coerceArray(this).every(callbackfn, thisArg);
        };
        ASArray.prototype.some = function (callbackfn, thisArg) {
            if (!callbackfn || !callbackfn.value || typeof callbackfn.value !== 'function') {
                return false;
            }
            thisArg = ensureBoxedReceiver(this.sec, thisArg, callbackfn);
            var self = this;
            return this.value.some(function (currentValue, index, array) {
                return callbackfn.value.call(thisArg, currentValue, index, self);
            });
        };
        ASArray.prototype.generic_some = function (callbackfn, thisArg) {
            return coerceArray(this).some(callbackfn, thisArg);
        };
        ASArray.prototype.forEach = function (callbackfn, thisArg) {
            if (!callbackfn || !callbackfn.value || typeof callbackfn.value !== 'function') {
                return;
            }
            thisArg = ensureBoxedReceiver(this.sec, thisArg, callbackfn);
            var self = this;
            this.value.forEach(function (currentValue, index) {
                callbackfn.value.call(thisArg, currentValue, index, self);
            });
        };
        ASArray.prototype.generic_forEach = function (callbackfn, thisArg) {
            return coerceArray(this).forEach(callbackfn, thisArg);
        };
        ASArray.prototype.map = function (callbackfn, thisArg) {
            if (!callbackfn || !callbackfn.value || typeof callbackfn.value !== 'function') {
                return this.sec.createArrayUnsafe([]);
            }
            thisArg = ensureBoxedReceiver(this.sec, thisArg, callbackfn);
            var self = this;
            return this.sec.createArrayUnsafe(this.value.map(function (currentValue, index) {
                return callbackfn.value.call(thisArg, currentValue, index, self);
            }));
        };
        ASArray.prototype.generic_map = function (callbackfn, thisArg) {
            return coerceArray(this).map(callbackfn, thisArg);
        };
        ASArray.prototype.filter = function (callbackfn, thisArg) {
            if (!callbackfn || !callbackfn.value || typeof callbackfn.value !== 'function') {
                return this.sec.createArrayUnsafe([]);
            }
            thisArg = ensureBoxedReceiver(this.sec, thisArg, callbackfn);
            var result = [];
            var o = this.value;
            for (var i = 0; i < o.length; i++) {
                if (callbackfn.value.call(thisArg, o[i], i, this) === true) {
                    result.push(o[i]);
                }
            }
            return this.sec.createArrayUnsafe(result);
        };
        ASArray.prototype.generic_filter = function (callbackfn, thisArg) {
            return coerceArray(this).filter(callbackfn, thisArg);
        };
        ASArray.prototype.toLocaleString = function () {
            var value = this.sec.AXArray.axCoerce(this).value;
            var out = "";
            for (var i = 0, n = value.length; i < n; i++) {
                var val = value[i];
                if (val !== null && val !== undefined) {
                    out += val.toLocaleString();
                }
                if (i + 1 < n) {
                    out += ",";
                }
            }
            return out;
        };
        ASArray.prototype.sort = function () {
            var o = this.value;
            if (arguments.length === 0) {
                o.sort();
                return this;
            }
            var compareFunction;
            var options = 0;
            if (this.sec.AXFunction.axIsInstanceOf(arguments[0])) {
                compareFunction = arguments[0].value;
            }
            else if (isNumber(arguments[0])) {
                options = arguments[0];
            }
            if (isNumber(arguments[1])) {
                options = arguments[1];
            }
            if (!options) {
                // Just passing compareFunction is ok because `undefined` is treated as not passed in JS.
                o.sort(compareFunction);
                return this;
            }
            if (!compareFunction) {
                compareFunction = axDefaultCompareFunction;
            }
            var sortOrder = options & 2 /* DESCENDING */ ? -1 : 1;
            o.sort(function (a, b) {
                return axCompare(a, b, options, sortOrder, compareFunction);
            });
            return this;
        };
        ASArray.prototype.generic_sort = function () {
            return coerceArray(this).sort.apply(this, arguments);
        };
        ASArray.prototype.sortOn = function (names, options) {
            if (arguments.length === 0) {
                this.sec.throwError("ArgumentError", Errors$1.WrongArgumentCountError, "Array/http://adobe.com/AS3/2006/builtin::sortOn()", "1", "0");
            }
            // The following oddities in how the arguments are used are gleaned from Tamarin, so hush.
            var o = this.value;
            // The options we'll end up using.
            var optionsList = [];
            if (isString(names)) {
                names = [Multiname.getPublicMangledName(names)];
                // If the name is a string, coerce `options` to int.
                optionsList = [options | 0];
            }
            else if (names && Array.isArray(names.value)) {
                names = names.value;
                for (var i = 0; i < names.length; i++) {
                    names[i] = Multiname.getPublicMangledName(names[i]);
                }
                if (options && Array.isArray(options.value)) {
                    options = options.value;
                    // Use the options Array only if it's the same length as names.
                    if (options.length === names.length) {
                        for (var i = 0; i < options.length; i++) {
                            optionsList[i] = options[i] | 0;
                        }
                        // Otherwise, use 0 for all options.
                    }
                    else {
                        for (var i = 0; i < names.length; i++) {
                            optionsList[i] = 0;
                        }
                    }
                }
                else {
                    var optionsVal = options | 0;
                    for (var i = 0; i < names.length; i++) {
                        optionsList[i] = optionsVal;
                    }
                }
            }
            else {
                // Not supplying either a String or an Array means nothing is sorted on.
                return this;
            }
            release$1 || assert(optionsList.length === names.length);
            // For use with uniqueSort and returnIndexedArray once we support them.
            var optionsVal = optionsList[0];
            release$1 || Debug$1.assertNotImplemented(!(optionsVal & 4 /* UNIQUESORT */), "UNIQUESORT");
            release$1 || Debug$1.assertNotImplemented(!(optionsVal & 8 /* RETURNINDEXEDARRAY */), "RETURNINDEXEDARRAY");
            o.sort(function (a, b) { return axCompareFields(a, b, names, optionsList); });
            return this;
        };
        ASArray.prototype.generic_sortOn = function () {
            return coerceArray(this).sortOn.apply(this, arguments);
        };
        Object.defineProperty(ASArray.prototype, "length", {
            get: function () {
                return this.value.length;
            },
            set: function (newLength) {
                this.value.length = newLength >>> 0;
            },
            enumerable: true,
            configurable: true
        });
        ASArray.prototype.axGetEnumerableKeys = function () {
            // Get the numeric Array keys first ...
            var keys = Object.keys(this.value);
            // ... then the keys that live on the array object.
            return keys.concat(_super.prototype.axGetEnumerableKeys.call(this));
        };
        ASArray.prototype.axHasPropertyInternal = function (mn) {
            var name = mn.name;
            if (typeof name === 'number' || isNumeric(name = axCoerceName(name))) {
                release$1 || assert(mn.isRuntimeName());
                return name in this.value;
            }
            if (this.traits.getTrait(mn.namespaces, name)) {
                return true;
            }
            return '$Bg' + name in this;
        };
        ASArray.prototype.axHasOwnProperty = function (mn) {
            var name = mn.name;
            if (typeof name === 'number' || isNumeric(name = axCoerceName(name))) {
                release$1 || assert(mn.isRuntimeName());
                return this.value.hasOwnProperty(name);
            }
            return !!this.traits.getTrait(mn.namespaces, name) || this.hasOwnProperty('$Bg' + name);
        };
        ASArray.prototype.axGetProperty = function (mn) {
            var name = mn.name;
            if (typeof name === 'number' || isNumeric(name = axCoerceName(name))) {
                return this.value[name];
            }
            return _super.prototype.axGetProperty.call(this, mn);
        };
        ASArray.prototype.axSetProperty = function (mn, value, bc) {
            release$1 || checkValue(value);
            var name = mn.name;
            if (typeof name === 'number' || isNumeric(name = axCoerceName(name))) {
                this.value[name] = value;
                return;
            }
            _super.prototype.axSetProperty.call(this, mn, value, bc);
        };
        ASArray.prototype.axDeleteProperty = function (mn) {
            var name = mn.name;
            if (typeof name === 'number' || isNumeric(name = axCoerceName(name))) {
                return delete this.value[name];
            }
            // Cannot delete array traits.
            if (this.traits.getTrait(mn.namespaces, name)) {
                return false;
            }
            return delete this['$Bg' + name];
        };
        ASArray.prototype.axGetPublicProperty = function (nm) {
            if (typeof nm === 'number' || isNumeric(nm = axCoerceName(nm))) {
                return this.value[nm];
            }
            return this['$Bg' + nm];
        };
        ASArray.prototype.axSetPublicProperty = function (nm, value) {
            release$1 || checkValue(value);
            if (typeof nm === 'number' || isNumeric(nm = axCoerceName(nm))) {
                this.value[nm] = value;
                return;
            }
            this['$Bg' + nm] = value;
        };
        return ASArray;
    }(ASObject$1));

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    /**
     * TypedArray Vector Template
     *
     * If you make any changes to this code you'll need to regenerate uint32Vector.ts &
     * float64Vector.ts. We duplicate all the code for vectors because we want to keep things
     * monomorphic as much as possible.
     *
     * NOTE: Not all of the AS3 methods need to be implemented natively, some are self-hosted in AS3
     * code. For better performance we should probably implement them all natively (in JS that is)
     * unless our compiler is good enough.
     */
    var Int32Vector = /** @class */ (function (_super) {
        __extends(Int32Vector, _super);
        function Int32Vector(length, fixed) {
            if (length === void 0) { length = 0; }
            if (fixed === void 0) { fixed = false; }
            var _this = _super.call(this) || this;
            length = length >>> 0;
            _this._fixed = !!fixed;
            _this._buffer = new Int32Array(Math.max(Int32Vector.INITIAL_CAPACITY, length + Int32Vector.EXTRA_CAPACITY));
            _this._offset = 0;
            _this._length = length;
            return _this;
        }
        Int32Vector.classInitializer = function () {
            var proto = this.dPrototype;
            var tProto = this.tPrototype;
            // Fix up MOP handlers to not apply to the dynamic prototype, which is a plain object.
            tProto.axGetProperty = proto.axGetProperty;
            tProto.axGetNumericProperty = proto.axGetNumericProperty;
            tProto.axSetProperty = proto.axSetProperty;
            tProto.axSetNumericProperty = proto.axSetNumericProperty;
            tProto.axHasPropertyInternal = proto.axHasPropertyInternal;
            tProto.axNextName = proto.axNextName;
            tProto.axNextNameIndex = proto.axNextNameIndex;
            tProto.axNextValue = proto.axNextValue;
            proto.axGetProperty = ASObject$1.prototype.axGetProperty;
            proto.axGetNumericProperty = ASObject$1.prototype.axGetNumericProperty;
            proto.axSetProperty = ASObject$1.prototype.axSetProperty;
            proto.axSetNumericProperty = ASObject$1.prototype.axSetNumericProperty;
            proto.axHasPropertyInternal = ASObject$1.prototype.axHasPropertyInternal;
            proto.axNextName = ASObject$1.prototype.axNextName;
            proto.axNextNameIndex = ASObject$1.prototype.axNextNameIndex;
            proto.axNextValue = ASObject$1.prototype.axNextValue;
            var asProto = Int32Vector.prototype;
            defineNonEnumerableProperty(proto, '$Bgjoin', asProto.join);
            // Same as join, see VectorImpl.as in Tamarin repository.
            defineNonEnumerableProperty(proto, '$BgtoString', asProto.join);
            defineNonEnumerableProperty(proto, '$BgtoLocaleString', asProto.toLocaleString);
            defineNonEnumerableProperty(proto, '$Bgpop', asProto.pop);
            defineNonEnumerableProperty(proto, '$Bgpush', asProto.push);
            defineNonEnumerableProperty(proto, '$Bgreverse', asProto.reverse);
            defineNonEnumerableProperty(proto, '$Bgconcat', asProto.concat);
            defineNonEnumerableProperty(proto, '$Bgsplice', asProto.splice);
            defineNonEnumerableProperty(proto, '$Bgslice', asProto.slice);
            defineNonEnumerableProperty(proto, '$Bgshift', asProto.shift);
            defineNonEnumerableProperty(proto, '$Bgunshift', asProto.unshift);
            defineNonEnumerableProperty(proto, '$BgindexOf', asProto.indexOf);
            defineNonEnumerableProperty(proto, '$BglastIndexOf', asProto.lastIndexOf);
            defineNonEnumerableProperty(proto, '$BgforEach', asProto.forEach);
            defineNonEnumerableProperty(proto, '$Bgmap', asProto.map);
            defineNonEnumerableProperty(proto, '$Bgfilter', asProto.filter);
            defineNonEnumerableProperty(proto, '$Bgsome', asProto.some);
            defineNonEnumerableProperty(proto, '$Bgevery', asProto.every);
            defineNonEnumerableProperty(proto, '$Bgsort', asProto.sort);
            defineNonEnumerableProperty(proto, 'checkVectorMethodArgs', asProto.checkVectorMethodArgs);
        };
        Int32Vector.axApply = function (_, args) {
            var object = args[0];
            if (this.axIsType(object)) {
                return object;
            }
            var length = object.axGetPublicProperty("length");
            if (length !== undefined) {
                var v = this.axConstruct([length, false]);
                for (var i = 0; i < length; i++) {
                    v.axSetNumericProperty(i, object.axGetPublicProperty(i));
                }
                return v;
            }
            unexpected();
        };
        Int32Vector.prototype.internalToString = function () {
            var str = "";
            var start = this._offset;
            var end = start + this._length;
            for (var i = 0; i < this._buffer.length; i++) {
                if (i === start) {
                    str += "[";
                }
                if (i === end) {
                    str += "]";
                }
                str += this._buffer[i];
                if (i < this._buffer.length - 1) {
                    str += ",";
                }
            }
            if (this._offset + this._length === this._buffer.length) {
                str += "]";
            }
            return str + ": offset: " + this._offset + ", length: " + this._length + ", capacity: " + this._buffer.length;
        };
        Int32Vector.prototype.toString = function () {
            var str = "";
            for (var i = 0; i < this._length; i++) {
                str += this._buffer[this._offset + i];
                if (i < this._length - 1) {
                    str += ",";
                }
            }
            return str;
        };
        Int32Vector.prototype.toLocaleString = function () {
            var str = "";
            for (var i = 0; i < this._length; i++) {
                str += this._buffer[this._offset + i];
                if (i < this._length - 1) {
                    str += ",";
                }
            }
            return str;
        };
        // vector.prototype.toString = vector.prototype.internalToString;
        Int32Vector.prototype._view = function () {
            return this._buffer.subarray(this._offset, this._offset + this._length);
        };
        Int32Vector.prototype._ensureCapacity = function (length) {
            var minCapacity = this._offset + length;
            if (minCapacity < this._buffer.length) {
                return;
            }
            if (length <= this._buffer.length) {
                // New length exceeds bounds at current offset but fits in the buffer, so we center it.
                var offset = (this._buffer.length - length) >> 2;
                this._buffer.set(this._view(), offset);
                this._offset = offset;
                return;
            }
            // New length doesn't fit at all, resize buffer.
            var oldCapacity = this._buffer.length;
            var newCapacity = ((oldCapacity * 3) >> 1) + 1;
            if (newCapacity < minCapacity) {
                newCapacity = minCapacity;
            }
            var buffer = new Int32Array(newCapacity);
            buffer.set(this._buffer, 0);
            this._buffer = buffer;
        };
        Int32Vector.prototype.concat = function () {
            var length = this._length;
            for (var i = 0; i < arguments.length; i++) {
                var vector = arguments[i];
                if (!(vector._buffer instanceof Int32Array)) {
                    assert(false); // TODO
                    // this.sec.throwError('TypeError', Errors.CheckTypeFailedError,
                    // vector.constructor.name, '__AS3__.vec.Vector.<int>');
                }
                length += vector._length;
            }
            var result = new this.sec.Int32Vector(length);
            var buffer = result._buffer;
            buffer.set(this._buffer);
            var offset = this._length;
            for (var i = 0; i < arguments.length; i++) {
                var vector = arguments[i];
                if (offset + vector._buffer.length < vector._buffer.length) {
                    buffer.set(vector._buffer, offset);
                }
                else {
                    buffer.set(vector._buffer.subarray(0, vector._length), offset);
                }
                offset += vector._length;
            }
            return result;
        };
        /**
         * Executes a |callback| function with three arguments: element, index, the vector itself as
         * well as passing the |thisObject| as |this| for each of the elements in the vector. If any of
         * the callbacks return |false| the function terminates, otherwise it returns |true|.
         */
        Int32Vector.prototype.every = function (callback, thisObject) {
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return true;
            }
            for (var i = 0; i < this._length; i++) {
                if (!callback.call(thisObject, this._buffer[this._offset + i], i, this)) {
                    return false;
                }
            }
            return true;
        };
        /**
         * Filters the elements for which the |callback| method returns |true|. The |callback| function
         * is called with three arguments: element, index, the vector itself as well as passing the
         * |thisObject| as |this| for each of the elements in the vector.
         */
        Int32Vector.prototype.filter = function (callback, thisObject) {
            var v = new this.sec.Int32Vector();
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return v;
            }
            for (var i = 0; i < this._length; i++) {
                if (callback.call(thisObject, this._buffer[this._offset + i], i, this)) {
                    v.push(this._buffer[this._offset + i]);
                }
            }
            return v;
        };
        Int32Vector.prototype.map = function (callback, thisObject) {
            var v = this.axClass.axConstruct([this.length, false]);
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return v;
            }
            for (var i = 0; i < this._length; i++) {
                v[i] = callback.call(thisObject, this._buffer[this._offset + i], i, this);
            }
            return v;
        };
        Int32Vector.prototype.some = function (callback, thisObject) {
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return false;
            }
            for (var i = 0; i < this._length; i++) {
                if (callback.call(thisObject, this._buffer[this._offset + i], i, this)) {
                    return true;
                }
            }
            return false;
        };
        Int32Vector.prototype.forEach = function (callback, thisObject) {
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return;
            }
            for (var i = 0; i < this._length; i++) {
                callback.call(thisObject, this._buffer[this._offset + i], i, this);
            }
        };
        Int32Vector.prototype.join = function (separator) {
            if (separator === void 0) { separator = ','; }
            var limit = this.length;
            var buffer = this._buffer;
            var offset = this._offset;
            var result = "";
            for (var i = 0; i < limit - 1; i++) {
                result += buffer[offset + i] + separator;
            }
            if (limit > 0) {
                result += buffer[offset + limit - 1];
            }
            return result;
        };
        Int32Vector.prototype.indexOf = function (searchElement, fromIndex) {
            if (fromIndex === void 0) { fromIndex = 0; }
            var length = this._length;
            var start = fromIndex | 0;
            if (start < 0) {
                start = start + length;
                if (start < 0) {
                    start = 0;
                }
            }
            else if (start >= length) {
                return -1;
            }
            var buffer = this._buffer;
            var length = this._length;
            var offset = this._offset;
            start += offset;
            var end = offset + length;
            for (var i = start; i < end; i++) {
                if (buffer[i] === searchElement) {
                    return i - offset;
                }
            }
            return -1;
        };
        Int32Vector.prototype.lastIndexOf = function (searchElement, fromIndex) {
            if (fromIndex === void 0) { fromIndex = 0x7fffffff; }
            var length = this._length;
            var start = fromIndex | 0;
            if (start < 0) {
                start = start + length;
                if (start < 0) {
                    return -1;
                }
            }
            else if (start >= length) {
                start = length;
            }
            var buffer = this._buffer;
            var offset = this._offset;
            start += offset;
            var end = offset;
            for (var i = start; i-- > end;) {
                if (buffer[i] === searchElement) {
                    return i - offset;
                }
            }
            return -1;
        };
        Int32Vector.prototype.push = function (arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8 /*...rest*/) {
            this._checkFixed();
            this._ensureCapacity(this._length + arguments.length);
            for (var i = 0; i < arguments.length; i++) {
                this._buffer[this._offset + this._length++] = arguments[i];
            }
        };
        Int32Vector.prototype.pop = function () {
            this._checkFixed();
            if (this._length === 0) {
                return Int32Vector.DEFAULT_VALUE;
            }
            this._length--;
            return this._buffer[this._offset + this._length];
            // TODO: should we potentially reallocate to a smaller buffer here?
        };
        Int32Vector.prototype.reverse = function () {
            var l = this._offset;
            var r = this._offset + this._length - 1;
            var b = this._buffer;
            while (l < r) {
                var t = b[l];
                b[l] = b[r];
                b[r] = t;
                l++;
                r--;
            }
            return this;
        };
        Int32Vector.prototype.sort = function (sortBehavior) {
            if (arguments.length === 0) {
                Array.prototype.sort.call(this._view());
                return this;
            }
            if (this.sec.AXFunction.axIsType(sortBehavior)) {
                Array.prototype.sort.call(this._view(), sortBehavior.value);
                return this;
            }
            var options = sortBehavior | 0;
            release$1 || assertNotImplemented(!(options & Int32Vector.UNIQUESORT), "UNIQUESORT");
            release$1 || assertNotImplemented(!(options & Int32Vector.RETURNINDEXEDARRAY), "RETURNINDEXEDARRAY");
            if (options & Int32Vector.DESCENDING) {
                Array.prototype.sort.call(this._view(), function (a, b) { return b - a; });
            }
            else {
                Array.prototype.sort.call(this._view(), function (a, b) { return a - b; });
            }
            return this;
        };
        Int32Vector.prototype.shift = function () {
            this._checkFixed();
            if (this._length === 0) {
                return 0;
            }
            this._length--;
            return this._buffer[this._offset++];
        };
        Int32Vector.prototype.unshift = function () {
            this._checkFixed();
            if (!arguments.length) {
                return;
            }
            this._ensureCapacity(this._length + arguments.length);
            this._slide(arguments.length);
            this._offset -= arguments.length;
            this._length += arguments.length;
            for (var i = 0; i < arguments.length; i++) {
                this._buffer[this._offset + i] = arguments[i];
            }
        };
        Int32Vector.prototype.slice = function (start, end) {
            if (start === void 0) { start = 0; }
            if (end === void 0) { end = 0x7fffffff; }
            var buffer = this._buffer;
            var length = this._length;
            var first = Math.min(Math.max(start, 0), length);
            var last = Math.min(Math.max(end, first), length);
            var result = new this.sec.Int32Vector(last - first, this.fixed);
            result._buffer.set(buffer.subarray(this._offset + first, this._offset + last), result._offset);
            return result;
        };
        Int32Vector.prototype.splice = function (start, deleteCount_ /*, ...items: number[] */) {
            var buffer = this._buffer;
            var length = this._length;
            var first = Math.min(Math.max(start, 0), length);
            var startOffset = this._offset + first;
            var deleteCount = Math.min(Math.max(deleteCount_, 0), length - first);
            var insertCount = arguments.length - 2;
            var deletedItems;
            var result = new this.sec.Int32Vector(deleteCount, this.fixed);
            if (deleteCount > 0) {
                deletedItems = buffer.subarray(startOffset, startOffset + deleteCount);
                result._buffer.set(deletedItems, result._offset);
            }
            this._ensureCapacity(length - deleteCount + insertCount);
            var right = startOffset + deleteCount;
            var slice = buffer.subarray(right, length);
            buffer.set(slice, startOffset + insertCount);
            this._length += insertCount - deleteCount;
            for (var i = 0; i < insertCount; i++) {
                buffer[startOffset + i] = arguments[i + 2];
            }
            return result;
        };
        Int32Vector.prototype._slide = function (distance) {
            this._buffer.set(this._view(), this._offset + distance);
            this._offset += distance;
        };
        Object.defineProperty(Int32Vector.prototype, "length", {
            get: function () {
                return this._length;
            },
            set: function (value) {
                value = value >>> 0;
                if (value > this._length) {
                    this._ensureCapacity(value);
                    for (var i = this._offset + this._length, j = this._offset + value; i < j; i++) {
                        this._buffer[i] = Int32Vector.DEFAULT_VALUE;
                    }
                }
                this._length = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Int32Vector.prototype, "fixed", {
            get: function () {
                return this._fixed;
            },
            set: function (f) {
                this._fixed = !!f;
            },
            enumerable: true,
            configurable: true
        });
        Int32Vector.prototype._checkFixed = function () {
            if (this._fixed) {
                this.sec.throwError("RangeError", Errors$1.VectorFixedError);
            }
        };
        Int32Vector.prototype.axGetNumericProperty = function (nm) {
            release$1 || assert(isNumeric(nm));
            var length = this._length;
            var idx = nm | 0;
            if (idx < 0 || idx >= length || idx != nm) {
                this.sec.throwError("RangeError", Errors$1.OutOfRangeError, nm, length);
            }
            return this._buffer[this._offset + idx];
        };
        Int32Vector.prototype.axSetNumericProperty = function (nm, v) {
            release$1 || assert(isNumeric(nm));
            var length = this._length;
            var idx = nm | 0;
            if (idx < 0 || idx > length || idx != nm || (idx === length && this._fixed)) {
                this.sec.throwError("RangeError", Errors$1.OutOfRangeError, nm, length);
            }
            if (idx === this._length) {
                this._ensureCapacity(this._length + 1);
                this._length++;
            }
            this._buffer[this._offset + idx] = v;
        };
        Int32Vector.prototype.axHasPropertyInternal = function (mn) {
            // Optimization for the common case of indexed element accesses.
            if ((mn.name | 0) === mn.name) {
                release$1 || assert(mn.isRuntimeName());
                return mn.name >= 0 && mn.name < this._length;
            }
            var name = axCoerceName(mn.name);
            if (mn.isRuntimeName() && isIndex(name)) {
                var index = name >>> 0;
                return index >= 0 && index < this._length;
            }
            return this.axResolveMultiname(mn) in this;
        };
        Int32Vector.prototype.axNextValue = function (index) {
            return this._buffer[this._offset + index - 1];
        };
        Int32Vector.prototype.axNextNameIndex = function (index) {
            var nextNameIndex = index + 1;
            if (nextNameIndex <= this._length) {
                return nextNameIndex;
            }
            return 0;
        };
        Int32Vector.EXTRA_CAPACITY = 4;
        Int32Vector.INITIAL_CAPACITY = 10;
        Int32Vector.DEFAULT_VALUE = 0;
        Int32Vector.DESCENDING = 2;
        Int32Vector.UNIQUESORT = 4;
        Int32Vector.RETURNINDEXEDARRAY = 8;
        return Int32Vector;
    }(BaseVector));

    /* THIS FILE WAS AUTOMATICALLY GENERATED FROM int32Vector.ts */
    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    /**
     * TypedArray Vector Template
     *
     * If you make any changes to this code you'll need to regenerate uint32Vector.ts &
     * float64Vector.ts. We duplicate all the code for vectors because we want to keep things
     * monomorphic as much as possible.
     *
     * NOTE: Not all of the AS3 methods need to be implemented natively, some are self-hosted in AS3
     * code. For better performance we should probably implement them all natively (in JS that is)
     * unless our compiler is good enough.
     */
    var Uint32Vector = /** @class */ (function (_super) {
        __extends(Uint32Vector, _super);
        function Uint32Vector(length, fixed) {
            if (length === void 0) { length = 0; }
            if (fixed === void 0) { fixed = false; }
            var _this = _super.call(this) || this;
            length = length >>> 0;
            _this._fixed = !!fixed;
            _this._buffer = new Uint32Array(Math.max(Uint32Vector.INITIAL_CAPACITY, length + Uint32Vector.EXTRA_CAPACITY));
            _this._offset = 0;
            _this._length = length;
            return _this;
        }
        Uint32Vector.classInitializer = function () {
            var proto = this.dPrototype;
            var tProto = this.tPrototype;
            // Fix up MOP handlers to not apply to the dynamic prototype, which is a plain object.
            tProto.axGetProperty = proto.axGetProperty;
            tProto.axGetNumericProperty = proto.axGetNumericProperty;
            tProto.axSetProperty = proto.axSetProperty;
            tProto.axSetNumericProperty = proto.axSetNumericProperty;
            tProto.axHasPropertyInternal = proto.axHasPropertyInternal;
            tProto.axNextName = proto.axNextName;
            tProto.axNextNameIndex = proto.axNextNameIndex;
            tProto.axNextValue = proto.axNextValue;
            proto.axGetProperty = ASObject$1.prototype.axGetProperty;
            proto.axGetNumericProperty = ASObject$1.prototype.axGetNumericProperty;
            proto.axSetProperty = ASObject$1.prototype.axSetProperty;
            proto.axSetNumericProperty = ASObject$1.prototype.axSetNumericProperty;
            proto.axHasPropertyInternal = ASObject$1.prototype.axHasPropertyInternal;
            proto.axNextName = ASObject$1.prototype.axNextName;
            proto.axNextNameIndex = ASObject$1.prototype.axNextNameIndex;
            proto.axNextValue = ASObject$1.prototype.axNextValue;
            var asProto = Uint32Vector.prototype;
            defineNonEnumerableProperty(proto, '$Bgjoin', asProto.join);
            // Same as join, see VectorImpl.as in Tamarin repository.
            defineNonEnumerableProperty(proto, '$BgtoString', asProto.join);
            defineNonEnumerableProperty(proto, '$BgtoLocaleString', asProto.toLocaleString);
            defineNonEnumerableProperty(proto, '$Bgpop', asProto.pop);
            defineNonEnumerableProperty(proto, '$Bgpush', asProto.push);
            defineNonEnumerableProperty(proto, '$Bgreverse', asProto.reverse);
            defineNonEnumerableProperty(proto, '$Bgconcat', asProto.concat);
            defineNonEnumerableProperty(proto, '$Bgsplice', asProto.splice);
            defineNonEnumerableProperty(proto, '$Bgslice', asProto.slice);
            defineNonEnumerableProperty(proto, '$Bgshift', asProto.shift);
            defineNonEnumerableProperty(proto, '$Bgunshift', asProto.unshift);
            defineNonEnumerableProperty(proto, '$BgindexOf', asProto.indexOf);
            defineNonEnumerableProperty(proto, '$BglastIndexOf', asProto.lastIndexOf);
            defineNonEnumerableProperty(proto, '$BgforEach', asProto.forEach);
            defineNonEnumerableProperty(proto, '$Bgmap', asProto.map);
            defineNonEnumerableProperty(proto, '$Bgfilter', asProto.filter);
            defineNonEnumerableProperty(proto, '$Bgsome', asProto.some);
            defineNonEnumerableProperty(proto, '$Bgevery', asProto.every);
            defineNonEnumerableProperty(proto, '$Bgsort', asProto.sort);
            defineNonEnumerableProperty(proto, 'checkVectorMethodArgs', asProto.checkVectorMethodArgs);
        };
        Uint32Vector.axApply = function (_, args) {
            var object = args[0];
            if (this.axIsType(object)) {
                return object;
            }
            var length = object.axGetPublicProperty("length");
            if (length !== undefined) {
                var v = this.axConstruct([length, false]);
                for (var i = 0; i < length; i++) {
                    v.axSetNumericProperty(i, object.axGetPublicProperty(i));
                }
                return v;
            }
            unexpected();
        };
        Uint32Vector.prototype.internalToString = function () {
            var str = "";
            var start = this._offset;
            var end = start + this._length;
            for (var i = 0; i < this._buffer.length; i++) {
                if (i === start) {
                    str += "[";
                }
                if (i === end) {
                    str += "]";
                }
                str += this._buffer[i];
                if (i < this._buffer.length - 1) {
                    str += ",";
                }
            }
            if (this._offset + this._length === this._buffer.length) {
                str += "]";
            }
            return str + ": offset: " + this._offset + ", length: " + this._length + ", capacity: " + this._buffer.length;
        };
        Uint32Vector.prototype.toString = function () {
            var str = "";
            for (var i = 0; i < this._length; i++) {
                str += this._buffer[this._offset + i];
                if (i < this._length - 1) {
                    str += ",";
                }
            }
            return str;
        };
        Uint32Vector.prototype.toLocaleString = function () {
            var str = "";
            for (var i = 0; i < this._length; i++) {
                str += this._buffer[this._offset + i];
                if (i < this._length - 1) {
                    str += ",";
                }
            }
            return str;
        };
        // vector.prototype.toString = vector.prototype.internalToString;
        Uint32Vector.prototype._view = function () {
            return this._buffer.subarray(this._offset, this._offset + this._length);
        };
        Uint32Vector.prototype._ensureCapacity = function (length) {
            var minCapacity = this._offset + length;
            if (minCapacity < this._buffer.length) {
                return;
            }
            if (length <= this._buffer.length) {
                // New length exceeds bounds at current offset but fits in the buffer, so we center it.
                var offset = (this._buffer.length - length) >> 2;
                this._buffer.set(this._view(), offset);
                this._offset = offset;
                return;
            }
            // New length doesn't fit at all, resize buffer.
            var oldCapacity = this._buffer.length;
            var newCapacity = ((oldCapacity * 3) >> 1) + 1;
            if (newCapacity < minCapacity) {
                newCapacity = minCapacity;
            }
            var buffer = new Uint32Array(newCapacity);
            buffer.set(this._buffer, 0);
            this._buffer = buffer;
        };
        Uint32Vector.prototype.concat = function () {
            var length = this._length;
            for (var i = 0; i < arguments.length; i++) {
                var vector = arguments[i];
                if (!(vector._buffer instanceof Uint32Array)) {
                    assert(false); // TODO
                    // this.sec.throwError('TypeError', Errors.CheckTypeFailedError,
                    // vector.constructor.name, '__AS3__.vec.Vector.<uint>');
                }
                length += vector._length;
            }
            var result = new this.sec.Uint32Vector(length);
            var buffer = result._buffer;
            buffer.set(this._buffer);
            var offset = this._length;
            for (var i = 0; i < arguments.length; i++) {
                var vector = arguments[i];
                if (offset + vector._buffer.length < vector._buffer.length) {
                    buffer.set(vector._buffer, offset);
                }
                else {
                    buffer.set(vector._buffer.subarray(0, vector._length), offset);
                }
                offset += vector._length;
            }
            return result;
        };
        /**
         * Executes a |callback| function with three arguments: element, index, the vector itself as
         * well as passing the |thisObject| as |this| for each of the elements in the vector. If any of
         * the callbacks return |false| the function terminates, otherwise it returns |true|.
         */
        Uint32Vector.prototype.every = function (callback, thisObject) {
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return true;
            }
            for (var i = 0; i < this._length; i++) {
                if (!callback.call(thisObject, this._buffer[this._offset + i], i, this)) {
                    return false;
                }
            }
            return true;
        };
        /**
         * Filters the elements for which the |callback| method returns |true|. The |callback| function
         * is called with three arguments: element, index, the vector itself as well as passing the
         * |thisObject| as |this| for each of the elements in the vector.
         */
        Uint32Vector.prototype.filter = function (callback, thisObject) {
            var v = new this.sec.Uint32Vector();
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return v;
            }
            for (var i = 0; i < this._length; i++) {
                if (callback.call(thisObject, this._buffer[this._offset + i], i, this)) {
                    v.push(this._buffer[this._offset + i]);
                }
            }
            return v;
        };
        Uint32Vector.prototype.map = function (callback, thisObject) {
            var v = this.axClass.axConstruct([this.length, false]);
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return v;
            }
            for (var i = 0; i < this._length; i++) {
                v[i] = callback.call(thisObject, this._buffer[this._offset + i], i, this);
            }
            return v;
        };
        Uint32Vector.prototype.some = function (callback, thisObject) {
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return false;
            }
            for (var i = 0; i < this._length; i++) {
                if (callback.call(thisObject, this._buffer[this._offset + i], i, this)) {
                    return true;
                }
            }
            return false;
        };
        Uint32Vector.prototype.forEach = function (callback, thisObject) {
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return;
            }
            for (var i = 0; i < this._length; i++) {
                callback.call(thisObject, this._buffer[this._offset + i], i, this);
            }
        };
        Uint32Vector.prototype.join = function (separator) {
            if (separator === void 0) { separator = ','; }
            var limit = this.length;
            var buffer = this._buffer;
            var offset = this._offset;
            var result = "";
            for (var i = 0; i < limit - 1; i++) {
                result += buffer[offset + i] + separator;
            }
            if (limit > 0) {
                result += buffer[offset + limit - 1];
            }
            return result;
        };
        Uint32Vector.prototype.indexOf = function (searchElement, fromIndex) {
            if (fromIndex === void 0) { fromIndex = 0; }
            var length = this._length;
            var start = fromIndex | 0;
            if (start < 0) {
                start = start + length;
                if (start < 0) {
                    start = 0;
                }
            }
            else if (start >= length) {
                return -1;
            }
            var buffer = this._buffer;
            var length = this._length;
            var offset = this._offset;
            start += offset;
            var end = offset + length;
            for (var i = start; i < end; i++) {
                if (buffer[i] === searchElement) {
                    return i - offset;
                }
            }
            return -1;
        };
        Uint32Vector.prototype.lastIndexOf = function (searchElement, fromIndex) {
            if (fromIndex === void 0) { fromIndex = 0x7fffffff; }
            var length = this._length;
            var start = fromIndex | 0;
            if (start < 0) {
                start = start + length;
                if (start < 0) {
                    return -1;
                }
            }
            else if (start >= length) {
                start = length;
            }
            var buffer = this._buffer;
            var offset = this._offset;
            start += offset;
            var end = offset;
            for (var i = start; i-- > end;) {
                if (buffer[i] === searchElement) {
                    return i - offset;
                }
            }
            return -1;
        };
        Uint32Vector.prototype.push = function (arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8 /*...rest*/) {
            this._checkFixed();
            this._ensureCapacity(this._length + arguments.length);
            for (var i = 0; i < arguments.length; i++) {
                this._buffer[this._offset + this._length++] = arguments[i];
            }
        };
        Uint32Vector.prototype.pop = function () {
            this._checkFixed();
            if (this._length === 0) {
                return Uint32Vector.DEFAULT_VALUE;
            }
            this._length--;
            return this._buffer[this._offset + this._length];
            // TODO: should we potentially reallocate to a smaller buffer here?
        };
        Uint32Vector.prototype.reverse = function () {
            var l = this._offset;
            var r = this._offset + this._length - 1;
            var b = this._buffer;
            while (l < r) {
                var t = b[l];
                b[l] = b[r];
                b[r] = t;
                l++;
                r--;
            }
            return this;
        };
        Uint32Vector.prototype.sort = function (sortBehavior) {
            if (arguments.length === 0) {
                Array.prototype.sort.call(this._view());
                return this;
            }
            if (this.sec.AXFunction.axIsType(sortBehavior)) {
                Array.prototype.sort.call(this._view(), sortBehavior.value);
                return this;
            }
            var options = sortBehavior | 0;
            release$1 || assertNotImplemented(!(options & Uint32Vector.UNIQUESORT), "UNIQUESORT");
            release$1 || assertNotImplemented(!(options & Uint32Vector.RETURNINDEXEDARRAY), "RETURNINDEXEDARRAY");
            if (options & Uint32Vector.DESCENDING) {
                Array.prototype.sort.call(this._view(), function (a, b) { return b - a; });
            }
            else {
                Array.prototype.sort.call(this._view(), function (a, b) { return a - b; });
            }
            return this;
        };
        Uint32Vector.prototype.shift = function () {
            this._checkFixed();
            if (this._length === 0) {
                return 0;
            }
            this._length--;
            return this._buffer[this._offset++];
        };
        Uint32Vector.prototype.unshift = function () {
            this._checkFixed();
            if (!arguments.length) {
                return;
            }
            this._ensureCapacity(this._length + arguments.length);
            this._slide(arguments.length);
            this._offset -= arguments.length;
            this._length += arguments.length;
            for (var i = 0; i < arguments.length; i++) {
                this._buffer[this._offset + i] = arguments[i];
            }
        };
        Uint32Vector.prototype.slice = function (start, end) {
            if (start === void 0) { start = 0; }
            if (end === void 0) { end = 0x7fffffff; }
            var buffer = this._buffer;
            var length = this._length;
            var first = Math.min(Math.max(start, 0), length);
            var last = Math.min(Math.max(end, first), length);
            var result = new this.sec.Uint32Vector(last - first, this.fixed);
            result._buffer.set(buffer.subarray(this._offset + first, this._offset + last), result._offset);
            return result;
        };
        Uint32Vector.prototype.splice = function (start, deleteCount_ /*, ...items: number[] */) {
            var buffer = this._buffer;
            var length = this._length;
            var first = Math.min(Math.max(start, 0), length);
            var startOffset = this._offset + first;
            var deleteCount = Math.min(Math.max(deleteCount_, 0), length - first);
            var insertCount = arguments.length - 2;
            var deletedItems;
            var result = new this.sec.Uint32Vector(deleteCount, this.fixed);
            if (deleteCount > 0) {
                deletedItems = buffer.subarray(startOffset, startOffset + deleteCount);
                result._buffer.set(deletedItems, result._offset);
            }
            this._ensureCapacity(length - deleteCount + insertCount);
            var right = startOffset + deleteCount;
            var slice = buffer.subarray(right, length);
            buffer.set(slice, startOffset + insertCount);
            this._length += insertCount - deleteCount;
            for (var i = 0; i < insertCount; i++) {
                buffer[startOffset + i] = arguments[i + 2];
            }
            return result;
        };
        Uint32Vector.prototype._slide = function (distance) {
            this._buffer.set(this._view(), this._offset + distance);
            this._offset += distance;
        };
        Object.defineProperty(Uint32Vector.prototype, "length", {
            get: function () {
                return this._length;
            },
            set: function (value) {
                value = value >>> 0;
                if (value > this._length) {
                    this._ensureCapacity(value);
                    for (var i = this._offset + this._length, j = this._offset + value; i < j; i++) {
                        this._buffer[i] = Uint32Vector.DEFAULT_VALUE;
                    }
                }
                this._length = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Uint32Vector.prototype, "fixed", {
            get: function () {
                return this._fixed;
            },
            set: function (f) {
                this._fixed = !!f;
            },
            enumerable: true,
            configurable: true
        });
        Uint32Vector.prototype._checkFixed = function () {
            if (this._fixed) {
                this.sec.throwError("RangeError", Errors$1.VectorFixedError);
            }
        };
        Uint32Vector.prototype.axGetNumericProperty = function (nm) {
            release$1 || assert(isNumeric(nm));
            var length = this._length;
            var idx = nm | 0;
            if (idx < 0 || idx >= length || idx != nm) {
                this.sec.throwError("RangeError", Errors$1.OutOfRangeError, nm, length);
            }
            return this._buffer[this._offset + idx];
        };
        Uint32Vector.prototype.axSetNumericProperty = function (nm, v) {
            release$1 || assert(isNumeric(nm));
            var length = this._length;
            var idx = nm | 0;
            if (idx < 0 || idx > length || idx != nm || (idx === length && this._fixed)) {
                this.sec.throwError("RangeError", Errors$1.OutOfRangeError, nm, length);
            }
            if (idx === this._length) {
                this._ensureCapacity(this._length + 1);
                this._length++;
            }
            this._buffer[this._offset + idx] = v;
        };
        Uint32Vector.prototype.axHasPropertyInternal = function (mn) {
            // Optimization for the common case of indexed element accesses.
            if ((mn.name | 0) === mn.name) {
                release$1 || assert(mn.isRuntimeName());
                return mn.name >= 0 && mn.name < this._length;
            }
            var name = axCoerceName(mn.name);
            if (mn.isRuntimeName() && isIndex(name)) {
                var index = name >>> 0;
                return index >= 0 && index < this._length;
            }
            return this.axResolveMultiname(mn) in this;
        };
        Uint32Vector.prototype.axNextValue = function (index) {
            return this._buffer[this._offset + index - 1];
        };
        Uint32Vector.prototype.axNextNameIndex = function (index) {
            var nextNameIndex = index + 1;
            if (nextNameIndex <= this._length) {
                return nextNameIndex;
            }
            return 0;
        };
        Uint32Vector.EXTRA_CAPACITY = 4;
        Uint32Vector.INITIAL_CAPACITY = 10;
        Uint32Vector.DEFAULT_VALUE = 0;
        Uint32Vector.DESCENDING = 2;
        Uint32Vector.UNIQUESORT = 4;
        Uint32Vector.RETURNINDEXEDARRAY = 8;
        return Uint32Vector;
    }(BaseVector));

    /* THIS FILE WAS AUTOMATICALLY GENERATED FROM int32Vector.ts */
    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    /**
     * TypedArray Vector Template
     *
     * If you make any changes to this code you'll need to regenerate uint32Vector.ts &
     * float64Vector.ts. We duplicate all the code for vectors because we want to keep things
     * monomorphic as much as possible.
     *
     * NOTE: Not all of the AS3 methods need to be implemented natively, some are self-hosted in AS3
     * code. For better performance we should probably implement them all natively (in JS that is)
     * unless our compiler is good enough.
     */
    var Float64Vector = /** @class */ (function (_super) {
        __extends(Float64Vector, _super);
        function Float64Vector(length, fixed) {
            if (length === void 0) { length = 0; }
            if (fixed === void 0) { fixed = false; }
            var _this = _super.call(this) || this;
            length = length >>> 0;
            _this._fixed = !!fixed;
            _this._buffer = new Float64Array(Math.max(Float64Vector.INITIAL_CAPACITY, length + Float64Vector.EXTRA_CAPACITY));
            _this._offset = 0;
            _this._length = length;
            return _this;
        }
        Float64Vector.classInitializer = function () {
            var proto = this.dPrototype;
            var tProto = this.tPrototype;
            // Fix up MOP handlers to not apply to the dynamic prototype, which is a plain object.
            tProto.axGetProperty = proto.axGetProperty;
            tProto.axGetNumericProperty = proto.axGetNumericProperty;
            tProto.axSetProperty = proto.axSetProperty;
            tProto.axSetNumericProperty = proto.axSetNumericProperty;
            tProto.axHasPropertyInternal = proto.axHasPropertyInternal;
            tProto.axNextName = proto.axNextName;
            tProto.axNextNameIndex = proto.axNextNameIndex;
            tProto.axNextValue = proto.axNextValue;
            proto.axGetProperty = ASObject$1.prototype.axGetProperty;
            proto.axGetNumericProperty = ASObject$1.prototype.axGetNumericProperty;
            proto.axSetProperty = ASObject$1.prototype.axSetProperty;
            proto.axSetNumericProperty = ASObject$1.prototype.axSetNumericProperty;
            proto.axHasPropertyInternal = ASObject$1.prototype.axHasPropertyInternal;
            proto.axNextName = ASObject$1.prototype.axNextName;
            proto.axNextNameIndex = ASObject$1.prototype.axNextNameIndex;
            proto.axNextValue = ASObject$1.prototype.axNextValue;
            var asProto = Float64Vector.prototype;
            defineNonEnumerableProperty(proto, '$Bgjoin', asProto.join);
            // Same as join, see VectorImpl.as in Tamarin repository.
            defineNonEnumerableProperty(proto, '$BgtoString', asProto.join);
            defineNonEnumerableProperty(proto, '$BgtoLocaleString', asProto.toLocaleString);
            defineNonEnumerableProperty(proto, '$Bgpop', asProto.pop);
            defineNonEnumerableProperty(proto, '$Bgpush', asProto.push);
            defineNonEnumerableProperty(proto, '$Bgreverse', asProto.reverse);
            defineNonEnumerableProperty(proto, '$Bgconcat', asProto.concat);
            defineNonEnumerableProperty(proto, '$Bgsplice', asProto.splice);
            defineNonEnumerableProperty(proto, '$Bgslice', asProto.slice);
            defineNonEnumerableProperty(proto, '$Bgshift', asProto.shift);
            defineNonEnumerableProperty(proto, '$Bgunshift', asProto.unshift);
            defineNonEnumerableProperty(proto, '$BgindexOf', asProto.indexOf);
            defineNonEnumerableProperty(proto, '$BglastIndexOf', asProto.lastIndexOf);
            defineNonEnumerableProperty(proto, '$BgforEach', asProto.forEach);
            defineNonEnumerableProperty(proto, '$Bgmap', asProto.map);
            defineNonEnumerableProperty(proto, '$Bgfilter', asProto.filter);
            defineNonEnumerableProperty(proto, '$Bgsome', asProto.some);
            defineNonEnumerableProperty(proto, '$Bgevery', asProto.every);
            defineNonEnumerableProperty(proto, '$Bgsort', asProto.sort);
            defineNonEnumerableProperty(proto, 'checkVectorMethodArgs', asProto.checkVectorMethodArgs);
        };
        Float64Vector.axApply = function (_, args) {
            var object = args[0];
            if (this.axIsType(object)) {
                return object;
            }
            var length = object.axGetPublicProperty("length");
            if (length !== undefined) {
                var v = this.axConstruct([length, false]);
                for (var i = 0; i < length; i++) {
                    v.axSetNumericProperty(i, object.axGetPublicProperty(i));
                }
                return v;
            }
            unexpected();
        };
        Float64Vector.prototype.internalToString = function () {
            var str = "";
            var start = this._offset;
            var end = start + this._length;
            for (var i = 0; i < this._buffer.length; i++) {
                if (i === start) {
                    str += "[";
                }
                if (i === end) {
                    str += "]";
                }
                str += this._buffer[i];
                if (i < this._buffer.length - 1) {
                    str += ",";
                }
            }
            if (this._offset + this._length === this._buffer.length) {
                str += "]";
            }
            return str + ": offset: " + this._offset + ", length: " + this._length + ", capacity: " + this._buffer.length;
        };
        Float64Vector.prototype.toString = function () {
            var str = "";
            for (var i = 0; i < this._length; i++) {
                str += this._buffer[this._offset + i];
                if (i < this._length - 1) {
                    str += ",";
                }
            }
            return str;
        };
        Float64Vector.prototype.toLocaleString = function () {
            var str = "";
            for (var i = 0; i < this._length; i++) {
                str += this._buffer[this._offset + i];
                if (i < this._length - 1) {
                    str += ",";
                }
            }
            return str;
        };
        // vector.prototype.toString = vector.prototype.internalToString;
        Float64Vector.prototype._view = function () {
            return this._buffer.subarray(this._offset, this._offset + this._length);
        };
        Float64Vector.prototype._ensureCapacity = function (length) {
            var minCapacity = this._offset + length;
            if (minCapacity < this._buffer.length) {
                return;
            }
            if (length <= this._buffer.length) {
                // New length exceeds bounds at current offset but fits in the buffer, so we center it.
                var offset = (this._buffer.length - length) >> 2;
                this._buffer.set(this._view(), offset);
                this._offset = offset;
                return;
            }
            // New length doesn't fit at all, resize buffer.
            var oldCapacity = this._buffer.length;
            var newCapacity = ((oldCapacity * 3) >> 1) + 1;
            if (newCapacity < minCapacity) {
                newCapacity = minCapacity;
            }
            var buffer = new Float64Array(newCapacity);
            buffer.set(this._buffer, 0);
            this._buffer = buffer;
        };
        Float64Vector.prototype.concat = function () {
            var length = this._length;
            for (var i = 0; i < arguments.length; i++) {
                var vector = arguments[i];
                if (!(vector._buffer instanceof Float64Array)) {
                    assert(false); // TODO
                    // this.sec.throwError('TypeError', Errors.CheckTypeFailedError,
                    // vector.constructor.name, '__AS3__.vec.Vector.<Number>');
                }
                length += vector._length;
            }
            var result = new this.sec.Float64Vector(length);
            var buffer = result._buffer;
            buffer.set(this._buffer);
            var offset = this._length;
            for (var i = 0; i < arguments.length; i++) {
                var vector = arguments[i];
                if (offset + vector._buffer.length < vector._buffer.length) {
                    buffer.set(vector._buffer, offset);
                }
                else {
                    buffer.set(vector._buffer.subarray(0, vector._length), offset);
                }
                offset += vector._length;
            }
            return result;
        };
        /**
         * Executes a |callback| function with three arguments: element, index, the vector itself as
         * well as passing the |thisObject| as |this| for each of the elements in the vector. If any of
         * the callbacks return |false| the function terminates, otherwise it returns |true|.
         */
        Float64Vector.prototype.every = function (callback, thisObject) {
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return true;
            }
            for (var i = 0; i < this._length; i++) {
                if (!callback.call(thisObject, this._buffer[this._offset + i], i, this)) {
                    return false;
                }
            }
            return true;
        };
        /**
         * Filters the elements for which the |callback| method returns |true|. The |callback| function
         * is called with three arguments: element, index, the vector itself as well as passing the
         * |thisObject| as |this| for each of the elements in the vector.
         */
        Float64Vector.prototype.filter = function (callback, thisObject) {
            var v = new this.sec.Float64Vector();
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return v;
            }
            for (var i = 0; i < this._length; i++) {
                if (callback.call(thisObject, this._buffer[this._offset + i], i, this)) {
                    v.push(this._buffer[this._offset + i]);
                }
            }
            return v;
        };
        Float64Vector.prototype.map = function (callback, thisObject) {
            var v = this.axClass.axConstruct([this.length, false]);
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return v;
            }
            for (var i = 0; i < this._length; i++) {
                v[i] = callback.call(thisObject, this._buffer[this._offset + i], i, this);
            }
            return v;
        };
        Float64Vector.prototype.some = function (callback, thisObject) {
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return false;
            }
            for (var i = 0; i < this._length; i++) {
                if (callback.call(thisObject, this._buffer[this._offset + i], i, this)) {
                    return true;
                }
            }
            return false;
        };
        Float64Vector.prototype.forEach = function (callback, thisObject) {
            if (!this.checkVectorMethodArgs(callback, thisObject)) {
                return;
            }
            for (var i = 0; i < this._length; i++) {
                callback.call(thisObject, this._buffer[this._offset + i], i, this);
            }
        };
        Float64Vector.prototype.join = function (separator) {
            if (separator === void 0) { separator = ','; }
            var limit = this.length;
            var buffer = this._buffer;
            var offset = this._offset;
            var result = "";
            for (var i = 0; i < limit - 1; i++) {
                result += buffer[offset + i] + separator;
            }
            if (limit > 0) {
                result += buffer[offset + limit - 1];
            }
            return result;
        };
        Float64Vector.prototype.indexOf = function (searchElement, fromIndex) {
            if (fromIndex === void 0) { fromIndex = 0; }
            var length = this._length;
            var start = fromIndex | 0;
            if (start < 0) {
                start = start + length;
                if (start < 0) {
                    start = 0;
                }
            }
            else if (start >= length) {
                return -1;
            }
            var buffer = this._buffer;
            var length = this._length;
            var offset = this._offset;
            start += offset;
            var end = offset + length;
            for (var i = start; i < end; i++) {
                if (buffer[i] === searchElement) {
                    return i - offset;
                }
            }
            return -1;
        };
        Float64Vector.prototype.lastIndexOf = function (searchElement, fromIndex) {
            if (fromIndex === void 0) { fromIndex = 0x7fffffff; }
            var length = this._length;
            var start = fromIndex | 0;
            if (start < 0) {
                start = start + length;
                if (start < 0) {
                    return -1;
                }
            }
            else if (start >= length) {
                start = length;
            }
            var buffer = this._buffer;
            var offset = this._offset;
            start += offset;
            var end = offset;
            for (var i = start; i-- > end;) {
                if (buffer[i] === searchElement) {
                    return i - offset;
                }
            }
            return -1;
        };
        Float64Vector.prototype.push = function (arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8 /*...rest*/) {
            this._checkFixed();
            this._ensureCapacity(this._length + arguments.length);
            for (var i = 0; i < arguments.length; i++) {
                this._buffer[this._offset + this._length++] = arguments[i];
            }
        };
        Float64Vector.prototype.pop = function () {
            this._checkFixed();
            if (this._length === 0) {
                return Float64Vector.DEFAULT_VALUE;
            }
            this._length--;
            return this._buffer[this._offset + this._length];
            // TODO: should we potentially reallocate to a smaller buffer here?
        };
        Float64Vector.prototype.reverse = function () {
            var l = this._offset;
            var r = this._offset + this._length - 1;
            var b = this._buffer;
            while (l < r) {
                var t = b[l];
                b[l] = b[r];
                b[r] = t;
                l++;
                r--;
            }
            return this;
        };
        Float64Vector.prototype.sort = function (sortBehavior) {
            if (arguments.length === 0) {
                Array.prototype.sort.call(this._view());
                return this;
            }
            if (this.sec.AXFunction.axIsType(sortBehavior)) {
                Array.prototype.sort.call(this._view(), sortBehavior.value);
                return this;
            }
            var options = sortBehavior | 0;
            release$1 || assertNotImplemented(!(options & Float64Vector.UNIQUESORT), "UNIQUESORT");
            release$1 || assertNotImplemented(!(options & Float64Vector.RETURNINDEXEDARRAY), "RETURNINDEXEDARRAY");
            if (options & Float64Vector.DESCENDING) {
                Array.prototype.sort.call(this._view(), function (a, b) { return b - a; });
            }
            else {
                Array.prototype.sort.call(this._view(), function (a, b) { return a - b; });
            }
            return this;
        };
        Float64Vector.prototype.shift = function () {
            this._checkFixed();
            if (this._length === 0) {
                return 0;
            }
            this._length--;
            return this._buffer[this._offset++];
        };
        Float64Vector.prototype.unshift = function () {
            this._checkFixed();
            if (!arguments.length) {
                return;
            }
            this._ensureCapacity(this._length + arguments.length);
            this._slide(arguments.length);
            this._offset -= arguments.length;
            this._length += arguments.length;
            for (var i = 0; i < arguments.length; i++) {
                this._buffer[this._offset + i] = arguments[i];
            }
        };
        Float64Vector.prototype.slice = function (start, end) {
            if (start === void 0) { start = 0; }
            if (end === void 0) { end = 0x7fffffff; }
            var buffer = this._buffer;
            var length = this._length;
            var first = Math.min(Math.max(start, 0), length);
            var last = Math.min(Math.max(end, first), length);
            var result = new this.sec.Float64Vector(last - first, this.fixed);
            result._buffer.set(buffer.subarray(this._offset + first, this._offset + last), result._offset);
            return result;
        };
        Float64Vector.prototype.splice = function (start, deleteCount_ /*, ...items: number[] */) {
            var buffer = this._buffer;
            var length = this._length;
            var first = Math.min(Math.max(start, 0), length);
            var startOffset = this._offset + first;
            var deleteCount = Math.min(Math.max(deleteCount_, 0), length - first);
            var insertCount = arguments.length - 2;
            var deletedItems;
            var result = new this.sec.Float64Vector(deleteCount, this.fixed);
            if (deleteCount > 0) {
                deletedItems = buffer.subarray(startOffset, startOffset + deleteCount);
                result._buffer.set(deletedItems, result._offset);
            }
            this._ensureCapacity(length - deleteCount + insertCount);
            var right = startOffset + deleteCount;
            var slice = buffer.subarray(right, length);
            buffer.set(slice, startOffset + insertCount);
            this._length += insertCount - deleteCount;
            for (var i = 0; i < insertCount; i++) {
                buffer[startOffset + i] = arguments[i + 2];
            }
            return result;
        };
        Float64Vector.prototype._slide = function (distance) {
            this._buffer.set(this._view(), this._offset + distance);
            this._offset += distance;
        };
        Object.defineProperty(Float64Vector.prototype, "length", {
            get: function () {
                return this._length;
            },
            set: function (value) {
                value = value >>> 0;
                if (value > this._length) {
                    this._ensureCapacity(value);
                    for (var i = this._offset + this._length, j = this._offset + value; i < j; i++) {
                        this._buffer[i] = Float64Vector.DEFAULT_VALUE;
                    }
                }
                this._length = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Float64Vector.prototype, "fixed", {
            get: function () {
                return this._fixed;
            },
            set: function (f) {
                this._fixed = !!f;
            },
            enumerable: true,
            configurable: true
        });
        Float64Vector.prototype._checkFixed = function () {
            if (this._fixed) {
                this.sec.throwError("RangeError", Errors$1.VectorFixedError);
            }
        };
        Float64Vector.prototype.axGetNumericProperty = function (nm) {
            release$1 || assert(isNumeric(nm));
            var length = this._length;
            var idx = nm | 0;
            if (idx < 0 || idx >= length || idx != nm) {
                this.sec.throwError("RangeError", Errors$1.OutOfRangeError, nm, length);
            }
            return this._buffer[this._offset + idx];
        };
        Float64Vector.prototype.axSetNumericProperty = function (nm, v) {
            release$1 || assert(isNumeric(nm));
            var length = this._length;
            var idx = nm | 0;
            if (idx < 0 || idx > length || idx != nm || (idx === length && this._fixed)) {
                this.sec.throwError("RangeError", Errors$1.OutOfRangeError, nm, length);
            }
            if (idx === this._length) {
                this._ensureCapacity(this._length + 1);
                this._length++;
            }
            this._buffer[this._offset + idx] = v;
        };
        Float64Vector.prototype.axHasPropertyInternal = function (mn) {
            // Optimization for the common case of indexed element accesses.
            if ((mn.name | 0) === mn.name) {
                release$1 || assert(mn.isRuntimeName());
                return mn.name >= 0 && mn.name < this._length;
            }
            var name = axCoerceName(mn.name);
            if (mn.isRuntimeName() && isIndex(name)) {
                var index = name >>> 0;
                return index >= 0 && index < this._length;
            }
            return this.axResolveMultiname(mn) in this;
        };
        Float64Vector.prototype.axNextValue = function (index) {
            return this._buffer[this._offset + index - 1];
        };
        Float64Vector.prototype.axNextNameIndex = function (index) {
            var nextNameIndex = index + 1;
            if (nextNameIndex <= this._length) {
                return nextNameIndex;
            }
            return 0;
        };
        Float64Vector.EXTRA_CAPACITY = 4;
        Float64Vector.INITIAL_CAPACITY = 10;
        Float64Vector.DEFAULT_VALUE = 0;
        Float64Vector.DESCENDING = 2;
        Float64Vector.UNIQUESORT = 4;
        Float64Vector.RETURNINDEXEDARRAY = 8;
        return Float64Vector;
    }(BaseVector));

    var ASMath = /** @class */ (function (_super) {
        __extends(ASMath, _super);
        function ASMath() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ASMath.classNatives = [Math];
        ASMath.classInitializer = function () {
            defineNonEnumerableProperty(this, '$BgE', Math.E);
            defineNonEnumerableProperty(this, '$BgLN10', Math.LN10);
            defineNonEnumerableProperty(this, '$BgLN2', Math.LN2);
            defineNonEnumerableProperty(this, '$BgLOG10E', Math.LOG10E);
            defineNonEnumerableProperty(this, '$BgLOG2E', Math.LOG2E);
            defineNonEnumerableProperty(this, '$BgPI', Math.PI);
            defineNonEnumerableProperty(this, '$BgSQRT1_2', Math.SQRT2);
            defineNonEnumerableProperty(this, '$BgSQRT2', Math.SQRT2);
        };
        return ASMath;
    }(ASObject$1));

    var ASRegExp = /** @class */ (function (_super) {
        __extends(ASRegExp, _super);
        function ASRegExp(pattern, flags) {
            var _this = _super.call(this) || this;
            _this._dotall = false;
            _this._extended = false;
            _this._captureNames = [];
            var source;
            if (pattern === undefined) {
                pattern = source = '';
            }
            else if (_this.sec.AXRegExp.axIsType(pattern)) {
                if (flags) {
                    _this.sec.throwError("TypeError", Errors$1.RegExpFlagsArgumentError);
                }
                source = pattern.source;
                pattern = pattern.value;
            }
            else {
                pattern = String(pattern);
                // Escape all forward slashes.
                source = pattern.replace(/(^|^[\/]|(?:\\\\)+)\//g, '$1\\/');
                if (flags) {
                    var f = flags;
                    flags = '';
                    for (var i = 0; i < f.length; i++) {
                        var flag = f[i];
                        switch (flag) {
                            case 's':
                                // With the s flag set, . will match the newline character.
                                _this._dotall = true;
                                break;
                            case 'x':
                                // With the x flag set, spaces in the regular expression, will be ignored as part of
                                // the pattern.
                                _this._extended = true;
                                break;
                            case 'g':
                            case 'i':
                            case 'm':
                                // Only keep valid flags since an ECMAScript compatible RegExp implementation will
                                // throw on invalid ones. We have to avoid that in ActionScript.
                                flags += flag;
                        }
                    }
                }
                pattern = _this._parse(source);
            }
            try {
                _this.value = new RegExp(pattern, flags);
            }
            catch (e) {
                // Our pattern pre-parser should have eliminated most errors, but in some cases we can't
                // meaningfully detect them. If that happens, just catch the error and substitute an
                // unmatchable pattern here.
                _this.value = new RegExp(ASRegExp.UNMATCHABLE_PATTERN, flags);
            }
            _this._source = source;
            return _this;
        }
        ASRegExp.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = ASRegExp.prototype;
            addPrototypeFunctionAlias(proto, '$BgtoString', asProto.ecmaToString);
            addPrototypeFunctionAlias(proto, '$Bgexec', asProto.exec);
            addPrototypeFunctionAlias(proto, '$Bgtest', asProto.test);
        };
        // Parses and sanitizes a AS3 RegExp pattern to be used in JavaScript. Silently fails and
        // returns an unmatchable pattern of the source turns out to be invalid.
        ASRegExp.prototype._parse = function (pattern) {
            var result = '';
            var captureNames = this._captureNames;
            var parens = [];
            var atoms = 0;
            for (var i = 0; i < pattern.length; i++) {
                var char = pattern[i];
                switch (char) {
                    case '(':
                        result += char;
                        parens.push(atoms > 1 ? atoms - 1 : atoms);
                        atoms = 0;
                        if (pattern[i + 1] === '?') {
                            switch (pattern[i + 2]) {
                                case ':':
                                case '=':
                                case '!':
                                    result += '?' + pattern[i + 2];
                                    i += 2;
                                    break;
                                default:
                                    if (/\(\?P<([\w$]+)>/.exec(pattern.substr(i))) {
                                        var name = RegExp.$1;
                                        if (name !== 'length') {
                                            captureNames.push(name);
                                        }
                                        if (captureNames.indexOf(name) > -1) {
                                            // TODO: Handle the case were same name is used for multiple groups.
                                        }
                                        i += RegExp.lastMatch.length - 1;
                                    }
                                    else {
                                        return ASRegExp.UNMATCHABLE_PATTERN;
                                    }
                            }
                        }
                        else {
                            captureNames.push(null);
                        }
                        // 406 seems to be the maximum number of capturing groups allowed in a pattern.
                        // Examined by testing.
                        if (captureNames.length > 406) {
                            return ASRegExp.UNMATCHABLE_PATTERN;
                        }
                        break;
                    case ')':
                        if (!parens.length) {
                            return ASRegExp.UNMATCHABLE_PATTERN;
                        }
                        result += char;
                        atoms = parens.pop() + 1;
                        break;
                    case '|':
                        result += char;
                        break;
                    case '\\':
                        result += char;
                        if (/\\|c[A-Z]|x[0-9,a-z,A-Z]{2}|u[0-9,a-z,A-Z]{4}|./.exec(pattern.substr(i + 1))) {
                            result += RegExp.lastMatch;
                            i += RegExp.lastMatch.length;
                        }
                        if (atoms <= 1) {
                            atoms++;
                        }
                        break;
                    case '[':
                        if (/\[[^\]]*\]/.exec(pattern.substr(i))) {
                            result += RegExp.lastMatch;
                            i += RegExp.lastMatch.length - 1;
                            if (atoms <= 1) {
                                atoms++;
                            }
                        }
                        else {
                            return ASRegExp.UNMATCHABLE_PATTERN;
                        }
                        break;
                    case '{':
                        if (/\{[^\{]*?(?:,[^\{]*?)?\}/.exec(pattern.substr(i))) {
                            result += RegExp.lastMatch;
                            i += RegExp.lastMatch.length - 1;
                        }
                        else {
                            return ASRegExp.UNMATCHABLE_PATTERN;
                        }
                        break;
                    case '.':
                        if (this._dotall) {
                            result += '[\\s\\S]';
                        }
                        else {
                            result += char;
                        }
                        if (atoms <= 1) {
                            atoms++;
                        }
                        break;
                    case '?':
                    case '*':
                    case '+':
                        if (!atoms) {
                            return ASRegExp.UNMATCHABLE_PATTERN;
                        }
                        result += char;
                        if (pattern[i + 1] === '?') {
                            i++;
                            result += '?';
                        }
                        break;
                    case ' ':
                        if (this._extended) {
                            break;
                        }
                    default:
                        result += char;
                        if (atoms <= 1) {
                            atoms++;
                        }
                }
                // 32767 seams to be the maximum allowed length for RegExps in SpiderMonkey.
                // Examined by testing.
                if (result.length > 0x7fff) {
                    return ASRegExp.UNMATCHABLE_PATTERN;
                }
            }
            if (parens.length) {
                return ASRegExp.UNMATCHABLE_PATTERN;
            }
            return result;
        };
        ASRegExp.prototype.ecmaToString = function () {
            var out = "/" + this._source + "/";
            if (this.value.global)
                out += "g";
            if (this.value.ignoreCase)
                out += "i";
            if (this.value.multiline)
                out += "m";
            if (this._dotall)
                out += "s";
            if (this._extended)
                out += "x";
            return out;
        };
        ASRegExp.prototype.axCall = function (ignoredThisArg) {
            return this.exec.apply(this, arguments);
        };
        ASRegExp.prototype.axApply = function (ignoredThisArg, argArray) {
            return this.exec.apply(this, argArray);
        };
        Object.defineProperty(ASRegExp.prototype, "source", {
            get: function () {
                return this._source;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASRegExp.prototype, "global", {
            get: function () {
                return this.value.global;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASRegExp.prototype, "ignoreCase", {
            get: function () {
                return this.value.ignoreCase;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASRegExp.prototype, "multiline", {
            get: function () {
                return this.value.multiline;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASRegExp.prototype, "lastIndex", {
            get: function () {
                return this.value.lastIndex;
            },
            set: function (value) {
                this.value.lastIndex = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASRegExp.prototype, "dotall", {
            get: function () {
                return this._dotall;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASRegExp.prototype, "extended", {
            get: function () {
                return this._extended;
            },
            enumerable: true,
            configurable: true
        });
        ASRegExp.prototype.exec = function (str) {
            if (str === void 0) { str = ''; }
            var result = this.value.exec(str);
            if (!result) {
                return null;
            }
            var axResult = transformJStoASRegExpMatchArray(this.sec, result);
            var captureNames = this._captureNames;
            if (captureNames) {
                for (var i = 0; i < captureNames.length; i++) {
                    var name = captureNames[i];
                    if (name !== null) {
                        // In AS3, non-matched named capturing groups return an empty string.
                        var value = result[i + 1] || '';
                        result[name] = value;
                        axResult.axSetPublicProperty(name, value);
                    }
                }
                return axResult;
            }
        };
        ASRegExp.prototype.test = function (str) {
            if (str === void 0) { str = ''; }
            return this.exec(str) !== null;
        };
        ASRegExp.UNMATCHABLE_PATTERN = '^(?!)$';
        return ASRegExp;
    }(ASObject$1));

    /**
     * Transforms an AS value into a JS value.
     */
    function transformASValueToJS(sec, value, deep) {
        if (typeof value !== "object") {
            return value;
        }
        if (isNullOrUndefined(value)) {
            return value;
        }
        if (sec.AXArray.axIsType(value)) {
            var resultList = [];
            var list = value.value;
            for (var i = 0; i < list.length; i++) {
                var entry = list[i];
                var jsValue = deep ? transformASValueToJS(sec, entry, true) : entry;
                resultList.push(jsValue);
            }
            return resultList;
        }
        var keys = Object.keys(value);
        var resultObject = {};
        for (var i = 0; i < keys.length; i++) {
            var key = keys[i];
            var jsKey = key;
            if (!isNumeric(key)) {
                release$1 || assert(key.indexOf('$Bg') === 0);
                jsKey = key.substr(3);
            }
            var v = value[key];
            if (deep) {
                v = transformASValueToJS(sec, v, true);
            }
            resultObject[jsKey] = v;
        }
        return resultObject;
    }

    function walk(sec, holder, name, reviver) {
        var val = holder[name];
        if (Array.isArray(val)) {
            var v = val;
            for (var i = 0, limit = v.length; i < limit; i++) {
                var newElement = walk(sec, v, axCoerceString$3(i), reviver);
                if (newElement === undefined) {
                    delete v[i];
                }
                else {
                    v[i] = newElement;
                }
            }
        }
        else if (val !== null && typeof val !== 'boolean' && typeof val !== 'number' &&
            typeof val !== 'string') {
            for (var p in val) {
                if (!val.hasOwnProperty(p) || !Multiname.isPublicQualifiedName(p)) {
                    break;
                }
                var newElement = walk(sec, val, p, reviver);
                if (newElement === undefined) {
                    delete val[p];
                }
                else {
                    val[p] = newElement;
                }
            }
        }
        return reviver.call(holder, name, val);
    }

    var ASJSON = /** @class */ (function (_super) {
        __extends(ASJSON, _super);
        function ASJSON() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ASJSON.parse = function (text, reviver) {
            if (reviver === void 0) { reviver = null; }
            text = axCoerceString$3(text);
            if (reviver !== null && !axIsCallable(reviver)) {
                this.sec.throwError('TypeError', Errors$1.CheckTypeFailedError, reviver, 'Function');
            }
            if (text === null) {
                this.sec.throwError('SyntaxError', Errors$1.JSONInvalidParseInput);
            }
            try {
                var unfiltered = transformJSValueToAS(this.sec, JSON.parse(text), true);
            }
            catch (e) {
                this.sec.throwError('SyntaxError', Errors$1.JSONInvalidParseInput);
            }
            if (reviver === null) {
                return unfiltered;
            }
            return walk(this.sec, { "": unfiltered }, "", reviver.value);
        };
        ASJSON.stringify = function (value, replacer, space) {
            if (replacer === void 0) { replacer = null; }
            if (space === void 0) { space = null; }
            // We deliberately deviate from ECMA-262 and throw on
            // invalid replacer parameter.
            if (replacer !== null) {
                var sec = typeof replacer === 'object' ? replacer.sec : null;
                if (!sec || !(sec.AXFunction.axIsType(replacer) || sec.AXArray.axIsType(replacer))) {
                    this.sec.throwError('TypeError', Errors$1.JSONInvalidReplacer);
                }
            }
            var gap;
            if (typeof space === 'string') {
                gap = space.length > 10 ? space.substring(0, 10) : space;
            }
            else if (typeof space === 'number') {
                gap = "          ".substring(0, Math.min(10, space | 0));
            }
            else {
                // We follow ECMA-262 and silently ignore invalid space parameter.
                gap = "";
            }
            if (replacer === null) {
                return this.stringifySpecializedToString(value, null, null, gap);
            }
            else if (sec.AXArray.axIsType(replacer)) {
                return this.stringifySpecializedToString(value, this.computePropertyList(replacer.value), null, gap);
            }
            else { // replacer is Function
                return this.stringifySpecializedToString(value, null, replacer.value, gap);
            }
        };
        // ECMA-262 5th ed, section 15.12.3 stringify, step 4.b
        ASJSON.computePropertyList = function (r) {
            var propertyList = [];
            var alreadyAdded = Object.create(null);
            for (var i = 0, length = r.length; i < length; i++) {
                if (!r.hasOwnProperty(i)) {
                    continue;
                }
                var v = r[i];
                var item = null;
                if (typeof v === 'string') {
                    item = v;
                }
                else if (typeof v === 'number') {
                    item = axCoerceString$3(v);
                }
                if (item !== null && !alreadyAdded[item]) {
                    alreadyAdded[item] = true;
                    propertyList.push(item);
                }
            }
            return propertyList;
        };
        ASJSON.stringifySpecializedToString = function (value, replacerArray, replacerFunction, gap) {
            try {
                // In AS3 |JSON.stringify(undefined)| returns "null", while JS returns |undefined|.
                // TODO: Is there anything to be done in case of a |replacerFunction| function?
                if (value === undefined) {
                    return "null";
                }
                return JSON.stringify(transformASValueToJS(this.sec, value, true), replacerFunction, gap);
            }
            catch (e) {
                this.sec.throwError('TypeError', Errors$1.JSONCyclicStructure);
            }
        };
        return ASJSON;
    }(ASObject$1));

    function FlashUtilScript_getDefinitionByName(sec, name) {
        var simpleName = String(name).replace("::", ".");
        return getCurrentABC().env.app.getClass(Multiname.FromFQNString(simpleName, 0 /* Public */));
    }

    function FlashUtilScript_getTimer$1(sec) {
        return Date.now() - sec.flash.display.Loader.axClass.runtimeStartTime;
    }

    function FlashNetScript_navigateToURL$1(sec, request, window_) {
        if (request === null || request === undefined) {
            sec.throwError('TypeError', Errors$1.NullPointerError, 'request');
        }
        var RequestClass = sec.flash.net.URLRequest.axClass;
        if (!RequestClass.axIsType(request)) {
            sec.throwError('TypeError', Errors$1.CheckTypeFailedError, request, 'flash.net.URLRequest');
        }
        var url = request.url;
        if (isNullOrUndefined(url)) {
            sec.throwError('TypeError', Errors$1.NullPointerError, 'url');
        }
        if (url.toLowerCase().indexOf('fscommand:') === 0) {
            var fscommand = sec.flash.system.fscommand.value;
            fscommand(sec, url.substring('fscommand:'.length), window_);
            return;
        }
        // TODO handle other methods than GET
        //console.log("TODO: FlashNetScript_navigateToURL: FileLoadingService")
        window.open(request.url, '_blank');
        //FileLoadingService.navigateTo(url, window_);
    }

    function FlashNetScript_sendToURL(sec, request) {
        if (isNullOrUndefined(request)) {
            sec.throwError('TypeError', Errors$1.NullPointerError, 'request');
        }
        var RequestClass = sec.flash.net.URLRequest.axClass;
        if (!RequestClass.axIsType(request)) {
            sec.throwError('TypeError', Errors$1.CheckTypeFailedError, request, 'flash.net.URLRequest');
        }
        console.log("TODO: FlashNetScript_sendToURL: FileLoadingService");
        /*var session = FileLoadingService.createSession();
        session.onprogress = function () {
          // ...
        };
        session.open(request);*/
    }

    function Toplevel_registerClassAlias(sec, aliasName, classObject) {
        aliasName = axCoerceString$3(aliasName);
        if (!aliasName) {
            sec.throwError('TypeError', Errors$1.NullPointerError, 'aliasName');
        }
        if (!classObject) {
            sec.throwError('TypeError', Errors$1.NullPointerError, 'classObject');
        }
        sec.classAliases.registerClassAlias(aliasName, classObject);
    }

    function Toplevel_getClassByAlias(sec, aliasName) {
        aliasName = axCoerceString$3(aliasName);
        if (!aliasName) {
            sec.throwError('TypeError', Errors$1.NullPointerError, 'aliasName');
        }
        var axClass = sec.classAliases.getClassByAlias(aliasName);
        if (!axClass) {
            sec.throwError('ReferenceError', Errors$1.ClassNotFoundError, aliasName);
        }
        return axClass;
    }

    var ASError = /** @class */ (function (_super) {
        __extends(ASError, _super);
        function ASError(message, id) {
            var _this = _super.call(this) || this;
            if (arguments.length < 1) {
                message = '';
            }
            _this.$Bgmessage = String(message);
            _this._errorID = id | 0;
            return _this;
        }
        ASError.throwError = function (type, id /*, ...rest */) {
            var info = getErrorInfo(id);
            var args = [info];
            for (var i = 2; i < arguments.length; i++) {
                args.push(arguments[i]);
            }
            var message = formatErrorMessage.apply(null, args);
            throw type.axConstruct([message, id]);
        };
        ASError.classInitializer = function (asClass) {
            defineNonEnumerableProperty(this, '$Bglength', 1);
            defineNonEnumerableProperty(this.dPrototype, '$Bgname', this.classInfo.instanceInfo.getName().name);
            if (asClass === ASError) {
                defineNonEnumerableProperty(this.dPrototype, '$Bgmessage', 'Error');
                defineNonEnumerableProperty(this.dPrototype, '$BgtoString', ASError.prototype.toString);
            }
        };
        ASError.prototype.toString = function () {
            return this.$Bgmessage !== "" ? this.$Bgname + ": " + this.$Bgmessage : this.$Bgname;
        };
        Object.defineProperty(ASError.prototype, "errorID", {
            get: function () {
                return this._errorID;
            },
            enumerable: true,
            configurable: true
        });
        ASError.prototype.getStackTrace = function () {
            // Stack traces are only available in debug builds. We only do opt.
            return null;
        };
        ASError.getErrorMessage = getErrorMessage;
        return ASError;
    }(ASObject$1));
    var ASDefinitionError = /** @class */ (function (_super) {
        __extends(ASDefinitionError, _super);
        function ASDefinitionError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASDefinitionError;
    }(ASError));
    var ASEvalError = /** @class */ (function (_super) {
        __extends(ASEvalError, _super);
        function ASEvalError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASEvalError;
    }(ASError));
    var ASRangeError = /** @class */ (function (_super) {
        __extends(ASRangeError, _super);
        function ASRangeError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASRangeError;
    }(ASError));
    var ASReferenceError = /** @class */ (function (_super) {
        __extends(ASReferenceError, _super);
        function ASReferenceError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASReferenceError;
    }(ASError));
    var ASSecurityError = /** @class */ (function (_super) {
        __extends(ASSecurityError, _super);
        function ASSecurityError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASSecurityError;
    }(ASError));
    var ASSyntaxError = /** @class */ (function (_super) {
        __extends(ASSyntaxError, _super);
        function ASSyntaxError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASSyntaxError;
    }(ASError));
    var ASTypeError = /** @class */ (function (_super) {
        __extends(ASTypeError, _super);
        function ASTypeError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASTypeError;
    }(ASError));
    var ASURIError = /** @class */ (function (_super) {
        __extends(ASURIError, _super);
        function ASURIError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASURIError;
    }(ASError));
    var ASVerifyError = /** @class */ (function (_super) {
        __extends(ASVerifyError, _super);
        function ASVerifyError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASVerifyError;
    }(ASError));
    var ASUninitializedError = /** @class */ (function (_super) {
        __extends(ASUninitializedError, _super);
        function ASUninitializedError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASUninitializedError;
    }(ASError));
    var ASArgumentError = /** @class */ (function (_super) {
        __extends(ASArgumentError, _super);
        function ASArgumentError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASArgumentError;
    }(ASError));
    var ASIOError = /** @class */ (function (_super) {
        __extends(ASIOError, _super);
        function ASIOError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASIOError;
    }(ASError));
    var ASEOFError = /** @class */ (function (_super) {
        __extends(ASEOFError, _super);
        function ASEOFError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASEOFError;
    }(ASError));
    var ASMemoryError = /** @class */ (function (_super) {
        __extends(ASMemoryError, _super);
        function ASMemoryError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASMemoryError;
    }(ASError));
    var ASIllegalOperationError = /** @class */ (function (_super) {
        __extends(ASIllegalOperationError, _super);
        function ASIllegalOperationError() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return ASIllegalOperationError;
    }(ASError));

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var ASDate = /** @class */ (function (_super) {
        __extends(ASDate, _super);
        function ASDate(yearOrTimevalue, month, date, hour, minute, second, millisecond) {
            if (date === void 0) { date = 1; }
            if (hour === void 0) { hour = 0; }
            if (minute === void 0) { minute = 0; }
            if (second === void 0) { second = 0; }
            if (millisecond === void 0) { millisecond = 0; }
            var _this = _super.call(this) || this;
            switch (arguments.length) {
                case 0:
                    _this.value = new Date();
                    break;
                case 1:
                    _this.value = new Date(yearOrTimevalue);
                    break;
                case 2:
                    _this.value = new Date(yearOrTimevalue, month);
                    break;
                case 3:
                    _this.value = new Date(yearOrTimevalue, month, date);
                    break;
                case 4:
                    _this.value = new Date(yearOrTimevalue, month, date, hour);
                    break;
                case 5:
                    _this.value = new Date(yearOrTimevalue, month, date, hour, minute);
                    break;
                case 6:
                    _this.value = new Date(yearOrTimevalue, month, date, hour, minute, second);
                    break;
                default:
                    _this.value = new Date(yearOrTimevalue, month, date, hour, minute, second, millisecond);
                    break;
            }
            return _this;
        }
        ASDate.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = ASDate.prototype;
            addPrototypeFunctionAlias(proto, '$BgtoString', asProto.toString);
            addPrototypeFunctionAlias(proto, '$BgtoLocaleString', asProto.toString);
            addPrototypeFunctionAlias(proto, '$BgvalueOf', asProto.valueOf);
            addPrototypeFunctionAlias(proto, '$BgtoDateString', asProto.toDateString);
            addPrototypeFunctionAlias(proto, '$BgtoTimeString', asProto.toTimeString);
            addPrototypeFunctionAlias(proto, '$BgtoLocaleString', asProto.toLocaleString);
            addPrototypeFunctionAlias(proto, '$BgtoLocaleDateString', asProto.toLocaleDateString);
            addPrototypeFunctionAlias(proto, '$BgtoLocaleTimeString', asProto.toLocaleTimeString);
            addPrototypeFunctionAlias(proto, '$BgtoUTCString', asProto.toUTCString);
            // NB: The default AS implementation of |toJSON| is not ES5-compliant, but
            // the native JS one obviously is.
            addPrototypeFunctionAlias(proto, '$BgtoJSON', asProto.toJSON);
            addPrototypeFunctionAlias(proto, '$BggetUTCFullYear', asProto.getUTCFullYear);
            addPrototypeFunctionAlias(proto, '$BggetUTCMonth', asProto.getUTCMonth);
            addPrototypeFunctionAlias(proto, '$BggetUTCDate', asProto.getUTCDate);
            addPrototypeFunctionAlias(proto, '$BggetUTCDay', asProto.getUTCDay);
            addPrototypeFunctionAlias(proto, '$BggetUTCHours', asProto.getUTCHours);
            addPrototypeFunctionAlias(proto, '$BggetUTCMinutes', asProto.getUTCMinutes);
            addPrototypeFunctionAlias(proto, '$BggetUTCSeconds', asProto.getUTCSeconds);
            addPrototypeFunctionAlias(proto, '$BggetUTCMilliseconds', asProto.getUTCMilliseconds);
            addPrototypeFunctionAlias(proto, '$BggetFullYear', asProto.getFullYear);
            addPrototypeFunctionAlias(proto, '$BggetMonth', asProto.getMonth);
            addPrototypeFunctionAlias(proto, '$BggetDate', asProto.getDate);
            addPrototypeFunctionAlias(proto, '$BggetDay', asProto.getDay);
            addPrototypeFunctionAlias(proto, '$BggetHours', asProto.getHours);
            addPrototypeFunctionAlias(proto, '$BggetMinutes', asProto.getMinutes);
            addPrototypeFunctionAlias(proto, '$BggetSeconds', asProto.getSeconds);
            addPrototypeFunctionAlias(proto, '$BggetMilliseconds', asProto.getMilliseconds);
            addPrototypeFunctionAlias(proto, '$BggetTimezoneOffset', asProto.getTimezoneOffset);
            addPrototypeFunctionAlias(proto, '$BggetTime', asProto.getTime);
            addPrototypeFunctionAlias(proto, '$BgsetFullYear', asProto.setFullYear);
            addPrototypeFunctionAlias(proto, '$BgsetMonth', asProto.setMonth);
            addPrototypeFunctionAlias(proto, '$BgsetDate', asProto.setDate);
            addPrototypeFunctionAlias(proto, '$BgsetHours', proto.setHours);
            addPrototypeFunctionAlias(proto, '$BgsetMinutes', asProto.setMinutes);
            addPrototypeFunctionAlias(proto, '$BgsetSeconds', asProto.setSeconds);
            addPrototypeFunctionAlias(proto, '$BgsetMilliseconds', asProto.setMilliseconds);
            addPrototypeFunctionAlias(proto, '$BgsetUTCFullYear', asProto.setUTCFullYear);
            addPrototypeFunctionAlias(proto, '$BgsetUTCMonth', asProto.setUTCMonth);
            addPrototypeFunctionAlias(proto, '$BgsetUTCDate', asProto.setUTCDate);
            addPrototypeFunctionAlias(proto, '$BgsetUTCHours', asProto.setUTCHours);
            addPrototypeFunctionAlias(proto, '$BgsetUTCMinutes', asProto.setUTCMinutes);
            addPrototypeFunctionAlias(proto, '$BgsetUTCSeconds', asProto.setUTCSeconds);
            addPrototypeFunctionAlias(proto, '$BgsetUTCMilliseconds', asProto.setUTCMilliseconds);
        };
        ASDate.parse = function (date) {
            return Date.parse(date);
        };
        ASDate.UTC = function (year, month, date, hour, minute, second, millisecond) {
            if (date === void 0) { date = 1; }
            if (hour === void 0) { hour = 0; }
            if (minute === void 0) { minute = 0; }
            if (second === void 0) { second = 0; }
            if (millisecond === void 0) { millisecond = 0; }
            return Date.parse.apply(null, arguments);
        };
        ASDate.axCoerce = function (value) {
            return this.axConstruct([value]);
        };
        ASDate.prototype.toString = function () {
            if (!(this.value instanceof Date)) {
                return 'Invalid Date';
            }
            // JS formats dates differently, so a little surgery is required here:
            // We need to move the year to the end, get rid of the timezone name, and remove leading 0
            // from the day.
            var dateStr = this.value.toString();
            var parts = dateStr.split(' ');
            // Detect invalid dates. Not 100% sure all JS engines always print 'Invalid Date' here,
            // so we just check how many parts the resulting string has, with some margin for error.
            if (parts.length < 4) {
                return 'Invalid Date';
            }
            parts.length = 6; // Get rid of the timezone, which might contain spaces.
            parts.push(parts.splice(3, 1)[0]); // Move Year to the end.
            if (parts[2][0] === '0') {
                parts[2] = parts[2][1];
            }
            return parts.join(' ');
        };
        ASDate.prototype.toDateString = function () {
            if (!(this.value instanceof Date)) {
                return 'Invalid Date';
            }
            var dateStr = this.value.toDateString();
            var parts = dateStr.split(' ');
            // Detect invalid dates. Not 100% sure all JS engines always print 'Invalid Date' here,
            // so we just check how many parts the resulting string has, with some margin for error.
            if (parts.length < 4) {
                return 'Invalid Date';
            }
            if (parts[2][0] === '0') {
                parts[2] = parts[2][1];
            }
            return parts.join(' ');
        };
        ASDate.prototype.toJSON = function () { return !(this.value instanceof Date) ? 'Invalid Date' : this.value.toString(); };
        ASDate.prototype.valueOf = function () { return !(this.value instanceof Date) ? NaN : this.value.valueOf(); };
        ASDate.prototype.setTime = function (value) {
            if (value === void 0) { value = 0; }
            return !(this.value instanceof Date) ? NaN : this.value.setTime(value);
        };
        ASDate.prototype.toTimeString = function () { return !(this.value instanceof Date) ? 'Invalid Date' : this.value.toTimeString(); };
        ASDate.prototype.toLocaleString = function () { return !(this.value instanceof Date) ? 'Invalid Date' : this.value.toLocaleString(); };
        ASDate.prototype.toLocaleDateString = function () { return !(this.value instanceof Date) ? 'Invalid Date' : this.value.toLocaleDateString(); };
        ASDate.prototype.toLocaleTimeString = function () { return !(this.value instanceof Date) ? 'Invalid Date' : this.value.toLocaleTimeString(); };
        ASDate.prototype.toUTCString = function () { return !(this.value instanceof Date) ? 'Invalid Date' : this.value.toUTCString(); };
        ASDate.prototype.getUTCFullYear = function () { return !(this.value instanceof Date) ? NaN : this.value.getUTCFullYear(); };
        ASDate.prototype.getUTCMonth = function () { return !(this.value instanceof Date) ? NaN : this.value.getUTCMonth(); };
        ASDate.prototype.getUTCDate = function () { return !(this.value instanceof Date) ? NaN : this.value.getUTCDate(); };
        ASDate.prototype.getUTCDay = function () { return !(this.value instanceof Date) ? NaN : this.value.getUTCDay(); };
        ASDate.prototype.getUTCHours = function () { return !(this.value instanceof Date) ? NaN : this.value.getUTCHours(); };
        ASDate.prototype.getUTCMinutes = function () { return !(this.value instanceof Date) ? NaN : this.value.getUTCMinutes(); };
        ASDate.prototype.getUTCSeconds = function () { return !(this.value instanceof Date) ? NaN : this.value.getUTCSeconds(); };
        ASDate.prototype.getUTCMilliseconds = function () { return !(this.value instanceof Date) ? NaN : this.value.getUTCMilliseconds(); };
        ASDate.prototype.getFullYear = function () { return !(this.value instanceof Date) ? NaN : this.value.getFullYear(); };
        ASDate.prototype.getMonth = function () { return !(this.value instanceof Date) ? NaN : this.value.getMonth(); };
        ASDate.prototype.getDate = function () { return !(this.value instanceof Date) ? NaN : this.value.getDate(); };
        ASDate.prototype.getDay = function () { return !(this.value instanceof Date) ? NaN : this.value.getDay(); };
        ASDate.prototype.getHours = function () { return !(this.value instanceof Date) ? NaN : this.value.getHours(); };
        ASDate.prototype.getMinutes = function () { return !(this.value instanceof Date) ? NaN : this.value.getMinutes(); };
        ASDate.prototype.getSeconds = function () { return !(this.value instanceof Date) ? NaN : this.value.getSeconds(); };
        ASDate.prototype.getMilliseconds = function () { return !(this.value instanceof Date) ? NaN : this.value.getMilliseconds(); };
        ASDate.prototype.getTimezoneOffset = function () { return !(this.value instanceof Date) ? NaN : this.value.getTimezoneOffset(); };
        ASDate.prototype.getTime = function () { return !(this.value instanceof Date) ? NaN : this.value.getTime(); };
        ASDate.prototype.setFullYear = function (year, month, date) {
            return !(this.value instanceof Date) ? NaN : this.value.setFullYear.apply(this.value, arguments);
        };
        ASDate.prototype.setMonth = function (month, date) {
            return !(this.value instanceof Date) ? NaN : this.value.setMonth.apply(this.value, arguments);
        };
        ASDate.prototype.setDate = function (date) {
            return !(this.value instanceof Date) ? NaN : this.value.setDate.apply(this.value, arguments);
        };
        ASDate.prototype.setHours = function (hour, minutes, seconds, milliseconds) {
            return !(this.value instanceof Date) ? NaN : this.value.setHours.apply(this.value, arguments);
        };
        ASDate.prototype.setMinutes = function (minutes, seconds, milliseconds) {
            return !(this.value instanceof Date) ? NaN : this.value.setMinutes.apply(this.value, arguments);
        };
        ASDate.prototype.setSeconds = function (seconds, milliseconds) {
            return !(this.value instanceof Date) ? NaN : this.value.setSeconds.apply(this.value, arguments);
        };
        ASDate.prototype.setMilliseconds = function (milliseconds) {
            return !(this.value instanceof Date) ? NaN : this.value.setMilliseconds.apply(this.value, arguments);
        };
        ASDate.prototype.setUTCFullYear = function (year, month, date) {
            return !(this.value instanceof Date) ? NaN : this.value.setUTCFullYear.apply(this.value, arguments);
        };
        ASDate.prototype.setUTCMonth = function (month, date) {
            return !(this.value instanceof Date) ? NaN : this.value.setUTCMonth.apply(this.value, arguments);
        };
        ASDate.prototype.setUTCDate = function (date) {
            return !(this.value instanceof Date) ? NaN : this.value.setUTCDate.apply(this.value, arguments);
        };
        ASDate.prototype.setUTCHours = function (hour, minutes, seconds, milliseconds) {
            return !(this.value instanceof Date) ? NaN : this.value.setUTCHours.apply(this.value, arguments);
        };
        ASDate.prototype.setUTCMinutes = function (minutes, seconds, milliseconds) {
            return !(this.value instanceof Date) ? NaN : this.value.setUTCMinutes.apply(this.value, arguments);
        };
        ASDate.prototype.setUTCSeconds = function (seconds, milliseconds) {
            return !(this.value instanceof Date) ? NaN : this.value.setUTCSeconds.apply(this.value, arguments);
        };
        ASDate.prototype.setUTCMilliseconds = function (milliseconds) {
            return !(this.value instanceof Date) ? NaN : this.value.setUTCMilliseconds.apply(this.value, arguments);
        };
        Object.defineProperty(ASDate.prototype, "fullYear", {
            get: function () {
                return this.value.getFullYear();
            },
            set: function (value) {
                this.value.setFullYear(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "month", {
            get: function () {
                return this.value.getMonth();
            },
            set: function (value) {
                this.value.setMonth(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "date", {
            get: function () {
                return this.value.getDate();
            },
            set: function (value) {
                this.value.setDate(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "hours", {
            get: function () {
                return this.value.getHours();
            },
            set: function (value) {
                this.value.setHours(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "minutes", {
            get: function () {
                return this.value.getMinutes();
            },
            set: function (value) {
                this.value.setMinutes(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "seconds", {
            get: function () {
                return this.value.getSeconds();
            },
            set: function (value) {
                this.value.setSeconds(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "milliseconds", {
            get: function () {
                return this.value.getMilliseconds();
            },
            set: function (value) {
                this.value.setMilliseconds(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "fullYearUTC", {
            get: function () {
                return this.value.getUTCFullYear();
            },
            set: function (value) {
                this.value.setUTCFullYear(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "monthUTC", {
            get: function () {
                return this.value.getUTCMonth();
            },
            set: function (value) {
                this.value.setUTCMonth(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "dateUTC", {
            get: function () {
                return this.value.getUTCDate();
            },
            set: function (value) {
                this.value.setUTCDate(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "hoursUTC", {
            get: function () {
                return this.value.getUTCHours();
            },
            set: function (value) {
                this.value.setUTCHours(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "minutesUTC", {
            get: function () {
                return this.value.getUTCMinutes();
            },
            set: function (value) {
                this.value.setUTCMinutes(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "secondsUTC", {
            get: function () {
                return this.value.getUTCSeconds();
            },
            set: function (value) {
                this.value.setUTCSeconds(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "millisecondsUTC", {
            get: function () {
                return this.value.getUTCMilliseconds();
            },
            set: function (value) {
                this.value.setUTCMilliseconds(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "time", {
            get: function () {
                return this.value.getTime();
            },
            set: function (value) {
                this.value.setTime(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "timezoneOffset", {
            get: function () {
                return this.value.getTimezoneOffset();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "day", {
            get: function () {
                return this.value.getDay();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ASDate.prototype, "dayUTC", {
            get: function () {
                return this.value.getUTCDay();
            },
            enumerable: true,
            configurable: true
        });
        return ASDate;
    }(ASObject$1));

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var proxyNamespace = internNamespace(0 /* Public */, "http://www.adobe.com/2006/actionscript/flash/proxy");
    var proxyPrefix = '$' + proxyNamespace.mangledName;
    /**
     * The Proxy class lets you override the default behavior of ActionScript operations
     * (such as retrieving and modifying properties) on an object.
     */
    var ASProxy = /** @class */ (function (_super) {
        __extends(ASProxy, _super);
        function ASProxy() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        ASProxy.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = ASProxy.prototype;
            defineNonEnumerableProperty(proto, proxyPrefix + 'getProperty', asProto.native_getProperty);
            defineNonEnumerableProperty(proto, proxyPrefix + 'setProperty', asProto.native_setProperty);
            defineNonEnumerableProperty(proto, proxyPrefix + 'callProperty', asProto.native_callProperty);
            defineNonEnumerableProperty(proto, proxyPrefix + 'hasProperty', asProto.native_hasProperty);
            defineNonEnumerableProperty(proto, proxyPrefix + 'deleteProperty', asProto.native_deleteProperty);
            defineNonEnumerableProperty(proto, proxyPrefix + 'getDescendants', asProto.native_getDescendants);
            defineNonEnumerableProperty(proto, proxyPrefix + 'nextNameIndex', asProto.native_nextNameIndex);
            defineNonEnumerableProperty(proto, proxyPrefix + 'nextName', asProto.native_nextName);
            defineNonEnumerableProperty(proto, proxyPrefix + 'nextValue', asProto.native_nextValue);
        };
        ASProxy.prototype.native_getProperty = function () {
            this.sec.throwError("flash.errors.IllegalOperationError", Errors$1.ProxyGetPropertyError);
        };
        ASProxy.prototype.native_setProperty = function () {
            this.sec.throwError("flash.errors.IllegalOperationError", Errors$1.ProxySetPropertyError);
        };
        ASProxy.prototype.native_callProperty = function () {
            this.sec.throwError("flash.errors.IllegalOperationError", Errors$1.ProxyCallPropertyError);
        };
        ASProxy.prototype.native_hasProperty = function () {
            this.sec.throwError("flash.errors.IllegalOperationError", Errors$1.ProxyHasPropertyError);
        };
        ASProxy.prototype.native_deleteProperty = function () {
            this.sec.throwError("flash.errors.IllegalOperationError", Errors$1.ProxyDeletePropertyError);
        };
        ASProxy.prototype.native_getDescendants = function () {
            this.sec.throwError("flash.errors.IllegalOperationError", Errors$1.ProxyGetDescendantsError);
        };
        ASProxy.prototype.native_nextNameIndex = function () {
            // Enumeration traverses the prototype chain. For proxies, this causes problems
            // because a Proxy-extending class has the MOP override for `axNextNameIndex`, but can't
            // have the `nextNameIndex` hook defined and thus hits this default hook. In that case,
            // we'd incorrectly throw an error instead of just returning null if we didn't
            // special-case here.
            if (this === this.axClass.dPrototype) {
                return;
            }
            this.sec.throwError("flash.errors.IllegalOperationError", Errors$1.ProxyNextNameIndexError);
        };
        ASProxy.prototype.native_nextName = function () {
            this.sec.throwError("flash.errors.IllegalOperationError", Errors$1.ProxyNextNameError);
        };
        ASProxy.prototype.native_nextValue = function () {
            this.sec.throwError("flash.errors.IllegalOperationError", Errors$1.ProxyNextValueError);
        };
        ASProxy.prototype.axGetProperty = function (mn) {
            var value;
            var trait = typeof mn.name === 'string' ? this.traits.getTrait(mn.namespaces, mn.name) : null;
            if (trait) {
                var name = trait.name.getMangledName();
                value = this[name];
                if (typeof value === 'function') {
                    return this.axGetMethod(name);
                }
            }
            else {
                value = this[proxyPrefix + 'getProperty'](this.sec.AXQName.FromMultiname(mn));
            }
            return value;
        };
        ASProxy.prototype.axGetNumericProperty = function (name) {
            return this[proxyPrefix + 'getProperty']((+name) + '');
        };
        ASProxy.prototype.axSetNumericProperty = function (name, value) {
            this[proxyPrefix + 'setProperty']((+name) + '', value);
        };
        ASProxy.prototype.axSetProperty = function (mn, value, bc) {
            var trait = typeof mn.name === 'string' ? this.traits.getTrait(mn.namespaces, mn.name) : null;
            if (trait) {
                _super.prototype.axSetProperty.call(this, mn, value, bc);
                return;
            }
            this[proxyPrefix + 'setProperty'](this.sec.AXQName.FromMultiname(mn), value);
        };
        ASProxy.prototype.axCallProperty = function (mn, args, isLex) {
            var trait = typeof mn.name === 'string' ? this.traits.getTrait(mn.namespaces, mn.name) : null;
            if (trait) {
                return _super.prototype.axCallProperty.call(this, mn, args, isLex);
            }
            var callArgs = [this.sec.AXQName.FromMultiname(mn)].concat(args);
            return this[proxyPrefix + 'callProperty'].apply(this, callArgs);
        };
        ASProxy.prototype.axHasProperty = function (mn) {
            return this.axHasOwnProperty(mn);
        };
        ASProxy.prototype.axHasPublicProperty = function (nm) {
            rn$1.name = nm;
            if (this.axHasPropertyInternal(rn$1)) {
                return true;
            }
            return this[proxyPrefix + 'hasProperty'](nm);
        };
        ASProxy.prototype.axHasOwnProperty = function (mn) {
            var trait = typeof mn.name === 'string' ? this.traits.getTrait(mn.namespaces, mn.name) : null;
            if (trait) {
                return true;
            }
            return this[proxyPrefix + 'hasProperty'](this.sec.AXQName.FromMultiname(mn));
        };
        ASProxy.prototype.axDeleteProperty = function (mn) {
            var trait = typeof mn.name === 'string' ? this.traits.getTrait(mn.namespaces, mn.name) : null;
            if (trait) {
                return delete this[trait.name.getMangledName()];
            }
            return this[proxyPrefix + 'deleteProperty'](this.sec.AXQName.FromMultiname(mn));
        };
        ASProxy.prototype.axNextName = function (index) {
            return this[proxyPrefix + 'nextName'](index);
        };
        ASProxy.prototype.axNextValue = function (index) {
            return this[proxyPrefix + 'nextValue'](index);
        };
        ASProxy.prototype.axNextNameIndex = function (index) {
            return this[proxyPrefix + 'nextNameIndex'](index);
        };
        return ASProxy;
    }(ASObject$1));
    var rn$1 = new Multiname(null, 0, 17 /* RTQNameL */, [], null, null, true);

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    /**
     * TODO: We need a more robust Dictionary implementation that doesn't only give you back
     * string keys when enumerating.
     */
    var Dictionary = /** @class */ (function (_super) {
        __extends(Dictionary, _super);
        function Dictionary(weakKeys) {
            if (weakKeys === void 0) { weakKeys = false; }
            var _this = _super.call(this) || this;
            _this.map = new WeakMap();
            _this.keys = null;
            _this.weakKeys = !!weakKeys;
            if (!weakKeys) {
                _this.keys = [];
            }
            _this.primitiveMap = Object.create(null);
            return _this;
        }
        Dictionary.makePrimitiveKey = function (key) {
            if (typeof key === "string" || typeof key === "number") {
                return key;
            }
            release$1 || assert(typeof key === "object" || typeof key === "function", typeof key);
            return undefined;
        };
        Dictionary.prototype.toJSON = function () {
            return "Dictionary";
        };
        Dictionary.prototype.axGetProperty = function (mn) {
            if (this === this.axClass.dPrototype) {
                return _super.prototype.axGetProperty.call(this, mn);
            }
            var key = Dictionary.makePrimitiveKey(mn.name);
            if (key !== undefined) {
                return this.primitiveMap[key];
            }
            return this.map.get(Object(mn.name));
        };
        Dictionary.prototype.axSetProperty = function (mn, value, bc) {
            if (this === this.axClass.dPrototype) {
                _super.prototype.axSetProperty.call(this, mn, value, bc);
                return;
            }
            var key = Dictionary.makePrimitiveKey(mn.name);
            if (key !== undefined) {
                this.primitiveMap[key] = value;
                return;
            }
            this.map.set(Object(mn.name), value);
            if (!this.weakKeys && this.keys.indexOf(mn.name) < 0) {
                this.keys.push(mn.name);
            }
        };
        // TODO: Not implemented yet.
        // public axCallProperty(mn: Multiname, args: any []) {
        //   release || release || notImplemented("axCallProperty");
        // }
        Dictionary.prototype.axHasPropertyInternal = function (mn) {
            if (this === this.axClass.dPrototype) {
                return _super.prototype.axHasProperty.call(this, mn);
            }
            var key = Dictionary.makePrimitiveKey(mn.name);
            if (key !== undefined) {
                return key in this.primitiveMap;
            }
            return this.map.has(Object(mn.name));
        };
        Dictionary.prototype.axDeleteProperty = function (mn) {
            if (this === this.axClass.dPrototype) {
                return _super.prototype.axDeleteProperty.call(this, mn);
            }
            var key = Dictionary.makePrimitiveKey(mn.name);
            if (key !== undefined) {
                delete this.primitiveMap[key];
            }
            this.map.delete(Object(mn.name));
            var i;
            if (!this.weakKeys && (i = this.keys.indexOf(mn.name)) >= 0) {
                this.keys.splice(i, 1);
            }
            return true;
        };
        Dictionary.prototype.axGetPublicProperty = function (nm) {
            if (this === this.axClass.dPrototype) {
                return _super.prototype.axGetPublicProperty.call(this, nm);
            }
            var key = Dictionary.makePrimitiveKey(nm);
            if (key !== undefined) {
                return this.primitiveMap[key];
            }
            return this.map.get(Object(nm));
        };
        Dictionary.prototype.axGetEnumerableKeys = function () {
            if (this === this.axClass.dPrototype) {
                return _super.prototype.axGetEnumerableKeys.call(this);
            }
            var primitiveMapKeys = [];
            for (var k in this.primitiveMap) {
                primitiveMapKeys.push(k);
            }
            if (this.weakKeys) {
                // TODO implement workaround for flashx.textLayout.external.WeakRef
                return primitiveMapKeys; // assuming all weak ref objects are gone
            }
            if (this.keys) {
                return primitiveMapKeys.concat(this.keys);
            }
            return primitiveMapKeys.slice();
        };
        Dictionary.classInitializer = function () {
            var proto = this.dPrototype;
            var asProto = Dictionary.prototype;
            addPrototypeFunctionAlias(proto, '$BgtoJSON', asProto.toJSON);
        };
        return Dictionary;
    }(ASObject$1));

    var AVMPlusFile = /** @class */ (function (_super) {
        __extends(AVMPlusFile, _super);
        function AVMPlusFile() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        AVMPlusFile.exists = function () {
        };
        AVMPlusFile.read = function () {
        };
        AVMPlusFile.write = function () {
        };
        AVMPlusFile.readByteArray = function () {
        };
        AVMPlusFile.writeByteArray = function () {
        };
        return AVMPlusFile;
    }(ASObject$1));
    function initializeBuiltins() {
        builtinNativeClasses["Object"] = ASObject$1;
        builtinNativeClasses["Class"] = ASClass$1;
        builtinNativeClasses["Function"] = ASFunction$1;
        builtinNativeClasses["Boolean"] = ASBoolean$1;
        builtinNativeClasses["builtin.as$0.MethodClosure"] = ASMethodClosure;
        builtinNativeClasses["Number"] = ASNumber$1;
        builtinNativeClasses["int"] = ASInt;
        builtinNativeClasses["uint"] = ASUint;
        builtinNativeClasses["String"] = ASString$1;
        builtinNativeClasses["Array"] = ASArray$1;
        builtinNativeClasses["__AS3__.vec.Vector"] = Vector;
        builtinNativeClasses["__AS3__.vec.Vector$object"] = GenericVector;
        builtinNativeClasses["__AS3__.vec.Vector$int"] = Int32Vector;
        builtinNativeClasses["__AS3__.vec.Vector$uint"] = Uint32Vector;
        builtinNativeClasses["__AS3__.vec.Vector$double"] = Float64Vector;
        builtinNativeClasses["Namespace"] = ASNamespace;
        builtinNativeClasses["QName"] = ASQName;
        builtinNativeClasses["XML"] = ASXML;
        builtinNativeClasses["XMLList"] = ASXMLList;
        builtinNativeClasses["flash.xml.XMLNode"] = XMLNode$1;
        builtinNativeClasses["flash.xml.XMLDocument"] = XMLDocument$1;
        builtinNativeClasses["flash.xml.XMLParser"] = XMLParser$1;
        builtinNativeClasses["flash.xml.XMLTag"] = XMLTag;
        builtinNativeClasses["flash.xml.XMLNodeType"] = XMLNodeType$1;
        builtinNativeClasses["Math"] = ASMath;
        builtinNativeClasses["Date"] = ASDate;
        builtinNativeClasses["RegExp"] = ASRegExp;
        builtinNativeClasses["JSON"] = ASJSON;
        builtinNativeClasses["flash.utils.Proxy"] = ASProxy;
        builtinNativeClasses["flash.utils.Dictionary"] = Dictionary;
        builtinNativeClasses["flash.utils.ByteArray"] = ByteArray$1;
        builtinNativeClasses["avmplus.System"] = OriginalSystem;
        builtinNativeClasses["avmplus.File"] = AVMPlusFile;
        // Errors
        builtinNativeClasses["Error"] = ASError;
        builtinNativeClasses["DefinitionError"] = ASDefinitionError;
        builtinNativeClasses["EvalError"] = ASEvalError;
        builtinNativeClasses["RangeError"] = ASRangeError;
        builtinNativeClasses["ReferenceError"] = ASReferenceError;
        builtinNativeClasses["SecurityError"] = ASSecurityError;
        builtinNativeClasses["SyntaxError"] = ASSyntaxError;
        builtinNativeClasses["TypeError"] = ASTypeError;
        builtinNativeClasses["URIError"] = ASURIError;
        builtinNativeClasses["VerifyError"] = ASVerifyError;
        builtinNativeClasses["UninitializedError"] = ASUninitializedError;
        builtinNativeClasses["ArgumentError"] = ASArgumentError;
        builtinNativeClasses["flash.errors.IOError"] = ASIOError;
        builtinNativeClasses["flash.errors.EOFError"] = ASEOFError;
        builtinNativeClasses["flash.errors.MemoryError"] = ASMemoryError;
        builtinNativeClasses["flash.errors.IllegalOperationError"] = ASIllegalOperationError;
    }
    function registerNativeClass(name, asClass, alias, nsType) {
        if (alias === void 0) { alias = name; }
        if (nsType === void 0) { nsType = 0 /* Public */; }
        release$1 || assert(!nativeClasses[name], "Native class: " + name + " is already registered.");
        nativeClasses[name] = asClass;
        nativeClassLoaderNames.push({ name: name, alias: alias, nsType: nsType });
    }
    function registerNativeFunction(path, fun) {
        release$1 || assert(!nativeFunctions[path], "Native function: " + path + " is already registered.");
        nativeFunctions[path] = fun;
    }
    registerNativeClass("__AS3__.vec.Vector$object", GenericVector, 'ObjectVector', 2 /* PackageInternal */);
    registerNativeClass("__AS3__.vec.Vector$int", Int32Vector, 'Int32Vector', 2 /* PackageInternal */);
    registerNativeClass("__AS3__.vec.Vector$uint", Uint32Vector, 'Uint32Vector', 2 /* PackageInternal */);
    registerNativeClass("__AS3__.vec.Vector$double", Float64Vector, 'Float64Vector', 2 /* PackageInternal */);
    registerNativeFunction('FlashUtilScript::getDefinitionByName', FlashUtilScript_getDefinitionByName);
    registerNativeFunction('FlashUtilScript::getTimer', FlashUtilScript_getTimer$1);
    registerNativeFunction('FlashUtilScript::navigateToURL', FlashNetScript_navigateToURL$1);
    registerNativeFunction('FlashNetScript::navigateToURL', FlashNetScript_navigateToURL$1);
    registerNativeFunction('FlashNetScript::sendToURL', FlashNetScript_sendToURL);
    registerNativeFunction('FlashUtilScript::escapeMultiByte', wrapJSGlobalFunction(jsGlobal.escape));
    registerNativeFunction('FlashUtilScript::unescapeMultiByte', wrapJSGlobalFunction(jsGlobal.unescape));
    registerNativeFunction('Toplevel::registerClassAlias', Toplevel_registerClassAlias);
    registerNativeFunction('Toplevel::getClassByAlias', Toplevel_getClassByAlias);

    var ClipboardService = {
        setClipboard: function (data) { notImplemented('setClipboard'); }
    };

    /*
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *     http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    var IME = /** @class */ (function (_super) {
        __extends(IME, _super); /* flash.events.EventDispatcher */
        function IME() {
            return _super.call(this) || this;
        }
        Object.defineProperty(IME, "enabled", {
            get: function () {
                release$1 || release$1 || somewhatImplemented("public flash.system.IME::static get enabled");
                return false;
            },
            set: function (enabled) {
                release$1 || release$1 || somewhatImplemented("public flash.system.IME::static set enabled");
                enabled = !!enabled;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(IME, "conversionMode", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.IME::static get conversionMode");
                return 'UNKNOWN';
            },
            set: function (mode) {
                mode = axCoerceString$3(mode);
                release$1 || somewhatImplemented("public flash.system.IME::static set conversionMode");
            },
            enumerable: true,
            configurable: true
        });
        IME.setCompositionString = function (composition) {
            composition = axCoerceString$3(composition);
            release$1 || somewhatImplemented("public flash.system.IME::static setCompositionString");
        };
        IME.doConversion = function () {
            release$1 || somewhatImplemented("public flash.system.IME::static doConversion");
        };
        IME.compositionSelectionChanged = function (start /*int*/, end /*int*/) {
            start = start | 0;
            end = end | 0;
            release$1 || somewhatImplemented("public flash.system.IME::static compositionSelectionChanged");
        };
        IME.compositionAbandoned = function () {
            release$1 || somewhatImplemented("public flash.system.IME::static compositionAbandoned");
        };
        Object.defineProperty(IME, "isSupported", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.IME::static get isSupported");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        return IME;
    }(ASObject$1 /* flash.events.EventDispatcher */));
    var System = /** @class */ (function (_super) {
        __extends(System, _super);
        function System() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        System.classInitializer = function () {
            defineNonEnumerableProperty(this, '$Bgargv', this.sec.createArray([]));
        };
        Object.defineProperty(System, "ime", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.System::get ime");
                return null;
            },
            enumerable: true,
            configurable: true
        });
        System.setClipboard = function (string) {
            string = axCoerceString$3(string);
            if (ClipboardService === null) {
                warning('setClipboard is only available in the Firefox extension');
                return;
            }
            ClipboardService.setClipboard(string);
        };
        Object.defineProperty(System, "totalMemoryNumber", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.System::get totalMemoryNumber");
                return 1024 * 1024 * 2;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(System, "freeMemory", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.System::get freeMemory");
                return 1024 * 1024;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(System, "privateMemory", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.System::get privateMemory");
                return 1024 * 1024;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(System, "useCodePage", {
            get: function () {
                return this._useCodePage;
            },
            set: function (value) {
                release$1 || somewhatImplemented("public flash.system.System::set useCodePage");
                this._useCodePage = !!value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(System, "vmVersion", {
            get: function () {
                return "1.0 Shumway - Mozilla Research";
            },
            enumerable: true,
            configurable: true
        });
        System.pause = function () {
            // Debugging-only function we can just ignore.
        };
        System.resume = function () {
            // Debugging-only function we can just ignore.
        };
        System.exit = function (code /*uint*/) {
            // Debugging-only function we can just ignore.
        };
        System.gc = function () {
            // Debugging-only function we can just ignore.
        };
        System.pauseForGCIfCollectionImminent = function (imminence) {
            if (imminence === void 0) { imminence = 0.75; }
            // Not gonna happen, probably ever.
        };
        System.disposeXML = function (node) {
            // We have a cycle collector, so we can ignore this. \o/
        };
        Object.defineProperty(System, "swfVersion", {
            get: function () {
                return 19;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(System, "apiVersion", {
            get: function () {
                return 26;
            },
            enumerable: true,
            configurable: true
        });
        System.getArgv = function () {
            return [];
        };
        System.getRunmode = function () {
            return "mixed";
        };
        System._useCodePage = false;
        return System;
    }(ASObject$1));
    var OriginalSystem = System;
    function initSystem() {
        // Do this here temporarily until we find a nicer place.
        initializeBuiltins();
    }

    /**
     * Dispatched by the Stage object when the state of the stageVideos property changes.
     * @eventType	flash.events.StageVideoAvailabilityEvent.STAGE_VIDEO_AVAILABILITY
     [Event(name="stageVideoAvailability", type="flash.events.StageVideoAvailabilityEvent")]

     * Dispatched by the Stage object when the stage orientation changes.
     * @eventType	flash.events.StageOrientationEvent.ORIENTATION_CHANGE
     [Event(name="orientationChange", type="flash.events.StageOrientationEvent")]

     * Dispatched by the Stage object when the stage orientation begins changing.
     * @eventType	flash.events.StageOrientationEvent.ORIENTATION_CHANGING
     [Event(name="orientationChanging", type="flash.events.StageOrientationEvent")]

     * Dispatched when the Stage object enters, or leaves, full-screen mode.
     * @eventType	flash.events.FullScreenEvent.FULL_SCREEN
     [Event(name="fullScreen", type="flash.events.FullScreenEvent")]

     * Dispatched when the scaleMode property of the Stage object is set to
     * StageScaleMode.NO_SCALE and the SWF file is resized.
     * @eventType	flash.events.Event.RESIZE
     [Event(name="resize", type="flash.events.Event")]

     * Dispatched by the Stage object when the pointer moves out of the
     * stage area.
     * @eventType	flash.events.Event.MOUSE_LEAVE
     [Event(name="mouseLeave", type="flash.events.Event")]

     * The Stage class represents the main drawing area.
     *
     *   <p class="- topic/p ">For SWF content running in the browser (in
     * Flash<sup class="+ topic/ph hi-d/sup ">®</sup> Player), the Stage represents the entire area where Flash
     * content is shown. For content running in AIR on desktop operating systems, each NativeWindow object has a corresponding
     * Stage object.</p><p class="- topic/p ">The Stage object is not globally accessible. You need to access it through the
     * <codeph class="+ topic/ph pr-d/codeph ">stage</codeph> property of a DisplayObject instance.</p><p class="- topic/p ">The Stage class has several ancestor classes — DisplayObjectContainer, InteractiveObject,
     * DisplayObject, and EventDispatcher — from which it inherits properties and methods.
     * Many of these properties and methods are either inapplicable to Stage objects,
     * or require security checks when called on a Stage object.  The properties and methods that
     * require security checks are documented as part of the Stage class.</p><p class="- topic/p ">In addition, the following inherited properties are inapplicable to Stage objects. If you
     * try to set them, an IllegalOperationError is thrown. These properties may always be read, but
     * since they cannot be set, they will always contain default values.</p><ul class="- topic/ul "><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">accessibilityProperties</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">alpha</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">blendMode</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">cacheAsBitmap</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">contextMenu</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">filters</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">focusRect</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">loaderInfo</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">mask</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">mouseEnabled</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">name</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">opaqueBackground</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">rotation</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">scale9Grid</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">scaleX</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">scaleY</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">scrollRect</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">tabEnabled</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">tabIndex</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">transform</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">visible</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">x</codeph></li><li class="- topic/li "><codeph class="+ topic/ph pr-d/codeph ">y</codeph></li></ul><p class="- topic/p ">Some events that you might expect to be a part of the Stage class,
     * such as <codeph class="+ topic/ph pr-d/codeph ">enterFrame</codeph>, <codeph class="+ topic/ph pr-d/codeph ">exitFrame</codeph>,
     * <codeph class="+ topic/ph pr-d/codeph ">frameConstructed</codeph>, and <codeph class="+ topic/ph pr-d/codeph ">render</codeph>,
     * cannot be Stage events because a reference to the Stage object
     * cannot be guaranteed to exist in every situation where these events
     * are used. Because these events cannot be dispatched by the Stage
     * object, they are instead dispatched by every DisplayObject instance,
     * which means that you can add an event listener to
     * any DisplayObject instance to listen for these events.
     * These events, which are part of the DisplayObject class,
     * are called broadcast events to differentiate them from events
     * that target a specific DisplayObject instance.
     * Two other broadcast events, <codeph class="+ topic/ph pr-d/codeph ">activate</codeph> and <codeph class="+ topic/ph pr-d/codeph ">deactivate</codeph>,
     * belong to DisplayObject's superclass, EventDispatcher.
     * The <codeph class="+ topic/ph pr-d/codeph ">activate</codeph> and <codeph class="+ topic/ph pr-d/codeph ">deactivate</codeph> events
     * behave similarly to the DisplayObject broadcast events, except
     * that these two events are dispatched not only by all DisplayObject
     * instances, but also by all EventDispatcher instances and instances
     * of other EventDispatcher subclasses.
     * For more information on broadcast events, see the DisplayObject class.</p>
     *
     *   EXAMPLE:
     *
     *   The following example uses the <codeph class="+ topic/ph pr-d/codeph ">StageExample</codeph> class to dispatch
     * events whenever the stage is activated or resized.  This is accomplished by performing the following steps:
     * <ol class="- topic/ol "><li class="- topic/li ">The class constructor first sets the Flash application to be fixed, regardless of the size of
     * the Flash Player window and then adds two event listeners with the
     * <codeph class="+ topic/ph pr-d/codeph ">activateHandler()</codeph> and <codeph class="+ topic/ph pr-d/codeph ">resizeHandler()</codeph> methods.</li><li class="- topic/li ">The <codeph class="+ topic/ph pr-d/codeph ">activateHandler()</codeph> method runs when the left mouse button is clicked.</li><li class="- topic/li ">The <codeph class="+ topic/ph pr-d/codeph ">resizeHandler()</codeph> method runs when the stage is resized.</li></ol><codeblock xml:space="preserve" class="+ topic/pre pr-d/codeblock ">
     * package {
         * import flash.display.Sprite;
         * import flash.display.StageAlign;
         * import flash.display.StageScaleMode;
         * import flash.events.Event;
         *
         *   public class StageExample extends Sprite {
         *
         *   public StageExample() {
         * stage.scaleMode = StageScaleMode.NO_SCALE;
         * stage.align = StageAlign.TOP_LEFT;
         * stage.addEventListener(Event.ACTIVATE, activateHandler);
         * stage.addEventListener(Event.RESIZE, resizeHandler);
         * }
         *
         *   private activateHandler(event:Event):void {
         * trace("activateHandler: " + event);
         * }
         *
         *   private resizeHandler(event:Event):void {
         * trace("resizeHandler: " + event);
         * trace("stageWidth: " + stage.stageWidth + " stageHeight: " + stage.stageHeight);
         * }
         * }
         * }
     * </codeblock>
     */
    var Stage$1 = /** @class */ (function (_super) {
        __extends(Stage, _super);
        function Stage(startClass, width, height, backgroundColor, frameRate, showFPS) {
            if (width === void 0) { width = 550; }
            if (height === void 0) { height = 400; }
            if (backgroundColor === void 0) { backgroundColor = null; }
            if (frameRate === void 0) { frameRate = 30; }
            if (showFPS === void 0) { showFPS = false; }
            var _this = _super.call(this) || this;
            _this._frameRate = 30;
            _this._currentFps = 0;
            _this._time = 0;
            _this._debugtimer = 0;
            _this.SHOW_FRAME_RATE = false;
            _this.SHOW_FRAME_RATE = showFPS;
            _this._stageWidth = width;
            _this._stageHeight = height;
            _this._eventOnEnter = new Event(Event.ENTER_FRAME);
            _this._eventFrameConstructed = new Event(Event.FRAME_CONSTRUCTED);
            _this._eventExitFrame = new Event(Event.EXIT_FRAME);
            _this._eventRender = new Event(Event.RENDER);
            _this._events = [_this._eventOnEnter, _this._eventExitFrame];
            _this._scaleMode = StageScaleMode.SHOW_ALL;
            _this._align = StageAlign.TOP_LEFT;
            _this._stage3Ds = [];
            //this._stage3Ds[this._stage3Ds.length]=new AwayStage(null, );
            AudioManager.setVolume(1);
            //todo: better implement this in graphics (this function provides the drawing api with materials for a color / alpha)
            Graphics.get_material_for_color = function (color, alpha) {
                if (alpha === void 0) { alpha = 1; }
                if (color == 0) {
                    color = 0x000001;
                }
                if (color == 0xFF8100) {
                    alpha = 1;
                }
                //color=0xFF8100;
                //alpha=0.5;
                var texObj = {};
                if (Stage._useTextureAtlasForColors) {
                    texObj = TextureAtlas.getTextureForColor(color, alpha);
                    if (Stage._colorMaterials[texObj.bitmap.id]) {
                        texObj.material = Stage._colorMaterials[texObj.bitmap.id];
                        return texObj;
                    }
                    var newmat = new MethodMaterial(texObj.bitmap);
                    newmat.alphaBlending = true;
                    newmat.useColorTransform = true;
                    newmat.bothSides = true;
                    Stage._colorMaterials[texObj.bitmap.id] = newmat;
                    texObj.material = newmat;
                    return texObj;
                }
                var colorstr = color + "_" + Math.round(alpha * 100).toString();
                if (Stage._colorMaterials[colorstr]) {
                    texObj.material = Stage._colorMaterials[colorstr];
                    return texObj;
                }
                var newmat = new MethodMaterial(color, alpha);
                newmat.alphaBlending = true;
                newmat.useColorTransform = true;
                newmat.bothSides = true;
                texObj.material = newmat;
                Stage._colorMaterials[colorstr] = newmat;
                return texObj;
            };
            Graphics.get_material_for_gradient = function (gradient) {
                var texObj = TextureAtlas.getTextureForGradient(gradient);
                /*if(alpha==0){
                 alpha=1;
                 }*/
                /*if(color==0xffffff){
                 color=0xcccccc;
                 }*/
                // alpha=0.5;
                var lookupstr = texObj.bitmap.id + gradient.type;
                if (Stage._textureMaterials[lookupstr]) {
                    texObj.material = Stage._textureMaterials[lookupstr];
                    return texObj;
                }
                var newmat = new MethodMaterial(texObj.bitmap);
                newmat.useColorTransform = true;
                newmat.alphaBlending = true;
                newmat.bothSides = true;
                Stage._textureMaterials[lookupstr] = newmat;
                texObj.material = newmat;
                return texObj;
            };
            /*
            //todo
            this.eventMappingDummys[StageVideoAvailabilityEvent.STAGE_VIDEO_AVAILABILITY]="StageVideoAvailabilityEvent.STAGE_VIDEO_AVAILABILITY";
            this.eventMappingDummys[StageOrientationEvent.ORIENTATION_CHANGE]="StageOrientationEvent.ORIENTATION_CHANGE";
            this.eventMappingDummys[StageOrientationEvent.ORIENTATION_CHANGING]="StageOrientationEvent.ORIENTATION_CHANGING";
            this.eventMappingDummys[FullScreenEvent.FULL_SCREEN]="FullScreenEvent.FULL_SCREEN";
            */
            // resize event listens on window
            _this._resizeCallbackDelegate = function (event) { return _this.resizeCallback(event); };
            _this.eventMapping[Event.RESIZE] = {
                adaptedType: "",
                addListener: _this.initResizeListener,
                removeListener: _this.removeResizeListener,
                callback: _this._resizeCallbackDelegate
            };
            // mouse leave event listens on window
            _this._mouseLeaveCallbackDelegate = function (event) { return _this.mouseLeaveCallback(event); };
            _this.eventMapping[Event.MOUSE_LEAVE] = {
                adaptedType: "",
                addListener: _this.initMouseLeaveListener,
                removeListener: _this.removeMouseLeaveListener,
                callback: _this._mouseLeaveCallbackDelegate
            };
            // set this as active stage.
            // this makes sure all DisplayObject.constructor can set a reference to stage,
            // befor constructors of Sprite or MovieClips are processed
            _this.sec.flash.display.DisplayObject.axClass._activeStage = _this;
            _this._stage = _this;
            // init awayengine
            _this.initEninge();
            _this._resizeCallbackDelegate(null);
            _this.adaptee.partition = new SceneGraphPartition(_this.adaptee, true);
            // create new Partition for the adaptee and make it child of the awayjs-scene
            //this._view.setPartition(this.adaptee, new SceneGraphPartition(this.adaptee));
            _this._scene.root.addChild(_this.adaptee);
            // helps with mouse-events:
            //this._view.mousePicker.onlyMouseEnabled=false;
            //this._view.renderer.stage.container.style.display="none";
            // create the entrance-class
            // this is the moment the converted as3-code is executed
            _this._scene.renderer.view.backgroundColor = (isNaN(backgroundColor)) ? 0xFFFFFF : backgroundColor;
            _this._frameRate = frameRate;
            // make sure we have a background, so any mousedowns on stage are registered even if no object is hit
            // it might make more sense to put this bg on the stage, but if i try to draw into the stage,
            // the shape is the only thing that shows up, the _mainSprite is than no longer rendered
            /*this._mainSprite.graphics.clear();
            this._mainSprite.graphics.beginFill(0xffff00, 0.5);
            this._mainSprite.graphics.drawRect(0,0,window.innerWidth, window.innerHeight);
            this._mainSprite.graphics.endFill();*/
            // prevent backspace and other default shortcutz for our document:
            /*document.onkeydown = function (event) {

                if (!event) { // This will happen in IE
                    event = <any>window.event;
                }

                var keyCode = event.keyCode;

                if (keyCode == 8 &&
                    ((<any>(event.target || event.srcElement)).tagName != "TEXTAREA") &&
                    ((<any>(event.target || event.srcElement)).tagName != "INPUT")) {

                    if (navigator.userAgent.toLowerCase().indexOf("msie") == -1) {
                        event.stopPropagation();
                    } else {
                        alert("prevented");
                        event.returnValue = false;
                    }

                    return false;
                }
                /*
                window.location.href += "#";

                var _hash = "";
                window.setTimeout(function () {
                    window.location.href += "";
                }, 50);

                window.onhashchange = function () {
                    if (window.location.hash !== _hash) {
                        window.location.hash = _hash;
                    }
                };
            }
                */
            if (_this.SHOW_FRAME_RATE) {
                _this._fpsTextField = document.createElement('div'); // disable in RC
                _this._fpsTextField.style.cssFloat = 'none';
                _this._fpsTextField.style.backgroundColor = '#000';
                _this._fpsTextField.style.position = 'fixed';
                _this._fpsTextField.style.top = '5px';
                _this._fpsTextField.style.width = '100px';
                _this._fpsTextField.style.height = '20px';
                _this._fpsTextField.style.right = '5px';
                _this._fpsTextField.style.textAlign = 'center';
                _this._fpsTextField.style.color = '#ffffff';
                _this._fpsTextField.style.fontSize = '16';
                _this._fpsTextField.innerHTML = "";
                document.body.appendChild(_this._fpsTextField);
                setInterval(function () { return _this.updateFPS(); }, 1000);
            }
            if (startClass) {
                _this._mainSprite = new startClass();
                _this.addChild(_this._mainSprite);
                _this.initListeners();
                console.log("constructed Stage and create the entranceclass");
            }
            _this._rendererStage.container.style.visibility = "visible";
            return _this;
            // inits the resize listener
        }
        Stage.prototype.init = function (startClass) {
            this._mainSprite = new startClass();
            this.addChild(this._mainSprite);
            this.initListeners();
            this._resizeCallbackDelegate(null);
            this._rendererStage.container.style.visibility = "visible";
        };
        Object.defineProperty(Stage.prototype, "view", {
            get: function () {
                return this._scene.renderer.view;
            },
            enumerable: true,
            configurable: true
        });
        Stage.prototype.updateFPS = function () {
            this._fpsTextField.innerText = this._currentFps.toFixed(2) + '/' + this._frameRate + " fps";
            this._currentFps = 0;
        };
        Object.defineProperty(Stage.prototype, "onlyMouseEnabled", {
            set: function (value) {
                // todo2019: what is this supposed to do ?
                //this._scene.mousePicker.onlyMouseEnabled = value;
            },
            enumerable: true,
            configurable: true
        });
        // ---------- event mapping functions Event.RESIZE
        Stage.prototype.initResizeListener = function (type, callback) {
            window.addEventListener("resize", callback);
        };
        Stage.prototype.removeResizeListener = function (type, callback) {
            window.removeEventListener("resize", callback);
        };
        Stage.prototype.resizeCallback = function (event) {
            // todo: correctly implement all StageScaleModes;
            if (event === void 0) { event = null; }
            var newWidth = window.innerWidth;
            var newHeight = window.innerHeight;
            var newX = 0;
            var newY = 0;
            switch (this.scaleMode) {
                case StageScaleMode.NO_SCALE:
                    this._projection.fieldOfView = Math.atan(window.innerHeight / 1000 / 2) * 360 / Math.PI;
                    break;
                case StageScaleMode.SHOW_ALL:
                    newHeight = window.innerHeight;
                    newWidth = (this._stageWidth / this._stageHeight) * newHeight;
                    if (newWidth > window.innerWidth) {
                        newWidth = window.innerWidth;
                        newHeight = newWidth * (this._stageHeight / this._stageWidth);
                    }
                    newX = (window.innerWidth - newWidth) / 2;
                    newY = (window.innerHeight - newHeight) / 2;
                    this._projection.fieldOfView = Math.atan(this._stageHeight / 1000 / 2) * 360 / Math.PI;
                    break;
                case StageScaleMode.EXACT_FIT:
                case StageScaleMode.NO_BORDER:
                    this._projection.fieldOfView = Math.atan(window.innerHeight / 1000 / 2) * 360 / Math.PI;
                    break;
                default:
                    console.log("Stage: only implemented StageScaleMode are NO_SCALE, SHOW_ALL");
                    break;
            }
            // todo: correctly implement all alignModes;
            switch (this.align) {
                case StageAlign.TOP_LEFT:
                    this._scene.renderer.view.y = 0;
                    this._scene.renderer.view.x = 0;
                    break;
                default:
                    this._scene.renderer.view.y = 0;
                    this._scene.renderer.view.x = 0;
                    console.log("Stage: only implemented StageAlign is TOP_LEFT");
                    break;
            }
            //console.log("test28");
            if (this._mainSprite) {
                this._mainSprite.graphics.clear();
                this._mainSprite.graphics.beginFill(0xffffff, 0);
                this._mainSprite.graphics.drawRect(0, 0, newWidth, newHeight);
                this._mainSprite.graphics.endFill();
            }
            this.updateSize(newX, newY, newWidth, newHeight);
            //this._scene.view.preserveFocalLength = true;
            /*
            if(aspectRatio>=1){
                this._projection.fieldOfView = Math.atan(window.innerHeight/1000/2)*360/Math.PI;
            }
            else{
                this._projection.fieldOfView = Math.atan(window.innerWidth/1000/2)*360/Math.PI;
            }
            */
            //this._projection.originX = (0.5 - 0.5*(window.innerHeight/newHeight)*(this._stageWidth/window.innerWidth));
            this.dispatchEvent(new this.sec.flash.events.Event(Event.RESIZE));
        };
        Stage.prototype.show = function () {
            //this._view.renderer.stage.container.style.display="initial";
        };
        // ---------- event mapping functions Event.MOUSE_LEAVE
        Stage.prototype.initMouseLeaveListener = function (type, callback) {
            window.addEventListener("mouseleave", callback);
        };
        Stage.prototype.removeMouseLeaveListener = function (type, callback) {
            window.removeEventListener("mouseleave", callback);
        };
        Stage.prototype.mouseLeaveCallback = function (event) {
            if (event === void 0) { event = null; }
            this.dispatchEvent(new Event(Event.MOUSE_LEAVE));
        };
        //---------------------------stuff added to make it work:
        Stage.prototype.initEninge = function () {
            //create the view
            this._scene = new Scene(new BasicPartition(new DisplayObjectContainer()));
            this._rendererStage = this._scene.view.stage;
            this._rendererStage.container.style.visibility = "hidden";
            this._rendererStage.antiAlias = 0;
            this._scene.renderer.renderableSorter = null; //new RenderableSort2D();
            this._projection = new PerspectiveProjection();
            this._projection.coordinateSystem = CoordinateSystem.RIGHT_HANDED;
            this._projection.originX = -1;
            this._projection.originY = 1;
            var camera = new Camera();
            camera.projection = this._projection;
            this._scene.camera = camera;
            this._projection.fieldOfView = Math.atan(window.innerHeight / 1000 / 2) * 360 / Math.PI;
            //this._projection.fieldOfView = Math.atan(this._stageHeight/1000/2)*360/Math.PI;
        };
        Stage.prototype.updateSize = function (x, y, w, h) {
            //this._stageWidth=w;
            //this._stageHeight=h;
            this._scene.view.x = x;
            this._scene.view.y = y;
            this._scene.view.width = w;
            this._scene.view.height = h;
            this._rendererStage.x = x;
            this._rendererStage.y = y;
            this._rendererStage.width = w;
            this._rendererStage.height = h;
            if (this._fpsTextField)
                this._fpsTextField.style.left = window.innerWidth * 0.5 - 100 + 'px';
        };
        /**
         * Initialise the listeners
         */
        Stage.prototype.initListeners = function () {
            console.log("init listeners");
            window.addEventListener("resize", this._resizeCallbackDelegate);
            this._timer = new RequestAnimationFrame(this.onEnterFrame, this);
            this._timer.start();
            this._resizeCallbackDelegate(null);
        };
        /**
         * Render loop
         */
        Stage.prototype.onEnterFrame = function (dt) {
            var frameMarker = Math.floor(1000 / this._frameRate);
            this._time += Math.min(dt, frameMarker);
            if (this._time >= frameMarker) {
                this._time -= frameMarker;
                this._rendererStage.clear();
                //this.dispatchEventRecursive(this._eventOnEnter);
                this.advanceFrame(this._events);
                //this.dispatchEventRecursive(this._eventFrameConstructed);
                // todo: move Framescriptexecution and rest from frame-update logic from Movieclip.update to here
                //this.dispatchEventRecursive(this._eventExitFrame);
                //this.dispatchEventRecursive(this._eventRender);
                this._scene.render();
                this._currentFps++;
                this._debugtimer++;
                if (this._debugtimer % 150 == 0) {
                    var displayGraph = {};
                    this.debugDisplayGraph(displayGraph);
                    console.log("SceneGraph frame :", this._debugtimer, displayGraph);
                }
            }
        };
        Stage.prototype.render = function () {
            this._currentFps++;
            //this._rendererStage.clear();
            this._scene.render();
        };
        Object.defineProperty(Stage.prototype, "rendererStage", {
            get: function () {
                return this._rendererStage;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "mouseX", {
            //---------------------------original as3 properties / methods:
            get: function () {
                //console.log("mouseX not implemented yet in flash/DisplayObject");
                return this._scene.getLocalMouseX(this.adaptee);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "mouseY", {
            /**
             * Indicates the y coordinate of the mouse or user input device position, in pixels.
             *
             *   Note: For a DisplayObject that has been rotated, the returned y coordinate will reflect the
             * non-rotated any.
             */
            get: function () {
                //console.log("mouseY not implemented yet in flash/DisplayObject");
                return this._scene.getLocalMouseY(this.adaptee);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "accessibilityImplementation", {
            set: function (value) {
                //todo: any is AccessibilityImplementation
                console.log("textSnapshot not implemented yet in flash/Stage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "align", {
            /**
             * A value from the StageAlign class that specifies the alignment of the stage in
             * Flash Player or the browser. The following are valid values:
             *
             *   ValueVertical AlignmentHorizontalStageAlign.TOPTopCenterStageAlign.BOTTOMBottomCenterStageAlign.LEFTCenterLeftStageAlign.RIGHTCenterRightStageAlign.TOP_LEFTTopLeftStageAlign.TOP_RIGHTTopRightStageAlign.BOTTOM_LEFTBottomLeftStageAlign.BOTTOM_RIGHTBottomRightThe align property is only available to an object that is in the same security sandbox
             * as the Stage owner (the main SWF file).
             * To avoid this, the Stage owner can grant permission to the domain of the
             * calling object by calling the Security.allowDomain() method or the Security.alowInsecureDomain() method.
             * For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                return this._align;
            },
            set: function (value) {
                value = this._align;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "allowsFullScreen", {
            /**
             * Specifies whether this stage allows the use of the full screen mode
             * @langversion	3.0
             * @playerversion	Flash 10.2
             * @oldexample	The following example traces the value of this read-only property:
             *   <pre xml:space="preserve" class="- topic/pre ">
             *   trace(Stage.allowsFullsreen);
             *   </pre>
             */
            get: function () {
                //todo
                console.log("allowsFullScreen not implemented yet in flash/Stage");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "allowsFullScreenInteractive", {
            get: function () {
                //todo
                console.log("allowsFullScreenInteractive not implemented yet in flash/Stage");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "browserZoomFactor", {
            get: function () {
                //todo
                console.log("browserZoomFactor not implemented yet in flash/Stage");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "color", {
            get: function () {
                return this._scene.renderer.view.backgroundColor;
            },
            set: function (color) {
                this._scene.renderer.view.backgroundColor = color;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "colorCorrection", {
            /**
             * Controls Flash runtime color correction for displays.
             * Color correction works only if the main monitor is assigned a valid ICC color profile, which specifies
             * the device's particular color attributes.
             * By default, the Flash runtime tries to match the color correction of its host (usually a browser).
             *
             *   Use the Stage.colorCorrectionSupport property
             * to determine if color correction is available on the current system and the default state.
             * .    If color correction is available, all colors on the stage are assumed to be in
             * the sRGB color space, which is the most standard color space. Source profiles of input devices are not considered during color correction.
             * No input color correction is applied; only the stage output is mapped to the main
             * monitor's ICC color profile.In general, the benefits of activating color management include predictable and consistent color, better conversion,
             * accurate proofing and more efficient cross-media output. Be aware, though, that color management does not provide
             * perfect conversions due to devices having a different gamut from each other or original images.
             * Nor does color management eliminate the need for custom or edited profiles.
             * Color profiles are dependent on browsers, operating systems (OS), OS extensions, output devices, and application support.Applying color correction degrades the Flash runtime performance.
             * A Flash runtime's color correction is document style color correction because
             * all SWF movies are considered documents with implicit sRGB profiles.
             * Use the Stage.colorCorrectionSupport property to tell the Flash runtime
             * to correct colors when displaying the SWF file (document) to the display color space.
             * Flash runtimes only compensates for differences between monitors, not for differences between input devices (camera/scanner/etc.).
             * The three possible values are strings with corresponding constants in the flash.display.ColorCorrection class:"default": Use the same color correction as the host system."on": Always perform color correction."off": Never perform color correction.
             */
            get: function () {
                //todo
                console.log("colorCorrection not implemented yet in flash/Stage");
                return "";
            },
            set: function (value) {
                //todo
                console.log("colorCorrection not implemented yet in flash/Stage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "colorCorrectionSupport", {
            /**
             * Specifies whether the Flash runtime is running on an operating system that supports
             * color correction and whether the color profile of the main (primary)
             * monitor can be read and understood by the Flash runtime. This property also returns the default state
             * of color correction on the host system (usually the browser).
             * Currently the return values can be:
             * The three possible values are strings with corresponding constants in the flash.display.ColorCorrectionSupport class:"unsupported": Color correction is not available."defaultOn": Always performs color correction."defaultOff": Never performs color correction.
        
             */
            get: function () {
                //todo
                console.log("colorCorrectionSupport not implemented yet in flash/Stage");
                return "";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "contentsScaleFactor", {
            get: function () {
                //todo
                console.log("contentsScaleFactor not implemented yet in flash/Stage");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "displayContextInfo", {
            get: function () {
                //todo
                console.log("displayContextInfo not implemented yet in flash/Stage");
                return "";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "displayState", {
            /**
             * A value from the StageDisplayState class that specifies which display state to use. The following
             * are valid values:
             *
             *   StageDisplayState.FULL_SCREEN Sets AIR application or Flash runtime to expand the
             * stage over the user's entire screen, with keyboard input disabled.StageDisplayState.FULL_SCREEN_INTERACTIVE Sets the AIR application to expand the
             * stage over the user's entire screen, with keyboard input allowed.
             * (Not available for content running in Flash Player.)StageDisplayState.NORMAL Sets the Flash runtime back to the standard stage display mode.The scaling behavior of the movie in full-screen mode is determined by the scaleMode
             * setting (set using the Stage.scaleMode property or the SWF file's embed
             * tag settings in the HTML file). If the scaleMode property is set to noScale
             * while the application transitions to full-screen mode, the Stage width and height
             * properties are updated, and the Stage dispatches a resize event. If any other scale mode is set,
             * the stage and its contents are scaled to fill the new screen dimensions. The Stage object retains its original
             * width and height values and does not dispatch a resize event.The following restrictions apply to SWF files that play within an HTML page (not those using the stand-alone
             * Flash Player or not running in the AIR runtime):To enable full-screen mode, add the allowFullScreen parameter to the object
             * and embed tags in the HTML page that includes the SWF file, with allowFullScreen set
             * to "true", as shown in the following example:
             *
             *   <codeblock>
             * <param name="allowFullScreen" value="true" />
             * ...
             * <embed src="example.swf" allowFullScreen="true" ... >
             * </codeblock>
             * An HTML page may also use a script to generate SWF-embedding tags. You need to alter the script
             * so that it inserts the proper allowFullScreen settings. HTML pages generated by Flash Professional and
             * Flash Builder use the AC_FL_RunContent() to embed references to SWF files, and you
             * need to add the allowFullScreen parameter settings, as in the following:
             * <codeblock>
             * AC_FL_RunContent( ... "allowFullScreen", "true", ... )
             * </codeblock>
             * Full-screen mode is initiated in response to a mouse click or key press by the user; the movie cannot change
             * Stage.displayState without user input. Flash runtimes restrict keyboard input  in full-screen mode.
             * Acceptable keys include keyboard shortcuts that terminate full-screen mode and non-printing keys such as arrows, space, Shift,
             * and Tab keys. Keyboard shortcuts that terminate full-screen mode are: Escape (Windows, Linux, and Mac), Control+W (Windows),
             * Command+W (Mac), and Alt+F4.
             * A Flash runtime dialog box appears over the movie when users enter full-screen mode to inform the users they are in
             * full-screen mode and that they can press the Escape key to end full-screen mode.Starting with Flash Player 9.0.115.0, full-screen works the same in windowless mode as it does in window mode.
             * If you set the Window Mode (wmode in the HTML) to Opaque Windowless (opaque)
             * or Transparent Windowless (transparent), full-screen can be initiated,
             * but the full-screen window will always be opaque.These restrictions are not present for SWF content running in the
             * stand-alone Flash Player or in AIR. AIR supports an interactive full-screen mode which allows keyboard input.For AIR content running in full-screen mode, the system screen saver
             * and power saving options are disabled while video content is playing and until either the video stops
             * or full-screen mode is exited.On Linux, setting displayState to StageDisplayState.FULL_SCREEN or
             * StageDisplayState.FULL_SCREEN_INTERACTIVE is an asynchronous operation.
             * @throws	SecurityError Calling the displayState property of a Stage object throws an exception for
             *   any caller that is not in the same security sandbox as the Stage owner (the main SWF file).
             *   To avoid this, the Stage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             *   Trying to set the displayState property while the settings dialog is displayed, without a user response, or
             *   if the param or embed HTML tag's allowFullScreen attribute is not set to
             *   true throws a security error.
             */
            get: function () {
                //todo
                console.log("displayState not implemented yet in flash/Stage");
                return "";
            },
            set: function (value) {
                //todo
                console.log("displayState not implemented yet in flash/Stage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "focus", {
            /**
             * The interactive object with keyboard focus; or null if focus is not set
             * or if the focused object belongs to a security sandbox to which the calling object does not
             * have access.
             * @throws	Error Throws an error if focus cannot be set to the target.
             */
            get: function () {
                //todo: any is InteractiveObject
                //console.log("focus not implemented yet in flash/Stage");
                return null;
            },
            set: function (newFocus) {
                //todo: any is InteractiveObject
                //console.log("focus not implemented yet in flash/Stage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "frameRate", {
            /**
             * Gets and sets the frame rate of the stage. The frame rate is defined as frames per second.
             * By default the rate is set to the frame rate of the first SWF file loaded. Valid range for the frame rate
             * is from 0.01 to 1000 frames per second.
             *
             *   Note: An application might not be able to follow
             * high frame rate settings, either because the target platform is not fast enough or the player is
             * synchronized to the vertical blank timing of the display device (usually 60 Hz on LCD devices).
             * In some cases, a target platform might also choose to lower the maximum frame rate if it
             * anticipates high CPU usage.For content running in Adobe AIR, setting the frameRate property of one Stage
             * object changes the frame rate for all Stage objects (used by different NativeWindow objects).
             * @throws	SecurityError Calling the frameRate property of a Stage object throws an exception for
             *   any caller that is not in the same security sandbox as the Stage owner (the main SWF file).
             *   To avoid this, the Stage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                return this._frameRate;
            },
            set: function (value) {
                this._frameRate = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "fullScreenHeight", {
            /**
             * Returns the height of the monitor that will be used when going to full screen size, if that state
             * is entered immediately. If the user has multiple monitors, the monitor that's used is the
             * monitor that most of the stage is on at the time.
             *
             *   Note: If the user has the opportunity to move the browser from one
             * monitor to another between retrieving the value and going to full screen
             * size, the value could be incorrect. If you retrieve the value in an event handler that
             * sets Stage.displayState to StageDisplayState.FULL_SCREEN, the value will be
             * correct.This is the pixel height of the monitor and is the same as the
             * stage height would be if Stage.align is set to StageAlign.TOP_LEFT
             * and Stage.scaleMode is set to StageScaleMode.NO_SCALE.
             */
            get: function () {
                //todo
                console.log("fullScreenHeight not implemented yet in flash/Stage");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "fullScreenSourceRect", {
            /**
             * Sets the Flash runtime to scale a specific region of the stage to full-screen mode.
             * If available, the Flash runtime scales in hardware, which uses the graphics and video card on a user's computer,
             * and generally displays content more quickly than software scaling.
             *
             *   When this property is set to a valid rectangle and the displayState property is set to full-screen mode,
             * the Flash runtime scales the specified area. The actual Stage size in pixels within ActionScript does not change.
             * The Flash runtime enforces a minimum limit for the size of the rectangle to accommodate the standard "Press Esc to exit full-screen mode" message.
             * This limit is usually around 260 by 30 pixels but can vary on platform and Flash runtime version.This property can only be set when the Flash runtime is not in full-screen mode.
             * To use this property correctly, set this property first, then set the displayState property to full-screen mode, as shown in the code examples.To enable scaling, set the fullScreenSourceRect property to a rectangle object:
             * <codeblock>
             *
             *   // valid, will enable hardware scaling
             * stage.fullScreenSourceRect = new Rectangle(0,0,320,240);
             *
             *   </codeblock>
             * To disable scaling, set the fullScreenSourceRect=null in ActionScript 3.0, and undefined in ActionScript 2.0.
             * <codeblock>
             *
             *   stage.fullScreenSourceRect = null;
             *
             *   </codeblock>
             * The end user also can select within Flash Player Display Settings to turn off hardware scaling, which is enabled by default.
             * For more information, see www.adobe.com/go/display_settings.
             */
            get: function () {
                //todo
                console.log("fullScreenSourceRect not implemented yet in flash/Stage");
                return null;
            },
            set: function (value) {
                //todo
                console.log("fullScreenSourceRect not implemented yet in flash/Stage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "fullScreenWidth", {
            /**
             * Returns the width of the monitor that will be used when going to full screen size, if that state
             * is entered immediately. If the user has multiple monitors, the monitor that's used is the
             * monitor that most of the stage is on at the time.
             *
             *   Note: If the user has the opportunity to move the browser from one
             * monitor to another between retrieving the value and going to full screen
             * size, the value could be incorrect. If you retrieve the value in an event handler that
             * sets Stage.displayState to StageDisplayState.FULL_SCREEN, the value will be
             * correct.This is the pixel width of the monitor and is the same as the stage width would be if
             * Stage.align is set to StageAlign.TOP_LEFT and
             * Stage.scaleMode is set to StageScaleMode.NO_SCALE.
             */
            get: function () {
                //todo
                console.log("fullScreenWidth not implemented yet in flash/Stage");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "mouseLock", {
            get: function () {
                //todo
                console.log("mouseLock not implemented yet in flash/Stage");
                return false;
            },
            set: function (value) {
                //todo
                console.log("mouseLock not implemented yet in flash/Stage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "quality", {
            /**
             * A value from the StageQuality class that specifies which rendering quality is used.
             * The following are valid values:
             *
             *   StageQuality.LOW—Low rendering quality. Graphics are not
             * anti-aliased, and bitmaps are not smoothed, but runtimes still use mip-mapping.StageQuality.MEDIUM—Medium rendering quality. Graphics are
             * anti-aliased using a 2 x 2 pixel grid, bitmap smoothing is dependent on the Bitmap.smoothing setting.
             * Runtimes use mip-mapping. This setting is suitable for movies that do not contain text.StageQuality.HIGH—High rendering quality. Graphics are anti-aliased
             * using a 4 x 4 pixel grid, and bitmap smoothing is dependent on the Bitmap.smoothing setting.
             * Runtimes use mip-mapping. This is the default rendering quality setting that Flash Player uses.StageQuality.BEST—Very high rendering quality. Graphics are
             * anti-aliased using a 4 x 4 pixel grid. If Bitmap.smoothing is true the runtime uses a high quality
             * downscale algorithm that produces fewer artifacts (however, using StageQuality.BEST with Bitmap.smoothing set to true
             * slows performance significantly and is not a recommended setting).Higher quality settings produce better rendering of scaled bitmaps. However, higher
             * quality settings are computationally more expensive. In particular, when rendering scaled video,
             * using higher quality settings can reduce the frame rate.
             * In the desktop profile of Adobe AIR, quality can be set
             * to StageQuality.BEST or StageQuality.HIGH (and the default value
             * is StageQuality.HIGH). Attempting to set it to another value has no effect
             * (and the property remains unchanged). In the moble profile of AIR, all four quality settings
             * are available. The default value on mobile devices is StageQuality.MEDIUM.For content running in Adobe AIR, setting the quality property of one Stage
             * object changes the rendering quality for all Stage objects (used by different NativeWindow objects).
             * Note: The operating system draws the device fonts,
             * which are therefore unaffected by the quality property.
             * @throws	SecurityError Calling the quality property of a Stage object throws an exception for
             *   any caller that is not in the same security sandbox as the Stage owner (the main SWF file).
             *   To avoid this, the Stage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                //todo
                //console.log("quality not implemented yet in flash/Stage");
                return "";
            },
            set: function (value) {
                //todo
                //console.log("quality not implemented yet in flash/Stage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "scaleMode", {
            /**
             * A value from the StageScaleMode class that specifies which scale mode to use.
             * The following are valid values:
             *
             *   StageScaleMode.EXACT_FIT—The entire application is visible
             * in the specified area without trying to preserve the original aspect ratio. Distortion can occur, and the application may appear stretched or compressed.
             * StageScaleMode.SHOW_ALL—The entire application is visible
             * in the specified area without distortion while maintaining the original aspect ratio of the application.
             * Borders can appear on two sides of the application.
             * StageScaleMode.NO_BORDER—The entire application fills the specified area,
             * without distortion but possibly with some cropping, while maintaining the original aspect ratio
             * of the application.
             * StageScaleMode.NO_SCALE—The entire application is fixed, so that
             * it remains unchanged even as the size of the player window changes. Cropping might
             * occur if the player window is smaller than the content.
             * @throws	SecurityError Calling the scaleMode property of a Stage object throws an exception for
             *   any caller that is not in the same security sandbox as the Stage owner (the main SWF file).
             *   To avoid this, the Stage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                return this._scaleMode;
            },
            set: function (value) {
                this._scaleMode = value;
                this._resizeCallbackDelegate(null);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "showDefaultContextMenu", {
            /**
             * Specifies whether to show or hide the default items in the Flash runtime
             * context menu.
             *
             *   If the showDefaultContextMenu property is set to true (the
             * default), all context menu items appear. If the showDefaultContextMenu property
             * is set to false, only the Settings and About... menu items appear.
             * @throws	SecurityError Calling the showDefaultContextMenu property of a Stage object throws an exception for
             *   any caller that is not in the same security sandbox as the Stage owner (the main SWF file).
             *   To avoid this, the Stage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                //todo
                console.log("showDefaultContextMenu not implemented yet in flash/Stage");
                return false;
            },
            set: function (value) {
                //todo
                console.log("showDefaultContextMenu not implemented yet in flash/Stage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "softKeyboardRect", {
            /**
             * The area of the stage that is currently covered by the software keyboard.
             *
             *   The area has a size of zero (0,0,0,0) when the soft keyboard is not visible.When the keyboard opens, the softKeyboardRect is set at the time the
             * softKeyboardActivate event is dispatched. If the keyboard changes size while open,
             * the runtime updates the softKeyboardRect property and dispatches an
             * additional softKeyboardActivate event.Note: On Android, the area covered by the keyboard is estimated when
             * the operating system does not provide the information necessary to determine the exact
             * area. This problem occurs in fullscreen mode and also when the keyboard opens in response to
             * an InteractiveObject receiving focus or invoking the requestSoftKeyboard() method.
             */
            get: function () {
                //todo
                console.log("softKeyboardRect not implemented yet in flash/Stage");
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "stage3Ds", {
            get: function () {
                // todo: any is stage3d
                console.log("stage3Ds not implemented yet in flash/Stage");
                return this._stage3Ds;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "stageFocusRect", {
            /**
             * Specifies whether or not objects display a glowing border when they have focus.
             * @throws	SecurityError Calling the stageFocusRect property of a Stage object throws an exception for
             *   any caller that is not in the same security sandbox as the Stage owner (the main SWF file).
             *   To avoid this, the Stage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                //todo
                console.log("stageFocusRect not implemented yet in flash/Stage");
                return false;
            },
            set: function (on) {
                //todo
                console.log("stageFocusRect not implemented yet in flash/Stage");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "stageHeight", {
            /**
             * The current height, in pixels, of the Stage.
             *
             *   If the value of the Stage.scaleMode property is set to StageScaleMode.NO_SCALE
             * when the user resizes the window, the Stage content maintains its size while the
             * stageHeight property changes to reflect the new height size of the screen area occupied by
             * the SWF file. (In the other scale modes, the stageHeight property always reflects the original
             * height of the SWF file.) You can add an event listener for the resize event and then use the
             * stageHeight property of the Stage class to determine the actual pixel dimension of the resized
             * Flash runtime window. The event listener allows you to control how
             * the screen content adjusts when the user resizes the window.Air for TV devices have slightly different behavior than desktop devices
             * when you set the stageHeight property.
             * If the Stage.scaleMode
             * property is set to StageScaleMode.NO_SCALE and you set the stageHeight
             * property, the stage height does not change until the next
             * frame of the SWF.Note: In an HTML page hosting the SWF file, both the object and embed tags' height attributes must be set to a percentage (such as 100%), not pixels. If the
             * settings are generated by JavaScript code, the height parameter of the AC_FL_RunContent()
             * method must be set to a percentage, too. This percentage is applied to the stageHeight
             * value.
             * @throws	SecurityError Calling the stageHeight property of a Stage object throws an exception for
             *   any caller that is not in the same security sandbox as the Stage owner (the main SWF file).
             *   To avoid this, the Stage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                return this._stageHeight;
            },
            set: function (value) {
                this._stageHeight = value;
                this.resizeCallback();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "stageVideos", {
            /**
             * A list of StageVideo objects available for playing external videos.
             *
             *   You can use only a limited number of StageVideo objects at a time.
             * When a SWF begins to run, the number of available StageVideo objects depends on the platform
             * and on available hardware.
             * To use a StageVideo object, assign a member of the stageVideos Vector object to a StageVideo variable.
             * All StageVideo objects are displayed on the stage behind any display objects.
             * The StageVideo objects are displayed on the stage in the order they appear in
             * the stageVideos Vector object. For example, if the stageVideos Vector object contains
             * three entries:The StageVideo object in the 0 index of the stageVideos Vector object is
             * displayed behind all StageVideo objects.The StageVideo object at index 1 is displayed in front
             * of the StageVideo object at index 0.The StageVideo object at index 2 is displayed in front
             * of the StageVideo object at index 1.Use the StageVideo.depth property to change this ordering.Note: AIR for TV devices support only one StageVideo object.
             */
            get: function () {
                //todo: any is StageVideo
                console.log("stageVideos not implemented yet in flash/Stage");
                return [];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "stageWidth", {
            /**
             * Specifies the current width, in pixels, of the Stage.
             *
             *   If the value of the Stage.scaleMode property is set to StageScaleMode.NO_SCALE
             * when the user resizes the window, the Stage content maintains its defined size while the stageWidth
             * property changes to reflect the new width size of the screen area occupied by the SWF file. (In the other scale
             * modes, the stageWidth property always reflects the original width of the SWF file.) You can add an event
             * listener for the resize event and then use the stageWidth property of the Stage class to
             * determine the actual pixel dimension of the resized Flash runtime window. The event listener allows you to control how
             * the screen content adjusts when the user resizes the window.Air for TV devices have slightly different behavior than desktop devices
             * when you set the stageWidth property.
             * If the Stage.scaleMode
             * property is set to StageScaleMode.NO_SCALE and you set the stageWidth
             * property, the stage width does not change until the next
             * frame of the SWF.Note: In an HTML page hosting the SWF file, both the object and embed tags' width attributes must be set to a percentage (such as 100%), not pixels. If the
             * settings are generated by JavaScript code, the width parameter of the AC_FL_RunContent()
             * method must be set to a percentage, too. This percentage is applied to the stageWidth
             * value.
             * @throws	SecurityError Calling the stageWidth property of a Stage object throws an exception for
             *   any caller that is not in the same security sandbox as the Stage owner (the main SWF file).
             *   To avoid this, the Stage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                return this._stageWidth;
            },
            set: function (value) {
                this._stageWidth = value;
                this.resizeCallback();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "tabChildren", {
            /**
             * Determines whether the children of the object are tab enabled. Enables or disables tabbing for the
             * children of the object. The default is true.
             * Note: Do not use the tabChildren property with Flex.
             * Instead, use the mx.core.UIComponent.hasFocusableChildren property.
             * @throws	SecurityError Referencing the tabChildren property of a Stage object throws an exception for
             *   any caller that is not in the same security sandbox as the Stage owner (the main SWF file).
             *   To avoid this, the Stage owner can grant permission to the domain of the caller by calling
             *   the Security.allowDomain() method or the Security.allowInsecureDomain() method.
             *   For more information, see the "Security" chapter in the ActionScript 3.0 Developer's Guide.
             */
            get: function () {
                //todo
                console.log("tabChildren not implemented yet in flash/Stage");
                return false;
            },
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "textSnapshot", {
            /**
             * Returns a TextSnapshot object for this DisplayObjectContainer instance.
             * @throws	IllegalOperationError Referencing the textSnapshot property of a Stage object throws an
             *   exception because the Stage class does not implement this property. To avoid this, call the
             *   textSnapshot property of a display object container other than the Stage object.
             */
            get: function () {
                //todo
                console.log("textSnapshot not implemented yet in flash/Stage");
                //todo: any is flash.text.TextSnapshot
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "wmodeGPU", {
            /**
             * Indicates whether GPU compositing is available and in use. The wmodeGPU value is trueonly
             * when all three of the following conditions exist:
             * GPU compositing has been requested.GPU compositing is available.GPU compositing is in use.Specifically, the wmodeGPU property indicates one of the following:GPU compositing has not been requested or is unavailable. In this case, the wmodeGPU property value is false.GPU compositing has been requested (if applicable and available), but the environment is operating in "fallback mode"
             * (not optimal rendering) due to limitations of the content. In this case, the wmodeGPU property value is true.GPU compositing has been requested (if applicable and available), and the environment is operating in the best mode. In this case, the
             * wmodeGPU property value is also true.In other words, the wmodeGPU property identifies the capability and state of the rendering environment. For runtimes
             * that do not support GPU compositing, such as AIR 1.5.2, the value is always false, because (as stated above) the value is
             * true only when GPU compositing has been requested, is available, and is in use.The wmodeGPU property is useful to determine, at runtime, whether or not GPU compositing is in use. The value of
             * wmodeGPU indicates if your content is going to be scaled by hardware, or not, so you can present graphics at the correct size.
             * You can also determine if you're rendering in a fast path or not, so that you can adjust your content complexity accordingly.For Flash Player in a browser, GPU compositing can be requested by the value of gpu for the wmode HTML
             * parameter in the page hosting the SWF file. For other configurations, GPU compositing can be requested in the header of a SWF file
             * (set using SWF authoring tools).However, the wmodeGPU property does not identify the current rendering performance. Even if GPU compositing is "in use" the rendering
             * process might not be operating in the best mode. To adjust your content for optimal rendering, use a Flash runtime debugger version,
             * and set the DisplayGPUBlendsetting in your mm.cfg file.Note: This property is always false when referenced
             * from ActionScript that runs before the runtime performs its first rendering
             * pass.  For example, if you examine wmodeGPU from a script in Frame 1 of
             * Adobe Flash Professional, and your SWF file is the first SWF file loaded in a new
             * instance of the runtime, then the wmodeGPU value is false.
             * To get an accurate value, wait until at least one rendering pass
             * has occurred. If you write an event listener for the
             * exitFrame event of any DisplayObject, the wmodeGPU value at
             * is the correct value.
             */
            get: function () {
                //todo
                console.log("wmodeGPU not implemented yet in flash/Stage");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "accessibilityProperties", {
            //empty functions to prevent inherited actions
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "alpha", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "blendMode", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "cacheAsBitmap", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "contextMenu", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "filters", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "focusRect", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "loaderInfo", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "mask", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "mouseChildren", {
            get: function () { return false; },
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "mouseEnabled", {
            get: function () { return false; },
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "numChildren", {
            get: function () { return 0; },
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "width", {
            get: function () { return 0; },
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "height", {
            get: function () { return 0; },
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "opaqueBackground", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "name", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "rotation", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "rotationX", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "rotationY", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "rotationZ", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "scale9Grid", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "scaleX", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "scaleY", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "scaleZ", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "scrollRect", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "tabEnabled", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "tabIndex", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "transform", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "visible", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "x", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "y", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Stage.prototype, "z", {
            set: function (value) { },
            enumerable: true,
            configurable: true
        });
        // 80pro: todo: this was added because otherwise avm2 cant find these on Stage
        //	but it should find them anyway, because its inheriting from Sprite...
        //____________________________________
        Stage.prototype.addChild = function (child) { return _super.prototype.addChild.call(this, child); };
        Stage.prototype.addChildAt = function (child, index) { return _super.prototype.addChildAt.call(this, child, index); };
        Stage.prototype.removeChildAt = function (index) { return _super.prototype.removeChildAt.call(this, index); };
        Stage.prototype.swapChildrenAt = function (index, index2) { return _super.prototype.swapChildrenAt.call(this, index, index2); };
        Stage.prototype.setChildIndex = function (child, index) { return null; };
        Stage.prototype.addEventListener = function (type, listener, useCapture, priority, useWeakReference) {
            if (useCapture === void 0) { useCapture = false; }
            if (priority === void 0) { priority = 0; }
            if (useWeakReference === void 0) { useWeakReference = false; }
            _super.prototype.addEventListener.call(this, type, listener, useCapture = false, priority, useWeakReference);
        };
        Stage.prototype.hasEventListener = function (type) {
            return _super.prototype.hasEventListener.call(this, type);
        };
        Stage.prototype.willTrigger = function () { return _super.prototype.willTrigger.call(this); };
        Stage.prototype.dispatchEvent = function (event) {
            return _super.prototype.dispatchEvent.call(this, event);
        };
        //____________________________________
        /**
         * Calling the invalidate() method signals Flash runtimes to alert display objects
         * on the next opportunity it has to render the display list (for example, when the playhead
         * advances to a new frame). After you call the invalidate() method, when the display
         * list is next rendered, the Flash runtime sends a render event to each display object that has
         * registered to listen for the render event. You must call the invalidate()
         * method each time you want the Flash runtime to send render events.
         *
         *   The render event gives you an opportunity to make changes to the display list
         * immediately before it is actually rendered. This lets you defer updates to the display list until the
         * latest opportunity. This can increase performance by eliminating unnecessary screen updates.The render event is dispatched only to display objects that are in the same
         * security domain as the code that calls the stage.invalidate() method,
         * or to display objects from a security domain that has been granted permission via the
         * Security.allowDomain() method.
         */
        Stage.prototype.invalidate = function () {
            //todo
            console.log("invalidate not implemented yet in flash/Stage");
        };
        /**
         * Determines whether the Stage.focus property returns null for
         * security reasons.
         * In other words, isFocusInaccessible returns true if the
         * object that has focus belongs to a security sandbox to which the SWF file does not have access.
         * @return	true if the object that has focus belongs to a security sandbox to which
         *   the SWF file does not have access.
         */
        Stage.prototype.isFocusInaccessible = function () {
            //todo
            console.log("isFocusInaccessible not implemented yet in flash/Stage");
            return false;
        };
        Stage._colorMaterials = {};
        Stage._textureMaterials = {};
        Stage._useTextureAtlasForColors = true;
        return Stage;
    }(DisplayObjectContainer$1));

    /*
    import { DisplayObject } from "./DisplayObject";
    import { Graphics } from "./Graphics";
    import { Sprite } from "./Sprite";
    */
    /**
     * This class is used to create lightweight shapes using the ActionScript drawing application program interface (API).
     * The Shape class includes a <codeph class="+ topic/ph pr-d/codeph ">graphics</codeph> property, which lets you access methods from the Graphics class.
     *
     *   <p class="- topic/p ">The Sprite class also includes a <codeph class="+ topic/ph pr-d/codeph ">graphics</codeph>property, and it includes other features not available to the
     * Shape class. For example, a Sprite object is a display object container, whereas a Shape object is not (and cannot contain
     * child display objects). For this reason, Shape objects consume less memory than Sprite objects that contain the
     * same graphics. However, a Sprite object supports user input events, while a Shape object does not.</p>
     */
    /*
    export class Shape extends DisplayObject
    {
    */
    /**
     * Creates a new Shape object.
     */
    /*
    constructor (){
        super(null)//todo;
    }
    */
    /**
     * Specifies the Graphics object belonging to this Shape object, where vector
     * drawing commands can occur.
     */
    /*
        public get graphics () : Graphics{
            console.log("graphics not implemented yet in flash/Shape");
            return null;
        }
    }
    */

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: Matrix3D
    /*
      * _matrix stores data by columns
      *  | 0  4  8  12 |
      *  | 1  5  9  13 |
      *  | 2  6 10  14 |
      *  | 3  7 11  15 |
      */
    var transposeTransform = new Uint32Array([
        0, 4, 8, 12, 1, 5, 9, 13, 2, 6, 10, 14, 3, 7, 11, 15
    ]);
    var Matrix3D$1 = /** @class */ (function (_super) {
        __extends(Matrix3D$$1, _super);
        function Matrix3D$$1(v) {
            if (v === void 0) { v = null; }
            var _this = _super.call(this) || this;
            if (v instanceof Matrix3D) {
                _this._adaptee = v;
            }
            else {
                _this._adaptee = new Matrix3D();
                if (v && v.length >= 16) {
                    _this.copyRawDataFrom(v, 0, false);
                }
                else {
                    _this.identity();
                }
            }
            return _this;
        }
        Object.defineProperty(Matrix3D$$1.prototype, "adaptee", {
            get: function () {
                return this._adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Matrix3D$$1.interpolate = function (thisMat, toMat, percent) {
            thisMat = thisMat;
            toMat = toMat;
            percent = +percent;
            release$1 || notImplemented("public flash.geom.Matrix3D::static interpolate");
            return;
        };
        Object.defineProperty(Matrix3D$$1.prototype, "rawData", {
            get: function () {
                var result = new this.sec.Float64Vector();
                this.copyRawDataTo(result, 0, false);
                return result;
            },
            set: function (v) {
                this.copyRawDataFrom(v, 0, false);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix3D$$1.prototype, "position", {
            get: function () {
                return new this.sec.flash.geom.Vector3D(this._adaptee.position);
            },
            set: function (pos) {
                this.copyColumnFrom(3, pos);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Matrix3D$$1.prototype, "determinant", {
            get: function () {
                return this._adaptee.determinant;
            },
            enumerable: true,
            configurable: true
        });
        Matrix3D$$1.prototype.clone = function () {
            return new this.sec.flash.geom.Matrix3D(this._adaptee.clone());
        };
        Matrix3D$$1.prototype.copyToMatrix3D = function (dest) {
            this._adaptee.copyTo(dest.adaptee);
        };
        Matrix3D$$1.prototype.append = function (lhs) {
            this._adaptee.append(lhs.adaptee);
        };
        Matrix3D$$1.prototype.prepend = function (rhs) {
            this._adaptee.prepend(rhs.adaptee);
        };
        Matrix3D$$1.prototype.invert = function () {
            return this._adaptee.invert();
        };
        Matrix3D$$1.prototype.identity = function () {
            this._adaptee.identity();
        };
        Matrix3D$$1.prototype.decompose = function (orientationStyle) {
            if (orientationStyle === void 0) { orientationStyle = "eulerAngles"; }
            this._adaptee.decompose(orientationStyle);
            orientationStyle = axCoerceString(orientationStyle);
            release$1 || notImplemented("public flash.geom.Matrix3D::decompose");
            return;
        };
        Matrix3D$$1.prototype.recompose = function (components, orientationStyle) {
            if (orientationStyle === void 0) { orientationStyle = "eulerAngles"; }
            //this._adaptee.recompose()
            orientationStyle = axCoerceString(orientationStyle);
            release$1 || notImplemented("public flash.geom.Matrix3D::recompose");
            return;
        };
        Matrix3D$$1.prototype.appendTranslation = function (x, y, z) {
            this._adaptee.appendTranslation(+x, +y, +z);
        };
        Matrix3D$$1.prototype.appendRotation = function (degrees, axis, pivotPoint) {
            if (pivotPoint === void 0) { pivotPoint = null; }
            release$1 || somewhatImplemented("public flash.geom.Matrix3D::appendRotation");
            this._adaptee.appendRotation(+degrees, axis.adaptee);
        };
        Matrix3D$$1.prototype.appendScale = function (xScale, yScale, zScale) {
            this._adaptee.appendScale(+xScale, +yScale, +zScale);
        };
        Matrix3D$$1.prototype.prependTranslation = function (x, y, z) {
            this._adaptee.prependTranslation(+x, +y, +z);
        };
        Matrix3D$$1.prototype.prependRotation = function (degrees, axis, pivotPoint) {
            if (pivotPoint === void 0) { pivotPoint = null; }
            release$1 || somewhatImplemented("public flash.geom.Matrix3D::prependRotation");
            this._adaptee.prependRotation(+degrees, axis.adaptee);
        };
        Matrix3D$$1.prototype.prependScale = function (xScale, yScale, zScale) {
            this._adaptee.prependScale(+xScale, +yScale, +zScale);
        };
        Matrix3D$$1.prototype.transformVector = function (v) {
            return new this.sec.flash.geom.Vector3D(this._adaptee.transformVector(v.adaptee));
        };
        Matrix3D$$1.prototype.deltaTransformVector = function (v) {
            return new this.sec.flash.geom.Vector3D(this._adaptee.deltaTransformVector(v.adaptee));
        };
        Matrix3D$$1.prototype.transformVectors = function (vin, vout) {
            var m = this._adaptee._rawData;
            var m11 = m[0], m12 = m[4], m13 = m[8], m14 = m[12], m21 = m[1], m22 = m[5], m23 = m[9], m24 = m[13], m31 = m[2], m32 = m[6], m33 = m[10], m34 = m[14];
            for (var i = 0; i < vin.length - 2; i += 3) {
                var x = vin.axGetNumericProperty(i), y = vin.axGetNumericProperty(i + 1), z = vin.axGetNumericProperty(i + 2);
                vout.push(m11 * x + m12 * y + m13 * z + m14);
                vout.push(m21 * x + m22 * y + m23 * z + m24);
                vout.push(m31 * x + m32 * y + m33 * z + m34);
            }
        };
        Matrix3D$$1.prototype.transpose = function () {
            this._adaptee.transpose();
        };
        Matrix3D$$1.prototype.pointAt = function (pos, at, up) {
            if (at === void 0) { at = null; }
            if (up === void 0) { up = null; }
            pos = pos;
            at = at;
            up = up;
            release$1 || notImplemented("public flash.geom.Matrix3D::pointAt");
            return;
        };
        Matrix3D$$1.prototype.interpolateTo = function (toMat, percent) {
            toMat = toMat;
            percent = +percent;
            release$1 || notImplemented("public flash.geom.Matrix3D::interpolateTo");
            return;
        };
        Matrix3D$$1.prototype.copyFrom = function (sourceMatrix3D) {
            this._adaptee.copyFrom(sourceMatrix3D.adaptee);
        };
        Matrix3D$$1.prototype.copyRawDataTo = function (vector, index, transpose) {
            if (index === void 0) { index = 0; }
            if (transpose === void 0) { transpose = false; }
            vector = vector;
            index = index >>> 0;
            transpose = !!transpose;
            var m = this._adaptee._rawData;
            if (transpose) {
                for (var i = 0, j = index | 0; i < 16; i++, j++) {
                    vector.axSetNumericProperty(j, m[transposeTransform[i]]);
                }
            }
            else {
                for (var i = 0, j = index | 0; i < 16; i++, j++) {
                    vector.axSetNumericProperty(j, m[i]);
                }
            }
        };
        Matrix3D$$1.prototype.copyRawDataFrom = function (vector, index, transpose) {
            if (index === void 0) { index = 0; }
            if (transpose === void 0) { transpose = false; }
            vector = vector;
            index = index >>> 0;
            transpose = !!transpose;
            var m = this._adaptee._rawData;
            if (transpose) {
                for (var i = 0, j = index | 0; i < 16; i++, j++) {
                    m[transposeTransform[i]] = vector.axGetNumericProperty(j) || 0; // removing NaN
                }
            }
            else {
                for (var i = 0, j = index | 0; i < 16; i++, j++) {
                    m[i] = vector.axGetNumericProperty(j) || 0; // removing NaN
                }
            }
        };
        Matrix3D$$1.prototype.copyRowTo = function (row /*uint*/, vector3D) {
            this._adaptee.copyRowTo(row >>> 0, vector3D.adaptee);
        };
        Matrix3D$$1.prototype.copyColumnTo = function (column /*uint*/, vector3D) {
            this._adaptee.copyColumnTo(column >>> 0, vector3D.adaptee);
        };
        Matrix3D$$1.prototype.copyRowFrom = function (row /*uint*/, vector3D) {
            this._adaptee.copyRowFrom(row >>> 0, vector3D.adaptee);
        };
        Matrix3D$$1.prototype.copyColumnFrom = function (column /*uint*/, vector3D) {
            this._adaptee.copyColumnFrom(column >>> 0, vector3D.adaptee);
        };
        Matrix3D$$1.classInitializer = null;
        return Matrix3D$$1;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: Vector3D
    var Vector3D$1 = /** @class */ (function (_super) {
        __extends(Vector3D$$1, _super);
        /**
         * Creates an instance of a Vector3D object. If you do not specify a
         * parameter for the constructor, a Vector3D object is created with
         * the elements (0,0,0,0).
         *
         * @param x The first element, such as the x coordinate.
         * @param y The second element, such as the y coordinate.
         * @param z The third element, such as the z coordinate.
         * @param w An optional element for additional data such as the angle
         *          of rotation.
         */
        function Vector3D$$1(xAdaptee, y, z, w) {
            if (xAdaptee === void 0) { xAdaptee = 0; }
            if (y === void 0) { y = 0; }
            if (z === void 0) { z = 0; }
            if (w === void 0) { w = 0; }
            var _this = _super.call(this) || this;
            _this._adaptee = (xAdaptee instanceof Vector3D) ? xAdaptee : new Vector3D(+xAdaptee, +y, +z, +w);
            return _this;
        }
        Vector3D$$1.classInitializer = function () {
            this.X_AXIS = Object.freeze(this.Create(1, 0, 0, 0));
            this.Y_AXIS = Object.freeze(this.Create(1, 0, 0, 0));
            this.Z_AXIS = Object.freeze(this.Create(1, 0, 0, 0));
        };
        Vector3D$$1.Create = function (x, y, z, w) {
            var v = Object.create(this.tPrototype);
            v.x = x;
            v.y = y;
            v.z = z;
            v.w = w;
            return v;
        };
        Object.defineProperty(Vector3D$$1.prototype, "adaptee", {
            get: function () {
                return this._adaptee;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Vector3D$$1.prototype, "x", {
            /**
             * The first element of a Vector3D object, such as the x coordinate of
             * a point in the three-dimensional space. The default value is 0.
             */
            get: function () {
                return this._adaptee._rawData[0];
            },
            set: function (value) {
                this._adaptee._rawData[0] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Vector3D$$1.prototype, "y", {
            /*
             *The second element of a Vector3D object, such as the y coordinate of
             * a point in the three-dimensional space. The default value is 0.
             */
            get: function () {
                return this._adaptee._rawData[1];
            },
            set: function (value) {
                this._adaptee._rawData[1] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Vector3D$$1.prototype, "z", {
            /**
             * The third element of a Vector3D object, such as the z coordinate of
             * a point in the three-dimensional space. The default value is 0.
             */
            get: function () {
                return this._adaptee._rawData[2];
            },
            set: function (value) {
                this._adaptee._rawData[2] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Vector3D$$1.prototype, "w", {
            /**
             * The fourth element of a Vector3D object (in addition to the x, y,
             * and z properties) can hold data such as the angle of rotation. The
             * default value is 0.
             *
             * <p>Quaternion notation employs an angle as the fourth element in
             * its calculation of three-dimensional rotation. The w property can
             * be used to define the angle of rotation about the Vector3D object.
             * The combination of the rotation angle and the coordinates (x,y,z)
             * determines the display object's orientation.</p>
             *
             * <p>In addition, the w property can be used as a perspective warp
             * factor for a projected three-dimensional position or as a projection
             * transform value in representing a three-dimensional coordinate
             * projected into the two-dimensional space. For example, you can
             * create a projection matrix using the <code>Matrix3D.rawData</code>
             * property, that, when applied to a Vector3D object, produces a
             * transform value in the Vector3D object's fourth element (the w
             * property). Dividing the Vector3D object's other elements by the
             * transform value then produces a projected Vector3D object. You can
             * use the <code>Vector3D.project()</code> method to divide the first
             * three elements of a Vector3D object by its fourth element.</p>
             */
            get: function () {
                return this._adaptee._rawData[3];
            },
            set: function (value) {
                this._adaptee._rawData[3] = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Vector3D$$1.prototype, "length", {
            /**
             * The length, magnitude, of the current Vector3D object from the
             * origin (0,0,0) to the object's x, y, and z coordinates. The w
             * property is ignored. A unit vector has a length or magnitude of
             * one.
             */
            get: function () {
                return this._adaptee.length;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Vector3D$$1.prototype, "lengthSquared", {
            /**
             * The square of the length of the current Vector3D object, calculated
             * using the x, y, and z properties. The w property is ignored. Use the
             * <code>lengthSquared()</code> method whenever possible instead of the
             * slower <code>Math.sqrt()</code> method call of the
             * <code>Vector3D.length()</code> method.
             */
            get: function () {
                return this._adaptee.lengthSquared;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Returns the angle in radians between two vectors. The returned angle
         * is the smallest radian the first Vector3D object rotates until it
         * aligns with the second Vector3D object.
         *
         * <p>The <code>angleBetween()</code> method is a static method. You
         * can use it directly as a method of the Vector3D class.</p>
         *
         * <p>To convert a degree to a radian, you can use the following
         * formula:</p>
         *
         * <p><code>radian = Math.PI/180 * degree</code></p>
         *
         * @param a The first Vector3D object.
         * @param b The second Vector3D object.
         * @returns The angle between two Vector3D objects.
         */
        Vector3D$$1.angleBetween = function (a, b) {
            return Vector3D.angleBetween(a.adaptee, b.adaptee);
        };
        /**
         * Returns the distance between two Vector3D objects. The
         * <code>distance()</code> method is a static method. You can use it
         * directly as a method of the Vector3D export class to get the Euclidean
         * distance between two three-dimensional points.
         *
         * @param pt1 A Vector3D object as the first three-dimensional point.
         * @param pt2 A Vector3D object as the second three-dimensional point.
         * @returns The distance between two Vector3D objects.
         */
        Vector3D$$1.distance = function (pt1, pt2) {
            return Vector3D.distance(pt1.adaptee, pt2.adaptee);
        };
        /**
         * If the current Vector3D object and the one specified as the
         * parameter are unit vertices, this method returns the cosine of the
         * angle between the two vertices. Unit vertices are vertices that
         * point to the same direction but their length is one. They remove the
         * length of the vector as a factor in the result. You can use the
         * <code>normalize()</code> method to convert a vector to a unit
         * vector.
         *
         * <p>The <code>dotProduct()</code> method finds the angle between two
         * vertices. It is also used in backface culling or lighting
         * calculations. Backface culling is a procedure for determining which
         * surfaces are hidden from the viewpoint. You can use the normalized
         * vertices from the camera, or eye, viewpoint and the cross product of
         * the vertices of a polygon surface to get the dot product. If the dot
         * product is less than zero, then the surface is facing the camera or
         * the viewer. If the two unit vertices are perpendicular to each
         * other, they are orthogonal and the dot product is zero. If the two
         * vertices are parallel to each other, the dot product is one.</p>
         *
         * @param a The second Vector3D object.
         * @returns A scalar which is the dot product of the current Vector3D
         *          object and the specified Vector3D object.
         */
        Vector3D$$1.prototype.dotProduct = function (a) {
            return this._adaptee.dotProduct(a.adaptee);
        };
        /**
         * Returns a new Vector3D object that is perpendicular (at a right
         * angle) to the current Vector3D and another Vector3D object. If the
         * returned Vector3D object's coordinates are (0,0,0), then the two
         * Vector3D objects are parallel to each other.
         *
         * <p>You can use the normalized cross product of two vertices of a
         * polygon surface with the normalized vector of the camera or eye
         * viewpoint to get a dot product. The value of the dot product can
         * identify whether a surface of a three-dimensional object is hidden
         * from the viewpoint.</p>
         *
         * @param a A second Vector3D object.
         * @returns A new Vector3D object that is perpendicular to the current
         *          Vector3D object and the Vector3D object specified as the
         *          parameter.
         */
        Vector3D$$1.prototype.crossProduct = function (a) {
            return new this.sec.flash.geom.Vector3D(this._adaptee.crossProduct(a.adaptee));
        };
        /**
         * Converts a Vector3D object to a unit vector by dividing the first
         * three elements (x, y, z) by the length of the vector. Unit vertices
         * are vertices that have a direction but their length is one. They
         * simplify vector calculations by removing length as a factor.
         */
        Vector3D$$1.prototype.normalize = function () {
            return this._adaptee.normalize();
        };
        /**
         * Scales the current Vector3D object by a scalar, a magnitude. The
         * Vector3D object's x, y, and z elements are multiplied by the scalar
         * number specified in the parameter. For example, if the vector is
         * scaled by ten, the result is a vector that is ten times longer. The
         * scalar can also change the direction of the vector. Multiplying the
         * vector by a negative number reverses its direction.
         *
         * @param s A multiplier (scalar) used to scale a Vector3D object.
         */
        Vector3D$$1.prototype.scaleBy = function (s) {
            this._adaptee.scaleBy(+s);
        };
        /**
         * Increments the value of the x, y, and z elements of the current
         * Vector3D object by the values of the x, y, and z elements of a
         * specified Vector3D object. Unlike the <code>Vector3D.add()</code>
         * method, the <code>incrementBy()</code> method changes the current
         * Vector3D object and does not return a new Vector3D object.
         *
         * @param a The Vector3D object to be added to the current Vector3D
         *          object.
         */
        Vector3D$$1.prototype.incrementBy = function (a) {
            this._adaptee.incrementBy(a.adaptee);
        };
        /**
         * Decrements the value of the x, y, and z elements of the current
         * Vector3D object by the values of the x, y, and z elements of
         * specified Vector3D object. Unlike the
         * <code>Vector3D.subtract()</code> method, the
         * <code>decrementBy()</code> method changes the current Vector3D
         * object and does not return a new Vector3D object.
         *
         * @param a The Vector3D object containing the values to subtract from
         *          the current Vector3D object.
         */
        Vector3D$$1.prototype.decrementBy = function (a) {
            this._adaptee.decrementBy(a.adaptee);
        };
        /**
         * Adds the value of the x, y, and z elements of the current Vector3D
         * object to the values of the x, y, and z elements of another Vector3D
         * object. The <code>add()</code> method does not change the current
         * Vector3D object. Instead, it returns a new Vector3D object with
         * the new values.
         *
         * <p>The result of adding two vectors together is a resultant vector.
         * One way to visualize the result is by drawing a vector from the
         * origin or tail of the first vector to the end or head of the second
         * vector. The resultant vector is the distance between the origin
         * point of the first vector and the end point of the second vector.
         * </p>
         */
        Vector3D$$1.prototype.add = function (a) {
            return new this.sec.flash.geom.Vector3D(this._adaptee.add(a.adaptee));
        };
        /**
         * Subtracts the value of the x, y, and z elements of the current
         * Vector3D object from the values of the x, y, and z elements of
         * another Vector3D object. The <code>subtract()</code> method does not
         * change the current Vector3D object. Instead, this method returns a
         * new Vector3D object with the new values.
         *
         * @param a The Vector3D object to be subtracted from the current
         *          Vector3D object.
         * @returns A new Vector3D object that is the difference between the
         *          current Vector3D and the specified Vector3D object.
         */
        Vector3D$$1.prototype.subtract = function (a) {
            return new this.sec.flash.geom.Vector3D(this._adaptee.subtract(a.adaptee));
        };
        /**
         * Sets the current Vector3D object to its inverse. The inverse object
         * is also considered the opposite of the original object. The value of
         * the x, y, and z properties of the current Vector3D object is changed
         * to -x, -y, and -z.
         */
        Vector3D$$1.prototype.negate = function () {
            this._adaptee.negate();
        };
        /**
         * Determines whether two Vector3D objects are equal by comparing the
         * x, y, and z elements of the current Vector3D object with a
         * specified Vector3D object. If the values of these elements are the
         * same, the two Vector3D objects are equal. If the second optional
         * parameter is set to true, all four elements of the Vector3D objects,
         * including the w property, are compared.
         *
         * @param toCompare The Vector3D object to be compared with the current
         *                  Vector3D object.
         * @param allFour   An optional parameter that specifies whether the w
         *                  property of the Vector3D objects is used in the
         *                  comparison.
         * @returns A value of true if the specified Vector3D object is equal
         *          to the current Vector3D object; false if it is not equal.
         */
        Vector3D$$1.prototype.equals = function (toCompare, allFour) {
            return this._adaptee.equals(toCompare.adaptee, allFour);
        };
        /**
         * Compares the elements of the current Vector3D object with the
         * elements of a specified Vector3D object to determine whether they
         * are nearly equal. The two Vector3D objects are nearly equal if the
         * value of all the elements of the two vertices are equal, or the
         * result of the comparison is within the tolerance range. The
         * difference between two elements must be less than the number
         * specified as the tolerance parameter. If the third optional
         * parameter is set to <code>true</code>, all four elements of the
         * Vector3D objects, including the <code>w</code> property, are
         * compared. Otherwise, only the x, y, and z elements are included in
         * the comparison.
         *
         * @param toCompare The Vector3D object to be compared with the current
         *                  Vector3D object.
         * @param tolerance A number determining the tolerance factor. If the
         *                  difference between the values of the Vector3D
         *                  element specified in the toCompare parameter and
         *                  the current Vector3D element is less than the
         *                  tolerance number, the two values are considered
         *                  nearly equal.
         * @param allFour   An optional parameter that specifies whether the w
         *                  property of the Vector3D objects is used in the
         *                  comparison.
         * @returns A value of true if the specified Vector3D object is nearly
         *          equal to the current Vector3D object; false if it is not
         *          equal.
         */
        Vector3D$$1.prototype.nearEquals = function (toCompare, tolerance, allFour) {
            return this._adaptee.nearEquals(toCompare.adaptee, tolerance, allFour);
        };
        /**
         * Divides the value of the <code>x</code>, <code>y</code>, and
         * <code>z</code> properties of the current Vector3D object by the
         * value of its <code>w</code> property.
         *
         * <p>If the current Vector3D object is the result of multiplying a
         * Vector3D object by a projection Matrix3D object, the w property can
         * hold the transform value. The <code>project()</code> method then can
         * complete the projection by dividing the elements by the
         * <code>w</code> property. Use the <code>Matrix3D.rawData</code>
         * property to create a projection Matrix3D object.</p>
         */
        Vector3D$$1.prototype.project = function () {
            this._adaptee.project();
        };
        /**
         * Copies all of vector data from the source Vector3D object into the
         * calling Vector3D object.
         *
         * @param sourceVector3D The Vector3D object from which to copy the data.
         */
        Vector3D$$1.prototype.copyFrom = function (sourceVector3D) {
            this._adaptee.copyFrom(sourceVector3D.adaptee);
        };
        /**
         * Sets the members of Vector3D to the specified values
         *
         * @param xa The first element, such as the x coordinate.
         * @param ya The second element, such as the y coordinate.
         * @param za The third element, such as the z coordinate.
         */
        Vector3D$$1.prototype.setTo = function (xa, ya, za) {
            this._adaptee.setTo(xa, ya, za);
        };
        /**
         * Returns a new Vector3D object that is an exact copy of the current
         * Vector3D object.
         *
         * @returns A new Vector3D object that is a copy of the current
         * Vector3D object.
         */
        Vector3D$$1.prototype.clone = function () {
            return new this.sec.flash.geom.Vector3D(this._adaptee.clone());
        };
        Vector3D$$1.prototype.toString = function () {
            return "Vector3D(" + this.x + ", " + this.y + ", " + this.z + ")";
        };
        return Vector3D$$1;
    }(ASObject$1));

    /**
     * The ApplicationDomain class is a container for discrete groups of class definitions.
     * Application domains are used to partition classes that are in the same security domain.
     * They allow multiple definitions of the same class to exist and allow children to reuse parent
     * definitions.
     *
     *   <p class="- topic/p ">Application domains are used when an external SWF file is loaded through the Loader class.
     * All ActionScript 3.0 definitions in the loaded SWF file are stored in the application
     * domain, which is specified by the <codeph class="+ topic/ph pr-d/codeph ">applicationDomain</codeph> property of the LoaderContext
     * object that you pass as a <codeph class="+ topic/ph pr-d/codeph ">context</codeph> parameter of the Loader object's <codeph class="+ topic/ph pr-d/codeph ">load()</codeph> or
     * <codeph class="+ topic/ph pr-d/codeph ">loadBytes()</codeph> method. The LoaderInfo object also contains an
     * <codeph class="+ topic/ph pr-d/codeph ">applicationDomain</codeph> property, which is read-only.</p><p class="- topic/p ">All code in a SWF file is defined to exist in an application domain. The current application
     * domain is where your main application runs. The system domain contains all application domains,
     * including the current domain, which means that it contains all Flash Player classes.</p><p class="- topic/p ">Every application domain, except the system domain, has an associated parent domain.
     * The parent domain of your main application's application domain is the system domain.
     * Loaded classes are defined only when their parent doesn't already define them.
     * You cannot override a loaded class definition with a newer definition.</p><p class="- topic/p ">For usage examples of application domains, see the <i class="+ topic/ph hi-d/i ">ActionScript 3.0 Developer's Guide</i>.</p><p class="- topic/p ">The <codeph class="+ topic/ph pr-d/codeph ">ApplicationDomain()</codeph> constructor function allows you to create an ApplicationDomain object.</p>
     *
     * @internal	Security considerations for application domains are discussed in the
     *   applicationDomain property entries of URLRequest and LoaderInfo.
     */
    var ApplicationDomain = /** @class */ (function (_super) {
        __extends(ApplicationDomain, _super);
        /**
         * Creates a new application domain.
         * @param	parentDomain	If no parent domain is passed in, this application domain takes the system domain as its parent.
         */
        function ApplicationDomain(parentDomain) {
            if (parentDomain === void 0) { parentDomain = null; }
            var _this = _super.call(this) || this;
            if (parentDomain == null && ApplicationDomain._currentDomain != null) {
                parentDomain = ApplicationDomain.getSystemDomain();
            }
            _this._parentDomain = parentDomain;
            _this._definitions = {};
            _this._font_definitions = {};
            _this._audio_definitions = {};
            return _this;
        }
        ApplicationDomain.getSystemDomain = function () {
            if (ApplicationDomain._systemDomain == null)
                ApplicationDomain._systemDomain = new ApplicationDomain();
            return ApplicationDomain._systemDomain;
        };
        Object.defineProperty(ApplicationDomain, "currentDomain", {
            /**
             * Gets the current application domain in which your code is executing.
             * @internal	Question: Do you call System.currentDomain? or Loader.currentDomain or request.currentDomain?
             */
            get: function () {
                if (ApplicationDomain._systemDomain == null)
                    ApplicationDomain._systemDomain = new ApplicationDomain();
                if (ApplicationDomain._currentDomain == null)
                    ApplicationDomain._currentDomain = new ApplicationDomain(ApplicationDomain._systemDomain);
                return ApplicationDomain._currentDomain;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ApplicationDomain.prototype, "domainMemory", {
            /**
             * Gets and sets the object on which domain-global memory operations
             * will operate within this ApplicationDomain.
             */
            get: function () {
                console.log("domainMemory not implemented yet in flash/ApplicationDomain");
                return null;
            },
            set: function (mem) {
                console.log("domainMemory not implemented yet in flash/ApplicationDomain");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ApplicationDomain, "MIN_DOMAIN_MEMORY_LENGTH", {
            /**
             * Gets the minimum memory object length required to be used as
             * ApplicationDomain.domainMemory.
             */
            get: function () {
                console.log("MIN_DOMAIN_MEMORY_LENGTH not implemented yet in flash/ApplicationDomain");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ApplicationDomain.prototype, "parentDomain", {
            /**
             * Gets the parent domain of this application domain.
             */
            get: function () {
                return this._parentDomain;
            },
            enumerable: true,
            configurable: true
        });
        ApplicationDomain.prototype.addDefinition = function (name, asset) {
            this._definitions[name] = asset;
        };
        ApplicationDomain.prototype.addAudioDefinition = function (name, asset) {
            this._audio_definitions[name] = asset;
        };
        ApplicationDomain.prototype.addFontDefinition = function (name, asset) {
            this._font_definitions[name] = asset;
        };
        /**
         * Gets a public definition from the specified application domain.
         * The definition can be that of a class, a namespace, or a function.
         * @param	name	The name of the definition.
         * @return	The object associated with the definition.
         * @internal	throws SecurityError The definition belongs to a domain to which
         *   the calling code does not have access.
         * @throws	ReferenceError No public definition exists with the
         *   specified name.
         */
        ApplicationDomain.prototype.getDefinition = function (name) {
            if (this._definitions[name]) {
                if (this._definitions[name].isAsset && this._definitions[name].isAsset(SceneImage2D)) {
                    return this._definitions[name];
                }
                var newAdapter = this._definitions[name].adapter.clone();
                if (newAdapter.adaptee.isAsset(MovieClip)) {
                    newAdapter.adaptee.currentFrameIndex = 0;
                }
                return newAdapter;
            }
            else if (this._font_definitions[name]) {
                return this._font_definitions[name];
            }
            else if (this._audio_definitions[name]) {
                var sound = new Sound();
                sound.adaptee = this._audio_definitions[name];
                //sound.adaptee.adapter=sound;
                return sound;
            }
            return null;
        };
        ApplicationDomain.prototype.getFontDefinition = function (name) {
            return this._font_definitions[name];
        };
        ApplicationDomain.prototype.getAwayJSAudio = function (name) {
            return this._audio_definitions[name];
        };
        ApplicationDomain.prototype.getAudioDefinition = function (name) {
            var sound = new Sound();
            sound.adaptee = this._audio_definitions[name];
            //sound.adaptee.adapter=sound;
            return sound;
        };
        ApplicationDomain.prototype.getQualifiedDefinitionNames = function () {
            var allDefinitionsnames = [];
            for (var key in this._definitions) {
                if (this._definitions.hasOwnProperty(key)) {
                    allDefinitionsnames[allDefinitionsnames.length] = key;
                }
            }
            return allDefinitionsnames;
        };
        /**
         * Checks to see if a public definition exists within the specified application domain.
         * The definition can be that of a class, a namespace, or a function.
         * @param	name	The name of the definition.
         * @return	A value of true if the specified definition exists; otherwise, false.
         */
        ApplicationDomain.prototype.hasDefinition = function (name) {
            return this._definitions.hasOwnProperty(name);
        };
        ApplicationDomain.prototype.hasFontDefinition = function (name) {
            return this._font_definitions.hasOwnProperty(name);
        };
        ApplicationDomain.prototype.hasAudioDefinition = function (name) {
            return this._audio_definitions.hasOwnProperty(name);
        };
        return ApplicationDomain;
    }(ASObject$1));

    //import { XML } from "../xml/XML";
    /**
     * The System class contains properties related to local settings and operations. Among these are <ph class="- topic/ph ">
     * settings for camers and microphones, operations with shared objects and</ph> the use of the Clipboard.
     *
     *   <p class="- topic/p ">Additional properties and methods are in other classes within the flash.system package:
     * the Capabilities class, <ph class="- topic/ph ">the IME class,</ph> and the
     * Security class.</p><p class="- topic/p ">This class contains only static methods and properties. You cannot
     * create new instances of the System class.</p>
     */
    var System$1 = /** @class */ (function (_super) {
        __extends(System, _super);
        function System() {
            return _super.call(this) || this;
        }
        Object.defineProperty(System, "freeMemory", {
            /**
             * The amount of memory (in bytes) that is allocated to
             * Adobe® Flash® Player or
             * Adobe® AIR® and that is not in use. This unused portion of
             * allocated memory (System.totalMemory) fluctuates as garbage collection takes place.
             * Use this property to monitor garbage collection.
             */
            get: function () {
                console.log("freeMemory not implemented yet in flash/System");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(System, "ime", {
            /**
             * The currently installed system IME.
             * To register for imeComposition events, call
             * addEventListener() on this instance.
             */
            get: function () {
                console.log("ime not implemented yet in flash/System");
                return null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(System, "privateMemory", {
            /**
             * The entire amount of memory (in bytes) used by an application. This is the amount of resident private memory for the entire process.
             *
             *   AIR developers should use this property to determine the entire memory consumption of an application.For Flash Player, this includes the memory used by the container application,
             * such as the web browser.
             */
            get: function () {
                console.log("privateMemory not implemented yet in flash/System");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(System, "processCPUUsage", {
            get: function () {
                console.log("processCPUUsage not implemented yet in flash/System");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(System, "totalMemory", {
            /**
             * The amount of memory (in bytes) currently in use that has been directly allocated by
             * Flash Player or AIR.
             *
             *   This property does not return all memory used by an Adobe AIR application or by
             * the application (such as a browser) containing Flash Player content. The browser or
             * operating system may consume other memory. The System.privateMemory property reflects all memory used by
             * an application.If the amount of memory allocated is greater than the maximum value for a uint object (uint.MAX_VALUE,
             * or 4,294,967,295), then this property is set to 0. The System.totalMemoryNumber property allows
             * larger values.
             */
            get: function () {
                console.log("totalMemory not implemented yet in flash/System");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(System, "totalMemoryNumber", {
            /**
             * The amount of memory (in bytes) currently in use that has been directly allocated by
             * Flash Player or AIR.
             *
             *   This property is expressed as a Number, which allows higher values than the
             * System.totalMemory property, which is of type int.This property does not return all memory used by an Adobe AIR application or by
             * the application (such as a browser) containing Flash Player content. The browser or
             * operating system may consume other memory. The System.privateMemory property reflects all memory used by
             * an application.
             */
            get: function () {
                console.log("totalMemoryNumber not implemented yet in flash/System");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(System, "useCodePage", {
            /**
             * A Boolean value that determines which code page to use to interpret external text files.
             * When the property is set to false, external text files are interpretted as Unicode.
             * (These files must be encoded as Unicode when you save them.) When the property is set to
             * true, external text files are interpretted using the traditional code page of the
             * operating system running the application. The default value of useCodePage is false.
             *
             *   Text that you load as an external file (using Loader.load(), the URLLoader class or
             * URLStream) must have been saved as Unicode in order for the application to recognize it
             * as Unicode. To encode external files as Unicode, save the files in an application that
             * supports Unicode, such as Notepad on Windows.If you load external text files that are not Unicode-encoded, set useCodePage to true.
             * Add the following as the first line of code of the file that
             * is loading the data (for Flash Professional, add it to the first frame):System.useCodePage = true;When this code is present, the application interprets external text
             * using the traditional code page of the operating system.
             * For example, this is generally CP1252 for an English Windows operating
             * system and Shift-JIS for a Japanese operating system.If you set useCodePage to true,
             * Flash Player 6 and later treat text as Flash Player 5 does. (Flash Player 5
             * treated all text as if it were in the traditional code page of the operating
             * system running the player.)If you set useCodePage to true, remember that the
             * traditional code page of the operating system running the application must include
             * the characters used in your external text file in order to display your text.
             * For example, if you load an external text file that contains Chinese characters,
             * those characters cannot display on a system that uses the CP1252 code page because
             * that code page does not include Chinese characters.To ensure that users on all platforms can view external text files used in your
             * application, you should encode all external text files as Unicode and leave
             * useCodePage set to false. This way, the application
             * (Flash Player 6 and later, or AIR) interprets the text as Unicode.
             */
            get: function () {
                console.log("useCodePage not implemented yet in flash/System");
                return false;
            },
            set: function (value) {
                console.log("useCodePage not implemented yet in flash/System");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(System, "vmVersion", {
            get: function () {
                console.log("vmVersion not implemented yet in flash/System");
                return "";
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Makes the specified XML object immediately available for garbage collection.
         * This method will remove parent and child connections between all the nodes
         * for the specified XML node.
         * @param	node	XML reference that should be made available for garbage collection.
         */
        System.disposeXML = function (node /*XML*/) {
            console.log("disposeXML not implemented yet in flash/System");
        };
        /**
         * Closes Flash Player.
         *
         *   For the standalone Flash Player debugger version only.AIR applications should call the NativeApplication.exit() method to exit the application.
         * @param	code	A value to pass to the operating system. Typically, if
         *   the process exits normally, the value is 0.
         */
        System.exit = function (code) {
            console.log("exit not implemented yet in flash/System");
        };
        /**
         * Forces the garbage collection process.
         *
         *   For the Flash Player debugger version and AIR applications only.
         * In an AIR application, the System.gc() method is only enabled in content running in the AIR Debug Launcher
         * (ADL) or, in an installed applcation, in content in the application security sandbox.
         */
        System.gc = function () {
            console.log("gc not implemented yet in flash/System");
        };
        /**
         * Pauses Flash Player or the AIR Debug Launcher (ADL).
         * After calling this method, nothing in the application continues except the delivery of Socket events.
         *
         *   For the Flash Player debugger version or the AIR Debug Launcher (ADL) only.
         */
        System.pause = function () {
            console.log("pause not implemented yet in flash/System");
        };
        System.pauseForGCIfCollectionImminent = function (imminence) {
            if (imminence === void 0) { imminence = 0.75; }
            console.log("pauseForGCIfCollectionImminent not implemented yet in flash/System");
        };
        /**
         * Resumes the application after calling System.pause().
         *
         *   For the Flash Player debugger version or the AIR Debug Launcher (ADL) only.
         */
        System.resume = function () {
            console.log("resume not implemented yet in flash/System");
        };
        /**
         * Replaces the contents of the Clipboard with a specified text string. This method works from any security
         * context when called as a result of a user event (such as a keyboard or input device event handler).
         *
         *   This method is provided for SWF content running in Flash Player 9. It allows only adding
         * String content to the Clipboard.Flash Player 10 content and content in the application security sandbox in an AIR application can call
         * the Clipboard.setData() method.
         * @param	string	A plain-text string of characters to put on the system Clipboard, replacing its current contents (if any).
         */
        System.setClipboard = function (string) {
            console.log("setClipboard not implemented yet in flash/System");
        };
        return System;
    }(ASObject$1));

    var TextFormat$2 = /** @class */ (function (_super) {
        __extends(TextFormat$$1, _super);
        function TextFormat$$1(font, size, color, bold, italic, underline, url, link_target, align, leftMargin, rightMargin, indent, leading) {
            if (font === void 0) { font = null; }
            if (size === void 0) { size = null; }
            if (color === void 0) { color = null; }
            if (bold === void 0) { bold = null; }
            if (italic === void 0) { italic = null; }
            if (underline === void 0) { underline = null; }
            if (url === void 0) { url = null; }
            if (link_target === void 0) { link_target = null; }
            if (align === void 0) { align = null; }
            if (leftMargin === void 0) { leftMargin = null; }
            if (rightMargin === void 0) { rightMargin = null; }
            if (indent === void 0) { indent = null; }
            if (leading === void 0) { leading = null; }
            var _this = _super.call(this) || this;
            _this.adaptee = new TextFormat(font, size, color, bold, italic, underline, url, link_target, align, leftMargin, rightMargin, indent, leading);
            return _this;
        }
        Object.defineProperty(TextFormat$$1.prototype, "target", {
            get: function () {
                console.log("not implemented: TextFormat target");
                return null;
            },
            set: function (value) {
                console.log("not implemented: TextFormat target");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "tabStops", {
            get: function () {
                console.log("not implemented: TextFormat tabStops");
                return null;
            },
            set: function (value) {
                console.log("not implemented: TextFormat tabStops");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "display", {
            get: function () {
                console.log("not implemented: TextFormat display");
                return null;
            },
            set: function (value) {
                console.log("not implemented: TextFormat display");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "bullet", {
            get: function () {
                console.log("not implemented: TextFormat bullet");
                return null;
            },
            set: function (value) {
                console.log("not implemented: TextFormat bullet");
                //this._bullet = TextFormat.coerceBoolean(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "url", {
            get: function () {
                console.log("not implemented: TextFormat url");
                return null;
            },
            set: function (value) {
                console.log("not implemented: TextFormat url");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "align", {
            get: function () {
                return this.adaptee.align;
            },
            set: function (value) {
                this.adaptee.align = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "blockIndent", {
            get: function () {
                return this.adaptee.blockIndent;
            },
            set: function (value) {
                this.adaptee.blockIndent = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "leftMargin", {
            get: function () {
                return this.adaptee.leftMargin;
            },
            set: function (value) {
                this.adaptee.leftMargin = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "rightMargin", {
            get: function () {
                return this.adaptee.rightMargin;
            },
            set: function (value) {
                this.adaptee.rightMargin = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "indent", {
            get: function () {
                return this.adaptee.indent;
            },
            set: function (value) {
                this.adaptee.indent = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "color", {
            get: function () {
                return this.adaptee.color;
            },
            set: function (value) {
                this.adaptee.color = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "kerning", {
            get: function () {
                return this.adaptee.kerning;
            },
            set: function (value) {
                this.adaptee.kerning = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "leading", {
            get: function () {
                return this.adaptee.leading;
            },
            set: function (value) {
                this.adaptee.leading = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "letterSpacing", {
            get: function () {
                return this.adaptee.letterSpacing;
            },
            set: function (value) {
                this.adaptee.letterSpacing = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "size", {
            get: function () {
                return this.adaptee.size;
            },
            set: function (value) {
                this.adaptee.size = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "bold", {
            get: function () {
                return this.adaptee.bold;
            },
            set: function (value) {
                this.adaptee.bold = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "italic", {
            get: function () {
                return this.adaptee.italic;
            },
            set: function (value) {
                this.adaptee.italic = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "underline", {
            get: function () {
                return this.adaptee.underline;
            },
            set: function (value) {
                this.adaptee.underline = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "font_name", {
            get: function () {
                console.log("not implemented: TextFormat font_name");
                return null;
            },
            set: function (value) {
                console.log("not implemented: TextFormat font_name");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "style_name", {
            get: function () {
                console.log("not implemented: TextFormat style_name");
                return null;
            },
            set: function (value) {
                console.log("not implemented: TextFormat style_name");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TextFormat$$1.prototype, "font", {
            get: function () {
                console.log("not implemented: TextFormat Font getter");
                return null; //this.adaptee.font;;
            },
            set: function (value) {
                console.log("not implemented: TextFormat Font setter");
            },
            enumerable: true,
            configurable: true
        });
        TextFormat$$1.prototype.clone = function () {
            console.log("not implemented: textFOrmat.clone");
            return null;
            /*var clonedFormat:TextFormat=new TextFormat();
            this.applyToFormat(clonedFormat);
            return clonedFormat;*/
        };
        return TextFormat$$1;
    }(ASObject$1));

    /**
     * Dispatched when a sound has finished playing.
     * @eventType	flash.events.Event.SOUND_COMPLETE
     * [Event(name="soundComplete", type="flash.events.Event")]
     *
     * The SoundChannel class controls a sound in an application. Every sound
     * is assigned to a sound channel, and the application can have multiple
     * sound channels that are mixed together. The SoundChannel class contains a <codeph class="+ topic/ph pr-d/codeph ">stop()</codeph> method,
     * properties for monitoring the amplitude (volume) of the channel, and a property for assigning a
     * SoundTransform object to the channel.
     */
    var SoundChannel$2 = /** @class */ (function (_super) {
        __extends(SoundChannel, _super);
        function SoundChannel() {
            return _super.call(this) || this;
        }
        // for AVM1:
        SoundChannel.prototype.axCallPublicProperty = function (value1, value2) {
            return null;
        };
        SoundChannel.prototype.axGetPublicProperty = function (value) {
            return null;
        };
        SoundChannel.prototype.axSetPublicProperty = function (value, value2) {
            return null;
        };
        SoundChannel.prototype.axHasPublicProperty = function (value) {
            return null;
        };
        SoundChannel.prototype.axDeletePublicProperty = function (value) {
            return null;
        };
        SoundChannel.prototype.axGetEnumerableKeys = function () {
            return [];
        };
        Object.defineProperty(SoundChannel.prototype, "leftPeak", {
            /**
             * The current amplitude (volume) of the left channel, from 0 (silent) to 1 (full amplitude).
             */
            get: function () {
                console.log("leftPeak not implemented yet in flash/SoundChannel");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundChannel.prototype, "position", {
            /**
             * When the sound is playing, the position property indicates in milliseconds the current point
             * that is being played in the sound file. When the sound is stopped or paused, the
             * position property indicates the last point that was played in the sound file.
             *
             *   A common use case is to save the value of the position property when the
             * sound is stopped. You can resume the sound later by restarting it from that saved position.
             * If the sound is looped, position is reset to 0 at the beginning of each loop.
             */
            get: function () {
                console.log("position not implemented yet in flash/SoundChannel");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundChannel.prototype, "rightPeak", {
            /**
             * The current amplitude (volume) of the right channel, from 0 (silent) to 1 (full amplitude).
             */
            get: function () {
                console.log("rightPeak not implemented yet in flash/SoundChannel");
                return 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundChannel.prototype, "soundTransform", {
            /**
             * The SoundTransform object assigned to the sound channel. A SoundTransform object
             * includes properties for setting volume, panning, left speaker assignment, and right
             * speaker assignment.
             */
            get: function () {
                return this._sndtranform;
            },
            set: function (value) {
                if (this._sound) {
                    this._sound.adaptee.volume = value.volume;
                    this._sound.adaptee.pan = value.pan;
                }
                this._sndtranform = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * Stops the sound playing in the channel.
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @refpath
         */
        SoundChannel.prototype.stop = function () {
            if (!this._sound) {
                console.log("SoundChannel.stop: No sound exists");
                return;
            }
            this._sound.stop();
        };
        return SoundChannel;
    }(EventDispatcher$1));

    /**
     * The SoundTransform class contains properties for volume and panning.
     *
     */
    var SoundTransform$2 = /** @class */ (function (_super) {
        __extends(SoundTransform, _super);
        /**
         * Creates a SoundTransform object.
         * @param	vol	The volume, ranging from 0 (silent) to 1 (full volume).
         * @param	panning	The left-to-right panning of the sound, ranging from -1 (full pan left)
         *   to 1 (full pan right). A value of 0 represents no panning (center).
         * @langversion	3.0
         * @playerversion	Flash 9
         * @playerversion	Lite 4
         * @refpath
         */
        function SoundTransform(vol, panning) {
            if (vol === void 0) { vol = 1; }
            if (panning === void 0) { panning = 0; }
            var _this = _super.call(this) || this;
            _this._vol = 1;
            _this._pan = 0.5;
            return _this;
        }
        // for AVM1:
        SoundTransform.prototype.axCallPublicProperty = function (value1, value2) {
            return null;
        };
        SoundTransform.prototype.axGetPublicProperty = function (value) {
            return null;
        };
        SoundTransform.prototype.axSetPublicProperty = function (value, value2) {
            return null;
        };
        SoundTransform.prototype.axHasPublicProperty = function (value) {
            return null;
        };
        SoundTransform.prototype.axDeletePublicProperty = function (value) {
            return null;
        };
        SoundTransform.prototype.axGetEnumerableKeys = function () {
            return [];
        };
        Object.defineProperty(SoundTransform.prototype, "leftToLeft", {
            /**
             * A value, from 0 (none) to 1 (all), specifying how much of the left input is played in the
             * left speaker.
             */
            get: function () {
                console.log("leftToLeft not implemented yet in flash/SoundTransform");
                return 0;
            },
            set: function (leftToLeft) {
                console.log("leftToLeft not implemented yet in flash/SoundTransform");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundTransform.prototype, "leftToRight", {
            /**
             * A value, from 0 (none) to 1 (all), specifying how much of the left input is played in the
             * right speaker.
             */
            get: function () {
                console.log("leftToRight not implemented yet in flash/SoundTransform");
                return 0;
            },
            set: function (leftToRight) {
                console.log("leftToRight not implemented yet in flash/SoundTransform");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundTransform.prototype, "pan", {
            /**
             * The left-to-right panning of the sound, ranging from -1 (full pan left)
             * to 1 (full pan right). A value of 0 represents no panning (balanced center between
             * right and left).
             */
            get: function () {
                return this._pan;
            },
            set: function (value) {
                this._pan = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundTransform.prototype, "rightToLeft", {
            /**
             * A value, from 0 (none) to 1 (all), specifying how much of the right input is played in the
             * left speaker.
             */
            get: function () {
                console.log("rightToLeft not implemented yet in flash/SoundTransform");
                return 0;
            },
            set: function (rightToLeft) {
                console.log("rightToLeft not implemented yet in flash/SoundTransform");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundTransform.prototype, "rightToRight", {
            /**
             * A value, from 0 (none) to 1 (all), specifying how much of the right input is played in the
             * right speaker.
             */
            get: function () {
                console.log("rightToRight not implemented yet in flash/SoundTransform");
                return 0;
            },
            set: function (rightToRight) {
                console.log("rightToRight not implemented yet in flash/SoundTransform");
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundTransform.prototype, "volume", {
            /**
             * The volume, ranging from 0 (silent) to 1 (full volume).
             */
            get: function () {
                return this._vol;
            },
            set: function (value) {
                this._vol = value;
            },
            enumerable: true,
            configurable: true
        });
        return SoundTransform;
    }(ASObject$1));

    var SecurityDomain$1 = /** @class */ (function (_super) {
        __extends(SecurityDomain, _super);
        function SecurityDomain() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return SecurityDomain;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: TextEvent
    var TextEvent$1 = /** @class */ (function (_super) {
        __extends(TextEvent, _super);
        function TextEvent(type, bubbles, cancelable, text) {
            var _this = _super.call(this, type, bubbles, cancelable) || this;
            _this._text = text;
            return _this;
        }
        Object.defineProperty(TextEvent.prototype, "text", {
            get: function () {
                return this._text;
            },
            set: function (value) {
                this._text = value;
            },
            enumerable: true,
            configurable: true
        });
        TextEvent.prototype.clone = function () {
            var textEvent = new TextEvent(this.type, this.bubbles, this.cancelable, this.text);
            //this.copyNativeData(textEvent);
            return textEvent;
        };
        TextEvent.prototype.toString = function () {
            return this.formatToString('TextEvent', 'type', 'bubbles', 'cancelable', 'text');
        };
        TextEvent.prototype.copyNativeData = function (event) {
            release$1 || notImplemented("public flash.events.TextEvent::copyNativeData");
        };
        TextEvent.classInitializer = null;
        TextEvent.classSymbols = null;
        TextEvent.instanceSymbols = null;
        TextEvent.LINK = "link";
        TextEvent.TEXT_INPUT = "textInput";
        return TextEvent;
    }(Event$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: ErrorEvent
    var ErrorEvent$1 = /** @class */ (function (_super) {
        __extends(ErrorEvent, _super);
        function ErrorEvent(type, bubbles, cancelable, text, id) {
            if (bubbles === void 0) { bubbles = false; }
            if (cancelable === void 0) { cancelable = false; }
            if (text === void 0) { text = ""; }
            if (id === void 0) { id = 0; }
            var _this = _super.call(this, type, bubbles, cancelable, text) || this;
            _this.setID(id);
            return _this;
        }
        ErrorEvent.prototype.setID = function (id) {
            this._id = id;
        };
        Object.defineProperty(ErrorEvent.prototype, "errorID", {
            get: function () {
                return this._id;
            },
            enumerable: true,
            configurable: true
        });
        ErrorEvent.prototype.clone = function () {
            return new ErrorEvent(this.type, this.bubbles, this.cancelable, this.text, this.errorID);
        };
        ErrorEvent.prototype.toString = function () {
            return this.formatToString('ErrorEvent', 'type', 'bubbles', 'cancelable', 'text', 'errorID');
        };
        ErrorEvent.classInitializer = null;
        ErrorEvent.classSymbols = null;
        ErrorEvent.instanceSymbols = null;
        // JS -> AS Bindings
        ErrorEvent.ERROR = "error";
        return ErrorEvent;
    }(TextEvent$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: IOErrorEvent
    var IOErrorEvent$1 = /** @class */ (function (_super) {
        __extends(IOErrorEvent, _super);
        function IOErrorEvent(type, bubbles, cancelable, text, id) {
            if (bubbles === void 0) { bubbles = false; }
            if (cancelable === void 0) { cancelable = false; }
            if (text === void 0) { text = ""; }
            if (id === void 0) { id = 0; }
            return _super.call(this, type, bubbles, cancelable, text, id) || this;
        }
        IOErrorEvent.prototype.clone = function () {
            var event = new IOErrorEvent(this.type, this.bubbles, this.cancelable, this.text, this.errorID);
            //this.copyNativeData(event);
            return event;
        };
        IOErrorEvent.prototype.toString = function () {
            return this.formatToString('IOErrorEvent', 'type', 'bubbles', 'cancelable', 'text', 'errorID');
        };
        IOErrorEvent.classInitializer = null;
        IOErrorEvent.classSymbols = null;
        IOErrorEvent.instanceSymbols = null;
        // JS -> AS Bindings
        IOErrorEvent.IO_ERROR = "ioError";
        IOErrorEvent.NETWORK_ERROR = "networkError";
        IOErrorEvent.DISK_ERROR = "diskError";
        IOErrorEvent.VERIFY_ERROR = "verifyError";
        return IOErrorEvent;
    }(ErrorEvent$1));

    function fscommand$1(sec, command, args) {
        command = axCoerceString$3(command);
        args = axCoerceString$3(args);
        console.log('FSCommand: ' + command + '; ' + args);
        command = command.toLowerCase();
        if (command === 'debugger') {
            /* tslint:disable */
            debugger;
            /* tslint:enable */
            return;
        }
        sec.player.executeFSCommand(command, args);
    }

    var FileLoadingService;

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: Security
    var Security$1 = /** @class */ (function (_super) {
        __extends(Security, _super);
        function Security() {
            return _super.call(this) || this;
        }
        Object.defineProperty(Security, "exactSettings", {
            // static _pageDomain: string;
            get: function () {
                return Security._exactSettings;
            },
            set: function (value) {
                value = !!value;
                Security._exactSettings = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Security, "disableAVM1Loading", {
            get: function () {
                release$1 || notImplemented("public flash.system.Security::get disableAVM1Loading");
                return;
                // return Security._disableAVM1Loading;
            },
            set: function (value) {
                value = !!value;
                release$1 || notImplemented("public flash.system.Security::set disableAVM1Loading");
                return;
                // Security._disableAVM1Loading = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Security, "sandboxType", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Security::get sandboxType");
                return Security._sandboxType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Security, "pageDomain", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Security::get pageDomain");
                // TODO: convert this to proper URI parsing.
                var pageHost = FileLoadingService.resolveUrl('/');
                var parts = pageHost.split('/');
                parts.pop();
                return parts.pop();
            },
            enumerable: true,
            configurable: true
        });
        Security.allowDomain = function () {
            release$1 || somewhatImplemented('public flash.system.Security::static allowDomain ["' +
                Array.prototype.join.call(arguments, '", "') + '"]');
            /*var whitelist: ICrossDomainSWFLoadingWhitelist = this.sec.player;
            for (var i = 0; i < arguments.length; i++) {
              whitelist.addToSWFLoadingWhitelist(axCoerceString(arguments[i]) || '', false, false);
            }*/
        };
        Security.allowInsecureDomain = function () {
            release$1 || somewhatImplemented("public flash.system.Security::static allowInsecureDomain");
            /*var whitelist: ICrossDomainSWFLoadingWhitelist = this.sec.player;
            for (var i = 0; i < arguments.length; i++) {
              whitelist.addToSWFLoadingWhitelist(axCoerceString(arguments[i]) || '', true, false);
            }*/
        };
        Security.loadPolicyFile = function (url) {
            url = axCoerceString$3(url);
            release$1 || somewhatImplemented("public flash.system.Security::static loadPolicyFile");
        };
        Security.showSettings = function (panel) {
            if (panel === void 0) { panel = "default"; }
            panel = axCoerceString$3(panel);
            release$1 || notImplemented("public flash.system.Security::static showSettings");
            return;
        };
        Security.duplicateSandboxBridgeInputArguments = function (toplevel, args) {
            toplevel = toplevel;
            args = args;
            release$1 || notImplemented("public flash.system.Security::static duplicateSandboxBridgeInputArguments");
            return;
        };
        Security.duplicateSandboxBridgeOutputArgument = function (toplevel, arg) {
            toplevel = toplevel;
            release$1 || notImplemented("public flash.system.Security::static duplicateSandboxBridgeOutputArgument");
            return;
        };
        // Called whenever the class is initialized.
        Security.classInitializer = null;
        // List of static symbols to link.
        Security.classSymbols = null; // [];
        // List of instance symbols to link.
        Security.instanceSymbols = null; // [];
        // JS -> AS Bindings
        Security.REMOTE = "remote";
        Security.LOCAL_WITH_FILE = "localWithFile";
        Security.LOCAL_WITH_NETWORK = "localWithNetwork";
        Security.LOCAL_TRUSTED = "localTrusted";
        Security.APPLICATION = "application";
        // AS -> JS Bindings
        Security._exactSettings = false;
        // static _disableAVM1Loading: boolean;
        Security._sandboxType = 'remote';
        return Security;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: Scene
    var Scene$1 = /** @class */ (function (_super) {
        __extends(Scene, _super);
        function Scene(name, labels, offset, numFrames /*int*/) {
            var _this = _super.call(this) || this;
            _this._name = axCoerceString$3(name);
            // Note: creating Scene objects in ActionScript, while possible, is undocumented and entirely
            // useless. Luckily, that also means that they're not very carefully implemented.
            // Specifically, the `labels` array isn't cloned during construction or when returned from
            // the getter. I.e., it can be modified freely.
            _this._labels = labels;
            _this.offset = offset;
            _this._numFrames = numFrames | 0;
            return _this;
        }
        Object.defineProperty(Scene.prototype, "name", {
            get: function () {
                return this._name;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "labels", {
            get: function () {
                return this._labels;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Scene.prototype, "numFrames", {
            get: function () {
                return this._numFrames;
            },
            enumerable: true,
            configurable: true
        });
        Scene.prototype.clone = function () {
            var labels_ = this._labels.value.map(function (label) { return label.clone(); });
            return new Scene(this._name, this.sec.createArrayUnsafe(labels_), this.offset, this._numFrames);
        };
        Scene.prototype.getLabelByName = function (name, ignoreCase) {
            if (ignoreCase) {
                name = name.toLowerCase();
            }
            var labels = this._labels.value;
            for (var i = 0; i < labels.length; i++) {
                var label = labels[i];
                if (ignoreCase ? label.name.toLowerCase() === name : label.name === name) {
                    return label;
                }
            }
            return null;
        };
        Scene.prototype.getLabelByFrame = function (frame) {
            var labels = this._labels.value;
            for (var i = 0; i < labels.length; i++) {
                var label = labels[i];
                if (label.frame === frame) {
                    return label;
                }
            }
            return null;
        };
        Scene.classInitializer = null;
        Scene.classSymbols = null; // [];
        Scene.instanceSymbols = null;
        return Scene;
    }(ASObject$1));

    var Keyboard$1 = /** @class */ (function (_super) {
        __extends(Keyboard, _super);
        function Keyboard() {
            return _super.call(this) || this;
        }
        Object.defineProperty(Keyboard, "capsLock", {
            // JS -> AS Bindings
            //static KEYNAME_UPARROW: string = "Up";
            //static KEYNAME_DOWNARROW: string = "Down";
            //static KEYNAME_LEFTARROW: string = "Left";
            //static KEYNAME_RIGHTARROW: string = "Right";
            //static KEYNAME_F1: string = "F1";
            //static KEYNAME_F2: string = "F2";
            //static KEYNAME_F3: string = "F3";
            //static KEYNAME_F4: string = "F4";
            //static KEYNAME_F5: string = "F5";
            //static KEYNAME_F6: string = "F6";
            //static KEYNAME_F7: string = "F7";
            //static KEYNAME_F8: string = "F8";
            //static KEYNAME_F9: string = "F9";
            //static KEYNAME_F10: string = "F10";
            //static KEYNAME_F11: string = "F11";
            //static KEYNAME_F12: string = "F12";
            //static KEYNAME_F13: string = "F13";
            //static KEYNAME_F14: string = "F14";
            //static KEYNAME_F15: string = "F15";
            //static KEYNAME_F16: string = "F16";
            //static KEYNAME_F17: string = "F17";
            //static KEYNAME_F18: string = "F18";
            //static KEYNAME_F19: string = "F19";
            //static KEYNAME_F20: string = "F20";
            //static KEYNAME_F21: string = "F21";
            //static KEYNAME_F22: string = "F22";
            //static KEYNAME_F23: string = "F23";
            //static KEYNAME_F24: string = "F24";
            //static KEYNAME_F25: string = "F25";
            //static KEYNAME_F26: string = "F26";
            //static KEYNAME_F27: string = "F27";
            //static KEYNAME_F28: string = "F28";
            //static KEYNAME_F29: string = "F29";
            //static KEYNAME_F30: string = "F30";
            //static KEYNAME_F31: string = "F31";
            //static KEYNAME_F32: string = "F32";
            //static KEYNAME_F33: string = "F33";
            //static KEYNAME_F34: string = "F34";
            //static KEYNAME_F35: string = "F35";
            //static KEYNAME_INSERT: string = "Insert";
            //static KEYNAME_DELETE: string = "Delete";
            //static KEYNAME_HOME: string = "Home";
            //static KEYNAME_BEGIN: string = "Begin";
            //static KEYNAME_END: string = "End";
            //static KEYNAME_PAGEUP: string = "PgUp";
            //static KEYNAME_PAGEDOWN: string = "PgDn";
            //static KEYNAME_PRINTSCREEN: string = "PrntScrn";
            //static KEYNAME_SCROLLLOCK: string = "ScrlLck";
            //static KEYNAME_PAUSE: string = "Pause";
            //static KEYNAME_SYSREQ: string = "SysReq";
            //static KEYNAME_BREAK: string = "Break";
            //static KEYNAME_RESET: string = "Reset";
            //static KEYNAME_STOP: string = "Stop";
            //static KEYNAME_MENU: string = "Menu";
            //static KEYNAME_USER: string = "User";
            //static KEYNAME_SYSTEM: string = "Sys";
            //static KEYNAME_PRINT: string = "Print";
            //static KEYNAME_CLEARLINE: string = "ClrLn";
            //static KEYNAME_CLEARDISPLAY: string = "ClrDsp";
            //static KEYNAME_INSERTLINE: string = "InsLn";
            //static KEYNAME_DELETELINE: string = "DelLn";
            //static KEYNAME_INSERTCHAR: string = "InsChr";
            //static KEYNAME_DELETECHAR: string = "DelChr";
            //static KEYNAME_PREV: string = "Prev";
            //static KEYNAME_NEXT: string = "Next";
            //static KEYNAME_SELECT: string = "Select";
            //static KEYNAME_EXECUTE: string = "Exec";
            //static KEYNAME_UNDO: string = "Undo";
            //static KEYNAME_REDO: string = "Redo";
            //static KEYNAME_FIND: string = "Find";
            //static KEYNAME_HELP: string = "Help";
            //static KEYNAME_MODESWITCH: string = "ModeSw";
            //static STRING_UPARROW: string = "";
            //static STRING_DOWNARROW: string = "";
            //static STRING_LEFTARROW: string = "";
            //static STRING_RIGHTARROW: string = "";
            //static STRING_F1: string = "";
            //static STRING_F2: string = "";
            //static STRING_F3: string = "";
            //static STRING_F4: string = "";
            //static STRING_F5: string = "";
            //static STRING_F6: string = "";
            //static STRING_F7: string = "";
            //static STRING_F8: string = "";
            //static STRING_F9: string = "";
            //static STRING_F10: string = "";
            //static STRING_F11: string = "";
            //static STRING_F12: string = "";
            //static STRING_F13: string = "";
            //static STRING_F14: string = "";
            //static STRING_F15: string = "";
            //static STRING_F16: string = "";
            //static STRING_F17: string = "";
            //static STRING_F18: string = "";
            //static STRING_F19: string = "";
            //static STRING_F20: string = "";
            //static STRING_F21: string = "";
            //static STRING_F22: string = "";
            //static STRING_F23: string = "";
            //static STRING_F24: string = "";
            //static STRING_F25: string = "";
            //static STRING_F26: string = "";
            //static STRING_F27: string = "";
            //static STRING_F28: string = "";
            //static STRING_F29: string = "";
            //static STRING_F30: string = "";
            //static STRING_F31: string = "";
            //static STRING_F32: string = "";
            //static STRING_F33: string = "";
            //static STRING_F34: string = "";
            //static STRING_F35: string = "";
            //static STRING_INSERT: string = "";
            //static STRING_DELETE: string = "";
            //static STRING_HOME: string = "";
            //static STRING_BEGIN: string = "";
            //static STRING_END: string = "";
            //static STRING_PAGEUP: string = "";
            //static STRING_PAGEDOWN: string = "";
            //static STRING_PRINTSCREEN: string = "";
            //static STRING_SCROLLLOCK: string = "";
            //static STRING_PAUSE: string = "";
            //static STRING_SYSREQ: string = "";
            //static STRING_BREAK: string = "";
            //static STRING_RESET: string = "";
            //static STRING_STOP: string = "";
            //static STRING_MENU: string = "";
            //static STRING_USER: string = "";
            //static STRING_SYSTEM: string = "";
            //static STRING_PRINT: string = "";
            //static STRING_CLEARLINE: string = "";
            //static STRING_CLEARDISPLAY: string = "";
            //static STRING_INSERTLINE: string = "";
            //static STRING_DELETELINE: string = "";
            //static STRING_INSERTCHAR: string = "";
            //static STRING_DELETECHAR: string = "";
            //static STRING_PREV: string = "";
            //static STRING_NEXT: string = "";
            //static STRING_SELECT: string = "";
            //static STRING_EXECUTE: string = "";
            //static STRING_UNDO: string = "";
            //static STRING_REDO: string = "";
            //static STRING_FIND: string = "";
            //static STRING_HELP: string = "";
            //static STRING_MODESWITCH: string = "";
            //static CharCodeStrings: any [] = undefined;
            //static NUMBER_0: number /*uint*/ = 48;
            //static NUMBER_1: number /*uint*/ = 49;
            //static NUMBER_2: number /*uint*/ = 50;
            //static NUMBER_3: number /*uint*/ = 51;
            //static NUMBER_4: number /*uint*/ = 52;
            //static NUMBER_5: number /*uint*/ = 53;
            //static NUMBER_6: number /*uint*/ = 54;
            //static NUMBER_7: number /*uint*/ = 55;
            //static NUMBER_8: number /*uint*/ = 56;
            //static NUMBER_9: number /*uint*/ = 57;
            //static A: number /*uint*/ = 65;
            //static B: number /*uint*/ = 66;
            //static C: number /*uint*/ = 67;
            //static D: number /*uint*/ = 68;
            //static E: number /*uint*/ = 69;
            //static F: number /*uint*/ = 70;
            //static G: number /*uint*/ = 71;
            //static H: number /*uint*/ = 72;
            //static I: number /*uint*/ = 73;
            //static J: number /*uint*/ = 74;
            //static K: number /*uint*/ = 75;
            //static L: number /*uint*/ = 76;
            //static M: number /*uint*/ = 77;
            //static N: number /*uint*/ = 78;
            //static O: number /*uint*/ = 79;
            //static P: number /*uint*/ = 80;
            //static Q: number /*uint*/ = 81;
            //static R: number /*uint*/ = 82;
            //static S: number /*uint*/ = 83;
            //static T: number /*uint*/ = 84;
            //static U: number /*uint*/ = 85;
            //static V: number /*uint*/ = 86;
            //static W: number /*uint*/ = 87;
            //static X: number /*uint*/ = 88;
            //static Y: number /*uint*/ = 89;
            //static Z: number /*uint*/ = 90;
            //static SEMICOLON: number /*uint*/ = 186;
            //static EQUAL: number /*uint*/ = 187;
            //static COMMA: number /*uint*/ = 188;
            //static MINUS: number /*uint*/ = 189;
            //static PERIOD: number /*uint*/ = 190;
            //static SLASH: number /*uint*/ = 191;
            //static BACKQUOTE: number /*uint*/ = 192;
            //static LEFTBRACKET: number /*uint*/ = 219;
            //static BACKSLASH: number /*uint*/ = 220;
            //static RIGHTBRACKET: number /*uint*/ = 221;
            //static QUOTE: number /*uint*/ = 222;
            //static ALTERNATE: number /*uint*/ = 18;
            //static BACKSPACE: number /*uint*/ = 8;
            //static CAPS_LOCK: number /*uint*/ = 20;
            //static COMMAND: number /*uint*/ = 15;
            //static CONTROL: number /*uint*/ = 17;
            //static DELETE: number /*uint*/ = 46;
            //static DOWN: number /*uint*/ = 40;
            //static END: number /*uint*/ = 35;
            //static ENTER: number /*uint*/ = 13;
            //static ESCAPE: number /*uint*/ = 27;
            //static F1: number /*uint*/ = 112;
            //static F2: number /*uint*/ = 113;
            //static F3: number /*uint*/ = 114;
            //static F4: number /*uint*/ = 115;
            //static F5: number /*uint*/ = 116;
            //static F6: number /*uint*/ = 117;
            //static F7: number /*uint*/ = 118;
            //static F8: number /*uint*/ = 119;
            //static F9: number /*uint*/ = 120;
            //static F10: number /*uint*/ = 121;
            //static F11: number /*uint*/ = 122;
            //static F12: number /*uint*/ = 123;
            //static F13: number /*uint*/ = 124;
            //static F14: number /*uint*/ = 125;
            //static F15: number /*uint*/ = 126;
            //static HOME: number /*uint*/ = 36;
            //static INSERT: number /*uint*/ = 45;
            //static LEFT: number /*uint*/ = 37;
            //static NUMPAD: number /*uint*/ = 21;
            //static NUMPAD_0: number /*uint*/ = 96;
            //static NUMPAD_1: number /*uint*/ = 97;
            //static NUMPAD_2: number /*uint*/ = 98;
            //static NUMPAD_3: number /*uint*/ = 99;
            //static NUMPAD_4: number /*uint*/ = 100;
            //static NUMPAD_5: number /*uint*/ = 101;
            //static NUMPAD_6: number /*uint*/ = 102;
            //static NUMPAD_7: number /*uint*/ = 103;
            //static NUMPAD_8: number /*uint*/ = 104;
            //static NUMPAD_9: number /*uint*/ = 105;
            //static NUMPAD_ADD: number /*uint*/ = 107;
            //static NUMPAD_DECIMAL: number /*uint*/ = 110;
            //static NUMPAD_DIVIDE: number /*uint*/ = 111;
            //static NUMPAD_ENTER: number /*uint*/ = 108;
            //static NUMPAD_MULTIPLY: number /*uint*/ = 106;
            //static NUMPAD_SUBTRACT: number /*uint*/ = 109;
            //static PAGE_DOWN: number /*uint*/ = 34;
            //static PAGE_UP: number /*uint*/ = 33;
            //static RIGHT: number /*uint*/ = 39;
            //static SHIFT: number /*uint*/ = 16;
            //static SPACE: number /*uint*/ = 32;
            //static TAB: number /*uint*/ = 9;
            //static UP: number /*uint*/ = 38;
            //static RED: number /*uint*/ = 16777216;
            //static GREEN: number /*uint*/ = 16777217;
            //static YELLOW: number /*uint*/ = 16777218;
            //static BLUE: number /*uint*/ = 16777219;
            //static CHANNEL_UP: number /*uint*/ = 16777220;
            //static CHANNEL_DOWN: number /*uint*/ = 16777221;
            //static RECORD: number /*uint*/ = 16777222;
            //static PLAY: number /*uint*/ = 16777223;
            //static PAUSE: number /*uint*/ = 16777224;
            //static STOP: number /*uint*/ = 16777225;
            //static FAST_FORWARD: number /*uint*/ = 16777226;
            //static REWIND: number /*uint*/ = 16777227;
            //static SKIP_FORWARD: number /*uint*/ = 16777228;
            //static SKIP_BACKWARD: number /*uint*/ = 16777229;
            //static NEXT: number /*uint*/ = 16777230;
            //static PREVIOUS: number /*uint*/ = 16777231;
            //static LIVE: number /*uint*/ = 16777232;
            //static LAST: number /*uint*/ = 16777233;
            //static MENU: number /*uint*/ = 16777234;
            //static INFO: number /*uint*/ = 16777235;
            //static GUIDE: number /*uint*/ = 16777236;
            //static EXIT: number /*uint*/ = 16777237;
            //static BACK: number /*uint*/ = 16777238;
            //static AUDIO: number /*uint*/ = 16777239;
            //static SUBTITLE: number /*uint*/ = 16777240;
            //static DVR: number /*uint*/ = 16777241;
            //static VOD: number /*uint*/ = 16777242;
            //static INPUT: number /*uint*/ = 16777243;
            //static SETUP: number /*uint*/ = 16777244;
            //static HELP: number /*uint*/ = 16777245;
            //static MASTER_SHELL: number /*uint*/ = 16777246;
            //static SEARCH: number /*uint*/ = 16777247;
            // AS -> JS Bindings
            // static _capsLock: boolean;
            // static _numLock: boolean;
            // static _hasVirtualKeyboard: boolean;
            // static _physicalKeyboardType: string;
            get: function () {
                release$1 || notImplemented("public flash.ui.Keyboard::get capsLock");
                return;
                // return this._capsLock;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Keyboard, "numLock", {
            get: function () {
                release$1 || notImplemented("public flash.ui.Keyboard::get numLock");
                return;
                // return this._numLock;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Keyboard, "hasVirtualKeyboard", {
            get: function () {
                release$1 || notImplemented("public flash.ui.Keyboard::get hasVirtualKeyboard");
                return;
                // return this._hasVirtualKeyboard;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Keyboard, "physicalKeyboardType", {
            get: function () {
                release$1 || notImplemented("public flash.ui.Keyboard::get physicalKeyboardType");
                return;
                // return this._physicalKeyboardType;
            },
            enumerable: true,
            configurable: true
        });
        Keyboard.isAccessible = function () {
            release$1 || notImplemented("public flash.ui.Keyboard::static isAccessible");
            return;
        };
        // Called whenever the class is initialized.
        Keyboard.classInitializer = null;
        // List of static symbols to link.
        Keyboard.classSymbols = null; // [];
        // List of instance symbols to link.
        Keyboard.instanceSymbols = null; // [];
        return Keyboard;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: Point
    var Point$2 = /** @class */ (function (_super) {
        __extends(Point, _super);
        function Point(x, y) {
            if (x === void 0) { x = 0; }
            if (y === void 0) { y = 0; }
            var _this = _super.call(this) || this;
            _this.x = +x;
            _this.y = +y;
            return _this;
        }
        Object.defineProperty(Point.prototype, "native_x", {
            get: function () {
                return this.x;
            },
            set: function (x) {
                this.x = x;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Point.prototype, "native_y", {
            get: function () {
                return this.y;
            },
            set: function (y) {
                this.y = y;
            },
            enumerable: true,
            configurable: true
        });
        Point.prototype.Point = function (x, y) {
            if (x === void 0) { x = 0; }
            if (y === void 0) { y = 0; }
            this.x = x;
            this.y = y;
        };
        Object.defineProperty(Point.prototype, "length", {
            get: function () {
                return Math.sqrt(this.x * this.x + this.y * this.y);
            },
            enumerable: true,
            configurable: true
        });
        Point.interpolate = function (p1, p2, f) {
            var f1 = 1 - f;
            return new Point(p1.x * f + p2.x * f1, p1.y * f + p2.y * f1);
        };
        Point.distance = function (p1, p2) {
            var dx = p2.x - p1.x;
            var dy = p2.y - p1.y;
            return (dx === 0) ? Math.abs(dy) : (dy === 0) ? Math.abs(dx) : Math.sqrt(dx * dx + dy * dy);
        };
        Point.polar = function (length, angle) {
            length = +length;
            angle = +angle;
            return new Point(length * Math.cos(angle), length * Math.sin(angle));
        };
        Point.prototype.clone = function () {
            return new Point(this.x, this.y);
        };
        Point.prototype.offset = function (dx, dy) {
            this.x += +dx;
            this.y += +dy;
        };
        Point.prototype.equals = function (toCompare) {
            return this.x === toCompare.x && this.y === toCompare.y;
        };
        Point.prototype.subtract = function (v) {
            return new Point(this.x - v.x, this.y - v.y);
        };
        Point.prototype.add = function (v) {
            return new Point(this.x + v.x, this.y + v.y);
        };
        Point.prototype.normalize = function (thickness) {
            if (this.x !== 0 || this.y !== 0) {
                var relativeThickness = +thickness / this.length;
                this.x *= relativeThickness;
                this.y *= relativeThickness;
            }
        };
        Point.prototype.copyFrom = function (sourcePoint) {
            this.x = sourcePoint.x;
            this.y = sourcePoint.y;
        };
        Point.prototype.setTo = function (x, y) {
            this.x = +x;
            this.y = +y;
        };
        Point.prototype.toTwips = function () {
            this.x = (this.x * 20) | 0;
            this.y = (this.y * 20) | 0;
            return this;
        };
        Point.prototype.toPixels = function () {
            this.x /= 20;
            this.y /= 20;
            return this;
        };
        Point.prototype.round = function () {
            this.x = Math.round(this.x);
            this.y = Math.round(this.y);
            return this;
        };
        Point.prototype.toString = function () {
            return "(x=" + this.x + ", y=" + this.y + ")";
        };
        // Called whenever the class is initialized.
        Point.classInitializer = null;
        // List of static symbols to link.
        Point.classSymbols = null; // ["interpolate", "distance", "polar"];
        // List of instance symbols to link.
        Point.instanceSymbols = null; // ["x", "y", "length", "clone", "offset", "equals", "subtract", "add", "normalize", "copyFrom", "setTo", "toString"];
        return Point;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: MouseEvent
    var MouseEvent$2 = /** @class */ (function (_super) {
        __extends(MouseEvent, _super);
        function MouseEvent(type, bubbles, cancelable, localX, localY, relatedObject, ctrlKey, altKey, shiftKey, buttonDown, delta) {
            if (bubbles === void 0) { bubbles = true; }
            if (cancelable === void 0) { cancelable = false; }
            if (localX === void 0) { localX = undefined; }
            if (localY === void 0) { localY = undefined; }
            if (relatedObject === void 0) { relatedObject = null; }
            if (ctrlKey === void 0) { ctrlKey = false; }
            if (altKey === void 0) { altKey = false; }
            if (shiftKey === void 0) { shiftKey = false; }
            if (buttonDown === void 0) { buttonDown = false; }
            if (delta === void 0) { delta = 0; }
            var _this = _super.call(this, type, bubbles, cancelable) || this;
            _this._localX = localX;
            _this._localY = localY;
            _this._relatedObject = relatedObject;
            _this._ctrlKey = ctrlKey;
            _this._altKey = altKey;
            _this._shiftKey = shiftKey;
            _this._buttonDown = buttonDown;
            _this._delta = delta;
            return _this;
        }
        /**
         * AS3 mouse event names don't match DOM even names, so map them here.
         */
        MouseEvent.typeFromDOMType = function (name) {
            switch (name) {
                case "click":
                    return MouseEvent.CLICK;
                case "dblclick":
                    return MouseEvent.DOUBLE_CLICK;
                case "mousedown":
                    return MouseEvent.MOUSE_DOWN;
                case "mouseout":
                case "mouseover":
                case "mousemove":
                    return MouseEvent.MOUSE_MOVE;
                case "mouseup":
                    return MouseEvent.MOUSE_UP;
                default:
                    notImplemented(name);
                // return MouseEvent.RELEASE_OUTSIDE;
                // return MouseEvent.MOUSE_WHEEL;
                // return MouseEvent.ROLL_OUT;
                // return MouseEvent.ROLL_OVER;
                // return MouseEvent.MIDDLE_CLICK;
                // return MouseEvent.MIDDLE_MOUSE_DOWN;
                // return MouseEvent.MIDDLE_MOUSE_UP;
                // return MouseEvent.RIGHT_CLICK;
                // return MouseEvent.RIGHT_MOUSE_DOWN;
                // return MouseEvent.RIGHT_MOUSE_UP;
                // return MouseEvent.CONTEXT_MENU;
            }
        };
        /* added to clone events from away to as3web. */
        MouseEvent.prototype.fillFromAway = function (awayEvent) {
            //console.log("cloneFromAway not implemented yet in flash/MouseEvent");
            // todo: set targets correctly
            this.target = awayEvent.target;
            //this.currentTarget = awayEvent.currentTarget;
            this.delta = awayEvent.delta;
            this.ctrlKey = awayEvent.ctrlKey;
            this.shiftKey = awayEvent.shiftKey;
            //this._stageX = awayEvent.screenX;
            //this._stageY = awayEvent.screenY;
            //todo: translate more stuff from awayjs to as3
            //result.screenX = this.screenX;
            //result.screenY = this.screenY;
            /*
                    result.view = awayEvent.view;
                    result.entity = awayEvent.entity;
                    result.renderable = awayEvent.renderable;
                    result.material = awayEvent.material;
                    result.uv = awayEvent.uv;
                    result.position = awayEvent.position;
                    result.normal = awayEvent.normal;
                    result.elementIndex = awayEvent.elementIndex;
            */
            //result._iParentEvent = awayEvent;
            //result._iAllowedToPropagate = awayEvent._iAllowedToPropagate;
        };
        Object.defineProperty(MouseEvent.prototype, "localX", {
            get: function () {
                return (this._localX / 20) | 0;
            },
            set: function (value) {
                this._localX = (value * 20) | 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "localY", {
            get: function () {
                return (this._localY / 20) | 0;
            },
            set: function (value) {
                this._localY = (value * 20) | 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "stageX", {
            get: function () {
                if (isNaN(this.localX + this.localY)) {
                    return Number.NaN;
                }
                return (this._getGlobalPoint().x / 20) | 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "stageY", {
            get: function () {
                if (isNaN(this.localX + this.localY)) {
                    return Number.NaN;
                }
                return (this._getGlobalPoint().y / 20) | 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "movementX", {
            get: function () {
                return this._movementX || 0;
            },
            set: function (value) {
                this._movementX = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "movementY", {
            get: function () {
                return this._movementY || 0;
            },
            set: function (value) {
                this._movementY = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "delta", {
            get: function () {
                return this._delta;
            },
            set: function (value) {
                this._delta = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "ctrlKey", {
            get: function () {
                return this._ctrlKey;
            },
            set: function (value) {
                this._ctrlKey = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "altKey", {
            get: function () {
                return this._altKey;
            },
            set: function (value) {
                this._altKey = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "shiftKey", {
            get: function () {
                return this._shiftKey;
            },
            set: function (value) {
                this._shiftKey = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "buttonDown", {
            get: function () {
                return this._buttonDown;
            },
            set: function (value) {
                this._buttonDown = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "relatedObject", {
            get: function () {
                return this._relatedObject;
            },
            set: function (value) {
                this._relatedObject = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(MouseEvent.prototype, "isRelatedObjectInaccessible", {
            get: function () {
                return this._isRelatedObjectInaccessible;
            },
            set: function (value) {
                this._isRelatedObjectInaccessible = value;
            },
            enumerable: true,
            configurable: true
        });
        MouseEvent.prototype.updateAfterEvent = function () {
            this.sec.player.requestRendering();
        };
        MouseEvent.prototype._getGlobalPoint = function () {
            var point = this._position;
            if (!point) {
                point = this._position = new Point$2();
            }
            if (this.target) {
                point.setTo(this._localX, this._localY);
                var m = this._target._getConcatenatedMatrix();
                m.transformPointInPlace(point);
            }
            else {
                point.setTo(0, 0);
            }
            return point;
        };
        MouseEvent.prototype.clone = function () {
            return new MouseEvent(this.type, this.bubbles, this.cancelable, this.localX, this.localY, this.relatedObject, this.ctrlKey, this.altKey, this.shiftKey, this.buttonDown, this.delta);
        };
        MouseEvent.prototype.toString = function () {
            return this.formatToString('MouseEvent', 'type', 'bubbles', 'cancelable', 'eventPhase', 'localX', "localY", 'relatedObject', 'ctrlKey', 'altKey', 'shiftKey', 'buttonDown', 'delta');
        };
        MouseEvent.classInitializer = null;
        MouseEvent.classSymbols = null;
        MouseEvent.instanceSymbols = null;
        // JS -> AS Bindings
        MouseEvent.CLICK = "click";
        MouseEvent.DOUBLE_CLICK = "doubleClick";
        MouseEvent.MOUSE_DOWN = "mouseDown";
        MouseEvent.MOUSE_MOVE = "mouseMove";
        MouseEvent.MOUSE_OUT = "mouseOut";
        MouseEvent.MOUSE_OVER = "mouseOver";
        MouseEvent.MOUSE_UP = "mouseUp";
        MouseEvent.RELEASE_OUTSIDE = "releaseOutside";
        MouseEvent.MOUSE_WHEEL = "mouseWheel";
        MouseEvent.ROLL_OUT = "rollOut";
        MouseEvent.ROLL_OVER = "rollOver";
        MouseEvent.MIDDLE_CLICK = "middleClick";
        MouseEvent.MIDDLE_MOUSE_DOWN = "middleMouseDown";
        MouseEvent.MIDDLE_MOUSE_UP = "middleMouseUp";
        MouseEvent.RIGHT_CLICK = "rightClick";
        MouseEvent.RIGHT_MOUSE_DOWN = "rightMouseDown";
        MouseEvent.RIGHT_MOUSE_UP = "rightMouseUp";
        MouseEvent.CONTEXT_MENU = "contextMenu";
        return MouseEvent;
    }(Event$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: BitmapFilter
    var BitmapFilter = /** @class */ (function (_super) {
        __extends(BitmapFilter, _super);
        function BitmapFilter() {
            return _super.call(this) || this;
        }
        BitmapFilter._updateBlurBounds = function (bounds, blurX, blurY, quality /*int*/, isBlurFilter) {
            if (isBlurFilter === void 0) { isBlurFilter = false; }
            // Approximation of BitmapData.generateFilterRect()
            var stepWidth = BitmapFilter.blurFilterStepWidths[quality - 1];
            if (isBlurFilter) {
                // BlurFilter behaves slightly different from other blur based filters:
                // Given ascending blurX/blurY values, generateFilterRect with BlurFilter
                // expands the source rect later than with i.e. GlowFilter. The difference
                // appears to be stepWidth / 4 for all quality values.
                var stepWidth4 = stepWidth / 4;
                blurX -= stepWidth4;
                blurY -= stepWidth4;
            }
            // Calculate horizontal and vertical borders:
            // blurX/blurY values <= 1 are always rounded up to 1,
            // which means that generateFilterRect always expands the source rect,
            // even when blurX/blurY is 0.
            var bh = Math.ceil((blurX < 1 ? 1 : blurX) * stepWidth);
            var bv = Math.ceil((blurY < 1 ? 1 : blurY) * stepWidth);
            bounds.inflate(bh, bv);
        };
        BitmapFilter.prototype._updateFilterBounds = function (bounds) {
            // ...
        };
        BitmapFilter.prototype._serialize = function (message) {
            // Overridden by subclasses
            // -1: Filter not supported, no further serialization
            // 0-7: Filter IDs according to SWF spec
            message.writeInt(-1);
        };
        // JS -> AS Bindings
        // AS -> JS Bindings
        BitmapFilter.prototype.clone = function () {
            return null;
        };
        // Called whenever the class is initialized.
        BitmapFilter.classInitializer = null;
        BitmapFilter.EPS = 0.000000001;
        // Step widths for blur based filters, for quality values 1..15:
        // If we plot the border width added by generateFilterRect for each
        // blurX (or blurY) value, the step width is the amount of blurX
        // that adds one pixel to the border width. I.e. for quality = 1,
        // the border width increments at blurX = 2, 4, 6, ...
        BitmapFilter.blurFilterStepWidths = [0.5, 1.05, 1.35, 1.55, 1.75, 1.9, 2, 2.1, 2.2, 2.3, 2.5, 3, 3, 3.5, 3.5];
        return BitmapFilter;
    }(ASObject$1));
    var GradientArrays = /** @class */ (function () {
        function GradientArrays() {
        }
        // colors null or empty - all empty
        // ratios empty - all empty
        // ratios null and alphas null - length: colors, alphas set to 0, ratios set to 0
        // ratios null and alphas != null - length: colors, alphas filled with 1, ratios set to 0
        // ratios not empty and alphas null - length: min(colors,ratios), alphas set to 0
        // ratios not empty and alphas != null - length: min(colors,ratios), alphas filled with 1
        GradientArrays.sanitize = function (colors, alphas, ratios) {
            if (isNullOrUndefined$1(colors) || colors.length === 0) {
                this.colors = [];
                this.alphas = [];
                this.ratios = [];
            }
            else {
                var len;
                if (isNullOrUndefined$1(ratios)) {
                    this.colors = this.sanitizeColors(colors);
                    len = this.colors.length;
                    this.ratios = this.initArray(len);
                    if (isNullOrUndefined$1(alphas)) {
                        this.alphas = this.initArray(len);
                    }
                    else {
                        this.alphas = this.sanitizeAlphas(alphas, len, len, 1);
                    }
                }
                else {
                    if (ratios.length === 0) {
                        this.colors = [];
                        this.alphas = [];
                        this.ratios = [];
                    }
                    else {
                        len = Math.min(colors.length, ratios.length, 16);
                        this.colors = this.sanitizeColors(colors, len);
                        this.ratios = this.sanitizeRatios(ratios, len);
                        if (isNullOrUndefined$1(alphas)) {
                            this.alphas = this.initArray(len);
                        }
                        else {
                            this.alphas = this.sanitizeAlphas(alphas, len, len, 1);
                        }
                    }
                }
            }
        };
        GradientArrays.sanitizeColors = function (colors, maxLen) {
            if (maxLen === void 0) { maxLen = 16; }
            var arr = [];
            for (var i = 0, n = Math.min(colors.length, maxLen); i < n; i++) {
                arr[i] = (colors[i] >>> 0) & 0xffffff;
            }
            return arr;
        };
        GradientArrays.sanitizeAlphas = function (alphas, maxLen, minLen, value) {
            if (maxLen === void 0) { maxLen = 16; }
            if (minLen === void 0) { minLen = 0; }
            if (value === void 0) { value = 0; }
            var arr = [];
            for (var i = 0, n = Math.min(alphas.length, maxLen); i < n; i++) {
                arr[i] = NumberUtilities.clamp(+alphas[i], 0, 1);
            }
            while (i < minLen) {
                arr[i++] = value;
            }
            return arr;
        };
        GradientArrays.sanitizeRatios = function (ratios, maxLen, minLen, value) {
            if (maxLen === void 0) { maxLen = 16; }
            if (minLen === void 0) { minLen = 0; }
            if (value === void 0) { value = 0; }
            var arr = [];
            for (var i = 0, n = Math.min(ratios.length, maxLen); i < n; i++) {
                arr[i] = NumberUtilities.clamp(+ratios[i], 0, 255);
            }
            while (i < minLen) {
                arr[i++] = value;
            }
            return arr;
        };
        GradientArrays.initArray = function (len, value) {
            if (value === void 0) { value = 0; }
            var arr = Array(len);
            for (var i = 0; i < len; i++) {
                arr[i] = value;
            }
            return arr;
        };
        return GradientArrays;
    }());

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: BitmapFilterType
    var BitmapFilterType = /** @class */ (function (_super) {
        __extends(BitmapFilterType, _super);
        function BitmapFilterType() {
            return _super.call(this) || this;
        }
        // Called whenever the class is initialized.
        BitmapFilterType.classInitializer = null;
        // List of static symbols to link.
        BitmapFilterType.classSymbols = null; // [];
        // List of instance symbols to link.
        BitmapFilterType.instanceSymbols = null; // [];
        // JS -> AS Bindings
        BitmapFilterType.INNER = "inner";
        BitmapFilterType.OUTER = "outer";
        BitmapFilterType.FULL = "full";
        return BitmapFilterType;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: BevelFilter
    var BevelFilter = /** @class */ (function (_super) {
        __extends(BevelFilter, _super);
        function BevelFilter(distance, angle, highlightColor, highlightAlpha, shadowColor, shadowAlpha, blurX, blurY, strength, quality, type, knockout) {
            if (distance === void 0) { distance = 4; }
            if (angle === void 0) { angle = 45; }
            if (highlightColor === void 0) { highlightColor = 16777215; }
            if (highlightAlpha === void 0) { highlightAlpha = 1; }
            if (shadowColor === void 0) { shadowColor = 0; }
            if (shadowAlpha === void 0) { shadowAlpha = 1; }
            if (blurX === void 0) { blurX = 4; }
            if (blurY === void 0) { blurY = 4; }
            if (strength === void 0) { strength = 1; }
            if (quality === void 0) { quality = 1; }
            if (type === void 0) { type = "inner"; }
            if (knockout === void 0) { knockout = false; }
            var _this = _super.call(this) || this;
            _this.distance = distance;
            _this.angle = angle;
            _this.highlightColor = highlightColor;
            _this.highlightAlpha = highlightAlpha;
            _this.shadowColor = shadowColor;
            _this.shadowAlpha = shadowAlpha;
            _this.blurX = blurX;
            _this.blurY = blurY;
            _this.strength = strength;
            _this.quality = quality;
            _this.type = type;
            _this.knockout = knockout;
            return _this;
        }
        BevelFilter.FromUntyped = function (obj) {
            // obj.colors is an array of RGBA colors.
            // Here it contains exactly two color objects (spec might state it differently):
            //  - first maps to highlightColor and highlightAlpha;
            //  - second maps to shadowColor and shadowAlpha;
            release$1 || assert$2(obj.colors && obj.colors.length === 2, "colors must be Array of length 2");
            var highlightColor = obj.colors[0] >>> 8;
            var highlightAlpha = (obj.colors[0] & 0xff) / 0xff;
            var shadowColor = obj.colors[1] >>> 8;
            var shadowAlpha = (obj.colors[1] & 0xff) / 0xff;
            // type is derived from obj.onTop and obj.innerShadow
            // obj.onTop true: type is FULL
            // obj.inner true: type is INNER
            // neither true: type is OUTER
            var type = BitmapFilterType.OUTER;
            if (!!obj.onTop) {
                type = BitmapFilterType.FULL;
            }
            else if (!!obj.inner) {
                type = BitmapFilterType.INNER;
            }
            // obj.angle is represented in radians, the api needs degrees
            var angle = obj.angle * 180 / Math.PI;
            return new BevelFilter(obj.distance, angle, highlightColor, highlightAlpha, shadowColor, shadowAlpha, obj.blurX, obj.blurY, obj.strength, obj.quality, type, obj.knockout);
        };
        BevelFilter.prototype._updateFilterBounds = function (bounds) {
            if (this.type !== BitmapFilterType.INNER) {
                BitmapFilter._updateBlurBounds(bounds, this._blurX, this._blurY, this._quality);
                if (this._distance !== 0) {
                    var a = this._angle * Math.PI / 180;
                    bounds.x += Math.floor(Math.cos(a) * this._distance);
                    bounds.y += Math.floor(Math.sin(a) * this._distance);
                    if (bounds.left > 0) {
                        bounds.left = 0;
                    }
                    if (bounds.top > 0) {
                        bounds.top = 0;
                    }
                }
            }
        };
        Object.defineProperty(BevelFilter.prototype, "distance", {
            get: function () {
                return this._distance;
            },
            set: function (value) {
                this._distance = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BevelFilter.prototype, "angle", {
            get: function () {
                return this._angle;
            },
            set: function (value) {
                this._angle = +value % 360;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BevelFilter.prototype, "highlightColor", {
            get: function () {
                return this._highlightColor;
            },
            set: function (value /*uint*/) {
                this._highlightColor = (value >>> 0) & 0xffffff;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BevelFilter.prototype, "highlightAlpha", {
            get: function () {
                return this._highlightAlpha;
            },
            set: function (value) {
                this._highlightAlpha = NumberUtilities.clamp(+value, 0, 1);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BevelFilter.prototype, "shadowColor", {
            get: function () {
                return this._shadowColor;
            },
            set: function (value /*uint*/) {
                this._shadowColor = (value >>> 0) & 0xffffff;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BevelFilter.prototype, "shadowAlpha", {
            get: function () {
                return this._shadowAlpha;
            },
            set: function (value) {
                this._shadowAlpha = NumberUtilities.clamp(+value, 0, 1);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BevelFilter.prototype, "blurX", {
            get: function () {
                return this._blurX;
            },
            set: function (value) {
                this._blurX = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BevelFilter.prototype, "blurY", {
            get: function () {
                return this._blurY;
            },
            set: function (value) {
                this._blurY = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BevelFilter.prototype, "knockout", {
            get: function () {
                return this._knockout;
            },
            set: function (value) {
                this._knockout = !!value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BevelFilter.prototype, "quality", {
            get: function () {
                return this._quality;
            },
            set: function (value /*int*/) {
                this._quality = NumberUtilities.clamp(value | 0, 0, 15);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BevelFilter.prototype, "strength", {
            get: function () {
                return this._strength;
            },
            set: function (value) {
                this._strength = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BevelFilter.prototype, "type", {
            get: function () {
                return this._type;
            },
            set: function (value) {
                value = axCoerceString$3(value);
                if (value === null) {
                    this.sec.throwError("TypeError", Errors$1.NullPointerError, "type");
                }
                else {
                    if (value === BitmapFilterType.INNER || value === BitmapFilterType.OUTER) {
                        this._type = value;
                    }
                    else {
                        this._type = BitmapFilterType.FULL;
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        BevelFilter.prototype.clone = function () {
            return new BevelFilter(this._distance, this._angle, this._highlightColor, this._highlightAlpha, this._shadowColor, this._shadowAlpha, this._blurX, this._blurY, this._strength, this._quality, this._type, this._knockout);
        };
        // Called whenever the class is initialized.
        BevelFilter.classInitializer = null;
        // List of static symbols to link.
        BevelFilter.classSymbols = null; // [];
        // List of instance symbols to link.
        BevelFilter.instanceSymbols = null;
        return BevelFilter;
    }(BitmapFilter));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: BlurFilter
    var BlurFilter = /** @class */ (function (_super) {
        __extends(BlurFilter, _super);
        function BlurFilter(blurX, blurY, quality) {
            if (blurX === void 0) { blurX = 4; }
            if (blurY === void 0) { blurY = 4; }
            if (quality === void 0) { quality = 1; }
            var _this = _super.call(this) || this;
            _this.blurX = blurX;
            _this.blurY = blurY;
            _this.quality = quality;
            return _this;
        }
        BlurFilter.FromUntyped = function (obj) {
            return new BlurFilter(obj.blurX, obj.blurY, obj.quality);
        };
        BlurFilter.prototype._updateFilterBounds = function (bounds) {
            BitmapFilter._updateBlurBounds(bounds, this._blurX, this._blurY, this._quality, true);
        };
        BlurFilter.prototype._serialize = function (message) {
            message.ensureAdditionalCapacity(16);
            message.writeIntUnsafe(1);
            message.writeFloatUnsafe(this._blurX);
            message.writeFloatUnsafe(this._blurY);
            message.writeIntUnsafe(this._quality);
        };
        Object.defineProperty(BlurFilter.prototype, "blurX", {
            get: function () {
                return this._blurX;
            },
            set: function (value) {
                this._blurX = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BlurFilter.prototype, "blurY", {
            get: function () {
                return this._blurY;
            },
            set: function (value) {
                this._blurY = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(BlurFilter.prototype, "quality", {
            get: function () {
                return this._quality;
            },
            set: function (value /*int*/) {
                this._quality = NumberUtilities.clamp(value | 0, 0, 15);
            },
            enumerable: true,
            configurable: true
        });
        BlurFilter.prototype.clone = function () {
            return new BlurFilter(this._blurX, this._blurY, this._quality);
        };
        // Called whenever the class is initialized.
        BlurFilter.classInitializer = null;
        // List of static symbols to link.
        BlurFilter.classSymbols = null; // [];
        // List of instance symbols to link.
        BlurFilter.instanceSymbols = null;
        return BlurFilter;
    }(BitmapFilter));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: ColorMatrixFilter
    var ColorMatrixFilter = /** @class */ (function (_super) {
        __extends(ColorMatrixFilter, _super);
        function ColorMatrixFilter(matrix) {
            if (matrix === void 0) { matrix = null; }
            var _this = _super.call(this) || this;
            if (matrix) {
                _this.matrix = matrix;
            }
            else {
                _this._matrix = [
                    1, 0, 0, 0, 0,
                    0, 1, 0, 0, 0,
                    0, 0, 1, 0, 0,
                    0, 0, 0, 1, 0
                ];
            }
            return _this;
        }
        ColorMatrixFilter.FromUntyped = function (obj) {
            var filter = Object.create(ColorMatrixFilter.axClass.tPrototype);
            filter._matrix = obj.matrix;
            return filter;
        };
        ColorMatrixFilter.prototype._serialize = function (message) {
            var matrix = this._matrix;
            message.ensureAdditionalCapacity((matrix.length + 1) * 4);
            message.writeIntUnsafe(6);
            for (var i = 0; i < matrix.length; i++) {
                message.writeFloatUnsafe(matrix[i]);
            }
        };
        Object.defineProperty(ColorMatrixFilter.prototype, "matrix", {
            get: function () {
                return this.sec.createArrayUnsafe(this._matrix.concat());
            },
            set: function (value_) {
                if (isNullOrUndefined$1(value_)) {
                    this.sec.throwError("TypeError", Errors$1.NullPointerError, "matrix");
                }
                var matrix = [
                    0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0,
                    0, 0, 0, 0, 0
                ];
                var value = value_.value;
                for (var i = 0, n = Math.min(value.length, 20); i < n; i++) {
                    matrix[i] = toNumber(value[i]);
                }
                this._matrix = matrix;
            },
            enumerable: true,
            configurable: true
        });
        ColorMatrixFilter.prototype.clone = function () {
            return new ColorMatrixFilter(this.matrix);
        };
        ColorMatrixFilter.classInitializer = null;
        return ColorMatrixFilter;
    }(BitmapFilter));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: ConvolutionFilter
    var ConvolutionFilter = /** @class */ (function (_super) {
        __extends(ConvolutionFilter, _super);
        function ConvolutionFilter(matrixX, matrixY, matrix, divisor, bias, preserveAlpha, clamp, color, alpha) {
            if (matrixX === void 0) { matrixX = 0; }
            if (matrixY === void 0) { matrixY = 0; }
            if (matrix === void 0) { matrix = null; }
            if (divisor === void 0) { divisor = 1; }
            if (bias === void 0) { bias = 0; }
            if (preserveAlpha === void 0) { preserveAlpha = true; }
            if (clamp === void 0) { clamp = true; }
            if (color === void 0) { color = 0; }
            if (alpha === void 0) { alpha = 0; }
            var _this = _super.call(this) || this;
            _this.matrixX = matrixX;
            _this.matrixY = matrixY;
            if (matrix) {
                _this.matrix = matrix;
            }
            else {
                _this._matrix = _this._expandArray([], _this._matrixX * _this._matrixY);
            }
            _this.divisor = divisor;
            _this.bias = bias;
            _this.preserveAlpha = preserveAlpha;
            _this.clamp = clamp;
            _this.color = color;
            _this.alpha = alpha;
            return _this;
        }
        ConvolutionFilter.FromUntyped = function (obj) {
            return new ConvolutionFilter(obj.matrixX, obj.matrixY, obj.matrix, obj.divisor, obj.bias, obj.preserveAlpha, obj.clamp, 
            // obj.color is an RGBA color.
            obj.color >>> 8, (obj.color & 0xff) / 0xff);
        };
        ConvolutionFilter.prototype._expandArray = function (a, newLen /*uint*/, value) {
            if (value === void 0) { value = 0; }
            if (a) {
                var i = a.length;
                while (i < newLen) {
                    a[i++] = 0;
                }
            }
            return a;
        };
        Object.defineProperty(ConvolutionFilter.prototype, "matrix", {
            get: function () {
                return this.sec.createArrayUnsafe(this._matrix.slice(0, this._matrixX * this._matrixY));
            },
            set: function (value_) {
                if (isNullOrUndefined$1(value_)) {
                    this.sec.throwError("TypeError", Errors$1.NullPointerError, "matrix");
                }
                var value = value_.value;
                var actualLen = this._matrixX * this._matrixY;
                var minLen = Math.min(value.length, actualLen);
                var matrix = Array(minLen);
                for (var i = 0; i < minLen; i++) {
                    matrix[i] = toNumber(value[i]);
                }
                this._expandArray(matrix, actualLen);
                this._matrix = matrix;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConvolutionFilter.prototype, "matrixX", {
            get: function () {
                return this._matrixX;
            },
            set: function (value) {
                var mx = NumberUtilities.clamp(+value, 0, 15) | 0;
                if (this._matrixX !== mx) {
                    this._matrixX = mx;
                    this._expandArray(this._matrix, mx * this._matrixY);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConvolutionFilter.prototype, "matrixY", {
            get: function () {
                return this._matrixY;
            },
            set: function (value) {
                var my = NumberUtilities.clamp(+value, 0, 15) | 0;
                if (this._matrixY !== my) {
                    this._matrixY = my;
                    this._expandArray(this._matrix, my * this._matrixX);
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConvolutionFilter.prototype, "divisor", {
            get: function () {
                return this._divisor;
            },
            set: function (value) {
                this._divisor = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConvolutionFilter.prototype, "bias", {
            get: function () {
                return this._bias;
            },
            set: function (value) {
                this._bias = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConvolutionFilter.prototype, "preserveAlpha", {
            get: function () {
                return this._preserveAlpha;
            },
            set: function (value) {
                this._preserveAlpha = !!value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConvolutionFilter.prototype, "clamp", {
            get: function () {
                return this._clamp;
            },
            set: function (value) {
                this._clamp = !!value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConvolutionFilter.prototype, "color", {
            get: function () {
                return this._color;
            },
            set: function (value /*uint*/) {
                this._color = value >>> 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ConvolutionFilter.prototype, "alpha", {
            get: function () {
                return this._alpha;
            },
            set: function (value) {
                this._alpha = NumberUtilities.clamp(+value, 0, 1);
            },
            enumerable: true,
            configurable: true
        });
        ConvolutionFilter.prototype.clone = function () {
            return new ConvolutionFilter(this._matrixX, this._matrixY, this.matrix, this._divisor, this._bias, this._preserveAlpha, this._clamp, this._color, this._alpha);
        };
        ConvolutionFilter.classInitializer = null;
        return ConvolutionFilter;
    }(BitmapFilter));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: DisplacementMapFilter
    var DisplacementMapFilter = /** @class */ (function (_super) {
        __extends(DisplacementMapFilter, _super);
        function DisplacementMapFilter(mapBitmap, mapPoint, componentX, componentY, scaleX, scaleY, mode, color, alpha) {
            if (mapBitmap === void 0) { mapBitmap = null; }
            if (mapPoint === void 0) { mapPoint = null; }
            if (componentX === void 0) { componentX = 0; }
            if (componentY === void 0) { componentY = 0; }
            if (scaleX === void 0) { scaleX = 0; }
            if (scaleY === void 0) { scaleY = 0; }
            if (mode === void 0) { mode = "wrap"; }
            if (color === void 0) { color = 0; }
            if (alpha === void 0) { alpha = 0; }
            var _this = _super.call(this) || this;
            _this.mapBitmap = mapBitmap;
            _this.mapPoint = mapPoint;
            _this.componentX = componentX;
            _this.componentY = componentY;
            _this.scaleX = scaleX;
            _this.scaleY = scaleY;
            _this.mode = mode;
            _this.color = color;
            _this.alpha = alpha;
            return _this;
        }
        DisplacementMapFilter.FromUntyped = function (obj) {
            return new DisplacementMapFilter(obj.mapBitmap, obj.mapPoint, obj.componentX, obj.componentY, obj.scaleX, obj.scaleY, obj.mode, obj.color, obj.alpha);
        };
        Object.defineProperty(DisplacementMapFilter.prototype, "mapBitmap", {
            get: function () {
                release$1 || somewhatImplemented("public flash.filters.DisplacementMapFilter::get mapBitmap");
                return this._mapBitmap;
            },
            set: function (value) {
                release$1 || somewhatImplemented("public flash.filters.DisplacementMapFilter::set mapBitmap");
                this._mapBitmap = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplacementMapFilter.prototype, "mapPoint", {
            get: function () {
                release$1 || somewhatImplemented("public flash.filters.DisplacementMapFilter::get mapPoint");
                return this._mapPoint;
            },
            set: function (value) {
                release$1 || somewhatImplemented("public flash.filters.DisplacementMapFilter::set mapPoint");
                this._mapPoint = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplacementMapFilter.prototype, "componentX", {
            get: function () {
                return this._componentX;
            },
            set: function (value /*uint*/) {
                release$1 || somewhatImplemented("public flash.filters.DisplacementMapFilter::set componentX");
                this._componentX = value >>> 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplacementMapFilter.prototype, "componentY", {
            get: function () {
                return this._componentY;
            },
            set: function (value /*uint*/) {
                release$1 || somewhatImplemented("public flash.filters.DisplacementMapFilter::set componentY");
                this._componentY = value >>> 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplacementMapFilter.prototype, "scaleX", {
            get: function () {
                return this._scaleX;
            },
            set: function (value) {
                release$1 || somewhatImplemented("public flash.filters.DisplacementMapFilter::set scaleX");
                this._scaleX = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplacementMapFilter.prototype, "scaleY", {
            get: function () {
                return this._scaleY;
            },
            set: function (value) {
                release$1 || somewhatImplemented("public flash.filters.DisplacementMapFilter::set scaleY");
                this._scaleY = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplacementMapFilter.prototype, "mode", {
            get: function () {
                return this._mode;
            },
            set: function (value) {
                release$1 || somewhatImplemented("public flash.filters.DisplacementMapFilter::set mode");
                this._mode = axCoerceString$3(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplacementMapFilter.prototype, "color", {
            get: function () {
                return this._color;
            },
            set: function (value /*uint*/) {
                release$1 || somewhatImplemented("public flash.filters.DisplacementMapFilter::set color");
                this._color = (value >>> 0) & 0xffffff;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DisplacementMapFilter.prototype, "alpha", {
            get: function () {
                return this._alpha;
            },
            set: function (value) {
                release$1 || somewhatImplemented("public flash.filters.DisplacementMapFilter::set alpha");
                this._alpha = +value;
            },
            enumerable: true,
            configurable: true
        });
        DisplacementMapFilter.prototype.clone = function () {
            return new DisplacementMapFilter(this._mapBitmap, this._mapPoint, this._componentX, this._componentY, this._scaleX, this._scaleY, this._mode, this._color, this._alpha);
        };
        // Called whenever the class is initialized.
        DisplacementMapFilter.classInitializer = null;
        // List of static symbols to link.
        DisplacementMapFilter.classSymbols = null; // [];
        // List of instance symbols to link.
        DisplacementMapFilter.instanceSymbols = null;
        return DisplacementMapFilter;
    }(BitmapFilter));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: DropShadowFilter
    var DropShadowFilter = /** @class */ (function (_super) {
        __extends(DropShadowFilter, _super);
        function DropShadowFilter(distance, angle, color, alpha, blurX, blurY, strength, quality, inner, knockout, hideObject) {
            if (distance === void 0) { distance = 4; }
            if (angle === void 0) { angle = 45; }
            if (color === void 0) { color = 0; }
            if (alpha === void 0) { alpha = 1; }
            if (blurX === void 0) { blurX = 4; }
            if (blurY === void 0) { blurY = 4; }
            if (strength === void 0) { strength = 1; }
            if (quality === void 0) { quality = 1; }
            if (inner === void 0) { inner = false; }
            if (knockout === void 0) { knockout = false; }
            if (hideObject === void 0) { hideObject = false; }
            var _this = _super.call(this) || this;
            _this.distance = distance;
            _this.angle = angle;
            _this.color = color;
            _this.alpha = alpha;
            _this.blurX = blurX;
            _this.blurY = blurY;
            _this.strength = strength;
            _this.quality = quality;
            _this.inner = inner;
            _this.knockout = knockout;
            _this.hideObject = hideObject;
            return _this;
        }
        DropShadowFilter.FromUntyped = function (obj) {
            // obj.colors is an array of RGBA colors.
            // Here it contains exactly one color object, which maps to color and alpha.
            release$1 || assert$2(obj.colors && obj.colors.length === 1, "colors must be Array of length 1");
            var color = obj.colors[0] >>> 8;
            var alpha = (obj.colors[0] & 0xff) / 0xff;
            // obj.angle is represented in radians, the api needs degrees
            var angle = obj.angle * 180 / Math.PI;
            // obj.compositeSource maps to !hideObject
            var hideObject = !obj.compositeSource;
            return new DropShadowFilter(obj.distance, angle, color, alpha, obj.blurX, obj.blurY, obj.strength, obj.quality, obj.inner, obj.knockout, hideObject);
        };
        DropShadowFilter.prototype._updateFilterBounds = function (bounds) {
            if (!this.inner) {
                BitmapFilter._updateBlurBounds(bounds, this._blurX, this._blurY, this._quality);
                if (this._distance !== 0) {
                    var a = this._angle * Math.PI / 180;
                    bounds.x += Math.floor(Math.cos(a) * this._distance);
                    bounds.y += Math.floor(Math.sin(a) * this._distance);
                    if (bounds.left > 0) {
                        bounds.left = 0;
                    }
                    if (bounds.top > 0) {
                        bounds.top = 0;
                    }
                }
            }
        };
        Object.defineProperty(DropShadowFilter.prototype, "distance", {
            get: function () {
                return this._distance;
            },
            set: function (value) {
                this._distance = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DropShadowFilter.prototype, "angle", {
            get: function () {
                return this._angle;
            },
            set: function (value) {
                this._angle = +value % 360;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DropShadowFilter.prototype, "color", {
            get: function () {
                return this._color;
            },
            set: function (value /*uint*/) {
                this._color = (value >>> 0) & 0xffffff;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DropShadowFilter.prototype, "alpha", {
            get: function () {
                return this._alpha;
            },
            set: function (value) {
                this._alpha = NumberUtilities.clamp(+value, 0, 1);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DropShadowFilter.prototype, "blurX", {
            get: function () {
                return this._blurX;
            },
            set: function (value) {
                this._blurX = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DropShadowFilter.prototype, "blurY", {
            get: function () {
                return this._blurY;
            },
            set: function (value) {
                this._blurY = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DropShadowFilter.prototype, "hideObject", {
            get: function () {
                return this._hideObject;
            },
            set: function (value) {
                this._hideObject = !!value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DropShadowFilter.prototype, "inner", {
            get: function () {
                return this._inner;
            },
            set: function (value) {
                this._inner = !!value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DropShadowFilter.prototype, "knockout", {
            get: function () {
                return this._knockout;
            },
            set: function (value) {
                this._knockout = !!value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DropShadowFilter.prototype, "quality", {
            get: function () {
                return this._quality;
            },
            set: function (value /*int*/) {
                this._quality = NumberUtilities.clamp(value | 0, 0, 15);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DropShadowFilter.prototype, "strength", {
            get: function () {
                return this._strength;
            },
            set: function (value) {
                this._strength = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        DropShadowFilter.prototype.clone = function () {
            return new DropShadowFilter(this._distance, this._angle, this._color, this._alpha, this._blurX, this._blurY, this._strength, this._quality, this._inner, this._knockout, this._hideObject);
        };
        // Called whenever the class is initialized.
        DropShadowFilter.classInitializer = null;
        // List of static symbols to link.
        DropShadowFilter.classSymbols = null; // [];
        // List of instance symbols to link.
        DropShadowFilter.instanceSymbols = null;
        return DropShadowFilter;
    }(BitmapFilter));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: GlowFilter
    var GlowFilter = /** @class */ (function (_super) {
        __extends(GlowFilter, _super);
        function GlowFilter(color, alpha, blurX, blurY, strength, quality, inner, knockout) {
            if (color === void 0) { color = 16711680; }
            if (alpha === void 0) { alpha = 1; }
            if (blurX === void 0) { blurX = 6; }
            if (blurY === void 0) { blurY = 6; }
            if (strength === void 0) { strength = 2; }
            if (quality === void 0) { quality = 1; }
            if (inner === void 0) { inner = false; }
            if (knockout === void 0) { knockout = false; }
            var _this = _super.call(this) || this;
            _this.color = color;
            _this.alpha = alpha;
            _this.blurX = blurX;
            _this.blurY = blurY;
            _this.strength = strength;
            _this.quality = quality;
            _this.inner = inner;
            _this.knockout = knockout;
            return _this;
        }
        GlowFilter.FromUntyped = function (obj) {
            // obj.colors is an array of RGBA colors.
            // Here it contains exactly one color object, which maps to color and alpha.
            release$1 || assert$2(obj.colors && obj.colors.length === 1, "colors must be Array of length 1");
            var color = obj.colors[0] >>> 8;
            var alpha = (obj.colors[0] & 0xff) / 0xff;
            return new GlowFilter(color, alpha, obj.blurX, obj.blurY, obj.strength, obj.quality, obj.inner, obj.knockout);
        };
        GlowFilter.prototype._updateFilterBounds = function (bounds) {
            BitmapFilter._updateBlurBounds(bounds, this._blurX, this._blurY, this._quality);
        };
        Object.defineProperty(GlowFilter.prototype, "color", {
            get: function () {
                return this._color;
            },
            set: function (value /*uint*/) {
                this._color = (value >>> 0) & 0xffffff;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GlowFilter.prototype, "alpha", {
            get: function () {
                return this._alpha;
            },
            set: function (value) {
                this._alpha = NumberUtilities.clamp(+value, 0, 1);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GlowFilter.prototype, "blurX", {
            get: function () {
                return this._blurX;
            },
            set: function (value) {
                this._blurX = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GlowFilter.prototype, "blurY", {
            get: function () {
                return this._blurY;
            },
            set: function (value) {
                this._blurY = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GlowFilter.prototype, "inner", {
            get: function () {
                return this._inner;
            },
            set: function (value) {
                this._inner = !!value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GlowFilter.prototype, "knockout", {
            get: function () {
                return this._knockout;
            },
            set: function (value) {
                this._knockout = !!value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GlowFilter.prototype, "quality", {
            get: function () {
                return this._quality;
            },
            set: function (value /*int*/) {
                this._quality = NumberUtilities.clamp(value | 0, 0, 15);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GlowFilter.prototype, "strength", {
            get: function () {
                return this._strength;
            },
            set: function (value) {
                this._strength = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        GlowFilter.prototype.clone = function () {
            return new GlowFilter(this._color, this._alpha, this._blurX, this._blurY, this._strength, this._quality, this._inner, this._knockout);
        };
        // Called whenever the class is initialized.
        GlowFilter.classInitializer = null;
        // List of static symbols to link.
        GlowFilter.classSymbols = null; // [];
        // List of instance symbols to link.
        GlowFilter.instanceSymbols = null;
        return GlowFilter;
    }(BitmapFilter));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: GradientBevelFilter
    var GradientBevelFilter = /** @class */ (function (_super) {
        __extends(GradientBevelFilter, _super);
        function GradientBevelFilter(distance, angle, colors, alphas, ratios, blurX, blurY, strength, quality, type, knockout) {
            if (distance === void 0) { distance = 4; }
            if (angle === void 0) { angle = 45; }
            if (colors === void 0) { colors = null; }
            if (alphas === void 0) { alphas = null; }
            if (ratios === void 0) { ratios = null; }
            if (blurX === void 0) { blurX = 4; }
            if (blurY === void 0) { blurY = 4; }
            if (strength === void 0) { strength = 1; }
            if (quality === void 0) { quality = 1; }
            if (type === void 0) { type = "inner"; }
            if (knockout === void 0) { knockout = false; }
            var _this = _super.call(this) || this;
            _this.distance = distance;
            _this.angle = angle;
            GradientArrays.sanitize(colors ? colors.value : null, alphas ? alphas.value : null, ratios ? ratios.value : null);
            _this._colors = GradientArrays.colors;
            _this._alphas = GradientArrays.alphas;
            _this._ratios = GradientArrays.ratios;
            _this.blurX = blurX;
            _this.blurY = blurY;
            _this.strength = strength;
            _this.quality = quality;
            _this.type = type;
            _this.knockout = knockout;
            return _this;
        }
        GradientBevelFilter.FromUntyped = function (obj) {
            // obj.colors is an array of RGBA colors.
            // The RGB and alpha parts must be separated into colors and alphas arrays.
            var colors = [];
            var alphas = [];
            for (var i = 0; i < obj.colors.length; i++) {
                var color = obj.colors[i];
                colors.push(color >>> 8);
                alphas.push(color & 0xff) / 0xff;
            }
            // type is derived from obj.onTop and obj.innerShadow
            // obj.onTop true: type is FULL
            // obj.inner true: type is INNER
            // neither true: type is OUTER
            var type = BitmapFilterType.OUTER;
            if (!!obj.onTop) {
                type = BitmapFilterType.FULL;
            }
            else if (!!obj.inner) {
                type = BitmapFilterType.INNER;
            }
            // obj.angle is represented in radians, the api needs degrees
            var angle = obj.angle * 180 / Math.PI;
            return new GradientBevelFilter(obj.distance, angle, 
            // Boxing these is obviously not ideal, but everything else is just annoying.
            this.sec.createArrayUnsafe(colors), this.sec.createArrayUnsafe(alphas), this.sec.createArrayUnsafe(obj.ratios), obj.blurX, obj.blurY, obj.strength, obj.quality, type, obj.knockout);
        };
        GradientBevelFilter.prototype._updateFilterBounds = function (bounds) {
            if (this.type !== BitmapFilterType.INNER) {
                BitmapFilter._updateBlurBounds(bounds, this._blurX, this._blurY, this._quality);
                if (this._distance !== 0) {
                    var a = this._angle * Math.PI / 180;
                    bounds.x += Math.floor(Math.cos(a) * this._distance);
                    bounds.y += Math.floor(Math.sin(a) * this._distance);
                    if (bounds.left > 0) {
                        bounds.left = 0;
                    }
                    if (bounds.top > 0) {
                        bounds.top = 0;
                    }
                }
            }
        };
        Object.defineProperty(GradientBevelFilter.prototype, "distance", {
            get: function () {
                return this._distance;
            },
            set: function (value) {
                this._distance = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientBevelFilter.prototype, "angle", {
            get: function () {
                return this._angle;
            },
            set: function (value) {
                this._angle = +value % 360;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientBevelFilter.prototype, "colors", {
            get: function () {
                return this.sec.createArrayUnsafe(this._colors.concat());
            },
            set: function (value) {
                if (isNullOrUndefined$1(value)) {
                    this.sec.throwError("TypeError", Errors$1.NullPointerError, "colors");
                }
                this._colors = GradientArrays.sanitizeColors(value.value);
                var len = this._colors.length;
                this._alphas = GradientArrays.sanitizeAlphas(this._alphas, len, len);
                this._ratios = GradientArrays.sanitizeRatios(this._ratios, len, len);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientBevelFilter.prototype, "alphas", {
            get: function () {
                return this.sec.createArrayUnsafe(this._alphas.concat());
            },
            set: function (value) {
                if (isNullOrUndefined$1(value)) {
                    this.sec.throwError("TypeError", Errors$1.NullPointerError, "alphas");
                }
                GradientArrays.sanitize(this._colors, value.value, this._ratios);
                this._colors = GradientArrays.colors;
                this._alphas = GradientArrays.alphas;
                this._ratios = GradientArrays.ratios;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientBevelFilter.prototype, "ratios", {
            get: function () {
                return this.sec.createArrayUnsafe(this._ratios.concat());
            },
            set: function (value_) {
                if (isNullOrUndefined$1(value_)) {
                    this.sec.throwError("TypeError", Errors$1.NullPointerError, "ratios");
                }
                GradientArrays.sanitize(this._colors, this._alphas, value_.value);
                this._colors = GradientArrays.colors;
                this._alphas = GradientArrays.alphas;
                this._ratios = GradientArrays.ratios;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientBevelFilter.prototype, "blurX", {
            get: function () {
                return this._blurX;
            },
            set: function (value) {
                this._blurX = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientBevelFilter.prototype, "blurY", {
            get: function () {
                return this._blurY;
            },
            set: function (value) {
                this._blurY = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientBevelFilter.prototype, "knockout", {
            get: function () {
                return this._knockout;
            },
            set: function (value) {
                this._knockout = !!value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientBevelFilter.prototype, "quality", {
            get: function () {
                return this._quality;
            },
            set: function (value /*int*/) {
                this._quality = NumberUtilities.clamp(value | 0, 0, 15);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientBevelFilter.prototype, "strength", {
            get: function () {
                return this._strength;
            },
            set: function (value) {
                this._strength = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientBevelFilter.prototype, "type", {
            get: function () {
                return this._type;
            },
            set: function (value) {
                value = axCoerceString$3(value);
                if (value === null) {
                    this.sec.throwError("TypeError", Errors$1.NullPointerError, "type");
                }
                else {
                    if (value === BitmapFilterType.INNER || value === BitmapFilterType.OUTER) {
                        this._type = value;
                    }
                    else {
                        this._type = BitmapFilterType.FULL;
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        GradientBevelFilter.prototype.clone = function () {
            return new GradientBevelFilter(this._distance, this._angle, this.colors, this.alphas, this.ratios, this._blurX, this._blurY, this._strength, this._quality, this._type, this._knockout);
        };
        // Called whenever the class is initialized.
        GradientBevelFilter.classInitializer = null;
        // List of static symbols to link.
        GradientBevelFilter.classSymbols = null; // [];
        // List of instance symbols to link.
        GradientBevelFilter.instanceSymbols = null;
        return GradientBevelFilter;
    }(BitmapFilter));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: GradientGlowFilter
    var GradientGlowFilter = /** @class */ (function (_super) {
        __extends(GradientGlowFilter, _super);
        function GradientGlowFilter(distance, angle, colors, alphas, ratios, blurX, blurY, strength, quality, type, knockout) {
            if (distance === void 0) { distance = 4; }
            if (angle === void 0) { angle = 45; }
            if (colors === void 0) { colors = null; }
            if (alphas === void 0) { alphas = null; }
            if (ratios === void 0) { ratios = null; }
            if (blurX === void 0) { blurX = 4; }
            if (blurY === void 0) { blurY = 4; }
            if (strength === void 0) { strength = 1; }
            if (quality === void 0) { quality = 1; }
            if (type === void 0) { type = "inner"; }
            if (knockout === void 0) { knockout = false; }
            var _this = _super.call(this) || this;
            _this.distance = distance;
            _this.angle = angle;
            GradientArrays.sanitize(colors ? colors.value : null, alphas ? alphas.value : null, ratios ? ratios.value : null);
            _this._colors = GradientArrays.colors;
            _this._alphas = GradientArrays.alphas;
            _this._ratios = GradientArrays.ratios;
            _this.blurX = blurX;
            _this.blurY = blurY;
            _this.strength = strength;
            _this.quality = quality;
            _this.type = type;
            _this.knockout = knockout;
            return _this;
        }
        GradientGlowFilter.FromUntyped = function (obj) {
            // obj.colors is an array of RGBA colors.
            // The RGB and alpha parts must be separated into colors and alphas arrays.
            var colors = [];
            var alphas = [];
            for (var i = 0; i < obj.colors.length; i++) {
                var color = obj.colors[i];
                colors.push(color >>> 8);
                alphas.push(color & 0xff) / 0xff;
            }
            // type is derived from obj.onTop and obj.innerShadow
            // obj.onTop true: type is FULL
            // obj.inner true: type is INNER
            // neither true: type is OUTER
            var type = BitmapFilterType.OUTER;
            if (!!obj.onTop) {
                type = BitmapFilterType.FULL;
            }
            else if (!!obj.inner) {
                type = BitmapFilterType.INNER;
            }
            // obj.angle is represented in radians, the api needs degrees
            var angle = obj.angle * 180 / Math.PI;
            return new GradientGlowFilter(obj.distance, angle, 
            // Boxing these is obviously not ideal, but everything else is just annoying.
            this.sec.createArrayUnsafe(colors), this.sec.createArrayUnsafe(alphas), this.sec.createArrayUnsafe(obj.ratios), obj.blurX, obj.blurY, obj.strength, obj.quality, type, obj.knockout);
        };
        GradientGlowFilter.prototype._updateFilterBounds = function (bounds) {
            if (this.type !== BitmapFilterType.INNER) {
                BitmapFilter._updateBlurBounds(bounds, this._blurX, this._blurY, this._quality);
                if (this._distance !== 0) {
                    var a = this._angle * Math.PI / 180;
                    bounds.x += Math.floor(Math.cos(a) * this._distance);
                    bounds.y += Math.floor(Math.sin(a) * this._distance);
                    if (bounds.left > 0) {
                        bounds.left = 0;
                    }
                    if (bounds.top > 0) {
                        bounds.top = 0;
                    }
                }
            }
        };
        Object.defineProperty(GradientGlowFilter.prototype, "distance", {
            get: function () {
                return this._distance;
            },
            set: function (value) {
                this._distance = +value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientGlowFilter.prototype, "angle", {
            get: function () {
                return this._angle;
            },
            set: function (value) {
                this._angle = +value % 360;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientGlowFilter.prototype, "colors", {
            get: function () {
                return this.sec.createArrayUnsafe(this._colors.concat());
            },
            set: function (value) {
                if (isNullOrUndefined$1(value)) {
                    this.sec.throwError("TypeError", Errors$1.NullPointerError, "colors");
                }
                this._colors = GradientArrays.sanitizeColors(value.value);
                var len = this._colors.length;
                this._alphas = GradientArrays.sanitizeAlphas(this._alphas, len, len);
                this._ratios = GradientArrays.sanitizeRatios(this._ratios, len, len);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientGlowFilter.prototype, "alphas", {
            get: function () {
                return this.sec.createArrayUnsafe(this._alphas.concat());
            },
            set: function (value) {
                if (isNullOrUndefined$1(value)) {
                    this.sec.throwError("TypeError", Errors$1.NullPointerError, "alphas");
                }
                GradientArrays.sanitize(this._colors, value.value, this._ratios);
                this._colors = GradientArrays.colors;
                this._alphas = GradientArrays.alphas;
                this._ratios = GradientArrays.ratios;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientGlowFilter.prototype, "ratios", {
            get: function () {
                return this.sec.createArrayUnsafe(this._ratios.concat());
            },
            set: function (value_) {
                if (isNullOrUndefined$1(value_)) {
                    this.sec.throwError("TypeError", Errors$1.NullPointerError, "ratios");
                }
                GradientArrays.sanitize(this._colors, this._alphas, value_.value);
                this._colors = GradientArrays.colors;
                this._alphas = GradientArrays.alphas;
                this._ratios = GradientArrays.ratios;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientGlowFilter.prototype, "blurX", {
            get: function () {
                return this._blurX;
            },
            set: function (value) {
                this._blurX = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientGlowFilter.prototype, "blurY", {
            get: function () {
                return this._blurY;
            },
            set: function (value) {
                this._blurY = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientGlowFilter.prototype, "knockout", {
            get: function () {
                return this._knockout;
            },
            set: function (value) {
                this._knockout = !!value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientGlowFilter.prototype, "quality", {
            get: function () {
                return this._quality;
            },
            set: function (value /*int*/) {
                this._quality = NumberUtilities.clamp(value | 0, 0, 15);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientGlowFilter.prototype, "strength", {
            get: function () {
                return this._strength;
            },
            set: function (value) {
                this._strength = NumberUtilities.clamp(+value, 0, 255);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(GradientGlowFilter.prototype, "type", {
            get: function () {
                return this._type;
            },
            set: function (value) {
                value = axCoerceString$3(value);
                if (value === null) {
                    this.sec.throwError("TypeError", Errors$1.NullPointerError, "type");
                }
                else {
                    if (value === BitmapFilterType.INNER || value === BitmapFilterType.OUTER) {
                        this._type = value;
                    }
                    else {
                        this._type = BitmapFilterType.FULL;
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        GradientGlowFilter.prototype.clone = function () {
            return new GradientGlowFilter(this._distance, this._angle, this.colors, this.alphas, this.ratios, this._blurX, this._blurY, this._strength, this._quality, this._type, this._knockout);
        };
        GradientGlowFilter.classInitializer = null;
        return GradientGlowFilter;
    }(BitmapFilter));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: TouchscreenType
    var TouchscreenType = /** @class */ (function (_super) {
        __extends(TouchscreenType, _super);
        function TouchscreenType() {
            return _super.call(this) || this;
        }
        // Called whenever the class is initialized.
        TouchscreenType.classInitializer = null;
        // List of static symbols to link.
        TouchscreenType.classSymbols = null; // [];
        // List of instance symbols to link.
        TouchscreenType.instanceSymbols = null; // [];
        TouchscreenType.FINGER = "finger";
        TouchscreenType.STYLUS = "stylus";
        TouchscreenType.NONE = "none";
        return TouchscreenType;
    }(ASObject$1));

    var Capabilities$1 = /** @class */ (function (_super) {
        __extends(Capabilities, _super);
        function Capabilities() {
            return _super.call(this) || this;
        }
        Object.defineProperty(Capabilities, "isEmbeddedInAcrobat", {
            // static _touchscreenType: string;
            // static _hasIME: boolean;
            // static _hasTLS: boolean;
            // static _maxLevelIDC: string;
            // static _supports32BitProcesses: boolean;
            // static _supports64BitProcesses: boolean;
            // static __internal: number /*uint*/;
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasEmbeddedVideo", {
            get: function () {
                release$1 || notImplemented("public flash.system.Capabilities::get hasEmbeddedVideo");
                return;
                // return Capabilities._hasEmbeddedVideo;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasAudio", {
            get: function () {
                // The documentation says "this property is always true".
                return true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "avHardwareDisable", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get avHardwareDisable");
                return true;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasAccessibility", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get hasAccessibility");
                return Capabilities._hasAccessibility;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasAudioEncoder", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get hasAudioEncoder");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasMP3", {
            get: function () {
                release$1 || notImplemented("public flash.system.Capabilities::get hasMP3");
                return;
                // return Capabilities._hasMP3;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasPrinting", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get hasPrinting");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasScreenBroadcast", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get hasScreenBroadcast");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasScreenPlayback", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get hasScreenPlayback");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasStreamingAudio", {
            get: function () {
                release$1 || notImplemented("public flash.system.Capabilities::get hasStreamingAudio");
                return;
                // return Capabilities._hasStreamingAudio;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasStreamingVideo", {
            get: function () {
                release$1 || notImplemented("public flash.system.Capabilities::get hasStreamingVideo");
                return;
                // return Capabilities._hasStreamingVideo;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasVideoEncoder", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get hasVideoEncoder");
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "isDebugger", {
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "localFileReadDisable", {
            get: function () {
                release$1 || notImplemented("public flash.system.Capabilities::get localFileReadDisable");
                return;
                // return Capabilities._localFileReadDisable;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "language", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get language");
                return Capabilities._language;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "manufacturer", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get manufacturer");
                return Capabilities._manufacturer;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "os", {
            get: function () {
                if (Capabilities._os === null) {
                    var os;
                    var userAgent = window.navigator.userAgent;
                    if (userAgent.indexOf("Macintosh") > 0) {
                        if (userAgent.indexOf('Mac OS X ') === -1) {
                            os = 'Mac OS 10.6';
                        }
                        else {
                            var versionStr = userAgent.split('Mac OS X ')[1];
                            os = versionStr.substr(0, versionStr.indexOf(';'));
                        }
                    }
                    else if (userAgent.indexOf("Windows") > 0) {
                        os = "Windows XP";
                    }
                    else if (userAgent.indexOf("Linux") > 0) {
                        os = "Linux";
                    }
                    else if (/(iPad|iPhone|iPod|Android)/.test(userAgent)) {
                        os = "iPhone3,1";
                    }
                    else {
                        release$1 || somewhatImplemented("public flash.system.Capabilities::get os");
                        os = "Generic OS";
                    }
                    Capabilities._os = os;
                }
                return Capabilities._os;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "cpuArchitecture", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get cpuArchitecture");
                return 'x86';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "playerType", {
            get: function () {
                return Capabilities._playerType;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "serverString", {
            get: function () {
                var str = toKeyValueArray({ OS: Capabilities.os }).map(function (pair) {
                    return pair[0] + "=" + encodeURIComponent(pair[1]);
                }).join("&");
                release$1 || somewhatImplemented("Capabilities.serverString: " + str);
                return str;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "version", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get version");
                return Capabilities._version;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "screenColor", {
            /**
             * This can be "color", "gray" or "bw" for black and white. I don't know when you'd have anything
             * other than "color".
             */
            get: function () {
                return "color";
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "pixelAspectRatio", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get pixelAspectRatio");
                return 1;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "screenDPI", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get screenDPI");
                return Capabilities._screenDPI;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "screenResolutionX", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get screenResolutionX");
                return window.screen.width; // TODO check
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "screenResolutionY", {
            get: function () {
                release$1 || somewhatImplemented("public flash.system.Capabilities::get screenResolutionY");
                return window.screen.height; // TODO check
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "touchscreenType", {
            get: function () {
                return TouchscreenType.NONE;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasIME", {
            get: function () {
                return false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "hasTLS", {
            get: function () {
                release$1 || notImplemented("public flash.system.Capabilities::get hasTLS");
                return;
                // return Capabilities._hasTLS;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "maxLevelIDC", {
            get: function () {
                release$1 || notImplemented("public flash.system.Capabilities::get maxLevelIDC");
                return;
                // return Capabilities._maxLevelIDC;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "supports32BitProcesses", {
            get: function () {
                release$1 || notImplemented("public flash.system.Capabilities::get supports32BitProcesses");
                return;
                // return Capabilities._supports32BitProcesses;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "supports64BitProcesses", {
            get: function () {
                release$1 || notImplemented("public flash.system.Capabilities::get supports64BitProcesses");
                return;
                // return Capabilities._supports64BitProcesses;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Capabilities, "_internal", {
            get: function () {
                release$1 || notImplemented("public flash.system.Capabilities::get _internal");
                return;
                // return Capabilities.__internal;
            },
            enumerable: true,
            configurable: true
        });
        Capabilities.hasMultiChannelAudio = function (type) {
            release$1 || somewhatImplemented("public flash.system.Capabilities::static hasMultiChannelAudio");
            return false;
        };
        Capabilities.classInitializer = null;
        // static _hasEmbeddedVideo: boolean;
        // static _hasAudio: boolean;
        // static _avHardwareDisable: boolean;
        Capabilities._hasAccessibility = false;
        // static _hasAudioEncoder: boolean;
        // static _hasMP3: boolean;
        // static _hasPrinting: boolean;
        // static _hasScreenBroadcast: boolean;
        // static _hasScreenPlayback: boolean;
        // static _hasStreamingAudio: boolean;
        // static _hasStreamingVideo: boolean;
        // static _hasVideoEncoder: boolean;
        // static _localFileReadDisable: boolean;
        Capabilities._language = 'en';
        Capabilities._manufacturer = 'Mozilla Research';
        Capabilities._os = null;
        // static _cpuArchitecture: string;
        Capabilities._playerType = 'PlugIn';
        Capabilities._version = 'SHUMWAY 10,0,0,0';
        // static _screenColor: string;
        // static _pixelAspectRatio: number;
        Capabilities._screenDPI = 96; // Using standard CSS DPI for now.
        return Capabilities;
    }(ASObject$1));

    var ExternalInterfaceService = {
        enabled: false,
        initJS: function (callback) {
            // ...
        },
        registerCallback: function (functionName) {
            // ...
        },
        unregisterCallback: function (functionName) {
            // ...
        },
        eval: function (expression) {
            // ...
        },
        call: function (request) {
            // ...
        },
        getId: function () { return null; }
    };

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: ExternalInterface
    var ExternalInterface$1 = /** @class */ (function (_super) {
        __extends(ExternalInterface, _super);
        function ExternalInterface() {
            return _super.call(this) || this;
        }
        ExternalInterface.ensureInitialized = function () {
            if (!this.available) {
                this.sec.throwError('Error', Errors$1.ExternalInterfaceNotAvailableError);
            }
            if (this.initialized) {
                return;
            }
            /*Telemetry.instance.reportTelemetry({
                                                  topic: 'feature',
                                                  feature: Telemetry.Feature.EXTERNAL_INTERFACE_FEATURE
                                                });*/
            this.initialized = true;
            ExternalInterfaceService.initJS(this._callIn);
        };
        ExternalInterface.call = function (functionName) {
            this.ensureInitialized();
            var argsExpr = '';
            if (arguments.length > 1) {
                var args = [];
                for (var i = 1; i < arguments.length; i++) {
                    args.push(this.convertToJSString(arguments[i]));
                }
                argsExpr = args.join(',');
            }
            var catchExpr = this.$BgmarshallExceptions ?
                '"<exception>" + e + "</exception>";' :
                '"<undefined/>";';
            var evalExpr = 'try {' + '__flash__toXML(' + functionName + '(' + argsExpr + '));' +
                '} catch (e) {' + catchExpr + '}';
            var result = this._evalJS(evalExpr);
            if (result == null) {
                return null;
            }
            return this.convertFromXML(this.convertToXML(result));
        };
        ExternalInterface.addCallback = function (functionName, closure) {
            this.ensureInitialized();
            if (!closure) {
                this._removeCallback(functionName);
                return;
            }
            var self = this;
            this._addCallback(functionName, function (request, args) {
                var returnAsJS = true;
                if (args) {
                    var wrappedArgs = [];
                    for (var i = 0; i < args.length; i++) {
                        var arg = args[i];
                        // Objects have to be converted into proper AS objects in the current security domain.
                        if (typeof arg === 'object' && arg) {
                            wrappedArgs.push(self.sec.createObjectFromJS(arg, true));
                        }
                        else {
                            wrappedArgs.push(arg);
                        }
                    }
                    args = wrappedArgs;
                }
                else {
                    var xml = this.convertToXML(request);
                    var returnTypeAttr = xml.attribute('returntype');
                    returnAsJS = returnTypeAttr && returnTypeAttr._value == 'javascript';
                    args = [];
                    for (var i = 0; i < xml._children.length; i++) {
                        var x = xml._children[i];
                        args.push(this.convertFromXML(x));
                    }
                }
                var result;
                try {
                    result = closure.axApply(null, args);
                }
                catch (e) {
                    if (this.$BgmarshallExceptions) {
                        result = e;
                    }
                    else {
                        throw e;
                    }
                }
                return returnAsJS ? self.convertToJSString(result) : self.convertToXMLString(result);
            });
        };
        Object.defineProperty(ExternalInterface, "available", {
            get: function () {
                return ExternalInterfaceService.enabled;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ExternalInterface, "objectID", {
            get: function () {
                return ExternalInterfaceService.getId();
            },
            enumerable: true,
            configurable: true
        });
        ExternalInterface._addCallback = function (functionName, closure) {
            ExternalInterfaceService.registerCallback(functionName);
            ExternalInterface.registeredCallbacks[functionName] = closure;
        };
        ExternalInterface._removeCallback = function (functionName) {
            ExternalInterfaceService.unregisterCallback(functionName);
            delete ExternalInterface.registeredCallbacks[functionName];
        };
        ExternalInterface._evalJS = function (expression) {
            expression = axCoerceString$3(expression);
            return ExternalInterfaceService.eval(expression);
        };
        ExternalInterface._callIn = function (functionName, args) {
            var callback = ExternalInterface.registeredCallbacks[functionName];
            if (!callback) {
                return;
            }
            return callback(functionName, args);
        };
        ExternalInterface._callOut = function (request) {
            request = axCoerceString$3(request);
            return ExternalInterfaceService.call(request);
        };
        ExternalInterface.convertToXML = function (s) {
            var xmlClass = this.sec.system.getClass(Multiname.FromSimpleName('XML'));
            var savedIgnoreWhitespace = xmlClass.ignoreWhitespace;
            xmlClass.ignoreWhitespace = false;
            var xml = xmlClass.Create(s);
            xmlClass.ignoreWhitespace = savedIgnoreWhitespace;
            return xml;
        };
        ExternalInterface.convertToXMLString = function (obj) {
            switch (typeof obj) {
                case 'boolean':
                    return obj ? '<true/>' : '<false/>';
                case 'number':
                    return '<number>' + obj + '</number>';
                case 'string':
                    return '<string>' + obj.split('&').join('&amp;').split('<').join('&lt;').
                        split('>').join('&gt;') + '</string>';
                case 'object':
                    if (obj === null) {
                        return '<null/>';
                    }
                    if (this.sec.AXDate.axIsInstanceOf(obj)) {
                        return '<date>' + obj.time + '</date>';
                    }
                    if (this.sec.AXError.axIsInstanceOf(obj)) {
                        if (this.$BgmarshallExceptions) {
                            return '<exception>' + obj + '</exception>';
                        }
                        else {
                            return '<null/>'; // not sure?
                        }
                    }
                    var result = [];
                    // Looks like length is used to detect array. (obj is Array) is better?
                    if (obj.hasOwnProperty('$Bglength')) {
                        var len = obj.$Bglength;
                        for (var i = 0; i < len; i++) {
                            var entry = this.convertToXMLString(obj.axGetNumericProperty(i));
                            result.push('<property id="' + i + '">' + entry + '</property>');
                        }
                        return '<array>' + result.join('') + '</array>';
                    }
                    var keys = obj.axGetEnumerableKeys();
                    for (var i = 0; i < keys.length; i++) {
                        var key = keys[i];
                        var entry = this.convertToXMLString(obj.axGetPublicProperty(key));
                        result.push('<property id="' + key + '">' + entry + '</property>');
                    }
                    return '<object>' + result.join('') + '</object>';
                default:
                    return '<undefined/>';
            }
        };
        ExternalInterface.convertFromXML = function (xml /* ASXML | ASXMLList */) {
            switch (xml._name.name) {
                case 'true':
                    return true;
                case 'false':
                    return false;
                case 'number':
                    return Number(String(xml.children()));
                case 'string':
                    return String(xml.children());
                case 'null':
                    return null;
                case 'date':
                    return this.sec.AXDate.axConstruct([Number(String(xml.children()))]);
                case 'exception':
                    if (this.$BgmarshallExceptions) {
                        throw this.sec.AXError.axConstruct([String(xml.children())]);
                    }
                    return undefined;
                case 'array':
                case 'object':
                    var obj = xml._name.name === 'object' ?
                        this.sec.createObject() :
                        this.sec.createArrayUnsafe([]);
                    for (var i = 0; i < xml._children.length; i++) {
                        var x = xml._children[i];
                        obj.axSetPublicProperty(extractId(x), this.convertFromXML(x._children[0]));
                    }
                    return obj;
                case 'class':
                    var className = Multiname.FromFQNString(String(xml.children()), 0 /* Public */);
                    return this.sec.application.getClass(className);
                default:
                    return undefined;
            }
        };
        ExternalInterface.convertToJSString = function (obj) {
            if (typeof obj == 'string') {
                return '"' + obj.split('\r').join('\\r').split('\n').join('\\n').split('"').join('\\"') + '"';
            }
            if (this.sec.AXArray.axIsInstanceOf(obj)) {
                var parts = [];
                var arr = obj.value;
                for (var i = 0; i < arr.length; i++) {
                    parts.push(this.convertToJSString(arr[i]));
                }
                return '[' + parts.join(',') + ']';
            }
            if (this.sec.AXDate.axIsInstanceOf(obj)) {
                return 'new Date(' + obj.value + ')';
            }
            if (this.$BgmarshallExceptions && (this.sec.AXError.axIsInstanceOf(obj))) {
                return 'throw "' + obj + '"';
            }
            if (typeof obj === 'object' && obj !== null) {
                var parts = [];
                var keys = obj.axGetEnumerableKeys();
                for (var i = 0; i < keys.length; i++) {
                    var key = keys[i];
                    parts.push(key + ':' + this.convertToJSString(obj.axGetPublicProperty(key)));
                }
                return '({' + parts.join(',') + '})';
            }
            return String(obj);
        };
        ExternalInterface.classInitializer = null;
        ExternalInterface.initialized = false;
        ExternalInterface.registeredCallbacks = Object.create(null);
        return ExternalInterface;
    }(ASObject$1));
    function extractId(node) {
        for (var i = 0; i < node._attributes.length; i++) {
            var attribute = node._attributes[i];
            if (attribute._name.name === 'id') {
                return attribute._value;
            }
        }
        // TODO: throw if no `id` attribute was found.
    }

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: TimerEvent
    var TimerEvent$1 = /** @class */ (function (_super) {
        __extends(TimerEvent, _super);
        function TimerEvent(type, bubbles, cancelable) {
            return _super.call(this, type, bubbles, cancelable) || this;
        }
        TimerEvent.prototype.clone = function () {
            return new TimerEvent(this.type, this.bubbles, this.cancelable);
        };
        TimerEvent.prototype.toString = function () {
            return this.formatToString('TimerEvent', 'type', 'bubbles', 'cancelable', 'eventPhase');
        };
        TimerEvent.prototype.updateAfterEvent = function () {
            this.sec.player.requestRendering();
        };
        TimerEvent.classInitializer = null;
        TimerEvent.classSymbols = null;
        TimerEvent.instanceSymbols = null;
        // JS -> AS Bindings
        TimerEvent.TIMER = "timer";
        TimerEvent.TIMER_COMPLETE = "timerComplete";
        return TimerEvent;
    }(Event$1));

    //import { leaveTimeline, enterTimeline } from "../../avm2/module";
    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: Timer
    var Timer$1 = /** @class */ (function (_super) {
        __extends(Timer, _super);
        function Timer(delay, repeatCount /*int = 0 */) {
            var _this = _super.call(this) || this;
            _this._delay = +delay;
            _this._repeatCount = repeatCount | 0;
            _this._iteration = 0;
            return _this;
        }
        Object.defineProperty(Timer.prototype, "running", {
            get: function () {
                return this._running;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Timer.prototype, "delay", {
            get: function () {
                return this._delay;
            },
            set: function (value) {
                value = +value;
                if (value < 0 || !isFinite(value)) {
                    this.sec.throwError('RangeError', Errors$1.DelayRangeError);
                }
                this._delay = value;
                if (this._running) {
                    this.stop();
                    this.start();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Timer.prototype, "repeatCount", {
            get: function () {
                return this._repeatCount;
            },
            set: function (value) {
                this._repeatCount = value | 0;
                if (this._repeatCount && this._running && this._iteration >= this._repeatCount) {
                    this.stop();
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(Timer.prototype, "currentCount", {
            get: function () {
                return this._iteration;
            },
            enumerable: true,
            configurable: true
        });
        Timer.prototype.reset = function () {
            if (this._running) {
                this.stop();
            }
            this._iteration = 0;
        };
        Timer.prototype.stop = function () {
            this._running = false;
            clearInterval(this._interval);
        };
        Timer.prototype.start = function () {
            if (this._running) {
                return;
            }
            this._running = true;
            this._interval = setInterval(this._tick.bind(this), this._delay);
        };
        Timer.prototype._tick = function () {
            this._iteration++;
            if (!this._running) {
                return;
            }
            if (Timer.dispatchingEnabled) {
                //enterTimeline("Timer.Timer");
                try {
                    this.dispatchEvent(new TimerEvent$1("timer", true, false));
                }
                catch (e) {
                    warning('caught error under Timer TIMER event: ', e);
                }
                //leaveTimeline();
            }
            if (this._repeatCount !== 0 && this._iteration >= this._repeatCount) {
                this.stop();
                //enterTimeline("Timer.TimerComplete");
                try {
                    this.dispatchEvent(new TimerEvent$1(TimerEvent$1.TIMER_COMPLETE, false, false));
                }
                catch (e) {
                    warning('caught error under Timer COMPLETE event: ', e);
                }
                //leaveTimeline();
            }
        };
        Timer.classInitializer = null;
        Timer.classSymbols = null; // [];
        Timer.instanceSymbols = null;
        /**
         * This lets you toggle timer event dispatching which is useful when trying to profile other
         * parts of the system.
         */
        Timer.dispatchingEnabled = true;
        return Timer;
    }(EventDispatcher$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: ProgressEvent
    var ProgressEvent$1 = /** @class */ (function (_super) {
        __extends(ProgressEvent, _super);
        function ProgressEvent(type, bubbles, cancelable, bytesLoaded, bytesTotal) {
            if (bubbles === void 0) { bubbles = false; }
            if (cancelable === void 0) { cancelable = false; }
            if (bytesLoaded === void 0) { bytesLoaded = 0; }
            if (bytesTotal === void 0) { bytesTotal = 0; }
            var _this = _super.call(this, type, bubbles, cancelable) || this;
            _this._bytesLoaded = bytesLoaded;
            _this._bytesTotal = bytesTotal;
            return _this;
        }
        Object.defineProperty(ProgressEvent.prototype, "bytesLoaded", {
            get: function () {
                return this._bytesLoaded;
            },
            set: function (value) {
                this._bytesLoaded = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ProgressEvent.prototype, "bytesTotal", {
            get: function () {
                return this._bytesTotal;
            },
            set: function (value) {
                this._bytesTotal = value;
            },
            enumerable: true,
            configurable: true
        });
        ProgressEvent.prototype.clone = function () {
            return new ProgressEvent(this._type, this._bubbles, this._cancelable, this._bytesLoaded, this._bytesTotal);
        };
        ProgressEvent.prototype.toString = function () {
            return this.formatToString('ProgressEvent', 'bubbles', 'cancelable', 'eventPhase', 'bytesLoaded', 'bytesTotal');
        };
        ProgressEvent.classInitializer = null;
        ProgressEvent.classSymbols = null;
        ProgressEvent.instanceSymbols = null;
        // JS -> AS Bindings
        ProgressEvent.PROGRESS = "progress";
        ProgressEvent.SOCKET_DATA = "socketData";
        return ProgressEvent;
    }(Event$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: SoundTransform
    var SoundTransform$3 = /** @class */ (function (_super) {
        __extends(SoundTransform, _super);
        function SoundTransform(vol, panning) {
            if (vol === void 0) { vol = 1; }
            if (panning === void 0) { panning = 0; }
            var _this = _super.call(this) || this;
            _this.volume = +vol;
            _this.pan = +panning;
            return _this;
        }
        Object.defineProperty(SoundTransform.prototype, "volume", {
            get: function () {
                return this._volume;
            },
            set: function (volume) {
                volume = +volume;
                this._volume = volume;
                this._updateTransform();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundTransform.prototype, "leftToLeft", {
            get: function () {
                return this._leftToLeft;
            },
            set: function (leftToLeft) {
                leftToLeft = +leftToLeft;
                this._leftToLeft = leftToLeft;
                this._updateTransform();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundTransform.prototype, "leftToRight", {
            get: function () {
                return this._leftToRight;
            },
            set: function (leftToRight) {
                leftToRight = +leftToRight;
                this._leftToRight = leftToRight;
                this._updateTransform();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundTransform.prototype, "rightToRight", {
            get: function () {
                return this._rightToRight;
            },
            set: function (rightToRight) {
                rightToRight = +rightToRight;
                this._rightToRight = rightToRight;
                this._updateTransform();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundTransform.prototype, "rightToLeft", {
            get: function () {
                return this._rightToLeft;
            },
            set: function (rightToLeft) {
                rightToLeft = +rightToLeft;
                this._rightToLeft = rightToLeft;
                this._updateTransform();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundTransform.prototype, "pan", {
            get: function () {
                if (this._leftToRight === 0 && this._rightToLeft === 0) {
                    return 1 - this._leftToLeft * this._leftToLeft;
                }
                return 0;
            },
            set: function (panning) {
                this.leftToLeft = Math.sqrt(1 - panning);
                this.leftToRight = 0;
                this.rightToRight = Math.sqrt(1 + panning);
                this.rightToLeft = 0;
            },
            enumerable: true,
            configurable: true
        });
        SoundTransform.prototype._updateTransform = function () {
            release$1 || somewhatImplemented("public flash.media.SoundTransform::_updateTransform");
            // TODO dispatch updates to the current audio destinations?
        };
        // Called whenever the class is initialized.
        SoundTransform.classInitializer = null;
        // List of static symbols to link.
        SoundTransform.classSymbols = null; // [];
        // List of instance symbols to link.
        SoundTransform.instanceSymbols = null; // [];
        return SoundTransform;
    }(ASObject$1));

    var SoundMixer$1 = /** @class */ (function (_super) {
        __extends(SoundMixer, _super);
        function SoundMixer() {
            return _super.call(this) || this;
        }
        Object.defineProperty(SoundMixer, "bufferTime", {
            // static _audioPlaybackMode: string;
            // static _useSpeakerphoneForVoice: boolean;
            get: function () {
                release$1 || notImplemented("public flash.media.SoundMixer::get bufferTime");
                return SoundMixer._bufferTime;
            },
            set: function (bufferTime /*int*/) {
                release$1 || somewhatImplemented("public flash.media.SoundMixer::set bufferTime");
                SoundMixer._bufferTime = bufferTime | 0;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundMixer, "soundTransform", {
            get: function () {
                release$1 || somewhatImplemented("public flash.media.SoundMixer::get soundTransform");
                return isNullOrUndefined$1(SoundMixer._soundTransform) ?
                    new SoundTransform$3() :
                    new SoundTransform$3(SoundMixer._soundTransform.volume, SoundMixer._soundTransform.pan);
            },
            set: function (sndTransform) {
                release$1 || somewhatImplemented("public flash.media.SoundMixer::set soundTransform");
                SoundMixer._soundTransform = isNullOrUndefined$1(sndTransform) ?
                    new SoundTransform$3() :
                    sndTransform;
                SoundMixer._updateAllSoundSources();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundMixer, "audioPlaybackMode", {
            get: function () {
                release$1 || notImplemented("public flash.media.SoundMixer::get audioPlaybackMode");
                return;
                // return SoundMixer._audioPlaybackMode;
            },
            set: function (value) {
                value = axCoerceString$3(value);
                release$1 || notImplemented("public flash.media.SoundMixer::set audioPlaybackMode");
                return;
                // SoundMixer._audioPlaybackMode = value;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundMixer, "useSpeakerphoneForVoice", {
            get: function () {
                release$1 || notImplemented("public flash.media.SoundMixer::get useSpeakerphoneForVoice");
                return;
                // return SoundMixer._useSpeakerphoneForVoice;
            },
            set: function (value) {
                value = !!value;
                release$1 || notImplemented("public flash.media.SoundMixer::set useSpeakerphoneForVoice");
                return;
                // SoundMixer._useSpeakerphoneForVoice = value;
            },
            enumerable: true,
            configurable: true
        });
        SoundMixer.stopAll = function () {
            SoundMixer._registeredSoundSources.forEach(function (channel) {
                channel.stopSound();
            });
            SoundMixer._registeredSoundSources = [];
        };
        SoundMixer.computeSpectrum = function (outputArray, FFTMode, stretchFactor) {
            if (FFTMode === void 0) { FFTMode = false; }
            if (stretchFactor === void 0) { stretchFactor = 0; }
            FFTMode = !!FFTMode;
            stretchFactor = stretchFactor | 0;
            release$1 || somewhatImplemented("public flash.media.SoundMixer::static computeSpectrum");
            var data = new Float32Array(1024);
            for (var i = 0; i < 1024; i++) {
                data[i] = Math.random();
            }
            outputArray.writeRawBytes(data);
            outputArray.position = 0;
        };
        SoundMixer.areSoundsInaccessible = function () {
            release$1 || notImplemented("public flash.media.SoundMixer::static areSoundsInaccessible");
            return;
        };
        SoundMixer._getMasterVolume = function () {
            return SoundMixer._masterVolume;
        };
        SoundMixer._setMasterVolume = function (volume) {
            volume = +volume;
            SoundMixer._masterVolume = volume;
            SoundMixer._updateAllSoundSources();
        };
        SoundMixer._registerSoundSource = function (source) {
            SoundMixer._registeredSoundSources.push(source);
        };
        SoundMixer._unregisterSoundSource = function (source) {
            var index = SoundMixer._registeredSoundSources.indexOf(source);
            if (index >= 0) {
                SoundMixer._registeredSoundSources.splice(index, 1);
            }
        };
        SoundMixer._updateSoundSource = function (source) {
            var volume = source.soundTransform.volume;
            if (SoundMixer._soundTransform) {
                volume *= SoundMixer._soundTransform.volume;
            }
            volume *= SoundMixer._getMasterVolume();
            source.updateSoundLevels(volume);
        };
        SoundMixer._updateAllSoundSources = function () {
            SoundMixer._registeredSoundSources.forEach(SoundMixer._updateSoundSource);
        };
        // Called whenever the class is initialized.
        SoundMixer.classInitializer = null;
        // List of static symbols to link.
        SoundMixer.classSymbols = null; // [];
        // List of instance symbols to link.
        SoundMixer.instanceSymbols = null; // [];
        SoundMixer._masterVolume = 1;
        SoundMixer._registeredSoundSources = [];
        SoundMixer._bufferTime = 0;
        return SoundMixer;
    }(ASObject$1));

    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    // Class: TextSnapshot
    var TextSnapshot = /** @class */ (function (_super) {
        __extends(TextSnapshot, _super);
        function TextSnapshot() {
            return _super.call(this) || this;
        }
        Object.defineProperty(TextSnapshot.prototype, "charCount", {
            // _charCount: number /*int*/;
            get: function () {
                release$1 || notImplemented("public flash.text.TextSnapshot::get charCount");
                return;
                // return this._charCount;
            },
            enumerable: true,
            configurable: true
        });
        TextSnapshot.prototype.findText = function (beginIndex /*int*/, textToFind, caseSensitive) {
            beginIndex = beginIndex | 0;
            textToFind = axCoerceString$3(textToFind);
            caseSensitive = !!caseSensitive;
            release$1 || notImplemented("public flash.text.TextSnapshot::findText");
            return;
        };
        TextSnapshot.prototype.getSelected = function (beginIndex /*int*/, endIndex /*int*/) {
            beginIndex = beginIndex | 0;
            endIndex = endIndex | 0;
            release$1 || notImplemented("public flash.text.TextSnapshot::getSelected");
            return;
        };
        TextSnapshot.prototype.getSelectedText = function (includeLineEndings) {
            if (includeLineEndings === void 0) { includeLineEndings = false; }
            includeLineEndings = !!includeLineEndings;
            release$1 || notImplemented("public flash.text.TextSnapshot::getSelectedText");
            return;
        };
        TextSnapshot.prototype.getText = function (beginIndex /*int*/, endIndex /*int*/, includeLineEndings) {
            if (includeLineEndings === void 0) { includeLineEndings = false; }
            beginIndex = beginIndex | 0;
            endIndex = endIndex | 0;
            includeLineEndings = !!includeLineEndings;
            release$1 || notImplemented("public flash.text.TextSnapshot::getText");
            return;
        };
        TextSnapshot.prototype.getTextRunInfo = function (beginIndex /*int*/, endIndex /*int*/) {
            beginIndex = beginIndex | 0;
            endIndex = endIndex | 0;
            release$1 || notImplemented("public flash.text.TextSnapshot::getTextRunInfo");
            return;
        };
        TextSnapshot.prototype.hitTestTextNearPos = function (x, y, maxDistance) {
            if (maxDistance === void 0) { maxDistance = 0; }
            x = +x;
            y = +y;
            maxDistance = +maxDistance;
            release$1 || notImplemented("public flash.text.TextSnapshot::hitTestTextNearPos");
            return;
        };
        TextSnapshot.prototype.setSelectColor = function (hexColor) {
            if (hexColor === void 0) { hexColor = 16776960; }
            hexColor = hexColor >>> 0;
            release$1 || notImplemented("public flash.text.TextSnapshot::setSelectColor");
            return;
        };
        TextSnapshot.prototype.setSelected = function (beginIndex /*int*/, endIndex /*int*/, select) {
            beginIndex = beginIndex | 0;
            endIndex = endIndex | 0;
            select = !!select;
            release$1 || notImplemented("public flash.text.TextSnapshot::setSelected");
            return;
        };
        // Called whenever the class is initialized.
        TextSnapshot.classInitializer = null;
        return TextSnapshot;
    }(ASObject$1));

    var URLVariables$1 = /** @class */ (function (_super) {
        __extends(URLVariables, _super);
        function URLVariables(source) {
            if (source === void 0) { source = null; }
            var _this = _super.call(this) || this;
            _this._ignoreDecodingErrors = false;
            source && _this.decode(source);
            return _this;
        }
        URLVariables.prototype.decode = function (source) {
            source = axCoerceString$3(source);
            var variables = source.split('&');
            for (var i = 0; i < variables.length; i++) {
                var p = variables[i];
                var j = p.indexOf('=');
                if (j < 0) {
                    if (this._ignoreDecodingErrors) {
                        j = p.length;
                    }
                    else {
                        this.sec.throwError('Error', Errors$1.DecodeParamError);
                    }
                }
                var name = unescape(p.substring(0, j).split('+').join(' '));
                var value = unescape(p.substring(j + 1).split('+').join(' '));
                var currentValue = this.axGetPublicProperty(name);
                if (typeof currentValue === 'undefined') {
                    this.axSetPublicProperty(name, value);
                }
                else if (Array.isArray(currentValue)) {
                    currentValue.push(value);
                }
                else {
                    this.axSetPublicProperty(name, [currentValue, value]);
                }
            }
        };
        URLVariables.prototype.toString = function () {
            var pairs = [];
            var keys = this.axGetEnumerableKeys();
            for (var i = 0; i < keys.length; i++) {
                var name = keys[i].split(' ').join('+');
                var value = this.axGetPublicProperty(name);
                name = escape(name).split(' ').join('+');
                if (Array.isArray(value)) {
                    for (var j = 0; j < value.length; j++) {
                        pairs.push(name + '=' + escape(value[j]));
                    }
                }
                else {
                    pairs.push(name + '=' + escape(value));
                }
            }
            return pairs.join('&');
        };
        URLVariables.classInitializer = null;
        URLVariables.classSymbols = null; // [];
        URLVariables.instanceSymbols = null;
        return URLVariables;
    }(ASObject$1));

    /*
    import { NativeMenu } from "./display/NativeMenu";
    import { NativeMenuItem } from "./display/NativeMenuItem";
    import { ContextMenu } from "./ui/ContextMenu";
    import { ContextMenuItem } from "./ui/ContextMenuItem";
    import { ContextMenuBuiltInItems } from "./ui/ContextMenuBuiltInItems";
    import { ContextMenuClipboardItems } from "./ui/ContextMenuClipboardItems";*/
    /*
    import { URLRequest } from "./net/URLRequest";
    import { ApplicationDomain } from "./system/ApplicationDomain";
    import { SharedObject } from "./net/SharedObject";
    import { URLVariables } from "./net/URLVariables";
    import { Symbol } from "./symbol";
    import { ByteArray, ObjectEncoding } from "../avm2/natives/byteArray";
    import { AccessibilityProperties } from "./accessibility/AccessibilityProperties";
    import { Accessibility } from "./accessibility/Accessibility";
    import { LoaderContext } from "./system/LoaderContext";
    import { JPEGLoaderContext } from "./system/JPEGLoaderContext";
    import { System } from "../avm2/natives/system";
    import { AVM1Movie } from "./display/AVM1Movie";
    import { MorphShape } from "./display/MorphShape";
    import { FrameLabel } from "./display/FrameLabel";
    import { GradientType } from "./display/GradientType";
    import { SpreadMethod } from "./display/SpreadMethod";
    import { InterpolationMethod } from "./display/InterpolationMethod";
    import { LineScaleMode } from "./display/LineScaleMode";
    import { CapsStyle } from "./display/CapsStyle";
    import { JointStyle } from "./display/JointStyle";
    import { Point } from "./geom/Point";
    import { Rectangle } from "./geom/Rectangle";
    import { Matrix } from "./geom/Matrix";
    import { Matrix3D } from "./geom/Matrix3D";
    import { Vector3D } from "./geom/Vector3D";
    import { Transform } from "./geom/Transform";
    import { ColorTransform } from "./geom/ColorTransform";
    import { PerspectiveProjection } from "./geom/PerspectiveProjection";
    import { KeyboardEvent } from "./events/KeyboardEvent";
    import { MouseEvent } from "./events/MouseEvent";
    import { HTTPStatusEvent } from "./events/HTTPStatusEvent";
    import { UncaughtErrorEvents } from "./events/UncaughtErrorEvents";
    import { Keyboard } from "./ui/Keyboard";
    import { Mouse } from "./ui/Mouse";
    import { MouseCursorData } from "./ui/MouseCursorData";
    import { GameInput } from "./ui/GameInput";
    import { GameInputControl } from "./ui/GameInputControl";
    import { GameInputControlType } from "./ui/GameInputControlType";
    import { GameInputDevice } from "./ui/GameInputDevice";
    import { GameInputFinger } from "./ui/GameInputFinger";
    import { GameInputHand } from "./ui/GameInputHand";
    import { Font } from "./text/Font";
    import { TextField } from "./text/TextField";
    import { StaticText } from "./text/StaticText";
    import { StyleSheet } from "./text/StyleSheet";
    import { TextFormat } from "./text/TextFormat";
    import { TextRun } from "./text/TextRun";
    import { TextLineMetrics } from "./text/TextLineMetrics";
    import { Sound } from "./media/Sound";
    import { SoundChannel } from "./media/SoundChannel";
    import { SoundTransform } from "./media/SoundTransform";
    import { StageVideo } from "./media/StageVideo";
    import { Video } from "./media/Video";
    import { TouchEvent } from "./events/TouchEvent";
    import { MultitouchInputMode } from "./ui/MultitouchInputMode";
    import { Multitouch } from "./ui/Multitouch";
    import { GameInputEvent } from "./events/GameInputEvent";
    import { AsyncErrorEvent } from "./events/AsyncErrorEvent";
    import { NetStatusEvent } from "./events/NetStatusEvent";
    import { StatusEvent } from "./events/StatusEvent";
    import { GestureEvent } from "./events/GestureEvent";
    import { ID3Info } from "./media/ID3Info";
    import { Microphone } from "./media/Microphone";
    import { Camera } from "./media/Camera";
    import { FileFilter } from "./net/FileFilter";
    import { FileReference } from "./net/FileReference";
    import { NetConnection } from "./net/NetConnection";
    import { NetStream } from "./net/NetStream";
    import { NetStreamInfo } from "./net/NetStreamInfo";
    import { Responder } from "./net/Responder";
    import { URLRequestHeader } from "./net/URLRequestHeader";
    import { URLStream } from "./net/URLStream";
    import { FileReferenceList } from "./net/FileReferenceList";
    import { LocalConnection } from "./net/LocalConnection";
    import { Socket } from "./net/Socket";
    import { Security } from "./system/Security";
    */
    /**
     * Copyright 2014 Mozilla Foundation
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     * http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
    function M(name, asClass) {
        registerNativeClass(name, asClass);
    }
    M("flash.display.Stage", Stage$1);
    M("flash.display.DisplayObject", DisplayObject$1);
    M("flash.display.InteractiveObject", InteractiveObject);
    M("flash.display.DisplayObjectContainer", DisplayObjectContainer$1);
    M("flash.display.Sprite", Sprite$1);
    M("flash.display.MovieClip", MovieClip$1);
    M("flash.display.Shape", Sprite$1);
    M("flash.display.Bitmap", Bitmap);
    M("flash.display.BitmapData", BitmapData);
    M("flash.display.Loader", Loader$1);
    M("flash.display.LoaderInfo", LoaderInfo$2);
    M("flash.display.Graphics", Graphics$1);
    M("flash.display.SimpleButton", SimpleButton$1);
    M("flash.display.Scene", Scene$1);
    M("flash.events.Event", Event);
    M("flash.ui.Keyboard", Keyboard$1);
    M("flash.events.KeyboardEvent", KeyboardEvent$1);
    M("flash.text.TextField", TextField$1);
    // M("flash.display.MorphShape", MorphShape);
    //M("flash.display.NativeMenu", NativeMenu);
    //M("flash.display.NativeMenuItem", NativeMenuItem);
    // M("flash.display.FrameLabel", FrameLabel);
    // M("flash.display.AVM1Movie", AVM1Movie);
    // M("flash.display.GradientType", GradientType);
    // M("flash.display.SpreadMethod", SpreadMethod);
    // M("flash.display.InterpolationMethod", InterpolationMethod);
    // M("flash.display.LineScaleMode", LineScaleMode);
    // M("flash.display.CapsStyle", CapsStyle);
    // M("flash.display.JointStyle", JointStyle);
    M("flash.filters.BevelFilter", BevelFilter);
    M("flash.filters.BitmapFilter", BitmapFilter);
    M("flash.filters.BlurFilter", BlurFilter);
    M("flash.filters.ColorMatrixFilter", ColorMatrixFilter);
    M("flash.filters.ConvolutionFilter", ConvolutionFilter);
    M("flash.filters.DisplacementMapFilter", DisplacementMapFilter);
    M("flash.filters.DropShadowFilter", DropShadowFilter);
    M("flash.filters.GlowFilter", GlowFilter);
    M("flash.filters.GradientBevelFilter", GradientBevelFilter);
    M("flash.filters.GradientGlowFilter", GradientGlowFilter);
    M("flash.geom.Point", Point$1);
    M("flash.geom.Rectangle", Rectangle$1);
    M("flash.geom.Matrix", Matrix$1);
    M("flash.geom.Matrix3D", Matrix3D$1);
    M("flash.geom.Vector3D", Vector3D$1);
    M("flash.geom.Transform", Transform$1);
    M("flash.geom.ColorTransform", ColorTransform$1);
    // M("flash.geom.PerspectiveProjection", PerspectiveProjection);
    M("flash.events.EventDispatcher", EventDispatcher$1);
    M("flash.events.MouseEvent", MouseEvent$2);
    M("flash.events.ErrorEvent", ErrorEvent$1);
    M("flash.events.IOErrorEvent", IOErrorEvent$1);
    // M("flash.events.GestureEvent", GestureEvent);
    M("flash.events.TextEvent", TextEvent$1);
    M("flash.events.TimerEvent", TimerEvent$1);
    M("flash.events.ProgressEvent", ProgressEvent$1);
    // M("flash.events.StatusEvent", StatusEvent);
    // M("flash.events.NetStatusEvent", NetStatusEvent);
    // M("flash.events.HTTPStatusEvent", HTTPStatusEvent);
    // M("flash.events.AsyncErrorEvent", AsyncErrorEvent);
    // M("flash.events.UncaughtErrorEvents", UncaughtErrorEvents);
    M("flash.external.ExternalInterface", ExternalInterface$1);
    /*
    M("flash.ui.ContextMenu", ContextMenu);
    M("flash.ui.ContextMenuItem", ContextMenuItem);
    M("flash.ui.ContextMenuBuiltInItems", ContextMenuBuiltInItems);
    M("flash.ui.ContextMenuClipboardItems", ContextMenuClipboardItems);*/
    // M("flash.ui.Mouse", Mouse);
    // M("flash.ui.MouseCursorData", MouseCursorData);
    // M("flash.ui.GameInput", GameInput);
    // M("flash.events.GameInputEvent", GameInputEvent);
    // M("flash.ui.GameInputControl", GameInputControl);
    // M("flash.ui.GameInputControlType", GameInputControlType);
    // M("flash.ui.GameInputDevice", GameInputDevice);
    // M("flash.ui.GameInputFinger", GameInputFinger);
    // M("flash.ui.GameInputHand", GameInputHand);
    // M("flash.ui.Multitouch", Multitouch);
    // M("flash.ui.MultitouchInputMode", MultitouchInputMode);
    // M("flash.events.TouchEvent", TouchEvent);
    // M("flash.text.Font", Font);
    // M("flash.text.StaticText", StaticText);
    // M("flash.text.StyleSheet", StyleSheet);
    M("flash.text.TextFormat", TextFormat$2);
    // M("flash.text.TextRun", TextRun);
    M("flash.text.TextSnapshot", TextSnapshot);
    // M("flash.text.TextLineMetrics", TextLineMetrics);
    M("flash.media.Sound", Sound);
    M("flash.media.SoundChannel", SoundChannel$2);
    M("flash.media.SoundMixer", SoundMixer$1);
    M("flash.media.SoundTransform", SoundTransform$2);
    // M("flash.media.Video", Video);
    // M("flash.media.StageVideo", StageVideo);
    // M("flash.media.ID3Info", ID3Info);
    // M("flash.media.Microphone", Microphone);
    // M("flash.media.Camera", Camera);
    // M("flash.net.FileFilter", FileFilter);
    // M("flash.net.FileReference", FileReference);
    // M("flash.net.FileReferenceList", FileReferenceList);
    // M("flash.net.NetConnection", NetConnection);
    // M("flash.net.NetStream", NetStream);
    // M("flash.net.NetStreamInfo", NetStreamInfo);
    // M("flash.net.Responder", Responder);
    M("flash.net.URLRequest", URLRequest$1);
    // M("flash.net.URLRequestHeader", URLRequestHeader);
    // M("flash.net.URLStream", URLStream);
    M("flash.net.URLLoader", URLLoader$1);
    M("flash.net.SharedObject", SharedObject);
    // M("flash.net.ObjectEncoding", ObjectEncoding);
    // M("flash.net.LocalConnection", LocalConnection);
    // M("flash.net.Socket", Socket);
    M("flash.net.URLVariables", URLVariables$1);
    M("flash.system.Capabilities", Capabilities$1);
    M("flash.system.Security", Security$1);
    M("flash.system.System", System$1);
    M("flash.system.SecurityDomain", SecurityDomain$1);
    M("flash.system.ApplicationDomain", ApplicationDomain);
    // M("flash.system.JPEGLoaderContext", JPEGLoaderContext);
    M("flash.system.LoaderContext", LoaderContext$1);
    // M("flash.accessibility.Accessibility", Accessibility);
    // M("flash.accessibility.AccessibilityProperties", AccessibilityProperties);
    M("flash.utils.Timer", Timer$1);
    // M("flash.utils.ByteArray", ByteArray);
    M("flash.xml.XMLNode", XMLNode$1);
    M("flash.xml.XMLDocument", XMLDocument$1);
    registerNativeFunction('flash.system.fscommand', fscommand$1);
    function initLink() {
        release$1 || console.log("init link");
    }

    /**
     * Naming Conventions:
     *
     *  mn:   multiname;
     *  nm:   name
     *  ns:   namespace
     *  nss:  namespace set
     *
     * Parsing is a combination of lazy and eager evaluation. String parsing is deferred until
     * it is needed for multiname parsing.
     */
    function initlazy() {
        Namespace.PUBLIC = internNamespace(0 /* Public */, "");
    }

    var EntryClass = /** @class */ (function (_super) {
        __extends(EntryClass, _super);
        function EntryClass() {
            return _super.call(this) || this;
        }
        return EntryClass;
    }(Sprite$1));
    initSystem();
    initLink();
    initializeAXBasePrototype();
    initlazy();
    // Add the |axApply| and |axCall| methods on the function prototype so that we can treat
    // Functions as AXCallables.
    Function.prototype.axApply = Function.prototype.apply;
    Function.prototype.axCall = Function.prototype.call;
    var Player = /** @class */ (function () {
        function Player() {
            var _this = this;
            this._time = 0;
            this._debugtimer = 0;
            this._renderStarted = false;
            this._onLoadCompleteDelegate = function (event) { return _this.onLoadComplete(event); };
            this._onAssetCompleteDelegate = function (event) { return _this._onAssetComplete(event); };
        }
        Player.prototype.playSWF = function (buffer, url) {
            var _this = this;
            if (this._loader || this._parser) {
                throw "Only playing of 1 SWF file is supported at the moment";
            }
            createSecurityDomain(AVM2LoadLibrariesFlags.Builtin | AVM2LoadLibrariesFlags.Playerglobal).then(function (sec) {
                console.log("builtins are loaded fine, start parsing SWF");
                _this._sec = sec;
                AXSecurityDomain.instance = sec;
                _this._eventOnEnter = new _this._sec.flash.events.Event(Event.ENTER_FRAME);
                _this._eventFrameConstructed = new _this._sec.flash.events.Event(Event.FRAME_CONSTRUCTED);
                _this._eventExitFrame = new _this._sec.flash.events.Event(Event.EXIT_FRAME);
                _this._eventRender = new _this._sec.flash.events.Event(Event.RENDER);
                _this._events = [_this._eventOnEnter, _this._eventExitFrame];
                _this._stage = new _this._sec.flash.display.Stage(null, window.innerWidth, window.innerHeight, 0xffffff, 30, true);
                _this._sec.flash.display.DisplayObject.axClass._activeStage = _this._stage;
                _this._parser = new SWFParser(new FlashSceneGraphFactory(sec));
                _this._parser._iFileName = url;
                _this._loader = new _this._sec.flash.display.Loader(_this._parser);
                _this._loader.loaderInfo.url = url;
                var loaderContext = new _this._sec.flash.system.LoaderContext(false, new _this._sec.flash.system.ApplicationDomain());
                ActiveLoaderContext.loaderContext = loaderContext;
                _this._loader.loaderInfo.addEventListener(Event.COMPLETE, _this._onLoadCompleteDelegate);
                _this._loader.loaderInfo.addEventListener(AssetEvent.ASSET_COMPLETE, _this._onAssetCompleteDelegate);
                if (buffer) {
                    _this._loader.loadData(buffer, loaderContext);
                }
                else {
                    _this._loader.load(new URLRequest$1(url), loaderContext);
                }
                _this._stage.rendererStage.container.style.visibility = "hidden";
            });
        };
        Player.prototype._onAssetComplete = function (event) {
        };
        Player.prototype.onLoadComplete = function (event) {
            console.log("loaded a SWFFile", this._parser.swfFile);
            this._stage.color = ColorUtils.f32_RGBA_To_f32_ARGB(this._parser.swfFile.backgroundColor);
            this._stage.frameRate = this._parser.swfFile.frameRate;
            this._stage.stageWidth = this._parser.swfFile.bounds.width / 20;
            this._stage.stageHeight = this._parser.swfFile.bounds.height / 20;
            this._stage.addChild(this._loader);
            /*
            This will be needed later to support multiple scenes
            it works to create a Scene Object atm, but our MovieClip is not yet setup to handle and support it

            var sceneData=(<any>this._parser).sceneAndFrameLabelData;
            if(sceneData && sceneData.scenes && sceneData.scenes.length>0){
                var scene=new (<any>this._sec).flash.display.Scene(sceneData.scenes[0].name,[], sceneData.scenes[0].offset, 1);
                scene.axInitializer();
            }
            */
            // loading is finished, start the main_loop:
            this._timer = new RequestAnimationFrame(this.main_loop, this);
            this._timer.start();
        };
        /**
         * Main loop
         */
        Player.prototype.main_loop = function (dt) {
            var frameMarker = Math.floor(1000 / this._stage.frameRate);
            this._time += Math.min(dt, frameMarker);
            if (this._time >= frameMarker || !this._renderStarted) {
                this._time -= frameMarker;
                // 	broadcast ENTER_FRAME event
                //	i think this should really be done after the stage has advanced, but it causes a error in BIC
                this._stage.dispatchStaticBroadCastEvent(Event.ENTER_FRAME);
                // 	advance the stage - this updates the timeline
                //	objects get removed, created and updated - framescripts get queued
                //	as3 constructors for the adpaters are not yet run
                //	ADD events are queued on the objects, because they need to run after the constructors
                this._stage.advanceFrame(this._events);
                OrphanManager.updateOrphans(this._events);
                // run all as3 constructors
                FrameScriptManager.execute_as3_constructors();
                // 	ADD events events have been queued on the objects before their constructor was run
                //	dispatch them now (this is recursivly)
                this._stage.dispatchQueuedEvents();
                // broadcast FRAME_CONSTRUCTED event to all objects
                this._stage.dispatchStaticBroadCastEvent(Event.FRAME_CONSTRUCTED);
                // run all queued framescripts
                FrameScriptManager.execute_queue();
                /*var displayGraph={};
                this._stage.debugDisplayGraph(displayGraph);
                console.log("SceneGraph frame :", displayGraph);*/
                // execute queued scripts
                // render
                this._stage.render();
                if (!this._renderStarted) {
                    if (window["hidePokiProgressBar"])
                        window["hidePokiProgressBar"]();
                    this._stage.rendererStage.container.style.visibility = "visible";
                }
                this._renderStarted = true;
            }
        };
        return Player;
    }());

    var PlayerAVM1 = /** @class */ (function () {
        function PlayerAVM1() {
            var _this = this;
            this._skipFrames = 0;
            this.showAdOnFrame = -1;
            this._fontsLoadedCallback = null;
            // create the AwayStage for AVM1
            this._stage = new AVMAwayStage(window.innerWidth / 2, window.innerHeight / 2, 0xffffff, 24, null, window.innerWidth / 2, window.innerHeight / 2, false);
            this._stage.scene.mouseManager._stage = this._stage;
            this._stage.rendererStageContainer.style.visibility = "hidden";
            var loaderInfo = new LoaderInfo$1();
            this._avm1SceneGraphFactory = new AVM1SceneGraphFactory(new AVM1ContextImpl(loaderInfo));
            this._avm1SceneGraphFactory.avm1Context.sec = new SecurityDomain();
            this._avm1SceneGraphFactory.avm1Context.setStage(this._stage, document);
            AVM1Globals.tracelevel = TraceLevel.ALL;
            AVM1Globals._scenegraphFactory = this._avm1SceneGraphFactory;
            AssetLibrary.enableParser(SWFParser);
            this._onAssetCompleteDelegate = function (event) { return _this._onAssetComplete(event); };
            this._onLoadCompleteDelegate = function (event) { return _this.onLoadComplete(event); };
            this._onLoadErrorDelegate = function (event) { return _this._onLoadError(event); };
            this._onAssetCompleteFontsDelegate = function (event) { return _this._onAssetFontsComplete(event); };
            this._onLoadCompleteFontsDelegate = function (event) { return _this.onLoadFontsComplete(event); };
            this._onLoadErrorFontsDelegate = function (event) { return _this._onLoadFontsError(event); };
            window.addEventListener("resize", function (e) { return _this._stage.resizeCallback(e); });
        }
        Object.defineProperty(PlayerAVM1.prototype, "avm1SceneGraphFactory", {
            get: function () {
                return this._avm1SceneGraphFactory;
            },
            enumerable: true,
            configurable: true
        });
        PlayerAVM1.prototype.preloadFonts = function (url, onFinished) {
            this._fontsLoadedCallback = onFinished;
            if (!this._parser) {
                this._parser = new SWFParser(this._avm1SceneGraphFactory);
                this._parser._iFileName = url;
            }
            AssetLibrary.addEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteFontsDelegate);
            AssetLibrary.addEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoadCompleteFontsDelegate);
            AssetLibrary.addEventListener(URLLoaderEvent.LOAD_ERROR, this._onLoadErrorFontsDelegate);
            AssetLibrary.load(new URLRequest(url), null, null, this._parser);
        };
        PlayerAVM1.prototype.playSWF = function (buffer, url, skipFramesOnScene, skipFramesCallback) {
            if (skipFramesOnScene === void 0) { skipFramesOnScene = 0; }
            if (skipFramesCallback === void 0) { skipFramesCallback = null; }
            this._skipFrames = skipFramesOnScene;
            this._skipFramesCallback = skipFramesCallback;
            AudioManager.setVolume(1);
            this._avm1SceneGraphFactory.avm1Context.executionProhibited = false;
            if (this._parser) {
                this._parser.dispose();
            }
            this._parser = new SWFParser(this._avm1SceneGraphFactory);
            this._parser._iFileName = url;
            AssetLibrary.addEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            AssetLibrary.addEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoadCompleteDelegate);
            AssetLibrary.addEventListener(URLLoaderEvent.LOAD_ERROR, this._onLoadErrorDelegate);
            AssetLibrary.loadData(buffer, null, null, this._parser);
        };
        PlayerAVM1.prototype._onLoadFontsError = function (event) {
            console.log("error preloading fonts", event);
            AssetLibrary.removeEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteFontsDelegate);
            AssetLibrary.removeEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoadCompleteFontsDelegate);
            AssetLibrary.removeEventListener(URLLoaderEvent.LOAD_ERROR, this._onLoadErrorFontsDelegate);
        };
        PlayerAVM1.prototype._onAssetFontsComplete = function (event) {
            var asset = event.asset;
            if (asset.isAsset(Font)) {
                DefaultFontManager.deviceFont = asset;
                console.log("font loaded", asset);
            }
        };
        PlayerAVM1.prototype.onLoadFontsComplete = function (event) {
            AssetLibrary.removeEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteFontsDelegate);
            AssetLibrary.removeEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoadCompleteFontsDelegate);
            AssetLibrary.removeEventListener(URLLoaderEvent.LOAD_ERROR, this._onLoadErrorFontsDelegate);
            if (this._fontsLoadedCallback) {
                this._fontsLoadedCallback();
            }
        };
        PlayerAVM1.prototype._onLoadError = function (event) {
        };
        PlayerAVM1.prototype._onAssetComplete = function (event) {
            var _this = this;
            var asset = event.asset;
            if (asset.isAsset(MovieClip)) {
                if (asset.isAVMScene) {
                    if (this._stage)
                        this._stage.getLayer(0).addChild(asset);
                    asset.adapter.initAdapter();
                    if (this._skipFrames > 0) {
                        FrameScriptManager.execute_queue();
                        if (this._skipFramesCallback) {
                            AudioManager.setVolume(0);
                            this._skipFramesCallback(function () {
                                AudioManager.setVolume(1);
                                asset.currentFrameIndex = _this._skipFrames;
                                asset.play();
                            });
                        }
                        else {
                            asset.currentFrameIndex = this._skipFrames;
                            asset.play();
                        }
                    }
                }
            }
        };
        PlayerAVM1.prototype.onLoadComplete = function (event) {
            console.log("loaded a SWFFile", this._parser.swfFile);
            this._stage.color = ColorUtils.f32_RGBA_To_f32_ARGB(this._parser.swfFile.backgroundColor);
            this._stage.frameRate = this._parser.swfFile.frameRate;
            MovieClipSoundStream.frameRate = this._parser.swfFile.frameRate;
            this._stage.stageWidth = this._parser.swfFile.bounds.width / 20;
            this._stage.stageHeight = this._parser.swfFile.bounds.height / 20;
            this._stage.scaleMode = StageScaleMode.SHOW_ALL;
            this._stage.align = StageAlign.TOP;
            this._stage && this._stage.resizeCallback();
            AssetLibrary.removeEventListener(AssetEvent.ASSET_COMPLETE, this._onAssetCompleteDelegate);
            AssetLibrary.removeEventListener(LoaderEvent.LOAD_COMPLETE, this._onLoadCompleteDelegate);
            AssetLibrary.removeEventListener(URLLoaderEvent.LOAD_ERROR, this._onLoadErrorDelegate);
            if (window["hidePokiProgressBar"])
                window["hidePokiProgressBar"]();
            this._stage.rendererStageContainer.style.visibility = "visible";
        };
        return PlayerAVM1;
    }());

    console.debug("AwayJS - SWF-viewer - 0.3.133");

    exports.SWFParser = SWFParser;
    exports.AVMAwayStage = AVMAwayStage;
    exports.AVM1SceneGraphFactory = AVM1SceneGraphFactory;
    exports.AVM1ContextImpl = AVM1ContextImpl;
    exports.LoaderInfo = LoaderInfo$1;
    exports.SecurityDomain = SecurityDomain;
    exports.AVM1MovieClip = AVM1MovieClip;
    exports.AVM1Globals = AVM1Globals;
    exports.TraceLevel = TraceLevel;
    exports.AVM1Object = AVM1Object;
    exports.AVM1Button = AVM1Button;
    exports.AVM1PropertyDescriptor = AVM1PropertyDescriptor;
    exports.wrapAVM1NativeClass = wrapAVM1NativeClass;
    exports.AVM1Context = AVM1Context;
    exports.Debug = Debug$1;
    exports.release = release$1;
    exports.alIsFunction = alIsFunction;
    exports.BaseVector = BaseVector;
    exports.Player = Player;
    exports.PlayerAVM1 = PlayerAVM1;
    exports.alIsArray = alIsArray;
    exports.alNewObject = alNewObject;
    exports.AVM1ArrayNative = AVM1ArrayNative;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=awayjs-swf-viewer.umd.js.map
